# IRAF Release 2.18.1

[![IRAF CI test](https://github.com/iraf-community/iraf/workflows/IRAF%20CI%20test/badge.svg)](https://github.com/olebole/iraf/actions?query=workflow%3A%22IRAF+CI+test%22)
[![GitHub release](https://img.shields.io/github/release/iraf-community/iraf.svg)](https://github.com/iraf-community/iraf/releases/latest)

IRAF is the Image Reduction and Analysis Facility, a general purpose
software system for the reduction and analysis of astronomical
data. IRAF was written by the National Optical Astronomy Observatories
(NOAO) in Tucson, Arizona. However, development and maintenance of
IRAF is discontinued since 2013. The latest release had a large number
of problems, including major license issues and security bugs.

To keep the software away from bitrotting, and to fix bugs that are in
the package despite (or because) of its age, the iraf-community works
on integrating the available patches into the IRAF source code.

For instructions to install from source see the file
[`INSTALL.md`](INSTALL.md) in this directory. Installation
instructions for binary packages on Linux or macOS can be found on the
[Installation web page](https://iraf-community.github.io/install.html).


## Contributing Code, Documentation, or Feedback

IRAF can only survive by the contribution of its users, so we welcome
and encourage your contributions. The preferred way to report a bug is
to create a new issue on the
[IRAF GitHub issue](https://github.com/iraf-community/iraf/issues) page.
To contribute patches, we suggest to create a
[pull request on GitHub](https://github.com/iraf-community/iraf/pulls).


## License

IRAF is licensed under a MIT style license -- see the file
[`COPYRIGHT`](COPYRIGHT). Detailed licensing information for third
party code may be found in the `doc/LICENSES` subdirectory. Note that
all non-free code from the book Numerical Recipes was removed.

These directories contain the source and libraries for the IRAF system, i.e.,
the system interface or "virtual operating system" (VOS) and the machine
independent i/o libraries comprising the program interface.  To rebuild the
VOS merely run "mkpkg" after bringing up the bootstrap utilities and libraries
in host$.  To relink the system executables after an important modification
to the VOS, type "mkpkg update".

    clio	command language i/o
    dbio	database i/o
    etc		miscellanous system modules
    fio		file i/o
    flib	contains nop.x, used to list modules for libmain.o
    fmtio	formatted i/o
    gio		graphics i/o
    imio	image i/o
    ki		kernel inteface (networking)
    memio	memory i/o
    mkpkg	descriptor file for the MKPKG utility
    mtio	magnetic tape i/o
    osb		bit and byte primitives
    spool	record of the last sysgen
    vops	vector operators

For example:

	mkpkg >& spool &		make or update the VOS libraries
	mkpkg update			update the system executables

NOAO -- A suite of IRAF based packages for the reduction and analysis of
Optical Astronomy data.

    artdata	artificial data generation
    astrometry	astrometric routines
    astcat      astronomical catalog and survey acess routines
    astutil	general astronomy oriented utilities
    digiphot	digital stellar photometry
    filterphot	filter photometry reductions
    focas	faint object classification and analysis
    imred	image reductions
    mtlocal	data i/o programs for custom NOAO data formats
    nobsolete	obsolete tasks
    nproto	miscellaneous prototype quality tasks
    obsutil     observing utilities for planning and evaluation
    observatory	Set and define observatory parameters
    onedspec	one dimensional spectra
    rv          radial velocity analysis package
    surfphot	surface photometry package
    twodspec	two dimensional spectra

Not all of these packages are necessarily implemented.

This directory contains general documents pertaining to the IRAF
system as a whole.

	clman.rst	CL Programmer’s Manual (1983)
	cluser.tex	A User's Introduction to the IRAF Command Language (1984)
	spp.rst		SPP Reference Manual (1983)
	std.rst		IRAF Standards and Conventions (1983)
	std_gl.rst	Standard Nomenclature (1983)
	unixsmg.rst	Site Manager's Guide (2011)
	paspconf.sty,
	iraf92f3.eps,
	iraf92.tex	IRAF in the Nineties (paper) (1992)
	logo.svg	IRAF logo (1987)
	releases	IRAF release notes

	This directory contains utility scripts used to build and 
maintain the system from the top-level IRAF root directory.  These
scripts should NOT be used to build individual packages or source
directories.

Contents include:

    README		This file
    mkarch		Reconfigure the system for given architecture
    mkclean		Clean the current architecture of binaries
    mkproto		Create system prototype files
    mksrc		Clean the system of all binaries
    mksysgen		Build from a clean system source
    mkup		Update current-arch binaries
    mkupx		Update current-arch binaries (debug)

The IRAF math library provides a collection of general purpose numerical
routines for use in scientific applications programs.  This library is
continually growing as we collect numerical packages from around the country.

At present the library is just a collection of untested routines from various
sources.  As time goes on, these routines will be edited to conform to a
standard which has not yet been developed.  The standard is expected to provide
for different classes of routines, according to how well the routines have
been integrated into the system and tested.  The standard for the math library
will affect programming style, naming conventions, documentation, and the
subset of Fortran which portable library routines are expected to comply with.

A fundamental part of the standard is that math library routines should not do
i/o.  Some of the otherwise numerical routines in these directories print
error messages when an error occurs, using Fortran i/o.  This is bad because
Fortran i/o is not used elsewhere in the IRAF system, and because it is
preferable for a numerical routine to return an error code in the event of an
error.  Before these codes are used in IRAF applications programs, this will
have to be fixed.

These directories contain the source, documentation, and default parameter
files for all IRAF system packages.

	cl		The command language
	dataio		Data format conversions (FITS, card image, etc.)
	images		General image processing and display
	language	CL language stuff (task, kill, set, etc.)
	lists		List processing utilities
	obsolete	Obsolete tasks to be phased out
	plot		General plotting utilities
	proto		Prototype tasks
	softools	Software tools
	system		System utilities (files etc.)
	utilities	Miscellaneous utilities

	xtools		Applications tools library
	bench		Benchmarks package (not an installed package)

PC-IRAF HSI -- September 2001

The old (1985) README for the Unix HSI is preserved unchanged below.
We are not going to attempt to include updated, comprehensive documentation
here now, but a few pointers follow.  See the Unix/IRAF or PC-IRAF system
manager's guide for more complete documentation.

    o   The PC-IRAF HSI currently uses F2C for Fortran (SPP) to C
	translation.  Although F2C is available as an option on many
	platforms, we integrate it into the HSI to avoid versioning
	problems and to avoid an external dependency.  The version of F2C
	used is maintained in /local/src/f2c on Lepus.  The README in that
	directory contains instructions for building f2c for a platform.
	Once the runtime files have been generated they are copied to the
	HBIN for the target platform.


===============================================================================
UNIX (a.k.a. host$) -- IRAF/UNIX System Interface (13Dec85 Dct)

    These directories contain those portions of the IRAF software which are
machine or host operating system dependent.  The major directories are as
follows:

	boot		bootstrap utilities (mkpkg, xc, etc.)
	hlib		host library (config files, header files, etc.)
	os		the UNIX/IRAF kernel (LIBOS.A)
	gdev		ZFIOGD device driver (i/o to binary graphics devices)

A graph of the IRAF/UNIX system interface directories is shown below.
-------------------------------------------------------------------------------
Thu Jan 16 16:37:52 MST 1986

                                |-bootlib-------
                                |-generic-------
                                |-mkpkg---------
                                |-rmbin---------
                                |-rtar----------
                                |               
                                |                               |-ratlibc-------
                |-boot----------|                               |-ratlibf-------
                |               |-spp-----------|-rpp-----------|-ratlibr-------
                |               |               |               |-rppfor--------
                |               |               |               |-rpprat--------
                |               |               |-xpp-----------
                |               |-vfn-----------
                |               |-wtar----------
                |               |
|-unix----------|               |-xyacc---------|-debug---------
                |
                |-gdev----------|-iism70--------
                |
                |
                |-hlib----------|-libc----------
                |
                |-os------------|-doc-----------
                                |-net-----------



SYSTEM GENERATION PROCEDURE

    The bootstrap utilities must be built before the remainder of the IRAF
system can be built.  The procedure for building the system from scratch given
a text-only distribution is outlined below.  Those sites fortunate to receive
a binary distribution can skip all this, and proceed to editing the device
tables and other runtime files.


    [1]	Edit the config files in HLIB.  The major files are iraf.h, config.h,
	mach.h, libc/iraf.h, libc/libc.h, and libc/knames.h.  All files should
	be reviewed.
    
    [2] If the zsvjmp assembler file will not work on your machine, add a new
	section in this file.  To code ZSVJMP on a UNIX system, it may help
	to write a small C program which calls longjmp and setjmp and use 
	"gcc -S" to create a template.  Write a modified version which is
	callable from Fortran and has the indicated calling sequence.

    [3] The directory OS contains the IRAF kernel for 4.2BSD UNIX.  This will
   	have to be modified somewhat if a different version of UNIX is in use.
	Manual pages are given in os/doc and the package is described in the
	"System Interface Reference Manual", which any IRAF implementor should
	already have.  As of this writing the documentation is partially out
	of date.

    [4] Edit the pathnames in the file ./hlib/libc/iraf.h.  Make a symbolic
	link /usr/include/iraf.h which points to this file (alternatively, copy
	the file to /usr/include).  Edit the pathnames in ./hlib/irafuser.csh.
	Add references to your CSHELL .login and .cshrc files to pick up the
	environment definitions and aliases in this file (alternatively,
	add the appropriate SET/EXPORT environment definitions to your Bourne
	shell login file, and make symbolic links pointing to the aliased
	commands in some public directory).

    [5]	Use source or login to pick up the environment defs and aliases.  You
	are now ready to compile the bootstrap utilities:

		% sh -x mkpkg.sh >& spool &

	This command should compile the libraries LIBOS.A and LIBBOOT.A and
	install them in hlib, then compile and install all the bootstrap
	utilities.

Once this sequence has been successfully completed you should be able to
compile the machine independent part of IRAF by the following sequence of
commands:

	% cd $iraf
	% mkpkg >& spool &

Generation of the full system will take many hours.

This directory contains text of the license files that apply to
third-party sources in the IRAF system:

 * GPL.txt: math/slalib, pkg/images/imcoords/src/healpix.x,
            pkg/xtools/rmturlach.x

 * CDDL.txt: unix/boot/xyacc

 * UCAR.txt: sys/gio/ncarutil

 * ERFA.txt: ast_julday_to_date in noao$astutil/asttools/asttimes.x

 * LLSQ.txt: math/llsq

 * LAPACK.txt: math/lapack

 * ATT.txt: unix/f2c

Linear least squares surface fitting package.
Contains routines to fit Legendre and Chebyshev polynomials
in the least squares sense to 2-dimensional data.
The normal equations are accumulated and solved using Cholesky factorization.
The package contains separate entry points for accumulating points,
solving the matrix equations, rejecting points and evaluating the surface.

IRAF$DEV - The DEV Directory (Aug 1986)
Fri Mar 21 20:36:00 MST 1997

This directory contains device descriptor tables and host system interface
information for the various devices accessed by IRAF.  With the exception of
the cache[gt].dat files, all these files are read at runtime hence new
devices can be interfaced without a sysgen in most cases.

    cacheg.dat, cachet.dat
	SPP include files, referenced in TTY, used to cache graphcap and
	termcap device entries for fast access.  [These are rarely touched
	any more although they are still functional - Mar97]

    devices
	Maps the logical (IRAF) device names of any allocatable devices to
	host system names.  Primary use is for magtape devices.  [Not used
	any more except in VMS/IRAF]

    edt.ed, emacs.ed, vi.ed
	Read by EDIT, EPARAM, and EHISTORY to determine the editor language
	and the host command to be used to call the host editor.

    graphcap
	Device information for all graphics terminals, plotters, and image
	displays.  If an entry is also in the cache file `cacheg.dat', the
	cache must be rebuilt before changes will take effect.

    help.db
	The compiled HELP database.  Tells HELP what packages and modules help
	is available for, and the names of the associaated help files.

    hostlogin, hosts, uhosts
	Network interface files.  Describe the nodes on the local network
	and how to talk to them.

    null
	The dev$null file.  I am not sure an actual file entry is still
	required for this special file, but it was in the beginning.

    pix.hhh, pix.imh, pix.pix
	The standard test image, dev$pix.imh, and the STF template header
	file, dev$pix.hhh, required to propagate the special VMS file type
	required by the STF format to new image header files.

    tapecap
    tapecap.<node>
	Magtape device capabilities file.  See os$zfiomt.c for a summary
	of device capabilities.  os$tape.c can be used as a standalone
	Unix task to exercise a tape drive to determine its capabilities.
	Tapecap files can be named either "tapecap.<node>" where <node> is
	the hostname of the server the tapecap file describes, or simply
	"tapecap" to provide a fallback for all servers.  The <node> form
	allows a single IRAF installation to be shared by multiple servers
	while still having distinct tapecap files for each.  The tapecap file
	for a server is located in the IRAF dev$ directory *on the server*.

    termcap
	Device information for all terminals and printers.  The printer
	info should be moved out into a PRINTCAP file at some point.
	If an entry is also in the cache file `cachet.dat', the cache must
	be rebuilt before changes will take effect.

    vdmfile.gki, vdmplot.gki
	Standard test GKI metacode files.  VDMFILE contains several test
	frames, VDMPLOT contains a single, more complicated plot, used to
	test and compare the resolution of different graphics devices.

This directory contains the source for the SDAS table I/O routines.  All
procedure names begin with "tb".  The next letter usually gives some idea of
the kind of object the procedure deals with (t - table, r - row, c - column,
p - parameter, h - header parameter).  Procedures beginning with "tbx", "tby",
"tbf" or "tbz" are lower-level routines for row-ordered tables, column-ordered
tables, FITS tables or text tables respectively.

The top-level procedures are listed in calls.doc in the doc subdirectory.

A description of the file format of a table is given by fileformat.doc in
the doc subdirectory.

Image interpolation package.  Contains interpolator routines specially
designed to interpolate image data.  This interpolator task is characterized
by data arrays in which the data points are equally spaced.  Data points
and interpolation points are referenced simply by array index.  Indefinite
valued pixels may be present in the data.  Since the interpolation routines
will be applied to very large data arrays, efficiency is emphasized in these
routines.

	This directory contains text of the license files that apply
to third-party sources in the IRAF system:

    GPL					For the math$slalib and ecl$readline
    OpenSolaris_License-CDDL.pdf	For the XYACC parser (boot$xyacc)
    UCAR				For NCAR graphics
    ERFA				For ast_julday_to_date in noao$astutil/asttools/asttimes.x
    LLSQ				For math$llsq

The NPROTO package provides a place in the system where users can put their
programs for others to conveniently use, without modifying the IRAF system
itself (see also LOCAL).  A program or package must meet a strict set of
standards to be installed in the IRAF system as a fully supported program;
NPROTO provides a way for users to get software into the system without having
to meet the mainline IRAF standards.  Programs or packages installed in NPROTO
are automatically candidates for eventual migration into the main system.
Tasks installed in NPROTO are generally expected to go away after a while.

Only portable IRAF software should be installed in the NPROTO package.
Nonportable programs should be placed in LOCAL and will not be exported with
the system.

Image i/o.  Coded May 1983, D. Tody.

This initial implementation of IMIO, described in the ".hlp" design file,
provides most of the functionality of the IMIO interface, but is not
fully optimized internally.  Features include:

    (1)	7 disk datatypes (ushort, silrdx).
    (2)	6 in-core datatypes (the standard silrdx).
    (3) Images of up to 7 dimensions are supported internally, though
	only images of up to 3 dimensions are currently supported in the
	interface.
    (4)	Fully automatic multidimensional buffer allocation, resizing,
	and deallocation.
    (5) Arbitrary number of input buffers, allocated in a round robin
	fashion, need not be the same size or dimension.
    (5) Fully automatic type conversion.
    (6) General image sections, coordinate flip, and subsampling.
    (7) Both "compressed" and "block aligned" storage modes are
	supported, with IMIO automatically selecting the optimal
	choice during image creation.  The device blocksize is a
	runtime variable.


Planned future improvements:

    (1)	Boundary extension.
    (3) Optimization to the get/put line procedures to work directly
	out of the FIO buffers when possible.
    (3) Addition of the get/put pixel procedures.
    (4) The image header is currently a simple binary file (structure).
	Only one image header structure per header file is permitted.
	Will be modified to use database facilities, and to permit
	embedded image headers.
    (5) Support for the unsigned byte disk datatype.


FV NOTES:  I've made the following bug fixes:

In imioff:
   The setting of IM_PHYSDIM was taken outside the loop called when
   IM_NDIM was zero.  There is was no way to set IM_PHYSDIM in the programmer
   interface.

In imhdr.h:
   The offset to the user area IMU was changed from 603 to 613.  This was
   a typo?

In impnln:
   The coerce statement is wrong since imgobf calls coerce to the
   appropriate data type.

In impnln:
   There was a typo which did not set ve.

------------------------

Review image interface.  Device namining convention, use of explicit
pathnames.  File read/write permissions required.  Why didn't imdopen
work.

Remove imdmap.x from system library, put in libim.a.


Nov 84
	Optimized line at a time i/o.  Added capability to reference directly
into the FIO buffer.  This greatly improved the efficiency of simple image
operations (no section, type conversion, etc.), without reducing the generality
of the interface.


---------------------------------------------------------------------------
IMIO Modifications, April 1985


1. Boundary Extension

	types:		constant, nearest, reflect, wrap
	parameters:	nbndrypix, tybndry, bndrypixval


2. Database Access

    New fields may be added to an image with IMADD.  The value of an existing
field is set with one of the IMPUT procedures; automatic type conversion will
be performed if necessary and permissible.  The value of an existing field is
fetched with an IMGET procedure.  The image database interface is both forward
and backward compatible, i.e., no changes are required to current programs and
the same interface (ignoring minor semantic details) will be available when
image headers are moved into DBIO.


Functions

	get,g - get the value of a field
	put,p - set the value of a field
	add,a - add a new field to a database
	  acc - determine if the named field exists
	  del - delete a field
       gftype - get field datatype
          gfn - get field name (matching a template)


Procedures

       value = imget[bcsilrdx] (im, "field")
		        imgstr (im, "field", outstr, maxch)
	       imput[bcsilrdx] (im, "field", value)
		        impstr (im, "field", value)
       	       imadd[bcsilrdx] (im, "field", def_value)
		        imastr (im, "field", def_value)
		        imaddf (im, "field", "datatype")
	          y/n = imaccf (im, "field")
			imdelf (im, "field")
	       type = imgftype (im, "field")

	     list = imofnl[us] (im, template)
	   nchars/EOF = imgnfn (list, outstr, maxch)
			imcfnl (list)


The database interface may be used to access any field of the image header,
including the following standard fields.  Note that the nomenclature has
been changed slightly to make it more consistent with FITS.  Additional
standard fields will be defined in the future.


	  keyword     type                 description

	i_naxis		i	number of axes (dimensionality)
	i_naxis[1-7]	l	length of an axis ("i_naxis1", etc.)
	i_pixtype	i	pixel datatype (SPP integer code)
	i_minpixval	r	minimum pixel value
	i_maxpixval	r	maximum pixel value
	i_ctime		l	time of image creation
	i_mtime		l	time of last modify
	i_limtime	l	time when limits (minmax) were last updated
	i_title		s	title string


The following additional field names are recognized, but may disappear in the
future:

	i_history	s	history record (a string buffer at present)
	i_pixfile	s	pathname of the pixel storage file


The names of the standard fields share an "i_" prefix to reduce the possibility
of collisions with data dependent keywords, to identify the standard fields in
sorted listings, to allow use of pattern matching to discriminate between the
standard fields and user fields, and so on.  The use of the "i_" prefix is
made optional for the convenience of the interactive user, but the full name
should always be used in compiled programs.


3. Subfile Management (not implemented)

    A subfile B of file A is a file which is logically subordinate to A but
which is physically a separate file to the host operating system.  A subfile
need not reside in the same directory as the main file.

FIO shall provide support for subfiles as an abstract datatype.  For each
ordinary file there shall optionally be zero or one subfile index files with
the same root name as the main file but with the extension .zsf.  The index
file, if present, shall list the subfiles of the main file.  The operations
supported by FIO for subfiles shall include the following:


	add a subfile to index and return pathname
	delete a subfile from index and return pathname
	get the pathname of a subfile
	delete both index entry and physical file
	delete a file and all subfiles


It is important that FIO maintain the mapping of a subfile name to a physical
file name to permit moves, copies, renames, etc. of files and their subfiles.
Having to open the index file to get the pathname of a subfile is however
inefficient.  To achieve both flexibility and efficiency the system packages
IMIO and DBIO will cache the names of subfiles to eliminate most accesses to
the index files.


	add a subfile:
	    add subfile to the index
	    cache pathname

	open subfile:
	    repeat {
		open subfile using cached pathname
		if (file cannot be opened) {
		    call fio to get the pathname of the subfile
		    if (different from cached pathname) {
			update cached pathname
			next
		    } else
			error: cannot open file
		} else {
		    read file header and verify that this is our subfile
		    if (not our subfile) {
			close file
			call fio to get the pathname of the subfile
			if (different from cached pathname) {
			    update cached pathname
			    next
			} else
			    error: not our subfile
		    } else
			break			# success
		}
	    }

This directory contains miscellaneous tools written in the spp language.
While not really system routines or mathematical library routines, these
library routines are nonetheless sufficiently general purpose to justify
making them publically available.  Reference library "libxtools.a" (-lxtools
on the xc command line) to access these routines.

IRAF Group members are encouraged to add to the tools.  To install a new
tool: (1) copy the .x source into the directory or subdirectory, (2) Enter
the name of each file followed by any dependency files into the mkpkg file,
and (3) enter the UNIX command "mkpkg". This will compile the new modules and
add them to the "libxtools.a" library.

This directory cotnains the original Fortran source for the Bevington
routines, as copied from his book.

Jun85	Removed the nonstandard & in col 1 UNIX style continuation and
	replaced it with standard Fortran (col 6) continuation.

Oct85   Added an extran continuation statement to chifit.f to avoid ambiguous
	transfer of control to statement 70

Nov85   It was possible to get a floating point divide by zero in regres.f
	when rmul=1 in the calculation in statement 135 of ftest.  The value
	of rmul (the correlation) is now tested before the division and a 
	value of ftest = -99999.  is returned when rmul=1.

This directory contains the Fortran source for the SLALIB version 2.5-2
routines. The SLALIB Fortran library has been made available to the IRAF
project courtesy of Patrick Wallace of the Starlink project, the version
distributed here is derived from the Starlink 2012 release in order to
include the GPL'd version of the code.  All the documentation normally
provided with the Starlink routines can be found in the doc subdirectory,
and in the sun67.tex file.  See the 'read.me' and 'SLA_CONDITIONS' file
in this directory for additional information and license restrictions.

In order to complete the port to iraf the following name changes were
made to the package routines. The package prefix was changed from "sla_"
to "sl". Routines with root names that were longer than four characters
have been renamed so that all the package routines have unique six
character names. The complete name change list is shown below.
A Unix sed script for implementing the changes automatically can be found
in the file sedscript, using the editing commands in the files SED1,
SED2, SED3.

The machine dependent routines gresid, random, and wait have been removed
from the IRAF version of SLALIB. The IRAF routines urand in osb$urand.x
and tsleep in etc$tsleep.x can be used to replace the SLALIB routines
random and wait.

No other changes have been made to any of the routines. However a new
routine precss.f has been added to the package. Precss.f is identical to
preces.f except that the system argument is an integer code rather
than a Fortran string. This avoids having to deal with Fortran strings
and conversions in spp programs for this commonly used routine.

The complete name translation list.

sla_ADDET	slADET   
sla_AFIN	slAFIN   
sla_AIRMAS	slARMS   
sla_ALTAZ	slALAZ   
sla_AMP		slAMP   
sla_AMPQK	slAMPQ   
sla_AOP		slAOP   
sla_AOPPA	slAOPA   
sla_AOPPAT	slAOPT   
sla_AOPQK	slAOPQ   
sla__ATMS	slATMS   
sla__ATMT	slATMT   
sla_ATMDSP	slATMD   
sla_AV2M	slAV2M   
	
sla_BEAR	slBEAR   
	
sla_CAF2R	slCAFR   
sla_CALDJ	slCADJ   
sla_CALYD	slCAYD   
sla_CC2S	slCC2S   
sla_CC62S	slC62S   
sla_CD2TF	slCDTF   
sla_CLDJ	slCLDJ   
sla_CLYD	slCLYD   
sla_CR2AF	slCRAF   
sla_CR2TF	slCRTF   
sla_CS2C	slCS2C   
sla_CS2C6	slS2C6   
sla_CTF2D	slCTFD   
sla_CTF2R	slCTFR   
	
sla_DAF2R	slDAFR   
sla_DAFIN	slDAFN   
sla_DAT		slDAT   
sla_DAV2M	slDAVM   
sla_DBEAR	slDBER   
sla_DBJIN	slDBJI   
sla_DC62S	slDC6S   
sla_DCC2S	slDC2S   
sla_DCMPF	slDCMF   
sla_DCS2C	slDS2C   
sla_DD2TF	slDDTF   
sla_DE2H	slDE2H   
sla_DEULER	slDEUL   
sla_DFLTIN	slDFLI   
sla_DH2E	slDH2E   
sla_DIMXV	slDIMV   
sla_DJCAL	slDJCA   
sla_DJCL	slDJCL   
sla_DM2AV	slDMAV   
sla_DMAT	slDMAT   
sla_DMOON	slDMON   
sla_DMXM	slDMXM   
sla_DMXV	slDMXV   
sla_DPAV	slDPAV
sla_DR2AF	slDRAF   
sla_DR2TF	slDRTF   
sla_DRANGE	slDA1P   
sla_DRANRM	slDA2P   
sla_DS2C6	slDSC6   
sla_DS2TP	slDSTP   
sla_DSEP	slDSEP   
sla_DT		slDT   
sla_DTF2D	slDTFD   
sla_DTF2R	slDTFR   
sla_DTP2S	slDTPS   
sla_DTP2V	slDTPV   
sla_DTPS2C	slDPSC   
sla_DTPV2C	slDPVC   
sla_DTT		slDTT   
sla_DV2TP	slDVTP   
sla_DVDV	slDVDV   
sla_DVN		slDVN   
sla_DVXV	slDVXV   
	
sla_E2H		slE2H   
sla_EARTH	slERTH   
sla_ECLEQ	slECEQ   
sla_ECMAT	slECMA   
sla_ECOR	slECOR   
sla_EG50	slEG50   
sla_EL2UE       slELUE   
sla_EPB		slEPB   
sla_EPB2D	slEB2D   
sla_EPCO	slEPCO   
sla_EPJ		slEPJ   
sla_EPJ2D	slEJ2D   
sla_EQECL	slEQEC   
sla_EQEQX	slEQEX   
sla_EQGAL	slEQGA   
sla_ETRMS	slETRM   
sla_EULER	slEULR   
sla_EVP		slEVP   
	
sla_FITXY	slFTXY   
sla_FK425	slFK45   
sla_FK45Z	slF45Z   
sla_FK524	slFK54   
sla_FK52H       slFK5H
sla_FK54Z	slF54Z   
sla_FK5HZ       slF5HZ
sla_FLOTIN	slRFLI   
	
sla_GALEQ	slGAEQ   
sla_GALSUP	slGASU   
sla_GE50	slGE50   
sla_GEOC	slGEOC   
sla_GMST	slGMST   
sla_GMSTA	slGMSA   

sla_H2E		slH2E   
sla_H2FK5       slHFK5
sla_HFK5Z       slHF5Z
	
sla__IDCHI	slICHI   
sla__IDCHF	slICHF   
sla_IMXV	slIMXV   
sla_INTIN	slINTI   
sla_INVF	slINVF   
	
sla_KBJ		slKBJ   
	
sla_M2AV	slM2AV   
sla_MAP		slMAP   
sla_MAPPA	slMAPA   
sla_MAPQK	slMAPQ   
sla_MAPQKZ	slMAPZ   
sla_MOON	slMOON   
sla_MXM		slMXM   
sla_MXV		slMXV   
	
sla_NUT		slNUT   
sla_NUTC	slNUTC   
	
sla_OBS		slOBS   
sla_OAP		slOAP   
sla_OAPQK	slOAPQ   
	
sla_PA		slPA   
sla_PAV		slPAV   
sla_PCD		slPCD   
sla_PDA2H	slPDAH   
sla_PDQ2H	slPDQH   
sla_PERTEL      slPRTL   
sla_PERTUE      slPRTE   
sla_PLANEL      slPLNE   
sla_PLANET	slPLNT   
sla_PLANTE      slPLTE   
sla_PM		slPM   
sla_POLMO       slPLMO
sla_PREBN	slPRBN   
sla_PREC	slPREC   
sla_PRECES	slPRCE   
sla_PRECL	slPREL   
sla_PRECSS      slPRCS			# no SLALIB version
sla_PRENUT	slPRNU   
sla_PV2EL       slPVEL   
sla_PV2UE       slPVUE   
sla_PVOBS	slPVOB   
sla_PXY		slPXY   
	
sla_RANGE	slRA1P   
sla_RANORM	slRA2P   
sla_RCC		slRCC   
sla_RDPLAN	slRDPL   
sla_REFCO	slRFCO   
sla_REFCOQ      slRFCQ   
sla_REFRO	slRFRO   
sla_REFV	slREFV   
sla_REFZ	slREFZ   
sla_RVEROT	slRVER   
sla_RVGALC	slRVGA   
sla_RVLG	slRVLG   
sla_RVLSRD	slRVLD   
sla_RVLSRK	slRVLK   
	
sla_S2TP	slS2TP   
sla_SEP		slSEP   
sla_SMAT	slSMAT   
sla_SUBET	slSUET   
sla_SUPGAL	slSUGA   
sla_SVD		slSVD   
sla_SVDCOV	slSVDC   
sla_SVDSOL	slSVDS   
	
sla_TP2S	slTP2S   
sla_TP2V	slTP2V   
sla_TPS2C	slTPSC   
sla_TPV2C	slTPVC   
	
sla_UE2EL       slUEEL    
sla_UE2PV       slUEPV    
sla_UNPCD	slUPCD   
	
sla_V2TP	slV2TP   
sla_VDV		slVDV   
sla_VN		slVN   
sla_VXV		slVXV   
	
sla_XY2XY	slXYXY   
sla_ZD		slZD   

These directories contain the codes described in the book "A Practical Guide
to Splines", by Carl DeBoor, Springer-Verlag, 1978.  The directory math/deboor
contains the single precision routines.  The same routines, edited to provide
double precision, are in the directory "dblprec", which may disappear at some
point in the future if we decide we don't need these.  The directory "progs"
contains a number of example programs from the book.

A number of the routines herein write error messages using Fortran i/o,
violating our convention that numerical routines should not perform i/o.
These routines have been flagged by adding the suffix "_io".  These routines
have not been compiled and installed in the library "deboor.a".  The most useful
routines either did not do i/o, or have had the i/o removed (e.g., splint.f).

Note: use the new SPLLSQ for smoothing with splines, instead of L2APPR, if a
uniform knot sequence is desired.  Use BSPLN to evaluate the coefficient array
from SPLLSQ.

Oct 85	Rearranged the order of argument declarations in cwidth.f, dtblok.f,
	factrb.f, fcblok.f, sbblok.f, shiftb.f, slvblk.f, subbak.f, subfor.f
	to conform with Fortran standard

HLIB -- Host system library.  All global library files which are machine at all
	host system dependent are placed in this library, rather than in lib$.

cllogout.cl		log out of the CL (not normally host dependent)
clpackage.cl		contains host system dependent device names
config.h		very host dependent
iraf.h			potentially host dependent
irafuser.csh		sets up UNIX/CSH environment for IRAF
libc			the C runtime library header files (mostly portable)
login.cl		default login.cl file (contains device names)
mach.h			machine constants (machine dependent)
mkiraf.csh		set up UNIX/IRAF files for a user
zzsetenv.def		environment startup file (contains device names)

BOOT -- Bootstrap utilities for building and maintaining IRAF.  The utilities
in this package are implemented at the host system level, sometimes with
assistance from the iraf kernel or other libraries.  All utilites are host
system callable, regardless of how they are implemented.

Major directories:

	mkpkg		- package/library maintenance utility
	spp		- compiler for the SPP language
	rmbin		- seek out and destroy all binaries in a directory tree
	rtar		- tar file reader
	wtar		- tar file writer
	bootlib		- system interface for the bootstrap utilities

Others:

	xyacc		- SPP/Yacc
	generic		- generic preprocessor
	vfn		- old boot-boot version of vfn2osfn (not currently used)

GIO

    This directory contains the source for the IRAF GIO (graphics i/o)
interface.  The interface is documented in the file "Gio.hlp".  Source for
the STDGRAPH kernel will be found in the subdirectory "stdgraph".  Source
for the NSPP kernel will be found in the subdirectory "nspp".

			   Kernel Interface Package
				12-May-85 dct
			         (21-Aug-85)


1. Introduction

    The kernel interface package (KI) isolates the IRAF virtual operating
system (VOS) from the IRAF kernel, permitting access either to the local
kernel or to an IRAF kernel resident on a remote host, via an IRAF kernel
server (KS).  The KI provides access to files, peripherals and devices,
and subprocesses irrespective of whether the resource is located on the
local machine or on a remote node.  Since the KI is implemented on top of
the IRAF kernel the different nodes may run different native operating systems.


           +-----------+
           |           |                  VOS = virtual operating system
           |   V O S   |                   KI = kernel interface
           |           |                   KS = kernel server
           +-----------+
                 |               :
                 |
           +-----------+         :        +-----------+
           |           |                  |           |
           |    K I    |=========:========|    K S    |==== (etc)
           |           |                  |           |
           +-----------+         :        +-----------+
                 |                              |
                 |               :              |
           +-----------+                  +-----------+
           |           |         :        |           |
           |   local   |                  |  remote   |
           |   kernel  |         :        |  kernel   |
           |           |                  |           |
           +-----------+         :        +-----------+
   
                                 :
              (host1)                        (host2)


	              Architecture of the Kernel Interface


2. Conceptual Design

    The purpose of the kernel interface is to permit access to logical files,
devices, and subprocesses regardless of where such objects physically reside
in a network.  This permits sharing of peripherals such as image displays and
plotters, data sharing (centralized databases), load sharing (running of
subprocesses on lightly loaded nodes), and makes such mundane operations as
copying a file between two nodes possible without developing special purpose
software and further complicating the user interface.

By addressing these problems by implementation of an interface just above
the IRAF kernel it becomes possible to remotely access nodes running different
native operating systems, e.g., UNIX and VMS, with the IRAF kernel on each host
system resolving the differences between file formats and filenames found
on the different host systems.  Full access to text files and raw peripherals
is inherent in the scheme regardless of the architecture of the host machine.
Full access to binary datafiles is possible provided the binary format is
machine independent, a desirable goal in any case.

The kernel interface is conceived as an optional and invisible interface
between the IRAF virtual operating system and the IRAF kernel.
The specifications of the kernel are not affected by the KI, except for the
addition of a new device driver for talking to remote kernel servers.  The VOS
sees the same kernel interface whether or not the system is configured with a
KI.

A VOS call to a kernel procedure such as ZOPNBF, for example, is directed
instead to the KI procedure KOPNBF which in turn calls either the local ZOPNBF
or passes the call to a remote KS.  The VOS still calls the procedure "zopnbf",
but the external name of this procedure is redefined in <config.h> as "kopnbf",
permitted substitution of the KI merely by recompilation.  When the file is
opened a channel descriptor is allocated within the KI telling whether the
channel is local or remote, and if remote giving the KS address on the net,
and giving the kernel channel number of the file on the node on which it
resides.  The KI channel number instead of the kernel channel number is
returned to the VOS.  Subsequent i/o requests on the channel are also processed
by the KI, which uses the channel descriptor to determine whether the file
is local or remote and then fulfils the request.


3. Other Network Interfaces

    The kernel interface is not intended to replace or compete with "real"
network implmentations such as NFS or DECNET.  If the local net provides such
facilities then remote access via the host network is equivalent to a local
file reference.  Few such commercial networks, however, permit equivalent
access when the different nodes run different operating systems.
Often the type of access provided by the network is restricted in some way,
e.g., NFS permits transparent access to remote files but not to remote devices.
On VMS an IRAF kernel routine which accesses an i/o channel at the QIO level
is bypassing DECNET hence can only be used to access a local device.
The kernel server approach neatly sidesteps these problems without preventing
use of the host networking facilities in cases were it is desirable to do so.


4. Performance

    The overhead of the KI for a local file access is one additional procedure
call per i/o request, e.g., an additional 20-30 microseconds per i/o request.
A remote file access requires encoding of the request as a KI instruction,
transmission of the instruction to the remote host, decoding of the instruction
by the remote host, a kernel access on the remote host, and in the case of a
read request transmission of the data back to the requesting node where it is
read out into the caller's buffer.  Handshaking is required to return the status
value after reads and writes to a remote node, hence large transfers will
significantly reduce the overhead involved in remote file access.  Large data
transfers are automatically transferred in segments by the interface code,
hence there is no builtin limit on the size of a transfer.

A file open or process spawn requiring connection to a kernel server on a
remote host is a relatively expensive procedure since it requires spawning of
the kernel server process on the remote host.  Once a process has connected to
a kernel server on a remote host that server will remain connected for the
life of the local process, with the single connection providing simultaneous
access to any number of files, devices, or child processes on the remote host.
Each local process requires its own kernel server process on the remote node.


5. Modifications to the Existing I/O System

    As noted above, implementation of the KI should require minimal
modifications to existing software.  The specific modifications or additions
required appear to be the following:


additions:

	add package KI (kernel interface)
	add source for the KS (kernel server) process
	add KS device driver to the kernel (package OS)
	add ZGHOST (get hostname) primitive to OS
	add SPP and LIBC include files <knames.h> to map zroutine names


modifications:

	add reference to <knames.h> to VOS procedures which access kernel
	finit.h: install kernel server device driver at process startup
	modify filename mapping:
	    do not map filenames which begin with a node name 
	    prepend CWD to relative filenames if CWD is on a remote node (?)


6. Filenames

    Files and processes anywhere in the network may be accessed by prepending
the node name to the VFN or OSFN of the file.  In essence we have extended
the VFN filename syntax to support node names.  The syntax is as follows:

	node "!" filename

The field delimiter "!" is used because it is not used in filenames in AOS,
UNIX, or VMS.  The delimiters ":" and "::", commonly used as node name
delimiters in commercial networds, were intentionally not used so that network
filenames may be specified without conflict on systems with host network
support.  Typical filenames using this notation are shown below.

	2!/dev/iis
	1!lib$motd
	3!dra0:[user.data]pic.db

An important consideration in choosing the node delimiter character is that
it not be necessary to quote filenames in common everyday usage.  It turns out
that in the CL "command mode" the character ! is only recognized as a
metacharacter when it occurs at the beginning of a command (as the OS escape),
hence quoting of filenames containing ! will not be necessary.

The strategy for resolving such filenames is as follows.  The full filename
including the nodename is passed to the filename mapping code on the local
machine.  If the filename includes a nodename the filename is not mapped.
The KI receives the filename and strips off the nodename, using it to
select the node which will execute the kernel primitive.  The remainder of
the filename (minus the nodename) is passed to the KS on the addressed node,
and the KS performs the filename mapping and passes the mapped filename on
to the IRAF kernel.  Since the filename mapping is carried out by the KS on
the remote node the filename will be mapped in the context of the remote
machine, i.e., the mapping will depend upon the native operating system used
on the remote node.  If the KS is itself configured with a kernel interface,
multiple indirection is possible, permitting gateways onto other networks,
e.g., "gateway!node!filename".

There should be no penalty for using a self referential node name in a
filename, i.e., the system should be smart enough to ignore node names
when the node named is the local node.  This permits use of the same absolute
network filenames in configuration tables on all nodes, without having to
maintain different sources on the different nodes.

Fully functional filename mapping requires that the IRAF environment variables
used by a process on the local machine be propagated to the kernel server on
the remote machine.  If this is not done then package directory references,
etc., appearing in virtual filenames will not be resolved.  The kernel server
will inherit all environment variables except iraf$, since logical directory
names of the form "node!ldir$file" must be expanded relative to the iraf
root directory on the remote node.  User defined logical directories should
include an explicit node name to permit access from any node.


6.1 External KI Procedures

    The majority of the KI procedures are internal, since the KI interface
is hidden behind the procedure redefinitions in <knet.h>.  Other subsystems
of the VOS do however occasionally need access to the KI, and the following
procedures are provided for this purpose.


	ki_extnode - Extract (or delimit) the node name field
	ki_mapchan - Map KI channel into OS channel (or pid) and node name

   len_prefix =  ki_extnode (resource, nodename, maxch, nchars)
       oschan =  ki_mapchan (kichan, nodename, maxch)


The EXTNODE function is used to extract the node name from a resource name,
e.g., to produce a simpler name as required by the low level code, or to
propagate the node name prefix to a second resource name.  The MAPCHAN function
is used to convert a KI channel descriptor into the corresponding OS channel
number and node name, e.g., for output to the user (the KI channel code is
meaningless to the user).


7. KI Procedures

    Only those procedures in the IRAF kernel which take a filename as an operand
or which do i/o to a file (or to IPC) need be mapped by the kernel interface.
This subset of the kernel includes all the file primitives, all the device
drivers, and some exception handling procedures.

	zfacss - determine file accessibility
	zfaloc - allocate a file
	zfchdr - change default directory 		(??)
	zfdele - delete a file
	zfgcwd - get default directory 			(??)
	zfinfo - get directory info on a file
	zfmkcp - make a null length copy of a file
	zfprot - set, remove, or query file protection
	zfrnam - rename a file
	zopdir - open a directory
	zgfdir - get next filename from a directory

	zopdpr - open a detached process
	zcldpr - close a detached process
	zopcpr - open a connected subprocess
	zclcpr - close a connected subprocess
	zintpr - interrupt a subprocess

	zfiobf - binary file driver
	zfiolp - line printer driver
	zfiomt - magtape driver
	zfiopl - plotter driver
	zfiopr - ipc driver
	zfiosf - static file driver
	zfiotx - text file driver
	zfioty - terminal driver


The basic function of a KI procedure is to determine which host is to execute
the kernel primitive, call the local or remote kernel to execute the primitive,
and return the results to the calling program.


7.1 Pseudocode for a KI Procedure

    Consider the common case of reading a file on a remote host.  The file
open procedure must connect to the KS on the remote host, command the remote
kernel to open the file, and read back the status of the open.  Whether the
file is on the local or remote node, a channel descriptor must be set up
to tell the KI i/o primitives how to access the file.


# KOPNBF -- KI version of ZOPNBF (open binary file).

procedure kopnbf (osfn, mode, status)

begin
	ks = get_kernel_server (osfn)
	if (ks is the local node)
	    call zopnbf (osfn, mode, status)
	else {
	    encode KI instruction for zopnbf
	    write instruction to KS
	    read reply from KS
	    if (error on channel to KS)
		return (status=ERR)
	}

	set up channel descriptor (set channel codes of KS and file)
end


# GET_KERNEL_SERVER -- Return a channel to the kernel server controlling
# a virtual filename.

int procedure get_kernel_server (vfn)

begin
	extract node name from vfn
	if (no node name given)
	    return (0)
	else if (node is already connected)
	    return (node channel)
	else {
	    connect to the KS on the remote node
	    save channel of node in channel table
	    return (node channel)
	}
end


# KARDBF -- KI version of ZARDBF (read from a binary file).  The read will not
# be asynchronous if the file is resident on a remote node.  The size of a
# transfer is not limited by the maximum block of the channel.

procedure kardbf (chan, buf, maxchars, offset)

begin
	if (ks[chan] == 0)
	    call zardbf (chan, buf, maxchars, offset)
	else {
	    encode KI instruction for ZARDBF
	    write KI instruction to remote kernel server
	    read back the KI header of the response

	    if (read status ok and KI status for read ok) { 
		transfer data from channel directly into callers buffer,
		    in blocks no larger than the channel block size
		save channel status for KAWTBF
	    }
	}
end


7.2 Data Structures

    The data structures required by the kernel interface are small and are
statically allocated.


7.2.1 Host Name Table

    The host name table (HNT) lists all of the hosts in the network which the
KI can access, giving for each node the node filename of the kernel server
process on that node, and a list of aliases (node names) for the node.
The host name table is the text file "dev$hosts".  The format of the file
is illustrated by the following example:


	1!/iraf/lib/irafks.e		: 1 a vax1 aquila
	2!/iraf/lib/irafks.e		: 2 b vax2 lyra
	3!usr1\:[irafx.lib]irafks.exe	: 3   vax3 vela
	5!/iraf/lib/irafks.e		: 5 c vax5 carina
	6!usr1\:[irafx.lib]irafks.exe	: 6   vax6 draco
	11!/iraf/lib/irafks.e		: 11  sun1 petunia


The format of an entry in this table is "server ':' aliases", where "server"
is a machine dependent, colon delimited string to be passed to the ZFIOKS
driver, and where the aliases are a sequence of null delimited logical names
by which the high level code or the user can refer to the nodes.  The first
field, e.g., "server", is limited to 80 characters, the aliases to 8 characters
(longer names will be silently truncated, either limit may be increased if
necessary).  Up to 8 aliases may be specified.  The alias "0" will be
automatically added to the alias list of the local node by the KI; this alias
is used by the high level code to force a file to be accessed on the local node.
The local node should also include as an alias the name returned by ZGHOST.
The maximum number of nodes is a <config.h> parameter.  The entries may appear
in any order.  


7.2.2 Node Descriptor Table

    For each entry in the host name table there is a corresponding entry in
the node descriptor table (NDT).  The fields of the NDT are initialized
when the first filename containing a node reference is processed.  When a
kernel server is opened on a node the N_KSCHAN field is set to the channel
code returned by the kernel server device driver.


	int	n_nnodes		# number of nodes in table

	struct node_descriptor {
		int	n_kschan	# KS i/o channel or NULL
		int	n_local		# set to YES for the local node
		int	n_nalias	# number of aliases for this node
		char	n_server[64]	# netname!process
		char	n_alias[8,8]	# aliases
	} ndt[MAX_NODES]


Runtime node references are satisfied by searching the NDT for the specified
alias.  If the referenced node is the local node a NULL channel number is
returned.  If the N_KSCHAN field of the referenced node is null a kernel
server is spawned and the channel number of the server returned.  If a kernel
server is already connected mapping an alias into a channel number is very
fast (compared to a file open).  Once a server is spawned it remains connected
until the local process shuts down.


7.2.3 Channel Descriptor Table

    Each open file or connected subprocess requires one channel descriptor
for each i/o channel or process id.  The K_KSCHAN field will contain NULL if
the channel resides on the local node.  Channel descriptors are allocated at
file or device open time or process connect time and are freed at close or
disconnect time.  If the channel is connected to a kernel server, the K_OSCHAN
and K_PID fields will contain the OS channel number or process id of the
resource as returned by the kernel server on the remote node.

	
	struct channel_descriptor {
		int	k_kschan	# KS channel (NULL if local node)
		int	k_oschan	# OS channel number or PID
		int	k_status	# status for the ZAWAIT call
	} cdt[MAX_CHANNELS]


7.3 KII Instruction Format

    The kernel interface instruction format (KII) is the binary encoding of
the data blocks sent to and received from the remote kernel server to execute
a call to a kernel procedure.  This format is machine independent, i.e.,
it is defined in a way that is independent of the byte ordering, char size,
etc. used by a node.  The KII format provides a machine independent interface
for the execution of all kernel subroutines as well as for text file i/o.
Binary data blocks passed via the binary file i/o procedures are not affected,
hence if a machine independent binary format is desired it must be implemented
at a level higher than the KI.

The KII format selected is a fixed format to simplify encode/decode and
packet transfer (if the transfer medium is stream oriented fixed size packets
are simpler to extract from the stream).  For media such as Ethernet
performance depends more upon the number of packets transferred than upon
the size of a packet, so there is little penalty for wasted space in a fixed
size packet.  The maximum amount of information necessary to encode a kernel
procedure call is limited (the argument lists are never large) hence it is
easy to set an upper bound on the packet size.  The KII packet structure is
shown below.
	
	struct kii_packet {
		int	p_opcode	# instruction opcode
		int	p_subcode	# subcode (for device drivers)
		int	p_arg[13]	# procedure arguments
		int	p_sbuflen	# nchars in string buffer
		char	p_sbuf[255]	# string buffer
	}

	sizeof (struct kii_packet) == ((16*4)+256) == 320 bytes


The OPCODE and SUBCODE fields identify the kernel procedure to be executed.
Each procedure argument is passed in the corresponding field of the ARG array;
for string arguments this field contains the offset of the string value in
the P_SBUF field.  Procedure argument N is passed in field N of the ARG array.
P_SBUFLEN is the number of chars in the string buffer, including the EOS at
the end of each string.

Before transmission of the packet over the net the packet is encoded in
a machine independent form.  The 16 integer fields are converted into MII
32 bit signed integer format, and the 256 character string buffer is packed
one byte per character (only the first SBUFLEN characters are packed).  The
inverse transformation is performed by the kernel server on the remote node
before accessing the contents of the packet.

Most kernel procedures return a status value and/or data.  The KII packet
structure is used both to remotely execute a kernel procedure and to return
the status value and any scalar or string output arguments.  In the case of
text file i/o the text data is passed in the SBUF field.  Procedures which
return a data structure (e.g., ZFINFO) may pass the data structure as a
sequence of ARG array elements, encode the structure in chararacter form
in SBUF, or pass the structure in a separate packet.  In most cases a single
packet will be used for greater efficiency and to avoid the need to
explicitly encode the return value.

The purpose of the SUBCODE field is to exploit the fact that the text and
binary file drivers each have the same set of driver procedures, each with
the same set of arguments.  The OPCODE field identifies the device driver
and the SUBCODE field the driver function, e.g., OPN, ARD, AWR, AWT, etc.


8. KS Driver

    Connecting and disconnecting kernel servers, and all i/o to connected
kernel servers, is provided by the KS driver.  To the KI in the calling
process a KS behaves like a synchronous binary file opened for readwrite
access.  The driver is patterned after a binary file driver, allowing the
server process to be connected to FIO as a streaming binary file.  Normally,
however, the driver procedures will be called directly by the KI.


	zopnks (server, mode, chan)
	zawrks (chan, buf, nbytes, offset)
	zardks (chan, buf, maxbytes, offset)
	zawtks (chan, status)
	zsttks (chan, what, lvalue)
	zclsks (chan, status)


The entry points of the KS driver are shown above.  The argument SERVER is
the network pathname of the kernel server process, e.g., "2!/iraf/lib/ks.e".
There no requirement, however, that the named process be a kernel server
process.  The driver will attempt to execute and set up readwrite streaming
i/o to any process, hence the KS driver may be useful for network functions
other than the kernel interface.


9. Kernel Server Process

    The kernel server process is an IRAF process with a standard IRAF Main
but a special ONENTRY procedure and no task dictionary (like the CL).
The server communicates with a KI via the binary streams CLIN and CLOUT,
both of which are connected to a single channel in the calling process.
The server process contains an interpreter capable of calling any kernel
procedure which does i/o.  In addition, the kernel server contains enough
of FIO to map filenames and read and write CLIN and CLOUT.  


10. Filename Mapping Details

    The system interface procedures used for filename mapping must be trapped
by the KI to deal with node pathnames.  The relevant procedures are the
following:

	zfnbrk		break vfn into its component parts
	zfchdr		change directory
	zfgcwd		get default directory
	zfxdir		extract directory prefix
	zfpath		convert vfn to pathname
	zfsubd		fold subdirectory into pathname

The first routine, ZFNBRK, merely parses filenames into their component fields
and it should be possible for the same routine to be used on all nodes without
help from the KI.  The remaining routines are fundamental to the action of
the KI.


10.1 Default Directory

    Normally, either the kernel or the host system keeps track of the default
directory.  This remains the case when the KI is in use, provided the default
directory is on the local node.  If the default directory is changed to some
different node the following actions are taken by the KI:

    [1]	Extract node prefix and save in a KI common for use during filename
	mapping.

    [2] Execute ZFCHDR on the remote node (minus the node prefix) to set
	the node-relative default directory.

All subsequent runtime file references are mapped as follows:

    [1]	The default node prefix is prepended to all filenames which do
	not include an explicit node name prefix.

    [2] Normal filename mapping is performed, i.e., filename mapping is
	disabled on the local node (since the filename has a node prefix),
	deferring mapping to the kernel server on the remote node.

All normal runtime filename mapping starts with a call to ZFXDIR.  If ZFXDIR
returns anything the filename is assumed to be host dependent and is not mapped.
Hence we want ZFXDIR to return the entire VFN as if it were an OSDIR name,
if the VFN includes a node prefix and the node referenced is not the local
node.  ZFPATH and ZFSUBD must behave similarly.


10.2 Semicode


procedure kfchdr (osdir, status)

begin
	server = ki_connect (osdir)

	if (server == NULL) {
	    # Directory is on the local node.

	    default node = local node
	    call zfchdr (osdir_minus_node_prefix, status)

	} else {
	    # Directory is on a remote node.

	    pass zfchdr request to remote node
	    if (request is successful)
		default node = remote node
	}
end


procedure kfgcwd (osdir, nchars)

begin
	if (default node is the local node)
	    call zfgcwd to get default directory
	else
	    pass zfgcwd request to remote node

	return (default_node // default_directory)
end


procedure zfxdir (vfn, osdir, maxch, nchars)

begin
	extract node name

	if (no node name specified)
	    node name = default node

	if (node is the local node)
	    pass the request to the local kernel
	else
	    return (node // vfn)
end


procedure zfpath (vfn, pathname, maxch, nchars)

begin
	extract node name

	if (no node name specified)
	    node name = default node

	if (node is the local node) {
	    call zfpath to compute local pathname
	    return (node // pathname)
	} else
	    return (node // vfn)
end


procedure zfsubd (osfn, maxch, subdir, nchars)

begin
	extract node name

	if (no node name specified)
	    node name = default node

	if (node is the local node) {
	    call zfsubd to compute local pathname
	    return (node // pathname)
	} else
	    return (node // vfn // "subdir/")
end

This directory contains the IRAF File I/O (FIO) routines.  This version of
FIO fully implements revision 5 of the FIO interface as described in Fio.hlp.
Internally, however, the buffer management code has been simplified by
restricting the number of buffers to one per file, and omitting global buffers.
These features will be added in an upcoming revision of FIO.  No modifications
to the external specifications of the FIO interface should be necessary.
D. Tody, 04-Apr-83.

Jul84	Added filename mapping, filename locking, extensive modifications to
	make use of the new kernel.

This directory contains all CL-callable routines for the "system" package.
Included are routines for file manipulation, date and time, device access,
and so on.  Certain of these routines are machine dependent; search for 
the string "MACHDEP" to identify such files.

FMIO -- BINARY FILE MANAGER (Jul88 DCT)
----------------------------------------------

    This directory contains the sources for a general low level binary file
manager (FMIO).  The purpose of this file manager is to manage a fixed number
of "lightweight files", or LFILES, maintained within a single variable length
binary file.  This facility is used by higher level interfaces such as
database interfaces to store variable length objects efficiently in a single
host binary file.


1. INTERFACE PROCEDURES

1.1 General Procedures

    The main FMIO interface procedures are summarized in the table below.
Most access to lfile data is intended to be via the FIO binary file driver
procedures (beginning with fm_lfopen in the figure).

	yes|no = fm_acccess (datafile, mode)
		  fm_rename (datafile, newname)
		    fm_copy (datafile, newname)
		  fm_delete (datafile)
		 fm_rebuild (datafile)

	       fm = fm_open (datafile, mode)
		    fm_seti (fm, param, ival)
	    ival = fm_stati (fm, param)
		   fm_debug (fm, out, what)
		   fm_copyo (fm, fm_to)
		    fm_sync (fm)
		   fm_close (fm)

       lfile = fm_nextlfile (fm)
		  fm_lfname (fm, lfile, type, lfname, maxch)
        ERR|OK = fm_lfparse (lfname, fm, lfile, type)
		  fm_lfcopy (fm_src, lfile_src, fm_dst, lfile_dst)
		   fm_fopen (fm, lfile, mode, type)

		  fm_lfopen (lfname, mode, lf)
		 fm_lfstati (lf, param, ival)
		 fm_lfaread (lf, buf, nbytes, offset, status)
		fm_lfawrite (lf, buf, nbytes, offset, status)
		 fm_lfawait (lf, status)
		 fm_lfclose (lf, status)

		  fm_lfstat (fm, lfile, statbuf)
		fm_lfdelete (fm, lfile)
	      fm_lfundelete (fm, lfile)


1.2 Buffer Cache

    To avoid excessive disk i/o when randomly accessing the datafile, it is
desirable to maintain a cache of several lfile data buffers, e.g., so that
accesses to a series of objects stored in a single lfile, or repeated accesses
to portions of several lfiles should incur minimal disk accesses.  A simple
way to implement such a buffer cache is to simply open each lfile as a file
under FIO, leaving it up to FIO to manage the file buffer, and maintaining
a LRU cache of open lfiles.  The number of buffers (open lfiles) is easily
parameterized.  The buffer cache procedures are summarized in the figure
below.

              fd = fm_getfd (fm, lfile, mode, type)
                   fm_retfd (fm, lfile)
                 fm_lockout (fm, lfile)
                 fm_debugfd (fm, out)

The fm_getfd routine maps an lfile onto a file descriptor.  A file descriptor
is opened on the lfile only when necessary.  Once opened, an lfile remains in
the cache until forced out by the LRU replacement algorithm, or the datafile
is closed.  While the datafile remains open, removal of an lfile from the
cache (closing the associated file descriptor) is permitted only after a call
to fm_retfd; calling this routine does not immediately close the file, it only
permits it to be closed.  Repeated to fm_getfd should return a file descriptor
immediately, with very little overhead, with an already active file buffer,
hence repeated calls to the cache manager and FIO may often be made without
incurring any disk accesses.

Note that lfiles may be opened on file descriptors via direct calls to the
file manager, regardless of whether these lfiles are already open in the
buffer cache (e.g., with fm_fopen).  This allows two or more independent
file buffers to be simultaneously active on the same lfile, but opens the
possibility of loss of data if the buffers overlap.  If this is a problem,
the routine fm_lockoutfd may be called to prevent inadvertent use of an lfile
by the cache.  This should be followed by a call to fm_retfd to clear the
lockout bit once the reason for the lockout (usually a noncached lfile open)
is gone.  The routine fm_debugfd will print information on stream 'out'
describing the status of the buffer cache.


2. FILE STRUCTURE

The layout of a datafile is as follows:

	    +   +-------------------------+
	    |   |     datafile header     |     (fixed size)
     stored |   |  +-------------------+  |
       as - +   |        file table       |     (configurable)
      unit  |   |  +-------------------+  |
	    |   |      page table index   |     (configurable)
	    +   +-------------------------+
                             |
                         data pages             (dynamic)
                             |
                             v

The datafile header is a fixed format binary structure.  The file table
contains one entry for each lfile stored in the datafile; the maximum number
of lfiles is fixed at datafile creation time.  Each lfile is known by its
lfile number, ranging from zero to MAXLFILES.  Lfile zero is the PAGE TABLE,
used to map each data page in the datafile to the lfile to which it is
allocated.  The first user lfile is hence number 1.  Lfiles may by any size;
storage is allocated in units of PAGES.  The page size is fixed at datafile
creation time.	There are two types of files, binary (opaque) files, and
text files.  Both file types appear as binary files to the high level code,
i.e., both are accessed by a FIO binary file driver, the only difference
being that for a text file, data blocks are assumed to contain text and are
packed/unpacked during i/o (saving storage and rendering the file machine
independent).

It is important to realize that lfiles are referred to only by FILE NUMBER
in this interface; any association with symbolic names must be made at a
higher level (lfiles are by no means necessarily associated with "files" at
the higher level, i.e., they might be used to store variable length parameters,
relations, or whatever).  All lfiles exist, in a sense, as zero length files
at datafile creation time.  To open a new lfile, one first calls fm_nextlfile
to get the file number of an empty lfile.  Lfiles can be deleted, but storage
is never deallocated; new pages are always allocated at the end of file.
Hence deleted lfiles can be undeleted, and the entire datafile must normally
be copied (or "rebuilt") to reclaim unused space and coalesce file segments
for more efficient i/o.  (There are cases where a deleted lfile can be reused
without rebuilding the lfile: fm_nextlfile will begin reusing deleted lfiles
after it wraps around, and the client software can always open an lfile
NEW_FILE, overwriting the pages already allocated to the lfile).

The FMIO datafile itself, and any text files stored therein, is maintained in
a machine indepenent format.  Binary file data is merely copied to and from
the datafile, hence it is up to the client software to store binary data in
a machine independent format, if desired.


2.1 Recovery

    Since new data pages are always allocated at the end of file (next
available PTE), and the datafile state is always sync-ed as a unit, protected
as a critical section (ignoring modifications to lfile data), a datafile
should always be recoverable after a crash, with loss only of data written
since the last sync.  The datafile is sync-ed automatically every several
minutes.  Applications wishing to protect newly written lfile data can sync
the datafile manually if desired.


3. RUNTIME DATA STRUCTURES

The internal runtime data structures are summarized below.  The terminology
used is as follows:

	FM		file manager
	FT		file table
	FTE		file table entry
	LFILE		lightweight file
	PAGE		unit of datafile file storage
	PT		page table
	PTE		page table entry
	PTI		page table index


# FMDES -- Main FM descriptor.
struct fmdes {
	int	fm_magic		# identifies file/descriptor type
	int	fm_active		# set once descriptor is initialized
	int	fm_chan			# host i/o channel for datafile
	int	fm_mode			# datafile access mode
	int	fm_dfversion		# datafile file version
	int	fm_szpage		# datafile page size, bytes
	int	fm_nlfiles		# number of lfiles
	int	fm_datastart		# file offset of first data page
	int	fm_devblksize		# device block size
	int	fm_optbufsize		# default file buffer size
	int	fm_maxbufsize		# maximum file buffer size
	int	fm_lsynctime		# time descriptor last updated on disk
	int	fm_dhmodified		# set if header needs to be updated

	int	fm_ftoff		# offset (su) of FT in datafile
	int	fm_ftlastnf		# file number of last lfile allocated
	struct	fte (*fm_ftable)[]	# file table storage

	int	fm_ptioff		# offset (su) of PTI in datafile
	int	fm_ptilen		# allocated length of PTI
	int	fm_ptinpti		# number of PTI entries in use
	int	fm_ptindex[]		# PTI storage

	int	fm_ptlen		# allocated length of page table array
	int	fm_ptnpte		# number of PTE's in use (#data pages)
	int	fm_ptlupte		# highest PTE updated on disk
	short	fm_ptable[]		# runtime page table array

	struct	lfcache *fm_lfcache;	# lfile cache descriptor
	int	fm_errcode		# error code of posted error
	char	fm_erropstr[]		# operand string of posted error
	char	fm_dfname[]		# datafile name, for error messages
}


3.1 Page Table

    During runtime access to the datafile, the page table is a vector mapping
each datafile page to an lfile.  Each page is allocated to a single lfile, and
lfile storage is allocated in units of pages.  As the datafile is extended by
writing to lfiles, elements are the in-core page table array.

When an lfile is first accessed, the in-core page table is scanned to find
those pages belonging to the lfile, building up a vector mapping offsets in
the lfile into datafile page numbers, i.e., to offsets in the physical
datafile.  As new pages are allocated to an lfile by writing at end of file,
both the lfile page vector and datafile page table are extended.

Assume the datafile page size is 512 bytes.  Since a PTE is 2 bytes, each PT
page holds 256 PTEs, representing 128 Kb of file space.  1 Mb of file space
(2048 pages) therefore requires 8 pages of page table space.  If we allocate
a default PT index of 256 slots, this gives us (for a 512 byte page) a 32 Mb
default maximum file size.

Only the PT index, stored in the datafile header, and the PT pages mapping
datafile page to lfile, are physically stored in the datafile.  The PT index
size is fixed.  The PT pages may be stored anywhere in the data pages and
are pointed to by the PT index.  The PT is stored as lfile zero.

This scheme is not intended for use with extremely large datafiles, or with
datafiles containing a very large number of lfiles.  A datafile of 32-256 Mb,
page size 512-4096, containing up to several hundred lfiles is the design
limit.  Of course, each datafile is a single host file, and there can be any
number of datafiles.


3.2 File Table

    The file table (FT) describes each lfile in the datafile.  Each lfile
has an entry in the file table, regardless of whether the lfile has ever been
accessed or contains any data.	As stored in the datafile, the FT is an array
of file table entries (FTEs) containing two longwords of data each, i.e.,

	FTE.1:	file size, bytes
	FTE.2:	flag bits (text, deleted, etc.)

Additional information must be maintained while an lfile is being accessed
at runtime.  The full runtime FTE is as follows.

	struct fte {
		struct	fmdes *lf_fm	# backpointer to FMIO descriptor
		int	lf_fsize	# file size, bytes
		int	lf_flags	# flag bits
		int	lf_status	# runtime i/o status (byte count)
		int	lf_ltsize	# logical byte size of last transfer
		int	lf_npages	# npages in lfile (pagemap size)
		int	*lf_pagemap	# pagemap array for lfile
		int	lf_pmlen	# pagemap array length (allocated)
	}

flag bits:
	
	LF_DELETED		set if the lfile is deleted
	LF_TEXTFILE		set if the lfile data is byte-packed text
	LF_IOINPROGRESS		set when i/o transfer is in progress

Deleting an lfile merely causes the FT_DELETED bit to be set; the actual
data will be lost only if the lfile is reused or explicitly overwritten,
or in a copy or rebuild operation.  Lfile space, once allocated, is never
freed, i.e., new pages are always allocated at the end of the datafile,
but lfile space can be *reused* by opening the lfile NEW_FILE and writing
into it.

Space for all lfile descriptors is preallocated in the FTE array at datafile
open time.  When an lfile is first accessed the pagemap for that lfile is
filled in; subsequent accesses to the lfile (lfile opens) while the datafile
remains open require very little overhead, since the lfile descriptor is
accessible via a vectored array reference, and will already have been activated.


4. EXAMPLE

    The following dialogue is from the debug tasks in ZZDEBUG.  A datafile Q
containing four textfiles has been created, and we print out the contents of
this with SHOW.  Next we copy the datafile to Q, and "show" that.  Note that
the page table file is moved to the beginning of the data pages area (which
will avoid an extra disk access during the datafile open), and all lfiles
have been rendered contiguous (lfile 5 was not stored in two segments in the
original datafile).

> ?
    create   wfile    pfile    show     copy     rebuild  
> 
> show
datafile: q
FMIO V1.1: datafile=q, pagesize=512, nlfiles=128
nlfinuse=5, nlfdeleted=0, nlffree=123, ftoff=13, ftlastnf=0
headersize=2560, filesize=20992, freespace=1408 bytes (6%)
fm=15AE9X, chan=4, mode=2, time since last sync=1 seconds
datastart=2561, devblksize=512, optbufsize=2048, maxbufsize=0
ptioff=271, ptilen=256, npti=1, ptlen=512, npte=36, lupte=36
====================== file table =======================
    0 size=72 [page table]
    1 size=1114 textfile
    2 size=7037 textfile
    5 size=4422 textfile
    6 size=4379 textfile
=================== page table index ====================
    4
====================== page table =======================
    1    1    1    0    2    2    2    2    2    2    2    2    2    2    2
    2    2    2    5    5    6    6    6    6    6    6    6    6    6    5
    5    5    5    5    5    5
> 
> copy
source: q
destination: p
> 
> show
datafile: p
FMIO V1.1: datafile=p, pagesize=512, nlfiles=128
nlfinuse=5, nlfdeleted=0, nlffree=123, ftoff=13, ftlastnf=0
headersize=2560, filesize=20992, freespace=1408 bytes (6%)
fm=15AE9X, chan=4, mode=2, time since last sync=0 seconds
datastart=2561, devblksize=512, optbufsize=2048, maxbufsize=0
ptioff=271, ptilen=256, npti=1, ptlen=512, npte=36, lupte=36
====================== file table =======================
    0 size=72 [page table]
    1 size=1114 textfile
    2 size=7037 textfile
    5 size=4422 textfile
    6 size=4379 textfile
=================== page table index ====================
    1
====================== page table =======================
    0    1    1    1    2    2    2    2    2    2    2    2    2    2    2
    2    2    2    5    5    5    5    5    5    5    5    5    6    6    6
    6    6    6    6    6    6
> 

# GTY -- This directory contains the generalized termcap style database
# reader.  Adapted from iraf$sys/tty/.

		  gty = gtyopen (termcap_file, device, ufields)
		       gtyclose (gty)
		   cp = gtycaps (gty)
	     pval = gtyget[bir] (gty, cap)
	       nchars = gtygets (gty, cap, outstr, maxch)

QPOE -- Prototype POE (Position Ordered Event file) Interface.
See QPOE.hlp for detailed information.
-----------------------------------------------------------------


1. QPOE (General QPOE file access)

		    [ --- external routines --- ]

	       qp_parse (expr, poefile, sz_poefile, paramex, sz_paramex)
     yes|no = qp_access (poefile, mode)
	        qp_copy (o_poefile, n_poefile)
	      qp_rename (o_poefile, n_poefile)
	     qp_rebuild (poefile)
	      qp_delete (poefile)

	  ptr = qp_open (poefile, mode, o_qp)
	     qp_set[ir] (qp, param, value)
      val = qp_stat[ir] (qp, param)
	       qp_debug (qp, out, what)
		qp_sync (qp)
	       qp_close (qp)

       qp_add[bcsilrdx] (qp, param, value, comment)
		qp_astr (qp, param, value, comment)
 val = qp_get[bcsilrdx] (qp, param)
       nchars = qp_gstr (qp, param, outstr, maxch)
       qp_put[bcsilrdx] (qp, param, value)
	        qp_pstr (qp, param, strval)

	    n = qp_read (qp, param, buf, maxelem, first, datatype)
	       qp_write (qp, param, buf, nelem, first, datatype)
          fd = qp_popen (qp, param, mode, type)
	mw = qp_loadwcs (qp)
	     qp_savewcs (qp, mw)

    yes|no = qp_accessf (qp, param)
	     qp_deletef (qp, param)
	     qp_renamef (qp, param, newname)
	       qp_copyf (o_qp, o_param, n_qp, n_param)
	        qp_addf (qp, param, datatype, maxelem, comment, flags)
      nelem = qp_queryf (qp, param, datatype, maxelem, comment, flags)
        nelem = qp_lenf (qp, param)
 nchars = qp_expandtext (qp, s1, s2, maxch)

      ptr = qp_ofnl[su] (qp, template)
	  ptr = qp_ofnl (qp, template, sort)
	n|EOF = qp_gnfn (fl, outstr, maxch)
	len = qp_lenfnl (fl)
	     qp_seekfnl (fl, pos)
		qp_cfnl (fl)

		    [ --- internal routines --- ]

		qp_bind (qp)
       dtype = qp_dtype (qp, datatype, dsym)
nchars = qp_elementsize (qp, datatype)
     nchars = qp_sizeof (qp, dtype, dsym)
	     qp_mkfname (poefile, extn, fname, maxch)
	 ival = qp_ctoi (str, ip, ival)
	 dval = qp_ctod (str, ip, dval)

	 ptr = qp_gmsym (qp, macro, textp)
	 ptr = qp_gpsym (qp, param)
   nfields = qp_parsefl (qp, fieldlist, dd)
	     qp_inherit (n_qp, o_qp, out)
    dtype = qp_getparam (qp, param, o_pp)
    dtype = qp_putparam (qp, param, o_pp)
	    qp_flushpar (qp)

       gt = qp_opentext (qp, text)			# token i/o
     token = qp_nexttok (gt)
      token = qp_gettok (gt, tokbuf, maxch)
      token = qp_rawtok (gt, outstr, maxch)
     nargs = qp_arglist (gt, argbuf, maxch)
	   qp_closetext (gt)

	ptr = qm_access ()				# macros
	   ch = qm_getc (fd, ch)
		qm_scan (qm, fname, flags)
	       qm_scano (qm, fd, flags)
   qm_[set|upd]defaults (qm, qp)
	    qm_setparam (qm, param, valstr)
	ptr = qm_symtab (qm)


2. QPIO (Event I/O)

		    [ --- external routines --- ]

         io = qpio_open (qp, paramex, mode)
	     qpio_close (io)

	  qpio_setrange (io, vs, ve, ndim)
   ndim = qpio_getrange (io, vs, ve, maxdim)
	 qpio_setfilter (io, expr)
nchars = qpio_getfilter (io, outstr, maxch)
	   qpio_set[ir] (io, param, value)
    val = qpio_stat[ir] (io, param)
      mw = qpio_loadwcs (io)
	   qpio_mkindex (io, key)

	 qpio_putevents (io, i_ev, nevents)
 n|EOF = qpio_getevents (io, o_ev, maskval, maxev, nev)
 nev = qpio_readpix[si] (io, obuf, vs, ve, ndim, xblock, yblock)

		    [ --- internal routines --- ]

    ok|err = qpio_parse (io, expr, filter, sz_filter, mask, sz_mask)
	  qpio_loadmask (io, mask, mergeflg)
bkno|EOF = qpio_rbucket (io, bkno)
	   qpio_wbucket (io, n_bkno)
	      qpio_sync (io)


3. QPEX (Event Attribute Filtering)

		    [ --- external routines --- ]

	 ex = qpex_open (qp, expr)
ok|err = qpex_modfilter (ex, exprlist)
nchars = qpex_getfilter (ex, outstr, maxch)
 nc = qpex_getattribute (ex, attribute, outstr, maxch)
   nr = qpex_attrl[ird] (ex, attribute, xs, xe, xlen)
    nev = qpex_evaluate (ex, i_ev, o_ev, nev)
	     qpex_close (ex)

		    [ --- internal routines --- ]

    v = qpex_parse[dir] (expr, xs, xe, xlen)
  v = qpex_sublist[dir] (x1, x2, xs,xe,nranges,ip, o_xs,o_xe)
  v = qpex_codegen[dir] (ex, atname, assignop, expr, offset, dtype)
	    qpex_delete (ex, offset, dtype)

       ptr = qpex_pbpos (ex)
     offset = qpex_refd (ex, value)
     ptr = qpex_dballoc (ex, nelem, dtype)
      ptr = qpex_dbpstr (ex, strval)
	     qpex_pbpin (ex, opcode, arg1, arg2, arg3)
	      qpex_mark (ex, pb_save, db_save)
	      qpex_free (ex, pb_save, db_save)

   nr = qp_rlmerge[dir] (os,oe,olen, xs,xe,nx, ys,ye,ny)


4. INTERFACE SYNTAX

Default parameter and domain names:

	"deffilt"	# default event filter (all event lists)
	"defmask"	# default region mask (all event lists)
	"deffilt.<evl>"	# default event filter for event list <evl>
	"defmask.<evl>"	# default region mask for event list <evl>
	"event"		# default name of user event datatype
	"events"	# default event-list parameter

QPIO expression syntax:

	[ evl-param ][ `[' [`!'] keyword [(`:='|`='|`+=') expr], ...`]' ]

where <evl-param> defaults to "events" if not given, and where <keyword> may
be any of the following, or a term of an event attribute expression.

	block		# blocking factor for image matrix
	debug		# debug level (integer, 0=nodebug)
	filter		# event attribute filter (expression)
	key		# event key (Y,X) fields (e.g.(s10,s8))
	noindex		# don't use index even if present
	param		# name of event list header parameter
	mask		# region mask
	rect		# subregion of image, e.g, rect=[*,100:400]

Any unrecognized keyword=expr terms are passed on to the event attribute
filter, hence the "filter=(expr)" syntax is optional.

QPEX expression syntax (the <expr> in "filter=<expr>" above):

	'(' attribute=expr [, attribute=expr...] ')'

where <attribute> is the "physical" name (type code plus byte offset) of
a field of the event structure, and expr is

	%N		bitwise mask test
	!%N		negated bitwise mask test

or some combination of

	N		equality test
	:N		open range (less than or equal to N)
	N:		open range (greater than or equal to N)
	M:N		range (M to N inclusive)
	expr,expr,...	list of values or ranges
	'(' expr ')'	parenthesized expr
	'!' expr	

MACRO syntax:

	macro		replace <macro> by defined value
	macro(arg,...)	replace <macro> with argument substitution
	@file		replace <@file> by contents of file
	`cmd`		replace <`cmd`> by output of the CL command "cmd",
			  replacing all newlines by spaces
	@file(arg,...)	file pushback with argument substitution
	`cmd`(arg,...)	command output pushback with argument substitution

Macro define syntax:

	define macro replacement-text
	set parameter value

where <macro> is any identifier, and <replacement-text> is literal text to
be pushed back into the input and rescanned when <macro> is encountered in
the input stream.  <replacement-text> may contain symbols of the form '$N'
denoting places where argument substitution is to be performed during pushback.
The special builtin macro $DFN will be replaced by the datafile name, returned
as a string token.

<parameter> denotes a QPOE interface parameter the value of which is to be
set, e.g., to set the size of a buffer to be created at run time.  The
following interface parameters are defined:

	"bucketlen"	QPIO bucket length, nevents
	"cachesize"	number of file descriptors in lfile cache
	"indexlen"	number of hash entries in symbol table index
	"maxlfiles"	maximum number of lfiles in datafile
	"pagesize"	page size, bytes, of datafile
	"sbufsize"	initial symbol table size, su
	"stablen"	initial symbol table string buffer size, chars
	"progbuflen"	QPEX program buffer size (compiled instructions)
	"databuflen"	QPEX data buffer size (initialized data space)
	"nodeffilt"	disable the use of any default event filters
	"nodefmask"	disable the use of any default region masks
	"maxpushback"	max characters pushback (for macro expansion)
	"maxfrlutlen"	max full resolution lookup table length
	"maxrrlutlen"	max reduced resolution lookup table length
	"lutminranges"	min ranges required before a lookup table is used
	"lutscale"	scale factor to convert nranges to n LUT bins
	"blockfactor"	QPIO blocking factor for output pixel arrays
	"optbufsize"	FIO i/o buffer size for IMIO access to QPOE file, chars
	"debuglevel"	debug level, 0 for no runtime debug messages

Environment:

	'qmfiles'	an environment variable listing a set of macro
			define files defining the global macros to be
			used by QPOE

	'qmsave'	an environment variable defining the name of a
			file to be used to store the compiled macros
			(defaults to uparm$qpoe.msv).


5. INTERFACE PARAMETERS

# QPSET.H -- User accessible definitions for the QPOE package.

define	SZ_COMMENT		79	# max size comment string
define	SZ_DATATYPE		79	# max size datatype name string

# QPOE Read-Write Parameters.
define	QPOE_BLOCKFACTOR	1	# blocking factor for pixel arrays
define	QPOE_BUCKETLEN		2	# event list bucket length, nevents
define	QPOE_CACHESIZE		3	# lfile (buffer) cache size, nlfiles
define	QPOE_DATABUFLEN		4	# QPEX data buffer length, chars
define	QPOE_DEBUGLEVEL		5	# debug level (0 = no messages)
define	QPOE_DEFLUTLEN		6	# default lookup table length (bins)
define	QPOE_INDEXLEN		7	# symbol table hash index length
define	QPOE_LUTMINRANGES	8	# min ranges before using LUT
define	QPOE_LUTSCALE		9	# scale nranges to LUT bins
define	QPOE_MAXFRLUTLEN	10	# max full-res LUT length
define	QPOE_MAXLFILES		11	# max lfiles in datafile
define	QPOE_MAXPUSHBACK	12	# max amount of pushed back macro data
define	QPOE_MAXRRLUTLEN	13	# max reduced-res LUT length
define	QPOE_OPTBUFSIZE		14	# optimum buffer size for IMIO/QPF/FIO
define	QPOE_PAGESIZE		15	# page size of datafile, bytes
define	QPOE_PROGBUFLEN		16	# QPEX program buffer length, ints
define	QPOE_SBUFSIZE		17	# symtab string buf size, chars (init)
define	QPOE_STABLEN		18	# symtab data area size, su (init)
define	QPOE_NODEFFILT		19	# disable use of default filter
define	QPOE_NODEFMASK		20	# disable use of default mask

# QPOE Read-Only Parameters.
define	QPOE_FM			21	# FMIO descriptor
define	QPOE_MODE		22	# poefile access mode
define	QPOE_ST			23	# SYMTAB symbol table descriptor
define	QPOE_VERSION		24	# QPOE version number

# Parameter flags (for qp_addf).
define	QPF_NONE		(-1)	# no flags (0 gives default flags)
define	QPF_INHERIT		0002B	# copy parameter in a NEW_COPY open


# QPIOSET.H -- QPIO User accessible interface parameters.

define	qpio_stati	qpiost		# (name collision with qpio_seti)

# Read-Write Parameters.
define	QPIO_BLOCKFACTOR	1	# blocking factor for image matrices
define	QPIO_BUCKETLEN		2	# event list bucket size, nevents
define	QPIO_DEBUG		3	# debug level, debug=0 for no messages
define	QPIO_EVXOFF		4	# short offset of X field of event
define	QPIO_EVYOFF		5	# short offset of Y field of event
define	QPIO_EX			6	# QPEX descriptor (event attr. filter)
define	QPIO_NODEFFILT		7	# disable use of default filter
define	QPIO_NODEFMASK		8	# disable use of default mask
define	QPIO_NOINDEX		9	# flag to disable use of index
define	QPIO_OPTBUFSIZE		10	# optimum buffer size for IMIO/QPF/FIO
define	QPIO_PL			11	# PLIO descriptor (pixel mask)

# Read-Only Parameters.
define	QPIO_EVENTLEN		12	# length of event struct, shorts
define	QPIO_FD			13	# file descriptor of event list lfile
define	QPIO_INDEXLEN		14	# event list index length (0=noindex)
define	QPIO_IXXOFF		15	# short offset of X field used in index
define	QPIO_IXYOFF		16	# short offset of Y field used in index
define	QPIO_LF			17	# lfile in which event list is stored
define	QPIO_MASKP		18	# char pointer to mask-name buffer
define	QPIO_MAXEVP		19	# pointer to MAX-event fields struct
define	QPIO_MINEVP		20	# pointer to MIN-event fields struct
define	QPIO_NCOLS		21	# number of columns in image
define	QPIO_NLINES		22	# number of lines in image
define	QPIO_PARAMP		23	# char pointer to param-name buffer
define	QPIO_QP			24	# backpointer to QPOE descriptor

CL -- This directory contains the sources for the IRAF command language (CL).
The command language is implemented as a C program upon the IRAF VOS, using an
interface called LIBC (the C runtime library).  LIBC is documented in the
source directory for the LIBC package, sys$libc.  LIBC provides a C language
binding for the IRAF VOS, plus an implementation of the UNIX "stdio" library. 

To compile the CL, the libraries comprising the IRAF VOS must first be compiled
and installed in lib$.  In addition the CL uses LIBC and two graphics
libraries, libstg.a (the STDGRAPH graphics kernel) and libcur.a (cursor mode,
for cursor type CL queries).  A number of global include files are also
required and will be found in host$hlib/libc.  The file <iraf.h> must be
installed in a public directory where it can be found by the C compiler on your
system. 

Given these libraries the CL may be compiled and linked simply by typing
"mkpkg" in this directory.  Typing "mkpkg update" will make the CL and
"install" the executable in the iraf$bin directory. 

MTIO -- Magtape i/o.  This directory contains the FIO device driver for the
magtape devices plus MTOPEN (used to open a magtape device and hook it to
FIO) plus a few other routines.  See ./doc for additional info.


USER ROUTINES

		yes|no = mtfile (fname)		# Is fname a magtape device?
	  yes|no = mtneedfileno (mtname)	# No file number given?
		    gty = mtcap (mtname)
			mtfname (mtname, file, outstr, maxch)

		        mtparse (mtname, device, fileno, recno, attrl, maxch)
		       mtencode (mtname, maxch, device, fileno, recno, attrl)

		    fd = mtopen (mtname, acmode, bufsize)
		       mtrewind (mtname, initcache)
		     mtposition (mtname, file, record)

	Use CLOSE to close a file descriptor opened with mtopen.
	Use GTYCLOSE to close a termcap descriptor opened with mtcap.
	MTNAME is the full magtape device specification, i.e, "mt[...]".



SYSTEM ROUTINES

		     mtallocate (mtname)
		   mtdeallocate (mtname, rewind_tape)
		       mtstatus (out, mtname)
		        mtclean (level, stale, out)



FIO DRIVER

			 zopnmt (iodev, acmode, mtchan)
			 zclsmt (mtchan, status)
			 zardmt (mtchan, buf, maxbytes, offset)
			 zawrmt (mtchan, buf, nbytes, offset)
			 zawtmt (mtchan, status)
			 zsttmt (mtchan, what, lvalue)


All other procedures are internal to the interface.

LIBC -- C language binding for a portion of the IRAF VOS
	UNIX emulator

This directory contains

    [1]	A subset of the routines from the UNIX stdio library.  These routines
	emulate the equivalent UNIX routines but are interfaced to the IRAF
	program interface.

    [2]	C-callable versions of a subset of the routines from the IRAF program
	interface.  Included are portions of the following packages:

		file i/o
		formatted i/o
		environment
		process control
		terminal control
		memory management
		exception handling

The header files "irafio.h" and "names.h" should be included in all C
files which reference the C library.  The include file "stdio.h"
should be used wherever they would be used in a UNIX/C system.


1. LIBC Emulation of UNIX C-Library Procedures

                   syntax                              err       eof

       double = atof (str)                              0.
          int = atoi (str)                              0
         long = atol (str)                              0
      charp = calloc (nelems, elsize)                  NULL
            clearerr (fp)
              fclose (fp)                              EOF
       FILE = fdopen (fd, modestr)                     NULL
         bool = feof (fp)
       bool = ferror (fp)
              fflush (fp)                              EOF
          ch = fgetc (fp)                              EOF
       charp = fgets (buf, maxch, fp)                  NULL
         fd = fileno (fp)
        FILE = fopen (fname, modestr)                  NULL
               fputc (ch, fp)                          EOF
               fputs (str, fp)
       nelem = fread (bp, szelem, nelem, fp)            0         0
                free (buf)
      FILE = freopen (fname, modestr, fp)              NULL
               fseek (fp, offset, origin)              EOF
        long = ftell (fp)
      nelem = fwrite (bp, szelem, nelem, fp)            0         0
           ch = getc (fp)                              EOF       EOF
        ch = getchar ()                                EOF       EOF
      charp = getenv (envvar)                          NULL
        charp = gets (buf)                             NULL      NULL
         word = getw (fp)                              EOF       EOF
      charp = malloc (nbytes)                          NULL
      charp = mktemp (template)                        NULL
              perror (prefix)
              printf (format, argp)
             fprintf (fp, format, argp)
             sprintf (str, format, argp)
             eprintf (format, argp)
           ch = putc (ch, fp)                          EOF
        ch = putchar (ch)                              EOF
                puts (str)
         word = putw (word, fp)                        EOF
     charp = realloc (buf, newsize)                    NULL
              rewind (fp)                              EOF
       nscan = scanf (format, argp)                    EOF       EOF
      nscan = fscanf (fp, format, argp)                EOF       EOF
      nscan = sscanf (str, format, argp)               EOF       EOF
              setbuf (fp, buf)
           setbuffer (fp, buf, size)
          setlinebuf (fp)
       stat = system (cmd)
         ch = ungetc (ch, fp)                          EOF



2. System Calls

All output parameters are shown as "&name" regardless of whether the actual
parameter is a pointer.  If no ERR or EOF type is shown it is inapplicable to
the procedure.  The error type "*" denotes an error action which will lead to
error recovery if not caught by calling the procedure inside an "iferr".  In
general, error actions are permitted only where errors are not expected and
where we suspect that the programmer would ignore an error return code if one
were used.  Fatal errors cannot be caught but "cannot happen".


                         syntax                         err        eof

       bool = c_access (fname, mode, type)               *
   longsec = c_clktime (reftime)
               c_close (fd)                              *
     charp = c_cnvdate (clktime, &outstr, maxch)
     charp = c_cnvtime (clktime, &outstr, maxch)
  longmsec = c_cputime (reftime)
              c_delete (fname)                          ERR
    nchars = c_envfind (var, &outstr, maxch)             0
    nchars = c_envgets (var, &outstr, maxch)             0
      bool = c_envgetb (var)                           no=0
      ival = c_envgeti (var)                             *
             c_envputs (var, value)                      *
             c_envlist (fd, prefix, show_redefs)         *
             c_envmark (&envp)
   nredefs = c_envfree (envp)
     nscan = c_envscan (input_source)                    *
               c_error (errcode, errmsg)                 *
              c_erract (action)                          *
    errcode = c_errget (&outstr, maxch)
              c_fchdir (newdir)                         ERR
         ch = c_filbuf (fp)                             EOF        EOF
               c_finfo (fname, fi)                      ERR
         ch = c_flsbuf (ch, fp)                         EOF
               c_flush (fd)                              *
     nchars = c_fmapfn (vfn, &osfn, maxch)               0
       stat = c_fmkdir (newdir)				ERR
     nchars = c_fnldir (vfn, &ldir, maxch)
     nchars = c_fnroot (vfn, &root, maxch)
     nchars = c_fnextn (vfn, &extn, maxch)
      nchars = c_fpath (vfn, &osfn, maxch)		 0
         fd = c_fredir (fd, fname, mode, type)          ERR
               c_fseti (fd, param, value)                *
       ival = c_fstati (fd, param)                       *
        int = c_getpid ()
              c_getuid (&outstr, maxch)                  *
 os_chan = c_kimapchan (ki_chan, nodename, maxch)
      token = c_lexnum (str, &toklen)
     nchars = c_mktemp (root, &temp_filename, maxch)     0
         long = c_note (fd)                              *
           fd = c_open (fname, mode, type)              ERR
   exit_stat = c_oscmd (cmd, infile, outfile, errfile)   *
	     c_prchdir (pid, newdir)			ERR
 exit_stat = c_prcldpr (job)                             *
             c_prclose (pid)                             *
       bool = c_prdone (job)                             *
	    c_prenvset (pid, envvar, valuestr)		ERR
              c_prkill (job)                            ERR
       pid = c_propdpr (process, bkgfile)               NULL
        pid = c_propen (process, &in, &out)             NULL
             c_prredir (pid, stream, new_fd)            ERR
            c_prsignal (pid, signal)                    ERR
       nbytes = c_read (fd, &buf, maxbytes)              *         EOF
              c_rename (old_fname, new_fname)           ERR
      charp = c_salloc (nbytes)                        fatal
               c_smark (&sp)                           fatal
               c_sfree (sp)                            fatal
       bool = c_stkcmp (p1, p2)                          *
                c_seek (fd, offset)                     ERR
     xcharp = c_sppstr (xstr)
       cstr = c_strpak (sppstr, &cstr, maxch)
     xcharp = c_strupk (str, &xoutstr, maxch)
              c_tsleep (nseconds)
  tty(int) = c_ttyodes (ttyname)                        ERR
             c_ttycdes (tty)                             *
             c_ttyseti (tty, param, value)               *
     ival = c_ttystati (tty, param)                      *
      bool = c_ttygetb (tty, cap)                      no=0
      ival = c_ttygeti (tty, cap)                        0
      fval = c_ttygetr (tty, cap)                        0.
    nchars = c_ttygets (tty, cap, &outstr, maxch)        0
             c_ttyputs (fd, tty, cap, afflncnt)         ERR
             c_ttyctrl (fd, tty, cap, afflncnt)         ERR
            c_ttyclear (fd, tty)                         *
          c_ttyclearln (fd, tty)                         *
             c_ttygoto (fd, tty, col, line)              *
             c_ttyinit (fd, tty)                         *
          c_ttyputline (fd, tty, line, map_cc)           *
               c_ttyso (fd, tty, onoff)                  *
              c_ungetc (fd, ch)                         ERR
           c_ungetline (fd, str)                        ERR
              c_vfnbrk (vfn, root, extn)
      nbytes = c_write (fd, buf, nbytes)                 *
               c_xwhen (vex, new_handler, old_handler)   *
               c_xgmes (oscode, oserrmsg, maxch)

The PROTO package provides a place in the system where users can put their
programs for others to conveniently use, without modifying the IRAF system
itself (see also LOCAL).  A program or package must meet a strict set of
standards to be installed in the IRAF system as a fully supported program;
PROTO provides a way for users to get software into the system without having
to meet the mainline IRAF standards.  Programs or packages installed in PROTO
are automatically candidates for eventual migration into the main system.
Tasks installed in PROTO are generally expected to go away after a while.

Only portable IRAF software should be installed in the PROTO package.
Nonportable programs should be placed in LOCAL and will not be exported with
the system.

ZFIOGD -- FIO device driver for binary graphics devices.
	  Note: this code is part of library LIBSYS.

The purpose of this driver is to provide a low level i/o interface to the
interactive binary graphics devices supported on a particular system.  This
includes devices such as image displays and bit mapped vector graphics devices
(e.g., the Versatec plotters).  The ZFIOGD driver is not intended for graphics
devices with a text interface, e.g., the Tektronix compatible graphics
terminals.  A third interface, i.e., the ZFIOPL driver, is used for devices
accessed via the NCAR system plot package.

By using a ZFIO level driver to talk to the binary graphics devices we can
isolate the system dependencies of the interface to a small amount of code.
We gain the ability to access the device over the network, since the kernel
server can be used once the i/o interface to the device is part of the kernel.

The ZFIOGD driver is implemented in LIBSYS rather than LIBOS since the
interface code, while system dependent, is generally written at least partially
in SPP to access header files shared with the GIO graphics kernel for the
device, as well as to gain access to the LIBSYS library functions for ease
of coding.  ZFIOGD is used only by the graphics kernels hence is not needed
to bootstrap the system; it is added to LIBSYS after the system is up and
running.

The code is made as follows:

    [1]	In a bootstrap, the commands in the mkpkg.csh file are executed by
	the root mkpkg.csh file in host$.

    [2] In a sysgen, the mkpkg file in this directory is called by an entry
	in sys$mkpkg to to update the libsys.a library.


ARCHITECTURE

    The single FIO device driver ZFIOGD is used to access all binary graphics
devices.  This simplifies the KI and VOS interfaces and maximally isolates
knowledge of the devices supported on a particular system.  New devices can
be added to ZFIOGD without any changes to the kernel interface or the VOS.
When a device is opened via the ZFIOGD driver the name of the device is
specified as follows:
	
	node!device:hostdevname
e.g.,
	lyra!iis,/dev/iis
	vela!iis,iia0

where
	device		identifies the bottom level driver to be used

	hostdevname	is the host system name for the particular
			    device to be accessed (there may be
			    multiple copies of a device on a single
			    system)

The task of ZOPNGD is to look up device name in an internal table and call
the appropriate lower level device open procedure to physically open the
device.  If the device resides on a remote node the kernel interface will
have have spawned a remote kernel server which will call ZOPNGD on the host
which actually owns the device.


                                 ZFIOGD
                                                                   
                                                                   
               iism7X   deanza    peritek   versatec    (etc.)


The ZFIOGD interface is a data driven interface, i.e., all control and status
readback functions are performed by ZARDGD and ZAWRGD calls to read and write
binary packets of data.  This is ideal for a device such as the IIS which is
also data driven, but is less convenient for devices which have a control
type interface (in a control type interface, a subroutine is called to do
something to the device, rather than writing to the device).  Even when the
device is control driven at the host system level, a data driven interface is
desirable to isolate the system dependence of the OS device driver, as well
as to provide network access.


PROTOCOLS

    When building a ZFIOGD sub-driver for a control driven device, it is
suggested that a control packet be defined for the device which is capable
of encoding all control functions.  The high level code (GIO graphics device
driver) will encode control functions in this packet (which should have a
machine independent external representation), and send it along via ZAWRGD
to the sub-kernel, which will decode the packet and poke the host system device
driver as necessary to perform the indicated function.

There is no predefined protocol for encoding control packets for binary
graphics devices.  Conceivably such an interface could be defined, but our
goal with the ZFIOGD interface is to isolate the host system dependence of
the interface and provide network access capabilities; we are NOT trying to
address the problems of device independence in this interface.  That is the
function of the GIO device driver, which should be machine independent and
portable, but addresses the problems of providing a device independent
interface.

A control packet and communications protocol should therefore be defined
separately for each device.  One possibility is to use the OFFSET argument
in the ZAWRGD call as a function code, rather than placing the function code
in a generic packet header.  This is possible since the OFFSET argument is not
used for streaming devices.  The only disadvantage to using the OFFSET field
in this way is that doing so would prevent use of FIO to buffer i/o to the
device, since FIO always sets OFFSET to zero when calling ZAWRGD for a
streaming device.  The alternative is the generic packet approach, wherein
each i/o or control operation is preceded by a packet defining the operation
to be performed (this can simplify the interface, since a single set of
subroutines can be used to encode/transmit and receive/decode packet headers).
Yet another possibilty is to combine the two approaches, using a generic
packet header for most operations, but a special "offset" or function code
for special operations such as master clear or device reset (as well as to
reset the communications protocol).  

See the send/receive procedures in the KI (kernel interface) for an example
of how to encode packets in a machine independent form for transmission over
the network.


ADDING NEW DEVICES

    To add a new device to ZFIOGD, create a subdirectory with the name of the
device and implement the six driver subroutines therein.  Add an entry to the
mkpkg to compile the new subdirectory.  Add a new entry to the device table
and to each switch-case statement in zfiogd.x.  Relink all affected graphics
executables, and relink the kernel server executable.

This directory contains notes on the various IRAF ports.  Most of these
files do not contain an up-to-date record of the current ports, but rather
these are historical notes taken during each port.  The name of the host
operating system is contained in each filename, while most files contain
the relevant dates of ports or upgrades inside them.  Some of this material
may be of use to persons contemplating future ports.

Conventions:

    aos		AOSVS  (Data General MV/10000)
    ctio	Cerro Tololo Interamerican Observatory
    isi		Integrated Systems; Jupiter workstation at IPAC
    nso		National Solar Observatory
    st		Space Telescope Science Institute
    sun		Sun Microsystems
    sun2	SUN-2 hardware, SUN V2.0
    sun3	SUN-3 hardware, SUN V3.0
    v22		IRAF V2.2 (etc.)

Where different files would otherwise have the same name, they are
distinguished by the date of the last modification to the system that
was part of the original "notes" file.  For example, "sun3_062486.doc"
is the "notes" file as it existed on a Sun-3 on June 24, 1986.

                      FFTPACK

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

                  version 4  april 1985

     a package of fortran subprograms for the fast fourier
      transform of periodic and other symmetric sequences

                         by

                  paul n swarztrauber

  national center for atmospheric research  boulder,colorado 80307

   which is sponsored by the national science foundation

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


this package consists of programs which perform fast fourier
transforms for both complex and real periodic sequences and
certain other symmetric sequences that are listed below.

1.   rffti     initialize  rfftf and rfftb
2.   rfftf     forward transform of a real periodic sequence
3.   rfftb     backward transform of a real coefficient array

4.   ezffti    initialize ezfftf and ezfftb
5.   ezfftf    a simplified real periodic forward transform
6.   ezfftb    a simplified real periodic backward transform

7.   sinti     initialize sint
8.   sint      sine transform of a real odd sequence

9.   costi     initialize cost
10.  cost      cosine transform of a real even sequence

11.  sinqi     initialize sinqf and sinqb
12.  sinqf     forward sine transform with odd wave numbers
13.  sinqb     unnormalized inverse of sinqf

14.  cosqi     initialize cosqf and cosqb
15.  cosqf     forward cosine transform with odd wave numbers
16.  cosqb     unnormalized inverse of cosqf

17.  cffti     initialize cfftf and cfftb
18.  cfftf     forward transform of a complex periodic sequence
19.  cfftb     unnormalized inverse of cfftf


******************************************************************

subroutine rffti(n,wsave)

  ****************************************************************

subroutine rffti initializes the array wsave which is used in
both rfftf and rfftb. the prime factorization of n together with
a tabulation of the trigonometric functions are computed and
stored in wsave.

input parameter

n       the length of the sequence to be transformed.

output parameter

wsave   a work array which must be dimensioned at least 2*n+15.
        the same work array can be used for both rfftf and rfftb
        as long as n remains unchanged. different wsave arrays
        are required for different values of n. the contents of
        wsave must not be changed between calls of rfftf or rfftb.

******************************************************************

subroutine rfftf(n,r,wsave)

******************************************************************

subroutine rfftf computes the fourier coefficients of a real
perodic sequence (fourier analysis). the transform is defined
below at output parameter r.

input parameters

n       the length of the array r to be transformed.  the method
        is most efficient when n is a product of small primes.
        n may change so long as different work arrays are provided

r       a real array of length n which contains the sequence
        to be transformed

wsave   a work array which must be dimensioned at least 2*n+15.
        in the program that calls rfftf. the wsave array must be
        initialized by calling subroutine rffti(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.
        the same wsave array can be used by rfftf and rfftb.


output parameters

r       r(1) = the sum from i=1 to i=n of r(i)

        if n is even set l =n/2   , if n is odd set l = (n+1)/2

          then for k = 2,...,l

             r(2*k-2) = the sum from i = 1 to i = n of

                  r(i)*cos((k-1)*(i-1)*2*pi/n)

             r(2*k-1) = the sum from i = 1 to i = n of

                 -r(i)*sin((k-1)*(i-1)*2*pi/n)

        if n is even

             r(n) = the sum from i = 1 to i = n of

                  (-1)**(i-1)*r(i)

 *****  note
             this transform is unnormalized since a call of rfftf
             followed by a call of rfftb will multiply the input
             sequence by n.

wsave   contains results which must not be destroyed between
        calls of rfftf or rfftb.


******************************************************************

subroutine rfftb(n,r,wsave)

******************************************************************

subroutine rfftb computes the real perodic sequence from its
fourier coefficients (fourier synthesis). the transform is defined
below at output parameter r.

input parameters

n       the length of the array r to be transformed.  the method
        is most efficient when n is a product of small primes.
        n may change so long as different work arrays are provided

r       a real array of length n which contains the sequence
        to be transformed

wsave   a work array which must be dimensioned at least 2*n+15.
        in the program that calls rfftb. the wsave array must be
        initialized by calling subroutine rffti(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.
        the same wsave array can be used by rfftf and rfftb.


output parameters

r       for n even and for i = 1,...,n

             r(i) = r(1)+(-1)**(i-1)*r(n)

                  plus the sum from k=2 to k=n/2 of

                   2.*r(2*k-2)*cos((k-1)*(i-1)*2*pi/n)

                  -2.*r(2*k-1)*sin((k-1)*(i-1)*2*pi/n)

        for n odd and for i = 1,...,n

             r(i) = r(1) plus the sum from k=2 to k=(n+1)/2 of

                  2.*r(2*k-2)*cos((k-1)*(i-1)*2*pi/n)

                 -2.*r(2*k-1)*sin((k-1)*(i-1)*2*pi/n)

 *****  note
             this transform is unnormalized since a call of rfftf
             followed by a call of rfftb will multiply the input
             sequence by n.

wsave   contains results which must not be destroyed between
        calls of rfftb or rfftf.


******************************************************************

subroutine ezffti(n,wsave)

******************************************************************

subroutine ezffti initializes the array wsave which is used in
both ezfftf and ezfftb. the prime factorization of n together with
a tabulation of the trigonometric functions are computed and
stored in wsave.

input parameter

n       the length of the sequence to be transformed.

output parameter

wsave   a work array which must be dimensioned at least 3*n+15.
        the same work array can be used for both ezfftf and ezfftb
        as long as n remains unchanged. different wsave arrays
        are required for different values of n.


******************************************************************

subroutine ezfftf(n,r,azero,a,b,wsave)

******************************************************************

subroutine ezfftf computes the fourier coefficients of a real
perodic sequence (fourier analysis). the transform is defined
below at output parameters azero,a and b. ezfftf is a simplified
but slower version of rfftf.

input parameters

n       the length of the array r to be transformed.  the method
        is must efficient when n is the product of small primes.

r       a real array of length n which contains the sequence
        to be transformed. r is not destroyed.


wsave   a work array which must be dimensioned at least 3*n+15.
        in the program that calls ezfftf. the wsave array must be
        initialized by calling subroutine ezffti(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.
        the same wsave array can be used by ezfftf and ezfftb.

output parameters

azero   the sum from i=1 to i=n of r(i)/n

a,b     for n even b(n/2)=0. and a(n/2) is the sum from i=1 to
        i=n of (-1)**(i-1)*r(i)/n

        for n even define kmax=n/2-1
        for n odd  define kmax=(n-1)/2

        then for  k=1,...,kmax

             a(k) equals the sum from i=1 to i=n of

                  2./n*r(i)*cos(k*(i-1)*2*pi/n)

             b(k) equals the sum from i=1 to i=n of

                  2./n*r(i)*sin(k*(i-1)*2*pi/n)


******************************************************************

subroutine ezfftb(n,r,azero,a,b,wsave)

******************************************************************

subroutine ezfftb computes a real perodic sequence from its
fourier coefficients (fourier synthesis). the transform is
defined below at output parameter r. ezfftb is a simplified
but slower version of rfftb.

input parameters

n       the length of the output array r.  the method is most
        efficient when n is the product of small primes.

azero   the constant fourier coefficient

a,b     arrays which contain the remaining fourier coefficients
        these arrays are not destroyed.

        the length of these arrays depends on whether n is even or
        odd.

        if n is even n/2    locations are required
        if n is odd (n-1)/2 locations are required

wsave   a work array which must be dimensioned at least 3*n+15.
        in the program that calls ezfftb. the wsave array must be
        initialized by calling subroutine ezffti(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.
        the same wsave array can be used by ezfftf and ezfftb.


output parameters

r       if n is even define kmax=n/2
        if n is odd  define kmax=(n-1)/2

        then for i=1,...,n

             r(i)=azero plus the sum from k=1 to k=kmax of

             a(k)*cos(k*(i-1)*2*pi/n)+b(k)*sin(k*(i-1)*2*pi/n)

********************* complex notation **************************

        for j=1,...,n

        r(j) equals the sum from k=-kmax to k=kmax of

             c(k)*exp(i*k*(j-1)*2*pi/n)

        where

             c(k) = .5*cmplx(a(k),-b(k))   for k=1,...,kmax

             c(-k) = conjg(c(k))

             c(0) = azero

                  and i=sqrt(-1)

*************** amplitude - phase notation ***********************

        for i=1,...,n

        r(i) equals azero plus the sum from k=1 to k=kmax of

             alpha(k)*cos(k*(i-1)*2*pi/n+beta(k))

        where

             alpha(k) = sqrt(a(k)*a(k)+b(k)*b(k))

             cos(beta(k))=a(k)/alpha(k)

             sin(beta(k))=-b(k)/alpha(k)

******************************************************************

subroutine sinti(n,wsave)

******************************************************************

subroutine sinti initializes the array wsave which is used in
subroutine sint. the prime factorization of n together with
a tabulation of the trigonometric functions are computed and
stored in wsave.

input parameter

n       the length of the sequence to be transformed.  the method
        is most efficient when n+1 is a product of small primes.

output parameter

wsave   a work array with at least int(2.5*n+15) locations.
        different wsave arrays are required for different values
        of n. the contents of wsave must not be changed between
        calls of sint.

******************************************************************

subroutine sint(n,x,wsave)

******************************************************************

subroutine sint computes the discrete fourier sine transform
of an odd sequence x(i). the transform is defined below at
output parameter x.

sint is the unnormalized inverse of itself since a call of sint
followed by another call of sint will multiply the input sequence
x by 2*(n+1).

the array wsave which is used by subroutine sint must be
initialized by calling subroutine sinti(n,wsave).

input parameters

n       the length of the sequence to be transformed.  the method
        is most efficient when n+1 is the product of small primes.

x       an array which contains the sequence to be transformed


wsave   a work array with dimension at least int(2.5*n+15)
        in the program that calls sint. the wsave array must be
        initialized by calling subroutine sinti(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.

output parameters

x       for i=1,...,n

             x(i)= the sum from k=1 to k=n

                  2*x(k)*sin(k*i*pi/(n+1))

             a call of sint followed by another call of
             sint will multiply the sequence x by 2*(n+1).
             hence sint is the unnormalized inverse
             of itself.

wsave   contains initialization calculations which must not be
        destroyed between calls of sint.

******************************************************************

subroutine costi(n,wsave)

******************************************************************

subroutine costi initializes the array wsave which is used in
subroutine cost. the prime factorization of n together with
a tabulation of the trigonometric functions are computed and
stored in wsave.

input parameter

n       the length of the sequence to be transformed.  the method
        is most efficient when n-1 is a product of small primes.

output parameter

wsave   a work array which must be dimensioned at least 3*n+15.
        different wsave arrays are required for different values
        of n. the contents of wsave must not be changed between
        calls of cost.

******************************************************************

subroutine cost(n,x,wsave)

******************************************************************

subroutine cost computes the discrete fourier cosine transform
of an even sequence x(i). the transform is defined below at output
parameter x.

cost is the unnormalized inverse of itself since a call of cost
followed by another call of cost will multiply the input sequence
x by 2*(n-1). the transform is defined below at output parameter x

the array wsave which is used by subroutine cost must be
initialized by calling subroutine costi(n,wsave).

input parameters

n       the length of the sequence x. n must be greater than 1.
        the method is most efficient when n-1 is a product of
        small primes.

x       an array which contains the sequence to be transformed

wsave   a work array which must be dimensioned at least 3*n+15
        in the program that calls cost. the wsave array must be
        initialized by calling subroutine costi(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.

output parameters

x       for i=1,...,n

            x(i) = x(1)+(-1)**(i-1)*x(n)

             + the sum from k=2 to k=n-1

                 2*x(k)*cos((k-1)*(i-1)*pi/(n-1))

             a call of cost followed by another call of
             cost will multiply the sequence x by 2*(n-1)
             hence cost is the unnormalized inverse
             of itself.

wsave   contains initialization calculations which must not be
        destroyed between calls of cost.

******************************************************************

subroutine sinqi(n,wsave)

******************************************************************

subroutine sinqi initializes the array wsave which is used in
both sinqf and sinqb. the prime factorization of n together with
a tabulation of the trigonometric functions are computed and
stored in wsave.

input parameter

n       the length of the sequence to be transformed. the method
        is most efficient when n is a product of small primes.

output parameter

wsave   a work array which must be dimensioned at least 3*n+15.
        the same work array can be used for both sinqf and sinqb
        as long as n remains unchanged. different wsave arrays
        are required for different values of n. the contents of
        wsave must not be changed between calls of sinqf or sinqb.

******************************************************************

subroutine sinqf(n,x,wsave)

******************************************************************

subroutine sinqf computes the fast fourier transform of quarter
wave data. that is , sinqf computes the coefficients in a sine
series representation with only odd wave numbers. the transform
is defined below at output parameter x.

sinqb is the unnormalized inverse of sinqf since a call of sinqf
followed by a call of sinqb will multiply the input sequence x
by 4*n.

the array wsave which is used by subroutine sinqf must be
initialized by calling subroutine sinqi(n,wsave).


input parameters

n       the length of the array x to be transformed.  the method
        is most efficient when n is a product of small primes.

x       an array which contains the sequence to be transformed

wsave   a work array which must be dimensioned at least 3*n+15.
        in the program that calls sinqf. the wsave array must be
        initialized by calling subroutine sinqi(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.

output parameters

x       for i=1,...,n

             x(i) = (-1)**(i-1)*x(n)

                + the sum from k=1 to k=n-1 of

                2*x(k)*sin((2*i-1)*k*pi/(2*n))

             a call of sinqf followed by a call of
             sinqb will multiply the sequence x by 4*n.
             therefore sinqb is the unnormalized inverse
             of sinqf.

wsave   contains initialization calculations which must not
        be destroyed between calls of sinqf or sinqb.

******************************************************************

subroutine sinqb(n,x,wsave)

******************************************************************

subroutine sinqb computes the fast fourier transform of quarter
wave data. that is , sinqb computes a sequence from its
representation in terms of a sine series with odd wave numbers.
the transform is defined below at output parameter x.

sinqf is the unnormalized inverse of sinqb since a call of sinqb
followed by a call of sinqf will multiply the input sequence x
by 4*n.

the array wsave which is used by subroutine sinqb must be
initialized by calling subroutine sinqi(n,wsave).


input parameters

n       the length of the array x to be transformed.  the method
        is most efficient when n is a product of small primes.

x       an array which contains the sequence to be transformed

wsave   a work array which must be dimensioned at least 3*n+15.
        in the program that calls sinqb. the wsave array must be
        initialized by calling subroutine sinqi(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.

output parameters

x       for i=1,...,n

             x(i)= the sum from k=1 to k=n of

               4*x(k)*sin((2k-1)*i*pi/(2*n))

             a call of sinqb followed by a call of
             sinqf will multiply the sequence x by 4*n.
             therefore sinqf is the unnormalized inverse
             of sinqb.

wsave   contains initialization calculations which must not
        be destroyed between calls of sinqb or sinqf.

******************************************************************

subroutine cosqi(n,wsave)

******************************************************************

subroutine cosqi initializes the array wsave which is used in
both cosqf and cosqb. the prime factorization of n together with
a tabulation of the trigonometric functions are computed and
stored in wsave.

input parameter

n       the length of the array to be transformed.  the method
        is most efficient when n is a product of small primes.

output parameter

wsave   a work array which must be dimensioned at least 3*n+15.
        the same work array can be used for both cosqf and cosqb
        as long as n remains unchanged. different wsave arrays
        are required for different values of n. the contents of
        wsave must not be changed between calls of cosqf or cosqb.

******************************************************************

subroutine cosqf(n,x,wsave)

******************************************************************

subroutine cosqf computes the fast fourier transform of quarter
wave data. that is , cosqf computes the coefficients in a cosine
series representation with only odd wave numbers. the transform
is defined below at output parameter x

cosqf is the unnormalized inverse of cosqb since a call of cosqf
followed by a call of cosqb will multiply the input sequence x
by 4*n.

the array wsave which is used by subroutine cosqf must be
initialized by calling subroutine cosqi(n,wsave).


input parameters

n       the length of the array x to be transformed.  the method
        is most efficient when n is a product of small primes.

x       an array which contains the sequence to be transformed

wsave   a work array which must be dimensioned at least 3*n+15
        in the program that calls cosqf. the wsave array must be
        initialized by calling subroutine cosqi(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.

output parameters

x       for i=1,...,n

             x(i) = x(1) plus the sum from k=2 to k=n of

                2*x(k)*cos((2*i-1)*(k-1)*pi/(2*n))

             a call of cosqf followed by a call of
             cosqb will multiply the sequence x by 4*n.
             therefore cosqb is the unnormalized inverse
             of cosqf.

wsave   contains initialization calculations which must not
        be destroyed between calls of cosqf or cosqb.

******************************************************************

subroutine cosqb(n,x,wsave)

******************************************************************

subroutine cosqb computes the fast fourier transform of quarter
wave data. that is , cosqb computes a sequence from its
representation in terms of a cosine series with odd wave numbers.
the transform is defined below at output parameter x.

cosqb is the unnormalized inverse of cosqf since a call of cosqb
followed by a call of cosqf will multiply the input sequence x
by 4*n.

the array wsave which is used by subroutine cosqb must be
initialized by calling subroutine cosqi(n,wsave).


input parameters

n       the length of the array x to be transformed.  the method
        is most efficient when n is a product of small primes.

x       an array which contains the sequence to be transformed

wsave   a work array that must be dimensioned at least 3*n+15
        in the program that calls cosqb. the wsave array must be
        initialized by calling subroutine cosqi(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.

output parameters

x       for i=1,...,n

             x(i)= the sum from k=1 to k=n of

               4*x(k)*cos((2*k-1)*(i-1)*pi/(2*n))

             a call of cosqb followed by a call of
             cosqf will multiply the sequence x by 4*n.
             therefore cosqf is the unnormalized inverse
             of cosqb.

wsave   contains initialization calculations which must not
        be destroyed between calls of cosqb or cosqf.

******************************************************************

subroutine cffti(n,wsave)

******************************************************************

subroutine cffti initializes the array wsave which is used in
both cfftf and cfftb. the prime factorization of n together with
a tabulation of the trigonometric functions are computed and
stored in wsave.

input parameter

n       the length of the sequence to be transformed

output parameter

wsave   a work array which must be dimensioned at least 4*n+15
        the same work array can be used for both cfftf and cfftb
        as long as n remains unchanged. different wsave arrays
        are required for different values of n. the contents of
        wsave must not be changed between calls of cfftf or cfftb.

******************************************************************

subroutine cfftf(n,c,wsave)

******************************************************************

subroutine cfftf computes the forward complex discrete fourier
transform (the fourier analysis). equivalently , cfftf computes
the fourier coefficients of a complex periodic sequence.
the transform is defined below at output parameter c.

the transform is not normalized. to obtain a normalized transform
the output must be divided by n. otherwise a call of cfftf
followed by a call of cfftb will multiply the sequence by n.

the array wsave which is used by subroutine cfftf must be
initialized by calling subroutine cffti(n,wsave).

input parameters


n      the length of the complex sequence c. the method is
       more efficient when n is the product of small primes. n

c      a complex array of length n which contains the sequence

wsave   a real work array which must be dimensioned at least 4n+15
        in the program that calls cfftf. the wsave array must be
        initialized by calling subroutine cffti(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.
        the same wsave array can be used by cfftf and cfftb.

output parameters

c      for j=1,...,n

           c(j)=the sum from k=1,...,n of

                 c(k)*exp(-i*(j-1)*(k-1)*2*pi/n)

                       where i=sqrt(-1)

wsave   contains initialization calculations which must not be
        destroyed between calls of subroutine cfftf or cfftb

******************************************************************

subroutine cfftb(n,c,wsave)

******************************************************************

subroutine cfftb computes the backward complex discrete fourier
transform (the fourier synthesis). equivalently , cfftb computes
a complex periodic sequence from its fourier coefficients.
the transform is defined below at output parameter c.

a call of cfftf followed by a call of cfftb will multiply the
sequence by n.

the array wsave which is used by subroutine cfftb must be
initialized by calling subroutine cffti(n,wsave).

input parameters


n      the length of the complex sequence c. the method is
       more efficient when n is the product of small primes.

c      a complex array of length n which contains the sequence

wsave   a real work array which must be dimensioned at least 4n+15
        in the program that calls cfftb. the wsave array must be
        initialized by calling subroutine cffti(n,wsave) and a
        different wsave array must be used for each different
        value of n. this initialization does not have to be
        repeated so long as n remains unchanged thus subsequent
        transforms can be obtained faster than the first.
        the same wsave array can be used by cfftf and cfftb.

output parameters

c      for j=1,...,n

           c(j)=the sum from k=1,...,n of

                 c(k)*exp(i*(j-1)*(k-1)*2*pi/n)

                       where i=sqrt(-1)

wsave   contains initialization calculations which must not be
        destroyed between calls of subroutine cfftf or cfftb



["send index for vfftpk" describes a vectorized version of fftpack]

			    The IMFORT Interface
			 Doug Tody, September 1986


1. INTRODUCTION

    The IMFORT interface is a host level Fortran programming environment for
IRAF.  Fortran programs (or C programs) may be written at the host level
with full access to the facilities of the host environment, plus limited
access to the IRAF environment via the IMFORT interface.  Such host level
programs may be interfaced to the IRAF CL as foreign tasks and called with
arguments on the command line, like ordinary IRAF tasks.

The chief advantage of the IMFORT interface is that it allows existing host
Fortran programs to be interfaced to IRAF with minimum effort.  The IMFORT
interface also provides a way for the scientist-user to extend the IRAF
environment with their own programs, without need to learn to use the much
more complex IRAF VOS programming environment.  Of course, the VOS is a much
more powerful environment and VOS programs tend to be much more portable than
host Fortran programs, so the VOS environment should be used for large
programming projects.

The IMFORT interface is described in detail in the document "A User's Guide
to Fortran Programming in the IRAF Environment".  A summary of the interface
procedures follows.  The IMFORT routines make use of the IRAF kernel for all
i/o, and of the FMTIO and VOPS packages for miscellaneous functions, hence
programs using IMFORT must be linked with LIBSYS, LIBVOPS, and LIBOS.


2. INTERFACE PROCEDURES

2.1 COMMAND LINE ACCESS

		clnarg (nargs)
		clrawc (outstr, ier)
           clarg[cird] (argno, [cird]val, ier)


2.2 IMAGE ACCESS

2.2.1 General

		imopen (f77nam, acmode, im, ier)
		imopnc (nimage, o_im, n_im, ier)
		imcrea (f77nam, axlen, naxis, pixtype, ier)
		imclos (im, ier)

		imflsh (im, ier)
		imgsiz (im, axlen, naxis, pixtype, ier)
		imhcpy (o_im, n_im, ier)
		impixf (im, pixfd, pixfil, pixoff, szline, ier)

		imemsg (ier, errmsg)


2.2.2 Image Header Keyword Access

		imacck (im, keyw)
		imaddk (im, keyw, dtype, comm, ier)
		imdelk (im, keyw, ier)
		imtypk (im, keyw, dtype, comm, ier)

	  imakw[bcdir] (im, keyw, [bcdir]val, comm, ier)
	  imgkw[bcdir] (im, keyw, [bcdir]val, ier)
	  impkw[bcdir] (im, keyw, [bcdir]val, ier)

		imokwl (im, patstr, sortit, kwl, ier)
		imgnkw (kwl, outstr, ier)
		imckwl (kwl, ier)


2.2.3 Image Pixel Access

	     imgl1[rs] (im, buf, ier)
	     imgl2[rs] (im, buf, lineno, ier)
	     imgl3[rs] (im, buf, lineno, bandno, ier)
	     imgs1[rs] (im, buf, i1, i2, ier)
	     imgs2[rs] (im, buf, i1, i2, j1, j2, ier)
	     imgs3[rs] (im, buf, i1, i2, j1, j2, k1, k2, ier)

	     impl1[rs] (im, buf, ier)
	     impl2[rs] (im, buf, lineno, ier)
	     impl3[rs] (im, buf, lineno, bandno, ier)
	     imps1[rs] (im, buf, i1, i2, ier)
	     imps2[rs] (im, buf, i1, i2, j1, j2, ier)
	     imps2[rs] (im, buf, i1, i2, j1, j2, k1, k2, ier)


2.3. BINARY FILE I/O (low level)

		bfaloc (fname, nchars, status)
	   fd = bfopen (fname, acmode, advice)
		bfclos (fd, status)
       nchars = bfbsiz (fd)
	 chan = bfchan (fd)
       nchars = bfread (fd, buf, nchars, offset)
       nchars = bfwrit (fd, buf, nchars, offset)
	 stat = bfflsh (fd)

Linear Least squares curve fitting package.
Contains routines to fit Legendre and Chebyshev polynomials and linear
cubic splines in the least squares sense to 1-dimensional data.
The normal equations are accumulated and solved using Cholesky factorization.
The package contains separate entry points for accumulating points,
solving the matrix equations, rejecting points and evaluating the curve.

LOCAL -- Locally added tasks and packages.

    The LOCAL package is a place to put locally added tasks and packages
without modifying the standard IRAF system (and thereby complicating future
updates and so on).  The LOCAL provided with the distributed system is a
template package provided to make it as easy as possible for user sites to
set up their own custom LOCAL packages.

To create a custom LOCAL package:

    [1] Copy the template package directory tree (iraf$local) to a new
	directory somewhere outside the iraf directories.  DO NOT MODIFY
	THE TEMPLATE LOCAL, CREATE AN EXTERNAL COPY AND MODIFY THAT INSTEAD.
	This is necessary to ensure that your custom local is unaffected by
	updates to the core IRAF system.

    [2]	Edit the pathame of local in the "reset local = ..." statement in the
	IRAF file hlib$extern.pkg, replacing the "iraf$local/" by the host
	pathname of the root directory of your custom LOCAL.  Be sure to
	include the trailing / on UNIX systems, or escape $ and [ on VMS
	systems.  All references to LOCAL will now refer to your custom
	version of LOCAL, rather than to the template version provided with
	the distributed system.

To add a new task to LOCAL:

    [1] Add the source and parameter file if any to this directory, e.g.,
	mytask.x, mytask.par.

    [2] Add the name of the new task to x_local.x.  Any number of tasks may
	be added to the package in this way.

		task	pavg	= t_pavg,
			mytask	= t_mytask

    [3] Add the manual page for the task to the `doc' subdirectory, e.g.,
	file doc/mytask.hlp.  Add entries for the new task to local.hd
	(so that HELP can find the new manual page) and local.men (so that
	the task will be listed when `help local' is entered).  Load the
	softools package and run `mkhelpdb' to recompile the help database
	else HELP will not know about the new manual page.

	cl> mkhelpdb local$lib/root.hd local$lib/helpdb.mip

    [4] Add an entry for all source files to the library member list in
	the mkpkg file in this directory.  List any include files referenced
	in the source file to the right of the source file name.
		
		libpkg.a:
			pavg.x		<imhdr.h>
			mytask.x
			;

    [5] Add an entry for the new task in local.cl, so that the CL will
	know about the new task when the LOCAL package is loaded.  Prefix
	the task name with a dollar sign ($mytask) if the new task does
	not have an associated parameter (.par) file.

		task	pavg,
			mytask	= "local$src/x_local.e"

    [6] Enter the command `mkpkg -p local' to compile and link the new package
	executable `x_local.e'.  After testing the new task, install the new
	package executable in bin$ with the command `mkpkg -p local install'.

You should now be able to load the LOCAL package in the CL, and run the new
task, or get help for any of the LOCAL package tasks.

Any number of tasks may be added to your custom LOCAL package in this fashion.
Host programs and IMFORT programs may also be added, modifying the task
statements and mkpkg compile/link instructions appropriately (if used).
Subpackages should be used to group like tasks if the LOCAL grows large
enough.  For more information on program development in IRAF, refer to the
SOFTOOLS package help pages for xc, mkpkg, etc., the SPP/VOS technical
documentation, the IMFORT manual, and so on.

VOPS -- Vector OPerators

This directory contains the (generic) source for the vector operators (VOPS).
These generic procedures are expanded into a set of type specific procedures
by the GENERIC preprocessor, before compilation by XC.  Documentation for
the vector operators and for the GENERIC preprocessor is in Vops.hlp.

The subdirectory "achtgen" contains code for generalized datatype conversion
of vectors.  The highest level routine, "acht" implements a full 9 by 9
type conversion matrix (BUcsilrdx) (the BU are in OSB).

4.2BSD UNIX IRAF Kernel.

    This directory contains the machine dependent routines comprising the IRAF
system interface to UNIX 4.2BSD.  Some additional potentially machine dependent
routines (the bit and byte primitives) are in sys$osb.  Documentation is in
the System Interface Reference manual doc$Os.ms and the manual pages for the
individual routines are in the subdirectory ./doc.

This directory contains the IRAF Formatted I/O (FMTIO) routines.  The FMTIO
package includes the string utilities (str___), character utilities (chr___),
encode/decode primitives (ctod, itoc, etc.), and the high level SCAN and
PRINTF routines.  This is a full implementation of FMTIO (excluding the
language dependent features that will be provided when the full language
becomes available).

MEMDBG -- Debug version of MEMIO.

This library may be linked with an application to perform runtime checks on
the memory allocation subsystem to check for memory leaks.  This library is
used only for debugging and is not supported on all IRAF host systems.

To use this package link the iraf process with the flags

    -z -lmemdbg

e.g.
    xc -c zz.x;  xc -z -o zz.e zz.o -lmemdbg

or include -lmemdbg on the $link line in the mkpkg file.

It may be desirable to edit the IRAF source code to insert MEMLOG messages
or change the logging defaults.  The following routines are provided for this
purpose.

		 memlog (message)
		memlog1 (message, arg1)
		memlog2 (message, arg1, arg2)
		memlogs (message, strarg)
		 memlev (loglevel)

MEMLOG logs a simple message string.  MEMLOG[12] allow one or two integer
arguments.  MEMLOGS allows one string argument.

The debug level may be set with MEMLEV, as follows:

	level = 1	log malloc/realloc/mfree calls
	level = 2	log smark/sfree calls
	level = 3	log both types of calls

The default debug level is 3.

Run one or more IRAF tasks in the process you want to debug and then type
flpr to exit the process (debug logging is process level and ALL calls during
the process lifetime are logged).  When the IRAF process is run a file

	mem.log

will be left in the current directory.  This contains a long sequence of lines
such as the following:

    215738  00000696    18d74  A 1  malloc 572 type 10
    21929d  00000697    59e34  A 2      smark
    21929d  00000698    5a0aa  F 2      sfree

The columns are as follows.

	bufadr		Buffer address for malloc, mfree, smark, etc.
	seqno		Sequence number - order in which the calls were made
	retadr		Return address - identifies routine which made the call
	action		Action code - A (alloc), R (realloc), F (free)
	class		Class of allocator (1=malloc/mfree, 2=smark/sfree)
	comment		Describes the type of call, may give extra info

This is just the raw debug output.  To check the debug output to see if there
are any calls that don't match up, the task MEMCHK in SOFTOOLS is used, e.g.,

    cl> sort mem.log | memchk | sort col=2 > mem.log2

This can also be run at the host level as follows.

    % sort mem.log | x_softools.e memchk fname=STDIN passall+ | sort +1 > ...

This may take a while for very large (> 10K lines) mem.log files.  The
output file will look like the input file except that any bad calls will be
flagged with the string "####" at the end of the line.

The RETADR field (printed in hex) can be used to determine what IRAF procedure
made a particular call.  On a Sun one can run

    % nm -n x_whatever.e

To list the symbol table sorted by address.  The routine which made the call
will be the .text routine with the greatest address which is less than
retadr, i.e., retadr is an address within the text of the calling procedure.

On a SysV system NM produces "pretty" output and is harder to use.  The
following command produces the necessary sorted list on my A/UX system.

    % nm -e -x imexpr.e | sort -t\| +1

Another way to do this is to let a debugger look up the symbol in the
symbol table for us.  Here is an example using adb.

    % adb zz.e
    0x25f0?i
    _foo_+0x28:     call    _xmallc_

In this example the value of retadr is 0x25f0, the executable is the file
zz.e, and the procedure which called the MEMIO (MEMDBG) routine malloc
was "foo" according to adb.

Note that memory debug logging starts during process startup and the first
messages logged will record the MEMIO calls made by the system code.  It is
normal for the system code to allocate some buffers which are used for the
lifetime of the process hence are never freed.  A simple way to determine
where the system MEMIO calls end and your task execution begins is to put a
call such as

	call memlog ("--------- start task -----------")

in the first executable line of your IRAF task.  Comments such as this will
be preserved in the mem.log file.

This directory contains a collection of routines for solving linear least
squares problems by the Singular Value Decomposition (SVD) method, as
described in "Solving Least Squares Problems", by Charles L. Lawson and
Richard J. Hanson, Prentice Hall, 1974.  The appendix of this book contains
full listings of the Fortran codes, as well as a users guide.

The numerical subroutines are in this directory.  The directory "progs"
contains a number of examples of the use of these routines in Fortran programs.

The numerical routines have been modified to eliminate the use of Fortran
i/o for error conditions.  The integer status return IER has been added to
all such routines, and the Fortran write statement(s) removed.  A successful
call returns zero in IER, while an unsucessful call returns a positive integer
error code, identifying the error.  The original codes are in the directory
"original_f".

The affected routines and the new calling sequences are as follows:

      subroutine BNDSOL (mode,g,mdg,nb,ip,ir,x,n,rnorm,ier)
      subroutine LDP	(g,mdg,m,n,h,x,xnorm,w,index,ier)
      subroutine NNLS	(a,mda,m,n,b,x,rnorm,w,zz,index,ier)
      subroutine SVDRS	(a,mda,mm,nn,b,mdb,nb,s,ier)

The routines SVA and MFEOUT were not installed in the library, since they
do extensive i/o, but have been modified to reflect the changes to the
above subroutines.

See "lsq.x" and "band.x" in progs/ for examples demonstrating the use
of these routines in IRAF spp programs.

20Nov82 D.Tody

Oct85	Added comma after P edit descriptor in sva.f

MWCS Interface Summary


		   mw = mw_open (bufptr|NULL, ndim)
		 mw = mw_openim (im)
		mw = mw_newcopy (mw)
		       mw_close (mw)

			mw_load (mw, bufptr)
		  len = mw_save (mw, bufptr, buflen)
	       mw_[load|save]im (mw, im)

		 ct = mw_sctran (mw, system1, system2, axes)
	  ndim = mw_gctran[r|d] (ct, ltm, ltv, axtype1, axtype2, maxdim)
		      mw_ctfree (ct)

	    x2 = mw_c1tran[r|d] (ct, x1)
		 mw_v1tran[r|d] (ct, x1, x2, npts)
		 mw_c2tran[r|d] (ct, x1,y1, x2,y2)
		 mw_v2tran[r|d] (ct, x1,y1, x2,y2, npts)
		  mw_ctran[r|d] (ct, p1, p2, ndim)
		  mw_vtran[r|d] (ct, v1, v2, ndim, npts)

	     mw_[s|g]lterm[r|d] (mw, ltm, ltv, ndim)
	      mw_translate[r|d] (mw, ltv_1, ltm, ltv_2, ndim)
		      mw_rotate (mw, theta, center, axes)
		       mw_scale (mw, scale, axes)
		       mw_shift (mw, shift, axes)

		   mw_newsystem (mw, system, ndim)
		 mw_[s|g]system (mw, system[, maxch])
		  mw_[s|g]axmap (mw, axno, axval, ndim)
		    mw_bindphys (mw)

	     mw_[s|g]wterm[r|d] (mw, r, w, cd, ndim)
		      mw_swtype (mw, axis, naxes, wtype, wattr)
	     mw_[s|g]wsamp[r|d] (mw, axis, pv, wv, npts)
		 mw_[s|g]wattrs (mw, axis, attribute, valstr[, maxch])

		 mw_invert[r|d] (o_ltm, n_ltm, ndim)
		   mw_mmul[r|d] (ltm_1, ltm_2, ltm_out, ndim)
		   mw_vmul[r|d] (ltm, ltv_in, ltv_out, ndim)
		    mw_glt[r|d] (v1, v2, ltm, ltv, ndim)

			mw_seti (mw, what, ival)
		ival = mw_stati (mw, what)
			mw_show (mw, outfd, what)

IMAGES -- General image processing tasks and utilties.
----------------------------------------------------------

imcoords	- Image world coordinate handling
imfilter	- Filtering (tasks which modify pixel values)
imfit		- Fitting (fitting functions to image data)
imgeom		- Geometry (tasks which move pixels around)
immatch		- Image matching
imutil		- Miscellaneous image utilties
tv		- Image display (prototype package)

SYMTAB -- General package for managing symbol tables.  The logical view of a 
symbol table is a collection of symbol structures.  The contents of a symbol
description structure are user defined, but the size of the structure is fixed.
The symbol name is a character string of arbitrary size, all characters of
which are significant.  The storage semantics of the symbol table are those
of a lifo stack, i.e., those symbols most recently defined must be the first
deleted.  There is no fixed limit on the size of a symbol table; additional
space will be dynamically allocated at run time if necessary.


       stp =     stopen (name, len_index, len_stab, sz_sbuf)
                stclose (stp)
                 stmark (stp, marker)           # mark storage
                 stfree (stp, marker)           # free to marked state
      nsym = stnsymbols (stp, marker)		# number of symbols in table
                 stinfo (stp, outfd)            # print info about symbol table

       sym =    stenter (stp, key, symlen)      # enter new symbol in table
       sym =     stfind (stp, key)              # search table for symbol
      nsym =  stfindall (stp, key, sym, maxsym) # find all occurrences of symbol
       sym =     sthead (stp)                   # last symbol entered into table
       sym =     stnext (stp, sym)              # next symbol on global list
     charp =     stname (stp, sym)              # access key name string

    offset =     stpstr (stp, str, minchars)    # put string in string buffer
    offset =    stalloc (stp, nints)            # alloc space in STAB
     charp =  strefsbuf (stp, offset)           # convert sbuf offset into charp
      intp =  strefstab (stp, offset)           # convert stab offset into intp

                 stsave (stp, fd)               # save symbol table in a file
       stp =  strestore (fd)                    # restore symbol table from file
              stsqueeze (stp)                   # return unused storage
     chars =     stsize (stp)			# chars req'd to store table


The symbol table is maintained as a multi-threaded linked list.  This provides
the efficiency of a hash table plus stack like semantics for redefinitions and
for freeing blocks of variables.  There are three primary data structures
internally, an array of pointers to the heads of the threads (the index),
a buffer containing the list elements (the symbol table), and a string buffer.
These data structures are dynamically allocated and will be automatically
reallocated at runtime if overflow occurs.  The number of threads is fixed at
table open time and determines the efficiency of table lookup.  The expected
running time is O(1) for well conditioned tables, i.e., tables with a sparse
index.  The worst case running time is O(N), i.e., the same as a linear search,
but of course the worst case is very unlikely to occur.  Symbol entry and
storage reclamation are especially efficient due to the use of a stack rather
than a heap for symbol storage.

	symtab descriptor
		index (integer array, size fixed at open time)
		sbuf  (char array, dynamic)
		stab  (list of symstructs, dynamic)

Each symbol consists of a variable size structure (symstruct) in STAB containing
references to one or more associated strings in SBUF.  A symstruct consists of
a fixed size SYMTAB header followed by a user defined structure, the size of
which is fixed at STENTER time.  Each symstruct is linked on two lists,
a global list and a hash list.  All symstructs are linked on the global list
which is ordered with the most recently entered symbol at the head of the list.
For a well conditioned table each hash list will typically contain zero or one
symbols, more when there are redefinitions or when identifiers happen to hash
to the same thread.  Often it is useful to store different types of entries
in the same symbol table; since symstructs may vary in size this may be done
efficiently.

The STOPEN procedure is used to create a new symbol table.  The 'name' argument
may be any string and is used for documentation purposes only.  The index
length argument sets the size of the hash index which is fixed for the
lifetime of the table.  The remaining two arguments specify the amount of
symbol table space and string storage space to be initially allocated for the
table.  The actual table may grow larger at runtime, but reallocation can be
expensive hence it is desirable to preallocate a large space if it is known
that the table will be large.

The STMARK and STFREE procedures mark and free storage on the symbol table
stack.  All symbols defined or redefined after a call to STMARK will be deleted
and storage freed by a call to STFREE.  If a redef is freed the next most
recent definition becomes current.  STFREE returns as its function value the
number of redefined variables uncovered by the free operation.  The calling
program must mark and free in the correct order or the symbol table may be
trashed.  The argument to STMARK is a magic integer which currently references
a marker record in the STAB containing the information necessary to mark and
free storage (an integer is not large enough to hold all of the necessary
information).

STENTER is used to enter a new symbol into the symbol table.  If the named
symbol is already present the new entry will nondestructively supercede the
old, which may be recovered by a subsequent STFREE (this is especially useful
for defining local contexts, e.g., when parsing a block structured language).
STENTER returns a pointer to the newly allocated symbol structure.  This pointer
may be invalidated if the symbol table buffer has to be reallocated in a
subsequent call to STENTER.  STFIND searches the symbol table for the named
key (symbol), returning a pointer to the most recently defined entry or NULL.
Once again, this pointer may be invalidated by a subsquent call which adds
to or removes symbols from the table.  STFINDALL finds all occurrences (or
some maximum number of occurrences), returning an array of symstruct pointers
ordered with the most recently defined symbols at the left.  STHEAD and STNEXT
are used to scan symbols in the reverse of the order in which they were
entered, e.g., for unkeyed symbol table searches.

The symbol table uses an associated string buffer for string storage.  Keys
(symbol names) are automatically added to the string buffer by STENTER.
The string buffer is maintained as a stack, with STMARK and STFREE marking
and freeing storage in the string buffer as well as in the symbol table buffer.
The user may store data in either the string buffer or the symbol table
provided the stack semantics are observed when marking and freeing storage.
To permit dynamic reallocation, storage is referenced by offset rather than
by pointer.  Only offsets into SBUF or STAB should be stored in symbol table
entries.  String storage is allocated in SBUF with STPSTR (which also deposits
the string).  Integer aligned storage is allocated in STAB with STALLOC.
The offset of a string stored in SBUF may be converted to a char pointer
with STREFSBUF.  The offset of a storage area in STAB may be converted into
an integer pointer with STREFSTAB.  Pointer conversions such as these should
not be done in the calling program since doing so requires knowledge of the
internal SYMTAB data structures (in particular, that symbol table storage
is contiguous).

A symbol table may be saved in a binary file using STSAVE.  The space which
will be required to store the symbol table may be queried in advance with
STSIZE.  The internal SYMTAB data structures are simply appended to the file.
The symbol table itself is not affected.  A saved symbol table may be restored
to memory with STRESTORE, which is used in place of STOPEN.  The file must be
opened and positioned to the correct offset before STRESTORE is called.
It may be desirable to call STSQUEEZE before calling STSAVE or STSIZE,
to minimize the file storage required to store the symbol table.

                      THE NLFIT PACKAGE

This subdirectory contains the routines in the non-linear least squares
fitting package NLFIT. NLFIT uses the Levenberg-Marquardt method  to
to solve for the parameters of a user specified non-linear equation.
The user must supply two routines. The first routine evaluates the function
in terms of its parameters. The second routine evaluates the function and its
derivatives in terms of its parameters.  The user must also supply initial
guesses for the parameters and parameter increments, the list of
parameters to be varied during the fitting processa, a fitting
tolerance and the maximum number of iterations.

The principal entry points into the NLFIT are listed below.

	nlinit - Initialize the fitting routines
       nlstati - Get the value of an integer NLFIT parameter
        nlstat - Get the value of floating point NLFIT parameter
	nlpget - Get the values of the fitted parameters
	nlfree - Free memory allocated by nlinit
	 nlfit - Fit the function
	nleval - Evaluate the curve at a given point
      nlvector - Evaluate the curve at an array of points 
      nlerrors - Compute the fits statistics and errors in the parameters

The calling sequences for the above routines are listed below. The [ird]
stand for integer, real and double precision versions of each routine
respectively.

               nlinit[rd] (nl, address(fnc), address(dfnc), params, dparams,
	            nparams, plist, nfparams, tol, itmax)
        ival = nlstati (nl, param)
     [rd]val = nlstat[rd] (nl, param)
               nlpget[rd] (nl, params, nparams)
               nlfree[rd] (nl)
               nlfit[rd] (nl, x, z, w, npts, nvars, wtflag, ier)
     [rd]val = nleval[rd] (nl, x, nvars)
               nlvector[rd] (nl, x, zfit, npts, nvars)
               nlerrors[rd] (nl, z, zfit, wts, npts, variance, chisqr, errors)

The user supplied functions fnc and dfnc have the following calling
sequences.
	
	       fnc (x, nvars, params, nparams, zfit)
	      dfnc (x, nvars, params, dparams, nparams, zfit, derivs)

    The address of the user supplied function can be determined with a
call to locpr as in

	      address = locpr (fnc)

The user definitions for the NLFIT package can be found in the file 
lib$math/nlfit.h and can be made available to user applications programs
with the statement "include <math/nlfit.h>".

The permitted values for the param argument in nlstat[ird] are the following.

define	NLNPARAMS	integer		# Number of parameters
define	NLNFPARAMS	integer         # Number of fitted parameters
define	NLITMAX		integer		# Maximum number of iterations
define	NLITER		integer		# Current number of iterations
define	NLNPTS		integer         # Number of points
define	NLSUMSQ		real/double	# Current reduced chi-squared
define	NLOLDSQ		real/double     # Previous reduced chi-squared
define	NLLAMBDA	real/double     # Value of lambda factor
define	NLTOL		real/double	# Fitting tolerance in %chi-squared
define	NLSCATTER	real/double     # Mean scatter in the fit

The permitted values of the wtflag argument in nlfit[rd] are the following.

define	WTS_USER			# User enters weights
define	WTS_UNIFORM			# Equal weights
define	WTS_CHISQ 			# Chi-squared weights
define	WTS_SCATTER			# Weights include scatter term

The permitted error values returned from nlfit[rd] are the following.

define	DONE			0	# Solution converged
define	SINGULAR		1	# Singular matrix
define	NO_DEG_FREEDOM		2	# Too few points
define	NOT_DONE		3	# Solution did not converge

This directory contains the source for the TTY interface, a device independent
interface used to control terminals.  We interface to the widely used
TERMCAP terminal database, thereby gaining the data required to control many
diverse terminals.  (Written Jan84 dct).

Mar84	Added TTYGDES and the "graphcap" file, used to describe graphics
	devices.

Jly84	Added capability to compile selected termcap entries to speedup
	TTYODES.  Added TTYCOMPILE, TTYLOAD, TTYOPEN, TTYCLOSE.  Modified
	the existing routines TTYODES and TTYGDES.  The new open and close
	routines are useful for any type of database maintained in termcap
	format.

Jly84	Entry point TTYCLINE changed to TTYCLEARLN to avoid name conflict
	with TTYCLOSE.

Jly84	Task MKTTYDATA is used to compile selected entries from TERMCAP
	files.  The include files "cache_?.dat" are the output of this
	program.  To tailor the cache of pre-compiled termcap device
	entries for a site, compile MKTTYDATA and run it to generate
	the files "cache_t.dat" for "dev$termcap" (default MKTTYDATA params)
	and "cache_g.dat" for "dev$graphcap", then do a Sysgen to recompile
	the libraries.  All programs which use the TTY interface, e.g.,
	the SYSTEM package, must then be relinked to make use of the new
	cache.

Jun85	Changed filenames to make them more machine independent.
	Installed MKTTYDATA as a task in the SOFTOOLS package.

CLIO - Command Language I/O.

This is the interface between IRAF applications and the IRAF command
language.  To an application, the CL appears to be a database managing named
"psets" (parameter sets) containing parameters.  CLIO is used by the
application to read and write these parameters.  The parameter sets are
predefined at the CL level rather than being dynamically defined by the
application.


EXTERNAL ROUTINES

			 clseti (clio-param, value)
		value = clstati (clio-param)

        value = clget[bcsilrdx] (param)
		clput[bcsilrdx] (param, value)
			 clgstr (param, outstr, maxch)
			 clpstr (param, value)
     nelem|EOF = clgl[bcsilrdx] (param, value)
	   nchars|EOF = clglstr (param, outstr, maxch)

	       key|EOF = clgcur (param, wx, wy, wcs, key, strval, maxch)
		nitems = clgkey (param, key, strval, maxch)
	       kwindex = clgwrd (param, keyword, maxchar, dictionary)

		   pp = clopset (pset)
			clcpset (pp)
       pval = clgpset[bcsilrdx] (pp, param)
	      clppset[bcsilrdx] (pp, param, pval)
		       clgpseta (pp, pname, outstr, maxch)
		       clppseta (pp, pname, sval)
			cllpset (pp, fd, format)
			clepset (pp)


OBSOLETE ROUTINES

	     list = clpopn[isu] (param)
			 clpcls (list)
			 clprew (list)
		 nelem = clplen (list)
		nchars = clgfil (list, fname, maxch)

			clgpset (pp, pname, outstr, maxch)
			clppset (pp, pname, sval)


RESTRICTED ROUTINES

			  clcmd (cmd)
			 clcmdw (cmd)

			 clopen (stdin, stdout, stderr, device, devtype)
			 zclsps (chan, status)
			 zardps (ps, buf, maxbytes, offset)
			 zawrps (ps, buf, nbytes, offset)
			 zawtps (ps, status)
			 zsttps (ps, what, lvalue)

		       clc_init ()
		   clc_compress ()
		       clc_free (marker)
		       clc_mark (marker)
		    clc_newtask (taskname)
		      clc_enter (param, value)
	     nchars = clc_fetch (param, outstr, maxch)
		 sym = clc_find (param, outstr, maxch)
		       clc_list (fd, pset, format)
		       clc_scan (cmd)

			 gexfls ()
		     gexfls_set (stream, gp_value, epa_gflush)
		   gexfls_clear (stream)


INTERNAL ROUTINES

	       key|EOF = rdukey (keystr, maxch)
	 charp = clpset_parname (pp, parname)
       status = cl_psio_request (cmd, arg1, arg2)
		       clreqpar (param)


INTERFACE PARAMETERS

	# clstati parameters (read only).
	CL_PRTYPE	# parent process type (see below)
	CL_PCACHE	# symtab descriptor of param cache

	# Process type codes.
	PR_CONNECTED	# connected subprocess
	PR_DETACHED	# detached subprocess
	PR_HOST		# subprocess spawned by host

	# Process interpreter mode codes (used by ONENTRY and the iraf main).
	PR_NOEXIT	# run interpreter in Iraf Main
	PR_EXIT		# skip interpreter, shutdown process

PSIO -- The Postscript I/O package.

	The PSIO interface is used to format a block of text as Postscript
output on a page of a given size (Letter, Legal, A4 or B5).  Once initialized
by a ps_open() call, programs can set various options related to the page
size or properties, preferred fonts, etc.  Output is begun with a call to
the ps_write_prolog() routine to initialize the PS prolog.  Afterwards,
text may be fed to a buffer using ps_deposit() to fill the output page to
a right justified margin, inserting linebreaks where needed.  Other routines
permit specific linebreaks or text positioning as required.


1) PSIO Interface Summary
-------------------------

		     include  <psset.h>

		ps = ps_open  (fd, default_footer)
	          ps_setfont  (ps, font)
	        ps_page_size  (ps, page)
	        ps_font_size  (ps, font_size)
		   ps_header  (ps, ledge, center, redge)
		   ps_footer  (ps, ledge, center, redge)
	       ps_setmargins  (ps, left, right, top, bottom)
	     ps_write_prolog  (ps)
		    ps_close  (ps)

	             ps_xpos  (ps, xpos)
	             ps_ypos  (ps, ypos)
	           ps_indent  (ps, nchars)
	         ps_testpage  (ps, nlines)
	          ps_deposit  (ps, line)
	        ps_linebreak  (ps, fill_flag)
	        ps_pagebreak  (ps, fill_flag)
	          ps_newline  (ps)
	           ps_output  (ps, line)
	           ps_center  (ps, line)
	     ps_rightjustify  (ps, text)

	width = ps_textwidth  (ps, string)
	  pos = ps_centerpos  (ps, text)
	      pos = ps_rjpos  (ps, text)



2) PSIO Interface Description
-----------------------------

    ps = ps_open (fd, default_footer)
	Initialize the PS structure with default page size and margins,
	set output file descriptor. Returns the PS struct pointer initialized
	with defaults.  If the 'default_footer' int flag is enabled a default
	footer containing the string "NOAO/IRAF" in the bottom left corner,
	the IRAF version string in the center, and the page number in the 
	bottom right will be created for each page.  Otherwise only a page
	number will appear unless a different footer is defined with the
	ps_footer() command.


    ps_setfont (ps, font)
	Set the current font to be used.  Allowable values for 'font' are set
	in the <psset.h> include file as

	    define F_ROMAN         1           	# times-roman font
	    define F_ITALIC        2           	# times-roman italic font
	    define F_BOLD          3           	# times-roman bold font
	    define F_TELETYPE      4           	# fixed-width font
	    define F_PREVIOUS      5           	# previous font

	The default font will be a 10-point Times-Roman.

    ps_font_size (ps, font_size)
	Set the font size in points to be used.  Font sizes are not changeable
	once the interface has been opened so this routine must be called
	before the Postscript prolog is written.

    ps_page_size (ps, page)

	Set the default page size to be used.  Allowable values for 'page'
	are set in the <psset.h> include file as

	    define PAGE_LETTER     1        # US Letter (612x792  @ 300 dpi)
	    define PAGE_LEGAL      2	    # US Legal  (612x1008 @ 300 dpi)
	    define PAGE_A4         3	    # A4 size   (595x850  @ 300 dpi)
	    define PAGE_B5         4	    # B5 size   (524x765  @ 300 dpi)

	The default page size will be US Letter but can be overridden in the
	environment by defining a 'pspage' variable as e.g.

	    cl> reset pspage = "legal"

    ps_header (ps, ledge, center, redge)
	Set header text tags.  The header will appear on each page, empty
	strings are allowed to indicate no text is to be written in that
	part of the header.

    ps_footer (ps, ledge, center, redge)
	Set footer text tags.  The footer will appear on each page, empty
	strings are allowed to indicate no text is to be written in that
	part of the header.  A running page number will always be written
	to the 'redge' field unless a non-empty value is defined, a white-
	space character can be used to indicate no text should be written
	to that part of the footer.

    ps_setmargins (ps, left, right, top, bottom)
	Set/Change page margins from defaults set by ps_open().  Values are
	defined in units of inches given as a floating point number.

    ps_write_prolog (ps)
	Write the PS prolog given the current postscript struct.  This
	initializes a flag preventing subsequent changes from taking effect
	once called.

    ps_close (ps)
	Close the struct, flush the page, and free memory


    ps_xpos (ps, xpos)
    ps_ypos (ps, ypos)
	Set current X or Y position on page

    ps_indent  (ps, nchars)
	Set a temporary indenture of the page from the permanent left margin.
	Value is given as a number of fixed-width characters, negative values
	are not permitted, a value of zero may be used to reset to the left
	margin.
	         
    ps_testpage  (ps, nlines)
	Test whether the output is within the specified number of line of
	the end of the page, if so do a page break.  This routine can be used
	to force a page break when a certain number of lines is to be reserved
	to e.g. keep a group of text together on a page.

    ps_deposit (ps, line)
	Deposit a line of text to the output buffer.  When the output width
	exceeds the permanent right margin the line is flushed to the output
	file and the x-position reset to the current left margin, the y-pos
	is moved to the next line determined by the font size.   Remaining
	words in the line buffer to added to the next line buffer. 
	    Width of the line is computed from the width of each word plus
	a space char, including font changes.  The line buffer outputs each
	word plus spacing individually,  font changes are handled in the
	output routine.

    ps_linebreak (ps, fill_flag)
	Break the current line regardless of whether it has been filled.  
	The int 'fill_flag' says whether to fill the current line to be right 
	justified.  May be called to simply flush the current line buffer.

    ps_output (ps, line, fill_flag)
	Output the given line and break, fill to be right justified if the
	int 'fill_flag' is set.
	
    ps_center (ps, line)
	Center the line on the page and break.

    ps_rightjustify (ps, text)
	Right justfify text on the current line.


    width = ps_textwidth (ps, string)
	Get the width of the given string.  Width is returned in terms of
	Postscript pixels assuming a 72 point, 300 dpi page.

    pos = ps_centerpos (ps, text)
    pos = ps_rjpos (ps, text)
	Get the X position of the centered and right-justified strings.


3) Postscript Prolog
--------------------

	Example prolog for the postscript output.  The actual prolog is
created based on parameters specified such as the page size, header/footer
text, etc.  Lines with '***' indicate those which are set dependent upon 
PS structure values.


%!PS-Adobe-1.0
%%Creator: IRAF postscript translator
%%CreationDate: Wed May 19 14:34:47 1999
%%Pages: (atend)
%%DocumentFonts: (atend)
%%EndComments
%%BeginProlog

/inch	{ 72 mul    } def		% 72 points per inch
/PL 	{ 792  	    } def		% set page height	     	   ***
/FtrY	{ 20	    } def		% footer Y position
/HdrY	{ PL 40 sub } def		% header Y position
/xOrg	72 	   def			% 1 inch left margin         	   ***
/yOrg	720    	   def			% 1 inch top margin          	   ***
/yDelta 12 	   def			% line spacing		     	   ***
/Line	1 	   def			% line number
/Page	0 	   def			% page number
/pnum   4 string   def			% sizeof page number cvs buffer
/res	10.00	   def			% pixel resolution factor    	   ***

/TA { 	newpath 			% Draw a box around our text
    xOrg yOrg moveto 			% area as a debugging procedure.
       0 -664 rlineto                   %                                  ***
     467    0 rlineto                   %                                  ***
       0  664 rlineto                   %                                  ***
    closepath 
    stroke
} bind def

/FS 	{ findfont exch scalefont } bind def 	% find and scale a font
/Fonts [					% create an array of fonts
    10 /Times-Roman FS 				%		     	   ***
    10 /Times-Bold FS 				%		     	   ***
    10 /Times-Italic FS 			%			   ***
    10 /Courier FS 				%			   ***
    12 /Times-Bold FS 				%		     	   ***
] def
/R  {	Fonts 0 get setfont } bind def 		% set roman font
/B  {	Fonts 1 get setfont } bind def 		% set bold font
/I  {	Fonts 2 get setfont } bind def 		% set italic font
/T  {	Fonts 3 get setfont } bind def 		% set teletype font
/H  {	Fonts 4 get setfont } bind def 		% set header font

/NL {	Line 1 add SL 	} bind def 		% newline
/H  {	res div 
	currentpoint exch pop 
	moveto 		} def			% horizontal position
/S  {	exch H show 	} bind def 		% show
/SL {	/Line exch def 				% set line position
	xOrg yOrg Line yDelta mul sub moveto
} bind def


/BP {	 					% Begin page (header).
    xOrg HdrY moveto R (TEE \(Nov97\)) show	% write the header         ***
     280 HdrY moveto R (system) show            %                          ***
     485 HdrY moveto R (TEE \(Nov97\)) show     %                          ***
    1 SL R
} bind def

/EP {	     					% End page (footer).
    /Page Page 1 add def			% increment page number
    xOrg FtrY moveto R (NOAO/IRAF) show	% write the footer                 ***
    250  FtrY moveto R (IRAF V2.11 May 1997) show                          ***
    530  FtrY moveto R Page pnum cvs show                                  ***
    showpage					% show the page
} bind def

%%EndProlog
%%Page: 1 1
%-----------------------------------------------------------------------------

initgraphics
TA
BP
	...<postscript generated by translator>...
EP
	...<repeat above as needed>...

% end of listing
%%Trailer
%%DocumentFonts: Times-Roman Times-Bold Times-Italic Courier
%%Pages: <N>								   ***



4) Example Program
------------------

include <time.h>
include <psset.h>

task   pstest        = t_pstest

# PSTEST -- Test the PSIO package.  This test program pretty-prints a file
# with a header message and page number suitable for output to a printer.

procedure t_pstest()

pointer	ps
int     fd, ip, op
char    fname[SZ_FNAME], date[SZ_TIME], line[SZ_LINE], outline[SZ_LINE]

pointer ps_open()
int     open(), getline()
long    clktime()

begin
        # Get the file to format and date string.
        call clgstr ("filename", fname, SZ_FNAME)
        call cnvtime (clktime(0), date, SZ_TIME)

        # Open the file.
        fd = open (fname, READ_ONLY, TEXT_FILE)

        # Initialize the PSIO interface.
        ps = ps_open (STDOUT, NO)
        call ps_header (ps, fname, "NOAO/IRAF", date)
        call ps_footer (ps, "PSIO Test Page", "", "")
        call ps_write_prolog (ps)

        # Output the text in a fixed-width font.
        call ps_setfont (ps, F_TELETYPE)

        call ps_linebreak (ps, NO)
        while (getline (fd, line) != EOF) {
	
            if (line[1] == EOS) {
		# Simple break on a newline.
                call ps_linebreak (ps, NO)

            } else {
	        # Detab the line.
	        ip = 1
	        op = 1
                while (line[ip] != EOS && op <= SZ_LINE) {
                    if (line[ip] == '\t') {
                        repeat {
                            outline[op] = ' '
                            op = op + 1
                        } until (mod(op,8) == 1)
                        ip = ip + 1
                    } else {
                        outline[op] = line [ip]
                        ip = ip + 1
                        op = op + 1
                    }
                }
                outline[op] = EOS

                # Output the line and a newline.
                call ps_output (ps, outline, NO)            
                call ps_newline (ps)
            }
        }

        # Close the file and PSIO interface.
        call close (fd)
        call ps_close (ps)
end

This directory contains miscellaneous parts of the IRAF system code.
These include the error handling facilities, the IRAF Main and associated
routines (the default exception handler, and ONEXIT), environment access
facilities, and time conversion facilities.

The UTILITIES package is a place to put programs which should be in the
mainline system, but which do not logically belong in any other package.
See also the NOAO.ASTUTIL package, for utilities pertaining to astronomy.

SOFTOOLS -- Software tools package.  This directory contains only the portable
software maintenance utilities.  Additional tools may be found in the HOST$BOOT
directories and in the local USER package.

NSPP -- The NCAR System Plot Package.

	portlib		portable NSPP modules
	sysint		the system interface

Usage:
	The user must supply a subroutine called WRITEB to use the library.
	See gio$nsppkern for an example.  The subroutine Z8ZPII should be
	called before using NSPP to initialize the internal variables.

                  The Aperture Photometry Package
                 ----------------------------------

The apphot package contains routines which perform aperture
photometry in circular and polygonal apertures using fractional pixel
techniques. No point spread function fitting techniques are employed.
The photometry routines are most suitable for use on uncrowded
or moderately crowded fields.

The apphot directory structure is listed below. The package organization
is by task, for example the center subdirectory contains routines
specific to the center task or by function, for example the nlfit
directory contains the non-linear least squares fitting routines.
The wphot task shares alot of code with the phot task. Similarly
the polymark task shares some code with the polyphot task.
The .h files are all in lib as many of them are shared by several tasks.

             |-aplib---------apphot routines used by several tasks
             |-aputil--------miscellaneous useful routines
             |-center--------routines specific to centering, the center task
             |-daofind-------routines specific to the daofind task
             |-doc-----------apphot documentation
|-apphot-----|-fitpsf--------routines specific to the fitpsf task
             |-fitsky--------routines specific to sky fitting, the fitsky task
	     |-lib-----------apphot definitions or .h files
             |-phot----------routines specific to the qphot/phot tasks
             |-polyphot------routines specific to the polyphot/polymark tasks
             |-radprof-------routines specific to the radprof task
	     |-wphot---------routines specific to the wphot task
             |-test----------directory of test data


Lindsey Davis
NOAO IRAF GROUP
November 1991

This directory contains a small subset  of the LAPACK source files for
the use in IRAF.

LAPACK is a library of Fortran subroutines for solving the most commonly
occurring problems in numerical linear algebra.

LAPACK is a freely-available software package. It can be included in commercial
software packages (and has been). We only ask that that proper credit be given
to the authors, for example by citing the LAPACK Users' Guide. The license used
for the software is the modified BSD license, see:
https://github.com/Reference-LAPACK/lapack/blob/master/LICENSE

Like all software, it is copyrighted. It is not trademarked, but we do ask the
following: if you modify the source for these routines we ask that you change
the name of the routine and comment the changes made to the original.

LAPACK is available from github at:
https://github.com/reference-lapack/lapack

LAPACK releases are also available on netlib at:
http://www.netlib.org/lapack/

The HELP package -- online documentation utilties.  This directory contains
the source and documtation for the HELP utility.  The subdirectory lroff
contains the source for the Lroff text formatter, called by HELP to format
help blocks.

Jul84	Added the help database facility, i.e., pre-compilation of the help
	directories to produce a binary database.  Numerous other improvements.
	See the revs file for additional details.

Note:	The TASK declaration for HELP is in pkg$system/system.cl.
	The TASK declarations for MKHELPDB and HDBEXAMINE are in the softools
	    package, file pkg$softools/softools.cl.

GIM -- GIO graphics imaging library.  This is a developmental library based
on GIO escapes, providing IRAF applications with access to the Gterm widget
imaging functions.  This library is tied directly to the Gterm widget and is
expected to be replaced by a more general imaging library in the future.

This library is intended only for clients that need to directly access the
imaging functions in the Gterm widget for full control over the imaging
capabilities of the Gterm widget.  Applications which merely need to display
an image as part of a more complex graphic would probably be better off
using the more device independent gpcell (put cell-array) and gpcmap (put
colormap) calls.


The following functions are direct RPC calls to the corresponding Gt-prefixed
imaging functions in the Gterm widget.

            gim_rasterinit (gp)
          gim_createraster (gp, raster, type, width, height, depth)
         gim_destroyraster (gp, raster)
  exists = gim_queryraster (gp, raster, type, width, height, depth)
	     gim_setraster (gp, raster)		# see gseti(gp,G_RASTER,n)

           gim_writepixels (gp, raster, data, nbits, x1, y1, nx, ny)
            gim_readpixels (gp, raster, data, nbits, x1, y1, nx, ny)
	    gim_refreshpix (gp, raster, ct, x1, y1, nx, ny)
	     gim_setpixels (gp, raster, ct, x1, y1, nx, ny, color, rop)

         gim_writecolormap (gp, colormap, first, nelem, r, g, b)
  nelem = gim_readcolormap (gp, colormap, first, maxelem, r, g, b)
          gim_loadcolormap (gp, colormap, offset, slope)
          gim_freecolormap (gp, colormap)
	    gim_iomapwrite (gp, iomap, first, nelem)
	     gim_iomapread (gp, iomap, first, nelem)

          gim_initmappings (gp)
	   gim_freemapping (gp, mapping)
            gim_copyraster (gp, rop, src,st,sx,sy,sw,sh, dst,dt,dx,dy,dw,dh)
            gim_setmapping (gp, mapping, rop, 
				src,st,sx,sy,sw,sh, dst,dt,dx,dy,dw,dh)
   status = gim_getmapping (gp, mapping, rop,
			        src,st,sx,sy,sw,sh, dst,dt,dx,dy,dw,dh)
         gim_enablemapping (gp, mapping, refresh)
        gim_disablemapping (gp, mapping, erase)
        gim_refreshmapping (gp, mapping)

The following Gterm widget imaging functions have no analogue in the GIM
imaging interface, but can be called from within GUI code.  These functions
are not implemented at the GIM level either because they are not essential
and would be too inefficient to be worth using via RPC, or because they
access resources available only to GUI code.

            GtAssignRaster (gt, raster, drawable)
  pixmap = GtExtractPixmap (gt, src, ct, x, y, width, height)
            GtInsertPixmap (gt, pixmap, dst, ct, x, y, width, height)
   raster = GtSelectRaster (gt, dras, dt, dx, dy, rt, rx, ry, mapping)
     raster = GtNextRaster (gt)
      raster = GtGetRaster (gt)
            n = GtNRasters (gt)
  pixel = GtGetClientPixel (gt, gterm_pixel)
   mapping = GtNextMapping (gt)
  active = GtActiveMapping (gt, mapping)


The following messaging routines are also defined by the GIO interface.
These are used to set the values of UI parameters (i.e., send messages to
the user interface).

		      gmsg (gp, object, message)
	    gmsg[bcsilrdx] (gp, object, value)
		  gmprintf (gp, object, format)


The imaging model of the Gterm widget defines the following key object or
data types: rasters, mappings, and colors.

    raster	A raster is a MxN array of pixels.  At present pixels are 8
		bits deep but hooks are built in to the interface to expand
		this in the future.  Pixel values are indices into the Gterm
		virtual colormap, with values starting at zero.  A raster
		may be any size.  A raster is merely a two-dimensional array
		in the graphics server; it is not displayed unless mapped.
		An exception is raster zero, which is the graphics window.
		Rasters are referred to by number, starting with zero.
		Initially only raster zero exists; new rasters are created
		with gim_createraster.  Space for rasters may be allocated
		either in the graphics server, or in the X server.  This has
		implications on performance but is otherwise transparent to
		the client.  By default rasters are allocated in the
		graphics server, i.e., in the X client.

    mapping	A mapping defines a projection of a rectangle of the source
		raster onto a rectangle of the destination raster.  Mappings
		may be either enabled (active) or disabled.  When a mapping
		is enabled, any change to a pixel in the source rect will
		cause the corresponding pixels in the destination rect to be
		updated.  Mappings are referred to by number starting with
		one.  Initially no mappings are defined.  If the size of the
		input and output rect is not the same the input rect will be
		scaled by pixel replication or subsampling to fill the
		output rect.  If the argument DW or DH of the destination
		rect is negative, the image will be flipped around the
		corresponding axis when copied to the destination; the
		region of the destination drawn into is the same in either
		case.  Multiple mappings may reference the same source or
		destination raster.  Mappings are refreshed in order by the
		mapping number.  Modifying a mapping causes the changed
		regions of the destination rect to be refreshed.

    color	The gterm widget provides a fixed number of preassigned colors
		corresponding to pixel values 0 through 9.  0 is the background
		color, 1 is the foreground color, and 2-9 (8 colors) are
		arbitrary colors defined by Gterm widget resources.  These
		static colors are normally used to draw the background, frame,
		axes, titles, etc. of a plot, or to draw color graphics within
		the drawing area.  The advantage of static colors is that they
		are shared with other X clients, and the values of these
		colors may be assigned by the user to personalize the way
		plots look.

		The gterm widget also allows any number (up to about 200 or
		so) additional colors to be defined at runtime by the client
		application.  These color values start at pixel value 10 and
		go up to the maximum pixel value assigned by the client.  The
		client application allocates colors with gim_writecolormap.
		Attempts to overwrite the values of the static colors are
		ignored.  The values of already allocated colors may be
		changed dynamically at runtime using gim_writecolormap to
		write the desired range of color values.

		Applications should not assume that there are 10 static
		colors and 200 or so allocatable colors.  The graphcap entry
		for the logical device in use defines these parameters for
		the device.  Alternatively, the readcolormap call may be
		used to dynamically determine how many colors the server has
		preallocated when the application starts up.

		An image may use either static and dyamic pixel values or
		both types of values, but in most cases imaging applications
		involve smoothly shaded surfaces hence will require
		dyamically assigned private colors.

		If for some reason the client application cannot use the
		gterm widget color model, the IOMAP feature can be used to
		make the widget appear to have some externally defined
		(i.e., client defined) color model.


The maximum number of rasters and maximum number of mappings is defined by
Gterm widget resources (e.g. in the GUI file) when the graphics application
starts up.  The maximum values should be much larger than most applications
require.  Applications should allocate raster or mapping numbers
sequentially starting at 1 (more or less) to avoid running out of raster or
mapping descriptors.

The {read|write}pixels routines in the GIM interface operate directly on
raster pixels.  The mapping routines support two alternative coordinate
systems, raster pixels and NDC (normalized device coordinates), as indicated
by the ST or DT argument (source or destination coordinate type).  Note
that the origin of the pixel coordinate system is the upper left corner of
the display window (consistent with most graphics systems), whereas the origin
of the NDC coordinate system is the lower left corner (consistent with IRAF).

Pixel coordinates allow precise control of imaging but require the
application to know the window size, and may result in complications e.g. if
the window is resized.  NDC coordinates pretty much guarantee that a mapping
will involve sampling, hence are not the most efficient, but the graphics
will be drawn correctly no matter how the window is resized and for most
applications the performance difference is negligible.  Most applications
should use NDC coordinates for raster 0 (the display window), and pixel
coordinates for rasters 1-N.

Although the size of rasters 1 and higher are defined by the client
application, the size of raster zero, the actual gterm display window, is
subject to the constraints of the window system.  The client can attempt to
reset the size of the gterm window using gim_createraster with raster=0,
however the Gterm widget, UI containing the gterm widget, and the window
manager are all free to deny such a request.  gim_queryraster should be
called to determine the actual size of the window one will be drawing into.


EXAMPLE

    A simple example of an imaging application might download an image and
display it in the gterm window, filling the window.  This could be done as
follows (following a GOPEN and other GIO calls to prepare the drawing surface).

	gim_createraster	Create raster 1 the size of the pixel array
				to be displayed.  This need not be the same
				as the size of the gterm display window.

	gim_setmapping		Define a mapping between raster 1 and raster 0,
				the display window, using NDC coordinates to
				define the region of the display window to be
				filled.  The mapping number is arbitrary but
				mappings should normally be allocated starting
				with 1.  The mapping is automatically enabled
				when first defined.

	gim_writecolormap	(Optional).  Define the pixel value to RGB
				color assignments for the image pixels.

	gim_writepixels		This routine is called one or more times to
				write pixels into raster 1.  At most 32K
				pixels (minus a bit for the GKI headers) can
				be written in each call.  As each write is
				made the affected region of the display
				window will be updated.

Alternatively, one could write the pixels and then define the mapping, to
cause the entire image to be displayed at once.

Note that the GIM calls can be combined with normal GIO graphics to draw text
and graphics around or on top of an image region.  The order in which drawing
operations occur is important, e.g., to draw graphics or text on top of an
image the image should be drawn first.

October 4, 2004

These routines represent an extension to the imio header routines manipulation.
Most of them have a new parameter which is the FITS header comment field. 
The routine names have changed slighly to avoid collision and to have some 
meaning; e.g. the ending 'c' for comment.

There are a couple of new routines to handle only comments.

Nelson Zarate


imakbc.x:# IMAKBC -- Add a new field to the image header and initialize to the value
imakdc.x:# IMAKDC -- Add a new field to the image header and initialize to the value
imakic.x:# IMAKIC -- Add a new field to the image header and initialize to the value
imaklc.x:# IMAKLC -- Add a new field to the image header and initialize to the value
imakrc.x:# IMAKRC -- Add a new field to the image header and initialize to the value
imaksc.x:# IMAKSC -- Add a new field to the image header and initialize to the value
imastrc.x:# IMASTRC -- Add a new field to the image header and initialize to the value
imgcom.x:# IMGCOM -- Get the comment field for a keyword.
impcom.x:# IMPCOM -- Change the comment field for a keyword.
impkbc.x:# IMPKBC -- Put an image header parameter of type boolean.
impkdc.x:# IMPKDDC -- Put an image header parameter of type double.
impkic.x:# IMPKIC -- Put an image header parameter of type integer.
impklc.x:# IMPKLC -- Put an image header parameter of type long integer.
impkrc.x:# IMPKRC -- Put an image header parameter of type real.
imdrmcom.x:# IMDRMCOM -- Remove the comment field for a keyword.
impksc.x:# IMPKSC -- Put an image header parameter of type short integer.
impstrc.x:# IMPSTRC -- Put an image header parameter of type string.  If the named

READ.ME

Revision date 31 May 1999                          SLALIB Version 2.3-0

-----------------------------------------------------------------------

FILES IN THE ORIGINAL SOURCE DIRECTORY (VAX)

   READ.ME           this file
   *.FOR             Fortran source (separate modules)
   *.OBS             ditto, but obsolete routines
   *.NEW             ditto, but new and not yet ready for release
   *.VAX             Fortran source for VAX/VMS
   *.CNVX            Fortran source for Convex
   *.MIPS            Fortran source for DECstation
   *.SUN4            Fortran source for Sun SPARCstation
   *.LNX             Fortran source for Linux
   *.PCM             Microsoft Fortran source for PC
   *.C               C functions needed for Linux version
   PC.BAT            rebuilds PC version
   REP.BAT           on PC, compiles one module and updates library
   CREATE.COM        complete rebuild of VAX and Unix releases
   PUT.COM           compile one module and update libraries
   VAX_TO_UNIX.USH   script to complete transfer to Unix platforms
   SLA.NEWS          NEWS item for latest release
   MAKEFILE          Unix make file
   MK                C-shell script to run make
   SUN67.TEX         document

FILES IN [.RELEASE] DIRECTORY ON VAX

   SLALIB.OLB        object library
   SLALIB.TLB        source library
   SUN67.TEX         document

FILES IN [.UNIX] DIRECTORY ON VAX

   MAKEFILE          make file for DECstation and Sun SPARC
   MK                C-shell script to run make
   SLA.A             archive file containing everything else
   VAX_TO_UNIX       script to complete transfer to Unix platforms
   SLA.NEWS          NEWS item for latest release
   SUN67.TEX         document

FILES IN (INFORMAL) FTP DIRECTORIES

   The files distributed informally through anonymous FTP may differ
   slightly in both content and name from the ones listed above.  For
   example the PC Fortran modules may be stored in archive files and
   called xxx.f_pcm rather than XXX.PCM etc.

-----------------------------------------------------------------------

DISTRIBUTION - THIS DIRECTORY

   Nothing from this directory needs to be distributed.

DISTRIBUTION - [.RELEASE] DIRECTORY

   SLALIB.*          SLALIB_DIR
   SLA.NEWS          SLALIB_DIR
   SUN67.TEX         DOCSDIR

INSTRUCTIONS FOR SAVING SPACE

   Extract from the SLALIB_DIR BACKUP save set only the file SLALIB.OLB.

-----------------------------------------------------------------------

PORTING FORTRAN SLALIB TO OTHER SYSTEMS

FORTRAN SLALIB runs on VAX (VMS), PC (Linux+f2c), PC (Microsoft FORTRAN),
Convex (ConvexOS), DECstation (Ultrix), DEC Alpha (OSF-1) and Sun
SPARCstation (SunOS and Solaris).

For most platforms, the required changes are confined to these routines:

    sla_GRESID
    sla_RANDOM
    sla_WAIT

VAX, CONVEX, DECSTATION/ALPHA, SUN & PC

Versions suitable for the above platforms are supplied in the
development directory as *.VAX, *,CNVX, *.MIPS, *.SUN4, *.PCM and
*.LNX respectively.


-----------------------------------------------------------------------

LATEST RELEASE INFORMATION

The latest release of SLALIB includes the following changes (most recent
at the end):

*  In sla_RCC, the topocentric term of coefficient 1.3184D-10 sec
   had the wrong sign.  Minus is correct.

*  The IAU decided in 1991 to rename the Terrestrial Dynamical
   Time, TDT, which is now called "Terrestrial Time" or TT.
   Appropriate changes have been made in the SLALIB documentation.
   The same IAU resolutions introduced the timescales TCG and TCB;
   there are at present no SLALIB routines to handle these new
   timescales.

*  The Keck 1 Telescope has been added to sla_OBS.

*  The handling of the random-number seed in the PC versions of
   sla_RANDOM and sla_GRESID was flawed and has been improved.

*  The UTC leap second at the end of June 1993 has been added to the
   routine sla_DAT.  Existing applications which call sla_DAT or
   sla_DTT require relinking.

*  Some unnecessary code in sla_AMPQK has been removed.

*  Minor reorganization of the sla_REFRO code has led to an improvement
   in speed of about 20%, and precautions have been taken against
   potential arithmetic errors.

*  There have been small revisions to sla_FK425 and sla_FK524.  The
   results are not significantly affected, except in the pathological
   case of large proper motion combined with immense distance, where
   sla_FK524 could produce erroneous radial velocity values.  The
   latest versions are close to the algorithms published in the 1992
   Explanatory Supplement to the Astronomical Almanac.

*  The leap second at the end of June 1994 has been added to sla_DAT.

*  THE SLA_RVLSR ROUTINE HAS BEEN RETIRED.  Its place has been taken
   by two new routines: sla_RVLSRK and sla_RVLSRD.  The original
   sla_RVLSR had used a "kinematical" LSR.  When this was later changed
   to a "dynamical" LSR for (what seemed liked good reasons at the time),
   the small differences were noticed by spectral-line radio observers,
   who had to fall back on old copies of the routine to remain consistent
   with existing practice.  The new routines provide both sorts of LSR:
   sla_RVLSRK uses a kinematical LSR and sla_RVLSRD uses the dynamical LSR.

*  The sla_PA routine (computation of parallactic angle) used an
   unnecessarily complicated formulation, which has been simplified.
   The results are unaffected.

*  The sla_ZD routine (computation of zenith distance) used a
   straightforward cosine-formula-based method, which suffered from
   decreased accuracy near the zenith.  A better, vector-derived,
   formulation has been substituted, without materially affecting
   the results.  Because sla_ZD is double precision, the old
   formulation was always adequate;  however, had anyone transcribed
   the code in single precision errors approaching 1 arcmin could
   have resulted.  The new formulation delivers good results all
   over the sky even in a single precision version.

*  Routines have been added to transform equatorial coordinates
   (HA,Dec) to horizon coordinates (Az,El) and back.  Single and
   double precision are both supported.  The routines are called
   sla_E2H, sla_DE2H, sla_H2E, sla_DH2E.

*  A new routine has been added to the tangent-plane projection set.
   The single and double precision versions are called sla_TPRD and
   sla_DTPRD respectively.  Given the RA,Dec of a star and its
   xi,eta coordinates, the routine determines the "plate centre".

*  The existing routine sla_PREC for obtaining the precession matrix
   uses the official IAU model and should continue to be used for
   canonical purposes.  A new version, called sla_PRECL, uses a
   more up-to-date model which delivers better accuracy, especially
   over intervals of millennia.

*  The routine sla_PVOBS was returning velocities in AU per sidereal
   second rather than per UT second.  This has been corrected.  The
   maximum error was equivalent to about 0.001 km/s.

*  In sla_MAPQK and sla_MAPQKZ, the area within which the gravitional
   light-deflection term is restrained has been extended from its
   original 300 arcsec radius to about 920 arcsec, just inside the
   Sun's disc.

*  A chapter of explanation, with examples, has been added to SUN/67,
   which has also undergone various cosmetic revisions.

*  There were two discrepancies between the documentation of sla_DCMPF
   (program comments and SUN/67) and the code.  The first was that the
   formulae for the nonperpendicularity used PERP instead of PERP/2;
   the documentation has been corrected.  The other was that the
   documentation showed the zero point corrections being applied first,
   whereas the code returned zero point corrections corresponding to
   being applied last.  The code has been corrected to match the
   documentation.

*  The C module slaCldj gave incorrect answers for dates during
   January and February.  The error, which did not affect the Fortran
   version, has been corrected.

*  THE CALL FOR TPRD AND DTPRD HAS BEEN CHANGED.  An integer status
   argument has been added;  non-zero means the supplied RA,Dec
   and Xi,Eta describe an impossible case.  (This can only happen
   near the pole and with non-zero Xi.)  Also, a slightly neater
   formulation has been introduced.

*  Three new routines have been added.  ALTAZ takes a star's HA,Dec
   and produces position, velocity and acceleration for azimuth,
   elevation and parallactic angle.  PDA2H predicts the HA at which
   a given azimuth will be reached.  PDQ2H does the same for
   position angle.

*  In the OBS routine, the wrong sign was returned for the Perkins
   72 inch telescope at Lowell - fixed.

*  A revised model for the equation of the equinoxes has been
   installed in EQEQX, in line with recent IAU resolutions.  The
   change amounts to less than 3 mas.

*  A bug in DFLTIN has been corrected.  A negative number following
   an E- or D-format number without intervening spaces lost its
   sign.

*  Four stations have been added to OBS:

     TAUTENBERG  Tautenberg 1.34 metre Schmidt
     PALOMAR48   Palomar 48-inch Schmidt
     UKST        UK 1.2 metre Schmidt, Siding Spring
     KISO        Kiso 1.05 metre Schmidt, Japan
     ESOSCHMIDT  ESO 1 metre Schmidt, La Silla

*  The EARTH and MOON routines could give an integer divide by zero
   for years before 1 BC.  This has been corrected.

*  CALYD (provided to support the EARTH and MOON routines) has been
   upgraded to work outside the interval 1900 March 1 to
   2100 February 28.  The status value indicating dates outside that
   range has been dropped;  a new error value for year before -4711
   has been introduced.

*  A new routine, CLYD, has been added.  It is a version of CALYD
   without the century-default feature and is to enable 1st-century
   dates to be supplied to EARTH and MOON.

*  Two new routines, PLANETS and RDPLAN, have been added, which
   compute approximate planetary ephemerides.

*  A new routine, DMOON, implements the same (Meeus) model as the
   MOON routine, but in full and in double precision.  The time
   argument is a straightforward MJD rather than MOON's year and
   day-in-year.

*  The REFRO code has been speeded up by a factor of two (and is
   also clearer).

*  REFV and REFZ have, in different ways, been made more accurate for
   cases close to the horizon.  The improvement to REFV is relatively
   modest, but REFZ is now capable of delivering useful results for
   rise/set phenomena.

*  AOPQK has been speeded up for low-elevation cases.

*  Versions of the tangent-plane routines working directly in x,y,z
   instead of spherical coordinates have been added.  They may be
   faster in some applications.  The routines are DV2TP, V2TP, DTP2V,
   TP2V, DTPXYZ, TPXYZ.

*  The coordinates of the Australia Telescope Compact Array have been
   added to OBS.  The name is 'ATCA'.

*  Despite their recent introduction THE ROUTINES DTPRD, DTPXYZ, TPRD
   AND TPXYZ HAVE BEEN WITHDRAWN.  They have been replaced by the new
   routines DTPS2C, DTPV2C, TPS2C and TPV2C.  These are functionally
   equivalent to the earlier routines but return two solutions instead
   of one:  the second solution can arise near a pole.

*  The UTC leap second at the end of 1995 has been added to sla_DAT.

*  The refraction routine REFRO has been extensively revised.  The
   principal motivation was to improve the radio predictions by
   introducing better humidity models.  The models previously in
   use had been entirely adequate for the optical case, for which
   they had been devised, but improved models were required for
   the radio case.  None of the changes significantly affects the
   optical results with respect to the earlier version of the REFRO
   routine.  For example, at 70 deg zenith distance the new version
   agrees with the old version to better than 0.05 arcsec for any
   reasonable combination of parameters.  However, the improved
   water-vapour expressions do make a significant difference in the
   radio band, at 70 deg zenith distance reaching almost 4 arcsec
   for a hot, humid, low-altitude site during a period of low pressure.

*  There was a bug in the (private) C version of RDPLAN.  The
   answers were unaffected but there could be floating-point
   problems on some platforms.

*  A new routine has been added, GMSTA.  This gives greater numerical
   precision than the existing GMST function by allowing the date and
   time to be specified separately rather than as a single MJD.

*  Measures taken in MAPQK to avoid trouble when processing Solar
   positions had not been carried through into MAPQKZ.  The two
   routines now use the same strategy.

*  In REFRO, at zenith distances well beyond 90 deg and under some
   conditions, it was possible to encounter arithmetic errors due to
   failure of the tropospheric model-atmosphere to deliver sensible
   temperatures.  This is inherent in the published algorithm.  To
   avoid the problem, the temperature delivered by the model has been
   constrained to the range 200 to 320 deg K.

*  A new routine has been added, ATMDSP, for rapidly recalculating
   the A,B refraction coefficients for different wavelengths.

*  The first UTC leap-second date in the DAT routine was one day early.
   This will have had no effect on the results for more recent epochs.

*  The C version of OBS had some problems related to character string
   handling.  A call using the "number" option retured an invalid
   station ID, and station ID and name strings of the stipulated 10
   and 40 character lengths were improperly terminated.

*  A new routine, POLMO has been added.  This is a specialist tool
   to do with Earth polar motion.

*  DC62S and CC62S could give floating point errors if vectors in
   unlikely units were supplied.  The handling of difficult cases
   has been improved.

*  Support for Linux has been added.

*  The C version of REFRO was not re-entrant.  It is now;  there has
   been a small (4%) speed penalty.

*  RANDOM, GRESID and WAIT have been dropped from the C version.  They
   could not easily be made re-entrant and posed perennial platform-
   dependency problems.

*  The value for the arcsec to radians factor in several routines
   had an incorrect (and superfluous) 19th digit, which has been
   removed.

*  There was a minor bug in DV2TP and V2TP, to do with protection
   against the special case where the tangent point is the pole.

*  In OBS, the position of the Parkes radiotelescope has been revised,
   and the ATNF Mopra observatory has been added.

*  Two new routines have been added.  PAV (single precision) and DPAV
   (double precision) are like BEAR and DBEAR but start with direction
   cosines rather than spherical coordinates - they return the position
   angle of one point with respect to the other.

*  The C version of REFRO still wasn't re-entrant, but is now.

*  The C version of DTF2D used to accept 60.0 in the seconds field;
   this has been corrected.

*  The PLANET and RDPLAN routines now include Pluto.  The ephemeris
   is accurate (sub-arcsecond) but covers the 20th and 21st centuries
   only.

   !!!  IMPORTANT NOTE  !!!

   RDPLAN used to interpret any planet number outside the range 1-8
   as meaning the Sun.  The new version uses planet number 9.  Existing
   programs using 9 for the Sun should be changed to use 0.  The rule
   has not been changed, except that the range is now 1-9 instead of
   1-8, as it is unlikely that the equivalent problem will arise in the
   future.

*  Two new routines have been added, PLANEL and PLANTE.  They are
   analogues of PLANET and RDPLAN but for the case where orbital
   elements are available.  They can be used for predicting the
   positions of asteroids and comets, and, if up-to-date osculating
   elements are supplied, more accurate positions for the major
   planets than can be provided through the PLANET and RDPLAN
   routines.

*  The REFRO routine could give inaccurate results for low temperatures
   (subzero C).  This was caused by over-cautious defensive programming,
   which prevented the tropospheric temperature falling below 200 K.

*  A new routine has been added, REFCOQ.  This calculates the coefficients
   of a two-term refraction model.  It complements the existing REFCO
   routine, being much faster at the expense of some accuracy.

*  The 1997 July 1 UTC leap second has been added to the DAT routine.

*  A bug in the C version of SVD (slaSvd) caused occasional false
   indications of ill-conditioning.  The results of least-squares
   fits do not seem to have been affected.  The Fortran version
   (sla_SVD) did not have the bug.

*  The Subaru telescope (Japanese National 8-metre telescope, Mauna Kea)
   has been added to the OBS routine.

*  The DAT routine has been extended back to the inception of UTC in
   1960.

*  The "earliest date possible" in DJCL was two days out (disagreeing
   with DJCAL, which had the correct value).

*  The GMSTA code has been improved.

*  A new routine, PV2EL, takes a heliocentric J2000 equatorial position
   and velocity and produces the equivalent set of osculating elements.

*  The 1999 January 1 UTC leap second has been added to the DAT routine.

*  Four new routines have been introduced which transform between the
   FK5 system and the ICRS (Hipparcos) system.  FK52H and H2FK5 transform
   star positions and proper motions from FK5 coordinates to Hipparcos
   coordinates and vice versa.  FK5HZ and HFK5Z do the same but for the
   case where the Hipparcos proper motions are zero.

*  Six new routines have been introduced for dealing with orbital elements.
   Four of them (sla_EL2UE, sla_PV2UE, sla_UE2EL and sla_UE2PV) provide
   applications with direct access to the "universal variables" method
   that was already being used internally.  Compared with using conventional
   (angular) elements and solving Kepler's equation, the universal variables
   approach has a number of advantages, including better handling of near-
   parabolic orbits and greater efficiency.  The remaining two routines
   (sla_PERTEL and sla_PERTUE) generate updated elements by applying
   major-planet perturbations.  The new elements can then be used to
   predict positions that are much more accurate.  For minor planets,
   sub-arcsecond accuracy over a decade is achievable.

*  Several observatory sites have been added to the OBS routine:  CFHT,
   Keck 2, Gemini North, FCRAO, IRTF and CSO.  The coordinates for all
   the Mauna Kea sites have been updated in accordance with recent aerial
   photography results made available by the Institute for Astronomy,
   University of Hawaii.

*  A coding error in DAT produced incorrect results for dates in the
   first 54 days of 1972.

-----------------------------------------------------------------------


 P.T.Wallace

 ptw@star.rl.ac.uk
 +44-1235-44-5372

LIBC (C library) include files

	error		c_erract actions
	finfo		c_finfo data structure
	fset		FIO set/stat parameter
	knames		external kernel names
	libc		must be included by all files which use libc
	spp		SPP language definitions
	stdio		UNIX standard i/o
	xnames		SPP external names
	xwhen		c_xwhen (exception handling)
	kernel		kernel constants, tables
	protect		file protection
	prtype		process types
	setjmp		non-local goto
	zfstat		FIO driver file status codes

The file "iraf.h" is referenced as <iraf.h> in IRAF C source files, and is used
to load all other IRAF/LIBC C header files via "#define import_XXX" defines in
these files.  In order for the C compiler to find <iraf.h>, one should either
[1] add the directory $hlib/libc to the list of directories to be searched by
the C compiler for include files, or [2] make a link to, or copy of,
libc/iraf.h in the system directory /usr/include.

This directory contains line lists which are used by IDENTIFY/REIDENTIFY.
There may additional applications using these lists in the future.

		       	       LINE LISTS
                  (eg coordlist = linelists$henear.dat)

      argon.dat -  Vacuum wavelengths of the infrared emission lines of argon.
                   The second column lists relative intensities.  The data 
                   are from "Wavelength Standards in the Infrared", K.N. Rao
                   et al., 1966.
 ctiohenear.dat -  HENEAR list used at CTIO
   ctiohear.dat -  HEAR list used at CTIO
       cuar.dat -  A linelist for the built-in comparison source for the KPNO
		   Hydra instrument consisting of 6 CuAr hollow cathode
		   lamps.  The identifications are from Coude Echelle
		   spectra and a list from AAO (Schinckel, Phillips, and
		   Hill). All wavelengths are from Norlen (Physica Scripta.
		   Vol 8, 249-268, 1973) except for a few CuI lines from
		   Striganov and Sventitskii (Tables of Spectral Lines of
		   Neutral and Ionized Atoms, 1968).
       fear.dat -  FeAr Hollow Cathode line list between 3,000A and 10,000A.
		   The reference for this line list is "A CCD Atlas of
		   Comparison Spectra: FeAr Hollow Cathode, 3000A - 10,000A"
		   by D. Willmarth.  The atlas is available from the
		   KPNO User Support Office.
     henear.dat -  Selected list of HENEAR lines to be used for 
		   KPNO IIDS/IRS reductions - this list is identical to 
		   that in the KPNO mountain reduction software for these 
		   instruments.  Source of wavelengths:  1982 MIT
		   Wavelength Tables Vol. 2.  Multiplet numbers from
		   Charlotte Moore's A Multiplet Table of Astrophysical
		   Interest 1972.
 henearhres.dat -  High resolution list of HENEAR lines covering the wavelength
		   range 3300A - 11,100A.  See "A CCD Atlas of Comparison
		   Spectra: He-Ne-Ar, 3300A - 11,100A" by Daryl Willmarth,
		   April 1993.
   idhenear.dat -  Extended list of HENEAR lines for general use.
		   Source of wavelengths:  1982 MIT Wavelength Tables Vol. 2.
		   Multiplet numbers from Charlotte Moore's A Multiplet Table
		   of Astrophysical Interest 1972.
    krypton.dat -  Vacuum wavelengths of the infrared emission lines of krypton.
                   The second column lists relative intensities.  The data  
                   are from "Wavelength Standards in the Infrared", K.N. Rao 
                   et al., 1966.
lowskylines.dat -  Rest (air) wavelengths of all the OH vibration-rotation
                   lines in the sky spectrum, useful for low dispersion
                   spectra - see "Sky Spectra at a Light-Polluted Site and
                   Wavelength Zero Points", Osterbrock and Martel, UCO/LO
                   Bulletin No. __ .
    ohlines.dat -  Vacuum wavelengths from calculations of Chamberlain
                   (lambda < 1.20microns) and laboratory observations of Hubbard
                   and Brault using the Solar FTS (lambda > 1.2microns).
                   The second column gives the observed intensity in kR
                   (Steed and Baker 1979, Appl. Opt., 18, 3386) of observed
                   atmospheric lines.
   skylines.dat -  Night sky lines from various sources compiled by Don
		   York.  See file header for comments.
       thar.dat -  List of thorium-argon lines (3180 - 9665),
                   A CCD Atlas of Comparison Spectra: Thorium-Argon Hollow
                   Cathode 3180 A - 9665 A, revised Feb. 1992, Daryl Willmarth.
vacidhenear.dat -  The idhenear.dat list converted to vacuum wavelengths
                   using the equation: (n-1) x 10**8 = 8342.13 + 2406030
                   (130 - sigma**2)**-1 + 15997(38.9 - sigma**2)**-1
                   where sigma = 1/lambda(air) and air at T=15C, P=760mmHg, and
		   no water vapour. (See B. Edlen, 1966
                   Metrologia, Vol. 2, p. 71).
    vacthar.dat -  The thar.dat list converted to vacuum wavelengths
                   using the equation: (n-1) x 10**8 = 8342.13 + 2406030
                   (130 - sigma**2)**-1 + 15997(38.9 - sigma**2)**-1
                   where sigma = 1/lambda(air) and air at T=15C, P=760mmHg, and
		   no water vapour. (See B. Edlen, 1966
                   Metrologia, Vol. 2, p. 71).
      xenon.dat -  Vacuum wavelengths of the infrared emission lines of xenon. 
                   The second column lists relative intensities.  The data  
                   are from "Wavelength Standards in the Infrared", K.N. Rao 
                   et al., 1966.

    thorium.dat -  Obsolete and will disappear in the future.  Use thar.dat.
 vacthorium.dat -  Obsolete and will disappear in the furture.  Use vacthar.dat.

GKI -- The graphics kernel interface.

    The GKI package is used to encode and decode the GKI instructions used to
communicate with a graphics kernel.  The kernel may be resident in the same
process, in the CL process, or in a subprocess of the CL.  Output may also
be spooled in a metafile.  The purposes of the GKI interface are to isolate GIO
from the kernel, to hide the details of packing and unpacking GKI metacode
from both GIO and the kernels, and to hide the details of the communications
protocols required to communicate with the different types of kernels.

    Before any i/o can be done on a GKI graphics stream, GKI must be informed
of the residency of the kernel associated with the stream.  Three calls are
provided for this purpose:

	    gki_redir (stream, fd, old_type, old_fd)		[1]
	   gki_inline (stream, dd)				[2]
	gki_subkernel (stream, pid, epa_prpsio)			[3]

Use [1] in the normal case of GIO talking to the CL or to a metafile.  The
first call will set, rather than redirect, the FD for a stream.  Subsequent
calls may be made to truely redirect a stream and then restore its normal
dataflow.  Use [2] when the graphics kernel is in the same process.  The
kernel must already have been opened with the driver for the kernel in the
DD array.  This is the most efficient mode of operation if a high data
bandwidth is required.  Kernel type [2] is used by GIOTR in the CL process
to communicate with external kernels.  A slightly different protocol is
required in this case since the input must be switched to the subprocess
before it can read or write the graphics stream.


			Summary Of Procedures

1. Initialize GKI

		      gki_redir (stream, fd, old_fd, old_type)
	      gki_inline_kernel (stream, dd)
		  gki_subkernel (stream, pid, prpsio_epa)


2. Metacode interpretation

     gki_fetch_next_instruction (fd, instruction)		(EOF|nwords)
		    gki_execute (gki, dd)
		      gki_write (fd, gki)


3. Instructions

		     gki_cancel (fd)
		      gki_clear (fd)
		    gki_closews (fd, device)
	       gki_deactivatews (fd)
		        gki_eof (fd)
		     gki_escape (fd, fn, instruction, nwords)
		      gki_faset (fd, ap)
		   gki_fillarea (fd, points, npts)
		      gki_flush (fd)
	       gki_getcellarray (fd, m, nx, ny, x1,y1, x2,y2)
		  gki_getcursor (fd, x, y, key, cursor)
		     gki_getwcs (fd, wcs, len_wcs)
		    gki_mftitle (fd, title)
		     gki_openws (fd, device, mode)
		      gki_plset (fd, ap)
		      gki_pmset (fd, ap)
		   gki_polyline (fd, points, npts)
		 gki_polymarker (fd, points, npts)
	       gki_putcellarray (fd, m, nx, ny, x1,y1, x2,y2)
	       gki_reactivatews (fd)
		  gki_setcursor (fd, x, y, cursor)
		     gki_setwcs (fd, wcs, len_wcs)
		       gki_text (fd, x, y, text)
		      gki_txset (fd, ap)


4. Instructions for encoding return values

	       gki_retcellarray (fd, m, np)
	     gki_retcursorvalue (fd, x, y, key, cursor)


5. Initialization of the GKIPRINT kernel

		    gkp_install (dd, out_fd, verbose_output)
		      gkp_close ()

SGIDEV -- This directory contains the UNIX dependent sources for the metacode
or bitmap translation programs for all devices supported by the SGI graphics
kernel.  See gio$sgikern or `help sgikern' for further information on SGI.

To add a new SGI device:

	[1] Add source file for translator to this directory.
	[2] Add references to mkpkg.csh and mkpkg.
	[3] Run `mkpkg update' in this directory to install new translator.

	[4] Add entry to graphcap file, including DD command string
		containing host command to dispose of the output.

	[5] Test new device interface.

Alternatively, you might wish to install the source for the translator in
local somewhere, to avoid a merge operation when a new version of the VMS
host system interface is installed.
                       
Note that some example graphcap entries for SGI devices might require non-
standard tasks residing outside of IRAF, for example the `impress300'
command to ship Impress output from a UNIX node to a VMS node running
Eunice in order to execute the VMS IMPRINT command.  These are considered
so unusual that support is not included in the standard system.

Astronomical Tools:

Precession:  These routines probably have some history even before the
    authors quoted as original sources.  They have been collected and
    some rewritten into SPP by F. Valdes (NOAO), March 1986.  PRECES.F
    was used originally in V2.3-V2.5 IRAF by George Jacoby.  It has
    been replaced by ASTPRECESS.X which is the only procedure in the
    library.

    astprecess.x -- Precession written by F. Valdes based on Astronomical
	Almanac using new IAU system.
    precessmgb.x -- Precession + aberration + nutation based on the work of
	Manchester, Gordon, and Ball
    precessgj.x -- Originally written by G. Jacoby in Fortran and distributed
	with V2.3-V2.5 IRAF.  Transcribed to SPP by F. Valdes

    Notes:
	1. The differences between ASTPRECESS.X and PRECESSGJ.X (
	   and a routine written by D. Wells for the Cyber and later
	   used in other NOAO software) are on the order of a few
	   tenths of a second of arc.  I believe the differences are
	   due to using 1984 almanac methods in the former and much
	   earlier methods for the latter.
	3. PRECESSMGB.X differs considerably from the others to the order
	   of many seconds of arc.  It does include other effects not
	   present in the other routines.  It totally fails at DEC=+-90.
	   It is based on roughly 1970 almanac methods.
	4. See PRECESS.DOC for comparison.

Radial Velocity:  These formulas for these routines were partly obtained
    by inspection of the code for the subroutine DOP in the program DOPSET
    written by R. N. Manchester and M. A. Gordon of NRAO dated January 1970.
    They have been restructured, revised, and coded in SPP by F. Valdes.

    astvr.x -- Project a velocity vector in radial velocity along line of sight.
    astvbary.x -- Radial velocity component of center of the Earth relative to
	to the barycenter of the Earth-Moon system.
    astvrotate.x -- Radial velocity component of the observer relative to
	the center of the Earth due to the Earth's rotation.
    astvorbit.x -- Radial velocity component of the observer relative to
	the center of the Earth due to the Earth's rotation.
    astvsun.x -- Projection of the sun's velocity along the given direction.

Coordinates:

    astarcsep.x -- Arc distance (arcsec) between two spherical coordinates
	(hours, degrees).
    astcoord.x -- This procedure converts the longitude-latitude coordinates
	(a1, b1) of a point on a sphere into corresponding coordinates
	(a2, b2) in a different coordinate system that is specified by
	the coordinates of its origin (ao, bo) and its north pole (ap,
	bp) in the original coordinate system.  The range of a2 will be
	from -pi to pi.
    astgalactic.x -- Convert equatorial coordinates (1950) to galactic
	coordinates.
    astgaltoeq.x -- Convert galactic coordinates to equitorial (1950).

Dates and times:

    asttimes.x:
	AST_DATE_TO_EPOCH -- Convert Gregorian date and solar mean time to
	    a Julian epoch.  A Julian epoch has 365.25 days per year and 24
	    hours per day.
	AST_EPOCH_TO_DATE -- Convert a Julian epoch to year, month, day, and
	    time.
	AST_DAY_OF_YEAR -- The day number for the given year is returned.
	AST_DAY_OF_WEEK -- Return the day of the week for the given Julian day.
	    The integer day of the week is 0=Sunday - 6=Saturday.  The
	    character string is the three character abbreviation for the day
	    of the week.  Note that the day of the week is for Greenwich
	    if the standard UT is used.
	AST_JULDAY -- Convert epoch to Julian day.
	AST_DATE_TO_JULDAY -- Convert date to Julian day.
	AST_JULDAY_TO_DATE -- Convert Julian day to date.
	AST_MST -- Mean sidereal time of the epoch at the given longitude.
	    This procedure may be used to optain Greenwich Mean Sidereal Time
	    (GMST) by setting the longitude to 0.
    asthjd.x:
	AST_HJD -- Helocentic Julian Day for a direction of observation.
	AST_JD_TO_HJD -- Helocentic Julian Day for a direction of observation.

Helocentric Parameters:

    astdsun.x:
	AST_DSUN - Distance to Sun in AU.

Misc:

    astlvac.x:
	AST_LVAC - Convert air wavelengths to vacuum wavelengths (Angstroms)

Y2K:
    Most routines work in Julian days or epochs.  If they have an input
    year it is converted to one of these forms by calling
    ast_date_to_julday.  This is the only routine that has a Y2K
    connection.  It assumes two digit years are 20th century.  These
    routines are Y2K correct.


The following are the comments and references from the DOPSET program
noted above.  The HJD routine was also derived from this code.

C     MODIFIED FOR IBM 360 BY R.N.MANCHESTER AND M.A.GORDON
C     JANUARY 1970
C
C
C  DOP CALCULATES THE VELOCITY COMPONENT OF THE OBSERVER WITH RESPECT
C  TO THE LOCAL STANDARD OF REST AS PROJECTED ONTO A LINE SPECIFIED BY T
C  ASCENSION AND DECLINATION (RAHRS, RAMIN, RASEC, DDEG, DMIN, DSEC) EPO
C  DATE, FOR A TIME SPECIFIED AS FOLLOWS:  NYR = LAST TWO DIGITS OF THE
C  (FOR 19XX A.D.), NDAY = DAY NUMBER (GMT), NHUT, NMUT, NSUT = HRS, MIN
C  (GMT).  THE LOCATION OF THE OBSERVER IS SPECIFIED BY THE LATITUDE (AL
C  LONGITUDE (OLONG) (GEODETIC) (IN DEGREES) AND ELEVATION (ELEV) (IN ME
C  ABOVE MEAN SEA LEVEL.  THE SUBROUTINE OUTPUTS THE LOCAL MEAN SIDEREAL
C  (XLST IN DAYS), THE COMPONENT OF THE SUN*S MOTION WITH RESPECT TO THE
C  STANDARD OF REST AS PROJECTED ONTO THE LINE OF SIGHT TO THE SOURCE (V
C  KM/SEC) AS WELL AS THE TOTAL VELOCITY COMPONENT V1 (KM/SEC).  POSITIV
C  VELOCITY CORRESPONDS TO INCREASING DISTANCE BETWEEN SOURCE AND OBSERV
C
C  THIS VERSION OF DOP TAKES INTO ACCOUNT COMPONENTS OF THE OBSERVER*S
C  MOTION DUE TO THE ROTATION OF THE EARTH, THE REVOLUTION OF THE EARTH-
C  BARYCENTER ABOUT THE SUN, AND THE MOTION OF THE EARTH*S CENTER ABOUT
C  EARTH-MOON BARYCENTER.  THE PERTURBATIONS OF THE EARTH*S ORBIT DUE TO
C  PLANETS ARE NEGLECTED.  THE ABSOLUTE PRECISION OF THIS VERSION OF DOP
C  ABOUT 0.004 KM/SEC, BUT SINCE THE DOMINANT ERROR TERM IS SLOWLY VARYI
C  RELATIVE ERROR WILL BE CONSIDERABLY LESS FOR TIMES UP TO A WEEK OR SO
C
C  REFERENCES:  MCRAE, D. A., WESTERHOUT, G., TABLE FOR THE REDUCTION OF
C                  VELOCITIES TO THE LOCAL STANDARD OF REST, THE OBSERVAY=2.
C                  LUND, SWEDEN, 1956.
C               SMART, W. M., TEXT-BOOK ON SPHERICAL ASTRONOMY, CAMBRIDG
C                  UNIV. PRESS, 1962.
C               THE AMERICAN EPHEMERIS AND NAUTICAL ALMANAC
C               THE SUPPLEMENT TO THE ABOVE
C
C     VERSION OF JUNE 1969

This directory ("dataio$cyber/") contains code for four Cyber tape readers:
LDUMPF, RDUMPF, RIDSOUT, RIDSFILE.  The executable file is x_cyber; the
definition file cyber.h is common to all four readers.
The subdirectory "rrcopy" contains code for the RRCOPY reader.  

These directories contain the source code for the UNIX version of the compiler
for the IRAF subset preprocessor language (SPP).  In its current implementation
the compiler consists of the following modules:

	xc.e		main program (like cc)
	xpp.e		first pass (written in Lex and C)
	rpp.e		second pass (written in ratfor)

files:
	xpp		subdirectory containing XPP
	rpp		subdirectory containing RPP
	xc.c		the XC compiler/linker

runtime files:
	lib$xc.e	installed UNIX xc compiler
	lib$xpp.e	installed first pass
	lib$rpp.e	installed second pass


This implementation of the SPP preprocessor (kludgy though it may be) should be
portable to any host computer supporting C and Fortran compilers.  A Ratfor
compiler and runtime library is no longer required.  XPP does contain some
machine dependencies in its internal tables describing the host Fortran
compiler, and these should be reviewed.  RPP has a C language interface to the
host machine which contains knowledge of how the host system permits C and
Fortran to be mixed in the same program.  Hopefully all machine dependence
has been concentrated in the two files xpp/xppcode.c and rpp/ratlibc/ratdef.h.

This version of the preprocessor no longer knows about pathnames other than
those defined in the C include file "iraf.h", which is also used by the
CL and all other C files in IRAF.  The "iraf.h" file is the only file used
by IRAF which does not reside in the IRAF directories (although a copy appears
in lib$libc and we make a symbolic link to it on our 4.2BSD UNIX system).
XC has to know the root directory of IRAF to reference important files in
iraf$lib.  The root directory may be set on the command line with the "-r"
(root) argument; if "-r ospathname" is omitted the default is the value of
IRAFDIR given in "iraf.h"

On our UNIX development system we have the executables (xc.e, xpp.e, etc.)
linked into both the source directory and the IRAF library lib$.  Hence when
any of these executables are relinked, the new versions do not have to
be installed.  If your system does not support links you will need to copy
the executable to lib$ after compilation.

IMDKERN -

This directory contains the source for the simple GIO/IMD kernel, used to
draw graphics in a display frame buffer.  It uses the data stream
interface to open the frame buffer and uses code from SGI to rasterize
the graphics.

Special graphcap entries used by this kernel:

	CI	Color index of graphics pixels
	FN	Display frame buffer
	LO	Width in pixels of line size 1.0
	LS	Difference in pixels between line sizes
	DB	Print debug messages?


Revision notes...
----------------
IMDKERN notes		20 December 1989	Z. G. Levay, STScI


  o Make private copy idskern of gio/sgikern.

  o Change "sgi" filename and procedure prefixes to "imd" throughout
    the code.  Change sgk.x to idk.x.  Changed imd_open to imd_fopen to
    aviod conflict with a procedure in libds.  The files are:

    font.com, font.h, idk.com, idk.h, idk.x, imd.com, imd.h,
    imdcancel.x, imdclear.x, imdclose.x, imdclws.x, imdcolor.x,
    imddrawch.x, imdescape.x, imdfa.x, imdfaset.x, imdflush.x,
    imdfont.x, imdfopen.x, imdgcell.x, imdinit.x, imdipl.x,
    imdkern.par, imdline.x, imdopenws.x, imdpcell.x, imdpl.x,
    imdplset.x, imdpm.x, imdpmset.x, imdreset.x, imdtx.x, imdtxset.x,
    ltype.dat, mkpkg, t_imdkern.x, x_imdkern.x,

  o Modify mkpkg to build the task locally without updating the system
    library or install the task.

  o Add global parameters "frame" and "color" to task imdkern.
    Modified imd_fopen to read task parameters and pass as arguments to
    imd_openws.  Added these parameters to imd_openws and the call to
    idk_open.

  o In idk_open, added frame and color to the calling sequence.  Added
    a call to imd_mapframe to open the frame buffer as an image,
    changed setting the bitmap size to use the frame buffer size (via
    IMIO) instead of graphcap parameters.  Set the bits per bitmap word
    to 8.  Set the maximum bitmap size to 2048x2048 pixels.  Ripped out
    the code for opening the SGI metacode file, DD string manipulation,
    etc.  Added ttygeti calls to read the frame and color from the
    graphcap in case they were passed as INDEF.

    In idk_frame, changed the code to map an input and output section
    of the frame buffer (via IMIO), read the bitmap line by line,
    testing each word for any on bits, and writing the color index
    value to the frame buffer pixel for each on bitmap bit.  Set the
    I/O buffer sizes to 64 lines (somewhat arbitrarily).

    In idk_open, Changed the code to compute the x and y max (right and
    top edges) of the bitmap by one pixel to draw to the edge.  In
    idk_linewidth, changed the code to compute the gap at the frame
    edges by one pixel.

    Removed sections of code dealing with non-bitmap format, rotated or
    flipped bitmaps.


----------------
Installation and checkout.  (12/21/89 dct)

Installed code in gio/imdkern.
Put hooks for new task IMDKERN in the PLOT package.
Moved imdkern.par to plot, moved frame,color params to after "generic".
Deleted file imdipl.x, identical to imdpl.x.
Renamed imdfopen.x to imdopen.x for consistency with other kernels;
    changed procedure name to imd_opendev to avoid name collision with imdopen.
Deleted idk.h, contains only SGI metecode defs not used in idk.x.
In t_imdkern.x, moved the clgeti's for color,frame to after the clgeti for
    "generic" (required by startup protocol for graphics subkernel).  For the
    generic case, added initializers to set values to -1 to flag not set.
    Got rid of the IS_INDEFs in idk.x.  Nothing wrong with these, I just try
    to avoid using INDEF in low level system code.
mkpkg - link xx_imdkern.e, not x_imdkern.e, rename in the install (this is
    necessary to permit local testing of new versions, else the installed BIN
    version is used).

This directory contains both Fortran and IRAF preprocessor programs
demonstrating the use of the Lawson-Hanson llsq procedures.  The Fortran
programs have not been modified to reflect the removal of Fortran i/o
from the library procedures as installed in the IRAF llsq.a library.

WTAR -- Write a tar format file or tape.  This is a portable, non-UNIX, non-
	proprietary program for writing tar format files on a variety of
	systems.  The TAR format is an excellent choice for transporting
	files between different machines because of its simplicity, efficiency,
	and machine independence.


wtar [-tvdo] [-f tarfile] [files]

	-t	print names of files as they are written
	-v	verbose output
	-d	debug mode
	-o	omit binary files
	-f fn	write to file FN (stdout, mt[ab..], binary file)
	[files]	files or directories to be written to tar file


Output may be to a disk file, a magtape device, or to the standard output
(on some systems).  Text files may be padded with extra blanks at the end on
some systems, due to lack of knowledge of the precise file length when the
file header is written.

This directory contains the source for GIOTR and cursor mode, i.e., the code
required to process the graphics output of a graphics task, spooling and/or
applying the workstation transformation and passing the transformed metacode
instructions on to the builtin STDGRAPH kernel or to an external kernel.  The
procedure RCURSOR is the main entry point for cursor mode.  RCURSOR is called
by the CL to service a query for a cursor type parameter when query mode is
in effect.  The workstation transformation is used to zoom and pan on a frame
buffer and consists of a viewport transformation in GKI coordinates with
clipping at the viewport boundary.

gio$stdgraph

    This directory contains the source and executables for the STDGRAPH and
GKIDECODE graphics kernels.  The two kernels are implemented both as libraries
and as executable tasks.

	gkidecode	This kernel is used standalone to examine GKI
			metafiles.  The real work is done by the GKIPRINT
			library module in the GIO package.

	stdgraph	A graphics kernel for graphics terminals.  Implemented
			both as the library "libstdg.a" and as the kernel task
			STDGRAPH.  The library is required for this kernel to
			permit inclusion of the stdgraph kernel in the CL
			process.

Both kernels are available as CL callable tasks in the executable file
x_kernel.e.


GKIPRINT -- Graphics kernel for decoding metacode.  This graphics kernel
formats metacode instructions into readable form and prints them on the output
file.  The gkiprint kernel is useful for examining metafiles and for
debugging kernels which drive specific devices.  The driver consists of the
following procedures:

	     gkp_openws (devname, n, mode)
	    gkp_closews (devname, n)
	    gkp_mftitle (title, n)			**
	      gkp_clear (dummy)
	     gkp_cancel (dummy)
	      gkp_flush (dummy)
	   gkp_polyline (p, npts)
	 gkp_polymarker (p, npts)
	       gkp_text (x, y, text, n)
	   gkp_fillarea (p, npts)
       gkp_getcellarray (m, nx, ny, x1,y1, x2,y2)
       gkp_putcellarray (m, nx, ny, x1,y1, x2,y2)
	  gkp_setcursor (x, y, cursor)
	      gkp_plset (gki)
	      gkp_pmset (gki)
	      gkp_txset (gki)
	      gkp_faset (gki)
	  gkp_getcursor (cursor)
	     gkp_escape (fn, instruction, nwords)	**
	     gkp_setwcs (wcs, nwords)			**
	     gkp_getwcs (wcs, nwords)			**
	    gkp_unknown (gki)				**

A GKI driven device driver may implement any subset of these procedures.
The starred procedures should be omitted by most drivers.  In particular,
the SETWCS and GETWCS instructions are internal instructions which should
be ignored by ordinary device drivers.  The procedure names may be anything,
but the arguments lists must be as shown.  All coordinates are in GKI units,
0 to 32767.  Character strings are passed in ASCII, one character per metacode
word.  Whenever a GKI character string appears as an array argument in the
argument list of a procedure, the count N of the number of characters in the
string follows as the next argument.  GKI character strings are not EOS
delimited.  Polyline, polymarker, and fillarea data is passed as an array
of (x,y) points P, in GKI coordinates, defining the polyline or polygon to
be plotted.

One additional procedure, GKP_INSTALL, is called by the main program of the
graphics kernel task to install the debugging driver, i.e., to fill the DD
array with the entry point addresses of the driver procedures.  For a normal
driver this function is performed by a user supplied procedure named
GKOPEN (graphics kernel open).  The user supplied kernel procedures will
be called to execute each instruction as the instructions are decoded by the
main routine.  The user supplied procedure GKCLOSE will be called when
interpretation ends and the task is about to exit.

		 gkopen (dd)
		gkclose ()

Do not confuse GKOPEN and GKCLOSE, which open and close the graphics kernel,
with GKI_OPENWS and GKI_CLOSEWS, the metacode instructions used to direct
an opened kernel to open and close workstations.

GKS - This directory contains code for a partial implementation of the Fortran
binding of GKS level OA.  The GKS functions are layered upon GIO.  The functions
provided are:

	gacwk	---	activate workstation
	gca	---	output (integer) cell array
	gcas	---	output (short) cell array
	gclks	---	close GKS
	gclrwk	---	clear workstation
	gclwk	---	close workstation
	gdawk	---	deactivate workstation
	gfa	---	fill area
	gopks	---	open GKS
	gopwk	---	open workstation
	gpl	---	polyline
	gpm	---	polymarker
	gqasf	---	query aspect source flag
	gqchh	---	query character height
	gqchup	---	query character up vector
	gqcntn	---	query current transformation number
	gqnt	---	query normalization transformation (window and viewport)
	gqopwk	---	query open workstations
	gqplci	---	query polyline color index
	gqpmi   ---     query polymarker index
	gqtxal	---	query text alignment
	gqtxci	---	query text color index
	gqtxp	---	query text path
	gqwks	---	query workstation state
	qsasf	--- 	query aspect source flag
	gschh	---	set character height
	gschup	---	set character up vector
	gscr    ---     set color representation
	gselnt	---	set normalization transformation
	gsfaci  ---     set fill area color index
	gsfais	---	set fill area interior style
	gslwsc  ---     set line width scale factor
	gsmk	---	set marker type
	gsplci	---	set polyline color index
	gspmci	---	set polymarker color index
	gspmi   ---     set polymarker index
	gstxal	---	set text alignment
	gstxci	---	set text color index
	gstxp	---	set text path
	gsvp	---	set viewport
	gswn	---	set window
	gtx	---	text (gtx.f, gxgtx.x)

Two functions were added 8Sep86:
	gsclip	---	set clipping flag
	gqclip	---	query clipping flag

RMFILES -- Descend a directory tree, removing or listing all the specified
	files therein.  This is similar to the RMBIN utility, except that
	it is not limited to removing binary files.  This task is used to
	strip production versions of the system down to the essentials.

                  The Photometry Tools Package
                 -------------------------------

The ptools package contains routines which perform oerations on the
text database files and/or ST binary tables files produced by the APPHOT
and DAOPHOT packages, and scripts which make the fact that any given database
is a table or a text file transparent to the user.

The ptools directory structure is listed below. The .h files are all in lib 
as many of them are shared by several tasks.

             |-pconvert------routines to the pconvert task
             |-doc-----------ptools documentation
|-ptools-----|-lib-----------ptools definitions or .h files
	     |-pexamine------routines specific to the pexamine task
             |-ptutils-------routines specific to miscellneous utility tasks
	     |-txtools-------routines specific to the text file operators
	     |-test----------directory of test data


Lindsey Davis
NOAO IRAF GROUP
August 1991

			Image Kernel Interface (IKI)
				Doug Tody
			       08 May 1986


1. INTRODUCTION

    The IKI is the interface between IMIO and some particular image storage
format.  IMIO itself has no knowledge of the storage format.  The primary
function of the IKI is to access image headers, mapping the host header
storage format into the IMIO image header descriptor and vice versa.
The IKI is responsible for all image management operations, including
opening/creating/updating headers, opening/creating pixfiles (pixel storage
files), deleting, renaming, and copying images, checking for the existence
of images, and so on.

The IKI can support an arbitrary number of different storage formats.
Each format requires a set of format dependent driver subroutines implementing
the standard IKI functions.  The IKI will dynamically select the driver to be
used to access a particular format at runtime.  New drivers may be dynamically
loaded at runtime, in a way similar to that used for FIO.  While IMIO directly
accesses the pixel storage file via binary FIO for efficiency reasons, the
pixfile is opened by the IKI driver, hence a special driver may be used if
desired.  For example, this feature may be used to access image display frame
as a pixfile, or an image stored in archival format on an optical disk.


2. STRUCTURE

    The role played by the IKI and format specific IKI drivers in the image
i/o subsystem is illustrated in the figure below.


	       IMIO		Format independent; primarily does i/o to
	         | 		the pixel file.  The image header is read
		 |		into a dynamically allocated descriptor at
		 |		open time.
		 |
		IKI		Selects driver to be used.  Maintains table
		 |		of open images, handles cleanup during error
		 |		recovery.
		 |
	     (drivers)		Physically accesses/creates/deletes etc. an
				image stored in a particular format.  Maps
				the header stored in some particular external
				format into the standardized IMIO descriptor.
				Responsible for opening/creating the pixfile,
				returning a FIO file descriptor to IMIO, which
				directly accesses the pixel data.


The format specific driver packages are written in SPP using only standard
VOS i/o facilities, e.g., FIO and MEMIO.  This is necessary due to the use
of an SPP descriptor structure to maintain the incore version of the image
header, due to the need to return an FIO file descriptor to IMIO, and so on.
To add support for a new format, one need only add a new driver to the IKI
and relink the system.


3. LOGICAL SCHEMA

    The logical schema of the current IKI is highly constrained by the fact
that the IKI is an add-on to the existing IMIO interface.  It is not worthwhile
in this revision to try to address the limitations/design flaws of the initial
IMIO interface, hence our intention is to add the IKI in such a way that few
changes are required to IMIO, and no changes are required to programs which
use IMIO.  One or two further major revisions are planned before the final
interface is realized.  The concept of the IKI is here to stay, but the current
interface attempts only to address the immediate need to support multiple
image formats with the least impact on current software.

An image consists of a header and a pixel array stored in a random access
binary file.  Images may be grouped together into an array or "cluster" of
images, with the individual images being accessed by a one indexed subscript
appended to the cluster name, e.g., "pix[3]" refers to image 3 of the cluster
"pix".  To create a cluster containing more than one image a / followed by
the cluster size may be included in the cluster index, e.g., "pix[3/10]" to
create a cluster of 10 images and write into image 3.  An image section may
optionally be appended to access some subset of the pixels in the image, e.g.,
"pix[3][*,5]".  Lastly, if the image is stored as a disk file, the filename
extension of the header file may be given to explicitly indicate the image
format (IKI driver) to be used to access the image.

A full specification (referencing an existing image) might therefore be
"pix.hhh[3][*,5]", where the ".hhh" extension indicates that the cluster is
physically stored in an SDAS GEIS (group format) data structure, the "[3]"
indicates image 3, and the "[*,5]" is a conventional IMIO image section.
If the minimal specification "pix" were given, the IKI would determine that
"pix" was a GEIS format image, accessing the entire contents of image [1].
As an aside, note that image sections are handled entirely by IMIO and are
not seen at the IKI level.  Likewise, the cluster subscript is parsed by
IMIO and passed to the IKI as an integer argument.


	IM_PIXTYPE	int		pixel type (usilrdx)
	IM_NDIM		int		number of axes (0:7)
	IM_LEN		long[7]		logical length of each axis (>=1)
	IM_PHYSLEN	long[7]		physical length of each axis (>=1)
	IM_CLINDEX	int		index of image in cluster
	IM_CLSIZE	int		number of images in cluster
	IM_PIXOFF	long		char file offset to the pixels
	IM_CTIME	long		image creation time
	IM_MTIME	long		most recent image modification time
	IM_LIMTIME	long		time when max/min last updated
	IM_MAX		real		maximum pixel value
	IM_MIN		real		minimum pixel value
	IM_PIXFILE	char*80		pathname of pixel file (optional)
	IM_TITLE	char*80		image title string


The important fields of the IMIO image descriptor are summarized above, along
with their datatype and length in the case of arrays.  This is from the original
IMIO design and has not been modified in any way, except for the addition of the
cluster fields to the runtime descriptor.  The IKI drivers directly read and
write these fields in the image descriptor.

In addition to these standard fields (for which the IKI driver must supply
reasonable values at open time) the image descriptor contains a "user area"
containing an arbitrary sequence of keyword=value parameters encoded in
FITS character format.  The FITS cards are trimmed at the right and
concatenated into an EOS delimited string with newline characters delimiting
each card.  All host format specific header parameters should be passed to
IMIO in the user area.  In the case of group format images, the user area
will contain both the group parameters (parameters shared by the entire group
of images) and the group header parameters (parameters for the individual
image in the group specified at open time).  IMIO makes no distinction
between the two types of parameters.  All header parameters are available
to the high level applications code via the IMIO/IDBI interface.


4. IKI INTERFACE PROCEDURES

    The IMIO code calls only the IKI procedures and has no knowledge of the
IKI drivers, or of which driver has been connected to a particular image
descriptor.  The high level IKI procedures are summarized below.  The interface
is fairly small due to the use of the descriptor to maintain all information
describing the image, and due to the fact that IMIO directly accesses the
pixel data via FIO.


	       iki_open (im, image, group, gcount, acmode, o_im)
	      iki_close (im)
	       iki_opix (im)			# open/create pixfile
	     iki_updhdr (im)			# update image header

	       iki_copy (oldname, newname)	# fast copy of entire group
	     iki_delete (group)			# delete entire group
	     iki_rename (oldname, newname)	# rename entire group

         k = iki_access (image, acmode)		# test existence, legal extn
	   iki_lddriver (open,close,		# install new driver
			 opix,updhdr, access,copy,delete,rename)


The OPEN procedure opens or creates the indicated image in the named cluster.
In the case of a new image or new copy image, only the header is created by
the open call; the pixfile is not created until the OPIX routine is called,
allowing the high level code time to set the image dimensions, datatype,
number of groups, etc., in the image descriptor.  Once OPIX has been called
to create a new group, the number of axes, size of each axis, pixel type,
etc. is fixed.

In the case of image stored in the SDAS/GEIS group format, all of the images
in a cluster (group) must be of the same size, must have the same header
parameters, and the header parameters must be defined when the group is
created (new parameters or images cannot be added to the group later).
The first open call for a image will allocate space for all images in the
cluster, but only the indicated image will be initialized in the first call.
Multiple images may be simultaneously open in the same cluster, and the same
image may be multiply opened on independent logical FIO file descriptors.

The high level IRAF software has little or no knowledge of the physical
association of images into clusters.  In particular, the high level software
is ignorant about the SDAS/GEIS image storage format, but this need not
prevent processing of these images.  The main limitations of the group
format derive from the fact that new images can neither be added to nor
deleted from to a group format cluster, and new parameters cannot be added
to a group header.  To create a group format image via IMIO, one will normally
make a NEW_COPY copy of an existing group format image (to define the fields
of the group headers), specifing the number of images in the new group in
the cluster size field of the image name specification.  For example, writing
to the new image "pix[3/10]" will cause a cluster of 10 images to be created
and image 3 to be initialized.  Subsequent calls to write to either "pix[I]"
or "pix[I/10]" will be necessary to initialize the remaining images in the
cluster.


5. KERNEL PROCEDURES

    Each supported image format requires a dedicated set of kernel procedures
to be called by the IKI to access images stored in that format.  The calling
sequences for these procedures are shown below.


               xxx_open (im, root, extn, cl_index, cl_size, acmode, status)
              xxx_close (im, status)
               xxx_opix (im, status)
             xxx_updhdr (im, status)

             xxx_access (root, extn, acmode, status)
               xxx_copy (old_root, old_extn, new_root, new_extn, status)
             xxx_delete (root, extn, status)
             xxx_rename (old_root, old_extn, new_root, new_extn, status)


Here, the package prefix "xxx" is OIF for the old IRAF image format, and STF
for the STScI/SDAS GEIS format.  Note that the OPEN procedure fills in selected
fields in a preallocated image descriptor rather than allocating the descriptor
itself.  Image names are parsed into root, extension, cl_index, etc. fields by
the IKI or higher level code, to further simplify the kernel code.  The IKI
verifies the existence or nonexistence of all operand images before calling
a kernel procedure, hence the kernel procedures need not perform these
functions.  The kernel procedures should return an ERR status if they cannot
perform their function for some reason (rather than take an error action).
The locpr() entry point addresses of the kernel procedures are saved in a
runtime table maintained by the IKI.

The syntax and semantics of the kernel procedures are discussed in detail below.
Since the interface routines have full access to the IMIO descriptors, it is
important to realize what does and does not have to be set.


5.1 IMAGE OPEN PRIMITIVE

include	<imhdr.h>
include	<imio.h>
include	"xxx.h"

# XXX_OPEN -- Open/create an image.

procedure oif_open (im, root, extn, cl_index, cl_size, acmode, status)

pointer	im			# image descriptor (allocated by IMIO)
char	root[ARB]		# root image name
char	extn[ARB]		# extension, if any
int	cl_index		# index of image to be opened
int	cl_size			# number of images in cluster
int	acmode			# access mode
int	status			# return status (OK|ERR)

begin
	1.  Construct the filename of the header file and open or create the
	    image header file.

	2.  If opening an existing image, read the image header and fill in
	    the following fields of the IMIO image header descriptor.  If
	    creating a new image set only the field IM_HDRFILE.

	    IM_PIXTYPE		# datatype of the pixels		**
	    IM_NDIM		# number of dimensions			**
	    IM_LEN		# length of the dimensions		**

	    IM_CTIME		# time of image creation
	    IM_MTIME		# time of last modify
	    IM_LIMTIME		# time min,max computed
	    IM_MAX		# max pixel value
	    IM_MIN		# min pixel value
	    IM_PIXFILE		# name of pixel storage file
	    IM_HDRFILE		# name of header storage file
	    IM_TITLE		# image name string
	    IM_HISTORY		# history comment string

	    The really essential fields are marked with a ** at the right.
	    CTIME, PIXFILE, HDRFILE, TITLE, and HISTORY are for information
	    only.  MTIME and LIMTIME are used to determine if the min/max
	    pixel values are up to date, and the actual values do not matter
	    provided the conclusion about the min/max values is correct.

	3.  If opening an existing image, call IMIO to set those fields of the
	    image header/descriptor describing the format in which the pixels
	    are stored in the pixel storage file.

		[] call imioff (im, pixoff, COMPRESS, blklen)

	    where
		    pixoff	FIO file offset of first pixel.
		    compress	Set to NO to enable alignment of image
				  lines on block boundaries, to YES for
				  compressed byte stream image.
		    blklen	Device block size, chars.  Set to 1 to
				  defeat all block alignment.

	    If opening a new image, this step may be left until the OPIX
	    primitive is called.

	3.  If the kernel procedures use their own internal descriptor,
	    allocate and initialize the descriptor and save a pointer to
	    it in IM_KDES(im).

	4.  Set return status.
end


5.2  OPEN PIXEL FILE PRIMITIVE

include	<imhdr.h>
include	<imio.h>
include	"xxx.h"

# XXX_OPIX -- Open (or create) the pixel storage file.  Call IMIO to set the
# file offsets and buffer sizes. 

procedure xxx_opix (im, status)

pointer	im				# image descriptor
int	status				# return status

begin
	1.  Opening existing image:
	    1.1 Open pixel file read only or read write.

	2.  Opening (creating) new image:
	    2.1 Call IMIO to set the offset parameters, assuming this was not
		already done in the OPEN primitive:

		    [] call imioff (im, pixoff, COMPRESS, blklen)

	    2.2 Using the file size computed by imioff or determined by more
		format specific means, open (falloc) the pixel storage file.
		The IM_HGMOFF field of the image header is set by imioff
		to the file offset of the end of the image.

	3.  Call IMIO to set the i/o buffer parameters:

		    [] call imsetbuf (pfd, im)

	    This sets the FIO buffer size and the IM_FAST parameter.
	    The buffer size should be set before doing any i/o on the
	    pixel file.  If in doubt, skip the call and simply set
	    IM_FAST(im) = NO (i/o will be suboptimal but not too bad).

	4.  Save the pixfile FIO file descriptor (required for pixel i/o)
	    in the image descriptor:

		    [] IM_PFD(im) = pfd
end


5.3  UPDATE HEADER PRIMITIVE

include	<imhdr.h>
include	<imio.h>

# XXX_UPDHDR -- Update the image header.

procedure xxx_updhdr (im, status)

pointer	im			# image descriptor
int	status			# return status

begin	
	1.  Update the values of the standard logical image header fields
	    in the physical image header, e.g., PIXTYPE, NDIM, LEN, and CTIME
	    (for new images), MTIME, LIMTIME, MIN, MAX (any image).

	2.  Save the "user fields" in the physical image header.  Some of
	    these may have been inserted in the user area by the kernel open
	    procedure, others may have been added by IRAF programs or by
	    the user since the image was opened.
end


5.4  CLOSE IMAGE PRIMITIVE

include <imio.h>

# XXX_CLOSE -- Close an image.

procedure xxx_close (im, status)

pointer	im			# image descriptor
int	status

begin
	1.  If the pixel file has been opened, close it.  Note that if no
	    pixel i/o was done to the image, the pixel file will never have
	    been opened.

	2.  If the header file is still open, close it.

	3.  If a special kernel descriptor was allocated at image open time
	    by the kernel, deallocate it.
end

		    Enhanced Image List Template Package

			     April 15, 2011


    The enhanced image list package provides new capabilities for handling
image lists, but remains backwards compatible with tasks currently using
the IMT interface.  The enhancements allow for expansion of MEF files into
lists of extensions using the @-file operator, as well as selection of
images within more general lists by means of modifiers (e.g. a simple
expression such as the extname/extver or explicit extension number, or more
complex boolean expressions to allow selection by header keyword). In
addition, tables may now take the @-file operator to use a column
containing image references as an input list.


========================================================================
TODO:  
    - Describe syntax for use with tables and selection by row values
    - Describe remote image specification caching mechanism
========================================================================



Template Strings
----------------

The FNT template package supports the following forms of pattern strings:

    alpha, *.x, data* // .pix, [a-m]*, @list_file, nite%1%2%.1024.imh

i.e. simple filenames, wildcard expansion in filenames, concatenation of
filenames, @files, substitution in filenames, or a comma-delimited list of
the above.  The image template package (IMT) extends these patterns to
allow image names followed by a cluster index or image section in []
brackets.  These patterns remain unchanged in the new version of the
package to allow backward compatability with existing applications. Lists
of these types represent *explicit* collections of images, i.e. a
collection based on the image name (wildcards) or as a result of processing
by some task (e.g. expansion of an MEF file to create an input @-file of
expanded extension specifications).

    The enhanced version of the IMT package further abstracts the concept
of image collections to include data objects such as MEF files or tables
containing a list of image references that *implicitly* defines the list
(e.g. the expanded MEF extension specification or the complete column of
image references).  Further, we allow this list (which might be quite
broad) to be refined using modifiers or selectors on the list and thus
dynamically create the list without requiring the use (and management) of
intermediate files.  For example,


  @file*			expand all files beginning w/ 'file'
  @file//".fits"		append ".fits" to contents of 'file'

  @mef.fits			expand all (image) extensions of an MEF file
  @mef.fits[SCI]		select SCI extensions from MEF file
  @mef.fits[SCI,2][noinherit]	select v2 SCI extns, add kernel param
  @mef.fits[1-16x2]		select range of extensions from MEF file
  @mef.fits[+1-8]		create a list of extensions for an MEF

  *.fits[1:100,1:100]		append section to all FITS images
  @@file[1:100,1:100]		append section to expanded MEFs in 'file'

  *.fits[filter?='V']		select images w/ FILTER keyword containing 'V'
  @*.fits[gain<3.0]		select image extns where GAIN keyword < 3.0
  *.fits[filter?='V';gain<2.0]	select using multiple OR's expressions


Template Syntax
---------------

    The previous syntax and behavior of image templates is unchanged in
this version, new functionality is provided by (optional) new syntax now
supported in the template pattern string.  Briefly,

    - wildcard filename expansion may now be applied to @-files

    - the use of an '@' operator is now permitted on MEF files.  By 
      default, all image extensions in the file will be included in the 
      list, modifiers may be used to select specific extensions or to
      indicate a range of extensions to be used.

    - the use of an '@@' operator to indicate expansion of the contents 
      of an @-file.  For example, an @-file of MEF image names can be
      expanded to list of all the file extensions using "@@file", whereas
      just using "@file" would list the names of the MEF files as before.

    - modifier expressions enclosed in square brackets may be appended
      to an image template string (or @-file) to either constrain the 
      list (e.g. only a range of MEF extensions, only images with a certain
      keyword value, etc) or to append extra information to the image
      specification (e.g. to add an image section to all images in the
      list).  Multiple modifier expressions may be used 


    The allowed syntax for a template string can be described roughly in
the following way:


  [@@ | @]  <file>  [extname] 	    [<expr>;...]  [<ikparams>] [<section>]
  [@@ | @]  <file>  [extname,extver][<expr>;...]  [<ikparams>] [<section>]
  [@@ | @]  <file>  [index_range]   [<expr>;...]  [<ikparams>] [<section>]
 
		    <-------- selectors ------->  <------ modifiers ----->

    The <file> specification may be the name of a file, and image, or a
table.  The behavior of the @-file and @@-file operators will depend on
the type of <file> but the @-file usage remains backward compatible when
used with text files.

    The use of a modifier/selection on an MEF file will automatically
trigger expansion of the extensions in the image and so an '@' operator is
not strictly required, however only those extensions matching the selection
expression will be present in the final image list.  Note that the use of 
index ranges and extname/extver selectors are mutually exclusive, selector
expressions may be added to either.


@-file Operations
-----------------

    The @-file operator is unchanged from previous versions when used with
text files of image names.  Modifier/selector expressions however can now
be applied to the contents of the @-file to select from the list only those
images that match the selector expression, or to augment the name in the 
list with an additional image syntax such as a section or kernel parameters.


@@-file Operations
------------------

    The @@-file operator is new syntax meant to allow the contents of an 
@-file to be expanded automaticaly, e.g. as if there were an @-file of
@-file names.  Primarily this can be used to create a list of MEF image
names in which an @-file would return the names of the MEF, while the
@@-file syntax could be used to expand each MEF into individual extension
specifications.


Extension Indices
-----------------

    The [index_range] modifier may be used to specify an explicit set of
extensions to be used.  Index ranges are specified as a comma-delimited
list of strings specifying individual range segments as described in the
RANGES help page.

    The use of a '+' operator before an index range indicates the range
list should be expanded without checking that the extension exists in the
MEF itself.  Otherwise, only those extensions present in the MEF will be
included in the list.


Selection Expressions
---------------------

    Selection expressions may be used to restrict a template list to only
those images that match some boolean expression, e.g. to provide for 
selection based on a header keyword value.  Expressions follow the same
guidelines as in the HSELECT task 'expr' parameter (see the help page
for details).  Multiple expressions may be specified if they are separated
by a semicolon however they are evaluated as a single expression of
OR'd values rather than as individual expressions.  This is significant
when considering that expressions may contain keywords not present in 
all images being checked, for instance

	*.fits[filter?='V';gain<3.0]

would evaluate as if the expression had been written

	(filter?='V' || gain < 3.0)

If a particular image lacks either the 'filter' or 'gain' keyword the
entire expression will evaluate to false because of an error even if one
of the two clauses would otherwise have been true.  

[NOTE:  This behavior will be changed in a future version.]



Image Sections
--------------
    Image sections may be added to an image specification by adding a
separate modifier string.  The section will be added once selection of
the list by the selector expressions is complete.  An example of where
this might be used is in automatically specifying the bias section for
all images in a list, e.g.

    @mef.fits[1:128,*]			all extensions in the image
    @mef.fits[1-16x2][1:128,*]		only 'left' amplifiers of a mosaic
    @mef.fits[2-16x2][1024:1128,*]	only 'right' amplifiers of a mosaic
    m31*.fits[345:528,200:300]		same section in all registered images

No check is made that the image section is valid for the given image.


Kernel Parameters
-----------------

    A comma-delimited list of image kernel parameters may be added to any 
image specification by adding the keywords to a separate modifier.  For 
example,
		@mef.fits[1-8][noinherit,padline=30]

would expand the file 'mef.fits' to include extensions 1 thru 8 and add the
kernel parameters, generating a list such as

		mef.fits[1][noinherit,padline=30]
		mef.fits[2][noinherit,padline=30]
		    :    :      :         :
		mef.fits[8][noinherit,padline=30]

No check is made to verify that the image kernel keywords are appropriate
for the image type.  Supplying an incorrect kernel parameter will likely
result in the task throwing an error when opening the image.



--------------------------------------------------------------------------------

Appendix 1:  Examples

   file
   file*
   @file
   @file*

   @file[2]				extension
   @file[SCI]				extname
   @file[SCI,2]				extname+extver

   @file[2][noinherit]			extension + ikiparams
   @file[SCI][noinherit]		extname + ikiparams
   @file[SCI,2][noinherit]		extname+extver + ikiparams

   @file[2][1:20,2:30]			extension + section
   @file[SCI][1:20,2:30]		extname + section
   @file[SCI,2][1:20,2:30]		extname+extver + section

   @file[2][noinherit][1:20,2:30]	extension + ikiparams + section
   @file[SCI][noinherit][1:20,2:30]	extname + ikiparams + section
   @file[SCI,2][noinherit][1:20,2:30]	extname+extver + ikiparams + section

   @file[noinherit]			ikiparams
   @file[noinherit][1:123,2:234]	ikiparams + sections

   @file[1:123,2:234]			sections

   @file[1:123,2:234]			sections

   mef*.fits[filter?='V']		selection expression
   mef*.fits[filter?='V';filter?='B']	selection expressions (OR)
   mef*.fits[filter?='V'||filter?='B']	selection expressions (OR)
   mef*.fits[gain>0.5&&gain<2.0]	selection expressions (AND)

	Expressions will evaluate to 'false' if there is an error such as
	"keyword not found", meaning that no images will match when one or
	more keywords may not be present.  Best to use a comma-delimited list
	in this case.

 Concatenation

   @file // foo				append
   @file* // foo			append wildcards
   @file // [2]				append modifiers

   foo // @file				prepend
   foo // @file*			prepend wildcards
   foo // @file[2]			prepend modifiers

   Prior Behavior:

	foo // bar.fits			==> foobar.fits
	foo.fits // bar			==> foobar.fits

	foo // @file1			==> foosif1.fits,foomef1.fits
	@file1 // bar			==> sif1foo.fits,mef1foo.fits

                      THE INLFIT PACKAGE

This subdirectory contains the routines of the interactive non-linear
least squares fitting package INLFIT. This package is layered on the NLFIT
package in MATH. NLFIT uses the Levenberg-Marquardt method to solve for
the parameters of a user specified non-linear equation. The user must supply
two routines. The first routine evaluates the function in terms of its
parameters. The second routine evaluates the function and its derivatives
in terms of its parameters. The user must also supply initial guesses for
the parameters and parameter increments, the list of parameters to be
varied during the fitting process, a fitting tolerance, and the maximum
number of iterations.

The entry points into the INLFIT package are listed below.

	  ininit - Initialize the fitting routines
	   inget - Get the value of an INLFIT parameter
	   input - Store the value of an INLFIT parameter
	  ingkey - Get the value of an INLFIT graphics/axis parameter
	  inpkey - Store the value of an INLFIT graphics/axis parameter
	   infit - Fit the function non-interactively
	  ingfit - Fit the function interactively
	inerrors - Compute the errors of the fit
	  infree - Free memory allocated by ininit

The calling sequences for the above routines are listed below. The [iprd]
stand for integer, pointer, real and double precision versions of each
routine respectively. [str] stands for string.

               in_init[rd] (in, address(func), address(dfunc), param, dparam,
	               nparams, plist, nfparams)
  [irdp]val = in_get[irdp] (in, param)
                   in_gstr (in, params, str, maxch)
              in_put[irdp] (in, param, val)
                   in_pstr (in, param, str)
                   in_gkey (in, key, axis, type, varnum)
                   in_pkey (in, key, axis, type, varnum)
               in_fit[rd]  (in, nl, x, y, wts, npts, nvars, wtflag, stat)
               ing_fit[rd] (in, gp, cursor, gt, nl, x, y, wts, names, npts,
	                     nvars, len_names, wtflag, stat)
             in_errors[rd] (in, nl, x, y, wts, npts, nvars, variance,
	                    chisqr, scatter, rms, errors)
               in_free[rd] (in)


The user supplied functions fnc and dfnc have the following calling
sequences.

	fnc (x, nvars, nparams, nparams, zfit)
       dfnc (x, nvars, params, dparams, nparams, zfit, derivs)

The addresses of the user supplied functions can be obtained with a call
to locpr as follows.

        address = locpr (fnc)

The user definition for the INLFIT package can be found in the file 
lib$pkg/inlfit.h and can be made available to user applications programs
with the statement "include <pkg/inlfit.h>".

The permitted values for the param argument are the following.

# Integer valued parameters (in_geti, in_puti)

define	INLFUNCTION		# Fitting function
define	INLDERIVATIVE		# Fitting function derivatives
define	INLNPARAMS		# Total number of parameters
define	INLNFPARAMS		# Number of fitting parameters
define	INLNVARS		# Number of variables
define	INLNPTS			# Number of variables
define	INLMAXITER		# Max. number of iterations
define	INLNREJECT		# Number of rejection iterations
define	INLNREJPTS		# Number of rejected points
define	INLUAXES		# User plot function
define	INLUCOLON		# User colon function
define	INLUFIT			# User fit function
define	INLOVERPLOT		# Overplot next plot ?
define	INLPLOTFIT		# Overplot fit ?
define	INLFITERROR		# Error fit code
define	INLGKEY			# Graph key


# Real/double valued parameters (in_get[rd], in_put[rd])

define	INLTOLERANCE		# Tolerance of convergence
define	INLLOW			# Low rejection value
define	INLHIGH			# High rejection value
define	INLGROW			# Rejection growing radius


# Pointer valued parameters (in_getp, in_getp)

define	INLNL			# NLFIT descriptor
define	INLPARAM		# Parameter vector
define	INLDPARAM		# Parameter change vector
define	INLPLIST		# Parameter list
define	INLREJPTS		# Rejected points
define	INLXMIN			# Minimum value for curve
define	INLXMAX			# Maximum value for curve
define	INLSFLOAT		# Floating point substructure
define	INLSGAXES		# Graphics substructure


# String valued parameters (in_gstr, in_pstr)

define	INLLABELS		# standard axis labels
define	INLUNITS		# standard axis units
define	INLFLABELS		# Function labels
define	INLFUNITS		# Function units
define	INLPLABELS		# Parameter labels
define	INLPUNITS		# Parameter units
define	INLVLABELS		# Variable labels
define	INLVUNITS		# Variable units
define	INLUSERLABELS		# User plot labels
define	INLUSERUNITS		# User plot units
define	INLHELP			# Help file name
define	INLPROMPT		# Help prompt


The permitted values for the key argument are the following.

# in_gkey, in_pkey

define	KEY_FUNCTION		# Function
define	KEY_FIT			# Fit
define	KEY_RESIDUALS		# Residuals
define	KEY_RATIO		# Ratio
define	KEY_NONLINEAR		# Non-linear part
define	KEY_VARIABLE		# Variable (user or default)
define	KEY_UAXIS		# User plot function
define	KEY_MIN			# Min. key type
define	KEY_MAX			# Max. key type

The permitted values for the axis argument are the following.

# in_gkey, in_pkey

define	INLXAXIS		# X axis
define	INLYAXIS		# Y axis


The permitted values of the weights flag argument wtflag input to
in_fit[rd] or in_gfit[rd], and the stat argument returned by in_fit[rd]
or in_gfit[rd] are defined in lib$math/nlfit.h. They can be included in
the user's application with the statement "include <math/nlfit.h>".
The values are listed below.

# Permitted values for wtflag

define	WTS_USER		# User supplied weights
define	WTS_UNIFORM		# Uniform weighting
define	WTS_CHISQ		# Chi-squared weighting
define	WTS_SCATTER		# Weights include computed scatter term

# Permitted values for stat

define	DONE			# Solution converged
define	SINGULAR		# Singular solution
define	NO_DEG_FREEDOM		# Too few points
define	NOT_DONE		# Solution did not converge.

Note the pointer to the NLFIT structure nl is returned by the in_fit[rd]
and in_gfit[rd] routines and input to the in_errors[rd] routine. This
pointer must be freed separately with a call to nl_free when the fitting
process terminates.

SCOMBINE -- Combine spectra

This routine is based in large part on IMCOMBINE.  The routines in the
generic directory are identical to those in that task except that they
only contain routines for real data.  The ic routines in this directory
are similar though modified from IMCOMBINE.

The iscombine files are for an interactive combine task based on work
by CTIO.  Because it is limited currently to linear spectra and is not
organized to take advantage of the IMCOMBINE options it is not installed.
A version of this may someday be added based on the current software.


=======

This version was renamed to OSCOMBINE.  It is obsolete and may be removed
at some future time.  (4/14/04, Valdes)

SGIKERN -

This directory contains the source for the simple GIO kernel, used to write
a metacode file using only the simplest possible drawing instructions.  This
makes it relatively easy to implement functional (but probably suboptimal)
translators for new devices.

Special graphcap entries used by this kernel:

	MF		maximum frame count per metafile
	FS		frame advance req'd at start of metafile
	FE		frame advance req'd at end of metafile

 2328 Sep 11 14:53 cfitsio.install  info about installing CFITSIO
 5988 Apr 20  1999 calls.doc        user-callable table I/O routines
 3328 Jul 30  1997 ex.x             a complete example
 3579 Jul 30  1997 example.doc      example
 4463 Aug 17  1999 fileformat.doc   description of stsdas table file format
  582 Jul 30  1997 tbtcpy.lis       info about tbtcpy
11898 Aug 17  1999 text_tables.doc  info about text tables
 1605 Aug 17  1999 versions.doc     changes to stsdas table format
 2654 Jul 30  1997 Notes            not up to date
 2858 Jul 30  1997 descrip.doc      not up to date

GIO Calcomp kernel

This directory contains source for the IRAF calcomp graphics kernel.
Specifications may be found in ccpspecs.hlp.  Installation involves
building the kernel task, which is accomplished using "make" (Makefile)
with argument "install" to move the executable into lib$.

In addition to the kernel task routines, the vttest.x routine contains code 
to simulate calcomp software on standard gio graphics devices.  vttest.x
contains all the source for the simulation, using parameter file vttest.par.
Here, the calcomp routines "plot", "plots", "newpen", and "symbol" are
replaced with appropriate gio calls (violating interfaces) and to be used
mainly for testing text fonts, line type and width simulation.

TODO:

- super-bold font
- bold + italic

- multiples of dash, dot for linetypes numbered higher than 4

--------------------------------------------------------------------------------
FUTURE ENHANCEMENTS (much work):

1)  Sophisticated parallel-tracing algorithm that looks at entire array
    and merges intersections so that all adjacent segments are parallel
    to each other and do not cross the acute bisector.  Implemented by
    parallel array segments rather than drawing each parallel segment
    individually, to avoid pen overtravel on short choppy lines.

2)  Panelling: when plot width exceeds available paper width, wrap graphics
    to beyond maximum x so that paper can be cut and pasted.

3)  Versatec extension with area-fill.

Directory gio$ncarutil, with subdirectories conlib, autograph and sysint, 
contains the source code for the GKS based NCAR plotting utilities library.
The first public release of this software was installed in IRAF 10SEP86.
(The 3 previous installations of the NCAR Utilities were the result of NOAO
serving as a Beta release test site.)  What follows is the Notes files from
the installation :

******************************************************************************
Notes for installation of the NCAR GKS based plotting utilities.  This
release marks the end of NCAR's beta testing and is the first public release
of the new software.  The changes made at NOAO have been merged into the
new source code; these changes have are marked with "+/- NOAO."  The IRAF
installed NCAR library differs from the version released on tape as documented
below.  Installation was begun September 2, 1986.  (S. Hammond)

Subdirectory AUTOGRAPH --

autograph/agback.f:
    Calls blockdata agdflt as run time subroutine.
autograph/agcurv.f:
    Calls blockdata agdflt as run time subroutine.
autograph/agdflt.f:
    This is the block data, which has been completely rewritten as
    initialization statements instead of data statements.
autograph/agexax.f:
    A ftn write statement has been commented out.
autograph/agppid.f:
    A string is written with f77upk/pstr instead of a ftn write statement.
autograph/agrstr.f:
    Binary read, completely commented out.
autograph/agsave.f:
    Binary write (opposite of agrstr.f), completely commented out.
autograph/agscan.f:
    Calls blockdata agdflt as run time subroutine.
    A ftn write statement has been commented out.
autograph/agsetp.f:
    Calls blockdata agdflt as run time subroutine.
autograph/agstup.f:
    Calls blockdata agdflt as run time subroutine.
autograph/ezmxy.f, ezmy.f, ezxy.f, ezy.f:
    These four subroutines require identical changes:
	Call blockdata agdflt as run time subroutine upon entering;
	Call subroutine initag before returning.
autograph/idiot.f:
    Call blockdata adgflt as run time subroutine.
    Call plotit and initut to reinitialize before returning.
autograph/pstr.x:
    This file is not on the distribution tape, it was written to
    output strings that have been unpacked by f77upk.

Subdirectory CONLIB --

conlib/conecd.f:
    Character variables IT and CHTMP are not used and so are commented out.
    The FTN internal writes are rewritten as calls to encode.
conlib/congen.f:
    FTN internal write replaced with call to encode.
conlib/conop1.f,conop2.f,conop3.f,conop4.f:
    These four routines now call blockdata conbdn as run time initialization.
conlib/conout.f, conot2.f:
    Both these routines are no-ops in IRAF.  All statements have been commented
    out.
conlib/conpdv.f:
    FTN internal write replaced with a call to encode.
conlib/conssd.f:
    FTN write and format statement commented out.
conlib/contng.f:
    FTN internal writes rewritten as calls to encode.


Directory NCARUTIL --

conran.f:
    Changed values of iabove, ibelow and ibel2 to improve label placement.
    Blockdata condbn rewritten as run time initialization. (conbdn.f)
    Internal writes rewritten as calls to encode.

conrec.f:
    Value of NCRT changed from 4 to 2.
    The contour plot labelling has been improved, with the titles being
    centered in the current viewport, and the large spaces between
    fields eliminated.  This change involves:
	1. common block noaolb added; also used in spp calling routine.
	2. Values of LNGTHS array modified.
	3. Character*25 variable string[5] added.
	4. Default plot position is centered on current viewport.
    All internal writes have been replaced with calls to encode.
    Error message concerning "overflow in STLINE" is now written only
        to stderr, not to stdgraph as well.
    EZCNTR no longer calls frame.
    Block data CONBD deleted from conrec.f source, rewritten as conbd.f

dashsmth.f:
    In two places, the blockdata DASHBD is called as an initializing subroutine.
    Subroutines kurv1s and kurv2s are used for both the dashsmth and
    isosrf utilities.  The code is duplicated in the two fortran files.  I
    have put it in a separate file (kurv.f) and deleted it from both original
    locations.

gridal.f:
    In two places, blockdata GRIDT is called as an initializing subroutine.
    All internal FTN writes changed to calls to encode.
    FTN write and format statements for error reporting deleted - used seter.
    Blockdata deleted from gridal.f; rewritten in gridt.f.

hafton.f:
    Blockdata hfinit rewritten and called as run time initializing subroutine.
    One internal write rewritten as call to encode.
    Call to FRAME removed from EZHFTN.

isosrf.f:
    Call to FRAME removed from EZISOS
    Blockdata isosrb was rewritten as run time initialization isosrb.f
    Source for subroutines kurv1s and kurv2s has been deleted from isosrf.f.
    (It is shared with the dashsmth utility, and has been moved to kurv.f.)

pwrity.f:
    Blockdata PWRYBD rewritten as subroutine.
    FTN writes and format statements commented out.

pwrzs.f:
    Common block noaovp added, so user can control viewport.  Calls to
    plotit and set had to be changed because they assumed the full
    viewport [1-1024] was being used for srface plots.

srface.f:
    Because user changes viewport when labelling is selected, mods had
    to be made.  Common block noaovp has been added, and calls to set
    and plotit no longer assume the full viewport [1-1024] is being used.
    Blockdata SRFABD has been rewritten as a run time initialization.

strmln.f:
    The value of uvmsg changed from 1.0E+36 to 1.0E+16 in an attempt
    to make this routine run on a VAX.

threed.f:
    Blockdata threbd rewritten as run time initialization.
    Subroutine pwrz completely commented out.

velvct.f:
    Blockdata veldat rewritten as run time initialization.
    FTN internal write rewritten as call to encode.


Subdirectory SYSINT (system interface) --

sysint/support.f:
    1. The character size calculated by WTSTR is doubled to be readable
       with the IRAF font.
    2. Subroutines SETER and E9RIN both used FTN write statements to
       output information.  This is now handled by passing the error 
       message to ULIBER, where the string gets unpacked with f77upk
       and written to stderr.
    3. Blockdata UERRBD was rewritten as a run time initialization.
    4. Block data UTILBD was rewritten as a run time initialization.
       A logical flag (first) was added to insure that the internal
       parameters were initialized only once per load; subroutine
       utilbd can be called at several points.  An entry point 'utinit'
       was added to reset the 'first' flag to true.
    5. In an attempt to mimic the organization of the release tape, file
       support.f contains the following fortran subroutines: 
       SUBROUTINE ENCD (VALU,ASH,IOUT,NC,IOFFD)
       SUBROUTINE ENCODE (NCHARS, FTNFMT, FTNOUT, RVAL)
       SUBROUTINE ENTSR(IROLD,IRNEW)
       SUBROUTINE RETSR(IROLD)
       SUBROUTINE ERROF
       SUBROUTINE SETER(MESSG,NERR,IOPT)
       SUBROUTINE EPRIN
       SUBROUTINE E9RIN(MESSG,NERR,SAVE)
       SUBROUTINE FDUM
       SUBROUTINE Q8QST4(NAME,LBRARY,ENTRY,VRSION)
       INTEGER FUNCTION NERRO(NERR)
       INTEGER FUNCTION I8SAV(ISW,IVALUE,SET)
       SUBROUTINE WTSTR (PX,PY,CH,IS,IO,IC)
       subroutine uerrbd
       subroutine uliber (errcode, pkerrmsg, msglen)

sysint/spps.f:
    1. Subroutine FLUSH has been renamed MCFLSH because of a name conflict.
    2. FRAME calls initut to initialize the 'first' flag in utilbd.
    3. Subroutines OPNGKS and CLSGKS have been commented out.
    4. In PLOTIT and PLOTIF the block data utilbd is called as a run time 
       initialization subroutine.

****************************************************************************

gio$ncarutil/conrec.f Dec 23, 1986 S. Hammond
        Moved the call to gsplci that set up major contours.  This
    statement was not being executed until after the first major line
    had been drawn, resulting in the first major line not being bold.


***************************************************************************
On June 1, 1987 the following copywright notice was inserted into all 
FORTRAN files in the ncarutil directory tree.  

C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
February 12, 1988.  During Steve Rooke's port of IRAF to the HP RISC computer
several Fortran errors were caught by the HP compiler.  These have been
fixed as shown:
sys/gio/ncarutil/conbdn.f
    The data statement at line 244 had not been commented out.  It is now.

June 10, 1988.  Made a mod to conbd.f (and in the comments to conrec.f) that
resets the point at which contour decides an image aspect ratio is "extreme".
Previously if the image axes ratio exceeded 1:4 the contour plot was square.
This limit was too restrictive and has been changed to 1:16.  See related 
change in pkg$plot.vport.x.  

NETwork interface.  08Oct85 dct
------------------------------------

This directory contains the network interface software required to support the
ZFIOKS FIO driver (for the kernel interface) in a TCP/IP environment.  The only
facilities required are those already provided by the IRAF kernel (i.e., to
read the host name table, a text file), plus the standard TCP network functions
provided by any system that supports TCP/IP.  The interface is self contained,
requiring only the host TCP/IP facilities and the file "uhosts" in iraf$dev,
used to map host names to network addresses (see gethostbyname).  The code
supplied here is coded for Berkeley UNIX and works fine, but a much simpler
Berkeley UNIX dependent version of ZFIOKS is what is actually used on a
Berkeley host.

The networking interface is not required to run IRAF and the contents of this
directory may be ignored if the IRAF system is to be configured without
networking.  On a system configured without networking the entry points of the
ZFIOKS driver must be present but may be stubbed out.  Additional information
on configuration details is given in the discussion of the kernel interface,
e.g., in sys$ki.


STRUCTURE

    The structure of the network interface software is as follows:


	 ZFIOKS		FIO device driver for the kernel server (in ..)
	   |
	 REXEC		remote execution of a shell command
	   |
	TCP_xxx		encapsulation of TCP interface
	   |
     (host TCP/IP)	host networking facilities


This software is machine dependent but is designed to be reusable, i.e., the
machine dependence has been isolated into simple procedures and definitions
whenever possible.  On a Berkeley UNIX system the TCP procedures map directly
into the system services of 4.2 Berkeley UNIX (and no doubt later versions as
well).  On a VMS system running EUNICE the TCP procedures map easily into
QIOW type device driver calls; EUNICE implements the TCP facilties in the
network device driver.  Similar mappings should be possible on other systems
with TCP/IP support.


TCP INTERFACE

    The TCP interface package consists of the following procedures.  On a
Berkeley UNIX system these TCP functions map directly into calls to the UNIX
system services.


	tcp_gethostbyname	get internet code for a host by name
	tcp_getsockname		get socket name

	tcp_socket		create and bind a socket (client or server)
	tcp_connect		connect to a socket (client)
	tcp_listen		listen for connections on a socket (server)
	tcp_accept		accept a connection (server)
	tcp_read		read from a socket (synchronous)
	tcp_write		write to a socket (synchronous)
	tcp_close		close a socket (client or server)


The usual sequence of calls used by a client process to connect to and
communicate with a server process is the following.


	gethostbyname;involves scan of hostname table

	make a socket
	connect to the socket
		(connect returns when the server has accepted the connection)
	read & write data packets
		(etc.)
	close the socket


A server does much the same thing, except that the server will listen() for
connections by client processes, accept() a connection when one occurs, and
then begin exchanging packets with the client.

------------------------------------
NOTE -- This directory contains software which is adapted from the Berkeley UNIX
networking software, hence a UNIX source license is required to use this
software.  Nonetheless, about 90% of the source herein is new; at some point
the remainder (only 100-200 lines) should be rewritten from scratch to eliminate
the proprietary restrictions.  This was not done initially since the network
interface is not expected to be included in the standard distribution.

ASTUTIL.PDM -- This directory contains the sources for the PDM program.

PDM finds periods in light curve data by a method called
Phase Dispersion Minimization.

Reference:

Stellingwerf, R. F., 1978, "Period Determination by Phase Dispersion
    Minimization", The Astrophysical Journal, 224, pp. 953-960.

These directories contain tasks for working with tables.  The various
subdirectories and the tasks that they contain are as follows:

copyone		keypar, keytab, parkey, partab, tabkey, tabpar
doc		help files
gtedit		gtedit
keyselect	keyselect
lib		subroutines used by more than one task
tcalc		tcalc
tchcol		tchcol
tchsize		tchsize
tcopy		tcopy, tdelete
tcreate		tcreate
tdiffer		tdiffer
tedit		tedit, tread
texpand		texpand
thedit		thedit, thselect
tinfo		tinfo, tlcol
tintegrate	tintegrate
tjoin		tjoin
tlinear		tlinear 
tmerge		tmerge 
tprint		tdump, tprint
tproduct	tproduct
tproject	tproject
tquery		tquery
trebin		trebin
tselect		tselect
tsort		tsort
tstat		thistogram, tstat
tunits		tunits
tupar		tupar

The VOLumes package is a possibly temporary collection of tasks related to
manipulating and viewing 3d or in some cases 4d "volume" images, and a few
other things.

IMJOIN joins sets of N-dimensional images together along a specified axis.
IM3DTRAN performs 3d image transposes; if appropriate [*,-*,*] type image
sections are given as input, it also accomplishes rotates.  Tasks such as
these may later be integrated into a standard IRAF package.

PVOL projects through volume images, casting rays onto a set of output
2d images distributed along a great circle around the volume image.  When
the output images are displayed or recorded onto video and played back,
the volume image appears to rotate.  Various translucency and opacity 
algorithms are employed.

I2SUN is a temporary task for converting IRAF images into Sun rasterfiles,
primarily to take advantage of a Sun-specific MOVIE utility for viewing
digital movies on a workstation screen; it will no longer be necessary when 
the IRAF image display servers can display movies.

# Not currently distributed:
#VIDRECORD is an NOAO-specific IRAF script that is used to display successive
#images from template or datacube on a display device connected to a recorder.
#The recorder is assumed to be connected via rs-232 to a port on some IRAF node.
#Other sites may wish to modify the associated host-level task that sends the
#device-control commands to the rs-232 port.

.help xyacc
.nf
This directory contains the source for the Yacc compiler compiler as modified
to produce SPP language parsers.  This version of XYACC is based on code
obtained from the OpenSolaris project and distributed under the Common
Development and Distribution License (CDDL), considered to be a 'free'
license.  All parsers in the system will be regenerated using this new
version of XYACC, all vestiges of the original XYACC code have been
removed.

Notes regarding the changes required for SPP from the original README
file are included below.

Mike Fitzpatrick 
1/25/2011


------------------------------------------------------------------------------

    For the most part, the operation of SPP/Yacc is as described in the 
Yacc reference manual, with the important differences noted below.  A 
complete working example of a desk calculator program may be found in 
the subdirectory debug, file dc.y.

Notes on SPP Yacc

    (1)	The Yacc input syntax is unmodified, except that the comment convention
	is now as in SPP, rather than C (i.e., use #, rather than /*..*/).
	All defines, actions, etc. are of course given in the SPP language.

    (2)	The Yacc output file is "ytab.x", rather than "y.tab.c".  The token
	defs file "y.tab.h" now contains SPP defines, rather than C #defines.
	The states file "y.output" is completely unmodified.

    (3)	The global declarations section %{ .. %} had to be changed somewhat
	because SPP does not have global variables.  The section is now
	divided into two subsections.  The first is for global defines,
	includes, etc. which go into the header area of the ytab.x file.
	Then follows a %L, telling Yacc that the local declarations for
	the parser procedure follow.  This second section should contain
	variable and function declarations required for the user supplied
	actions (code fragments to be executed when a rule of the grammar
	is recognized) in the yyparse procedure.

    (4)	The global declarations section MUST contain the following two
	defines:

		YYMAXDEPTH	Depth of the parser stacks; determines
				the maximum complexity of a language
				construct which can be parsed.  A typical
				value is 150.

		YYOPLEN		The length, in struct units, of a token
				operand value structure.  You define the
				operand structure to be whatever you wish;
				all the parser needs to know is how big an
				element is.  The lexical analyzer and the
				actions, both of which are supplied by the
				user, use the operand structure for
				communications.  Operand structures are
				always referred to by a Mem pointer.

    (5)	The calling sequence for the parser is as follows

		status = yyparse (fd, debug, yylex)

	where
		status is OK, EOF, or ERR (syntax error)
		fd is the text stream to be parsed
		debug is a boolean, true to print debugging info
		yylex is the user supplied lexical analysis procedure.

	The calling sequence for the lexical analysis procedure is as
	follows (the name "yylex" may be anything):

		token = yylex (fd, yylval)

	where
		Token is the integer code for the token.  The tokens are
		    named in the Yacc grammar, and are defined either by
		    the user or by Yacc in the header area of ytab.x.
		    If Yacc is permitted to assign codes to tokens, the
		    token defininitions file ytab.h is written out.
		fd is the file to be read
		yylval is a POINTER to the token value structure to be
		    returned by yylex.

    (6)	The SPP version of Yacc, unlike the C version, does not use any
	external or global variables for communication between routines,
	and hence it is possible for several distinct parsers to coexist
	in the same image.  If this is done, the user supplied yylex
	procedures should be named something else, and the name of the
	parser procedure (yyparse) should be changed.  This can be done
	by putting a "define yyparse" in the global definitions area.

    (7)	Token values (i.e., $$, $1, $2, yyval, yylval, etc.) are always
	pointers to structures in the SPP version, as opposed to structures
	in the C version.  Thus actions like

		{ $$ = $1; }

	which are common in the C version, are programmed like this in SPP:

		{ YYMOVE ($1, $$) }
	
	where YYMOVE is a Yacc supplied macro which copies an operand
	structure.

    (8)	The source for the language independent part of the parser is given
	in "lib$yaccpar.x".

Doug Tody, 21 Feb 84.
20Jan85:
	y.tab.x -> ytab.x (etc), added EOF token
20Apr85:
	lib$yaccpar.x, deleted entry points for examining parser stack and
	other context state variables.

The onedstds$ directory contains standard calibration data for extinction and
sensitivity calibration as used in the ONEDSPEC, TWODSPEC, and the various
IMRED packages.


                            EXTINCTION TABLES
                (eg extinction = onedstds$kpnoextinct.dat)

ctioextinct.dat -  CTIO extinction table for ONEDSPEC (in Angstroms)
    The CTIO extinction curve distributed with IRAF comes from the work of
    Stone & Baldwin (1983 MN 204, 347) and Baldwin & Stone (1984 MN 206,
    241).  The first of these papers lists the points from 3200-8370A while
    the second extended the flux calibration from 6056 to 10870A but the
    derived extinction curve was not given in the paper.  The IRAF table
    follows SB83 out to 6436, the redder points presumably come from BS84
    with averages used in the overlap region.

    More recent CTIO extinction curves are shown as Figures in Hamuy 
    et al (92, PASP 104, 533 ; 94 PASP 106, 566).

    Steve Heathcote, Mon, 19 Jul 1999


kpnoextinct.dat -  KPNO extinction table for ONEDSPEC (in Angstroms)

                              MISCELLANEOUS

           ctio -  Directory containing CTIO decker comb positions and
                   neutral density filter curves (used with NDPREP).

                           FLUX STANDARD DIRECTORIES
                        (eg caldir = onedstds$iidscal/)

      blackbody -  Directory for using blackbody flux distributions in
		   various magnitude bands.
       bstdscal -  Directory of the brighter KPNO IRS standards (i.e. those 
                   with HR numbers) at 29 bandpasses, data from various
                   sources transformed to the Hayes and Latham system,
                   unpublished.
        ctiocal -  Directory containing fluxes for the southern tertiary
                   standards as published by Baldwin & Stone, 1984, MNRAS,
                   206, 241 and Stone and Baldwin, 1983, MNRAS, 204, 347.
     ctionewcal -  Directory containing fluxes at 50A steps in the blue range
                   3300-7550A for the tertiary standards of Baldwin and
                   Stone derived from the revised calibration of Hamuy et
                   al., 1992, PASP, 104, 533.  This directory also contains
                   the fluxes of the tertiaries in the red (6050-10000A) at
                   50A steps as will be published in PASP (Hamuy et al
                   1994).  The combined fluxes are obtained by gray
                   shifting the blue fluxes to match the red fluxes in the
                   overlap region of 6500A-7500A and averaging the red and
                   blue fluxes in the overlap.  The separate red and blue
                   fluxes may be selected by following the star name with
                   "red" or "blue"; i.e. CD 32 blue.
        iidscal -  Directory of the KPNO IIDS standards at 29 bandpasses,
                   data from various sources transformed to the Hayes and 
                   Latham system, unpublished.
         irscal -  Directory of the KPNO IRS standards at 78 bandpasses,
                   data from various sources transformed to the Hayes and  
                   Latham system, unpublished (note that in this directory the 
                   brighter standards have no values - the `bstdscal' directory
                   must be used for these standards at this time).
        oke1990 -  Directory of spectrophotometric standards observed for use 
                   with the HST, Table VII, Oke 1990, AJ, 99. 1621 (no 
                   correction was applied).  An arbitrary 1A bandpass
                   is specified for these smoothed and interpolated
                   flux "points".  Users may copy and modify these files
                   for other bandpasses.
         redcal -  Directory of standard stars with flux data beyond 8370A.
                   These stars are from the IRS or the IIDS directory but
                   have data extending as far out into the red as the
                   literature permits.  Data from various sources.   
   spechayescal -  The KPNO spectrophotometric standards at the Hayes flux
                   points, Table IV, Spectrophotometric Standards, Massey
                   et al., 1988, ApJ 328, p. 315.
      spec16cal -  Directory containing fluxes at 16A steps in the blue
                   range 3300-7550A for the secondary standards, published
                   in Hamuy et al., 1992, PASP, 104, 533.  This directory
                   also contains the fluxes of the secondaries in the red
                   (6020-10300A) at 16A steps as will be published in PASP
                   (Hamuy et al 1994).  The combined fluxes are obtained by
                   gray shifting the blue fluxes to match the red fluxes in
                   the overlap region of 6500A-7500A and averaging the blue
                   and red fluxes in the overlap.  The separate red and
                   blue fluxes may be selected by following the star name
                   with "red" or "blue"; i.e. HR 1544 blue.
      spec50cal -  The KPNO spectrophotometric standards at 50 A intervals.
                   The data are from (1) Table V, Spectrophotometric Standards,
                   Massey et al., 1988, ApJ 328, p. 315 and (2) Table 3, The
                   Kitt Peak Spectrophotometric Standards: Extension to 1
                   micron, Massey and Gronwall, 1990, ApJ 358, p. 344.


                       STANDARD STAR MENUS

--------------------------------------------------------------------------------
Blackbody calibrations in onedstds$blackbody/

U    B    V    R    I   J   H   K   L   Lprime    M

Magnitude conversions are available between V, J, H, K, L, Lprime, and M
but for U, B, R, and I the star magnitudes must be in the same bandpass.
--------------------------------------------------------------------------------
Standard stars in onedstds$bstdscal/

hr718        hr3454       hr3982       hr4468       hr4534
hr5191       hr5511       hr7001       hr7596       hr7950
hr8634       hr9087       hd15318      hd74280      hd100889
hd188350     hd198001     hd214923     hd224926

--------------------------------------------------------------------------------
Standard stars in onedstds$ctiocal/

bd25            eg139           feige56         l2415           l93080
bd73632         eg149           feige98         l2511           l97030
bd8             eg158           g16350          l3218           lds235
cd32            eg248           g2631           l3864           lds749
eg11            eg274           g9937           l4364           ltt4099
eg21            f15             h600            l4816           ltt8702
eg26            f25             hz2             l6248           ross627
eg31            f56             hz4             l7379           w1346
eg54            f98             hz15            l7987           w485a
eg63            f110            kopf27          l8702           wolf1346
eg76            feige110        l377            l9239           wolf485a
eg79            feige15         l1020           l9491
eg99            feige25         l1788           l74546

--------------------------------------------------------------------------------
Standard stars in onedstds$ctionewcal/:

Combined red and blue 3300A-10000A:

cd32            f56             l2415           l4364           l7987    
eg21            h600            l3218           l4816           l9239    
eg274           l1020           l377            l6248           l9491    
f110            l1788           l3864           l7379           l745    

Blue 3300A-7550A:

cd32blue        f56blue         l2415blue       l4364blue       l7987blue    
eg21blue        h600blue        l3218blue       l4816blue       l9239blue    
eg274blue       l1020blue       l377blue        l6248blue       l9491blue    
f110blue        l1788blue       l3864blue       l7379blue    

Red 6050A-10000A:

cd32red         f56red          l2415red        l4364red        l7987red    
eg21red         h600red         l3218red        l4816red        l9239red    
eg274red        l1020red        l377red         l6248red        l9491red    
f110red         l1788red        l3864red        l7379red        l745red    

--------------------------------------------------------------------------------
Standard stars in onedstds$iidscal/

40erib       eg50         eg149        g16350       hz4          lds235b
amcvn        eg54         eg158        g191b2b      hz7          lds749b
bd253941     eg63         eg162        g2610        hz14         lft1655
bd284211     eg67         eg182        g2631        hz15         lp414101
bd332642     eg71         eg184        g4718        hz29         ltt13002
bd404032     eg76         eg193        g88          hz43         ltt16294
bd73632      eg77         eg247        g9937        hz44         ltt4099
bd7781       eg79         eg248        gd128        kopff27      ltt8702
bd82015      eg91         feige15      gd140        l13633       ross627
eg11         eg98         feige24      gd190        l140349      ross640
eg20         eg99         feige25      gh7112       l14094       sa29130
eg26         eg102        feige34      grw705824    l151234b     sao131065
eg28         eg119        feige56      grw708247    l74546a      ton573
eg29         eg129        feige92      grw738031    l8702        wolf1346
eg31         eg139        feige98      he3          l93080       wolf485a
eg33         eg144        feige110     hiltner102   l97030       
eg39         eg145        g12627       hiltner600   lb1240       
eg42         eg148        g14563       hz2          lb227        

--------------------------------------------------------------------------------
Standard stars in onedstds$irscal/

bd082015     eg50         feige34      hd117880     hd60778      hr7001
bd174708     eg71         feige56      hd161817     hd74721      hz44
bd253941     eg139        feige92      hd17520      hd84937      kopff27
bd262606     eg158        feige98      hd192281     hd86986      wolf1346
bd284211     eg247        feige110     hd19445      he3          
bd332642     feige15      g191b2b      hd217086     hiltner102   
bd404032     feige25      hd109995     hd2857       hiltner600   

--------------------------------------------------------------------------------
Standard stars in onedstds$oke1990/

bd284211  feige110  feige67   g191b2b   g249      gd248     ltt9491   eg71
bd75325   feige34   g13831    g19374    gd108     hz21      eg158     eg247

--------------------------------------------------------------------------------
Standard stars in onedstds$redcal/

40erib     eg63       eg139      eg248      gd140      hz44       ltt16294
amcvn      eg67       eg144      feige24    gd190      l13633     ltt4099
bd7781     eg76       eg145      g12627     grw705824  l14094     ltt8702
bd73632    eg79       eg148      g14563     grw708247  l151234b   ross627
bd174708   eg91       eg149      g16350     grw738031  l74546a    ross640
bd262606   eg98       eg162      g191b2b    hd19445    l93080     sa29130
eg20       eg99       eg182      g2610      hd84937    l97030     sao131065
eg33       eg102      eg184      g2631      he3        lds235b    wolf1346
eg50       eg119      eg193      g4718      hz29       lds749b    wolf485a
eg54       eg129      eg247      g9937      hz43       lft1655    

--------------------------------------------------------------------------------
Standard stars in onedstds$spec16cal/:

Combined red and blue 3300A-10300A:

hd15318      hd74280      hd114330     hd188350     hd214923
hd30739      hd100889     hd129956     hd198001     hd224926
hr1544       hr4468       hr5501       hr7596       hr8634       
hr3454       hr4963       hr718        hr7950       hr9087    

Blue 3300A-7550A:

hd15318blue     hd74280blue     hd114330blue    hd188350blue    hd214923blue
hd30739blue     hd100889blue    hd129956blue    hd198001blue    hd224926blue
hr1544blue      hr4468blue      hr5501blue      hr7596blue      hr8634blue    
hr3454blue      hr4963blue      hr718blue       hr7950blue      hr9087blue    

Red 6020A-10300A:

hd15318red      hd74280red      hd114330red     hd188350red     hd214923red
hd30739red      hd100889red     hd129956red     hd198001red     hd224926red
hr1544red       hr4468red       hr5501red       hr7596red       hr8634red    
hr3454red       hr4963red       hr718red        hr7950red       hr9087red    

--------------------------------------------------------------------------------
Standard stars in onedstds$spec50cal/  (3200A - 8100 A)

bd284211   eg247      feige34    hd192281   pg0205134  pg0934554  wolf1346
cygob2no9  eg42       feige66    hd217086   pg0216032  pg0939262  
eg139      eg71       feige67    hilt600    pg0310149  pg1121145  
eg158      eg81       g191b2b    hz14       pg0823546  pg1545035  
eg20       feige110   gd140      hz44       pg0846249  pg1708602  

Standard stars in onedstds$spec50cal/  (3200A - 10200A)

bd284211   eg247      feige34    g191b2b    hz44       
eg139      eg71       feige66    gd140      pg0823546  
eg158      feige110   feige67    hilt600    wolf1346   

--------------------------------------------------------------------------------
Standard stars in onedstds$spechayescal/

bd284211     eg139        feige67      hd217086     pg0216032    pg0939262
cygob2no9    eg158        feige110     hiltner600   pg0310149    pg1121145
eg42         eg247        g191b2b      hz14         pg0823546    pg1545035
eg71         feige34      gd140        hz44         pg0846249    pg1708602
eg81         feige66      hd192281     pg0205134    pg0934554    wolf1346

			Image Header Database Interface
				dct 16-Apr-85

1. Overview

    This directory contains the first version of the image header database
interface.  In this implementation the image header is a variable length fixed
format binary structure.  The first, fixed format, part of the image header
contains the standard fields in binary and is fixed in size.  This is followed
by the so called "user area", a string buffer containing a sequence of
variable length, newline delimited FITS format keyword=value header cards.
When an image is open a large user area is allocated to permit the addition
of new parameters without filling up the buffer.  When the header is
subsequently updated on disk only as much disk space is used as is needed to
store the actual header.

This format header is upwards compatible with the old image header format,
hence old images and programs do not have to be modified to use the IMIO
release supporting database accesss.  In the future image headers will be
maintained under DBIO, but the routines in the image header database interface
are not exected to change.  The actual disk format of images will of course
change when we switch over to the  DBIO headers.



2. Functions

	get,g - get the value of a field
	put,p - set the value of a field
	add,a - add a new field to a database
	  acc - determine if the named field exists


3. Procedures

       value = imget[bcsilrdx] (im, "field")
		        imgstr (im, "field", outstr, maxch)
	       imput[bcsilrdx] (im, "field", value)
		        impstr (im, "field", value)
       	       imadd[bcsilrdx] (im, "field", def_value)
		        imastr (im, "field", def_value)
		        imaddf (im, "field", "datatype")
	          y/n = imaccf (im, "field")

             list = imofnl[su] (im, template)
                  nch = imgnfn (im, outstr, maxch)
                        imcfnl (im)



4. Description

    New parameters will typically be added to the image header with either
one of the typed procedures IMADD_ or with the lower level procedure IMADDF.
The former procedures permit the parameter to be created and the value
initialized all in one call, while the latter only creates the parameter.
In addition, the typed IMADD_ procedures may be used to update the values
of existing parameters (it is not considered an error if the parameter
already exists).  The principal limitation of the typed procedures is that
they may only be used to add or set parameters of a standard datatype.
The IMADDF procedure will permit creation of parameters with more descriptive
datatypes (domains) when the interface is recut upon DBIO.

The value of any parameter may be fetched with one of the IMGET functions.
The IMACCF function may be used (like ACCESS for a file) to determine
whether a parameter exists.

The database interface may be used to access any field of the image header,
including the following standard fields.  Note that the nomenclature has
been changed slightly to make it more consistent with FITS.  Additional
standard fields will be defined in the future.


	  keyword     type                 description

	i_naxis		i	number of axes (dimensionality)
	i_naxis[1-7]	l	length of an axis ("i_naxis1", etc.)
	i_pixtype	i	pixel datatype (SPP integer code)
	i_minpixval	r	minimum pixel value
	i_maxpixval	r	maximum pixel value
	i_ctime		l	time of image creation
	i_mtime		l	time of last modify
	i_limtime	l	time when limits (minmax) were last updated
	i_title		s	title string


The names of the standard fields share an "i_" prefix to reduce the possibility
of collisions with data dependent keywords, to identify the standard fields in
sorted listings, to allow use of pattern matching to discriminate between the
standard fields and user fields, and so on.  For the convenience of the user,
the "i_" prefix may be omitted provided the resultant name does not match the
name of a user parameter.  It is however recommended that the full name be
used in all applications software.


5. Restrictions

    The use of FITS format as the internal format for storing fields in this
version of the interface places restrictions on the size of field names and
of the string value of string valued parameters.  Field names are currently
limited to eight characters or less and case is ignored (since FITS requires
upper case).  The eight character limit does not apply to the standard fields.
String values are limited to at most 68 characters.  If put string is passed
a longer string it will be silently truncated.  Trailing whitespace and
newlines are chopped when a string value is read.

This directory contains the source for the NSPP/GIO kernel, the interface
between GIO and the old Ncar system plot package and associated metacode
translators.

Special graphcap entries used by this kernel:

	MF		maximum frame count per metafile
	FS		frame advance req'd at start of metafile
	FE		frame advance req'd at end of metafile

Rev 1.0 installed in March 1985.
----------------------------------------------------------------------------

Differences between Rev 1.0 and Rev 1.1 of the NSPP/GIO kernel.
Collated at installation of Rev 1.1 on 24 April 1985.
----------------------------------------------------------------------------

gktclose.x
+ diff gktclose.x ../nsppkern.old/gktclose.x 
12,13d11
< 	call frame
< 	call gkt_flush
+ echo gktclosews.x 
gktinit.x
+ diff gktinit.x ../nsppkern.old/gktinit.x 
49a50,59
> 	# get the window offsets
> 
> 	g_xoff = ttygeti (tty, "XO")
> 	if (g_xoff < 0)
> 	    g_xoff = 0
> 	g_yoff = ttygeti (tty, "YO")
> 	if (g_yoff < 0)
> 	    g_yoff = 0
> 
> 
112d121
< 	GKT_PIXREP(g_kt)     = btoi (ttygetb (tty, "pr"))
gktopenws.x
+ diff gktopenws.x ../nsppkern.old/gktopenws.x 
98,104c98,99
< 	if (mode == NEW_FILE) {
< 	    # Frame call only if NEW_FILE and not first time open with
< 	    # this device.  This prevents frame before first data.
< 	    if (!need_open)
< 	        call frame
< 	    call gkt_reset
< 	}
---
> 	if (mode == NEW_FILE)
> 	    call frame()
+ echo gktpcell.x 
gktpcell.x
+ diff gktpcell.x ../nsppkern.old/gktpcell.x 
8a9
> 
12c13
< procedure gkt_putcellarray (m, nc, nr, ax1,ay1, ax2,ay2)
---
> procedure gkt_putcellarray (m, nc, nr, x1,y1, x2,y2)
17,18c18,19
< int	ax1, ay1		# lower left corner of output window
< int	ax2, ay2		# upper right corner of output window
---
> int	x1, y1			# lower left corner of output window
> int	x2, y2			# upper right corner of output window
20d20
< int	x1,y1,x2,y2		# device coordinates
22c22
< int	nx, ny, y
---
> int	nx, ny
28c28
< bool	ca, use_orig, new_row, pr
---
> bool	ca, use_orig, new_row
31,32d30
< real	delta_y
< int	xrep, yrep
43c41
< 	# Determine if can do real cell array.  If not, use character
---
> 	# determine if can do real cell array.  If not, use character
49d46
< 	pr = false
53d49
< 	    pr = (GKT_PIXREP(g_kt) != 0)
65,66c61
< 	# Input arguments (ax, ay) refer to corners of put cell array;
< 	# we need corners of the corresponding device array.
---
> 	# find out how many real pixels we have to fill
68,73c63,66
< 	x1 = ax1
< 	x2 = ax2
< 	y1 = ay1
< 	y2 = ay2
< 	call adjust(x1,x2,xres)
< 	call adjust(y1,y2,yres)
---
> 	px1 = real(x1)/GKI_MAXNDC
> 	py1 = real(y1)/GKI_MAXNDC
> 	px2 = real(x2)/GKI_MAXNDC
> 	py2 = real(y2)/GKI_MAXNDC
75,79c68,69
< 	# Find out how many real pixels we have to fill
< 	px1 = real(x1)/(GKI_MAXNDC+1)
< 	py1 = real(y1)/(GKI_MAXNDC+1)
< 	px2 = real(x2)/(GKI_MAXNDC+1)
< 	py2 = real(y2)/(GKI_MAXNDC+1)
---
> 	nx = int( (px2 - px1) * (xres-1.0) + 1.5 )
> 	ny = int( (py2 - py1) * (yres-1.0) + 1.5 )
81,90c71
< 	nx = int( px2 * xres ) - int( px1 * xres ) + 1
< 	ny = int( py2 * yres ) - int( py1 * yres ) + 1
< 
< 	if ( ny > 1)
< 	     delta_y = (real(y2) - real(y1))/ny
< 	else {
< 	     delta_y = 0.
< 	}
< 
< 	# If too many data points in input, set skip.  If skip is close
---
> 	# if too many data points in input, set skip.  If skip is close
92,93c73,74
< 	# Set block replication factors - will be > 1.0 if too few input points.
< 	# Cannot set to 1.0 if "close" enough, since, if > 1.0, we don't have
---
> 	# set block replication factors - will be > 1.0 if too few input points.
> 	# cannot set to 1.0 if "close" enough, since, if > 1.0, we don't have
110c91,101
< 	# Allocate storage for a row of pixels.  This is quite inefficient
---
> 
> 	# try for the simplest case: 1:1 match with input data
> 
> 	if ( ca && (nx == nc) && (ny == nr) ) {
> 	    call pixels( real(x1)/GKI_MAXNDC, real(y1)/GKI_MAXNDC,
> 		nx, ny, m)
> 	    call sfree(sp)
> 	    return
> 	}
> 
> 	# allocate storage for a row of pixels.  This is quite inefficient
113d103
< 	# need nx+1 in case nx odd ... pixels() wants to pad output.
115,116c105
< 	call salloc ( cell, nx+1, TY_SHORT)
< 	Mems[cell + nx] = 0
---
> 	call salloc ( cell, nx, TY_SHORT)
118c107
< 	# Initialize counters
---
> 	# initialize counters
125c114
< 	# See if we can use original data ... no massaging
---
> 	# see if we can use original data ... no massaging
128c117
< 	# Note that if blockx > 1.0, skip_x must be 1.0, and vv
---
> 	# note that if blockx > 1.0, skip_x must be 1.0, and vv
138,152c127
< 	# If device can pixel replicate, use that feature where we can
< 	if( pr) {
< 	    if( (skip_x == 1.0) && ( int(blockx) == blockx) ) {
< 		 xrep = int(blockx)
< 		 use_orig = true
< 		 nx = nc
< 	    } else
< 		 xrep = 1
< 	    if( (skip_y == 1.0) && ( int(blocky) == blocky) ) {
< 		 yrep = int(blocky)
< 		 ny = 1
< 	    } else
< 		 yrep = 1
< 	}
< 	call pixel0(1,0,xrep,0,1,yrep)
---
> 	# do it
154c129
< 	# Do it
---
> 	for (i = 1;  i <= ny;  i = i + 1) {
156c131
< 	for ( i = 1; i <= ny ; i = i + 1) {
---
> 	    # Build the row data.
158,159d132
< 	    # Build the row data
< 
161c134
< 		if ( skip_x == 1.0) {
---
> 		if ( skip_x == 1.0)
163c136
< 		} else {
---
> 		else {
181d153
< 		y = y1 + ((i - 1)*delta_y + 0.5)
183,184c155,159
< 		        call pixels( px1, real(y)/GKI_MAXNDC,
< 			    nx, 1, m[element])
---
> 		    if ( i == 1 )
> 		        call pixelr( real(x1)/GKI_MAXNDC, real(y1)/GKI_MAXNDC,
> 			    nx, ny, m[element])
> 		    else
> 		        call pixeli( 0., 0., nx, 1, m[element])
186c161,165
< 		        call pixels( px1, real(y)/GKI_MAXNDC, nx, 1, Mems[cell])
---
> 		    if ( i == 1 )
> 		        call pixelr( real(x1)/GKI_MAXNDC, real(y1)/GKI_MAXNDC,
> 			    nx, ny, Mems[cell])
> 		    else
> 		        call pixeli( 0., 0., nx, 1, Mems[cell])
188,189c167
< 	    }   
< 	    else
---
> 	    } else
192c170
< 	    # Advance a row
---
> 	    # Advance a row.
206c184
< 	# All done, restore text parameters and release storage
---
> 	# all done, restore text parameters and release storage
209c187
< 	    call restoretx (txsave,tx)
---
> 	    call restoretx(txsave,tx)
212a191
> 
218d196
< pointer savep, txp
219a198
> pointer savep, txp
254a234
> 
258d237
< pointer savep, txp
259a239
> pointer savep, txp
263c243
< 	# Restore values
---
> 	# restore values
283a264
> 
287c268,269
< procedure fakepc (indata, outdata, nx,  scale)
---
> procedure fakepc( indata, outdata, nx,  scale)
> 
298c280
< data cdata /' ', '.', ':', '|', 'i', 'l', 'J', 'm', '#', 'S', 'B', EOS/
---
> data	cdata /' ', '.', ':', '|', 'i', 'l', 'J', 'm', '#', 'S', 'B', EOS/
330,374d311
< end
< 
< # ADJUST -- round/truncate putcell array corners to device coordinates
< # move up lower bound if it is above center point of device cell,
< # move down upper bound if below.  Don't allow bounds to go beyond
< # resolution or below zero.  Do not allow bounds to cross.  Part of the
< # assumptions behind all this is that putcells will be continguous and
< # rows/columns must not be plotted twice.
< 
< procedure adjust ( lower, upper, res)
< 
< int	lower, upper
< real	res
< 
< real	factor
< real	low, up
< 
< begin
< 	factor = res/(GKI_MAXNDC+1)
< 	low = real(lower) * factor
< 	up  = real(upper) * factor
< 
< 	# if boundaries result in same row, return
< 	if ( int(low) == int(up) )
< 	    return
< 
< 	# if low is in upper half of device pixel, round up
< 	if ( (low - int(low)) >= 0.5 ) {
< 	    low = int(low) + 1
< 	    # don't go to or beyond upper bound
< 	    if ( low < up ) {
< 	        # ... 0.2 just for "rounding protection";
< 		lower = (low + 0.2)/factor
< 	        # if now reference same cell, return
< 		if ( int(low) == int(up) )
< 		    return
< 	    }
< 	}
< 
< 	# if "up" in bottom half of pixel, drop down one.  Note that
< 	# due to two "==" tests above, upper will not drop below lower.
< 	# 0.2 means drop partway down into pixel below; calling code will
< 	# truncate.
< 	if ( (up - int(up)) < 0.5 )
< 	    upper = real(int(up) - 0.2)/factor
+ echo gktpl.x 
gktpl.x
+ diff gktpl.x ../nsppkern.old/gktpl.x 
51,52c51,52
< 	x = p[1]
< 	y = p[2]
---
> 	x = p[1] + g_xoff
> 	y = p[2] + g_yoff
58,59c58,59
< 	    x = p[i]
< 	    y = p[i+1]
---
> 	    x = p[i] + g_xoff
> 	    y = p[i+1] + g_yoff
gktpm.x
+ diff gktpm.x ../nsppkern.old/gktpm.x 
48,49c48,49
< 	x = p[1]
< 	y = p[2]
---
> 	x = p[1] + g_xoff
> 	y = p[2] + g_yoff
63,64c63,64
< 	    x = p[i]
< 	    y = p[i+1]
---
> 	    x = p[i] + g_xoff
> 	    y = p[i+1] + g_yoff
+ echo gktpmset.x 
gkttx.x
+ diff gkttx.x ../nsppkern.old/gkttx.x 
109,110c109,110
< 		call pwrity (real(x)/GKI_MAXNDC,
< 			real(y)/GKI_MAXNDC, Memc[pstring], seglen,
---
> 		call pwrity (real(x+g_xoff)/GKI_MAXNDC,
> 			real(y+g_yoff)/GKI_MAXNDC, Memc[pstring], seglen,
_____________________________________________________________________________

25Apr85	gktpl.x
	Call to optn to set line width changed to set option "inten" instead
	of "spot size", which was not changing the line width.

26Apr85 gktpm.x
	Same change as one to gktpl.x

	Character size as used in gkttx.x is a floating point number, but
	NCAR pwry.f uses an integer value -- the conversion was causing
	centering errors as gkttx.x would calculate a "path length" for
	the text based on one size, and pwry.f would use a different size
	to generate the text.  Changed pwry.f to use a floating point
	size as an input variable, changed gkttx.x to send same.

	gktpcell.x
	Moved pixel0 call inside the "if (pr) {" statment, where it should
	have been.

	graphcap
	Added  "pr" capablility flag to dicomed entry.  Changed character
	height to reflect the 9 to 8 ratio that pwry uses.


---------------------------------------------------------------------------
Rev 1.2 10 May 1985 Dct.

Fairly extensive modifications made to minimize the number of frame calls
and metafiles generated.  Redundant CLEAR calls or clear calls immediately
after open workstation are ignored.  Multiple frames are permitted in a
metafile (formerly the metafile was disposed after each frame).  Graphcap
parameters were added to control automatic frame advances at the beginning
and end of metafiles.

---------------------------------------------------------------------------
Rev 1.3 1 June 1985 Dct.

[1] Fixed a bug in polymarker; was drawing polylines.

[2] Replaced the old character generation code by all new code, using the stroke
table from the NCAR/GKS code.  Replaced "pwry.f" by the much simpler
"gktdrawch.x".  Largely copied the stdgraph "stgtx.x", including the clipping
logic therein.

17-Aug-85 Dct.
	Added support for the new DD graphcap parameter, used to pass device
	dependent information to the device driver.  This information was
	formerly encoded in a table at compile time, with the table defined
	in <libc/kernel.h>.

To compile f2c on Linux or Unix systems, copy makefile.u to makefile,
edit makefile if necessary (see the comments in it and below) and
type "make" (or maybe "nmake", depending on your system).

To compile f2c.exe on MS Windows systems with Microsoft Visual C++,

	copy makefile.vc makefile
	nmake

With other PC compilers, you may need to compile xsum.c with -DMSDOS
(i.e., with MSDOS #defined).

If your compiler does not understand ANSI/ISO C syntax (i.e., if
you have a K&R C compiler), compile with -DKR_headers .

On non-Unix systems where files have separate binary and text modes,
you may need to "make xsumr.out" rather than "make xsum.out".

If (in accordance with what follows) you need to any of the source
files (excluding the makefile), first issue a "make xsum.out" (or, if
appropriate, "make xsumr.out") to check the validity of the f2c source,
then make your changes, then type "make f2c".

The file usignal.h is for the benefit of strictly ANSI include files
on a UNIX system -- the ANSI signal.h does not define SIGHUP or SIGQUIT.
You may need to modify usignal.h if you are not running f2c on a UNIX
system.

Should you get the message "xsum0.out xsum1.out differ", see what lines
are different (`diff xsum0.out xsum1.out`) and ask netlib
(e.g., netlib@netlib.org) to send you the files in question,
plus the current xsum0.out (which may have changed) "from f2c/src".
For example, if exec.c and expr.c have incorrect check sums, you would
send netlib the message
	send exec.c expr.c xsum0.out from f2c/src
You can also ftp these files from netlib.bell-labs.com; for more
details, ask netlib@netlib.org to "send readme from f2c".

On some systems, the malloc and free in malloc.c let f2c run faster
than do the standard malloc and free.  Other systems may not tolerate
redefinition of malloc and free (though changes of 8 Nov. 1994 may
render this less of a problem than hitherto).  If your system permits
use of a user-supplied malloc, you may wish to change the MALLOC =
line in the makefile to "MALLOC = malloc.o", or to type
	make MALLOC=malloc.o
instead of
	make
Still other systems have a -lmalloc that provides performance
competitive with that from malloc.c; you may wish to compare the two
on your system.  If your system does not permit user-supplied malloc
routines, then f2c may fault with "MALLOC=malloc.o", or may display
other untoward behavior.

On some BSD systems, you may need to create a file named "string.h"
whose single line is
#include <strings.h>
you may need to add " -Dstrchr=index" to the "CFLAGS =" assignment
in the makefile, and you may need to add " memset.o" to the "OBJECTS ="
assignment in the makefile -- see the comments in memset.c .

For non-UNIX systems, you may need to change some things in sysdep.c,
such as the choice of intermediate file names.

On some systems, you may need to modify parts of sysdep.h (which is
included by defs.h).  In particular, for Sun 4.1 systems and perhaps
some others, you need to comment out the typedef of size_t.  For some
systems (e.g., IRIX 4.0.1 and AIX) it is better to add
#define ANSI_Libraries
to the beginning of sysdep.h (or to supply -DANSI_Libraries in the
makefile).

Alas, some systems #define __STDC__ but do not provide a true standard
(ANSI or ISO) C environment, e.g., do not provide stdlib.h .  If yours
is such a system, then (a) you should complain loudly to your vendor
about __STDC__ being erroneously defined, and (b) you should insert
#undef __STDC__
at the beginning of sysdep.h .  You may need to make other adjustments.

For some non-ANSI versions of stdio, you must change the values given
to binread and binwrite in sysdep.c from "rb" and "wb" to "r" and "w".
You may need to make this change if you run f2c and get an error
message of the form
	Compiler error ... cannot open intermediate file ...

In the days of yore, two libraries, libF77 and libI77, were used with
f77 (the Fortran compiler on which f2c is based).  Separate source for
these libraries is still available from netlib, but it is more
convenient to combine them into a single library, libf2c.  Source for
this combined library is also available from netlib in f2c/libf2c.zip,
e.g.,
	http://netlib.bell-labs.com/netlib/f2c/libf2c.zip
or
	http://www.netlib.org/f2c/libf2c.zip

(and similarly for other netlib mirrors).  After unzipping libf2c.zip,
copy the relevant makefile.* to makefile, edit makefile if necessary
(see the comments in it and in libf2c/README) and invoke "make" or
"nmake".  The resulting library is called *f2c.lib on MS Windows
systems and libf2c.a or libf2c.so on Linux and Unix systems;
makefile.u just shows how to make libf2c.a.  Details on creating the
shared-library variant, libf2c.so, are system-dependent; some that
have worked under Linux appear below.  For some other systems, you can
glean the details from the system-dependent makefile variants in
directory http://www.netlib.org/ampl/solvers/funclink or
http://netlib.bell-labs.com/netlib/ampl/solvers/funclink, etc.

In general, under Linux it is necessary to compile libf2c (or libI77)
with -DNON_UNIX_STDIO .  Under at least one variant of Linux, you can
make and install a shared-library version of libf2c by compiling
libI77 with -DNON_UNIX_STDIO, creating libf2c.a as above, and then
executing

	mkdir t
	ln lib?77/*.o t
	cd t; cc -shared -o ../libf2c.so -Wl,-soname,libf2c.so.1 *.o
	cd ..
	rm -r t
	rm /usr/lib/libf2c*
	mv libf2c.a libf2c.so /usr/lib
	cd /usr/lib
	ln libf2c.so libf2c.so.1
	ln libf2c.so libf2c.so.1.0.0

On some other systems, /usr/local/lib is the appropriate installation
directory.


Some older C compilers object to
	typedef void (*foo)();
or to
	typedef void zap;
	zap (*foo)();
If yours is such a compiler, change the definition of VOID in
f2c.h from void to int.

For convenience with systems that use control-Z to denote end-of-file,
f2c treats control-Z characters (ASCII 26, '\x1a') that appear at the
beginning of a line as an end-of-file indicator.  You can disable this
test by compiling lex.c with NO_EOF_CHAR_CHECK #defined, or can
change control-Z to some other character by #defining EOF_CHAR to
be the desired value.


If your machine has IEEE, VAX, or IBM-mainframe arithmetic, but your
printf is inaccurate (e.g., with Symantec C++ version 6.0,
printf("%.17g",12.) prints 12.000000000000001), you can make f2c print
correctly rounded numbers by compiling with -DUSE_DTOA and adding
dtoa.o g_fmt.o to the makefile's OBJECTS = line, so it becomes

	OBJECTS = $(OBJECTSd) malloc.o dtoa.o g_fmt.o

Also add the rule

	dtoa.o: dtoa.c
		$(CC) -c $(CFLAGS) -DMALLOC=ckalloc -DIEEE... dtoa.c

(without the initial tab) to the makefile, where IEEE... is one of
IEEE_MC68k, IEEE_8087, VAX, or IBM, depending on your machine's
arithmetic.  See the comments near the start of dtoa.c.

The relevant source files, dtoa.c and g_fmt.c, are available
separately from netlib's fp directory.  For example, you could
send the E-mail message

	send dtoa.c g_fmt.c from fp

to netlib@netlib.netlib.org (or use anonymous ftp from
ftp.netlib.org and look in directory /netlib/fp).

The makefile has a rule for creating tokdefs.h.  If you cannot use the
makefile, an alternative is to extract tokdefs.h from the beginning of
gram.c: it's the first 100 lines.

File mem.c has #ifdef CRAY lines that are appropriate for machines
with the conventional CRAY architecture, but not for "Cray" machines
based on DEC Alpha chips, such as the T3E; on such machines, you may
need to make a suitable adjustment, e.g., add #undef CRAY to sysdep.h.

Fortran 77 assumes variables of type INTEGER and REAL occupy the same
storage and that a DOUBLE PRECISION or COMPLEX variable occupies twice
this storage.  The types in f2c.h need to reflect these assumptions,
at least when EQUIVALENCE is involved.  As of 2021, most modern C and
C++ compilers make "int" a four-byte type, i.e., (in C notation)
sizeof(int) == 4.  Some make sizeof(long) == 4, others make
sizeof(long) == 8.  (With the compiler originally used for f2c,
sizeof(int) == 2 and sizeof(long) == 4.)  For compilers having
sizeof(int) == 4 and sizeof(long) == 8, in f2c.h it suffices to change
"long int" to "int" and is safe to change "#ifdef INTEGER_STAR_8" to
"#if 1".


Please send bug reports to dmg at acm.org (with " at " changed to "@").
The old index file (now called "readme" due to unfortunate changes in
netlib conventions:  "send readme from f2c") will report recent
changes in the recent-change log at its end; all changes will be shown
in the "changes" file ("send changes from f2c").  To keep current
source, you will need to request xsum0.out and version.c, in addition
to the changed source files.

		IRAF Tools for Color Image Display

A prototype IRAF color image display package, COLOR, is now available.
Currently this package provides conversion of 3 bandpass IRAF images to a
Sun 24-bit RGB rasterfile format, a 24-bit to 8-bit compression algorithm
and Floyd-Steinberg dithering, and an RGB 8-bit pixel dithering algorithm.
The Sun rasterfiles are displayed using non-IRAF tools and the others use
only IRAF images and SAOimage or IMTOOL.  These tasks are usable with the
currently common 8-bit color workstations and are provided for those users
which don't have more capable hardware such as 24-bit workstations, IIS
displays, and 24-bit addon cards.  Addtional functionality will be added to
the COLOR package in time.

The task RGBSUN takes three input IRAF images and produces a 24-bit Sun
rasterfile.  Though this file type was developed by Sun Microsystems it is
a relatively simple format which may useful on other machines having
software designed to use it.  The color image may be displayed with a variety
of non-IRAF tools such as XV (a very powerful and generic viewer for
X-window systems), XLOADIMAGE (another X-window display tool), SCREENLOAD
(a simple displayer on Sun computers), and SNAPSHOT (an Open-Look tool).
Also some color printers can be used with this format such as a Shinko
color printer.

The recommended display tool is XV which provides a great deal of
capability in adjusting the color map and size.  This program compress the
24-bit colors to 8-bits on an 8-bit workstation using color dithering
techniques (there is a choice of a slow and fast method).  This program
also provides the capability to write the picture out to other formats and
one may also use screen capture tools such as XWD or SNAPSHOT
to extract and possibly print the picture.

For hardcopy there is always the option of photographing the workstation
screen.  Different sites may also have color printers which accept
the rasterfile directly or some other form of capture from the screen.
At NOAO there is a Shinko color printer which may be used directly with
the rasterfile to make moderate quality color prints and slides.

The task RGBTO8 takes three input IRAF images, maps them to 8-bits each,
compresses the 24-bit RGB colors to 8-bits using the Heckbert Median
Cut Algorithm, and applies a Floyd-Steinberg dither to the output
8-bit IRAF image.  The task also outputs a color map suitable for use
with (V1.07) SAOimage and IMTOOL.  Basically this does the same thing
as the X tools except in an IRAF task which produces and IRAF image and
separate color map.  This approach, thus, only requires this package
and the standard IRAF display server and only uses IRAF images.

The pixel dithering techique takes three input IRAF images and makes a
special output image in which each pixel in the input images is expanded
into nine pixels in the output image with a specified pattern such as
the default of

				brg
		r + g + b =	gbr
				rgb

where r is the red image pixel, g is the green image pixel, and b is the
blue image pixel.

The pixel intensities are linearly mapped from a specified input range to
one of three sets of 85 levels.  The red pixels map to the values 0 to 84,
the green pixels to the range 85 to 169, and the blue pixels to the range
170 to 254.  The display server then uses a special 8-bit look up table
that maps each set of 85 levels in each pure color from off to the maximum
intensity.  The displayed image counts on the nearby grouping of pure
colors to blend in the detector, such as the eye, to give a color composite
effect.

This is essentially the same technique used in some kinds of color printing
and CRT monitors where each resolution element has three color phosphors
and three guns to excite them.  The pixel dithering is also related to
black and white half-toning.  As with any of these, if the image is
magnified or viewed with enough resolution (by looking very closely at the
display) the individual color elements can be distinguished.  However, when
viewed normally without magnification the effect is reasonably good.

The advantages of the last two techniques for IRAF users are that the
currently common 8-bit color workstation displays, the standard IRAF
display servers SAOimage and IMTOOL, and the standard IRAF image formats
are all that is required.  The pixel dither technique has the advantage of
using a palette of colors which is wider than attempting to compress the
three images into a single 8-bit word (color compression) and the method is
more intuitive than the 24-bit to 8-bit compress and dithering used in XV
RGBTO8.  The disadvantages of the pixel dithering are the loss of
resolution, the decrease in overall brightness (since at most only one
color is at maximum at each resolution element), and the special nature of
the composite image (which, however, is an IRAF image rather than one of
the many other color picture formats).

IMFORT/DB -- Image header keyword access for IMFORT (20Apr86)

    This directory contains a version of the imio/db package, modified for
IMFORT.  The modifications consisted of [1] elimination of calls to the
various printf routines, so that only pure code (no external dependencies
or use of VOS i/o) is linked into the Fortran program, [2] deleted imgnfn
template stuff, [3] added provision for comments when adding new keywords,
[4] changed datatype code to integer uniformly.  Error checking is still
used but should be iferr-ed and turned into an IER code in the Fortran
binding.


Old IDBI readme docs:
----------------------------------------

			Image Header Database Interface
				dct 16-Apr-85

1. Overview

    This directory contains the first version of the image header database
interface.  In this implementation the image header is a variable length fixed
format binary structure.  The first, fixed format, part of the image header
contains the standard fields in binary and is fixed in size.  This is followed
by the so called "user area", a string buffer containing a sequence of
variable length, newline delimited FITS format keyword=value header cards.
When an image is open a large user area is allocated to permit the addition
of new parameters without filling up the buffer.  When the header is
subsequently updated on disk only as much disk space is used as is needed to
store the actual header.

This format header is upwards compatible with the old image header format,
hence old images and programs do not have to be modified to use the IMIO
release supporting database accesss.  In the future image headers will be
maintained under DBIO, but the routines in the image header database interface
are not exected to change.  The actual disk format of images will of course
change when we switch over to the  DBIO headers.



2. Functions

	get,g - get the value of a field
	put,p - set the value of a field
	add,a - add a new field to a database
	  acc - determine if the named field exists


3. Procedures

       value = imget[bcsilrdx] (im, "field")
		        imgstr (im, "field", outstr, maxch)
	       imput[bcsilrdx] (im, "field", value)
		        impstr (im, "field", value)
       	       imadd[bcsilrdx] (im, "field", def_value)
		        imastr (im, "field", def_value)
		        imaddf (im, "field", "datatype")
	          y/n = imaccf (im, "field")

             list = imofnl[su] (im, template)
                  nch = imgnfn (im, outstr, maxch)
                        imcfnl (im)



4. Description

    New parameters will typically be added to the image header with either
one of the typed procedures IMADD_ or with the lower level procedure IMADDF.
The former procedures permit the parameter to be created and the value
initialized all in one call, while the latter only creates the parameter.
In addition, the typed IMADD_ procedures may be used to update the values
of existing parameters (it is not considered an error if the parameter
already exists).  The principal limitation of the typed procedures is that
they may only be used to add or set parameters of a standard datatype.
The IMADDF procedure will permit creation of parameters with more descriptive
datatypes (domains) when the interface is recut upon DBIO.

The value of any parameter may be fetched with one of the IMGET functions.
The IMACCF function may be used (like ACCESS for a file) to determine
whether a parameter exists.

The database interface may be used to access any field of the image header,
including the following standard fields.  Note that the nomenclature has
been changed slightly to make it more consistent with FITS.  Additional
standard fields will be defined in the future.


	  keyword     type                 description

	i_naxis		i	number of axes (dimensionality)
	i_naxis[1-7]	l	length of an axis ("i_naxis1", etc.)
	i_pixtype	i	pixel datatype (SPP integer code)
	i_minpixval	r	minimum pixel value
	i_maxpixval	r	maximum pixel value
	i_ctime		l	time of image creation
	i_mtime		l	time of last modify
	i_limtime	l	time when limits (minmax) were last updated
	i_title		s	title string


The names of the standard fields share an "i_" prefix to reduce the possibility
of collisions with data dependent keywords, to identify the standard fields in
sorted listings, to allow use of pattern matching to discriminate between the
standard fields and user fields, and so on.  For the convenience of the user,
the "i_" prefix may be omitted provided the resultant name does not match the
name of a user parameter.  It is however recommended that the full name be
used in all applications software.


5. Restrictions

    The use of FITS format as the internal format for storing fields in this
version of the interface places restrictions on the size of field names and
of the string value of string valued parameters.  Field names are currently
limited to eight characters or less and case is ignored (since FITS requires
upper case).  The eight character limit does not apply to the standard fields.
String values are limited to at most 68 characters.  If put string is passed
a longer string it will be silently truncated.  Trailing whitespace and
newlines are chopped when a string value is read.

MKPKG -- Package maintenance utility.

    The MKPKG utility is used to maintain the IRAF system libraries as well
as the system executables and the applications packages.  The file "mkpkg.csh"
in this directory will make and install the initial mkpkg.e executable.
The libraries lib$libboot.a and lib$libos.a must have been made first.
Once MKPKG is up it can be used to remake itself.


NOTES

    The MKPKG utility is used to keep libraries and/or packages up to date.
The dates of the library modules are compared to the corresponding SOURCE
(not object) files in the directories contributing to the library.
Any source files newer than their corresponding library modules are
compiled and the library is updated.  Note that the sources contributing
to the library may reside in multiple subdirectories as well as in the
current directory.  Each source file may depend on zero or more other files.
If any of these files are newer than the source file, the source file is
recompiled and replaced in the library.

MKPKG is built upon a preprocessor front end providing macro replacement
and conditional interpretation facilities.  These facilities, in combination
with the OS escape mechanism used to send commands to the host system,
make it possible to use MKPKG for more than just updating libraries.

As far as possible, the system dependent functions required by MKPKG have
been isolated and placed in separate small files.  The bulk of the code is
machine independent.  Additional system dependent functions are provided
by the BOOTLIB library (LIBBOOT) and by the IRAF kernel (LIBOS).  The MKPKG
specific functions required are the following:
 
	[1] Given the NAME of a source file, return the date of the
	    corresponding object module in a library.
	[2] Replace (or add) a series of object modules in a library,
	    creating the library if it does not already exist.
	[3] "Rebuild" the library after all updates are complete.

The library functions are normally implemented by formatting a command
for the host librarian utility and sending it to the host with the ZOSCMD
utility.  Note that an entire command script can be built in a temporary
file if the ZOSCMD interface is too inefficient for multiple small calls
on your system.

All filenames in the portable code (and in the Makelib files) are in the
IRAF format, which is very similar to UNIX format.  Do not change the high
level code to manipulate host system filenames directly.  All filename
mapping should be performed in the host interface code; the VFN2OSFN
function is convenient to use for this purpose.

For simplicity, most buffers are fixed in size.  Dynamically allocating
everything is less efficient and is not warranted since the memory
requirements of this program are modest.  If a buffer overflows simply
increase the allocation below and remake mkpkg.

This directory contains interface routines for the spectral world
coordinate systems.  The interface has two functions.  The first is to
convert various input formats, including old formats, to one of the WCS
formats used by the ONEDSPEC package.  These are MULTISPEC, EQUISPEC, and
NDSPEC.  The second is to split large numbers of spectra which exceed the
limits of the MWCS for a single WCS into a number of smaller WCS.

               Photometric Calibrations Package
	    -------------------------------------

    The photometry calibration package contains a set for tasks for converting
from the instrumental magnitude system to the standard photometric system.

    The PHOTCAL directory structure is listed below. The package organization
is by task and/or function.


            |-catalogs----------library of standard photometric catalogs
	    |-debug-------------debugging routines
	    |-doc---------------the package documentation
	    |-evaluate----------routines to evaluate the transformations
	    |-fitparams---------routines to compute the transformations
	    |-io----------------package io routines
|-photcal---|-lib---------------include files
            |-mctable-----------package table routines
	    |-mkcatalog---------routines for typing in catalog files
	    |-mkconfig----------routines for creating the config files
	    |-mkimsets----------routines for creating the image set files
	    |-mkobsfile---------routines for preprocessing ap/daophot output
	    |-parser------------the parser code
	    |-test--------------directory of test data


Lindsey Davis
NOAO IRAF GROUP
August 1991

                  The Daophot Photometry Package
                 ----------------------------------

The daophot package contains routines which perform crowded-filed
photometry using point spread functions fitting techniques.
The aperture photometry package routines are used to provide initial
estimates for the magnitudes of these objects.

The daophot directory structure is listed below. The package organization
is by task, for example the nstar subdirectory contains routines
specific to the nstar task or by function.
The .h files are all in lib as many of them are shared by several tasks.

             |-addstar-------routines specific to the addstar task
             |-allstar-------routines specific to the allstar task
	     |-daoedit-------routines specific to the daoedit task
             |-daolib--------routines common to many daophot tasks
             |-doc-----------daophot documentation
             |-group---------routines specific to the group task
|-daophot----|-lib-----------daophot definitions or .h files
             |-nstar---------routines specific to the nstar task
             |-peak----------routines specific to the peak task
	     |-psf-----------routines specific to the psf/pstselect tasks
	     |-seepsf--------routines specific to the seepsf task
	     |-select--------routines specific to the grpselect/psfmerge tasks
             |-substar-------routines specific to the substar task
	     |-test----------directory of test data


Lindsey Davis
NOAO IRAF GROUP
May 1993

RTAR -- Read tar format file or tape.  This is a portable, non-UNIX, non-
	proprietary program for reading tar format files on a variety of
	systems.  The TAR format is an excellent choice for transporting
	files between different machines because of its simplicity, efficiency,
	and machine independence.

FONT Generation Utilities  (August 1997)
----------------------------------------

This directory contains utilities for building font tables for the GIO
system executables.  For reference we include here the font tables for
the standard and greek fonts currently installed in the system:

	font.com		standard text font (Roman)
	greek.com		greek character font
	
These table were built from the Hershey stroke data using the following 
files:

	mkfont.c		task to build font table
	hershey.dat		Hershey stroke data table

Once compiled the MKFONT task can be used to build the table with a command
such as

		% mkfont < romant.txt > font.com

Note that by default the tables are created with a "chr" prefix for the
index, width, and character tables in the .com file.  When building a new
Greek or other symbolic font these should be changed appropriately.
	

Addition input files for fonts supplied here include:

	futural.txt	Futura (light)
	futuram.txt	Futura (medium)
	gotheng.txt	Gothic (english)
	gothger.txt	Gothic (german)
	gothita.txt	Gothic (italian)
	greekc.txt	Greek (complex)			(current greek.com)
	greeks.txt	Greek (simple)
	math.txt	Math symbols
	meteor.txt	Meteorological symbols
	romans.txt	Roman (simple)
	romant.txt	Roman (Times)			(current font.com)
	scripts.txt	Script text font
	timesr.txt	Times-Roman

This is the home directory for the Kitt Peak vacuum telescope
reduction programs.

README		this file
Revisions	revisions file
asciilook	lookup table for ascii values into the pixelfont
d1900.x		calculate number of days since turn of century
decodeheader.x	decode/print vacuum telescope tape header
destreak.par	
destreak.x	destreak 10830 full disk helium grams
destreak5.cl	script for processing 10830 tape containing 5 grams
destreak5.par
dicoplot.h	header file containing defines for DICOPLOT
dicoplot.par
dicoplot.x	program to make Carrington rotation mape on the Dicomed
doc		documentation directory
ephem.x		program to calculate solar ephemeris data
fitslogr.cl	script, make a log file of a fits tape (daily grams)
fitslogr.par
getsqib.par
getsqib.x	get the squibby brightness image from a full disk gram
gryscl.dico	greyscale lookup table for use with DICOPLOT
imfglexr.x	Get Line with EXtension Real for use with IMFilt
imfilt.x	convolve an image with gaussian kernel, used in destreak
imratio.x	find the ratio between two images, used in merge
imtext.x	subroutine to load text into an image by overwriting pixels
lstsq.x		least squares fitting subroutine
makehelium.cl	script to process a helium 10830 tape into daily grams (180)
makehelium.par
makeimages.cl	script to process a magnetogram tape into daily grams (180)
makeimages.par
merge.par
merge.x		program to merge daily grams into Carrington rotation maps
mkpkg		make the package
mrotlogr.cl	script, make a log file of a fits tape (Carrington rotations)
mrotlogr.par
mscan.par
mscan.x		read vacuum telescope area scan tapes
numeric.h	header file for numeric subroutine
numeric.x	subroutine to calculate derivitives of latitude and longitude
		with respect to x and y respectively (used in rmap)
pimtext.par
pimtext.x	program to put text into images by overwriting pixels
pixbit.x	subroutine that looks up text pixel format in pixelfont
pixelfont	pixel font for use with pimtext (no lower case, no decenders)
putsqib.par
putsqib.x	program to put the squibby brightness back in a full disk gram
quickfit.par
quickfit.x	fit an ellipse to the limb of the sun
readheader.x    read a vacuum telescope header
readss1.x	subroutine to read a type 1 area scan
readss2.x	subroutine to read a type 2 area scan
readss3.x	subroutine to read a type 3 area scan
readss4.x	subroutine to read a type 4 area scan
readsubswath.x	subroutine to read a sub-swath
readvt.par
readvt.x	read full disk grams from tape
rmap.par
rmap.x		map full disk grams into daily grams (180x180)
syndico.x	Make dicomed print of daily grams 18 cm across.
tcopy.par
tcopy.x		tape to tape copy program
trim.par
trim.x		trim a full disk gram using squibby brightness info
unwrap.par
unwrap.x	program to remove binary wrap-around from images
vt.h
vtblink.cl	script to blink images on the IIS to check registration
vtblink.par
vtel.cl		load the vacuum telescope package
vtel.hd		info about locations of various files
vtel.men	menu for package
vtel.par
vtexamine.par
vtexamine.x	program to examine a vacuum telescope tape (tell about record
		lengths, header info, number of files, etc.)
writetape.cl	script to write five full disk grams to tape
writetape.par
writevt.par
writevt.x	program to write a full disk gram to tape in mountain format
x_vtel.x	package parent program

IMIO$IMFORT/ZZDEBUG -

    This directory contains a set of Fortran programs used to test the IMFORT
software, and to provide real working examples illustrating the use of the
IMFORT interface in host Fortran programs.

	hello.f		prints `hello, world!'
	imcopy.f	copy an image
	imdel.f		delete an image
	imren.f		rename an image
	keyw.f		test header keyword access
	minmax.f	update datamin, datamax
	mkim.f		make a test image, pix[i,j] = j * 100 + i
	pcube.f		print a subraster, e.g., of a MKIM test image
	phead.f		print an image header in FITS format
	planck.f	compute the planck function
	readim.f	test sequential read through an image

To compile individual programs:		cl> fc prog.f
To define the tasks to the CL:		cl> cl < tasks.cl (edit tasks.cl first)

                SKYWCS: The Sky Coordinates Package

1. Introduction

    The skywcs package contains a simple set of routines for managing sky
coordinate information and for transforming from one sky coordinate system to
another. The sky coordinate system is defined either by a system name, e.g.
"J2000", "galactic", etc., or by an image system name, e.g. "dev$ypix" or
"dev$ypix world".

    The skywcs routine are layered on the Starlink Positional Astronomy library
SLALIB which is installed in the IRAF MATH package. Type "help slalib option=
sys" for more information about SLALIB.


2. The Interface Routines

The package prefix is sk. The interface routines are listed below.

   stat = sk_decwcs (ccsystem, mw, coo, imcoo)
   stat = sk_decwstr (ccsystem, coo, imcoo)
   stat = sk_decim (im, wcs, mw, coo)
	  sk_enwcs (coo, ccsystem, maxch)
 newcoo = sk_copy (coo)
          sk_iiprint (label, imagesys, mw, coo) 
          sk_iiwrite (fd, label, imagesys, mw, coo) 
[id]val = sk_stat[id] (coo, param)
          sk_stats (coo, param, str, maxch)
	  sk_set[id] (coo, param, [id]val)
          sk_sets (coo, param, str)
	  sk_ultran (incoo, outcoo, ilng, ilat, olng, olat, npts)
	  sk_lltran (incoo, outoo, ilng, ilat, ipmlng, ipmlat, px, rv,
             olng, olat)
	  sk_equatorial (incoo, outcoo, ilng, ilat, ipmlng, ipmlat, px,
	     rv, olng, olat)
	  sk_saveim (coo, mw, im)
	  sk_close (coo)


3. Notes

    An "include <pkg/skywcs.h>" statement must appear in the calling program
to make the skywcs package parameter definitions visible to the calling
program.

    A "-lxtools -lslalib" must be included in the calling program link line
to link in the skywcs and the slalib routines.

    The sky coordinate descriptor is created with a call to one of the
sk_decwcs, sk_decwstr, or sk_imwcs routines. If the source of the sky
coordinate descriptor is an image then an IRAF MWCS descriptor will be returned
with the sky oordinate descriptor. The sky coordinate descriptor is freed with a
call to sk_close. A separate call to mw_close must be made to free the MWCS
descriptor if one was allocated.

    By default the main skywcs coordinate transformation routine sk_ultran
assumes that the input and output sky coordinates are in hours and degrees
if the input and output coordinate systems are equatorial, otherwise the
coordinates are assumed to be in degrees and degrees. The default input and
output sky coordinate units can be reset with calls to sk_seti. Two lower level
coordinate transformations for handling proper motions sk_lltran and
sk_equatorial are also available. These routines assume that the input and
output coordinates and proper motions are in radians.

    Calling programs working with both sky coordinate and MWCS descriptors
need to be aware that the MWCS routines assume that all sky coordinates
will be input and output in degrees and adjust their code accordingly.

    The skywcs routine sk_saveim can be used to update an image header.


3. Examples

Example 1: Convert from B1950 coordinates to J2000 coordinates.

    include <skywcs.h>

    ....

    # Open input coordinate system.
    instat = sk_decwstr ("B1950", incoo, NULL)
    if (instat == ERR) {
	call sk_close (incoo)
	return
    }

    # Open output coordinate system.
    outstat = sk_decwstr ("J2000", outcoo, NULL)
    if (outstat == ERR) {
	call sk_close (outcoo)
	return
    }

    # Do the transformation assuming the input coordinates are in hours
    # and degrees. The output coordinates will be in hours and degrees
    # as well.
    call sk_ultran (incoo, outcoo, rain, decin, raout, decout, npts) 

    # Close the coordinate descriptors.
    call sk_close (incoo)
    call sk_close (outcoo)

    ...


Example 2: Repeat example 1 but convert to galactic coordinates.

    include <skywcs.h>

    ....

    # Open the input coordinate system.
    instat = sk_decwstr ("B1950", incoo, NULL)
    if (instat == ERR) {
	call sk_close (incoo)
	return
    }

    # Open the output coordinate system.
    outstat = sk_decwstr ("galactic", outcoo, NULL)
    if (outstat == ERR) {
	call sk_close (outcoo)
	return
    }

    # Dd the transformation assuming the input coordinates are in hours and
    # degrees. The output coordinates will be in degrees and degrees.
    call sk_ultran (incoo, outcoo, rain, decin, raout, decout, npts) 

    # Close the coordinate descriptors.
    call sk_close (incoo)
    call sk_close (outcoo)

    ...

Example 3: Convert a grid of pixel coordinates in the input image to the
equivalent pixel coordinate in the output image using the image world
coordinate systems to connect the two.

    include <skywcs.h>

    ....

    # Mwref will be defined because the input system is an image.
    refstat = sk_decwcs ("refimage logical", mwref, refcoo, NULL)
    if (refstat == ERR || mwref == NULL) {
	if (mwref != NULL)
	    call mw_close (mwref)
	call sk_close (refcoo)
	return
    }

    # Set the reference coordinate descriptor so it expects input in degrees
    # and degrees.
    call sk_seti (refcoo, S_NLNGUNUTS, SKY_DEGREES)
    call sk_seti (refcoo, S_NLATUNUTS, SKY_DEGREES)

    # Mwout will be defined because the output system is an image.
    outstat = sk_decwcs ("image logical", mwout, outcoo, NULL)
    if (outstat == ERR || mwout == NULL) {
	if (mwout != NULL)
	    call mw_close (mwout)
	call sk_close (outcoo)
	call mw_close (mwref)
	call sk_close (refcoo)
	return
    }

    # Set the output coordinate descriptor so it will output coordinates
    # in degrees and degrees.
    call sk_seti (outcoo, S_NLNGUNUTS, SKY_DEGREES)
    call sk_seti (outcoo, S_NLATUNUTS, SKY_DEGREES)

    # Compute pixel grid in refimage and store coordinate in the arrays
    # xref and yref.
    npts = 0
    do j = 1, IM_LEN(im,2), 100 {
        do i = 1, IM_LEN(im,1), 100 {
	    npts = npts + 1
	    xref[npts] = i
	    yref[npts] = j
	}
    }

    # Convert xref and yref to celestial coordinates raref and decref using
    # mwref. The output coordinates will be in degrees and degrees.
    ctref = mw_sctran (mwref, "logical", "world", 03B)
    do i = 1, npts
	call mw_c2trand (ctref, xref[i], yref[i], raref[i], decref[i])
    call ct_free (ctref)

    # Convert the reference celestial coordinates to the output celestial
    # coordinate system using the coordinate descriptors.
    call sk_ultran (refcoo, outcoo, raref, decref, raout, decout, npts)

    # Convert the output celestial coordinates to  pixel coordinates in
    # the other image using mwout.
    ctout = mw_sctran (mwout, "world", "logical", 03B)
    do i = 1, npts
	call mw_c2trand (ctout, raout[i], decout[i], xout[i], yout[i])
    call ct_free (ctout)

    # Print the input and output pixel coordinates.
    do i = 1, npts {
	call printf ("%10.3f %10.3f  %10.3f %10.3f\n")
	    call pargd (xref[i])
	    call pargd (yref[i])
	    call pargd (xout[i])
	    call pargd (yout[i])
    }

    # Tidy up.
    call mw_close (mwref)
    call mw_close (mwout)
    call sk_close (refcoo)
    call sk_close (outcoo)


Example 4: Convert a 2D image with an J2000 tangent plane projection wcs to the
equivalent galactic wcs. The transformation requires a shift in origin and a
rotation. Assume that the ra axis is 1 and the dec axis is 2. The details of
how to compute the rotation are not shown here. See the imcctran task for
details.

    include <mwset.h> 
    include <skywcs.h>

    ...

    # Open image.
    im = immap (image, READ_WRITE, 0)

    # Open the image coordinate system.
    instat = sk_decim (im, "logical", mwin, cooin)
    if (instat == ERR || mwin == NULL) {
	...
	call sk_close (cooin)
	...
    }

    # Get the dimensions of the mwcs descriptor. This should be 2.
    ndim = mw_ndim (mwin, MW_NPHYSDIM)

    # Get the default coordinates to degrees and degreees.
    call sk_seti (cooin, S_NLNGUNITS, SKY_DEGREES)
    call sk_seti (cooin, S_NATGUNITS, SKY_DEGREES)

    # Open the output coordinate system. Mwout is NULL because this system
    # is not an image.
    outstat = sk_decwstr ("galactic", mwout, cooout, cooin)
    if (outstat == ERR) {
        ...
	call sk_close (outstat)
	...
    }

    # Make a copy of the mwcs descriptor.
    mwout = mw_newcopy (mwin)

    # Allocate space for the r and w vectors and cd matrix.
    call malloc (r, ndim, TY_DOUBLE)
    call malloc (w, ndim, TY_DOUBLE)
    call malloc (cd, ndim * ndim, TY_DOUBLE)
    call malloc (newcd, ndim * ndim, TY_DOUBLE)

    # Assume for simplicty that the MWCS LTERM is the identify transform.
    # so we don't have to worry about it. Get the WTERM which consists
    # of r the reference point in pixels, w the reference point in degrees,
    # and the cd matrix in degrees per pixel.
    call mw_gwtermd (mwin, Memd[r], Memd[w], Memd[cd], ndim)

    # Convert the world coordinates zero point. The pixel zero point
    # remains the same.
    tilng = Memd[w]
    tilat = Memd[w+1]
    call sk_ultran (incoo, outcoo, tilng, tilat, tolng, tolat, 1)
    Memd[w] = tolng
    Memd[w+1] = tolat

    # Figure out how much to rotate the coordinate system and edit the
    # compute a new CD matrix. Call it newcd.
    ...

    # Enter the new CD matrix and zero point.
    call mw_swterm (mwout, Memd[r], Memd[w], Memd[newcd], ndim)

    # Update the header. 
    call sk_saveim (cooout, mwout, im)
    call mw_saveim (mwout, im)
    ...

    # Tidy up.
    call mfree (r, TY_DOUBLE)
    call mfree (w, TY_DOUBLE)
    call mfree (cd, TY_DOUBLE)
    call mfree (newcd, TY_DOUBLE)
    call mw_close (mwin)
    call mw_close (mwout)
    call sk_close (cooin)
    call sk_close (cooout)
    call imunmap (im)

BOOTLIB -- C callable file primitives used by the bootstrap utilities.

This is a somewhat adhoc interface consisting of a collection of low level
functions required by the bootstrap utilities.  As far as possible these
use the iraf kernel, but occasionally non-kernel facilities are required or
desirable.  The purpose of this interface is to isolate the machine dependence
of the bootstrap utilities from the bulk of the code, making it easier to
maintain IRAF on different hosts, as well as to make it easier to port IRAF
to a new host.  No attempt has been made to specify this interface carefully;
it is not necessary since only a limited number of programs use the routines.

Partial list of functions (grows sporadically):

	char *	     vfn2osfn (vfn, mode)		# Map filenames
	char *	     osfn2vfn (osfn)

	      fd = os_diropen (dir)			# Read directories
		  os_dirclose (fd)
		     os_gfdir (fd, fname, maxch)

	bool	    os_access (fname, mode, type)	# General file
		     os_chdir (dir)
		     os_close (fd)
		       os_cmd (cmd)
		     os_close (fd
		 os_createdir (dirname, mode)
		os_createfile (fname, mode, type)
		    os_delete (fname)
		     os_fcopy (oldfile, newfile)
		 os_fpathname (vfn, pathname, maxch)
	long	     os_fdate (file)
	char *      os_getenv (ennvar)
		 fd = os_open (fname, mode, type)
		  os_setfmode (fname, mode)
		  os_setowner (fname, uid, gid)
		  os_setmtime (fname, mtime)
		   os_sysfile (fname, outstr, maxch)
		      os_read (fd, buf, nbytes)
		     os_write (fd, buf, nbytes)

	       fd = tape_open (fname, mode)		# Tape or disk file
		   tape_close (fd)
		    tape_read (fd, buf, nbytes)
		   tape_write (fd, buf, nbytes)


Tasks which use this library must also use the kernel library (libos.a).
Tasks which use full filename mapping will also need libsys.a and libvops.a,
however the system can be bootstrapped with simpler filename mapping and
then the utilities relinked with full filename mapping, once the system
libraries have been generated.  Note that no VOS level i/o is used (only
kernel level i/o functions are used), hence an IRAF main is not required
to initialize the VOS i/o system.

This directory (dataio$idsmtn) contains code for the mountain format
IIDS/IRS tapes.  Either raw or mountain reduced data tapes are read
with task ridsmtn.  This task was installed in dataio 11/84.  SEH

		CATQUERY: The Catalog and Survey Access Routines

1. Introduction

    The catquery package provides a set of routines for local and remote
catalog and image survey server access. The supported catalogs and image
surveys are described in records stored in a catalog and image survey
configuration file respectively. The catalog and image survey records
specify the network address, the query format, and the output format for
each supported catalog or image display server. More detailed information
about catalogs and image survey access and configuration files can be
found by typing "help catalogs" and "help surveys".

    The results of each catalog query are stored in memory in an IRAF spool
file.  Calling programs can access the catalog results sequentially or randomly
by record number. Individual fields in each record can be decoded into
floating point, integer, or string values.

The results of each image survey query are written to an image file on disk,
currently a fits image file. IRAF image i/o routines can be used to access
the image. There must be enough space availale on the disk to receive the
image.


2. The Interface Routines

The package prefix is cq. The interface routines are listed below.

           cq = cq_map (file, mode)
	 ival = cq_stati (cq, param)
	        cq_stats (cq, param, str, maxch)
       nlines = cq_statt (cq, param, text, maxch)

	catno = cq_locate (cq, name)
	catno = cq_locaten (cq, catno, catname, maxch)
	catno = cq_setcat (cq, name)
	catno = cq_setcatn (cq, catno)

     [ird]val = cq_fget[ird] (cq, name)
       nelems = cq_fga[ird] (cq, name, array[ird], max_nelems)
                cq_fgstr (cq, name, str, maxch)
                cq_fgwrd (cq, name, wrd, maxch)
       nlines = cq_fgtext (cq, name, text, maxch)
         stat = cq_scan (cq)

	nqpars = cq_nqpars (cq)
	qparno = cq_gqpar (cq, name, qpname, max_qpname, qpvalue,
	         max_qpvalue, qpunits, max_qpunits, qpformat,
		 max_qpformat)
	qparno = cq_gqparn (cq, qparno, qpname, max_qpname, qpvalue,
 	         max_qpvalue, qpunits, max_qpunits, qpformat, max_qpformat)
	qparno = cq_sqpar (cq, name, valuestr)
	qparno = cq_sqparn (cq, qparno, valuestr)

	   res = cq_query (cq)
	   res = cq_fquery (cq, catfile, cathdr)
	  ival = cq_rstati (res, param)
	         cq_rstats (res, param, str, maxch)
	nlines = cq_rstatt (res, param, text, maxch)
	hparno = cq_hinfo (res, name, hpvalue, max_hpvalue)
	hparno = cq_hinfon (res, hparno, hpname, max_hpname, hpvalue,
	         max_hpvalue)
	nchars = cq_grecord (res, buffer, maxch, recno)
        nchars = cq_gnrecord (res, buffer, maxch, nextrec)
       fieldno = cq_finfo (res, name, foffset, fsize, ftype, funits,
		 max_funits, formats, max_formats)
       fieldno = cq_finfon (res, fieldno, fname, max_fname, foffset, fsize,
	         ftype, funits, max_funits, formats, max_formats)
	         cq_rclose (res)
       nchars = cq_gval[silrd] (res, name, [silrd]val)
       nchars = cq_gvalc (res, name, str, maxch)

	 imres = cq_imquery (cq, imname)
	 imres = cq_fimquery (cq, imname)
	  ival = cq_istati (imres, param)
	         cq_istats (imres, param, str, maxch)
	nlines = cq_istatt (imres, param, text, maxch)
	wparno = cq_winfo (imres, name, wkname, max_wkname, wvalue,
	         max_wvalue, wtype, wunits, max_wunits)
	wparno = cq_winfon (imres, wparno, wpname, max_wpnane, wkname,
	         max_wkname, wvalue, max_wvalue, wtype, wunits, max_wunits)
	kparno = cq_kinfo (imres, name, skname, max_skname, svalue,
	         max_svalue, stype, sunits, max_sunits)
	kparno = cq_kinfon (imres, kparno, spname, max_spname, skname,
	         max_skname, svalue, max_svalue, stype, sunits, max_sunits)
	         cq_imclose (imres)

        cq_unmap (cq)


3. Notes

    An "include <pkg/cq.h>" statement must appear in the calling program to
make the catquery pacakge parameter definitions visible to the calling program. 

    A "-lxtools" must be included in the calling program link line to link in
the catquery routines.

    The catalog and image surveys configuration files are mapped and unmapped
with the routines cq_map and cq_unmap.

    Before making a query the calling program must set the current catalog
or image survey with the cq_setcat or cq_setcatn routines, and format
and set the query parameters with the cq_gqpar, cq_gqparn, and cq_sqparn
routines. 

    Remote and locate catalog queries are made with the cq_query routine.
The routines cq_rstat[ist] are used to retrieve the catalog results parameters.
Header parameter values and field descriptions can be retrieved with
the cq_hinfo / cq_hinfon and cq_finfo / cq_finfon routines respectively.
Catalog records can be accessed sequentially or randomly with the cq_gnrecord
and cq_grecord routines. The cq_gval[csilrd] routines can be used to decode
the record fields into floating point, integer, or string values.  The
cq_fquery routine is used to make a catalog file emulate the results of a
catalog query. Cq_rclose frees the catalog results descriptor.

    Remote and locate image survey queries are made with the cq_imquery routine.
The routines cq_istat[ist] are used to retrieve the survey results parameters.
The standard wcs and image parameter descriptions can be retrieved with the
the cq_winfo / cq_winfon and cq_kinfo / cq_kinfon routines respectively. The
cq_fimquery routine is used to make an existing image emulate the results of
an image survey query. Cq_imclose frees the survey results descriptor.

4. Examples

Example 1: Query a catalog and dump the results to a catalog file.

    include <cq.h>

    ....

    ra = clgetd ("ra")
    dec = clgetd ("dec")
    width = clgetd ("width")

    ....

    # Open the catalog configuration file.
    cq = cq_map ("astromz$lib/catdb.dat", READ_ONLY)
    if (cq == NULL)
	...

    # Set the catalog.
    catno = cq_setcat (cq, "noao@usno2")
    if (catno == 0)
	...

    # Set the query parameters. Assume the input input units match the
    # the expected units. The input size is a width so divide by two 
    # if the query expects a radius.
    nqpars = cq_nqpars (cq)
    do i = 1, nqpars {
	parno = cq_gqparn (cq, i, qpname, CQ_SZ_QPNAME, qpvalue,
    	    CQ_SZ_QPVALUE, qpunits, CQ_SZ_QPUNITS, qpformats
	    CQ_SZ_QPFORMATS)
	if (parno != i)
	    next
	if (streq (qpname, "ra")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (ra)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "dec")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (dec)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "radius")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (width / 2.0d0)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "width")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (width)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "xwidth")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (width)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "ywidth")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (width)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	}
    }

    # Make the query.
    res = cq_query (cq)
    if (res == NULL)
	...

    # Write the results to a file.
    recptr = 0
    while (cq_gnrecord (res, buffer, SZ_LINE, rectpr) != EOF) {
	call fprintf (outfd, "%s")
	    call pargstr (buffer)
    }

    # Close the query.
    call cq_rclose (res)

    # Close the database.
    call cq_unmap (cq)


Example 2: Repeat the previous example but only output records for
	   which magnitude values  <= 16.0.

     include <cq.h>

     ...

     res = cq_query (cq)
     if (res == NULL)
	...

     nrec = cq_rstati (res, CQNRECS)
     do i = 1, nrecs {
	nchars = cq_gvalr (res, i, "mag1", mag)
	if (nchars <= 0)
	    next
	if (mag > 16.0)
	    next
	nchars = cq_grecord (res, buffer, SZ_LINE, i)
	if (nchars <= 0)
	    next
	call fprintf (outfd, "%s")
	    call pargstr (buffer)
     }

     call cq_rclose (res)

     ...


Example 3: Make an image survey query and dump the results to a fits file.

    include <cq.h>

    ....

    ra = clgetd ("ra")
    dec = clgetd ("dec")
    width = clgetd ("width")

    ....

    # Open the catalog configuration file.
    cq = cq_map ("astromz$lib/imdb.dat", READ_ONLY)
    if (cq == NULL)
	...

    # Set the catalog.
    catno = cq_setcat (cq, "dss1@cadc")
    if (catno == 0)
	...

    # Set the query parameters. Assume the input input units match the
    # the expected units. 
    nqpars = cq_nqpars (cq)
    do i = 1, nqpars {
	parno = cq_gqparn (cq, i, qpname, CQ_SZ_QPNAME, qpvalue, CQ_SZ_QPVALUE,
	    qpunits, CQ_SZ_QPUNITS, qpformats, CQ_SZ_QPFORMATS)
	if (parno != i)
	    next
	if (streq (qpname, "ra")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (ra)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "dec")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (dec)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "width")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (width)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "xwidth")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (width)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	} else if (streq (qpname, "ywidth")) {
	    call sprintf (qpvalue, CQ_SZ_QPVALUE, qpformats)
		call pargd (width)
	    parno = cq_sqpars (cq, qpname, qpvalue)
	}
    }

    # Make the query.
    imres = cq_imquery (cq, "outimage.fits")
    if (imres == NULL)
	...

    # Free the results structure
    call cq_imclose (imres)

    # Unmap the database
    call cq_unmap (cq)



Example 4:  Repeat the previous example but convert the dss wcs to a fits wcs.
At_mkdss is a routine which converts a dss wcs to a fits wcs

    ...

    # Make the query.
    imres = cq_imquery (cq, "outimage.fits")
    if (imres == NULL)
        ...

    wcstype = cq_istati (imres, CQWCS)
    if (wcstype == CQWDSS) {
        im = immap ("outimage.fits", READ_WRITE, 0)
        stat = at_mkdss (im, true, false)
        if (stat == ERR)
            ...
        call imunmap (im)
    }

    # Free the results structure
    call cq_imclose (imres)

    ...

# These routines are part of the FITSIO library and are designed to run in
# the IRAF/SPP environment.
#------------------------------------------------------------------------------
#   This software was prepared by High Energy Astrophysics Science Archive
#   Research Center (HEASARC) at the NASA Goddard Space Flight Center. Users
#   shall not, without prior written permission of the U.S. Government,
#   establish a claim to statutory copyright.  The Government and others acting
#   on its behalf shall have a royalty-free, non-exclusive, irrevocable,
#   worldwide license for Government purposes to publish, distribute,
#   translate, copy, exhibit, and perform such material.
#------------------------------------------------------------------------------
#
# In the standard FITSIO distribution, the SPP source files in this
# directory are contained in a single file, fitssppb.x.

	This directory contains the source code for the 'builtin' formats 
converted with IMPORT.  Here we implement three formats that require different
levels of processing: the GIF format uses LZW compression and a colormap for
pixel storage and requires the most work, Sun Rasterfiles have various formats
that may require colormap application or RLE decoding, and lastly the X 
Window Dump format that fits the generic binary raster model with the exception
of an 8-bit file with a colormap.
	Because formats are defined in the data base the user is unaware of
any special processing that occurs unless implementing a new format that
requires partivular handling.  In the case of colormap files the example of
XWD can be followed and all that's needed is a routine to read the colormap
from the image.  'Builtin' formats must, however, be declared in the source
import$ipbuiltin.x to route execution to the format-specific code.

PLF -- Partial, IKI mini-driver for the pixel list (PLIO) image format.

Only part of the IKI routines are implemented here.  The open/close, header
access, and i/o functions are handled as a special case directly in the
IMIO code (see the impm*.x routines, and im[rd|wr]px.x).

CONLIB -- This directory contains the contents of the NCAR files concom.f and
conterp.f, unpacked one subroutine per file.  The unpacking operation is
necessary to permit topological ordering of the library.

IKI/STF -- IKI kernel for the STScI SDAS/GEIS image format.  This format stores
images in a format which resembles FITS group format.  A GROUP FORMAT IMAGE is
a set of one or more images, all of which are the same size, dimension, and
datatype, and which share a common FITS header.  The individual images in a
group each has a binary GROUP PARAMETER BLOCK (GPB).  The image and associated
group parameter block are commonly referred to as a GROUP.  A group format
image consists of two files, the FITS format header file for the group,
and the pixel file containing the image data and GPBs.


1. Typical STF group format FITS image header (imname.hhh)

	SIMPLE	=		    F		/ Standard STF keywords
	BITPIX	=		    32
	DATATYPE= 'REAL*4	'
	NAXIS	=		    2
	NAXIS1	=		    512
	NAXIS2	=		    512
	GROUPS	=		    T
	PSIZE	=		    512
	GCOUNT	=		    1
	PCOUNT	=		    12

	PTYPE1	= 'DATAMIN	'		/ Define binary group params
	PSIZE1	= 		    32
	PDTYPE1	= 'REAL*4	'
	    (etc, for a total of 3*PCOUNT entries)

	(special keywords and HISTORY cards)


2. Pixel file format (imname.hhd) (byte stream, no alignment, no header)

	[1].pixels
	[1].group parameter block
	[2].pixels
	[2].group parameter block
		...
	[GCOUNT].pixels
	[GCOUNT].group parameter block


The chief problems with this format are that the FITS format header can contain
only parameters which pertain to the group as a whole, while the format of the
GPBs is fixed at image creation time.  Images may be neither deleted from nor
added to a group.  It is possible for parameters in the FITS header to have
the same names as parameters in the GPBs.  Multiple entries for the same
keyword may appear in the FITS header and the format does not define how
these are to be handled.  Although the format is general enough to support
any datatype pixels, in practice only REAL*4 can be used as the SDAS software
maps the pixfile directly into virtual memory.

CAVEAT -- This is an awkward interface and some liberties have been taken in
the code (hidden, subtle semantics, etc.).  At least we were able to confine
the bad code to this one directory; any problems can be fixed without any
changes to the rest of IMIO.  All of this low level code is expected to be
thrown out when IMIO is cut over onto DBIO (the upcoming IRAF database
interface).


IKI/STF Pseudocode
----------------------------

1. Data structures:

	1.1 IMIO image descriptor
	    header, pixel file descriptors
	    pointer to additional kernel descriptor, if any
	    index of IKI kernel in use
	    pathnames of header, pixel files
	    IM_NDIM, IM_LEN, etc., physical image parameters

	1.2 STF image descriptor
	    Pointed to by IM_KDES field of IMIO descriptor.
	    Contains values of all reserved fields of STF image header,
		some of which duplicate values in IMIO descriptor.
	    Group, gcount, size of a group in pixfile, description of
		the group parameter block, i.e., for each parameter,
		the offset, datatype type, name, length if array, etc.

	1.3 IMIO user area (FITS cards)
	    While an image is open, the first few cards in the user area
		contain the FITS encoded group parameters.
	    The remainder of the user area contains an exact image of
		all non-reserved keyword cards found in the STF image
		header (or in the header of some other type of image
		when making a new_copy of an image stored in some other
		format).


2. Major Procedures

procedure open_image

begin
	if (mode is not new_image or new_copy) {
	    open_existing_image
	    return
	}

	We are opening a new_image or new_copy image.  The problem here is
	that the new image might be a group within an existing group format
	image.  This ambiguity is resolved by a simple test on the group
	index, rather than by a context dependent test on the existence of
	the group format image.  If the mode is new_whatever and the group
	is 1, a new group format image is created, else if the group is > 1,
	the indicated group is initialized in an existing group format image.

	if (group > 1) {
	    We are opening a new group within an existing group format image.

	    Call open_existing_image to open the group without reading the
		group parameter block, which has not yet been initialized.

	    if (mode is new_image)
		initialize GPB to pixel coords
	    else if (mode is new_copy)
		copy old GPB to new image; transform coords if necessary

	    Note that when opening a new copy of an existing image as a new
	    group within a group format image, it is not clear what to do
	    with the FITS header of the old image.  Our solution is to ignore
	    it, and retain only the GPB, the only part of the old header
	    pertaining directly to the group being accessed.

	} else if (opening group 1 of a new image) {
	    We are creating a new group format image.

	    if (mode is new_image)
		open_new_image
	    else
		open_new_copy
	}
end


procedure open_existing_image

begin
	Allocate STF descriptor, save pointer in imio descriptor.
	Open image header.

	Read header:
		process reserved cards into STF descriptor
		spool other cards

	Load group data block from pixfile, get datamin/datamax:
		if (there is a gdb) {
		    open pixfile
		    read gdb into buffer
		    for (each param in gdb) {
			set up parameter descriptor
			format FITS card and put in imio user area
		    }
		}

		fetch datamin, datamax from user area

	Set IM_MIN, IM_MAX, IM_LIMTIME from DATAMIN, DATAMAX.
	Mark end of user area.
	Copy spooled cards to user area.
		(increase size of user area if necessary)

	Call imioff to set up imio pixel offset parameters
end


procedure open_new_image

begin
	Upon entry, the imio iminie procedure has already been called to
	    initialize the imio descriptor for the new image.

	Allocate STF descriptor, save pointer in imio descriptor.
	Create header file from template dev$pix.hhh.
	Open new image header.

	(At this point the IMIO header fields IM_NDIM, IM_LEN, etc., and
	(the STF descriptor fields have not yet been set, and cannot be set
	(until the image dimensions have been defined by the high level code.
	(imopix() will later have to fix up the remaining header fields and
	(set up the default group data block.
end


procedure open_new_copy

begin
	Upon entry, the imio immaky procedure has already been called to
	    copy the old header to the new and initialize the data
	    dependent fields.  This will include the FITS encoded group
	    parameters in the user area of the old image.

	Allocate STF descriptor, save pointer in imio descriptor.
	Create header file from template dev$pix.hhh.
	Open new image header.

	Copy the STF descriptor of the old image to the new.  Preserve
	    the parameter marking the end of the GPB area of the old
	    user area, as we do not want to write these cards when the
	    header is updated.

	(At this point all header information is set up, except that there
	(is no pixel file and the pixfile offsets have not been set.
	(Provided the image dimensions do not change, one could simply
	(set the pixfile name, call imioff, and do i/o to the image.
end


procedure open_pixel_file

begin
	(We are called when the first i/o is done to an image.  When writing
	(to a new image, the user may change any of the image header attributes
	(after the open and before we are called.

	if (pixel file already open)
	    return
	else if (opening existing image) {
	    open pixel file
	    return
	}

	if (opening a new image) {
	    Given the values of IM_NDIM and IM_LEN set by the user, set up the
	    STF descriptor including the default group parameter block.  Add
	    the FITS encoded cards for the GPB to the image header.  Mark the
	    end of the GPB cards, i.e., the start of the real user parameter
	    area.  Ignore IM_PIXTYPE; always open an image of type real since
	    that is what the SDAS software requires.  Set up the WCS to linear
	    pixel coordinates.

	} else if (opening a new_copy image) {
	    (The STF descriptor and GPB will already have been set up as a
	    (copy of the data structures used by the old image.  However,
	    (the user may have changed the values of IM_NDIM and IM_LEN
	    (since the image was opened, and the value of GCOUNT set when
	    (the image was opened may be different than that of the old image.

	    Transform the coordinate system of the old image to produce the
	    WCS for the new image, i.e., if an image section was used to
	    reference the old image.

	    Make a new STF descriptor using the values of IM_NDIM and IM_LEN
	    given, as for a new_image, but using the WCS information for the
	    new image.  The FITS encoded fields in the IMIO user area will be
	    automatically updated by the IMADD functions, or new cards added
	    if not present.

	    Merge any additional fields from the old STF descriptor into the
	    new one, e.g., any instrument dependent parameters stored in the
	    GPB.

	    (The STF and FITS encoded user area should now contain a full
	    (description of the GPB for the new image.
	}

	Allocate the pixel file, using the GCOUNT parameter set in the
	    STF descriptor at stf_open time.
	Open the pixel file.

	Set IM_MIN and IM_MAX to zero (not defined).
	Call IMIOFF to initialize the pixel offsets.
end


procedure update_image_header

begin
	Update the values of DATAMIN, DATAMAX from the IMIO header fields.

	Update the binary GPB in the pixel file from the FITS encoded GPB
	    in the IMIO user area, using the GPB structure defined in the
	    STF descriptor.

	Update the STF image header file:
	    Open a new, empty header file using FMKCOPY and OPEN.
	    Format and output FITS cards for the reserved header fields,
		e.g., SIMPLE, BITPIX, GCOUNT, the GPB information, etc.
	    Copy the user area to the new header file, excluding the
		GPB cards at the beginning of the user area.
	    Close the new header file and replace the old header file
		with the new one via a rename operation.
end


procedure close_image

begin
	(We assume that IMIO has already update the image header if such
	(is necessary.

	if (pixel file open)
	    close pixel file
	if (header file open)
	    close header file

	deallocate STF descriptor
	(IMIO will deallocate the IMIO descriptor)
end

This directory contains the supported standard star catalogs, format
description files, and a template transformation equation set for each
catalog.

The following standard star catalogs are supported.

	  elias.dat - the Elias JHKL standards catalog
	landolt.dat - the Landolt UBVRI standards catalog
       nlandolt.dat - the new Landolt UBVRI standards catalog
	odewahn.dat - the Odewahn BVR cluster standards catalog        (1)
	 porter.dat - the Porter UBVRI standards catalog               (2)
	  ukirt.dat - the UKIRT JHK standards                          (3)
         nicmos.dat - the NICMOS JHKKs standards catalog               (4)
         arnica.dat - the ARNICA JHK standards catalog                 (4)

Each supported catalog has an accompanying format description file which
describes which photometric indices are stored in which column. This file is
used by the MKCONFIG task to construct the user's configuration file. The
following format files are defined.

        felias.dat - format file for Elias JHKL standards
      flandolt.dat - format file for Landolt UBVRI standards
     fnlandolt.dat - format file for new Landolt UBVRI standards
      fodewahn.dat - format file for Odewahn BVR cluster standards
       fporter.dat - format file for Porter UBVRI cluster standards
        fukirt.dat - format file for UKIRT JHK standards
       fnicmos.dat - format file for NICMOS JHKKs standards
       farnica.dat - format file for ARNICA JHK standards

Each supported catalog has an accompanying template transformation file
which defines a default set of transformations equations. This file is
used as a template by the MKCONFIG task to guide the user in the construction
of a set of transformation equations. The following transformation equations
sets are defined.

     telias.dat - template trnasformations for Elias JHKL standards
   tlandolt.dat - template transformations for Landolt UBVRI standards
  tnlandolt.dat - template transformations for new Landolt UBVRI standards
   todewahn.dat - template transformations for Odewahn BVR cluster standards
    tporter.dat - template transformations for Porter UBVRI cluster standards
     tukirt.dat - template transformations for UKIRT JHK standards
    tnicmos.dat - template transformations for the NICMOS JHKKs standards
    tarnica.dat - template transformations for the ARNICA JHK standards

The references for the supported catalogs are listed below.

	   
	      elias.dat - Elias, et. al 1982, A.J. 87, 1029
	    landolt.dat - Landolt, A. U. 1983, A.J.  88, 439
	   nlandolt.dat - Landolt, A. U. 1992, A.J. 104, 340 
	    odewahn.dat - Odewahn, S. C. 1992 PASP 104,553
	     porter.dat - unpublished
	      ukirt.dat - Casali, M. and Hawarden, T. 1992, JCMT-UKIRT
			  Newsletter, 4, 33
	     nicmos.dat - Persson et al. 1998, A.J. 116, 2475
	     arnica.dat - Hunt et al. 1998, A.J. 115, 2594

Notes:

(1) The Odewahn catalog contains data for the clusters NGC4147, NGC7006
    and NGC7790. The data was kindly formatted for use with photcal by Pat
    Hall (Steward Observatory).

(2) The Porter catalog contains unpublished UBVRI data and data compiled from
    the literature for the clusters M67, M92, NGC2264, NGC2419, NGC4147,
    NGC7006, and NGC7790 kindly provided by Alain Porter (KPNO) and formatted
    for use with photcal by Pat Hall (Steward Observatory). The following
    notes describe how the the catalog was compiled.

   Porter.dat contains unpublished UBVRI (**KRON-COUSINS** RI) photometry
   compiled by Alain Porter (KPNO) from personal data, photometry from the
   literature, and photmetry supplied by Lindsey Davis (KPNO).  It is
   basically intended to supplement BVRI data from Christian et.al. (1985).
   The differences between this data and Christian's, and between this data
   and the BVR data of Odewahn et.al. (1992), are well within the errors.
   The only exception is that for stars in common with Odewahn's NGC 7790
   data, this data is ~0.05 mag fainter than Odewahn's data, a difference
   at the 3-sigma level.

   Notes on individual clusters follow, giving the source of the ID numbers
   and references where finding charts can be found.

   M67     ID numbers are from Schild (1983), Eggen & Sandage (1964), or
	   Johnson & Sandage (1955).
   M92     ID numbers are from Christian et.al. or from Sandage (1966).
   NGC2264 ID numbers are from Christian et.al. or from Adams et.al. (1983).
   NGC2419 These values come straight from Christian et.al. and thus there
           is no U information for this cluster.
   NGC4147 ID numbers are from Odewahn et.al.
   NGC7006 ID numbers are from Christian et.al. or from Sandage & Wildey
           (1967).
   NGC7790 ID numbers are from Odewahn et.al., except for C-25 which is star
           25 of Christian et.al.

    REFERENCES
        Adams, M., et. al. 1983, ApJS 53, 893. (field P2 or 2P)
        Christian, C.A., et. al. 1985, PASP 97, 363.
        Eggen, O. and Sandage, A. 1964, ApJ 140, 130.
        Johnson, H. and Sandage, A. 1955, ApJ 121, 616.
        Odewahn, S.C., et. al. 1992, PASP 104, 553.
        Sandage, A. 1966, ApJ 143, 313.
        Sandage, A. and Wildey, R. 1967, ApJ 150, 469
        Schild, R.E. 1983, PASP 95, 1021.

(3) The UKIRT JHK catalog was formatted for use with photcal by Pat Hall
    (Steward Observatory).

(1) The NICMOS and ARNICAL catalogs were kindly formatted for use with photcal
by Pat Hall (University or Toronto).

DISPLAY -- Prototype routines for loading and controlling the image display.
The lower level code is device dependent.

	display		loads the display
	dcontrol	adjusts the display (frame select, window, etc.)

The basic strategy is that the image display device is interfaced to IRAF 
file i/o as a binary file.  IMIO is then used to access the image or graphics
planes of the device as a disk resident imagefile would be referenced.
Each image plane of each image device is a separate "imagefile", and has a
distinct image header file in the directory "dev$".

This package uses the ZFIOGD (binary graphics device) device driver, the
source for which is in host$gdev.  It is this driver which implements physical
i/o to the device (actually, to the host system device driver for the device).

# IKI/FXF -- Fits extension image kernel.
# There is a document describing the differents FK supported parameters:
#   iraf.noao.edu/iraf/web/docs/fitsuserguide.html
# A PS file of this can be found in iraf.noao.edu/iraf/docs/fitsuserguide.ps.Z

This directory contains the sources for the NCAR system plot package.
The original source is in the file "plot.4.8.sav".  If any modifications
have to be made, they will be recorded here.

REVISIONS

04Mar84 SET --> SPPSET
	The name of the SET module, used to set the device window and
	user coordinate system, was changed to SPPSET.  The module "set.x"
	in the high level code intercepts calls by the utilities to set,
	so that the transformations may be stored away in a file for recovery
	by another process.

05Mar84 Elimination of Fortran i/o
	All formatted writes to mprint were commented out.

05Mar48 Resolve library conflict
	getchr --> ncgchr		[collision with fio.getchar]
	putchr --> ncpchr		[for consistency with above]

12Mar84 Moved most of the initialization from the block data z8zpbd into
	the initialization subroutine z8zpii, called by nspp_init at
	GOPEN time.

12Dec85 SPPSET -> SET
	Changed this guy back, as the high level interface to the system
	plot package is no longer used.  The NCAR system plot package stuff
	is only used by the GIO/NCAR kernel now.

RPP -- Second pass of the SPP preprocessor.

    While RPP is derived from ratfor, it is not a ratfor preprocessor.
It accepts as input the output of the first pass, XPP, and produces Fortran as
output.  XPP and RPP together with the UNIX driver program XC make up the
preprocessor for the IRAF SPP language.


subdirectories:

	ratlibc		Interface to the host system, written in C
	ratlibf		Fortran version of the ratfor library (used by RPP)
	ratlibr		Ratfor version of the ratfor library
	rppfor		Fortran source for RPP
	rpprat		Ratfor source for RPP


RPP consists of the source for the program itself, the portable library
functions, and the interface to the host system.  Everything required to
compile and link RPP on a host system providing a C and Fortran compiler
is included in these directories.  RPP is currently implemented as a stand
alone (bootstrap) program, i.e. it can be compiled before IRAF itself is
running.  While the ratfor sources for the preprocessor and the library
are included in the distribution, a ratfor preprocessor is not necessary
to compile RPP.  All ratfor sources are distributed already preprocessed
into Fortran.

To compile RPP on a UNIX host type "make".  If there are any problems they
will most likely be in the interface routines, which are not (cannot be)
completely portable.  In particular the definitions in ratlibc/ratdef.h
should be examined to see is they are appropriate for your machine.  The
single biggest difference between different host systems providing C and
simple UNIX like STDIO is in the naming conventions of external identifiers.
All C externals called from Fortran are defined in ratdef.h to make it
easier to change the names.  RPP is a C program (it has a C main) even
though most of the code is written in Fortran.

Source for a Fortran (ratfor) version of the interface routines is provided
in ratlibr/old.  Since XPP is currently written in C we have not bothered
to try to use these routines.

# These routines are part of the FITSIO library and are designed to run in
# the IRAF/SPP environment.
#------------------------------------------------------------------------------
#   This software was prepared by High Energy Astrophysics Science Archive
#   Research Center (HEASARC) at the NASA Goddard Space Flight Center. Users
#   shall not, without prior written permission of the U.S. Government,
#   establish a claim to statutory copyright.  The Government and others acting
#   on its behalf shall have a royalty-free, non-exclusive, irrevocable,
#   worldwide license for Government purposes to publish, distribute,
#   translate, copy, exhibit, and perform such material.
#------------------------------------------------------------------------------
#
# The two files ftgcbf.x and ftpcbf.x were extracted from ../fitsspp.x
# into this directory because they are system dependent.  There is
# another version in the ../vms/ directory which uses the %ref function.

XPP -- First pass of the SPP preprocessor.

    This directory contains the Lex and C sources for the first pass of the
preprocessor for the IRAF SPP (subset preprocessor) language.  XPP takes as
input an SPP source file and produces as output a text file which is further
processed by RPP (the second pass) to produce Fortran.

IISM70 -- Device dependent interface subroutines for the IIS Model 70 image
display device.  This package uses the ZFIOGD device driver, which is
responsible for physical i/o to the device.  The source for the ZFIOGD driver
is in host$gdev; this driver must be compiled and installed in a system library
(libsys.a) before i/o to the IIS will work correctly.

AUTOGRAPH -- This directory contains the contents of the NCAR file
autograph.f, unpacked one subroutine per file.  Here is the revision file 
supplied by NCAR for the autograph package.  For NOAO specific enhancements, 
see gio$ncarutil/README.

 Revision history:

 February, 1979   Added a revision history and enhanced machine
                  independency.

 September, 1979  Fixed a couple of problems which caused the code to
                  bomb when core was pre-set to indefinites and the
                  1st graph drawn was peculiar in some way and another
                  which caused it to set the default dashed-line-speci-
                  fier length wrong.  Added new documentation.

 October, 1979    Changed the way IDIOT behaves when NPTS is negative.

 March, 1980      Fixed a couple of small errors, one which prevented
                  an error exit in AGSETP from ever being reached and
                  another which caused AUTOGRAPH to blow up when given
                  a zero or negative on a logarithmic axis.  Changed
                  the way in which NBPF is computed by AGSTR1.

 August, 1981     Removed all calls setting the plotter intensity and
                  made the computation of the variable SMRL portable.

 April, 1984      Made the code strictly FORTRAN-77 compatible, taking
                  out all dependency on support routines (such as LOC).
                  This required some changes in the user interface.

 February, 1985   Put code in AGSETP to reclaim character-store space
                  used by character-string dash patterns when they are
                  redefined using binary patterns.  Also changed AGGTCH
                  to return a single blank for a non-existent string.

 August, 1985     Put code in AGGETP so that the label-name identifier
                  is now returned properly.  Among other things, this
                  cures a problem which caused the character-storage
                  space to be eaten up.

 December, 1985   Fixed AGSETP to zero the current-line pointer when
                  the current-label pointer is changed.

 January, 1986    Fixed AGAXIS to respond properly to the zeroing of
                  NCIM by AGCHNL.

The procedures in this directory are an implementation of the Unix
curses library, with a few deletions and extensions. The procedures
have been modified to work in an SPP environment instead of a C
environment. Unlike the C routines, they do not return an error status
as a function value. In fact, very few of the procedures call error,
instead they try to do the most reasonable thing. The mv macros are
not implemented, instead the program should call move() followed by
the appropriate procedure. Formatted reads and writes to windows are
not supported, all reading and writing is done using strings.
Subwindows are also not supported. The user program does not have
direct access to the window structure, the function winstat() is
provided to read fields from the structure. In order to make
customization of windows easier, each window can have an input
function and data structure bound to it. The functions bindstruct()
and getstruct() are provided for this purpose. The forms directory
gives several examples of binding functions and data structures to a
window. Two other procedures hidewin() and showwin() are provided to
hide a window which is currently displayed on the terminal and to
redisplay it.

The procedure initscr() should be called before using any of the
procedures in the curses directory. It initializes the terminal and
creates the first window (referred to as STDSCR), which covers the
terminal scrren. The procedure endwin() should be called at the end of
the user program. It closes any windows which are still open and
resets the terminal. Windows are created by calling newwin() and
destroyed by calling delwin(). The terminal cursor is moved by the
procedure move(). Text is written into a window by the procedures
addch() and addstr(). Text is read from the keyboard and displayed in
the window by the procedures getch() and getstr(). Changes to the
window are not displayed until refresh() is called. Fuller
explanations of these and the other curses procedures is given below.

Many procedures in this directory exist in two forms. The first form
uses the default window, STDSCR. This window is created when initscr()
is called and covers the entire screen. The second form uses any
window and has an extra argument to specify which window to use. The
names of the two forms are the same, except that the second has the
letter "w" as the first character. For example, addch() adds a
character to STDSCR, while waddch() adds a character to any window.
The macro STDSCR is defined in <curses.h>, so it can be used by your
program. Many of the procedures in this library operate relative to
the current cursor position in that window. To set the cursor
position, the program should call move() or wmove() first. Window
coordinates are passed row first, column second. The upper left corner
of a window is (1,1).

procedure addch (ch)
procedure waddch (win, ch)

pointer	win		# i: Window descriptor
char	ch		# i: Character to add

This procedure adds a single character at the current cursor position.
The character currently at that position is overwritten. A linefeed
character clears the rest of the line and moves the cursor to the next
row. A tab character inserts the apropriate number of spaces at the
current position. A carriage return moves the cursor to the first
character on the current line. A backspace moves the cursor one column
left unless the cursor is in the first column of the window.

procedure addstr (str)
procedure waddstr (win, str)

int	win		# i: Window descriptor
char	str[ARB]	# i: String to add to window

This procedure adds a string at the current cursor position. If part
of the string extends beyond the right edge of the window, it will be
truncated. Special characters have the same meaning as those in addch().
The window will scroll if scrolling is enabled.

procedure bindstruct (func, structure)
procedure wbindstruct (win, func, structure)

int	win		# i: Window descriptor
extern	func		# i: Input function
pointer	structure	# i: Data structure

This procedure binds an input function and a data structure to a
window. The data structure is used by the input function to maintain
the window's state. The input function is called by getch() and
getstr() to process keyboard input instead of the default procedure,
editfn(). The input function should have the following calling sequence.

procedure func (win, str, maxch)

int	win		#  i: Window descriptor
char	str[ARB]	# io: String containing line
int	maxch		#  i: Maximum line length

When writing this procedure, the default procedure, editfn() should be
used as a guide. The procedure should update the terminal screen,
string, and data structure appropriately. When the procedure gets a
character indicating input is complete, the character should be pushed
back on the input stream with the procedure k_pushbk(). Then the
procedure should return the string to the calling program. The calling
program can also call getstruct() to retrieve the contents of the data
structure.

procedure box (win, vert, hor)

int	win		# i: Window descriptor
char	vert		# i: Character used for vertical side of window
char	hor		# i: Character used for horizontal side of window

This procedure draws a box around a window. The box is inside the
original area of the window, which is then reduced so that subsequent
writes to the window will not overwrite the box.

procedure clear ()
procedure wclear (win)

int	win		# i: Window descriptor

This procedure clears a window. It is equivalent to calling clearok()
with flag set to true, followed by calling erase().

procedure clearok (win, flag)

int	win		# i: Window descriptor
bool	flag		# i: Flag value

This procedure sets the clear flag for a window. If the clear flag is
true, the entire window will be redrawn when refresh is called.

procedure clrtobot ()
procedure wclrtobot (win)

int	win		# i: Window descriptor

This procedure clears a window from the current cursor position to the
end of the window.

procedure clrtoeol ()
procedure wclrtoeol (win)

int	win		# i: Window descriptor

This procedure clears a window from the current cursor position to the
end of the line.

procedure delch ()
procedure wdelch (win)

pointer	win		# i: Window descriptor

This procedure deletes the character at the current cursor poisition
in the window. Subsequent characters on the line are moved to the left
by one.

procedure deleteln ()
procedure wdeleteln (win)

pointer	win		# i: Window descriptor

This procedure deletes the current line in the window. Subsequent
lines in the window slide up by one and the last line is left blank.

procedure delwin (win)

This procedure deletes a window created by newwin(). The terminal area
that was under the window before it was created is redisplayed. The
data structure associated with the window is freed, including the data
structure bound by bindstruct(). STDSCR cannot be deleted by this
procedure, it is deleted by endwin().

procedure echo ()
procedure noecho ()

These procedures turn character echoing on and off. Character echoing
is on when the terminal is initialized. If character ecoing is off,
procedures addch() and addstr() will return immediately after being
called. 

procedure endwin ()

This procedure should be called at the end of a program which uses the
curses library. It deletes all windows that are still open (including
STDSCR) and resets the terminal.

procedure erase ()
procedure werase (win)

int	win		# i: Window descriptor

This procedure erases a window, filling it with blanks.

int procedure getch ()
int procedure wgetch (win)

This procedure reads a single character from the keyboard and adds it
to the window at the current cursor position. If an input function
has been bound to the window by bindstruct(), the input procedure is
called to process the character. The procedure returns after calling
the input function once, regardless of the value of done. The returned
character is the first character in the string output by the input
function. 

procedure getstr (str, maxch)
procedure wgetstr (win, str, maxch)

pointer	win		# i: Window descriptor
char	str[ARB]	# o: String that was read from the keyboard
int	maxch		# i: Maximum string length

This procedure reads a string from the keyboard and displays it in the
window at the current cursor position. Editing keys are recognized;
however, editing is limited to a single line and keys which change the
current line cause the procedure to exit. The default behaviour of
this procedure can be modified by binding an input function to the
window with bindstruct().

procedure getstruct (structure)
procedure wgetstruct (win, structure)

int	win		# i: Window descriptor
pointer	structure	# o: Data structure

This procedure returns a pointer to the data structure that was bound 
to the window by bindstruct().

procedure getyx (win, row, col)

int	win		# i: Window descriptor
int	row		# o: Cursor row
int	col		# o: Cursor column

This procedure returns the location of the cursor in a window. The
top left corner of a window is (1,1).

procedure hidewin (win)

int	win		# i: Window descriptor

This procedure hides a window that is currently displayed on the
screen. The terminal area under the window is displayed after the
window is hidden. The window can be redisplayed by calling showwin().

char procedure inch ()
char procedure winch (win)

pointer	win		# i: Window descriptor

This procedure returns the character at the current cursor location in
the window.

procedure initscr ()

This procedure initializes the terminal and creates the default
window, STDSCR. It should be called before any other procedure in the
curses library is called.

procedure insch (ch)
procedure winsch (win, ch)

pointer	win		# i: Window descriptor
char	ch		# i: Character to insert

This procedure inserts a character at the current cursor position.

procedure insertln ()
procedure winsertln (win)

pointer	win		# i: Window descriptor

This procedure inserts a blank line on the current row. The current
line and subsequent lines move down by one and the last line in the
window is deleted.

procedure leaveok (win, flag)

int	win		# i: Window descriptor
bool	flag		# i: Flag value

This procedure sets the leave flag for a window. If the leave flag
is true, procedures that modify the screen will not move the terminal
cursor to the window's current cursor position when the window is
modified. If it is false, the terminal cursor position will be moved
when the window is updated. When a window is created, the leave flag
is set to false.

procedure move (row, col)
procedure wmove (win, row, col)

int	win		# i: Window descriptor
int	row		# i: Cursor row
int	col		# i: Cursor column

This procedure moves the cursor position in a window. Coordinates are
relative to those of the window, and the top left corner of a window
has the coordinates (1,1)

procedure mvwin (win, row, col)

int	win		# i: Window descriptor
int	row		# i: New top row of window
int	col		# i: New left column of window

This position moves the position of a window on the screen. The
position of a window is the position of the top left corner on the
terminal screen. If the new corrdinates would place part of the window
off the screen, the coordinates are modified so that the window stays
on the screen.

int procedure newwin (nrows, ncols, row, col)

int	nrows		# i: Window height
int	ncols		# i: Window width
int	row		# i: Top row of window
int	col		# i: Leftmost column of window

This procedure creates a new window. The returned value is the window
descriptor, which is used as an argument to the other window
functions. The window position is relative to the top left corner of
the terminal, which has the coordinates (1,1). If part of the window
is off the terminal screen, it will be placed and sized so that the
entire window fits on the screen.

procedure refresh ()
procedure wrefresh (win)

int	win		# i: Window descriptor

This procedure causes all changes to a window that have been made by
other calls in this library to be displayed on the terminal screen. If
the clear flag has been set to yes by clearok(), the window will be
cleared and redrawn.

procedure savewin ()
procedure nosavewin ()

These procedures set and unset the save flag. If the save flag is set,
whenever a window is created, the area on the terminal screen under is
saved in a buffer so it can be restored when the window is hidden or
deleted. If a window will exist throughout the life of a program, the
save flag can be unset by calling nosavewin() before creating the
window so that the memory used to hold the buffer will not be wasted.
The save flag is initially set to yes so that all windows have
associated screen buffers by default.

procedure scrollok (win, flag)

int	win		# i: Window descriptor
bool	flag		# i: Flag value

If the scroll flag is set to true, a window will scroll when an
attempt is made to write beyond the last line of a window. If the
scroll flag is false, the last line of the window will be overwritten.
When a new window is created, the scroll flag is set to false.

procedure showwin (win)

int	win		# i: Window descriptor

This procedure shows a window that was previously hidden by a call to
hidewin(). If the window is not hidden, this procedure has no effect.

procedure standout ()
procedure standend ()
procedure wstandout (win)
procedure wstandend (win)

int	win		# i: Window descriptor

These procedures modify the character attribute of a window. Calling
standout() causes all characters written to the window after the call
to be written in standout mode. Calling standend() causes all
characacters to be written in normal mode. When a window is created,
the character attribute of the window is normal.

procedure wdimen (win, nrows, ncols)

int	win		# i: Window descriptor
int	nrows		# o: Window height
int	ncols		# o: Window width

This procedure returns the height and width of a window.

int procedure winstat (win, what)

int	win		# i: Window descriptor
int	what		# i: Field to retrieve

This procedure returns a field from the window descriptor. The field
to retrieve is given by a symbolic constant. These constants are
listed in the include file <curses.h>.

The procedures in this directory implement the lowest level of the
screen handling routines in the display library. Procedures not
described in this file are not part of the public interface and should
not be called by user programs.  All the capabilities of the curses
procedures are layered on top of the procedures in this directory.
These procedures provide less functionality than the curses routines,
but can be faster, at the expense of more complications in the user
program. The procedures in this directory are portable. They are
written in SPP and they do all their I/O through the IRAF VOS. They
use the termcap and edcap files so that this library can be used with
a variety of terminals and the editing commands can be tailored to the
user's preferences.  There are two sets of subroutines in this
directory.  The first set is the keyboard subroutines, prefixed by the
letter "k", which read the keyboard and translate control key
sequences to a single character.  The second set is the screen
sunroutines, prefixed by the letters "ps", which write to the
terminal.

The keyboard subroutines read input from the keyboard, translating
command key sequences into a single number.  The command key sequences
are read from the edcap file.  This is a file located either in the
user's home directory or the dev$ directory whose name is the value of
the editor environment variable with an extension of ".ed".  See the
files in the dev$ directory for an example of the file format.  The
keyboard subroutines are initialized by a call to the following
subroutine:

procedure k_begin (cmdlist)

char	cmdlist[ARB]	# i: List of editing commands

This subroutine puts the terminal in raw mode, reads the edcap file,
and sends the keyboard initialization sequence to the terminal. Its
argument is a list of command names taken from the edcap file that you
want your program to recognize. The first character in the string is a
command separator, used to separate the commands in the string. The
macro CMDSTR in <curses.h> defines the list of commands used by the
curses routines. The screen initialization routine, ps_begin, must be
called before k_begin is called. To terminate the keyboard interface,
call the following subroutine:

procedure k_end ()

This procedure ends raw mode and sends the keyboard termination sequence
to the terminal.  The screen termination routine, ps_end, should be
called after this routine is called.  The following subroutine reads a
single character from the terminal:

int procedure k_get ()

Command key sequences that were named in the command list passed to
k_begin are returned as a single number.  The value returned by the
first command key sequence in the command list is K_BASE, the value
returned by the second sequence is K_BASE+1, and so on.  The macro
K_BASE is defined in <curses.h>.  

The next keyboard subroutine returns a pointer to a character string
containing the help text for the keyboard commands:

procedure k_help (text)

pointer	text		# o: Help text

The help text string is formatted as a series of command descriptions.
Each description starts with the name of the edcap command , followed
by an equals sign, followed by the ascii representation of the key
sequence which executes the command, and terminated by a newline
character.The string is formatted as a series of command descriptions.
Each description starts with the name of the edcap command , followed
by an equals sign, followed by the ascii representation of the key
sequence which executes the command, and terminated by a newline
character.

The following routine copies one of the command descriptions from the
help text to an output string:

procedure k_eseq (name, eseq, maxch)

char	name[ARB]	# i: Name bound to command sequence
char	eseq[ARB]	# o: String representation of command sequence
int	maxch		# i: Maximum length of command sequence

The input parameters are the name of the command sequence and the
length of the output string. The name of the sequence should be
the name passed as part of the command string to k_begin(). The output
is the ascii represntation of the escape sequence of that command.

The screen subroutines are used to send output to the terminal.  They
are based on the subroutines in Marc Rochkind's book, "Advanced C
Programs for Displays".  Several conventions are followed by these
subroutines.  The first is that while strings are passed as arrays of
characters, individual characters are passed as integers.  The second is
that screen coordinates are passed row first, column second and that the
coordinates of the upper left corner of the screen are (1, 1).  The
third is that areas on the screen are passed as rectangles, which are
represented as arrays of four elements, where the four elements are the
(top, left, bottom, right) corners of the rectangle.  The initialization
and termination routines for the screen subroutines are:

procedure ps_begin ()
procedure ps_end ()

The first subroutine opens the terminal for I/O and reads the termcap
file, the second closes the terminal. The calling program get the size
of the screen by calling the subroutines:

int procedure ps_height ()
int procedure ps_width ()

These subroutines return the number of screen rows and columns,
respectively. The following subroutine flushes the output buffer:

procedure ps_synch ()

The user will not see any output sent by these subroutine to the
terminal until this subroutine is called. To ring the terminal's bell,
call the following subroutine:

procedure ps_beep ()

To move the cursor on the screen call the following subroutine:

procedure ps_setcur (row, col)

int	row		# i: Cursor row
int	col		# i: Cursor column

To write a string to the screen call the following subroutine:

procedure ps_write (row, col, ncols, str, att)

int	row		# i: Starting row
int	col		# i: Starting column
int	ncols		# i: Number of columns to write
char	str[ARB]	# i: String to write
int	att		# i: Attribute

The number of columns is an upper limit on the number of characters to
write, if the string is shorter than this, the actual number of
characters on the screen will be displayed. If the string does not lie
entirely on the screen, the string will be clipped at the screen boundary.
The attribute determines whether the string is printed normally or in
standout mode. The value should be set to either A_NORM or A_STANDOUT,
which is defined in display.h. To write a string where the screen
attribute may change from character to characater call the following
subroutine: 

procedure ps_wrtcells (row, col, vector, ncols)

int	row		# i: Starting row
int	col		# i: Starting column
char	vector[ARB]	# i: Vector to write
int	ncols		# i: Number of columns to write

The string to be written must be at least ncols long and each character
to be displayed in standout mode should have A_STANDOUT added to its
ascii code. This subroutine is used when the calling program keeps an
array whose contents corresponds to the current screen display. To fill
an area on the screen with a single character call the following
subroutine: 

procedure ps_fill (source, ch, att)

int	source[RSIZE]	# i: Rectangle
int	ch		# i: Fill character
int	att		# i: Fill attribute

This subroutine can be used to clear part or all of the screen by
setting the fill character to blank and the fill attribute to A_NORM.
The macro RSIZE is equal to 4 and is defined in display.h. To move an
area of the screen in any of the four directions call the following
subroutine: 

bool procedure ps_slide (source, dir, dist)

int	source[RSIZE]	# i: Rectangle
int	dir		# i: Direction (from display.h)
int	dist		# i: Distance (> 0)

This subroutine can be used to scroll the screen up or down, delete one
or more characters from a line, or move a line over so that a new
character can be inserted. The direction is given as one of the four
macros DIR_UP, DIR_DOWN, DIR_LEFT, and DIR_RIGHT, defined in <curses.h>.
This subroutine may or may not be able to move the screen, depending on
the capabilities defined in the terminal's termcap file. If the
subroutine can move the area, it returns true and if it cannot, it
returns false. In the latter case, it is the responsibility of the
calling program to redraw the affected area of the screen in order to
move the area.

The include file display.h contains several macros the can be used to
manipulate the rectangles passed to the screen subroutines. In order to
access the elements of a rectangle the following macros can be used:

RTOP(rect)	# Top row of a rectangle
RLEFT(rect)	# Left column of a rectangle
RBOT(rect)	# Bottom row of a rectangle
RRIGHT(rect)	# Right column of a rectangle

The dimensions of a rectangle can be computed by the following macros:

RWIDTH(rect)	# Number of columns in a rectangle
RHEIGHT(rect)	# Number of rows in a rectangle

A program can set the elements in a rectangle with the following macros:

RASG(newrect, top, left, bottom, right)
RCPY(newrect, oldrect)

The first macro assigns four scalars to the elements of a rectangle and
the second macro copies the elements of one rectangle to another.

The forms procedures give an example of a display handling library
built on top of the curses routines.  The forms procedures divide the
terminal screen into two windows, the form and prompt window.  The
form window contains the form fields.  Each field in the form occupies
one line on the screen with the field name on the left side of the
line and the field value on the right side separated by an equals
sign. If the number of fields in the form exceed the number of lines
in the form window, a portion of the fields will be displayed, which
the user can scroll through. The prompt window is used to read user
input and display messages.  The first line contains a message,
typically used to list the possible commands, and the second line
contains the user input. 

The following two procedures are used to initialize and terminate the
form handling.  The first procedure, fm_begin, calls the keyboard and
screen initialization routines, and initializes some global variables.
The second procedure, fm_end, calls the keyboard and screen
termination routines.

procedure fm_begin ()
procedure fm_end ()

The next three procedures handle the form window of the screen. The
first procedure, fm_mkform(), associates a form with a window.  The
second procedure, fm_getform(), gets user input from the form. The
third procedure, fm_endform(), frees the data structure associated
with the form. 

The first procedure has the following calling sequence:

procedure fm_mkform (win, nfield, lenname, lenvalue, title, ftype, fname)

int	win			# i: Window descriptor
int	nfield			# i: Number of fields in form
int	lenname			# i: Declared length of field name
int	lenvalue		# i: Declared length of field value
char	title[ARB]		# i: Form title
int	ftype[ARB]		# i: Data types of fields
char	fname[lenname,ARB]	# i: Names of fields

The first argument, win, is the window descriptor. It is created by
calling newwin(), the curses procedure which creates windows. The next
three arguments are used to compute the size of the structure which
holds the form. The number of fields can be greater than the height of
the window, as the window will scroll up and down. But the combined
length of the field name and value must be less than the width of the
window, as it will not scroll side to side. The title is a string that
is printed on the title bar, which is the bottom row of the form. The
title bar also contains the help key escape sequence.  Three items of
information are associated with each field: a type, a name, and a
value. The type is an integer with the same meaning used by the table
interface: a negative number if the field is a string whose magnitude
is equal to the maximum string length or a positive integer equal to
the spp type code if the field is not a string. The type is used to
check the field value, the procedure will not let the user enter a
value of a different type. Each field name is printed on a separate
line of the form followed by an equals sign.

The second procedure, fm_getform, is used to read or display the
values associated with the fields of the form. It has the following
calling sequence:

procedure fm_getform (win, redraw, lenvalue, fvalue)

int	win			# i: Window descriptor
bool	redraw			# i: Redraw screen?
int	lenvalue		# i: Declared length of field value
char	fvalue[lenvalue,ARB]	# u: Values in fields

The first argument is the window descriptor of the window associated
with the form. If the second argument, redraw is set to true, the
window is redrawn when the procedure begins, otherwise the window is
unchanged. Redraw should set to true the first time this procedure is
called. The last argument, fvalue, contains the values that are
displayed on the form. The user updates these values by editing the
form on the screen. When the user has finished updating the values,
the modified values are returned to the calling procedure.

The third procedure frees the form data structure. After freeing the
data structure, the window should be closed by calling delwin. This
procedure has the following calling sequence:

procedure fm_clsform (win)

int	win			# i: Window descriptor


The next procedure, fm_prompt, handles the prompt window on the screen.
It has the following calling sequence:

int procedure fm_prompt (commands, message)

char	commands[ARB]	# i: List of commands
char	message[ARB]	# i: Message to print in prompt area

The list of commands is a string containing the possible commands.  This
string is formatted like the dictionary in strdic: the first character
in the string is a command separator which appears between the commands
in the string.  The message is displayed on the top line of the prompt
area.  If the message is a null string, the command string is displayed
instead.  The user enters one of the commands and presses carriage
return.  The procedure returns the number of the command that the user
entered if the command is legal, or beeps and displays the list of
commands if it is not. If the list of commands is a null string, the
procedure displays the message in the prompt area and returns a value
of zero without looking for user input.

The last procedure displays the help window. This window covers the
entire screen. Its argument is the currently active window. It is
passed so that the cursor can be restored to its previous position
when the procedure is finished.

procedure fm_help (win)

int	win		# i: Window which currently is active

# Unit tests for IRAF

This subdirectory contains a simple test script, `run_tests`, and a
collection of non-interactive tests for various aspectes of IRAF. 

The following tests are available:

 * [Check the IRAF tree for generated files](files.md)
 * [Preliminary Test Procedure for IRAF](testproc.md): basic functionality,
   mainly from the test procedure document written by Jeanette Barnes and 
   her "Beginner's Guide to Using IRAF",
 * [Command Language](cl.md), and for [ECL extensions](ecl.md)
 * [Programming interface](programming.md) for basic SPP functionality,
 * [OS specific subroutines](os.md),
 * Test from the examples in several packages:
    - [`lists`](lists.md),
    - [`images.imcoords`](images.imcoords.md)
    - [`images.imfilter`](images.imfilter.md)
    - [`images.imfit`](images.imfit.md)
    - [`images.imgeom`](images.imgeom.md)
    - [`images.immatch`](images.immatch.md)
    - [`utilities.nttools`](utilities.nttools.md)
    - [`noao.digiphot.photcal`](noao.digiphot.photcal.md)
    - [`noao.astutil`](noao.astutil.md)
	- [`sys.vops`](sys.vops.md)
 * [Regression test](numerical-recipes.md) for the replacement of Numerical
   Recipes code
 * [A self-test](test-syntax.md) for the basic unit test functionality,

# Dynamic External Package Loading

Dynamic package loading is a new feature in v2.15 that allows for
package directories created in the iraf$extern directory to be
automatically defined when the CL is started.  The means that external
package installation no longer *requires* that the hlib$extern.pkg
file be edited to define the package, although that remains an option
for packages which somehow cannot conform to this new scheme.

The option to load external packages from the IRAF repository is
removed, since the repository is not available anymore.

		  ===================================
		   LIBVOTABLE v1.0 Tools README File
		  ===================================

    This directory contains the source and documentation for the
LIBVOTABLE (VOTable Parser) Interface.  See the INSTALL file for
detailed installation instructions.

Contents:
---------
	Makefile		Top-level Makefile for the source
	README			This file
	INSTALL			Installation instructions
	examples/		Example task using the interface
	include/		Library include files
	lib/			Sources used to build the interface
	src/			Public libVOTable interface source

    Please report any bugs, comments, or suggestions to the author
(fitz@noao.edu) or the NVO Help Desk (feedback@us-vo.org).


We expect to provide the following set of applications in the initial
distribution:

*   votinfo             Print summary information about a VOTable document
    votcopy             Copy a VOTable to a different format              
    votlint             VOTable validator                                 

    (*) Existing application requiring mantenance work only.



Mike Fitzpatrick, fitz@noao.edu, NOAO
May 7, 2010

This directory contains example programs using the libvotable interface.
These tasks are meant to be useful and tutorial in how to use the API to
do common things.

Current Tasks:

    votconcat		Concatenate RESOURCES into a single VOTable
    votcomp		Remove pretty-print whitespace from a VOTable
    votdump		Dump a VOTable in another format
    votget		Extract image access references and download
    votlint		Check a VOTable for correctness
    votinfo		Print information about the structure of a VOTable
    votpos		Extract position information from a VOTable
    votsplit		Split RESOURCEs from a VOTable to single VOTables

This subdirectory contains test data for the installer/maintainer of
the apphot package. The files beginning with fits contain test images
of both real and artificial data. There are also some coordinate files
supplied for these images. Eventually there will be some apphot demos
which can be run to automatically test new releases of the software etc.

		  Dynamic External Package Loading
							
			 November 2, 2010


    Dynamic package loading is a new feature in v2.15 that allows for
package directories created in the iraf$extern directory to be automatically
defined when the CL is started.  The means that external package installation
no longer *requires* that the hlib$extern.pkg file be edited to define the
package, although that remains an option for packages which somehow cannot
conform to this new scheme.



Getting Started
---------------

    The IRAF v2.15 system is shipped with no defined external packages,
instead we assume packages will be installed using this new feature.  To
begin, simply execute the 'configure' script in this directory to create
the files needed.  For example,

	% ./configure

This will create a local 'manifest' file of packages available form
the IRAF reposistory and iraf.noao.edu and skeleton directories of
available packages will be created automatically along with a Makefile
used to do the actual installation.  THIS STEP IS REQUIRED BEFORE PACKAGE
INSTALLATION!

    To get a listing of packages that can be installed, or to check
which installed packages might need to be updated or are newly available,
use the command:

	% make check

Each listed package may then be installed using a simple 'make' command.
For packages not on the list, a manual install is still required.

    The external package tree may be initialize to the distribution state
using the command:

	% make init

Updates to the distribution mechanism itself is done using the command:

	% make self_update

This last command is used to update the system to new features or bug fixes
that might be available as the mechanism evolves.



Installing and Updating Packages
--------------------------------

    External packages may now be installed with a command such as:
	
	% make ctio mscred stsdas

Note that dependency packages for each requested package will
automatically be added to the installation so you do not need to
necessarily list every package (e.g. you'll get FITSUTIL automatically
by installing MSCRED).  The next time you login to the CL the requested
package will be defined.

    To update packages to the latest version, use the command

	% make update

The information about available packages will be updated, then a
comparison of the timestamps of your installed packages with those on
the repository will be made.  If newer package versions are available
they will be updated (along with their depencies) automatically.

    If a binary repository distribution of a package is not available
at the moment, a 'source only' distribution will be installed and you will
not a "[SOURCE ONLY]' status from the make command.  The user is then
responsible for compiling th epackages locally even though the package
will still be defined for use (but unusable).  Our goal is to provide a
binary distribution for all available packages we can reasonably support.



How it Works
------------

    This scheme relies on IRAF v2.15 changes to the CL login process to
scan this directory for packages, as well as a server-side respository of
distribution files suited for this method (see below).  The 'configure'
script customizes the package information for your platform and creates a
'Makefile' based on that information.  Subsequent commands update these
files, however we don't yet provide an automated system for multi-platform
support.

    The bulk of the work is done using utility scripts found in the
iraf@util directory and called from the makefile.  The management of the
repository files is the rsponsibility of the distribution maintainers
(by default this is NOAO).  Please contact us if you wish to have your
package added to the system.



Repositories
------------

    The default package repository is defined in the $iraf/util/pkgrepo
script and may be changed to point to a local respository (e.g. a mirror
site).  It may also be changed by pointing the 'IRAF_REPO' environment
variable to a new URI source, e.g.

	setenv IRAF_REPO  "ftp://localhost/myrepository"

Of course, a network connection is assumed to exist in most cases.  Local
repositories may be preferred for faster local access via mirrors, please
contact us for information on creating one.




==================================
Server-Side Repository Description
==================================


[The following comes from the README file on the repository]

	This is the IRAF v2.15 distribution repository directory.  Files
    here are bundled so as to allow them to operate with the dynamic
    package mechanism or IRAF install procedurs for v2.15. Aside from
    the repository files themselves, this directory contains

	README		This file REPO.DESC	  A description of
	each package MK		     Utility script to update repo
	checksum/manifest

	CHECKSUM	Checksums files on repo tarballs created by MK
	REPO.MANIFEST	Manifest file

    The MK script is used to generate the CHECKSUMS file and REPO.MANIFEST
    file automatically, it should be run whenever a package is installed
    or updated.  The REPO.DESC file is a handcrafted description of the
    available package, this is important to describing the dependencies
    of each package.  The MK script is also capable of determining
    which of the available packages may be used on which platform.
    For example, a "redhat" package will suffice for both a linux64
    and linux IRAF system if there is no specific version available.
    The manifest file created will then list the redhat version as the
    file to be installed for the linux/linux64 platforms.

	If a binary distribution for a particular package is not provided,
    the MK script will default to use the source distribution tarball
    (if available).  On the receiving end the user will then have the
    option of compiling the package locally.  The reserved <arch> name
    "universal" is used for script-only packages, or distributions
    containing binaries for all supported platforms.

	When packages are installed in the IRAF dynamic package tree,
    both the REPO.MANIFEST and REPO.DESC files are downloaded.	Scripts
    use these files to build up package lists that are available for a
    particular platform, as well as which packages are required to be
    installed to support the requested package. We assume the REPO.DESC
    file lists full dependencies, e.g. if A requires B, and B requires
    C the the dependency list for A is both B and C.


    The convention for file names is as follows:

		<pkg>-<arch>.tar.gz

    where <pkg> is the package name and <arch> is the iraf architecture.

	For external packages, tarfiles are build at the toplevel, i.e.
    when unpacked, a subdirectory of the package is created in th current
    directory.	For IRAF distributions we violate this rule and assume
    the tarball is built from the $iraf root directory.

    When installing a new package, the REPO.DESC file should be edited
    and the MK script should be run.

    When installing an update to an existing repo package, or a new
    architecture version of a package, the MK script should be re-run.

C--------------------------------------------------------------------------
        subroutine ftgtkn(iunit,nkey,keynam,ival,status)

C       test that keyword number NKEY has name = KEYNAM and get the
C       integer value of the keyword.  Return an error if the keyword
C       name does not match the input KEYNAM, or if the value of the
C       keyword is not a positive integer.
C
C       iunit   i  Fortran I/O unit number
C       nkey    i  sequence number of the keyword to test
C       keynam  c  name that the keyword is supposed to have
C       OUTPUT PARAMETERS:
C       ival    i  returned value of the integer keyword
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991
C
        integer iunit,nkey,status,ival
        character*(*) keynam
        character kname*8,value*30,comm*48,npos*8,keybuf*80

        if (status .gt. 0)return

C       read the name and value of the keyword
        call ftgrec(iunit,nkey,keybuf,status)

        kname=keybuf(1:8)
C       parse the value and comment fields from the record
        call ftpsvc(keybuf,value,comm,status)

        if (status .gt. 0)go to 900

C       test if the keyword has the correct name
        if (kname .ne. keynam)then
                status=208
                go to 900
        end if

C       convert character string to integer
        call ftc2ii(value,ival,status)
        if (status .gt. 0 .or. ival .lt. 0 )then
C               keyword value must be zero or positive integer
                status=209
        end if

900     continue

        if (status .gt. 0)then
            write(npos,1000)nkey
1000        format(i8)
            call ftpmsg('FTGTKN found unexpected keyword or value '// 
     &      'for header keyword number '//npos//'.')
            call ftpmsg('  Was expecting positive integer keyword '//
     &      keynam(1:8))
            if (keybuf(9:10) .ne. '= ')then
                call ftpmsg('  but found the keyword '//kname//
     &          ' with no value field (no "= " in cols. 9-10).')
            else
              call ftpmsg('  but instead found keyword = '//kname//
     &        ' with value = '//value)
            end if
            call ftpmsg(keybuf)
        end if
        end

      subroutine strdcl
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer t, token (100), dchar (100)
      integer gnbtok
      integer i, j, k, n, len
      integer length, ctoi, lex
      integer char(11)
      integer dat(6)
      integer eoss(3)
      data char(1)/105/,char(2)/110/,char(3)/116/,char(4)/101/,char(5)/1
     *03/,char(6)/101/,char(7)/114/,char(8)/42/,char(9)/50/,char(10)/47/
     *,char(11)/-2/
      data dat(1)/100/,dat(2)/97/,dat(3)/116/,dat(4)/97/,dat(5)/32/,dat(
     *6)/-2/
      data eoss(1)/48/,eoss(2)/47/,eoss(3)/-2/
      t = gnbtok (token, 100)
      if (.not.(t .ne. -9))goto 23000
      call synerr (21Hmissing string token.)
23000 continue
      call squash (token)
      call outtab
      call pbstr (char)
23002 continue
      t = gnbtok (dchar, 100)
      if (.not.(t .eq. 47))goto 23005
      goto 23004
23005 continue
      call outstr (dchar)
23003 goto 23002
23004 continue
      call outch (32)
      call outstr (token)
      call addstr (token, sbuf, sbp, 2048)
      call addchr (-2, sbuf, sbp, 2048)
      if (.not.(gnbtok (token, 100) .ne. 40))goto 23007
      len = length (token) + 1
      if (.not.(token (1) .eq. 39 .or. token (1) .eq. 34))goto 23009
      len = len - 2
23009 continue
      goto 23008
23007 continue
      t = gnbtok (token, 100)
      i = 1
      len = ctoi (token, i)
      if (.not.(token (i) .ne. -2))goto 23011
      call synerr (20Hinvalid string size.)
23011 continue
      if (.not.(gnbtok (token, 100) .ne. 41))goto 23013
      call synerr (20Hmissing right paren.)
      goto 23014
23013 continue
      t = gnbtok (token, 100)
23014 continue
23008 continue
      call outch (40)
      call outnum (len)
      call outch (41)
      call outdon
      if (.not.(token (1) .eq. 39 .or. token (1) .eq. 34))goto 23015
      len = length (token)
      token (len) = -2
      call addstr (token (2), sbuf, sbp, 2048)
      goto 23016
23015 continue
      call addstr (token, sbuf, sbp, 2048)
23016 continue
      call addchr (-2, sbuf, sbp, 2048)
      t = lex (token)
      call pbstr (token)
      if (.not.(t .ne. -75))goto 23017
      i = 1
23019 if (.not.(i .lt. sbp))goto 23021
      call outtab
      call outstr (dat)
      k = 1
      j = i + length (sbuf (i)) + 1
23022 continue
      if (.not.(k .gt. 1))goto 23025
      call outch (44)
23025 continue
      call outstr (sbuf (i))
      call outch (40)
      call outnum (k)
      call outch (41)
      call outch (47)
      if (.not.(sbuf (j) .eq. -2))goto 23027
      goto 23024
23027 continue
      n = sbuf (j)
      call outnum (n)
      call outch (47)
      k = k + 1
23023 j = j + 1
      goto 23022
23024 continue
      call pbstr (eoss)
23029 continue
      t = gnbtok (token, 100)
      call outstr (token)
23030 if (.not.(t .eq. 47))goto 23029
23031 continue
      call outdon
23020 i = j + 1
      goto 23019
23021 continue
      sbp = 1
23017 continue
      return
      end
c     logic0  logical_column

      integer function gctoi (str, i, radix)
      integer str (100)
      integer i, radix
      integer base, v, d, j
      external index
      integer index
      integer clower
      logical neg
      integer digits(17)
      data digits(1)/48/,digits(2)/49/,digits(3)/50/,digits(4)/51/,digit
     *s(5)/52/,digits(6)/53/,digits(7)/54/,digits(8)/55/,digits(9)/56/,d
     *igits(10)/57/,digits(11)/97/,digits(12)/98/,digits(13)/99/,digits(
     *14)/100/,digits(15)/101/,digits(16)/102/,digits(17)/-2/
      v = 0
      base = radix
23000 if (.not.(str (i) .eq. 32 .or. str (i) .eq. 9))goto 23001
      i = i + 1
      goto 23000
23001 continue
      neg = (str (i) .eq. 45)
      if (.not.(str (i) .eq. 43 .or. str (i) .eq. 45))goto 23002
      i = i + 1
23002 continue
      if (.not.(str (i + 2) .eq. 114 .and. str (i) .eq. 49 .and. (48.le.
     *str (i + 1).and.str (i + 1).le.57) .or. str (i + 1) .eq. 114 .and.
     * (48.le.str (i).and.str (i).le.57)))goto 23004
      base = str (i) - 48
      j = i
      if (.not.(str (i + 1) .ne. 114))goto 23006
      j = j + 1
      base = base * 10 + (str (j) - 48)
23006 continue
      if (.not.(base .lt. 2 .or. base .gt. 16))goto 23008
      base = radix
      goto 23009
23008 continue
      i = j + 2
23009 continue
23004 continue
23010 if (.not.(str (i) .ne. -2))goto 23012
      if (.not.((48.le.str (i).and.str (i).le.57)))goto 23013
      d = str (i) - 48
      goto 23014
23013 continue
      d = index (digits, clower (str (i))) - 1
23014 continue
      if (.not.(d .lt. 0 .or. d .ge. base))goto 23015
      goto 23012
23015 continue
      v = v * base + d
23011 i = i + 1
      goto 23010
23012 continue
      if (.not.(neg))goto 23017
      gctoi=(-v)
      return
23017 continue
      gctoi=(+v)
      return
23018 continue
      end

      SUBROUTINE TPWRZT	(IERROR)
C
C LATEST REVISION	 JULY, 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 PWRZT IN CONJUNCTION WITH THREED.
C
C USAGE			 CALL TPWRZT (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST IS SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   PWRZT TEST SUCCESSFUL  . . .	 SEE PLOT
C			   TO VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C
C			 IN ADDITION, ONE FRAME	CONTAINING THE
C			 CHARACTER PLOT	IS PRODUCED ON THE
C			 MACHINE GRAPHICS DEVICE.  TO DETERMINE
C			 IF THE	TEST IS	SUCCESSFUL, IT IS NECESSARY
C			 TO EXAMINE THIS PLOT.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 PWRZT,	THREED
C FILES
C
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 TPWRZT	CALLS SUBROUTINES SET3 AND LINE3 FROM
C			 THE ULIB THREED PACKAGE TO ESTABLISH THE
C			 THREE SPACE-TO-TWO SPACE TRANSFORMATION
C			 AND TO	DRAW AXIS LINES.  TPWRZT NEXT CALLS
C			 SUBROUTINE PWRZT FROM THE ULIB	THREED
C			 PACKAGE TO LABEL THE AXES FOR A THREE SPACE
C			 PLOT.
C
C PORTABILITY		 ANSI FORTRAN 77
C
C
C EYE CONTAINS THE (U,V,Z) COORDINATE OF THE EYE POSITION
C
      REAL	      EYE(3)
      DATA EYE(1), EYE(2), EYE(3) /3.5,	3.0, 5.0/
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 1
C
C SELECT NORMALIZATION TRANS NUMBER 0
C
      CALL GSELNT (0)
C
C SUBROUTINE SET3 ESTABLISHES THE MAPPING OF THREE SPACE COORDINATES
C ONTO THE GRAPHICS DEVICE COORDINATE SYSTEM.
C
      CALL SET3	(.1,.9,.1,.9,0.,1.,0.,1.,0.,1.,EYE)
C
C THE FOLLOWING	THREE CALLS TO LINE3 DRAW THE THREE SPACE AXES
C
      CALL LINE3 (0.,0.,0.,0.,0.,1.)
      CALL LINE3 (0.,0.,0.,0.,1.,0.)
      CALL LINE3 (0.,0.,0.,1.,0.,0.)
C
C SUBROUTINE PWRZ IS USED TO LABEL EACH	OF THE AXES AND	THE PLOT
C ON INPUT TO PWRZ,
C THE FIRST THREE PARAMETERS AND ICNT DETERMINE	THE POSITION OF	THE
C CHARACTER STRING.
C ISIZE	DETERMINES THE CHARACTER SIZE.
C LINE AND ITOP	DETERMINE THE DIRECTION	AND PLANE OF THE CHARACTERS.
C
C
      ICNT = 0
      ISIZE = 30
      LINE = 2
      ITOP = 3
      CALL PWRZT (0.,.5,.1,'V-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = -1
      ITOP = 3
      CALL PWRZT (.5,0.,.1,'U-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = 3
      ITOP = -2
      CALL PWRZT (0.,.1,.5,'Z-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = 2
      ITOP = -1
      ISIZE = 30
      ICNT = -1
      CALL PWRZT (.5,.2,0.,'DEMONSTRATION OF PWRZT WITH	THREED',
     1		  34,ISIZE,LINE,ITOP,ICNT)
C
C A CALL TO NEWFM INDICATES THAT THE PICTURE IS	COMPLETE
C
      CALL NEWFM
C
      IERROR = 0
c     WRITE (6,1001)
C
      RETURN
C
C
C
c1001 FORMAT ('	     PWRZT TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

C----------------------------------------------------------------------
        subroutine ftggpj(iunit,group,fparm,nparm,array,status)

C       Read an array of group parameter values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       iunit   i  Fortran unit number
C       group   i  number of the data group, if any
C       fparm   i  the first group parameter be read (starting with 1)
C       nparm   i  number of group parameters to be read
C       array   i  returned array of values that were read
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,group,fparm,nparm,status,row 
        integer nulval,array(*)
        logical anynul,flgval

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
C       set nulval to blank to inhibit checking for undefined values
        nulval=0
        row=max(1,group)
        call ftgclj(iunit,1,row,fparm,nparm,1,1,nulval,
     &      array,flgval,anynul,status)
        end

include	defs

# DECLCO -- Process a declaration (xpp directive).  Look up directive in
# the symbol table.  If found, output the corresponding Fortran declaration,
# otherwise output the original string.

subroutine declco (id)

character id(MAXTOK)
character newid(MAXTOK), tok, tokbl
integer junk, ludef, equal, gettok
include COMMON_BLOCKS
string	xptyp XPOINTER
string	xpntr "x$pntr"
string	xfunc "x$func"
string	xsubr "x$subr"

	if (ludef (id, newid, xpptbl) == YES) {
	    if (equal (id, xpntr) == YES) {
		# Pointer declaration.
		tokbl = gettok (newid, MAXTOK)
		if (tokbl == BLANK)
		    tok = gettok (newid, MAXTOK)
		else
		    tok = tokbl

		if (tok == XPP_DIRECTIVE & equal (newid, xfunc) == YES) {
		    # Pointer function.
		    call outtab
		    call outstr (xptyp)
		    junk = ludef (newid, newid, xpptbl)
		    call outstr (newid)
		    call eatup
		    call outdon

		    call poicod (NO)

		} else {
		    # Pointer variable.
		    call pbstr (newid)
		    call poicod (YES)
		}

	    } else if (equal (id, xsubr) == YES) {
		# Subroutine declaration.
		call outtab
		call outstr (newid)
		call eatup
		call outdon

	    } else  {
		# Some other declaration.
		call outtab
		call outstr (newid)
		call outch (BLANK)
	    }

	} else
	    call synerr ("Invalid x$type type declaration.")
end

include	defs

# insub - determine if argument is STDIN substitution

   integer function insub (arg, file)
   character arg (ARB), file (ARB)

   if (arg (1) == LESS & arg (2) != EOS) {
      insub = YES
      call scopy (arg, 2, file, 1)
      }
   else
      insub = NO

   return
   end

      integer function addstr (s, str, j, maxsiz)
      integer j, maxsiz
      integer s (100), str (maxsiz)
      integer i, addset
      i = 1
23000 if (.not.(s (i) .ne. -2))goto 23002
      if (.not.(addset (s (i), str, j, maxsiz) .eq. 0))goto 23003
      addstr = 0
      return
23003 continue
23001 i = i + 1
      goto 23000
23002 continue
      addstr = 1
      return
      end

      subroutine ldp (g,mdg,m,n,h,x,xnorm,w,index,mode)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1974 mar 1
c     to appear in 'solving least squares problems', prentice-hall, 1974
c
c	     **********  least distance programming  **********
c
      integer index(m)
      dimension g(mdg,n), h(m), x(n), w(1)
      zero=0.
      one=1.
      if (n.le.0) go to 120
	  do 10 j=1,n
   10	  x(j)=zero
      xnorm=zero
      if (m.le.0) go to 110
c
c     the declared dimension of w() must be at least (n+1)*(m+2)+2*m.
c
c      first (n+1)*m locs of w()   =  matrix e for problem nnls.
c	next	 n+1 locs of w()   =  vector f for problem nnls.
c	next	 n+1 locs of w()   =  vector z for problem nnls.
c	next	   m locs of w()   =  vector y for problem nnls.
c	next	   m locs of w()   =  vector wdual for problem nnls.
c     copy g**t into first n rows and m columns of e.
c     copy h**t into row n+1 of e.
c
      iw=0
	  do 30 j=1,m
	      do 20 i=1,n
	      iw=iw+1
   20	      w(iw)=g(j,i)
	  iw=iw+1
   30	  w(iw)=h(j)
      if=iw+1
c				 store n zeros followed by a one into f.
	  do 40 i=1,n
	  iw=iw+1
   40	  w(iw)=zero
      w(iw+1)=one
c
      np1=n+1
      iz=iw+2
      iy=iz+np1
      iwdual=iy+m
c
      call nnls (w,np1,np1,m,w(if),w(iy),rnorm,w(iwdual),w(iz),index,
     *		 mode)
c		       use the following return if unsuccessful in nnls.
      if (mode.ne.1) return
      if (rnorm) 130,130,50
   50 fac=one
      iw=iy-1
	  do 60 i=1,m
	  iw=iw+1
c				here we are using the solution vector y.
   60	  fac=fac-h(i)*w(iw)
c
      if (diff(one+fac,one)) 130,130,70
   70 fac=one/fac
	  do 90 j=1,n
	  iw=iy-1
	      do 80 i=1,m
	      iw=iw+1
c				here we are using the solution vector y.
   80	      x(j)=x(j)+g(i,j)*w(iw)
   90	  x(j)=x(j)*fac
	  do 100 j=1,n
  100	  xnorm=xnorm+x(j)**2
      xnorm=sqrt(xnorm)
c			      successful return.
  110 mode=1
      return
c			      error return.	  n .le. 0.
  120 mode=2
      return
c			      returning with constraints not compatible.
  130 mode=4
      return
      end

C----------------------------------------------------------------------
        subroutine ftgcls(iunit,colnum,frow,felem,nelem,nultyp,nulval,
     &    sray,flgval,anynul,status)

C       read an array of character string values from the specified column of 
C       the table.
C       The binary or ASCII table column being read must have datatype 'A'
C       This general purpose routine will handle null values in one
C       of two ways: if nultyp=1, then undefined array elements will be
C       set equal to the input value of NULVAL.  Else if nultyp=2, then
C       undefined array elements will have the corresponding FLGVAL element
C       set equal to .TRUE.  If NULTYP=1 and NULVAL=0, then no checks for
C       undefined values will be made, for maximum efficiency.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read from
C       frow    i  first row to read
C       felem   i  first element within row to read
C       nelem   i  number of elements to read
C       nultyp  i  input code indicating how to handle undefined values
C       nulval  c  value that undefined pixels will be set to (if nultyp=1)
C       sray    c  array of data values to be read
C       flgval  l  set .true. if corresponding element undefined (if nultyp=2)
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,nultyp,status
        logical flgval(*),anynul
        character*(*) sray(*),nulval

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bstart,nulchk,twidth,tread,tcode,offset,repeat
        integer ibuff,i1,ntodo,rstart,estart,lennul,strlen,nulfil
        character snull*16, crow*9,cp1*9,cp2*9,ccol*4
        
        if (status .gt. 0)return

C       check for zero length array
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table read '//
     &          'request is out of range:'//crow//' (FTGCLS).')
                return
        else if (felem .lt. 1)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLS).')
                        return
        end if

        anynul=.false.
        ibuff=bufnum(iunit)
        i1=1

C       column must be character string data type

        tcode=tdtype(colnum+tstart(ibuff)) 
        if (tcode .eq. 16)then
C               for ASCII columns, TNULL actually stores the field width
                twidth=tnull(colnum+tstart(ibuff)) 
                ntodo=nelem
                rstart=frow-1
                repeat=trept(colnum+tstart(ibuff))
                if (felem .gt. repeat)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLS).')
                        return
                end if
                estart=felem-1
                bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &                 +tbcol(colnum+tstart(ibuff))+estart*twidth
        else if (tcode .eq. -16)then
C               this is a variable length descriptor field
                ntodo=1
C               read the string length and the starting offset:
                call ftgdes(iunit,colnum,frow,twidth,offset,status)
C               calc the i/o pointer position for the start of the string
                bstart=dtstrt(ibuff)+offset+theap(ibuff)
        else
C               error: not a character string column
                status=309
                call ftpmsg('Cannot to read character string'//
     &          ' from a non-character column of a table (FTGCLS).')
                return
        end if

C       define the max. number of charcters to be read: either
C       the length of the variable length field, or the length
C       of the character string variable, which ever is smaller
        strlen=len(sray(1))
        tread=min(twidth,strlen)

C       move the i/o pointer to the start of the sequence of pixels
        call ftmbyt(iunit,bstart,.false.,status)

        if (status .gt. 0)then
            call ftpmsg('Failed to move to starting position '//
     &      'to read character string(s)  (FTGCLS).')
            return
        end if

        lennul=0
C       determine if we have to check for null values
        if (nultyp .eq. 1 .and. nulval .eq. ' ')then
C               user doesn't want to check for nulls
                nulchk=0
        else
                nulchk=nultyp
                snull=cnull(colnum+tstart(ibuff))
C               lennul = length of the string to check for null values
                lennul=min(len(sray(1)),8)
        end if

C       process one string at a time
20      continue
C       get the string of characters
        sray(i1)=' '
        call ftgcbf(iunit,1,tread,sray(i1),status)
        if (status .gt. 0)return

C       check for null value, if required
        if (nulchk .ne. 0)then
                if (ichar(sray(i1)(1:1)) .eq. 0 .or.
     &              sray(i1)(1:lennul) .eq. snull(1:lennul))then
                        if (nulchk .eq. 1)then
                                sray(i1)=nulval
                                anynul=.true.
                        else
                                flgval(i1)=.true.
                                anynul=.true.
                        end if
                end if
        end if

C       check for null terminated string; pad out with blanks if found
        nulfil=index(sray(i1),char(0))
        if (nulfil .gt. 1)then
                sray(i1)(nulfil:len(sray(1)))=' '               
        end if

        if (status .gt. 0)then
          write(cp1,2000)i1
             write(ccol,2001)colnum
2001         format(i4)
             write(cp1,2000)rstart+1
             write(cp2,2000)estart+1
             if (felem .eq. 1)then
                call ftpmsg('Error while reading ASCII string from '//
     &           'column'//ccol//', row'//cp1//' (FTGCLS).')
             else
                call ftpmsg('Error reading string from '//
     &           'column'//ccol//', row'//cp1
     &         //', element'//cp2//' (FTGCLS).')    
             end if
          return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-1
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+1
                estart=estart+1
                if (estart .eq. repeat)then
                        rstart=rstart+1
                        estart=0
                end if
C               move to the start of the next string; need to do
C               this every time in case we didn't read all the characters
C               from the previous string.
                bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &                 +tbcol(colnum+tstart(ibuff))+estart*twidth
C               move the i/o pointer
                call ftmbyt(iunit,bstart,.false.,status)
                go to 20
        end if
        end

      integer function sdupl (str)
      integer str (100)
      integer mem( 60000)
      common/cdsmem/mem
      integer i
      integer length
      integer j
      integer dsget
      j = dsget (length (str) + 1)
      sdupl = j
      i = 1
23000 if (.not.(str (i) .ne. -2))goto 23002
      mem (j) = str (i)
      j = j + 1
23001 i = i + 1
      goto 23000
23002 continue
      mem (j) = -2
      return
      end

C----------------------------------------------------------------------
        subroutine ftgcve(iunit,colnum,frow,felem,nelem,nulval,array,
     &          anynul,status)

C       read an array of R*4 values from a specified column of the table.
C       Any undefined pixels will be set equal to the value of NULVAL,
C       unless NULVAL=0, in which case no checks for undefined pixels
C       will be made.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of elements to read
C       nulval  r  value that undefined pixels will be set to
C       array   r  returned array of data values that was read from FITS file
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,status
        logical flgval,anynul
        real array(*),nulval

        call ftgcle(iunit,colnum,frow,felem,nelem,1,1,nulval,
     &      array,flgval,anynul,status)
        end        

C--------------------------------------------------------------------------
        subroutine ftrhdu(iunit,xtend,status)

C       read the CHDU structure by reading the header keywords which define
C       the size and structure of the header and data units.

C       iunit   i  Fortran I/O unit number
C       OUTPUT PARAMETERS:
C       xtend   i  returned type of extension:   0 = the primary HDU
C                                                1 = an ASCII table
C                                                2 = a binary table
C                                               -1 = unknown
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991
        
        integer iunit,xtend,status,i,ic,tstat
        character keynam*8,exttyp*10,comm*30,keybuf*80
        logical endof

        if (status .gt. 0)return

C       read first keyword to determine the type of the CHDU
        call ftgrec(iunit,1,keybuf,status)

        if (status .gt. 0)then
          call ftpmsg('Cannot read first keyword in header (FTRHDU)')
                return
        end if

C       release any current column descriptors for this unit
        call ftfrcl(iunit,status)

        keynam=keybuf(1:8)
C       parse the value and comment fields from the record
        call ftpsvc(keybuf,exttyp,comm,status)

        if (status .gt. 0)then
C               unknown type of FITS record; can't read it
          call ftpmsg('Cannot parse value of first keyword; unknown '
     &      //'type of FITS record (FTRHDU):')

        else if (keynam .eq. 'SIMPLE')then
C               initialize the parameters describing the primay HDU
                call ftpini(iunit,status)
                xtend=0
        else if (keynam.eq.'XTENSION')then
                if (exttyp(1:1) .ne. '''')then
C                       value of XTENSION is not a quoted character string!
                        if (keybuf(9:10) .ne. '= ')then
                            call ftpmsg('XTENSION keyword does not '
     &                     //'have "= " in cols 9-10.')
                        else
                        call ftpmsg('Unknown type of extension; value'
     &               //' of XTENSION keyword is not a quoted string:')
                        end if
                        status=251
                        call ftpmsg(keybuf)
                else if (exttyp(2:9) .eq. 'TABLE   ')then
C                       initialize the parameters for the ASCII table extension
                        call ftaini(iunit,status)
                        xtend=1
                else if (exttyp(2:9) .eq. 'BINTABLE' .or. exttyp(2:9)  
     &            .eq. 'A3DTABLE' .or. exttyp(2:9) .eq. '3DTABLE ')then
C                       initialize the parameters for the binary table extension
                        call ftbini(iunit,status)
                        xtend=2
                else 
C                       try to initialize the parameters describing extension
                        tstat=status
                        call ftpini(iunit,status)
                        xtend=0
                        if (status .eq. 251)then
C                           unknown type of extension
                            xtend=-1
                            status=tstat
                        end if
                end if
        else
C               unknown record 
C               If file is created on a VAX with 512-byte records, then
C               the FITS file may have fill bytes (ASCII NULs) at the end.
C               Also, if file has been editted on a SUN, an extra ASCII 10 
C               character may appear at the end of the file.  Finally, if
C               file is not a multiple of the record length long, then
C               the last truncated record may be filled with ASCII blanks.
C               So, if the record only contains NULS, LF, and blanks, then
C               assume we found the end of file.  Otherwise report an error.

                endof=.true.
                do 10 i=1,80
                    ic=ichar(keybuf(i:i))
                    if (ic .ne. 0 .and .ic .ne. 10 .and. ic .ne. 32)
     &                 endof=.false.
10              continue
                if (endof)then
                     status=107
                     call ftpmsg('ASCII 0s, 10s, or 32s at start of '
     &             //'extension are treated as EOF (FTRHDU):')
                else
                     status=252
                     call ftpmsg('Extension does not start with SIMPLE'
     &               //' or XTENSION keyword (FTRHDU):')
                end if
                xtend=-1
                call ftpmsg(keybuf)
        end if        
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGLBLS (ITST,WCWP,HCWP,FLLB,LBIM,FLLN,DBOX,SBOX,RBOX)
C
      DIMENSION FLLB(10,8),FLLN(6,16),DBOX(6,4),SBOX(6,4),RBOX(6)
C
C The routine AGLBLS is used (if ITST .LE. 0) to predict the amount of
C space which will be required for graph labels (excluding the numeric
C labels on the axes, which are handled by AGAXIS) or (if ITST .GT. 0)
C to actually draw the graph labels.
C
C The labels in question are defined by the label list (FLLB array) and
C the line list (FLLN array).  Each label is assumed to lie in one of
C five boxes, as follows:
C
C    Box 1 is to the left of the curve window.
C    Box 2 is to the right of the curve window.
C    Box 3 is below the curve window.
C    Box 4 is above the curve window.
C    Box 5 is the curve window itself.
C    Box 6 is the entire plot (graph) window.
C
C A test run of AGLBLS returns two sets of box dimensions to the caller.
C DBOX contains the dimensions required if all labels are to have their
C desired sizes, SBOX the dimensions required if all labels are to have
C their smallest sizes.  The caller is expected to use this information
C to determine a final set of box dimensions (stored in DBOX), and then
C call AGLBLS again to actually draw the labels in those boxes.
C
C The arguments of AGLBLS are as follows:
C
C -- ITST specifies whether the call is a test call (ITST .LE. 0) or a
C    real call (ITST .GT. 0).  If ABSV(ITST) .GT. 1, AGLBLS is allowed
C    to shrink the labels if they would not otherwise fit in their box.
C    If ABSV(ITST) .EQ. 1, shrinkage of labels is prohibited.  If ITST
C    .EQ. 0, labels are suppressed.
C
C -- WCWP and HCWP are the width and height of the curve window, in
C    plotter-coordinate-system units.  AGLBLS assumes that the last call
C    to the plot package routine "SET" had arguments XLCW, XRCW, YBCW,
C    YTCW, 0., 1., 0., 1., and 1 - defining the most convenient system
C    of coordinates for it.
C
C -- FLLB is the array in which the label list is stored.  The array is
C    doubly-dimensioned.  The first subscript specifies one of ten label
C    attributes, the second a particular label.  The attributes are as
C    follows (the name ILLB(M,N) refers to a label attribute which is
C    intrinsically an integer, despite being stored as a real):
C
C    -- ILLB(1,N) specifies the name of label N.  If ILLB(1,N) is zero,
C       no label is defined.  Otherwise, ILLB(1,N) is an identifier
C       returned by AGSTCH when the name of the label (a character
C       string) was stored away.
C
C    -- ILLB(2,N) may be set non-zero to suppress label N.
C
C    -- FLLB(3,N) and FLLB(4,N) are the x and y coordinates of a base-
C       point relative to which label N is positioned, as fractions of
C       the width and height, respectively, of the curve window.  The
C       position of the base-point determines the box in which label N
C       is considered to lie.
C
C    -- FLLB(5,N) and FLLB(6,N) are small offsets (typically about the
C       size of a character width), stated as fractions of the smaller
C       side of the curve window.  They are used to offset the label
C       base-point (after the box number is determined).  Typically,
C       this provides a minimum spacing between the label and one side
C       of the curve window.
C
C    -- ILLB(7,N) is the orientation angle of the label, in degrees
C       counter-clockwise from horizontal.  The base-line for label N
C       is a vector emanating from the base-point at this angle.  The
C       specified angle must be a multiple of 90 degrees.
C
C    -- ILLB(8,N) is the centering option for the label.  It specifies
C       how each line of the label is to be positioned relative to a
C       line perpendicular to the base-line at the base-point.
C
C       -- If ILLB(8,N) .LT. 0, the left edge of each line lies on
C          the perpendicular.
C
C       -- If ILLB(8,N) .EQ. 0, the center of each line lies on the
C          perpendicular.
C
C       -- If ILLB(8,N) .GT. 0, the right edge of each line lies on
C          the perpendicular.
C
C    -- ILLB(9,N) is the number of lines in label N.
C
C    -- ILLB(10,N) is the second subscript (in the line list) of the
C       first line of label N.
C
C -- LBIM is the maximum number of labels the label list will hold.
C
C -- FLLN is the array in which the line list is stored.  The array is
C    doubly-dimensioned.  The first subscript specifies one of six line
C    attributes, the second a particular line.  The attributes are as
C    follows (the name ILLN(M,N) refers to a line attribute which is
C    intrinsically an integer, despite being stored as a real):
C
C    -- ILLN(1,N) is the position number of line N.  The lines of a
C       label are ordered according to their position numbers, the one
C       having the largest position number being top-most.  Moreover,
C       lines having position numbers .GT. 0 are placed above the label
C       base-line, those having position numbers .EQ. 0 (of which there
C       should be but one) are placed on the label base-line, and those
C       having position numbers .LT. 0 are placed below the label base-
C       line.  The magnitudes of the position numbers have nothing to
C       do with inter-line spacing - that is up to AGLBLS to determine.
C
C    -- ILLN(2,N) may be set non-zero to suppress line N.
C
C    -- FLLN(3,N) is the desired width of characters in the line, as a
C       fraction of the smaller side of the curve window.
C
C    -- ILLN(4,N) is the identifier of the character string comprising
C       the text of the line, as returned by AGSTCH at the time the
C       string was stored.
C
C    -- ILLN(5,N) is the number of characters in the line.
C
C    -- ILLN(6,N) is the index of the next line of the label.  The
C       lines of a label must be ordered by position number (largest
C       to smallest).
C
C -- DBOX and SBOX, dimensioned 6 X 4, contain box dimensions, as dis-
C    cussed above.  D/SBOX(M,N) is the Nth edge-coordinate of box M,
C    where N .EQ. 1 for the left edge, 2 for the right edge, 3 for the
C    bottom edge, and 4 for the top edge, of the box.  The first two are
C    stated as fractions of the width, the second two as fractions of
C    the height, of the curve window.
C
C    RBOX, dimensioned 6, holds reduction factors for the sizes of the
C    characters in labels in each of the six boxes.  Each RBOX(M) is
C
C    -- negative to specify smallest-size characters, or
C
C    -- zero to specify that no reduction factor has been chosen, or
C
C    -- positive, between 0. and 1. (an actual reduction factor).
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.  The only one of
C interest here is MWCL, which is the minimum usable character width,
C in plotter units.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The following common block contains other AUTOGRAPH variables, of type
C character.
C
      COMMON /AGOCHP/ CHS1,CHS2
C
c+noao
c     CHARACTER*504 CHS1,CHS2
      CHARACTER*500 CHS1,CHS2
c-noao
C
C HCFW(WDTH) specifies the height of a character as a function of width.
C
      HCFW(WDTH)=2.*WDTH
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This is the main section of AGLBLS.
C
C Compute the length of the smallest side of the curve window.
C
      SCWP=AMIN1(WCWP,HCWP)
C
C Preset certain jumps in the internal procedure which follows.
C
      ASSIGN 211 TO JMP1
      ASSIGN 216 TO JMP2
      ASSIGN 221 TO JMP3
C
C Jump if this is a test run.
C
      IF (ITST.LE.0) GO TO 101
C
C This is not a test run.  If the reduction factors for the six boxes
C are already set, jump directly to the plotting section; otherwise, we
C must first compute the coordinates of the six smallest-size boxes.
C
      IF (RBOX(1).NE.0.) GO TO 115
      GO TO 105
C
C This is a test run.  Compute the coordinates of the edges of the six
C desired-size boxes.
C
  101 RWCL=1.
      NBOX=0
      ASSIGN 102 TO JMP4
      GO TO 200
C
  102 DBOX(NBOX,1)=XLBX
      DBOX(NBOX,2)=XRBX
      DBOX(NBOX,3)=YBBX
      DBOX(NBOX,4)=YTBX
C
      IF (NBOX.LT.6) GO TO 200
C
C This is a test run.  Compute the coordinates of the edges of the six
C smallest-size boxes, in one of two ways.
C
      IF (IABS(ITST).GT.1) GO TO 105
C
C This is a test run.  Determine smallest-size boxes (no shrinking).
C
      DO 104 J=1,4
        DO 103 I=1,6
          SBOX(I,J)=DBOX(I,J)
  103   CONTINUE
  104 CONTINUE
      RETURN
C
C Determine smallest-size boxes (shrinking allowed).
C
  105 RWCL=0.
      NBOX=0
      ASSIGN 106 TO JMP4
      GO TO 200
C
  106 SBOX(NBOX,1)=XLBX
      SBOX(NBOX,2)=XRBX
      SBOX(NBOX,3)=YBBX
      SBOX(NBOX,4)=YTBX
C
      IF (NBOX.LT.6) GO TO 200
C
C If this is not a test run, jump to compute reduction factors for each
C of the six boxes and then plot the labels.  Otherwise, return.
C
      IF (ITST.GT.0) GO TO 107
      RETURN
C
C This is not a test run.  Compute reduction factors for each of the
C six boxes.
C
  107 NBOX=1
      ASSIGN 110 TO JMP4
C
C (DBOX(NBOX,I),I=1,4) specifies the box in which the labels are to be
C drawn, (SBOX(NBOX,I),I=1,4) the minimum box in which they can be drawn
C if shrunk.  Check first whether the latter is contained in the former.
C If so, we have a chance.  If not, the best we can do is shrink the
C labels to minimum size and hope for the best.
C
  108 IF (SBOX(NBOX,1).LT.SBOX(NBOX,2).AND.
     +    DBOX(NBOX,1)-SBOX(NBOX,1).LT..0001.AND.
     +    SBOX(NBOX,2)-DBOX(NBOX,2).LT..0001.AND.
     +    DBOX(NBOX,3)-SBOX(NBOX,3).LT..0001.AND.
     +    SBOX(NBOX,4)-DBOX(NBOX,4).LT..0001      ) GO TO 109
C
      RBOX(NBOX)=-1.
      GO TO 114
C
C Mimimum-size labels will fit.  Find the largest value of RBOX(NBOX)
C for which the labels will fit.
C
  109 RWCL=1.
      DWCL=.5
      SWCL=0.
      GO TO 201
C
C See if the last value of RBOX(NBOX) gave us labels which would fit or
C not and adjust the value accordingly.
C
  110 IF (DBOX(NBOX,1)-XLBX.LT..0001.AND.
     +    XRBX-DBOX(NBOX,2).LT..0001.AND.
     +    DBOX(NBOX,3)-YBBX.LT..0001.AND.
     +    YTBX-DBOX(NBOX,4).LT..0001      ) GO TO 111
C
C Labels did not fit.  Adjust RBOX(NBOX) downward.
C
      RWCL=RWCL-DWCL
      DWCL=.5*DWCL
      IF (DWCL.LT..001) RWCL=SWCL
      GO TO 201
C
C Labels did fit.  Adjust RBOX(NBOX) upward, unless it is equal to 1.
C
  111 IF (RWCL.EQ.1.) GO TO 113
      SWCL=RWCL
      RWCL=RWCL+DWCL
      DWCL=.5*DWCL
      IF (DWCL.GT..001) GO TO 201
C
C The current value of RBOX(NBOX) is acceptable.  Do next box, if any.
C
  113 IF (NBOX.GE.5) GO TO 114
C
C Return updated box-edge coordinates for boxes 1 through 4.
C
      DBOX(NBOX,1)=XLBX
      DBOX(NBOX,2)=XRBX
      DBOX(NBOX,3)=YBBX
      DBOX(NBOX,4)=YTBX
C
  114 NBOX=NBOX+1
      IF (NBOX.LE.6) GO TO 108
C
C We have done all we can to make the labels fit.  Plot them now.
C
  115 NBOX=0
      LBIN=0
      ASSIGN 117 TO JMP3
      ASSIGN 120 TO JMP4
C
C Get a label to chew on.
C
  116 ASSIGN 211 TO JMP1
      ASSIGN 216 TO JMP2
      GO TO 202
C
C We have a label.  Initialize the re-loop through the lines in it.
C
  117 XPLN=XPLB-DTLB*YDLB/WCWP
      YPLN=YPLB+DTLB*XDLB/HCWP
      PHCL=0.
      LNIN=LNII
      ASSIGN 118 TO JMP1
      ASSIGN 116 TO JMP2
      GO TO 210
C
C Get ready to plot the label line.
C
  118 XPLN=XPLN+.5*(PHCL+FHCL)*YDLB/WCWP
      YPLN=YPLN-.5*(PHCL+FHCL)*XDLB/HCWP
      PHCL=FHCL
      CALL AGGTCH (IFIX(FLLN(4,LNIN)),CHS2,LNC2)
C
C Give the user a chance to change the appearance of the label line.
C
      CALL AGCHIL (0,CHS1(1:LNC1),IFIX(FLLN(1,LNIN)))
C
C Plot the label line.
C
      CALL AGPWRT (XPLN,YPLN,CHS2,LNC2,IWCL,LBOR,LBCN)
C
C Give the user a chance to undo the changes he made above.
C
      CALL AGCHIL (1,CHS1(1:LNC1),IFIX(FLLN(1,LNIN)))
C
C Go get the next line, if any.
C
      GO TO 215
C
C All labels are drawn.  Return.
C
  120 RETURN
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This internal procedure, which may be entered and exited in a number
C of different ways, is used to scan the label list and the line list
C and to return information about the labels and lines defined there.
C
C Entry occurs here to bump the box number, store away a reduction
C factor for the sizes of labels in that box, and then compute the edge
C coordinates of the box required to hold labels of the size implied by
C that reduction factor.
C
  200 NBOX=NBOX+1
C
C Entry occurs here to do all of the above except the bumping of the box
C number.
C
  201 RBOX(NBOX)=RWCL
C
C Initialize the label-list index and the box-edge parameters.
C
      LBIN=0
      XLBX=+1000.
      XRBX=-1000.
      YBBX=+1000.
      YTBX=-1000.
      IF (ITST.EQ.0) GO TO 222
C
C This is the beginning of the loop through the labels.  Entry occurs
C here to find the next label in the list and return positioning info.
C
C Increment the label index and test for end of label list.
C
  202 LBIN=LBIN+1
      IF (LBIN.GT.LBIM) GO TO 222
C
C Skip this label if it is non-existent, suppressed, or empty.
C
      IF (FLLB(1,LBIN).EQ.0..OR.FLLB(2,LBIN).NE.0.
     +                      .OR.FLLB(9,LBIN).EQ.0.) GO TO 202
C
C Unpack the parameters specifying the label-base-point position.
C
      XBLB=FLLB(3,LBIN)
      YBLB=FLLB(4,LBIN)
      XOLB=FLLB(5,LBIN)
      YOLB=FLLB(6,LBIN)
C
C Determine in which of five boxes the label lies:
C
C in the box to the left of the curve window.
C
      LBBX=1
      IF (XBLB.EQ.0..AND.XOLB.LE.0.) GO TO 203
C
C in the box to the right of the curve window,
C
      LBBX=2
      IF (XBLB.EQ.1..AND.XOLB.GE.0.) GO TO 203
C
C in the box below the curve window,
C
      LBBX=3
      IF (YBLB.EQ.0..AND.YOLB.LE.0.) GO TO 203
C
C in the box above the curve window,
C
      LBBX=4
      IF (YBLB.EQ.1..AND.YOLB.GE.0.) GO TO 203
C
C in the curve window,
C
      LBBX=5
      IF ( (XBLB.EQ.0..AND.XOLB.GT.0.).OR.
     +     (XBLB.EQ.1..AND.XOLB.LT.0.).OR.
     +     (YBLB.EQ.0..AND.YOLB.GT.0.).OR.
     +     (YBLB.EQ.1..AND.YOLB.LT.0.)    ) GO TO 203
C
C or elsewhere.
C
      LBBX=6
C
C If we are interested in a particular box and this label is not in that
C box, skip it.
C
  203 IF (NBOX.NE.0.AND.LBBX.NE.NBOX) GO TO 202
C
C On a non-test run, get the label name and length for call to AGCHIL.
C
      IF (ITST.GT.0) CALL AGGTCH (IFIX(FLLB(1,LBIN)),CHS1,LNC1)
C
C Unpack the label orientation and compute its direction cosines.
C
      LBOR=IFIX(FLLB(7,LBIN))
C
      XDLB=COS(.017453292519943*FLLB(7,LBIN))
      YDLB=SIN(.017453292519943*FLLB(7,LBIN))
C
C Unpack the label-centering option.
C
      LBCN=IFIX(FLLB(8,LBIN))
C
C Unpack the index of the initial line of the label and save it.
C
      LNIN=IFIX(FLLB(10,LBIN))
      LNII=LNIN
C
C If this is not a test run, modify the label-base-point position as
C needed to move the label into the actual box in which it must fit.
C
      IF (ITST.LE.0) GO TO 209
C
      GO TO (204,205,206,207,208,209) , LBBX
C
  204 XBLB=XBLB+DBOX(1,2)
      GO TO 209
C
  205 XBLB=XBLB+DBOX(2,1)-1.
      GO TO 209
C
  206 YBLB=YBLB+DBOX(3,4)
      GO TO 209
C
  207 YBLB=YBLB+DBOX(4,3)-1.
      GO TO 209
C
  208 IF (XBLB.EQ.0.) XBLB=XBLB+DBOX(5,1)
      IF (XBLB.EQ.1.) XBLB=XBLB+DBOX(5,2)-1.
      IF (YBLB.EQ.0.) YBLB=YBLB+DBOX(5,3)
      IF (YBLB.EQ.1.) YBLB=YBLB+DBOX(5,4)-1.
C
C Compute the final label-base-point position.
C
  209 XPLB=XBLB+XOLB*SCWP/WCWP
      YPLB=YBLB+YOLB*SCWP/HCWP
C
C Before entering the loop through the line list, initialize the label-
C dimension parameters.
C
      DLLB=0.
      DRLB=0.
      DBLB=0.
      DTLB=0.
C
C This is the beginning of the loop through the lines in a given label.
C Entry may occur here to find the next line and return info about it.
C
C If the line is suppressed or of zero length, skip it.
C
  210 IF (FLLN(2,LNIN).NE.0..OR.FLLN(5,LNIN).LE.0.) GO TO 215
C
C Unpack the position-number, character-width, and character-count
C parameters for the line.
C
      LNPN=IFIX(FLLN(1,LNIN))
      WCLN=FLLN(3,LNIN)
      LNCC=IFIX(FLLN(5,LNIN))
C
C Compute the integer width (IWCL) and the floating-point width and
C height (FWCL and FHCL) of characters in the label.  All are expressed
C in plotter-coordinate-system units.
C
      IWCL=MAX0(MWCL,IFIX(RBOX(LBBX)*WCLN*SCWP+.5))
      FWCL=FLOAT(IWCL)
      FHCL=HCFW(FWCL)
C
C Jump back with line information or drop through, as directed.
C
      GO TO JMP1 , (118,211)
C
C Update the label-dimension parameters.
C
  211 DRLB=AMAX1(DRLB,FLOAT(LNCC)*FWCL)
C
      IF (LNPN) 212,213,214
C
  212 DBLB=DBLB+FHCL
      GO TO 215
C
  213 DBLB=DBLB+.5*FHCL
      DTLB=DTLB+.5*FHCL
      GO TO 215
C
  214 DTLB=DTLB+FHCL
C
C Go to the next line in the label, if there is one.
C
  215 LNIN=IFIX(FLLN(6,LNIN))
      IF (LNIN.NE.0) GO TO 210
C
C Jump back on end of lines or drop through, as directed.
C
      GO TO JMP2 , (116,216)
C
C If all the lines in the label were either suppressed or of zero
C length, skip this label.
C
  216 IF (DRLB.EQ.0.) GO TO 202
C
C Complete the computation of the label dimensions.  The four parameters
C DLLB, DRLB, DBLB, and DTLB represent the distances from the base-point
C to the left edge, right edge, bottom edge, and top edge of the label,
C in plotter-coordinate-system units, where left, right, etc., are as
C viewed by a reader of the label.
C
      IF (LBCN) 217,218,219
C
C Left edges of lines are aligned.
C
  217 GO TO 220
C
C Centers of lines are aligned.
C
  218 DLLB=.5*(DLLB+DRLB)
      DRLB=DLLB
      GO TO 220
C
C Right edges of lines are aligned.
C
  219 SWAP=DLLB
      DLLB=DRLB
      DRLB=SWAP
C
C Jump back with label information or drop through, as directed.
C
  220 GO TO JMP3 , (117,221)
C
C Update the x and y coordinates of the label box edges.
C
  221 XLBX=AMIN1(XLBX,XBLB,
     +     XPLB-AMAX1(+DLLB*XDLB,-DRLB*XDLB,-DBLB*YDLB,+DTLB*YDLB)/WCWP)
      XRBX=AMAX1(XRBX,XBLB,
     +     XPLB+AMAX1(-DLLB*XDLB,+DRLB*XDLB,+DBLB*YDLB,-DTLB*YDLB)/WCWP)
      YBBX=AMIN1(YBBX,YBLB,
     +     YPLB-AMAX1(+DLLB*YDLB,-DRLB*YDLB,+DBLB*XDLB,-DTLB*XDLB)/HCWP)
      YTBX=AMAX1(YTBX,YBLB,
     +     YPLB+AMAX1(-DLLB*YDLB,+DRLB*YDLB,-DBLB*XDLB,+DTLB*XDLB)/HCWP)
C
C Go back for the next label.
C
      GO TO 202
C
C End of label list.  Jump as directed.
C
  222 GO TO JMP4 , (102,106,110,120)
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
      END

      SUBROUTINE ZHAFTO	(IERROR)
C
C LATEST REVISION	 JULY, 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 EZHAFTON AND TO TEST HAFTON ON A SINGLE
C			 PROBLEM
C
C USAGE			 CALL ZHAFTO (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   HAFTON TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, TWO FRAMES CONTAINING THE
C			 HALF-TONE PLOT	ARE PRODUCED ON	THE MACHINE
C			 GRAPHICS DEVICE.  IN ORDER TO DETERMINE IF THE
C			 TEST WAS SUCCESSFUL, IT IS NECESSARY TO EXAMINE
C			 THESE PLOTS.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 HAFTON
C FILES
C
C LANGUAGE		 ANSI FORTRAN 77
C
C ALGORITHM		 THE FUNCTION
C			   Z(X,Y) = X +	Y + 1./((X-.1)**2+Y**2+.09)
C				    -1./((X+.1)**2+Y**2+.09)
C			 FOR X = -1. TO	+1. IN INCREMENTS OF .1	AND
C			     Y = -1.2 TO +1.2 IN INCREMENTS OF .1
C			 IS COMPUTED.
C			 THAFTO	CALLS SUBROUTINES EZHFTN AND HAFTON TO
C			 DRAW TWO HALF-TONE PLOTS OF THE ARRAY Z.
C
C PORTABILITY		 ANSI STANDARD
C
C
C Z CONTAINS THE VALUES	TO BE PLOTTED.
C
C
      REAL	      Z(21,25)
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE COORDINATES RANGE	FROM 0.0 TO 1.0, THE VALUES TX AND TY
C DEFINE THE CENTER OF THE LEFT	EDGE OF	THE TITLE STRING.
C
      DATA TX/0.0762/, TY/0.9769/
C
C SPECIFY SOME ARGUMENT	VALUES FOR ROUTINE HAFTON.
C FLO CONTAINS THE LOW VALUE DESIGNATION FOR HAFTON, FHI
C CONTAINS THE HIGH VALUE DESIGNATION FOR HAFTON, NLEV
C SPECIFIES THE	NUMBER OF UNIQUE LEVELS	BETWEEN	FLO AND	FHI,  THE
C ABSOLUTE VALUE OF NOPT DETERMINES THE	MAPPING	OF Z ONTO THE
C INTENSITIES, AND THE SIGN OF NOPT CONTROLS THE DIRECTNESS OR
C INVERSNESS OF	THE MAPPING.
C
      DATA FLO/-4.0/, FHI/4.0/,	NLEV/8/, NOPT/-3/
C
C
      SAVE
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 0
C
C FILL TWO DIMENSIONAL ARRAY TO	BE PLOTTED
C
      DO  20 I=1,21
	 X = .1*FLOAT(I-11)
	 DO  10	J=1,25
	    Y =	.1*FLOAT(J-13)
	    Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1		     1./((X+.10)**2+Y**2+.09)
   10	 CONTINUE
   20 CONTINUE
C
C SELECT NORMALIZATION TRANS 0 FOR PLOTTING TITLE
C
      CALL GSELNT (0)
C
C
C
C ENTRY	EZHFTN REQUIRES	ONLY THE ARRAY NAME AND	ITS DIMENSIONS
C
C   THE	TITLE FOR THIS PLOT IS
C
C     DEMONSTRATION PLOT FOR ENTRY EZHFTN OF HAFTON
C
      CALL WTSTR (TX,TY,
     1		'DEMONSTRATION PLOT FOR	ENTRY EZHFTN OF	HAFTON',2,0,-1)
      CALL EZHFTN (Z,21,25)
C
C ENTRY	HAFTON ALLOWS USER SPECIFICATIONS OF PLOT PARAMETERS, IF DESIRED
C
C   THE	TITLE FOR THIS PLOT IS
C
C     DEMONSTRATION PLOT FOR ENTRY HAFTON OF HAFTON
C
c     CALL GSELNT (0)
c     CALL WTSTR (TX,TY,
c    1		'DEMONSTRATION PLOT FOR	ENTRY HAFTON OF	HAFTON',2,0,-1)
c     CALL HAFTON (Z,21,21,25,FLO,FHI,NLEV,NOPT,0,0,0.)
c     CALL NEWFM
C
c     WRITE (6,1001)
      RETURN
C
C
c1001 FORMAT ('	    HAFTON TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

#-h-  elseif			  155  local   12/01/80  15:53:51
# elseif - generate code for end of if before else
   include  defs

   subroutine elseif (lab)
   integer lab

   call outgo (lab+1)
   call indent (-1)
   call outcon (lab)
   call indent (1)
   return
   end

C----------------------------------------------------------------------
        subroutine ftmahd(iunit,extno,xtend,status)

C       Move to Absolute Header Data unit
C       move the i/o pointer to the specified HDU and initialize all
C       the common block parameters which describe the extension

C       iunit   i  fortran unit number
C       extno   i  number of the extension to point to.
C       xtend   i  returned type of extension:   0 = the primary HDU
C                                                1 = an ASCII table
C                                                2 = a binary table
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1991

        integer iunit,extno,xtend,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,movto,tstat

        if (status .gt. 0)then
            return
        else if (extno .le. 0 .or. extno .ge. ne)then
            status=301
            return
        end if

        ibuff=bufnum(iunit)

C       check if we are already positioned to the correct HDU
        if (extno .eq. chdu(ibuff))then
C           just return the type of extension
            xtend=hdutyp(ibuff)
        else

C           now move to the extension, or the highest one we know about
10          movto=min(extno,maxhdu(ibuff)+1)

C           before closing out the CHDU, make sure the new extension exists
            call ftmbyt(iunit,hdstrt(ibuff,movto),.false.,status)
            if (status .gt. 0)return

C           close out the current HDU before moving to the new one
            call ftchdu(iunit,status)
            if (status .gt. 0)then
                call ftpmsg('FTMAHD could not close the'//
     &              ' current HDU before moving to the new HDU.')
                return
            end if

            call ftgext(iunit,movto,xtend,status)
            if (status .gt. 0)then
C               failed to move to new extension, so restore previous extension
                tstat=0
                call ftrhdu(iunit,movto,tstat)
                return
            end if

C           continue reading extensions until we get to the one we want
            if (movto .lt. extno)go to 10
        end if
        end        

C--------------------------------------------------------------------------
        subroutine ftcmps(templt,string,casesn,match,exact)

C       compare the template to the string and test if they match.
C       The strings are limited to 68 characters or less (the max. length
C       of a FITS string keyword value.  This routine reports whether
C       the two strings match and whether the match is exact or
C       involves wildcards.

C       this algorithm is very similar to the way unix filename wildcards
C       work except that this first treats a wild card as a literal character
C       when looking for a match.  If there is no literal match, then
C       it interpretes it as a wild card.  So the template 'AB*DE'
C       is considered to be an exact rather than a wild card match to
C       the string 'AB*DE'.

C       templt    C input template (may includ % or * wild cards)
C       string    C input string to be compared to template
C       casesn    L should comparison be case sensitive?
C       match     L (output) does the template match the string?
C       exact     L (output) are the strings an exact match (true) or
C                            is it a wildcard match (false)

C       written by Wm Pence, HEASARC/GSFC, December 1994

        character*(*) templt,string
        logical casesn,match,exact
        character*68 temp,str
        integer tlen,slen,t1,s1

        tlen=len(templt)
        slen=len(string)
        tlen=min(tlen,68)
        slen=min(tlen,68)

        match=.false.
        exact=.true.
        temp=templt
        str=string
        if (.not. casesn)then
            call ftupch(temp)
            call ftupch(str)
        end if

C       check for exact match
        if (temp .eq. str)then
            match=.true.
            return
        else
C           the strings are not identical, any match cannot be exact
            exact=.false.
        end if

        t1=1
        s1=1
10      continue
        if (t1 .gt. tlen .or. s1 .gt. slen)then
C           completely scanned one or both strings, so it must be a match
            match=.true.
            return
        end if

C       see if the characters in the 2 strings are an exact match
        if (temp(t1:t1) .eq. str(s1:s1))then
            s1=s1+1
            t1=t1+1
        else
            exact=.false.
            if (temp(t1:t1) .eq. '?')then
C               The '?' wild card matches anything
                s1=s1+1
                t1=t1+1
            else if (temp(t1:t1) .eq. '*')then
C               get next character from template and look for it in the string
                t1=t1+1
                if (t1 .le. tlen)then
                    if (temp(t1:t1) .eq. ' ')then
C                       * is followed by a space, so a match is guaranteed
                        t1=tlen+1
                    else
20                      continue
                        if (temp(t1:t1) .eq. str(s1:s1))then
C                           found a matching character
                            t1=t1+1
                            s1=s1+1
                        else
C                           increment the string pointer and try again
                            s1=s1+1
                            if (s1 .le. slen)then
                                go to 20
                            else
C                               hit end of string and failed to find a match
                                return
                            end if
                        end if
                    end if
                end if
            else
C               match failed
                return
            end if
        end if
        go to 10
        end

      integer function dsget (w)
      integer w
      integer mem( 60000)
      common/cdsmem/mem
      integer p, q, l
      integer n, k, junk
      integer getlin
      integer c (10)
      n = w + 2
      q = 2
23000 continue
      p = mem (q + 1)
      if (.not.(p .eq. 0))goto 23003
      call remark (31Hin dsget: out of storage space.)
      call remark (41Htype 'c' or 'i' for char or integer dump.)
      junk = getlin (c, 0)
      if (.not.(c (1) .eq. 99 .or. c (1) .eq. 67))goto 23005
      call dsdump (97)
      goto 23006
23005 continue
      if (.not.(c (1) .eq. 105 .or. c (1) .eq. 73))goto 23007
      call dsdump (48)
23007 continue
23006 continue
      call error (19Hprogram terminated.)
23003 continue
      if (.not.(mem (p + 0) .ge. n))goto 23009
      goto 23002
23009 continue
      q = p
23001 goto 23000
23002 continue
      k = mem (p + 0) - n
      if (.not.(k .ge. 8))goto 23011
      mem (p + 0) = k
      l = p + k
      mem (l + 0) = n
      goto 23012
23011 continue
      mem (q + 1) = mem (p + 1)
      l = p
23012 continue
      dsget=(l + 2)
      return
      end

C--------------------------------------------------------------------------
        subroutine ftdcol(iunit,colnum,status)

C       delete a column from a table

C       iunit   i  Fortran I/O unit number
C       colnum  i  number of of the column to be deleted
C       status  i  returned error status (0=ok)

        integer iunit,colnum,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,typhdu,delbyt,fstbyt,sp,tflds,i
        integer naxis1,naxis2,size,freesp,nblock,tbc
        character comm*70,keynam*8

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       test that the CHDU is an ASCII table or BINTABLE
        typhdu=hdutyp(ibuff)
        if (typhdu .ne. 1 .and. typhdu .ne. 2)then
                status=235
                call ftpmsg('Can only delete column from TABLE '//
     &          'or BINTABLE extension (FTDCOL)')
                return
        end if

C       check if column number exists in the table
        tflds=tfield(ibuff)
        if (colnum .lt. 1 .or. colnum .gt. tflds)then
            status=302
            return
        end if

C       get the starting byte position of the column (=zero for first column)
        fstbyt=tbcol(colnum+tstart(ibuff))

C       find the width of the column
        if (typhdu .eq. 1)then
C           tnull is used to store the width of the ASCII column field
C           NOTE: ASCII columns may not be in physical order, or may overlap.

            delbyt=tnull(colnum+tstart(ibuff))

C           delete the space(s) between the columns, if there are any.
            if (colnum .lt. tflds)then
C               check for spaces between following column
                sp=tbcol(colnum+1+tstart(ibuff))-tbcol(colnum+
     &             tstart(ibuff))-delbyt
                if (sp .gt. 0)then
                    delbyt=delbyt+1
                end if
            else if (colnum .gt. 1)then
C               check for space between the last and next to last columns
                sp=tbcol(colnum+tstart(ibuff))-tbcol(colnum-1+
     &             tstart(ibuff))-tnull(colnum-1+tstart(ibuff))
                if (sp .gt. 0)then
                   delbyt=delbyt+1
                   fstbyt=fstbyt-1
                end if
            end if
        else
            if (colnum .lt. tflds)then
                delbyt=tbcol(colnum+1+tstart(ibuff))-
     &                 tbcol(colnum+tstart(ibuff))
            else
                delbyt=rowlen(ibuff)-tbcol(colnum+tstart(ibuff))
            end if
        end if

C       get current size of the table
        naxis1=rowlen(ibuff)
        call ftgkyj(iunit,'NAXIS2',naxis2,comm,status)

C       Calculate how many FITS blocks (2880 bytes) need to be deleted
        size=theap(ibuff)+scount(ibuff)
        freesp=(delbyt*naxis2) + ((size+2879)/2880)*2880 - size
        nblock=freesp/2880

C       shift each row up, deleting the desired column
        call ftcdel(iunit,naxis1,naxis2,delbyt,fstbyt,status)

C       shift the heap up and update pointer to start of heap
        size=delbyt*naxis2
        call fthpup(iunit,size,status)

C       delete the needed number of new FITS blocks at the end of the HDU
        if (nblock .gt. 0)call ftdblk(iunit,nblock,1,status)

        if (typhdu .eq. 1)then
C           adjust the TBCOL values of the remaining columns
            do 10 i=1,tflds
                call ftkeyn('TBCOL',i,keynam,status)
                call ftgkyj(iunit,keynam,tbc,comm,status)
                if (tbc .gt. fstbyt)then
                     tbc=tbc-delbyt
                     call ftmkyj(iunit,keynam,tbc,'&',status)
                end if
10          continue
        end if

C       update the mandatory keywords
        call ftmkyj(iunit,'TFIELDS',tflds-1,'&',status)        
        call ftmkyj(iunit,'NAXIS1',naxis1-delbyt,'&',status)

C       delete the index keywords starting with 'T' associated with the 
C       deleted column and subtract 1 from index of all higher keywords
        call ftkshf(iunit,colnum,tflds,-1,status)

C       parse the header to initialize the new table structure
        call ftrdef(iunit,status)
        end

C----------------------------------------------------------------------
        subroutine ftppnd(ounit,group,felem,nelem,array,nulval,status)

C       Write an array of double precision values into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same as the
C       array being written).  Any input pixels equal to the value of NULVAL
C       will be replaced by the appropriate null value in the output FITS file.

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       felem   i  the first pixel to be written (this routine treats
C                  the primary array a large one dimensional array of
C                  values, regardless of the actual dimensionality).
C       nelem   i  number of data elements to be written
C       array   d  the array of values to be written
C       nulval  d  pixel value used to represent an undefine pixel
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1994

        integer ounit,group,felem,nelem,status,row
        double precision array(*),nulval

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
        row=max(group,1)
        call ftpcnd(ounit,2,row,felem,nelem,array,nulval,status)
        end

C----------------------------------------------------------------------
        subroutine ftpprh(ounit,simple,bitpix,naxis,naxes,
     &                    pcount,gcount,extend,status)

C       OBSOLETE routine: should call ftphpr instead

        integer ounit,bitpix,naxis,naxes(*),pcount,gcount,status
        logical simple,extend

        call ftphpr(ounit,simple,bitpix,naxis,naxes,
     &                    pcount,gcount,extend,status)
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
c +noao: blockdata isosrb changed to run time initialization subroutine
      subroutine isosrb
c     BLOCKDATA ISOSRB
C
C     BLOCK DATA
C
      COMMON /ISOSR2/ LX         ,NX               ,NY   ,ISCR(8,128),
     1                ISCA(8,128)
      COMMON /ISOSR4/ RX         ,RY
      COMMON /ISOSR5/ NBPW       ,MASK(16)      ,GENDON
      LOGICAL               GENDON
      COMMON /ISOSR6/ IX         ,IY               ,IDX  ,IDY,
     1                IS         ,ISS        ,NP         ,CV,
     2                INX(8)     ,INY(8)     ,IR(500)    ,NR
      COMMON /ISOSR7/ IENTRY     ,IONES
      COMMON /ISOSR8/ NMASK(16)  ,IXOLD      ,IYOLD      ,IBTOLD,
     1                HBFLAG     ,IOSLSN     ,LRLX       ,IFSX,
     2                IFSY       ,FIRST      ,IYDIR      ,IHX,
     3                IHB        ,IHS        ,IHV        ,IVOLD,
     4                IVAL       ,IHRX       ,YCHANG     ,ITPD,
     5                IHF
      COMMON /ISOSR9/ BIG        ,IXBIT
      COMMON /TEMPR/  RZERO
      LOGICAL               YCHANG       ,HBFLAG        ,FIRST   ,IHF
C
      logical first1
      SAVE
      data first1 /.true./
      if (.not. first1) then
        return
      endif
      first1 = .false.
c
c     DATA LX,NX,NY/8,128,128/
      LX = 8
      NX = 128
      NY = 128   
c
c     DATA INX(1),INX(2),INX(3),INX(4),INX(5),INX(6),INX(7),INX(8)/
c    1        -1 ,   -1 ,    0 ,    1 ,    1 ,          1 ,      0 ,   -1 /
      INX(1) = -1
      INX(2) = -1
      INX(3) =  0
      INX(4) =  1
      INX(5) =  1
      INX(6) =  1
      INX(7) =  0
      INX(8) = -1
c
c     DATA INY(1),INY(2),INY(3),INY(4),INY(5),INY(6),INY(7),INY(8)/
c    1         0 ,    1 ,    1 ,    1 ,    0 ,   -1 ,   -1 ,   -1 /
      INY(1) =  0
      INY(2) =  1
      INY(3) =  1
      INY(4) =  1
      INY(5) =  0
      INY(6) = -1
      INY(7) = -1
      INY(8) = -1
c
c     DATA NR/500/
      NR = 500
c
c     DATA NBPW/16/
      NBPW = 16
c
c     DATA IHF/.FALSE./
      IHF = .FALSE.
C
c     DATA GENDON /.FALSE./
      GENDON = .FALSE.
c
c     DATA RZERO/0./
      RZERO = 0.
C
C
C RX = (NX-1)/SCREEN WIDTH FROM TRN32I
C RY = (NY-1)/SCREEN HEIGHT FROM TRN32I
C
c     DATA RX,RY/.00389,.00389/
      RX = .00389
      RY = .00389  
C
c -noao
      END

include  defs

# SQUASH - convert a long or special identifier into a Fortran variable

subroutine squash (id)

character id(MAXTOK)
integer junk, i, j
integer lookup, ludef
character newid(MAXTOK), recdid(MAXTOK)
include COMMON_BLOCKS

	# identify names for which error checking is to be performed
	if (body == YES & errtbl != NULL & ername == NO)
	    if (lookup (id, junk, errtbl) == YES)
		ername = YES

	j = 1
	for (i=1;  id(i) != EOS;  i=i+1)		# copy, delete '_'
	    if ((BIGA <= id(i) & id(i) <= BIGZ)
              | (LETA <= id(i) & id(i) <= LETZ)
              | (DIG0 <= id(i) & id(i) <= DIG9)) {
		newid(j) = id(i)
	        j = j + 1
	    }
	newid(j) = EOS

	# done if ordinary (short) Fortran variable
	if (i-1 < MAXIDLENGTH & i == j)
	    return

# Otherwise, the identifier (1) is longer than Fortran allows,
# (2) contains special characters (_ or .), or (3) is the maximum
# length permitted by the Fortran compiler.  The first two cases
# obviously call for name conversion; the last case may require conversion
# to avoid accidental conflicts with automatically generated names.

	if (lookup (id, junk, fkwtbl) == YES)	# Fortran key word?
	    return				# (must be treated as reserved)

	if (ludef (id, recdid, namtbl) == YES) {   # have we seen this before?
	    call scopy (recdid, 1, id, 1)
	    return
	}
		
	call mapid (newid)			# try standard mapping
	if (lookup (newid, junk, gentbl) == YES) {
	    call synerr ("Warning: identifier mapping not unique.")
	    call uniqid (newid)
	}
	call entdef (newid, id, gentbl)

	call entdef (id, newid, namtbl)		# record it for posterity
	call scopy (newid, 1, id, 1)		# substitute it for the old one
end

      SUBROUTINE CONCLS (ZD,NDP)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  GENERATE CONTOUR LEVELS BASED ON THE INPUT DATA
C
      DIMENSION       ZD(1)
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      SAVE
C
C  IF NOT USER SET COMPUTE CONTOUR LEVELS
C
      IF (.NOT.CON) GO TO  150
C
C  OTHERWISE GET HI AND LOW CONTOURS FOR MESSAGE
C
      HI = CL(1)
      FLO = CL(1)
      DO  110 I=1,NCL
         IF (HI .GE. CL(I)) GO TO  100
         HI = CL(I)
         GO TO  110
  100    IF (FLO .LE. CL(I)) GO TO  110
         FLO = CL(I)
  110 CONTINUE
C
C GET INCREMENT IF EQUAL SPACED CONTOURS
C
      IF (NCL .NE. 1) GO TO  120
      FINC = 0.
      RETURN
  120 FINC = ABS(CL(1)-CL(2))
      IF (NCL .EQ. 2) RETURN
      DO  130 I=3,NCL
         IF (FINC .NE. ABS(CL(I-1)-CL(I))) GO TO  140
  130 CONTINUE
      RETURN
  140 FINC = -1.
      RETURN
C
C  FIND HIGHEST AND LOWEST INPUT VALUES
C
  150 IF (CHILO) GO TO  180
      FLO = ZD(1)
      HI = ZD(1)
      DO  170 I=2,NDP
         IF (FLO .LE. ZD(I)) GO TO  160
         FLO = ZD(I)
         GO TO  170
  160    IF (HI .GE. ZD(I)) GO TO  170
         HI = ZD(I)
  170 CONTINUE
C
C  CALCULATE THE CONTOUR LEVEL INTERVAL
C
  180 IF (CINC) GO TO  200
      FINC = (HI-FLO)/15.
      IF (FINC .NE. 0.) GO TO  190
      CALL SETER (' CONCLS - CONSTANT INPUT FIELD',1,1)
      RETURN
C
C  ROUND FINC TO NICE NUMBER
C
  190 P = 10.**(IFIX(ALOG10(FINC)+500.)-500)
      FINC = AINT(FINC/P+0.1)*P
C
C  ROUND THE LOW VALUE TO START AT A NICE NUMBER
C
  200 IF (CHILO) GO TO  210
      FLO = AINT(FLO/FINC)*FINC
C
C  COMPUTE THE CONTOUR LEVELS
C
C  TEST IF BREAK POINT WITHIN RANGE OF HI TO FLO
C
  210 IF (BPSIZ.GE.FLO .AND. BPSIZ.LE.HI) GO TO  240
C
C  BREAK POINT OUT OF RANGE SO GENERATE CONTOURS BASED ON FLO
C
      DO  220 I=1,30
         CV = FLO+FLOAT(I-1)*FINC
         ICUR = I
         CL(I) = CV
         IF (CV .GE. HI) GO TO  230
  220 CONTINUE
  230 NCL = ICUR
      HI = CV
      RETURN
C
C  BREAK POINT WITHIN RANGE SO BASE CONTOURS ON IT
C
  240 DO  250 I=1,30
         CV = BPSIZ-FLOAT(I-1)*FINC
         IND = (30-I)+1
         CL(IND) = CV
         ICUR = I
         IF (CV .LE. FLO) GO TO  260
  250 CONTINUE
C
C  PUT THE CONTOURS IN THE CORRECT ORDER
C
  260 DO  270 I=1,ICUR
         IND = (30-ICUR)+I
         CL(I) = CL(IND)
  270 CONTINUE
C
C  ADD THE GREATER THAN BREAK POINT CONTOURS
C
      IEND = 30-ICUR
      ISAV = ICUR+1
      DO  280 I=1,IEND
         CV = BPSIZ+FLOAT(I)*FINC
         CL(ISAV) = CV
         ISAV = ISAV+1
         IF (CV .GE. HI) GO TO  290
  280 CONTINUE
C
C  SET NUMBER OF CONTOUR LEVELS AND UPDATE THE HIGH VALUE
C
  290 NCL = ISAV-1
      HI = CV
      RETURN
      END

C--------------------------------------------------------------------------
        subroutine ftprsv(keyrec,lenval,status)

C       find the total length of the keyword+value string in a keyword record

C       keyrec  c  80 column header record
C       OUTPUT PARAMETERS:
C       lenval  i  output length of keyword+value string
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*80 keyrec
        integer lenval,status,j,c1

        if (status .gt. 0)return

        if (keyrec(1:8) .eq.'COMMENT ' .or. keyrec(1:8).eq.'HISTORY '
     &  .or. keyrec(1:8).eq.'END     ' .or. keyrec(1:8).eq.'        ')
     &  then
C           this is a COMMENT or HISTORY record, with no value
             lenval=8
        else if (keyrec(9:10) .eq. '= ')then
C           this keyword has a value field; now find the first character:
            do 10 j=10,80
                if (keyrec(j:j) .ne. ' ')then
                        c1=j
                        go to 15
                end if
10          continue
C           error: value is blank
            status=204
            call ftpmsg('The keyword '//keyrec(1:8)//
     &      ' has no value string after the equal sign:')
            call ftpmsg(keyrec)
            return

15          if (keyrec(c1:c1) .eq. '''')then
C               This is a string value.
C               Work forward to find a single quote.  Two single quotes
C               in succession is to be interpreted as a literal single
C               quote character as part of the character string, not as
C               the end of the character string.  Everything to the right 
C               of the closing quote is assumed to be the comment.
                do 20 j=c1+1,80
                    if (keyrec(j:j) .eq. '''')then
                        if (j.lt.80 .and. keyrec(j+1:j+1).eq.'''')then
C                               found 2 successive quote characters; this is 
C                               interpreted as a literal quote character
                        else
                                lenval=max(30,j)
                                go to 30
                        end if
                    end if
20              continue
C               error: no closing quote character
                status=205
            call ftpmsg('The following Keyword value string has '//
     &            'no closing quote:')
            call ftpmsg(keyrec)
                return
            else
C               This is either an integer, floating point, or logical value.
C               Extract the first token as the value; remainder = comment
                do 25 j=c1,80
                    if (keyrec(j:j) .eq. ' ')then
                        lenval=j-1
                        go to 30
                    end if
25              continue
C               the first token went all the way to column 80:
                lenval=80
            end if
        else
C               illegal keyword record format; must have '= ' in columns 9-10
C                status=210
C            Modified July 1993:  this is actually not an error.  The
C            keyword should simply be interpreted as a comment.
             lenval=8
        end if
30      continue
        end

chapter xvi, example 2, taut spline interpolation to the
c  titanium heat data of example xiii.3.
c  from  * a practical guide to splines *  by c. de boor
calls titand,tautsp,ppvalu(interv)
      integer i,iflag,ipick(12),ipicki,k,l,lx,n,npoint
      real break(122),coef(4,22),gamma,gtau(49),gtitan(49),plotf(201)
     *	  ,plott(201),plotts(201),scrtch(119),step,tau(12),x(49)
      real ppvalu
      data n,ipick /12,1,5,11,21,27,29,31,33,35,40,45,49/
      data k,npoint /4,201/
      call titand ( x, gtitan, lx )
      do 10 i=1,n
	 ipicki = ipick(i)
	 tau(i) = x(ipicki)
   10	 gtau(i) = gtitan(ipicki)
      call tautsp(tau,gtau,n,0.,scrtch,break,coef,l,k,iflag)
      if (iflag .gt. 1) 		stop
      step = (tau(n) - tau(1))/float(npoint-1)
      do 20 i=1,npoint
	 plott(i) = tau(1) + step*float(i-1)
   20	 plotf(i) = ppvalu(break,coef,l,k,plott(i),0)
    1 print 601
  601 format(18h gamma = ? (f10.3))
      read 500,gamma
  500 format(f10.3)
      if (gamma .lt. 0.)		stop
      call tautsp(tau,gtau,n,gamma,scrtch,break,coef,l,k,iflag)
      if (iflag .gt. 1) 		stop
      do 30 i=1,npoint
   30	 plotts(i) = ppvalu(break,coef,l,k,plott(i),0)
      print 602,gamma,(plott(i),plotf(i),plotts(i),i=1,npoint)
  602 format(/42h cubic spline vs. taut spline with gamma =,f6.3//
     *	    (f15.7,2e20.8))
					go to 1
      end

C----------------------------------------------------------------------
        subroutine ftgcxj(iunit,colnum,frow,nrow,fbit,nbit,
     &             jvalue,status)

C       read any consecutive bits from an 'X' or 'B' column as an unsigned
C       n-bit integer, unless nbits=32 in which case the 32 bits
C       are interpreted as a 32-bit signed 2s complement word

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       nrow    i  number of rows to read
C       fbit    i  first bit within the row to read
C       nbit    i  number of bits to read
C       jvalue  i  returned integer value(s)
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Nov 1994

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer iunit,colnum,fbit,nbit,frow,nrow,status,i,j,k,row,jval
        integer jvalue(*),power2(32),ibuff
        logical lray(32)
        save power2
        data power2/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     &  16384,32768,65536,131072,262144,524288,1048576,2097152,4194304,
     &  8388608,16777216,33554432,67108864,134217728,268435456,536870912
     &  ,1073741824,0/

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

        if (nbit .gt. 32)then
            call ftpmsg('Cannot read more than 32 bits (ftgcxj)')
            status=308
            return
        else if ((fbit+nbit+6)/8 .gt. trept(colnum+tstart(ibuff)))then
            call ftpmsg('Asked to read more bits than exist in'//
     &      ' the column (ftgcxj)')
            status=308
            return
        end if

        row=frow-1
        do 30 k=1,nrow
            row=row+1
C           get the individual bits
            call ftgcx(iunit,colnum,row,fbit,nbit,lray,status)
            if (status .gt. 0)return

            jval=0
            j=0
            if (nbit .eq. 32 .and. lray(1))then
C               interprete this as a 32 bit negative integer
                do 10 i=32,2,-1
                    j=j+1
                    if (.not. lray(i))jval=jval+power2(j)
10              continue
C               make 2's complement
                jvalue(k)=-jval-1
            else
C               reconstruct the positive integer value
                do 20 i=nbit,1,-1
                    j=j+1
                    if (lray(i))jval=jval+power2(j)
20              continue
                jvalue(k)=jval
            end if
30      continue
        end

C PACKAGE ERPRT77	 DESCRIPTION OF	INDIVIDUAL USER	ENTRIES
C			 FOLLOWS THIS PACKAGE DESCRIPTION.
C
C LATEST REVISION	 FEBRUARY 1985
C
C PURPOSE		 TO PROVIDE A PORTABLE,	FORTRAN	77 ERROR
C			 HANDLING PACKAGE.
C
C USAGE			 THESE ROUTINES	ARE INTENDED TO	BE USED	IN
C			 THE SAME MANNER AS THEIR SIMILARLY NAMED
C			 COUNTERPARTS ON THE PORT LIBRARY.  EXCEPT
C			 FOR ROUTINE SETER, THE	CALLING	SEQUENCES
C			 OF THESE ROUTINES ARE THE SAME	AS FOR
C			 THEIR PORT COUNTERPARTS.
C			 ERPRT77 ENTRY		PORT ENTRY
C			 -------------		----------
C			 ENTSR			ENTSRC
C			 RETSR			RETSRC
C			 NERRO			NERROR
C			 ERROF			ERROFF
C			 SETER			SETERR
C			 EPRIN			EPRINT
C			 FDUM			FDUMP
C
C I/O			 SOME OF THE ROUTINES PRINT ERROR MESSAGES.
C
C PRECISION		 NOT APPLICABLE
C
C REQUIRED LIBRARY	 MACHCR, WHICH IS LOADED BY DEFAULT ON
C FILES			 NCAR'S	CRAY MACHINES.
C
C LANGUAGE		 FORTRAN 77
C
C HISTORY		 DEVELOPED OCTOBER, 1984 AT NCAR IN BOULDER,
C			 COLORADO BY FRED CLARE	OF THE SCIENTIFIC
C			 COMPUTING DIVISION BY ADAPTING	THE NON-
C			 PROPRIETARY, ERROR HANDLING ROUTINES
C			 FROM THE PORT LIBRARY OF BELL LABS.
C
C PORTABILITY		 FULLY PORTABLE
C
C REFERENCES		 SEE THE MANUAL
C			   PORT	MATHEMATICAL SUBROUTINE	LIBRARY
C			 ESPECIALLY "ERROR HANDLING" IN	SECTION	2
C			 OF THE	INTRODUCTION, AND THE VARIOUS
C			 SUBROUTINE DESCRIPTIONS.
C ******************************************************************
C
C SUBBROUTINE ENTSR(IROLD,IRNEW)
C
C PURPOSE		SAVES THE CURRENT RECOVERY MODE	STATUS AND
C			SETS A NEW ONE.	 IT ALSO CHECKS	THE ERROR
C			STATE, AND IF THERE IS AN ACTIVE ERROR
C			STATE A	MESSAGE	IS PRINTED.
C
C USAGE			CALL ENTSR(IROLD,IRNEW)
C
C ARGUMENTS
C
C ON INPUT		 IRNEW
C			   VALUE SPECIFIED BY USER FOR ERROR
C			   RECOVERY
C			   = 0 LEAVES RECOVERY UNCHANGED
C			   = 1 GIVES  RECOVERY
C			   = 2 TURNS  RECOVERY OFF
C
C ON OUTPUT		 IROLD
C			   RECEIVES THE	CURRENT	VALUE OF THE ERROR
C			   RECOVERY MODE
C
C SPECIAL CONDITIONS	 IF THERE IS AN	ACTIVE ERROR STATE, THE
C			 MESSAGE IS PRINTED AND	EXECUTION STOPS.
C
C			 ERROR STATES -
C			 1 - ILLEGAL VALUE OF IRNEW.
C			 2 - CALLED WHILE IN AN	ERROR STATE.
C ******************************************************************
C
C SUBROUTINE RETSR(IROLD)
C
C PURPOSE		 SETS THE RECOVERY MODE	TO THE STATUS GIVEN
C			 BY THE	INPUT ARGUMENT.	 A TEST	IS THEN	MADE
C			 TO SEE	IF A CURRENT ERROR STATE EXISTS	WHICH
C			 IS UNRECOVERABLE; IF SO, RETSR	PRINTS AN
C			 ERROR MESSAGE AND TERMINATES THE RUN.
C
C			 BY CONVENTION,	RETSR IS USED UPON EXIT
C			 FROM A	SUBROUTINE TO RESTORE THE PREVIOUS
C			 RECOVERY MODE STATUS STORED BY	ROUTINE
C			 ENTSR IN IROLD.
C
C USAGE			 CALL RETSR(IROLD)
C
C ARGUMENTS
C
C ON INPUT		 IROLD
C			   = 1 SETS FOR	RECOVERY
C			   = 2 SETS FOR	NONRECOVERY
C
C ON OUTPUT		 NONE
C
C SPECIAL CONDITIONS	 IF THE	CURRENT	ERROR BECOMES UNRECOVERABLE,
C			 THE MESSAGE IS	PRINTED	AND EXECUTION STOPS.
C
C			 ERROR STATES -
C			   1 - ILLEGAL VALUE OF	IROLD.
C ******************************************************************
C
C INTEGER FUNCTION NERRO(NERR)
C
C PURPOSE		 PROVIDES THE CURRENT ERROR NUMBER (IF ANY)
C			 OR ZERO IF THE	PROGRAM	IS NOT IN THE
C			 ERROR STATE.
C
C USAGE			 N = NERRO(NERR)
C
C ARGUMENTS
C
C ON INPUT		 NONE
C
C ON OUTPUT		 NERR
C			   CURRENT VALUE OF THE	ERROR NUMBER
C ******************************************************************
C SUBROUTINE ERROF
C
C PURPOSE		 TURNS OFF THE ERROR STATE BY SETTING THE
C			 ERROR NUMBER TO ZERO
C
C USAGE			 CALL ERROF
C
C ARGUMENTS
C
C ON INPUT		 NONE
C
C ON OUTPUT		 NONE
C ******************************************************************
C
C SUBROUTINE SETER(MESSG,NERR,IOPT)
C
C PURPOSE		 SETS THE ERROR	INDICATOR AND, DEPENDING
C			 ON THE	OPTIONS	STATED BELOW, PRINTS A
C			 MESSAGE AND PROVIDES A	DUMP.
C
C
C USAGE			 CALL SETER(MESSG,NERR,IOPT)
C
C ARGUMENTS
C
C ON INPUT		 MESSG
C			   HOLLERITH STRING CONTAINING THE MESSAGE
C			   ASSOCIATED WITH THE ERROR
C
C			 NERR
C			   THE NUMBER TO ASSIGN	TO THE ERROR
C
C			 IOPT
C			   = 1 FOR A RECOVERABLE ERROR
C			   = 2 FOR A FATAL ERROR
C
C			  IF IOPT = 1 AND THE USER IS IN ERROR
C			  RECOVERY MODE, SETERR	SIMPLY REMEMBERS
C			  THE ERROR MESSAGE, SETS THE ERROR NUMBER
C			  TO NERR, AND RETURNS.
C
C			  IF IOPT = 1 AND THE USER IS NOT IN ERROR
C			  RECOVERY MODE, SETERR	PRINTS THE ERROR
C			  MESSAGE AND TERMINATES THE RUN.
C
C			  IF IOPT = 2 SETERR ALWAYS PRINTS THE ERROR
C			  MESSAGE, CALLS FDUM, AND TERMINATES THE RUN.
C
C ON OUTPUT		 NONE
C
C SPECIAL CONDITIONS	 CANNOT	ASSIGN NERR = 0, AND CANNOT SET	IOPT
C			 TO ANY	VALUE OTHER THAN 1 OR 2.
C ******************************************************************
C
C  SUBROUTINE EPRIN
C
C PURPOSE		 PRINTS	THE CURRENT ERROR MESSAGE IF THE
C			 PROGRAM IS IN THE ERROR STATE;	OTHERWISE
C			 NOTHING IS PRINTED.
C
C USAGE			 CALL EPRIN
C
C ARGUMENTS
C
C ON INPUT		 NONE
C
C ON OUTPUT		 NONE
C ******************************************************************
C
C SUBROUTINE FDUM
C
C PURPOSE		 TO PROVIDE A DUMMY ROUTINE WHICH SERVES
C			 AS A PLACEHOLDER FOR A	SYMBOLIC DUMP
C			 ROUTINE, SHOULD IMPLEMENTORS DECIDE TO
C			 PROVIDE SUCH A	ROUTINE.
C
C USAGE			 CALL EPRIN
C
C ARGUMENTS
C
C ON INPUT		 NONE
C
C ON OUTPUT		 NONE
C ******************************************************************
      SUBROUTINE ENTSR(IROLD,IRNEW)
C
      LOGICAL TEMP
      IF (IRNEW.LT.0 .OR. IRNEW.GT.2)
     1	 CALL SETER(' ENTSR - ILLEGAL VALUE OF IRNEW',1,2)
C
      TEMP = IRNEW.NE.0
      IROLD = I8SAV(2,IRNEW,TEMP)
C
C  IF HAVE AN ERROR STATE, STOP	EXECUTION.
C
      IF (I8SAV(1,0,.FALSE.) .NE. 0) CALL SETER
     1	 (' ENTSR - CALLED WHILE IN AN ERROR STATE',2,2)
C
      RETURN
C
      END
      SUBROUTINE RETSR(IROLD)
C
      IF (IROLD.LT.1 .OR. IROLD.GT.2)
     1	CALL SETER(' RETSR - ILLEGAL VALUE OF IROLD',1,2)
C
      ITEMP=I8SAV(2,IROLD,.TRUE.)
C
C  IF THE CURRENT ERROR	IS NOW UNRECOVERABLE, PRINT AND	STOP.
C
      IF (IROLD.EQ.1 .OR. I8SAV(1,0,.FALSE.).EQ.0) RETURN
C
	CALL EPRIN
	CALL FDUM
c       STOP
C
      END
      INTEGER FUNCTION NERRO(NERR)
C
      NERRO=I8SAV(1,0,.FALSE.)
      NERR=NERRO
      RETURN
C
      END
      SUBROUTINE ERROF
C
      I=I8SAV(1,0,.TRUE.)
      RETURN
C
      END
      SUBROUTINE SETER(MESSG,NERR,IOPT)
C
      CHARACTER*(*) MESSG
      COMMON /UERRF/IERF
C
C  THE UNIT FOR	ERROR MESSAGES IS I1MACH(4)
C
c +noao:  blockdata uerrbd changed to runtime initialization subroutine
C     FORCE LOAD OF BLOCKDATA
C
c     EXTERNAL UERRBD
      call uerrbd
c -noao
      IF (IERF .EQ. 0) THEN
      IERF = I1MACH(4)
      ENDIF
C
      NMESSG = LEN(MESSG)
      IF (NMESSG.GE.1) GO TO 10
C
C  A MESSAGE OF	NON-POSITIVE LENGTH IS FATAL.
C
c +noao:  FTN writes rewritten as calls to uliber for IRAF
c       WRITE(IERF,9000)
c9000	FORMAT(' ERROR 1 IN SETER - MESSAGE LENGTH NOT POSITIVE.')
        call uliber (1,' SETER - MESSAGE LENGTH NOT POSITIVE.', 80) 
c -noao
	GO TO 60
C
   10 CONTINUE
      IF (NERR.NE.0) GO	TO 20
C
C  CANNOT TURN THE ERROR STATE OFF USING SETER.
C
c +noao:  FTN writes rewritten as calls to uliber for IRAF
c       WRITE(IERF,9001)
c9001	FORMAT(' ERROR 2 IN SETER - CANNOT HAVE NERR=0'/
c    1	       ' THE CURRENT ERROR MESSAGE FOLLOWS'/)
        call uliber (2, ' SETER - CANNOT HAVE NERR=0', 80)
        call uliber (2, ' SETER - THE CURRENT ERROR MSG FOLLOWS', 80) 
c -noao
	CALL E9RIN(MESSG,NERR,.TRUE.)
	ITEMP=I8SAV(1,1,.TRUE.)
	GO TO 50
C
C  SET LERROR AND TEST FOR A PREVIOUS UNRECOVERED ERROR.
C
 20   CONTINUE
      IF (I8SAV(1,NERR,.TRUE.).EQ.0) GO	TO 30
C
c +noao: FTN writes rewritten as calls to uliber for IRAF
c       WRITE(IERF,9002)
c9002	FORMAT(' ERROR	  3 IN SETER -',
c    1	       ' AN UNRECOVERED	ERROR FOLLOWED BY ANOTHER ERROR.'//
c    2	       ' THE PREVIOUS AND CURRENT ERROR	MESSAGES FOLLOW.'///)
        call uliber (3,' SETER - A SECOND UNRECOV ERROR SEEN.', 80)
        call uliber (3,' SETER - THE ERROR MESSAGES FOLLOW.', 80)
c -noao
	CALL EPRIN
	CALL E9RIN(MESSG,NERR,.TRUE.)
	GO TO 50
C
C  SAVE	THIS MESSAGE IN	CASE IT	IS NOT RECOVERED FROM PROPERLY.
C
 30   CALL E9RIN(MESSG,NERR,.TRUE.)
C
      IF (IOPT.EQ.1 .OR. IOPT.EQ.2) GO TO 40
C
C  MUST	HAVE IOPT = 1 OR 2.
C
c +noao:  FTN writes rewritten as calls to uliber for IRAF
c     WRITE(IERF,9003)
c9003	FORMAT(' ERROR	  4 IN SETER - BAD VALUE FOR IOPT'//
c    1	       ' THE CURRENT ERROR MESSAGE FOLLOWS'///)
        call uliber (4, ' SETER - BAD VALUE FOR IOPT', 80)
	call uliber (4, ' SETER - THE CURRENT ERR MSG FOLLOWS', 80)
c -noao 
	GO TO 50
C
C  TEST	FOR RECOVERY.
C
 40   CONTINUE
      IF (IOPT.EQ.2) GO	TO 50
C
      IF (I8SAV(2,0,.FALSE.).EQ.1) RETURN
C
      CALL EPRIN
      CALL FDUM
c     STOP
C
 50   CALL EPRIN
 60   CALL FDUM
c     STOP
C
      END
      SUBROUTINE EPRIN
C
      CHARACTER*1 MESSG
C
      CALL E9RIN(MESSG,1,.FALSE.)
      RETURN
C
      END
      SUBROUTINE E9RIN(MESSG,NERR,SAVE)
C
C  THIS	ROUTINE	STORES THE CURRENT ERROR MESSAGE OR PRINTS THE OLD ONE,
C  IF ANY, DEPENDING ON	WHETHER	OR NOT SAVE = .TRUE. .
C
      CHARACTER*(*) MESSG
      CHARACTER*113 MESSGP
      LOGICAL SAVE
      COMMON /UERRF/IERF
C
C  MESSGP STORES THE FIRST 113 CHARACTERS OF THE PREVIOUS MESSAGE
C
C
C  START WITH NO PREVIOUS MESSAGE.
C
c+noao
c Moved save to before data statements.
      SAVE MESSGP,NERRP
c-noao
      DATA MESSGP/'1'/
      DATA NERRP/0/
C
      IF (.NOT.SAVE) GO	TO 20
C
C  SAVE	THE MESSAGE.
C
	NERRP=NERR
	MESSGP = MESSG
C
	GO TO 30
C
 20   IF (I8SAV(1,0,.FALSE.).EQ.0) GO TO 30
C
C  PRINT THE MESSAGE.
C
c +noao:  FTN write rewritten as call to uliber
c     WRITE(IERF,9000) NERRP,MESSGP
c9000 FORMAT(' ERROR ',I4,' IN ',A113)
      call uliber (nerrp, messgp, 113)
C
 30   RETURN
C
      END
      INTEGER FUNCTION I8SAV(ISW,IVALUE,SET)
C
C  IF (ISW = 1)	I8SAV RETURNS THE CURRENT ERROR	NUMBER AND
C		SETS IT	TO IVALUE IF SET = .TRUE. .
C
C  IF (ISW = 2)	I8SAV RETURNS THE CURRENT RECOVERY SWITCH AND
C		SETS IT	TO IVALUE IF SET = .TRUE. .
C
      LOGICAL SET
C
C  START EXECUTION ERROR FREE AND WITH RECOVERY	TURNED OFF.
C
c+noao
c Moved save to before data statement.
      SAVE LERROR,LRECOV
      DATA LERROR/0/ , LRECOV/2/
c-noao
      IF (ISW .EQ. 1) THEN
	I8SAV =	LERROR
	IF (SET) LERROR	= IVALUE
      ELSE IF (ISW .EQ.	2) THEN
	I8SAV =	LRECOV
	IF (SET) LRECOV	= IVALUE
      ENDIF
      RETURN
      END
      SUBROUTINE FDUM
C
C     DUMMY ROUTINE TO BE LOCALLY IMPLEMENTED
C
      RETURN
      END
c +noao:  Blockdata uerrbd rewritten as a runtime initialization subroutine
c     BLOCKDATA	UERRBD
      subroutine uerrbd
c
      COMMON /UERRF/IERF
C     DEFAULT ERROR UNIT
c     DATA IERF/0/
      IERF= 0
      END
c -noao

*> \brief \b DTRSM
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*       SUBROUTINE DTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
*
*       .. Scalar Arguments ..
*       DOUBLE PRECISION ALPHA
*       INTEGER LDA,LDB,M,N
*       CHARACTER DIAG,SIDE,TRANSA,UPLO
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION A(LDA,*),B(LDB,*)
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DTRSM  solves one of the matrix equations
*>
*>    op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
*>
*> where alpha is a scalar, X and B are m by n matrices, A is a unit, or
*> non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
*>
*>    op( A ) = A   or   op( A ) = A**T.
*>
*> The matrix X is overwritten on B.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>           On entry, SIDE specifies whether op( A ) appears on the left
*>           or right of X as follows:
*>
*>              SIDE = 'L' or 'l'   op( A )*X = alpha*B.
*>
*>              SIDE = 'R' or 'r'   X*op( A ) = alpha*B.
*> \endverbatim
*>
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>           On entry, UPLO specifies whether the matrix A is an upper or
*>           lower triangular matrix as follows:
*>
*>              UPLO = 'U' or 'u'   A is an upper triangular matrix.
*>
*>              UPLO = 'L' or 'l'   A is a lower triangular matrix.
*> \endverbatim
*>
*> \param[in] TRANSA
*> \verbatim
*>          TRANSA is CHARACTER*1
*>           On entry, TRANSA specifies the form of op( A ) to be used in
*>           the matrix multiplication as follows:
*>
*>              TRANSA = 'N' or 'n'   op( A ) = A.
*>
*>              TRANSA = 'T' or 't'   op( A ) = A**T.
*>
*>              TRANSA = 'C' or 'c'   op( A ) = A**T.
*> \endverbatim
*>
*> \param[in] DIAG
*> \verbatim
*>          DIAG is CHARACTER*1
*>           On entry, DIAG specifies whether or not A is unit triangular
*>           as follows:
*>
*>              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*>
*>              DIAG = 'N' or 'n'   A is not assumed to be unit
*>                                  triangular.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>           On entry, M specifies the number of rows of B. M must be at
*>           least zero.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the number of columns of B.  N must be
*>           at least zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is DOUBLE PRECISION.
*>           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
*>           zero then  A is not referenced and  B need not be set before
*>           entry.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension ( LDA, k ),
*>           where k is m when SIDE = 'L' or 'l'
*>             and k is n when SIDE = 'R' or 'r'.
*>           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
*>           upper triangular part of the array  A must contain the upper
*>           triangular matrix  and the strictly lower triangular part of
*>           A is not referenced.
*>           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
*>           lower triangular part of the array  A must contain the lower
*>           triangular matrix  and the strictly upper triangular part of
*>           A is not referenced.
*>           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
*>           A  are not referenced either,  but are assumed to be  unity.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*>           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
*>           then LDA must be at least max( 1, n ).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension ( LDB, N )
*>           Before entry,  the leading  m by n part of the array  B must
*>           contain  the  right-hand  side  matrix  B,  and  on exit  is
*>           overwritten by the solution matrix  X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>           On entry, LDB specifies the first dimension of B as declared
*>           in  the  calling  (sub)  program.   LDB  must  be  at  least
*>           max( 1, m ).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup double_blas_level3
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 3 Blas routine.
*>
*>
*>  -- Written on 8-February-1989.
*>     Jack Dongarra, Argonne National Laboratory.
*>     Iain Duff, AERE Harwell.
*>     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*>     Sven Hammarling, Numerical Algorithms Group Ltd.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
*
*  -- Reference BLAS level3 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA
      INTEGER LDA,LDB,M,N
      CHARACTER DIAG,SIDE,TRANSA,UPLO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),B(LDB,*)
*     ..
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,J,K,NROWA
      LOGICAL LSIDE,NOUNIT,UPPER
*     ..
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER (ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*
*     Test the input parameters.
*
      LSIDE = LSAME(SIDE,'L')
      IF (LSIDE) THEN
          NROWA = M
      ELSE
          NROWA = N
      END IF
      NOUNIT = LSAME(DIAG,'N')
      UPPER = LSAME(UPLO,'U')
*
      INFO = 0
      IF ((.NOT.LSIDE) .AND. (.NOT.LSAME(SIDE,'R'))) THEN
          INFO = 1
      ELSE IF ((.NOT.UPPER) .AND. (.NOT.LSAME(UPLO,'L'))) THEN
          INFO = 2
      ELSE IF ((.NOT.LSAME(TRANSA,'N')) .AND.
     +         (.NOT.LSAME(TRANSA,'T')) .AND.
     +         (.NOT.LSAME(TRANSA,'C'))) THEN
          INFO = 3
      ELSE IF ((.NOT.LSAME(DIAG,'U')) .AND. (.NOT.LSAME(DIAG,'N'))) THEN
          INFO = 4
      ELSE IF (M.LT.0) THEN
          INFO = 5
      ELSE IF (N.LT.0) THEN
          INFO = 6
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 9
      ELSE IF (LDB.LT.MAX(1,M)) THEN
          INFO = 11
      END IF
      IF (INFO.NE.0) THEN
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF (M.EQ.0 .OR. N.EQ.0) RETURN
*
*     And when  alpha.eq.zero.
*
      IF (ALPHA.EQ.ZERO) THEN
          DO 20 J = 1,N
              DO 10 I = 1,M
                  B(I,J) = ZERO
   10         CONTINUE
   20     CONTINUE
          RETURN
      END IF
*
*     Start the operations.
*
      IF (LSIDE) THEN
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*inv( A )*B.
*
              IF (UPPER) THEN
                  DO 60 J = 1,N
                      IF (ALPHA.NE.ONE) THEN
                          DO 30 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
   30                     CONTINUE
                      END IF
                      DO 50 K = M,1,-1
                          IF (B(K,J).NE.ZERO) THEN
                              IF (NOUNIT) B(K,J) = B(K,J)/A(K,K)
                              DO 40 I = 1,K - 1
                                  B(I,J) = B(I,J) - B(K,J)*A(I,K)
   40                         CONTINUE
                          END IF
   50                 CONTINUE
   60             CONTINUE
              ELSE
                  DO 100 J = 1,N
                      IF (ALPHA.NE.ONE) THEN
                          DO 70 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
   70                     CONTINUE
                      END IF
                      DO 90 K = 1,M
                          IF (B(K,J).NE.ZERO) THEN
                              IF (NOUNIT) B(K,J) = B(K,J)/A(K,K)
                              DO 80 I = K + 1,M
                                  B(I,J) = B(I,J) - B(K,J)*A(I,K)
   80                         CONTINUE
                          END IF
   90                 CONTINUE
  100             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*inv( A**T )*B.
*
              IF (UPPER) THEN
                  DO 130 J = 1,N
                      DO 120 I = 1,M
                          TEMP = ALPHA*B(I,J)
                          DO 110 K = 1,I - 1
                              TEMP = TEMP - A(K,I)*B(K,J)
  110                     CONTINUE
                          IF (NOUNIT) TEMP = TEMP/A(I,I)
                          B(I,J) = TEMP
  120                 CONTINUE
  130             CONTINUE
              ELSE
                  DO 160 J = 1,N
                      DO 150 I = M,1,-1
                          TEMP = ALPHA*B(I,J)
                          DO 140 K = I + 1,M
                              TEMP = TEMP - A(K,I)*B(K,J)
  140                     CONTINUE
                          IF (NOUNIT) TEMP = TEMP/A(I,I)
                          B(I,J) = TEMP
  150                 CONTINUE
  160             CONTINUE
              END IF
          END IF
      ELSE
          IF (LSAME(TRANSA,'N')) THEN
*
*           Form  B := alpha*B*inv( A ).
*
              IF (UPPER) THEN
                  DO 210 J = 1,N
                      IF (ALPHA.NE.ONE) THEN
                          DO 170 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
  170                     CONTINUE
                      END IF
                      DO 190 K = 1,J - 1
                          IF (A(K,J).NE.ZERO) THEN
                              DO 180 I = 1,M
                                  B(I,J) = B(I,J) - A(K,J)*B(I,K)
  180                         CONTINUE
                          END IF
  190                 CONTINUE
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(J,J)
                          DO 200 I = 1,M
                              B(I,J) = TEMP*B(I,J)
  200                     CONTINUE
                      END IF
  210             CONTINUE
              ELSE
                  DO 260 J = N,1,-1
                      IF (ALPHA.NE.ONE) THEN
                          DO 220 I = 1,M
                              B(I,J) = ALPHA*B(I,J)
  220                     CONTINUE
                      END IF
                      DO 240 K = J + 1,N
                          IF (A(K,J).NE.ZERO) THEN
                              DO 230 I = 1,M
                                  B(I,J) = B(I,J) - A(K,J)*B(I,K)
  230                         CONTINUE
                          END IF
  240                 CONTINUE
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(J,J)
                          DO 250 I = 1,M
                              B(I,J) = TEMP*B(I,J)
  250                     CONTINUE
                      END IF
  260             CONTINUE
              END IF
          ELSE
*
*           Form  B := alpha*B*inv( A**T ).
*
              IF (UPPER) THEN
                  DO 310 K = N,1,-1
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(K,K)
                          DO 270 I = 1,M
                              B(I,K) = TEMP*B(I,K)
  270                     CONTINUE
                      END IF
                      DO 290 J = 1,K - 1
                          IF (A(J,K).NE.ZERO) THEN
                              TEMP = A(J,K)
                              DO 280 I = 1,M
                                  B(I,J) = B(I,J) - TEMP*B(I,K)
  280                         CONTINUE
                          END IF
  290                 CONTINUE
                      IF (ALPHA.NE.ONE) THEN
                          DO 300 I = 1,M
                              B(I,K) = ALPHA*B(I,K)
  300                     CONTINUE
                      END IF
  310             CONTINUE
              ELSE
                  DO 360 K = 1,N
                      IF (NOUNIT) THEN
                          TEMP = ONE/A(K,K)
                          DO 320 I = 1,M
                              B(I,K) = TEMP*B(I,K)
  320                     CONTINUE
                      END IF
                      DO 340 J = K + 1,N
                          IF (A(J,K).NE.ZERO) THEN
                              TEMP = A(J,K)
                              DO 330 I = 1,M
                                  B(I,J) = B(I,J) - TEMP*B(I,K)
  330                         CONTINUE
                          END IF
  340                 CONTINUE
                      IF (ALPHA.NE.ONE) THEN
                          DO 350 I = 1,M
                              B(I,K) = ALPHA*B(I,K)
  350                     CONTINUE
                      END IF
  360             CONTINUE
              END IF
          END IF
      END IF
*
      RETURN
*
*     End of DTRSM .
*
      END

      integer function gfnarg (name, state)
      integer name (100)
      integer state (4)
      integer l
      integer getarg, getlin
      integer fd
      integer rfopen
      integer in1(12)
      integer in2(12)
      integer in3(12)
      data in1(1)/47/,in1(2)/100/,in1(3)/101/,in1(4)/118/,in1(5)/47/,in1
     *(6)/115/,in1(7)/116/,in1(8)/100/,in1(9)/105/,in1(10)/110/,in1(11)/
     *49/,in1(12)/-2/
      data in2(1)/47/,in2(2)/100/,in2(3)/101/,in2(4)/118/,in2(5)/47/,in2
     *(6)/115/,in2(7)/116/,in2(8)/100/,in2(9)/105/,in2(10)/110/,in2(11)/
     *50/,in2(12)/-2/
      data in3(1)/47/,in3(2)/100/,in3(3)/101/,in3(4)/118/,in3(5)/47/,in3
     *(6)/115/,in3(7)/116/,in3(8)/100/,in3(9)/105/,in3(10)/110/,in3(11)/
     *51/,in3(12)/-2/
23000 continue
      if (.not.(state (1) .eq. 1))goto 23003
      state (1) = 2
      state (2) = 1
      state (3) = -3
      state (4) = 0
      goto 23004
23003 continue
      if (.not.(state (1) .eq. 2))goto 23005
      if (.not.(getarg (state (2), name, 128) .ne. -1))goto 23007
      state (1) = 2
      state (2) = state (2) + 1
      if (.not.(name (1) .ne. 45))goto 23009
      state (4) = state (4) + 1
      gfnarg=(-2)
      return
23009 continue
      if (.not.(name (2) .eq. -2))goto 23011
      call scopy (in1, 1, name, 1)
      state (4) = state (4) + 1
      gfnarg=(-2)
      return
23011 continue
      if (.not.(name (2) .eq. 49 .and. name (3) .eq. -2))goto 23013
      call scopy (in1, 1, name, 1)
      state (4) = state (4) + 1
      gfnarg=(-2)
      return
23013 continue
      if (.not.(name (2) .eq. 50 .and. name (3) .eq. -2))goto 23015
      call scopy (in2, 1, name, 1)
      state (4) = state (4) + 1
      gfnarg=(-2)
      return
23015 continue
      if (.not.(name (2) .eq. 51 .and. name (3) .eq. -2))goto 23017
      call scopy (in3, 1, name, 1)
      state (4) = state (4) + 1
      gfnarg=(-2)
      return
23017 continue
      if (.not.(name (2) .eq. 110 .or. name (2) .eq. 78))goto 23019
      state (1) = 3
      if (.not.(name (3) .eq. -2))goto 23021
      state (3) = 0
      goto 23022
23021 continue
      if (.not.(name (3) .eq. 49 .and. name (4) .eq. -2))goto 23023
      state (3) = stdin1
      goto 23024
23023 continue
      if (.not.(name (3) .eq. 50 .and. name (4) .eq. -2))goto 23025
      state (3) = stdin2
      goto 23026
23025 continue
      if (.not.(name (3) .eq. 51 .and. name (4) .eq. -2))goto 23027
      state (3) = stdin3
      goto 23028
23027 continue
      state (3) = rfopen(name (3), 1)
      if (.not.(state (3) .eq. -3))goto 23029
      call putlin (name, 2)
      call remark (14H:  can't open.)
      state (1) = 2
23029 continue
23028 continue
23026 continue
23024 continue
23022 continue
      goto 23020
23019 continue
      gfnarg=(-3)
      return
23020 continue
23018 continue
23016 continue
23014 continue
23012 continue
23010 continue
      goto 23008
23007 continue
      state (1) = 4
23008 continue
      goto 23006
23005 continue
      if (.not.(state (1) .eq. 3))goto 23031
      l = getlin (name, state (3))
      if (.not.(l .ne. -1))goto 23033
      name (l) = -2
      state (4) = state (4) + 1
      gfnarg=(-2)
      return
23033 continue
      if (.not.(fd .ne. -3 .and. fd .ne. 0))goto 23035
      call rfclos(state (3))
23035 continue
      state (1) = 2
      goto 23032
23031 continue
      if (.not.(state (1) .eq. 4))goto 23037
      state (1) = 5
      if (.not.(state (4) .eq. 0))goto 23039
      call scopy (in1, 1, name, 1)
      gfnarg=(-2)
      return
23039 continue
      goto 23002
23037 continue
      if (.not.(state (1) .eq. 5))goto 23041
      goto 23002
23041 continue
      call error (32Hin gfnarg:  bad state (1) value.)
23042 continue
23038 continue
23032 continue
23006 continue
23004 continue
23001 goto 23000
23002 continue
      name (1) = -2
      gfnarg=(-1)
      return
      end

#-h-  lndict			  678  local   12/01/80  15:54:13
# lndict - output long-name dictionary as a debugging aid
   include  defs

subroutine lndict

character sym (MAXTOK), c
integer sctabl, length
pointer posn, locn
include COMMON_BLOCKS

   posn = 0
   while (sctabl (namtbl, sym, locn, posn) != EOF)
      if (length(sym) > MAXIDLENGTH) {
	  call outch (LETC)
	  call outtab
	  for (; mem (locn) != EOS; locn = locn + 1) {
	     c = mem (locn) # kluge for people with LOGICAL*1 characters
	     call outch (c)
	  }
	  call outch (BLANK)
	  call outch (BLANK)
	  call outstr (sym)
	  call outdon
      }
   return
end

*> \brief \b SLASWP performs a series of row interchanges on a general rectangular matrix.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download SLASWP + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/slaswp.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/slaswp.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/slaswp.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE SLASWP( N, A, LDA, K1, K2, IPIV, INCX )
*
*       .. Scalar Arguments ..
*       INTEGER            INCX, K1, K2, LDA, N
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       REAL               A( LDA, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SLASWP performs a series of row interchanges on the matrix A.
*> One row interchange is initiated for each of rows K1 through K2 of A.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the matrix of column dimension N to which the row
*>          interchanges will be applied.
*>          On exit, the permuted matrix.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.
*> \endverbatim
*>
*> \param[in] K1
*> \verbatim
*>          K1 is INTEGER
*>          The first element of IPIV for which a row interchange will
*>          be done.
*> \endverbatim
*>
*> \param[in] K2
*> \verbatim
*>          K2 is INTEGER
*>          (K2-K1+1) is the number of elements of IPIV for which a row
*>          interchange will be done.
*> \endverbatim
*>
*> \param[in] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (K1+(K2-K1)*abs(INCX))
*>          The vector of pivot indices. Only the elements in positions
*>          K1 through K1+(K2-K1)*abs(INCX) of IPIV are accessed.
*>          IPIV(K1+(K-K1)*abs(INCX)) = L implies rows K and L are to be
*>          interchanged.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>          The increment between successive values of IPIV. If INCX
*>          is negative, the pivots are applied in reverse order.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date June 2017
*
*> \ingroup realOTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Modified by
*>   R. C. Whaley, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE SLASWP( N, A, LDA, K1, K2, IPIV, INCX )
*
*  -- LAPACK auxiliary routine (version 3.7.1) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     June 2017
*
*     .. Scalar Arguments ..
      INTEGER            INCX, K1, K2, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * )
*     ..
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, I1, I2, INC, IP, IX, IX0, J, K, N32
      REAL               TEMP
*     ..
*     .. Executable Statements ..
*
*     Interchange row I with row IPIV(K1+(I-K1)*abs(INCX)) for each of rows
*     K1 through K2.
*
      IF( INCX.GT.0 ) THEN
         IX0 = K1
         I1 = K1
         I2 = K2
         INC = 1
      ELSE IF( INCX.LT.0 ) THEN
         IX0 = K1 + ( K1-K2 )*INCX
         I1 = K2
         I2 = K1
         INC = -1
      ELSE
         RETURN
      END IF
*
      N32 = ( N / 32 )*32
      IF( N32.NE.0 ) THEN
         DO 30 J = 1, N32, 32
            IX = IX0
            DO 20 I = I1, I2, INC
               IP = IPIV( IX )
               IF( IP.NE.I ) THEN
                  DO 10 K = J, J + 31
                     TEMP = A( I, K )
                     A( I, K ) = A( IP, K )
                     A( IP, K ) = TEMP
   10             CONTINUE
               END IF
               IX = IX + INCX
   20       CONTINUE
   30    CONTINUE
      END IF
      IF( N32.NE.N ) THEN
         N32 = N32 + 1
         IX = IX0
         DO 50 I = I1, I2, INC
            IP = IPIV( IX )
            IF( IP.NE.I ) THEN
               DO 40 K = N32, N
                  TEMP = A( I, K )
                  A( I, K ) = A( IP, K )
                  A( IP, K ) = TEMP
   40          CONTINUE
            END IF
            IX = IX + INCX
   50    CONTINUE
      END IF
*
      RETURN
*
*     End of SLASWP
*
      END

      subroutine frame
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      if (modef .eq. 1) go to 101
      mbpair = ior(ishift(226,8),0)
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      if ((mipair+5) .gt. 16) call flushb
      mbpair = ior(ishift(231,8),8)
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = mjxmin
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = mjymin
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = mjxmax
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = mjymax
      mfrend = 1
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      call flushb
      if (mbuflu .gt. 0) call preout
      mjxmin = 32767
      mjymin = 32767
      mjxmax = 0
      mjymax = 0
      mxold = -9999
      myold = -9999
      mop(1) = 0
      mop(2) = 204
      mop(5) = 0
      mop(3) = 0
      mop(4) = 128
      mop(7) = 8
      mop(6) = ior(1,ishift(32767,1))
      mop(8) = 0
      mop(9) = 0
      mop(10) = 0
      mfrend = 0
      return
c
  101 call uliber (0,45h0frame call illegal between flash1 and flash2,
     1             45)
      call perror
      return
      end

include defs

# ERRGO -- Ouput error checking code.

subroutine errgo

include COMMON_BLOCKS
string	serrchk "if (xerflg) "

	# In the processing of the last line, was an indentifier encountered
	# for which error checking is required (named in errchk declaration)?

	if (ername == YES) {
	    call outtab
	    if (esp > 0) {				# in iferr ... stmt?
		# Omit goto if goto statement label number is zero.  This
		# happens in "iferr (...)" statements.
		if (errstk(esp) > 0) {
		    call outstr (serrchk)
		    call ogotos (errstk(esp)+2, NO)	# "goto lab"
		}
	    } else {
		call outstr (serrchk)
		call ogotos (retlab, NO)
		call outdon
	    }
	    ername = NO
	}
end

      SUBROUTINE slDC2S (V, A, B)
*+
*     - - - - - -
*      D C 2 S
*     - - - - - -
*
*  Cartesian to spherical coordinates (double precision)
*
*  Given:
*     V     d(3)   x,y,z vector
*
*  Returned:
*     A,B   d      spherical coordinates in radians
*
*  The spherical coordinates are longitude (+ve anticlockwise looking
*  from the +ve latitude pole) and latitude.  The Cartesian coordinates
*  are right handed, with the x axis at zero longitude and latitude, and
*  the z axis at the +ve latitude pole.
*
*  If V is null, zero A and B are returned.  At either pole, zero A is
*  returned.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(3),A,B

      DOUBLE PRECISION X,Y,Z,R


      X = V(1)
      Y = V(2)
      Z = V(3)
      R = SQRT(X*X+Y*Y)

      IF (R.EQ.0D0) THEN
         A = 0D0
      ELSE
         A = ATAN2(Y,X)
      END IF

      IF (Z.EQ.0D0) THEN
         B = 0D0
      ELSE
         B = ATAN2(Z,R)
      END IF

      END

      SUBROUTINE SINT1(N,WAR,WAS,XH,X,IFAC)
      DIMENSION WAR(*),WAS(*),X(*),XH(*),IFAC(*)
      DATA SQRT3 /1.73205080756888/
      DO 100 I=1,N
      XH(I) = WAR(I)
      WAR(I) = X(I)
  100 CONTINUE
      IF (N.lt.2) GO TO 101
      IF (N.eq.2) GO TO 102
      GO TO 103
  101 XH(1) = XH(1)+XH(1)
      GO TO 106
  102 XHOLD = SQRT3*(XH(1)+XH(2))
      XH(2) = SQRT3*(XH(1)-XH(2))
      XH(1) = XHOLD
      GO TO 106
  103 NP1 = N+1
      NS2 = N/2
      X(1) = 0.
      DO 104 K=1,NS2
         KC = NP1-K
         T1 = XH(K)-XH(KC)
         T2 = WAS(K)*(XH(K)+XH(KC))
         X(K+1) = T1+T2
         X(KC+1) = T2-T1
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN .NE. 0) X(NS2+2) = 4.*XH(NS2+1)
      CALL RFFTF1 (NP1,X,XH,WAR,IFAC)
      XH(1) = .5*X(1)
      DO 105 I=3,N,2
         XH(I-1) = -X(I)
         XH(I) = XH(I-2)+X(I-1)
  105 CONTINUE
      IF (MODN .NE. 0) GO TO 106
      XH(N) = -X(N+1)
  106 DO 107 I=1,N
      X(I) = WAR(I)
      WAR(I) = XH(I)
  107 CONTINUE
      RETURN
      END

*> \brief \b ISAMAX
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*       INTEGER FUNCTION ISAMAX(N,SX,INCX)
*
*       .. Scalar Arguments ..
*       INTEGER INCX,N
*       ..
*       .. Array Arguments ..
*       REAL SX(*)
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    ISAMAX finds the index of the first element having maximum absolute value.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>         number of elements in input vector(s)
*> \endverbatim
*>
*> \param[in] SX
*> \verbatim
*>          SX is REAL array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>         storage spacing between elements of SX
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup aux_blas
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>     jack dongarra, linpack, 3/11/78.
*>     modified 3/93 to return if incx .le. 0.
*>     modified 12/3/93, array(1) declarations changed to array(*)
*> \endverbatim
*>
*  =====================================================================
      INTEGER FUNCTION ISAMAX(N,SX,INCX)
*
*  -- Reference BLAS level1 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      REAL SX(*)
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL SMAX
      INTEGER I,IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC ABS
*     ..
      ISAMAX = 0
      IF (N.LT.1 .OR. INCX.LE.0) RETURN
      ISAMAX = 1
      IF (N.EQ.1) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
         SMAX = ABS(SX(1))
         DO I = 2,N
            IF (ABS(SX(I)).GT.SMAX) THEN
               ISAMAX = I
               SMAX = ABS(SX(I))
            END IF
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         IX = 1
         SMAX = ABS(SX(1))
         IX = IX + INCX
         DO I = 2,N
            IF (ABS(SX(IX)).GT.SMAX) THEN
               ISAMAX = I
               SMAX = ABS(SX(IX))
            END IF
            IX = IX + INCX
         END DO
      END IF
      RETURN
      END

include  defs

# OGOTOS - Output "goto	n", unconditionally.


subroutine ogotos (n, error_check)

integer n, error_check
include COMMON_BLOCKS
string sgoto "goto "

	call outtab
	call outstr (sgoto)
	call outnum (n)
	if (error_check == YES)
	    call outdwe
	else
	    call outdon
end

      subroutine pixels(x0,y0,ni,nj,inten)
      integer*2 inten(1)
c	assume inten is a linear array rather than 2-d.  This is a change
c	from the original code.
c	assume nj == 1
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      data ipixop / 10/
      mbpair = ior(ishift(ior(192, ipixop + 1), 8), 8)
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      xx = x0
      yy = y0
      call tran16
      mbpair = mx
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair=my
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair=ni
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair=nj
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      nni = max0(1,(ni+iand(ni,1)))
      nnj = max0(1,nj)
      kmax=nni*nnj
      k=0
      do 200 j=1,nnj
      do 100 i=1,nni
      if(mod(k,254).ne.0) goto 90
      mbpair = ior(ishift(ior(192, ipixop+2),8), min0(254,kmax-k))
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = 0
   90 ik = iand ( i, 1)
c
c 14Nov85 mod so that arguments to ishift are of same type
      itmp = inten(i)
      mbpair = ior (ishift(iand(itmp,255),8*ik),mbpair)
c     mbpair = ior (ishift(iand(inten(i),255),8*ik),mbpair)
c
      if ( ik .ne. 0 ) go to 95
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = 0
   95 k = k + 1
  100 continue
  200 continue
      return
      end

include	defs

# omatch --- try to match a single pattern at pat (j)

   integer function omatch (lin, i, pat, j)
   character lin (MAXLINE), pat (MAXPAT)
   integer i, j

   integer bump
   integer locate

   omatch = NO
   if (lin (i) == EOS)
      return
   bump = -1
   if (pat (j) == CHAR) {
      if (lin (i) == pat (j + 1))
	 bump = 1
      }
   else if (pat (j) == BOL) {
      if (i == 1)
	 bump = 0
      }
   else if (pat (j) == ANY) {
      if (lin (i) != NEWLINE)
	 bump = 1
      }
   else if (pat (j) == EOL) {
      if (lin (i) == NEWLINE)
	 bump = 0
      }
   else if (pat (j) == CCL) {
      if (locate (lin (i), pat, j + 1) == YES)
	 bump = 1
      }
   else if (pat (j) == NCCL) {
      if (lin (i) != NEWLINE & locate (lin (i), pat, j + 1) == NO)
	 bump = 1
      }
   else
      call error ("in omatch: can't happen.")
   if (bump >= 0) {
      i = i + bump
      omatch = YES
      }

   return
   end

include	defs

# locate --- look for c in char class at pat (offset)

   integer function locate (c, pat, offset)
   character c, pat (MAXPAT)
   integer offset

   integer i

   # size of class is at pat (offset), characters follow
   for (i = offset + pat (offset); i > offset; i = i - 1)
      if (c == pat (i))
	 return (YES)

   return (NO)
   end

      SUBROUTINE STRMLN (U,V,WORK,IMAX,IPTSX,JPTSY,NSET,IER)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C SUBROUTINE STRMLN (U,V,WORK,IMAX,IPTSX,JPTSY,NSET,IER)
C
C DIMENSION OF           U(IMAX,JPTSY) , V(IMAX,JPTSY) ,
C ARGUMENTS              WORK(2*IMAX*JPTSY)
C
C LATEST REVISION        JUNE 1984
C
C PURPOSE                STRMLN DRAWS A STREAMLINE REPRESENTATION OF
C                        THE FLOW FIELD. THE REPRESENTATION IS
C                        INDEPENDENT OF THE FLOW SPEED.
C
C USAGE                  IF THE FOLLOWING ASSUMPTIONS ARE MET, USE
C
C                            CALL EZSTRM  (U,V,WORK,IMAX,JMAX)
C
C                          ASSUMPTIONS:
C                            --THE WHOLE ARRAY IS TO BE PROCESSED.
C                            --THE ARRAYS ARE DIMENSIONED
C                              U(IMAX,JMAX) , V(IMAX,JMAX) AND
C                              WORK(2*IMAX*JMAX).
C                            --WINDOW AND VIEWPORT ARE TO BE CHOSEN
C                              BY STRMLN.
C                            --PERIM IS TO BE CALLED.
C
C                        IF THESE ASSUMPTIONS ARE NOT MET, USE
C
C                            CALL STRMLN (U,V,WORK,IMAX,IPTSX,JPTSY,
C                                         NSET,IER)
C
C                        THE USER MUST CALL FRAME IN THE CALLING
C                        ROUTINE.
C
C                        THE USER MAY CHANGE VARIOUS INTERNAL
C                        PARAMETERS VIA COMMON BLOCKS. SEE BELOW.
C
C ARGUMENTS
C
C ON INPUT               U, V
C                          TWO DIMENSIONAL ARRAYS CONTAINING THE
C                          VELOCITY FIELDS TO BE PLOTTED.
C                          (NOTE:  IF THE U AND V COMPONENTS
C                          ARE, FOR EXAMPLE, DEFINED IN CARTESIAN
C                          COORDINATES AND THE USER WISHES TO PLOT THEM
C                          ON A DIFFERENT PROJECTION (I.E., STEREO-
C                          GRAPHIC), THEN THE APPROPRIATE
C                          TRANSFORMATION MUST BE MADE TO THE U AND V
C                          COMPONENTS VIA THE FUNCTIONS FU AND FV
C                          (LOCATED IN DRWSTR).
C
C                        WORK
C                          USER PROVIDED WORK ARRAY.  THE DIMENSION
C                          OF THIS ARRAY MUST BE .GE. 2*IMAX*JPTSY.
C                          CAUTION:  THIS ROUTINE DOES NOT CHECK THE
C                          SIZE OF THE WORK ARRAY.
C
C                        IMAX
C                          THE FIRST DIMENSION OF U AND V IN THE
C                          CALLING PROGRAM. (X-DIRECTION)
C
C                        IPTSX
C                          THE NUMBER OF POINTS TO BE PLOTTED IN THE
C                          FIRST SUBSCRIPT DIRECTION.  (X-DIRECTION)
C
C                        JPTSY
C                          THE NUMBER OF POINTS TO BE PLOTTED IN THE
C                          SECOND SUBSCRIPT DIRECTION. (Y-DIRECTION)
C
C                        NSET
C                          FLAG TO CONTROL SCALING
C                          > 0  STRMLN ASSUMES THAT THE WINDOW
C                               AND VIEWPORT HAVE BEEN SET BY THE
C                               USER IN SUCH A WAY AS TO PROPERLY
C                               SCALE THE PLOTTING INSTRUCTIONS
C                               GENERATED BY STRMLN. PERIM IS NOT
C                               CALLED.
C                          = 0  STRMLN WILL ESTABLISH THE WINDOW AND
C                               VIEWPORT TO PROPERLY SCALE THE
C                               PLOTTING INSTRUCTIONS TO THE STANDARD
C                               CONFIGURATION. PERIM IS CALLED TO DRAW
C                               THE BORDER.
C                          < 0  STRMLN ESTABLISHES THE WINDOW
C                               AND VIEWPORT SO AS TO PLACE THE
C                               STREAMLINES WITHIN THE LIMITS
C                               OF THE USER'S WINDOW.  PERIM IS
C                               NOT CALLED.
C
C ON OUTPUT              ONLY THE IER ARGUMENT MAY BE CHANGED. ALL
C                        OTHER ARGUMENTS ARE UNCHANGED.
C
C
C                        IER
C                          =  0 WHEN NO ERRORS ARE DETECTED
C                          = -1 WHEN THE ROUTINE IS CALLED WITH ICYC
C                               .NE. 0  AND THE DATA ARE NOT CYCLIC
C                               (ICYC IS AN INTERNAL PARAMETER
C                               DESCRIBED BELOW); IN THIS CASE THE
C                               ROUTINE WILL DRAW THE
C                               STREAMLINES WITH THE NON-CYCLIC
C                               INTERPOLATION FORMULAS.
C
C ENTRY POINTS           STRMLN, DRWSTR, EZSTRM, GNEWPT, CHKCYC
C
C COMMON BLOCKS          STR01, STR02, STR03, STR04
C
C REQUIRED LIBRARY       GRIDAL, GBYTES, AND THE SPPS
C ROUTINES
C
C HISTORY                WRITTEN AND STANDARDIZED IN NOVEMBER 1973.
C I/O                    DRAWS STREAMLINES
C
C PRECISION              SINGLE
C
C LANGUAGE               FORTRAN
C
C HISTORY                WRITTEN IN 1979.
C                        CONVERTED TO FORTRAN 77 AND GKS IN JUNE 1984.
C
C PORTABILITY            FORTRAN 77
C
C ALGORITHM              WIND COMPONENTS ARE NORMALIZED TO THE VALUE
C                        OF DISPL. THE LEAST SIGNIFICANT TWO
C                        BITS OF THE WORK ARRAY ARE
C                        UTILIZED AS FLAGS FOR EACH GRID BOX. FLAG 1
C                        INDICATES WHETHER ANY STREAMLINE HAS
C                        PREVIOUSLY PASSED THROUGH THIS BOX.  FLAG 2
C                        INDICATES WHETHER A DIRECTIONAL ARROW HAS
C                        ALREADY APPEARED IN A BOX. JUDICIOUS USE
C                        OF THESE FLAGS PREVENTS OVERCROWDING OF
C                        STREAMLINES AND DIRECTIONAL ARROWS.
C                        EXPERIENCE INDICATES THAT A FINAL PLEASING
C                        PICTURE IS PRODUCED WHEN STREAMLINES ARE
C                        INITIATED IN THE CENTER OF A GRID BOX. THE
C                        STREAMLINES ARE DRAWN IN ONE DIRECTION THEN
C                        IN THE OPPOSITE DIRECTION.
C
C REFERENCE              THE TECHNIQUES UTILIZED HERE ARE DESCRIBED
C                        IN AN ARTICLE BY THOMAS WHITTAKER (U. OF
C                        WISCONSIN) WHICH APPEARED IN THE NOTES AND
C                        CORRESPONDENCE SECTION OF MONTHLY WEATHER
C                        REVIEW, JUNE 1977.
C
C TIMING                 HIGHLY VARIABLE
C                          IT DEPENDS ON THE COMPLEXITY OF THE
C                          FLOW FIELD AND THE PARAMETERS:  DISPL,
C                          DISPC , CSTOP , INITA , INITB , ITERC ,
C                          AND IGFLG. (SEE BELOW FOR A DISCUSSION
C                          OF THESE PARAMETERS.) IF ALL VALUES
C                          ARE DEFAULT, THEN A SIMPLE LINEAR
C                          FLOW FIELD FOR A 40 X 40 GRID WILL
C                          TAKE ABOUT 0.4 SECONDS ON THE CRAY1-A;
C                          A FAIRLY COMPLEX FLOW FIELD WILL TAKE ABOUT
C                          1.5 SECONDS ON THE CRAY1-A.
C
C
C INTERNAL PARAMETERS
C
C                        NAME     DEFAULT            FUNCTION
C                        ----     -------            --------
C
C                        EXT       0.25      LENGTHS OF THE SIDES OF THE
C                                            PLOT ARE PROPORTIONAL TO
C                                            IPTSX AND JPTSY EXCEPT IN
C                                            THE CASE WHEN MIN(IPTSX,JPT
C                                            / MAX(IPTSX,JPTSY) .LT. EXT;
C                                            IN THAT CASE A SQUARE
C                                            GRAPH IS PLOTTED.
C
C                        SIDE      0.90      LENGTH OF LONGER EDGE OF
C                                            PLOT. (SEE ALSO EXT.)
C
C                        XLT       0.05      LEFT HAND EDGE OF THE PLOT.
C                                            (0.0 = LEFT EDGE OF FRAME)
C                                            (1.0 = RIGHT EDGE OF FRAME)
C
C                        YBT       0.05      BOTTOM EDGE OF THE PLOT.
C                                            (0.0 = BOTTOM ; 1.0 = TOP)
C
C                                            (YBT+SIDE AND XLT+SIDE MUST
C                                            BE .LE. 1. )
C
C                        INITA     2         USED TO PRECONDITION GRID
C                                            BOXES TO BE ELIGIBLE TO
C                                            START A STREAMLINE.
C                                            FOR EXAMPLE, A VALUE OF 4
C                                            MEANS THAT EVERY FOURTH
C                                            GRID BOX IS ELIGIBLE ; A
C                                            VALUE OF 2 MEANS THAT EVERY
C                                            OTHER GRID BOX IS ELIGIBLE.
C                                            (SEE INITB)
C
C                        INITB     2         USED TO PRECONDITION GRID
C                                            BOXES TO BE ELIGIBLE FOR
C                                            DIRECTION ARROWS.
C                                            IF THE USER CHANGES THE
C                                            DEFAULT VALUES OF INITA
C                                            AND/OR INITB, IT SHOULD
C                                            BE DONE SUCH THAT
C                                            MOD(INITA,INITB) = 0 .
C                                            FOR A DENSE GRID TRY
C                                            INITA=4 AND INITB=2 TO
C                                            REDUCE THE CPU TIME.
C
C                        AROWL     0.33      LENGTH OF DIRECTION ARROW.
C                                            FOR EXAMPLE, 0.33 MEANS
C                                            EACH DIRECTIONAL ARROW WILL
C                                            TAKE UP A THIRD OF A GRID
C                                            BOX.
C
C                        ITERP     35        EVERY 'ITERP' ITERATIONS
C                                            THE STREAMLINE PROGRESS
C                                            IS CHECKED.
C
C                        ITERC     -99       THE DEFAULT VALUE OF THIS
C                                            PARAMETER IS SUCH THAT
C                                            IT HAS NO EFFECT ON THE
C                                            CODE. WHEN SET TO SOME
C                                            POSITIVE VALUE, THE PROGRAM
C                                            WILL CHECK FOR STREAMLINE
C                                            CROSSOVER EVERY 'ITERC'
C                                            ITERATIONS. (THE ROUTINE
C                                            CURRENTLY DOES THIS EVERY
C                                            TIME IT ENTERS A NEW GRID
C                                            BOX.) CAUTION:  WHEN
C                                            THIS PARAMETER IS ACTIVATED
C                                            CPU TIME WILL INCREASE.
C
C                        IGFLG     0         A VALUE OF ZERO MEANS THAT
C                                            THE SIXTEEN POINT BESSEL
C                                            INTERPOLATION FORMULA WILL
C                                            BE UTILIZED WHERE POSSIBLE;
C                                            WHEN NEAR THE GRID EDGES,
C                                            QUADRATIC AND BI-LINEAR
C                                            INTERPOLATION  WILL BE
C                                            USED. THIS MIXING OF
C                                            INTERPOLATION SCHEMES CAN
C                                            SOMETIMES CAUSE SLIGHT
C                                            RAGGEDNESS NEAR THE EDGES
C                                            OF THE PLOT.  IF IGFLG.NE.0,
C                                            THEN ONLY THE BILINEAR
C                                            INTERPOLATION FORMULA
C                                            IS USED; THIS WILL GENERALLY
C                                            RESULT IN SLIGHTLY FASTER
C                                            PLOT TIMES BUT A LESS
C                                            PLEASING PLOT.
C
C                        IMSG      0         IF ZERO, THEN NO MISSING
C                                            U AND V COMPONENTS ARE
C                                            PRESENT.
C                                            IF .NE. 0, STRMLN WILL
C                                            UTILIZE THE
C                                            BI-LINEAR INTERPOLATION
C                                            SCHEME AND TERMINATE IF
C                                            ANY DATA POINTS ARE MISSING.
C
C                        UVMSG     1.E+36    VALUE ASSIGNED TO A MISSING
C                                            POINT.
C
C                        ICYC      0         ZERO MEANS THE DATA ARE
C                                            NON-CYCLIC IN THE X
C                                            DIRECTION.
C                                            IF .NE 0, THE
C                                            CYCLIC INTERPOLATION
C                                            FORMULAS WILL BE USED.
C                                            (NOTE:  EVEN IF THE DATA
C                                            ARE CYCLIC IN X LEAVING
C                                            ICYC = 0 WILL DO NO HARM.)
C
C                        DISPL     0.33      THE WIND SPEED IS
C                                            NORMALIZED TO THIS VALUE.
C                                            (SEE THE DISCUSSION BELOW.)
C
C                        DISPC     0.67      THE CRITICAL DISPLACEMENT.
C                                            IF AFTER 'ITERP' ITERATIONS
C                                            THE STREAMLINE HAS NOT
C                                            MOVED THIS DISTANCE, THE
C                                            STREAMLINE WILL BE
C                                            TERMINATED.
C
C                        CSTOP     0.50      THIS PARAMETER CONTROLS
C                                            THE SPACING BETWEEN
C                                            STREAMLINES.  THE CHECKING
C                                            IS DONE WHEN A NEW GRID
C                                            BOX IS ENTERED.
C
C DISCUSSION OF          ASSUME A VALUE OF 0.33 FOR DISPL.  THIS
C DISPL,DISPC            MEANS THAT IT WILL TAKE THREE STEPS TO MOVE
C AND CSTOP              ACROSS ONE GRID BOX IF THE FLOW WAS ALL IN THE
C                        X DIRECTION. IF THE FLOW IS ZONAL, THEN A
C                        LARGER VALUE OF DISPL IS IN ORDER.
C                        IF THE FLOW IS HIGHLY TURBULENT, THEN
C                        A SMALLER VALUE IS IN ORDER. NOTE: THE SMALLER
C                        DISPL, THE MORE THE CPU TIME.  A VALUE
C                        OF 2 TO 4 TIMES DISPL IS A REASONABLE VALUE
C                        FOR DISPC.  DISPC SHOULD ALWAYS BE GREATER
C                        THAN DISPL. A VALUE OF 0.33 FOR CSTOP WOULD
C                        MEAN THAT A MAXIMUM OF THREE STREAM-
C                        LINES WILL BE DRAWN PER GRID BOX. THIS MAX
C                        WILL NORMALLY ONLY OCCUR IN AREAS OF SINGULAR
C                        POINTS.
C
C                                            ***************************
C                                            ANY OR ALL OF THE ABOVE
C                                            PARAMETERS MAY BE CHANGED
C                                            BY UTILIZING COMMON BLOCKS
C                                            STR02 AND/OR STR03
C                                            ***************************
C
C                        UXSML     1.E-50    THE SMALLEST REAL NUMBER
C                                            ON THE HOST COMPUTER.  THIS
C                                            IS SET AUTOMATICALLY BY
C                                            R1MACH.
C
C                        NCHK      750       THIS PARAMETER IS LOCATED
C                                            IN DRWSTR. IT SPECIFIES THE
C                                            LENGTH OF THE CIRCULAR
C                                            LISTS  USED FOR CHECKING
C                                            FOR STRMLN CROSSOVERS.
C                                            FOR MOST PLOTS THIS NUMBER
C                                            MAY BE REDUCED TO 500
C                                            OR LESS AND THE PLOTS WILL
C                                            NOT BE ALTERED.
C
C                        ISKIP               NUMBER OF BITS TO BE
C                                            SKIPPED TO GET TO THE
C                                            LEAST TWO SIGNIFICANT BITS
C                                            IN A FLOATING POINT NUMBER.
C                                            THE DEFAULT VALUE IS SET TO
C                                            I1MACH(5) - 2 . THIS VALUE
C                                            MAY HAVE TO BE CHANGED
C                                            DEPENDING ON THE TARGET
C                                            COMPUTER, SEE SUBROUTINE
C                                            DRWSTR.
C
C
C
      DIMENSION       U(IMAX,JPTSY)         ,V(IMAX,JPTSY)           ,
     1                WORK(1)
      DIMENSION       WNDW(4)               ,VWPRT(4)
C
      COMMON /STR01/  IS         ,IEND      ,JS        ,JEND
     1             ,  IEND1      ,JEND1     ,I         ,J
     2             ,  X          ,Y         ,DELX      ,DELY
     3             ,  ICYC1      ,IMSG1     ,IGFL1
      COMMON /STR02/  EXT , SIDE , XLT , YBT
      COMMON /STR03/  INITA , INITB , AROWL , ITERP , ITERC , IGFLG
     1             ,  IMSG , UVMSG , ICYC , DISPL , DISPC , CSTOP
C
      SAVE
C
      EXT       = 0.25
      SIDE      = 0.90
      XLT       = 0.05
      YBT       = 0.05
C
      INITA     = 2
      INITB     = 2
      AROWL     = 0.33
      ITERP     = 35
      ITERC     = -99
      IGFLG     = 0
      ICYC      = 0
      IMSG      = 0
C +NOAO
C     UVMSG     = 1.E+36
      uvmsg     = 1.E+16
C -NOAO
      DISPL     = 0.33
      DISPC     = 0.67
      CSTOP     = 0.50
C
C THE FOLLOWING CALL IS FOR MONITORING LIBRARY USE AT NCAR
C
      CALL Q8QST4 ( 'GRAPHX', 'STRMLN', 'STRMLN', 'VERSION 01')
C
      IER = 0
C
C LOAD THE COMMUNICATION COMMON BLOCK WITH PARAMETERS
C
      IS = 1
      IEND = IPTSX
      JS = 1
      JEND = JPTSY
      IEND1 = IEND-1
      JEND1 = JEND-1
      IEND2 = IEND-2
      JEND2 = JEND-2
      XNX = FLOAT(IEND-IS+1)
      XNY = FLOAT(JEND-JS+1)
      ICYC1 = ICYC
      IGFL1 = IGFLG
      IMSG1 = 0
C
C IF ICYC .NE. 0 THEN CHECK TO MAKE SURE THE CYCLIC CONDITION EXISTS.
C
      IF (ICYC1.NE.0) CALL CHKCYC  (U,V,IMAX,JPTSY,IER)
C
C SAVE ORIGINAL  NORMALIZATION TRANSFORMATION NUMBER
C
      CALL GQCNTN ( IERR,NTORIG )
C
C SET UP SCALING
C
      IF (NSET) 10 , 20 , 60
   10 CALL GETUSV ( 'LS' , ITYPE )
      CALL GQNT ( NTORIG,IERR,WNDW,VWPRT )
      CALL GETUSV('LS',IOLLS)
      X1 = VWPRT(1)
      X2 = VWPRT(2)
      Y1 = VWPRT(3)
      Y2 = VWPRT(4)
      X3 = IS
      X4 = IEND
      Y3 = JS
      Y4 = JEND
      GO TO  55
C
   20 ITYPE = 1
      X1 = XLT
      X2 = (XLT+SIDE)
      Y1 = YBT
      Y2 = (YBT+SIDE)
      X3 = IS
      X4 = IEND
      Y3 = JS
      Y4 = JEND
      IF (AMIN1(XNX,XNY)/AMAX1(XNX,XNY).LT.EXT) GO TO  50
      IF (XNX-XNY)  30, 50, 40
   30 X2 = (SIDE*(XNX/XNY) + XLT)
      GO TO  50
   40 Y2 = (SIDE*(XNY/XNX) + YBT)
   50 CONTINUE
C
C CENTER THE PLOT
C
      DX = 0.25*( 1. - (X2-X1) )
      DY = 0.25*( 1. - (Y2-Y1) )
      X1 = (XLT+DX)
      X2 = (X2+DX )
      Y1 = (YBT+DY)
      Y2 = (Y2+DY )
C
   55 CONTINUE
C
C SAVE NORMALIZATION TRANSFORMATION 1
C
      CALL GQNT ( 1,IERR,WNDW,VWPRT )
C
C DEFINE AND SELECT NORMALIZATION TRANS, SET LOG SCALING
C
      CALL SET(X1,X2,Y1,Y2,X3,X4,Y3,Y4,ITYPE)
C
      IF (NSET.EQ.0) CALL PERIM (1,0,1,0)
C
   60 CONTINUE
C
C DRAW THE STREAMLINES
C .   BREAK THE WORK ARRAY INTO TWO PARTS.  SEE DRWSTR FOR FURTHER
C .   COMMENTS ON THIS.
C
      CALL DRWSTR (U,V,WORK(1),WORK(IMAX*JPTSY+1),IMAX,JPTSY)
C
C RESET NORMALIATION TRANSFORMATION 1 TO ORIGINAL VALUES
C
      IF (NSET .LE. 0) THEN
        CALL SET(VWPRT(1),VWPRT(2),VWPRT(3),VWPRT(4),
     -           WNDW(1),WNDW(2),WNDW(3),WNDW(4),IOLLS)
      ENDIF
      CALL GSELNT (NTORIG)
C
      RETURN
      END
      SUBROUTINE DRWSTR  (U,V,UX,VY,IMAX,JPTSY)
C
      PARAMETER (NCHK=750)
C
C THIS ROUTINE DRAWS THE STREAMLINES.
C .   THE XCHK AND YCHK ARRAYS SERVE AS A CIRCULAR LIST. THEY
C .   ARE USED TO PREVENT LINES FROM CROSSING ONE ANOTHER.
C
C THE WORK ARRAY HAS BEEN BROKEN UP INTO TWO ARRAYS FOR CLARITY.  THE
C .   TOP HALF OF WORK (CALLED UX) WILL HAVE THE NORMALIZED (AND
C .   POSSIBLY TRANSFORMED) U COMPONENTS AND WILL BE USED FOR BOOK
C .   KEEPING.  THE LOWER HALF OF THE WORK ARRAY (CALLED VY) WILL
C .   CONTAIN THE NORMALIZED (AND POSSIBLY TRANSFORMED) V COMPONENTS.
C
      DIMENSION       U(IMAX,JPTSY)         ,V(IMAX,JPTSY)
     1             ,  UX(IMAX,JPTSY)        ,VY(IMAX,JPTSY)
      COMMON /STR01/  IS         ,IEND      ,JS        ,JEND
     1             ,  IEND1      ,JEND1     ,I         ,J
     2             ,  X          ,Y         ,DELX      ,DELY
     3             ,  ICYC1      ,IMSG1     ,IGFL1
      COMMON /STR03/  INITA , INITB , AROWL , ITERP , ITERC , IGFLG
     1             ,  IMSG , UVMSG , ICYC , DISPL , DISPC , CSTOP
      COMMON /STR04/  XCHK(NCHK) ,YCHK(NCHK) , NUMCHK , UXSML
C
C
        SAVE
C
C STATEMENT FUNCTIONS FOR SPATIAL AND VELOCITY TRANSFORMATIONS.
C .   (IF THE USER WISHES OTHER TRANSFORMATIONS  REPLACE THESE STATEMENT
C .   FUNCTIONS WITH THE APPROPRIATE NEW ONES, OR , IF THE TRANSFORMA-
C .   TIONS ARE COMPLICATED DELETE THESE STATEMENT FUNCTIONS
C .   AND ADD EXTERNAL ROUTINES WITH THE SAME NAMES TO DO THE TRANS-
C .   FORMING.)
C
      FX(X,Y) = X
      FY(X,Y) = Y
      FU(X,Y) = X
      FV(X,Y) = Y
C
C INITIALIZE
C
      ISKIP    = I1MACH(5) - 2
      ISKIP1   = ISKIP + 1
      UXSML    = R1MACH(1)
C
C
      NUMCHK   = NCHK
      LCHK = 1
      ICHK = 1
      XCHK(1) = 0.
      YCHK(1) = 0.
      KFLAG = 0
      IZERO = 0
      IONE = 1
      ITWO = 2
C
C
C COMPUTE THE X AND Y NORMALIZED (AND POSSIBLY TRANSFORMED)
C .   DISPLACEMENT COMPONENTS (UX AND VY).
C
      DO  40 J=JS,JEND
      DO  30 I=IS,IEND
      IF (U(I,J).EQ.0. .AND. V(I,J).EQ.0.) GO TO  10
      UX(I,J) = FU(U(I,J),V(I,J))
      VY(I,J) = FV(U(I,J),V(I,J))
      CON = DISPL/SQRT(UX(I,J)*UX(I,J) + VY(I,J)*VY(I,J))
      UX(I,J) = CON*UX(I,J)
      VY(I,J) = CON*VY(I,J)
C
      IF(UX(I,J) .EQ. 0.) UX(I,J) = CON*FU(UXSML,V(I,J))
C
      GO TO  20
   10 CONTINUE
C
C BOOKKEEPING IS DONE IN THE LEAST SIGNIFICANT BITS OF THE UX ARRAY.
C .   WHEN UX(I,J) IS EXACTLY ZERO THIS CAN PRESENT SOME PROBLEMS.
C .   TO GET AROUND THIS PROBLEM SET IT TO SOME VERY SMALL NUMBER.
C
      UX(I,J) = FU(UXSML,0.)
      VY(I,J) = 0.
C
C MASK OUT THE LEAST SIGNIFICANT TWO BITS AS FLAGS FOR EACH GRID BOX
C .   A GRID BOX IS ANY REGION SURROUNDED BY FOUR GRID POINTS.
C .   FLAG 1 INDICATES WHETHER ANY STREAMLINE HAS PREVIOUSLY PASSED
C .          THROUGH THIS BOX.
C .   FLAG 2 INDICATES WHETHER ANY DIRECTIONAL ARROW HAS ALREADY
C .          APPEARED IN THIS BOX.
C .   JUDICIOUS USE OF THESE FLAGS PREVENTS OVERCROWDING OF
C .   STREAMLINES AND DIRECTIONAL ARROWS.
C
   20 CALL SBYTES( UX(I,J) , IZERO , ISKIP , 2 , 0 , 1 )
C
      IF (MOD(I,INITA).NE.0 .OR. MOD(J,INITA).NE.0)
     1    CALL SBYTES( UX(I,J) , IONE , ISKIP1, 1 , 0 , 1 )
      IF (MOD(I,INITB).NE.0 .OR. MOD(J,INITB).NE.0)
     1    CALL SBYTES( UX(I,J) , IONE , ISKIP , 1 , 0 , 1 )
C
   30 CONTINUE
   40 CONTINUE
C
   50 CONTINUE
C
C START A STREAMLINE. EXPERIENCE HAS SHOWN THAT A PLEASING PICTURE
C .   WILL BE PRODUCED IF NEW STREAMLINES ARE STARTED ONLY IN GRID
C .   BOXES THAT PREVIOUSLY HAVE NOT HAD OTHER STREAMLINES PASS THROUGH
C .   THEM. AS LONG AS A REASONABLY DENSE PATTERN OF AVAILABLE BOXES
C .   IS INITIALLY PRESCRIBED, THE ORDER OF SCANNING THE GRID PTS. FOR
C .   AVAILABLE BOXES IS IMMATERIAL
C
C FIND AN AVAILABLE BOX FOR STARTING A STREAMLINE
C
      IF (KFLAG.NE.0) GO TO  90
      DO  70 J=JS,JEND1
      DO  60 I=IS,IEND1
      CALL GBYTES( UX(I,J) , IUX , ISKIP , 2 , 0 , 1 )
      IF ( IAND( IUX , IONE ) .EQ. IZERO ) GO TO 80
   60 CONTINUE
   70 CONTINUE
C
C MUST BE NO AVAILABLE BOXES FOR STARTING A STREAMLINE
C
      GO TO 190
   80 CONTINUE
C
C INITILIZE PARAMETERS FOR STARTING A STREAMLINE
C .   TURN THE BOX OFF FOR STARTING A STREAMLINE
C .   CHECK TO SEE IF THIS BOX HAS MISSING DATA (IMSG.NE.0). IF SO ,
C .      FIND A NEW STARTING BOX
C
      CALL SBYTES( UX(I,J) , IONE , ISKIP1 , 1 , 0 , 1 )
      IF ( IMSG.EQ.0) GO TO 85
      IF (U(I,J).EQ.UVMSG .OR. U(I,J+1).EQ.UVMSG .OR.
     1    U(I+1,J).EQ.UVMSG .OR. U(I+1,J+1).EQ.UVMSG) GO TO 50
C
   85 ISAV = I
      JSAV = J
      KFLAG = 1
      PLMN1 = +1.
      GO TO 100
   90 CONTINUE
C
C COME TO HERE TO DRAW IN THE OPPOSITE DIRECTION
C
      KFLAG = 0
      PLMN1 = -1.
      I = ISAV
      J = JSAV
  100 CONTINUE
C
C INITIATE THE DRAWING SEQUENCE
C .   START ALL STREAMLINES IN THE CENTER OF A BOX
C
      NBOX = 0
      ITER = 0
      IF (KFLAG.NE.0) ICHKB = ICHK+1
      IF (ICHKB.GT.NUMCHK) ICHKB = 1
      X = FLOAT(I)+0.5
      Y = FLOAT(J)+0.5
      XBASE = X
      YBASE = Y
      CALL FL2INT (FX(X,Y),FY(X,Y),IFX,IFY)
      CALL PLOTIT (IFX,IFY,0)
      CALL GBYTES( UX(I,J) , IUX , ISKIP , 2 , 0 , 1 )
      IF ( (KFLAG.EQ.0) .OR. (IAND( IUX , ITWO ) .NE. 0 ) ) GO TO 110
C
C GRID BOX MUST BE ELIGIBLE FOR A DIRECTIONAL ARROW
C
      CALL GNEWPT (UX,VY,IMAX,JPTSY)
      MFLAG = 1
      GO TO 160
C
  110 CONTINUE
C
C PLOT LOOP
C .   CHECK TO SEE IF THE STREAMLINE HAS ENTERED A NEW GRID BOX
C
      IF (I.NE.IFIX(X) .OR. J.NE.IFIX(Y)) GO TO 120
C
C MUST BE IN SAME BOX CALCULATE THE DISPLACEMENT COMPONENTS
C
      CALL GNEWPT (UX,VY,IMAX,JPTSY)
C
C UPDATE THE POSITION AND DRAW THE VECTOR
C
      X = X+PLMN1*DELX
      Y = Y+PLMN1*DELY
      CALL FL2INT (FX(X,Y),FY(X,Y),IFX,IFY)
      CALL PLOTIT (IFX,IFY,1)
      ITER = ITER+1
C
C CHECK STREAMLINE PROGRESS EVERY 'ITERP' OR SO ITERATIONS
C
      IF (MOD(ITER,ITERP).NE.0) GO TO 115
      IF (ABS(X-XBASE).LT.DISPC  .AND. ABS(Y-YBASE).LT.DISPC ) GO TO  50
      XBASE = X
      YBASE = Y
      GO TO 110
  115 CONTINUE
C
C SHOULD THE CIRCULAR LISTS BE CHECKED FOR STREAMLINE CROSSOVER
C
      IF ( (ITERC.LT.0) .OR. (MOD(ITER,ITERC).NE.0) ) GO TO 110
C
C MUST WANT THE CIRCULAR LIST CHECKED
C
      GO TO 130
  120 CONTINUE
C
C MUST HAVE ENTERED A NEW GRID BOX  CHECK FOR THE FOLLOWING :
C .   (1) ARE THE NEW POINTS ON THE GRID
C .   (2) CHECK FOR MISSING DATA IF MSG  DATA FLAG (IMSG) HAS BEEN SET.
C .   (3) IS THIS BOX ELIGIBLE FOR A DIRECTIONAL ARROW
C .   (4) LOCATION OF THIS ENTRY VERSUS OTHER STREAMLINE ENTRIES
C
      NBOX = NBOX+1
C
C CHECK (1)
C
      IF (IFIX(X).LT.IS .OR. IFIX(X).GT.IEND1) GO TO  50
      IF (IFIX(Y).LT.JS .OR. IFIX(Y).GT.JEND1) GO TO  50
C
C CHECK (2)
C
      IF ( IMSG.EQ.0) GO TO 125
      II = IFIX(X)
      JJ = IFIX(Y)
      IF (U(II,JJ).EQ.UVMSG .OR. U(II,JJ+1).EQ.UVMSG .OR.
     1    U(II+1,JJ).EQ.UVMSG .OR. U(II+1,JJ+1).EQ.UVMSG) GO TO 50
  125 CONTINUE
C
C CHECK (3)
C
      CALL GBYTES( UX(I,J) , IUX , ISKIP , 2 , 0 , 1 )
      IF ( IAND( IUX , ITWO )  .NE. 0) GO TO 130
      MFLAG = 2
      GO TO 160
  130 CONTINUE
C
C CHECK (4)
C
      DO 140 LOC=1,LCHK
      IF (ABS( X-XCHK(LOC) ).GT.CSTOP .OR.
     1    ABS( Y-YCHK(LOC) ).GT.CSTOP) GO TO 140
      LFLAG = 1
      IF (ICHKB.LE.ICHK .AND. LOC.GE.ICHKB .AND. LOC.LE.ICHK) LFLAG = 2
      IF (ICHKB.GE.ICHK .AND. (LOC.GE.ICHKB .OR. LOC.LE.ICHK)) LFLAG = 2
      IF (LFLAG.EQ.1) GO TO  50
  140 CONTINUE
      LCHK = MIN0(LCHK+1,NUMCHK)
      ICHK = ICHK+1
      IF (ICHK.GT.NUMCHK) ICHK = 1
      XCHK(ICHK) = X
      YCHK(ICHK) = Y
      I = IFIX(X)
      J = IFIX(Y)
      CALL SBYTES( UX(I,J) , IONE , ISKIP1 , 1 , 0 , 1 )
      IF (NBOX.LT.5) GO TO 150
      ICHKB = ICHKB+1
      IF (ICHKB.GT.NUMCHK) ICHKB = 1
  150 CONTINUE
      GO TO 110
C
  160 CONTINUE
C
C THIS SECTION DRAWS A DIRECTIONAL ARROW BASED ON THE MOST RECENT DIS-
C .   PLACEMENT COMPONENTS ,DELX AND DELY, RETURNED BY GNEWPT. IN EARLIE
C .   VERSIONS THIS WAS A SEPARATE SUBROUTINE (CALLED DRWDAR). IN THAT
C .   CASE ,HOWEVER, FX AND FY WERE DEFINED EXTERNAL SINCE THESE
C .   FUNCTIONS WERE USED BY BOTH DRWSTR AND DRWDAR. IN ORDER TO
C .   MAKE ALL DEFAULT TRANSFORMATIONS STATEMENT FUNCTIONS I HAVE
C .   PUT DRWDAR  HERE AND I WILL USE MFLAG TO RETURN  TO THE CORRECT
C .   LOCATION IN THE CODE.
C
      IF ( (DELX.EQ.0.) .AND. (DELY.EQ.0.) ) GO TO 50
C
      CALL SBYTES( UX(I,J) ,IONE , ISKIP , 1 ,0 , 1 )
      D = ATAN2(-DELX,DELY)
      D30 = D+0.5
  170 YY = -AROWL*COS(D30)+Y
      XX = +AROWL*SIN(D30)+X
      CALL FL2INT (FX(XX,YY),FY(XX,YY),IFXX,IFYY)
      CALL PLOTIT (IFXX,IFYY,1)
      CALL FL2INT (FX(X,Y),FY(X,Y),IFX,IFY)
      CALL PLOTIT (IFX,IFY,0)
      IF (D30.LT.D) GO TO 180
      D30 = D-0.5
      GO TO 170
  180 IF (MFLAG.EQ.1) GO TO 110
      IF (MFLAG.EQ.2) GO TO 130
C
  190 CONTINUE
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END
      SUBROUTINE GNEWPT (UX,VY,IMAX,JPTSY)
C
C INTERPOLATION ROUTINE TO CALCULATE THE DISPLACEMANT COMPONENTS
C .   THE PHILOSPHY HERE IS TO UTILIZE AS MANY POINTS AS POSSIBLE
C .   (WITHIN REASON) IN ORDER TO OBTAIN A PLEASING AND ACCURATE PLOT.
C .   INTERPOLATION SCHEMES DESIRED BY OTHER USERS MAY EASILY BE
C .   SUBSTITUTED IF DESIRED.
C
      DIMENSION       UX(IMAX,JPTSY)        ,VY(IMAX,JPTSY)
      COMMON /STR01/  IS         ,IEND      ,JS        ,JEND
     1             ,  IEND1      ,JEND1     ,I         ,J
     2             ,  X          ,Y         ,DELX      ,DELY
     3             ,  ICYC1      ,IMSG1     ,IGFL1
      COMMON /STR03/  INITA , INITB , AROWL , ITERP , ITERC , IGFLG
     1             ,  IMSG , UVMSG , ICYC , DISPL , DISPC , CSTOP
C
      SAVE
C
C FDLI - DOUBLE LINEAR INTERPOLATION FORMULA
C FBESL - BESSEL 16 PT INTERPOLATION FORMULA ( MOST USED FORMULA )
C FQUAD - QUADRATIC INTERPOLATION FORMULA
C
      FDLI(Z,Z1,Z2,Z3,DX,DY) = (1.-DX)*((1.-DY)*Z +DY*Z1)
     1                         +     DX *((1.-DY)*Z2+DY*Z3)
      FBESL(Z,ZP1,ZP2,ZM1,DZ)=Z+DZ*(ZP1-Z+0.25*(DZ-1.)*((ZP2-ZP1-Z+ZM1)
     1                        +0.666667*(DZ-0.5)*(ZP2-3.*ZP1+3.*Z-ZM1)))
      FQUAD(Z,ZP1,ZM1,DZ)=Z+0.5*DZ*(ZP1-ZM1+DZ*(ZP1-2.*Z+ZM1))
C
      DX = X-AINT(X)
      DY = Y-AINT(Y)
C
      IF( IMSG.NE.0.OR.IGFLG.NE.0) GO TO 20
C
      IM1 = I-1
      IP2 = I+2
C
C DETERMINE WHICH INTERPOLATION FORMULA TO USE DEPENDING ON I,J LOCATION
C .   THE FIRST CHECK IS FOR I,J IN THE GRID INTERIOR.
C
      IF (J.GT.JS .AND. J.LT.JEND1 .AND. I.GT.IS .AND. I.LT.IEND1)
     1    GO TO 30
      IF (J.EQ.JEND1 .AND. I.GT.IS .AND. I.LT.IEND1) GO TO  40
      IF (J.EQ.JS) GO TO 20
C
      IF (ICYC1.EQ.1) GO TO 10
C
C MUST NOT BE CYCLIC
C
      IF (I.EQ.IS) GO TO 20
      IF (I.EQ.IEND1) GO TO  50
      GO TO 20
   10 CONTINUE
C
C MUST BE CYCLIC IN THE X DIRECTION
C
      IF (I.EQ.IS .AND. J.LT.JEND1) GO TO 12
      IF (I.EQ.IEND1 .AND. J.LT.JEND1) GO TO 14
      IF (J.EQ.JEND1 .AND. I.EQ.IS) GO TO 16
      IF (J.EQ.JEND1 .AND. I.EQ.IEND1) GO TO 18
      GO TO 20
   12 IM1 = IEND1
      GO TO 30
   14 IP2 = IS+1
      GO TO 30
   16 IM1 = IEND1
      GO TO 40
   18 IP2 = IS+1
      GO TO 40
C
   20 CONTINUE
C
C DOUBLE LINEAR INTERPOLATION FORMULA. THIS SCHEME WORKS AT ALL POINTS
C .   BUT THE RESULTING STREAMLINES ARE NOT AS PLEASING AS THOSE DRAWN
C .   BY FBESL OR FQUAD. CURRENTLY THIS IS USED AT THIS IS UTILIZED
C .   ONLY AT CERTAIN BOUNDARY POINTS OR IF IGFLG IS NOT EQUAL TO ZERO.
C
      DELX = FDLI (UX(I,J),UX(I,J+1),UX(I+1,J),UX(I+1,J+1),DX,DY)
      DELY = FDLI (VY(I,J),VY(I,J+1),VY(I+1,J),VY(I+1,J+1),DX,DY)
      RETURN
   30 CONTINUE
C
C USE A 16 POINT BESSEL INTERPOLATION SCHEME
C
      UJM1 = FBESL (UX(I,J-1),UX(I+1,J-1),UX(IP2,J-1),UX(IM1,J-1),DX)
      UJ   = FBESL (UX(I,J),UX(I+1,J),UX(IP2,J),UX(IM1,J),DX)
      UJP1 = FBESL (UX(I,J+1),UX(I+1,J+1),UX(IP2,J+1),UX(IM1,J+1),DX)
      UJP2 = FBESL (UX(I,J+2),UX(I+1,J+2),UX(IP2,J+2),UX(IM1,J+2),DX)
      DELX = FBESL (UJ,UJP1,UJP2,UJM1,DY)
      VJM1 = FBESL (VY(I,J-1),VY(I+1,J-1),VY(IP2,J-1),VY(IM1,J-1),DX)
      VJ   = FBESL (VY(I,J),VY(I+1,J),VY(IP2,J),VY(IM1,J),DX)
      VJP1 = FBESL (VY(I,J+1),VY(I+1,J+1),VY(IP2,J+1),VY(IM1,J+1),DX)
      VJP2 = FBESL (VY(I,J+2),VY(I+1,J+2),VY(IP2,J+2),VY(IM1,J+2),DX)
      DELY = FBESL (VJ,VJP1,VJP2,VJM1,DY)
      RETURN
   40 CONTINUE
C
C 12 POINT INTERPOLATION SCHEME APPLICABLE TO ONE ROW FROM TOP BOUNDARY
C
      UJM1 = FBESL (UX(I,J-1),UX(I+1,J-1),UX(IP2,J-1),UX(IM1,J-1),DX)
      UJ   = FBESL (UX(I,J),UX(I+1,J),UX(IP2,J),UX(IM1,J),DX)
      UJP1 = FBESL (UX(I,J+1),UX(I+1,J+1),UX(IP2,J+1),UX(IM1,J+1),DX)
      DELX = FQUAD (UJ,UJP1,UJM1,DY)
      VJM1 = FBESL (VY(I,J-1),VY(I+1,J-1),VY(IP2,J-1),VY(IM1,J-1),DX)
      VJ   = FBESL (VY(I,J),VY(I+1,J),VY(IP2,J),VY(IM1,J),DX)
      VJP1 = FBESL (VY(I,J+1),VY(I+1,J+1),VY(IP2,J+1),VY(IM1,J+1),DX)
      DELY = FQUAD (VJ,VJP1,VJM1,DY)
      RETURN
   50 CONTINUE
C
C 9 POINT INTERPOLATION SCHEME FOR USE IN THE NON-CYCLIC CASE
C .   AT I=IEND1 ; JS.LT.J AND J.LE.JEND1
C
      UJP1 = FQUAD (UX(I,J+1),UX(I+1,J+1),UX(IM1,J+1),DX)
      UJ   = FQUAD (UX(I,J),UX(I+1,J),UX(IM1,J),DX)
      UJM1 = FQUAD (UX(I,J-1),UX(I+1,J-1),UX(IM1,J-1),DX)
      DELX = FQUAD (UJ,UJP1,UJM1,DY)
      VJP1 = FQUAD (VY(I,J+1),VY(I+1,J+1),VY(IM1,J+1),DX)
      VJ   = FQUAD (VY(I,J),VY(I+1,J),VY(IM1,J),DX)
      VJM1 = FQUAD (VY(I,J-1),VY(I+1,J-1),VY(IM1,J-1),DX)
      DELY = FQUAD (VJ,VJP1,VJM1,DY)
      RETURN
      END
      SUBROUTINE EZSTRM(U,V,WORK,IMAX,JMAX)
C
      DIMENSION       U(IMAX,JMAX)       ,V(IMAX,JMAX)     ,WORK(1)
C
        SAVE
C
C THE FOLLOWING CALL IS FOR MONITORING LIBRARY USE AT NCAR
C
      CALL Q8QST4 ( 'GRAPHX', 'STRMLN', 'EZSTRM', 'VERSION 01')
C
      CALL STRMLN(U,V,WORK,IMAX,IMAX,JMAX,0,IER)
      RETURN
      END
      SUBROUTINE CHKCYC  (U,V,IMAX,JPTSY,IER)
C
C CHECK FOR CYCLIC CONDITION
C
      DIMENSION       U(IMAX,JPTSY)          ,V(IMAX,JPTSY)
      COMMON /STR01/  IS         ,IEND      ,JS        ,JEND
     1             ,  IEND1      ,JEND1     ,I         ,J
     2             ,  X          ,Y         ,DELX      ,DELY
     3             ,  ICYC1      ,IMSG1     ,IGFL1
C
        SAVE
      DO  10 J=JS,JEND
      IF (U(IS,J).NE.U(IEND,J)) GO TO  20
      IF (V(IS,J).NE.V(IEND,J)) GO TO  20
   10 CONTINUE
C
C MUST BE CYCLIC
C
      RETURN
   20 CONTINUE
C
C MUST NOT BE CYCLIC
C . CHANGE THE PARAMETER AND SET IER = -1
C
      ICYC1 = 0
      IER = -1
      RETURN
C
C------------------------------------------------------------------
C REVISION HISTORY
C
C OCTOBER 1979      FIRST ADDED TO ULIB
C
C OCTOBER 1980      ADDED BUGS SECTION
C
C JUNE    1984      REMOVED STATEMENT FUNCTIONS ANDF AND ORF,
C                   CONVERTED TO FORTRAN77 AND GKS.
C-------------------------------------------------------------------
      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGPWRT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
C
      CHARACTER*(*) CHRS
C
C This routine just passes its arguments along to the character-drawing
C routine PWRIT, in the system plot package.  By substituting his/her
C own version of AGPWRT, the user can cause a fancier character-drawer
C to be used.
C
      CALL PWRIT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
C
C Done.
C
      RETURN
C
      END

#-h-  litral			  316  local   12/01/80  15:54:13
# litral - process literal Fortran line
   include  defs

   subroutine litral

   include COMMON_BLOCKS

   character ngetch

   # Finish off any left-over characters
   if (outp > 0)
      call outdwe

   for (outp = 1; ngetch (outbuf (outp)) != NEWLINE; outp = outp + 1)
      ;
   outp = outp - 1
   call outdwe
   return
   end

      subroutine knots ( break, l, kpm, t, n )
c  from  * a practical guide to splines *  by c. de boor
c  to be called in  c o l l o c .
c  constructs from the given breakpoint sequence  b r e a k  the knot
c  sequence  t	so that
c  spline(k+m,t) = pp(k+m,break) with  m-1  continuous derivatives .
c  this means that
c  t(1),...,t(n+kpm)  =  break(1) kpm times, then break(2),...,
c	 break(l) each	k  times, then, finally, break(l+1) kpm times.
c
c******  i n p u t  ******
c  break(1),...,break(l+1)  breakpoint sequence
c  l  number of intervals or pieces
c  kpm	 = k + m, order of the pp function or spline
c
c******  o u t p u t  ******
c  t(1),...,t(n+kpm)  the knot sequence.
c  n	 = l*k + m  =  dimension of  spline(k+m,t).
c
      integer l,kpm,n,	 iside,j,jj,jjj,k,ll,m
      real break(1),t(1),   xside
      common /side/ m,iside,xside(10)
      k = kpm - m
      n = l*k + m
      jj = n + kpm
      jjj = l + 1
      do 11 ll=1,kpm
	 t(jj) = break(jjj)
   11	 jj = jj - 1
      do 12 j=1,l
      jjj = jjj - 1
	 do 12 ll=1,k
	    t(jj) = break(jjj)
   12	    jj = jj - 1
      do 13 ll=1,kpm
   13	 t(ll) = break(1)
					return
      end

C----------------------------------------------------------------------
        subroutine ftgcks(iunit,datsum,chksum,status)

C       calculate and encode the checksums of the data unit and the total HDU 

C       iunit   i  fortran unit number
C       datsum  d  output  checksum for the data
C       chksum  d  output  checksum for the entire HDU 
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Sept, 1994

        integer iunit,status
        double precision datsum,chksum

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------------------------------------

        integer ibuff,nrec

        if (status .gt. 0)return

C       calculate number of data records
        ibuff=bufnum(iunit)
        nrec=(hdstrt(ibuff,chdu(ibuff)+1)-dtstrt(ibuff))/2880

        datsum=0.
        if (nrec .gt. 0)then

C           move to the start of the data
            call ftmbyt(iunit,dtstrt(ibuff),.true.,status)

C           accumulate the 32-bit 1's complement checksum
            call ftcsum(iunit,nrec,datsum,status)
        end if

C       move to the start of the header
        call ftmbyt(iunit,hdstrt(ibuff,chdu(ibuff)),.true.,status)

C       calculate number of FITS blocks in the header
        nrec=(dtstrt(ibuff)-hdstrt(ibuff,chdu(ibuff)))/2880

C       accumulate the header into the checksum
        chksum=datsum
        call ftcsum(iunit,nrec,chksum,status)
        end

include	defs

# dodash --- expand array (i-1)-array (i+1) into set (j)... from valid

   subroutine dodash (valid, array, i, set, j, maxset)
   integer i, j, maxset
   character valid (ARB), array (ARB), set (maxset)

   character esc

   integer junk, k, limit
   external index
   integer addset, index

   i = i + 1
   j = j - 1
   limit = index (valid, esc (array, i))
   for (k = index (valid, set (j)); k <= limit; k = k + 1)
      junk = addset (valid (k), set, j, maxset)

   return
   end

      subroutine fold (token)
      integer token (100)
      integer clower
      integer i
      i = 1
23000 if (.not.(token (i) .ne. -2))goto 23002
      token (i) = clower (token (i))
23001 i = i + 1
      goto 23000
23002 continue
      return
      end

      SUBROUTINE slMOON (IY, ID, FD, PV)
*+
*     - - - - -
*      M O O N
*     - - - - -
*
*  Approximate geocentric position and velocity of the Moon
*  (single precision).
*
*  Given:
*     IY       i       year
*     ID       i       day in year (1 = Jan 1st)
*     FD       r       fraction of day
*
*  Returned:
*     PV       r(6)    Moon position & velocity vector
*
*  Notes:
*
*  1  The date and time is TDB (loosely ET) in a Julian calendar
*     which has been aligned to the ordinary Gregorian
*     calendar for the interval 1900 March 1 to 2100 February 28.
*     The year and day can be obtained by calling slCAYD or
*     slCLYD.
*
*  2  The Moon 6-vector is Moon centre relative to Earth centre,
*     mean equator and equinox of date.  Position part, PV(1-3),
*     is in AU;  velocity part, PV(4-6), is in AU/sec.
*
*  3  The position is accurate to better than 0.5 arcminute
*     in direction and 1000 km in distance.  The velocity
*     is accurate to better than 0.5"/hour in direction and
*     4 m/s in distance.  (RMS figures with respect to JPL DE200
*     for the interval 1960-2025 are 14 arcsec and 0.2 arcsec/hour in
*     longitude, 9 arcsec and 0.2 arcsec/hour in latitude, 350 km and
*     2 m/s in distance.)  Note that the distance accuracy is
*     comparatively poor because this routine is principally intended
*     for computing topocentric direction.
*
*  4  This routine is only a partial implementation of the original
*     Meeus algorithm (reference below), which offers 4 times the
*     accuracy in direction and 30 times the accuracy in distance
*     when fully implemented (as it is in slDMON).
*
*  Reference:
*     Meeus, l'Astronomie, June 1984, p348.
*
*  Called:  slS2C6
*
*  P.T.Wallace   Starlink   8 December 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IY,ID
      REAL FD,PV(6)

      INTEGER ITP(4,4),ITL(4,39),ITB(4,29),I,IY4,N
      REAL D2R,RATCON,ERADAU
      REAL ELP0,ELP1,ELP1I,ELP1F
      REAL EM0,EM1,EM1F
      REAL EMP0,EMP1,EMP1I,EMP1F
      REAL D0,D1,D1I,D1F
      REAL F0,F1,F1I,F1F
      REAL TL(39)
      REAL TB(29)
      REAL TP(4)
      REAL YI,YF,T,ELP,EM,EMP,D,F,EL,ELD,COEFF,CEM,CEMP
      REAL CD,CF,THETA,THETAD,B,BD,P,PD,SP,R,RD
      REAL V(6),EPS,SINEPS,COSEPS

*  Degrees to radians
      PARAMETER (D2R=1.745329252E-2)

*  Rate conversion factor:  D2R**2/(86400*365.25)
      PARAMETER (RATCON=9.652743551E-12)

*  Earth radius in AU:  6378.137/149597870
      PARAMETER (ERADAU=4.2635212653763E-5)

*
*  Coefficients for fundamental arguments
*
*  Fixed term (deg), term in T (deg & whole revs + fraction per year)
*
*  Moon's mean longitude
      DATA ELP0,ELP1,ELP1I,ELP1F /
     :            270.434164, 4812.678831, 4680., 132.678831 /
*
*  Sun's mean anomaly
      DATA EM0,EM1,EM1F /
     :            358.475833,  359.990498,        359.990498 /
*
*  Moon's mean anomaly
      DATA EMP0,EMP1,EMP1I,EMP1F /
     :            296.104608, 4771.988491, 4680.,  91.988491 /
*
*  Moon's mean elongation
      DATA D0,D1,D1I,D1F /
     :            350.737486,  4452.671142, 4320., 132.671142 /
*
*  Mean distance of the Moon from its ascending node
      DATA F0,F1,F1I,F1F /
     :             11.250889, 4832.020251, 4680., 152.020251 /

*
*  Coefficients for Moon position
*
*   T(N)       = coefficient of term (deg)
*   IT(N,1-4)  = coefficients of M, M', D, F in argument
*
*  Longitude
*                                         M   M'  D   F
      DATA TL( 1)/            +6.288750                     /,
     :     (ITL(I, 1),I=1,4)/             0, +1,  0,  0     /
      DATA TL( 2)/            +1.274018                     /,
     :     (ITL(I, 2),I=1,4)/             0, -1, +2,  0     /
      DATA TL( 3)/            +0.658309                     /,
     :     (ITL(I, 3),I=1,4)/             0,  0, +2,  0     /
      DATA TL( 4)/            +0.213616                     /,
     :     (ITL(I, 4),I=1,4)/             0, +2,  0,  0     /
      DATA TL( 5)/            -0.185596                     /,
     :     (ITL(I, 5),I=1,4)/            +1,  0,  0,  0     /
      DATA TL( 6)/            -0.114336                     /,
     :     (ITL(I, 6),I=1,4)/             0,  0,  0, +2     /
      DATA TL( 7)/            +0.058793                     /,
     :     (ITL(I, 7),I=1,4)/             0, -2, +2,  0     /
      DATA TL( 8)/            +0.057212                     /,
     :     (ITL(I, 8),I=1,4)/            -1, -1, +2,  0     /
      DATA TL( 9)/            +0.053320                     /,
     :     (ITL(I, 9),I=1,4)/             0, +1, +2,  0     /
      DATA TL(10)/            +0.045874                     /,
     :     (ITL(I,10),I=1,4)/            -1,  0, +2,  0     /
      DATA TL(11)/            +0.041024                     /,
     :     (ITL(I,11),I=1,4)/            -1, +1,  0,  0     /
      DATA TL(12)/            -0.034718                     /,
     :     (ITL(I,12),I=1,4)/             0,  0, +1,  0     /
      DATA TL(13)/            -0.030465                     /,
     :     (ITL(I,13),I=1,4)/            +1, +1,  0,  0     /
      DATA TL(14)/            +0.015326                     /,
     :     (ITL(I,14),I=1,4)/             0,  0, +2, -2     /
      DATA TL(15)/            -0.012528                     /,
     :     (ITL(I,15),I=1,4)/             0, +1,  0, +2     /
      DATA TL(16)/            -0.010980                     /,
     :     (ITL(I,16),I=1,4)/             0, -1,  0, +2     /
      DATA TL(17)/            +0.010674                     /,
     :     (ITL(I,17),I=1,4)/             0, -1, +4,  0     /
      DATA TL(18)/            +0.010034                     /,
     :     (ITL(I,18),I=1,4)/             0, +3,  0,  0     /
      DATA TL(19)/            +0.008548                     /,
     :     (ITL(I,19),I=1,4)/             0, -2, +4,  0     /
      DATA TL(20)/            -0.007910                     /,
     :     (ITL(I,20),I=1,4)/            +1, -1, +2,  0     /
      DATA TL(21)/            -0.006783                     /,
     :     (ITL(I,21),I=1,4)/            +1,  0, +2,  0     /
      DATA TL(22)/            +0.005162                     /,
     :     (ITL(I,22),I=1,4)/             0, +1, -1,  0     /
      DATA TL(23)/            +0.005000                     /,
     :     (ITL(I,23),I=1,4)/            +1,  0, +1,  0     /
      DATA TL(24)/            +0.004049                     /,
     :     (ITL(I,24),I=1,4)/            -1, +1, +2,  0     /
      DATA TL(25)/            +0.003996                     /,
     :     (ITL(I,25),I=1,4)/             0, +2, +2,  0     /
      DATA TL(26)/            +0.003862                     /,
     :     (ITL(I,26),I=1,4)/             0,  0, +4,  0     /
      DATA TL(27)/            +0.003665                     /,
     :     (ITL(I,27),I=1,4)/             0, -3, +2,  0     /
      DATA TL(28)/            +0.002695                     /,
     :     (ITL(I,28),I=1,4)/            -1, +2,  0,  0     /
      DATA TL(29)/            +0.002602                     /,
     :     (ITL(I,29),I=1,4)/             0, +1, -2, -2     /
      DATA TL(30)/            +0.002396                     /,
     :     (ITL(I,30),I=1,4)/            -1, -2, +2,  0     /
      DATA TL(31)/            -0.002349                     /,
     :     (ITL(I,31),I=1,4)/             0, +1, +1,  0     /
      DATA TL(32)/            +0.002249                     /,
     :     (ITL(I,32),I=1,4)/            -2,  0, +2,  0     /
      DATA TL(33)/            -0.002125                     /,
     :     (ITL(I,33),I=1,4)/            +1, +2,  0,  0     /
      DATA TL(34)/            -0.002079                     /,
     :     (ITL(I,34),I=1,4)/            +2,  0,  0,  0     /
      DATA TL(35)/            +0.002059                     /,
     :     (ITL(I,35),I=1,4)/            -2, -1, +2,  0     /
      DATA TL(36)/            -0.001773                     /,
     :     (ITL(I,36),I=1,4)/             0, +1, +2, -2     /
      DATA TL(37)/            -0.001595                     /,
     :     (ITL(I,37),I=1,4)/             0,  0, +2, +2     /
      DATA TL(38)/            +0.001220                     /,
     :     (ITL(I,38),I=1,4)/            -1, -1, +4,  0     /
      DATA TL(39)/            -0.001110                     /,
     :     (ITL(I,39),I=1,4)/             0, +2,  0, +2     /
*
*  Latitude
*                                         M   M'  D   F
      DATA TB( 1)/            +5.128189                     /,
     :     (ITB(I, 1),I=1,4)/             0,  0,  0, +1     /
      DATA TB( 2)/            +0.280606                     /,
     :     (ITB(I, 2),I=1,4)/             0, +1,  0, +1     /
      DATA TB( 3)/            +0.277693                     /,
     :     (ITB(I, 3),I=1,4)/             0, +1,  0, -1     /
      DATA TB( 4)/            +0.173238                     /,
     :     (ITB(I, 4),I=1,4)/             0,  0, +2, -1     /
      DATA TB( 5)/            +0.055413                     /,
     :     (ITB(I, 5),I=1,4)/             0, -1, +2, +1     /
      DATA TB( 6)/            +0.046272                     /,
     :     (ITB(I, 6),I=1,4)/             0, -1, +2, -1     /
      DATA TB( 7)/            +0.032573                     /,
     :     (ITB(I, 7),I=1,4)/             0,  0, +2, +1     /
      DATA TB( 8)/            +0.017198                     /,
     :     (ITB(I, 8),I=1,4)/             0, +2,  0, +1     /
      DATA TB( 9)/            +0.009267                     /,
     :     (ITB(I, 9),I=1,4)/             0, +1, +2, -1     /
      DATA TB(10)/            +0.008823                     /,
     :     (ITB(I,10),I=1,4)/             0, +2,  0, -1     /
      DATA TB(11)/            +0.008247                     /,
     :     (ITB(I,11),I=1,4)/            -1,  0, +2, -1     /
      DATA TB(12)/            +0.004323                     /,
     :     (ITB(I,12),I=1,4)/             0, -2, +2, -1     /
      DATA TB(13)/            +0.004200                     /,
     :     (ITB(I,13),I=1,4)/             0, +1, +2, +1     /
      DATA TB(14)/            +0.003372                     /,
     :     (ITB(I,14),I=1,4)/            -1,  0, -2, +1     /
      DATA TB(15)/            +0.002472                     /,
     :     (ITB(I,15),I=1,4)/            -1, -1, +2, +1     /
      DATA TB(16)/            +0.002222                     /,
     :     (ITB(I,16),I=1,4)/            -1,  0, +2, +1     /
      DATA TB(17)/            +0.002072                     /,
     :     (ITB(I,17),I=1,4)/            -1, -1, +2, -1     /
      DATA TB(18)/            +0.001877                     /,
     :     (ITB(I,18),I=1,4)/            -1, +1,  0, +1     /
      DATA TB(19)/            +0.001828                     /,
     :     (ITB(I,19),I=1,4)/             0, -1, +4, -1     /
      DATA TB(20)/            -0.001803                     /,
     :     (ITB(I,20),I=1,4)/            +1,  0,  0, +1     /
      DATA TB(21)/            -0.001750                     /,
     :     (ITB(I,21),I=1,4)/             0,  0,  0, +3     /
      DATA TB(22)/            +0.001570                     /,
     :     (ITB(I,22),I=1,4)/            -1, +1,  0, -1     /
      DATA TB(23)/            -0.001487                     /,
     :     (ITB(I,23),I=1,4)/             0,  0, +1, +1     /
      DATA TB(24)/            -0.001481                     /,
     :     (ITB(I,24),I=1,4)/            +1, +1,  0, +1     /
      DATA TB(25)/            +0.001417                     /,
     :     (ITB(I,25),I=1,4)/            -1, -1,  0, +1     /
      DATA TB(26)/            +0.001350                     /,
     :     (ITB(I,26),I=1,4)/            -1,  0,  0, +1     /
      DATA TB(27)/            +0.001330                     /,
     :     (ITB(I,27),I=1,4)/             0,  0, -1, +1     /
      DATA TB(28)/            +0.001106                     /,
     :     (ITB(I,28),I=1,4)/             0, +3,  0, +1     /
      DATA TB(29)/            +0.001020                     /,
     :     (ITB(I,29),I=1,4)/             0,  0, +4, -1     /
*
*  Parallax
*                                         M   M'  D   F
      DATA TP( 1)/            +0.051818                     /,
     :     (ITP(I, 1),I=1,4)/             0, +1,  0,  0     /
      DATA TP( 2)/            +0.009531                     /,
     :     (ITP(I, 2),I=1,4)/             0, -1, +2,  0     /
      DATA TP( 3)/            +0.007843                     /,
     :     (ITP(I, 3),I=1,4)/             0,  0, +2,  0     /
      DATA TP( 4)/            +0.002824                     /,
     :     (ITP(I, 4),I=1,4)/             0, +2,  0,  0     /



*  Whole years & fraction of year, and years since J1900.0
      YI=FLOAT(IY-1900)
      IY4=MOD(MOD(IY,4)+4,4)
      YF=(FLOAT(4*(ID-1/(IY4+1))-IY4-2)+4.0*FD)/1461.0
      T=YI+YF

*  Moon's mean longitude
      ELP=D2R*MOD(ELP0+ELP1I*YF+ELP1F*T,360.0)

*  Sun's mean anomaly
      EM=D2R*MOD(EM0+EM1F*T,360.0)

*  Moon's mean anomaly
      EMP=D2R*MOD(EMP0+EMP1I*YF+EMP1F*T,360.0)

*  Moon's mean elongation
      D=D2R*MOD(D0+D1I*YF+D1F*T,360.0)

*  Mean distance of the moon from its ascending node
      F=D2R*MOD(F0+F1I*YF+F1F*T,360.0)

*  Longitude
      EL=0.0
      ELD=0.0
      DO N=39,1,-1
         COEFF=TL(N)
         CEM=FLOAT(ITL(1,N))
         CEMP=FLOAT(ITL(2,N))
         CD=FLOAT(ITL(3,N))
         CF=FLOAT(ITL(4,N))
         THETA=CEM*EM+CEMP*EMP+CD*D+CF*F
         THETAD=CEM*EM1+CEMP*EMP1+CD*D1+CF*F1
         EL=EL+COEFF*SIN(THETA)
         ELD=ELD+COEFF*COS(THETA)*THETAD
      END DO
      EL=EL*D2R+ELP
      ELD=RATCON*(ELD+ELP1/D2R)

*  Latitude
      B=0.0
      BD=0.0
      DO N=29,1,-1
         COEFF=TB(N)
         CEM=FLOAT(ITB(1,N))
         CEMP=FLOAT(ITB(2,N))
         CD=FLOAT(ITB(3,N))
         CF=FLOAT(ITB(4,N))
         THETA=CEM*EM+CEMP*EMP+CD*D+CF*F
         THETAD=CEM*EM1+CEMP*EMP1+CD*D1+CF*F1
         B=B+COEFF*SIN(THETA)
         BD=BD+COEFF*COS(THETA)*THETAD
      END DO
      B=B*D2R
      BD=RATCON*BD

*  Parallax
      P=0.0
      PD=0.0
      DO N=4,1,-1
         COEFF=TP(N)
         CEM=FLOAT(ITP(1,N))
         CEMP=FLOAT(ITP(2,N))
         CD=FLOAT(ITP(3,N))
         CF=FLOAT(ITP(4,N))
         THETA=CEM*EM+CEMP*EMP+CD*D+CF*F
         THETAD=CEM*EM1+CEMP*EMP1+CD*D1+CF*F1
         P=P+COEFF*COS(THETA)
         PD=PD-COEFF*SIN(THETA)*THETAD
      END DO
      P=(P+0.950724)*D2R
      PD=RATCON*PD

*  Transform parallax to distance (AU, AU/sec)
      SP=SIN(P)
      R=ERADAU/SP
      RD=-R*PD/SP

*  Longitude, latitude to x,y,z (AU)
      CALL slS2C6(EL,B,R,ELD,BD,RD,V)

*  Mean obliquity
      EPS=D2R*(23.45229-0.00013*T)
      SINEPS=SIN(EPS)
      COSEPS=COS(EPS)

*  Rotate Moon position and velocity into equatorial system
      PV(1)=V(1)
      PV(2)=V(2)*COSEPS-V(3)*SINEPS
      PV(3)=V(2)*SINEPS+V(3)*COSEPS
      PV(4)=V(4)
      PV(5)=V(5)*COSEPS-V(6)*SINEPS
      PV(6)=V(5)*SINEPS+V(6)*COSEPS

      END

C SUBROUTINE INTERP.F 
C
C SOURCE
C   BEVINGTON, PAGES 266-267.
C
C PURPOSE
C   INTERPOLATE BETWEEN DATA POINTS TO EVALUATE A FUNCTION
C
C USAGE 
C   CALL INTERP (X, Y, NPTS, NTERMS, XIN, YOUT) 
C
C DESCRIPTION OF PARAMETERS
C   X	   - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C   Y	   - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C   NPTS   - NUMBER OF PAIRS OF DATA POINTS
C   NTERMS - NUMBER OF TERMS IN FITTING POLYNOMIAL
C   XIN    - INPUT VALUE OF X
C   YOUT   - INTERPOLATED VALUE OF Y
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE
C
C COMMENTS
C   DIMENSION STATEMENT VALID FOR NTERMS UP TO 10
C   VALUE OF NTERMS MAY BE MODIFIED BY THE PROGRAM
C
	SUBROUTINE INTERP (X,Y,NPTS,NTERMS,XIN,YOUT)
	DOUBLE PRECISION DELTAX,DELTA,A,PROD,SUM
	DIMENSION X(1),Y(1)
	DIMENSION DELTA(10),A(10)
C
C SEARCH FOR APPROPRIATE VALUE OF X(1)
C
11	DO 19 I=1,NPTS
	IF (XIN-X(I)) 13,17,19
13	I1=I-NTERMS/2
	IF (I1) 15,15,21
15	I1=1
	GOTO 21 
17	YOUT=Y(I)
18	GOTO 61 
19	CONTINUE
	I1=NPTS-NTERMS+1
21	I2=I1+NTERMS-1
	IF (NPTS-I2) 23,31,31
23	I2=NPTS 
	I1=I2-NTERMS+1
25	IF (I1) 26,26,31
26	I1=1
27	NTERMS=I2-I1+1
C
C EVALUATE DEVIATIONS DELTA
C
31	DENOM=X(I1+1)-X(I1)
	DELTAX=(XIN-X(I1))/DENOM
	DO 35 I=1,NTERMS
	IX=I1+I-1
35	DELTA(I)=(X(IX)-X(I1))/DENOM
C
C ACCUMULATE COEFFICIENTS A
C
40	A(1)=Y(I1)
41	DO 50 K=2,NTERMS
	PROD=1. 
	SUM=0.
	IMAX=K-1
	IXMAX=I1+IMAX
	DO 49 I=1,IMAX
	J=K-I
	PROD=PROD*(DELTA(K)-DELTA(J))
49	SUM=SUM-A(J)/PROD
50	A(K)=SUM+Y(IXMAX)/PROD
C
C ACCUMULATE SUM OF EXPANSION
C
51	SUM=A(1)
	DO 57 J=2,NTERMS
	PROD=1. 
	IMAX=J-1
	DO 56 I=1,IMAX
56	PROD=PROD*(DELTAX-DELTA(I))
57	SUM=SUM+A(J)*PROD
60	YOUT=SUM
61	RETURN
	END

      subroutine banslv ( w, nroww, nrow, nbandl, nbandu, b )
c  from  * a practical guide to splines *  by c. de boor
c  companion routine to  banfac . it returns the solution  x  of the
c  linear system  a*x = b  in place of	b , given the lu-factorization
c  for	a  in the workarray  w .
c
c******  i n p u t  ******
c  w, nroww,nrow,nbandl,nbandu.....describe the lu-factorization of a
c	 banded matrix	a  of roder  nrow  as constructed in  banfac .
c	 for details, see  banfac .
c  b.....right side of the system to be solved .
c
c******  o u t p u t  ******
c  b.....contains the solution	x , of order  nrow .
c
c******  m e t h o d  ******
c     (with  a = l*u, as stored in  w,) the unit lower triangular system
c  l(u*x) = b  is solved for  y = u*x, and  y  stored in  b . then the
c  upper triangular system  u*x = y  is solved for  x  . the calcul-
c  ations are so arranged that the innermost loops stay within columns.
c
      integer nbandl,nbandu,nrow,nroww,   i,j,jmax,middle,nrowm1
      real w(nroww,nrow),b(nrow)
      middle = nbandu + 1
      if (nrow .eq. 1)			go to 49
      nrowm1 = nrow - 1
      if (nbandl .eq. 0)		go to 30
c				  forward pass
c	     for i=1,2,...,nrow-1, subtract  right side(i)*(i-th column
c	     of  l )  from right side  (below i-th row) .
      do 21 i=1,nrowm1
	 jmax = min0(nbandl, nrow-i)
	 do 21 j=1,jmax
   21	    b(i+j) = b(i+j) - b(i)*w(middle+j,i)
c				  backward pass
c	     for i=nrow,nrow-1,...,1, divide right side(i) by i-th diag-
c	     onal entry of  u, then subtract  right side(i)*(i-th column
c	     of  u)  from right side  (above i-th row).
   30 if (nbandu .gt. 0)		go to 40
c				 a  is lower triangular .
      do 31 i=1,nrow
   31	 b(i) = b(i)/w(1,i)
					return
   40 i = nrow
   41	 b(i) = b(i)/w(middle,i)
	 jmax = min0(nbandu,i-1)
	 do 45 j=1,jmax
   45	    b(i-j) = b(i-j) - b(i)*w(middle-j,i)
	 i = i - 1
	 if (i .gt. 1)			go to 41
   49 b(1) = b(1)/w(middle,1)
					return
      end

C----------------------------------------------------------------------
        subroutine ftphtb(ounit,ncols,nrows,nfield,ttype,tbcol,
     &  tform,tunit,extnam,status)

C       write required standard header keywords for an ASCII table extension 
C
C       ounit   i  fortran output unit number
C       ncols   i  number of columns in the table
C       nrows   i  number of rows in the table
C       nfield  i  number of fields in the table
C       ttype   c  name of each field (array) (optional)
C       tbcol   i  beginning column of each field (array)
C       tform   c  Fortran-77 format of each field (array)
C       tunit   c  units of each field (array) (optional)
C       extnam  c  name of table extension (optional)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,ncols,nrows,nfield,tbcol(*),status,i
        character*(*) ttype(*),tform(*),tunit(*),extnam
        character comm*48,tfm*20

        comm='ASCII table extension'
        call ftpkys(ounit,'XTENSION','TABLE',comm,status)

        comm='8-bit ASCII characters'
        call ftpkyj(ounit,'BITPIX',8,comm,status)

        comm='2-dimensional ASCII table'
        call ftpkyj(ounit,'NAXIS',2,comm,status)

        if (status .gt. 0)return

        if (ncols .ge. 0)then
                comm='width of table in characters'
                call ftpkyj(ounit,'NAXIS1',ncols,comm,status)
        else
C               illegal table width
                status=217
        call ftpmsg('ASCII table has negative width (NAXIS1) in'//
     &  ' call to FTPHTB')
                return
        end if

        if (status .gt. 0)return

        if (nrows .ge. 0)then
                comm='number of rows in table'
                call ftpkyj(ounit,'NAXIS2',nrows,comm,status)
        else
C               illegal number of rows in table
                status=218
        call ftpmsg('ASCII table has negative number of rows in'//
     &  ' call to FTPHTB')
        end if

        if (status .gt. 0)return

        comm='no group parameters (required keyword)'
        call ftpkyj(ounit,'PCOUNT',0,comm,status)

        comm='one data group (required)'
        call ftpkyj(ounit,'GCOUNT',1,comm,status)

        if (status .gt. 0)return

        if (nfield .ge. 0)then
                comm='number of fields in each row'
                call ftpkyj(ounit,'TFIELDS',nfield,comm,status)
        else
C               illegal number of fields
                status=216
        call ftpmsg('ASCII table has negative number of fields in'//
     &  ' call to FTPHTB')
        end if

        if (status .gt. 0)return

        do 10 i=1,nfield
            if (ttype(i) .ne. ' ' .and. ichar(ttype(i)(1:1)).ne.0)then
                comm='label for field '
                write(comm(17:19),1000)i
1000            format(i3)      
                call ftpkns(ounit,'TTYPE',i,1,ttype(i),comm,status)
            end if

            comm='beginning column of field '
            write(comm(27:29),1000)i
            call ftpknj(ounit,'TBCOL',i,1,tbcol(i),comm,status)

            comm='Fortran-77 format of field'
C           make sure format characters are in upper case:
            tfm=tform(i)
            call ftupch(tfm)
            call ftpkns(ounit,'TFORM',i,1,tfm,comm,status)

            if (tunit(i) .ne. ' ' .and. ichar(tunit(i)(1:1)).ne.0)then
                comm='physical unit of field'
                call ftpkns(ounit,'TUNIT',i,1,tunit(i),comm,status)
            end if
        if (status .gt. 0)return
10      continue        

        if (extnam .ne. ' ' .and. ichar(extnam(1:1)) .ne. 0)then
                comm='name of this ASCII table extension'
                call ftpkys(ounit,'EXTNAME',extnam,comm,status)
        end if
        end

      subroutine chol1d ( p, v, qty, npoint, ncol, u, qu )
c  from  * a practical guide to splines *  by c. de boor
c  from  * a practical guide to splines *  by c. de boor
c to be called in  s m o o t h
constructs the upper three diags. in v(i,j), i=2,,npoint-1, j=1,3, of
c  the matrix  6*(1-p)*q-transp.*(d**2)*q + p*r, then computes its
c  l*l-transp. decomposition and stores it also in v, then applies
c  forward and backsubstitution to the right side q-transp.*y in  qty
c  to obtain the solution in  u .
      integer ncol,npoint,   i,npm1,npm2
      real p,qty(npoint),qu(npoint),u(npoint),v(npoint,7),   prev,ratio
     *	  ,six1mp,twop
      npm1 = npoint - 1
c     construct 6*(1-p)*q-transp.*(d**2)*q  +  p*r
      six1mp = 6.*(1.-p)
      twop = 2.*p
      do 2 i=2,npm1
	 v(i,1) = six1mp*v(i,5) + twop*(v(i-1,4)+v(i,4))
	 v(i,2) = six1mp*v(i,6) + p*v(i,4)
    2	 v(i,3) = six1mp*v(i,7)
      npm2 = npoint - 2
      if (npm2 .ge. 2)			go to 10
      u(1) = 0.
      u(2) = qty(2)/v(2,1)
      u(3) = 0.
					go to 41
c  factorization
   10 do 20 i=2,npm2
	 ratio = v(i,2)/v(i,1)
	 v(i+1,1) = v(i+1,1) - ratio*v(i,2)
	 v(i+1,2) = v(i+1,2) - ratio*v(i,3)
	 v(i,2) = ratio
	 ratio = v(i,3)/v(i,1)
	 v(i+2,1) = v(i+2,1) - ratio*v(i,3)
   20	 v(i,3) = ratio
c
c  forward substitution
      u(1) = 0.
      v(1,3) = 0.
      u(2) = qty(2)
      do 30 i=2,npm2
   30	 u(i+1) = qty(i+1) - v(i,2)*u(i) - v(i-1,3)*u(i-1)
c  back substitution
      u(npoint) = 0.
      u(npm1) = u(npm1)/v(npm1,1)
      i = npm2
   40	 u(i) = u(i)/v(i,1)-u(i+1)*v(i,2)-u(i+2)*v(i,3)
	 i = i - 1
	 if (i .gt. 1)			go to 40
c  construct q*u
   41 prev = 0.
      do 50 i=2,npoint
	 qu(i) = (u(i) - u(i-1))/v(i-1,4)
	 qu(i-1) = qu(i) - prev
   50	 prev = qu(i)
      qu(npoint) = -qu(npoint)
					return
      end

chapter ix. example comparing the b-representation of a cubic  f  with
c  its values at knot averages.
c  from  * a practical guide to splines *  by c. de boor
c
      integer i,id,j,jj,n,nm4
      real bcoef(23),d(4),d0(4),dtip1,dtip2,f(23),t(27),tave(23),x
c	     the taylor coefficients at  0  for the polynomial	f  are
      data d0 /-162.,99.,-18.,1./
c
c		  set up knot sequence in the array  t .
      n = 13
      do 5 i=1,4
	 t(i) = 0.
    5	 t(n+i) = 10.
      nm4 = n-4
      do 6 i=1,nm4
    6	 t(i+4) = float(i)
c
      do 50 i=1,n
c	 use nested multiplication to get taylor coefficients  d  at
c		t(i+2)	from those at  0 .
	 do 20 j=1,4
   20	    d(j) = d0(j)
	 do 21 j=1,3
	    id = 4
	    do 21 jj=j,3
	       id = id-1
   21	       d(id) = d(id) + d(id+1)*t(i+2)
c
c		 compute b-spline coefficients by formula (9).
	 dtip1 = t(i+2) - t(i+1)
	 dtip2 = t(i+3) - t(i+2)
	 bcoef(i) = d(1) + (d(2)*(dtip2-dtip1)-d(3)*dtip1*dtip2)/3.
c
c		   evaluate  f	at corresp. knot average.
	 tave(i) = (t(i+1) + t(i+2) + t(i+3))/3.
	 x = tave(i)
   50	 f(i) = d0(1) + x*(d0(2) + x*(d0(3) + x*d0(4)))
c
      print 650, (i,tave(i), f(i), bcoef(i),i=1,n)
  650 format(45h  i   tave(i)	   f at tave(i)      bcoef(i)//
     *	     (i3,f10.5,2f16.5))
					stop
      end

C----------------------------------------------------------------------
        subroutine ftpclx(iunit,colnum,frow,fbit,nbit,lray,status)

C       write an array of logical values to a specified bit or byte
C       column of the binary table.   If the LRAY parameter is .true.,
C       then the corresponding bit is set to 1, otherwise it is set
C       to 0.
C       The binary table column being written to must have datatype 'B'
C       or 'X'. 

C       iunit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       fbit    i  first bit within the row to write
C       nbit    i  number of bits to write
C       lray    l  array of logical data values corresponding to the bits
C                        to be written
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Mar 1992
C       modified by Wm Pence May 1992 to remove call to system dependent
C                                     bit testing and setting routines.

        integer iunit,colnum,frow,fbit,nbit,status
        logical lray(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bstart,offset,tcode,fbyte,bitloc,ndone,tstat
        integer ibuff,i,ntodo,repeat,rstart,estart,buffer
        logical descrp,wrbit(8),setbit(8)
        character*1 cbuff
        character crow*9

        if (status .gt. 0)return

        ibuff=bufnum(iunit)
        tcode=tdtype(colnum+tstart(ibuff))

C       check input parameters
        if (nbit .le. 0)then
                return
        else if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &          'request is out of range:'//crow//' (FTPCLX).')
                return
        else if (fbit .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)fbit
                call ftpmsg('Starting element number for write '//
     &          'request is out of range:'//crow//' (FTPCLX).')
                return
        end if

        fbyte=(fbit+7)/8
        bitloc=fbit-(fbit-1)/8*8
        ndone=0
        ntodo=nbit
        rstart=frow-1
        estart=fbyte-1

        if (tcode .eq. 11)then
                descrp=.false.
C               N.B: REPEAT is the number of bytes, not number of bits
                repeat=trept(colnum+tstart(ibuff))
                if (fbyte .gt. repeat)then
C                               illegal element number
                                status=308
                                write(crow,2000)fbit
                    call ftpmsg('Starting element number for write '//
     &              'request is out of range:'//crow//' (FTPCLX).')
                                return
                end if
C               calc the i/o pointer location to start of sequence of pixels
                bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &          tbcol(colnum+tstart(ibuff))+estart
        else if (tcode .eq. -11)then
C               this is a variable length descriptor column
                descrp=.true.
C               only bit arrays (tform = 'X') are supported for variable
C               length arrays.  REPEAT is the number of BITS in the array.        
                repeat=estart+ntodo
                offset=nxheap(ibuff)
C               write the number of elements and the starting offset:
                call ftpdes(iunit,colnum,frow,repeat,
     &                              offset,status)
C               calc the i/o pointer location to start of sequence of pixels
                bstart=dtstrt(ibuff)+offset+
     &                          theap(ibuff)+estart
C               increment the empty heap starting address (in bytes):
                repeat=(repeat+7)/8
                nxheap(ibuff)=nxheap(ibuff)+repeat
        else
C               column must be byte or bit data type
                status=310
                return
        end if

C       move the i/o pointer to the start of the pixel sequence
        call ftmbyt(iunit,bstart,.true.,status)
        tstat=0

C       read the next byte (we may only be modifying some of the bits)
20      call ftgcbf(iunit,0,1,cbuff,status)
        if (status .eq. 107)then
C            hit end of file trying to read the byte, so just set byte = 0
             status=tstat
             cbuff=char(0)
        end if

        buffer=ichar(cbuff)
        if (buffer .lt. 0)buffer=buffer+256
C       move back, to be able to overwrite the byte
        call ftmbyt(iunit,bstart,.true.,status)

C       reset flags indicating which bits are to be set
        wrbit(1)=.false.
        wrbit(2)=.false.
        wrbit(3)=.false.
        wrbit(4)=.false.
        wrbit(5)=.false.
        wrbit(6)=.false.
        wrbit(7)=.false.
        wrbit(8)=.false.

C       flag the bits that are to be set 
        do 10 i=bitloc,8
                wrbit(i)=.true.
                ndone=ndone+1
                if(lray(ndone))then
                        setbit(i)=.true.
                else
                        setbit(i)=.false.
                end if
                if (ndone .eq. ntodo)go to 100
10      continue

C       set or reset the bits within the byte
        call ftpbit(setbit,wrbit,buffer)

C       write the new byte
        cbuff=char(buffer)
        call ftpcbf(iunit,0,1,cbuff,status)
        
C       not done, so get the next byte
        bstart=bstart+1
        if (.not. descrp)then
                estart=estart+1
                if (estart .eq. repeat)then
C                       move the i/o pointer to the next row of pixels
                        estart=0
                        rstart=rstart+1
                        bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &                         tbcol(colnum+tstart(ibuff))+estart
                        call ftmbyt(iunit,bstart,.true.,status)
                end if
        end if
        bitloc=1
        go to 20

100     continue
C       set or reset the bits within the byte
        call ftpbit(setbit,wrbit,buffer)

C       write the new byte
        cbuff=char(buffer)
        call ftpcbf(iunit,0,1,cbuff,status)
        end

      function	 gen(anoise)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1972 dec 15
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   generate numbers for construction of test cases.
      if (anoise) 10,30,20
   10 mi=891
      mj=457
      i=5
      j=7
      aj=0.
      gen=0.
      return
c
c     the sequence of values of j  is bounded between 1 and 996
c     if initial j = 1,2,3,4,5,6,7,8, or 9, the period is 332
   20 j=j*mj
      j=j-997*(j/997)
      aj=j-498
c     the sequence of values of i  is bounded between 1 and 999
c     if initial i = 1,2,3,6,7, or 9,  the period will be 50
c     if initial i = 4 or 8   the period will be 25
c     if initial i = 5	      the period will be 10
   30 i=i*mi
      i=i-1000*(i/1000)
      ai=i-500
      gen=ai+aj*anoise
      return
      end

      subroutine entdkw
      integer deft(2), prag(2)
      integer defnam(7)
      integer prgnam(7)
      data defnam(1)/100/,defnam(2)/101/,defnam(3)/102/,defnam(4)/105/,d
     *efnam(5)/110/,defnam(6)/101/,defnam(7)/-2/
      data prgnam(1)/112/,prgnam(2)/114/,prgnam(3)/97/,prgnam(4)/103/,pr
     *gnam(5)/109/,prgnam(6)/97/,prgnam(7)/-2/
      data deft (1), deft (2) /-4, -2/
      data prag (1), prag (2) /-17, -2/
      call ulstal (defnam, deft)
      call ulstal (prgnam, prag)
      return
      end

C----------------------------------------------------------------------
        subroutine ftcrhd(iunit,status)

C       'CReate Header Data unit'
C       create, initialize, and move the i/o pointer to a new extension at 
C       the end of the FITS file.

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1991

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff

        if (status .gt. 0)return

C       close the current HDU
        call ftchdu(iunit,status)
        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       check that we haven't exceeded the maximum allowed number of extensions
        if (maxhdu(ibuff)+1 .ge. ne)then
                status=301
                return
        end if

C       move to the end of the highest known extension
        call ftmbyt(iunit,hdstrt(ibuff,maxhdu(ibuff)+1),.true.,status)

C       initialize various parameters about the CHDU
        maxhdu(ibuff)=maxhdu(ibuff)+1
        chdu(ibuff)=maxhdu(ibuff)
        nxthdr(ibuff)=hdstrt(ibuff,chdu(ibuff))
C       the logical location of the END record at the start of the header
        hdend(ibuff)=nxthdr(ibuff)
C       the data start location is undefined
        dtstrt(ibuff)=-2000000000
        end

      SUBROUTINE slGASU (DL, DB, DSL, DSB)
*+
*     - - - - - - -
*      G A S U
*     - - - - - - -
*
*  Transformation from IAU 1958 galactic coordinates to
*  de Vaucouleurs supergalactic coordinates (double precision)
*
*  Given:
*     DL,DB       dp       galactic longitude and latitude L2,B2
*
*  Returned:
*     DSL,DSB     dp       supergalactic longitude and latitude
*
*  (all arguments are radians)
*
*  Called:
*     slDS2C, slDMXV, slDC2S, slDA2P, slDA1P
*
*  References:
*
*     de Vaucouleurs, de Vaucouleurs, & Corwin, Second Reference
*     Catalogue of Bright Galaxies, U. Texas, page 8.
*
*     Systems & Applied Sciences Corp., Documentation for the
*     machine-readable version of the above catalogue,
*     Contract NAS 5-26490.
*
*    (These two references give different values for the galactic
*     longitude of the supergalactic origin.  Both are wrong;  the
*     correct value is L2=137.37.)
*
*  P.T.Wallace   Starlink   25 January 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DL,DB,DSL,DSB

      DOUBLE PRECISION slDA2P,slDA1P

      DOUBLE PRECISION V1(3),V2(3)

*
*  System of supergalactic coordinates:
*
*    SGL   SGB        L2     B2      (deg)
*     -    +90      47.37  +6.32
*     0     0         -      0
*
*  Galactic to supergalactic rotation matrix:
*
      DOUBLE PRECISION RMAT(3,3)
      DATA RMAT(1,1),RMAT(1,2),RMAT(1,3),
     :     RMAT(2,1),RMAT(2,2),RMAT(2,3),
     :     RMAT(3,1),RMAT(3,2),RMAT(3,3)/
     : -0.735742574804D0,+0.677261296414D0,+0.000000000000D0,
     : -0.074553778365D0,-0.080991471307D0,+0.993922590400D0,
     : +0.673145302109D0,+0.731271165817D0,+0.110081262225D0/



*  Spherical to Cartesian
      CALL slDS2C(DL,DB,V1)

*  Galactic to supergalactic
      CALL slDMXV(RMAT,V1,V2)

*  Cartesian to spherical
      CALL slDC2S(V2,DSL,DSB)

*  Express in conventional ranges
      DSL=slDA2P(DSL)
      DSB=slDA1P(DSB)

      END

C--------------------------------------------------------------------------
        subroutine ftmkyf(ounit,keywrd,rval,decim,comm,status)

C       modify a real*4 value header record in F format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       rval    r  keyword value 
C       decim   i  number of decimal places to display in value field
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        real rval
        integer ounit,status,decim
        character value*20,cmnt*48

C       find the old keyword
        call ftgkey(ounit,keywrd,value,cmnt,status)

C       check for special symbol indicating that comment should not be changed
        if (comm .ne. '&')then
              cmnt=comm
        end if

C       convert real to F format character string
        call ftr2f(rval,decim,value,status)

C       write the keyword record
        call ftmkey(ounit,keywrd,value,cmnt,status)
        end

include	defs

# sctabl --- scan symbol table, returning next entry or EOF

   integer function sctabl (table, sym, info, posn)
   pointer table, posn
   character sym (ARB)
   integer info (ARB)

   DS_COMMON

   pointer bucket, walker
   pointer dsget

   integer nodsiz, i, j

   if (posn == 0) {		    # just starting scan?
      posn = dsget (2)		       # get space for position info
      Mem (posn) = 1		       # get index of first bucket
      Mem (posn + 1) = Mem (table + 1) # get pointer to first chain
      }

   bucket = Mem (posn)		    # recover previous position
   walker = Mem (posn + 1)
   nodsiz = Mem (table)

   repeat {    # until the next symbol, or none are left
      if (walker != LAMBDA) {	    # symbol available?
	 i = walker + ST_DATA + nodsiz
	 j = 1
	 while (Mem (i) != EOS) {
	    sym (j) = Mem (i)
	    i = i + 1
	    j = j + 1
	    }
	 sym (j) = EOS
	 for (i = 1; i <= nodsiz; i = i + 1) {
	    j = walker + ST_DATA + i - 1
	    info (i) = Mem (j)
	    }
	 Mem (posn) = bucket	    # save position of next symbol
	 Mem (posn + 1) = Mem (walker + ST_LINK)
	 sctabl = 1  # not EOF
	 return
	 }
      else {
	 bucket = bucket + 1
	 if (bucket > ST_HTABSIZE)
	    break
	 j = table + bucket
	 walker = Mem (j)
	 }
      }

   call dsfree (posn)	   # throw away position information
   posn = 0
   sctabl = EOF
   return
   end

      subroutine g2    (cos,sin,x,y)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1972 dec 15
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   apply the rotation computed by g1 to (x,y).
      xr=cos*x+sin*y
      y=-sin*x+cos*y
      x=xr
      return
      end

c BSWAP4 - Move bytes from array "a" to array "b", swapping the four bytes
c in each successive 4 byte group, i.e., 12345678 becomes 43218765.

	subroutine bswap4 (a, aoff, b, boff, nbytes)

	character*1 a(*), b(*), temp
	integer	aoff, boff, nbytes, i
	integer aoff1, boff1, aoff2, boff2, aoff3, boff3

		if (nbytes .le. 4) then
		    return
		endif

		aoff1 = aoff + 1
		boff1 = boff + 1
		aoff2 = aoff + 2
		boff2 = boff + 2
		aoff3 = aoff + 3
		boff3 = boff + 3

 		do 10 i = 0, nbytes-3, 4
		    temp = a(aoff1+i)
		    b(boff1+i) = a(aoff2+i)
		    b(boff2+i) = temp
		    temp = a(aoff3+i)
		    b(boff3+i) = a(aoff+i)
		    b(boff+i) = temp
 10		continue
	end

      subroutine eatup
      integer ptoken (100), t, token (100)
      integer gettok
      integer nlpar, equal
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer serror(6)
      data serror(1)/101/,serror(2)/114/,serror(3)/114/,serror(4)/111/,s
     *error(5)/114/,serror(6)/-2/
      nlpar = 0
      token(1) = -2
23000 continue
      call outstr (token)
      t = gettok (token, 100)
23001 if (.not.(t .ne. 32 .and. t .ne. 9))goto 23000
23002 continue
      if (.not.(t .eq. -9))goto 23003
      if (.not.(equal (token, serror) .eq. 1))goto 23005
      ername = 1
23005 continue
23003 continue
      goto 10
23007 continue
      t = gettok (token, 100)
10    if (.not.(t .eq. 59 .or. t .eq. 10))goto 23010
      goto 23009
23010 continue
      if (.not.(t .eq. 125 .or. t .eq. 123))goto 23012
      call pbstr (token)
      goto 23009
23012 continue
      if (.not.(t .eq. -1))goto 23014
      call synerr (15Hunexpected EOF.)
      call pbstr (token)
      goto 23009
23014 continue
      if (.not.(t .eq. 44 .or. t .eq. 43 .or. t .eq. 45 .or. t .eq. 42 .
     *or. (t .eq. 47 .and. body .eq. 1) .or. t .eq. 40 .or. t .eq. 38 .o
     *r. t .eq. 124 .or. t .eq. 33 .or. t .eq. 126 .or. t .eq. 126 .or. 
     *t .eq. 94 .or. t .eq. 61 .or. t .eq. 95))goto 23016
23018 if (.not.(gettok (ptoken, 100) .eq. 10))goto 23019
      goto 23018
23019 continue
      call pbstr (ptoken)
      if (.not.(t .eq. 95))goto 23020
      token (1) = -2
23020 continue
23016 continue
      if (.not.(t .eq. 40))goto 23022
      nlpar = nlpar + 1
      goto 23023
23022 continue
      if (.not.(t .eq. 41))goto 23024
      nlpar = nlpar - 1
23024 continue
23023 continue
      if (.not.(t .eq. -9))goto 23026
      call squash (token)
23026 continue
      call outstr (token)
23008 if (.not.(nlpar .lt. 0))goto 23007
23009 continue
      if (.not.(nlpar .ne. 0))goto 23028
      call synerr (23Hunbalanced parentheses.)
23028 continue
      return
      end
c     logic0  logical_column

      SUBROUTINE HAFTON (Z,L,M,N,FLO,HI,NLEV,NOPT,NPRM,ISPV,SPVAL)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C     SUBROUTINE HAFTON (Z,L,M,N,FLO,HI,NLEV,NOPT,NPRM,ISPV,SPVAL)
C
C
C     DIMENSION OF           Z(L,M)
C     ARGUMENTS
C
C     LATEST REVISION        JULY,1984
C
C     PURPOSE                HAFTON DRAWS A HALF-TONE PICTURE FROM DATA
C                            STORED IN A RECTANGULAR ARRAY WITH THE
C                            INTENSITY IN THE PICTURE PROPORTIONAL TO
C                            THE DATA VALUE.
C
C     USAGE                  IF THE FOLLOWING ASSUMPTIONS ARE MET, USE
C
C                                 CALL EZHFTN (Z,M,N)
C
C                              ASSUMPTIONS:
C                                  .ALL OF THE ARRAY IS TO BE DRAWN.
C                                  .LOWEST VALUE IN Z WILL BE AT LOWEST
C                                   INTENSITY ON READER/PRINTER OUTPUT.
C                                  .HIGHEST VALUE IN Z WILL BE AT
C                                   HIGHEST INTENSITY.
C                                  .VALUES IN BETWEEN WILL APPEAR
C                                   LINEARLY SPACED.
C                                  .MAXIMUM POSSIBLE NUMBER OF
C                                   INTENSITIES ARE USED.
C                                  .THE PICTURE WILL HAVE A PERIMETER
C                                   DRAWN.
C                                  .FRAME WILL BE CALLED AFTER THE
C                                   PICTURE IS DRAWN.
C                                  .Z IS FILLED WITH NUMBERS THAT SHOULD
C                                   BE USED (NO MISSING VALUES).
C
C                            IF THESE ASSUMPTIONS ARE NOT MET, USE
C
C                                 CALL HAFTON (Z,L,M,N,FLO,HI,NLEV,
C                                              NOPT,NPRM,ISPV,SPVAL)
C
C     ARGUMENTS
C
C     ON INPUT               Z
C     FOR EZHFTN               M BY N ARRAY TO BE USED TO GENERATE A
C                              HALF-TONE PLOT.
C
C                            M
C                              FIRST DIMENSION OF Z.
C
C                            N
C                              SECOND DIMENSION OF Z.
C
C     ON OUTPUT              ALL ARGUMENTS ARE UNCHANGED.
C     FOR EZHFTN
C
C     ON INPUT               Z
C     FOR HAFTON               THE ORIGIN OF THE ARRAY TO BE PLOTTED.
C
C                            L
C                              THE FIRST DIMENSION OF Z IN THE CALLING
C                              PROGRAM.
C
C                            M
C                              THE NUMBER OF DATA VALUES TO BE PLOTTED
C                              IN THE X-DIRECTION (THE FIRST SUBSCRIPT
C                              DIRECTION).  WHEN PLOTTING ALL OF AN
C                              ARRAY, L = M.
C
C                            N
C                              THE NUMBER OF DATA VALUES TO BE PLOTTED
C                              IN THE Y-DIRECTION (THE SECOND SUBSCRIPT
C                              DIRECTION).
C
C                            FLO
C                              THE VALUE OF Z THAT CORRESPONDS TO THE
C                              LOWEST INTENSITY.  (WHEN NOPT.LT.0, FLO
C                              CORRESPONDS TO THE HIGHEST INTENSITY.)
C                              IF FLO=HI=0.0, MIN(Z) WILL BE USED FOR FLO.
C
C                            HI
C                              THE VALUE OF Z THAT CORRESPONDS TO THE
C                              HIGHEST INTENSITY.  (WHEN NOPT.LT.0, HI
C                              CORRESPONDS TO THE LOWEST INTENSITY.)  IF
C                              HI=FLO=0.0, MAX(Z) WILL BE USED FOR HI.
C
C                            NLEV
C                              THE NUMBER OF INTENSITY LEVELS DESIRED.
C                              16 MAXIMUM.  IF NLEV = 0 OR 1, 16 LEVELS
C                              ARE USED.
C
C                            NOPT
C                              FLAG TO CONTROL THE MAPPING OF Z ONTO THE
C                              INTENSITIES.  THE SIGN OF NOPT CONTROLS
C                              THE DIRECTNESS OR INVERSENESS OF THE
C                              MAPPING.
C
C                              . NOPT POSITIVE YIELDS DIRECT MAPPING.
C                                THE LARGEST VALUE OF Z PRODUCES THE
C                                MOST DENSE DOTS.  ON MECHANICAL PLOTTERS,
C                                LARGE VALUES OF Z WILL PRODUCE A DARK
C                                AREA ON THE PAPER.  WITH THE FILM
C                                DEVELOPMENT METHODS USED AT NCAR,
C                                LARGE VALUES OF Z WILL PRODUCE MANY
C                                (WHITE) DOTS ON THE FILM, ALSO
C                                RESULTING IN A DARK AREA ON
C                                READER-PRINTER PAPER.
C                              . NOPT NEGATIVE YIELDS INVERSE MAPPING.
C                                THE SMALLEST VALUES OF Z PRODUCE THE
C                                MOST DENSE DOTS RESULTING IN DARK
C                                AREAS ON THE PAPER.
C
C                              THE ABSOLUTE VALUE OF NOPT DETERMINES THE
C                              MAPPING OF Z ONTO THE INTENSITIES.  FOR
C                              IABS(NOPT)
C                              = 0  THE MAPPING IS LINEAR.  FOR
C                                   EACH INTENSITY THERE IS AN EQUAL
C                                   RANGE IN Z VALUE.
C                              = 1  THE MAPPING IS LINEAR.  FOR
C                                   EACH INTENSITY THERE IS AN EQUAL
C                                   RANGE IN Z VALUE.
C                              = 2  THE MAPPING IS EXPONENTIAL.  FOR
C                                   LARGER VALUES OF Z, THERE IS A
C                                   LARGER DIFFERENCE IN INTENSITY FOR
C                                   RELATIVELY CLOSE VALUES OF Z.  DETAILS
C                                   IN THE LARGER VALUES OF Z ARE DISPLAYED
C                                   AT THE EXPENSE OF THE SMALLER VALUES
C                                   OF Z.
C                              = 3  THE MAPPING IS LOGRITHMIC, SO
C                                   DETAILS OF SMALLER VALUES OF Z ARE SHOWN
C                                   AT THE EXPENSE OF LARGER VALUES OF Z.
C                              = 4  SINUSOIDAL MAPPING, SO MID-RANGE VALUES
C                                   OF Z SHOW DETAILS AT THE EXPENSE OF
C                                   EXTREME VALUES OF Z.
C                              = 5  ARCSINE MAPPING, SO EXTREME VALUES OF
C                                   Z ARE SHOWN AT THE EXPENSE OF MID-RANGE
C                                   VALUES OF Z.
C
C                            NPRM
C                              FLAG TO CONTROL THE DRAWING OF A
C                              PERIMETER AROUND THE HALF-TONE PICTURE.
C
C                              . NPRM=0:  THE PERIMETER IS DRAWN WITH
C                                TICKS POINTING AT DATA LOCATIONS.
C                                (SIDE LENGTHS ARE PROPORTIONAL TO NUMBER
C                                OF DATA VALUES.)
C                              . NPRM POSITIVE:  NO PERIMETER IS DRAWN.  THE
C                                PICTURE FILLS THE FRAME.
C                              . NPRM NEGATIVE:  THE PICTURE IS WITHIN THE
C                                CONFINES OF THE USER'S CURRENT VIEWPORT
C                                SETTING.
C
C                            ISPV
C                              FLAG TO TELL IF THE SPECIAL VALUE FEATURE
C                              IS BEING USED.  THE SPECIAL VALUE FEATURE
C                              IS USED TO MARK AREAS WHERE THE DATA IS
C                              NOT KNOWN OR HOLES ARE WANTED IN THE
C                              PICTURE.
C
C                              . ISPV = 0:  SPECIAL VALUE FEATURE NOT IN
C                                USE.  SPVAL IS IGNORED.
C                              . ISPV NON-ZERO:  SPECIAL VALUE FEATURE
C                                IN USE.  SPVAL DEFINES THE SPECIAL
C                                VALUE.  WHERE Z CONTAINS THE SPECIAL
C                                VALUE, NO HALF-TONE IS DRAWN.  IF ISPV
C                                = 0  SPECIAL VALUE FEATURE NOT IN USE.
C                                     SPVAL IS IGNORED.
C                                = 1  NOTHING IS DRAWN IN SPECIAL VALUE
C                                     AREA.
C                                = 2  CONTIGUOUS SPECIAL VALUE AREAS ARE
C                                     SURROUNDED BY A POLYGONAL LINE.
C                                = 3  SPECIAL VALUE AREAS ARE FILLED
C                                     WITH X(S).
C                                = 4  SPECIAL VALUE AREAS ARE FILLED IN
C                                     WITH THE HIGHEST INTENSITY.
C
C                            SPVAL
C                              THE VALUE USED IN Z TO DENOTE MISSING
C                              VALUES.  THIS ARGUMENT IS IGNORED IF
C                              ISPV = 0.
C
C     ON OUTPUT              ALL ARGUMENTS ARE UNCHANGED.
C     FOR HAFTON
C
C     NOTE                   THIS ROUTINE PRODUCES A HUGE NUMBER OF
C                            PLOTTER INSTRUCTIONS PER PICTURE, AVERAGING
C                            OVER 100,000 LINE-DRAWS PER FRAME WHEN M = N.
C
C
C     ENTRY POINTS           EZHFTN, HAFTON, ZLSET, GRAY, BOUND, HFINIT
C
C     COMMON BLOCKS          HAFT01, HAFT02, HAFT03, HAFT04
C
C     REQUIRED LIBRARY       GRIDAL, THE ERPRT77 PACKAGE AND THE SPPS.
C     ROUTINES
C
C     I/O                    PLOTS HALF-TONE PICTURE.
C
C     PRECISION              SINGLE
C
C     LANGUAGE               FORTRAN
C
C     HISTORY                REWRITE OF PHOMAP ORIGINALLY WRITTEN BY
C                            M. PERRY OF HIGH ALTITUDE OBSERVATORY,
C                            NCAR.
C
C     ALGORITHM              BI-LINEAR INTERPOLATION ON PLOTTER
C                            (RESOLUTION-LIMITED) GRID OF NORMALIZED
C                            REPRESENTATION OF DATA.
C
C     PORTABILITY            ANSI FORTRAN 77.
C
C
C
C INTERNAL PARAMTERSS
C VALUES SET IN BLOCK DATA
C         NAME  DEFAULT                   FUNCTION
C         ----  -------                   ________
C
C         XLT     0.1    LEFT-HAND EDGE OF THE PLOT WHEN NSET=0.  (0.0=
C                        LEFT EDGE OF FRAME, 1.0=RIGHT EDGE OF FRAME.)
C         YBT     0.1    BOTTOM EDGE OF THE PLOT WHEN NSET=0.  (0.0=
C                        BOTTOM OF FRAME, 1.0=TOP OF FRAME.)
C         SIDE    0.8    LENGTH OF LONGER EDGE OF PLOT (SEE ALSO EXT).
C         EXT     .25    LENGTHS OF THE SIDES OF THE PLOT ARE PROPOR-
C                        TIONAL TO M AND N (WHEN NSET=0) EXCEPT IN
C                        EXTREME CASES, NAMELY, WHEN MIN(M,N)/MAX(M,N)
C                        IS LESS THAN EXT.  THEN A SQUARE PLOT IS PRO-
C                        DUCED.  WHEN A RECTANGULAR PLOT IS PRODUCED,
C                        THE PLOT IS CENTERED ON THE FRAME (AS LONG AS
C                        SIDE+2*XLT = SIDE+2*YBT=1., AS WITH THE
C                        DEFAULTS.)
C         ALPHA   1.6    A PARAMETER TO CONTROL THE EXTREMENESS OF THE
C                        MAPPING FUNCTION SPECIFIED BY NOPT.  (FOR
C                        IABS(NOPT)=0 OR 1, THE MAPPING FUNCTION IS
C                        LINEAR AND INDEPENDENT OF ALPHA.)  FOR THE NON-
C                        LINEAR MAPPING FUNCTIONS, WHEN ALPHA IS CHANGED
C                        TO A NUMBER CLOSER TO 1., THE MAPPING FUNCTION
C                        BECOMES MORE LINEAR; WHEN ALPHA IS CHANGED TO
C                        A LARGER NUMBER, THE MAPPING FUNCTION BECOMES
C                        MORE EXTREME.
C         MXLEV   16     MAXIMUM NUMBER OF LEVELS.  LIMITED BY PLOTTER.
C         NCRTG   8      NUMBER OF CRT UNITS PER GRAY-SCALE CELL.
C                        LIMITED BY PLOTTER.
C         NCRTF   1024   NUMBER OF PLOTTER ADDRESS UNITS PER FRAME.
C         IL    (BELOW)  AN ARRAY DEFINING WHICH OF THE AVAILABLE IN-
C                        TENSITIES ARE USED WHEN LESS THAN THE MAXIMUM
C                        NUMBER OF INTENSITIES ARE REQUESTED.
C
C
C   NLEV         INTENSITIES USED
C   ____         ________________
C    2           5,11,
C    3           4, 8,12,
C    4           3, 6,10,13,
C    5           2, 5, 8,11,14,
C    6           1, 4, 7, 9,12,15,
C    7           1, 4, 6, 8,10,12,15,
C    8           1, 3, 5, 7, 9,11,13,15,
C    9           1, 3, 4, 6, 8,10,12,13,15
C   10           1, 3, 4, 6, 7, 9,10,12,13,15,
C   11           1, 2, 3, 5, 6, 8,10,11,13,14,15,
C   12           1, 2, 3, 5, 6, 7, 9,10,11,13,14,15,
C   13           1, 2, 3, 4, 6, 7, 8, 9,10,12,13,14,15
C   14           1, 2, 3, 4, 5, 6, 7, 9,10,11,12,13,14,15,
C   15           1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
C   16           0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
C
C

      SAVE
      DIMENSION       Z(L,N)      ,PX(2)       ,PY(2)
      DIMENSION       ZLEV(16)    ,VWPRT(4)    ,WNDW(4)
      DIMENSION                    VWPR2(4)    ,WND2(4)
      CHARACTER*11    IDUMMY
C
C
      COMMON /HAFTO1/ I          ,J          ,INTEN
      COMMON /HAFTO2/ GLO        ,HA         ,NOPTN      ,ALPHA      ,
     1                NSPV       ,SP         ,ICNST
      COMMON /HAFTO3/ XLT        ,YBT        ,SIDE       ,EXT        ,
     1                IOFFM      ,ALPH       ,MXLEV      ,NCRTG      ,
     2                NCRTF      ,IL(135)
      COMMON /HAFTO4/ NPTMAX     ,NPOINT     ,XPNT(50)  ,YPNT(50)
C +NOAO - Blockdata rewritten as run time initialization subroutine
C
C     EXTERNAL HFINIT
      call hfinit
C -NOAO
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','HAFTON','HAFTON','VERSION  1')
C
      NPOINT = 0
      ALPHA = ALPH
      GLO = FLO
      HA = HI
      NLEVL = MIN0(IABS(NLEV),MXLEV)
      IF (NLEVL .LE. 1) NLEVL = MXLEV
      NOPTN = NOPT
      IF (NOPTN .EQ. 0) NOPTN = 1
      NPRIM = NPRM
      NSPV = MAX0(MIN0(ISPV,4),0)
      IF (NSPV .NE. 0) SP = SPVAL
      MX = L
      NX = M
      NY = N
      CRTF = NCRTF
      MSPV = 0
C
C SET INTENSITY BOUNDARY LEVELS
C
      CALL ZLSET (Z,MX,NX,NY,ZLEV,NLEVL)
C
C SET UP PERIMETER
C
      X3 = NX
      Y3 = NY
      CALL GQCNTN (IERR,NTORIG)
      CALL GETUSV('LS',IOLLS)
      IF (NPRIM.LT.0) THEN
         CALL GQNT (NTORIG,IERR,WNDW,VWPRT)
         X1 = VWPRT(1)
         X2 = VWPRT(2)
         Y1 = VWPRT(3)
         Y2 = VWPRT(4)
      ELSE IF (NPRIM.EQ.0) THEN
         X1 = XLT
         X2 = XLT+SIDE
         Y1 = YBT
         Y2 = YBT+SIDE
         IF (AMIN1(X3,Y3)/AMAX1(X3,Y3) .GE. EXT) THEN
            IF (NX-NY.LT.0) THEN
               X2 =SIDE*X3/Y3+XLT
               X2 = (AINT(X2*CRTF/FLOAT(NCRTG))*FLOAT(NCRTG))/CRTF
            ELSE IF (NX-NY.GT.0) THEN
               Y2 = SIDE*Y3/X3+YBT
               Y2 = (AINT(Y2*CRTF/FLOAT(NCRTG))*FLOAT(NCRTG))/CRTF
            END IF
         END IF
      ELSE IF (NPRIM.GT.0) THEN
         X1 = 0.0
         X2 = 1.0
         Y1 = 0.0
         Y2 = 1.0
      END IF
      MX1 = X1*CRTF
      MX2 = X2*CRTF
      MY1 = Y1*CRTF
      MY2 = Y2*CRTF
      IF (NPRIM.GT.0) THEN
         MX1 = 1
         MY1 = 1
         MX2 = NCRTF
         MY2 = NCRTF
      END IF
C
C SAVE NORMALIZATION TRANS 1
C
      CALL GQNT (1,IERR,WNDW,VWPRT)
C
C DEFINE NORMALIZATION TRANS 1 AND LOG SCALING FOR USE WITH PERIM
C DRAW PERIMETER IF NPRIM EQUALS 0
C
      CALL SET(X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
      IF (NPRIM .EQ. 0) CALL PERIM (NX-1,1,NY-1,1)
      IF (ICNST .NE. 0) THEN
        CALL GSELNT (0)
        CALL WTSTR(XLT*1.1,0.5,'CONSTANT FIELD',2,0,0)
        GO TO 132
      END IF
C
C FIND OFFSET FOR REFERENCE TO IL, WHICH IS TRIANGULAR
C
      IOFFST = NLEVL*((NLEVL-1)/2)+MOD(NLEVL-1,2)*(NLEVL/2)-1
C
C OUTPUT INTENSITY SCALE
C
      IF (NPRIM .GT. 0) GO TO 112
      LEV = 0
      KX = (1.1*XLT+SIDE)*CRTF
      KY = YBT*CRTF
      NNX = KX/NCRTG
  109 LEV = LEV+1
C +NOAO
C The following statement moved from after statement label 111 (CONTINUE) to
C here.  Otherwise an extra (unlabelled) grayscale box was being drawn.
C This was (eventually) causing a [floating operand error] on a Sun-3.
      IF (LEV .GT. NLEVL) GO TO 112
C -NOAO
      ISUB = IOFFST+LEV
      INTEN = IL(ISUB)
      IF (NOPTN .LT. 0) INTEN = MXLEV-INTEN
      NNY = KY/NCRTG
      DO 111 JJ=1,3
         DO 110 II=1,10
            I = NNX+II
            J = NNY+JJ
            CALL GRAY
  110    CONTINUE
  111 CONTINUE
C +NOAO - FTN internal write rewritten as call to encode.
C       WRITE(IDUMMY,'(G11.4)') ZLEV(LEV)
	call encode (11, '(g11.4)', idummy, zlev(lev))
C -NOAO
      TKX = KX
      TKY = KY+38
      CALL GQNT(1,IERR,WND2,VWPR2)
      CALL SET(0.,1.,0.,1.,0.,1023.,0.,1023.,1)
      CALL WTSTR (TKX,TKY,IDUMMY,0,0,-1)
      CALL SET(VWPR2(1),VWPR2(2),VWPR2(3),VWPR2(4),
     -         WND2(1),WND2(2),WND2(3),WND2(4),1)
C
C ADJUST 38 TO PLOTTER.
C
      KY = KY+52
C
C ADJUST 52 TO PLOTTER.
C
      GO TO 109
C
C STEP THROUGH PLOTTER GRID OF INTENSITY CELLS.
C
  112 IMIN = (MX1-1)/NCRTG+1
      IMAX = (MX2-1)/NCRTG
      JMIN = (MY1-1)/NCRTG+1
      JMAX = (MY2-1)/NCRTG
      XL = IMAX-IMIN+1
      YL = JMAX-JMIN+1
      XN = NX
      YN = NY
      LSRT = NLEVL/2
      DO 130 J=JMIN,JMAX
C
C FIND Y FOR THIS J AND Z FOR THIS Y.
C
       YJ = (FLOAT(J-JMIN)+.5)/YL*(YN-1.)+1.
         LOWY = YJ
         YPART = YJ-FLOAT(LOWY)
         IF (LOWY .NE. NY) GO TO 113
         LOWY = LOWY-1
         YPART = 1.
  113    IPEN = 0
         ZLFT = Z(1,LOWY)+YPART*(Z(1,LOWY+1)-Z(1,LOWY))
         ZRHT = Z(2,LOWY)+YPART*(Z(2,LOWY+1)-Z(2,LOWY))
         IF (NSPV .EQ. 0) GO TO 114
         IF (Z(1,LOWY).EQ.SP .OR. Z(2,LOWY).EQ.SP .OR.
     1       Z(1,LOWY+1).EQ.SP .OR. Z(2,LOWY+1).EQ.SP) IPEN = 1
  114    IF (IPEN .EQ. 1) GO TO 117
C
C FIND INT FOR THIS Z.
C
         IF (ZLFT .GT. ZLEV(LSRT+1)) GO TO 116
  115    IF (ZLFT .GE. ZLEV(LSRT)) GO TO 117
C
C LOOK LOWER
C
         IF (LSRT .LE. 1) GO TO 117
         LSRT = LSRT-1
         GO TO 115
C
C LOOK HIGHER
C
  116    IF (LSRT .GE. NLEVL) GO TO 117
         LSRT = LSRT+1
         IF (ZLFT .GT. ZLEV(LSRT+1)) GO TO 116
C
C OK
C
  117    IRHT = 2
         LAST = LSRT
         DO 129 I=IMIN,IMAX
C
C FIND X FOR THIS I AND Z FOR THIS X AND Y.
C
            IADD = 1
            XI = (FLOAT(I-IMIN)+.5)/XL*(XN-1.)+1.
            LOWX = XI
            XPART = XI-FLOAT(LOWX)
            IF (LOWX .NE. NX) GO TO 118
            LOWX = LOWX-1
            XPART = 1.
C
C TEST FOR INTERPOLATION POSITIONING
C
  118       IF (LOWX .LT. IRHT) GO TO 119
C
C MOVE INTERPOLATION ONE CELL TO THE RIGHT
C
            ZLFT = ZRHT
            IRHT = IRHT+1
            ZRHT = Z(IRHT,LOWY)+YPART*(Z(IRHT,LOWY+1)-Z(IRHT,LOWY))
            IF (NSPV .EQ. 0) GO TO 118
            IPEN = 0
            IF (Z(IRHT-1,LOWY).EQ.SP .OR. Z(IRHT,LOWY).EQ.SP .OR.
     1          Z(IRHT-1,LOWY+1).EQ.SP .OR. Z(IRHT,LOWY+1).EQ.SP)
     2          IPEN = 1
            GO TO 118
  119       IF (IPEN .NE. 1) GO TO 123
C
C SPECIAL VALUE AREA
C
            GO TO (129,120,121,122),NSPV
  120       MSPV = 1
            GO TO 129
  121       PX(1) = I*NCRTG
            PY(1) = J*NCRTG
            PX(2) = PX(1)+NCRTG-1
            PY(2) = PY(1)+NCRTG-1
            CALL GPL (2,PX,PY)
            PYTMP = PY(1)
            PY(1) = PY(2)
            PY(2) = PYTMP
            CALL GPL (2,PX,PY)
C
            GO TO 129
  122       INTEN = MXLEV
            GO TO 128
  123       ZZ = ZLFT+XPART*(ZRHT-ZLFT)
C
C TEST FOR SAME INT AS LAST TIME.
C
            IF (ZZ .GT. ZLEV(LAST+1)) GO TO 126
  124       IF (ZZ .GE. ZLEV(LAST)) GO TO 127
C
C LOOK LOWER
C
            IF (LAST .LE. 1) GO TO 125
            LAST = LAST-1
            GO TO 124
  125       IF (ZZ .LT. ZLEV(LAST)) IADD = 0
            GO TO 127
C
C LOOK HIGHER
C
  126       IF (LAST .GE. NLEVL) GO TO 127
            LAST = LAST+1
            IF (ZZ .GE. ZLEV(LAST+1)) GO TO 126
C
C OK
C
  127       ISUB = LAST+IOFFST+IADD
            INTEN = IL(ISUB)
            IF (NOPTN .LT. 0) INTEN = MXLEV-INTEN
  128       CALL GRAY
  129    CONTINUE
  130 CONTINUE
C
C PUT OUT ANY REMAINING BUFFERED POINTS.
C
      IF (NPOINT.GT.0) THEN
         CALL GQNT(1,IERR,WND2,VWPR2)
         CALL SET(0.,1.,0.,1.,0.,1023.,0.,1023.,1)
         CALL POINTS(XPNT,YPNT,NPOINT,0,0)
         CALL SET(VWPR2(1),VWPR2(2),VWPR2(3),VWPR2(4),
     -            WND2(1),WND2(2),WND2(3),WND2(4),1)
      ENDIF
C
C CALL BOUND IF ISPV=2 AND SPECIAL VALUES WERE FOUND.
C
      IF (MSPV .EQ. 1) THEN
        CALL SET(X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
        CALL BOUND (Z,MX,NX,NY,SP)
      END IF
  132 CONTINUE
C
C RESTORE NORMALIZATION TRANS 1 AND ORIGINAL NORMALIZATION NUMBER
C
      CALL SET(VWPRT(1),VWPRT(2),VWPRT(3),VWPRT(4),
     -         WNDW(1),WNDW(2),WNDW(3),WNDW(4),IOLLS)
      CALL SETUSV('LS',IOLLS)
      CALL GSELNT (NTORIG)
      RETURN
C
      END
      SUBROUTINE ZLSET (Z,MX,NX,NY,ZL,NLEVL)
      SAVE
C
      DIMENSION       Z(MX,NY)   ,ZL(NLEVL)
C
      COMMON /HAFTO2/ GLO        ,HA         ,NOPTN      ,ALPHA      ,
     1                NSPV       ,SP         ,ICNST
C
      BIG = R1MACH(2)
C
C ZLSET PUTS THE INTENSITY LEVEL BREAK POINTS IN ZL.
C ALL ARGUMENTS ARE AS IN HAFTON.
C
      LX = NX
      LY = NY
      NLEV = NLEVL
      NOPT = IABS(NOPTN)
      RALPH = 1./ALPHA
      ICNST = 0
      IF (GLO.NE.0. .OR. HA.NE.0.) GO TO 106
C
C FIND RANGE IF NOT KNOWN.
C
      GLO = BIG
      HA = -GLO
      IF (NSPV .NE. 0) GO TO 103
      DO 102 J=1,LY
         DO 101 I=1,LX
            ZZ = Z(I,J)
            GLO = AMIN1(ZZ,GLO)
            HA = AMAX1(ZZ,HA)
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 J=1,LY
         DO 104 I=1,LX
            ZZ = Z(I,J)
            IF (ZZ .EQ. SP) GO TO 104
            GLO = AMIN1(ZZ,GLO)
            HA = AMAX1(ZZ,HA)
  104    CONTINUE
  105 CONTINUE
C
C FILL ZL
C
  106 DELZ = HA-GLO
      IF (DELZ .EQ. 0.) GO TO 115
      DZ = DELZ/FLOAT(NLEV)
      NLEVM1 = NLEV-1
      DO 114 K=1,NLEVM1
         ZNORM = FLOAT(K)/FLOAT(NLEV)
         GO TO (107,108,109,110,111),NOPT
C
C NOPT=1
C
  107    ZL(K) = GLO+FLOAT(K)*DZ
         GO TO 114
C
C NOPT=2
C
  108    ONORM = (1.-(1.-ZNORM)**ALPHA)**RALPH
         GO TO 113
C
C NOPT=3
C
  109    ONORM = 1.-(1.-ZNORM**ALPHA)**RALPH
         GO TO 113
C
C NOPT=4
C
  110    ONORM = .5*(1.-(ABS(ZNORM+ZNORM-1.))**ALPHA)**RALPH
         GO TO 112
C
C NOPT=5
C
  111    ZNORM2 = ZNORM+ZNORM
         IF (ZNORM .GT. .5) ZNORM2 = 2.-ZNORM2
         ONORM = .5*(1.-(1.-ABS(ZNORM2)**ALPHA)**RALPH)
  112    IF (ZNORM .GT. .5) ONORM = 1.-ONORM
  113    ZL(K) = GLO+DELZ*ONORM
  114 CONTINUE
      ZL(NLEV) = BIG
      RETURN
  115 ICNST = 1
      RETURN
      END
      SUBROUTINE GRAY
C
C SUBROUTINE GRAY COLORS HALF-TONE CELL (I,J) WITH INTENSITY INTEN.
C THE ROUTINE ASSUMES 8X8 CELL SIZE ON A VIRTUAL SCREEN 1024X1024.
C
      DIMENSION       IFOT(16)   ,JFOT(16)
      DIMENSION       WNDW(4)    ,VWPRT(4)
CCC      DIMENSION       MX(16)  ,MY(16)
      COMMON /HAFTO1/ I          ,J          ,INTEN
      COMMON /HAFTO4/ NPTMAX     ,NPOINT     ,XPNT(50)  ,YPNT(50)
      SAVE
C
      DATA
     1 IFOT(1),IFOT(2),IFOT(3),IFOT(4),IFOT(5),IFOT(6),IFOT(7),IFOT(8)/
     2   1,      5,      1,      5,      3,      7,      3,      7   /
      DATA
     1 IFOT(9),IFOT(10),IFOT(11),IFOT(12),IFOT(13),IFOT(14),IFOT(15)/
     2   3,      7,       3,       7,       1,       5,       1/,
     3 IFOT(16)/
     4   5    /
C
      DATA
     1 JFOT(1),JFOT(2),JFOT(3),JFOT(4),JFOT(5),JFOT(6),JFOT(7),JFOT(8)/
     2   1,      5,      5,      1,      3,     7,      7,      3   /
      DATA
     1 JFOT(9),JFOT(10),JFOT(11),JFOT(12),JFOT(13),JFOT(14),JFOT(15)/
     2   1,      5,       5,       1,       3,       7,       7/,
     3 JFOT(16)/
     4   3    /
C
      IF (INTEN) 103,103,101
  101 I1 = I*8
      J1 = J*8
      IF ((NPOINT+INTEN) .LE.NPTMAX)  GO TO 1015
      CALL GQNT(1,IERR,WNDW,VWPRT)
      CALL SET(0.,1.,0.,1.,0.,1023.,0.,1023.,1)
      CALL POINTS(XPNT,YPNT,NPOINT,0,0)
      CALL SET(VWPRT(1),VWPRT(2),VWPRT(3),VWPRT(4),
     -         WNDW(1),WNDW(2),WNDW(3),WNDW(4),1)
      NPOINT = 0
 1015 DO 102 I2=1,INTEN
      NPOINT = NPOINT + 1
      XPNT(NPOINT) = I1+IFOT(I2)
      YPNT(NPOINT) = J1+JFOT(I2)
  102 CONTINUE
  103 RETURN
      END
      SUBROUTINE BOUND (Z,MX,NNX,NNY,SSP)
      DIMENSION       Z(MX,NNY)   ,PX(2)   ,PY(2)
C
C BOUND DRAWS A POLYGONAL BOUNDRY AROUND ANY SPECIAL-VALUE AREAS IN Z.
C
      SAVE
      NX = NNX
      NY = NNY
C
C VERTICAL LINES
C
      SP = SSP
      DO 103 IP1=3,NX
         I = IP1-1
         PX(1) = I
         PX(2) = I
         IM1 = I-1
         DO 102 JP1=2,NY
            PY(2) = JP1
            J = JP1-1
            PY(1) = J
            KLEFT = 0
            IF (Z(IM1,J).EQ.SP .OR. Z(IM1,JP1).EQ.SP) KLEFT = 1
            KCENT = 0
            IF (Z(I,J).EQ.SP .OR. Z(I,JP1).EQ.SP) KCENT = 1
            KRIGT = 0
            IF (Z(IP1,J).EQ.SP .OR. Z(IP1,JP1).EQ.SP) KRIGT = 1
            JUMP = KLEFT*4+KCENT*2+KRIGT+1
            GO TO (102,101,102,102,101,102,102,102,102),JUMP
  101       CALL GPL (2,PX,PY)
  102    CONTINUE
  103 CONTINUE
C
C HORIZONTAL
C
      DO 106 JP1=3,NY
         J = JP1-1
         PY(1) = J
         PY(2) = J
         JM1 = J-1
         DO 105 IP1=2,NX
            PX(2) = IP1
            I = IP1-1
            PX(1) = I
            KLOWR = 0
            IF (Z(I,JM1).EQ.SP .OR. Z(IP1,JM1).EQ.SP) KLOWR = 1
            KCENT = 0
            IF (Z(I,J).EQ.SP .OR. Z(IP1,J).EQ.SP) KCENT = 1
            KUPER = 0
            IF (Z(I,JP1).EQ.SP .OR. Z(IP1,JP1).EQ.SP) KUPER = 1
            JUMP = KLOWR*4+KCENT*2+KUPER+1
            GO TO (105,104,105,105,104,105,105,105,105),JUMP
  104       CALL GPL (2,PX,PY)
  105    CONTINUE
  106 CONTINUE
      RETURN
      END
      SUBROUTINE EZHFTN (Z,M,N)
C
      DIMENSION       Z(M,N)
      SAVE
C
C HALF-TONE PICTURE VIA SHORTEST ARGUMENT LIST.
C ASSUMPTIONS--
C     ALL OF THE ARRAY IS TO BE DRAWN,
C     LOWEST VALUE IN Z WILL BE AT LOWEST INTENSITY ON READER/PRINTER
C     OUTPUT, HIGHEST VALUE IN Z WILL BE AT HIGHEST INTENSITY, VALUES IN
C     BETWEEN WILL APPEAR LINEARLY SPACED, MAXIMUM POSSIBLE NUMBER OF
C     INTENSITIES ARE USED, THE PICTURE WILL HAVE A PERIMETER DRAWN,
C     FRAME WILL BE CALLED AFTER THE PICTURE IS DRAWN, Z IS FILLED WITH
C     NUMBERS THAT SHOULD BE USED (NO UNKNOWN VALUES).
C IF THESE CONDITIONS ARE NOT MET, USE HAFTON.
C EZHFTN ARGUMENTS--
C     Z   2 DIMENSIONAL ARRAY TO BE USED TO GENERATE A HALF-TONE PLOT.
C     M   FIRST DIMENSION OF Z.
C     N   SECOND DIMENSION OF Z.
C
      DATA FLO,HI,NLEV,NOPT,NPRM,ISPV,SPV/0.0,0.0,0,0,0,0,0.0/
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','HAFTON','EZHFTN','VERSION  1')
C
      CALL HAFTON (Z,M,M,N,FLO,HI,NLEV,NOPT,NPRM,ISPV,SPV)
C
C +NOAO - EZHFTN no longer calls frame.
C     CALL FRAME
C -NOAO
      RETURN
      END
C
C-----------------------------------------------------------------------
C
C REVISION HISTORY---
C
C JULY     1984    CONVERTED TO FORTAN 77 AND GKS
C
C MARCH    1983    INSTITUTED BUFFERING OF POINTS WITHIN ROUTINE GRAY,
C                  WHICH DRAMATICALLY REDUCES SIZE OF OUTPUT PLOT CODE,
C                  METACODE.  THIS IN TURN GENERALLY IMPROVES THROUGHPUT
C                  OF METACODE INTERPRETERS.
C
C FEBRUARY 1979    MODIFIED CODE TO CONFORM TO FORTRAN 66 STANDARD
C
C JANUARY  1978    DELETED REFERENCES TO THE  *COSY  CARDS AND
C                  ADDED REVISION HISTORY
C
C-----------------------------------------------------------------------
C

      REAL FUNCTION slSEPV (V1, V2)
*+
*     - - - - -
*      S E P V
*     - - - - -
*
*  Angle between two vectors.
*
*  (single precision)
*
*  Given:
*     V1      r(3)    first vector
*     V2      r(3)    second vector
*
*  The result is the angle, in radians, between the two vectors.  It
*  is always positive.
*
*  Notes:
*
*  1  There is no requirement for the vectors to be unit length.
*
*  2  If either vector is null, zero is returned.
*
*  3  The simplest formulation would use dot product alone.  However,
*     this would reduce the accuracy for angles near zero and pi.  The
*     algorithm uses both cross product and dot product, which maintains
*     accuracy for all sizes of angle.
*
*  Called:  slDSEPV
*
*  Last revision:   7 May 2000
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL V1(3),V2(3)

      INTEGER I
      DOUBLE PRECISION DV1(3),DV2(3)
      DOUBLE PRECISION slDSEPV



*  Use double precision version.
      DO I=1,3
         DV1(I) = DBLE(V1(I))
         DV2(I) = DBLE(V2(I))
      END DO
      slSEPV = REAL(slDSEPV(DV1,DV2))

      END

C--------------------------------------------------------------------------
        subroutine ftmkyd(ounit,keywrd,dval,decim,comm,status)

C       modify a double precision value header record in E format
C       If it will fit, the value field will be 20 characters wide;
C       otherwise it will be expanded to up to 35 characters, left
C       justified.
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       dval    d  keyword value 
C       decim   i  number of decimal places to display in value field
C       comm    c  keyword comment (max. 47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        double precision dval
        integer ounit,status,decim,vlen
        character value*35,key*8,cmnt*48

C       find the old keyword
        call ftgkey(ounit,keywrd,value,cmnt,status)

        key=keywrd
C       check for special symbol indicating that comment should not be changed
        if (comm .ne. '&')then
              cmnt=comm
        end if

C       convert double precision to E format character string
        call ftd2e(dval,decim,value,vlen,status)

C       write the keyword record
        call ftmodr(ounit,key//'= '//value(1:vlen)//' / '//cmnt,status)
        end

include	defs

# dsdump --- produce semi-readable dump of storage

   subroutine dsdump (form)
   character form

   DS_COMMON

   pointer p, t, q

   t = DS_AVAIL

   call remark ("** DYNAMIC STORAGE DUMP **.")
   call putint (1, 5, ERROUT)
   call putch (BLANK, ERROUT)
   call putint (DS_OHEAD + 1, 0, ERROUT)
   call remark (" words in use.")

   p = Mem (t + DS_LINK)
   while (p != LAMBDA) {
      call putint (p, 5, ERROUT)
      call putch (BLANK, ERROUT)
      call putint (Mem (p + DS_SIZE), 0, ERROUT)
      call remark (" words available.")
      q = p + Mem (p + DS_SIZE)
      while (q != Mem (p + DS_LINK) & q < Mem (DS_MEMEND))
	 call dsdbiu (q, form)
      p = Mem (p + DS_LINK)
      }

   call remark ("** END DUMP **.")
   return
   end

#-h-  ludef			  495  local   12/01/80  15:54:29
# ludef --- look up a defined identifier, return its definition
   include  defs

   integer function ludef (id, defn, table)
   character id (ARB), defn (ARB)
   pointer table

   include COMMON_BLOCKS

   integer i
   integer lookup

   pointer locn

   ludef = lookup (id, locn, table)
   if (ludef == YES) {
      i = 1
      for (; mem (locn) != EOS; locn = locn + 1) {
	 defn (i) = mem (locn)
	 i = i + 1
	 }
      defn (i) = EOS
      }
   else
      defn (1) = EOS

   return
   end

include	defs

# wkday --- get day-of-week corresponding to month,day,year

   integer function wkday (month, day, year)
   integer month, day, year

   integer lmonth, lday, lyear

   lmonth = month - 2
   lday = day
   lyear = year

   if (lmonth <= 0) {
      lmonth = lmonth + 12
      lyear = lyear - 1
      }

   wkday = mod (lday + (26 * lmonth - 2) / 10 + lyear + lyear / 4 - 34,
       7) + 1

   return
   end

include  defs

# entfkw - place Fortran keywords in symbol table.
# Place in the following table any long (> 6 characters)
# keyword that is used by your Fortran compiler:


subroutine entfkw

include COMMON_BLOCKS
string sequiv "equivalence"

	call enter (sequiv, 0, fkwtbl)
end

#-h-  fors			  458  local   12/01/80  15:54:08
# fors - process end of for statement
   include  defs

   subroutine fors (lab)
   integer lab

   include COMMON_BLOCKS

   integer i, j
   integer length

   xfer = NO
   call outnum (lab)
   j = 1
   for (i = 1; i < fordep; i = i + 1)
      j = j + length (forstk (j)) + 1
   if (length (forstk (j)) > 0) {
      call outtab
      call outstr (forstk (j))
      call outdon
      }
   call outgo (lab - 1)
   call indent (-1)
   call outcon (lab + 1)
   fordep = fordep - 1
   ername = NO
   return
   end

      subroutine outstr (str)
      integer str (100)
      integer c
      integer i, j
      i = 1
23000 if (.not.(str (i) .ne. -2))goto 23002
      c = str (i)
      if (.not.(c .ne. 39 .and. c .ne. 34))goto 23003
      call outch (c)
      goto 23004
23003 continue
      i = i + 1
      j = i
23005 if (.not.(str (j) .ne. c))goto 23007
23006 j = j + 1
      goto 23005
23007 continue
      call outnum (j - i)
      call outch (72)
23008 if (.not.(i .lt. j))goto 23010
      call outch (str (i))
23009 i = i + 1
      goto 23008
23010 continue
23004 continue
23001 i = i + 1
      goto 23000
23002 continue
      return
      end

C--------------------------------------------------------------------------
        subroutine ftgclm(iunit,colnum,frow,felem,nelem,eincr,
     &   nultyp,nulval,array,flgval,anynul,status)

C       read an array of double complex data values from the specified 
C       column of the table.  
C       This general purpose routine will handle null values in one
C       of two ways: if nultyp=1, then undefined array elements will be
C       set equal to the input value of NULVAL.  Else if nultyp=2, then
C       undefined array elements will have the corresponding FLGVAL element
C       set equal to .TRUE.  If NULTYP=1 and NULVAL=0, then no checks for
C       undefined values will be made, for maximum efficiency.
C       The binary table column being read to must have datatype 'M'
C       and no datatype conversion will be perform if it is not.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read from
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of (pairs) elements to read
C       eincr   i  element increment
C       nultyp  i  input code indicating how to handle undefined values
C       nulval  d  value that undefined pixels will be set to (if nultyp=1)
C       array   d  array of data values that are read from the FITS file
C       flgval  l  set .true. if corresponding element undefined (if nultyp=2)
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,eincr,nultyp,status
        double precision array(*),nulval(2)
        logical flgval(*),anynul

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bytpix,bstart,tcode,nulchk,incre
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart
        integer offset,rskip,dstart,begcol,lenrow,i,j
        logical scaled,descrp
        double precision scale,zero
        character crow*9,cp1*9,cp2*9,ccol*4
               
        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table read '//
     &          'request is out of range:'//crow//' (FTGCLM).')
                return
        end if
        if (felem .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLM).')
                return
        end if

        i1=1
        ntodo=nelem
        estart=felem-1
        rstart=frow-1
        anynul=.false.
        ibuff=bufnum(iunit)
        dstart=dtstrt(ibuff)
        lenrow=rowlen(ibuff)
        begcol=tbcol(colnum+tstart(ibuff))
        tcode=tdtype(colnum+tstart(ibuff))
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
        bytpix=16

C       determine the repeat count and the first element position
C       incre is the byte offset between consecutive pixels
        incre=bytpix*eincr               

        if (tcode .eq. 163)then
                descrp=.false.
                repeat=trept(colnum+tstart(ibuff))
                if (felem .gt. repeat)then
C                        illegal element number
                         status=308
                         write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLM).')
                         return
                end if
                if (repeat .eq. 1 .and. nelem .gt. 1)then
C                        read multiple rows of data at one time by
C                        fooling it into thinking that this is a vector
C                        column with a large value of bytes per pixel
                                dstart=dstart+rstart*lenrow
                                rstart=0
                                estart=0
                                repeat=nelem*eincr
                                incre=lenrow*eincr 
                                lenrow=lenrow*repeat
                end if
        else if (tcode .eq. -163)then
C               this is a variable length descriptor column
C               read the number of elements and the starting offset:
                descrp=.true.
                call ftgdes(iunit,colnum,frow,repeat,offset,status)
                if (repeat .eq. 0)then
C                               error: null length vector
                                 status=318
                                return
                else if (estart+(nelem-1)*eincr+1 .gt. repeat) then
C                               error: trying to read beyond end of record
                                status=319
                                return
                end if
C               define the starting point of the row
                dstart=dstart+offset+theap(ibuff)
                rstart=0
                begcol=0
        else
C               column must be double complex data type
                status=312
                write(ccol,2001)colnum
                call ftpmsg('Column'//ccol//' does not have '//
     &          'Double Precision Complex (M) data type (FTGCLM).')
                return
        end if

C       determine if we have to check for null values
        if (nultyp .eq. 1 .and. nulval(1) .eq. 0 .and.
     &      nulval(2) .eq. 0)then
C               user doesn't want to check for nulls
                nulchk=0
        else
C           user does want to check for null values
            nulchk=nultyp
        end if

C       check if scaling is required
        if (scale .eq. 1.0 .and. zero .eq. 0.)then
                scaled=.false.
        else
                scaled=.true.
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,(repeat-estart-1)/eincr+1)

C       move the i/o pointer to the start of the sequence of pixels
        bstart=dstart+rstart*lenrow+begcol+estart*bytpix
        call ftmbyt(iunit,bstart,.false.,status)

C       read the data 
        if (incre .eq. 16)then
C               the data values are contiguous in the FITS file
C               multiply itodo*2 because we are getting pairs of values
                call ftgr8b(iunit,itodo*2,8,array(i1),status)
        else
C               have to read each complex double pair one by one
                j=i1
                call ftgr8b(iunit,2,8,array(j),status)
                j=j+2
                do 25 i=2,itodo
                    call ftmoff(iunit,incre-16,.false.,status)
                    call ftgr8b(iunit,2,8,array(j),status)
                    j=j+2
25              continue
        end if

C       find number of pixels left to do, and process them
30      ntodo=ntodo-itodo

        if (status .gt. 0)then
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error reading elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTGCLM.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error reading rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTGCLM).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error reading'//cp2//' elements from'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTGCLM).')
             end if
            return
        end if

        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo*2
                estart=estart+itodo*eincr
                rskip=estart/repeat
                rstart=rstart+rskip
                estart=estart-rskip*repeat
                go to 20
        end if

C       check for null values and/or scale the values
        if (nulchk .ne. 0 .or. scaled)then
          call ftnulm(array,nelem,nulchk,nulval,flgval,anynul,
     &     scaled,scale,zero)
        end if
        end

      SUBROUTINE slPLNE (DATE, JFORM, EPOCH, ORBINC, ANODE, PERIH,
     :                       AORQ, E, AORL, DM, PV, JSTAT)
*+
*     - - - - - - -
*      P L N L
*     - - - - - - -
*
*  Heliocentric position and velocity of a planet, asteroid or comet,
*  starting from orbital elements.
*
*  Given:
*     DATE     d     date, Modified Julian Date (JD - 2400000.5, Note 1)
*     JFORM    i     choice of element set (1-3; Note 3)
*     EPOCH    d     epoch of elements (TT MJD, Note 4)
*     ORBINC   d     inclination (radians)
*     ANODE    d     longitude of the ascending node (radians)
*     PERIH    d     longitude or argument of perihelion (radians)
*     AORQ     d     mean distance or perihelion distance (AU)
*     E        d     eccentricity
*     AORL     d     mean anomaly or longitude (radians, JFORM=1,2 only)
*     DM       d     daily motion (radians, JFORM=1 only)
*
*  Returned:
*     PV       d(6)  heliocentric x,y,z,xdot,ydot,zdot of date,
*                                     J2000 equatorial triad (AU,AU/s)
*     JSTAT    i     status:  0 = OK
*                            -1 = illegal JFORM
*                            -2 = illegal E
*                            -3 = illegal AORQ
*                            -4 = illegal DM
*                            -5 = numerical error
*
*  Called:  slELUE, slUEPV
*
*  Notes
*
*  1  DATE is the instant for which the prediction is required.  It is
*     in the TT timescale (formerly Ephemeris Time, ET) and is a
*     Modified Julian Date (JD-2400000.5).
*
*  2  The elements are with respect to the J2000 ecliptic and equinox.
*
*  3  A choice of three different element-set options is available:
*
*     Option JFORM = 1, suitable for the major planets:
*
*       EPOCH  = epoch of elements (TT MJD)
*       ORBINC = inclination i (radians)
*       ANODE  = longitude of the ascending node, big omega (radians)
*       PERIH  = longitude of perihelion, curly pi (radians)
*       AORQ   = mean distance, a (AU)
*       E      = eccentricity, e (range 0 to <1)
*       AORL   = mean longitude L (radians)
*       DM     = daily motion (radians)
*
*     Option JFORM = 2, suitable for minor planets:
*
*       EPOCH  = epoch of elements (TT MJD)
*       ORBINC = inclination i (radians)
*       ANODE  = longitude of the ascending node, big omega (radians)
*       PERIH  = argument of perihelion, little omega (radians)
*       AORQ   = mean distance, a (AU)
*       E      = eccentricity, e (range 0 to <1)
*       AORL   = mean anomaly M (radians)
*
*     Option JFORM = 3, suitable for comets:
*
*       EPOCH  = epoch of elements and perihelion (TT MJD)
*       ORBINC = inclination i (radians)
*       ANODE  = longitude of the ascending node, big omega (radians)
*       PERIH  = argument of perihelion, little omega (radians)
*       AORQ   = perihelion distance, q (AU)
*       E      = eccentricity, e (range 0 to 10)
*
*     Unused arguments (DM for JFORM=2, AORL and DM for JFORM=3) are not
*     accessed.
*
*  4  Each of the three element sets defines an unperturbed heliocentric
*     orbit.  For a given epoch of observation, the position of the body
*     in its orbit can be predicted from these elements, which are
*     called "osculating elements", using standard two-body analytical
*     solutions.  However, due to planetary perturbations, a given set
*     of osculating elements remains usable for only as long as the
*     unperturbed orbit that it describes is an adequate approximation
*     to reality.  Attached to such a set of elements is a date called
*     the "osculating epoch", at which the elements are, momentarily,
*     a perfect representation of the instantaneous position and
*     velocity of the body.
*
*     Therefore, for any given problem there are up to three different
*     epochs in play, and it is vital to distinguish clearly between
*     them:
*
*     . The epoch of observation:  the moment in time for which the
*       position of the body is to be predicted.
*
*     . The epoch defining the position of the body:  the moment in time
*       at which, in the absence of purturbations, the specified
*       position (mean longitude, mean anomaly, or perihelion) is
*       reached.
*
*     . The osculating epoch:  the moment in time at which the given
*       elements are correct.
*
*     For the major-planet and minor-planet cases it is usual to make
*     the epoch that defines the position of the body the same as the
*     epoch of osculation.  Thus, only two different epochs are
*     involved:  the epoch of the elements and the epoch of observation.
*
*     For comets, the epoch of perihelion fixes the position in the
*     orbit and in general a different epoch of osculation will be
*     chosen.  Thus, all three types of epoch are involved.
*
*     For the present routine:
*
*     . The epoch of observation is the argument DATE.
*
*     . The epoch defining the position of the body is the argument
*       EPOCH.
*
*     . The osculating epoch is not used and is assumed to be close
*       enough to the epoch of observation to deliver adequate accuracy.
*       If not, a preliminary call to slPRTL may be used to update
*       the element-set (and its associated osculating epoch) by
*       applying planetary perturbations.
*
*  5  The reference frame for the result is with respect to the mean
*     equator and equinox of epoch J2000.
*
*  6  The algorithm was originally adapted from the EPHSLA program of
*     D.H.P.Jones (private communication, 1996).  The method is based
*     on Stumpff's Universal Variables.
*
*  Reference:  Everhart, E. & Pitkin, E.T., Am.J.Phys. 51, 712, 1983.
*
*  P.T.Wallace   Starlink   31 December 2002
*
*  Copyright (C) 2002 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE
      INTEGER JFORM
      DOUBLE PRECISION EPOCH,ORBINC,ANODE,PERIH,AORQ,E,AORL,DM,PV(6)
      INTEGER JSTAT

      DOUBLE PRECISION U(13)
      INTEGER J



*  Validate elements and convert to "universal variables" parameters.
      CALL slELUE(DATE,JFORM,
     :               EPOCH,ORBINC,ANODE,PERIH,AORQ,E,AORL,DM,U,J)

*  Determine the position and velocity.
      IF (J.EQ.0) THEN
         CALL slUEPV(DATE,U,PV,J)
         IF (J.NE.0) J=-5
      END IF

*  Wrap up.
      JSTAT = J

      END

      integer function ifparm (strng)
      integer strng (100)
      integer c
      external index
      integer i, index, type
      c = strng (1)
      if (.not.(c .eq. -12 .or. c .eq. -13 .or. c .eq. -11 .or. c .eq. -
     *14 .or. c .eq. -10))goto 23000
      ifparm = 1
      goto 23001
23000 continue
      ifparm = 0
      i = 1
23002 if (.not.(index (strng (i), 36) .gt. 0))goto 23004
      i = i + index (strng (i), 36)
      if (.not.(type (strng (i)) .eq. 48))goto 23005
      if (.not.(type (strng (i + 1)) .ne. 48))goto 23007
      ifparm = 1
      goto 23004
23007 continue
23005 continue
23003 goto 23002
23004 continue
23001 continue
      return
      end

C--------------------------------------------------------------------------
        subroutine ftcrep(comm,comm1,repeat)
        
C       check if the first comment string is to be repeated for all keywords
C       (if the last non-blank character is '&', then it is to be repeated)

C       comm    c  input comment string
C       OUTPUT PARAMETERS:
C       comm1   c  output comment string, = COMM minus the last '&' character
C       repeat  l  true if the last character of COMM was the '&" character
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) comm,comm1
        logical repeat
        integer i,j

        repeat=.false.
        j=len(comm)
        do 10 i=j,1,-1
                if (comm(i:i) .ne. ' ')then
                        if (comm(i:i) .eq. '&')then
                                comm1=comm(1:i-1)
                                repeat=.true.
                        end if
                        return
                end if
10      continue
        end

c
c	MATH -- C callable math functions.  This is the only portable way
c	to access the Fortran intrinsic functions from C.  As a local
c	optimization it is possible to add defines to map these external
c	names onto the local Fortran library functions, but since C is not
c	generally used intensively for computations and all floating point
c	is done in double precision anyway, it is probably not worth it.
c

	integer function xnint (x)
	double precision x
		xnint = nint (x)
	end

	double precision function xexp (x)
	double precision x
		xexp = exp(x)
	end

	double precision function xlog (x)
	double precision x
		xlog = log(x)
	end

	double precision function xlog10 (x)
	double precision x
		xlog10 = log10(x)
	end

	double precision function xpow (x, y)
	double precision x
	double precision y
		xpow = x ** y
	end

	double precision function xsqrt (x)
	double precision x
		xsqrt = sqrt(x)
	end

	double precision function xsin (x)
	double precision x
		xsin = sin(x)
	end

	double precision function xcos (x)
	double precision x
		xcos = cos(x)
	end

	double precision function xtan (x)
	double precision x
		xtan = tan(x)
	end

	double precision function xasin (x)
	double precision x
		xasin = asin(x)
	end

	double precision function xacos (x)
	double precision x
		xacos = acos(x)
	end

	double precision function xatan (x)
	double precision x
		xatan = atan(x)
	end

	double precision function xatan2 (x, y)
	double precision x
	double precision y
		xatan2 = atan2(x,y)
	end

      subroutine cascod (lab, token)
      integer lab, token
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer t, l, lb, ub, i, j, junk
      integer caslab, labgen, gnbtok
      integer tok (100)
      if (.not.(swtop .le. 0))goto 23000
      call synerr (24Hillegal case or default.)
      return
23000 continue
      call indent (-1)
      call outgo (lab + 1)
      xfer = 1
      l = labgen (1)
      if (.not.(token .eq. -91))goto 23002
23004 if (.not.(caslab (lb, t) .ne. -1))goto 23005
      ub = lb
      if (.not.(t .eq. 45))goto 23006
      junk = caslab (ub, t)
23006 continue
      if (.not.(lb .gt. ub))goto 23008
      call synerr (28Hillegal range in case label.)
      ub = lb
23008 continue
      if (.not.(swlast + 3 .gt. 1000))goto 23010
      call baderr (22Hswitch table overflow.)
23010 continue
      i = swtop + 3
23012 if (.not.(i .lt. swlast))goto 23014
      if (.not.(lb .le. swstak (i)))goto 23015
      goto 23014
23015 continue
      if (.not.(lb .le. swstak (i+1)))goto 23017
      call synerr (21Hduplicate case label.)
23017 continue
23016 continue
23013 i = i + 3
      goto 23012
23014 continue
      if (.not.(i .lt. swlast .and. ub .ge. swstak (i)))goto 23019
      call synerr (21Hduplicate case label.)
23019 continue
      j = swlast
23021 if (.not.(j .gt. i))goto 23023
      swstak (j+2) = swstak (j-1)
23022 j = j - 1
      goto 23021
23023 continue
      swstak (i) = lb
      swstak (i + 1) = ub
      swstak (i + 2) = l
      swstak (swtop + 1) = swstak (swtop + 1) + 1
      swlast = swlast + 3
      if (.not.(t .eq. 58))goto 23024
      goto 23005
23024 continue
      if (.not.(t .ne. 44))goto 23026
      call synerr (20Hillegal case syntax.)
23026 continue
23025 continue
      goto 23004
23005 continue
      goto 23003
23002 continue
      t = gnbtok (tok, 100)
      if (.not.(swstak (swtop + 2) .ne. 0))goto 23028
      call error (38Hmultiple defaults in switch statement.)
      goto 23029
23028 continue
      swstak (swtop + 2) = l
23029 continue
23003 continue
      if (.not.(t .eq. -1))goto 23030
      call synerr (15Hunexpected EOF.)
      goto 23031
23030 continue
      if (.not.(t .ne. 58))goto 23032
      call error (39Hmissing colon in case or default label.)
23032 continue
23031 continue
      xfer = 0
      call outcon (l)
      call indent (1)
      return
      end
c     logic0  logical_column

      subroutine stcopy (in, i, out, j)
      integer in (100), out (100)
      integer i, j
      integer k
      k = i
23000 if (.not.(in (k) .ne. -2))goto 23002
      out (j) = in (k)
      j = j + 1
23001 k = k + 1
      goto 23000
23002 continue
      out(j) = -2
      return
      end

c READIM -- Read through an image and count the lines (used for timing tests).
c Tests line sequential i/o.
c
c	usage:  readim image
c ----------------------------------------------------------------------------

	program readim

	character*80	image, errmsg
	integer		ncols, nlines, nbands, j, k
	integer		im, ier, axlen(7), naxis, dtype
	integer*2	pix(8192)

c --- Get image name.
	call clargc (1, image, ier)
	if (ier .ne. 0) then
	    write (*, '('' enter image name: '',$)')
	    read (*,*) image
	endif

c --- Open the image.
	call imopen (image, 1, im, ier)
	if (ier .ne. 0) goto 91
	call imgsiz (im, axlen, naxis, dtype, ier)
	if (ier .ne. 0) goto 91

	ncols  = axlen(1)
	nlines = axlen(2)
	nbands = axlen(3)

c --- Read through the image.
	do 20 k = 1, nbands
	    do 10 j = 1, nlines
		call imgl3s (im, pix, j, k, ier)
		if (ier .ne. 0) goto 91
 10	    continue
 20	continue

c --- Clean up.
	call imclos (im, ier)
	if (ier .ne. 0) goto 91

	print 81, nlines, image
 81	format (' read ', i4, ' lines from image ', a64)

	stop

c --- Error exit.
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg

	stop
	end

include	defs

# query - print usage message if user has requested one

   subroutine query (mesg)
   character mesg (ARB)

   integer getarg

   character arg1 (3), arg2 (1)

   if (getarg (1, arg1, 3) != EOF & getarg (2, arg2, 1) == EOF)
      if (arg1 (1) == QMARK & arg1 (2) == EOS)
	 call error (mesg)

   return
   end

      DOUBLE PRECISION FUNCTION slGMSA (DATE, UT)
*+
*     - - - - - -
*      G M S A
*     - - - - - -
*
*  Conversion from Universal Time to Greenwich mean sidereal time,
*  with rounding errors minimized.
*
*  double precision
*
*  Given:
*    DATE    d      UT1 date (MJD: integer part of JD-2400000.5))
*    UT      d      UT1 time (fraction of a day)
*
*  The result is the Greenwich mean sidereal time (double precision,
*  radians, in the range 0 to 2pi).
*
*  There is no restriction on how the UT is apportioned between the
*  DATE and UT arguments.  Either of the two arguments could, for
*  example, be zero and the entire date+time supplied in the other.
*  However, the routine is designed to deliver maximum accuracy when
*  the DATE argument is a whole number and the UT lies in the range
*  0 to 1 (or vice versa).
*
*  The algorithm is based on the IAU 1982 expression (see page S15 of
*  the 1984 Astronomical Almanac).  This is always described as giving
*  the GMST at 0 hours UT1.  In fact, it gives the difference between
*  the GMST and the UT, the steady 4-minutes-per-day drawing-ahead of
*  ST with respect to UT.  When whole days are ignored, the expression
*  happens to equal the GMST at 0 hours UT1 each day.  Note that the
*  factor 1.0027379... does not appear explicitly but in the form of
*  the coefficient 8640184.812866, which is 86400x36525x0.0027379...
*
*  In this routine, the entire UT1 (the sum of the two arguments DATE
*  and UT) is used directly as the argument for the standard formula.
*  The UT1 is then added, but omitting whole days to conserve accuracy.
*
*  See also the routine slGMST, which accepts the UT as a single
*  argument.  Compared with slGMST, the extra numerical precision
*  delivered by the present routine is unlikely to be important in
*  an absolute sense, but may be useful when critically comparing
*  algorithms and in applications where two sidereal times close
*  together are differenced.
*
*  Called:  slDA2P
*
*  P.T.Wallace   Starlink   14 October 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,UT

*  Seconds of time to radians
      DOUBLE PRECISION S2R
      PARAMETER (S2R=7.272205216643039903848712D-5)

      DOUBLE PRECISION D1,D2,T
      DOUBLE PRECISION slDA2P


*  Julian centuries since J2000.
      IF (DATE.LT.UT) THEN
         D1=DATE
         D2=UT
      ELSE
         D1=UT
         D2=DATE
      END IF
      T=(D1+(D2-51544.5D0))/36525D0

*  GMST at this UT1.
      slGMSA=slDA2P(S2R*(24110.54841D0+
     :                         (8640184.812866D0+
     :                         (0.093104D0
     :                         -6.2D-6*T)*T)*T
     :                         +86400D0*(MOD(D1,1D0)+MOD(D2,1D0))))

      END

      REAL FUNCTION slRVGA (R2000, D2000)
*+
*     - - - - - - -
*      R V G A
*     - - - - - - -
*
*  Velocity component in a given direction due to the rotation
*  of the Galaxy (single precision)
*
*  Given:
*     R2000,D2000   real    J2000.0 mean RA,Dec (radians)
*
*  Result:
*     Component of dynamical LSR motion in direction R2000,D2000 (km/s)
*
*  Sign convention:
*     The result is +ve when the dynamical LSR is receding from the
*     given point on the sky.
*
*  Note:  The Local Standard of Rest used here is a point in the
*         vicinity of the Sun which is in a circular orbit around
*         the Galactic centre.  Sometimes called the "dynamical" LSR,
*         it is not to be confused with a "kinematical" LSR, which
*         is the mean standard of rest of star catalogues or stellar
*         populations.
*
*  Reference:  The orbital speed of 220 km/s used here comes from
*              Kerr & Lynden-Bell (1986), MNRAS, 221, p1023.
*
*  Called:
*     slCS2C, slVDV
*
*  P.T.Wallace   Starlink   23 March 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL R2000,D2000

      REAL VA(3), VB(3)

      REAL slVDV

*
*  LSR velocity due to Galactic rotation
*
*  Speed = 220 km/s
*  Apex  = L2,B2  90deg, 0deg
*        = RA,Dec  21 12 01.1  +48 19 47  J2000.0
*
*  This is expressed in the form of a J2000.0 x,y,z vector:
*
*      VA(1) = X = -SPEED*COS(RA)*COS(DEC)
*      VA(2) = Y = -SPEED*SIN(RA)*COS(DEC)
*      VA(3) = Z = -SPEED*SIN(DEC)

      DATA VA / -108.70408, +97.86251, -164.33610 /



*  Convert given J2000 RA,Dec to x,y,z
      CALL slCS2C(R2000,D2000,VB)

*  Compute dot product with LSR motion vector
      slRVGA=slVDV(VA,VB)

      END

c     prog6
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 15
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   demonstrate the use of the subroutine   ldp	for least
c     distance programming by solving the constrained line data fitting
c     problem of chapter 23.
c
      dimension e(4,2), f(4), g(3,2), h(3), g2(3,2), h2(3), x(2), z(2),
     1w(4)
      dimension wldp(21), s(6), t(4)
      integer index(3)
c
      write (6,110)
      mde=4
      mdgh=3
c
      me=4
      mg=3
      n=2
c		 define the least squares and constraint matrices.
      t(1)=0.25
      t(2)=0.5
      t(3)=0.5
      t(4)=0.8
c
      w(1)=0.5
      w(2)=0.6
      w(3)=0.7
      w(4)=1.2
c
	  do 10 i=1,me
	  e(i,1)=t(i)
	  e(i,2)=1.
   10	  f(i)=w(i)
c
      g(1,1)=1.
      g(1,2)=0.
      g(2,1)=0.
      g(2,2)=1.
      g(3,1)=-1.
      g(3,2)=-1.
c
      h(1)=0.
      h(2)=0.
      h(3)=-1.
c
c     compute the singular value decomposition of the matrix, e.
c
      call svdrs (e,mde,me,n,f,1,1,s)
c
      write (6,120) ((e(i,j),j=1,n),i=1,n)
      write (6,130) f,(s(j),j=1,n)
c
c     generally rank determination and levenberg-marquardt
c     stabilization could be inserted here.
c
c	 define the constraint matrix for the z coordinate system.
	  do 30 i=1,mg
	      do 30 j=1,n
	      sm=0.
		  do 20 l=1,n
   20		  sm=sm+g(i,l)*e(l,j)
   30	      g2(i,j)=sm/s(j)
c	  define constraint rt side for the z coordinate system.
	  do 50 i=1,mg
	  sm=0.
	      do 40 j=1,n
   40	      sm=sm+g2(i,j)*f(j)
   50	  h2(i)=h(i)-sm
c
      write (6,140) ((g2(i,j),j=1,n),i=1,mg)
      write (6,150) h2
c
c			 solve the constrained problem in z-coordinates.
c
      call ldp (g2,mdgh,mg,n,h2,z,znorm,wldp,index,mode)
c
      write (6,200) mode,znorm
      write (6,160) z
c
c		     transform back from z-coordinates to x-coordinates.
	  do 60 j=1,n
   60	  z(j)=(z(j)+f(j))/s(j)
	  do 80 i=1,n
	  sm=0.
	      do 70 j=1,n
   70	      sm=sm+e(i,j)*z(j)
   80	  x(i)=sm
      res=znorm**2
      np1=n+1
	  do 90 i=np1,me
   90	  res=res+f(i)**2
      res=sqrt(res)
c				     compute the residuals.
	  do 100 i=1,me
  100	  f(i)=w(i)-x(1)*t(i)-x(2)
      write (6,170) (x(j),j=1,n)
      write (6,180) (i,f(i),i=1,me)
      write (6,190) res
      stop
c
  110 format (46h0prog6..  example of constrained curve fitting,26h usin
     1g the subroutine ldp.,/43h0related intermediate quantities are giv
     2en.)
  120 format (10h0v =	   ,2f10.5/(10x,2f10.5))
  130 format (10h0f tilda =,4f10.5/10h0s =	,2f10.5)
  140 format (10h0g tilda =,2f10.5/(10x,2f10.5))
  150 format (10h0h tilda =,3f10.5)
  160 format (10h0z =	   ,2f10.5)
  170 format (52h0the coeficients of the fitted line f(t)=x(1)*t+x(2),12
     1h are x(1) = ,f10.5,14h	and x(2) = ,f10.5)
  180 format (30h0the consecutive residuals are/1x,4(i10,f10.5))
  190 format (23h0the residuals norm is ,f10.5)
  200 format (18h0mode (from ldp) =,i3,2x,7hznorm =,f10.5)
c
      end

      SUBROUTINE slCRTF (NDP, ANGLE, SIGN, IHMSF)
*+
*     - - - - - -
*      C R T F
*     - - - - - -
*
*  Convert an angle in radians into hours, minutes, seconds
*  (single precision)
*
*  Given:
*     NDP       int      number of decimal places of seconds
*     ANGLE     real     angle in radians
*
*  Returned:
*     SIGN      char     '+' or '-'
*     IHMSF     int(4)   hours, minutes, seconds, fraction
*
*  Notes:
*
*  1)  NDP less than zero is interpreted as zero.
*
*  2)  The largest useful value for NDP is determined by the size of
*      ANGLE, the format of REAL floating-point numbers on the target
*      machine, and the risk of overflowing IHMSF(4).  On some
*      architectures, for ANGLE up to 2pi, the available floating-point
*      precision corresponds roughly to NDP=3.  This is well below
*      the ultimate limit of NDP=9 set by the capacity of a typical
*      32-bit IHMSF(4).
*
*  3)  The absolute value of ANGLE may exceed 2pi.  In cases where it
*      does not, it is up to the caller to test for and handle the
*      case where ANGLE is very nearly 2pi and rounds up to 24 hours,
*      by testing for IHMSF(1)=24 and setting IHMSF(1-4) to zero.
*
*  Called:  slCDTF
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER NDP
      REAL ANGLE
      CHARACTER SIGN*(*)
      INTEGER IHMSF(4)

*  Turns to radians
      REAL T2R
      PARAMETER (T2R=6.283185307179586476925287)



*  Scale then use days to h,m,s routine
      CALL slCDTF(NDP,ANGLE/T2R,SIGN,IHMSF)

      END

      real function ppvalu (break, coef, l, k, x, jderiv )
c  from  * a practical guide to splines *  by c. de boor
calls  interv
calculates value at  x	of  jderiv-th derivative of pp fct from pp-repr
c
c******  i n p u t  ******
c  break, coef, l, k.....forms the pp-representation of the function  f
c	 to be evaluated. specifically, the j-th derivative of	f  is
c	 given by
c
c     (d**j)f(x) = coef(j+1,i) + h*(coef(j+2,i) + h*( ... (coef(k-1,i) +
c			      + h*coef(k,i)/(k-j-1))/(k-j-2) ... )/2)/1
c
c	 with  h = x - break(i),  and
c
c	i  =  max( 1 , max( j ,  break(j) .le. x , 1 .le. j .le. l ) ).
c
c  x.....the point at which to evaluate.
c  jderiv.....integer giving the order of the derivative to be evaluat-
c	 ed.  a s s u m e d  to be zero or positive.
c
c******  o u t p u t  ******
c  ppvalu.....the value of the (jderiv)-th derivative of  f  at  x.
c
c******  m e t h o d  ******
c     the interval index  i , appropriate for  x , is found through a
c  call to  interv . the formula above for the	jderiv-th derivative
c  of  f  is then evaluated (by nested multiplication).
c
      integer jderiv,k,l,   i,m,ndummy
      real break(l),coef(k,l),x,   fmmjdr,h
      ppvalu = 0.
      fmmjdr = k - jderiv
c	       derivatives of order  k	or higher are identically zero.
      if (fmmjdr .le. 0.)		go to 99
c
c	       find index  i  of largest breakpoint to the left of  x .
      call interv ( break, l, x, i, ndummy )
c
c      evaluate  jderiv-th derivative of  i-th polynomial piece at  x .
      h = x - break(i)
      m = k
    9	 ppvalu = (ppvalu/fmmjdr)*h + coef(m,i)
	 m = m - 1
	 fmmjdr = fmmjdr - 1.
	 if (fmmjdr .gt. 0.)		go to 9
   99					return
      end

      SUBROUTINE slAMPQ (RA, DA, AMPRMS, RM, DM)
*+
*     - - - - - -
*      A M P Q
*     - - - - - -
*
*  Convert star RA,Dec from geocentric apparent to mean place
*
*  The mean coordinate system is the post IAU 1976 system,
*  loosely called FK5.
*
*  Use of this routine is appropriate when efficiency is important
*  and where many star positions are all to be transformed for
*  one epoch and equinox.  The star-independent parameters can be
*  obtained by calling the slMAPA routine.
*
*  Given:
*     RA       d      apparent RA (radians)
*     DA       d      apparent Dec (radians)
*
*     AMPRMS   d(21)  star-independent mean-to-apparent parameters:
*
*       (1)      time interval for proper motion (Julian years)
*       (2-4)    barycentric position of the Earth (AU)
*       (5-7)    heliocentric direction of the Earth (unit vector)
*       (8)      (grav rad Sun)*2/(Sun-Earth distance)
*       (9-11)   ABV: barycentric Earth velocity in units of c
*       (12)     sqrt(1-v**2) where v=modulus(ABV)
*       (13-21)  precession/nutation (3,3) matrix
*
*  Returned:
*     RM       d      mean RA (radians)
*     DM       d      mean Dec (radians)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Note:
*
*     Iterative techniques are used for the aberration and
*     light deflection corrections so that the routines
*     slAMP (or slAMPQ) and slMAP (or slMAPQ) are
*     accurate inverses;  even at the edge of the Sun's disc
*     the discrepancy is only about 1 nanoarcsecond.
*
*  Called:  slDS2C, slDIMV, slDVDV, slDVN, slDC2S,
*           slDA2P
*
*  P.T.Wallace   Starlink   7 May 2000
*
*  Copyright (C) 2000 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RA,DA,AMPRMS(21),RM,DM

      INTEGER I,J

      DOUBLE PRECISION GR2E,AB1,EHN(3),ABV(3),P3(3),P2(3),
     :                 AB1P1,P1DV,P1DVP1,P1(3),W,PDE,PDEP1,P(3)

      DOUBLE PRECISION slDVDV,slDA2P



*  Unpack scalar and vector parameters
      GR2E = AMPRMS(8)
      AB1 = AMPRMS(12)
      DO I=1,3
         EHN(I) = AMPRMS(I+4)
         ABV(I) = AMPRMS(I+8)
      END DO

*  Apparent RA,Dec to Cartesian
      CALL slDS2C(RA,DA,P3)

*  Precession and nutation
      CALL slDIMV(AMPRMS(13),P3,P2)

*  Aberration
      AB1P1 = AB1+1D0
      DO I=1,3
         P1(I) = P2(I)
      END DO
      DO J=1,2
         P1DV = slDVDV(P1,ABV)
         P1DVP1 = 1D0+P1DV
         W = 1D0+P1DV/AB1P1
         DO I=1,3
            P1(I) = (P1DVP1*P2(I)-W*ABV(I))/AB1
         END DO
         CALL slDVN(P1,P3,W)
         DO I=1,3
            P1(I) = P3(I)
         END DO
      END DO

*  Light deflection
      DO I=1,3
         P(I) = P1(I)
      END DO
      DO J=1,5
         PDE = slDVDV(P,EHN)
         PDEP1 = 1D0+PDE
         W = PDEP1-GR2E*PDE
         DO I=1,3
            P(I) = (PDEP1*P1(I)-GR2E*EHN(I))/W
         END DO
         CALL slDVN(P,P2,W)
         DO I=1,3
            P(I) = P2(I)
         END DO
      END DO

*  Mean RA,Dec
      CALL slDC2S(P,RM,DM)
      RM = slDA2P(RM)

      END

C--------------------------------------------------------------------------
        subroutine ftukye(ounit,keywrd,rval,decim,comm,status)

C       update a real*4 value header record in E format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       rval    r  keyword value 
C       decim   i  number of decimal places to display in value field
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Oct 1994

        character*(*) keywrd,comm
        real rval
        integer ounit,status,decim,tstat

        if (status .gt. 0)return
        tstat=status

C       try modifying the keyword, if it exists
        call ftmkye(ounit,keywrd,rval,decim,comm,status)

        if (status .eq. 202)then
C               keyword doesn't exist, so create it
                status=tstat
                call ftpkye(ounit,keywrd,rval,decim,comm,status)
        end if
        end

      SUBROUTINE slDEUL (ORDER, PHI, THETA, PSI, RMAT)
*+
*     - - - - - - -
*      D E U L
*     - - - - - - -
*
*  Form a rotation matrix from the Euler angles - three successive
*  rotations about specified Cartesian axes (double precision)
*
*  Given:
*    ORDER   c*(*)   specifies about which axes the rotations occur
*    PHI     d       1st rotation (radians)
*    THETA   d       2nd rotation (   "   )
*    PSI     d       3rd rotation (   "   )
*
*  Returned:
*    RMAT    d(3,3)  rotation matrix
*
*  A rotation is positive when the reference frame rotates
*  anticlockwise as seen looking towards the origin from the
*  positive region of the specified axis.
*
*  The characters of ORDER define which axes the three successive
*  rotations are about.  A typical value is 'ZXZ', indicating that
*  RMAT is to become the direction cosine matrix corresponding to
*  rotations of the reference frame through PHI radians about the
*  old Z-axis, followed by THETA radians about the resulting X-axis,
*  then PSI radians about the resulting Z-axis.
*
*  The axis names can be any of the following, in any order or
*  combination:  X, Y, Z, uppercase or lowercase, 1, 2, 3.  Normal
*  axis labelling/numbering conventions apply;  the xyz (=123)
*  triad is right-handed.  Thus, the 'ZXZ' example given above
*  could be written 'zxz' or '313' (or even 'ZxZ' or '3xZ').  ORDER
*  is terminated by length or by the first unrecognized character.
*
*  Fewer than three rotations are acceptable, in which case the later
*  angle arguments are ignored.  If all rotations are zero, the
*  identity matrix is produced.
*
*  P.T.Wallace   Starlink   23 May 1997
*
*  Copyright (C) 1997 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) ORDER
      DOUBLE PRECISION PHI,THETA,PSI,RMAT(3,3)

      INTEGER J,I,L,N,K
      DOUBLE PRECISION RESULT(3,3),ROTN(3,3),ANGLE,S,C,W,WM(3,3)
      CHARACTER AXIS



*  Initialize result matrix
      DO J=1,3
         DO I=1,3
            IF (I.NE.J) THEN
               RESULT(I,J) = 0D0
            ELSE
               RESULT(I,J) = 1D0
            END IF
         END DO
      END DO

*  Establish length of axis string
      L = LEN(ORDER)

*  Look at each character of axis string until finished
      DO N=1,3
         IF (N.LE.L) THEN

*        Initialize rotation matrix for the current rotation
            DO J=1,3
               DO I=1,3
                  IF (I.NE.J) THEN
                     ROTN(I,J) = 0D0
                  ELSE
                     ROTN(I,J) = 1D0
                  END IF
               END DO
            END DO

*        Pick up the appropriate Euler angle and take sine & cosine
            IF (N.EQ.1) THEN
               ANGLE = PHI
            ELSE IF (N.EQ.2) THEN
               ANGLE = THETA
            ELSE
               ANGLE = PSI
            END IF
            S = SIN(ANGLE)
            C = COS(ANGLE)

*        Identify the axis
            AXIS = ORDER(N:N)
            IF (AXIS.EQ.'X'.OR.
     :          AXIS.EQ.'x'.OR.
     :          AXIS.EQ.'1') THEN

*           Matrix for x-rotation
               ROTN(2,2) = C
               ROTN(2,3) = S
               ROTN(3,2) = -S
               ROTN(3,3) = C

            ELSE IF (AXIS.EQ.'Y'.OR.
     :               AXIS.EQ.'y'.OR.
     :               AXIS.EQ.'2') THEN

*           Matrix for y-rotation
               ROTN(1,1) = C
               ROTN(1,3) = -S
               ROTN(3,1) = S
               ROTN(3,3) = C

            ELSE IF (AXIS.EQ.'Z'.OR.
     :               AXIS.EQ.'z'.OR.
     :               AXIS.EQ.'3') THEN

*           Matrix for z-rotation
               ROTN(1,1) = C
               ROTN(1,2) = S
               ROTN(2,1) = -S
               ROTN(2,2) = C

            ELSE

*           Unrecognized character - fake end of string
               L = 0

            END IF

*        Apply the current rotation (matrix ROTN x matrix RESULT)
            DO I=1,3
               DO J=1,3
                  W = 0D0
                  DO K=1,3
                     W = W+ROTN(I,K)*RESULT(K,J)
                  END DO
                  WM(I,J) = W
               END DO
            END DO
            DO J=1,3
               DO I=1,3
                  RESULT(I,J) = WM(I,J)
               END DO
            END DO

         END IF

      END DO

*  Copy the result
      DO J=1,3
         DO I=1,3
            RMAT(I,J) = RESULT(I,J)
         END DO
      END DO

      END

c-------------------------------------------------------------------------
c Compute machine epsilon, i.e, the smallest real or double precision
c number EPS such that (1.0 + EPS > 1.0).  This calculation is tricky
c because of the optimizations performed by some compilers, and because
c a comparison performed in registers may be done to a higher precision
c than one involving variables.  This program contains some minor
c violations of the F78 standard.
c-------------------------------------------------------------------------


	program epsilo

	real seps
	double precision deps

		write (*,*) 'Calculate Machine Epsilon ------'
		call cseps (seps)
		call cdeps (deps)
		write (*,*) '   single precision epsilon: ', seps
		write (*,*) '   double precision epsilon: ', deps

		write (*,*) ' '
		write (*,*) 'Verify Values -----'

		write (*, '(''     enter s.p. epsilon: '',$)')
		read (*,*) seps
		if (1.0 + seps .gt. 1.0) then
		    write (*,*) '     ok'
		else
		    write (*,*) '     not ok'
		endif

		write (*, '(''     enter d.p. epsilon: '',$)')
		read (*,*) deps
		if (1.0 + deps .gt. 1.0) then
		    write (*,*) '     ok'
		else
		    write (*,*) '     not ok'
		endif

		stop
	end


c -- Compute the single precision epsilon.

	subroutine cseps (seps)

	real	seps
	real	sval
	double	precision dval
	logical	sgt
	common	/eps/ sval, dval
	save	/eps/

		sval = 1.0
 10		seps = sval
		sval = sval / 2.0
		if (sgt (1.0)) then
		    goto 10
		endif
	end



c -- Is SVAL + 1.0 greater than 1.0?

	logical function sgt (value)

	real	value, sval, stemp
	double precision dval
	common	/eps/ sval, dval
	save	/eps/

		stemp = sval + 1.0
		sgt = (stemp .gt. value)
	end



c -- Compute the double precision epsilon.

	subroutine cdeps (deps)

	double	precision deps
	double	precision dval
	real	sval
	logical	dgt
	common	/eps/ sval, dval
	save	/eps/

		dval = 1.0d0
 10		deps = dval
		dval = dval / 2.0d0
		if (dgt (1.0d0)) then
		    goto 10
		endif
	end


c -- Is DVAL + 1.0 greater than 1.0?

	logical function dgt (value)

	double	precision value
	double	precision dval, dtemp
	real	sval
	common	/eps/ sval, dval
	save	/eps/

		dtemp = dval + 1.0d0
		dgt = (dtemp .gt. value)
	end

      SUBROUTINE slDJCA (NDP, DJM, IYMDF, J)
*+
*     - - - - - -
*      D J C A
*     - - - - - -
*
*  Modified Julian Date to Gregorian Calendar, expressed
*  in a form convenient for formatting messages (namely
*  rounded to a specified precision, and with the fields
*  stored in a single array)
*
*  Given:
*     NDP      i      number of decimal places of days in fraction
*     DJM      d      modified Julian Date (JD-2400000.5)
*
*  Returned:
*     IYMDF    i(4)   year, month, day, fraction in Gregorian
*                     calendar
*     J        i      status:  nonzero = out of range
*
*  Any date after 4701BC March 1 is accepted.
*
*  NDP should be 4 or less if internal overflows are to be avoided
*  on machines which use 32-bit integers.
*
*  The algorithm is adapted from Hatcher 1984 (QJRAS 25, 53-55).
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER NDP
      DOUBLE PRECISION DJM
      INTEGER IYMDF(4),J

      INTEGER NFD
      DOUBLE PRECISION FD,DF,F,D
      INTEGER JD,N4,ND10


*  Validate.
      IF ( DJM.LE.-2395520D0 .OR. DJM.GE.1D9 ) THEN
         J = -1
      ELSE
         J = 0

*     Denominator of fraction.
         NFD = 10**MAX(NDP,0)
         FD = DBLE(NFD)

*     Round date and express in units of fraction.
         DF = ANINT(DJM*FD)

*     Separate day and fraction.
         F = MOD(DF,FD)
         IF (F.LT.0D0) F = F+FD
         D = (DF-F)/FD

*     Express day in Gregorian calendar.
         JD = NINT(D)+2400001

         N4 = 4*(JD+((2*((4*JD-17918)/146097)*3)/4+1)/2-37)
         ND10 = 10*(MOD(N4-237,1461)/4)+5

         IYMDF(1) = N4/1461-4712
         IYMDF(2) = MOD(ND10/306+2,12)+1
         IYMDF(3) = MOD(ND10,306)/10+1
         IYMDF(4) = NINT(F)

      END IF

      END

      subroutine set (xa,xb,ya,yb,xc,xd,yc,yd,itype)
c
c *************** KPNO -- name changed from set to sppset **********
c
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c     ray bovet patch to avoid small integers being set to 0
      integer xa,xb,ya,yb,xxa,xxb,yya,yyb,zz
      logical         intt
      dimension       zz(4)  ,mz(4)  ,zc(2)  ,zd(2)  ,zfactr(2)      ,
     1                zadd(2),mtypez(2)
      dimension       mshftz(2)
      dimension       mes(2)
      equivalence     (xxc,zc(1))    ,(xxd,zd(1))    ,(xxa,zz(1))    ,
     1                (mxa,mz(1))    ,(xfactr,zfactr(1))     ,
     2                (xadd,zadd(1)) ,(mtypex,mtypez(1))     ,
     3                (mshftx,mshftz(1))     ,(temp,itemp)
      data mes(1),mes(2)/1hx,1hy/
      xxa = xa
      xxb = xb
      xxc = xc
      xxd = xd
      yya = ya
      yyb = yb
      yyc = yc
      yyd = yd
      mtype = itype
      mtypex = (mtype-1)/2
      mtypey = mod(mtype-1,2)
c
c find mxa, mxb, etc by mapping xxa, xxb, etc into integer space if they
c are not integers
c
      do 103 i=1,4
         k = i
         if (k .gt. 2) k = k-2
c     ray bovet patch to avoid small integers being set to 0
c        temp = zz(i)
         itemp = zz(i)
c        if (temp .lt. 0.0) go to 106
c
         if (.not.(intt(temp))) go to 101
         if (itemp.lt.0) go to 106
         itemp = ishift(itemp-1,mshftz(k))
         go to 102
c     ray bovet patch to avoid small integers being set to 0
c 101    itemp = temp*32767.
  101    if(temp.lt.0.0) go to 106
         itemp = temp*32767.
c
  102    if (itemp.lt.0 .or. itemp.gt.32767) go to 107
         mz(i) = itemp
  103 continue
c
c set up parameters for translating real input from frstpt, etc. to
c integer plotting space
c
      do 105 i=1,2
         prange = mz(i+2)-mz(i)
         urange = zd(i)-zc(i)
c
c test for no range
c
         if (urange.eq.0. .or. prange.eq.0.) go to 108
c
c test for log scaling
c
         if (mtypez(i) .eq. 0) go to 104
c
c test for error
c
         if (zc(i) .le. 0.) go to 109
         if (zd(i) .le. 0.) go to 110
         urange = alog10(zd(i)/zc(i))
         zfactr(i) = prange/urange
         zadd(i) = float(mz(i))-zfactr(i)*alog10(zc(i))
         go to 105
  104    zfactr(i) = prange/urange
         zadd(i) = float(mz(i))-zfactr(i)*zc(i)
  105 continue
      return
c
c error processing
c
  106 continue
      if (i.gt.1 .and. i.lt.4) i = 5-i
c     write (mprint,1001) i
c
      call uliber (0,53h0negative values not allowed in first 4 set argu
     1ments        ,53)
      call perror
      return
  107 continue
      if (i.gt.1 .and. i.lt.4) i = 5-i
c     write (mprint,1002) i
c
      call uliber (0,83h0first 4 set arguments must be real between 0 an
     1d 1 or integers between 1 and 32767,83)
      call perror
      return
  108 continue
      i1 = i*2+3
      i2 = i*2+4
c     write (mprint,1003) i1,i2
c
      call uliber (0,31h0no range in x or y in set call,31)
      call perror
      return
  109 continue
c 109 write (mprint,1004) mes(i)
      go to 111
  110 continue
c 110 write (mprint,1005) mes(i)
c
  111 call uliber (0,46h0non-positive argument to set with log scaling,
     1             46)
      call perror
      return
c
c1001 format (9h0argument,i2,9h negative)
c1002 format (9h0argument,i2,13h out of range)
c1003 format (10h0arguments,i2,4h and,i2,14h are identical)
c1004 format (1h0,a1,8hc .le. 0)
c1005 format (1h0,a1,8hd .le. 0)
c
      end

      integer function stclos (pat, j, lastj, lastcl)
      integer pat (128)
      integer j, lastj, lastcl
      integer addset
      integer jp, jt, junk
      jp = j - 1
23000 if (.not.(jp .ge. lastj))goto 23002
      jt = jp + 4
      junk = addset (pat (jp), pat, jt, 128)
23001 jp = jp - 1
      goto 23000
23002 continue
      j = j + 4
      stclos = lastj
      junk = addset (42, pat, lastj, 128)
      junk = addset (0, pat, lastj, 128)
      junk = addset (lastcl, pat, lastj, 128)
      junk = addset (0, pat, lastj, 128)
      return
      end

C--------------------------------------------------------------------------
        subroutine ftgkys(iunit,keywrd,strval,comm,status)

C       read a character string value and comment string from a header record 
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name   
C       OUTPUT PARAMETERS:
C       strval  c  output keyword value 
C       comm    c  output keyword comment
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991
C       modified 6/93 to support long strings which are continued
C       over several keywords.  A string may be continued by putting
C       a backslash as the last non-blank character in the keyword string,
C       then continuing the string in the next keyword which must have
C       a blank keyword name. 
C       Modified 9/94 to support the new OGIP continuation convention

        character*(*) keywrd,comm,strval
        integer status,iunit
        character value*70, comm2*70, bslash*1
        integer clen,i,bspos,lenval

C       find the keyword and return value and comment as character strings
        call ftgkey(iunit,keywrd,value,comm,status)

C       convert character string to unquoted string
        call ftc2s(value,strval,status)

        if (status .gt. 0)return

        clen=len(strval)

C       is last character a backslash or & ?
C       have to use 2 \\'s because the SUN compiler treats 1 \ as an escape
        bslash='\\'
        do 10 i=70,1,-1
                if (value(i:i) .ne. ' ' .and. value(i:i).ne.'''')then
                        if (value(i:i) .eq. bslash .or. 
     &                      value(i:i) .eq. '&')then
C                               have to subtract 1 due to the leading quote char
                                bspos=i-1
                                go to 20
                        end if
C                       no continuation character, so just return
                        return
                end if
10      continue
C       value field was blank, so just return
        return

C       try to get the string continuation, and new comment string
20      call ftgnst(iunit,value,lenval,comm2,status)
        if (lenval .eq. 0)return

        if (bspos .le. clen)then
                strval(bspos:)=value(1:lenval)
                bspos=bspos+lenval-1
        end if

        if (comm2 .ne. ' ')comm=comm2

C       see if there is another continuation line
        if (value(lenval:lenval) .eq. bslash .or. 
     &      value(lenval:lenval) .eq. '&')go to 20
        end

include	defs

# ctoi - convert string at in(i) to integer, increment i

   integer function ctoi(in, i)
   character in (ARB)
   integer i

   integer d
   external index
   integer index

   # string digits "0123456789"
   character digits(11)
   data digits (1) /DIG0/,
      digits (2) /DIG1/,
      digits (3) /DIG2/,
      digits (4) /DIG3/,
      digits (5) /DIG4/,
      digits (6) /DIG5/,
      digits (7) /DIG6/,
      digits (8) /DIG7/,
      digits (9) /DIG8/,
      digits (10) /DIG9/,
      digits (11) /EOS/

   while (in (i) == BLANK | in (i) == TAB)
      i = i + 1
   for (ctoi = 0; in (i) != EOS; i = i + 1) {
      d = index (digits, in (i))
      if (d == 0)      # non-digit
	 break
      ctoi = 10 * ctoi + d - 1
      }

   return
   end

      SUBROUTINE slDIMV (DM, VA, VB)
*+
*     - - - - - -
*      D I M V
*     - - - - - -
*
*  Performs the 3-D backward unitary transformation:
*
*     vector VB = (inverse of matrix DM) * vector VA
*
*  (double precision)
*
*  (n.b.  the matrix must be unitary, as this routine assumes that
*   the inverse and transpose are identical)
*
*  Given:
*     DM       dp(3,3)    matrix
*     VA       dp(3)      vector
*
*  Returned:
*     VB       dp(3)      result vector
*
*  P.T.Wallace   Starlink   March 1986
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DM(3,3),VA(3),VB(3)

      INTEGER I,J
      DOUBLE PRECISION W,VW(3)



*  Inverse of matrix DM * vector VA -> vector VW
      DO J=1,3
         W=0D0
         DO I=1,3
            W=W+DM(I,J)*VA(I)
         END DO
         VW(J)=W
      END DO

*  Vector VW -> vector VB
      DO J=1,3
         VB(J)=VW(J)
      END DO

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSETC (TPID,CUSR)
C
      CHARACTER*(*) TPID,CUSR
C
      DIMENSION FURA(1)
C
C The routine AGSETC is used to set the values of individual AUTOGRAPH
C parameters which intrinsically represent character strings.  TPID is a
C parameter identifier.  CUSR is a character string.  The situation is
C complicated by the fact that the character string may be either a dash
C pattern, the name of a label, the line-end character, or the text of a
C line, all of which are treated differently.
C
C Define a local variable to hold the "line-end" character.
C
      CHARACTER*1 LEND
C
C See what kind of parameter is being set.
C
      CALL AGCTCS (TPID,ITCS)
C
C If the parameter is not intrinsically of type character, log an error.
C
      IF (ITCS.EQ.0) GO TO 901
C
C Find the length of the string, which may or may not actually be used.
C (On the Cray, at least, it may be zero if the wrong type of argument
C was used.)
C
      ILEN=LEN(CUSR)
C
C Retrieve the current (integer) value of the parameter.
C
      CALL AGGETI (TPID,ITMP)
C
C Check for a dash pattern.
C
      IF (ITCS.EQ.1) THEN
        CALL AGGETI ('DASH/LENG.',NCHR)
        IF (ILEN.GT.0.AND.ILEN.LT.NCHR) NCHR=ILEN
        CALL AGRPCH (CUSR,NCHR,ITMP)
C
C Check for a label name.
C
      ELSE IF (ITCS.EQ.2) THEN
        CALL AGRPCH (CUSR,MAX0(1,ILEN),ITMP)
C
C Check for the line-end character.
C
      ELSE IF (ITCS.EQ.3) THEN
        CALL AGRPCH (CUSR,1,ITMP)
C
C Check for the text of a label.
C
      ELSE IF (ITCS.EQ.4) THEN
        CALL AGGETI ('LINE/MAXI.',NCHR)
        IF (ILEN.GT.0) NCHR=MIN0(NCHR,ILEN)
        CALL AGGETC ('LINE/END .',LEND)
        DO 101 I=1,NCHR
          IF (CUSR(I:I).EQ.LEND) THEN
            NCHR=I-1
            GO TO 102
          END IF
  101   CONTINUE
C
  102   CALL AGRPCH (CUSR,NCHR,ITMP)
C
      END IF
C
C Transfer the generated value to the list of AUTOGRAPH parameters.
C
      FURA(1)=FLOAT(ITMP)
      CALL AGSETP (TPID,FURA,1)
C
C Done.
C
      RETURN
C
C Error exit.
C
  901 CALL AGPPID (TPID)
      CALL SETER ('AGSETC - PARAMETER TO SET IS NOT INTRINSICALLY OF TYP
     +E CHARACTER',14,2)
C
      END

include	defs

# errsub - see if argument is ERROUT substitution

   integer function errsub (arg, file, access)

   character arg (ARB), file (ARB)
   integer access

   if (arg (1) == QMARK & arg (2) != QMARK & arg (2) != EOS) {
      errsub = YES
      access = WRITE
      call scopy (arg, 2, file, 1)
      }

   else if (arg (1) == QMARK & arg (2) == QMARK & arg (3) != EOS) {
      errsub = YES
      access = APPEND
      call scopy (arg, 3, file, 1)
      }

   else
      errsub = NO

   return
   end

      SUBROUTINE CONECD (VAL,IOUT,NUSED)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  ENCODE A NUMBER IN THE LEAST AMOUNT OF SPACE
C  ON INPUT
C       VAL THE NUMBER TO BE ENCODED
C  ON OUTPUT
C       IOUT CHARACTER STRING FILLED WITH THE ENCODED RESULT, MUST BE ABLE TO
C            HOLD UP TO 9 CHARACTERS.
C
C     NUSED NUMBER OF CHARACTERS IN IOUT
C
C  VALUE INPUT WILL BE SCALED BY SCALE IN CONRA2
C
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
        CHARACTER*(*)   IOUT
        CHARACTER*6     IFMT1
C
C +NOAO - Variables CHTMP and IT are not used.
C
C       CHARACTER*9     CHTMP
C       CHARACTER*1     IT
C
C -NOAO
C
        SAVE
C
      V = VAL
C
C  IF VAL EQUALS ZERO EASY PROCESSING
C
      IF (V.NE.0.) GO TO    20
        IOUT = '0.0'
      NUSED = 3
      RETURN
C
C  SCALE VALUE
C
   20 V = V*SCALE
C
C  GET SIZE OF NUMBER
C
      LOG = IFIX(ALOG10(ABS(V))+.1)
      IF (IABS(LOG).GT.4) GO TO    60
C
C  COMPUTE FLOATING POINT FIELD
C
      NS = IABS(LOG)+3
      ND = 1
      IF (LOG.GT.0) GO TO    40
C
C  LOG = 0 TEST FOR FRACTIONAL PART ONLY
C
      IF (ALOG10( ABS(V) ).GE.0.) GO TO    30
C
C  NUMBER LT 1 BUT GREATER THAN ZERO IN ABSOLUTE VALUE
C
      NS = 4
      ND = 1
      GO TO    40
C
C  NUMBER LESS THAN 10 BUT GE 1
C
   30 ND = 1
      NS = 4
C
C  BUILD THE FORMAT
C
   40 IF (V.LT.0) NS = NS+1
        IFMT1 = '(F . )'
C
C  INSERT THE FLOATING POINT FORMAT SIZE
C
C +NOAO - Scheme for creating format has been modified because it uses
C         FTN internal writes.  NOAO mods are written in lower case.
C
C       WRITE(IT,'(I1)')NS
C       IFMT1(3:3) = IT
C       WRITE(IT,'(I1)')ND
C       IFMT1(5:5) = IT
C
	ifmt1(1:6) = '(f . )'
	ifmt1(3:3) = char (ns + ichar ('0') + 1)
	ifmt1(5:5) = char (nd + ichar ('0'))
C
C  ENCODE THE DESIRED NUMBER
C
C       WRITE(CHTMP,IFMT1)V
C       IOUT = CHTMP
C
        call encode (ns, ifmt1, iout, v)

      NUSED = NS
      RETURN
C
C  DATA LARGER THAN A NICE SIZE FORCE IT TO BE ENCODED
C
C 60  WRITE(CHTMP,'(E8.3)')V
C     IOUT = CHTMP
C
  60  call encode (8, '(E8.3)', iout, v)
C
C -NOAO
      NUSED = 8
      RETURN
C
C******************************************************************
C*                                                                *
C*                   REVISION HISTORY                             *
C*                                                                *
C*  JUNE 1980   ADDED CONCOM TO ULIB                              *
C*  AUGUST 1980 FIXED BOARDER CONTOUR DETECTION                   *
C*  DECEMBER 1980 FIXED ERROR TRAP, CONTOUR REORDERING ALGORITHM  *
C*                AND ERROR MESSAGE 10                            *
C*  AUGUST 1983 ADDED LINEAR INTERPOLATION AND SHIELDING          *
C*  JULY 1984 CONVERTED TO FORTRAN77 AND GKS                      *
C*  AUGUST 1985 DELETED (MACHINE DEPENDENT) FUNCTION LOC; CHANGED *
C*              COMMON /CONR13/                                   *
C*                                                                *
C******************************************************************
C
      END

      subroutine flash2 (ipoint,ibuflu)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      dimension       idummy(1)
      if (modef .ne. 1) go to 101
      kpoint = ipoint
      if (kpoint.lt.0 .or. kpoint.gt.10) go to 102
      call flushb
      nextra = 5
      ibuflu = mbuflu+nextra
      if (mf2er .gt. 0) go to 103
      if (ibuflu .gt. mbufl) go to 103
      mfwa(kpoint+1) = mbufa
      mlwa(kpoint+1) = mbufa+mbuflu-1
      isub = mbufa+mbuflu-loci(idummy)
      idummy(isub+1) = mbuflu
      idummy(isub+2) = mjxmin
      idummy(isub+3) = mjymin
      idummy(isub+4) = mjxmax
      idummy(isub+5) = mjymax
      modef = 2
      mbufa = loci(msybuf)
      mbufl = msblen
      mbuflu = 0
      mbprs(1) = mpair1
      mbprs(2) = mpair2
      mipair = 2
      mflcnt = 0
      mxold = -9999
      myold = -9999
      mjxmin = mnxsto
      mjymin = mnysto
      mjxmax = mxxsto
      mjymax = mxysto
      return
c
  101 call uliber (0,29h0flash2 called without flash1,29)
      call perror
      return
  102 continue
c     write (mprint,1001) kpoint
c
      call uliber (0,38h0first argument to flash2 out of range,38)
      call perror
      return
  103 continue
      nlen = mf2er*mbufl+ibuflu
c     write (mprint,1002) nlen
c
      call uliber (0,23h0flash buffer too short,23)
      call perror
      return
c
c1001 format (27h0flash2 called with ipoint=,i5)
c1002 format (27h0flash buffer must be about,i8,11h words long)
c
      end

c GTX -- Text.  Unpack an f77 string and call gx_gtx to output the string.
c
	subroutine gtx (px, py, f77chars)
c
	real		px, py
	character*(*) 	f77chars
	integer*2     	sppchars(161)
c
c
c	Unpack characters from packed input array
c
	call f77upk (f77chars, sppchars, min (len(f77chars), 161))
	call gxgtx (px, py, sppchars)
c
c
	end

      subroutine repcod (lab)
      integer lab
      integer labgen
      call outcon (0)
      lab = labgen (3)
      call outcon (lab)
      lab = lab + 1
      call indent (1)
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGEXAX (IAXS,SVAL,UMIN,UMAX,NICE,QLUA,FUNS,QBTP,BASD,
     +                   BASE,QMJD,QMND,QMNT,QLTD,QLTP,QLED,QLEX,QLFD,
     +                   QLFL,QMIN,QMAX)
C
      DIMENSION SVAL(2)
C
C The routine AGEXAX is used by AGSTUP to examine the parameters which
C determine how a given axis is tick-marked and labelled and to provide
C default values for missing ones.  Its arguments are as follows:
C
C -- IAXS is the number of the axis being drawn - 1, 2, 3, or 4.
C
C -- SVAL is the array of special values.
C
C -- UMIN and UMAX are the minimum and maximum values along the axis, in
C    the user coordinate system.  Rounded values of UMIN and UMAX are
C    returned in QMIN and QMAX if the following argument (NICE) is zero.
C
C -- NICE is a flag indicating whether rounded values of UMIN and UMAX
C    are to be returned (NICE.EQ.0) or not (NICE.NE.0).
C
C -- LLUA and FUNS specify the user-system-to-label-system mapping along
C    the axis.  See the routine AGAXIS for a discussion of them.
C
C -- NBTP, BASD, BASE, and NMJD are used to determine the positioning of
C    major tick marks in the label coordinate system.  NBTP and BASE are
C    described in the routine AGNUMB.  BASD is the desired value of BASE
C    supplied by the user.  If BASD has a null value, BASE is computed
C    by AGEXAX.  NMJD is a user-supplied-or-defaulted parameter giving
C    the approximate number of major ticks (and therefore the number of
C    numeric labels) to be placed on the axis.
C
C -- NMND and NMNT are the desired and actual (to be determined) number
C    of minor ticks per major division.  See discussion in AGAXIS.
C
C -- NLTD, NLTP, NLED, NLEX, NLFD, and NLFL are desired and actual (to
C    be determined) values of the parameters describing the form to be
C    used for numeric labels.  See discussion in AGNUMB.
C
C -- QMIN and QMAX are rounded values of UMIN and UMAX, returned only if
C    NICE.EQ.0.
C
C The following common block contains AUTOGRAPH variables which are
C not control parameters.  The only one used here is SMRL, which is a
C (machine-dependent) small real which, when added to a number in the
C range (1,10), will round it upward without seriously affecting the
C leading significant digits.  The object of this is to get rid of
C strings of nines.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The arrays BASP and NMNP specify possible default values for BASE and
C NMNT when NBTP.EQ.1.
C
      DIMENSION BASP(5),NMNP(5)
C
      DATA BASP(1) / 10. / , NMNP(1) / 1 / ,
     *     BASP(2) /  5. / , NMNP(2) / 4 / ,
     *     BASP(3) /  2. / , NMNP(3) / 1 / ,
     *     BASP(4) /  1. / , NMNP(4) / 1 / ,
     *     BASP(5) /  .5 / , NMNP(5) / 4 /
C
C If the parameter NBTP is zero, tick marks and labels are suppressed.
C
      NBTP=IFIX(QBTP)
      IF (NBTP.EQ.0) RETURN
C
C Unpack integer values from floating-point arguments.
C
      LLUA=IFIX(QLUA)
      NMJD=IFIX(QMJD)
      IF (QMND.NE.SVAL(1).AND.QMND.NE.SVAL(2)) NMND=IFIX(QMND)
      NMNT=0
      IF (QLTD.NE.SVAL(1).AND.QLTD.NE.SVAL(2)) NLTD=IFIX(QLTD)
      NLTP=0
      IF (QLED.NE.SVAL(1).AND.QLED.NE.SVAL(2)) NLED=IFIX(QLED)
      NLEX=0
      IF (QLFD.NE.SVAL(1).AND.QLFD.NE.SVAL(2)) NLFD=IFIX(QLFD)
      NLFL=0
C
C Compute label-coordinate-system values at the ends of the axis.
C
      CALL AGUTOL (IAXS,FUNS,1,UMIN,VMIN)
      CALL AGUTOL (IAXS,FUNS,1,UMAX,VMAX)
C
C Error if the label-coordinate-system values are equal.
C
      IF (VMIN.EQ.VMAX) GO TO 901
C
C If a special value is specified for the parameter BASD, AGEXAX must
C pick a value for the parameter BASE.
C
      IF (BASD.EQ.SVAL(1).OR.BASD.EQ.SVAL(2)) GO TO 101
C
C The user has specified a value for the parameter BASE.  If that value
C is less than or equal to zero, tick marks and labels are suppressed.
C
      BASE=AMAX1(0.,BASD)
      IF (BASE.EQ.0.) RETURN
      NMNT=0
      GO TO 108
C
C Pick a value for the parameter BASE, depending on the number type.
C
  101 GO TO (102,105,106) , NBTP
C
C Major ticks and labels are at numbers of the form (-) BASE * EXMU.
C
  102 NMJD=MAX0(0,NMJD)
C
C Compute an approximate value for BASE.
C
      FTMP=ABS(VMAX-VMIN)/FLOAT(NMJD+1)
C
C Reduce the approximate value to the form FTMP * 10 ** ITMP.
C
      ASSIGN 103 TO JMP1
      GO TO 200
C
C Pick a reasonable value for BASE (1., 2., OR 5. * 10**ITMP).
C
  103 DO 104 I=1,5
        IF (FTMP.LT.BASP(I)) GO TO 104
        BASE=BASP(I)*SNGL(10.D0**ITMP)
        NMNT=NMNP(I)
        GO TO 107
  104 CONTINUE
C
C Major ticks and labels are at numbers of the form (-) BASE * 10**EXMU.
C
  105 BASE=1.
      NMNT=8
      GO TO 107
C
C Major ticks and labels are at numbers of the form (-) BASE**EXMU.
C
  106 BASE=10.
      NMNT=8
C
  107 IF (BASD.EQ.SVAL(2)) BASD=BASE
C
  108 IF (QMND.NE.SVAL(1).AND.QMND.NE.SVAL(2)) NMNT=MAX0(0,NMND)
      IF (QMND.EQ.SVAL(2)) QMND=FLOAT(NMNT)
C
C If the user wants nice values at the axis ends, reset UMIN and UMAX.
C
      IF (NICE.NE.0) GO TO 115
C
      LOOP=0
C
      WMIN=VMIN
      WMAX=VMAX
C
      GO TO (109,110,112) , NBTP
C
  109 EMIN=VMIN/BASE+.5+SIGN(.5,VMIN-VMAX)
      EMIN=EMIN-.5+SIGN(.5,EMIN)-SIGN(SMRL*EMIN,VMIN-VMAX)
      WMIN=BASE*(EMIN-AMOD(EMIN,1.))
      EMAX=VMAX/BASE+.5+SIGN(.5,VMAX-VMIN)
      EMAX=EMAX-.5+SIGN(.5,EMAX)-SIGN(SMRL*EMAX,VMAX-VMIN)
      WMAX=BASE*(EMAX-AMOD(EMAX,1.))
      GO TO 114
C
  110 IF (VMIN.EQ.0.) GO TO 111
      EMIN=ALOG10(ABS(VMIN)/BASE)+.5+SIGN(.5,VMIN*(VMIN-VMAX))
      EMIN=EMIN-.5+SIGN(.5,EMIN)-SIGN(SMRL*EMIN,VMIN*(VMIN-VMAX))
      WMIN=SIGN(BASE,VMIN)*10.**(EMIN-AMOD(EMIN,1.))
  111 IF (VMAX.EQ.0.) GO TO 114
      EMAX=ALOG10(ABS(VMAX)/BASE)+.5+SIGN(.5,VMAX*(VMAX-VMIN))
      EMAX=EMAX-.5+SIGN(.5,EMAX)-SIGN(SMRL*EMAX,VMAX*(VMAX-VMIN))
      WMAX=SIGN(BASE,VMAX)*10.**(EMAX-AMOD(EMAX,1.))
      GO TO 114
C
  112 IF (BASE.EQ.1.) GO TO 115
      IF (VMIN.EQ.0.) GO TO 113
      EMIN=ALOG10(ABS(VMIN))/ALOG10(BASE)+.5+SIGN(.5,VMIN*(VMIN-VMAX))
      EMIN=EMIN-.5+SIGN(.5,EMIN)-SIGN(SMRL*EMIN,VMIN*(VMIN-VMAX))
      WMIN=SIGN(1.,VMIN)*BASE**(EMIN-AMOD(EMIN,1.))
  113 IF (VMAX.EQ.0.) GO TO 114
      EMAX=ALOG10(ABS(VMAX))/ALOG10(BASE)+.5+SIGN(.5,VMAX*(VMAX-VMIN))
      EMAX=EMAX-.5+SIGN(.5,EMAX)-SIGN(SMRL*EMAX,VMAX*(VMAX-VMIN))
      WMAX=SIGN(1.,VMAX)*BASE**(EMAX-AMOD(EMAX,1.))
C
C Re-compute the user-coordinate-system minimum and maximum values.
C
  114 CALL AGUTOL (IAXS,FUNS,-1,WMIN,QMIN)
      CALL AGUTOL (IAXS,FUNS,-1,WMAX,QMAX)
C
C Test for problems with nice values chosen.
C
      IF (QMIN.LT.QMAX) GO TO 140
      IF (QMIN.GT.QMAX) GO TO 901
C
C We have a pathological case - user values are clustered very close to
C a label position.  See what can be done about it.
C
      LOOP=LOOP+1
      IF (LOOP.GT.1) GO TO 901
C
      GO TO (137,138,139) , NBTP
C
  137 VMIN=VMIN+SIGN(BASE,VMIN-VMAX)
      VMAX=VMAX+SIGN(BASE,VMAX-VMIN)
      GO TO 109
C
  138 VMIN=VMIN*10.**SIGN(1.,VMIN*(VMIN-VMAX))
      VMAX=VMAX*10.**SIGN(1.,VMAX*(VMAX-VMIN))
      GO TO 110
C
  139 VMIN=VMIN*BASE**SIGN(1.,VMIN*(VMIN-VMAX))
      VMAX=VMAX*BASE**SIGN(1.,VMAX*(VMAX-VMIN))
      GO TO 112
C
  140 VMIN=WMIN
      VMAX=WMAX
C
C Now we examine the parameters defining the appearance of the numeric
C labels.  If the numeric-label type is zero, there is no more to do.
C
  115 IF (QLTD.EQ.SVAL(1).OR.QLTD.EQ.SVAL(2)) GO TO 116
      NLTP=MAX0(0,MIN0(3,NLTD))
      IF (NLTP.EQ.0) GO TO 136
C
C The numeric-label type (NLTP) is specified.  If both the numeric-label
C exponent and numeric-label fraction-length are also specified, quit.
C
      NLEX=NLED
      NLFL=NLFD
      IF (QLED.NE.SVAL(1).AND.QLED.NE.SVAL(2).AND.
     +    QLFD.NE.SVAL(1).AND.QLFD.NE.SVAL(2)       ) GO TO 136
      GO TO 117
C
C We must pick a value for the numeric-label type.  Start with the dummy
C value 4 so as to jump to the proper piece of code.
C
  116 NLTP=4
C
C Reduce the value of BASE to the form RBSE * 10**KBSE, where RBSE is
C in the range (1,10) and KBSE is an integer.
C
  117 FTMP=BASE
      ASSIGN 118 TO JMP1
      GO TO 200
C
  118 RBSE=FTMP
      KBSE=ITMP
C
C Compute LBSE = the number of significant digits in RBSE.
C
      ASSIGN 119 TO JMP2
      GO TO 300
C
  119 LBSE=1+ITMP
C
C Jump depending on the value of the numeric-label type.
C
      GO TO (120,128,131,132) , NLTP
C
C Scientific notation is to be used.  Estimate the number of significant
C digits that are likely to be required, depending on the number type.
C
  120 GO TO (121,123,124) , NBTP
C
  121 FTMP=AMAX1(ABS(VMIN),ABS(VMAX))/BASE
      ASSIGN 122 TO JMP1
      GO TO 200
C
  122 NSIG=MAX0(1,ITMP+1+LBSE)
      GO TO 125
C
  123 NSIG=LBSE
      GO TO 125
C
  124 NSIG=10
C
C NLEX + NLFL should be equal to NSIG.  Make that the case.
C
  125 IF (QLED.NE.SVAL(1).AND.QLED.NE.SVAL(2)) GO TO 127
      IF (QLFD.EQ.SVAL(1).OR. QLFD.EQ.SVAL(2)) GO TO 126
      NLEX=NSIG-MAX0(0,NLFL)
      GO TO 135
  126 NLEX=1
  127 NLFL=NSIG-NLEX
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C Exponential notation is to be used.  Compute the exponent NEXP such
C that BASE / 10**NEXP is an integer.
C
  128 NEXP=KBSE-LBSE+1
C
C NLEX - NLFL should be equal to NEXP.  Make that the case.  (Note that,
C if NBTP is 3, NLEX is forced to zero.)
C
      IF (NBTP.EQ.3) NLEX=0
C
      IF (QLFD.NE.SVAL(1).AND.QLFD.NE.SVAL(2)) GO TO 129
      IF (QLED.NE.SVAL(1).AND.QLED.NE.SVAL(2)) GO TO 130
      NLFL=-1
  129 NLEX=MAX0(0,NLFL)+NEXP
      GO TO 135
  130 NLFL=NLEX-NEXP
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C No-exponent notation is to be used.  NLFL is the only parameter we
C need to worry about.  If it is already set, quit.
C
  131 IF (QLFD.NE.SVAL(1).AND.QLFD.NE.SVAL(2)) GO TO 136
C
C Set NLFL to the actual number of digits in the fractional portion of
C BASE.
C
      NLFL=LBSE-KBSE-1
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C We must pick a value for the numeric-label type, depending on the
C number type.
C
  132 GO TO (133,134,134) , NBTP
C
C Nunbers are of the form (-) BASE * EXMU.  Use labels with no exponent
C unless the use of an exponent would result in shorter labels.
C
  133 IF (MAX0(KBSE+1-LBSE,-KBSE-1).GT.4) GO TO 134
      NLTP=3
      NLFL=LBSE-KBSE-1
      IF (NLFL.LE.0) NLFL=-1
      GO TO 135
C
C Exponential notation is used.
C
  134 NLTP=2
      NLEX=KBSE-LBSE+1
      NLFL=-1
C
C Back-store the computed parameters, if requested, and return.
C
  135 IF (QLTD.EQ.SVAL(2)) QLTD=FLOAT(NLTP)
      IF (QLED.EQ.SVAL(2)) QLED=FLOAT(NLEX)
      IF (QLFD.EQ.SVAL(2)) QLFD=FLOAT(NLFL)
C
C Pack up integer values to floating-point arguments and return.
C
  136 QMNT=FLOAT(NMNT)
      QLTP=FLOAT(NLTP)
      QLEX=FLOAT(NLEX)
      QLFL=FLOAT(NLFL)
      RETURN
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This internal procedure reduces the number (FTMP) to the range (1,10),
C returning (FTMP) and (ITMP) such that (FTMP) * 10**(ITMP) is equal to
C the original value of (FTMP).  (FTMP) must be positive.
C
  200 FTM1=ALOG10(FTMP+SMRL*FTMP)
      IF (FTM1.LT.0.) FTM1=FTM1-1.
      ITMP=IFIX(FTM1)
      FTMP=AMAX1(1.,FTMP*SNGL(10.D0**(-ITMP)))
      GO TO JMP1 , (103,118,122)
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This internal procedure counts the number of digits in the fractional
C portion of (FTMP), returning the count as the value of (ITMP).
C
  300 FTM1=AMOD(FTMP+SMRL*FTMP,1.)
      FTM2=10.*SMRL*FTMP
      ITMP=0
C
  301 IF (FTM1.LT.FTM2) GO TO 302
      ITMP=ITMP+1
      IF (ITMP.GE.10) GO TO 302
      FTM1=AMOD(10.*FTM1,1.)
      FTM2=10.*FTM2
      GO TO 301
C
  302 GO TO JMP2 , (119)
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C Error exit.
C
C +NOAO - Comment out FTN write and format statement, SETER is okay.
C
  901 CONTINUE
C 901 WRITE (I1MACH(4),9001) IAXS
      CALL SETER ('AGEXAX (CALLED BY AGSTUP) - USER-SYSTEM-TO-LABEL-SYST
     +EM MAPPING IS NOT MONOTONIC',1,2)
C
C Formats.
C
C9001 FORMAT ('0PROBLEM WITH AXIS NUMBER',I2,
C    +        ' (1, 2, 3, AND 4 IMPLY LEFT, RIGHT, BOTTOM, AND TOP)')
C
C -NOAO
      END

      SUBROUTINE slEULR (ORDER, PHI, THETA, PSI, RMAT)
*+
*     - - - - - -
*      E U L R
*     - - - - - -
*
*  Form a rotation matrix from the Euler angles - three successive
*  rotations about specified Cartesian axes (single precision)
*
*  Given:
*    ORDER  c*(*)    specifies about which axes the rotations occur
*    PHI    r        1st rotation (radians)
*    THETA  r        2nd rotation (   "   )
*    PSI    r        3rd rotation (   "   )
*
*  Returned:
*    RMAT   r(3,3)   rotation matrix
*
*  A rotation is positive when the reference frame rotates
*  anticlockwise as seen looking towards the origin from the
*  positive region of the specified axis.
*
*  The characters of ORDER define which axes the three successive
*  rotations are about.  A typical value is 'ZXZ', indicating that
*  RMAT is to become the direction cosine matrix corresponding to
*  rotations of the reference frame through PHI radians about the
*  old Z-axis, followed by THETA radians about the resulting X-axis,
*  then PSI radians about the resulting Z-axis.
*
*  The axis names can be any of the following, in any order or
*  combination:  X, Y, Z, uppercase or lowercase, 1, 2, 3.  Normal
*  axis labelling/numbering conventions apply;  the xyz (=123)
*  triad is right-handed.  Thus, the 'ZXZ' example given above
*  could be written 'zxz' or '313' (or even 'ZxZ' or '3xZ').  ORDER
*  is terminated by length or by the first unrecognized character.
*
*  Fewer than three rotations are acceptable, in which case the later
*  angle arguments are ignored.  If all rotations are zero, the
*  identity matrix is produced.
*
*  Called:  slDEUL
*
*  P.T.Wallace   Starlink   23 May 1997
*
*  Copyright (C) 1997 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) ORDER
      REAL PHI,THETA,PSI,RMAT(3,3)

      INTEGER J,I
      DOUBLE PRECISION W(3,3)



*  Compute matrix in double precision
      CALL slDEUL(ORDER,DBLE(PHI),DBLE(THETA),DBLE(PSI),W)

*  Copy the result
      DO J=1,3
         DO I=1,3
            RMAT(I,J) = REAL(W(I,J))
         END DO
      END DO

      END

      SUBROUTINE slDE2H (HA, DEC, PHI, AZ, EL)
*+
*     - - - - -
*      D E 2 H
*     - - - - -
*
*  Equatorial to horizon coordinates:  HA,Dec to Az,El
*
*  (double precision)
*
*  Given:
*     HA      d     hour angle
*     DEC     d     declination
*     PHI     d     observatory latitude
*
*  Returned:
*     AZ      d     azimuth
*     EL      d     elevation
*
*  Notes:
*
*  1)  All the arguments are angles in radians.
*
*  2)  Azimuth is returned in the range 0-2pi;  north is zero,
*      and east is +pi/2.  Elevation is returned in the range
*      +/-pi/2.
*
*  3)  The latitude must be geodetic.  In critical applications,
*      corrections for polar motion should be applied.
*
*  4)  In some applications it will be important to specify the
*      correct type of hour angle and declination in order to
*      produce the required type of azimuth and elevation.  In
*      particular, it may be important to distinguish between
*      elevation as affected by refraction, which would
*      require the "observed" HA,Dec, and the elevation
*      in vacuo, which would require the "topocentric" HA,Dec.
*      If the effects of diurnal aberration can be neglected, the
*      "apparent" HA,Dec may be used instead of the topocentric
*      HA,Dec.
*
*  5)  No range checking of arguments is carried out.
*
*  6)  In applications which involve many such calculations, rather
*      than calling the present routine it will be more efficient to
*      use inline code, having previously computed fixed terms such
*      as sine and cosine of latitude, and (for tracking a star)
*      sine and cosine of declination.
*
*  P.T.Wallace   Starlink   9 July 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION HA,DEC,PHI,AZ,EL

      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925286766559D0)

      DOUBLE PRECISION SH,CH,SD,CD,SP,CP,X,Y,Z,R,A


*  Useful trig functions
      SH=SIN(HA)
      CH=COS(HA)
      SD=SIN(DEC)
      CD=COS(DEC)
      SP=SIN(PHI)
      CP=COS(PHI)

*  Az,El as x,y,z
      X=-CH*CD*SP+SD*CP
      Y=-SH*CD
      Z=CH*CD*CP+SD*SP

*  To spherical
      R=SQRT(X*X+Y*Y)
      IF (R.EQ.0D0) THEN
         A=0D0
      ELSE
         A=ATAN2(Y,X)
      END IF
      IF (A.LT.0D0) A=A+D2PI
      AZ=A
      EL=ATAN2(Z,R)

      END

C--------------------------------------------------------------------------
        subroutine ftrwup(iunit,frow,lrow,nshift,status)

C       shift rows in a table up by NROWS rows, overwriting the rows above

C       iunit   i  Fortran I/O unit number
C       frow    i  first row to be moved up
C       lrow    i  last row to be moved up (last row of the table)
C       nshift  i  how far to shift the rows (number of rows)
C       status  i  returned error status (0=ok)

        integer iunit,frow,lrow,nshift,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,kshift,nchar,fchar,i,j
        integer lstptr,inptr,outptr,nseg
        character cfill*1

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       select appropriate fill value
        if (hdutyp(ibuff) .eq. 1)then
C           fill  header or ASCII table with space
            cfill=char(32)
        else
C           fill image or bintable data area with Null (0)      
            cfill=char(0)
        end if

C **********************************************************************
C       CASE #1: One or more rows of the table will fit in the work buffer,
C **********************************************************************
        if (rowlen(ibuff) .le. 5760)then

C       how many rows can we move at one time?
        kshift=5760/rowlen(ibuff)
        fchar=1

C       check if we just need to clear the last NSHIFT rows of the table
        if (frow .eq. lrow+1)go to 25

C       initialize pointers
        inptr=frow
        lstptr=inptr+kshift

20      if (lstptr .gt. lrow)lstptr=lrow
        nchar=(lstptr-inptr+1)*rowlen(ibuff)
        outptr=inptr-nshift

C       read the row(s) to be shifted
        call ftgtbs(iunit,inptr,fchar,nchar,buff,status)

C       write the row(s) to the new location
        call ftptbs(iunit,outptr,fchar,nchar,buff,status)

C       If there are more rows, update pointers and repeat
        if (lstptr .lt. lrow)then
            inptr =inptr +kshift
            lstptr=lstptr+kshift
            go to 20
        end if

C       initialize the buffer with the fill value
25      continue
        do 30 i=1,5760
            buff(i)=cfill
30      continue

C       fill the empty rows at the bottom of the table with blanks or nulls
        nchar=rowlen(ibuff)
        do 35 i=1,nshift
            outptr=lrow-nshift+i
            call ftptbs(iunit,outptr,fchar,nchar,buff,status)
35      continue
        return

C **********************************************************************
C       CASE #2:  Cannot fit a whole row into the work buffer, so have
C       to move each row in pieces.   
C **********************************************************************
        else

        nseg=(rowlen(ibuff)+5759)/5760
        nchar=5760

        do 60 j=1,nseg
            fchar=(j-1)*5760+1
            if (j .eq. nseg)nchar=rowlen(ibuff)-(nseg-1)*5760

C           check if we just need to clear the last NSHIFT rows of the table
            if (frow .eq. lrow+1)go to 45

            do 40 i=frow,lrow
C               read the row to be shifted
                call ftgtbs(iunit,i,fchar,nchar,buff,status)

C               write the row(s) to the new location
                call ftptbs(iunit,i-nshift,fchar,nchar,buff,status)
40          continue

C           initialize the buffer with the fill value
45          continue
            do 50 i=1,5760
                buff(i)=cfill
50          continue

C           fill the empty rows with blanks or nulls
            do 55 i=1,nshift
                outptr=lrow-nshift+i
                call ftptbs(iunit,outptr,fchar,nchar,buff,status)
55          continue
60      continue
        end if
        end

      SUBROUTINE slUEPV ( DATE, U, PV, JSTAT )
*+
*     - - - - - -
*      U E P V
*     - - - - - -
*
*  Heliocentric position and velocity of a planet, asteroid or comet,
*  starting from orbital elements in the "universal variables" form.
*
*  Given:
*     DATE     d       date, Modified Julian Date (JD-2400000.5)
*
*  Given and returned:
*     U        d(13)   universal orbital elements (updated; Note 1)
*
*       given    (1)   combined mass (M+m)
*         "      (2)   total energy of the orbit (alpha)
*         "      (3)   reference (osculating) epoch (t0)
*         "    (4-6)   position at reference epoch (r0)
*         "    (7-9)   velocity at reference epoch (v0)
*         "     (10)   heliocentric distance at reference epoch
*         "     (11)   r0.v0
*     returned  (12)   date (t)
*         "     (13)   universal eccentric anomaly (psi) of date
*
*  Returned:
*     PV       d(6)    position (AU) and velocity (AU/s)
*     JSTAT    i       status:  0 = OK
*                              -1 = radius vector zero
*                              -2 = failed to converge
*
*  Notes
*
*  1  The "universal" elements are those which define the orbit for the
*     purposes of the method of universal variables (see reference).
*     They consist of the combined mass of the two bodies, an epoch,
*     and the position and velocity vectors (arbitrary reference frame)
*     at that epoch.  The parameter set used here includes also various
*     quantities that can, in fact, be derived from the other
*     information.  This approach is taken to avoiding unnecessary
*     computation and loss of accuracy.  The supplementary quantities
*     are (i) alpha, which is proportional to the total energy of the
*     orbit, (ii) the heliocentric distance at epoch, (iii) the
*     outwards component of the velocity at the given epoch, (iv) an
*     estimate of psi, the "universal eccentric anomaly" at a given
*     date and (v) that date.
*
*  2  The companion routine is slELUE.  This takes the conventional
*     orbital elements and transforms them into the set of numbers
*     needed by the present routine.  A single prediction requires one
*     one call to slELUE followed by one call to the present routine;
*     for convenience, the two calls are packaged as the routine
*     slPLNE.  Multiple predictions may be made by again
*     calling slELUE once, but then calling the present routine
*     multiple times, which is faster than multiple calls to slPLNE.
*
*     It is not obligatory to use slELUE to obtain the parameters.
*     However, it should be noted that because slELUE performs its
*     own validation, no checks on the contents of the array U are made
*     by the present routine.
*
*  3  DATE is the instant for which the prediction is required.  It is
*     in the TT timescale (formerly Ephemeris Time, ET) and is a
*     Modified Julian Date (JD-2400000.5).
*
*  4  The universal elements supplied in the array U are in canonical
*     units (solar masses, AU and canonical days).  The position and
*     velocity are not sensitive to the choice of reference frame.  The
*     slELUE routine in fact produces coordinates with respect to the
*     J2000 equator and equinox.
*
*  5  The algorithm was originally adapted from the EPHSLA program of
*     D.H.P.Jones (private communication, 1996).  The method is based
*     on Stumpff's Universal Variables.
*
*  Reference:  Everhart, E. & Pitkin, E.T., Am.J.Phys. 51, 712, 1983.
*
*  P.T.Wallace   Starlink   22 October 2005
*
*  Copyright (C) 2005 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,U(13),PV(6)
      INTEGER JSTAT

*  Gaussian gravitational constant (exact)
      DOUBLE PRECISION GCON
      PARAMETER (GCON=0.01720209895D0)

*  Canonical days to seconds
      DOUBLE PRECISION CD2S
      PARAMETER (CD2S=GCON/86400D0)

*  Test value for solution and maximum number of iterations
      DOUBLE PRECISION TEST
      INTEGER NITMAX
      PARAMETER (TEST=1D-13,NITMAX=25)

      INTEGER I,NIT,N

      DOUBLE PRECISION CM,ALPHA,T0,P0(3),V0(3),R0,SIGMA0,T,PSI,DT,W,
     :                 TOL,PSJ,PSJ2,BETA,S0,S1,S2,S3,
     :                 FF,R,FLAST,PLAST,F,G,FD,GD



*  Unpack the parameters.
      CM = U(1)
      ALPHA = U(2)
      T0 = U(3)
      DO I=1,3
         P0(I) = U(I+3)
         V0(I) = U(I+6)
      END DO
      R0 = U(10)
      SIGMA0 = U(11)
      T = U(12)
      PSI = U(13)

*  Approximately update the universal eccentric anomaly.
      PSI = PSI+(DATE-T)*GCON/R0

*  Time from reference epoch to date (in Canonical Days: a canonical
*  day is 58.1324409... days, defined as 1/GCON).
      DT = (DATE-T0)*GCON

*  Refine the universal eccentric anomaly, psi.
      NIT = 1
      W = 1D0
      TOL = 0D0
      DO WHILE (ABS(W).GE.TOL)

*     Form half angles until BETA small enough.
         N = 0
         PSJ = PSI
         PSJ2 = PSJ*PSJ
         BETA = ALPHA*PSJ2
         DO WHILE (ABS(BETA).GT.0.7D0)
            N = N+1
            BETA = BETA/4D0
            PSJ = PSJ/2D0
            PSJ2 = PSJ2/4D0
         END DO

*     Calculate Universal Variables S0,S1,S2,S3 by nested series.
         S3 = PSJ*PSJ2*((((((BETA/210D0+1D0)
     :                      *BETA/156D0+1D0)
     :                      *BETA/110D0+1D0)
     :                      *BETA/72D0+1D0)
     :                      *BETA/42D0+1D0)
     :                      *BETA/20D0+1D0)/6D0
         S2 = PSJ2*((((((BETA/182D0+1D0)
     :                  *BETA/132D0+1D0)
     :                  *BETA/90D0+1D0)
     :                  *BETA/56D0+1D0)
     :                  *BETA/30D0+1D0)
     :                  *BETA/12D0+1D0)/2D0
         S1 = PSJ+ALPHA*S3
         S0 = 1D0+ALPHA*S2

*     Undo the angle-halving.
         TOL = TEST
         DO WHILE (N.GT.0)
            S3 = 2D0*(S0*S3+PSJ*S2)
            S2 = 2D0*S1*S1
            S1 = 2D0*S0*S1
            S0 = 2D0*S0*S0-1D0
            PSJ = PSJ+PSJ
            TOL = TOL+TOL
            N = N-1
         END DO

*     Values of F and F' corresponding to the current value of psi.
         FF = R0*S1+SIGMA0*S2+CM*S3-DT
         R = R0*S0+SIGMA0*S1+CM*S2

*     If first iteration, create dummy "last F".
         IF ( NIT.EQ.1) FLAST = FF

*     Check for sign change.
         IF ( FF*FLAST.LT.0D0 ) THEN

*        Sign change:  get psi adjustment using secant method.
            W = FF*(PLAST-PSI)/(FLAST-FF)
         ELSE

*        No sign change:  use Newton-Raphson method instead.
            IF (R.EQ.0D0) GO TO 9010
            W = FF/R
         END IF

*     Save the last psi and F values.
         PLAST = PSI
         FLAST = FF

*     Apply the Newton-Raphson or secant adjustment to psi.
         PSI = PSI-W

*     Next iteration, unless too many already.
         IF (NIT.GT.NITMAX) GO TO 9020
         NIT = NIT+1
      END DO

*  Project the position and velocity vectors (scaling velocity to AU/s).
      W = CM*S2
      F = 1D0-W/R0
      G = DT-CM*S3
      FD = -CM*S1/(R0*R)
      GD = 1D0-W/R
      DO I=1,3
         PV(I) = P0(I)*F+V0(I)*G
         PV(I+3) = CD2S*(P0(I)*FD+V0(I)*GD)
      END DO

*  Update the parameters to allow speedy prediction of PSI next time.
      U(12) = DATE
      U(13) = PSI

*  OK exit.
      JSTAT = 0
      GO TO 9999

*  Null radius vector.
 9010 CONTINUE
      JSTAT = -1
      GO TO 9999

*  Failed to converge.
 9020 CONTINUE
      JSTAT = -2

 9999 CONTINUE
      END

c IMDEL -- Delete an image.
c
c	usage:  imdel imagename
c ----------------------------------------------------------------------

	program imdel

	integer		ier
	character*80	image, errmsg

c --- Get the name of the image to be deleted.
	call clargc (1, image, ier)
	if (ier .ne. 0) then
	    write (*, '('' enter image name: '',$)')
	    read (*,*) image
	endif

c --- Delete the image.
	call imdele (image, ier)
	if (ier .ne. 0) goto 91

	stop

c --- Error exit.
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg

	stop
	end

      subroutine skipbl(lin, i)
      integer lin(100)
      integer i
23000 if (.not.(lin (i) .eq. 32 .or. lin (i) .eq. 9))goto 23001
      i = i + 1
      goto 23000
23001 continue
      return
      end

      subroutine outch (c)
      integer c, splbuf(8+1)
      integer i, ip, op, index
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      external index
      integer break0(10)
      data break0(1)/32/,break0(2)/41/,break0(3)/44/,break0(4)/46/,break
     *0(5)/43/,break0(6)/45/,break0(7)/42/,break0(8)/47/,break0(9)/40/,b
     *reak0(10)/-2/
      if (.not.(outp .ge. 72))goto 23000
      if (.not.(index (break0, c) .gt. 0))goto 23002
      ip = outp
      goto 23003
23002 continue
      ip=outp
23004 if (.not.(ip .ge. 1))goto 23006
      if (.not.(index (break0, outbuf(ip)) .gt. 0))goto 23007
      goto 23006
23007 continue
23005 ip=ip-1
      goto 23004
23006 continue
23003 continue
      if (.not.(ip .ne. outp .and. (outp-ip) .lt. 8))goto 23009
      op = 1
      i=ip+1
23011 if (.not.(i .le. outp))goto 23013
      splbuf(op) = outbuf(i)
      op = op + 1
23012 i=i+1
      goto 23011
23013 continue
      splbuf(op) = -2
      outp = ip
      goto 23010
23009 continue
      splbuf(1) = -2
23010 continue
      call outdon
      op=1
23014 if (.not.(op .lt. col))goto 23016
      outbuf(op) = 32
23015 op=op+1
      goto 23014
23016 continue
      outbuf(6) = 42
      outp = col
      ip=1
23017 if (.not.(splbuf(ip) .ne. -2))goto 23019
      outp = outp + 1
      outbuf(outp) = splbuf(ip)
23018 ip=ip+1
      goto 23017
23019 continue
23000 continue
      outp = outp + 1
      outbuf(outp) = c
      end
c     logic0  logical_column
c     break0  break_chars

C----------------------------------------------------------------------
        subroutine ftmrhd(iunit,extmov,xtend,status)

C       Move Relative Header Data unit
C       move the i/o pointer to the specified HDU and initialize all
C       the common block parameters which describe the extension

C       iunit   i  fortran unit number
C       extmov  i  number of the extension to point to, relative to the CHDU
C       xtend   i  returned type of extension:   0 = the primary HDU
C                                                1 = an ASCII table
C                                                2 = a binary table
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1991

        integer iunit,extmov,xtend,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,extno

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       calculate the absolute HDU number, then move to it
        extno=chdu(ibuff)+extmov
        call ftmahd(iunit,extno,xtend,status)
        end        

C----------------------------------------------------------------------
        subroutine ftpgpb(ounit,group,fparm,nparm,array,status)

C       Write an array of group parmeters into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being written).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       fparm   i  the first group parameter to be written (starting with 1)
C       nparm   i  number of group parameters to be written
C       array   b  the array of group parameters to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,fparm,nparm,status,row

        character*1 array(*)

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
        row=max(group,1)
        call ftpclb(ounit,1,row,fparm,nparm,array,status)
        end

      subroutine brknxt (sp, lextyp, labval, token)
      integer labval (100), lextyp (100), sp, token
      integer i, n
      integer alldig, ctoi
      integer t, ptoken (100)
      integer gnbtok
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      n = 0
      t = gnbtok (ptoken, 100)
      if (.not.(alldig (ptoken) .eq. 1))goto 23000
      i = 1
      n = ctoi (ptoken, i) - 1
      goto 23001
23000 continue
      if (.not.(t .ne. 59))goto 23002
      call pbstr (ptoken)
23002 continue
23001 continue
      i = sp
23004 if (.not.(i .gt. 0))goto 23006
      if (.not.(lextyp (i) .eq. -95 .or. lextyp (i) .eq. -96 .or. lextyp
     * (i) .eq. -94 .or. lextyp (i) .eq. -93))goto 23007
      if (.not.(n .gt. 0))goto 23009
      n = n - 1
      goto 23005
23009 continue
      if (.not.(token .eq. -79))goto 23011
      call outgo (labval (i) + 1)
      goto 23012
23011 continue
      call outgo (labval (i))
23012 continue
23010 continue
      xfer = 1
      return
23007 continue
23005 i = i - 1
      goto 23004
23006 continue
      if (.not.(token .eq. -79))goto 23013
      call synerr (14Hillegal break.)
      goto 23014
23013 continue
      call synerr (13Hillegal next.)
23014 continue
      return
      end
c     logic0  logical_column

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGEXUS (SVAL,ZMIN,ZMAX,ZLOW,ZHGH,
     +                               ZDRA,NVIZ,IIVZ,NEVZ,IIEZ,UMIN,UMAX)
C
      DIMENSION SVAL(2),ZDRA(1)
C
C The routine AGEXUS is used by AGSTUP to determine tentative values of
C the user-window edge coordinates.  Its arguments are as follows:
C
C -- SVAL is the array of special values.
C
C -- ZMIN and ZMAX are user-supplied minimum and maximum values of the
C    data x (or y) coordinates.
C
C -- ZLOW and ZHGH are, respectively, the smallest and largest data
C    values to be considered in choosing the minimum and maximum, if
C    those values, as given by the user, are null.
C
C -- ZDRA, NVIZ, IIVZ, NEVZ, and IIEZ specify the array of x (or y)
C    data coordinates (see AGMAXI or AGMINI for complete description).
C
C -- UMIN and UMAX are returned with tentative minimum and maximum
C    values for use at the appropriate user-window edges (left/right
C    or bottom/top).
C
C The following common block contains AUTOGRAPH variables which are
C not control parameters.  The only one used here is SMRL, which is a
C (machine-dependent) small real which, when added to a number in the
C range (1,10), will round it upward without seriously affecting the
C leading significant digits.  The object of this is to get rid of
C strings of nines.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C Assume initially that the user has provided actual values to be used.
C
      UMIN=ZMIN
      UMAX=ZMAX
C
C If either of the values is null, replace it by a data-based value.
C
      IF (UMIN.EQ.SVAL(1).OR.UMIN.EQ.SVAL(2))
     +                UMIN=AGMINI(SVAL(1),ZLOW,ZDRA,NVIZ,IIVZ,NEVZ,IIEZ)
      IF (UMAX.EQ.SVAL(1).OR.UMAX.EQ.SVAL(2))
     +                UMAX=AGMAXI(SVAL(1),ZHGH,ZDRA,NVIZ,IIVZ,NEVZ,IIEZ)
C
C Either or both values might still be null (if the user data was null).
C
      IF (UMIN.EQ.SVAL(1)) UMIN=UMAX
      IF (UMAX.EQ.SVAL(1)) UMAX=UMIN
C
C Check the relative values of UMIN and UMAX for problems.
C
      IF (ABS(UMIN-UMAX).LT.50.*SMRL*(ABS(UMIN)+ABS(UMAX))) GO TO 102
      IF (UMAX-UMIN) 101,102,103
  101 IF (ZMIN.NE.SVAL(1).AND.ZMIN.NE.SVAL(2)) UMAX=UMIN
      IF (ZMAX.NE.SVAL(1).AND.ZMAX.NE.SVAL(2)) UMIN=UMAX
C
  102 UMIN=UMIN-.5*ABS(UMIN)
      UMAX=UMAX+.5*ABS(UMAX)
      IF (UMIN.NE.UMAX) GO TO 103
      UMIN=-1.
      UMAX=+1.
C
C If the user wanted these values back-stored, do it.
C
  103 IF (ZMIN.EQ.SVAL(2)) ZMIN=UMIN
      IF (ZMAX.EQ.SVAL(2)) ZMAX=UMAX
C
C Done.
C
      RETURN
C
      END

      subroutine option (icas,int,ital,ior)
      call optn (4hcase,icas)
      if (int .eq. 0) call optn (4hintn,3hlow)
      if (int .eq. 1) call optn (4hintn,4hhigh)
      call optn (4hfont,ital)
      call optn (4horen,ior)
      return
      end

      SUBROUTINE slNUTC80 (DATE, DPSI, DEPS, EPS0)
*+
*     - - - - - - -
*      N U T C 8 0
*     - - - - - - -
*
*  Nutation:  longitude & obliquity components and mean obliquity,
*  using the IAU 1980 theory (double precision)
*
*  Given:
*     DATE        d     TDB (loosely ET) as Modified Julian Date
*                                            (JD-2400000.5)
*  Returned:
*     DPSI,DEPS   d     nutation in longitude,obliquity
*     EPS0        d     mean obliquity
*
*  Called:  slDA1P
*
*  Notes:
*
*  1  Earth attitude predictions made by combining the present nutation
*     model with IAU 1976 precession are accurate to 0.35 arcsec over
*     the interval 1900-2100.  (The accuracy is much better near the
*     middle of the interval.)
*
*  2  The slNUTC routine is the equivalent of the present routine
*     but using the Shirai & Fukushima 2001 forced nutation theory
*     (SF2001).  The newer theory is more accurate than IAU 1980,
*     within 1 mas (with respect to the ICRF) for a few decades around
*     2000.  The improvement is mainly because of the corrections to the
*     IAU 1976 precession that the SF2001 theory includes.
*
*  References:
*     Final report of the IAU Working Group on Nutation,
*      chairman P.K.Seidelmann, 1980.
*     Kaplan,G.H., 1981, USNO circular no. 163, pA3-6.
*
*  P.T.Wallace   Starlink   7 October 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,DPSI,DEPS,EPS0

      DOUBLE PRECISION T2AS,AS2R,U2R
      DOUBLE PRECISION T,EL,EL2,EL3
      DOUBLE PRECISION ELP,ELP2
      DOUBLE PRECISION F,F2,F4
      DOUBLE PRECISION D,D2,D4
      DOUBLE PRECISION OM,OM2
      DOUBLE PRECISION DP,DE
      DOUBLE PRECISION A

      DOUBLE PRECISION slDA1P


*  Turns to arc seconds
      PARAMETER (T2AS=1296000D0)
*  Arc seconds to radians
      PARAMETER (AS2R=0.484813681109535994D-5)
*  Units of 0.0001 arcsec to radians
      PARAMETER (U2R=AS2R/1D4)




*  Interval between basic epoch J2000.0 and current epoch (JC)
      T=(DATE-51544.5D0)/36525D0

*
*  FUNDAMENTAL ARGUMENTS in the FK5 reference system
*

*  Mean longitude of the Moon minus mean longitude of the Moon's perigee
      EL=slDA1P(AS2R*(485866.733D0+(1325D0*T2AS+715922.633D0
     :                   +(31.310D0+0.064D0*T)*T)*T))

*  Mean longitude of the Sun minus mean longitude of the Sun's perigee
      ELP=slDA1P(AS2R*(1287099.804D0+(99D0*T2AS+1292581.224D0
     :                   +(-0.577D0-0.012D0*T)*T)*T))

*  Mean longitude of the Moon minus mean longitude of the Moon's node
      F=slDA1P(AS2R*(335778.877D0+(1342D0*T2AS+295263.137D0
     :                   +(-13.257D0+0.011D0*T)*T)*T))

*  Mean elongation of the Moon from the Sun
      D=slDA1P(AS2R*(1072261.307D0+(1236D0*T2AS+1105601.328D0
     :                   +(-6.891D0+0.019D0*T)*T)*T))

*  Longitude of the mean ascending node of the lunar orbit on the
*   ecliptic, measured from the mean equinox of date
      OM=slDA1P(AS2R*(450160.280D0+(-5D0*T2AS-482890.539D0
     :                   +(7.455D0+0.008D0*T)*T)*T))

*  Multiples of arguments
      EL2=EL+EL
      EL3=EL2+EL
      ELP2=ELP+ELP
      F2=F+F
      F4=F2+F2
      D2=D+D
      D4=D2+D2
      OM2=OM+OM


*
*  SERIES FOR THE NUTATION
*
      DP=0D0
      DE=0D0

*  106
      DP=DP+SIN(ELP+D)
*  105
      DP=DP-SIN(F2+D4+OM2)
*  104
      DP=DP+SIN(EL2+D2)
*  103
      DP=DP-SIN(EL-F2+D2)
*  102
      DP=DP-SIN(EL+ELP-D2+OM)
*  101
      DP=DP-SIN(-ELP+F2+OM)
*  100
      DP=DP-SIN(EL-F2-D2)
*  99
      DP=DP-SIN(ELP+D2)
*  98
      DP=DP-SIN(F2-D+OM2)
*  97
      DP=DP-SIN(-F2+OM)
*  96
      DP=DP+SIN(-EL-ELP+D2+OM)
*  95
      DP=DP+SIN(ELP+F2+OM)
*  94
      DP=DP-SIN(EL+F2-D2)
*  93
      DP=DP+SIN(EL3+F2-D2+OM2)
*  92
      DP=DP+SIN(F4-D2+OM2)
*  91
      DP=DP-SIN(EL+D2+OM)
*  90
      DP=DP-SIN(EL2+F2+D2+OM2)
*  89
      A=EL2+F2-D2+OM
      DP=DP+SIN(A)
      DE=DE-COS(A)
*  88
      DP=DP+SIN(EL-ELP-D2)
*  87
      DP=DP+SIN(-EL+F4+OM2)
*  86
      A=-EL2+F2+D4+OM2
      DP=DP-SIN(A)
      DE=DE+COS(A)
*  85
      A=EL+F2+D2+OM
      DP=DP-SIN(A)
      DE=DE+COS(A)
*  84
      A=EL+ELP+F2-D2+OM2
      DP=DP+SIN(A)
      DE=DE-COS(A)
*  83
      DP=DP-SIN(EL2-D4)
*  82
      A=-EL+F2+D4+OM2
      DP=DP-2D0*SIN(A)
      DE=DE+COS(A)
*  81
      A=-EL2+F2+D2+OM2
      DP=DP+SIN(A)
      DE=DE-COS(A)
*  80
      DP=DP-SIN(EL-D4)
*  79
      A=-EL+OM2
      DP=DP+SIN(A)
      DE=DE-COS(A)
*  78
      A=F2+D+OM2
      DP=DP+2D0*SIN(A)
      DE=DE-COS(A)
*  77
      DP=DP+2D0*SIN(EL3)
*  76
      A=EL+OM2
      DP=DP-2D0*SIN(A)
      DE=DE+COS(A)
*  75
      A=EL2+OM
      DP=DP+2D0*SIN(A)
      DE=DE-COS(A)
*  74
      A=-EL+F2-D2+OM
      DP=DP-2D0*SIN(A)
      DE=DE+COS(A)
*  73
      A=EL+ELP+F2+OM2
      DP=DP+2D0*SIN(A)
      DE=DE-COS(A)
*  72
      A=-ELP+F2+D2+OM2
      DP=DP-3D0*SIN(A)
      DE=DE+COS(A)
*  71
      A=EL3+F2+OM2
      DP=DP-3D0*SIN(A)
      DE=DE+COS(A)
*  70
      A=-EL2+OM
      DP=DP-2D0*SIN(A)
      DE=DE+COS(A)
*  69
      A=-EL-ELP+F2+D2+OM2
      DP=DP-3D0*SIN(A)
      DE=DE+COS(A)
*  68
      A=EL-ELP+F2+OM2
      DP=DP-3D0*SIN(A)
      DE=DE+COS(A)
*  67
      DP=DP+3D0*SIN(EL+F2)
*  66
      DP=DP-3D0*SIN(EL+ELP)
*  65
      DP=DP-4D0*SIN(D)
*  64
      DP=DP+4D0*SIN(EL-F2)
*  63
      DP=DP-4D0*SIN(ELP-D2)
*  62
      A=EL2+F2+OM
      DP=DP-5D0*SIN(A)
      DE=DE+3D0*COS(A)
*  61
      DP=DP+5D0*SIN(EL-ELP)
*  60
      A=-D2+OM
      DP=DP-5D0*SIN(A)
      DE=DE+3D0*COS(A)
*  59
      A=EL+F2-D2+OM
      DP=DP+6D0*SIN(A)
      DE=DE-3D0*COS(A)
*  58
      A=F2+D2+OM
      DP=DP-7D0*SIN(A)
      DE=DE+3D0*COS(A)
*  57
      A=D2+OM
      DP=DP-6D0*SIN(A)
      DE=DE+3D0*COS(A)
*  56
      A=EL2+F2-D2+OM2
      DP=DP+6D0*SIN(A)
      DE=DE-3D0*COS(A)
*  55
      DP=DP+6D0*SIN(EL+D2)
*  54
      A=EL+F2+D2+OM2
      DP=DP-8D0*SIN(A)
      DE=DE+3D0*COS(A)
*  53
      A=-ELP+F2+OM2
      DP=DP-7D0*SIN(A)
      DE=DE+3D0*COS(A)
*  52
      A=ELP+F2+OM2
      DP=DP+7D0*SIN(A)
      DE=DE-3D0*COS(A)
*  51
      DP=DP-7D0*SIN(EL+ELP-D2)
*  50
      A=-EL+F2+D2+OM
      DP=DP-10D0*SIN(A)
      DE=DE+5D0*COS(A)
*  49
      A=EL-D2+OM
      DP=DP-13D0*SIN(A)
      DE=DE+7D0*COS(A)
*  48
      A=-EL+D2+OM
      DP=DP+16D0*SIN(A)
      DE=DE-8D0*COS(A)
*  47
      A=-EL+F2+OM
      DP=DP+21D0*SIN(A)
      DE=DE-10D0*COS(A)
*  46
      DP=DP+26D0*SIN(F2)
      DE=DE-COS(F2)
*  45
      A=EL2+F2+OM2
      DP=DP-31D0*SIN(A)
      DE=DE+13D0*COS(A)
*  44
      A=EL+F2-D2+OM2
      DP=DP+29D0*SIN(A)
      DE=DE-12D0*COS(A)
*  43
      DP=DP+29D0*SIN(EL2)
      DE=DE-COS(EL2)
*  42
      A=F2+D2+OM2
      DP=DP-38D0*SIN(A)
      DE=DE+16D0*COS(A)
*  41
      A=EL+F2+OM
      DP=DP-51D0*SIN(A)
      DE=DE+27D0*COS(A)
*  40
      A=-EL+F2+D2+OM2
      DP=DP-59D0*SIN(A)
      DE=DE+26D0*COS(A)
*  39
      A=-EL+OM
      DP=DP+(-58D0-0.1D0*T)*SIN(A)
      DE=DE+32D0*COS(A)
*  38
      A=EL+OM
      DP=DP+(63D0+0.1D0*T)*SIN(A)
      DE=DE-33D0*COS(A)
*  37
      DP=DP+63D0*SIN(D2)
      DE=DE-2D0*COS(D2)
*  36
      A=-EL+F2+OM2
      DP=DP+123D0*SIN(A)
      DE=DE-53D0*COS(A)
*  35
      A=EL-D2
      DP=DP-158D0*SIN(A)
      DE=DE-COS(A)
*  34
      A=EL+F2+OM2
      DP=DP-301D0*SIN(A)
      DE=DE+(129D0-0.1D0*T)*COS(A)
*  33
      A=F2+OM
      DP=DP+(-386D0-0.4D0*T)*SIN(A)
      DE=DE+200D0*COS(A)
*  32
      DP=DP+(712D0+0.1D0*T)*SIN(EL)
      DE=DE-7D0*COS(EL)
*  31
      A=F2+OM2
      DP=DP+(-2274D0-0.2D0*T)*SIN(A)
      DE=DE+(977D0-0.5D0*T)*COS(A)
*  30
      DP=DP-SIN(ELP+F2-D2)
*  29
      DP=DP+SIN(-EL+D+OM)
*  28
      DP=DP+SIN(ELP+OM2)
*  27
      DP=DP-SIN(ELP-F2+D2)
*  26
      DP=DP+SIN(-F2+D2+OM)
*  25
      DP=DP+SIN(EL2+ELP-D2)
*  24
      DP=DP-4D0*SIN(EL-D)
*  23
      A=ELP+F2-D2+OM
      DP=DP+4D0*SIN(A)
      DE=DE-2D0*COS(A)
*  22
      A=EL2-D2+OM
      DP=DP+4D0*SIN(A)
      DE=DE-2D0*COS(A)
*  21
      A=-ELP+F2-D2+OM
      DP=DP-5D0*SIN(A)
      DE=DE+3D0*COS(A)
*  20
      A=-EL2+D2+OM
      DP=DP-6D0*SIN(A)
      DE=DE+3D0*COS(A)
*  19
      A=-ELP+OM
      DP=DP-12D0*SIN(A)
      DE=DE+6D0*COS(A)
*  18
      A=ELP2+F2-D2+OM2
      DP=DP+(-16D0+0.1D0*T)*SIN(A)
      DE=DE+7D0*COS(A)
*  17
      A=ELP+OM
      DP=DP-15D0*SIN(A)
      DE=DE+9D0*COS(A)
*  16
      DP=DP+(17D0-0.1D0*T)*SIN(ELP2)
*  15
      DP=DP-22D0*SIN(F2-D2)
*  14
      A=EL2-D2
      DP=DP+48D0*SIN(A)
      DE=DE+COS(A)
*  13
      A=F2-D2+OM
      DP=DP+(129D0+0.1D0*T)*SIN(A)
      DE=DE-70D0*COS(A)
*  12
      A=-ELP+F2-D2+OM2
      DP=DP+(217D0-0.5D0*T)*SIN(A)
      DE=DE+(-95D0+0.3D0*T)*COS(A)
*  11
      A=ELP+F2-D2+OM2
      DP=DP+(-517D0+1.2D0*T)*SIN(A)
      DE=DE+(224D0-0.6D0*T)*COS(A)
*  10
      DP=DP+(1426D0-3.4D0*T)*SIN(ELP)
      DE=DE+(54D0-0.1D0*T)*COS(ELP)
*  9
      A=F2-D2+OM2
      DP=DP+(-13187D0-1.6D0*T)*SIN(A)
      DE=DE+(5736D0-3.1D0*T)*COS(A)
*  8
      DP=DP+SIN(EL2-F2+OM)
*  7
      A=-ELP2+F2-D2+OM
      DP=DP-2D0*SIN(A)
      DE=DE+1D0*COS(A)
*  6
      DP=DP-3D0*SIN(EL-ELP-D)
*  5
      A=-EL2+F2+OM2
      DP=DP-3D0*SIN(A)
      DE=DE+1D0*COS(A)
*  4
      DP=DP+11D0*SIN(EL2-F2)
*  3
      A=-EL2+F2+OM
      DP=DP+46D0*SIN(A)
      DE=DE-24D0*COS(A)
*  2
      DP=DP+(2062D0+0.2D0*T)*SIN(OM2)
      DE=DE+(-895D0+0.5D0*T)*COS(OM2)
*  1
      DP=DP+(-171996D0-174.2D0*T)*SIN(OM)
      DE=DE+(92025D0+8.9D0*T)*COS(OM)

*  Convert results to radians
      DPSI=DP*U2R
      DEPS=DE*U2R

*  Mean obliquity
      EPS0=AS2R*(84381.448D0+
     :           (-46.8150D0+
     :           (-0.00059D0+
     :           0.001813D0*T)*T)*T)

      END

C------------------------------------------------------------------------------
        subroutine ftfiou(iounit,status)

C       free specified logical unit number; if iounit=-1, then free all units

        integer iounit,status

        if (status .gt. 0)return

        call ftxiou(iounit,status)
        end

      subroutine pbstr (s)
      integer s(100)
      integer lenstr, i
      integer length
      lenstr = length (s)
      if (.not.(s(1) .eq. 46 .and. s(lenstr) .eq. 46))goto 23000
      if (.not.(lenstr .eq. 4))goto 23002
      if (.not.(s(2) .eq. 103))goto 23004
      if (.not.(s(3) .eq. 116))goto 23006
      call putbak (62)
      return
23006 continue
      if (.not.(s(3) .eq. 101))goto 23008
      call putbak (61)
      call putbak (62)
      return
23008 continue
23007 continue
      goto 23005
23004 continue
      if (.not.(s(2) .eq. 108))goto 23010
      if (.not.(s(3) .eq. 116))goto 23012
      call putbak (60)
      return
23012 continue
      if (.not.(s(3) .eq. 101))goto 23014
      call putbak (61)
      call putbak (60)
      return
23014 continue
23013 continue
      goto 23011
23010 continue
      if (.not.(s(2) .eq. 101 .and. s(3) .eq. 113))goto 23016
      call putbak (61)
      call putbak (61)
      return
23016 continue
      if (.not.(s(2) .eq. 110 .and. s(3) .eq. 101))goto 23018
      call putbak (61)
      call putbak (33)
      return
23018 continue
      if (.not.(s(2) .eq. 111 .and. s(3) .eq. 114))goto 23020
      call putbak (124)
      return
23020 continue
23019 continue
23017 continue
23011 continue
23005 continue
      goto 23003
23002 continue
      if (.not.(lenstr .eq. 5))goto 23022
      if (.not.(s(2) .eq. 110 .and. s(3) .eq. 111 .and. s(4) .eq. 116))g
     *oto 23024
      call putbak (33)
      return
23024 continue
      if (.not.(s(2) .eq. 97 .and. s(3) .eq. 110 .and. s(4) .eq. 100))go
     *to 23026
      call putbak (38)
      return
23026 continue
23025 continue
23022 continue
23003 continue
23000 continue
      i=lenstr
23028 if (.not.(i .gt. 0))goto 23030
      call putbak (s(i))
23029 i=i-1
      goto 23028
23030 continue
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGUTOL (IAXS,FUNS,IDMA,VINP,VOTP)
C
C This routine is called to perform the mapping from the "user system"
C along an axis to the "label system" along that axis or vice-versa.  It
C may be replaced by the user in order to create a desired graph.  The
C arguments are as follows:
C
C -- IAXS is the index of the axis being drawn.  Its value is 1, 2, 3,
C    or 4, implying the left, right, bottom, or top axis, respectively.
C
C -- FUNS is the value of the parameter 'AXIS/s/FUNCTION.', which may be
C    used to select the desired mapping function for axis IAXS.  It is
C    recommended that the default value (zero) be used to specify the
C    identity mapping.  A non-zero value may be integral (1., 2., etc.)
C    and serve purely to select the code to be executed or it may be the
C    value of a real parameter in the equations defining the mapping.
C
C -- IDMA specifies the direction of the mapping.  A value greater than
C    zero indicates that VINP is a value in the user system and that
C    VOTP is to be a value in the label system, a value less than zero
C    the opposite.
C
C -- VINP is an input value in one coordinate system along the axis.
C
C -- VOTP is an output value in the other coordinate system along the
C    axis.
C
C The default routine simply defines the identity mapping for all axes.
C
      VOTP=VINP
C
      RETURN
C
      END

      SUBROUTINE TRANS(Y,A,X)
      DIMENSION  Y(10), A(10), X(10)      
	COMMON /NLCPAR/XC(10), N, FIXSEP
	LOGICAL FIXSEP
C----- TRANSOFRMATION FOR GAUSSIAN LINES
C
C----- 'N' GAUSSIAN LINES
C
	Y(1)=EXP(-0.5*((X(1)-XC(1)-A(2))/A(1))**2)
	DO 1000 I=2,N
		IF(FIXSEP) THEN
			DELTA=A(2)
		ELSE
			DELTA=A(2*I)
		ENDIF
		Y(1)=Y(1)+ABS(A(2*I-1)*EXP(-0.5*((X(1)-XC(I)-DELTA)/
     *                        A(1))**2))
1000	CONTINUE
C            
      RETURN      
      END      

      subroutine fdjac1(fcn,n,x,fvec,fjac,ldfjac,iflag,ml,mu,epsfcn,
     *                  wa1,wa2)
      integer n,ldfjac,iflag,ml,mu
      double precision epsfcn
      double precision x(n),fvec(n),fjac(ldfjac,n),wa1(n),wa2(n)
c     **********
c
c     subroutine fdjac1
c
c     this subroutine computes a forward-difference approximation
c     to the n by n jacobian matrix associated with a specified
c     problem of n functions in n variables. if the jacobian has
c     a banded form, then function evaluations are saved by only
c     approximating the nonzero terms.
c
c     the subroutine statement is
c
c       subroutine fdjac1(fcn,n,x,fvec,fjac,ldfjac,iflag,ml,mu,epsfcn,
c                         wa1,wa2)
c
c     where
c
c       fcn is the name of the user-supplied subroutine which
c         calculates the functions. fcn must be declared
c         in an external statement in the user calling
c         program, and should be written as follows.
c
c         subroutine fcn(n,x,fvec,iflag)
c         integer n,iflag
c         double precision x(n),fvec(n)
c         ----------
c         calculate the functions at x and
c         return this vector in fvec.
c         ----------
c         return
c         end
c
c         the value of iflag should not be changed by fcn unless
c         the user wants to terminate execution of fdjac1.
c         in this case set iflag to a negative integer.
c
c       n is a positive integer input variable set to the number
c         of functions and variables.
c
c       x is an input array of length n.
c
c       fvec is an input array of length n which must contain the
c         functions evaluated at x.
c
c       fjac is an output n by n array which contains the
c         approximation to the jacobian matrix evaluated at x.
c
c       ldfjac is a positive integer input variable not less than n
c         which specifies the leading dimension of the array fjac.
c
c       iflag is an integer variable which can be used to terminate
c         the execution of fdjac1. see description of fcn.
c
c       ml is a nonnegative integer input variable which specifies
c         the number of subdiagonals within the band of the
c         jacobian matrix. if the jacobian is not banded, set
c         ml to at least n - 1.
c
c       epsfcn is an input variable used in determining a suitable
c         step length for the forward-difference approximation. this
c         approximation assumes that the relative errors in the
c         functions are of the order of epsfcn. if epsfcn is less
c         than the machine precision, it is assumed that the relative
c         errors in the functions are of the order of the machine
c         precision.
c
c       mu is a nonnegative integer input variable which specifies
c         the number of superdiagonals within the band of the
c         jacobian matrix. if the jacobian is not banded, set
c         mu to at least n - 1.
c
c       wa1 and wa2 are work arrays of length n. if ml + mu + 1 is at
c         least n, then the jacobian is considered dense, and wa2 is
c         not referenced.
c
c     subprograms called
c
c       minpack-supplied ... dpmpar
c
c       fortran-supplied ... dabs,dmax1,dsqrt
c
c     argonne national laboratory. minpack project. march 1980.
c     burton s. garbow, kenneth e. hillstrom, jorge j. more
c
c     **********
      integer i,j,k,msum
      double precision eps,epsmch,h,temp,zero
      double precision dpmpar
      data zero /0.0d0/
c
c     epsmch is the machine precision.
c
      epsmch = dpmpar(1)
c
      eps = dsqrt(dmax1(epsfcn,epsmch))
      msum = ml + mu + 1
      if (msum .lt. n) go to 40
c
c        computation of dense approximate jacobian.
c
         do 20 j = 1, n
            temp = x(j)
            h = eps*dabs(temp)
            if (h .eq. zero) h = eps
            x(j) = temp + h
            call fcn(n,x,wa1,iflag)
            if (iflag .lt. 0) go to 30
            x(j) = temp
            do 10 i = 1, n
               fjac(i,j) = (wa1(i) - fvec(i))/h
   10          continue
   20       continue
   30    continue
         go to 110
   40 continue
c
c        computation of banded approximate jacobian.
c
         do 90 k = 1, msum
            do 60 j = k, n, msum
               wa2(j) = x(j)
               h = eps*dabs(wa2(j))
               if (h .eq. zero) h = eps
               x(j) = wa2(j) + h
   60          continue
            call fcn(n,x,wa1,iflag)
            if (iflag .lt. 0) go to 100
            do 80 j = k, n, msum
               x(j) = wa2(j)
               h = eps*dabs(wa2(j))
               if (h .eq. zero) h = eps
               do 70 i = 1, n
                  fjac(i,j) = zero
                  if (i .ge. j - mu .and. i .le. j + ml)
     *               fjac(i,j) = (wa1(i) - fvec(i))/h
   70             continue
   80          continue
   90       continue
  100    continue
  110 continue
      return
c
c     last card of subroutine fdjac1.
c
      end

      subroutine putit ( t, kpm, left, scrtch, dbiatx, q, nrow, b )
c  from  * a practical guide to splines *  by c. de boor
calls  bsplvd(bsplvb),difequ(*)
c  to be called by  e q b l o k .
c
c  puts together one block of the collocation equation system
c
c******  i n p u t  ******
c  t	 knot sequence, of size  left+kpm (at least)
c  kpm	 order of spline
c  left  integer indicating interval of interest, viz the interval
c	    (t(left), t(left+1))
c  nrow  number of rows in block to be put together
c
c******  w o r k  a r e a  ******
c  scrtch   used in bsplvd, of size (kpm,kpm)
c  dbiatx   used to contain derivatives of b-splines, of size (kpm,m+1)
c	    with dbiatx(j,i+1) containing the i-th derivative of the
c	    j-th b-spline of interest
c
c******  o u t p u t  ******
c  q  the block, of size (nrow,kpm)
c  b  the corresponding piece of the right side, of size (nrow)
c
c******  m e t h o d  ******
c  the	k  collocation equations for the interval  (t(left),t(left+1))
c  are constructed with the aid of the subroutine  d i f e q u ( 2, .,
c  . ) and interspersed (in order) with the side conditions (if any) in
c  this interval, using  d i f e q u ( 3, ., . )  for the information.
c     the block  q  has  kpm  columns, corresponding to the  kpm  b-
c  splines of order  kpm  which have the interval (t(left),t(left+1))
c  in their support. the block's diagonal is part of the diagonal of the
c  total system. the first equation in this block not overlapped by the
c  preceding block is therefore equation  l o w r o w , with lowrow =
c  number of side conditions in preceding intervals (or blocks).
c
      integer kpm,left,nrow,   i,irow,iside,itermx,j,k,ll,lowrow,m,mode
     *			      ,mp1
      real b(1),dbiatx(kpm,1),q(nrow,kpm),scrtch(1),t(1),   dx,rho,sum
     *						      ,v(20),xm,xside,xx
      common /side/ m, iside, xside(10)
      common /other/ itermx,k,rho(19)
      mp1 = m+1
      do 10 j=1,kpm
	 do 10 i=1,nrow
   10	    q(i,j) = 0.
      xm = (t(left+1)+t(left))/2.
      dx = (t(left+1)-t(left))/2.
c
      ll = 1
      lowrow = iside
      do 30 irow=lowrow,nrow
	 if (ll .gt. k) 		go to 22
	 mode = 2
c	 next collocation point is ...
	 xx = xm + dx*rho(ll)
	 ll = ll + 1
c	 the corresp.collocation equation is next unless the next side
c	 condition occurs at a point at, or to the left of, the next
c	 collocation point.
	 if (iside .gt. m)		go to 24
	 if (xside(iside) .gt. xx)	go to 24
	 ll = ll - 1
   22	 mode = 3
	 xx = xside(iside)
   24	 call difequ ( mode, xx, v )
c	 the next equation, a collocation equation (mode = 2) or a side
c	 condition (mode = 3), reads
c   (*)   (v(m+1)*d**m + v(m)*d**(m-1) +...+ v(1)*d**0)f(xx) = v(m+2)
c	 in terms of the info supplied by  difequ . the corresponding
c	 equation for the b-coeffs of  f  therefore has the left side of
c	 (*), evaluated at each of the	kpm  b-splines having  xx  in
c	 their support, as its	kpm  possibly nonzero coefficients.
	 call bsplvd ( t, kpm, xx, left, scrtch, dbiatx, mp1 )
	 do 26 j=1,kpm
	    sum = 0.
	    do 25 i=1,mp1
   25	       sum = v(i)*dbiatx(j,i) + sum
   26	    q(irow,j) = sum
   30	 b(irow) = v(m+2)
					return
      end

C----------------------------------------------------------------------
        subroutine ftgpfd(iunit,group,felem,nelem,
     &                    array,flgval,anynul,status)

C       Read an array of r*8 values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).
C       Undefined elements will have the corresponding element of
C       FLGVAL set equal to .true.
C       ANYNUL is return with a value of .true. if any pixels were undefined.

C       iunit   i  Fortran unit number
C       group   i  number of the data group, if any
C       felem   i  the first pixel to be read (this routine treats
C                  the primary array a large one dimensional array of
C                  values, regardless of the actual dimensionality).
C       nelem   i  number of data elements to be read
C       array   d  returned array of values that were read
C       flgval  l  set to .true. if the corresponding element is undefined
C       anynul  l  set to .true. if any returned elements are undefined
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,group,felem,nelem,status,row 
        double precision nulval,array(*)
        logical anynul,flgval(*)
        integer i

        do 10 i=1,nelem
                flgval(i)=.false.
10      continue

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
        row=max(1,group)
        call ftgcld(iunit,2,row,felem,nelem,1,2,nulval,
     &      array,flgval,anynul,status)
        end

c F77PAK -- Convert an SPP string into a Fortran 77 string.
c
        subroutine f77pak (sppstr, f77str, maxch)
c
        integer*2 sppstr(*)
        character*(*) f77str
        integer maxch
        integer i, ch, last, maxout, EOS
        parameter (EOS=0)
c
        maxout = min (maxch, len(f77str))
c
c       # Unpack the EOS delimited SPP string.
	last = maxout
        do 10 i = 1, maxout
            ch = sppstr(i)
            if (ch .eq. EOS) then
		last = i - 1
		goto 20
	    endif
            f77str(i:i) = char (ch)
 10     continue
 20     continue
c
c       # Pad on the right with blanks.
	if (last .gt. maxch) last = maxch
	if (last .le. 0) then
	    f77str = ' '
	else
	    f77str = f77str(1:last)
	endif
        end

      subroutine colloc(aleft,aright,lbegin,iorder,ntimes,addbrk,relerr,ier)
c  from  * a practical guide to splines *  by c. de boor
chapter xv, example. solution of an ode by collocation.
calls colpnt, difequ(ppvalu(interv)), knots, eqblok(putit(difequ*,
c     bsplvd(bsplvb)))), slvblk(various subprograms), bsplpp(bsplvb*),
c     newnot
c
c******  i n p u t  ******
c  aleft, aright  endpoints of interval of approximation
c  lbegin   initial number of polynomial pieces in the approximation.
c	    a uniform breakpoint sequence is chosen.
c  iorder   order of polynomial pieces in the approximation
c  ntimes   number of passes through  n e w n o t  to be made
c  addbrk   the number (possibly fractional) of breaks to be added per
c	    pass through newnot. e.g., if addbrk = .33334, then a break-
c	    point will be added at every third pass through newnot.
c  relerr   a tolerance. newton iteration is stopped if the difference
c	    between the b-coeffs of two successive iterates is no more
c	    than  relerr*(absol.largest b-coefficient).
c
c******  p r i n t e d	 o u t p u t  ******
c     consists of the pp-representation of the approximate solution,
c     and of the error at selected points.
c
c******  m e t h o d  ******
c  the m-th order ordinary differential equation with  m  side condit-
c  ions, to be specified in subroutine	d i f e q u , is solved approx-
c  imately by collocation.
c  the approximation  f  to the solution  g  is pp of order  k+m  with
c  l  pieces and  m-1 continuous derivatives.  f  is determined by the
c  requirement that it satisfy the d.e. at  k  points per interval (to
c  be specified in  c o l p n t ) and the  m  side conditions.
c     this usually nonlinear system of equations for  f  is solved by
c  newton's method. the resulting linear system for the b-coeffs of an
c  iterate is constructed appropriately in  e q b l o k  and then solved
c  in  s l v b l k , a program designed to solve  a l m o s t  b l o c k
c  d i a g o n a l  linear systems efficiently.
c     there is an opportunity to attempt improvement of the breakpoint
c  sequence (both in number and location) through use of  n e w n o t .
c
c     parameter npiece=100, ndim=200, ncoef=2000, lenblk=2000
c     integer iorder,lbegin,ntimes,   i,iflag,ii,integs(3,npiece),iside
c    *			,iter,itermx,k,kpm,l,lnew,m,n,nbloks,nncoef,nt
      integer iorder,lbegin,ntimes,   i,iflag,ii,integs(3,100),iside
     *		  ,iter,itermx,k,kpm,l,lnew,m,n,nbloks,ncoef,nncoef,nt
c     real addbrk,aleft,aright,relerr,	 a(ndim),amax,asave(ndim)
c    *	   ,b(ndim),bloks(lenblk),break,coef,dx,err,rho,t(ndim)
c    *	   ,templ(lenblk),temps(ndim),xside
      real addbrk,aleft,aright,relerr,	 a(200),amax,asave(200)
     *	   ,b(200),bloks(2000),break,coef,dx,err,rho,t(200)
     *	   ,templ(2000),temps(200),xside
      equivalence (bloks,templ)
c     common /approx/ break(npiece), coef(ncoef), l,kpm
      common /approx/ break(100), coef(2000), l,kpm
      common /side/ m, iside, xside(10)
      common /other/ itermx,k,rho(19)
      data ncoef,lenblk / 2000,2000 /
c
      ier = 0
      kpm = iorder
      if (lbegin*kpm .gt. ncoef)	go to 999
c  *** set the various parameters concerning the particular dif.equ.
c     including a first approx. in case the de is to be solved by
c     iteration ( itermx .gt. 0) .
      call difequ (1, temps(1), temps )
c  *** obtain the  k  collocation points for the standard interval.
      k = kpm - m
      call colpnt ( k, rho )
c  *** the following five statements could be replaced by a read in or-
c     der to obtain a specific (nonuniform) spacing of the breakpnts.
      dx = (aright - aleft)/float(lbegin)
      temps(1) = aleft
      do 4 i=2,lbegin
    4	 temps(i) = temps(i-1) + dx
      temps(lbegin+1) = aright
c  *** generate, in knots, the required knots t(1),...,t(n+kpm).
      call knots ( temps, lbegin, kpm, t, n )
      nt = 1
c  *** generate the almost block diagonal coefficient matrix  bloks  and
c     right side  b  from collocation equations and side conditions.
c     then solve via  slvblk , obtaining the b-representation of the ap-
c     proximation in  t , a ,  n  , kpm  .
   10	 call eqblok(t,n,kpm,temps,a,bloks,lenblk,integs,nbloks,b)
	 call slvblk(bloks,integs,nbloks,b,temps,a,iflag)
	 iter = 1
	 if (itermx .le. 1)		go to 30
c  *** save b-spline coeff. of current approx. in  asave , then get new
c     approx. and compare with old. if coeff. are more than  relerr
c     apart (relatively) or if no. of iterations is less than  itermx ,
c     continue iterating.
   20	    call bsplpp(t,a,n,kpm,templ,break,coef,l)
	    do 25 i=1,n
   25	       asave(i) = a(i)
	    call eqblok(t,n,kpm,temps,a,bloks,lenblk,integs,nbloks,b)
	    call slvblk(bloks,integs,nbloks,b,temps,a,iflag)
	    err = 0.
	    amax = 0.
	    do 26 i=1,n
	       amax = amax1(amax,abs(a(i)))
   26	       err = amax1(err,abs(a(i)-asave(i)))
	    if (err .le. relerr*amax)	go to 30
	    iter = iter+1
	    if (iter .lt. itermx)	go to 20
c  *** iteration (if any) completed. print out approx. based on current
c     breakpoint sequence, then try to improve the sequence.
   30	 print 630,kpm,l,n,(break(i),i=2,l)
  630	 format(47h approximation from a space of splines of order,i3
     *	       ,4h on ,i3,11h intervals,/13h of dimension,i4
     *	       ,16h.  breakpoints -/(5e20.10))
 	 if (itermx .gt. 0)  print 635,iter,itermx
  635	 format(6h after,i3,3h of,i3,20h allowed iterations,)
	 call bsplpp(t,a,n,kpm,templ,break,coef,l)
 	 print 637
  637	 format(46h the pp representation of the approximation is)
 	 do 38 i=1,l
 	    ii = (i-1)*kpm
   38	    print 638, break(i),(coef(ii+j),j=1,kpm)
  638	 format(f9.3,e13.6,10e11.3)
c  *** the following call is provided here for possible further analysis
c     of the approximation specific to the problem being solved.
c     it is, of course, easily omitted.
 	 call difequ ( 4, temps(1), temps )
c
	 if (nt .gt. ntimes)		return
c  *** from the pp-rep. of the current approx., obtain in  newnot  a new
c     (and possibly better) sequence of breakpoints, adding (on the ave-
c     rage)  a d d b r k  breakpoints per pass through newnot.
	 lnew = lbegin + int(float(nt)*addbrk)
	 if (lnew*kpm .gt. ncoef)	go to 999
	 call newnot(break,coef,l,kpm,temps,lnew,templ)
	 call knots(temps,lnew,kpm,t,n)
	 nt = nt + 1
					go to 10
  999 nncoef = ncoef
      print 699,nncoef
  699 format(11h **********/23h the assigned dimension,i5
     *	    ,25h for  coef  is too small.)
 					return
      end

      SUBROUTINE slPVUE (PV, DATE, PMASS, U, JSTAT)
*+
*     - - - - - -
*      P V U E
*     - - - - - -
*
*  Construct a universal element set based on an instantaneous position
*  and velocity.
*
*  Given:
*     PV        d(6)   heliocentric x,y,z,xdot,ydot,zdot of date,
*                      (AU,AU/s; Note 1)
*     DATE      d      date (TT Modified Julian Date = JD-2400000.5)
*     PMASS     d      mass of the planet (Sun=1; Note 2)
*
*  Returned:
*     U         d(13)  universal orbital elements (Note 3)
*
*                 (1)  combined mass (M+m)
*                 (2)  total energy of the orbit (alpha)
*                 (3)  reference (osculating) epoch (t0)
*               (4-6)  position at reference epoch (r0)
*               (7-9)  velocity at reference epoch (v0)
*                (10)  heliocentric distance at reference epoch
*                (11)  r0.v0
*                (12)  date (t)
*                (13)  universal eccentric anomaly (psi) of date, approx
*
*     JSTAT     i      status:  0 = OK
*                              -1 = illegal PMASS
*                              -2 = too close to Sun
*                              -3 = too slow
*
*  Notes
*
*  1  The PV 6-vector can be with respect to any chosen inertial frame,
*     and the resulting universal-element set will be with respect to
*     the same frame.  A common choice will be mean equator and ecliptic
*     of epoch J2000.
*
*  2  The mass, PMASS, is important only for the larger planets.  For
*     most purposes (e.g. asteroids) use 0D0.  Values less than zero
*     are illegal.
*
*  3  The "universal" elements are those which define the orbit for the
*     purposes of the method of universal variables (see reference).
*     They consist of the combined mass of the two bodies, an epoch,
*     and the position and velocity vectors (arbitrary reference frame)
*     at that epoch.  The parameter set used here includes also various
*     quantities that can, in fact, be derived from the other
*     information.  This approach is taken to avoiding unnecessary
*     computation and loss of accuracy.  The supplementary quantities
*     are (i) alpha, which is proportional to the total energy of the
*     orbit, (ii) the heliocentric distance at epoch, (iii) the
*     outwards component of the velocity at the given epoch, (iv) an
*     estimate of psi, the "universal eccentric anomaly" at a given
*     date and (v) that date.
*
*  Reference:  Everhart, E. & Pitkin, E.T., Am.J.Phys. 51, 712, 1983.
*
*  P.T.Wallace   Starlink   18 March 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION PV(6),DATE,PMASS,U(13)
      INTEGER JSTAT

*  Gaussian gravitational constant (exact)
      DOUBLE PRECISION GCON
      PARAMETER (GCON=0.01720209895D0)

*  Canonical days to seconds
      DOUBLE PRECISION CD2S
      PARAMETER (CD2S=GCON/86400D0)

*  Minimum allowed distance (AU) and speed (AU per canonical day)
      DOUBLE PRECISION RMIN,VMIN
      PARAMETER (RMIN=1D-3,VMIN=1D-3)

      DOUBLE PRECISION T0,CM,X,Y,Z,XD,YD,ZD,R,V2,V,ALPHA,RDV


*  Reference epoch.
      T0 = DATE

*  Combined mass (mu=M+m).
      IF (PMASS.LT.0D0) GO TO 9010
      CM = 1D0+PMASS

*  Unpack the state vector, expressing velocity in AU per canonical day.
      X = PV(1)
      Y = PV(2)
      Z = PV(3)
      XD = PV(4)/CD2S
      YD = PV(5)/CD2S
      ZD = PV(6)/CD2S

*  Heliocentric distance, and speed.
      R = SQRT(X*X+Y*Y+Z*Z)
      V2 = XD*XD+YD*YD+ZD*ZD
      V = SQRT(V2)

*  Reject unreasonably small values.
      IF (R.LT.RMIN) GO TO 9020
      IF (V.LT.VMIN) GO TO 9030

*  Total energy of the orbit.
      ALPHA = V2-2D0*CM/R

*  Outward component of velocity.
      RDV = X*XD+Y*YD+Z*ZD

*  Construct the universal-element set.
      U(1) = CM
      U(2) = ALPHA
      U(3) = T0
      U(4) = X
      U(5) = Y
      U(6) = Z
      U(7) = XD
      U(8) = YD
      U(9) = ZD
      U(10) = R
      U(11) = RDV
      U(12) = T0
      U(13) = 0D0

*  Exit.
      JSTAT = 0
      GO TO 9999

*  Negative PMASS.
 9010 CONTINUE
      JSTAT = -1
      GO TO 9999

*  Too close.
 9020 CONTINUE
      JSTAT = -2
      GO TO 9999

*  Too slow.
 9030 CONTINUE
      JSTAT = -3

 9999 CONTINUE
      END

#-h-  addchr			  254  local   12/01/80  15:53:44
# addchr - put c in buf (bp) if it fits, increment bp
   include  defs

   subroutine addchr (c, buf, bp, maxsiz)
   integer bp, maxsiz
   character c, buf (ARB)

   if (bp > maxsiz)
      call baderr ("buffer overflow.")
   buf (bp) = c
   bp = bp + 1

   return
   end

C--------------------------------------------------------------------------
        subroutine ftdhdu(ounit,typhdu,status)

C       delete the current HDU (as long as it is not the primary array)

C       ounit   i  fortran output unit number
C       typhdu  i  type of the new CHDU, after deleting the old CHDU
C       status  i  returned error status (0=ok)

        integer ounit,typhdu,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS:------------------------------------

        integer ibuff,nhdu,nblock

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

        nhdu=chdu(ibuff)
        if (nhdu .eq. 1)then
C            cannot delete the primary array
             status=301
             return
        end if

C       close the CHDU first, to flush buffers and free memory
        call ftchdu(ounit,status)

C       how many blocks to delete?
        nblock=(hdstrt(ibuff,nhdu+1)-hdstrt(ibuff,nhdu))/2880
        if (nblock .lt. 1)return

C       delete the blocks
        call ftdblk(ounit,nblock,1,status)
        if (status .gt. 0)return

C       try reinitializing the CHDU, if there is one
        call ftrhdu(ounit,typhdu,status)
        if (status .gt. 0)then
C            there is no HDU after the one we just deleted so move back one HDU
             status=0
             call ftcmsg
             call ftgext(ounit,nhdu-1,typhdu,status)
        end if
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C A   B R I E F   D E S C R I P T I O N   O F   A U T O G R A P H
C ---------------------------------------------------------------------
C
C Following is a brief description of the AUTOGRAPH package.  For a
C complete write-up, see the document "AUTOGRAPH - THE UNABRIDGED
C WRITE-UP".
C
C
C PACKAGE AUTOGRAPH
C
C LATEST REVISION        January, 1986
C
C PURPOSE                To draw graphs, each with a labelled background
C                        and each displaying one or more curves.
C
C ACCESS (ON THE CRAY)   To use AUTOGRAPH routines on the Cray, simply
C                        call them; they are in the binary library
C                        $NCARLB, which is automatically searched.
C
C                        To get smoother curves, drawn using spline
C                        interpolation, compile DASHSMTH, from ULIB,
C                        to replace DASHCHAR, from $NCARLB:
C
C                          GETSRC,LIB=ULIB,FILE=DASHSMTH,L=DSMTH.
C                          CFT,I=DSMTH,L=0.
C
C                        AUTOGRAPH contains a routine AGPWRT, which it
C                        calls to draw labels.  This routine just passes
C                        its arguments on to the system-plot-package
C                        routine PWRIT.  To use one of the fancier
C                        character-drawers, like PWRITX or PWRITY,
C                        just compile a routine AGPWRT to replace the
C                        default version; it has the same arguments as
C                        PWRIT and may either draw the character string
C                        itself, or just pass the arguments on to a
C                        desired character-drawer.  The AUTOGRAPH
C                        specialist has some "standard" versions of
C                        AGPWRT and should be consulted for help in
C                        avoiding pitfalls.  One standard version,
C                        which calls PWRITX, may be obtained using the
C                        following JCL:
C
C                          GETSRC,LIB=XLIB,FILE=AGUPWRITX,L=UPWRTX.
C                          CFT,I=UPWRTX,L=0.
C
C USAGE                  Following this indented preamble are given two
C                        lists:  one describing the AUTOGRAPH routines
C                        and another describing the arguments of those
C                        routines.
C
C                        "AUTOGRAPH - THE UNABRIDGED WRITE-UP" gives
C                        a complete write-up of AUTOGRAPH, in great
C                        detail and with a set of helpful examples.
C
C ENTRY POINTS           Except for seven routines which are included
C                        in the package for historical reasons (EZY,
C                        EZXY, EZMY, EZMXY, IDIOT, ANOTAT, and DISPLA),
C                        the AUTOGRAPH routines have six-character names
C                        beginning with the characters 'AG'.  An alpha-
C                        betized list follows:
C
C                          AGAXIS AGBACK AGBNCH AGCHAX AGCHCU AGCHIL
C                          AGCHNL AGCTCS AGCTKO AGCURV AGDASH AGDFLT
C                          AGDLCH AGDSHN AGEXAX AGEXUS AGEZSU AGFPBN
C                          AGFTOL AGGETC AGGETF AGGETI AGGETP AGGTCH
C                          AGINIT AGKURV AGLBLS AGMAXI AGMINI AGNUMB
C                          AGPPID AGPWRT AGQURV AGRPCH AGRSTR AGSAVE
C                          AGSCAN AGSETC AGSETF AGSETI AGSETP AGSRCH
C                          AGSTCH AGSTUP AGUTOL
C
C                        NOTE:  The "routine" AGDFLT is a block-data
C                        routine specifying the default values of
C                        AUTOGRAPH control parameters.
C
C SPECIAL CONDITIONS     Under certain conditions, AUTOGRAPH may print
C                        an error message (via the routine SETER) and
C                        stop.  Each error message includes the name of
C                        the routine which issued it.  A description of
C                        the condition which caused the error may be
C                        found in the AUTOGRAPH write-up in the NCAR
C                        graphics manual; look in the write-up of the
C                        routine which issued the error message, under
C                        the heading 'SPECIAL CONDITIONS'.
C
C                        For error messages issued by the routine
C                        AGNUMB, see the write-up of the routine AGSTUP.
C
C                        If you get an error in the routine ALOG10, it
C                        probably means that you are using a logarithmic
C                        axis and some of the coordinate data along that
C                        axis are zero or negative.
C
C COMMON BLOCKS          The AUTOGRAPH common blocks are AGCONP, AGORIP,
C                        AGOCHP, AGCHR1, and AGCHR2.  AGCONP contains
C                        the AUTOGRAPH "control parameters", primary and
C                        secondary, all of which are real, AGORIP other
C                        real and/or integer parameters, AGOCHP other
C                        character parameters, AGCHR1 and AGCHR2 the
C                        variables implementing the character-storage-
C                        and-retrieval scheme of AUTOGRAPH.
C
C I/O                    Lower-level plotting routines are called to
C                        produce graphical output and, when errors
C                        occur, error messages may be written to the
C                        system error file, as defined by I1MACH(4),
C                        either directly or by way of a call to SETER.
C
C REQUIRED ULIB          AUTOGRAPH uses the software dashed-line package
C ROUTINES               DASHCHAR.  Of course, either of the packages
C                        DASHSMTH or DASHSUPR may be used instead, to
C                        get smoother curves.
C
C SPECIALIST             Dave Kennison, Scientific Computing Division,
C                        National Center for Atmospheric Research
C
C LANGUAGE               FORTRAN
C
C HISTORY                Dave Robertson wrote the original routine
C                        IDIOT, which was intended to provide a simple,
C                        quick-and-dirty, x-y graph-drawing capability.
C                        In time, as it became obvious that many users
C                        were adapting IDIOT to more sophisticated
C                        tasks, Dan Anderson wrote the first AUTOGRAPH
C                        package, based on IDIOT.  It allowed the user
C                        to put more than one curve on a graph, to use
C                        more sophisticated backgrounds, to specify
C                        coordinate data in a variety of ways, and to
C                        more easily control the scaling and positioning
C                        of graphs.  Eventually, this package, too, was
C                        found wanting.  In 1977, Dave Kennison entirely
C                        re-wrote AUTOGRAPH, with the following goals:
C                        to maintain the ease of use for simple graphs
C                        which had been the principal virtue of the
C                        package, to provide the user with as much
C                        control as possible, to incorporate desirable
C                        new features, and to make the package as
C                        portable as possible.  In 1984, the package
C                        was again worked over by Dave Kennison, to
C                        make it compatible with FORTRAN-77 and
C                        to remove any dependency on the LOC function,
C                        which had proved to cause difficulties on
C                        certain machines.  The user interface was
C                        changed somewhat and some new features were
C                        added.  A GKS-compatible version was written.
C
C SPACE REQUIRED         AUTOGRAPH is big; one pays a price for its
C                        capabilities.  On the Cray, it occupies a
C                        little under 30000 (octal) locations.  The
C                        required plot package routines take about
C                        another 7000 (octal), the (modified) PORT
C                        support routines about another 1000 (octal),
C                        and system routines (math, I/O, miscellany)
C                        another 30000 (octal).
C
C PORTABILITY            AUTOGRAPH may be ported with few modifications
C                        to most systems having a FORTRAN-77 compiler.
C
C                        The labelled common blocks may have to be
C                        declared in a part of the user program which
C                        is always core-resident so that variables
C                        in them will maintain their values from one
C                        AUTOGRAPH-routine call to the next.  Such a
C                        problem may arise when AUTOGRAPH is placed in
C                        an overlay or when some sort of memory-paging
C                        scheme is used.
C
C REQUIRED RESIDENT      AUTOGRAPH uses the DASHCHAR routines DASHDB,
C ROUTINES               DASHDC, FRSTD, LASTD, LINED, AND VECTD, the
C                        system-plot-package routines FRAME, GETSET,
C                        GETSI, LINE, PWRIT, and SET, the support
C                        routines ISHIFT and IOR, the (modified)
C                        PORT utilities SETER and I1MACH, and the
C                        FORTRAN-library routines ALOG10, ATAN2, COS,
C                        SIN, AND SQRT.
C
C ---------------------------------------------------------------------
C U S E R - C A L L A B L E   A U T O G R A P H   R O U T I N E S
C ---------------------------------------------------------------------
C
C Following is a list of AUTOGRAPH routines to be called by the user
C (organized by function).  Each routine is described briefly.  The
C arguments of the routines are described in the next section.
C
C Each of the following routines draws a complete graph with one call.
C Each is implemented by a set of calls to the lower-level AUTOGRAPH
C routines AGSTUP, AGCURV, and AGBACK (which see, below).
C
C -- EZY (YDRA,NPTS,GLAB) - draws a graph of the curve defined by the
C    data points ((I,YDRA(I)),I=1,NPTS), with a graph label specified
C    by GLAB.
C
C -- EZXY (XDRA,YDRA,NPTS,GLAB) - draws a graph of the curve defined by
C    the data points ((XDRA(I),YDRA(I)),I=1,NPTS), with a graph label
C    specified by GLAB.
C
C -- EZMY (YDRA,IDXY,MANY,NPTS,GLAB) - draws a graph of the family of
C    curves defined by data points (((I,YDRA(I,J)),I=1,NPTS),J=1,MANY),
C    with a graph label specified by GLAB.  The order of the subscripts
C    of YDRA may be reversed - see the routine DISPLA, argument LROW.
C
C -- EZMXY (XDRA,YDRA,IDXY,MANY,NPTS,GLAB) - draws a graph of the
C    family of curves defined by the data points (((XDRA(I),YDRA(I,J)),
C    I=1,NPTS),J=1,MANY), with a graph label specified by GLAB.  XDRA
C    may be doubly-subscripted and the order of the subscripts of XDRA
C    and YDRA may be reversed - see the routine DISPLA, argument LROW.
C
C -- IDIOT (XDRA,YDRA,NPTS,LTYP,LDSH,LABX,LABY,LABG,LFRA) - implements
C    the routine from which AUTOGRAPH grew - not recommended - provided
C    for antique lovers.
C
C The following routines provide user access to the AUTOGRAPH control
C parameters (in the labelled common block AGCONP).
C
C -- ANOTAT (XLAB,YLAB,LBAC,LSET,NDSH,DSHL) - may be used to change the
C    x- and y-axis (non-numeric) labels, the background type, the way
C    in which graphs are positioned and scaled, and the type of dash
C    patterns to be used in drawing curves.
C
C -- DISPLA (LFRA,LROW,LTYP) - may be used to specify when, if ever,
C    the EZ... routines do a frame advance, how input arrays for EZMY
C    and EZMXY are dimensioned, and the linear/log nature of graphs.
C
C -- AGSETP (TPGN,FURA,LURA) - a general-purpose parameter-setting
C    routine, used to set the group of parameters specified by TPGN,
C    using values obtained from the array (FURA(I),I=1,LURA).
C
C -- AGSETF (TPGN,FUSR) - used to set the single parameter specified by
C    TPGN, giving it the floating-point value FUSR.
C
C -- AGSETI (TPGN,IUSR) - used to set the single parameter specified by
C    TPGN, giving it the floating-point value FLOAT(IUSR).
C
C -- AGSETC (TPGN,CUSR) - the character string CUSR is stashed in an
C    array inside AUTOGRAPH and the floating-point equivalent of an
C    identifier which may be used for later retrieval of the string is
C    stored as the value of the single parameter specified by TPGN.  The
C    single parameter must be a label name, a dash pattern, the text of
C    a label line, or the line-terminator character.
C
C -- AGGETP (TPGN,FURA,LURA) - a general-purpose parameter-getting
C    routine, used to get the group of parameters specified by TPGN,
C    putting the result in the array (FURA(I),I=1,LURA).
C
C -- AGGETF (TPGN,FUSR) - used to get, in FUSR, the floating-point
C    value of the single parameter specified by TPGN.
C
C -- AGGETI (TPGN,IUSR) - used to get, in IUSR, the integer equivalent
C    of the value of the single parameter specified by TPGN.
C
C -- AGGETC (TPGN,CUSR) - used to get, in CUSR, the character string
C    whose identifier is specified by the integer equivalent of the
C    single parameter specified by TPGN.  The single parameter must
C    be a label name, a dash pattern, the text of a label line, or the
C    line-terminator character.
C
C The following are lower-level routines, which may be used to draw
C graphs of many different kinds.  The EZ... routines call these.  They
C are intended to be called by user programs, as well.
C
C -- AGSTUP (XDRA,NVIX,IIVX,NEVX,IIEX,YDRA,NVIY,IIVY,NEVY,IIEY) - this
C    routine must be called prior to the first call to either of the
C    two routines AGBACK and AGCURV, to force the set-up of secondary
C    parameters controlling the behavior of those routines.  After any
C    parameter-setting call, AGSTUP must be called again before calling
C    either AGBACK or AGCURV again.  AGSTUP calls the routine "SET", in
C    the plot package, so that user x/y coordinates in subsequent calls
C    will map properly into the plotter space.
C
C -- AGBACK - draws the background defined by the current state of the
C    AUTOGRAPH control parameters.
C
C -- AGCURV (XVEC,IIEX,YVEC,IIEY,NEXY,KDSH) - draws the curve defined
C    by the arguments, positioning it as specified by the current state
C    of the AUTOGRAPH control parameters.
C
C The following utility routines are called by the user.
C
C -- AGSAVE (IFNO) - used to save the current state of AUTOGRAPH by
C    writing the appropriate information to a specified file.  Most
C    commonly used to save the default state for later restoration.
C    This routine should be used instead of AGGETP when the object
C    is to save the whole state of AUTOGRAPH, since it saves not only
C    the primary control parameters, but all of the character strings
C    pointed to by the primary control parameters.  It is the user's
C    responsibility to position the file before calling AGSAVE.
C
C -- AGRSTR (IFNO) - used to restore a saved state of AUTOGRAPH by
C    reading the appropriate information from a specified file.  Most
C    commonly used to restore AUTOGRAPH to its default state.  It is
C    the user's responsibility to position the file before calling
C    AGRSTR.
C
C -- AGBNCH (IDSH) - a function, of type CHARACTER*16 (it must be
C    declared as such in a user routine referencing it), whose value,
C    given a 16-bit binary dash pattern, is the equivalent character
C    dash pattern.
C
C -- AGDSHN (IDSH) - a function, of type CHARACTER*16 (it must be
C    declared as such in a user routine referencing it), whose value,
C    given an integer "n" (typically between 1 and 26) is the character
C    string 'DASH/ARRAY/nnnn.', which is the name of the nth dash
C    pattern parameter.  To set the 13th dash pattern, for example,
C    one might use "CALL AGSETC (AGDSHN(13),'$$$$$$CURVE 13$$$$$$')".
C
C The following utility routines are called by AUTOGRAPH.  The versions
C included in AUTOGRAPH itself are dummies; they do nothing but RETURN.
C The user may replace one or more of these routines with versions to
C accomplish specific purposes.
C
C -- AGUTOL (IAXS,FUNS,IDMA,VINP,VOTP) - called by AUTOGRAPH to perform
C    the mapping from user-system values along an axis to label-system
C    values along the axis and vice-versa.  This routine may be replaced
C    by the user to create a desired graph.
C
C -- AGCHAX (IFLG,IAXS,IPRT,VILS) - called by AUTOGRAPH just before and
C    just after the various parts of the axes are drawn.
C
C -- AGCHCU (IFLG,KDSH) - called by AUTOGRAPH just before and just after
C    each curve is drawn.
C
C -- AGCHIL (IFLG,LBNM,LNNO) - called by AUTOGRAPH just before and just
C    after each line of an informational label is drawn.
C
C -- AGCHNL (IAXS,VILS,CHRM,MCIM,NCIM,IPXM,CHRE,MCIE,NCIE) - called by
C    AUTOGRAPH just after the character strings defining a numeric label
C    have been generated.
C
C ---------------------------------------------------------------------
C D E S C R I P T I O N S   O F   A R G U M E N T S
C ---------------------------------------------------------------------
C
C In calls to the routines EZY, EZXY, EZMY, and EZMXY:
C
C -- XDRA is an array of x coordinates, dimensioned as implied by the
C    current value of the AUTOGRAPH control parameter 'ROW.' (see the
C    description of the argument LROW, below).  The value of the
C    AUTOGRAPH parameter 'NULL/1.' (1.E36, by default) when used as an
C    x coordinate, implies a missing data point; the curve segments
C    on either side of such a point are not drawn.
C
C -- YDRA is an array of y coordinates, dimensioned as implied by the
C    current value of the AUTOGRAPH control parameter 'ROW.' (see the
C    description of the argument LROW, below).  The value of the
C    AUTOGRAPH parameter 'NULL/1.' (1.E36, by default) when used as a
C    y coordinate, implies a missing data point; the curve segments
C    on either side of such a point are not drawn.
C
C -- IDXY is the first dimension of the arrays XDRA (if it has two
C    dimensions) and YDRA.
C
C -- MANY is the number of curves to be drawn by the call to EZ... -
C    normally, the second dimension of XDRA (if it has two dimensions)
C    and YDRA.
C
C -- NPTS is the number of points defining each curve to be drawn by
C    the routine EZ... - normally, the first (or only) dimension of
C    XDRA and YDRA.
C
C -- GLAB is a character constant or a character variable, defining a
C    label to be placed at the top of the graph.  The string may not be
C    more than 40 characters long - if it is fewer than 40 characters
C    long, its last character must be a dollar sign.  (The dollar sign
C    is not a part of the label - it is stripped off.)  The character
C    string "CHAR(0)" may be used to indicate that the previous label,
C    whatever it was, should continue to be used.  The initial graph
C    label consists of blanks.
C
C In calls to the routine ANOTAT:
C
C -- XLAB and YLAB resemble GLAB (see above) and define labels for the
C    x and y axes.  The default x-axis label is the single character
C    X, the default y-axis label the single character Y.  Note that one
C    may use the string "CHAR(0)" to indicate that the x-axis (y-axis)
C    label is not to be changed from what it was previously.
C
C -- LBAC, if non-zero, specifies a new value for the AUTOGRAPH control
C    parameter 'BACKGROUND.', as follows:
C
C       1 - a perimeter background
C
C       2 - a grid background
C
C       3 - an axis background
C
C       4 - no background
C
C    The default value of 'BACKGROUND.' is 1.
C
C -- LSET, if non-zero, specifies a new value for the AUTOGRAPH control
C    parameter 'SET.'.  This parameter may be negated to suspend the
C    drawing of curves by the EZ... routines, so that a call to one of
C    them will produce only a background.  The absolute value of 'SET.'
C    affects the way in which AUTOGRAPH determines the position and
C    shape of the graph and the scaling of the axes, as follows:
C
C       1 - Restores the default values of the AUTOGRAPH parameters
C           in question.  AUTOGRAPH will set up an appropriate call
C           to the plot-package routine "SET", over-riding any prior
C           call to that routine.
C
C       2 - Tells AUTOGRAPH to use arguments 1-4 and 9 of the last
C           "SET" call.  Arguments 1-4 specify where the graph should
C           fall on the plotter frame, argument 9 whether the graph
C           is linear/linear, linear/log, etc.
C
C       3 - Tells AUTOGRAPH to use arguments 5-8 and 9 of the last
C           "SET" call.  Arguments 5-8 specify the scaling of the
C           axes, argument 9 whether the graph is linear/linear,
C           linear/log, etc.
C
C       4 - A combination of 2 and 3.  Arguments 1-4 of the last "SET"
C           call specify the position, arguments 5-8 the scaling, and
C           argument 9 the linear/log nature, of the graph.
C
C    (The plot-package routine "SET" is described in the NCAR Graphics
C    Manual; it is not a part of AUTOGRAPH.)
C
C    If the routine DISPLA is called with its argument LTYP non-zero,
C    the linear/log nature of the graph will be that specified by LTYP,
C    not that specified by the last "SET" call, no matter what the value
C    of the control parameter 'SET.'.
C
C    The default value of 'SET.' is 1.
C
C -- NDSH, if non-zero, specifies a new value of the AUTOGRAPH control
C    parameter 'DASH/SELECTOR.' (and therefore a new set of dashed-line
C    patterns), as described below.  Note:  The default value of the
C    dashed-line parameters is such that all curves will be drawn using
C    solid lines; if that is what you want, use a zero for NDSH.
C
C       If the value of 'DASH/SELECTOR.' is negative, curves produced
C       by subsequent calls to EZMY or EZMXY will be drawn using a
C       set of alphabetic dashed-line patterns.  The first curve drawn
C       by a given call will be labelled 'A', the second 'B', ..., the
C       twenty-sixth 'Z', the twenty-seventh 'A' again, and so on.
C       Curves drawn by calls to EZY and EZXY will be unaffected.
C
C       If the value of 'DASH/SELECTOR.' is positive, it must be less
C       than or equal to 26.  The next argument, DSHL, is an array
C       containing NDSH dashed-line patterns.  All curves produced by
C       subsequent calls to EZY, EZXY, EZMY, and EZMXY will be drawn
C       using the dashed-line patterns in (DSHL(I),I=1,NDSH) - the
C       first curve produced by a given call will have the pattern
C       specified by DSHL(1), the second that specified by DSHL(2),
C       the third that specified by DSHL(3), . . . the NDSH+1st that
C       specified by DSHL(1), . . . etc.  Each element of DSHL must
C       be a character string, in which a dollar sign stands for a
C       solid-line segment, a quote stands for a gap, and other
C       characters stand for themselves.  See the write-up of the
C       package "DASHCHAR".  Binary dashed-line patterns may not be
C       defined by means of a call to ANOTAT, only by means of calls
C       to lower-level routines.
C
C -- DSHL (if NDSH is greater than zero) is an array of dashed-line
C    patterns, as described above.
C
C In calls to the routine DISPLA:
C
C -- LFRA, if non-zero, specifies a new value for the AUTOGRAPH control
C    parameter 'FRAME.'.  Possible values are as follows:
C
C       1 - The EZ... routines do a frame advance after drawing.
C
C       2 - No frame advance is done by the EZ... routines.
C
C       3 - The EZ... routines do a frame advance before drawing.
C
C    The default value of 'FRAME.' is 1.
C
C -- LROW, if non-zero, specifies a new value for the AUTOGRAPH control
C    parameter 'ROW.'.  This parameter tells AUTOGRAPH how the argument
C    arrays XDRA and YDRA, in calls to the routines EZMY and EZMXY, are
C    subscripted, as follows:
C
C       If 'ROW.' is positive, this implies that the first subscript
C       of YDRA is a point number and the second subscript is a curve
C       number.  If 'ROW.' is negative, the order is reversed.
C
C       If the absolute value of 'ROW.' is 1, this implies that XDRA
C       is singly-subscripted, by point number only.  If the absolute
C       value of 'ROW.' is 2 or greater, this implies that XDRA is
C       doubly-subscripted, just like YDRA.
C
C    The default value of 'ROW.' is 1, spicifying that XDRA is singly-
C    subscripted and that YDRA is doubly-subscripted by point number
C    and curve number, in that order.
C
C -- LTYP, if non-zero, specifies new values for the AUTOGRAPH control
C    parameters 'X/LOGARITHMIC.' and 'Y/LOGARITHMIC.', which determine
C    whether the X and Y axes are linear or logarithmic.  Possible
C    values are as follows:
C
C       1 - x axis linear, y axis linear
C
C       2 - x axis linear, y axis logarithmic
C
C       3 - x axis logarithmic, y axis linear
C
C       4 - x axis logarithmic, y axis logarithmic
C
C    The default values of these parameters make both axes linear.
C
C    If the parameters 'X/LOGARITHMIC.' and 'Y/LOGARITHMIC.' are reset
C    by the routine DISPLA, they are given values which make them
C    immune to being reset when 'SET.' = 2, 3, or 4 (see the discussion
C    of the argument LSET, above).
C
C In calls to the routines AGSETP, AGSETF, AGSETI AGSETC, AGGETP,
C AGGETF, AGGETI, and AGGETC:
C
C -- TPGN is a character string identifying a group of AUTOGRAPH
C    control parameters.  It is of the form 'K1/K2/K3/ . . . /Kn.'.
C    Each Ki is a keyword.  The keyword K1 specifies a group of control
C    parameters, K2 a subgroup of that group, K3 a subgroup of that
C    subgroup, etc.  See the AUTOGRAPH write-up in the graphics manual
C    for a more complete description of these parameter-group names and
C    the ways in which they may be abbreviated.
C
C -- FURA is an array, from which control-parameter values are to be
C    taken (the routine AGSETP) or into which they are to be stored
C    (the routine AGGETP).  Note that the array is real; all of the
C    AUTOGRAPH parameters are stored internally as reals.
C
C -- LURA is the length of the user array FURA.
C
C -- FUSR is a variable, from which a single control parameter value is
C    to be taken (the routine AGSETF) or in which it is to be returned
C    (the routine AGGETF).  Note that the variable is real.
C
C -- IUSR is a variable, from which a single-control parameter value is
C    to be taken (the routine AGSETI) or in which it is to be returned
C    (the routine AGGETI).  Note that, since the control parameters are
C    stored internally as reals, each of the routines AGSETI and AGGETI
C    does a conversion - from integer to real or vice-versa.  Note also
C    that AGSETI and AGGETI should only be used for parameters which
C    have intrinsically integral values.
C
C -- CUSR is a character variable from which a character string is to
C    be taken (the routine AGSETC) or into which it is to be retrieved
C    (the routine AGGETC).  The control parameter affected by the call
C    contains the floating-point equivalent of an integer identifier
C    returned by the routine which stashes the character string and
C    tendered to the routine which retrieves it (sort of the automated
C    equivalent of a hat check).  Note that AGSETC and AGGETC should
C    only be used for parameters which intrinsically represent character
C    strings.
C
C In calls to the routine AGSTUP:
C
C -- XDRA is an array of x coordinates of user data - usually, but not
C    necessarily, the same data which will later be used in calls to
C    the routine AGCURV.
C
C -- NVIX is the number of vectors of data in XDRA - if XDRA is doubly-
C    dimensioned, NVIX would normally have the value of its second
C    dimension, if XDRA is singly-dimensioned, a 1.
C
C -- IIVX is the index increment between vectors in XDRA - if XDRA is
C    doubly-dimensioned, IIVX would normally have the value of its
C    first dimension, if XDRA is singly-dimensioned, a dummy value.
C
C -- NEVX is the number of elements in each data vector in XDRA - if
C    XDRA is doubly-dimensioned, NEVX would normally have the value of
C    its first dimension, if XDRA is singly-dimensioned, the value of
C    that single dimension.
C
C -- IIEX is the index increment between elements of a data vector in
C    XDRA - normally a 1.
C
C -- YDRA, NVIY, IIVY, NEVY, and IIEY are analogous to XDRA, NVIX,
C    IIVX, NEVX, and IIEX, but define y-coordinate data.
C
C In calls to the routine AGCURV:
C
C -- XVEC is a vector of x coordinate data.
C
C -- IIEX is the index increment between elements in XVEC.  AGCURV will
C    use XVEC(1), XVEC(1+IIEX), XVEC(1+2*IIEX), etc.
C
C -- YVEC is a vector of y coordinate data.
C
C -- IIEY is the index increment between elements in YVEC.  AGCURV will
C    use YVEC(1), YVEC(1+IIEY), YVEC(1+2*IIEY), etc.
C
C -- NEXY is the number of points defining the curve to be drawn.
C
C -- KDSH is a dashed-line selector.  Possible values are as follows:
C
C       If KDSH is zero, AUTOGRAPH will assume that the user has
C       called the routine DASHD (in the DASHCHAR package, which see)
C       to define the dashed-line pattern to be used.
C
C       If KDSH is less than zero and has absolute value M, AUTOGRAPH
C       will use the Mth (modulo 26) alphabetic dashed-line pattern.
C       Each of these patterns defines a solid line interrupted every
C       so often by a letter of the alphabet.
C
C       If KDSH is greater than zero and has the value M, AUTOGRAPH
C       will use the Mth (modulo N) dashed-line pattern in the group
C       of N dashed-line patterns defined by the AUTOGRAPH control
C       parameters in the group named 'DASH/PATTERNS.'.  The default
C       values of these parameters specify solid lines.
C
C In calls to the routines AGSAVE and AGRSTR:
C
C -- IFNO is the unit number associated with a file to which a single
C    unformatted logical record of data is to be written, or from which
C    such a record is to be read, by AUTOGRAPH.  The file is not rewound
C    before being written or read; positioning it properly is the user's
C    responsibility.
C
C In calls to the function AGBNCH:
C
C -- IDSH is a 16-bit binary dash pattern, the character equivalent of
C    which is to be returned as the value of AGBNCH.
C
C In calls to the function AGDSHN:
C
C -- IDSH is the number of the dash pattern parameter whose name is to
C    be returned as the value of the function AGDSHN.
C
C In calls to the routine AGUTOL:
C
C -- IAXS is the number of the axis.  The values 1, 2, 3, and 4 imply
C    the left, right, bottom, and top axes, respectively.
C
C -- FUNS is the value of the parameter 'AXIS/s/FUNCTION.' which may be
C    used to select the desired mapping function for axis IAXS.  It is
C    recommended that the default value (zero) be used to specify the
C    identity mapping.  A non-zero value may be integral (1., 2., etc.)
C    and serve purely to select the code to be executed or it may be the
C    value of a real parameter in the equations defining the mapping.
C
C -- IDMA specifies the direction of the mapping.  A value greater than
C    zero indicates that VINP is a value in the user system and that
C    VOTP is to be a value in the label system, a value less than zero
C    the opposite.
C
C -- VINP is an input value in one coordinate system along the axis.
C
C -- VOTP is an output value in the other coordinate system along the
C    axis.
C
C In calls to the routine AGCHAX:
C
C -- IFLG is zero if a particular object is about to be drawn, non-zero
C    if it has just been drawn.
C
C -- IAXS is the number of the axis being drawn.  The values 1, 2, 3,
C    and 4 indicate the left, right, bottom, and top axes, respectively.
C
C -- IPRT indicates the part of the axis being drawn.  Possible values
C    are as follows:
C
C    -- 1 implies the line of the axis.
C
C    -- 2 implies a major tick.
C
C    -- 3 implies a minor tick.
C
C    -- 4 implies the mantissa of a numeric label.
C
C    -- 5 implies the exponent of a numeric label.
C
C -- VILS is the value in the label system at the point where the part
C    is being drawn.  For IPRT = 1, VILS is zero.
C
C In calls to the routine AGCHCU:
C
C -- IFLG is zero if a particular object is about to be drawn, non-zero
C    if it has just been drawn.
C
C -- KDSH is the value with which AGCURV was called, as follows:
C
C       AGCURV called by   Value of KDSH
C       ----------------   ----------------------------------------
C       EZY                1
C       EZXY               1
C       EZMY               "n" or "-n", where n is the curve number
C       EZMXY              "n" or "-n", where n is the curve number
C       the user program   the user value
C
C In calls to the routine AGCHIL:
C
C -- IFLG is zero if a particular object is about to be drawn, non-zero
C    if it has just been drawn.
C
C -- LBNM is a character variable containing the name of the label being
C    drawn.
C
C -- LNNO is the number of the line being drawn.
C
C In calls to the routine AGCHNL:
C
C -- IAXS is the number of the axis being drawn.  The values 1, 2, 3,
C    and 4 imply the left, right, bottom, and top axes, respectively.
C
C -- VILS is the value to be represented by the numeric label, in the
C    label system for the axis.  The value of VILS must not be altered.
C
C -- CHRM, on entry, is a character string containing the mantissa of
C    the numeric label, as it will appear if AGCHNL makes no changes.
C    If the numeric label includes a "times" symbol, it is represented
C    by a blank in CHRM.  (See IPXM, below.)  CHRM may be modified.
C
C -- MCIM is the length of CHRM - the maximum number of characters that
C    it will hold.  The value of MCIM must not be altered.
C
C -- NCIM, on entry, is the number of meaningful characters in CHRM.  If
C    CHRM is changed, NCIM should be changed accordingly.
C
C -- IPXM, on entry, is zero if there is no "times" symbol in CHRM; if
C    it is non-zero, it is the index of a character position in CHRM.
C    If AGCHNL changes the position of the "times" symbol in CHRM,
C    removes it, or adds it, the value of IPXM must be changed.
C
C -- CHRE, on entry, is a character string containing the exponent of
C    the numeric label, as it will appear if AGCHNL makes no changes.
C    CHRE may be modified.
C
C -- MCIE is the length of CHRE - the maximum number of characters that
C    it will hold.  The value of MCIE must not be altered.
C
C -- NCIE, on entry, is the number of meaningful characters in CHRE.  If
C    CHRE is changed, NCIE should be changed accordingly.
C
C ---------------------------------------------------------------------
C T H E   A U T O G R A P H   C O D E
C ---------------------------------------------------------------------
C
C Following is the AUTOGRAPH code.  Routines appear in alphabetic order.
C
      SUBROUTINE AGAXIS (IAXS,QTST,QSPA,WCWP,HCWP,XBGA,YBGA,XNDA,YNDA,
     +                   QLUA,UBGA,UNDA,FUNS,QBTP,BASE,QJDP,WMJL,WMJR,
     +                   QMNT,QNDP,WMNL,WMNR,QLTP,QLEX,QLFL,QLOF,QLOS,
     +                   DNLA,WCLM,WCLE,RFNL,QCIM,QCIE,WNLL,WNLR,WNLB,
     +                                                           WNLE)
C
C The routine AGAXIS is used to draw, tick-mark, and label an axis or,
C if ITST is non-zero, to pre-compute the amount of space which will be
C required for numeric labels when the axis is actually drawn.  AGAXIS
C assumes that the last call to the plot-package routine SET was as
C follows (or the equivalent thereof):
C
C    CALL SET (XLCW,XRCW,YBCW,YTCW,0.,1.,0.,1.,1)
C
C where XLCW, XRCW, YBCW, and YTCW are the coordinates of the left,
C right, bottom, and top edges of the curve window, stated as fractions
C of the appropriate edge of the plotter frame.
C
C The arguments of AGAXIS are as follows:
C
C -- IAXS is the number of the axis being drawn - 1, 2, 3, or 4, meaning
C    the left, right, bottom, and top axes, respectively.
C
C -- ITST is an integer specifying what the caller wishes AGAXIS to do,
C    as follows:
C
C    -- If ITST .LT. 0, AGAXIS is to draw only the axis, nothing else.
C
C    -- If ITST .EQ. 0, AGAXIS is to draw, tick, and label the axis.
C
C    -- If ITST .GT. 0, AGAXIS is to pre-compute the amount of space
C       which will be required for numeric labels.  If the labels will
C       not fit in the space provided, AGAXIS is instructed to take
C       action as follows:
C
C       -- ITST .EQ. 1 - no action.
C
C       -- ITST .EQ. 2 - shrink the labels.
C
C       -- ITST .EQ. 3 - re-orient the labels.
C
C       -- ITST .EQ. 4 - shrink and/or re-orient the labels.
C
C -- ISPA is a 0 or a 1, specifying whether or not the axis itself is
C    to be drawn.  If ISPA .NE. 0, the axis is suppressed.  Tick marks
C    and/or labels may still be drawn.
C
C -- WCWP is the width of the curve window, in plotter units.
C
C -- HCWP is the height of the curve window, in plotter units.
C
C -- XBGA, YBGA, XNDA, and YNDA are the x and y coordinates of the ends
C    of the axis.  X coordinates are stated as fractions of the width,
C    y coordinates as fractions of the height, of the curve window.  The
C    axis to be drawn must be either horizontal or vertical (at an angle
C    of 0, 90, 180, or 270 degrees).  The left side, right side, begin-
C    ning, and end of the axis are defined from the viewpoint of a demon
C    standing at (XBGA,YBGA) and staring balefully toward (XNDA,YNDA).
C
C -- LLUA, UBGA, and UNDA define the mapping of the "user" coordinate
C    system (used for data-point coordinates) onto the axis.  If LLUA
C    is zero, the mapping is linear; if LLUA is non-zero, the mapping
C    is logarithmic.  UBGA is the user-system value at the beginning of
C    the axis, UNDA the value at the end of the axis.  The subroutine
C    AGFTOL, which needs these parameters, is actually passed LLUA,
C    UBEG=F(UBGA), and UDIF=F(UNDA)-F(UBGA), where F is the function
C    F(X)=X or the function F(X)=ALOG10(X), depending on LLUA.
C
C -- FUNS is a function-selector, to be used in calls to AGUTOL, which
C    defines the mappings from the user system to the label system and
C    vice-versa for each of the four axes.  The functions defined must
C    be continuous, monotonic, and bounded within the user-system range
C    (UBGA,UNDA) and a little bit outside that range.  The positions
C    of numeric labels and tick marks are chosen in the label system,
C    mapped to the user system, and then onto the axis.
C
C -- NBTP and BASE specify how major ticks are to be positioned in the
C    label coordinate system.  See the routine AGNUMB (arguments NBTP,
C    SBSE, and EXMU) for a description of these arguments.  Note that
C    NBTP .EQ. 0 or BASE .EQ. 0. suppresses both major tick marks and
C    their labels.  Note:  SBSE .EQ. +BASE or -BASE, as needed.
C
C -- QJDP is the major-tick-mark dash pattern (0. .LE. QJDP .LE. 65535.)
C    QJDP .LE. 0 suppresses major ticks.
C
C -- WMJL and WMJR are the distances to the left and right ends of the
C    major tick marks, stated as fractions of the shortest side of the
C    curve window.  Values .EQ. 0 may be used to suppress one or both
C    portions.  Values .GE. 1 may be used to extend a given portion all
C    the way to the edge of the curve window.  (See routine AGCTKO.)
C
C -- NMNT is the number of minor tick marks to be placed between each
C    pair of consecutive major tick marks.  NMNT .EQ. 0 suppresses them.
C
C -- QNDP, WMNL, and WMNR are analogous to QJDP, WMJL, and WMJR, but
C    specify minor-tick-mark characteristics.
C
C -- NLTP, NLEX, and NLFL specify the graphic form of numeric labels, as
C    described in the routine AGNUMB (which see).  Note that NLTP .LE. 0
C    suppresses numeric labels.
C
C -- NLOF and NLOS are first and second choices for the numeric label
C    orientation.  Both must be multiples of 90, specifying an angle
C    measured in degrees counter-clockwise from a vector running from
C    left to right in the curve window.  If ITST .EQ. 0, AGAXIS uses
C    NLOF if it is .GE. 0, NLOS otherwise, for the label orientation.
C    If ITST .NE. 0, AGAXIS initially makes both NLOF and NLOS positive.
C    Then, if ITST .GE. 3, NLOF may or may not be made negative.  (To
C    set the sign of NLOF or NLOS, AGAXIS adds or subtracts 360*K.)
C
C -- DNLA is the desired distance of numeric labels from the axis,
C    positive to the left, negative to the right, of the axis.  The
C    magnitude of DNLA is the size of the gap between the axis and the
C    nearest edge of a label, expressed as a fraction of the smaller
C    dimension of the curve window.  See also RFNL, below.
C
C -- WCLM and WCLE are the desired widths of characters in the mantissa
C    or the exponent, respectively, of numeric labels, expressed as a
C    fraction of the smaller dimension of the curve window.  See also
C    RFNL, below.
C
C -- RFNL is a reduction factor, used as a multiplier for DNLA, WCLM,
C    and WCLE.  If ITST .NE. 0, RFNL is initially set to 1. - then, if
C    ITST .EQ. 2 or 4, it is reset as necessary to shrink the labels.
C
C -- MCIM and MCIE specify the maximum number of characters in the
C    mantissa and exponent, respectively, of a numeric label.  These
C    are input parameters if ITST .EQ. 0, output parameters otherwise.
C
C -- WNLL, WNLR, WNLB, and WNLE are the widths of numeric-label strips
C    on the left side, on the right side, at the beginning, and at the
C    end, of the axis.  These are both input and output parameters of
C    AGAXIS.  On input, they specify the amount of space available for
C    numeric labels - on output, they specify the amount of space used
C    (if ITST .EQ. 0) or required (if ITST .NE. 0).  Each is stated as
C    a fraction of either the width or the height of the curve window,
C    depending on the orientation of the axis in the curve window.
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.  The only ones
C actually used here are ISLD, MWCM, MWCE, and MDLA.  ISLD is a solid-
C line dash pattern (sixteen one bits).  MWCM, MWCE, and MDLA specify
C the minimum allowed values of the width of a character in a label
C mantissa, the width of a character in a label exponent, and the
C distance of a label from the axis.  All are in plotter coordinate
C units.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The AUTOGRAPH function AGFPBN is of type integer.
C
      INTEGER AGFPBN
C
C Local data required are as follows:
C
C BFRM is a buffer in which the routine AGNUMB returns the characters of
C a label mantissa.  CTMP holds a sub-string from an AGPWRT call.
C
      CHARACTER*40 BFRM
      CHARACTER*40 CTMP
C
C BFRE is a buffer in which the routine AGNUMB returns the characters of
C a label exponent.
C
      CHARACTER*5 BFRE
C
C XMJT, YMJT, XMNT, and YMNT are used to hold x and y offsets to the
C endpoints of left-of-label and right-of-label portions of major and
C minor tick marks.
C
      DIMENSION XMJT(4),YMJT(4),XMNT(4),YMNT(4)
C
C SMJP is the minimum distance allowed between major tick marks, in
C plotter coordinate units.
C
      DATA SMJP / 4. /
C
C FBGM, FBGP, FNDM, and FNDP are the coordinates of points a little on
C either side of the beginning and end of the axis, as fractions of the
C distance along the axis.
C
      DATA FBGM / -0.000001 /
      DATA FBGP / +0.000001 /
      DATA FNDM / +0.999999 /
      DATA FNDP / +1.000001 /
C
C HCFW is an arithmetic statement function specifying the height of a
C character as a function of its width (not counting "white space").
C The value of the multiplier was determined heuristically, by trying
C various values and seeing which gave the best results.
C
      HCFW(WDTH)=1.25*WDTH
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This is the initialization section of AGAXIS.
C
C Unpack integer values from floating-point arguments.
C
      ITST=IFIX(QTST)
      ISPA=IFIX(QSPA)
      LLUA=IFIX(QLUA)
      NBTP=IFIX(QBTP)
      NMNT=IFIX(QMNT)
      NLTP=IFIX(QLTP)
      NLEX=IFIX(QLEX)
      NLFL=IFIX(QLFL)
      NLOF=IFIX(QLOF)
      NLOS=IFIX(QLOS)
      MCIM=IFIX(QCIM)
      MCIE=IFIX(QCIE)
C
C Initialize the local flags which specify what entities to draw, using
C values appropriate for the following quick exit.
C
      LDAX=1-ISPA
      LDNL=0
      LDMN=0
C
C If AGAXIS is to draw only the axis, exit immediately.
C
      IF (ITST.LT.0) GO TO 800
C
C If either NBTP or BASE is zeroed, exit immediately.
C
      IF (NBTP.EQ.0.OR.BASE.EQ.0.) GO TO 800
C
C Re-initialize the flag controlling the drawing of numeric labels.
C
      IF (NLTP.NE.0) LDNL=1
C
C If this is not a test run, skip.
C
      IF (ITST.EQ.0) GO TO 101
C
C This is a test run - exit if there are no numeric labels.
C
      IF (LDNL.EQ.0) GO TO 800
C
C This is a test run and the axis is to have numeric labels - initialize
C the numeric-label orientation and sizing parameters.  Clobber drawing.
C
      NLOF=MOD(NLOF+3600,360)
      NLOS=MOD(NLOS+3600,360)
      RFNL=1.
      MCIM=0
      MCIE=0
      LDMJ=0
      LDMN=0
C
C The main body of the initialization follows.
C
C Compute the length of the smaller side of the curve window, in the
C plotter coordinate system.
C
  101 SCWP=AMIN1(WCWP,HCWP)
C
C Compute a set of direction numbers for the axis, in the curve-window
C coordinate system (the change in x and y from the beginning to the
C end of the axis).
C
      XDNA=XNDA-XBGA
      YDNA=YNDA-YBGA
C
C Compute the length of the axis in the plotter coordinate system and
C its direction cosines.
C
      XDNP=XDNA*WCWP
      YDNP=YDNA*HCWP
      AXLP=SQRT(XDNP*XDNP+YDNP*YDNP)
      XDCA=XDNP/AXLP
      YDCA=YDNP/AXLP
C
C Compute the axis orientation angle, in degrees counter-clockwise.
C
      IAOR=MOD(IFIX(57.2957795130823*ATAN2(YDCA,XDCA)+3600.5),360)
C
C Compute the multiplicative constants required to convert a fraction of
C the axis length to a fraction of the width or height of the curve
C window (a distance in x or y).
C
      CFAX=AXLP/WCWP
      CFAY=AXLP/HCWP
C
C Compute the multiplicative constants required to convert a fraction of
C the axis length to a fraction of the along-axis and perpendicular-to-
C axis sides of the curve window.
C
      CFAA=ABS(XDCA*CFAX+YDCA*CFAY)
      CFAP=ABS(XDCA*CFAY+YDCA*CFAX)
C
C Compute the quantities (UBEG) and (UDIF) for AGFTOL.
C
      IF (LLUA.NE.0) GO TO 102
C
      UBEG=UBGA
      UDIF=UNDA-UBGA
      GO TO 103
C
  102 UBEG=ALOG10(UBGA)
      UDIF=ALOG10(UNDA)-UBEG
C
C SMJT and SMNT are fractions of the axis length and specify the minimum
C space which must be available between two major ticks before the major
C ticks themselves or the minor ticks between them, respectively, may be
C drawn.
C
  103 SMJT=SMJP/AXLP
      SMNT=SMJT*FLOAT(NMNT+1)
C
C Initialize the fractional numeric-label character heights.
C
      FHCM=0.
      FHCE=0.
C
C If the axis has no numeric labels, skip the following code.
C
      IF (LDNL.EQ.0) GO TO 104
C
C Zero the numeric-label offset.
C
      FNLO=0.
C
C The numeric-label parameters are computed by an internal procedure
C (which see, below).
C
      ASSIGN 104 TO JMP3
      GO TO 500
C
C If this is a test run, skip the following code.
C
  104 IF (ITST.NE.0) GO TO 200
C
C This is not a test run.  First, set up the tick-mark parameters.
C
C Compute the multiplicative constant required to convert a fraction of
C the smaller dimension of the grid to a fraction of the axis length.
C
      CSFA=SCWP/AXLP
C
C Compute the widths of the left and right portions of the numeric-label
C space as fractions of the axis length, affixing an appropriate sign.
C
      FNLL=-WNLL/CFAP
      FNLR=+WNLR/CFAP
C
C Compute a jump parameter to sort out the axis orientations.
C
      JAOR=1+IAOR/90
C
C The routine AGCTKO is used to compute the rest of the tick parameters.
C
      CALL AGCTKO (XBGA,YBGA,XDCA,YDCA,CFAX,CFAY,CSFA,JAOR,   1,QJDP,
     +             WMJL,WMJR,FNLL,FNLR,MJ12,MJ34,XMJT,YMJT)
C
      CALL AGCTKO (XBGA,YBGA,XDCA,YDCA,CFAX,CFAY,CSFA,JAOR,NMNT,QNDP,
     +             WMNL,WMNR,FNLL,FNLR,MN12,MN34,XMNT,YMNT)
C
C Set the flags controlling the drawing of tick marks.
C
      LDMJ=MJ12+MJ34
      LDMN=MN12+MN34
      LDLR=-(LDMJ+LDMN)
C
C If no numeric labels are to be drawn, skip the following code.
C
      IF (LDNL.EQ.0) GO TO 117
C
C Numeric labels are to be drawn.  Precompute parameters which will be
C used to position labels relative to the axis.
C
C Compute the widths and heights of the longest possible label mantissa
C and exponent, as fractions of the length of the axis.
C
      FWLM=FLOAT(MCIM)*FWCM
      FWLE=FLOAT(MCIE)*FWCE
      FHLM=FHCM
      FHLE=FHCE
      IF (MCIE.EQ.0) FHLE=0.
C
C Jump on the label-to-axis orientation.
C
      GO TO (105,106,107,108) , JLAO
C
C Label is at a 0-degree angle to the axis.
C
  105 FBLP=-FHLM
      GO TO 109
C
C Label is at a 90-degree angle to the axis.
C
  106 FBLA=0.
      FBLQ=-FWLM-FWLE
      GO TO 110
C
C Label is at a 180-degree angle to the axis.
C
  107 FBLP=FHLM+FHLE
      GO TO 109
C
C Label is at a 270-degree angle to the axis.
C
  108 FBLA=0.
      FBLQ=FWLM+FWLE
      GO TO 110
C
C Label is parallel to the axis.
C
  109 FNLW=FHLM+.5*FHLE
      FBLQ=0.
      GO TO 111
C
C Label is perpendicular to the axis.
C
  110 FNLW=FWLM+FWLE
      FBLP=0.
C
C If the labels will not fit in the space provided, clobber them.
C
  111 IF (.999999*FNLW.LT.FNLR-FNLL) GO TO 112
C
      LDNL=0
      GO TO 117
C
C Jump on the signed value of the numeric-label distance from the axis.
C
  112 IF (DNLA) 113,114,115
C
C Labels are to the right of the axis.
C
  113 FNLC=FDLA+.5*FNLW
      FBLP=FDLA+.5*ABS(FBLP-FHLE)
      FBLQ=FDLA+.5*ABS(FBLQ+FWLM-FWLE)
      GO TO 116
C
C Labels are centered on the axis.
C
  114 FNLC=0.
      FBLP=0.
      FBLQ=0.
      GO TO 116
C
C Labels are to the left of the axis.
C
  115 FNLC=-(FDLA+.5*FNLW)
      FBLP=-(FDLA+.5*ABS(FBLP))
      FBLQ=-(FDLA+.5*ABS(FBLQ-FWLM+FWLE))
C
  116 FNLO=.5*(FNLL+FNLR)-FNLC
C
C If the axis would pass through the offset labels, clobber it.
C
      IF (FNLL*FNLR.LT.0.) LDAX=0
C
C Jump to draw numeric labels and/or tick marks.
C
      GO TO 200
C
C No numeric labels are to be drawn.  If no tick marks are to be drawn
C either, exit.
C
  117 IF (LDLR.EQ.0) GO TO 800
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C The following code directs the process of tick-marking and labelling
C the axis, using the internal procedures which follow it.  If the
C label-coordinate-system value 0 maps onto the axis, tick-marking and
C labelling are done in two passes, one starting at 0 and proceeding
C in a positive direction and the other starting at 0 and proceeding
C in a negative direction.  If the label-coordinate-system value 0 does
C not map onto the axis, only one pass is required.
C
C First, determine the label-coordinate-system values VBGM and VNDP at
C the points FBGM and FNDP, a little beyond the ends of the axis.
C
  200 CALL AGFTOL (IAXS,1,FBGM,VBGM,DUMI,LLUA,UBEG,UDIF,FUNS,NBTP,BASE)
      CALL AGFTOL (IAXS,1,FNDP,VNDP,DUMI,LLUA,UBEG,UDIF,FUNS,NBTP,BASE)
C
C If zero falls on the axis, jump to the two-pass section of the code.
C
      IF (VBGM*VNDP.LE.0.) GO TO 201
C
C We may tick-mark and label the axis in a single pass.  Compute an
C appropriate starting value for the exponent/multiplier EXMU.
C
      SBSE=SIGN(BASE,VBGM)
      CALL AGFTOL (IAXS,2,FBGM,EBGM,DUMI,LLUA,UBEG,UDIF,FUNS,NBTP,SBSE)
      CALL AGFTOL (IAXS,2,FNDP,ENDP,DUMI,LLUA,UBEG,UDIF,FUNS,NBTP,SBSE)
      EXMU=AMIN1(EBGM,ENDP)
      EXMU=EXMU-AMOD(EXMU,1.)+.5+SIGN(.5,EXMU)
C
C Set the numeric-label-space limits for the beginning and end of the
C axis.
C
      FNLB=FBGM-WNLB/CFAA-.5*(FHCM+FHCE)
      FNLE=FNDP+WNLE/CFAA+.5*(FHCM+FHCE)
C
C Jump to an internal procedure to tick-mark and label the axis.  Return
C from there to the termination section of AGAXIS.
C
      ASSIGN 800 TO JMP1
      GO TO 300
C
C Tick marks and labels must be done in two passes.  First, draw the
C tick mark and/or label at the zero position in the label system, using
C an internal procedure below.  A number of parameters must be preset.
C
  201 CALL AGFTOL (IAXS,-1,0.,FRAX,VLCS,LLUA,UBEG,UDIF,FUNS,NBTP,BASE)
C
C Determine whether label is to be drawn or not.
C
      LDLB=0
      IF (LDNL.EQ.0) GO TO 202
      LDLB=1
C
C The mantissa portion of the label consists of the single character 0.
C
      BFRM(1:1)='0'
      NCIM=1
      IPXM=0
C
C The label has no exponent portion.
C
      NCIE=0
C
C Allow the user to change the numeric label.
C
      CALL AGCHNL (IAXS,VLCS,BFRM,40,NCIM,IPXM,BFRE,5,NCIE)
C
C Compute the length of the mantissa, the exponent, and the whole label.
C
      FLLM=FLOAT(NCIM)*FWCM
      FLLE=FLOAT(NCIE)*FWCE
      FLLB=FLLM+FLLE
C
C The numeric-label space begins and ends at impossible values.
C
      FNLB=-10.
      FNLE=+10.
C
C Force the labeler to update FNLB, rather than FNLE.
C
      FDIR=1.
C
C Jump to an internal procedure to draw the label and/or the tick mark.
C
  202 ASSIGN 203 TO JMP2
      GO TO 400
C
C Save the position of the zero-point (FRAX, expressed as a fraction of
C the axis length) and preset the parameter DZRT, which is the minimum
C distance from the zero-point at which a major tick mark could occur,
C and the parameter DZRL, which is the minimum distance from the zero-
C point at which a label could occur.  Set the label-space limit FNLE.
C Preset the internal-procedure exit parameter JMP1.
C
  203 ASSIGN 205 TO JMP1
      FZRO=FRAX
      DZRT=AMAX1(SMJT,1.6*FLOAT(LDNL)*FHCM)
      IF (LDNL.EQ.0) GO TO 204
      DZRL=FNLB-FZRO
      FNLE=FNDP+WNLE/CFAA+.5*(FHCM+FHCE)
C
C Do the portion of the axis lying in the direction specified by DZRT.
C If it is too short, skip it entirely.
C
  204 FRAX=FZRO+DZRT
      IF (FRAX.LT.FBGM.OR.FRAX.GT.FNDP) GO TO JMP1 , (205,800)
C
C Find out whether BASE must be negated for this portion.
C
      CALL AGFTOL (IAXS,1,FRAX,VLCS,DUMI,LLUA,UBEG,UDIF,FUNS,NBTP,BASE)
      SBSE=SIGN(BASE,VLCS)
C
C Compute a starting value of the exponent/multiplier EXMU.
C
      CALL AGFTOL (IAXS,2,FRAX,EXMU,DUMI,LLUA,UBEG,UDIF,FUNS,NBTP,SBSE)
      EXMU=EXMU-AMOD(EXMU,1.)+.5+SIGN(.5,EXMU)
C
C Jump to an internal procedure to draw the tick marks and/or labels.
C
      GO TO 300
C
C Set up to do the second portion of the axis, then go do it.
C
  205 ASSIGN 800 TO JMP1
      DZRT=-DZRT
      IF (LDNL.EQ.0) GO TO 204
      FNLB=FBGM-WNLB/CFAA-.5*(FHCM+FHCE)
      FNLE=FZRO-DZRL
      GO TO 204
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C The following is an internal procedure, exited via the assigned-go-to
C variable JMP1.  Its purpose is to tick-mark and label a portion of the
C axis (perhaps the entire axis) at positions determined by consecutive
C values of the parameter EXMU.  It prevents tick marks from piling up
C or passing through the label space and prevents overlapping of labels.
C Tick marks are drawn alternately from left to right or vice-versa.
C
C The caller has provided an initial value of EXMU, but we must consider
C possible minor tick marks in the interval (EXMU-1.,EXMU).
C
  300 EXMU=EXMU-1.
C
C Compute FRAX, which is the fractional distance along the axis, and
C VLCS, which is the value in the label coordinate system corresponding
C to the current value of EXMU.
C
      CALL AGFTOL (IAXS,-2,EXMU,FRAX,VLCS,LLUA,UBEG,UDIF,FUNS,NBTP,SBSE)
C
C Move the current values of EXMU, FRAX, and VLCS to ELST, FLST, and
C VLST, specifying the last values of these parameters.  Then increment
C EXMU by 1. and recompute FRAX and VLCS.  (The loop through consecutive
C values of EXMU begins here.)
C
  301 ELST=EXMU
      FLST=FRAX
      VLST=VLCS
C
      EXMU=EXMU+1.
      CALL AGFTOL (IAXS,-2,EXMU,FRAX,VLCS,LLUA,UBEG,UDIF,FUNS,NBTP,SBSE)
C
C FDIR indicates the direction, FDST the magnitude, of step along axis.
C
      FDIR=FRAX-FLST
      FDST=ABS(FDIR)
C
C Draw minor tick marks, if any, in the interval (FLST,FRAX).
C
      IF (LDMN.EQ.0.OR.FDST.LT.SMNT) GO TO 304
C
C Use the dashed-line pattern for minor tick marks.
C
      CALL DASHDB (AGFPBN(QNDP))
C
C Minor tick marks are equally spaced in the label-coordinate system.
C
      VINC=(VLCS-VLST)/FLOAT(NMNT+1)
C
      DO 303 I=1,NMNT
        VMNT=VLST+VINC*FLOAT(I)
        CALL AGFTOL (IAXS,-1,VMNT,FMNT,DUMI,LLUA,UBEG,UDIF,FUNS,NBTP,
     +                                                             SBSE)
        IF (FMNT.LT.FBGP.OR.FMNT.GT.FNDM) GO TO 303
        XPAX=XBGA+FMNT*XDNA
        YPAX=YBGA+FMNT*YDNA
        LDLR=-LDLR
        IF (LDLR.LT.0) GO TO 302
        CALL AGCHAX (0,IAXS,3,VMNT)
        IF (MN12.NE.0) CALL LINED (XPAX+XMNT(1),YPAX+YMNT(1),
     +                             XPAX+XMNT(2),YPAX+YMNT(2))
        IF (MN34.NE.0) CALL LINED (XPAX+XMNT(3),YPAX+YMNT(3),
     +                             XPAX+XMNT(4),YPAX+YMNT(4))
        CALL AGCHAX (1,IAXS,3,VMNT)
        GO TO 303
  302   CALL AGCHAX (0,IAXS,3,VMNT)
        IF (MN34.NE.0) CALL LINED (XPAX+XMNT(4),YPAX+YMNT(4),
     +                             XPAX+XMNT(3),YPAX+YMNT(3))
        IF (MN12.NE.0) CALL LINED (XPAX+XMNT(2),YPAX+YMNT(2),
     +                             XPAX+XMNT(1),YPAX+YMNT(1))
        CALL AGCHAX (1,IAXS,3,VMNT)
  303 CONTINUE
C
C If the end of the axis has been reached, return to caller.
C
  304 IF (FRAX.LT.FBGM.OR.FRAX.GT.FNDP) GO TO JMP1 , (205,800)
C
C Draw the major tick mark and/or the numeric label at FRAX.
C
      IF (FDST.LT.SMJT) GO TO 301
      LDLB=0
      IF (LDNL.EQ.0) GO TO 305
      CALL AGNUMB (NBTP,SBSE,EXMU,NLTP,NLEX,NLFL,BFRM,40,NCIM,IPXM,BFRE,
     +                                                           5,NCIE)
      CALL AGCHNL (IAXS,VLCS,BFRM,40,NCIM,IPXM,BFRE,5,NCIE)
C
C If this is not a test run, mantissa and exponent length are checked.
C
      IF (ITST.EQ.0.AND.(NCIM.GT.MCIM.OR.NCIE.GT.MCIE)) GO TO 305
      LDLB=1
      FLLM=FLOAT(NCIM)*FWCM
      FLLE=FLOAT(NCIE)*FWCE
      FLLB=FLLM+FLLE
C
C Use the next internal procedure to draw the major tick and/or label.
C
  305 ASSIGN 301 TO JMP2
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C The following is an internal procedure, exited via the assigned-go-to
C variable JMP2.  Its purpose is to draw the major tick mark and/or the
C numeric label at a specified point on the axis or, if ITST is .NE. 0,
C to predict the amount of space which will be required for such items.
C
C Jump if no label is to be drawn.
C
  400 IF (LDLB.EQ.0.OR.NCIM.LE.0) GO TO 410
C
C See if the label will fit without overlapping another label.  To do
C this, first compute its fractional length along the axis (FLAA).
C
      GO TO (401,402,401,402) , JLAO
C
C Label is parallel to the axis.  Allow for inter-label spacing.
C
  401 FLAA=FLLB+FWCM
      GO TO 403
C
C Label is perpendicular to the axis.  Ignore exponent portion.
C
  402 FLAA=1.6*FHCM
C
C Compute the fractional coordinates of the endpoints of the label
C (along the axis) and see if it will fit in the available label space.
C
  403 FLBB=FRAX-.5*FLAA
      FLBE=FRAX+.5*FLAA
C
      IF (FLBB.GE.FNLB.AND.FLBE.LE.FNLE) GO TO 407
C
C Label will not fit.  Omit it or, if this is a test run, see if any
C remedial action is to be taken.
C
      LDLB=0
      IF (ITST.EQ.0) GO TO 411
C
C This is a test run and we have two consecutive labels which overlap.
C See what can be done about it.
C
      GO TO (424,404,406,404) , ITST
C
C We are allowed to shrink the labels.  See if they are minimum-size
C already.  If so, the only other possibility is to re-orient them.
C
  404 IF (IWCM.LE.MWCM.AND.IWCE.LE.MWCE.AND.IDLA.LE.MDLA) GO TO 405
C
C If not, shrink them by an amount based on the extent of the overlap,
C reset the parameters affected, and start from square one.
C
      RFNL=AMIN1(.9,FDST/(FDST+AMAX1(FNLB-FLBB,FLBE-FNLE)))*RFNL
      MCIM=0
      MCIE=0
      ASSIGN 200 TO JMP3
      GO TO 500
C
C If labels have already been shrunk to minimum size, see if we can
C re-orient them.  If not, at least continue with finding the maximum
C mantissa and exponent lengths.
C
  405 IF (ITST.NE.4) GO TO 424
C
C Try re-orienting the labels.  If this has already been tried, or it it
C would be pointless, skip it, but continue with finding the maximum
C mantissa and exponent lengths.
C
  406 IF (NLOF.LT.0.OR.NLOS.EQ.NLOF.OR.JLAO.EQ.2.OR.JLAO.EQ.4) GO TO 424
C
C If re-orienting makes sense, reset the appropriate parameters and
C start from square one.
C
      NLOF=NLOF-360
      RFNL=1.
      MCIM=0
      MCIE=0
      ASSIGN 200 TO JMP3
      GO TO 500
C
C Label will fit.  Update the label space limits for next time.
C
  407 IF (FDIR.GE.0.) GO TO 408
      FNLE=FLBB
      GO TO 409
  408 FNLB=FLBE
C
C If this is not just a test shot, go off and draw the tick mark/label.
C
  409 IF (ITST.EQ.0) GO TO 411
C
C If this is a test shot, update the maximum mantissa and exponent
C lengths being generated and exit from this internal procedure.
C
      MCIM=MAX0(MCIM,NCIM)
      MCIE=MAX0(MCIE,NCIE)
      GO TO 424
C
C No label is to be drawn.  If this is a test shot, exit from this
C internal procedure without drawing the tick mark.
C
  410 IF (ITST.NE.0) GO TO 424
C
C Compute x and y coordinates of current axis point.
C
  411 XPAX=XBGA+FRAX*XDNA
      YPAX=YBGA+FRAX*YDNA
C
C Jump if no major tick-mark is to be drawn.  Otherwise, set up the
C dash pattern for major tick-marks.
C
      IF (LDMJ.EQ.0) GO TO 414
      CALL DASHDB (AGFPBN(QJDP))
C
C Flip the left-to-right/right-to-left direction flag.
C
      LDLR=-LDLR
C
C Draw the first portion of the tick mark.
C
      IF (LDLR) 413,414,412
C
  412 IF (MJ12.NE.0) THEN
        CALL AGCHAX (0,IAXS,2,VLCS)
        CALL LINED (XPAX+XMJT(1),YPAX+YMJT(1),XPAX+XMJT(2),YPAX+YMJT(2))
        CALL AGCHAX (1,IAXS,2,VLCS)
      END IF
      GO TO 414
C
  413 IF (MJ34.NE.0) THEN
        CALL AGCHAX (0,IAXS,2,VLCS)
        CALL LINED (XPAX+XMJT(4),YPAX+YMJT(4),XPAX+XMJT(3),YPAX+YMJT(3))
        CALL AGCHAX (1,IAXS,2,VLCS)
      END IF
C
C Draw the label, if any.
C
  414 IF (LDLB.EQ.0.OR.NCIM.LE.0) GO TO 421
C
C Compute the distances from (XPAX,YPAX) to the beginning of the label -
C along the axis (FBLA) and perpendicular to the axis (FBLP).  Each is a
C directed distance whose magnitude represents a fraction of the length
C of the axis.  The values depend on the label/axis orientation and the
C distance of the label from the axis.  In some cases, these quantities,
C or portions of them, have already been computed.
C
      GO TO (415,416,417,418) , JLAO
C
C Label is at a 0-degree angle to the axis.
C
  415 FBLA=-.5*FLLB
      GO TO 419
C
C Label is at a 90-degree angle to the axis.
C
  416 FBLP=FBLQ+FLLM
      IF (DNLA.EQ.0.) FBLP=.5*FLLB
      GO TO 419
C
C Label is at a 180-degree angle to the axis.
C
  417 FBLA=.5*FLLB
      GO TO 419
C
C Label is at a 270-degree angle to the axis.
C
  418 FBLP=FBLQ-FLLM
      IF (DNLA.EQ.0.) FBLP=-.5*FLLB
C
C Draw the mantissa portion of the label (excluding the "X", if any).
C
  419 DEEX=FBLA*XDCA+(FBLP+FNLO)*YDCA
      DEEY=FBLA*YDCA-(FBLP+FNLO)*XDCA
      CALL AGCHAX (0,IAXS,4,VLCS)
      IF (IPXM.EQ.0) THEN
        CALL AGPWRT (XPAX+CFAX*DEEX,
     +               YPAX+CFAY*DEEY,BFRM,NCIM,IWCM,NLOR,-1)
      ELSE
        CALL AGPWRT (XPAX+CFAX*(DEEX+(FLLM-3.*FWCM)*XDCL),
     +               YPAX+CFAY*(DEEY+(FLLM-3.*FWCM)*YDCL),
     +               BFRM,IPXM-1,IWCM,NLOR,+1)
        CTMP=BFRM(IPXM+1:NCIM)
        CALL AGPWRT (XPAX+CFAX*(DEEX+(FLLM-2.*FWCM)*XDCL),
     +               YPAX+CFAY*(DEEY+(FLLM-2.*FWCM)*YDCL),
     +               CTMP,NCIM-IPXM,IWCM,NLOR,-1)
      END IF
      DEEX=DEEX+FLLM*XDCL
      DEEY=DEEY+FLLM*YDCL
C
C Draw the "X" portion of the mantissa, if it was left out above.
C
      IF (IPXM.EQ.0) GO TO 420
      DEEX=DEEX-2.5*FWCM*XDCL
      DEEY=DEEY-2.5*FWCM*YDCL
      CALL LINE (XPAX+CFAX*(DEEX-.3*FWCM*(XDCL-YDCL)),
     +           YPAX+CFAY*(DEEY-.3*FWCM*(YDCL+XDCL)),
     +           XPAX+CFAX*(DEEX+.3*FWCM*(XDCL-YDCL)),
     +           YPAX+CFAY*(DEEY+.3*FWCM*(YDCL+XDCL)))
      CALL LINE (XPAX+CFAX*(DEEX-.3*FWCM*(XDCL+YDCL)),
     +           YPAX+CFAY*(DEEY-.3*FWCM*(YDCL-XDCL)),
     +           XPAX+CFAX*(DEEX+.3*FWCM*(XDCL+YDCL)),
     +           YPAX+CFAY*(DEEY+.3*FWCM*(YDCL-XDCL)))
      DEEX=DEEX+2.5*FWCM*XDCL
      DEEY=DEEY+2.5*FWCM*YDCL
  420 CALL AGCHAX (1,IAXS,4,VLCS)
C
C Draw the exponent portion of the label (if it has one).
C
      IF (NCIE.EQ.0) GO TO 421
      DEEX=DEEX-.5*FHCM*YDCL
      DEEY=DEEY+.5*FHCM*XDCL
      CALL AGCHAX (0,IAXS,5,VLCS)
      CALL AGPWRT (XPAX+CFAX*DEEX,YPAX+CFAY*DEEY,BFRE,NCIE,IWCE,NLOR,-1)
      CALL AGCHAX (1,IAXS,5,VLCS)
C
C Draw the second portion of the tick mark, if any.
C
  421 IF (LDLR) 423,424,422
C
  422 IF (MJ34.NE.0) THEN
        CALL AGCHAX (0,IAXS,2,VLCS)
        CALL LINED (XPAX+XMJT(3),YPAX+YMJT(3),XPAX+XMJT(4),YPAX+YMJT(4))
        CALL AGCHAX (1,IAXS,2,VLCS)
      END IF
      GO TO 424
C
  423 IF (MJ12.NE.0) THEN
        CALL AGCHAX (0,IAXS,2,VLCS)
        CALL LINED (XPAX+XMJT(2),YPAX+YMJT(2),XPAX+XMJT(1),YPAX+YMJT(1))
        CALL AGCHAX (1,IAXS,2,VLCS)
      END IF
C
C Exit from internal procedure.
C
  424 GO TO JMP2 , (203,301)
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C The following is an internal procedure, exited via the assigned-go-to
C variable JMP3.  Its purpose is to compute all numeric-label parameters
C required by AGAXIS.
C
C Compute the desired label orientation and its direction cosines.
C
  500 NLOR=NLOF
      IF (NLOR.LT.0) NLOR=NLOS
C
      XDCL=COS(.017453292519943*FLOAT(NLOR))
      YDCL=SIN(.017453292519943*FLOAT(NLOR))
C
C Compute JLAO, which is a computed-go-to jump parameter specifying the
C label-to-axis orientation.
C
      JLAO=1+MOD(NLOR-IAOR+3600,360)/90
C
C Compute the width of a character in the label mantissa, the width of a
C character in the label exponent, and the distance of a label from the
C axis, in the plotter coordinate system.
C
      IWCM=MAX0(MWCM,IFIX(RFNL*ABS(WCLM)*SCWP+.5))
      IWCE=MAX0(MWCE,IFIX(RFNL*ABS(WCLE)*SCWP+.5))
      IDLA=MAX0(MDLA,IFIX(RFNL*ABS(DNLA)*SCWP+.5))
C
C Compute the same quantities as fractions of the axis length.
C
      FWCM=FLOAT(IWCM)/AXLP
      FWCE=FLOAT(IWCE)/AXLP
      FDLA=FLOAT(IDLA)/AXLP
C
C Compute character heights as fractions of the axis length.
C
      FHCM=HCFW(FWCM)
      FHCE=HCFW(FWCE)
C
C Return to internal-procedure caller.
C
      GO TO JMP3 , (104,200,801)
C
C *-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
C
C This is the termination section of AGAXIS.
C
C Update the parameters WNLL and WNLR to reflect the amount of space
C used/needed for numeric labels to the left and right of the axis.
C
  800 IF (LDNL.NE.0) GO TO 801
C
C No numeric labels occur on the axis.  Zero WNLL and WNLR and jump.
C
      WNLL=0.
      WNLR=0.
      GO TO 815
C
C Numeric labels do occur on the axis.  Compute the space required.
C
  801 GO TO (802,803,802,803) , JLAO
C
C Labels are parallel to the axis.
C
  802 FNLW=FHCM
      IF (MCIE.NE.0) FNLW=FNLW+.5*FHCE
      GO TO 804
C
C Labels are perpendicular to the axis.
C
  803 FNLW=FLOAT(MCIM)*FWCM+FLOAT(MCIE)*FWCE
C
C Jump on the numeric-label-distance-from-axis parameter DNLA.
C
  804 IF (DNLA) 805,806,807
C
C Labels are to the right of the axis.
C
  805 FNLL=-FDLA
      FNLR=+FDLA+FNLW
      GO TO 808
C
C Labels are centered on the axis.
C
  806 FNLL=+.5*FNLW
      FNLR=+.5*FNLW
      GO TO 808
C
C Labels are to the left of the axis.
C
  807 FNLL=+FDLA+FNLW
      FNLR=-FDLA
C
C Adjust FNLL and FNLR as implied by the numeric-label offset.
C
  808 FNLL=FNLL-FNLO
      FNLR=FNLR+FNLO
C
C If this is not a test run, jump to reset WNLL and WNLR.
C
      IF (ITST.EQ.0) GO TO 814
C
C If this is a test run, see if the labels will fit.  Jump if so.
C
      IF (CFAP*FNLL.LE.WNLL.AND.CFAP*FNLR.LE.WNLR) GO TO 814
C
C If the labels will not fit, we have a problem.  We may or may not be
C able to do anything about it, depending on ITST.
C
      GO TO (814,809,813,809) , ITST
C
C We are allowed to shrink the labels.  See if they are minimum-size
C already.  If so, the only other possibility is to re-orient them.
C
  809 IF (IWCM.LE.MWCM.AND.IWCE.LE.MWCE.AND.IDLA.LE.MDLA) GO TO 812
C
C If not, shrink them by an amount based on the extent of the problem,
C reset the parameters affected and see if the problem is solved.
C
      IF (WNLR+WNLL.GT.0.) GO TO 810
C
      RFNL=.000001*RFNL
      GO TO 811
C
  810 RFNL=AMIN1(.9,(WNLL+WNLR)/(CFAP*(FNLL+FNLR)))*RFNL
C
  811 ASSIGN 801 TO JMP3
      GO TO 500
C
C If labels have already been shrunk to minimum size, see if we can
C re-orient them.  If not, give up.
C
  812 IF (ITST.NE.3) GO TO 814
C
C Try re-orienting the labels.  If this has already been tried, or if it
C would be pointless, give up.
C
  813 IF (NLOF.LT.0.OR.NLOS.EQ.NLOF.OR.JLAO.EQ.1.OR.JLAO.EQ.3) GO TO 814
C
C If re-orienting makes sense, reset the parameters affected and see if
C the problem is solved.
C
      NLOF=NLOF-360
      RFNL=1.
      ASSIGN 801 TO JMP3
      GO TO 500
C
C Reset WNLL and WNLR for caller.
C
  814 WNLL=FNLL*CFAP
      WNLR=FNLR*CFAP
C
C If this is a test run, we are now done.
C
  815 IF (ITST.GT.0) GO TO 816
C
C Draw the axis, if it is to be drawn.
C
      IF (LDAX.EQ.0) GO TO 816
C
      CALL DASHDB (ISLD)
      CALL AGCHAX (0,IAXS,1,0.)
      CALL LINED (XBGA,YBGA,XNDA,YNDA)
      CALL AGCHAX (1,IAXS,1,0.)
C
C Pack up integer values which might have been changed into the
C corresponding floating-point arguments.
C
  816 QLOF=FLOAT(NLOF)
      QLOS=FLOAT(NLOS)
      QCIM=FLOAT(MCIM)
      QCIE=FLOAT(MCIE)
C
C Done.
C
      RETURN
C
      END

      subroutine banfac ( w, nroww, nrow, nbandl, nbandu, iflag )
c  from  * a practical guide to splines *  by c. de boor
c  returns in  w  the lu-factorization (without pivoting) of the banded
c  matrix  a  of order	nrow  with  (nbandl + 1 + nbandu) bands or diag-
c  onals in the work array  w .
c
c******  i n p u t  ******
c  w.....work array of size  (nroww,nrow)  containing the interesting
c	 part of a banded matrix  a , with the diagonals or bands of  a
c	 stored in the rows of	w , while columns of  a  correspond to
c	 columns of  w . this is the storage mode used in  linpack  and
c	 results in efficient innermost loops.
c	    explicitly,  a  has  nbandl  bands below the diagonal
c			     +	   1	 (main) diagonal
c			     +	 nbandu  bands above the diagonal
c	 and thus, with    middle = nbandu + 1,
c	   a(i+j,j)  is in  w(i+middle,j)  for i=-nbandu,...,nbandl
c					       j=1,...,nrow .
c	 for example, the interesting entries of a (1,2)-banded matrix
c	 of order  9  would appear in the first  1+1+2 = 4  rows of  w
c	 as follows.
c			   13 24 35 46 57 68 79
c			12 23 34 45 56 67 78 89
c		     11 22 33 44 55 66 77 88 99
c		     21 32 43 54 65 76 87 98
c
c	 all other entries of  w  not identified in this way with an en-
c	 try of  a  are never referenced .
c  nroww.....row dimension of the work array  w .
c	 must be  .ge.	nbandl + 1 + nbandu  .
c  nbandl.....number of bands of  a  below the main diagonal
c  nbandu.....number of bands of  a  above the main diagonal .
c
c******  o u t p u t  ******
c  iflag.....integer indicating success( = 1) or failure ( = 2) .
c     if  iflag = 1, then
c  w.....contains the lu-factorization of  a  into a unit lower triangu-
c	 lar matrix  l	and an upper triangular matrix	u (both banded)
c	 and stored in customary fashion over the corresponding entries
c	 of  a . this makes it possible to solve any particular linear
c	 system  a*x = b  for  x  by a
c	       call banslv ( w, nroww, nrow, nbandl, nbandu, b )
c	 with the solution x  contained in  b  on return .
c     if  iflag = 2, then
c	 one of  nrow-1, nbandl,nbandu failed to be nonnegative, or else
c	 one of the potential pivots was found to be zero indicating
c	 that  a  does not have an lu-factorization. this implies that
c	 a  is singular in case it is totally positive .
c
c******  m e t h o d  ******
c     gauss elimination  w i t h o u t	pivoting is used. the routine is
c  intended for use with matrices  a  which do not require row inter-
c  changes during factorization, especially for the  t o t a l l y
c  p o s i t i v e  matrices which occur in spline calculations.
c     the routine should not be used for an arbitrary banded matrix.
c
      integer iflag,nbandl,nbandu,nrow,nroww,	i,ipk,j,jmax,k,kmax
     *					      ,middle,midmk,nrowm1
      real w(nroww,nrow),   factor,pivot
c
      iflag = 1
      middle = nbandu + 1
c			  w(middle,.) contains the main diagonal of  a .
      nrowm1 = nrow - 1
      if (nrowm1)			999,900,1
    1 if (nbandl .gt. 0)		go to 10
c		 a is upper triangular. check that diagonal is nonzero .
      do 5 i=1,nrowm1
	 if (w(middle,i) .eq. 0.)	go to 999
    5	 continue
					go to 900
   10 if (nbandu .gt. 0)		go to 20
c	       a is lower triangular. check that diagonal is nonzero and
c		  divide each column by its diagonal .
      do 15 i=1,nrowm1
	 pivot = w(middle,i)
	 if(pivot .eq. 0.)		go to 999
	 jmax = min0(nbandl, nrow - i)
	 do 15 j=1,jmax
   15	    w(middle+j,i) = w(middle+j,i)/pivot
					return
c
c	 a  is not just a triangular matrix. construct lu factorization
   20 do 50 i=1,nrowm1
c				   w(middle,i)	is pivot for i-th step .
	 pivot = w(middle,i)
	 if (pivot .eq. 0.)		go to 999
c		  jmax	is the number of (nonzero) entries in column  i
c		      below the diagonal .
	 jmax = min0(nbandl,nrow - i)
c	       divide each entry in column  i  below diagonal by pivot .
	 do 32 j=1,jmax
   32	    w(middle+j,i) = w(middle+j,i)/pivot
c		  kmax	is the number of (nonzero) entries in row  i  to
c		      the right of the diagonal .
	 kmax = min0(nbandu,nrow - i)
c		   subtract  a(i,i+k)*(i-th column) from (i+k)-th column
c		   (below row  i ) .
	 do 40 k=1,kmax
	    ipk = i + k
	    midmk = middle - k
	    factor = w(midmk,ipk)
	    do 40 j=1,jmax
   40	       w(midmk+j,ipk) = w(midmk+j,ipk) - w(middle+j,i)*factor
   50	 continue
c					check the last diagonal entry .
  900 if (w(middle,nrow) .ne. 0.)	return
  999 iflag = 2
					return
      end

C--------------------------------------------------------------------------
        subroutine ftmodr(ounit,record,status)

C       modify the preceeding 80 character record in the FITS header
C
C       ounit   i  fortran output unit number
C       record  c  input 80 character header record
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) record
        character*80  rec
        integer ounit,status,ibuff

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------- -----------------------------

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

        rec=record

C       make sure keyword name is in upper case
        call ftupch(rec(1:8))

C       test that keyword name contains only legal characters
        call fttkey(rec(1:8),status)

C       move the I/O pointer back to the beginning of the preceeding keyword
        call ftmbyt(ounit,nxthdr(ibuff)-80,.false.,status)

C       overwrite the 80 characters to the output buffer:
        call ftpcbf(ounit,1,80,rec,status)
        end

      SUBROUTINE slERTH (IY, ID, FD, PV)
*+
*     - - - - - -
*      E R T H
*     - - - - - -
*
*  Approximate heliocentric position and velocity of the Earth
*
*  Given:
*     IY       I       year
*     ID       I       day in year (1 = Jan 1st)
*     FD       R       fraction of day
*
*  Returned:
*     PV       R(6)    Earth position & velocity vector
*
*  Notes:
*
*  1  The date and time is TDB (loosely ET) in a Julian calendar
*     which has been aligned to the ordinary Gregorian
*     calendar for the interval 1900 March 1 to 2100 February 28.
*     The year and day can be obtained by calling slCAYD or
*     slCLYD.
*
*  2  The Earth heliocentric 6-vector is mean equator and equinox
*     of date.  Position part, PV(1-3), is in AU;  velocity part,
*     PV(4-6), is in AU/sec.
*
*  3  Max/RMS errors 1950-2050:
*       13/5 E-5 AU = 19200/7600 km in position
*       47/26 E-10 AU/s = 0.0070/0.0039 km/s in speed
*
*  4  More accurate results are obtainable with the routines slEVP
*     and slEPV.
*
*  Last revision:   5 April 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IY,ID
      REAL FD,PV(6)

      INTEGER IY4
      REAL TWOPI,SPEED,REMB,SEMB,YI,YF,T,ELM,GAMMA,EM,ELT,EPS0,
     :     E,ESQ,V,R,ELMM,COSELT,SINEPS,COSEPS,W1,W2,SELMM,CELMM

      PARAMETER (TWOPI=6.28318530718)

*  Mean orbital speed of Earth, AU/s
      PARAMETER (SPEED=1.9913E-7)

*  Mean Earth:EMB distance and speed, AU and AU/s
      PARAMETER (REMB=3.12E-5,SEMB=8.31E-11)



*  Whole years & fraction of year, and years since J1900.0
      YI=FLOAT(IY-1900)
      IY4=MOD(MOD(IY,4)+4,4)
      YF=(FLOAT(4*(ID-1/(IY4+1))-IY4-2)+4.0*FD)/1461.0
      T=YI+YF

*  Geometric mean longitude of Sun
*  (cf 4.881627938+6.283319509911*T MOD 2PI)
      ELM=MOD(4.881628+TWOPI*YF+0.00013420*T,TWOPI)

*  Mean longitude of perihelion
      GAMMA=4.908230+3.0005E-4*T

*  Mean anomaly
      EM=ELM-GAMMA

*  Mean obliquity
      EPS0=0.40931975-2.27E-6*T

*  Eccentricity
      E=0.016751-4.2E-7*T
      ESQ=E*E

*  True anomaly
      V=EM+2.0*E*SIN(EM)+1.25*ESQ*SIN(2.0*EM)

*  True ecliptic longitude
      ELT=V+GAMMA

*  True distance
      R=(1.0-ESQ)/(1.0+E*COS(V))

*  Moon's mean longitude
      ELMM=MOD(4.72+83.9971*T,TWOPI)

*  Useful functions
      COSELT=COS(ELT)
      SINEPS=SIN(EPS0)
      COSEPS=COS(EPS0)
      W1=-R*SIN(ELT)
      W2=-SPEED*(COSELT+E*COS(GAMMA))
      SELMM=SIN(ELMM)
      CELMM=COS(ELMM)

*  Earth position and velocity
      PV(1)=-R*COSELT-REMB*CELMM
      PV(2)=(W1-REMB*SELMM)*COSEPS
      PV(3)=W1*SINEPS
      PV(4)=SPEED*(SIN(ELT)+E*SIN(GAMMA))+SEMB*SELMM
      PV(5)=(W2-SEMB*CELMM)*COSEPS
      PV(6)=W2*SINEPS

      END

      SUBROUTINE slFK5H (R5,D5,DR5,DD5,RH,DH,DRH,DDH)
*+
*     - - - - - -
*      F K 5 H
*     - - - - - -
*
*  Transform FK5 (J2000) star data into the Hipparcos frame.
*
*  (double precision)
*
*  This routine transforms FK5 star positions and proper motions
*  into the frame of the Hipparcos catalogue.
*
*  Given (all FK5, equinox J2000, epoch J2000):
*     R5        d      RA (radians)
*     D5        d      Dec (radians)
*     DR5       d      proper motion in RA (dRA/dt, rad/Jyear)
*     DD5       d      proper motion in Dec (dDec/dt, rad/Jyear)
*
*  Returned (all Hipparcos, epoch J2000):
*     RH        d      RA (radians)
*     DH        d      Dec (radians)
*     DRH       d      proper motion in RA (dRA/dt, rad/Jyear)
*     DDH       d      proper motion in Dec (dDec/dt, rad/Jyear)
*
*  Called:  slDSC6, slDAVM, slDMXV, slDVXV, slDC6S,
*           slDA2P
*
*  Notes:
*
*  1)  The proper motions in RA are dRA/dt rather than
*      cos(Dec)*dRA/dt, and are per year rather than per century.
*
*  2)  The FK5 to Hipparcos transformation consists of a pure
*      rotation and spin;  zonal errors in the FK5 catalogue are
*      not taken into account.
*
*  3)  The published orientation and spin components are interpreted
*      as "axial vectors".  An axial vector points at the pole of the
*      rotation and its length is the amount of rotation in radians.
*
*  4)  See also slHFK5, slF5HZ, slHF5Z.
*
*  Reference:
*
*     M.Feissel & F.Mignard, Astron. Astrophys. 331, L33-L36 (1998).
*
*  P.T.Wallace   Starlink   22 June 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R5,D5,DR5,DD5,RH,DH,DRH,DDH

      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

*  FK5 to Hipparcos orientation and spin (radians, radians/year)
      DOUBLE PRECISION EPX,EPY,EPZ
      DOUBLE PRECISION OMX,OMY,OMZ

      PARAMETER ( EPX = -19.9D-3 * AS2R,
     :            EPY =  -9.1D-3 * AS2R,
     :            EPZ = +22.9D-3 * AS2R )

      PARAMETER ( OMX = -0.30D-3 * AS2R,
     :            OMY = +0.60D-3 * AS2R,
     :            OMZ = +0.70D-3 * AS2R )

      DOUBLE PRECISION PV5(6),ORTN(3),R5H(3,3),S5(3),VV(3),PVH(6),W,R,V
      INTEGER I

      DOUBLE PRECISION slDA2P



*  FK5 barycentric position/velocity 6-vector (normalized).
      CALL slDSC6(R5,D5,1D0,DR5,DD5,0D0,PV5)

*  FK5 to Hipparcos orientation matrix.
      ORTN(1) = EPX
      ORTN(2) = EPY
      ORTN(3) = EPZ
      CALL slDAVM(ORTN,R5H)

*  Hipparcos wrt FK5 spin vector.
      S5(1) = OMX
      S5(2) = OMY
      S5(3) = OMZ

*  Orient & spin the 6-vector into the Hipparcos frame.
      CALL slDMXV(R5H,PV5,PVH)
      CALL slDVXV(PV5,S5,VV)
      DO I=1,3
         VV(I) = PV5(I+3)+VV(I)
      END DO
      CALL slDMXV(R5H,VV,PVH(4))

*  Hipparcos 6-vector to spherical.
      CALL slDC6S(PVH,W,DH,R,DRH,DDH,V)
      RH = slDA2P(W)

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGFTOL (IAXS,IDMA,VINP,VOTP,VLCS,LLUA,UBEG,UDIF,FUNS,
     +                                                        NBTP,SBSE)
C
C The routine AGFTOL is used by AGAXIS to map a fractional distance
C along the axis to a value in the label coordinate system or vice-
C versa.  Its arguments are as follows:
C
C -- IAXS specifies which axis is being drawn.  It is passed to the
C    routine AGUTOL.  See AGAXIS for a complete description of IAXS.
C
C -- IDMA specifies the direction of the mapping - from the fractional
C    system to the label system if IDMA .GT. 0 or from the label system
C    to the fractional system if IDMA .LT. 0.  IDMA also specifies how
C    the label-system value is given to or returned by AGFTOL.
C
C     -- If ABSV(IDMA) .EQ. 1, an actual value in the label coordinate
C        system (VLCS) is given to or returned by AGFTOL.
C
C     -- If ABSV(IDMA) .NE. 1, a value of the exponent/multiplier EXMU
C        corresponding to VLCS is given to or returned by AGFTOL.
C
C -- VINP is an input value in one coordinate system.
C
C -- VOTP is an output value in the other coordinate system.
C
C -- VLCS is an output value in the label coordinate system, returned
C    no matter what the value of IDMA.
C
C -- LLUA, UBGA, and UDFA specify the mapping from the user coordinate
C    system to the fractional system and vice-versa.  See the routine
C    AGAXIS for a complete description of these parameters.
C
C -- FUNS is a function-selector, to be used in calls to AGUTOL.  It
C    selects the mapping from the user coordinate system to the label
C    coordinate system and vice-versa.  See the routine AGAXIS for a
C    complete description of this parameter.
C
C -- NBTP and SBSE specify the mapping of label-coordinate-system values
C    to exponent/multiplier values and vice-versa.  See the routine
C    AGNUMB for a complete dexcription of these parameters.
C
C Determine desired direction of mapping.
C
      IF (IDMA.GT.0) THEN
C
C Map axis fraction VINP to a label-coordinate-system value VLCS.
C
        VUCS=UBEG+VINP*UDIF
        IF (LLUA.NE.0) VUCS=10.**VUCS
        CALL AGUTOL (IAXS,FUNS,1,VUCS,VLCS)
C
C If IDMA .EQ. 1, caller wants VLCS - otherwise, map VLCS to the
C appropriate exponent/multiplier value EXMU - return value in VOTP.
C
        IF (IDMA.EQ.1) THEN
          VOTP=VLCS
          RETURN
        END IF
C
        GO TO (101,102,103) , NBTP
C
  101   VOTP=VLCS/SBSE
        RETURN
C
  102   VOTP=ALOG10(VLCS/SBSE)
        RETURN
C
  103   VOTP=ALOG10(ABS(VLCS))/ALOG10(ABS(SBSE))
        RETURN
C
      ELSE
C
C If IDMA .EQ. -1, caller has provided VINP .EQ. VLCS, a value in the
C label coordinate system - otherwise, VINP .EQ. EXMU, the exponent/
C multiplier needed to generate VLCS.
C
        IF (IDMA.EQ.(-1)) THEN
          VLCS=VINP
          GO TO 107
        END IF
C
        GO TO (104,105,106) , NBTP
C
  104   VLCS=SBSE*VINP
        GO TO 107
C
  105   VLCS=SBSE*10.**VINP
        GO TO 107
C
  106   VLCS=SIGN(1.,SBSE)*ABS(SBSE)**VINP
C
C Map label-system value VLCS to a user-system value VUCS.
C
  107   CALL AGUTOL (IAXS,FUNS,-1,VLCS,VUCS)
C
C Map user-system value VUCS to an axis fraction VOTP and return.
C
        IF (LLUA.NE.0) VUCS=ALOG10(VUCS)
        VOTP=(VUCS-UBEG)/UDIF
        RETURN
C
      END IF
C
      END

C--------------------------------------------------------------------------
        subroutine ftddef(ounit,bytlen,status)

C       Data DEFinition
C       re-define the length of the data unit
C       this simply redefines the start of the next HDU
C
C       ounit   i  Fortran I/O unit number
C       bytlen  i  new length of the data unit, in bytes
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,bytlen,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne,nf
        parameter (nf = 3000)
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

        if (dtstrt(ibuff) .lt. 0)then
C               freeze the header at its current size
                call fthdef(ounit,0,status)
        end if

        hdstrt(ibuff,chdu(ibuff)+1)=
     &          dtstrt(ibuff)+(bytlen+2879)/2880*2880

C       initialize the fictitious heap starting address (immediately following
C       the array data) and a zero length heap.  This is used to find the
C       end of the data when checking the fill values in the last block. 
        scount(ibuff)=0
        theap(ibuff)=bytlen
        nxheap(ibuff)=0
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSETI (TPID,IUSR)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGSETI may be used to set the integer-equivalent value of
C any single AUTOGRAPH control parameter.
C
      FURA(1)=FLOAT(IUSR)
      CALL AGSETP (TPID,FURA,1)
      RETURN
C
      END

      SUBROUTINE slPRTE (DATE, U, JSTAT)
*+
*     - - - - - - -
*      P R T E
*     - - - - - - -
*
*  Update the universal elements of an asteroid or comet by applying
*  planetary perturbations.
*
*  Given:
*     DATE     d       final epoch (TT MJD) for the updated elements
*
*  Given and returned:
*     U        d(13)   universal elements (updated in place)
*
*                (1)   combined mass (M+m)
*                (2)   total energy of the orbit (alpha)
*                (3)   reference (osculating) epoch (t0)
*              (4-6)   position at reference epoch (r0)
*              (7-9)   velocity at reference epoch (v0)
*               (10)   heliocentric distance at reference epoch
*               (11)   r0.v0
*               (12)   date (t)
*               (13)   universal eccentric anomaly (psi) of date, approx
*
*  Returned:
*     JSTAT    i       status:
*                          +102 = warning, distant epoch
*                          +101 = warning, large timespan ( > 100 years)
*                     +1 to +10 = coincident with major planet (Note 5)
*                             0 = OK
*                            -1 = numerical error
*
*  Called:  slEPJ, slPLNT, slPVUE, slUEPV, slEPV,
*           slPREC, slDMON, slDMXV
*
*  Notes:
*
*  1  The "universal" elements are those which define the orbit for the
*     purposes of the method of universal variables (see reference 2).
*     They consist of the combined mass of the two bodies, an epoch,
*     and the position and velocity vectors (arbitrary reference frame)
*     at that epoch.  The parameter set used here includes also various
*     quantities that can, in fact, be derived from the other
*     information.  This approach is taken to avoiding unnecessary
*     computation and loss of accuracy.  The supplementary quantities
*     are (i) alpha, which is proportional to the total energy of the
*     orbit, (ii) the heliocentric distance at epoch, (iii) the
*     outwards component of the velocity at the given epoch, (iv) an
*     estimate of psi, the "universal eccentric anomaly" at a given
*     date and (v) that date.
*
*  2  The universal elements are with respect to the J2000 equator and
*     equinox.
*
*  3  The epochs DATE, U(3) and U(12) are all Modified Julian Dates
*     (JD-2400000.5).
*
*  4  The algorithm is a simplified form of Encke's method.  It takes as
*     a basis the unperturbed motion of the body, and numerically
*     integrates the perturbing accelerations from the major planets.
*     The expression used is essentially Sterne's 6.7-2 (reference 1).
*     Everhart and Pitkin (reference 2) suggest rectifying the orbit at
*     each integration step by propagating the new perturbed position
*     and velocity as the new universal variables.  In the present
*     routine the orbit is rectified less frequently than this, in order
*     to gain a slight speed advantage.  However, the rectification is
*     done directly in terms of position and velocity, as suggested by
*     Everhart and Pitkin, bypassing the use of conventional orbital
*     elements.
*
*     The f(q) part of the full Encke method is not used.  The purpose
*     of this part is to avoid subtracting two nearly equal quantities
*     when calculating the "indirect member", which takes account of the
*     small change in the Sun's attraction due to the slightly displaced
*     position of the perturbed body.  A simpler, direct calculation in
*     double precision proves to be faster and not significantly less
*     accurate.
*
*     Apart from employing a variable timestep, and occasionally
*     "rectifying the orbit" to keep the indirect member small, the
*     integration is done in a fairly straightforward way.  The
*     acceleration estimated for the middle of the timestep is assumed
*     to apply throughout that timestep;  it is also used in the
*     extrapolation of the perturbations to the middle of the next
*     timestep, to predict the new disturbed position.  There is no
*     iteration within a timestep.
*
*     Measures are taken to reach a compromise between execution time
*     and accuracy.  The starting-point is the goal of achieving
*     arcsecond accuracy for ordinary minor planets over a ten-year
*     timespan.  This goal dictates how large the timesteps can be,
*     which in turn dictates how frequently the unperturbed motion has
*     to be recalculated from the osculating elements.
*
*     Within predetermined limits, the timestep for the numerical
*     integration is varied in length in inverse proportion to the
*     magnitude of the net acceleration on the body from the major
*     planets.
*
*     The numerical integration requires estimates of the major-planet
*     motions.  Approximate positions for the major planets (Pluto
*     alone is omitted) are obtained from the routine slPLNT.  Two
*     levels of interpolation are used, to enhance speed without
*     significantly degrading accuracy.  At a low frequency, the routine
*     slPLNT is called to generate updated position+velocity "state
*     vectors".  The only task remaining to be carried out at the full
*     frequency (i.e. at each integration step) is to use the state
*     vectors to extrapolate the planetary positions.  In place of a
*     strictly linear extrapolation, some allowance is made for the
*     curvature of the orbit by scaling back the radius vector as the
*     linear extrapolation goes off at a tangent.
*
*     Various other approximations are made.  For example, perturbations
*     by Pluto and the minor planets are neglected and relativistic
*     effects are not taken into account.
*
*     In the interests of simplicity, the background calculations for
*     the major planets are carried out en masse.  The mean elements and
*     state vectors for all the planets are refreshed at the same time,
*     without regard for orbit curvature, mass or proximity.
*
*     The Earth-Moon system is treated as a single body when the body is
*     distant but as separate bodies when closer to the EMB than the
*     parameter RNE, which incurs a time penalty but improves accuracy
*     for near-Earth objects.
*
*  5  This routine is not intended to be used for major planets.
*     However, if major-planet elements are supplied, sensible results
*     will, in fact, be produced.  This happens because the routine
*     checks the separation between the body and each of the planets and
*     interprets a suspiciously small value (0.001 AU) as an attempt to
*     apply the routine to the planet concerned.  If this condition is
*     detected, the contribution from that planet is ignored, and the
*     status is set to the planet number (1-10 = Mercury, Venus, EMB,
*     Mars, Jupiter, Saturn, Uranus, Neptune, Earth, Moon) as a warning.
*
*  References:
*
*     1  Sterne, Theodore E., "An Introduction to Celestial Mechanics",
*        Interscience Publishers Inc., 1960.  Section 6.7, p199.
*
*     2  Everhart, E. & Pitkin, E.T., Am.J.Phys. 51, 712, 1983.
*
*  Last revision:   27 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE
      DOUBLE PRECISION DATE,U(13)
      INTEGER JSTAT

*  Distance from EMB at which Earth and Moon are treated separately
      DOUBLE PRECISION RNE
      PARAMETER (RNE=1D0)

*  Coincidence with major planet distance
      DOUBLE PRECISION COINC
      PARAMETER (COINC=0.0001D0)

*  Coefficient relating timestep to perturbing force
      DOUBLE PRECISION TSC
      PARAMETER (TSC=1D-4)

*  Minimum and maximum timestep (days)
      DOUBLE PRECISION TSMIN,TSMAX
      PARAMETER (TSMIN=0.01D0,TSMAX=10D0)

*  Age limit for major-planet state vector (days)
      DOUBLE PRECISION AGEPMO
      PARAMETER (AGEPMO=5D0)

*  Age limit for major-planet mean elements (days)
      DOUBLE PRECISION AGEPEL
      PARAMETER (AGEPEL=50D0)

*  Margin for error when deciding whether to renew the planetary data
      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-6)

*  Age limit for the body's osculating elements (before rectification)
      DOUBLE PRECISION AGEBEL
      PARAMETER (AGEBEL=100D0)

*  Gaussian gravitational constant (exact) and square
      DOUBLE PRECISION GCON,GCON2
      PARAMETER (GCON=0.01720209895D0,GCON2=GCON*GCON)

*  The final epoch
      DOUBLE PRECISION TFINAL

*  The body's current universal elements
      DOUBLE PRECISION UL(13)

*  Current reference epoch
      DOUBLE PRECISION T0

*  Timespan from latest orbit rectification to final epoch (days)
      DOUBLE PRECISION TSPAN

*  Time left to go before integration is complete
      DOUBLE PRECISION TLEFT

*  Time direction flag: +1=forwards, -1=backwards
      DOUBLE PRECISION FB

*  First-time flag
      LOGICAL FIRST

*
*  The current perturbations
*
*  Epoch (days relative to current reference epoch)
      DOUBLE PRECISION RTN
*  Position (AU)
      DOUBLE PRECISION PERP(3)
*  Velocity (AU/d)
      DOUBLE PRECISION PERV(3)
*  Acceleration (AU/d/d)
      DOUBLE PRECISION PERA(3)
*

*  Length of current timestep (days), and half that
      DOUBLE PRECISION TS,HTS

*  Epoch of middle of timestep
      DOUBLE PRECISION T

*  Epoch of planetary mean elements
      DOUBLE PRECISION TPEL

*  Planet number (1=Mercury, 2=Venus, 3=EMB...8=Neptune)
      INTEGER NP

*  Planetary universal orbital elements
      DOUBLE PRECISION UP(13,8)

*  Epoch of planetary state vectors
      DOUBLE PRECISION TPMO

*  State vectors for the major planets (AU,AU/s)
      DOUBLE PRECISION PVIN(6,8)

*  Earth velocity and position vectors (AU,AU/s)
      DOUBLE PRECISION VB(3),PB(3),VH(3),PE(3)

*  Moon geocentric state vector (AU,AU/s) and position part
      DOUBLE PRECISION PVM(6),PM(3)

*  Date to J2000 de-precession matrix
      DOUBLE PRECISION PMAT(3,3)

*
*  Correction terms for extrapolated major planet vectors
*
*  Sun-to-planet distances squared multiplied by 3
      DOUBLE PRECISION R2X3(8)
*  Sunward acceleration terms, G/2R^3
      DOUBLE PRECISION GC(8)
*  Tangential-to-circular correction factor
      DOUBLE PRECISION FC
*  Radial correction factor due to Sunwards acceleration
      DOUBLE PRECISION FG
*

*  The body's unperturbed and perturbed state vectors (AU,AU/s)
      DOUBLE PRECISION PV0(6),PV(6)

*  The body's perturbed and unperturbed heliocentric distances (AU) cubed
      DOUBLE PRECISION R03,R3

*  The perturbating accelerations, indirect and direct
      DOUBLE PRECISION FI(3),FD(3)

*  Sun-to-planet vector, and distance cubed
      DOUBLE PRECISION RHO(3),RHO3

*  Body-to-planet vector, and distance cubed
      DOUBLE PRECISION DELTA(3),DELTA3

*  Miscellaneous
      INTEGER I,J
      DOUBLE PRECISION R2,W,DT,DT2,R,FT
      LOGICAL NE

      DOUBLE PRECISION slEPJ

*  Planetary inverse masses, Mercury through Neptune then Earth and Moon
      DOUBLE PRECISION AMAS(10)
      DATA AMAS / 6023600D0, 408523.5D0, 328900.5D0, 3098710D0,
     :            1047.355D0, 3498.5D0, 22869D0, 19314D0,
     :            332946.038D0, 27068709D0 /

*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 59 Temple Place, Suite 330,
*    Boston, MA  02111-1307  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*----------------------------------------------------------------------*


*  Preset the status to OK.
      JSTAT = 0

*  Copy the final epoch.
      TFINAL = DATE

*  Copy the elements (which will be periodically updated).
      DO I=1,13
         UL(I) = U(I)
      END DO

*  Initialize the working reference epoch.
      T0=UL(3)

*  Total timespan (days) and hence time left.
      TSPAN = TFINAL-T0
      TLEFT = TSPAN

*  Warn if excessive.
      IF (ABS(TSPAN).GT.36525D0) JSTAT=101

*  Time direction: +1 for forwards, -1 for backwards.
      FB = SIGN(1D0,TSPAN)

*  Initialize relative epoch for start of current timestep.
      RTN = 0D0

*  Reset the perturbations (position, velocity, acceleration).
      DO I=1,3
         PERP(I) = 0D0
         PERV(I) = 0D0
         PERA(I) = 0D0
      END DO

*  Set "first iteration" flag.
      FIRST = .TRUE.

*  Step through the time left.
      DO WHILE (FB*TLEFT.GT.0D0)

*     Magnitude of current acceleration due to planetary attractions.
         IF (FIRST) THEN
            TS = TSMIN
         ELSE
            R2 = 0D0
            DO I=1,3
               W = FD(I)
               R2 = R2+W*W
            END DO
            W = SQRT(R2)

*        Use the acceleration to decide how big a timestep can be tolerated.
            IF (W.NE.0D0) THEN
               TS = MIN(TSMAX,MAX(TSMIN,TSC/W))
            ELSE
               TS = TSMAX
            END IF
         END IF
         TS = TS*FB

*     Override if final epoch is imminent.
         TLEFT = TSPAN-RTN
         IF (ABS(TS).GT.ABS(TLEFT)) TS=TLEFT

*     Epoch of middle of timestep.
         HTS = TS/2D0
         T = T0+RTN+HTS

*     Is it time to recompute the major-planet elements?
         IF (FIRST.OR.ABS(T-TPEL)-AGEPEL.GE.TINY) THEN

*        Yes: go forward in time by just under the maximum allowed.
            TPEL = T+FB*AGEPEL

*        Compute the state vector for the new epoch.
            DO NP=1,8
               CALL slPLNT(TPEL,NP,PV,J)

*           Warning if remote epoch, abort if error.
               IF (J.EQ.1) THEN
                  JSTAT = 102
               ELSE IF (J.NE.0) THEN
                  GO TO 9010
               END IF

*           Transform the vector into universal elements.
               CALL slPVUE(PV,TPEL,0D0,UP(1,NP),J)
               IF (J.NE.0) GO TO 9010
            END DO
         END IF

*     Is it time to recompute the major-planet motions?
         IF (FIRST.OR.ABS(T-TPMO)-AGEPMO.GE.TINY) THEN

*        Yes: look ahead.
            TPMO = T+FB*AGEPMO

*        Compute the motions of each planet (AU,AU/d).
            DO NP=1,8

*           The planet's position and velocity (AU,AU/s).
               CALL slUEPV(TPMO,UP(1,NP),PVIN(1,NP),J)
               IF (J.NE.0) GO TO 9010

*           Scale velocity to AU/d.
               DO J=4,6
                  PVIN(J,NP) = PVIN(J,NP)*86400D0
               END DO

*           Precompute also the extrapolation correction terms.
               R2 = 0D0
               DO I=1,3
                  W = PVIN(I,NP)
                  R2 = R2+W*W
               END DO
               R2X3(NP) = R2*3D0
               GC(NP) = GCON2/(2D0*R2*SQRT(R2))
            END DO
         END IF

*     Reset the first-time flag.
         FIRST = .FALSE.

*     Unperturbed motion of the body at middle of timestep (AU,AU/s).
         CALL slUEPV(T,UL,PV0,J)
         IF (J.NE.0) GO TO 9010

*     Perturbed position of the body (AU) and heliocentric distance cubed.
         R2 = 0D0
         DO I=1,3
            W = PV0(I)+PERP(I)+(PERV(I)+PERA(I)*HTS/2D0)*HTS
            PV(I) = W
            R2 = R2+W*W
         END DO
         R3 = R2*SQRT(R2)

*     The body's unperturbed heliocentric distance cubed.
         R2 = 0D0
         DO I=1,3
            W = PV0(I)
            R2 = R2+W*W
         END DO
         R03 = R2*SQRT(R2)

*     Compute indirect and initialize direct parts of the perturbation.
         DO I=1,3
            FI(I) = PV0(I)/R03-PV(I)/R3
            FD(I) = 0D0
         END DO

*     Ready to compute the direct planetary effects.

*     Reset the "near-Earth" flag.
         NE = .FALSE.

*     Interval from state-vector epoch to middle of current timestep.
         DT = T-TPMO
         DT2 = DT*DT

*     Planet by planet, including separate Earth and Moon.
         DO NP=1,10

*        Which perturbing body?
            IF (NP.LE.8) THEN

*           Planet: compute the extrapolation in longitude (squared).
               R2 = 0D0
               DO J=4,6
                  W = PVIN(J,NP)*DT
                  R2 = R2+W*W
               END DO

*           Hence the tangential-to-circular correction factor.
               FC = 1D0+R2/R2X3(NP)

*           The radial correction factor due to the inwards acceleration.
               FG = 1D0-GC(NP)*DT2

*           Planet's position.
               DO I=1,3
                  RHO(I) = FG*(PVIN(I,NP)+FC*PVIN(I+3,NP)*DT)
               END DO

            ELSE IF (NE) THEN

*           Near-Earth and either Earth or Moon.

               IF (NP.EQ.9) THEN

*              Earth: position.
                  CALL slEPV(T,PE,VH,PB,VB)
                  DO I=1,3
                     RHO(I) = PE(I)
                  END DO

               ELSE

*              Moon: position.
                  CALL slPREC(slEPJ(T),2000D0,PMAT)
                  CALL slDMON(T,PVM)
                  CALL slDMXV(PMAT,PVM,PM)
                  DO I=1,3
                     RHO(I) = PM(I)+PE(I)
                  END DO
               END IF
            END IF

*        Proceed unless Earth or Moon and not the near-Earth case.
            IF (NP.LE.8.OR.NE) THEN

*           Heliocentric distance cubed.
               R2 = 0D0
               DO I=1,3
                  W = RHO(I)
                  R2 = R2+W*W
               END DO
               R = SQRT(R2)
               RHO3 = R2*R

*           Body-to-planet vector, and distance.
               R2 = 0D0
               DO I=1,3
                  W = RHO(I)-PV(I)
                  DELTA(I) = W
                  R2 = R2+W*W
               END DO
               R = SQRT(R2)

*           If this is the EMB, set the near-Earth flag appropriately.
               IF (NP.EQ.3.AND.R.LT.RNE) NE = .TRUE.

*           Proceed unless EMB and this is the near-Earth case.
               IF (.NOT.(NE.AND.NP.EQ.3)) THEN

*              If too close, ignore this planet and set a warning.
                  IF (R.LT.COINC) THEN
                     JSTAT = NP

                  ELSE

*                 Accumulate "direct" part of perturbation acceleration.
                     DELTA3 = R2*R
                     W = AMAS(NP)
                     DO I=1,3
                        FD(I) = FD(I)+(DELTA(I)/DELTA3-RHO(I)/RHO3)/W
                     END DO
                  END IF
               END IF
            END IF
         END DO

*     Update the perturbations to the end of the timestep.
         RTN = RTN+TS
         DO I=1,3
            W = (FI(I)+FD(I))*GCON2
            FT = W*TS
            PERP(I) = PERP(I)+(PERV(I)+FT/2D0)*TS
            PERV(I) = PERV(I)+FT
            PERA(I) = W
         END DO

*     Time still to go.
         TLEFT = TSPAN-RTN

*     Is it either time to rectify the orbit or the last time through?
         IF (ABS(RTN).GE.AGEBEL.OR.FB*TLEFT.LE.0D0) THEN

*        Yes: update to the end of the current timestep.
            T0 = T0+RTN
            RTN = 0D0

*        The body's unperturbed motion (AU,AU/s).
            CALL slUEPV(T0,UL,PV0,J)
            IF (J.NE.0) GO TO 9010

*        Add and re-initialize the perturbations.
            DO I=1,3
               J = I+3
               PV(I) = PV0(I)+PERP(I)
               PV(J) = PV0(J)+PERV(I)/86400D0
               PERP(I) = 0D0
               PERV(I) = 0D0
               PERA(I) = FD(I)*GCON2
            END DO

*        Use the position and velocity to set up new universal elements.
            CALL slPVUE(PV,T0,0D0,UL,J)
            IF (J.NE.0) GO TO 9010

*        Adjust the timespan and time left.
            TSPAN = TFINAL-T0
            TLEFT = TSPAN
         END IF

*     Next timestep.
      END DO

*  Return the updated universal-element set.
      DO I=1,13
         U(I) = UL(I)
      END DO

*  Finished.
      GO TO 9999

*  Miscellaneous numerical error.
 9010 CONTINUE
      JSTAT = -1

 9999 CONTINUE
      END

      SUBROUTINE slF45Z (R1950,D1950,BEPOCH,R2000,D2000)
*+
*     - - - - - -
*      F 4 5 Z
*     - - - - - -
*
*  Convert B1950.0 FK4 star data to J2000.0 FK5 assuming zero
*  proper motion in the FK5 frame (double precision)
*
*  This routine converts stars from the old, Bessel-Newcomb, FK4
*  system to the new, IAU 1976, FK5, Fricke system, in such a
*  way that the FK5 proper motion is zero.  Because such a star
*  has, in general, a non-zero proper motion in the FK4 system,
*  the routine requires the epoch at which the position in the
*  FK4 system was determined.
*
*  The method is from Appendix 2 of Ref 1, but using the constants
*  of Ref 4.
*
*  Given:
*     R1950,D1950     dp    B1950.0 FK4 RA,Dec at epoch (rad)
*     BEPOCH          dp    Besselian epoch (e.g. 1979.3D0)
*
*  Returned:
*     R2000,D2000     dp    J2000.0 FK5 RA,Dec (rad)
*
*  Notes:
*
*  1)  The epoch BEPOCH is strictly speaking Besselian, but
*      if a Julian epoch is supplied the result will be
*      affected only to a negligible extent.
*
*  2)  Conversion from Besselian epoch 1950.0 to Julian epoch
*      2000.0 only is provided for.  Conversions involving other
*      epochs will require use of the appropriate precession,
*      proper motion, and E-terms routines before and/or
*      after FK45Z is called.
*
*  3)  In the FK4 catalogue the proper motions of stars within
*      10 degrees of the poles do not embody the differential
*      E-term effect and should, strictly speaking, be handled
*      in a different manner from stars outside these regions.
*      However, given the general lack of homogeneity of the star
*      data available for routine astrometry, the difficulties of
*      handling positions that may have been determined from
*      astrometric fields spanning the polar and non-polar regions,
*      the likelihood that the differential E-terms effect was not
*      taken into account when allowing for proper motion in past
*      astrometry, and the undesirability of a discontinuity in
*      the algorithm, the decision has been made in this routine to
*      include the effect of differential E-terms on the proper
*      motions for all stars, whether polar or not.  At epoch 2000,
*      and measuring on the sky rather than in terms of dRA, the
*      errors resulting from this simplification are less than
*      1 milliarcsecond in position and 1 milliarcsecond per
*      century in proper motion.
*
*  References:
*
*     1  Aoki,S., et al, 1983.  Astron.Astrophys., 128, 263.
*
*     2  Smith, C.A. et al, 1989.  "The transformation of astrometric
*        catalog systems to the equinox J2000.0".  Astron.J. 97, 265.
*
*     3  Yallop, B.D. et al, 1989.  "Transformation of mean star places
*        from FK4 B1950.0 to FK5 J2000.0 using matrices in 6-space".
*        Astron.J. 97, 274.
*
*     4  Seidelmann, P.K. (ed), 1992.  "Explanatory Supplement to
*        the Astronomical Almanac", ISBN 0-935702-68-7.
*
*  Called:  slDS2C, slEPJ, slEB2D, slDC2S, slDA2P
*
*  P.T.Wallace   Starlink   21 September 1998
*
*  Copyright (C) 1998 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R1950,D1950,BEPOCH,R2000,D2000

      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)

      DOUBLE PRECISION W
      INTEGER I,J

*  Position and position+velocity vectors
      DOUBLE PRECISION R0(3),A1(3),V1(3),V2(6)

*  Radians per year to arcsec per century
      DOUBLE PRECISION PMF
      PARAMETER (PMF=100D0*60D0*60D0*360D0/D2PI)

*  Functions
      DOUBLE PRECISION slEPJ,slEB2D,slDA2P

*
*  CANONICAL CONSTANTS  (see references)
*

*  Vectors A and Adot, and matrix M (only half of which is needed here)
      DOUBLE PRECISION A(3),AD(3),EM(6,3)
      DATA A,AD/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     :           +1.245D-3,    -1.580D-3,   -0.659D-3/

      DATA (EM(I,1),I=1,6) / +0.9999256782D0,
     :                       +0.0111820610D0,
     :                       +0.0048579479D0,
     :                       -0.000551D0,
     :                       +0.238514D0,
     :                       -0.435623D0 /

      DATA (EM(I,2),I=1,6) / -0.0111820611D0,
     :                       +0.9999374784D0,
     :                       -0.0000271474D0,
     :                       -0.238565D0,
     :                       -0.002667D0,
     :                       +0.012254D0 /

      DATA (EM(I,3),I=1,6) / -0.0048579477D0,
     :                       -0.0000271765D0,
     :                       +0.9999881997D0,
     :                       +0.435739D0,
     :                       -0.008541D0,
     :                       +0.002117D0 /



*  Spherical to Cartesian
      CALL slDS2C(R1950,D1950,R0)

*  Adjust vector A to give zero proper motion in FK5
      W=(BEPOCH-1950D0)/PMF
      DO I=1,3
         A1(I)=A(I)+W*AD(I)
      END DO

*  Remove e-terms
      W=R0(1)*A1(1)+R0(2)*A1(2)+R0(3)*A1(3)
      DO I=1,3
         V1(I)=R0(I)-A1(I)+W*R0(I)
      END DO

*  Convert position vector to Fricke system
      DO I=1,6
         W=0D0
         DO J=1,3
            W=W+EM(I,J)*V1(J)
         END DO
         V2(I)=W
      END DO

*  Allow for fictitious proper motion in FK4
      W=(slEPJ(slEB2D(BEPOCH))-2000D0)/PMF
      DO I=1,3
         V2(I)=V2(I)+W*V2(I+3)
      END DO

*  Revert to spherical coordinates
      CALL slDC2S(V2,W,D2000)
      R2000=slDA2P(W)

      END

chapter xii, example 2. cubic spline interpolation with good knots
c  from  * a practical guide to splines *  by c. de boor
calls  cubspl, newnot
c     parameter nmax=20
      integer i,istep,iter,itermx,j,n,nhigh,nlow,nm1
c     real algerp,aloger,decay,dx,errmax,c(4,nmax),g,h,pnatx
c    *	  ,scrtch(2,nmax),step,tau(nmax),taunew(nmax)
      real algerp,aloger,decay,dx,errmax,c(4,20),g,h,pnatx
     *	  ,scrtch(2,20),step,tau(20),taunew(20),x
c     istep and step = float(istep) specify point density for error det-
c     ermination.
      data step, istep /20., 20/
c				the function  g  is to be interpolated .
      g(x) = sqrt(x+1.)
      decay = 0.
c      read in the number of iterations to be carried out and the lower
c      and upper limit for the number  n  of data points to be used.
      read 500,itermx,nlow,nhigh
  500 format(3i3)
      print 600, itermx
  600 format(i4,22h cycles through newnot//
     *	    28h  n   max.error	 decay exp./)
c				  loop over  n = number of data points .
      do 40 n=nlow,nhigh,2
c					 knots are initially equispaced.
	 nm1 = n-1
	 h = 2./float(nm1)
	 do 10 i=1,n
   10	    tau(i) = float(i-1)*h - 1.
	 iter = 1
c		construct cubic spline interpolant. then, itermx  times,
c		 determine new knots from it and find a new interpolant.
   11	    do 15 i=1,n
   15	       c(1,i) = g(tau(i))
	    call cubspl ( tau, c, n, 0, 0 )
	    if (iter .gt. itermx)	go to 19
	    iter = iter+1
	    call newnot(tau,c,nm1,4,taunew,nm1,scrtch)
	    do 18 i=1,n
   18	       tau(i) = taunew(i)
					go to 11
   19	 continue
c			     estimate max.interpolation error on (-1,1).
	 errmax = 0.
c			    loop over polynomial pieces of interpolant .
	 do 30 i=1,nm1
	    dx = (tau(i+1)-tau(i))/step
c		 interpolation error is calculated at  istep  points per
c		     polynomial piece .
	    do 30 j=1,istep
	       h = float(j)*dx
	       pnatx = c(1,i)+h*(c(2,i)+h*(c(3,i)+h*c(4,i)/3.)/2.)
   30	    errmax = amax1(errmax,abs(g(tau(i)+h)-pnatx))
c					      calculate decay exponent .
	 aloger = alog(errmax)
	 if (n .gt. nlow)  decay =
     *	     (aloger - algerp)/alog(float(n)/float(n-2))
	 algerp = aloger
c
   40	 print 640,n,errmax,decay
  640 format(i3,e12.4,f11.2)
					stop
      end

C----------------------------------------------------------------------
        subroutine ftpclu(ounit,colnum,frow,felem,nelem,status)

C       set elements of a table to be undefined

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
        character snull*500
        character*1 xdummy(5260)
        common/ftheap/snull,xdummy
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bytpix,bstart,i4null,tcode,nchars,i,offset,nulval
        integer ibuff,ntodo,itodo,repeat,rstart,estart
        integer*2 i2null,l1null
        real r4null
        double precision r8null
        logical descrp
        character*1 i1null
        character crow*9,cp1*9,cp2*9,ccol*4

        if (status .gt. 0)return

C       check for zero length array
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &         'request is out of range:'//crow//' (FTPCLU).')
                return
        end if
        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)

        tcode=tdtype(colnum+tstart(ibuff))
        bytpix=max(abs(tcode)/10,1)

        descrp=.false.
        ntodo=nelem
        rstart=frow-1

        if (felem .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &         'request is out of range:'//crow//' (FTPCLU).')
                return
        else
                estart=felem-1
        end if

        if (tcode .eq. 16)then
C               this is an ASCII field
                repeat=trept(colnum+tstart(ibuff))
                if (felem .gt. repeat)then
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &         'request is out of range:'//crow//' (FTPCLU).')
                        return
                end if

                if (cnull(colnum+tstart(ibuff))(1:1) .eq. char(1))then
C                       error: null value has not been defined
                        status=314
                call ftpmsg('Null value string for ASCII table'//
     &          ' column has not yet been defined (FTPCLU).')
                        return
                end if
C               the TNULL parameter stores the width of the character field
                bytpix=tnull(colnum+tstart(ibuff))
        else
C               this is a binary table
                nulval=tnull(colnum+tstart(ibuff))

                if (tcode .gt. 0)then
                        if (hdutyp(ibuff) .eq. 0)then
C                           if this is a primary array or image extension, then
C                           set repeat as large as needed to write all
C                           the pixels.  This prevents an error message if
C                           array size is not yet known.  The actual array
C                           dimension must be defined by the NAXISn keywords
C                           before closing this HDU. 
                            repeat=estart+nelem
                        else
                            repeat=trept(colnum+tstart(ibuff))
                        end if

                        if (felem .gt. repeat)then
C                               illegal element number
                                status=308
                                return
                        end if
                else
C                       this is a variable length descriptor column
                        descrp=.true.
                        tcode=-tcode
C                       read the number of elements and the starting offset:
                        call ftgdes(ounit,colnum,frow,repeat,
     &                              offset,status)
                        if (ntodo+estart .gt. repeat)then
C                               error:  tried to write past end of record
                                status=319
                                return
                        end if

C                       move the i/o pointer to the start of the pixel sequence
                        bstart=dtstrt(ibuff)+offset+
     &                          theap(ibuff)+estart*bytpix
                        call ftmbyt(ounit,bstart,.true.,status)
                end if

                if (tcode.eq.11 .or. tcode.eq.21 .or. tcode.eq.41)then
                        if (nulval .eq. 123454321)then
C                               error: null value has not been defined
                                status=314
                call ftpmsg('Null value for integer'//
     &          ' column has not yet been defined (FTPCLU).')
                                return
                        end if
                else
C                       set the floating point Not-a-Number values
                        call ftsrnn(r4null)
                        call ftsdnn(r8null)
                end if

        end if

C       process as many contiguous pixels as possible
20      itodo=min(ntodo,repeat-estart)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &             +tbcol(colnum+tstart(ibuff))+estart*bytpix
            call ftmbyt(ounit,bstart,.true.,status)
        end if

C       write the appropriate null value to the pixels
        if (tcode .eq. 21)then
C               column data type is I (I*2)
                do 5 i=1,itodo
                        i2null=nulval
                        call ftpi2b(ounit,1,0,i2null,status)
5               continue
        else if (tcode .eq. 41)then
C               column data type is J (I*4)
                do 15 i=1,itodo
                        i4null=nulval
                        call ftpi4b(ounit,1,0,i4null,status)
15              continue
        else if (tcode .eq. 42)then
C               column data type is E (R*4)
                do 25 i=1,itodo
                        call ftpbyt(ounit,4,r4null,status)
25              continue
        else if (tcode .eq. 82 .or. tcode .eq. 83)then
C               column data type is D (R*8), or C complex 2 x R*4
                do 35 i=1,itodo
                        call ftpbyt(ounit,8,r8null,status)
35              continue
        else if (tcode .eq. 16)then
C               this is an ASCII table column
                snull=cnull(colnum+tstart(ibuff))
C               write up to 500 characters in the column, remainder unchanged
C               (500 is the maximum size string allowed in IBM AIX compiler)
                nchars=min(bytpix,500)
                do 45 i=1,itodo
                        call ftpcbf(ounit,1,nchars,snull,status)
45              continue
        else if (tcode .eq. 11)then
C               column data type is B (byte)
                i1null=char(nulval)
                do 55 i=1,itodo
                        call ftpcbf(ounit,0,1,i1null,status)
55              continue
        else if (tcode .eq. 163)then
C               column data type is double complex (M)
                do 65 i=1,itodo*2
                        call ftpbyt(ounit,8,r8null,status)
65              continue
        else if (tcode .eq. 14)then
C               column data type is logical (L)
                l1null=0
                do 85 i=1,itodo
                        call ftpbyt(ounit,1,l1null,status)
85              continue
        end if


        if (status .gt. 0)then
          if (hdutyp(ibuff) .eq. 0)then
C            this is a primary array or image extension
             write(cp1,2000)felem+nelem-ntodo
             write(cp2,2000)felem+nelem-ntodo+itodo-1
             call ftpmsg('Error writing Nulls to pixels'
     &       //cp1//' to'//cp2//' in the FITS array (FTPCLU).')
             if (frow .ne. 1)then
                write(cp1,2000)frow
                call ftpmsg('Error while writing group'//cp1//
     &          ' of the multigroup primary array.')
             end if
          else
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem
               write(cp2,2000)felem+nelem-1
               call ftpmsg('Error writing Nulls to elements'//cp1//
     &         ' to'//cp2 //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTPCLU.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow
               write(cp2,2000)frow+nelem-1
               call ftpmsg('Error writing Nulls to rows'//cp1//' to'
     &         //cp2//' of column'//ccol//' (FTPCLU).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error writing'//cp2//' Null elements to'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTPCLU).')
             end if
          end if
          return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        rstart=rstart+1
                end if
                go to 20
        end if
        end

c MINMAX -- Compute the minimum and maximum pixel values in an image.
c The new values are printed as well as updated in the image header.
c
c	usage:  minmax image
c ----------------------------------------------------------------------

	program minmax

	character*80	image, errmsg
	real		pix(8192), dmin, dmax, vmin, vmax
	integer		im, axlen(7), naxis, dtype, ier, j

c --- Get image name.
	call clargc (1, image, ier)
	if (ier .ne. 0) then
	    write (*, '('' enter image name: '',$)')
	    read (*,*) image
	endif

c --- Open the image for readwrite access (we need to update the header).
	call imopen (image, 3, im, ier)
	if (ier .ne. 0) goto 91
	call imgsiz (im, axlen, naxis, dtype, ier)
	if (ier .ne. 0) goto 91

c --- Read through the image and compute the limiting pixel values.
	do 10 j = 1, axlen(2)
	    call imgl2r (im, pix, j, ier)
	    if (ier .ne. 0) goto 91
	    call alimr (pix, axlen(1), vmin, vmax)
	    if (j .eq. 1) then
		dmin = vmin
		dmax = vmax
	    else
		dmin = min (dmin, vmin)
		dmax = max (dmax, vmax)
	    endif
 10	continue

c --- Update the image header.
	call impkwr (im, 'datamin', dmin, ier)
	if (ier .ne. 0) goto 91
	call impkwr (im, 'datamax', dmax, ier)
	if (ier .ne. 0) goto 91

c --- Clean up.
	call imclos (im, ier)
	if (ier .ne. 0) goto 91
	write (*, '(1x, a20, 2 g12.5)') image, dmin, dmax
	stop

c --- Error exit.
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg
	stop
	end

C----------------------------------------------------------------------
        subroutine ftwend(iunit,status)

C       write the END card, and following fill values in the CHDU

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Aug 1994

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,nblank,i,endpos
        character*80 rec

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       calc the data starting position if not currently defined
        if (dtstrt(ibuff) .lt. 0)then
                dtstrt(ibuff)=(hdend(ibuff)/2880 + 1)*2880
        end if

C       calculate the number of blank keyword slots in the header
        endpos=hdend(ibuff)
        nblank=(dtstrt(ibuff)-endpos)/80
C       move the i/o pointer to the end of the header keywords
        call ftmbyt(iunit,endpos,.true.,status)

C       fill all the slots with blanks
        rec=' '
        do 10 i=1,nblank
                call ftpcbf(iunit,1,80,rec,status)
10      continue

C               The END keyword must either be placed 
C               immediately after the last keyword that was written 
C               (as indicated by the HDEND parameter), or must be in the
C               first 80 bytes of the FITS record immediately preceeding
C               the data unit, whichever is further in the file.
C               The latter will occur if the user reserved room for more
C               header keywords which have not (yet) been filled.

C       move pointer to where the END card should be
        endpos=max(endpos,dtstrt(ibuff)-2880)
        call ftmbyt(iunit,endpos,.true.,status)

C       write the END record to the output buffer:
        rec='END'
        call ftpcbf(iunit,1,80,rec,status)

        if (status .gt. 0)then
            call ftpmsg('Error while writing END card (FTWEND).')
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftnkey(nseq,keywrd,keyout,status)

C       Make a keyword name by concatinating a sequence number and
C       the root name. (Sequence number is prepended to the name)

C       nseq    i  sequence number 
C       keywrd  c  root keyword name
C       OUTPUT PARAMETERS:
C       keyout  c  output concatinated keyword name
C       status  i  output error status (0 = ok)
C       
C       written by Wm Pence, HEASARC/GSFC, Aug 1994

        character*(*) keywrd
        integer nseq,status,nspace,i
        character keyout*8,value*20,work*8
        
        work=keywrd

C       find end of keyword string
        nspace=0
        do 10 i=8,1,-1
                if (work(i:i) .ne. ' ')go to 15
                nspace=nspace+1
10      continue
15      continue

C       prepend sequence number to keyword root only if there is room
        if (nseq .lt. 0)then
C               illegal value
                go to 900
        else if (nseq .lt. 10 .and. nspace .ge. 1)then
                write(keyout,1001,err=900)nseq,work(1:7)
        else if (nseq .lt. 100 .and. nspace .ge. 2)then
                write(keyout,1002,err=900)nseq,work(1:6)
        else if (nseq .lt. 1000 .and. nspace .ge. 3)then
                write(keyout,1003,err=900)nseq,work(1:5)
        else if (nseq .lt. 10000 .and. nspace .ge. 4)then
                write(keyout,1004,err=900)nseq,work(1:4)
        else if (nseq .lt. 100000 .and. nspace .ge. 5)then
                write(keyout,1005,err=900)nseq,work(1:3)
        else if (nseq .lt. 1000000 .and. nspace .ge. 6)then
                write(keyout,1006,err=900)nseq,work(1:2)
        else if (nseq .lt. 10000000 .and. nspace .ge. 7)then
                write(keyout,1007,err=900)nseq,work(1:1)
        else
C               number too big to fit in keyword
                go to 900
        end if

1001    format(i1,a7)
1002    format(i2,a6)
1003    format(i3,a5)
1004    format(i4,a4)
1005    format(i5,a3)
1006    format(i6,a2)
1007    format(i7,a1)

        return
C       come here if error concatinating the seq. no. to the root string
900     continue

        if (status .gt. 0)return
        status=206
        write(value,1008)nseq
1008    format(i20)
        call ftpmsg('Could not concatinate the integer '//value//
     & ' and the root keyword named: '//work)
        end

      integer function sdrop (from, to, chars)
      integer from (100), to (100)
      integer chars
      integer len, start
      integer ctoc, length, min0
      len = length (from)
      if (.not.(chars .lt. 0))goto 23000
      sdrop=(ctoc (from, to, len + chars + 1))
      return
23000 continue
      start = min0 (chars, len)
      sdrop=(ctoc (from (start + 1), to, len + 1))
      return
23001 continue
      end

      SUBROUTINE COSQI (N,WSAVE)
      DIMENSION       WSAVE(*)
      DATA PIH /1.57079632679491/
      DT = PIH/FLOAT(N)
      FK = 0.
      DO 101 K=1,N
         FK = FK+1.
         WSAVE(K) = COS(FK*DT)
  101 CONTINUE
      CALL RFFTI (N,WSAVE(N+1))
      RETURN
      END

      subroutine forcod (lab)
      integer lab
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer t, token (100)
      integer gettok, gnbtok
      integer i, j, nlpar
      integer length, labgen
      integer ifnot(10)
      integer serrc0(22)
      data ifnot(1)/105/,ifnot(2)/102/,ifnot(3)/32/,ifnot(4)/40/,ifnot(5
     *)/46/,ifnot(6)/110/,ifnot(7)/111/,ifnot(8)/116/,ifnot(9)/46/,ifnot
     *(10)/-2/
      data serrc0(1)/46/,serrc0(2)/97/,serrc0(3)/110/,serrc0(4)/100/,ser
     *rc0(5)/46/,serrc0(6)/40/,serrc0(7)/46/,serrc0(8)/110/,serrc0(9)/11
     *1/,serrc0(10)/116/,serrc0(11)/46/,serrc0(12)/120/,serrc0(13)/101/,
     *serrc0(14)/114/,serrc0(15)/102/,serrc0(16)/108/,serrc0(17)/103/,se
     *rrc0(18)/41/,serrc0(19)/41/,serrc0(20)/41/,serrc0(21)/32/,serrc0(2
     *2)/-2/
      lab = labgen (3)
      call outcon (0)
      if (.not.(gnbtok (token, 100) .ne. 40))goto 23000
      call synerr (19Hmissing left paren.)
      return
23000 continue
      if (.not.(gnbtok (token, 100) .ne. 59))goto 23002
      call pbstr (token)
      call outtab
      call eatup
      call outdwe
23002 continue
      if (.not.(gnbtok (token, 100) .eq. 59))goto 23004
      call outcon (lab)
      goto 23005
23004 continue
      call pbstr (token)
      call outnum (lab)
      call outtab
      call outstr (ifnot)
      call outch (40)
      nlpar = 0
23006 if (.not.(nlpar .ge. 0))goto 23007
      t = gettok (token, 100)
      if (.not.(t .eq. 59))goto 23008
      goto 23007
23008 continue
      if (.not.(t .eq. 40))goto 23010
      nlpar = nlpar + 1
      goto 23011
23010 continue
      if (.not.(t .eq. 41))goto 23012
      nlpar = nlpar - 1
23012 continue
23011 continue
      if (.not.(t .eq. -1))goto 23014
      call pbstr (token)
      return
23014 continue
      if (.not.(t .eq. -9))goto 23016
      call squash (token)
23016 continue
      if (.not.(t .ne. 10 .and. t .ne. 95))goto 23018
      call outstr (token)
23018 continue
      goto 23006
23007 continue
      if (.not.(ername .eq. 1))goto 23020
      call outstr (serrc0)
      goto 23021
23020 continue
      call outch (41)
      call outch (41)
      call outch (32)
23021 continue
      call outgo (lab+2)
      if (.not.(nlpar .lt. 0))goto 23022
      call synerr (19Hinvalid for clause.)
23022 continue
23005 continue
      fordep = fordep + 1
      j = 1
      i = 1
23024 if (.not.(i .lt. fordep))goto 23026
      j = j + length (forstk (j)) + 1
23025 i = i + 1
      goto 23024
23026 continue
      forstk (j) = -2
      nlpar = 0
      t = gnbtok (token, 100)
      call pbstr (token)
23027 if (.not.(nlpar .ge. 0))goto 23028
      t = gettok (token, 100)
      if (.not.(t .eq. 40))goto 23029
      nlpar = nlpar + 1
      goto 23030
23029 continue
      if (.not.(t .eq. 41))goto 23031
      nlpar = nlpar - 1
23031 continue
23030 continue
      if (.not.(t .eq. -1))goto 23033
      call pbstr (token)
      goto 23028
23033 continue
      if (.not.(nlpar .ge. 0 .and. t .ne. 10 .and. t .ne. 95))goto 23035
      if (.not.(t .eq. -9))goto 23037
      call squash (token)
23037 continue
      if (.not.(j + length (token) .ge. 200))goto 23039
      call baderr (20Hfor clause too long.)
23039 continue
      call scopy (token, 1, forstk, j)
      j = j + length (token)
23035 continue
      goto 23027
23028 continue
      lab = lab + 1
      call indent (1)
      call errgo
      return
      end
c     logic0  logical_column
c     serrc0  serrchk

C--------------------------------------------------------------------------
        subroutine ftcsum(iunit,nrec,sum,status)

C       Calculate a 32-bit 1's complement checksum of the FITS 2880-byte blocks.
C       This Fortran algorithm is based on the C algorithm developed by Rob
C       Seaman at NOAO that was presented at the 1994 ADASS conference, to be 
C       published in the Astronomical Society of the Pacific Conference Series.

C       This uses a 32-bit 1's complement checksum in which the overflow bits
C       are permuted back into the sum and therefore all bit positions are
C       sampled evenly.  In this Fortran version of the original C algorithm,
C       a double precision value (which has at least 48 bits of precision)
C       is used to accumulate the checksum because standard Fortran does not 
C       support an unsigned integer datatype.

C       iunit   i  fortran unit number
C       nrec    i  number of FITS 2880-byte blocks to be summed
C       sum     d  check sum value (initialize to zero before first call)
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Sept, 1994

        integer iunit,nrec,status,i,j,hibits,i4vals(720)
        double precision sum,word32
        parameter (word32=4.294967296D+09)
C       word32 is equal to 2**32

        if (status .gt. 0)return

C       Sum the specified number of FITS 2880-byte records.  This assumes that
C       the FITSIO file pointer points to the start of the records to be summed.
        do 30 j=1,nrec

C           read the record as 720 pixel I*4 vector (do byte swapping if needed)
            call ftgi4b(iunit,720,0,i4vals,status)
            do 10 i=1,720
                if (i4vals(i) .ge. 0)then
                        sum=sum+i4vals(i)
                else
C                       sign bit is set, so add the equalvalent unsigned value
                        sum=sum+(word32+i4vals(i))
                end if
10          continue

C           fold any overflow bits beyond 32 back into the word
20          hibits=sum/word32
            if (hibits .gt. 0)then
                sum=sum-(hibits*word32)+hibits
                go to 20
            end if
30      continue
        end

      SUBROUTINE slH2E ( AZ, EL, PHI, HA, DEC )
*+
*     - - - - -
*      D E 2 H
*     - - - - -
*
*  Horizon to equatorial coordinates:  Az,El to HA,Dec
*
*  (single precision)
*
*  Given:
*     AZ      r     azimuth
*     EL      r     elevation
*     PHI     r     observatory latitude
*
*  Returned:
*     HA      r     hour angle
*     DEC     r     declination
*
*  Notes:
*
*  1)  All the arguments are angles in radians.
*
*  2)  The sign convention for azimuth is north zero, east +pi/2.
*
*  3)  HA is returned in the range +/-pi.  Declination is returned
*      in the range +/-pi/2.
*
*  4)  The latitude is (in principle) geodetic.  In critical
*      applications, corrections for polar motion should be applied.
*
*  5)  In some applications it will be important to specify the
*      correct type of elevation in order to produce the required
*      type of HA,Dec.  In particular, it may be important to
*      distinguish between the elevation as affected by refraction,
*      which will yield the "observed" HA,Dec, and the elevation
*      in vacuo, which will yield the "topocentric" HA,Dec.  If the
*      effects of diurnal aberration can be neglected, the
*      topocentric HA,Dec may be used as an approximation to the
*      "apparent" HA,Dec.
*
*  6)  No range checking of arguments is done.
*
*  7)  In applications which involve many such calculations, rather
*      than calling the present routine it will be more efficient to
*      use inline code, having previously computed fixed terms such
*      as sine and cosine of latitude.
*
*  Last revision:   11 September 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL AZ, EL, PHI, HA, DEC

      DOUBLE PRECISION SA, CA, SE, CE, SP, CP, X, Y, Z, R


*  Useful trig functions.
      SA = SIN(AZ)
      CA = COS(AZ)
      SE = SIN(EL)
      CE = COS(EL)
      SP = SIN(PHI)
      CP = COS(PHI)

*  HA,Dec as x,y,z.
      X = -CA*CE*SP+SE*CP
      Y = -SA*CE
      Z = CA*CE*CP+SE*SP

*  To HA,Dec.
      R = SQRT(X*X+Y*Y)
      IF (R.EQ.0.0) THEN
         HA = 0.0
      ELSE
         HA = REAL(ATAN2(Y,X))
      END IF
      DEC = REAL(ATAN2(Z,R))

      END

      subroutine pbnum (n)
      integer n
      integer m, num
      integer mod
      integer digits(11)
      data digits(1)/48/,digits(2)/49/,digits(3)/50/,digits(4)/51/,digit
     *s(5)/52/,digits(6)/53/,digits(7)/54/,digits(8)/55/,digits(9)/56/,d
     *igits(10)/57/,digits(11)/-2/
      num = n
23000 continue
      m = mod (num, 10)
      call putbak (digits (m + 1))
      num = num / 10
23001 if (.not.(num .eq. 0))goto 23000
23002 continue
      return
      end

#-h-  otherc			  284  local   12/01/80  15:54:30
# otherc - output ordinary Fortran statement
   include  defs

   subroutine otherc (lexstr)
   character lexstr(ARB)

   include COMMON_BLOCKS

   xfer = NO
   call outtab
   if ((BIGA <= lexstr(1) & lexstr(1) <= BIGZ)
     | (LETA <= lexstr(1) & lexstr(1) <= LETZ))
      call squash (lexstr)
   call outstr (lexstr)
   call eatup
   call outdwe
   return
   end

      subroutine l2appr ( t, n, k, q, diag, bcoef )
c  from  * a practical guide to splines *  by c. de boor
c  to be called in main program  l 2 m a i n .
calls subprograms  bsplvb, bchfac/slv
c
constructs the (weighted discrete) l2-approximation by splines of order
c  k  with knot sequence  t(1), ..., t(n+k)  to given data points
c  ( tau(i), gtau(i) ), i=1,...,ntau. the b-spline coefficients
c  b c o e f   of the approximating spline are determined from the
c  normal equations using cholesky's method.
c
c******  i n p u t  ******
c  t(1), ..., t(n+k)  the knot sequence
c  n.....the dimension of the space of splines of order k with knots t.
c  k.....the order
c
c  w a r n i n g  . . .  the restriction   k .le. kmax (= 20)	is impo-
c	 sed by the arbitrary dimension statement for  biatx  below, but
c	 is  n o w h e r e   c h e c k e d   for.
c
c******  w o r k  a r r a y s  ******
c  q....a work array of size (at least) k*n. its first	k  rows are used
c	for the  k  lower diagonals of the gramian matrix  c .
c  diag.....a work array of length  n  used in bchfac .
c
c******  i n p u t  via  c o m m o n  /data/  ******
c  ntau.....number of data points
c  (tau(i),gtau(i)), i=1,...,ntau     are the  ntau  data points to be
c	 fitted .
c  weight(i), i=1,...,ntau    are the corresponding weights .
c
c******  o u t p u t  ******
c  bcoef(1), ..., bcoef(n)  the b-spline coeffs. of the l2-appr.
c
c******  m e t h o d  ******
c  the b-spline coefficients of the l2-appr. are determined as the sol-
c  ution of the normal equations
c     sum ( (b(i),b(j))*bcoef(j) : j=1,...,n)  = (b(i),g),
c						i = 1, ..., n .
c  here,  b(i)	denotes the i-th b-spline,  g  denotes the function to
c  be approximated, and the  i n n e r	 p r o d u c t	of two funct-
c  ions  f  and  g  is given by
c      (f,g)  :=  sum ( f(tau(i))*g(tau(i))*weight(i) : i=1,...,ntau) .
c  the arrays  t a u  and  w e i g h t	are given in common block
c   d a t a , as is the array  g t a u	containing the sequence
c  g(tau(i)), i=1,...,ntau.
c  the relevant function values of the b-splines  b(i), i=1,...,n, are
c  supplied by the subprogram  b s p l v b .
c     the coeff.matrix	c , with
c	    c(i,j)  :=	(b(i), b(j)), i,j=1,...,n,
c  of the normal equations is symmetric and (2*k-1)-banded, therefore
c  can be specified by giving its k bands at or below the diagonal. for
c  i=1,...,n,  we store
c   (b(i),b(j))  =  c(i,j)  in	q(i-j+1,j), j=i,...,min0(i+k-1,n)
c  and the right side
c   (b(i), g )	in  bcoef(i) .
c  since b-spline values are most efficiently generated by finding sim-
c  ultaneously the value of  e v e r y	nonzero b-spline at one point,
c  the entries of  c  (i.e., of  q ), are generated by computing, for
c  each ll, all the terms involving  tau(ll)  simultaneously and adding
c  them to all relevant entries.
c     parameter kmax=20,ntmax=200
      integer k,n,   i,j,jj,left,leftmk,ll,mm,ntau
c     real bcoef(n),diag(n),q(k,n),t(1),  biatx(kmax),dw,gtau,tau,weight
      real bcoef(n),diag(n),q(k,n),t(1),  biatx(  20),dw,gtau,tau,weight
c     dimension t(n+k)
current fortran standard makes it impossible to specify the exact dimen-
c  sion of  t  without the introduction of additional otherwise super-
c  fluous arguments.
c     common / data / ntau, tau(ntmax),gtau(ntmax),weight(ntmax)
      common / data / ntau, tau(  200),gtau(  200),weight(  200)
      do 7 j=1,n
	 bcoef(j) = 0.
	 do 7 i=1,k
    7	    q(i,j) = 0.
      left = k
      leftmk = 0
      do 20 ll=1,ntau
c		    locate  l e f t  s.t. tau(ll) in (t(left),t(left+1))
   10	    if (left .eq. n)		go to 15
	    if (tau(ll) .lt. t(left+1)) go to 15
	    left = left+1
	    leftmk = leftmk + 1
					go to 10
   15	 call bsplvb ( t, k, 1, tau(ll), left, biatx )
c	 biatx(mm) contains the value of b(left-k+mm) at tau(ll).
c	 hence, with  dw := biatx(mm)*weight(ll), the number dw*gtau(ll)
c	 is a summand in the inner product
c	    (b(left-k+mm), g)  which goes into	bcoef(left-k+mm)
c	 and the number biatx(jj)*dw is a summand in the inner product
c	    (b(left-k+jj), b(left-k+mm)), into	q(jj-mm+1,left-k+mm)
c	 since	(left-k+jj) - (left-k+mm) + 1  =  jj - mm + 1 .
	 do 20 mm=1,k
	    dw = biatx(mm)*weight(ll)
	    j = leftmk + mm
	    bcoef(j) = dw*gtau(ll) + bcoef(j)
	    i = 1
	    do 20 jj=mm,k
	       q(i,j) = biatx(jj)*dw + q(i,j)
   20	       i = i + 1
c
c	      construct cholesky factorization for  c  in  q , then use
c	      it to solve the normal equations
c		     c*x  =  bcoef
c	      for  x , and store  x  in  bcoef .
      call bchfac ( q, k, n, diag )
      call bchslv ( q, k, n, bcoef )
					return
      end

#-h-  outstr			  687  local   12/01/80  15:54:32
# outstr - output string; handles quoted literals
   include  defs

   subroutine outstr (str)
   character str (ARB)

   character c

   integer i, j

   for (i = 1; str (i) != EOS; i = i + 1) {
      c = str (i)
      if (c != SQUOTE & c != DQUOTE) {
			 # produce upper case fortran, if desired
	 call outch (c)
	 }
      else {
	 i = i + 1
	 for (j = i; str (j) != c; j = j + 1)	# find end
	    ;
	 call outnum (j - i)
	 call outch (BIGH)
	 for ( ; i < j; i = i + 1)
	    call outch (str (i))
	 }
      }
   return
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE ANOTAT (LABX,LABY,LBAC,LSET,NDSH,DSHL)
C
      CHARACTER*(*) LABX,LABY,DSHL(*)
C
C The routine ANOTAT resets background annotation.
C
C Declare the type of the dash-pattern-parameter-name generator.
C
      CHARACTER*16 AGDSHN
C
C Set up the x-axis label.
C
      IF (ICHAR(LABX(1:1)).NE.0) THEN
        CALL AGSETC ('LABE/NAME.', 'B')
        CALL AGSETI ('LINE/NUMB.',-100)
        CALL AGSETC ('LINE/TEXT.',LABX)
      END IF
C
C Set up the y-axis label.
C
      IF (ICHAR(LABY(1:1)).NE.0) THEN
        CALL AGSETC ('LABE/NAME.', 'L')
        CALL AGSETI ('LINE/NUMB.', 100)
        CALL AGSETC ('LINE/TEXT.',LABY)
      END IF
C
C Set up the background the user wants.
C
      IF (LBAC.GT.0) CALL AGSETI ('BACK.',LBAC)
C
C Set the parameter ISET.
C
      IF (LSET.NE.0) CALL AGSETI ('SET .',LSET)
C
C Set up the dash patterns the user wants.
C
      IF (NDSH.NE.0) THEN
        IDSH=MIN0(26,NDSH)
        CALL AGSETI ('DASH/SELE.',IDSH)
        IF (IDSH.LT.0) RETURN
        DO 101 I=1,IDSH
          CALL AGSETC (AGDSHN(I),DSHL(I))
  101   CONTINUE
      END IF
C
      RETURN
C
      END

      subroutine subbak ( w, ipivot, nrow, ncol, last, x )
c  carries out backsubstitution for current block.
c
c parameters
c    w, ipivot, nrow, ncol, last  are as on return from factrb.
c    x(1),...,x(ncol)  contains, on input, the right side for the
c	     equations in this block after backsubstitution has been
c	     carried up to but not including equation ipivot(last).
c	     means that x(j) contains the right side of equation ipi-
c	     vot(j) as modified during elimination, j=1,...,last, while
c	     for j .gt. last, x(j) is already a component of the solut-
c	     ion vector.
c    x(1),...,x(ncol) contains, on output, the components of the solut-
c	     ion corresponding to the present block.
c
      integer nrow, ncol
      integer ipivot(nrow),last,  ip,j,k,kp1
      real w(nrow,ncol),x(ncol), sum
      k = last
      ip = ipivot(k)
      sum = 0.
      if (k .eq. ncol)			go to 4
      kp1 = k+1
    2	 do 3 j=kp1,ncol
    3	    sum = w(ip,j)*x(j) + sum
    4	 x(k) = (x(k) - sum)/w(ip,k)
	 if (k .eq. 1)			return
	 kp1 = k
	 k = k-1
	 ip = ipivot(k)
	 sum = 0.
					go to 2
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE EZMXY (XDRA,YDRA,IDXY,MANY,NPTS,LABG)
C
      REAL XDRA(*),YDRA(*)
C
      CHARACTER*(*) LABG
C
C The routine EZMXY draws many curves, each of them defined by points of
C the form (XDRA(I,J),YDRA(I,J)) or (XDRA(J,I),YDRA(J,I)) or, possibly,
C (XDRA(I),YDRA(I,J)) or (XDRA(I),YDRA(J,I)), for I = 1, 2, ... NPTS and
C for J = 1, 2, ... MANY.  (YDRA is actually dimensioned IDXY by * .)
C
C Do statistics-gathering call.
C
      LOGICAL Q8Q4
      SAVE Q8Q4
      DATA Q8Q4 /.TRUE./
      IF (Q8Q4) THEN
        CALL Q8QST4('GRAPHX','AUTOGRAPH','EZMXY','VERSION 07')
        Q8Q4 = .FALSE.
      ENDIF
C
C +NOAO
C
      call agdflt
C 
C -NOAO
      CALL AGGETI ('SET .',ISET)
      CALL AGGETI ('FRAM.',IFRA)
      CALL AGGETI ('DASH/SELE.',IDSH)
C
      CALL AGEZSU (4,XDRA,YDRA,IDXY,MANY,NPTS,LABG,IIVX,IIEX,IIVY,IIEY)
      CALL AGBACK
C
      IF (ISET.LT.0) GO TO 102
C
           DO 101 I=1,MANY
           INXD=1+(I-1)*IIVX
           INYD=1+(I-1)*IIVY
           KDSH=ISIGN(I,IDSH)
           CALL AGCURV (XDRA(INXD),IIEX,YDRA(INYD),IIEY,NPTS,KDSH)
  101      CONTINUE
C
  102 IF (IFRA.EQ.1) CALL FRAME
C
C +NOAO
C
      call initag
C
C -NOAO
      RETURN
C
      END

include	defs

# gctoi --- convert any radix string to single precision integer

   integer function gctoi (str, i, radix)
   character str (ARB)
   integer i, radix

   integer base, v, d, j
   external index
   integer index

   character clower

   logical neg

   string digits "0123456789abcdef"

   v = 0
   base = radix

   while (str (i) == BLANK | str (i) == TAB)
      i = i + 1

   neg = (str (i) == MINUS)
   if (str (i) == PLUS | str (i) == MINUS)
      i = i + 1

   if (str (i + 2) == LETR & str (i) == DIG1 & DIG0 <= str(i+1) & str(i+1) <= DIG9
	 | str (i + 1) == LETR & DIG0 <= str(i) & str(i) <= DIG9) {
      base = str (i) - DIG0
      j = i
      if (str (i + 1) != LETR) {
	 j = j + 1
	 base = base * 10 + (str (j) - DIG0)
	 }
      if (base < 2 | base > 16)
	 base = radix
      else
	 i = j + 2
      }

   for (; str (i) != EOS; i = i + 1) {
      if (DIG0 <= str(i) & str(i) <= DIG9)
	 d = str (i) - DIG0
      else
	 d = index (digits, clower (str (i))) - 1
      if (d < 0 | d >= base)
	 break
      v = v * base + d
      }

   if (neg)
      return (-v)
   else
      return (+v)

   end

      SUBROUTINE slMAP (RM, DM, PR, PD, PX, RV, EQ, DATE, RA, DA)
*+
*     - - - -
*      M A P
*     - - - -
*
*  Transform star RA,Dec from mean place to geocentric apparent
*
*  The reference frames and timescales used are post IAU 1976.
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Given:
*     RM,DM    dp     mean RA,Dec (rad)
*     PR,PD    dp     proper motions:  RA,Dec changes per Julian year
*     PX       dp     parallax (arcsec)
*     RV       dp     radial velocity (km/sec, +ve if receding)
*     EQ       dp     epoch and equinox of star data (Julian)
*     DATE     dp     TDB for apparent place (JD-2400000.5)
*
*  Returned:
*     RA,DA    dp     apparent RA,Dec (rad)
*
*  Called:
*     slMAPA       star-independent parameters
*     slMAPQ       quick mean to apparent
*
*  Notes:
*
*  1)  EQ is the Julian epoch specifying both the reference frame and
*      the epoch of the position - usually 2000.  For positions where
*      the epoch and equinox are different, use the routine slPM to
*      apply proper motion corrections before using this routine.
*
*  2)  The distinction between the required TDB and TT is always
*      negligible.  Moreover, for all but the most critical
*      applications UTC is adequate.
*
*  3)  The proper motions in RA are dRA/dt rather than cos(Dec)*dRA/dt.
*
*  4)  This routine may be wasteful for some applications because it
*      recomputes the Earth position/velocity and the precession-
*      nutation matrix each time, and because it allows for parallax
*      and proper motion.  Where multiple transformations are to be
*      carried out for one epoch, a faster method is to call the
*      slMAPA routine once and then either the slMAPQ routine
*      (which includes parallax and proper motion) or slMAPZ (which
*      assumes zero parallax and proper motion).
*
*  5)  The accuracy is sub-milliarcsecond, limited by the
*      precession-nutation model (IAU 1976 precession, Shirai &
*      Fukushima 2001 forced nutation and precession corrections).
*
*  6)  The accuracy is further limited by the routine slEVP, called
*      by slMAPA, which computes the Earth position and velocity
*      using the methods of Stumpff.  The maximum error is about
*      0.3 mas.
*
*  P.T.Wallace   Starlink   17 September 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RM,DM,PR,PD,PX,RV,EQ,DATE,RA,DA

      DOUBLE PRECISION AMPRMS(21)



*  Star-independent parameters
      CALL slMAPA(EQ,DATE,AMPRMS)

*  Mean to apparent
      CALL slMAPQ(RM,DM,PR,PD,PX,RV,AMPRMS,RA,DA)

      END

C----------------------------------------------------------------------
        subroutine ftdtyp(value,dtype,status)

C       determine datatype of a FITS value field
C       This assumes value field conforms to FITS standards and may not
C          detect all invalid formats.
C       value   c  input value field from FITS header record only,
C                  (usually the value field is in columns 11-30 of record)
C                  The value string is left justified.
C       dtype   c  output type (C,L,I,F) for Character string, Logical,
C                    Integer, Floating point, respectively
C
C       written by Wm Pence, HEASARC/GSFC, February 1991

        character*(*)value,dtype
        integer status

        if (status .gt. 0)return

        dtype=' '

        if (value(1:1) .eq. '''')then
C               character string
                dtype='C'
        else if (value(1:1).eq.'T' .or. value(1:1).eq.'F')then
C               logical
                dtype='L'
        else if (index(value,'.') .gt. 0)then
C               floating point
                dtype='F'
        else
C               assume it must be an integer, since it isn't anything else
                dtype='I'
        end if
        end

      subroutine dsdbiu (b, form)
      integer b
      integer form
      integer mem( 60000)
      common/cdsmem/mem
      integer l, s, lmax
      integer blanks(6)
      data blanks(1)/9/,blanks(2)/32/,blanks(3)/32/,blanks(4)/32/,blanks
     *(5)/32/,blanks(6)/-2/
      call putint (b, 5, 2)
      call putch (32, 2)
      call putint (mem (b + 0), 0, 2)
      call remark (14H words in use.)
      l = 0
      s = b + mem (b + 0)
      if (.not.(form .eq. 48))goto 23000
      lmax = 5
      goto 23001
23000 continue
      lmax = 50
23001 continue
      b = b + 2
23002 if (.not.(b .lt. s))goto 23004
      if (.not.(l .eq. 0))goto 23005
      call putlin (blanks, 2)
23005 continue
      if (.not.(form .eq. 48))goto 23007
      call putint (mem (b), 10, 2)
      goto 23008
23007 continue
      if (.not.(form .eq. 97))goto 23009
      call putch (mem (b), 2)
23009 continue
23008 continue
      l = l + 1
      if (.not.(l .ge. lmax))goto 23011
      l = 0
      call putch (10, 2)
23011 continue
23003 b = b + 1
      goto 23002
23004 continue
      if (.not.(l .ne. 0))goto 23013
      call putch (10, 2)
23013 continue
      return
      end

C--------------------------------------------------------------------------
        subroutine ftgknd(iunit,keywrd,nstart,nmax,
     &                    dval,nfound,status)

C       read an array of real*8 values from  header records
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name
C       nstart  i  starting sequence number (usually 1)
C       nmax    i  number of keywords to read
C       OUTPUT PARAMETERS:
C       dval    d  array of output keyword values
C       nfound  i  number of keywords found
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd
        double precision dval(*)
        integer iunit,nstart,nmax,nfound,status,tstat
        integer nkeys,mkeys,i,ival,nend,namlen,indval
        character inname*8,keynam*8
        character*80 rec,value,comm

        if (status .gt. 0)return

C       for efficiency, we want to search just once through the header
C       for all the keywords which match the root.

        nfound=0
        nend=nstart+nmax-1
        inname=keywrd
        call ftupch(inname)

C       find the length of the root name
        namlen=0
        do 5 i=8,1,-1
                if (inname(i:i) .ne. ' ')then
                        namlen=i
                        go to 6
                end if
5       continue
6       if (namlen .eq. 0)return

C       get the number of keywords in the header
        call ftghsp(iunit,nkeys,mkeys,status)

        do 10 i=3,nkeys
                call ftgrec(iunit,i,rec,status)
                if (status .gt. 0)return
                keynam=rec(1:8)
                if (keynam(1:namlen) .eq. inname(1:namlen))then

C                   try to interpret the remainder of the name as an integer
                    tstat=status
                    call ftc2ii(keynam(namlen+1:8),ival,status)
                    if (status .le. 0)then
                        if (ival .le. nend .and. ival .ge. nstart)then
                            call ftpsvc(rec,value,comm,status)
                            indval=ival-nstart+1
                            call ftc2dd(value,dval(indval),status)
                            if (status .gt. 0)then
             call ftpmsg('Error in FTGKND evaluating '//keynam//
     &       ' as a Double: '//value)
                               return
                             else
                               nfound=max(nfound,indval)                   
                             end if
                        end if
                    else
                        if (status .eq. 407)then
                                status=tstat
                        else
                                return
                        end if
                    end if
                end if
10      continue
        end

      SUBROUTINE slVXV (VA, VB, VC)
*+
*     - - - -
*      V X V
*     - - - -
*
*  Vector product of two 3-vectors (single precision)
*
*  Given:
*      VA      real(3)     first vector
*      VB      real(3)     second vector
*
*  Returned:
*      VC      real(3)     vector result
*
*  P.T.Wallace   Starlink   March 1986
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL VA(3),VB(3),VC(3)

      REAL VW(3)
      INTEGER I


*  Form the vector product VA cross VB
      VW(1)=VA(2)*VB(3)-VA(3)*VB(2)
      VW(2)=VA(3)*VB(1)-VA(1)*VB(3)
      VW(3)=VA(1)*VB(2)-VA(2)*VB(1)

*  Return the result
      DO I=1,3
         VC(I)=VW(I)
      END DO

      END

      REAL FUNCTION slPAV ( V1, V2 )
*+
*     - - - -
*      P A V
*     - - - -
*
*  Position angle of one celestial direction with respect to another.
*
*  (single precision)
*
*  Given:
*     V1    r(3)    direction cosines of one point
*     V2    r(3)    direction cosines of the other point
*
*  (The coordinate frames correspond to RA,Dec, Long,Lat etc.)
*
*  The result is the bearing (position angle), in radians, of point
*  V2 with respect to point V1.  It is in the range +/- pi.  The
*  sense is such that if V2 is a small distance east of V1, the
*  bearing is about +pi/2.  Zero is returned if the two points
*  are coincident.
*
*  V1 and V2 do not have to be unit vectors.
*
*  The routine slBEAR performs an equivalent function except
*  that the points are specified in the form of spherical
*  coordinates.
*
*  Called:  slDPAV
*
*  Last revision:   11 September 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL V1(3), V2(3)

      INTEGER I
      DOUBLE PRECISION D1(3), D2(3)

      DOUBLE PRECISION slDPAV


*  Call the double precision version.
      DO I=1,3
         D1(I) = V1(I)
         D2(I) = V2(I)
      END DO
      slPAV = REAL(slDPAV(D1,D2))

      END

      subroutine outdon
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer allblk
      integer itoc, ip, op, i
      integer obuf(80)
      integer sline0(7)
      data sline0(1)/35/,sline0(2)/108/,sline0(3)/105/,sline0(4)/110/,sl
     *ine0(5)/101/,sline0(6)/32/,sline0(7)/-2/
      if (.not.(dbgout .eq. 1))goto 23000
      if (.not.((body .eq. 1 .or. dbglev .ne. level)
     * .and. linect (level) .gt. 0))goto 23002
      op = 1
      ip=1
23004 if (.not.(sline0(ip) .ne. -2))goto 23006
      obuf(op) = sline0(ip)
      op = op + 1
23005 ip=ip+1
      goto 23004
23006 continue
      op = op + itoc (linect, obuf(op), 80-op+1)
      obuf(op) = 32
      op = op + 1
      obuf(op) = 34
      op = op + 1
      i=fnamp-1
23007 if (.not.(i .ge. 1))goto 23009
      if (.not.(fnames(i-1) .eq. -2 .or. i .eq. 1))goto 23010
      ip=i
23012 if (.not.(fnames(ip) .ne. -2))goto 23014
      obuf(op) = fnames(ip)
      op = op + 1
23013 ip=ip+1
      goto 23012
23014 continue
      goto 23009
23010 continue
23008 i=i-1
      goto 23007
23009 continue
      obuf(op) = 34
      op = op + 1
      obuf(op) = 10
      op = op + 1
      obuf(op) = -2
      op = op + 1
      call putlin (obuf, 1)
      dbglev = level
23002 continue
23000 continue
      outbuf (outp + 1) = 10
      outbuf (outp + 2) = -2
      if (.not.(allblk (outbuf) .eq. 0))goto 23015
      call putlin (outbuf, 1)
23015 continue
      outp = 0
      return
      end
c     logic0  logical_column
c     sline0  s_line

      SUBROUTINE CONDET (NDP,XD,YD,NCP,IPC)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C******************************************************************
C*                                                                *
C*   THIS FILE IS A PACKAGE OF SUPPORT ROUTINES FOR THE ULIB      *
C*   FILES CONRAN , CONRAQ AND CONRAS.  SEE THOSE FILES FOR AN    *
C*   EXPLAINATION OF THE ENTRY POINTS.                            *
C*                                                                *
C******************************************************************
C
C THIS SUBROUTINE SELECTS SEVERAL DATA POINTS THAT ARE CLOSEST
C TO EACH OF THE DATA POINT.
C THE INPUT PARAMETERS ARE
C     NDP = NUMBER OF DATA POINTS,
C     XD,YD = ARRAYS CONTAINING THE X AND Y COORDINATES
C             OF DATA POINTS,
C     NCP = NUMBER OF DATA POINTS CLOSEST TO EACH DATA
C           POINTS.
C THE OUTPUT PARAMETER IS
C     IPC = INTEGER ARRAY OF DIMENSION NCP*NDP, WHERE THE
C           POINT NUMBERS OF NCP DATA POINTS CLOSEST TO
C           EACH OF THE NDP DATA POINTS ARE TO BE STORED.
C THIS SUBROUTINE ARBITRARILY SETS A RESTRICTION THAT NCP MUST
C NOT EXCEED 25 WITHOUT MODIFICATION TO THE ARRAYS DSQ0 AND IPC0.
C DECLARATION STATEMENTS
C
      COMMON /CONRA3/ IREC
      DIMENSION       XD(NDP)    ,YD(NDP)    ,IPC(1)
      DIMENSION       DSQ0(25)   ,IPC0(25)
C
        SAVE
C
C STATEMENT FUNCTION
C
      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
C
C CALCULATION
C
      DO  220 IP1=1,NDP
C
C - SELECTS NCP POINTS.
C
         X1 = XD(IP1)
         Y1 = YD(IP1)
         J1 = 0
         DSQMX = 0.0
         DO  110 IP2=1,NDP
            IF (IP2 .EQ. IP1) GO TO  110
            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
            J1 = J1+1
            DSQ0(J1) = DSQI
            IPC0(J1) = IP2
            IF (DSQI .LE. DSQMX) GO TO  100
            DSQMX = DSQI
            JMX = J1
  100       IF (J1 .GE. NCP) GO TO  120
  110    CONTINUE
  120    IP2MN = IP2+1
         IF (IP2MN .GT. NDP) GO TO  150
         DO  140 IP2=IP2MN,NDP
            IF (IP2 .EQ. IP1) GO TO  140
            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
            IF (DSQI .GE. DSQMX) GO TO  140
            DSQ0(JMX) = DSQI
            IPC0(JMX) = IP2
            DSQMX = 0.0
            DO  130 J1=1,NCP
               IF (DSQ0(J1) .LE. DSQMX) GO TO  130
               DSQMX = DSQ0(J1)
               JMX = J1
  130       CONTINUE
  140    CONTINUE
C
C - CHECKS IF ALL THE NCP+1 POINTS ARE COLLINEAR.
C
  150    IP2 = IPC0(1)
         DX12 = XD(IP2)-X1
         DY12 = YD(IP2)-Y1
         DO  160 J3=2,NCP
            IP3 = IPC0(J3)
            DX13 = XD(IP3)-X1
            DY13 = YD(IP3)-Y1
            IF ((DY13*DX12-DX13*DY12) .NE. 0.0) GO TO  200
  160    CONTINUE
C
C - SEARCHES FOR THE CLOSEST NONCOLLINEAR POINT.
C
         NCLPT = 0
         DO  190 IP3=1,NDP
            IF (IP3 .EQ. IP1) GO TO  190
            DO  170 J4=1,NCP
               IF (IP3 .EQ. IPC0(J4)) GO TO  190
  170       CONTINUE
            DX13 = XD(IP3)-X1
            DY13 = YD(IP3)-Y1
            IF ((DY13*DX12-DX13*DY12) .EQ. 0.0) GO TO  190
            DSQI = DSQF(X1,Y1,XD(IP3),YD(IP3))
            IF (NCLPT .EQ. 0) GO TO  180
            IF (DSQI .GE. DSQMN) GO TO  190
  180       NCLPT = 1
            DSQMN = DSQI
            IP3MN = IP3
  190    CONTINUE
         DSQMX = DSQMN
         IPC0(JMX) = IP3MN
C
C - REPLACES THE LOCAL ARRAY FOR THE OUTPUT ARRAY.
C
  200    J1 = (IP1-1)*NCP
         DO  210 J2=1,NCP
            J1 = J1+1
            IPC(J1) = IPC0(J2)
  210    CONTINUE
  220 CONTINUE
      RETURN
      END

      SUBROUTINE slDTFD (IHOUR, IMIN, SEC, DAYS, J)
*+
*     - - - - - -
*      D T F D
*     - - - - - -
*
*  Convert hours, minutes, seconds to days (double precision)
*
*  Given:
*     IHOUR       int       hours
*     IMIN        int       minutes
*     SEC         dp        seconds
*
*  Returned:
*     DAYS        dp        interval in days
*     J           int       status:  0 = OK
*                                    1 = IHOUR outside range 0-23
*                                    2 = IMIN outside range 0-59
*                                    3 = SEC outside range 0-59.999...
*
*  Notes:
*
*     1)  The result is computed even if any of the range checks fail.
*
*     2)  The sign must be dealt with outside this routine.
*
*  P.T.Wallace   Starlink   July 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IHOUR,IMIN
      DOUBLE PRECISION SEC,DAYS
      INTEGER J

*  Seconds per day
      DOUBLE PRECISION D2S
      PARAMETER (D2S=86400D0)



*  Preset status
      J=0

*  Validate sec, min, hour
      IF (SEC.LT.0D0.OR.SEC.GE.60D0) J=3
      IF (IMIN.LT.0.OR.IMIN.GT.59) J=2
      IF (IHOUR.LT.0.OR.IHOUR.GT.23) J=1

*  Compute interval
      DAYS=(60D0*(60D0*DBLE(IHOUR)+DBLE(IMIN))+SEC)/D2S

      END

C 	This routine was copied from the stsdas$pkg/analysis/gasp/gasplib/
C	directory. See stsdas$copyright.stsdas for copyright restrictions.
C
	subroutine fitsvd (x, y, wg, npts, coef, nterms,
     *			  u, v, w, chisq)
	parameter(nmax=1000,mmax=50,tol=1.d-14)

	real   wg(npts)
	real*8 x(npts,nterms), y(npts), coef(nterms), v(nterms,nterms),
     *		u(npts,nterms), w(nterms), b(nmax)
	real*8 wmax, thresh, chisq, sum

	do i=1,npts
		do j=1,nterms
			u(i,j)=x(i,j)*wg(i)
		enddo
		b(i)=y(i)*wg(i)
	enddo
	call dcmpsv (u,npts,nterms,w,v)
	wmax=0.
	do j=1,nterms
		if(w(j).gt.wmax) wmax=w(j)
	enddo
	thresh=tol*wmax
	do j=1,nterms
		if(w(j).lt.thresh) w(j)=0.
	enddo
	call ksbsvd (u, w, v, npts, nterms, b, coef)
	chisq=0.
	do i=1,npts
		sum=0.
		do j=1,nterms
			sum=sum+coef(j)*x(i,j)
		enddo
		chisq=chisq+((y(i)-sum)*wg(i))**2
	enddo
	return
	end

c subroutine quick (dataum, n, index)
c
c
c A quick-sorting algorithm suggested by the discussion on pages 114-119
c of THE ART OF COMPUTER PROGRAMMING, Vol. 3, SORTING AND SEARCHING, by
c D.E. Knuth, which was referenced in Don Wells' subroutine QUIK.  This
c is my own attempt at encoding a quicksort-- PBS.
c
c Arguments
c
c datum (input / output) is a vector of dimension n containing randomly 
c        ordered real data upon input.  Upon output the elements of 
c        dataum will be in order of increasing value.
c
c 
c index (output) is an integer vector of dimension n.  Upon return to
c       the calling program the i-th element of index will tell where
c       the i-th element of the sorted vector datum had been before
c       datum was sorted.
c
c
c
c      parameter (maxstack = 28)
c
c Parameters
c
c maxstack is the maximum number of entries the stack can contain.
c         A limiting stack length of 28 restricts this quicksort 

      subroutine  quick (datum, n, index, ier)
c
      implicit none
      integer n, index(n), ier
      real datum(n)
c
      real dkey
      integer stklo(28), stkhi(28), i, lo, hi, nstak, limlo, limhi, ikey
c
c Initialize error code

      ier = 0
c
c Initialize index.
c
      do 50 i = 1, n
   50 index(i) = i
c
c Initialize the pointers.
c
      nstak = 0
      limlo = 1
      limhi = n
c
  100 dkey = datum(limlo)
      ikey = index(limlo)
c
c Compare all elements in the sub-vector between limlo and limhi with
c the current key datum.
c
      lo = limlo
      hi = limhi
  101 continue
c
      if (lo .eq. hi) go to 200
c
      if (datum(hi) .le. dkey) go to 109
      hi = hi - 1
c
c The pointer hi is to be left pointing at a datum smaller than the
c key, which is intended to be overwritten.
c
      go to 101
c
  109 datum(lo) = datum(hi)
      index(lo) = index(hi)
      lo = lo + 1
  110 continue
c
      if (lo .eq. hi) go to 200
c
      if (datum(lo) .ge. dkey) go to 119
c
      lo = lo + 1
      go to 110
c
  119 datum(hi) = datum(lo)
      index(hi) = index(lo)
      hi = hi - 1
c
c The pointer LO is to be left pointing at a datum LARGER than the
c key, which is intended to be overwritten.
c
      go to 101
c
  200 continue
c
c lo and hi are equal, and point at a value which is intended to
c be overwritten.  Since all values below this point are less than
c the key and all values above this point are greater than the key,
c this is where we stick the key back into the vector.
c
      datum(lo) = dkey
      index(lo) = ikey
c
c At this point in the subroutine, all data between limlo and LO-1, 
c inclusive, are less than datum(LO), and all data between LO+1 and 
c limhi are larger than datum(LO).
c
c If both subarrays contain no more than one element, then take the most
c recent interval from the stack (if the stack is empty, we're done).
c If the larger of the two subarrays contains more than one element, and
c if the shorter subarray contains one or no elements, then forget the 
c shorter one and reduce the other subarray.  If the shorter subarray
c contains two or more elements, then place the larger subarray on the
c stack and process the subarray.
c
      if ((limhi - lo) .gt. (lo - limlo)) go to 300
c
c Case 1:  the lower subarray is longer.  If it contains one or no 
c elements then take the most recent interval from the stack and go 
c back and operate on it.
c
      if ((lo - limlo) .le. 1) go to 400
c
c If the upper (shorter) subinterval contains one or no elements, then
c process the lower (longer) one, but if the upper subinterval contains
c more than one element, then place the lower (longer) subinterval on
c the stack and process the upper one.
c
      if ((limhi - lo) .ge. 2) go to 250
c
c Case 1a:  the upper (shorter) subinterval contains no or one elements,
c so we go back and operate on the lower (longer) subinterval.
c
      limhi = lo - 1
      go to 100
c
  250 continue
c
c Case 1b:  the upper (shorter) subinterval contains at least two 
c elements, so we place the lower (longer) subinterval on the stack and
c then go back and operate on the upper subinterval.
c 
      nstak = nstak + 1
      if (nstak .gt. 28) then
          ier = -1
          return
      endif
      stklo(nstak) = limlo
      stkhi(nstak) = lo - 1
      limlo = lo + 1
      go to 100
c
  300 continue
c
c Case 2:  the upper subarray is longer.  If it contains one or no 
c elements then take the most recent interval from the stack and 
c operate on it.
c
      if ((limhi - lo) .le. 1) go to 400
c
c If the lower (shorter) subinterval contains one or no elements, then
c process the upper (longer) one, but if the lower subinterval contains
c more than one element, then place the upper (longer) subinterval on
c the stack and process the lower one.
c
      if ((lo - limlo) .ge. 2) go to 350
c
c Case 2a:  the lower (shorter) subinterval contains no or one elements,
c so we go back and operate on the upper (longer) subinterval.
c
      limlo = lo + 1
      go to 100
c
  350 continue
c
c Case 2b:  the lower (shorter) subinterval contains at least two 
c elements, so we place the upper (longer) subinterval on the stack and
c then go back and operate on the lower subinterval.
c 
      nstak = nstak + 1
      if (nstak .gt. 28) then
          ier = -1
          return
      endif
      stklo(nstak) = lo + 1
      stkhi(nstak) = limhi
      limhi = lo - 1
      go to 100
c
  400 continue
c
c Take the most recent interval from the stack.  If the stack happens 
c to be empty, we are done.
c
      if (nstak .le. 0) return
      limlo = stklo(nstak)
      limhi = stkhi(nstak)
      nstak = nstak - 1
      go to 100
c
      end

C SUBROUTINE POLFIT.F 
C
C SOURCE
C   BEVINGTON, PAGES 140-142.
C
C PURPOSE
C   MAKE A LEAST-SQUARES FIT TO DATA WITH A POLYNOMIAL CURVE
C      Y = A(1) + A(2)*X + A(3)*X**2 + A(3)*X**3 + . . .
C
C USAGE 
C   CALL POLFIT (X, Y, SIGMAY, NPTS, NTERMS, MODE, A, CHISQR)
C
C DESCRIPTION OF PARAMETERS
C   X	   - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C   Y	   - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C   SIGMAY - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
C   NPTS   - NUMBER OF PAIRS OF DATA POINTS
C   NTERMS - NUMBER OF COEFFICIENTS (DEGREE OF POLYNOMIAL + 1)
C   MODE   - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C	     +1 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
C	      0 (NO WEIGHTING) WEIGHT(I) = 1.
C	     -1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
C   A	   - ARRAY OF COEFFICIENTS OF POLYNOMIAL
C   CHISQR - REDUCED CHI SQUARE FOR FIT 
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   DETERM (ARRAY, NORDER)
C      EVALUATES THE DETERMINANT OF A SYMETRICAL
C      TWO-DIMENSIONAL MATRIX OF ORDER NORDER
C
C COMMENTS
C   DIMENSION STATEMENT VALID FOR NTERMS UP TO 10
C
	SUBROUTINE POLFIT (X,Y,SIGMAY,NPTS,NTERMS,MODE,A,CHISQR)
	DOUBLE PRECISION SUMX,SUMY,XTERM,YTERM,ARRAY,CHISQ
	DIMENSION X(1),Y(1),SIGMAY(1),A(1)
	DIMENSION SUMX(19),SUMY(10),ARRAY(10,10)
C
C ACCUMULATE WEIGHTED SUMS
C
11	NMAX=2*NTERMS-1 
	DO 13 N=1,NMAX
13	SUMX(N)=0.
	DO 15 J=1,NTERMS
15	SUMY(J)=0.
	CHISQ=0.
21	DO 50 I=1,NPTS
	XI=X(I) 
	YI=Y(I) 
31	IF (MODE) 32,37,39
32	IF (YI) 35,37,33
33	WEIGHT=1./YI
	GOTO 41 
35	WEIGHT=1./(-YI) 
	GOTO 41 
37	WEIGHT=1.
	GOTO 41 
39	WEIGHT=1./SIGMAY(I)**2
41	XTERM=WEIGHT
	DO 44 N=1,NMAX
	SUMX(N)=SUMX(N)+XTERM
44	XTERM=XTERM*XI
45	YTERM=WEIGHT*YI 
	DO 48 N=1,NTERMS
	SUMY(N)=SUMY(N)+YTERM
48	YTERM=YTERM*XI
49	CHISQ=CHISQ+WEIGHT*YI**2
50	CONTINUE
C
C CONSTRUCT MATRICES AND CALCULATE COEFFICIENTS 
C
51	DO 54 J=1,NTERMS
	DO 54 K=1,NTERMS
	N=J+K-1 
54	ARRAY(J,K)=SUMX(N)
	DELTA=DETERM (ARRAY,NTERMS)
	IF (DELTA) 61,57,61
57	CHISQR=0.
	DO 59 J=1,NTERMS
59	A(J)=0. 
	GOTO 80 
61	DO 70 L=1,NTERMS
62	DO 66 J=1,NTERMS
	DO 65 K=1,NTERMS
	N=J+K-1 
65	ARRAY(J,K)=SUMX(N)
66	ARRAY(J,L)=SUMY(J)
70	A(L)=DETERM (ARRAY,NTERMS) /DELTA
C
C CALCULATE CHI SQUARE
C
71	DO 75 J=1,NTERMS
	CHISQ=CHISQ-2.*A(J)*SUMY(J)
	DO 75 K=1,NTERMS
	N=J+K-1 
75	CHISQ=CHISQ+A(J)*A(K)*SUMX(N)
76	FREE=NPTS-NTERMS
77	CHISQR=CHISQ/FREE
80	RETURN
	END

include defs

# MAPID -- Map a long identifier.  The new identifier is formed by
# concatenating the first MAXIDLENGTH-1 characters and the last character.


subroutine mapid (name)

character name(MAXTOK)
integer	i

	for (i=1;  name(i) != EOS;  i=i+1)
	    ;
	if (i-1 > MAXIDLENGTH) {
	    name(MAXIDLENGTH) = name(i-1)
	    name(MAXIDLENGTH+1) = EOS
	}
end

include defs

# ERRORC -- Process an error statement.  "call error" already processed.


subroutine errorc (str)

character str(1)
include COMMON_BLOCKS

	xfer = YES
	call outstr (str)
	call balpar			# output "(errcod, errmsg)"
	ername = NO			# just to be safe
	call outdon
	call outtab
	call ogotos (retlab, NO)	# always return after error statement
	call outdon
end

      subroutine shiftb ( ai, ipivot, nrowi, ncoli, last,
     *			  ai1, nrowi1, ncoli1 )
c  shifts the rows in current block, ai, not used as pivot rows, if
c  any, i.e., rows ipivot(last+1),...,ipivot(nrowi), onto the first
c  mmax = nrow-last rows of the next block, ai1, with column last+j of
c  ai  going to column j , j=1,...,jmax=ncoli-last. the remaining col-
c  umns of these rows of ai1 are zeroed out.
c
c			      picture
c
c	original situation after	 results in a new block i+1
c	last = 2 columns have been	 created and ready to be
c	done in factrb (assuming no	 factored by next factrb call.
c	interchanges of rows)
c		    1
c	       x  x 1x	x  x	       x  x  x	x  x
c		    1
c	       0  x 1x	x  x	       0  x  x	x  x
c  block i	    1			    ---------------
c  nrowi = 4   0  0 1x	x  x	       0  0 1x	x  x  0  01
c  ncoli = 5	    1			    1		  1
c  last = 2    0  0 1x	x  x	       0  0 1x	x  x  0  01
c  -------------------------------	    1		  1   new
c		    1x	x  x  x  x	    1x	x  x  x  x1  block
c		    1			    1		  1   i+1
c  block i+1	    1x	x  x  x  x	    1x	x  x  x  x1
c  nrowi1= 5	    1			    1		  1
c  ncoli1= 5	    1x	x  x  x  x	    1x	x  x  x  x1
c  -------------------------------	    1-------------1
c		    1
c
      integer nrowi, ncoli, nrowi1, ncoli1
      integer ipivot(nrowi),last, ip,j,jmax,jmaxp1,m,mmax
      real ai(nrowi,ncoli),ai1(nrowi1,ncoli1)
      mmax = nrowi - last
      jmax = ncoli - last
      if (mmax .lt. 1 .or. jmax .lt. 1) return
c	       put the remainder of block i into ai1
      do 10 m=1,mmax
	 ip = ipivot(last+m)
	 do 10 j=1,jmax
   10	    ai1(m,j) = ai(ip,last+j)
      if (jmax .eq. ncoli1)		return
c	       zero out the upper right corner of ai1
      jmaxp1 = jmax + 1
      do 20 j=jmaxp1,ncoli1
	 do 20 m=1,mmax
   20	    ai1(m,j) = 0.
					return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGCURV (XVEC,IIEX,YVEC,IIEY,NEXY,KDSH)
C
      DIMENSION XVEC(1),YVEC(1)
C
C AGCURV plots the curve defined by the points ((X(I),Y(I)),I=1,NEXY),
C where, if the primary parameter 'INVERT.' is zero,
C
C    X(I)=XVEC(1+(I-1)*IIEX) (unless IIEX=0, in which case X(I)=I), and
C    Y(I)=YVEC(1+(I-1)*IIEY) (unless IIEY=0, in which case Y(I)=I).
C
C If 'INVERT.' is non-zero, the definitions are interchanged, so that
C
C    X(I)=YVEC(1+(I-1)*IIEY) (unless IIEY=0, in which case X(I)=I), and
C    Y(I)=XVEC(1+(I-1)*IIEX) (unless IIEX=0, in which case Y(I)=I).
C
C If, for some I, X(I)=SVAL or Y(I)=SVAL, curve line segments having
C (X(I),Y(I)) as an endpoint are omitted.
C
C If the primary parameter 'WINDOW.' is zero, AGKURV is called; it does
C no windowing.  If 'WINDOW.' is non-zero, AGQURV is called; it omits
C portions of the curve which fall outside the current curve window.
C
C The argument KDSH specifies the dash pattern to be used.  If KDSH is
C negative, the function MOD(IABS(KDSH),26) is used to select a solid
C line interrupted by one of the alphabetic characters.  If KDSH is
C zero, the user is assumed to have done his own DASHD call.  If KDSH
C is positive, the function MOD(KDSH,NODP) is used to select one of the
C dash patterns in the parameter group 'DASH/PATTERNS.'.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C Declare the block data routine external to force it to load.
C
C +NOAO
C     EXTERNAL AGDFLT
C -NOAO
C
C DASH receives alphabetic dash patterns.
C
      CHARACTER*10 DASH
C
C ALPH contains an alphabet.
C
      CHARACTER*26 ALPH
C
      DATA ALPH / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
C
C +NOAO - replace blockdata with run time initialization.
      call agdflt
C -NOAO
C
C Check for an alphabetic dash pattern.
C
      IF (KDSH.LT.0) THEN
        IDSH=MOD(-KDSH-1,26)+1
        IPSN=MOD(3*IDSH-1,10)+1
        DASH='$$$$$$$$$$'
        DASH(IPSN:IPSN)=ALPH(IDSH:IDSH)
        CALL AGSTCH (DASH,10,IDCS)
        CALL AGDASH (FLOAT(IDCS),WODQ,WOCD,SCWP)
        CALL AGDLCH (IDCS)
C
C Check for a dash pattern from the group "DASH/PATTERNS."
C
      ELSE IF (KDSH.GT.0) THEN
        IDSH=MOD(KDSH-1,IFIX(QODP))+1
        CALL AGDASH (QDSH(IDSH),WODQ,WOCD,SCWP)
C
      END IF
C
C Now that the dash pattern is determined, do the SET call.
C
      CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,
     +                            1+IABS(IFIX(QLUX))*2+IABS(IFIX(QLUY)))
C
C Give the user a chance to modify the curve (by changing line style,
C color, etc.).
C
      CALL AGCHCU (0,KDSH)
C
C Decide whether AGKURV or AGQURV is to draw the curve.
C
      IF (QWND.EQ.0.) THEN
C
C No windowing requested - AGKURV is used.
C
        IF (QIXY.EQ.0.) THEN
          CALL AGKURV (XVEC,IIEX,YVEC,IIEY,NEXY,SVAL(1))
        ELSE
          CALL AGKURV (YVEC,IIEY,XVEC,IIEX,NEXY,SVAL(1))
        END IF
C
      ELSE
C
C Windowing requested - AGQURV is used.
C
        IF (QIXY.EQ.0.) THEN
          CALL AGQURV (XVEC,IIEX,YVEC,IIEY,NEXY,SVAL(1))
        ELSE
          CALL AGQURV (YVEC,IIEY,XVEC,IIEX,NEXY,SVAL(1))
        END IF
C
      END IF
C
C Give the user a chance to change back what he changed above.
C
      CALL AGCHCU (1,KDSH)
C
C Done.
C
      RETURN
C
      END

include	defs

# concat - concatenate two strings together

   subroutine concat (buf1, buf2, outstr)
   character buf1(ARB), buf2(ARB), outstr(ARB)

   integer i

   i = 1
   call stcopy (buf1, 1, outstr, i)
   call scopy (buf2, 1, outstr, i)

   return
   end

      subroutine splint ( tau, gtau, t, n, k, q, bcoef, iflag )
c  from  * a practical guide to splines *  by c. de boor
calls bsplvb, banfac/slv
c
c   splint  produces the b-spline coeff.s  bcoef  of the spline of order
c   k  with knots  t(i), i=1,..., n + k , which takes on the value
c   gtau(i) at	tau(i), i=1,..., n .
c
c******  i n p u t  ******
c  tau.....array of length  n , containing data point abscissae.
c    a s s u m p t i o n . . .	tau  is strictly increasing
c  gtau.....corresponding array of length  n , containing data point or-
c	 dinates
c  t.....knot sequence, of length  n+k
c  n.....number of data points and dimension of spline space  s(k,t)
c  k.....order of spline
c
c******  o u t p u t  ******
c  q.....array of size	(2*k-1)*n , containing the triangular factoriz-
c	 ation of the coefficient matrix of the linear system for the b-
c	 coefficients of the spline interpolant.
c	    the b-coeffs for the interpolant of an additional data set
c	 (tau(i),htau(i)), i=1,...,n  with the same data abscissae can
c	 be obtained without going through all the calculations in this
c	 routine, simply by loading  htau  into  bcoef	and then execut-
c	 ing the    call banslv ( q, 2*k-1, n, k-1, k-1, bcoef )
c  bcoef.....the b-coefficients of the interpolant, of length  n
c  iflag.....an integer indicating success (= 1)  or failure (= 2)
c	 the linear system to be solved is (theoretically) invertible if
c	 and only if
c	       t(i) .lt. tau(i) .lt. tau(i+k),	  all i.
c	 violation of this condition is certain to lead to  iflag = 2 .
c
c******  m e t h o d  ******
c     the i-th equation of the linear system  a*bcoef = b  for the b-co-
c  effs of the interpolant enforces interpolation at  tau(i), i=1,...,n.
c  hence,  b(i) = gtau(i), all i, and  a  is a band matrix with  2k-1
c   bands (if it is invertible).
c     the matrix  a  is generated row by row and stored, diagonal by di-
c  agonal, in the  r o w s  of the array  q , with the main diagonal go-
c  ing into row  k .  see comments in the program below.
c     the banded system is then solved by a call to  banfac (which con-
c  structs the triangular factorization for  a	and stores it again in
c   q ), followed by a call to	banslv (which then obtains the solution
c   bcoef  by substitution).
c     banfac  does no pivoting, since the total positivity of the matrix
c  a  makes this unnecessary.
c
      integer iflag,k,n,   i,ilp1mx,j,jj,km1,kpkm2,left,lenq,np1
      real bcoef(n),gtau(n),q(1),t(1),tau(n),	taui
c     dimension q(2*k-1,n), t(n+k)
current fortran standard makes it impossible to specify precisely the
c  dimension of  q  and  t  without the introduction of otherwise super-
c  fluous additional arguments.
      np1 = n + 1
      km1 = k - 1
      kpkm2 = 2*km1
      left = k
c		 zero out all entries of q
      lenq = n*(k+km1)
      do 5 i=1,lenq
    5	 q(i) = 0.
c
c  ***	 loop over i to construct the  n  interpolation equations
      do 30 i=1,n
	 taui = tau(i)
	 ilp1mx = min0(i+k,np1)
c	 *** find  left  in the closed interval (i,i+k-1) such that
c		 t(left) .le. tau(i) .lt. t(left+1)
c	 matrix is singular if this is not possible
	 left = max0(left,i)
	 if (taui .lt. t(left)) 	go to 998
   15	    if (taui .lt. t(left+1))	go to 16
	    left = left + 1
	    if (left .lt. ilp1mx)	go to 15
	 left = left - 1
	 if (taui .gt. t(left+1))	go to 998
c	 *** the i-th equation enforces interpolation at taui, hence
c	 a(i,j) = b(j,k,t)(taui), all j. only the  k  entries with  j =
c	 left-k+1,...,left actually might be nonzero. these  k	numbers
c	 are returned, in  bcoef (used for temp.storage here), by the
c	 following
   16	 call bsplvb ( t, k, 1, taui, left, bcoef )
c	 we therefore want  bcoef(j) = b(left-k+j)(taui) to go into
c	 a(i,left-k+j), i.e., into  q(i-(left+j)+2*k,(left+j)-k) since
c	 a(i+j,j)  is to go into  q(i+k,j), all i,j,  if we consider  q
c	 as a two-dim. array , with  2*k-1  rows (see comments in
c	 banfac). in the present program, we treat  q  as an equivalent
c	 one-dimensional array (because of fortran restrictions on
c	 dimension statements) . we therefore want  bcoef(j) to go into
c	 entry
c	     i -(left+j) + 2*k + ((left+j) - k-1)*(2*k-1)
c		    =  i-left+1 + (left -k)*(2*k-1) + (2*k-2)*j
c	 of  q .
	 jj = i-left+1 + (left-k)*(k+km1)
	 do 30 j=1,k
	    jj = jj+kpkm2
   30	    q(jj) = bcoef(j)
c
c     ***obtain factorization of  a  , stored again in	q.
      call banfac ( q, k+km1, n, km1, km1, iflag )
					go to (40,999), iflag
c     *** solve  a*bcoef = gtau  by backsubstitution
   40 do 41 i=1,n
   41	 bcoef(i) = gtau(i)
      call banslv ( q, k+km1, n, km1, km1, bcoef )
					return
  998 iflag = 2
  999 return
c 999 print 699
c 699 format(41h linear system in  splint  not invertible)
c					return
      end

      SUBROUTINE NLCFIT(IM,INN,IN,INTA,XEPSI,XV,XYD)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     NONLINEAR LEAST SQUARES FITTING USING SIMPLEX
C     METHOD AND QUADRATIC APPROXIMATION.
C     WITH LINEAR PARAMETER ELIMINATION.
C-------------------------------------------------------------
      INTEGER IM,INN,IN,INTA
      REAL XEPSI,XV(IM),XYD(IM)
      COMMON /NLC/ EPSI,IFLAG,IL,IQ,INDEX,F(15,120),M,N
      COMMON /NLC/ SOLD,Y(20),YVAL,XF(11),X(11,11),V(120),YD(120,10)
      COMMON /NLC/ GG(11,11),GINV(11,11),EM(15,120),BB(5),NT
      COMMON /NLC/ GA(120,5),NN
	COMMON /NLCOUT/ FF(120),PARS(10),BPARS(10)
      DIMENSION SUMC(11),XC(11),XE(11),XCO(11),XR(11)
      REAL LERROR
C-----
C RESET ERROR HANDLER
c...UNIX has general handler only!
c	call trpfpe (0, 0d0)
C-----
C FLOAT OVERFLOW
c	CALL ERRSET(72,.TRUE.,.FALSE.,.FALSE.,.FALSE.,15)
C FLOAT UNDERFLOW
c	CALL ERRSET(74,.TRUE.,.FALSE.,.FALSE.,.FALSE.,15)
C EXP TOO SMALL
c	CALL ERRSET(89,.TRUE.,.FALSE.,.FALSE.,.FALSE.,15)
C EXP TOO LRGE
c	CALL ERRSET(88,.TRUE.,.FALSE.,.FALSE.,.FALSE.,15)
C-----
      LERROR=1.E30
	IFLAG=0
C     COEFFICIENTS
C-----
C ASSIGN EXTERNAL PARAMETERS
	M=IM
	NN=INN
	N=IN
	NT=INTA
	EPSI=XEPSI
	DO 8100 I=1,M
		V(I)=XV(I)
		YD(I,1)=XYD(I)
8100	CONTINUE
C-----
      T=1.0
      A=1.0
      B=0.5
      G=2.0
      ICOUNT=0
      INDEX=1
      IQ=3*N
      DO 140 J=1,N
140   X(1,J)=1.0
160   DO 172 J=1,N
172   XF(J)=X(1,J)
      CALL FVAL
      Y(1)=YVAL
      SOLD=YVAL
C---- CONSTRUCT SIMPLEX
      EN=N
      PN=(SQRT(EN+1.0)-1.0+EN)/(EN*SQRT(2.0))*T
      QN=(SQRT(EN+1.0)-1.0)/(EN*SQRT(2.0))*T
      NP1=N+1
      DO 305 I=2,NP1
      INDEX=I
      DO 300 J=1,N
      EJ=0.0
      EI=0.0
      IF(I-1.NE.J) EJ=1.0
      IF(I-1.EQ.J) EI=1.0
      X(I,J)=X(1,J)+EI*PN+EJ*QN
300   XF(J)=X(I,J)
      CALL FVAL
305   Y(I)=YVAL
C---- DETERMINE MAX XH
310   IH=1
      DO 350 J=1,NP1
      IF(Y(IH).GE.Y(J)) GOTO 350
      IH=J
350   CONTINUE
C---- DETERMINE SECOND MAX XS
      IS=1
      IF(IH.NE.1) GOTO 470
      IS=2
470   CONTINUE
      DO 420 J=1,NP1
      IF(J.EQ.IH) GOTO 420
      IF(Y(IS).GE.Y(J)) GOTO 420
      IS=J
420   CONTINUE
C---- DETERMINE MIN XL
      IL=1
      DO 480 J=1,NP1
      IF(Y(IL).LE.Y(J)) GOTO 480
      IL=J
480   CONTINUE
C---- COMPUTE CENTROID
      DO 510 J=1,N
510   SUMC(J)=0.0
      EN=N
      DO 570 J=1,N
      DO 560 I=1,NP1
      IF(I.EQ.IH) GOTO 560
      SUMC(J)=SUMC(J)+X(I,J)
560   CONTINUE
570   XC(J)=1.0/EN*SUMC(J)
      DO 573 J=1,N
573   XF(J)=XC(J)
      CALL FVAL
      YBAR=YVAL
      SUM=0.0
      DO 577 I=1,NP1
  577 SUM = SUM + ((Y(I)-YBAR)/YBAR)**2
      ICOUNT=ICOUNT+1
      ERROR=SQRT(SUM/EN)
      IQ=IQ-1
      IF(IQ.EQ.-1) CALL QADFIT
      IF(IFLAG.EQ.1) GOTO 1990
      IF(ERROR.LE.EPSI) GOTO 1990
      IF(ABS(LERROR-ERROR).LT.EPSI) GO TO 1990
      LERROR=ERROR
C---- DO A REFLECTION
      DO 600 J=1,N
600   XR(J)=(1.0+A)*XC(J)-A*X(IH,J)
      DO 610 J=1,N
610   XF(J)=XR(J)
      INDEX=N+2
      CALL FVAL
      YXR=YVAL
      IF(YXR.GE.Y(IL)) GOTO 750
C---- DO A EXPANSION
      DO 660 J=1,N
660   XE(J)=G*XR(J)+(1.0-G)*XC(J)
      DO 680 J=1,N
680   XF(J)=XE(J)
      INDEX=N+3
      CALL FVAL
      YXE=YVAL
      IF(YXE.GT.Y(IL)) GOTO 760
      DO 730 J=1,N
730   X(IH,J)=XE(J)
      Y(IH)=YXE
      NP3=N+3
      DO 735 K=1,M
735   F(IH,K)=F(NP3,K)
      GOTO 310
750   IF(YXR.GT.Y(IS)) GOTO 800
760   DO 780 J=1,N
780   X(IH,J)=XR(J)
      Y(IH)=YXR
      NP2=N+2
      DO 785 K=1,M
785   F(IH,K)=F(NP2,K)
      GOTO 310
800   IF(YXR.GT.Y(IH)) GOTO 830
      DO 820 J=1,N
820   X(IH,J)=XR(J)
C---- DO A CONTRACTION
830   DO 840 J=1,N
840   XCO(J)=B*X(IH,J)+(1.0-B)*XC(J)
      DO 860 J=1,N
860   XF(J)=XCO(J)
      INDEX=N+2
      CALL FVAL
      YXCO=YVAL
      IF(YXCO.GT.Y(IH)) GOTO 930
      DO 910 J=1,N
910   X(IH,J)=XCO(J)
      Y(IH)=YXCO
      NP2=N+2
      DO 915 K=1,M
915   F(IH,K)=F(NP2,K)
      GOTO 310
930   DO 960 I=1,NP1
      INDEX=I
      DO 955 J=1,N
950   X(I,J)=0.5*(X(I,J)+X(IL,J))
955   XF(J)=X(I,J)
      CALL FVAL
960   Y(I)=YVAL
C---- HAS A MIN BEEN REACHED?
      GOTO 310
1990  DO 1594 J=1,N
	PARS(J)=X(IL,J)
1594  XF(J)=X(IL,J)
      CALL FVAL
	DO 1595 I=1,NT
1595	BPARS(I)=BB(I)
      CALL INDEXD
	RETURN
      END
C---------------------------------------------------------------------
      SUBROUTINE MATIN
C---- DETERMINE INVERSE OF MATRIX
      COMMON /NLC/ EPSI,IFLAG,IL,IQ,INDEX,F(15,120),M,N
      COMMON /NLC/ SOLD,Y(20),YVAL,XF(11),X(11,11),V(120),YD(120,10)
      COMMON /NLC/ GG(11,11),GINV(11,11),EM(15,120),BB(5),NT
      COMMON /NLC/ GA(120,5),NN
      DIMENSION E(15,120),EN(20),T(20),Z(11,11),YY(20)
      EQUIVALENCE (EM(1,1),E(1,1))
      DO 20 I=1,N
      DO 20 J=1,N
      IF(I.EQ.J) GOTO 10
      Z(I,J)=0.0
      GOTO 20
10    Z(I,J)=1.0
20    CONTINUE
      DO 120 J0=1,N
      I0=J0
      DO 30 I=1,N
30    YY(I)=GG(I,J0)
      DO 40 I=1,N
      EN(I) = 0.
      T(I)=0.0
      DO 40 J=1,N
40    T(I)=T(I)+Z(I,J)*YY(J)
      IF(T(J0).EQ.0.) GO TO 65
      DO 60 J=1,N
      IF(J.EQ.J0) GOTO 50
      EN(J)=-T(J)/T(J0)
      GOTO 60
50    EN(J)=1./T(J0)
60    CONTINUE
   65 DO 80 I = 1,N
      DO 80 J=1,N
      IF (I.EQ.J) GOTO 70
      E(I,J)=0.0
      GOTO 80
70    E(I,J)=1.0
80    CONTINUE
      DO 90 J=1,N
90    E(J,J0)=EN(J)
      DO 100 K=1,N
      DO 100 I=1,N
      GINV(K,I)=0.0
      DO 100 J=1,N
100   GINV(K,I)=GINV(K,I)+E(K,J)*Z(J,I)
      DO 110 J=1,N
      DO 110 I=1,N
110   Z(I,J)=GINV(I,J)
120   CONTINUE
      RETURN
      END
C-------------------------------------------------------------------------
      SUBROUTINE QADFIT
      COMMON /NLC/ EPSI,IFLAG,IL,IQ,INDEX,F(15,120),M,N
      COMMON /NLC/ SOLD,Y(20),YVAL,XF(11),X(11,11),V(120),YD(120,10)
      COMMON /NLC/ GG(11,11),GINV(11,11),EM(15,120),BB(5),NT
      COMMON /NLC/ GA(120,5),NN
      DIMENSION A(11,11),DELX(20),E(20),F0(20)
      NP1=N+1
C---- QUADRATIC COEFFICIENTS
      II=0
      DO 30 K=1,M
      II=0
      DO 30 I=1,NP1
      IF(I.EQ.IL) GOTO 30
      II=II+1
      EM(II,K)=F(I,K)-F(IL,K)
30    CONTINUE
      DO 50 I=1,N
      F0(I)=0.0
      DO 50 K=1,M
50    F0(I)=F0(I)-F(IL,K)*EM(I,K)
C---- ELEMENTS OF THE MATRIX GAMMA,G
      DO 70 I=1,N
      DO 70 J=1,N
      GG(I,J)=0.0
      DO 70 K=1,M
70    GG(I,J)=GG(I,J)+EM(I,K)*EM(J,K)
      CALL MATIN
      DO 80 I=1,N
      E(I)=0.0
      DO 80 J=1,N
80    E(I)=E(I)+GINV(I,J)*F0(J)
C---- DEFINE THE SCALING MATRIX A
      II=0
      DO 101 I=1,NP1
      IF(I.EQ.IL) GOTO 101
      II=II+1
      DO 100 J=1,N
      A(II,J)=X(I,J)-X(IL,J)
100   CONTINUE
101   CONTINUE
C---- DETERMINE DEL X
      DO 110 I=1,N
      DELX(I)=0.0
      DO 110 J=1,N
110   DELX(I)=DELX(I)+A(J,I)*E(J)
      DO 120 J=1,N
120   XF(J)=X(IL,J)+DELX(J)
      INDEX=N+2
      CALL FVAL
      IF(Y(IL).LT.YVAL) GOTO 140
      TEMP=ABS(1-SOLD/YVAL)
      IF(TEMP.EQ.1) GOTO 150
      IF(TEMP.LE.EPSI) GOTO 150
      SOLD=YVAL
      DO 130 J=1,N
130   X(IL,J)=XF(J)
      NP2=N+2
      DO 135 K=1,M
135   F(IL,K)=F(NP2,K)
      IFLAG=2
      IQ=(3*N)/2
      GOTO 160
140   IFLAG=2
      IQ=3*N
      GOTO 160
150   IFLAG=1
      DO 155 J=1,N
155   X(IL,J)=XF(J)
      Y(IL)=YVAL
160   RETURN
      END
C----------------------------------------------------------------------
      SUBROUTINE  INDEXD
      COMMON /NLC/ EPSI,IFLAG,IL,IQ,INDEX,F(15,120),M,N
      COMMON /NLC/ SOLD,Y(20),YVAL,XF(11),X(11,11),V(120),YD(120,10)
      COMMON /NLC/ GG(11,11),GINV(11,11),EM(15,120),BB(5),NT
      COMMON /NLC/ GA(120,5),NN
	COMMON /NLCOUT/ FF(120),PARS(10),BPARS(10)
      SUM=0.0
      DO 200 I=1,M
200   SUM=SUM+V(I)
      XM=M
      YBAR=SUM/XM
      SST=0.0
      DO 240 I=1,M
240   SST=SST+(V(I)-YBAR)**2
      SSR=0.0
      DO 280 I=1,M
      FF(I)=0.0
      DO 260  J=1,NT
260   FF(I)=BB(J)*GA(I,J)+FF(I)
280   SSR=SSR+(FF(I)-V(I))**2
      XINDX=1-SSR/SST
      SIGMAR=SQRT(SSR/XM)
      DO 300 I=1,M
      DIFF=FF(I)-V(I)
      IF(V(I).EQ.0.) GO TO 295
      DIFF = DIFF*100./V(I)
      GO TO 300
295   DIFF=0.
300   CONTINUE
C
C----  WRITE(1) (FF(I),I=1,M)
C----  WRITE(1) (V(I),I=1,M)
      RETURN
      END
C---------------------------------------------------------------------------
      SUBROUTINE FVAL
      COMMON /NLC/ EPSI,IFLAG,IL,IQ,INDEX,F(15,120),M,N
      COMMON /NLC/ SOLD,Y(20),YVAL,XF(11),X(11,11),V(120),YD(120,10)
      COMMON /NLC/ GG(11,11),GINV(11,11),EM(15,120),BB(5),NT
      COMMON /NLC/ GA(120,5),NN
      DIMENSION GTGA(11,11),GT(5,120),GGG(5,120),B(5)
      DIMENSION G(120,5),A(11),TR(5),XP(11)
      EQUIVALENCE (GG(1,1),GTGA(1,1)),(BB(1),B(1)),(XF(1),A(1)),
     *(G(1,1),GA(1,1))
      DO 200 I=1,M
      DO 100 J=1,NN
100   XP(J)=YD(I,J)
C
C---- LOCATION OF TRANSFORMS
      CALL TRANS(TR,A,XP)
C
      DO 110 J=1,NT
110   GA(I,J)=TR(J)
200   CONTINUE
      DO 230 J=1,NT
      DO 230 I=1,M
230   GT(J,I)=GA(I,J)
      DO 280 K=1,NT
      DO 280 I=1,NT
      GTGA(K,I)=0.0
      DO 280 J=1,M
280   GTGA(K,I)=GTGA(K,I)+GT(K,J)*GA(J,I)
      HOLD=N
      N=NT
      CALL MATIN
      N=HOLD
      DO 350 K=1,NT
      DO 350 I=1,M
      GGG(K,I)=0.0
      DO 350 J=1,NT
350   GGG(K,I)=GGG(K,I)+GINV(K,J)*GT(J,I)
      DO 400 K=1,NT
      B(K)=0.0
      DO 400 J=1,M
400   B(K)=B(K)+GGG(K,J)*V(J)
      YVAL=0.0
      DO 460 I=1,M
      FF=0.0
      DO 240 J=1,NT
240   FF=B(J)*GA(I,J)+FF
      F(INDEX,I)=V(I)-FF
460   YVAL=(V(I)-FF)**2+YVAL
      RETURN
      END

C--------------------------------------------------------------------------
        subroutine ftesum(sum,complm,string)

C       encode the 32 bit checksum by converting every 
C       2 bits of each byte into an ASCII character (32 bit word encoded 
C       as 16 character string).   Only ASCII letters and digits are used
C       to encode the values (no ASCII punctuation characters).

C       If complm=.true., then the complement of the sum will be encoded.

C       This Fortran algorithm is based on the C algorithm developed by Rob
C       Seaman at NOAO that was presented at the 1994 ADASS conference, to be 
C       published in the Astronomical Society of the Pacific Conference Series.
C     
C       sum     d  checksum value 
C       complm  l  encode the complement of the sum?
C       string  c  output ASCII encoded check sum
C
C       written by Wm Pence, HEASARC/GSFC, Sept, 1994

        double precision sum,tmpsum,all32
        character*16 string,tmpstr
        integer offset,exclud(13),nbyte(4),ch(4),i,j,k
        integer quot,remain,check,nc
        logical complm

C       all32 equals a 32 bit unsigned integer with all bits set
        parameter (all32=4.294967295D+09)

C       ASCII 0 is the offset value
        parameter (offset=48)

C       this is the list of ASCII punctutation characters to be excluded
        data exclud/58,59,60,61,62,63,64,91,92,93,94,95,96/

        if (complm)then
C           complement the 32-bit unsigned integer equivalent (flip every bit)
            tmpsum=all32-sum
        else
            tmpsum=sum
        end if
                           
C       separate each 8-bit byte into separate integers
        nbyte(1)=tmpsum/16777216.
        tmpsum=tmpsum-nbyte(1)*16777216.
        nbyte(2)=tmpsum/65536.
        tmpsum=tmpsum-nbyte(2)*65536.
        nbyte(3)=tmpsum/256.
        nbyte(4)=tmpsum-nbyte(3)*256.

C       encode each 8-bit integer as 4-characters 
        do 100 i=1,4
                quot=nbyte(i)/4+offset
                remain=nbyte(i) - (nbyte(i)/4*4)
                ch(1)=quot+remain
                ch(2)=quot
                ch(3)=quot
                ch(4)=quot

C               avoid ASCII punctuation characters by incrementing and
C               decrementing adjacent characters thus preserving checksum value
10              check=0
                    do 30 k=1,13
                        do 20 j=1,4,2
                           if (ch(j)   .eq. exclud(k) .or.
     &                         ch(j+1) .eq. exclud(k))then
                               ch(j)=ch(j)+1
                               ch(j+1)=ch(j+1)-1
                               check=1
                           end if
20                      continue
30                  continue

C               keep repeating, until all punctuation character are removed
                if (check .ne. 0)go to 10

C               convert the byte values to the equivalent ASCII characters
                do 40 j=0,3
                    nc=4*j+i
                    tmpstr(nc:nc)=char(ch(j+1))
40              continue
100     continue

C       shift the characters 1 place to the right, since the FITS character
C       string value starts in column 12, which is not word aligned
        string(2:16)=tmpstr(1:15)
        string(1:1)=tmpstr(16:16)

C       convert characters from ASCII codes to machine's native character
C       coding sequence.  (The string gets converted back to ASCII when it
C       is written to the FITS file). This only affects IBM mainframe computers 
C       that do not use ASCII for the internal character representation.
        call ftas2c(string,16)
        end

c function ploren.f
c
c source
c   Bevington, page 51.
c
c purpose
c   evaluate lorentzian probability function
c
c usage
c   result = ploren (x, averag, width)
c
c description of parameters
c   x      - value for which probability is to be evaluated
c   averag - mean of distribution
c   width  - full width at half maximum of distribution
c
c subroutines and function subprograms required
c   none
c
	function ploren (x,averag,width)
1	ploren=0.1591549431*width/((x-averag)**2+(width/2.)**2)
	return
	end

      integer function strim (str)
      integer str (100)
      integer lnb, i
      lnb = 0
      i = 1
23000 if (.not.(str (i) .ne. -2))goto 23002
      if (.not.(str (i) .ne. 32 .and. str (i) .ne. 9))goto 23003
      lnb = i
23003 continue
23001 i = i + 1
      goto 23000
23002 continue
      str (lnb + 1) = -2
      strim=(lnb)
      return
      end

      SUBROUTINE CONOP1 (IOPT)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
        COMMON /RASINT/ IRASMJ, IRASMN, IRASTX
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
C
        SAVE
C
c +NOAO - initialize block data before changing any values
        call conbdn
c -NOAO
C  DETERMINE OPTION AND ITS VALUE
C
        TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
                OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  REP FOUND CHECK VALUE OF SWITCH
C
      IF (TAG .EQ. 'RE') THEN
C
C  SWITCH = ON CONTOUR SAME DATA
C
            IF (OPT .EQ. 'ON') THEN
              REPEAT = .TRUE.
              RETURN
C
C  SWITCH = OFF CONTOUR NEW DATA
C
            ELSEIF (OPT .EQ. 'OF') THEN
              REPEAT = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  EXTRAPOLATION FLAG
C
      ELSEIF (TAG .EQ. 'EX') THEN
C
C  SWITCH = ON EXTRAPOLATE WHEN CONTOURING
C
            IF (OPT .EQ. 'ON') THEN
              EXTRAP = .TRUE.
              RETURN
C
C  SWITCH = OFF INTERPOLATE ONLY
C
            ELSEIF (OPT .EQ. 'OF') THEN
              EXTRAP = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  PER FOUND SET PERIMETER
C
      ELSEIF (TAG .EQ. 'PE') THEN
C
C  SWITCH = ON DRAW PERIMETERS
C
            IF (OPT .EQ. 'ON') THEN
              PER = .TRUE.
C
C  TURN GRID OFF, USER WANTS PERIMETER
C
             GRD = .FALSE.
             RETURN
C
C  SWITCH = OFF DO NOT DRAW PERIMETERS
C
            ELSEIF (OPT .EQ. 'OF') THEN
             PER = .FALSE.
             RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  DEF FOUND SET ALL OPTIONS TO DEFAULT (NO SWITCHES)
C
        ELSEIF (TAG .EQ. 'DE') THEN
      PER = .TRUE.
      LISTOP = .FALSE.
      PMIMX = .FALSE.
      SCALE = 1.
      TENSN = TENS
      EXTRAP = .FALSE.
      TITLE = .FALSE.
      ITLSIZ = 16
      REPEAT = .FALSE.
      MESS = .TRUE.
      CON = .FALSE.
      CINC = .FALSE.
      CHILO = .FALSE.
      IGRAD = IG
      ISCALE = 0
      NCP = 4
      LOOK = .FALSE.
      GRD = .FALSE.
      PLDVLS = .FALSE.
      INMAJ = 1
      INMIN = 1
      INDAT = 1
      INLAB = 1
      IRANMJ = 1
      IRANMN = 1
      IRANTX = 1
      IRASMJ = 1
      IRASMN = 1
      IRASTX = 1
      IRAQMJ = 1
      IRAQMN = 1
      IRAQTX = 1
      BPSIZ = 0.
      LABON = .TRUE.
      ISIZEL = 9
      ISIZEP = 8
      ISIZEM = 15
      FRADV = .TRUE.
      EXTRI = .FALSE.
      MINGAP = 3
      LINEAR = .FALSE.
      ICOUNT = 0
      SHIELD = .FALSE.
      SLDPLT = .FALSE.
C
C  SET DEFAULT DASH PATTERN
C
         IDASH = '$$$$$$$$$$'
         NDASH = '$$$$$$$$$$'
         EDASH = '$$$$$$$$$$'
C
C  SET DEFAULT FORMAT
C
         FORM = '(G10.3)'
      RETURN
C
C  MES FOUND TEST VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'ME') THEN
C
C  ACTIVATE CONRAN MESSAGE
C
            IF (OPT .EQ. 'ON') THEN
              MESS = .TRUE.
              RETURN
C
C  TURN OFF CONRAN MESSAGE
C
            ELSEIF (OPT .EQ. 'OF') THEN
              MESS = .FALSE.
              RETURN
          ELSE
                  GOTO 120
          ENDIF
C
C  SCALING OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'SC') THEN
C
C  SET VALUE OF SCALE FLAG
C
            IF (OPT .EQ. 'ON') THEN
                  ISCALE = 0
                  RETURN
            ELSEIF (OPT .EQ. 'OF') THEN
                  ISCALE = 1
                  RETURN
            ELSEIF (OPT .EQ. 'PR') THEN
                  ISCALE = 2
                  RETURN
            ELSE
                  GOTO 120
            ENDIF
C
C  TRIANGLE FLAG GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'TR') THEN
C
C  SWITCH ON
C
            IF (OPT .EQ. 'ON') THEN
              LOOK = .TRUE.
              RETURN
C
C  SWITCH OFF
C
          ELSEIF (OPT .EQ. 'OF') THEN
              LOOK = .FALSE.
              RETURN
          ELSE
                  GOTO 120
          ENDIF
C
C  PLOT DATA VALUES FLAG GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'PD') THEN
C
C SWITCH ON
C
            IF (OPT .EQ. 'ON') THEN
              PLDVLS = .TRUE.
              RETURN
C
C  SWITCH OFF
C
            ELSEIF (OPT .EQ. 'OF') THEN
              PLDVLS = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  GRID OPTION ACTIVATED GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'GR') THEN
C
C  SWITCH ON SET GRID FLAG
C
            IF (OPT .EQ. 'ON') THEN
              GRD = .TRUE.
C
C  TURN PER OFF USER WANTS GRID
C
              PER = .FALSE.
              RETURN
C
C  SWITCH OFF CLEAR GRID FLAG
C
            ELSEIF (OPT .EQ. 'OF') THEN
              GRD = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  LABEL PLOTTING FLAG GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'LA') THEN
C
C  SWITCH ON LABEL CONTOURS
C
            IF (OPT .EQ. 'ON') THEN
              LABON = .TRUE.
                RETURN
C
C  SWITCH OFF DON"T LABEL CONTOURS
C
            ELSEIF (OPT .EQ. 'OF') THEN
              LABON = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  PLOT THE RELATIVE MIN"S AND MAX"S
C
      ELSEIF (TAG .EQ. 'PM') THEN
C
C  SWTICH ON PLOT THE INFO
C
            IF (OPT .EQ. 'ON') THEN
              PMIMX = .TRUE.
                RETURN
C
C  SWTICH OFF DO NOT PLOT THE INFO
C
            ELSEIF (OPT .EQ. 'OF') THEN
              PMIMX = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  ADVANCE FRAME BEFORE TRIANGULATION PLOT
C
      ELSEIF (TAG .EQ. 'TF') THEN
C
C  SWITCH ON ADVANCE FRAME
C
          IF (OPT .EQ. 'ON') THEN
                FRADV = .TRUE.
                RETURN
C
C  SWITCH OFF DO NOT ADVANCE FRAME
C
            ELSEIF (OPT .EQ. 'OF') THEN
                FRADV = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  EXIT AFTER TRIANGULATION
C
      ELSEIF (TAG .EQ. 'TO') THEN
C
C  SWITCH ON EXIT AFTER TRIANGULATION
C
          IF (OPT .EQ. 'ON') THEN
                EXTRI = .TRUE.
                LOOK = .TRUE.
                FRADV = .FALSE.
                RETURN
C
C  SWITCH OFF DO NOT EXIT AFTER TRIANGULATION
C
          ELSEIF (OPT .EQ. 'OF') THEN
                FRADV = .TRUE.
                LOOK = .FALSE.
                EXTRI = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  LIST OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'LO') THEN
C
C  ON SET LIST OPTIONS FLAG
C
            IF (OPT .EQ. 'ON') THEN
              LISTOP = .TRUE.
                RETURN
C
C  TURN OFF LIST OPTIONS FLAG
C
          ELSEIF (OPT .EQ. 'OF') THEN
              LISTOP = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET THE INTERPOLATION SCHEME
C
      ELSEIF (TAG .EQ. 'IT') THEN
C
C  SET TO C1 SURFACE
C
            IF (OPT .EQ. 'C1') THEN
              LINEAR = .FALSE.
                RETURN
C
C  SET TO LINEAR INTERPOLATION
C
            ELSEIF (OPT .EQ. 'LI') THEN
                LINEAR = .TRUE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET THE SHIELD PLOT FLAG
C
      ELSEIF (TAG .EQ. 'PS') THEN
C
C  TURN ON SHIELD PLOT
C
            IF (OPT .EQ. 'ON') THEN
                SLDPLT = .TRUE.
                RETURN
C
C  TURN OFF SHIELD PLOT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                SLDPLT = .FALSE.
                RETURN
            ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP1 -- UNDEFINED OPTION',1,1)
      RETURN
C
        END

      integer function deftok (token, toksiz)
      integer token (100)
      integer toksiz
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer t, c, defn (2048), mdefn (2048)
      integer gtok
      integer equal
      integer ap, argstk (100), callst (50), nlb, plev (50), ifl
      integer ludef, push, ifparm
      integer balp(3)
      integer pswrg(22)
      data balp(1)/40/,balp(2)/41/,balp(3)/-2/
      data pswrg(1)/115/,pswrg(2)/119/,pswrg(3)/105/,pswrg(4)/116/,pswrg
     *(5)/99/,pswrg(6)/104/,pswrg(7)/95/,pswrg(8)/110/,pswrg(9)/111/,psw
     *rg(10)/95/,pswrg(11)/114/,pswrg(12)/97/,pswrg(13)/110/,pswrg(14)/1
     *03/,pswrg(15)/101/,pswrg(16)/95/,pswrg(17)/99/,pswrg(18)/104/,pswr
     *g(19)/101/,pswrg(20)/99/,pswrg(21)/107/,pswrg(22)/-2/
      cp = 0
      ap = 1
      ep = 1
      t = gtok (token, toksiz)
23000 if (.not.(t .ne. -1))goto 23002
      if (.not.(t .eq. -9))goto 23003
      if (.not.(ludef (token, defn, deftbl) .eq. 0))goto 23005
      if (.not.(cp .eq. 0))goto 23007
      goto 23002
23007 continue
      call puttok (token)
23008 continue
      goto 23006
23005 continue
      if (.not.(defn (1) .eq. -4))goto 23009
      call getdef (token, toksiz, defn, 2048)
      call entdef (token, defn, deftbl)
      goto 23010
23009 continue
      if (.not.(defn (1) .eq. -15 .or. defn (1) .eq. -16))goto 23011
      c = defn (1)
      call getdef (token, toksiz, defn, 2048)
      ifl = ludef (token, mdefn, deftbl)
      if (.not.((ifl .eq. 1 .and. c .eq. -15) .or. (ifl .eq. 0 .and. c .
     *eq. -16)))goto 23013
      call pbstr (defn)
23013 continue
      goto 23012
23011 continue
      if (.not.(defn(1) .eq. -17 .and. cp .eq. 0))goto 23015
      if (.not.(gtok (defn, 2048) .eq. 32))goto 23017
      if (.not.(gtok (defn, 2048) .eq. -9))goto 23019
      if (.not.(equal (defn, pswrg) .eq. 1))goto 23021
      swinrg = 1
      goto 23022
23021 continue
      goto 10
23022 continue
      goto 23020
23019 continue
10    call pbstr (defn)
      call putbak (32)
      goto 23002
23020 continue
      goto 23018
23017 continue
      call pbstr (defn)
      goto 23002
23018 continue
      goto 23016
23015 continue
      cp = cp + 1
      if (.not.(cp .gt. 50))goto 23023
      call baderr (20Hcall stack overflow.)
23023 continue
      callst (cp) = ap
      ap = push (ep, argstk, ap)
      call puttok (defn)
      call putchr (-2)
      ap = push (ep, argstk, ap)
      call puttok (token)
      call putchr (-2)
      ap = push (ep, argstk, ap)
      t = gtok (token, toksiz)
      if (.not.(t .eq. 32))goto 23025
      t = gtok (token, toksiz)
      call pbstr (token)
      if (.not.(t .ne. 40))goto 23027
      call putbak (32)
23027 continue
      goto 23026
23025 continue
      call pbstr (token)
23026 continue
      if (.not.(t .ne. 40))goto 23029
      call pbstr (balp)
      goto 23030
23029 continue
      if (.not.(ifparm (defn) .eq. 0))goto 23031
      call pbstr (balp)
23031 continue
23030 continue
      plev (cp) = 0
23016 continue
23012 continue
23010 continue
23006 continue
      goto 23004
23003 continue
      if (.not.(t .eq. -69))goto 23033
      nlb = 1
23035 continue
      t = gtok (token, toksiz)
      if (.not.(t .eq. -69))goto 23038
      nlb = nlb + 1
      goto 23039
23038 continue
      if (.not.(t .eq. -68))goto 23040
      nlb = nlb - 1
      if (.not.(nlb .eq. 0))goto 23042
      goto 23037
23042 continue
      goto 23041
23040 continue
      if (.not.(t .eq. -1))goto 23044
      call baderr (14HEOF in string.)
23044 continue
23041 continue
23039 continue
      call puttok (token)
23036 goto 23035
23037 continue
      goto 23034
23033 continue
      if (.not.(cp .eq. 0))goto 23046
      goto 23002
23046 continue
      if (.not.(t .eq. 40))goto 23048
      if (.not.(plev (cp) .gt. 0))goto 23050
      call puttok (token)
23050 continue
      plev (cp) = plev (cp) + 1
      goto 23049
23048 continue
      if (.not.(t .eq. 41))goto 23052
      plev (cp) = plev (cp) - 1
      if (.not.(plev (cp) .gt. 0))goto 23054
      call puttok (token)
      goto 23055
23054 continue
      call putchr (-2)
      call evalr (argstk, callst (cp), ap - 1)
      ap = callst (cp)
      ep = argstk (ap)
      cp = cp - 1
23055 continue
      goto 23053
23052 continue
      if (.not.(t .eq. 44 .and. plev (cp) .eq. 1))goto 23056
      call putchr (-2)
      ap = push (ep, argstk, ap)
      goto 23057
23056 continue
      call puttok (token)
23057 continue
23053 continue
23049 continue
23047 continue
23034 continue
23004 continue
23001 t = gtok (token, toksiz)
      goto 23000
23002 continue
      deftok = t
      if (.not.(t .eq. -9))goto 23058
      call fold (token)
23058 continue
      return
      end
c     logic0  logical_column

      subroutine dsfree (block)
      integer block
      integer mem( 60000)
      common/cdsmem/mem
      integer p0, p, q
      integer n, junk
      integer con (10)
      p0 = block - 2
      n = mem (p0 + 0)
      q = 2
23000 continue
      p = mem (q + 1)
      if (.not.(p .eq. 0 .or. p .gt. p0))goto 23003
      goto 23002
23003 continue
      q = p
23001 goto 23000
23002 continue
      if (.not.(q + mem (q + 0) .gt. p0))goto 23005
      call remark (45Hin dsfree:	attempt to free unallocated block.)
      call remark (21Htype 'c' to continue.)
      junk = getlin (con, 0)
      if (.not.(con (1) .ne. 99 .and. con (1) .ne. 67))goto 23007
      call endst
23007 continue
      return
23005 continue
      if (.not.(p0 + n .eq. p .and. p .ne. 0))goto 23009
      n = n + mem (p + 0)
      mem (p0 + 1) = mem (p + 1)
      goto 23010
23009 continue
      mem (p0 + 1) = p
23010 continue
      if (.not.(q + mem (q + 0) .eq. p0))goto 23011
      mem (q + 0) = mem (q + 0) + n
      mem (q + 1) = mem (p0 + 1)
      goto 23012
23011 continue
      mem (q + 1) = p0
      mem (p0 + 0) = n
23012 continue
      return
      end

C------------------------------------------------------------------------------
        subroutine ftgics(iunit,xrval,yrval,xrpix,yrpix,xinc,yinc,rot,
     &                   type,status)

C       read the values of the celestial coordinate system keywords.
C       These values may be used as input to the subroutines that
C       calculate celestial coordinates. (FTXYPX, FTWLDP)

C       This routine assumes that the CHDU contains an image
C       with the RA type coordinate running along the first axis
C       and the DEC type coordinate running along the 2nd axis.

        double precision xrval,yrval,xrpix,yrpix,xinc,yinc,rot
        integer iunit,status,tstat
        character*(*) type
        character comm*20,ctype*8

        if (status .gt. 0)return

        call ftgkyd(iunit,'CRVAL1',xrval,comm,status)
        call ftgkyd(iunit,'CRVAL2',yrval,comm,status)

        call ftgkyd(iunit,'CRPIX1',xrpix,comm,status)
        call ftgkyd(iunit,'CRPIX2',yrpix,comm,status)

        call ftgkyd(iunit,'CDELT1',xinc,comm,status)
        call ftgkyd(iunit,'CDELT2',yinc,comm,status)

        call ftgkys(iunit,'CTYPE1',ctype,comm,status)

        if (status .gt. 0)then
            call ftpmsg('FTGICS could not find all the required'//
     &                  'celestial coordinate Keywords.')
            status=505
            return
        end if

        type=ctype(5:8)

        tstat=status
        call ftgkyd(iunit,'CROTA2',rot,comm,status)
        if (status .gt. 0)then
C           CROTA2 is assumed to = 0 if keyword is not present
            status=tstat
            rot=0.
        end if
        end

      subroutine interv ( xt, lxt, x, left, mflag )
c  from  * a practical guide to splines *  by c. de boor
computes  left = max( i , 1 .le. i .le. lxt  .and.  xt(i) .le. x )  .
c
c******  i n p u t  ******
c  xt.....a real sequence, of length  lxt , assumed to be nondecreasing
c  lxt.....number of terms in the sequence  xt .
c  x.....the point whose location with respect to the sequence	xt  is
c	 to be determined.
c
c******  o u t p u t  ******
c  left, mflag.....both integers, whose value is
c
c   1	  -1	  if		   x .lt.  xt(1)
c   i	   0	  if   xt(i)  .le. x .lt. xt(i+1)
c  lxt	   1	  if  xt(lxt) .le. x
c
c	 in particular,  mflag = 0 is the 'usual' case.  mflag .ne. 0
c	 indicates that  x  lies outside the halfopen interval
c	 xt(1) .le. y .lt. xt(lxt) . the asymmetric treatment of the
c	 interval is due to the decision to make all pp functions cont-
c	 inuous from the right.
c
c******  m e t h o d  ******
c  the program is designed to be efficient in the common situation that
c  it is called repeatedly, with  x  taken from an increasing or decrea-
c  sing sequence. this will happen, e.g., when a pp function is to be
c  graphed. the first guess for  left  is therefore taken to be the val-
c  ue returned at the previous call and stored in the  l o c a l  varia-
c  ble	ilo . a first check ascertains that  ilo .lt. lxt (this is nec-
c  essary since the present call may have nothing to do with the previ-
c  ous call). then, if	xt(ilo) .le. x .lt. xt(ilo+1), we set  left =
c  ilo	and are done after just three comparisons.
c     otherwise, we repeatedly double the difference  istep = ihi - ilo
c  while also moving  ilo  and	ihi  in the direction of  x , until
c		       xt(ilo) .le. x .lt. xt(ihi) ,
c  after which we use bisection to get, in addition, ilo+1 = ihi .
c  left = ilo  is then returned.
c
      integer left,lxt,mflag,	ihi,ilo,istep,middle
      real x,xt(lxt)
      data ilo /1/
c     save ilo	(a valid fortran statement in the new 1977 standard)
      ihi = ilo + 1
      if (ihi .lt. lxt) 		go to 20
	 if (x .ge. xt(lxt))		go to 110
	 if (lxt .le. 1)		go to 90
	 ilo = lxt - 1
	 ihi = lxt
c
   20 if (x .ge. xt(ihi))		go to 40
      if (x .ge. xt(ilo))		go to 100
c
c	       **** now x .lt. xt(ilo) . decrease  ilo	to capture  x .
      istep = 1
   31	 ihi = ilo
	 ilo = ihi - istep
	 if (ilo .le. 1)		go to 35
	 if (x .ge. xt(ilo))		go to 50
	 istep = istep*2
					go to 31
   35 ilo = 1
      if (x .lt. xt(1)) 		go to 90
					go to 50
c	       **** now x .ge. xt(ihi) . increase  ihi	to capture  x .
   40 istep = 1
   41	 ilo = ihi
	 ihi = ilo + istep
	 if (ihi .ge. lxt)		go to 45
	 if (x .lt. xt(ihi))		go to 50
	 istep = istep*2
					go to 41
   45 if (x .ge. xt(lxt))		go to 110
      ihi = lxt
c
c	    **** now xt(ilo) .le. x .lt. xt(ihi) . narrow the interval.
   50 middle = (ilo + ihi)/2
      if (middle .eq. ilo)		go to 100
c     note. it is assumed that middle = ilo in case ihi = ilo+1 .
      if (x .lt. xt(middle))		go to 53
	 ilo = middle
					go to 50
   53	 ihi = middle
					go to 50
c**** set output and return.
   90 mflag = -1
      left = 1
					return
  100 mflag = 0
      left = ilo
					return
  110 mflag = 1
      left = lxt
					return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
c +noao: block data threbd changed to run time initialization
        subroutine threbd
c     BLOCKDATA THREBD
      COMMON /TEMPR/  RZERO
      COMMON /SET31/  ISCALE     ,XMIN       ,XMAX   ,YMIN,
     1                YMAX       ,BIGD       ,R0     ,NLX,
     2                NBY        ,NRX        ,NTY
      COMMON /TCK31/  TMAGU      ,TMINU      ,TMAGV  ,TMINV,
     1                TMAGW      ,TMINW
      COMMON /THRINT/ ITHRMJ     ,ITHRMN     ,ITHRTX
c +noao: following flag added to prevent over-initialization
      logical first
      SAVE
      data first /.true./
      if (.not. first) then
        return
      endif
      first = .false.

c     DATA RZERO/0./
      RZERO = 0.
c
c     DATA NLX,NBY,NRX,NTY/10,10,1010,1010/
      NLX = 10
      NBY = 10
      NRX = 1010
      NTY = 1010   
c
c     DATA TMAGU,TMINU,TMAGV,TMINV,TMAGW,TMINW/12.,8.,12.,8.,12.,8./
      TMAGU = 12.
      TMINU =  8.
      TMAGV = 12.
      TMINV =  8.
      TMAGW = 12.
      TMINW =  8.
c
c     DATA ITHRMJ,ITHRMN,ITHRTX/ 1,1,1/
      ITHRMJ = 2
      ITHRMN = 1
      ITHRTX = 1
c
c -noao
      END

C----------------------------------------------------------------------
        subroutine ftgttb(iunit,ncols,nrows,nfield,status)

C       test that this is a legal ASCII table, and get some keywords
C
C       iunit   i  Fortran i/o unit number
C       OUTPUT PARAMETERS:
C       ncols   i  number of columns in the table
C       nrows   i  number of rows in the table
C       nfield  i  number of fields in the table
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,ncols,nrows,nfield,status
        character keynam*8,value*10,comm*8,keybuf*80

        if (status .gt. 0)return

C       check for correct type of extension
        call ftgrec(iunit,1,keybuf,status)

        keynam=keybuf(1:8)
C       parse the value and comment fields from the record
        call ftpsvc(keybuf,value,comm,status)

        if (status .gt. 0)go to 900

        if (keynam .eq. 'XTENSION')then
                if (value(2:9) .ne. 'TABLE   ')then
C                       this is not a ASCII table extension
                        status=226
        call ftpmsg('Was expecting an ASCII table; instead got '//
     &  'XTENSION= '//value)
                        call ftpmsg(keybuf)
                        go to 900
                 end if
        else
                 status=225
        call ftpmsg('First keyword of extension was not XTENSION:'//
     &           keynam)
                 call ftpmsg(keybuf)
                 go to 900
        end if

C       check that the second keyword is BITPIX = 8
        call fttkyn(iunit,2,'BITPIX','8',status)
        if (status .eq. 208)then
C               BITPIX keyword not found
                status=222
        else if (status .eq. 209)then
C               illegal value of BITPIX
                status=211
        end if
        if (status .gt. 0)go to 900

C       check that the third keyword is NAXIS = 2
        call fttkyn(iunit,3,'NAXIS','2',status)
        if (status .eq. 208)then
C               NAXIS keyword not found
                status=223
        else if (status .eq. 209)then
C               illegal value of NAXIS
                status=212
        end if
        if (status .gt. 0)go to 900

C       check that the 4th keyword is NAXIS1 and get it's value
        call ftgtkn(iunit,4,'NAXIS1',ncols,status)
        if (status .eq. 208)then
C               NAXIS1 keyword not found
                status=224
        else if (status .eq. 209)then
C               illegal NAXIS1 value
                status=213
        end if
        if (status .gt. 0)go to 900

C       check that the 5th keyword is NAXIS2 and get it's value
        call ftgtkn(iunit,5,'NAXIS2',nrows,status)
        if (status .eq. 208)then
C               NAXIS2 keyword not found
                status=224
        else if (status .eq. 209)then
C               illegal NAXIS2 value
                status=213
        end if
        if (status .gt. 0)go to 900

C       check that the 6th keyword is PCOUNT = 0
        call fttkyn(iunit,6,'PCOUNT','0',status)
        if (status .eq. 208)then
C               PCOUNT keyword not found
                status=228      
        else if (status .eq. 209)then
C               illegal PCOUNT value
                status=214
        end if
        if (status .gt. 0)go to 900

C       check that the 7th keyword is GCOUNT = 1
        call fttkyn(iunit,7,'GCOUNT','1',status)
        if (status .eq. 208)then
C               GCOUNT keyword not found
                status=229
        else if (status .eq. 209)then
C               illegal value of GCOUNT
                status=215
        end if
        if (status .gt. 0)go to 900

C       check that the 8th keyword is TFIELDS
        call ftgtkn(iunit,8,'TFIELDS',nfield,status)
        if (status .eq. 208)then
C               TFIELDS keyword not found
                status=230
        else if (status .eq. 209)then
C               illegal value of TFIELDS
                status=216
        end if

900     continue
        if (status .gt. 0)then
            call ftpmsg('Failed to parse the required keywords in '//
     &       'the ASCII TABLE header (FTGTTB).')
        end if
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGRPCH (CHST,LNCS,IDCS)
C
      CHARACTER*(*) CHST
C
C This routine is used to replace a character string previously stored
C by the routine AGSTCH (which see).  This could be done by an AGDLCH
C followed by an AGSTCH, and, in fact, under certain conditions, does
C exactly that.  Only when it is easy to do so does AGRPCH operate more
C efficiently.  Nevertheless, a user who (for example) repeatedly and
C perhaps redundantly defines x-axis labels of the same length may
C greatly benefit thereby; repeated deletes and stores would lead to
C frequent garbage collection by AGSTCH.
C
C AGRPCH has the following arguments:
C
C -- CHST is the new character string, to replace what was originally
C    stored.
C
C -- LNCS is the length of the character string in CHST.
C
C -- IDCS is the identifier returned by AGSTCH when the original string
C    was stored.  The value of IDCS may be changed by the call.
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
C
      COMMON /AGCHR2/ CHRA(2000)
C
      CHARACTER*1 CHRA
C
C If the identifier is positive or is negative but less than -LNIC, the
C original string was never stored in CHRA; just treat the replacement
C as a store and return a new value of IDCS.
C
      IF (IDCS.GT.(-1).OR.IDCS.LT.(-LNIC)) THEN
        CALL AGSTCH (CHST,LNCS,IDCS)
C
      ELSE
C
C The absolute value of the identifier is the index, in INCH, of the
C descriptor of the character string stored in CHRA.  If the new string
C is shorter than the old one, store it and zero remaining character
C positions.  Otherwise, treat the replacement as a delete followed by
C a store.
C
        I=-IDCS
        IF (LNCS.LE.INCH(2,I)) THEN
          J=INCH(1,I)-1
          DO 101 K=1,LNCS
            J=J+1
            CHRA(J)=CHST(K:K)
  101     CONTINUE
          DO 102 K=LNCS+1,INCH(2,I)
            J=J+1
            CHRA(J)=CHAR(0)
  102     CONTINUE
          INCH(2,I)=LNCS
        ELSE
          CALL AGDLCH (IDCS)
          CALL AGSTCH (CHST,LNCS,IDCS)
        END IF
C
      END IF
C
C Done.
C
      RETURN
C
      END

C--------------------------------------------------------------------------
        subroutine ftiblk(ounit,nblock,hdrdat,status)

C       insert a 2880-byte block at the end of the current header or data.

C       ounit   i  fortran output unit number
C       nblock  i  number of blocks to insert
C       hdrdat  i  insert space in header (0) or data (1)
C       status  i  returned error status (0=ok)

        integer ounit,nblock,hdrdat,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        character*1 buff(2880,2)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS:------------------------------------

        integer ibuff,ipoint,jpoint,i,tstat,thdu,nshift,in,out,tin
        character*1 cfill

        if (status .gt. 0)return
        tstat=status

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

C       set the appropriate fill value
        if (hdrdat .eq. 0 .or. hdutyp(ibuff) .eq. 1)then
C               fill  header or ASCII table with space
                cfill=char(32)
        else
C               fill with Null (0) in image or bintable data area        
                cfill=char(0)
        end if

C       find position in file to insert new block
        if (hdrdat .eq. 0)then
            ipoint=dtstrt(ibuff)
        else
            ipoint=hdstrt(ibuff,chdu(ibuff)+1)
        end if


        if (nblock .eq. 1 .and. hdrdat .eq. 0)then
C******************************************************************
C  Don't use this algoritm, even though it may be faster (but initial
C  tests showed it didn't make any difference on a SUN) because it is
C  less safe than the other more general algorithm.  If there is
C  not enough disk space available for the added block, this faster
C  algorithm won't fail until it tries to move the last block, thus leaving
C  the FITS file in a corrupted state.   The other more general
C  algorithm tries to add a new empty block to the file as the
C  first step.  If this fails, it still leaves the current FITS
C  file unmodified, which is better for the user.  
C******************************************************************
C  (Note added later:)
C  Will use this algorithm anyway when inserting one block in a FITS
C  header because the more general algorithm results in a status=252 error
C  in cases where the number of rows in a table has not yet been defined
C******************************************************************
C           use this more efficient algorithm if just adding a single block
C           initialize the first buffer
            do 5 i=1,2880
               buff(i,1)=cfill
5           continue

            in=2
            out=1

C           move to the read start position
10          call ftmbyt(ounit,ipoint,.false.,status)

C           read one 2880-byte FITS logical record into the input buffer
            call ftgcbf(ounit,0,2880,buff(1,in),status)

C           check for End-Of-File
            if (status .eq. 107)go to 20

C           move back to the write start postion
            call ftmbyt(ounit,ipoint,.false.,status)

C           write the 2880-byte FITS logical record stored in the output buffer
            call ftpcbf(ounit,0,2880,buff(1,out),status)

C           check for error during write (the file may not have write access)
            if (status .gt. 0)return

C           swap the input and output buffer pointers and move to next block
            tin=in
            in=out
            out=tin
            ipoint=ipoint+2880

C           now repeat the process until we reach the End-Of-File
            go to 10

C           we have reached the end of file; now append the last block
20          status=tstat

C           move back to the write start postion
            call ftmbyt(ounit,ipoint,.true.,status)

C           write the 2880-byte FITS logical record stored in the output buffer
            call ftpcbf(ounit,0,2880,buff(1,out),status)

        else
C           use this general algorithm for adding arbitrary number of blocks

C           first, find the end of file
            thdu=chdu(ibuff)

30          call ftmahd(ounit,maxhdu(ibuff)+1,i,status)

            if (status .eq. 107)then
                status=tstat
C               move back to the current extension
                call ftmahd(ounit,thdu,i,status)
                go to 100
            else if (status .le. 0)then
                go to 30
            else
                call ftpmsg('Error while seeking End of File (FTIBLK)')
                return
            end if

C           calculate number of 2880-byte blocks that have to be shifted down
100         continue
            nshift=(hdstrt(ibuff,maxhdu(ibuff)+1)-ipoint)/2880
            jpoint=hdstrt(ibuff,maxhdu(ibuff)+1)-2880

C           move all the blocks, one at a time, starting at end of file and
C           working back to the insert position
            do 110 i=1,nshift

C               move to the read start position
                call ftmbyt(ounit,jpoint,.false.,status)

C               read one 2880-byte FITS logical record
                call ftgcbf(ounit,0,2880,buff,status)

C               move forward to the write start postion
                call ftmbyt(ounit,jpoint+nblock*2880,.true.,status)

C               write the 2880-byte FITS logical record
                call ftpcbf(ounit,0,2880,buff,status)

C               check for error 
                if (status .gt. 0)then
                    call ftpmsg('Error inserting empty FITS block(s) '//
     &              '(FTIBLK)')
                    return
                end if
                jpoint=jpoint-2880
110         continue

            do 120 i=1,2880
                buff(i,1)=cfill
120         continue
             
C           move back to the write start postion
            call ftmbyt(ounit,ipoint,.true.,status)

            do 130 i=1,nblock
C               write the 2880-byte FITS logical record 
                call ftpcbf(ounit,0,2880,buff,status)
130         continue
        end if

        if (hdrdat .eq. 0)then
C               recalculate the starting location of the current data unit
                dtstrt(ibuff)=dtstrt(ibuff)+2880*nblock
        end if

C       recalculate the starting location of all subsequent HDUs
        do 140 i=chdu(ibuff)+1,maxhdu(ibuff)+1
                    hdstrt(ibuff,i)=hdstrt(ibuff,i)+2880*nblock
140     continue
        if (status .gt. 0)then
            call ftpmsg('Error inserting FITS block(s) (FTIBLK)')
        end if
        end

C----------------------------------------------------------------------
        subroutine ftpcle(ounit,colnum,frow,felem,nelem,array,status)

C       write an array of real data values to the specified column of
C       the table.  

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       array   r  array of data values to be written 
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status
        real array(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
        character*1 chbuff(400),xdummy(5360)
        common/ftheap/chbuff,xdummy
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bufdim
        parameter (bufdim = 100)
        integer buffer(bufdim),bytpix,bstart,tcode,incre
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart,maxpix,ival
        real rval
        double precision scale,zero,dval
        character sval*40,wform*10,crow*9,cp1*9,cp2*9,ccol*4
        logical tofits,lval,descrp
        integer*2 i2val
        character*1 i1val

        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &          'request is out of range:'//crow//' (FTPCLE).')
                return
        end if

        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)

        descrp=.false.
        i1=1
        ntodo=nelem
        rstart=frow-1
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
        tcode=tdtype(colnum+tstart(ibuff)) 
C       the data are being scaled from internal format to FITS:
        tofits=.true.

C       calculate the maximum number of column pixels which fit in buffer
        bytpix=max(abs(tcode)/10,1)
        maxpix=bufdim/bytpix*4

C       incre is the byte offset between consecutive pixels
        incre=0
        if (tcode .eq. 16)then
C               this is an ASCII table; table elements cannot be vectors
                repeat=1
                estart=0
        else
C               this is a binary table
                if (felem .lt. 1)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                    call ftpmsg('Starting element number for write '//
     &                 'request is out of range:'//crow//' (FTPCLE).')
                        return
                else
                        estart=felem-1
                end if

                if (tcode .gt. 0)then
                        if (hdutyp(ibuff) .eq. 0)then
C                           if this is a primary array or image extension, then
C                           set repeat as large as needed to write all
C                           the pixels.  This prevents an error message if
C                           array size is not yet known.  The actual array
C                           dimension must be defined by the NAXISn keywords
C                           before closing this HDU. 
                            repeat=estart+nelem
                        else
                            repeat=trept(colnum+tstart(ibuff))
                        end if

                        if (felem .gt. repeat)then
C                               illegal element number
                                status=308
                                write(crow,2000)felem
                    call ftpmsg('Starting element number for write '//
     &                 'request is out of range:'//crow//' (FTPCLE).')
                                return
                        end if
                        if (repeat .eq. 1 .and. nelem .gt. 1)then
C                               write multiple rows of data at one time
                                incre=rowlen(ibuff)
                                repeat=maxpix
                                estart=0
                        end if
                else
C                       this is a variable length descriptor column
                        descrp=.true.
                        tcode=-tcode
                        repeat=nelem+felem-1
C                       write the number of elements and the starting offset:
                        call ftpdes(ounit,colnum,frow,repeat,
     &                              nxheap(ibuff),status)
C                       move the i/o pointer to the start of the pixel sequence
                        bstart=dtstrt(ibuff)+nxheap(ibuff)+
     &                          theap(ibuff)+estart*bytpix
                        call ftmbyt(ounit,bstart,.true.,status)
C                       increment the empty heap starting address:
                        nxheap(ibuff)=nxheap(ibuff)+repeat*bytpix
                end if
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,repeat-estart,maxpix)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &             +tbcol(colnum+tstart(ibuff))+estart*bytpix
            call ftmbyt(ounit,bstart,.true.,status)
        end if

C       copy data to buffer, doing scaling and datatype conversion, if required
        if (tcode .eq. 21)then
C               column data type is I (I*2)
                call ftr4i2(array(i1),itodo,scale,zero,tofits,
     &          ival,i2val,lval,lval,buffer,status)
C               do any machine dependent data conversion and write the I*2 data
                call ftpi2b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 41)then
C               column data type is J (I*4)
                call ftr4i4(array(i1),itodo,scale,zero,tofits,
     &          ival,ival,lval,lval,buffer,status)
C               do any machine dependent data conversion and write the I*4 data
                call ftpi4b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 42)then
C               column data type is E (R*4)
                call ftr4r4(array(i1),itodo,scale,zero,tofits,
     &              ival,rval,lval,lval,buffer,status)
C               do any machine dependent conversion and write the R*4 data
                call ftpr4b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 82)then
C               column data type is D (R*8)
                call ftr4r8(array(i1),itodo,scale,zero,tofits,
     &          ival,dval,lval,lval,buffer,status)
C               do any machine dependent data conversion and write the R*8 data
                call ftpr8b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 11)then
C               column data type is B (byte)
                call ftr4i1(array(i1),itodo,scale,zero,tofits,
     &          ival,i1val,lval,lval,chbuff,status)
C               do any machine dependent data conversion and write the byte data
                call ftpi1b(ounit,itodo,incre,chbuff,status)
        else if (tcode .eq. 16 .and. hdutyp(ibuff) .eq. 1)then
C               this is an ASCII table column
                wform='(        )'
                wform(2:9)=cform(colnum+tstart(ibuff))
                if (cform(colnum+tstart(ibuff))(1:1) .eq. 'I')then
C                 column data type is integer
                  call ftr4i4(array(i1),itodo,scale,zero,tofits,
     &            ival,ival,lval,lval,ival,status)
C                 create the formated character string
                  write(sval,wform,err=900)ival
C                 write the character string to the FITS file
                  call ftpcbf(ounit,1,tnull(colnum+tstart(ibuff)),sval,
     &                   status)
                else if (cform(colnum+tstart(ibuff))(1:1) .eq. 'F'
     &            .or.  cform(colnum+tstart(ibuff))(1:1) .eq. 'E')then
C                 column data type is real
                  call ftr4r4(array(i1),itodo,scale,zero,tofits,
     &            ival,rval,lval,lval,rval,status)
C                 create the formated character string
                  write(sval,wform,err=900)rval
C                 write the character string to the FITS file
                  call ftpcbf(ounit,1,tnull(colnum+tstart(ibuff)),sval,
     &                        status)
                else if (cform(colnum+tstart(ibuff))(1:1) .eq. 'D')then
C                 column data type is double precision
                  call ftr4r8(array(i1),itodo,scale,zero,tofits,
     &            ival,dval,lval,lval,dval,status)
C                 create the formated character string
                  write(sval,wform,err=900)dval
C                 write the character string to the FITS file
                  call ftpcbf(ounit,1,tnull(colnum+tstart(ibuff)),sval,
     &                        status)
                else
C                 error: illegal ASCII table format code
                  status=311
                  write(ccol,2001)colnum
        call ftpmsg('Cannot write Real values to column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTPCLE).')
                  return
                end if
        else
C               error illegal binary table data type code
                status=312
                write(ccol,2001)colnum
        call ftpmsg('Cannot write Real values to column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTPCLE).')
                return
        end if

        if (status .gt. 0)then
          if (hdutyp(ibuff) .eq. 0)then
C            this is a primary array or image extension
             write(cp1,2000)felem+i1-1
             write(cp2,2000)felem+i1+itodo-2
             call ftpmsg('Error writing pixels'//cp1//' to'//cp2
     &                 // ' to the FITS image array (FTPCLE).')
             if (frow .ne. 1)then
                write(cp1,2000)frow
                call ftpmsg('Error while writing group'//cp1//
     &          ' of the multigroup primary array.')
             end if
          else
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error writing elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTPCLE.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error writing rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTPCLE).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error writing'//cp2//' elements to'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTPCLE).')
             end if
          end if
          return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        if (incre .eq. 0)then
                                rstart=rstart+1
                        else
                                rstart=rstart+repeat
                        end if
                end if
                go to 20
        end if

C       check for any overflows
        if (status .eq. -11)then
                status=412
                call ftpmsg('Numeric overflow error occurred writing '//
     &        'Real*4 data to FITS file.')
        end if
        return

900     continue
C       error writing formatted data value to ASCII table
        write(ccol,2001)colnum
        write(cp1,2000)rstart+1
        call ftpmsg('Error writing colunm'//ccol//', row'//cp1//
     &  ' of the ASCII Table.')
        call ftpmsg('Tried to write value'//
     &              '" with format '//wform//' (FTPCLE).')
        status=313
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGPPID (TPID)
C
      CHARACTER*(*) TPID
C
C The object of this routine is to print out a parameter identifier
C which has caused some kind of problem.
C
C Define a character variable to hold the print line.
C
      CHARACTER*124 TEMP
C
C +NOAO
      integer*2 itemp(124)
C -NOAO
C
C Set up the print line.
C
      TEMP='0PARAMETER IDENTIFIER - '
C
C Transfer characters of the parameter identifier, one at a time, until
C 100 have been transferred or a period is encountered, whichever occurs
C first.  This is done so as to allow for old programs on the Cray which
C used Hollerith strings as parameter identifiers.
C
      I=24
C
      DO 101 J=1,100
        I=I+1
        TEMP(I:I)=TPID(J:J)
        IF (TEMP(I:I).EQ.'.') GO TO 102
  101 CONTINUE
C
C Print the line.
C
C +NOAO - replace FTN write and format statement.
C 102 WRITE (I1MACH(4),1001) TEMP
  102 CONTINUE
      call f77upk (temp, itemp, 125)
      call pstr (itemp)
C
C Done.
C
      RETURN
C
C Format.
C
C1001 FORMAT (A124)
C -NOAO
C
      END

#-h-  strdcl			 2575  local   12/01/80  15:55:05
# strdcl - generate code for string declaration
   include  defs

   subroutine strdcl

   include COMMON_BLOCKS

   character t, token (MAXTOK), dchar (MAXTOK)
   character gnbtok

   integer i, j, k, n, len
   integer length, ctoi, lex

   string char "integer*2/"
   string dat  "data "
   string eoss "0/"

   t = gnbtok (token, MAXTOK)
   if (t != ALPHA)
      call synerr ("missing string token.")
   call squash (token)
   call outtab
   call pbstr (char) # use defined meaning of "character"
   repeat {
      t = gnbtok (dchar, MAXTOK)
      if (t == SLASH)
	 break
      call outstr (dchar)
      }
   call outch (BLANK)  # separator in declaration
   call outstr (token)
   call addstr (token, sbuf, sbp, SBUFSIZE)  # save for later
   call addchr (EOS, sbuf, sbp, SBUFSIZE)
   if (gnbtok (token, MAXTOK) != LPAREN) {  # make size same as initial value
      len = length (token) + 1
      if (token (1) == SQUOTE | token (1) == DQUOTE)
	 len = len - 2
      }
   else { # form is string name (size) init
      t = gnbtok (token, MAXTOK)
      i = 1
      len = ctoi (token, i)
      if (token (i) != EOS)
	 call synerr ("invalid string size.")
      if (gnbtok (token, MAXTOK) != RPAREN)
	 call synerr ("missing right paren.")
      else
	 t = gnbtok (token, MAXTOK)
      }
   call outch (LPAREN)
   call outnum (len)
   call outch (RPAREN)
   call outdon
   if (token (1) == SQUOTE | token (1) == DQUOTE) {
      len = length (token)
      token (len) = EOS
      call addstr (token (2), sbuf, sbp, SBUFSIZE)
      }
   else
      call addstr (token, sbuf, sbp, SBUFSIZE)
   call addchr (EOS, sbuf, sbp, SBUFSIZE)
   t = lex (token)   # peek at next token
   call pbstr (token)
   if (t != LEXSTRING) {   # dump accumulated data statements
      for (i = 1; i < sbp; i = j + 1) {
	 call outtab
	 call outstr (dat)
	 k = 1
	 for (j = i + length (sbuf (i)) + 1; ; j = j + 1) {
	    if (k > 1)
	       call outch (COMMA)
	    call outstr (sbuf (i))
	    call outch (LPAREN)
	    call outnum (k)
	    call outch (RPAREN)
	    call outch (SLASH)
	    if (sbuf (j) == EOS)
	       break
	    n = sbuf (j)
	    call outnum (n)
	    call outch (SLASH)
	    k = k + 1
	    }
	 call pbstr (eoss) # use defined meaning of EOS
	 repeat {
	    t = gnbtok (token, MAXTOK)
	    call outstr (token)
	    } until (t == SLASH)
	 call outdon
	 }
      sbp = 1
      }

   return
   end

        subroutine intrp (itab, xtab, ytab, ntab, x, y, ierr)
c
c Interpolator using CODIM1 algorithm which is admittedly
c obscure  but works well.
c
c       itab - a label between 1 and 20 to identify the table and its
c              most recent search index
c       xtab - array of length ntab containing the x-values
c       ytab -                                     y-values
c       ntab - number of x,y pairs in the table
c          x - independent for which a y-value is desired
c          y - returned interpolated (or extrapolated) value
c       ierr - =0 for ok, -1 for extrapolation
c
        double precision xtab(ntab), ytab(ntab), x, y
        integer itab, ierr, index
        double precision t(4), u(4)
c       integer savind
c       data savind/-1/
c
c----- Only 1 pt in table
        if (ntab .eq. 1) then
                y = ytab(1)
                ierr = 0
                return
        endif
c
c-----
c Locate search index
        call srch (itab, x, xtab, ntab, index, ierr)
c       if (index .eq. savind) go to 2000
c       savind = index
c
c-----
c Set interpolator index flags
        i1 = 2
        i2 = 3
        iload = max0 (index-2, 1)
c
        if (ntab .gt. 2) then
                if (index.eq.   2) i2 = 4
c
                if (index.eq.ntab) i1 = 1
        endif
c
        if (index.gt.2 .and. index.lt.ntab) then
                i1 = 1
                i2 = 4
        endif
c-----
c Load interpolation arrays
        do 1000 i = i1, i2
                j = iload + (i-i1)
                t(i) = xtab (j)
                u(i) = ytab (j)
1000    continue
c
c-----
c Get interpolated value
2000    call codim1 (x, t, u, i1, i2, y)
        return
        end
c
c--------------------------------------------------------------
c
        subroutine srch (itab, x, xtab, ntab, index, ierr)
c
c Search table of x-values to bracket the desired interpolant, x
c
c The returned search index will be:
c       2 - if extrapolation below the table is required
c    ntab -                  above
c   index - points to value just above x in the table if bounded.
c
c The index is saved as a starting point for subsequent entries
c in an array indexed through 'itab' which serves to label the
c set of saved search indices. Itab may be between 1 and 20.
c
c       itab - The table identifier (1-20)
c          x - The value for which an index is desired
c       xtab - The table containing the x-values (array of length ntab)
c       ntab - number of elements in the table
c      index - returned index into the table (points just above x)
c       ierr - 0 for ok, -1 for extrapolation
c
c       Modified to remove entry points.  3/20/86 Valdes
c
        integer ntab, index, init
        double precision xtab(ntab), x
c
c common for subroutines intrp0 and intrpi
c
        common /insvcm/ insave(20)
c
c initialize
        data init/0/
c
c-----
c Initialize
        if (init.eq.0) then
            do 1110 i = 1, 20
1110            insave(i) = 0
            init = 1
        endif
c
c Determine direction of table, ascending or descending
        idir = sign (1.0d0, xtab(ntab) - xtab(1))
c
c-----
c Reset error flag
        ierr = 0
c
c-----
c Check for previous insaved index
        last = insave(itab)
        if (last .eq. 0 .or. last .gt. ntab) then
c
c-----
c no previous entry
                isrch = 1
c check for extrapolation
                if ((x-xtab(   1)) * idir .lt. 0.0d0) go to 2000
                if ((x-xtab(ntab)) * idir .gt. 0.0d0) go to 2100
        else
c
c-----
c previous entry left a valid index
                isrch = last
c
c check for still wihin bounds - difference from above should be opposite
c                                sign of difference from below
c
                if ((xtab(last)-x) * (xtab(last-1)-x) .lt. 0.0d0) then
                        index = last
                        return
                endif
        endif
c
c -----
c Begin searching - first determine direction
c
c This change made because x = xtab(1) was considered extrapolation.
c       if ((x - xtab(isrch)) * idir .gt. 0.0d0) then
        if ((x - xtab(isrch)) * idir .ge. 0.0d0) then
c forward
                do 1100 i = isrch+1, ntab
                        if ((x-xtab(i)) * idir .gt. 0.0d0) go to 1100
                        go to 1500
1100            continue
c fall thru implies extrapolation required at high end
                go to 2100
        else
c
c-----
c negative direction search
                do 1200 i = isrch-1,1,-1
                        if ((x-xtab(i)) * idir .lt. 0.0d0) go to 1200
                        go to 1400
1200            continue
c fall through implies extrapolation at low end
                go to 2000
        endif
c
c-----
c point has been bounded
1400    index = i + 1
        go to 3000
1500    index = i
        go to 3000
c
c-----
c extrapolations
2000    index = 2
        ierr = -1
        go to 3000
2100    index = ntab
        ierr = -1
        go to 3000
c
c-----
c insave index
3000    insave(itab) = index
        end
c
c------
c Subroutine to reset saved index
        subroutine intrp0 (itab)
        integer itab
        common /insvcm/ insave(20)
c
        insave(itab) = 0
        end
c
c-----
c Subroutine to return current index
        subroutine intrpi (itab, ind)
        integer itab, ind
        common /insvcm/ insave(20)
c
        ind = insave(itab)
        end
c
c-------------------------------------------------------------------
c
        subroutine codim1 (x, t, u, i1, i2, y)
c
c this subroutine performs an interposlation in a fashion
c not really understandable, but it works well.
c
c       x - input independent variable
c       t - array of 4 table independents surrounding x if possible
c       u - array of 4 table dependents corresponding to the t array
c
c  i1, i2 - indicators as follows:
c
c           i1 = 1, i2 = 4  :  4 pts available in t and u arrays
c           i1 = 1, i2 = 3  :  3 pts available (x near right edge of table)
c           i1 = 2, i2 = 4  :                  (x near left  edge of table)
c           i1 = 2, i2 = 3  :  2 pts available
c           i1 = 3, i3 = 3  :  1 pt  available
c
c       y - output interpolated (or extrapolated) dependent value
c
        double precision t(4), u(4), x, y
        integer i1, i2
        double precision s, v, z, a1, a2, a3, c1, c2, c3, a4, c4, c5, c6
	double precision e1, e2, p1, p2, slope1, slope2, al, bt, xe

c
c variable xk affects the extrapolation procedure. a value of -1.0
c appears to be a reliable value.
c
        data xk/-1.0d0/
c
        v = x
c the following code is extracted from an original source
c
      a2=v-t(2)
      al=a2/(t(3)-t(2))
      s=al*u(3)+(1.-al)*u(2)
      if(i1.gt.1.and.i2.lt.4)goto1530
      a3=v-t(3)
      if(i1.gt.1)goto1185
1180  a1=v-t(1)
      c1=a2/(t(1)-t(2))*a3/(t(1)-t(3))
      c2=a1/(t(2)-t(1))*a3/(t(2)-t(3))
      c3=a1/(t(3)-t(1))*a2/(t(3)-t(2))
      p1=c1*u(1)+c2*u(2)+c3*u(3)
      if(i2.lt.4)goto1400
1185  a4=v-t(4)
      c4=a3/(t(2)-t(3))*a4/(t(2)-t(4))
      c5=a2/(t(3)-t(2))*a4/(t(3)-t(4))
      c6=a2/(t(4)-t(2))*a3/(t(4)-t(3))
      p2=c4*u(2)+c5*u(3)+c6*u(4)
      if(i1.eq.1)goto1500
1200  if(xk.lt.0.)goto1230
      xe=xk
      goto1260
1230  slope1=abs((u(4)-u(3))/(t(4)-t(3)))
      slope2=abs((u(3)-u(2))/(t(3)-t(2)))
      xe=1.0d0
      if(slope1+slope2.ne.0.)xe=1.-abs(slope1-slope2)/(slope1+slope2)
1260  p1=s+xe*(p2-s)
      goto1500
1400  if(xk.lt.0.)goto1430
      xe=xk
      goto1460
1430  slope1=abs((u(2)-u(1))/(t(2)-t(1)))
      slope2=abs((u(3)-u(2))/(t(3)-t(2)))
      xe=1.0d0
      if(slope1+slope2.ne.0.)xe=1.-abs(slope1-slope2)/(slope1+slope2)
1460  p2=s+xe*(p1-s)
1500  e1=abs(p1-s)
      e2=abs(p2-s)
      if(e1+e2.gt.0.)goto1560
1530  z=s
      goto1700
1560  bt=(e1*al)/(e1*al+(1.-al)*e2)
      z=bt*p2+(1.-bt)*p1
c
1700    y = z
        return
        end
c
c----------------------------------------------------------------------
c
        subroutine lintrp (itab, xtab, ytab, ntab, x, y, ierr)
c
c Linear interpolator with last index save
c
c Arguments are identical to INTRP, and uses the same index search
c scheme so that values for ITAB should not clash with calls
c to INTRP and LINTRP.
c
        double precision xtab(ntab), ytab(ntab), x , y
        integer itab, ierr
c
c----- Only 1 pt in table
        if (ntab .eq. 1) then
                y = ytab (1)
                ierr = 0
                return
        endif
c
c-----locate search index
        call srch (itab, x, xtab, ntab, index, ierr)
c
c----- index points just above x
        y = ytab(index-1) + (x - xtab(index-1)) * 
     1   (ytab(index) - ytab(index-1)) / (xtab(index) - xtab(index-1))
c
        return
        end

      SUBROUTINE slAOP ( RAP, DAP, DATE, DUT, ELONGM, PHIM, HM,
     :                     XP, YP, TDK, PMB, RH, WL, TLR,
     :                     AOB, ZOB, HOB, DOB, ROB )
*+
*     - - - -
*      A O P
*     - - - -
*
*  Apparent to observed place, for sources distant from the solar
*  system.
*
*  Given:
*     RAP    d      geocentric apparent right ascension
*     DAP    d      geocentric apparent declination
*     DATE   d      UTC date/time (Modified Julian Date, JD-2400000.5)
*     DUT    d      delta UT:  UT1-UTC (UTC seconds)
*     ELONGM d      mean longitude of the observer (radians, east +ve)
*     PHIM   d      mean geodetic latitude of the observer (radians)
*     HM     d      observer's height above sea level (metres)
*     XP     d      polar motion x-coordinate (radians)
*     YP     d      polar motion y-coordinate (radians)
*     TDK    d      local ambient temperature (K; std=273.15D0)
*     PMB    d      local atmospheric pressure (mb; std=1013.25D0)
*     RH     d      local relative humidity (in the range 0D0-1D0)
*     WL     d      effective wavelength (micron, e.g. 0.55D0)
*     TLR    d      tropospheric lapse rate (K/metre, e.g. 0.0065D0)
*
*  Returned:
*     AOB    d      observed azimuth (radians: N=0,E=90)
*     ZOB    d      observed zenith distance (radians)
*     HOB    d      observed Hour Angle (radians)
*     DOB    d      observed Declination (radians)
*     ROB    d      observed Right Ascension (radians)
*
*  Notes:
*
*   1)  This routine returns zenith distance rather than elevation
*       in order to reflect the fact that no allowance is made for
*       depression of the horizon.
*
*   2)  The accuracy of the result is limited by the corrections for
*       refraction.  Providing the meteorological parameters are
*       known accurately and there are no gross local effects, the
*       predicted apparent RA,Dec should be within about 0.1 arcsec
*       for a zenith distance of less than 70 degrees.  Even at a
*       topocentric zenith distance of 90 degrees, the accuracy in
*       elevation should be better than 1 arcmin;  useful results
*       are available for a further 3 degrees, beyond which the
*       slRFRO routine returns a fixed value of the refraction.
*       The complementary routines slAOP (or slAOPQ) and slOAP
*       (or slOAPQ) are self-consistent to better than 1 micro-
*       arcsecond all over the celestial sphere.
*
*   3)  It is advisable to take great care with units, as even
*       unlikely values of the input parameters are accepted and
*       processed in accordance with the models used.
*
*   4)  "Apparent" place means the geocentric apparent right ascension
*       and declination, which is obtained from a catalogue mean place
*       by allowing for space motion, parallax, precession, nutation,
*       annual aberration, and the Sun's gravitational lens effect.  For
*       star positions in the FK5 system (i.e. J2000), these effects can
*       be applied by means of the slMAP etc routines.  Starting from
*       other mean place systems, additional transformations will be
*       needed;  for example, FK4 (i.e. B1950) mean places would first
*       have to be converted to FK5, which can be done with the
*       slFK45 etc routines.
*
*   5)  "Observed" Az,El means the position that would be seen by a
*       perfect theodolite located at the observer.  This is obtained
*       from the geocentric apparent RA,Dec by allowing for Earth
*       orientation and diurnal aberration, rotating from equator
*       to horizon coordinates, and then adjusting for refraction.
*       The HA,Dec is obtained by rotating back into equatorial
*       coordinates, using the geodetic latitude corrected for polar
*       motion, and is the position that would be seen by a perfect
*       equatorial located at the observer and with its polar axis
*       aligned to the Earth's axis of rotation (n.b. not to the
*       refracted pole).  Finally, the RA is obtained by subtracting
*       the HA from the local apparent ST.
*
*   6)  To predict the required setting of a real telescope, the
*       observed place produced by this routine would have to be
*       adjusted for the tilt of the azimuth or polar axis of the
*       mounting (with appropriate corrections for mount flexures),
*       for non-perpendicularity between the mounting axes, for the
*       position of the rotator axis and the pointing axis relative
*       to it, for tube flexure, for gear and encoder errors, and
*       finally for encoder zero points.  Some telescopes would, of
*       course, exhibit other properties which would need to be
*       accounted for at the appropriate point in the sequence.
*
*   7)  This routine takes time to execute, due mainly to the
*       rigorous integration used to evaluate the refraction.
*       For processing multiple stars for one location and time,
*       call slAOPA once followed by one call per star to slAOPQ.
*       Where a range of times within a limited period of a few hours
*       is involved, and the highest precision is not required, call
*       slAOPA once, followed by a call to slAOPT each time the
*       time changes, followed by one call per star to slAOPQ.
*
*   8)  The DATE argument is UTC expressed as an MJD.  This is,
*       strictly speaking, wrong, because of leap seconds.  However,
*       as long as the delta UT and the UTC are consistent there
*       are no difficulties, except during a leap second.  In this
*       case, the start of the 61st second of the final minute should
*       begin a new MJD day and the old pre-leap delta UT should
*       continue to be used.  As the 61st second completes, the MJD
*       should revert to the start of the day as, simultaneously,
*       the delta UTC changes by one second to its post-leap new value.
*
*   9)  The delta UT (UT1-UTC) is tabulated in IERS circulars and
*       elsewhere.  It increases by exactly one second at the end of
*       each UTC leap second, introduced in order to keep delta UT
*       within +/- 0.9 seconds.
*
*  10)  IMPORTANT -- TAKE CARE WITH THE LONGITUDE SIGN CONVENTION.
*       The longitude required by the present routine is east-positive,
*       in accordance with geographical convention (and right-handed).
*       In particular, note that the longitudes returned by the
*       slOBS routine are west-positive, following astronomical
*       usage, and must be reversed in sign before use in the present
*       routine.
*
*  11)  The polar coordinates XP,YP can be obtained from IERS
*       circulars and equivalent publications.  The maximum amplitude
*       is about 0.3 arcseconds.  If XP,YP values are unavailable,
*       use XP=YP=0D0.  See page B60 of the 1988 Astronomical Almanac
*       for a definition of the two angles.
*
*  12)  The height above sea level of the observing station, HM,
*       can be obtained from the Astronomical Almanac (Section J
*       in the 1988 edition), or via the routine slOBS.  If P,
*       the pressure in millibars, is available, an adequate
*       estimate of HM can be obtained from the expression
*
*             HM ~ -29.3D0*TSL*LOG(P/1013.25D0).
*
*       where TSL is the approximate sea-level air temperature in K
*       (see Astrophysical Quantities, C.W.Allen, 3rd edition,
*       section 52).  Similarly, if the pressure P is not known,
*       it can be estimated from the height of the observing
*       station, HM, as follows:
*
*             P ~ 1013.25D0*EXP(-HM/(29.3D0*TSL)).
*
*       Note, however, that the refraction is nearly proportional to the
*       pressure and that an accurate P value is important for precise
*       work.
*
*  13)  The azimuths etc produced by the present routine are with
*       respect to the celestial pole.  Corrections to the terrestrial
*       pole can be computed using slPLMO.
*
*  Called:  slAOPA, slAOPQ
*
*  Last revision:   2 December 2005
*
*  Copyright P.T.Wallace.   All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RAP,DAP,DATE,DUT,ELONGM,PHIM,HM,
     :                 XP,YP,TDK,PMB,RH,WL,TLR,AOB,ZOB,HOB,DOB,ROB

      DOUBLE PRECISION AOPRMS(14)


      CALL slAOPA(DATE,DUT,ELONGM,PHIM,HM,XP,YP,TDK,PMB,RH,WL,TLR,
     :               AOPRMS)
      CALL slAOPQ(RAP,DAP,AOPRMS,AOB,ZOB,HOB,DOB,ROB)

      END

#-h-  outdon			  257  local   12/01/80  15:54:31
# outdon - finish off an output line
    include  defs

    subroutine outdon

    include COMMON_BLOCKS

    integer allblk
    integer itoc, ip, op, i
    character obuf(80)
    string s_line "#line "

    # If dbgout is enabled output the "#line" statement.
    if (dbgout == YES) {
	if ((body == YES | dbglev != level) & linect (level) > 0) {
	    op = 1
	    for (ip=1;  s_line(ip) != EOS;  ip=ip+1) {
		obuf(op) = s_line(ip)
		op = op + 1
	    }

	    op = op + itoc (linect, obuf(op), 80-op+1)
	    obuf(op) = BLANK
	    op = op + 1
	    obuf(op) = DQUOTE
	    op = op + 1

	    for (i=fnamp-1;  i >= 1;  i=i-1)
		if (fnames(i-1) == EOS | i == 1) {	 # print file name
		    for (ip=i;  fnames(ip) != EOS;  ip=ip+1) {
			obuf(op) = fnames(ip)
			op = op + 1
		    }
		    break
		}

	    obuf(op) = DQUOTE
	    op = op + 1
	    obuf(op) = NEWLINE
	    op = op + 1
	    obuf(op) = EOS
	    op = op + 1

	    call putlin (obuf, STDOUT)
	    dbglev = level
	}
    }

    # Output the program statement.
    outbuf (outp + 1) = NEWLINE
    outbuf (outp + 2) = EOS
    if (allblk (outbuf) == NO)
	call putlin (outbuf, STDOUT)
    outp = 0

    return
    end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGGETF (TPID,FUSR)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGGETF may be used to get the real (floating-point) value
C of any single AUTOGRAPH control parameter.
C
      CALL AGGETP (TPID,FURA,1)
      FUSR=FURA(1)
      RETURN
C
      END

C--------------------------------------------------------------------------
        subroutine ftgkns(iunit,keywrd,nstart,nmax,strval,nfound,
     &                    status)

C       read an array of character string values from  header records
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name
C       nstart  i  starting sequence number (usually 1)
C       nmax    i  number of keywords to read
C       OUTPUT PARAMETERS:
C       strval  i  array of output keyword values
C       nfound  i  number of keywords found
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,strval(*)
        integer iunit,nstart,nmax,nfound,status,tstat
        integer nkeys,mkeys,i,ival,nend,namlen,indval,ibuff
        character inname*8,keynam*8
        character*80 value,comm

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(iunit)

C       for efficiency, we want to search just once through the header
C       for all the keywords which match the root.

        nfound=0
        nend=nstart+nmax-1
        inname=keywrd
        call ftupch(inname)

C       find the length of the root name
        namlen=0
        do 5 i=8,1,-1
                if (inname(i:i) .ne. ' ')then
                        namlen=i
                        go to 6
                end if
5       continue
6       if (namlen .eq. 0)return

C       get the number of keywords in the header
        call ftghsp(iunit,nkeys,mkeys,status)

        do 10 i=3,nkeys
                call ftgrec(iunit,i,value,status)
                if (status .gt. 0)return
                keynam=value(1:8)
                if (keynam(1:namlen) .eq. inname(1:namlen))then

C                   try to interpret the remainder of the name as an integer
                    tstat=status
                    call ftc2ii(keynam(namlen+1:8),ival,status)
                    if (status .le. 0)then
                      if (ival .le. nend .and. ival .ge. nstart)then

C                       OK, this looks like a valid keyword; Reset the
C                       next-header-keyword pointer by one record, then
C                       call ftgkys to read it. (This does  support
C                       long continued string values)

                        nxthdr(ibuff)=nxthdr(ibuff)-80
                        indval=ival-nstart+1
                        call ftgkys(iunit,keynam,strval(indval),
     &                              comm,status)

                        nfound=max(nfound,indval)                       
                      end if
                    else
                        if (status .eq. 407)then
                                status=tstat
                        else
                                return
                        end if
                    end if
                end if
10      continue
        end

      integer function lookup (symbol, info, st)
      integer symbol (100)
      integer info (100)
      integer st
      integer mem( 60000)
      common/cdsmem/mem
      integer i, nodsiz, kluge
      integer stlu
      integer node, pred
      if (.not.(stlu (symbol, node, pred, st) .eq. 0))goto 23000
      lookup = 0
      return
23000 continue
      nodsiz = mem (st)
      i = 1
23002 if (.not.(i .le. nodsiz))goto 23004
      kluge = node + 1 - 1 + i
      info (i) = mem (kluge)
23003 i = i + 1
      goto 23002
23004 continue
      lookup = 1
      return
      end

C--------------------------------------------------------------------------
        subroutine ftphis(ounit,histry,status)

C       write a HISTORY record to the FITS header
C
C       ounit   i  fortran output unit number
C       histry  c  input history string
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,status,strlen,actlen,i,nkeys,c1,c2
        character*(*) histry
        character*80  rec

        if (status .gt. 0)return
                
C       find the length of the string, and write it out 70 characters at a time
        nkeys=1
        strlen=len(histry)
        actlen=strlen
        do 10 i=strlen,1,-1
                if (histry(i:i) .ne. ' ')then
                        actlen=i
                        go to 20
                end if
10      continue

20      c1=1
        c2=min(actlen,70)
        nkeys=(actlen-1)/70+1
        do 30 i=1,nkeys
                rec='HISTORY   '//histry(c1:c2)
                call ftprec(ounit,rec,status)
                c1=c1+70
                c2=min(actlen,c2+70)
30      continue
        end

C--------------------------------------------------------------------------
        subroutine ftpcom(ounit,commnt,status)

C       write a COMMENT record to the FITS header
C
C       ounit   i  fortran output unit number
C       commnt c  input comment string 
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,status,strlen,actlen,i,nkeys,c1,c2
        character*(*) commnt
        character*80  rec

        if (status .gt. 0)return

C       find the length of the string, and write it out 70 characters at a time
        nkeys=1
        strlen=len(commnt)
        actlen=strlen
        do 10 i=strlen,1,-1
                if (commnt(i:i) .ne. ' ')then
                        actlen=i
                        go to 20
                end if
10      continue

20      c1=1
        c2=min(actlen,70)
        nkeys=(actlen-1)/70+1
        do 30 i=1,nkeys
                rec='COMMENT   '//commnt(c1:c2)
                call ftprec(ounit,rec,status)
                c1=c1+70
                c2=min(actlen,c2+70)
30      continue
        end

      subroutine synerr (msg)
      integer msg
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer lc (20)
      integer i, junk
      integer itoc
      integer of(5)
      integer errmsg(100)
      data of(1)/32/,of(2)/111/,of(3)/102/,of(4)/32/,of(5)/-2/
      data errmsg(1)/69/,errmsg(2)/114/,errmsg(3)/114/,errmsg(4)/111/,er
     *rmsg(5)/114/,errmsg(6)/32/,errmsg(7)/111/,errmsg(8)/110/,errmsg(9)
     */32/,errmsg(10)/108/,errmsg(11)/105/,errmsg(12)/110/,errmsg(13)/10
     *1/,errmsg(14)/32/,errmsg(15)/-2/
      call putlin (errmsg, 2)
      if (.not.(level .ge. 1))goto 23000
      i = level
      goto 23001
23000 continue
      i = 1
23001 continue
      junk = itoc (linect (i), lc, 20)
      call putlin (lc, 2)
      i = fnamp - 1
23002 if (.not.(i .ge. 1))goto 23004
      if (.not.(fnames (i - 1) .eq. -2 .or. i .eq. 1))goto 23005
      call putlin (of, 2)
      call putlin (fnames (i), 2)
      goto 23004
23005 continue
23003 i = i - 1
      goto 23002
23004 continue
      call putch (58, 2)
      call putch (32, 2)
      call remark (msg)
      return
      end
c     logic0  logical_column

      SUBROUTINE slDS2C (A, B, V)
*+
*     - - - - - -
*      D S 2 C
*     - - - - - -
*
*  Spherical coordinates to direction cosines (double precision)
*
*  Given:
*     A,B       d      spherical coordinates in radians
*                         (RA,Dec), (long,lat) etc.
*
*  Returned:
*     V         d(3)   x,y,z unit vector
*
*  The spherical coordinates are longitude (+ve anticlockwise looking
*  from the +ve latitude pole) and latitude.  The Cartesian coordinates
*  are right handed, with the x axis at zero longitude and latitude, and
*  the z axis at the +ve latitude pole.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION A,B,V(3)

      DOUBLE PRECISION COSB


      COSB = COS(B)

      V(1) = COS(A)*COSB
      V(2) = SIN(A)*COSB
      V(3) = SIN(B)

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
c +noao:  blockdata rewritten to be run time initialization
c     BLOCK DATA AGDFLT
      subroutine agdflt
C
C The block data subroutine AGDFLT defines the default values of those
C AUTOGRAPH parameters which can be declared in a DATA statement.  See
C AGINIT for code initializing other AUTOGRAPH parameters.
C
C Following are declarations of all the AUTOGRAPH common blocks.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The following common block contains other AUTOGRAPH variables, of
C type character.
C
      COMMON /AGOCHP/ CHS1,CHS2
C
c+noao
c     CHARACTER*504 CHS1,CHS2
      CHARACTER*500 CHS1,CHS2
c-noao
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
C
      COMMON /AGCHR2/ CHRA(2000)
C
      CHARACTER*1 CHRA
C
c +noao:  logical flag added to prevent "over-initialization"
      logical first
      data first /.true./
      call utilbd
      if (.not. first) return
      first = .false.
c -noao
C ---------------------------------------------------------------------
C
C Following are declarations of default values of variables in the
C AUTOGRAPH common blocks.
C
C ---------------------------------------------------------------------
C
C QFRA defines the control parameter 'FRAME.', which specifies when, if
C ever, the EZ... routines are to call FRAME to advance to a new frame.
C
c     DATA QFRA / 1. /
      QFRA = 1. 
C
C QSET defines the control parameter 'SET.', which determines how the
C last call to the plot-package routine "SET" is to affect AUTOGRAPH.
C
c     DATA QSET / 1. /
      QSET = 1.
C
C QROW defines the control parameter 'ROW.', which determines how the x
C and y input arrays (in calls to AGSTUP and AGCURV) are to be used.
C
c     DATA QROW / 1. /
      QROW = 1.
C
C QIXY defines the control parameter 'INVERT.', which, if set non-zero,
C causes the routines AGSTUP and AGCURV to behave as if the arguments
C defining the x and y data had been interchanged.
C
c     DATA QIXY / 0. /
      QIXY = 0.
C
C QWND defines the control parameter 'WINDOW.', which, if set non-zero,
C causes curves drawn to be scissored by the edge of the curve window.
C
c     DATA QWND / 0. /
      QWND = 0.
C
C QBAC defines the control parameter 'BACKGROUND.', which can be given
C any of four values to set up four specific types of plot background.
C
c     DATA QBAC / 1. /
      QBAC = 1.
C
C SVAL defines the control parameters 'NULL/1.' and 'NULL/2.', which are
C used in various ways by AUTOGRAPH.
C
c     DATA SVAL(1) / 1E36 / , SVAL(2) / 2E36 /
      SVAL(1) = 1E36 
      SVAL(2) = 2E36
C
C XLGF, XRGF, YBGF, and YTGF define the parameter-group 'GRAPH.'; they
C specify the position of the graph window within the plotter frame.
C
c     DATA XLGF / 0. / , XRGF / 1. / , YBGF / 0. / , YTGF / 1. /
      XLGF = 0. 
      XRGF = 1.
      YBGF = 0.
      YTGF = 1.
C
C XLGD, XRGD, YBGD, and YTGD define the first four parameters in the
C group 'GRID.'; they specify the position of the grid window within
C the graph window.
C
c     DATA XLGD / .15 / , XRGD / .95 / , YBGD / .15 / , YTGD / .95 /
      XLGD = .15
      XRGD = .95 
      YBGD = .15 
      YTGD = .95
C
C SOGD defines the control parameter 'GRID/SHAPE.', which defines the
C shape of the grid window.
C
c     DATA SOGD / 0. /
      SOGD = 0.
C
C XMIN and XMAX define the control parameters 'X/MIN.' and 'X/MAX.',
C which determine how minimum and maximum values of x are to be chosen.
C Null values imply that AUTOGRAPH is to choose real values; non-null
C values are the actual values to be used (perhaps after rounding).
C
c     DATA XMIN / 1E36 / , XMAX / 1E36 /
      XMIN = 1E36
      XMAX = 1E36
C
C QLUX defines the control parameter 'X/LOG.', which is set non-zero to
C specify that the horizontal axis is to be logarithmic.
C
c     DATA QLUX / 0. /
      QLUX = 0.
C
C QOVX defines the control parameter 'X/ORDER.', which is set non-zero
C to flip the horizontal axis end-for-end.
C
c     DATA QOVX / 0. /
      QOVX = 0.
C
C QCEX defines the control parameter 'X/NICE.', which determines which,
C if either, of the horizontal axes is to have "nice" (rounded) values
C at its ends.
C
c     DATA QCEX / -1. /
      QCEX = -1.
C
C XLOW and XHGH define the control parameters 'X/SMALLEST.' and
C 'X/LARGEST.'; they come into play only when XMIN and/or XMAX are null
C and they are non-null, in which case they set limits on the range of
C x data to be considered when choosing the minimum and/or maximum.
C
c     DATA XLOW / 1E36 / , XHGH / 1E36 /
      XLOW = 1E36
      XHGH = 1E36
C
C YMIN and YMAX define the control parameters 'Y/MIN.' and 'Y/MAX.',
C which determine how minimum and maximum values of y are to be chosen.
C Null values imply that AUTOGRAPH is to choose real values; non-null
C values are the actual values to be used (perhaps after rounding).
C
c     DATA YMIN / 1E36 / , YMAX / 1E36 /
      YMIN = 1E36
      YMAX = 1E36
C
C QLUY defines the control parameter 'Y/LOG.', which is set non-zero to
C specify that the horizontal axis is to be logarithmic.
C
c     DATA QLUY / 0. /
      QLUY = 0.
C
C QOVY defines the control parameter 'Y/ORDER.', which is set non-zero
C to flip the horizontal axis end-for-end.
C
c     DATA QOVY / 0. /
      QOVY = 0.
C
C QCEY defines the control parameter 'Y/NICE.', which determines which,
C if either, of the horizontal axes is to have "nice" (rounded) values
C at its ends.
C
c     DATA QCEY / -1. /
      QCEY = -1.
C
C YLOW and YHGH define the control parameters 'Y/SMALLEST.' and
C 'Y/LARGEST.'; they come into play only when YMIN and/or YMAX are null
C and they are non-null, in which case they set limits on the range of
C y data to be considered when choosing the minimum and/or maximum.
C
c     DATA YLOW / 1E36 / , YHGH / 1E36 /
      YLOW = 1E36
      YHGH = 1E36
C
C QDAX(i) defines the control parameters 'AXIS/s/CONTROL.' (i=1 implies
C s='LEFT', i=2 implies s='RIGHT', i=3 implies s='BOTTOM', i=4 implies
C s='TOP').  Each of these specifies whether or not a given axis will
C be drawn or not and what liberties may be taken with numeric labels
C on the axis.
C
c     DATA QDAX(1)/ 4. / , QDAX(2)/ 4. / , QDAX(3)/ 4. / , QDAX(4)/ 4. /
      QDAX(1) = 4.
      QDAX(2) = 4.
      QDAX(3) = 4.
      QDAX(4) = 4.
C
C Each QSPA(i) defines a control parameter 'AXIS/s/LINE.', which says
C whether or not the line portion of a particular axis is to be drawn.
C
c     DATA QSPA(1)/ 0. / , QSPA(2)/ 0. / , QSPA(3)/ 0. / , QSPA(4)/ 0. /
      QSPA(1) = 0.
      QSPA(2) = 0.
      QSPA(3) = 0.
      QSPA(4) = 0.
C
C Each PING(i) defines a control parameter 'AXIS/s/INTERSECTION/GRID.',
C which may be used to move a particular axis to a specified position.
C
c     DATA PING(1)/1E36/ , PING(2)/1E36/ , PING(3)/1E36/ , PING(4)/1E36/
      PING(1) = 1E36
      PING(2) = 1E36
      PING(3) = 1E36
      PING(4) = 1E36
C
C Each PINU(i) defines a control parameter 'AXIS/s/INTERSECTION/USER.',
C which may be used to move a particular axis to a specified position.
C
c     DATA PINU(1)/1E36/ , PINU(2)/1E36/ , PINU(3)/1E36/ , PINU(4)/1E36/
      PINU(1) = 1E36
      PINU(2) = 1E36
      PINU(3) = 1E36
      PINU(4) = 1E36
C
C Each FUNS(i) defines a control parameter 'AXIS/s/FUNCTION.', which is
C used within a user-supplied version of AGUTOL to select a particular
C uset-system-to-label-system mapping for a particular axis.  The
C default value selects the identity mapping.
C
c     DATA FUNS(1)/ 0. / , FUNS(2)/ 0. / , FUNS(3)/ 0. / , FUNS(4)/ 0. /
      FUNS(1) =  0.
      FUNS(2) =  0.
      FUNS(3) =  0.
      FUNS(4) =  0.
C
C The values of QBTD(i), BASD(i), QMJD(i), QJDP(i), WMJL(i), and WMJR(i)
C together define the control-parameter group 'AXIS/s/TICKS/MAJOR.',
C which determines the positioning and appearance of the major ticks on
C a particular axis.
C
c     DATA QBTD(1)/1E36/ , QBTD(2)/1E36/ , QBTD(3)/1E36/ , QBTD(4)/1E36/
c     DATA BASD(1)/1E36/ , BASD(2)/1E36/ , BASD(3)/1E36/ , BASD(4)/1E36/
c     DATA QMJD(1)/ 6. / , QMJD(2)/ 6. / , QMJD(3)/ 6. / , QMJD(4)/ 6. /
c     DATA QJDP(1)/1E36/ , QJDP(2)/1E36/ , QJDP(3)/1E36/ , QJDP(4)/1E36/
c     DATA WMJL(1)/ 0. / , WMJL(2)/ 0. / , WMJL(3)/ 0. / , WMJL(4)/ 0. /
c     DATA WMJR(1)/.015/ , WMJR(2)/.015/ , WMJR(3)/.015/ , WMJR(4)/.015/
      QBTD(1) = 1E36
      QBTD(2) = 1E36
      QBTD(3) = 1E36
      QBTD(4) = 1E36
      BASD(1) = 1E36
      BASD(2) = 1E36
      BASD(3) = 1E36
      BASD(4) = 1E36
      QMJD(1) =  6. 
      QMJD(2) =  6. 
      QMJD(3) =  6. 
      QMJD(4) =  6. 
      QJDP(1) = 1E36
      QJDP(2) = 1E36
      QJDP(3) = 1E36
      QJDP(4) = 1E36
      WMJL(1) =  0. 
      WMJL(2) =  0. 
      WMJL(3) =  0. 
      WMJL(4) =  0. 
      WMJR(1) = .015
      WMJR(2) = .015
      WMJR(3) = .015
      WMJR(4) = .015
C
C The values of QMND(i), QNDP(i), WMNL(i), and WMNR(i) together define
C the control-parameter group 'AXIS/s/TICKS/MINOR.', which determines
C the positioning and appearance of the major ticks on a particular
C axis.
C
c     DATA QMND(1)/1E36/ , QMND(2)/1E36/ , QMND(3)/1E36/ , QMND(4)/1E36/
c     DATA QNDP(1)/1E36/ , QNDP(2)/1E36/ , QNDP(3)/1E36/ , QNDP(4)/1E36/
c     DATA WMNL(1)/ 0. / , WMNL(2)/ 0. / , WMNL(3)/ 0. / , WMNL(4)/ 0. /
c     DATA WMNR(1)/.010/ , WMNR(2)/.010/ , WMNR(3)/.010/ , WMNR(4)/.010/
      QMND(1) = 1E36
      QMND(2) = 1E36
      QMND(3) = 1E36
      QMND(4) = 1E36
      QNDP(1) = 1E36
      QNDP(2) = 1E36
      QNDP(3) = 1E36
      QNDP(4) = 1E36
      WMNL(1) =  0. 
      WMNL(2) =  0. 
      WMNL(3) =  0. 
      WMNL(4) =  0. 
      WMNR(1) = .010
      WMNR(2) = .010
      WMNR(3) = .010
      WMNR(4) = .010
C
C The values of QLTD(i), QLED(i), QLFD(i), QLOF(i), QLOS(i), DNLA(i),
C WCLM(i), and WCLE(i) together define the control-parameter group
C 'AXIS/s/NUMERIC.', which determines the positioning and appearance of
C the numeric labels on a particular axis.
C
c     DATA QLTD(1)/1E36/ , QLTD(2)/  0./ , QLTD(3)/1E36/ , QLTD(4)/  0./
c     DATA QLED(1)/1E36/ , QLED(2)/1E36/ , QLED(3)/1E36/ , QLED(4)/1E36/
c     DATA QLFD(1)/1E36/ , QLFD(2)/1E36/ , QLFD(3)/1E36/ , QLFD(4)/1E36/
c     DATA QLOF(1)/ 0. / , QLOF(2)/ 0. / , QLOF(3)/ 0. / , QLOF(4)/ 0. /
c     DATA QLOS(1)/ 90./ , QLOS(2)/ 90./ , QLOS(3)/ 90./ , QLOS(4)/ 90./
c     DATA DNLA(1)/.015/ , DNLA(2)/.015/ , DNLA(3)/.015/ , DNLA(4)/.015/
c     DATA WCLM(1)/.015/ , WCLM(2)/.015/ , WCLM(3)/.015/ , WCLM(4)/.015/
c     DATA WCLE(1)/.010/ , WCLE(2)/.010/ , WCLE(3)/.010/ , WCLE(4)/.010/
      QLTD(1) = 1E36
      QLTD(2) =   0.
      QLTD(3) = 1E36
      QLTD(4) =   0.
      QLED(1) = 1E36
      QLED(2) = 1E36
      QLED(3) = 1E36
      QLED(4) = 1E36
      QLFD(1) = 1E36
      QLFD(2) = 1E36
      QLFD(3) = 1E36
      QLFD(4) = 1E36
      QLOF(1) =  0. 
      QLOF(2) =  0. 
      QLOF(3) =  0. 
      QLOF(4) =  0. 
      QLOS(1) =  90.
      QLOS(2) =  90.
      QLOS(3) =  90.
      QLOS(4) =  90.
      DNLA(1) = .015
      DNLA(2) = .015
      DNLA(3) = .015
      DNLA(4) = .015
      WCLM(1) = .015
      WCLM(2) = .015
      WCLM(3) = .015
      WCLM(4) = .015
      WCLE(1) = .010
      WCLE(2) = .010
      WCLE(3) = .010
      WCLE(4) = .010
C
C QODP defines the control parameter 'DASH/SELECTOR.', the sign of which
C determines which set of dash patterns is used by EZMY and EZMXY (the
C alphabetic set or the user-specified set); if the user-specified set
C is selected, the magnitude of QODP determines how many of them are to
C be used.
C
c     DATA QODP / 1. /
      QODP = 1. 
C
C QCDP defines the control parameter 'DASH/LENGTH.', which specifies the
C assumed length of dash patterns tendered to AUTOGRAPH.
C
c     DATA QCDP / 8. /
      QCDP =  8. 
C
C WOCD and WODQ define the control parameters 'DASH/CHARACTER.' and
C 'DASH/DOLLAR-QUOTE.', which specify the widths of characters used in
C character-string dash patterns.
C
c     DATA WOCD / .010 / , WODQ / .010 /
      WOCD = .010 
      WODQ = .010
C
C QDSH defines the control-parameter group 'DASH/PATTERN.'.  Each value,
C if positive, defines a binary dash pattern, and, if negative, serves
C as an identifier in retrieving a character-string dash pattern.
C
c     DATA QDSH / 26*65535. /
      do 20, ijk = 1, 26
  20      QDSH(ijk) = 65535.
C
C QDLB defines the control parameter 'LABEL/CONTROL.', which specifies
C what may be done with informational labels in response to overlap
C problems.
C
c     DATA QDLB /2./
      QDLB = 2.
C
C QBIM defines the control parameter 'LABEL/BUFFER/LENGTH.' and must
C be equal to the second dimension of the array FLLB.
C
c     DATA QBIM / 8. /
      QBIM =  8.
C
C QBAN defines the control parameter 'LABEL/NAME.'; its value is really
C a pointer into the label list.  The default value, zero, means that
C the pointer has not been set.
C
c     DATA QBAN / 0. /
      QBAN =  0.
C
C QLLN defines the control parameter 'LINE/MAXIMUM.' - the assumed
C maximum length of character strings intended for use as the text of a
C line of a label.
C
c     DATA QLLN /40./
      QLLN = 40.
C
C TCLN defines the control parameter 'LINE/TERMINATOR.' - which is used
C to mark the end of character strings intended for use as the text of a
C line of a label.  It is initialized in AGINIT.
C
C QNIM defines the control parameter 'LINE/BUFFER/LENGTH.' and must be
C equal to the second dimension of FLLN.
C
c     DATA QNIM / 16. /
      QNIM =  16.
C
C QNAN defines the control parameter 'LINE/NUMBER.'; its value is really
C a pointer into the line list.  The default value, zero, says that the
C pointer has not been set.
C
c     DATA QNAN / 0. /
      QNAN =  0.
C
C (FLLB(I,1),I=1,10) and (FLLN(I,1),I=1,6) define the label to the left
C of the grid.  The name, in FLLB(1,1), and the line text, in FLLN(4,1),
C must be filled in by AGINIT.
C
c     DATA FLLB( 1,1)/   0./ , FLLB( 2,1)/   0./ , FLLB( 3,1)/   0./ ,
c    +     FLLB( 4,1)/   .5/ , FLLB( 5,1)/-.015/ , FLLB( 6,1)/   0./ ,
c    +     FLLB( 7,1)/  90./ , FLLB( 8,1)/   0./ , FLLB( 9,1)/   1./ ,
c    +     FLLB(10,1)/   1./ , FLLN( 1,1)/+100./ , FLLN( 2,1)/   0./ ,
c    +     FLLN( 3,1)/ .015/ , FLLN( 4,1)/  -2./ , FLLN( 5,1)/   1./ ,
c    +     FLLN( 6,1)/   0./
           FLLB( 1,1) = 0.
           FLLB( 2,1) = 0.
           FLLB( 3,1) = 0.
           FLLB( 4,1) = .5
           FLLB( 5,1) = -.015
           FLLB( 6,1) = 0.
           FLLB( 7,1) = 90.
           FLLB( 8,1) = 0.
           FLLB( 9,1) = 1.
           FLLB(10,1) = 1.
           FLLN( 1,1) = +100.
           FLLN( 2,1) = 0.
           FLLN( 3,1) = .015
           FLLN( 4,1) = -2.
           FLLN( 5,1) = 1.
           FLLN( 6,1) = 0.
C
C (FLLB(I,2),I=1,10) and (FLLN(I,2),I=1,6) define the label to the right
C of the grid.  The name, in FLLB(1,2), and the line text, in FLLN(4,2),
C must be filled in by AGINIT.
C
c     DATA FLLB( 1,2)/   0./ , FLLB( 2,2)/   0./ , FLLB( 3,2)/   1./ ,
c    +     FLLB( 4,2)/   .5/ , FLLB( 5,2)/+.015/ , FLLB( 6,2)/   0./ ,
c    +     FLLB( 7,2)/  90./ , FLLB( 8,2)/   0./ , FLLB( 9,2)/   1./ ,
c    +     FLLB(10,2)/   2./ , FLLN( 1,2)/-100./ , FLLN( 2,2)/   0./ ,
c    +     FLLN( 3,2)/ .015/ , FLLN( 4,2)/  -3./ , FLLN( 5,2)/   0./ ,
c    +     FLLN( 6,2)/   0./
           FLLB( 1,2) =  0.
           FLLB( 2,2) =  0.
           FLLB( 3,2) =  1.
           FLLB( 4,2) =  .5
           FLLB( 5,2) = +.015
           FLLB( 6,2) =  0.
           FLLB( 7,2) = 90.
           FLLB( 8,2) =  0.
           FLLB( 9,2) =  1.
           FLLB(10,2) =  2.
           FLLN( 1,2) = -100.
           FLLN( 2,2) =  0.
           FLLN( 3,2) =  .015
           FLLN( 4,2) =  -3.
           FLLN( 5,2) =  0.
           FLLN( 6,2) =  0.
C
C (FLLB(I,3),I=1,10) and (FLLN(I,3),I=1,6) define the label below the
C grid.  The name, in FLLB(1,3), and the line text, in FLLN(4,3), must
C be filled in by AGINIT.
C
c     DATA FLLB( 1,3)/   0./ , FLLB( 2,3)/   0./ , FLLB( 3,3)/   .5/ ,
c    +     FLLB( 4,3)/   0./ , FLLB( 5,3)/   0./ , FLLB( 6,3)/-.015/ ,
c    +     FLLB( 7,3)/   0./ , FLLB( 8,3)/   0./ , FLLB( 9,3)/   1./ ,
c    +     FLLB(10,3)/   3./ , FLLN( 1,3)/-100./ , FLLN( 2,3)/   0./ ,
c    +     FLLN( 3,3)/ .015/ , FLLN( 4,3)/  -1./ , FLLN( 5,3)/   1./ ,
c    +     FLLN( 6,3)/   0./
           FLLB( 1,3) =  0.
           FLLB( 2,3) =  0.
           FLLB( 3,3) = .5
           FLLB( 4,3) =  0.
           FLLB( 5,3) =  0.
           FLLB( 6,3) = -.015
           FLLB( 7,3) =  0.
           FLLB( 8,3) =  0.
           FLLB( 9,3) =  1.
           FLLB(10,3) =  3.
           FLLN( 1,3) = -100.
           FLLN( 2,3) =  0.
           FLLN( 3,3) =  .015
           FLLN( 4,3) =   -1.
           FLLN( 5,3) =  1.
           FLLN( 6,3) =  0.
C
C (FLLB(I,4),I=1,10) and (FLLN(I,4),I=1,6) define the label above the
C grid.  The name, in FLLB(1,4), and the line text, in FLLN(4,4), must
C be filled in by AGINIT.
C
c     DATA FLLB( 1,4)/   0./ , FLLB( 2,4)/   0./ , FLLB( 3,4)/   .5/ ,
c    +     FLLB( 4,4)/   1./ , FLLB( 5,4)/   0./ , FLLB( 6,4)/+.020/ ,
c    +     FLLB( 7,4)/   0./ , FLLB( 8,4)/   0./ , FLLB( 9,4)/   1./ ,
c    +     FLLB(10,4)/   4./ , FLLN( 1,4)/+100./ , FLLN( 2,4)/   0./ ,
c    +     FLLN( 3,4)/ .020/ , FLLN( 4,4)/  -3./ , FLLN( 5,4)/   0./ ,
c    +     FLLN( 6,4)/   0./
           FLLB( 1,4) =  0.
           FLLB( 2,4) =  0.
           FLLB( 3,4) =  .5
           FLLB( 4,4) =  1.
           FLLB( 5,4) =  0.
           FLLB( 6,4) = +.020
           FLLB( 7,4) =  0.
           FLLB( 8,4) =  0.
           FLLB( 9,4) =  1.
           FLLB(10,4) =  4.
           FLLN( 1,4) = +100.
           FLLN( 2,4) =  0.
           FLLN( 3,4) =  .020
           FLLN( 4,4) =  -3.
           FLLN( 5,4) =  0.
           FLLN( 6,4) =  0.
C
C Certain secondary parameters must be initialized to prevent bombing.
C
c     DATA QBTP(1)/  0./ , QBTP(2)/  0./ , QBTP(3)/  0./ , QBTP(4)/  0./
c     DATA BASE(1)/  0./ , BASE(2)/  0./ , BASE(3)/  0./ , BASE(4)/  0./
c     DATA QMNT(1)/  0./ , QMNT(2)/  0./ , QMNT(3)/  0./ , QMNT(4)/  0./
c     DATA QLTP(1)/  0./ , QLTP(2)/  0./ , QLTP(3)/  0./ , QLTP(4)/  0./
c     DATA QLEX(1)/  0./ , QLEX(2)/  0./ , QLEX(3)/  0./ , QLEX(4)/  0./
c     DATA QLFL(1)/  0./ , QLFL(2)/  0./ , QLFL(3)/  0./ , QLFL(4)/  0./
c     DATA QCIM(1)/  0./ , QCIM(2)/  0./ , QCIM(3)/  0./ , QCIM(4)/  0./
c     DATA QCIE(1)/  0./ , QCIE(2)/  0./ , QCIE(3)/  0./ , QCIE(4)/  0./
c     DATA RFNL(1)/  0./ , RFNL(2)/  0./ , RFNL(3)/  0./ , RFNL(4)/  0./
c     DATA QLUA(1)/  0./ , QLUA(2)/  0./ , QLUA(3)/  0./ , QLUA(4)/  0./
      QBTP(1) =   0.
      QBTP(2) =   0.
      QBTP(3) =   0.
      QBTP(4) =   0.
      BASE(1) =   0.
      BASE(2) =   0.
      BASE(3) =   0.
      BASE(4) =   0.
      QMNT(1) =   0.
      QMNT(2) =   0.
      QMNT(3) =   0.
      QMNT(4) =   0.
      QLTP(1) =   0.
      QLTP(2) =   0.
      QLTP(3) =   0.
      QLTP(4) =   0.
      QLEX(1) =   0.
      QLEX(2) =   0.
      QLEX(3) =   0.
      QLEX(4) =   0.
      QLFL(1) =   0.
      QLFL(2) =   0.
      QLFL(3) =   0.
      QLFL(4) =   0.
      QCIM(1) =   0.
      QCIM(2) =   0.
      QCIM(3) =   0.
      QCIM(4) =   0.
      QCIE(1) =   0.
      QCIE(2) =   0.
      QCIE(3) =   0.
      QCIE(4) =   0.
      RFNL(1) =   0.
      RFNL(2) =   0.
      RFNL(3) =   0.
      RFNL(4) =   0.
      QLUA(1) =   0.
      QLUA(2) =   0.
      QLUA(3) =   0.
      QLUA(4) =   0.
C
C SMRL and ISLD are set by the routine AGINIT (which see, below).
C
C MWCL, MWCM, MWCE, MDLA, MWCD, and MWDQ are the minimum widths of label
C characters, mantissa characters, exponent characters, label-to-axis
C distances, dash-pattern characters, and dash-pattern spaces, respect-
C ively (in the plotter coordinate system).
C
c     DATA MWCL /8/, MWCM /8/, MWCE /8/, MDLA /8/, MWCD /8/, MWDQ /8/
      MWCL = 8
      MWCM = 8
      MWCE = 8
      MDLA = 8
      MWCD = 8
      MWDQ = 8
C
C INIF is an initialization flag, set non-zero to indicate that the
C routine AGINIT has been executed to set the values of AUTOGRAPH
C parameters which, for one reason or another, cannot be preset by
C this block data routine.
C
c     DATA INIF / 0 /
      INIF =  0 
C
C CHS1 and CHS2 are used within AUTOGRAPH when manipulating character
C strings retrieved by calls to AGGTCH.  They need not be preset.
C
C LNIC is the second dimension of the array (INCH) which holds an index
C of the character strings stored by AGSTCH.
C
c     DATA LNIC / 50 /
      LNIC = 50 
C
C INCH is an index of character strings currently stored in CHRA.  Each
C entry has the following format:
C
C    INCH(1,I), if non-zero, is the index, in the array CHRA, of the
C    first character of the Ith character string.
C
C    INCH(2,I) is the length of the Ith character string.
C
c     DATA (INCH(1,I),I=1,50) / 50*0 /
c     DATA (INCH(2,I),I=1,50) / 50*0 /
      do 10, ijk = 1, 50
        inch (1, ijk) = 0
        inch (2, ijk) = 0
  10  continue
C
C LNCA is the size of the array (CHRA) in which AGSTCH stores character
C strings.
C
c     DATA LNCA / 2000 /
      LNCA =  2000 
C
C INCA is the index of the last character used in CHRA.
C
c     DATA INCA / 0 /
      INCA =  0 
C
C CHRA holds character strings stored by AGSTCH.  It need not be pre-set
C to anything.
C
      return
c 
      entry initag
      first = .true.
      END

C--------------------------------------------------------------------------
        subroutine ftgcnn(iunit,casesn,templt,colnam,colnum,status)

C       determine the column name and number corresponding to an input 
C       column name template string.  The template may contain the * and ?
C       wildcards.  Status = 237 is returned if match is not unique.
C       One may call this routine again with input status=237  to
C       get the next match.  

C       iunit   i  Fortran i/o unit number
C       casesn  l  true if an exact case match of the names is required
C       templt  c  templt for column name
C       colnam  c  name of (first) column that matchs the template
C       colnum  i  number of the column (first column = 1)
C                       (a value of 0 is returned if the column is not found)
C       status  i  returned error status

C       written by Wm Pence, HEASARC/GSFC, December 1994

        integer iunit,colnum,status
        character*(*) templt,colnam
        logical casesn

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne,nf
        parameter (nb = 20)
        parameter (ne = 200)
        parameter (nf = 3000)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        integer colpnt,untpnt
        common/ftname/colpnt,untpnt
C       END OF COMMON BLOCK DEFINITIONS------------------------------------

        integer ibuff,i,nfound,tstat,ival
        logical match,exact,founde,foundw,unique
        character*80 errmsg
        character*68 tname(999)
        save tname

        ibuff=bufnum(iunit)

C       load the common block with names, if not already defined
        if (colpnt .eq. -999 .or. iunit .ne. untpnt)then
            do 10 i=1,tfield(ibuff)
                tname(i)=' '
10          continue
            call ftgkns(iunit,'TTYPE',1,nf,tname,nfound,status)
            if (status .gt. 0)return
            untpnt=iunit
            colpnt=1
        end if

        if (status .le. 0)then
            tstat=0
            colpnt=1
        else if (status .eq. 237)then
C           search for next non-unique match, starting from the previous match
            tstat=237
            status=0
        else
            return
        end if

        colnam=' '
        colnum=0


C       set the 'found exact' and 'found wildcard' flags to false
        founde=.false.
        foundw=.false.
       
        do 100 i=colpnt,tfield(ibuff)
C               test for match between template and column name
                call ftcmps(templt,tname(i),casesn,match,exact)

                if (match)then
                    if (founde .and. exact)then
C                       warning: this is the second exact match we've found
C                       reset pointer to first match so next search starts there
                        colpnt=colnum+1
                        status=237
                        return
                    else if (founde)then
C                       already found exact match so ignore this non-exact match
                    else if (exact)then
C                       this is the first exact match we have found, so save it.
                        colnam=tname(i)
                        colnum=i
                        founde=.true.
                    else if (foundw)then
C                       we have already found a wild card match, so not unique
C                       continue searching for other matches
                        unique=.false.
                    else
C                       this is the first wild card match we've found. save it
                        colnam=tname(i)
                        colnum=i
                        foundw=.true.
                        unique=.true.
                    end if
                end if
100     continue        

C       OK, we've checked all the names now see if we got any matches
        if (founde)then
C           we did find 1 exact match
            if (tstat .eq. 237)status=237
        else if (foundw)then
C           we found one or more wildcard matches
C           report error if not unique
            if (.not. unique .or. tstat .eq. 237)status=237
        else
C           didn't find a match; check if template is a simple positive integer
            call ftc2ii(templt,ival,tstat)
            if (tstat .eq. 0 .and. ival .le. tfield(ibuff) 
     &          .and. ival .gt. 0)then
                colnum=ival
                colnam=tname(ival)
            else
                status=219
                if (tstat .ne. 237)then
                  errmsg='FTGCNN: Could not find column: '//templt
                  call ftpmsg(errmsg)
                end if
            end if
        end if

C       reset pointer so next search starts here if input status=237
        colpnt=colnum+1
        end

include	defs

# makpat --- make pattern from arg (from), terminate at delim

   integer function makpat (arg, from, delim, pat)
   character arg (MAXARG), delim, pat (MAXPAT)
   integer from

   character esc

   integer i, j, junk, lastcl, lastj, lj,
      tagnst, tagnum, tagstk (9)
   integer addset, getccl, stclos

   j = 1      # pat index
   lastj = 1
   lastcl = 0
   tagnum = 0
   tagnst = 0
   for (i = from; arg (i) != delim & arg (i) != EOS; i = i + 1) {
      lj = j
      if (arg (i) == ANY)
	 junk = addset (ANY, pat, j, MAXPAT)
      else if (arg (i) == BOL & i == from)
	 junk = addset (BOL, pat, j, MAXPAT)
      else if (arg (i) == EOL & arg (i + 1) == delim)
	 junk = addset (EOL, pat, j, MAXPAT)
      else if (arg (i) == CCL) {
	 if (getccl (arg, i, pat, j) == ERR) {
	    makpat = ERR
	    return
	    }
	 }
      else if (arg (i) == CLOSURE & i > from) {
	 lj = lastj
	 if (pat (lj) == BOL | pat (lj) == EOL | pat (lj) == CLOSURE |
	       pat (lj) == START_TAG | pat (lj) == STOP_TAG)
	    break
	 lastcl = stclos (pat, j, lastj, lastcl)
	 }
      else if (arg (i) == START_TAG) {
	 if (tagnum >= 9)    # too many tagged sub-patterns
	    break
	 tagnum = tagnum + 1
	 tagnst = tagnst + 1
	 tagstk (tagnst) = tagnum
	 junk = addset (START_TAG, pat, j, MAXPAT)
	 junk = addset (tagnum, pat, j, MAXPAT)
	 }
      else if (arg (i) == STOP_TAG & tagnst > 0) {
	 junk = addset (STOP_TAG, pat, j, MAXPAT)
	 junk = addset (tagstk (tagnst), pat, j, MAXPAT)
	 tagnst = tagnst - 1
	 }
      else {
	 junk = addset (CHAR, pat, j, MAXPAT)
	 junk = addset (esc (arg, i), pat, j, MAXPAT)
	 }
      lastj = lj
      }
   if (arg (i) != delim)   # terminated early
      makpat = ERR
   else if (addset (EOS, pat, j, MAXPAT) == NO)   # no room
      makpat = ERR
   else if (tagnst != 0)
      makpat = ERR
   else
      makpat = i
   return
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE DISPLA (LFRA,LROW,LTYP)
C
C The subroutine DISPLA resets the parameters IFRA, IROW, and/or LLUX
C and LLUY.
C
      IF (LFRA.NE.0) CALL AGSETI ('FRAM.', MAX0(1,MIN0(3,LFRA)))
C
      IF (LROW.NE.0) CALL AGSETI ('ROW .',LROW)
C
      IF (LTYP.EQ.0) RETURN
C
      ITYP=MAX0(1,MIN0(4,LTYP))
      CALL AGSETI ('X/LOGA.',   (1-ITYP)/2)
      CALL AGSETI ('Y/LOGA.',MOD(1-ITYP,2))
C
      RETURN
C
      END

      integer function addset (c, str, j, maxsiz)
      integer j, maxsiz
      integer c, str (maxsiz)
      if (.not.(j .gt. maxsiz))goto 23000
      addset = 0
      goto 23001
23000 continue
      str(j) = c
      j = j + 1
      addset = 1
23001 continue
      return
      end

      subroutine tautsp ( tau, gtau, ntau, gamma, s,
     *			  break, coef, l, k, iflag )
c  from  * a practical guide to splines *  by c. de boor
constructs cubic spline interpolant to given data
c	  tau(i), gtau(i), i=1,...,ntau.
c  if  gamma .gt. 0., additional knots are introduced where needed to
c  make the interpolant more flexible locally. this avoids extraneous
c  inflection points typical of cubic spline interpolation at knots to
c  rapidly changing data.
c
c  parameters
c	     input
c  tau	    sequence of data points. must be strictly increasing.
c  gtau     corresponding sequence of function values.
c  ntau     number of data points. must be at least  4 .
c  gamma    indicates whether additional flexibility is desired.
c	   = 0., no additional knots
c	   in (0.,3.), under certain conditions on the given data at
c		 points i-1, i, i+1, and i+2, a knot is added in the
c		 i-th interval, i=2,...,ntau-2. see description of meth-
c		 od below. the interpolant gets rounded with increasing
c		 gamma. a value of  2.5  for gamma is typical.
c	   in (3.,6.), same , except that knots might also be added in
c		 intervals in which an inflection point would be permit-
c		 ted.  a value of  5.5	for gamma is typical.
c	     output
c  break, coef, l, k  give the pp-representation of the interpolant.
c	   specifically, for break(i) .le. x .le. break(i+1), the
c	 interpolant has the form
c  f(x) = coef(1,i) +dx(coef(2,i) +(dx/2)(coef(3,i) +(dx/3)coef(4,i)))
c	 with  dx = x - break(i) and i=1,...,l .
c  iflag   = 1, ok
c	   = 2, input was incorrect. a printout specifying the mistake
c	     was made.
c	     workspace
c  s	 is required, of size (ntau,6). the individual columns of this
c	 array contain the following quantities mentioned in the write-
c	 up and below.
c     s(.,1) = dtau = tau(.+1) - tau
c     s(.,2) = diag = diagonal in linear system
c     s(.,3) = u = upper diagonal in linear system
c     s(.,4) = r = right side for linear system (initially)
c	     = fsecnd = solution of linear system , namely the second
c			derivatives of interpolant at  tau
c     s(.,5) = z = indicator of additional knots
c     s(.,6) = 1/hsecnd(1,x) with x = z or = 1-z. see below.
c
c  ------  m e t h o d	------
c  on the i-th interval, (tau(i), tau(i+1)), the interpolant is of the
c  form
c  (*)	f(u(x)) = a + b*u + c*h(u,z) + d*h(1-u,1-z) ,
c  with  u = u(x) = (x - tau(i))/dtau(i). here,
c	z = z(i) = addg(i+1)/(addg(i) + addg(i+1))
c  (= .5, in case the denominator vanishes). with
c	addg(j) = abs(ddg(j)), ddg(j) = dg(j+1) - dg(j),
c	dg(j) = divdif(j) = (gtau(j+1) - gtau(j))/dtau(j)
c  and
c	h(u,z) = alpha*u**3 + (1 - alpha)*(max(((u-zeta)/(1-zeta)),0)**3
c  with
c	alpha(z) = (1-gamma/3)/zeta
c	zeta(z) = 1 - gamma*min((1 - z), 1/3)
c  thus, for 1/3 .le. z .le. 2/3,  f  is just a cubic polynomial on
c  the interval i. otherwise, it has one additional knot, at
c	  tau(i) + zeta*dtau(i) .
c  as  z  approaches  1, h(.,z) has an increasingly sharp bend	near 1,
c  thus allowing  f  to turn rapidly near the additional knot.
c     in terms of f(j) = gtau(j) and
c	fsecnd(j) = 2.derivative of  f	at  tau(j),
c  the coefficients for (*) are given as
c	a = f(i) - d
c	b = (f(i+1) - f(i)) - (c - d)
c	c = fsecnd(i+1)*dtau(i)**2/hsecnd(1,z)
c	d = fsecnd(i)*dtau(i)**2/hsecnd(1,1-z)
c  hence can be computed once fsecnd(i),i=1,...,ntau, is fixed.
c   f  is automatically continuous and has a continuous second derivat-
c  ive (except when z = 0 or 1 for some i). we determine fscnd(.) from
c  the requirement that also the first derivative of  f  be contin-
c  uous. in addition, we require that the third derivative be continuous
c  across  tau(2) and across  tau(ntau-1) . this leads to a strictly
c  diagonally dominant tridiagonal linear system for the fsecnd(i)
c  which we solve by gauss elimination without pivoting.
c
      integer iflag,k,l,ntau,	i,method,ntaum1
      real break(1),coef(4,1),gamma,gtau(ntau),s(ntau,6),tau(ntau)
     *	  ,alpha,c,d,del,denom,divdif,entry,entry3,factor,factr2,gam
     *	  ,onemg3,onemzt,ratio,sixth,temp,x,z,zeta,zt2
      real alph
      alph(x) = amin1(1.,onemg3/x)
c
c  there must be at least  4  interpolation points.
      if (ntau .ge. 4)			go to 5
c     print 600,ntau
c 600 format(8h ntau = ,i4,20h. should be .ge. 4 .)
					go to 999
c
construct delta tau and first and second (divided) differences of data
c
    5 ntaum1 = ntau - 1
      do 6 i=1,ntaum1
	 s(i,1) = tau(i+1) - tau(i)
	 if (s(i,1) .gt. 0.)		go to 6
c	 print 610,i,tau(i),tau(i+1)
c 610	 format(7h point ,i3,13h and the next,2e15.6,15h are disordered)
					go to 999
    6	 s(i+1,4) = (gtau(i+1)-gtau(i))/s(i,1)
      do 7 i=2,ntaum1
    7	 s(i,4) = s(i+1,4) - s(i,4)
c
construct system of equations for second derivatives at  tau. at each
c  interior data point, there is one continuity equation, at the first
c  and the last interior data point there is an additional one for a
c  total of  ntau  equations in  ntau  unknowns.
c
      i = 2
      s(2,2) = s(1,1)/3.
      sixth = 1./6.
      method = 2
      gam = gamma
      if (gam .le. 0.)	 method = 1
      if ( gam .le. 3.) 		go to 9
      method = 3
      gam = gam - 3.
    9 onemg3 = 1. - gam/3.
c		  ------ loop over i ------
   10 continue
c	   construct z(i) and zeta(i)
      z = .5
					go to (19,11,12),method
   11 if (s(i,4)*s(i+1,4) .lt. 0.)	go to 19
   12 temp = abs(s(i+1,4))
      denom = abs(s(i,4)) + temp
      if (denom .eq. 0.)		go to 19
      z = temp/denom
      if (abs(z - .5) .le. sixth)  z = .5
   19 s(i,5) = z
c   ******set up part of the i-th equation which depends on
c	  the i-th interval
      if (z - .5)			21,22,23
   21 zeta = gam*z
      onemzt = 1. - zeta
      zt2 = zeta**2
      alpha = alph(onemzt)
      factor = zeta/(alpha*(zt2-1.) + 1.)
      s(i,6) = zeta*factor/6.
      s(i,2) = s(i,2) + s(i,1)*((1.-alpha*onemzt)*factor/2. - s(i,6))
c     if z = 0 and the previous z = 1, then d(i) = 0. since then
c     also u(i-1) = l(i+1) = 0, its value does not matter. reset
c     d(i) = 1 to insure nonzero pivot in elimination.
      if (s(i,2) .le. 0.) s(i,2) = 1.
      s(i,3) = s(i,1)/6.
					go to 25
   22 s(i,2) = s(i,2) + s(i,1)/3.
      s(i,3) = s(i,1)/6.
					go to 25
   23 onemzt = gam*(1. - z)
      zeta = 1. - onemzt
      alpha = alph(zeta)
      factor = onemzt/(1. - alpha*zeta*(1.+onemzt))
      s(i,6) = onemzt*factor/6.
      s(i,2) = s(i,2) + s(i,1)/3.
      s(i,3) = s(i,6)*s(i,1)
   25 if (i .gt. 2)			go to 30
      s(1,5) = .5
c  ******the first two equations enforce continuity of the first and of
c	 the third derivative across tau(2).
      s(1,2) = s(1,1)/6.
      s(1,3) = s(2,2)
      entry3 = s(2,3)
      if (z - .5)			26,27,28
   26 factr2 = zeta*(alpha*(zt2-1.) + 1.)/(alpha*(zeta*zt2-1.)+1.)
      ratio = factr2*s(2,1)/s(1,2)
      s(2,2) = factr2*s(2,1) + s(1,1)
      s(2,3) = -factr2*s(1,1)
					go to 29
   27 ratio = s(2,1)/s(1,2)
      s(2,2) = s(2,1) + s(1,1)
      s(2,3) = -s(1,1)
					go to 29
   28 ratio = s(2,1)/s(1,2)
      s(2,2) = s(2,1) + s(1,1)
      s(2,3) = -s(1,1)*6.*alpha*s(2,6)
c	at this point, the first two equations read
c	       diag(1)*x1 + u(1)*x2 + entry3*x3 = r(2)
c	-ratio*diag(1)*x1 + diag(2)*x2 + u(2)*x3 = 0.
c	eliminate first unknown from second equation
   29 s(2,2) = ratio*s(1,3) + s(2,2)
      s(2,3) = ratio*entry3 + s(2,3)
      s(1,4) = s(2,4)
      s(2,4) = ratio*s(1,4)
					go to 35
   30 continue
c  ******the i-th equation enforces continuity of the first derivative
c	 across tau(i). it has been set up in statements 35 up to 40
c	 and 21 up to 25 and reads now
c	  -ratio*diag(i-1)*xi-1 + diag(i)*xi + u(i)*xi+1 = r(i) .
c	 eliminate (i-1)st unknown from this equation
      s(i,2) = ratio*s(i-1,3) + s(i,2)
      s(i,4) = ratio*s(i-1,4) + s(i,4)
c
c  ******set up the part of the next equation which depends on the
c	 i-th interval.
   35 if (z - .5)			36,37,38
   36 ratio = -s(i,6)*s(i,1)/s(i,2)
      s(i+1,2) = s(i,1)/3.
					go to 40
   37 ratio = -(s(i,1)/6.)/s(i,2)
      s(i+1,2) = s(i,1)/3.
					go to 40
   38 ratio = -(s(i,1)/6.)/s(i,2)
      s(i+1,2) = s(i,1)*((1.-zeta*alpha)*factor/2. - s(i,6))
c	  ------  end of i loop ------
   40 i = i+1
      if (i .lt. ntaum1)		go to 10
      s(i,5) = .5
c
c	 ------  last two equations  ------
c  the last two equations enforce continuity of third derivative and
c  of first derivative across  tau(ntau-1).
      entry = ratio*s(i-1,3) + s(i,2) + s(i,1)/3.
      s(i+1,2) = s(i,1)/6.
      s(i+1,4) = ratio*s(i-1,4) + s(i,4)
      if (z - .5)			41,42,43
   41 ratio = s(i,1)*6.*s(i-1,6)*alpha/s(i-1,2)
      s(i,2) = ratio*s(i-1,3) + s(i,1) + s(i-1,1)
      s(i,3) = -s(i-1,1)
					go to 45
   42 ratio = s(i,1)/s(i-1,2)
      s(i,2) = ratio*s(i-1,3) + s(i,1) + s(i-1,1)
      s(i,3) = -s(i-1,1)
					go to 45
   43 factr2 = onemzt*(alpha*(onemzt**2-1.)+1.)/
     *		     (alpha*(onemzt**3-1.)+1.)
      ratio = factr2*s(i,1)/s(i-1,2)
      s(i,2) = ratio*s(i-1,3) + factr2*s(i-1,1) + s(i,1)
      s(i,3) = -factr2*s(i-1,1)
c     at this point, the last two equations read
c	      diag(i)*xi + u(i)*xi+1 = r(i)
c      -ratio*diag(i)*xi + diag(i+1)*xi+1 = r(i+1)
c     eliminate xi from last equation
   45 s(i,4) = ratio*s(i-1,4)
      ratio = -entry/s(i,2)
      s(i+1,2) = ratio*s(i,3) + s(i+1,2)
      s(i+1,4) = ratio*s(i,4) + s(i+1,4)
c
c	 ------ back substitution ------
c
      s(ntau,4) = s(ntau,4)/s(ntau,2)
   50	 s(i,4) = (s(i,4) - s(i,3)*s(i+1,4))/s(i,2)
	 i = i - 1
	 if (i .gt. 1)			go to 50
      s(1,4) = (s(1,4)-s(1,3)*s(2,4)-entry3*s(3,4))/s(1,2)
c
c	 ------ construct polynomial pieces ------
c
      break(1) = tau(1)
      l = 1
      do 70 i=1,ntaum1
	 coef(1,l) = gtau(i)
	 coef(3,l) = s(i,4)
	 divdif = (gtau(i+1)-gtau(i))/s(i,1)
	 z = s(i,5)
	 if (z - .5)			61,62,63
   61	 if (z .eq. 0.) 		go to 65
	 zeta = gam*z
	 onemzt = 1. - zeta
	 c = s(i+1,4)/6.
	 d = s(i,4)*s(i,6)
	 l = l + 1
	 del = zeta*s(i,1)
	 break(l) = tau(i) + del
	 zt2 = zeta**2
	 alpha = alph(onemzt)
	 factor = onemzt**2*alpha
	 coef(1,l) = gtau(i) + divdif*del
     *		   + s(i,1)**2*(d*onemzt*(factor-1.)+c*zeta*(zt2-1.))
	 coef(2,l) = divdif + s(i,1)*(d*(1.-3.*factor)+c*(3.*zt2-1.))
	 coef(3,l) = 6.*(d*alpha*onemzt + c*zeta)
	 coef(4,l) = 6.*(c - d*alpha)/s(i,1)
	 coef(4,l-1) = coef(4,l) - 6.*d*(1.-alpha)/(del*zt2)
	 coef(2,l-1) = coef(2,l) - del*(coef(3,l) -(del/2.)*coef(4,l-1))
					go to 68
   62	 coef(2,l) = divdif - s(i,1)*(2.*s(i,4) + s(i+1,4))/6.
	 coef(4,l) = (s(i+1,4)-s(i,4))/s(i,1)
					go to 68
   63	 onemzt = gam*(1. - z)
	 if (onemzt .eq. 0.)		go to 65
	 zeta = 1. - onemzt
	 alpha = alph(zeta)
	 c = s(i+1,4)*s(i,6)
	 d = s(i,4)/6.
	 del = zeta*s(i,1)
	 break(l+1) = tau(i) + del
	 coef(2,l) = divdif - s(i,1)*(2.*d + c)
	 coef(4,l) = 6.*(c*alpha - d)/s(i,1)
	 l = l + 1
	 coef(4,l) = coef(4,l-1) + 6.*(1.-alpha)*c/(s(i,1)*onemzt**3)
	 coef(3,l) = coef(3,l-1) + del*coef(4,l-1)
	 coef(2,l) = coef(2,l-1)+del*(coef(3,l-1)+(del/2.)*coef(4,l-1))
	 coef(1,l) = coef(1,l-1)+del*(coef(2,l-1)+(del/2.)*(coef(3,l-1)
     *			+(del/3.)*coef(4,l-1)))
					go to 68
   65	 coef(2,l) = divdif
	 coef(3,l) = 0.
	 coef(4,l) = 0.
   68	 l = l + 1
   70	 break(l) = tau(i+1)
      l = l - 1
      k = 4
      iflag = 1
					return
  999 iflag = 2
					return
      end

C--------------------------------------------------------------------------
        subroutine ftgacl(iunit,colnum,xtype,xbcol,xunit,xform,
     &        xscal,xzero,xnull,xdisp,status)

C       Get information about an Ascii CoLumn
C       returns the parameters which define the column

C       iunit   i  Fortran i/o unit number
C       colnum  i  number of the column (first column = 1)
C       xtype   c  name of the column
C       xbcol   i  starting character in the row of the column
C       xunit   c  physical units of the column
C       xform   c  Fortran-77 format of the column
C       xscal   d  scaling factor for the column values
C       xzero   d  scaling zero point for the column values
C       xnull   c  value used to represent undefined values in the column
C       xdisp   c  display format for the column (if different from xform
C       status  i  returned error status

        integer iunit,colnum,xbcol,status
        double precision xscal,xzero
        character*(*) xtype,xunit,xform,xnull,xdisp

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C       END OF COMMON BLOCK DEFINITIONS------------------------------------

        integer ibuff,nfound

        if (status .gt. 0)return

        if (colnum .lt. 1 .or. colnum .gt. 999)then
C               illegal column number
                status=302
                return
        end if

        ibuff=bufnum(iunit)

C       get the parameters which are stored in the common block
        xbcol=tbcol(colnum+tstart(ibuff))+1
        xform=cform(colnum+tstart(ibuff))
        xscal=tscale(colnum+tstart(ibuff))
        xzero=tzero(colnum+tstart(ibuff))
        xnull=cnull(colnum+tstart(ibuff))

C       read remaining values from the header keywords
        xtype=' '
        call ftgkns(iunit,'TTYPE',colnum,1,xtype,nfound,status)
        xunit=' '
        call ftgkns(iunit,'TUNIT',colnum,1,xunit,nfound,status)
        xdisp=' '
        call ftgkns(iunit,'TDISP',colnum,1,xdisp,nfound,status)
        end        

      subroutine errchk
      integer tok, lastt0, gnbtok, token(100)
      integer mktabl
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer serrc0(27)
      integer serrd0(31)
      data serrc0(1)/108/,serrc0(2)/111/,serrc0(3)/103/,serrc0(4)/105/,s
     *errc0(5)/99/,serrc0(6)/97/,serrc0(7)/108/,serrc0(8)/32/,serrc0(9)/
     *120/,serrc0(10)/101/,serrc0(11)/114/,serrc0(12)/102/,serrc0(13)/10
     *8/,serrc0(14)/103/,serrc0(15)/44/,serrc0(16)/32/,serrc0(17)/120/,s
     *errc0(18)/101/,serrc0(19)/114/,serrc0(20)/112/,serrc0(21)/97/,serr
     *c0(22)/100/,serrc0(23)/40/,serrc0(24)/56/,serrc0(25)/52/,serrc0(26
     *)/41/,serrc0(27)/-2/
      data serrd0(1)/99/,serrd0(2)/111/,serrd0(3)/109/,serrd0(4)/109/,se
     *rrd0(5)/111/,serrd0(6)/110/,serrd0(7)/32/,serrd0(8)/47/,serrd0(9)/
     *120/,serrd0(10)/101/,serrd0(11)/114/,serrd0(12)/99/,serrd0(13)/111
     */,serrd0(14)/109/,serrd0(15)/47/,serrd0(16)/32/,serrd0(17)/120/,se
     *rrd0(18)/101/,serrd0(19)/114/,serrd0(20)/102/,serrd0(21)/108/,serr
     *d0(22)/103/,serrd0(23)/44/,serrd0(24)/32/,serrd0(25)/120/,serrd0(2
     *6)/101/,serrd0(27)/114/,serrd0(28)/112/,serrd0(29)/97/,serrd0(30)/
     *100/,serrd0(31)/-2/
      tok = 0
23000 continue
      lastt0 = tok
      tok = gnbtok (token, 100)
      I23003=(tok)
      goto 23003
23005 continue
      if (.not.(errtbl .eq. 0))goto 23006
      errtbl = mktabl(0)
      call outtab
      call outstr (serrc0)
      call outdon
      call outtab
      call outstr (serrd0)
      call outdon
23006 continue
      call enter (token, 0, errtbl)
      goto 23004
23008 continue
      goto 23004
23009 continue
      if (.not.(lastt0 .ne. 44))goto 23010
      goto 23002
23010 continue
      goto 23004
23012 continue
      call synerr (35HSyntax error in ERRCHK declaration.)
      goto 23004
23003 continue
      if (I23003.eq.-9)goto 23005
      if (I23003.eq.10)goto 23009
      if (I23003.eq.44)goto 23008
      goto 23012
23004 continue
23001 goto 23000
23002 continue
      end
c     lastt0  last_tok
c     logic0  logical_column
c     serrc0  serrcom1
c     serrd0  serrcom2

      SUBROUTINE slRFCQ ( TDK, PMB, RH, WL, REFA, REFB )
*+
*     - - - - - - -
*      R F C Q
*     - - - - - - -
*
*  Determine the constants A and B in the atmospheric refraction
*  model dZ = A tan Z + B tan**3 Z.  This is a fast alternative
*  to the slRFCO routine - see notes.
*
*  Z is the "observed" zenith distance (i.e. affected by refraction)
*  and dZ is what to add to Z to give the "topocentric" (i.e. in vacuo)
*  zenith distance.
*
*  Given:
*    TDK      d      ambient temperature at the observer (K)
*    PMB      d      pressure at the observer (millibar)
*    RH       d      relative humidity at the observer (range 0-1)
*    WL       d      effective wavelength of the source (micrometre)
*
*  Returned:
*    REFA     d      tan Z coefficient (radian)
*    REFB     d      tan**3 Z coefficient (radian)
*
*  The radio refraction is chosen by specifying WL > 100 micrometres.
*
*  Notes:
*
*  1  The model is an approximation, for moderate zenith distances,
*     to the predictions of the slRFRO routine.  The approximation
*     is maintained across a range of conditions, and applies to
*     both optical/IR and radio.
*
*  2  The algorithm is a fast alternative to the slRFCO routine.
*     The latter calls the slRFRO routine itself:  this involves
*     integrations through a model atmosphere, and is costly in
*     processor time.  However, the model which is produced is precisely
*     correct for two zenith distance (45 degrees and about 76 degrees)
*     and at other zenith distances is limited in accuracy only by the
*     A tan Z + B tan**3 Z formulation itself.  The present routine
*     is not as accurate, though it satisfies most practical
*     requirements.
*
*  3  The model omits the effects of (i) height above sea level (apart
*     from the reduced pressure itself), (ii) latitude (i.e. the
*     flattening of the Earth) and (iii) variations in tropospheric
*     lapse rate.
*
*     The model was tested using the following range of conditions:
*
*       lapse rates 0.0055, 0.0065, 0.0075 K/metre
*       latitudes 0, 25, 50, 75 degrees
*       heights 0, 2500, 5000 metres ASL
*       pressures mean for height -10% to +5% in steps of 5%
*       temperatures -10 deg to +20 deg with respect to 280 deg at SL
*       relative humidity 0, 0.5, 1
*       wavelengths 0.4, 0.6, ... 2 micron, + radio
*       zenith distances 15, 45, 75 degrees
*
*     The accuracy with respect to direct use of the slRFRO routine
*     was as follows:
*
*                            worst         RMS
*
*       optical/IR           62 mas       8 mas
*       radio               319 mas      49 mas
*
*     For this particular set of conditions:
*
*       lapse rate 0.0065 K/metre
*       latitude 50 degrees
*       sea level
*       pressure 1005 mb
*       temperature 280.15 K
*       humidity 80%
*       wavelength 5740 Angstroms
*
*     the results were as follows:
*
*       ZD        slRFRO   slRFCQ  Saastamoinen
*
*       10         10.27        10.27        10.27
*       20         21.19        21.20        21.19
*       30         33.61        33.61        33.60
*       40         48.82        48.83        48.81
*       45         58.16        58.18        58.16
*       50         69.28        69.30        69.27
*       55         82.97        82.99        82.95
*       60        100.51       100.54       100.50
*       65        124.23       124.26       124.20
*       70        158.63       158.68       158.61
*       72        177.32       177.37       177.31
*       74        200.35       200.38       200.32
*       76        229.45       229.43       229.42
*       78        267.44       267.29       267.41
*       80        319.13       318.55       319.10
*
*      deg        arcsec       arcsec       arcsec
*
*     The values for Saastamoinen's formula (which includes terms
*     up to tan^5) are taken from Hohenkerk and Sinclair (1985).
*
*     The results from the much slower but more accurate slRFCO
*     routine have not been included in the tabulation as they are
*     identical to those in the slRFRO column to the 0.01 arcsec
*     resolution used.
*
*  4  Outlandish input parameters are silently limited to mathematically
*     safe values.  Zero pressure is permissible, and causes zeroes to
*     be returned.
*
*  5  The algorithm draws on several sources, as follows:
*
*     a) The formula for the saturation vapour pressure of water as
*        a function of temperature and temperature is taken from
*        expressions A4.5-A4.7 of Gill (1982).
*
*     b) The formula for the water vapour pressure, given the
*        saturation pressure and the relative humidity, is from
*        Crane (1976), expression 2.5.5.
*
*     c) The refractivity of air is a function of temperature,
*        total pressure, water-vapour pressure and, in the case
*        of optical/IR but not radio, wavelength.  The formulae
*        for the two cases are developed from Hohenkerk & Sinclair
*        (1985) and Rueger (2002).
*
*     The above three items are as used in the slRFRO routine.
*
*     d) The formula for beta, the ratio of the scale height of the
*        atmosphere to the geocentric distance of the observer, is
*        an adaption of expression 9 from Stone (1996).  The
*        adaptations, arrived at empirically, consist of (i) a
*        small adjustment to the coefficient and (ii) a humidity
*        term for the radio case only.
*
*     e) The formulae for the refraction constants as a function of
*        n-1 and beta are from Green (1987), expression 4.31.
*
*  References:
*
*     Crane, R.K., Meeks, M.L. (ed), "Refraction Effects in the Neutral
*     Atmosphere", Methods of Experimental Physics: Astrophysics 12B,
*     Academic Press, 1976.
*
*     Gill, Adrian E., "Atmosphere-Ocean Dynamics", Academic Press, 1982.
*
*     Green, R.M., "Spherical Astronomy", Cambridge University Press, 1987.
*
*     Hohenkerk, C.Y., & Sinclair, A.T., NAO Technical Note No. 63, 1985.
*
*     Rueger, J.M., "Refractive Index Formulae for Electronic Distance
*     Measurement with Radio and Millimetre Waves", in Unisurv Report
*     S-68, School of Surveying and Spatial Information Systems,
*     University of New South Wales, Sydney, Australia, 2002.
*
*     Stone, Ronald C., P.A.S.P. 108 1051-1058, 1996.
*
*  Last revision:   2 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION TDK,PMB,RH,WL,REFA,REFB

      LOGICAL OPTIC
      DOUBLE PRECISION T,P,R,W,TDC,PS,PW,WLSQ,GAMMA,BETA



*  Decide whether optical/IR or radio case:  switch at 100 microns.
      OPTIC = WL.LE.100D0

*  Restrict parameters to safe values.
      T = MIN(MAX(TDK,100D0),500D0)
      P = MIN(MAX(PMB,0D0),10000D0)
      R = MIN(MAX(RH,0D0),1D0)
      W = MIN(MAX(WL,0.1D0),1D6)

*  Water vapour pressure at the observer.
      IF (P.GT.0D0) THEN
         TDC = T-273.15D0
         PS = 10D0**((0.7859D0+0.03477D0*TDC)/(1D0+0.00412D0*TDC))*
     :                                    (1D0+P*(4.5D-6+6D-10*TDC*TDC))
         PW = R*PS/(1D0-(1D0-R)*PS/P)
      ELSE
         PW = 0D0
      END IF

*  Refractive index minus 1 at the observer.
      IF (OPTIC) THEN
         WLSQ = W*W
         GAMMA = ((77.53484D-6+(4.39108D-7+3.666D-9/WLSQ)/WLSQ)*P
     :                                                 -11.2684D-6*PW)/T
      ELSE
         GAMMA = (77.6890D-6*P-(6.3938D-6-0.375463D0/T)*PW)/T
      END IF

*  Formula for beta adapted from Stone, with empirical adjustments.
      BETA=4.4474D-6*T
      IF (.NOT.OPTIC) BETA=BETA-0.0074D0*PW*BETA

*  Refraction constants from Green.
      REFA = GAMMA*(1D0-BETA)
      REFB = -GAMMA*(BETA-GAMMA/2D0)

      END

#-h-  dosub			  709  local   12/01/80  15:53:50
# dosub - select macro substring
   include  defs

   subroutine dosub (argstk, i, j)
   integer argstk (ARGSIZE), i, j

   include COMMON_BLOCKS

   integer ap, fc, k, nc
   integer ctoi, length

   if (j - i < 3)
      return
   if (j - i < 4)
      nc = MAXTOK
   else {
      k = argstk (i + 4)
      nc = ctoi (evalst, k)	 # number of characters
      }
   k = argstk (i + 3)	      # origin
   ap = argstk (i + 2)	       # target string
   fc = ap + ctoi (evalst, k) - 1   # first char of substring
   if (fc >= ap & fc < ap + length (evalst (ap))) {   # subarrays
      k = fc + min (nc, length (evalst (fc))) - 1
       for ( ; k >= fc; k = k - 1)
	  call putbak (evalst (k))
       }

    return
    end

      DOUBLE PRECISION FUNCTION slDAT (UTC)
*+
*     - - - -
*      D A T
*     - - - -
*
*  Increment to be applied to Coordinated Universal Time UTC to give
*  International Atomic Time TAI (double precision)
*
*  Given:
*     UTC      d      UTC date as a modified JD (JD-2400000.5)
*
*  Result:  TAI-UTC in seconds
*
*  Notes:
*
*  1  The UTC is specified to be a date rather than a time to indicate
*     that care needs to be taken not to specify an instant which lies
*     within a leap second.  Though in most cases UTC can include the
*     fractional part, correct behaviour on the day of a leap second
*     can only be guaranteed up to the end of the second 23:59:59.
*
*  2  For epochs from 1961 January 1 onwards, the expressions from the
*     file ftp://maia.usno.navy.mil/ser7/tai-utc.dat are used.
*
*  3  The 5ms time step at 1961 January 1 is taken from 2.58.1 (p87) of
*     the 1992 Explanatory Supplement.
*
*  4  UTC began at 1960 January 1.0 (JD 2436934.5) and it is improper
*     to call the routine with an earlier epoch.  However, if this
*     is attempted, the TAI-UTC expression for the year 1960 is used.
*
*
*     :-----------------------------------------:
*     :                                         :
*     :                IMPORTANT                :
*     :                                         :
*     :  This routine must be updated on each   :
*     :     occasion that a leap second is      :
*     :                announced                :
*     :                                         :
*     :  Latest leap second:  2012 July 1       :
*     :                                         :
*     :-----------------------------------------:
*
*  Last revision:   5 July 2008
*
*  Copyright P.T.Wallace.  All rights reserved.
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION UTC

      DOUBLE PRECISION DT



      IF (.FALSE.) THEN

* - - - - - - - - - - - - - - - - - - - - - - *
*  Add new code here on each occasion that a  *
*  leap second is announced, and update the   *
*  preamble comments appropriately.           *
* - - - - - - - - - - - - - - - - - - - - - - *

*     2012 July 1
      ELSE IF (UTC.GE.56109D0) THEN
         DT=35D0

*     2009 January 1
      ELSE IF (UTC.GE.54832D0) THEN
         DT=34D0

*     2006 January 1
      ELSE IF (UTC.GE.53736D0) THEN
         DT=33D0

*     1999 January 1
      ELSE IF (UTC.GE.51179D0) THEN
         DT=32D0

*     1997 July 1
      ELSE IF (UTC.GE.50630D0) THEN
         DT=31D0

*     1996 January 1
      ELSE IF (UTC.GE.50083D0) THEN
         DT=30D0

*     1994 July 1
      ELSE IF (UTC.GE.49534D0) THEN
         DT=29D0

*     1993 July 1
      ELSE IF (UTC.GE.49169D0) THEN
         DT=28D0

*     1992 July 1
      ELSE IF (UTC.GE.48804D0) THEN
         DT=27D0

*     1991 January 1
      ELSE IF (UTC.GE.48257D0) THEN
         DT=26D0

*     1990 January 1
      ELSE IF (UTC.GE.47892D0) THEN
         DT=25D0

*     1988 January 1
      ELSE IF (UTC.GE.47161D0) THEN
         DT=24D0

*     1985 July 1
      ELSE IF (UTC.GE.46247D0) THEN
         DT=23D0

*     1983 July 1
      ELSE IF (UTC.GE.45516D0) THEN
         DT=22D0

*     1982 July 1
      ELSE IF (UTC.GE.45151D0) THEN
         DT=21D0

*     1981 July 1
      ELSE IF (UTC.GE.44786D0) THEN
         DT=20D0

*     1980 January 1
      ELSE IF (UTC.GE.44239D0) THEN
         DT=19D0

*     1979 January 1
      ELSE IF (UTC.GE.43874D0) THEN
         DT=18D0

*     1978 January 1
      ELSE IF (UTC.GE.43509D0) THEN
         DT=17D0

*     1977 January 1
      ELSE IF (UTC.GE.43144D0) THEN
         DT=16D0

*     1976 January 1
      ELSE IF (UTC.GE.42778D0) THEN
         DT=15D0

*     1975 January 1
      ELSE IF (UTC.GE.42413D0) THEN
         DT=14D0

*     1974 January 1
      ELSE IF (UTC.GE.42048D0) THEN
         DT=13D0

*     1973 January 1
      ELSE IF (UTC.GE.41683D0) THEN
         DT=12D0

*     1972 July 1
      ELSE IF (UTC.GE.41499D0) THEN
         DT=11D0

*     1972 January 1
      ELSE IF (UTC.GE.41317D0) THEN
         DT=10D0

*     1968 February 1
      ELSE IF (UTC.GE.39887D0) THEN
         DT=4.2131700D0+(UTC-39126D0)*0.002592D0

*     1966 January 1
      ELSE IF (UTC.GE.39126D0) THEN
         DT=4.3131700D0+(UTC-39126D0)*0.002592D0

*     1965 September 1
      ELSE IF (UTC.GE.39004D0) THEN
         DT=3.8401300D0+(UTC-38761D0)*0.001296D0

*     1965 July 1
      ELSE IF (UTC.GE.38942D0) THEN
         DT=3.7401300D0+(UTC-38761D0)*0.001296D0

*     1965 March 1
      ELSE IF (UTC.GE.38820D0) THEN
         DT=3.6401300D0+(UTC-38761D0)*0.001296D0

*     1965 January 1
      ELSE IF (UTC.GE.38761D0) THEN
         DT=3.5401300D0+(UTC-38761D0)*0.001296D0

*     1964 September 1
      ELSE IF (UTC.GE.38639D0) THEN
         DT=3.4401300D0+(UTC-38761D0)*0.001296D0

*     1964 April 1
      ELSE IF (UTC.GE.38486D0) THEN
         DT=3.3401300D0+(UTC-38761D0)*0.001296D0

*     1964 January 1
      ELSE IF (UTC.GE.38395D0) THEN
         DT=3.2401300D0+(UTC-38761D0)*0.001296D0

*     1963 November 1
      ELSE IF (UTC.GE.38334D0) THEN
         DT=1.9458580D0+(UTC-37665D0)*0.0011232D0

*     1962 January 1
      ELSE IF (UTC.GE.37665D0) THEN
         DT=1.8458580D0+(UTC-37665D0)*0.0011232D0

*     1961 August 1
      ELSE IF (UTC.GE.37512D0) THEN
         DT=1.3728180D0+(UTC-37300D0)*0.001296D0

*     1961 January 1
      ELSE IF (UTC.GE.37300D0) THEN
         DT=1.4228180D0+(UTC-37300D0)*0.001296D0

*     Before that
      ELSE
         DT=1.4178180D0+(UTC-37300D0)*0.001296D0

      END IF

      slDAT=DT

      END

      subroutine sva (a,mda,m,n,mdata,b,sing,names,iscale,d)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c               singular value analysis printout
c
c     iscale       set by user to 1, 2, or 3 to select column scaling
c                  option.
c                  1   subr will use identity scaling and ignore the d()
c                      array.
c                  2   subr will scale nonzero cols to have unit euclide
c                      length and will store reciprocal lengths of
c                      original nonzero cols in d().
c                  3   user supplies col scale factors in d(). subr
c                      will mult col j by d(j) and remove the scaling
c                      from the soln at the end.
c
      dimension  a(mda,n), b(m), sing(01),d(n)
c     sing(3*n)
      dimension names(n)
      logical test
      double precision   sb, dzero
      dzero=0.d0
      one=1.
      zero=0.
      if (m.le.0 .or. n.le.0) return
      np1=n+1
      write (6,270)
      write (6,260) m,n,mdata
      go to (60,10,10), iscale
c
c     apply column scaling to a
c
   10      do 50 j=1,n
           a1=d(j)
           go to (20,20,40), iscale
   20      sb=dzero
                do 30 i=1,m
   30           sb=sb+dble(a(i,j))**2
           a1=dsqrt(sb)
           if (a1.eq.zero) a1=one
           a1=one/a1
           d(j)=a1
   40           do 50 i=1,m
   50           a(i,j)=a(i,j)*a1
      write (6,280) iscale,(d(j),j=1,n)
      go to 70
   60 continue
      write (6,290)
   70 continue
c
c     obtain  sing. value decomp. of scaled matrix.
c
c**********************************************************
      call svdrs (a,mda,m,n,b,1,1,sing,ier)
      if (ier.eq.0) goto 75
         write (6,295)
         return
   75 continue
c**********************************************************
c
c     print the v matrix.
c
      call mfeout (a,mda,n,n,names,1)
      if (iscale.eq.1) go to 90
c
c     replace v by d*v in the array a()
c
           do 80 i=1,n
                do 80 j=1,n
   80           a(i,j)=d(i)*a(i,j)
c
c     g  now in  b array.  v now in a array.
c
c
c     obtain summary output.
c
   90 continue
      write (6,220)
c
c     compute cumulative sums of squares of components of
c     g and store them in sing(i), i=minmn+1,...,2*minmn+1
c
      sb=dzero
      minmn=min0(m,n)
      minmn1=minmn+1
      if (m.eq.minmn) go to 110
           do 100 i=minmn1,m
  100      sb=sb+dble(b(i))**2
  110 sing(2*minmn+1)=sb
           do 120 jj=1,minmn
           j=minmn+1-jj
           sb=sb+dble(b(j))**2
           js=minmn+j
  120      sing(js)=sb
      a3=sing(minmn+1)
      a4=sqrt(a3/float(max0(1,mdata)))
      write (6,230) a3,a4
c
      nsol=0
c
c
c
           do 160 k=1,minmn
           if (sing(k).eq.zero) go to 130
           nsol=k
           pi=b(k)/sing(k)
           a1=one/sing(k)
           a2=b(k)**2
           a3=sing(minmn1+k)
           a4=sqrt(a3/float(max0(1,mdata-k)))
           test=sing(k).ge.100..or.sing(k).lt..001
           if (test) write (6,240) k,sing(k),pi,a1,b(k),a2,a3,a4
           if (.not.test) write (6,250) k,sing(k),pi,a1,b(k),a2,a3,a4
           go to 140
  130      write (6,240) k,sing(k)
           pi=zero
  140           do 150 i=1,n
                a(i,k)=a(i,k)*pi
  150           if (k.gt.1) a(i,k)=a(i,k)+a(i,k-1)
  160      continue
c
c     compute and print values of ynorm and rnorm.
c
      write (6,300)
      j=0
      ysq=zero
      go to 180
  170 j=j+1
      ysq=ysq+(b(j)/sing(j))**2
  180 ynorm=sqrt(ysq)
      js=minmn1+j
      rnorm=sqrt(sing(js))
      yl=-1000.
      if (ynorm.gt.0.) yl=alog10(ynorm)
      rl=-1000.
      if (rnorm.gt.0.) rl=alog10(rnorm)
      write (6,310) j,ynorm,rnorm,yl,rl
      if (j.lt.nsol) go to 170
c
c     compute values of xnorm and rnorm for a sequence of values of
c     the levenberg-marquardt parameter.
c
      if (sing(1).eq.zero) go to 210
      el=alog10(sing(1))+one
      el2=alog10(sing(nsol))-one
      del=(el2-el)/20.
      ten=10.
      aln10=alog(ten)
      write (6,320)
           do 200 ie=1,21
c     compute        alamb=10.**el
           alamb=exp(aln10*el)
           ys=0.
           js=minmn1+nsol
           rs=sing(js)
                do 190 i=1,minmn
                sl=sing(i)**2+alamb**2
                ys=ys+(b(i)*sing(i)/sl)**2
                rs=rs+(b(i)*(alamb**2)/sl)**2
  190           continue
           ynorm=sqrt(ys)
           rnorm=sqrt(rs)
           rl=-1000.
           if (rnorm.gt.zero) rl=alog10(rnorm)
           yl=-1000.
           if (ynorm.gt.zero) yl=alog10(ynorm)
           write (6,330) alamb,ynorm,rnorm,el,yl,rl
           el=el+del
  200      continue
c
c     print candidate solutions.
c
  210 if (nsol.ge.1) call mfeout (a,mda,n,nsol,names,2)
      return
  220 format (42h0 index  sing. value       p coef         ,48hrecip. s.
     1v.             g coef            g**2  ,
     234h            c.s.s.    n.s.r.c.s.s.)
  230 format (1h ,5x,1h0,88x,1pe15.4,1pe17.4)
  240 format (1h ,i6,e12.4,1p,(e15.4,4x,e15.4,4x,e15.4,4x,e15.4,4x,e15.4
     1,2x,e15.4))
  250 format (1h ,i6,f12.4,1p,(e15.4,4x,e15.4,4x,e15.4,4x,e15.4,4x,e15.4
     1,2x,e15.4))
  260 format (5h0m = ,i6,8h,   n = ,i4,12h,   mdata = ,i8)
  270 format (45h0singular value analysis of the least squares,42h probl
     1em,  a*x=b,  scaled as  (a*d)*y=b  .)
  280 format (19h0scaling option no.,i2,18h.  d is a diagonal,46h matrix
     1 with the following diagonal elements../(5x,10e12.4))
  290 format (50h0scaling option no. 1.   d is the identity matrix./1x)
  295 format (49h convergence failure in qr bidiagonal svd routine)
  300 format (6h0index,13x,28h         ynorm         rnorm,14x,28h  log1
     10(ynorm)  log10(rnorm)/1x)
  310 format (1h ,i4,14x,2e14.5,14x,2f14.5)
  320 format (54h0norms of solution and residual vectors for a range of,
     144h values of the levenberg-marquardt parameter,9h, lambda./1h0,4x
     2,42h        lambda         ynorm         rnorm,
     345h log10(lambda)     log10(ynorm)  log10(rnorm))
  330 format (5x,3e14.5,3f14.5)
      end

      SUBROUTINE XMPL10
C
C Define the data arrays.
C
      REAL XDRA(1201),YDRA(1201)
C
C Fill the data arrays.  The independent variable represents time during
C the year (a hypothetical year with equal-length months) and is set up
C so that the minor ticks can be lengthened to delimit the months; the
C major ticks, though shortened to invisibility, will determine where
C the labels go.
C
      DO 101 I=1,1201
        XDRA(I)=FLOAT(I-51)
        YDRA(I)=COSH(FLOAT(I-601)/202.)
  101 CONTINUE
C
C Change the labels on the bottom and left axes.
C
      CALL ANOTAT ('MONTHS OF THE YEAR$','ROMAN NUMERALS$',0,0,0,0)
C
C Fix the minimum and maximum values on both axes and prevent AUTOGRAPH
C from using rounded values at the ends of the axes.
C
      CALL AGSETF ('X/MIN.',-50.)
      CALL AGSETF ('X/MAX.',1150.)
      CALL AGSETI ('X/NICE.',0)
C
      CALL AGSETF ('Y/MIN.',1.)
      CALL AGSETF ('Y/MAX.',10.)
      CALL AGSETI ('Y/NICE.',0)
C
C Specify the spacing between major tick marks on all axes.  Note that
C the AUTOGRAPH dummy routine AGCHNL is supplanted (below) by one which
C supplies dates for the bottom axis and Roman numerals for the left
C axis in place of the numeric labels one would otherwise get.
C
      CALL AGSETI ('  LEFT/MAJOR/TYPE.',1)
      CALL AGSETI (' RIGHT/MAJOR/TYPE.',1)
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',1)
      CALL AGSETI ('   TOP/MAJOR/TYPE.',1)
C
      CALL AGSETF ('  LEFT/MAJOR/BASE.',  1.)
      CALL AGSETF (' RIGHT/MAJOR/BASE.',  1.)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',100.)
      CALL AGSETF ('   TOP/MAJOR/BASE.',100.)
C
C Suppress minor ticks on the left and right axes.
C
      CALL AGSETI ('  LEFT/MINOR/SPACING.',0)
      CALL AGSETI (' RIGHT/MINOR/SPACING.',0)
C
C On the bottom and top axes, put one minor tick between each pair of
C major ticks, shorten the major ticks to invisibility, and lengthen
C the minor ticks.  The net effect is to make the minor ticks delimit
C the beginning and end of each month, while the major ticks, though
C invisible, cause the names of the months to be where we want them.
C
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',1)
      CALL AGSETI ('   TOP/MINOR/SPACING.',1)
C
      CALL AGSETF ('BOTTOM/MAJOR/INWARD. ',0.)
      CALL AGSETF ('BOTTOM/MINOR/INWARD. ',.015)
      CALL AGSETF ('   TOP/MAJOR/INWARD. ',0.)
      CALL AGSETF ('   TOP/MINOR/INWARD. ',.015)
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,1201,'EXAMPLE 10 (MODIFIED NUMERIC LABELS)$')
C
c     STOP
C
      END
      SUBROUTINE AGCHNL (IAXS,VILS,CHRM,MCIM,NCIM,IPXM,CHRE,MCIE,NCIE)
C
      CHARACTER*(*) CHRM,CHRE
C
C The routine AGCHNL is called by AGAXIS just after it has set up the
C character strings comprising a numeric label along an axis.  The
C default version does nothing.  A user may supply his own version to
C change the numeric labels.  For each numeric label, this routine is
C called twice by AGAXIS - once to determine how much space will be
C required when the label is actually drawn and once just before it
C is actually drawn.  The arguments are as follows:
C
C - IAXS is the number of the axis being drawn.  Its value is 1, 2, 3,
C   or 4, implying the left, right, bottom, or top axes, respectively.
C   The value of IAXS must not be altered.
C
C - VILS is the value to be represented by the numeric label, in the
C   label system for the axis.  The value of VILS must not be altered.
C
C - CHRM, on entry, is a character string containing the mantissa of the
C   numeric label, as it will appear if AGCHNL makes no changes.  If the
C   numeric label includes a "times" symbol, it will be represented by
C   a blank in CHRM.  (See IPXM, below.)  CHRM may be modified.
C
C - MCIM is the length of CHRM - the maximum number of characters that
C   it will hold.  The value of MCIM must not be altered.
C
C - NCIM, on entry, is the number of meaningful characters in CHRM.  If
C   CHRM is changed, NCIM should be changed accordingly.
C
C - IPXM, on entry, is zero if there is no "times" symbol in CHRM; if it
C   is non-zero, it is the index of the appropriate character position
C   in CHRM.  If AGCHNL changes the position of the "times" symbol in
C   CHRM, removes it, or adds it, the value of IPXM must be changed.
C
C - CHRE, on entry, is a character string containing the exponent of the
C   numeric label, as it will appear if AGCHNL makes no changes.  CHRE
C   may be modified.
C
C - MCIE is the length of CHRE - the maximum number of characters that
C   it will hold.  The value of MCIE must not be altered.
C
C - NCIE, on entry, is the number of meaningful characters in CHRE.  If
C   CHRE is changed, NCIE should be changed accordingly.
C
C Define the names of the months for use on the bottom axis.
C
      CHARACTER*3 MONS(12)
      DATA MONS / 'JAN','FEB','MAR','APR','MAY','JUN',
     +            'JUL','AUG','SEP','OCT','NOV','DEC'/
C
C Modify the numeric labels on the left axis.
C
      IF (IAXS.EQ.1) THEN
        CALL AGCORN (IFIX(VILS),CHRM,NCIM)
        IPXM=0
        NCIE=0
C
C Modify the numeric labels on the bottom axis.
C
      ELSE IF (IAXS.EQ.3) THEN
        IMON=IFIX(VILS+.5)/100+1
        CHRM(1:3)=MONS(IMON)
        NCIM=3
        IPXM=0
        NCIE=0
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE AGCORN (NTGR,BCRN,NCRN)
C
      CHARACTER*(*) BCRN
C
C This routine receives an integer in NTGR and returns its Roman-numeral
C equivalent - NCRN characters - in the character variable BCRN.  It
C only works for integers within a limited range and it does some rather
C unorthodox things (like using zero and minus).
C
C ICH1, ICH5, and IC10 are character variables used for the single-unit,
C five-unit, and ten-unit symbols at a given level.
C
      CHARACTER*1 ICH1,ICH5,IC10
C
C Treat numbers outside the range (-4000,+4000) as infinites.
C
      IF (IABS(NTGR).GE.4000) THEN
        IF (NTGR.GT.0) THEN
          NCRN=5
          BCRN(1:5)='(INF)'
        ELSE
          NCRN=6
          BCRN(1:6)='(-INF)'
        END IF
        RETURN
      END IF
C
C Use the symbol '0' for the zero.  The Romans never had it so good.
C
      IF (NTGR.EQ.0) THEN
        NCRN=1
        BCRN(1:1)='0'
        RETURN
      END IF
C
C Zero the character counter.
C
      NCRN=0
C
C Handle negative integers by prefixing a minus sign.
C
      IF (NTGR.LT.0) THEN
        NCRN=NCRN+1
        BCRN(NCRN:NCRN)='-'
      END IF
C
C Initialize some constants.  We'll check for thousands first.
C
      IMOD=10000
      IDIV=1000
      ICH1='M'
C
C Find out how many thousands (hundreds, tens, units) there are and jump
C to the proper code block for each case.
C
  101 INTG=MOD(IABS(NTGR),IMOD)/IDIV
C
      GO TO (107,104,104,104,102,103,103,103,103,106) , INTG+1
C
C Four - add ICH1 followed by ICH5.
C
  102 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH1
C
C Five through eight - add ICH5, followed by INTG-5 ICH1's.
C
  103 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH5
C
      INTG=INTG-5
      IF (INTG.LE.0) GO TO 107
C
C One through three - add that many ICH1's.
C
  104 DO 105 I=1,INTG
        NCRN=NCRN+1
        BCRN(NCRN:NCRN)=ICH1
  105 CONTINUE
C
      GO TO 107
C
C Nine - add ICH1, followed by IC10.
C
  106 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH1
      NCRN=NCRN+1
      BCRN(NCRN:NCRN)=IC10
C
C If we're done, exit.
C
  107 IF (IDIV.EQ.1) RETURN
C
C Otherwise, tool up for the next digit and loop back.
C
      IMOD=IMOD/10
      IDIV=IDIV/10
      IC10=ICH1
C
      IF (IDIV.EQ.100) THEN
        ICH5='D'
        ICH1='C'
      ELSE IF (IDIV.EQ.10) THEN
        ICH5='L'
        ICH1='X'
      ELSE
        ICH5='V'
        ICH1='I'
      END IF
C
      GO TO 101
C
      END

      integer function length (str)
      integer str (100)
      length = 0
23000 if (.not.(str (length+1) .ne. -2))goto 23002
23001 length = length + 1
      goto 23000
23002 continue
      return
      end

      subroutine factrb ( w, ipivot, d, nrow, ncol, last, iflag )
c  adapted from p.132 of 'element.numer.analysis' by conte-de boor
c
c  constructs a partial plu factorization, corresponding to steps 1,...,
c   l a s t   in gauss elimination, for the matrix  w  of order
c   ( n r o w ,  n c o l ), using pivoting of scaled rows.
c
c  parameters
c    w	     contains the (nrow,ncol) matrix to be partially factored
c	     on input, and the partial factorization on output.
c    ipivot  an integer array of length nrow containing a record of the
c	     pivoting strategy used; row ipivot(i) is used during the
c	     i-th elimination step, i=1,...,last.
c    d	     a work array of length nrow used to store row sizes
c	     temporarily.
c    nrow    number of rows of w.
c    ncol    number of columns of w.
c    last    number of elimination steps to be carried out.
c    iflag   on output, equals iflag on input times (-1)**(number of
c	     row interchanges during the factorization process), in
c	     case no zero pivot was encountered.
c	     otherwise, iflag = 0 on output.
c
      integer nrow
      integer ipivot(nrow),ncol,last,iflag, i,ipivi,ipivk,j,k,kp1
      real w(nrow,ncol),d(nrow), awikdi,colmax,ratio,rowmax
c  initialize ipivot, d
      do 10 i=1,nrow
	 ipivot(i) = i
	 rowmax = 0.
	 do 9 j=1,ncol
    9	    rowmax = amax1(rowmax, abs(w(i,j)))
	 if (rowmax .eq. 0.)		go to 999
   10	 d(i) = rowmax
c gauss elimination with pivoting of scaled rows, loop over k=1,.,last
      k = 1
c	 as pivot row for k-th step, pick among the rows not yet used,
c	 i.e., from rows ipivot(k),...,ipivot(nrow), the one whose k-th
c	 entry (compared to the row size) is largest. then, if this row
c	 does not turn out to be row ipivot(k), redefine ipivot(k) ap-
c	 propriately and record this interchange by changing the sign
c	 of  i f l a g .
   11	 ipivk = ipivot(k)
	 if (k .eq. nrow)		go to 21
	 j = k
	 kp1 = k+1
	 colmax = abs(w(ipivk,k))/d(ipivk)
c	       find the (relatively) largest pivot
	 do 15 i=kp1,nrow
	    ipivi = ipivot(i)
	    awikdi = abs(w(ipivi,k))/d(ipivi)
	    if (awikdi .le. colmax)	go to 15
	       colmax = awikdi
	       j = i
   15	    continue
	 if (j .eq. k)			go to 16
	 ipivk = ipivot(j)
	 ipivot(j) = ipivot(k)
	 ipivot(k) = ipivk
	 iflag = -iflag
   16	 continue
c	 if pivot element is too small in absolute value, declare
c	 matrix to be noninvertible and quit.
	 if (abs(w(ipivk,k))+d(ipivk) .le. d(ipivk))
     *					go to 999
c	 otherwise, subtract the appropriate multiple of the pivot
c	 row from remaining rows, i.e., the rows ipivot(k+1),...,
c	 ipivot(nrow), to make k-th entry zero. save the multiplier in
c	 its place.
	 do 20 i=kp1,nrow
	    ipivi = ipivot(i)
	    w(ipivi,k) = w(ipivi,k)/w(ipivk,k)
	    ratio = -w(ipivi,k)
	    do 20 j=kp1,ncol
   20	       w(ipivi,j) = ratio*w(ipivk,j) + w(ipivi,j)
	 k = kp1
c	 check for having reached the next block.
	 if (k .le. last)		go to 11
					return
c     if  last	.eq. nrow , check now that pivot element in last row
c     is nonzero.
   21 if( abs(w(ipivk,nrow))+d(ipivk) .gt. d(ipivk) )
     *					return
c		    singularity flag set
  999 iflag = 0
					return
      end

C----------------------------------------------------------------------
        subroutine ftgcx(iunit,colnum,frow,fbit,nbit,lray,status)

C       read an array of logical values from a specified bit or byte
C       column of the binary table.  A logical .true. value is returned
C       if the corresponding bit is 1, and a logical .false. value is
C       returned if the bit is 0.
C       The binary table column being read from must have datatype 'B'
C       or 'X'. This routine ignores any undefined values in the 'B' array.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       fbit    i  first bit within the row to read
C       nbit    i  number of bits to read
C       lray    l  returned array of logical data values that is read
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Mar 1992

        integer iunit,colnum,frow,fbit,nbit,status
        logical lray(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bstart,offset,tcode,fbyte,bitloc,ndone
        integer ibuff,i,ntodo,repeat,rstart,estart,buffer
        logical descrp,log8(8)
        character*1 cbuff
      
        if (status .gt. 0)return

        ibuff=bufnum(iunit)
        tcode=tdtype(colnum+tstart(ibuff))

C       check input parameters
        if (nbit .le. 0)then
                return
        else if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                return
        else if (fbit .lt. 1)then
C               illegal element number
                status=308
                return
        end if

        fbyte=(fbit+7)/8
        bitloc=fbit-(fbit-1)/8*8
        ndone=0
        ntodo=nbit
        rstart=frow-1
        estart=fbyte-1

        if (tcode .eq. 11)then
                repeat=trept(colnum+tstart(ibuff))
                if (fbyte .gt. repeat)then
C                       illegal element number
                        status=308
                        return
                end if
                descrp=.false.
C               move the i/o pointer to the start of the sequence of pixels
                bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &          tbcol(colnum+tstart(ibuff))+estart
        else if (tcode .eq. -11)then
C               this is a variable length descriptor column
                descrp=.true.
C               read the number of elements and the starting offset:
                call ftgdes(iunit,colnum,frow,repeat,
     &                              offset,status)
                repeat=(repeat+7)/8
                if (repeat .eq. 0)then
C                       error: null length vector
                        status=318
                        return
                else if ((fbit+nbit+6)/8 .gt. repeat)then
C                       error: trying to read beyond end of record
                        status=319
                        return
                end if
                bstart=dtstrt(ibuff)+offset+
     &                          theap(ibuff)+estart
        else
C               column must be byte or bit data type
                status=312
                return
        end if

C       move the i/o pointer to the start of the pixel sequence
        call ftmbyt(iunit,bstart,.false.,status)

C       get the next byte
20      call ftgcbf(iunit,0,1,cbuff,status)
        buffer=ichar(cbuff)
        if (buffer .lt. 0)buffer=buffer+256

C       decode the bits within the byte into an array of logical values
        call ftgbit(buffer,log8)

        do 10 i=bitloc,8
                ndone=ndone+1
                lray(ndone)=log8(i)
                if (ndone .eq. ntodo)go to 100
10      continue
        
C       not done, so get the next byte
        if (.not. descrp)then
                estart=estart+1
                if (estart .eq. repeat)then
C                       move the i/o pointer to the next row of pixels
                        estart=0
                        rstart=rstart+1
                        bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &                         tbcol(colnum+tstart(ibuff))+estart
                        call ftmbyt(iunit,bstart,.false.,status)
                end if
        end if
        bitloc=1
        go to 20

100     continue
        end

include defs

# INDENT -- Indent the output listing.

subroutine indent (nlevels)

integer	nlevels
include COMMON_BLOCKS

	logical_column = logical_column + (nlevels * INDENT)
	col = max(6, min(MAX_INDENT, logical_column))
end

      subroutine pwrit (x,y,ichar,nchar,isize,ioren,icent)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c     ray bovet patch to avoid small integers being set to 0
      integer x,y,xx,yy
c
      dimension       ichar(nchar)
      dimension       iwide(4)
      data wide,high,white /6.,7.,2./
      data iwide(1),iwide(2),iwide(3),iwide(4)/256,384,512,768/
c
c copy parameters into local variables
c
      kchar = nchar
      ksize = isize
      koren = ioren
c
c transform character size into metacode units.
c
      if (ksize .gt. 3) ksize = ishift(ksize,mshftx)
      if (ksize .le. 3) ksize = iwide(ksize+1)
      call optn (4hcsiz,ksize)
c
c transform orientation.
c
      if (koren .lt. 0) koren = koren+360
      if (koren .ge. 0) call optn (4horen,koren)
c
c pass on centering.
c
      call optn (4hcent,max0(0,min0(2,icent+1)))
c
c make coordinates global.
c
      xx = x
      yy = y
      call trans
c
c use real variables for convenience.
c
      fmx = mx
      fmy = my
c
c work with radians instead of degrees.
c 2*pi/360. approximately = .0174533
c
      angle = float(koren)*.0174533
c
c find starting point for string when considering centering option.
c
      cosa = cos(angle)
      sina = sin(angle)
      wide2 = ksize/2
      widen = float(ksize*kchar)-float(ksize)*white/wide
      if (icent) 103,101,102
  101 fmx = fmx-cosa*widen*.5
      fmy = fmy-sina*widen*.5
      go to 103
  102 fmx = fmx-cosa*widen
      fmy = fmy-sina*widen
  103 continue
      hgt2 = (3*ksize)/4
      nxul = fmx-cosa*wide2-sina*hgt2
      nyul = fmy+cosa*hgt2-sina*wide2
      nxll = fmx-cosa*wide2+sina*hgt2
      nyll = fmy-cosa*hgt2-sina*wide2
      nxur = fmx+cosa*widen+cosa*wide2-sina*hgt2
      nyur = fmy+sina*widen+cosa*hgt2+sina*wide2
      nxlr = fmx+cosa*widen+cosa*wide2+sina*hgt2
      nylr = fmy+sina*widen-cosa*hgt2+sina*wide2
      mjxmax = min0(32767,max0(mjxmax,nxul,nxll,nxur,nxlr))
      mjxmin = max0(0,min0(mjxmin,nxul,nxll,nxur,nxlr))
      mjymax = min0(32767,max0(mjymax,nyul,nyll,nyur,nylr))
      mjymin = max0(0,min0(mjymin,nyul,nyll,nyur,nylr))
      minst = 0
      call put42
      call putins (33,ichar,kchar)
      mxold = -9999
      myold = -9999
      return
      end

include	defs

# lookup --- find a symbol in the symbol table, return its data

   integer function lookup (symbol, info, st)
   character symbol (ARB)
   integer info (ARB)
   pointer st

   DS_COMMON

   integer i, nodsiz, kluge
   integer stlu

   pointer node, pred

   if (stlu (symbol, node, pred, st) == NO) {
      lookup = NO
      return
      }

   nodsiz = Mem (st)
   for (i = 1; i <= nodsiz; i = i + 1) {
      kluge = node + ST_DATA - 1 + i
      info (i) = Mem (kluge)
      }
   lookup = YES

   return
   end

      subroutine filset (delim, array, i, set, j, maxset)
      integer i, j, maxset
      integer array (100), delim, set (maxset)
      integer esc
      integer junk
      external index
      integer addset, index
      integer digits(11)
      integer lowalf(27)
      integer upalf(27)
      data digits(1)/48/,digits(2)/49/,digits(3)/50/,digits(4)/51/,digit
     *s(5)/52/,digits(6)/53/,digits(7)/54/,digits(8)/55/,digits(9)/56/,d
     *igits(10)/57/,digits(11)/-2/
      data lowalf(1)/97/,lowalf(2)/98/,lowalf(3)/99/,lowalf(4)/100/,lowa
     *lf(5)/101/,lowalf(6)/102/,lowalf(7)/103/,lowalf(8)/104/,lowalf(9)/
     *105/,lowalf(10)/106/,lowalf(11)/107/,lowalf(12)/108/,lowalf(13)/10
     *9/,lowalf(14)/110/,lowalf(15)/111/,lowalf(16)/112/,lowalf(17)/113/
     *,lowalf(18)/114/,lowalf(19)/115/,lowalf(20)/116/,lowalf(21)/117/,l
     *owalf(22)/118/,lowalf(23)/119/,lowalf(24)/120/,lowalf(25)/121/,low
     *alf(26)/122/,lowalf(27)/-2/
      data upalf(1)/65/,upalf(2)/66/,upalf(3)/67/,upalf(4)/68/,upalf(5)/
     *69/,upalf(6)/70/,upalf(7)/71/,upalf(8)/72/,upalf(9)/73/,upalf(10)/
     *74/,upalf(11)/75/,upalf(12)/76/,upalf(13)/77/,upalf(14)/78/,upalf(
     *15)/79/,upalf(16)/80/,upalf(17)/81/,upalf(18)/82/,upalf(19)/83/,up
     *alf(20)/84/,upalf(21)/85/,upalf(22)/86/,upalf(23)/87/,upalf(24)/88
     */,upalf(25)/89/,upalf(26)/90/,upalf(27)/-2/
23000 if (.not.(array (i) .ne. delim .and. array (i) .ne. -2))goto 23002
      if (.not.(array (i) .eq. 64))goto 23003
      junk = addset (esc (array, i), set, j, maxset)
      goto 23004
23003 continue
      if (.not.(array (i) .ne. 45))goto 23005
      junk = addset (array (i), set, j, maxset)
      goto 23006
23005 continue
      if (.not.(j .le. 1 .or. array (i + 1) .eq. -2))goto 23007
      junk = addset (45, set, j, maxset)
      goto 23008
23007 continue
      if (.not.(index (digits, set (j - 1)) .gt. 0))goto 23009
      call dodash (digits, array, i, set, j, maxset)
      goto 23010
23009 continue
      if (.not.(index (lowalf, set (j - 1)) .gt. 0))goto 23011
      call dodash (lowalf, array, i, set, j, maxset)
      goto 23012
23011 continue
      if (.not.(index (upalf, set (j - 1)) .gt. 0))goto 23013
      call dodash (upalf, array, i, set, j, maxset)
      goto 23014
23013 continue
      junk = addset (45, set, j, maxset)
23014 continue
23012 continue
23010 continue
23008 continue
23006 continue
23004 continue
23001 i = i + 1
      goto 23000
23002 continue
      return
      end

      SUBROUTINE CONGEN (XI,YI,IPACK,SCRARR,ICA)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  DRAW A CONTOUR AT THE CURRENT LEVEL
C
C  INPUT
C       XI YI LOWER RIGHT CORNER OF CELL
C       IPACK-FLAG TO ALLOW REDUCTION OF COORDINATE PAIR STORAGE
C             IF REQUIRED
C       SCRARR-SCRATCH ARRAY OF CONTOUR VALUES
C       ICA-ENTERING CASE CONDITIONS IF ANY REQUIRED
C
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
      DIMENSION       SCRARR(1)  ,IXMOV(2)   ,IYMOV(2)
        CHARACTER*64    IHOLD
        CHARACTER*23    IVOUT
      INTEGER         GOOP
C
        SAVE
        DATA NOOP,GOOP/1,0/
C
C  STATEMENT FUNCTIONS FOR MAPPING GRAPHICS OUTPUT
C
      FX(XXX,YYY) = XXX
      FY(XXX,YYY) = YYY
C
C  STATEMENT FUNCTION TO MAKE ARRAY ACCESS SEEM LIKE MATRIX ACCESS
C
      SCRTCH(IXX,IYY) = SCRARR(IYY+(IXX-1)*IYMAX)
C
C  DRAW AN ENTIRE CONTOUR LINE WHEN A POTENTIAL START POINT IS
C  PROVIDED
C
C  SAVE STARTING CELL
C
      XCS = XI
      YCS = YI
C
C  TEST IF VALID START POINT
C
      ICASE = ICA
      XC = XI
      YC = YI
      CALL CONCLD (ICASE,NOOP)
C
C  IF NO CONTOUR RETURN
C
      IF (ICASE.EQ.-1) RETURN
      IF (ICASE.EQ.0) RETURN
C
C  IF CONTOUR ALREADY DRAWN RETURN
C
      ILOC = IOR(ISHIFT(JX,ISHFCT),JY)
      IF (NP.EQ.0) GO TO    20
C
C TEST IF CONTOUR FOUND
C
          DO    10 I=1,NP
          IF (ILOC.NE.ICOORD(I)) GO TO    10
          RETURN
   10     CONTINUE
C
C  GET CORRECT OLD CASE
C
   20 IC = IOC
      IF (ICASE.EQ.IOC) IC = NC
C
C  SET UP STRUCTURE TO START IN OTHER DIRECTION FROM HERE IF CONTOUR
C  UNEXPECTLY ENDS IN THIS DIRECTION
C
      IFCASE = IC
      IFOCSE = ICASE
      FXO = XO
      FYO = YO
      LOOP = 1
C
C  SET UP IC TO SIMULATE EXIT FROM A PREVIOUS CELL
C
      IC = MOD(IC+2,4)
C
C  IF EXTRAPOLATING PASS ON
C
      IF (EXTRAP) GO TO    60
C
C  TEST IF CONTOUR EXCEEDED BORDER LIMITS
C  NOTE THAT ICASER CANNOT EQUAL 3 AT THIS POINT
C
      GO TO (   30,   40,   30,   50),ICASE
C
C  EXIT FROM BOTTOM
C
   30 IF (JX.GE.IXMAX) RETURN
      GO TO    60
C
C  EXIT FROM LEFT
C
   40 IF (JY.LE.ITLOC(JX*2 - 1)) RETURN
      GO TO    60
C
C  EXIT FROM RIGHT
C
   50 IF (JY.GE.ITLOC(JX*2 - 1)) RETURN
C
C  SAVE CELL INFO IF COMMING BACK
C
   60 TRT = TR
      BRT = BR
      TLT = TL
      BLT = BL
      IX = JX
      IY = JY
C
C  VALID CONTOUR START FOUND
C
      XX = FX(XO,YO)
      CALL FRSTD (XX,FY(XO,YO))
C
C  DRAW CONTOUR IN THIS CELL
C
   70 XX = FX(XN,YN)
      CALL VECTD (XX,FY(XN,YN))
      XCSTOR = XC
      YCSTOR = YC
      IXSTOR = IX
      IYSTOR = IY
      IOLDC = IC
      IC = ICASE
C
C  ENTER COORDINATE PAIR OF CONTOUR IN LIST
C
      NP = NP+1
      IF (NP.GT.MXXY) GO TO   180
      ICOORD(NP) = ILOC
C
C  BRANCH TO APPROPIATE CODE DEPENDING ON CONTOUR EXIT FROM THE CELL
C
   80 GO TO (   90,  110,  130,  150),IC
C
C  EXIT FORM BOTTOM
C  END CONTOUR IF ON CONVEX HULL
C
   90 IF (EXTRAP) GO TO   100
      IF (IY.LT.ITLOC(IX*2 - 1) .OR. IY-1.GT.ITLOC(IX*2)) GO TO   360
  100 TR = BR
      TL = BL
      XC = XC+STPSZ
C
C  IF ON BORDER END CONTOUR
C
      IX = IX+1
      IF (IX.GT.IXMAX) GO TO   360
      BR = SCRTCH(IX,IY)
      BL = SCRTCH(IX,IY-1)
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  EXIT FROM LEFT SIDE
C  TEST IF IN CONVEX HULL
C
  110 IF (EXTRAP) GO TO   120
      IF (IY-1.LT.ITLOC( (IX-1)*2 - 1 ) .AND. IY-1.LT.ITLOC(IX*2 - 1))
     1    GO TO   360
  120 TR = TL
      BR = BL
      YC = YC-STPSZ
C
C  IF ON BORDER END CONTOUR
C
      IY = IY-1
      IF (IY.LT.2) GO TO   360
      TL = SCRTCH(IX-1,IY-1)
      BL = SCRTCH(IX,IY-1)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  EXIT FROM TOP
C  END CONTOUR IF OUT OF CONVEX HULL
C
  130 IF (EXTRAP) GO TO   140
      IF (IY.LT.ITLOC( (IX-1)*2 - 1 ) .OR. IY-1.GT.ITLOC( (IX-1)*2 ))
     1    GO TO   360
  140 BR = TR
      BL = TL
      XC = XC-STPSZ
C
C  END CONTOUR IF OUTSIDE OF BORDER
C
      IX = IX-1
      IF (IX.LT.2) GO TO   360
      TR = SCRTCH(IX-1,IY)
      TL = SCRTCH(IX-1,IY-1)
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  EXIT FROM RIGHT SIDE
C  TEST IF ON CONVEX HULL
C
  150 IF (EXTRAP) GO TO   160
      IF (IY.GT.ITLOC( (IX-1)*2 ) .AND. IY.GT.ITLOC(IX*2)) GO TO   360
  160 TL = TR
      BL = BR
      YC = YC+STPSZ
C
C  IF ON BORDER END CONTOUR
C
      IY = IY+1
      IF (IY.GT.IYMAX) GO TO   360
      TR = SCRTCH(IX-1,IY)
      BR = SCRTCH(IX,IY)
      ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  BRANCH IF CONTOUR CLOSED
C
      IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
      CALL CONCLD (ICASE,GOOP)
      IF (ICASE.EQ.-1) GO TO 360
      IF (ICASE.NE.0) GO TO    70
      GO TO   230
C
C  END THE CONTOUR
C
  170 CALL LASTD
      TR = TRT
      BR = BRT
      TL = TLT
      BL = BLT
      RETURN
C
C  CONTOUR STORAGE EXCEEDED TRY PACKING
C
  180 IF (IPACK.EQ.0) GO TO   200
      NP = 0
      ITEST = IOR(ISHIFT(JX,ISHFCT),JY)
          DO   190 K=1,MXXY
          IF (ICOORD(K).LE.ITEST) GO TO   190
          NP = NP+1
          ICOORD(NP) = ICOORD(K)
  190     CONTINUE
      IF (NP.LT.MXXY) GO TO    80
C
C  FAILURE NO MORE SPACE ABORT THIS CONTOUR LEVEL
C
  200 IHOLD(1:39) = ' CONDRW-CONTOUR STORAGE EXAUSTED LEVEL='
C
C  BLANK FILL THE ENCODE ARRAY
C
        IVOUT = '                       '
C +NOAO - FTN internal write rewritten as encode for IRAF.
C
C     WRITE(IVOUT,'(G13.5)')CONV
      call encode (13, '(g13.5)', ivout, conv)
C
C -NOAO
        IHOLD(40:62) = IVOUT
      CALL SETER (IHOLD,10,IREC)
      RETURN
C
C  BAD TIME THE CONTOUR EXITED A CORNER OF THE CELL MUST SEARCH FOR
C  NEW CELL
C
  230 IXSTP = IXSTOR
      IYSTP = IYSTOR
      GO TO (  240,  250,  260,  270),IOLDC
C
C PREVIOUS CELL BOTTOM EXIT
C
  240 IXSTP = IXSTP-1
      GO TO   280
C
C  PREVIOUS CELL LEFT EXIT
C
  250 IYSTP = IYSTP+1
      GO TO   280
C
C  PREVIOUS CELL TOP EXIT
C
  260 IXSTP = IXSTP+1
      GO TO   280
C
C  PREVIOUS CELL RIGHT EXIT
C
  270 IYSTP = IYSTP-1
C
C  BRANCH TO CURRENT CELL CASE
C
  280 GO TO (  290,  300,  310,  320),IC
C
C  APPARENT BOTTOM EXIT
C
  290 IXMOV(1) = 0
      IXMOV(2) = 1
      IYMOV(1) = -1
      IYMOV(2) = 1
      GO TO   330
C
C  APPARENT LEFT EXIT
C
  300 IXMOV(1) = 1
      IXMOV(2) = -1
      IYMOV(1) = 0
      IYMOV(2) = -1
      GO TO   330
C
C  APPARENT TOP EXIT
C
  310 IXMOV(1) = 0
      IXMOV(2) = -1
      IYMOV(1) = -1
      IYMOV(2) = 1
      GO TO   330
C
C  APPARENT RIGHT EXIT
C
  320 IXMOV(1) = 1
      IXMOV(2) = -1
      IYMOV(1) = 0
      IYMOV(2) = 1
C
C  SEARCH THE POSSIBLE CELLS
C
  330     DO   350 K=1,2
              DO   340 L=1,2
              XC = XCSTOR + STPSZ*FLOAT( IXMOV(K) )
              YC = YCSTOR + STPSZ*FLOAT( IYMOV(L) )
              IX = IXSTOR+IXMOV(K)
              IY = IYSTOR+IYMOV(L)
              ILOC = IOR(ISHIFT(IX,ISHFCT),IY)
C
C  IF BACK TO START END CONTOUR
C
              IF (IX.EQ.JX .AND. IY.EQ.JY) GO TO   170
C
C  IF AT PREVIOUS CELL SKIP PROCESSING
C
              IF (IX.EQ.IXSTP .AND. IY.EQ.IYSTP) GO TO   340
C
C  COMPUTE CELL VALUES
C
              TL = SCRTCH(IX-1,IY-1)
              BL = SCRTCH(IX,IY-1)
              TR = SCRTCH(IX-1,IY)
              BL = SCRTCH(IX,IY)
              ICASE = IC
              CALL CONCLD (ICASE,NOOP)
              IF (ICASE.EQ.-1) GO TO 360
              IF (ICASE.NE.0) GO TO    70
C
C  FAILURE TRY AGAIN
C
  340         CONTINUE
  350     CONTINUE
C
C  NO MORE CONTOUR TRY OTHER END OF LINE
C
  360 IF (LOOP.EQ.0) GO TO   170
      LOOP = 0
      IX = JX
      IY = JY
      TR = TRT
      TL = TLT
      BR = BRT
      BL = BLT
      IC = IFCASE
      ICASE = IC
      IOLDC = IFOCSE
      XC = XI
      YC = YI
      IXSTOR = IX
      IYSTOR = IY
      YCSTOR = YI
      XCSTOR = XI
      XX = FX(FXO,FYO)
      CALL LASTD
      CALL FRSTD (XX,FY(FXO,FYO))
      GO TO (   90,  110,  130,  150),IC
      END

*> \brief \b SGETRS
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download SGETRS + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sgetrs.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sgetrs.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sgetrs.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
*       .. Scalar Arguments ..
*       CHARACTER          TRANS
*       INTEGER            INFO, LDA, LDB, N, NRHS
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       REAL               A( LDA, * ), B( LDB, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGETRS solves a system of linear equations
*>    A * X = B  or  A**T * X = B
*> with a general N-by-N matrix A using the LU factorization computed
*> by SGETRF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>          Specifies the form of the system of equations:
*>          = 'N':  A * X = B  (No transpose)
*>          = 'T':  A**T* X = B  (Transpose)
*>          = 'C':  A**T* X = B  (Conjugate transpose = Transpose)
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] NRHS
*> \verbatim
*>          NRHS is INTEGER
*>          The number of right hand sides, i.e., the number of columns
*>          of the matrix B.  NRHS >= 0.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          The factors L and U from the factorization A = P*L*U
*>          as computed by SGETRF.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (N)
*>          The pivot indices from SGETRF; for 1<=i<=N, row i of the
*>          matrix was interchanged with row IPIV(i).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is REAL array, dimension (LDB,NRHS)
*>          On entry, the right hand side matrix B.
*>          On exit, the solution matrix X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup realGEcomputational
*
*  =====================================================================
      SUBROUTINE SGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
*  -- LAPACK computational routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * ), B( LDB, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLASWP, STRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( NOTRAN ) THEN
*
*        Solve A * X = B.
*
*        Apply row interchanges to the right hand sides.
*
         CALL SLASWP( NRHS, B, LDB, 1, N, IPIV, 1 )
*
*        Solve L*X = B, overwriting B with X.
*
         CALL STRSM( 'Left', 'Lower', 'No transpose', 'Unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve U*X = B, overwriting B with X.
*
         CALL STRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
      ELSE
*
*        Solve A**T * X = B.
*
*        Solve U**T *X = B, overwriting B with X.
*
         CALL STRSM( 'Left', 'Upper', 'Transpose', 'Non-unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve L**T *X = B, overwriting B with X.
*
         CALL STRSM( 'Left', 'Lower', 'Transpose', 'Unit', N, NRHS, ONE,
     $               A, LDA, B, LDB )
*
*        Apply row interchanges to the solution vectors.
*
         CALL SLASWP( NRHS, B, LDB, 1, N, IPIV, -1 )
      END IF
*
      RETURN
*
*     End of SGETRS
*
      END

      SUBROUTINE slDMAV (RMAT, AXVEC)
*+
*     - - - - - -
*      D M A V
*     - - - - - -
*
*  From a rotation matrix, determine the corresponding axial vector.
*  (double precision)
*
*  A rotation matrix describes a rotation about some arbitrary axis,
*  called the Euler axis.  The "axial vector" returned by this routine
*  has the same direction as the Euler axis, and its magnitude is the
*  amount of rotation in radians.  (The magnitude and direction can be
*  separated by means of the routine slDVN.)
*
*  Given:
*    RMAT   d(3,3)   rotation matrix
*
*  Returned:
*    AXVEC  d(3)     axial vector (radians)
*
*  The reference frame rotates clockwise as seen looking along
*  the axial vector from the origin.
*
*  If RMAT is null, so is the result.
*
*  Last revision:   26 November 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RMAT(3,3),AXVEC(3)

      DOUBLE PRECISION X,Y,Z,S2,C2,PHI,F



      X = RMAT(2,3)-RMAT(3,2)
      Y = RMAT(3,1)-RMAT(1,3)
      Z = RMAT(1,2)-RMAT(2,1)
      S2 = SQRT(X*X+Y*Y+Z*Z)
      IF (S2.NE.0D0) THEN
         C2 = RMAT(1,1)+RMAT(2,2)+RMAT(3,3)-1D0
         PHI = ATAN2(S2,C2)
         F = PHI/S2
         AXVEC(1) = X*F
         AXVEC(2) = Y*F
         AXVEC(3) = Z*F
      ELSE
         AXVEC(1) = 0D0
         AXVEC(2) = 0D0
         AXVEC(3) = 0D0
      END IF

      END

C--------------------------------------------------------------------------
        subroutine ftikys(ounit,keywrd,strval,comm,status)

C       insert a string keyword into the header at the current position
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       strval  c  keyword value 
C       comm    c  keyword comment 
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, March 1993
C       Modifed 9/94 to call FTPKLS, supporting the OGIP long string convention

        character*(*) keywrd,comm,strval
        integer ounit,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------- -----------------------------

        integer lenval,length,i,nspace,ibuff,nexthd,endhd,nkeys,keypos  

        if (status .gt. 0)return

C       find how many keywords are required to write the string, in case it
C       cannot fit onto one keyword and has to be continued on multiple lines.

        lenval=len(strval)
        length=0
        do 10 i=lenval,1,-1
                if (strval(i:i) .ne. ' ')then
                        length=i
                        go to 20
                end if
10      continue
20      nspace=max(1,(length-2)/67+1)

C       save current pointer values
        ibuff=bufnum(ounit)
        endhd=hdend(ibuff)
        nexthd=nxthdr(ibuff)

C       insert enough spaces in the header at the current location
        call ftghps(ounit,nkeys,keypos,status)

        do 30 i=1,nspace
            call ftirec(ounit,keypos,' ',status)
30      continue

C       temporarily reset position of the end of header to force keyword
C       to be written at the current header position.
        hdend(ibuff)=nexthd

C       write the keyword (supporting the OGIP long string convention)
        call ftpkls(ounit,keywrd,strval,comm,status)

C       reset the next keyword pointer to follow the inserted keyword
        nxthdr(ibuff)=nexthd+80*nspace

C       reset the end-of-header pointer to its real location
        hdend(ibuff)=endhd+80*nspace
        end

      SUBROUTINE slPLTE (DATE, ELONG, PHI, JFORM, EPOCH,
     :                       ORBINC, ANODE, PERIH, AORQ, E,
     :                       AORL, DM, RA, DEC, R, JSTAT)
*+
*     - - - - - - -
*      P L T E
*     - - - - - - -
*
*  Topocentric apparent RA,Dec of a Solar-System object whose
*  heliocentric orbital elements are known.
*
*  Given:
*     DATE     d     MJD of observation (JD - 2400000.5, Notes 1,5)
*     ELONG    d     observer's east longitude (radians, Note 2)
*     PHI      d     observer's geodetic latitude (radians, Note 2)
*     JFORM    i     choice of element set (1-3; Notes 3-6)
*     EPOCH    d     epoch of elements (TT MJD, Note 5)
*     ORBINC   d     inclination (radians)
*     ANODE    d     longitude of the ascending node (radians)
*     PERIH    d     longitude or argument of perihelion (radians)
*     AORQ     d     mean distance or perihelion distance (AU)
*     E        d     eccentricity
*     AORL     d     mean anomaly or longitude (radians, JFORM=1,2 only)
*     DM       d     daily motion (radians, JFORM=1 only )
*
*  Returned:
*     RA,DEC   d     RA, Dec (topocentric apparent, radians)
*     R        d     distance from observer (AU)
*     JSTAT    i     status:  0 = OK
*                            -1 = illegal JFORM
*                            -2 = illegal E
*                            -3 = illegal AORQ
*                            -4 = illegal DM
*                            -5 = numerical error
*
*  Called: slELUE, slPLTU
*
*  Notes:
*
*  1  DATE is the instant for which the prediction is required.  It is
*     in the TT timescale (formerly Ephemeris Time, ET) and is a
*     Modified Julian Date (JD-2400000.5).
*
*  2  The longitude and latitude allow correction for geocentric
*     parallax.  This is usually a small effect, but can become
*     important for near-Earth asteroids.  Geocentric positions can be
*     generated by appropriate use of routines slEVP (or slEPV) and
*     slPLNE.
*
*  3  The elements are with respect to the J2000 ecliptic and equinox.
*
*  4  A choice of three different element-set options is available:
*
*     Option JFORM = 1, suitable for the major planets:
*
*       EPOCH  = epoch of elements (TT MJD)
*       ORBINC = inclination i (radians)
*       ANODE  = longitude of the ascending node, big omega (radians)
*       PERIH  = longitude of perihelion, curly pi (radians)
*       AORQ   = mean distance, a (AU)
*       E      = eccentricity, e (range 0 to <1)
*       AORL   = mean longitude L (radians)
*       DM     = daily motion (radians)
*
*     Option JFORM = 2, suitable for minor planets:
*
*       EPOCH  = epoch of elements (TT MJD)
*       ORBINC = inclination i (radians)
*       ANODE  = longitude of the ascending node, big omega (radians)
*       PERIH  = argument of perihelion, little omega (radians)
*       AORQ   = mean distance, a (AU)
*       E      = eccentricity, e (range 0 to <1)
*       AORL   = mean anomaly M (radians)
*
*     Option JFORM = 3, suitable for comets:
*
*       EPOCH  = epoch of elements and perihelion (TT MJD)
*       ORBINC = inclination i (radians)
*       ANODE  = longitude of the ascending node, big omega (radians)
*       PERIH  = argument of perihelion, little omega (radians)
*       AORQ   = perihelion distance, q (AU)
*       E      = eccentricity, e (range 0 to 10)
*
*     Unused arguments (DM for JFORM=2, AORL and DM for JFORM=3) are not
*     accessed.
*
*  5  Each of the three element sets defines an unperturbed heliocentric
*     orbit.  For a given epoch of observation, the position of the body
*     in its orbit can be predicted from these elements, which are
*     called "osculating elements", using standard two-body analytical
*     solutions.  However, due to planetary perturbations, a given set
*     of osculating elements remains usable for only as long as the
*     unperturbed orbit that it describes is an adequate approximation
*     to reality.  Attached to such a set of elements is a date called
*     the "osculating epoch", at which the elements are, momentarily,
*     a perfect representation of the instantaneous position and
*     velocity of the body.
*
*     Therefore, for any given problem there are up to three different
*     epochs in play, and it is vital to distinguish clearly between
*     them:
*
*     . The epoch of observation:  the moment in time for which the
*       position of the body is to be predicted.
*
*     . The epoch defining the position of the body:  the moment in time
*       at which, in the absence of purturbations, the specified
*       position (mean longitude, mean anomaly, or perihelion) is
*       reached.
*
*     . The osculating epoch:  the moment in time at which the given
*       elements are correct.
*
*     For the major-planet and minor-planet cases it is usual to make
*     the epoch that defines the position of the body the same as the
*     epoch of osculation.  Thus, only two different epochs are
*     involved:  the epoch of the elements and the epoch of observation.
*
*     For comets, the epoch of perihelion fixes the position in the
*     orbit and in general a different epoch of osculation will be
*     chosen.  Thus, all three types of epoch are involved.
*
*     For the present routine:
*
*     . The epoch of observation is the argument DATE.
*
*     . The epoch defining the position of the body is the argument
*       EPOCH.
*
*     . The osculating epoch is not used and is assumed to be close
*       enough to the epoch of observation to deliver adequate accuracy.
*       If not, a preliminary call to slPRTL may be used to update
*       the element-set (and its associated osculating epoch) by
*       applying planetary perturbations.
*
*  6  Two important sources for orbital elements are Horizons, operated
*     by the Jet Propulsion Laboratory, Pasadena, and the Minor Planet
*     Center, operated by the Center for Astrophysics, Harvard.
*
*     The JPL Horizons elements (heliocentric, J2000 ecliptic and
*     equinox) correspond to SLALIB arguments as follows.
*
*       Major planets:
*
*         JFORM  = 1
*         EPOCH  = JDCT-2400000.5D0
*         ORBINC = IN (in radians)
*         ANODE  = OM (in radians)
*         PERIH  = OM+W (in radians)
*         AORQ   = A
*         E      = EC
*         AORL   = MA+OM+W (in radians)
*         DM     = N (in radians)
*
*         Epoch of osculation = JDCT-2400000.5D0
*
*       Minor planets:
*
*         JFORM  = 2
*         EPOCH  = JDCT-2400000.5D0
*         ORBINC = IN (in radians)
*         ANODE  = OM (in radians)
*         PERIH  = W (in radians)
*         AORQ   = A
*         E      = EC
*         AORL   = MA (in radians)
*
*         Epoch of osculation = JDCT-2400000.5D0
*
*       Comets:
*
*         JFORM  = 3
*         EPOCH  = Tp-2400000.5D0
*         ORBINC = IN (in radians)
*         ANODE  = OM (in radians)
*         PERIH  = W (in radians)
*         AORQ   = QR
*         E      = EC
*
*         Epoch of osculation = JDCT-2400000.5D0
*
*     The MPC elements correspond to SLALIB arguments as follows.
*
*       Minor planets:
*
*         JFORM  = 2
*         EPOCH  = Epoch-2400000.5D0
*         ORBINC = Incl. (in radians)
*         ANODE  = Node (in radians)
*         PERIH  = Perih. (in radians)
*         AORQ   = a
*         E      = e
*         AORL   = M (in radians)
*
*         Epoch of osculation = Epoch-2400000.5D0
*
*       Comets:
*
*         JFORM  = 3
*         EPOCH  = T-2400000.5D0
*         ORBINC = Incl. (in radians)
*         ANODE  = Node. (in radians)
*         PERIH  = Perih. (in radians)
*         AORQ   = q
*         E      = e
*
*         Epoch of osculation = Epoch-2400000.5D0
*
*  This revision:  19 June 2004
*
*  Copyright (C) 2004 P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,ELONG,PHI
      INTEGER JFORM
      DOUBLE PRECISION EPOCH,ORBINC,ANODE,PERIH,AORQ,E,
     :                 AORL,DM,RA,DEC,R
      INTEGER JSTAT

      DOUBLE PRECISION U(13)


*  Transform conventional elements to universal elements.
      CALL slELUE(DATE,
     :               JFORM,EPOCH,ORBINC,ANODE,PERIH,AORQ,E,AORL,DM,
     :               U,JSTAT)

*  If successful, make the prediction.
      IF (JSTAT.EQ.0) CALL slPLTU(DATE,ELONG,PHI,U,RA,DEC,R,JSTAT)

      END

	SUBROUTINE LUBKSB (A, N, NP, INDX, B)

C Solves a matrix equation AX = B.  Before using this routine you must
C call ludcmp to decompose the matrix A (in-place) into lower and upper
C triangular portions.  The vector B is input to this routine, and the
C answer X is returned in B.
C
C	real	a(np,np)	i: matrix returned by ludcmp
C	int	n		i: logical size of a is n x n
C	int	np		i: space allocated for a is np x np
C	int	indx(n)		i: index returned by ludcmp
C	real	b(n)		io: input b, output x in equation ax = b
C
C This routine simply calls the LU decomposition routine provided by LAPACK.

	INTEGER N, NP
	REAL	A(NP,NP)
	INTEGER INDX(N)
	REAL	B(N)

	INTEGER STATUS

	CALL SGETRS('N', N, 1, A, NP, INDX, B, N, STATUS)
	RETURN
	END

C----------------------------------------------------------------------
        subroutine ftgcl(iunit,colnum,frow,felem,nelem,lray,status)

C       read an array of logical values from a specified column of the table.
C       The binary table column being read from must have datatype 'L'
C       and no datatype conversion will be perform if it is not.
C       This routine ignores any undefined values in the logical array.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of elements to read
C       lray    l  returned array of data values that is read
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,status
        logical lray(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bstart,maxpix,offset,tcode
        integer ibuff,i,i1,ntodo,itodo,repeat,rstart,estart
        character*1 buffer(80)
        logical descrp
        character crow*9,cp1*9,cp2*9,ccol*4
        
        if (status .gt. 0)return

        ibuff=bufnum(iunit)
        tcode=tdtype(colnum+tstart(ibuff))

C       check for zero length array
        if (nelem .le. 0)then
                return
        else if (frow .lt. 1)then
C               error: illegal first row number
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table read '//
     &          'request is out of range:'//crow//' (FTGCL).')
                status=307
                return
        else if (felem .lt. 1)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCL).')
                 return
        end if

        i1=0
        ntodo=nelem
        rstart=frow-1
        estart=felem-1
        maxpix=80

        if (tcode .eq. 14)then
                repeat=trept(colnum+tstart(ibuff))
                if (felem .gt. repeat)then
C                               illegal element number
                                status=308
                                write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCL).')
                                return
                end if
                descrp=.false.
        else if (tcode .eq. -14)then
C               this is a variable length descriptor column
                descrp=.true.
C               read the number of elements and the starting offset:
                call ftgdes(iunit,colnum,frow,repeat,
     &                              offset,status)
                if (repeat .eq. 0)then
C                       error: null length vector
                        status=318
                        return
                else if (estart+ntodo .gt. repeat)then
C                       error: trying to read beyond end of record
                        status=319
                        return
                end if
C               move the i/o pointer to the start of the pixel sequence
                bstart=dtstrt(ibuff)+offset+
     &                          theap(ibuff)+estart
                call ftmbyt(iunit,bstart,.true.,status)
        else
C               column must be logical data type
                status=312
                return
        end if

C       process as many contiguous pixels as possible
20      itodo=min(ntodo,repeat-estart,maxpix)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &      tbcol(colnum+tstart(ibuff))+estart
            call ftmbyt(iunit,bstart,.false.,status)
        end if

C       get the array of logical bytes
        call ftgcbf(iunit,1,itodo,buffer,status)

C       decode the 'T' and 'F' characters, 
        do 10 i=1,itodo
                if (buffer(i) .eq. 'T')then
                        lray(i1+i)=.true.
                else if (buffer(i) .eq. 'F')then
                        lray(i1+i)=.false.
                else if (ichar(buffer(i)) .eq. 0)then
C                       ignore null values; leave input logical value unchanged
                else
C                       illegal logical value
                        status=316
                        return
                end if
10      continue
        
        if (status .gt. 0)then
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error reading elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTGCLB.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error reading rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTGCLB).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error reading'//cp2//' elements from'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTGCLB).')
             end if
          return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        rstart=rstart+1
                end if
                go to 20
        end if
        end

      SUBROUTINE THAFTO	(IERROR)
C
C LATEST REVISION	 JULY, 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 HAFTON	AND TO TEST HAFTON ON A	SINGLE
C			 PROBLEM
C
C USAGE			 CALL THAFTO (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   HAFTON TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, TWO FRAMES CONTAINING THE
C			 HALF-TONE PLOT	ARE PRODUCED ON	THE MACHINE
C			 GRAPHICS DEVICE.  IN ORDER TO DETERMINE IF THE
C			 TEST WAS SUCCESSFUL, IT IS NECESSARY TO EXAMINE
C			 THESE PLOTS.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 HAFTON
C FILES
C
C LANGUAGE		 ANSI FORTRAN 77
C
C ALGORITHM		 THE FUNCTION
C			   Z(X,Y) = X +	Y + 1./((X-.1)**2+Y**2+.09)
C				    -1./((X+.1)**2+Y**2+.09)
C			 FOR X = -1. TO	+1. IN INCREMENTS OF .1	AND
C			     Y = -1.2 TO +1.2 IN INCREMENTS OF .1
C			 IS COMPUTED.
C			 THAFTO	CALLS SUBROUTINES EZHFTN AND HAFTON TO
C			 DRAW TWO HALF-TONE PLOTS OF THE ARRAY Z.
C
C PORTABILITY		 ANSI STANDARD
C
C
C Z CONTAINS THE VALUES	TO BE PLOTTED.
C
C
      REAL	      Z(21,25)
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE COORDINATES RANGE	FROM 0.0 TO 1.0, THE VALUES TX AND TY
C DEFINE THE CENTER OF THE LEFT	EDGE OF	THE TITLE STRING.
C
      DATA TX/0.0762/, TY/0.9769/
C
C SPECIFY SOME ARGUMENT	VALUES FOR ROUTINE HAFTON.
C FLO CONTAINS THE LOW VALUE DESIGNATION FOR HAFTON, FHI
C CONTAINS THE HIGH VALUE DESIGNATION FOR HAFTON, NLEV
C SPECIFIES THE	NUMBER OF UNIQUE LEVELS	BETWEEN	FLO AND	FHI,  THE
C ABSOLUTE VALUE OF NOPT DETERMINES THE	MAPPING	OF Z ONTO THE
C INTENSITIES, AND THE SIGN OF NOPT CONTROLS THE DIRECTNESS OR
C INVERSNESS OF	THE MAPPING.
C
      DATA FLO/-4.0/, FHI/4.0/,	NLEV/8/, NOPT/-3/
C
C
      SAVE
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 0
C
C FILL TWO DIMENSIONAL ARRAY TO	BE PLOTTED
C
      DO  20 I=1,21
	 X = .1*FLOAT(I-11)
	 DO  10	J=1,25
	    Y =	.1*FLOAT(J-13)
	    Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1		     1./((X+.10)**2+Y**2+.09)
   10	 CONTINUE
   20 CONTINUE
C
C SELECT NORMALIZATION TRANS 0 FOR PLOTTING TITLE
C
c     CALL GSELNT (0)
C
C
C
C ENTRY	EZHFTN REQUIRES	ONLY THE ARRAY NAME AND	ITS DIMENSIONS
C
C   THE	TITLE FOR THIS PLOT IS
C
C     DEMONSTRATION PLOT FOR ENTRY EZHFTN OF HAFTON
C
c     CALL WTSTR (TX,TY,
c    1		'DEMONSTRATION PLOT FOR ENTRY EZHFTN OF HAFTON',2,0,-1)
c     CALL EZHFTN (Z,21,25)
C
C ENTRY	HAFTON ALLOWS USER SPECIFICATIONS OF PLOT PARAMETERS, IF DESIRED
C
C   THE	TITLE FOR THIS PLOT IS
C
C     DEMONSTRATION PLOT FOR ENTRY HAFTON OF HAFTON
C
      CALL GSELNT (0)
      CALL WTSTR (TX,TY,
     1		'DEMONSTRATION PLOT FOR ENTRY HAFTON OF HAFTON',2,0,-1)
      CALL HAFTON (Z,21,21,25,FLO,FHI,NLEV,NOPT,0,0,0.)
c     CALL NEWFM
C
c     WRITE (6,1001)
      RETURN
C
C
c1001 FORMAT ('	    HAFTON TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

C SUBROUTINE PHMINV.F 
C
C SOURCE								       
C   BEVINGTON, PAGES 302-303.
C
C PURPOSE
C   INVERT A SYMMETRIC MATRIX AND CALCULATE ITS DETERMINANT
C
C USAGE 
C   CALL PHMINV (ARRAY, IK, JK, NORDER, DET)
C
C DESCRIPTION OF PARAMETERS
C   ARRAY  - INPUT MATRIX WHICH IS REPLACED BY ITS INVERSE
C   IK     - WORK ARRAY REQUIRED BY PHMINV
C   JK     - WORK ARRAY REQUIRED BY PHMINV
C   NORDER - DEGREE OF MATRIX (ORDER OF DETERMINANT)
C   DET    - DETERMINANT OF INPUT MATRIX
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE
C
C COMMENT
C   DIMENSION STATEMENT VALID FOR NORDER UP TO 10
C
	SUBROUTINE PHMINV (ARRAY,IK,JK,NORDER,DET)
	DOUBLE PRECISION ARRAY,AMAX,SAVE
	DIMENSION ARRAY(NORDER,NORDER),IK(NORDER),JK(NORDER)
C
10	DET=1.
11	DO 100 K=1,NORDER
C
C FIND LARGEST ELEMENT ARRAY(I,J) IN REST OF MATRIX
C
	AMAX=0. 
21	CONTINUE
	IK(K) = K
	JK(K) = K
	DO 30 I=K,NORDER
	DO 30 J=K,NORDER
23	IF (DABS(AMAX)-DABS(ARRAY(I,J))) 24,24,30
24	AMAX=ARRAY(I,J) 
	IK(K)=I 
	JK(K)=J 
30	CONTINUE
C
C INTERCHANGE ROWS AND COLUMNS TO PUT AMAX IN ARRAY(K,K)
C
41	I=IK(K) 
	IF (I-K) 21,51,43
43	DO 50 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=ARRAY(I,J)
50	ARRAY(I,J)=-SAVE
51	J=JK(K) 
	IF (J-K) 21,600,53
53	DO 60 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=ARRAY(I,J)
60	ARRAY(I,J)=-SAVE

C
C CHECK FOR SINGULAR MATRIX
C
600  	IF (AMAX) 61,610,61
610	DET=0.
	DO 700 I=1,NORDER
	IF (I-K) 630,700,630
630	ARRAY(I,K)=0.
700	CONTINUE
	DO 800 J=1,NORDER
	IF (J-K) 730,800,730
730	ARRAY(K,J)=0.
800	CONTINUE
	ARRAY(K,K)=0.
	GOTO 100
C
C ACCUMULATE ELEMENTS OF INVERSE MATRIX 
C
61	DO 70 I=1,NORDER
	IF (I-K) 63,70,63
63	ARRAY(I,K)=-ARRAY(I,K)/AMAX
70	CONTINUE
71	DO 80 I=1,NORDER
	DO 80 J=1,NORDER
	IF (I-K) 74,80,74
74	IF (J-K) 75,80,75
75	ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)
80	CONTINUE
81	DO 90 J=1,NORDER
	IF (J-K) 83,90,83
83	ARRAY(K,J)=ARRAY(K,J)/AMAX
90	CONTINUE
	ARRAY(K,K)=1./AMAX
100	DET=DET*AMAX
C
C RESTORE ORDERING OF MATRIX
C
101	DO 130 L=1,NORDER
	K=NORDER-L+1
	J=IK(K) 
	IF (J-K) 111,111,105
105	DO 110 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=-ARRAY(I,J)
110	ARRAY(I,J)=SAVE 
111	I=JK(K) 
	IF (I-K) 130,130,113
113	DO 120 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=-ARRAY(I,J)
120	ARRAY(I,J)=SAVE 
130	CONTINUE
140	RETURN
	END

C--------------------------------------------------------------------------
        subroutine ftdkey(iunit,keynam,status)

C       delete a header keyword
C
C       iunit   i  fortran output unit number
C       keynam  c  keyword name    ( 8 characters, cols.  1- 8)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Feb 1992

        character*(*) keynam
        integer iunit,status,i,lenval,nkeys,keypos
        character keybuf*80,strval*70,comm*8,value*70,bslash*1,kname*8

        if (status .gt. 0)return

C       have to use 2 \\'s because the SUN compiler treats 1 \ as an escape
        bslash='\\'

C       find the keyword to be deleted
        call ftgcrd(iunit,keynam,keybuf,status)
        if (status .eq. 202)then
            kname=keynam
            call ftpmsg('FTDKEY could not find the '//kname//
     &      ' keyword to be deleted.')
            return
        end if

C       get the position of the keyword in the header
        call ftghps(iunit,nkeys,keypos,status)
        keypos=keypos-1

C       get position of last character in value string to see if it is a \ or &
        call ftpsvc(keybuf,strval,comm,status)
        call ftc2s(strval,value,status)
        do 10 i=70,1,-1
                if (value(i:i) .ne. ' ')then
                        lenval=i
                        go to 20
                end if
10      continue

C       now delete this keyword
20      call ftdrec(iunit,keypos,status)
        if (status .gt. 0)return

C       test if this keyword was also continued
        if (value(lenval:lenval) .eq. bslash .or.
     &          value(lenval:lenval) .eq. '&')then
                call ftgnst(iunit,value,lenval,comm,status)
                if (lenval .gt. 0)go to 20
        end if
        end

c function pgauss.f
c
c source
c   Bevington, page 45.
c
c purpose
c   evaluate gaussian probability function
c
c usage
c   result = pgauss (x, averag, sigma)
c
c description of parameters
c   x      - value for which probability is to be evaluated
c   averag - mean of distribution
c   sigma  - standard deviation of distribution
c
c subroutines and function subprograms required
c   none
c
	function pgauss (x,averag,sigma)
	double precision z
1	z=(x-averag)/sigma
2	pgauss=0.3989422804/sigma*dexp(-(z**2)/2.)
	return
	end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGCHCU (IFLG,KDSH)
C
C The routine AGCHCU is called by AGCURV just before and just after each
C curve is drawn.  The default version does nothing.  A user may supply
C a version to change the appearance of the curves.  The arguments are
C as follows:
C
C - IFLG is zero if a curve is about to be drawn, non-zero if a curve
C   has just been drawn.
C
C - KDSH is the last argument of AGCURV, as follows:
C
C      AGCURV called by   Value of KDSH
C      ----------------   ----------------------------------------
C      EZY                1
C      EZXY               1
C      EZMY               "n" or "-n", where n is the curve number
C      EZMXY              "n" or "-n", where n is the curve number
C      the user program   the user value
C
C   The sign of KDSH, when AGCURV is called by EZMY or EZMXY, indicates
C   whether the "user" dash patterns or the "alphabetic" dash patterns
C   were selected for use.
C
C Done.
C
      RETURN
C
      END

chapter xiii, example 2m. cubic spline interpolant at knot averages
c			 with good knots. modified around label 4.
c  from  * a practical guide to splines *  by c. de boor
calls splint(banfac/slv,bsplvb),newnot,bsplpp(bsplvb*)
c     parameter nmax=20,nmaxp6=26,nmaxp2=22,nmaxt7=140
      integer i,istep,iter,itermx,n,nhigh,nmk,nlow
c     real algerp,aloger,bcoef(nmaxp2),break(nmax),decay,dx,errmax,
c    *	  c(4,nmax),g,gtau(nmax),h,pnatx,scrtch(nmaxt7),step,t(nmaxp6),
c    *	  tau(nmax),tnew(nmax)
      real algerp,aloger,bcoef(22),break(20),decay,dx,errmax,
     *	  c(4,20),g,gtau(20),h,pnatx,scrtch(140),step,t(26),
     *	  tau(20),tnew(20),x
c     istep and step = float(istep) specify point density for error det-
c     ermination.
      data step, istep /20., 20/
c				the function  g  is to be interpolated .
      g(x) = sqrt(x+1.)
      decay = 0.
c      read in the number of iterations to be carried out and the lower
c      and upper limit for the number  n  of data points to be used.
      read 500,itermx,nlow,nhigh
  500 format(3i3)
      print 600, itermx
  600 format(i4,22h cycles through newnot//
     *	    28h  n   max.error	 decay exp./)
c				  loop over  n = number of data points .
      do 40 n=nlow,nhigh,2
	 if (n .eq. nlow)		go to 4
	 call newnot ( break, c, l, 4, tnew, l+2, scrtch )
	 l = l + 2
	 t(5+l) = 1.
	 t(6+l) = 1.
	 iter = 1
					go to 15
    4	 nmk = n-4
	 h = 2./float(nmk+1)
	 do 5 i=1,4
	    t(i) = -1.
    5	    t(n+i) = 1.
	 if (nmk .lt. 1)		go to 10
	 do 6 i=1,nmk
    6	    t(i+4) = float(i)*h - 1.
   10	 iter = 1
c		construct cubic spline interpolant. then, itermx  times,
c		 determine new knots from it and find a new interpolant.
   11	    do 12 i=1,n
	       tau(i) = (t(i+1)+t(i+2)+t(i+3))/3.
   12	       gtau(i) = g(tau(i))
	    call splint ( tau, gtau, t, n, 4, scrtch, bcoef, iflag )
	    call bsplpp ( t, bcoef, n, 4, scrtch, break, c, l )
	    if (iter .gt. itermx)	go to 19
	    iter = iter + 1
	    call newnot ( break, c, l, 4, tnew, l, scrtch )
   15	    do 18 i=2,l
   18	       t(3+i) = tnew(i)
					go to 11
c		       estimate max.interpolation error on  (-1,1) .
   19	 errmax = 0.
c			    loop over polynomial pieces of interpolant .
	 do 30 i=1,l
	    dx = (break(i+1)-break(i))/step
c		 interpolation error is calculated at  istep  points per
c		     polynomial piece .
	    do 30 j=1,istep
	       h = float(j)*dx
	       pnatx = c(1,i)+h*(c(2,i)+h*(c(3,i)+h*c(4,i)/3.)/2.)
   30	    errmax = amax1(errmax,abs(g(break(i)+h)-pnatx))
c					      calculate decay exponent .
	 aloger = alog(errmax)
	 if (n .gt. nlow)  decay =
     *	     (aloger - algerp)/alog(float(n)/float(n-2))
	 algerp = aloger
c
   40	 print 640,n,errmax,decay
  640 format(i3,e12.4,f11.2)
					stop
      end

      subroutine outnum (n)
      integer n
      integer chars (20)
      integer i, m
      m = iabs (n)
      i = 0
23000 continue
      i = i + 1
      chars (i) = mod (m, 10) + 48
      m = m / 10
23001 if (.not.(m .eq. 0 .or. i .ge. 20))goto 23000
23002 continue
      if (.not.(n .lt. 0))goto 23003
      call outch (45)
23003 continue
23005 if (.not.(i .gt. 0))goto 23007
      call outch (chars (i))
23006 i = i - 1
      goto 23005
23007 continue
      return
      end

      subroutine getdef (token, toksiz, defn, defsiz)
      integer token (100), defn (2048)
      integer toksiz, defsiz
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer c, t, ptoken (100)
      integer gtok, ngetch
      integer i, nlpar
      call skpblk
      c = gtok (ptoken, 100)
      if (.not.(c .eq. 40))goto 23000
      t = 40
      goto 23001
23000 continue
      t = 32
      call pbstr (ptoken)
23001 continue
      call skpblk
      if (.not.(gtok (token, toksiz) .ne. -9))goto 23002
      call baderr (22Hnon-alphanumeric name.)
23002 continue
      call skpblk
      c = gtok (ptoken, 100)
      if (.not.(t .eq. 32))goto 23004
      call pbstr (ptoken)
      i = 1
23006 continue
      c = ngetch (c)
      if (.not.(i .gt. defsiz))goto 23009
      call baderr (20Hdefinition too long.)
23009 continue
      defn (i) = c
      i = i + 1
23007 if (.not.(c .eq. 35 .or. c .eq. 10 .or. c .eq. -1))goto 23006
23008 continue
      if (.not.(c .eq. 35))goto 23011
      call putbak (c)
23011 continue
      goto 23005
23004 continue
      if (.not.(t .eq. 40))goto 23013
      if (.not.(c .ne. 44))goto 23015
      call baderr (24Hmissing comma in define.)
23015 continue
      nlpar = 0
      i = 1
23017 if (.not.(nlpar .ge. 0))goto 23019
      if (.not.(i .gt. defsiz))goto 23020
      call baderr (20Hdefinition too long.)
      goto 23021
23020 continue
      if (.not.(ngetch (defn (i)) .eq. -1))goto 23022
      call baderr (20Hmissing right paren.)
      goto 23023
23022 continue
      if (.not.(defn (i) .eq. 40))goto 23024
      nlpar = nlpar + 1
      goto 23025
23024 continue
      if (.not.(defn (i) .eq. 41))goto 23026
      nlpar = nlpar - 1
23026 continue
23025 continue
23023 continue
23021 continue
23018 i = i + 1
      goto 23017
23019 continue
      goto 23014
23013 continue
      call baderr (19Hgetdef is confused.)
23014 continue
23005 continue
      defn (i - 1) = -2
      return
      end
c     logic0  logical_column

C----------------------------------------------------------------------
        subroutine ftpclb(ounit,colnum,frow,felem,nelem,array,status)

C       write an array of unsigned byte data values to the 
C       specified column of the table.  

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       array   i  array of data values to be written 
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status
        character*1 array(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
        character*1 chbuff(400),xdummy(5360)
        common/ftheap/chbuff,xdummy
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bufdim
        parameter (bufdim = 100)
        integer buffer(bufdim),bytpix,bstart,tcode,incre
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart,maxpix,ival
        double precision scale,zero,dval
        real rval
        character sval*40,wform*10,crow*9,cp1*9,cp2*9,ccol*4
        logical tofits,lval,descrp
        integer*2 i2val
        character*1 i1val

        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &          'request is out of range:'//crow//' (FTPCLB).')
                return
        end if

        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)

        descrp=.false.
        i1=1
        ntodo=nelem
        rstart=frow-1
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
        tcode=tdtype(colnum+tstart(ibuff)) 
C       the data are being scaled from internal format to FITS:
        tofits=.true.

C       calculate the maximum number of column pixels which fit in buffer
        bytpix=max(abs(tcode)/10,1)
        maxpix=bufdim/bytpix*4

C       incre is the byte offset between consecutive pixels
        incre=0
        if (tcode .eq. 16)then
C               this is an ASCII table; table elements cannot be vectors
                repeat=1
                estart=0
        else
C               this is a binary table
                if (felem .lt. 1)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                    call ftpmsg('Starting element number for write '//
     &                 'request is out of range:'//crow//' (FTPCLB).')
                        return
                else
                        estart=felem-1
                end if

                if (tcode .gt. 0)then
                        if (hdutyp(ibuff) .eq. 0)then
C                           if this is a primary array or image extension, then
C                           set repeat as large as needed to write all
C                           the pixels.  This prevents an error message if
C                           array size is not yet known.  The actual array
C                           dimension must be defined by the NAXISn keywords
C                           before closing this HDU. 
                            repeat=estart+nelem
                        else
                            repeat=trept(colnum+tstart(ibuff))
                        end if

                        if (felem .gt. repeat)then
C                               illegal element number
                                status=308
                                write(crow,2000)felem
                    call ftpmsg('Starting element number for write '//
     &                 'request is out of range:'//crow//' (FTPCLB).')
                                return
                        end if
                        
                        if (repeat .eq. 1 .and. nelem .gt. 1)then
C                               write multiple rows of data at one time
                                incre=rowlen(ibuff)
                                repeat=maxpix
                                estart=0
                        end if
                else
C                       this is a variable length descriptor column
                        descrp=.true.
                        tcode=-tcode
                        repeat=nelem+felem-1
C                       write the number of elements and the starting offset:
                        call ftpdes(ounit,colnum,frow,repeat,
     &                              nxheap(ibuff),status)
C                       move the i/o pointer to the start of the pixel sequence
                        bstart=dtstrt(ibuff)+nxheap(ibuff)+
     &                          theap(ibuff)+estart*bytpix                
                        call ftmbyt(ounit,bstart,.true.,status)
C                       increment the empty heap starting address:
                        nxheap(ibuff)=nxheap(ibuff)+repeat*bytpix
                end if
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,repeat-estart,maxpix)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &             +tbcol(colnum+tstart(ibuff))+estart*bytpix
            call ftmbyt(ounit,bstart,.true.,status)
        end if

C       copy data to buffer, doing scaling and datatype conversion, if required
        if (tcode .eq. 11)then
C               column data type is B (byte)
                call fti1i1(array(i1),itodo,scale,zero,tofits,
     &              ival,i1val,i1val,lval,lval,chbuff,status)
C               do any machine dependent conversion and write the byte data
                call ftpi1b(ounit,itodo,incre,chbuff,status)
        else if (tcode .eq. 21)then
C               column data type is I (I*2)
                call fti1i2(array(i1),itodo,scale,zero,tofits,
     &             ival,i1val,i2val,lval,lval,buffer,status)
C               do any machine dependent data conversion and write the I*2 data
                call ftpi2b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 41)then
C               column data type is J (I*4)
                call fti1i4(array(i1),itodo,scale,zero,tofits,
     &          ival,i1val,ival,lval,lval,buffer,status)
C               do any machine dependent data conversion and write the I*4 data
                call ftpi4b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 42)then
C               column data type is E (R*4)
                call fti1r4(array(i1),itodo,scale,zero,tofits,
     &          ival,i1val,rval,lval,lval,buffer,status)
C               do any machine dependent data conversion and write the R*4 data
                call ftpr4b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 82)then
C               column data type is D (R*8)
                call fti1r8(array(i1),itodo,scale,zero,tofits,
     &          ival,i1val,dval,lval,lval,buffer,status)
C               do any machine dependent data conversion and write the R*8 data
                call ftpr8b(ounit,itodo,incre,buffer,status)
        else if (tcode .eq. 16 .and. hdutyp(ibuff) .eq. 1)then
C               this is an ASCII table column
                wform='(        )'
                wform(2:9)=cform(colnum+tstart(ibuff))
                if (cform(colnum+tstart(ibuff))(1:1) .eq. 'I')then
C                 column data type is integer
                  call fti1i4(array(i1),itodo,scale,zero,tofits,
     &            ival,i1val,ival,lval,lval,ival,status)
C                 create the formated character string
                  write(sval,wform,err=900)ival
C                 write the character string to the FITS file
                  call ftpcbf(ounit,1,tnull(colnum+tstart(ibuff)),sval,
     &                        status)
                else if (cform(colnum+tstart(ibuff))(1:1) .eq. 'F'
     &            .or.  cform(colnum+tstart(ibuff))(1:1) .eq. 'E')then
C                 column data type is real
                  call fti1r4(array(i1),itodo,scale,zero,tofits,
     &            ival,i1val,rval,lval,lval,rval,status)
C                 create the formated character string
                  write(sval,wform,err=900)rval
C                 write the character string to the FITS file
                  call ftpcbf(ounit,1,tnull(colnum+tstart(ibuff)),sval,
     &                        status)
                else if (cform(colnum+tstart(ibuff))(1:1) .eq. 'D')then
C                 column data type is double precision
                  call fti1r8(array(i1),itodo,scale,zero,tofits,
     &            ival,i1val,dval,lval,lval,dval,status)
C                 create the formated character string
                  write(sval,wform,err=900)dval
C                 write the character string to the FITS file
                  call ftpcbf(ounit,1,tnull(colnum+tstart(ibuff)),sval,
     &                        status)
                else
C                 error: illegal ASCII table format code
                  status=311
                  write(ccol,2001)colnum
        call ftpmsg('Cannot write byte (I*1) values to column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTPCLB).')
                  return
                end if
        else
C               error illegal binary table data type code
                status=312
                write(ccol,2001)colnum
        call ftpmsg('Cannot write byte (I*1) values to column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTPCLB).')
                return
        end if

        if (status .gt. 0)then
          if (hdutyp(ibuff) .eq. 0)then
C            this is a primary array or image extension
             write(cp1,2000)felem+i1-1
             write(cp2,2000)felem+i1+itodo-2
             call ftpmsg('Error writing pixels'//cp1//' to'//cp2
     &                 // ' to the FITS image array (FTPCLB).')
             if (frow .ne. 1)then
                write(cp1,2000)frow
                call ftpmsg('Error while writing group'//cp1//
     &          ' of the multigroup primary array.')
             end if
          else
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error writing elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTPCLB.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error writing rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTPCLB).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error writing'//cp2//' elements to'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTPCLB).')
             end if
          end if
          return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        if (incre .eq. 0)then
                                rstart=rstart+1
                        else
                                rstart=rstart+repeat
                        end if
                end if
                go to 20
        end if

C       check for any overflows
        if (status .eq. -11)then
                status=412
                call ftpmsg('Numeric overflow error occurred writing '//
     &        'Byte data to FITS file.')
        end if
        return

900     continue
C       error writing formatted data value to ASCII table
        write(ccol,2001)colnum
        write(cp1,2000)rstart+1
        call ftpmsg('Error writing colunm'//ccol//', row'//cp1//
     &  ' of the ASCII Table.')
        call ftpmsg('Tried to write value'//
     &              '" with format '//wform//' (FTPCLB).')
        status=313
        end

      subroutine newnot ( break, coef, l, k, brknew, lnew, coefg )
c  from  * a practical guide to splines *  by c. de boor
c  this is a fake version of  n e w n o t  , of use in example 3 of
c  chapter xiv .
c  returns  lnew+1  knots in  brknew  which are equidistributed on (a,b)
c  = (break(1),break(l+1)) .
c
      integer k,l,lnew,   i
      real break(1),brknew(1),coef(k,l),coefg(2,l),   step
c******  i n p u t ******
c  break, coef, l, k.....contains the pp-representation of a certain
c	 function  f  of order	k . specifically,
c	 d**(k-1)f(x) = coef(k,i)  for	break(i).le. x .lt.break(i+1)
c  lnew.....number of intervals into which the interval (a,b) is to be
c	 sectioned by the new breakpoint sequence  brknew .
c
c******  o u t p u t  ******
c  brknew.....array of length  lnew+1  containing the new breakpoint se-
c	 quence
c  coefg.....the coefficient part of the pp-repr.  break, coefg, l, 2
c	 for the monotone p.linear function  g	wrto which  brknew  will
c	 be equidistributed.
c
      brknew(1) = break(1)
      brknew(lnew+1) = break(l+1)
      step = (break(l+1) - break(1))/float(lnew)
      do 93 i=2,lnew
   93	 brknew(i) = break(1) + float(i-1)*step
					return
      end

include	defs

# mntoc --- translate ASCII mnemonic into a character

   character function mntoc (buf, p, defalt)
   character buf (ARB), defalt
   integer p

   integer i, tp
   integer equal

   character c, tmp (MAXLINE)

   character text (170)
   data text / _
      ACK, LETA, LETC, LETK, EOS,
      BEL, LETB, LETE, LETL, EOS,
      BS,  LETB, LETS, EOS,  EOS,
      CAN, LETC, LETA, LETN, EOS,
      CR,  LETC, LETR, EOS,  EOS,
      DC1, LETD, LETC, DIG1, EOS,
      DC2, LETD, LETC, DIG2, EOS,
      DC3, LETD, LETC, DIG3, EOS,
      DC4, LETD, LETC, DIG4, EOS,
      DEL, LETD, LETE, LETL, EOS,
      DLE, LETD, LETL, LETE, EOS,
      EM,  LETE, LETM, EOS,  EOS,
      ENQ, LETE, LETN, LETQ, EOS,
      EOT, LETE, LETO, LETT, EOS,
      ESC, LETE, LETS, LETC, EOS,
      ETB, LETE, LETT, LETB, EOS,
      ETX, LETE, LETT, LETX, EOS,
      FF,  LETF, LETF, EOS,  EOS,
      FS,  LETF, LETS, EOS,  EOS,
      GS,  LETG, LETS, EOS,  EOS,
      HT,  LETH, LETT, EOS,  EOS,
      LF,  LETL, LETF, EOS,  EOS,
      NAK, LETN, LETA, LETK, EOS,
      NUL, LETN, LETU, LETL, EOS,
      RS,  LETR, LETS, EOS,  EOS,
      SI,  LETS, LETI, EOS,  EOS,
      SO,  LETS, LETO, EOS,  EOS,
      SOH, LETS, LETO, LETH, EOS,
      SP,  LETS, LETP, EOS,  EOS,
      STX, LETS, LETT, LETX, EOS,
      SUB, LETS, LETU, LETB, EOS,
      SYN, LETS, LETY, LETN, EOS,
      US,  LETU, LETS, EOS,  EOS,
      VT,  LETV, LETT, EOS,  EOS/

   tp = 1
   repeat {
      tmp (tp) = buf (p)
      tp = tp + 1
      p = p + 1
      } until (! ((BIGA <= buf(p) & buf(p) <= BIGZ)
                | (LETA <= buf(p) & buf(p) <= LETZ)
                | (DIG0 <= buf(p) & buf(p) <= DIG9))
		  | tp >= MAXLINE)
   tmp (tp) = EOS

   if (tp == 2)
      c = tmp (1)
   else {
      call lower (tmp)
      for (i = 1; i < 170; i = i + 5)  # should use binary search here
	 if (equal (tmp, text (i + 1)) == YES)
	    break
      if (i < 170)
	 c = text (i)
      else
	 c = defalt
      }

   return (c)
   end

      SUBROUTINE slSUET (RC, DC, EQ, RM, DM)
*+
*     - - - - - -
*      S U E T
*     - - - - - -
*
*  Remove the E-terms (elliptic component of annual aberration)
*  from a pre IAU 1976 catalogue RA,Dec to give a mean place
*  (double precision)
*
*  Given:
*     RC,DC     dp     RA,Dec (radians) with E-terms included
*     EQ        dp     Besselian epoch of mean equator and equinox
*
*  Returned:
*     RM,DM     dp     RA,Dec (radians) without E-terms
*
*  Called:
*     slETRM, slDS2C, sla_,DVDV, slDC2S, slDA2P
*
*  Explanation:
*     Most star positions from pre-1984 optical catalogues (or
*     derived from astrometry using such stars) embody the
*     E-terms.  This routine converts such a position to a
*     formal mean place (allowing, for example, comparison with a
*     pulsar timing position).
*
*  Reference:
*     Explanatory Supplement to the Astronomical Ephemeris,
*     section 2D, page 48.
*
*  P.T.Wallace   Starlink   10 May 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RC,DC,EQ,RM,DM

      DOUBLE PRECISION slDA2P,slDVDV
      DOUBLE PRECISION A(3),V(3),F

      INTEGER I



*  E-terms
      CALL slETRM(EQ,A)

*  Spherical to Cartesian
      CALL slDS2C(RC,DC,V)

*  Include the E-terms
      F=1D0+slDVDV(V,A)
      DO I=1,3
         V(I)=F*V(I)-A(I)
      END DO

*  Cartesian to spherical
      CALL slDC2S(V,RM,DM)

*  Bring RA into conventional range
      RM=slDA2P(RM)

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      CHARACTER*16 FUNCTION AGBNCH (IDSH)
C
C The value of this function is the character-dash-pattern equivalent of
C the integer dash pattern IDSH, a string of quotes and/or dollar signs.
C Note that the support routines IAND and ISHIFT are used.
C
      KDSH=IDSH
C
      DO 101 I=16,1,-1
        IF (IAND(KDSH,1).EQ.0) THEN
          AGBNCH(I:I)=''''
        ELSE
          AGBNCH(I:I)='$'
        END IF
        KDSH=ISHIFT(KDSH,-1)
  101 CONTINUE
C
      RETURN
C
      END

include	defs

# stake --- take characters from a string APL-style

   integer function stake (from, to, chars)
   character from (ARB), to (ARB)
   integer chars

   integer len, start
   integer length, ctoc, max0

   len = length (from)
   if (chars < 0) {
      start = max0 (len + chars, 0)
      return (ctoc (from (start + 1), to, len + 1))
      }
   else
      return (ctoc (from, to, chars + 1))

   end

C FUNCTION FCHISQ.F
C
C SOURCE
C   BEVINGTON, PAGE 194.
C
C PURPOSE
C   EVALUATE REDUCED CHI SQUARE FOR FIT OF DATA 
C     FCHISQ = SUM ((Y-YFIT)**2 / SIGMA**2) / NFREE
C
C USAGE 
C   RESULT = FCHISQ (Y, SIGMAY, NPTS, NFREE, MODE, YFIT)
C
C DESCRIPTION OF PARAMETERS
C   Y	   - ARRAY OF DATA POINTS
C   SIGMAY - ARRAY OF STANDARD DEVIATIONS FOR DATA POINTS
C   NPTS   - NUMBER OF DATA POINTS
C   NFREE  - NUMBER OF DEGREES OF FREEDOM
C   MODE   - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C	     +1 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
C	      0 (NO WEIGHTING) WEIGHT(I) = 1.
C	     -1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
C   YFIT   - ARRAY OF CALCULATED VALUES OF Y
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE
C
	FUNCTION FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT) 
	DOUBLE PRECISION CHISQ,WEIGHT
	DIMENSION Y(1),SIGMAY(1),YFIT(1)
11	CHISQ=0.
12	IF (NFREE) 13,13,20
13	FCHISQ=0.
	GOTO 40 
C
C ACCUMULATE CHI SQUARE 
C
20	DO 30 I=1,NPTS
21	IF (MODE) 22,27,29
22	IF (Y(I)) 25,27,23
23	WEIGHT=1./Y(I)
	GOTO 30 
25	WEIGHT=1./(-Y(I))
	GOTO 30 
27	WEIGHT=1.
	GOTO 30 
29	WEIGHT=1./SIGMAY(I)**2
30	CHISQ=CHISQ+WEIGHT*(Y(I)-YFIT(I))**2
C
C	DIVIDE BY NUMBER OF DEGREES OF FREEDOM
C
31	FREE=NFREE
32	FCHISQ=CHISQ/FREE
40	RETURN
	END

      SUBROUTINE slCADJ (IY, IM, ID, DJM, J)
*+
*     - - - - - -
*      C A D J
*     - - - - - -
*
*  Gregorian Calendar to Modified Julian Date
*
*  (Includes century default feature:  use slCLDJ for years
*   before 100AD.)
*
*  Given:
*     IY,IM,ID     int    year, month, day in Gregorian calendar
*
*  Returned:
*     DJM          dp     modified Julian Date (JD-2400000.5) for 0 hrs
*     J            int    status:
*                           0 = OK
*                           1 = bad year   (MJD not computed)
*                           2 = bad month  (MJD not computed)
*                           3 = bad day    (MJD computed)
*
*  Acceptable years are 00-49, interpreted as 2000-2049,
*                       50-99,     "       "  1950-1999,
*                       100 upwards, interpreted literally.
*
*  Called:  slCLDJ
*
*  P.T.Wallace   Starlink   November 1985
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID
      DOUBLE PRECISION DJM
      INTEGER J

      INTEGER NY




*  Default century if appropriate
      IF (IY.GE.0.AND.IY.LE.49) THEN
         NY=IY+2000
      ELSE IF (IY.GE.50.AND.IY.LE.99) THEN
         NY=IY+1900
      ELSE
         NY=IY
      END IF

*  Modified Julian Date
      CALL slCLDJ(NY,IM,ID,DJM,J)

      END

c BSWAP2 - Move bytes from array "a" to array "b", swapping successive
c pairs of bytes.

	subroutine bswap2 (a, aoff, b, boff, nbytes)

	character*1 a(*), b(*), temp
	integer	aoff, boff, nbytes, i
	integer aoff1, boff1

		aoff1 = aoff + 1
		boff1 = boff + 1

 		do 10 i = 0, nbytes-1, 2
		    temp = a(aoff1+i)
		    if (i .ne. nbytes) then
			b(boff1+i) = a(aoff+i)
		    endif
		    b(boff+i) = temp
 10		continue
	end

C----------------------------------------------------------------------
        subroutine ftgtdm(iunit,colnum,maxdim,naxis,naxes,status)

C       parse the TDIMnnn keyword to get the dimensionality of a column

C       iunit   i  fortran unit number to use for reading
C       colnum  i  column number to read
C       maxdim  i  maximum no. of dimensions to read; dimension of naxes
C       OUTPUT PARAMETERS:
C       naxis   i  number of axes in the data array
C       naxes   i  array giving the length of each data axis
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, October 1993

        integer iunit,colnum,maxdim,naxis,naxes(*),status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,nfound,c1,c2,clast,dimval
        logical last
        character*120 tdim

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

        if (colnum .lt. 1 .or. colnum .gt. tfield(ibuff))then
C               illegal column number
                status=302
                return
        end if

        nfound=0
C       try getting the TDIM keyword value
        call ftgkns(iunit,'TDIM',colnum,1,tdim,nfound,status)

        if (nfound .ne. 1)then
C               no TDIM keyword found
                naxis=1
                naxes(1)=trept(colnum+tstart(ibuff))
                return
        end if

        naxis=0
C       first, find the opening ( and closing )
        c1=index(tdim,'(')+1
        c2=index(tdim,')')-1
        if (c1 .eq. 1 .or. c2 .eq. -1)go to 900

        last=.false.
C       find first non-blank character
10      if (tdim(c1:c1) .ne. ' ')go to 20
        c1=c1+1
        go to 10

C       find the comma separating the dimension sizes
20      clast=index(tdim(c1:c2),',')+c1-2
        if (clast .eq. c1-2)then
                last=.true.
                clast=c2
        end if

C       read the string of characters as the (integer) dimension size
        call ftc2ii(tdim(c1:clast),dimval,status)
        if (status .gt. 0)then
             call ftpmsg('Error in FTGTDM parsing dimension string: '
     &       //tdim)
             go to 900
        end if

        naxis=naxis+1
        if (naxis .le. maxdim)naxes(naxis)=dimval

        if (last)return

        c1=clast+2
        go to 10

C       could not parse the tdim value
900     status=263
        end

      SUBROUTINE slEQEC (DR, DD, DATE, DL, DB)
*+
*     - - - - - -
*      E Q E C
*     - - - - - -
*
*  Transformation from J2000.0 equatorial coordinates to
*  ecliptic coordinates (double precision)
*
*  Given:
*     DR,DD       dp      J2000.0 mean RA,Dec (radians)
*     DATE        dp      TDB (loosely ET) as Modified Julian Date
*                                              (JD-2400000.5)
*  Returned:
*     DL,DB       dp      ecliptic longitude and latitude
*                         (mean of date, IAU 1980 theory, radians)
*
*  Called:
*     slDS2C, slPREC, slEPJ, slDMXV, slECMA, slDC2S,
*     slDA2P, slDA1P
*
*  P.T.Wallace   Starlink   March 1986
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DR,DD,DATE,DL,DB

      DOUBLE PRECISION slEPJ,slDA2P,slDA1P

      DOUBLE PRECISION RMAT(3,3),V1(3),V2(3)



*  Spherical to Cartesian
      CALL slDS2C(DR,DD,V1)

*  Mean J2000 to mean of date
      CALL slPREC(2000D0,slEPJ(DATE),RMAT)
      CALL slDMXV(RMAT,V1,V2)

*  Equatorial to ecliptic
      CALL slECMA(DATE,RMAT)
      CALL slDMXV(RMAT,V2,V1)

*  Cartesian to spherical
      CALL slDC2S(V1,DL,DB)

*  Express in conventional ranges
      DL=slDA2P(DL)
      DB=slDA1P(DB)

      END

c
c subroutine dinver (a, max, n, iflag)
c
c Arguments
c 
c     a (input/output) is a square matrix of dimension N.  The inverse 
c       of the input matrix A is returned in A.
c
c   max (input) is the size assigned to the matrix A in the calling 
c       routine.  It's needed for the dimension statement below.
c
c iflag (output) is an error flag.  iflag  =  1 if the matrix could not
c       be inverted; iflag  =  0 if it could.
c
      subroutine dinver (a, max, n, iflag)
c
      implicit none
      integer max, n, iflag
      double precision a(max,max)
      integer i, j, k
c
      iflag = 0
      i = 1
  300 if (a(i,i) .eq. 0.0d0) go to 9100
      a(i,i) = 1.0e0 / a(i,i)
      j = 1
  301 if (j .eq. i) go to 304
      a(j,i) = -a(j,i) * a(i,i)
      k = 1
  302 if (k .eq. i) go to 303
      a(j,k) = a(j,k) + a(j,i) * a(i,k)
  303 if (k .eq. n) go to 304
      k = k + 1
      go to 302
  304 if (j .eq. n) go to 305
      j = j + 1
      go to 301
  305 k = 1
  306 if (k .eq. i) go to 307
      a(i,k) = a(i,k) * a(i,i)
  307 if (k .eq. n) go to 308
      k = k + 1
      go to 306
  308 if (i .eq. n) return
      i = i+1
      go to 300
c
c Error:  zero on the diagonal.
c
 9100 iflag = 1
      return
c
      end

      REAL FUNCTION slRVER (PHI, RA, DA, ST)
*+
*     - - - - - - -
*      R V E R
*     - - - - - - -
*
*  Velocity component in a given direction due to Earth rotation
*  (single precision)
*
*  Given:
*     PHI     real    latitude of observing station (geodetic)
*     RA,DA   real    apparent RA,DEC
*     ST      real    local apparent sidereal time
*
*  PHI, RA, DEC and ST are all in radians.
*
*  Result:
*     Component of Earth rotation in direction RA,DA (km/s)
*
*  Sign convention:
*     The result is +ve when the observatory is receding from the
*     given point on the sky.
*
*  Accuracy:
*     The simple algorithm used assumes a spherical Earth, of
*     a radius chosen to give results accurate to about 0.0005 km/s
*     for observing stations at typical latitudes and heights.  For
*     applications requiring greater precision, use the routine
*     slPVOB.
*
*  P.T.Wallace   Starlink   20 July 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL PHI,RA,DA,ST

*  Nominal mean sidereal speed of Earth equator in km/s (the actual
*  value is about 0.4651)
      REAL ESPEED
      PARAMETER (ESPEED=0.4655)


      slRVER=ESPEED*COS(PHI)*SIN(ST-RA)*COS(DA)

      END

      subroutine addchr (c, buf, bp, maxsiz)
      integer bp, maxsiz
      integer c, buf (100)
      if (.not.(bp .gt. maxsiz))goto 23000
      call baderr (16Hbuffer overflow.)
23000 continue
      buf (bp) = c
      bp = bp + 1
      return
      end

      SUBROUTINE slRFRO ( ZOBS, HM, TDK, PMB, RH, WL, PHI, TLR,
     :                       EPS, REF )
*+
*     - - - - - -
*      R F R O
*     - - - - - -
*
*  Atmospheric refraction for radio and optical/IR wavelengths.
*
*  Given:
*    ZOBS    d  observed zenith distance of the source (radian)
*    HM      d  height of the observer above sea level (metre)
*    TDK     d  ambient temperature at the observer (K)
*    PMB     d  pressure at the observer (millibar)
*    RH      d  relative humidity at the observer (range 0-1)
*    WL      d  effective wavelength of the source (micrometre)
*    PHI     d  latitude of the observer (radian, astronomical)
*    TLR     d  temperature lapse rate in the troposphere (K/metre)
*    EPS     d  precision required to terminate iteration (radian)
*
*  Returned:
*    REF     d  refraction: in vacuo ZD minus observed ZD (radian)
*
*  Notes:
*
*  1  A suggested value for the TLR argument is 0.0065D0.  The
*     refraction is significantly affected by TLR, and if studies
*     of the local atmosphere have been carried out a better TLR
*     value may be available.  The sign of the supplied TLR value
*     is ignored.
*
*  2  A suggested value for the EPS argument is 1D-8.  The result is
*     usually at least two orders of magnitude more computationally
*     precise than the supplied EPS value.
*
*  3  The routine computes the refraction for zenith distances up
*     to and a little beyond 90 deg using the method of Hohenkerk
*     and Sinclair (NAO Technical Notes 59 and 63, subsequently adopted
*     in the Explanatory Supplement, 1992 edition - see section 3.281).
*
*  4  The code is a development of the optical/IR refraction subroutine
*     AREF of C.Hohenkerk (HMNAO, September 1984), with extensions to
*     support the radio case.  Apart from merely cosmetic changes, the
*     following modifications to the original HMNAO optical/IR refraction
*     code have been made:
*
*     .  The angle arguments have been changed to radians.
*
*     .  Any value of ZOBS is allowed (see note 6, below).
*
*     .  Other argument values have been limited to safe values.
*
*     .  Murray's values for the gas constants have been used
*        (Vectorial Astrometry, Adam Hilger, 1983).
*
*     .  The numerical integration phase has been rearranged for
*        extra clarity.
*
*     .  A better model for Ps(T) has been adopted (taken from
*        Gill, Atmosphere-Ocean Dynamics, Academic Press, 1982).
*
*     .  More accurate expressions for Pwo have been adopted
*        (again from Gill 1982).
*
*     .  The formula for the water vapour pressure, given the
*        saturation pressure and the relative humidity, is from
*        Crane (1976), expression 2.5.5.
*
*     .  Provision for radio wavelengths has been added using
*        expressions devised by A.T.Sinclair, RGO (private
*        communication 1989).  The refractivity model currently
*        used is from J.M.Rueger, "Refractive Index Formulae for
*        Electronic Distance Measurement with Radio and Millimetre
*        Waves", in Unisurv Report S-68 (2002), School of Surveying
*        and Spatial Information Systems, University of New South
*        Wales, Sydney, Australia.
*
*     .  The optical refractivity for dry air is from Resolution 3 of
*        the International Association of Geodesy adopted at the XXIIth
*        General Assembly in Birmingham, UK, 1999.
*
*     .  Various small changes have been made to gain speed.
*
*  5  The radio refraction is chosen by specifying WL > 100 micrometres.
*     Because the algorithm takes no account of the ionosphere, the
*     accuracy deteriorates at low frequencies, below about 30 MHz.
*
*  6  Before use, the value of ZOBS is expressed in the range +/- pi.
*     If this ranged ZOBS is -ve, the result REF is computed from its
*     absolute value before being made -ve to match.  In addition, if
*     it has an absolute value greater than 93 deg, a fixed REF value
*     equal to the result for ZOBS = 93 deg is returned, appropriately
*     signed.
*
*  7  As in the original Hohenkerk and Sinclair algorithm, fixed values
*     of the water vapour polytrope exponent, the height of the
*     tropopause, and the height at which refraction is negligible are
*     used.
*
*  8  The radio refraction has been tested against work done by
*     Iain Coulson, JACH, (private communication 1995) for the
*     James Clerk Maxwell Telescope, Mauna Kea.  For typical conditions,
*     agreement at the 0.1 arcsec level is achieved for moderate ZD,
*     worsening to perhaps 0.5-1.0 arcsec at ZD 80 deg.  At hot and
*     humid sea-level sites the accuracy will not be as good.
*
*  9  It should be noted that the relative humidity RH is formally
*     defined in terms of "mixing ratio" rather than pressures or
*     densities as is often stated.  It is the mass of water per unit
*     mass of dry air divided by that for saturated air at the same
*     temperature and pressure (see Gill 1982).
*
*  10 The algorithm is designed for observers in the troposphere.  The
*     supplied temperature, pressure and lapse rate are assumed to be
*     for a point in the troposphere and are used to define a model
*     atmosphere with the tropopause at 11km altitude and a constant
*     temperature above that.  However, in practice, the refraction
*     values returned for stratospheric observers, at altitudes up to
*     25km, are quite usable.
*
*  Called:  slDA1P, slATMT, slATMS
*
*  Last revision:   5 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION ZOBS,HM,TDK,PMB,RH,WL,PHI,TLR,EPS,REF

*
*  Fixed parameters
*
      DOUBLE PRECISION D93,GCR,DMD,DMW,S,DELTA,HT,HS
      INTEGER ISMAX
*  93 degrees in radians
      PARAMETER (D93=1.623156204D0)
*  Universal gas constant
      PARAMETER (GCR=8314.32D0)
*  Molecular weight of dry air
      PARAMETER (DMD=28.9644D0)
*  Molecular weight of water vapour
      PARAMETER (DMW=18.0152D0)
*  Mean Earth radius (metre)
      PARAMETER (S=6378120D0)
*  Exponent of temperature dependence of water vapour pressure
      PARAMETER (DELTA=18.36D0)
*  Height of tropopause (metre)
      PARAMETER (HT=11000D0)
*  Upper limit for refractive effects (metre)
      PARAMETER (HS=80000D0)
*  Numerical integration: maximum number of strips.
      PARAMETER (ISMAX=16384)

      INTEGER IS,K,N,I,J
      LOGICAL OPTIC,LOOP
      DOUBLE PRECISION ZOBS1,ZOBS2,HMOK,TDKOK,PMBOK,RHOK,WLOK,ALPHA,
     :                 TOL,WLSQ,GB,A,GAMAL,GAMMA,GAMM2,DELM2,
     :                 TDC,PSAT,PWO,W,
     :                 C1,C2,C3,C4,C5,C6,R0,TEMPO,DN0,RDNDR0,SK0,F0,
     :                 RT,TT,DNT,RDNDRT,SINE,ZT,FT,DNTS,RDNDRP,ZTS,FTS,
     :                 RS,DNS,RDNDRS,ZS,FS,REFOLD,Z0,ZRANGE,FB,FF,FO,FE,
     :                 H,R,SZ,RG,DR,TG,DN,RDNDR,T,F,REFP,REFT

      DOUBLE PRECISION slDA1P

*  The refraction integrand
      DOUBLE PRECISION REFI
      REFI(DN,RDNDR) = RDNDR/(DN+RDNDR)



*  Transform ZOBS into the normal range.
      ZOBS1 = slDA1P(ZOBS)
      ZOBS2 = MIN(ABS(ZOBS1),D93)

*  Keep other arguments within safe bounds.
      HMOK = MIN(MAX(HM,-1D3),HS)
      TDKOK = MIN(MAX(TDK,100D0),500D0)
      PMBOK = MIN(MAX(PMB,0D0),10000D0)
      RHOK = MIN(MAX(RH,0D0),1D0)
      WLOK = MAX(WL,0.1D0)
      ALPHA = MIN(MAX(ABS(TLR),0.001D0),0.01D0)

*  Tolerance for iteration.
      TOL = MIN(MAX(ABS(EPS),1D-12),0.1D0)/2D0

*  Decide whether optical/IR or radio case - switch at 100 microns.
      OPTIC = WLOK.LE.100D0

*  Set up model atmosphere parameters defined at the observer.
      WLSQ = WLOK*WLOK
      GB = 9.784D0*(1D0-0.0026D0*COS(PHI+PHI)-0.00000028D0*HMOK)
      IF (OPTIC) THEN
         A = (287.6155D0+(1.62887D0+0.01360D0/WLSQ)/WLSQ)
     :                                              *273.15D-6/1013.25D0
      ELSE
         A = 77.6890D-6
      END IF
      GAMAL = (GB*DMD)/GCR
      GAMMA = GAMAL/ALPHA
      GAMM2 = GAMMA-2D0
      DELM2 = DELTA-2D0
      TDC = TDKOK-273.15D0
      PSAT = 10D0**((0.7859D0+0.03477D0*TDC)/(1D0+0.00412D0*TDC))*
     :                                (1D0+PMBOK*(4.5D-6+6D-10*TDC*TDC))
      IF (PMBOK.GT.0D0) THEN
         PWO = RHOK*PSAT/(1D0-(1D0-RHOK)*PSAT/PMBOK)
      ELSE
         PWO = 0D0
      END IF
      W = PWO*(1D0-DMW/DMD)*GAMMA/(DELTA-GAMMA)
      C1 = A*(PMBOK+W)/TDKOK
      IF (OPTIC) THEN
         C2 = (A*W+11.2684D-6*PWO)/TDKOK
      ELSE
         C2 = (A*W+6.3938D-6*PWO)/TDKOK
      END IF
      C3 = (GAMMA-1D0)*ALPHA*C1/TDKOK
      C4 = (DELTA-1D0)*ALPHA*C2/TDKOK
      IF (OPTIC) THEN
         C5 = 0D0
         C6 = 0D0
      ELSE
         C5 = 375463D-6*PWO/TDKOK
         C6 = C5*DELM2*ALPHA/(TDKOK*TDKOK)
      END IF

*  Conditions at the observer.
      R0 = S+HMOK
      CALL slATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,C1,C2,C3,C4,C5,C6,
     :                                              R0,TEMPO,DN0,RDNDR0)
      SK0 = DN0*R0*SIN(ZOBS2)
      F0 = REFI(DN0,RDNDR0)

*  Conditions in the troposphere at the tropopause.
      RT = S+MAX(HT,HMOK)
      CALL slATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,C1,C2,C3,C4,C5,C6,
     :                                                 RT,TT,DNT,RDNDRT)
      SINE = SK0/(RT*DNT)
      ZT = ATAN2(SINE,SQRT(MAX(1D0-SINE*SINE,0D0)))
      FT = REFI(DNT,RDNDRT)

*  Conditions in the stratosphere at the tropopause.
      CALL slATMS(RT,TT,DNT,GAMAL,RT,DNTS,RDNDRP)
      SINE = SK0/(RT*DNTS)
      ZTS = ATAN2(SINE,SQRT(MAX(1D0-SINE*SINE,0D0)))
      FTS = REFI(DNTS,RDNDRP)

*  Conditions at the stratosphere limit.
      RS = S+HS
      CALL slATMS(RT,TT,DNT,GAMAL,RS,DNS,RDNDRS)
      SINE = SK0/(RS*DNS)
      ZS = ATAN2(SINE,SQRT(MAX(1D0-SINE*SINE,0D0)))
      FS = REFI(DNS,RDNDRS)

*  Variable initialization to avoid compiler warning.
      REFT = 0D0

*  Integrate the refraction integral in two parts;  first in the
*  troposphere (K=1), then in the stratosphere (K=2).

      DO K = 1,2

*     Initialize previous refraction to ensure at least two iterations.
         REFOLD = 1D0

*     Start off with 8 strips.
         IS = 8

*     Start Z, Z range, and start and end values.
         IF (K.EQ.1) THEN
            Z0 = ZOBS2
            ZRANGE = ZT-Z0
            FB = F0
            FF = FT
         ELSE
            Z0 = ZTS
            ZRANGE = ZS-Z0
            FB = FTS
            FF = FS
         END IF

*     Sums of odd and even values.
         FO = 0D0
         FE = 0D0

*     First time through the loop we have to do every point.
         N = 1

*     Start of iteration loop (terminates at specified precision).
         LOOP = .TRUE.
         DO WHILE (LOOP)

*        Strip width.
            H = ZRANGE/DBLE(IS)

*        Initialize distance from Earth centre for quadrature pass.
            IF (K.EQ.1) THEN
               R = R0
            ELSE
               R = RT
            END IF

*        One pass (no need to compute evens after first time).
            DO I=1,IS-1,N

*           Sine of observed zenith distance.
               SZ = SIN(Z0+H*DBLE(I))

*           Find R (to the nearest metre, maximum four iterations).
               IF (SZ.GT.1D-20) THEN
                  W = SK0/SZ
                  RG = R
                  DR = 1D6
                  J = 0
                  DO WHILE (ABS(DR).GT.1D0.AND.J.LT.4)
                     J=J+1
                     IF (K.EQ.1) THEN
                        CALL slATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,
     :                                 C1,C2,C3,C4,C5,C6,RG,TG,DN,RDNDR)
                     ELSE
                        CALL slATMS(RT,TT,DNT,GAMAL,RG,DN,RDNDR)
                     END IF
                     DR = (RG*DN-W)/(DN+RDNDR)
                     RG = RG-DR
                  END DO
                  R = RG
               END IF

*           Find the refractive index and integrand at R.
               IF (K.EQ.1) THEN
                  CALL slATMT(R0,TDKOK,ALPHA,GAMM2,DELM2,
     :                                   C1,C2,C3,C4,C5,C6,R,T,DN,RDNDR)
               ELSE
                  CALL slATMS(RT,TT,DNT,GAMAL,R,DN,RDNDR)
               END IF
               F = REFI(DN,RDNDR)

*           Accumulate odd and (first time only) even values.
               IF (N.EQ.1.AND.MOD(I,2).EQ.0) THEN
                  FE = FE+F
               ELSE
                  FO = FO+F
               END IF
            END DO

*        Evaluate the integrand using Simpson's Rule.
            REFP = H*(FB+4D0*FO+2D0*FE+FF)/3D0

*        Has the required precision been achieved (or can't be)?
            IF (ABS(REFP-REFOLD).GT.TOL.AND.IS.LT.ISMAX) THEN

*           No: prepare for next iteration.

*           Save current value for convergence test.
               REFOLD = REFP

*           Double the number of strips.
               IS = IS+IS

*           Sum of all current values = sum of next pass's even values.
               FE = FE+FO

*           Prepare for new odd values.
               FO = 0D0

*           Skip even values next time.
               N = 2
            ELSE

*           Yes: save troposphere component and terminate the loop.
               IF (K.EQ.1) REFT = REFP
               LOOP = .FALSE.
            END IF
         END DO
      END DO

*  Result.
      REF = REFT+REFP
      IF (ZOBS1.LT.0D0) REF = -REF

      END

C----------------------------------------------------------------------
        subroutine ftgbnh(iunit,nrows,nfield,ttype,tform,tunit,
     &                    extnam,pcount,status)

C       OBSOLETE routine: should call ftghbn instead

        integer iunit,nrows,nfield,pcount,status
        character*(*) ttype(*),tform(*),tunit(*),extnam

        call ftghbn(iunit,-1,nrows,nfield,ttype,tform,
     &                    tunit,extnam,pcount,status)
        end

      integer function allblk (buf)
      integer buf (100)
      integer i
      allblk = 1
      i = 1
23000 if (.not.(buf (i) .ne. 10 .and. buf (i) .ne. -2))goto 23002
      if (.not.(buf (i) .ne. 32))goto 23003
      allblk = 0
      goto 23002
23003 continue
23001 i = i + 1
      goto 23000
23002 continue
      return
      end

C----------------------------------------------------------------------
        subroutine ftgcfd(iunit,colnum,frow,felem,nelem,array,
     &          flgval,anynul,status)

C       read an array of r*8 values from a specified column of the table.
C       Any undefined pixels will be have the corresponding value of FLGVAL
C       set equal to .true., and ANYNUL will be set equal to .true. if
C       any pixels are undefined.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of elements to read
C       array   d  returned array of data values that was read from FITS file
C       flgval  l  set .true. if corresponding element undefined
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,status
        logical flgval(*),anynul
        double precision array(*),dummy
        integer i

        do 10 i=1,nelem
                flgval(i)=.false.
10      continue

        call ftgcld(iunit,colnum,frow,felem,nelem,1,2,dummy,
     &      array,flgval,anynul,status)
        end        

      DOUBLE PRECISION FUNCTION slEQEX (DATE)
*+
*     - - - - - -
*      E Q E X
*     - - - - - -
*
*  Equation of the equinoxes  (IAU 1994, double precision)
*
*  Given:
*     DATE    dp      TDB (loosely ET) as Modified Julian Date
*                                          (JD-2400000.5)
*
*  The result is the equation of the equinoxes (double precision)
*  in radians:
*
*     Greenwich apparent ST = GMST + slEQEX
*
*  References:  IAU Resolution C7, Recommendation 3 (1994)
*               Capitaine, N. & Gontier, A.-M., Astron. Astrophys.,
*               275, 645-650 (1993)
*
*  Called:  slNUTC
*
*  Patrick Wallace   Starlink   23 August 1996, amended 22 May 2021
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE

*  Turns to arc seconds and arc seconds to radians
      DOUBLE PRECISION T2AS,AS2R
      PARAMETER (T2AS=1296000D0,
     :           AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T,OM,DPSI,DEPS,EPS0



*  Interval between basic epoch J2000.0 and current epoch (JC)
      T=(DATE-51544.5D0)/36525D0

*  Longitude of the mean ascending node of the lunar orbit on the
*   ecliptic, measured from the mean equinox of date
      OM=AS2R*(450160.280D0+(-5D0*T2AS-482890.539D0
     :         +(7.455D0+0.008D0*T)*T)*T)

*  Nutation
      CALL slNUTC80(DATE,DPSI,DEPS,EPS0)

*  Equation of the equinoxes
      slEQEX=DPSI*COS(EPS0)+AS2R*(0.00264D0*SIN(OM)+
     :                               0.000063D0*SIN(OM+OM))

      END

C----------------------------------------------------------------------
        subroutine ftptbh(ounit,ncols,nrows,nfield,ttype,tbcol,
     &  tform,tunit,extnam,status)

C       OBSOLETE routine: should call ftphtb instead

        integer ounit,ncols,nrows,nfield,tbcol(*),status
        character*(*) ttype(*),tform(*),tunit(*),extnam

        call ftphtb(ounit,ncols,nrows,nfield,ttype,tbcol,
     &  tform,tunit,extnam,status)
        end

C--------------------------------------------------------------------------
        subroutine ftgkyt(iunit,keywrd,jval,dval,comm,status)

C       read an integer value and fractional parts of a keyword value
C       and the comment string from a header record 
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name   
C       OUTPUT PARAMETERS:
C       jval    i  output integer part of keyword value 
C       dval    d  output fractional part of keyword value 
C       comm    c  output keyword comment
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, Sept 1992

        character*(*) keywrd,comm
        integer iunit,jval,status,i,dot
        double precision dval
        character value*35
        logical ed

C       find the keyword and return value and comment as character strings
        call ftgkey(iunit,keywrd,value,comm,status)

C       read keyword in straight forward way first:
C       just convert character string to double precision
C       datatype conversion will be performed if necessary and if possible
        call ftc2d(value,dval,status)
        jval=dval
        if (jval .ge. 0)then
                dval=dval-jval
        else
                dval=dval+jval
        end if

C       now see if we have to read the fractional part again, this time
C       with more precision

C       find the decimal point, if any, and look for a D or E
        dot=0
        ed=.false.
        do 10 i=1,35
            if (value(i:i) .eq. '.')dot=i
            if (value(i:i) .eq. 'E' .or. value(i:i) .eq. 'D')ed=.true.
10      continue

        if (.not. ed .and. dot .gt. 0)then
C           convert fractional part to double precision
            call ftc2d(value(dot:),dval,status)
        end if

        end

      integer function caslab (n, t)
      integer n, t
      integer tok(100)
      integer i, s, lev
      integer gnbtok, ctoi
      caslab=0
      t = gnbtok (tok, 100)
23000 if (.not.(t .eq. 10))goto 23001
      t = gnbtok (tok, 100)
      goto 23000
23001 continue
      if (.not.(t .eq. -1))goto 23002
      caslab=(t)
      return
23002 continue
      lev=0
23004 if (.not.(t .eq. 40))goto 23006
      lev = lev + 1
23005 t = gnbtok (tok, 100)
      goto 23004
23006 continue
      if (.not.(t .eq. 45))goto 23007
      s = -1
      goto 23008
23007 continue
      s = +1
23008 continue
      if (.not.(t .eq. 45 .or. t .eq. 43))goto 23009
      t = gnbtok (tok, 100)
23009 continue
      if (.not.(t .ne. 48))goto 23011
      goto 99
c     goto 23012
23011 continue
      i = 1
      n = s * ctoi (tok, i)
23012 continue
      t=gnbtok(tok,100)
23013 if (.not.(t .eq. 41))goto 23015
      lev = lev - 1
23014 t=gnbtok(tok,100)
      goto 23013
23015 continue
      if (.not.(lev .ne. 0))goto 23016
      goto 99
23016 continue
23018 if (.not.(t .eq. 10))goto 23019
      t = gnbtok (tok, 100)
      goto 23018
23019 continue
      return
99    call synerr (19HInvalid case label.)
      n = 0
      end

C------------------------------------------------------------------------------
        subroutine ftxiou(iounit,status)

C       generic routine to manage logical unit numbers in the range 50-99

        integer iounit,status,i
        integer*2 array(50)
        save array
        data array/50*0/

        if (iounit .eq. 0)then
C           get an unused logical unit number
            do 10 i=50,1,-1
                 if (array(i) .eq. 0)then
                     array(i)=1
                     iounit=i+49
                     return
                 end if
10          continue
C           error: all units are allocated
            iounit=-1
            status=114
            call ftpmsg('FTGIOU has no more available unit numbers.')

        else if (iounit .eq. -1)then
C           deallocate all the unit numbers
            do 20 i=1,50
                 array(i)=0
20          continue

        else
C            deallocat a specific unit number
             if (iounit .ge. 50 .and. iounit .le. 99)then
                 array(iounit-49)=0
             end if
        endif
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSETP (TPID,FURA,LURA)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(LURA)
C
C The routine AGSETP stores user-provided values of the AUTOGRAPH
C parameters specified by the parameter identifier TPID.  The arguments
C are as follows:
C
C -- TPID is the parameter identifier, a string of keywords separated
C    from each other by slashes and followed by a period.
C
C -- FURA is the user array from which parameter values are to be taken.
C
C -- LURA is the length of the user array.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The following common block contains other AUTOGRAPH variables, of type
C character.
C
      COMMON /AGOCHP/ CHS1,CHS2
C
c+noao
c     CHARACTER*504 CHS1,CHS2
      CHARACTER*500 CHS1,CHS2
c-noao
C
C Define the array DUMI, which allows access to the control-parameter
C list as an array.
C
      DIMENSION DUMI(1)
      EQUIVALENCE (QFRA,DUMI)
C
C +NOAO - Make sure common has been initialized. 
C
      call agdflt
C
C -NOAO
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C The routine AGSCAN is called to scan the parameter identifier and to
C return three quantities describing the AUTOGRAPH parameters affected.
C
      CALL AGSCAN (TPID,LOPA,NIPA,IIPA)
C
C Determine the number of values to transfer.
C
      NURA=MAX0(1,MIN0(LURA,NIPA))
C
C If character-string dash patterns are being replaced by integer dash
C patterns, reclaim the space used in the character-storage arrays.
C
      CALL AGSCAN ('DASH/PATT.',LODP,NIDP,IIDP)
      IF (LOPA.LE.LODP+NIDP-1.AND.LOPA+NURA-1.GE.LODP) THEN
        MINI=MAX0(LOPA,LODP)-LOPA+1
        MAXI=MIN0(LOPA+NURA-1,LODP+NIDP-1)-LOPA+1
        DO 100 I=MINI,MAXI
          IF (FURA(I).GT.0.) CALL AGDLCH (IFIX(DUMI(LOPA+I-1)))
  100   CONTINUE
      END IF
C
C Save the current values of special values 1 and 2.
C
      SVL1=SVAL(1)
      SVL2=SVAL(2)
C
C Transfer the user-provided values to the parameter list.
C
      IDMI=LOPA-IIPA
C
      DO 101 IURA=1,NURA
        IDMI=IDMI+IIPA
        DUMI(IDMI)=FURA(IURA)
  101 CONTINUE
C
C If a specific item was changed, we may have a bit more work to do;
C otherwise, return to the user.
C
      IF (NIPA.NE.1) RETURN
C
C If the specific item was special value 1 or 2, scan the primary list
C of parameters for other occurrences of the special value and change
C them to the new value.
C
      IF (SVAL(1).NE.SVL1) THEN
        SVLO=SVL1
        SVLN=SVAL(1)
        GO TO 102
      END IF
C
      IF (SVAL(2).NE.SVL2) THEN
        SVLO=SVL2
        SVLN=SVAL(2)
        GO TO 102
      END IF
C
      GO TO 104
C
  102 CALL AGSCAN ('PRIM.',LOPR,NIPR,IIPR)
C
      IDMI=LOPR-IIPR
C
      DO 103 I=1,NIPR
        IDMI=IDMI+IIPR
        IF (DUMI(IDMI).EQ.SVLO) DUMI(IDMI)=SVLN
  103 CONTINUE
C
      RETURN
C
C If the specific item was the label control flag and it was set
C negative, delete all labels and lines.
C
  104 CALL AGSCAN ('LABE/CONT.',LOLC,NILC,IILC)
      IF (LOPA.NE.LOLC) GO TO 107
      IF (QDLB.GE.0.) RETURN
C
      QBAN=0.
      QNAN=0.
C
      LBIM=IFIX(QBIM)
C
      DO 105 I=1,LBIM
        IF (FLLB(1,I).NE.0.) THEN
          CALL AGDLCH (IFIX(FLLB(1,I)))
          FLLB(1,I)=0.
        END IF
  105 CONTINUE
C
      LNIM=IFIX(QNIM)
C
      DO 106 I=1,LNIM
        IF (FLLN(1,I).NE.SVAL(1)) THEN
          CALL AGDLCH (IFIX(FLLN(4,I)))
          FLLN(1,I)=SVAL(1)
        END IF
  106 CONTINUE
C
      RETURN
C
C If the specific item was the label name, reset it to an appropriate
C index in the label list, providing initial values if appropriate.
C
  107 CALL AGSCAN ('LABE/NAME.',LOLN,NILN,IILN)
      IF (LOPA.NE.LOLN) GO TO 109
C
      LBAN=0
      LBIM=IFIX(QBIM)
      QNAN=0.
C
      CALL AGGTCH (IFIX(FURA(1)),CHS1,LCS1)
C
      DO 108 I=1,LBIM
        IF (LBAN.EQ.0.AND.FLLB(1,I).EQ.0.) LBAN=I
        CALL AGGTCH (IFIX(FLLB(1,I)),CHS2,LCS2)
        IF (LCS1.NE.LCS2) GO TO 108
        IF (CHS1(1:LCS1).NE.CHS2(1:LCS2)) GO TO 108
        QBAN=FLOAT(I)
        RETURN
  108 CONTINUE
C
      IF (LBAN.EQ.0) GO TO 901
C
      QBAN=FLOAT(LBAN)
C
      FLLB( 1,LBAN)=FURA(1)
      FLLB( 2,LBAN)=0.
      FLLB( 3,LBAN)=.5
      FLLB( 4,LBAN)=.5
      FLLB( 5,LBAN)=0.
      FLLB( 6,LBAN)=0.
      FLLB( 7,LBAN)=0.
      FLLB( 8,LBAN)=0.
      FLLB( 9,LBAN)=0.
      FLLB(10,LBAN)=0.
C
      RETURN
C
C If the label access name is not set, skip.
C
  109 IF (QBAN.LE.0.) GO TO 122
C
      LBAN=IFIX(QBAN)
      LBIM=IFIX(QBIM)
      LNAN=IFIX(QNAN)
      LNIM=IFIX(QNIM)
C
C If the specific item was the suppression flag for the current label
C and it was set negative, delete the label and/or its lines.
C
      CALL AGSCAN ('LABE/SUPP.',LOLS,NILS,IILS)
      IF (LOPA.NE.LOLS) GO TO 111
      IF (FLLB(2,LBAN).GE.0.) RETURN
C
      ITMP=IFIX(FLLB(2,LBAN))
      FLLB(2,LBAN)=0.
      FLLB(9,LBAN)=0.
      LNIN=IFIX(FLLB(10,LBAN))
      FLLB(10,LBAN)=0.
      QNAN=0.
      IF (ITMP.EQ.(-1)) GO TO 110
      CALL AGDLCH (IFIX(FLLB(1,LBAN)))
      FLLB(1,LBAN)=0.
      QBAN=0.
C
  110 IF (LNIN.LT.1.OR.LNIN.GT.LNIM) RETURN
      FLLN(1,LNIN)=SVAL(1)
      CALL AGDLCH (IFIX(FLLN(4,LNIN)))
      LNIN=IFIX(FLLN(6,LNIN))
      GO TO 110
C
C If the specific item was the line number, reset it to an appropriate
C index in the line list, providing initial values if appropriate.
C
  111 CALL AGSCAN ('LINE/NUMB.',LOLN,NILN,IILN)
      IF (LOPA.NE.LOLN) GO TO 118
C
      LNIL=0
      LNIN=IFIX(FLLB(10,LBAN))
C
  112 IF (LNIN.LT.1.OR.LNIN.GT.LNIM) GO TO 115
      IF (LNAN-IFIX(FLLN(1,LNIN))) 113,114,115
C
  113 LNIL=LNIN
      LNIN=IFIX(FLLN(6,LNIN))
      GO TO 112
C
  114 QNAN=FLOAT(LNIN)
      RETURN
C
  115      DO 116 I=1,LNIM
           LNIT=I
           IF (FLLN(1,I).EQ.SVAL(1)) GO TO 117
  116      CONTINUE
C
      GO TO 903
C
  117 CALL AGSTCH (' ',1,ITMP)
C
      FLLN(1,LNIT)=FLOAT(LNAN)
      FLLN(2,LNIT)=0.
      FLLN(3,LNIT)=.015
      FLLN(4,LNIT)=ITMP
      FLLN(5,LNIT)=1.
      FLLN(6,LNIT)=FLOAT(LNIN)
C
      LNAN=LNIT
      IF (LNIL.EQ.0) FLLB(10,LBAN)=FLOAT(LNAN)
      IF (LNIL.NE.0) FLLN( 6,LNIL)=FLOAT(LNAN)
C
      FLLB(9,LBAN)=FLLB(9,LBAN)+1.
C
      QNAN=FLOAT(LNAN)
      RETURN
C
C If the line access number is not set, skip.
C
  118 IF (LNAN.LE.0) GO TO 122
C
C If the specific item was the suppression flag for the current line and
C it was set negative, delete the line.
C
      CALL AGSCAN ('LINE/SUPP.',LOLS,NILS,IILS)
      IF (LOPA.NE.LOLS) GO TO 121
      IF (FLLN(2,LNAN).GE.0.) RETURN
C
      LNIL=0
      LNIN=IFIX(FLLB(10,LBAN))
C
  119 IF (LNIN.LT.1.OR.LNIN.GT.LNIM) RETURN
      IF (LNAN.EQ.LNIN) GO TO 120
      LNIL=LNIN
      LNIN=IFIX(FLLN(6,LNIN))
      GO TO 119
C
  120 IF (LNIL.EQ.0) FLLB(10,LBAN)=FLLN(6,LNAN)
      IF (LNIL.NE.0) FLLN( 6,LNIL)=FLLN(6,LNAN)
      FLLN(1,LNAN)=SVAL(1)
      CALL AGDLCH (IFIX(FLLN(4,LNAN)))
      QNAN=0.
      RETURN
C
C If the specific item was the text of a line, set the length of the
C line, as well.
C
  121 CALL AGSCAN ('LINE/TEXT.',LOLT,NILT,IILT)
      IF (LOPA.NE.LOLT) GO TO 123
      CALL AGGTCH (IFIX(FURA(1)),CHS1,LCS1)
      FLLN(5,LNAN)=FLOAT(LCS1)
      RETURN
C
C See if the user is trying to get at a line of a non-existent label.
C
  122 CALL AGSCAN ('LINE/NUMB.',LOLN,NILN,IILN)
      IF (LOPA.EQ.LOLN) GO TO 902
C
C If the specific item was the background parameter, set up the back-
C ground requested by the user.
C
  123 CALL AGSCAN ('BACK.',LOBG,NIBG,IIBG)
      IF (LOPA.NE.LOBG) GO TO 130
C
      QBAC=AMAX1(1.,AMIN1(4.,QBAC))
      IBAC=IFIX(QBAC)
      GO TO (124,125,126,127) , IBAC
C
C Perimeter background.
C
  124 QLBC=4.
      QRTC=4.
      WMJI=.015
      WMNI=.010
      GO TO 128
C
C Grid background.
C
  125 QLBC=4.
      QRTC=-1.
      WMJI=1.
      WMNI=1.
      GO TO 128
C
C Half-axis background.
C
  126 QLBC=4.
      QRTC=0.
      WMJI=.015
      WMNI=.010
      GO TO 128
C
C No background.
C
  127 QLBC=0.
      QRTC=0.
      WMJI=.015
      WMNI=.010
C
  128 QDAX(1)=QLBC
      QDAX(2)=QRTC
      QDAX(3)=QLBC
      QDAX(4)=QRTC
C
      DO 129 I=1,4
        WMJR(I)=WMJI
        WMNR(I)=WMNI
  129 CONTINUE
C
      QDLB=FLOAT(2-2*(IBAC/4))
      RETURN
C
C If the specific item was the get-limits-from-last-SET-call parameter,
C do what is necessary.
C
  130 CALL AGSCAN ('SET .',LOSE,NISE,IISE)
      IF (LOPA.NE.LOSE) GO TO 131
C
      QSET=SIGN(AMAX1(1.,AMIN1(4.,ABS(QSET))),QSET)
C
      XLGD=.15
      XRGD=.95
      YBGD=.15
      YTGD=.95
      SOGD=0.
C
      XMIN=SVAL(1)
      XMAX=SVAL(1)
      QLUX=AMIN1(QLUX,0.)
      QOVX=0.
      QCEX=-1.
      XLOW=SVAL(1)
      XHGH=SVAL(1)
C
      YMIN=SVAL(1)
      YMAX=SVAL(1)
      QLUY=AMIN1(QLUY,0.)
      QOVY=0.
      QCEY=-1.
      YLOW=SVAL(1)
      YHGH=SVAL(1)
C
      RETURN
C
C Return to caller.
C
  131 RETURN
C
C Error exits.
C
  901 CALL AGPPID (TPID)
      CALL SETER ('AGSETP - LABEL LIST OVERFLOW - SEE AUTOGRAPH SPECIALI
     +ST',15,2)
C
  902 CALL AGPPID (TPID)
      CALL SETER ('AGSETP - ATTEMPT TO DEFINE LINE OF NON-EXISTENT LABEL
     +',16,2)
C
  903 CALL AGPPID (TPID)
      CALL SETER ('AGSETP - LINE LIST OVERFLOW - SEE AUTOGRAPH SPECIALIS
     +T',17,2)
C
      END

      SUBROUTINE slSVD (M, N, MP, NP, A, W, V, WORK, JSTAT)
*+
*     - - - -
*      S V D
*     - - - -
*
*  Singular value decomposition  (double precision)
*
*  This routine expresses a given matrix A as the product of
*  three matrices U, W, V:
*
*     A = U x W x VT
*
*  Where:
*
*     A   is any M (rows) x N (columns) matrix, where M.GE.N
*     U   is an M x N column-orthogonal matrix
*     W   is an N x N diagonal matrix with W(I,I).GE.0
*     VT  is the transpose of an N x N orthogonal matrix
*
*     Note that M and N, above, are the LOGICAL dimensions of the
*     matrices and vectors concerned, which can be located in
*     arrays of larger PHYSICAL dimensions, given by MP and NP.
*
*  Given:
*     M,N    i         numbers of rows and columns in matrix A
*     MP,NP  i         physical dimensions of array containing matrix A
*     A      d(MP,NP)  array containing MxN matrix A
*
*  Returned:
*     A      d(MP,NP)  array containing MxN column-orthogonal matrix U
*     W      d(N)      NxN diagonal matrix W (diagonal elements only)
*     V      d(NP,NP)  array containing NxN orthogonal matrix V
*     WORK   d(N)      workspace
*     JSTAT  i         0 = OK, -1 = A wrong shape, >0 = index of W
*                      for which convergence failed.  See note 2, below.
*
*   Notes:
*
*   1)  V contains matrix V, not the transpose of matrix V.
*
*   2)  If the status JSTAT is greater than zero, this need not
*       necessarily be treated as a failure.  It means that, due to
*       chance properties of the matrix A, the QR transformation
*       phase of the routine did not fully converge in a predefined
*       number of iterations, something that very seldom occurs.
*       When this condition does arise, it is possible that the
*       elements of the diagonal matrix W have not been correctly
*       found.  However, in practice the results are likely to
*       be trustworthy.  Applications should report the condition
*       as a warning, but then proceed normally.
*
*  References:
*     The algorithm is an adaptation of the routine SVD in the EISPACK
*     library (Garbow et al 1977, EISPACK Guide Extension, Springer
*     Verlag), which is a FORTRAN 66 implementation of the Algol
*     routine SVD of Wilkinson & Reinsch 1971 (Handbook for Automatic
*     Computation, vol 2, ed Bauer et al, Springer Verlag).  These
*     references give full details of the algorithm used here.  A good
*     account of the use of SVD in least squares problems is given in
*     Numerical Recipes (Press et al 1986, Cambridge University Press),
*     which includes another variant of the EISPACK code.
*
*  Last revision:   8 September 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER M,N,MP,NP
      DOUBLE PRECISION A(MP,NP),W(N),V(NP,NP),WORK(N)
      INTEGER JSTAT

*  Maximum number of iterations in QR phase
      INTEGER ITMAX
      PARAMETER (ITMAX=30)

      INTEGER L,L1,I,K,J,K1,ITS,I1
      LOGICAL CANCEL
      DOUBLE PRECISION G,SCALE,AN,S,X,F,H,C,Y,Z



*  Variable initializations to avoid compiler warnings.
      L = 0
      L1 = 0

*  Check that the matrix is the right shape
      IF (M.LT.N) THEN

*     No:  error status
         JSTAT = -1

      ELSE

*     Yes:  preset the status to OK
         JSTAT = 0

*
*     Householder reduction to bidiagonal form
*     ----------------------------------------

         G = 0D0
         SCALE = 0D0
         AN = 0D0
         DO I=1,N
            L = I+1
            WORK(I) = SCALE*G
            G = 0D0
            S = 0D0
            SCALE = 0D0
            IF (I.LE.M) THEN
               DO K=I,M
                  SCALE = SCALE+ABS(A(K,I))
               END DO
               IF (SCALE.NE.0D0) THEN
                  DO K=I,M
                     X = A(K,I)/SCALE
                     A(K,I) = X
                     S = S+X*X
                  END DO
                  F = A(I,I)
                  G = -SIGN(SQRT(S),F)
                  H = F*G-S
                  A(I,I) = F-G
                  IF (I.NE.N) THEN
                     DO J=L,N
                        S = 0D0
                        DO K=I,M
                           S = S+A(K,I)*A(K,J)
                        END DO
                        F = S/H
                        DO K=I,M
                           A(K,J) = A(K,J)+F*A(K,I)
                        END DO
                     END DO
                  END IF
                  DO K=I,M
                     A(K,I) = SCALE*A(K,I)
                  END DO
               END IF
            END IF
            W(I) = SCALE*G
            G = 0D0
            S = 0D0
            SCALE = 0D0
            IF (I.LE.M .AND. I.NE.N) THEN
               DO K=L,N
                  SCALE = SCALE+ABS(A(I,K))
               END DO
               IF (SCALE.NE.0D0) THEN
                  DO K=L,N
                     X = A(I,K)/SCALE
                     A(I,K) = X
                     S = S+X*X
                  END DO
                  F = A(I,L)
                  G = -SIGN(SQRT(S),F)
                  H = F*G-S
                  A(I,L) = F-G
                  DO K=L,N
                     WORK(K) = A(I,K)/H
                  END DO
                  IF (I.NE.M) THEN
                     DO J=L,M
                        S = 0D0
                        DO K=L,N
                           S = S+A(J,K)*A(I,K)
                        END DO
                        DO K=L,N
                           A(J,K) = A(J,K)+S*WORK(K)
                        END DO
                     END DO
                  END IF
                  DO K=L,N
                     A(I,K) = SCALE*A(I,K)
                  END DO
               END IF
            END IF

*        Overestimate of largest column norm for convergence test
            AN = MAX(AN,ABS(W(I))+ABS(WORK(I)))

         END DO

*
*     Accumulation of right-hand transformations
*     ------------------------------------------

         DO I=N,1,-1
            IF (I.NE.N) THEN
               IF (G.NE.0D0) THEN
                  DO J=L,N
                     V(J,I) = (A(I,J)/A(I,L))/G
                  END DO
                  DO J=L,N
                     S = 0D0
                     DO K=L,N
                        S = S+A(I,K)*V(K,J)
                     END DO
                     DO K=L,N
                        V(K,J) = V(K,J)+S*V(K,I)
                     END DO
                  END DO
               END IF
               DO J=L,N
                  V(I,J) = 0D0
                  V(J,I) = 0D0
               END DO
            END IF
            V(I,I) = 1D0
            G = WORK(I)
            L = I
         END DO

*
*     Accumulation of left-hand transformations
*     -----------------------------------------

         DO I=N,1,-1
            L = I+1
            G = W(I)
            IF (I.NE.N) THEN
               DO J=L,N
                  A(I,J) = 0D0
               END DO
            END IF
            IF (G.NE.0D0) THEN
               IF (I.NE.N) THEN
                  DO J=L,N
                     S = 0D0
                     DO K=L,M
                        S = S+A(K,I)*A(K,J)
                     END DO
                     F = (S/A(I,I))/G
                     DO K=I,M
                        A(K,J) = A(K,J)+F*A(K,I)
                     END DO
                  END DO
               END IF
               DO J=I,M
                  A(J,I) = A(J,I)/G
               END DO
            ELSE
               DO J=I,M
                  A(J,I) = 0D0
               END DO
            END IF
            A(I,I) = A(I,I)+1D0
         END DO

*
*     Diagonalisation of the bidiagonal form
*     --------------------------------------

         DO K=N,1,-1
            K1 = K-1

*        Iterate until converged
            ITS = 0
            DO WHILE (ITS.LT.ITMAX)
               ITS = ITS+1

*           Test for splitting into submatrices
               CANCEL = .TRUE.
               DO L=K,1,-1
                  L1 = L-1
                  IF (AN+ABS(WORK(L)).EQ.AN) THEN
                     CANCEL = .FALSE.
                     GO TO 10
                  END IF
*              (Following never attempted for L=1 because WORK(1) is zero)
                  IF (AN+ABS(W(L1)).EQ.AN) GO TO 10
               END DO
 10            CONTINUE

*           Cancellation of WORK(L) if L>1
               IF (CANCEL) THEN
                  C = 0D0
                  S = 1D0
                  DO I=L,K
                     F = S*WORK(I)
                     IF (AN+ABS(F).EQ.AN) GO TO 20
                     G = W(I)
                     H = SQRT(F*F+G*G)
                     W(I) = H
                     C = G/H
                     S = -F/H
                     DO J=1,M
                        Y = A(J,L1)
                        Z = A(J,I)
                        A(J,L1) = Y*C+Z*S
                        A(J,I) = -Y*S+Z*C
                     END DO
                  END DO
 20               CONTINUE
               END IF

*           Converged?
               Z = W(K)
               IF (L.EQ.K) THEN

*              Yes:  stop iterating
                  ITS = ITMAX

*              Ensure singular values non-negative
                  IF (Z.LT.0D0) THEN
                     W(K) = -Z
                     DO J=1,N
                        V(J,K) = -V(J,K)
                     END DO
                  END IF
               ELSE

*              Not converged yet:  set status if iteration limit reached
                  IF (ITS.EQ.ITMAX) JSTAT = K

*              Shift from bottom 2x2 minor
                  X = W(L)
                  Y = W(K1)
                  G = WORK(K1)
                  H = WORK(K)
                  F = ((Y-Z)*(Y+Z)+(G-H)*(G+H))/(2D0*H*Y)
                  IF (ABS(F).LE.1D15) THEN
                     G = SQRT(F*F+1D0)
                  ELSE
                     G = ABS(F)
                  END IF
                  F = ((X-Z)*(X+Z)+H*(Y/(F+SIGN(G,F))-H))/X

*              Next QR transformation
                  C = 1D0
                  S = 1D0
                  DO I1=L,K1
                     I = I1+1
                     G = WORK(I)
                     Y = W(I)
                     H = S*G
                     G = C*G
                     Z = SQRT(F*F+H*H)
                     WORK(I1) = Z
                     IF (Z.NE.0D0) THEN
                        C = F/Z
                        S = H/Z
                     ELSE
                        C = 1D0
                        S = 0D0
                     END IF
                     F = X*C+G*S
                     G = -X*S+G*C
                     H = Y*S
                     Y = Y*C
                     DO J=1,N
                        X = V(J,I1)
                        Z = V(J,I)
                        V(J,I1) = X*C+Z*S
                        V(J,I) = -X*S+Z*C
                     END DO
                     Z = SQRT(F*F+H*H)
                     W(I1) = Z
                     IF (Z.NE.0D0) THEN
                        C = F/Z
                        S = H/Z
                     END IF
                     F = C*G+S*Y
                     X = -S*G+C*Y
                     DO J=1,M
                        Y = A(J,I1)
                        Z = A(J,I)
                        A(J,I1) = Y*C+Z*S
                        A(J,I) = -Y*S+Z*C
                     END DO
                  END DO
                  WORK(L) = 0D0
                  WORK(K) = F
                  W(K) = X
               END IF
            END DO
         END DO
      END IF

      END

      SUBROUTINE TSTRML	(IERROR)
C
C LATEST REVISION	 JUNE 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 ROUTINE STRMLN.
C
C USAGE			 CALL TSTRML (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   =0 IF THERE IS A NORMAL EXIT	FROM THE
C			      ROUTINE STRMLN.
C			   =1 OTHERWISE
C
C I/O			 IF THERE IS A NORMAL EXIT FROM	THE ROUTINE
C			 STRMLN	THE MESSAGE
C			   STRMLN TEST SUCCESSFUL . . .	SEE PLOT TO
C			   VERIFY PERFORMANCE
C			 IS PRINTED.
C
C PRECISION		 SINGLE
C
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 ROUTINE TSTRML	CALLS ROUTINE STRMLN TO
C			 PRODUCE A PLOT	REPRESENTING THE  FLOW AND
C			 MAGNITUDE OF A	VECTOR FIELD.
C
C PORTABILITY		 FORTRAN77
C
C
C
      REAL	      U(21,25)	 ,V(21,25)   ,WRK(1050)
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE INTEGER COORDINATES RANGE	FROM 0.0 TO 1.0, THE VALUES TX AND TY
C DEFINE THE CENTER OF THE TITLE STRING.
C
      DATA TX/.5/,TY/.9765/
C
C     SET DIMENSIONS
C
      DATA NH,NV/21,25/
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 1
C
C SPECIFY HORIZONTAL AND VERTICAL VECTOR COMPONENTS U AND V ON
C THE RECTANGULAR GRID
C
      TPIMX = 2.*3.14/FLOAT(NH)
      TPJMX = 2.*3.14/FLOAT(NV)
      DO  20 J=1,NV
	 DO  10	I=1,NH
	 U(I,J)	= SIN(TPIMX*(FLOAT(I)-1.))
	 V(I,J)	= SIN(TPJMX*(FLOAT(J)-1.))
   10	 CONTINUE
   20 CONTINUE
C
C SELECT NORMALIZATION TRANSFORMATION 0
C
      CALL GSELNT (0)
C
C CALL WTSTR FOR STRMLN	PLOT TITLE
C
      CALL WTSTR (TX,TY,'DEMONSTRATION PLOT FOR ROUTINE STRMLN',2,
     1		  0,0)
C
C DEFINE NORMALIZATION TRANSFORMATION 1, AND SET UP LOG	SCALING
C
      CALL GSVP	( 1, 0.1, 0.9, 0.1, 0.9	)
      CALL GSWN	( 1, 1.0, 21., 1.0, 25.	)
      CALL SETUSV ( 'LS' , 1 )
C
C SELECT NORMALIZATION TRANSFORMATION 1
C
      CALL GSELNT (1)
C
C     DRAW PERIMETER
C
c     CALL PERIM(1,0,1,0)
C
C CALL STRMLN FOR VECTOR FIELD STREAMLINES PLOT
C
      CALL STRMLN (U,V,WRK,NH,NH,NV,0,IER)
C
c     CALL NEWFM
C
      IERROR = 0
c     WRITE (6,1001)
      RETURN
C
c1001 FORMAT ('	    STRMLN TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

      subroutine query (mesg)
      integer mesg (100)
      integer getarg
      integer arg1 (3), arg2 (1)
      if (.not.(getarg (1, arg1, 3) .ne. -1 .and. getarg (2, arg2, 1) .e
     *q. -1))goto 23000
      if (.not.(arg1 (1) .eq. 63 .and. arg1 (2) .eq. -2))goto 23002
      call error (mesg)
23002 continue
23000 continue
      return
      end

C SUBROUTINE MATINV.F 
C
C SOURCE								       
C   BEVINGTON, PAGES 302-303.
C
C PURPOSE
C   INVERT A SYMMETRIC MATRIX AND CALCULATE ITS DETERMINANT
C
C USAGE 
C   CALL MATINV (ARRAY, NORDER, DET)
C
C DESCRIPTION OF PARAMETERS
C   ARRAY  - INPUT MATRIX WHICH IS REPLACED BY ITS INVERSE
C   NORDER - DEGREE OF MATRIX (ORDER OF DETERMINANT)
C   DET    - DETERMINANT OF INPUT MATRIX
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE
C
C COMMENT
C   DIMENSION STATEMENT VALID FOR NORDER UP TO 10
C
	SUBROUTINE MATINV (ARRAY,NORDER,DET)
	DOUBLE PRECISION ARRAY,AMAX,SAVE
	DIMENSION ARRAY(10,10),IK(10),JK(10)
C
10	DET=1.
11	DO 100 K=1,NORDER
C
C FIND LARGEST ELEMENT ARRAY(I,J) IN REST OF MATRIX
C
	AMAX=0. 
21	DO 30 I=K,NORDER
	DO 30 J=K,NORDER
23	IF (DABS(AMAX)-DABS(ARRAY(I,J))) 24,24,30
24	AMAX=ARRAY(I,J) 
	IK(K)=I 
	JK(K)=J 
30	CONTINUE
C
C INTERCHANGE ROWS AND COLUMNS TO PUT AMAX IN ARRAY(K,K)
C
31	IF (AMAX) 41,32,41
32	DET=0.
	GOTO 140
41	I=IK(K) 
	IF (I-K) 21,51,43
43	DO 50 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=ARRAY(I,J)
50	ARRAY(I,J)=-SAVE
51	J=JK(K) 
	IF (J-K) 21,61,53
53	DO 60 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=ARRAY(I,J)
60	ARRAY(I,J)=-SAVE
C
C ACCUMULATE ELEMENTS OF INVERSE MATRIX 
C
61	DO 70 I=1,NORDER
	IF (I-K) 63,70,63
63	ARRAY(I,K)=-ARRAY(I,K)/AMAX
70	CONTINUE
71	DO 80 I=1,NORDER
	DO 80 J=1,NORDER
	IF (I-K) 74,80,74
74	IF (J-K) 75,80,75
75	ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)
80	CONTINUE
81	DO 90 J=1,NORDER
	IF (J-K) 83,90,83
83	ARRAY(K,J)=ARRAY(K,J)/AMAX
90	CONTINUE
	ARRAY(K,K)=1./AMAX
100	DET=DET*AMAX
C
C RESTORE ORDERING OF MATRIX
C
101	DO 130 L=1,NORDER
	K=NORDER-L+1
	J=IK(K) 
	IF (J-K) 111,111,105
105	DO 110 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=-ARRAY(I,J)
110	ARRAY(I,J)=SAVE 
111	I=JK(K) 
	IF (I-K) 130,130,113
113	DO 120 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=-ARRAY(I,J)
120	ARRAY(I,J)=SAVE 
130	CONTINUE
140	RETURN
	END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSETF (TPID,FUSR)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGSETF may be used to set the real (floating-point) value
C of any single AUTOGRAPH control parameter.
C
      FURA(1)=FUSR
      CALL AGSETP (TPID,FURA,1)
      RETURN
C
      END

C----------------------------------------------------------------------
        subroutine ftuscm(input,np,scaled,scale,zero,output)

C       unscale the array of complex numbers, prior to writing to the FITS file

C       input  d  array of complex numbers (pairs of real/imaginay numbers)
C       np     i  total number of values to scale (no. of pairs times 2)
C       scaled l  is the data scaled?
C       scale  d  scale factor
C       zero   d  offset
C       output d  output array

        integer np,i,j
        logical scaled
        double precision input(np),output(np)
        double precision scale,zero

        j=1
        if (scaled)then
            do 10 i=1,np/2
                output(j)=(input(j)-zero)/scale
                j=j+1
C               the imaginary part of the number is not offset!!
                output(j)=input(j)/scale
                j=j+1
10          continue
        else
            do 20 i=1,np
                output(i)=input(i)
20          continue
        end if
        end

      subroutine put42
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      mjxmax = max0(mx,mjxmax)
      mjymax = max0(my,mjymax)
      mjxmin = min0(mx,mjxmin)
      mjymin = min0(my,mjymin)
c
c test if increment instruction will work
c
      if (iabs(mx-mxold).gt.mxmax .or. iabs(my-myold).gt.mymax)
     1    go to 101
c
c construct increment instructions
c
      incx = (mx-mxold)/mxfac+160
      incy = (my-myold)/myfac+32+minst*128
c
c put instruction in buffer
c
      mbpair = ior(ishift(incx,8),incy)
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mxold = mx
      myold = my
      return
  101 continue
c
c mx is first half of the instruction as it stands
c
      mbpair = mx
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
c
c my needs only pen bit
c
      mbpair = my+ishift(minst,15)
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mxold = mx
      myold = my
      return
      end

      SUBROUTINE CONINT (NDP,XD,YD,ZD,NCP,IPC,PD)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C THIS SUBROUTINE ESTIMATES PARTIAL DERIVATIVES OF THE FIRST AND
C SECOND ORDER AT THE DATA POINTS.
C THE INPUT PARAMETERS ARE
C
C     NDP = NUMBER OF DATA POINTS,
C     XD,YD,ZD = ARRAYS CONTAINING THE X, Y, AND Z COORDI-
C                NATES OF DATA POINTS,
C     NCP = NUMBER OF DATA POINTS TO BE USED FOR ESTIMATION
C           OF PARTIAL DERIVATIVES AT EACH DATA POINT,
C     IPC = INTEGER ARRAY CONTAINING THE POINT NUMBERS OF
C           NCP DATA POINTS CLOSEST TO EACH OF THE NDP DATA
C           POINT.
C THE OUTPUT PARAMETER IS
C
C     PD  = ARRAY OF DIMENSION 5*NDP, WHERE THE ESTIMATED
C
C           ZX, ZY, ZXX, ZXY, AND ZYY VALUES AT THE DATA
C           POINTS ARE TO BE STORED.
C DECLARATION STATEMENTS
C
C
      DIMENSION       XD(NDP)    ,YD(NDP)    ,ZD(NDP)    ,IPC(1)     ,
     1                PD(1)
      REAL            NMX        ,NMY        ,NMZ        ,NMXX       ,
     1                NMXY        ,NMYX       ,NMYY
C
      SAVE
C
C PRELIMINARY PROCESSING
C
C
      NCPM1 = NCP-1
C
C ESTIMATION OF ZX AND ZY
C
C
      DO  130 IP0=1,NDP
         X0 = XD(IP0)
         Y0 = YD(IP0)
         Z0 = ZD(IP0)
         NMX = 0.0
         NMY = 0.0
         NMZ = 0.0
         JIPC0 = NCP*(IP0-1)
         DO  120 IC1=1,NCPM1
            JIPC = JIPC0+IC1
            IPI = IPC(JIPC)
            DX1 = XD(IPI)-X0
            DY1 = YD(IPI)-Y0
            DZ1 = ZD(IPI)-Z0
            IC2MN = IC1+1
            DO  110 IC2=IC2MN,NCP
               JIPC = JIPC0+IC2
               IPI = IPC(JIPC)
               DX2 = XD(IPI)-X0
               DY2 = YD(IPI)-Y0
               DNMZ = DX1*DY2-DY1*DX2
               IF (DNMZ .EQ. 0.0) GO TO  110
               DZ2 = ZD(IPI)-Z0
               DNMX = DY1*DZ2-DZ1*DY2
               DNMY = DZ1*DX2-DX1*DZ2
               IF (DNMZ .GE. 0.0) GO TO  100
               DNMX = -DNMX
               DNMY = -DNMY
               DNMZ = -DNMZ
  100          NMX = NMX+DNMX
               NMY = NMY+DNMY
               NMZ = NMZ+DNMZ
  110       CONTINUE
  120    CONTINUE
         JPD0 = 5*IP0
         PD(JPD0-4) = -NMX/NMZ
         PD(JPD0-3) = -NMY/NMZ
  130 CONTINUE
C
C ESTIMATION OF ZXX, ZXY, AND ZYY
C
C
      DO  170 IP0=1,NDP
         JPD0 = JPD0+5
         X0 = XD(IP0)
         JPD0 = 5*IP0
         Y0 = YD(IP0)
         ZX0 = PD(JPD0-4)
         ZY0 = PD(JPD0-3)
         NMXX = 0.0
         NMXY = 0.0
         NMYX = 0.0
         NMYY = 0.0
         NMZ = 0.0
         JIPC0 = NCP*(IP0-1)
         DO  160 IC1=1,NCPM1
            JIPC = JIPC0+IC1
            IPI = IPC(JIPC)
            DX1 = XD(IPI)-X0
            DY1 = YD(IPI)-Y0
            JPD = 5*IPI
            DZX1 = PD(JPD-4)-ZX0
            DZY1 = PD(JPD-3)-ZY0
            IC2MN = IC1+1
            DO  150 IC2=IC2MN,NCP
               JIPC = JIPC0+IC2
               IPI = IPC(JIPC)
               DX2 = XD(IPI)-X0
               DY2 = YD(IPI)-Y0
               DNMZ = DX1*DY2-DY1*DX2
               IF (DNMZ .EQ. 0.0) GO TO  150
               JPD = 5*IPI
               DZX2 = PD(JPD-4)-ZX0
               DZY2 = PD(JPD-3)-ZY0
               DNMXX = DY1*DZX2-DZX1*DY2
               DNMXY = DZX1*DX2-DX1*DZX2
               DNMYX = DY1*DZY2-DZY1*DY2
               DNMYY = DZY1*DX2-DX1*DZY2
               IF (DNMZ .GE. 0.0) GO TO  140
               DNMXX = -DNMXX
               DNMXY = -DNMXY
               DNMYX = -DNMYX
               DNMYY = -DNMYY
               DNMZ = -DNMZ
  140          NMXX = NMXX+DNMXX
               NMXY = NMXY+DNMXY
               NMYX = NMYX+DNMYX
               NMYY = NMYY+DNMYY
               NMZ = NMZ+DNMZ
  150       CONTINUE
  160    CONTINUE
         PD(JPD0-2) = -NMXX/NMZ
         PD(JPD0-1) = -(NMXY+NMYX)/(2.0*NMZ)
         PD(JPD0) = -NMYY/NMZ
  170 CONTINUE
      RETURN
      END

	subroutine intrp (itab, xtab, ytab, ntab, x, y, ierr)
c
c Interpolator using CODIM1 algorithm which is admittedly
c obscure  but works well.
c
c	itab - a label between 1 and 20 to identify the table and its
c              most recent search index
c	xtab - array of length ntab containing the x-values
c	ytab -                                     y-values
c	ntab - number of x,y pairs in the table
c	   x - independent for which a y-value is desired
c	   y - returned interpolated (or extrapolated) value
c	ierr - =0 for ok, -1 for extrapolation
c
	real xtab(ntab), ytab(ntab), x, y
	integer itab, ierr
	real t(4), u(4)
c	integer savind
c	data savind/-1/
c
c----- Only 1 pt in table
	if (ntab .eq. 1) then
		y = ytab(1)
		ierr = 0
		return
	endif
c
c-----
c Locate search index
	call srch (itab, x, xtab, ntab, index, ierr)
c	if (index .eq. savind) go to 2000
c	savind = index
c
c-----
c Set interpolator index flags
	i1 = 2
	i2 = 3
	iload = max0 (index-2, 1)
c
	if (ntab .gt. 2) then
		if (index.eq.   2) i2 = 4
c
		if (index.eq.ntab) i1 = 1
	endif
c
	if (index.gt.2 .and. index.lt.ntab) then
		i1 = 1
		i2 = 4
	endif
c-----
c Load interpolation arrays
	do 1000 i = i1, i2
		j = iload + (i-i1)
		t(i) = xtab (j)
		u(i) = ytab (j)
1000	continue
c
c-----
c Get interpolated value
2000	call codim1 (x, t, u, i1, i2, y)
	return
	end
c
c--------------------------------------------------------------
c
	subroutine srch (itab, x, xtab, ntab, index, ierr)
c
c Search table of x-values to bracket the desired interpolant, x
c
c The returned search index will be:
c	2 - if extrapolation below the table is required
c    ntab -                  above
c   index - points to value just above x in the table if bounded.
c
c The index is saved as a starting point for subsequent entries
c in an array indexed through 'itab' which serves to label the
c set of saved search indices. Itab may be between 1 and 20.
c
c	itab - The table identifier (1-20)
c	   x - The value for which an index is desired
c	xtab - The table containing the x-values (array of length ntab)
c	ntab - number of elements in the table
c      index - returned index into the table (points just above x)
c	ierr - 0 for ok, -1 for extrapolation
c
	integer insave(20), ntab, index, ind
	real xtab(ntab), x
c
c intialize insaved indices
	data insave/20*0/
c
c-----
c Determine direction of table, ascending or descending
	idir = sign (1.0, xtab(ntab) - xtab(1))
c
c-----
c Reset error flag
	ierr = 0
c
c-----
c Check for previous insaved index
	last = insave(itab)
	if (last .eq. 0 .or. last .gt. ntab) then
c
c-----
c no previous entry
		isrch = 1
c check for extrapolation
		if ((x-xtab(   1)) * idir .lt. 0.0) go to 2000
		if ((x-xtab(ntab)) * idir .gt. 0.0) go to 2100
	else
c
c-----
c previous entry left a valid index
		isrch = last
c
c check for still wihin bounds - difference from above should be opposite
c                                sign of difference from below
c
		if ((xtab(last)-x) * (xtab(last-1)-x) .lt. 0.0) then
			index = last
			return
		endif
	endif
c
c -----
c Begin searching - first determine direction
c
	if ((x - xtab(isrch)) * idir .gt. 0.0) then
c forward
		do 1100 i = isrch+1, ntab
			if ((x-xtab(i)) * idir .gt. 0.0) go to 1100
			go to 1500
1100		continue
c fall thru implies extrapolation required at high end
		go to 2100
	else
c
c-----
c negative direction search
		do 1200 i = isrch-1,1,-1
			if ((x-xtab(i)) * idir .lt. 0.0) go to 1200
			go to 1400
1200		continue
c fall through implies extrapolation at low end
		go to 2000
	endif
c
c-----
c point has been bounded
1400	index = i + 1
	go to 3000
1500	index = i
	go to 3000
c
c-----
c extrapolations
2000	index = 2
	ierr = -1
	go to 3000
2100	index = ntab
	ierr = -1
	go to 3000
c
c-----
c insave index
3000	insave(itab) = index
	return
c
c------
c Entry to reset saved index
	entry intrp0 (itab)
c
	insave(itab) = 0
	return
c
c-----
c Entry to return current index
	entry intrpi (itab, ind)
c
	ind = insave(itab)
	return
	end 
c
c-------------------------------------------------------------------
c
	subroutine codim1 (x, t, u, i1, i2, y)
c
c this subroutine performs an interposlation in a fashion
c not really understandable, but it works well.
c
c	x - input independent variable
c	t - array of 4 table independents surrounding x if possible
c	u - array of 4 table dependents corresponding to the t array
c
c  i1, i2 - indicators as follows:
c
c	    i1 = 1, i2 = 4  :  4 pts available in t and u arrays
c           i1 = 1, i2 = 3  :  3 pts available (x near right edge of table)
c	    i1 = 2, i2 = 4  :                  (x near left  edge of table)
c	    i1 = 2, i2 = 3  :  2 pts available
c           i1 = 3, i3 = 3  :  1 pt  available
c
c	y - output interpolated (or extrapolated) dependent value
c
	real t(4), u(4), x, y
	integer i1, i2
c
c variable xk affects the extrapolation procedure. a value of -1.0
c appears to be a reliable value.
c
	data xk/-1.0/
c
	v = x
c the following code is extracted from an original source
c
      a2=v-t(2)
      al=a2/(t(3)-t(2))
      s=al*u(3)+(1.-al)*u(2)
      if(i1.gt.1.and.i2.lt.4)goto1530
      a3=v-t(3)
      if(i1.gt.1)goto1185
1180  a1=v-t(1)
      c1=a2/(t(1)-t(2))*a3/(t(1)-t(3))
      c2=a1/(t(2)-t(1))*a3/(t(2)-t(3))
      c3=a1/(t(3)-t(1))*a2/(t(3)-t(2))
      p1=c1*u(1)+c2*u(2)+c3*u(3)
      if(i2.lt.4)goto1400
1185  a4=v-t(4)
      c4=a3/(t(2)-t(3))*a4/(t(2)-t(4))
      c5=a2/(t(3)-t(2))*a4/(t(3)-t(4))
      c6=a2/(t(4)-t(2))*a3/(t(4)-t(3))
      p2=c4*u(2)+c5*u(3)+c6*u(4)
      if(i1.eq.1)goto1500
1200  if(xk.lt.0.)goto1230
      xe=xk
      goto1260
1230  slope1=abs((u(4)-u(3))/(t(4)-t(3)))
      slope2=abs((u(3)-u(2))/(t(3)-t(2)))
      xe=1.0
      if(slope1+slope2.ne.0.)xe=1.-abs(slope1-slope2)/(slope1+slope2)
1260  p1=s+xe*(p2-s)
      goto1500
1400  if(xk.lt.0.)goto1430
      xe=xk
      goto1460
1430  slope1=abs((u(2)-u(1))/(t(2)-t(1)))
      slope2=abs((u(3)-u(2))/(t(3)-t(2)))
      xe=1.0
      if(slope1+slope2.ne.0.)xe=1.-abs(slope1-slope2)/(slope1+slope2)
1460  p2=s+xe*(p1-s)
1500  e1=abs(p1-s)
      e2=abs(p2-s)
      if(e1+e2.gt.0.)goto1560
1530  z=s
      goto1700
1560  bt=(e1*al)/(e1*al+(1.-al)*e2)
      z=bt*p2+(1.-bt)*p1
c
1700	y = z
	return
	end
c
c----------------------------------------------------------------------
c
	subroutine lintrp (itab, xtab, ytab, ntab, x, y, ierr)
c
c Linear interpolator with last index save
c
c Arguments are identical to INTRP, and uses the same index search
c scheme so that values for ITAB should not clash with calls
c to INTRP and LINTRP.
c
	real xtab(ntab), ytab(ntab), x , y
	integer itab, ierr
c
c----- Only 1 pt in table
	if (ntab .eq. 1) then
		y = ytab (1)
		ierr = 0
		return
	endif
c
c-----locate search index
	call srch (itab, x, xtab, ntab, index, ierr)
c
c----- index points just above x
	y = ytab(index-1) + (x - xtab(index-1)) * 
     1   (ytab(index) - ytab(index-1)) / (xtab(index) - xtab(index-1))
c
	return
	end

include	defs

# strim --- trim trailing blanks and tabs from a string

   integer function strim (str)
   character str (ARB)

   integer lnb, i

   lnb = 0
   for (i = 1; str (i) != EOS; i = i + 1)
      if (str (i) != BLANK & str (i) != TAB)
	 lnb = i

   str (lnb + 1) = EOS
   return (lnb)

   end

include	defs

# mktabl --- make a new (empty) symbol table

   pointer function mktabl (nodsiz)
   integer nodsiz

   DS_COMMON

   pointer st
   pointer dsget

   integer i

   st = dsget (ST_HTABSIZE + 1)     # +1 for record of nodsiz
   Mem (st) = nodsiz
   mktabl = st
   do i = 1, ST_HTABSIZE; {
      st = st + 1
      Mem (st) = LAMBDA 	    # null link
      }

   return
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C +NOAO - this subroutine is a no-op in IRAF.
C ---------------------------------------------------------------------
C
      SUBROUTINE AGRSTR (IFNO)
C
C This subroutine is called to restore the current state of AUTOGRAPH by
C reading all of its important variables from a record on the file which
C is associated with the unit number IFNO.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
C
      COMMON /AGCHR2/ CHRA(2000)
C
      CHARACTER*1 CHRA
C
C Read the record.
C
C     READ (IFNO,ERR=901,END=902)
C    1 BASD,BASE,DBOX,DNLA,FLLB,FLLN,FUNS,HCWP,PING,PINU,QBAC,QBAN,QBIM,
C    2 QBTD,QBTP,QCDP,QCEX,QCEY,QCIE,QCIM,QDAX,QDLB,QDSH,QFRA,QIXY,QJDP,
C    3 QLED,QLEX,QLFD,QLFL,QLLN,QLOF,QLOS,QLTD,QLTP,QLUA,QLUX,QLUY,QMJD,
C    4 QMND,QMNT,QNAN,QNDP,QNIM,QODP,QOVX,QOVY,QROW,QSET,QSPA,QWND,RBOX,
C    5 RFNL,SBOX,SCWP,SOGD,SVAL,TCLN,UBGA,UNDA,WCLE,WCLM,WCWP,WMJL,WMJR,
C    6 WMNL,WMNR,WNLB,WNLE,WNLL,WNLR,WOCD,WODQ,XBGA,XHGH,XLCW,XLGD,XLGF,
C    7 XLGW,XLOW,XLUW,XMAX,XMIN,XNDA,XRCW,XRGD,XRGF,XRGW,XRUW,YBCW,YBGA,
C    8 YBGD,YBGF,YBGW,YBUW,YHGH,YLOW,YMAX,YMIN,YNDA,YTCW,YTGD,YTGF,YTGW,
C    9 YTUW,
C    + INIF,ISLD,MDLA,MWCD,MWCE,MWCL,MWCM,MWDQ,SMRL,
C    1 INCA,INCH,LNCA,LNIC,
C    2 CHRA
C
C Done.
C
      RETURN
C
C Error exits.
C
C 901 CALL SETER ('AGRSTR - ERROR ON READ',8,2)
C
C 902 CALL SETER ('AGRSTR - END-OF-FILE ON READ',9,2)
C
C -NOAO
      END

      subroutine l2knts ( break, l, k, t, n )
c  from  * a practical guide to splines *  by c. de boor
c  to be called in main program  l 2 m a i n .
converts the breakpoint sequence  b r e a k   into a corresponding knot
c  sequence  t	to allow the repr. of a pp function of order  k  with
c  k-2 continuous derivatives as a spline of order  k  with knot
c  sequence  t . this means that
c  t(1), ..., t(n+k) =	break(1) k times, then break(i), i=2,...,l, each
c			once, then break(l+1) k times .
c  therefore,  n = k-1 + l.
c
c******  i n p u t  ******
c  k	 the order
c  l	 the number of polynomial pieces
c  break(1), ...,break(l+1)  the breakpoint sequence
c
c******  o u t p u t  ******
c  t(1),...,t(n+k)   the knot sequence
c  n	 the dimension of the corresp. spline space of order  k .
c
      integer k,l,n,   i,km1
      real break(1),t(1)
c     dimension break(l+1),t(n+k)
      km1 = k - 1
      do 5 i=1,km1
    5	 t(i) = break(1)
      do 6 i=1,l
    6	 t(km1+i) = break(i)
      n = km1 + l
      do 7 i=1,k
    7	 t(n+i) = break(l+1)
					return
      end

include	defs

# filset --- expand set at  array (i)  into  set (j),  stop at	delim

   subroutine filset (delim, array, i, set, j, maxset)
   integer i, j, maxset
   character array (ARB), delim, set (maxset)

   character esc

   integer junk
   external index
   integer addset, index

   string digits "0123456789"
   string lowalf "abcdefghijklmnopqrstuvwxyz"
   string upalf "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

   for ( ; array (i) != delim & array (i) != EOS; i = i + 1)
      if (array (i) == ESCAPE)
	 junk = addset (esc (array, i), set, j, maxset)
      else if (array (i) != DASH)
	 junk = addset (array (i), set, j, maxset)
      else if (j <= 1 | array (i + 1) == EOS)	# literal -
	 junk = addset (DASH, set, j, maxset)
      else if (index (digits, set (j - 1)) > 0)
	 call dodash (digits, array, i, set, j, maxset)
      else if (index (lowalf, set (j - 1)) > 0)
	 call dodash (lowalf, array, i, set, j, maxset)
      else if (index (upalf, set (j - 1)) > 0)
	 call dodash (upalf, array, i, set, j, maxset)
      else
	 junk = addset (DASH, set, j, maxset)
   return
   end

include	defs

# fcopy - copy file in to file out

   subroutine fcopy (in, out)
   filedes in, out

   character line (MAXLINE)

   integer getlin

   while (getlin (line, in) != EOF)
      call putlin (line, out)

   return
   end

C--------------------------------------------------------------------------
        subroutine ftdrow(iunit,frow,nrows,status)

C       delete NROWS rows from a table, beginning with row FROW

C       iunit   i  Fortran I/O unit number
C       frow    i  row number after which the new rows will be inserted.
C                  Specify  0 to add rows to the beginning of the table.
C       nrows   i  number of rows to add to the table (must be greater than 0)
C       status  i  returned error status (0=ok)

        integer iunit,frow,nrows,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,naxis1,naxis2,size,freesp,nblock,row
        character comm*8

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       test that the CHDU is an ASCII table or BINTABLE
        if (hdutyp(ibuff) .ne. 1 .and. hdutyp(ibuff) .ne. 2)then
                status=235
                call ftpmsg('Can only delete rows from TABLE or '//
     &          'BINTABLE extension (FTDROW)')
                return
        end if

C       get current size of the table
        call ftgkyj(iunit,'NAXIS1',naxis1,comm,status)
        call ftgkyj(iunit,'NAXIS2',naxis2,comm,status)

        if (nrows .lt. 0)then
                 status=306
                 call ftpmsg('Cannot delete negative number of ' //
     &           'rows in the table (FTDROW)')
                 return
        else if (frow+nrows-1 .gt. naxis2)then
                 status=307
                 call ftpmsg('Specified number of rows to delete '
     &           //'exceeds number of rows in table (FTDROW)')
                 return
        else if (nrows .eq. 0)then
                 return
        else if (frow .gt. naxis2)then
                status=307
                call ftpmsg('First row to delete is greater'//
     &            ' than the number of rows in the table (FTDROW)') 
                return
        else if (frow .le. 0)then
                status=307
                call ftpmsg('Delete starting row number is less '
     &          //'than 1 (FTDROW)')
                return
        end if
        
C       Calculate how many FITS blocks (2880 bytes) need to be deleted
        size=theap(ibuff)+scount(ibuff)
        freesp=((size+2879)/2880)*2880 - size + naxis1*nrows
        nblock=freesp/2880

C       shift the rows up
        row=frow+nrows
        call ftrwup(iunit,row,naxis2,nrows,status)

C       shift the heap up
        size=naxis1*nrows
        call fthpup(iunit,size,status)

        if (nblock .gt. 0)call ftdblk(iunit,nblock,1,status)

C       update the NAXIS2 keyword
        naxis2=naxis2-nrows
        call ftmkyj(iunit,'NAXIS2',naxis2,'&',status)
        end

C----------------------------------------------------------------------
        subroutine ftpcks(iunit,status)

C       Create or update the checksum keywords in the CHU.  These keywords
C       provide a checksum verification of the FITS HDU based on the ASCII
C       coded 1's complement checksum algorithm developed by Rob Seaman at NOAO.

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Sept, 1994

        integer iunit,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nf = 3000)
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld 
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        double precision sum,dsum,odsum
        integer ibuff,nrec,dd,mm,yy,dummy,i,tstat
        character datstr*8,string*16,comm*40,oldcks*16,datsum*20
        logical complm

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       generate current date string to put into the keyword comment
        call ftgsdt(dd,mm,yy,status)
        if (status .gt. 0)return

        datstr='  /  /  '
        write(datstr(1:2),1001)dd
        write(datstr(4:5),1001)mm
        write(datstr(7:8),1001)yy
1001    format(i2)

C       replace blank with leading 0 in each field if required
        if (datstr(1:1) .eq. ' ')datstr(1:1)='0'
        if (datstr(4:4) .eq. ' ')datstr(4:4)='0'
        if (datstr(7:7) .eq. ' ')datstr(7:7)='0'

C       get the checksum keyword, if it exists, otherwise initialize it
        tstat=status
        call ftgkys(iunit,'CHECKSUM',oldcks,comm,status)
        if (status .eq. 202)then
          status=tstat
          oldcks=' '
          comm='encoded HDU checksum updated on '//datstr
          call ftpkys(iunit,'CHECKSUM','0000000000000000',comm,status)
        end if

C       get the DATASUM keyword and convert it to a double precision value
C       if it exists, otherwise initialize it
        tstat=status
        call ftgkys(iunit,'DATASUM',datsum,comm,status)
        if (status .eq. 202)then
          status=tstat
          odsum=0.
C         set the CHECKSUM keyword as undefined
          oldcks=' '
          comm='data unit checksum updated on '//datstr
          call ftpkys(iunit,'DATASUM','         0',comm,status)
        else
C         decode the datasum into a double precision variable
          do 10 i=1,20
            if (datsum(i:i) .ne. ' ')then
                call ftc2dd(datsum(i:20),odsum,status)
                if (status .eq. 409)then
C                   couldn't read the keyword; assume it is out of date
                    status=tstat
                    odsum=-1.
                end if
                go to 15
            end if
10        continue
          odsum=0.
        end if

C       rewrite the header END card, and following blank fill
15      call ftwend(iunit,status)
        if (status .gt. 0)return
 
C       now re-read the required keywords to determine the structure
        call ftrhdu(iunit,dummy,status)

C       write the correct data fill values, if they are not already correct
        call ftpdfl(iunit,status)

C       calc. checksum of the data records; first, calc number of data records
        nrec=(hdstrt(ibuff,chdu(ibuff)+1)-dtstrt(ibuff))/2880
        dsum=0.

        if (nrec .gt. 0)then
C           move to the start of the data
            call ftmbyt(iunit,dtstrt(ibuff),.true.,status)

C           accumulate the 32-bit 1's complement checksum
            call ftcsum(iunit,nrec,dsum,status)
        end if

        if (dsum .ne. odsum)then
C               modify the DATASUM keyword with the correct value 
                comm='data unit checksum updated on '//datstr
C               write the datasum into an I10 integer string
                write(datsum,2000)dsum
2000            format(f11.0)
                call ftmkys(iunit,'DATASUM',datsum(1:10),comm,status)
C               set the CHECKSUM keyword as undefined
                oldcks=' '
        end if

C       if DATASUM was correct, check if CHECKSUM is still OK
        if (oldcks .ne. ' ')then

C           move to the start of the header
            call ftmbyt(iunit,hdstrt(ibuff,chdu(ibuff)),.true.,status)

C           accumulate the header checksum into the previous data checksum
            nrec= (dtstrt(ibuff)-hdstrt(ibuff,chdu(ibuff)))/2880
            sum=dsum
            call ftcsum(iunit,nrec,sum,status)

C           encode the COMPLEMENT of the checksum into a 16-character string
            complm=.true.
            call ftesum(sum,complm,string)

C           return if the checksum is correct
            if (string .eq. '0000000000000000')then
                return
            else if (oldcks .eq. '0000000000000000')then
C               update the CHECKSUM keyword value with the checksum string
                call ftmkys(iunit,'CHECKSUM',string,'&',status)
                return
            end if
        end if

C       Zero the checksum and compute the new value
        comm='encoded HDU checksum updated on '//datstr
        call ftmkys(iunit,'CHECKSUM','0000000000000000',comm,status)

C       move to the start of the header
        call ftmbyt(iunit,hdstrt(ibuff,chdu(ibuff)),.true.,status)

C       accumulate the header checksum into the previous data checksum
        nrec= (dtstrt(ibuff)-hdstrt(ibuff,chdu(ibuff)))/2880
        sum=dsum
        call ftcsum(iunit,nrec,sum,status)

C       encode the COMPLEMENT of the checksum into a 16-character string
        complm=.true.
        call ftesum(sum,complm,string)

C       update the CHECKSUM keyword value with the checksum string
        call ftmkys(iunit,'CHECKSUM',string,'&',status)
        end

      subroutine justfy (ichar,len,newlen)
      dimension       ichar(1)
      in = 0
      call ncgchr (1h ,1,1,iblank)
      do 102 i=1,len
         call ncgchr (ichar,len,i,jchar)
         if (in .ne. 0) go to 101
         if (jchar .eq. iblank) go to 102
  101    in = in+1
         call ncpchr (ichar,len,in,jchar)
  102 continue
      newlen = in
      return
      end

      SUBROUTINE CONOP3 (IOPT,ARRAY,ISIZE)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C     ARRAY-   REAL ARRAY OF DIMENSION ISIZE
C     ISIZE-   SIZE OF ARRAY
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        DIMENSION ARRAY(ISIZE)
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
C
        SAVE
C
C +NOAO - initialize block data before changing any values
        call conbdn
c -NOAO
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
            OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  CON CONTOUR LEVELS  CHECK VALUE OF SWITCH
C
      IF (TAG .EQ. 'CO') THEN
C
C  SWITCH = ON SET CONTOUR LEVELS
C
          IF (OPT .EQ. 'ON') THEN
              IF (CHILO .OR. CINC) GOTO  140
C
C  TEST IF NUMBER OF CONTOURS IS ACCEPTABLE
C
              IF (ISIZE .GT. 30)
     1    CALL SETER (' CONOP3-NUMBER OF CONTOUR LEVELS EXCEEDS 30',
     2                 1,1)
      DO  200 I=1,ISIZE
       CL(I) = ARRAY(I)
  200 CONTINUE
      CON = .TRUE.
      NCL = ISIZE
      RETURN
C
C  SWITCH = OFF CLEAR CONTOUR LEVEL ARRAY (PROGRAM SELECTS)
C
            ELSEIF (OPT .EQ. 'OF') THEN
              CON = .FALSE.
              RETURN
            ELSE
                  GOTO 120
          ENDIF
C
C  CONTOUR HI LO OPTION FOUND GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'CH') THEN
C
C  SWITCH ON SET HI AND FLO
C
            IF (OPT .EQ. 'ON') THEN
              IF (CON) GOTO  140
                  HI = ARRAY(1)
                  FLO = ARRAY(2)
                  CHILO = .TRUE.
                  RETURN
C
C  SWITCH OFF CLEAR FLAG
C
            ELSEIF (OPT .EQ. 'OF') THEN
                CHILO = .FALSE.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  CONTOUR INCREMENT OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'CI') THEN
C
C  SWITCH ON SET INCREMENT
C
          IF (OPT .EQ. 'ON') THEN
              IF (CON) GOTO  140
              CINC = .TRUE.
              FINC = ARRAY(1)
              RETURN
C
C  SWITCH OFF CLEAR FLAG
C
          ELSEIF (OPT .EQ. 'OF') THEN
              CINC = .FALSE.
              RETURN
        ELSE
                GOTO 120
          ENDIF
C
C  SCALE THE DATA PLOTTED ON THE CONTOURS AND MIN MAX POINTS
C
      ELSEIF (TAG .EQ. 'SD') THEN
C
C  SWTICH ON GET SCALE FACTOR
C
            IF (OPT .EQ. 'ON') THEN
                SCALE = ARRAY(1)
                RETURN
C
C  SWTICH OFF SET FOR NO SCALING
C
            ELSEIF (OPT .EQ. 'OF') THEN
                SCALE = 1.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET THE TENSION VALUE FOR SMOOTHING
C
      ELSEIF (TAG .EQ. 'TE') THEN
C
C  SWTICH ON SET TENSION FACTOR
C
            IF (OPT .EQ. 'ON') THEN
                TENSN = ARRAY(1)
                RETURN
C
C  SWTICH OFF SET TO DEFAULT TENSION
C
            ELSEIF (OPT .EQ. 'OF') THEN
                TENSN = TENS
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  DASH PATTERN BREAK POINT SWITCH
C
      ELSEIF (TAG .EQ. 'DB') THEN
C
C  SWITCH ON GET USERS BREAKPOINT
C
            IF (OPT .EQ. 'ON') THEN
                BPSIZ = ARRAY(1)
                RETURN
C
C  SWITCH OFF SET TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                BPSIZ = 0.
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SHIELD OPTION
C
        ELSEIF (TAG .EQ. 'SL') THEN
C
C  TURN SHIELDING ON AND SET THE SHIELD COORD POINTERS
C
            IF (OPT .EQ. 'ON') THEN
                  NISIZE = ISIZE/2
                  CALL CONSSD(ARRAY(1),ARRAY(NISIZE+1),NISIZE)
                  RETURN
C
C  DEACTIVATE SHIELDING
C
            ELSEIF (OPT .EQ. 'OF') THEN
                  ICOUNT = 0
                  SHIELD = .FALSE.
                  RETURN
            ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP3-UNDEFINED OPTION',1,1)
      RETURN
C
C  ILLEGAL USE OF CON WITH CIL OR CHL
C
  140 CALL SETER
     1('CONOP3-ILLEGAL USE OF CON OPTION WITH CIL OR CHL OPTION',
     2 1,1)
      RETURN
        END

      subroutine docant(name)
      integer name(100), prog(30)
      integer length
      integer getarg
      length = getarg(0, prog, 30)
      if (.not.(length .ne. -1))goto 23000
      call putlin(prog, 2)
      call putch(58, 2)
      call putch(32, 2)
23000 continue
      call cant(name)
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      INTEGER FUNCTION AGFPBN (FPDP)
C
C The value of AGFPBN(FPDP) is a binary dash pattern, obtained from the
C floating-point dash pattern FPDP.  On machines having a word length
C greater than 16 bits, AGFPBN(FPDP) = IFIX(FPDP).  On machines having
C a word length of 16 bits, this is not true.  For example, when FPDP =
C 65535. (2 to the 16th minus 1), the equivalent binary dash pattern
C does not have the value 65535, but the value -1 (assuming integers
C are represented in a ones' complement format).  So, the functions
C ISHIFT and IOR must be used to generate the dash pattern.
C
      TEMP=FPDP
      AGFPBN=0
C
      DO 101 I=1,16
        IF (AMOD(TEMP,2.).GE.1.) AGFPBN=IOR(AGFPBN,ISHIFT(1,I-1))
        TEMP=TEMP/2.
  101 CONTINUE
C
      RETURN
C
      END

C------------------------------------------------------------------------------
        subroutine ftxmsg(action,text)

C       get, put, or clear the error message stack 

        integer action
        character*(*) text

        integer nbuff,i
        parameter (nbuff=50)
        character*80 txbuff(nbuff)
        save txbuff
        data txbuff/nbuff * ' '/

        if (action .eq. -1)then

C           get error message from top of stack and shift the stack up one
            text=txbuff(1)
            do 10 i=1,nbuff-1
                txbuff(i) = txbuff(i+1)
 10         continue
            txbuff(nbuff)=' '

        else if (action .eq. 1)then

C           put error message onto stack.
            do 20 i=1,nbuff
                if (txbuff(i) .eq. ' ')then
                   txbuff(i)=text
                   return
                end if
20          continue
C           stack is full so discard oldest message
            do 25 i=1,nbuff-1
                txbuff(i) = txbuff(i+1)
25          continue
            txbuff(nbuff)=text

        else if (action .eq. 0)then

C           clear the error message stack
            do 30 i=1,nbuff
                txbuff(i) = ' '
30          continue

        end if
        end

      SUBROUTINE GRIDAL(MAJRX,MINRX,MAJRY,MINRY,IXLAB,IYLAB,IGPH,X,Y)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C LATEST REVISION        JULY, 1985
C
C PURPOSE                THIS IS A PACKAGE OF ROUTINES FOR DRAWING
C                        GRAPH PAPER, AXES, AND OTHER BACKGROUNDS.
C
C USAGE                  EACH USER ENTRY POINT IN THIS PACKAGE (GRID,
C                        GRIDL, PERIM, PERIML, HALFAX, LABMOD,
C                        TICK4, AND GRIDAL) WILL BE DESCRIBED
C                        SEPARATELY BELOW.  FIRST, HOWEVER, WE
C                        WILL DISCUSS HOW MAJOR AND MINOR DIVISIONS
C                        IN THE GRAPH PAPER ARE HANDLED BY ALL
C                        ENTRIES WHICH USE THEM.
C
C                        GRIDAL, GRID, GRIDL, PERIM, PERIML, AND
C                        HALFAX HAVE ARGUMENTS  MAJRX,MINRX,MAJRY,
C                        MINRY WHICH CONTROL THE NUMBER OF MAJOR AND
C                        MINOR DIVISIONS IN THE GRAPH PAPER OR
C                        PERIMETERS.  THE NUMBER OF DIVISIONS REFERS
C                        TO THE HOLES BETWEEN LINES RATHER THAN THE
C                        LINES THEMSELVES.  THIS MEANS THAT THERE
C                        IS ALWAYS ONE MORE MAJOR DIVISION LINE THAN
C                        THE NUMBER OF MAJOR DIVISIONS.  SIMILARLY,
C                        THERE IS ONE LESS MINOR DIVISION LINE THAN
C                        MINOR DIVISIONS (PER MAJOR DIVISION.)
C
C                        MAJRX,MAJRY,MINRX,MINRY HAVE DIFFERENT
C                        MEANINGS DEPENDING UPON WHETHER LOG
C                        SCALING IS IN EFFECT (SET VIA SETUSV OR
C                        SET IN THE SPPS PACKAGE.)
C
C                        FOR LINEAR SCALING,
C                        MAJRX AND MAJRY SPECIFY THE NUMBER OF MAJOR
C                        DIVISIONS ALONG THE X-AXIS OR Y-AXIS
C                        RESPECTIVELY, AND MINRX AND MINRY SPECIFY
C                        THE NUMBER OF MINOR DIVISIONS PER MAJOR
C                        DIVISION.
C
C                        FOR LOG SCALING ALONG THE X-AXIS
C                        EACH MAJOR DIVISION OCCURS AT A FACTOR OF
C                        10**MAJRX TIMES THE PREVIOUS DIVISION.
C                        FOR EXAMPLE, IF THE MINIMUM X-AXIS VALUE IS
C                        3., AND THE MAXIMUM X-AXIS VALUE IS 3000.,
C                        AND MAJRX IS 1, THEN MAJOR DIVISIONS WILL
C                        OCCUR AT 3., 30., 300., AND 3000.  SIMILARLY
C                        FOR MAJRY.   IF LOG SCALING IS IN EFFECT ON
C                        THE X-AXIS AND MINRX.LE.10, THEN THERE ARE
C                        NINE MINOR DIVISIONS BETWEEN EACH MAJOR
C                        DIVISION.  FOR EXAMPLE, BETWEEN 3. AND 30.
C                        THERE WOULD BE A MINOR DIVISION AT 6., 9.,
C                        12.,...,27.  IF LOG SCALING IS IN EFFECT ON
C                        THE X-AXIS AND MINRX.GT.10, THEN THERE WILL
C                        BE NO MINOR SUBDIVISIONS.  MINRY IS TREATED
C                        IN THE SAME MANNER AS MINRX.
C
C                        IF DIFFERENT COLORS (OR INTENSITIES) ARE TO
C                        BE USED FOR NORMAL INTENSITY, LOW INTENSITY,
C                        OR TEXT COLOR, THEN THE VALUES IN COMMON
C                        BLOCK  GRIINT  SHOULD BE CHANGED AS FOLLOWS:
C
C                          IGRIMJ      COLOR INDEX FOR NORMAL (MAJOR)
C                                      INTENSITY LINES.
C                          IGRIMN      COLOR INDEX FOR LOW INTENSITY
C                                      LINES.
C                          IGRITX      COLOR INDEX FOR TEXT (LABELS.)
C
C WE NOW DESCRIBE EACH ENTRY IN THIS PACKAGE.
C
C-----------------------------------------------------------------------
C SUBROUTINE GRID
C-----------------------------------------------------------------------
C
C PURPOSE       TO DRAW GRAPH PAPER.
C
C USAGE         CALL GRID (MAJRX,MINRX,MAJRY,MINRY)
C
C DESCRIPTION   THIS SUBROUTINE DRAWS GRAPH LINES IN THE PORTION
C               OF THE PLOTTER SPECIFIED BY THE CURRENT VIEWPORT
C               SETTING WITH THE NUMBER OF MAJOR AND MINOR
C               DIVISIONS AS SPECIFIED BY THE ARGUMENTS.
C
C-----------------------------------------------------------------------
C SUBROUTINE GRIDAL
C-----------------------------------------------------------------------
C
C PURPOSE       A GENERAL ENTRY POINT FOR ALL BACKGROUND ROUTINES
C               WITH THE OPTION OF LINE LABELLING ON EACH AXIS.
C
C USAGE         CALL GRIDAL (MAJRX,MINRX,MAJRY,MINRY,IXLAB,IYLAB,
C                            IGPH,X,Y)
C
C ARGUMENTS     MAJRX,MINRX,MAJRY,MINRY
C                 MAJOR AND MINOR AXIS DIVISIONS AS DESCRIBED IN THE
C                 USAGE SECTION OF THE PACKAGE DOCUMENTATION ABOVE.
C
C               IXLAB,IYLAB (INTEGERS)
C                 FLAGS FOR AXIS LABELS:
C
C                   IXLAB = -1  NO X-AXIS DRAWN
C                               NO X-AXIS LABELS
C
C                         =  0  X-AXIS DRAWN
C                               NO X-AXIS LABELS
C
C                         =  1  X-AXIS DRAWN
C                               X-AXIS LABELS
C
C                   IYLAB = -1  NO Y-AXIS DRAWN
C                               NO Y-AXIS LABELS
C
C                         =  0  Y-AXIS DRAWN
C                               NO Y-AXIS LABELS
C
C                         =  1  Y-AXIS DRAWN
C                               Y-AXIS LABELS
C
C
C               IGPH
C                 FLAG FOR BACKGROUND TYPE:
C
C                    IGPH         X-AXIS BACKGROUND  Y-AXIS BACKGROUND
C                    ----         -----------------  -----------------
C                     0           GRID               GRID
C                     1           GRID               PERIM
C                     2           GRID               HALFAX
C                     4           PERIM              GRID
C                     5           PERIM              PERIM
C                     6           PERIM              HALFAX
C                     8           HALFAX             GRID
C                     9           HALFAX             PERIM
C                    10           HALFAX             HALFAX
C
C               X,Y
C                 WORLD COORDINATES OF THE INTERSECTION OF THE AXES
C                 IF  IGPH=10 .
C
C-----------------------------------------------------------------------
C SUBROUTINE GRIDL
C-----------------------------------------------------------------------
C
C PURPOSE       TO DRAW GRAPH PAPER.
C
C USAGE         CALL GRIDL (MAJRX,MINRX,MAJRY,MINRY)
C
C DESCRIPTION   THIS SUBROUTINE BEHAVES EXACTLY AS GRID, BUT EACH
C               MAJOR DIVISION IS LABELED WITH ITS NUMERICAL VALUE.
C
C-----------------------------------------------------------------------
C SUBROUTINE HALFAX
C-----------------------------------------------------------------------
C
C PURPOSE       TO DRAW ORTHOGONAL AXES.
C
C USAGE         CALL HALFAX (MAJRX,MINRX,MAJRY,MINRY,X,Y,IXLAB,IYLAB)
C
C DESCRIPTION   THIS SUBROUTINE DRAWS ORTHOGONAL AXES INTERSECTING
C               AT COORDINATE (X,Y) WITH OPTIONAL LABELING OPTIONS AS
C               SPECIFIED BY IXLAB AND IYLAB.
C
C ARGUMENTS     MAJRX,MINRX,MAJRY,MINRY
C                 MAJOR AND MINOR DIVISION SPECIFICATIONS AS PER THE
C                 DESCRIPTION IN THE PACKAGE USAGE SECTION ABOVE.
C
C               X,Y
C                 WORLD COORDINATES SPECIFYING THE INTERSECTION POINT
C                 OF THE X AND Y AXES.
C
C               IXLAB,IYLAB (INTEGERS)
C                 FLAGS FOR AXIS LABELS:
C
C                   IXLAB = -1  NO X-AXIS DRAWN
C                               NO X-AXIS LABELS
C
C                         =  0  X-AXIS DRAWN
C                               NO X-AXIS LABELS
C
C                         =  1  X-AXIS DRAWN
C                               X-AXIS LABELS
C
C                   IYLAB = -1  NO Y-AXIS DRAWN
C                               NO Y-AXIS LABELS
C
C                         =  0  Y-AXIS DRAWN
C                               NO Y-AXIS LABELS
C
C                         =  1  Y-AXIS DRAWN
C                               Y-AXIS LABELS
C
C-----------------------------------------------------------------------
C SUBROUTINE LABMOD
C-----------------------------------------------------------------------
C
C PURPOSE       TO ALLOW MORE COMPLETE CONTROL OVER THE APPEARANCE
C               OF THE LABELS ON THE BACKGROUND PLOTS.
C
C USAGE         CALL LABMOD (FMTX,FMTY,NUMX,NUMY,ISIZX,ISIZY,
C                            IXDEC,IYDEC,IXOR)
C
C DESCRIPTION   THIS SUBROUTINE PRESETS PARAMETERS FOR THE OTHER
C               BACKGROUND ROUTINES IN THIS PACKAGE.  LABMOD ITSELF
C               DOES NO PLOTTING AND IT MUST BE CALLED BEFORE THE
C               THE BACKGROUND ROUTINES FOR WHICH IT IS PRESETTING
C               PARAMETERS.
C
C ARGUMENTS     FMTX,FMTY  (TYPE CHARACTER)
C                 FORMAT SPECIFICATIONS FOR THE X-AXIS AND Y-AXIS
C                 NUMERICAL LABELS IN GRIDL, PERIML, GRIDAL, OR
C                 HALFAX.  THE SPECIFICATION MUST START WITH A LEFT
C                 PARENTHESIS AND END WITH A RIGHT PARENTHESIS AND
C                 SHOULD NOT USE MORE THAN 8 CHARACTERS.  ONLY
C                 FLOATING-POINT CONVERSIONS (F, E, AND G) SUCH AS
C                 FMTX='(F8.2)' AND  FMTY='(E10.0)' FOR EXAMPLE.
C
C               NUMX,NUMY (INTEGER)
C                 THE NUMBER OF CHARACTERS SPECIFIED BY  FMTX  AND
C                 FMTY.  FOR THE ABOVE EXAMPLES, THESE WOULD BE
C                 NUMX=8  AND  NUMY=10  (NOT 6 AND 7).
C
C               ISIZX,ISIZY
C                 CHARACTER SIZE CODES FOR THE LABELS.  THESE SIZE
C                 CODES ARE THE SAME AS THOSE FOR THE SPPS ENTRY
C                 PWRIT.
C
C               IXDEC
C                 THE DECREMENT IN PLOTTER ADDRESS UNITS FROM THE
C                 LEFTMOST PLOTTER COORDINATE (AS SPECIFIED BY THE
C                 CURRENT VIEWPORT) TO THE NEAREST X-ADDRESS OF THE
C                 LABEL SPECIFIED BY  FMTY, NUMY, AND ISIZY.  FOR
C                 EXAMPLE, IF THE MINIMUM X-COORDINATE OF THE CURRENT
C                 VIEWPORT IS .1,  MINX  IS 102 (.1*1024).  IF  IXDEC
C                 IS 60, THE LABEL WILL START AT 42 (102-60).  THE
C                 FOLLOWING CONVENTIONS ARE USED:
C
C                 O  IF  IXDEC=0, IT IS AUTOMATICALLY RESET TO PROPERLY
C                    POSITION THE  Y-AXIS  LABELS TO THE LEFT OF THE
C                    LEFT Y-AXIS,  IXDEC=20 .
C
C                 O  IF  IXDEC=1,  Y-AXIS LABELS WILL GO TO THE RIGHT
C                    OF THE GRAPH, IXDEC=-20 .
C
C                 WHEN EITHER  HALFAX  OR  GRIDAL  IS CALLED TO DRAW AN
C                 AXIS,  IXDEC  IS THE DISTANCE FROM THE AXIS RATHER
C                 THAN FROM THE MINIMUM VIEWPORT COORDINATE.
C
C               IYDEC
C                 THE DECREMENT IN PLOTTER ADDRESS UNITS FROM THE
C                 MINIMUM Y-AXIS COORDINATE AS SPECIFIED BY THE
C                 CURRENT VIEWPORT TO THE NEAREST Y-ADDRESS OF THE
C                 LABEL SPECIFIED BY  FMTX, NUMX, AND ISIZX.  FOR
C                 EXAMPLE, IF THE MINIMUM Y-COORDINATE OF THE
C                 CURRENT VIEWPORT IS .2,  MINY IS 205 (.2*1024).
C                 IF  IYDEC=30, THE LABEL WILL END AT  205-30=175.
C                 THE FOLLOWING CONVENTIONS ARE USED:
C
C                 O  IF  IYDEC=0, IT IS AUTOMATICALLY RESET TO
C                    PROPERLY POSITION X-AXIS LABELS ALONG THE
C                    BOTTOM,  IYDEC=20 .
C
C                 O  IF  IYDEC=1, X-AXIS LABELS WILL GO ALONG THE
C                    TOP OF THE GRAPH,  IYDEC=-20 .
C
C               IXOR (INTEGER)
C                 ORIENTATION OF THE X-AXIS LABELS.
C
C                   IXOR = 0    +X (HORIZONTAL)
C                        = 1    +Y (VERTICAL)
C
C                 IN NORMAL ORIENTATION, THE ACTUAL NUMBER OF
C                 NON-BLANK DIGITS IS CENTERED UNDER THE LINE
C                 OR TICK TO WHICH IT APPLIES.
C
C-----------------------------------------------------------------------
C SUBROUTINE PERIM
C-----------------------------------------------------------------------
C
C PURPOSE       TO DRAW A PERIMETER WITH TICK MARKS.
C
C USAGE         CALL PERIM (MAJRX,MINRX,MAJRY,MINRY)
C
C DESCRIPTION   THIS SUBROUTINE BEHAVES JUST AS GRID EXCEPT THAT
C               INTERIOR LINES ARE REPLACED WITH TICK MARKS ALONG
C               THE EDGES.  TICK MARKS AT MAJOR DIVISIONS ARE
C               SLIGHTLY LARGER THAN TICK MARKS AT MINOR DIVISIONS.
C
C-----------------------------------------------------------------------
C SUBROUTINE PERIML
C-----------------------------------------------------------------------
C
C PURPOSE       TO DRAW A PERIMETER WITH TICK MARKS AND LABELS.
C
C USAGE         CALL PERIML (MAJRX,MINRX,MAJRY,MINRY)
C
C DESCRIPTION   THIS SUBROUTINE BEHAVES JUST AS PERIM, BUT EACH
C               MAJOR DIVISION IS LABELED WITH ITS NUMERICAL VALUE.
C
C-----------------------------------------------------------------------
C SUBROUTINE TICK4
C-----------------------------------------------------------------------
C
C PURPOSE       TO ALLOW PROGRAM CONTROL OF TICK MARK LENGTH.
C
C USAGE         CALL TICK4 (LMAJX,LMINX,LMAJY,LMINY)
C
C DESCRIPTION   THIS SUBROUTINE ALLOWS PROGRAM CONTROL OF TICK
C               MARK LENGTH IN  PERIM, PERIML, GRIDAL, AND HALFAX.
C
C ARGUMENTS     LMAJX,LMAJY
C                 LENGTH IN PLOTTER ADDRESS UNITS OF MAJOR DIVISION
C                 TICK MARKS ON THE X-AXIS AND Y-AXIS RESPECTIVELY.
C                 THESE VALUES ARE INITIALLY SET TO 12 .
C
C               MINRX,MINRY
C                 LENGTH IN PLOTTER ADDRESS UNITS OF MINOR DIVISION
C                 TICK MARKS ON THE X-AXIS AND Y-AXIS RESPECTIVELY.
C                 THESE VALUES ARE INITIALLY SET TO 8 .
C
C-----------------------------------------------------------------------
C
C WE NOW RESUME THE PACKAGE DOCUMENTATION.
C
C ENTRY POINTS  GRID,GRIDAL,GRIDL,HALFAX,LABMOD,PERIM,PERIML,TICK4,
C               TICKS,CHSTR,EXPAND,GRIDT
C
C COMMON BLOCKS LAB,CLAB,TICK,GRIINT
C
C REQUIRED      THE ERPRT77 PACKAGE AND THE SPPS.
C ROUTINES
C
C I/O           PLOTS BACKGROUNDS
C
C PRECISION     SINGLE
C
C LANGUAGE      FORTRAN 77
C
C HISTORY       WRITTEN IN JUNE, 1984.  BASED ON THE NCAR SYSTEM
C               PLOT PACKAGE ENTRIES HAVING THE SAME NAMES.
C
        COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
        COMMON /CLAB/ XFMT, YFMT
        COMMON /TICK/ MAJX, MINX, MAJY, MINY
        COMMON /GRIINT/ IGRIMJ, IGRIMN, IGRITX
C
C INTERNAL VARIABLES:
C
C               CHUPX,CHUPY     CHARACTER UP VECTOR VALUES ON ENTRY
C
C               CURMAJ          IF LOGMIN=.TRUE., THEN THIS IS THE
C                               CURRENT MAJOR TICK/GRID POSITION
C
C               ICNT            NORMALIZATION TRANSFORMATION NUMBER IN
C                               EFFECT ON ENTRY TO GRIDAL
C
C               LASF(13)        ASPECT SOURCE FLAG TABLE AS USED BY GKS.
C
C               LGRID           .TRUE. IF GRIDS ARE TO BE DRAWN ON THE
C                               CURRENT AXIS (OPPOSED TO TICKS)
C
C               LOGMIN          .TRUE.  IF LOG SCALING IS IN EFFECT AND
C                               MINOR TICK MARKS OR GRIDS ARE DESIRED
C
C               LOGVAL          LINEAR OR LOG SCALING
C                               1 = X LINEAR, Y LINEAR
C                               2 = X LINEAR, Y LOG
C                               3 = X LOG, Y LINEAR
C                               4 = X LOG, Y LOG
C
C               MINCNT          NUMBER OF MINOR DIVISIONS PER MAJOR
C
C               NERR            COUNTS ERROR NUMBER
C
C               NEXTMAJ         IF LOGMIN=.TRUE., THEN THIS IS THE NEXT
C                               MAJOR TICK/GRID POSITION
C
C               NWIND(4)        WINDOW LIMITS IN WORLD COORDINATES
C                               AFTER EXPANSION
C
C               OCOLI           COLOR INDEX ON ENTRY TO GRIDAL
C
C               OLDALH,OLDALV   TEXT ALIGNMENT VALUES ON ENTRY
C                               (HORIZONTAL AND VERTICAL)
C
C               OLDCH           CHARACTER HEIGHT ON ENTRY TO GRIDAL
C
C               OPLASF          STORES VALUE OF POLYLINE COLOR ASF ON
C                               ENTRY TO GRIDAL
C
C               OTXASF          STORES VALUE OF TEXT COLOR ASF ON
C                               ENTRY TO GRIDAL
C
C               OTXCOL          TEXT COLOR INDEX ON ENTRY TO GRIDAL
C
C               OWIND(4)        WINDOW LIMITS IN WORLD COORDINATES
C                               ON ENTRY TO GRIDAL
C
C               PY(2)           2 Y-COORDINATES FOR LINE TO BE DRAWN
C                               VIA GKS ROUTINE GPL
C
C               PX(2)           2 X-COORDINATES FOR LINE TO BE DRAWN
C                               VIA GKS ROUTINE GPL
C
C               START           IF DRAWING TICKS/GRIDS ON X-AXIS:
C                                       Y-COORD OF ORIGIN OF EACH LINE;
C                               IF DRAWING TICKS/GRIDS ON Y-AXIS:
C                                       X-COORD OF ORIGIN OF EACH LINE
C
C               TICBIG          END OF MAJOR TICK LINE IN WORLD
C                               COORDINATES
C
C               TICEND          END OF MINOR TICK LINE IN WORLD
C                               COORDINATES
C
C               TICMAJ          LENGTH OF MAJOR TICKS IN WORLD
C                               COORDINATES
C
C               TICMIN          LENGTH OF MINOR TICKS IN WORLD
C                               COORDINATES
C
C               VIEW(4)         VIEWPORT LIMITS IN NDC PRIOR TO
C                               EXPANSION FOR LABELLING
C
C               WIND(4)         SAME AS IN OWIND(4)
C
C               XCUR            A TICK/GRID IS DRAWN AT THIS POSITION
C                               IF LOG SCALING IS IN EFFECT.
C
C               XDEC            LENGTH IN WORLD COORDINATES FROM
C                               X-AXIS TO LABEL
C
C               XI              ALOG10(X), IF LOG SCALING
C
C               XINT            INTERVAL BETWEEN MINOR X-AXIS
C                               TICKS/GRIDS IN WORLD COORDINATES
C
C               XINTM           INTERVAL BETWEEN MAJOR X-AXIS
C                               TICKS/GRIDS IN WORLD COORDINATES
C
C               XMIRRO          LOGICAL FLAGS FOR MIRROR-IMAGE
C
C               XNUM            TOTAL NUMBER OF X-AXIS TICKS/GRIDS
C                               WITH LINEAR SCALING
C
C               XPOS            IF LINEAR SCALING, KEEPS TRACK OF X-AXIS
C                               POSITION FOR CURRENT TICK/GRID
C
C               XRANGE          TOTAL RANGE IN X DIRECTION IN WORLD
C                               COORDINATES PRIOR TO EXPANSION FOR
C                               LABELLING.
C
C               XRNEW           RANGE IN X DIRECTION IN WORLD
C                               COORDINATES, AFTER EXPANSION
C
C               YCUR            A TICK/GRID IS DRAWN AT THIS POSITION
C                               IF LOG SCALING IS IN EFFECT.
C
C               YDEC            LENGTH IN WORLD COORDINATES FROM
C                               Y-AXIS TO LABEL
C
C               YI              ALOG10(Y), IF LOG SCALING
C
C               YINTM           INTERVAL BETWEEN MAJOR Y-AXIS
C                               TICKS/GRIDS IN WORLD COORDINATES
C
C               YMIRRO          PLOTTING.
C
C               YNUM            TOTAL NUMBER OF Y-AXIS TICKS/GRIDS
C                               WITH LINEAR SCALING
C
C               YPOS            IF LINEAR SCALING, KEEPS TRACK OF Y-AXIS
C                               POSITION FOR CURRENT TICK/GRID
C
C               YRANGE          TOTAL RANGE IN Y DIRECTION IN WORLD
C                               COORDINATES PRIOR TO EXPANSION FOR
C                               LABELLING.
C
C               YRNEW           RANGE IN Y DIRECTION IN WORLD
C                               COORDINATES, AFTER EXPANSION
C
C               XLAB,YLAB       IF LABELLING X-AXIS, Y-COORDINATE FOR
C                               FOR TEXT POSITION;
C                               IF LABELLING Y-AXIS, X-COORDINATE FOR
C                               TEXT POSITION.
C
C
C
      CHARACTER*8 XFMT,YFMT
      REAL WIND(4), VIEW(4), PX(2), PY(2), NWIND(4), OWIND(4)
      REAL MAJX, MINX, MAJY, MINY
      INTEGER TCOUNT, XTNUM, YTNUM, FIRST, LAST
      INTEGER OPLASF, OTXASF, LASF(13), OCOLI, OTEXCI, OLDALH ,OLDALV
      LOGICAL LGRID,LOGMIN
      LOGICAL XMIRRO,YMIRRO
      REAL MAJDIV, NEXTMA
      CHARACTER*15 LABEL
C
      DATA TICMIN,TICMAJ,XCUR,YCUR,EXCUR,EYCUR/0.,0.,0.,0.,0.,0./
C
C +NOAO - Blockdata rewritten as run time initialization.
C       EXTERNAL GRIDT
	call gridt
C -NOAO
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR.
C
      CALL Q8QST4('GRAPHX','GRIDAL','GRIDAL','VERSION 01')
      XRNEW = 0.
      YRNEW = 0.
C
C  INITIALIZE ERROR COUNT.
C
      NERR = 0
C
C  CHECK FOR BAD VALUES OF IGPH.
C
      IF (IGPH.LT.0.OR.IGPH.EQ.3.OR.IGPH.EQ.7.OR.IGPH.GT.10) THEN
          NERR = NERR + 1
          CALL SETER(' GRIDAL--INVALID IGPH VALUE',NERR,2)
      ENDIF
C
C  GET STANDARD ERROR MESSAGE UNIT
C
      IERUNT = I1MACH(4)
      XMIRRO = .FALSE.
      YMIRRO = .FALSE.
C
C  SET POLYLINE COLOR ASF TO INDIVIDAUL.
C
      CALL GQASF(IERR,LASF)
      OPLASF = LASF(3)
      LASF(3) = 1
      OTXASF = LASF(10)
      LASF(10) = 1
      CALL GSASF(LASF)
C
C  INQUIRE CURRENT POLYLINE COLOR INDEX.
C
      CALL GQPLCI(IERR,OCOLI)
C
C  SET POLYLINE COLOR TO THE VALUE SPECIFIED IN COMMON.
C
      CALL GSPLCI(IGRIMJ)
C
C  INQUIRE CURRENT NORMALIZATION TRANSFORMATION NUMBER.
C
      CALL GQCNTN(IERR,ICNT)
C
C  INQUIRE CURRENT WINDOW AND VIEWPORT LIMITS.
C
      CALL GQNT(ICNT,IERR,WIND,VIEW)
C
C  STORE WINDOW VALUES
C
      DO 10 I = 1,4
      OWIND(I) = WIND(I)
   10 CONTINUE
C
C  LOG OR LINEAR SCALING?
C
C           1 = X LINEAR, Y LINEAR
C           2 = X LINEAR, Y LOG
C           3 = X LOG, Y LINEAR
C           4 = X LOG, Y LOG
C
      CALL GETUSV('LS',LOGVAL)
C
C  ADJUST WINDOW TO ACCOUNT FOR LOG SCALING.
C
      IF (LOGVAL .EQ. 2) THEN
        WIND(3) = 10.**WIND(3)
        WIND(4) = 10.**WIND(4)
      ELSE IF (LOGVAL .EQ. 3) THEN
        WIND(1) = 10.**WIND(1)
        WIND(2) = 10.**WIND(2)
      ELSE IF (LOGVAL .EQ. 4) THEN
        WIND(1) = 10.**WIND(1)
        WIND(2) = 10.**WIND(2)
        WIND(3) = 10.**WIND(3)
        WIND(4) = 10.**WIND(4)
      ENDIF
C
C  DETERMINE IF MIRROR-IMAGE MAPPING IS REQUIRED.
C
      IF (WIND(1) .GT. WIND(2)) THEN
        XMIRRO = .TRUE.
      ENDIF
      IF (WIND(3) .GT. WIND(4)) THEN
        YMIRRO = .TRUE.
      ENDIF
C
C  IF IGPH=10, CHECK FOR X(Y) VALUES IN RANGE (IF NOT, CHANGE TO
C  DEFAULT.
C
      IF (IGPH .EQ. 10) THEN
        XI = X
        YI = Y
        IF (((XI .LT. WIND(1) .OR. XI .GT. WIND(2)) .AND. .NOT.
     1  XMIRRO) .OR. (XMIRRO.AND.(XI.GT.WIND(1).OR.XI.LT.WIND(2))))
     2  THEN
          NERR = NERR + 1
          CALL SETER(' GRIDAL--X VALUE OUT OF WINDOW RANGE',NERR,1)
C +NOAO - FTN writes and format statements deleted.  Call to SETER okay.
C
C         WRITE(IERUNT,1001)NERR
C1001     FORMAT(' ERROR',I3,' IN GRIDAL--X VALUE OUT OF WINDOW RANGE')
          CALL ERROF
          XI = WIND(1)
        ENDIF
        IF (((YI .LT. WIND(3) .OR. YI .GT. WIND(4)) .AND. .NOT.
     1  YMIRRO).OR.(YMIRRO.AND.(YI.GT.WIND(3).OR.YI.LT.WIND(4))))
     2  THEN
          NERR = NERR + 1
          CALL SETER(' GRIDAL--Y VALUE OUT OF WINDOW RANGE',NERR,1)
C         WRITE(IERUNT,1002)NERR
C1002     FORMAT(' ERROR',I3,' IN GRIDAL--Y VALUE OUT OF WINDOW RANGE')
C -NOAO
          CALL ERROF
          YI = WIND(3)
        ENDIF
      ENDIF
      MX = MAJRX
      MY = MAJRY
      IF (LOGVAL .EQ. 4 .OR. LOGVAL .EQ. 3) THEN
        IF (MX .LT. 1) MX = 1
        IF (WIND(1) .LE. 0.) THEN
          NERR = NERR + 1
          CALL SETER(' GRIDAL--NON-POSITIVE WINDOW BOUNDARY WITH LOG SCA
     1LING',NERR,2)
        ELSE
          WIND(1) = ALOG10(WIND(1))
        ENDIF
        IF (WIND(2) .LE. 0.) THEN
          NERR = NERR + 1
          CALL SETER(' GRIDAL--NON-POSITIVE WINDOW BOUNDARY WITH LOG SCA
     1LING',NERR,2)
        ELSE
          WIND(2) = ALOG10(WIND(2))
        ENDIF
        IF (IGPH .EQ. 10) THEN
          XI = ALOG10(XI)
        ENDIF
      ENDIF
C
      IF(LOGVAL .EQ. 4 .OR. LOGVAL .EQ. 2) THEN
        IF (MY .LT. 1) MY = 1
        IF (WIND(3) .LE. 0.) THEN
          NERR = NERR + 1
          CALL SETER(' GRIDAL--NON-POSITIVE WINDOW BOUNDARY WITH LOG SCA
     1LING',NERR,2)
        ELSE
          WIND(3) = ALOG10(WIND(3))
        ENDIF
        IF (WIND(4) .LE. 0.) THEN
          NERR = NERR + 1
          CALL SETER(' GRIDAL--NON-POSITIVE WINDOW BOUNDARY WITH LOG SCA
     1LING',NERR,2)
        ELSE
          WIND(4) = ALOG10(WIND(4))
        ENDIF
        IF (IGPH .EQ. 10) THEN
          YI = ALOG10(YI)
        ENDIF
      ENDIF
C
C  DEFINE NORMALIZATION TRANSFORMATION NUMBER 1.
C
      CALL GSWN(1,WIND(1),WIND(2),WIND(3),WIND(4))
      CALL GSVP(1,VIEW(1),VIEW(2),VIEW(3),VIEW(4))
      CALL GSELNT(1)
C
C  CALCULATE X AND Y WORLD COORDINATE RANGES.
C
      XRANGE = WIND(2) - WIND(1)
      YRANGE = WIND(4) - WIND(3)
C
C  IF LABELS ARE REQUESTED, INQUIRE AND SAVE TEXT ATTRIBUTES.
C
      IF (IXLAB .EQ. 1 .OR. IYLAB .EQ. 1) THEN
        CALL GQCHH(IERR,OLDCHH)
        CALL GQCHUP(IERR,CHUPX,CHUPY)
        CALL GQTXAL(IERR,OLDALH,OLDALV)
        CALL GQTXCI (IERR,OTEXCI)
        CALL GSTXCI (IGRITX)
C
C  EXPAND WINDOW AND VIEWPORT FOR LABELS AND CALCULATE NEW
C  X AND Y WORLD COORDINATE RANGES.
C
        CALL EXPAND(NWIND)
        XRNEW = NWIND(2) - NWIND(1)
        YRNEW = NWIND(4) - NWIND(3)
C
C  SET CHARACTER HEIGHT (1% OF Y RANGE.)
C
        CHARH = SIZX * YRNEW
        IF (YMIRRO) THEN
          CHARH = -CHARH
        ENDIF
        CALL GSCHH(CHARH)
      ENDIF
C
      IF (IGPH .EQ. 0) GOTO 50
C
C  CALCULATE TIC LENGTH.
C
C  IF NO LABELS AND TICK4 (OR TICKS) WERE NOT CALLED.
C
      IF (MAJX .EQ. 0.) THEN
        MAJX = .013
        MINX = .007
        TICMIN = MINX * YRANGE
        TICMAJ = MAJX * YRANGE
      ELSE
C
C  EXPAND WINDOW IF NOT ALREADY EXPANDED.
C  (IF LABMOD WAS NOT CALLED BUT TICK4(S) WAS.)
C
        IF (IXLAB.NE.1 .AND. IYLAB.NE.1) THEN
          CALL EXPAND (NWIND)
          XRNEW = NWIND(2) - NWIND(1)
          YRNEW = NWIND(4) - NWIND(3)
        ENDIF
        TICMIN = MINX * YRNEW
        TICMAJ = MAJX * YRNEW
      ENDIF
C
C  **** X-AXIS TICS/GRIDS AND LABELS ****
C
C  CALCULATE TIC/GRID INTERVALS ON X AXIS.
C
  50  IF (IXLAB .EQ. -1) GOTO 175
      MINCNT = MINRX
      IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ. 2) THEN
        LOGMIN = .FALSE.
        XINTM = XRANGE/MX
        XINT = XINTM
        IF (MINCNT .GT. 1) THEN
          XINT = XINT/MINCNT
        ENDIF
C
C  CALCULATE TOTAL NUMBER OF TICS/GRIDS ON AXIS.
C
        XTNUM = MX * MINCNT
        IF (MINCNT .EQ. 0) XTNUM = MX
      ELSE
        XTNUM = 50
        XCUR = 10.**OWIND(1)
        MAJDIV = 10 ** MX
        IF (MINCNT .LE. 10 .AND. MX .LE. 1) THEN
          LOGMIN = .TRUE.
          CURMAJ = XCUR
          NEXTMA = XCUR * MAJDIV
          XINT = (NEXTMA - CURMAJ) / 9.
          MINCNT = 9
        ELSE
          LOGMIN = .FALSE.
          MINCNT = 1
        ENDIF
      ENDIF
C
      LGRID = .FALSE.
      LOOP = 1
C
C  DETERMINE ORIGIN OF TICK/GRID LINES (Y COORDINATE.)
C
      IF (IGPH .NE. 10) THEN
        START = WIND(3)
      ELSE
        START = YI
      ENDIF
C
      XPOS = WIND(1)
      PY(1) = START
      TICEND = START + TICMIN
      TICBIG = START + TICMAJ
C
      PX(1) = XPOS
      PX(2) = PX(1)
C
C  DRAW LEFT-MOST TICK ON X-AXIS (IF IGPH = 10 AND
C  INTERSECTION OF AXES IS NOT AT BOTTOM LEFT OF WINDOW.)
C
      IF (IGPH .EQ. 10) THEN
        IF (XI .NE. WIND(1)) THEN
          PY(2) = TICBIG
          CALL GPL(2,PX,PY)
        ENDIF
C
C  DRAW X-AXIS FOR IGPH = 10
C
        PX(2) = WIND(2)
        PY(2) = PY(1)
        CALL GPL(2,PX,PY)
        PX(2) = PX(1)
      ELSE
C
C  DRAW Y-AXIS FOR ANY OTHER IGPH (FIRST TICK.)
C
        PY(2) = WIND(4)
        CALL GPL(2,PX,PY)
      ENDIF
C
C  TICKS OR GRIDS ?
C
      IF (IGPH .EQ. 0 .OR. IGPH .EQ. 1 .OR. IGPH .EQ.2) THEN
        PY(2) = WIND(4)
        LGRID = .TRUE.
      ELSE
        PY(2) = TICEND
      ENDIF
C
      IF (IXLAB .EQ. 1) THEN
C
C  IF VERTICAL X-AXIS LABEL ORIENTATION, THEN SET CHAR UP VECTOR
C  TO BE VERTICAL AND TEXT ALIGNMENT TO (RIGHT,HALF),
C  OTHERWISE TO (CENTER,TOP)
C
        IF (YMIRRO) THEN
          IF (IXORI .EQ. 1) THEN
            CALL GSCHUP(1.,0.)
            CALL GSTXAL(3,3)
          ELSE
            CALL GSCHUP(0.,-1.)
            CALL GSTXAL(2,1)
          ENDIF
        ELSE
          IF (IXORI .EQ. 1) THEN
            CALL GSCHUP(-1.,0.)
            CALL GSTXAL(3,3)
          ELSE
            CALL GSTXAL(2,1)
          ENDIF
        ENDIF
        IF (XDEC.NE.0. .AND. XDEC.NE.1.) THEN
          DEC = XDEC * YRNEW
        ELSE
          DEC = .02 * YRNEW
        ENDIF
        IF (XDEC .NE. 1.) THEN
          XLAB = START - DEC
        ELSE
          IF (IGPH .NE. 10) THEN
            XLAB = WIND(4)+DEC
          ELSE
            XLAB = YI+DEC
          ENDIF
C
C  IF LABELS ARE ON TOP OF THE X-AXIS, SET THE TEXT
C  ALIGNMENT TO (LEFT,HALF) IF THE X-AXIS LABELS ARE
C  VERTICAL, OTHERWISE TO (CENTER,BASE).
C
          IF (IXORI .EQ. 1) THEN
            CALL GSTXAL(1,3)
          ELSE
            CALL GSTXAL(2,4)
          ENDIF
        ENDIF
        IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ. 2) THEN
C +NOAO
C         WRITE(LABEL,XFMT)XPOS
          call encode (10, xfmt, label, xpos)
C -NOAO
        ELSE
C +NOAO
C         WRITE(LABEL,XFMT)XCUR
          call encode (10, yfmt, label, xcur)
C -NOAO
        ENDIF
        CALL CHSTR(LABEL,FIRST,LAST)
        CALL GTX (XPOS,XLAB,LABEL(FIRST:LAST))
      ENDIF
C
 80   TCOUNT = 1
C
      DO 100 I = 1,XTNUM
      IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ. 2) THEN
        XPOS = XPOS + XINT
      ELSE
        IF (.NOT. LOGMIN) THEN
          XCUR = XCUR * MAJDIV
        ELSE
          IF (TCOUNT .NE. MINCNT) THEN
            XCUR = XCUR + XINT
          ELSE
            XCUR = XCUR + XINT
            CURMAJ = NEXTMA
            NEXTMA = CURMAJ * MAJDIV
            XINT = (NEXTMA - CURMAJ) / 9.
          ENDIF
        ENDIF
        IF (XCUR .GT. 10.**OWIND(2)-.1*XINT) THEN
          XPOS = WIND(2)
        ELSE
          XPOS = ALOG10(XCUR)
        ENDIF
      ENDIF
C
      PX(1) = XPOS
      PX(2) = XPOS
C
C  IF IGPH = 0,1,2,4,5,8 OR 9 AND XPOS=RIGHT AXIS, THEN
C  DRAW AXIS, ELSE IF IGPH = 6 OR 10 DRAW TIC AND LABEL.
C
      IF (LOGVAL .EQ. 3 .OR. LOGVAL .EQ. 4) EXCUR = 10.**OWIND(2)
C
      IF ((((LOGVAL .EQ. 1.OR.LOGVAL.EQ.2) .AND. (I .EQ. XTNUM))
     1 .OR.((LOGVAL .EQ.4 .OR.LOGVAL .EQ.3).AND.XCUR.GE.EXCUR-.1*XINT))
     2 .AND.(IGPH.NE.6.AND.IGPH.NE.10)) THEN
        IF (LOOP .EQ. 1) THEN
          PY(2) = WIND(4)
          CALL GPL(2,PX,PY)
          IF (IXLAB .EQ. 1) THEN
            IF (LOGVAL.EQ.1 .OR. LOGVAL.EQ.2) THEN
C (NOAO)      WRITE(LABEL,XFMT) XPOS
              call encode (10, xfmt, label, xpos)
            ELSE
              IF (XCUR .GT. EXCUR+.1*XINT) THEN
                GOTO 101
              ELSE
C (NOAO)        WRITE(LABEL,XFMT) XCUR
                call encode (10, xfmt, label, xcur)
              ENDIF
            ENDIF
            CALL CHSTR(LABEL,FIRST,LAST)
            CALL GTX (XPOS,XLAB,LABEL(FIRST:LAST))
          ENDIF
        ENDIF
        GOTO 101
      ENDIF
      IF ((LOGVAL.EQ.4 .OR. LOGVAL.EQ.3) .AND. XCUR.GT.EXCUR+.1*XINT)
     1    GOTO 101
C
C  MINOR TIC/GRID ?
C
      IF (TCOUNT .NE. MINCNT .AND. MINCNT .NE. 0) THEN
        IF (LGRID) THEN
          CALL GSPLCI(IGRIMN)
        ENDIF
        CALL GPL(2,PX,PY)
        IF (LGRID) THEN
          CALL GSPLCI(IGRIMJ)
        ENDIF
        TCOUNT = TCOUNT + 1
C
C  MAJOR TIC/GRID
C
      ELSE
        IF (.NOT. LGRID) THEN
          PY(2) = TICBIG
        ENDIF
        CALL GPL(2,PX,PY)
C
C  LABEL.
C
        IF (IXLAB .EQ. 1 .AND. LOOP .EQ. 1) THEN
          IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ. 2) THEN
C (NOAO)    WRITE(LABEL,XFMT)XPOS
            call encode (10, xfmt, label, xpos)
          ELSE
C (NOAO)    WRITE(LABEL,XFMT)XCUR
            call encode (10, xfmt, label, xcur)
          ENDIF
          CALL CHSTR(LABEL,FIRST,LAST)
          CALL GTX (XPOS,XLAB,LABEL(FIRST:LAST))
        ENDIF
        TCOUNT = 1
        IF (.NOT. LGRID) THEN
          PY(2) = TICEND
        ENDIF
      ENDIF
      IF ((LOGVAL .EQ. 4 .OR. LOGVAL .EQ. 3) .AND.
     1     XCUR .GE. EXCUR-.1*XINT) GOTO 101
 100  CONTINUE
 101  CONTINUE
C
C  TOP X-AXIS TICKS ?
C
      IF (LOOP.EQ.1 .AND. (IGPH.EQ.4 .OR. IGPH.EQ.5 .OR. IGPH.EQ.6))
     1  THEN
        START = WIND(4)
        TICEND = START - TICMIN
        TICBIG = START - TICMAJ
        PY(1) = START
        PY(2) = TICEND
        XPOS = WIND(1)
        LOOP = 2
        IF (LOGVAL .EQ. 4 .OR. LOGVAL .EQ.3) THEN
          XCUR = 10.**OWIND(1)
          IF (LOGMIN) THEN
            CURMAJ = XCUR
            NEXTMA = XCUR * MAJDIV
            XINT = (NEXTMA - CURMAJ) / 9.
          ENDIF
        ENDIF
        GOTO 80
      ENDIF
C
C  **** Y-AXIS TICS/GRIDS AND LABELS ****
C
  175 IF (IYLAB .EQ. -1) GOTO 999
C
C  CALCULATE Y-AXIS TICS
C
      MINCNT = MINRY
      IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ. 3) THEN
        LOGMIN = .FALSE.
        YINTM = YRANGE/MY
        YINT = YINTM
        IF (MINCNT .GT. 1) THEN
          YINT = YINT/MINCNT
        ENDIF
        YTNUM = MY * MINCNT
        IF (MINCNT .EQ. 0) YTNUM = MY
      ELSE
        YTNUM = 50
        YCUR = 10.**OWIND(3)
        MAJDIV = 10 ** MY
        IF (MINCNT .LE. 10 .AND. MY .LE. 1) THEN
          LOGMIN = .TRUE.
          CURMAJ = YCUR
          NEXTMA = YCUR * MAJDIV
          YINT = (NEXTMA - CURMAJ) / 9.
          MINCNT = 9
        ELSE
          LOGMIN = .FALSE.
          MINCNT = 1
        ENDIF
      ENDIF
C
      LGRID = .FALSE.
      LOOP = 1
C
C  DETERMINE ORIGIN OF TICK/GRID LINES (X COORDINATE.)
C
      IF (IGPH .NE. 10) THEN
        START = WIND(1)
      ELSE
        START = XI
      ENDIF
C
      YPOS = WIND(3)
      PX(1) = START
C
C  DETERMINE Y-AXIS TICK LENGTHS.
C
      IF (MAJY .EQ. 0.) THEN
        MAJY = .013
        MINY = .007
      ENDIF
      IF (XRNEW .EQ. 0.) THEN
        TICMIN = MINY * XRANGE
        TICMAJ = MAJY * XRANGE
      ELSE
        TICMIN = MINY * XRNEW
        TICMAJ = MAJY * XRNEW
      ENDIF
      TICEND = START + TICMIN
      TICBIG = START + TICMAJ
C
      PY(1) = YPOS
      PY(2) = PY(1)
C
C  DRAW BOTTOM-MOST TICK ON Y-AXIS IF (IGPH = 10
C  AND INTERSECTION OF AXES IS NOT AT BOTTOM LEFT
C  OF WINDOW.)
C
      IF (IGPH .EQ. 10) THEN
        IF (YI .NE. WIND(3)) THEN
          PX(2) = TICBIG
          CALL GPL(2,PX,PY)
        ENDIF
C
C  DRAW Y-AXIS FOR IGPH = 10
C
        PY(2) = WIND(4)
        PX(2) = PX(1)
        CALL GPL(2,PX,PY)
        PY(2) = PY(1)
      ELSE
C
C  DRAW X-AXIS FOR ANY OTHER IGPH (FIRST TICK.)
C
        PX(2) = WIND(2)
        CALL GPL(2,PX,PY)
      ENDIF
C
C  GRIDS OR TICS ?
C
      IF ((IGPH .EQ. 0 .OR. IGPH .EQ. 4).OR. IGPH .EQ. 8) THEN
        PX(2) = WIND(2)
        LGRID = .TRUE.
      ELSE
        PX(2) = TICEND
      ENDIF
C
C  SET TEXT ATTRIBUTES IF Y-AXIS IS TO BE LABELLED.
C
      IF (IYLAB .EQ. 1) THEN
        IF (IXORI .EQ. 1) THEN
          IF (YMIRRO) THEN
            CALL GSCHUP(0.,-1.)
          ELSE
            CALL GSCHUP(0.,1.)
          ENDIF
        ENDIF
C
C  SET TEXT ALIGNMENT TO (RIGHT,HALF)
C
        CALL GSTXAL(3,3)
C
C  RECALCULATE CHARACTER HEIGHT IF Y-AXIS LABELS ARE OF DIFFERENT
C  SIZE FORM X-AXIS LABELS.
C
        CHARH = SIZY * YRNEW
        IF (YMIRRO) THEN
          CHARH = -CHARH
        ENDIF
        CALL GSCHH(CHARH)
        IF (YDEC .NE. 0. .AND. YDEC .NE. 1.) THEN
          DEC = YDEC * XRNEW
        ELSE
          DEC = .02 * XRNEW
        ENDIF
        IF (YDEC .NE. 1.) THEN
          YLAB = START - DEC
        ELSE
          IF (IGPH .NE. 10) THEN
            YLAB = WIND(2)+DEC
          ELSE
            YLAB = XI+DEC
          ENDIF
C
C  SET TEXT ALIGNMENT TO (LEFT,HALF) IF LABELLING ON RIGHT OF Y-AXIS.
C
          CALL GSTXAL(1,3)
        ENDIF
        IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ.3) THEN
C (NOAO)  WRITE(LABEL,YFMT)YPOS
          call encode (10, yfmt, label, ypos)
        ELSE
C (NOAO)  WRITE(LABEL,YFMT)YCUR
          call encode (10, yfmt, label, ycur)
        ENDIF
        CALL CHSTR(LABEL,FIRST,LAST)
        CALL GTX (YLAB,YPOS,LABEL(FIRST:LAST))
      ENDIF
C
 180  TCOUNT = 1
C
      DO 200 I = 1,YTNUM
      IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ. 3) THEN
        YPOS = YPOS + YINT
      ELSE
        IF (.NOT. LOGMIN) THEN
          YCUR = YCUR * MAJDIV
        ELSE
          IF (TCOUNT .NE. MINCNT) THEN
            YCUR = YCUR + YINT
          ELSE
            YCUR = YCUR + YINT
            CURMAJ = NEXTMA
            NEXTMA = CURMAJ * MAJDIV
            YINT = (NEXTMA - CURMAJ) / 9.
          ENDIF
        ENDIF
        IF (YCUR .GT. 10.**OWIND(4)-.1*YINT) THEN
          YPOS = WIND(4)
        ELSE
          YPOS = ALOG10(YCUR)
        ENDIF
      ENDIF
C
      PY(1) = YPOS
      PY(2) = YPOS
C
C IF IGPH = 0,1,2,4,5,6 OR 8 AND YPOS = TOP AXIS, THEN
C DRAW AXIS, ELSE IF IGPH = 9 OR 10 DRAW TIC.
C
      IF (LOGVAL .EQ. 3 .OR. LOGVAL .EQ. 4) EYCUR = 10.**OWIND(4)
C
      IF ((((LOGVAL .EQ. 1.OR.LOGVAL.EQ.3) .AND. (I .EQ. YTNUM))
     1 .OR.((LOGVAL .EQ.4 .OR.LOGVAL .EQ.2).AND.YCUR.GE.EYCUR-.1*YINT))
     2 .AND.(IGPH.NE.9.AND.IGPH.NE.10)) THEN
        IF (LOOP .EQ. 1) THEN
          PX(2) = WIND(2)
          CALL GPL(2,PX,PY)
          IF (IYLAB .EQ. 1) THEN
            IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ.3) THEN
C (NOAO)      WRITE(LABEL,YFMT)YPOS
              call encode (10, yfmt, label, ypos)
            ELSE
              IF (YCUR .GT. EYCUR+.1*YINT) THEN
                GOTO 201
              ELSE
C (NOAO)        WRITE(LABEL,YFMT)YCUR
                call encode (10, yfmt, label, ycur)
              ENDIF
            ENDIF
            CALL CHSTR(LABEL,FIRST,LAST)
            CALL GTX (YLAB,YPOS,LABEL(FIRST:LAST))
          ENDIF
        ENDIF
        GOTO 201
      ENDIF
      IF ((LOGVAL.EQ.4 .OR. LOGVAL.EQ.2) .AND. YCUR.GT.EYCUR+.1*YINT)
     1  GOTO 201
C
C  MINOR TIC/GRID ?
C
      IF (TCOUNT .NE. MINCNT .AND. MINCNT .NE. 0) THEN
        IF (LGRID) THEN
          CALL GSPLCI(IGRIMN)
        ENDIF
        CALL GPL(2,PX,PY)
        IF (LGRID) THEN
          CALL GSPLCI(IGRIMJ)
        ENDIF
        TCOUNT = TCOUNT + 1
C
C  MAJOR TIC/GRID.
C
      ELSE
        IF (.NOT. LGRID) THEN
          PX(2) = TICBIG
        ENDIF
        CALL GPL(2,PX,PY)
C
C  LABEL.
C
        IF (IYLAB .EQ. 1 .AND. LOOP .EQ.1) THEN
          IF (LOGVAL .EQ. 1 .OR. LOGVAL .EQ.3) THEN
C (NOAO)   WRITE(LABEL,YFMT)YPOS
           call encode (10, yfmt, label, ypos)
          ELSE
C (NOAO)    WRITE(LABEL,YFMT)YCUR
            call encode (10, yfmt, label, ycur)
          ENDIF
          CALL CHSTR(LABEL,FIRST,LAST)
          CALL GTX(YLAB,YPOS,LABEL(FIRST:LAST))
        ENDIF
        TCOUNT = 1
        IF (.NOT. LGRID) THEN
          PX(2) = TICEND
        ENDIF
      ENDIF
      IF ((LOGVAL .EQ. 4 .OR. LOGVAL .EQ. 2) .AND.
     -     YCUR .GE. EYCUR-.1*YINT)
     1   GOTO 201
  200 CONTINUE
  201 CONTINUE
C
C  RIGHT Y-AXIS TICKS ?
C
      IF (LOOP .EQ. 1 .AND.(IGPH.EQ.1 .OR. IGPH .EQ. 5 .OR.
     1  IGPH .EQ. 9)) THEN
        START = WIND(2)
        TICEND = START - TICMIN
        TICBIG = START - TICMAJ
        PX(1) = START
        PX(2) = TICEND
        YPOS = WIND(3)
        LOOP = 2
        IF (LOGVAL .EQ. 4 .OR. LOGVAL .EQ. 2) THEN
          YCUR = 10.**OWIND(3)
          IF (LOGMIN) THEN
            CURMAJ = YCUR
            NEXTMA = YCUR * MAJDIV
            YINT = (NEXTMA - CURMAJ) / 9.
          ENDIF
        ENDIF
        GOTO 180
      ENDIF
C
C  RESET NORMALIZATION TRANSFORMATION TO WHAT IT WAS UPON ENTRY.
C
      IF (ICNT .NE. 0) THEN
        CALL GSWN(ICNT,OWIND(1),OWIND(2),OWIND(3),OWIND(4))
        CALL GSVP(ICNT,VIEW(1),VIEW(2),VIEW(3),VIEW(4))
      ENDIF
      CALL GSELNT(ICNT)
C
C  IF LABELS, RESTORE TEXT ATTRIBUTES.
C
      IF (IXLAB .EQ. 1 .OR. IYLAB .EQ. 1) THEN
        CALL GSCHH(OLDCHH)
        CALL GSCHUP(CHUPX,CHUPY)
        CALL GSTXAL(OLDALH,OLDALV)
        CALL GSTXCI(OTEXCI)
      ENDIF
C
C  RESTORE ORIGINAL COLOR.
C
      CALL GSPLCI(OCOLI)
C
C  RESTORE POLYLINE COLOR ASF TO WHAT IS WAS ON ENTRY.
C
      LASF(10) = OTXASF
      LASF(3) = OPLASF
      CALL GSASF(LASF)
C
 999  RETURN
      END
      SUBROUTINE GRID(MAJRX,MINRX,MAJRY,MINRY)
C
      COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
      COMMON /CLAB/ XFMT, YFMT
      COMMON /TICK/ MAJX, MINX, MAJY, MINY
      COMMON /GRIINT/ IGRIMJ, IGRIMN, IGRITX
      CHARACTER*8 XFMT,YFMT
      REAL MAJX,MINX,MAJY,MINY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','GRID','VERSION 01')
C
      CALL GRIDAL(MAJRX,MINRX,MAJRY,MINRY,0,0,0,0.,0.)
      RETURN
      END
      SUBROUTINE GRIDL(MAJRX,MINRX,MAJRY,MINRY)
C
      COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
      COMMON /CLAB/ XFMT, YFMT
      COMMON /TICK/ MAJX, MINX, MAJY, MINY
      COMMON /GRIINT/ IGRIMJ, IGRIMN, IGRITX
      CHARACTER*8 XFMT,YFMT
      REAL MAJX,MINX,MAJY,MINY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','GRIDL','VERSION 01')
C
      CALL GRIDAL(MAJRX,MINRX,MAJRY,MINRY,1,1,0,0.,0.)
      RETURN
      END
      SUBROUTINE PERIM(MAJRX,MINRX,MAJRY,MINRY)
C
      COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
      COMMON /CLAB/ XFMT, YFMT
      COMMON /TICK/ MAJX, MINX, MAJY, MINY
      COMMON /GRIINT/ IGRIMJ, IGRIMN, IGRITX
      CHARACTER*8 XFMT,YFMT
      REAL MAJX,MINX,MAJY,MINY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','PERIM','VERSION 01')
C
      CALL GRIDAL(MAJRX,MINRX,MAJRY,MINRY,0,0,5,0.,0.)
      RETURN
      END
      SUBROUTINE PERIML(MAJRX,MINRX,MAJRY,MINRY)
C
      COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
      COMMON /CLAB/ XFMT, YFMT
      COMMON /TICK/ MAJX, MINX, MAJY, MINY
      COMMON /GRIINT/ IGRIMJ, IGRIMN, IGRITX
      CHARACTER*8 XFMT,YFMT
      REAL MAJX,MINX,MAJY,MINY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','PERIML','VERSION 01')
C
      CALL GRIDAL(MAJRX,MINRX,MAJRY,MINRY,1,1,5,0.,0.)
      RETURN
      END
      SUBROUTINE HALFAX(MAJRX,MINRX,MAJRY,MINRY,X,Y,IXLAB,IYLAB)
C
      COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
      COMMON /CLAB/ XFMT, YFMT
      COMMON /TICK/ MAJX, MINX, MAJY, MINY
      COMMON /GRIINT/ IGRIMJ, IGRIMN, IGRITX
      CHARACTER*8 XFMT,YFMT
      REAL MAJX,MINX,MAJY,MINY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','HALFAX','VERSION 01')
C
      CALL GRIDAL(MAJRX,MINRX,MAJRY,MINRY,IXLAB,IYLAB,10,X,Y)
      RETURN
      END
      SUBROUTINE LABMOD(FMTX,FMTY,NUMX,NUMY,ISIZX,ISIZY,IXDEC,IYDEC,
     1                  IXOR)
C
C  RESETS PARAMETERS FOR TEXT GRAPHICS FROM DEFAULT VALUES.
C
      COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
      COMMON /CLAB/ XFMT, YFMT
      CHARACTER*8 XFMT,YFMT,FMTX,FMTY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','LABMOD','VERSION 01')
C
C
C +NOAO - Blockdata rewritten as run time initialization.
C       EXTERNAL GRIDT
	call gridt
C -NOAO
      XFMT = '        '
      YFMT = '        '
      XFMT = FMTX
      YFMT = FMTY
C
      CALL GETUSV('XF',IVAL)
      XRANGE = 2. ** IVAL
      CALL GETUSV('YF', IVAL)
      YRANGE = 2. ** IVAL
C
C  SIZX AND SIZY ARE COMPUTED TO BE PERCENTAGES OF TOTAL SCREEN
C  WIDTH.
C
      IF (ISIZX .GT. 3) THEN
        SIZX = FLOAT(ISIZX)/XRANGE
      ELSEIF (ISIZX .EQ. 3) THEN
        SIZX = 24./1024.
      ELSEIF (ISIZX .EQ. 2) THEN
        SIZX = 16./1024.
      ELSEIF (ISIZX .EQ. 1) THEN
        SIZX = 12./1024.
      ELSE
        SIZX = 8./1024.
      ENDIF
C
      IF (ISIZY .GT. 3) THEN
        SIZY = FLOAT(ISIZY)/XRANGE
      ELSEIF (ISIZY .EQ. 3) THEN
        SIZY = 24./1024.
      ELSEIF (ISIZY .EQ. 2) THEN
        SIZY = 16./1024.
      ELSEIF (ISIZY .EQ. 1) THEN
        SIZY = 12./1024.
      ELSE
        SIZY = 8./1024.
      ENDIF
C
C  CALCULATE XDEC AND YDEC AS PERCENTAGES OF TOTAL SCREEN WIDTH
C  IN PLOTTER ADDRESS UNITS.
C
      IF (IXDEC .EQ. 0 .OR. IXDEC .EQ. 1) THEN
        YDEC = FLOAT(IXDEC)
      ELSE
        YDEC = FLOAT(IXDEC)/XRANGE
      ENDIF
      IF (IYDEC .EQ. 0 .OR. IYDEC .EQ. 1) THEN
        XDEC = FLOAT(IYDEC)
      ELSE
        XDEC = FLOAT(IYDEC)/YRANGE
      ENDIF
C
      IXORI = IXOR
C
      RETURN
      END
      SUBROUTINE TICK4(LMAJX,LMINX,LMAJY,LMINY)
C
C  CHANGES TICK LENGTH FOR EACH AXIS.
C
      COMMON /TICK/ MAJX, MINX, MAJY, MINY
      REAL MAJX, MINX, MAJY, MINY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','TICK4','VERSION 01')
C
      CALL GETUSV('XF', IVAL)
      XRANGE = 2. ** IVAL
      CALL GETUSV('YF', IVAL)
      YRANGE = 2. ** IVAL
C
      MAJX = FLOAT(LMAJX)/YRANGE
      MINX = FLOAT(LMINX)/YRANGE
      MAJY = FLOAT(LMAJY)/XRANGE
      MINY = FLOAT(LMINY)/XRANGE
C
      RETURN
      END
      SUBROUTINE TICKS(LMAJ,LMIN)
C
      COMMON /TICK/ MAJX,MINX,MAJY,MINY
      REAL MAJX,MINX,MAJY,MINY
C
C  THE FOLLOWING IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4('GRAPHX','GRIDAL','TICKS','VERSION 01')
C
      CALL TICK4(LMAJ,LMIN,LMAJ,LMIN)
C
      RETURN
      END
      SUBROUTINE CHSTR(LABEL,FIRST,LAST)
C
C  THIS CALCULATES THE POSITION OF THE FIRST NON-BLANK CHARACTER
C  AND THE POSITION OF THE LAST NON-BLANK CHARACTER IN LABEL.
C
      INTEGER   FIRST, LAST
      CHARACTER*15 LABEL
C
      DO 100 I = 1,15
      IF (LABEL(I:I) .NE. ' ') GOTO 200
 100  CONTINUE
 200  FIRST = I
      LAST = 15
      IF (FIRST .NE. 15) THEN
        DO 300 J = FIRST+1,15
        IF (LABEL(J:J) .EQ. ' ') THEN
          LAST = J-1
          GOTO 999
        ENDIF
 300    CONTINUE
 999    CONTINUE
      ENDIF
      RETURN
      END
      SUBROUTINE EXPAND(MAXW)
C
C  THE WINDOW IS EXPANDED AND THE NEW WORLD COORDINATES ARE
C  CALCULATED TO CORRESPOND TO THE MAXIMUM VIEWPORT.
C  THE ORIGINAL ASPECT RATIO OF WORLD COORDINATES TO VIEWPORT
C  COORDINATES REMAINS THE SAME.  UNDER THE NEWLY-DEFINED
C  NORMALIZATION TRANSFORMATION, THE WINDOW OF THE ORIGINAL
C  NORMALIZATION TRANSFORMATION IS MAPPED TO THE VIEWPORT
C  OF THE ORIGINAL NORMALIZATION TRANSFORMATION IN EXACTLY
C  THE SAME WAY AS IN THE INITIAL NORMALIZATION TRANSFORMATION.
C
      REAL MAXW(4), VIEW(4), WIND(4)
      REAL LEFT
C
C  INQUIRE CURRENT WINDOW AND VIEWPORT SETTINGS.
C
      CALL GQCNTN(IERR,ICNT)
      CALL GQNT(ICNT,IERR,WIND,VIEW)
C
C  CALCULATE RATIO OF Y WORLD/VIEWPORT COORDINATES.
C
      YRATIO = (WIND(4) - WIND(3))/(VIEW(4) - VIEW(3))
C
C  CALCULATE RATIO OF X WORLD/VIEWPORT COORDINATES.
C
      XRATIO = (WIND(2) - WIND(1))/(VIEW(2) - VIEW(1))
C
C  GET EXPANDED LOWER LIMIT Y COORDINATE.
C
      VBOTTM = VIEW(3) - 0.
      BOTTOM = YRATIO * VBOTTM
      MAXW(3) = WIND(3) - BOTTOM
C
C  GET EXPANDED UPPER LIMIT Y COORDINATE.
C
      VTOP = 1. - VIEW(4)
      TOP = YRATIO * VTOP
      MAXW(4) = WIND(4) + TOP
C
C  GET EXPANDED LEFT LIMIT X COORDINATE.
C
      VLEFT = VIEW(1) - 0.
      LEFT = XRATIO * VLEFT
      MAXW(1) = WIND(1) - LEFT
C
C  GET EXPANDED RIGHT LIMIT X COORDINATE.
C
      VRIGHT = 1. - VIEW(2)
      RIGHT = XRATIO * VRIGHT
      MAXW(2) = WIND(2) + RIGHT
C
C  SET NEW (EXPANDED) NORMALIZATION TRANSFORMATION.
C
      CALL GSWN(1,MAXW(1),MAXW(2),MAXW(3),MAXW(4))
      CALL GSVP(1, 0., 1., 0., 1. )
      CALL GSELNT(1)
C
      RETURN
      END

      SUBROUTINE slGE50 (DL, DB, DR, DD)
*+
*     - - - - -
*      G E 5 0
*     - - - - -
*
*  Transformation from IAU 1958 galactic coordinates to
*  B1950.0 'FK4' equatorial coordinates (double precision)
*
*  Given:
*     DL,DB       dp       galactic longitude and latitude L2,B2
*
*  Returned:
*     DR,DD       dp       B1950.0 'FK4' RA,Dec
*
*  (all arguments are radians)
*
*  Called:
*     slDS2C, slDIMV, slDC2S, slADET, slDA2P, slDA1P
*
*  Note:
*     The equatorial coordinates are B1950.0 'FK4'.  Use the
*     routine slGAEQ if conversion to J2000.0 coordinates
*     is required.
*
*  Reference:
*     Blaauw et al, Mon.Not.R.Astron.Soc.,121,123 (1960)
*
*  P.T.Wallace   Starlink   5 September 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DL,DB,DR,DD

      DOUBLE PRECISION slDA2P,slDA1P

      DOUBLE PRECISION V1(3),V2(3),R,D,RE,DE

*
*  L2,B2 system of galactic coordinates
*
*  P = 192.25       RA of galactic north pole (mean B1950.0)
*  Q =  62.6        inclination of galactic to mean B1950.0 equator
*  R =  33          longitude of ascending node
*
*  P,Q,R are degrees
*
*
*  Equatorial to galactic rotation matrix
*
*  The Euler angles are P, Q, 90-R, about the z then y then
*  z axes.
*
*         +CP.CQ.SR-SP.CR     +SP.CQ.SR+CP.CR     -SQ.SR
*
*         -CP.CQ.CR-SP.SR     -SP.CQ.CR+CP.SR     +SQ.CR
*
*         +CP.SQ              +SP.SQ              +CQ
*

      DOUBLE PRECISION RMAT(3,3)
      DATA RMAT(1,1),RMAT(1,2),RMAT(1,3),
     :     RMAT(2,1),RMAT(2,2),RMAT(2,3),
     :     RMAT(3,1),RMAT(3,2),RMAT(3,3) /
     : -0.066988739415D0,-0.872755765852D0,-0.483538914632D0,
     : +0.492728466075D0,-0.450346958020D0,+0.744584633283D0,
     : -0.867600811151D0,-0.188374601723D0,+0.460199784784D0 /



*  Spherical to Cartesian
      CALL slDS2C(DL,DB,V1)

*  Rotate to mean B1950.0
      CALL slDIMV(RMAT,V1,V2)

*  Cartesian to spherical
      CALL slDC2S(V2,R,D)

*  Introduce E-terms
      CALL slADET(R,D,1950D0,RE,DE)

*  Express in conventional ranges
      DR=slDA2P(RE)
      DD=slDA1P(DE)

      END

#-h-  doarth			  636  local   12/01/80  15:53:48
# doarth - do arithmetic operation
   include  defs

   subroutine doarth (argstk, i, j)
   integer argstk (ARGSIZE), i, j

   include COMMON_BLOCKS

   integer k, l
   integer ctoi

   character op

   k = argstk (i + 2)
   l = argstk (i + 4)
   op = evalst (argstk (i + 3))
   if (op == PLUS)
      call pbnum (ctoi (evalst, k) + ctoi (evalst, l))
   else if (op == MINUS)
      call pbnum (ctoi (evalst, k) - ctoi (evalst, l))
   else if (op ==  STAR )
      call pbnum (ctoi (evalst, k) * ctoi (evalst, l))
   else if (op ==  SLASH )
      call pbnum (ctoi (evalst, k) / ctoi (evalst, l))
   else
      call remark ('arith error')

   return
   end

C--------------------------------------------------------------------------
        subroutine ftmkys(ounit,keywrd,strval,comm,status)

C       modify a character string value header record 
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       strval  c  keyword value 
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991
C       modifed 7/93 to support string keywords continued over multiple cards
C       modified 9/94 to support the OGIP long string convention

        character*(*) keywrd,strval,comm
        integer ounit,status

        integer clen,i,nvalue,ncomm
        character keynam*8,value*70,cmnt*48,bslash

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        if (status .gt. 0)return

C       check if the new value is too long to fit in a single 'card image'
        clen=len(strval)
        if (clen .le. 68)go to 20

        do 10 i=clen,69,-1
                if (strval(i:i) .ne. ' ')go to 100
10      continue

C       now check that the old keyword is not continued over multiple cards
C       read the (first line) of the existing keyword

20      call ftgkey(ounit,keywrd,value,cmnt,status)
        if (status .gt. 0)go to 900

C       is last character of the value a backslash or & ?
C       have to use 2 \\'s because the SUN compiler treats 1 \ as an escape
        bslash='\\'
        do 30 i=70,1,-1
                if (value(i:i) .ne. ' '.and. value(i:i).ne.'''')then
                    if (value(i:i) .eq. bslash .or. 
     &                  value(i:i) .eq. '&')then
C                     backspace the current header pointer by one record
                      nxthdr(bufnum(ounit))=nxthdr(bufnum(ounit))-80
                      go to 100
                    else
                      go to 40
                    end if
                end if
30      continue

C       OK, we can simply overwrite the old keyword with the new
40      continue

C       overwrite the old comment unless user supplied the magic value
        if (comm .ne. '&')then
                cmnt=comm
        end if
C       convert string to quoted character string (max length = 70 characters)
        call fts2c(strval,value,clen,status)
        if (status .gt. 0)go to 900

C       find amount of space left for comment string
C       (assume 10 char. for 'keyword = ', and 3 between value and comment)
C       which leaves 67 spaces for the value string + comment string
        nvalue=max(20,clen)
        ncomm=67-nvalue

C       write the keyword record
        keynam=keywrd
        if (ncomm .gt. 0)then
C         there is space for a comment
          call ftmodr(ounit,
     &    keynam//'= '//value(1:nvalue)//' / '//cmnt(1:ncomm),status)
        else
C         no room for a comment
          call ftmodr(ounit,
     &    keynam//'= '//value(1:nvalue)//'   ',status)
        end if  
        go to 900

100     continue

C       Either the old or new keyword is continued over multiple
C       header card images, so have to use a less efficient way to modify
C       the keyword by completely deleting the old and inserting the new.

C       read the old comment, if we need to preserve it
        if (comm .eq. '&')then
                call ftgkys(ounit,keywrd,value,cmnt,status)
                if (status .gt. 0)go to 900
C               reset the current header pointer by 2 records to make
C               it faster (usually) to find and delete the keyword
                nxthdr(bufnum(ounit))=nxthdr(bufnum(ounit))-160
        else
                cmnt=comm
        end if

C       delete the old keyword
        call ftdkey(ounit,keywrd,status)
        if (status .gt. 0)go to 900

C       insert the new keyword
        call ftikys(ounit,keywrd,strval,cmnt,status)

900     continue
        end

      DOUBLE PRECISION FUNCTION slDT (EPOCH)
*+
*     - - -
*      D T
*     - - -
*
*  Estimate the offset between dynamical time and Universal Time
*  for a given historical epoch.
*
*  Given:
*     EPOCH       d        (Julian) epoch (e.g. 1850D0)
*
*  The result is a rough estimate of ET-UT (after 1984, TT-UT) at
*  the given epoch, in seconds.
*
*  Notes:
*
*  1  Depending on the epoch, one of three parabolic approximations
*     is used:
*
*      before 979    Stephenson & Morrison's 390 BC to AD 948 model
*      979 to 1708   Stephenson & Morrison's 948 to 1600 model
*      after 1708    McCarthy & Babcock's post-1650 model
*
*     The breakpoints are chosen to ensure continuity:  they occur
*     at places where the adjacent models give the same answer as
*     each other.
*
*  2  The accuracy is modest, with errors of up to 20 sec during
*     the interval since 1650, rising to perhaps 30 min by 1000 BC.
*     Comparatively accurate values from AD 1600 are tabulated in
*     the Astronomical Almanac (see section K8 of the 1995 AA).
*
*  3  The use of double-precision for both argument and result is
*     purely for compatibility with other SLALIB time routines.
*
*  4  The models used are based on a lunar tidal acceleration value
*     of -26.00 arcsec per century.
*
*  Reference:  Explanatory Supplement to the Astronomical Almanac,
*              ed P.K.Seidelmann, University Science Books (1992),
*              section 2.553, p83.  This contains references to
*              the Stephenson & Morrison and McCarthy & Babcock
*              papers.
*
*  P.T.Wallace   Starlink   1 March 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION EPOCH
      DOUBLE PRECISION T,W,S


*  Centuries since 1800
      T=(EPOCH-1800D0)/100D0

*  Select model
      IF (EPOCH.GE.1708.185161980887D0) THEN

*     Post-1708: use McCarthy & Babcock
         W=T-0.19D0
         S=5.156D0+13.3066D0*W*W
      ELSE IF (EPOCH.GE.979.0258204760233D0) THEN

*     979-1708: use Stephenson & Morrison's 948-1600 model
         S=25.5D0*T*T
      ELSE

*     Pre-979: use Stephenson & Morrison's 390 BC to AD 948 model
         S=1360.0D0+(320D0+44.3D0*T)*T
      END IF

*  Result
      slDT=S

      END

      SUBROUTINE TISOSR	(nplot, IERROR)
C
C LATEST REVISION	 DECEMBER 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 ISOSRF	AND TO TEST ISOSRF ON A	SINGLE PROBLEM
C
C USAGE			 CALL TISOSR (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   ISOSRF TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS WRITTEN ON UNIT 6.
C			 IN ADDITION, TWO FRAMES CONTAINING THE	SAMPLE
C			 PLOTS ARE PRODUCED ON THE MACHINE GRAPHICS
C			 DEVICE.  IN ORDER TO DETERMINE	IF THE TEST
C			 WAS SUCCESSFUL, IT IS NECESSARY TO EXAMINE
C			 THESE PLOTS.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 ISOSRF	FROM ULIB LIBRARY
C FILES
C
C LANGUAGE		 STANDARD FORTRAN77
C
C HISTORY		 WRITTEN  BY MEMBERS OF	THE
C			 SCIENTIFIC COMPUTING DIVISION OF NCAR,
C			 BOULDER COLORADO
C
C ALGORITHM		 A FUNCTION OF THREE VARIABLES IS DEFINED, AND
C			 VALUES	OF THE FUNCTION	ON A THREE DIMENSIONAL
C			 RECTANGULAR GRID ARE STORED IN	AN ARRAY.  THIS
C			 SUBROUTINE CALLS EZISOS AND ISOSRF TO DRAW ISO-
C			 VALUED	SURFACE	PLOTS OF THE FUNCTION.
C
C PORTABILITY		 ANSI STANDARD
C
C
      SAVE
      DIMENSION	      T(21,31,19),SLAB(33,33),EYE(3)
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE INTEGER COORDINATES RANGE	FROM 1 TO 1024,	THE VALUES IX AND IY
C DEFINE THE CENTER OF THE TITLE STRING.
C
      REAL IX,IY
      DATA IX/.44/, IY/.95/
C
      DATA NU,NV,NW/21,31,19/
      DATA RBIG1,RBIG2,RSML1,RSML2/6.,6.,2.,2./
      DATA TISO/0./
      DATA MUVWP2/33/
      DATA IFLAG/-7/
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 1
C
C FILL THREE DIMENSIONAL ARRAY TO BE PLOTTED
C
      JCENT1 = FLOAT(NV)*.5-RBIG1*.5
      JCENT2 = FLOAT(NV)*.5+RBIG2*.5
      DO  30 I=1,NU
	 FIMID = I-NU/2
	 DO  20	J=1,NV
	    FJMID1 = J-JCENT1
	    FJMID2 = J-JCENT2
	    DO	10 K=1,NW
	       FKMID = K-NW/2
	       F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
	       F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
	       FIP1 = (1.-F1)*FIMID
	       FIP2 = (1.-F2)*FIMID
	       FJP1 = (1.-F1)*FJMID1
	       FJP2 = (1.-F2)*FJMID2
	       FKP1 = (1.-F1)*FKMID
	       FKP2 = (1.-F2)*FKMID
	       T(I,J,K)	= AMIN1(FIMID*FIMID+FJP1*FJP1+FKP1*FKP1-
     1			  RSML1*RSML1,
     2			    FKMID*FKMID+FIP2*FIP2+FJP2*FJP2-RSML2*RSML2)
   10	    CONTINUE
   20	 CONTINUE
   30 CONTINUE
C
C DEFINE EYE POSITION
C
      EYE(1) = 100.
      EYE(2) = 150.
      EYE(3) = 125.
C
C LABEL	THE PLOT TO BE DRAWN BY	EZISOS
C
      if (nplot .eq. 1) then
      CALL GSELNT(0)
      CALL WTSTR(IX,IY,'DEMONSTRATION PLOT FOR ENTRY EZISOS OF ISOSRF',
     1 2,0,0)
C
C TEST EZISOS
C
      CALL EZISOS (T,NU,NV,NW,EYE,SLAB,TISO)
      endif
C
C LABEL	THE PLOT TO BE DRAWN BY	ISOSRF
C
      if (nplot .eq. 2) then
      CALL GSELNT(0)
      CALL WTSTR(IX,IY,'DEMONSTRATION PLOT FOR ENTRY ISOSRF OF ISOSRF',
     1 2,0,0)
C
C TEST ISOSRF WITH SUBARRAY OF T
C
      MU=NU/2
      MV=NV/2
      MW=NW/2
      MUVWP2=MAX0(MU,MV,MW)+2
      CALL ISOSRF(T(MU,MV,MW),NU,MU,NV,MV,MW,EYE,MUVWP2,SLAB,TISO,IFLAG)
      endif
c     CALL FRAME
C
      IERROR = 0
c     WRITE (6,1001)
      RETURN
C
c1001 FORMAT ('	    ISOSRF TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

      integer function esc (array, i)
      integer array (100)
      integer i
      if (.not.(array (i) .ne. 64))goto 23000
      esc = array (i)
      goto 23001
23000 continue
      if (.not.(array (i+1) .eq. -2))goto 23002
      esc = 64
      goto 23003
23002 continue
      i = i + 1
      if (.not.(array (i) .eq. 110 .or. array (i) .eq. 78))goto 23004
      esc = 10
      goto 23005
23004 continue
      if (.not.(array (i) .eq. 116 .or. array (i) .eq. 84))goto 23006
      esc = 9
      goto 23007
23006 continue
      esc = array (i)
23007 continue
23005 continue
23003 continue
23001 continue
      return
      end

      SUBROUTINE slDJCL (DJM, IY, IM, ID, FD, J)
*+
*     - - - - -
*      D J C L
*     - - - - -
*
*  Modified Julian Date to Gregorian year, month, day,
*  and fraction of a day.
*
*  Given:
*     DJM      dp     modified Julian Date (JD-2400000.5)
*
*  Returned:
*     IY       int    year
*     IM       int    month
*     ID       int    day
*     FD       dp     fraction of day
*     J        int    status:
*                       0 = OK
*                      -1 = unacceptable date (before 4701BC March 1)
*
*  The algorithm is adapted from Hatcher 1984 (QJRAS 25, 53-55).
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DJM
      INTEGER IY,IM,ID
      DOUBLE PRECISION FD
      INTEGER J

      DOUBLE PRECISION F,D
      INTEGER JD,N4,ND10


*  Check if date is acceptable.
      IF ( DJM.LE.-2395520D0 .OR. DJM.GE.1D9 ) THEN
         J = -1
      ELSE
         J = 0

*     Separate day and fraction.
         F = MOD(DJM,1D0)
         IF (F.LT.0D0) F = F+1D0
         D = ANINT(DJM-F)

*     Express day in Gregorian calendar.
         JD = NINT(D)+2400001

         N4 = 4*(JD+((6*((4*JD-17918)/146097))/4+1)/2-37)
         ND10 = 10*(MOD(N4-237,1461)/4)+5

         IY = N4/1461-4712
         IM = MOD(ND10/306+2,12)+1
         ID = MOD(ND10,306)/10+1
         FD = F

         J=0

      END IF

      END

      SUBROUTINE FDVDLD (IENTRY,IIX,IIY)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C SOFTWARE DASHED LINE PACKAGE WITH CHARACTER CAPABILITY AND SMOOTHING
C
C LATEST REVISION        JUNE 1984
C
C PURPOSE                DASHSMTH IS A SOFTWARE DASHED LINE PACKAGE WITH
C                        SMOOTHING CAPABILITIES.  DASHSMTH IS DASHCHAR
C                        WITH SMOOTHING FEATURES ADDED.
C
C USAGE                  FIRST, EITHER
C                             CALL DASHDB (IPAT)
C                        WHERE IPAT IS A 16-BIT DASH PATTERN AS
C                        DESCRIBED IN THE SUBROUTINE DASHDB (SEE
C                        DASHLINE DOCUMENTATION), OR
C                             CALL DASHDC (IPAT,JCRT,JSIZE)
C                        AS DESCRIBED BELOW.
C
C                        THEN, CALL ANY OF THE FOLLOWING:
C                             CALL CURVED (X,Y,N)
C                             CALL FRSTD (X,Y)
C                             CALL VECTD (X,Y)
C                             CALL LASTD
C
C                        LASTD IS CALLED ONLY AFTER THE LAST
C                        POINT OF A LINE HAS BEEN PROCESSED IN VECTD.
C
C                        THE FOLLOWING MAY ALSO BE CALLED, BUT NO
C                        SMOOTHING WILL RESULT:
C                             CALL LINED (XA,YA,XB,YB)
C
C
C ARGUMENTS              IPAT
C ON INPUT                 A CHARACTER STRING OF ARBITRARY LENGTH
C TO DASHDC                (60 CHARACTERS SEEMS TO BE A PRACTICAL
C                          LIMIT) WHICH SPECIFIES THE DASH PATTERN
C                          TO BE USED.  A DOLLAR SIGN IN IPAT
C                          INDICATES SOLID; AN APOSTROPHE INDICATES
C                          A GAP; BLANKS ARE IGNORED.  ANY CHARACTER
C                          IN IPAT WHICH IS NOT A DOLLAR SIGN,
C                          APOSTROPHE, OR BLANK IS CONSIDERED TO BE
C                          PART OF A LINE LABEL.  EACH LINE LABEL
C                          CAN BE AT MOST 15 CHARACTERS IN LENGTH.
C                          SUFFICIENT WHITE SPACE IS RESERVED IN THE
C                          DASHED LINE FOR WRITING LINE LABELS.
C
C                        JCRT
C                          THE LENGTH IN PLOTTER ADDRESS UNITS PER
C                          $ OR APOSTROPHE.
C
C                        JSIZE
C                          IS THE SIZE OF THE PLOTTED CHARACTERS:
C                          . IF BETWEEN 0 AND 3 , IT IS 1., 1.5, 2.
C                            AND 3. TIMES AN 8 PLOTTER ADDRESS UNIT
C                            WIDTH.
C                          . IF GREATER THAN 3, IT IS THE CHARACTER
C                            WIDTH IN PLOTTER ADDRESS UNITS.
C
C
C ARGUMENTS TO           CURVED(X,Y,N)
C OTHER LINE-DRAWING       X AND Y ARE ARRAYS OF WORLD COORDINATE VALUES
C ROUTINES                 OF LENGTH N OR GREATER.  LINE SEGMENTS OBEYING
C                          THE SPECIFIED DASH PATTERN ARE DRAWN TO
C                          CONNECT THE N POINTS.
C
C                        FRSTD(X,Y)
C                          THE CURRENT PEN POSITION IS SET TO
C                          THE WORLD COORDINATE VALUE (X,Y)
C
C                        VECTD(X,Y)
C                          A LINE SEGMENT IS DRAWN BETWEEN THE
C                          WORLD COORDINATE VALUE (X,Y) AND THE
C                          MOST RECENT PEN POSITION.  (X,Y) THEN
C                          BECOMES THE MOST RECENT PEN POSITION.
C
C                        LINED(XA,XB,YA,YB)
C                          A LINE IS DRAWN BETWEEN WORLD COORDINATE
C                          VALUES (XA,YA) AND (XB,YB).
C
C ON OUTPUT                ALL ARGUMENTS ARE UNCHANGED FOR ALL ROUTINES.
C
C NOTE                     WHEN USING FRSTD AND VECTD, LASTD MUST BE
C                          CALLED (NO ARGUMENTS NEEDED).  LASTD SETS UP
C                          THE CALLS TO THE SMOOTHING ROUTINES KURV1S AND
C                          KURV2S.
C
C                          WHEN SWITCHING FROM THE REGULAR PLOTTING
C                          ROUTINES TO A DASHED LINE PACKAGE THE FIRST
C                          CALL SHOULD NOT BE TO VECTD.
C
C ENTRY POINTS             DASHDB, DASHDC, CURVED, FRSTD, VECTD, LINED,
C                          RESET, LASTD, KURV1S, KURV2S, CFVLD, FDVDLD,
C                          DRAWPV, DASHBD
C
C COMMON BLOCKS            INTPR, DASHD1, DASHD2, DDFLAG, DCFLAG, DSAVE1,
C                          DSAVE2, DSAVE3, DSAVE5, CFFLAG, SMFLAG, DFFLAG,
C                          FDFLAG
C
C REQUIRED LIBRARY         THE ERPRT77 PACKAGE AND THE SPPS.
C ROUTINES
C
C I/O                      PLOTS SOLID OR DASHED LINES, POSSIBLY WITH
C                          CHARACTERS AT INTERVALS IN THE LINE.
C                          THE LINES MAY ALSO BE SMOOTHED.
C
C PRECISION                SINGLE
C
C LANGUAGE                 FORTRAN
C
C HISTORY                  WRITTEN IN OCTOBER 1973.
C                          MADE PORTABLE IN SEPTEMBER 1977 FOR USE
C                          WITH ALL MACHINES WHICH
C                          SUPPORT PLOTTERS WITH UP TO 15 BIT RESOLUTION.
C                          CONVERTED TO FORTRAN77 AND GKS IN JUNE, 1984.
C
C ALGORITHM                POINTS FOR EACH LINE
C                          SEGMENT ARE PROCESSED AND PASSED TO THE
C                          ROUTINES, KURV1S AND KURV2S, WHICH COMPUTE
C                          SPLINES UNDER TENSION PASSING THROUGH THESE
C                          POINTS.  NEW POINTS ARE GENERATED BETWEEN THE
C                          GIVEN POINTS, RESULTING IN SMOOTH LINES.
C
C ACCURACY                 PLUS OR MINUS .5 PLOTTER ADDRESS UNITS PER CALL.
C                          THERE IS NO CUMULATIVE ERROR.
C
C TIMING                   ABOUT THREE TIMES AS LONG AS DASHCHAR.
C
C
C
C
C
C
C
C
C***********************************************************************
C
C FDVDLD RECEIVES IN ITS ARGUMENTS THE POINTS TO BE PROCESSED FOR A
C LINE SEGMENT. IT PASSES THESE POINTS TO THE ROUTINES KURV1S AND KURV2S
C WHICH COMPUTE SPLINES UNDER TENSION PASSING THROUGH THESE POINTS.
C FDVDLD THEN CALLS CFVLD TO CONNECT THE POINTS GENERATED IN KURV2S.
C
      DIMENSION       XP(70),  YP(70),  TEMP(70)
C
C THE VARIABLES IN DSAVE5 HAVE TO BE SAVED FOR THE NEXT CALL TO FDVDLD.
C
      COMMON /DSAVE5/ XSAVE(70), YSAVE(70), XSVN, YSVN, XSV1, YSV1,
     1                SLP1, SLPN, SSLP1, SSLPN, N, NSEG
C
C IOFFS IS AN INTERNAL PARAMETER. IT IS INITIALIZED IN DASHBD AND
C REFERENCED IN FDVDLD AND DRAWPV.
C
      COMMON /SMFLAG/ IOFFS
C
C IFSTF2 IS A FLAG TO CONTROL THAT FRSTD IS CALLED BEFORE VECTD IS
C CALLED.
C
      COMMON /DFFLAG/ IFSTF2
C
C IFLAG CONTROLS IF LASTD CAN BE CALLED DIRECTLY OR IF IT WAS JUST
C CALLED FROM BY VECTD SO THAT THIS CALL CAN BE IGNORED.
C
      COMMON /FDFLAG/ IFLAG
C
C NOTE THAT THIS IFSTF2 FLAG CANNOT BE IDENTICAL TO THE IFSTFL FLAG
C IN THE ROUTINE CFVLD, BECAUSE A CALL TO THE FRSTD ENTRY OF FDVDLD DOES
C NOT ELIMINATE THE NECESSITY OF A CALL TO THE FRSTD ENTRY OF CFVLD,
C AND REVERSE.
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
C
C
C OTHER CONSTANTS.
C
      DATA PI /3.14159265358/
      DATA IDUMMY /0/
C
C
      GO TO (10,15,35),IENTRY
C
C *************************************
C
C ENTRY  FRSTD (XX,YY)
C
   10 DEG = 180./PI
C
      MX = IIX
      MY = IIY
      IFSTF2 = 0
      SSLP1 = 0.0
      SSLPN = 0.0
      XSVN = 0.0
      YSVN = 0.0
      IF (IOFFS .GE. 1) CALL CFVLD (1,MX,MY)
      IF (IOFFS .GE. 1) RETURN
C
C INITIALIZE THE POINT AND SEGMENT COUNTER
C N COUNTS THE NUMBER OF POINTS/SEGMENT
C
      N = 0
C
C NSEG = 0       FIRST SEGMENT
C NSEG = 1       MORE THAN ONE SEGMENT
C
      NSEG = 0
C
C SAVE THE X,Y COORDINATES OF THE FIRST POINT
C XSV1           CONTAINS THE X COORDINATE OF THE FIRST POINT
C                OF A LINE
C YSV1           CONTAINS THE Y COORDINATE OF THE FIRST POINT
C                OF A LINE
C
      XSV1 = MX
      YSV1 = MY
      GO TO 30
C
C *************************************
C
C     ENTRY VECTD (XX,YY)
C
   15 CONTINUE
C
C TEST FOR PREVIOUS FRSTD CALL
C
      IF (IFSTF2 .EQ. 0) GO TO 20
C
C INFORM USER - NO PREVIOUS CALL TO FRSTD. TREAT CALL AS FRSTD CALL.
C
      CALL SETER(' FDVDLD- VECTD CALL OCCURS BEFORE A CALL TO FRSTD.',
     -            1,1)
      GO TO 10
   20 MX = IIX
      MY = IIY
C
C VECTD          SAVES THE X,Y COORDINATES OF THE ACCEPTED
C                POINTS ON A LINE SEGMENT
C
      IF (IOFFS .GE. 1) CALL CFVLD (2,MX,MY)
      IF (IOFFS .GE. 1) RETURN
C
C IF THE NEW POINT IS TOO CLOSE TO THE PREVIOUS POINT, IGNORE IT
C
      IF (ABS(FLOAT(IFIX(XSVN)-MX))+ABS(FLOAT(IFIX(YSVN)-MY)) .LT.
     1    SMALL) RETURN
      IFLAG = 0
   30 N = N+1
C
C SAVE THE X,Y COORDINATES OF EACH POINT OF THE SEGMENT
C XSAVE          THE ARRAY OF X COORDINATES OF LINE SEGMENT
C YSAVE          THE ARRAY OF Y COORDINATES OF LINE SEGMENT
C
      XSAVE(N) = MX
      YSAVE(N) = MY
      XSVN = XSAVE(N)
      YSVN = YSAVE(N)
      IF (N .GE. L1-1) GO TO 40
      RETURN
C
C *************************************
C
C     ENTRY LASTD
C
   35 CONTINUE
      IF (IFSTF2 .NE. 0) RETURN
      IFSTF2 = 1
C
C LASTD          CHECKS FOR PERIODIC LINES AND SETS UP
C                  THE CALLS TO KURV1S AND KURV2S
C
      IF (IOFFS .GE. 1) CALL CFVLD (3,IDUMMY,IDUMMY)
      IF (IOFFS .GE. 1) RETURN
C
C IFLAG = 0      OK TO CALL LASTD DIRECTLY
C IFLAG = 1      LASTD WAS JUST CALLED FROM BY VECTD
C                IGNORE CALL TO LASTD
C
      IF (IFLAG .EQ. 1) RETURN
C
C COMPARE THE LAST POINT OF SEGMENT WITH FIRST POINT OF LINE
C
   40 IFLAG = 1
C
C IPRD = 0       PERIODIC LINE
C IPRD = 1       NON-PERIODIC LINE
C
      IPRD = 1
      IF (ABS(XSV1-XSVN)+ABS(YSV1-YSVN) .LT. SMALL) IPRD = 0
C
C TAKE CARE OF THE CASE OF ONLY TWO DISTINCT P0INTS ON A LINE
C
      IF (NSEG .GE. 1) GO TO 60
      IF (N-2) 150,140,50
   50 IF (N .GE. 4) GO TO 60
C
      IF (IPRD .NE. 0) GO TO 60
      DX = XSAVE(2)-XSAVE(1)
      DY = YSAVE(2)-YSAVE(1)
      SLOPE = ATAN2(DY,DX)*DEG+90.
      IF (SLOPE .GE. 360.) SLOPE = SLOPE-360.
      IF (SLOPE .LE. 0.) SLOPE = SLOPE+360.
      SLP1 = SLOPE
      SLPN = SLOPE
      ISLPSW = 0
      SIGMA = TENSN
      GO TO 100
   60 SIGMA = TENSN
      IF (IPRD .GE. 1) GO TO 80
      IF (NSEG .GE. 1) GO TO 70
C
C SET UP FLAGS FOR A  1  SEGMENT, PERIODIC LINE
C
      ISLPSW = 4
      XSAVE(N) = XSV1
      YSAVE(N) = YSV1
      GO TO 100
C
C SET UP FLAGS FOR AN N-SEGMENT, PERIODIC LINE
C
   70 SLP1 = SSLPN
      SLPN = SSLP1
      ISLPSW = 0
      GO TO 100
   80 IF (NSEG .GE. 1) GO TO 90
C
C SET UP FLAGS FOR THE 1ST SEGMENT OF A NON-PERIODIC LINE
C
      ISLPSW = 3
      GO TO 100
C
C SET UP FLAGS FOR THE NTH SEGMENT OF A NON-PERIODIC LINE
C
   90 SLP1 = SSLPN
      ISLPSW = 1
C
C CALL THE SMOOTHING ROUTINES
C
  100 CALL KURV1S (N,XSAVE,YSAVE,SLP1,SLPN,XP,YP,TEMP,S,SIGMA,ISLPSW)
C
C DETERMINE THE NUMBER OF POINTS TO INTERPOLATE FOR EACH SEGMENT
C
      IF (NSEG.GE.1 .AND. N.LT.L1-1) GO TO 110
      NPRIME = FLOAT(NP)-(S*FLOAT(NP)*.5)/32767.
      IF (S .GE. 32767.) NPRIME = .5*FLOAT(NP)
      NPL = AMAX1(FLOAT(NPRIME)*S/32767.,2.5)
  110 DT = 1./FLOAT(NPL)
      IX = IFIX (XSAVE(1))
      IY = IFIX (YSAVE(1))
      IF (NSEG .LE. 0) GO TO 112
      CALL DRAWPV (IX,IY,0)
      GO TO 114
  112 CONTINUE
      CALL CFVLD (1,IX,IY)
  114 CONTINUE
      T = 0.0
      NSLPSW = 1
      IF (NSEG .GE. 1) NSLPSW = 0
      NSEG = 1
      CALL KURV2S (T,XS,YS,N,XSAVE,YSAVE,XP,YP,S,SIGMA,NSLPSW,SLP)
C
C SAVE SLOPE AT THE FIRST POINT OF THE LINE
C
      IF (NSLPSW .GE. 1) SSLP1 = SLP
      NSLPSW = 0
      DO 120 I=1,NPL
         T = T+DT
         TT = -T
         IF (I .EQ. NPL) NSLPSW = 1
         CALL KURV2S (TT,XS,YS,N,XSAVE,YSAVE,XP,YP,S,SIGMA,NSLPSW,SLP)
C
C SAVE THE LAST SLOPE OF THIS LINE SEGMENT
C
         IF (NSLPSW .GE. 1) SSLPN = SLP
C
C DRAW EACH PART OF THE LINE SEGMENT
C
         IX = IFIX(XS)
         IY = IFIX (YS)
         CALL CFVLD (2,IX,IY)
  120 CONTINUE
      IF (IPRD .NE. 0) GO TO 130
C
C CONNECT THE LAST POINT WITH THE FIRST POINT OF A PERIODIC LINE
C
      IX = IFIX (XSV1)
      IY = IFIX (YSV1)
      CALL CFVLD (2,IX,IY)
C
C BEGIN THE NEXT LINE SEGMENT WITH THE LAST POINT OF THIS SEGMENT
C
  130 XSAVE(1) = XS
      YSAVE(1) = YS
      N = 1
      IF (IFSTF2 .EQ. 1) CALL CFVLD (3,IDUMMY,IDUMMY)
      GO TO 150
C
C FOR THE CASE WHEN THERE ARE ONLY 2 DISTINCT POINTS ON A LINE.
C
  140 IX = IFIX (XSAVE(1))
      IY = IFIX (YSAVE(1))
      CALL CFVLD (1,IX,IY)
      IX = IFIX (XSAVE(N))
      IY = IFIX (YSAVE(N))
      CALL CFVLD (2,IX,IY)
      IF (IFSTF2 .EQ. 1) CALL CFVLD (3,IDUMMY,IDUMMY)
C
  150 CONTINUE
      RETURN
      END
      SUBROUTINE RESET
C
C  THIS USER ENTRY POINT IS HERE ONLY FOR COMPATIBILITY WITH USE IN
C  THE CONREC FAMILY WHICH CALL RESET WHEN USED WITH DASHSUPR.
C
      RETURN
      END
      SUBROUTINE DASHDC (IPAT,JCRT,JSIZE)
C
C
C
C
C
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C USER ENTRY POINT.
C DASHDC GIVES AN INTERNAL REPRESENTATION TO THE DASH PATTERN WHICH IS
C SPECIFIED IN ITS ARGUMENTS. THIS INTERNAL REPRESENTATION IS PASSED
C TO ROUTINE CFVLD IN THE COMMON-BLOCK DASHD1.
C
      CHARACTER*(*) IPAT
      CHARACTER*1   IBLK, IGAP, ISOL, ICR
      CHARACTER*16  IPC(100)
C
C DASHD1 AND DASHD2 ARE USED
C FOR COMMUNICATION BETWEEN THE ROUTINES DASHDB, DASHDC AND CFVLD.
C ISL, MNCSTR AND IGP ARE INITIALIZED IN DASHBD.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
      COMMON /DASHD2/  IPC
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB AND DASHDC.
C IT IS INITIALIZED IN DASHBD.
C
      COMMON /DDFLAG/ IFCFLG
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C IT IS INITIALIZED IN DASHBD AND REFERENCED IN CFVLD.
C
      COMMON /DCFLAG/ IFSTFL
C
C IFSTF2 CONTROLS THAT THE FRSTD ENTRY IS CALLED IN FDVDLD BEFORE THE
C VECTD ENTRY IS CALLED WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C IT IS INITIALIZED IN DASHBD AND REFERENCED IN FDVDLD.
C
      COMMON /DFFLAG/ IFSTF2
C
C LOCAL VARIABLES TO DASHDB AND DASHDC ARE SAVED IN DSAVE2
C FOR THE NEXT CALL
C
      COMMON /DSAVE2/ MASK, NCHRWD, NBWD, MNCST1
C SAVE ALL VARIABLES
      SAVE
C
C NECESSARY ON SOME MACHINES TO GET BLOCK DATA LOADED
C
C NPD IS THE NUMBER OF WORDS IN IP
C
      DATA NPD/100/
C
C INITIALIZE CHARACTER FLAGS
C
      DATA IBLK,IGAP,ISOL/' ','''','$'/
C
C +NOAO - blockdata replaced with run time initialization.
C     EXTERNAL DASHBD
      call dashbd
C -NOAO
C
C THE FOLLOWING CALL IS FOR LIBRARY STATISTICS GATHERING AT NCAR
      CALL Q8QST4 ('GRAPHX', 'DASHSMTH', 'DASHDC', 'VERSION  1')
C
C     NC IS THE NUMBER OF CHARACTERS IN IPAT
C
      NC = LEN(IPAT)
      IF (IFCFLG .EQ. 2) GOTO 10
C
C CHECK IF THE CONSTANTS IN THE BLOCKDATA DASHBD ARE LOADED CORRECTLY
C
      IF (MNCSTR .EQ. 15) GOTO 6
      CALL SETER('DASHDC -- BLOCKDATA DASHBD APPARRENTLY NOT LOADED CORR
     1ECTLY',1,2)
    6 CONTINUE
C
C INITIALIZATION
C
      MNCST1 = MNCSTR + 1
C
C MASK IS AN ALL SOLID PATTERN TO BE PASSED TO OPTN (65535=177777B).
C
      MASK=IOR(ISHIFT(32767,1),1)
C
C
      IFCFLG = 2
C
C NCHRTS - NUMBER OF CHARS IN THIS HOLLERITH STRING.
C L      - NUMBER OF WORDS IN THE FINAL PATTERN, POINTER TO IP ARRAY.
C ISL    - FLAG FOR ALL SOLID PATTERN (1) OR ALL GAP PATTERN (-1).
C IFSTFL - FLAG TO CONTROL THAT FRSTD IS CALLED IN CFVLD BEFORE VECTD IS
C          CALLED, WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C IFSTF2 - FLAG TO CONTROL THAT FRSTD IS CALLED IN FDVDLD BEFORE VECTD
C          IS CALLED, WHENEVER DASHDB OR DASHDC HAVE BEEN CALLED.
C
   10 CONTINUE
      NCHRTS = 0
      L = 0
      ISL = 0
      IFSTFL = 1
      IFSTF2 = 1
C
C RETRIEVE THE RESOLUTION AS SET BY THE USER.
C
      CALL GETUSV('XF',LXSAVE)
      CALL GETUSV('YF',LYSAVE)
C
C IADJUS - TO ADJUST NUMBERS TO THE GIVEN RESOLUTION.
C
      IADJUS = ISHIFT(1,15-LXSAVE)
      ICRT = JCRT*IADJUS
      ISIZE = JSIZE
      CHARW = FLOAT(ISIZE*IADJUS)
      IF (ISIZE .GT. 3) GO TO 30
      CHARW = 256. + FLOAT(ISIZE)*128.
      IF (ISIZE .EQ. 3) CHARW = 768.
C
   30 CONTINUE
      IF (ICRT .LT. 1) GO TO 230
      MODE = 2
C
C START MAIN LOOP
C
C THIS LOOP GENERATES THE IP ARRAY (NEEDED BY CURVED,VECTD,ETC.) FROM
C THE CHARACTER STRING IN IPAT.  EACH ITERATION OF THE LOOP PROCESSES
C ONE CHAR OF IPAT.  A SOLID OR GAP IS CONSIDERED TO BE A TYPE 1 ENTRY,
C AND A LABEL CHARACTER IS CONSIDERED TO BE A TYPE 2 ENTRY.
C
C IN THE CODE, L IS THE NUMBER OF CHANGES IN THE LINESTYLE (FROM GAP
C TO SOLID, SOLID TO CHARACTER, ETC.)  THE IP AND IPFLAG ARRAYS DESCRIBE
C THE LINE TO BE DRAWN, AND THESE ARRAYS ARE INDEXED FROM 1 TO L.  THE
C RELATIONSHIP BETWEEN IP AND IPFLAG IS:
C
C      IPFLAG(N)    IP(N)
C      ---------    -----
C          1        LENGTH (IN PLOTTER ADDRESS UNITS) OF SOLID LINE TO
C                   BE DRAWN.
C          0        NUMBER OF CHARACTERS TO BE PLOTTED.
C         -1        LENGTH (IN PLOTTER ADDRESS UNITS) OF GAP.
C
C THE 160 LOOP HANDLES 5 CASES:
C
C    1.)  CONTINUE TYPE 2 ENTRY (60-80)
C    2.)  START TYPE 2 ENTRY (80-90)
C    3.)  END TYPE 2 ENTRY AND START TYPE 1 ENTRY (90-160)
C    4.)  START TYPE 1 ENTRY, OR SWITCH TYPE 1 ENTRY FROM SOLID TO
C         GAP OR FROM GAP TO SOLID (140-160)
C    5.)  CONTINUE TYPE 1 ENTRY (150-160)
C
      DO 160 J=1,NC
C
C GET NEXT CHAR INTO ICR, RIGHT JUSTIFIED ZERO FILLED.
C
            ICR = IPAT(J:J)
C
C MODE SPECIFIES WHAT THE LAST CHARACTER PROCESSED WAS:
C
C    LAST ICR WAS $ (SOLID),      MODE IS 8
C    LAST ICR WAS ' (GAP),        MODE IS 2
C    LAST ICR WAS HOLLERITH CHAR, MODE IS 5
C
C NMODE SPECIFIES WHAT THE CURRENT CHARACTER TO BE PROCESSED IS:
C
C      ICR     NMODE
C      ---     -----
C       $        1
C       CHAR     0
C       '       -1
C
            NMODE = 0
            IF (ICR .EQ. IBLK) GO TO 160
            IF (ICR .EQ. IGAP) NMODE = -1
            IF (ICR .EQ. ISOL) NMODE = 1
            IF (L.EQ.0 .AND. NMODE.EQ.-1) MODE = 8
C
C NGO DETERMINES WHERE TO BRANCH BASED ON CASE TO BE PROCESSED.
C COMPUTE MODE FOR NEXT ITERATION.
C
            NGO = NMODE+MODE
            MODE = NMODE*3+5
            GO TO (150,80,140,90,60,90,140,80,150),NGO
C
C CHAR TO CHAR
C
C CASE 1) - CONTINUE TYPE 2 ENTRY.
C
   60      IF (NCHRTS .EQ. MNCSTR) GO TO 160
           NCHRTS = NCHRTS + 1
           IP(L) = NCHRTS
           IPC(L)(NCHRTS:NCHRTS) = ICR
           GO TO 160
C
C BLANK OR SOLID TO CHAR
C
C CASE 2) - START STRING ENTRY.  LGBSTR POINTS TO THE GAP WHICH
C           WILL CONTAIN THE STRING.
C
   80      LGBSTR = MIN0(L+1,NPD)
           L = MIN0(LGBSTR+1,NPD)
           IPFLAG(L) = 0
           NCHRTS    = 1
           IP(L)     = 1
           IPC(L)(NCHRTS:NCHRTS) = ICR
           GO TO 160
C
C CHAR TO SOLID OR GAP
C
C CASE 3) - END STRING ENTRY.  ICR IS A $ OR '.
C
   90      CONTINUE
           IP(LGBSTR) = CHARW*(FLOAT(NCHRTS) + .5)
           IPFLAG(LGBSTR) = -1
           IF (IGP .EQ. 0) IPFLAG(LGBSTR) = 1
C
C BLANK TO SOLID OR SOLID TO BLANK
C
C CASE 4) - START TYPE 1 ENTRY.
C
  140       L = MIN0(L+1,NPD)
            IP(L) = 0
C
C ADD TO A BLANK OR SOLID LINE
C
C CASE 5) - CONTINUE TYPE 1 ENTRY.  ICR IS A $ OR '.
C ADD ICRT UNITS TO THE PLOTTER ADDRESS UNITS IN IP(L).
C NMODE INDICATES IF IT IS A GAP OR A SOLID.
C
  150       IP(L) = IP(L) + ICRT
            IPFLAG(L) = NMODE
  160    CONTINUE
C
C IF LAST ICR PROCESSED WAS A LABEL CHARACTER, MUST END STRING
C ENTRY.
C
      IF (NGO.NE.2 .AND. NGO.NE.5 .AND. NGO.NE.8) GO TO 220
      IP(LGBSTR) = CHARW*(FLOAT(NCHRTS)+.5)
      IPFLAG(LGBSTR) = -1
      IF (IGP .EQ. 0) IPFLAG(LGBSTR) = 1
C
C IF IP ARRAY HAS ONLY ONE TYPE 1 ENTRY, SET ISL FLAG.
C
  220 IF (L .GT. 1) RETURN
      IBIG = ISHIFT(1,MAX0(LXSAVE,LYSAVE))
      IF (IP(L) .GE. IBIG) GO TO 230
      IF (IPFLAG(L)) 240,240,230
  230 ISL = 1
      RETURN
  240 ISL = -1
      RETURN
      END
      SUBROUTINE DASHDB (IPAT)
C
C ARGUMENTS              IPAT
C ON INPUT                 IPAT IS A 16-BIT DASH PATTERN.  BY DEFAULT
C                          EACH BIT IN THE PATTERN REPRESENTS 3 PLOTTER
C                          ADDRESS UNITS (1=SOLID, 0=BLANK)
C
C
C
C USER ENTRY POINT.
C DASHDB GIVES AN INTERNAL REPRESENTATION TO THE DASH PATTERN WHICH IS
C SPECIFIED IN ITS ARGUMENT. THIS INTERNAL REPRESENTATION IS PASSED
C TO ROUTINE CFVLD IN THE COMMON-BLOCK DASHD1.
C
      DIMENSION IPAT(1)
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C DASHD1 IS FOR COMMUNICATION BETWEEN THE ROUTINES DASHDB AND CFVLD.
C ISL, MNCSTR AND IGP ARE INITIALIZED IN DASHBD.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
C
C IFCFLG IS THE FIRST CALL FLAG FOR DASHDB. IT IS INITIALIZED IN DASHBD.
C
      COMMON /DDFLAG/ IFCFLG
C
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB HAS BEEN CALLED. IT IS INITIALIZED IN DASHBD AND
C REFERENCED IN CFVLD.
C
      COMMON /DCFLAG/ IFSTFL
C
C IFSTF2 CONTROLS THAT THE FRSTD ENTRY IS CALLED IN FDVDLD BEFORE THE
C VECTD ENTRY IS CALLED WHENEVER DASHDB OR DASHDC HAS BEEN CALLED. IT IS
C INITIALIZED IN DASHBD AND REFERENCED IN FDVDLD.
C
      COMMON /DFFLAG/ IFSTF2
C
C LOCAL VARIABLES TO DASHDB ARE SAVED IN DSAVE2 FOR THE NEXT CALL TO
C DASHDB.
C
      COMMON /DSAVE2/ MASK, NCHRWD, NBWD, MNCST1
C
C NECESSARY ON SOME MACHINES TO GET BLOCK DATA LOADED
C
      SAVE
C
C +NOAO - blockdata replaced with run time initialization.
C     EXTERNAL DASHBD
      call dashbd
C -NOAO
C
C THE FOLLOWING CALL IS FOR LIBRARY STATISTICS GATHERING AT NCAR
      CALL Q8QST4 ('GRAPHX', 'DASHSMTH', 'DASHDB', 'VERSION  1')
      IF (IFCFLG .EQ. 2) GOTO 10
C
C CHECK IF THE CONSTANTS IN THE BLOCKDATA DASHBD ARE LOADED CORRECTLY
C
      IF (MNCSTR .EQ. 15) GOTO 6
      CALL SETER('DASHDB -- BLOCKDATA DASHBD APPARRENTLY NOT LOADED CORR
     1ECTLY',1,2)
    6 CONTINUE
C
C INITIALIZATION
C
      MNCST1 = MNCSTR + 1
C
C MASK IS AN ALL SOLID PATTERN
C
      MASK=IOR(ISHIFT(32767,1),1)
C
      IFCFLG = 2
C
C L - NUMBER OF WORDS IN THE FINAL PATTERN, POINTER TO IP ARRAY.
C ISL - FLAG FOR ALL SOLID PATTERN (1) OR ALL GAP PATTERN (-1).
C IFSTFL - FLAG TO CONTROL THAT FRSTD IS CALLED IN CFVLD BEFORE VECTD IS
C          CALLED, WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C IFSTF2 - FLAG TO CONTROL THAT FRSTD IS CALLED IN FDVDLD BEFORE VECTD
C          IS CALLED, WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C
   10 CONTINUE
      NCHRTS = 0
      L = 0
      ISL = 0
      IFSTFL = 1
      IFSTF2 = 1
C
      ICRT = IPAU*ISHIFT(1,15-10)
      IF (IPAT(1) .NE. 0) GO TO 260
      ISL = -1
      RETURN
  260 IF (IPAT(1) .NE. MASK) GO TO 270
      ISL = 1
      RETURN
  270 NMODE1 = IAND(ISHIFT(IPAT(1),-15),1)
      DO 290 I = 1,16
      IF (NMODE1 .NE. IAND(ISHIFT(IPAT(1),I-16),1)) GO TO 280
      NMODE1 = 1 - NMODE1
      L = L + 1
      IP(L) = 0
      IPFLAG(L) = 1 - 2*NMODE1
  280 IP(L) = IP(L) + ICRT
  290 CONTINUE
      RETURN
      END
      SUBROUTINE DRAWPV (IX,IY,IND)
C
C DRAWPV INTERCEPTS THE CALL TO PLOTIT TO CHECK IF THE PEN HAS TO BE
C MOVED OR IF IT IS ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
C IF IND=2 NEVER MOVE PEN, JUST UPDATE VARIABLES IXSTOR AND IYSTOR.
C
C IN IXSTOR AND IYSTOR THE CURRENT POSITION OF THE PEN IS SAVED.
C
      COMMON /DSAVE3/ IXSTOR,IYSTOR
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      SAVE
      IIND = IND + 1
      GOTO (100,90,105), IIND
C
   90 CONTINUE
C
C DRAW LINE AND SAVE POSITION OF PEN.
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IXSTOR,IYSTOR,1)
      GOTO 110
C
  100 CONTINUE
C
C CHECK IF PEN IS ALREADY CLOSE ENOUGH TO THE WANTED POSITION.
C
      DIFF = FLOAT(IABS(IXSTOR-IX)+IABS(IYSTOR-IY))
      IF (DIFF .LE. FLOAT(ICLOSE)) GO TO 110
C
      IXSTOR = IX
      IYSTOR = IY
      CALL PLOTIT (IXSTOR,IYSTOR,0)
      GOTO 110
C
  105 CONTINUE
C
C DO NOT MOVE PEN. JUST UPDATE VARIABLES IXSTOR AND IYSTOR.
C
      IXSTOR = IX
      IYSTOR = IY
C
  110 CONTINUE
C
      RETURN
      END
C
      SUBROUTINE CFVLD (IENTRY,IIX,IIY)
C
C CFVLD CONNECTS POINTS WHOSE COORDINATES ARE SUPPLIED IN THE ARGUMENTS,
C ACCORDING TO THE DASH PATTERN WHICH IS PASSED FROM ROUTINE DASHDB
C OR DASHDC IN THE COMMON-BLOCK DASHD1.
C
      CHARACTER*16  IPC(100)
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
C THE VARIABLES IN DASHD1 AND DASHD2 ARE USED FOR COMMUNICATION WITH
C DASHDC AND DASHDB.
C
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
      COMMON /DASHD2/  IPC
C
C THE VARIABLES IN DSAVE1 HAVE TO BE SAVED FOR THE NEXT CALL TO CFVLD.
C
      COMMON /DSAVE1/ X,Y,X2,Y2,X3,Y3,M,BTI,IB,IX,IY
C
C THE FLAGS IFSTFL AND IVCTFG ARE INITIALIZED IN THE BLOCK DATA DASHBD.
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED.
C IVCTFG IS A FLAG TO INDICATE IF CFVLD IS BEING CALLED FROM VECTD OR
C LASTD.
C
      COMMON /DCFLAG/ IFSTFL
      COMMON /CFFLAG/ IVCTFG
      SAVE
C
C
C CMN IS USED TO DETERMINE WHEN TO STOP DRAWING A LINE SEGMENT
C
      DATA CMN/1.5/
C
C IMPOS IS USED AS AN IMPOSSIBLE PEN POSITION.
C
      DATA IMPOS /-9999/
C
C
C  ISL= -1  ALL BLANK  ) FLAG TO AVOID MOST CALCULATIONS
C        0  DASHED     )   IF PATTERN IS ALL SOLID OR
C        1  ALL SOLID  )   ALL BLANK
C
C     X,IX,Y,IY    CURRENT POSITION
C     X1,Y1        START OF A USER LINE SEGMENT
C     X2,Y2        END OF A USER LINE SEGMENT
C     X3,Y3        START OF A GAP PATTERN SEGMENT
C
C  SYMBOLS,IF PRESENT ARE CENTERED IN AN IMMEDIATLY PRECEEDING
C     GAP SEGMENT, OR DONE AT THE CURRENT POSITION OTHERWISE
C
C  SEGMENT TYPES ARE RECOGNIZED AS FOLLOWS
C     SOLID - WORD IN IP-ARRAY CONTAINS POSITIVE INTEGER, CORRESPONDING
C             ELEMENT IN IPFLAG IS 1.
C     GAP - WORD IN IP-ARRAY CONTAINS POSITIVE INTEGER, CORRESPONDING
C             ELEMENT IN IPFLAG IS -1.
C     SYMBOL - WORD IN IP-ARRAY CONTAINS CHARACTER REPRESENTATIONS.
C             CORRESPONDING ELEMENT IN IPFLAG IS 0.
C             SYMBOL COUNT FOR CHAR STRING IN CHAR NUMBER MNCSTR+1.
C     THE IP ARRAY AND THE IPFLAG ARRAY ARE COMPOSED OF L ELEMENTS.
C
C     BTI - BITS THIS INCREMENT
C     BPBX,BPBY BITS PER BIT X(Y)
C
C
C BRANCH DEPENDING ON FUNCTION TO BE PERFORMED.
C
      GO TO (330,305,350),IENTRY
C
C INITIALIZE VARIABLES (ENTRY FRSTD ONLY)
C
   30 CONTINUE
      X = IX
      Y = IY
      X2 = X
      X3 = X
      Y2 = Y
      Y3 = Y
      M = 1
      IB = IPFLAG(1)
      IF (IPFLAG(1) .NE. 0) GO TO 40
      IB = 0
      BTI = 0
   40 CONTINUE
      BTI = FLOAT(IP(1))*FPART
      GO TO 300
C
C MAIN LOOP START
C
   50 CONTINUE
         X1 = X2
         Y1 = Y2
         MX = IIX
         MY = IIY
         X2 = MX
         Y2 = MY
         DX = X2-X1
         DY = Y2-Y1
         D = SQRT(DX*DX+DY*DY)
         IF (D .LT. CMN) GO TO 190
   60    BPBX = DX/D
         BPBY = DY/D
         CALL DRAWPV (IX,IY,0)
   70    BTI = BTI-D
         IF (BTI) 100,100,80
C
C LINE SEGMENT WILL FIT IN CURRENT PATTERN ELEMENT
C
   80    X = X2
         Y = Y2
         IX = X2
         IY = Y2
         IF (IB) 200,160,90
   90    CALL DRAWPV (IX,IY,1)
         GO TO 200
C
C LINE SEGMENT WONT FIT IN CURRENT PATTERN ELEMENT
C DO IT TO END OF ELEMENT, SAVE HOW MUCH OF SEGMENT LEFT TO DO (D)
C
  100    BTI = BTI+D
         D = D-BTI
         X = X+BPBX*BTI
         Y = Y+BPBY*BTI
         IX = X+.5
         IY = Y+.5
         IF (IB) 110,160,120
  110    CALL DRAWPV (IX,IY,0)
         GO TO 130
  120    CALL DRAWPV (IX,IY,1)
C
C GET THE NEXT PATTERN ELEMENT
C
  130    M = MOD(M,L)+1
         IB = IPFLAG(M)
         IF (IB) 140,160,150
  140    X3 = X
         Y3 = Y
         BTI = FLOAT(IP(M))
         GO TO 70
  150    X3 = -1.
         BTI = FLOAT(IP(M))
         GO TO 70
C
C CHARACTER GENERATION
C
  160    S = 0.
         IF (IGP .NE. 9) GO TO 162
C
         DX = X-X3
         DY = Y-Y3
         GO TO 164
C
  162    CONTINUE
         DX = X - X1
         DY = Y - Y1
  164    CONTINUE
C
         IF (DY) 170,180,170
  170    S = ATAN2(DY,DX)
         IF (ABS(S-.00005) .GT. 1.5708) S = S-SIGN(3.14159,S)
  180    IF (IGP .NE. 9) GO TO 182
C
         MX = X3 + DX*.5
         MY = Y3 + DY*.5
         LIGP = 0
         GO TO 184
C
  182    CONTINUE
         MX = X
         MY = Y
         LIGP = 1
C
  184    CONTINUE
         IS = IFIX(S*180./3.14 + .5)
         IF (IS .LT. 0) IS = 360+IS
         CALL GETUSV('XF',LXSAVE)
         CALL GETUSV('YF',LYSAVE)
         MX = ISHIFT (MX,LXSAVE-15)
         MY = ISHIFT(MY,LYSAVE-15)
         CALL WTSTR(CPUX(MX),CPUY(MY),IPC(M)(1:IP(M)),ISIZE,IS,LIGP)
         CALL DRAWPV (IMPOS,IMPOS,2)
         CALL DRAWPV (IX,IY,0)
         GO TO 130
  190    X2 = X1
         Y2 = Y1
  200 CONTINUE
C
C EXIT IF CALL WAS TO VECTD.
C
      IF (IVCTFG .NE. 2) GO TO 210
      IVCTFG = 1
      GO TO 300
C
C EXIT IF NOT PLOTTING A GAP
C
  210 IF (IB .GE. 0) GO TO 300
C
C MUST BE IN A GAP AT END OF LASTD. EXIT IF NOT A LABEL GAP.
C
      MO = M
      M = MOD(M,L) + 1
      IF (IPFLAG(M) .NE. 0) GO TO 300
C
C CHECK PREVIOUS PLOTTED ELEMENT. WAS IT A GAP OR A LINE.
C
      MPREV = M - 2
      IF (MPREV .LE. 0) MPREV = MPREV + L
      IB = IPFLAG(MPREV)
      IF (IB .GE. 0) GO TO 250
C
C PREVIOUS ELEMENT WAS A GAP - LOOK FOR NEXT LINE.
C EXIT IF NO LINES IN PATTERN.
C
  230 CONTINUE
  240 M = MOD(M,L)+1
      IF (M .EQ. MO) GO TO 300
      IB = IPFLAG(M)
      IF (IB .EQ. 0) GOTO 245
      BTI = FLOAT(IP(M))
  245 CONTINUE
C
C IF IP(M) NOT A LINE, CONTINUE LOOKING.
C
      IF (IB) 240,230,280
C
C PREVIOUS ELEMENT WAS A LINE - LOOK FOR NEXT GAP.
C IF NO NON-LABEL GAPS IN PATTERN, GO TO 290.
C
  250 CONTINUE
  260 M = MOD(M,L)+1
      IF (M .EQ. MO) GO TO 290
      IB = IPFLAG(M)
      IF (IB .EQ. 0) GOTO 265
      BTI = FLOAT(IP(M))
  265 CONTINUE
C
C IF IP(M) NOT A GAP, CONTINUE LOOKING.
C
      IF (IB) 270,250,260
C
C FOUND A GAP. IF ITS A LABEL GAP, GO LOOK FOR NEXT GAP.
C
  270 MT = M
      M = MOD(M,L)+1
      IF (IPFLAG(M) .EQ. 0) GO TO 250
      M = MT
C
C M POINTS TO NEXT ELEMENT TO PLOT. SET UP AND GO PLOT.
C
  280 X1 = X3
      Y1 = Y3
      X = X3
      Y = Y3
      IX = X+0.5
      IY = Y+0.5
      DX = X2-X1
      DY = Y2-Y1
      D = SQRT(DX*DX+DY*DY)
      IF (D .GE. CMN) GO TO 60
      GO TO 300
C
C NO NON-LABEL GAPS IN THE PATTERN - FILL IN WITH SOLID LINE.
C
  290 IX = X3+0.5
      IY = Y3+0.5
      CALL DRAWPV (IX,IY,0)
      IX = X2
      IY = Y2
      CALL DRAWPV (IX,IY,1)
  300 RETURN
C
C *************************************
C
C ENTRY VECTD (XX,YY)
C
  305 CONTINUE
C
C TEST FOR PREVIOUS CALL TO FRSTD.
C
      IF (IFSTFL .EQ. 2) GO TO 310
C
C INFORM USER - NO PREVIOUS CALL TO FRSTD. TREAT CALL AS FRSTD CALL.
C
      CALL SETER ('CFVLD -- VECTD CALL OCCURS BEFORE A CALL TO FRSTD.',
     -             1,1)
      GO TO 330
  310 K = 1
      IVCTFG = 2
      IF (ISL) 300,50,320
  320 IX = IIX
      IY = IIY
      CALL DRAWPV (IX,IY,1)
      GO TO 300
C
C *************************************
C
C     ENTRY FRSTD (FLDX,FLDY)
C
  330 IX = IIX
      IY = IIY
      IFSTFL = 2
C AVOID UNEXPECTED PEN POSITION IF CALLS TO SYSTEM PLOT PACKAGE
C ROUTINES WERE MADE.
      CALL DRAWPV (IMPOS,IMPOS,2)
      IF (ISL) 300,30,340
  340 CALL DRAWPV (IX,IY,0)
      GO TO 300
C
C *************************************
C
C     ENTRY LASTD
C
  350 CONTINUE
C
C TEST FOR PREVIOUS CALL TO FRSTD
C
      IF (IFSTFL .NE. 2) GO TO 300
      IFSTFL = 1
      K = 1
      IF (ISL .NE. 0) GO TO 300
      GO TO 210
      END
      SUBROUTINE FRSTD (X,Y)
C USER ENTRY PPINT.
      CALL FL2INT (X,Y,IIX,IIY)
      CALL FDVDLD (1,IIX,IIY)
      RETURN
      END
      SUBROUTINE VECTD (X,Y)
C USER ENTRY POINT.
      CALL FL2INT (X,Y,IIX,IIY)
      CALL FDVDLD (2,IIX,IIY)
      RETURN
      END
      SUBROUTINE LASTD
C USER ENTRY POINT. SEE DOCUMENTATION FOR PURPOSE.
      DATA IDUMMY /0/
      CALL FDVDLD (3,IDUMMY,IDUMMY)
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END
      SUBROUTINE CURVED (X,Y,N)
C USER ENTRY POINT.
C
      DIMENSION X(N),Y(N)
C
      CALL FRSTD (X(1),Y(1))
      DO 10 I=2,N
         CALL VECTD (X(I),Y(I))
   10 CONTINUE
C
      CALL LASTD
C
      RETURN
      END
      SUBROUTINE LINED (XA,YA,XB,YB)
C USER ENTRY POINT.
C
      DATA IDUMMY /0/
      CALL FL2INT (XA,YA,IXA,IYA)
      CALL FL2INT (XB,YB,IXB,IYB)
C
      CALL CFVLD (1,IXA,IYA)
      CALL CFVLD (2,IXB,IYB)
      CALL CFVLD (3,IDUMMY,IDUMMY)
C
      RETURN
C
C------REVISION HISTORY
C
C JUNE 1984          CONVERTED TO FORTRAN77 AND GKS
C
C DECEMBER 1979      ADDED REVISION HISTORY AND STATISTICS
C                    CALL
C
C-----------------------------------------------------------------------
C
      END

      SUBROUTINE TCNSUP	(IERROR)
C
C LATEST REVISION	 JUNE 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 CONRECSUPR AND	TO TEST	CONRECSUPR ON A	SINGLE
C			 PROBLEM
C
C USAGE			 CALL TCNSUP (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   CONRECSUPR TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, TWO FRAMES CONTAINING THE	CONTOUR
C			 PLOT ARE PRODUCED ON THE MACHINE GRAPHICS
C			 DEVICE.  IN ORDER TO DETERMINE	IF THE TEST
C			 WAS SUCCESSFUL, IT IS NECESSARY TO EXAMINE
C			 THESE PLOTS.
C
C PRECISION		 SINGLE
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 THE FUNCTION
C			   Z(X,Y) = X +	Y + 1./((X-.1)**2+Y**2+.09)
C				    -1./((X+.1)**2+Y**2+.09)
C			 FOR X = -1. TO	+1. IN INCREMENTS OF .1	AND
C			     Y = -1.2 TO +1.2 IN INCREMENTS OF .1
C			 IS COMPUTED.
C			 TCNSUP	CALLS SUBROUTINES EZCNTR, CONREC, AND
C			 WTSTR TO DRAW TWO LABELLED CONTOUR PLOTS OF THE
C			 ARRAY Z.
C
C PORTABILITY		 ANSI FORTRAN77
C
C Z CONTAINS THE VALUES	TO BE PLOTTED.
C
      REAL	      Z(21,25)
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE INTEGER COORDINATES RANGE	FROM 0.0 TO 1.0, THE VALUES TX AND TY
C DEFINE THE CENTER OF THE TITLE STRING.
C
      DATA TX/0.4219/, TY/0.9765/
C
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 0
C
C FILL TWO DIMENSIONAL ARRAY TO	BE PLOTTED
C
      DO  20 I=1,21
	 X = .1*FLOAT(I-11)
	 DO  10	J=1,25
	    Y =	.1*FLOAT(J-13)
	    Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1		     1./((X+.10)**2+Y**2+.09)
   10	 CONTINUE
   20 CONTINUE
C
C SELECT NORMALIZATION TRANS NUMBER 0
C
      CALL GSELNT (0)
C
C ENTRY	EZCNTR REQUIRES	ONLY THE ARRAY NAME AND	ITS DIMENSIONS
C
C THE TITLE FOR	THIS PLOT IS
C
C  DEMONSTRATION PLOT FOR EZCNTR ENTRY OF CONRECSUPR
C
      CALL WTSTR (TX,TY,
     1		 'DEMONSTRATION	PLOT FOR EZCNTR	ENTRY OF CONRECSUPR',
     2		 2,0,0)
      CALL EZCNTR (Z,21,25)
C
C
C ENTRY	CONREC ALLOWS USER SPECIFICATION OF PLOT PARAMETERS, IF	DESIRED
C
C IN THIS EXAMPLE, THE LOWEST CONTOUR LEVEL (-4.5), THE	HIGHEST	CONTOUR
C LEVEL	(4.5), AND THE INCREMENT BETWEEN CONTOUR LEVELS	(0.3) ARE
C SPECIFIED.  ALSO THE LABELLING OF THE	HIGHS AND LOWS IS SUPRESSED.
C
C THE TITLE FOR	THIS PLOT IS
C
C  DEMONSTRATION PLOT FOR CONREC ENTRY OF CONRECSUPR
C
      CALL WTSTR (TX,TY,
     1		 'DEMONSTRATION	PLOT FOR CONREC	ENTRY OF CONRECSUPR',
     2		 2,0,0)
      CALL CONREC (Z,21,21,25,-4.5,4.5,.3,0,-1,0)
      CALL NEWFM
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT ('	CONRECSUPR TEST	SUCCESSFUL',24X,
     1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

include	defs

# type - determine type of character

   character function type (c)

   character c

   if ((LETA <= c & c <= LETZ) | (BIGA <= c & c <= BIGZ))
      type = LETTER
   else if (DIG0 <= c & c <= DIG9)
      type = DIGIT
   else
      type = c

   # The original version used a table look-up; you'll have to
   # use that method if you have subverted the convention to
   # use ASCII characters internally:
   # integer index
   # character digits(11), lowalf(27), upalf(27)
   # data digits(1) /DIG0/
   # data digits(2) /DIG1/
   # data digits(3) /DIG2/
   # data digits(4) /DIG3/
   # data digits(5) /DIG4/
   # data digits(6) /DIG5/
   # data digits(7) /DIG6/
   # data digits(8) /DIG7/
   # data digits(9) /DIG8/
   # data digits(10) /DIG9/
   # data digits(11) /EOS/
   #
   # data lowalf(1) /LETA/
   # data lowalf(2) /LETB/
   # data lowalf(3) /LETC/
   # data lowalf(4) /LETD/
   # data lowalf(5) /LETE/
   # data lowalf(6) /LETF/
   # data lowalf(7) /LETG/
   # data lowalf(8) /LETH/
   # data lowalf(9) /LETI/
   # data lowalf(10) /LETJ/
   # data lowalf(11) /LETK/
   # data lowalf(12) /LETL/
   # data lowalf(13) /LETM/
   # data lowalf(14) /LETN/
   # data lowalf(15) /LETO/
   # data lowalf(16) /LETP/
   # data lowalf(17) /LETQ/
   # data lowalf(18) /LETR/
   # data lowalf(19) /LETS/
   # data lowalf(20) /LETT/
   # data lowalf(21) /LETU/
   # data lowalf(22) /LETV/
   # data lowalf(23) /LETW/
   # data lowalf(24) /LETX/
   # data lowalf(25) /LETY/
   # data lowalf(26) /LETZ/
   # data lowalf(27) /EOS/
   #
   # data upalf(1) /BIGA/
   # data upalf(2) /BIGB/
   # data upalf(3) /BIGC/
   # data upalf(4) /BIGD/
   # data upalf(5) /BIGE/
   # data upalf(6) /BIGF/
   # data upalf(7) /BIGG/
   # data upalf(8) /BIGH/
   # data upalf(9) /BIGI/
   # data upalf(10) /BIGJ/
   # data upalf(11) /BIGK/
   # data upalf(12) /BIGL/
   # data upalf(13) /BIGM/
   # data upalf(14) /BIGN/
   # data upalf(15) /BIGO/
   # data upalf(16) /BIGP/
   # data upalf(17) /BIGQ/
   # data upalf(18) /BIGR/
   # data upalf(19) /BIGS/
   # data upalf(20) /BIGT/
   # data upalf(21) /BIGU/
   # data upalf(23) /BIGW/
   # data upalf(24) /BIGX/
   # data upalf(25) /BIGY/
   # data upalf(26) /BIGZ/
   # data upalf(27) /EOS/
   #
   # if (index(lowalf, c) > 0)
   #	    type = LETTER
   # else if (index(upalf,c) >0)
   #	    type = LETTER
   # else if (index(digits,c) > 0)
   #	    type = DIGIT
   # else
   #	    type = c


   return
   end

        subroutine uliber (errcode, pkerrmsg, msglen)

	character*80 pkerrmsg
	integer errcode, msglen
	integer*2 sppmsg(81)
	integer SZLINE
	parameter (SZLINE=80)

c unpack the fortran character string, call fulib to output the string.
c
	call f77upk (pkerrmsg, sppmsg, SZLINE)
	call fulib  (errcode, sppmsg, msglen)

	end

      SUBROUTINE slELUE (DATE, JFORM, EPOCH, ORBINC, ANODE,
     :                      PERIH, AORQ, E, AORL, DM,
     :                      U, JSTAT)
*+
*     - - - - - -
*      E L U E
*     - - - - - -
*
*  Transform conventional osculating orbital elements into "universal"
*  form.
*
*  Given:
*     DATE    d      epoch (TT MJD) of osculation (Note 3)
*     JFORM   i      choice of element set (1-3, Note 6)
*     EPOCH   d      epoch (TT MJD) of the elements
*     ORBINC  d      inclination (radians)
*     ANODE   d      longitude of the ascending node (radians)
*     PERIH   d      longitude or argument of perihelion (radians)
*     AORQ    d      mean distance or perihelion distance (AU)
*     E       d      eccentricity
*     AORL    d      mean anomaly or longitude (radians, JFORM=1,2 only)
*     DM      d      daily motion (radians, JFORM=1 only)
*
*  Returned:
*     U       d(13)  universal orbital elements (Note 1)
*
*               (1)  combined mass (M+m)
*               (2)  total energy of the orbit (alpha)
*               (3)  reference (osculating) epoch (t0)
*             (4-6)  position at reference epoch (r0)
*             (7-9)  velocity at reference epoch (v0)
*              (10)  heliocentric distance at reference epoch
*              (11)  r0.v0
*              (12)  date (t)
*              (13)  universal eccentric anomaly (psi) of date, approx
*
*     JSTAT   i      status:  0 = OK
*                            -1 = illegal JFORM
*                            -2 = illegal E
*                            -3 = illegal AORQ
*                            -4 = illegal DM
*                            -5 = numerical error
*
*  Called:  slUEPV, slPVUE
*
*  Notes
*
*  1  The "universal" elements are those which define the orbit for the
*     purposes of the method of universal variables (see reference).
*     They consist of the combined mass of the two bodies, an epoch,
*     and the position and velocity vectors (arbitrary reference frame)
*     at that epoch.  The parameter set used here includes also various
*     quantities that can, in fact, be derived from the other
*     information.  This approach is taken to avoiding unnecessary
*     computation and loss of accuracy.  The supplementary quantities
*     are (i) alpha, which is proportional to the total energy of the
*     orbit, (ii) the heliocentric distance at epoch, (iii) the
*     outwards component of the velocity at the given epoch, (iv) an
*     estimate of psi, the "universal eccentric anomaly" at a given
*     date and (v) that date.
*
*  2  The companion routine is slUEPV.  This takes the set of numbers
*     that the present routine outputs and uses them to derive the
*     object's position and velocity.  A single prediction requires one
*     call to the present routine followed by one call to slUEPV;
*     for convenience, the two calls are packaged as the routine
*     slPLNE.  Multiple predictions may be made by again calling the
*     present routine once, but then calling slUEPV multiple times,
*     which is faster than multiple calls to slPLNE.
*
*  3  DATE is the epoch of osculation.  It is in the TT timescale
*     (formerly Ephemeris Time, ET) and is a Modified Julian Date
*     (JD-2400000.5).
*
*  4  The supplied orbital elements are with respect to the J2000
*     ecliptic and equinox.  The position and velocity parameters
*     returned in the array U are with respect to the mean equator and
*     equinox of epoch J2000, and are for the perihelion prior to the
*     specified epoch.
*
*  5  The universal elements returned in the array U are in canonical
*     units (solar masses, AU and canonical days).
*
*  6  Three different element-format options are available:
*
*     Option JFORM=1, suitable for the major planets:
*
*     EPOCH  = epoch of elements (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = longitude of perihelion, curly pi (radians)
*     AORQ   = mean distance, a (AU)
*     E      = eccentricity, e (range 0 to <1)
*     AORL   = mean longitude L (radians)
*     DM     = daily motion (radians)
*
*     Option JFORM=2, suitable for minor planets:
*
*     EPOCH  = epoch of elements (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = argument of perihelion, little omega (radians)
*     AORQ   = mean distance, a (AU)
*     E      = eccentricity, e (range 0 to <1)
*     AORL   = mean anomaly M (radians)
*
*     Option JFORM=3, suitable for comets:
*
*     EPOCH  = epoch of perihelion (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = argument of perihelion, little omega (radians)
*     AORQ   = perihelion distance, q (AU)
*     E      = eccentricity, e (range 0 to 10)
*
*  7  Unused elements (DM for JFORM=2, AORL and DM for JFORM=3) are
*     not accessed.
*
*  8  The algorithm was originally adapted from the EPHSLA program of
*     D.H.P.Jones (private communication, 1996).  The method is based
*     on Stumpff's Universal Variables.
*
*  Reference:  Everhart & Pitkin, Am.J.Phys. 51, 712 (1983).
*
*  Last revision:   8 September 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE
      INTEGER JFORM
      DOUBLE PRECISION EPOCH,ORBINC,ANODE,PERIH,AORQ,E,AORL,DM,U(13)
      INTEGER JSTAT

*  Gaussian gravitational constant (exact)
      DOUBLE PRECISION GCON
      PARAMETER (GCON=0.01720209895D0)

*  Sin and cos of J2000 mean obliquity (IAU 1976)
      DOUBLE PRECISION SE,CE
      PARAMETER (SE=0.3977771559319137D0,
     :           CE=0.9174820620691818D0)

      INTEGER J

      DOUBLE PRECISION PHT,ARGPH,Q,W,CM,ALPHA,PHS,SW,CW,SI,CI,SO,CO,
     :                 X,Y,Z,PX,PY,PZ,VX,VY,VZ,DT,FC,FP,PSI,
     :                 UL(13),PV(6)



*  Validate arguments.
      IF (JFORM.LT.1.OR.JFORM.GT.3) THEN
         JSTAT = -1
         GO TO 9999
      END IF
      IF (E.LT.0D0.OR.E.GT.10D0.OR.(E.GE.1D0.AND.JFORM.NE.3)) THEN
         JSTAT = -2
         GO TO 9999
      END IF
      IF (AORQ.LE.0D0) THEN
         JSTAT = -3
         GO TO 9999
      END IF
      IF (JFORM.EQ.1.AND.DM.LE.0D0) THEN
         JSTAT = -4
         GO TO 9999
      END IF

*
*  Transform elements into standard form:
*
*  PHT   = epoch of perihelion passage
*  ARGPH = argument of perihelion (little omega)
*  Q     = perihelion distance (q)
*  CM    = combined mass, M+m (mu)

      IF (JFORM.EQ.1) THEN

*     Major planet.
         PHT = EPOCH-(AORL-PERIH)/DM
         ARGPH = PERIH-ANODE
         Q = AORQ*(1D0-E)
         W = DM/GCON
         CM = W*W*AORQ*AORQ*AORQ

      ELSE IF (JFORM.EQ.2) THEN

*     Minor planet.
         PHT = EPOCH-AORL*SQRT(AORQ*AORQ*AORQ)/GCON
         ARGPH = PERIH
         Q = AORQ*(1D0-E)
         CM = 1D0

      ELSE

*     Comet.
         PHT = EPOCH
         ARGPH = PERIH
         Q = AORQ
         CM = 1D0

      END IF

*  The universal variable alpha.  This is proportional to the total
*  energy of the orbit:  -ve for an ellipse, zero for a parabola,
*  +ve for a hyperbola.

      ALPHA = CM*(E-1D0)/Q

*  Speed at perihelion.

      PHS = SQRT(ALPHA+2D0*CM/Q)

*  In a Cartesian coordinate system which has the x-axis pointing
*  to perihelion and the z-axis normal to the orbit (such that the
*  object orbits counter-clockwise as seen from +ve z), the
*  perihelion position and velocity vectors are:
*
*    position   [Q,0,0]
*    velocity   [0,PHS,0]
*
*  To express the results in J2000 equatorial coordinates we make a
*  series of four rotations of the Cartesian axes:
*
*           axis      Euler angle
*
*     1      z        argument of perihelion (little omega)
*     2      x        inclination (i)
*     3      z        longitude of the ascending node (big omega)
*     4      x        J2000 obliquity (epsilon)
*
*  In each case the rotation is clockwise as seen from the +ve end of
*  the axis concerned.

*  Functions of the Euler angles.
      SW = SIN(ARGPH)
      CW = COS(ARGPH)
      SI = SIN(ORBINC)
      CI = COS(ORBINC)
      SO = SIN(ANODE)
      CO = COS(ANODE)

*  Position at perihelion (AU).
      X = Q*CW
      Y = Q*SW
      Z = Y*SI
      Y = Y*CI
      PX = X*CO-Y*SO
      Y = X*SO+Y*CO
      PY = Y*CE-Z*SE
      PZ = Y*SE+Z*CE

*  Velocity at perihelion (AU per canonical day).
      X = -PHS*SW
      Y = PHS*CW
      Z = Y*SI
      Y = Y*CI
      VX = X*CO-Y*SO
      Y = X*SO+Y*CO
      VY = Y*CE-Z*SE
      VZ = Y*SE+Z*CE

*  Time from perihelion to date (in Canonical Days: a canonical day
*  is 58.1324409... days, defined as 1/GCON).

      DT = (DATE-PHT)*GCON

*  First approximation to the Universal Eccentric Anomaly, PSI,
*  based on the circle (FC) and parabola (FP) values.

      FC = DT/Q
      W = (3D0*DT+SQRT(9D0*DT*DT+8D0*Q*Q*Q))**(1D0/3D0)
      FP = W-2D0*Q/W
      PSI = (1D0-E)*FC+E*FP

*  Assemble local copy of element set.
      UL(1) = CM
      UL(2) = ALPHA
      UL(3) = PHT
      UL(4) = PX
      UL(5) = PY
      UL(6) = PZ
      UL(7) = VX
      UL(8) = VY
      UL(9) = VZ
      UL(10) = Q
      UL(11) = 0D0
      UL(12) = DATE
      UL(13) = PSI

*  Predict position+velocity at epoch of osculation.
      CALL slUEPV(DATE,UL,PV,J)
      IF (J.NE.0) GO TO 9010

*  Convert back to universal elements.
      CALL slPVUE(PV,DATE,CM-1D0,U,J)
      IF (J.NE.0) GO TO 9010

*  OK exit.
      JSTAT = 0
      GO TO 9999

*  Quasi-impossible numerical errors.
 9010 CONTINUE
      JSTAT = -5

 9999 CONTINUE
      END

#-h-  ulstal			  268  local   12/01/80  15:55:09
# ulstal - install lower and upper case versions of symbol
   include  defs

   subroutine ulstal (name, defn)
   character name (ARB), defn (ARB)

   include COMMON_BLOCKS

   call entdef (name, defn, deftbl)
   call upper (name)
   call entdef (name, defn, deftbl)

   return
   end

      SUBROUTINE CONOP2 (IOPT,ISIZE)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT-CHARACTER STRING OF OPTION VALUE
C     ISIZE-  INTEGER INPUT
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
        COMMON /RASINT/ IRASMJ, IRASMN, IRASTX
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
        SAVE
C +NOAO - initialize block data before changing any values
        call conbdn
c -NOAO
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
            OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  SET RESOLUTION OF VIRTUAL GRID
C
      IF (TAG .EQ. 'SS') THEN
C
C  SWITCH = ON SET RESOLUTION OF VIRTUAL GRID
C
            IF (OPT .EQ. 'ON') THEN
              IGRAD = ISIZE
              RETURN
C
C  SWITCH = OFF RESET RESOLUTION TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
              IGRAD = IG
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  NCP OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'NC') THEN
C
C  SWITCH ON GET VALUE FOR NUMBER OF SURROUNDING DATA POINTS TO USE
C
            IF (OPT .EQ. 'ON') THEN
              NCP = ISIZE
              RETURN
C
C  SWITCH OFF SET TO DEFAULT VALUE
C
            ELSEIF (OPT .EQ. 'OF') THEN
              NCP = 4
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  INTENSITY OPTION FOUND GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'IN') THEN
C
C  SWITCH OFF SET DEFAULT VALUES
C
            IF (OPT .EQ. 'OF') THEN
                  IRANMJ = 1
                  IRANMN = 1
                  IRANTX = 1
                  IRASMJ = 1
                  IRASMN = 1
                  IRASTX = 1
                  IRAQMJ = 1
                  IRAQMN = 1
                  IRAQTX = 1
              INMAJ = 1
              INMIN = 1
              INDAT = 1
              INLAB = 1
              RETURN
C
C  SET PLOTTED DATA INTENSITY
C
            ELSEIF (OPT .EQ. 'DA') THEN
              INDAT = ISIZE
              RETURN
C
C SET TITLE AND MESSAGE INTENSITY
C
            ELSEIF (OPT .EQ. 'LA') THEN
              INLAB = ISIZE
                  IRANTX = ISIZE
                  IRASTX = ISIZE
                  IRAQTX = ISIZE
              RETURN
C
C  SET ALL INTENSITIES TO THE SAME VALUE
C
            ELSEIF (OPT .EQ. 'AL') THEN
                  IRANMJ = ISIZE
                  IRANMN = ISIZE
                  IRANTX = ISIZE
                  IRASMJ = ISIZE
                  IRASMN = ISIZE
                  IRASTX = ISIZE
                  IRAQMJ = ISIZE
                  IRAQMN = ISIZE
                  IRAQTX = ISIZE
              INMAJ = ISIZE
                INMIN = ISIZE
              INLAB = ISIZE
              INDAT = ISIZE
              RETURN
C
C  SET MAJOR LINE INTENSITY
C
            ELSEIF (OPT .EQ. 'MA') THEN
                  IRANMJ = ISIZE
                  IRASMJ = ISIZE
                  IRAQMJ = ISIZE
              INMAJ = ISIZE
              RETURN
C
C  SET MINOR LINE INTENSITY
C
            ELSEIF (OPT .EQ. 'MI') THEN
                  IRANMN = ISIZE
                  IRASMN = ISIZE
                  IRAQMN = ISIZE
                INMIN = ISIZE
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  LABEL SIZE OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'LS') THEN
C
C  SWITCH ON GET USER LABEL SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ISIZEL = ISIZE
                RETURN
C
C  SWITCH OFF SET LABEL SIZE TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ISIZEL = 9
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET SIZES OF MINIMUM AND MAXIMUM LABELS
C
      ELSEIF (TAG .EQ. 'SM') THEN
C
C  SWTICH ON GET USERS SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ISIZEM = ISIZE
                RETURN
C
C  SWTICH OFF SET TO DEFAULT VALUE
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ISIZEM = 15
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  SET SIZE OF THE PLOTTED DATA
C
      ELSEIF (TAG .EQ. 'SP') THEN
C
C  SWTICH ON GET USERS SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ISIZEP = ISIZE
                RETURN
C
C  SWTICH OFF SET TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ISIZEP = 8
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  TITLE SIZE SWITCH
C
      ELSEIF (TAG .EQ. 'ST') THEN
C
C  SWITCH ON SET THE TITLE SIZE
C
            IF (OPT .EQ. 'ON') THEN
                ITLSIZ = ISIZE
                RETURN
C
C  SWITCH OFF SET TITLE SIZE TO DEFAULT VALUE
C
            ELSEIF (OPT .EQ. 'OF') THEN
                ITLSIZ = 16
                RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  MINOR LINE COUNT OPTION
C
      ELSEIF (TAG .EQ. 'MI') THEN
C
C  SET MINOR LINE COUNT
C
            IF (OPT .EQ. 'ON') THEN
                MINGAP = ISIZE+1
                RETURN
C
C  SET MINOR LINE COUNT TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                MINGAP = 3
                RETURN
          ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP2 - UNDEFINED OPTION',1,1)
      RETURN
        END

      SUBROUTINE slCLDJ (IY, IM, ID, DJM, J)
*+
*     - - - - -
*      C L D J
*     - - - - -
*
*  Gregorian Calendar to Modified Julian Date
*
*  Given:
*     IY,IM,ID     int    year, month, day in Gregorian calendar
*
*  Returned:
*     DJM          dp     modified Julian Date (JD-2400000.5) for 0 hrs
*     J            int    status:
*                           0 = OK
*                           1 = bad year   (MJD not computed)
*                           2 = bad month  (MJD not computed)
*                           3 = bad day    (MJD computed)
*
*  The year must be -4699 (i.e. 4700BC) or later.
*
*  The algorithm is adapted from Hatcher 1984 (QJRAS 25, 53-55).
*
*  Last revision:   27 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID
      DOUBLE PRECISION DJM
      INTEGER J

*  Month lengths in days
      INTEGER MTAB(12)
      DATA MTAB / 31,28,31,30,31,30,31,31,30,31,30,31 /



*  Preset status.
      J = 0

*  Validate year.
      IF ( IY .LT. -4699 ) THEN
         J = 1
      ELSE

*     Validate month.
         IF ( IM.GE.1 .AND. IM.LE.12 ) THEN

*        Allow for leap year.
            IF ( MOD(IY,4) .EQ. 0 ) THEN
               MTAB(2) = 29
            ELSE
               MTAB(2) = 28
            END IF
            IF ( MOD(IY,100).EQ.0 .AND. MOD(IY,400).NE.0 )
     :         MTAB(2) = 28

*        Validate day.
            IF ( ID.LT.1 .OR. ID.GT.MTAB(IM) ) J=3

*        Modified Julian Date.
            DJM = DBLE ( ( 1461 * ( IY - (12-IM)/10 + 4712 ) ) / 4
     :               + ( 306 * MOD ( IM+9, 12 ) + 5 ) / 10
     :               - ( 3 * ( ( IY - (12-IM)/10 + 4900 ) / 100 ) ) / 4
     :               + ID - 2399904 )

*        Bad month.
         ELSE
            J=2
         END IF

      END IF

      END

chapter xiv, example 1. cubic smoothing spline
c  from  * a practical guide to splines *  by c. de boor
calls  bsplpp(bsplvb), ppvalu(interv), smooth(setupq,chol1d)
c     values from a cubic b-spline are rounded to  n d i g i t	places
c  after the decimal point, then smoothed via  s m o o t h  for
c  various values of the control parameter  s .
      integer i,is,j,l,lsm,ndigit,npoint,ns
      real a(61,4),bcoef(7),break(5),coef(4,4),coefsm(4,60),dely,dy(61)
     *	  ,s(20),scrtch(427),sfp,t(11),tenton,x(61),y(61)
      real ppvalu,smooth
      equivalence (scrtch,coefsm)
      data t /4*0.,1.,3.,4.,4*6./
      data bcoef /3*0.,1.,3*0./
      call bsplpp(t,bcoef,7,4,scrtch,break,coef,l)
      npoint = 61
      read 500,ndigit,ns,(s(i),i=1,ns)
  500 format(2i3/(e10.4))
      print 600,ndigit
  600 format(24h exact values rounded to,i2,21h digits after decimal
     *	     ,7h point./)
      tenton = 10.**ndigit
      dely = .5/tenton
      do 10 i=1,npoint
	 x(i) = .1*float(i-1)
	 y(i) = ppvalu(break,coef,l,4,x(i),0)
	 y(i) = float(int(y(i)*tenton + .5))/tenton
   10	 dy(i) = dely
      do 15 i=1,npoint,5
	 do 15 j=1,4
   15	    a(i,j) = ppvalu(break,coef,l,4,x(i),j-1)
      print 615,(i,(a(i,j),j=1,4),i=1,npoint,5)
  615 format(52h value and derivatives of noisefree function at some
     *	    ,7h points/(i4,4e15.7))
      do 20 is=1,ns
	 sfp = smooth ( x, y, dy, npoint, s(is), scrtch, a )
	 lsm = npoint - 1
	 do 16 i=1,lsm
	    do 16 j=1,4
   16	       coefsm(j,i) = a(i,j)
	 do 18 i=1,npoint,5
	    do 18 j=1,4
   18	       a(i,j) = ppvalu(x,coefsm,lsm,4,x(i),j-1)
   20	 print 620, s(is), sfp, (i,(a(i,j),j=1,4),i=1,npoint,5)
  620 format(15h prescribed s =,e10.3,23h, s(smoothing spline) =,e10.3/
     *	     54h value and derivatives of smoothing spline at corresp.
     *	    ,7h points/(i4,4e15.7))
					stop
      end

C--------------------------------------------------------------------------
        subroutine ftgkey(iunit,keynam,value,comm,status)

C       Read value and comment of a header keyword from the keyword buffer

C       iunit   i  Fortran I/O unit number
C       keynam  c  name of keyword to be read
C       OUTPUT PARAMETERS:
C       value   c  output value of the keyword, if any
C       comm    c  output comment string, if any, of the keyword
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June, 1991

        integer iunit,status
        character*(*) keynam,value,comm
        character*80 keybuf

        call ftgcrd(iunit,keynam,keybuf,status)
        if (status .le. 0)then
C               parse the record to find value and comment strings
                call ftpsvc(keybuf,value,comm,status)
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftgtcl(iunit,colnum,datcod,repeat,width,status)

C       get the datatype of the column, as well as the vector
C       repeat count and (if it is an ASCII character column) the
C       width of a unit string within the column.  This supports the
C       TFORMn = 'rAw' syntax for specifying arrays of substrings.


C       iunit   i  Fortran i/o unit number
C       colnum  i  number of the column (first column = 1)

C       datcod  i  returned datatype code
C       repeat  i  number of elements in the vector column
C       width   i  width of unit string in character columns
C       status  i  returned error status
C
C       written by Wm Pence, HEASARC/GSFC, November 1994

        integer iunit,colnum,datcod,repeat,width,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS------------------------------------

        integer ibuff,dummy
        character keywrd*8,tform*24,comm*20

        if (status .gt. 0)return

C       construct the keyword name
        call ftkeyn('TFORM',colnum,keywrd,status)

C       get the keyword value
        call ftgkys(iunit,keywrd,tform,comm,status)
        if (status .gt. 0)then
            call ftpmsg('Could not read the '//keywrd//' keyword.')
            return
        end if

C       parse the keyword value
        ibuff=bufnum(iunit)
        if (hdutyp(ibuff) .eq. 1)then
C           this is an ASCII table
            repeat=1
            call ftasfm(tform,datcod,width,dummy,status)

        else if (hdutyp(ibuff) .eq. 2)then
C           this is a binary table
            call ftbnfm(tform,datcod,repeat,width,status)

        else
C           error: this HDU is not a table
            status=235
            return
        end if
        end

C----------------------------------------------------------------------
        subroutine ftgext(iunit,extno,xtend,status)

C       'Get Extension'
C       move i/o pointer to another extension (or the primary HDU) and
C       initialize all the common block parameters which describe the
C       extension

C       iunit   i  fortran unit number
C       extno   i  number of the extension to point to.
C       xtend   i  type of extension:   0 = the primary HDU
C                                       1 = an ASCII table
C                                       2 = a binary table
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1991

        integer iunit,extno,xtend,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,xchdu,xhdend,xmaxhd

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       move to the beginning of the desired extension
        call ftmbyt(iunit,hdstrt(ibuff,extno),.false.,status)
        if (status .le. 0)then

C               temporarily save parameters
                xchdu=chdu(ibuff)
                xmaxhd=maxhdu(ibuff)
                xhdend=hdend(ibuff)

C               initialize various parameters about the CHDU
                chdu(ibuff)=extno
                maxhdu(ibuff)=max(extno,maxhdu(ibuff))
C               the location of the END record is currently unknown, so 
C               temporarily just set it to a very large number
                hdend(ibuff)=2000000000

C               determine the structure of the CHDU
                call ftrhdu(iunit,xtend,status)
                if (status .gt. 0)then
C                       couldn't read the extension so restore previous state
                        chdu(ibuff)= xchdu
                        maxhdu(ibuff)=xmaxhd
                        hdend(ibuff)= xhdend
                end if
        end if
        end

C----------------------------------------------------------------------
        subroutine fts2c(in,cval,lenval,status)
C       convert an input string to a left justified quoted string
C               The minimum length FITS string is 8 characters, so
C               pad the quoted string with spaces if necessary.
C       cval = returned quoted string
C       lenval = length of the cval string, including the 2 quote characters
        character*(*) in,cval
        integer length,i,j,i1,i2,lenval,status

        if (status .gt. 0)return

        i1=1
        i2=1
C       test for blank input string
        if (in .eq. ' ')then
                cval='''        '''
                lenval=10
                return
        end if

        length=len(in)
C       find first and last non-blank characters

C       modified 29 Nov 1994 to treat leading spaces as significant
C        do 5 i=1,length
C                i1=i
C                if (in(i:i) .ne. ' ')go to 10
C5       continue
C10      continue

        do 15 i=length,1,-1
                i2=i
                if (in(i:i) .ne. ' ')go to 20
15      continue
20      continue

        cval=''''//in(i1:i2)

C       test if there are any single quotes in the string;  if so, replace
C       them with two successive single quotes
        lenval=i2-i1+2
        do 30 i=lenval,2,-1
                if (cval(i:i) .eq. '''')then
C                  shift all the characters over 1 space
                   do 40 j=len(cval),i+1,-1
                      cval(j:j)=cval(j-1:j-1)
40                 continue
                   i2=i2+1
                end if
30      continue

C       find location of closing quote
        lenval=max(10,i2-i1+3)  
        lenval=min(lenval,len(cval))
        cval(lenval:lenval)=''''
        end

include defs

# OUTDWE -- (outdon with error checking).
# Called by code generation routines to output a line of code,
# possibly followed by an error checking instruction.


subroutine outdwe

	call outdon
	call errgo
end

      SUBROUTINE slAFIN (STRING, IPTR, A, J)
*+
*     - - - - -
*      A F I N
*     - - - - -
*
*  Sexagesimal character string to angle (single precision)
*
*  Given:
*     STRING  c*(*)   string containing deg, arcmin, arcsec fields
*     IPTR      i     pointer to start of decode (1st = 1)
*
*  Returned:
*     IPTR      i     advanced past the decoded angle
*     A         r     angle in radians
*     J         i     status:  0 = OK
*                             +1 = default, A unchanged
*                             -1 = bad degrees      )
*                             -2 = bad arcminutes   )  (note 3)
*                             -3 = bad arcseconds   )
*
*  Example:
*
*    argument    before                           after
*
*    STRING      '-57 17 44.806  12 34 56.7'      unchanged
*    IPTR        1                                16 (points to 12...)
*    A           ?                                -1.00000
*    J           ?                                0
*
*    A further call to slAFIN, without adjustment of IPTR, will
*    decode the second angle, 12deg 34min 56.7sec.
*
*  Notes:
*
*     1)  The first three "fields" in STRING are degrees, arcminutes,
*         arcseconds, separated by spaces or commas.  The degrees field
*         may be signed, but not the others.  The decoding is carried
*         out by the DFLTIN routine and is free-format.
*
*     2)  Successive fields may be absent, defaulting to zero.  For
*         zero status, the only combinations allowed are degrees alone,
*         degrees and arcminutes, and all three fields present.  If all
*         three fields are omitted, a status of +1 is returned and A is
*         unchanged.  In all other cases A is changed.
*
*     3)  Range checking:
*
*           The degrees field is not range checked.  However, it is
*           expected to be integral unless the other two fields are
*           absent.
*
*           The arcminutes field is expected to be 0-59, and integral if
*           the arcseconds field is present.  If the arcseconds field
*           is absent, the arcminutes is expected to be 0-59.9999...
*
*           The arcseconds field is expected to be 0-59.9999...
*
*     4)  Decoding continues even when a check has failed.  Under these
*         circumstances the field takes the supplied value, defaulting
*         to zero, and the result A is computed and returned.
*
*     5)  Further fields after the three expected ones are not treated
*         as an error.  The pointer IPTR is left in the correct state
*         for further decoding with the present routine or with DFLTIN
*         etc.  See the example, above.
*
*     6)  If STRING contains hours, minutes, seconds instead of degrees
*         etc, or if the required units are turns (or days) instead of
*         radians, the result A should be multiplied as follows:
*
*           for        to obtain    multiply
*           STRING     A in         A by
*
*           d ' "      radians      1       =  1.0
*           d ' "      turns        1/2pi   =  0.1591549430918953358
*           h m s      radians      15      =  15.0
*           h m s      days         15/2pi  =  2.3873241463784300365
*
*  Called:  slDAFN
*
*  P.T.Wallace   Starlink   13 September 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER IPTR
      REAL A
      INTEGER J

      DOUBLE PRECISION AD



*  Call the double precision version
      CALL slDAFN(STRING,IPTR,AD,J)
      IF (J.LE.0) A=REAL(AD)

      END

      subroutine bndacc (g,mdg,nb,ip,ir,mt,jt)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   sequential algorithm for banded least squares problem..
c	   accumulation phase.	    for solution phase use bndsol.
c
c     the calling program must set ir=1 and ip=1 before the first call
c     to bndacc for a new case.
c
c     the second subscript of g( ) must be dimensioned at least
c     nb+1 in the calling program.
      dimension g(mdg,1)
      zero=0.
c
c	       alg. steps 1-4 are performed external to this subroutine.
c
      nbp1=nb+1
      if (mt.le.0) return
c					      alg. step 5
      if (jt.eq.ip) go to 70
c					      alg. steps 6-7
      if (jt.le.ir) go to 30
c					      alg. steps 8-9
      do 10 i=1,mt
	ig1=jt+mt-i
	ig2=ir+mt-i
	do 10 j=1,nbp1
   10	g(ig1,j)=g(ig2,j)
c					      alg. step 10
      ie=jt-ir
      do 20 i=1,ie
	ig=ir+i-1
	do 20 j=1,nbp1
   20	g(ig,j)=zero
c					      alg. step 11
      ir=jt
c					      alg. step 12
   30 mu=min0(nb-1,ir-ip-1)
      if (mu.eq.0) go to 60
c					      alg. step 13
      do 50 l=1,mu
c					      alg. step 14
	k=min0(l,jt-ip)
c					      alg. step 15
	lp1=l+1
	ig=ip+l
	do 40 i=lp1,nb
	  jg=i-k
   40	  g(ig,jg)=g(ig,i)
c					      alg. step 16
	do 50 i=1,k
	jg=nbp1-i
   50	g(ig,jg)=zero
c					      alg. step 17
   60 ip=jt
c					      alg. steps 18-19
   70 mh=ir+mt-ip
      kh=min0(nbp1,mh)
c					      alg. step 20
      do 80 i=1,kh
   80	call h12 (1,i,max0(i+1,ir-ip+1),mh,g(ip,i),1,rho,
     1		  g(ip,i+1),1,mdg,nbp1-i)
c					      alg. step 21
      ir=ip+kh
c					      alg. step 22
      if (kh.lt.nbp1) go to 100
c					      alg. step 23
      do 90 i=1,nb
   90	g(ir-1,i)=zero
c					      alg. step 24
  100 continue
c					      alg. step 25
      return
      end

      SUBROUTINE slDMAT (N, A, Y, D, JF, IW)
*+
*     - - - - -
*      D M A T
*     - - - - -
*
*  Matrix inversion & solution of simultaneous equations
*  (double precision)
*
*  For the set of n simultaneous equations in n unknowns:
*     A.Y = X
*
*  where:
*     A is a non-singular N x N matrix
*     Y is the vector of N unknowns
*     X is the known vector
*
*  DMATRX computes:
*     the inverse of matrix A
*     the determinant of matrix A
*     the vector of N unknowns
*
*  Arguments:
*
*     symbol  type   dimension           before              after
*
*       N      i                    no. of unknowns       unchanged
*       A      d      (N,N)             matrix             inverse
*       Y      d       (N)            known vector      solution vector
*       D      d                           -             determinant
*     * JF     i                           -           singularity flag
*       IW     i       (N)                 -              workspace
*
*  * JF is the singularity flag.  If the matrix is non-singular, JF=0
*    is returned.  If the matrix is singular, JF=-1 & D=0D0 are
*    returned.  In the latter case, the contents of array A on return
*    are undefined.
*
*  Algorithm:
*     Gaussian elimination with partial pivoting.
*
*  Speed:
*     Very fast.
*
*  Accuracy:
*     Fairly accurate - errors 1 to 4 times those of routines optimized
*     for accuracy.
*
*  P.T.Wallace   Starlink   4 December 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER N
      DOUBLE PRECISION A(N,N),Y(N),D
      INTEGER JF
      INTEGER IW(N)

      DOUBLE PRECISION SFA
      PARAMETER (SFA=1D-20)

      INTEGER K,IMX,I,J,NP1MK,KI
      DOUBLE PRECISION AMX,T,AKK,YK,AIK


      JF=0
      D=1D0
      DO K=1,N
         AMX=DABS(A(K,K))
         IMX=K
         IF (K.NE.N) THEN
            DO I=K+1,N
               T=DABS(A(I,K))
               IF (T.GT.AMX) THEN
                  AMX=T
                  IMX=I
               END IF
            END DO
         END IF
         IF (AMX.LT.SFA) THEN
            JF=-1
         ELSE
            IF (IMX.NE.K) THEN
               DO J=1,N
                  T=A(K,J)
                  A(K,J)=A(IMX,J)
                  A(IMX,J)=T
               END DO
               T=Y(K)
               Y(K)=Y(IMX)
               Y(IMX)=T
               D=-D
            END IF
            IW(K)=IMX
            AKK=A(K,K)
            D=D*AKK
            IF (DABS(D).LT.SFA) THEN
               JF=-1
            ELSE
               AKK=1D0/AKK
               A(K,K)=AKK
               DO J=1,N
                  IF (J.NE.K) A(K,J)=A(K,J)*AKK
               END DO
               YK=Y(K)*AKK
               Y(K)=YK
               DO I=1,N
                  AIK=A(I,K)
                  IF (I.NE.K) THEN
                     DO J=1,N
                        IF (J.NE.K) A(I,J)=A(I,J)-AIK*A(K,J)
                     END DO
                     Y(I)=Y(I)-AIK*YK
                  END IF
               END DO
               DO I=1,N
                  IF (I.NE.K) A(I,K)=-A(I,K)*AKK
               END DO
            END IF
         END IF
      END DO
      IF (JF.NE.0) THEN
         D=0D0
      ELSE
         DO K=1,N
            NP1MK=N+1-K
            KI=IW(NP1MK)
            IF (NP1MK.NE.KI) THEN
               DO I=1,N
                  T=A(I,NP1MK)
                  A(I,NP1MK)=A(I,KI)
                  A(I,KI)=T
               END DO
            END IF
         END DO
      END IF

      END

      integer function ctoc (from, to, len)
      integer len
      integer from (100), to (len)
      integer i
      i = 1
23000 if (.not.(i .lt. len .and. from (i) .ne. -2))goto 23002
      to (i) = from (i)
23001 i = i + 1
      goto 23000
23002 continue
      to (i) = -2
      ctoc=(i - 1)
      return
      end

#-h-  cascod			 1876  local   12/01/80  15:53:46
# cascod - generate code for case or default label
   include  defs

   subroutine cascod (lab, token)
   integer lab, token

   include COMMON_BLOCKS

   integer t, l, lb, ub, i, j, junk
   integer caslab, labgen, gnbtok

   character tok (MAXTOK)

   if (swtop <= 0) {
      call synerr ("illegal case or default.")
      return
      }
   call indent (-1)
   call outgo (lab + 1) # terminate previous case
   xfer = YES
   l = labgen (1)
   if (token == LEXCASE) { # case n[,n]... : ...
      while (caslab (lb, t) != EOF) {
	 ub = lb
	 if (t == MINUS)
	    junk = caslab (ub, t)
	 if (lb > ub) {
	    call synerr ("illegal range in case label.")
	    ub = lb
	    }
	 if (swlast + 3 > MAXSWITCH)
	    call baderr ("switch table overflow.")
	 for (i = swtop + 3; i < swlast; i = i + 3)
	    if (lb <= swstak (i))
	       break
	    else if (lb <= swstak (i+1))
	       call synerr ("duplicate case label.")
	 if (i < swlast & ub >= swstak (i))
	    call synerr ("duplicate case label.")
	 for (j = swlast; j > i; j = j - 1)   # insert new entry
	    swstak (j+2) = swstak (j-1)
	 swstak (i) = lb
	 swstak (i + 1) = ub
	 swstak (i + 2) = l
	 swstak (swtop + 1) = swstak (swtop + 1)  +  1
	 swlast = swlast + 3
	 if (t == COLON)
	    break
	 else if (t != COMMA)
	    call synerr ("illegal case syntax.")
	 }
      }
   else {   # default : ...
      t = gnbtok (tok, MAXTOK)
      if (swstak (swtop + 2) != 0)
	 call error ("multiple defaults in switch statement.")
      else
	 swstak (swtop + 2) = l
      }

   if (t == EOF)
      call synerr ("unexpected EOF.")
   else if (t != COLON)
      call error ("missing colon in case or default label.")

   xfer = NO
   call outcon (l)
   call indent (1)
   return
   end

      DOUBLE PRECISION FUNCTION slDTT (UTC)
*+
*     - - - -
*      D T T
*     - - - -
*
*  Increment to be applied to Coordinated Universal Time UTC to give
*  Terrestrial Time TT (formerly Ephemeris Time ET)
*
*  (double precision)
*
*  Given:
*     UTC      d      UTC date as a modified JD (JD-2400000.5)
*
*  Result:  TT-UTC in seconds
*
*  Notes:
*
*  1  The UTC is specified to be a date rather than a time to indicate
*     that care needs to be taken not to specify an instant which lies
*     within a leap second.  Though in most cases UTC can include the
*     fractional part, correct behaviour on the day of a leap second
*     can only be guaranteed up to the end of the second 23:59:59.
*
*  2  Pre 1972 January 1 a fixed value of 10 + ET-TAI is returned.
*
*  3  See also the routine slDT, which roughly estimates ET-UT for
*     historical epochs.
*
*  Called:  slDAT
*
*  P.T.Wallace   Starlink   6 December 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION UTC

      DOUBLE PRECISION slDAT


      slDTT=32.184D0+slDAT(UTC)

      END

      subroutine hfti (a,mda,m,n,b,mdb,nb,tau,krank,rnorm,h,g,ip)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   solve least squares problem using algorithm, hfti.
c
      dimension a(mda,n),b(mdb,nb),h(n),g(n),rnorm(nb)
      integer ip(n)
      double precision sm,dzero
      szero=0.
      dzero=0.d0
      factor=0.001
c
      k=0
      ldiag=min0(m,n)
      if (ldiag.le.0) go to 270
	  do 80 j=1,ldiag
	  if (j.eq.1) go to 20
c
c     update squared column lengths and find lmax
c    ..
	  lmax=j
	      do 10 l=j,n
	      h(l)=h(l)-a(j-1,l)**2
	      if (h(l).gt.h(lmax)) lmax=l
   10	      continue
	  if(diff(hmax+factor*h(lmax),hmax)) 20,20,50
c
c     compute squared column lengths and find lmax
c    ..
   20	  lmax=j
	      do 40 l=j,n
	      h(l)=0.
		  do 30 i=j,m
   30		  h(l)=h(l)+a(i,l)**2
	      if (h(l).gt.h(lmax)) lmax=l
   40	      continue
	  hmax=h(lmax)
c    ..
c     lmax has been determined
c
c     do column interchanges if needed.
c    ..
   50	  continue
	  ip(j)=lmax
	  if (ip(j).eq.j) go to 70
	      do 60 i=1,m
	      tmp=a(i,j)
	      a(i,j)=a(i,lmax)
   60	      a(i,lmax)=tmp
	  h(lmax)=h(j)
c
c     compute the j-th transformation and apply it to a and b.
c    ..
   70	  call h12 (1,j,j+1,m,a(1,j),1,h(j),a(1,j+1),1,mda,n-j)
   80	  call h12 (2,j,j+1,m,a(1,j),1,h(j),b,1,mdb,nb)
c
c     determine the pseudorank, k, using the tolerance, tau.
c    ..
	  do 90 j=1,ldiag
	  if (abs(a(j,j)).le.tau) go to 100
   90	  continue
      k=ldiag
      go to 110
  100 k=j-1
  110 kp1=k+1
c
c     compute the norms of the residual vectors.
c
      if (nb.le.0) go to 140
	  do 130 jb=1,nb
	  tmp=szero
	  if (kp1.gt.m) go to 130
	      do 120 i=kp1,m
  120	      tmp=tmp+b(i,jb)**2
  130	  rnorm(jb)=sqrt(tmp)
  140 continue
c					    special for pseudorank = 0
      if (k.gt.0) go to 160
      if (nb.le.0) go to 270
	  do 150 jb=1,nb
	      do 150 i=1,n
  150	      b(i,jb)=szero
      go to 270
c
c     if the pseudorank is less than n compute householder
c     decomposition of first k rows.
c    ..
  160 if (k.eq.n) go to 180
	  do 170 ii=1,k
	  i=kp1-ii
  170	  call h12 (1,i,kp1,n,a(i,1),mda,g(i),a,mda,1,i-1)
  180 continue
c
c
      if (nb.le.0) go to 270
	  do 260 jb=1,nb
c
c     solve the k by k triangular system.
c    ..
	      do 210 l=1,k
	      sm=dzero
	      i=kp1-l
	      if (i.eq.k) go to 200
	      ip1=i+1
		  do 190 j=ip1,k
  190		  sm=sm+a(i,j)*dble(b(j,jb))
  200	      sm1=sm
  210	      b(i,jb)=(b(i,jb)-sm1)/a(i,i)
c
c     complete computation of solution vector.
c    ..
	  if (k.eq.n) go to 240
	      do 220 j=kp1,n
  220	      b(j,jb)=szero
	      do 230 i=1,k
  230	      call h12 (2,i,kp1,n,a(i,1),mda,g(i),b(1,jb),1,mdb,1)
c
c      re-order the solution vector to compensate for the
c      column interchanges.
c    ..
  240	      do 250 jj=1,ldiag
	      j=ldiag+1-jj
	      if (ip(j).eq.j) go to 250
	      l=ip(j)
	      tmp=b(l,jb)
	      b(l,jb)=b(j,jb)
	      b(j,jb)=tmp
  250	      continue
  260	  continue
c    ..
c     the solution vectors, x, are now
c     in the first  n  rows of the array b(,).
c
  270 krank=k
      return
      end

include	defs

# stlu --- symbol table lookup primitive

   integer function stlu (symbol, node, pred, st)
   character symbol (ARB)
   pointer node, pred, st

   DS_COMMON

   integer hash, i, j, nodsiz

   nodsiz = Mem (st)

   hash = 0
   for (i = 1; symbol (i) != EOS; i = i + 1)
      hash = hash + symbol (i)
   hash = mod (hash, ST_HTABSIZE) + 1

   pred = st + hash
   node = Mem (pred)
   while (node != LAMBDA) {
      i = 1
      j = node + ST_DATA + nodsiz
      while (symbol (i) == Mem (j)) {
	 if (symbol (i) == EOS)
	    return (YES)
	 i = i + 1
	 j = j + 1
	 }
      pred = node
      node = Mem (pred + ST_LINK)
      }

   return (NO)
   end

C--------------------------------------------------------------------------
        subroutine ftrdef(ounit,status)

C       ReDEFine the structure of a data unit.  This routine re-reads
C       the CHDU header keywords to determine the structure and length of the
C       current data unit.  This redefines the start of the next HDU.
C
C       ounit   i  Fortran I/O unit number
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Oct 1993

        integer ounit,status
      
C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,dummy

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

C       see if we have write access to this file (no need to go on, if not)
        if (wrmode(ibuff))then
C           rewrite the header END card, and following blank fill
            call ftwend(ounit,status)
            if (status .gt. 0)return
 
C           now re-read the required keywords to determine the structure
            call ftrhdu(ounit,dummy,status)
        end if
        end

      SUBROUTINE slTPVC (XI, ETA, V, V01, V02, N)
*+
*     - - - - - -
*      T P V C
*     - - - - - -
*
*  Given the tangent-plane coordinates of a star and its direction
*  cosines, determine the direction cosines of the tangent-point.
*
*  (single precision)
*
*  Given:
*     XI,ETA    r       tangent plane coordinates of star
*     V         r(3)    direction cosines of star
*
*  Returned:
*     V01       r(3)    direction cosines of tangent point, solution 1
*     V02       r(3)    direction cosines of tangent point, solution 2
*     N         i       number of solutions:
*                         0 = no solutions returned (note 2)
*                         1 = only the first solution is useful (note 3)
*                         2 = both solutions are useful (note 3)
*
*  Notes:
*
*  1  The vector V must be of unit length or the result will be wrong.
*
*  2  Cases where there is no solution can only arise near the poles.
*     For example, it is clearly impossible for a star at the pole
*     itself to have a non-zero XI value, and hence it is meaningless
*     to ask where the tangent point would have to be.
*
*  3  Also near the poles, cases can arise where there are two useful
*     solutions.  The argument N indicates whether the second of the
*     two solutions returned is useful.  N=1 indicates only one useful
*     solution, the usual case;  under these circumstances, the second
*     solution can be regarded as valid if the vector V02 is interpreted
*     as the "over-the-pole" case.
*
*  4  This routine is the Cartesian equivalent of the routine slTPSC.
*
*  P.T.Wallace   Starlink   5 June 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL XI,ETA,V(3),V01(3),V02(3)
      INTEGER N

      REAL X,Y,Z,RXY2,XI2,ETA2P1,SDF,R2,R,C


      X=V(1)
      Y=V(2)
      Z=V(3)
      RXY2=X*X+Y*Y
      XI2=XI*XI
      ETA2P1=ETA*ETA+1.0
      SDF=Z*SQRT(XI2+ETA2P1)
      R2=RXY2*ETA2P1-Z*Z*XI2
      IF (R2.GT.0.0) THEN
         R=SQRT(R2)
         C=(SDF*ETA+R)/(ETA2P1*SQRT(RXY2*(R2+XI2)))
         V01(1)=C*(X*R+Y*XI)
         V01(2)=C*(Y*R-X*XI)
         V01(3)=(SDF-ETA*R)/ETA2P1
         R=-R
         C=(SDF*ETA+R)/(ETA2P1*SQRT(RXY2*(R2+XI2)))
         V02(1)=C*(X*R+Y*XI)
         V02(2)=C*(Y*R-X*XI)
         V02(3)=(SDF-ETA*R)/ETA2P1
         IF (ABS(SDF).LT.1.0) THEN
            N=1
         ELSE
            N=2
         END IF
      ELSE
         N=0
      END IF

      END

      SUBROUTINE slDTFR (IHOUR, IMIN, SEC, RAD, J)
*+
*     - - - - - -
*      D T F R
*     - - - - - -
*
*  Convert hours, minutes, seconds to radians (double precision)
*
*  Given:
*     IHOUR       int       hours
*     IMIN        int       minutes
*     SEC         dp        seconds
*
*  Returned:
*     RAD         dp        angle in radians
*     J           int       status:  0 = OK
*                                    1 = IHOUR outside range 0-23
*                                    2 = IMIN outside range 0-59
*                                    3 = SEC outside range 0-59.999...
*
*  Called:
*     slDTFD
*
*  Notes:
*
*     1)  The result is computed even if any of the range checks fail.
*
*     2)  The sign must be dealt with outside this routine.
*
*  P.T.Wallace   Starlink   July 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IHOUR,IMIN
      DOUBLE PRECISION SEC,RAD
      INTEGER J

      DOUBLE PRECISION TURNS

*  Turns to radians
      DOUBLE PRECISION T2R
      PARAMETER (T2R=6.283185307179586476925287D0)



*  Convert to turns then radians
      CALL slDTFD(IHOUR,IMIN,SEC,TURNS,J)
      RAD=T2R*TURNS

      END

C--------------------------------------------------------------------------
        subroutine ftplsw(ounit,status)

C       Put Long String Warning:
C       write the LONGSTRN keyword and a few COMMENT keywords to the header 
C       (if they don't already exist) to warn users that this FITS file
C       may use the OGIP long string convention.

C       This subroutine should be called whenever FTPKLS is called.

        integer ounit,status,tstat
        character value*8,comm*8

        if (status .gt. 0)return

        tstat=status
        call ftgkys(ounit,'LONGSTRN',value,comm,status)
        if (status .eq. 0)then
C             The keyword already exists so just exit
              return
         end if

         status=tstat
         call ftpkys(ounit,'LONGSTRN','OGIP 1.0',
     &   'The OGIP Long String Convention may be used.',status)

         call ftpcom(ounit,
     & 'This FITS file may contain long string keyword values that are'
     &  ,status)
           call ftpcom(ounit,
     & 'continued over multiple keywords.  The OGIP convention uses the'
     &  //' &',status)
            call ftpcom(ounit,
     & 'character at the end of each substring which is then continued'       
     &  ,status)
            call ftpcom(ounit,
     & 'on the next keyword which has the name CONTINUE.'
     &  ,status)
        end                

include	defs

# index - find character  c  in string	str

   integer function index (str, c)
   character str (ARB), c

   for (index = 1; str (index) != EOS; index = index + 1)
      if (str (index) == c)
	 return

   index = 0
   return
   end

      SUBROUTINE slALAZ (HA, DEC, PHI,
     :                      AZ, AZD, AZDD, EL, ELD, ELDD, PA, PAD, PADD)
*+
*     - - - - - -
*      A L A Z
*     - - - - - -
*
*  Positions, velocities and accelerations for an altazimuth
*  telescope mount.
*
*  (double precision)
*
*  Given:
*     HA      d     hour angle
*     DEC     d     declination
*     PHI     d     observatory latitude
*
*  Returned:
*     AZ      d     azimuth
*     AZD     d        "    velocity
*     AZDD    d        "    acceleration
*     EL      d     elevation
*     ELD     d         "     velocity
*     ELDD    d         "     acceleration
*     PA      d     parallactic angle
*     PAD     d         "      "   velocity
*     PADD    d         "      "   acceleration
*
*  Notes:
*
*  1)  Natural units are used throughout.  HA, DEC, PHI, AZ, EL
*      and ZD are in radians.  The velocities and accelerations
*      assume constant declination and constant rate of change of
*      hour angle (as for tracking a star);  the units of AZD, ELD
*      and PAD are radians per radian of HA, while the units of AZDD,
*      ELDD and PADD are radians per radian of HA squared.  To
*      convert into practical degree- and second-based units:
*
*        angles * 360/2pi -> degrees
*        velocities * (2pi/86400)*(360/2pi) -> degree/sec
*        accelerations * ((2pi/86400)**2)*(360/2pi) -> degree/sec/sec
*
*      Note that the seconds here are sidereal rather than SI.  One
*      sidereal second is about 0.99727 SI seconds.
*
*      The velocity and acceleration factors assume the sidereal
*      tracking case.  Their respective numerical values are (exactly)
*      1/240 and (approximately) 1/3300236.9.
*
*  2)  Azimuth is returned in the range 0-2pi;  north is zero,
*      and east is +pi/2.  Elevation and parallactic angle are
*      returned in the range +/-pi.  Parallactic angle is +ve for
*      a star west of the meridian and is the angle NP-star-zenith.
*
*  3)  The latitude is geodetic as opposed to geocentric.  The
*      hour angle and declination are topocentric.  Refraction and
*      deficiencies in the telescope mounting are ignored.  The
*      purpose of the routine is to give the general form of the
*      quantities.  The details of a real telescope could profoundly
*      change the results, especially close to the zenith.
*
*  4)  No range checking of arguments is carried out.
*
*  5)  In applications which involve many such calculations, rather
*      than calling the present routine it will be more efficient to
*      use inline code, having previously computed fixed terms such
*      as sine and cosine of latitude, and (for tracking a star)
*      sine and cosine of declination.
*
*  This revision:  29 October 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION HA,DEC,PHI,AZ,AZD,AZDD,EL,ELD,ELDD,PA,PAD,PADD

      DOUBLE PRECISION DPI,D2PI,TINY
      PARAMETER (DPI=3.1415926535897932384626433832795D0,
     :           D2PI=6.283185307179586476925286766559D0,
     :           TINY=1D-30)

      DOUBLE PRECISION SH,CH,SD,CD,SP,CP,CHCD,SDCP,X,Y,Z,RSQ,R,A,E,C,S,
     :                 Q,QD,AD,ED,EDR,ADD,EDD,QDD


*  Useful functions
      SH=SIN(HA)
      CH=COS(HA)
      SD=SIN(DEC)
      CD=COS(DEC)
      SP=SIN(PHI)
      CP=COS(PHI)
      CHCD=CH*CD
      SDCP=SD*CP
      X=-CHCD*SP+SDCP
      Y=-SH*CD
      Z=CHCD*CP+SD*SP
      RSQ=X*X+Y*Y
      R=SQRT(RSQ)

*  Azimuth and elevation
      IF (RSQ.EQ.0D0) THEN
         A=0D0
      ELSE
         A=ATAN2(Y,X)
      END IF
      IF (A.LT.0D0) A=A+D2PI
      E=ATAN2(Z,R)

*  Parallactic angle
      C=CD*SP-CH*SDCP
      S=SH*CP
      IF (C*C+S*S.GT.0) THEN
         Q=ATAN2(S,C)
      ELSE
         Q=DPI-HA
      END IF

*  Velocities and accelerations (clamped at zenith/nadir)
      IF (RSQ.LT.TINY) THEN
         RSQ=TINY
         R=SQRT(RSQ)
      END IF
      QD=-X*CP/RSQ
      AD=SP+Z*QD
      ED=CP*Y/R
      EDR=ED/R
      ADD=EDR*(Z*SP+(2D0-RSQ)*QD)
      EDD=-R*QD*AD
      QDD=EDR*(SP+2D0*Z*QD)

*  Results
      AZ=A
      AZD=AD
      AZDD=ADD
      EL=E
      ELD=ED
      ELDD=EDD
      PA=Q
      PAD=QD
      PADD=QDD

      END

include	defs

# docant
#
# Similar to cant(name), however precede the messge with the name
# of the program that was running when the file could not be
# opened.  Helpful in a pipeline to verify which program was not
# able to open a file.
#
   subroutine  docant(name)

   character  name(ARB), prog(FILENAMESIZE)
   integer    length
   integer    getarg

   length = getarg(0, prog, FILENAMESIZE)
   if (length != EOF) {
      call putlin(prog, STDERR)
      call putch(COLON, STDERR)
      call putch(BLANK, STDERR)
   }
   call cant(name)

   return
   end

      SUBROUTINE slDSTP (RA, DEC, RAZ, DECZ, XI, ETA, J)
*+
*     - - - - - -
*      D S T P
*     - - - - - -
*
*  Projection of spherical coordinates onto tangent plane:
*  "gnomonic" projection - "standard coordinates" (double precision)
*
*  Given:
*     RA,DEC      dp   spherical coordinates of point to be projected
*     RAZ,DECZ    dp   spherical coordinates of tangent point
*
*  Returned:
*     XI,ETA      dp   rectangular coordinates on tangent plane
*     J           int  status:   0 = OK, star on tangent plane
*                                1 = error, star too far from axis
*                                2 = error, antistar on tangent plane
*                                3 = error, antistar too far from axis
*
*  P.T.Wallace   Starlink   18 July 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RA,DEC,RAZ,DECZ,XI,ETA
      INTEGER J

      DOUBLE PRECISION SDECZ,SDEC,CDECZ,CDEC,
     :                 RADIF,SRADIF,CRADIF,DENOM

      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-6)


*  Trig functions
      SDECZ=SIN(DECZ)
      SDEC=SIN(DEC)
      CDECZ=COS(DECZ)
      CDEC=COS(DEC)
      RADIF=RA-RAZ
      SRADIF=SIN(RADIF)
      CRADIF=COS(RADIF)

*  Reciprocal of star vector length to tangent plane
      DENOM=SDEC*SDECZ+CDEC*CDECZ*CRADIF

*  Handle vectors too far from axis
      IF (DENOM.GT.TINY) THEN
         J=0
      ELSE IF (DENOM.GE.0D0) THEN
         J=1
         DENOM=TINY
      ELSE IF (DENOM.GT.-TINY) THEN
         J=2
         DENOM=-TINY
      ELSE
         J=3
      END IF

*  Compute tangent plane coordinates (even in dubious cases)
      XI=CDEC*SRADIF/DENOM
      ETA=(SDEC*CDECZ-CDEC*SDECZ*CRADIF)/DENOM

      END

      integer function push (ep, argstk, ap)
      integer ap, argstk (100), ep
      if (.not.(ap .gt. 100))goto 23000
      call baderr (19Harg stack overflow.)
23000 continue
      argstk (ap) = ep
      push = ap + 1
      return
      end

      integer function makpat (arg, from, delim, pat)
      integer arg (128), delim, pat (128)
      integer from
      integer esc
      integer i, j, junk, lastcl, lastj, lj, tagnst, tagnum, tagstk (9)
      integer addset, getccl, stclos
      j = 1
      lastj = 1
      lastcl = 0
      tagnum = 0
      tagnst = 0
      i = from
23000 if (.not.(arg (i) .ne. delim .and. arg (i) .ne. -2))goto 23002
      lj = j
      if (.not.(arg (i) .eq. 63))goto 23003
      junk = addset (63, pat, j, 128)
      goto 23004
23003 continue
      if (.not.(arg (i) .eq. 37 .and. i .eq. from))goto 23005
      junk = addset (37, pat, j, 128)
      goto 23006
23005 continue
      if (.not.(arg (i) .eq. 36 .and. arg (i + 1) .eq. delim))goto 23007
      junk = addset (36, pat, j, 128)
      goto 23008
23007 continue
      if (.not.(arg (i) .eq. 91))goto 23009
      if (.not.(getccl (arg, i, pat, j) .eq. -3))goto 23011
      makpat = -3
      return
23011 continue
      goto 23010
23009 continue
      if (.not.(arg (i) .eq. 42 .and. i .gt. from))goto 23013
      lj = lastj
      if (.not.(pat (lj) .eq. 37 .or. pat (lj) .eq. 36 .or. pat (lj) .eq
     *. 42 .or. pat (lj) .eq. 123 .or. pat (lj) .eq. 125))goto 23015
      goto 23002
23015 continue
      lastcl = stclos (pat, j, lastj, lastcl)
      goto 23014
23013 continue
      if (.not.(arg (i) .eq. 123))goto 23017
      if (.not.(tagnum .ge. 9))goto 23019
      goto 23002
23019 continue
      tagnum = tagnum + 1
      tagnst = tagnst + 1
      tagstk (tagnst) = tagnum
      junk = addset (123, pat, j, 128)
      junk = addset (tagnum, pat, j, 128)
      goto 23018
23017 continue
      if (.not.(arg (i) .eq. 125 .and. tagnst .gt. 0))goto 23021
      junk = addset (125, pat, j, 128)
      junk = addset (tagstk (tagnst), pat, j, 128)
      tagnst = tagnst - 1
      goto 23022
23021 continue
      junk = addset (97, pat, j, 128)
      junk = addset (esc (arg, i), pat, j, 128)
23022 continue
23018 continue
23014 continue
23010 continue
23008 continue
23006 continue
23004 continue
      lastj = lj
23001 i = i + 1
      goto 23000
23002 continue
      if (.not.(arg (i) .ne. delim))goto 23023
      makpat = -3
      goto 23024
23023 continue
      if (.not.(addset (-2, pat, j, 128) .eq. 0))goto 23025
      makpat = -3
      goto 23026
23025 continue
      if (.not.(tagnst .ne. 0))goto 23027
      makpat = -3
      goto 23028
23027 continue
      makpat = i
23028 continue
23026 continue
23024 continue
      return
      end

c PLANCK -- Compute the Planck blackbody radiation distribution for a
c given temperature and wavelength region.
c
c       usage:  planck temperature lambda1 lambda2
c
c The temperature is specified in degrees Kelvin and the wavelength
c region in microns (1u=10000A).  100 [x,y] data points defining the
c curve are output.
c ----------------------------------------------------------------------

        program planck

	character*80	errmsg
        integer         nargs, ier, i
        real            w1, w2, dw, cm, t
        real            xv(100), yv(100)

c --- Get the temperature in degrees kelvin.
        call clargr (1, t, ier)
        if (ier .ne. 0) then
            write (*, '('' temperature (degrees kelvin): '',$)')
            read (*,*) t
        endif

c --- Get the wavelength region to be computed.
        call clnarg (nargs)
        if (nargs .ge. 3) then
            call clargr (2, w1, ier)
            if (ier .ne. 0) goto 91
            call clargr (3, w2, ier)
            if (ier .ne. 0) goto 91
        else
            write (*, '('' start wavelength (microns): '',$)')
            read (*,*) w1
            write (*, '('' end wavelength (microns): '',$)')
            read (*,*) w2
        endif

c --- Compute the blackbody curve.
        dw = (w2 - w1) / 99.0
        do 10 i = 1, 100
            xv(i) = ((i-1) * dw) + w1
            cm = xv(i) * 1.0E-4
            yv(i) = (3.74185E-5 * (cm ** -5)) /
     *          (2.71828 ** (1.43883 / (cm * t)) - 1.0)
 10	continue

c --- Print the curve as a table.
        do 20 i = 1, 100
	    write (*, '(1x, f7.4, g12.4)') xv(i), yv(i)
 20	continue

	stop

c --- Error exit. 
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg
	stop
	end

      SUBROUTINE TISOHR	(IERROR)
C
C LATEST REVISION	 JULY 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 THE  ISOSRFHR	PACKAGE
C
C USAGE			 CALL TISOHR (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   =0 IF THERE IS A NORMAL EXIT	FROM THE
C			      ISOSRFHR	ROUTINES
C			   =1 OTHERWISE
C
C I/O			 THIS ROUTINE REQUIRES UNIT IUNIT FOR SCRATCH
C			 PURPOSES.  USERS SHOULD PUT THE UNITS LABELLED
C			 COMMON	(SEE BELOW) IN THE CALLING PROGRAM,
C			 AND ALSO SET THE VALUE	OF THE COMMON VARIABLE
C			 IUNIT IN THE CALLING PROGRAM.
C
C			 IF THERE IS A NORMAL EXIT FROM	THE
C			 ISOSRFHR  ROUTINES THE	MESSAGE
C			   ISOSRFHR TEST SUCCESSFUL . .	. SEE PLOT TO
C			   VERIFY PERFORMANCE
C			 IS PRINTED.
C
C			 ALSO, A SAMPLE	PLOT IS
C			 PRODUCED ON THE MACHINE GRAPHICS
C			 DEVICE.  ONE MUST EXAMINE THIS	PLOT
C			 TO DETERMINE IF THE ROUTINES HAVE
C			 EXECUTED CORRECTLY.
C
C COMMON BLOCKS		 UNITS
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 ISOSRFHR
C FILES
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 THIS SUBROUTINE USES THE ROUTINES IN
C			 THE PACKAGE  ISOSRFHR	TO DRAW	A PERSPECTIVE
C			 DRAWING OF TWO	INTERLOCKING DOUGHNUTS
C
C PORTABILITY		 ANSI STANDARD
C
C
      DIMENSION	      EYE(3)	 ,S(4)	     ,IS2(4,200) ,
     1		      ST1(81,51,2)	     ,IOBJS(81,51)
      COMMON /UNITS/  IUNIT
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE INTEGER COORDINATES RANGE	FROM 1 TO 1024,	THE VALUES IX AND IY
C DEFINE THE CENTER OF THE TITLE STRING.
C
      DATA IX/448/, IY/990/
C
C
C     DEFINE THE EYE POSITION
C
      DATA	      EYE(1), EYE(2), EYE(3) / 200., 250., 250.	/
C
C     DEFINE THE OVERALL DIMENSION OF THE BOX CONTAINING THE OBJECTS
C
      DATA	      NU, NV, NW /  51,	81, 51 /
C
C     SPECIFY THE DIMENSIONS OF	THE MODEL OF THE IMAGE PLANE
C
      DATA	      LX, NX, NY / 4, 180, 180 /
C
C     SPECIFY  CRT  COORDINATES	OF THE AREA WHERE THE PICTURE
C     IS TO BE DRAWN
C
      DATA	      S(1),S(2),S(3),S(4)/ 10.,1010.,10.,1010./
      DATA	      MV / 81 /
C
C     SPECIFY THE LARGE	AND SMALL RADII	FOR THE	INDIVIDUAL DOUGHNUTS
C
      DATA	      RBIG1,RBIG2,RSML1,RSML2/ 20., 20., 6., 6.	/
C
      SAVE
C
C     CALL THE INITIALIZATION ROUTINE
C
      CALL INIT3D (EYE,NU,NV,NW,ST1,LX,NY,IS2,IUNIT,S)
C
C     INITIALIZE THE ERRROR FLAG
C
      IERROR = 1
C
C     CREATE AND PLOT DATA FOR TWO INTERLOCKING	DOUGHNUTS
C
      JCENT1 = FLOAT(NV)*.5-RBIG1*.5
      JCENT2 = FLOAT(NV)*.5+RBIG2*.5
      DO  70 IBKWDS=1,NU
	 I = NU+1-IBKWDS
C
C     CREATE THE I-TH CROSS SECTION IN THE U DIRECTION OF THE
C     THREE-DIMENSIONAL	ARRAY AND STORE	IN  IOBJS  AS ZEROS AND	ONES
C
	 FIMID = I-NU/2
	 DO  20	J=1,NV
	    FJMID1 = J-JCENT1
	    FJMID2 = J-JCENT2
	    DO	10 K=1,NW
	       FKMID = K-NW/2
	       F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
	       F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
	       FIP1 = (1.-F1)*FIMID
	       FIP2 = (1.-F2)*FIMID
	       FJP1 = (1.-F1)*FJMID1
	       FJP2 = (1.-F2)*FJMID2
	       FKP1 = (1.-F1)*FKMID
	       FKP2 = (1.-F2)*FKMID
	       TEMP = AMIN1(FIMID**2+FJP1**2+FKP1**2-RSML1**2,
     1				      FKMID**2+FIP2**2+FJP2**2-RSML2**2)
	       IF (TEMP	.LE. 0.) IOBJS(J,K) = 1
	       IF (TEMP	.GT. 0.) IOBJS(J,K) = 0
   10	    CONTINUE
   20	 CONTINUE
C
C     SET PROPER WORDS TO  1  FOR DRAWING AXES
C
	 IF (I .NE. 1) GO TO  50
	 DO  30	K=1,NW
	    IOBJS(1,K) = 1
   30	 CONTINUE
	 DO  40	J=1,NV
	    IOBJS(J,1) = 1
   40	 CONTINUE
	 GO TO	60
   50	 CONTINUE
	 IOBJS(1,1) = 1
   60	 CONTINUE
C
C     CALL THE DRAW AND	REMEMBER ROUTINE FOR THIS SLAB
C
	 CALL DANDR (NV,NW,ST1,LX,NX,NY,IS2,IUNIT,S,IOBJS,MV)
   70 CONTINUE
C
C    TITLE THE PLOT
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      XC = PAU2FX(IX)
      YC = PAU2FY(IY)
      CALL WTSTR(XC,YC,'DEMONSTRATION PLOT FOR ISOSRFHR',2,0,0)
      CALL GSELNT(ICN)
C
C     ADVANCE THE PLOTTING DEVICE
C
c     CALL NEWFM
C
      IERROR = 0
c     WRITE (6,1001)
      RETURN
C
c1001 FORMAT ('	  ISOSRFHR TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

      subroutine difequ ( mode, xx, v )
c  from  * a practical guide to splines *  by c. de boor
calls  ppvalu(interv)
c  to be called by   c o l l o c ,  p u t i t
c  information about the differential equation is dispensed from here
c
c******  i n p u t  ******
c  mode  an integer indicating the task to be performed.
c	 = 1   initialization
c	 = 2   evaluate  de  at  xx
c	 = 3   specify the next side condition
c	 = 4   analyze the approximation
c  xx a point at which information is wanted
c
c******  o u t p u t  ******
c  v  depends on the  mode  . see comments below
c
c     parameter npiece=100,ncoef=2000
      integer mode,   i,iside,itermx,k,kpm,l,m
      real v(20),xx,   break,coef,eps,ep1,ep2,error,factor,rho,solutn
     *		      ,s2ovep,un,x,xside
      real ppvalu
c     common /approx/ break(npiece),coef(ncoef),l,kpm
      common /approx/ break(100),coef(2000),l,kpm
      common /side/ m,iside,xside(10)
      common /other/ itermx,k,rho(19)
c
c  this sample of  difequ  is for the example in chapter xv. it is a
c  nonlinear second order two point boundary value problem.
c
					go to (10,20,30,40),mode
c  initialize everything
c  i.e. set the order  m  of the dif.equ., the nondecreasing sequence
c  xside(i),i=1,...,m, of points at which side cond.s are given and
c  anything else necessary.
   10 m = 2
      xside(1) = 0.
      xside(2) = 1.
c  *** print out heading
      print 499
  499 format(37h carrier,s nonlinear perturb. problem)
      eps = .5e-2
      print 610, eps
  610 format(5h eps ,e20.10)
c  *** set constants used in formula for solution below.
      factor = (sqrt(2.) + sqrt(3.))**2
      s2ovep = sqrt(2./eps)
c  *** initial guess for newton iteration. un(x) = x*x - 1.
      l = 1
      break(1) = 0.
      do 16 i=1,kpm
   16	 coef(i) = 0.
      coef(1) = -1.
      coef(3) = 2.
      itermx = 10
					return
c
c  provide value of left side coeff.s and right side at  xx .
c  specifically, at  xx  the dif.equ. reads
c	 v(m+1)d**m + v(m)d**(m-1) + ... + v(1)d**0  =	v(m+2)
c  in terms of the quantities v(i),i=1,...,m+2, to be computed here.
   20 continue
      v(3) = eps
      v(2) = 0.
      un = ppvalu(break,coef,l,kpm,xx,0)
      v(1) = 2.*un
      v(4) = un**2 + 1.
					return
c
c  provide the	m  side conditions. these conditions are of the form
c	 v(m+1)d**m + v(m)d**(m-1) + ... + v(1)d**0  =	v(m+2)
c  in terms of the quantities v(i),i=1,...,m+2, to be specified here.
c  note that v(m+1) = 0  for customary side conditions.
   30 v(m+1) = 0.
					go to (31,32,39),iside
   31 v(2) = 1.
      v(1) = 0.
      v(4) = 0.
					go to 38
   32 v(2) = 0.
      v(1) = 1.
      v(4) = 0.
   38 iside = iside + 1
   39					return
c
c  calculate the error near the boundary layer at  1.
   40 continue
      print 640
  640 format(44h x, g(x)  and  g(x)-f(x)  at selected points)
      x = .75
      do 41 i=1,9
	 ep1 = exp(s2ovep*(1.-x))*factor
	 ep2 = exp(s2ovep*(1.+x))*factor
	 solutn = 12./(1.+ep1)**2*ep1 + 12./(1.+ep2)**2*ep2 - 1.
	 error = solutn - ppvalu(break,coef,l,kpm,x,0)
	 print 641,x,solutn,error
  641	 format(3e20.10)
   41	 x = x + .03125
					return
      end

      SUBROUTINE slDTPS (XI, ETA, RAZ, DECZ, RA, DEC)
*+
*     - - - - - -
*      D T P S
*     - - - - - -
*
*  Transform tangent plane coordinates into spherical
*  (double precision)
*
*  Given:
*     XI,ETA      dp   tangent plane rectangular coordinates
*     RAZ,DECZ    dp   spherical coordinates of tangent point
*
*  Returned:
*     RA,DEC      dp   spherical coordinates (0-2pi,+/-pi/2)
*
*  Called:        slDA2P
*
*  P.T.Wallace   Starlink   24 July 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION XI,ETA,RAZ,DECZ,RA,DEC

      DOUBLE PRECISION slDA2P

      DOUBLE PRECISION SDECZ,CDECZ,DENOM



      SDECZ=SIN(DECZ)
      CDECZ=COS(DECZ)

      DENOM=CDECZ-ETA*SDECZ

      RA=slDA2P(ATAN2(XI,DENOM)+RAZ)
      DEC=ATAN2(SDECZ+ETA*CDECZ,SQRT(XI*XI+DENOM*DENOM))

      END

      SUBROUTINE TSUPMA	(IERROR)
C
C LATEST REVISION	 AUGUST	1984
C
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF THE
C			 SUPMAP	AND MAPDRW ENTRYS OF EZMAPG.
C
C USAGE			 CALL TSUPMA (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			 = 0 IF	THE TEST WAS SUCCESSFUL
C			 = 1 OTHERWISE
C
C I/O			 IF EACH CALL TO ROUTINE SUPMAP	RESULTS	IN
C			 A NORMAL SUPMAP EXIT, THE MESSAGE
C			   SUPMAP TEST SUCCESSFUL  . .	SEE PLOT TO
C			   VERIFY PERFORMANCE
C			 IS PRINTED ON UNIT 6.
C
C			 TEN CONTINENTAL OUTLINE PLOTS,	EACH
C			 RESULTING FROM	A DIFFERENT SPECIFIED
C			 PROJECTION, ARE PRODUCED ON THE MACHINE
C			 GRAPHICS DEVICE.
C			 TO DETERMINE IF THE TEST WAS SUCCESSFUL,
C			 IT IS NECESSARY TO EXAMINE THESE PLOTS.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 EZMAPG
C FILES
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 SUBROUTINE TSUPMA CALLS ROUTINE SUPMAP	ONCE
C			 FOR EACH OF THE NINE PROJECTION TYPES
C			 IN SUPMAP.  SPECIFICALLY, THESE ARE
C			   STEREOGRAPHIC
C			   ORTHOGRAPHIC
C			   LAMBERT CONFORMAL CONIC WITH	TWO
C			     STANDARD PARALLELS
C			   LAMBERT EQUAL AREA
C			   GNOMONIC
C			   AZIMUTHAL EQUIDISTANT
C			   CYLINDRICAL EQUIDISTANT
C			   MERCATOR
C			   MOLLWEIDE TYPE
C			 THE ROUTINE THEN DEMONSTRATES THE SATELLITE VIEW
C			 PROJECTION.
C
C HISTORY		 WRITTEN OCTOBER, 1976
C
C PORTABILITY		 ANSI FORTRAN 77
C
C
C COMMON BLOCK FOR SATELLITE VIEW PROJECTION
C
      COMMON /SATMAP/ SL
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT PLOTTER GRID
C WHERE	THE  COORDINATES RANGE FROM 0.0	TO 1.0,	THE VALUES TX
C AND TY DEFINE	THE CENTER OF THE TITLE	STRING.
C
      DATA TX/0.5/, TY/0.9765/
C
C INITIALIZE ERROR FLAG
C
      IERROR = 0
C
C CHECK	PERFORMANCE CRITERION
C SPECIFY PARAMETERS BEFORE EACH SUPMAP	CALL
C
      IPROJ = 1
      POLAT = 80.
      POLONG = -160.
      ROT = 0.
      PL1 = 0.
      PL2 = 0.
      PL3 = 0.
      PL4 = 0.
      JLTS = 1
      JGRID = 10
      IUSOUT = -1
      IDOT = 0
C
C SELECT NORMALIZATION TRANS 0 TO WRITE	TITLE
C
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	STEREOGRAPHIC PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO 10
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   10 CONTINUE
C
C
      IPROJ = 2
      POLAT = 60.
      POLONG = -120.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	ORTHOGRAPHIC PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO  20
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   20 CONTINUE
C
C
      IPROJ = -3
      POLAT = 45.
      POLONG = -100.
      ROT = 45.
      PL1 = 50.
      PL2 = -130.
      PL3 = 20.
      PL4 = -75.
      JLTS = 2
      JGRID = 10
      IUSOUT = 1
      IDOT = 0
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1	      'SUPMAP DEMONSTRATION: LAMBERT CONFORMAL CONIC PROJECTION'
     2	      ,2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO  30
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   30 CONTINUE
C
C
      IPROJ = 4
      POLAT = 20.
      POLONG = -40.
      ROT = 0.
      PL1 = 0.
      PL2 = 0.
      PL3 = 0.
      PL4 = 0.
      JLTS = 1
      JGRID = 10
      IUSOUT = 0
      IDOT = 0
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		'SUPMAP	DEMONSTRATION: LAMBERT EQUAL AREA PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO  40
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   40 CONTINUE
C
C
      IPROJ = 5
      POLAT = 0.
      POLONG = 0.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	GNOMONIC PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO  50
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   50 CONTINUE
C
C
      IPROJ = 6
      POLAT = -20.
      POLONG = 40.
      JGRID = 5
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1	     'SUPMAP DEMONSTRATION: AZIMUTHAL EQUIDISTANT PROJECTION',
     2	      2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO  60
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   60 CONTINUE
C
C
      IPROJ = 8
      POLAT = -40.
      POLONG = 80.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1	   'SUPMAP DEMONSTRATION: CYLINDRICAL EQUIDISTANT PROJECTION'
     2	   ,2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO  70
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   70 CONTINUE
C
C
      IPROJ = 9
      POLAT = -60.
      POLONG = 120.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	MERCATOR PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO  80
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   80 CONTINUE
C
C
      IPROJ = 10
      POLAT = -80.
      POLONG = 160.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	MOLLWEIDE TYPE PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
      CALL FRAME
      IF (IER .EQ. 0) GO TO 90
C
C SUPMAP TEST UNSUCCESSFUL
C
      WRITE (6,1001) IPROJ
      IERROR = 1
   90 CONTINUE
C
C DEMONSTRATION	OF SATELLITE VIEW PROJECTION
C
      SL = 6.5
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'EZMAPG DEMONSTRATION:	SATELLITE VIEW PROJECTION',
     2		 2,0,0)
      CALL MAPROJ('OR',0.0,-135.0,0.0)
      CALL MAPSET('MA',0.0,0.0,0.0,0.0)
      CALL MAPDRW
      CALL FRAME
C
C
      IF (IERROR .EQ. 0) WRITE (6,1002)
      IF (IERROR .EQ. 1) WRITE (6,1003)
      RETURN
C
C
 1001 FORMAT ('	SUPMAP RETURNED	ERROR FLAG','	IPROJ=',I4/)
 1002 FORMAT('	   SUPMAP TEST SUCCESSFUL',24X,
     1	     'SEE PLOT TO VERIFY PERFORMANCE')
 1003 FORMAT ('	    SUPMAP TEST	UNSUCCESSFUL')
C
      END

include	defs

# catsub --- add replacement text to end of  new

   subroutine catsub (lin, from, to, sub, new, k, maxnew)

   character	lin(MAXLINE)
   integer	from(10), to(10)
   integer	maxnew
   character	sub(maxnew), new(MAXPAT)
   integer	k

   integer	i, j, junk, ri
   integer	addset

   for (i = 1; sub (i) != EOS; i = i + 1)
      if (sub (i) == DITTO) {
	 i = i + 1
	 ri = sub (i) + 1
	 for (j = from (ri); j < to (ri); j = j + 1)
	    junk = addset (lin (j), new, k, maxnew)
	 }
      else
	 junk = addset (sub (i), new, k, maxnew)

   return
   end

#-h-  putbak			  254  local   12/01/80  15:54:34
# putbak - push character back onto input
   include  defs

   subroutine putbak (c)
   character c

   include COMMON_BLOCKS

   if (bp <= 1)
      call baderr ("too many characters pushed back.")
   else {
      bp = bp - 1
      buf (bp) = c
      }

   return
   end

C----------------------------------------------------------------------
        subroutine ftpclm(ounit,colnum,frow,felem,nelem,array,status)

C       write an array of double precision complex data values to the 
C       specified column of the table.  
C       The binary table column being written to must have datatype 'M'
C       and no datatype conversion will be perform if it is not.

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       array   dcmp  array of data values to be written 
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status
C       array is really double precison complex
        double precision array(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        double precision buffer(100)
        integer bytpix,bstart,tcode
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart,maxpix
        double precision scale,zero
        logical descrp,scaled
        character crow*9,cp1*9,cp2*9,ccol*4

        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &          'request is out of range:'//crow//' (FTPCLM).')
                return
        end if

        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)

        i1=1
C       multiply by 2, because the complex data type has pairs of values
        ntodo=nelem*2
        rstart=frow-1
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
        if (scale .eq. 1. .and. zero .eq. 0.)then
                scaled=.false.
        else
                scaled=.true.
        end if
        tcode=tdtype(colnum+tstart(ibuff)) 

        if (felem .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &          'request is out of range:'//crow//' (FTPCLM).')
                return
        else
C               multiply by 2 because the complex data type has pairs of values
                estart=(felem-1)*2
        end if

C       calculate the maximum number of column pixels which fit in buffer
        bytpix=8
        maxpix=100

        if (tcode .eq. 163)then
                repeat=trept(colnum+tstart(ibuff))*2
                if (felem*2 .gt. repeat)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                   call ftpmsg('Starting element number for write '//
     &             'request is out of range:'//crow//' (FTPCLM).')
                        return
                end if
                descrp=.false.
        else if (tcode .eq. -163)then
C               this is a variable length descriptor column
                descrp=.true.
                repeat=nelem+felem-1
C               write the number of elements and the starting offset:
                call ftpdes(ounit,colnum,frow,repeat,
     &                              nxheap(ibuff),status)
                repeat=repeat*2
C               move the i/o pointer to the start of the pixel sequence
                bstart=dtstrt(ibuff)+nxheap(ibuff)+
     &                  theap(ibuff)+estart*bytpix
                call ftmbyt(ounit,bstart,.true.,status)
C               increment the empty heap starting address:
                nxheap(ibuff)=nxheap(ibuff)+repeat*bytpix
        else
C               error illegal binary table data type code
                status=312
                return
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,repeat-estart,maxpix)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &             +tbcol(colnum+tstart(ibuff))+estart*bytpix
            call ftmbyt(ounit,bstart,.true.,status)
        end if

C       scale data into buffer,
        call ftuscm(array(i1),itodo,scaled,scale,zero,buffer)

C       do any machine dependent data conversion and write the R*8 data
        call ftpr8b(ounit,itodo,0,buffer,status)

        if (status .gt. 0)then
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error writing elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTPCLM.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error writing rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTPCLM).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error writing'//cp2//' elements to'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTPCLM).')
             end if
             return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        rstart=rstart+1
                end if
                go to 20
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftmcom(ounit,keywrd,comm,status)

C       modify a the comment string in a header record 
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       comm    c  new keyword comment (max of 72 characters long)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Feb 1992

        character*(*) keywrd,comm
        integer ounit,status,lenval,ncomm
        character value*80,knam*8,cmnt*72
        
        if (status .gt. 0)return

        knam=keywrd

C       find the old keyword + value string
        call ftgcrd(ounit,knam,value,status)
        if (status .eq. 202)then
          call ftpmsg('FTMCOM Could not find the '//knam//' keyword.')
          return
        end if

        call ftprsv(value,lenval,status)
        
        cmnt=comm

C       find amount of space left for comment string (3 spaces needed for ' / ')
        ncomm=77-lenval

C       write the keyword record if there is space
        if (ncomm .gt. 0)then
          call ftmodr(ounit,
     &    value(1:lenval)//' / '//cmnt(1:ncomm),status)
        end if  
        end

      subroutine putstr (str, w, fd)
      integer str (100)
      integer w
      integer fd
      integer length
      integer i, len
      len = length (str)
      i = len + 1
23000 if (.not.(i .le. w))goto 23002
      call putch (32, fd)
23001 i = i + 1
      goto 23000
23002 continue
      i = 1
23003 if (.not.(i .le. len))goto 23005
      call putch (str (i), fd)
23004 i = i + 1
      goto 23003
23005 continue
      i = (-w) - len
23006 if (.not.(i .gt. 0))goto 23008
      call putch (32, fd)
23007 i = i - 1
      goto 23006
23008 continue
      return
      end

      SUBROUTINE TCONAN	(IERROR)
C
C LATEST REVISION	 JULY 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 CONRAN, THE STANDARD ENTRY POINT OF THE
C			 CONRAN	PACKAGE.
C
C			 THIS SAME SUBROUTINE CAN BE USED TO PRODUCE
C			 DEMO PLOTS OF THE SMOOTH VERSION OF CONRAN
C			 BY LOADING DASHSMTH INSTEAD OF	DASHCHAR.
C
C USAGE			 CALL TCONAN (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   .EQ.	0, IF THE TEST WAS SUCCESSFUL,
C			   .NE.	0, OTHERWISE
C			   IF NOT ZERO THE NUMBER PRODUCED WILL
C			   CORRESPOND TO THE ERROR NUMBERS IN
C			   THE CONRAN LISTING.
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   CONRAN TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, TWO FRAMES CONTAINING THE	CONTOUR
C			 PLOT AND TRIANGULATION	OF THE DATA ARE	PRODUCED
C			 ON THE	DEFAULT	GRAPHICS DEVICE	UNLESS THE USER
C			 SPECIFIES OTHERWISE VIA JCL.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 CONRAN
C FILES			 CONTERP
C			 CONCOM
C
C LANGUAGE		 FORTRAN77
C
C ALGORITHM		 A SPARSE DATA SET IS DEFINED VIA DATA
C			 STATEMENTS.  OPTIONS ARE SET TO PRODUCE A
C			 TITLE AND DISPLAY THE TRIANGULATION GENERATED
C			 BY THE	INTERPOLATING ROUTINES.	 BY DEFAULT
C			 A MESSAGE AT THE BOTTEM OF THE	PLOT AND A
C			 PERIMETER ARE ALSO PRODUCED.  THIS ROUTINE
C			 TAKES ADVANTAGE OF THE	PORT ERROR HANDLING
C			 ROUTINES TO DETERMINE IF CONRAN TERMINATED
C			 NORMALLY.
C
C PORTABILITY		 ANSI FORTRAN77	STANDARD
C
C     COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
C  SET UP THE SCRATCH SPACES REQUIRED BY CONRAN
C
      DIMENSION	WK(221),IWK(744),SCR(1600)
C
C  SET UP THE ARRAYS TO	DEFINE THE DATA	SET
C
      DIMENSION	XD(17),YD(17),ZD(17)
C
C DEFINE THE DATA SET
C
      DATA XD(1),XD(2),XD(3),XD(4),XD(5),XD(6),XD(7),XD(8),
     1	   XD(9),XD(10),XD(11),XD(12),XD(13),XD(14),XD(15),
     2	   XD(16),XD(17)
     3	   /3.,3.,10.,18.,18.,10.,10.,5.,1.,15.,20.,
     4		5.,15.,10.,7.,13.,16./
C
      DATA YD(1),YD(2),YD(3),YD(4),YD(5),YD(6),YD(7),YD(8),
     1	   YD(9),YD(10),YD(11),YD(12),YD(13),YD(14),YD(15),
     2	   YD(16),YD(17)
     3	  /3.,18.,18.,3.,18.,10.,1.,5.,10.,5.,10.,
     4		15.,15.,15.,20.,20.,8./
C
      DATA ZD(1),ZD(2),ZD(3),ZD(4),ZD(5),ZD(6),ZD(7),ZD(8),
     1	   ZD(9),ZD(10),ZD(11),ZD(12),ZD(13),ZD(14),ZD(15),
     2	   ZD(16),ZD(17)
     3	  /25.,25.,25.,25.,25.,-5.,1.,1.,1.,1.,1.,
     4		1.,1.,1.,1.,1.,25./
C
C  SET UP PARAMETER FOR	NUMBER OF INPUT	POINTS
C
      DATA NDP/17/
      call conbdn
C
C  SET UP TITLE	 FOR PLOT
C
      CALL CONOP4('TLE=ON','DEMONSTRATION PLOT FOR CONRAN',29, 0)
C
      CALL CONRAN(XD,YD,ZD,NDP,WK,IWK,SCR)
C
      RETURN
      END

      SUBROUTINE TAUTOG	(IERROR)
C
C LATEST REVISION	 FEBRUARY 1985
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 AUTOGRAPH AND TO TEST AUTOGRAPH ON A
C			 SIMPLE	PROBLEM
C
C USAGE			 CALL TAUTOG (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN ERROR PARAMETER
C			   = 0,	IF THE TEST IS SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   AUTOGRAPH TEST SUCCESSFUL  .	. .  SEE PLOT
C			   TO VERIFY PERFORMANCE
C
C			 IS WRITTEN ON UNIT 6.
C
C			 IN ADDITION, FOUR (4) LABELLED	FRAMES
C			 CONTAINING THE	TWO-DIMENSIONAL	PLOTS ARE
C			 PRODUCED ON THE MACHINE GRAPHICS DEVICE.
C			 TO DETERMINE IF THE TEST WAS SUCCESSFUL,
C			 IT IS NECESSARY TO EXAMINE THESE PLOTS.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 AUTOGRAPH
C FILES
C
C LANGUAGE		 FORTRAN
C
C HISTORY		 ORIGINALLY WRITTEN IN APRIL, 1979 AND
C			 CONVERTED TO FORTRAN 77 AND GKS IN FEBRUARY
C			 1985.
C
C ALGORITHM		 TAUTOG	COMPUTES DATA FOR AUTOGRAPH SUBROUTINES
C
C			   EZY,	EZXY, EZMY, AND	EZMXY,
C
C			 AND CALLS EACH	OF THESE ROUTINES TO PRODUCE
C			 ONE PLOT EACH.
C
C			 ON THREE OF THE PLOTS,	TAUTOG USES THE
C			 AUTOGRAPH CONTROL PARAMETER ROUTINES
C			 AGSETF, AGSETI, AND AGSETP TO SPECIFY
C			 Y-AXIS	LABELS OR INTRODUCE LOG	SCALING.
C
C PORTABILITY		 FORTRAN 77
C
      REAL	      X(21)	 ,Y1D(21)    ,Y2D(21,5)
C
C X CONTAINS THE ABSCISSA VALUES FOR THE PLOTS PRODUCED	BY EZXY	AND
C EZMXY,  Y1D CONTAINS THE ORDINATE VALUES FOR THE PLOTS PRODUCED BY
C EZXY AND EZY,	 AND Y2D CONTAINS THE ORDINATE VALUES FOR THE PLOTS
C PRODUCED BY EZMY AND EZMXY.
C
C
C
C
C FILL Y1D ARRAY FOR ENTRY EZY
C
      DO  10 I=1,21
	 Y1D(I)	= EXP(-.1*FLOAT(I))*COS(FLOAT(I)*.5)
   10 CONTINUE
C
C     ENTRY EZY	PLOTS THE CONTENTS OF Y1D AS A FUNCTION	OF THE INTEGERS
C     THE TITLE	FOR THIS PLOT IS
C
C	DEMONSTRATING EZY ENTRY	OF AUTOGRAPH
C
      CALL EZY (Y1D(1),21,'DEMONSTRATING EZY ENTRY OF AUTOGRAPH$')
C
	
C
C
C
C FILL X AND Y1D ARRAYS	FOR ENTRY EZXY
C
      DO  20 I=1,21
	 X(I) =	FLOAT(I-1)*.314
	 Y1D(I)	= X(I)+COS(X(I))*2.0
   20 CONTINUE
C
C     SET AUTOGRAPH CONTROL PARAMETERS FOR Y-AXIS LABEL
C	  X+COS(X)*2
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X+COS(X)*2$')
C
C     ENTRY EZXY PLOTS CONTENTS	OF X-ARRAY VS. Y1D-ARRAY
C     THE TITLE	FOR THIS PLOT IS
C
C	DEMONSTRATING EZXY ENTRY OF AUTOGRAPH
C
      CALL EZXY	(X,Y1D,21,'DEMONSTRATING EZXY ENTRY IN AUTOGRAPH$')
C
C
C
C
C FILL Y2D ARRAY FOR ENTRY EZMY
C
      DO  40 I=1,21
	 T = .5*FLOAT(I-1)
	 DO  30	J=1,5
	    Y2D(I,J) = EXP(-.5*T)*COS(T)/FLOAT(J)
   30	 CONTINUE
   40 CONTINUE
C
C     SET AUTOGRAPH CONTROL PARAMETERS FOR Y-AXIS LABEL
C	  EXP(-X/2)*COS(X)*SCALE
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','EXP(-X/2)*COS(X)*SCALE$')
C
C     SET AUTOGRAPH CONTROL PARAMETER FOR SPECIFYING THAT THE
C     ALPHABETIC SET OF	DASHED LINE PATTERNS IS	TO BE USED.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C     SET AUTOGRAPH CONTROL PARAMETER FOR SPECIFYING THAT THE
C     GRAPH DRAWN IS TO	BE LOGARITHMIC IN THE X-AXIS.
C
      CALL AGSETI('X/LOGARITHMIC.',1)
C
C     ENTRY EZMY PLOTS MULTIPLE	ARRAYS AS A FUNCTION OF	THE INTEGERS
C     THE TITLE	FOR THIS PLOT IS
C
C	DEMONSTRATING EZMY ENTRY OF AUTOGRAPH
C
      CALL EZMY	(Y2D,21,5,10,'DEMONSTRATING EZMY ENTRY OF AUTOGRAPH$')
C
C
C
C
C FILL Y2D ARRAY FOR EZMXY
C
      DO  60 I=1,21
	 DO  50	J=1,5
	    Y2D(I,J) = X(I)**J+COS(X(I))
   50	 CONTINUE
   60 CONTINUE
C
C     SET AUTOGRAPH CONTROL PARAMETERS FOR Y-AXIS LABEL
C	  X**J+COS(X)
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X**J+COS(X)$')
C
C     SET AUTOGRAPH CONTROL PARAMETER FOR SPECIFYING THAT THE
C     ALPHABETIC SET OF	DASHED LINE PATTERNS IS	TO BE USED.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C     SET AUTOGRAPH CONTROL PARAMETER FOR SPECIFYING THAT THE GRAPH
C     IS TO BE LINEAR IN THE X-AXIS AND	LOGARITHMIC IN THE Y-AXIS.
C
      CALL AGSETI('X/LOGARITHMIC.',0)
      CALL AGSETI('Y/LOGARITHMIC.',1)
C
C     ENTRY EZMXY PLOTS	MULTIPLE ARRAYS	AS A FUNCTION OF A SINGLE
C		  X ARRAY (OR MANY X ARRAYS)
C     THE TITLE	FOR THIS PLOT IS
C
C	DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH
C
      CALL EZMXY (X,Y2D,21,5,21,
     +		  'DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH$')
C
      IERROR = 0
c     WRITE (6,1001)
C
      RETURN
C
c1001 FORMAT ('	 AUTOGRAPH TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

#-h-  forcod			 2259  local   12/01/80  15:54:07
# forcod - beginning of for statement
   include  defs

   subroutine forcod (lab)
   integer lab

   include COMMON_BLOCKS

   character t, token (MAXTOK)
   character gettok, gnbtok

   integer i, j, nlpar
   integer length, labgen

   string ifnot "if (.not."
   string serrchk ".and.(.not.xerflg))) "

   lab = labgen (3)
   call outcon (0)
   if (gnbtok (token, MAXTOK) != LPAREN) {
      call synerr ("missing left paren.")
      return
      }
   if (gnbtok (token, MAXTOK) != SEMICOL) {   # real init clause
      call pbstr (token)
      call outtab
      call eatup
      call outdwe
      }
   if (gnbtok (token, MAXTOK) == SEMICOL)   # empty condition
      call outcon (lab)
   else {   # non-empty condition
      call pbstr (token)
      call outnum (lab)
      call outtab
      call outstr (ifnot)
      call outch (LPAREN)
      nlpar = 0
      while (nlpar >= 0) {
	 t = gettok (token, MAXTOK)
	 if (t == SEMICOL)
	    break
	 if (t == LPAREN)
	    nlpar = nlpar + 1
	 else if (t == RPAREN)
	    nlpar = nlpar - 1
	 if (t == EOF) {
	    call pbstr (token)
	    return
	    }
	 if (t == ALPHA)
	    call squash (token)
	 if (t != NEWLINE & t != UNDERLINE)
	    call outstr (token)
	 }

      # name encountered for which error checking is required?
      if (ername == YES)
	 call outstr (serrchk)
      else {
	  call outch (RPAREN)
	  call outch (RPAREN)
	  call outch (BLANK)
	  }
      call outgo (lab+2)			# error checking below (errgo)
      if (nlpar < 0)
	 call synerr ("invalid for clause.")
      }
   fordep = fordep + 1	 # stack reinit clause
   j = 1
   for (i = 1; i < fordep; i = i + 1)	# find end
      j = j + length (forstk (j)) + 1
   forstk (j) = EOS   # null, in case no reinit
   nlpar = 0
   t = gnbtok (token, MAXTOK)
   call pbstr (token)
   while (nlpar >= 0) {
      t = gettok (token, MAXTOK)
      if (t == LPAREN)
	 nlpar = nlpar + 1
      else if (t == RPAREN)
	 nlpar = nlpar - 1
      if (t == EOF) {
	 call pbstr (token)
	 break
	 }
      if (nlpar >= 0 & t != NEWLINE & t != UNDERLINE) {
	 if (t == ALPHA)
	    call squash (token)
	 if (j + length (token) >= MAXFORSTK)
	    call baderr ("for clause too long.")
	 call scopy (token, 1, forstk, j)
	 j = j + length (token)
	 }
      }
   lab = lab + 1   # label for next's
   call indent (1)
   call errgo
   return
   end

      SUBROUTINE slDTPV (XI, ETA, V0, V)
*+
*     - - - - - -
*      D T P V
*     - - - - - -
*
*  Given the tangent-plane coordinates of a star and the direction
*  cosines of the tangent point, determine the direction cosines
*  of the star.
*
*  (double precision)
*
*  Given:
*     XI,ETA    d       tangent plane coordinates of star
*     V0        d(3)    direction cosines of tangent point
*
*  Returned:
*     V         d(3)    direction cosines of star
*
*  Notes:
*
*  1  If vector V0 is not of unit length, the returned vector V will
*     be wrong.
*
*  2  If vector V0 points at a pole, the returned vector V will be
*     based on the arbitrary assumption that the RA of the tangent
*     point is zero.
*
*  3  This routine is the Cartesian equivalent of the routine slDTPS.
*
*  P.T.Wallace   Starlink   11 February 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION XI,ETA,V0(3),V(3)

      DOUBLE PRECISION X,Y,Z,F,R


      X=V0(1)
      Y=V0(2)
      Z=V0(3)
      F=SQRT(1D0+XI*XI+ETA*ETA)
      R=SQRT(X*X+Y*Y)
      IF (R.EQ.0D0) THEN
         R=1D-20
         X=R
      END IF
      V(1)=(X-(XI*Y+ETA*X*Z)/R)/F
      V(2)=(Y+(XI*X-ETA*Y*Z)/R)/F
      V(3)=(Z+ETA*R)/F

      END

      SUBROUTINE slAOPT (DATE, AOPRMS)
*+
*     - - - - - - -
*      A O P T
*     - - - - - - -
*
*  Recompute the sidereal time in the apparent to observed place
*  star-independent parameter block.
*
*  Given:
*     DATE   d      UTC date/time (modified Julian Date, JD-2400000.5)
*                   (see AOPPA source for comments on leap seconds)
*
*     AOPRMS d(14)  star-independent apparent-to-observed parameters
*
*       (1-12)   not required
*       (13)     longitude + eqn of equinoxes + sidereal DUT
*       (14)     not required
*
*  Returned:
*     AOPRMS d(14)  star-independent apparent-to-observed parameters:
*
*       (1-13)   not changed
*       (14)     local apparent sidereal time (radians)
*
*  For more information, see slAOPA.
*
*  Called:  slGMST
*
*  P.T.Wallace   Starlink   1 July 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,AOPRMS(14)

      DOUBLE PRECISION slGMST



      AOPRMS(14) = slGMST(DATE)+AOPRMS(13)

      END

      SUBROUTINE slTP2V (XI, ETA, V0, V)
*+
*     - - - - -
*      T P 2 V
*     - - - - -
*
*  Given the tangent-plane coordinates of a star and the direction
*  cosines of the tangent point, determine the direction cosines
*  of the star.
*
*  (single precision)
*
*  Given:
*     XI,ETA    r       tangent plane coordinates of star
*     V0        r(3)    direction cosines of tangent point
*
*  Returned:
*     V         r(3)    direction cosines of star
*
*  Notes:
*
*  1  If vector V0 is not of unit length, the returned vector V will
*     be wrong.
*
*  2  If vector V0 points at a pole, the returned vector V will be
*     based on the arbitrary assumption that the RA of the tangent
*     point is zero.
*
*  3  This routine is the Cartesian equivalent of the routine slTP2S.
*
*  P.T.Wallace   Starlink   11 February 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL XI,ETA,V0(3),V(3)

      REAL X,Y,Z,F,R


      X=V0(1)
      Y=V0(2)
      Z=V0(3)
      F=SQRT(1.0+XI*XI+ETA*ETA)
      R=SQRT(X*X+Y*Y)
      IF (R.EQ.0.0) THEN
         R=1E-20
         X=R
      END IF
      V(1)=(X-(XI*Y+ETA*X*Z)/R)/F
      V(2)=(Y+(XI*X-ETA*Y*Z)/R)/F
      V(3)=(Z+ETA*R)/F

      END

C--------------------------------------------------------------------------
        subroutine ftpknf(ounit,keywrd,nstart,nkey,rval,decim,comm,
     &                    status)

C       write an array of real*4 values to header records in F format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       nstart  i  starting sequence number (usually 1)
C       nkey    i  number of keywords to write
C       rval    r  array of keyword values
C       decim   i  number of decimal places to display in the value field
C       comm    c  array of keyword comments (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm(*)
        integer nstart,nkey,decim,ounit,status,i,j
        real rval(*)
        character keynam*8,comm1*48
        logical repeat

        if (status .gt. 0)return

C       check if the first comment string is to be repeated for all keywords
C       (if the last non-blank character is '&', then it is to be repeated)
        call ftcrep(comm(1),comm1,repeat)

        j=nstart
        do 10 i=1,nkey
C               construct keyword name:
                call ftkeyn(keywrd,j,keynam,status)

C               write the keyword record
                if (repeat)then
                  call ftpkyf(ounit,keynam,rval(i),decim,comm1,status)
                else
                  call ftpkyf(ounit,keynam,rval(i),decim,comm(i),status)
                end if
                if (status .gt. 0)return
                j=j+1
10      continue
        end

      DOUBLE PRECISION FUNCTION slDA2P (ANGLE)
*+
*     - - - - - - -
*      D A 2 P
*     - - - - - - -
*
*  Normalize angle into range 0-2 pi  (double precision)
*
*  Given:
*     ANGLE     dp      the angle in radians
*
*  The result is ANGLE expressed in the range 0-2 pi.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION ANGLE

      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925286766559D0)


      slDA2P = MOD(ANGLE,D2PI)
      IF (slDA2P.LT.0D0) slDA2P = slDA2P+D2PI

      END

C--------------------------------------------------------------------------
        subroutine ftgkne(iunit,keywrd,nstart,nmax,
     &                    rval,nfound,status)

C       read an array of real*4 values from  header records
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name
C       nstart  i  starting sequence number (usually 1)
C       nmax    i  number of keywords to read
C       OUTPUT PARAMETERS:
C       rval    r  array of output keyword values
C       nfound  i  number of keywords found
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd
        real rval(*)
        integer iunit,nstart,nmax,nfound,status,tstat
        integer nkeys,mkeys,i,ival,nend,namlen,indval
        character inname*8,keynam*8
        character*80 rec,value,comm

        if (status .gt. 0)return

C       for efficiency, we want to search just once through the header
C       for all the keywords which match the root.

        nfound=0
        nend=nstart+nmax-1
        inname=keywrd
        call ftupch(inname)

C       find the length of the root name
        namlen=0
        do 5 i=8,1,-1
                if (inname(i:i) .ne. ' ')then
                        namlen=i
                        go to 6
                end if
5       continue
6       if (namlen .eq. 0)return

C       get the number of keywords in the header
        call ftghsp(iunit,nkeys,mkeys,status)

        do 10 i=3,nkeys
                call ftgrec(iunit,i,rec,status)
                if (status .gt. 0)return
                keynam=rec(1:8)
                if (keynam(1:namlen) .eq. inname(1:namlen))then

C                   try to interpret the remainder of the name as an integer
                    tstat=status
                    call ftc2ii(keynam(namlen+1:8),ival,status)
                    if (status .le. 0)then
                        if (ival .le. nend .and. ival .ge. nstart)then
                            call ftpsvc(rec,value,comm,status)
                            indval=ival-nstart+1
                            call ftc2rr(value,rval(indval),status)
                            if (status .gt. 0)then
             call ftpmsg('Error in FTGKNE evaluating '//keynam//
     &       ' as a Real: '//value)
                               return
                             else
                               nfound=max(nfound,indval)                   
                             end if
                        end if
                    else
                        if (status .eq. 407)then
                                status=tstat
                        else
                                return
                        end if
                    end if
                end if
10      continue
        end

#-h-  synerr			  703  local   12/01/80  15:55:08
# synerr --- report non-fatal error
   include  defs

   subroutine synerr (msg)

   character msg
#      character*(*) msg

   include COMMON_BLOCKS
   character lc (MAXCHARS)

   integer i, junk
   integer itoc

   string of " of "
   string errmsg "Error on line "

   call putlin (errmsg, ERROUT)
   if (level >= 1)
      i = level
   else
      i = 1 # for EOF errors
   junk = itoc (linect (i), lc, MAXCHARS)
   call putlin (lc, ERROUT)
   for (i = fnamp - 1; i >= 1; i = i - 1)
      if (fnames (i - 1) == EOS | i == 1) {  # print file name
	 call putlin (of, ERROUT)
	 call putlin (fnames (i), ERROUT)
	 break
	 }

   call putch (COLON, ERROUT)
   call putch (BLANK, ERROUT)
   call remark (msg)
   return
   end

C------------------------------------------------------------------------------
        subroutine ftgiou(iounit,status)

C       get an unallocated logical unit number

        integer iounit,status

        if (status .gt. 0)return
        iounit=0
        call ftxiou(iounit,status)
        end

chapter iv. runge example, with cubic hermite interpolation
c  from  * a practical guide to splines *  by c. de boor
      integer i,istep,j,n,nm1
      real aloger,algerp,c(4,20),decay,divdf1,divdf3,dtau,dx,errmax,g,h
     *	  ,pnatx,step,tau(20),x
      data step, istep /20., 20/
      g(x) = 1./(1.+(5.*x)**2)
      print 600
  600 format(28h  n   max.error   decay exp.//)
      decay = 0.
      do 40 n=2,20,2
c	 choose interpolation points  tau(1), ..., tau(n) , equally
c	 spaced in (-1,1), and set  c(1,i) = g(tau(i)), c(2,i) =
c	 gprime(tau(i)) = -50.*tau(i)*g(tau(i))**2, i=1,...,n.
	 nm1 = n-1
	 h = 2./float(nm1)
	 do 10 i=1,n
	    tau(i) = float(i-1)*h - 1.
	    c(1,i) = g(tau(i))
   10	    c(2,i) = -50.*tau(i)*c(1,i)**2
c	 calculate the coefficients of the polynomial pieces
c
	 do 20 i=1,nm1
	    dtau = tau(i+1) - tau(i)
	    divdf1 = (c(1,i+1) - c(1,i))/dtau
	    divdf3 = c(2,i) + c(2,i+1) - 2.*divdf1
	    c(3,i) = (divdf1 - c(2,i) - divdf3)/dtau
   20	    c(4,i) = (divdf3/dtau)/dtau
c
c	 estimate max.interpolation error on (-1,1).
	 errmax = 0.
	 do 30 i=2,n
	    dx = (tau(i)-tau(i-1))/step
	    do 30 j=1,istep
	       h = float(j)*dx
c	       evaluate (i-1)st cubic piece
c
	       pnatx = c(1,i-1)+h*(c(2,i-1)+h*(c(3,i-1)+h*c(4,i-1)))
c
   30	       errmax = amax1(errmax,abs(g(tau(i-1)+h)-pnatx))
	 aloger = alog(errmax)
	 if (n .gt. 2)	decay =
     *	     (aloger - algerp)/alog(float(n)/float(n-2))
	 algerp = aloger
   40	 print 640,n,errmax,decay
  640 format(i3,e12.4,f11.2)
					stop
      end

      SUBROUTINE CONLOD (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C******************************************************************
C*                                                                *
C*   THIS FILE IS A PACKAGE OF SUPPORT ROUTINES FOR THE ULIB      *
C*   FILES CONRAN AND CONRAS.  SEE THOSE FILES FOR AN             *
C*   EXPLAINATION OF THE ENTRY POINTS.                            *
C*                                                                *
C******************************************************************
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       SCRARR(1)
C
        SAVE
C
C  IFR - FLAG TO REGISTER FIRST PASS IN Y DIRECTION
C
C  LOAD THE SCRATCH SPACE AND CONVEX HULL POINTERS
C  ITLOC IS THE LIST OF CONVEX HULL POINTERS RELATIVE TO THE SCARTCH
C  SPACE.
C  PV IS THE LIST OF CONVEX HULL POINTERS RELATIVE TO USER COORDINATES
C
C  INITALIZE THE SPECIAL VALUE FEATURE
C
      X = (XED-XST)/2. + XST
      Y = (YED-YST)/2. + YST
      IF(LINEAR) GO TO 1
      SPVAL = CONCOM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
        GO TO 2
 1    SPVAL = CONLCM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
 2    CONTINUE
C
C  INITIALIZE THE SEARCH
C
      IYMAX = 0
      IFR = 1
      JX = 1
      X = XST
   10 JY = 1
      Y = YST
C
C  SET HULL POINTERS FOR THIS COLUMN TO NULL
C
      ITLOC(JX*2-1) = 0
      ITLOC(JX*2) = 0
C
C  FLAG START OF COLUMN
C
      LOOP = 1
C
C  GET INTERPOLATED VALUE
C
  20  IF (LINEAR) GO TO 3
      RVAL = CONCOM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
      GO TO 4
  3   RVAL = CONLCM(X,Y,XD,YD,ZD,NDP,WK,IWK,IT)
  4   CONTINUE
      SCRARR(JY+(JX-1)*IYMAX) = RVAL
      IF (RVAL.GT.SPVAL) SPVAL = RVAL
C
C  IF OUTSIDE CONVEX HULL BRANCH
C
      IF (IT.GT.NTNL) GO TO    30
C
C  IF OUTSIDE TRIANGLES AND USING LINEAR INTERPLOATION THEN BRANCH
C
      IF(LINEAR.AND.IT.GT.NT) GO TO 30
C
C  IF FIRST OF COLUMN IN HULL CONTINUE THROUGH
C
      IF (LOOP.NE.1) GO TO    40
C
C  SET HULL POINTERS
C
      PV(JX*2-1) = Y
      ITLOC(JX*2-1) = JY
C
C  SET FLAG TO LOOK FOR END OF HULL IN COLUMN
C
      LOOP = 2
C
C  GO FOR NEXT ENTRY
C
      GO TO    40
C
C  TEST FOR END OF CONVEX HULL ON THIS ROW
C
   30 IF (LOOP.NE.2) GO TO    40
C
C  END OF HULL SET POINTERS FOR END OF HULL AND FLAG IT VIA LOOP
C
      LOOP = 0
      ITLOC(JX*2) = JY-1
      PV(JX*2) = Y-STPSZ
C
C  GET NEXT ELEMENT IN ROW IF NOT OUTSIDE ENCLOSING RECTANGULAR
C  BOARDER
C
   40 Y = Y+STPSZ
      JY = JY+1
      IF (Y.LE.YED) GO TO    20
C
C  TEST FOR FIRST COLUMN
C
      IF (IFR.NE.1) GO TO    50
C
C  FIRST COLUMN OVER SET MAX Y VALUES
C
      IYMAX = JY-1
      YMAX = Y-STPSZ
      IFR = 0
C
C  IF HULL WENT TO EDGE OF RECTANGULAR BOARDER SET HULL POINTERS HERE
C
   50 IF (LOOP.NE.2) GO TO    60
      PV(JX*2) = Y-STPSZ
      ITLOC(JX*2) = JY-1
C
C  END OF COLUMN GET NEXT ONE
C
   60 X = X+STPSZ
      JX = JX+1
C
C  IF NOT END OF WORK CONTINUE WITH NEXT COLUMN
C
      IF (X.LE.XED) GO TO    10
C
C  END OF WORK SET MAX X VALUES
C
      IXMAX = JX-1
      XMAX = X-STPSZ
      RETURN
      END

c subroutine integ.f
c
c source
c   Bevington, page 274.
c
c purpose
c   integrate the area beneath two data points
c
c usage
c   call integ (x, y, nterms, i1, x1, x2, sum)
c
c description of parameters
c   x	   - array of data points for independent variable
c   y	   - array of data points for dependent variable
c   nterms - number of terms in fitting polymonial
c   i1	   - first data point for fitting polynomial
c   x1	   - first value of x for integration
c   x2	   - final value of x for integration
c
c subroutines and function subprograms required
c   none
c
c comments
c   dimension statement valid for nterms up to 10
c
	subroutine integ (x,y,nterms,i1,x1,x2,sum)
	double precision xjk,array,a,denom,deltax,sum
	dimension x(1),y(1)
	dimension array(10,10)
c
c construct square matrix and invert
c
11	do 17 j=1,nterms
	i=j+i1-1
	deltax=x(i)-x(i1)
	xjk=1.
	do 17 k=1,nterms
	array(j,k)=xjk
17	xjk=xjk*deltax
21	call matinv (array,nterms,det)
	if (det) 31,23,31
23	imid=i1+nterms/2
	sum=sum+y(imid)*(x2-x1)
	goto 40
c
c evaluate coefficients and integrate
c
31	dx1=x1-x(i1)
	dx2=x2-x(i1)
33	do 39 j=1,nterms
	i=j+i1-1
	a=0.
	do 37 k=1,nterms
37	a=a+y(i)*array(j,k)
	denom=j
39	sum=sum+(a/denom)*(dx2**j-dx1**j)
40	return
	end

      subroutine thenco (tok, lab)
      integer lab, tok
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer siferr(20)
      integer sifno0(15)
      data siferr(1)/105/,siferr(2)/102/,siferr(3)/32/,siferr(4)/40/,sif
     *err(5)/46/,siferr(6)/110/,siferr(7)/111/,siferr(8)/116/,siferr(9)/
     *46/,siferr(10)/120/,siferr(11)/101/,siferr(12)/114/,siferr(13)/112
     */,siferr(14)/111/,siferr(15)/112/,siferr(16)/40/,siferr(17)/41/,si
     *ferr(18)/41/,siferr(19)/32/,siferr(20)/-2/
      data sifno0(1)/105/,sifno0(2)/102/,sifno0(3)/32/,sifno0(4)/40/,sif
     *no0(5)/120/,sifno0(6)/101/,sifno0(7)/114/,sifno0(8)/112/,sifno0(9)
     */111/,sifno0(10)/112/,sifno0(11)/40/,sifno0(12)/41/,sifno0(13)/41/
     *,sifno0(14)/32/,sifno0(15)/-2/
      xfer = 0
      call outnum (lab+2)
      call outtab
      if (.not.(tok .eq. -98))goto 23000
      call outstr (siferr)
      goto 23001
23000 continue
      call outstr (sifno0)
23001 continue
      call outgo (lab)
      esp = esp - 1
      call indent (1)
      return
      end
c     sifno0  sifnoerr
c     logic0  logical_column

      subroutine uniqid (id)
      integer id (100)
      integer i, j, junk, idchl
      external index
      integer lookup, index, length
      integer start (6)
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer idch(37)
      data idch(1)/48/,idch(2)/49/,idch(3)/50/,idch(4)/51/,idch(5)/52/,i
     *dch(6)/53/,idch(7)/54/,idch(8)/55/,idch(9)/56/,idch(10)/57/,idch(1
     *1)/97/,idch(12)/98/,idch(13)/99/,idch(14)/100/,idch(15)/101/,idch(
     *16)/102/,idch(17)/103/,idch(18)/104/,idch(19)/105/,idch(20)/106/,i
     *dch(21)/107/,idch(22)/108/,idch(23)/109/,idch(24)/110/,idch(25)/11
     *1/,idch(26)/112/,idch(27)/113/,idch(28)/114/,idch(29)/115/,idch(30
     *)/116/,idch(31)/117/,idch(32)/118/,idch(33)/119/,idch(34)/120/,idc
     *h(35)/121/,idch(36)/122/,idch(37)/-2/
      i = 1
23000 if (.not.(id (i) .ne. -2))goto 23002
23001 i = i + 1
      goto 23000
23002 continue
23003 if (.not.(i .le. 6))goto 23005
      id (i) = 48
23004 i = i + 1
      goto 23003
23005 continue
      i = 6 + 1
      id (i) = -2
      id (i - 1) = 48
      if (.not.(lookup (id, junk, gentbl) .eq. 1))goto 23006
      idchl = length (idch)
      i = 2
23008 if (.not.(i .lt. 6))goto 23010
      start (i) = id (i)
23009 i = i + 1
      goto 23008
23010 continue
23011 continue
      i = 6 - 1
23014 if (.not.(i .gt. 1))goto 23016
      j = mod (index (idch, id (i)), idchl) + 1
      id (i) = idch (j)
      if (.not.(id (i) .ne. start (i)))goto 23017
      goto 23016
23017 continue
23015 i = i - 1
      goto 23014
23016 continue
      if (.not.(i .eq. 1))goto 23019
      call baderr (30Hcannot make identifier unique.)
23019 continue
23012 if (.not.(lookup (id, junk, gentbl) .eq. 0))goto 23011
23013 continue
23006 continue
      end
c     logic0  logical_column

      subroutine enter (symbol, info, st)
      integer symbol (100)
      integer info (100)
      integer st
      integer mem( 60000)
      common/cdsmem/mem
      integer i, nodsiz, j
      integer stlu, length
      integer node, pred
      integer dsget
      nodsiz = mem (st)
      if (.not.(stlu (symbol, node, pred, st) .eq. 0))goto 23000
      node = dsget (1 + nodsiz + length (symbol) + 1)
      mem (node + 0) = 0
      mem (pred + 0) = node
      i = 1
      j = node + 1 + nodsiz
23002 if (.not.(symbol (i) .ne. -2))goto 23003
      mem (j) = symbol (i)
      i = i + 1
      j = j + 1
      goto 23002
23003 continue
      mem (j) = -2
23000 continue
      i = 1
23004 if (.not.(i .le. nodsiz))goto 23006
      j = node + 1 + i - 1
      mem (j) = info (i)
23005 i = i + 1
      goto 23004
23006 continue
      return
      end

C--------------------------------------------------------------------------
        subroutine ftukyf(ounit,keywrd,rval,decim,comm,status)

C       update a real*4 value header record in F format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       rval    r  keyword value 
C       decim   i  number of decimal places to display in value field
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Oct 1994

        character*(*) keywrd,comm
        real rval
        integer ounit,status,decim,tstat

        if (status .gt. 0)return
        tstat=status

C       try modifying the keyword, if it exists
        call ftmkyf(ounit,keywrd,rval,decim,comm,status)

        if (status .eq. 202)then
C               keyword doesn't exist, so create it
                status=tstat
                call ftpkyf(ounit,keywrd,rval,decim,comm,status)
        end if
        end

C----------------------------------------------------------------------
        subroutine ftr8i4(input,n,scale,zero,tofits,
     &          chktyp,setval,flgray,anynul,output,status)

C       copy input r*8 values to output i*4 values, doing optional
C       scaling and checking for null values

C       input   d  input array of values
C       n       i  number of values 
C       scale   d  scaling factor to be applied
C       zero    d  scaling zero point to be applied
C       tofits  l  true if converting from internal format to FITS
C       chktyp  i  type of null value checking to be done if TOFITS=.false.
C                       =0  no checking for null values
C                       =1  set null values = SETVAL
C                       =2  set corresponding FLGRAY value = .true.
C       setval  i   value to set output array to if value is undefined
C       flgray  l   array of logicals indicating if corresponding value is null
C       anynul  l   set to true if any nulls were set in the output array
C       output  i   returned array of values
C       status  i  output error status (0 = ok)

        double precision input(*)
        integer output(*),setval
        integer n,i,chktyp,status
        double precision scale,zero,dval,i4min,i4max
        logical tofits,flgray(*),anynul,noscal
        logical fttdnn
        parameter (i4max=2.14748364749D+09)
        parameter (i4min=-2.14748364849D+09)
        integer maxi4,mini4
        parameter (maxi4=2147483647)
        external fttdnn
C       work around for bug in the DEC Alpha VMS compiler
        mini4=-2147483647 - 1

        if (status .gt. 0)return

        if (scale .eq. 1. .and. zero .eq. 0)then
                noscal=.true.
        else
                noscal=.false.
        end if
        
        if (tofits) then
C               we don't have to worry about null values when writing to FITS
                if (noscal)then
                        do 10 i=1,n
C                           trap any values that overflow the I*4 range
                            if (input(i) .le. i4max .and. 
     &                          input(i) .ge. i4min)then
                                    output(i)=nint(input(i))
                            else if (input(i) .gt. i4max)then
                                    status=-11
                                    output(i)=maxi4
                            else
                                    status=-11
                                    output(i)=mini4
                            end if
10                      continue
                else
                        do 20 i=1,n
                            dval=(input(i)-zero)/scale
C                           trap any values that overflow the I*4 range
                            if (dval.lt.i4max .and. dval.gt.i4min)then      
                                output(i)=nint(dval)
                            else if (dval .ge. i4max)then
                                status=-11
                                output(i)=maxi4
                            else
                                status=-11
                                output(i)=mini4
                            end if
20                      continue
                end if
        else
C               converting from FITS to internal format; may have to check nulls
                if (chktyp .eq. 0)then
C                       don't have to check for nulls
                        if (noscal)then
                          do 30 i=1,n
C                           trap any values that overflow the I*4 range
                            if (input(i) .le. i4max .and. 
     &                          input(i) .ge. i4min)then
                                    output(i)=nint(input(i))
                            else if (input(i) .gt. i4max)then
                                    status=-11
                                    output(i)=maxi4
                            else
                                    status=-11
                                    output(i)=mini4
                            end if
30                        continue
                        else
                            do 40 i=1,n
                              dval=input(i)*scale+zero
C                             trap any values that overflow the I*4 range
                              if (dval.lt.i4max .and. dval.gt.i4min)then
                                  output(i)=nint(dval)
                              else if (dval .ge. i4max)then
                                  status=-11
                                  output(i)=maxi4
                              else
                                  status=-11
                                  output(i)=mini4
                              end if
40                          continue
                        end if
                else 
C                   must test for null values
                    if (noscal)then
                        do 50 i=1,n
                            if (fttdnn(input(i)))then
                                anynul=.true.
                                if (chktyp .eq. 1)then
                                    output(i)=setval
                                else
                                    flgray(i)=.true.
                                end if
                            else
C                               trap any values that overflow the I*4 range
                                if (input(i) .le. i4max .and. 
     &                              input(i) .ge. i4min)then
                                        output(i)=nint(input(i))
                                else if (input(i) .gt. i4max)then
                                        status=-11
                                        output(i)=maxi4
                                else
                                        status=-11
                                        output(i)=mini4
                                end if
                            end if
50                      continue
                    else
                        do 60 i=1,n
                            if (fttdnn(input(i)))then
                                anynul=.true.
                                if (chktyp .eq. 1)then
                                     output(i)=setval
                                else
                                     flgray(i)=.true.
                                end if
                            else
                              dval=input(i)*scale+zero
C                             trap any values that overflow the I*4 range
                              if (dval.lt.i4max .and. dval.gt.i4min)then
                                  output(i)=nint(dval)
                              else if (dval .ge. i4max)then
                                  status=-11
                                  output(i)=maxi4
                              else
                                  status=-11
                                  output(i)=mini4
                              end if
                            end if
60                      continue
                    end if
                end if
        end if
        end

C------------------------------------------------------------------------------
        subroutine ftgerr(errnum,text)

C       Return a descriptive error message corresponding to the error number

C       errnum i  input symbolic error code presumably returned by another
C                 FITSIO subroutine
C       text   C*30  Descriptive error message

        integer errnum
        character*(*) text

C       nerror specifies the maxinum number of different error messages
        integer nerror
        parameter (nerror=100)
        character*30 errors(nerror)
        character*30 er1(10),er2(10),er3(10),er4(10),er5(10),er6(10)
        character*30 er7(10),er8(10),er9(10),er10(10)
        integer i,errcod(nerror)
        save errors

C       we equivalence the big array to several smaller ones, so that
C       the DATA statements will not have too many continuation lines.
        equivalence (errors(1), er1(1))
        equivalence (errors(11),er2(1))
        equivalence (errors(21),er3(1))
        equivalence (errors(31),er4(1))
        equivalence (errors(41),er5(1))
        equivalence (errors(51),er6(1))
        equivalence (errors(61),er7(1))
        equivalence (errors(71),er8(1))
        equivalence (errors(81),er9(1))
        equivalence (errors(91),er10(1))

        data errcod/0,101,102,103,104,105,106,107,108,109,110,111,
     &  201,202,203,204,205,206,207,208,209,211,212,213,214,215,216,
     &  217,218,221,222,223,224,225,226,227,228,229,230,231,232,
     &  241,251,252,261,262,
     &  302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,
     &  317,318,319,    401,402,403,404,405,406,407,408,409,411,112,
     &  210,233,220,219,301,320,321,322,263,323,113,114,234,253,254,
     &  255,412,235,236,501,502,503,504,505,237/

        data er1/
     & 'OK, no error',
     & 'Bad logical unit number',
     & 'Too many FITS files opened',
     & 'File not found; not opened',
     & 'Error opening existing file',
     & 'Error creating new FITS file',
     & 'Error writing to FITS file',
     & 'EOF while reading FITS file',
     & 'Error reading FITS file',
     & 'Bad blocking factor (1-28800)'/

        data er2/
     & 'Error closing FITS file',
     & 'Too many columns in table',
     & 'No room in header for keyword',
     & 'Specified keyword not found',  
     & 'Bad keyword record number', 
     & 'Keyword value field is blank',
     & 'Missing quote in string value',
     & 'Could not construct NAMEnnn',
     & 'Bad character in header record',
     & 'Keywords out of order?'/

        data er3/
     & 'Bad nnn value in NAMEnnn',
     & 'Illegal BITPIX keyword value',
     & 'Illegal NAXIS keyword value',
     & 'Illegal NAXISnnn keyword value',
     & 'Illegal PCOUNT keyword value',
     & 'Illegal GCOUNT keyword value',
     & 'Illegal TFIELDS keyword value',
     & 'Illegal NAXIS1 keyword value',
     & 'Illegal NAXIS2 keyword value',
     & 'SIMPLE keyword not found'/

        data er4/
     & 'BITPIX keyword not found',
     & 'NAXIS  keyword not found',
     & 'NAXISnnn keyword(s) not found',
     & 'XTENSION keyword not found',
     & 'CHDU is not an ASCII table',
     & 'CHDU is not a binary table', 
     & 'PCOUNT keyword not found',
     & 'GCOUNT keyword not found',
     & 'TFIELDS keyword not found',
     & 'TBCOLnnn keywords not found'/

        data er5/
     & 'TFORMnnn keywords not found',
     & 'Row width not = field widths',
     & 'Unknown extension type',
     & 'Unknown FITS record type',
     & 'Cannot parse TFORM keyword',
     & 'Unknown TFORM datatype code',
     & 'Column number out of range',
     & 'Data structure not defined',
     & 'Negative file record number',
     & 'HDU start location is unknown'/

        data er6/
     & 'Requested no. of bytes < 0',
     & 'Illegal first row number',
     & 'Illegal first element number',
     & 'Bad TFORM for Character I/O',
     & 'Bad TFORM for Logical I/O',
     & 'Invalid ASCII table TFORM code',
     & 'Invalid BINTABLE TFORM code',
     & 'Error making formated string',
     & 'Null value is undefined',
     & 'Internal read error of string'/

        data er7/
     & 'Illegal logical column value',
     & 'Bad TFORM for descriptor I/O',
     & 'Variable array has 0 length',
     & 'End-of-rec in var. len. array',
     & 'Int to Char conversion error',
     & 'Real to Char conversion error',
     & 'Illegal Char to Int conversion',
     & 'Illegal Logical keyword value',
     & 'Illegal Char to R*4 conversion',
     & 'Illegal Char to R*8 conversion'/

        data er8/
     & 'Char to Int conversion error',
     & 'Char to Real conversion error',
     & 'Char to R*8 conversion error',
     & 'Illegal no. of decimal places',
     & 'Cannot modify a READONLY file',
     & 'END header keyword not found',
     & 'CHDU is not an IMAGE extension',
     & 'Illegal SIMPLE keyword value',
     & 'Column name (TTYPE) not found',
     & 'Out of bounds HDU number'/

        data er9/
     & 'Bad no. of array dimensions',
     & 'Max pixel less than min pixel',
     & 'Illegal BSCALE or TSCALn = 0',
     & 'Could not parse TDIMn keyword',
     & 'Axis length less than 1',
     & 'Incompatible FITSIO version',
     & 'All LUNs have been allocated',
     & 'TBCOLn value out of range',
     & 'END keyword value not blank ',
     & 'Header fill area not blank'/

        data er10/
     & 'Data fill area invalid',
     & 'Data type conversion overflow',
     & 'CHDU must be a table/bintable',
     & 'Column is too wide for table',
     & 'celestial angle too large',
     & 'bad celestial coordinate',
     & 'error in celestial coord calc',
     & 'unsupported projection',
     & 'missing celestial coord keywrd',
     & 'column name not unique'/

C       find the matching error code number
        do 10 i=1,nerror
                if (errnum .eq. errcod(i))then
                        text=errors(i)
                        return
                end if
10      continue

        text='Unknown FITSIO status code'
        end

c IMCOPY -- Copy an image of up to 2048 pixels per line.  Works for images of
c up to three dimensions with a pixel type of either short or real.
c
c	usage:  imcopy oldimage newimage
c ----------------------------------------------------------------------------

	program imcopy

	real		rpix(2048)
	integer*2	spix(4096)
	equivalence	(rpix, spix)
	character*80	oimage, nimage, errmsg
	integer		ncols, nlines, nbands, j, k, oim, nim
	integer		ier, axlen(7), naxis, pixtype, nargs

c --- Get command line arguments.
	call clnarg (nargs)
	if (nargs .eq. 2) then
	    call clargc (1, oimage, ier)
	    if (ier .ne. 0) goto 91
	    call clargc (2, nimage, ier)
	    if (ier .ne. 0) goto 91
	else
	    write (*, '('' input image: '',$)')
	    read (*,*) oimage
	    write (*, '('' output image: '',$)')
	    read (*,*) nimage
	endif

c --- Open the input image.
	call imopen (oimage, 1, oim, ier)
	if (ier .ne. 0) goto 91

c --- Create a new output image with the same header and size as the
c	input image.

	call imopnc (nimage, oim, nim, ier)
	if (ier .ne. 0) goto 91

c --- Determine the size and pixel type of the image being copied.
	call imgsiz (oim, axlen, naxis, pixtype, ier)
	if (ier .ne. 0) goto 91
	ncols  = axlen(1)
	nlines = axlen(2)
	nbands = axlen(3)

c --- Copy the image.
	if (pixtype .eq. 3) then
	    do 15 k = 1, nbands
		do 10 j = 1, nlines
		    call imgl3s (oim, spix, j, k, ier)
		    if (ier .ne. 0) goto 91
		    call impl3s (nim, spix, j, k, ier)
		    if (ier .ne. 0) goto 91
 10	        continue
 15	    continue
	else
	    do 25 k = 1, nbands
		do 20 j = 1, nlines
		    call imgl3r (oim, rpix, j, k, ier)
		    if (ier .ne. 0) goto 91
		    call impl3r (nim, rpix, j, k, ier)
		    if (ier .ne. 0) goto 91
 20	        continue
 25	    continue
	endif

c --- Clean up.
	call imclos (oim, ier)
	if (ier .ne. 0) goto 91
	call imclos (nim, ier)
	if (ier .ne. 0) goto 91

	stop

c -- Error actions.
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg

	stop
	end

C----------------------------------------------------------------------
        subroutine ftpbnh(ounit,nrows,nfield,ttype,tform,tunit,
     &                    extnam,pcount,status)

C       OBSOLETE routine: should call ftphbn instead

        integer ounit,nrows,nfield,pcount,status
        character*(*) ttype(*),tform(*),tunit(*),extnam

        call ftphbn(ounit,nrows,nfield,ttype,tform,tunit,
     &                    extnam,pcount,status)
        end

C--------------------------------------------------------------------------
        subroutine ftirec(ounit,pos,record,status)

C       insert a 80-char keyword record into the header at the pos-th keyword
C       position (i.e., immediately before the current keyword at position POS.
C
C       ounit   i  fortran output unit number
C       pos     i  keyword will be inserted at this position (1 = 1st keyword)
C       record  c*80  keyword record
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Jan 1995

        character*(*) record
        integer ounit,pos,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------- -----------------------------

        character*80 outrec, inrec
        integer ibuff, fkey, lkey, i, nexthd, nkey

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

C       calculate number of existing keywords
        nkey=(hdend(ibuff)-hdstrt(ibuff,chdu(ibuff)))/80

        if (pos .eq. nkey+1)then
C               simply append the record to the header
                call ftprec(ounit,record,status)
                return
        else if (pos .lt. 1 .or. pos .gt.  nkey)then
                status=203
                return
        end if

        outrec=record

C       move to the insert position
        nexthd=hdstrt(ibuff,chdu(ibuff))+(pos-1)*80
        call ftmbyt(ounit,nexthd,.false.,status)
        nxthdr(ibuff)=nexthd

C       calculated the first and last keyword to be rewritten
        fkey=pos
        lkey=fkey + (hdend(ibuff)-nexthd)/80 - 1

C       now sequentially read each keyword and overwrite it with the previous
        do 10 i=fkey,lkey
                call ftgrec(ounit,i,inrec,status)
                call ftmodr(ounit,outrec,status)
                outrec=inrec
10      continue

C       finally, write the last keyword
        call ftprec(ounit,outrec,status)

C       reset the next keyword pointer to follow the inserted keyword
        nxthdr(ibuff)=nexthd+80
        end

C--------------------------------------------------------------------------
        subroutine ftmnam(ounit,oldkey,newkey,status)

C       modify (overwrite) the name of an existing keyword, preserving
C       the current value and comment fields
C
C       ounit   i  fortran output unit number
C       oldkey  c  old keyword name    ( 8 characters, cols.  1- 8)
C       newkey  c  new keyword name to be written
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Feb 1992

        character*(*) oldkey,newkey
        integer ounit,status
        character card*80
        
        if (status .gt. 0)return

C       find the old keyword string
        call ftgcrd(ounit,oldkey,card,status)
        
        card(1:8)=newkey

C       make sure new keyword name is in upper case
        call ftupch(card(1:8))

C       test that keyword name contains only legal characters
        call fttkey(card(1:8),status)

C       write the new keyword record
        call ftmodr(ounit,card,status)
        end

      subroutine trans
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c     ray bovet patch to avoid small integers being set to 0
      integer xx,yy
c
      logical         intt
      equivalence     (zz,mz),(temp,itemp)
c     ray bovet patch to avoid small integers being set to 0
c     zz = xx
      mz = xx
      if (intt(zz)) go to 102
      if (mtypex .eq. 0) go to 101
      if (zz .le. 0.0)
     1    call uliber (0,35h0negative argument with log scaling,35)
      zz = amax1(zz,small)
      zz = xfactr*alog10(zz)+xadd
      go to 103
  101 zz = xfactr*zz+xadd
      go to 103
  102 zz = float(ishift(mz-1,mshftx))
  103 mx = max1(0.,amin1(32767.,zz))
c     ray bovet patch to avoid small integers being set to 0
c     zz = yy
      mz = yy
      if (intt(zz)) go to 105
      if (mtypey .eq. 0) go to 104
      if (zz .le. 0.0)
     1    call uliber (0,35h0negative argument with log scaling,35)
      zz = amax1(zz,small)
      zz = yfactr*alog10(zz)+yadd
      go to 106
  104 zz = yfactr*zz+yadd
      go to 106
  105 zz = float(ishift(mz-1,mshfty))
  106 my = max1(0.,amin1(32767.,zz))
      return
      end

C--------------------------------------------------------------------------
        subroutine fthpup(ounit,nbytes,status)

C       shift the binary table heap up by nbytes bytes 

C       ounit   i  fortran output unit number
C       nbytes  i  number of bytes by which to move the heap
C       status  i  returned error status (0=ok)

        integer ounit,nbytes,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer i,ibuff,ntodo,jpoint,nchar,tstat

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

        if (scount(ibuff) .gt. 0)then
            ntodo=scount(ibuff)

C           set pointer to the start of the heap
            jpoint=dtstrt(ibuff)+theap(ibuff)

10          nchar=min(ntodo,5760)

C           move to the read start position
            call ftmbyt(ounit,jpoint,.false.,status)

C           read the heap
            call ftgcbf(ounit,0,nchar,buff,status)

C           move back to the write start postion
            call ftmbyt(ounit,jpoint-nbytes,.false.,status)

C           write the heap
            call ftpcbf(ounit,0,nchar,buff,status)

C           check for error 
            if (status .gt. 0)then
               call ftpmsg('Error while moving heap up (FTUPHP)')
               return
            end if

C           check for more data in the heap
            ntodo=ntodo-nchar
            jpoint=jpoint+nchar
            if (ntodo .gt. 0)go to 10

C           now overwrite the old fill data with zeros
            do 20 i=1,5760
                buff(i)=char(0)
20          continue

            jpoint=dtstrt(ibuff)+theap(ibuff)+scount(ibuff)-nbytes
            call ftmbyt(ounit,jpoint,.false.,status)

            ntodo=nbytes
30          nchar=min(ntodo,5760)
            call ftpcbf(ounit,0,nchar,buff,status)
            ntodo=ntodo-nchar
            if (ntodo .gt. 0)go to 30
        end if

C       update the heap starting address
        theap(ibuff)=theap(ibuff)-nbytes

C       try updating the keyword value, if it exists
        tstat=status
        call ftmkyj(ounit,'THEAP',theap(ibuff),'&',status)
        if (status .eq. 202)status=tstat
        end

      SUBROUTINE slEVP (DATE, DEQX, DVB, DPB, DVH, DPH)
*+
*     - - - -
*      E V P
*     - - - -
*
*  Barycentric and heliocentric velocity and position of the Earth
*
*  All arguments are double precision
*
*  Given:
*
*     DATE          TDB (loosely ET) as a Modified Julian Date
*                                         (JD-2400000.5)
*
*     DEQX          Julian Epoch (e.g. 2000.0D0) of mean equator and
*                   equinox of the vectors returned.  If DEQX .LE. 0D0,
*                   all vectors are referred to the mean equator and
*                   equinox (FK5) of epoch DATE.
*
*  Returned (all 3D Cartesian vectors):
*
*     DVB,DPB       barycentric velocity, position (AU/s, AU)
*     DVH,DPH       heliocentric velocity, position (AU/s, AU)
*
*  Called:  slEPJ, slPREC
*
*  Notes:
*
*  1  This routine is accurate enough for many purposes but faster and
*     more compact than the slEPV routine.  The maximum deviations
*     from the JPL DE96 ephemeris are as follows:
*
*       barycentric velocity         0.42  m/s
*       barycentric position         6900  km
*
*       heliocentric velocity        0.42  m/s
*       heliocentric position        1600  km
*
*  2  The routine is adapted from the BARVEL and BARCOR subroutines of
*     Stumpff (1980).  Most of the changes are merely cosmetic and do
*     not affect the results at all.  However, some adjustments have
*     been made so as to give results that refer to the IAU 1976 'FK5'
*     equinox and precession, although the differences these changes
*     make relative to the results from Stumpff's original 'FK4' version
*     are smaller than the inherent accuracy of the algorithm.  One
*     minor shortcoming in the original routines that has NOT been
*     corrected is that better numerical accuracy could be achieved if
*     the various polynomial evaluations were nested.
*
*  Reference:
*
*    Stumpff, P., Astron.Astrophys.Suppl.Ser. 41, 1-8 (1980).
*
*  Last revision:   7 April 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,DEQX,DVB(3),DPB(3),DVH(3),DPH(3)

      INTEGER IDEQ,I,J,K

      REAL CC2PI,CCSEC3,CCSGD,CCKM,CCMLD,CCFDI,CCIM,T,TSQ,A,PERTL,
     :     PERTLD,PERTR,PERTRD,COSA,SINA,ESQ,E,PARAM,TWOE,TWOG,G,
     :     PHI,F,SINF,COSF,PHID,PSID,PERTP,PERTPD,TL,SINLM,COSLM,
     :     SIGMA,B,PLON,POMG,PECC,FLATM,FLAT

      DOUBLE PRECISION DC2PI,DS2R,DCSLD,DC1MME,DT,DTSQ,DLOCAL,DML,
     :                 DEPS,DPARAM,DPSI,D1PDRO,DRD,DRLD,DTL,DSINLS,
     :                 DCOSLS,DXHD,DYHD,DZHD,DXBD,DYBD,DZBD,DCOSEP,
     :                 DSINEP,DYAHD,DZAHD,DYABD,DZABD,DR,
     :                 DXH,DYH,DZH,DXB,DYB,DZB,DYAH,DZAH,DYAB,
     :                 DZAB,DEPJ,DEQCOR,B1950

      REAL SN(4),CCSEL(3,17),CCAMPS(5,15),CCSEC(3,4),CCAMPM(4,3),
     :     CCPAMV(4),CCPAM(4),FORBEL(7),SORBEL(17),SINLP(4),COSLP(4)
      EQUIVALENCE (SORBEL(1),E),(FORBEL(1),G)

      DOUBLE PRECISION DCFEL(3,8),DCEPS(3),DCARGS(2,15),DCARGM(2,3),
     :                 DPREMA(3,3),W,VW(3)

      DOUBLE PRECISION slEPJ

      PARAMETER (DC2PI=6.2831853071796D0,CC2PI=6.283185)
      PARAMETER (DS2R=0.7272205216643D-4)
      PARAMETER (B1950=1949.9997904423D0)

*
*   Constants DCFEL(I,K) of fast changing elements
*                     I=1                I=2              I=3
      DATA DCFEL/ 1.7400353D+00, 6.2833195099091D+02, 5.2796D-06,
     :            6.2565836D+00, 6.2830194572674D+02,-2.6180D-06,
     :            4.7199666D+00, 8.3997091449254D+03,-1.9780D-05,
     :            1.9636505D-01, 8.4334662911720D+03,-5.6044D-05,
     :            4.1547339D+00, 5.2993466764997D+01, 5.8845D-06,
     :            4.6524223D+00, 2.1354275911213D+01, 5.6797D-06,
     :            4.2620486D+00, 7.5025342197656D+00, 5.5317D-06,
     :            1.4740694D+00, 3.8377331909193D+00, 5.6093D-06/

*
*   Constants DCEPS and CCSEL(I,K) of slowly changing elements
*                      I=1           I=2           I=3
      DATA DCEPS/  4.093198D-01,-2.271110D-04,-2.860401D-08 /
      DATA CCSEL/  1.675104E-02,-4.179579E-05,-1.260516E-07,
     :             2.220221E-01, 2.809917E-02, 1.852532E-05,
     :             1.589963E+00, 3.418075E-02, 1.430200E-05,
     :             2.994089E+00, 2.590824E-02, 4.155840E-06,
     :             8.155457E-01, 2.486352E-02, 6.836840E-06,
     :             1.735614E+00, 1.763719E-02, 6.370440E-06,
     :             1.968564E+00, 1.524020E-02,-2.517152E-06,
     :             1.282417E+00, 8.703393E-03, 2.289292E-05,
     :             2.280820E+00, 1.918010E-02, 4.484520E-06,
     :             4.833473E-02, 1.641773E-04,-4.654200E-07,
     :             5.589232E-02,-3.455092E-04,-7.388560E-07,
     :             4.634443E-02,-2.658234E-05, 7.757000E-08,
     :             8.997041E-03, 6.329728E-06,-1.939256E-09,
     :             2.284178E-02,-9.941590E-05, 6.787400E-08,
     :             4.350267E-02,-6.839749E-05,-2.714956E-07,
     :             1.348204E-02, 1.091504E-05, 6.903760E-07,
     :             3.106570E-02,-1.665665E-04,-1.590188E-07/

*
*   Constants of the arguments of the short-period perturbations
*   by the planets:   DCARGS(I,K)
*                       I=1               I=2
      DATA DCARGS/ 5.0974222D+00,-7.8604195454652D+02,
     :             3.9584962D+00,-5.7533848094674D+02,
     :             1.6338070D+00,-1.1506769618935D+03,
     :             2.5487111D+00,-3.9302097727326D+02,
     :             4.9255514D+00,-5.8849265665348D+02,
     :             1.3363463D+00,-5.5076098609303D+02,
     :             1.6072053D+00,-5.2237501616674D+02,
     :             1.3629480D+00,-1.1790629318198D+03,
     :             5.5657014D+00,-1.0977134971135D+03,
     :             5.0708205D+00,-1.5774000881978D+02,
     :             3.9318944D+00, 5.2963464780000D+01,
     :             4.8989497D+00, 3.9809289073258D+01,
     :             1.3097446D+00, 7.7540959633708D+01,
     :             3.5147141D+00, 7.9618578146517D+01,
     :             3.5413158D+00,-5.4868336758022D+02/

*
*   Amplitudes CCAMPS(N,K) of the short-period perturbations
*           N=1          N=2          N=3          N=4          N=5
      DATA CCAMPS/
     : -2.279594E-5, 1.407414E-5, 8.273188E-6, 1.340565E-5,-2.490817E-7,
     : -3.494537E-5, 2.860401E-7, 1.289448E-7, 1.627237E-5,-1.823138E-7,
     :  6.593466E-7, 1.322572E-5, 9.258695E-6,-4.674248E-7,-3.646275E-7,
     :  1.140767E-5,-2.049792E-5,-4.747930E-6,-2.638763E-6,-1.245408E-7,
     :  9.516893E-6,-2.748894E-6,-1.319381E-6,-4.549908E-6,-1.864821E-7,
     :  7.310990E-6,-1.924710E-6,-8.772849E-7,-3.334143E-6,-1.745256E-7,
     : -2.603449E-6, 7.359472E-6, 3.168357E-6, 1.119056E-6,-1.655307E-7,
     : -3.228859E-6, 1.308997E-7, 1.013137E-7, 2.403899E-6,-3.736225E-7,
     :  3.442177E-7, 2.671323E-6, 1.832858E-6,-2.394688E-7,-3.478444E-7,
     :  8.702406E-6,-8.421214E-6,-1.372341E-6,-1.455234E-6,-4.998479E-8,
     : -1.488378E-6,-1.251789E-5, 5.226868E-7,-2.049301E-7, 0.0E0,
     : -8.043059E-6,-2.991300E-6, 1.473654E-7,-3.154542E-7, 0.0E0,
     :  3.699128E-6,-3.316126E-6, 2.901257E-7, 3.407826E-7, 0.0E0,
     :  2.550120E-6,-1.241123E-6, 9.901116E-8, 2.210482E-7, 0.0E0,
     : -6.351059E-7, 2.341650E-6, 1.061492E-6, 2.878231E-7, 0.0E0/

*
*   Constants of the secular perturbations in longitude
*   CCSEC3 and CCSEC(N,K)
*                      N=1           N=2           N=3
      DATA CCSEC3/-7.757020E-08/,
     :     CCSEC/  1.289600E-06, 5.550147E-01, 2.076942E+00,
     :             3.102810E-05, 4.035027E+00, 3.525565E-01,
     :             9.124190E-06, 9.990265E-01, 2.622706E+00,
     :             9.793240E-07, 5.508259E+00, 1.559103E+01/

*   Sidereal rate DCSLD in longitude, rate CCSGD in mean anomaly
      DATA DCSLD/1.990987D-07/,
     :     CCSGD/1.990969E-07/

*   Some constants used in the calculation of the lunar contribution
      DATA CCKM/3.122140E-05/,
     :     CCMLD/2.661699E-06/,
     :     CCFDI/2.399485E-07/

*
*   Constants DCARGM(I,K) of the arguments of the perturbations
*   of the motion of the Moon
*                       I=1               I=2
      DATA DCARGM/  5.1679830D+00, 8.3286911095275D+03,
     :              5.4913150D+00,-7.2140632838100D+03,
     :              5.9598530D+00, 1.5542754389685D+04/

*
*   Amplitudes CCAMPM(N,K) of the perturbations of the Moon
*            N=1          N=2           N=3           N=4
      DATA CCAMPM/
     :  1.097594E-01, 2.896773E-07, 5.450474E-02, 1.438491E-07,
     : -2.223581E-02, 5.083103E-08, 1.002548E-02,-2.291823E-08,
     :  1.148966E-02, 5.658888E-08, 8.249439E-03, 4.063015E-08/

*
*   CCPAMV(K)=A*M*DL/DT (planets), DC1MME=1-MASS(Earth+Moon)
      DATA CCPAMV/8.326827E-11,1.843484E-11,1.988712E-12,1.881276E-12/
      DATA DC1MME/0.99999696D0/

*   CCPAM(K)=A*M(planets), CCIM=INCLINATION(Moon)
      DATA CCPAM/4.960906E-3,2.727436E-3,8.392311E-4,1.556861E-3/
      DATA CCIM/8.978749E-2/




*
*   EXECUTION
*   ---------

*   Control parameter IDEQ, and time arguments
      IDEQ = 0
      IF (DEQX.GT.0D0) IDEQ=1
      DT = (DATE-15019.5D0)/36525D0
      T = REAL(DT)
      DTSQ = DT*DT
      TSQ = REAL(DTSQ)

*   Values of all elements for the instant DATE
      DO K=1,8
         DLOCAL = MOD(DCFEL(1,K)+DT*DCFEL(2,K)+DTSQ*DCFEL(3,K), DC2PI)
         IF (K.EQ.1) THEN
            DML = DLOCAL
         ELSE
            FORBEL(K-1) = REAL(DLOCAL)
         END IF
      END DO
      DEPS = MOD(DCEPS(1)+DT*DCEPS(2)+DTSQ*DCEPS(3), DC2PI)
      DO K=1,17
         SORBEL(K) = MOD(CCSEL(1,K)+T*CCSEL(2,K)+TSQ*CCSEL(3,K),
     :                   CC2PI)
      END DO

*   Secular perturbations in longitude
      DO K=1,4
         A = MOD(CCSEC(2,K)+T*CCSEC(3,K), CC2PI)
         SN(K) = SIN(A)
      END DO

*   Periodic perturbations of the EMB (Earth-Moon barycentre)
      PERTL =  CCSEC(1,1)          *SN(1) +CCSEC(1,2)*SN(2)+
     :        (CCSEC(1,3)+T*CCSEC3)*SN(3) +CCSEC(1,4)*SN(4)
      PERTLD = 0.0
      PERTR = 0.0
      PERTRD = 0.0
      DO K=1,15
         A = SNGL(MOD(DCARGS(1,K)+DT*DCARGS(2,K), DC2PI))
         COSA = COS(A)
         SINA = SIN(A)
         PERTL = PERTL + CCAMPS(1,K)*COSA+CCAMPS(2,K)*SINA
         PERTR = PERTR + CCAMPS(3,K)*COSA+CCAMPS(4,K)*SINA
         IF (K.LT.11) THEN
            PERTLD = PERTLD+
     :               (CCAMPS(2,K)*COSA-CCAMPS(1,K)*SINA)*CCAMPS(5,K)
            PERTRD = PERTRD+
     :               (CCAMPS(4,K)*COSA-CCAMPS(3,K)*SINA)*CCAMPS(5,K)
         END IF
      END DO

*   Elliptic part of the motion of the EMB
      ESQ = E*E
      DPARAM = 1D0-DBLE(ESQ)
      PARAM = REAL(DPARAM)
      TWOE = E+E
      TWOG = G+G
      PHI = TWOE*((1.0-ESQ*0.125)*SIN(G)+E*0.625*SIN(TWOG)
     :          +ESQ*0.54166667*SIN(G+TWOG) )
      F = G+PHI
      SINF = SIN(F)
      COSF = COS(F)
      DPSI = DPARAM/(1D0+DBLE(E*COSF))
      PHID = TWOE*CCSGD*((1.0+ESQ*1.5)*COSF+E*(1.25-SINF*SINF*0.5))
      PSID = CCSGD*E*SINF/SQRT(PARAM)

*   Perturbed heliocentric motion of the EMB
      D1PDRO = 1D0+DBLE(PERTR)
      DRD = D1PDRO*(DBLE(PSID)+DPSI*DBLE(PERTRD))
      DRLD = D1PDRO*DPSI*(DCSLD+DBLE(PHID)+DBLE(PERTLD))
      DTL = MOD(DML+DBLE(PHI)+DBLE(PERTL), DC2PI)
      DSINLS = SIN(DTL)
      DCOSLS = COS(DTL)
      DXHD = DRD*DCOSLS-DRLD*DSINLS
      DYHD = DRD*DSINLS+DRLD*DCOSLS

*   Influence of eccentricity, evection and variation on the
*   geocentric motion of the Moon
      PERTL = 0.0
      PERTLD = 0.0
      PERTP = 0.0
      PERTPD = 0.0
      DO K=1,3
         A = SNGL(MOD(DCARGM(1,K)+DT*DCARGM(2,K), DC2PI))
         SINA = SIN(A)
         COSA = COS(A)
         PERTL = PERTL +CCAMPM(1,K)*SINA
         PERTLD = PERTLD+CCAMPM(2,K)*COSA
         PERTP = PERTP +CCAMPM(3,K)*COSA
         PERTPD = PERTPD-CCAMPM(4,K)*SINA
      END DO

*   Heliocentric motion of the Earth
      TL = FORBEL(2)+PERTL
      SINLM = SIN(TL)
      COSLM = COS(TL)
      SIGMA = CCKM/(1.0+PERTP)
      A = SIGMA*(CCMLD+PERTLD)
      B = SIGMA*PERTPD
      DXHD = DXHD+DBLE(A*SINLM)+DBLE(B*COSLM)
      DYHD = DYHD-DBLE(A*COSLM)+DBLE(B*SINLM)
      DZHD =     -DBLE(SIGMA*CCFDI*COS(FORBEL(3)))

*   Barycentric motion of the Earth
      DXBD = DXHD*DC1MME
      DYBD = DYHD*DC1MME
      DZBD = DZHD*DC1MME
      DO K=1,4
         PLON = FORBEL(K+3)
         POMG = SORBEL(K+1)
         PECC = SORBEL(K+9)
         TL = MOD(PLON+2.0*PECC*SIN(PLON-POMG), CC2PI)
         SINLP(K) = SIN(TL)
         COSLP(K) = COS(TL)
         DXBD = DXBD+DBLE(CCPAMV(K)*(SINLP(K)+PECC*SIN(POMG)))
         DYBD = DYBD-DBLE(CCPAMV(K)*(COSLP(K)+PECC*COS(POMG)))
         DZBD = DZBD-DBLE(CCPAMV(K)*SORBEL(K+13)*COS(PLON-SORBEL(K+5)))
      END DO

*   Transition to mean equator of date
      DCOSEP = COS(DEPS)
      DSINEP = SIN(DEPS)
      DYAHD = DCOSEP*DYHD-DSINEP*DZHD
      DZAHD = DSINEP*DYHD+DCOSEP*DZHD
      DYABD = DCOSEP*DYBD-DSINEP*DZBD
      DZABD = DSINEP*DYBD+DCOSEP*DZBD

*   Heliocentric coordinates of the Earth
      DR = DPSI*D1PDRO
      FLATM = CCIM*SIN(FORBEL(3))
      A = SIGMA*COS(FLATM)
      DXH = DR*DCOSLS-DBLE(A*COSLM)
      DYH = DR*DSINLS-DBLE(A*SINLM)
      DZH =          -DBLE(SIGMA*SIN(FLATM))

*   Barycentric coordinates of the Earth
      DXB = DXH*DC1MME
      DYB = DYH*DC1MME
      DZB = DZH*DC1MME
      DO K=1,4
         FLAT = SORBEL(K+13)*SIN(FORBEL(K+3)-SORBEL(K+5))
         A = CCPAM(K)*(1.0-SORBEL(K+9)*COS(FORBEL(K+3)-SORBEL(K+1)))
         B = A*COS(FLAT)
         DXB = DXB-DBLE(B*COSLP(K))
         DYB = DYB-DBLE(B*SINLP(K))
         DZB = DZB-DBLE(A*SIN(FLAT))
      END DO

*   Transition to mean equator of date
      DYAH = DCOSEP*DYH-DSINEP*DZH
      DZAH = DSINEP*DYH+DCOSEP*DZH
      DYAB = DCOSEP*DYB-DSINEP*DZB
      DZAB = DSINEP*DYB+DCOSEP*DZB

*   Copy result components into vectors, correcting for FK4 equinox
      DEPJ=slEPJ(DATE)
      DEQCOR = DS2R*(0.035D0+0.00085D0*(DEPJ-B1950))
      DVH(1) = DXHD-DEQCOR*DYAHD
      DVH(2) = DYAHD+DEQCOR*DXHD
      DVH(3) = DZAHD
      DVB(1) = DXBD-DEQCOR*DYABD
      DVB(2) = DYABD+DEQCOR*DXBD
      DVB(3) = DZABD
      DPH(1) = DXH-DEQCOR*DYAH
      DPH(2) = DYAH+DEQCOR*DXH
      DPH(3) = DZAH
      DPB(1) = DXB-DEQCOR*DYAB
      DPB(2) = DYAB+DEQCOR*DXB
      DPB(3) = DZAB

*   Was precession to another equinox requested?
      IF (IDEQ.NE.0) THEN

*     Yes: compute precession matrix from MJD DATE to Julian epoch DEQX
         CALL slPREC(DEPJ,DEQX,DPREMA)

*     Rotate DVH
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DVH(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DVH(J)=VW(J)
         END DO

*     Rotate DVB
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DVB(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DVB(J)=VW(J)
         END DO

*     Rotate DPH
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DPH(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DPH(J)=VW(J)
         END DO

*     Rotate DPB
         DO J=1,3
            W=0D0
            DO I=1,3
               W=W+DPREMA(J,I)*DPB(I)
            END DO
            VW(J)=W
         END DO
         DO J=1,3
            DPB(J)=VW(J)
         END DO
      END IF

      END

c     prog1
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	 demonstrate algorithms hft and hs1 for solving least squares
c     problems and algorithm cov for omputing the associated covariance
c     matrices.
c
      dimension a(8,8),h(8),b(8)
      real gen,anoise
      double precision sm
      data mda/8/
c
	   do 180 noise=1,2
	   anoise=0.
	   if (noise.eq.2) anoise=1.e-4
	   write (6,230)
	   write (6,240) anoise
c     initialize the data generation function
c    ..
	   dummy=gen(-1.)
		do 180 mn1=1,6,5
		mn2=mn1+2
		     do 180 m=mn1,mn2
		     do 180 n=mn1,mn2
		     np1=n+1
		     write (6,250) m,n
c     generate data
c    ..
			  do 10 i=1,m
			       do 10 j=1,n
   10			       a(i,j)=gen(anoise)
			  do 20 i=1,m
   20			  b(i)=gen(anoise)
		     if(m .lt. n) go to 180
c
c     ******  begin algorithm hft  ******
c    ..
			  do 30 j=1,n
   30		   call h12 (1,j,j+1,m,a(1,j),1,h(j),a(1,j+1),1,mda,n-j)
c    ..
c     the algorithm 'hft' is completed.
c
c     ******  begin algorithm hs1  ******
c     apply the transformations  q(n)...q(1)=q to b
c     replacing the previous contents of the array, b .
c    ..
			  do 40 j=1,n
   40			      call h12 (2,j,j+1,m,a(1,j),1,h(j),b,1,1,1)
c     solve the triangular system for the solution x.
c     store x in the array, b .
c    ..
			  do 80 k=1,n
			  i=np1-k
			  sm=0.d0
			  if (i.eq.n) go to 60
			  ip1=i+1
			       do 50 j=ip1,n
   50			       sm=sm+a(i,j)*dble(b(j))
   60			  if (a(i,i)) 80,70,80
   70			  write (6,260)
			  go to 180
   80			  b(i)=(b(i)-sm)/a(i,i)
c      compute length of residual vector.
c     ..
		     srsmsq=0.
		     if (n.eq.m) go to 100
		     mmn=m-n
			  do 90 j=1,mmn
			  npj=n+j
   90			  srsmsq=srsmsq+b(npj)**2
		     srsmsq=sqrt(srsmsq)
c     ******  begin algorithm  cov  ******
c     compute unscaled covariance matrix   ((a**t)*a)**(-1)
c    ..
  100			  do 110 j=1,n
  110			  a(j,j)=1./a(j,j)
		     if (n.eq.1) go to 140
		     nm1=n-1
			  do 130 i=1,nm1
			  ip1=i+1
			       do 130 j=ip1,n
			       jm1=j-1
			       sm=0.d0
				    do 120 l=i,jm1
  120				    sm=sm+a(i,l)*dble(a(l,j))
  130			       a(i,j)=-sm*a(j,j)
c    ..
c     the upper triangle of a has been inverted
c     upon itself.
  140			  do 160 i=1,n
			       do 160 j=i,n
			       sm=0.d0
				    do 150 l=j,n
  150				    sm=sm+a(i,l)*dble(a(j,l))
  160			       a(i,j)=sm
c    ..
c     the upper triangular part of the
c     symmetric matrix (a**t*a)**(-1) has
c     replaced the upper triangular part of
c     the a array.
		     write (6,200) (i,b(i),i=1,n)
		     write (6,190) srsmsq
		     write (6,210)
			  do 170 i=1,n
  170			  write (6,220) (i,j,a(i,j),j=i,n)
  180		     continue
      stop
  190 format (1h0,8x,17hresidual length =,e12.4)
  200 format (1h0,8x,34hestimated parameters,  x=a**(+)*b,,22h computed
     1by 'hft,hs1'//(9x,i6,e16.8,i6,e16.8,i6,e16.8,i6,e16.8,i6,e16.8))
  210 format (1h0,8x,31hcovariance matrix (unscaled) of,22h estimated pa
     1rameters.,19h computed by 'cov'./1x)
  220 format (9x,2i3,e16.8,2i3,e16.8,2i3,e16.8,2i3,e16.8,2i3,e16.8)
  230 format (52h1 prog1.    this program demonstrates the algorithms,19
     1h hft, hs1, and cov.//40h caution.. 'prog1' does no checking for ,
     252hnear rank deficient matrices.  results in such cases,20h may be
     3 meaningless.,/34h such cases are handled by 'prog2',11h or 'pro
     4')
  240 format (1h0,54hthe relative noise level of the generated data will
     1 be,e16.4)
  250 format (1h0////9h0   m   n/1x,2i4)
  260 format (1h0,8x,36h******  terminating this case due to,37h a divis
     1or being exactly zero. ******)
      end

      integer function gtok (lexstr, toksiz)
      integer lexstr (100)
      integer toksiz
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer c
      integer ngetch
      integer i
      c = ngetch (lexstr (1))
      if (.not.(c .eq. 32 .or. c .eq. 9))goto 23000
      lexstr (1) = 32
23002 if (.not.(c .eq. 32 .or. c .eq. 9))goto 23003
      c = ngetch (c)
      goto 23002
23003 continue
      if (.not.(c .eq. 35))goto 23004
23006 if (.not.(ngetch (c) .ne. 10))goto 23007
      goto 23006
23007 continue
23004 continue
      if (.not.(c .ne. 10))goto 23008
      call putbak (c)
      goto 23009
23008 continue
      lexstr (1) = 10
23009 continue
      lexstr (2) = -2
      gtok = lexstr (1)
      return
23000 continue
      i = 1
      if (.not.(((65.le.c.and.c.le.90).or.(97.le.c.and.c.le.122))))goto 
     *23010
      gtok = -9
      if (.not.(c .eq. 120))goto 23012
      c = ngetch (lexstr(2))
      if (.not.(c .eq. 36))goto 23014
      gtok =  -166
      i = 2
      goto 23015
23014 continue
      call putbak (c)
23015 continue
23012 continue
23016 if (.not.(i .lt. toksiz - 2))goto 23018
      c = ngetch (lexstr(i+1))
      if (.not.(.not.((65.le.c.and.c.le.90).or.(97.le.c.and.c.le.122)) .
     *and. .not.(48.le.c.and.c.le.57) .and. c .ne. 95))goto 23019
      goto 23018
23019 continue
23017 i=i+1
      goto 23016
23018 continue
      call putbak (c)
      goto 23011
23010 continue
      if (.not.((48.le.c.and.c.le.57)))goto 23021
      i=1
23023 if (.not.(i .lt. toksiz - 2))goto 23025
      c = ngetch (lexstr (i + 1))
      if (.not.(.not.(48.le.c.and.c.le.57)))goto 23026
      goto 23025
23026 continue
23024 i=i+1
      goto 23023
23025 continue
      call putbak (c)
      gtok = 48
      goto 23022
23021 continue
      if (.not.(c .eq. 91))goto 23028
      lexstr (1) = 123
      gtok = 123
      goto 23029
23028 continue
      if (.not.(c .eq. 93))goto 23030
      lexstr (1) = 125
      gtok = 125
      goto 23031
23030 continue
      if (.not.(c .eq. 36))goto 23032
      if (.not.(ngetch (lexstr (2)) .eq. 40))goto 23034
      i = 2
      gtok = -69
      goto 23035
23034 continue
      if (.not.(lexstr (2) .eq. 41))goto 23036
      i = 2
      gtok = -68
      goto 23037
23036 continue
      call putbak (lexstr (2))
      gtok = 36
23037 continue
23035 continue
      goto 23033
23032 continue
      if (.not.(c .eq. 39 .or. c .eq. 34))goto 23038
      gtok = c
      i = 2
23040 if (.not.(ngetch (lexstr (i)) .ne. lexstr (1)))goto 23042
      if (.not.(lexstr (i) .eq. 95))goto 23043
      if (.not.(ngetch (c) .eq. 10))goto 23045
23047 if (.not.(c .eq. 10 .or. c .eq. 32 .or. c .eq. 9))goto 23048
      c = ngetch (c)
      goto 23047
23048 continue
      lexstr (i) = c
      goto 23046
23045 continue
      call putbak (c)
23046 continue
23043 continue
      if (.not.(lexstr (i) .eq. 10 .or. i .ge. toksiz - 1))goto 23049
      call synerr (14Hmissing quote.)
      lexstr (i) = lexstr (1)
      call putbak (10)
      goto 23042
23049 continue
23041 i = i + 1
      goto 23040
23042 continue
      goto 23039
23038 continue
      if (.not.(c .eq. 35))goto 23051
23053 if (.not.(ngetch (lexstr (1)) .ne. 10))goto 23054
      goto 23053
23054 continue
      gtok = 10
      goto 23052
23051 continue
      if (.not.(c .eq. 62 .or. c .eq. 60 .or. c .eq. 126 .or. c .eq. 33 
     *.or. c .eq. 126 .or. c .eq. 94 .or. c .eq. 61 .or. c .eq. 38 .or. 
     *c .eq. 124))goto 23055
      call relate (lexstr, i)
      gtok = c
      goto 23056
23055 continue
      gtok = c
23056 continue
23052 continue
23039 continue
23033 continue
23031 continue
23029 continue
23022 continue
23011 continue
      if (.not.(i .ge. toksiz - 1))goto 23057
      call synerr (15Htoken too long.)
23057 continue
      lexstr (i + 1) = -2
      return
      end
c     logic0  logical_column

C--------------------------------------------------------------------------
        subroutine ftinit(funit,fname,block,status)

C       open a new FITS file with write access
C
C       funit   i  Fortran I/O unit number
C       fname   c  name of file to be opened
C       block   i  input record length blocking factor
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer funit,status,block,strlen,i
        character*(*) fname

        if (status .gt. 0)return

C       ignore any leading blanks in the file name
        strlen=len(fname)
        do 10 i=1,strlen
            if (fname(i:i) .ne. ' ')then

C               call the machine dependent routine which creates the file
                call ftopnx(funit,fname(i:),1,1,block,status)
                if (status .gt. 0)then
         call ftpmsg('FTINIT failed to create the following new file:')
         call ftpmsg(fname)
                    return
                end if

C               set column descriptors as undefined
                call ftfrcl(funit,-999)

C               set current column name buffer as undefined
                call ftrsnm
                return
            end if
10      continue

C       if we got here, then the input filename was all blanks
        status=105
        call ftpmsg('FTINIT: Name of file to create is blank.')
        end

include	defs

# trmout - pick up name of output channel to users teletype

   subroutine trmout (name)
   character name (ARB)

   string tname TERMINAL_OUT

   call scopy (tname, 1, name, 1)
   return
   end

      SUBROUTINE CFFTF (N,C,WSAVE)
      DIMENSION       C(*)       ,WSAVE(*)
      IF (N .EQ. 1) RETURN
      IW1 = N+N+1
      IW2 = IW1+N+N
      CALL CFFTF1 (N,C,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

#-h-  gettok			 2076  local   12/01/80  15:54:09
# gettok - get token. handles file inclusion and line numbers
   include  defs

character function gettok (token, toksiz)

character token (MAXTOK)
integer toksiz
include COMMON_BLOCKS
integer equal
character t, deftok
#character name(MAXNAME), t
#integer i, len, open, length

string ssubr "x$subr"
string sfunc "x$func"
#string incl "include"

#  for (;  level > 0;  level = level - 1) {

	gettok = deftok (token, toksiz)
	if (gettok != EOF) {
	    if (gettok == XPP_DIRECTIVE) {
	        if (equal (token, sfunc) == YES) {
		    call skpblk
		    t = deftok (fcname, MAXNAME)
		    call pbstr (fcname)
		    if (t != ALPHA)
		        call synerr ("Missing function name.")
		    call putbak (BLANK)
		    swvnum = 0
		    swvlev = 0
		    return
	        } else if (equal (token, ssubr) == YES) {
		    swvnum = 0
		    swvlev = 0
		    return
	        } else
		    return
	     }
	     return
	}

	token (1) = EOF
	token (2) = EOS
	gettok = EOF
	return
end


# -- Includes are now processed elsewhere

#	 else if (equal (token, incl) == NO)
#	    return
#
#	 # process 'include' statements:
#	 call skpblk
#	 t = deftok (name, MAXNAME)
#	 if (t == SQUOTE | t == DQUOTE) {
#	    len = length (name) - 1
#	    for (i = 1; i < len; i = i + 1)
#	       name (i) = name (i + 1)
#	    name (i) = EOS
#	    }
#	 i = length (name) + 1
#	 if (level >= NFILES)
#	    call synerr ("includes nested too deeply.")
#	 else {
#	    infile (level + 1) = open (name, READ)
#	    linect (level + 1) = 0
#	    if (infile (level + 1) == ERR)
#	       call synerr ("can't open include.")
#	    else {
#	       level = level + 1
#	       if (fnamp + i <= MAXFNAMES) {
#		  call scopy (name, 1, fnames, fnamp)
#		  fnamp = fnamp + i    # push file name stack
#		  }
#	       }
#	    }
#	 }
#      if (level > 1) {	    # close include file pop file name stack
#	 call close (infile (level))
#	 for (fnamp = fnamp - 1; fnamp > 1; fnamp = fnamp - 1)
#	    if (fnames (fnamp - 1) == EOS)
#	       break
#	 }

#    }

#-h-  push			  249  local   12/01/80  15:54:34
# push - push ep onto argstk, return new pointer ap
   include  defs

   integer function push (ep, argstk, ap)
   integer ap, argstk (ARGSIZE), ep

   if (ap > ARGSIZE)
      call baderr ('arg stack overflow.')
   argstk (ap) = ep
   push = ap + 1
   return
   end

c BYTMOV -- Byte move from array "a" to array "b".  The move must be
c nondestructive, allowing a byte array to be shifted left or right a
c few bytes, hence calls to zlocva() are required to get the addresses of 
c the arrays.

	subroutine bytmov (a, aoff, b, boff, nbytes)

	character*1 a(*), b(*)
	integer	aoff, boff, nbytes
	integer	fwaa, lwaa, fwab, i

		call zlocva (a(aoff), fwaa)
		call zlocva (a(aoff+nbytes-1), lwaa)
		call zlocva (b(boff), fwab)

		if (fwaa .eq. fwab) then
		    return
		else if (fwab .ge. fwaa .and. fwab .le. lwaa) then
		    do 10 i = nbytes-1, 0, -1
			b(boff+i) = a(aoff+i)
 10		    continue
		else
		    do 20 i = 0, nbytes-1
			b(boff+i) = a(aoff+i)
 20		    continue
		endif
	end

      SUBROUTINE slKBJ (JB, E, K, J)
*+
*     - - - -
*      K B J
*     - - - -
*
*  Select epoch prefix 'B' or 'J'
*
*  Given:
*     JB     int     slDBJI prefix status:  0=none, 1='B', 2='J'
*     E      dp      epoch - Besselian or Julian
*
*  Returned:
*     K      char    'B' or 'J'
*     J      int     status:  0=OK
*
*  If JB=0, B is assumed for E < 1984D0, otherwise J.
*
*  P.T.Wallace   Starlink   31 July 1989
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER JB
      DOUBLE PRECISION E
      CHARACTER K*(*)
      INTEGER J

*  Preset status
      J=0

*  If prefix given expressly, use it
      IF (JB.EQ.1) THEN
         K='B'
      ELSE IF (JB.EQ.2) THEN
         K='J'

*  If no prefix, examine the epoch
      ELSE IF (JB.EQ.0) THEN

*     If epoch is pre-1984.0, assume Besselian;  otherwise Julian
         IF (E.LT.1984D0) THEN
            K='B'
         ELSE
            K='J'
         END IF

*  If illegal prefix, return error status
      ELSE
         K=' '
         J=1
      END IF

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE IDIOT (XDRA,YDRA,NPTS,LTYP,LDSH,LABX,LABY,LABG,LFRA)
C
      REAL XDRA(*),YDRA(*)
C
      INTEGER LDSH(*)
C
      CHARACTER*(*) LABX,LABY,LABG
C
      CHARACTER*16 AGBNCH
C
C This is an implementation of the routine from which AUTOGRAPH grew.
C It should work pretty much as the original did (if you can figure out
C what that was).
C
C Do statistics-gathering call.
C
      LOGICAL Q8Q4
      SAVE Q8Q4
      DATA Q8Q4 /.TRUE./
      IF (Q8Q4) THEN
        CALL Q8QST4('GRAPHX','AUTOGRAPH','IDIOT','VERSION 07')
        Q8Q4 = .FALSE.
      ENDIF
C
C +NOAO
C
      call agdflt
C 
C -NOAO
      CALL ANOTAT (LABX,LABY,1,2-ISIGN(1,NPTS),1,AGBNCH(LDSH))
C
      CALL DISPLA (2-MAX0(-1,MIN0(1,LFRA)),1,LTYP)
C
      CALL AGEZSU (5,XDRA,YDRA,IABS(NPTS),1,IABS(NPTS),LABG,IIVX,IIEX,
     +                                                        IIVY,IIEY)
      CALL AGBACK
C
      CALL AGCURV (XDRA,1,YDRA,1,IABS(NPTS),1)
C
      IF (LFRA.GT.0) CALL FRAME
C
C +NOAO
C
      call plotit (0, 0, 2)
      call initut
C
C -NOAO
      RETURN
      END

#-h-  entrkw			 1003  local   12/01/80  15:54:06
# entrkw --- install Ratfor keywords in symbol table
   include  defs

   subroutine entrkw

   include COMMON_BLOCKS

   string sif "if"
   string selse "else"
   string swhile "while"
   string sdo "do"
   string sbreak "break"
   string snext "next"
   string sfor "for"
   string srept "repeat"
   string suntil "until"
   string sret "return"
   string sstr "string"
   string sswtch "switch"
   string scase "case"
   string sdeflt "default"
   string send "end"
   string serrchk "errchk"
   string siferr "iferr"
   string sifnoerr "ifnoerr"
   string sthen "then"
   string sbegin "begin"
   string spoint "pointer"
   string sgoto "goto"

   call enter (sif, LEXIF, rkwtbl)
   call enter (selse, LEXELSE, rkwtbl)
   call enter (swhile, LEXWHILE, rkwtbl)
   call enter (sdo, LEXDO, rkwtbl)
   call enter (sbreak, LEXBREAK, rkwtbl)
   call enter (snext, LEXNEXT, rkwtbl)
   call enter (sfor, LEXFOR, rkwtbl)
   call enter (srept, LEXREPEAT, rkwtbl)
   call enter (suntil, LEXUNTIL, rkwtbl)
   call enter (sret, LEXRETURN, rkwtbl)
   call enter (sstr, LEXSTRING, rkwtbl)
   call enter (sswtch, LEXSWITCH, rkwtbl)
   call enter (scase, LEXCASE, rkwtbl)
   call enter (sdeflt, LEXDEFAULT, rkwtbl)
   call enter (send, LEXEND, rkwtbl)
   call enter (serrchk, LEXERRCHK, rkwtbl)
   call enter (siferr, LEXIFERR, rkwtbl)
   call enter (sifnoerr, LEXIFNOERR, rkwtbl)
   call enter (sthen, LEXTHEN, rkwtbl)
   call enter (sbegin, LEXBEGIN, rkwtbl)
   call enter (spoint, LEXPOINTER, rkwtbl)
   call enter (sgoto, LEXGOTO, rkwtbl)

   return
   end

include	defs

# dsdbiu --- dump contents of block-in-use

   subroutine dsdbiu (b, form)
   pointer b
   character form

   DS_COMMON

   integer l, s, lmax

   string blanks "	    "

   call putint (b, 5, ERROUT)
   call putch (BLANK, ERROUT)
   call putint (Mem (b + DS_SIZE), 0, ERROUT)
   call remark (" words in use.")

   l = 0
   s = b + Mem (b + DS_SIZE)
   if (form == DIGIT)
      lmax = 5
   else
      lmax = 50

   for (b = b + DS_OHEAD; b < s; b = b + 1) {
      if (l == 0)
	 call putlin (blanks, ERROUT)
      if (form == DIGIT)
	 call putint (Mem (b), 10, ERROUT)
      else if (form == LETTER)
	 call putch (Mem (b), ERROUT)
      l = l + 1
      if (l >= lmax) {
	 l = 0
	 call putch (NEWLINE, ERROUT)
	 }
      }

   if (l != 0)
      call putch (NEWLINE, ERROUT)

   return
   end

      subroutine fcblok ( bloks, integs, nbloks, ipivot, scrtch, iflag )
calls subroutines  f a c t r b	and  s h i f t b .
c
c   f c b l o k  supervises the plu factorization with pivoting of
c  scaled rows of the almost block diagonal matrix stored in the arrays
c   b l o k s  and  i n t e g s .
c
c   factrb = subprogram which carries out steps 1,...,last of gauss
c	     elimination (with pivoting) for an individual block.
c   shiftb = subprogram which shifts the remaining rows to the top of
c	     the next block
c
c parameters
c    bloks   an array that initially contains the almost block diagonal
c	     matrix  a	to be factored, and on return contains the com-
c	     puted factorization of  a .
c    integs  an integer array describing the block structure of  a .
c    nbloks  the number of blocks in  a .
c    ipivot  an integer array of dimension  sum (integs(1,n) ; n=1,
c	     ...,nbloks) which, on return, contains the pivoting stra-
c	     tegy used.
c    scrtch  work area required, of length  max (integs(1,n) ; n=1,
c	     ...,nbloks).
c    iflag   output parameter;
c	     = 0  in case matrix was found to be singular.
c	     otherwise,
c	     = (-1)**(number of row interchanges during factorization)
c
      integer nbloks
      integer integs(3,nbloks),ipivot(1),iflag, i,index,indexb,indexn,
     *	      last,ncol,nrow
      real bloks(1),scrtch(1)
      iflag = 1
      indexb = 1
      indexn = 1
      i = 1
c			 loop over the blocks.	i  is loop index
   10	 index = indexn
	 nrow = integs(1,i)
	 ncol = integs(2,i)
	 last = integs(3,i)
c	 carry out elimination on the i-th block until next block
c	 enters, i.e., for columns 1,...,last  of i-th block.
	 call factrb(bloks(index),ipivot(indexb),scrtch,nrow,ncol,last,
     *		  iflag)
c	  check for having reached a singular block or the last block
	 if (iflag .eq. 0 .or. i .eq. nbloks)
     *					return
	 i = i+1
	 indexn = nrow*ncol + index
c	       put the rest of the i-th block onto the next block
	 call shiftb(bloks(index),ipivot(indexb),nrow,ncol,last,
     *		  bloks(indexn),integs(1,i),integs(2,i))
	 indexb = indexb + nrow
					go to 10
      end

      SUBROUTINE slPVOB (P, H, STL, PV)
*+
*     - - - - - -
*      P V O B
*     - - - - - -
*
*  Position and velocity of an observing station (double precision)
*
*  Given:
*     P     dp     latitude (geodetic, radians)
*     H     dp     height above reference spheroid (geodetic, metres)
*     STL   dp     local apparent sidereal time (radians)
*
*  Returned:
*     PV    dp(6)  position/velocity 6-vector (AU, AU/s, true equator
*                                              and equinox of date)
*
*  Called:  slGEOC
*
*  IAU 1976 constants are used.
*
*  P.T.Wallace   Starlink   14 November 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION P,H,STL,PV(6)

      DOUBLE PRECISION R,Z,S,C,V

*  Mean sidereal rate (at J2000) in radians per (UT1) second
      DOUBLE PRECISION SR
      PARAMETER (SR=7.292115855306589D-5)



*  Geodetic to geocentric conversion
      CALL slGEOC(P,H,R,Z)

*  Functions of ST
      S=SIN(STL)
      C=COS(STL)

*  Speed
      V=SR*R

*  Position
      PV(1)=R*C
      PV(2)=R*S
      PV(3)=Z

*  Velocity
      PV(4)=-V*S
      PV(5)=V*C
      PV(6)=0D0

      END

      subroutine evalr (argstk, i, j)
      integer argstk (100), i, j
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer argno, k, m, n, t, td, instr0, delim
      external index
      integer index, length
      integer digits(11)
      data digits(1)/48/,digits(2)/49/,digits(3)/50/,digits(4)/51/,digit
     *s(5)/52/,digits(6)/53/,digits(7)/54/,digits(8)/55/,digits(9)/56/,d
     *igits(10)/57/,digits(11)/-2/
      t = argstk (i)
      td = evalst (t)
      if (.not.(td .eq. -10))goto 23000
      call domac (argstk, i, j)
      goto 23001
23000 continue
      if (.not.(td .eq. -12))goto 23002
      call doincr (argstk, i, j)
      goto 23003
23002 continue
      if (.not.(td .eq. -13))goto 23004
      call dosub (argstk, i, j)
      goto 23005
23004 continue
      if (.not.(td .eq. -11))goto 23006
      call doif (argstk, i, j)
      goto 23007
23006 continue
      if (.not.(td .eq. -14))goto 23008
      call doarth (argstk, i, j)
      goto 23009
23008 continue
      instr0 = 0
      k = t + length (evalst (t)) - 1
23010 if (.not.(k .gt. t))goto 23012
      if (.not.(evalst(k) .eq. 39 .or. evalst(k) .eq. 34))goto 23013
      if (.not.(instr0 .eq. 0))goto 23015
      delim = evalst(k)
      instr0 = 1
      goto 23016
23015 continue
      instr0 = 0
23016 continue
      call putbak (evalst(k))
      goto 23014
23013 continue
      if (.not.(evalst(k-1) .ne. 36 .or. instr0 .eq. 1))goto 23017
      call putbak (evalst (k))
      goto 23018
23017 continue
      argno = index (digits, evalst (k)) - 1
      if (.not.(argno .ge. 0 .and. argno .lt. j - i))goto 23019
      n = i + argno + 1
      m = argstk (n)
      call pbstr (evalst (m))
23019 continue
      k = k - 1
23018 continue
23014 continue
23011 k = k - 1
      goto 23010
23012 continue
      if (.not.(k .eq. t))goto 23021
      call putbak (evalst (k))
23021 continue
23009 continue
23007 continue
23005 continue
23003 continue
23001 continue
      return
      end
c     logic0  logical_column
c     instr0  in_string

include	defs

# stclos --- insert closure entry at pat (j)

   integer function stclos (pat, j, lastj, lastcl)
   character pat (MAXPAT)
   integer j, lastj, lastcl

   integer addset
   integer jp, jt, junk

   for (jp = j - 1; jp >= lastj; jp = jp - 1) {   # make a hole
      jt = jp + CLOSIZE
      junk = addset (pat (jp), pat, jt, MAXPAT)
      }
   j = j + CLOSIZE
   stclos = lastj
   junk = addset (CLOSURE, pat, lastj, MAXPAT)	 # put closure in it
   junk = addset (0, pat, lastj, MAXPAT)	 # COUNT
   junk = addset (lastcl, pat, lastj, MAXPAT)	 # PREVCL
   junk = addset (0, pat, lastj, MAXPAT)	 # START

   return
   end

      integer function maksub (arg, from, delim, sub)
      integer arg (128), delim, sub (128)
      integer from
      integer esc, type
      integer i, j, junk
      integer addset
      j = 1
      i = from
23000 if (.not.(arg (i) .ne. delim .and. arg (i) .ne. -2))goto 23002
      if (.not.(arg (i) .eq. 38))goto 23003
      junk = addset (-3, sub, j, 128)
      junk = addset (0, sub, j, 128)
      goto 23004
23003 continue
      if (.not.(arg (i) .eq. 64 .and. type (arg (i + 1)) .eq. 48))goto 2
     *3005
      i = i + 1
      junk = addset (-3, sub, j, 128)
      junk = addset (arg (i) - 48, sub, j, 128)
      goto 23006
23005 continue
      junk = addset (esc (arg, i), sub, j, 128)
23006 continue
23004 continue
23001 i = i + 1
      goto 23000
23002 continue
      if (.not.(arg (i) .ne. delim))goto 23007
      maksub = -3
      goto 23008
23007 continue
      if (.not.(addset (-2, sub, j, 128) .eq. 0))goto 23009
      maksub = -3
      goto 23010
23009 continue
      maksub = i
23010 continue
23008 continue
      return
      end

      SUBROUTINE slPDQH (P, D, Q, H1, J1, H2, J2)
*+
*     - - - - - -
*      P D Q H
*     - - - - - -
*
*  Hour Angle corresponding to a given parallactic angle
*
*  (double precision)
*
*  Given:
*     P       d        latitude
*     D       d        declination
*     Q       d        parallactic angle
*
*  Returned:
*     H1      d        hour angle:  first solution if any
*     J1      i        flag: 0 = solution 1 is valid
*     H2      d        hour angle:  second solution if any
*     J2      i        flag: 0 = solution 2 is valid
*
*  Called:  slDA1P
*
*  P.T.Wallace   Starlink   6 October 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION P,D,Q,H1
      INTEGER J1
      DOUBLE PRECISION H2
      INTEGER J2

      DOUBLE PRECISION DPI
      PARAMETER (DPI=3.141592653589793238462643D0)
      DOUBLE PRECISION D90
      PARAMETER (D90=DPI/2D0)
      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-12)
      DOUBLE PRECISION PN,QN,DN,SQ,CQ,SQSD,QT,QB,HPT,T
      DOUBLE PRECISION slDA1P


*  Preset status flags to OK
      J1=0
      J2=0

*  Adjust latitude, declination, parallactic angle to avoid critical values
      PN=slDA1P(P)
      IF (ABS(ABS(PN)-D90).LT.TINY) THEN
         PN=PN-SIGN(TINY,PN)
      ELSE IF (ABS(PN).LT.TINY) THEN
         PN=TINY
      END IF
      QN=slDA1P(Q)
      IF (ABS(ABS(QN)-DPI).LT.TINY) THEN
         QN=QN-SIGN(TINY,QN)
      ELSE IF (ABS(QN).LT.TINY) THEN
         QN=TINY
      END IF
      DN=slDA1P(D)
      IF (ABS(ABS(D)-ABS(P)).LT.TINY) THEN
         DN=DN-SIGN(TINY,DN)
      ELSE IF (ABS(ABS(D)-D90).LT.TINY) THEN
         DN=DN-SIGN(TINY,DN)
      END IF

*  Useful functions
      SQ=SIN(QN)
      CQ=COS(QN)
      SQSD=SQ*SIN(DN)

*  Quotient giving sin(h+t)
      QT=SIN(PN)*SQ*COS(DN)
      QB=COS(PN)*SQRT(CQ*CQ+SQSD*SQSD)

*  Any solutions?
      IF (ABS(QT).LE.QB) THEN

*     Yes: find h+t and t
         HPT=ASIN(QT/QB)
         T=ATAN2(SQSD,CQ)

*     The two solutions
         H1=slDA1P(HPT-T)
         H2=slDA1P(-HPT-(T+DPI))

*     Reject if h and Q different signs
         IF (H1*QN.LT.0D0) J1=-1
         IF (H2*QN.LT.0D0) J2=-1
      ELSE
         J1=-1
         J2=-1
      END IF

      END

#-h-  allblk			  486  local   12/01/80  15:53:44
# allblk - determine if line consists of all blanks
   include  defs

# this routine is called by outdon, and is here to fix
# a bug which sometimes occurs if two or more includes precede the
# first line of executable code.  Could not trace down the cause

   integer function allblk (buf)
   character buf (ARB)

   integer i

   allblk = YES
   for (i = 1; buf (i) != NEWLINE & buf (i) != EOS; i = i + 1)
      if (buf (i) != BLANK) {
	 allblk = NO
	 break
	 }

   return
   end

C--------------------------------------------------------------------------
        subroutine ftgrec(iunit,nrec,record,status)

C       Read the Nth 80-byte header record 
C       This routine is useful for reading the entire header, one
C       record at a time.

C       iunit   i  Fortran I/O unit number
C       nrec    i  sequence number (starting with 1) of the record to read
C       OUTPUT PARAMETERS:
C       record  c  output 80-byte record
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,nrec,status
        character*80 record

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,nbyte,endhd
        character arec*8

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(iunit)

C       calculate byte location of the record, and check if it is legal
        nbyte=hdstrt(ibuff,chdu(ibuff))+(nrec-1)*80

C       endhd=(hdend(ibuff)/2880+1)*2880
C       modified this on 4 Nov 1994 to allow for blanks before the END keyword
        endhd=max(hdend(ibuff),dtstrt(ibuff)-2880)

        if (nbyte .gt. endhd .or. nrec .le. 0)then
C               header record number is out of bounds
                status=203
                write(arec,1000)nrec
1000            format(i8)
                call ftpmsg('Cannot get Keyword number '//arec//'.'//
     &          '  It does not exist.')
                go to 100
        end if 

C       position the I/O pointer to the appropriate header keyword
        call ftmbyt(iunit,nbyte,.false.,status)

C       read the 80 byte record
        call ftgcbf(iunit,1,80,record,status)
        if (status .gt. 0)then
                write(arec,1000)nrec
                call ftpmsg('FTGREC could not read header keyword'//
     &            ' number '//arec//'.')
                return
        end if

C       update the keyword pointer position
        nxthdr(ibuff)=nbyte+80

100     continue
        end

chapter xvii, example 2. bivariate spline interpolation
c  from  * a practical guide to splines *  by c. de boor
calls  spli2d(bsplvb,banfac/slv),interv,bvalue(bsplvb*,interv*)
c     parameter nx=7,kx=3,ny=6,ky=4
c     integer i,iflag,j,jj,lefty,mflag,
c     real bcoef(nx,ny),taux(nx),tauy(ny),tx(10),ty(10)
c    *	       ,work1(nx,ny),work2(nx),work3(42)
      integer i,iflag,j,jj,kp1,kx,ky,lefty,mflag,nx,ny
      real bcoef(7,6),taux(7),tauy(6),tx(10),ty(10)
     *	       ,work1(7,6),work2(7),work3(42)
      real bvalue,g,x,y
      data nx,kx,ny,ky /7,3,6,4/
      g(x,y) = amax1(x-3.5,0.)**2 + amax1(y-3.,0.)**3
c *** set up data points and knots
c     in x, interpolate between knots by parabolic splines, using
c     not-a-knot end condition
      do 10 i=1,nx
   10	 taux(i) = float(i)
      do 11 i=1,kx
	 tx(i) = taux(1)
   11	 tx(nx+i) = taux(nx)
      kp1 = kx+1
      do 12 i=kp1,nx
   12	 tx(i) = (taux(i-kx+1) + taux(i-kx+2))/2.
c     in y, interpolate at knots by cubic splines, using not-a-knot
c     end condition
      do 20 i=1,ny
   20	 tauy(i) = float(i)
      do 21 i=1,ky
	 ty(i) = tauy(1)
   21	 ty(ny+i) = tauy(ny)
      kp1 = ky+1
      do 22 i=kp1,ny
   22	 ty(i) = tauy(i-ky+2)
c  *** generate and print out function values
      print 620,(tauy(i),i=1,ny)
  620 format(11h given data//6f12.1)
      do 32 i=1,nx
	 do 31 j=1,ny
   31	    bcoef(i,j) = g(taux(i),tauy(j))
   32	 print 632,taux(i),(bcoef(i,j),j=1,ny)
  632 format(f5.1,6e12.5)
c
c  *** construct b-coefficients of interpolant
c
      call spli2d(taux,bcoef,tx,nx,kx,ny,work2,work3,work1,iflag)
      call spli2d(tauy,work1,ty,ny,ky,nx,work2,work3,bcoef,iflag)
c
c  *** evaluate interpolation error at mesh points and print out
      print 640,(tauy(j),j=1,ny)
  640 format(//20h interpolation error//6f12.1)
      do 45 j=1,ny
	 call interv(ty,ny,tauy(j),lefty,mflag)
	 do 45 i=1,nx
	    do 41 jj=1,ky
   41	       work2(jj)=bvalue(tx,bcoef(1,lefty-ky+jj),nx,kx,taux(i),0)
   45	    work1(i,j) = g(taux(i),tauy(j)) -
     *			bvalue(ty(lefty-ky+1),work2,ky,ky,tauy(j),0)
      do 46 i=1,nx
   46	 print 632,taux(i),(work1(i,j),j=1,ny)
					stop
      end

include  defs

# caslab - get one case label

integer function caslab (n, t)

integer n, t
character tok(MAXTOK)
integer i, s, lev
integer gnbtok, ctoi

	t = gnbtok (tok, MAXTOK)
	while (t == NEWLINE)
	    t = gnbtok (tok, MAXTOK)

	if (t == EOF)
	    return (t)

	for (lev=0;  t == LPAREN;  t = gnbtok (tok, MAXTOK))
	    lev = lev + 1

	if (t == MINUS)
	    s = -1
	else
	    s = +1
	if (t == MINUS | t == PLUS)
	    t = gnbtok (tok, MAXTOK)

	if (t != DIGIT)
	    goto 99
	else {
	    i = 1
	    n = s * ctoi (tok, i)
	}

	for (t=gnbtok(tok,MAXTOK);  t == RPAREN;  t=gnbtok(tok,MAXTOK))
	    lev = lev - 1
	if (lev != 0)
	    goto 99

	while (t == NEWLINE)
	    t = gnbtok (tok, MAXTOK)

	return 0

 99	call synerr ("Invalid case label.")
	n = 0
end

C--------------------------------------------------------------------------
        subroutine ftgcno(iunit,casesn,templt,colnum,status)

C       determine the column number corresponding to an input column name.
C       This supports the * and ? wild cards in the input template.

C       iunit   i  Fortran i/o unit number
C       casesn  l  true if an exact case match of the names is required
C       templt  c  name of column as specified in a TTYPE keyword
C       colnum  i  number of the column (first column = 1)
C                       (a value of 0 is returned if the column is not found)
C       status  i  returned error status

C       modified by Wm Pence, HEASARC/GSFC, December 1994

        integer iunit,colnum,status
        character*(*) templt
        logical casesn
        character*8 dummy

        call ftgcnn(iunit,casesn,templt,dummy,colnum,status)
        end

       subroutine eqblok ( t, n, kpm,  work1, work2,
     *		       bloks, lenblk, integs, nbloks,  b )
c  from  * a practical guide to splines *  by c. de boor
calls putit(difequ,bsplvd(bsplvb))
c  to be called in  c o l l o c
c
c******  i n p u t  ******
c  t   the knot sequence, of length n+kpm
c  n   the dimension of the approximating spline space, i.e., the order
c      of the linear system to be constructed.
c  kpm = k+m, the order of the approximating spline
c  lenblk   the maximum length of the array  bloks  as allowed by the
c	    dimension statement in  colloc .
c
c******  w o r k   a r e a s  ******
c  work1    used in  putit, of size (kpm,kpm)
c  work2    used in  putit, of size (kpm,m+1)
c
c******  o u t p u t  ******
c  bloks    the coefficient matrix of the linear system, stored in al-
c	    most block diagonal form, of size
c	       kpm*sum(integs(1,i) , i=1,...,nbloks)
c  integs   an integer array, of size (3,nbloks), describing the block
c	    structure.
c	    integs(1,i)  =  number of rows in block  i
c	    integs(2,i)  =  number of columns in block	i
c	    integs(3,i)  =  number of elimination steps which can be
c			carried out in block  i  before pivoting might
c			bring in an equation from the next block.
c  nbloks   number of blocks, equals number of polynomial pieces
c  b   the right side of the linear system, stored corresponding to the
c      almost block diagonal form, of size sum(integs(1,i) , i=1,...,
c      nbloks).
c
c******  m e t h o d  ******
c  each breakpoint interval gives rise to a block in the linear system.
c  this block is determined by the  k  colloc.equations in the interval
c  with the side conditions (if any) in the interval interspersed ap-
c  propriately, and involves the  kpm  b-splines having the interval in
c  their support. correspondingly, such a block has  nrow = k + isidel
c  rows, with  isidel = number of side conditions in this and the prev-
c  ious intervals, and	ncol = kpm  columns.
c     further, because the interior knots have multiplicity  k, we can
c  carry out (in slvblk)  k  elimination steps in a block before pivot-
c  ing might involve an equation from the next block. in the last block,
c  of course, all kpm elimination steps will be carried out (in slvblk).
c
c  see the detailed comments in the solveblok package for further in-
c  formation about the almost block diagonal form used here.
      integer integs(3,1),kpm,lenblk,n,nbloks,	 i,index,indexb,iside
     *					    ,isidel,itermx,k,left,m,nrow
      real b(1),bloks(1),t(1),work1(1),work2(1),   rho,xside
      common /side/ m, iside, xside(10)
      common /other/ itermx,k,rho(19)
      index = 1
      indexb = 1
      i = 0
      iside = 1
      do 20 left=kpm,n,k
	 i = i+1
c	 determine integs(.,i)
	 integs(2,i) = kpm
	 if (left .lt. n)		go to 14
	 integs(3,i) = kpm
	 isidel = m
					go to 16
   14	 integs(3,i) = k
c	 at this point,  iside-1  gives the number of side conditions
c	 incorporated so far. adding to this the side conditions in the
c	 current interval gives the number  isidel .
	 isidel = iside-1
   15	 if (isidel .eq. m)		go to 16
	 if (xside(isidel+1) .ge. t(left+1))
     *					go to 16
	 isidel = isidel+1
					go to 15
   16	 nrow = k + isidel
	 integs(1,i) = nrow
c	 the detailed equations for this block are generated and put
c	 together in  p u t i t .
	 if (lenblk .lt. index+nrow*kpm-1)go to 999
	 call putit(t,kpm,left,work1,work2,bloks(index),nrow,b(indexb))
	 index = index + nrow*kpm
   20	 indexb = indexb + nrow
      nbloks = i
					return
  999 print 699,lenblk
  699 format(11h **********/23h the assigned dimension,i5
     *	      ,38h for	bloks  in  colloc  is too small.)
					stop
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE EZXY (XDRA,YDRA,NPTS,LABG)
C
      REAL XDRA(*),YDRA(*)
C
      CHARACTER*(*) LABG
C
C The routine EZXY draws one curve through the points (XDRA(I),YDRA(I)),
C for I = 1, 2, ... NPTS.
C
C Do statistics-gathering call.
C
      LOGICAL Q8Q4
      SAVE Q8Q4
      DATA Q8Q4 /.TRUE./
      IF (Q8Q4) THEN
        CALL Q8QST4('GRAPHX','AUTOGRAPH','EZXY','VERSION 07')
        Q8Q4 = .FALSE.
      ENDIF
C
C +NOAO
C
      call agdflt
C
C -NOAO
      CALL AGGETI ('SET .',ISET)
      CALL AGGETI ('FRAM.',IFRA)
C
      CALL AGEZSU (2,XDRA,YDRA,NPTS,1,NPTS,LABG,IIVX,IIEX,IIVY,IIEY)
      CALL AGBACK
C
      IF (ISET.GE.0) CALL AGCURV (XDRA,1,YDRA,1,NPTS,1)
C
      IF (IFRA.EQ.1) CALL FRAME
C
C +NOAO
C
      call initag
C
C -NOAO
      RETURN
C
      END

C----------------------------------------------------------------------
        subroutine ftghbn(iunit,maxfld,nrows,nfield,ttype,tform,
     &                    tunit,extnam,pcount,status)

C       read required standard header keywords from a binary table extension 
C
C       iunit   i  Fortran i/o unit number
C       maxfld  i  maximum no. of fields to read; size of ttype array
C       OUTPUT PARAMETERS:
C       nrows   i  number of rows in the table
C       nfield  i  number of fields in the table
C       ttype   c  name of each field (array)
C       tform   c  format of each field (array)
C       tunit   c  units of each field (array)
C       extnam  c  name of table (optional)
C       pcount  i  size of special data area following the table (usually = 0)
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,maxfld,ncols,nrows,nfield,pcount,status,tstat
        integer maxf,i,nfind
        character*(*) ttype(*),tform(*),tunit(*),extnam
        character comm*72

C       check that this is a valid binary table and get parameters
        call ftgtbn(iunit,ncols,nrows,pcount,nfield,status)
        if (status .gt. 0)return

        if (maxfld .lt. 0)then
              maxf=nfield
        else if (maxfld .eq. 0)then
              go to 20
        else
              maxf=min(maxfld,nfield)
        end if
C       initialize optional keywords
        do 10 i=1,maxf
                ttype(i)=' '
                tunit(i)=' '
10      continue

        call ftgkns(iunit,'TTYPE',1,maxf,ttype,nfind,status)
        call ftgkns(iunit,'TUNIT',1,maxf,tunit,nfind,status)

        if (status .gt. 0)return

        call ftgkns(iunit,'TFORM',1,maxf,tform,nfind,status)
        if (status .gt. 0 .or. nfind .ne. maxf)then
                status=232
                return
        end if

20      extnam=' '
        tstat=status
        call ftgkys(iunit,'EXTNAME',extnam,comm,status)
C       this keyword is not required, so ignore status
        if (status .eq. 202)status =tstat
        end

C----------------------------------------------------------------------
        subroutine ftucks(iunit,status)

C       Update the CHECKSUM keyword value.  This assumes that the DATASUM
C       keyword exists and has the correct value.

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, May, 1995

        integer iunit,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nf = 3000)
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld 
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        double precision sum,dsum
        integer ibuff,nrec,dd,mm,yy,i,tstat
        character datstr*8,string*16,comm*40,datsum*20,oldcks*16
        logical complm

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       get the DATASUM keyword value
        call ftgkys(iunit,'DATASUM',datsum,comm,status)
        if (status .eq. 202)then
             call ftpmsg('DATASUM keyword not found (FTUCKS)')
             return
        end if

C       decode the datasum string into a double precision variable
        do 10 i=1,20
            if (datsum(i:i) .ne. ' ')then
                call ftc2dd(datsum(i:20),dsum,status)
                go to 15
            end if
10      continue
        dsum=0.

C       generate current date string to put into the keyword comment
15      call ftgsdt(dd,mm,yy,status)
        if (status .gt. 0)return

        datstr='  /  /  '
        write(datstr(1:2),1001)dd
        write(datstr(4:5),1001)mm
        write(datstr(7:8),1001)yy
1001    format(i2)

C       replace blank with leading 0 in each field if required
        if (datstr(1:1) .eq. ' ')datstr(1:1)='0'
        if (datstr(4:4) .eq. ' ')datstr(4:4)='0'
        if (datstr(7:7) .eq. ' ')datstr(7:7)='0'

C       get the CHECKSUM keyword value if it exists
        tstat=status
        call ftgkys(iunit,'CHECKSUM',oldcks,comm,status)
        if (status .eq. 202)then
          status=tstat
          oldcks='0000000000000000'
          comm='encoded HDU checksum updated on '//datstr
          call ftpkys(iunit,'CHECKSUM','0000000000000000',comm,status)
        end if

C       rewrite the header END card, and following blank fill
        call ftwend(iunit,status)
        if (status .gt. 0)return
 
C       move to the start of the header
        call ftmbyt(iunit,hdstrt(ibuff,chdu(ibuff)),.true.,status)

C       accumulate the header checksum into the previous data checksum
        nrec= (dtstrt(ibuff)-hdstrt(ibuff,chdu(ibuff)))/2880
        sum=dsum
        call ftcsum(iunit,nrec,sum,status)

C       encode the COMPLEMENT of the checksum into a 16-character string
        complm=.true.
        call ftesum(sum,complm,string)

C       return if the checksum is correct
        if (string .eq. '0000000000000000')return

        if (oldcks .eq. '0000000000000000')then
C               update the CHECKSUM keyword value with the checksum string
                call ftmkys(iunit,'CHECKSUM',string,'&',status)
        else

C           Zero the checksum and compute the new value
            comm='encoded HDU checksum updated on '//datstr
            call ftmkys(iunit,'CHECKSUM','0000000000000000',comm,status)

C           move to the start of the header
            call ftmbyt(iunit,hdstrt(ibuff,chdu(ibuff)),.true.,status)

C           accumulate the header checksum into the previous data checksum
            sum=dsum
            call ftcsum(iunit,nrec,sum,status)

C           encode the COMPLEMENT of the checksum into a 16-character string
            complm=.true.
            call ftesum(sum,complm,string)

C           update the CHECKSUM keyword value with the checksum string
            call ftmkys(iunit,'CHECKSUM',string,'&',status)
        end if
        end

      SUBROUTINE slECOR (RM, DM, IY, ID, FD, RV, TL)
*+
*     - - - - -
*      E C O R
*     - - - - -
*
*  Component of Earth orbit velocity and heliocentric
*  light time in a given direction (single precision)
*
*  Given:
*     RM,DM    real    mean RA, Dec of date (radians)
*     IY       int     year
*     ID       int     day in year (1 = Jan 1st)
*     FD       real    fraction of day
*
*  Returned:
*     RV       real    component of Earth orbital velocity (km/sec)
*     TL       real    component of heliocentric light time (sec)
*
*  Notes:
*
*  1  The date and time is TDB (loosely ET) in a Julian calendar
*     which has been aligned to the ordinary Gregorian
*     calendar for the interval 1900 March 1 to 2100 February 28.
*     The year and day can be obtained by calling slCAYD or
*     slCLYD.
*
*  2  Sign convention:
*
*     The velocity component is +ve when the Earth is receding from
*     the given point on the sky.  The light time component is +ve
*     when the Earth lies between the Sun and the given point on
*     the sky.
*
*  3  Accuracy:
*
*     The velocity component is usually within 0.004 km/s of the
*     correct value and is never in error by more than 0.007 km/s.
*     The error in light time correction is about 0.03s at worst,
*     but is usually better than 0.01s. For applications requiring
*     higher accuracy, see the slEVP and slEPV routines.
*
*  Called:  slERTH, slCS2C, slVDV
*
*  Last revision:   5 April 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL RM,DM
      INTEGER IY,ID
      REAL FD,RV,TL

      REAL slVDV

      REAL PV(6),V(3),AUKM,AUSEC

*  AU to km and light sec (1985 Almanac)
      PARAMETER (AUKM=1.4959787066E8,
     :           AUSEC=499.0047837)



*  Sun:Earth position & velocity vector
      CALL slERTH(IY,ID,FD,PV)

*  Star position vector
      CALL slCS2C(RM,DM,V)

*  Velocity component
      RV=-AUKM*slVDV(PV(4),V)

*  Light time component
      TL=AUSEC*slVDV(PV(1),V)

      END

      subroutine slvblk ( bloks, integs, nbloks, b, ipivot, x, iflag )
c    this program solves  the  linear system  a*x = b  where a is an
c  almost block diagonal matrix.  such almost block diagonal matrices
c  arise naturally in piecewise polynomial interpolation or approx-
c  imation and in finite element methods for two-point boundary value
c  problems.  the plu factorization method is implemented here to take
c  advantage of the special structure of such systems for savings in
c  computing time and storage requirements.
c
c		   parameters
c  bloks   a one-dimenional array, of length
c		    sum( integs(1,i)*integs(2,i) ; i = 1,nbloks )
c	   on input, contains the blocks of the almost block diagonal
c	   matrix  a  .  the array integs (see below and the example)
c	   describes the block structure.
c	   on output, contains correspondingly the plu factorization
c	   of  a  (if iflag .ne. 0).  certain of the entries into bloks
c	   are arbitrary (where the blocks overlap).
c  integs  integer array description of the block structure of	a .
c	     integs(1,i) = no. of rows of block i	 =  nrow
c	     integs(2,i) = no. of colums of block i	 =  ncol
c	     integs(3,i) = no. of elim. steps in block i =  last
c			   i  = 1,2,...,nbloks
c	   the linear system is of order
c		 n  =  sum ( integs(3,i) , i=1,...,nbloks ),
c	   but the total number of rows in the blocks is
c	       nbrows = sum( integs(1,i) ; i = 1,...,nbloks)
c  nbloks  number of blocks
c  b	   right side of the linear system, array of length nbrows.
c	   certain of the entries are arbitrary, corresponding to
c	   rows of the blocks which overlap (see block structure and
c	   the example below).
c  ipivot  on output, integer array containing the pivoting sequence
c	   used. length is nbrows
c  x	   on output, contains the computed solution (if iflag .ne. 0)
c	   length is n.
c  iflag   on output, integer
c	     = (-1)**(no. of interchanges during factorization)
c		    if	a  is invertible
c	     = 0    if	a  is singular
c
c		    auxiliary programs
c  fcblok (bloks,integs,nbloks,ipivot,scrtch,iflag)  factors the matrix
c	    a , and is used for this purpose in slvblk. its arguments
c	   are as in slvblk, except for
c	       scrtch = a work array of length max(integs(1,i)).
c
c  sbblok (bloks,integs,nbloks,ipivot,b,x)  solves the system a*x = b
c	   once  a  is factored. this is done automatically by slvblk
c	   for one right side b, but subsequent solutions may be
c	   obtained for additional b-vectors. the arguments are all
c	   as in slvblk.
c
c  dtblok (bloks,integs,nbloks,ipivot,iflag,detsgn,detlog) computes the
c	   determinant of  a  once slvblk or fcblok has done the fact-
c	   orization.the first five arguments are as in slvblk.
c	       detsgn  = sign of the determinant
c	       detlog  = natural log of the determinant
c
c	      ------ block structure of  a  ------
c  the nbloks blocks are stored consecutively in the array  bloks .
c  the first block has its (1,1)-entry at bloks(1), and, if the i-th
c  block has its (1,1)-entry at bloks(index(i)), then
c	  index(i+1) = index(i)  +  nrow(i)*ncol(i) .
c    the blocks are pieced together to give the interesting part of  a
c  as follows.	for i = 1,2,...,nbloks-1, the (1,1)-entry of the next
c  block (the (i+1)st block ) corresponds to the (last+1,last+1)-entry
c  of the current i-th block.  recall last = integs(3,i) and note that
c  this means that
c      a. every block starts on the diagonal of  a .
c      b. the blocks overlap (usually). the rows of the (i+1)st block
c	  which are overlapped by the i-th block may be arbitrarily de-
c	  fined initially. they are overwritten during elimination.
c    the right side for the equations in the i-th block are stored cor-
c  respondingly as the last entries of a piece of  b  of length  nrow
c  (= integs(1,i)) and following immediately in  b  the corresponding
c  piece for the right side of the preceding block, with the right side
c  for the first block starting at  b(1) . in this, the right side for
c  an equation need only be specified once on input, in the first block
c  in which the equation appears.
c
c	      ------ example and test driver ------
c    the test driver for this package contains an example, a linear
c  system of order 11, whose nonzero entries are indicated in the fol-
c  lowing schema by their row and column index modulo 10. next to it
c  are the contents of the  integs  arrray when the matrix is taken to
c  be almost block diagonal with  nbloks = 5, and below it are the five
c  blocks.
c
c		       nrow1 = 3, ncol1 = 4
c	    11 12 13 14
c	    21 22 23 24   nrow2 = 3, ncol2 = 3
c	    31 32 33 34
c  last1 = 2	  43 44 45
c		  53 54 55	      nrow3 = 3, ncol3 = 4
c	 last2 = 3	   66 67 68 69	 nrow4 = 3, ncol4 = 4
c			   76 77 78 79	    nrow5 = 4, ncol5 = 4
c			   86 87 88 89
c		  last3 = 1   97 98 99 90
c		     last4 = 1	 08 09 00 01
c				 18 19 10 11
c			last5 = 4
c
c	  actual input to bloks shown by rows of blocks of  a .
c      (the ** items are arbitrary, this storage is used by slvblk)
c
c  11 12 13 14	/ ** ** **  / 66 67 68 69  / ** ** ** **  / ** ** ** **
c  21 22 23 24 /  43 44 45 /  76 77 78 79 /  ** ** ** ** /  ** ** ** **
c  31 32 33 34/   53 54 55/   86 87 88 89/   97 98 99 90/   08 09 00 01
c							    18 19 10 11
c
c  index = 1	  index = 13  index = 22     index = 34     index = 46
c
c	  actual right side values with ** for arbitrary values
c  b1 b2 b3 ** b4 b5 b6 b7 b8 ** ** b9 ** ** b10 b11
c
c  (it would have been more efficient to combine block 3 with block 4)
c
      integer nbloks
      integer integs(3,nbloks),ipivot(1),iflag
      real bloks(1),b(1),x(1)
c     in the call to fcblok,  x  is used for temporary storage.
      call fcblok(bloks,integs,nbloks,ipivot,x,iflag)
      if (iflag .eq. 0) 		return
      call sbblok(bloks,integs,nbloks,ipivot,b,x)
					return
      end

      integer function errsub (arg, file, access)
      integer arg (100), file (100)
      integer access
      if (.not.(arg (1) .eq. 63 .and. arg (2) .ne. 63 .and. arg (2) .ne.
     * -2))goto 23000
      errsub = 1
      access = 2
      call scopy (arg, 2, file, 1)
      goto 23001
23000 continue
      if (.not.(arg (1) .eq. 63 .and. arg (2) .eq. 63 .and. arg (3) .ne.
     * -2))goto 23002
      errsub = 1
      access = 4
      call scopy (arg, 3, file, 1)
      goto 23003
23002 continue
      errsub = 0
23003 continue
23001 continue
      return
      end

include	defs

# equal - compare str1 to str2;  return YES if equal, NO if not

   integer function equal (str1, str2)
   character str1(ARB), str2(ARB)

   integer i

   for (i = 1; str1 (i) == str2 (i); i = i + 1)
      if (str1 (i) == EOS)
	 return (YES)

   return (NO)
   end

#-h-  labgen			  189  local   12/01/80  15:54:12
# labgen - generate  n	consecutive labels, return first one
   include  defs

   integer function labgen (n)
   integer n

   include COMMON_BLOCKS

   labgen = label
   label = label + (n / 10 + 1) * 10
   return
   end

C----------------------------------------------------------------------
        subroutine ftpclc(ounit,colnum,frow,felem,nelem,array,status)

C       write an array of single precision complex data values to the 
C       specified column of the table.  
C       The binary table column being written to must have datatype 'C'
C       and no datatype conversion will be perform if it is not.

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       array   cmp  array of data values to be written 
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status
C       the input array is really complex data type
        real array(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bufdim
        parameter (bufdim = 200)
        integer bytpix,bstart,tcode
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart,maxpix
        real buffer(bufdim)
        double precision scale,zero
        logical descrp,scaled
        character crow*9,cp1*9,cp2*9,ccol*4

        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &          'request is out of range:'//crow//' (FTPCLC).')
                return
        end if

        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)

        i1=1
C       multiply by 2, because the complex data type has pairs of values
        ntodo=nelem*2
        rstart=frow-1
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
        if (scale .eq. 1. .and. zero .eq. 0.)then
                scaled=.false.
        else
                scaled=.true.
        end if
        tcode=tdtype(colnum+tstart(ibuff)) 

        if (felem .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &          'request is out of range:'//crow//' (FTPCLC).')
                return
        else
C               multiply by 2 because the complex data type has pairs of values
                estart=(felem-1)*2
        end if

C       calculate the maximum number of column pixels which fit in buffer
        bytpix=4
        maxpix=bufdim/bytpix*4

        if (tcode .eq. 83)then
                repeat=trept(colnum+tstart(ibuff))*2
                if (felem*2 .gt. repeat)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                   call ftpmsg('Starting element number for write '//
     &             'request is out of range:'//crow//' (FTPCLC).')
                        return
                end if
                descrp=.false.
        else if (tcode .eq. -83)then
C               this is a variable length descriptor column
                descrp=.true.
                repeat=nelem+felem-1
C               write the number of elements and the starting offset:
                call ftpdes(ounit,colnum,frow,repeat,
     &                              nxheap(ibuff),status)
                repeat=repeat*2
C               move the i/o pointer to the start of the pixel sequence
                bstart=dtstrt(ibuff)+nxheap(ibuff)+
     &                  theap(ibuff)+estart*bytpix
                call ftmbyt(ounit,bstart,.true.,status)
C               increment the empty heap starting address:
                nxheap(ibuff)=nxheap(ibuff)+repeat*bytpix
        else
C               error illegal table data type code
                status=312
                return
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,repeat-estart,maxpix)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &             +tbcol(colnum+tstart(ibuff))+estart*bytpix
            call ftmbyt(ounit,bstart,.true.,status)
        end if

C       scale data into buffer,
        call ftuscc(array(i1),itodo,scaled,scale,zero,buffer)

C       do any machine dependent data conversion and write the R*4 data
        call ftpr4b(ounit,itodo,0,buffer,status)

        if (status .gt. 0)then
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error writing elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTPCLC.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error writing rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTPCLC).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error writing'//cp2//' elements to'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTPCLC).')
             end if
             return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        rstart=rstart+1
                end if
                go to 20
        end if
        end

      SUBROUTINE slS2TP (RA, DEC, RAZ, DECZ, XI, ETA, J)
*+
*     - - - - -
*      S 2 T P
*     - - - - -
*
*  Projection of spherical coordinates onto tangent plane:
*  "gnomonic" projection - "standard coordinates"
*  (single precision)
*
*  Given:
*     RA,DEC      real  spherical coordinates of point to be projected
*     RAZ,DECZ    real  spherical coordinates of tangent point
*
*  Returned:
*     XI,ETA      real  rectangular coordinates on tangent plane
*     J           int   status:   0 = OK, star on tangent plane
*                                 1 = error, star too far from axis
*                                 2 = error, antistar on tangent plane
*                                 3 = error, antistar too far from axis
*
*  P.T.Wallace   Starlink   18 July 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL RA,DEC,RAZ,DECZ,XI,ETA
      INTEGER J

      REAL SDECZ,SDEC,CDECZ,CDEC,RADIF,SRADIF,CRADIF,DENOM

      REAL TINY
      PARAMETER (TINY=1E-6)


*  Trig functions
      SDECZ=SIN(DECZ)
      SDEC=SIN(DEC)
      CDECZ=COS(DECZ)
      CDEC=COS(DEC)
      RADIF=RA-RAZ
      SRADIF=SIN(RADIF)
      CRADIF=COS(RADIF)

*  Reciprocal of star vector length to tangent plane
      DENOM=SDEC*SDECZ+CDEC*CDECZ*CRADIF

*  Handle vectors too far from axis
      IF (DENOM.GT.TINY) THEN
         J=0
      ELSE IF (DENOM.GE.0.0) THEN
         J=1
         DENOM=TINY
      ELSE IF (DENOM.GT.-TINY) THEN
         J=2
         DENOM=-TINY
      ELSE
         J=3
      END IF

*  Compute tangent plane coordinates (even in dubious cases)
      XI=CDEC*SRADIF/DENOM
      ETA=(SDEC*CDECZ-CDEC*SDECZ*CRADIF)/DENOM

      END

include	defs

# addstr - add s to str(j) if it fits, increment j

   integer function addstr (s, str, j, maxsiz)
   integer j, maxsiz
   character s (ARB), str (maxsiz)

   integer i, addset

   for (i = 1; s (i) != EOS; i = i + 1)
      if (addset (s (i), str, j, maxsiz) == NO) {
	 addstr = NO
	 return
	 }
   addstr = YES

   return
   end

      SUBROUTINE slEQGA (DR, DD, DL, DB)
*+
*     - - - - - -
*      E Q G A
*     - - - - - -
*
*  Transformation from J2000.0 equatorial coordinates to
*  IAU 1958 galactic coordinates (double precision)
*
*  Given:
*     DR,DD       dp       J2000.0 RA,Dec
*
*  Returned:
*     DL,DB       dp       galactic longitude and latitude L2,B2
*
*  (all arguments are radians)
*
*  Called:
*     slDS2C, slDMXV, slDC2S, slDA2P, slDA1P
*
*  Note:
*     The equatorial coordinates are J2000.0.  Use the routine
*     slEG50 if conversion from B1950.0 'FK4' coordinates is
*     required.
*
*  Reference:
*     Blaauw et al, Mon.Not.R.Astron.Soc.,121,123 (1960)
*
*  P.T.Wallace   Starlink   21 September 1998
*
*  Copyright (C) 1998 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DR,DD,DL,DB

      DOUBLE PRECISION slDA2P,slDA1P

      DOUBLE PRECISION V1(3),V2(3)

*
*  L2,B2 system of galactic coordinates
*
*  P = 192.25       RA of galactic north pole (mean B1950.0)
*  Q =  62.6        inclination of galactic to mean B1950.0 equator
*  R =  33          longitude of ascending node
*
*  P,Q,R are degrees
*
*  Equatorial to galactic rotation matrix (J2000.0), obtained by
*  applying the standard FK4 to FK5 transformation, for zero proper
*  motion in FK5, to the columns of the B1950 equatorial to
*  galactic rotation matrix:
*
      DOUBLE PRECISION RMAT(3,3)
      DATA RMAT(1,1),RMAT(1,2),RMAT(1,3),
     :     RMAT(2,1),RMAT(2,2),RMAT(2,3),
     :     RMAT(3,1),RMAT(3,2),RMAT(3,3)/
     : -0.054875539726D0,-0.873437108010D0,-0.483834985808D0,
     : +0.494109453312D0,-0.444829589425D0,+0.746982251810D0,
     : -0.867666135858D0,-0.198076386122D0,+0.455983795705D0/



*  Spherical to Cartesian
      CALL slDS2C(DR,DD,V1)

*  Equatorial to galactic
      CALL slDMXV(RMAT,V1,V2)

*  Cartesian to spherical
      CALL slDC2S(V2,DL,DB)

*  Express in conventional ranges
      DL=slDA2P(DL)
      DB=slDA1P(DB)

      END

include	defs

# patsiz --- returns size of pattern entry at pat (n)

   integer function patsiz (pat, n)
   character pat (MAXPAT)
   integer n

   if (pat (n) == CHAR | pat (n) == START_TAG | pat (n) == STOP_TAG)
      patsiz = 2
   else if (pat (n) == BOL | pat (n) == EOL | pat (n) == ANY)
      patsiz = 1
   else if (pat (n) == CCL | pat (n) == NCCL)
      patsiz = pat (n + 1) + 2
   else if (pat (n) == CLOSURE)      # optional
      patsiz = CLOSIZE
   else
      call error ("in patsiz: can't happen.")

   return
   end

C--------------------------------------------------------------------------
        subroutine ftpthp(ounit,heap,status)

C       Define the starting address for the heap for a binary table.
C       The default address is NAXIS1 * NAXIS2.  It is in units of
C       bytes relative to the beginning of the regular binary table data.
C       This subroutine also writes the appropriate THEAP keyword to the
C       FITS header.

C       ounit   i  Fortran I/O unit number
C       heap   i  starting address of the heap
C       OUTPUT PARAMETERS:
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, Nov 1991

        integer ounit,heap,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        parameter (nf = 3000)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff

        if (status .gt. 0)return
        ibuff=bufnum(ounit)
        theap(ibuff)=heap        

C       write the keyword
        call ftukyj(ounit,'THEAP',heap,'Byte offset of heap area',
     &              status)
        end

      subroutine bsplpp ( t, bcoef, n, k, scrtch, break, coef, l )
c  from  * a practical guide to splines *  by c. de boor
calls  bsplvb
c
converts the b-representation  t, bcoef, n, k  of some spline into its
c  pp-representation  break, coef, l, k .
c
c******  i n p u t  ******
c  t.....knot sequence, of length  n+k
c  bcoef.....b-spline coefficient sequence, of length  n
c  n.....length of  bcoef  and	dimension of spline space  spline(k,t)
c  k.....order of the spline
c
c  w a r n i n g  . . .  the restriction   k .le. kmax (= 20)	is impo-
c	 sed by the arbitrary dimension statement for  biatx  below, but
c	 is  n o w h e r e   c h e c k e d   for.
c
c******  w o r k   a r e a  ******
c  scrtch......of size	(k,k) , needed to contain bcoeffs of a piece of
c	 the spline and its  k-1  derivatives
c
c******  o u t p u t  ******
c  break.....breakpoint sequence, of length  l+1, contains (in increas-
c	 ing order) the distinct points in the sequence  t(k),...,t(n+1)
c  coef.....array of size (k,n), with  coef(i,j) = (i-1)st derivative of
c	 spline at break(j) from the right
c  l.....number of polynomial pieces which make up the spline in the in-
c	 terval  (t(k), t(n+1))
c
c******  m e t h o d  ******
c     for each breakpoint interval, the  k  relevant b-coeffs of the
c  spline are found and then differenced repeatedly to get the b-coeffs
c  of all the derivatives of the spline on that interval. the spline and
c  its first  k-1  derivatives are then evaluated at the left end point
c  of that interval, using  bsplvb  repeatedly to obtain the values of
c  all b-splines of the appropriate order at that point.
c
c     parameter kmax = 20
      integer k,l,n,   i,j,jp1,kmj,left,lsofar
      real bcoef(n),break(1),coef(k,1),t(1),   scrtch(k,k)
     *					      ,biatx(20),diff,fkmj,sum
c    *					      ,biatx(kmax),diff,fkmj,sum
c     dimension break(l+1),coef(k,l),t(n+k)
current fortran standard makes it impossible to specify the length of
c  break , coef  and  t  precisely without the introduction of otherwise
c  superfluous additional arguments.
      lsofar = 0
      break(1) = t(k)
      do 50 left=k,n
c				 find the next nontrivial knot interval.
	 if (t(left+1) .eq. t(left))	go to 50
	 lsofar = lsofar + 1
	 break(lsofar+1) = t(left+1)
	 if (k .gt. 1)			go to 9
	 coef(1,lsofar) = bcoef(left)
					go to 50
c	 store the k b-spline coeff.s relevant to current knot interval
c			      in  scrtch(.,1) .
    9	 do 10 i=1,k
   10	    scrtch(i,1) = bcoef(left-k+i)
c
c	 for j=1,...,k-1, compute the  k-j  b-spline coeff.s relevant to
c	 current knot interval for the j-th derivative by differencing
c	 those for the (j-1)st derivative, and store in scrtch(.,j+1) .
	 do 20 jp1=2,k
	    j = jp1 - 1
	    kmj = k - j
	    fkmj = float(kmj)
	    do 20 i=1,kmj
	       diff = t(left+i) - t(left+i - kmj)
	       if (diff .gt. 0.)  scrtch(i,jp1) =
     *			     ((scrtch(i+1,j)-scrtch(i,j))/diff)*fkmj
   20	       continue
c
c	 for  j = 0, ..., k-1, find the values at  t(left)  of the  j+1
c	 b-splines of order  j+1  whose support contains the current
c	 knot interval from those of order  j  (in  biatx ), then comb-
c	 ine with the b-spline coeff.s (in scrtch(.,k-j) ) found earlier
c	 to compute the (k-j-1)st derivative at  t(left)  of the given
c	 spline.
c	    note. if the repeated calls to  bsplvb  are thought to gene-
c	 rate too much overhead, then replace the first call by
c	    biatx(1) = 1.
c	 and the subsequent call by the statement
c	    j = jp1 - 1
c	 followed by a direct copy of the lines
c	    deltar(j) = t(left+j) - x
c		   ......
c	    biatx(j+1) = saved
c	 from  bsplvb . deltal(kmax)  and  deltar(kmax)  would have to
c	 appear in a dimension statement, of course.
c
	 call bsplvb ( t, 1, 1, t(left), left, biatx )
	 coef(k,lsofar) = scrtch(1,k)
	 do 30 jp1=2,k
	    call bsplvb ( t, jp1, 2, t(left), left, biatx )
	    kmj = k+1 - jp1
	    sum = 0.
	    do 28 i=1,jp1
   28	       sum = biatx(i)*scrtch(i,kmj) + sum
   30	    coef(kmj,lsofar) = sum
   50	 continue
      l = lsofar
					return
      end

      SUBROUTINE slSVDC (N, NP, NC, W, V, WORK, CVM)
*+
*     - - - - - - -
*      S V D C
*     - - - - - - -
*
*  From the W and V matrices from the SVD factorisation of a matrix
*  (as obtained from the slSVD routine), obtain the covariance matrix.
*
*  (double precision)
*
*  Given:
*     N      i         number of rows and columns in matrices W and V
*     NP     i         first dimension of array containing matrix V
*     NC     i         first dimension of array to receive CVM
*     W      d(N)      NxN diagonal matrix W (diagonal elements only)
*     V      d(NP,NP)  array containing NxN orthogonal matrix V
*
*  Returned:
*     WORK   d(N)      workspace
*     CVM    d(NC,NC)  array to receive covariance matrix
*
*  Reference:
*     Numerical Recipes, section 14.3.
*
*  P.T.Wallace   Starlink   December 1988
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER N,NP,NC
      DOUBLE PRECISION W(N),V(NP,NP),WORK(N),CVM(NC,NC)

      INTEGER I,J,K
      DOUBLE PRECISION S



      DO I=1,N
         S=W(I)
         IF (S.NE.0D0) THEN
            WORK(I)=1D0/(S*S)
         ELSE
            WORK(I)=0D0
         END IF
      END DO
      DO I=1,N
         DO J=1,I
            S=0D0
            DO K=1,N
               S=S+V(I,K)*V(J,K)*WORK(K)
            END DO
            CVM(I,J)=S
            CVM(J,I)=S
         END DO
      END DO

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGEZSU (ITOC,XDRA,YDRA,IDXY,MANY,NPTS,LABG,IIVX,IIEX,
     +                                                      IIVY,IIEY)
C
      REAL XDRA(1),YDRA(1)
      CHARACTER*(*) LABG
C
C The routine AGEZSU is used by the AUTOGRAPH routines EZY, EZXY, EZMY,
C EZMXY, and IDIOT to examine those parameters which are peculiar to the
C old version of AUTOGRAPH and to do the appropriate call to AGSTUP.
C The arguments are as follows:
C
C -- ITOC indicates which routine is calling AGEZSU, as follows:
C
C     -- ITOC .EQ. 1 - call by EZY
C     -- ITOC .EQ. 2 - call by EZXY
C     -- ITOC .EQ. 3 - call by EZMY
C     -- ITOC .EQ. 4 - call by EZMXY
C     -- ITOC .EQ. 5 - call by IDIOT
C
C -- XDRA is an array of x-coordinate data.
C
C -- YDRA is an array of y-coordinate data.
C
C -- IDXY is the first dimension of YDRA.
C
C -- MANY is the number of curves defined by XDRA and YDRA.
C
C -- NPTS is the number of points per curve.
C
C -- LABG is a new header label (or the single character CHAR(0), if the
C    header label is to be unchanged).
C
C -- IIVX, IIEX, IIVY, and IIEY are indexing controls for the x and y
C    data arrays, computed and returned by AGEZSU for use in setting up
C    calls to the routine AGCURV.
C
C Examine the frame-advance parameter.  Do frame advance as appropriate.
C
      CALL AGGETI ('FRAM.',IFRA)
      IFRA=MAX0(1,MIN0(3,IFRA))
C
      IF (IFRA.EQ.3) CALL FRAME
C
C Set up the header label.
C
      IF (ICHAR(LABG(1:1)).NE.0) THEN
        CALL AGSETC ('LABE/NAME.', 'T')
        CALL AGSETI ('LINE/NUMB.', 100)
        CALL AGSETC ('LINE/TEXT.',LABG)
      END IF
C
C Set up the AGSTUP arguments defining the coordinate-data arrays.
C
      CALL AGGETI ('ROW .',IROW)
      IROW=MAX0(-2,MIN0(+2,IROW))
C
      NVIY=MANY
      IIVY=IDXY
      NEVY=NPTS
      IIEY=1
C
      IF (IROW.LE.0.AND.ITOC.GE.3.AND.ITOC.LE.4) THEN
        IIVY=1
        IIEY=IDXY
      END IF
C
      NVIX=NVIY
      IIVX=IIVY
      NEVX=NEVY
      IIEX=IIEY
C
      IF (IABS(IROW).LE.1) THEN
        NVIX=1
        IIVX=0
        NEVX=NPTS
        IIEX=1
      END IF
C
      IF (ITOC.EQ.1.OR.ITOC.EQ.3) IIEX=0
C
C Do the AGSTUP call.
C
      CALL AGSTUP (XDRA,NVIX,IIVX,NEVX,IIEX,YDRA,NVIY,IIVY,NEVY,IIEY)
C
C Done.
C
      RETURN
C
      END

C----------------------------------------------------------------------
        subroutine ftpgpi(ounit,group,fparm,nparm,array,status)

C       Write an array of group parmeters into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being written).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       fparm   i  the first group parameter to be written (starting with 1)
C       nparm   i  number of group parameters to be written
C       array   i*2  the array of group parameters to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,fparm,nparm,status,row
        integer*2 array(*)

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
        row=max(group,1)
        call ftpcli(ounit,1,row,fparm,nparm,array,status)
        end

include	defs

# upper - fold all alphas to upper case

   subroutine upper (token)
   character token (ARB)

   character cupper

   integer i

   for (i = 1; token (i) != EOS; i = i + 1)
      token (i) = cupper (token (i))

   return
   end

include	defs

# fmtdat - format date and time information

   subroutine fmtdat(date, time, now, form)
   character date(ARB), time(ARB)
   integer now(7), form

   # at present, simply return mm/dd/yy and hh:mm:ss
   # 'form' is reserved for selecting different formats
   # when those have been chosen.

   date(1) = now(2) / 10 + DIG0
   date(2) = mod(now(2), 10) + DIG0
   date(3) = SLASH
   date(4) = now(3) / 10 + DIG0
   date(5) = mod(now(3), 10) + DIG0
   date(6) = SLASH
   date(7) = mod(now(1), 100) / 10 + DIG0
   date(8) = mod(now(1), 10) + DIG0
   date(9) = EOS

   time(1) = now(4) / 10 + DIG0
   time(2) = mod(now(4), 10) + DIG0
   time(3) = COLON
   time(4) = now(5) / 10 + DIG0
   time(5) = mod(now(5), 10) + DIG0
   time(6) = COLON
   time(7) = now(6) / 10 + DIG0
   time(8) = mod(now(6), 10) + DIG0
   time(9) = EOS

   return
   end

#-h-  repcod			  262  local   12/01/80  15:54:35
# repcod - generate code for beginning of repeat
   include  defs

   subroutine repcod (lab)
   integer lab

   integer labgen

   call outcon (0)   # in case there was a label
   lab = labgen (3)
   call outcon (lab)
   lab = lab + 1   # label to go on next's
   call indent (1)
   return
   end

      SUBROUTINE slINTI (STRING, NSTRT, IRESLT, JFLAG)
*+
*     - - - - - -
*      I N T I
*     - - - - - -
*
*  Convert free-format input into an integer
*
*  Given:
*     STRING     c     string containing number to be decoded
*     NSTRT      i     pointer to where decoding is to start
*     IRESLT     i     current value of result
*
*  Returned:
*     NSTRT      i      advanced to next number
*     IRESLT     i      result
*     JFLAG      i      status: -1 = -OK, 0 = +OK, 1 = null, 2 = error
*
*  Called:  slICHI
*
*  Notes:
*
*     1     The reason INTIN has separate OK status values for +
*           and - is to enable minus zero to be detected.   This is
*           of crucial importance when decoding mixed-radix numbers.
*           For example, an angle expressed as deg, arcmin, arcsec
*           may have a leading minus sign but a zero degrees field.
*
*     2     A TAB is interpreted as a space.
*
*     3     The basic format is the sequence of fields #^, where
*           # is a sign character + or -, and ^ means a string of
*           decimal digits.
*
*     4     Spaces:
*
*             .  Leading spaces are ignored.
*
*             .  Spaces between the sign and the number are allowed.
*
*             .  Trailing spaces are ignored;  the first signifies
*                end of decoding and subsequent ones are skipped.
*
*     5     Delimiters:
*
*             .  Any character other than +,-,0-9 or space may be
*                used to signal the end of the number and terminate
*                decoding.
*
*             .  Comma is recognized by INTIN as a special case;  it
*                is skipped, leaving the pointer on the next character.
*                See 9, below.
*
*     6     The sign is optional.  The default is +.
*
*     7     A "null result" occurs when the string of characters being
*           decoded does not begin with +,- or 0-9, or consists
*           entirely of spaces.  When this condition is detected, JFLAG
*           is set to 1 and IRESLT is left untouched.
*
*     8     NSTRT = 1 for the first character in the string.
*
*     9     On return from INTIN, NSTRT is set ready for the next
*           decode - following trailing blanks and any comma.  If a
*           delimiter other than comma is being used, NSTRT must be
*           incremented before the next call to INTIN, otherwise
*           all subsequent calls will return a null result.
*
*     10    Errors (JFLAG=2) occur when:
*
*             .  there is a + or - but no number;  or
*
*             .  the number is greater than BIG (defined below).
*
*     11    When an error has been detected, NSTRT is left
*           pointing to the character following the last
*           one used before the error came to light.
*
*     12    See also FLOTIN and DFLTIN.
*
*  P.T.Wallace   Starlink   27 April 1998
*
*  Copyright (C) 1998 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER NSTRT,IRESLT,JFLAG

*  Maximum allowed value
      DOUBLE PRECISION BIG
      PARAMETER (BIG=2147483647D0)

      INTEGER JPTR,MSIGN,NVEC,J
      DOUBLE PRECISION DRES,DIGIT



*  Current character
      JPTR=NSTRT

*  Set defaults
      DRES=0D0
      MSIGN=1

*  Look for sign
 100  CONTINUE
      CALL slICHI(STRING,JPTR,NVEC,DIGIT)
      GO TO ( 400, 100,  300,  200, 9110, 9100, 9110),NVEC
*             0-9   SP     +     -     ,   ELSE   END

*  Negative
 200  CONTINUE
      MSIGN=-1

*  Look for first decimal
 300  CONTINUE
      CALL slICHI(STRING,JPTR,NVEC,DIGIT)
      GO TO ( 400, 300, 9200, 9200, 9200, 9200, 9210),NVEC
*             0-9   SP     +     -     ,   ELSE   END

*  Accept decimals
 400  CONTINUE
      DRES=DRES*1D1+DIGIT

*  Test for overflow
      IF (DRES.GT.BIG) GO TO 9200

*  Look for subsequent decimals
      CALL slICHI(STRING,JPTR,NVEC,DIGIT)
      GO TO ( 400, 1610, 1600, 1600, 1600, 1600, 1610),NVEC
*             0-9   SP     +     -     ,   ELSE   END

*  Get result & status
 1600 CONTINUE
      JPTR=JPTR-1
 1610 CONTINUE
      J=0
      IF (MSIGN.EQ.1) GO TO 1620
      J=-1
      DRES=-DRES
 1620 CONTINUE
      IRESLT=NINT(DRES)

*  Skip to end of field
 1630 CONTINUE
      CALL slICHI(STRING,JPTR,NVEC,DIGIT)
      GO TO (1720, 1630, 1720, 1720, 9900, 1720, 9900),NVEC
*             0-9   SP     +     -     ,   ELSE   END

 1720 CONTINUE
      JPTR=JPTR-1
      GO TO 9900

*  Exits

*  Null field
 9100 CONTINUE
      JPTR=JPTR-1
 9110 CONTINUE
      J=1
      GO TO 9900

*  Errors
 9200 CONTINUE
      JPTR=JPTR-1
 9210 CONTINUE
      J=2

*  Return
 9900 CONTINUE
      NSTRT=JPTR
      JFLAG=J

      END

      SUBROUTINE slINVF (FWDS,BKWDS,J)
*+
*     - - - - -
*      I N V F
*     - - - - -
*
*  Invert a linear model of the type produced by the slFTXY routine.
*
*  Given:
*     FWDS    d(6)      model coefficients
*
*  Returned:
*     BKWDS   d(6)      inverse model
*     J        i        status:  0 = OK, -1 = no inverse
*
*  The models relate two sets of [X,Y] coordinates as follows.
*  Naming the elements of FWDS:
*
*     FWDS(1) = A
*     FWDS(2) = B
*     FWDS(3) = C
*     FWDS(4) = D
*     FWDS(5) = E
*     FWDS(6) = F
*
*  where two sets of coordinates [X1,Y1] and [X2,Y1] are related
*  thus:
*
*     X2 = A + B*X1 + C*Y1
*     Y2 = D + E*X1 + F*Y1
*
*  the present routine generates a new set of coefficients:
*
*     BKWDS(1) = P
*     BKWDS(2) = Q
*     BKWDS(3) = R
*     BKWDS(4) = S
*     BKWDS(5) = T
*     BKWDS(6) = U
*
*  such that:
*
*     X1 = P + Q*X2 + R*Y2
*     Y1 = S + T*X2 + U*Y2
*
*  Two successive calls to slINVF will thus deliver a set
*  of coefficients equal to the starting values.
*
*  To comply with the ANSI Fortran standard, FWDS and BKWDS must
*  not be the same array, even though the routine is coded to
*  work on many platforms even if this rule is violated.
*
*  See also slFTXY, slPXY, slXYXY, slDCMF
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION FWDS(6),BKWDS(6)
      INTEGER J

      DOUBLE PRECISION A,B,C,D,E,F,DET



      A=FWDS(1)
      B=FWDS(2)
      C=FWDS(3)
      D=FWDS(4)
      E=FWDS(5)
      F=FWDS(6)
      DET=B*F-C*E
      IF (DET.NE.0D0) THEN
         BKWDS(1)=(C*D-A*F)/DET
         BKWDS(2)=F/DET
         BKWDS(3)=-C/DET
         BKWDS(4)=(A*E-B*D)/DET
         BKWDS(5)=-E/DET
         BKWDS(6)=B/DET
         J=0
      ELSE
         J=-1
      END IF

      END

C--------------------------------------------------------------------------
        subroutine ftmcrd(ounit,keywrd,card,status)

C       modify (overwrite) a given header record specified by keyword name.
C       This can be used to overwrite the name of the keyword as well as
C       the value and comment fields.
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       card    c  new 80-character card image to be written
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Feb 1992

        character*(*) keywrd,card
        integer ounit,status
        character value*80
        
        if (status .gt. 0)return

C       find the old keyword string
        call ftgcrd(ounit,keywrd,value,status)
        
        value=card

C       make sure new keyword name is in upper case
        call ftupch(value(1:8))

C       test that keyword name contains only legal characters
        call fttkey(value(1:8),status)

C       write the new keyword record
        call ftmodr(ounit,value,status)
        end

C----------------------------------------------------------------------------
        subroutine ftgsvd(iunit,colnum,naxis,naxes,blc,trc,inc,
     &  nulval,array,anynul,status)

C       read a subsection of double precision data values from an image or
C       a table column.  

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read from
C       naxis   i  number of dimensions in the FITS array
C       naxes   i  size of each dimension. 
C       blc     i  'bottom left corner' of the subsection to be read
C       trc     i  'top right corner' of the subsection to be read
C       inc     i  increment to be applied in each dimension
C       nulval  i  value that undefined pixels will be set to
C       array   i  array of data values that are read from the FITS file
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1993

        integer iunit,colnum,naxis,naxes(*),blc(*),trc(*),inc(*),status
        double precision array(*),nulval
        logical anynul,anyf

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------- -----------------------------

        integer i,i1,i2,i3,i4,i5,i6,i7,i8,i9,row,rstr,rstp,rinc
        integer str(9),stp(9),incr(9),dsize(10)
        integer felem,nelem,nultyp,ninc,ibuff,numcol
        logical ldummy
        character caxis*20

C       this routine is set up to handle a maximum of nine dimensions

        if (status .gt. 0)return

        if (naxis .lt. 1 .or. naxis .gt. 9)then
                status=320
                write(caxis,1001)naxis
1001            format(i20)
                call ftpmsg('NAXIS ='//caxis//' in the call to FTGSVD '
     &          //'is illegal.')
                return
        end if

C       if this is a primary array, then the input COLNUM parameter should
C       be interpreted as the row number, and we will alway read the image
C       data from column 2 (any group parameters are in column 1).

        ibuff=bufnum(iunit)
        if (hdutyp(ibuff) .eq. 0)then
C               this is a primary array, or image extension
                if (colnum .eq. 0)then
                    rstr=1
                    rstp=1
                else
                    rstr=colnum
                    rstp=colnum
                end if
                rinc=1
                numcol=2
        else
C               this is a table, so the row info is in the (naxis+1) elements
                rstr=blc(naxis+1)
                rstp=trc(naxis+1)
                rinc=inc(naxis+1)
                numcol=colnum
        end if

        nultyp=1
        anynul=.false.
        i1=1
        do 5 i=1,9
                str(i)=1
                stp(i)=1
                incr(i)=1
                dsize(i)=1
5       continue
        do 10 i=1,naxis
                if (trc(i) .lt. blc(i))then
                        status=321
                        write(caxis,1001)i
        call ftpmsg('In FTGSVD, the range specified for axis '//
     &  caxis(19:20)//' has the start greater than the end.')
                        return
                end if
                str(i)=blc(i)
                stp(i)=trc(i)
                incr(i)=inc(i)
                dsize(i+1)=dsize(i)*naxes(i)
10      continue

        if (naxis .eq. 1 .and. naxes(1) .eq. 1)then
C               This is not a vector column, so read all the rows at once
                nelem=(rstp-rstr)/rinc+1
                ninc=rinc
                rstp=rstr
        else
C               have to read each row individually, in all dimensions
                nelem=(stp(1)-str(1))/inc(1)+1
                ninc=incr(1)
        end if

        do 100 row=rstr,rstp,rinc
         do 90 i9=str(9),stp(9),incr(9)
          do 80 i8=str(8),stp(8),incr(8)
           do 70 i7=str(7),stp(7),incr(7)
            do 60 i6=str(6),stp(6),incr(6)
             do 50 i5=str(5),stp(5),incr(5)
              do 40 i4=str(4),stp(4),incr(4)
               do 30 i3=str(3),stp(3),incr(3)
                do 20 i2=str(2),stp(2),incr(2)

        felem=str(1)+(i2-1)*dsize(2)+(i3-1)*dsize(3)+(i4-1)*dsize(4)
     &  +(i5-1)*dsize(5)+(i6-1)*dsize(6)+(i7-1)*dsize(7)
     &  +(i8-1)*dsize(8)+(i9-1)*dsize(9)

        call ftgcld(iunit,numcol,row,felem,nelem,ninc,
     &  nultyp,nulval,array(i1),ldummy,anyf,status)
        if (status .gt. 0)return
        if (anyf)anynul=.true.
        i1=i1+nelem

20              continue
30             continue
40            continue
50           continue
60          continue
70         continue
80        continue
90       continue
100     continue
        end

      subroutine newnot ( break, coef, l, k, brknew, lnew, coefg )
c  from  * a practical guide to splines *  by c. de boor
c  returns  lnew+1  knots in  brknew  which are equidistributed on (a,b)
c  = (break(1),break(l+1)) wrto a certain monotone fctn  g  related to
c  the k-th root of the k-th derivative of the pp function  f  whose pp-
c  representation is contained in  break, coef, l, k .
c
c******  i n p u t ******
c  break, coef, l, k.....contains the pp-representation of a certain
c	 function  f  of order	k . specifically,
c	 d**(k-1)f(x) = coef(k,i)  for	break(i).le. x .lt.break(i+1)
c  lnew.....number of intervals into which the interval (a,b) is to be
c	 sectioned by the new breakpoint sequence  brknew .
c
c******  o u t p u t  ******
c  brknew.....array of length  lnew+1  containing the new breakpoint se-
c	 quence
c  coefg.....the coefficient part of the pp-repr.  break, coefg, l, 2
c	 for the monotone p.linear function  g	wrto which  brknew  will
c	 be equidistributed.
c
c******  optional  p r i n t e d  o u t p u t  ******
c  coefg.....the pp coeffs of  g  are printed out if  iprint  is set
c	 .gt. 0  in data statement below.
c
c******  m e t h o d  ******
c     the k-th derivative of the given pp function  f  does not exist
c  (except perhaps as a linear combination of delta functions). never-
c  theless, we construct a p.constant function	h  with breakpoint se-
c  quence  break  which is approximately proportional to abs(d**k(f)).
c  specifically, on  (break(i), break(i+1)),
c
c     abs(jump at break(i) of pc)    abs(jump at break(i+1) of pc)
c h = --------------------------  +  ----------------------------
c	break(i+1) - break(i-1) 	break(i+2) - break(i)
c
c  with  pc  the p.constant (k-1)st derivative of  f .
c      then, the p.linear function  g  is constructed as
c
c    g(x)  =  integral of  h(y)**(1/k)	for  y	from  a  to  x
c
c  and its pp coeffs. stored in  coefg .
c     then  brknew  is determined by
c
c	 brknew(i)  =  a + g**(-1)((i-1)*step) , i=1,...,lnew+1
c
c  where  step = g(b)/lnew  and  (a,b) = (break(1),break(l+1)) .
c     in the event that  pc = d**(k-1)(f) is constant in  (a,b)  and
c  therefore  h = 0 identically,  brknew  is chosen uniformly spaced.
c
      integer k,l,lnew,   i,iprint,j
      real break(1),brknew(1),coef(k,l),coefg(2,l),   dif,difprv,oneovk
     *						     ,step,stepi
c     dimension break(l+1), brknew(lnew+1)
current fortran standard makes it impossible to specify the dimension
c  of  break   and  brknew  without the introduction of additional
c  otherwise superfluous arguments.
      data iprint /0/
c
      brknew(1) = break(1)
      brknew(lnew+1) = break(l+1)
c				if  g  is constant,  brknew  is uniform.
      if (l .le. 1)			go to 90
c			 construct the continuous p.linear function  g .
      oneovk = 1./float(k)
      coefg(1,1) = 0.
      difprv = abs(coef(k,2) - coef(k,1))/(break(3)-break(1))
      do 10 i=2,l
	 dif = abs(coef(k,i) - coef(k,i-1))/(break(i+1) - break(i-1))
	 coefg(2,i-1) = (dif + difprv)**oneovk
	 coefg(1,i) = coefg(1,i-1)+coefg(2,i-1)*(break(i)-break(i-1))
   10	 difprv = dif
      coefg(2,l) = (2.*difprv)**oneovk
c						      step  =  g(b)/lnew
      step = (coefg(1,l)+coefg(2,l)*(break(l+1)-break(l)))/float(lnew)
c
      if (iprint .gt. 0) print 600, step,(i,coefg(1,i),coefg(2,i),i=1,l)
  600 format(7h step =,e16.7/(i5,2e16.5))
c			       if  g  is constant,  brknew  is uniform .
      if (step .le. 0.) 		go to 90
c
c      for i=2,...,lnew, construct  brknew(i) = a + g**(-1)(stepi),
c      with  stepi = (i-1)*step .  this requires inversion of the p.lin-
c      ear function  g .  for this,  j	is found so that
c	  g(break(j)) .le. stepi .le. g(break(j+1))
c      and then
c	  brknew(i)  =	break(j) + (stepi-g(break(j)))/dg(break(j)) .
c      the midpoint is chosen if  dg(break(j)) = 0 .
      j = 1
      do 30 i=2,lnew
	 stepi = float(i-1)*step
   21	    if (j .eq. l)		go to 27
	    if (stepi .le. coefg(1,j+1))go to 27
	    j = j + 1
					go to 21
   27	 if (coefg(2,j) .eq. 0.)	go to 29
	    brknew(i) = break(j) + (stepi - coefg(1,j))/coefg(2,j)
					go to 30
   29	    brknew(i) = (break(j) + break(j+1))/2.
   30	 continue
					return
c
c			       if  g  is constant,  brknew  is uniform .
   90 step = (break(l+1) - break(1))/float(lnew)
      do 93 i=2,lnew
   93	 brknew(i) = break(1) + float(i-1)*step
					return
      end

C--------------------------------------------------------------------------
        subroutine ftrsnm

C       simply reset the column names as undefined
C       this will force ftgcnn to read the column names from the
C       file the next time it is called

C       written by Wm Pence, HEASARC/GSFC, Feb 1995

        integer colpnt,untpnt
        common/ftname/colpnt,untpnt

        colpnt= -999
        untpnt=0
        end

      subroutine setdt3(icount)
c  from  * a practical guide to splines *  by c. de boor
c  to be called in main program  l 2 m a i n .
c	calls titand
c     this routine is set up to provide the specific data for example 4
c     in chapter xiv.
      integer icount,  i,k,l,n,ntau
      real break,brkpic(9),coef,gtau,tau,totalw,weight
c     parameter lpkmax=100,ntmax=200,ltkmax=2000
c     common / data / ntau, tau(ntmax),gtau(ntmax),weight(ntmax),totalw
c     common /approx/ break(lpkmax),coef(ltkmax),l,k
      common / data / ntau, tau(200),gtau(200),weight(200),totalw
      common /approx/ break(100),coef(2000),l,k
      data brkpic,n/595.,730.985,794.414,844.476,880.06,907.814,
     *		    938.001,976.752,1075.,9/
      if (icount .gt. 0)		stop
      icount = icount + 1
      call titand ( tau, gtau, ntau )
      do 10 i=1,ntau
   10	 weight(i) = 1.
      totalw = ntau
      l = n-1
      k = 5
      do 11 i=1,n
   11	 break(i) = brkpic(i)
					return
      end

C------------------------------------------------------------------------------
C   This software was prepared by High Energy Astrophysic Science Archive
C   Research Center (HEASARC) at the NASA Goddard Space Flight Center. Users
C   shall not, without prior written permission of the U.S. Government,
C   establish a claim to statutory copyright.  The Government and others acting
C   on its behalf, shall have a royalty-free, non-exclusive, irrevocable,
C   worldwide license for Government purposes to publish, distribute,
C   translate, copy, exhibit, and perform such material. 
C------------------------------------------------------------------------------
        subroutine ftvers(vernum)

C       Returns the current revision number of the FITSIO package.
C       The revision number will be incremented whenever any modifications,
C       bug fixes, or enhancements are made to the package

        real vernum
C       version 4.06   18 Aug   1995   ftdelt bug; ftpmsg saves latest errors
C       version 4.05    2 Aug   1995   another bug in ftfrcl in reseting tstart
C       version 4.04   12 Jul   1995   bug in ftfrcl in resetting tstart
C       version 4.03    3 Jul   1995   bug in restoring CHDU when moving to EOF
C       version 4.02   20 Jun   1995   modified checksum algorithm
C       version 4.01   30 May   1995   many changes
C       version 3.711  30 Jan   1995   ftgphx was cutting BSCALE to 20 chars
C       version 3.710  27 Jan   1995   fix ftgcnn, fitsmac; add ftirec, ftdrec
C       version 3.700  29 Dec   1994   public release
C       version 3.623   8 Nov   1994   ftgkys, ftgnst, checksum
C       version 3.622   7 Nov   1994   ftgclj R*8 alignment; I*2 overflow fti4i2
C       version 3.621   4 Nov   1994   fixed endhd position in ftgrec
C       version 3.62    2 Nov   1994   ftgcx[ijd] routines added
C       version 3.612  31 Oct   1994   restored previous FTIBLK algorithm
C       version 3.61   26 Oct   1994   ftirow and ftdrow to modify tables
C       version 3.6    18 Oct   1994   ftukyX, range checking, new EOF checks
C       version 3.512  20 Sep   1994   fixed writing header fill in FTWEND 
C       version 3.511  20 Sep   1994   removed '=' from CONTINUE on long strings
C       version 3.51   14 Sep   1994   long string convention and IEEE support
C       version 3.504  22 Aug   1994   fixed bug in ftcopy making files too big
C       version 3.503   8 Aug   1994   fixed bug in ftcopy making files too big
C       version 3.502  26 Jul   1994   explicitly write data fill bytes
C       version 3.501  19 Jul   1994   minor changes for FTOOLS release
C       version 3.500  29 Jun   1994   added error message stack
C       version 3.415  07 Jun   1994   fixed ftmahd and ftgrec
C       version 3.414  18 May   1994   modify ftmoff and ftpbyt for status 112
C       version 3.413  18 Mar   1994   Cray port added
C       version 3.412  01 Mar   1994   SUN internal read problem in ftgthd
C       version 3.411  25 Feb   1994   fixed 107 error when reading byte column
C       version 3.410  21 Jan   1994   bug fixes in Alpha VMS version
C       version 3.409  21 Dec   1993   long string bug; HP support
C       version 3.408  09 Nov   1993   Alpha VMS open; ftgthd -; 210 status
C       version 3.407  02 Nov   1993   initialize TABLEs with blanks; ftrdef
C       version 3.406  26 Oct   1993   ftgtdm bug - last not initialized
C                                      modified to read unknown extenstions
C       version 3.405  21 Oct   1993   ftpini bug with GROUP format files
C       version 3.404   7 Oct   1993   new TDIM subroutines, new error status
C       version 3.403   1 Sept  1993   initialize strlen in ftpkys
C       version 3.402  23 Aug   1993   bug in ftgcno
C       version 3.401  20 Aug   1993   minor change to ftpi1b
C       version 3.4  - 11 Aug   1993
C       version 3.31 -  2 Feb   1993
C       version 3.3  - 28 Oct   1992
C       version 3.21 -  8 July  1992
C       version 3.20 - 30 Mar   1992
C       version 3.10 -  4 Nov   1991
C       version 3.01 - 27 Sept  1991
C       version 3.00 - 12 Sept  1991
C       version 2.99 - 24 July  1991
C       version 2.0  -  1 May   1991
C       version 1.3  -  2 April 1991
C       version 1.22 - 22 March 1991
C       version 1.21 - 20 March 1991

        vernum=4.06
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGQURV (XVEC,IIEX,YVEC,IIEY,NEXY,SVAL)
C
      DIMENSION XVEC(1),YVEC(1)
C
C AGQURV plots the curve defined by the points ((X(I),Y(I)),I=1,NEXY),
C where
C
C    X(I)=XVEC(1+(I-1)*IIEX) (unless IIEX=0, in which case X(I)=I), and
C    Y(I)=YVEC(1+(I-1)*IIEY) (unless IIEY=0, in which case Y(I)=I).
C
C If, for some I, X(I)=SVAL or Y(I)=SVAL, curve line segments having
C (X(I),Y(I)) as an endpoint are omitted.
C
C The curve drawn is windowed.  Portions of the curve which would fall
C outside the current curve window, as defined by the last SET call,
C are not drawn.
C
C Check first whether the number of curve points is properly specified.
C
      IF (NEXY.LE.0) GO TO 901
C
C Initialization.  Pretend that the last point was point number zero.
C Set the indices for the x and y vectors accordingly.  Clear the line-
C drawn-to-last-point and last-point-outside-window flags.
C
      INDP=0
      INDX=1-IIEX
      INDY=1-IIEY
      LDLP=0
      LPOW=0
C
C Initialization.  Retrieve the current curve window, user window, and
C x/y linear/logarithmic flags.
C
      CALL GETSET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,LTYP)
C
C Initialization.  Set linear/log flag and linear-window limits for
C x-axis values.
C
      IF (LTYP.EQ.1.OR.LTYP.EQ.2) THEN
        LLUX=0
        XLLW=XLUW
        XRLW=XRUW
      ELSE
        LLUX=1
        XLLW=ALOG10(XLUW)
        XRLW=ALOG10(XRUW)
      END IF
C
C Initialization.  Set linear/log flag and linear-window limits for
C y-axis values.
C
      IF (LTYP.EQ.1.OR.LTYP.EQ.3) THEN
        LLUY=0
        YBLW=YBUW
        YTLW=YTUW
      ELSE
        LLUY=1
        YBLW=ALOG10(YBUW)
        YTLW=ALOG10(YTUW)
      END IF
C
C Initialization.  Call SET, if necessary, to define a linear mapping.
C (This greatly simplifies the windowing code.)
C
      IF (LTYP.NE.1)
     +              CALL SET (XLCW,XRCW,YBCW,YTCW,XLLW,XRLW,YBLW,YTLW,1)
C
C Initialization.  Compute mimimum and maximum values of x which are
C slightly outside the linear window.  (Note:  XLLW and XRLW will not
C be used after this.)
C
      IF (XLLW.GT.XRLW) THEN
        TEMP=XLLW
        XLLW=XRLW
        XRLW=TEMP
      END IF
      XEPS=.000001*(XRLW-XLLW)
      XMIN=XLLW-XEPS
      XMAX=XRLW+XEPS
C
C Initialization.  Compute minimum and maximum values of y which are
C slightly outside the linear window.  (Note:  YBLW and YTLW will not
C be used after this.)
C
      IF (YBLW.GT.YTLW) THEN
        TEMP=YBLW
        YBLW=YTLW
        YTLW=TEMP
      END IF
      YEPS=.000001*(YTLW-YBLW)
      YMIN=YBLW-YEPS
      YMAX=YTLW+YEPS
C
C Beginning of loop through points.  Update indices and determine the
C user-space coordinates of the next point.
C
  101 IF (INDP.EQ.NEXY) GO TO 120
      INDP=INDP+1
C
      INDX=INDX+IIEX
      XNXT=XVEC(INDX)
      IF (IIEX.EQ.0) XNXT=FLOAT(INDP)
      IF (LLUX.NE.0.AND.XNXT.LE.0.) XNXT=SVAL
C
      INDY=INDY+IIEY
      YNXT=YVEC(INDY)
      IF (IIEY.EQ.0) YNXT=FLOAT(INDP)
      IF (LLUY.NE.0.AND.YNXT.LE.0.) YNXT=SVAL
C
C Check whether (XNXT,YNXT) is a special-value point.  Handle that case.
C
      IF (XNXT.EQ.SVAL.OR.YNXT.EQ.SVAL) THEN
        LPOW=0
        IF (LDLP.EQ.0) GO TO 101
        IF (LDLP.EQ.1) CALL VECTD (XLST,YLST)
        CALL LASTD
        LDLP=0
        GO TO 101
      END IF
C
C If user space is not linear/linear, modify XNXT and YNXT accordingly.
C
      IF (LLUX.NE.0) XNXT=ALOG10(XNXT)
      IF (LLUY.NE.0) YNXT=ALOG10(YNXT)
C
C Set the next-point-outside-window flag to a value between -4 and +4,
C inclusive.  A non-zero value indicates that the next point is outside
C the window and indicates which of eight possible areas it falls in.
C
      NPOW=IFIX(3.*(SIGN(.51,XNXT-XMIN)+SIGN(.51,XNXT-XMAX))+
     +             (SIGN(.51,YNXT-YMIN)+SIGN(.51,YNXT-YMAX)))
C
C There are now various possible cases, depending on whether the line-
C drawn-to-last-point flag is set or not, whether the next point is in
C the window or not, and whether the last point was in the window, not
C in the window, or non-existent (point 0 or a special-value point).
C
      IF (LDLP.EQ.0) GO TO 102
      IF (NPOW.NE.0) GO TO 103
C
C Line drawn to last point, next point inside, last point inside.
C
      CALL VECTD (XNXT,YNXT)
      LDLP=LDLP+1
      GO TO 119
C
  102 IF (NPOW.NE.0) GO TO 109
      IF (LPOW.NE.0) GO TO 105
C
C No line drawn to last point, next point inside, no last point.
C
      CALL FRSTD (XNXT,YNXT)
      LDLP=1
      GO TO 119
C
C Line drawn to last point, next point outside, last point inside.
C
  103 XPIW=XLST
      YPIW=YLST
      XPOW=XNXT
      YPOW=YNXT
      ASSIGN 104 TO JUMP
      GO TO 107
  104 CALL VECTD (XPEW,YPEW)
      CALL LASTD
      LDLP=0
      GO TO 119
C
C No line drawn to last point, next point inside, last point outside.
C
  105 XPIW=XNXT
      YPIW=YNXT
      XPOW=XLST
      YPOW=YLST
      ASSIGN 106 TO JUMP
      GO TO 107
  106 CALL FRSTD (XPEW,YPEW)
      CALL VECTD (XNXT,YNXT)
      LDLP=2
      GO TO 119
C
C The following local procedure, given a point (XPIW,YPIW) inside the
C window and a point (XPOW,YPOW) outside the window, finds the point of
C intersection (XPEW,YPEW) of a line joining them with the window edge.
C
  107 XPEW=XPIW
      YPEW=YPIW
      XDIF=XPOW-XPIW
      YDIF=YPOW-YPIW
C
      IF (ABS(XDIF).GT.XEPS) THEN
        XPEW=XMIN
        IF (XDIF.GE.0.) XPEW=XMAX
        YPEW=YPIW+(XPEW-XPIW)*YDIF/XDIF
        IF (YPEW.GE.YMIN.AND.YPEW.LE.YMAX) GO TO 108
      END IF
C
      IF (ABS(YDIF).GT.YEPS) THEN
        YPEW=YMIN
        IF (YDIF.GE.0.) YPEW=YMAX
        XPEW=XPIW+(YPEW-YPIW)*XDIF/YDIF
      END IF
C
  108 GO TO JUMP , (104,106)
C
C No line drawn to last point, next point outside.  Jump if no last
C point.
C
  109 IF (LPOW.EQ.0) GO TO 119
C
C No line drawn to last point, next point outside, last point outside.
C Check whether a portion of the line joining them lies in the window.
C
      MPOW=9*LPOW+NPOW+41
C
      GO TO (119,119,119,119,119,110,119,110,110,
     +       119,119,119,111,119,110,111,110,110,
     +       119,119,119,111,119,119,111,111,119,
     +       119,113,113,119,119,110,119,110,110,
     +       119,119,119,119,119,119,119,119,119,
     +       112,112,119,112,119,119,111,111,119,
     +       119,113,113,119,119,113,119,119,119,
     +       112,112,113,112,119,113,119,119,119,
     +       112,112,119,112,119,119,119,119,119) , MPOW
C
  110 XPE1=XMIN
      YPT1=YMIN
      XPE2=XMAX
      YPT2=YMAX
      GO TO 114
C
  111 XPE1=XMIN
      YPT1=YMAX
      XPE2=XMAX
      YPT2=YMIN
      GO TO 114
C
  112 XPE1=XMAX
      YPT1=YMAX
      XPE2=XMIN
      YPT2=YMIN
      GO TO 114
C
  113 XPE1=XMAX
      YPT1=YMIN
      XPE2=XMIN
      YPT2=YMAX
C
  114 XDIF=XNXT-XLST
      YDIF=YNXT-YLST
C
      IF (ABS(XDIF).LE.XEPS) GO TO 116
      YPE1=YLST+(XPE1-XLST)*YDIF/XDIF
      YPE2=YLST+(XPE2-XLST)*YDIF/XDIF
C
      IF (ABS(YDIF).LE.YEPS) GO TO 118
      IF (YPE1.GE.YMIN.AND.YPE1.LE.YMAX) GO TO 115
      YPE1=YPT1
      XPE1=XLST+(YPE1-YLST)*XDIF/YDIF
      IF (XPE1.LT.XMIN.OR.XPE1.GT.XMAX) GO TO 119
C
  115 IF (YPE2.GE.YMIN.AND.YPE2.LE.YMAX) GO TO 118
      GO TO 117
C
  116 YPE1=YPT1
      XPE1=XLST+(YPE1-YLST)*XDIF/YDIF
      IF (XPE1.LT.XMIN.OR.XPE1.GT.XMAX) GO TO 119
C
  117 YPE2=YPT2
      XPE2=XLST+(YPE2-YLST)*XDIF/YDIF
      IF (XPE2.LT.XMIN.OR.XPE2.GT.XMAX) GO TO 119
C
  118 CALL FRSTD (XPE1,YPE1)
      CALL VECTD (XPE2,YPE2)
      CALL LASTD
C
C Processing of next point is done.  It becomes the last point and we
C go back for a new next point.
C
  119 LPOW=NPOW
      XLST=XNXT
      YLST=YNXT
      GO TO 101
C
C Last point was final point.  Finish up.
C
  120 IF (LDLP.NE.0) THEN
        IF (LDLP.EQ.1) CALL VECTD (XLST,YLST)
        CALL LASTD
      END IF
C
C Restore logarithmic mapping, if appropriate.
C
      IF (LTYP.NE.1)
     +           CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,LTYP)
C
C Return to caller.
C
      RETURN
C
C Error exit.
C
  901 CALL SETER ('AGQURV - NUMBER OF POINTS IS LESS THAN OR EQUAL TO ZE
     +RO',7,2)
C
      END

*> \brief \b DGETF2 computes the LU factorization of a general m-by-n matrix using partial pivoting with row interchanges (unblocked algorithm).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download DGETF2 + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dgetf2.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dgetf2.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dgetf2.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE DGETF2( M, N, A, LDA, IPIV, INFO )
*
*       .. Scalar Arguments ..
*       INTEGER            INFO, LDA, M, N
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       DOUBLE PRECISION   A( LDA, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DGETF2 computes an LU factorization of a general m-by-n matrix A
*> using partial pivoting with row interchanges.
*>
*> The factorization has the form
*>    A = P * L * U
*> where P is a permutation matrix, L is lower triangular with unit
*> diagonal elements (lower trapezoidal if m > n), and U is upper
*> triangular (upper trapezoidal if m < n).
*>
*> This is the right-looking Level 2 BLAS version of the algorithm.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix A.  M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the m by n matrix to be factored.
*>          On exit, the factors L and U from the factorization
*>          A = P*L*U; the unit diagonal elements of L are not stored.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (min(M,N))
*>          The pivot indices; for 1 <= i <= min(M,N), row i of the
*>          matrix was interchanged with row IPIV(i).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -k, the k-th argument had an illegal value
*>          > 0: if INFO = k, U(k,k) is exactly zero. The factorization
*>               has been completed, but the factor U is exactly
*>               singular, and division by zero will occur if it is used
*>               to solve a system of equations.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup doubleGEcomputational
*
*  =====================================================================
      SUBROUTINE DGETF2( M, N, A, LDA, IPIV, INFO )
*
*  -- LAPACK computational routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   SFMIN
      INTEGER            I, J, JP
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      EXTERNAL           IDAMAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGER, DSCAL, DSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Compute machine safe minimum
*
      SFMIN = D1MACH(1)
*
      DO 10 J = 1, MIN( M, N )
*
*        Find pivot and test for singularity.
*
         JP = J - 1 + IDAMAX( M-J+1, A( J, J ), 1 )
         IPIV( J ) = JP
         IF( A( JP, J ).NE.ZERO ) THEN
*
*           Apply the interchange to columns 1:N.
*
            IF( JP.NE.J )
     $         CALL DSWAP( N, A( J, 1 ), LDA, A( JP, 1 ), LDA )
*
*           Compute elements J+1:M of J-th column.
*
            IF( J.LT.M ) THEN
               IF( ABS(A( J, J )) .GE. SFMIN ) THEN
                  CALL DSCAL( M-J, ONE / A( J, J ), A( J+1, J ), 1 )
               ELSE
                 DO 20 I = 1, M-J
                    A( J+I, J ) = A( J+I, J ) / A( J, J )
   20            CONTINUE
               END IF
            END IF
*
         ELSE IF( INFO.EQ.0 ) THEN
*
            INFO = J
         END IF
*
         IF( J.LT.MIN( M, N ) ) THEN
*
*           Update trailing submatrix.
*
            CALL DGER( M-J, N-J, -ONE, A( J+1, J ), 1, A( J, J+1 ), LDA,
     $                 A( J+1, J+1 ), LDA )
         END IF
   10 CONTINUE
      RETURN
*
*     End of DGETF2
*
      END

c subroutine xfit.f
c
c source
c   Bevington, page 76.
c
c purpose
c   calculate the mean and estimated errors for a set of data points
c
c usage
c   call xfit (x, sigmax, npts, mode, xmean, sigmam, sigma)
c
c description of parameters
c   x      - array of data points
c   sigmax - array of standard deviations for data points
c   npts   - number of data points
c   mode   - determines method of weighting
c            +1 (instrumental) weight(i) = 1./sigmax(i)**2
c             0 (no weighting) weight(i) = 1.
c            -1 (statistical)  weight(i) = 1.
c   xmean  - weighted mean
c   sigmam - standard deviation of mean
c   sigma  - standard deviation of data
c
c subroutines and function subprograms required
c   none
c
	subroutine xfit (x,sigmax,npts,mode,xmean,sigmam,sigma)
	double precision sum,sumx,weight,free
	dimension x(1),sigmax(1)
c
c accumulate weighted sums
c
11	sum=0.
	sumx=0.
	sigma=0.
	sigmam=0.
20	do 32 i=1,npts
21	if (mode) 22,22,24
22	weight=1.
	goto 31
24	weight=1./sigmax(i)**2
31	sum=sum+weight
32	sumx=sumx+weight*x(i)
c
c evaluate mean and standard deviations
c
41	xmean=sumx/sum
51	do 52 i=1,npts
52	sigma=sigma+(x(i)-xmean)**2
	free=npts-1
54	sigma=dsqrt(sigma/free)
61	if (mode) 62,64,66
62	sigmam=dsqrt(xmean/sum)
	goto 70
64	sigmam=sigma/dsqrt(sum)
	goto 70
66	sigmam=dsqrt(1./sum)
70	return
	end

C--------------------------------------------------------------------------
        subroutine ftpini(iunit,status)

C       initialize the parameters defining the structure of the primary data

C       iunit   i  Fortran I/O unit number
C       OUTPUT PARAMETERS:
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,bitpix,naxis,naxes(99),pcnt,gcnt,ttype
        integer blank,bytlen,npix,i,nblank,tstat
        double precision bscale,bzero
        logical simple,extend,groups
        character*8 comm

        if (status .gt. 0)return
        groups=.false.

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       store the type of HDU (0=primary array or image extension)
        hdutyp(ibuff)=0

C       temporarily set the location of the end of the header to a huge number
        hdend(ibuff)=2000000000
        hdstrt(ibuff,chdu(ibuff)+1)=2000000000

C       get the standard header keywords
        tstat=status
        call ftgphx(iunit,99,simple,bitpix,naxis,naxes,
     &        pcnt,gcnt,extend,bscale,bzero,blank,nblank,status)
        if (status .eq. 251)then
C               ignore 'unknown extension type' error, and go on
                status=tstat
        else if (status .gt. 0)then
                return
        end if

        if (naxis .gt. 99)then
C               the image array has too many dimensions for me to handle
                status=111
        call ftpmsg('This FITS image has too many dimensions (FTPINI)')
                return
        end if

C       the 'END' record is 80 bytes before the current position, ignoring
C       any trailing blank keywords just before the END keyword.
        hdend(ibuff)=nxthdr(ibuff)-80*(nblank+1)

C       the data unit begins at the beginning of the next logical block
        dtstrt(ibuff)=((nxthdr(ibuff)-80)/2880+1)*2880

C       test for the presence of 'random groups' structure
        if (naxis .gt. 0 .and. naxes(1) .eq. 0)then
                tstat=status
                call ftgkyl(iunit,'GROUPS',groups,comm,status)
                if (status .gt. 0)then
                        status=tstat
                        groups=.false.
                end if
        end if

C       test  bitpix and set the datatype code value
        if (bitpix .eq. 8)then
                ttype=11
                bytlen=1
        else if (bitpix .eq. 16)then
                ttype=21
                bytlen=2
        else if (bitpix .eq. 32)then
                ttype=41
                bytlen=4
        else if (bitpix .eq. -32)then
                ttype=42
                bytlen=4
        else if (bitpix .eq. -64)then
                ttype=82
                bytlen=8
        end if
        
C       calculate the size of the primary array
        if (naxis .eq. 0)then
                npix=0
        else
                if (groups)then
C                       NAXIS1 = 0 is a special flag for 'random groups'
                        npix=1
                else
                        npix=naxes(1)
                end if

                do 10 i=2,naxis
                        npix=npix*naxes(i)
10              continue
        end if

C       now we know everything about the array; just fill in the parameters:
C       the next HDU begins in the next logical block after the data
        hdstrt(ibuff,chdu(ibuff)+1)=
     &  dtstrt(ibuff)+((pcnt+npix)*bytlen*gcnt+2879)/2880*2880

C       initialize the fictitious heap starting address (immediately following
C       the array data) and a zero length heap.  This is used to find the
C       end of the data when checking the fill values in the last block. 
        scount(ibuff)=0
        theap(ibuff)=(pcnt+npix)*bytlen*gcnt
        nxheap(ibuff)=0

C       quit if there is no data
        if (naxis .eq. 0)then
                tfield(ibuff)=0
                rowlen(ibuff)=0
                go to 900
        end if

C       the primary array is actually interpreted as a binary table.  There
C       are two columns: the first column contains the 
C       group parameters, if any, and the second column contains the
C       primary array of data.  Each group is in a separate row of the table.

        tfield(ibuff)=2
        if (nxtfld + 2 .gt. nf)then
C               too many columns open at one time; exceeded array dimensions
                status=111
        else
                tstart(ibuff)=nxtfld
                nxtfld=nxtfld+2
                tdtype(1+tstart(ibuff))=ttype
                tdtype(2+tstart(ibuff))=ttype
                trept(1+tstart(ibuff))=pcnt
                trept(2+tstart(ibuff))=npix
                tnull(1+tstart(ibuff))=blank
                tnull(2+tstart(ibuff))=blank
                tscale(1+tstart(ibuff))=1.
                tscale(2+tstart(ibuff))=bscale
                tzero(1+tstart(ibuff))=0.
                tzero(2+tstart(ibuff))=bzero
                tbcol(1+tstart(ibuff))=0
                tbcol(2+tstart(ibuff))=pcnt*bytlen
                rowlen(ibuff)=(pcnt+npix)*bytlen
        end if

900     continue
        end

#-h-  brknxt			 1077  local   12/01/80  15:53:46
# brknxt - generate code for break n and next n; n = 1 is default
   include  defs

   subroutine brknxt (sp, lextyp, labval, token)
   integer labval (MAXSTACK), lextyp (MAXSTACK), sp, token

   integer i, n
   integer alldig, ctoi

   character t, ptoken (MAXTOK)
   character gnbtok

   include COMMON_BLOCKS

   n = 0
   t = gnbtok (ptoken, MAXTOK)
   if (alldig (ptoken) == YES) {     # have break n or next n
      i = 1
      n = ctoi (ptoken, i) - 1
      }
   else if (t != SEMICOL)      # default case
      call pbstr (ptoken)
   for (i = sp; i > 0; i = i - 1)
      if (lextyp (i) == LEXWHILE | lextyp (i) == LEXDO
	| lextyp (i) == LEXFOR | lextyp (i) == LEXREPEAT) {
	 if (n > 0) {
	    n = n - 1
	    next	     # seek proper level
	    }
	 else if (token == LEXBREAK)
	    call outgo (labval (i) + 1)
	 else
	    call outgo (labval (i))
	 xfer = YES
	 return
	 }

   if (token == LEXBREAK)
      call synerr ("illegal break.")
   else
      call synerr ("illegal next.")

   return
   end

      SUBROUTINE slAOPQ (RAP, DAP, AOPRMS, AOB, ZOB, HOB, DOB, ROB)
*+
*     - - - - - -
*      A O P Q
*     - - - - - -
*
*  Quick apparent to observed place (but see note 8, below, for
*  remarks about speed).
*
*  Given:
*     RAP    d      geocentric apparent right ascension
*     DAP    d      geocentric apparent declination
*     AOPRMS d(14)  star-independent apparent-to-observed parameters:
*
*       (1)      geodetic latitude (radians)
*       (2,3)    sine and cosine of geodetic latitude
*       (4)      magnitude of diurnal aberration vector
*       (5)      height (HM)
*       (6)      ambient temperature (T)
*       (7)      pressure (P)
*       (8)      relative humidity (RH)
*       (9)      wavelength (WL)
*       (10)     lapse rate (TLR)
*       (11,12)  refraction constants A and B (radians)
*       (13)     longitude + eqn of equinoxes + sidereal DUT (radians)
*       (14)     local apparent sidereal time (radians)
*
*  Returned:
*     AOB    d      observed azimuth (radians: N=0,E=90)
*     ZOB    d      observed zenith distance (radians)
*     HOB    d      observed Hour Angle (radians)
*     DOB    d      observed Declination (radians)
*     ROB    d      observed Right Ascension (radians)
*
*  Notes:
*
*   1)  This routine returns zenith distance rather than elevation
*       in order to reflect the fact that no allowance is made for
*       depression of the horizon.
*
*   2)  The accuracy of the result is limited by the corrections for
*       refraction.  Providing the meteorological parameters are
*       known accurately and there are no gross local effects, the
*       observed RA,Dec predicted by this routine should be within
*       about 0.1 arcsec for a zenith distance of less than 70 degrees.
*       Even at a topocentric zenith distance of 90 degrees, the
*       accuracy in elevation should be better than 1 arcmin;  useful
*       results are available for a further 3 degrees, beyond which
*       the slRFRO routine returns a fixed value of the refraction.
*       The complementary routines slAOP (or slAOPQ) and sla_OaAP
*       (or slOAPQ) are self-consistent to better than 1 micro-
*       arcsecond all over the celestial sphere.
*
*   3)  It is advisable to take great care with units, as even
*       unlikely values of the input parameters are accepted and
*       processed in accordance with the models used.
*
*   4)  "Apparent" place means the geocentric apparent right ascension
*       and declination, which is obtained from a catalogue mean place
*       by allowing for space motion, parallax, precession, nutation,
*       annual aberration, and the Sun's gravitational lens effect.  For
*       star positions in the FK5 system (i.e. J2000), these effects can
*       be applied by means of the slMAP etc routines.  Starting from
*       other mean place systems, additional transformations will be
*       needed;  for example, FK4 (i.e. B1950) mean places would first
*       have to be converted to FK5, which can be done with the
*       slFK45 etc routines.
*
*   5)  "Observed" Az,El means the position that would be seen by a
*       perfect theodolite located at the observer.  This is obtained
*       from the geocentric apparent RA,Dec by allowing for Earth
*       orientation and diurnal aberration, rotating from equator
*       to horizon coordinates, and then adjusting for refraction.
*       The HA,Dec is obtained by rotating back into equatorial
*       coordinates, using the geodetic latitude corrected for polar
*       motion, and is the position that would be seen by a perfect
*       equatorial located at the observer and with its polar axis
*       aligned to the Earth's axis of rotation (n.b. not to the
*       refracted pole).  Finally, the RA is obtained by subtracting
*       the HA from the local apparent ST.
*
*   6)  To predict the required setting of a real telescope, the
*       observed place produced by this routine would have to be
*       adjusted for the tilt of the azimuth or polar axis of the
*       mounting (with appropriate corrections for mount flexures),
*       for non-perpendicularity between the mounting axes, for the
*       position of the rotator axis and the pointing axis relative
*       to it, for tube flexure, for gear and encoder errors, and
*       finally for encoder zero points.  Some telescopes would, of
*       course, exhibit other properties which would need to be
*       accounted for at the appropriate point in the sequence.
*
*   7)  The star-independent apparent-to-observed-place parameters
*       in AOPRMS may be computed by means of the slAOPA routine.
*       If nothing has changed significantly except the time, the
*       slAOPT routine may be used to perform the requisite
*       partial recomputation of AOPRMS.
*
*   8)  At zenith distances beyond about 76 degrees, the need for
*       special care with the corrections for refraction causes a
*       marked increase in execution time.  Moreover, the effect
*       gets worse with increasing zenith distance.  Adroit
*       programming in the calling application may allow the
*       problem to be reduced.  Prepare an alternative AOPRMS array,
*       computed for zero air-pressure;  this will disable the
*       refraction corrections and cause rapid execution.  Using
*       this AOPRMS array, a preliminary call to the present routine
*       will, depending on the application, produce a rough position
*       which may be enough to establish whether the full, slow
*       calculation (using the real AOPRMS array) is worthwhile.
*       For example, there would be no need for the full calculation
*       if the preliminary call had already established that the
*       source was well below the elevation limits for a particular
*       telescope.
*
*  9)   The azimuths etc produced by the present routine are with
*       respect to the celestial pole.  Corrections to the terrestrial
*       pole can be computed using slPLMO.
*
*  Called:  slDS2C, slREFZ, slRFRO, slDC2S, slDA2P
*
*  P.T.Wallace   Starlink   24 October 2003
*
*  Copyright (C) 2003 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RAP,DAP,AOPRMS(14),AOB,ZOB,HOB,DOB,ROB

*  Breakpoint for fast/slow refraction algorithm:
*  ZD greater than arctan(4), (see slRFCO routine)
*  or vector Z less than cosine(arctan(Z)) = 1/sqrt(17)
      DOUBLE PRECISION ZBREAK
      PARAMETER (ZBREAK=0.242535625D0)

      INTEGER I

      DOUBLE PRECISION SPHI,CPHI,ST,V(3),XHD,YHD,ZHD,DIURAB,F,
     :                 XHDT,YHDT,ZHDT,XAET,YAET,ZAET,AZOBS,
     :                 ZDT,REFA,REFB,ZDOBS,DZD,DREF,CE,
     :                 XAEO,YAEO,ZAEO,HMOBS,DCOBS,RAOBS

      DOUBLE PRECISION slDA2P



*  Sin, cos of latitude
      SPHI = AOPRMS(2)
      CPHI = AOPRMS(3)

*  Local apparent sidereal time
      ST = AOPRMS(14)

*  Apparent RA,Dec to Cartesian -HA,Dec
      CALL slDS2C(RAP-ST,DAP,V)
      XHD = V(1)
      YHD = V(2)
      ZHD = V(3)

*  Diurnal aberration
      DIURAB = AOPRMS(4)
      F = (1D0-DIURAB*YHD)
      XHDT = F*XHD
      YHDT = F*(YHD+DIURAB)
      ZHDT = F*ZHD

*  Cartesian -HA,Dec to Cartesian Az,El (S=0,E=90)
      XAET = SPHI*XHDT-CPHI*ZHDT
      YAET = YHDT
      ZAET = CPHI*XHDT+SPHI*ZHDT

*  Azimuth (N=0,E=90)
      IF (XAET.EQ.0D0.AND.YAET.EQ.0D0) THEN
         AZOBS = 0D0
      ELSE
         AZOBS = ATAN2(YAET,-XAET)
      END IF

*  Topocentric zenith distance
      ZDT = ATAN2(SQRT(XAET*XAET+YAET*YAET),ZAET)

*
*  Refraction
*  ----------

*  Fast algorithm using two constant model
      REFA = AOPRMS(11)
      REFB = AOPRMS(12)
      CALL slREFZ(ZDT,REFA,REFB,ZDOBS)

*  Large zenith distance?
      IF (COS(ZDOBS).LT.ZBREAK) THEN

*     Yes: use rigorous algorithm

*     Initialize loop (maximum of 10 iterations)
         I = 1
         DZD = 1D1
         DO WHILE (ABS(DZD).GT.1D-10.AND.I.LE.10)

*        Compute refraction using current estimate of observed ZD
            CALL slRFRO(ZDOBS,AOPRMS(5),AOPRMS(6),AOPRMS(7),
     :                     AOPRMS(8),AOPRMS(9),AOPRMS(1),
     :                     AOPRMS(10),1D-8,DREF)

*        Remaining discrepancy
            DZD = ZDOBS+DREF-ZDT

*        Update the estimate
            ZDOBS = ZDOBS-DZD

*        Increment the iteration counter
            I = I+1
         END DO
      END IF

*  To Cartesian Az/ZD
      CE = SIN(ZDOBS)
      XAEO = -COS(AZOBS)*CE
      YAEO = SIN(AZOBS)*CE
      ZAEO = COS(ZDOBS)

*  Cartesian Az/ZD to Cartesian -HA,Dec
      V(1) = SPHI*XAEO+CPHI*ZAEO
      V(2) = YAEO
      V(3) = -CPHI*XAEO+SPHI*ZAEO

*  To spherical -HA,Dec
      CALL slDC2S(V,HMOBS,DCOBS)

*  Right Ascension
      RAOBS = slDA2P(ST+HMOBS)

*  Return the results
      AOB = AZOBS
      ZOB = ZDOBS
      HOB = -HMOBS
      DOB = DCOBS
      ROB = RAOBS

      END

      SUBROUTINE CONLOC (NDP,XD,YD,NT,IPT,NL,IPL,XII,YII,ITI,IWK,WK)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C THIS SUBROUTINE LOCATES A POINT, I.E., DETERMINES TO WHAT TRI-
C ANGLE A GIVEN POINT (XII,YII) BELONGS.  WHEN THE GIVEN POINT
C DOES NOT LIE INSIDE THE DATA AREA, THIS SUBROUTINE DETERMINES
C THE BORDER LINE SEGMENT WHEN THE POINT LIES IN AN OUTSIDE
C RECTANGULAR AREA, AND TWO BORDER LINE SEGMENTS WHEN THE POINT
C LIES IN AN OUTSIDE TRIANGULAR AREA.
C THE INPUT PARAMETERS ARE
C     NDP = NUMBER OF DATA POINTS,
C     XD,YD = ARRAYS OF DIMENSION NDP CONTAINING THE X AND Y
C           COORDINATES OF THE DATA POINTS,
C     NT  = NUMBER OF TRIANGLES,
C     IPT = INTEGER ARRAY OF DIMENSION 3*NT CONTAINING THE
C           POINT NUMBERS OF THE VERTEXES OF THE TRIANGLES,
C     NL  = NUMBER OF BORDER LINE SEGMENTS,
C     IPL = INTEGER ARRAY OF DIMENSION 3*NL CONTAINING THE
C           POINT NUMBERS OF THE END POINTS OF THE BORDER
C           LINE SEGMENTS AND THEIR RESPECTIVE TRIANGLE
C           NUMBERS,
C     XII,YII = X AND Y COORDINATES OF THE POINT TO BE
C           LOCATED.
C THE OUTPUT PARAMETER IS
C     ITI = TRIANGLE NUMBER, WHEN THE POINT IS INSIDE THE
C           DATA AREA, OR
C           TWO BORDER LINE SEGMENT NUMBERS, IL1 AND IL2,
C           CODED TO IL1*(NT+NL)+IL2, WHEN THE POINT IS
C           OUTSIDE THE DATA AREA.
C THE OTHER PARAMETERS ARE
C     IWK = INTEGER ARRAY OF DIMENSION 18*NDP USED INTER-
C           NALLY AS A WORK AREA,
C     WK  = ARRAY OF DIMENSION 8*NDP USED INTERNALLY AS A
C           WORK AREA.
C DECLARATION STATEMENTS
C
      DIMENSION       XD(1)      ,YD(1)      ,IPT(1)     ,IPL(1)     ,
     1                IWK(1)     ,WK(1)
C
C
C
      DIMENSION       NTSC(9)    ,IDSC(9)
      COMMON /CONRA5/ NIT        ,ITIPV
C
        SAVE
C
C STATEMENT FUNCTIONS
C
      SIDE(U1,V1,U2,V2,U3,V3) = (U1-U3)*(V2-V3)-(V1-V3)*(U2-U3)
      SPDT(U1,V1,U2,V2,U3,V3) = (U1-U2)*(U3-U2)+(V1-V2)*(V3-V2)
C
C PRELIMINARY PROCESSING
C
      NT0 = NT
      NL0 = NL
      NTL = NT0+NL0
      X0 = XII
      Y0 = YII
C
C PROCESSING FOR A NEW SET OF DATA POINTS
C
      IF (NIT .NE. 0) GO TO  170
      NIT = 1
C
C - DIVIDES THE X-Y PLANE INTO NINE RECTANGULAR SECTIONS.
C
      XMN = XD(1)
      XMX = XMN
      YMN = YD(1)
      YMX = YMN
      DO  100 IDP=2,NDP
         XI = XD(IDP)
         YI = YD(IDP)
         XMN = AMIN1(XI,XMN)
         XMX = AMAX1(XI,XMX)
         YMN = AMIN1(YI,YMN)
         YMX = AMAX1(YI,YMX)
  100 CONTINUE
      XS1 = (XMN+XMN+XMX)/3.0
      XS2 = (XMN+XMX+XMX)/3.0
      YS1 = (YMN+YMN+YMX)/3.0
      YS2 = (YMN+YMX+YMX)/3.0
C
C - DETERMINES AND STORES IN THE IWK ARRAY TRIANGLE NUMBERS OF
C - THE TRIANGLES ASSOCIATED WITH EACH OF THE NINE SECTIONS.
C
      DO  110 ISC=1,9
         NTSC(ISC) = 0
         IDSC(ISC) = 0
  110 CONTINUE
      IT0T3 = 0
      JWK = 0
      DO  160 IT0=1,NT0
         IT0T3 = IT0T3+3
         I1 = IPT(IT0T3-2)
         I2 = IPT(IT0T3-1)
         I3 = IPT(IT0T3)
         XMN = AMIN1(XD(I1),XD(I2),XD(I3))
         XMX = AMAX1(XD(I1),XD(I2),XD(I3))
         YMN = AMIN1(YD(I1),YD(I2),YD(I3))
         YMX = AMAX1(YD(I1),YD(I2),YD(I3))
         IF (YMN .GT. YS1) GO TO  120
         IF (XMN .LE. XS1) IDSC(1) = 1
         IF (XMX.GE.XS1 .AND. XMN.LE.XS2) IDSC(2) = 1
         IF (XMX .GE. XS2) IDSC(3) = 1
  120    IF (YMX.LT.YS1 .OR. YMN.GT.YS2) GO TO  130
         IF (XMN .LE. XS1) IDSC(4) = 1
         IF (XMX.GE.XS1 .AND. XMN.LE.XS2) IDSC(5) = 1
         IF (XMX .GE. XS2) IDSC(6) = 1
  130    IF (YMX .LT. YS2) GO TO  140
         IF (XMN .LE. XS1) IDSC(7) = 1
         IF (XMX.GE.XS1 .AND. XMN.LE.XS2) IDSC(8) = 1
         IF (XMX .GE. XS2) IDSC(9) = 1
  140    DO  150 ISC=1,9
            IF (IDSC(ISC) .EQ. 0) GO TO  150
            JIWK = 9*NTSC(ISC)+ISC
            IWK(JIWK) = IT0
            NTSC(ISC) = NTSC(ISC)+1
            IDSC(ISC) = 0
  150    CONTINUE
C
C - STORES IN THE WK ARRAY THE MINIMUM AND MAXIMUM OF THE X AND
C - Y COORDINATE VALUES FOR EACH OF THE TRIANGLE.
C
         JWK = JWK+4
         WK(JWK-3) = XMN
         WK(JWK-2) = XMX
         WK(JWK-1) = YMN
         WK(JWK) = YMX
  160 CONTINUE
      GO TO  200
C
C CHECKS IF IN THE SAME TRIANGLE AS PREVIOUS.
C
  170 IT0 = ITIPV
      IF (IT0 .GT. NT0) GO TO  180
      IT0T3 = IT0*3
      IP1 = IPT(IT0T3-2)
      X1 = XD(IP1)
      Y1 = YD(IP1)
      IP2 = IPT(IT0T3-1)
      X2 = XD(IP2)
      Y2 = YD(IP2)
      IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  200
      IP3 = IPT(IT0T3)
      X3 = XD(IP3)
      Y3 = YD(IP3)
      IF (SIDE(X2,Y2,X3,Y3,X0,Y0) .LT. 0.0) GO TO  200
      IF (SIDE(X3,Y3,X1,Y1,X0,Y0) .LT. 0.0) GO TO  200
      GO TO  260
C
C CHECKS IF ON THE SAME BORDER LINE SEGMENT.
C
  180 IL1 = IT0/NTL
      IL2 = IT0-IL1*NTL
      IL1T3 = IL1*3
      IP1 = IPL(IL1T3-2)
      X1 = XD(IP1)
      Y1 = YD(IP1)
      IP2 = IPL(IL1T3-1)
      X2 = XD(IP2)
      Y2 = YD(IP2)
      IF (IL2 .NE. IL1) GO TO  190
      IF (SPDT(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  200
      IF (SPDT(X2,Y2,X1,Y1,X0,Y0) .LT. 0.0) GO TO  200
      IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .GT. 0.0) GO TO  200
      GO TO  260
C
C CHECKS IF BETWEEN THE SAME TWO BORDER LINE SEGMENTS.
C
  190 IF (SPDT(X1,Y1,X2,Y2,X0,Y0) .GT. 0.0) GO TO  200
      IP3 = IPL(3*IL2-1)
      X3 = XD(IP3)
      Y3 = YD(IP3)
      IF (SPDT(X3,Y3,X2,Y2,X0,Y0) .LE. 0.0) GO TO  260
C
C LOCATES INSIDE THE DATA AREA.
C - DETERMINES THE SECTION IN WHICH THE POINT IN QUESTION LIES.
C
  200 ISC = 1
      IF (X0 .GE. XS1) ISC = ISC+1
      IF (X0 .GE. XS2) ISC = ISC+1
      IF (Y0 .GE. YS1) ISC = ISC+3
      IF (Y0 .GE. YS2) ISC = ISC+3
C
C - SEARCHES THROUGH THE TRIANGLES ASSOCIATED WITH THE SECTION.
C
      NTSCI = NTSC(ISC)
      IF (NTSCI .LE. 0) GO TO  220
      JIWK = -9+ISC
      DO  210 ITSC=1,NTSCI
         JIWK = JIWK+9
         IT0 = IWK(JIWK)
         JWK = IT0*4
         IF (X0 .LT. WK(JWK-3)) GO TO  210
         IF (X0 .GT. WK(JWK-2)) GO TO  210
         IF (Y0 .LT. WK(JWK-1)) GO TO  210
         IF (Y0 .GT. WK(JWK)) GO TO  210
         IT0T3 = IT0*3
         IP1 = IPT(IT0T3-2)
         X1 = XD(IP1)
         Y1 = YD(IP1)
         IP2 = IPT(IT0T3-1)
         X2 = XD(IP2)
         Y2 = YD(IP2)
         IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  210
         IP3 = IPT(IT0T3)
         X3 = XD(IP3)
         Y3 = YD(IP3)
         IF (SIDE(X2,Y2,X3,Y3,X0,Y0) .LT. 0.0) GO TO  210
         IF (SIDE(X3,Y3,X1,Y1,X0,Y0) .LT. 0.0) GO TO  210
         GO TO  260
  210 CONTINUE
C
C LOCATES OUTSIDE THE DATA AREA.
C
  220 DO  240 IL1=1,NL0
         IL1T3 = IL1*3
         IP1 = IPL(IL1T3-2)
         X1 = XD(IP1)
         Y1 = YD(IP1)
         IP2 = IPL(IL1T3-1)
         X2 = XD(IP2)
         Y2 = YD(IP2)
         IF (SPDT(X2,Y2,X1,Y1,X0,Y0) .LT. 0.0) GO TO  240
         IF (SPDT(X1,Y1,X2,Y2,X0,Y0) .LT. 0.0) GO TO  230
         IF (SIDE(X1,Y1,X2,Y2,X0,Y0) .GT. 0.0) GO TO  240
         IL2 = IL1
         GO TO  250
  230    IL2 = MOD(IL1,NL0)+1
         IP3 = IPL(3*IL2-1)
         X3 = XD(IP3)
         Y3 = YD(IP3)
         IF (SPDT(X3,Y3,X2,Y2,X0,Y0) .LE. 0.0) GO TO  250
  240 CONTINUE
      IT0 = 1
      GO TO  260
  250 IT0 = IL1*NTL+IL2
C
C NORMAL EXIT
C
  260 ITI = IT0
      ITIPV = IT0
      RETURN
      END

      integer function sysruk (task, cmd, rukarf, rukint)
      integer rukarf
      integer rukint
      integer*2 task(*)
      integer*2 cmd(*)
      integer i
      integer ntasks
      integer lmarg
      integer rmarg
      integer maxch
      integer ncol
      integer rukean
      integer envgei
      integer envscn
      logical streq
      logical xerpop
      logical xerflg
      common /xercom/ xerflg
      integer iyy
      integer dp(2)
      integer*2 dict(10)
      integer*2 st0001(9)
      integer*2 st0002(6)
      integer*2 st0003(3)
      integer*2 st0004(6)
      integer*2 st0005(6)
      integer*2 st0006(4)
      integer*2 st0007(6)
      integer*2 st0008(2)
      integer*2 st0009(29)
      integer*2 st0010(25)
      save
      data (dict(iyy),iyy= 1, 8) /115,112,101, 99,102,111, 99,117/
      data (dict(iyy),iyy= 9,10) /115, 0/
      data (st0001(iyy),iyy= 1, 8) /116,116,121,110, 99,111,108,115/
      data (st0001(iyy),iyy= 9, 9) / 0/
      data st0002 / 99,104,100,105,114, 0/
      data st0003 / 99,100, 0/
      data st0004 /104,111,109,101, 36, 0/
      data st0005 / 72, 79, 77, 69, 36, 0/
      data st0006 /115,101,116, 0/
      data st0007 /114,101,115,101,116, 0/
      data st0008 / 9, 0/
      data (st0009(iyy),iyy= 1, 8) /105,110,118, 97,108,105,100, 32/
      data (st0009(iyy),iyy= 9,16) /115,101,116, 32,115,116, 97,116/
      data (st0009(iyy),iyy=17,24) /101,109,101,110,116, 58, 32, 39/
      data (st0009(iyy),iyy=25,29) / 37,115, 39, 10, 0/
      data (st0010(iyy),iyy= 1, 8) /105,110,118, 97,108,105,100, 32/
      data (st0010(iyy),iyy= 9,16) / 83, 69, 84, 32,105,110, 32, 73/
      data (st0010(iyy),iyy=17,24) / 82, 65, 70, 32, 77, 97,105,110/
      data (st0010(iyy),iyy=25,25) / 0/
      data (dp(iyy),iyy= 1, 2) / 1, 0/
      data lmarg /5/, maxch /0/, ncol /0/, rukean /3/
      data ntasks /0/
         if (.not.(ntasks .eq. 0)) goto 110
            i=1
120         if (.not.(dp(i) .ne. 0)) goto 122
121            i=i+1
               goto 120
122         continue
            ntasks = i - 1
110      continue
         if (.not.(task(1) .eq. 63)) goto 130
            call xerpsh
            rmarg = envgei (st0001)
            if (.not.xerpop()) goto 140
               rmarg = 80
140         continue
            call strtbl (4, dict, dp, ntasks, lmarg, rmarg, maxch, ncol)
            sysruk = (0)
            goto 100
130      continue
         if (.not.(streq(task,st0002) .or. streq(task,st0003))) goto 150
            call xerpsh
            if (.not.(cmd(rukarf) .eq. 0)) goto 170
               call xerpsh
               call xfchdr(st0004)
               if (.not.xerpop()) goto 180
                  call xfchdr(st0005)
180            continue
               goto 171
170         continue
               call xfchdr(cmd(rukarf))
171         continue
162         if (.not.xerpop()) goto 160
               if (.not.(rukint .eq. 1)) goto 190
                  call erract (rukean)
                  if (xerflg) goto 100
                  goto 191
190            continue
191            continue
160         continue
            sysruk = (0)
            goto 100
150      continue
         if (.not.(streq(task,st0006) .or. streq(task,st0007))) goto 200
            call xerpsh
            if (.not.(cmd(rukarf) .eq. 0)) goto 220
               call envlit (4, st0008, 1)
               call xffluh(4)
               goto 221
220         continue
            if (.not.(envscn (cmd) .le. 0)) goto 230
               if (.not.(rukint .eq. 1)) goto 240
                  call eprinf (st0009)
                  call pargsr (cmd)
                  goto 241
240            continue
                  goto 91
241            continue
230         continue
221         continue
212         if (.not.xerpop()) goto 210
               if (.not.(rukint .eq. 1)) goto 250
                  call erract (rukean)
                  if (xerflg) goto 100
                  goto 251
250            continue
91                call syspac (0, st0010)
251            continue
210         continue
            sysruk = (0)
            goto 100
200      continue
151      continue
131      continue
         if (.not.(streq (task, dict(dp(1))))) goto 260
            call tspecs
            sysruk = (0)
            goto 100
260      continue
         sysruk = (-1)
         goto 100
100      return
      end
c     rukint  ruk_interact
c     sysruk  sys_runtask
c     envscn  envscan
c     tspecs  t_specfocus
c     envgei  envgeti
c     syspac  sys_panic
c     eprinf  eprintf
c     rukarf  ruk_argoff
c     rukean  ruk_eawarn
c     pargsr  pargstr
c     envlit  envlist

C----------------------------------------------------------------------
        subroutine ftgpve(iunit,group,felem,nelem,nulval,
     &                    array,anynul,status)

C       Read an array of r*4 values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).
C       Undefined elements will be set equal to NULVAL, unless NULVAL=0
C       in which case no checking for undefined values will be performed.
C       ANYNUL is return with a value of .true. if any pixels were undefined.

C       iunit   i  Fortran unit number
C       group   i  number of the data group, if any
C       felem   i  the first pixel to be read (this routine treats
C                  the primary array a large one dimensional array of
C                  values, regardless of the actual dimensionality).
C       nelem   i  number of data elements to be read
C       nulval  r  the value to be assigned to undefined pixels
C       array   r  returned array of values that were read
C       anynul  l  set to .true. if any returned elements were undefined
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,group,felem,nelem,status,row 
        real nulval,array(*)
        logical anynul,flgval

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
        row=max(1,group)
        call ftgcle(iunit,2,row,felem,nelem,1,1,nulval,
     &      array,flgval,anynul,status)
        end

include	defs

# skipbl - skip blanks and tabs at lin(i)

   subroutine skipbl(lin, i)
   character lin(ARB)
   integer i

   while (lin (i) == BLANK | lin (i) == TAB)
      i = i + 1

   return
   end

      SUBROUTINE slPXY (NP,XYE,XYM,COEFFS,XYP,XRMS,YRMS,RRMS)
*+
*     - - - -
*      P X Y
*     - - - -
*
*  Given arrays of "expected" and "measured" [X,Y] coordinates, and a
*  linear model relating them (as produced by slFTXY), compute
*  the array of "predicted" coordinates and the RMS residuals.
*
*  Given:
*     NP       i        number of samples
*     XYE     d(2,np)   expected [X,Y] for each sample
*     XYM     d(2,np)   measured [X,Y] for each sample
*     COEFFS  d(6)      coefficients of model (see below)
*
*  Returned:
*     XYP     d(2,np)   predicted [X,Y] for each sample
*     XRMS     d        RMS in X
*     YRMS     d        RMS in Y
*     RRMS     d        total RMS (vector sum of XRMS and YRMS)
*
*  The model is supplied in the array COEFFS.  Naming the
*  elements of COEFF as follows:
*
*     COEFFS(1) = A
*     COEFFS(2) = B
*     COEFFS(3) = C
*     COEFFS(4) = D
*     COEFFS(5) = E
*     COEFFS(6) = F
*
*  the model is applied thus:
*
*     XP = A + B*XM + C*YM
*     YP = D + E*XM + F*YM
*
*  The residuals are (XP-XE) and (YP-YE).
*
*  If NP is less than or equal to zero, no coordinates are
*  transformed, and the RMS residuals are all zero.
*
*  See also slFTXY, slINVF, slXYXY, slDCMF
*
*  Called:  slXYXY
*
*  P.T.Wallace   Starlink   22 May 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER NP
      DOUBLE PRECISION XYE(2,NP),XYM(2,NP),COEFFS(6),
     :                 XYP(2,NP),XRMS,YRMS,RRMS

      INTEGER I
      DOUBLE PRECISION SDX2,SDY2,XP,YP,DX,DY,DX2,DY2,P



*  Initialize summations
      SDX2=0D0
      SDY2=0D0

*  Loop by sample
      DO I=1,NP

*     Transform "measured" [X,Y] to "predicted" [X,Y]
         CALL slXYXY(XYM(1,I),XYM(2,I),COEFFS,XP,YP)
         XYP(1,I)=XP
         XYP(2,I)=YP

*     Compute residuals in X and Y, and update summations
         DX=XYE(1,I)-XP
         DY=XYE(2,I)-YP
         DX2=DX*DX
         DY2=DY*DY
         SDX2=SDX2+DX2
         SDY2=SDY2+DY2

*     Next sample
      END DO

*  Compute RMS values
      P=MAX(1D0,DBLE(NP))
      XRMS=SQRT(SDX2/P)
      YRMS=SQRT(SDY2/P)
      RRMS=SQRT(XRMS*XRMS+YRMS*YRMS)

      END

      SUBROUTINE SINT (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
      NP1 = N+1
      IW1 = N/2+1
      IW2 = IW1+NP1
      IW3 = IW2+NP1
      CALL SINT1(N,X,WSAVE,WSAVE(IW1),WSAVE(IW2),WSAVE(IW3))
      RETURN
      END

C--------------------------------------------------------------------------
        subroutine ftpkys(ounit,keywrd,strval,comm,status)

C       write a character string value to a header record 
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       strval  c  keyword value 
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991
C       modified 6/93 to handle long string values by continuing the
C       string onto subsequent comment keywords (with a blank keyword name)

C       Modified again in 9/94 to remove support for long string values;
C       Now, one must call ftpkls to write a long string values.

        character*(*) keywrd,comm,strval
        integer ounit,status,lenval,ncomm,nvalue
        character strtmp*68,value*70,keynam*8,cmnt*48
        
        if (status .gt. 0)return

        strtmp=strval
        keynam=keywrd
        cmnt=comm

C       convert string to quoted character string (max length = 70 characters)
        call fts2c(strtmp,value,lenval,status)

        if (lenval .gt. 70)then
C           truncate the string to 70 characters (if the input string contained
C           apostrophies, then it could get expanded to more than 70 characters)
            value(70:70)=''''
            lenval=70
C           N.B. there could be a problem here if character 69 is also a '.
C           Then the closing quote would be considered a literal appostrophy.
        end if

C       find amount of space left for comment string
C       (assume 10 char. for 'keyword = ', and 3 between value and comment)
C       which leaves 67 spaces for the value string + comment string
        nvalue=max(20,lenval)
        ncomm=67-nvalue

C       write the keyword record
        if (ncomm .gt. 0)then
C         there is space for a comment
          call ftprec(ounit,
     &    keynam//'= '//value(1:nvalue)//' / '//cmnt(1:ncomm),status)
        else
C         no room for a comment
          call ftprec(ounit,
     &    keynam//'= '//value(1:nvalue)//'   ',status)
        end if  
        end

      SUBROUTINE slFK54 (R2000,D2000,DR2000,DD2000,P2000,V2000,
     :                      R1950,D1950,DR1950,DD1950,P1950,V1950)
*+
*     - - - - - -
*      F K 5 4
*     - - - - - -
*
*  Convert J2000.0 FK5 star data to B1950.0 FK4 (double precision)
*
*  This routine converts stars from the new, IAU 1976, FK5, Fricke
*  system, to the old, Bessel-Newcomb, FK4 system.  The precepts
*  of Smith et al (Ref 1) are followed, using the implementation
*  by Yallop et al (Ref 2) of a matrix method due to Standish.
*  Kinoshita's development of Andoyer's post-Newcomb precession is
*  used.  The numerical constants from Seidelmann et al (Ref 3) are
*  used canonically.
*
*  Given:  (all J2000.0,FK5)
*     R2000,D2000     dp    J2000.0 RA,Dec (rad)
*     DR2000,DD2000   dp    J2000.0 proper motions (rad/Jul.yr)
*     P2000           dp    parallax (arcsec)
*     V2000           dp    radial velocity (km/s, +ve = moving away)
*
*  Returned:  (all B1950.0,FK4)
*     R1950,D1950     dp    B1950.0 RA,Dec (rad)
*     DR1950,DD1950   dp    B1950.0 proper motions (rad/trop.yr)
*     P1950           dp    parallax (arcsec)
*     V1950           dp    radial velocity (km/s, +ve = moving away)
*
*  Notes:
*
*  1)  The proper motions in RA are dRA/dt rather than
*      cos(Dec)*dRA/dt, and are per year rather than per century.
*
*  2)  Note that conversion from Julian epoch 2000.0 to Besselian
*      epoch 1950.0 only is provided for.  Conversions involving
*      other epochs will require use of the appropriate precession,
*      proper motion, and E-terms routines before and/or after
*      FK524 is called.
*
*  3)  In the FK4 catalogue the proper motions of stars within
*      10 degrees of the poles do not embody the differential
*      E-term effect and should, strictly speaking, be handled
*      in a different manner from stars outside these regions.
*      However, given the general lack of homogeneity of the star
*      data available for routine astrometry, the difficulties of
*      handling positions that may have been determined from
*      astrometric fields spanning the polar and non-polar regions,
*      the likelihood that the differential E-terms effect was not
*      taken into account when allowing for proper motion in past
*      astrometry, and the undesirability of a discontinuity in
*      the algorithm, the decision has been made in this routine to
*      include the effect of differential E-terms on the proper
*      motions for all stars, whether polar or not.  At epoch 2000,
*      and measuring on the sky rather than in terms of dRA, the
*      errors resulting from this simplification are less than
*      1 milliarcsecond in position and 1 milliarcsecond per
*      century in proper motion.
*
*  References:
*
*     1  Smith, C.A. et al, 1989.  "The transformation of astrometric
*        catalog systems to the equinox J2000.0".  Astron.J. 97, 265.
*
*     2  Yallop, B.D. et al, 1989.  "Transformation of mean star places
*        from FK4 B1950.0 to FK5 J2000.0 using matrices in 6-space".
*        Astron.J. 97, 274.
*
*     3  Seidelmann, P.K. (ed), 1992.  "Explanatory Supplement to
*        the Astronomical Almanac", ISBN 0-935702-68-7.
*
*  P.T.Wallace   Starlink   19 December 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R2000,D2000,DR2000,DD2000,P2000,V2000,
     :                 R1950,D1950,DR1950,DD1950,P1950,V1950


*  Miscellaneous
      DOUBLE PRECISION R,D,UR,UD,PX,RV
      DOUBLE PRECISION SR,CR,SD,CD,X,Y,Z,W
      DOUBLE PRECISION V1(6),V2(6)
      DOUBLE PRECISION XD,YD,ZD
      DOUBLE PRECISION RXYZ,WD,RXYSQ,RXY
      INTEGER I,J

*  2Pi
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)

*  Radians per year to arcsec per century
      DOUBLE PRECISION PMF
      PARAMETER (PMF=100D0*60D0*60D0*360D0/D2PI)

*  Small number to avoid arithmetic problems
      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-30)

*
*  CANONICAL CONSTANTS  (see references)
*

*  Km per sec to AU per tropical century
*  = 86400 * 36524.2198782 / 149597870
      DOUBLE PRECISION VF
      PARAMETER (VF=21.095D0)

*  Constant vector and matrix (by columns)
      DOUBLE PRECISION A(6),EMI(6,6)
      DATA A/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     :        +1.245D-3,    -1.580D-3,   -0.659D-3/

      DATA (EMI(I,1),I=1,6) / +0.9999256795D0,
     :                        -0.0111814828D0,
     :                        -0.0048590040D0,
     :                        -0.000551D0,
     :                        -0.238560D0,
     :                        +0.435730D0 /

      DATA (EMI(I,2),I=1,6) / +0.0111814828D0,
     :                        +0.9999374849D0,
     :                        -0.0000271557D0,
     :                        +0.238509D0,
     :                        -0.002667D0,
     :                        -0.008541D0 /

      DATA (EMI(I,3),I=1,6) / +0.0048590039D0,
     :                        -0.0000271771D0,
     :                        +0.9999881946D0,
     :                        -0.435614D0,
     :                        +0.012254D0,
     :                        +0.002117D0 /

      DATA (EMI(I,4),I=1,6) / -0.00000242389840D0,
     :                        +0.00000002710544D0,
     :                        +0.00000001177742D0,
     :                        +0.99990432D0,
     :                        -0.01118145D0,
     :                        -0.00485852D0 /

      DATA (EMI(I,5),I=1,6) / -0.00000002710544D0,
     :                        -0.00000242392702D0,
     :                        +0.00000000006585D0,
     :                        +0.01118145D0,
     :                        +0.99991613D0,
     :                        -0.00002716D0 /

      DATA (EMI(I,6),I=1,6) / -0.00000001177742D0,
     :                        +0.00000000006585D0,
     :                        -0.00000242404995D0,
     :                        +0.00485852D0,
     :                        -0.00002717D0,
     :                        +0.99996684D0 /



*  Pick up J2000 data (units radians and arcsec/JC)
      R=R2000
      D=D2000
      UR=DR2000*PMF
      UD=DD2000*PMF
      PX=P2000
      RV=V2000

*  Spherical to Cartesian
      SR=SIN(R)
      CR=COS(R)
      SD=SIN(D)
      CD=COS(D)

      X=CR*CD
      Y=SR*CD
      Z=   SD

      W=VF*RV*PX

      V1(1)=X
      V1(2)=Y
      V1(3)=Z

      V1(4)=-UR*Y-CR*SD*UD+W*X
      V1(5)= UR*X-SR*SD*UD+W*Y
      V1(6)=         CD*UD+W*Z

*  Convert position+velocity vector to BN system
      DO I=1,6
         W=0D0
         DO J=1,6
            W=W+EMI(I,J)*V1(J)
         END DO
         V2(I)=W
      END DO

*  Position vector components and magnitude
      X=V2(1)
      Y=V2(2)
      Z=V2(3)
      RXYZ=SQRT(X*X+Y*Y+Z*Z)

*  Apply E-terms to position
      W=X*A(1)+Y*A(2)+Z*A(3)
      X=X+A(1)*RXYZ-W*X
      Y=Y+A(2)*RXYZ-W*Y
      Z=Z+A(3)*RXYZ-W*Z

*  Recompute magnitude
      RXYZ=SQRT(X*X+Y*Y+Z*Z)

*  Apply E-terms to both position and velocity
      X=V2(1)
      Y=V2(2)
      Z=V2(3)
      W=X*A(1)+Y*A(2)+Z*A(3)
      WD=X*A(4)+Y*A(5)+Z*A(6)
      X=X+A(1)*RXYZ-W*X
      Y=Y+A(2)*RXYZ-W*Y
      Z=Z+A(3)*RXYZ-W*Z
      XD=V2(4)+A(4)*RXYZ-WD*X
      YD=V2(5)+A(5)*RXYZ-WD*Y
      ZD=V2(6)+A(6)*RXYZ-WD*Z

*  Convert to spherical
      RXYSQ=X*X+Y*Y
      RXY=SQRT(RXYSQ)

      IF (X.EQ.0D0.AND.Y.EQ.0D0) THEN
         R=0D0
      ELSE
         R=ATAN2(Y,X)
         IF (R.LT.0.0D0) R=R+D2PI
      END IF
      D=ATAN2(Z,RXY)

      IF (RXY.GT.TINY) THEN
         UR=(X*YD-Y*XD)/RXYSQ
         UD=(ZD*RXYSQ-Z*(X*XD+Y*YD))/((RXYSQ+Z*Z)*RXY)
      END IF

*  Radial velocity and parallax
      IF (PX.GT.TINY) THEN
         RV=(X*XD+Y*YD+Z*ZD)/(PX*VF*RXYZ)
         PX=PX/RXYZ
      END IF

*  Return results
      R1950=R
      D1950=D
      DR1950=UR/PMF
      DD1950=UD/PMF
      P1950=PX
      V1950=RV

      END

      SUBROUTINE CONCAL (XD,YD,ZD,NT,IPT,NL,IPL,PDD,ITI,XII,YII,ZII,
     1                   ITPV)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C THIS SUBROUTINE PERFORMS PUNCTUAL INTERPOLATION OR EXTRAPO-
C LATION, I.E., DETERMINES THE Z VALUE AT A POINT.
C THE INPUT PARAMETERS ARE
C
C     XD,YD,ZD = ARRAYS CONTAINING THE X, Y, AND Z
C                COORDINATES OF DATA POINTS,
C     NT  = NUMBER OF TRIANGLES,
C     IPT = INTEGER ARRAY CONTAINING THE POINT NUMBERS OF
C           THE VERTEXES OF THE TRIANGLES,
C     NL  = NUMBER OF BORDER LINE SEGMENTS,
C     IPL = INTEGER ARRAY CONTAINING THE POINT NUMBERS OF
C           THE END POINTS OF THE BORDER LINE SEGMENTS AND
C           THEIR RESPECTIVE TRIANGLE NUMBERS,
C     PDD = ARRAY CONTAINING THE PARTIAL DERIVATIVES AT
C           THE DATA POINTS,
C     ITI = TRIANGLE NUMBER OF THE TRIANGLE IN WHICH LIES
C           THE POINT FOR WHICH INTERPOLATION IS TO BE
C           PERFORMED,
C     XII,YII = X AND Y COORDINATES OF THE POINT FOR WHICH
C               INTERPOLATION IS TO BE PERFORMED.
C THE OUTPUT PARAMETER IS
C
C     ZII = INTERPOLATED Z VALUE.
C
C DECLARATION STATEMENTS
C
C
      DIMENSION       XD(1)      ,YD(1)      ,ZD(1)      ,IPT(1)     ,
     1                IPL(1)     ,PDD(1)
      DIMENSION       X(3)       ,Y(3)       ,Z(3)       ,PD(15)     ,
     1                ZU(3)      ,ZV(3)      ,ZUU(3)     ,ZUV(3)     ,
     2                ZVV(3)
      REAL            LU         ,LV
      EQUIVALENCE     (P5,P50)
C
        SAVE
C
C PRELIMINARY PROCESSING
C
      IT0 = ITI
      NTL = NT+NL
      IF (IT0 .LE. NTL) GO TO  100
      IL1 = IT0/NTL
      IL2 = IT0-IL1*NTL
      IF (IL1 .EQ. IL2) GO TO  150
      GO TO  200
C
C CALCULATION OF ZII BY INTERPOLATION.
C CHECKS IF THE NECESSARY COEFFICIENTS HAVE BEEN CALCULATED.
C
  100 IF (IT0 .EQ. ITPV) GO TO  140
C
C LOADS COORDINATE AND PARTIAL DERIVATIVE VALUES AT THE
C IPI 102 VERTEXES.
C IPI 103
C
      JIPT = 3*(IT0-1)
      JPD = 0
      DO  120 I=1,3
         JIPT = JIPT+1
         IDP = IPT(JIPT)
         X(I) = XD(IDP)
         Y(I) = YD(IDP)
         Z(I) = ZD(IDP)
         JPDD = 5*(IDP-1)
         DO  110 KPD=1,5
            JPD = JPD+1
            JPDD = JPDD+1
            PD(JPD) = PDD(JPDD)
  110    CONTINUE
  120 CONTINUE
C
C DETERMINES THE COEFFICIENTS FOR THE COORDINATE SYSTEM
C TRANSFORMATION FROM THE X-Y SYSTEM TO THE U-V SYSTEM
C AND VICE VERSA.
C
      X0 = X(1)
      Y0 = Y(1)
      A = X(2)-X0
      B = X(3)-X0
      C = Y(2)-Y0
      D = Y(3)-Y0
      AD = A*D
      BC = B*C
      DLT = AD-BC
      AP = D/DLT
      BP = -B/DLT
      CP = -C/DLT
      DP = A/DLT
C
C CONVERTS THE PARTIAL DERIVATIVES AT THE VERTEXES OF THE
C TRIANGLE FOR THE U-V COORDINATE SYSTEM.
C
      AA = A*A
      ACT2 = 2.0*A*C
      CC = C*C
      AB = A*B
      ADBC = AD+BC
      CD = C*D
      BB = B*B
      BDT2 = 2.0*B*D
      DD = D*D
      DO  130 I=1,3
         JPD = 5*I
         ZU(I) = A*PD(JPD-4)+C*PD(JPD-3)
         ZV(I) = B*PD(JPD-4)+D*PD(JPD-3)
         ZUU(I) = AA*PD(JPD-2)+ACT2*PD(JPD-1)+CC*PD(JPD)
         ZUV(I) = AB*PD(JPD-2)+ADBC*PD(JPD-1)+CD*PD(JPD)
         ZVV(I) = BB*PD(JPD-2)+BDT2*PD(JPD-1)+DD*PD(JPD)
  130 CONTINUE
C
C CALCULATES THE COEFFICIENTS OF THE POLYNOMIAL.
C
      P00 = Z(1)
      P10 = ZU(1)
      P01 = ZV(1)
      P20 = 0.5*ZUU(1)
      P11 = ZUV(1)
      P02 = 0.5*ZVV(1)
      H1 = Z(2)-P00-P10-P20
      H2 = ZU(2)-P10-ZUU(1)
      H3 = ZUU(2)-ZUU(1)
      P30 = 10.0*H1-4.0*H2+0.5*H3
      P40 = -15.0*H1+7.0*H2-H3
      P50 = 6.0*H1-3.0*H2+0.5*H3
      H1 = Z(3)-P00-P01-P02
      H2 = ZV(3)-P01-ZVV(1)
      H3 = ZVV(3)-ZVV(1)
      P03 = 10.0*H1-4.0*H2+0.5*H3
      P04 = -15.0*H1+7.0*H2-H3
      P05 = 6.0*H1-3.0*H2+0.5*H3
      LU = SQRT(AA+CC)
      LV = SQRT(BB+DD)
      THXU = ATAN2(C,A)
      THUV = ATAN2(D,B)-THXU
      CSUV = COS(THUV)
      P41 = 5.0*LV*CSUV/LU*P50
      P14 = 5.0*LU*CSUV/LV*P05
      H1 = ZV(2)-P01-P11-P41
      H2 = ZUV(2)-P11-4.0*P41
      P21 = 3.0*H1-H2
      P31 = -2.0*H1+H2
      H1 = ZU(3)-P10-P11-P14
      H2 = ZUV(3)-P11-4.0*P14
      P12 = 3.0*H1-H2
      P13 = -2.0*H1+H2
      THUS = ATAN2(D-C,B-A)-THXU
      THSV = THUV-THUS
      AA = SIN(THSV)/LU
      BB = -COS(THSV)/LU
      CC = SIN(THUS)/LV
      DD = COS(THUS)/LV
      AC = AA*CC
      AD = AA*DD
      BC = BB*CC
      G1 = AA*AC*(3.0*BC+2.0*AD)
      G2 = CC*AC*(3.0*AD+2.0*BC)
      H1 = -AA*AA*AA*(5.0*AA*BB*P50+(4.0*BC+AD)*P41)-
     1     CC*CC*CC*(5.0*CC*DD*P05+(4.0*AD+BC)*P14)
      H2 = 0.5*ZVV(2)-P02-P12
      H3 = 0.5*ZUU(3)-P20-P21
      P22 = (G1*H2+G2*H3-H1)/(G1+G2)
      P32 = H2-P22
      P23 = H3-P22
      ITPV = IT0
C
C CONVERTS XII AND YII TO U-V SYSTEM.
C
  140 DX = XII-X0
      DY = YII-Y0
      U = AP*DX+BP*DY
      V = CP*DX+DP*DY
C
C EVALUATES THE POLYNOMIAL.
C
      P0 = P00+V*(P01+V*(P02+V*(P03+V*(P04+V*P05))))
      P1 = P10+V*(P11+V*(P12+V*(P13+V*P14)))
      P2 = P20+V*(P21+V*(P22+V*P23))
      P3 = P30+V*(P31+V*P32)
      P4 = P40+V*P41
      ZII = P0+U*(P1+U*(P2+U*(P3+U*(P4+U*P5))))
      RETURN
C
C CALCULATION OF ZII BY EXTRATERPOLATION IN THE RECTANGLE.
C CHECKS IF THE NECESSARY COEFFICIENTS HAVE BEEN CALCULATED.
C
  150 IF (IT0 .EQ. ITPV) GO TO  190
C
C LOADS COORDINATE AND PARTIAL DERIVATIVE VALUES AT THE END
C POINTS OF THE BORDER LINE SEGMENT.
C
      JIPL = 3*(IL1-1)
      JPD = 0
      DO  170 I=1,2
         JIPL = JIPL+1
         IDP = IPL(JIPL)
         X(I) = XD(IDP)
         Y(I) = YD(IDP)
         Z(I) = ZD(IDP)
         JPDD = 5*(IDP-1)
         DO  160 KPD=1,5
            JPD = JPD+1
            JPDD = JPDD+1
            PD(JPD) = PDD(JPDD)
  160    CONTINUE
  170 CONTINUE
C
C DETERMINES THE COEFFICIENTS FOR THE COORDINATE SYSTEM
C TRANSFORMATION FROM THE X-Y SYSTEM TO THE U-V SYSTEM
C AND VICE VERSA.
C
      X0 = X(1)
      Y0 = Y(1)
      A = Y(2)-Y(1)
      B = X(2)-X(1)
      C = -B
      D = A
      AD = A*D
      BC = B*C
      DLT = AD-BC
      AP = D/DLT
      BP = -B/DLT
      CP = -BP
      DP = AP
C
C CONVERTS THE PARTIAL DERIVATIVES AT THE END POINTS OF THE
C BORDER LINE SEGMENT FOR THE U-V COORDINATE SYSTEM.
C
      AA = A*A
      ACT2 = 2.0*A*C
      CC = C*C
      AB = A*B
      ADBC = AD+BC
      CD = C*D
      BB = B*B
      BDT2 = 2.0*B*D
      DD = D*D
      DO  180 I=1,2
         JPD = 5*I
         ZU(I) = A*PD(JPD-4)+C*PD(JPD-3)
         ZV(I) = B*PD(JPD-4)+D*PD(JPD-3)
         ZUU(I) = AA*PD(JPD-2)+ACT2*PD(JPD-1)+CC*PD(JPD)
         ZUV(I) = AB*PD(JPD-2)+ADBC*PD(JPD-1)+CD*PD(JPD)
         ZVV(I) = BB*PD(JPD-2)+BDT2*PD(JPD-1)+DD*PD(JPD)
  180 CONTINUE
C
C CALCULATES THE COEFFICIENTS OF THE POLYNOMIAL.
C
      P00 = Z(1)
      P10 = ZU(1)
      P01 = ZV(1)
      P20 = 0.5*ZUU(1)
      P11 = ZUV(1)
      P02 = 0.5*ZVV(1)
      H1 = Z(2)-P00-P01-P02
      H2 = ZV(2)-P01-ZVV(1)
      H3 = ZVV(2)-ZVV(1)
      P03 = 10.0*H1-4.0*H2+0.5*H3
      P04 = -15.0*H1+7.0*H2-H3
      P05 = 6.0*H1-3.0*H2+0.5*H3
      H1 = ZU(2)-P10-P11
      H2 = ZUV(2)-P11
      P12 = 3.0*H1-H2
      P13 = -2.0*H1+H2
      P21 = 0.0
      P23 = -ZUU(2)+ZUU(1)
      P22 = -1.5*P23
      ITPV = IT0
C
C CONVERTS XII AND YII TO U-V SYSTEM.
C
  190 DX = XII-X0
      DY = YII-Y0
      U = AP*DX+BP*DY
      V = CP*DX+DP*DY
C
C EVALUATES THE POLYNOMIAL.
C
      P0 = P00+V*(P01+V*(P02+V*(P03+V*(P04+V*P05))))
      P1 = P10+V*(P11+V*(P12+V*P13))
      P2 = P20+V*(P21+V*(P22+V*P23))
      ZII = P0+U*(P1+U*P2)
      RETURN
C
C CALCULATION OF ZII BY EXTRATERPOLATION IN THE TRIANGLE.
C CHECKS IF THE NECESSARY COEFFICIENTS HAVE BEEN CALCULATED.
C
  200 IF (IT0 .EQ. ITPV) GO TO  220
C
C LOADS COORDINATE AND PARTIAL DERIVATIVE VALUES AT THE VERTEX
C OF THE TRIANGLE.
C
      JIPL = 3*IL2-2
      IDP = IPL(JIPL)
      X(1) = XD(IDP)
      Y(1) = YD(IDP)
      Z(1) = ZD(IDP)
      JPDD = 5*(IDP-1)
      DO  210 KPD=1,5
         JPDD = JPDD+1
         PD(KPD) = PDD(JPDD)
  210 CONTINUE
C
C CALCULATES THE COEFFICIENTS OF THE POLYNOMIAL.
C
      P00 = Z(1)
      P10 = PD(1)
      P01 = PD(2)
      P20 = 0.5*PD(3)
      P11 = PD(4)
      P02 = 0.5*PD(5)
      ITPV = IT0
C
C CONVERTS XII AND YII TO U-V SYSTEM.
C
  220 U = XII-X(1)
      V = YII-Y(1)
C
C EVALUATES THE POLYNOMIAL.
C
      P0 = P00+V*(P01+V*P02)
      P1 = P10+V*P11
      ZII = P0+U*(P1+U*P20)
      RETURN
      END

#-h-  alldig			  306  local   12/01/80  15:53:45
# alldig - return YES if str is all digits
   include  defs

   integer function alldig (str)
   character str (ARB)
   integer i

   alldig = NO
   if (str (1) == EOS)
      return
   for (i = 1; str (i) != EOS; i = i + 1)
      if (!(DIG0 <= str (i) & str (i) <= DIG9))
	 return
   alldig = YES
   return
   end

      SUBROUTINE CONSTP (XD,YD,NDP)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  COMPUTE STEP SIZE IN X AND Y DIRECTION
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       XD(1)      ,YD(1)
C
        SAVE
C
C  FIND SMALLEST AND LARGST X AND Y
C
      XST = XD(1)
      XED = XD(1)
      YST = YD(1)
      YED = YD(1)
      DO  130 I=2,NDP
         IF (XST .LE. XD(I)) GO TO  100
         XST = XD(I)
         GO TO  110
  100    IF (XED .GE. XD(I)) GO TO  110
         XED = XD(I)
  110    IF (YST .LE. YD(I)) GO TO  120
         YST = YD(I)
         GO TO  130
  120    IF (YED .GE. YD(I)) GO TO  130
         YED = YD(I)
  130 CONTINUE
C
C  COMPUTE STEP SIZE
C
      XRG = (ABS(XED-XST))
      YRG = (ABS(YED-YST))
      SQRG = XRG
      IF (SQRG .LT. YRG) SQRG = YRG
      STPSZ = SQRG/FLOAT(IGRAD-1)
C
C  COMPUTE PARAMETERS FOR SET CALL
C
      DIFX = XRG/SQRG
      DIFY = YRG/SQRG
      PXST = .5-(BORD*DIFX)/2.
      PXED = .5+(BORD*DIFX)/2.
      PYST = .5-(BORD*DIFY)/2.
      PYED = .5+(BORD*DIFY)/2.
      XRG = XRG/FLOAT(ITICK)
      YRG = YRG/FLOAT(ITICK)
C
C  TEST IF THE ASPECT RATIO FOR THE COORDINATES IS REASONABLE.
C     REASONABLE IS CURRENTLY DEFINED AS 5 TO 1.
C     IF IT IS NOT REASONABLE THEN A POOR PLOT MAY BE GENERATED
C     SO IT IS NICE THE WARN THE USER WHEN THIS HAPPENS.
C
      TEST = XRG/YRG
      IF (TEST.LE.5. .AND. TEST.GE.0.2) RETURN
C
C  WARN THE USER ON THE STANDARD OUTPUT UNIT THAT THE PLOT MAY
C  NOT BE TOO GOOD.
C
C  SET RECOVERY MODE
C
      CALL ENTSR(IROLD,IREC)
C
C  FLAG THE ERROR
C
      CALL SETER(' ASPECT RATIO OF X AND Y GREATER THAN 5 TO 1',
     1           1,1)
C
      CALL EPRIN
C
C  CLEAR THE ERROR
C
      CALL ERROF
C
C  RESET USER ERROR MODE
C
      CALL ENTSR(IDUM,IROLD)
C
      RETURN
      END

      SUBROUTINE slPRNU (EPOCH, DATE, RMATPN)
*+
*     - - - - - - -
*      P R N U
*     - - - - - - -
*
*  Form the matrix of precession and nutation (SF2001)
*  (double precision)
*
*  Given:
*     EPOCH   dp         Julian Epoch for mean coordinates
*     DATE    dp         Modified Julian Date (JD-2400000.5)
*                        for true coordinates
*
*  Returned:
*     RMATPN  dp(3,3)    combined precession/nutation matrix
*
*  Called:  slPREC, slEPJ, slNUT, slDMXM
*
*  Notes:
*
*  1)  The epoch and date are TDB (loosely ET).  TT will do, or even
*      UTC.
*
*  2)  The matrix is in the sense   V(true) = RMATPN * V(mean)
*
*  Last revision:   3 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION EPOCH,DATE,RMATPN(3,3)

      DOUBLE PRECISION RMATP(3,3),RMATN(3,3),slEPJ



*  Precession
      CALL slPREC(EPOCH,slEPJ(DATE),RMATP)

*  Nutation
      CALL slNUT(DATE,RMATN)

*  Combine the matrices:  PN = N x P
      CALL slDMXM(RMATN,RMATP,RMATPN)

      END

#-h-  lex			  543  local   12/01/80  15:54:12
# lex - return lexical type of token
   include  defs

   integer function lex (lexstr)
   character lexstr (MAXTOK)

   include COMMON_BLOCKS

   character gnbtok, t, c

   integer lookup, n
   string sdefault "default"

   for (lex = gnbtok (lexstr, MAXTOK);  lex == NEWLINE;
        lex = gnbtok (lexstr, MAXTOK))
      ;

   if (lex == EOF | lex == SEMICOL | lex == LBRACE | lex == RBRACE)
      return
   if (lex == DIGIT)
      lex = LEXDIGITS
   else if (lex == TOGGLE)
      lex = LEXLITERAL
   else if (lex == XPP_DIRECTIVE)
      lex = LEXDECL
   else if (lookup (lexstr, lex, rkwtbl) == YES) {
      if (lex == LEXDEFAULT) {				# "default:"
	 n = -1
	 repeat {
	    c = ngetch (c)
	    n = n + 1
	 } until (c != BLANK & c != TAB)
	 call putbak (c)

	 t = gnbtok (lexstr, MAXTOK)
	 call pbstr (lexstr)
	 if (n > 0)
	    call putbak (BLANK)
	 call scopy (sdefault, 1, lexstr, 1)
	 if (t != COLON)
	    lex = LEXOTHER
	 }
      }
   else
      lex = LEXOTHER

   return
   end

include	defs

# rmtabl --- remove a symbol table, deleting all entries

   subroutine rmtabl (st)
   pointer st

   DS_COMMON

   integer i

   pointer walker, bucket, node

   bucket = st
   do i = 1, ST_HTABSIZE; {
      bucket = bucket + 1
      walker = Mem (bucket)
      while (walker != LAMBDA) {
	 node = walker
	 walker = Mem (node + ST_LINK)
	 call dsfree (node)
	 }
      }

   call dsfree (st)
   return
   end

c KEYW -- Test the image header get/put interface routines.
c
c	usage:  keyw imagename
c ----------------------------------------------------------------------------

	program keyw

	character*80	image, errmsg
	character*8	keywrd, option
	character*80	valstr, commnt
	integer		ncols, nlines, dtype
	integer		im, ier, axlen(7), naxis

c --- Get image name.
	call clargc (1, image, ier)
	if (ier .ne. 0) then
	    write (*, '('' enter image name: '',$)')
	    read (*,*) image
	endif

c --- Open the image.
	call imopen (image, 3, im, ier)
	if (ier .ne. 0) goto 91
	call imgsiz (im, axlen, naxis, dtype, ier)
	if (ier .ne. 0) goto 91

	ncols  = axlen(1)
	nlines = axlen(2)

c --- Interpreter loop.
 10	continue
	write (*, '('' enter command (quit,gkw[cir],pkw[cir],addk,delk): '',$)')
	read (*,*) option

	if (option .eq. 'pkwc') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    write (*, '('' value: '',$)')
	    read (*,*) valstr
	    call impkwc (im, keywrd, valstr, ier)
	    if (ier .ne. 0) goto 91
	    goto 10

	else if (option .eq. 'pkwi') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    write (*, '('' value: '',$)')
	    read (*,*) ival
	    call impkwi (im, keywrd, ival, ier)
	    if (ier .ne. 0) goto 91
	    goto 10

	else if (option .eq. 'pkwr') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    write (*, '('' value: '',$)')
	    read (*,*) rval
	    call impkwr (im, keywrd, rval, ier)
	    if (ier .ne. 0) goto 91
	    goto 10

	else if (option .eq. 'gkwc') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    call imgkwc (im, keywrd, valstr, ier)
	    if (ier .ne. 0) goto 91
	    write (*,*) 'value ', valstr
	    goto 10

	else if (option .eq. 'gkwi') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    call imgkwi (im, keywrd, ival, ier)
	    if (ier .ne. 0) goto 91
	    write (*,*) 'value ', ival
	    goto 10

	else if (option .eq. 'gkwr') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    call imgkwr (im, keywrd, rval, ier)
	    if (ier .ne. 0) goto 91
	    write (*,*) 'value ', rval
	    goto 10

	else if (option .eq. 'addk') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    write (*, '('' keyword datatype: '',$)')
	    read (*,*) dtype
	    write (*, '('' comment field: '',$)')
	    read (*,*) commnt
	    call imaddk (im, keywrd, dtype, commnt, ier)
	    if (ier .ne. 0) goto 91
	    write (*,*) 'value ', rval
	    goto 10

	else if (option .eq. 'delk') then
	    write (*, '('' keyword name: '',$)')
	    read (*,*) keywrd
	    call imdelk (im, keywrd, ier)
	    if (ier .ne. 0) goto 91
	    goto 10

	endif

c --- Clean up.
	call imclos (im, ier)
	if (ier .ne. 0) goto 91

	stop
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg

	stop
	end

C--------------------------------------------------------------------------
        subroutine ftg3di(ounit,group,nulval,dim1,dim2,nx,ny,nz,
     &                    array,anyflg,status)

C       Read a 3-d cube of i*2 values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       nulval  i*2  undefined pixels will be set to this value (unless = 0)
C       dim1    i  actual first dimension of ARRAY
C       dim2    i  actual second dimension of ARRAY
C       nx      i  size of the cube in the x direction
C       ny      i  size of the cube in the y direction
C       nz      i  size of the cube in the z direction
C       array   i*2  the array of values to be read
C       anyflg  l  set to true if any of the image pixels were undefined
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,dim1,dim2,nx,ny,nz,status
        integer*2 array(dim1,dim2,*),nulval
        logical anyflg,ltemp
        integer fpixel,row,band

        anyflg=.false.
        fpixel=1
        do 20 band=1,nz
        do 10 row = 1,ny
                call ftgpvi(ounit,group,fpixel,nx,nulval,
     &              array(1,row,band),ltemp,status)
                if (ltemp)anyflg=.true.
                fpixel=fpixel+nx
10      continue
20      continue
        end

C----------------------------------------------------------------------
        subroutine ftpcll(ounit,colnum,frow,felem,nelem,lray,status)

C       write an array of logical values to the  specified column of the table.
C       The binary table column being written to must have datatype 'L'
C       and no datatype conversion will be perform if it is not.

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       lray    l  array of data values to be written
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status
        logical lray(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bstart,maxpix,i
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart,tcode
        character*1 buffer(80)
        character crow*9,cp1*9,cp2*9,ccol*4
        logical descrp
        
        if (status .gt. 0)return

C       check for zero length array
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &          'request is out of range:'//crow//' (FTPCLL).')
                return
        end if

        if (felem .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &          'request is out of range:'//crow//' (FTPCLL).')
                return
        else
                estart=felem-1
        end if

        ibuff=bufnum(ounit)
C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)

        i1=1
        ntodo=nelem
        rstart=frow-1
        maxpix=80

C       column must be logical data type
        tcode=tdtype(colnum+tstart(ibuff)) 
        if (tcode .eq. 14)then
                descrp=.false.
                repeat=trept(colnum+tstart(ibuff))
                if (felem .gt. repeat)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &          'request is out of range:'//crow//' (FTPCLL).')
                        return
                end if
        else if (tcode .eq. -14)then
                descrp=.true.
                repeat=nelem+estart
C               write the number of elements and the starting offset:
                call ftpdes(ounit,colnum,frow,repeat,
     &                              nxheap(ibuff),status)
C               move the i/o pointer to the start of the pixel sequence
                bstart=dtstrt(ibuff)+nxheap(ibuff)+
     &                          theap(ibuff)+estart
                call ftmbyt(ounit,bstart,.true.,status)
C               increment the empty heap starting address:
                nxheap(ibuff)=nxheap(ibuff)+repeat
        else 
C               error illegal data type code 
                status=310
                return
        end if

C       process as many contiguous pixels as possible
20      itodo=min(ntodo,repeat-estart,maxpix)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &      tbcol(colnum+tstart(ibuff))+estart
            call ftmbyt(ounit,bstart,.true.,status)
        end if

C       create the buffer of logical bytes
        do 10 i=1,itodo
                if (lray(i1))then
                        buffer(i)='T'
                else
                        buffer(i)='F'
                end if
                i1=i1+1
10      continue

C       write out the buffer
        call ftpcbf(ounit,1,itodo,buffer,status)

        if (status .gt. 0)then
          write(cp1,2000)i1
          write(cp2,2000)i1+itodo-1
          call ftpmsg('Error while writing values'//cp1//' to'//cp2)
          write(ccol,2001)colnum
2001      format(i4)
          write(cp1,2000)frow
          write(cp2,2000)felem
          if (felem .eq. 1)then
               call ftpmsg('of column'//ccol//', starting at row'//cp1
     &                    //' (FTPCLL).')
          else
               call ftpmsg('of column'//ccol//', starting at row'//cp1
     &         //', element'//cp2//' (FTPCLL).')    
          end if
          return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        rstart=rstart+1
                end if
                go to 20
        end if
        end

      SUBROUTINE slNUT (DATE, RMATN)
*+
*     - - - -
*      N U T
*     - - - -
*
*  Form the matrix of nutation for a given date - Shirai & Fukushima
*  2001 theory (double precision)
*
*  Reference:
*     Shirai, T. & Fukushima, T., Astron.J. 121, 3270-3283 (2001).
*
*  Given:
*     DATE    d          TDB (loosely ET) as Modified Julian Date
*                                           (=JD-2400000.5)
*  Returned:
*     RMATN   d(3,3)     nutation matrix
*
*  Notes:
*
*  1  The matrix is in the sense  v(true) = rmatn * v(mean) .
*     where v(true) is the star vector relative to the true equator and
*     equinox of date and v(mean) is the star vector relative to the
*     mean equator and equinox of date.
*
*  2  The matrix represents forced nutation (but not free core
*     nutation) plus corrections to the IAU~1976 precession model.
*
*  3  Earth attitude predictions made by combining the present nutation
*     matrix with IAU~1976 precession are accurate to 1~mas (with
*     respect to the ICRS) for a few decades around 2000.
*
*  4  The distinction between the required TDB and TT is always
*     negligible.  Moreover, for all but the most critical applications
*     UTC is adequate.
*
*  Called:   slNUTC, slDEUL
*
*  Last revision:   1 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,RMATN(3,3)

      DOUBLE PRECISION DPSI,DEPS,EPS0



*  Nutation components and mean obliquity
      CALL slNUTC(DATE,DPSI,DEPS,EPS0)

*  Rotation matrix
      CALL slDEUL('XZX',EPS0,-DPSI,-(EPS0+DEPS),RMATN)

      END

      SUBROUTINE SET3 (XA,XB,YA,YB,ULO,UHI,VLO,VHI,WLO,WHI,EYE)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C THREE-DIMENSIONAL LINE DRAWING PACKAGE
C
C
C LATEST REVISION        JULY, 1984
C
C PURPOSE                THREED IS A PACKAGE OF SUBROUTINES THAT
C                        PROVIDES LINE DRAWING CAPABILITIES IN
C                        THREE-SPACE.
C
C USAGE                  EACH ENTRY POINT IN THIS PACKAGE IS
C                        DESCRIBED BELOW.
C
C                        SET3 (XA,XB,YA,YB,UC,UD,VC,VD,WC,WD,EYE)
C
C                          XA, XB, YA, YB  DEFINE THE PORTION OF THE
C                          PLOTTING SURFACE INTO WHICH THE USER'S
C                          PLOT WILL BE PLACED.  THESE VALUES SHOULD
C                          BE IN THE RANGE 0. TO 1.  FOR EXAMPLE, IF
C                          ONE WANTS THE PLOT TO OCCUPY THE MAXIMUM
C                          PLOTTING SURFACE, SET XA=0., YA=0., XB=1.,
C                          YB=1.; IF ONE WANTS THE PLOT TO APPEAR IN
C                          THE LOWER LEFT CORNER OF THE PLOTTING
C                          SURFACE, SET XA=0., YA=0., XB=.5, YB=.5 .
C
C                          UC, UD, VC, VD, WC, AND WD DEFINE A
C                          VOLUME IN USER-COORDINATE SPACE WHICH
C                          WILL BE TRANSFORMED ONTO THE PLOTTING
C                          SURFACE DEFINED BY XA, XB, YA, YB.
C
C                          EYE IS AN ARRAY, 3 WORDS LONG, CONTAINING THE
C                          U, V, AND W COORDINATES OF THE EYE POSITION.
C                          ALL LINES IN THE PLOT ARE DRAWN AS VIEWED
C                          FROM THE EYE.  EYE IS SPECIFIED IN USER
C                          COORDINATES AND SHOULD BE OUTSIDE THE BOX
C                          DEFINED BY UC, UD, VC, VC, WC, AND WD.
C
C                        CURVE3 (U,V,W,N)
C
C                          DRAWS A CURVE THROUGH N POINTS.  THE
C                          POINTS ARE DEFINED BY THE LINEAR ARRAYS
C                          U, V, AND W WHICH ARE DIMENSIONED N OR
C                          GREATER.
C
C                        LINE3 (UA,VA,WA,UB,VB,WB)
C
C                          DRAWS A LINE CONNECTING THE COORDINATES
C                          (UA,VA,WA)  AND  (UB,VB,WB).
C
C                        FRST3 (U,V,W)
C
C                          POSITIONS THE PEN TO (U,V,W).
C
C                        VECT3 (U,V,W)
C
C                          DRAWS A LINE BETWEEN THE CURRENT PEN
C                          POSITION AND THE POINT (U,V,W).  THE
C                          CURRENT PEN POSITION BECOMES (U,V,W).
C                          NOTE THAT A CURVE CAN BE DRAWN BY USING
C                          A FRST3 CALL FOLLOWED BY A SEQUENCE OF
C                          VECT3 CALLS.
C
C                        POINT3 (U,V,W)
C
C                          PLOTS A POINT AT (U,V,W) .
C
C                        PERIM3 (MAGR1,MINR1,MAGR2,MINR2,IWHICH,VAR)
C
C                          DRAWS A PERIMETER WITH TICK MARKS.
C
C                          IWHICH DESIGNATES THE NORMAL VECTOR TO THE
C                          PERIMETER DRAWN (1=U, 2=V, 3=W).
C
C                          VAR IS THE VALUE ON THE AXIS SPECIFIED BY
C                          INWHICH WHERE THE PERIMETER IS TO BE DRAWN.
C
C                          MAGR1  AND  MAGR2  SPECIFY THE
C                          NUMBER OF MAJOR TICK MARKS TO BE DRAWN IN
C                          THE TWO COORDINATE DIRECTIONS.
C
C                          MINR1  AND  MINR2  SPECIFY THE NUMBER
C                          OF MINOR TICKS BETWEEN EACH MAJOR TICK.
C
C                          MAGR1, MAGR2, MINR1 AND MINR2
C                          ARE SPECIFIED BY THE NUMBER
C                          OF DIVISIONS(HOLES), NOT THE NUMBER OF
C                          TICKS.  SO IF MAGR1=1, THERE WOULD BE NO
C                          MAJOR DIVISIONS.
C
C                        TICK43 (MAGU,MINU,MAGV,MINV,MAGW,MINW)
C
C                          TICK43 ALLOWS PROGRAM CONTROL OF TICK
C                          MARK LENGTH IN SUBROUTINE PERIM3.
C                          MAGU, MAGV, MAGW SPECIFY THE LENGTH,
C                          IN PLOTTER ADDRESS UNITS OF MAJOR
C                          DIVISION TICK MARKS ON THE U, V, AND W
C                          AXES.  MINU, MINV, MINW SPECIFY THE LENGTH,
C                          IN PLOTTER ADDRESS UNITS OF MINOR
C                          DIVISION TICK MARKS ON THE U, V, AND
C                          W AXES.
C
C                        FENCE3 (U,V,W,N,IOREN,BOT)
C
C                          THIS ENTRY IS USED TO DRAW A LINE IN THREE-
C                          SPACE AS WELL AS A "FENCE" BETWEEN THE
C                          LINE AND A PLANE NORMAL TO ONE OF THE
C                          COORDINATE AXES.
C
C                          THE ARGUMENTS U, V, W AND N
C                          ARE THE SAME AS FOR CURVE, DESCRIBED ABOVE.
C
C                          IOREN SPECIFIES THE DIRECTION IN WHICH THE
C                          FENCE LINES ARE TO BE DRAWN (1 INDICATES
C                          PARALLEL TO THE U-AXIS, 2 INDICATES PARALLEL
C                          TO THE V-AXIS, AND 3 INDICATES PARALLEL TO
C                          TO THE W-AXIS.)
C
C                          BOT SPECIFIES WHERE THE BOTTOM OF THE FENCE
C                          IS TO BE DRAWN.
C                          IF THE FENCE LINES ARE TO BE DRAWN PARALLEL
C                          TO THE W-AXIS, AND  BOT=2., THEN THE BOTTOM
C                          OF THE FENCE WOULD BE THE PLANE  W=2.
C
C ON OUTPUT              ALL ARGUMENTS ARE UNCHANGED.
C
C NOTES                  .  FOR DRAWING CHARACTERS IN CONJUNCTION
C                           WITH THREED, USE THE COMPANION ROUTINE
C                           PWRZT.
C
C ENTRY POINTS          FENCE3, TRN32T, FRST3, VECT3, LIN3,
C                       POINT3, CURVE3, PSYM3, PERIM3, LINE3W,
C                       DRAWT, TICK43, TICK3, THREBD
C
C COMMON BLOCKS         TEMPR, SET31, PWRZ1T, TCK31, PRM31, THRINT
C
C REQUIRED LIBRARY      PWRZ AND THE SPPS
C ROUTINES
C
C HISTORY               WRITTEN AND STANDARDIZED IN NOVEMBER 1973.
C I/O                   PLOTS LINES.
C
C PRECISION             SINGLE
C
C LANGUAGE              FORTRAN
C
C ACCURACY              + OR -.5 PLOTTER ADDRESS UNITS PER CALL.
C                       THERE IS NO CUMULATIVE ERROR.
C
C PORTABILITY           ANSI FORTRAN 77
C
C
C
C
C
      SAVE
C
      COMMON /TEMPR/  RZERO
C
      DIMENSION       EYE(3)
C
      COMMON /SET31/  ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0         ,NLX        ,
     2                NBY        ,NRX        ,NTY
      COMMON /PWRZ1T/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
C
C
      AVE(A,B) = (A+B)*.5
C
C ARITHMETIC STATEMENT FUNCTION FOR SCALING
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
C +NOAO - Blockdata threbd rewritten as run time initialization.
C
C     EXTERNAL        THREBD
      call threbd
C -NOAO
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','SET3','VERSION  1')
C
C SET UP FRAME SIZE
C
      NLX = XA*1023.+1.
      NRX = XB*1023.+1.
      NBY = YA*1023.+1.
      NTY = YB*1023.+1.
C
C CONSTANTS FOR PWRZT
C
      UUMIN = ULO
      UUMAX = UHI
      VVMIN = VLO
      VVMAX = VHI
      WWMIN = WLO
      WWMAX = WHI
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
C
C FIND CORNERS IN 2-SPACE FOR 3-SPACE BOX CONTAINING OBJECT
C
      ISCALE = 0
      ATU = AVE(SU(UUMIN),SU(UUMAX))
      ATV = AVE(SV(VVMIN),SV(VVMAX))
      ATW = AVE(SW(WWMIN),SW(WWMAX))
      BIGD = 0.
      IF (RZERO .LE. 0.) GO TO  10
C
C RELATIVE SIZE FEATURE IN USE.  THIS SECTION OF CODE IS NEVER
C EXECUTED UNLESS RZERO IS SET POSITIVE IN THE CALLING PROGRAM
C VIA COMMON BLOCK TEMPR.  RZERO  IS THE DISTANCE BETWEEN THE
C OBSERVER AND THE POINT LOOKED AT (CENTER OF THE BOX BY DEFAULT)
C WHEN THE INPUT BOX IS TO FILL THE SCREEN WHEN VIEWED FROM THE
C DIRECTION WHICH MAKES THE BOX BIGGEST.  RZERO  IS THUS TO
C BE USED TO DETERMINE THE SHAPE OF THE OBJECT.   THIS SECTION
C OF CODE IS TO BE USED WHEN IT IS DESIRED TO KEEP THE VIEWED
C OBJECT IN RELATIVE PERSPECTIVE ACROSS FRAMES--E.G. IN MAKING
C MOVIES.
C
      ALPHA = -(VVMIN-ATV)/(UUMIN-ATU)
      VVEYE = -RZERO/SQRT(1.+ALPHA*ALPHA)
      UUEYE = VVEYE*ALPHA
      VVEYE = VVEYE+ATV
      UUEYE = UUEYE+ATU
      WWEYE = ATW
      CALL TRN32T (ATU,ATV,ATW,UUEYE,VVEYE,WWEYE,1)
      CALL TRN32T (UUMIN,VVMIN,ATW,XMIN,DUMM,DUMM,2)
      CALL TRN32T (UUMAX,VVMIN,WWMIN,DUMM,YMIN,DUMM,2)
      CALL TRN32T (UUMAX,VVMAX,ATW,XMAX,DUMM,DUMM,2)
      CALL TRN32T (UUMAX,VVMIN,WWMAX,DUMM,YMAX,DUMM,2)
      BIGD = SQRT((UUMAX-UUMIN)**2+(VVMAX-VVMIN)**2+(WWMAX-WWMIN)**2)*.5
      R0 = RZERO
      GO TO  20
   10 CALL TRN32T (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      CALL TRN32T (SU(UUMIN),SV(VVMIN),SW(WWMIN),X1,Y1,DUM,2)
      CALL TRN32T (SU(UUMIN),SV(VVMIN),SW(WWMAX),X2,Y2,DUM,2)
      CALL TRN32T (SU(UUMIN),SV(VVMAX),SW(WWMIN),X3,Y3,DUM,2)
      CALL TRN32T (SU(UUMIN),SV(VVMAX),SW(WWMAX),X4,Y4,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMIN),SW(WWMIN),X5,Y5,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMIN),SW(WWMAX),X6,Y6,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMAX),SW(WWMIN),X7,Y7,DUM,2)
      CALL TRN32T (SU(UUMAX),SV(VVMAX),SW(WWMAX),X8,Y8,DUM,2)
      XMIN = AMIN1(X1,X2,X3,X4,X5,X6,X7,X8)
      XMAX = AMAX1(X1,X2,X3,X4,X5,X6,X7,X8)
      YMIN = AMIN1(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
      YMAX = AMAX1(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
C
C ADD RIGHT AMOUNT TO KEEP PICTURE SQUARE
C
   20 WIDTH = XMAX-XMIN
      HIGHT = YMAX-YMIN
      DIF = .5*(WIDTH-HIGHT)
      IF (DIF)  30, 50, 40
   30 XMIN = XMIN+DIF
      XMAX = XMAX-DIF
      GO TO  50
   40 YMIN = YMIN-DIF
      YMAX = YMAX+DIF
   50 ISCALE = 1
      CALL TRN32T (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      RETURN
      END
      SUBROUTINE TRN32T (U,V,W,XT,YT,ZT,IENT)
C
C THIS ROUTINE IMPLEMENTS THE 3-SPACE TO 2-SPACE TRANSFOR-
C MATION BY KUBER, SZABO AND GIULIERI, THE PERSPECTIVE
C REPRESENTATION OF FUNCTIONS OF TWO VARIABLES. J. ACM 15,
C 2, 193-204,1968.
C TRN32T ARGUMENTS
C U,V,W    ARE THE 3-SPACE COORDINATES OF THE INTERSECTION
C          OF THE LINE OF SIGHT AND THE IMAGE PLANE.  THIS
C          POINT CAN BE THOUGHT OF AS THE POINT LOOKED AT.
C XT,YT,ZT ARE THE 3-SPACE COORDINATES OF THE EYE POSITION.
C
C TRN32 ARGUMENTS
C U,V,W    ARE THE 3-SPACE COORDINATES OF A POINT TO BE
C          TRANSFORMED.
C XT,YT    THE RESULTS OF THE 3-SPACE TO 2-SPACE TRANSFOR-
C          MATION.  WHEN ISCALE=0, XT AND YT ANR IN THE SAME
C          UNITS AS U,V, AND W.  WHEN ISCALE'0, XT AND YT
C          ARE IN PLOTTER COORDINATES.
C ZT       NOT USED.
C
C
      SAVE
C
      COMMON /PWRZ1T/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
      COMMON /SET31/  ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0         ,NLX        ,
     2                NBY        ,NRX        ,NTY
C
C DECIDE IF SET OR TRANSLATE CALL
C
      IF (IENT .NE. 1) GO TO  50
C
C STORE THE PARAMETERS OF THE SET CALL
C FOR USE WITH THE TRANSLATION CALL
C
      AU = U
      AV = V
      AW = W
      EU = XT
      EV = YT
      EW = ZT
C
C
C
C
C
      DU = AU-EU
      DV = AV-EV
      DW = AW-EW
      D = SQRT(DU*DU+DV*DV+DW*DW)
      COSAL = DU/D
      COSBE = DV/D
      COSGA = DW/D
      AL = ACOS(COSAL)
      BE = ACOS(COSBE)
      GA = ACOS(COSGA)
      SINGA = SIN(GA)
C
C THE 3-SPACE POINT LOOKED AT IS TRANSFORMED INTO (0,0) OF
C THE 2-SPACE.  THE 3-SPACE W AXIS IS TRANSFORMED INTO THE
C 2-SPACE Y AXIS.  IF THE LINE OF SIGHT IS CLOSE TO PARALLEL
C TO THE 3-SPACE W AXIS, THE 3-SPACE V AXIS IS CHOSEN (IN-
C STEAD OF THE 3-SPACE W AXIS) TO BE TRANSFORMED INTO THE
C 2-SPACE Y AXIS.
C
      ASSIGN  90 TO JDONE
      IF (ISCALE)  10, 30, 10
   10 X0 = XMIN
      Y0 = YMIN
      X1 = NLX
      Y1 = NBY
      X2 = NRX-NLX
      Y2 = NTY-NBY
      X3 = X2/(XMAX-XMIN)
      Y3 = Y2/(YMAX-YMIN)
      X4 = NRX
      Y4 = NTY
      FACT = 1.
      IF (BIGD .LE. 0.) GO TO  20
      X0 = -BIGD
      Y0 = -BIGD
      X3 = X2/(2.*BIGD)
      Y3 = Y2/(2.*BIGD)
      FACT = R0/D
   20 DELCRT = X2
      ASSIGN  80 TO JDONE
   30 IF (SINGA .LT. 0.0001) GO TO  40
      R = 1./SINGA
      ASSIGN  70 TO JUMP
      RETURN
   40 SINBE = SIN(BE)
      R = 1./SINBE
      ASSIGN  60 TO JUMP
      RETURN
C
C********************  ENTRY TRN32  ************************
C     ENTRY TRN32 (U,V,W,XT,YT,ZT)
C
   50 UU = U
      VV = V
      WW = W
      Q = D/((UU-EU)*COSAL+(VV-EV)*COSBE+(WW-EW)*COSGA)
      GO TO JUMP,( 60, 70)
   60 UU = ((EW+Q*(WW-EW)-AW)*COSAL-(EU+Q*(UU-EU)-AU)*COSGA)*R
      VV = (EV+Q*(VV-EV)-AV)*R
      GO TO JDONE,( 80, 90)
   70 UU = ((EU+Q*(UU-EU)-AU)*COSBE-(EV+Q*(VV-EV)-AV)*COSAL)*R
      VV = (EW+Q*(WW-EW)-AW)*R
      GO TO JDONE,( 80, 90)
   80 XT = X1+X3*(FACT*UU-X0)
      YT = Y1+Y3*(FACT*VV-Y0)
      RETURN
   90 XT = UU
      YT = VV
      RETURN
      END
      SUBROUTINE FRST3 (U,V,W)
      SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','FRST3','VERSION  1')
      XDUM = 5.
      CALL TRN32T (U,V,W,X,Y,XDUM,2)
      CALL PLOTIT  (32*IFIX(X),32*IFIX(Y),0)
      RETURN
      END
      SUBROUTINE VECT3 (U,V,W)
      SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','VECT3','VERSION  1')
      CALL TRN32T (U,V,W,X,Y,ZDUM,2)
      IIX = 32*IFIX(X)
      IIY = 32*IFIX(Y)
      CALL PLOTIT  (IIX,IIY,1)
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT  (IIX,IIY,0)
      RETURN
      END
      SUBROUTINE LINE3 (UA,VA,WA,UB,VB,WB)
      SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','LINE3','VERSION  1')
      CALL TRN32T (UA,VA,WA,XA,YA,XDUM,2)
      CALL TRN32T (UB,VB,WB,XB,YB,XDUM,2)
      IIX = 32*IFIX(XB)
      IIY = 32*IFIX(YB)
      CALL PLOTIT (32*IFIX(XA),32*IFIX(YA),0)
      CALL PLOTIT (IIX,IIY,1)
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT (IIX,IIY,0)
      RETURN
      END
      SUBROUTINE POINT3 (U,V,W)
      SAVE
      DIMENSION VWPRT(4),WNDW(4)
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','POINT3','VERSION  1')
C
C INQUIRE CURRENT NORMALIZATION TRANS NUMBER
C
      CALL GQCNTN (IERR,NTORIG)
C
C SAVE NORMALIZATION TRANS 1 AND CURRENT LOG SCALING
C
      CALL GQNT (1,IERR,WNDW,VWPRT)
      CALL GETUSV ('LS',IOLLS)
C
C DEFINE NOMALIZATION TRANS TO BE USED WITH POLYMARKER
C
      CALL SET(0.0, 1.0, 0.0, 1.0, 1.0, 1024.0, 1.0, 1024.0, 1)
C
C SET MARKER TYPE TO 1
C
      CALL GSMK (1)
      CALL TRN32T (U,V,W,X,Y,ZDUM,2)
      PX = X
      PY = Y
      CALL GPM (1,PX,PY)
C
C RESTORE ORIGINAL TRANS 1 AND SELECT TRANS NUMBER NTORIG
C RESTORE LOG SCALING
C
      CALL SET(VWPRT(1),VWPRT(2),VWPRT(3),VWPRT(4),
     -         WNDW(1),WNDW(2),WNDW(3),WNDW(4),IOLLS)
      CALL GSELNT (NTORIG)
      RETURN
      END
      SUBROUTINE CURVE3 (U,V,W,N)
      SAVE
      DIMENSION       U(N)       ,V(N)       ,W(N)
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','CURVE3','VERSION  1')
      CALL TRN32T (U(1),V(1),W(1),X,Y,ZDUM,2)
      CALL PLOTIT (32*IFIX(X),32*IFIX(Y),0)
      NN = N
      IF (NN .LT. 2) RETURN
      DO  10 I=2,NN
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL TRN32T (UU,VV,WW,X,Y,ZDUM,2)
         CALL PLOTIT (32*IFIX(X),32*IFIX(Y),1)
   10 CONTINUE
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END
      SUBROUTINE PSYM3 (U,V,W,ICHAR,SIZE,IDIR,ITOP,IUP)
      SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','PSYM3','VERSION  1')
      IF (IUP .EQ. 2) CALL VECT3 (U,V,W)
      CALL PWRZ (U,V,W,ICHAR,1,SIZE,IDIR,ITOP,0)
      RETURN
      END
      SUBROUTINE PERIM3 (MAGR1,MINI1,MAGR2,MINI2,IWHICH,VAR)
      SAVE
      COMMON /PWRZ1T/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
      COMMON /PRM31/  Q          ,L
      COMMON /TCK31/  TMAGU      ,TMINU      ,TMAGV      ,TMINV      ,
     1                TMAGW      ,TMINW
C
C THRINT COMMON BLOCK IS USED FOR SETTING COLOR INTENSITY
C
      COMMON /THRINT/ ITHRMJ     ,ITHRMN     ,ITHRTX
      DIMENSION       LASF(13)
C
      TICK(T) = AMAX1(UUMAX-UUMIN,VVMAX-VVMIN,WWMAX-WWMIN)*T/1024.
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','PERIM3','VERSION  1')
C
C INQUIRE LINE COLOR INDEX AND SET ASF TO INDIVIDUAL
C
      CALL GQPLCI (IERR, IPLCI)
      CALL GQASF (IERR, LASF)
      LSV3  = LASF(3)
      LASF(3) = 1
      CALL GSASF (LASF)
C
      MGR1 = MAGR1
      MN1 = MINI1-1
      MGR2 = MAGR2
      MN2 = MINI2-1
      MN1P1 = MAX0(MN1+1,1)
      MN2P1 = MAX0(MN2+1,1)
      L = MIN0(3,MAX0(1,IWHICH))
      Q = VAR
C
C PICK BOUNDS
C
      GO TO ( 10, 30, 40),L
   10 XMIN = VVMIN
      XMAX = VVMAX
      DELXL = TICK(TMAGU)
      DELXS = TICK(TMINU)
   20 YMIN = WWMIN
      YMAX = WWMAX
      DELYL = TICK(TMAGW)
      DELYS = TICK(TMINW)
      GO TO  50
   30 XMIN = UUMIN
      XMAX = UUMAX
      DELXL = TICK(TMAGU)
      DELXS = TICK(TMINU)
      GO TO  20
   40 XMIN = UUMIN
      XMAX = UUMAX
      DELXL = TICK(TMAGU)
      DELXS = TICK(TMINU)
      YMIN = VVMIN
      YMAX = VVMAX
      DELYL = TICK(TMAGV)
      DELYS = TICK(TMINV)
C
C PERIM
C
   50 CALL LINE3W (XMIN,YMIN,XMAX,YMIN)
      CALL LINE3W (XMAX,YMIN,XMAX,YMAX)
      CALL LINE3W (XMAX,YMAX,XMIN,YMAX)
      CALL LINE3W (XMIN,YMAX,XMIN,YMIN)
      IF (MGR1 .LT. 1) GO TO  90
      DX = (XMAX-XMIN)/AMAX0(MGR1*(MN1P1),1)
      DO  80 I=1,MGR1
C
C MINORS FIRST
C
         IF (MN1 .LE. 0) GO TO  70
C
C SET LINE INTENSITY TO LOW
C
         CALL GSPLCI (ITHRMN)
         DO  60 J=1,MN1
            X = XMIN+FLOAT(MN1P1*(I-1)+J)*DX
            CALL LINE3W (X,YMIN,X,YMIN+DELYS)
            CALL LINE3W (X,YMAX,X,YMAX-DELYS)
   60    CONTINUE
   70    IF (I .GE. MGR1) GO TO  90
C
C SET LINE INTENSITY TO HIGH
C
         CALL GSPLCI (ITHRMJ)
         X = XMIN+FLOAT(MN1P1*I)*DX
C
C MAJORS
C
         CALL LINE3W (X,YMIN,X,YMIN+DELYL)
         CALL LINE3W (X,YMAX,X,YMAX-DELYL)
   80 CONTINUE
   90 IF (MGR2 .LT. 1) GO TO 130
      DY = (YMAX-YMIN)/AMAX0(MGR2*(MN2P1),1)
      DO 120 J=1,MGR2
         IF (MN2 .LE. 0) GO TO 110
         DO 100 I=1,MN2
            Y = YMIN+FLOAT(MN2P1*(J-1)+I)*DY
            CALL LINE3W (XMIN,Y,XMIN+DELXS,Y)
C
C SET LINE INTENSITY TO LOW
C
            CALL GSPLCI (ITHRMN)
            CALL LINE3W (XMAX,Y,XMAX-DELXS,Y)
  100    CONTINUE
  110    IF (J .GE. MGR2) GO TO 130
C
C SET LINE INTENSITY TO HIGH
C
         CALL GSPLCI (ITHRMJ)
         Y = YMIN+FLOAT(MN2P1*J)*DY
         CALL LINE3W (XMIN,Y,XMIN+DELXL,Y)
         CALL LINE3W (XMAX,Y,XMAX-DELXL,Y)
  120 CONTINUE
C
C RESTORE ASF AND LINE INTENSITY TO ORIGINAL
C
  130 LASF(3) = LSV3
      CALL GSASF (LASF)
      CALL GSPLCI (IPLCI)
      RETURN
      END
      SUBROUTINE LINE3W (XA,YA,XB,YB)
      SAVE
      COMMON /PRM31/  Q          ,L
      GO TO ( 10, 30, 40),L
   10 UA = Q
      UB = Q
      VA = XA
      VB = XB
   20 WA = YA
      WB = YB
      GO TO  50
   30 UA = XA
      UB = XB
      VA = Q
      VB = Q
      GO TO  20
   40 UA = XA
      UB = XB
      VA = YA
      VB = YB
      WA = Q
      WB = Q
   50 CALL LINE3 (UA,VA,WA,UB,VB,WB)
      RETURN
      END
      SUBROUTINE DRAWT (IXA,IYA,IXB,IYB)
      SAVE
      CALL PLOTIT(32*IXA,32*IYA,0)
      IIX = 32*IXB
      IIY = 32*IYB
      CALL PLOTIT(IIX,IIY,1)
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(IIX,IIY,0)
      RETURN
      END
      SUBROUTINE TICK43 (MAGU,MINU,MAGV,MINV,MAGW,MINW)
      SAVE
      COMMON /TCK31/  TMAGU      ,TMINU      ,TMAGV      ,TMINV      ,
     1                TMAGW      ,TMINW
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','TICK43','VERSION  1')
      TMAGU = MAGU
      TMINU = MINU
      TMAGV = MAGV
      TMINV = MINV
      TMAGW = MAGW
      TMINW = MINW
      RETURN
      END
      SUBROUTINE TICK3 (MAG,MIN)
      SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','TICK3','VERSION  1')
      CALL TICK43 (MAG,MIN,MAG,MIN,MAG,MIN)
      RETURN
      END
      SUBROUTINE FENCE3 (U,V,W,N,IOR,BOT)
      SAVE
      REAL            U(N)       ,V(N)       ,W(N)
      DIMENSION       LASF(13)
C
C COMMON BLOCK THRINT IS USED FOR SETTING COLOR INTENSITY
C
      COMMON /THRINT/ ITHRMJ     ,ITHRMN     ,ITHRTX
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','THREED','FENCE3','VERSION  1')
C
C INQUIRE LINE COLOR INDEX AND SET ASF TO INDIVIDUAL
C
      CALL GQPLCI (IERR, IPLCI)
      CALL GQASF (IERR, LASF)
      LSV3  = LASF(3)
      LASF(3) = 1
      CALL GSASF (LASF)
C
      M = N
      BASE = BOT
      L = MAX0(1,MIN0(3,IOR))
C
C SET LINE INTENSITY TO LOW
C
      CALL GSPLCI (ITHRMN)
      GO TO ( 10, 40, 70),L
   10 CALL FRST3 (BASE,V(1),W(1))
      DO  20 I=2,M
         VV = V(I)
         WW = W(I)
         CALL VECT3 (BASE,VV,WW)
   20 CONTINUE
      DO  30 I=1,M
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL LINE3 (UU,VV,WW,BASE,VV,WW)
   30 CONTINUE
      GO TO 100
   40 CALL FRST3 (U(1),BASE,W(1))
      DO  50 I=2,M
         UU = U(I)
         WW = W(I)
         CALL VECT3 (UU,BASE,WW)
   50 CONTINUE
      DO  60 I=1,M
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL LINE3 (UU,VV,WW,UU,BASE,WW)
   60 CONTINUE
      GO TO 100
   70 CALL FRST3 (U(1),V(1),BASE)
      DO  80 I=2,M
         UU = U(I)
         VV = V(I)
         CALL VECT3 (UU,VV,BASE)
   80 CONTINUE
      DO  90 I=1,M
         UU = U(I)
         VV = V(I)
         WW = W(I)
         CALL LINE3 (UU,VV,WW,UU,VV,BASE)
   90 CONTINUE
C
C SET LINE INTENSITY TO HIGH
C
  100 CALL GSPLCI (ITHRMJ)
      CALL CURVE3 (U,V,W,M)
C
C RESTORE ASF AND LINE INTENSITY TO ORIGINAL
C
      LASF(3) = LSV3
      CALL GSASF (LASF)
      CALL GSPLCI (IPLCI)
C
      RETURN
C
C REVISION HISTORY---
C
C JANUARY 1978     DELETED REFERENCES TO THE  *COSY  CARDS AND
C                  ADDED REVISION HISTORY
C FEBURARY 1979    MODIFIED CODE TO CONFORM TO FORTRAN 66 STANDARD
C JUNE 1979        UPDATED FILE TO INCLUDE BLOCK DATA PWRZBD AND
C                  CORRECT A COMMENTED OUT STATEMENT IN CURVE3.
C MARCH 1980       REMOVED THE PWRZ AND PWRITZ ENTRIES.  THESE
C                  CAPABILITIES WERE REPLACED WITH THE NEW ULIB FILE
C                  PWRZT.
C JULY 1984        CONVERTED TO FORTRAN 77 AND GKS
C-----------------------------------------------------------------------
C
      END
      SUBROUTINE PWRZ (X,Y,Z,ID,N,ISIZE,LIN3,ITOP,ICNT)
C     WRITE (6,1001)
C     WRITE (6,1002)
C     STOP
C
C1001 FORMAT (1H1//////////)
C1002 FORMAT (' *****************************************'/
C    1        ' *                                       *'/
C    2        ' *                                       *'/
C    3        ' *   THE ENTRY POINT PWRZ IS NO LONGER   *'/
C    4        ' *   SUPPORTED.  THE CAPABILITIES OF     *'/
C    5        ' *   THIS OLD ENTRY ARE NOW AVAILABLE    *'/
C    6        ' *   IN THE NEW PORTABLE VERSIONS        *'/
C    7        ' *                                       *'/
C    8        ' *        PWRZS  FOR USE WITH SRFACE     *'/
C    9        ' *        PWRZI  FOR USE WITH ISOSRF     *'/
C    +        ' *        PWRZT  FOR USE WITH THREED     *'/
C    1        ' *                                       *'/
C    2        ' *   FOR USAGE OF THESE ROUTINES, SEE    *'/
C    3        ' *   THE DOCUMENTATION FOR THE DESIRED   *'/
C    4        ' *   ROUTINE.                            *'/
C    5        ' *                                       *'/
C    6        ' *                                       *'/
C    7        ' *****************************************')
C
      END

include defs

# ERRCHK -- Code called to process an ERRCHK declaration.

subroutine errchk

character tok, last_tok, gnbtok, token(MAXTOK)
pointer	mktabl
include	COMMON_BLOCKS
string	serrcom1 "logical xerflg, xerpad(84)"
string	serrcom2 "common /xercom/ xerflg, xerpad"

	tok = 0

	repeat {
	    last_tok = tok
	    tok = gnbtok (token, MAXTOK)

	    switch (tok) {
	    case ALPHA:
		if (errtbl == NULL) {
		    errtbl = mktabl(0)			# make empty table
		    call outtab				# declare err flag
		    call outstr (serrcom1)
		    call outdon
		    call outtab				# declare err common
		    call outstr (serrcom2)
		    call outdon
		}
		call enter (token, 0, errtbl)		# enter keyw in table
	    case COMMA:
		# no action, but required by syntax
	    case NEWLINE:
		if (last_tok != COMMA)
		    break
	    default:
		call synerr ("Syntax error in ERRCHK declaration.")
	    }
	}
end

      subroutine putdec(n,w)
      integer n, w
      integer chars (20)
      integer i, nd
      integer itoc
      nd = itoc (n, chars, 20)
      i = nd + 1
23000 if (.not.(i .le. w))goto 23002
      call putc (32)
23001 i = i + 1
      goto 23000
23002 continue
      i = 1
23003 if (.not.(i .le. nd))goto 23005
      call putc (chars (i))
23004 i = i + 1
      goto 23003
23005 continue
      return
      end

#-h-  dostat			  156  local   12/01/80  15:53:50
# dostat - generate code for end of do statement
   include  defs

   subroutine dostat (lab)

   integer lab

   call indent (-1)
   call outcon (lab)
   call outcon (lab + 1)
   return
   end

c     subroutine h12 (mode,lpivot,l1,m,u,iue,up,c,ice,icv,ncv)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c
c     construction and/or application of a single
c     householder transformation..     q = i + u*(u**t)/b
c
c     mode    = 1 or 2	 to select algorithm  h1  or  h2 .
c     lpivot is the index of the pivot element.
c     l1,m   if l1 .le. m   the transformation will be constructed to
c	     zero elements indexed from l1 through m.	if l1 gt. m
c	     the subroutine does an identity transformation.
c     u(),iue,up    on entry to h1 u() contains the pivot vector.
c		    iue is the storage increment between elements.
c					on exit from h1 u() and up
c		    contain quantities defining the vector u of the
c		    householder transformation.   on entry to h2 u()
c		    and up should contain quantities previously computed
c		    by h1.  these will not be modified by h2.
c     c()    on entry to h1 or h2 c() contains a matrix which will be
c	     regarded as a set of vectors to which the householder
c	     transformation is to be applied.  on exit c() contains the
c	     set of transformed vectors.
c     ice    storage increment between elements of vectors in c().
c     icv    storage increment between vectors in c().
c     ncv    number of vectors in c() to be transformed. if ncv .le. 0
c	     no operations will be done on c().
c
      subroutine h12 (mode,lpivot,l1,m,u,iue,up,c,ice,icv,ncv)
      dimension u(iue,m), c(1)
      double precision sm,b
      one=1.
c
      if (0.ge.lpivot.or.lpivot.ge.l1.or.l1.gt.m) return
      cl=abs(u(1,lpivot))
      if (mode.eq.2) go to 60
c			     ****** construct the transformation. ******
	  do 10 j=l1,m
   10	  cl=amax1(abs(u(1,j)),cl)
      if (cl) 130,130,20
   20 clinv=one/cl
      sm=(dble(u(1,lpivot))*clinv)**2
	  do 30 j=l1,m
   30	  sm=sm+(dble(u(1,j))*clinv)**2
c			       convert dble. prec. sm to sngl. prec. sm1
      sm1=sm
      cl=cl*sqrt(sm1)
      if (u(1,lpivot)) 50,50,40
   40 cl=-cl
   50 up=u(1,lpivot)-cl
      u(1,lpivot)=cl
      go to 70
c	     ****** apply the transformation  i+u*(u**t)/b  to c. ******
c
   60 if (cl) 130,130,70
   70 if (ncv.le.0) return
      b=dble(up)*u(1,lpivot)
c			b  must be nonpositive here.  if b = 0., return.
c
      if (b) 80,130,130
   80 b=one/b
      i2=1-icv+ice*(lpivot-1)
      incr=ice*(l1-lpivot)
	  do 120 j=1,ncv
	  i2=i2+icv
	  i3=i2+incr
	  i4=i3
	  sm=c(i2)*dble(up)
	      do 90 i=l1,m
	      sm=sm+c(i3)*dble(u(1,i))
   90	      i3=i3+ice
	  if (sm) 100,120,100
  100	  sm=sm*b
	  c(i2)=c(i2)+sm*dble(up)
	      do 110 i=l1,m
	      c(i4)=c(i4)+sm*dble(u(1,i))
  110	      i4=i4+ice
  120	  continue
  130 return
      end

      REAL FUNCTION slSEP (A1, B1, A2, B2)
*+
*     - - - -
*      S E P
*     - - - -
*
*  Angle between two points on a sphere.
*
*  (single precision)
*
*  Given:
*     A1,B1    r     spherical coordinates of one point
*     A2,B2    r     spherical coordinates of the other point
*
*  (The spherical coordinates are [RA,Dec], [Long,Lat] etc, in radians.)
*
*  The result is the angle, in radians, between the two points.  It
*  is always positive.
*
*  Called:  slDSEP
*
*  Last revision:   7 May 2000
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL A1,B1,A2,B2

      DOUBLE PRECISION slDSEP



*  Use double precision version.
      slSEP = REAL(slDSEP(DBLE(A1),DBLE(B1),DBLE(A2),DBLE(B2)))

      END

*> \brief \b LSAME
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*      LOGICAL FUNCTION LSAME( CA, CB )
*
*     .. Scalar Arguments ..
*      CHARACTER          CA, CB
*     ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> LSAME returns .TRUE. if CA is the same letter as CB regardless of
*> case.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] CA
*> \verbatim
*> \endverbatim
*>
*> \param[in] CB
*> \verbatim
*>          CA and CB specify the single characters to be compared.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup auxOTHERauxiliary
*
*  =====================================================================
      LOGICAL FUNCTION LSAME( CA, CB )
*
*  -- LAPACK auxiliary routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      CHARACTER          CA, CB
*     ..
*
* =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC          ICHAR
*     ..
*     .. Local Scalars ..
      INTEGER            INTA, INTB, ZCODE
*     ..
*     .. Executable Statements ..
*
*     Test if the characters are equal
*
      LSAME = CA.EQ.CB
      IF( LSAME )
     $   RETURN
*
*     Now test for equivalence if both characters are alphabetic.
*
      ZCODE = ICHAR( 'Z' )
*
*     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
*     machines, on which ICHAR returns a value with bit 8 set.
*     ICHAR('A') on Prime machines returns 193 which is the same as
*     ICHAR('A') on an EBCDIC machine.
*
      INTA = ICHAR( CA )
      INTB = ICHAR( CB )
*
      IF( ZCODE.EQ.90 .OR. ZCODE.EQ.122 ) THEN
*
*        ASCII is assumed - ZCODE is the ASCII code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.97 .AND. INTA.LE.122 ) INTA = INTA - 32
         IF( INTB.GE.97 .AND. INTB.LE.122 ) INTB = INTB - 32
*
      ELSE IF( ZCODE.EQ.233 .OR. ZCODE.EQ.169 ) THEN
*
*        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.129 .AND. INTA.LE.137 .OR.
     $       INTA.GE.145 .AND. INTA.LE.153 .OR.
     $       INTA.GE.162 .AND. INTA.LE.169 ) INTA = INTA + 64
         IF( INTB.GE.129 .AND. INTB.LE.137 .OR.
     $       INTB.GE.145 .AND. INTB.LE.153 .OR.
     $       INTB.GE.162 .AND. INTB.LE.169 ) INTB = INTB + 64
*
      ELSE IF( ZCODE.EQ.218 .OR. ZCODE.EQ.250 ) THEN
*
*        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
*        plus 128 of either lower or upper case 'Z'.
*
         IF( INTA.GE.225 .AND. INTA.LE.250 ) INTA = INTA - 32
         IF( INTB.GE.225 .AND. INTB.LE.250 ) INTB = INTB - 32
      END IF
      LSAME = INTA.EQ.INTB
*
*     RETURN
*
*     End of LSAME
*
      END

      SUBROUTINE slVN (V, UV, VM)
*+
*     - - -
*      V N
*     - - -
*
*  Normalizes a 3-vector also giving the modulus (single precision)
*
*  Given:
*     V       real(3)      vector
*
*  Returned:
*     UV      real(3)      unit vector in direction of V
*     VM      real         modulus of V
*
*  If the modulus of V is zero, UV is set to zero as well
*
*  P.T.Wallace   Starlink   23 November 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL V(3),UV(3),VM

      INTEGER I
      REAL W1,W2


*  Modulus
      W1=0.0
      DO I=1,3
         W2=V(I)
         W1=W1+W2*W2
      END DO
      W1=SQRT(W1)
      VM=W1

*  Normalize the vector
      IF (W1.LE.0.0) W1=1.0
      DO I=1,3
         UV(I)=V(I)/W1
      END DO

      END

c function pbinom.f
c
c source
c   Bevington, page 31.
c
c purpose
c   evaluate binomial probability coefficient
c
c usage
c   result = pbinom (nobs, ntotal, prob)
c
c description of parameters
c   nobs   - number of items observed
c   ntotal - total number of items
c   prob   - probability of observing each item
c
c subroutines and function subprograms required
c   factor (n)
c      calculates n factorial for integers
c
      function pbinom (nobs,ntotal,prob)
1     notobs=ntotal-nobs
2     pbinom=factor(ntotal)/(factor(nobs)*factor(notobs))*
     *       (prob**nobs)*(1.-prob)**notobs
      return
      end

#-h-  domac			  326  local   12/01/80  15:53:49
# domac - install macro definition in table
   include  defs

   subroutine domac (argstk, i, j)
   integer argstk (ARGSIZE), i, j

   include COMMON_BLOCKS

   integer a2, a3

   if (j - i > 2) {
      a2 = argstk (i + 2)
      a3 = argstk (i + 3)
      call entdef (evalst (a2), evalst (a3), deftbl)	 # subarrays
      }
   return
   end

#-h-  outgo			  239  local   12/01/80  15:54:31
# outgo - output "goto	n"
   include  defs

subroutine outgo (n)

integer n
include COMMON_BLOCKS

       if (xfer == YES)
	   return
       call ogotos (n, NO)
end

      SUBROUTINE CFFTB (N,C,WSAVE)
      DIMENSION       C(*)       ,WSAVE(*)
      IF (N .EQ. 1) RETURN
      IW1 = N+N+1
      IW2 = IW1+N+N
      CALL CFFTB1 (N,C,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

#-h-  gnbtok			  237  local   12/01/80  15:54:09
# gnbtok - get nonblank token
   include  defs

   character function gnbtok (token, toksiz)
   character token (MAXTOK)
   integer toksiz

   include COMMON_BLOCKS

   character gettok

   call skpblk
   repeat {
      gnbtok = gettok (token, toksiz)
   } until (gnbtok != BLANK)

   return
   end

#-h-  eatup			 1137  local   12/01/80  15:53:50
# eatup - process rest of statement; interpret continuations
   include  defs

   subroutine eatup

   character ptoken (MAXTOK), t, token (MAXTOK)
   character gettok
   integer nlpar, equal
   include COMMON_BLOCKS
   string serror "error"

   nlpar = 0
   token(1) = EOS

   repeat {
       call outstr (token)
       t = gettok (token, MAXTOK)
   } until (t != BLANK & t != TAB)

   if (t == ALPHA) {				# is it a "call error" stmt?
      if (equal (token, serror) == YES) {
	 # call errorc (token)
	 # return

	 # ERROR statement is now simply error checked like any other
	 # external procedure, so that it may be used the same way.
	 ername = YES
	 }
      }
   goto 10

   repeat {
      t = gettok (token, MAXTOK)
10    if (t == SEMICOL | t == NEWLINE)
	 break
      if (t == RBRACE | t == LBRACE) {
	 call pbstr (token)
	 break
	 }
      if (t == EOF) {
	 call synerr ("unexpected EOF.")
	 call pbstr (token)
	 break
	 }
      if (t == COMMA | t == PLUS | t == MINUS | t == STAR |
      (t == SLASH & body == YES) |
       t == LPAREN | t == AND | t == BAR | t == BANG | t == TILDE |
       t == NOT | t == CARET | t == EQUALS | t == UNDERLINE) {
	 while (gettok (ptoken, MAXTOK) == NEWLINE)
	    ;
	 call pbstr (ptoken)
	 if (t == UNDERLINE)
	    token (1) = EOS
	 }
      if (t == LPAREN)
	 nlpar = nlpar + 1
      else if (t == RPAREN)
	 nlpar = nlpar - 1
      if (t == ALPHA)
	 call squash (token)
      call outstr (token)
      } until (nlpar < 0)

   if (nlpar != 0)
      call synerr ("unbalanced parentheses.")

   return
   end

      SUBROUTINE slRFCO ( HM, TDK, PMB, RH, WL, PHI, TLR, EPS,
     :                       REFA, REFB )
*+
*     - - - - - -
*      R F C O
*     - - - - - -
*
*  Determine the constants A and B in the atmospheric refraction
*  model dZ = A tan Z + B tan**3 Z.
*
*  Z is the "observed" zenith distance (i.e. affected by refraction)
*  and dZ is what to add to Z to give the "topocentric" (i.e. in vacuo)
*  zenith distance.
*
*  Given:
*    HM      d     height of the observer above sea level (metre)
*    TDK     d     ambient temperature at the observer (K)
*    PMB     d     pressure at the observer (millibar)
*    RH      d     relative humidity at the observer (range 0-1)
*    WL      d     effective wavelength of the source (micrometre)
*    PHI     d     latitude of the observer (radian, astronomical)
*    TLR     d     temperature lapse rate in the troposphere (K/metre)
*    EPS     d     precision required to terminate iteration (radian)
*
*  Returned:
*    REFA    d     tan Z coefficient (radian)
*    REFB    d     tan**3 Z coefficient (radian)
*
*  Called:  slRFRO
*
*  Notes:
*
*  1  Typical values for the TLR and EPS arguments might be 0.0065D0 and
*     1D-10 respectively.
*
*  2  The radio refraction is chosen by specifying WL > 100 micrometres.
*
*  3  The routine is a slower but more accurate alternative to the
*     slRFCQ routine.  The constants it produces give perfect
*     agreement with slRFRO at zenith distances arctan(1) (45 deg)
*     and arctan(4) (about 76 deg).  It achieves 0.5 arcsec accuracy
*     for ZD < 80 deg, 0.01 arcsec accuracy for ZD < 60 deg, and
*     0.001 arcsec accuracy for ZD < 45 deg.
*
*  P.T.Wallace   Starlink   22 May 2004
*
*  Copyright (C) 2004 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION HM,TDK,PMB,RH,WL,PHI,TLR,EPS,REFA,REFB

      DOUBLE PRECISION ATN1,ATN4,R1,R2

*  Sample zenith distances: arctan(1) and arctan(4)
      PARAMETER (ATN1=0.7853981633974483D0,
     :           ATN4=1.325817663668033D0)



*  Determine refraction for the two sample zenith distances
      CALL slRFRO(ATN1,HM,TDK,PMB,RH,WL,PHI,TLR,EPS,R1)
      CALL slRFRO(ATN4,HM,TDK,PMB,RH,WL,PHI,TLR,EPS,R2)

*  Solve for refraction constants
      REFA = (64D0*R1-R2)/60D0
      REFB = (R2-4D0*R1)/60D0

      END

      integer function wkday (month, day, year)
      integer month, day, year
      integer lmonth, lday, lyear
      lmonth = month - 2
      lday = day
      lyear = year
      if (.not.(lmonth .le. 0))goto 23000
      lmonth = lmonth + 12
      lyear = lyear - 1
23000 continue
      wkday = mod (lday + (26 * lmonth - 2) / 10 + lyear + lyear / 4 - 3
     *4, 7) + 1
      return
      end

C----------------------------------------------------------------------
        logical function fttrnn(value)

C       test if a R*4 value has a IEEE Not-a-Number (NaN) value
C       A NaN has all the exponent bits=1, and the fractional part not=0.  
C       The exponent field occupies bits 23-30,  (least significant bit = 0)
C       The mantissa field occupies bits 0-22

C       This routine also sets any underflow values to zero.

C       written by Wm Pence, HEASARC/GSFC, May 1992
C       modified Aug 1994 to handle all IEEE special values.

        integer value

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer compid
        common/ftcpid/compid
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

C       COMPID specifies what type of floating point word structure
C       is used on this machine, and determines how to test for NaNs.

C       COMPID value:
C           1   VAX or generic machine: simply test for NaNs with all bits set
C           2   like a decstation or alpha OSF/1, or IBM PC
C           3   SUN workstation, or IBM mainframe
C          -2305843009213693952   Cray (64-bit) machine

        fttrnn=.false.
	return

        if (compid .eq. 1)then
C           on the VAX we can assume that all NaNs will be set to all bits on
C           (which is equivalent to an integer with a value of -1) because
C           this is what the IEEE to VAX conversion MACRO program returns
            if (value .eq. -1)fttrnn=.true.
        else if (compid .gt. 1)then
C           the following test works on all other machines (except Cray)
C           the sign bit may be either 1 or 0 so have to test both possibilites.
C           Note: overflows and infinities are also flagged as NaNs.
            if (value .ge. 2139095039 .or. (value .lt. 0 .and. 
     1             value .ge. -8388609))then
                   fttrnn=.true.
            else if ((value .gt. 0 .and. value .le. 8388608) .or.
     1             value .le. -2139095040)then
C                  set underflows and denormalized values to zero
                   value=0
            end if            
        else
C           branch for the Cray:  COMPID stores the negative integer
C           which corresponds to the 3 most sig digits set to 1.   If these
C           3 bits are set in a floating point number, then it represents
C           a reserved value (i.e., a NaN)
            if (value .lt. 0 .and. value .ge. compid)fttrnn=.true. 
        end if
        end

      subroutine putint (n, w, fd)
      integer n, w
      integer fd
      integer chars (20)
      integer junk
      integer itoc
      junk = itoc (n, chars, 20)
      call putstr (chars, w, fd)
      return
      end

#-h-  relate			 1276  local   12/01/80  15:54:35
# relate - convert relational shorthands into long form
   include  defs

   subroutine relate (token, last)
   character token (ARB)
   integer last

   character ngetch

   integer length

   if (ngetch (token (2)) != EQUALS) {
      call putbak (token (2))
      token (3) = LETT
      }
   else
      token (3) = LETE
   token (4) = PERIOD
   token (5) = EOS
   token (6) = EOS # for .not. and .and.
   if (token (1) == GREATER)
      token (2) = LETG
   else if (token (1) == LESS)
      token (2) = LETL
   else if (token (1) == NOT | token (1) == BANG |
	    token (1) == CARET | token (1) == TILDE) {
      if (token (2) != EQUALS) {
	 token (3) = LETO
	 token (4) = LETT
	 token (5) = PERIOD
	 }
      token (2) = LETN
      }
   else if (token (1) == EQUALS) {
      if (token (2) != EQUALS) {
	 token (2) = EOS
	 last = 1
	 return
	 }
      token (2) = LETE
      token (3) = LETQ
      }
   else if (token (1) == AND) {
      token (2) = LETA
      token (3) = LETN
      token (4) = LETD
      token (5) = PERIOD
      }
   else if (token (1) == OR) {
      token (2) = LETO
      token (3) = LETR
      }
   else   # can't happen
      token (2) = EOS
   token (1) = PERIOD
   last = length (token)
   return
   end

      SUBROUTINE EXMPL1
C
C Define the data array.
C
      REAL YDRA(1001)
C
C Fill the data array.
C
      DO 101 I=1,1001
        X=FLOAT(I)/20.
        YDRA(I)=10.*(X-1.)*(X-11.)*(X-21.)*(X-31.)*(X-41.)*(X-51.)
     +                                                 +2.E7*(FRAN()-.5)
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the graph, using EZY.
C
      CALL EZY (YDRA,1001,'EXAMPLE 1 (EZY)$')
C
c     STOP
C
      END
      FUNCTION FRAN()
C
C Random-number generator.
C
      DATA X / 2.7182818 /
      SAVE X
      X=AMOD(9821.*X+.211327,1.)
      FRAN=X
      RETURN
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END
c
      SUBROUTINE EXMPL2
C
C Define the data arrays.
C
      REAL XDRA(4001),YDRA(4001)
C
C Fill the data arrays.
C
      DO 101 I=1,4001
        THETA=.0015707963267949*FLOAT(I-1)
        RHO=SIN(2.*THETA)+.05*SIN(64.*THETA)
        XDRA(I)=RHO*COS(THETA)
        YDRA(I)=RHO*SIN(THETA)
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,4001,'EXAMPLE 2 (EZXY)$')
C
c     STOP
C
      END
c
      SUBROUTINE EXMPL3
C
C Define the data array.
C
      REAL YDRA(100,2)
C
C Fill the data array.
C
      DO 101 I=1,100
        YDRA(I,1)=COS(3.14159265358979*FLOAT(I)/25.)*FLOAT(I)**2
        YDRA(I,2)=COS(3.14159265358979*FLOAT(I)/25.)*10.**(.04*FLOAT(I))
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the graph, using EZMY.
C
      CALL EZMY (YDRA,100,2,100,'EXAMPLE 3 (EZMY)$')
C
c     STOP
C
      END
c
      SUBROUTINE EXMPL4
C
C Define the data arrays.
C
      REAL XDRA(201),YDRA(201,10)
C
C Fill the data arrays.
C
      DO 102 I=1,201
        XDRA(I)=-1.+.02*FLOAT(I-1)
        IF (I.GT.101) XDRA(I)=2.-XDRA(I)
        DO 101 J=1,10
          YDRA(I,J)=FLOAT(J)*SQRT(1.000000000001-XDRA(I)**2)/10.
          IF (I.GT.101) YDRA(I,J)=-YDRA(I,J)
  101   CONTINUE
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,201,10,201,'EXAMPLE 4 (EZMXY)$')
C
c     STOP
C
      END
c
      SUBROUTINE EXMPL5
C
C Define the data arrays.
C
      REAL XDRA(401,6),YDRA(401,6)
C
C Compute required constants.
C
      PI=3.14159265358979
      PID200=PI/200.
      PITTWO=2.*PI
      PIT2D3=2.*PI/3.
      PIT4D3=4.*PI/3.
      RADOSC=SQRT(3.)/3.
      RADOLC=SQRT(3.)/2.
      BSSCLL=ATAN(SQRT(12.)/6.)
      BSSCUL=ATAN(SQRT(143.)/7.)
      BSLCLL=ATAN(SQRT(143.)/17.)
      BSLCUL=ATAN(SQRT(2.0))
C
C Fill the data arrays.
C
      DO 101 I=1,401
        THETA=PID200*FLOAT(I-1)
        XDRA(I,1)=   -.5+RADOSC*COS(THETA)
        YDRA(I,1)=       RADOSC*SIN(THETA)
        IF (ABS(THETA       ).GE.BSSCLL.AND.
     +      ABS(THETA       ).LE.BSSCUL) XDRA(I,1)=1.E36
        IF (ABS(THETA-PITTWO).GE.BSSCLL.AND.
     +      ABS(THETA-PITTWO).LE.BSSCUL) XDRA(I,1)=1.E36
        XDRA(I,2)=    .5+RADOSC*COS(THETA)
        YDRA(I,2)=       RADOSC*SIN(THETA)
        IF (ABS(THETA-PIT2D3).GE.BSSCLL.AND.
     +      ABS(THETA-PIT2D3).LE.BSSCUL) XDRA(I,2)=1.E36
        XDRA(I,3)=       RADOSC*COS(THETA)
        YDRA(I,3)=RADOLC+RADOSC*SIN(THETA)
        IF (ABS(THETA-PIT4D3).GE.BSSCLL.AND.
     +      ABS(THETA-PIT4D3).LE.BSSCUL) XDRA(I,3)=1.E36
        XDRA(I,4)=   -.5+RADOLC*COS(THETA)
        YDRA(I,4)=       RADOLC*SIN(THETA)
        IF (ABS(THETA       ).GE.BSLCLL.AND.
     +      ABS(THETA       ).LE.BSLCUL) XDRA(I,4)=1.E36
        IF (ABS(THETA-PITTWO).GE.BSLCLL.AND.
     +      ABS(THETA-PITTWO).LE.BSLCUL) XDRA(I,4)=1.E36
        XDRA(I,5)=    .5+RADOLC*COS(THETA)
        YDRA(I,5)=       RADOLC*SIN(THETA)
        IF (ABS(THETA-PIT2D3).GE.BSLCLL.AND.
     +      ABS(THETA-PIT2D3).LE.BSLCUL) XDRA(I,5)=1.E36
        XDRA(I,6)=       RADOLC*COS(THETA)
        YDRA(I,6)=RADOLC+RADOLC*SIN(THETA)
        IF (ABS(THETA-PIT4D3).GE.BSLCLL.AND.
     +      ABS(THETA-PIT4D3).LE.BSLCUL) XDRA(I,6)=1.E36
  101 CONTINUE
C
C Specify subscripting of XDRA and YDRA.
C
      CALL AGSETI ('ROW.',2)
C
C Make sure grid shape is such that one unit in x = one unit in y.
C
      CALL AGSETF ('GRID/SHAPE.',2.)
C
C Turn off background, then turn labels back on.
C
      CALL AGSETF ('BACKGROUND.',4.)
      CALL AGSETI ('LABEL/CONTROL.',2)
C
C Turn off left label.
C
      CALL AGSETC ('LABEL/NAME.','L')
      CALL AGSETI ('LABEL/SUPPRESSION FLAG.',1)
C
C Change text of bottom label.
C
      CALL AGSETC ('LABEL/NAME.','B')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','PURITY, BODY, AND FLAVOR$')
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,401,6,401,'EXAMPLE 5 (EZMXY)$')
C
c     STOP
C
      END
c
      SUBROUTINE EXMPL6
C
C Define the data arrays.
C
      REAL XDRA(501),YDRA(501)
C
      CHARACTER*35 GLAB
      CHARACTER*23 BACK(4)
      CHARACTER*12 LNLG(4)
      character*1  tmp
C Define the graph-window parameter array.
C
      REAL GWND (4,4)
C
      DATA (GWND(I,1),I=1,4) / 0.0 , 0.5 , 0.5 , 1.0 /
      DATA (GWND(I,2),I=1,4) / 0.5 , 1.0 , 0.5 , 1.0 /
      DATA (GWND(I,3),I=1,4) / 0.0 , 0.5 , 0.0 , 0.5 /
      DATA (GWND(I,4),I=1,4) / 0.5 , 1.0 , 0.0 , 0.5 /
C
C Define variables used in setting up informational labels on the graph.
C
C
      DATA BACK(1) / '(PERIMETER BACKGROUND)$' /
      DATA BACK(2) / '(GRID BACKGROUND)$     ' /
      DATA BACK(3) / '(HALF-AXIS BACKGROUND)$' /
      DATA BACK(4) / '(NO BACKGROUND)$       ' /
C
      DATA LNLG(1) / 'LINEAR$' /
      DATA LNLG(2) / 'LOGARITHMIC$' /
C
C Fill the data arrays.
C
      DO 101 I=1,501
        THETA=.031415926535898*FLOAT(I-1)
        XDRA(I)=500.+.9*FLOAT(I-1)*COS(THETA)
        YDRA(I)=500.+.9*FLOAT(I-1)*SIN(THETA)
  101 CONTINUE
C
C
C Do four graphs on the same frame, using different backgrounds.
C
      DO 102 IGRF = 1,4
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Position the graph window.
C
        CALL AGSETP ('GRAPH WINDOW.',GWND(1,IGRF),4)
C
C Declare the background type.
C
        CALL AGSETI ('BACKGROUND TYPE.',IGRF)
C
C Setting the background type may have turned the informational labels
C off.  In that case, turn them back on.
C
        IF (IGRF.EQ.4) CALL AGSETI ('LABEL/CONTROL.',2)
C
C Set up parameters determining the linear/log nature of the axes.
C
        ILLX=(IGRF-1)/2
        ILLY=MOD(IGRF-1,2)
C
C Declare the linear/log nature of the graph.
C
        CALL AGSETI ('X/LOGARITHMIC.',ILLX)
        CALL AGSETI ('Y/LOGARITHMIC.',ILLY)
C
C Change the x- and y-axis labels to reflect the linear/log nature of
C the graph.
C
        CALL AGSETC ('LABEL/NAME.','B')
        CALL AGSETI ('LINE/NUMBER.',-100)
        CALL AGSETC ('LINE/TEXT.',LNLG(ILLX+1))
C
        CALL AGSETC ('LABEL/NAME.','L')
        CALL AGSETI ('LINE/NUMBER.',100)
        CALL AGSETC ('LINE/TEXT.',LNLG(ILLY+1))
C
C Set up the label for the top of the graph.
C
c     WRITE (GLAB,1001) IGRF,BACK(IGRF)
      glab(1:35) = 'EXAMPLE 6-                         '
      glab(11:11) = char (igrf + ichar ('0'))
      glab(13:35) = back (igrf)
C
C Draw the graph, using EZXY.
C
        CALL EZXY (XDRA,YDRA,501,GLAB)
C
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
c     STOP
C
C Format for encode.
C
c1001 FORMAT ('EXAMPLE 6-',I1,' ',A23)
      END
c
      SUBROUTINE EXMPL7
C
C Define the data arrays and the dash-pattern array.
C
      REAL XDRA(101),YDRA(101,9)
      CHARACTER*28 DSHP(9)
C
C Declare the type of the dash-pattern-name generator.
C
      CHARACTER*16 AGDSHN
C
C Fill the data arrays and the dash pattern array.
C
      DO 101 I=1,101
        XDRA(I)=-90.+1.8*FLOAT(I-1)
  101 CONTINUE
C
      DO 103 J=1,9
c       WRITE (DSHP(J),1001) J
        dshp(j) = '$$$$$$$$$$$$$$$$$$$$$ J =   '
	dshp(j)(27:27) = char (j + ichar ('0'))
        FJ=J
        DO 102 I=1,101
          YDRA(I,J)=3.*FJ-(FJ/2700.)*XDRA(I)**2
  102   CONTINUE
  103 CONTINUE
C
C Turn on windowing.  (Some curves run outside the curve window.)
C
      CALL AGSETI ('WINDOWING.',1)
C
C Move the edges of the curve window (grid).
C
      CALL AGSETF ('GRID/LEFT.'  ,.10)
      CALL AGSETF ('GRID/RIGHT.' ,.90)
      CALL AGSETF ('GRID/BOTTOM.',.10)
      CALL AGSETF ('GRID/TOP.'   ,.85)
C
C Set the x and y minimum and maximum.
C
      CALL AGSETF ('X/MINIMUM.',-90.)
      CALL AGSETF ('X/MAXIMUM.',+90.)
      CALL AGSETF ('Y/MINIMUM.',  0.)
      CALL AGSETF ('Y/MAXIMUM.', 18.)
C
C Set left axis parameters.
C
      CALL AGSETI ('LEFT/MAJOR/TYPE.',1)
      CALL AGSETF ('LEFT/MAJOR/BASE.',3.)
      CALL AGSETI ('LEFT/MINOR/SPACING.',2)
C
C Set right axis parameters.
C
      CALL AGSETI ('RIGHT/FUNCTION.',1)
      CALL AGSETF ('RIGHT/NUMERIC/TYPE.',1.E36)
C
C Set bottom axis parameters.
C
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',1)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',15.)
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',2)
C
C Set top axis parameters.
C
      CALL AGSETI ('TOP/FUNCTION.',1)
      CALL AGSETF ('TOP/NUMERIC/TYPE.',1.E36)
C
C Set up the dash patterns to be used.
C
      CALL AGSETI ('DASH/SELECTOR.',9)
      CALL AGSETI ('DASH/LENGTH.',28)
      DO 104 I=1,9
        CALL AGSETC (AGDSHN(I),DSHP(I))
  104 CONTINUE
C
C Set up the left label.
C
      CALL AGSETC ('LABEL/NAME.','L')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.','HEIGHT (KILOMETERS)$')
C
C Set up the right label.
C
      CALL AGSETC ('LABEL/NAME.','R')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','PRESSURE (TONS/SQUARE FURLONG)$')
C
C Set up the bottom labels.
C
      CALL AGSETC ('LABEL/NAME.','B')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','LATITUDE (DEGREES)$')
C
      CALL AGSETC ('LABEL/NAME.','SP')
      CALL AGSETF ('LABEL/BASEPOINT/X.',.000001)
      CALL AGSETF ('LABEL/BASEPOINT/Y.',0.)
      CALL AGSETF ('LABEL/OFFSET/Y.',-.015)
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','SP$')
C
      CALL AGSETC ('LABEL/NAME.','NP')
      CALL AGSETF ('LABEL/BASEPOINT/X.',.999999)
      CALL AGSETF ('LABEL/BASEPOINT/Y.',0.)
      CALL AGSETF ('LABEL/OFFSET/Y.',-.015)
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','NP$')
C
C Set up the top label.
C
      CALL AGSETC ('LABEL/NAME.','T')
      CALL AGSETI ('LINE/NUMBER.',80)
      CALL AGSETC ('LINE/TEXT.','DISTANCE FROM EQUATOR (MILES)$')
      CALL AGSETI ('LINE/NUMBER.',90)
      CALL AGSETC ('LINE/TEXT.',' $')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.','LINES OF CONSTANT INCRUDESCENCE$')
      CALL AGSETI ('LINE/NUMBER.',110)
      CALL AGSETC ('LINE/TEXT.','EXAMPLE 7 (EZMXY)$')
C
C Set up centered (box 6) label.
C
      CALL AGSETC ('LABEL/NAME.','EQUATOR')
      CALL AGSETI ('LABEL/ANGLE.',90)
      CALL AGSETI ('LINE/NUMBER.',0)
      CALL AGSETC ('LINE/TEXT.','EQUATOR$')
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,101,9,101,0)
C
c     STOP
C
C Format for encode above.
C
c1001 FORMAT ('$$$$$$$$$$$$$$$$$$$$$''J''=''',I1,'''')
C
      END
c
      SUBROUTINE EXMPL8
C
C Define the data arrays.
C
      REAL XDRA(101),YDRA(4,101)
C
C Fill the data arrays.
C
      DO 101 I=1,101
        XDRA(I)=-3.14159265358979+.062831853071796*FLOAT(I-1)
  101 CONTINUE
C
      DO 103 I=1,4
        FLTI=I
        BASE=2.*FLTI-1.
        DO 102 J=1,101
          YDRA(I,J)=BASE+.75*SIN(-3.14159265358979+.062831853071796*
     +                                                  FLTI*FLOAT(J-1))
  102   CONTINUE
  103 CONTINUE
C
C Change the line-end character to a period.
C
      CALL AGSETC ('LINE/END.','.')
C
C Specify labels for x and y axes.
C
      CALL ANOTAT ('SINE FUNCTIONS OF T.','T.',0,0,0,0)
C
C Use a half-axis background.
C
      CALL AGSETI ('BACKGROUND.',3)
C
C Move x axis to the zero point on the y axis.
C
      CALL AGSETF ('BOTTOM/INTERSECTION/USER.',0.)
C
C Specify base value for spacing of major ticks on x axis.
C
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',1.)
C
C Run major ticks on x axis to edge of curve window.
C
      CALL AGSETF ('BOTTOM/MAJOR/INWARD.',1.)
      CALL AGSETF ('BOTTOM/MAJOR/OUTWARD.',1.)
C
C Position x axis minor ticks.
C
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',9)
C
C Run the y axis backward.
C
      CALL AGSETI ('Y/ORDER.',1)
C
C Run plots full-scale in y.
C
      CALL AGSETI ('Y/NICE.',0)
C
C Have AUTOGRAPH scale x and y data the same.
C
      CALL AGSETF ('GRID/SHAPE.',.01)
C
C Use the alphabetic set of dashed-line patterns.
C
      CALL AGSETI ('DASH/SELECTOR.',-1)
C
C Tell AUTOGRAPH how the data arrays are dimensioned.
C
      CALL AGSETI ('ROW.',-1)
C
C Reverse the roles of the x and y arrays.
C
      CALL AGSETI ('INVERT.',1)
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Draw the curves.
C
      CALL EZMXY (XDRA,YDRA,4,4,101,'EXAMPLE 8.')
C
c     STOP
C
      END
c
C      SUBROUTINE EXMPL9
CC
CC Define the data arrays.
CC
C      DIMENSION XDAT(400),YDAT(400)
CC
CC Fill the data arrays.
CC
C      DO 101 I=1,400
C        XDAT(I)=(FLOAT(I)-1.)/399.
C  101 CONTINUE
CC
C      CALL GENDAT (YDAT(  1),200,200,1,3,3,+.01,+10.)
C      CALL GENDAT (YDAT(201),200,200,1,3,3,-10.,-.01)
CC
CC The y data ranges over both positive and negative values.  It is
CC desired that both ranges be represented on the same graph and that
CC each be shown logarithmically, ignoring values in the range -.01 to
CC +.01, in which we're not interested.  First we map each y datum into
CC its absolute value (.01 if the absolute value is too small).  Then we
CC take the base-10 logarithm, add 2.0001 (so as to be sure of getting a
CC positive number), and re-attach the original sign.  We can plot the
CC resulting y data on a linear y axis.
CC
C      DO 102 I=1,400
C        YDAT(I)=SIGN(ALOG10(AMAX1(ABS(YDAT(I)),.01))+2.0001,YDAT(I))
C  102 CONTINUE
CC
CC In order that the labels on the y axis should show the original values
CC of the y data, we change the user-system-to-label-system mapping on
CC both y axes and force major ticks to be spaced logarithmically in the
CC label system (which will be defined by the subroutine AGUTOL in such
CC a way as to re-create numbers in the original range).
CC
C      CALL AGSETI ('LEFT/FUNCTION.',1)
C      CALL AGSETI ('LEFT/MAJOR/TYPE.',2)
CC
C      CALL AGSETI ('RIGHT/FUNCTION.',1)
C      CALL AGSETI ('RIGHT/MAJOR/TYPE.',2)
CC
CC Change the label on the left axis to reflect what's going on.
CC
C      CALL AGSETC ('LABEL/NAME.','L')
C      CALL AGSETI ('LINE/NUMBER.',100)
C      CALL AGSETC ('LINE/TEXT.','LOG SCALING, POSITIVE AND NEGATIVE$')
CC
CC Draw a boundary around the edge of the plotter frame.
CC
Cc     CALL BNDARY
CC
CC Draw the curve.
CC
C      CALL EZXY (XDAT,YDAT,400,'EXAMPLE 9$')
CC
Cc     STOP
CC
C      END
Cc
C      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
CC
CC This is a routine to generate test data for two-dimensional graphics
CC routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
CC the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
CC of data having approximately "MLOW" lows and "MHGH" highs, a minimum
CC value of exactly "DLOW" and a maximum value of exactly "DHGH".
CC
CC "MLOW" and "MHGH" are each forced to be greater than or equal to 1
CC and less than or equal to 25.
CC
CC The function used is a sum of exponentials.
CC
C      DIMENSION DATA(IDIM,1),CCNT(3,50)
CC
C      FOVM=9./FLOAT(M)
C      FOVN=9./FLOAT(N)
CC
C      NLOW=MAX0(1,MIN0(25,MLOW))
C      NHGH=MAX0(1,MIN0(25,MHGH))
C      NCNT=NLOW+NHGH
CC
C      DO 101 K=1,NCNT
C        CCNT(1,K)=1.+(FLOAT(M)-1.)*FRAN()
C        CCNT(2,K)=1.+(FLOAT(N)-1.)*FRAN()
C        IF (K.LE.NLOW) THEN
C          CCNT(3,K)=-1.
C        ELSE
C          CCNT(3,K)=+1.
C        END IF
C  101 CONTINUE
CC
C      DMIN=+1.E36
C      DMAX=-1.E36
C      DO 104 J=1,N
C        DO 103 I=1,M
C          DATA(I,J)=.5*(DLOW+DHGH)
C          DO 102 K=1,NCNT
C            DATA(I,J)=DATA(I,J) + .5 * (DHGH-DLOW) * CCNT(3,K) *
C     +                EXP( - ( ( FOVM*(FLOAT(I)-CCNT(1,K)) )**2 +
C     +                         ( FOVN*(FLOAT(J)-CCNT(2,K)) )**2   ) )
C  102     CONTINUE
C          DMIN=AMIN1(DMIN,DATA(I,J))
C          DMAX=AMAX1(DMAX,DATA(I,J))
C  103   CONTINUE
C  104 CONTINUE
CC
C      DO 106 J=1,N
C        DO 105 I=1,M
C          DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
C  105   CONTINUE
C  106 CONTINUE
CC
C      RETURN
CC
C      END
Cc
C      SUBROUTINE XMPL10
C      RETURN
C      END
Cc
      SUBROUTINE XMPL11
C
C Create a sort of histogram.
C
      REAL XDRA(249),YDRA(249),WORK(204),IWRK(204)
C
C Fill the data arrays.  First, we define the histogram outline.  This
C will be used in the call to FILL which fills in the area under the
C histogram.
C
      XDRA(1)=0.
      YDRA(1)=0.
C
      DO 101 I=2,100,2
        XDRA(I  )=XDRA(I-1)
        YDRA(I  )=EXP(-16.*(FLOAT(I/2)/50.-.51)**2)+.1*FRAN()
        XDRA(I+1)=XDRA(I-1)+.02
        YDRA(I+1)=YDRA(I)
  101 CONTINUE
C
      XDRA(102)=1.
      YDRA(102)=0.
C
C Then, we define lines separating the vertical boxes from each other.
C
      NDRA=102
C
      DO 102 I=3,99,2
        XDRA(NDRA+1)=1.E36
        YDRA(NDRA+1)=1.E36
        XDRA(NDRA+2)=XDRA(I)
        YDRA(NDRA+2)=0.
        XDRA(NDRA+3)=XDRA(I)
        YDRA(NDRA+3)=AMIN1(YDRA(I),YDRA(I+1))
        NDRA=NDRA+3
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,249,'EXAMPLE 11 (HISTOGRAM)$')
C
C Use the XLIB routine FILL to fill the area defined by the data.  Note
C that FILL is not a part of the AUTOGRAPH package.
C
c     CALL FILLOP ('AN',45)
c    CALL FILLOP ('SP',128)
c    CALL FILL (XDRA,YDRA,102,WORK,204,IWRK,204)
C
C Advance the frame.
C
c     CALL FRAME
C
c     STOP
C
      END
c
      SUBROUTINE EXMPLF
C
C Define the data array.
C
      DIMENSION XYCD(226)
C
C Fill the data array.
C
c     READ 1001 , XYCD
C
      DO 101 I=1,226
        IF (XYCD(I).EQ.1.E36) GO TO 101
        XYCD(I)=2.**((XYCD(I)-15.)/2.5)
  101 CONTINUE
C
C Specify log/log plot.
C
      CALL DISPLA (0,0,4)
C
C Bump the line-maximum parameter past 42.
C
      CALL AGSETI ('LINE/MAXIMUM.',50)
C
C Specify x- and y-axis labels, grid background.
C
      CALL ANOTAT ('LOGARITHMIC, BASE 2, EXPONENTIAL LABELING$',
     +             'LOGARITHMIC, BASE 2, NO-EXPONENT LABELING$',2,0,0,0)
C
C Specify the graph label.
C
      CALL AGSETC ('LABEL/NAME.','T')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.','FINAL EXAMPLE$')
C
C Specify x-axis ticks and labels.
C
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',3)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',2.)
      CALL AGSETI ('BOTTOM/NUMERIC/TYPE.',2)
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',4)
c     CALL AGSETI ('BOTTOM/MINOR/PATTERN.',125252B)
C
C Specify y-axis ticks and labels.
C
      CALL AGSETI ('LEFT/MAJOR/TYPE.',3)
      CALL AGSETF ('LEFT/MAJOR/BASE.',2.)
      CALL AGSETI ('LEFT/NUMERIC/TYPE.',3)
      CALL AGSETI ('LEFT/MINOR/SPACING.',4)
c     CALL AGSETI ('LEFT/MINOR/PATTERN.',125252B)
C
C Compute secondary control parameters.
C
      CALL AGSTUP (XYCD(1),1,0,113,2,XYCD(2),1,0,113,2)
C
C Draw the background.
C
      CALL AGBACK
C
C Draw the curve twice to make it darker.
C
      CALL AGCURV (XYCD(1),2,XYCD(2),2,113,1)
      CALL AGCURV (XYCD(1),2,XYCD(2),2,113,1)
C
C Draw a boundary around the edge of the plotter frame.
C
c     CALL BNDARY
C
C Advance the frame.
C
c     CALL FRAME
C
c     STOP
C
C Format.
C
c1001 FORMAT (14E5.0)
C
      END
C  1.8  2.1  2.7         1.6  4.2  1.5  5.7  1.9  6.3  2.9  6.5  4.7  6.0  6.7
C  5.6  8.6  5.4        10.7  5.6 13.1  4.8 11.2  3.7  9.7 1E36 1E36  7.0  8.2
C  7.7 10.6  8.2        12.6  8.2 14.3  8.0 15.3  7.7 15.6  7.5 15.1  7.4 14.0
C  7.6 12.3  7.7        10.7  7.9  8.9  8.2  7.3  8.5  4.6  8.5  7.3  8.6  9.3
C  8.8 10.2  9.1        10.5  9.4 10.1  9.6  9.1  9.9  7.8 10.3  6.9 11.1  7.0
C 11.7  7.8 12.0         8.6 12.3 10.0 12.5 11.5 12.4 12.7 12.2 13.0 11.9 12.6
C 11.7 11.7 11.6        10.5 11.7  9.3 12.0  8.6 12.5  8.6 13.0  9.0 13.8 10.1
C 14.3 11.1 1E36        1E36 18.5 23.4 18.2 23.5 17.8 23.2 17.2 22.6 16.8 21.8
C 16.0 20.2 15.8        19.5 16.0 19.3 16.6 19.6 17.8 20.6 17.3 19.1 16.9 17.3
C 16.6 16.0 16.6        14.5 16.8 13.7 17.1 13.1 17.8 13.2 18.4 14.0 19.2 15.5
C 19.8 16.8 20.3        18.0 20.9 20.1 21.1 18.9 21.1 17.4 21.1 18.9 21.2 19.7
C  1.5 20.5 21.8        20.8 22.0 20.4 22.1 19.6 22.3 18.7 22.6 18.4 23.1 18.9
C 23.6 20.0 24.1        21.7 24.7 22.9 25.3 23.9 24.7 22.9 24.4 21.6 24.4 20.6
C 24.7 20.2 25.2        20.7 25.6 21.5 26.0 22.9 26.4 24.5 26.7 25.9 26.8 27.9
C 26.6 30.0 26.4        30.3 26.2 30.0 25.7 28.0 25.5 26.1 25.3 24.9 25.3 23.9
C 25.4 22.9 25.9        22.5 26.6 22.4 27.4 23.1 28.2 24.0 29.0 25.0 30.1 26.4
C 1E36 1E36

C----------------------------------------------------------------------
        subroutine ftd2f(val,dec,cval,status)

C       convert double precision value to F20.* format character string
C       NOTE: some precision may be lost
C       val     d  input value to be converted 
C       dec     i  number of decimal places to display in output string
C       cval    c  output character string
C       status  i  output error status (0 = OK)

        double precision val
        integer dec,status
        character*20 cval,form*8

        if (status .gt. 0)return

        if (dec .ge. 0 .and. dec .le. 9)then
                write(form,2000)dec
2000            format('(f20.',i1,')')
        else if (dec .ge. 10 .and. dec .lt.18)then
                write(form,2001)dec
2001            format('(f20.',i2,')')
        else
C               illegal number of decimal places were specified
                status=411
                call ftpmsg('Error in FTD2F: number of decimal places '
     &                      //'is less than 0 or greater than 18.')
                return
        endif

        write(cval,form,err=900)val
        if (cval(1:1) .eq. '*')go to 900
        return
900     status=402
        call ftpmsg('Error in FTD2F converting double to F20. string.')
        end

      subroutine z8zpii
c+kpno
c
c All data statements changed to runtime assignment statements; routine
c changed from block data to subroutine.
c
c-kpno
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c
      common /nsplt1/  iclrfb ,isetfb ,ibpw   ,ifwd
c
c      variables                 use
c      ---------                 ---
c
c mmajx,mmajy,mminx,   gridal arguments stored here so they will be in a
c mminy,mxlab,mylab,   known order for insertion in the instruction
c mflg                 stream only when ultracompact metacode is
c                      being produced.
c
c mtype                scaling type of the most recent set call
c
c mx,my                plotter address of the pen location
c
c mxa,mya,mxb,myb      plotter address corresponding to the first four
c                      arguments of the most recent set call.
c
c mtypex,mtypey        a decoding of mtype-- 0 = linear, 1 = log
c
c xxa,yya,xxb,yyb,     exact copies of the first eight parameters
c xxc,yyc,xxd,yyd      of the most recent set call
c
c xfactr,yfactr,xadd,  numbers computed from the most recent set call
c yadd                 arguments so that real valued coordinates can
c                      be translated to integers by
c                       mx = xfactr*xx + xadd
c                      or
c                       mx = xfactr*alog10(xx) + xadd
c                      and similarly for y.
c
c xx,yy                most recent coordinate input to the plot package
c
c mfmtx,mfmty,mumx,    most recent labmod inputs except that mxdec = 0
c mumy,msizx,msizy,    and mydec = 0 are decoded and mxdec = 1 and
c mxdec,mydec,mxor     mydec = 1 become 0.
c
c mop(i),mname(i)      option names are given in mname and their
c                      current values in mop
c
c mxold,myold,mxmax,   all used for increment instructions only.  mxold
c mymax,mxfac,myfac    and myold are the plotter coordinates of the
c                      previous point, mxmax and mymax are the greatest
c                      distance an increment can move, and mxfac and
c                      myfac are the number of plotter units per
c                      increment unit (generally 1, but can be more if
c                      compaction is important and high resolution is
c                      not).
c
c modef                = 0 flash routines have not been used
c                      = 1 most recent flash call was to flash1
c                          (we are between flash1 and flash2 calls
c                          and the instructions should be put in the
c                          users buffer)
c                      = 2 flash1 call has been closed with a
c                          flash2 call
c                      =-3 flash3 has been entered, but not exited,
c                          i.e., flash3 is dumping a user buffer.
c                      = 3 most recent flash activity is a completed
c                          flash3 call.
c                      = 4 most recent flash call was to flash4
c
c mf2er                = 0 no flash buffer overflow
c                      = n counts the number of times the buffer
c                          was reused so the required size can be
c                          estimated
c
c mshftx,mshfty        the power of two of the ratio between the
c                      resolution of the metacode address and the
c                      resolution the user is working in.  in the
c                      default case, the user assumes the plotter
c                      is 1024 by 1024 (1024 = 2 **10).  metacode
c                      addresses have 15 bits, so their capacity is
c                      32,768.  thus, the default for mshftx and mshfty
c                      is 5, and user integer coordinates are left
c                      shifted 5 to make plotter addresses.
c
c mmgrx,mmgry,mmnrx,   tick mark lengths (positive values point in)
c mmnry
c
c mcrout               number of metacode records that have been put
c                      out via preout.
c
c mflcnt               used to count the number of flushb calls since
c                      last mbprs initialization.  it is used to avoid
c                      empty records which could otherwise be put out.
c
c mfrend               frame sets to 1 to indicate last output call of a
c                      frame,  and resets to zero before returning.
c
c mfrlst               preout manipulates, based on mfrend, so that it
c                      knows when a record is the first of a new frame.
c
c mjxmin,mjymin,       used to keep track of the range of the plotting
c mjxmax,mjymax        address on the frame being created
c
c mnxsto,mnysto        used to hold mjxmin,... after flash1 call, and
c mxxsto,mxysto        restore them after flash2.  mjxmin,... are ac-
c                      cumulated anew during flash saving, and stored
c                      in user flash buffer after flash2 call.
c
c mpair1,mpair2        two 16-bit pairs used to initialize each output
c                      record, so that preout may format first 32 bits.
c                      they are actually put into mbprs at proper times
c
c mprint               unit number for printing error messages too
c                      extensive to be handled by uliber
c
c msybuf               buffer to hold up to a few hundred metacode
c                      instructions
c
c msblen               word length of msybuf.
c
c mncpw                the number of characters per word on the host
c                      computer
c
c minst                holds instruction op-code for the instruction
c                      being formed
c
c mbufa                contains the address of the buffer for the
c                      metacode instructions, either loci(msybuf) or
c                      loci(user buffer) from a flash1 call
c
c mbuflu               the number of words of the buffer pointed to by
c                      mbufa that have been filled with metacode or
c                      dd80 instructions
c
c mfwa,mlwa            contains the first word address and the last
c                      word address for the flash buffers
c
c mipair,mbprs         mbprs is used to store byte pairs of metacode
c                      until they can be packed in an integral number
c                      of words and placed in the buffer pointed to by
c                      mbufa.  mipair tells how much of mbprs has been
c                      used.
c
c mbufl                the length of the buffer pointed to by mbufa.
c
c munit                unit number for writing metacode
c
c small                smallest positive number on the host computer.
c                      this is used when nonpositive numbers are plotted
c                      with log scaling.
c
c
      dimension mfssx(2), mfssy(2), mnsss(9)
c
      data mfssx(1)/4h(e10/
      data mfssx(2)/4h.3) /
      data mfssy(1)/4h(e10/
      data mfssy(2)/4h.3) /
c
      data mnsss(1)/4hcase/
      data mnsss(2)/4hintn/
      data mnsss(3)/4horen/
      data mnsss(4)/4hcsiz/
      data mnsss(5)/4hfont/
      data mnsss(6)/4hdpat/
      data mnsss(7)/4hssiz/
      data mnsss(8)/4hcent/
      data mnsss(9)/4hcolr/
c
      do 10 i = 1, 2
	  mfmtx(i) = mfssx(i)
10    continue
      do 11 i = 1, 2
	  mfmty(i) = mfssy(i)
11    continue
      do 12 i = 1, 9
	  mname(i) = mnsss(i)
12    continue
c
c     data iclrfb/0/, isetfb/0/, ibpw/32/, ifwd/1/
      iclrfb   = 0
      isetfb   = 0
      ibpw     = 32
      ifwd     = 1
c
c     data mtype,mtypex,mtypey/1,0,0/
      mtype    = 1
      mtypex   = 0
      mtypey   = 0
c
c     data mx,my/0,0/
      mx       = 0
      my       = 0
c
c     data xxa,yya,xxb,yyb/0.,0.,1.,1./
      xxa      = 0.0
      yya      = 0.0
      xxb      = 1.0
      yyb      = 1.0
c
c     data xxc,yyc,xxd,yyd/0.,0.,1.,1./
      xxc      = 0.0
      yyc      = 0.0
      xxd      = 1.0
      yyd      = 1.0
c
c     data mxa,mya,mxb,myb/1,1,32767,32767/
      mxa      = 1
      mya      = 32767
      mxb      = 1
      mxb      = 32767
c
c     data xfactr,yfactr/32767.,32767./
      xfactr   = 32767.
      yfactr   = 32767.
c
c     data xadd,yadd/1.,1./
      xadd     = 1.0
      yadd     = 1.0
c
c     data mumx,mumy/10,10/
      mumx     = 10
      mumy     = 10
c
c     data msizx,msizy/0,0/
      msizx    = 0
      msizy    = 0
c
c     data mxdec,mydec/655,655/
      mxdec    = 655
      mydec    = 655
c
c     data mxor/0/
      mxor     = 0
c
c     data mop(1)/0/
c     data mop(2)/204/
c     data mop(3)/0/
c     data mop(4)/128/
c     data mop(5)/0/
c     data mop(6)/65535/
c     data mop(7)/8/
c     data mop(8)/0/
c     data mop(9)/0/
      mop(1)   = 0
      mop(2)   = 204
      mop(3)   = 0
      mop(4)   = 128
      mop(5)   = 0
      mop(6)   = 65535
      mop(7)   = 8
      mop(8)   = 0
      mop(9)   = 0
c
c     data mxold,myold/-9999,-9999/
      mxold    = -9999
      myold    = -9999
c
c     data mxmax,mymax/31,31/
      mxmax    = 31
      mymax    = 31
c
c     data mxfac,myfac/1,1/
      mxfac    = 1
      myfac    = 1
c
c     data mmgrx,mmgry/385,385/
      mmgrx    = 385
      mmgry    = 385
c
c     data mmnrx,mmnry/255,255/
      mmnrx    = 255
      mmnry    = 255
c
c     data modef/0/
      modef    = 0
c
c     data mncpw/4/
      mncpw    = 4
c
c     data mbuflu/0/
      mbuflu   = 0
c
c     data msblen/360/
      msblen   = 360
c
c     data mbufl/360/
      mbufl    = 360
c
c     data mf2er/0/
      mf2er    = 0
c
c     data mshftx,mshfty/5,5/
      mshftx   = 5
      mshfty   = 5
c
c     data mbufa/-9999/
      mbufa    = -9999
c
c     data mflcnt/0/
      mflcnt   = 0
c
c     data mfrend/0/
      mfrend   = 0
c
c     data mfrlst/1/
      mfrlst   = 1
c
c     data mpair1/0/
      mpair1   = 0
c
c     data mpair2/8192/
      mpair2   = 8192
c
c     data mcrout/0/
      mcrout   = 0
c
c     data mbprs(1)/0/
      mbprs(1) = 0
c
c     data mbprs(2)/8192/
      mbprs(2) = 8192
c
c     data mipair/2/
      mipair   = 2
c
c     data mjxmax,mjymax,mjxmin,mjymin/0,0,32767,32767/
      mjxmax   = 0
      mjymax   = 0
      mjxmin   = 32767
      mjxmin   = 32767
c
c set to unit number for printer
c
c     data mprint/6/
      mprint   = 6
c
c set to unit number for plotter
c
c     data munit/8/
      munit     = 8
c set to smallest positive number on the computer
c
c     data small/1.e-25/
      small     = 1.e-25
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSTUP (XDRA,NVIX,IIVX,NEVX,IIEX,
     +                   YDRA,NVIY,IIVY,NEVY,IIEY)
C
      DIMENSION XDRA(1),YDRA(1)
C
C The routine AGSTUP is called to examine the parameter list, to provide
C default values for missing parameters, and to check for and cope with
C label overlap problems.
C
C The arguments describe the x and y data arrays to be used for the next
C graph.  See the routine AGEXUS for a description of them.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C Declare the block data routine external to force it to load.
C
C     EXTERNAL AGDFLT
C
C Do statistics-gathering call.
C
      LOGICAL Q8Q4
      SAVE Q8Q4
      DATA Q8Q4 /.TRUE./
      IF (Q8Q4) THEN
        CALL Q8QST4('GRAPHX','AUTOGRAPH','AGSTUP','VERSION 07')
        Q8Q4 = .FALSE.
      ENDIF
C
C +NOAO - Block data replaced with run time initialization
C
      call agdflt
C 
C -NOAO
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C Compute the width and height of the plotter frame.
C
      CALL GETSI (IWFP,IHFP)
      WOFP=2.**IWFP-1.
      HOFP=2.**IHFP-1.
C
C Examine the get-limits-from-last-set-call parameter.
C
      IF (ABS(QSET).EQ.1.) GO TO 141
C
      CALL GETSET (XLCW,XRCW,YBCW,YTCW,XMNT,XMXT,YMNT,YMXT,LILO)
C
      QLUX=FLOAT((1-LILO)/2)
      QLUY=FLOAT(MOD(1-LILO,2))
C
      IF (ABS(QSET).EQ.3.) GO TO 140
C
      XLGD=(XLCW-XLGF)/(XRGF-XLGF)
      XRGD=(XRCW-XLGF)/(XRGF-XLGF)
      YBGD=(YBCW-YBGF)/(YTGF-YBGF)
      YTGD=(YTCW-YBGF)/(YTGF-YBGF)
      SOGD=0.
C
      IF (ABS(QSET).EQ.2.) GO TO 141
C
  140 XMIN=AMIN1(XMNT,XMXT)
      XMAX=AMAX1(XMNT,XMXT)
      QOVX=0.
      IF (XMNT.GT.XMXT) QOVX=1.
      QCEX=0.
C
      YMIN=AMIN1(YMNT,YMXT)
      YMAX=AMAX1(YMNT,YMXT)
      QOVY=0.
      IF (YMNT.GT.YMXT) QOVY=1.
      QCEY=0.
C
  141 CONTINUE
C
C Examine the graph-window parameters.
C
      XLGF=AMAX1(0.,AMIN1(1.,XLGF))
      XRGF=AMAX1(0.,AMIN1(1.,XRGF))
      YBGF=AMAX1(0.,AMIN1(1.,YBGF))
      YTGF=AMAX1(0.,AMIN1(1.,YTGF))
C
      IF (XLGF.GE.XRGF.OR.YBGF.GE.YTGF) GO TO 901
C
C Examine the grid-window parameters.
C
      XLGD=AMAX1(0.,AMIN1(1.,XLGD))
      XRGD=AMAX1(0.,AMIN1(1.,XRGD))
      YBGD=AMAX1(0.,AMIN1(1.,YBGD))
      YTGD=AMAX1(0.,AMIN1(1.,YTGD))
C
      IF (XLGD.GE.XRGD.OR.YBGD.GE.YTGD) GO TO 902
C
C Examine the user-window minima and maxima for special values.  Compute
C tentative values of the user-window edge parameters.
C
      QIXY=AMAX1(0.,AMIN1(1.,QIXY))
C
      IF (QIXY.NE.0.) GO TO 142
C
      CALL AGEXUS (SVAL,XMIN,XMAX,XLOW,XHGH,
     +                               XDRA,NVIX,IIVX,NEVX,IIEX,XLUW,XRUW)
      CALL AGEXUS (SVAL,YMIN,YMAX,YLOW,YHGH,
     +                               YDRA,NVIY,IIVY,NEVY,IIEY,YBUW,YTUW)
      GO TO 143
C
  142 CALL AGEXUS (SVAL,XMIN,XMAX,XLOW,XHGH,
     +                               YDRA,NVIY,IIVY,NEVY,IIEY,XLUW,XRUW)
      CALL AGEXUS (SVAL,YMIN,YMAX,YLOW,YHGH,
     +                               XDRA,NVIX,IIVX,NEVX,IIEX,YBUW,YTUW)
C
  143 CONTINUE
C
C Examine the user-window nice-value-at-ends parameters.  INAX and INAY
C specify which axis has the nice values (if any).
C
      QCEX=AMAX1(-1.,AMIN1(+1.,QCEX))
      INAX=IFIX(QCEX)
      IF (INAX.NE.0) INAX=(INAX+7)/2
C
      QCEY=AMAX1(-1.,AMIN1(+1.,QCEY))
      INAY=IFIX(QCEY)
      IF (INAY.NE.0) INAY=(INAY+3)/2
C
C Examine the user-window linear-log flags.
C
      QLUX=AMAX1(-1.,AMIN1(1.,QLUX))
      QLUY=AMAX1(-1.,AMIN1(1.,QLUY))
C
C Examine the axis parameters.
C
      QLUD=ABS(QLUY)
      INAD=INAY
      UMIN=YBUW
      UMAX=YTUW
      QMIN=YBUW
      QMAX=YTUW
C
      I=0
C
  101 I=I+1
      IF (I.EQ.5) GO TO 104
C
      IF (I.EQ.3) THEN
        QLUD=ABS(QLUX)
        INAD=INAX
        UMIN=XLUW
        UMAX=XRUW
        QMIN=XLUW
        QMAX=XRUW
      END IF
C
      QDAX(I)=AMAX1(-1.,AMIN1(4.,QDAX(I)))
      IF (QDAX(I).LE.0.) GO TO 102
      QLUA(I)=QLUD
      QBTP(I)=QBTD(I)
      IF (QBTD(I).EQ.SVAL(1).OR.QBTD(I).EQ.SVAL(2)) QBTP(I)=1.+QLUD
      QBTP(I)=AMAX1(0.,AMIN1(3.,QBTP(I)))
      IF (QBTD(I).EQ.SVAL(2)) QBTD(I)=QBTP(I)
C
      CALL AGEXAX (I,SVAL,UMIN,UMAX,INAD-I,QLUD,FUNS(I),QBTP(I),BASD(I),
     +             BASE(I),QMJD(I),QMND(I),QMNT(I),QLTD(I),QLTP(I),
     +             QLED(I),QLEX(I),QLFD(I),QLFL(I),QMIN,QMAX)
C
      QSPA(I)=AMAX1(0.,AMIN1(1.,QSPA(I)))
      IF (QJDP(I).EQ.SVAL(1).OR.QJDP(I).EQ.SVAL(2)) QJDP(I)=65535.
      IF (QNDP(I).EQ.SVAL(1).OR.QNDP(I).EQ.SVAL(2)) QNDP(I)=65535.
C
  102 IF (I.EQ.2) THEN
        YBUW=QMIN
        YTUW=QMAX
      ELSE IF (I.EQ.4) THEN
        XLUW=QMIN
        XRUW=QMAX
      END IF
C
      GO TO 101
C
C Examine the user-window min-max/max-min ordering parameters.  Compute
C final values of the user-window edge parameters.
C
  104 QOVX=AMAX1(0.,AMIN1(1.,QOVX))
      IF (QOVX.EQ.0.) GO TO 105
      TEMP=XLUW
      XLUW=XRUW
      XRUW=TEMP
C
  105 QOVY=AMAX1(0.,AMIN1(1.,QOVY))
      IF (QOVY.EQ.0.) GO TO 106
      TEMP=YBUW
      YBUW=YTUW
      YTUW=TEMP
C
C Determine the exact size and shape of the curve window.
C
  106 XLGW=XLGF*WOFP
      XRGW=XRGF*WOFP
      YBGW=YBGF*HOFP
      YTGW=YTGF*HOFP
C
      XLCW=XLGW+XLGD*(XRGW-XLGW)
      XRCW=XLGW+XRGD*(XRGW-XLGW)
      YBCW=YBGW+YBGD*(YTGW-YBGW)
      YTCW=YBGW+YTGD*(YTGW-YBGW)
C
      WCWP=XRCW-XLCW
      HCWP=YTCW-YBCW
C
      ARWH=WCWP/HCWP
C
      IF (SOGD) 107,115,108
C
  107 DRWH=ABS(SOGD)
      GO TO 111
C
  108 DRWH=ABS((XRUW-XLUW)/(YTUW-YBUW))
      IF (SOGD-1.) 109,110,110
C
  109 IF (DRWH.LT.SOGD.OR.(1./DRWH).LT.SOGD) GO TO 115
      GO TO 111
C
  110 IF (DRWH.GT.SOGD.OR.(1./DRWH).GT.SOGD) DRWH=1.
C
  111 IF (DRWH-ARWH) 112,115,113
C
  112 XLCW=XLCW+.5*(WCWP-HCWP*DRWH)
      XRCW=XRCW-.5*(WCWP-HCWP*DRWH)
      GO TO 114
C
  113 YBCW=YBCW+.5*(HCWP-WCWP/DRWH)
      YTCW=YTCW-.5*(HCWP-WCWP/DRWH)
C
  114 WCWP=XRCW-XLCW
      HCWP=YTCW-YBCW
C
  115 SCWP=AMIN1(WCWP,HCWP)
C
      XLGW=(XLGW-XLCW)/WCWP
      XRGW=(XRGW-XLCW)/WCWP
      YBGW=(YBGW-YBCW)/HCWP
      YTGW=(YTGW-YBCW)/HCWP
C
      XLCW=XLCW/WOFP
      XRCW=XRCW/WOFP
      YBCW=YBCW/HOFP
      YTCW=YTCW/HOFP
C
C Make sure the number of dash patterns is in range.
C
      QODP=AMAX1(-26.,AMIN1(+26.,QODP))
      IF (QODP.EQ.0.) QODP=-1.
C
C Examine the windowing parameter.
C
      QWND=AMAX1(0.,AMIN1(1.,QWND))
C
C Do a test run of the routine AGLBLS to find out how much space will be
C required for labels in each of the six label boxes.
C
      QDLB=AMAX1(0.,AMIN1(2.,QDLB))
      IDLB=IFIX(QDLB)
      LBIM=IFIX(QBIM)
C
      CALL AGLBLS (-IDLB,WCWP,HCWP,FLLB,LBIM,FLLN,DBOX,SBOX,RBOX)
C
C Compute the desired and smallest-possible widths of the labels in
C boxes 1 and 2.
C
      DWB1=AMAX1(0.,DBOX(1,2)-DBOX(1,1))
      SWB1=AMAX1(0.,SBOX(1,2)-SBOX(1,1))
      DWB2=AMAX1(0.,DBOX(2,2)-DBOX(2,1))
      SWB2=AMAX1(0.,SBOX(2,2)-SBOX(2,1))
C
C Compute the desired and smallest-possible heights of the labels in
C boxes 3 and 4.
C
      DHB3=AMAX1(0.,DBOX(3,4)-DBOX(3,3))
      SHB3=AMAX1(0.,SBOX(3,4)-SBOX(3,3))
      DHB4=AMAX1(0.,DBOX(4,4)-DBOX(4,3))
      SHB4=AMAX1(0.,SBOX(4,4)-SBOX(4,3))
C
C Do test runs of AGAXIS for each of the four axes to see how much space
C will be required for numeric labels.
C
      I=0
C
  118 I=I+1
      IF (I.EQ.5) GO TO 128
C
      XYPI=FLOAT(1-MOD(I,2))
      IF (QDAX(I).EQ.0.) GO TO 121
      IF (PING(I).NE.SVAL(1)) XYPI=PING(I)
C
      IF (I.GE.3) GO TO 119
C
      XYMN=XLGW
      XYMX=XRGW
      IF (PINU(I).EQ.SVAL(1)) GO TO 120
      XYPI=(PINU(I)-XLUW)/(XRUW-XLUW)
      IF (QLUX.NE.0.) XYPI=(ALOG10(PINU(I))-ALOG10(XLUW))/
     +                                       (ALOG10(XRUW)-ALOG10(XLUW))
      GO TO 120
C
  119 XYMN=YBGW
      XYMX=YTGW
      IF (PINU(I).EQ.SVAL(1)) GO TO 120
      XYPI=(PINU(I)-YBUW)/(YTUW-YBUW)
      IF (QLUY.NE.0.) XYPI=(ALOG10(PINU(I))-ALOG10(YBUW))/
     +                                       (ALOG10(YTUW)-ALOG10(YBUW))
C
  120 XYPI=AMAX1(XYMN,AMIN1(XYMX,XYPI))
C
  121 GO TO (122,123,124,125) , I
C
C Left y axis.
C
  122 XBGA(1)=XYPI
      YBGA(1)=0.
      UBGA(1)=YBUW
      XNDA(1)=XYPI
      YNDA(1)=1.
      UNDA(1)=YTUW
      WNLL(1)=XYPI-XLGW-DWB1
      WNLR(1)=XRGW-XYPI-DWB2
      GO TO 126
C
C Right y axis.
C
  123 XBGA(2)=XYPI
      YBGA(2)=1.
      UBGA(2)=YTUW
      XNDA(2)=XYPI
      YNDA(2)=0.
      UNDA(2)=YBUW
      WNLL(2)=XRGW-XYPI-DWB2
      WNLR(2)=XYPI-XLGW-DWB1
      GO TO 126
C
C Bottom x axis.
C
  124 XBGA(3)=1.
      YBGA(3)=XYPI
      UBGA(3)=XRUW
      XNDA(3)=0.
      YNDA(3)=XYPI
      UNDA(3)=XLUW
      WNLL(3)=XYPI-YBGW-DHB3
      WNLR(3)=YTGW-XYPI-DHB4
      GO TO 126
C
C Top x axis.
C
  125 XBGA(4)=0.
      YBGA(4)=XYPI
      UBGA(4)=XLUW
      XNDA(4)=1.
      YNDA(4)=XYPI
      UNDA(4)=XRUW
      WNLL(4)=YTGW-XYPI-DHB4
      WNLR(4)=XYPI-YBGW-DHB3
C
  126 IF (QDAX(I).GT.0.) THEN
        CALL AGAXIS (I,QDAX(I),QSPA(I),WCWP,HCWP,XBGA(I),YBGA(I),
     +               XNDA(I),YNDA(I),QLUA(I),UBGA(I),UNDA(I),FUNS(I),
     +               QBTP(I),BASE(I),QJDP(I),WMJL(I),WMJR(I),QMNT(I),
     +               QNDP(I),WMNL(I),WMNR(I),QLTP(I),QLEX(I),QLFL(I),
     +               QLOF(I),QLOS(I),DNLA(I),WCLM(I),WCLE(I),RFNL(I),
     +               QCIM(I),QCIE(I),WNLL(I),WNLR(I),10.,11.)
      ELSE
        WNLL(I)=0.
        WNLR(I)=0.
      END IF
      GO TO 118
C
C If no labels are to be drawn, AGSTUP is now done.
C
  128 IF (IDLB.EQ.0) GO TO 138
C
C Check the label boxes, moving and/or shrinking them to prevent the
C labels in them from overlapping any portion of any axis.  The labels
C on an axis may have to be moved, as well.
C
C Box 1 - to the left of the curve window.
C
      IF (DBOX(1,2).GT.0.) GO TO 903
      DBOX(1,2)=AMIN1(0.,XBGA(1)-WNLL(1),XBGA(2)-WNLR(2))
      DBOX(1,1)=DBOX(1,2)-DWB1
      IF (DBOX(1,1).LT.XLGW) DBOX(1,1)=AMIN1(DBOX(1,2)-SWB1,XLGW)
      IF (DBOX(1,1).GE.XLGW) GO TO 130
      DBOX(1,1)=XLGW
      DBOX(1,2)=XLGW+SWB1
      TEMP=XBGA(1)-WNLL(1)-DBOX(1,2)
      IF (TEMP.GE.0.) GO TO 129
      WNLL(1)=WNLL(1)+TEMP
      WNLR(1)=WNLR(1)-TEMP
  129 TEMP=XBGA(2)-WNLR(2)-DBOX(1,2)
      IF (TEMP.GE.0.) GO TO 130
      WNLL(2)=WNLL(2)-TEMP
      WNLR(2)=WNLR(2)+TEMP
C
C Box 2 - to the right of the curve window.
C
  130 IF (DBOX(2,1).LT.1.) GO TO 904
      DBOX(2,1)=AMAX1(1.,XBGA(1)+WNLR(1),XBGA(2)+WNLL(2))
      DBOX(2,2)=DBOX(2,1)+DWB2
      IF (DBOX(2,2).GT.XRGW) DBOX(2,2)=AMAX1(DBOX(2,1)+SWB2,XRGW)
      IF (DBOX(2,2).LE.XRGW) GO TO 132
      DBOX(2,1)=XRGW-SWB2
      DBOX(2,2)=XRGW
      TEMP=XBGA(1)+WNLR(1)-DBOX(2,1)
      IF (TEMP.LE.0.) GO TO 131
      WNLL(1)=WNLL(1)+TEMP
      WNLR(1)=WNLR(1)-TEMP
  131 TEMP=XBGA(2)+WNLL(2)-DBOX(2,1)
      IF (TEMP.LE.0.) GO TO 132
      WNLL(2)=WNLL(2)-TEMP
      WNLR(2)=WNLR(2)+TEMP
C
C Box 3 - below the curve window.
C
  132 IF (DBOX(3,4).GT.0.) GO TO 905
      DBOX(3,4)=AMIN1(0.,YBGA(3)-WNLL(3),YBGA(4)-WNLR(4))
      DBOX(3,3)=DBOX(3,4)-DHB3
      IF (DBOX(3,3).LT.YBGW) DBOX(3,3)=AMIN1(DBOX(3,4)-SHB3,YBGW)
      IF (DBOX(3,3).GE.YBGW) GO TO 134
      DBOX(3,3)=YBGW
      DBOX(3,4)=YBGW+SHB3
      TEMP=YBGA(3)-WNLL(3)-DBOX(3,4)
      IF (TEMP.GE.0.) GO TO 133
      WNLL(3)=WNLL(3)+TEMP
      WNLR(3)=WNLR(3)-TEMP
  133 TEMP=YBGA(4)-WNLR(4)-DBOX(3,4)
      IF (TEMP.GE.0.) GO TO 134
      WNLL(4)=WNLL(4)-TEMP
      WNLR(4)=WNLR(4)+TEMP
C
C Box 4 - above the curve window.
C
  134 IF (DBOX(4,3).LT.1.) GO TO 906
      DBOX(4,3)=AMAX1(1.,YBGA(3)+WNLR(3),YBGA(4)+WNLL(4))
      DBOX(4,4)=DBOX(4,3)+DHB4
      IF (DBOX(4,4).GT.YTGW) DBOX(4,4)=AMAX1(DBOX(4,3)+SHB4,YTGW)
      IF (DBOX(4,4).LE.YTGW) GO TO 136
      DBOX(4,3)=YTGW-SHB4
      DBOX(4,4)=YTGW
      TEMP=YBGA(3)+WNLR(3)-DBOX(4,3)
      IF (TEMP.LE.0.) GO TO 135
      WNLL(3)=WNLL(3)+TEMP
      WNLR(3)=WNLR(3)-TEMP
  135 TEMP=YBGA(4)+WNLL(4)-DBOX(4,3)
      IF (TEMP.LE.0.) GO TO 136
      WNLL(4)=WNLL(4)-TEMP
      WNLR(4)=WNLR(4)+TEMP
C
C Box 5 - the curve window itself.
C
  136 IF (DBOX(5,1).LT.0..OR.DBOX(5,2).GT.1..OR.
     +                     DBOX(5,3).LT.0..OR.DBOX(5,4).GT.1.) GO TO 907
C
      DBOX(5,1)=AMAX1(XLGW,XBGA(1)+WNLR(1))
      DBOX(5,2)=AMIN1(XRGW,XBGA(2)-WNLR(2))
      DBOX(5,3)=AMAX1(YBGW,YBGA(3)+WNLR(3))
      DBOX(5,4)=AMIN1(YTGW,YBGA(4)-WNLR(4))
C
C Do a final check on all boxes for labels running outside the graph
C window.
C
           DO 137 NBOX=1,6
           DBOX(NBOX,1)=AMAX1(XLGW,DBOX(NBOX,1))
           DBOX(NBOX,2)=AMIN1(XRGW,DBOX(NBOX,2))
           DBOX(NBOX,3)=AMAX1(YBGW,DBOX(NBOX,3))
           DBOX(NBOX,4)=AMIN1(YTGW,DBOX(NBOX,4))
  137      CONTINUE
C
C Do a "SET" call for the user and return.
C
  138 CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,
     +                            1+IABS(IFIX(QLUX))*2+IABS(IFIX(QLUY)))
C
      RETURN
C
C Error exits.
C
  901 CALL SETER ('AGSTUP - GRAPH WINDOW IMPROPERLY SPECIFIED',20,2)
C
  902 CALL SETER ('AGSTUP - GRID WINDOW IMPROPERLY SPECIFIED',21,2)
C
  903 CALL SETER ('AGSTUP - LEFT LABELS IMPROPERLY SPECIFIED',22,2)
C
  904 CALL SETER ('AGSTUP - RIGHT LABELS IMPROPERLY SPECIFIED',23,2)
C
  905 CALL SETER ('AGSTUP - BOTTOM LABELS IMPROPERLY SPECIFIED',24,2)
C
  906 CALL SETER ('AGSTUP - TOP LABELS IMPROPERLY SPECIFIED',25,2)
C
  907 CALL SETER ('AGSTUP - INTERIOR LABELS IMPROPERLY SPECIFIED',26,2)
C
      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSTCH (CHST,LNCS,IDCS)
C
      CHARACTER*(*) CHST
C
C This routine stores strings of characters for later retrieval and/or
C modification by the routines AGGTCH, AGRPCH, and AGDLCH.  It has the
C following arguments:
C
C -- CHST is the character string to be stored.
C
C -- LNCS is the length of the character string in CHST.  LNCS must be
C    less than or equal to the value of the FORTRAN function LEN(CHST).
C
C -- IDCS is an identifying integer, returned to the caller by AGSTCH
C    for later use in calls to AGGTCH, AGRPCH, and AGDLCH.  If CHST is
C    more than one character long, it is stashed in the array CHRA, and
C    the value returned in IDCS is a negative number between -LNIC and
C    -1, inclusive, the absolute value of which is the index of an entry
C    in the array INCH describing where in the array CHRA the string was
C    stored.  If CHST is only one character long, IDCS is returned as
C    the value of the FORTRAN expression -(LNIC+1+ICHAR(CHST(1:1))).
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
C
      COMMON /AGCHR2/ CHRA(2000)
C
      CHARACTER*1 CHRA
C
C If the string is short enough, just embed it in a negative integer
C and return that value to the caller as the identifier of the string.
C
      IF (LNCS.LE.1) THEN
        IDCS=-(LNIC+1+ICHAR(CHST(1:1)))
        RETURN
      END IF
C
C Otherwise, the string must be stashed in CHRA and the negative of the
C index, in INCH, of its descriptor returned to the caller.  Loop, on I,
C through the index of character strings.
C
      DO 104 I=1,LNIC
C
C If the next entry in the index is zeroed, use it for the new string.
C
        IF (INCH(1,I).EQ.0) THEN
C
C Zeroed entry found.  Return the negative of its index to the user.
C
          IDCS=-I
C
C If there isn't enough room for the character string at the end of the
C character-storage array, do some garbage-collecting, eliminating all
C strings of all-zero characters.
C
          IF (LNCS.GT.LNCA-INCA) THEN
            J=0
            K=0
            DO 102 L=1,INCA
              IF (CHRA(L).EQ.CHAR(0)) THEN
                IF (J.EQ.0) J=L
              ELSE
                IF (J.NE.0) THEN
                  DO 101 M=1,LNIC
                    IF (INCH(1,M).GT.K) INCH(1,M)=INCH(1,M)+J-L
  101             CONTINUE
                  J=0
                END IF
                K=K+1
                CHRA(K)=CHRA(L)
              END IF
  102       CONTINUE
            INCA=K
          END IF
C
C If there still isn't enough room for the character string at the end
C of the character-storage array, take an error exit.  Otherwise, stash
C it and return.  All-zero characters are changed to blanks.
C
          IF (LNCS.GT.LNCA-INCA) GO TO 901
          INCH(1,I)=INCA+1
          INCH(2,I)=LNCS
          DO 103 J=1,LNCS
            INCA=INCA+1
            CHRA(INCA)=CHST(J:J)
            IF (ICHAR(CHRA(INCA)).EQ.0) CHRA(INCA)=' '
  103     CONTINUE
          RETURN
C
        END IF
C
  104 CONTINUE
C
C If no zeroed entry was found in the index of character strings, jump
C to log an error and quit.
C
      GO TO 902
C
C Error exits.
C
  901 CALL SETER ('AGSTCH - CHARACTER-STRING BUFFER OVERFLOW - SEE CONSU
     +LTANT',18,2)
C
  902 CALL SETER ('AGSTCH - CHARACTER-STRING INDEX OVERFLOW - SEE CONSUL
     +TANT',19,2)
C
      END

C--------------------------------------------------------------------------
        subroutine ftgbtp(ibuff,keynam,value,status)

C       Get Binary Table Parameter
C       test if the keyword is one of the table column definition keywords
C       of a binary table. If so, decode it and update the values in the common
C       block

C       ibuff   i sequence number of the data buffer
C       OUTPUT PARAMETERS:
C       keynam  c name of the keyword
C       value   c value of the keyword
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ibuff,status,width
        character keynam*8,value*70

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
C       nb = number of file buffers = max. number of FITS file opened at once
C       nf = maximum number of fields allowed in a table
        integer nf,nb
        parameter (nb = 20)
        parameter (nf = 3000)
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer nfield,tstat
        character tform*16

        if (status .gt. 0)return
        tstat=status

        if (keynam(1:5) .eq. 'TFORM')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TFORMn keyword
                    status=tstat
                else
C                   get the TFORM character string, without quotes
                    call ftc2s(value,tform,status)
C                   get the datatype code and repeat count
                    call ftbnfm(tform,tdtype(nfield+tstart(ibuff)),
     &                 trept(nfield+tstart(ibuff)),width,status)
                    if (tdtype(nfield+tstart(ibuff)) .eq. 1)then
C                       treat Bit datatype as if it were a Byte datatype
                        tdtype(nfield+tstart(ibuff))=11
                        trept(nfield+tstart(ibuff))=(trept(nfield+
     &                  tstart(ibuff))+7)/8
                    else if (tdtype(nfield+tstart(ibuff)) .eq. 16)then
C                      store the width of the ASCII field in the TNULL parameter
                        tnull(nfield+tstart(ibuff))=width
                   end if
                end if
        else if (keynam(1:5) .eq. 'TSCAL')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TSCALn keyword
                    status=tstat
                else
C                   get the scale factor
                    call ftc2dd(value,tscale(nfield+tstart(ibuff)),
     &                          status)
                    if (status .gt. 0)then
                         call ftpmsg('Error reading value of'//keynam
     &                //' as a Double: '//value)
                    end if
                end if
        else if (keynam(1:5) .eq. 'TZERO')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TZEROn keyword
                    status=tstat
                else
C                   get the scaling zero point
                    call ftc2dd(value,tzero(nfield+tstart(ibuff)),
     &                          status)
                    if (status .gt. 0)then
                         call ftpmsg('Error reading value of'//keynam
     &                //' as a Double: '//value)
                    end if
                end if
        else if (keynam(1:5) .eq. 'TNULL')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TNULLn keyword
                    status=tstat
                else
C                   make sure this is not an ASCII column (the tnull
C                   variable is use to store the ASCII column width)
                    if (tdtype(nfield+tstart(ibuff)) .ne. 16)then
C                       get the Null value flag (Integer)
                        call ftc2ii(value,tnull(nfield+tstart(ibuff)),
     &                              status)
                        if (status .gt. 0)then
                            call ftpmsg('Error reading value of '//
     &                      keynam//' as an integer: '//value)
                        end if
                    end if
                end if
        else if (keynam(1:8) .eq. 'THEAP   ')then
C               get the heap offset value
                call ftc2ii(value,theap(ibuff),status)
                if (status .gt. 0)then
                        call ftpmsg('Error reading value of '//keynam
     &                  //' as an integer: '//value)
                end if
        end if
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
c +noao: block data veldat changed to run time initialization
c     BLOCK DATA VELDAT
        subroutine veldat
C
C THIS 'ROUTINE' DEFINES THE DEFAULT VALUES OF THE VELVCT PARAMETERS.
C
      COMMON /VEC1/   ASH        ,EXT        ,ICTRFG     ,ILAB,
     +                IOFFD      ,IOFFM      ,ISX        ,ISY,
     +                RMN        ,RMX        ,SIDE       ,SIZE,
     +                XLT        ,YBT        ,ZMN        ,ZMX
C
      COMMON /VEC2/   BIG        ,INCX       ,INCY
C
c     DATA     EXT /    0.25 /
c     DATA  ICTRFG /    1         /
c     DATA    ILAB /    0         /
c     DATA   IOFFD /    0         /
c     DATA   IOFFM /    0         /
c     DATA     RMN /  160.00 /
c     DATA     RMX / 6400.00 /
c     DATA    SIDE /    0.90 /
c     DATA    SIZE /  256.00 /
c     DATA     XLT /    0.05 /
c     DATA     YBT /    0.05 /
c     DATA     ZMX /    0.00 /
c     DATA    INCX /    1          /
c     DATA    INCY /    1          /
c
c +noao: following flag added to prevent over-initialization
      logical first
        SAVE
      data first /.true./
      if (.not. first) then
          return
      endif
      first = .false.

      EXT =     0.25 
      ICTRFG =  1    
      ILAB =    0         
      IOFFD =   0    
      IOFFM =   0    
      RMN =  160.00 
      RMX = 6400.00 
      SIDE =    0.90 
      SIZE =  256.00 
      XLT =     0.05 
      YBT =     0.05 
      ZMX =     0.00 
      INCX =    1          
      INCY =    1          
C
c - noao
      END

      SUBROUTINE COSQB (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
      DATA TSQRT2 /2.82842712474619/
      IF (N.lt.2) GO TO 101
      IF (N.eq.2) GO TO 102
      GO TO 103
  101 X(1) = 4.*X(1)
      RETURN
  102 X1 = 4.*(X(1)+X(2))
      X(2) = TSQRT2*(X(1)-X(2))
      X(1) = X1
      RETURN
  103 CALL COSQB1 (N,X,WSAVE,WSAVE(N+1))
      RETURN
      END
      SUBROUTINE COSQB1 (N,X,W,XH)
      DIMENSION       X(1)       ,W(1)       ,XH(1)
      NS2 = (N+1)/2
      NP2 = N+2
      DO 101 I=3,N,2
         XIM1 = X(I-1)+X(I)
         X(I) = X(I)-X(I-1)
         X(I-1) = XIM1
  101 CONTINUE
      X(1) = X(1)+X(1)
      MODN = MOD(N,2)
      IF (MODN .EQ. 0) X(N) = X(N)+X(N)
      CALL RFFTB (N,X,XH)
      DO 102 K=2,NS2
         KC = NP2-K
         XH(K) = W(K-1)*X(KC)+W(KC-1)*X(K)
         XH(KC) = W(K-1)*X(K)-W(KC-1)*X(KC)
  102 CONTINUE
      IF (MODN .EQ. 0) X(NS2+1) = W(NS2)*(X(NS2+1)+X(NS2+1))
      DO 103 K=2,NS2
         KC = NP2-K
         X(K) = XH(K)+XH(KC)
         X(KC) = XH(K)-XH(KC)
  103 CONTINUE
      X(1) = X(1)+X(1)
      RETURN
      END

chapter xvii, example 3. bivariate spline interpolation
c  followed by conversion to pp-repr and evaluation
c  from  * a practical guide to splines *  by c. de boor
calls  spli2d(bsplvb,banfac/slv),interv,bspp2d(bsplvb*),ppvalu(interv*)
c     parameter nx=7,kx=3,ny=6,ky=4
c     integer i,iflag,j,jj,lefty,lx,ly,mflag
c     real bcoef(nx,ny),breakx(6),breaky(4),coef(kx,5,ky,3),taux(nx)
c    *	  ,tauy(ny),tx(10),ty(10)
c    *	       ,work1(nx,ny),work2(nx),work3(42)
c    *	       ,work4(kx,kx,ny),work5(ny,kx,5),work6(ky,ky,21)
      integer i,iflag,j,jj,kp1,kx,ky,lefty,lx,ly,mflag,nx,ny
      real bcoef(7,6),breakx(6),breaky(4),coef(3,5,4,3),taux(7)
     *	  ,tauy(6),tx(10),ty(10)
     *	       ,work1(7,6),work2(7),work3(42)
     *	       ,work4(3,3,6),work5(6,3,5),work6(4,4,21)
      real ppvalu,g,x,y
      data nx,kx,ny,ky / 7,3,6,4 /
c     note that , with the above parameters, lx=5, ly = 3
      equivalence (work4,work6)
      g(x,y) = amax1(x-3.5,0.)**2 + amax1(y-3.,0.)**3
c *** set up data points and knots
c     in x, interpolate between knots by parabolic splines, using
c     not-a-knot end condition
      do 10 i=1,nx
   10	 taux(i) = float(i)
      do 11 i=1,kx
	 tx(i) = taux(1)
   11	 tx(nx+i) = taux(nx)
      kp1 = kx+1
      do 12 i=kp1,nx
   12	 tx(i) = (taux(i-kx+1) + taux(i-kx+2))/2.
c     in y, interpolate at knots by cubic splines, using not-a-knot
c     end condition
      do 20 i=1,ny
   20	 tauy(i) = float(i)
      do 21 i=1,ky
	 ty(i) = tauy(1)
   21	 ty(ny+i) = tauy(ny)
      kp1 = ky+1
      do 22 i=kp1,ny
   22	 ty(i) = tauy(i-ky+2)
c  *** generate and print out function values
      print 620,(tauy(i),i=1,ny)
  620 format(11h given data//6f12.1)
      do 32 i=1,nx
	 do 31 j=1,ny
   31	    bcoef(i,j) = g(taux(i),tauy(j))
   32	 print 632,taux(i),(bcoef(i,j),j=1,ny)
  632 format(f5.1,6e12.5)
c
c  *** construct b-coefficients of interpolant
c
      call spli2d(taux,bcoef,tx,nx,kx,ny,work2,work3,work1,iflag)
      call spli2d(tauy,work1,ty,ny,ky,nx,work2,work3,bcoef,iflag)
c
c  *** convert to pp-representation
c
      call bspp2d(tx,bcoef,nx,kx,ny,work4,breakx,work5,lx)
      call bspp2d(ty,work5,ny,ky,lx*kx,work6,breaky,coef,ly)
c
c  *** evaluate interpolation error at mesh points and print out
      print 640,(tauy(j),j=1,ny)
  640 format(//20h interpolation error//6f12.1)
      do 45 j=1,ny
	 call interv(breaky,ly,tauy(j),lefty,mflag)
	 do 45 i=1,nx
	    do 41 jj=1,ky
   41	     work2(jj)=ppvalu(breakx,coef(1,1,jj,lefty),lx,kx,taux(i),0)
   45	    work1(i,j) = g(taux(i),tauy(j)) -
     *	    ppvalu(breaky(lefty),work2,1,ky,tauy(j),0)
      do 46 i=1,nx
   46	 print 632,taux(i),(work1(i,j),j=1,ny)
					stop
      end

include	defs

# sdrop --- drop characters from a string APL-style

   integer function sdrop (from, to, chars)
   character from (ARB), to (ARB)
   integer chars

   integer len, start
   integer ctoc, length, min0

   len = length (from)
   if (chars < 0)
      return (ctoc (from, to, len + chars + 1))
   else {
      start = min0 (chars, len)
      return (ctoc (from (start + 1), to, len + 1))
      }

   end

include  defs

# IFERRC - Generate initial code for an IFERR statement.  Used to provide
# error recovery for a statement or compound statement.

subroutine iferrc (lab, sense)	

integer lab, sense
integer labgen, nlpar
character t, gettok, gnbtok, token(MAXTOK)
include COMMON_BLOCKS
string	errpsh "call xerpsh"
string	siferr "if (.not.xerpop()) "
string	sifnoerr "if (xerpop()) "

	xfer = NO
	lab = labgen (3)

	call outtab					# "call errpsh"
	call outstr (errpsh)
	call outdon

	switch (gnbtok (token, MAXTOK)) {		# "iferr (" or "iferr {"
	case LPAREN:
	    call outtab
	case LBRACE:
	    call pbstr (token)
	    esp = esp + 1
	    if (esp >= MAXERRSTK)			# not likely
		call baderr ("Iferr statements nested too deeply.")
	    errstk(esp) = lab
	    return
	default:
	    call synerr ("Missing left paren.")
	    return
	}

	nlpar = 1					# process "iferr (.."
	token(1) = EOS

	# Push handler on error stack temporarily so that "iferr (call error.."
	# can be handled properly.
	esp = esp + 1
	if (esp >= MAXERRSTK)				# not likely
	    call baderr ("Iferr statements nested too deeply.")
	errstk(esp) = 0
	
	repeat {					# output the statement
	    call outstr (token)
	    t = gettok (token, MAXTOK)
	    if (t == SEMICOL | t == LBRACE | t == RBRACE | t == EOF) {
		call pbstr (token)
		break
	    }
	    if (t == NEWLINE)      			# delete newlines
		token (1) = EOS
	    else if (t == LPAREN)
		nlpar = nlpar + 1
	    else if (t == RPAREN)
		nlpar = nlpar - 1
	    else if (t == SEMICOL) {
		call outdon
		call outtab
	    } else if (t == ALPHA)
		call squash (token)
	    # else nothing special
	} until (nlpar <= 0)
	
	esp = esp - 1
	ername = NO					# ignore errchk
	if (nlpar != 0)
	    call synerr ("Missing parenthesis in condition.")
	else
	    call outdon
	
	call outtab					# "if (errpop())"
	if (sense == 1)
	    call outstr (siferr)
	else
	    call outstr (sifnoerr)
	call outgo (lab)				# "... goto lab"

	call indent (1)
	return
end

C----------------------------------------------------------------------
        subroutine ftd2e(val,dec,cval,vlen,status)

C       convert a double precision value to an E format character string
C       If it will fit, the value field will be 20 characters wide;
C       otherwise it will be expanded to up to 35 characters, left
C       justified.
C
C       val     d  input value to be converted 
C       dec     i  number of decimal places to display in output string
C       cval    c  output character string
C       vlen    i  length of output string
C       status  i  output error status (0 = OK)

        double precision val
        integer dec,vlen,status
        character*35 cval,form*10

        if (status .gt. 0)return

        if (dec .ge. 1 .and. dec .le. 9)then
                vlen=20
                write(form,2000)dec
2000            format('(1pe20.',i1,')')
        else if (dec .ge. 10 .and. dec .le. 28)then
                vlen=max(20,dec+7)
                write(form,2001)vlen,dec
2001            format('(1pe',i2,'.',i2,')')
        else
C               illegal number of decimal places were specified
                status=411
                call ftpmsg('Error in FTR2E: number of decimal places '
     &                      //'is less than 1 or greater than 28.')
                return
        endif

        write(cval,form,err=900)val
        if (cval(1:1) .eq. '*')go to 900
        return

900     status=402
        call ftpmsg('Error in FTD2E converting double to En.m string.')
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSRCH (TPID,IPID,IKWL,TKWL)
C
      CHARACTER*(*) TPID,TKWL
C
C The routine AGSRCH is used by AGSCAN to search a parameter identifier
C for the next keyword and return the index of that keyword in a list of
C keywords.  It has the following arguments.
C
C -- TPID is the parameter identifier, a character string.
C
C -- IPID is the index of the last character examined in TPID.  It is
C    updated by AGSRCH to point to the first slash or period following
C    the next keyword.
C
C -- IKWL is returned containing the index (in the keyword list) of the
C    next keyword in the parameter identifier (list length, plus one,
C    if the keyword is not found in the list).
C
C -- TKWL is the keyword list - 4*LKWL characters in all.
C
C ICHR is used to hold up to four characters of a keyword.
C
      CHARACTER*4 ICHR
C
C LPID is the assumed maximum length of a parameter identifier.
C
      DATA LPID / 100 /
C
C Compute the number of 4-character keywords in the keyword list.
C
      LKWL=LEN(TKWL)/4
C
C Find the next non-blank in the parameter identifier.
C
  101 IPID=IPID+1
      IF (IPID.GT.LPID) GO TO 107
      IF (TPID(IPID:IPID).EQ.' ') GO TO 101
C
C Pick up at most four characters of the keyword, stopping on the first
C blank, slash, or period encountered.
C
      NCHR=0
C
  102 IF (TPID(IPID:IPID).EQ.' '.OR.
     +    TPID(IPID:IPID).EQ.'/'.OR.
     +    TPID(IPID:IPID).EQ.'.') GO TO 103
C
      NCHR=NCHR+1
      ICHR(NCHR:NCHR)=TPID(IPID:IPID)
C
      IPID=IPID+1
C
      IF (NCHR.LT.4) GO TO 102
C
C If the keyword found has zero length, error.
C
  103 IF (NCHR.EQ.0) GO TO 107
C
C Scan ahead for the next slash or period.
C
  104 IF (TPID(IPID:IPID).EQ.'/'.OR.TPID(IPID:IPID).EQ.'.') GO TO 105
C
      IPID=IPID+1
      IF (IPID.GT.LPID) GO TO 107
      GO TO 104
C
C Search the keyword list for the keyword found.
C
  105 DO 106 I=1,LKWL
        IKWL=I
        ISTR=(I-1)*4+1
        IEND=(I-1)*4+NCHR
        IF (ICHR(1:NCHR).EQ.TKWL(ISTR:IEND)) RETURN
  106 CONTINUE
C
C Keyword not found - set IKWL to impossible value and return.
C
  107 IKWL=LKWL+1
      RETURN
C
      END

C SUBROUTINE GRIDLS.F 
C
C SOURCE
C   BEVINGTON, PAGES 212-213.
C
C PURPOSE
C   MAKE A GRID-SEARCH LEAST-SQUARES FIT TO DATA WITH A SPECIFIED
C   FUNCTION WHICH IS NOT LINEAR IN COEFFICIENTS
C
C USAGE 
C   CALL GRIDLS (X, Y, SIGMAY, NPTS, NTERMS, MODE, A, DELTAA,
C      SIGMAA, YFIT, CHISQR)
C
C DESCRIPTION OF PARAMETERS
C   X	   - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C   Y	   - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C   SIGMAY - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
C   NPTS   - NUMBER OF PAIRS OF DATA POINTS
C   NTERMS - NUMBER OF PARAMETERS
C   MODE   - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C	     +1 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
C	      0 (NO WEIGHTING) WEIGHT(I) = 1.
C	     -1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
C   A	   - ARRAY OF PARAMETERS
C   DELTAA - ARRAY OF INCREMENTS FOR PARAMETERS A
C   SIGMAA - ARRAY OF STANDARD DEVIATIONS FOR PARAMETERS A
C   YFIT   - ARRAY OF CALCULATED VALUES OF Y
C   CHISQR - REDUCED CHI SQUARE FOR FIT 
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   FUNCTN (X, I, A)
C      EVALUATES THE FITTING FUNCTION FOR THE ITH TERM
C   FCHISQ (Y, SIGMAY, NPTS, NFREE, MODE, YFIT) 
C      EVALUATES REDUCED CHI SQUARED FOR FIT TO DATA
C
C COMMENTS
C   DELTAA VALUES ARE MODIFIED BY THE PROGRAM
C
      SUBROUTINE GRIDLS (X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,
     *SIGMAA,YFIT,CHISQR)
      DIMENSION X(1),Y(1),SIGMAY(1),A(1),DELTAA(1),SIGMAA(1), 
     *YFIT(1)
      REAL FUNCTN
      EXTERNAL FUNCTN

C
11    NFREE=NPTS-NTERMS
      FREE=NFREE
      CHISQR=0.
      IF (NFREE) 100,100,20
20    DO 90 J=1,NTERMS
C
C EVALUATE CHI SQUARE AT FIRST TWO SEARCH POINTS
C
21    DO 22 I=1,NPTS
22    YFIT(I)=FUNCTN (X,I,A)
23    CHISQ1=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
      FN=0.
      DELTA=DELTAA(J) 
41    A(J)=A(J)+DELTA 
      DO 43 I=1,NPTS
43    YFIT(I)=FUNCTN (X,I,A)
44    CHISQ2=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
45    IF (CHISQ1-CHISQ2) 51,41,61
C
C REVERSE DIRECTION OF SEARCH IF CHI SQUARE IS INCREASING
C
51    DELTA=-DELTA
      A(J)=A(J)+DELTA 
      DO 54 I=1,NPTS
54    YFIT(I)=FUNCTN (X,I,A)
      SAVE=CHISQ1
      CHISQ1=CHISQ2
57    CHISQ2=SAVE
C
C INCREMENT A(J) UNTIL CHI SQUARE INCREASES
C
61    FN=FN+1.
      A(J)=A(J)+DELTA 
      DO 64 I=1,NPTS
64    YFIT(I)=FUNCTN (X,I,A)
      CHISQ3=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
66    IF (CHISQ3-CHISQ2) 71,81,81
71    CHISQ1=CHISQ2
      CHISQ2=CHISQ3
      GOTO 61 
C
C FIND MINIMUM OF PARABOLA DEFINED BY LAST THREE POINTS 
C
81    DELTA=DELTA*(1./(1.+(CHISQ1-CHISQ2)/(CHISQ3-CHISQ2))+0.5)
82    A(J)=A(J)-DELTA 
83    SIGMAA(J)=DELTAA(J)*SQRT(2./(FREE*(CHISQ3-2.*CHISQ2+CHISQ1)))
84    DELTAA(J)=DELTAA(J)*FN/3.
90    CONTINUE
C
C EVALUATE FIT AND CHI SQUARE FOR FINAL PARAMETERS
C
91    DO 92 I=1,NPTS
92    YFIT(I)=FUNCTN (X,I,A)
93    CHISQR=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
100   RETURN
      END

      integer function strcmp (str1, str2)
      integer str1 (100), str2 (100)
      integer i
      i = 1
23000 if (.not.(str1 (i) .eq. str2 (i)))goto 23002
      if (.not.(str1 (i) .eq. -2))goto 23003
      strcmp=(0)
      return
23003 continue
23001 i = i + 1
      goto 23000
23002 continue
      if (.not.(str1 (i) .eq. -2))goto 23005
      strcmp = -1
      goto 23006
23005 continue
      if (.not.(str2 (i) .eq. -2))goto 23007
      strcmp = + 1
      goto 23008
23007 continue
      if (.not.(str1 (i) .lt. str2 (i)))goto 23009
      strcmp = -1
      goto 23010
23009 continue
      strcmp = +1
23010 continue
23008 continue
23006 continue
      return
      end

#-h-  outcon			  332  local   12/01/80  15:54:31
# outcon - output "n   continue"
   include  defs

   subroutine outcon (n)
   integer n

   include COMMON_BLOCKS

   string contin "continue"

   xfer = NO
   if (n <= 0 & outp == 0)
      return		# don't need unlabeled continues
   if (n > 0)
      call outnum (n)
   call outtab
   call outstr (contin)
   call outdon
   return
   end

      SUBROUTINE slECMA (DATE, RMAT)
*+
*     - - - - - -
*      E C M A
*     - - - - - -
*
*  Form the equatorial to ecliptic rotation matrix - IAU 1980 theory
*  (double precision)
*
*  Given:
*     DATE     dp         TDB (loosely ET) as Modified Julian Date
*                                            (JD-2400000.5)
*  Returned:
*     RMAT     dp(3,3)    matrix
*
*  Reference:
*     Murray,C.A., Vectorial Astrometry, section 4.3.
*
*  Note:
*    The matrix is in the sense   V(ecl)  =  RMAT * V(equ);  the
*    equator, equinox and ecliptic are mean of date.
*
*  Called:  slDEUL
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,RMAT(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T,EPS0



*  Interval between basic epoch J2000.0 and current epoch (JC)
      T = (DATE-51544.5D0)/36525D0

*  Mean obliquity
      EPS0 = AS2R*
     :   (84381.448D0+(-46.8150D0+(-0.00059D0+0.001813D0*T)*T)*T)

*  Matrix
      CALL slDEUL('X',EPS0,0D0,0D0,RMAT)

      END

      SUBROUTINE slMAPA (EQ, DATE, AMPRMS)
*+
*     - - - - - -
*      M A P A
*     - - - - - -
*
*  Compute star-independent parameters in preparation for
*  conversions between mean place and geocentric apparent place.
*
*  The parameters produced by this routine are required in the
*  parallax, light deflection, aberration, and precession/nutation
*  parts of the mean/apparent transformations.
*
*  The reference frames and timescales used are post IAU 1976.
*
*  Given:
*     EQ       d      epoch of mean equinox to be used (Julian)
*     DATE     d      TDB (JD-2400000.5)
*
*  Returned:
*     AMPRMS   d(21)  star-independent mean-to-apparent parameters:
*
*       (1)      time interval for proper motion (Julian years)
*       (2-4)    barycentric position of the Earth (AU)
*       (5-7)    heliocentric direction of the Earth (unit vector)
*       (8)      (grav rad Sun)*2/(Sun-Earth distance)
*       (9-11)   ABV: barycentric Earth velocity in units of c
*       (12)     sqrt(1-v**2) where v=modulus(ABV)
*       (13-21)  precession/nutation (3,3) matrix
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Notes:
*
*  1)  For DATE, the distinction between the required TDB and TT
*      is always negligible.  Moreover, for all but the most
*      critical applications UTC is adequate.
*
*  2)  The vectors AMPRMS(2-4) and AMPRMS(5-7) are referred to
*      the mean equinox and equator of epoch EQ.
*
*  3)  The parameters AMPRMS produced by this routine are used by
*      slAMPQ, slMAPQ and slMAPZ.
*
*  4)  The accuracy is sub-milliarcsecond, limited by the
*      precession-nutation model (IAU 1976 precession, Shirai &
*      Fukushima 2001 forced nutation and precession corrections).
*
*  5)  A further limit to the accuracy of routines using the parameter
*      array AMPRMS is imposed by the routine slEVP, used here to
*      compute the Earth position and velocity by the methods of
*      Stumpff.  The maximum error in the resulting aberration
*      corrections is about 0.3 milliarcsecond.
*
*  Called:
*     slEPJ         MDJ to Julian epoch
*     slEVP         earth position & velocity
*     slDVN         normalize vector
*     slPRNU      precession/nutation matrix
*
*  P.T.Wallace   Starlink   24 October 2003
*
*  Copyright (C) 2003 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION EQ,DATE,AMPRMS(21)

*  Light time for 1 AU (sec)
      DOUBLE PRECISION CR
      PARAMETER (CR=499.004782D0)

*  Gravitational radius of the Sun x 2 (2*mu/c**2, AU)
      DOUBLE PRECISION GR2
      PARAMETER (GR2=2D0*9.87063D-9)

      INTEGER I

      DOUBLE PRECISION EBD(3),EHD(3),EH(3),E,VN(3),VM

      DOUBLE PRECISION slEPJ



*  Time interval for proper motion correction
      AMPRMS(1) = slEPJ(DATE)-EQ

*  Get Earth barycentric and heliocentric position and velocity
      CALL slEVP(DATE,EQ,EBD,AMPRMS(2),EHD,EH)

*  Heliocentric direction of earth (normalized) and modulus
      CALL slDVN(EH,AMPRMS(5),E)

*  Light deflection parameter
      AMPRMS(8) = GR2/E

*  Aberration parameters
      DO I=1,3
         AMPRMS(I+8) = EBD(I)*CR
      END DO
      CALL slDVN(AMPRMS(9),VN,VM)
      AMPRMS(12) = SQRT(1D0-VM*VM)

*  Precession/nutation matrix
      CALL slPRNU(EQ,DATE,AMPRMS(13))

      END

c subroutine smooth.f
c
c source
c   Bevington, page 260.
c
c purpose
c   smooth a set of data points by averaging adjacent channels
c
c usage
c   call smooth (y, npts)
c
c description of parameters
c   y	   - array of data points
c   npts   - number of data points
c
c subroutines and function subprograms required
c   none
c
	subroutine smooth (y,npts)
	dimension y(1)
11	imax=npts-1
	yi=y(1)
21	do 24 i=1,imax
	ynew=(yi+2.*y(i)+y(i+1))/4.
	yi=y(i)
24	y(i)=ynew
25	y(npts)=(yi+3.*y(npts))/4.
	return
	end

C--------------------------------------------------------------------------
        subroutine ftclos(iunit,status)

C       close a FITS file that was previously opened with ftopen or ftinit
C
C       iunit   i  Fortran I/O unit number
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,status

        logical keep

C       close the current HDU and pad the header with blanks
        call ftchdu(iunit,status)

C       close the file
        keep=.true.
        call ftclsx(iunit,keep,status)
        end

include  defs

# gtok - get token for Ratfor

   character function gtok (lexstr, toksiz)
   character lexstr (MAXTOK)
   integer toksiz

   include COMMON_BLOCKS

   character c
   character ngetch

   integer i
#  external index
#  integer index

#  string digits "0123456789abcdefghijklmnopqrstuvwxyz"

   c = ngetch (lexstr (1))

   if (c == BLANK | c == TAB) {
      lexstr (1) = BLANK
      while (c == BLANK | c == TAB)    # compress many blanks to one
	 c = ngetch (c)
      if (c == SHARP)
	 while (ngetch (c) != NEWLINE)	 # strip comments
	    ;
      if (c != NEWLINE)
	 call putbak (c)
      else
	 lexstr (1) = NEWLINE
      lexstr (2) = EOS
      gtok = lexstr (1)
      return
      }

   i = 1
   if ((BIGA <= c & c <= BIGZ) | (LETA <= c & c <= LETZ)) {				# alpha
      gtok = ALPHA
      if (c == LETX) {				# "x$cccc" directive?
	 c = ngetch (lexstr(2))
	 if (c == DOLLAR) {
	    gtok = XPP_DIRECTIVE
	    i = 2
	    }
	 else
	    call putbak (c)
	 }

      for (;  i < toksiz - 2;  i=i+1) {
	 c = ngetch (lexstr(i+1))
	 if (!((BIGA <= c & c <= BIGZ)
	     | (LETA <= c & c <= LETZ)
	     | (DIG0 <= c & c <= DIG9)) & c != UNDERLINE)
	    break
	 }
      call putbak (c)

	} else if (DIG0 <= c & c <= DIG9) {   # digits
	    for (i=1;  i < toksiz - 2;  i=i+1) {
		c = ngetch (lexstr (i + 1))
		if (!(DIG0 <= c & c <= DIG9))
		    break
	    }
	    call putbak (c)
	    gtok = DIGIT
	}

# The following is not needed since XPP does base conversion, and this caused
# fixed point overflow on a Data General machine.
#
#      b = c - DIG0 # in case alternate base number
#      for (i = 1; i < toksiz - 2; i = i + 1) {
#	 c = ngetch (lexstr (i + 1))
#	 if (!(DIG0 <= c & c <= DIG9))
#	    break
#	 b = 10 * b + (c - DIG0)
#	 }
#      if (c == RADIX & b >= 2 & b <= 36) {   #n%ddd...
#	 n = 0
#	 repeat {
#	    d = index (digits, clower (ngetch (c))) - 1
#	    if (d < 0)
#	       break
#	    n = b * n + d
#	    }
#	 call putbak (c)
#	 i = itoc (n, lexstr, toksiz)
#	 }
#      else
#	 call putbak (c)
#      gtok = DIGIT
#      }

   else if (c == LBRACK) {   # allow [ for {
      lexstr (1) = LBRACE
      gtok = LBRACE
      }

   else if (c == RBRACK) {   # allow ] for }
      lexstr (1) = RBRACE
      gtok = RBRACE
      }

   else if (c == DOLLAR) {    # $( and $) now used by macro processor
      if (ngetch (lexstr (2)) == LPAREN) {
	 i = 2
	 gtok = LSTRIPC
	 }
      else if (lexstr (2) == RPAREN) {
	 i = 2
	 gtok = RSTRIPC
	 }
      else {
	 call putbak (lexstr (2))
	 gtok = DOLLAR
	 }
      }

   else if (c == SQUOTE | c == DQUOTE) {
      gtok = c
      for (i = 2; ngetch (lexstr (i)) != lexstr (1); i = i + 1) {
	 if (lexstr (i) == UNDERLINE)
	    if (ngetch (c) == NEWLINE) {
	       while (c == NEWLINE | c == BLANK | c == TAB)
		  c = ngetch (c)
	       lexstr (i) = c
	       }
	    else
	       call putbak (c)
	 if (lexstr (i) == NEWLINE | i >= toksiz - 1) {
	    call synerr ("missing quote.")
	    lexstr (i) = lexstr (1)
	    call putbak (NEWLINE)
	    break
	    }
	 }
      }

   else if (c == SHARP) {   # strip comments
      while (ngetch (lexstr (1)) != NEWLINE)
	 ;
      gtok = NEWLINE
      }

   else if (c == GREATER | c == LESS | c == NOT | c == BANG |
    c == TILDE | c == CARET | c == EQUALS | c == AND | c == OR) {
      call relate (lexstr, i)
      gtok = c
      }

   else
      gtok = c

   if (i >= toksiz - 1)
      call synerr ("token too long.")
   lexstr (i + 1) = EOS

   # Note:  line number accounting is now done in 'ngetch'

   return
   end

C----------------------------------------------------------------------
        subroutine ftggpb(iunit,group,fparm,nparm,array,status)

C       Read an array of group parameter values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       iunit   i  Fortran unit number
C       group   i  number of the data group, if any
C       fparm   i  the first group parameter be read (starting with 1)
C       nparm   i  number of group parameters to be read
C       array   b  returned array of values that were read
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,group,fparm,nparm,status,row 
        character*1 nulval,array(*)
        logical anynul,flgval

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
C       set nulval to blank to inhibit checking for undefined values
        nulval=' '
        row=max(1,group)
        call ftgclb(iunit,1,row,fparm,nparm,1,1,nulval,
     &      array,flgval,anynul,status)
        end

      REAL FUNCTION slBEAR (A1, B1, A2, B2)
*+
*     - - - - -
*      B E A R
*     - - - - -
*
*  Bearing (position angle) of one point on a sphere relative to another
*  (single precision)
*
*  Given:
*     A1,B1    r    spherical coordinates of one point
*     A2,B2    r    spherical coordinates of the other point
*
*  (The spherical coordinates are RA,Dec, Long,Lat etc, in radians.)
*
*  The result is the bearing (position angle), in radians, of point
*  A2,B2 as seen from point A1,B1.  It is in the range +/- pi.  If
*  A2,B2 is due east of A1,B1 the bearing is +pi/2.  Zero is returned
*  if the two points are coincident.
*
*  P.T.Wallace   Starlink   23 March 1991
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL A1,B1,A2,B2

      REAL DA,X,Y


      DA=A2-A1
      Y=SIN(DA)*COS(B2)
      X=SIN(B2)*COS(B1)-COS(B2)*SIN(B1)*COS(DA)
      IF (X.NE.0.0.OR.Y.NE.0.0) THEN
         slBEAR=ATAN2(Y,X)
      ELSE
         slBEAR=0.0
      END IF

      END

include	defs

# getccl --- expand char class at arg (i) into pat (j)

   integer function getccl (arg, i, pat, j)
   character arg (MAXARG), pat (MAXPAT)
   integer i, j

   integer jstart, junk
   integer addset

   i = i + 1	  # skip over [
   if (arg (i) == NOT) {
      junk = addset (NCCL, pat, j, MAXPAT)
      i = i + 1
      }
   else
      junk = addset (CCL, pat, j, MAXPAT)
   jstart = j
   junk = addset (0, pat, j, MAXPAT)	  # leave room for count
   call filset (CCLEND, arg, i, pat, j, MAXPAT)
   pat (jstart) = j - jstart - 1
   if (arg (i) == CCLEND)
      getccl = OK
   else
      getccl = ERR

   return
   end

C----------------------------------------------------------------------
        subroutine ftptdm(iunit,colnum,naxis,naxes,status)

C       write the TDIMnnn keyword describing the dimensionality of a column

C       iunit   i  fortran unit number to use for reading
C       colnum  i  column number to read
C       naxis   i  number of axes in the data array
C       naxes   i  array giving the length of each data axis
C       OUTPUT PARAMETERS:
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, October 1993

        integer iunit,colnum,naxis,naxes(*),status

        integer i,j,nextsp
        character tdim*120, cval*20

        if (status .gt. 0)return

        if (naxis .lt. 1 .or. naxis .gt. 100)then
C               illegal number of axes
                status=320
                return
        else if (colnum .lt. 1 .or. colnum .gt. 999)then
C               illegal column number
                status=302
                return
        end if

C       construct the keyword value
        tdim='('

        nextsp=2
        do 100 i=1,naxis
                if (naxes(i) .lt. 1)then
                        status=323
                        return
                end if

C               convert integer to right justified C*20 string
                call fti2c(naxes(i),cval,status)
                if (status .gt. 0)return

                do 20 j=20,1,-1
                        if (cval(j:j) .eq. ' ')then
                                tdim(nextsp:)=cval(j+1:20)
                                nextsp=nextsp+21-j
                                tdim(nextsp-1:)=','
                                go to 100
                        end if
20              continue
100     continue

        tdim(nextsp-1:)=')'             

        call ftpkns(iunit,'TDIM',colnum,1,tdim,
     &          'size of the multidimensional array',status)
        end

      SUBROUTINE slPLTU (DATE, ELONG, PHI, U, RA, DEC, R, JSTAT)
*+
*     - - - - - - -
*      P L A N T U
*     - - - - - - -
*
*  Topocentric apparent RA,Dec of a Solar-System object whose
*  heliocentric universal elements are known.
*
*  Given:
*     DATE      d     TT MJD of observation (JD - 2400000.5)
*     ELONG     d     observer's east longitude (radians)
*     PHI       d     observer's geodetic latitude (radians)
*     U       d(13)   universal elements
*
*               (1)   combined mass (M+m)
*               (2)   total energy of the orbit (alpha)
*               (3)   reference (osculating) epoch (t0)
*             (4-6)   position at reference epoch (r0)
*             (7-9)   velocity at reference epoch (v0)
*              (10)   heliocentric distance at reference epoch
*              (11)   r0.v0
*              (12)   date (t)
*              (13)   universal eccentric anomaly (psi) of date, approx
*
*  Returned:
*     RA,DEC    d     RA, Dec (topocentric apparent, radians)
*     R         d     distance from observer (AU)
*     JSTAT     i     status:  0 = OK
*                             -1 = radius vector zero
*                             -2 = failed to converge
*
*  Called: slGMST, slDT, slEPJ, slEPV, slUEPV, slPRNU,
*          slDMXV, slPVOB, slDC2S, slDA2P
*
*  Notes:
*
*  1  DATE is the instant for which the prediction is required.  It is
*     in the TT timescale (formerly Ephemeris Time, ET) and is a
*     Modified Julian Date (JD-2400000.5).
*
*  2  The longitude and latitude allow correction for geocentric
*     parallax.  This is usually a small effect, but can become
*     important for near-Earth asteroids.  Geocentric positions can be
*     generated by appropriate use of routines slEPV (or slEVP) and
*     slUEPV.
*
*  3  The "universal" elements are those which define the orbit for the
*     purposes of the method of universal variables (see reference 2).
*     They consist of the combined mass of the two bodies, an epoch,
*     and the position and velocity vectors (arbitrary reference frame)
*     at that epoch.  The parameter set used here includes also various
*     quantities that can, in fact, be derived from the other
*     information.  This approach is taken to avoiding unnecessary
*     computation and loss of accuracy.  The supplementary quantities
*     are (i) alpha, which is proportional to the total energy of the
*     orbit, (ii) the heliocentric distance at epoch, (iii) the
*     outwards component of the velocity at the given epoch, (iv) an
*     estimate of psi, the "universal eccentric anomaly" at a given
*     date and (v) that date.
*
*  4  The universal elements are with respect to the J2000 equator and
*     equinox.
*
*     1  Sterne, Theodore E., "An Introduction to Celestial Mechanics",
*        Interscience Publishers Inc., 1960.  Section 6.7, p199.
*
*     2  Everhart, E. & Pitkin, E.T., Am.J.Phys. 51, 712, 1983.
*
*  Last revision:   19 February 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,ELONG,PHI,U(13),RA,DEC,R
      INTEGER JSTAT

*  Light time for unit distance (sec)
      DOUBLE PRECISION TAU
      PARAMETER (TAU=499.004782D0)

      INTEGER I
      DOUBLE PRECISION DVB(3),DPB(3),VSG(6),VSP(6),V(6),RMAT(3,3),
     :                 VGP(6),STL,VGO(6),DX,DY,DZ,D,TL
      DOUBLE PRECISION slGMST,slDT,slEPJ,slDA2P



*  Sun to geocentre (J2000, velocity in AU/s).
      CALL slEPV(DATE,VSG,VSG(4),DPB,DVB)
      DO I=4,6
         VSG(I)=VSG(I)/86400D0
      END DO

*  Sun to planet (J2000).
      CALL slUEPV(DATE,U,VSP,JSTAT)

*  Geocentre to planet (J2000).
      DO I=1,6
         V(I)=VSP(I)-VSG(I)
      END DO

*  Precession and nutation to date.
      CALL slPRNU(2000D0,DATE,RMAT)
      CALL slDMXV(RMAT,V,VGP)
      CALL slDMXV(RMAT,V(4),VGP(4))

*  Geocentre to observer (date).
      STL=slGMST(DATE-slDT(slEPJ(DATE))/86400D0)+ELONG
      CALL slPVOB(PHI,0D0,STL,VGO)

*  Observer to planet (date).
      DO I=1,6
         V(I)=VGP(I)-VGO(I)
      END DO

*  Geometric distance (AU).
      DX=V(1)
      DY=V(2)
      DZ=V(3)
      D=SQRT(DX*DX+DY*DY+DZ*DZ)

*  Light time (sec).
      TL=TAU*D

*  Correct position for planetary aberration
      DO I=1,3
         V(I)=V(I)-TL*V(I+3)
      END DO

*  To RA,Dec.
      CALL slDC2S(V,RA,DEC)
      RA=slDA2P(RA)
      R=D

      END

C--------------------------------------------------------------------------
        subroutine ftpkls(ounit,keywrd,strval,comm,status)

C       write a character string value to a header record, supporting
C       the OGIP long string convention.  If the keyword string value
C       is longer than 68 characters (which is the maximum that will fit
C       on a single 80 character keyword record) then the value string will
C       be continued over multiple keywords.  This OGIP convention uses the
C       '&' character at the end of a string to indicate that it is continued
C       on the next keyword.  The name of all the continued keywords is
C       'CONTINUE'.
C
C       The FTPLSW subroutine should be called prior to using this
C       subroutine, to write a warning message in the header
C       describing how the convention works. 

C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       strval  c  keyword value 
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Sept 1994

        character*(*) keywrd,comm,strval
        integer ounit,status,lenval,ncomm,nvalue
        integer clen,i,strlen,nseg,c1,c2
        character value*70,keynam*10,cmnt*48
        
        if (status .gt. 0)return

        keynam=keywrd
        keynam(9:10)='= '
        cmnt=comm

C       find the number of characters in the input string
        clen=len(strval)
        do 10 i=clen,1,-1
                if (strval(i:i) .ne. ' ')then
                        strlen=i
                        go to 20
                end if
10      continue
        strlen=1

C       calculate the number of keywords needed to write the whole string
20      nseg=max(1,(strlen-2)/67+1)
        
        c1=1
        do 30 i=1,nseg
                c2=min(c1+67,strlen)
C               convert string to quoted character string 

C        fts2c was modified on 29 Nov 1994, so this code is no longer needed
C                (remember to declare character*70 ctemp if this code is used)
C                if (i .gt. 1 .and. strval(c1:c1) .eq. ' ')then
CC                   have to preserve leading blanks on continuation cards
C                    ctemp='A'//strval(c1+1:c2)
C                    call fts2c(ctemp,value,lenval,status)
CC                   now reset the first character of the string back to a blank
C                    value(2:2)=' '
C                else

                    call fts2c(strval(c1:c2),value,lenval,status)

C                end if

                if (i .ne. nseg .and. lenval .ne. 70)then
C                       if the string is continued, preserve trailing blanks
                        value(lenval:69)=' '
                        value(70:70)=''''
                        lenval=70
                end if

C               overwrite last character with a '&' if string is continued.
                if (i .lt. nseg)then
                        value(69:69)='&'
                end if

C               find amount of space left for comment string (assume
C               10 char. for 'keyword = ', and 3 between value and comment) 
C               which leaves 67 spaces for the value + comment strings

                nvalue=max(20,lenval)
                ncomm=67-nvalue

C               write the keyword record
                if (ncomm .gt. 0)then
C                       there is space for a comment
                        call ftprec(ounit,keynam//
     &                  value(1:nvalue)//' / '//cmnt(1:ncomm),status)
                else
C                       no room for a comment
                        call ftprec(ounit,keynam//
     &                  value(1:nvalue)//'   ',status)
                end if

C               initialize for the next segment of the string, if any
                c1=c1+67
                keynam='CONTINUE  '
30      continue
        end

      integer function match (lin, pat)
      integer lin (128), pat (128)
      integer i, junk (9)
      integer amatch
      i = 1
23000 if (.not.(lin (i) .ne. -2))goto 23002
      if (.not.(amatch (lin, i, pat, junk, junk) .gt. 0))goto 23003
      match = 1
      return
23003 continue
23001 i = i + 1
      goto 23000
23002 continue
      match = 0
      return
      end

include	defs

# strcmp - compare 2 strings; return -1 if <, 0 if =, +1 if >

   integer function strcmp (str1, str2)
   character str1 (ARB), str2 (ARB)

   integer i

   for (i = 1; str1 (i) == str2 (i); i = i + 1)
      if (str1 (i) == EOS)
	 return (0)

   if (str1 (i) == EOS)
      strcmp = -1
   else if (str2 (i) == EOS)
      strcmp = + 1
   else if (str1 (i) < str2 (i))
      strcmp = -1
   else
      strcmp = +1

   return
   end

      subroutine optn (iopnam,iopval)
      dimension       iopnam(1)      ,iopval(1)
      dimension       ichar(3)
      logical         skip
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c
      data ihigh,ilow/2hhi,2hlo/
c
c find index for input name
c
      do 101 i=1,9
         iop = i
         if (jlm2(iopnam) .eq. jlm2(mname(i))) go to 102
  101 continue
c
      call uliber (0,36hounknown name in optn or getopt call,36)
      call perror
      return
  102 continue
      if (iop.ne.2 .and. iop.ne.9) iopv = iopval(1)
c
c     if character input for intensity, change to numeric
c
      if (iop .ne. 2) go to 105
      jchar = jlm2(iopval)
      if (jchar .ne. jlm2(ihigh)) go to 103
      iopv = 204
      go to 105
  103 if (jchar .ne. jlm2(ilow)) go to 104
      iopv = 127
      go to 105
  104 iopv = iopval(1)
  105 continue
c
c     reset option if necessary
c
      if (iop .ne. 9) go to 107
      skip = modef .eq. 0
      do 106 i=1,3
         call ncgchr (iopval,3,i,ichar(i))
         call ncgchr (mop(iop),3,i,jchar)
         skip = skip .and. (jchar .eq. ichar(i))
         call ncpchr (mop(iop),3,i,ichar(i))
  106 continue
      if (skip) go to 109
      nchar = 4
      mbpair = 1*nchar+58112
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = ior(ishift(iop,8),ichar(1))
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = ior(ishift(ichar(2),8),ichar(3))
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      go to 109
  107 continue
      if (mop(iop).eq.iopv .and. modef.eq.0) go to 109
      mop(iop) = iopv
      nchar = 2
      if (iop.eq.6 .or. iop.eq.3 .or. iop.eq.4 .or. iop.eq.7) nchar = 4
      mbpair = 1*nchar+58112
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      if (nchar .eq. 4) go to 108
      mbpair = ior(ishift(iand(iop,255),8),iand(iopv,255))
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      go to 109
  108 mbpair = ishift(iop,8)
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair = iand(iopv,65535)
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
  109 return
      end

C--------------------------------------------------------------------------
        subroutine ftnulm(input,np,chktyp,setval,flgray,anynul,
     &                    scaled,scale,zero)

C       check input double complex array for nulls and apply scaling
C       if chktyp=1 then set the undefined pixel = SETVAL
C       if chktyp=2 then set the corresponding FLGRAY = .true.

C       When scaling complex data values,  both the real and imaginary
C       components of the value are scaled by SCALE, but the offset
C       given by ZERO is only applied to the real part of the complex number

C       input   d  input array of values
C       np      i  number of pairs of values 
C       chktyp  i  type of null value checking to be done if TOFITS=.false.
C                       =1  set null values = SETVAL
C                       =2  set corresponding FLGRAY value = .true.
C       setval  d  value to set output array to if value is undefined
C       flgray  l  array of logicals indicating if corresponding value is null
C       anynul  l  set to true if any nulls were set in the output array
C       scaled  l  does data need to be scaled?
C       scale   d  scale factor
C       zero    d  offset

        double precision input(*),setval(2)
        integer np,i,chktyp,j
        double precision scale,zero
        logical flgray(*),anynul,scaled
        logical fttdnn
        external fttdnn
        
        if (chktyp .eq. 2)then
C               initialize the null flag values
                do 5 i=1,np
                        flgray(i)=.false.
5               continue
        end if

        j=1
        do 10 i=1,np
C               do the real part of the complex number
                if (chktyp .ne. 0 .and. fttdnn(input(j)))then
                    anynul=.true.
                    if (chktyp .eq. 1)then
C                               set both parts of the complex number to the
C                               specified special value
                                input(j)=setval(1)
                                input(j+1)=setval(2)
                    else
C                               set the corresponding flag value to true
                                flgray(i)=.true.
                    end if
                    j=j+2
                else if (scaled)then
                    input(j)=input(j)*scale+zero
                    j=j+1

C                   do the imaginary part of the complex number
                    if (chktyp .ne. 0 .and. fttdnn(input(j)))then
                            anynul=.true.
                            if (chktyp .eq. 1)then
C                               set both parts of the complex number to the
C                               specified special value
                                input(j-1)=setval(1)
                                input(j)=setval(2)
                            else
C                               set the corresponding flag value to true
                                flgray(i)=.true.
                            end if
                    else if (scaled)then
                        input(j)=input(j)*scale
                    end if
                    j=j+1
                else
                    j=j+2
                end if
10      continue
        end

include	defs

# cupper - change letter to upper case

   character function cupper (c)
   character c

   if (c >= LETA & c <= LETZ)
      cupper = c + (BIGA - LETA)
   else
      cupper = c

   return
   end

      integer function index (str, c)
      integer str (100), c
      index = 1
23000 if (.not.(str (index) .ne. -2))goto 23002
      if (.not.(str (index) .eq. c))goto 23003
      return
23003 continue
23001 index = index + 1
      goto 23000
23002 continue
      index = 0
      return
      end

include	defs

# clower - change letter to lower case

   character function clower(c)
   character c

   character k

   if (c >= BIGA & c <= BIGZ) {
      k = LETA - BIGA	# avoid integer overflow in byte machines
      clower = c + k
      }
   else
      clower = c

   return
   end

#-h-  doincr			  246  local   12/01/80  15:53:49
# doincr - increment macro argument by 1
   include  defs

   subroutine doincr (argstk, i, j)
   integer argstk (ARGSIZE), i, j

   include COMMON_BLOCKS

   integer k
   integer ctoi

   k = argstk (i + 2)
   call pbnum (ctoi (evalst, k) + 1)

   return
   end

      subroutine catsub (lin, from, to, sub, new, k, maxnew)
      integer lin(128)
      integer from(10), to(10)
      integer maxnew
      integer sub(maxnew), new(128)
      integer k
      integer i, j, junk, ri
      integer addset
      i = 1
23000 if (.not.(sub (i) .ne. -2))goto 23002
      if (.not.(sub (i) .eq. -3))goto 23003
      i = i + 1
      ri = sub (i) + 1
      j = from (ri)
23005 if (.not.(j .lt. to (ri)))goto 23007
      junk = addset (lin (j), new, k, maxnew)
23006 j = j + 1
      goto 23005
23007 continue
      goto 23004
23003 continue
      junk = addset (sub (i), new, k, maxnew)
23004 continue
23001 i = i + 1
      goto 23000
23002 continue
      return
      end

      DOUBLE PRECISION FUNCTION slARMS (ZD)
*+
*     - - - - - - -
*      A R M S
*     - - - - - - -
*
*  Air mass at given zenith distance (double precision)
*
*  Given:
*     ZD     d     Observed zenith distance (radians)
*
*  The result is an estimate of the air mass, in units of that
*  at the zenith.
*
*  Notes:
*
*  1)  The "observed" zenith distance referred to above means "as
*      affected by refraction".
*
*  2)  Uses Hardie's (1962) polynomial fit to Bemporad's data for
*      the relative air mass, X, in units of thickness at the zenith
*      as tabulated by Schoenberg (1929). This is adequate for all
*      normal needs as it is accurate to better than 0.1% up to X =
*      6.8 and better than 1% up to X = 10. Bemporad's tabulated
*      values are unlikely to be trustworthy to such accuracy
*      because of variations in density, pressure and other
*      conditions in the atmosphere from those assumed in his work.
*
*  3)  The sign of the ZD is ignored.
*
*  4)  At zenith distances greater than about ZD = 87 degrees the
*      air mass is held constant to avoid arithmetic overflows.
*
*  References:
*     Hardie, R.H., 1962, in "Astronomical Techniques"
*        ed. W.A. Hiltner, University of Chicago Press, p180.
*     Schoenberg, E., 1929, Hdb. d. Ap.,
*        Berlin, Julius Springer, 2, 268.
*
*  Original code by P.W.Hill, St Andrews
*
*  P.T.Wallace   Starlink   18 March 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION ZD

      DOUBLE PRECISION SECZM1


      SECZM1 = 1D0/(COS(MIN(1.52D0,ABS(ZD))))-1D0
      slARMS = 1D0 + SECZM1*(0.9981833D0
     :             - SECZM1*(0.002875D0 + 0.0008083D0*SECZM1))

      END

      SUBROUTINE slF5HZ (R5,D5,EPOCH,RH,DH)
*+
*     - - - - - -
*      F 5 H Z
*     - - - - - -
*
*  Transform an FK5 (J2000) star position into the frame of the
*  Hipparcos catalogue, assuming zero Hipparcos proper motion.
*
*  (double precision)
*
*  This routine converts a star position from the FK5 system to
*  the Hipparcos system, in such a way that the Hipparcos proper
*  motion is zero.  Because such a star has, in general, a non-zero
*  proper motion in the FK5 system, the routine requires the epoch
*  at which the position in the FK5 system was determined.
*
*  Given:
*     R5        d      FK5 RA (radians), equinox J2000, epoch EPOCH
*     D5        d      FK5 Dec (radians), equinox J2000, epoch EPOCH
*     EPOCH     d      Julian epoch (TDB)
*
*  Returned (all Hipparcos):
*     RH        d      RA (radians)
*     DH        d      Dec (radians)
*
*  Called:  slDS2C, slDAVM, slDIMV, slDMXV, slDC2S,
*           slDA2P
*
*  Notes:
*
*  1)  The FK5 to Hipparcos transformation consists of a pure
*      rotation and spin;  zonal errors in the FK5 catalogue are
*      not taken into account.
*
*  2)  The published orientation and spin components are interpreted
*      as "axial vectors".  An axial vector points at the pole of the
*      rotation and its length is the amount of rotation in radians.
*
*  3)  See also slFK5H, slHFK5, slHF5Z.
*
*  Reference:
*
*     M.Feissel & F.Mignard, Astron. Astrophys. 331, L33-L36 (1998).
*
*  P.T.Wallace   Starlink   22 June 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R5,D5,EPOCH,RH,DH

      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

*  FK5 to Hipparcos orientation and spin (radians, radians/year)
      DOUBLE PRECISION EPX,EPY,EPZ
      DOUBLE PRECISION OMX,OMY,OMZ

      PARAMETER ( EPX = -19.9D-3 * AS2R,
     :            EPY =  -9.1D-3 * AS2R,
     :            EPZ = +22.9D-3 * AS2R )

      PARAMETER ( OMX = -0.30D-3 * AS2R,
     :            OMY = +0.60D-3 * AS2R,
     :            OMZ = +0.70D-3 * AS2R )

      DOUBLE PRECISION P5E(3),ORTN(3),R5H(3,3),T,VST(3),RST(3,3),
     :                 P5(3),PH(3),W

      DOUBLE PRECISION slDA2P



*  FK5 barycentric position vector.
      CALL slDS2C(R5,D5,P5E)

*  FK5 to Hipparcos orientation matrix.
      ORTN(1) = EPX
      ORTN(2) = EPY
      ORTN(3) = EPZ
      CALL slDAVM(ORTN,R5H)

*  Time interval from epoch to J2000.
      T = 2000D0-EPOCH

*  Axial vector:  accumulated Hipparcos wrt FK5 spin over that interval.
      VST(1) = OMX*T
      VST(2) = OMY*T
      VST(3) = OMZ*T

*  Express the accumulated spin as a rotation matrix.
      CALL slDAVM(VST,RST)

*  Derotate the vector's FK5 axes back to epoch.
      CALL slDIMV(RST,P5E,P5)

*  Rotate the vector into the Hipparcos frame.
      CALL slDMXV(R5H,P5,PH)

*  Hipparcos vector to spherical.
      CALL slDC2S(PH,W,DH)
      RH = slDA2P(W)

      END

      subroutine cwidth ( w,b,nequ,ncols,integs,nbloks, d, x,iflag )
c  this program is a variation of the theme in the algorithm bandet1
c  by martin and wilkinson (numer.math. 9(1976)279-307). it solves
c  the linear system
c			    a*x  =  b
c  of  nequ  equations in case	a  is almost block diagonal with all
c  blocks having  ncols  columns using no more storage than it takes to

c  store the interesting part of  a . such systems occur in the determ-

c  ination of the b-spline coefficients of a spline approximation.
c
c			    parameters
c  w	 on input, a two-dimensional array of size (nequ,ncols) contain-
c	 ing the interesting part of the almost block diagonal coeffici-
c	 ent matrix  a (see description and example below). the array
c	 integs  describes the storage scheme.
c	 on output, w  contains the upper triangular factor  u	of the
c	 lu factorization of a possibly permuted version of  a . in par-
c	 ticular, the determinant of  a  could now be found as
c	     iflag*w(1,1)*w(2,1)* ... * w(nequ,1)  .
c  b	 on input, the right side of the linear system, of length  nequ.
c	 the contents of  b  are changed during execution.
c  nequ  number of equations in system
c  ncols block width, i.e., number of columns in each block.
c  integs  integer array, of size (2,nequ), describing the block struct-
c	 ure of  a .
c	    integs(1,i) = no. of rows in block i	       =  nrow
c	    integs(2,i) = no. of elimination steps in block i
c			= overhang over next block	       =  last
c  nbloks  number of blocks
c  d	 work array, to contain row sizes . if storage is scarce, the
c	 array	x  could be used in the calling sequence for  d .
c  x	 on output, contains computed solution (if iflag .ne. 0), of
c	 length  nequ .
c  iflag  on output, integer
c	  = (-1)**(no.of interchanges during elimination)
c		 if  a	is invertible
c	  =  0	 if  a	is singular
c
c	 ------  block structure of  a	------
c     the interesting part of  a  is taken to consist of  nbloks  con-
c  secutive blocks, with the i-th block made up of  nrowi = integs(1,i)

c  consecutive rows and  ncols	consecutive columns of	a , and with
c  the first  lasti = integs(2,i) columns to the left of the next block.
c  these blocks are stored consecutively in the workarray  w .
c     for example, here is an 11th order matrix and its arrangement in
c  the workarray  w . (the interesting entries of  a  are indicated by
c  their row and column index modulo 10.)
c
c		   ---	 a   ---			  ---	w   ---

c
c		      nrow1=3
c	   11 12 13 14					   11 12 13 14
c	   21 22 23 24					   21 22 23 24
c	   31 32 33 34	    nrow2=2			   31 32 33 34
c   last1=2	 43 44 45 46				   43 44 45 46
c		 53 54 55 56	     nrow3=3		   53 54 55 56
c	  last2=3	  66 67 68 69			   66 67 68 69
c			  76 77 78 79			   76 77 78 79
c			  86 87 88 89	nrow4=1 	   86 87 88 89
c		   last3=1   97 98 99 90   nrow5=2	   97 98 99 90
c		      last4=1	08 09 00 01		   08 09 00 01
c				18 19 10 11		   18 19 10 11
c			 last5=4
c
c  for this interpretation of  a  as an almost block diagonal matrix,
c  we have  nbloks = 5 , and the integs array is
c
c			 i=  1	 2   3	 4   5
c		   k=
c  integs(k,i) =      1      3	 2   3	 1   2
c		      2      2	 3   1	 1   4
c
c	--------  method  --------
c     gauss elimination with scaled partial pivoting is used, but mult-

c  ipliers are	n o t  s a v e d  in order to save storage. rather, the

c  right side is operated on during elimination.
c     the two parameters
c		   i p v t e q	 and  l a s t e q
c  are used to keep track of the action.  ipvteq is the index of the
c  variable to be eliminated next, from equations  ipvteq+1,...,lasteq,

c  using equation  ipvteq (possibly after an interchange) as the pivot
c  equation. the entries in the pivot column are  a l w a y s  in column
c  1 of  w . this is accomplished by putting the entries in rows
c  ipvteq+1,...,lasteq	revised by the elimination of the  ipvteq-th
c  variable one to the left in	w . in this way, the columns of the
c  equations in a given block (as stored in  w ) will be aligned with
c  those of the next block at the moment when these next equations be-
c  come involved in the elimination process.
c     thus, for the above example, the first elimination steps proceed
c  as follows.
c
c  *11 12 13 14    11 12 13 14	  11 12 13 14	 11 12 13 14
c  *21 22 23 24   *22 23 24	  22 23 24	 22 23 24
c  *31 32 33 34   *32 33 34	 *33 34 	 33 34
c   43 44 45 46    43 44 45 46	 *43 44 45 46	*44 45 46	 etc.
c   53 54 55 56    53 54 55 56	 *53 54 55 56	*54 55 56
c   66 67 68 69    66 67 68 69	  66 67 68 69	 66 67 68 69
c	 .		.	       .	      .
c
c     in all other respects, the procedure is standard, including the
c  scaled partial pivoting.
c
      integer nbloks, ipvtp1, jmax
      integer iflag,integs(2,nbloks),ncols,nequ,   i,ii,icount,ipvteq
     *			   ,istar,j,lastcl,lasteq,lasti,nexteq,nrowad
      real b(nequ),d(nequ),w(nequ,ncols),x(nequ),   awi1od,colmax
     *	   ,ratio,sum				   ,rowmax,temp
      iflag = 1
      ipvteq = 0
      lasteq = 0
c				  the i-loop runs over the blocks
      do 50 i=1,nbloks
c
c	 the equations for the current block are added to those current-
c	 ly involved in the elimination process, by increasing	lasteq
c	 by  integs(1,i) after the rowsize of these equations has been
c	 recorded in the array	d .
c
	 nrowad = integs(1,i)
	 do 10 icount=1,nrowad
	    nexteq = lasteq + icount
	    rowmax = 0.
	    do 5 j=1,ncols
    5	       rowmax = amax1(rowmax,abs(w(nexteq,j)))
	    if (rowmax .eq. 0.) 	go to 999
   10	    d(nexteq) = rowmax
	 lasteq = lasteq + nrowad
c
c	 there will be	lasti = integs(2,i)  elimination steps before
c	 the equations in the next block become involved. further,
c	 l a s t c l  records the number of columns involved in the cur-
c	 rent elimination step. it starts equal to  ncols  when a block

c	 first becomes involved and then drops by one after each elim-
c	 ination step.
c
	 lastcl = ncols
	 lasti = integs(2,i)
	 do 30 icount=1,lasti
	    ipvteq = ipvteq + 1
	    if (ipvteq .lt. lasteq)	go to 11
	    if ( abs(w(ipvteq,1))+d(ipvteq) .gt. d(ipvteq) )
     *					go to 50
					go to 999
c
c	 determine the smallest  i s t a r  in	(ipvteq,lasteq)  for
c	 which	abs(w(istar,1))/d(istar)  is as large as possible, and
c	 interchange equations	ipvteq	and  istar  in case  ipvteq
c	 .lt. istar .
c
   11	    colmax = abs(w(ipvteq,1))/d(ipvteq)
	    istar = ipvteq
	    ipvtp1 = ipvteq + 1
	    do 13 ii=ipvtp1,lasteq
	       awi1od = abs(w(ii,1))/d(ii)
	       if (awi1od .le. colmax)	go to 13
	       colmax = awi1od
	       istar = ii
   13	       continue
	    if ( abs(w(istar,1))+d(istar) .eq. d(istar) )
     *					go to 999
	    if (istar .eq. ipvteq)	go to 16
	    iflag = -iflag
	    temp = d(istar)
	    d(istar) = d(ipvteq)
	    d(ipvteq) = temp
	    temp = b(istar)
	    b(istar) = b(ipvteq)
	    b(ipvteq) = temp
	    do 14 j=1,lastcl
	       temp = w(istar,j)
	       w(istar,j) = w(ipvteq,j)
   14	       w(ipvteq,j) = temp
c
c	 subtract the appropriate multiple of equation	ipvteq	from
c	 equations  ipvteq+1,...,lasteq to make the coefficient of the
c	 ipvteq-th unknown (presently in column 1 of  w ) zero, but
c	 store the new coefficients in	w  one to the left from the old.
c
   16	    do 20 ii=ipvtp1,lasteq
	       ratio = w(ii,1)/w(ipvteq,1)
	       do 18 j=2,lastcl
   18		  w(ii,j-1) = w(ii,j) - ratio*w(ipvteq,j)
	       w(ii,lastcl) = 0.
   20	       b(ii) = b(ii) - ratio*b(ipvteq)
   30	    lastcl = lastcl - 1
   50	 continue
c
c  at this point,  w  and  b  contain an upper triangular linear system

c  equivalent to the original one, with  w(i,j) containing entry
c  (i, i-1+j ) of the coefficient matrix. solve this system by backsub-

c  stitution, taking into account its block structure.
c
c			   i-loop over the blocks, in reverse order
      i = nbloks
   59	 lasti = integs(2,i)
	 jmax = ncols - lasti
	 do 70 icount=1,lasti
	    sum = 0.
	    if (jmax .eq. 0)		go to 61
	    do 60 j=1,jmax
   60	       sum = sum + x(ipvteq+j)*w(ipvteq,j+1)
   61	    x(ipvteq) = (b(ipvteq)-sum)/w(ipvteq,1)
	    jmax = jmax + 1
   70	    ipvteq = ipvteq - 1
	 i = i - 1
	 if (i .gt. 0)			go to 59
					return
  999 iflag = 0
					return
      end

C--------------------------------------------------------------------------
        subroutine ftucrd(ounit,keywrd,card,status)

C       update a 80-character FITS header card/record
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       card    c  80-character FITS card image
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, May 1995

        character*(*) keywrd,card
        integer ounit,status,tstat

        if (status .gt. 0)return
        tstat=status

C       try modifying the card, if it exists
        call ftmcrd(ounit,keywrd,card,status)

        if (status .eq. 202)then
C               card doesn't exist, so create it
                status=tstat
                call ftprec(ounit,card,status)
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftdblk(ounit,nblock,hdrdat,status)

C       delete  2880-byte FITS blocks at the end of the current header or data

C       ounit   i  fortran output unit number
C       nblock  i  number of 2880-byte blocks to be deleted
C       hdrdat  i  delete space at end of header (0) or data (1)
C       status  i  returned error status (0=ok)

        integer ounit,nblock,hdrdat,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS:------------------------------------

        integer ibuff,jpoint,i,tstat

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

C       get address of first block to be deleted/overwritten
        if (hdrdat .eq. 0)then
            jpoint=dtstrt(ibuff)-2880*nblock
        else
            jpoint=hdstrt(ibuff,chdu(ibuff)+1)-2880*nblock
        end if

C       move each block up, until we reach the end of file
10      continue
C           move to the read start position
            tstat=status
            call ftmbyt(ounit,jpoint+nblock*2880,.false.,status)

C           read one 2880-byte FITS logical record 
            call ftgcbf(ounit,0,2880,buff,status)

C           check for end of file
            if (status .eq. 107)then
                status=tstat
                go to 20
            end if

C           move back to the write start postion
            call ftmbyt(ounit,jpoint,.false.,status)

C           write the 2880-byte FITS logical record
            call ftpcbf(ounit,0,2880,buff,status)

C           check for error 
            if (status .gt. 0)then
                call ftpmsg('Error deleting FITS blocks (FTDBLK)')
                return
            end if

C           increment pointer to next block and loop back
            jpoint=jpoint+2880
            go to 10
20      continue

C       now fill the last nblock blocks with zeros;  initialize the  buffer
        do 30 i=1,2880
            buff(i)=char(0)
30      continue

C       move back to the write start postion
        call ftmbyt(ounit,jpoint,.false.,status)

C       write the 2880-byte block NBLOCK times.
        do 40 i=1,nblock
            call ftpcbf(ounit,0,2880,buff,status)
40      continue

        if (hdrdat .eq. 0)then
C           recalculate the starting location of the current data unit, if moved
            dtstrt(ibuff)=dtstrt(ibuff)-2880*nblock
        end if

C       recalculate the starting location of all subsequent HDUs
        do 50 i=chdu(ibuff)+1,maxhdu(ibuff)+1
            hdstrt(ibuff,i)=hdstrt(ibuff,i)-2880*nblock
50      continue

        if (status .gt. 0)then
            call ftpmsg('Error deleting FITS block(s) (FTDBLK)')
        end if
        end

      subroutine putins (nopcd,ins,nchar)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      dimension       ins(nchar)
      kopcd = nopcd
      kchar = nchar
c
c put in the two header bytes
c
      if (kopcd.lt.0 .or. kopcd.gt.63) go to 102
      mbpair = ior(ishift(kopcd+192,8),kchar)
      mipair = mipair+1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      if (kchar .eq. 0) return
      if (kchar.lt.0 .or. kchar.ge.255) go to 103
c
c put character string into instruction string
c
      do 101 i=1,kchar,2
         call ncgchr (ins,kchar,i,jcharl)
         call ncgchr (ins,kchar,i+1,jcharr)
         mbpair = ior(ishift(jcharl,8),jcharr)
         mipair = mipair+1
         mbprs(mipair) = mbpair
         if (mipair .ge. 16) call flushb
  101 continue
      return
  102 continue
c     write (mprint,1001) kopcd
c
      call uliber (0,40h0in putins call, nopcd .lt. 0 or .ge. 63,40)
      call perror
      return
  103 continue
c     write (mprint,1002) kchar
c
      call uliber (0,41h0in putins call, nchar .le. 0 or .ge. 255,41)
      call perror
      return
c
c1001 format (7h0nopcd=,i10)
c1002 format (7h0nchar=,i10)
c
      end

C----------------------------------------------------------------------
        subroutine ftghpr(iunit,maxdim,simple,bitpix,naxis,naxes,
     &                    pcount,gcount,extend,status)

C       get the required primary header or image extension keywords
C
C       iunit   i  fortran unit number to use for reading
C       maxdim  i  maximum no. of dimensions to read; dimension of naxes
C       OUTPUT PARAMETERS:
C       simple  l  does file conform to FITS standard?
C       bitpix  i  number of bits per data value
C       naxis   i  number of axes in the data array
C       naxes   i  array giving the length of each data axis
C       pcount  i  number of group parameters (usually 0)
C       gcount  i  number of random groups (usually 1 or 0)
C       extend  l  may extensions be present in the FITS file?
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,bitpix,naxis,naxes(*),pcount,gcount,blank,status
        integer maxdim,nblank
        logical simple,extend
        double precision fill
        
        call ftgphx(iunit,maxdim,simple,bitpix,naxis,naxes,
     &        pcount,gcount,extend,fill,fill,blank,nblank,status)
        end

      SUBROUTINE slPRBN (BEP0, BEP1, RMATP)
*+
*     - - - - - -
*      P R B N
*     - - - - - -
*
*  Generate the matrix of precession between two epochs,
*  using the old, pre-IAU1976, Bessel-Newcomb model, using
*  Kinoshita's formulation (double precision)
*
*  Given:
*     BEP0    dp         beginning Besselian epoch
*     BEP1    dp         ending Besselian epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  The matrix is in the sense   V(BEP1)  =  RMATP * V(BEP0)
*
*  Reference:
*     Kinoshita, H. (1975) 'Formulas for precession', SAO Special
*     Report No. 364, Smithsonian Institution Astrophysical
*     Observatory, Cambridge, Massachusetts.
*
*  Called:  slDEUL
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION BEP0,BEP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION BIGT,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch B1850.0 and beginning epoch in TC
      BIGT = (BEP0-1850D0)/100D0

*  Interval over which precession required, in tropical centuries
      T = (BEP1-BEP0)/100D0

*  Euler angles
      TAS2R = T*AS2R
      W = 2303.5548D0+(1.39720D0+0.000059D0*BIGT)*BIGT

      ZETA = (W+(0.30242D0-0.000269D0*BIGT+0.017996D0*T)*T)*TAS2R
      Z = (W+(1.09478D0+0.000387D0*BIGT+0.018324D0*T)*T)*TAS2R
      THETA = (2005.1125D0+(-0.85294D0-0.000365D0*BIGT)*BIGT+
     :        (-0.42647D0-0.000365D0*BIGT-0.041802D0*T)*T)*TAS2R

*  Rotation matrix
      CALL slDEUL('ZYZ',-ZETA,THETA,-Z,RMATP)

      END

C--------------------------------------------------------------------------
        subroutine ftikyg(ounit,keywrd,dval,decim,comm,status)

C       insert a double F keyword into the header at the current position
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       dval    d  keyword value 
C       decim   i  number of decimal places to display in value field
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, March 1993

        character*(*) keywrd,comm
        integer ounit,status,decim
        double precision dval

        character value*20,key*8,com*47
        character*80 record
        integer nkeys,keypos

        if (status .gt. 0)return

C       convert double to F format character string and construct the record
        call ftd2f(dval,decim,value,status)
        key=keywrd
        com=comm
        record=key//'= '//value//' / '//com

        call ftghps(ounit,nkeys,keypos,status)
        call ftirec(ounit,keypos,record,status)
        end

      SUBROUTINE slDAVM (AXVEC, RMAT)
*+
*     - - - - - -
*      D A V M
*     - - - - - -
*
*  Form the rotation matrix corresponding to a given axial vector.
*  (double precision)
*
*  A rotation matrix describes a rotation about some arbitrary axis,
*  called the Euler axis.  The "axial vector" supplied to this routine
*  has the same direction as the Euler axis, and its magnitude is the
*  amount of rotation in radians.
*
*  Given:
*    AXVEC  d(3)     axial vector (radians)
*
*  Returned:
*    RMAT   d(3,3)   rotation matrix
*
*  If AXVEC is null, the unit matrix is returned.
*
*  The reference frame rotates clockwise as seen looking along
*  the axial vector from the origin.
*
*  Last revision:   26 November 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION AXVEC(3),RMAT(3,3)

      DOUBLE PRECISION X,Y,Z,PHI,S,C,W



*  Rotation angle - magnitude of axial vector - and functions
      X = AXVEC(1)
      Y = AXVEC(2)
      Z = AXVEC(3)
      PHI = SQRT(X*X+Y*Y+Z*Z)
      S = SIN(PHI)
      C = COS(PHI)
      W = 1D0-C

*  Euler axis - direction of axial vector (perhaps null)
      IF (PHI.NE.0D0) THEN
         X = X/PHI
         Y = Y/PHI
         Z = Z/PHI
      END IF

*  Compute the rotation matrix
      RMAT(1,1) = X*X*W+C
      RMAT(1,2) = X*Y*W+Z*S
      RMAT(1,3) = X*Z*W-Y*S
      RMAT(2,1) = X*Y*W-Z*S
      RMAT(2,2) = Y*Y*W+C
      RMAT(2,3) = Y*Z*W+X*S
      RMAT(3,1) = X*Z*W+Y*S
      RMAT(3,2) = Y*Z*W-X*S
      RMAT(3,3) = Z*Z*W+C

      END

#-h-  swend			 2714  local   12/01/80  15:55:07
# swend - finish off switch statement; generate dispatch code
   include  defs

   subroutine swend (lab)
   integer lab

   include COMMON_BLOCKS

   integer lb, ub, n, i, j, swn

   string sif "if ("
   string slt ".lt.1.or."
   string sgt ".gt."
   string sgoto "goto ("
   string seq ".eq."
   string sge ".ge."
   string sle ".le."
   string sand ".and."

   swn = swvstk(swvlev)		#get switch variable number, SWnnnn
   swvlev = max(0, swvlev - 1)

   lb = swstak (swtop + 3)
   ub = swstak (swlast - 2)
   n = swstak (swtop + 1)
   call outgo (lab + 1) # terminate last case
   if (swstak (swtop + 2) == 0)
      swstak (swtop + 2) = lab + 1  # default default label
   xfer = NO
   call indent (-1)
   call outcon (lab)  # L   continue
   call indent (1)
   if (n >= CUTOFF & ub - lb + 1 < DENSITY * n) { # output branch table
      if (lb != 1) {  # L  Innn=Innn-lb+1
	 call outtab
	 call swvar (swn)
	 call outch (EQUALS)
	 call swvar (swn)
	 if (lb < 1)
	    call outch (PLUS)
	 call outnum (-lb + 1)
	 call outdon
	 }
      if (swinrg == NO) {
	  call outtab  #  if (Innn.lt.1.or.Innn.gt.ub-lb+1)goto default
	  call outstr (sif)
	  call swvar (swn)
	  call outstr (slt)
	  call swvar (swn)
	  call outstr (sgt)
	  call outnum (ub - lb + 1)
	  call outch (RPAREN)
	  call outch (BLANK)
	  call outgo (swstak (swtop + 2))
      }
      call outtab  #  goto (....),Innn
      call outstr (sgoto)
      j = lb
      for (i = swtop + 3; i < swlast; i = i + 3) {
	 for ( ; j < swstak (i); j = j + 1) { # fill in vacancies
	    call outnum (swstak (swtop + 2))
	    call outch (COMMA)
	    }
	 for (j = swstak (i + 1) - swstak (i); j >= 0; j = j - 1)
	    call outnum (swstak (i + 2)) # fill in range
	 j = swstak (i + 1) + 1
	 if (i < swlast - 3)
	    call outch (COMMA)
	 }
      call outch (RPAREN)
      call outch (COMMA)
      call swvar (swn)
      call outdon
      }
   else if (n > 0) {  # output linear search form
      for (i = swtop + 3; i < swlast; i = i + 3) {
	 call outtab  # if (Innn
	 call outstr (sif)
	 call swvar (swn)
	 if (swstak (i) == swstak (i+1)) {
	    call outstr (seq) #   .eq....
	    call outnum (swstak (i))
	    }
	 else {
	    call outstr (sge) #   .ge.lb.and.Innn.le.ub
	    call outnum (swstak (i))
	    call outstr (sand)
	    call swvar (swn)
	    call outstr (sle)
	    call outnum (swstak (i + 1))
	    }
	 call outch (RPAREN) #	  ) goto ...
	 call outch (BLANK)
	 call outgo (swstak (i + 2))
	 }
      if (lab + 1 != swstak (swtop + 2))
	 call outgo (swstak (swtop + 2))
      }
   call indent (-1)
   call outcon (lab + 1)   # L+1  continue
   swlast = swtop # pop switch stack
   swtop = swstak (swtop)
   swinrg = NO
   return
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
      FUNCTION CFUX (RX)
C
C Given an x coordinate RX in the fractional system, CFUX(RX) is an x
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=1
      IF (MI.GE.3) I=2
      CFUX=WD(I)+(RX-VP(1))/(VP(2)-VP(1))*(WD(3-I)-WD(I))
      IF (LL.GE.3) CFUX=10.**CFUX
      RETURN
      END
      FUNCTION CFUY (RY)
C
C Given a y coordinate RY in the fractional system, CFUY(RY) is a y
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      CFUY=WD(I)+(RY-VP(3))/(VP(4)-VP(3))*(WD(7-I)-WD(I))
      IF (LL.EQ.2.OR.LL.GE.4) CFUY=10.**CFUY
      RETURN
      END
      FUNCTION CMFX (IX)
C
C Given an x coordinate IX in the metacode system, CMFX(IX) is an x
C coordinate in the fractional system.
C
      CMFX=FLOAT(IX)/32767.
      RETURN
      END
      FUNCTION CMFY (IY)
C
C Given a y coordinate IY in the metacode system, CMFY(IY) is a y
C coordinate in the fractional system.
C
      CMFY=FLOAT(IY)/32767.
      RETURN
      END
      FUNCTION CMUX (IX)
C
C Given an x coordinate IX in the metacode system, CMUX(IX) is an x
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=1
      IF (MI.GE.3) I=2
      CMUX=WD(I)+(FLOAT(IX)/32767.-VP(1))/(VP(2)-VP(1))*(WD(3-I)-WD(I))
      IF (LL.GE.3) CMUX=10.**CMUX
      RETURN
      END
      FUNCTION CMUY (IY)
C
C Given a y coordinate IY in the metacode system, CMUY(IY) is a y
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      CMUY=WD(I)+(FLOAT(IY)/32767.-VP(3))/(VP(4)-VP(3))*(WD(7-I)-WD(I))
      IF (LL.EQ.2.OR.LL.GE.4) CMUY=10.**CMUY
      RETURN
      END
      FUNCTION CPFX (IX)
C
C Given an x coordinate IX in the plotter system, CPFX(IX) is an x
C coordinate in the fractional system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      CPFX=FLOAT(IX-1)/(2.**MX-1.)
      RETURN
      END
      FUNCTION CPFY (IY)
C
C Given a y coordinate IY in the plotter system, CPFY(IY) is a y
C coordinate in the fractional system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      CPFY=FLOAT(IY-1)/(2.**MY-1.)
      RETURN
      END
      FUNCTION CPUX (IX)
C
C Given an x coordinate IX in the plotter system, CPUX(IX) is an x
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=1
      IF (MI.GE.3) I=2
      CPUX=WD(I)+(FLOAT(IX-1)/(2.**MX-1.)-VP(1))/(VP(2)-VP(1))*
     +           (WD(3-I)-WD(I))
      IF (LL.GE.3) CPUX=10.**CPUX
      RETURN
      END
      FUNCTION CPUY (IY)
C
C Given a y coordinate IY in the plotter system, CPUY(IY) is a y
C coordinate in the user system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      CPUY=WD(I)+(FLOAT(IY-1)/(2.**MY-1.)-VP(3))/(VP(4)-VP(3))*
     +     (WD(7-I)-WD(I))
      IF (LL.EQ.2.OR.LL.GE.4) CPUY=10.**CPUY
      RETURN
      END
      FUNCTION CUFX (RX)
C
C Given an x coordinate RX in the user system, CUFX(RX) is an x
C coordinate in the fractional system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=1
      IF (MI.GE.3) I=2
      IF (LL.LE.2) THEN
        CUFX=(RX-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+VP(1)
      ELSE
        CUFX=(ALOG10(RX)-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+VP(1)
      ENDIF
      RETURN
      END
      FUNCTION CUFY (RY)
C
C Given a y coordinate RY in the user system, CUFY(RY) is a y
C coordinate in the fractional system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      IF (LL.LE.1.OR.LL.EQ.3) THEN
        CUFY=(RY-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+VP(3)
      ELSE
        CUFY=(ALOG10(RY)-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+VP(3)
      ENDIF
      RETURN
      END
      FUNCTION KFMX (RX)
C
C Given an x coordinate RX in the fractional system, KFMX(RX) is an x
C coordinate in the metacode system.
C
      KFMX=IFIX(RX*32767.)
      RETURN
      END
      FUNCTION KFMY (RY)
C
C Given a y coordinate RY in the fractional system, KFMY(RY) is a y
C coordinate in the metacode system.
C
      KFMY=IFIX(RY*32767.)
      RETURN
      END
      FUNCTION KFPX (RX)
C
C Given an x coordinate RX in the fractional system, KFPX(RX) is an x
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      KFPX=1+IFIX(RX*(2.**MX-1.))
      RETURN
      END
      FUNCTION KFPY (RY)
C
C Given a y coordinate RY in the fractional system, KFPY(RY) is a y
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      KFPY=1+IFIX(RY*(2.**MX-1.))
      RETURN
      END
      FUNCTION KMPX (IX)
C
C Given an x coordinate IX in the metacode system, KMPX(IX) is an x
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      KMPX=1+IFIX((2.**MX-1.)*FLOAT(IX)/32767.)
      RETURN
      END
      FUNCTION KMPY (IY)
C
C Given a y coordinate IY in the metacode system, KMPY(IY) is a y
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      KMPY=1+IFIX((2.**MY-1.)*FLOAT(IY)/32767.)
      RETURN
      END
      FUNCTION KPMX (IX)
C
C Given an x coordinate IX in the plotter system, KPMX(IX) is an x
C coordinate in the metacode system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      KPMX=IFIX(32767.*FLOAT(IX-1)/(2.**MX-1.))
      RETURN
      END
      FUNCTION KPMY (IY)
C
C Given a y coordinate IY in the plotter system, KPMY(IY) is a y
C coordinate in the metacode system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      KPMY=IFIX(32767.*FLOAT(IY-1)/(2.**MY-1.))
      RETURN
      END
      FUNCTION KUMX (RX)
C
C Given an x coordinate RX in the user system, KUMX(RX) is an x
C coordinate in the metacode system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=1
      IF (MI.GE.3) I=2
      IF (LL.LE.2) THEN
        KUMX=IFIX(((RX-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+VP(1))*
     +              32767.)
      ELSE
        KUMX=IFIX(((ALOG10(RX)-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+
     +              VP(1))*32767.)
      ENDIF
      RETURN
      END
      FUNCTION KUMY (RY)
C
C Given a y coordinate RY in the user system, KUMY(RY) is a y
C coordinate in the metacode system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      IF (LL.LE.1.OR.LL.EQ.3) THEN
        KUMY=IFIX(((RY-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+VP(3))*
     +              32767.)
      ELSE
        KUMY=IFIX(((ALOG10(RY)-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+
     +              VP(3))*32767.)
      ENDIF
      RETURN
      END
      FUNCTION KUPX (RX)
C
C Given an x coordinate RX in the user system, KUPX(RX) is an x
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=1
      IF (MI.GE.3) I=2
      IF (LL.LE.2) THEN
        KUPX=1+IFIX(((RX-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+VP(1))*
     +              (2.**MX-1.))
      ELSE
        KUPX=1+IFIX(((ALOG10(RX)-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+
     +              VP(1))*(2.**MX-1.))
      ENDIF
      RETURN
      END
      FUNCTION KUPY (RY)
C
C Given a y coordinate RY in the user system, KUPY(RY) is a y
C coordinate in the plotter system.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
      DIMENSION WD(4),VP(4)
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      IF (LL.LE.1.OR.LL.EQ.3) THEN
        KUPY=1+IFIX(((RY-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+VP(3))*
     +              (2.**MY-1.))
      ELSE
        KUPY=1+IFIX(((ALOG10(RY)-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+
     +              VP(3))*(2.**MY-1.))
      ENDIF
      RETURN
      END
      SUBROUTINE CLSGKS
C
C IU(6), in IUTLCM, is the current metacode unit number.
C
      COMMON /IUTLCM/ IU(100)
C
C Deactivate the metacode workstation, close the workstation, and
C close GKS.
C
      CALL GDAWK (IU(6))
      CALL GCLWK (IU(6))
      CALL GCLKS
C
      RETURN
C
      END
      SUBROUTINE CURVE (PX,PY,NP)
C
      DIMENSION PX(NP),PY(NP)
C
C CURVE draws the curve defined by the points (PX(I),PY(I)), for I = 1
C to NP.  All coordinates are stated in the user coordinate system.
C
C Define arrays to hold converted point coordinates when it becomes
C necessary to draw the curve piecewise.
C
      DIMENSION QX(10),QY(10)
C
C If NP is less than or equal to zero, there's nothing to do.
C
      IF (NP.LE.0) RETURN
C
C If NP is exactly equal to 1, just draw a point.
C
      IF (NP.EQ.1) THEN
        CALL POINT (PX(1),PY(1))
C
C Otherwise, draw the curve.
C
      ELSE
C
C Flush the pen-move buffer.
C
        CALL PLOTIF (0.,0.,2)
C
C Save the current SET parameters.
C
        CALL GETSET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
C
C If the mapping defined by the last SET call was non-reversed and
C linear in both x and y, a single polyline will suffice.
C
        IF (F5.LT.F6.AND.F7.LT.F8.AND.LL.EQ.1) THEN
          CALL GPL (NP,PX,PY)
C
C Otherwise, piece the line together out of smaller chunks, converting
C the coordinates for each chunk as directed by the last SET call.
C
        ELSE
          DO 102 IP=1,NP,9
            NQ=MIN0(10,NP-IP+1)
            IF (NQ.GE.2) THEN
              DO 101 IQ=1,NQ
                QX(IQ)=CUFX(PX(IP+IQ-1))
                QY(IQ)=CUFY(PY(IP+IQ-1))
  101         CONTINUE
              CALL SET (F1,F2,F3,F4,F1,F2,F3,F4,1)
              CALL GPL (NQ,QX,QY)
              CALL SET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
            END IF
  102     CONTINUE
        END IF
C
C Update the pen position.
C
        CALL FRSTPT (PX(NP),PY(NP))
C
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE FL2INT (PX,PY,IX,IY)
C
C Given the user coordinates PX and PY of a point, FL2INT returns the
C metacode coordinates IX and IY of that point.
C
C Declare the common block containing the user state variables LL, MI,
C MX, and MY.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
C
C Declare arrays in which to retrieve the variables defining the current
C window and viewport.
C
      DIMENSION WD(4),VP(4)
C
C Get the variables defining the current window and viewport.
C
      CALL GQCNTN (IE,NT)
      CALL GQNT (NT,IE,WD,VP)
C
C Compute IX.
C
      I=1
      IF (MI.GE.3) I=2
      IF (LL.LE.2) THEN
        IX=IFIX(((PX-WD(I))/(WD(3-I)-WD(I))*(VP(2)-VP(1))+VP(1))*32767.)
      ELSE
        IX=IFIX(((ALOG10(PX)-WD(I))/(WD(3-I)-WD(I))*
     +                              (VP(2)-VP(1))+VP(1))*32767.)
      ENDIF
C
C Compute IY.
C
      I=3
      IF (MI.EQ.2.OR.MI.GE.4) I=4
      IF (LL.LE.1.OR.LL.EQ.3) THEN
        IY=IFIX(((PY-WD(I))/(WD(7-I)-WD(I))*(VP(4)-VP(3))+VP(3))*32767.)
      ELSE
        IY=IFIX(((ALOG10(PY)-WD(I))/(WD(7-I)-WD(I))*
     +                              (VP(4)-VP(3))+VP(3))*32767.)
      ENDIF
C
C Done.
C
      RETURN
C
      END
C
C +NOAO - name conflict
C
C     SUBROUTINE FLUSH
      subroutine mcflsh
C
C - NOAO
C
C FLUSH currently does nothing except flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE FRAME
C
C FRAME is intended to advance to a new frame.  The GKS version clears
C all open workstations.
C
C First, flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
C
C +NOAO - Initialize utilbd 'first' flag for next plot
      call initut
C 
C - NOAO
C Get the number of open workstations.  If there are none, we're done.
C
      CALL GQOPWK (0,IE,NO,ID)
      IF (NO.EQ.0) RETURN
C
C Otherwise, clear the open workstations.
C
      DO 101 I=1,NO
        CALL GQOPWK (I,IE,NO,ID)
        CALL GCLRWK (ID,1)
  101 CONTINUE
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE FRSTPT (PX,PY)
C
C Given the user coordinates PX and PY of a point, FRSTPT generates a
C pen-up move to that point.
C
      CALL PLOTIF (CUFX(PX),CUFY(PY),0)
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE GETSET (VL,VR,VB,VT,WL,WR,WB,WT,LF)
C
C GETSET returns to its caller the current values of the parameters
C defining the mapping from the user system to the fractional system
C (in GKS terminology, the mapping from world coordinates to normalized
C device coordinates).
C
C VL, VR, VB, and VT define the viewport (in the fractional system), WL,
C WR, WB, and WT the window (in the user system), and LF the nature of
C the mapping, according to the following table:
C
C    1  -  x linear, y linear
C    2  -  x linear, y logarithmic
C    3  -  x logarithmic, y linear
C    4  -  x logarithmic, y logarithmic
C
C Declare the common block containing the linear-log and mirror-imaging
C flags.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
C
C Define variables to receive the GKS viewport and window.
C
      DIMENSION VP(4),WD(4)
C
C Retrieve the number of the current GKS normalization transformation.
C
      CALL GQCNTN (IE,NT)
C
C Retrieve the definition of that normalization transformation.
C
      CALL GQNT (NT,IE,WD,VP)
C
C Pass the viewport definition to the caller.
C
      VL=VP(1)
      VR=VP(2)
      VB=VP(3)
      VT=VP(4)
C
C Pass the linear/log flag and a (possibly modified) window definition
C to the caller.
C
      LF=LL
C
      IF (LL.EQ.1.OR.LL.EQ.2) THEN
        WL=WD(1)
        WR=WD(2)
      ELSE
        WL=10.**WD(1)
        WR=10.**WD(2)
      END IF
C
      IF (MI.GE.3) THEN
        WW=WL
        WL=WR
        WR=WW
      END IF
C
      IF (LL.EQ.1.OR.LL.EQ.3) THEN
        WB=WD(3)
        WT=WD(4)
      ELSE
        WB=10.**WD(3)
        WT=10.**WD(4)
      END IF
C
      IF (MI.EQ.2.OR.MI.GE.4) THEN
        WW=WB
        WB=WT
        WT=WW
      END IF
C
      RETURN
C
      END
      SUBROUTINE GETSI (IX,IY)
C
C Return to the user the parameters which determine the assumed size of
C the target plotter and therefore determine how user coordinates are
C to be mapped into plotter coordinates.
C
C Declare the common block containing the scaling information.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
C
C Set the user variables.

      IX=MX
      IY=MY
C
      RETURN
C
      END
      SUBROUTINE GETUSV (VN,IV)
      CHARACTER*(*) VN
C
C This subroutine retrieves the current values of the utility state
C variables.  VN is the character name of the variable and IV is
C its value.
C
C The labelled common block IUTLCM contains all of the utility state
C variables.
C
      COMMON /IUTLCM/IU(100)
C
C Check for the linear-log scaling variable.
C
      IF (VN(1:2).EQ.'LS') THEN
        IV=IU(1)
C
C Check for the variable specifying the mirror-imaging of the axes.
C
      ELSE IF (VN(1:2).EQ.'MI') THEN
        IV=IU(2)
C
C Check for the variable specifying the resolution of the plotter in x.
C
      ELSE IF (VN(1:2).EQ.'XF') THEN
        IV=IU(3)
C
C Check for the variable specifying the resolution of the plotter in x.
C
      ELSE IF (VN(1:2).EQ.'YF') THEN
        IV=IU(4)
C
C Check for the variable specifying the size of the pen-move buffer.
C
      ELSE IF (VN(1:2).EQ.'PB') THEN
        IV=IU(5)
C
C Check for the variable specifying the metacode unit.
C
      ELSE IF (VN(1:2).EQ.'MU') THEN
        IV=IU(6)
C
C Check for one of the variables specifying color and intensity.
C
      ELSE IF (VN(1:2).EQ.'IR') THEN
        IV=IU(7)
C
      ELSE IF (VN(1:2).EQ.'IG') THEN
        IV=IU(8)
C
      ELSE IF (VN(1:2).EQ.'IB') THEN
        IV=IU(9)
C
      ELSE IF (VN(1:2).EQ.'IN') THEN
        IV=IU(10)
C
C Check for the variable specifying the current color index.
C
      ELSE IF (VN(1:2).EQ.'II') THEN
        IV=IU(11)
C
C Check for the variable specifying the maximum color index.
C
      ELSE IF (VN(1:2).EQ.'IM') THEN
        IV=IU(12)
C
C Check for the variable specifying the line width scale factor.
C
      ELSE IF (VN(1:2).EQ.'LW') THEN
        IV=IU(13)
C
C Check for the variable specifying the marker size scale factor.
C
      ELSE IF (VN(1:2).EQ.'MS') THEN
        IV=IU(14)
C
C Otherwise, the variable name is unknown.
C
      ELSE
        CALL SETER ('GETUSV - UNKNOWN VARIABLE NAME IN CALL',1,2)
C
      ENDIF
C
      RETURN
C
      END
      SUBROUTINE LINE (X1,Y1,X2,Y2)
C
C Draw a line connecting the point (X1,Y1) to the point (X2,Y2), in the
C user coordinate system.
C
      CALL PLOTIF (CUFX(X1),CUFY(Y1),0)
      CALL PLOTIF (CUFX(X2),CUFY(Y2),1)
      RETURN
      END
      SUBROUTINE MXMY (IX,IY)
C
C Return to the user the coordinates of the current pen position, in the
C plotter coordinate system.
C
C In the common block PLTCM are recorded the coordinates of the last
C pen position, in the metacode coordinate system.
C
      COMMON /PLTCM/ JX,JY
C
C Declare the common block containing the user state variables LL, MI,
C MX, and MY.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
C
C Return to the user the plotter-system equivalents of the values in
C the metacode system.
C
      IX=1+IFIX((2.**MX-1.)*FLOAT(JX)/32767.)
      IY=1+IFIX((2.**MY-1.)*FLOAT(JY)/32767.)
C
C Done.
C
      RETURN
C
      END
C
C + NOAO - Following subroutine 
C     SUBROUTINE OPNGKS
C
C IU(6), in IUTLCM, is the current metacode unit number.
C
C     COMMON /IUTLCM/ IU(100)
C
C Force all required BLOCKDATA's to load.
C
C     EXTERNAL GKSBD,G01BKD,UERRBD,UTILBD
C
C GKS buffer size (a dummy for NCAR GKS.)
C
C     DATA ISZ /0/
C
C Open GKS, define a workstation, and activate the workstation.
C
C     CALL GOPKS (6,ISZ)
C     CALL GOPWK (IU(6),2,1)
C     CALL GACWK (IU(6))
C
C     RETURN
C
C + NOAO
C
C     END
      SUBROUTINE PLOTIF (FX,FY,IP)
C
C Move the pen to the point (FX,FY), in the fractional cooordinate
C system.  If IP is zero, do a pen-up move.  If IP is one, do a pen-down
C move.  If IP is two, flush the buffer.
C
C The variable IU(5), in the labelled common block IUTLCM, specifies
C the size of the pen-move buffer (between 2 and 50).
C
      COMMON /IUTLCM/ IU(100)
C
C The common block VCTSEQ contains variables implementing the buffering
C of pen moves.
C
      COMMON /VCTSEQ/ NQ,QX(50),QY(50),NF,IF(25)
C
C In the common block PLTCM are recorded the coordinates of the last
C pen position, in the metacode coordinate system, for MXMY.
C
      COMMON /PLTCM/ JX,JY
C
C Force loading of the block data routine which initializes the contents
C of the common blocks.
C
C     EXTERNAL UTILBD
C
C VP and WD hold viewport and window parameters obtained, when needed,
C from GKS.
C
      DIMENSION VP(4),WD(4)
C
C + NOAO - block data utilbd has been rewritten as a run time initialization
C
      call utilbd
C
C - NOAO
C Check for out-of-range values of the pen parameter.
C
      IF (IP.LT.0.OR.IP.GT.2) THEN
        CALL SETER ('PLOTIF - ILLEGAL VALUE FOR IPEN',1,2)
      END IF
C
C If a buffer flush is requested, jump.
C
      IF (IP.EQ.2) GO TO 101
C
C Limit the given coordinates to the legal fractional range.
C
      GX=AMAX1(0.,AMIN1(1.,FX))
      GY=AMAX1(0.,AMIN1(1.,FY))
C
C Set JX and JY for a possible call to MXMY.
C
      JX=KFMX(GX)
      JY=KFMY(GY)
C
C If the current move is a pen-down move, or if the last one was, bump
C the pointer into the coordinate arrays and, if the current move is
C a pen-up move, make a new entry in the array IF, which records the
C positions of the pen-up moves.  Note that we never get two pen-up
C moves in a row, which means that IF need be dimensioned only half as
C large as QX and QY.
C
      IF (IP.NE.0.OR.IF(NF).NE.NQ) THEN
        NQ=NQ+1
        IF (IP.EQ.0) THEN
          NF=NF+1
          IF(NF)=NQ
        END IF
      END IF
C
C Save the coordinates of the point, in the fractional coordinate
C system.
C
      QX(NQ)=GX
      QY(NQ)=GY
C
C If the point-coordinate buffer is full, dump the buffers; otherwise,
C return.
C
      IF (NQ.LT.IU(5)) RETURN
C
C Dump the buffers.  If NQ is one, there's nothing to dump.  All that's
C there is a single pen-up move.
C
  101 IF (NQ.LE.1) RETURN
C
C Get NT, the number of the current transformation, and, if it is not
C zero, modify the current transformation so that we can use fractional
C coordinates (normalized device coordinates, in GKS terms).
C
      CALL GQCNTN (IE,NT)
      IF (NT.NE.0) THEN
        CALL GQNT (NT,IE,WD,VP)
        CALL GSWN (NT,VP(1),VP(2),VP(3),VP(4))
      END IF
C
C Dump out a series of polylines, each one defined by a pen-up move and
C a series of pen-down moves.
C
      DO 102 I=1,NF-1
        CALL GPL (IF(I+1)-IF(I),QX(IF(I)),QY(IF(I)))
  102 CONTINUE
      IF (IF(NF).NE.NQ) CALL GPL (NQ-IF(NF)+1,QX(IF(I)),QY(IF(I)))
C
C Put the current transformation back the way it was.
C
      IF (NT.NE.0) THEN
        CALL GSWN (NT,WD(1),WD(2),WD(3),WD(4))
      END IF
C
C Move the last pen position to the beginning of the buffer and pretend
C there was a pen-up move to that position.
C
      QX(1)=QX(NQ)
      QY(1)=QY(NQ)
      NQ=1
      IF(1)=1
      NF=1
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE PLOTIT (IX,IY,IP)
C
C Move the pen to the point (IX,IY), in the metacode coordinate system.
C If IP is zero, do a pen-up move.  If IP is one, do a pen-down move.
C If IP is two, flush the buffer.  (For the sake of efficiency, the
C moves are buffered; "CALL PLOTIT (0,0,0)" will also flush the buffer.)
C
C The variable IU(5), in the labelled common block IUTLCM, specifies
C the size of the pen-move buffer (between 2 and 50).
C
      COMMON /IUTLCM/ IU(100)
C
C The common block VCTSEQ contains variables implementing the buffering
C of pen moves.
C
      COMMON /VCTSEQ/ NQ,QX(50),QY(50),NF,IF(25)
C
C In the common block PLTCM are recorded the coordinates of the last
C pen position, in the metacode coordinate system, for MXMY.
C
      COMMON /PLTCM/ JX,JY
C
C Force loading of the block data routine which initializes the contents
C of the common blocks.
C
C     EXTERNAL UTILBD
C
C VP and WD hold viewport and window parameters obtained, when needed,
C from GKS.
C
      DIMENSION VP(4),WD(4)
C
C + NOAO - Blockdata utilbd has been rewritten as a run time initialization
C
      call utilbd
C
C - NOAO
C Check for out-of-range values of the pen parameter.
C
      IF (IP.LT.0.OR.IP.GT.2) THEN
        CALL SETER ('PLOTIT - ILLEGAL VALUE FOR IPEN',1,2)
      END IF
C
C If a buffer flush is requested, jump.
C
      IF (IP.EQ.2) GO TO 101
C
C Limit the given coordinates to the legal metacode range.
C
      JX=MAX0(0,MIN0(32767,IX))
      JY=MAX0(0,MIN0(32767,IY))
C
C If the current move is a pen-down move, or if the last one was, bump
C the pointer into the coordinate arrays and, if the current move is
C a pen-up move, make a new entry in the array IF, which records the
C positions of the pen-up moves.  Note that we never get two pen-up
C moves in a row, which means that IF need be dimensioned only half as
C large as QX and QY.
C
      IF (IP.NE.0.OR.IF(NF).NE.NQ) THEN
        NQ=NQ+1
        IF (IP.EQ.0) THEN
          NF=NF+1
          IF(NF)=NQ
        END IF
      END IF
C
C Save the coordinates of the point, in the fractional coordinate
C system.
C
      QX(NQ)=FLOAT(JX)/32767.
      QY(NQ)=FLOAT(JY)/32767.
C
C If all three arguments were zero, or if the point-coordinate buffer
C is full, dump the buffers; otherwise, return.
C
      IF (IX.EQ.0.AND.IY.EQ.0.AND.IP.EQ.0) GO TO 101
      IF (NQ.LT.IU(5)) RETURN
C
C Dump the buffers.  If NQ is one, there's nothing to dump.  All that's
C there is a single pen-up move.
C
  101 IF (NQ.LE.1) RETURN
C
C Get NT, the number of the current transformation, and, if it is not
C zero, modify the current transformation so that we can use fractional
C coordinates (normalized device coordinates, in GKS terms).
C
      CALL GQCNTN (IE,NT)
      IF (NT.NE.0) THEN
        CALL GQNT (NT,IE,WD,VP)
        CALL GSWN (NT,VP(1),VP(2),VP(3),VP(4))
      END IF
C
C Dump out a series of polylines, each one defined by a pen-up move and
C a series of pen-down moves.
C
      DO 102 I=1,NF-1
        CALL GPL (IF(I+1)-IF(I),QX(IF(I)),QY(IF(I)))
  102 CONTINUE
      IF (IF(NF).NE.NQ) CALL GPL (NQ-IF(NF)+1,QX(IF(I)),QY(IF(I)))
C
C Put the current transformation back the way it was.
C
      IF (NT.NE.0) THEN
        CALL GSWN (NT,WD(1),WD(2),WD(3),WD(4))
      END IF
C
C Move the last pen position to the beginning of the buffer and pretend
C there was a pen-up move to that position.
C
      QX(1)=QX(NQ)
      QY(1)=QY(NQ)
      NQ=1
      IF(1)=1
      NF=1
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE POINT (PX,PY)
C
C Draws a point at (PX,PY), defined in the user coordinate system.
C
      CALL PLOTIF (CUFX(PX),CUFY(PY),0)
      CALL PLOTIF (CUFX(PX),CUFY(PY),1)
      RETURN
      END
      SUBROUTINE POINTS (PX,PY,NP,IC,IL)
      DIMENSION PX(NP),PY(NP)
C
C Marks the points at positions in the user coordinate system defined
C by ((PX(I),PY(I)),I=1,NP).  If IC is zero, each point is marked with
C a simple point.  If IC is positive, each point is marked with the
C single character defined by the FORTRAN-77 function CHAR(IC).  If IC
C is negative, each point is marked with a GKS polymarker of type -IC.
C If IL is non-zero, a curve is also drawn, connecting the points.
C
C Define arrays to hold converted point coordinates when it becomes
C necessary to mark the points a few at a time.
C
      DIMENSION QX(10),QY(10)
C
C Define an array to hold the aspect source flags which may need to be
C retrieved from GKS.
C
      DIMENSION LA(13)
      CHARACTER*1 CHRTMP
C
C If the number of points is zero or negative, there's nothing to do.
C
      IF (NP.LE.0) RETURN
C
C Otherwise, flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
C
C Retrieve the parameters from the last SET call.
C
      CALL GETSET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
C
C If a linear-linear, non-mirror-imaged, mapping is being done and the
C GKS polymarkers can be used, all the points can be marked with a
C single polymarker call and joined, if requested, by a single polyline
C call.
C
      IF (F5.LT.F6.AND.F7.LT.F8.AND.LL.EQ.1.AND.IC.LE.0) THEN
        CALL GQASF (IE,LA)
        IF (LA(4).EQ.0) THEN
          CALL GQPMI (IE,IN)
          CALL GSPMI (MAX0(-IC,1))
          CALL GPM (NP,PX,PY)
          CALL GSPMI (IN)
        ELSE
          CALL GQMK (IE,IN)
          CALL GSMK (MAX0(-IC,1))
          CALL GPM (NP,PX,PY)
          CALL GSMK (IN)
        END IF
        IF (IL.NE.0.AND.NP.GE.2) CALL GPL (NP,PX,PY)
C
C Otherwise, things get complicated.  We have to do batches of nine
C points at a time.  (Actually, we convert ten coordinates at a time,
C so that the curve joining the points, if any, won't have gaps in it.)
C
      ELSE
C
C Initially, we have to reset either the polymarker index or the text
C alignment, depending on how we're marking the points.
C
        IF (IC.LE.0) THEN
          CALL GQASF (IE,LA)
          IF (LA(4).EQ.0) THEN
            CALL GQPMI (IE,IN)
            CALL GSPMI (MAX0(-IC,1))
          ELSE
            CALL GQMK (IE,IN)
            CALL GSMK (MAX0(-IC,1))
          END IF
        ELSE
          CALL GQTXAL (IE,IH,IV)
          CALL GSTXAL (2,3)
        END IF
C
C Loop through the points by nines.
C
        DO 104 IP=1,NP,9
C
C Fill the little point coordinate arrays with up to ten values,
C converting them from the user system to the fractional system.
C
          NQ=MIN0(10,NP-IP+1)
          MQ=MIN0(9,NQ)
          DO 102 IQ=1,NQ
            QX(IQ)=CUFX(PX(IP+IQ-1))
            QY(IQ)=CUFY(PY(IP+IQ-1))
  102     CONTINUE
C
C Change the SET call to allow the use of fractional coordinates.
C
          CALL SET (F1,F2,F3,F4,F1,F2,F3,F4,1)
C
C Crank out either a polymarker or a set of characters.
C
          IF (IC.LE.0) THEN
            CALL GPM (MQ,QX,QY)
          ELSE
            DO 103 IQ=1,MQ
              CHRTMP = CHAR(IC)
              CALL GTX (QX(IQ),QY(IQ),CHRTMP)
  103       CONTINUE
          END IF
          IF (IL.NE.0.AND.NQ.GE.2) CALL GPL (NQ,QX,QY)
C
C Put the SET parameters back the way they were.
C
          CALL SET (F1,F2,F3,F4,F5,F6,F7,F8,LL)
C
  104   CONTINUE
C
C Finally, we put either the polymarker index or the text alignment
C back the way it was.
C
        IF (IC.LE.0) THEN
          IF (LA(4).EQ.0) THEN
            CALL GSPMI (IN)
          ELSE
            CALL GSMK (IN)
          END IF
        ELSE
          CALL GSTXAL (IH,IV)
        END IF
C
      END IF
C
C Update the pen position.
C
      CALL FRSTPT (PX(NP),PY(NP))
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE PWRIT (PX,PY,CH,NC,IS,IO,IC)
      CHARACTER*(*) CH
C
C PWRIT is called to draw a character string in a specified position.
C It is just like WTSTR, but has one extra argument.  NC is the number
C of characters to be written from the string CH.
C
      CALL WTSTR (PX,PY,CH(1:NC),IS,IO,IC)
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE SET (VL,VR,VB,VT,WL,WR,WB,WT,LF)
C
C SET allows the user to change the current values of the parameters
C defining the mapping from the user system to the fractional system
C (in GKS terminology, the mapping from world coordinates to normalized
C device coordinates).
C
C VL, VR, VB, and VT define the viewport (in the fractional system), WL,
C WR, WB, and WT the window (in the user system), and LF the nature of
C the mapping, according to the following table:
C
C    1  -  x linear, y linear
C    2  -  x linear, y logarithmic
C    3  -  x logarithmic, y linear
C    4  -  x logarithmic, y logarithmic
C
C Declare the common block containing the linear-log and mirror-imaging
C flags.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
C
C Flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
C
C Set the GKS viewport for transformation 1.
C
      CALL GSVP (1,VL,VR,VB,VT)
C
C Set the utility state variable controlling linear-log mapping.
C
      LL=MAX0(1,MIN0(4,LF))
C
C Set the GKS window for transformation 1.
C
      IF (WL.LT.WR) THEN
        MI=1
        QL=WL
        QR=WR
      ELSE
        MI=3
        QL=WR
        QR=WL
      END IF
C
      IF (WB.LT.WT) THEN
        QB=WB
        QT=WT
      ELSE
        MI=MI+1
        QB=WT
        QT=WB
      END IF
C
      IF (LL.EQ.1) THEN
        CALL GSWN (1,QL,QR,QB,QT)
      ELSE IF (LL.EQ.2) THEN
        CALL GSWN (1,QL,QR,ALOG10(QB),ALOG10(QT))
      ELSE IF (LL.EQ.3) THEN
        CALL GSWN (1,ALOG10(QL),ALOG10(QR),QB,QT)
      ELSE
        CALL GSWN (1,ALOG10(QL),ALOG10(QR),ALOG10(QB),ALOG10(QT))
      END IF
C
C Select transformation 1 as the current one.
C
      CALL GSELNT (1)
C
      RETURN
C
      END
      SUBROUTINE SETI (IX,IY)
C
C Allows the user to set the parameters which determine the assumed size
C of the target plotter and therefore determine how user coordinates are
C to be mapped into plotter coordinates.
C
C Declare the common block containing the scaling information.
C
      COMMON /IUTLCM/ LL,MI,MX,MY,IU(96)
C
C Transfer the user's values into the common block.
C
      MX=MAX0(1,MIN0(15,IX))
      MY=MAX0(1,MIN0(15,IY))
C
      RETURN
C
      END
      SUBROUTINE SETUSV (VN,IV)
      CHARACTER*(*) VN
C
C This subroutine sets the values of various utility state variables.
C VN is the name of the variable and IV is its value.
C
C The labelled common block IUTLCM contains all of the utility state
C variables.
C
      COMMON /IUTLCM/ IU(100)
C
C Define an array in which to get the GKS aspect source flags.
C
      DIMENSION LF(13)
C
C Check for the linear-log scaling variable, which can take on these
C values:
C
C     1 = X linear, Y linear
C     2 = X linear, Y log
C     3 = X log   , Y linear
C     4 = X log   , Y log
C
      IF (VN(1:2).EQ.'LS') THEN
        IF (IV.LT.1.OR.IV.GT.4) THEN
          CALL SETER ('SETUSV - LOG SCALE VALUE OUT OF RANGE',2,2)
        END IF
        IU(1)=IV
C
C Check for the mirror-imaging variable, which can take on these
C values:
C
C     1 = X normal  , Y normal
C     2 = X normal  , Y reversed
C     3 = X reversed, Y normal
C     4 = X reversed, Y reversed
C
      ELSE IF (VN(1:2).EQ.'MI') THEN
        IF (IV.LT.1.OR.IV.GT.4) THEN
          CALL SETER ('SETUSV - MIRROR-IMAGING VALUE OUT OF RANGE',3,2)
        END IF
        IU(2)=IV
C
C Check for the scale factor setting the resolution of the plotter in
C the x direction.
C
      ELSE IF (VN(1:2).EQ.'XF') THEN
        IF (IV.LT.1.OR.IV.GT.15) THEN
          CALL SETER ('SETUSV - X RESOLUTION OUT OF RANGE',4,2)
        END IF
        IU(3)=IV
C
C Check for the scale factor setting the resolution of the plotter in
C the y direction.
C
      ELSE IF (VN(1:2).EQ.'YF') THEN
        IF (IV.LT.1.OR.IV.GT.15) THEN
          CALL SETER ('SETUSV - Y RESOLUTION OUT OF RANGE',5,2)
        END IF
        IU(4)=IV
C
C Check for the variable specifying the size of the pen-move buffer.
C
      ELSE IF (VN(1:2).EQ.'PB') THEN
        IF (IV.LT.2.OR.IV.GT.50) THEN
          CALL SETER ('SETUSV - PEN-MOVE BUFFER SIZE OUT OF RANGE',6,2)
        END IF
        CALL PLOTIF (0.,0.,2)
        IU(5)=IV
C
C Check for a metacode unit number.
C
      ELSE IF (VN(1:2).EQ.'MU') THEN
        IF (IV.LE.0) THEN
          CALL SETER ('SETUSV - METACODE UNIT NUMBER ILLEGAL',7,2)
        END IF
C
C For the moment (1/11/85), we have to deactivate and close the old
C workstation and open and activate a new one.  This does allow the
C user to break up his metacode output.  It does not necessarily allow
C for the resumption of output to a previously-written metacode file.
C
        CALL GDAWK (IU(6))
        CALL GCLWK (IU(6))
        IU(6)=IV
        CALL GOPWK (IU(6),2,1)
        CALL GACWK (IU(6))
C
C If, in the future, it becomes possible to have more than one metacode
C workstation open at once, the following code can be used instead.
C
C       CALL GDAWK (IU(6))
C       IU(6)=IV
C       CALL GQOPWK (0,IE,NO,ID)
C       IF (NO.NE.0) THEN
C         DO 101 I=1,NO
C           CALL GQOPWK (I,IE,NO,ID)
C           IF (ID.EQ.IU(6)) GO TO 102
C 101     CONTINUE
C       END IF
C       CALL GOPWK (IU(6),2,1)
C 102   CALL GAWK (IU(6))
C
C Check for one of the variables setting color and intensity.
C
      ELSE IF (VN(1:2).EQ.'IR') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF RED INTENSITY',8,2)
        END IF
        IU(7)=IV
C
      ELSE IF (VN(1:2).EQ.'IG') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF GREEN INTENSITY',9,2)
        END IF
        IU(8)=IV
C
      ELSE IF (VN(1:2).EQ.'IB') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF BLUE INTENSITY',10,2)
        END IF
        IU(9)=IV
C
      ELSE IF (VN(1:2).EQ.'IN') THEN
        IF (IV.LT.0.OR.IV.GT.10000) THEN
          CALL SETER ('SETUSV - ILLEGAL VALUE OF INTENSITY',11,2)
        END IF
        IU(10)=IV
C
C Assign the intensity-controlling variables to local variables with
C simple, meaningful names.
C
        IR=IU(7)
        IG=IU(8)
        IB=IU(9)
        IN=IU(10)
        II=IU(11)
        IM=IU(12)
C
C Compute the floating-point red, green, and blue intensities.
C
        FR=FLOAT(IR)/FLOAT(MAX0(IR,IG,IB,1))*FLOAT(IN)/10000.
        FG=FLOAT(IG)/FLOAT(MAX0(IR,IG,IB,1))*FLOAT(IN)/10000.
        FB=FLOAT(IB)/FLOAT(MAX0(IR,IG,IB,1))*FLOAT(IN)/10000.
C
C Dump the pen-move buffer before changing anything.
C
        CALL PLOTIF (0.,0.,2)
C
C Set the aspect source flags for all the color indices to "individual".
C
        CALL GQASF (IE,LF)
        LF( 3)=1
        LF( 6)=1
        LF(10)=1
        LF(13)=1
        CALL GSASF (LF)
C
C Pick a new color index and use it for polylines, polymarkers, text,
C and areas.
C
        II=MOD(II,IM)+1
        IU(11)=II
        CALL GSPLCI (II)
        CALL GSPMCI (II)
        CALL GSTXCI (II)
        CALL GSFACI (II)
C
C Now, redefine the color for that color index on each open workstation.
C
        CALL GQOPWK (0,IE,NO,ID)
C
        DO 103 I=1,NO
          CALL GQOPWK (I,IE,NO,ID)
          CALL GSCR (ID,II,FR,FG,FB)
  103   CONTINUE
C
C Check for variable resetting the color index.
C
      ELSE IF (VN(1:2).EQ.'II') THEN
        IF (IV.LT.1.OR.IV.GT.IU(12)) THEN
          CALL SETER ('SETUSV - ILLEGAL COLOR INDEX',12,2)
        END IF
        IU(11)=IV
C
        CALL PLOTIF (0.,0.,2)
C
        CALL GQASF (IE,LF)
        LF( 3)=1
        LF( 6)=1
        LF(10)=1
        LF(13)=1
        CALL GSASF (LF)
C
        CALL GSPLCI (IV)
        CALL GSPMCI (IV)
        CALL GSTXCI (IV)
        CALL GSFACI (IV)
C
C Check for the variable limiting the values of color index used.
C
      ELSE IF (VN(1:2).EQ.'IM') THEN
        IF (IV.LT.1) THEN
          CALL SETER ('SETUSV - ILLEGAL MAXIMUM COLOR INDEX',13,2)
        END IF
        IU(12)=IV
C
C Check for the variable setting the current line width scale factor.
C
      ELSE IF (VN(1:2).EQ.'LW') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL LINE WIDTH SCALE FACTOR',14,2)
        END IF
        IU(13)=IV
C
C Dump the pen-move buffer before changing anything.
C
        CALL PLOTIF (0.,0.,2)
C
C Set the aspect source flag for linewidth scale factor to "individual".
C
        CALL GQASF (IE,LF)
        LF(2)=1
        CALL GSASF (LF)
C
C Redefine the line width scale factor.
C
        CALL GSLWSC (FLOAT(IV)/1000.)
C
C Check for the variable setting the current marker size scale factor.
C
      ELSE IF (VN(1:2).EQ.'MS') THEN
        IF (IV.LT.0) THEN
          CALL SETER ('SETUSV - ILLEGAL MARKER SIZE SCALE FACTOR',15,2)
        END IF
        IU(14)=IV
C
C Set aspect source flag for marker size scale factor to "individual".
C
        CALL GQASF (IE,LF)
        LF(5)=1
        CALL GSASF (LF)
C
C Redefine the marker size scale factor.
C
        CALL GSMKSC (FLOAT(IV)/1000.)
C
C Otherwise, the variable name is unknown.
C
      ELSE
        CALL SETER ('SETUSV - UNKNOWN VARIABLE NAME IN CALL',1,2)
C
      ENDIF
      RETURN
      END
      SUBROUTINE VECTOR (PX,PY)
C
C Draw a vector (line segment) from the current pen position to the new
C pen position (PX,PY), in the user coordinate system, and then make
C (PX,PY) the current pen position.
C
      CALL PLOTIF (CUFX(PX),CUFY(PY),1)
      RETURN
      END
      SUBROUTINE WTSTR (PX,PY,CH,IS,IO,IC)
C
C WTSTR is called to draw a character string in a specified position.
C
C PX and PY specify, in user coordinates, the position of a point
C relative to which a character string is to be positioned.
C
C CH is the character string to be written.
C
C IS is the desired size of the characters to be used, stated as a
C character width in the plotter coordinate system.  The values 0, 1,
C 2, and 3 mean 8, 12, 16, and 24, respectively.
C
C IO is the desired orientation angle, in degrees counterclockwise from
C a horizontal vector pointing to the right.
C
C IC specifies the desired type of centering.  A negative value puts
C (PX,PY) in the center of the left end of the character string, a zero
C puts (PX,PY) in the center of the whole string, and a positive value
C puts (PX,PY) in the center of the right end of the character string.
C
      CHARACTER*(*) CH
C
C Define arrays in which to save the current viewport and window.
C
      DIMENSION VP(4),WD(4)
C
C Flush the pen-move buffer.
C
      CALL PLOTIF (0.,0.,2)
C
C Compute the coordinates of (PX,PY) in the fractional coordinate
C system (normalized device coordinates).
C
      XN=CUFX(PX)
      YN=CUFY(PY)
C
C Save the current window and, if necessary, redefine it so that we can
C use normalized device coordinates.
C
      CALL GQCNTN (IE,NT)
      IF (NT.NE.0) THEN
        CALL GQNT (NT,IE,WD,VP)
        CALL GSWN (NT,VP(1),VP(2),VP(3),VP(4))
      END IF
C
C Save current character height, text path, character up vector, and
C text alignment.
C
      CALL GQCHH (IE,OS)
      CALL GQTXP (IE,IP)
      CALL GQCHUP (IE,UX,UY)
      CALL GQTXAL (IE,IX,IY)
C
C Define the character height.  (The final scale factor is derived from
C the default font.)
C
      CALL GETUSV ('YF',MY)
      YS=FLOAT(2**MY)
      IF (IS.GE.0.AND.IS.LE.3) THEN
        CS=FLOAT(8+4*IS+4*(IS/3))/YS
      ELSE
        CS=AMIN1(FLOAT(IS),YS)/YS
      ENDIF
C
      CS=CS*25.5/27.
C
C + NOAO - make character size readable with IRAF font
      cs = cs * 2.0
C
C - NOAO

      CALL GSCHH(CS)
C
C Define the text path.
C
      CALL GSTXP (0)
C
C Define the character up vector.
C
      JO=MOD(IO,360)
      IF (JO.EQ.0) THEN
        CALL GSCHUP (0.,1.)
      ELSE IF (JO.EQ.90) THEN
        CALL GSCHUP (-1.,0.)
      ELSE IF (JO.EQ.180) THEN
        CALL GSCHUP (0.,-1.)
      ELSE IF (JO.EQ.270) THEN
        CALL GSCHUP (1.,0.)
      ELSE IF (JO.GT.0.AND.JO.LT.180) THEN
        CALL GSCHUP (-1.,1./TAN(FLOAT(JO)*3.1415926/180.))
      ELSE
        CALL GSCHUP (1.,-1./TAN(FLOAT(JO)*3.1415926/180.))
      ENDIF
C
C Define the text alignment.
C
      CALL GSTXAL (IC+2,3)
C
C Plot the characters.
C
      CALL GTX (XN,YN,CH)
C
C Restore the original text attributes.
C
      CALL GSCHH (OS)
      CALL GSTXP (IP)
      CALL GSCHUP (UX,UY)
      CALL GSTXAL (IX,IY)
C
C Restore the window definition.
C
      IF (NT.NE.0) THEN
        CALL GSWN (NT,WD(1),WD(2),WD(3),WD(4))
      END IF
C
C Update the pen position.
C
      CALL FRSTPT (PX,PY)
C
C Done.
C
      RETURN
C
      END
c + NOAO - blockdata utilbd changed to run time initialization
      subroutine utilbd
c     BLOCKDATA UTILBD
C
      logical first
C The common block IUTLCM contains integer utility variables which are
C user-settable by the routine SETUSV and user-retrievable by the
C routine GETUSV.
C
      COMMON /IUTLCM/ IU(100)
C
C The common block VCTSEQ contains variables realizing the buffering
C scheme used by PLOTIT/F for pen moves.  The dimension of QX and QY must
C be an even number greater than or equal to the value of IU(5).  The
C dimension of IF must be half that of QX and QY.
C
      COMMON /VCTSEQ/ NQ,QX(50),QY(50),NF,IF(25)
C
C In the common block PLTCM are recorded the coordinates of the last
C point to which a pen move was requested by a call to PLOTIT/F.
C
      COMMON /PLTCM/ JX,JY
C
C IU(1) contains the log scaling parameter, which may take on the
C following possible values:
C
C     1 = linear-linear
C     2 = log-linear
C     3 = linear-log
C     4 = log-log
C
c     DATA IU(1) / 1 /
      IU(1) = 1 
C
C IU(2) specifies the mirror-imaging of the x and y axes, as follows:
C
C     1 = x normal, y normal
C     2 = x normal, y reversed
C     3 = x reversed, y normal
C     4 = x reversed, y reversed
C
c +NOAO - logical parameter first inserted to avoid clobbering initialization
      data first /.true./
      if (.not. first) return
        first = .false.
c -NOAO
c     DATA IU(2) / 1 /
      IU(2) = 1 
C
C IU(3) specifies the assumed resolution of the plotter in the x
C direction.  Plotter x coordinates are assumed to lie between 1 and
C 2**IU(3), inclusive.
C
c     DATA IU(3) / 10 /
      IU(3) = 10 
C
C IU(4) specifies the assumed resolution of the plotter in the y
C direction.  Plotter y coordinates are assumed to lie between 1 and
C 2**IU(4), inclusive.
C
c     DATA IU(4) / 10 /
      IU(4) = 10 
C
C IU(5) specifies the size of the buffers used by PLOTIT/F.  Its value
C must be greater than or equal to 2 and not greater than the dimension
C of the variables QX and QY.  Using the value 2 effectively turns off
C the buffering.
C
c     DATA IU(5) / 50 /
      IU(5) = 50
C
C IU(6) specifies the current metacode unit, which is machine-dependent.
C At NCAR, the value "1" currently (1/11/85) causes metacode to be
C written on the file "GMETA".  Eventually, it will cause output to be
C written on unit number 1.  At that point, the value, on the Cray at
C least, should be changed to "4H$PLT", so that output will come out on
C the old familiar dataset.
C
c     DATA IU(6) / 1 /
      IU(6) = 1 
C
C IU(7), IU(8), IU(9), and IU(10) specify color and intensity, in the
C following way (letting IR=IU(7), IG=IU(8), IB=IU(9), and IN=IU(10)):
C
C     The red intensity is IR/(IR+IG+IB)*IN/10000.
C     The green intensity is IG/(IR+IG+IB)*IN/10000.
C     The blue intensity is IB/(IR+IG+IB)*IN/10000.
C
C The GKS calls to set these intensities are executed in response to a
C "CALL SETUSV ('IN',IN)", using the existing values of IR, IG, and IB.
C Thus, to completely determine the color and the intensity, the user
C must execute four calls, as follows:
C
C     CALL SETUSV ('IR',IR)
C     CALL SETUSV ('IG',IG)
C     CALL SETUSV ('IB',IB)
C     CALL SETUSV ('IN',IN)
C
C The default values create a white line at .8 x maximum intensity.
C
c     DATA IU(7) / 1 /
c     DATA IU(8) / 1 /
c     DATA IU(9) / 1 /
      IU(7) = 1
      IU(8) = 1 
      IU(9) = 1
C
c     DATA IU(10) / 8000 /
      IU(10) = 8000 
C
C IU(11) and IU(12) specify, respectively, the last color index used
C and the maximum number of color indices it is permissible to use.
C
c     DATA IU(11) / 0 /
c     DATA IU(12) / 1 /
      IU(11) = 0 
      IU(12) = 1 
C
C IU(13)/1000 specifies the current line width scale factor.
C
c     DATA IU(13) / 1000 /
      IU(13) = 1000
C
C IU(14)/1000 specifies the current marker size scale factor.
C
c     DATA IU(14) / 1000 /
      IU(14) = 1000 
C
C IU(15) through IU(100) are currently undefined.
C
C Initialization for the routine PLOTIT/F:  For values of I between 1 and
C NQ, (QX(I),QY(I)) is a point to which a pen move has been requested
C by a past call to PLOTIT/F.  The coordinates are stated in the fractional
C coordinate system.  For values of I between 1 and NF, IF(I) is the
C index, in QX and QY, of the coordinates of a point to which a pen-up
C move was requested.  NQ and NF are never allowed to be less than one.
C
c     DATA NQ,QX(1),QY(1),NF,IF(1) / 1 , 0. , 0. , 1 , 1 /
      NQ    = 1
      QX(1) = 0. 
      QY(1) = 0. 
      NF    = 1 
      IF(1) = 1 
C
C JX and JY are the coordinates, in the metacode system, of the last
C point to which a pen move was requested by a call to PLOTIT/F.
C
c     DATA JX,JY / 0 , 0 /
      JX = 0 
      JY = 0 
C
c -NOAO
      return
c
      entry initut
      first = .true.
      END

include	defs

# dsfree --- return a block of storage to the available space list

   subroutine dsfree (block)
   pointer block

   DS_COMMON

   pointer p0, p, q

   integer n, junk

   character con (10)

   p0 = block - DS_OHEAD
   n = Mem (p0 + DS_SIZE)
   q = DS_AVAIL

   repeat {
      p = Mem (q + DS_LINK)
      if (p == LAMBDA | p > p0)
	 break
      q = p
      }

   if (q + Mem (q + DS_SIZE) > p0) {
      call remark ("in dsfree:	attempt to free unallocated block.")
      call remark ("type 'c' to continue.")
      junk = getlin (con, STDIN)
      if (con (1) != LETC & con (1) != BIGC)
	 call endst
      return	  # do not attempt to free the block
      }

   if (p0 + n == p & p != LAMBDA) {
      n = n + Mem (p + DS_SIZE)
      Mem (p0 + DS_LINK) = Mem (p + DS_LINK)
      }
   else
      Mem (p0 + DS_LINK) = p

   if (q + Mem (q + DS_SIZE) == p0) {
      Mem (q + DS_SIZE) = Mem (q + DS_SIZE) + n
      Mem (q + DS_LINK) = Mem (p0 + DS_LINK)
      }
   else {
      Mem (q + DS_LINK) = p0
      Mem (p0 + DS_SIZE) = n
      }

   return
   end

      SUBROUTINE slCMBN ( NSEL, NCAND, LIST, J )
*+
*     - - - - - -
*      C O M B N
*     - - - - - -
*
*  Generate the next combination, a subset of a specified size chosen
*  from a specified number of items.
*
*  Given:
*     NSEL     i        number of items (subset size)
*     NCAND    i        number of candidates (set size)
*
*  Given and returned:
*     LIST     i(NSEL)  latest combination, LIST(1)=0 to initialize
*
*  Returned:
*     J        i        status: -1 = illegal NSEL or NCAND
*                                0 = OK
*                               +1 = no more combinations available
*
*  Notes:
*
*  1) NSEL and NCAND must both be at least 1, and NSEL must be less
*     than or equal to NCAND.
*
*  2) This routine returns, in the LIST array, a subset of NSEL integers
*     chosen from the range 1 to NCAND inclusive, in ascending order.
*     Before calling the routine for the first time, the caller must set
*     the first element of the LIST array to zero (any value less than 1
*     will do) to cause initialization.
*
*  2) The first combination to be generated is:
*
*        LIST(1)=1, LIST(2)=2, ..., LIST(NSEL)=NSEL
*
*     This is also the combination returned for the "finished" (J=1)
*     case.
*
*     The final permutation to be generated is:
*
*        LIST(1)=NCAND, LIST(2)=NCAND-1, ..., LIST(NSEL)=NCAND-NSEL+1
*
*  3) If the "finished" (J=1) status is ignored, the routine
*     continues to deliver combinations, the pattern repeating
*     every NCAND!/(NSEL!*(NCAND-NSEL)!) calls.
*
*  4) The algorithm is by R.F.Warren-Smith (private communication).
*
*  P.T.Wallace   Starlink   25 August 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER NSEL,NCAND,LIST(NSEL),J

      INTEGER I,LISTI,NMAX,M
      LOGICAL MORE


*  Validate, and set status.
      IF (NSEL.LT.1.OR.NCAND.LT.1.OR.NSEL.GT.NCAND) THEN
         J = -1
         GO TO 9999
      ELSE
         J = 0
      END IF

*  Just starting?
      IF (LIST(1).LT.1) THEN

*     Yes: return 1,2,3...
         DO I=1,NSEL
            LIST(I) = I
         END DO

      ELSE

*     No: find the first selection that we can increment.

*     Start with the first list item.
         I = 1

*     Loop.
         MORE = .TRUE.
         DO WHILE (MORE)

*        Current list item.
            LISTI = LIST(I)

*        Is this the final list item?
            IF (I.GE.NSEL) THEN

*           Yes:  comparison value is number of candidates plus one.
               NMAX = NCAND+1
            ELSE

*           No:  comparison value is next list item.
               NMAX = LIST(I+1)
            END IF

*        Can the current item be incremented?
            IF (NMAX-LISTI.GT.1) THEN

*           Yes:  increment it.
               LIST(I) = LISTI+1

*           Reinitialize the preceding items.
               DO M=1,I-1
                  LIST(M) = M
               END DO

*           Break.
               MORE = .FALSE.
            ELSE

*           Can't increment the current item:  is it the final one?
               IF (I.GE.NSEL) THEN

*              Yes:  set the status.
                  J = 1

*              Restart the sequence.
                  DO I=1,NSEL
                     LIST(I) = I
                  END DO

*              Break.
                  MORE = .FALSE.
               ELSE

*              No:  next list item.
                  I = I+1
               END IF
            END IF
         END DO
      END IF
 9999 CONTINUE

      END

      integer function amatch (lin, from, pat, tagbeg, tagend)
      integer lin (128), pat (128)
      integer from, tagbeg (10), tagend (10)
      integer i, j, offset, stack
      integer omatch, patsiz
      i = 1
23000 if (.not.(i .le. 10))goto 23002
      tagbeg (i) = 0
      tagend (i) = 0
23001 i = i + 1
      goto 23000
23002 continue
      tagbeg (1) = from
      stack = 0
      offset = from
      j = 1
23003 if (.not.(pat (j) .ne. -2))goto 23005
      if (.not.(pat (j) .eq. 42))goto 23006
      stack = j
      j = j + 4
      i = offset
23008 if (.not.(lin (i) .ne. -2))goto 23010
      if (.not.(omatch (lin, i, pat, j) .eq. 0))goto 23011
      goto 23010
23011 continue
23009 goto 23008
23010 continue
      pat (stack + 1) = i - offset
      pat (stack + 3) = offset
      offset = i
      goto 23007
23006 continue
      if (.not.(pat (j) .eq. 123))goto 23013
      i = pat (j + 1)
      tagbeg (i + 1) = offset
      goto 23014
23013 continue
      if (.not.(pat (j) .eq. 125))goto 23015
      i = pat (j + 1)
      tagend (i + 1) = offset
      goto 23016
23015 continue
      if (.not.(omatch (lin, offset, pat, j) .eq. 0))goto 23017
23019 if (.not.(stack .gt. 0))goto 23021
      if (.not.(pat (stack + 1) .gt. 0))goto 23022
      goto 23021
23022 continue
23020 stack = pat (stack + 2)
      goto 23019
23021 continue
      if (.not.(stack .le. 0))goto 23024
      amatch = 0
      return
23024 continue
      pat (stack + 1) = pat (stack + 1) - 1
      j = stack + 4
      offset = pat (stack + 3) + pat (stack + 1)
23017 continue
23016 continue
23014 continue
23007 continue
23004 j = j + patsiz (pat, j)
      goto 23003
23005 continue
      amatch = offset
      tagend (1) = offset
      return
      end

      SUBROUTINE CONTNG (NDP,XD,YD,NT,IPT,NL,IPL,IWL,IWP,WK)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C THIS SUBROUTINE PERFORMS TRIANGULATION.  IT DIVIDES THE X-Y
C PLANE INTO A NUMBER OF TRIANGLES ACCORDING TO GIVEN DATA
C POINTS IN THE PLANE, DETERMINES LINE SEGMENTS THAT FORM THE
C BORDER OF DATA AREA, AND DETERMINES THE TRIANGLE NUMBERS
C CORRESPONDING TO THE BORDER LINE SEGMENTS.
C AT COMPLETION, POINT NUMBERS OF THE VERTEXES OF EACH TRIANGLE
C ARE LISTED COUNTER-CLOCKWISE.  POINT NUMBERS OF THE END POINTS
C OF EACH BORDER LINE SEGMENT ARE LISTED COUNTER-CLOCKWISE,
C LISTING ORDER OF THE LINE SEGMENTS BEING COUNTER-CLOCKWISE.
C THE INPUT PARAMETERS ARE
C     NDP = NUMBER OF DATA POINTS,
C     XD  = ARRAY OF DIMENSION NDP CONTAINING THE
C           X COORDINATES OF THE DATA POINTS,
C     YD  = ARRAY OF DIMENSION NDP CONTAINING THE
C           Y COORDINATES OF THE DATA POINTS.
C THE OUTPUT PARAMETERS ARE
C     NT  = NUMBER OF TRIANGLES,
C     IPT = ARRAY OF DIMENSION 6*NDP-15, WHERE THE POINT
C           NUMBERS OF THE VERTEXES OF THE (IT)TH TRIANGLE
C           ARE TO BE STORED AS THE (3*IT-2)ND, (3*IT-1)ST,
C           AND (3*IT)TH ELEMENTS, IT=1,2,...,NT,
C     NL  = NUMBER OF BORDER LINE SEGMENTS,
C     IPL = ARRAY OF DIMENSION 6*NDP, WHERE THE POINT
C           NUMBERS OF THE END POINTS OF THE (IL)TH BORDER
C           LINE SEGMENT AND ITS RESPECTIVE TRIANGLE NUMBER
C           ARE TO BE STORED AS THE (3*IL-2)ND, (3*IL-1)ST,
C           AND (3*IL)TH ELEMENTS, IL=1,2,..., NL.
C THE OTHER PARAMETERS ARE
C     IWL = INTEGER ARRAY OF DIMENSION 18*NDP USED
C           INTERNALLY AS A WORK AREA,
C     IWP = INTEGER ARRAY OF DIMENSION NDP USED
C           INTERNALLY AS A WORK AREA,
C     WK  = ARRAY OF DIMENSION NDP USED INTERNALLY AS A
C           WORK AREA.
C DECLARATION STATEMENTS
C
      SAVE
C
      INTEGER         CONXCH
      COMMON /CONRA3/ IREC
      DIMENSION       XD(*)      ,YD(*)      ,IPT(*)     ,IPL(*)     ,
     1                IWL(*)     ,IWP(*)     ,WK(*)
      DIMENSION       ITF(2)
        CHARACTER*4  IP1C, IP2C
        CHARACTER*64  ITEMP
      DATA  RATIO/1.0E-6/, NREP/100/
C
C STATEMENT FUNCTIONS
C
      DSQF(U1,V1,U2,V2) = (U2-U1)**2+(V2-V1)**2
      SIDE(U1,V1,U2,V2,U3,V3) = (V3-V1)*(U2-U1)-(U3-U1)*(V2-V1)
C
C PRELIMINARY PROCESSING
C
      NDPM1 = NDP-1
C
C DETERMINES THE CLOSEST PAIR OF DATA POINTS AND THEIR MIDPOINT.
C
      DSQMN = DSQF(XD(1),YD(1),XD(2),YD(2))
      IPMN1 = 1
      IPMN2 = 2
      DO  140 IP1=1,NDPM1
         X1 = XD(IP1)
         Y1 = YD(IP1)
         IP1P1 = IP1+1
         DO  130 IP2=IP1P1,NDP
            DSQI = DSQF(X1,Y1,XD(IP2),YD(IP2))
            IF (DSQI .NE. 0.) GO TO  120
C
C  ERROR, IDENTICAL INPUT DATA POINTS
C
          ITEMP = ' CONTNG-IDENTICAL INPUT DATA POINTS FOUND
     1 AT      AND      '
C 
C + NOAO - FTN internal writes rewritten as calls to encode for IRAF
C
C         WRITE(IP1C,'(I4)')IP1
C         WRITE(IP2C,'(I4)')IP2
          call encode (4, '(I4)', ip1c, ip1)
	  call encode (4, '(I4)', ip2c, ip2)
C - NOAO
C
            CALL SETER (ITEMP,1,1)
            ITEMP(46:49) = IP1C
            ITEMP(55:58) = IP2C
            RETURN
  120       IF (DSQI .GE. DSQMN) GO TO  130
            DSQMN = DSQI
            IPMN1 = IP1
            IPMN2 = IP2
  130    CONTINUE
  140 CONTINUE
      DSQ12 = DSQMN
      XDMP = (XD(IPMN1)+XD(IPMN2))/2.0
      YDMP = (YD(IPMN1)+YD(IPMN2))/2.0
C
C SORTS THE OTHER (NDP-2) DATA POINTS IN ASCENDING ORDER OF
C DISTANCE FROM THE MIDPOINT AND STORES THE SORTED DATA POINT
C NUMBERS IN THE IWP ARRAY.
C
      JP1 = 2
      DO  150 IP1=1,NDP
         IF (IP1.EQ.IPMN1 .OR. IP1.EQ.IPMN2) GO TO  150
         JP1 = JP1+1
         IWP(JP1) = IP1
         WK(JP1) = DSQF(XDMP,YDMP,XD(IP1),YD(IP1))
  150 CONTINUE
      DO  170 JP1=3,NDPM1
         DSQMN = WK(JP1)
         JPMN = JP1
         DO  160 JP2=JP1,NDP
            IF (WK(JP2) .GE. DSQMN) GO TO  160
            DSQMN = WK(JP2)
            JPMN = JP2
  160    CONTINUE
         ITS = IWP(JP1)
         IWP(JP1) = IWP(JPMN)
         IWP(JPMN) = ITS
         WK(JPMN) = WK(JP1)
  170 CONTINUE
C
C IF NECESSARY, MODIFIES THE ORDERING IN SUCH A WAY THAT THE
C FIRST THREE DATA POINTS ARE NOT COLLINEAR.
C
      AR = DSQ12*RATIO
      X1 = XD(IPMN1)
      Y1 = YD(IPMN1)
      DX21 = XD(IPMN2)-X1
      DY21 = YD(IPMN2)-Y1
      DO  180 JP=3,NDP
         IP = IWP(JP)
         IF (ABS((YD(IP)-Y1)*DX21-(XD(IP)-X1)*DY21) .GT. AR) GO TO  190
  180 CONTINUE
      CALL SETER (' CONTNG - ALL COLLINEAR DATA POINTS',1,1)
  190 IF (JP .EQ. 3) GO TO  210
      JPMX = JP
      JP = JPMX+1
      DO  200 JPC=4,JPMX
         JP = JP-1
         IWP(JP) = IWP(JP-1)
  200 CONTINUE
      IWP(3) = IP
C
C FORMS THE FIRST TRIANGLE.  STORES POINT NUMBERS OF THE VER-
C TEXES OF THE TRIANGLE IN THE IPT ARRAY, AND STORES POINT NUM-
C BERS OF THE BORDER LINE SEGMENTS AND THE TRIANGLE NUMBER IN
C THE IPL ARRAY.
C
  210 IP1 = IPMN1
      IP2 = IPMN2
      IP3 = IWP(3)
      IF (SIDE(XD(IP1),YD(IP1),XD(IP2),YD(IP2),XD(IP3),YD(IP3)) .GE.
     1    0.0) GO TO  220
      IP1 = IPMN2
      IP2 = IPMN1
  220 NT0 = 1
      NTT3 = 3
      IPT(1) = IP1
      IPT(2) = IP2
      IPT(3) = IP3
      NL0 = 3
      NLT3 = 9
      IPL(1) = IP1
      IPL(2) = IP2
      IPL(3) = 1
      IPL(4) = IP2
      IPL(5) = IP3
      IPL(6) = 1
      IPL(7) = IP3
      IPL(8) = IP1
      IPL(9) = 1
C
C ADDS THE REMAINING (NDP-3) DATA POINTS, ONE BY ONE.
C
      DO  400 JP1=4,NDP
         IP1 = IWP(JP1)
         X1 = XD(IP1)
         Y1 = YD(IP1)
C
C - DETERMINES THE VISIBLE BORDER LINE SEGMENTS.
C
         IP2 = IPL(1)
         JPMN = 1
         DXMN = XD(IP2)-X1
         DYMN = YD(IP2)-Y1
         DSQMN = DXMN**2+DYMN**2
         ARMN = DSQMN*RATIO
         JPMX = 1
         DXMX = DXMN
         DYMX = DYMN
         DSQMX = DSQMN
         ARMX = ARMN
         DO  240 JP2=2,NL0
            IP2 = IPL(3*JP2-2)
            DX = XD(IP2)-X1
            DY = YD(IP2)-Y1
            AR = DY*DXMN-DX*DYMN
            IF (AR .GT. ARMN) GO TO  230
            DSQI = DX**2+DY**2
            IF (AR.GE.(-ARMN) .AND. DSQI.GE.DSQMN) GO TO  230
            JPMN = JP2
            DXMN = DX
            DYMN = DY
            DSQMN = DSQI
            ARMN = DSQMN*RATIO
  230       AR = DY*DXMX-DX*DYMX
            IF (AR .LT. (-ARMX)) GO TO  240
            DSQI = DX**2+DY**2
            IF (AR.LE.ARMX .AND. DSQI.GE.DSQMX) GO TO  240
            JPMX = JP2
            DXMX = DX
            DYMX = DY
            DSQMX = DSQI
            ARMX = DSQMX*RATIO
  240    CONTINUE
         IF (JPMX .LT. JPMN) JPMX = JPMX+NL0
         NSH = JPMN-1
         IF (NSH .LE. 0) GO TO  270
C
C - SHIFTS (ROTATES) THE IPL ARRAY TO HAVE THE INVISIBLE BORDER
C - LINE SEGMENTS CONTAINED IN THE FIRST PART OF THE IPL ARRAY.
C
         NSHT3 = NSH*3
         DO  250 JP2T3=3,NSHT3,3
            JP3T3 = JP2T3+NLT3
            IPL(JP3T3-2) = IPL(JP2T3-2)
            IPL(JP3T3-1) = IPL(JP2T3-1)
            IPL(JP3T3) = IPL(JP2T3)
  250    CONTINUE
         DO  260 JP2T3=3,NLT3,3
            JP3T3 = JP2T3+NSHT3
            IPL(JP2T3-2) = IPL(JP3T3-2)
            IPL(JP2T3-1) = IPL(JP3T3-1)
            IPL(JP2T3) = IPL(JP3T3)
  260    CONTINUE
         JPMX = JPMX-NSH
C
C - ADDS TRIANGLES TO THE IPT ARRAY, UPDATES BORDER LINE
C - SEGMENTS IN THE IPL ARRAY, AND SETS FLAGS FOR THE BORDER
C - LINE SEGMENTS TO BE REEXAMINED IN THE IWL ARRAY.
C
  270    JWL = 0
         DO  310 JP2=JPMX,NL0
            JP2T3 = JP2*3
            IPL1 = IPL(JP2T3-2)
            IPL2 = IPL(JP2T3-1)
            IT = IPL(JP2T3)
C
C - - ADDS A TRIANGLE TO THE IPT ARRAY.
C
            NT0 = NT0+1
            NTT3 = NTT3+3
            IPT(NTT3-2) = IPL2
            IPT(NTT3-1) = IPL1
            IPT(NTT3) = IP1
C
C - - UPDATES BORDER LINE SEGMENTS IN THE IPL ARRAY.
C
            IF (JP2 .NE. JPMX) GO TO  280
            IPL(JP2T3-1) = IP1
            IPL(JP2T3) = NT0
  280       IF (JP2 .NE. NL0) GO TO  290
            NLN = JPMX+1
            NLNT3 = NLN*3
            IPL(NLNT3-2) = IP1
            IPL(NLNT3-1) = IPL(1)
            IPL(NLNT3) = NT0
C
C - - DETERMINES THE VERTEX THAT DOES NOT LIE ON THE BORDER
C - - LINE SEGMENTS.
C
  290       ITT3 = IT*3
            IPTI = IPT(ITT3-2)
            IF (IPTI.NE.IPL1 .AND. IPTI.NE.IPL2) GO TO  300
            IPTI = IPT(ITT3-1)
            IF (IPTI.NE.IPL1 .AND. IPTI.NE.IPL2) GO TO  300
            IPTI = IPT(ITT3)
C
C - - CHECKS IF THE EXCHANGE IS NECESSARY.
C
  300       IF (CONXCH(XD,YD,IP1,IPTI,IPL1,IPL2) .EQ. 0) GO TO  310
C
C - - MODIFIES THE IPT ARRAY WHEN NECESSARY.
C
            IPT(ITT3-2) = IPTI
            IPT(ITT3-1) = IPL1
            IPT(ITT3) = IP1
            IPT(NTT3-1) = IPTI
            IF (JP2 .EQ. JPMX) IPL(JP2T3) = IT
            IF (JP2.EQ.NL0 .AND. IPL(3).EQ.IT) IPL(3) = NT0
C
C - - SETS FLAGS IN THE IWL ARRAY.
C
            JWL = JWL+4
            IWL(JWL-3) = IPL1
            IWL(JWL-2) = IPTI
            IWL(JWL-1) = IPTI
            IWL(JWL) = IPL2
  310    CONTINUE
         NL0 = NLN
         NLT3 = NLNT3
         NLF = JWL/2
         IF (NLF .EQ. 0) GO TO  400
C
C - IMPROVES TRIANGULATION.
C
         NTT3P3 = NTT3+3
         DO  390 IREP=1,NREP
            DO  370 ILF=1,NLF
               ILFT2 = ILF*2
               IPL1 = IWL(ILFT2-1)
               IPL2 = IWL(ILFT2)
C
C - - LOCATES IN THE IPT ARRAY TWO TRIANGLES ON BOTH SIDES OF
C - - THE FLAGGED LINE SEGMENT.
C
               NTF = 0
               DO  320 ITT3R=3,NTT3,3
                  ITT3 = NTT3P3-ITT3R
                  IPT1 = IPT(ITT3-2)
                  IPT2 = IPT(ITT3-1)
                  IPT3 = IPT(ITT3)
                  IF (IPL1.NE.IPT1 .AND. IPL1.NE.IPT2 .AND.
     1                IPL1.NE.IPT3) GO TO  320
                  IF (IPL2.NE.IPT1 .AND. IPL2.NE.IPT2 .AND.
     1                IPL2.NE.IPT3) GO TO  320
                  NTF = NTF+1
                  ITF(NTF) = ITT3/3
                  IF (NTF .EQ. 2) GO TO  330
  320          CONTINUE
               IF (NTF .LT. 2) GO TO  370
C
C - - DETERMINES THE VERTEXES OF THE TRIANGLES THAT DO NOT LIE
C - - ON THE LINE SEGMENT.
C
  330          IT1T3 = ITF(1)*3
               IPTI1 = IPT(IT1T3-2)
               IF (IPTI1.NE.IPL1 .AND. IPTI1.NE.IPL2) GO TO  340
               IPTI1 = IPT(IT1T3-1)
               IF (IPTI1.NE.IPL1 .AND. IPTI1.NE.IPL2) GO TO  340
               IPTI1 = IPT(IT1T3)
  340          IT2T3 = ITF(2)*3
               IPTI2 = IPT(IT2T3-2)
               IF (IPTI2.NE.IPL1 .AND. IPTI2.NE.IPL2) GO TO  350
               IPTI2 = IPT(IT2T3-1)
               IF (IPTI2.NE.IPL1 .AND. IPTI2.NE.IPL2) GO TO  350
               IPTI2 = IPT(IT2T3)
C
C - - CHECKS IF THE EXCHANGE IS NECESSARY.
C
  350          IF (CONXCH(XD,YD,IPTI1,IPTI2,IPL1,IPL2) .EQ. 0)
     1             GO TO  370
C
C - - MODIFIES THE IPT ARRAY WHEN NECESSARY.
C
               IPT(IT1T3-2) = IPTI1
               IPT(IT1T3-1) = IPTI2
               IPT(IT1T3) = IPL1
               IPT(IT2T3-2) = IPTI2
               IPT(IT2T3-1) = IPTI1
               IPT(IT2T3) = IPL2
C
C - - SETS NEW FLAGS.
C
               JWL = JWL+8
               IWL(JWL-7) = IPL1
               IWL(JWL-6) = IPTI1
               IWL(JWL-5) = IPTI1
               IWL(JWL-4) = IPL2
               IWL(JWL-3) = IPL2
               IWL(JWL-2) = IPTI2
               IWL(JWL-1) = IPTI2
               IWL(JWL) = IPL1
               DO  360 JLT3=3,NLT3,3
                  IPLJ1 = IPL(JLT3-2)
                  IPLJ2 = IPL(JLT3-1)
                  IF ((IPLJ1.EQ.IPL1 .AND. IPLJ2.EQ.IPTI2) .OR.
     1                (IPLJ2.EQ.IPL1 .AND. IPLJ1.EQ.IPTI2))
     2                IPL(JLT3) = ITF(1)
                  IF ((IPLJ1.EQ.IPL2 .AND. IPLJ2.EQ.IPTI1) .OR.
     1                (IPLJ2.EQ.IPL2 .AND. IPLJ1.EQ.IPTI1))
     2                IPL(JLT3) = ITF(2)
  360          CONTINUE
  370       CONTINUE
            NLFC = NLF
            NLF = JWL/2
            IF (NLF .EQ. NLFC) GO TO  400
C
C - - RESETS THE IWL ARRAY FOR THE NEXT ROUND.
C
            JWL = 0
            JWL1MN = (NLFC+1)*2
            NLFT2 = NLF*2
            DO  380 JWL1=JWL1MN,NLFT2,2
               JWL = JWL+2
               IWL(JWL-1) = IWL(JWL1-1)
               IWL(JWL) = IWL(JWL1)
  380       CONTINUE
            NLF = JWL/2
  390    CONTINUE
  400 CONTINUE
C
C REARRANGE THE IPT ARRAY SO THAT THE VERTEXES OF EACH TRIANGLE
C ARE LISTED COUNTER-CLOCKWISE.
C
      DO  410 ITT3=3,NTT3,3
         IP1 = IPT(ITT3-2)
         IP2 = IPT(ITT3-1)
         IP3 = IPT(ITT3)
         IF (SIDE(XD(IP1),YD(IP1),XD(IP2),YD(IP2),XD(IP3),YD(IP3)) .GE.
     1       0.0) GO TO  410
         IPT(ITT3-2) = IP2
         IPT(ITT3-1) = IP1
  410 CONTINUE
      NT = NT0
      NL = NL0
      RETURN
      END

      SUBROUTINE slRFLI (STRING, NSTRT, RESLT, JFLAG)
*+
*     - - - - - - -
*      R F L I
*     - - - - - - -
*
*  Convert free-format input into single precision floating point
*
*  Given:
*     STRING     c     string containing number to be decoded
*     NSTRT      i     pointer to where decoding is to start
*     RESLT      r     current value of result
*
*  Returned:
*     NSTRT      i      advanced to next number
*     RESLT      r      result
*     JFLAG      i      status: -1 = -OK, 0 = +OK, 1 = null, 2 = error
*
*  Called:  slDFLI
*
*  Notes:
*
*     1     The reason FLOTIN has separate OK status values for +
*           and - is to enable minus zero to be detected.   This is
*           of crucial importance when decoding mixed-radix numbers.
*           For example, an angle expressed as deg, arcmin, arcsec
*           may have a leading minus sign but a zero degrees field.
*
*     2     A TAB is interpreted as a space, and lowercase characters
*           are interpreted as uppercase.
*
*     3     The basic format is the sequence of fields #^.^@#^, where
*           # is a sign character + or -, ^ means a string of decimal
*           digits, and @, which indicates an exponent, means D or E.
*           Various combinations of these fields can be omitted, and
*           embedded blanks are permissible in certain places.
*
*     4     Spaces:
*
*             .  Leading spaces are ignored.
*
*             .  Embedded spaces are allowed only after +, -, D or E,
*                and after the decomal point if the first sequence of
*                digits is absent.
*
*             .  Trailing spaces are ignored;  the first signifies
*                end of decoding and subsequent ones are skipped.
*
*     5     Delimiters:
*
*             .  Any character other than +,-,0-9,.,D,E or space may be
*                used to signal the end of the number and terminate
*                decoding.
*
*             .  Comma is recognized by FLOTIN as a special case;  it
*                is skipped, leaving the pointer on the next character.
*                See 13, below.
*
*     6     Both signs are optional.  The default is +.
*
*     7     The mantissa ^.^ defaults to 1.
*
*     8     The exponent @#^ defaults to E0.
*
*     9     The strings of decimal digits may be of any length.
*
*     10    The decimal point is optional for whole numbers.
*
*     11    A "null result" occurs when the string of characters being
*           decoded does not begin with +,-,0-9,.,D or E, or consists
*           entirely of spaces.  When this condition is detected, JFLAG
*           is set to 1 and RESLT is left untouched.
*
*     12    NSTRT = 1 for the first character in the string.
*
*     13    On return from FLOTIN, NSTRT is set ready for the next
*           decode - following trailing blanks and any comma.  If a
*           delimiter other than comma is being used, NSTRT must be
*           incremented before the next call to FLOTIN, otherwise
*           all subsequent calls will return a null result.
*
*     14    Errors (JFLAG=2) occur when:
*
*             .  a +, -, D or E is left unsatisfied;  or
*
*             .  the decimal point is present without at least
*                one decimal digit before or after it;  or
*
*             .  an exponent more than 100 has been presented.
*
*     15    When an error has been detected, NSTRT is left
*           pointing to the character following the last
*           one used before the error came to light.  This
*           may be after the point at which a more sophisticated
*           program could have detected the error.  For example,
*           FLOTIN does not detect that '1E999' is unacceptable
*           (on a computer where this is so) until the entire number
*           has been decoded.
*
*     16    Certain highly unlikely combinations of mantissa &
*           exponent can cause arithmetic faults during the
*           decode, in some cases despite the fact that they
*           together could be construed as a valid number.
*
*     17    Decoding is left to right, one pass.
*
*     18    See also DFLTIN and INTIN
*
*  P.T.Wallace   Starlink   23 November 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER NSTRT
      REAL RESLT
      INTEGER JFLAG

      DOUBLE PRECISION DRESLT


*  Call the double precision version
      CALL slDFLI(STRING,NSTRT,DRESLT,JFLAG)
      IF (JFLAG.LE.0) RESLT=REAL(DRESLT)

      END

      SUBROUTINE slDFLI (STRING, NSTRT, DRESLT, JFLAG)
*+
*     - - - - - - -
*      D F L I
*     - - - - - - -
*
*  Convert free-format input into double precision floating point
*
*  Given:
*     STRING     c     string containing number to be decoded
*     NSTRT      i     pointer to where decoding is to start
*     DRESLT     d     current value of result
*
*  Returned:
*     NSTRT      i      advanced to next number
*     DRESLT     d      result
*     JFLAG      i      status: -1 = -OK, 0 = +OK, 1 = null, 2 = error
*
*  Notes:
*
*     1     The reason DFLTIN has separate OK status values for +
*           and - is to enable minus zero to be detected.   This is
*           of crucial importance when decoding mixed-radix numbers.
*           For example, an angle expressed as deg, arcmin, arcsec
*           may have a leading minus sign but a zero degrees field.
*
*     2     A TAB is interpreted as a space, and lowercase characters
*           are interpreted as uppercase.
*
*     3     The basic format is the sequence of fields #^.^@#^, where
*           # is a sign character + or -, ^ means a string of decimal
*           digits, and @, which indicates an exponent, means D or E.
*           Various combinations of these fields can be omitted, and
*           embedded blanks are permissible in certain places.
*
*     4     Spaces:
*
*             .  Leading spaces are ignored.
*
*             .  Embedded spaces are allowed only after +, -, D or E,
*                and after the decomal point if the first sequence of
*                digits is absent.
*
*             .  Trailing spaces are ignored;  the first signifies
*                end of decoding and subsequent ones are skipped.
*
*     5     Delimiters:
*
*             .  Any character other than +,-,0-9,.,D,E or space may be
*                used to signal the end of the number and terminate
*                decoding.
*
*             .  Comma is recognized by DFLTIN as a special case;  it
*                is skipped, leaving the pointer on the next character.
*                See 13, below.
*
*     6     Both signs are optional.  The default is +.
*
*     7     The mantissa ^.^ defaults to 1.
*
*     8     The exponent @#^ defaults to D0.
*
*     9     The strings of decimal digits may be of any length.
*
*     10    The decimal point is optional for whole numbers.
*
*     11    A "null result" occurs when the string of characters being
*           decoded does not begin with +,-,0-9,.,D or E, or consists
*           entirely of spaces.  When this condition is detected, JFLAG
*           is set to 1 and DRESLT is left untouched.
*
*     12    NSTRT = 1 for the first character in the string.
*
*     13    On return from DFLTIN, NSTRT is set ready for the next
*           decode - following trailing blanks and any comma.  If a
*           delimiter other than comma is being used, NSTRT must be
*           incremented before the next call to DFLTIN, otherwise
*           all subsequent calls will return a null result.
*
*     14    Errors (JFLAG=2) occur when:
*
*             .  a +, -, D or E is left unsatisfied;  or
*
*             .  the decimal point is present without at least
*                one decimal digit before or after it;  or
*
*             .  an exponent more than 100 has been presented.
*
*     15    When an error has been detected, NSTRT is left
*           pointing to the character following the last
*           one used before the error came to light.  This
*           may be after the point at which a more sophisticated
*           program could have detected the error.  For example,
*           DFLTIN does not detect that '1D999' is unacceptable
*           (on a computer where this is so) until the entire number
*           has been decoded.
*
*     16    Certain highly unlikely combinations of mantissa &
*           exponent can cause arithmetic faults during the
*           decode, in some cases despite the fact that they
*           together could be construed as a valid number.
*
*     17    Decoding is left to right, one pass.
*
*     18    See also FLOTIN and INTIN
*
*  Called:  slICHF
*
*  P.T.Wallace   Starlink   18 March 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER NSTRT
      DOUBLE PRECISION DRESLT
      INTEGER JFLAG

      INTEGER NPTR,MSIGN,NEXP,NDP,NVEC,NDIGIT,ISIGNX,J
      DOUBLE PRECISION DMANT,DIGIT



*  Current character
      NPTR=NSTRT

*  Set defaults: mantissa & sign, exponent & sign, decimal place count
      DMANT=0D0
      MSIGN=1
      NEXP=0
      ISIGNX=1
      NDP=0

*  Look for sign
 100  CONTINUE
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO ( 400,  100,  800,  500,  300,  200, 9110, 9100, 9110),NVEC
*             0-9    SP   D/E    .     +     -     ,   ELSE   END

*  Negative
 200  CONTINUE
      MSIGN=-1

*  Look for first leading decimal
 300  CONTINUE
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO ( 400, 300,  800,  500, 9200, 9200, 9200, 9200, 9210),NVEC
*             0-9   SP   D/E    .     +     -     ,   ELSE   END

*  Accept leading decimals
 400  CONTINUE
      DMANT=DMANT*1D1+DIGIT
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO ( 400, 1310,  900,  600, 1300, 1300, 1300, 1300, 1310),NVEC
*             0-9   SP    D/E    .     +     -     ,   ELSE   END

*  Look for decimal when none preceded the point
 500  CONTINUE
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO ( 700, 500, 9200, 9200, 9200, 9200, 9200, 9200, 9210),NVEC
*             0-9   SP   D/E    .     +     -     ,   ELSE   END

*  Look for trailing decimals
 600  CONTINUE
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO ( 700, 1310,  900, 1300, 1300, 1300, 1300, 1300, 1310),NVEC
*             0-9   SP    D/E    .     +     -     ,   ELSE   END

*  Accept trailing decimals
 700  CONTINUE
      NDP=NDP+1
      DMANT=DMANT*1D1+DIGIT
      GO TO 600

*  Exponent symbol first in field: default mantissa to 1
 800  CONTINUE
      DMANT=1D0

*  Look for sign of exponent
 900  CONTINUE
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO (1200, 900, 9200, 9200, 1100, 1000, 9200, 9200, 9210),NVEC
*             0-9   SP   D/E    .     +     -     ,   ELSE   END

*  Exponent negative
 1000 CONTINUE
      ISIGNX=-1

*  Look for first digit of exponent
 1100 CONTINUE
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO (1200, 1100, 9200, 9200, 9200, 9200, 9200, 9200, 9210),NVEC
*             0-9   SP    D/E    .     +     -     ,   ELSE   END

*  Use exponent digit
 1200 CONTINUE
      NEXP=NEXP*10+NDIGIT
      IF (NEXP.GT.100) GO TO 9200

*  Look for subsequent digits of exponent
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO (1200, 1310, 1300, 1300, 1300, 1300, 1300, 1300, 1310),NVEC
*             0-9   SP    D/E    .     +     -     ,   ELSE   END

*  Combine exponent and decimal place count
 1300 CONTINUE
      NPTR=NPTR-1
 1310 CONTINUE
      NEXP=NEXP*ISIGNX-NDP

*  Skip if net exponent negative
      IF (NEXP.LT.0) GO TO 1500

*  Positive exponent: scale up
 1400 CONTINUE
      IF (NEXP.LT.10) GO TO 1410
      DMANT=DMANT*1D10
      NEXP=NEXP-10
      GO TO 1400
 1410 CONTINUE
      IF (NEXP.LT.1) GO TO 1600
      DMANT=DMANT*1D1
      NEXP=NEXP-1
      GO TO 1410

*  Negative exponent: scale down
 1500 CONTINUE
      IF (NEXP.GT.-10) GO TO 1510
      DMANT=DMANT/1D10
      NEXP=NEXP+10
      GO TO 1500
 1510 CONTINUE
      IF (NEXP.GT.-1) GO TO 1600
      DMANT=DMANT/1D1
      NEXP=NEXP+1
      GO TO 1510

*  Get result & status
 1600 CONTINUE
      J=0
      IF (MSIGN.EQ.1) GO TO 1610
      J=-1
      DMANT=-DMANT
 1610 CONTINUE
      DRESLT=DMANT

*  Skip to end of field
 1620 CONTINUE
      CALL slICHF(STRING,NPTR,NVEC,NDIGIT,DIGIT)
      GO TO (1720, 1620, 1720, 1720, 1720, 1720, 9900, 1720, 9900),NVEC
*             0-9   SP    D/E    .     +     -     ,   ELSE   END

 1720 CONTINUE
      NPTR=NPTR-1
      GO TO 9900


*  Exits

*  Null field
 9100 CONTINUE
      NPTR=NPTR-1
 9110 CONTINUE
      J=1
      GO TO 9900

*  Errors
 9200 CONTINUE
      NPTR=NPTR-1
 9210 CONTINUE
      J=2

*  Return
 9900 CONTINUE
      NSTRT=NPTR
      JFLAG=J

      END

      real function round ( x )
c  from  * a practical guide to splines *  by c. de boor
called in example 1  of chapter xiii
      real x,	flip,size
      common /rount/ size
      data flip /-1./
      flip = -flip
      round = x + flip*size
					return
      end

c PCUBE -- Extract a subraster (image cube) from an image and print
c the values on the standard output.  This is used with a standard
c test image to verify that the IMFORT interface is working correctly.
c
c	usage:  pcube image i1 i2 [j1 j2 [k1 k2]]
c ---------------------------------------------------------------------

	program pcube

	character*80	image, errmsg
	integer		i1, i2, j1, j2, k1, k2
	integer		im, ier, axlen(7), naxis, dtype, nargs
	real		pix(8192)

c --- Get image name.
	call clargc (1, image, ier)
	if (ier .ne. 0) then
	    write (*, '('' enter image name: '',$)')
	    read (*,*) image
	endif

c --- Open the image.
	call imopen (image, 1, im, ier)
	if (ier .ne. 0) goto 91
	call imgsiz (im, axlen, naxis, dtype, ier)
	if (ier .ne. 0) goto 91

c --- Get subraster coordinates.
	call clnarg (nargs)
	if (nargs .lt. 3) then
	    write (*, '('' enter subraster coordinates (i1 i2 j1 j2): '',$)')
	    read (*,*) i1, i2, j1, j2
	    k1 = 1
	    k2 = 1
	else
	    call clargi (2, i1, ier)
	    if (ier .ne. 0) goto 91
	    call clargi (3, i2, ier)
	    if (ier .ne. 0) goto 91

	    if (nargs .ge. 5) then
		call clargi (4, j1, ier)
		if (ier .ne. 0) goto 91
		call clargi (5, j2, ier)
		if (ier .ne. 0) goto 91
	    else
		j1 = 1
		j2 = 1
	    endif

	    if (nargs .ge. 7) then
		call clargi (6, k1, ier)
		if (ier .ne. 0) goto 91
		call clargi (7, k2, ier)
		if (ier .ne. 0) goto 91
	    else
		k1 = 1
		k2 = 1
	    endif
	endif

c --- Extract the subraster.
	call imgs3r (im, pix, i1, i2, j1, j2, k1, k2, ier)
	if (ier .ne. 0) goto 91

c --- Print the pixel values.
	call pcuber (pix, i2-i1+1, j2-j1+1, k2-k1+1, i1,i2, j1,j2, k1,k2)

c --- Close the input image and quit.
	call imclos (im, ier)
	if (ier .ne. 0) goto 91

	stop

c --- Error handler.
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg
	stop
	end


c PCUBER -- Print pixel values, 3d subraster, type real.
c ----------------------------------------------------------------

	subroutine pcuber (pix, nx,ny,nz, i1,i2, j1,j2, k1,k2)

	integer		nx, ny, nz
	real		pix(nx,ny,nz)
	integer		i1, i2, j1, j2, k1, k2
	integer		i, j, k

	nx = i2 - i1 + 1
	ny = j2 - j1 + 1
	nz = k2 - k1 + 1

	do 20 k = k1, k2
	    write (*, '('' band '', i3)') k

	    print 81, i1, i2, j1, j2
	    do 10 j = 1, ny
		print 82, j-1+j1, (pix(i,j,k), i = 1, nx)
 10	    continue
 20	continue

 81	format (' subraster at ', 4 i4)
 82	format (' line ', i4, 8 (1x, f7.0))

	end

      SUBROUTINE slPVEL (PV, DATE, PMASS, JFORMR,
     :                      JFORM, EPOCH, ORBINC, ANODE, PERIH,
     :                      AORQ, E, AORL, DM, JSTAT)
*+
*     - - - - - -
*      P V E L
*     - - - - - -
*
*  Heliocentric osculating elements obtained from instantaneous position
*  and velocity.
*
*  Given:
*     PV        d(6)   heliocentric x,y,z,xdot,ydot,zdot of date,
*                      J2000 equatorial triad (AU,AU/s; Note 1)
*     DATE      d      date (TT Modified Julian Date = JD-2400000.5)
*     PMASS     d      mass of the planet (Sun=1; Note 2)
*     JFORMR    i      requested element set (1-3; Note 3)
*
*  Returned:
*     JFORM     d      element set actually returned (1-3; Note 4)
*     EPOCH     d      epoch of elements (TT MJD)
*     ORBINC    d      inclination (radians)
*     ANODE     d      longitude of the ascending node (radians)
*     PERIH     d      longitude or argument of perihelion (radians)
*     AORQ      d      mean distance or perihelion distance (AU)
*     E         d      eccentricity
*     AORL      d      mean anomaly or longitude (radians, JFORM=1,2 only)
*     DM        d      daily motion (radians, JFORM=1 only)
*     JSTAT     i      status:  0 = OK
*                              -1 = illegal PMASS
*                              -2 = illegal JFORMR
*                              -3 = position/velocity out of range
*
*  Notes
*
*  1  The PV 6-vector is with respect to the mean equator and equinox of
*     epoch J2000.  The orbital elements produced are with respect to
*     the J2000 ecliptic and mean equinox.
*
*  2  The mass, PMASS, is important only for the larger planets.  For
*     most purposes (e.g. asteroids) use 0D0.  Values less than zero
*     are illegal.
*
*  3  Three different element-format options are supported:
*
*     Option JFORM=1, suitable for the major planets:
*
*     EPOCH  = epoch of elements (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = longitude of perihelion, curly pi (radians)
*     AORQ   = mean distance, a (AU)
*     E      = eccentricity, e
*     AORL   = mean longitude L (radians)
*     DM     = daily motion (radians)
*
*     Option JFORM=2, suitable for minor planets:
*
*     EPOCH  = epoch of elements (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = argument of perihelion, little omega (radians)
*     AORQ   = mean distance, a (AU)
*     E      = eccentricity, e
*     AORL   = mean anomaly M (radians)
*
*     Option JFORM=3, suitable for comets:
*
*     EPOCH  = epoch of perihelion (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = argument of perihelion, little omega (radians)
*     AORQ   = perihelion distance, q (AU)
*     E      = eccentricity, e
*
*  4  It may not be possible to generate elements in the form
*     requested through JFORMR.  The caller is notified of the form
*     of elements actually returned by means of the JFORM argument:
*
*      JFORMR   JFORM     meaning
*
*        1        1       OK - elements are in the requested format
*        1        2       never happens
*        1        3       orbit not elliptical
*
*        2        1       never happens
*        2        2       OK - elements are in the requested format
*        2        3       orbit not elliptical
*
*        3        1       never happens
*        3        2       never happens
*        3        3       OK - elements are in the requested format
*
*  5  The arguments returned for each value of JFORM (cf Note 5: JFORM
*     may not be the same as JFORMR) are as follows:
*
*         JFORM         1              2              3
*         EPOCH         t0             t0             T
*         ORBINC        i              i              i
*         ANODE         Omega          Omega          Omega
*         PERIH         curly pi       omega          omega
*         AORQ          a              a              q
*         E             e              e              e
*         AORL          L              M              -
*         DM            n              -              -
*
*     where:
*
*         t0           is the epoch of the elements (MJD, TT)
*         T              "    epoch of perihelion (MJD, TT)
*         i              "    inclination (radians)
*         Omega          "    longitude of the ascending node (radians)
*         curly pi       "    longitude of perihelion (radians)
*         omega          "    argument of perihelion (radians)
*         a              "    mean distance (AU)
*         q              "    perihelion distance (AU)
*         e              "    eccentricity
*         L              "    longitude (radians, 0-2pi)
*         M              "    mean anomaly (radians, 0-2pi)
*         n              "    daily motion (radians)
*         -             means no value is set
*
*  6  At very small inclinations, the longitude of the ascending node
*     ANODE becomes indeterminate and under some circumstances may be
*     set arbitrarily to zero.  Similarly, if the orbit is close to
*     circular, the true anomaly becomes indeterminate and under some
*     circumstances may be set arbitrarily to zero.  In such cases,
*     the other elements are automatically adjusted to compensate,
*     and so the elements remain a valid description of the orbit.
*
*  7  The osculating epoch for the returned elements is the argument
*     DATE.
*
*  Reference:  Sterne, Theodore E., "An Introduction to Celestial
*              Mechanics", Interscience Publishers, 1960
*
*  Called:  slDA2P
*
*  Last revision:   8 September 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION PV(6),DATE,PMASS
      INTEGER JFORMR,JFORM
      DOUBLE PRECISION EPOCH,ORBINC,ANODE,PERIH,AORQ,E,AORL,DM
      INTEGER JSTAT

*  Seconds to days
      DOUBLE PRECISION DAY
      PARAMETER (DAY=86400D0)

*  Gaussian gravitational constant (exact)
      DOUBLE PRECISION GCON
      PARAMETER (GCON=0.01720209895D0)

*  Sin and cos of J2000 mean obliquity (IAU 1976)
      DOUBLE PRECISION SE,CE
      PARAMETER (SE=0.3977771559319137D0,
     :           CE=0.9174820620691818D0)

*  Minimum allowed distance (AU) and speed (AU/day)
      DOUBLE PRECISION RMIN,VMIN
      PARAMETER (RMIN=1D-3,VMIN=1D-8)

*  How close to unity the eccentricity has to be to call it a parabola
      DOUBLE PRECISION PARAB
      PARAMETER (PARAB=1D-8)

      DOUBLE PRECISION X,Y,Z,XD,YD,ZD,R,V2,V,RDV,GMU,HX,HY,HZ,
     :                 HX2PY2,H2,H,OI,BIGOM,AR,ECC,S,C,AT,U,OM,
     :                 GAR3,EM1,EP1,HAT,SHAT,CHAT,AE,AM,DN,PL,
     :                 EL,Q,TP,THAT,THHF,F

      INTEGER JF

      DOUBLE PRECISION slDA2P


*  Validate arguments PMASS and JFORMR.
      IF (PMASS.LT.0D0) THEN
         JSTAT = -1
         GO TO 999
      END IF
      IF (JFORMR.LT.1.OR.JFORMR.GT.3) THEN
         JSTAT = -2
         GO TO 999
      END IF

*  Provisionally assume the elements will be in the chosen form.
      JF = JFORMR

*  Rotate the position from equatorial to ecliptic coordinates.
      X = PV(1)
      Y = PV(2)*CE+PV(3)*SE
      Z = -PV(2)*SE+PV(3)*CE

*  Rotate the velocity similarly, scaling to AU/day.
      XD = DAY*PV(4)
      YD = DAY*(PV(5)*CE+PV(6)*SE)
      ZD = DAY*(-PV(5)*SE+PV(6)*CE)

*  Distance and speed.
      R = SQRT(X*X+Y*Y+Z*Z)
      V2 = XD*XD+YD*YD+ZD*ZD
      V = SQRT(V2)

*  Reject unreasonably small values.
      IF (R.LT.RMIN.OR.V.LT.VMIN) THEN
         JSTAT = -3
         GO TO 999
      END IF

*  R dot V.
      RDV = X*XD+Y*YD+Z*ZD

*  Mu.
      GMU = (1D0+PMASS)*GCON*GCON

*  Vector angular momentum per unit reduced mass.
      HX = Y*ZD-Z*YD
      HY = Z*XD-X*ZD
      HZ = X*YD-Y*XD

*  Areal constant.
      HX2PY2 = HX*HX+HY*HY
      H2 = HX2PY2+HZ*HZ
      H = SQRT(H2)

*  Inclination.
      OI = ATAN2(SQRT(HX2PY2),HZ)

*  Longitude of ascending node.
      IF (HX.NE.0D0.OR.HY.NE.0D0) THEN
         BIGOM = ATAN2(HX,-HY)
      ELSE
         BIGOM=0D0
      END IF

*  Reciprocal of mean distance etc.
      AR = 2D0/R-V2/GMU

*  Eccentricity.
      ECC = SQRT(MAX(1D0-AR*H2/GMU,0D0))

*  True anomaly.
      S = H*RDV
      C = H2-R*GMU
      IF (S.NE.0D0.OR.C.NE.0D0) THEN
         AT = ATAN2(S,C)
      ELSE
         AT = 0D0
      END IF

*  Argument of the latitude.
      S = SIN(BIGOM)
      C = COS(BIGOM)
      U = ATAN2((-X*S+Y*C)*COS(OI)+Z*SIN(OI),X*C+Y*S)

*  Argument of perihelion.
      OM = U-AT

*  Capture near-parabolic cases.
      IF (ABS(ECC-1D0).LT.PARAB) ECC=1D0

*  Comply with JFORMR = 1 or 2 only if orbit is elliptical.
      IF (ECC.GE.1D0) JF=3

*  Functions.
      GAR3 = GMU*AR*AR*AR
      EM1 = ECC-1D0
      EP1 = ECC+1D0
      HAT = AT/2D0
      SHAT = SIN(HAT)
      CHAT = COS(HAT)

*  Variable initializations to avoid compiler warnings.
      AM = 0D0
      DN = 0D0
      PL = 0D0
      EL = 0D0
      Q = 0D0
      TP = 0D0

*  Ellipse?
      IF (ECC.LT.1D0 ) THEN

*     Eccentric anomaly.
         AE = 2D0*ATAN2(SQRT(-EM1)*SHAT,SQRT(EP1)*CHAT)

*     Mean anomaly.
         AM = AE-ECC*SIN(AE)

*     Daily motion.
         DN = SQRT(GAR3)
      END IF

*  "Major planet" element set?
      IF (JF.EQ.1) THEN

*     Longitude of perihelion.
         PL = BIGOM+OM

*     Longitude at epoch.
         EL = PL+AM
      END IF

*  "Comet" element set?
      IF (JF.EQ.3) THEN

*     Perihelion distance.
         Q = H2/(GMU*EP1)

*     Ellipse, parabola, hyperbola?
         IF (ECC.LT.1D0) THEN

*        Ellipse: epoch of perihelion.
            TP = DATE-AM/DN
         ELSE

*        Parabola or hyperbola: evaluate tan ( ( true anomaly ) / 2 )
            THAT = SHAT/CHAT
            IF (ECC.EQ.1D0) THEN

*           Parabola: epoch of perihelion.
               TP = DATE-THAT*(1D0+THAT*THAT/3D0)*H*H2/(2D0*GMU*GMU)
            ELSE

*           Hyperbola: epoch of perihelion.
               THHF = SQRT(EM1/EP1)*THAT
               F = LOG(1D0+THHF)-LOG(1D0-THHF)
               TP = DATE-(ECC*SINH(F)-F)/SQRT(-GAR3)
            END IF
         END IF
      END IF

*  Return the appropriate set of elements.
      JFORM = JF
      ORBINC = OI
      ANODE = slDA2P(BIGOM)
      E = ECC
      IF (JF.EQ.1) THEN
         PERIH = slDA2P(PL)
         AORL = slDA2P(EL)
         DM = DN
      ELSE
         PERIH = slDA2P(OM)
         IF (JF.EQ.2) AORL = slDA2P(AM)
      END IF
      IF (JF.NE.3) THEN
         EPOCH = DATE
         AORQ = 1D0/AR
      ELSE
         EPOCH = TP
         AORQ = Q
      END IF
      JSTAT = 0

 999  CONTINUE
      END

      SUBROUTINE COSTI (N,WSAVE)
      DIMENSION       WSAVE(*)
      DATA PI /3.14159265358979/
      IF (N .LE. 3) RETURN
      NM1 = N-1
      NP1 = N+1
      NS2 = N/2
      DT = PI/FLOAT(NM1)
      FK = 0.
      DO 101 K=2,NS2
         KC = NP1-K
         FK = FK+1.
         WSAVE(K) = 2.*SIN(FK*DT)
         WSAVE(KC) = 2.*COS(FK*DT)
  101 CONTINUE
      CALL RFFTI (NM1,WSAVE(N+1))
      RETURN
      END

      SUBROUTINE slATMD (TDK, PMB, RH, WL1, A1, B1, WL2, A2, B2)
*+
*     - - - - - - -
*      A T M D
*     - - - - - - -
*
*  Apply atmospheric-dispersion adjustments to refraction coefficients.
*
*  Given:
*     TDK       d       ambient temperature, K
*     PMB       d       ambient pressure, millibars
*     RH        d       ambient relative humidity, 0-1
*     WL1       d       reference wavelength, micrometre (0.4D0 recommended)
*     A1        d       refraction coefficient A for wavelength WL1 (radians)
*     B1        d       refraction coefficient B for wavelength WL1 (radians)
*     WL2       d       wavelength for which adjusted A,B required
*
*  Returned:
*     A2        d       refraction coefficient A for wavelength WL2 (radians)
*     B2        d       refraction coefficient B for wavelength WL2 (radians)
*
*  Notes:
*
*  1  To use this routine, first call slRFCO specifying WL1 as the
*     wavelength.  This yields refraction coefficients A1,B1, correct
*     for that wavelength.  Subsequently, calls to slATMD specifying
*     different wavelengths will produce new, slightly adjusted
*     refraction coefficients which apply to the specified wavelength.
*
*  2  Most of the atmospheric dispersion happens between 0.7 micrometre
*     and the UV atmospheric cutoff, and the effect increases strongly
*     towards the UV end.  For this reason a blue reference wavelength
*     is recommended, for example 0.4 micrometres.
*
*  3  The accuracy, for this set of conditions:
*
*        height above sea level    2000 m
*                      latitude    29 deg
*                      pressure    793 mb
*                   temperature    17 degC
*                      humidity    50%
*                    lapse rate    0.0065 degC/m
*          reference wavelength    0.4 micrometre
*                star elevation    15 deg
*
*     is about 2.5 mas RMS between 0.3 and 1.0 micrometres, and stays
*     within 4 mas for the whole range longward of 0.3 micrometres
*     (compared with a total dispersion from 0.3 to 20.0 micrometres
*     of about 11 arcsec).  These errors are typical for ordinary
*     conditions and the given elevation;  in extreme conditions values
*     a few times this size may occur, while at higher elevations the
*     errors become much smaller.
*
*  4  If either wavelength exceeds 100 micrometres, the radio case
*     is assumed and the returned refraction coefficients are the
*     same as the given ones.  Note that radio refraction coefficients
*     cannot be turned into optical values using this routine, nor
*     vice versa.
*
*  5  The algorithm consists of calculation of the refractivity of the
*     air at the observer for the two wavelengths, using the methods
*     of the slRFRO routine, and then scaling of the two refraction
*     coefficients according to classical refraction theory.  This
*     amounts to scaling the A coefficient in proportion to (n-1) and
*     the B coefficient almost in the same ratio (see R.M.Green,
*     "Spherical Astronomy", Cambridge University Press, 1985).
*
*  Last revision   2 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION TDK,PMB,RH,WL1,A1,B1,WL2,A2,B2

      DOUBLE PRECISION F,TDKOK,PMBOK,RHOK,
     :                 PSAT,PWO,W1,WLOK,WLSQ,W2,DN1,DN2


*  Check for radio wavelengths
      IF (WL1.GT.100D0.OR.WL2.GT.100D0) THEN

*     Radio: no dispersion
         A2 = A1
         B2 = B1
      ELSE

*     Optical: keep arguments within safe bounds
         TDKOK = MIN(MAX(TDK,100D0),500D0)
         PMBOK = MIN(MAX(PMB,0D0),10000D0)
         RHOK = MIN(MAX(RH,0D0),1D0)

*     Atmosphere parameters at the observer
         PSAT = 10D0**(-8.7115D0+0.03477D0*TDKOK)
         PWO = RHOK*PSAT
         W1 = 11.2684D-6*PWO

*     Refractivity at the observer for first wavelength
         WLOK = MAX(WL1,0.1D0)
         WLSQ = WLOK*WLOK
         W2 = 77.5317D-6+(0.43909D-6+0.00367D-6/WLSQ)/WLSQ
         DN1 = (W2*PMBOK-W1)/TDKOK

*     Refractivity at the observer for second wavelength
         WLOK = MAX(WL2,0.1D0)
         WLSQ = WLOK*WLOK
         W2 = 77.5317D-6+(0.43909D-6+0.00367D-6/WLSQ)/WLSQ
         DN2 = (W2*PMBOK-W1)/TDKOK

*     Scale the refraction coefficients (see Green 4.31, p93)
         IF (DN1.NE.0D0) THEN
            F = DN2/DN1
            A2 = A1*F
            B2 = B1*F
            IF (DN1.NE.A1) B2=B2*(1D0+DN1*(DN1-DN2)/(2D0*(DN1-A1)))
         ELSE
            A2 = A1
            B2 = B1
         END IF
      END IF

      END

      real function smooth ( x, y, dy, npoint, s, v, a )
c  from  * a practical guide to splines *  by c. de boor
calls  setupq, chol1d
c
c  constructs the cubic smoothing spline  f  to given data  (x(i),y(i)),
c  i=1,...,npoint, which has as small a second derivative as possible
c  while
c  s(f) = sum( ((y(i)-f(x(i)))/dy(i))**2 , i=1,...,npoint ) .le. s .
c
c******  i n p u t  ******
c  x(1),...,x(npoint)	data abscissae,  a s s u m e d	to be strictly
c	 increasing .
c  y(1),...,y(npoint)	  corresponding data ordinates .
c  dy(1),...,dy(npoint)     estimate of uncertainty in data,  a s s u m-
c	 e d  to be positive .
c  npoint.....number of data points,  a s s u m e d  .gt. 1
c  s.....upper bound on the discrete weighted mean square distance of
c	 the approximation  f  from the data .
c
c******  w o r k  a r r a y s  *****
c  v.....of size (npoint,7)
c  a.....of size (npoint,4)
c
c*****	o u t p u t  *****
c  a(.,1).....contains the sequence of smoothed ordinates .
c  a(i,j) = d**(j-1)f(x(i)), j=2,3,4, i=1,...,npoint-1 ,  i.e., the
c	 first three derivatives of the smoothing spline  f  at the
c	 left end of each of the data intervals .
c     w a r n i n g . . .   a  would have to be transposed before it
c	 could be used in  ppvalu .
c
c******  m e t h o d  ******
c     the matrices  q-transp*d	and  q-transp*d**2*q  are constructed in
c   s e t u p q  from  x  and  dy , as is the vector  qty = q-transp*y .
c  then, for given  p , the vector  u  is determined in  c h o l 1 d  as
c  the solution of the linear system
c		(6(1-p)q-transp*d**2*q + p*r)u	= qty  .
c  from  u , the smoothing spline  f  (for this choice of smoothing par-
c  ameter  p ) is obtained in the sense that
c			 f(x(.))  =  y - 6(1-p)d**2*q*u        and
c		   (d**2)f(x(.))  =  6*p*u			.
c     the smoothing parameter  p  is found (if possible) so that
c		 sf(p)	=  s ,
c  with  sf(p) = s(f) , where  f  is the smoothing spline as it depends
c  on  p .  if	s = 0, then p = 1 . if	sf(0) .le. s , then p = 0 .
c  otherwise, the secant method is used to locate an appropriate  p  in
c  the open interval  (0,1) . specifically,
c		 p(0) = 0,  p(1) = (s - sf(0))/dsf
c  with  dsf = -24*u-transp*r*u  a good approximation to  d(sf(0)) = dsf
c  + 60*(d*q*u)-transp*(d*q*u) , and  u  as obtained for  p = 0 .
c  after that, for n=1,2,...  until sf(p(n)) .le. 1.01*s, do....
c     determine  p(n+1)  as the point at which the secant to  sf  at the
c     points  p(n)  and  p(n-1)  takes on the value  s .
c     if  p(n+1) .ge. 1 , choose instead  p(n+1)  as the point at which
c     the parabola  sf(p(n))*((1-.)/(1-p(n)))**2  takes on the value  s.
c     note that, in exact arithmetic, always  p(n+1) .lt. p(n) , hence
c     sf(p(n+1)) .lt. sf(p(n)) . therefore, also stop the iteration,
c     with final  p = 1 , in case  sf(p(n+1)) .ge. sf(p(n)) .
c
      integer npoint,	i,npm1
      real a(npoint,4),dy(npoint),s,v(npoint,7),x(npoint),y(npoint)
     *	   ,change,p,prevsf,prevp,sfp,sixp,six1mp,utru
      call setupq(x,dy,y,npoint,v,a(1,4))
      if (s .gt. 0.)			go to 20
   10 p = 1.
      call chol1d(p,v,a(1,4),npoint,1,a(1,3),a(1,1))
      sfp = 0.
					go to 60
   20 p = 0.
      call chol1d(p,v,a(1,4),npoint,1,a(1,3),a(1,1))
      sfp = 0.
      do 21 i=1,npoint
   21	 sfp = sfp + (a(i,1)*dy(i))**2
      sfp = sfp*36.
      if (sfp .le. s)			go to 60
      prevp = 0.
      prevsf = sfp
      utru = 0.
      do 25 i=2,npoint
   25	 utru = utru + v(i-1,4)*(a(i-1,3)*(a(i-1,3)+a(i,3))+a(i,3)**2)
      p = (sfp-s)/(24.*utru)
c  secant iteration for the determination of p starts here.
   30 call chol1d(p,v,a(1,4),npoint,1,a(1,3),a(1,1))
      sfp = 0.
      do 35 i=1,npoint
   35	 sfp = sfp+ (a(i,1)*dy(i))**2
      sfp = sfp*36.*(1.-p)**2
      if (sfp .le. 1.01*s)		go to 60
      if (sfp .ge. prevsf)		go to 10
      change = (p-prevp)/(sfp-prevsf)*(sfp-s)
      prevp = p
      p = p - change
      prevsf = sfp
      if (p .lt. 1.)			go to 30
      p = 1. - sqrt(s/prevsf)*(1.-prevp)
					go to 30
correct value of p has been found.
compute pol.coefficients from  q*u (in a(.,1)).
   60 smooth = sfp
      six1mp = 6.*(1.-p)
      do 61 i=1,npoint
   61	 a(i,1) = y(i) - six1mp*dy(i)**2*a(i,1)
      sixp = 6.*p
      do 62 i=1,npoint
   62	 a(i,3) = a(i,3)*sixp
      npm1 = npoint - 1
      do 63 i=1,npm1
	 a(i,4) = (a(i+1,3)-a(i,3))/v(i,4)
   63	 a(i,2) = (a(i+1,1)-a(i,1))/v(i,4)
     *			    - (a(i,3)+a(i,4)/3.*v(i,4))/2.*v(i,4)
					return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
c +noao: block data changed to run time initialization. Logical param
c "first" added, so initialization doesn't occur more than once.
c     BLOCKDATA DASHBD
        subroutine dashbd
C
C DASHBD IS USED TO INITIALIZE VARIABLES IN NAMED COMMON.
C
        logical first
c
      COMMON /DASHD1/  ISL,  L,  ISIZE,  IP(100),  NWDSM1,  IPFLAG(100)
     1                 ,MNCSTR, IGP
C
      COMMON /FDFLAG/ IFLAG
C
      COMMON /DDFLAG/ IFCFLG
C
      COMMON /DCFLAG/ IFSTFL
C
      COMMON /DFFLAG/ IFSTF2
C
      COMMON /CFFLAG/ IVCTFG
C
      COMMON /DSAVE3/ IXSTOR,IYSTOR
C
      COMMON /DSAVE5/ XSAVE(70), YSAVE(70), XSVN, YSVN, XSV1, YSV1,
     1                SLP1, SLPN, SSLP1, SSLPN, N, NSEG
C
      COMMON /SMFLAG/ IOFFS
C
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
C
        SAVE
        data first /.true./
        if (.not. first) return
        first = .false.
            
C IFSTFL CONTROLS THAT FRSTD IS CALLED BEFORE VECTD IS CALLED (IN CFVLD)
C WHENEVER DASHDB OR DASHDC HAS BEEN CALLED.
C
c     DATA IFSTFL /1/
      IFSTFL  = 1
C
C IVCTFG INDICATES IF VECTD IS BEING CALLED OR LASTD (IN CFVLD)
C
c     DATA IVCTFG /1/
      IVCTFG = 1
C
C ISL IS A FLAG FOR AN ALL SOLID PATTERN (+1) OR AN ALL GAP PATTERN (-1)
C
c     DATA ISL /1/
      ISL = 1
C
C IGP IS AN INTERNAL PARAMETER. IT IS DESCRIBED IN THE DOCUMENTATION
C TO THE DASHED LINE PACKAGE.
C
c     DATA IGP /9/
      IGP = 9
C
C MNCSTR IS THE MAXIMUM NUMBER OF CHARACTERS ALLOWED IN A HOLLERITH
C STRING PASSED TO DASHDC.
C
c     DATA MNCSTR /15/
      MNCSTR = 15
C
C IOFFS IS AN INTERNAL PARAMETER.
C IOFFS IS USED IN FDVDLD AND DRAWPV.
C
c     DATA IOFFS /0/
      IOFFS = 0
C
C  INTERNAL PARAMETERS
C
c     DATA IPAU/3/
      IPAU = 3
c     DATA FPART/1./
      FPART = 1.
c     DATA TENSN/2.5/
      TENSN = 2.5
c     DATA NP/150/
      NP = 150
c     DATA SMALL/128./
      SMALL = 128.
c     DATA L1/70/
      L1 = 70
c     DATA ADDLR/2./
      ADDLR = 2.
c     DATA ADDTB/2./
      ADDTB = 2.
c     DATA MLLINE/384/
      MLLINE = 384
c     DATA ICLOSE/6/
      ICLOSE = 6
C
C IFSTF2 IS A FLAG TO CONTROL THAT FRSTD IS CALLED BEFORE VECTD IS
C CALLED (IN SUBROUTINE FDVDLD), WHENEVER DASHDB OR DASHDC
C HAS BEEN CALLED.
C
c     DATA IFSTF2 /1/
      IFSTF2  = 1
C
C IFLAG CONTROLS IF LASTD CAN BE CALLED DIRECTLY OR IF IT WAS JUST
C CALLED FROM BY VECTD SO THAT THIS CALL CAN BE IGNORED.
C
c     DATA IFLAG /1/
      IFLAG = 1
C
C IFCFLG IS THE FIRST CALL FLAG FOR SUBROUTINES DASHDB AND DASHDC.
C  1 = FIRST CALL TO DASHDB OR DASHDC.
C  2 = DASHDB OR DASHDC HAS BEEN CALLED BEFORE.
C
c     DATA IFCFLG /1/
      IFCFLG = 1
C
C IXSTOR AND IYSTOR CONTAIN THE CURRENT PEN POSITION. THEY ARE
C INITIALIZED TO AN IMPOSSIBLE VALUE.
C
c     DATA IXSTOR,IYSTOR /-9999,-9999/
      IXSTOR = -9999 
      IYSTOR = -9999
C
C SLP1 AND SLPN ARE INITIALIZED TO AVOID THAT THEY ARE PASSED AS ACTUAL
C PARAMETERS FROM FDVDLD TO KURV1S WITHOUT BEING DEFINED.
C
c     DATA SLP1,SLPN /-9999.,-9999./
      SLP1 = -9999. 
      SLPN = -9999.
c -noao
C
      END

include	defs

# putstr - output character string in specified field

   subroutine putstr (str, w, fd)
   character str (ARB)
   integer w
   filedes fd

   character length

   integer i, len

   len = length (str)
   for (i = len + 1; i <= w; i = i + 1)
      call putch (BLANK, fd)
   for (i = 1; i <= len; i = i + 1)
      call putch (str (i), fd)
   for (i = (-w) - len; i > 0; i = i - 1)
      call putch (BLANK, fd)

   return
   end

        SUBROUTINE CONSLD (SCRARR)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  THIS ROUTINE IS USED TO GENERATE A SHIELD WHERE CONTOUR
C  DRAWING IS ALLOWED.
C
C  THE ROUTINE TAKES THE SILHOUETTE INFORMATION FROM COMMON BLOCK
C  CONR13 AND TRANSFORMS THIS INTO A SHIELD TO BE USED IN THE
C  SCRATCH ARRAY PASSED IN BY THE USER (THE SCRATCH ARRAY HOLDS THE
C  GRIDED DATA FROM THE INTERPOLATION).
C
C  INPUT
C       SCRARR-THE SCRATCH ARRAY HOLDING THE INTERPOLATED DATA
C
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
C
C  INCREASE THE RESOLUTION OF THE SHIELD PROFILE
C
      DIMENSION SCRARR(1)
C
      SAVE
      DATA RESINC/8.0/
C
C  STATEMENT FUNCTION TO MAKE ARRAY ACCESS SEEM LIKE MATRIX ACCESS
C
C +NOAO
C  These statement functions are never called.
C     SCRTCH(IXX,IYY) = SCRARR(IYY+(IXX-1)*IYMAX)
C     IARVL(IXX,IYY) = IYY+(IXX-1)*IYMAX
C -NOAO
      IGADDR(XXX,YYY) =
     1 IFIX((YYY-YST)/STPSZ+.5)+(IFIX((XXX-XST)/STPSZ+.5))*IYMAX
C
C  SET THE SPECIAL VALUE
C
      SPVAL = SPVAL * 2.
C
C  SET THE USER ARRAY LOCATIONS TO TEMPORARY POINTERS
C
C  LOOP FOR ALL SHIELD ELEMENTS
C
      DO 100 IC = 1,ICOUNT
C
C       ASSIGN LINE SEGMENT END POINTS
C
        X1 = XVS(IC)
        Y1 = YVS(IC)
        IF (IC .EQ. ICOUNT) GO TO 10
                X2 = XVS(IC+1)
                Y2 = YVS(IC+1)
                GO TO 15
 10             CONTINUE
                X2 = XVS(1)
                Y2 = YVS(1)
 15     CONTINUE
C
C  INSURE THAT ALL POINTS ARE IN THE CONVEX HULL
C
      IF (X1.GT.XED) X1 = XED
      IF (X1.LT.XST) X1 = XST
      IF (X2.GT.XED) X2 = XED
      IF (X2.LT.XST) X2 = XST
      IF (Y1.GT.YED) Y1 = YED
      IF (Y1.LT.YST) Y1 = YST
      IF (Y2.GT.YED) Y2 = YED
      IF (Y2.LT.YST) Y2 = YST
C
C       SET THE START OF THE LINE SEGMENT SCRATCH LOCATION TO
C       THE SPECIAL VALUE
C
        II = IGADDR(X1,Y1)
        SCRARR(II) = SPVAL
C
C       FIND THE LENGTH OF THE LINE SEGMENT
C
        DIST = SQRT(((X2-X1)**2)+((Y2-Y1)**2))
C
C       IF LENGTH SHORTER THAN STEP SIZE THEN THERE IS NOTHING TO DO
C
        IF (DIST .LE. STPSZ) GO TO 100
C
C       SET UP LOOP TO SET ALL CELLS ON THE LINE SEGMENT
C
        NSTPS = (DIST/STPSZ)*RESINC
        XSTP = (X2-X1)/FLOAT(NSTPS)
        YSTP = (Y2-Y1)/FLOAT(NSTPS)
        X = X1
        Y = Y1
        DO 20 K = 1,NSTPS
                X = X + XSTP
                Y = Y + YSTP
                II = IGADDR(X,Y)
                SCRARR(II) = SPVAL
 20     CONTINUE
C
 100  CONTINUE
C
C  FILL THE SHIELDED AREAS
C       FOR EACH COLUMN THE ELEMENTS ARE SET TO SPVAL IF FILL IS TRUE.
C       THE VALUE OF FILL IS NEGATED EVERY TIME A SPVAL IS ENCOUNTERED,
C       AND THAT CELL REMAINS UNCHANGED.
C
C       LOOP THROUGH THE GRID
C
        DO 39 I = 1,IXMAX
C
C               GET THE START AND END FOR THE COLUMN
C
                IYS = (I-1)*IYMAX+1
                IYE = I*IYMAX
C
C               ADVANCE IN THE FORWARD DIRECTION
C
                DO 32 J = IYS,IYE
C
C                       IF NOT SPVAL THEN SET CELL AS APPROPIATE
C
                        IF (SCRARR(J).EQ.SPVAL) GO TO 33
                                SCRARR(J) = SPVAL
 32             CONTINUE
                GO TO 39
C
C               ADVANCE IN THE BACKWARD DIRECTION
C
 33             CONTINUE
                DO 34 J = 1,IYMAX
                        NJ =IYE+1-J
C                       IF NOT SPVAL THEN SET CELL AS APPROPIATE
C
                        IF (SCRARR(NJ).EQ.SPVAL) GO TO 39
                                SCRARR(NJ) = SPVAL
 34             CONTINUE
 39     CONTINUE
C
      RETURN
      END

C----------------------------------------------------------------------
        subroutine ftcdfl(iunit,status)

C       Check Data Unit Fill values
C       Check that the data unit is correctly filled with zeros or blanks 
C       from the end of the data to the end of the current FITS 2880 byte block

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1994

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nf = 3000)
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character*1 chbuff(2880),chfill,xdummy(2879)
        common/ftheap/chbuff,chfill,xdummy
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,filpos,nfill,i

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       check if the data unit is null
        if (theap(ibuff) .eq. 0)return

C       move to the beginning of the fill bytes
        filpos=dtstrt(ibuff)+theap(ibuff)+scount(ibuff)
        call ftmbyt(iunit,filpos,.true.,status)

C       get all the fill bytes
        nfill=(filpos+2879)/2880*2880-filpos
        if (nfill .eq. 0)return

        call ftgcbf(iunit,0,nfill,chbuff,status)
        if (status .gt. 0)then
           call ftpmsg('Error reading data unit fill bytes (FTCDFL).')
           return
        end if

C       set the correct fill value to be checked
        if (hdutyp(ibuff) .eq. 1)then
C              this is an ASCII table; should be filled with blanks
               chfill=char(32)
        else
               chfill=char(0)
        end if

C       check for all zeros or blanks
        do 10 i=1,nfill
            if (chbuff(i) .ne. chfill)then
                status=255
                if (hdutyp(ibuff) .eq. 1)then
                    call ftpmsg('Warning: remaining bytes following'//
     &              ' ASCII table data are not filled with blanks.')
                else
                    call ftpmsg('Warning: remaining bytes following'//
     &              ' data are not filled with zeros.')
                end if
                return
            end if
10      continue             
        end

C----------------------------------------------------------------------
        subroutine ftgcfl(iunit,colnum,frow,felem,nelem,lray,
     &          flgval,anynul,status)

C       read an array of logical values from a specified column of the table.
C       The binary table column being read from must have datatype 'L'
C       and no datatype conversion will be perform if it is not.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of elements to read
C       lray    l  returned array of data values that is read
C       flgval  l  set .true. if corresponding element undefined
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,status
        logical lray(*),flgval(*),anynul

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bstart,maxpix,tcode,offset
        integer ibuff,i,i1,ntodo,itodo,repeat,rstart,estart
        character*1 buffer(80)
        logical descrp
        
        if (status .gt. 0)return

        ibuff=bufnum(iunit)
C       check for zero length array
        if (nelem .le. 0)then
                return
        else if (frow .lt. 1)then
C               error: illegal first row number
                status=307
        else if (felem .lt. 1)then
C                       illegal element number
                        status=308
        end if

        if (status .gt. 0)return

C       initialize the null flag array
        do 5 i=1,nelem
                flgval(i)=.false.
5       continue
        anynul=.false.

        i1=0
        ntodo=nelem
        rstart=frow-1
        estart=felem-1
        maxpix=80
        tcode=tdtype(colnum+tstart(ibuff))

        if (tcode .eq. 14)then
                repeat=trept(colnum+tstart(ibuff))
                if (felem .gt. repeat)then
C                               illegal element number
                                status=308
                                return
                end if
                descrp=.false.
        else if (tcode .eq. -14)then
C               this is a variable length descriptor column
                descrp=.true.
C               read the number of elements and the starting offset:
                call ftgdes(iunit,colnum,frow,repeat,
     &                              offset,status)
                if (repeat .eq. 0)then
C                       error: null length vector
                        status=318
                        return
                else if (estart+ntodo .gt. repeat)then
C                       error: trying to read beyond end of record
                        status=319
                        return
                end if
C               move the i/o pointer to the start of the pixel sequence
                bstart=dtstrt(ibuff)+offset+
     &                          theap(ibuff)+estart
                call ftmbyt(iunit,bstart,.true.,status)
        else
C               column must be logical data type
                status=312
                return
        end if

C       process as many contiguous pixels as possible
20      itodo=min(ntodo,repeat-estart,maxpix)

        if (.not. descrp)then
C           move the i/o pointer to the start of the sequence of pixels
            bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &             tbcol(colnum+tstart(ibuff))+estart
            call ftmbyt(iunit,bstart,.false.,status)
        end if

C       get the array of logical bytes
        call ftgcbf(iunit,1,itodo,buffer,status)
        if (status .gt. 0)return

C       decode the 'T' and 'F' characters, and look for nulls (0)
        do 10 i=1,itodo
                if (buffer(i) .eq. 'T')then
                        lray(i1+i)=.true.
                else if (buffer(i) .eq. 'F')then
                        lray(i1+i)=.false.
                else if (ichar(buffer(i)) .eq. 0)then
                        flgval(i1+i)=.true.
                        anynul=.true.
                else
                        status=316
                        return
                end if
10      continue
        
C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-itodo
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo
                if (estart .eq. repeat)then
                        estart=0
                        rstart=rstart+1
                end if
                go to 20
        end if
        end

      SUBROUTINE slPREL (EP0, EP1, RMATP)
*+
*     - - - - - -
*      P R E L
*     - - - - - -
*
*  Form the matrix of precession between two epochs, using the
*  model of Simon et al (1994), which is suitable for long
*  periods of time.
*
*  (double precision)
*
*  Given:
*     EP0    dp         beginning epoch
*     EP1    dp         ending epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  Notes:
*
*     1)  The epochs are TDB Julian epochs.
*
*     2)  The matrix is in the sense   V(EP1)  =  RMATP * V(EP0)
*
*     3)  The absolute accuracy of the model is limited by the
*         uncertainty in the general precession, about 0.3 arcsec per
*         1000 years.  The remainder of the formulation provides a
*         precision of 1 mas over the interval from 1000AD to 3000AD,
*         0.1 arcsec from 1000BC to 5000AD and 1 arcsec from
*         4000BC to 8000AD.
*
*  Reference:
*     Simon, J.L. et al., 1994. Astron.Astrophys., 282, 663-683.
*
*  Called:  slDEUL
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION EP0,EP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T0,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch J2000.0 and beginning epoch (1000JY)
      T0 = (EP0-2000D0)/1000D0

*  Interval over which precession required (1000JY)
      T = (EP1-EP0)/1000D0

*  Euler angles
      TAS2R = T*AS2R
      W =      23060.9097D0+
     :          (139.7459D0+
     :           (-0.0038D0+
     :           (-0.5918D0+
     :           (-0.0037D0+
     :             0.0007D0*T0)*T0)*T0)*T0)*T0

      ZETA =   (W+(30.2226D0+
     :            (-0.2523D0+
     :            (-0.3840D0+
     :            (-0.0014D0+
     :              0.0007D0*T0)*T0)*T0)*T0+
     :            (18.0183D0+
     :            (-0.1326D0+
     :             (0.0006D0+
     :              0.0005D0*T0)*T0)*T0+
     :            (-0.0583D0+
     :            (-0.0001D0+
     :              0.0007D0*T0)*T0+
     :            (-0.0285D0+
     :            (-0.0002D0)*T)*T)*T)*T)*T)*TAS2R

      Z =     (W+(109.5270D0+
     :             (0.2446D0+
     :            (-1.3913D0+
     :            (-0.0134D0+
     :              0.0026D0*T0)*T0)*T0)*T0+
     :            (18.2667D0+
     :            (-1.1400D0+
     :            (-0.0173D0+
     :              0.0044D0*T0)*T0)*T0+
     :            (-0.2821D0+
     :            (-0.0093D0+
     :              0.0032D0*T0)*T0+
     :            (-0.0301D0+
     :              0.0006D0*T0
     :             -0.0001D0*T)*T)*T)*T)*T)*TAS2R

      THETA =  (20042.0207D0+
     :           (-85.3131D0+
     :            (-0.2111D0+
     :             (0.3642D0+
     :             (0.0008D0+
     :            (-0.0005D0)*T0)*T0)*T0)*T0)*T0+
     :           (-42.6566D0+
     :            (-0.2111D0+
     :             (0.5463D0+
     :             (0.0017D0+
     :            (-0.0012D0)*T0)*T0)*T0)*T0+
     :           (-41.8238D0+
     :             (0.0359D0+
     :             (0.0027D0+
     :            (-0.0001D0)*T0)*T0)*T0+
     :            (-0.0731D0+
     :             (0.0019D0+
     :              0.0009D0*T0)*T0+
     :            (-0.0127D0+
     :              0.0011D0*T0+0.0004D0*T)*T)*T)*T)*T)*TAS2R

*  Rotation matrix
      CALL slDEUL('ZYZ',-ZETA,THETA,-Z,RMATP)

      END

C
C  F77POS -- Fortran example task to extract position columns from a votable.
C
C  M.Fitzpatrick, NOAO, Aug 2009

        program f77pos

        character  ra*16, dec*16, ucd*30
        integer    vot, res, tab, data, tdata, field
        integer    i, ncols, nrows
        integer    ra_col, dec_col


C       Declare the libvotable functions we'll be using.
C
        integer  vf_openvotable, vf_getresource, vf_gettable
        integer  vf_getdata, vf_gettabledata, vf_getnext
        integer  vf_getfield, vf_getnrows, vf_getncols


C       Parse the table.
C
        vot   = vf_openvotable ("sample.xml")
        res   = vf_getresource (vot)
        tab   = vf_gettable (res)
        data  = vf_getdata (tab)
        tdata = vf_gettabledata (data)

C       Get some useful values.
C
        nrows = vf_getnrows (tdata)
        ncols = vf_getncols (tdata)
            print *, nrows, "  ", ncols

C       Get the RA and DEC columns by matching the UCD.
C
        field = vf_getfield (tab)
        do 90 i = 1, ncols
C           Get the UCD for this FIELD
            call vf_getattr (field, "ucd", ucd, 30)
            if (ucd .eq. "POS_EQ_RA_MAIN")  ra_col = i
            if (ucd .eq. "POS_EQ_DEC_MAIN")  dec_col = i

C           Get the next FIELD (i.e. column) in the table.
            field = vf_getnext (field)
90      continue


C       Loop through the data table and print the selected columns.
C
        do 91 i = 1, nrows
C           Get the value of the cell
            call vf_gettablecell (tdata, i, ra_col,  ra,  16)
            call vf_gettablecell (tdata, i, dec_col, dec, 16)

            print *, ra, "  ", dec
91      continue

        stop
        end

      subroutine trmout (name)
      integer name (100)
      integer tname(9)
      data tname(1)/47/,tname(2)/100/,tname(3)/101/,tname(4)/118/,tname(
     *5)/47/,tname(6)/116/,tname(7)/116/,tname(8)/121/,tname(9)/-2/
      call scopy (tname, 1, name, 1)
      return
      end

      SUBROUTINE CONOT2 (IVER,IUNIT)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C + NOAO - This routine is a no-op in IRAF.
C - NOAO
C
C  OUTPUT THE OPTION VALUES TO THE LINE PRINTER
C
C  CONTINUE FOR CONRAN AND CONRAS
C
C
C
C      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
C     1                FINC       ,HI         ,FLO
C      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
C     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
C     2                CINC       ,CHILO      ,CON        ,LABON      ,
C     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
C     4                BPSIZ      ,LISTOP
C      COMMON /CONRA3/ IREC
C      COMMON /CONRA4/ NCP        ,NCPSZ
C      COMMON /CONRA5/ NIT        ,ITIPV
C      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
C     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
C     2                YRG        ,BORD       ,PXST       ,PYST       ,
C     3                PXED       ,PYED       ,ITICK
C      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
C      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
C     1              LEN      ,IFMT       ,LEND       ,
C     2                IFMTD      ,ISIZEP     ,INMIN
C      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
C     1                BR         ,TL         ,BL         ,CONV       ,
C     2                XN         ,YN         ,ITLL       ,IBLL       ,
C     3                ITRL       ,IBRL       ,XC         ,YC         ,
C     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
C     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
C      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
C     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
C     2                ITPV
C      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
C     1                MINGAP     ,ISIZEM         ,
C     2                TENS
C      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
C      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
C     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
C     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
C     3                TITLE      ,LISTOP     ,CHILO      ,CON
C      COMMON /CONR15/ ISTRNG
C        CHARACTER*64 ISTRNG
C        COMMON /CONR16/ FORM
C        CHARACTER*10 FORM
C        COMMON /CONR17/ NDASH, IDASH, EDASH
C        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C      SAVE
C
C  LABEL THE CONTOURS
C
C      WRITE (IUNIT,1001)
C      IF (LABON) GO TO  100
C      WRITE (IUNIT,1002)
C      GO TO  110
C  100 WRITE (IUNIT,1003)
C
C  LABEL SIZE
C
C  110 WRITE (IUNIT,1004) ISIZEL
C
C  SCALE DATA ON CONTOURS
C
C      WRITE (IUNIT,1005)
C      IF (SCALE .NE. 1.) GO TO  120
C      WRITE (IUNIT,1006)
C      GO TO  130
C  120 WRITE (IUNIT,1007) SCALE
C
C  TENSION FACTOR
C
C  130 WRITE (IUNIT,1008) TENS
C
C  PLOT RELATIVE MINS AND MAXS
C
C      WRITE (IUNIT,1009)
C      IF (PMIMX) GO TO  140
C      WRITE (IUNIT,1010)
C      GO TO  150
C  140 WRITE (IUNIT,1011)
C
C  SIZE OF MINIMUM AND MAXIMUM LABELS
C
C  150 WRITE (IUNIT,1012) ISIZEM
C
C  DASH PATTERN
C
C      WRITE (IUNIT,1013)
C      IF (IDASH(1:1) .EQ. ' ') GO TO  170
C      WRITE (IUNIT,1014) IDASH
C      GO TO  180
C  170 WRITE (IUNIT,1015)
C  180 IF (EDASH(1:1) .EQ. ' ') GO TO  200
C      WRITE (IUNIT,1016) EDASH
C      GO TO  210
C  200 WRITE (IUNIT,1017)
C  210 IF (NDASH(1:1) .EQ. ' ') GO TO  230
C      WRITE (IUNIT,1018) NDASH
C      GO TO  240
C  230 WRITE (IUNIT,1019)
C
C  DASH PATTERN BREAK POINT
C
C  240 WRITE (IUNIT,1020) BPSIZ
C
C  PRINT MINOR LINE GAP
C
C      ITT = MINGAP-1
C      WRITE (IUNIT,1021) ITT
C      RETURN
C
C 1001 FORMAT (5X,'LABEL THE CONTOURS, LAB=')
C 1002 FORMAT ('+',28X,'OFF')
C 1003 FORMAT ('+',28X,'ON')
C 1004 FORMAT (5X,'CONTOUR LABEL SIZE IN PWRIT UNITS, LSZ=',I4)
C 1005 FORMAT (5X,'SCALE THE DATA ON CONTOUR LINES, SDC=')
C 1006 FORMAT ('+',41X,'OFF')
C 1007 FORMAT ('+','ON, SCALE FACTOR=',G10.3)
C 1008 FORMAT (5X,'TENSION FACTOR (USED FOR SMOOTH AND SUPER), TEN=',
C     1        F6.2)
C 1009 FORMAT (5X,'PLOT RELATIVE MINIMUMS AND MAXIMUMS, PMM=')
C 1010 FORMAT ('+',45X,'OFF')
C 1011 FORMAT ('+',45X,'ON')
C 1012 FORMAT (5X,'SIZE OF MIN AND MAX LABELS IN PWRIT UNITS SML=',
C     1        I4)
C 1013 FORMAT (5X,'DASH PATTERN GTR=GREATER, EQU=EQUAL, LSS=LESS')
C 1014 FORMAT (10X,'GTR=',A10)
C 1015 FORMAT (10X,'GTR=$$$$$$$$$$')
C 1016 FORMAT (10X,'EQU=',A10)
C 1017 FORMAT (10X,'EQU=$$$$$$$$$$')
C 1018 FORMAT (10X,'LSS=',A10)
C 1019 FORMAT (10X,'LSS=$$$$$$$$$$')
C 1020 FORMAT (5X,'DASH PATTERN BREAK POINT, DBP=',G10.3)
C 1021 FORMAT (5X,'MINOR LINE COUNT=',I3)
C
C
C******************************************************************
C*                                                                *
C*                   REVISION HISTORY                             *
C*                                                                *
C*  JUNE 1980   ADDED CONTERP TO ULIB                             *
C*  AUGUST 1980 FIXED THE FOLLOWING PROBLEMS                      *
C*              1.PLOTTING OF INPUT DATA VALUES                   *
C*              2.SETTING OF MINIMUM INTENSITY IN ALL OPTION      *
C*              3.SETTING OF EQU FLAG IN CONTOUR DASH PATTERN     *
C*              4.TURNING OFF OF SIZE OF PLOTTED DATA OPTION      *
C*  DECEMBER 1980 FIXED CONTOUR SELECTION ALGORITHM  AND MOVED IN *
C*                DASH PACKAGE COMMON BLOCK INTPR
C*  MARCH 1981  FIXED NON-PORTABLE STATEMENT ORDERING IN CONSET   *
C*  APRIL 1981  FIXED OPTION LISTING ROUTINE                      *
C*              ADDED MINOR LINE COUNT OPTION                     *
C*  JULY 1983   ADDED LINEAR INTERPOLATION AND SHIELDING          *
C*  JULY 1984     CONVERTED TO STANDARD FORTRAN77 AND GKS         *
C*  AUGUST 1985 DELETED LOC (MACHINE DEPENDENT FUNCTION), CHANGED *
C*              COMMON /CONR13/                                   *
C*                                                                *
C******************************************************************
C
      END

C--------------------------------------------------------------------------
        subroutine ftmrec(ounit,nkey,record,status)

C       modify the nth keyword in the CHU, by replacing it with the
C       input 80 character string.
C
C       ounit   i  fortran output unit number
C       nkey    i  sequence number (starting with 1) of the keyword to read
C       record  c  80-character string to replace the record with
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,nkey,status
        character*(*) record
        character rec*80

C       find the old keyword; just use REC as a temporary variable
        call ftgrec(ounit,nkey,rec,status)
        
        rec=record
C       overwrite the keyword with the new record
        call ftmodr(ounit,rec,status)
        end

C----------------------------------------------------------------------
        subroutine fti1i1(input,n,scale,zero,tofits,
     &          chktyp,chkval,setval,flgray,anynul,output,status)

C       copy input i*1 values to output i*1 values, doing optional
C       scaling and checking for null values

C       input   c*1 input array of values
C       n       i  number of values 
C       scale   d  scaling factor to be applied
C       zero    d  scaling zero point to be applied
C       tofits  l  true if converting from internal format to FITS
C       chktyp  i  type of null value checking to be done if TOFITS=.false.
C                       =0  no checking for null values
C                       =1  set null values = SETVAL
C                       =2  set corresponding FLGRAY value = .true.
C       chkval  c*1 value in the input array that is used to indicated nulls
C       setval  c*1 value to set output array to if value is undefined
C       flgray  l   array of logicals indicating if corresponding value is null
C       anynul  l   set to true if any nulls were set in the output array
C       output  c*1 returned array of values
C       status  i  output error status (0 = ok)

        character*1 input(*),chkval
        character*1 output(*),setval
        integer n,i,chktyp,status,itemp
        double precision scale,zero,dval
        logical tofits,flgray(*),anynul,noscal

        if (status .gt. 0)return

        if (scale .eq. 1. .and. zero .eq. 0)then
                noscal=.true.
        else
                noscal=.false.
        end if
        
        if (tofits) then
C               we don't have to worry about null values when writing to FITS
                if (noscal)then
                        do 10 i=1,n
                                output(i)=input(i)
10                      continue
                else
                        do 20 i=1,n
                          itemp=ichar(input(i))
                          if (itemp .lt. 0)itemp=itemp+256
                          dval=(itemp-zero)/scale
C                         trap any values that overflow the I*1 range
                          if (dval.lt. 255.49 .and. dval.gt. -.49)then      
                                output(i)=char(nint(dval))
                          else if (dval .ge. 255.49)then
                                status=-11
                                output(i)=char(255)
                          else
                                status=-11
                                output(i)=char(0)
                          end if
20                      continue
                end if
        else
C               converting from FITS to internal format; may have to check nulls
                if (chktyp .eq. 0)then
C                   don't have to check for nulls
                    if (noscal)then
                                do 30 i=1,n
                                        output(i)=input(i)
30                              continue
                    else
                        do 40 i=1,n
                            itemp=ichar(input(i))
                            if (itemp .lt. 0)itemp=itemp+256
                            dval=itemp*scale+zero
C                           trap any values that overflow the I*1 range
                          if (dval.lt. 255.49 .and. dval.gt. -.49)then      
                                    output(i)=char(int(dval))
                            else if (dval .ge. 255.49)then
                                    status=-11
                                    output(i)=char(255)
                            else
                                    status=-11
                                    output(i)=char(0)
                            end if
40                      continue
                    end if
                else 
C                       must test for null values
                        if (noscal)then
                                do 50 i=1,n
                                        if (input(i) .eq. chkval)then
                                            anynul=.true.
                                            if (chktyp .eq. 1)then
                                                output(i)=setval
                                            else
                                                flgray(i)=.true.
                                            end if
                                        else
                                            output(i)=input(i)
                                        end if
50                              continue
                        else
                         do 60 i=1,n
                          if (input(i) .eq. chkval)then
                                    anynul=.true.
                                    if (chktyp .eq. 1)then
                                        output(i)=setval
                                    else
                                        flgray(i)=.true.
                                    end if
                          else
                            itemp=ichar(input(i))
                            if (itemp .lt. 0)itemp=itemp+256
                            dval=itemp*scale+zero
C                           trap any values that overflow the I*1 range
                            if (dval.lt. 255.49 .and. dval.gt. -.49)then      
                                    output(i)=char(int(dval))
                            else if (dval .ge. 255.49)then
                                    status=-11
                                    output(i)=char(255)
                            else
                                    status=-11
                                    output(i)=char(0)
                            end if
                          end if
60                       continue
                        end if
                end if
        end if
        end

      subroutine spli2d ( tau, gtau, t, n, k, m, work, q, bcoef, iflag )
c  from  * a practical guide to splines *  by c. de boor
calls bsplvb, banfac/slv
c  this is an extended version of  splint , for the use in tensor prod-
c  uct interpolation.
c
c   spli2d  produces the b-spline coeff.s  bcoef(j,.)  of the spline of
c   order  k  with knots  t (i), i=1,..., n + k , which takes on the
c   value  gtau (i,j)  at  tau (i), i=1,..., n , j=1,..., m .
c
c******  i n p u t  ******
c  tau.....array of length  n , containing data point abscissae.
c    a s s u m p t i o n . . .	tau  is strictly increasing
c  gtau(.,j)..corresponding array of length  n , containing data point
c	 ordinates, j=1,...,m
c  t.....knot sequence, of length  n+k
c  n.....number of data points and dimension of spline space  s(k,t)
c  k.....order of spline
c  m.....number of data sets
c
c******  w o r k   a r e a  ******
c  work  a vector of length  n
c
c******  o u t p u t  ******
c  q.....array of size	(2*k-1)*n , containing the triangular factoriz-

c	 ation of the coefficient matrix of the linear system for the b-
c	 coefficients of the spline interpolant.
c	    the b-coeffs for the interpolant of an additional data set
c	 (tau(i),htau(i)), i=1,...,n  with the same data abscissae can
c	 be obtained without going through all the calculations in this

c	 routine, simply by loading  htau  into  bcoef	and then execut-
c	 ing the    call banslv ( q, 2*k-1, n, k-1, k-1, bcoef )
c  bcoef.....the b-coefficients of the interpolant, of length  n
c  iflag.....an integer indicating success (= 1)  or failure (= 2)
c	 the linear system to be solved is (theoretically) invertible if
c	 and only if
c	       t(i) .lt. tau(i) .lt. tau(i+k),	  all i.
c	 violation of this condition is certain to lead to  iflag = 2 .

c
c******  m e t h o d  ******
c     the i-th equation of the linear system  a*bcoef = b  for the b-co-
c  effs of the interpolant enforces interpolation at  tau(i), i=1,...,n.
c  hence,  b(i) = gtau(i), all i, and  a  is a band matrix with  2k-1
c   bands (if it is invertible).
c     the matrix  a  is generated row by row and stored, diagonal by di-
c  agonal, in the  r o w s  of the array  q , with the main diagonal go-
c  ing into row  k .  see comments in the program below.
c     the banded system is then solved by a call to  banfac (which con-

c  structs the triangular factorization for  a	and stores it again in
c   q ), followed by a call to	banslv (which then obtains the solution

c   bcoef  by substitution).
c     banfac  does no pivoting, since the total positivity of the matrix
c  a  makes this unnecessary.
c
      integer iflag,k,m,n,   i,ilp1mx,j,jj,km1,kpkm2,left,lenq,np1
      real bcoef(m,n),gtau(n,m),q(1),t(1),tau(n),work(n),   taui
c     dimension q(2*k-1,n), t(n+k)
current fortran standard makes it impossible to specify precisely the
c  dimension of  q  and  t  without the introduction of otherwise super-
c  fluous additional arguments.
      np1 = n + 1
      km1 = k - 1
      kpkm2 = 2*km1
      left = k
c		 zero out all entries of q
      lenq = n*(k+km1)
      do 5 i=1,lenq
    5	 q(i) = 0.
c
c  ***	 loop over i to construct the  n  interpolation equations
      do 30 i=1,n
	 taui = tau(i)
	 ilp1mx = min0(i+k,np1)
c	 *** find  left  in the closed interval (i,i+k-1) such that
c		 t(left) .le. tau(i) .lt. t(left+1)
c	 matrix is singular if this is not possible
	 left = max0(left,i)
	 if (taui .lt. t(left)) 	go to 998
   15	    if (taui .lt. t(left+1))	go to 16
	    left = left + 1
	    if (left .lt. ilp1mx)	go to 15
	 left = left - 1
	 if (taui .gt. t(left+1))	go to 998
c	 *** the i-th equation enforces interpolation at taui, hence
c	 a(i,j) = b(j,k,t)(taui), all j. only the  k  entries with  j =

c	 left-k+1,...,left actually might be nonzero. these  k	numbers

c	 are returned, in  work  (used for temp.storage here), by the
c	 following
   16	 call bsplvb ( t, k, 1, taui, left, work )
c	 we therefore want  work(j) = b(left -k+j)(taui) to go into
c	 a(i,left-k+j), i.e., into  q(i-(left+j)+2*k,(left+j)-k) since
c	 a(i+j,j)  is to go into  q(i+k,j), all i,j,  if we consider  q

c	 as a two-dim. array , with  2*k-1  rows (see comments in
c	 banfac). in the present program, we treat  q  as an equivalent

c	 one-dimensional array (because of fortran restrictions on
c	 dimension statements) . we therefore want  work(j) to go into
c	 entry
c	     i -(left+j) + 2*k + ((left+j) - k-1)*(2*k-1)
c		    =  i-left+1 + (left -k)*(2*k-1) + (2*k-2)*j
c	 of  q .
	 jj = i-left+1 + (left-k)*(k+km1)
	 do 30 j=1,k
	    jj = jj+kpkm2
   30	    q(jj) = work(j)
c
c     ***obtain factorization of  a  , stored again in	q.
      call banfac ( q, k+km1, n, km1, km1, iflag )
					go to (40,999), iflag
c     *** solve  a*bcoef = gtau  by backsubstitution
   40 do 50 j=1,m
	 do 41 i=1,n
   41	    work(i) = gtau(i,j)
	 call banslv ( q, k+km1, n, km1, km1, work )
	 do 50 i=1,n
   50	    bcoef(j,i) = work(i)
					return
  998 iflag = 2
  999 print 699
  699 format(41h linear system in  splint  not invertible)
					return
      end

      subroutine puttok (str)
      integer str (100)
      integer i
      i = 1
23000 if (.not.(str (i) .ne. -2))goto 23002
      call putchr (str (i))
23001 i = i + 1
      goto 23000
23002 continue
      return
      end

      SUBROUTINE slATMT (R0, T0, ALPHA, GAMM2, DELM2,
     :                      C1, C2, C3, C4, C5, C6, R, T, DN, RDNDR)
*+
*     - - - - -
*      A T M T
*     - - - - -
*
*  Internal routine used by REFRO
*
*  Refractive index and derivative with respect to height for the
*  troposphere.
*
*  Given:
*    R0      d    height of observer from centre of the Earth (metre)
*    T0      d    temperature at the observer (K)
*    ALPHA   d    alpha          )
*    GAMM2   d    gamma minus 2  ) see HMNAO paper
*    DELM2   d    delta minus 2  )
*    C1      d    useful term  )
*    C2      d    useful term  )
*    C3      d    useful term  ) see source
*    C4      d    useful term  ) of slRFRO
*    C5      d    useful term  )
*    C6      d    useful term  )
*    R       d    current distance from the centre of the Earth (metre)
*
*  Returned:
*    T       d    temperature at R (K)
*    DN      d    refractive index at R
*    RDNDR   d    R * rate the refractive index is changing at R
*
*  Note that in the optical case C5 and C6 are zero.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R0,T0,ALPHA,GAMM2,DELM2,C1,C2,C3,C4,C5,C6,
     :                 R,T,DN,RDNDR

      DOUBLE PRECISION TT0,TT0GM2,TT0DM2


      T = MAX(MIN(T0-ALPHA*(R-R0),320D0),100D0)
      TT0 = T/T0
      TT0GM2 = TT0**GAMM2
      TT0DM2 = TT0**DELM2
      DN = 1D0+(C1*TT0GM2-(C2-C5/T)*TT0DM2)*TT0
      RDNDR = R*(-C3*TT0GM2+(C4-C6/TT0)*TT0DM2)

      END

C------------------------------------------------------------------------------
        subroutine ftgtcs(iunit,xcol,ycol,xrval,yrval,xrpix,yrpix,
     &                   xinc,yinc,rot,type,status)

C       read the values of the celestial coordinate system keywords
C       from a FITS table where the X and Y or RA and DEC coordinates
C       are stored in separate column.  
C       
C       These values may be used as input to the subroutines that
C       calculate celestial coordinates. (FTXYPX, FTWLDP)

C       xcol (integer) number of the column containing the RA type coordinate
C       ycol (integer) number of the column containing the DEC type coordinate

        double precision xrval,yrval,xrpix,yrpix,xinc,yinc,rot
        integer iunit,xcol,ycol,status
        character*(*) type
        character comm*20,ctype*8,keynam*8,xnum*3,ynum*3

        if (status .gt. 0)return

        call ftkeyn('TCRVL',xcol,keynam,status)
        xnum=keynam(6:8)
        call ftgkyd(iunit,keynam,xrval,comm,status)

        call ftkeyn('TCRVL',ycol,keynam,status)
        ynum=keynam(6:8)
        call ftgkyd(iunit,keynam,yrval,comm,status)

        keynam='TCRPX'//xnum
        call ftgkyd(iunit,keynam,xrpix,comm,status)
        keynam='TCRPX'//ynum
        call ftgkyd(iunit,keynam,yrpix,comm,status)

        keynam='TCDLT'//xnum
        call ftgkyd(iunit,keynam,xinc,comm,status)
        keynam='TCDLT'//ynum
        call ftgkyd(iunit,keynam,yinc,comm,status)

        keynam='TCTYP'//xnum
        call ftgkys(iunit,keynam,ctype,comm,status)

        if (status .gt. 0)then
            call ftpmsg('FTGTCS could not find all the required'//
     &                  ' celestial coordinate Keywords.')
            status=505
            return
        end if

        type=ctype(5:8)

        rot=0.
        end

      subroutine entxkw
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer sbool(7)
      integer schar(7)
      integer sshort(8)
      integer sint(6)
      integer slong(7)
      integer sreal(7)
      integer sdble(7)
      integer scplx(7)
      integer spntr(7)
      integer sfchr(7)
      integer sfunc(7)
      integer ssubr(7)
      integer sextn(7)
      integer dbool(8)
      integer dchar(10)
      integer dshort(10)
C     integer dint(10)
C     integer dlong(10)
C     integer dpntr(10)
      integer dint(8)
      integer dlong(8)
      integer dpntr(8)
      integer dreal(5)
      integer ddble(17)
      integer dcplx(8)
      integer dfchr(10)
      integer dfunc(9)
      integer dsubr(11)
      integer dextn(9)
      data sbool(1)/120/,sbool(2)/36/,sbool(3)/98/,sbool(4)/111/,sbool(5
     *)/111/,sbool(6)/108/,sbool(7)/-2/
      data schar(1)/120/,schar(2)/36/,schar(3)/99/,schar(4)/104/,schar(5
     *)/97/,schar(6)/114/,schar(7)/-2/
      data sshort(1)/120/,sshort(2)/36/,sshort(3)/115/,sshort(4)/104/,ss
     *hort(5)/111/,sshort(6)/114/,sshort(7)/116/,sshort(8)/-2/
      data sint(1)/120/,sint(2)/36/,sint(3)/105/,sint(4)/110/,sint(5)/11
     *6/,sint(6)/-2/
      data slong(1)/120/,slong(2)/36/,slong(3)/108/,slong(4)/111/,slong(
     *5)/110/,slong(6)/103/,slong(7)/-2/
      data sreal(1)/120/,sreal(2)/36/,sreal(3)/114/,sreal(4)/101/,sreal(
     *5)/97/,sreal(6)/108/,sreal(7)/-2/
      data sdble(1)/120/,sdble(2)/36/,sdble(3)/100/,sdble(4)/98/,sdble(5
     *)/108/,sdble(6)/101/,sdble(7)/-2/
      data scplx(1)/120/,scplx(2)/36/,scplx(3)/99/,scplx(4)/112/,scplx(5
     *)/108/,scplx(6)/120/,scplx(7)/-2/
      data spntr(1)/120/,spntr(2)/36/,spntr(3)/112/,spntr(4)/110/,spntr(
     *5)/116/,spntr(6)/114/,spntr(7)/-2/
      data sfchr(1)/120/,sfchr(2)/36/,sfchr(3)/102/,sfchr(4)/99/,sfchr(5
     *)/104/,sfchr(6)/114/,sfchr(7)/-2/
      data sfunc(1)/120/,sfunc(2)/36/,sfunc(3)/102/,sfunc(4)/117/,sfunc(
     *5)/110/,sfunc(6)/99/,sfunc(7)/-2/
      data ssubr(1)/120/,ssubr(2)/36/,ssubr(3)/115/,ssubr(4)/117/,ssubr(
     *5)/98/,ssubr(6)/114/,ssubr(7)/-2/
      data sextn(1)/120/,sextn(2)/36/,sextn(3)/101/,sextn(4)/120/,sextn(
     *5)/116/,sextn(6)/110/,sextn(7)/-2/
      data dbool(1)/108/,dbool(2)/111/,dbool(3)/103/,dbool(4)/105/,dbool
     *(5)/99/,dbool(6)/97/,dbool(7)/108/,dbool(8)/-2/
      data dchar(1)/105/,dchar(2)/110/,dchar(3)/116/,dchar(4)/101/,dchar
     *(5)/103/,dchar(6)/101/,dchar(7)/114/,dchar(8)/42/,dchar(9)/50/,dch
     *ar(10)/-2/
      data dshort(1)/105/,dshort(2)/110/,dshort(3)/116/,dshort(4)/101/,d
     *short(5)/103/,dshort(6)/101/,dshort(7)/114/,dshort(8)/42/,dshort(9
     *)/50/,dshort(10)/-2/
C     data dint(1)/105/,dint(2)/110/,dint(3)/116/,dint(4)/101/,dint(5)/1
C    *03/,dint(6)/101/,dint(7)/114/,dint(8)/42/,dint(9)/56/,dint(10)/-2/
      data dint(1)/105/,dint(2)/110/,dint(3)/116/,dint(4)/101/,dint(5)/1
     *03/,dint(6)/101/,dint(7)/114/,dint(8)/-2/
C     data dlong(1)/105/,dlong(2)/110/,dlong(3)/116/,dlong(4)/101/,dlong
C    *(5)/103/,dlong(6)/101/,dlong(7)/114/,dlong(8)/42/,dlong(9)/52/,dlo
C    *ng(10)/-2/
      data dlong(1)/105/,dlong(2)/110/,dlong(3)/116/,dlong(4)/101/,dlong
     *(5)/103/,dlong(6)/101/,dlong(7)/114/,dlong(8)/-2/
C     data dpntr(1)/105/,dpntr(2)/110/,dpntr(3)/116/,dpntr(4)/101/,dpntr
C    *(5)/103/,dpntr(6)/101/,dpntr(7)/114/,dpntr(8)/42/,dpntr(9)/56/,dpn
C    *tr(10)/-2/
      data dpntr(1)/105/,dpntr(2)/110/,dpntr(3)/116/,dpntr(4)/101/,dpntr
     *(5)/103/,dpntr(6)/101/,dpntr(7)/114/,dpntr(8)/-2/
      data dreal(1)/114/,dreal(2)/101/,dreal(3)/97/,dreal(4)/108/,dreal(
     *5)/-2/
      data ddble(1)/100/,ddble(2)/111/,ddble(3)/117/,ddble(4)/98/,ddble(
     *5)/108/,ddble(6)/101/,ddble(7)/32/,ddble(8)/112/,ddble(9)/114/,ddb
     *le(10)/101/,ddble(11)/99/,ddble(12)/105/,ddble(13)/115/,ddble(14)/
     *105/,ddble(15)/111/,ddble(16)/110/,ddble(17)/-2/
      data dcplx(1)/99/,dcplx(2)/111/,dcplx(3)/109/,dcplx(4)/112/,dcplx(
     *5)/108/,dcplx(6)/101/,dcplx(7)/120/,dcplx(8)/-2/
      data dfchr(1)/99/,dfchr(2)/104/,dfchr(3)/97/,dfchr(4)/114/,dfchr(5
     *)/97/,dfchr(6)/99/,dfchr(7)/116/,dfchr(8)/101/,dfchr(9)/114/,dfchr
     *(10)/-2/
      data dfunc(1)/102/,dfunc(2)/117/,dfunc(3)/110/,dfunc(4)/99/,dfunc(
     *5)/116/,dfunc(6)/105/,dfunc(7)/111/,dfunc(8)/110/,dfunc(9)/-2/
      data dsubr(1)/115/,dsubr(2)/117/,dsubr(3)/98/,dsubr(4)/114/,dsubr(
     *5)/111/,dsubr(6)/117/,dsubr(7)/116/,dsubr(8)/105/,dsubr(9)/110/,ds
     *ubr(10)/101/,dsubr(11)/-2/
      data dextn(1)/101/,dextn(2)/120/,dextn(3)/116/,dextn(4)/101/,dextn
     *(5)/114/,dextn(6)/110/,dextn(7)/97/,dextn(8)/108/,dextn(9)/-2/
      call entdef (sbool, dbool, xpptbl)
      call entdef (schar, dchar, xpptbl)
      call entdef (sshort, dshort, xpptbl)
      call entdef (sint, dint, xpptbl)
      call entdef (slong, dlong, xpptbl)
      call entdef (spntr, dpntr, xpptbl)
      call entdef (sreal, dreal, xpptbl)
      call entdef (sdble, ddble, xpptbl)
      call entdef (scplx, dcplx, xpptbl)
      call entdef (sfchr, dfchr, xpptbl)
      call entdef (sfunc, dfunc, xpptbl)
      call entdef (ssubr, dsubr, xpptbl)
      call entdef (sextn, dextn, xpptbl)
      end
c     logic0  logical_column

C--------------------------------------------------------------------------
        subroutine ftg2dj(ounit,group,nulval,dim1,nx,ny,
     &                    array,anyflg,status)

C       Read a 2-d image of i*4 values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       nulval  i  undefined pixels will be set to this value (unless = 0)
C       dim1    i  actual first dimension of ARRAY
C       nx      i  size of the image in the x direction
C       ny      i  size of the image in the y direction
C       array   i  the array of values to be read
C       anyflg  l  set to true if any of the image pixels were undefined
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,dim1,nx,ny,status
        integer array(dim1,*),nulval
        logical anyflg,ltemp
        integer fpixel,row

        anyflg=.false.
        fpixel=1
        do 10 row = 1,ny
                call ftgpvj(ounit,group,fpixel,nx,nulval,
     &              array(1,row),ltemp,status)
                if (ltemp)anyflg=.true.
                fpixel=fpixel+nx
10      continue

        end

      SUBROUTINE CONLIN(XD,YD,ZD,NT,IWK,WK)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  THIS ROUTINE GENERATES THE COORDINATES USED IN A LINEAR INTERPOLATION
C  OF THE TRIANGLES CREATED FROM IRREGULARLY DISTRIBUTED DATA.
C
C  INPUT
C       XD-X INPUT COORDINATES]
C       YD-Y INPUT COORDINATES
C       ZD-Z VALUE AT INPUT X,Y
C       NT-NUMBER OF TRIANGLES GENERATED
C       IWK-LIST OF TRIANGLE POINTS, RELATIVE TO XD,YD
C               GROUPED 3 PER TRIANGLE I.E. TRIANGLE 1 IWK(1,2,3),
C               TRIANGLE 2 IWK(4,5,6)  ETC.
C
C  OUTPUT
C       WK ARRAY OF COEFICENTS FOR LINEATION FORMUALS
C               GROUPED 3 PER TRIANGLE
C               POINTS ARE (TRI-1)*3 + 1,2,3
C
      DIMENSION IWK(1),WK(1),XD(1),YD(1),ZD(1)
C
        SAVE
C
C   LOOP FOR ALL TRIANGLES
C
      DO 1000 ITRI = 1,NT
C
C       GET THE POINTS OF THE TRIANGLE
C
        IPOINT = (ITRI-1)*3
        IP1 = IWK(IPOINT+1)
        IP2 = IWK(IPOINT+2)
        IP3 = IWK(IPOINT+3)
C
C       GET THE VALUES AT THE TRIANBGLE POINTS
C
        X1 = XD(IP1)
        Y1 = YD(IP1)
        Z1 = ZD(IP1)
        X2 = XD(IP2)
        Y2 = YD(IP2)
        Z2 = ZD(IP2)
        X3 = XD(IP3)
        Y3 = YD(IP3)
        Z3 = ZD(IP3)
C
C  COMPUTE THE INTERPLOATING COEFICIENTS
C
        WK(IPOINT+1) = (Y2-Y1)*(Z3-Z1)-(Y3-Y1)*(Z2-Z1)
        WK(IPOINT+2) = (X3-X1)*(Z2-Z1)-(X2-X1)*(Z3-Z1)
        WK(IPOINT+3) = (X3-X1)*(Y2-Y1)-(X2-X1)*(Y3-Y1)
C
 1000 CONTINUE
C
      RETURN
      END

#-h-  evalr			 1126  local   12/01/80  15:54:06
# evalr - expand args i through j: evaluate builtin or push back defn
   include  defs

   subroutine evalr (argstk, i, j)
   integer argstk (ARGSIZE), i, j

   include COMMON_BLOCKS

   integer argno, k, m, n, t, td, in_string, delim
   external index
   integer index, length

   string digits '0123456789'

   t = argstk (i)
   td = evalst (t)
   if (td == MACTYPE)
      call domac (argstk, i, j)
   else if (td == INCTYPE)
      call doincr (argstk, i, j)
   else if (td == SUBTYPE)
      call dosub (argstk, i, j)
   else if (td == IFTYPE)
      call doif (argstk, i, j)
   else if (td == ARITHTYPE)
      call doarth (argstk, i, j)
   else {
      in_string = NO
      for (k = t + length (evalst (t)) - 1; k > t; k = k - 1)
	 if (evalst(k) == SQUOTE | evalst(k) == DQUOTE) {
	    if (in_string == NO) {
		delim = evalst(k)
		in_string = YES
		}
	    else
		in_string = NO
	    call putbak (evalst(k))
	    }
	 # Don't expand $arg if in a string.
	 else if (evalst(k-1) != ARGFLAG | in_string == YES)
	    call putbak (evalst (k))
	 else {
	    argno = index (digits, evalst (k))	-  1
	    if (argno >= 0 & argno < j - i) {
	       n = i + argno + 1
	       m = argstk (n)
	       call pbstr (evalst (m))
	       }
	    k = k - 1	# skip over $
	    }
      if (k == t)	  # do last character
	 call putbak (evalst (k))
      }
   return
   end

C------------------------------------------------------------------------------
        subroutine ftgmsg(text)

C       get error message from top of stack and shift the stack up one message
        character*(*) text
        call ftxmsg(-1,text)
        end

#-h-  ratfor			 4496  local   12/01/80  15:53:43
# Ratfor preprocessor
   include  defs

   subroutine ratfor

#   DRIVER(ratfor)   Not used; RPP has a C main.

   include COMMON_BLOCKS

   integer i, n
   integer getarg, open

   character arg (FILENAMESIZE)

   STDEFNS 	# define standard definitions file

   call initkw	# initialize variables

   # Read file containing standard definitions
   # If this isn't desired, define (STDEFNS,"")

   if (defns (1) != EOS) {
      infile (1) = open (defns, READ)
      if (infile (1) == ERR)
	 call remark ("can't open standard definitions file.")
      else {
	 call finit
	 call parse
	 call close (infile (1))
      }
   }

   n = 1
   for (i=1;  getarg(i,arg,FILENAMESIZE) != EOF;  i=i+1) {
      n = n + 1
      call query ("usage:  ratfor [-g] [files] >outfile.")
      if (arg(1) == MINUS & arg(2) == LETG & arg(3) == EOS) {
	 dbgout = YES
	 next
      } else if (arg(1) == MINUS & arg(2) == EOS) {
	 infile(1) = STDIN
         call finit
      } else {
	 infile(1) = open (arg, READ)
	 if (infile(1) == ERR) {
	    call cant (arg)
	 } else {			#save file name for error messages
            call finit
	    call scopy (arg, 1, fnames, 1)
	    for (fnamp=1;  fnames(fnamp) != EOS;  fnamp=fnamp+1)
		if (fnames(fnamp) == PERIOD & fnames(fnamp+1) == LETR)
		    fnames(fnamp+1) = LETX
	 }
      }
      call parse
      if (infile (1) != STDIN)
	 call close (infile (1))
   }

   if (n == 1) {   # no files given on command line, use STDIN
      infile (1) = STDIN
      call finit
      call parse
   }

   call lndict

#   DRETURN
   end

include  defs

# THENCO -- Generate code for the "then" part of a compound IFERR statement.


subroutine thenco (tok, lab)

integer lab, tok
include COMMON_BLOCKS
string	siferr "if (.not.xerpop()) "
string	sifnoerr "if (xerpop()) "

	xfer = NO
	call outnum (lab+2)
	call outtab
	if (tok == LEXIFERR)
	    call outstr (siferr)
	else
	    call outstr (sifnoerr)
	call outgo (lab)
	esp = esp - 1				# pop error stack
	call indent (1)
	return
end

      SUBROUTINE slADET (RM, DM, EQ, RC, DC)
*+
*     - - - - - -
*      A D E T
*     - - - - - -
*
*  Add the E-terms (elliptic component of annual aberration)
*  to a pre IAU 1976 mean place to conform to the old
*  catalogue convention (double precision)
*
*  Given:
*     RM,DM     dp     RA,Dec (radians) without E-terms
*     EQ        dp     Besselian epoch of mean equator and equinox
*
*  Returned:
*     RC,DC     dp     RA,Dec (radians) with E-terms included
*
*  Note:
*
*     Most star positions from pre-1984 optical catalogues (or
*     derived from astrometry using such stars) embody the
*     E-terms.  If it is necessary to convert a formal mean
*     place (for example a pulsar timing position) to one
*     consistent with such a star catalogue, then the RA,Dec
*     should be adjusted using this routine.
*
*  Reference:
*     Explanatory Supplement to the Astronomical Ephemeris,
*     section 2D, page 48.
*
*  Called:  slETRM, slDS2C, slDC2S, slDA2P, slDA1P
*
*  P.T.Wallace   Starlink   18 March 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RM,DM,EQ,RC,DC

      DOUBLE PRECISION slDA2P

      DOUBLE PRECISION A(3),V(3)

      INTEGER I



*  E-terms vector
      CALL slETRM(EQ,A)

*  Spherical to Cartesian
      CALL slDS2C(RM,DM,V)

*  Include the E-terms
      DO I=1,3
         V(I)=V(I)+A(I)
      END DO

*  Cartesian to spherical
      CALL slDC2S(V,RC,DC)

*  Bring RA into conventional range
      RC=slDA2P(RC)

      END

c  main program for example in chapter xv.
c  from  * a practical guide to splines *  by c. de boor
c  solution of a second order nonlinear two point boundary value
c  problem  on (0., 1.) , by collocation with pp functions having  4
c  pieces of order  6 .  2  passes through newnot are to be made,
c  without any knots being added. newton iteration is to be stopped
c  when two iterates agree to  6  decimal places.
       call colloc(0.,1.,4,6,2,0.,1.e-6)
					stop
       end

      SUBROUTINE slSUGA (DSL, DSB, DL, DB)
*+
*     - - - - - - -
*      S U G A
*     - - - - - - -
*
*  Transformation from de Vaucouleurs supergalactic coordinates
*  to IAU 1958 galactic coordinates (double precision)
*
*  Given:
*     DSL,DSB     dp       supergalactic longitude and latitude
*
*  Returned:
*     DL,DB       dp       galactic longitude and latitude L2,B2
*
*  (all arguments are radians)
*
*  Called:
*     slDS2C, slDIMV, slDC2S, slDA2P, slDA1P
*
*  References:
*
*     de Vaucouleurs, de Vaucouleurs, & Corwin, Second Reference
*     Catalogue of Bright Galaxies, U. Texas, page 8.
*
*     Systems & Applied Sciences Corp., Documentation for the
*     machine-readable version of the above catalogue,
*     Contract NAS 5-26490.
*
*    (These two references give different values for the galactic
*     longitude of the supergalactic origin.  Both are wrong;  the
*     correct value is L2=137.37.)
*
*  P.T.Wallace   Starlink   March 1986
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DSL,DSB,DL,DB

      DOUBLE PRECISION slDA2P,slDA1P

      DOUBLE PRECISION V1(3),V2(3)

*
*  System of supergalactic coordinates:
*
*    SGL   SGB        L2     B2      (deg)
*     -    +90      47.37  +6.32
*     0     0         -      0
*
*  Galactic to supergalactic rotation matrix:
*
      DOUBLE PRECISION RMAT(3,3)
      DATA RMAT(1,1),RMAT(1,2),RMAT(1,3),
     :     RMAT(2,1),RMAT(2,2),RMAT(2,3),
     :     RMAT(3,1),RMAT(3,2),RMAT(3,3)/
     : -0.735742574804D0,+0.677261296414D0,+0.000000000000D0,
     : -0.074553778365D0,-0.080991471307D0,+0.993922590400D0,
     : +0.673145302109D0,+0.731271165817D0,+0.110081262225D0/



*  Spherical to Cartesian
      CALL slDS2C(DSL,DSB,V1)

*  Supergalactic to galactic
      CALL slDIMV(RMAT,V1,V2)

*  Cartesian to spherical
      CALL slDC2S(V2,DL,DB)

*  Express in conventional ranges
      DL=slDA2P(DL)
      DB=slDA1P(DB)

      END

C--------------------------------------------------------------------------
        subroutine ftaini(iunit,status)

C       initialize the parameters defining the structure of an ASCII table 

C       iunit   i  Fortran I/O unit number
C       OUTPUT PARAMETERS:
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer nrows,tfld,nkey,ibuff,i,nblank
        character keynam*8,value*70,comm*72,rec*80
        character cnum*3,cbcol*10,caxis1*10

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       store the type of HDU (1 = ASCII table extension)
        hdutyp(ibuff)=1

C       temporarily set the location of the end of the header to a huge number
        hdend(ibuff)=2000000000
        hdstrt(ibuff,chdu(ibuff)+1)=2000000000

C       check that this is a valid ASCII table, and get parameters
        call ftgttb(iunit,rowlen(ibuff),nrows,tfld,status)
        if (status .gt. 0)go to 900

        if (tfld .gt. nf)then
C               arrays not dimensioned large enough for this many fields
                status=111
        call ftpmsg('This ASCII table has too many fields '//
     & 'to be read with FITSIO (FTAINI).')
                go to 900
         end if

C       store the number of fields in the common block
        tfield(ibuff)=tfld

        if (nxtfld + tfld .gt. nf)then
C               too many columns open at one time; exceeded array dimensions
                status=111
                return
        end if

        tstart(ibuff)=nxtfld
        nxtfld=nxtfld+tfld

C       initialize the table field parameters
        do 5 i=1,tfld
                tscale(i+tstart(ibuff))=1.
                tzero(i+tstart(ibuff))=0.
C               choose special value to indicate that null value is not defined
                cnull(i+tstart(ibuff))=char(1)
C               pre-set required keyword values to a null value
                tbcol(i+tstart(ibuff))=-1
                tdtype(i+tstart(ibuff))=-9999
5       continue

C       initialize the fictitious heap starting address (immediately following
C       the table data) and a zero length heap.  This is used to find the
C       end of the table data when checking the fill values in the last block. 
C       there is no special data following an ASCII table
        scount(ibuff)=0
        theap(ibuff)=rowlen(ibuff)*nrows
        nxheap(ibuff)=0

C       now read through the rest of the header looking for table column
C       definition keywords, and the END keyword.

        nkey=8
8       nblank=0
10      nkey=nkey+1
        call ftgrec(iunit,nkey,rec,status)
        if (status .eq. 107)then
C               if we hit the end of file, then set status = no END card found
                status=210
        call ftpmsg('Required END keyword not found in ASCII table'//
     &  ' header (FTAINI).')
                go to 900
        else if (status .gt. 0)then
                go to 900
        end if
        keynam=rec(1:8)
        comm=rec(9:80)

        if (keynam(1:1) .eq. 'T')then
C               get the ASCII table parameter (if it is one)
                call ftpsvc(rec,value,comm,status)
                call ftgatp(ibuff,keynam,value,status)
        else if (keynam .eq. ' ' .and. comm .eq. ' ')then
                nblank=nblank+1
                go to 10
        else if (keynam .eq. 'END')then
                go to 20
        end if
        go to 8

20      continue

C       test that all the required keywords were found
        do 25 i=1,tfld
            if (tbcol(i+tstart(ibuff)) .eq. -1)then
                status=231
                call ftkeyn('TBCOL',i,keynam,status)
                call ftpmsg('Required '//keynam//
     &                      ' keyword not found (FTAINI).')
                return
            else if (tbcol(i+tstart(ibuff)) .lt. 0 .or.
     &               tbcol(i+tstart(ibuff)) .ge. rowlen(ibuff)
     &               .and. rowlen(ibuff) .ne. 0)then
                status=234
                call ftkeyn('TBCOL',i,keynam,status)
                call ftpmsg('Value of the '//keynam//
     &                      ' keyword is out of range (FTAINI).')
                return

C               check that column fits within the table
            else if (tbcol(i+tstart(ibuff))+tnull(i+tstart(ibuff)) .gt.
     &               rowlen(ibuff) .and. rowlen(ibuff) .ne. 0)then
                    status=236
                    write(cnum,1000)i
                    write(cbcol,1001)tbcol(i+tstart(ibuff))+1
                    write(caxis1,1001)rowlen(ibuff)
1000                format(i3)
1001                format(i10)
                    call ftpmsg('Column '//cnum//' will not fit '//
     &             'within the specified width of the ASCII table.')

                    call ftpmsg('TFORM='//cform(i+tstart(ibuff))//
     &              '  TBCOL='//cbcol//'  NAXIS1='//caxis1)
                    return
            else if (tdtype(i+tstart(ibuff)) .eq. -9999)then
                status=232
                call ftkeyn('TFORM',i,keynam,status)
                call ftpmsg('Required '//keynam//
     &                      ' keyword not found (FTAINI).')
                return
            end if
25      continue

C       now we know everything about the table; just fill in the parameters:
C       the 'END' record begins 80 bytes before the current position,
C       ignoring any trailing blank keywords just before the END keyword
        hdend(ibuff)=nxthdr(ibuff)-80*(nblank+1)

C       the data unit begins at the beginning of the next logical block
        dtstrt(ibuff)=((nxthdr(ibuff)-80)/2880+1)*2880

C       reset header pointer to the first keyword
        nxthdr(ibuff)=hdstrt(ibuff,chdu(ibuff))

C       the next HDU begins in the next logical block after the data
        hdstrt(ibuff,chdu(ibuff)+1)=
     &  dtstrt(ibuff)+(rowlen(ibuff)*nrows+2879)/2880*2880

900     continue
        end

include	defs

# putint - output integer in specified field

   subroutine putint (n, w, fd)
   integer n, w
   filedes fd

   character chars (MAXCHARS)

   integer junk
   integer itoc

   junk = itoc (n, chars, MAXCHARS)
   call putstr (chars, w, fd)

   return
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGGETP (TPID,FURA,LURA)
C
      CHARACTER*(*) TPID
      DIMENSION FURA(1)
C
C The routine AGGETP returns to the user the AUTOGRAPH parameter(s)
C specified by the parameter identifier TPID.  The arguments are as
C follows:
C
C -- TPID is the parameter identifier, a string of keywords separated
C    from each other by slashes and followed by a period.
C
C -- FURA is the user array which is to receive the desired parameter(s)
C    specified by TPID.
C
C -- LURA is the length of the user array FURA.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C Define the array DUMI, which allows access to the parameter list as
C an array.
C
      DIMENSION DUMI(1)
      EQUIVALENCE (QFRA,DUMI)
C
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C The routine AGSCAN is called to scan the parameter identifier and to
C return three quantities describing the AUTOGRAPH parameters desired.
C
      CALL AGSCAN (TPID,LOPA,NIPA,IIPA)
C
C Determine the number of elements to transfer.
C
      NURA=MAX0(1,MIN0(LURA,NIPA))
C
C Transfer the desired parameters to the user array.
C
      IDMI=LOPA-IIPA
C
      DO 101 IURA=1,NURA
        IDMI=IDMI+IIPA
        FURA(IURA)=DUMI(IDMI)
  101 CONTINUE
C
C If the current label name is being gotten, return its identifier.
C
      CALL AGSCAN ('LABE/NAME.',LOLN,NILN,IILN)
      IF (LOPA.EQ.LOLN.AND.NIPA.EQ.NILN.AND.QBAN.NE.0.) THEN
        LBAN=IFIX(QBAN)
        FURA(1)=FLLB(1,LBAN)
      END IF
C
C Done.
C
      RETURN
C
      END

c  main program for least-squares approximation by splines
c  from  * a practical guide to splines *  by c. de boor
calls setdat,l2knts,l2appr(bsplvb,bchfac,bchslv),bsplpp(bsplvb*)
c     ,l2err(ppvalu(interv)),ppvalu*,newnot
c
c  the program, though ostensibly written for l2-approximation, is typ-
c  ical for programs constructing a pp approximation to a function gi-
c  ven in some sense. the subprogram  l 2 a p p r , for instance, could
c  easily be replaced by one carrying out interpolation or some other
c  form of approximation.
c
c******  i n p u t  ******
c  is expected in  s e t d a t	(quo vide), specifying both the data to
c  be approximated and the order and breakpoint sequence of the pp ap-
c  proximating function to be used. further,  s e t d a t  is expected
c  to  t e r m i n a t e  the run (for lack of further input or because
c   i c o u n t  has reached a critical value).
c     the number  n t i m e s  is read in in the main program. it speci
c  fies the number of passes through the knot improvement algorithm in
c  n e w n o t	to be made. also,  a d d b r k	is read in to specify
c  that, on the average, addbrk knots are to be added per pass through
c  newnot. for example,  addbrk = .34  would cause a knot to be added
c  every third pass (as long as  ntimes .lt. 50).
c
c******  p r i n t e d	o u t p u t  ******
c  is governed by the three print control hollerith strings
c  p r b c o  = 2hon  gives printout of b-spline coeffs. of approxim.
c  p r p c o  = 2hon  gives printout of pp repr. of approximation.
c  p r f u n  = 2hon  gives printout of approximation and error at
c		      every data point.
c  the order  k , the number of pieces	l, and the interior breakpoints
c  are always printed out as are (in l2err) the mean, mean square, and
c  maximum errors in the approximation.
c
c     parameter lpkmax=100,ntmax=200,ltkmax=2000
      integer i,icount,ii,j,k,l,lbegin,lnew,ll,n,nt,ntimes,ntau
     *	     ,on,prbco,prfun,prpco
c     real addbrk,bcoef(lpkmax),break,coef,gtau,q(ltkmax),scrtch(ntmax)
c    *	  ,t(ntmax),tau,totalw,weight
c     common / data / ntau, tau(ntmax),gtau(ntmax),weight(ntmax),totalw
      real addbrk,bcoef(100),break,coef,gtau,q(2000),scrtch(200)
     *	  ,t(200),tau,totalw,weight
      common / data / ntau, tau(200),gtau(200),weight(200),totalw
c     common /data/ also occurs in setdat, l2appr and l2err. it is ment-
c     ioned here only because it might otherwise become undefined be-
c     tween calls to those subroutines.
c     common /approx/ break(lpkmax),coef(ltkmax),l,k
      common /approx/ break(100),coef(2000),l,k
c     common /approx/ also occurs in setdat and l2err.
      data on /2hon /
c
      icount = 0
c	 i c o u n t  provides communication with the data-input-and-
c     termination routine  s e t d a t . it is initialized to  0  to
c     signal to setdat when it is being called for the first time. after
c     that, it is up to setdat to use icount for keeping track of the
c     passes through setdat .
c
c     information about the function to be approximated and order and
c     breakpoint sequence of the approximating pp functions is gathered
c     by a
    1 call setdat(icount)
c
c     breakpoints are translated into knots, and the number  n	of
c     b-splines to be used is obtained by a
      call l2knts ( break, l, k, t, n )
c
c     the integer  n t i m e s	and the real  a d d b r k  are requested
c     as well as the print controls  p r b c o ,  p r p c o  and
c     p r f u n .  ntimes  passes  are made through the subroutine new-
c     not, with an increase of	addbrk	knots for every pass .
      print 600
  600 format(52h ntimes,addbrk , prbco,prpco,prfun =? (i3,f10.5/3a2))
      read 500,ntimes,addbrk,prbco,prpco,prfun
  500 format(i3,f10.5/3a2)
c
      lbegin = l
      nt = 1
c	 the b-spline coeffs.  b c o e f  of the l2-approx. are obtain-
c	 ed by a
   10	 call l2appr ( t, n, k, q, scrtch, bcoef )
	 if (prbco .eq. on)  print 609, (bcoef(i),i=1,n)
  609	 format(//22h b-spline coefficients/(5e16.9))
c
c	 convert the b-repr. of the approximation to pp repr.
	 call bsplpp ( t, bcoef, n, k, q, break, coef, l )
	 print 610, k, l, (break(ll),ll=2,l)
  610	 format(//34h approximation by splines of order,i3,4h on ,
     *	       i3,25h intervals. breakpoints -/(5e16.9))
	 if (prpco .ne. on)		go to 15
	 print 611
  611	 format(/36h pp-representation for approximation)
	 do 12 i=1,l
	    ii = (i-1)*k
   12	    print 613,break(i),(coef(ii+j),j=1,k)
  613	 format(f9.3,5e16.9/(11x,5e16.9))
c
c	 compute and print out various error norms by a
   15	 call l2err ( prfun, scrtch, q )
c
c	 if newnot has been applied less than  n t i m e s  times, try
c	 it again to obtain, from the current approx. a possibly improv-
c	 ed sequence of breakpoints with  addbrk  more breakpoints (on
c	 the average) than the current approximation has.
c	    if only an increase in breakpoints is wanted, without the
c	 adjustment that newnot provides, a fake newnot routine could be
c	 used here which merely returns the breakpoints for  l n e w
c	 equal intervals .
	 if (nt .ge. ntimes)		go to 1
	 lnew = lbegin + float(nt)*addbrk
	 call newnot (break, coef, l, k, scrtch, lnew, t )
	 call l2knts ( scrtch, lnew, k, t, n )
	 nt = nt + 1
					go to 10
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGBACK
C
C The subroutine AGBACK is used to draw a graph background, as directed
C by the current contents of the parameter list.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C Declare the block data routine external to force it to load.
C
C +NOAO - Block data replaced with run time initialization subroutine.
C
C     EXTERNAL AGDFLT
      call agdflt
C     
C -NOAO
C
C Do an appropriate SET call for the following routines.  The call is
C equivalent to "CALL SET (XLCW,XRCW,YBCW,YTCW,0.,1.,0.,1.,1)", but
C makes the viewport cover the whole plotter frame, which avoids the
C problems resulting from clipping by GKS.
C
      CALL SET (0.,1.,0.,1.,-XLCW/(XRCW-XLCW),(1.-XLCW)/(XRCW-XLCW),
     +                      -YBCW/(YTCW-YBCW),(1.-YBCW)/(YTCW-YBCW),1)
C
C Draw the labels, if any, first.
C
      IDLB=IFIX(QDLB)
      IF (IDLB.EQ.0) GO TO 101
C
      LBIM=IFIX(QBIM)
      CALL AGLBLS (IDLB,WCWP,HCWP,FLLB,LBIM,FLLN,DBOX,SBOX,RBOX)
C
C Now draw each of the four axes.
C
  101 I=0
C
  102 I=I+1
C
      IF (I.EQ.5) GO TO 108
C
      IF (QDAX(I).EQ.0.) GO TO 102
C
      GO TO (103,104,105,106) , I
C
C Y axis - left.
C
  103 WNLB(1)=0.-YBGW
      IF (XBGA(1)-WNLL(1).LT.DBOX(3,2).AND.
     +                XBGA(1)+WNLR(1).GT.DBOX(3,1)) WNLB(1)=0.-DBOX(3,4)
C
      WNLE(1)=YTGW-1.
      IF (XBGA(1)-WNLL(1).LT.DBOX(4,2).AND.
     +                XBGA(1)+WNLR(1).GT.DBOX(4,1)) WNLE(1)=DBOX(4,3)-1.
C
      GO TO 107
C
C Y axis - right.
C
  104 WNLB(2)=YTGW-1.
      IF (XBGA(2)-WNLR(2).LT.DBOX(4,2).AND.
     +                XBGA(2)+WNLL(2).GT.DBOX(4,1)) WNLB(2)=DBOX(4,3)-1.
C
      WNLE(2)=0.-YBGW
      IF (XBGA(2)-WNLR(2).LT.DBOX(3,2).AND.
     +                XBGA(2)+WNLL(2).GT.DBOX(3,1)) WNLE(2)=0.-DBOX(3,4)
C
      GO TO 107
C
C X axis - bottom.
C
  105 WNLB(3)=XRGW-1.
      IF (YBGA(3)-WNLL(3).LT.DBOX(2,4).AND.
     +                YBGA(3)+WNLR(3).GT.DBOX(2,3)) WNLB(3)=DBOX(2,1)-1.
C
      WNLE(3)=0.-XLGW
      IF (YBGA(3)-WNLL(3).LT.DBOX(1,4).AND.
     +                YBGA(3)+WNLR(3).GT.DBOX(1,3)) WNLE(3)=0.-DBOX(1,2)
C
      GO TO 107
C
C X axis - top.
C
  106 WNLB(4)=0.-XLGW
      IF (YBGA(4)-WNLR(4).LT.DBOX(1,4).AND.
     +                YBGA(4)+WNLL(4).GT.DBOX(1,3)) WNLB(4)=0.-DBOX(1,2)
C
      WNLE(4)=XRGW-1.
      IF (YBGA(4)-WNLR(4).LT.DBOX(2,4).AND.
     +                YBGA(4)+WNLL(4).GT.DBOX(2,3)) WNLE(4)=DBOX(2,1)-1.
C
  107 Q=AMIN1(0.,QDAX(I))
C
      CALL AGAXIS (I,Q,
     +             QSPA(I),WCWP,HCWP,XBGA(I),YBGA(I),XNDA(I),YNDA(I),
     +             QLUA(I),UBGA(I),UNDA(I),FUNS(I),QBTP(I),BASE(I),
     +             QJDP(I),WMJL(I),WMJR(I),QMNT(I),QNDP(I),WMNL(I),
     +             WMNR(I),QLTP(I),QLEX(I),QLFL(I),QLOF(I),QLOS(I),
     +             DNLA(I),WCLM(I),WCLE(I),RFNL(I),QCIM(I),QCIE(I),
     +             WNLL(I),WNLR(I),WNLB(I),WNLE(I))
C
      GO TO 102
C
C Do set call for user and return.
C
  108 CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,
     +                            1+IABS(IFIX(QLUX))*2+IABS(IFIX(QLUY)))
C
      RETURN
C
      END

C----------------------------------------------------------------------
        subroutine fttbit(bitpix,status)

C       test that bitpix has a legal value

        integer bitpix,status
        character value*20

        if (status .gt. 0)return

        if (bitpix .ne. 8 .and. bitpix .ne. 16 .and. bitpix .ne. 32
     &      .and. bitpix .ne. -32 .and. bitpix .ne. -64)then
                status=211
                write(value,1000)bitpix
1000            format(i20)
                call ftpmsg('Illegal BITPIX value: '//value)
        end if
        end

include	defs

# esc - map array (i) into escaped character if appropriate

   character function esc (array, i)
   character array (ARB)
   integer i

   if (array (i) != ESCAPE)
      esc = array (i)
   else if (array (i+1) == EOS)    # @ not special at end
      esc = ESCAPE
   else {
      i = i + 1
      if (array (i) == LETN | array (i) == BIGN)
	 esc = NEWLINE
      else if (array (i) == LETT | array (i) == BIGT)
	 esc = TAB
      else
	 esc = array (i)
      }

   return
   end

include  defs

# outch - put one character into output buffer

subroutine outch (c)

character c, splbuf(SZ_SPOOLBUF+1)
integer i, ip, op, index
include COMMON_BLOCKS
external index
string	break_chars " ),.+-*/("

	# Process a continuation card.  Try to break the card at a whitespace
	# division, operator, or punctuation mark.

	if (outp >= 72) {
	    if (index (break_chars, c) > 0)		# find break point
		ip = outp
	    else {
		for (ip=outp;  ip >= 1;  ip=ip-1) {
		    if (index (break_chars, outbuf(ip)) > 0)
			break
		}
	    }

	    if (ip != outp & (outp-ip) < SZ_SPOOLBUF) {
		op = 1
		for (i=ip+1;  i <= outp;  i=i+1) {	# save chars
		    splbuf(op) = outbuf(i)
		    op = op + 1
		}
		splbuf(op) = EOS
		outp = ip
	    } else
		splbuf(1) = EOS

	    call outdon
	    
	    for (op=1;  op < col;  op=op+1)
		outbuf(op) = BLANK
	    outbuf(6) = STAR
	    outp = col
	    for (ip=1;  splbuf(ip) != EOS;  ip=ip+1) {
		outp = outp + 1
		outbuf(outp) = splbuf(ip)
	    }
	}

	outp = outp + 1				# output character
	outbuf(outp) = c
end

chapter x. example 2. plotting the pol,s which make up a b-spline
c  from  * a practical guide to splines *  by c. de boor
calls  bsplvb
c
      integer ia,left
      real biatx(4),t(11),values(4),x
c		  knot sequence set here....
      data t / 4*0.,1.,3.,4.,4*6. /
      do 20 ia=1,40
	 x = float(ia)*.2 - 1.
	 do 10 left=4,7
	    call bsplvb ( t, 4, 1, x, left, biatx )
c
c	    according to  bsplvb  listing,  biatx(.) now contains value
c	    at	x  of polynomial which agrees on the interval  (t(left),
c	    t(left+1) )  with the b-spline  b(left-4 + . ,4,t) . hence,
c	    biatx(8-left)  now contains value of that polynomial for
c	    b(left-4 +(8-left) ,4,t) = b(4,4,t) . since this b-spline
c	    has support  (t(4),t(8)), it makes sense to run  left = 4,
c	    ...,7, storing the resulting values in  values(1),...,
c	    values(4)  for later printing.
c
   10	    values(left-3) = biatx(8-left)
   20	 print 620, x, values
  620 format(f10.1,4f20.8)
					stop
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGKURV (XVEC,IIEX,YVEC,IIEY,NEXY,SVAL)
C
      DIMENSION XVEC(1),YVEC(1)
C
C AGKURV plots the curve defined by the points ((X(I),Y(I)),I=1,NEXY),
C where
C
C    X(I)=XVEC(1+(I-1)*IIEX) (unless IIEX=0, in which case X(I)=I), and
C    Y(I)=YVEC(1+(I-1)*IIEY) (unless IIEY=0, in which case Y(I)=I).
C
C If, for some I, X(I)=SVAL or Y(I)=SVAL, curve line segments having
C (X(I),Y(I)) as an endpoint are omitted.
C
C No windowing is performed.
C
C Check first whether the number of curve points is properly specified.
C
      IF (NEXY.LE.0) GO TO 901
C
C Initialization.  Pretend that the last point was point number zero.
C Set the indices for the x and y vectors accordingly.  Clear the line-
C drawn-to-last-point flag.
C
      INDP=0
      INDX=1-IIEX
      INDY=1-IIEY
      LDLP=0
C
C Initialization.  Retrieve the current curve window, user window, and
C x/y linear/logarithmic flags.
C
      CALL GETSET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,LTYP)
C
C Initialization.  Set linear/log flag and linear-window limits for
C x-axis values.
C
      IF (LTYP.EQ.1.OR.LTYP.EQ.2) THEN
        LLUX=0
        XLLW=XLUW
        XRLW=XRUW
      ELSE
        LLUX=1
        XLLW=ALOG10(XLUW)
        XRLW=ALOG10(XRUW)
      END IF
C
C Initialization.  Set linear/log flag and linear-window limits for
C y-axis values.
C
      IF (LTYP.EQ.1.OR.LTYP.EQ.3) THEN
        LLUY=0
        YBLW=YBUW
        YTLW=YTUW
      ELSE
        LLUY=1
        YBLW=ALOG10(YBUW)
        YTLW=ALOG10(YTUW)
      END IF
C
C Initialization.  Call SET, if necessary, to define a linear mapping.
C
      IF (LTYP.NE.1)
     +              CALL SET (XLCW,XRCW,YBCW,YTCW,XLLW,XRLW,YBLW,YTLW,1)
C
C Beginning of loop through points.  Update indices and determine the
C user-space coordinates of the next point.
C
  101 IF (INDP.EQ.NEXY) GO TO 102
      INDP=INDP+1
C
      INDX=INDX+IIEX
      XNXT=XVEC(INDX)
      IF (IIEX.EQ.0) XNXT=FLOAT(INDP)
      IF (LLUX.NE.0.AND.XNXT.LE.0.) XNXT=SVAL
C
      INDY=INDY+IIEY
      YNXT=YVEC(INDY)
      IF (IIEY.EQ.0) YNXT=FLOAT(INDP)
      IF (LLUY.NE.0.AND.YNXT.LE.0.) YNXT=SVAL
C
C Check whether (XNXT,YNXT) is a special-value point.  Handle that case.
C
      IF (XNXT.EQ.SVAL.OR.YNXT.EQ.SVAL) THEN
        IF (LDLP.EQ.0) GO TO 101
        IF (LDLP.EQ.1) CALL VECTD (XLST,YLST)
        CALL LASTD
        LDLP=0
        GO TO 101
      END IF
C
C If user space is not linear/linear, modify XNXT and YNXT accordingly.
C
      IF (LLUX.NE.0) XNXT=ALOG10(XNXT)
      IF (LLUY.NE.0) YNXT=ALOG10(YNXT)
C
C Start or continue line.
C
      IF (LDLP.EQ.0) THEN
        CALL FRSTD (XNXT,YNXT)
        XLST=XNXT
        YLST=YNXT
      ELSE
        CALL VECTD (XNXT,YNXT)
      END IF
C
      LDLP=LDLP+1
      GO TO 101
C
C Last point was final point.  Finish up.
C
  102 IF (LDLP.NE.0) THEN
        IF (LDLP.EQ.1) CALL VECTD (XLST,YLST)
        CALL LASTD
      END IF
C
C Restore logarithmic mapping, if appropriate.
C
      IF (LTYP.NE.1)
     +           CALL SET (XLCW,XRCW,YBCW,YTCW,XLUW,XRUW,YBUW,YTUW,LTYP)
C
C Return to caller.
C
      RETURN
C
C Error exit.
C
  901 CALL SETER ('AGKURV - NUMBER OF POINTS IS LESS THAN OR EQUAL TO ZE
     +RO',3,2)
C
      END

      subroutine setdt2(icount)
c  from  * a practical guide to splines *  by c. de boor
c  to be called in main program  l 2 m a i n .
c     this routine is set up to provide the specific data for example 3
c     in chapter xiv.
c
      integer icount,  i,k,l,ntau
      real break,coef,gtau,step,tau,totalw,weight,x,round
c     parameter lpkmax=100,ntmax=200,ltkmax=2000
c     common / data / ntau, tau(ntmax),gtau(ntmax),weight(ntmax),totalw
c     common /approx/ break(lpkmax),coef(ltkmax),l,k
      common / data / ntau, tau(200),gtau(200),weight(200),totalw
      common /approx/ break(100),coef(2000),l,k
      round(x) = float(ifix(x*100.))/100.
      if (icount .gt. 0)		stop
      icount = icount + 1
      ntau = 65
      step = 3./float(ntau-1)
      do 10 i=1,ntau
	 tau(i) = i*step
	 gtau(i) = round(exp(tau(i)))
   10	 weight(i) = 1.
      totalw = ntau
      l = 1
      break(1) = tau(1)
      break(2) = tau(ntau)
      k = 3
					return
      end

C----------------------------------------------------------------------
        subroutine ftc2r(cval,rval,status)
C       convert a character string to a real value
C       perform datatype conversion, if required

        character*(*) cval
        real rval
        integer ival,status
        character*1 dtype
        logical lval
        character*16 sval
        double precision dval


C       convert string to its intrinsic data type
        call ftc2x(cval,dtype,ival,lval,sval,dval,status)
        if (status .gt. 0)return

        if (dtype .eq. 'F')then
C               convert from double to single precision
                rval=dval
        else if (dtype .eq. 'I')then
C               convert from integer to real
                rval=ival
        else if (dtype .eq. 'L')then
C               need to convert from logical to real
                if (lval)then
                        rval=1.
                else
                        rval=0.
                end if
        else if (dtype .eq. 'C')then
C               can't convert a string to a real, so return error
                rval=0
                status=405
                sval=cval
                call ftpmsg('Error in FTC2R evaluating this string '//
     &          'as a real value: '//sval)
        end if
        end

c     subroutine svdrs (a,mda,mm,nn,b,mdb,nb,s,ier)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1974 mar 1
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   singular value decomposition also treating right side vector.
c
c     the array s occupies 3*n cells.
c     a occupies m*n cells
c     b occupies m*nb cells.
c
c     special singular value decomposition subroutine.
c     we have the m x n matrix a and the system a*x=b to solve.
c     either m .ge. n  or  m .lt. n is permitted.
c			the singular value decomposition
c     a = u*s*v**(t) is made in such a way that one gets
c	 (1) the matrix v in the first n rows and columns of a.
c	 (2) the diagonal matrix of ordered singular values in
c	     the first n cells of the array s(ip), ip .ge. 3*n.
c	 (3) the matrix product u**(t)*b=g gets placed back in b.
c	 (4) the user must complete the solution and do his own
c	     singular value analysis.
c     *******
c     give special
c     treatment to rows and columns which are entirely zero.  this
c     causes certain zero sing. vals. to appear as exact zeros rather
c     than as about eta times the largest sing. val.   it similarly
c     cleans up the associated columns of u and v.
c     method..
c      1. exchange cols of a to pack nonzero cols to the left.
c	  set n = no. of nonzero cols.
c	  use locations a(1,nn),a(1,nn-1),...,a(1,n+1) to record the
c	  col permutations.
c      2. exchange rows of a to pack nonzero rows to the top.
c	  quit packing if find n nonzero rows.	make same row exchanges
c	  in b.  set m so that all nonzero rows of the permuted a
c	  are in first m rows.	if m .le. n then all m rows are
c	  nonzero.  if m .gt. n then	  the first n rows are known
c	  to be nonzero,and rows n+1 thru m may be zero or nonzero.
c      3. apply original algorithm to the m by n problem.
c      4. move permutation record from a(,) to s(i),i=n+1,...,nn.
c      5. build v up from  n by n  to  nn by nn  by placing ones on
c	  the diagonal and zeros elsewhere.  this is only partly done
c	  explicitly.  it is completed during step 6.
c      6. exchange rows of v to compensate for col exchanges of step 2.
c      7. place zeros in  s(i),i=n+1,nn  to represent zero sing vals.
c
      subroutine svdrs (a,mda,mm,nn,b,mdb,nb,s,ier)
      dimension a(mda,nn),b(mdb,nb),s(nn,3)
      zero=0.
      ier = 0
      one=1.
c
c			      begin.. special for zero rows and cols.
c
c			      pack the nonzero cols to the left
c
      n=nn
      if (n.le.0.or.mm.le.0) return
      j=n
   10 continue
	  do 20 i=1,mm
	  if (a(i,j)) 50,20,50
   20	  continue
c
c	  col j  is zero. exchange it with col n.
c
      if (j.eq.n) go to 40
	  do 30 i=1,mm
   30	  a(i,j)=a(i,n)
   40 continue
      a(1,n)=j
      n=n-1
   50 continue
      j=j-1
      if (j.ge.1) go to 10
c			      if n=0 then a is entirely zero and svd
c			      computation can be skipped
      ns=0
      if (n.eq.0) go to 240
c			      pack nonzero rows to the top
c			      quit packing if find n nonzero rows
      i=1
      m=mm
   60 if (i.gt.n.or.i.ge.m) go to 150
      if (a(i,i)) 90,70,90
   70	  do 80 j=1,n
	  if (a(i,j)) 90,80,90
   80	  continue
      go to 100
   90 i=i+1
      go to 60
c			      row i is zero
c			      exchange rows i and m
  100 if(nb.le.0) go to 115
	  do 110 j=1,nb
	  t=b(i,j)
	  b(i,j)=b(m,j)
  110	  b(m,j)=t
  115	  do 120 j=1,n
  120	  a(i,j)=a(m,j)
      if (m.gt.n) go to 140
	  do 130 j=1,n
  130	  a(m,j)=zero
  140 continue
c			      exchange is finished
      m=m-1
      go to 60
c
  150 continue
c			      end.. special for zero rows and columns
c			      begin.. svd algorithm
c     method..
c     (1)     reduce the matrix to upper bidiagonal form with
c     householder transformations.
c	   h(n)...h(1)aq(1)...q(n-2) = (d**t,0)**t
c     where d is upper bidiagonal.
c
c     (2)     apply h(n)...h(1) to b.  here h(n)...h(1)*b replaces b
c     in storage.
c
c     (3)     the matrix product w= q(1)...q(n-2) overwrites the first
c     n rows of a in storage.
c
c     (4)     an svd for d is computed.  here k rotations ri and pi are
c     computed so that
c	   rk...r1*d*p1**(t)...pk**(t) = diag(s1,...,sm)
c     to working accuracy.  the si are nonnegative and nonincreasing.
c     here rk...r1*b overwrites b in storage while
c     a*p1**(t)...pk**(t)  overwrites a in storage.
c
c     (5)     it follows that,with the proper definitions,
c     u**(t)*b overwrites b, while v overwrites the first n row and
c     columns of a.
c
      l=min0(m,n)
c	      the following loop reduces a to upper bidiagonal and
c	      also applies the premultiplying transformations to b.
c
	  do 170 j=1,l
	  if (j.ge.m) go to 160
	  call h12 (1,j,j+1,m,a(1,j),1,t,a(1,j+1),1,mda,n-j)
	  call h12 (2,j,j+1,m,a(1,j),1,t,b,1,mdb,nb)
  160	  if (j.ge.n-1) go to 170
	  call h12 (1,j+1,j+2,n,a(j,1),mda,s(j,3),a(j+1,1),mda,1,m-j)
  170	  continue
c
c     copy the bidiagonal matrix into the array s() for qrbd.
c
      if (n.eq.1) go to 190
	  do 180 j=2,n
	  s(j,1)=a(j,j)
  180	  s(j,2)=a(j-1,j)
  190 s(1,1)=a(1,1)
c
      ns=n
      if (m.ge.n) go to 200
      ns=m+1
      s(ns,1)=zero
      s(ns,2)=a(m,m+1)
  200 continue
c
c     construct the explicit n by n product matrix, w=q1*q2*...*ql*i
c     in the array a().
c
	  do 230 k=1,n
	  i=n+1-k
	  if(i.gt.min0(m,n-2)) go to 210
	  call h12 (2,i+1,i+2,n,a(i,1),mda,s(i,3),a(1,i+1),1,mda,n-i)
  210	      do 220 j=1,n
  220	      a(i,j)=zero
  230	  a(i,i)=one
c
c	   compute the svd of the bidiagonal matrix
c
      call qrbd (ipass,s(1,1),s(1,2),ns,a,mda,n,b,mdb,nb)
c
      go to (240,310), ipass
  240 continue
      if (ns.ge.n) go to 260
      nsp1=ns+1
	  do 250 j=nsp1,n
  250	  s(j,1)=zero
  260 continue
      if (n.eq.nn) return
      np1=n+1
c				   move record of permutations
c				   and store zeros
	  do 280 j=np1,nn
	  s(j,1)=a(1,j)
	      do 270 i=1,n
  270	      a(i,j)=zero
  280	  continue
c			      permute rows and set zero singular values.
	  do 300 k=np1,nn
	  i=s(k,1)
	  s(k,1)=zero
	      do 290 j=1,nn
	      a(k,j)=a(i,j)
  290	      a(i,j)=zero
	  a(i,k)=one
  300	  continue
c			      end.. special for zero rows and columns
      return
c     convergence failure in qr bidiagonal svd routine
  310 ier = 1
      end

      SUBROUTINE slAV2M (AXVEC, RMAT)
*+
*     - - - - -
*      A V 2 M
*     - - - - -
*
*  Form the rotation matrix corresponding to a given axial vector.
*
*  (single precision)
*
*  A rotation matrix describes a rotation about some arbitrary axis,
*  called the Euler axis.  The "axial vector" supplied to this routine
*  has the same direction as the Euler axis, and its magnitude is the
*  amount of rotation in radians.
*
*  Given:
*    AXVEC  r(3)     axial vector (radians)
*
*  Returned:
*    RMAT   r(3,3)   rotation matrix
*
*  If AXVEC is null, the unit matrix is returned.
*
*  The reference frame rotates clockwise as seen looking along
*  the axial vector from the origin.
*
*  Last revision:   26 November 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL AXVEC(3),RMAT(3,3)

      REAL X,Y,Z,PHI,S,C,W



*  Rotation angle - magnitude of axial vector - and functions
      X = AXVEC(1)
      Y = AXVEC(2)
      Z = AXVEC(3)
      PHI = SQRT(X*X+Y*Y+Z*Z)
      S = SIN(PHI)
      C = COS(PHI)
      W = 1.0-C

*  Euler axis - direction of axial vector (perhaps null)
      IF (PHI.NE.0.0) THEN
         X = X/PHI
         Y = Y/PHI
         Z = Z/PHI
      END IF

*  Compute the rotation matrix
      RMAT(1,1) = X*X*W+C
      RMAT(1,2) = X*Y*W+Z*S
      RMAT(1,3) = X*Z*W-Y*S
      RMAT(2,1) = X*Y*W-Z*S
      RMAT(2,2) = Y*Y*W+C
      RMAT(2,3) = Y*Z*W+X*S
      RMAT(3,1) = X*Z*W+Y*S
      RMAT(3,2) = Y*Z*W-X*S
      RMAT(3,3) = Z*Z*W+C

      END

c function factor.f
c
c source
c   Bevington, page 32.
c
c purpose
c   calculates factorial function for integers
c
c usage
c   result = factor (n)
c
c description of parameters
c   n      - integer argument
c
c subroutines and function subprograms required
c   none
c
	function factor (n)
	double precision fi,sum
11	factor=1.
	if (n-1) 40,40,13
13	if (n-10) 21,21,31
c
c n less than 11
c
21	do 23 i=2,n
	fi=i
23	factor=factor*fi
	goto 40
c
c n greater than 10
c
31	sum=0.
	do 34 i=11,n
	fi=i
34	sum=sum+dlog(fi)
35	factor=3628800.*dexp(sum)
40	return
	end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGNUMB (NBTP,SBSE,EXMU , NLTP,NLEX,NLFL ,
     +                             BFRM,MCIM,NCIM,IPXM , BFRE,MCIE,NCIE)
C
      CHARACTER*(*) BFRM,BFRE
C
C The routine AGNUMB converts the number specified by the arguments
C NBTP, SBSE, and EXMU to the label format specified by the arguments
C NLTP, NLEX, and NLFL, returning the characters of the mantissa in the
C buffer BFRM and the characters of the exponent in the buffer BFRE,
C ready for plotting.  The arguments of AGNUMB are as follows:
C
C -- NBTP is an integer specifying the type of number to be converted.
C    There are three possibilities:
C
C        NBTP = 1 - number of the form SBSE * EXMU.
C
C        NBTP = 2 - number of the form SBSE * 10**EXMU.
C
C        NBTP = 3 - number of the form SIGN(SBSE) * ABSV(SBSE)**EXMU.
C
C -- SBSE is a base value for a set of labels.  See NBTP description.
C
C -- EXMU is an exponent or a multiplier for a given label.  Although it
C    is a floating-point number, its value should be integral, unless
C    NBTP equals 1 and/or NLTP equals 1.  Using a non-integral EXMU in
C    other cases will have undesirable effects.  See NBTP description.
C
C -- NLTP is an integer specifying the type of label to be generated.
C    There are three possibilities:
C
C      -- NLTP = 1 - label is to have an exponent portion and is to be
C         expressed in scientific notation.
C
C      -- NLTP = 2 - label is to have an exponent portion and is to be
C         expressed in a form determined by the number type NBTP.
C
C      -- NLTP = 3 - label is to have no exponent portion and is to be
C         expressed in a form determined by the number type NBTP.
C
C    The possible label types will be described in greater detail below.
C
C -- NLEX (when used) is an integer specifying (in a manner depending on
C    the values of other parameters) the value of the exponent portion
C    of the label.  See the detailed discussion of label types, below.
C
C -- NLFL (when used) is an integer specifying (in a manner depending on
C    the values of other parameters) the length of the fractional por-
C    tion of the mantissa of the label.  See the detailed discussion of
C    label types, below.
C
C -- BFRM is a character variable in which the mantissa portion of the
C    label is to be returned.
C
C -- MCIM specifies the maximum number of characters BFRM can hold.
C
C -- NCIM is the number of characters returned in BFRM by AGNUMB.
C
C -- IPXM is the position of the character X in the mantissa.  If IPXM
C    is zero, the character X does not occur in the mantissa.
C
C -- BFRE, MCIE, and NCIE are analogous to BFRM, MCIM, and NCIM, but
C    pertain to the exponent portion of the label.
C
C Label types:  AGNUMB will produce many different types of labels, as
C directed by the various input parameters.  Each of these is described
C below.  The general form of a label is
C
C    (-) (1/) (I) (.) (F) (X 10) (E)
C
C where the parentheses are used to mark portions which may either be
C present or absent.  The minus sign is included only if the label value
C is negative.  I is the integer portion of the mantissa, included only
C if its value is non-zero.  The decimal point is included if the input
C parameter NLFL does not specifically direct that it should be omitted
C or if the fractional portion of the mantissa (F) is present.  F is the
C fractional portion of the mantissa.  The "X 10" is included if it is
C appropriate, and is considered to be a part of the mantissa; if it is
C included, a blank is actually returned for the character X, so the
C routine which plots the label should construct this character by
C drawing two short lines.  E is the exponent, returned in a separate
C buffer so that it may be plotted in a superscript form.  The possible
C label types are, then, as follows:
C
C -- Scientific notation - if the label type NLTP equals 1, the form
C
C        (-) (I) (.) (F) X 10 (E)
C
C    is used.  NLEX specifies the length of I (thus also specifying the
C    value of the exponent E).  If NLEX is .LE. 0, I is omitted.  If
C    NLEX is .LT. 0 and has the absolute value N, the fraction F is
C    forced to have N leading zeroes.  NLFL specifies the length of F.
C    If NLFL is .LE. 0, F is omitted.  If NLFL is .LT. 0, the decimal
C    point is omitted.  If (I.F) has the value 1, (I.F X) is omitted.
C    If the entire label has zero value, the character 0 is used.
C
C -- Exponential, but non-scientific notation - if the label type NLTP
C    equals 2, the form used depends on the argument NBTP, as follows:
C
C     -- If NBTP equals 1 (number of the form SBSE * EXMU), the form
C
C            (-) (I) (.) (F) X 10 (E)
C
C        is used.  NLEX specifies the value of the exponent E.  The
C        length of F is specified by NLFL.  If NLFL is .LE. 0, F is
C        omitted.  If NLFL is .LT. 0, the decimal point is omitted.  If
C        the label value is exactly 0, the character 0 is used.
C
C     -- If NBTP equals 2 (number of the form SBSE*10**EXMU), the form
C
C            (-) (I) (.) (F) X 10 (E)
C
C        is used.  The exponent E has the value NLEX+EXMU.  The length
C        of F is specified by NLFL.  If NLFL is .LE. 0, F is omitted.
C        If NLFL is .LT. 0, the decimal point is omitted.  If the label
C        value is exactly 0, the character 0 is used.  If (I.F) has the
C        value 1., then (I.F X) is omitted.
C
C     -- If NBTP equals 3, specifying that the number is of the form
C        SIGN(SBSE) * ABSV(SBSE)**EXMU, the form
C
C            (-) (I) (.) (F) (E)
C
C        is used.  The exponent E has the value EXMU.  The length of F
C        is specified by NLFL.  If NLFL is .LE. 0, F is omitted.  If
C        NLFL is .LT. 0, the decimal point is omitted.
C
C -- No-exponent notation - if the label type NLTP equals 3, the form
C    used depends on the argument NBTP, as follows:
C
C     -- If NBTP equals 1 (number of the form SBSE * EXMU), the form
C
C            (-) (I) (.) (F)
C
C        is used.  NLFL specifies the length of F.  If NLFL is .LE. 0,
C        F is omitted.  If NLFL is .LT. 0, the decimal point is omitted.
C        If the entire label has zero value, the character 0 is used.
C
C     -- If NBTP equals 2 (number of the form SBSE*10**EXMU), the form
C
C            (-) (I) (.) (F)
C
C        is used.  The length of F is specified by the function
C
C            MAX(NLFL,0)-EXMU  (if EXMU is .LT. MAX(NLFL,0))
C            MIN(NLFL,0)       (if EXMU is .GE. MAX(NLFL,0))
C
C        which may appear somewhat formidable, but produces a simple,
C        desirable result.  Suppose, for example, that SBSE = 3.6,
C        NLFL = 1, and EXMU ranges from -3 to +3 - the labels produced
C        are as follows:
C
C            .0036   .036   .36   3.6   36.   360.   3600.
C
C        NLFL may be viewed as specifying the length of F if EXMU is 0.
C        If the value of the function is .LE. 0, F is omitted - if its
C        value is .LT. 0, the decimal point is omitted.
C
C     -- If NBTP equals 3, specifying that the number is of the form
C        SIGN(SBSE) * ABSV(SBSE)**EXMU, the form
C
C            (-) (I) (.) (F)
C
C        is used if EXMU is positive (or zero), and the form
C
C            (-) 1 / (I) (.) (F)
C
C        is used if EXMU is negative.  The length of F is specified by
C        the function
C
C            NLFL * ABSV(EXMU)  (if EXMU is .NE. 0)
C            MIN(NLFL,0)        (if EXMU is .EQ. 0)
C
C        Again, this function produces a simple result.  Suppose that
C        SBSE = 1.1, NLFL = 1, and EXMU ranges from -3 to +3 - the
C        labels produced are as follows:
C
C            1/1.331   1/1.21   1/1.1   1.   1.1   1.21   1.331
C
C        NLFL may be viewed as specifying the length of F if EXMU is 1.
C        If the value of the function is .LE. 0, F is omitted - if its
C        value is .LT. 0, the decimal point is omitted.  As another
C        example, suppose that SBSE = 2., NLFL = -1, and EXMU ranges
C        from -4 to +4.  The labels produced are as follows:
C
C            1/16   1/8   1/4   1/2   1   2   4   8   16
C
C The following common block contains AUTOGRAPH variables which are
C not control parameters.  The only one used here is SMRL, which is a
C (machine-dependent) small real which, when added to a number in the
C range (1,10), will round it upward without seriously affecting the
C leading significant digits.  The object of this is to get rid of
C strings of nines.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C KHAR holds single characters to be stored away in BFRM or BFRE.
C
      CHARACTER*1 KHAR
C
C Zero character counters and pointers.
C
      NCIM=0
      NCIE=0
      IPXM=0
C
C Compute a jump parameter to allow a quick sorting-out of the possible
C number-type/label-type combinations below.
C
      NTLT=NBTP+3*(NLTP-1)
C
C Compute the value (XMAN) from which the characters of the mantissa
C will be generated.
C
      GO TO (101,102,103,101,102,104,101,102,105) , NTLT
C
  101 XMAN=SBSE*EXMU
      GO TO 106
C
  102 XMAN=SBSE*SNGL(10.D0**DBLE(EXMU))
      GO TO 106
C
  103 XMAN=SIGN(1.,SBSE)*SNGL(DBLE(ABS(SBSE))**DBLE(EXMU))
      GO TO 106
C
  104 XMAN=SBSE
      GO TO 106
C
  105 XMAN=SIGN(1.,SBSE)*SNGL(DBLE(ABS(SBSE))**DBLE(ABS(EXMU)))
C
C If the mantissa-generator is negative, make it positive and put a
C minus sign in the mantissa buffer.
C
  106 IF (XMAN.LT.0.) THEN
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='-'
        XMAN=-XMAN
      END IF
C
C If the number is zero, put a zero in the mantissa buffer and quit.
C
      IF (XMAN.EQ.0.) THEN
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='0'
        RETURN
      END IF
C
C Reduce the mantissa-generator to the range (1.,10.), keeping track of
C the power of 10 required to do it.  Round the result, keeping in mind
C that the rounding may kick the value past 10. .
C
      IMAN=IFIX(ALOG10(XMAN))
      IF (XMAN.LT.1.) IMAN=IMAN-1
      XMAN=XMAN*SNGL(10.D0**(-IMAN))+SMRL
      IF (XMAN.GE.10.) THEN
        XMAN=XMAN/10.
        IMAN=IMAN+1
      END IF
C
C Jump (depending on the number-type/label-type combination) to set up
C the label-generation control parameters, as follows:
C
C    NDPD - number of digits to precede decimal point - if NDPD .LT. 0,
C           ABS(NDPD) leading zeroes follow the decimal point, preceding
C           the first digit generated from XMAN.
C    NDFD - number of digits to follow decimal point - if NDFD .LT. 0,
C           the decimal point is suppressed.
C    IF10 - flag, set non-zero to force generation of the (X 10) portion
C           of the label.
C    IFEX - flag, set non-zero to force generation of an exponent.
C    IVEX - value of exponent (if any) - always equals (IMAN+1) - NDPD.
C
      GO TO (107,107,107,108,109,110,111,112,113) , NTLT
C
C Scientific notation.
C
  107 NDPD=NLEX
      NDFD=NLFL
      IF10=1
      IFEX=1
      GO TO 114
C
C Non-scientific exponential notation for SBSE * EXMU.
C
  108 NDPD=IMAN+1-NLEX
      NDFD=NLFL
      IF10=1
      IFEX=1
      GO TO 114
C
C Non-scientific exponential notation for SBSE * 10**EXMU.
C
  109 NDPD=IMAN+1-(NLEX+IFIX(EXMU+SMRL*EXMU))
      NDFD=NLFL
      IF10=1
      IFEX=1
      GO TO 114
C
C Non-scientific exponential notation for SIGN(SBSE) * ABSV(SBSE)**EXMU.
C
  110 NDPD=IMAN+1
      IMAN=IMAN+IFIX(EXMU+SMRL*EXMU)
      NDFD=NLFL
      IF10=0
      IFEX=1
      GO TO 115
C
C No-exponent notation for SBSE * EXMU.
C
  111 NDPD=IMAN+1
      NDFD=NLFL
      IF10=0
      IFEX=0
      GO TO 115
C
C No-exponent notation for SBSE * 10**EXMU.
C
  112 NDPD=IMAN+1
      NDFD=MAX0(NLFL,0)-IFIX(EXMU+SMRL*EXMU)
      IF (NDFD.LE.0) NDFD=MIN0(NLFL,0)
      IF10=0
      IFEX=0
      GO TO 115
C
C No-exponent notation for SIGN(SBSE) * ABSV(SBSE)**EXMU
C
  113 IF (EXMU.LT.0.) THEN
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='1'
        NCIM=NCIM+1
        IF (NCIM.GT.MCIM) GO TO 901
        BFRM(NCIM:NCIM)='/'
      END IF
C
      NDPD=IMAN+1
      NDFD=NLFL*IFIX(ABS(EXMU+SMRL*EXMU))
      IF (NDFD.EQ.0) NDFD=MIN0(NLFL,0)
      IF10=0
      IFEX=0
      GO TO 115
C
C If there is an exponent of 10 and the mantissa is precisely 1, omit
C the (I.F X) portion of the mantissa.
C
  114 IF (NDPD.NE.1) GO TO 115
      IF (IFIX(XMAN).NE.1) GO TO 115
      IF (((XMAN-1.)*10.**MAX0(0,NDFD)).GE.1.) GO TO 115
      IVEX=IMAN+1-NDPD
      GO TO 123
C
C Generate the characters of the mantissa (I.F).  Check first for zero-
C or-negative-length error.
C
  115 LMAN=MAX0(NDPD,0)+1+MAX0(NDFD,-1)
      IF (LMAN.LE.0) GO TO 903
C
C Make sure the mantissa buffer is big enough to hold (I.F).
C
      IF (NCIM+LMAN.GT.MCIM) GO TO 901
C
C Compute the value of the parameter IVEX before changing NDPD.
C
      IVEX=IMAN+1-NDPD
C
C Generate the digits preceding the decimal point, if any.
C
      IF (NDPD.LE.0) GO TO 117
C
      ASSIGN 116 TO JUMP
      GO TO 121
C
  116 NDPD=NDPD-1
      IF (NDPD.NE.0) GO TO 121
C
C Generate the decimal point.
C
  117 KHAR='.'
      ASSIGN 118 TO JUMP
      GO TO 122
C
C Generate leading zeroes, if any, after the decimal point.
C
  118 IF (NDPD.EQ.0) GO TO 120
      KHAR='0'
      ASSIGN 119 TO JUMP
      GO TO 122
C
  119 NDPD=NDPD+1
      IF (NDPD.NE.0) GO TO 122
C
C Generate remaining fractional digits.
C
  120 ASSIGN 121 TO JUMP
C
C Generate a digit from the mantissa-generator.  It is assumed that, for
C n between 1 and 9, ICHAR('n') = ICHAR('n-1') + 1 .
C
  121 IDGT=IFIX(XMAN)
      KHAR=CHAR(ICHAR('0')+IDGT)
      XMAN=XMAN-FLOAT(IDGT)
      XMAN=XMAN*10.
C
C Store a digit from KHAR into the mantissa buffer.
C
  122 NCIM=NCIM+1
      BFRM(NCIM:NCIM)=KHAR
C
C Check whether (I.F) is complete.
C
      LMAN=LMAN-1
      IF (LMAN.NE.0) GO TO JUMP , (116,118,119,121)
C
C If appropriate, leave space in the mantissa buffer for the "X" .
C
      IF (IF10.EQ.0) GO TO 124
      NCIM=NCIM+1
      IF (NCIM.GT.MCIM) GO TO 901
      IPXM=NCIM
      BFRM(IPXM:IPXM)=' '
C
C If appropriate, put a "10" in the mantissa buffer.
C
  123 NCIM=NCIM+1
      IF (NCIM.GT.MCIM) GO TO 901
      BFRM(NCIM:NCIM)='1'
      NCIM=NCIM+1
      IF (NCIM.GT.MCIM) GO TO 901
      BFRM(NCIM:NCIM)='0'
C
C If appropriate, generate an exponent in the exponent buffer.
C
  124 IF (IFEX.EQ.0) RETURN
C
      IF (IVEX) 126,125,127
C
  125 NCIE=NCIE+1
      IF (NCIE.GT.MCIE) GO TO 902
      BFRE(NCIE:NCIE)='0'
      RETURN
C
  126 NCIE=NCIE+1
      IF (NCIE.GT.MCIE) GO TO 902
      BFRE(NCIE:NCIE)='-'
      IVEX=-IVEX
C
  127 NCIE=NCIE+1
      IF (IVEX.GE.10) NCIE=NCIE+1
      IF (IVEX.GE.100) NCIE=NCIE+1
      IF (IVEX.GE.1000) NCIE=NCIE+1
      IF (NCIE.GT.MCIE) GO TO 902
C
      DO 128 I=1,4
        J=NCIE+1-I
        BFRE(J:J)=CHAR(ICHAR('0')+MOD(IVEX,10))
        IVEX=IVEX/10
        IF (IVEX.EQ.0) RETURN
  128 CONTINUE
C
      IF (IVEX.NE.0) GO TO 902
C
C Done.
C
      RETURN
C
C Error exits.
C
  901 CALL SETER ('AGNUMB - MANTISSA TOO LONG',4,2)
C
  902 CALL SETER ('AGNUMB - EXPONENT TOO LARGE',5,2)
C
  903 CALL SETER ('AGNUMB - ZERO-LENGTH MANTISSA',6,2)
C
      END

#-h-  ifparm			  689  local   12/01/80  15:54:11
# ifparm - determines if the defined symbol has arguments in its
   include  defs
# definition.  This effects how the macro is expanded.

   integer function ifparm (strng)
   character strng (ARB)

   character c

   external index
   integer i, index, type

   c = strng (1)
   if (c == INCTYPE | c == SUBTYPE | c == IFTYPE | c == ARITHTYPE |
    c == MACTYPE)
      ifparm = YES
   else {
      ifparm = NO
      for (i = 1; index (strng (i), ARGFLAG) > 0; ) {
	 i = i + index (strng (i), ARGFLAG) # i points at char after ARGFLAG
	 if ((type (strng (i)) == DIGIT)
	   & (type (strng (i + 1)) != DIGIT)) {
	    ifparm = YES
	    break
	 }
      }
   }
   return
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C +NOAO - This routine is a no-op in IRAF.
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSAVE (IFNO)
C
C This subroutine is called to save the current state of AUTOGRAPH by
C writing all of its important variables as a record on the file which
C is associated with the unit number IFNO.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
C
      COMMON /AGCHR2/ CHRA(2000)
C
      CHARACTER*1 CHRA
C
C If initialization has not yet been done, do it.
C
      IF (INIF.EQ.0) THEN
        CALL AGINIT
      END IF
C
C Write the record.  Variables from each COMMON block are together, in
C alphabetical order.
C
C     WRITE (IFNO,ERR=901)
C    1 BASD,BASE,DBOX,DNLA,FLLB,FLLN,FUNS,HCWP,PING,PINU,QBAC,QBAN,QBIM,
C    2 QBTD,QBTP,QCDP,QCEX,QCEY,QCIE,QCIM,QDAX,QDLB,QDSH,QFRA,QIXY,QJDP,
C    3 QLED,QLEX,QLFD,QLFL,QLLN,QLOF,QLOS,QLTD,QLTP,QLUA,QLUX,QLUY,QMJD,
C    4 QMND,QMNT,QNAN,QNDP,QNIM,QODP,QOVX,QOVY,QROW,QSET,QSPA,QWND,RBOX,
C    5 RFNL,SBOX,SCWP,SOGD,SVAL,TCLN,UBGA,UNDA,WCLE,WCLM,WCWP,WMJL,WMJR,
C    6 WMNL,WMNR,WNLB,WNLE,WNLL,WNLR,WOCD,WODQ,XBGA,XHGH,XLCW,XLGD,XLGF,
C    7 XLGW,XLOW,XLUW,XMAX,XMIN,XNDA,XRCW,XRGD,XRGF,XRGW,XRUW,YBCW,YBGA,
C    8 YBGD,YBGF,YBGW,YBUW,YHGH,YLOW,YMAX,YMIN,YNDA,YTCW,YTGD,YTGF,YTGW,
C    9 YTUW,
C    + INIF,ISLD,MDLA,MWCD,MWCE,MWCL,MWCM,MWDQ,SMRL,
C    1 INCA,INCH,LNCA,LNIC,
C    2 CHRA
C
C Done.
C
      RETURN
C
C Error exit.
C
C 901 CALL SETER ('AGSAVE - ERROR ON WRITE',10,2)
C
C -NOAO
      END

chapter x.  example 4. construction of a b-spline via  bvalue
c  from  * a practical guide to splines *  by c. de boor
calls  bvalue(interv)
      integer ia
      real bcoef(1),t(5),value,x
      real bvalue
c		   set knot sequence  t  and  b-coeffs for  b(1,4,t)
      data t / 0.,1.,3.,4.,6. / , bcoef / 1. /
c	evaluate  b(1,4,t)  on a fine mesh.  on (0,6), the values should
c		coincide with those obtained in example 3 .
      do 20 ia=1,40
	 x = float(ia)*.2 - 1.
	 value = bvalue ( t, bcoef, 1, 4, x, 0 )
   20	 print 620, x, value
  620 format(f10.1,f20.8)
					stop
      end

      SUBROUTINE slDC6S (V, A, B, R, AD, BD, RD)
*+
*     - - - - - -
*      D C 6 S
*     - - - - - -
*
*  Conversion of position & velocity in Cartesian coordinates
*  to spherical coordinates (double precision)
*
*  Given:
*     V      d(6)   Cartesian position & velocity vector
*
*  Returned:
*     A      d      longitude (radians)
*     B      d      latitude (radians)
*     R      d      radial coordinate
*     AD     d      longitude derivative (radians per unit time)
*     BD     d      latitude derivative (radians per unit time)
*     RD     d      radial derivative
*
*  P.T.Wallace   Starlink   28 April 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(6),A,B,R,AD,BD,RD

      DOUBLE PRECISION X,Y,Z,XD,YD,ZD,RXY2,RXY,R2,XYP



*  Components of position/velocity vector
      X=V(1)
      Y=V(2)
      Z=V(3)
      XD=V(4)
      YD=V(5)
      ZD=V(6)

*  Component of R in XY plane squared
      RXY2=X*X+Y*Y

*  Modulus squared
      R2=RXY2+Z*Z

*  Protection against null vector
      IF (R2.EQ.0D0) THEN
         X=XD
         Y=YD
         Z=ZD
         RXY2=X*X+Y*Y
         R2=RXY2+Z*Z
      END IF

*  Position and velocity in spherical coordinates
      RXY=SQRT(RXY2)
      XYP=X*XD+Y*YD
      IF (RXY2.NE.0D0) THEN
         A=ATAN2(Y,X)
         B=ATAN2(Z,RXY)
         AD=(X*YD-Y*XD)/RXY2
         BD=(ZD*RXY2-Z*XYP)/(R2*RXY)
      ELSE
         A=0D0
         IF (Z.NE.0D0) THEN
            B=ATAN2(Z,RXY)
         ELSE
            B=0D0
         END IF
         AD=0D0
         BD=0D0
      END IF
      R=SQRT(R2)
      IF (R.NE.0D0) THEN
         RD=(XYP+Z*ZD)/R
      ELSE
         RD=0D0
      END IF

      END

      subroutine initkw
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer mktabl
      call dsinit (60000)
      deftbl = mktabl (1)
      call entdkw
      rkwtbl = mktabl (1)
      call entrkw
      fkwtbl = mktabl (0)
      call entfkw
      namtbl = mktabl (1)
      xpptbl = mktabl (1)
      call entxkw
      gentbl = mktabl (0)
      errtbl = 0
      label = 100
      smem(1) = -2
      body = 0
      dbgout = 0
      dbglev = 0
      memflg = 0
      swinrg = 0
      col = 6
      return
      end
c     logic0  logical_column

      integer function outsub (arg, file, access)
      integer arg (100), file (100)
      integer access
      if (.not.(arg (1) .eq. 62 .and. arg (2) .ne. 62 .and. arg (2) .ne.
     * -2))goto 23000
      outsub = 1
      access = 2
      call scopy (arg, 2, file, 1)
      goto 23001
23000 continue
      if (.not.(arg (1) .eq. 62 .and. arg (2) .eq. 62 .and. arg (3) .ne.
     * -2))goto 23002
      access = 4
      outsub = 1
      call scopy (arg, 3, file, 1)
      goto 23003
23002 continue
      outsub = 0
23003 continue
23001 continue
      return
      end

      SUBROUTINE CONTLK (XD,YD,NDP,IPT)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  DRAW THE TRIANGLES CREATED BY CONTNG
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       XD(1)      ,YD(1)      ,IPT(1)
C
        SAVE
C
C  STATEMENT FUNCTIONS TO SCALE DATA FOR OVERLAYS
C
      FX(XXX,YYY) = XXX
      FY(XXX,YYY) = YYY
C
C   ADVANCE PICTURE IF DESIRED
C
      IF (FRADV) CALL FRAME
C
C  DRAW TRIANGLES
C
      DO  100 K=1,NT
         I = K*3
         I1 = IPT(I)
         I2 = IPT(I-1)
         I3 = IPT(I-2)
         XX = FX(XD(I1),YD(I1))
         CALL FL2INT (XX,FY(XD(I1),YD(I1)),MX1,MY1)
         CALL PLOTIT (MX1,MY1,0)
         XX = FX(XD(I2),YD(I2))
         CALL FL2INT (XX,FY(XD(I2),YD(I2)),MX,MY)
         CALL PLOTIT (MX,MY,1)
         XX = FX(XD(I3),YD(I3))
         CALL FL2INT (XX,FY(XD(I3),YD(I3)),MX,MY)
         CALL PLOTIT (MX,MY,1)
         CALL PLOTIT (MX1,MY1,1)
  100 CONTINUE
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
      END

      subroutine mapid (name)
      integer name(100)
      integer i
      i=1
23000 if (.not.(name(i) .ne. -2))goto 23002
23001 i=i+1
      goto 23000
23002 continue
      if (.not.(i-1 .gt. 6))goto 23003
      name(6) = name(i-1)
      name(6+1) = -2
23003 continue
      end

      subroutine flash3 (ipoint)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      dimension       idummy(1)
      if (modef .lt. 2) go to 102
      kpoint = ipoint
      if (kpoint.lt.0 .or. kpoint.gt.10) go to 103
      if (mfwa(kpoint+1) .eq. -9999) go to 102
      call mcflsh
      isave1 = mbufa
      isave2 = mbuflu
      mbufa = mfwa(kpoint+1)
      nlentg = mlwa(kpoint+1)-mbufa+1
      isub = mbufa+nlentg-loci(idummy)
      nusrwc = idummy(isub+1)
      if (nusrwc .ne. nlentg) go to 104
      modef = -3
  101 mbuflu = min0(nlentg,msblen)
      if (mbuflu .gt. 0) call preout
      nlentg = nlentg-msblen
      mbufa = mbufa+msblen
      if (nlentg .gt. 0) go to 101
      mbufa = isave1
      mbuflu = isave2
      mxold = -9999
      myold = -9999
      modef = 3
      mjxmin = min0(mjxmin,idummy(isub+2))
      mjymin = min0(mjymin,idummy(isub+3))
      mjxmax = max0(mjxmax,idummy(isub+4))
      mjymax = max0(mjymax,idummy(isub+5))
      return
  102 continue
c     write (mprint,1001) kpoint
c
      call uliber (0,
     1             48h0flash3 called without call to flash1 and flash2,
     2             48)
      call perror
      return
  103 continue
c     write (mprint,1001) kpoint
c
      call uliber (0,37h0argument out of range in flash3 call,37)
      call perror
      return
  104 continue
c     write (mprint,1001) kpoint
c
      call uliber (0,37h0user flash buffer has been corrupted,37)
      call perror
      return
c
c1001 format (27h0flash3 called with ipoint=,i5)
c
      end

      subroutine prompt (str, buf, fd)
      integer str(100), buf(100)
      integer fd
      integer isatty
      if (.not.(isatty(fd) .eq. 1))goto 23000
      call putlin (str, fd)
      call rfflus(fd)
23000 continue
      call getlin (buf, fd)
      return
      end

C----------------------------------------------------------------------
        subroutine ftc2rr(cval,val,status)

C       convert a character string to a real value
C       (assumes that the input string is left justified)
C       cval    c  input character string to be converted 
C       val     r  output value 
C       status  i  output error status (0 = OK)

        character*(*) cval
        real val
        integer status,nleng
        character iform*8,sval*16

        if (status .gt. 0)return

        if (cval .eq. ' ')go to 900

C       find length of the input real character string
        nleng=index(cval,' ')-1
        if (nleng .eq. -1)nleng=len(cval)

C       construct the format statement to read the character string
        if (nleng .le. 9)then
                write(iform,1000)nleng, '\0'
1000            format('(F',I1,'.0)',A)
        else
                write(iform,1001)nleng, '\0'
1001            format('(F',I2,'.0)',A)
        end if

        read(cval,iform,err=900)val
        return

900     status=408
        sval=cval
        call ftpmsg('Error in FTC2RR evaluating this string '//
     &       'as a real: '//sval)
        end

      SUBROUTINE slOAP ( TYPE, OB1, OB2, DATE, DUT, ELONGM, PHIM,
     :                     HM, XP, YP, TDK, PMB, RH, WL, TLR,
     :                     RAP, DAP )
*+
*     - - - -
*      O A P
*     - - - -
*
*  Observed to apparent place.
*
*  Given:
*     TYPE   c*(*)  type of coordinates - 'R', 'H' or 'A' (see below)
*     OB1    d      observed Az, HA or RA (radians; Az is N=0,E=90)
*     OB2    d      observed ZD or Dec (radians)
*     DATE   d      UTC date/time (modified Julian Date, JD-2400000.5)
*     DUT    d      delta UT:  UT1-UTC (UTC seconds)
*     ELONGM d      mean longitude of the observer (radians, east +ve)
*     PHIM   d      mean geodetic latitude of the observer (radians)
*     HM     d      observer's height above sea level (metres)
*     XP     d      polar motion x-coordinate (radians)
*     YP     d      polar motion y-coordinate (radians)
*     TDK    d      local ambient temperature (K; std=273.15D0)
*     PMB    d      local atmospheric pressure (mb; std=1013.25D0)
*     RH     d      local relative humidity (in the range 0D0-1D0)
*     WL     d      effective wavelength (micron, e.g. 0.55D0)
*     TLR    d      tropospheric lapse rate (K/metre, e.g. 0.0065D0)
*
*  Returned:
*     RAP    d      geocentric apparent right ascension
*     DAP    d      geocentric apparent declination
*
*  Notes:
*
*  1)  Only the first character of the TYPE argument is significant.
*      'R' or 'r' indicates that OBS1 and OBS2 are the observed right
*      ascension and declination;  'H' or 'h' indicates that they are
*      hour angle (west +ve) and declination;  anything else ('A' or
*      'a' is recommended) indicates that OBS1 and OBS2 are azimuth
*      (north zero, east 90 deg) and zenith distance.  (Zenith
*      distance is used rather than elevation in order to reflect the
*      fact that no allowance is made for depression of the horizon.)
*
*  2)  The accuracy of the result is limited by the corrections for
*      refraction.  Providing the meteorological parameters are
*      known accurately and there are no gross local effects, the
*      predicted apparent RA,Dec should be within about 0.1 arcsec
*      for a zenith distance of less than 70 degrees.  Even at a
*      topocentric zenith distance of 90 degrees, the accuracy in
*      elevation should be better than 1 arcmin;  useful results
*      are available for a further 3 degrees, beyond which the
*      slRFRO routine returns a fixed value of the refraction.
*      The complementary routines slAOP (or slAOPQ) and slOAP
*      (or slOAPQ) are self-consistent to better than 1 micro-
*      arcsecond all over the celestial sphere.
*
*  3)  It is advisable to take great care with units, as even
*      unlikely values of the input parameters are accepted and
*      processed in accordance with the models used.
*
*  4)  "Observed" Az,El means the position that would be seen by a
*      perfect theodolite located at the observer.  This is
*      related to the observed HA,Dec via the standard rotation, using
*      the geodetic latitude (corrected for polar motion), while the
*      observed HA and RA are related simply through the local
*      apparent ST.  "Observed" RA,Dec or HA,Dec thus means the
*      position that would be seen by a perfect equatorial located
*      at the observer and with its polar axis aligned to the
*      Earth's axis of rotation (n.b. not to the refracted pole).
*      By removing from the observed place the effects of
*      atmospheric refraction and diurnal aberration, the
*      geocentric apparent RA,Dec is obtained.
*
*  5)  Frequently, mean rather than apparent RA,Dec will be required,
*      in which case further transformations will be necessary.  The
*      slAMP etc routines will convert the apparent RA,Dec produced
*      by the present routine into an "FK5" (J2000) mean place, by
*      allowing for the Sun's gravitational lens effect, annual
*      aberration, nutation and precession.  Should "FK4" (1950)
*      coordinates be needed, the routines slFK54 etc will also
*      need to be applied.
*
*  6)  To convert to apparent RA,Dec the coordinates read from a
*      real telescope, corrections would have to be applied for
*      encoder zero points, gear and encoder errors, tube flexure,
*      the position of the rotator axis and the pointing axis
*      relative to it, non-perpendicularity between the mounting
*      axes, and finally for the tilt of the azimuth or polar axis
*      of the mounting (with appropriate corrections for mount
*      flexures).  Some telescopes would, of course, exhibit other
*      properties which would need to be accounted for at the
*      appropriate point in the sequence.
*
*  7)  This routine takes time to execute, due mainly to the rigorous
*      integration used to evaluate the refraction.  For processing
*      multiple stars for one location and time, call slAOPA once
*      followed by one call per star to slOAPQ.  Where a range of
*      times within a limited period of a few hours is involved, and the
*      highest precision is not required, call slAOPA once, followed
*      by a call to slAOPT each time the time changes, followed by
*      one call per star to slOAPQ.
*
*  8)  The DATE argument is UTC expressed as an MJD.  This is, strictly
*      speaking, wrong, because of leap seconds.  However, as long as
*      the delta UT and the UTC are consistent there are no
*      difficulties, except during a leap second.  In this case, the
*      start of the 61st second of the final minute should begin a new
*      MJD day and the old pre-leap delta UT should continue to be used.
*      As the 61st second completes, the MJD should revert to the start
*      of the day as, simultaneously, the delta UTC changes by one
*      second to its post-leap new value.
*
*  9)  The delta UT (UT1-UTC) is tabulated in IERS circulars and
*      elsewhere.  It increases by exactly one second at the end of
*      each UTC leap second, introduced in order to keep delta UT
*      within +/- 0.9 seconds.
*
*  10) IMPORTANT -- TAKE CARE WITH THE LONGITUDE SIGN CONVENTION.
*      The longitude required by the present routine is east-positive,
*      in accordance with geographical convention (and right-handed).
*      In particular, note that the longitudes returned by the
*      slOBS routine are west-positive, following astronomical
*      usage, and must be reversed in sign before use in the present
*      routine.
*
*  11) The polar coordinates XP,YP can be obtained from IERS
*      circulars and equivalent publications.  The maximum amplitude
*      is about 0.3 arcseconds.  If XP,YP values are unavailable,
*      use XP=YP=0D0.  See page B60 of the 1988 Astronomical Almanac
*      for a definition of the two angles.
*
*  12) The height above sea level of the observing station, HM,
*      can be obtained from the Astronomical Almanac (Section J
*      in the 1988 edition), or via the routine slOBS.  If P,
*      the pressure in millibars, is available, an adequate
*      estimate of HM can be obtained from the expression
*
*             HM ~ -29.3D0*TSL*LOG(P/1013.25D0).
*
*      where TSL is the approximate sea-level air temperature in K
*      (see Astrophysical Quantities, C.W.Allen, 3rd edition,
*      section 52).  Similarly, if the pressure P is not known,
*      it can be estimated from the height of the observing
*      station, HM, as follows:
*
*             P ~ 1013.25D0*EXP(-HM/(29.3D0*TSL)).
*
*      Note, however, that the refraction is nearly proportional to the
*      pressure and that an accurate P value is important for precise
*      work.
*
*  13) The azimuths etc. used by the present routine are with respect
*      to the celestial pole.  Corrections from the terrestrial pole
*      can be computed using slPLMO.
*
*  Called:  slAOPA, slOAPQ
*
*  Last revision:   2 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) TYPE
      DOUBLE PRECISION OB1,OB2,DATE,DUT,ELONGM,PHIM,HM,
     :                 XP,YP,TDK,PMB,RH,WL,TLR,RAP,DAP

      DOUBLE PRECISION AOPRMS(14)


      CALL slAOPA(DATE,DUT,ELONGM,PHIM,HM,XP,YP,TDK,PMB,RH,WL,TLR,
     :               AOPRMS)
      CALL slOAPQ(TYPE,OB1,OB2,AOPRMS,RAP,DAP)

      END

#-h-  puttok			  198  local   12/01/80  15:54:34
# puttok-put token into eval stack
   include  defs

    subroutine puttok (str)
    character str (MAXTOK)

    integer i

    for (i = 1; str (i) != EOS; i = i + 1)
       call putchr (str (i))
    return
    end

      SUBROUTINE slPCD (DISCO,X,Y)
*+
*     - - - -
*      P C D
*     - - - -
*
*  Apply pincushion/barrel distortion to a tangent-plane [x,y].
*
*  Given:
*     DISCO    d      pincushion/barrel distortion coefficient
*     X,Y      d      tangent-plane coordinates
*
*  Returned:
*     X,Y      d      distorted coordinates
*
*  Notes:
*
*  1)  The distortion is of the form RP = R*(1 + C*R**2), where R is
*      the radial distance from the tangent point, C is the DISCO
*      argument, and RP is the radial distance in the presence of
*      the distortion.
*
*  2)  For pincushion distortion, C is +ve;  for barrel distortion,
*      C is -ve.
*
*  3)  For X,Y in units of one projection radius (in the case of
*      a photographic plate, the focal length), the following
*      DISCO values apply:
*
*          Geometry          DISCO
*
*          astrograph         0.0
*          Schmidt           -0.3333
*          AAT PF doublet  +147.069
*          AAT PF triplet  +178.585
*          AAT f/8          +21.20
*          JKT f/8          +13.32
*
*  4)  There is a companion routine, slUPCD, which performs the
*      inverse operation.
*
*  P.T.Wallace   Starlink   3 September 2000
*
*  Copyright (C) 2000 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DISCO,X,Y

      DOUBLE PRECISION F



      F=1D0+DISCO*(X*X+Y*Y)
      X=X*F
      Y=Y*F

      END

      SUBROUTINE slDVTP (V, V0, XI, ETA, J)
*+
*     - - - - - -
*      D V T P
*     - - - - - -
*
*  Given the direction cosines of a star and of the tangent point,
*  determine the star's tangent-plane coordinates.
*
*  (double precision)
*
*  Given:
*     V         d(3)    direction cosines of star
*     V0        d(3)    direction cosines of tangent point
*
*  Returned:
*     XI,ETA    d       tangent plane coordinates of star
*     J         i       status:   0 = OK
*                                 1 = error, star too far from axis
*                                 2 = error, antistar on tangent plane
*                                 3 = error, antistar too far from axis
*
*  Notes:
*
*  1  If vector V0 is not of unit length, or if vector V is of zero
*     length, the results will be wrong.
*
*  2  If V0 points at a pole, the returned XI,ETA will be based on the
*     arbitrary assumption that the RA of the tangent point is zero.
*
*  3  This routine is the Cartesian equivalent of the routine slDSTP.
*
*  P.T.Wallace   Starlink   27 November 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(3),V0(3),XI,ETA
      INTEGER J

      DOUBLE PRECISION X,Y,Z,X0,Y0,Z0,R2,R,W,D

      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-6)


      X=V(1)
      Y=V(2)
      Z=V(3)
      X0=V0(1)
      Y0=V0(2)
      Z0=V0(3)
      R2=X0*X0+Y0*Y0
      R=SQRT(R2)
      IF (R.EQ.0D0) THEN
         R=1D-20
         X0=R
      END IF
      W=X*X0+Y*Y0
      D=W+Z*Z0
      IF (D.GT.TINY) THEN
         J=0
      ELSE IF (D.GE.0D0) THEN
         J=1
         D=TINY
      ELSE IF (D.GT.-TINY) THEN
         J=2
         D=-TINY
      ELSE
         J=3
      END IF
      D=D*R
      XI=(Y*X0-X*Y0)/D
      ETA=(Z*R2-Z0*W)/D

      END

C----------------------------------------------------------------------
        subroutine ftgcvj(iunit,colnum,frow,felem,nelem,nulval,array,
     &          anynul,status)

C       read an array of I*4 values from a specified column of the table.
C       Any undefined pixels will be set equal to the value of NULVAL,
C       unless NULVAL=0, in which case no checks for undefined pixels
C       will be made.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of elements to read
C       nulval  i  value that undefined pixels will be set to
C       array   i  returned array of data values that was read from FITS file
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,status
        logical flgval,anynul
        integer array(*),nulval

        call ftgclj(iunit,colnum,frow,felem,nelem,1,1,nulval,
     &      array,flgval,anynul,status)
        end        

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      CHARACTER*16 FUNCTION AGDSHN (IDSH)
C
C The value of this function is the name of the dash pattern numbered
C IDSH - that is to say, the character string 'DASH/PATTERN/n.', where
C n is an integer between 1 and 99, equal to MAX0(1,MIN0(99,IDSH)).
C
      AGDSHN='DASH/PATTERN/  .'
C
      KDSH=MAX0(1,MIN0(99,IDSH))
C
      DO 101 I=15,14,-1
        AGDSHN(I:I)=CHAR(ICHAR('0')+MOD(KDSH,10))
        IF (KDSH.LE.9) GO TO 102
        KDSH=KDSH/10
  101 CONTINUE
C
  102 RETURN
C
      END

C--------------------------------------------------------------------------
        subroutine ftdsum(string,complm,sum)

C       decode the 32 bit checksum

C       If complm=.true., then the complement of the sum will be decoded.

C       This Fortran algorithm is based on the C algorithm developed by Rob
C       Seaman at NOAO that was presented at the 1994 ADASS conference, to be 
C       published in the Astronomical Society of the Pacific Conference Series.
C     
C       sum     d  checksum value 
C       complm  l  encode the complement of the sum?
C       string  c  output ASCII encoded check sum
C       sum     d  checksum value 
C
C       written by Wm Pence, HEASARC/GSFC, May, 1995

        double precision sum,all32,word32,factor(4)
        character*16 string,tmpstr
        integer offset,i,j,k,temp,hibits
        logical complm

C       all32 equals a 32 bit unsigned integer with all bits set
C       word32 is equal to 2**32
        parameter (all32=4.294967295D+09)
        parameter (word32=4.294967296D+09)

C       ASCII 0 is the offset value
        parameter (offset=48)

        data factor/16777216.,65536.,256.,1./

        sum=0

C       shift the characters 1 place to the left, since the FITS character
C       string value starts in column 12, which is not word aligned
        tmpstr(1:15)=string(2:16)
        tmpstr(16:16)=string(1:1)

C       convert characters from machine's native character coding sequence
C       to ASCII codes.   This only affects IBM mainframe computers 
C       that do not use ASCII for the internal character representation.
        call ftc2as(tmpstr,16)

C       substract the offset from each byte and interpret each 4 character
C       string as a 4-byte unsigned integer; sum the 4 integers
        k=0
        do 10 i=1,4
          do 20 j=1,4
            k=k+1
            temp=ichar(tmpstr(k:k))-offset
            sum=sum+temp*factor(j)
20        continue
10      continue

C       fold any overflow bits beyond 32 back into the word
30      hibits=sum/word32
        if (hibits .gt. 0)then
                sum=sum-(hibits*word32)+hibits
                go to 30
         end if

        if (complm)then
C           complement the 32-bit unsigned integer equivalent (flip every bit)
            sum=all32-sum
        end if
        end

include defs

# ENDCOD -- Code thats gets executed when the END statement is encountered,
# terminating a procedure.

subroutine endcod (endstr)

character endstr(1)
include COMMON_BLOCKS
string	sepro "call zzepro"
string	sret "return"

	if (esp != 0)
	    call synerr ("Unmatched 'iferr' or 'then' keyword.")
	esp = 0					# error stack pointer
	body = NO
	ername = NO
	if (errtbl != NULL)
	    call rmtabl (errtbl)
	errtbl = NULL
	memflg = NO				# reinit mem decl flag

	if (retlab != NULL)
	    call outnum (retlab)
	call outtab
	call outstr (sepro)
	call outdon
	call outtab
	call outstr (sret)
	call outdon

	col = 6
	call outtab
	call outstr (endstr)
	call outdon
end

define	ARB		999999999
define	ERR		-1
define	EOF		-2
define	BOF		-3
define	EOT		-4
define	BOFL		BOF
define	EOFL		EOF
define	EOS		0
define	NO		0
define	YES		1
define	OK		0
define	NULL		0


define	READ_ONLY	1		
define	READ_WRITE	2
define	WRITE_ONLY	3
define	APPEND		4
define	NEW_FILE	5
define	TEMP_FILE	6
define	NEW_COPY	7
define	NEW_IMAGE	5		
define	NEW_STRUCT	5
define	NEW_TAPE	5
define	TEXT_FILE	11		
define	BINARY_FILE	12
define	DIRECTORY_FILE	13
define	STATIC_FILE	14
define	SPOOL_FILE	(-2)
define	RANDOM		1		
define	SEQUENTIAL	2
define	CLIN		1		
define	CLOUT		2		
define	STDIN		3		
define	STDOUT		4
define	STDERR		5
define	STDGRAPH	6
define	STDIMAGE	7
define	STDPLOT		8



define	SZ_BOOL		2		
define	SZ_CHAR		1
define	SZ_SHORT	1
define	SZ_INT		2
define	SZ_LONG		2
define	SZ_REAL		2
define	SZ_DOUBLE	4
define	SZ_COMPLEX	4
define	SZ_POINTER	2
define	SZ_STRUCT	2
define	SZ_USHORT	1
define	SZ_FNAME	255		
define	SZ_PATHNAME	511		
define	SZ_LINE		1023		
define	SZ_COMMAND	2047		

define  SZ_MII_SHORT    1		
define  SZ_MII_LONG     2
define  SZ_MII_REAL     2
define  SZ_MII_DOUBLE   4
define  SZ_MII_INT      SZ_MII_LONG

define	SZ_INT32	2		
define	SZ_LONG32	2
define	SZ_STRUCT32	2

define	TY_BOOL		1		
define	TY_CHAR		2
define	TY_SHORT	3
define	TY_INT		4
define	TY_LONG		5
define	TY_REAL		6
define	TY_DOUBLE	7
define	TY_COMPLEX	8
define	TY_POINTER	9
define	TY_STRUCT	10		
define	TY_USHORT	11		
define	TY_UBYTE	12		


define	INDEFS		(-32767)
define	INDEFL		(-2147483647)
define	INDEFI		INDEFL
define	INDEFR		1.6e38
define	INDEFD		1.6d308
define	INDEFX		(INDEF,INDEF)
define	INDEF		INDEFR

define	IS_INDEFS	(($1)==INDEFS)
define	IS_INDEFL	(($1)==INDEFL)
define	IS_INDEFI	(($1)==INDEFI)
define	IS_INDEFR	(($1)==INDEFR)
define	IS_INDEFD	(($1)==INDEFD)
define	IS_INDEFX	(real($1)==INDEFR)
define	IS_INDEF	(($1)==INDEFR)


define	P2C	((($1)-1)*2+1)
define	P2S	((($1)-1)*2+1)
define	P2L	($1)
define	P2R	($1)
define	P2D	((($1)-1)/2+1)
define	P2X	((($1)-1)/2+1)

define	P2P	($1)			












define	access	xfaccs
define	calloc	xcallc
define	close	xfcloe
define	delete	xfdele
define	error	xerror
define	flush	xffluh
define	getc	xfgetc
define	getchar	xfgetr
define	malloc	xmallc
define	mfree	xmfree
define	mktemp	xmktep
define	note	xfnote
define	open	xfopen
define	poll	xfpoll
define	printf	xprinf
define	putc	xfputc
define	putchar	xfputr
define	qsort	xqsort
define	read	xfread
define	realloc	xrealc
define	seek	xfseek
define	sizeof	xsizef
define	strcat	xstrct
define	strcmp	xstrcp
define	strcpy	xstrcy
define	strlen	xstrln
define	ungetc	xfungc
define	write	xfwrie
define  fatal   xfatal
define  fchdir  xfchdr
define  fscan   xfscan
define  getopt  xgtopt
define  getpid  xgtpid
define  getuid  xgtuid
define  rename  xfrnam
define  reset   xreset
define  scan    xxscan






define	IS_UPPER	($1>=65&$1<=90)
define	IS_LOWER	($1>=97&$1<=122)
define	IS_DIGIT	($1>=48&$1<=57)
define	IS_PRINT	($1>=32&$1<127)
define	IS_CNTRL	($1>0&$1<32)
define	IS_ASCII	($1>0&$1<=127)
define	IS_ALPHA	(IS_UPPER($1)|IS_LOWER($1))
define	IS_ALNUM	(IS_ALPHA($1)|IS_DIGIT($1))
define	IS_WHITE	($1==32|$1==9)
define	TO_UPPER	($1+65-97)
define	TO_LOWER	($1+97-65)
define	TO_INTEG	($1-48)
define	TO_DIGIT	($1+48)

#!# 2
















 
x$subr t_hello ()

x$short	ST0001(14)
save
x$int	iyy
data	(ST0001(iyy),iyy= 1, 8)	/104,101,108,108,111, 44, 32,119/
data	(ST0001(iyy),iyy= 9,14)	/111,114,108,100, 10, 0/
begin
#!# 10

	call printf (ST0001)
end

#-h-  entdkw			  975  local   12/01/80  15:54:05
# entdkw --- install macro processor keywords
   include  defs

   subroutine entdkw

   character deft(2), prag(2) #, inct(2), subt(2), ift(2), art(2),
      # ifdft(2), ifndt(2), mact(2)

   string defnam "define"
   string prgnam "pragma"
#  string macnam "mdefine"
#  string incnam "incr"
#  string subnam "substr"
#  string ifnam "ifelse"
#  string arnam "arith"
#  string ifdfnm "ifdef"
#  string ifndnm "ifnotdef"

   data deft (1), deft (2) /DEFTYPE, EOS/
   data prag (1), prag (2) /PRAGMATYPE, EOS/
#  data mact (1), mact (2) /MACTYPE, EOS/
#  data inct (1), inct (2) /INCTYPE, EOS/
#  data subt (1), subt (2) /SUBTYPE, EOS/
#  data ift (1), ift (2) /IFTYPE, EOS/
#  data art (1), art (2) /ARITHTYPE, EOS/
#  data ifdft (1), ifdft (2) /IFDEFTYPE, EOS/
#  data ifndt (1), ifndt (2) /IFNOTDEFTYPE, EOS/

   call ulstal (defnam, deft)
   call ulstal (prgnam, prag)
#  call ulstal (macnam, mact)
#  call ulstal (incnam, inct)
#  call ulstal (subnam, subt)
#  call ulstal (ifnam, ift)
#  call ulstal (arnam, art)
#  call ulstal (ifdfnm, ifdft)
#  call ulstal (ifndnm, ifndt)

return
end

      integer function clower(c)
      integer c
      integer k
      if (.not.(c .ge. 65 .and. c .le. 90))goto 23000
      k = 97 - 65
      clower = c + k
      goto 23001
23000 continue
      clower = c
23001 continue
      return
      end

C SUBROUTINE CHIFIT.F 
C
C SOURCE
C   BEVINGTON, PAGES 228-231.
C
C PURPOSE
C   MAKE A LEAST-SQUARES FIT TO A NON-LINEAR FUNCTION
C      WITH A PARABOLIC EXPANSION OF CHI SQUARE 
C
C USAGE 
C   CALL CHIFIT (X, Y, SIGMAY, NPTS, NTERMS, MODE, A, DELTAA,
C      SIGMAA, YFIT, CHISQR)
C
C DESCRIPTION OF PARAMETERS
C   X      - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C   Y      - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C   SIGMAY - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
C   NPTS   - NUMBER OF PAIRS OF DATA POINTS
C   NTERMS - NUMBER OF PARAMETERS
C   MODE   - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C            +1 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
C             0 (NO WEIGHTING) WEIGHT(I) = 1.
C            -1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
C   A      - ARRAY OF PARAMETERS
C   DELTAA - ARRAY OF INCREMENTS FOR PARAMETERS A
C   SIGMAA - ARRAY OF STANDARD DEVIATIONS FOR PARAMETERS A
C   YFIT   - ARRAY OF CALCULATED VALUES OF Y
C   CHISQR - REDUCED CHI SQUARE FOR FIT 
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   FUNCTN (X, I, A)
C      EVALUATES THE FITTING FUNCTION FOR THE ITH TERM
C   FCHISQ (Y, SIGMAY, NPTS, NFREE, MODE, YFIT) 
C      EVALUATES REDUCED CHI SQUARED FOR FIT TO DATA
C   MATINV (ARRAY, NTERMS, DET) 
C      INVERTS A SYMMETRIC TWO-DIMENSIONAL MATRIX OF DEGREE NTERMS
C      AND CALCULATES ITS DETERMINANT
C
C COMMENTS
C   DIMENSION STATEMENT VALID FOR NTERMS UP TO 10
C
      SUBROUTINE CHIFIT (X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,
     *SIGMAA,YFIT,CHISQR)
      DOUBLE PRECISION ALPHA
      DIMENSION X(1),Y(1),SIGMAY(1),A(1),DELTAA(1),SIGMAA(1), 
     *YFIT(1)
      DIMENSION ALPHA(10,10),BETA(10),DA(10)
      REAL FUNCTN
      EXTERNAL FUNCTN
C 
11    NFREE=NPTS-NTERMS
      FREE=NFREE
      IF (NFREE) 14,14,16
14    CHISQR=0.
      GOTO 120
16    DO 17 I=1,NPTS
17    YFIT(I)=FUNCTN (X,I,A)
      CHISQ1=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C 
C EVALUATE ALPHA AND BETA MATRICES
C 
20    DO 60 J=1,NTERMS
C 
C A(J) + DELTAA(J)
C 
21    AJ=A(J) 
      A(J)=AJ+DELTAA(J)
      DO 24 I=1,NPTS
24    YFIT(I)=FUNCTN (X,I,A)
      CHISQ2=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
      ALPHA(J,J)=CHISQ2-2.*CHISQ1
      BETA(J)=-CHISQ2 
31    DO 50 K=1,NTERMS
      IF (K-J) 33,50,36
33    ALPHA(K,J)=(ALPHA(K,J)-CHISQ2)/2.
      ALPHA(J,K)=ALPHA(K,J)
      GOTO 50 
36    ALPHA(J,K)=CHISQ1-CHISQ2
C 
C A(J) + DELTAA(J) AND A(K) + DELTAA(K) 
C 
41    AK=A(K) 
      A(K)=AK+DELTAA(K)
      DO 44 I=1,NPTS
44    YFIT(I)=FUNCTN (X,I,A)
      CHISQ3=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
      ALPHA(J,K)=ALPHA(J,K)+CHISQ3
      A(K)=AK 
50    CONTINUE
C 
C A(J) - DELTAA(J)
C 
51    A(J)=AJ-DELTAA(J)
      DO 53 I=1,NPTS
53    YFIT(I)=FUNCTN (X,I,A)
      CHISQ3=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
      A(J)=AJ 
      ALPHA(J,J)=(ALPHA(J,J)+CHISQ3)/2.
      BETA(J)=(BETA(J)+CHISQ3)/4.
60    CONTINUE
C 
C ELIMINATE NEGATIVE CURVATURE
C 
61    DO 70 J=1,NTERMS
      IF (ALPHA(J,J)) 63,65,70
63    ALPHA(J,J)=-ALPHA(J,J)
      GOTO 66 
65    ALPHA(J,J)=0.01 
C Changed from DO 70
66    DO 700 K=1,NTERMS		
C Changed from 68, 70, 68
      IF (K-J) 68,700,68
68    ALPHA(J,K)=0.
      ALPHA(K,J)=0.
C New continuation statement
700   CONTINUE
70    CONTINUE
C 
C INVERT MATRIX AND EVALUATE PARAMETER INCREMENTS
C 
71    CALL MATINV (ALPHA,NTERMS,DET)
      DO 76 J=1,NTERMS
      DA(J)=0.
74    DO 75 K=1,NTERMS
75    DA(J)=DA(J)+BETA(K)*ALPHA(J,K)
76    DA(J)=0.2*DA(J)*DELTAA(J)
C 
C MAKE SURE CHI SQUARE DECREASES
C 
81    DO 82 J=1,NTERMS
82    A(J)=A(J)+DA(J) 
83    DO 84 I=1,NPTS
84    YFIT(I)=FUNCTN (X,I,A)
      CHISQ2=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
      IF (CHISQ1-CHISQ2) 87,91,91
87    DO 89 J=1,NTERMS
      DA(J)=DA(J)/2.
89    A(J)=A(J)-DA(J) 
      GOTO 83 
C 
C INCREMENT PARAMETERS UNTIL CHI SQUARE STARTS TO INCREASE
C 
91    DO 92 J=1,NTERMS
92    A(J)=A(J)+DA(J) 
      DO 94 I=1,NPTS
94    YFIT(I)=FUNCTN (X,I,A)
      CHISQ3=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
      IF (CHISQ3-CHISQ2) 97,101,101
97    CHISQ1=CHISQ2
      CHISQ2=CHISQ3
99    GOTO 91 
C 
C FIND MINIMUM OF PARABOLA DEFINED BY LAST THREE POINTS 
C 
101   DELTA=1./(1.+(CHISQ1-CHISQ2)/(CHISQ3-CHISQ2))+0.5
      DO 104 J=1,NTERMS
      A(J)=A(J)-DELTA*DA(J)
104   SIGMAA(J)=DELTAA(J)*SQRT(FREE*ALPHA(J,J))
      DO 106 I=1,NPTS 
106   YFIT(I)=FUNCTN (X,I,A)
      CHISQR=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
111   IF (CHISQ2-CHISQR) 112,120,120
112   DO 113 J=1,NTERMS
113   A(J)=A(J)+(DELTA-1.)*DA(J)
      DO 115 I=1,NPTS 
115   YFIT(I)=FUNCTN (X,I,A)
      CHISQR=CHISQ2
120   RETURN
      END

      REAL FUNCTION slRVLD (R2000, D2000)
*+
*     - - - - - - -
*      R V L D
*     - - - - - - -
*
*  Velocity component in a given direction due to the Sun's motion
*  with respect to the dynamical Local Standard of Rest.
*
*  (single precision)
*
*  Given:
*     R2000,D2000   r    J2000.0 mean RA,Dec (radians)
*
*  Result:
*     Component of "peculiar" solar motion in direction R2000,D2000 (km/s)
*
*  Sign convention:
*     The result is +ve when the Sun is receding from the given point on
*     the sky.
*
*  Note:  The Local Standard of Rest used here is the "dynamical" LSR,
*         a point in the vicinity of the Sun which is in a circular
*         orbit around the Galactic centre.  The Sun's motion with
*         respect to the dynamical LSR is called the "peculiar" solar
*         motion.
*
*         There is another type of LSR, called a "kinematical" LSR.  A
*         kinematical LSR is the mean standard of rest of specified star
*         catalogues or stellar populations, and several slightly
*         different kinematical LSRs are in use.  The Sun's motion with
*         respect to an agreed kinematical LSR is known as the "standard"
*         solar motion.  To obtain a radial velocity correction with
*         respect to an adopted kinematical LSR use the routine slRVLK.
*
*  Reference:  Delhaye (1965), in "Stars and Stellar Systems", vol 5,
*              p73.
*
*  Called:
*     slCS2C, slVDV
*
*  P.T.Wallace   Starlink   9 March 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL R2000,D2000

      REAL VA(3), VB(3)

      REAL slVDV

*
*  Peculiar solar motion from Delhaye 1965: in Galactic Cartesian
*  coordinates (+9,+12,+7) km/s.  This corresponds to about 16.6 km/s
*  towards Galactic coordinates L2 = 53 deg, B2 = +25 deg, or RA,Dec
*  17 49 58.7 +28 07 04 J2000.
*
*  The solar motion is expressed here in the form of a J2000.0
*  equatorial Cartesian vector:
*
*      VA(1) = X = -SPEED*COS(RA)*COS(DEC)
*      VA(2) = Y = -SPEED*SIN(RA)*COS(DEC)
*      VA(3) = Z = -SPEED*SIN(DEC)

      DATA VA / +0.63823, +14.58542, -7.80116 /



*  Convert given J2000 RA,Dec to x,y,z
      CALL slCS2C(R2000,D2000,VB)

*  Compute dot product with solar motion vector
      slRVLD=slVDV(VA,VB)

      END

#-h-  baderr			  144  local   12/01/80  15:53:45
# baderr --- report fatal error message, then die
   include  defs

   subroutine baderr (msg)

   character msg (ARB)
#      character*(*) msg

   call synerr (msg)
   call endst
   end

      subroutine outcon (n)
      integer n
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer contin(9)
      data contin(1)/99/,contin(2)/111/,contin(3)/110/,contin(4)/116/,co
     *ntin(5)/105/,contin(6)/110/,contin(7)/117/,contin(8)/101/,contin(9
     *)/-2/
      xfer = 0
      if (.not.(n .le. 0 .and. outp .eq. 0))goto 23000
      return
23000 continue
      if (.not.(n .gt. 0))goto 23002
      call outnum (n)
23002 continue
      call outtab
      call outstr (contin)
      call outdon
      return
      end
c     logic0  logical_column

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
c + noao: block data gridt changed to run time initialization
c       BLOCK DATA GRIDT
        subroutine gridt
C
C
        COMMON /LAB/ SIZX,SIZY,XDEC,YDEC,IXORI
        COMMON /CLAB/ XFMT, YFMT
        COMMON /TICK/ MAJX, MINX, MAJY, MINY
        COMMON /GRIINT/ IGRIMJ, IGRIMN, IGRITX
        CHARACTER*8 XFMT,YFMT
        REAL MAJX,MINX,MAJY,MINY
C
c +noao: following flag added to prevent initializing more than once
        logical first
        SAVE
        data first /.true./
        if (.not. first) then
            return
        endif
        first = .false.
C
c       DATA XFMT,YFMT /'(E10.3) ','(E10.3) '/
        XFMT = '(E10.3) '
        YFMT = '(E10.3) '
c
c       DATA SIZX,SIZY / 0.01, 0.01 /
        SIZX = 0.01
        SIZY = 0.01
c
c       DATA XDEC,YDEC / 0., 0. /
        XDEC = 0.
        YDEC = 0.
c
c       DATA IXORI / 0 /
        IXORI = 0 
c
c       DATA MAJX,MINX,MAJY,MINY / 0., 0., 0., 0./
        MAJX = 0.
        MINX = 0.
        MAJY = 0.
        MINY = 0.
c
c       DATA IGRIMJ,IGRIMN,IGRITX / 1, 1, 1/
c+noao: These values changed so major axes and labels are bold
        IGRIMJ = 2
        IGRIMN = 1
        IGRITX = 2
C - noao
        END
C REVISION HISTORY---------------
C----------------------------------------------------------

#-h-  whiles			  148  local   12/01/80  15:55:12
# whiles - generate code for end of while
   include  defs

   subroutine whiles (lab)

   integer lab
   include COMMON_BLOCKS

   call outgo (lab)
   call indent (-1)
   call outcon (lab + 1)
   return
   end

include	defs

# putdec - put decimal integer n in field width >= w

   subroutine putdec(n,w)
   integer n, w

   character chars (MAXCHARS)

   integer i, nd
   integer itoc

   nd = itoc (n, chars, MAXCHARS)
   for (i = nd + 1; i <= w; i = i + 1)
      call putc (BLANK)
   for (i = 1; i <= nd; i = i + 1)
      call putc (chars (i))

   return
   end

      SUBROUTINE TCONAS	(IERROR)
C
C LATEST REVISION	 AUGUST	1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 CONRAS, THE SUPER ENTRY  POINT	OF THE
C			 CONRAN	PACKAGE.
C
C USAGE			 CALL TCONAS (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   .EQ.	0, IF THE TEST WAS SUCCESSFUL,
C			   .NE.	0, OTHERWISE
C			   IF NOT ZERO THE NUMBER PRODUCED WILL
C			   CORRESPOND TO THE ERROR NUMBERS IN
C			   THE CONRAS LISTING.
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   CONRAS TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, TWO FRAMES CONTAINING THE	CONTOUR
C			 PLOT AND TRIANGULATION	OF THE DATA ARE	PRODUCED
C			 ON THE	DEFAULT	GRAPHICS DEVICE	UNLESS THE USER
C			 SPECIFIES OTHERWISE VIA JCL.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 CONRAS
C FILES			 CONTERP
C			 CONCOM
C			 DASHSUPR
C
C SPECIALIST		 FOR INFORMATION ABOUT THIS ROUTINE OR THE
C			 ULIB CONRAS PACKAGE, CONTACT THE SPECIALIST
C			 NAMED IN THE ULIB CONRAS PACKAGE.
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 A SPARSE DATA SET IS DEFINED VIA DATA
C			 STATEMENTS.  OPTIONS ARE SET TO PRODUCE A
C			 TITLE AND DISPLAY THE TRIANGULATION GENERATED
C			 BY THE	INTERPOLATING ROUTINES.	 BY DEFAULT
C			 A MESSAGE AT THE BOTTEM OF THE	PLOT AND A
C			 PERIMETER ARE ALSO PRODUCED.  THIS ROUTINE
C			 TAKES ADVANTAGE OF THE	PORT ERROR HANDLING
C			 ROUTINES TO DETERMINE IF CONRAS TERMINATED
C			 NORMALLY.
C
C PORTABILITY		 ANSI STANDARD
C
C
C  SET UP THE SCRATCH SPACES REQUIRED BY CONRAS
C
      DIMENSION	WK(221),IWK(744),SCR(1600)
C
C  SET UP THE ARRAYS TO	DEFINE THE DATA	SET
C
      DIMENSION	XD(17),YD(17),ZD(17)
	COMMON /RASINT/	IRASMJ,	IRASMN,	IRASTX
C
C DEFINE THE DATA SET
C
      DATA XD(1),XD(2),XD(3),XD(4),XD(5),XD(6),XD(7),XD(8),
     1	   XD(9),XD(10),XD(11),XD(12),XD(13),XD(14),XD(15),
     2	   XD(16),XD(17)
     3	   /3.,3.,10.,18.,18.,10.,10.,5.,1.,15.,20.,
     4		5.,15.,10.,7.,13.,16./
C
      DATA YD(1),YD(2),YD(3),YD(4),YD(5),YD(6),YD(7),YD(8),
     1	   YD(9),YD(10),YD(11),YD(12),YD(13),YD(14),YD(15),
     2	   YD(16),YD(17)
     3	  /3.,18.,18.,3.,18.,10.,1.,5.,10.,5.,10.,
     4		15.,15.,15.,20.,20.,8./
C
      DATA ZD(1),ZD(2),ZD(3),ZD(4),ZD(5),ZD(6),ZD(7),ZD(8),
     1	   ZD(9),ZD(10),ZD(11),ZD(12),ZD(13),ZD(14),ZD(15),
     2	   ZD(16),ZD(17)
     3	  /25.,25.,25.,25.,25.,-5.,1.,1.,1.,1.,1.,
     4		1.,1.,1.,1.,1.,25./
C
C  SET UP PARAMETER FOR	NUMBER OF INPUT	POINTS
C
      DATA NDP/17/
C
C  SET PORT ERROR HANDLING ROUTINE TO RECOVERY MODE
C
      CALL ENTSR(IROLD,1)
C
C  SET UP TITLE	 FOR PLOT
C
      CALL CONOP4('TLE=ON','DEMONSTRATION PLOT FOR CONRAS',29,0)
C
C  TEST	FOR ERROR
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C  NO ERROR
C
C  SET OPTION TO DISPLAY THE TRIANGULATION
C
      CALL CONOP1('TRI=ON')
C
C  TEST	FOR ERROR
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C  NO ERROR
C
C  CALL	CONRAS TO CONTOUR DATA
C
      CALL CONRAS(XD,YD,ZD,NDP,WK,IWK,SCR)
C
C  TEST	FOR ERROR
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C  NO ERROR
C
C
C  CALL	FRAME, CONRAS WILL NOT DO THIS
C
c	CALL NEWFM
C
C  PRINT MESSAGE EVERYTHING OK
C
c     WRITE(6,10)
c10   FORMAT(1X,'CONRAS	TEST SUCCESSFUL, SEE PLOT TO VERIFY ',
c    1'PERFORMANCE')
C
C
      RETURN
C
C  IF ERROR CALL THE PORT ERROR	PRINT ROUTINE.
C  THIS	CALL IS	NOT NECESSARY UNLESS YOU ARE IN	RECOVER	MODE.
C  IF YOU ARE NOT IN RECOVER MODE THE ERROR MESSAGE WILL  BE PRINTED
C  AUTOMATICALLY.
C
 100  CALL EPRIN
      RETURN
C
      END

      subroutine ldp (g,mdg,m,n,h,x,xnorm,w,index,ier)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1974 mar 1
c     to appear in 'solving least squares problems', prentice-hall, 1974
c
c	     **********  least distance programming  **********
c
      integer index(m)
      dimension g(mdg,n), h(m), x(n), w(1)
      zero=0.
      one=1.
      if (n.le.0) go to 120
	  do 10 j=1,n
   10	  x(j)=zero
      xnorm=zero
      if (m.le.0) go to 110
c
c     the declared dimension of w() must be at least (n+1)*(m+2)+2*m.
c
c      first (n+1)*m locs of w()   =  matrix e for problem nnls.
c	next	 n+1 locs of w()   =  vector f for problem nnls.
c	next	 n+1 locs of w()   =  vector z for problem nnls.
c	next	   m locs of w()   =  vector y for problem nnls.
c	next	   m locs of w()   =  vector wdual for problem nnls.
c     copy g**t into first n rows and m columns of e.
c     copy h**t into row n+1 of e.
c
      iw=0
	  do 30 j=1,m
	      do 20 i=1,n
	      iw=iw+1
   20	      w(iw)=g(j,i)
	  iw=iw+1
   30	  w(iw)=h(j)
      if=iw+1
c				 store n zeros followed by a one into f.
	  do 40 i=1,n
	  iw=iw+1
   40	  w(iw)=zero
      w(iw+1)=one
c
      np1=n+1
      iz=iw+2
      iy=iz+np1
      iwdual=iy+m
c
      call nnls (w,np1,np1,m,w(if),w(iy),rnorm,w(iwdual),w(iz),index,
     *		 ier)
c		       use the following return if unsuccessful in nnls.
      if (ier.ne.0) return
      if (rnorm) 130,130,50
   50 fac=one
      iw=iy-1
	  do 60 i=1,m
	  iw=iw+1
c				here we are using the solution vector y.
   60	  fac=fac-h(i)*w(iw)
c
      if (diff(one+fac,one)) 130,130,70
   70 fac=one/fac
	  do 90 j=1,n
	  iw=iy-1
	      do 80 i=1,m
	      iw=iw+1
c				here we are using the solution vector y.
   80	      x(j)=x(j)+g(i,j)*w(iw)
   90	  x(j)=x(j)*fac
	  do 100 j=1,n
  100	  xnorm=xnorm+x(j)**2
      xnorm=sqrt(xnorm)
c			      successful return.
  110 ier=0
      return
c			      error return.	  n .le. 0.
  120 ier=2
      return
c			      returning with constraints not compatible.
  130 ier=4
      return
      end

      subroutine relate (token, last)
      integer token (100)
      integer last
      integer ngetch
      integer length
      if (.not.(ngetch (token (2)) .ne. 61))goto 23000
      call putbak (token (2))
      token (3) = 116
      goto 23001
23000 continue
      token (3) = 101
23001 continue
      token (4) = 46
      token (5) = -2
      token (6) = -2
      if (.not.(token (1) .eq. 62))goto 23002
      token (2) = 103
      goto 23003
23002 continue
      if (.not.(token (1) .eq. 60))goto 23004
      token (2) = 108
      goto 23005
23004 continue
      if (.not.(token (1) .eq. 126 .or. token (1) .eq. 33 .or. token (1)
     * .eq. 94 .or. token (1) .eq. 126))goto 23006
      if (.not.(token (2) .ne. 61))goto 23008
      token (3) = 111
      token (4) = 116
      token (5) = 46
23008 continue
      token (2) = 110
      goto 23007
23006 continue
      if (.not.(token (1) .eq. 61))goto 23010
      if (.not.(token (2) .ne. 61))goto 23012
      token (2) = -2
      last = 1
      return
23012 continue
      token (2) = 101
      token (3) = 113
      goto 23011
23010 continue
      if (.not.(token (1) .eq. 38))goto 23014
      token (2) = 97
      token (3) = 110
      token (4) = 100
      token (5) = 46
      goto 23015
23014 continue
      if (.not.(token (1) .eq. 124))goto 23016
      token (2) = 111
      token (3) = 114
      goto 23017
23016 continue
      token (2) = -2
23017 continue
23015 continue
23011 continue
23007 continue
23005 continue
23003 continue
      token (1) = 46
      last = length (token)
      return
      end

C--------------------------------------------------------------------------
        subroutine ftitab(ounit,rowlen,nrows,nfield,ttype,tbcol,
     &                    tform,tunit,extnam,status)

C       insert an ASCII table extension following the current HDU 

C       ounit   i  fortran output unit number
C       rowlen  i  width of a row, in characters
C       nrows   i  number of rows in the table
C       nfield  i  number of fields in the table
C       ttype   c  name of each field (array) (optional)
C       tform   c  format of each field (array)
C       tunit   c  units of each field (array) (optional)
C       extnam  c  name of table extension (optional)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,rowlen,nrows,nfield,tbcol(*),status
        character*(*) ttype(*),tform(*),tunit(*),extnam

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS:------------------------------------

        integer ibuff,nhdu,i,savstr,nblock,hsize,nkey

        if (status .gt. 0)return
        ibuff=bufnum(ounit)

C       close the current HDU to make sure END and fill values are written
        call ftchdu(ounit,status)
        if (status .gt. 0)return

C       save the starting address of the next HDU
        nhdu=chdu(ibuff)+1
        savstr=hdstrt(ibuff,nhdu)

C       count number of optional TUNITS keywords to be written
        nkey=0
        do 5 i=1,nfield
               if (tunit(i) .ne. ' ')nkey=nkey+1
5       continue
        if (extnam .ne. ' ')nkey=nkey+1
    
C       calc min size of header
        nblock=(9 + 3*nfield + nkey +35)/36
        hsize=nblock*2880

C       define a fake CHDU with minimum header
        dtstrt(ibuff)=hdstrt(ibuff,chdu(ibuff))+hsize

C       define the size of the new HDU (this modifies hdstrt(ibuff,nhdu))
        call ftadef(ounit,rowlen,nfield,tbcol,tform,nrows,status)

C       use start of next HDU to calc. how big this new HDU is
        nblock=(hdstrt(ibuff,nhdu)-hdstrt(ibuff,nhdu-1))/2880

C       reset the start of the next HDU back to it original value
        hdstrt(ibuff,nhdu)=savstr

C       insert the required number of blocks at the end of the real CHDU
C       (first define hdutyp so that the correct fill value will be used) 
        hdutyp(ibuff)=1
        call ftiblk(ounit,nblock,1,status)
        if (status .gt. 0)return

C       increment the number of HDUs in the file and their starting address
        maxhdu(ibuff)=maxhdu(ibuff)+1
        do 10 i=maxhdu(ibuff),nhdu,-1
                hdstrt(ibuff,i+1)=hdstrt(ibuff,i)
10      continue

C       again, reset the start of the next HDU back to it original value
        hdstrt(ibuff,nhdu)=savstr

C       flush the buffers holding data for the old HDU
        call ftflsh(ibuff,status)

C       recover common block space containing column descriptors for old HDU
        call ftfrcl(ounit,status)

C       move to the new (empty) HDU
        chdu(ibuff)=nhdu

C       set parameters describing an empty header
        hdutyp(ibuff)=1
        nxthdr(ibuff)=hdstrt(ibuff,nhdu)
        hdend(ibuff)= hdstrt(ibuff,nhdu)
        dtstrt(ibuff)=hdstrt(ibuff,nhdu)+hsize

C       write the header keywords
        call ftphtb(ounit,rowlen,nrows,nfield,ttype,tbcol,tform,tunit,
     &              extnam,status)

C       define the structure of the new HDU
        call ftadef(ounit,rowlen,nfield,tbcol,tform,nrows,status)
        end

include defs

# POICOD -- Called to process a declaration of type "pointer".

subroutine poicod (declare_variable)

integer	declare_variable
include COMMON_BLOCKS
string	spointer XPOINTER

# Fortran declarations for the MEM common.
string	p1	"logical Memb(1024)"
string	p2	"integer*2 Memc(1024)"
string	p3	"integer*2 Mems(1024)"
string	p4	"integer Memi(1024)"
string	p5	"integer Meml(1024)"
string	p6	"real Memr(1024)"
string	p7	"double precision Memd(1024)"
string	p8	"complex Memx(1024)"
string	p9	"equivalence (Memb, Memc, Mems, Memi, Meml, Memr, Memd, Memx)"
string	pa	"common /Mem/ Memd"

	# Output declarations only once per procedure declarations section.
	# The flag memflg is cleared when processing of a procedure begins.

	if (memflg == NO) {
	    call poidec (p1)
	    call poidec (p2)
	    call poidec (p3)
	    call poidec (p4)
	    call poidec (p5)
	    call poidec (p6)
	    call poidec (p7)
	    call poidec (p8)
	    call poidec (p9)
	    call poidec (pa)
	    memflg = YES
	}

	if (declare_variable == YES) {
	    call outtab
	    call outstr (spointer)
	}
end


# POIDEC -- Output a poicod declaration statement.

subroutine poidec (str)

character str

	call outtab
	call outstr (str)
	call outdon
end

      DOUBLE PRECISION FUNCTION slDSEP (A1, B1, A2, B2)
*+
*     - - - - -
*      D S E P
*     - - - - -
*
*  Angle between two points on a sphere.
*
*  (double precision)
*
*  Given:
*     A1,B1    d     spherical coordinates of one point
*     A2,B2    d     spherical coordinates of the other point
*
*  (The spherical coordinates are [RA,Dec], [Long,Lat] etc, in radians.)
*
*  The result is the angle, in radians, between the two points.  It
*  is always positive.
*
*  Called:  slDS2C, slDSEPV
*
*  Last revision:   7 May 2000
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION A1,B1,A2,B2

      DOUBLE PRECISION V1(3),V2(3)
      DOUBLE PRECISION slDSEPV



*  Convert coordinates from spherical to Cartesian.
      CALL slDS2C(A1,B1,V1)
      CALL slDS2C(A2,B2,V2)

*  Angle between the vectors.
      slDSEP = slDSEPV(V1,V2)

      END

C--------------------------------------------------------------------------
        subroutine ftp3de(ounit,group,dim1,dim2,nx,ny,nz,array,status)

C       Write a 3-d cube of r*4 values into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being written).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       dim1    i  actual first dimension of ARRAY
C       dim2    i  actual second dimension of ARRAY
C       nx      i  size of the cube in the x direction
C       ny      i  size of the cube in the y direction
C       nz      i  size of the cube in the z direction
C       array   r  the array of values to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,dim1,dim2,nx,ny,nz,status
        real array(dim1,dim2,*)
        integer fpixel,row,band

        fpixel=1
        do 20 band=1,nz
        do 10 row = 1,ny
            call ftppre(ounit,group,fpixel,nx,array(1,row,band),status)
            fpixel=fpixel+nx
10      continue
20      continue

        end

      SUBROUTINE slPLMO ( ELONGM, PHIM, XP, YP, ELONG, PHI, DAZ )
*+
*     - - - - - -
*      P L M O
*     - - - - - -
*
*  Polar motion:  correct site longitude and latitude for polar
*  motion and calculate azimuth difference between celestial and
*  terrestrial poles.
*
*  Given:
*     ELONGM   d      mean longitude of the observer (radians, east +ve)
*     PHIM     d      mean geodetic latitude of the observer (radians)
*     XP       d      polar motion x-coordinate (radians)
*     YP       d      polar motion y-coordinate (radians)
*
*  Returned:
*     ELONG    d      true longitude of the observer (radians, east +ve)
*     PHI      d      true geodetic latitude of the observer (radians)
*     DAZ      d      azimuth correction (terrestrial-celestial, radians)
*
*  Notes:
*
*   1)  "Mean" longitude and latitude are the (fixed) values for the
*       site's location with respect to the IERS terrestrial reference
*       frame;  the latitude is geodetic.  TAKE CARE WITH THE LONGITUDE
*       SIGN CONVENTION.  The longitudes used by the present routine
*       are east-positive, in accordance with geographical convention
*       (and right-handed).  In particular, note that the longitudes
*       returned by the slOBS routine are west-positive, following
*       astronomical usage, and must be reversed in sign before use in
*       the present routine.
*
*   2)  XP and YP are the (changing) coordinates of the Celestial
*       Ephemeris Pole with respect to the IERS Reference Pole.
*       XP is positive along the meridian at longitude 0 degrees,
*       and YP is positive along the meridian at longitude
*       270 degrees (i.e. 90 degrees west).  Values for XP,YP can
*       be obtained from IERS circulars and equivalent publications;
*       the maximum amplitude observed so far is about 0.3 arcseconds.
*
*   3)  "True" longitude and latitude are the (moving) values for
*       the site's location with respect to the celestial ephemeris
*       pole and the meridian which corresponds to the Greenwich
*       apparent sidereal time.  The true longitude and latitude
*       link the terrestrial coordinates with the standard celestial
*       models (for precession, nutation, sidereal time etc).
*
*   4)  The azimuths produced by slAOP and slAOPQ are with
*       respect to due north as defined by the Celestial Ephemeris
*       Pole, and can therefore be called "celestial azimuths".
*       However, a telescope fixed to the Earth measures azimuth
*       essentially with respect to due north as defined by the
*       IERS Reference Pole, and can therefore be called "terrestrial
*       azimuth".  Uncorrected, this would manifest itself as a
*       changing "azimuth zero-point error".  The value DAZ is the
*       correction to be added to a celestial azimuth to produce
*       a terrestrial azimuth.
*
*   5)  The present routine is rigorous.  For most practical
*       purposes, the following simplified formulae provide an
*       adequate approximation:
*
*       ELONG = ELONGM+XP*COS(ELONGM)-YP*SIN(ELONGM)
*       PHI   = PHIM+(XP*SIN(ELONGM)+YP*COS(ELONGM))*TAN(PHIM)
*       DAZ   = -SQRT(XP*XP+YP*YP)*COS(ELONGM-ATAN2(XP,YP))/COS(PHIM)
*
*       An alternative formulation for DAZ is:
*
*       X = COS(ELONGM)*COS(PHIM)
*       Y = SIN(ELONGM)*COS(PHIM)
*       DAZ = ATAN2(-X*YP-Y*XP,X*X+Y*Y)
*
*   Reference:  Seidelmann, P.K. (ed), 1992.  "Explanatory Supplement
*               to the Astronomical Almanac", ISBN 0-935702-68-7,
*               sections 3.27, 4.25, 4.52.
*
*  P.T.Wallace   Starlink   30 November 2000
*
*  Copyright (C) 2000 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION ELONGM,PHIM,XP,YP,ELONG,PHI,DAZ

      DOUBLE PRECISION SEL,CEL,SPH,CPH,XM,YM,ZM,XNM,YNM,ZNM,
     :                 SXP,CXP,SYP,CYP,ZW,XT,YT,ZT,XNT,YNT



*  Site mean longitude and mean geodetic latitude as a Cartesian vector
      SEL=SIN(ELONGM)
      CEL=COS(ELONGM)
      SPH=SIN(PHIM)
      CPH=COS(PHIM)

      XM=CEL*CPH
      YM=SEL*CPH
      ZM=SPH

*  Rotate site vector by polar motion, Y-component then X-component
      SXP=SIN(XP)
      CXP=COS(XP)
      SYP=SIN(YP)
      CYP=COS(YP)

      ZW=(-YM*SYP+ZM*CYP)

      XT=XM*CXP-ZW*SXP
      YT=YM*CYP+ZM*SYP
      ZT=XM*SXP+ZW*CXP

*  Rotate also the geocentric direction of the terrestrial pole (0,0,1)
      XNM=-SXP*CYP
      YNM=SYP
      ZNM=CXP*CYP

      CPH=SQRT(XT*XT+YT*YT)
      IF (CPH.EQ.0D0) XT=1D0
      SEL=YT/CPH
      CEL=XT/CPH

*  Return true longitude and true geodetic latitude of site
      IF (XT.NE.0D0.OR.YT.NE.0D0) THEN
         ELONG=ATAN2(YT,XT)
      ELSE
         ELONG=0D0
      END IF
      PHI=ATAN2(ZT,CPH)

*  Return current azimuth of terrestrial pole seen from site position
      XNT=(XNM*CEL+YNM*SEL)*ZT-ZNM*CPH
      YNT=-XNM*SEL+YNM*CEL
      IF (XNT.NE.0D0.OR.YNT.NE.0D0) THEN
         DAZ=ATAN2(-YNT,-XNT)
      ELSE
         DAZ=0D0
      END IF

      END

C--------------------------------------------------------------------------
        subroutine ftgthd(tmplat,card,hdtype,status)

C       'Get Template HeaDer'
C       parse a template header line and create a formated
C       80-character string which is suitable for appending to a FITS header 

C       tmplat  c  input header template string
C       card    c  returned 80-character string = FITS header record
C       hdtype  i  type of operation that should be applied to this keyword:
C                      -2  =  modify the name of a keyword; the new name
C                             is returned in characters 41:48 of CARD.
C                      -1  =  delete this keyword 
C                       0  =  append (if it doesn't already exist) or 
C                             overwrite this keyword (if it does exist)
C                       1  =  append this comment keyword ('HISTORY', 
C                             'COMMENT', or blank keyword name) 
C                       2  =  this is an END record; do not append it
C                             to a FITS header! 
C       status  i  returned error status 
C               if a positive error status is returned then the first 
C               80 characters of the offending input line are returned
C               by the CARD parameter

        integer hdtype,status,tstat
        character*(*) tmplat
        character*80 card
        integer i1,i2,com1,strend,length
        character inline*100,keynam*8,ctemp*80,qc*1
        logical number
        double precision dvalue

        if (status .gt. 0)return
        card=' '
        hdtype=0

        inline=tmplat

C       test if columns 1-8 are blank; if so, this is a FITS comment record;
C       just copy it verbatim to the FITS header
        if (inline(1:8) .eq. ' ')then
                card=inline(1:80)
                go to 999
        end if

C       parse the keyword name = the first token separated by a space or a '='
C       1st locate the first nonblank character (we know it is not all blank):
        i1=0
20      i1=i1+1
C       test for a leading minus sign which flags name of keywords to be deleted
        if (inline(i1:i1) .eq. '-')then
                hdtype=-1
C               test for a blank keyword name
                if (inline(i1+1:i1+8) .eq. '        ')then
                       card=' '
                       i2=i1+9
                       go to 35
                end if
                go to 20
        else if (inline(i1:i1) .eq. ' ')then
                go to 20
        end if

C       now find the last character of the keyword name
        i2=i1
30      i2=i2+1
        if (inline(i2:i2) .ne. ' ' .and. inline(i2:i2) .ne. '=')go to 30

C       test for legal keyword name length (max 8 characters)
        if (i2-i1 .gt. 8)then
                status=207
                card=inline(1:80)
                go to 999
        end if

        keynam=inline(i1:i2-1)

C       convert to upper case and test for illegal characters in keyword name
        call ftupch(keynam)
        call fttkey(keynam,status)
        if (status .gt. 0)then
                card=inline(1:80)
                go to 999
        end if

C       if this is the 'END' then this is the end of the input file
        if (keynam .eq. 'END     ')goto 998

C       copy the keyword name to the output record string
        card(1:8)=keynam

C       jump if this is just the name of keyword to be deleted
        if (hdtype .lt. 0)go to 35

C       test if this is a COMMENT or HISTORY record
        if (keynam .eq. 'COMMENT' .or. keynam .eq. 'HISTORY')then
C               append next 72 characters from input line to output record
                card(9:80)=inline(i2:)
                hdtype=1
                go to 999
        else
C               this keyword must have a value, so append the '= ' to output
                card(9:10)='= '
        end if

C       now locate the value token in the input line.  If it includes
C       embedded spaces it must be enclosed in single quotes. The value must
C       be separated by at least one blank space from the comment string

C       find the first character of the value string
35      i1=i2-1
40      i1=i1+1
        if (i1 .gt. 100)then
C               no value is present in the input line
                if (hdtype .lt. 0)then
C                       this is normal; just quit
                        go to 999
                else
                        status=204
                        card=inline(1:80)
                        go to 999
                end if
        end if
        if (hdtype .lt. 0 .and. inline(i1:i1) .eq. '=')then
C               The leading minus sign, plus the presence of an equal sign
C               between the first 2 tokens is taken to mean that the
C               keyword with the first token name is to be deleted.
                go to 999
        else if (inline(i1:i1).eq. ' ' .or.inline(i1:i1).eq. '=')then 
                go to 40
        end if

C       is the value a quoted string?
        if (inline(i1:i1) .eq. '''')then
C               find the closing quote 
                i2=i1
50              i2=i2+1
                if (i2 .gt. 100)then
C                       error: no closing quote on value string
                        status=205
                        card=inline(1:80)
            call ftpmsg('Keyword value string has no closing quote:')
            call ftpmsg(card)
                        go to 999
                end if
                if (inline(i2:i2) .eq. '''')then
                        if (inline(i2+1:i2+1) .eq. '''')then
C                               ignore 2 adjacent single quotes
                                i2=i2+1
                                go to 50
                        end if
                else
                        go to 50
                end if
C               value string can't be more than 70 characters long (cols 11-80)
                length=i2-i1
                if (length .gt. 69)then
                        status=205
                        card=inline(1:80)
            call ftpmsg('Keyword value string is too long:')
            call ftpmsg(card)
                        go to 999
                end if

C               append value string to output, left justified in column 11
                card(11:11+length)=inline(i1:i2)
C               com1 is the starting position for the comment string
                com1=max(32,13+length)

C               FITS string must be at least 8 characters long
                if (length .lt. 9)then
                        card(11+length:11+length)=' '
                        card(20:20)=''''
                end if
        else
C               find the end of the value field
                i2=i1
60              i2=i2+1
                if (i2 .gt. 100)then
C                       error: value string is too long
                        status=205
                        card=inline(1:80)
            call ftpmsg('Keyword value string is too long:')
            call ftpmsg(card)
                        go to 999
                end if
                if (inline(i2:i2) .ne. ' ')go to 60

C               test if this is a logical value
                length=i2-i1
                if (length .eq. 1 .and. (inline(i1:i1) .eq. 'T'
     &              .or. inline(i1:i1) .eq. 'F'))then
                        card(30:30)=inline(i1:i1)
                        com1=32
                else
C                   test if this is a numeric value; try reading it as 
C                   double precision value; if it fails, it must be a string
                    number=.true.
                    tstat=status
                    call ftc2dd(inline(i1:i2-1),dvalue,status)
                    if (status .gt. 0)then
                        status=tstat
                        number=.false.
                    else
C                       check the first character to make sure this is a number
C                       since certain non-numeric character strings pass the
C                       above test on SUN machines.
                        qc=inline(i1:i1)
                        if (qc .ne. '+' .and. qc .ne. '-' .and. qc .ne.
     &                  '.' .and. (qc .lt. '0' .or. qc .gt. '9'))then
C                              This really was not a number!
                               number=.false.
                        end if
                    end if

                    if (number)then
                        if (length .le. 20)then
C                               write the value right justified in col 30
                                card(31-length:30)=inline(i1:i2-1)
                                com1=32
                        else
C                               write the long value left justified in col 11
                                card(11:10+length)=inline(i1:i2-1)
                                com1=max(32,12+length)
                        end if
                    else
C                       value is a character string datatype
                        card(11:11)=''''
                        strend=11+length
                        card(12:strend)=inline(i1:i2-1)
C                       need to expand any embedded single quotes into 2 quotes
                        i1=11
70                      i1=i1+1
                        if (i1 .gt. strend) go to 80
                        if (card(i1:i1) .eq. '''')then
                                i1=i1+1
                                if (card(i1:i1) .ne. '''')then
C                                       have to insert a 2nd quote into string
                                        ctemp=card(i1:strend)
                                        card(i1:i1)=''''
                                        strend=strend+1
                                        i1=i1+1
                                        card(i1:strend)=ctemp
                                end if
                        end if
                        go to 70

80                      strend=max(20,strend+1)
                        card(strend:strend)=''''
                        com1=max(32,strend+2)
                    end if
                end if
        end if
        
C       check if this was a request to modify a keyword name
        if (hdtype .eq. -1)then
                hdtype = -2
C               the keyword value is really the new keyword name
C               return the new name in characters 41:48 of the output card
                keynam=card(12:19)
C               convert to upper case and test for illegal characters in name
                call ftupch(keynam)
                call fttkey(keynam,status)
                if (status .gt. 0)then
                        card=inline(1:80)
                        go to 999
                else
                        card(9:80)=' '
                        card(41:48)=keynam
                        go to 999
                end if
        end if

C       is there room for a comment string?
        if (com1 .lt. 79)then
C               now look for the beginning of the comment string
                i1=i2
90              i1=i1+1
C               if no comment field then just quit
                if (i1 .gt. 100)go to 999
                if (inline(i1:i1) .eq. ' ')go to 90

C               append the comment field
                if (inline(i1:i1) .eq. '/')then
                        card(com1:80)=inline(i1:)
                else
                        card(com1:80)='/ '//inline(i1:)
                end if
        end if

        go to 999

C       end of input file was detected
998     hdtype=2

999     continue
        end

#-h-  entdef			  387  local   12/01/80  15:53:51
# entdef - enter a new symbol definition, discarding any old one
   include  defs

   subroutine entdef (name, defn, table)
   character name (MAXTOK), defn (ARB)
   pointer table

   integer lookup

   pointer text
   pointer sdupl

   if (lookup (name, text, table) == YES)
      call dsfree (text)   # this is how to do UNDEFINE, by the way
   call enter (name, sdupl (defn), table)

   return
   end

C----------------------------------------------------------------------
        subroutine ftgcxi(iunit,colnum,frow,nrow,fbit,nbit,
     &                    ivalue,status)

C       read any consecutive bits from an 'X' or 'B' column as an unsigned
C       n-bit integer, unless nbits=16 in which case the 16 bits
C       are interpreted as a 16-bit signed 2s complement word

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       nrow    i  number of rows to read
C       fbit    i  first bit within the row to read
C       nbit    i  number of bits to read
C       ivalue  i*2  returned integer value(s)
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Nov 1994

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer iunit,colnum,fbit,nbit,frow,nrow,status,i,j,k,row,ibuff
        integer*2 ivalue(*),ival,power2(16)
        logical lray(16)
        save power2
        data power2/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     &  16384,0/

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

        if (nbit .gt. 16)then
            call ftpmsg('Cannot read more than 16 bits (ftgcxi)')
            status=308
            return
        else if ((fbit+nbit+6)/8 .gt. trept(colnum+tstart(ibuff)))then
            call ftpmsg('Asked to read more bits than exist in'//
     &      ' the column (ftgcxi)')
            status=308
            return
        end if


        row=frow-1
        do 30 k=1,nrow
            row=row+1
C           get the individual bits
            call ftgcx(iunit,colnum,row,fbit,nbit,lray,status)
            if (status .gt. 0)return
            ival=0
            j=0
            if (nbit .eq. 16 .and. lray(1))then
C               interprete this as a 16 bit negative integer
                do 10 i=16,2,-1
                    j=j+1
                    if (.not. lray(i))ival=ival+power2(j)
10              continue
C               make 2's complement
                ivalue(k)=-ival-1
            else
C               reconstruct the positive integer value
                do 20 i=nbit,1,-1
                    j=j+1
                    if (lray(i))ival=ival+power2(j)
20              continue
                ivalue(k)=ival
            end if
30      continue
        end

include	defs

# amatch --- (non-recursive) look for match starting at lin (from)

   integer function amatch (lin, from, pat, tagbeg, tagend)
   character lin (MAXLINE), pat (MAXPAT)
   integer from, tagbeg (10), tagend (10)

   integer i, j, offset, stack
   integer omatch, patsiz

   for (i = 1; i <= 10; i = i + 1) {
      tagbeg (i) = 0
      tagend (i) = 0
      }
   tagbeg (1) = from
   stack = 0
   offset = from      # next unexamined input character
   for (j = 1; pat (j) != EOS; j = j + patsiz (pat, j))
      if (pat (j) == CLOSURE) {      # a closure entry
	 stack = j
	 j = j + CLOSIZE      # step over CLOSURE
	 for (i = offset; lin (i) != EOS; )	 # match as many as
	    if (omatch (lin, i, pat, j) == NO)	 # possible
	       break
	 pat (stack + COUNT) = i - offset
	 pat (stack + START) = offset
	 offset = i	 # character that made us fail
	 }
      else if (pat (j) == START_TAG) {
	 i = pat (j + 1)
	 tagbeg (i + 1) = offset
	 }
      else if (pat (j) == STOP_TAG) {
	 i = pat (j + 1)
	 tagend (i + 1) = offset
	 }
      else if (omatch (lin, offset, pat, j) == NO) {  # non-closure
	 for ( ; stack > 0; stack = pat (stack + PREVCL))
	    if (pat (stack + COUNT) > 0)
	       break
	 if (stack <= 0) {	# stack is empty
	    amatch = 0	    # return failure
	    return
	    }
	 pat (stack + COUNT) = pat (stack + COUNT) - 1
	 j = stack + CLOSIZE
	 offset = pat (stack + START)  +  pat (stack + COUNT)
	 }
      # else omatch succeeded

   amatch = offset
   tagend (1) = offset
   return      # success
   end

      SUBROUTINE ENCD (VALU,ASH,IOUT,NC,IOFFD)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C
C
C ON INPUT     VALU      FLOATING POINT NUMBER FROM WHICH THE LABEL IS
C                        TO BE CREATED.
C              ASH       SEE IOFFD.
C              IOFFD     IF IOFFD .EQ. 0, A LABEL WHICH REFLECTS THE
C                             MAGNITUDE OF VALU IS TO BE CREATED.
C                             .1 .LE. ABS(VALU) .LE. 99999.49999...
C                             OR VALUE .EQ. 0.0.  THE LABEL CREATED
C                             SHOULD HAVE 3 TO 5 CHARACTERS DEPENDING
C                             ON THE MAGNITUDE OF VALU.  SEE IOUT.
C                        IF IOFFD .NE. 0, A LABEL WHICH DOES NOT REFLECT
C                             THE MAGNITUDE OF VALU IS TO BE CREATED.
C                             ASH IS USED AS THE NORMALIZATION FACTOR.
C                             1. .LE. ASH*ABS(VALU) .LT. 1000. OR
C                             VALU .EQ. 0.0.  THE LABEL CREATED SHOULD
C                             HAVE 1 TO 3 CHARACTERS, DEPENDING ON THE
C                             MAGNITUDE OF ASH*VALU.  SEE IOUT.
C ON OUTPUT    IOUT      CONTAINS THE LABEL CREATED.  IT SHOULD HAVE NO
C                        LEADING BLANKS.  SEE NC.
C              NC        THE NUMBERS IN THE LABEL IN IOUT.  SHOULD BE
C                        1 TO 5.
C
      SAVE
      CHARACTER*11 IFMT
      CHARACTER*(*) IOUT
C
C IFMT MUST HOLD 11 CHARACTERS
C
      VAL = VALU
      IF (IOFFD .NE. 0) GO TO 103
      IF (VAL) 101,104,101
  101 LOG = IFIX((ALOG10(ABS(VAL))+.00001)+5000.)-5000
      V = VAL
      NS = MAX0(4,MIN0(6,LOG+2))
      ND = MIN0(3,MAX0(0,2-LOG))
c     IF (VAL.LT.0)  NS = NS + 1
c + NOAO - replacing ftn i/o for iraf implementation
c 102 WRITE (IFMT,'(A2,I2,A1,I1,A1)') '(F',NS,'.',ND,')'
  102 continue
      ifmt(1:6) = '(f . )'
      ifmt(3:3) = char (ns + ichar ('0'))
      ifmt(5:5) = char (nd + ichar ('0'))
c     WRITE (IOUT,IFMT) V
      call encode (ns, ifmt, iout, v)
      NC = NS
c + NOAO
c The following statement was making 5 digit labels (+4800) come out
c truncated (+480) and it has been commented out.
c     IF (LOG.GE.3)  NC = NC - 1
c - NOAO
      RETURN
  103 NS = 4
      IF (VAL.LT.0.)  NS=5
      IF (VAL.EQ.0.)  NS=2
      ND = 0
      V = VAL*ASH
      LOG = 100
      GO TO 102
  104 iout(1:3) = '0.0'
      nc = 3
c 104 NS = 3
c     ND = 1
c     LOG = -100
c     V = 0.
c     GO TO 102
C
C1001 FORMAT('(F',I2,'.',I1,',1H',A1,')')
C
      END
C
      SUBROUTINE ENCODE (NCHARS, FTNFMT, FTNOUT, RVAL)

      INTEGER SZFMT, SZBUF
      PARAMETER (SZFMT=11)
      PARAMETER (SZBUF=15)

      CHARACTER*(*) FTNFMT
      CHARACTER*(*) FTNOUT
      INTEGER*2 SPPFMT(SZFMT), SPPOUT(SZBUF)

C UNPACK THE FORTRAN CHARACTER STRING, CALL FENCD TO ACTUALLY ENCODE THE
C OUTPUT STRING, THEN PACK THE OUTPUT STRING INTO A FORTRAN STRING FOR RETURN
C
      CALL F77UPK (FTNFMT, SPPFMT, SZFMT)
      CALL FENCD (NCHARS, SPPFMT, SPPOUT, RVAL)
      CALL F77PAK (SPPOUT, FTNOUT, NCHARS)

      END
C
C PACKAGE ERPRT77        DESCRIPTION OF INDIVIDUAL USER ENTRIES
C                        FOLLOWS THIS PACKAGE DESCRIPTION.
C
C LATEST REVISION        FEBRUARY 1985
C
C PURPOSE                TO PROVIDE A PORTABLE, FORTRAN 77 ERROR
C                        HANDLING PACKAGE.
C
C USAGE                  THESE ROUTINES ARE INTENDED TO BE USED IN
C                        THE SAME MANNER AS THEIR SIMILARLY NAMED
C                        COUNTERPARTS ON THE PORT LIBRARY.  EXCEPT
C                        FOR ROUTINE SETER, THE CALLING SEQUENCES
C                        OF THESE ROUTINES ARE THE SAME AS FOR
C                        THEIR PORT COUNTERPARTS.
C                        ERPRT77 ENTRY          PORT ENTRY
C                        -------------          ----------
C                        ENTSR                  ENTSRC
C                        RETSR                  RETSRC
C                        NERRO                  NERROR
C                        ERROF                  ERROFF
C                        SETER                  SETERR
C                        EPRIN                  EPRINT
C                        FDUM                   FDUMP
C
C I/O                    SOME OF THE ROUTINES PRINT ERROR MESSAGES.
C
C PRECISION              NOT APPLICABLE
C
C REQUIRED LIBRARY       MACHCR, WHICH IS LOADED BY DEFAULT ON
C FILES                  NCAR'S CRAY MACHINES.
C
C LANGUAGE               FORTRAN 77
C
C HISTORY                DEVELOPED OCTOBER, 1984 AT NCAR IN BOULDER,
C                        COLORADO BY FRED CLARE OF THE SCIENTIFIC
C                        COMPUTING DIVISION BY ADAPTING THE NON-
C                        PROPRIETARY, ERROR HANDLING ROUTINES
C                        FROM THE PORT LIBRARY OF BELL LABS.
C
C PORTABILITY            FULLY PORTABLE
C
C REFERENCES             SEE THE MANUAL
C                          PORT MATHEMATICAL SUBROUTINE LIBRARY
C                        ESPECIALLY "ERROR HANDLING" IN SECTION 2
C                        OF THE INTRODUCTION, AND THE VARIOUS
C                        SUBROUTINE DESCRIPTIONS.
C ******************************************************************
C
C SUBBROUTINE ENTSR(IROLD,IRNEW)
C
C PURPOSE               SAVES THE CURRENT RECOVERY MODE STATUS AND
C                       SETS A NEW ONE.  IT ALSO CHECKS THE ERROR
C                       STATE, AND IF THERE IS AN ACTIVE ERROR
C                       STATE A MESSAGE IS PRINTED.
C
C USAGE                 CALL ENTSR(IROLD,IRNEW)
C
C ARGUMENTS
C
C ON INPUT               IRNEW
C                          VALUE SPECIFIED BY USER FOR ERROR
C                          RECOVERY
C                          = 0 LEAVES RECOVERY UNCHANGED
C                          = 1 GIVES  RECOVERY
C                          = 2 TURNS  RECOVERY OFF
C
C ON OUTPUT              IROLD
C                          RECEIVES THE CURRENT VALUE OF THE ERROR
C                          RECOVERY MODE
C
C SPECIAL CONDITIONS     IF THERE IS AN ACTIVE ERROR STATE, THE
C                        MESSAGE IS PRINTED AND EXECUTION STOPS.
C
C                        ERROR STATES -
C                        1 - ILLEGAL VALUE OF IRNEW.
C                        2 - CALLED WHILE IN AN ERROR STATE.
C ******************************************************************
C
C SUBROUTINE RETSR(IROLD)
C
C PURPOSE                SETS THE RECOVERY MODE TO THE STATUS GIVEN
C                        BY THE INPUT ARGUMENT.  A TEST IS THEN MADE
C                        TO SEE IF A CURRENT ERROR STATE EXISTS WHICH
C                        IS UNRECOVERABLE; IF SO, RETSR PRINTS AN
C                        ERROR MESSAGE AND TERMINATES THE RUN.
C
C                        BY CONVENTION, RETSR IS USED UPON EXIT
C                        FROM A SUBROUTINE TO RESTORE THE PREVIOUS
C                        RECOVERY MODE STATUS STORED BY ROUTINE
C                        ENTSR IN IROLD.
C
C USAGE                  CALL RETSR(IROLD)
C
C ARGUMENTS
C
C ON INPUT               IROLD
C                          = 1 SETS FOR RECOVERY
C                          = 2 SETS FOR NONRECOVERY
C
C ON OUTPUT              NONE
C
C SPECIAL CONDITIONS     IF THE CURRENT ERROR BECOMES UNRECOVERABLE,
C                        THE MESSAGE IS PRINTED AND EXECUTION STOPS.
C
C                        ERROR STATES -
C                          1 - ILLEGAL VALUE OF IROLD.
C ******************************************************************
C
C INTEGER FUNCTION NERRO(NERR)
C
C PURPOSE                PROVIDES THE CURRENT ERROR NUMBER (IF ANY)
C                        OR ZERO IF THE PROGRAM IS NOT IN THE
C                        ERROR STATE.
C
C USAGE                  N = NERRO(NERR)
C
C ARGUMENTS
C
C ON INPUT               NONE
C
C ON OUTPUT              NERR
C                          CURRENT VALUE OF THE ERROR NUMBER
C ******************************************************************
C SUBROUTINE ERROF
C
C PURPOSE                TURNS OFF THE ERROR STATE BY SETTING THE
C                        ERROR NUMBER TO ZERO
C
C USAGE                  CALL ERROF
C
C ARGUMENTS
C
C ON INPUT               NONE
C
C ON OUTPUT              NONE
C ******************************************************************
C
C SUBROUTINE SETER(MESSG,NERR,IOPT)
C
C PURPOSE                SETS THE ERROR INDICATOR AND, DEPENDING
C                        ON THE OPTIONS STATED BELOW, PRINTS A
C                        MESSAGE AND PROVIDES A DUMP.
C
C
C USAGE                  CALL SETER(MESSG,NERR,IOPT)
C
C ARGUMENTS
C
C ON INPUT               MESSG
C                          HOLLERITH STRING CONTAINING THE MESSAGE
C                          ASSOCIATED WITH THE ERROR
C
C                        NERR
C                          THE NUMBER TO ASSIGN TO THE ERROR
C
C                        IOPT
C                          = 1 FOR A RECOVERABLE ERROR
C                          = 2 FOR A FATAL ERROR
C
C                         IF IOPT = 1 AND THE USER IS IN ERROR
C                         RECOVERY MODE, SETERR SIMPLY REMEMBERS
C                         THE ERROR MESSAGE, SETS THE ERROR NUMBER
C                         TO NERR, AND RETURNS.
C
C                         IF IOPT = 1 AND THE USER IS NOT IN ERROR
C                         RECOVERY MODE, SETERR PRINTS THE ERROR
C                         MESSAGE AND TERMINATES THE RUN.
C
C                         IF IOPT = 2 SETERR ALWAYS PRINTS THE ERROR
C                         MESSAGE, CALLS FDUM, AND TERMINATES THE RUN.
C
C ON OUTPUT              NONE
C
C SPECIAL CONDITIONS     CANNOT ASSIGN NERR = 0, AND CANNOT SET IOPT
C                        TO ANY VALUE OTHER THAN 1 OR 2.
C ******************************************************************
C
C  SUBROUTINE EPRIN
C
C PURPOSE                PRINTS THE CURRENT ERROR MESSAGE IF THE
C                        PROGRAM IS IN THE ERROR STATE; OTHERWISE
C                        NOTHING IS PRINTED.
C
C USAGE                  CALL EPRIN
C
C ARGUMENTS
C
C ON INPUT               NONE
C
C ON OUTPUT              NONE
C ******************************************************************
C
C SUBROUTINE FDUM
C
C PURPOSE                TO PROVIDE A DUMMY ROUTINE WHICH SERVES
C                        AS A PLACEHOLDER FOR A SYMBOLIC DUMP
C                        ROUTINE, SHOULD IMPLEMENTORS DECIDE TO
C                        PROVIDE SUCH A ROUTINE.
C
C USAGE                  CALL EPRIN
C
C ARGUMENTS
C
C ON INPUT               NONE
C
C ON OUTPUT              NONE
C ******************************************************************
      SUBROUTINE ENTSR(IROLD,IRNEW)
C
      LOGICAL TEMP
      IF (IRNEW.LT.0 .OR. IRNEW.GT.2)
     1   CALL SETER(' ENTSR - ILLEGAL VALUE OF IRNEW',1,2)
C
      TEMP = IRNEW.NE.0
      IROLD = I8SAV(2,IRNEW,TEMP)
C
C  IF HAVE AN ERROR STATE, STOP EXECUTION.
C
      IF (I8SAV(1,0,.FALSE.) .NE. 0) CALL SETER
     1   (' ENTSR - CALLED WHILE IN AN ERROR STATE',2,2)
C
      RETURN
C
      END
      SUBROUTINE RETSR(IROLD)
C
      IF (IROLD.LT.1 .OR. IROLD.GT.2)
     1  CALL SETER(' RETSR - ILLEGAL VALUE OF IROLD',1,2)
C
      ITEMP=I8SAV(2,IROLD,.TRUE.)
C
C  IF THE CURRENT ERROR IS NOW UNRECOVERABLE, PRINT AND STOP.
C
      IF (IROLD.EQ.1 .OR. I8SAV(1,0,.FALSE.).EQ.0) RETURN
C
        CALL EPRIN
        CALL FDUM
c       STOP
C
      END
      INTEGER FUNCTION NERRO(NERR)
C
      NERRO=I8SAV(1,0,.FALSE.)
      NERR=NERRO
      RETURN
C
      END
      SUBROUTINE ERROF
C
      I=I8SAV(1,0,.TRUE.)
      RETURN
C
      END
      SUBROUTINE SETER(MESSG,NERR,IOPT)
C
      CHARACTER*(*) MESSG
      COMMON /UERRF/IERF
C
C  THE UNIT FOR ERROR MESSAGES IS I1MACH(4)
C
c + NOAO -  blockdata uerrbd changed to runtime initialization subroutine
C     FORCE LOAD OF BLOCKDATA
C
c     EXTERNAL UERRBD
      call uerrbd
c - NOAO
      IF (IERF .EQ. 0) THEN
      IERF = I1MACH(4)
      ENDIF
C
      NMESSG = LEN(MESSG)
      IF (NMESSG.GE.1) GO TO 10
C
C  A MESSAGE OF NON-POSITIVE LENGTH IS FATAL.
C
c + NOAO -  FTN writes rewritten as calls to uliber for IRAF
c       WRITE(IERF,9000)
c9000   FORMAT(' ERROR 1 IN SETER - MESSAGE LENGTH NOT POSITIVE.')
        call uliber (1,' SETER - MESSAGE LENGTH NOT POSITIVE.', 80) 
c - NOAO
        GO TO 60
C
   10 CONTINUE
      IF (NERR.NE.0) GO TO 20
C
C  CANNOT TURN THE ERROR STATE OFF USING SETER.
C
c + NOAO -  FTN writes rewritten as calls to uliber for IRAF
c       WRITE(IERF,9001)
c9001   FORMAT(' ERROR 2 IN SETER - CANNOT HAVE NERR=0'/
c    1         ' THE CURRENT ERROR MESSAGE FOLLOWS'/)
        call uliber (2, ' SETER - CANNOT HAVE NERR=0', 80)
        call uliber (2, ' SETER - THE CURRENT ERROR MSG FOLLOWS', 80) 
c - NOAO
        CALL E9RIN(MESSG,NERR,.TRUE.)
        ITEMP=I8SAV(1,1,.TRUE.)
        GO TO 50
C
C  SET LERROR AND TEST FOR A PREVIOUS UNRECOVERED ERROR.
C
 20   CONTINUE
      IF (I8SAV(1,NERR,.TRUE.).EQ.0) GO TO 30
C
c + NOAO - FTN writes rewritten as calls to uliber for IRAF
c       WRITE(IERF,9002)
c9002   FORMAT(' ERROR    3 IN SETER -',
c    1         ' AN UNRECOVERED ERROR FOLLOWED BY ANOTHER ERROR.'//
c    2         ' THE PREVIOUS AND CURRENT ERROR MESSAGES FOLLOW.'///)
        call uliber (3,' SETER - A SECOND UNRECOV ERROR SEEN.', 80)
        call uliber (3,' SETER - THE ERROR MESSAGES FOLLOW.', 80)
c - NOAO
        CALL EPRIN
        CALL E9RIN(MESSG,NERR,.TRUE.)
        GO TO 50
C
C  SAVE THIS MESSAGE IN CASE IT IS NOT RECOVERED FROM PROPERLY.
C
 30   CALL E9RIN(MESSG,NERR,.TRUE.)
C
      IF (IOPT.EQ.1 .OR. IOPT.EQ.2) GO TO 40
C
C  MUST HAVE IOPT = 1 OR 2.
C
c + NOAO -  FTN writes rewritten as calls to uliber for IRAF
c     WRITE(IERF,9003)
c9003   FORMAT(' ERROR    4 IN SETER - BAD VALUE FOR IOPT'//
c    1         ' THE CURRENT ERROR MESSAGE FOLLOWS'///)
        call uliber (4, ' SETER - BAD VALUE FOR IOPT', 80)
        call uliber (4, ' SETER - THE CURRENT ERR MSG FOLLOWS', 80)
c - NOAO 
        GO TO 50
C
C  TEST FOR RECOVERY.
C
 40   CONTINUE
      IF (IOPT.EQ.2) GO TO 50
C
      IF (I8SAV(2,0,.FALSE.).EQ.1) RETURN
C
      CALL EPRIN
      CALL FDUM
c     STOP
C
 50   CALL EPRIN
 60   CALL FDUM
c     STOP
C
      END
      SUBROUTINE EPRIN
C
      CHARACTER*1 MESSG
C
      CALL E9RIN(MESSG,1,.FALSE.)
      RETURN
C
      END
      SUBROUTINE E9RIN(MESSG,NERR,SAVE)
C
C  THIS ROUTINE STORES THE CURRENT ERROR MESSAGE OR PRINTS THE OLD ONE,
C  IF ANY, DEPENDING ON WHETHER OR NOT SAVE = .TRUE. .
C
      CHARACTER*(*) MESSG
      CHARACTER*113 MESSGP
      INTEGER NERRP
      LOGICAL SAVE
      COMMON /UERRF/IERF
      SAVE MESSGP,NERRP
C
C  MESSGP STORES THE FIRST 113 CHARACTERS OF THE PREVIOUS MESSAGE
C
C
C  START WITH NO PREVIOUS MESSAGE.
C
      DATA MESSGP/'1'/
      DATA NERRP/0/
C
      IF (.NOT.SAVE) GO TO 20
C
C  SAVE THE MESSAGE.
C
        NERRP=NERR
        MESSGP = MESSG
C
        GO TO 30
C
 20   IF (I8SAV(1,0,.FALSE.).EQ.0) GO TO 30
C
C  PRINT THE MESSAGE.
C
c + NOAO -  FTN write rewritten as call to uliber
c     WRITE(IERF,9000) NERRP,MESSGP
c9000 FORMAT(' ERROR ',I4,' IN ',A113)
      call uliber (nerrp, messgp, 113)
C
 30   RETURN
C
      END
      INTEGER FUNCTION I8SAV(ISW,IVALUE,SET)
C
C  IF (ISW = 1) I8SAV RETURNS THE CURRENT ERROR NUMBER AND
C               SETS IT TO IVALUE IF SET = .TRUE. .
C
C  IF (ISW = 2) I8SAV RETURNS THE CURRENT RECOVERY SWITCH AND
C               SETS IT TO IVALUE IF SET = .TRUE. .
C
      LOGICAL SET
      INTEGER LERROR, LRECOV
      SAVE LERROR,LRECOV
C
C  START EXECUTION ERROR FREE AND WITH RECOVERY TURNED OFF.
C
      DATA LERROR/0/ , LRECOV/2/
      IF (ISW .EQ. 1) THEN
        I8SAV = LERROR
        IF (SET) LERROR = IVALUE
      ELSE IF (ISW .EQ. 2) THEN
        I8SAV = LRECOV
        IF (SET) LRECOV = IVALUE
      ENDIF
      RETURN
      END
      SUBROUTINE FDUM
C
C     DUMMY ROUTINE TO BE LOCALLY IMPLEMENTED
C
      RETURN
      END
C
      SUBROUTINE Q8QST4(NAME,LBRARY,ENTRY,VRSION)
C
C DIMENSION OF           NAME(1),LBRARY(1),ENTRY(1),VRSION(1)
C ARGUMENTS
C
C LATEST REVISION        MARCH 1984
C
C PURPOSE                MONITORS LIBRARY USE BY WRITING A RECORD WITH
C                        INFORMATION ABOUT THE CIRCUMSTANCES OF A
C                        LIBRARY ROUTINE CALL TO THE SYSTEM ACCOUNTING
C                        TAPE FOR LATER PROCESSING.
C
C NOTE---                THIS VERSION OF Q8QST4 SIMPLY RETURNS TO THE
C                        CALLING ROUTINE.  LOCAL IMPLEMENTORS MAY WISH
C                        TO IMPLEMENT A VERSION OF THIS ROUTINE THAT
C                        MONITORS USE OF NCAR ROUTINES WITH LOCAL
C                        MECHANISMS.  OTHERWISE IT WILL SAVE A SMALL
C                        AMOUNT OF SPACE AND TIME IF CALLS TO Q8QST4 ARE
C                        DELETED FROM ALL NSSL ROUTINES.
C
      CHARACTER*(*) NAME,LBRARY,ENTRY,VRSION
C
      RETURN
      END
c + NOAO -  Blockdata uerrbd rewritten as a runtime initialization subroutine
c     BLOCKDATA UERRBD
      subroutine uerrbd
c
      COMMON /UERRF/IERF
C     DEFAULT ERROR UNIT
c     DATA IERF/0/
      IERF= 0
      END
c -NOAO
        subroutine uliber (errcode, pkerrmsg, msglen)

        character*80 pkerrmsg
        integer errcode, msglen
        integer*2 sppmsg(81)
        integer SZLINE
        parameter (SZLINE=80)

c unpack the fortran character string, call fulib to output the string.
c
        call f77upk (pkerrmsg, sppmsg, SZLINE)
        call fulib  (errcode, sppmsg, msglen)

        end

      SUBROUTINE slAMP (RA, DA, DATE, EQ, RM, DM)
*+
*     - - - -
*      A M P
*     - - - -
*
*  Convert star RA,Dec from geocentric apparent to mean place
*
*  The mean coordinate system is the post IAU 1976 system,
*  loosely called FK5.
*
*  Given:
*     RA       d      apparent RA (radians)
*     DA       d      apparent Dec (radians)
*     DATE     d      TDB for apparent place (JD-2400000.5)
*     EQ       d      equinox:  Julian epoch of mean place
*
*  Returned:
*     RM       d      mean RA (radians)
*     DM       d      mean Dec (radians)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Notes:
*
*  1)  The distinction between the required TDB and TT is always
*      negligible.  Moreover, for all but the most critical
*      applications UTC is adequate.
*
*  2)  Iterative techniques are used for the aberration and light
*      deflection corrections so that the routines slAMP (or
*      slAMPQ) and slMAP (or slMAPQ) are accurate inverses;
*      even at the edge of the Sun's disc the discrepancy is only
*      about 1 nanoarcsecond.
*
*  3)  Where multiple apparent places are to be converted to mean
*      places, for a fixed date and equinox, it is more efficient to
*      use the slMAPA routine to compute the required parameters
*      once, followed by one call to slAMPQ per star.
*
*  4)  The accuracy is sub-milliarcsecond, limited by the
*      precession-nutation model (IAU 1976 precession, Shirai &
*      Fukushima 2001 forced nutation and precession corrections).
*
*  5)  The accuracy is further limited by the routine slEVP, called
*      by slMAPA, which computes the Earth position and velocity
*      using the methods of Stumpff.  The maximum error is about
*      0.3 mas.
*
*  Called:  slMAPA, slAMPQ
*
*  P.T.Wallace   Starlink   17 September 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RA,DA,DATE,EQ,RM,DM

      DOUBLE PRECISION AMPRMS(21)



      CALL slMAPA(EQ,DATE,AMPRMS)
      CALL slAMPQ(RA,DA,AMPRMS,RM,DM)

      END

C----------------------------------------------------------------------
        subroutine ftsdnn(value)

C       set a 64-bit pattern equal to an IEEE Not-a-Number value
C       A NaN has all the exponent bits=1, and the fractional part 
C       not=0.  
C
C       written by Wm Pence, HEASARC/GSFC, February 1991

        integer value(2)

C       there are many NaN values;  choose a simple one in which all bits=1
        value(1)=-1
        value(2)=-1
        end

      SUBROUTINE ENCD (VALU,ASH,IOUT,NC,IOFFD)
C
C
C
C
C ON INPUT     VALU	 FLOATING POINT	NUMBER FROM WHICH THE LABEL IS
C			 TO BE CREATED.
C	       ASH	 SEE IOFFD.
C	       IOFFD	 IF IOFFD .EQ. 0, A LABEL WHICH	REFLECTS THE
C			      MAGNITUDE	OF VALU	IS TO BE CREATED.
C			      .1 .LE. ABS(VALU)	.LE. 99999.49999...
C			      OR VALUE .EQ. 0.0.  THE LABEL CREATED
C			      SHOULD HAVE 3 TO 5 CHARACTERS DEPENDING
C			      ON THE MAGNITUDE OF VALU.	 SEE IOUT.
C			 IF IOFFD .NE. 0, A LABEL WHICH	DOES NOT REFLECT
C			      THE MAGNITUDE OF VALU IS TO BE CREATED.
C			      ASH IS USED AS THE NORMALIZATION FACTOR.
C			      1. .LE. ASH*ABS(VALU) .LT. 1000. OR
C			      VALU .EQ.	0.0.  THE LABEL	CREATED	SHOULD
C			      HAVE 1 TO	3 CHARACTERS, DEPENDING	ON THE
C			      MAGNITUDE	OF ASH*VALU.  SEE IOUT.
C ON OUTPUT    IOUT	 CONTAINS THE LABEL CREATED.  IT SHOULD	HAVE NO
C			 LEADING BLANKS.  SEE NC.
C	       NC	 THE NUMBERS IN	THE LABEL IN IOUT.  SHOULD BE
C			 1 TO 5.
C
      SAVE
      CHARACTER*11 IFMT, IOUT
C
C IFMT MUST HOLD 11 CHARACTERS
C
      VAL = VALU
      IF (IOFFD	.NE. 0)	GO TO 103
      IF (VAL) 101,104,101
  101 LOG = IFIX((ALOG10(ABS(VAL))+.00001)+5000.)-5000
      V	= VAL
      NS = MAX0(4,MIN0(6,LOG+2))
      ND = MIN0(3,MAX0(0,2-LOG))
c     IF (VAL.LT.0)  NS	= NS + 1
c +noao: replacing ftn i/o for iraf implementation
c 102 WRITE (IFMT,'(A2,I2,A1,I1,A1)') '(F',NS,'.',ND,')'
  102 continue
c     if (len (char (ns + ichar ('0'))) .eq. 2) then
c	 ifmt(1:7) = '(f  . )'
c	 ifmt(3:4) = char (ns + ichar ('0'))
c	 ifmt(6:6) = char (nd + ichar ('0'))
c     else 
c	 ifmt(1:6) = '(f . )'
c	 ifmt(3:3) = char (ns + ichar ('0'))
c	 ifmt(5:5) = char (nd + ichar ('0'))
c     endif
c     WRITE (IOUT,IFMT)	V
      call encode (ns, ifmt, iout, v)
      NC = NS
c +noao
c The following statement was making 5 digit labels (+4800) come out
c truncated (+480) and it has been commented out.
c     IF (LOG.GE.3)  NC	= NC - 1
c -noao
      RETURN
  103 NS = 4
      IF (VAL.LT.0.)  NS=5
      IF (VAL.EQ.0.)  NS=2
      ND = 0
      V	= VAL*ASH
      LOG = 100
      GO TO 102
  104 iout(1:3) = '0.0'
      nc = 3
c 104 NS = 3
c     ND = 1
c     LOG = -100
c     V	= 0.
c     GO TO 102
C
C1001 FORMAT('(F',I2,'.',I1,',1H',A1,')')
C
      END

      subroutine iferrc (lab, sense)
      integer lab, sense
      integer labgen, nlpar
      integer t, gettok, gnbtok, token(100)
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer errpsh(12)
      integer siferr(20)
      integer sifno0(15)
      data errpsh(1)/99/,errpsh(2)/97/,errpsh(3)/108/,errpsh(4)/108/,err
     *psh(5)/32/,errpsh(6)/120/,errpsh(7)/101/,errpsh(8)/114/,errpsh(9)/
     *112/,errpsh(10)/115/,errpsh(11)/104/,errpsh(12)/-2/
      data siferr(1)/105/,siferr(2)/102/,siferr(3)/32/,siferr(4)/40/,sif
     *err(5)/46/,siferr(6)/110/,siferr(7)/111/,siferr(8)/116/,siferr(9)/
     *46/,siferr(10)/120/,siferr(11)/101/,siferr(12)/114/,siferr(13)/112
     */,siferr(14)/111/,siferr(15)/112/,siferr(16)/40/,siferr(17)/41/,si
     *ferr(18)/41/,siferr(19)/32/,siferr(20)/-2/
      data sifno0(1)/105/,sifno0(2)/102/,sifno0(3)/32/,sifno0(4)/40/,sif
     *no0(5)/120/,sifno0(6)/101/,sifno0(7)/114/,sifno0(8)/112/,sifno0(9)
     */111/,sifno0(10)/112/,sifno0(11)/40/,sifno0(12)/41/,sifno0(13)/41/
     *,sifno0(14)/32/,sifno0(15)/-2/
      xfer = 0
      lab = labgen (3)
      call outtab
      call outstr (errpsh)
      call outdon
      I23000=(gnbtok (token, 100))
      goto 23000
23002 continue
      call outtab
      goto 23001
23003 continue
      call pbstr (token)
      esp = esp + 1
      if (.not.(esp .ge. 30))goto 23004
      call baderr (35HIferr statements nested too deeply.)
23004 continue
      errstk(esp) = lab
      return
23006 continue
      call synerr (19HMissing left paren.)
      return
23000 continue
      if (I23000.eq.40)goto 23002
      if (I23000.eq.123)goto 23003
      goto 23006
23001 continue
      nlpar = 1
      token(1) = -2
      esp = esp + 1
      if (.not.(esp .ge. 30))goto 23007
      call baderr (35HIferr statements nested too deeply.)
23007 continue
      errstk(esp) = 0
23009 continue
      call outstr (token)
      t = gettok (token, 100)
      if (.not.(t .eq. 59 .or. t .eq. 123 .or. t .eq. 125 .or. t .eq. -1
     *))goto 23012
      call pbstr (token)
      goto 23011
23012 continue
      if (.not.(t .eq. 10))goto 23014
      token (1) = -2
      goto 23015
23014 continue
      if (.not.(t .eq. 40))goto 23016
      nlpar = nlpar + 1
      goto 23017
23016 continue
      if (.not.(t .eq. 41))goto 23018
      nlpar = nlpar - 1
      goto 23019
23018 continue
      if (.not.(t .eq. 59))goto 23020
      call outdon
      call outtab
      goto 23021
23020 continue
      if (.not.(t .eq. -9))goto 23022
      call squash (token)
23022 continue
23021 continue
23019 continue
23017 continue
23015 continue
23010 if (.not.(nlpar .le. 0))goto 23009
23011 continue
      esp = esp - 1
      ername = 0
      if (.not.(nlpar .ne. 0))goto 23024
      call synerr (33HMissing parenthesis in condition.)
      goto 23025
23024 continue
      call outdon
23025 continue
      call outtab
      if (.not.(sense .eq. 1))goto 23026
      call outstr (siferr)
      goto 23027
23026 continue
      call outstr (sifno0)
23027 continue
      call outgo (lab)
      call indent (1)
      return
      end
c     sifno0  sifnoerr
c     logic0  logical_column

      subroutine beginc
      integer labgen
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      body = 1
      ername = 0
      esp = 0
      label = 100
      retlab = labgen (1)
      logic0 = 6 + 3
      col = logic0
      end
c     logic0  logical_column

C--------------------------------------------------------------------------
        subroutine ftrwdn(iunit,frow,lrow,nshift,status)

C       shift rows in a table down by NROWS rows, inserting blank rows

C       iunit   i  Fortran I/O unit number
C       frow    i  rows *AFTER* this one are to be moved down
C       lrow    i  last row to be moved down (last row of the table)
C       nshift  i  how far to shift the rows
C       status  i  returned error status (0=ok)

        integer iunit,frow,lrow,nshift,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character*1 buff(2880,2)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,kshift,nchar,fchar,in,out,i,j,irow,tin,jrow
        integer lstptr,inptr,outptr,nseg
        character cfill*1
        
        if (status .gt. 0)return

C       don't have to do anything if inserting blank rows at end of the table
        if (frow .eq. lrow)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       select appropriate fill value
        if (hdutyp(ibuff) .eq. 1)then
C           fill  header or ASCII table with space
            cfill=char(32)
        else
C           fill image or bintable data area with Null (0)      
            cfill=char(0)
        end if

C       how many rows will fit in the single buffer?
        kshift=2880/rowlen(ibuff)

C **********************************************************************
C       CASE #1: optimal case where the NSHIFT number of rows will all
C       fit in the 2880-byte work buffer simultaneously.  The rows can
C       be shifted down in one efficient pass through the table.
C **********************************************************************
        if (kshift .ge. nshift)then
    
        kshift=nshift
        nchar=kshift*rowlen(ibuff)
        fchar=1

C       initialize the first buffer
        in=2
        out=1

        do 5 i=1,2880
            buff(i,1)=cfill
5       continue

        do 10 irow=frow+1,lrow,kshift

C           read the row(s) to be shifted
            call ftgtbs(iunit,irow,fchar,nchar,buff(1,in),status)

C           overwrite these row(s) with the previous row(s)
            call ftptbs(iunit,irow,fchar,nchar,buff(1,out),status)

C           swap the input and output buffer pointers and move to next rows
            tin=in
            in=out
            out=tin
            jrow=irow
10      continue

C       write the last row(s) out
        irow=jrow+kshift
        nchar=(lrow-jrow+1)*rowlen(ibuff)
        
        call ftptbs(iunit,irow,fchar,nchar,buff(1,out),status)
        return

C **********************************************************************
C       CASE #2: One or more rows of the table will fit in the work buffer,
C       but cannot fit all NSHIFT rows in the buffer at once.  Note that
C       since we do not need 2 buffers, as in the previous case, we can
C       combine both buffers into one single 2880*2 byte buffer, to handle
C       wider tables.  This algorithm copies then moves blocks of contiguous
C       rows at one time, working upwards from the bottom of the table.
C **********************************************************************
        else if (rowlen(ibuff) .le. 5760)then

C       how many rows can we move at one time?
        kshift=5760/rowlen(ibuff)
        fchar=1

C       initialize pointers
        lstptr=lrow
        inptr=lrow-kshift+1

20      if (inptr .le. frow)inptr=frow+1
        nchar=(lstptr-inptr+1)*rowlen(ibuff)
        outptr=inptr+nshift

C       read the row(s) to be shifted
        call ftgtbs(iunit,inptr,fchar,nchar,buff,status)

C       write the row(s) to the new location
        call ftptbs(iunit,outptr,fchar,nchar,buff,status)

C       If there are more rows, update pointers and repeat
        if (inptr .gt. frow+1)then
            lstptr=lstptr-kshift
            inptr =inptr -kshift
            go to 20
        end if

C       initialize the buffer with the fill value
        do 25 i=1,2880
            buff(i,1)=cfill
            buff(i,2)=cfill
25      continue

C       fill the empty rows with blanks or nulls
        nchar=rowlen(ibuff)
        do 30 i=1,nshift
            outptr=frow+i
            call ftptbs(iunit,outptr,fchar,nchar,buff,status)
30      continue
        return

C **********************************************************************
C       CASE #3:  Cannot fit a whole row into the work buffer, so have
C       to move each row in pieces.   
C **********************************************************************
        else

        nseg=(rowlen(ibuff)+5759)/5760
        nchar=5760

        do 60 j=1,nseg
            fchar=(j-1)*5760+1
            if (j .eq. nseg)nchar=rowlen(ibuff)-(nseg-1)*5760

            do 40 i=lrow,frow+1,-1
C               read the row to be shifted
                call ftgtbs(iunit,i,fchar,nchar,buff,status)

C               write the row(s) to the new location
                call ftptbs(iunit,i+nshift,fchar,nchar,buff,status)
40          continue

C           initialize the buffer with the fill value
            do 45 i=1,2880
                buff(i,1)=cfill
                buff(i,2)=cfill
45          continue

C           fill the empty rows with blanks or nulls
            do 50 i=1,nshift
                outptr=frow+i
                call ftptbs(iunit,outptr,fchar,nchar,buff,status)
50          continue
60      continue

        end if
        end

      subroutine ifgo (lab)
      integer lab
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer ifnot(10)
      integer serrc0(21)
      data ifnot(1)/105/,ifnot(2)/102/,ifnot(3)/32/,ifnot(4)/40/,ifnot(5
     *)/46/,ifnot(6)/110/,ifnot(7)/111/,ifnot(8)/116/,ifnot(9)/46/,ifnot
     *(10)/-2/
      data serrc0(1)/46/,serrc0(2)/97/,serrc0(3)/110/,serrc0(4)/100/,ser
     *rc0(5)/46/,serrc0(6)/40/,serrc0(7)/46/,serrc0(8)/110/,serrc0(9)/11
     *1/,serrc0(10)/116/,serrc0(11)/46/,serrc0(12)/120/,serrc0(13)/101/,
     *serrc0(14)/114/,serrc0(15)/102/,serrc0(16)/108/,serrc0(17)/103/,se
     *rrc0(18)/41/,serrc0(19)/41/,serrc0(20)/32/,serrc0(21)/-2/
      call outtab
      call outstr (ifnot)
      call balpar
      if (.not.(ername .eq. 1))goto 23000
      call outstr (serrc0)
      goto 23001
23000 continue
      call outch (41)
      call outch (32)
23001 continue
      call outgo (lab)
      call errgo
      end
c     logic0  logical_column
c     serrc0  serrchk

      SUBROUTINE slETRM (EP, EV)
*+
*     - - - - - -
*      E T R M
*     - - - - - -
*
*  Compute the E-terms (elliptic component of annual aberration)
*  vector (double precision)
*
*  Given:
*     EP      dp      Besselian epoch
*
*  Returned:
*     EV      dp(3)   E-terms as (dx,dy,dz)
*
*  Note the use of the J2000 aberration constant (20.49552 arcsec).
*  This is a reflection of the fact that the E-terms embodied in
*  existing star catalogues were computed from a variety of
*  aberration constants.  Rather than adopting one of the old
*  constants the latest value is used here.
*
*  References:
*     1  Smith, C.A. et al., 1989.  Astr.J. 97, 265.
*     2  Yallop, B.D. et al., 1989.  Astr.J. 97, 274.
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION EP,EV(3)

*  Arcseconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T,E,E0,P,EK,CP



*  Julian centuries since B1950
      T=(EP-1950D0)*1.00002135903D-2

*  Eccentricity
      E=0.01673011D0-(0.00004193D0+0.000000126D0*T)*T

*  Mean obliquity
      E0=(84404.836D0-(46.8495D0+(0.00319D0+0.00181D0*T)*T)*T)*AS2R

*  Mean longitude of perihelion
      P=(1015489.951D0+(6190.67D0+(1.65D0+0.012D0*T)*T)*T)*AS2R

*  E-terms
      EK=E*20.49552D0*AS2R
      CP=COS(P)
      EV(1)= EK*SIN(P)
      EV(2)=-EK*CP*COS(E0)
      EV(3)=-EK*CP*SIN(E0)

      END

      SUBROUTINE slS2C6 ( A, B, R, AD, BD, RD, V )
*+
*     - - - - - -
*      S 2 C 6
*     - - - - - -
*
*  Conversion of position & velocity in spherical coordinates
*  to Cartesian coordinates (single precision)
*
*  Given:
*     A     r      longitude (radians)
*     B     r      latitude (radians)
*     R     r      radial coordinate
*     AD    r      longitude derivative (radians per unit time)
*     BD    r      latitude derivative (radians per unit time)
*     RD    r      radial derivative
*
*  Returned:
*     V     r(6)   Cartesian position & velocity vector
*
*  Last revision:   11 September 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL A, B, R, AD, BD, RD, V(6)

      REAL SA, CA, SB, CB, RCB, X, Y, RBD, W



*  Useful functions.
      SA = SIN(A)
      CA = COS(A)
      SB = SIN(B)
      CB = COS(B)
      RCB = R*CB
      X = RCB*CA
      Y = RCB*SA
      RBD = R*BD
      W = RBD*SB-CB*RD

*  Position.
      V(1) = X
      V(2) = Y
      V(3) = R*SB

*  Velocity.
      V(4) = -Y*AD-W*CA
      V(5) = X*AD-W*SA
      V(6) = RBD*CB+SB*RD

      END

chapter xvi, example 3. two parametrizations of some data
c  from  * a practical guide to splines *  by c. de boor
calls  splint(bsplvb,banfac/slv),bsplpp(bsplvb*),banslv*,ppvalu(interv)
c     parameter k=4,kpkm1=7, n=8,npk=12, npiece=6,npoint=21
c     integer i,icount,iflag,kp1,l
c     real bcoef(n),break(npiece),ds,q(n,kpkm1),s(n),scrtch(k,k)
c    *	  ,ss,t(npk),x(n),xcoef(k,npiece),xx(npoint),y(n)
c    *	  ,ycoef(k,npiece),yy(npoint)
      integer i,icount,iflag,k,kpkm1,kp1,l,n,npoint
      real bcoef(8),break(6),ds,q(8,7),s(8),scrtch(4,4)
     *	  ,ss,t(12),x(8),xcoef(4,6),xx(21),y(8)
     *	  ,ycoef(4,6),yy(21)
      real ppvalu
      data k,kpkm1,n,npoint /4,7,8,21/
      data x /0.,.1,.2,.3,.301,.4,.5,.6/
c  *** compute y-component and set 'natural' parametrization
      do 1 i=1,n
	 y(i) = (x(i)-.3)**2
    1	 s(i) = x(i)
      print 601
  601 format(26h 'natural' parametrization/6x,1hx,11x,1hy)
      icount = 1
c  *** convert data abscissae to knots. note that second and second
c     last data abscissae are not knots.
    5 do 6 i=1,k
	 t(i) = s(1)
    6	 t(n+i) = s(n)
      kp1 = k+1
      do 7 i=kp1,n
    7	 t(i) = s(i+2-k)
c  *** interpolate to x-component
      call splint(s,x,t,n,k,q,bcoef,iflag)
      call bsplpp(t,bcoef,n,k,scrtch,break,xcoef,l)
c  *** interpolate to y-component. since data abscissae and knots are
c     the same for both components, we only need to use backsubstitution
      do 10 i=1,n
   10	 bcoef(i) = y(i)
      call banslv(q,kpkm1,n,k-1,k-1,bcoef)
      call bsplpp(t,bcoef,n,k,scrtch,break,ycoef,l)
c  *** evaluate curve at some points near the potential trouble spot,
c     the fourth and fifth data points.
      ss = s(3)
      ds = (s(6)-s(3))/float(npoint-1)
      do 20 i=1,npoint
	 xx(i) = ppvalu(break,xcoef,l,k,ss,0)
	 yy(i) = ppvalu(break,ycoef,l,k,ss,0)
   20	 ss = ss + ds
      print 620,(xx(i),yy(i),i=1,npoint)
  620 format(2f12.7)
      if (icount .ge. 2)		stop
c  *** now repeat the whole process with uniform parametrization
      icount = icount + 1
      do 30 i=1,n
   30	 s(i) = float(i)
      print 630
  630 format(/26h 'uniform' parametrization/6x,1hx,11x,1hy)
					go to 5
      end

c     subroutine nnls  (a,mda,m,n,b,x,rnorm,w,zz,index,ier)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 june 15
c     to appear in 'solving least squares problems', prentice-hall, 1974
c
c	  **********   nonnegative least squares   **********
c
c     given an m by n matrix, a, and an m-vector, b,  compute an
c     n-vector, x, which solves the least squares problem
c
c		       a * x = b  subject to x .ge. 0
c
c     a(),mda,m,n     mda is the first dimensioning parameter for the
c		      array, a().   on entry a() contains the m by n
c		      matrix, a.	   on exit a() contains
c		      the product matrix, q*a , where q is an
c		      m by m orthogonal matrix generated implicitly by
c		      this subroutine.
c     b()     on entry b() contains the m-vector, b.   on exit b() con-
c	      tains q*b.
c     x()     on entry x() need not be initialized.  on exit x() will
c	      contain the solution vector.
c     rnorm   on exit rnorm contains the euclidean norm of the
c	      residual vector.
c     w()     an n-array of working space.  on exit w() will contain
c	      the dual solution vector.   w will satisfy w(i) = 0.
c	      for all i in set p  and w(i) .le. 0. for all i in set z
c     zz()     an m-array of working space.
c     index()	  an integer working array of length at least n.
c		  on exit the contents of this array define the sets
c		  p and z as follows..
c
c		  index(1)   thru index(nsetp) = set p.
c		  index(iz1) thru index(iz2)   = set z.
c		  iz1 = nsetp + 1 = npp1
c		  iz2 = n
c     ier     this is a success-failure flag with the following
c	      meanings.
c	      0     the solution has been computed successfully.
c	      2     the dimensions of the problem are bad.
c		    either m .le. 0 or n .le. 0.
c	      3     iteration count exceeded.  more than 3*n iterations.
c
      subroutine nnls (a,mda,m,n,b,x,rnorm,w,zz,index,ier)
      dimension a(mda,n), b(m), x(n), w(n), zz(m)
      integer index(n)
      zero=0.
      one=1.
      two=2.
      factor=0.01
c
      ier=0
      if (m.gt.0.and.n.gt.0) go to 10
      ier=2
      return
   10 iter=0
      itmax=3*n
c
c		     initialize the arrays index() and x().
c
	  do 20 i=1,n
	  x(i)=zero
   20	  index(i)=i
c
      iz2=n
      iz1=1
      nsetp=0
      npp1=1
c			      ******  main loop begins here  ******
   30 continue
c		   quit if all coefficients are already in the solution.
c			 or if m cols of a have been triangularized.
c
      if (iz1.gt.iz2.or.nsetp.ge.m) go to 350
c
c	  compute components of the dual (negative gradient) vector w().
c
	  do 50 iz=iz1,iz2
	  j=index(iz)
	  sm=zero
	      do 40 l=npp1,m
   40	      sm=sm+a(l,j)*b(l)
   50	  w(j)=sm
c				    find largest positive w(j).
   60 wmax=zero
	  do 70 iz=iz1,iz2
	  j=index(iz)
	  if (w(j).le.wmax) go to 70
	  wmax=w(j)
	  izmax=iz
   70	  continue
c
c	      if wmax .le. 0. go to termination.
c	      this indicates satisfaction of the kuhn-tucker conditions.
c
      if (wmax) 350,350,80
   80 iz=izmax
      j=index(iz)
c
c     the sign of w(j) is ok for j to be moved to set p.
c     begin the transformation and check new diagonal element to avoid
c     near linear dependence.
c
      asave=a(npp1,j)
      call h12 (1,npp1,npp1+1,m,a(1,j),1,up,dummy,1,1,0)
      unorm=zero
      if (nsetp.eq.0) go to 100
	  do 90 l=1,nsetp
   90	  unorm=unorm+a(l,j)**2
  100 unorm=sqrt(unorm)
      if (diff(unorm+abs(a(npp1,j))*factor,unorm)) 130,130,110
c
c     col j is sufficiently independent.  copy b into zz, update zz and
c   > solve for ztest ( = proposed new value for x(j) ).
c
  110	  do 120 l=1,m
  120	  zz(l)=b(l)
      call h12 (2,npp1,npp1+1,m,a(1,j),1,up,zz,1,1,1)
      ztest=zz(npp1)/a(npp1,j)
c
c				      see if ztest is positive
c     reject j as a candidate to be moved from set z to set p.
c     restore a(npp1,j), set w(j)=0., and loop back to test dual
c
      if (ztest) 130,130,140
c
c     coeffs again.
c
  130 a(npp1,j)=asave
      w(j)=zero
      go to 60
c
c     the index  j=index(iz)  has been selected to be moved from
c     set z to set p.	 update b,  update indices,  apply householder
c     transformations to cols in new set z,  zero subdiagonal elts in
c     col j,  set w(j)=0.
c
  140	  do 150 l=1,m
  150	  b(l)=zz(l)
c
      index(iz)=index(iz1)
      index(iz1)=j
      iz1=iz1+1
      nsetp=npp1
      npp1=npp1+1
c
      if (iz1.gt.iz2) go to 170
	  do 160 jz=iz1,iz2
	  jj=index(jz)
  160	  call h12 (2,nsetp,npp1,m,a(1,j),1,up,a(1,jj),1,mda,1)
  170 continue
c
      if (nsetp.eq.m) go to 190
	  do 180 l=npp1,m
  180	  a(l,j)=zero
  190 continue
c
      w(j)=zero
c				 solve the triangular system.
c				 store the solution temporarily in zz().
      assign 200 to next
      go to 400
  200 continue
c
c			******	secondary loop begins here ******
c
c			   iteration counter.
c
  210 iter=iter+1
      if (iter.le.itmax) go to 220
         ier=3
         go to 350
  220 continue
c
c		     see if all new constrained coeffs are feasible.
c				   if not compute alpha.
c
      alpha=two
	  do 240 ip=1,nsetp
	  l=index(ip)
	  if (zz(ip)) 230,230,240
c
  230	  t=-x(l)/(zz(ip)-x(l))
	  if (alpha.le.t) go to 240
	  alpha=t
	  jj=ip
  240	  continue
c
c	   if all new constrained coeffs are feasible then alpha will
c	   still = 2.	 if so exit from secondary loop to main loop.
c
      if (alpha.eq.two) go to 330
c
c	   otherwise use alpha which will be between 0. and 1. to
c	   interpolate between the old x and the new zz.
c
	  do 250 ip=1,nsetp
	  l=index(ip)
  250	  x(l)=x(l)+alpha*(zz(ip)-x(l))
c
c	 modify a and b and the index arrays to move coefficient i
c	 from set p to set z.
c
      i=index(jj)
  260 x(i)=zero
c
      if (jj.eq.nsetp) go to 290
      jj=jj+1
	  do 280 j=jj,nsetp
	  ii=index(j)
	  index(j-1)=ii
	  call g1 (a(j-1,ii),a(j,ii),cc,ss,a(j-1,ii))
	  a(j,ii)=zero
	      do 270 l=1,n
	      if (l.ne.ii) call g2 (cc,ss,a(j-1,l),a(j,l))
  270	      continue
  280	  call g2 (cc,ss,b(j-1),b(j))
  290 npp1=nsetp
      nsetp=nsetp-1
      iz1=iz1-1
      index(iz1)=i
c
c	 see if the remaining coeffs in set p are feasible.  they should
c	 be because of the way alpha was determined.
c	 if any are infeasible it is due to round-off error.  any
c	 that are nonpositive will be set to zero
c	 and moved from set p to set z.
c
	  do 300 jj=1,nsetp
	  i=index(jj)
	  if (x(i)) 260,260,300
  300	  continue
c
c	  copy b( ) into zz( ).  then solve again and loop back.
c

	  do 310 i=1,m
  310	  zz(i)=b(i)
      assign 320 to next
      go to 400
  320 continue
      go to 210
c		       ******  end of secondary loop  ******
c
  330	  do 340 ip=1,nsetp
	  i=index(ip)
  340	  x(i)=zz(ip)
c	 all new coeffs are positive.  loop back to beginning.
      go to 30
c
c			 ******  end of main loop  ******
c
c			 come to here for termination.
c		      compute the norm of the final residual vector.
c
  350 sm=zero
      if (npp1.gt.m) go to 370
	  do 360 i=npp1,m
  360	  sm=sm+b(i)**2
      go to 390
  370	  do 380 j=1,n
  380	  w(j)=zero
  390 rnorm=sqrt(sm)
      return
c
c     the following block of code is used as an internal subroutine
c     to solve the triangular system, putting the solution in zz().
c
  400	  do 430 l=1,nsetp
	  ip=nsetp+1-l
	  if (l.eq.1) go to 420
	      do 410 ii=1,ip
  410	      zz(ii)=zz(ii)-a(ii,jj)*zz(ip+1)
  420	  jj=index(ip)
  430	  zz(ip)=zz(ip)/a(ip,jj)
      go to next, (200,320)
      end

C----------------------------------------------------------------------
        subroutine ftcopy(iunit,ounit,moreky,status)

C       copies the CHDU from IUNIT to the CHDU of OUNIT.
C       This will also reserve space in the header for MOREKY keywords
C       if MOREKY > 0.

C       iunit   i  fortran unit number of the input file to be copied
C       ounit   i  fortran unit number of the output file to be copied to
C       moreky  i  create space in header for this many more keywords
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Jan, 1992

        integer iunit,ounit,moreky,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,obuff,i,nkeys,nadd
        integer bitpix,naxis,naxes(99),pcount,gcount
        character hrec*80
        logical simple,extend

        if (status .gt. 0)return

        if (iunit .eq. ounit)then
                status=101
                return
        end if

        ibuff=bufnum(iunit)
        obuff=bufnum(ounit)

C       find out the number of keywords which exist in the input CHDU
        call ftghsp(iunit,nkeys,nadd,status)

C       copy the keywords one at a time to the output CHDU
        if ( (chdu(ibuff) .eq. 1 .and. chdu(obuff) .ne. 1) .or.
     &     (chdu(ibuff) .ne. 1 .and. chdu(obuff) .eq. 1) )then
C               copy primary array to image extension, or vise versa

C               copy the required keywords:
                simple=.true.
                extend=.true.
                call ftghpr(iunit,99,simple,bitpix,naxis,
     &          naxes,pcount,gcount,extend,status)
                if (status .gt. 0)return
                call ftphpr(ounit,simple,bitpix,naxis,
     &          naxes,pcount,gcount,extend,status)
                if (status .gt. 0)return

C               copy remaining keywords, excluding pcount, gcount and extend
                do 10 i=naxis+4,nkeys
                    call ftgrec(iunit,i,hrec,status)
                    if (hrec(1:8) .ne. 'PCOUNT  ' .and.
     &                  hrec(1:8) .ne. 'GCOUNT  ' .and.
     &                  hrec(1:8) .ne. 'EXTEND  ')then
                           call ftprec(ounit,hrec,status)
                    end if
10              continue
        else 
C               just copy all the keys exactly from the input file to the output
                do 20 i=1,nkeys
                    call ftgrec(iunit,i,hrec,status)
                    call ftprec(ounit,hrec,status)
20              continue
        end if
  
C       reserve space for more keywords (if moreky > 0)
        call fthdef(ounit,moreky,status)

C       now ccopy the data from the input CHDU to the output CHDU
        call ftcpdt(iunit,ounit,status)

        end

C--------------------------------------------------------------------------
        subroutine fttscl(ounit,colnum,bscale,bzero,status)

C       Table column SCaLing factor definition
C       Define the scaling factor for a table column.
C
C       ounit   i  Fortran I/O unit number
C       colnum  i  number of the column to be defined
C       bscale  d  scaling factor
C       bzero   d  scaling zero point
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,status
        double precision bscale,bzero

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne,nf
        parameter (nb = 20)
        parameter (ne = 200)
        parameter (nf = 3000)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff

        if (status .gt. 0)return

        if (bscale .eq. 0.)then
C               illegal bscale value
                status=322
                return
        end if

        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)
        if (status .gt. 0)return

C       test for proper HDU type
        if (hdutyp(ibuff) .eq. 0)then
            status=235
            return
        end if

        if (colnum .gt. tfield(ibuff) .or. colnum .lt. 1)then
             status=302
             return
        end if
            
        tscale(colnum+tstart(ibuff))=bscale
        tzero(colnum+tstart(ibuff))=bzero
        end

      INTEGER FUNCTION I1MACH(I)
C
C  I/O UNIT NUMBERS.
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C
C  WORDS.
C
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER CHARACTER STORAGE UNIT.
C                 FOR FORTRAN 77, THIS IS ALWAYS 1.  FOR FORTRAN 66,
C                 CHARACTER STORAGE UNIT = INTEGER STORAGE UNIT.
C
C  INTEGERS.
C
C    ASSUME INTEGERS ARE REPRESENTED IN THE S-DIGIT, BASE-A FORM
C
C               SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,S-1.
C
C    I1MACH( 7) = A, THE BASE.
C
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C
C    ASSUME FLOATING-POINT NUMBERS ARE REPRESENTED IN THE T-DIGIT,
C    BASE-B FORM
C
C               SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C               WHERE 0 .LE. X(I) .LT. B FOR I=1,...,T,
C               0 .LT. X(1), AND EMIN .LE. E .LE. EMAX.
C
C    I1MACH(10) = B, THE BASE.
C
C  SINGLE-PRECISION
C
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
C  TO ALTER THIS FUNCTION FOR A PARTICULAR ENVIRONMENT,
C  THE DESIRED SET OF DATA STATEMENTS SHOULD BE ACTIVATED BY
C  REMOVING THE C FROM COLUMN 1.  ALSO, THE VALUES OF
C  I1MACH(1) - I1MACH(4) SHOULD BE CHECKED FOR CONSISTENCY
C  WITH THE LOCAL OPERATING SYSTEM.  FOR FORTRAN 77, YOU MAY WISH
C  TO ADJUST THE DATA STATEMENT SO IMACH(6) IS SET TO 1, AND
C  THEN TO COMMENT OUT THE EXECUTABLE TEST ON I .EQ. 6 BELOW.
C
C  FOR IEEE-ARITHMETIC MACHINES (BINARY STANDARD), THE FIRST
C  SET OF CONSTANTS BELOW SHOULD BE APPROPRIATE, EXCEPT PERHAPS
C  FOR IMACH(1) - IMACH(4).
C
C  COMMENTS JUST BEFORE THE END STATEMENT (LINES STARTING WITH *)
C  GIVE C SOURCE FOR I1MACH.
C
      INTEGER IMACH(16), OUTPUT, SMALL(2), I
C/6S
C/7S
      SAVE IMACH
C/
      REAL RMACH
C
      EQUIVALENCE (IMACH(4),OUTPUT), (RMACH,SMALL(1))
C
C     MACHINE CONSTANTS FOR IEEE ARITHMETIC MACHINES, SUCH AS THE AT&T
C     3B SERIES, MOTOROLA 68000 BASED MACHINES (E.G. SUN 3 AND AT&T
C     PC 7300), AND 8087 BASED MICROS (E.G. IBM PC AND AT&T 6300).
C
      DATA IMACH( 1) /    5 /
      DATA IMACH( 2) /    6 /
      DATA IMACH( 3) /    7 /
      DATA IMACH( 4) /    6 /
      DATA IMACH( 5) /   32 /
      DATA IMACH( 6) /    4 /
      DATA IMACH( 7) /    2 /
      DATA IMACH( 8) /   31 /
      DATA IMACH( 9) / 2147483647 /
      DATA IMACH(10) /    2 /
      DATA IMACH(11) /   24 /
      DATA IMACH(12) / -125 /
      DATA IMACH(13) /  128 /
      DATA IMACH(14) /   53 /
      DATA IMACH(15) / -1021 /
      DATA IMACH(16) /  1024 /
C
C     MACHINE CONSTANTS FOR AMDAHL MACHINES.
C
C      DATA IMACH( 1) /   5 /
C      DATA IMACH( 2) /   6 /
C      DATA IMACH( 3) /   7 /
C      DATA IMACH( 4) /   6 /
C      DATA IMACH( 5) /  32 /
C      DATA IMACH( 6) /   4 /
C      DATA IMACH( 7) /   2 /
C      DATA IMACH( 8) /  31 /
C      DATA IMACH( 9) / 2147483647 /
C      DATA IMACH(10) /  16 /
C      DATA IMACH(11) /   6 /
C      DATA IMACH(12) / -64 /
C      DATA IMACH(13) /  63 /
C      DATA IMACH(14) /  14 /
C      DATA IMACH(15) / -64 /
C      DATA IMACH(16) /  63 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM.
C
C      DATA IMACH( 1) /    7 /
C      DATA IMACH( 2) /    2 /
C      DATA IMACH( 3) /    2 /
C      DATA IMACH( 4) /    2 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   33 /
C      DATA IMACH( 9) / Z1FFFFFFFF /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -256 /
C      DATA IMACH(13) /  255 /
C      DATA IMACH(14) /   60 /
C      DATA IMACH(15) / -256 /
C      DATA IMACH(16) /  255 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM.
C
C      DATA IMACH( 1) /   5 /
C      DATA IMACH( 2) /   6 /
C      DATA IMACH( 3) /   7 /
C      DATA IMACH( 4) /   6 /
C      DATA IMACH( 5) /  48 /
C      DATA IMACH( 6) /   6 /
C      DATA IMACH( 7) /   2 /
C      DATA IMACH( 8) /  39 /
C      DATA IMACH( 9) / O0007777777777777 /
C      DATA IMACH(10) /   8 /
C      DATA IMACH(11) /  13 /
C      DATA IMACH(12) / -50 /
C      DATA IMACH(13) /  76 /
C      DATA IMACH(14) /  26 /
C      DATA IMACH(15) / -50 /
C      DATA IMACH(16) /  76 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS.
C
C      DATA IMACH( 1) /   5 /
C      DATA IMACH( 2) /   6 /
C      DATA IMACH( 3) /   7 /
C      DATA IMACH( 4) /   6 /
C      DATA IMACH( 5) /  48 /
C      DATA IMACH( 6) /   6 /
C      DATA IMACH( 7) /   2 /
C      DATA IMACH( 8) /  39 /
C      DATA IMACH( 9) / O0007777777777777 /
C      DATA IMACH(10) /   8 /
C      DATA IMACH(11) /  13 /
C      DATA IMACH(12) / -50 /
C      DATA IMACH(13) /  76 /
C      DATA IMACH(14) /  26 /
C      DATA IMACH(15) / -32754 /
C      DATA IMACH(16) /  32780 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR FTN4 ON THE CDC 6000/7000 SERIES.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   60 /
C      DATA IMACH( 6) /   10 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   48 /
C      DATA IMACH( 9) / 00007777777777777777B /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   47 /
C      DATA IMACH(12) / -929 /
C      DATA IMACH(13) / 1070 /
C      DATA IMACH(14) /   94 /
C      DATA IMACH(15) / -929 /
C      DATA IMACH(16) / 1069 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR FTN5 ON THE CDC 6000/7000 SERIES.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   60 /
C      DATA IMACH( 6) /   10 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   48 /
C      DATA IMACH( 9) / O"00007777777777777777" /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   47 /
C      DATA IMACH(12) / -929 /
C      DATA IMACH(13) / 1070 /
C      DATA IMACH(14) /   94 /
C      DATA IMACH(15) / -929 /
C      DATA IMACH(16) / 1069 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR CONVEX C-1.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   32 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   31 /
C      DATA IMACH( 9) / 2147483647 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -128 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   53 /
C      DATA IMACH(15) /-1024 /
C      DATA IMACH(16) / 1023 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE CRAY 1, XMP, 2, AND 3.
C
C      DATA IMACH( 1) /     5 /
C      DATA IMACH( 2) /     6 /
C      DATA IMACH( 3) /   102 /
C      DATA IMACH( 4) /     6 /
C      DATA IMACH( 5) /    64 /
C      DATA IMACH( 6) /     8 /
C      DATA IMACH( 7) /     2 /
C      DATA IMACH( 8) /    63 /
C      DATA IMACH( 9) /  777777777777777777777B /
C      DATA IMACH(10) /     2 /
C      DATA IMACH(11) /    47 /
C      DATA IMACH(12) / -8189 /
C      DATA IMACH(13) /  8190 /
C      DATA IMACH(14) /    94 /
C      DATA IMACH(15) / -8099 /
C      DATA IMACH(16) /  8190 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200.
C
C      DATA IMACH( 1) /   11 /
C      DATA IMACH( 2) /   12 /
C      DATA IMACH( 3) /    8 /
C      DATA IMACH( 4) /   10 /
C      DATA IMACH( 5) /   16 /
C      DATA IMACH( 6) /    2 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   15 /
C      DATA IMACH( 9) /32767 /
C      DATA IMACH(10) /   16 /
C      DATA IMACH(11) /    6 /
C      DATA IMACH(12) /  -64 /
C      DATA IMACH(13) /   63 /
C      DATA IMACH(14) /   14 /
C      DATA IMACH(15) /  -64 /
C      DATA IMACH(16) /   63 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE HARRIS SLASH 6 AND SLASH 7.
C
C      DATA IMACH( 1) /       5 /
C      DATA IMACH( 2) /       6 /
C      DATA IMACH( 3) /       0 /
C      DATA IMACH( 4) /       6 /
C      DATA IMACH( 5) /      24 /
C      DATA IMACH( 6) /       3 /
C      DATA IMACH( 7) /       2 /
C      DATA IMACH( 8) /      23 /
C      DATA IMACH( 9) / 8388607 /
C      DATA IMACH(10) /       2 /
C      DATA IMACH(11) /      23 /
C      DATA IMACH(12) /    -127 /
C      DATA IMACH(13) /     127 /
C      DATA IMACH(14) /      38 /
C      DATA IMACH(15) /    -127 /
C      DATA IMACH(16) /     127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE HONEYWELL DPS 8/70 SERIES.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /   43 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   63 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9 AND THE SEL SYSTEMS 85/86.
C
C      DATA IMACH( 1) /   5 /
C      DATA IMACH( 2) /   6 /
C      DATA IMACH( 3) /   7 /
C      DATA IMACH( 4) /   6 /
C      DATA IMACH( 5) /  32 /
C      DATA IMACH( 6) /   4 /
C      DATA IMACH( 7) /   2 /
C      DATA IMACH( 8) /  31 /
C      DATA IMACH( 9) / Z7FFFFFFF /
C      DATA IMACH(10) /  16 /
C      DATA IMACH(11) /   6 /
C      DATA IMACH(12) / -64 /
C      DATA IMACH(13) /  63 /
C      DATA IMACH(14) /  14 /
C      DATA IMACH(15) / -64 /
C      DATA IMACH(16) /  63 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE INTERDATA 8/32
C     WITH THE UNIX SYSTEM FORTRAN 77 COMPILER.
C
C     FOR THE INTERDATA FORTRAN VII COMPILER REPLACE
C     THE Z'S SPECIFYING HEX CONSTANTS WITH Y'S.
C
C      DATA IMACH( 1) /   5 /
C      DATA IMACH( 2) /   6 /
C      DATA IMACH( 3) /   6 /
C      DATA IMACH( 4) /   6 /
C      DATA IMACH( 5) /  32 /
C      DATA IMACH( 6) /   4 /
C      DATA IMACH( 7) /   2 /
C      DATA IMACH( 8) /  31 /
C      DATA IMACH( 9) / Z'7FFFFFFF' /
C      DATA IMACH(10) /  16 /
C      DATA IMACH(11) /   6 /
C      DATA IMACH(12) / -64 /
C      DATA IMACH(13) /  62 /
C      DATA IMACH(14) /  14 /
C      DATA IMACH(15) / -64 /
C      DATA IMACH(16) /  62 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR).
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    5 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / "377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -128 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   54 /
C      DATA IMACH(15) / -101 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR).
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    5 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / "377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -128 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   62 /
C      DATA IMACH(15) / -128 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   32 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   31 /
C      DATA IMACH( 9) / 2147483647 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   56 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     16-BIT INTEGER ARITHMETIC.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   16 /
C      DATA IMACH( 6) /    2 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   15 /
C      DATA IMACH( 9) / 32767 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   56 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE PRIME 50 SERIES SYSTEMS
C     WTIH 32-BIT INTEGERS AND 64V MODE INSTRUCTIONS,
C     SUPPLIED BY IGOR BRAY.
C
C      DATA IMACH( 1) /            1 /
C      DATA IMACH( 2) /            1 /
C      DATA IMACH( 3) /            2 /
C      DATA IMACH( 4) /            1 /
C      DATA IMACH( 5) /           32 /
C      DATA IMACH( 6) /            4 /
C      DATA IMACH( 7) /            2 /
C      DATA IMACH( 8) /           31 /
C      DATA IMACH( 9) / :17777777777 /
C      DATA IMACH(10) /            2 /
C      DATA IMACH(11) /           23 /
C      DATA IMACH(12) /         -127 /
C      DATA IMACH(13) /         +127 /
C      DATA IMACH(14) /           47 /
C      DATA IMACH(15) /       -32895 /
C      DATA IMACH(16) /       +32637 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE SEQUENT BALANCE 8000.
C
C      DATA IMACH( 1) /     0 /
C      DATA IMACH( 2) /     0 /
C      DATA IMACH( 3) /     7 /
C      DATA IMACH( 4) /     0 /
C      DATA IMACH( 5) /    32 /
C      DATA IMACH( 6) /     1 /
C      DATA IMACH( 7) /     2 /
C      DATA IMACH( 8) /    31 /
C      DATA IMACH( 9) /  2147483647 /
C      DATA IMACH(10) /     2 /
C      DATA IMACH(11) /    24 /
C      DATA IMACH(12) /  -125 /
C      DATA IMACH(13) /   128 /
C      DATA IMACH(14) /    53 /
C      DATA IMACH(15) / -1021 /
C      DATA IMACH(16) /  1024 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C
C     NOTE THAT THE PUNCH UNIT, I1MACH(3), HAS BEEN SET TO 7
C     WHICH IS APPROPRIATE FOR THE UNIVAC-FOR SYSTEM.
C     IF YOU HAVE THE UNIVAC-FTN SYSTEM, SET IT TO 1.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    6 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -128 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   60 /
C      DATA IMACH(15) /-1024 /
C      DATA IMACH(16) / 1023 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR VAX.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   32 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   31 /
C      DATA IMACH( 9) / 2147483647 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   56 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C  ***  ISSUE STOP 775 IF ALL DATA STATEMENTS ARE COMMENTED...
C      IF (SANITY .NE. 987) THEN
C*        *** CHECK FOR AUTODOUBLE ***
C         SMALL(2) = 0
C         RMACH = 1E13
C         IF (SMALL(2) .NE. 0) THEN
C*           *** AUTODOUBLED ***
C            IF (      (SMALL(1) .EQ. 1117925532
C     *           .AND. SMALL(2) .EQ. -448790528)
C     *       .OR.     (SMALL(2) .EQ. 1117925532
C     *           .AND. SMALL(1) .EQ. -448790528)) THEN
C*               *** IEEE ***
C               IMACH(10) = 2
C               IMACH(14) = 53
C               IMACH(15) = -1021
C               IMACH(16) = 1024
C            ELSE IF ( SMALL(1) .EQ. -2065213935
C     *          .AND. SMALL(2) .EQ. 10752) THEN
C*               *** VAX WITH D_FLOATING ***
C               IMACH(10) = 2
C               IMACH(14) = 56
C               IMACH(15) = -127
C               IMACH(16) = 127
C            ELSE IF ( SMALL(1) .EQ. 1267827943
C     *          .AND. SMALL(2) .EQ. 704643072) THEN
C*               *** IBM MAINFRAME ***
C               IMACH(10) = 16
C               IMACH(14) = 14
C               IMACH(15) = -64
C               IMACH(16) = 63
C            ELSE
C               WRITE(*,*)'Adjust autodoubled I1MACH by uncommenting'
C               WRITE(*,*)'data statements appropriate for your machine'
C               WRITE(*,*)'and setting IMACH(I) = IMACH(I+3) for'
C               WRITE(*,*)'I = 11, 12, and 13.'
C               STOP 777
C               END IF
C            IMACH(11) = IMACH(14)
C            IMACH(12) = IMACH(15)
C            IMACH(13) = IMACH(16)
C         ELSE
C            RMACH = 1234567.
C            IF (SMALL(1) .EQ. 1234613304) THEN
C*               *** IEEE ***
C               IMACH(10) = 2
C               IMACH(11) = 24
C               IMACH(12) = -125
C               IMACH(13) = 128
C               IMACH(14) = 53
C               IMACH(15) = -1021
C               IMACH(16) = 1024
C               SANITY = 987
C            ELSE IF (SMALL(1) .EQ. -1271379306) THEN
C*               *** VAX ***
C               IMACH(10) = 2
C               IMACH(11) = 24
C               IMACH(12) = -127
C               IMACH(13) = 127
C               IMACH(14) = 56
C               IMACH(15) = -127
C               IMACH(16) = 127
C               SANITY = 987
C            ELSE IF (SMALL(1) .EQ. 1175639687) THEN
C*               *** IBM ***
C               IMACH(10) = 16
C               IMACH(11) = 6
C               IMACH(12) = -64
C               IMACH(13) = 63
C               IMACH(14) = 14
C               IMACH(15) = -64
C               IMACH(16) = 63
C               SANITY = 987
C            ELSE
C               WRITE(*,*)'Adjust I1MACH by uncommenting'
C               WRITE(*,*)'data statements appropriate for your machine.'
C               STOP 777
C               END IF
C            END IF
C         IMACH( 1) = 5
C         IMACH( 2) = 6
C         IMACH( 3) = 7
C         IMACH( 4) = 6
C         IMACH( 5) = 32
C         IMACH( 6) = 4
C         IMACH( 7) = 2
C         IMACH( 8) = 31
C         IMACH( 9) = 2147483647
C         SANITY = 987
C         END IF
C      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 30
      IF (I .LT. 1  .OR.  I .GT. 16) THEN
         I1MACH = -1
	 RETURN
      END IF
C
      I1MACH = IMACH(I)
C/6S
C/7S
      IF (I .EQ. 6) I1MACH = 1
C/
      RETURN
C
C 30   WRITE(*,*) 'I1MACH(I): I =',I,' is out of bounds.'
C
C*     CALL FDUMP
C
C      STOP
C
C* /* C source for I1MACH -- remove the * in column 1 */
C* /* Note that some values may need changing -- see the comments below. */
C*#include <stdio.h>
C*#include <float.h>
C*#include <limits.h>
C*#include <math.h>
C*
C*long i1mach_(long *i)
C*{
C*	switch(*i){
C*	  case 1:  return 5;	/* standard input  unit -- may need changing */
C*	  case 2:  return 6;	/* standard output unit -- may need changing */
C*	  case 3:  return 7;	/* standard punch  unit -- may need changing */
C*	  case 4:  return 0;	/* standard error  unit -- may need changing */
C*	  case 5:  return 32;	/* bits per integer -- may need changing */
C*	  case 6:  return 1;	/* Fortran 77 value: 1 character */
C*	  			/*    per character storage unit */
C*	  case 7:  return 2;	/* base for integers -- may need changing */
C*	  case 8:  return 31;	/* digits of integer base -- may need changing */
C*	  case 9:  return LONG_MAX;
C*	  case 10: return FLT_RADIX;
C*	  case 11: return FLT_MANT_DIG;
C*	  case 12: return FLT_MIN_EXP;
C*	  case 13: return FLT_MAX_EXP;
C*	  case 14: return DBL_MANT_DIG;
C*	  case 15: return DBL_MIN_EXP;
C*	  case 16: return DBL_MAX_EXP;
C*	  }
C*
C*	fprintf(stderr, "invalid argument: i1mach(%ld)\n", *i);
C*	exit(1);
C*	return 0; /* for compilers that complain of missing return values */
C*	}
      END

      SUBROUTINE VELVCT (U,LU,V,LV,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C SUBROUTINE VELVCT (U,LU,V,LV,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
C
C
C DIMENSION OF           U(LU,N),V(LV,N),SPV(2)
C ARGUMENTS
C
C LATEST REVISION        JULY 1984
C
C PURPOSE                VELVCT DRAWS A REPRESENTATION OF A TWO-
C                        DIMENSIONAL VELOCITY FIELD BY DRAWING ARROWS
C                        FROM EACH DATA LOCATION.  THE LENGTH OF THE
C                        ARROW IS PROPORTIONAL TO THE STRENGTH OF THE
C                        FIELD AT THAT LOCATION AND THE DIRECTION OF
C                        THE ARROW INDICATES THE DIRECTION OF THE FLOW
C                        AT THAT LOCATION.
C
C USAGE                  IF THE FOLLOWING ASSUMPTIONS ARE MET, USE
C
C                               CALL EZVEC (U,V,M,N)
C
C                          ASSUMPTIONS -
C
C                            --THE WHOLE ARRAY IS PROCESSED.
C                            --THE SCALE FACTOR IS CHOSEN INTERNALLY.
C                            --THE PERIMETER IS DRAWN.
C                            --FRAME IS CALLED AFTER PLOTTING.
C                            --THERE ARE NO SPECIAL VALUES.
C
C                        IF THESE ASSUMPTIONS ARE NOT MET, USE
C
C                               CALL VELVCT (U,LU,V,LV,M,N,FLO,HI,
C                                                 NSET,LENGTH,ISPV,SPV)
C
C ARGUMENTS
C
C ON INPUT               U,V
C
C                          THE (ORIGINS OF THE) TWO-DIMENSIONAL ARRAYS
C                          CONTAINING THE VELOCITY FIELD TO BE PLOTTED.
C                          THE VECTOR AT THE POINT (I,J) HAS MAGNITUDE
C                          SQRT(U(I,J)**2+V(I,J)**2) AND DIRECTION
C                          ATAN2(V(I,J),U(I,J)).  OTHER REPRESENTATIONS,
C                          SUCH AS (R,THETA), CAN BE PLOTTED BY
C                          CHANGING STATEMENT FUNCTIONS IN THIS ROUTINE.
C
C                        LU
C
C                          THE FIRST DIMENSION OF U IN THE CALLING
C                          PROGRAM.
C
C                        LV
C
C                          THE FIRST DIMENSION OF V IN THE CALLING
C                          PROGRAM.
C
C                        M
C
C                          THE NUMBER OF DATA VALUES TO BE PLOTTED IN
C                          THE X-DIRECTION (THE FIRST SUBSCRIPT
C                          DIRECTION).  WHEN PLOTTING THE ENTIRE ARRAY,
C                          LU = LV = M.
C
C                        N
C
C                          THE NUMBER OF DATA VALUES TO BE PLOTTED IN
C                          THE Y-DIRECTION (THE SECOND SUBSCRIPT
C                          DIRECTION).
C
C                        FLO
C
C                          THE MINIMUM VECTOR MAGNITUDE TO BE SHOWN.
C
C                        HI
C
C                          THE MAXIMUM VECTOR MAGNITUDE TO BE SHOWN. (A
C                          VALUE LESS THAN OR EQUAL TO ZERO CAUSES THE
C                          MAXIMUM VALUE OF SQRT(U**2+V**2) TO BE USED.)
C
C                        NSET
C
C                          FLAG TO CONTROL SCALING -
C
C                          IF NSET IS ZERO, VELVCT ESTABLISHES THE
C                          WINDOW AND VIEWPORT TO PROPERLY
C                          SCALE PLOTTING INSTRUCTIONS TO THE STANDARD
C                          CONFIGURATION.  PERIM IS CALLED TO DRAW A
C                          BORDER.
C
C                          IF NSET IS GREATER THAN ZERO, VELVCT ASSUMES
C                          THAT THE USER HAS ESTABLISHED THE WINDOW
C                          AND VIEWPORT IN SUCH A WAY AS TO PROPERLY
C                          SCALE THE PLOTTING INSTRUCTIONS GENERATED
C                          BY VELVCT.  PERIM IS NOT CALLED.
C
C                          IF NSET IS LESS THAN ZERO, VELVCT
C                          PLACES THE CONTOUR PLOT
C                          WITHIN THE LIMITS OF THE USER'S CURRENT
C                          WINDOW AND VIEWPORT.  PERIM IS NOT CALLED.
C
C                        LENGTH
C
C                          THE LENGTH, IN PLOTTER ADDRESS UNITS (PAUS),
C                          OF A VECTOR HAVING MAGNITUDE HI
C                          (OR, IF HI=0, THE LENGTH IN PAUS
C                          OF THE LONGEST VECTOR).  IF LENGTH=0, A
C                          VALUE IS CHOSEN SUCH THAT THE LONGEST VECTOR
C                          COULD JUST REACH TO THE TAIL OF THE NEXT
C                          VECTOR.  IF THE HORIZONTAL AND VERTICAL
C                          RESOLUTIONS OF THE PLOTTER ARE DIFFERENT,
C                          LENGTH SHOULD BE NON-ZERO AND SPECIFIED AS A
C                          HORIZONTAL DISTANCE.
C
C                        ISPV
C
C                          FLAG TO CONTROL THE SPECIAL VALUE FEATURE.
C
C                             0 MEANS THAT THE FEATURE IS NOT IN USE.
C
C                             1 MEANS THAT IF THE VALUE OF
C                               U(I,J)=SPV(1) THE VECTOR WILL NOT BE
C                               PLOTTED.
C
C                             2 MEANS THAT IF THE VALUE OF
C                               V(I,J)=SPV(2) THE VECTOR WILL NOT BE
C                               PLOTTED.
C
C                             3 MEANS THAT IF EITHER U(I,J)=SPV(1) OR
C                               V(I,J)=SPV(2) THEN THE VECTOR WILL NOT
C                               BE PLOTTED.
C
C                             4 MEANS THAT IF U(I,J)=SPV(1)
C                               AND V(I,J)=SPV(2), THE VECTOR
C                               WILL NOT BE PLOTTED.
C
C                        SPV
C
C                        AN ARRAY OF LENGTH 2 WHICH GIVES THE VALUE
C                        IN THE U ARRAY AND THE VALUE IN THE V ARRAY
C                        WHICH DENOTE MISSING VALUES.
C                        THIS ARGUMENT IS IGNORED IF ISPV=0.
C
C
C ON OUTPUT              ALL ARGUMENTS REMAIN UNCHANGED.
C
C NOTE                   THE ENDPOINTS OF EACH ARROW DRAWN ARE (FX(X,Y),
C                        FY(X,Y)) AND (MXF(X,Y,U,V,SFX,SFY,MX,MY),
C                        MYF(X,Y,U,V,SFX,SFY,MX,MY)) WHERE X=I, Y=J,
C                        U=U(I,J), V=V(I,J), AND SFX AND SFY ARE SCALE
C                        FACTORS.  HERE I IS THE X-INDEX AND J IS THE
C                        Y-INDEX.  (MX,MY) IS THE LOCATION OF THE TAIL.
C                        THUS THE ACTUAL LENGTH OF THE ARROW IS
C                        SQRT(DX**2+DY**2) AND THE DIRECTION IS
C                        ATAN2(DX,DY), WHERE DX=MX-MXF(...) AND
C                        DY=MY-MYF(...).
C
C ENTRY POINTS           VELVCT,EZVECT,DRWVEC,VELVEC,VELDAT
C
C COMMON BLOCKS          VEC1,VEC2
C
C I/O                    PLOTS THE VECTOR FIELD.
C
C PRECISION              SINGLE
C
C LANGUAGE               FORTRAN
C
C REQUIRED LIBRARY       GRIDAL AND THE SPPS
C ROUTINES
C
C HISTORY                WRITTEN AND STANDARDIZED IN NOVEMBER 1973.
C                        REVISED IN MAY, 1975, TO INCLUDE MXF AND MYF.
C                        REVISED IN MARCH, 1981, TO FIX CERTAIN ERRORS;
C                        TO USE FL2INT AND PLOTIT INSTEAD OF MXMY,
C                        FRSTPT, AND VECTOR; AND TO MAKE THE ARROWHEADS
C                        NARROWER.  CONVERTED TO FORTRAN77 AND GKS
C                        IN JULY 1984.
C
C ALGORITHM              EACH VECTOR IS EXAMINED, POSSIBLY TRANSFORMED,
C                        THEN PLOTTED.
C
C PORTABILITY            FORTRAN77
C
C ---------------------------------------------------------------------
C
C SPECIAL NOTE -
C
C USING THIS ROUTINE TO PUT VECTORS ON AN ARBITRARY BACKGROUND DRAWN BY
C SUPMAP IS A BIT TRICKY.  THE ARITHMETIC STATEMENT FUNCTIONS FX AND FY
C ARE EASY TO REPLACE.  THE PROBLEM ARISES IN REPLACING MXF AND MYF.
C THE FOLLOWING EXAMPLE MAY BE HELPFUL. (SUPMAP IS AN ENTRY POINT IN
C THE EZMAP PACKAGE.)
C
C SUPPOSE THAT WE HAVE TWO ARRAYS, CLON(36,9) AND CLAT(36,9), WHICH
C CONTAIN THE E-W AND N-S COMPONENTS OF A WIND FLOW FIELD ON THE SURFACE
C OF THE EARTH.  CLON(I,J) IS THE MAGNITUDE OF THE EASTERLY FLOW.
C CLAT(I,J) IS THE MAGNITUDE OF THE NORTHERLY FLOW AT A LONGITUDE (I-1)
C *10 DEGREES EAST OF GREENWICH AND A LATITUDE (J-1)*10 DEGREES NORTH OF
C THE EQUATOR.  SUPMAP IS TO BE USED TO DRAW A POLAR PROJECTION OF THE
C EARTH AND VELVCT IS TO BE USED TO SUPERIMPOSE VECTORS REPRESENTING THE
C FLOW FIELD ON IT.  THE FOLLOWING STEPS WOULD BE NECESSARY:
C
C     1.  CALL SUPMAP (1,90.,0.,-90.,90.,90.,90.,90.,-4,10,0,1,IER)
C         TO DRAW THE MAP.
C
C     2.  CALL VELVCT (CLON,36,CLAT,36,36,9,0.,0.,1,50,0,0.) TO PUT
C         VECTORS ON IT.  NOTICE THAT NSET HAS THE VALUE 1 TO TELL
C         VELVCT THAT SUPMAP HAS DONE THE REQUIRED SET CALL.
C
C     3.  IN ORDER TO ENSURE THAT STEP 2 WILL WORK PROPERLY, DELETE
C         THE ARITHMETIC STATEMENT FUNCTIONS FX, FY, MXF, AND MYF
C         FROM VELVCT AND INCLUDE THE FOLLOWING FUNCTIONS.
C
C     FUNCTION FX(XX,YY)
C     CALL MAPTRN (10.*(YY-1.),10.*(XX-1.),X,Y)
C     FX=X
C     RETURN
C     END
C
C     FUNCTION FY(XX,YY)
C     CALL MAPTRN (10.*(YY-1.),10.*(XX-1.),X,Y)
C     FY=Y
C     RETURN
C     END
C
C     FUNCTION MXF(XX,YY,UU,VV,SFX,SFY,MX,MY)
C     CFCT=COS(.17453292519943*(YY-1.))
C     CALL MAPTRN(10.*(YY-1.)         ,10.*(XX-1.)              ,X1,Y1)
C     CALL MAPTRN(10.*(YY-1.)+1.E-6*VV,10.*(XX-1.)+1.E-6*UU/CFCT,X2,Y2)
C     U=((X2-X1)/SQRT((X2-X1)**2+(Y2-Y1)**2))*SQRT(UU**2+VV**2)
C     MXF=MX+IFIX(SFX*U)
C     RETURN
C     END
C
C     FUNCTION MYF(XX,YY,UU,VV,SFX,SFY,MX,MY)
C     CFCT=COS(.17453292519943*(YY-1.))
C     CALL MAPTRN(10.*(YY-1.)         ,10.*(XX-1.)              ,X1,Y1)
C     CALL MAPTRN(10.*(YY-1.)+1.E-6*VV,10.*(XX-1.)+1.E-6*UU/CFCT,X2,Y2)
C     V=((Y2-Y1)/SQRT((X2-X1)**2+(Y2-Y1)**2))*SQRT(UU**2+VV**2)
C     MYF=MY+IFIX(SFY*V)
C     RETURN
C     END
C
C THE BASIC NOTION BEHIND THE CODING OF THE MXF AND MYF FUNCTIONS IS AS
C FOLLOWS.  SINCE UU AND VV ARE THE LONGITUDINAL AND LATITUDINAL COMPONENTS,
C RESPECTIVELY, OF A VELOCITY VECTOR HAVING UNITS OF DISTANCE OVER TIME,
C 1.E-6*UU/COS(LATITUDE) AND 1.E-6*VV REPRESENT THE CHANGE IN LONGITUDE
C AND LATITUDE, RESPECTIVELY, OF A PARTICLE MOVING WITH THE FLOW FIELD
C FOR A VERY SHORT PERIOD OF TIME.  THE ROUTINE MAPTRN IS USED TO FIND
C THE POSITION OF THE PARTICLE'S PROJECTION AT THE BEGINNING AND END OF
C THAT TINY TIME SLICE AND, THEREFORE, THE DIRECTION IN WHICH TO DRAW
C THE ARROW REPRESENTING THE VELOCITY VECTOR SO THAT IT WILL BE TANGENT
C TO A PROJECTED FLOW LINE OF THE FIELD AT THAT POINT.  THE VALUES U
C AND V ARE COMPUTED SO AS TO GIVE THE ARROW THE LENGTH IMPLIED BY UU
C AND VV.  (THE CODE ENSURES THAT SQRT(U**2+V**2) IS EQUAL TO
C SQRT(UU**2+VV**2).)  THE LENGTH OF THE ARROW REPRESENTS THE MAGNITUDE
C OF THE VELOCITY VECTOR, UNAFFECTED BY PERSPECTIVE.  THE SCALING SET
C UP BY VELVCT WILL THEREFORE BE APPROPRIATE FOR THE ARROWS DRAWN.
C
C THIS METHOD IS RATHER HEURISTIC AND HAS THREE INHERENT PROBLEMS.
C FIRST, THE CONSTANT 1.E-6 MAY NEED TO BE MADE LARGER OR SMALLER,
C DEPENDING ON THE MAGNITUDE OF YOUR U/V DATA.  SECOND, THE NORTH AND
C SOUTH POLES MUST BE AVOIDED.  AT EITHER POLE, CFCT GOES TO ZERO,
C GIVING A DIVISION BY ZERO; IN A SMALL REGION NEAR THE POLE, THE
C METHOD MAY TRY TO USE MAPTRN WITH A LATITUDE OUTSIDE THE RANGE
C (-90,+90).  THIRD, THE PROJECTION MUST BE SET UP SO AS TO AVOID
C HAVING VECTOR BASEPOINTS AT THE EXACT EDGE OF THE MAP.  VECTORS
C THERE WILL BE OF THE CORRECT LENGTH, BUT THEY MAY BE DRAWN IN THE
C WRONG DIRECTION (WHEN THE PROJECTED PARTICLE TRACK DETERMINING THE
C DIRECTION CROSSES THE EDGE AND REAPPEARS ELSEWHERE ON THE MAP).
C WITH A LITTLE CARE, THE DESIRED RESULTS MAY BE OBTAINED.
C ---------------------------------------------------------------------
C
C DECLARATIONS -
C
      COMMON /VEC1/   ASH        ,EXT        ,ICTRFG     ,ILAB       ,
     +                IOFFD      ,IOFFM      ,ISX        ,ISY        ,
     +                RMN        ,RMX        ,SIDE       ,SIZE       ,
     +                XLT        ,YBT        ,ZMN        ,ZMX
C
      COMMON /VEC2/   BIG        ,INCX       ,INCY
C
C ARGUMENT DIMENSIONS.
C
      DIMENSION       U(LU,N)    ,V(LV,N)    ,SPV(2)
        CHARACTER*10    LABEL
        REAL WIND(4), VIEW(4), IAR(4)
C
C ---------------------------------------------------------------------
C
C INTERNAL PARAMETERS OF VELVCT ARE AS FOLLOWS.  THE DEFAULT VALUES OF
C THESE PARAMETERS ARE DECLARED IN THE BLOCK DATA ROUTINE VELDAT.
C
C                        NAME   DEFAULT  FUNCTION
C                        ----   -------  --------
C
C                        BIG   R1MACH(2) CONSTANT USED TO INITIALIZE
C                                        POSSIBLE SEARCH FOR HI.
C
C                        EXT     0.25    THE LENGTHS OF THE SIDES OF THE
C                                        PLOT ARE PROPORTIONAL TO M AND
C                                        N WHEN NSET IS LESS THAN OR
C                                        EQUAL TO ZERO, EXCEPT WHEN
C                                        MIN(M,N)/MAX(M,N) IS LESS THAN
C                                        EXT, IN WHICH CASE A SQUARE
C                                        GRAPH IS PLOTTED.
C
C                        ICTRFG    1     FLAG TO CONTROL THE POSITION OF
C                                        THE ARROW RELATIVE TO  A BASE
C                                        POINT AT (MX,MY).
C
C                                        ZERO - CENTER AT (MX,MY)
C
C                                        POSITIVE - TAIL AT (MX,MY)
C
C                                        NEGATIVE -  HEAD AT (MX,MY)
C
C                        ILAB      0     FLAG TO CONTROL THE DRAWING OF
C                                        LINE LABELS.
C
C                                        ZERO - DO NOT DRAW THE LABELS
C
C                                        NON-ZERO - DRAW THE LABELS
C
C                        INCX      1     X-COORDINATE STEP SIZE FOR LESS
C                                        DENSE ARRAYS.
C
C                        INCY      1     Y-COORDINATE STEP SIZE.
C
C                        IOFFD     0     FLAG TO CONTROL NORMALIZATION
C                                        OF LABEL NUMBERS.
C
C                                        ZERO - INCLUDE A DECIMAL POINT
C                                        WHEN POSSIBLE
C
C                                        NON-ZERO - NORMALIZE ALL LABEL
C                                        NUMBERS BY ASH
C
C                        IOFFM     0     FLAG TO CONTROL PLOTTING OF
C                                        THE MESSAGE BELOW THE PLOT.
C
C                                        ZERO - PLOT THE MESSAGE
C
C                                        NON-ZERO - DO NOT PLOT IT
C
C                        RMN     160.    ARROW SIZE BELOW WHICH THE
C                                        HEAD NO LONGER SHRINKS, ON A
C                                        2**15 X 2**15 GRID.
C
C                        RMX    6400.    ARROW SIZE ABOVE WHICH THE
C                                        HEAD NO LONGER GROWS LARGER,
C                                        ON A 2**15 X 2**15 GRID.
C
C                        SIDE    0.90    LENGTH OF LONGER EDGE OF PLOT.
C                                        (SEE ALSO EXT.)
C
C                        SIZE    256.    WIDTH OF THE CHARACTERS IN
C                                        VECTOR LABELS, ON A 2**15 X
C                                        2**15 GRID.
C
C                        XLT     0.05    LEFT HAND EDGE OF THE PLOT.
C                                        (0 IS THE LEFT EDGE OF THE
C                                        FRAME, 1 THE RIGHT EDGE.)
C
C                        YBT     0.05    BOTTOM EDGE OF THE PLOT (0 IS
C                                        THE BOTTOM OF THE FRAME, 1 THE
C                                        TOP OF THE FRAME.)
C
C ---------------------------------------------------------------------
C
C INTERNAL FUNCTIONS WHICH MAY BE MODIFIED FOR DATA TRANSFORMATION -
C
C                        SCALE    COMPUTES A SCALE FACTOR USED IN THE
C                                 DETERMINATION OF THE LENGTH OF THE
C                                 VECTOR TO BE DRAWN.
C
C                        DIST     COMPUTES THE LENGTH OF A VECTOR.
C
C                        FX       RETURNS THE X INDEX AS THE
C                                 X-COORDINATE OF THE VECTOR BASE.
C
C                        MXF      RETURNS THE X-COORDINATE OF THE VECTOR
C                                 HEAD.
C
C                        FY       RETURNS THE Y INDEX AS THE
C                                 Y-COORDINATE OF THE VECTOR BASE.
C
C                        MYF      RETURNS THE Y-COORDINATE OF THE VECTOR
C                                 HEAD.
C
C                        VLAB     THE VALUE FOR THE VECTOR LABEL WHEN
C                                 ILAB IS NON-ZERO.
C
      SAVE
      DIST(XX,YY) = SQRT(XX*XX+YY*YY)
      FX(XX,YY) = XX
      FY(XX,YY) = YY
      MXF(XX,YY,UU,VV,SFXX,SFYY,MXX,MYY) = MXX+IFIX(SFXX*UU)
      MYF(XX,YY,UU,VV,SFXX,SFYY,MXX,MYY) = MYY+IFIX(SFYY*VV)
      SCALEX(MM,NN,INCXX,INCYY,HAA,XX1,XX2,YY1,YY2,XX3,XX4,YY3,YY4,
     1       LENN) = LENN/HAA
      SCALEY(MM,NN,INCXX,INCYY,HAA,XX1,XX2,YY1,YY2,XX3,XX4,YY3,YY4,
     1       LENN) = SCALEX(MM,NN,INCXX,INCYY,HAA,XX1,XX2,YY1,YY2,XX3,
     2                                                 XX4,YY3,YY4,LENN)
      VLAB(UU,VV,II,JJ) = DIST(UU,VV)
C
C FORCE THE BLOCK DATA ROUTINE, WHICH SETS DEFAULT VARIABLES, TO LOAD.
C +NOAO - blockdata replaced with run time initialization.
C
C     EXTERNAL        VELDAT
      call veldat
C -NOAO
C
C ---------------------------------------------------------------------
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR.
C
      CALL Q8QST4 ('NSSL','VELVCT','VELVCT','VERSION  6')
C
C INITIALIZE AND TRANSFER SOME ARGUMENTS TO LOCAL VARIABLES.
C
      BIG = -R1MACH(2)
      MX = LU
      MY = LV
      NX = M
      NY = N
      GL = FLO
      HA = HI
      ISP = ISPV
      NC = 0
C
C COMPUTE CONSTANTS BASED ON THE ADDRESSABILITY OF THE PLOTTER.
C
      CALL GETUSV('XF',ISX)
      CALL GETUSV('YF',ISY)
      ISX = 2**(15-ISX)
      ISY = 2**(15-ISY)
      LEN = LENGTH*ISX
C
C SET UP THE SCALING OF THE PLOT.
C
        CALL GQCNTN(IERR,IOLDNT)
        CALL GQNT(IOLDNT,IERR,WIND,VIEW)
        X1 = VIEW(1)
        X2 = VIEW(2)
        Y1 = VIEW(3)
        Y2 = VIEW(4)
        X3 = WIND(1)
        X4 = WIND(2)
        Y3 = WIND(3)
        Y4 = WIND(4)
        CALL GETUSV('LS',IOLLS)
C
C     SAVE NORMALIZATION TRANSFORMATION 1
C
      CALL GQNT(1,IERR,WIND,VIEW)
C
      IF (NSET) 101,102,106
C
  101 X3 = 1.
      X4 = FLOAT(NX)
      Y3 = 1.
      Y4 = FLOAT(NY)
      GO TO 105
C
  102 X1 = XLT
      X2 = XLT+SIDE
      Y1 = YBT
      Y2 = YBT+SIDE
      X3 = 1.
      Y3 = 1.
      X4 = FLOAT(NX)
      Y4 = FLOAT(NY)
      IF (AMIN1(X4,Y4)/AMAX1(X4,Y4) .LT. EXT) GO TO 105
C
      IF (NX-NY) 103,105,104
  103 X2 = XLT+SIDE*X4/Y4
      GO TO 105
  104 Y2 = YBT+SIDE*Y4/X4
C
  105 CALL SET(X1,X2,Y1,Y2,X3,X4,Y3,Y4,1)
      IF (NSET .EQ. 0) CALL PERIM (1,0,1,0)
C
C CALCULATE A LENGTH IF NONE PROVIDED.
C
  106 IF (LEN .NE. 0) GO TO 107
      CALL FL2INT(FX(1.,1.),FY(1.,1.),MX,MY)
      CALL FL2INT(FX(FLOAT(1+INCX),FLOAT(1+INCY)),
     +            FY(FLOAT(1+INCX),FLOAT(1+INCY)),LX,LY)
      LEN = SQRT((FLOAT(MX-LX)**2+FLOAT(MY-LY)**2)/2.)
C
C SET UP SPECIAL VALUES.
C
  107 IF (ISP .EQ. 0) GO TO 108
      SPV1 = SPV(1)
      SPV2 = SPV(2)
      IF (ISP .EQ. 4) SPV2 = SPV(1)
C
C FIND THE MAXIMUM VECTOR LENGTH.
C
  108 IF (HA .GT. 0.) GO TO 118
C
      HA = BIG
      IF (ISP .EQ. 0) GO TO 115
C
      DO 114 J=1,NY,INCY
         DO 113 I=1,NX,INCX
            IF (ISP-2) 109,111,110
  109       IF (U(I,J) .EQ. SPV1) GO TO 113
            GO TO 112
  110       IF (U(I,J) .EQ. SPV1) GO TO 113
  111       IF (V(I,J) .EQ. SPV2) GO TO 113
  112       HA = AMAX1(HA,DIST(U(I,J),V(I,J)))
  113    CONTINUE
  114 CONTINUE
      GO TO 126
C
  115 DO 117 J=1,NY,INCY
         DO 116 I=1,NX,INCX
            HA = AMAX1(HA,DIST(U(I,J),V(I,J)))
  116    CONTINUE
  117 CONTINUE
C
C BRANCH IF NULL VECTOR SIZE.
C
  126 IF (HA .LE. 0.) GO TO 125
C
C COMPUTE SCALE FACTORS.
C
  118 SFX = SCALEX(M,N,INCX,INCY,HA,X1,X2,Y1,Y2,X3,X4,Y3,Y4,LEN)
      SFY = SCALEY(M,N,INCX,INCY,HA,X1,X2,Y1,Y2,X3,X4,Y3,Y4,LEN)
      IOFFDT = IOFFD
      IF (GL.NE.0.0 .AND. (ABS(GL).LT.0.1 .OR. ABS(GL).GE.1.E5))
     1    IOFFDT = 1
      IF (HA.NE.0.0 .AND. (ABS(HA).LT.0.1 .OR. ABS(HA).GE.1.E5))
     1    IOFFDT = 1
      ASH = 1.0
      IF (IOFFDT .NE. 0)
     1    ASH = 10.**(3-IFIX(ALOG10(AMAX1(ABS(GL),ABS(HA)))-500.)-500)
      IZFLG = 0
C
C COMPUTE ZMN AND ZMX, WHICH ARE USED IN DRWVEC.
C
      ZMN = LEN*(GL/HA)
      ZMX = FLOAT(LEN)+.01
C
C DRAW THE VECTORS.
C
      DO 123 J=1,NY,INCY
         DO 122 I=1,NX,INCX
            UI = U(I,J)
            VI = V(I,J)
            IF (ISP-1) 121,119,120
  119       IF (UI-SPV1) 121,122,121
  120       IF (VI .EQ. SPV2) GO TO 122
            IF (ISP .GE. 3) GO TO 119
  121       X = I
            Y = J
            CALL FL2INT(FX(X,Y),FY(X,Y),MX,MY)
            LX = MAX0(1,MXF(X,Y,UI,VI,SFX,SFY,MX,MY))
            LY = MAX0(1,MYF(X,Y,UI,VI,SFX,SFY,MX,MY))
            IZFLG = 1
            IF (ILAB .NE. 0) CALL ENCD(VLAB(UI,VI,I,J),ASH,LABEL,NC,
     +                                                           IOFFDT)
            CALL DRWVEC (MX,MY,LX,LY,LABEL,NC)
  122    CONTINUE
  123 CONTINUE
C
      IF (IZFLG .EQ. 0) GO TO 125
C
      IF (IOFFM .NE. 0) GO TO 200
C +NOAO - FTN internal write replaced with call to encode
C     WRITE(LABEL,'(E10.3)')HA
      call encode (10, '(e10.3)', label, ha)
C -NOAO
C
C     TURN OFF CLIPPING SO ARROW CAN BE DRAWN
C
      CALL GQCLIP(IER,ICLP,IAR)
      CALL GSCLIP(0)
      CALL DRWVEC (28768,608,28768+LEN,608,LABEL,10)
C
C     RESTORE CLIPPING
C
      CALL GSCLIP(ICLP)
        IX = 1+(28768+LEN/2)/ISX
        IY = 1+(608-(5*ISX*MAX0(256/ISX,8))/4)/ISY
        CALL GQCNTN(IER,ICN)
        CALL GSELNT(0)
        XC = CPUX(IX)
        YC = CPUY(IY)
      CALL WTSTR (XC,YC,
     +                         'MAXIMUM VECTOR',MAX0(256/ISX,8),0,0)
      CALL GSELNT(ICN)
C
C DONE.
C
      GOTO 200
C
C ZERO-FIELD ACTION.
C
  125 IX = 1+16384/ISX
        IY = 1+16384/ISY
        CALL GQCNTN(IER,ICN)
        CALL GSELNT(0)
        XC = CPUX(IX)
        YC = CPUY(IY)
      CALL WTSTR (XC,YC,
     +                             'ZERO FIELD',MAX0(960/ISX,8),0,0)
        CALL GSELNT(ICN)
C
C RESTORE TRANS 1 AND LOG SCALING AND ORIGINAL TRANS NUMBER
C
  200 CONTINUE
      IF (NSET .LE. 0) THEN
        CALL SET(VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     -           WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
      ENDIF
      CALL GSELNT(IOLDNT)
      RETURN
      END
      SUBROUTINE EZVEC (U,V,M,N)
C
C THIS SUBROUTINE IS FOR THE USER WHO WANTS A QUICK-AND-DIRTY VECTOR
C PLOT WITH DEFAULT VALUES FOR MOST OF THE ARGUMENTS.
C
        SAVE
C
      DIMENSION       U(M,N)     ,V(M,N)     ,SPVAL(2)
C
      DATA FLO,HI,NSET,LENGTH,ISPV,SPVAL(1),SPVAL(2) /
     +      0.,0.,   0,     0,   0,      0.,      0. /
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR.
C
      CALL Q8QST4 ('CRAYLIB','VELVCT','EZVEC','VERSION  6')
C
      CALL VELVCT (U,M,V,M,M,N,FLO,HI,NSET,LENGTH,ISPV,SPVAL)
C +NOAO - call to frame is suppressed.
C     CALL FRAME
C -NOAO
      RETURN
      END
      SUBROUTINE DRWVEC (M1,M2,M3,M4,LABEL,NC)
C
C THIS ROUTINE IS CALLED TO DRAW A SINGLE ARROW.  IT HAS ARGUMENTS AS
C FOLLOWS -
C
C     (M1,M2)  -  COORDINATE OF ARROW BASE, ON A 2**15 X 2**15 GRID.
C     (M3,M4)  -  COORDINATE OF ARROW HEAD, ON A 2**15 X 2**15 GRID.
C     LABEL    -  CHARACTER LABEL TO BE PUT ABOVE ARROW.
C     NC       -  NUMBER OF CHARACTERS IN LABEL.
C
        SAVE
C
C
      COMMON /VEC1/   ASH        ,EXT        ,ICTRFG     ,ILAB       ,
     +                IOFFD      ,IOFFM      ,ISX        ,ISY        ,
     +                RMN        ,RMX        ,SIDE       ,SIZE       ,
     +                XLT        ,YBT        ,ZMN        ,ZMX
        CHARACTER*10 LABEL
C
C SOME LOCAL PARAMETERS ARE THE FOLLOWING -
C
C     CL     -  ARROW HEAD LENGTH SCALE FACTOR - EACH SIDE OF THE ARROW
C               HEAD IS THIS LONG RELATIVE TO THE LENGTH OF THE ARROW
C     ST,CT  -  SIN AND COS OF THE ARROW HEAD ANGLE
C     PI     -  THE CONSTANT PI
C     TWOPI  -  TWO TIMES PI
C     OHOPI  -  ONE HALF OF PI
C     FHOPI  -  FIVE HALVES OF PI
C
      DATA    CL / .25 /
      DATA    ST / .382683432365090 /
      DATA    CT / .923879532511287 /
      DATA    PI / 3.14159265358979 /
      DATA TWOPI / 6.28318530717959 /
      DATA OHOPI / 1.57079632679489 /
      DATA FHOPI / 7.85398163397448 /
C
      DIST(X,Y) = SQRT(X*X+Y*Y)
C
C TRANSFER ARGUMENTS TO LOCAL VARIABLES AND COMPUTE THE VECTOR LENGTH.
C
      N1 = M1
      N2 = M2
      N3 = M3
      N4 = M4
      DX = N3-N1
      DY = N4-N2
      R = DIST(DX,DY)
C
C SORT OUT POSSIBLE CASES, DEPENDING ON VECTOR LENGTH.
C
      IF (R .LE. ZMN) RETURN
C
      IF (R .LE. ZMX) GO TO 101
C
C PLOT A POINT FOR VECTORS WHICH ARE TOO LONG.
C
      CALL PLOTIT (N1,N2,0)
      CALL PLOTIT (N1,N2,1)
      CALL PLOTIT (N1,N2,0)
      RETURN
C
C ADJUST THE COORDINATES OF THE VECTOR ENDPOINTS AS IMPLIED BY THE
C CENTERING OPTION.
C
  101 IF (ICTRFG) 102,103,104
C
  102 N3 = N1
      N4 = N2
      N1 = FLOAT(N1)-DX
      N2 = FLOAT(N2)-DY
      GO TO 104
C
  103 N1 = FLOAT(N1)-.5*DX
      N2 = FLOAT(N2)-.5*DY
      N3 = FLOAT(N3)-.5*DX
      N4 = FLOAT(N4)-.5*DY
C
C DETERMINE THE COORDINATES OF THE POINTS USED TO DRAW THE ARROWHEAD.
C
  104 C1 = CL
C
C SHORT ARROWS HAVE HEADS OF A FIXED MINIMUM SIZE.
C
      IF (R .LT. RMN) C1 = RMN*CL/R
C
C LONG ARROWS HAVE HEADS OF A FIXED MAXIMUM SIZE.
C
      IF (R .GT. RMX) C1 = RMX*CL/R
C
C COMPUTE THE COORDINATES OF THE HEAD.
C
      N5 = FLOAT(N3)-C1*(CT*DX-ST*DY)
      N6 = FLOAT(N4)-C1*(CT*DY+ST*DX)
      N7 = FLOAT(N3)-C1*(CT*DX+ST*DY)
      N8 = FLOAT(N4)-C1*(CT*DY-ST*DX)
C
C PLOT THE ARROW.
C
      CALL PLOTIT (N1,N2,0)
      CALL PLOTIT (N3,N4,1)
      CALL PLOTIT (N5,N6,0)
      CALL PLOTIT (N3,N4,1)
      CALL PLOTIT (N7,N8,1)
      CALL PLOTIT (0,0,0)
C
C IF REQUESTED, PUT THE VECTOR MAGNITUDE ABOVE THE ARROW.
C
      IF (NC .EQ. 0) RETURN
      PHI = ATAN2(DY,DX)
      IF (AMOD(PHI+FHOPI,TWOPI) .GT. PI) PHI = PHI+PI
      IX = 1+IFIX(.5*FLOAT(N1+N3)+1.25*
     +            FLOAT(ISX*MAX0(IFIX(SIZE)/ISX,8))*COS(PHI+OHOPI))/ISX
      IY = 1+IFIX(.5*FLOAT(N2+N4)+1.25*
     +            FLOAT(ISX*MAX0(IFIX(SIZE)/ISX,8))*SIN(PHI+OHOPI))/ISY
        CALL GQCNTN(IER,ICN)
        CALL GSELNT(0)
        XC = CPUX(IX)
        YC = CPUY(IY)
      CALL WTSTR(XC,YC,
     +           LABEL,MAX0(IFIX(SIZE)/ISX,8),
     +                                     IFIX(57.2957795130823*PHI),0)
        CALL GSELNT(ICN)
      RETURN
      END
      SUBROUTINE VELVEC (U,LU,V,LV,M,N,FLO,HI,NSET,ISPV,SPV)
C
C THIS ROUTINE SUPPORTS USERS OF THE OLD VERSION OF THIS PACKAGE.
C
      DIMENSION       U(LU,N)    ,V(LV,N)    ,SPV(2)
C
        SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR.
C
      CALL Q8QST4 ('CRAYLIB','VELVCT','VELVEC','VERSION  4')
      CALL VELVCT (U,LU,V,LV,M,N,FLO,HI,NSET,0,ISPV,SPV)
      RETURN
      END
C
C REVISION HISTORY ----------------------------------------------------
C
C FEBRUARY, 1979   ADDED REVISION HISTORY
C                  MODIFIED CODE TO CONFORM TO FORTRAN 66 STANDARD
C
C JULY, 1979       FIXED HI VECTOR TRAP AND MESSAGE INDICATING
C                  MAXIMUM VECTOR PLOTTED.
C
C DECEMBER, 1979   CHANGED THE STATISTICS CALL FROM CRAYLIB TO NSSL
C
C MARCH, 1981      FIXED SOME FRINGE-CASE ERRORS, CHANGED THE CODE TO
C                  USE FL2INTT AND PLOTIT INSTEAD OF MXMY, FRSTPT, AND
C                  VECTOR, AND MADE THE ARROWHEADS NARROWER (45 DEGREES
C                  APART, RATHER THAN 60 DEGREES APART)
C
C FEBRUARY, 1984   PROVIDED A DIMENSION STATEMENT FOR A VARIABLE INTO
C                  WHICH A TEN-CHARACTER STRING WAS BEING ENCODED.  ON
C                  THE CRAY, WHEN THE ENCODE WAS DONE, A WORD FOLLOWING
C                  THE VARIABLE WAS CLOBBERED, BUT THIS APPARENTLY MADE
C                  NO DIFFERENCE.  ON AT LEAST ONE OTHER MACHINE, THE
C                  CODE BLEW UP.  (ERROR REPORTED BY GREG WOODS)
C
C JULY, 1984       CONVERTED TO FORTRAN77 AND GKS.
C
C ---------------------------------------------------------------------

      SUBROUTINE COSQF (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
      DATA SQRT2 /1.4142135623731/
      IF (N.lt.2) GO TO 102
      IF (N.eq.2) GO TO 101
      GO TO 103
  101 TSQX = SQRT2*X(2)
      X(2) = X(1)-TSQX
      X(1) = X(1)+TSQX
  102 RETURN
  103 CALL COSQF1 (N,X,WSAVE,WSAVE(N+1))
      RETURN
      END
      SUBROUTINE COSQF1 (N,X,W,XH)
      DIMENSION       X(1)       ,W(1)       ,XH(1)
      NS2 = (N+1)/2
      NP2 = N+2
      DO 101 K=2,NS2
         KC = NP2-K
         XH(K) = X(K)+X(KC)
         XH(KC) = X(K)-X(KC)
  101 CONTINUE
      MODN = MOD(N,2)
      IF (MODN .EQ. 0) XH(NS2+1) = X(NS2+1)+X(NS2+1)
      DO 102 K=2,NS2
         KC = NP2-K
         X(K) = W(K-1)*XH(KC)+W(KC-1)*XH(K)
         X(KC) = W(K-1)*XH(K)-W(KC-1)*XH(KC)
  102 CONTINUE
      IF (MODN .EQ. 0) X(NS2+1) = W(NS2)*XH(NS2+1)
      CALL RFFTF (N,X,XH)
      DO 103 I=3,N,2
         XIM1 = X(I-1)-X(I)
         X(I) = X(I-1)+X(I)
         X(I-1) = XIM1
  103 CONTINUE
      RETURN
      END

      SUBROUTINE slREFZ (ZU, REFA, REFB, ZR)
*+
*     - - - - -
*      R E F Z
*     - - - - -
*
*  Adjust an unrefracted zenith distance to include the effect of
*  atmospheric refraction, using the simple A tan Z + B tan**3 Z
*  model (plus special handling for large ZDs).
*
*  Given:
*    ZU    dp    unrefracted zenith distance of the source (radian)
*    REFA  dp    tan Z coefficient (radian)
*    REFB  dp    tan**3 Z coefficient (radian)
*
*  Returned:
*    ZR    dp    refracted zenith distance (radian)
*
*  Notes:
*
*  1  This routine applies the adjustment for refraction in the
*     opposite sense to the usual one - it takes an unrefracted
*     (in vacuo) position and produces an observed (refracted)
*     position, whereas the A tan Z + B tan**3 Z model strictly
*     applies to the case where an observed position is to have the
*     refraction removed.  The unrefracted to refracted case is
*     harder, and requires an inverted form of the text-book
*     refraction models;  the formula used here is based on the
*     Newton-Raphson method.  For the utmost numerical consistency
*     with the refracted to unrefracted model, two iterations are
*     carried out, achieving agreement at the 1D-11 arcseconds level
*     for a ZD of 80 degrees.  The inherent accuracy of the model
*     is, of course, far worse than this - see the documentation for
*     slRFCO for more information.
*
*  2  At ZD 83 degrees, the rapidly-worsening A tan Z + B tan^3 Z
*     model is abandoned and an empirical formula takes over.  For
*     optical/IR wavelengths, over a wide range of observer heights and
*     corresponding temperatures and pressures, the following levels of
*     accuracy (arcsec, worst case) are achieved, relative to numerical
*     integration through a model atmosphere:
*
*              ZR    error
*
*              80      0.7
*              81      1.3
*              82      2.4
*              83      4.7
*              84      6.2
*              85      6.4
*              86      8
*              87     10
*              88     15
*              89     30
*              90     60
*              91    150         } relevant only to
*              92    400         } high-elevation sites
*
*     For radio wavelengths the errors are typically 50% larger than
*     the optical figures and by ZD 85 deg are twice as bad, worsening
*     rapidly below that.  To maintain 1 arcsec accuracy down to ZD=85
*     at the Green Bank site, Condon (2004) has suggested amplifying
*     the amount of refraction predicted by slREFZ below 10.8 deg
*     elevation by the factor (1+0.00195*(10.8-E_t)), where E_t is the
*     unrefracted elevation in degrees.
*
*     The high-ZD model is scaled to match the normal model at the
*     transition point;  there is no glitch.
*
*  3  Beyond 93 deg zenith distance, the refraction is held at its
*     93 deg value.
*
*  4  See also the routine slREFV, which performs the adjustment in
*     Cartesian Az/El coordinates, and with the emphasis on speed
*     rather than numerical accuracy.
*
*  Reference:
*
*     Condon,J.J., Refraction Corrections for the GBT, PTCS/PN/35.2,
*     NRAO Green Bank, 2004.
*
*  P.T.Wallace   Starlink   9 April 2004
*
*  Copyright (C) 2004 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION ZU,REFA,REFB,ZR

*  Radians to degrees
      DOUBLE PRECISION R2D
      PARAMETER (R2D=57.29577951308232D0)

*  Largest usable ZD (deg)
      DOUBLE PRECISION D93
      PARAMETER (D93=93D0)

*  Coefficients for high ZD model (used beyond ZD 83 deg)
      DOUBLE PRECISION C1,C2,C3,C4,C5
      PARAMETER (C1=+0.55445D0,
     :           C2=-0.01133D0,
     :           C3=+0.00202D0,
     :           C4=+0.28385D0,
     :           C5=+0.02390D0)

*  ZD at which one model hands over to the other (radians)
      DOUBLE PRECISION Z83
      PARAMETER (Z83=83D0/R2D)

*  High-ZD-model prediction (deg) for that point
      DOUBLE PRECISION REF83
      PARAMETER (REF83=(C1+C2*7D0+C3*49D0)/(1D0+C4*7D0+C5*49D0))

      DOUBLE PRECISION ZU1,ZL,S,C,T,TSQ,TCU,REF,E,E2



*  Perform calculations for ZU or 83 deg, whichever is smaller
      ZU1 = MIN(ZU,Z83)

*  Functions of ZD
      ZL = ZU1
      S = SIN(ZL)
      C = COS(ZL)
      T = S/C
      TSQ = T*T
      TCU = T*TSQ

*  Refracted ZD (mathematically to better than 1 mas at 70 deg)
      ZL = ZL-(REFA*T+REFB*TCU)/(1D0+(REFA+3D0*REFB*TSQ)/(C*C))

*  Further iteration
      S = SIN(ZL)
      C = COS(ZL)
      T = S/C
      TSQ = T*T
      TCU = T*TSQ
      REF = ZU1-ZL+
     :          (ZL-ZU1+REFA*T+REFB*TCU)/(1D0+(REFA+3D0*REFB*TSQ)/(C*C))

*  Special handling for large ZU
      IF (ZU.GT.ZU1) THEN
         E = 90D0-MIN(D93,ZU*R2D)
         E2 = E*E
         REF = (REF/REF83)*(C1+C2*E+C3*E2)/(1D0+C4*E+C5*E2)
      END IF

*  Return refracted ZD
      ZR = ZU-REF

      END

chapter ii. runge example
c  from  * a practical guide to splines *  by c. de boor
      integer i,istep,j,k,n,nmk,nm1
      real aloger,algerp,d(20),decay,dx,errmax,g,h,pnatx,step,tau(20),x
      data step, istep /20., 20/
      g(x) = 1./(1.+(5.*x)**2)
      print 600
  600 format(28h  n   max.error   decay exp.//)
      decay = 0.
      do 40 n=2,20,2
c	 choose interpolation points  tau(1), ..., tau(n) , equally
c	 spaced in (-1,1), and set  d(i) = g(tau(i)), i=1,...,n.
	 nm1 = n-1
	 h = 2./float(nm1)
	 do 10 i=1,n
	    tau(i) = float(i-1)*h - 1.
   10	    d(i) = g(tau(i))
c	 calculate the divided differences for the newton form.
c
	 do 20 k=1,nm1
	    nmk = n-k
	    do 20 i=1,nmk
   20	       d(i) = (d(i+1)-d(i))/(tau(i+k)-tau(i))
c
c	 estimate max.interpolation error on (-1,1).
	 errmax = 0.
	 do 30 i=2,n
	    dx = (tau(i)-tau(i-1))/step
	    do 30 j=1,istep
	       x = tau(i-1) + float(j)*dx
c	       evaluate interp.pol. by nested multiplication
c
	       pnatx = d(1)
	       do 29 k=2,n
   29		  pnatx = d(k) + (x-tau(k))*pnatx
c
   30	       errmax = amax1(errmax,abs(g(x)-pnatx))
	 aloger = alog(errmax)
	 if (n .gt. 2)	decay =
     *	     (aloger - algerp)/alog(float(n)/float(n-2))
	 algerp = aloger
   40	 print 640,n,errmax,decay
  640 format(i3,e12.4,f11.2)
					stop
      end

C----------------------------------------------------------------------
        subroutine ftpcls(ounit,colnum,frow,felem,nelem,sray,status)

C       write an array of character string values to the  specified column of 
C       the table.
C       The binary or ASCII table column being written to must have datatype 'A'

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       sray    c  array of data values to be written
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,frow,felem,nelem,status
        character*(*) sray(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bstart,strlen,c1,c2,repeat,twidth
        integer ibuff,i1,ntodo,rstart,estart,nchars,clen,tcode
        character sbuff*80,blank*80,crow*9,cp1*9,cp2*9,ccol*4
        logical small,fill
        
        if (status .gt. 0)return

C       check for zero length array
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table write '//
     &          'request is out of range:'//crow//' (FTPCLS).')
                return
        end if
        if (felem .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &          'request is out of range:'//crow//' (FTPCLS).')
                return
        end if

        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)

        blank=' '
        i1=1

C       column must be character string data type
        tcode=tdtype(colnum+tstart(ibuff)) 
        if (tcode .eq. 16)then
C               for ASCII columns, TNULL actually stores the field width
                twidth=tnull(colnum+tstart(ibuff)) 
                ntodo=nelem
                rstart=frow-1
                repeat=trept(colnum+tstart(ibuff))
                estart=felem-1
                if (estart .ge. repeat)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for write '//
     &          'request is out of range:'//crow//' (FTPCLS).')
                        return
                end if
                bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)
     &                 +tbcol(colnum+tstart(ibuff))+estart*twidth
        else if (tcode .eq. -16)then
C               this is a variable length descriptor field
C               the length of the output string is defined by nelem
                twidth=nelem
                ntodo=1
                repeat=1
C               write the number of string length and the starting offset:
                call ftpdes(ounit,colnum,frow,twidth,
     &                              nxheap(ibuff),status)
C               calc the i/o pointer position for the start of the string
                bstart=dtstrt(ibuff)+nxheap(ibuff)+theap(ibuff)
C               increment the empty heap starting address:
                nxheap(ibuff)=nxheap(ibuff)+twidth
        else
C               error: not a character string column
                status=309
                return
        end if

C       move the i/o pointer to the start of the sequence of pixels
        call ftmbyt(ounit,bstart,.true.,status)

C       is the input string short enough to completely fit in buffer?
        strlen=len(sray(1))
        if (strlen .gt. 80 .and. twidth .gt. 80)then
                small=.false.
        else
                small=.true.
        end if

C       do we need to pad the FITS string field with trailing blanks?
        if (twidth .gt. strlen)then
                fill=.true.
        else
                fill=.false.
        end if

C       process one string at a time
20      continue
        nchars=min(strlen,twidth)
        if (small)then
C               the whole input string fits in the temporary buffer
                sbuff=sray(i1)
C               output the string
                call ftpcbf(ounit,1,nchars,sbuff,status)
        else
C               have to write the string in several pieces
                c1=1
                c2=80
30              sbuff=sray(i1)(c1:c2)
C               output the string
                clen=c2-c1+1
                call ftpcbf(ounit,1,clen,sbuff,status)
                nchars=nchars-clen
                if (nchars .gt. 0)then
                        c1=c1+80
                        c2=min(c2+80,c1+nchars-1)
                        go to 30
                end if
        end if

C       pad any remaining space in the column with blanks
        if (fill)then
                nchars=twidth-strlen
40              clen=min(nchars,80)
                call ftpcbf(ounit,1,clen,blank,status)
                nchars=nchars-80
                if (nchars .gt. 0)go to 40
        end if

        if (status .gt. 0)then
          write(cp1,2000)i1
          call ftpmsg('Error while writing ASCII string to ')
             write(ccol,2001)colnum
2001         format(i4)
             write(cp1,2000)rstart+1
             write(cp2,2000)estart+1
             if (felem .eq. 1)then
               call ftpmsg('column'//ccol//', row'//cp1
     &                    //' (FTPCLS).')
             else
               call ftpmsg('column'//ccol//', row'//cp1
     &         //', element'//cp2//' (FTPCLS).')    
             end if
          return
        end if

C       find number of pixels left to do, and quit if none left
        ntodo=ntodo-1
        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+1
                estart=estart+1
                if (estart .eq. repeat)then
                        estart=0
                        rstart=rstart+1
                        bstart=dtstrt(ibuff)+rstart*rowlen(ibuff)+
     &                  tbcol(colnum+tstart(ibuff))
C                       move the i/o pointer 
                        call ftmbyt(ounit,bstart,.true.,status)
                end if
                go to 20
        end if
        end

      SUBROUTINE ISOSRF (T,LU,MU,LV,MV,MW,EYE,MUVWP2,SLAB,TISO,IFLAG)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C DIMENSION OF           T(LU,LV,MW),EYE(3),SLAB(MUVWP2,MUVWP2)
C ARGUMENTS
C
C LATEST REVISION        DECEMBER 1984
C
C PURPOSE                ISOSRF DRAWS AN APPROXIMATION OF AN ISO-VALUED
C                        SURFACE FROM A THREE-DIMENSIONAL ARRAY WITH
C                        HIDDEN LINES REMOVED.
C
C USAGE                  IF THE FOLLOWING ASSUMPTIONS ARE MET, USE
C
C                            CALL EZISOS (T,MU,MV,MW,EYE,SLAB,TISO)
C
C                               ASSUMPTIONS:
C                                 -- ALL OF THE T ARRAY IS TO BE USED.
C                                 -- IFLAG IS CHOSEN INTERNALLY.
C                                 -- FRAME IS CALLED BY EZISOS.
C
C                        IF THE ASSUMPTIONS ARE NOT MET, USE
C
C                            CALL ISOSRF (T,LU,MU,LV,MV,MW,EYE,MUVWP2,
C                                         SLAB,TISO,IFLAG)
C
C ARGUMENTS
C
C ON INPUT               T
C                          THREE DIMENSIONAL ARRAY OF DATA THAT DEFINES
C                          THE ISO-VALUED SURFACE.
C
C                        LU
C                          FIRST DIMENSION OF T IN THE CALLING PROGRAM.
C
C                        MU
C                          THE NUMBER OF DATA VALUES OF T TO BE
C                          PROCESSED IN THE U DIRECTION (THE FIRST
C                          SUBSCRIPT DIRECTION).  WHEN PROCESSING THE
C                          ENTIRE ARRAY, LU = MU (AND LV = MV).
C
C                        LV
C                          SECOND DIMENSION OF T IN THE CALLING PROGRAM.
C
C                        MV
C                          THE NUMBER OF DATA VALUES OF T TO BE
C                          PROCESSED IN THE V DIRECTION (THE SECOND
C                          SUBSCRIPT DIRECTION).
C
C                        MV
C                          THE NUMBER OF DATA VALUES OF T TO BE
C                          PROCESSED IN THE W DIRECTION (THE THIRD
C                          SUBSCRIPT DIRECTION).
C
C                        EYE
C                          THE POSITION OF THE EYE IN THREE-SPACE.  T IS
C                          CONSIDERED TO BE IN A BOX WITH OPPOSITE
C                          CORNERS (1,1,1) AND (MU,MV,MW).  THE EYE IS
C                          AT (EYE(1),EYE(2),EYE(3)), WHICH MUST BE
C                          OUTSIDE THE BOX THAT CONTAINS T.  WHILE GAINING
C                          EXPERIENCE WITH THE ROUTINE, A GOOD CHOICE
C                          FOR EYE MIGHT BE (5.0*MU,3.5*MV,2.0*MW).
C
C                        MUVWP2
C                          THE MAXIMUM OF (MU,MV,MW)+2; THAT IS,
C                          MUVWP2 = MAX(MU,MV,MW)+2).
C
C                        SLAB
C                          A WORK SPACE USED FOR INTERNAL STORAGE.  SLAB
C                          MUST BE AT LEAST MUVWP2*MUVWP2 WORDS LONG.
C
C                        TISO
C                          THE ISO-VALUE USED TO DEFINE THE SURFACE.  THE
C                          SURFACE DRAWN WILL SEPARATE VOLUMES OF T THAT
C                          HAVE VALUES GREATER THAN OR EQUAL TO TISO FROM
C                          VOLUMES OF T THAT HAVE VALUES LESS THAN TISO.
C
C                        IFLAG
C                          THIS FLAG SERVES TWO PURPOSES.
C                          .  FIRST, THE ABSOLUTE VALUE OF IFLAG
C                             DETERMINES WHICH TYPES OF LINES ARE DRAWN
C                             TO APPROXIMATE THE SURFACE.  THREE TYPES
C                             OF LINES ARE CONSIDERED:  LINES OF
C                             CONSTANT U, LINES OF CONSTANT V AND LINES
C                             OF CONSTANT W.  THE FOLLOWING TABLE LISTS
C                             THE TYPES OF LINES DRAWN.
C
C                                                LINES OF CONSTANT
C                                                -----------------
C                             IABS(IFLAG)           U    V    W
C                             -----------          ---  ---  ---
C                                  1               NO   NO   YES
C                                  2               NO   YES  NO
C                                  3               NO   YES  YES
C                                  4               YES  NO   NO
C                                  5               YES  NO   YES
C                                  6               YES  YES  NO
C                             0, 7 OR MORE         YES  YES  YES
C
C                          .  SECOND, THE SIGN OF IFLAG DETERMINES WHAT
C                             IS INSIDE AND WHAT IS OUTSIDE, HENCE,
C                             WHICH LINES ARE VISIBLE AND WHAT IS DONE
C                             AT THE BOUNDARY OF T.  FOR IFLAG:
C
C                             POSITIVE   T VALUES GREATER THAN TISO ARE
C                                        ASSUMED TO BE INSIDE THE SOLID
C                                        FORMED BY THE DRAWN SURFACE.
C                             NEGATIVE   T VALUES LESS THAN TISO ARE
C                                        ASSUMED TO BE INSIDE THE SOLID
C                                        FORMED BY THE DRAWN SURFACE.
C                             IF THE ALGORITHM DRAWS A CUBE, REVERSE THE
C                             SIGN OF IFLAG.
C
C ON OUTPUT              T,LU,MU,LV,MV,MW,EYE,MUVWP2,TISO AND IFLAG ARE
C                        UNCHANGED.  SLAB HAS BEEN WRITTEN IN.
C
C NOTE                   .   THIS ROUTINE IS FOR LOWER RESOLUTION ARRAYS
C                            THAN ISOSRFHR.  40 BY 40 BY 40 IS A
C                            PRACTICAL MAXIMUM.
C                        .   TRANSFORMATIONS CAN BE ACHIEVED BY
C                            ADJUSTING SCALING STATEMENT FUNCTIONS IN
C                            ISOSRF, SET3D AND TR32.
C                        .   THE HIDDEN-LINE ALGORITHM IS NOT EXACT, SO
C                            VISIBILITY ERRORS CAN OCCUR.
C                        .   THREE-DIMENSIONAL PERSPECTIVE CHARACTER
C                            LABELING OF ISOSRF IS POSSIBLE BY USING
C                            THE UTILITY PWRZI.  FOR A DESCRIPTION OF
C                            THE USAGE, SEE THE PWRZI DOCUMENTATION.
C
C ENTRY POINTS           ISOSRF, EZISOS, SET3D, TRN32I, ZEROSC,
C                        STCNTR, DRCNTR, TR32, FRSTS, KURV1S, KURV2S,
C                        FRSTC, FILLIN, DRAWI, ISOSRB, MMASK
C
C COMMON BLOCKS          ISOSR1, ISOSR2, ISOSR3, ISOSR4, ISOSR5,
C                        ISOSR6, ISOSR7, ISOSR8, ISOSR9, TEMPR,
C                        PWRZ1I
C
C REQUIRED LIBRARY       THE ERPRT77 PACKAGE AND THE SPPS.
C ROUTINES
C
C I/O                    PLOTS SURFACE
C
C PRECISION              SINGLE
C
C LANGUAGE               FORTRAN 77
C
C HISTORY                DEVELOPED FOR USERS OF ISOSRFHR WITH SMALLER
C                        ARRAYS.
C
C ALGORITHM              CUTS THROUGH THE THREE-DIMENSIONAL ARRAY ARE
C                        CONTOURED WITH A SMOOTHING CONTOURER WHICH ALSO
C                        MARKS A MODEL OF THE PLOTTING PLANE.  INTERIORS
C                        OF BOUNDARIES ARE FILLED IN AND THE RESULT IS
C                        .OR.ED INTO ANOTHER MODEL OF THE PLOTTING PLANE
C                        WHICH IS USED TO TEST SUBSEQUENT CONTOUR LINES
C                        FOR VISIBILITY.
C
C TIMING                 VARIES WIDELY WITH SIZE OF T AND THE VOLUME OF
C                        THE SPACE ENCLOSED BY THE SURFACE DRAWN.
C
C  **NOTE**                  SPACE REQUIREMENTS CAN BE REDUCED BY
C                            CHANGING THE SIZE OF THE ARRAYS ISCR, ISCA
C                            (FOUND IN COMMON ISOSR2), MASK(FOUND IN
C                            COMMON ISOSR5) AND THE VARIABLE NBPW
C                            (COMMON ISOSR5).
C                            ISCR AND ISCA NEED 128X128 BITS.  SO ON A
C                            64 BIT MACHINE ISCR, ISCA CAN BE
C                            DIMENSIONED TO (2,128). NBPW SET IN
C                            SUBROUTINE MMASK SHOULD CONTAIN THE
C                            NUMBER OF BITS PER WORD YOU WISH TO
C                            UTILIZE.
C                            THE DIMENSION OF MASK AND NMASK SHOULD
C                            EQUAL THE VALUE OF NBPW.
C                            LS SHOULD BE SET TO THE FIRST DIMENSION
C                            OF ISCA AND ISCR.
C
C               EXAMPLES:
C                            ON A 60 BIT MACHINE:
C                                 DIMENSION ISCA(4,128), ISCR(4,128)
C                                 DIMENSION MASK(32)
C                                 NBPW = 32
C                            ON A 64 BIT MACHINE:
C                                 DIMENSION ISCA(2,128), ISCR(2,128)
C                                 DIMENSION MASK(64)
C                                 NBPW = 64
C
C INTERNAL PARAMETERS    NAME  DEFAULT           FUNCTION
C                        ----  -------           --------
C                        IREF     1     FLAG TO CONTROL DRAWING OF AXES.
C                                       .IREF=NONZERO   DRAW AXES.
C                                       .IREF=ZERO      DO NOT DRAW AXES.
C
C
      SAVE
      DIMENSION       T(LU,LV,MW),EYE(3)     ,SLAB(MUVWP2,MUVWP2)
C
      COMMON /ISOSR1/ ISLBT      ,U          ,V          ,W
      COMMON /ISOSR2/ LX         ,NX         ,NY         ,ISCR(8,128),
     1                ISCA(8,128)
      COMMON /ISOSR3/ ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0
      COMMON /ISOSR4/ RX         ,RY
      COMMON /ISOSR5/ NBPW       ,MASK(16)   ,GENDON
      COMMON /ISOSR6/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(500)    ,NR
      COMMON /ISOSR7/ IENTRY     ,IONES
      COMMON /ISOSR9/ BIG        ,IXBIT
C
      LOGICAL         GENDON
      DATA IREF/1/
C
      AVE(A,B) = (A+B)*.5
C
C A.S.F. FOR SCALING
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
C +NOAO - Blockdata ISOSRB rewritten as run time initialization
C     EXTERNAL ISOSRB
      call isosrb
C -NOAO
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('NSSL','ISOSRF','ISOSRF','VERSION 12')
      NERR = 0
C
C 3-SPACE  U,V,W,IU,IV,IW,ETC
C 2-SPACE  X,Y,IX,IY,ETC
C
C  INITIALIZE MASKS
C
      IF (.NOT.GENDON) CALL MMASK
C
C  SET SHIFT VALUE FOR X,Y PACKING
C
C  IF YOUR MACHINE HAS MORE THAN 16 BITS PER WORD THIS CHECK MAY BE
C  MODIFIED
C
      IF (LU .LE. 256) GO TO  10
      NERR = NERR + 1
      CALL SETER('DIMENSION OF CUBE EXCEEDS 256',NERR,2)
      RETURN
   10 DO  20 J=1,30
         IF (LU .LE. 2**(J-1)) GO TO  30
   20 CONTINUE
   30 IXBIT = J
      NU = MU
      NUP2 = NU+2
      NV = MV
      NVP2 = NV+2
      NW = MW
      NWP2 = NW+2
      FNU = NU
      FNV = NV
      FNW = NW
      SU1 = SU(1.)
      SV1 = SV(1.)
      SW1 = SW(1.)
      SUNU = SU(FNU)
      SVNV = SV(FNV)
      SWNW = SW(FNW)
      AVEU = AVE(SU1,SUNU)
      AVEV = AVE(SV1,SVNV)
      AVEW = AVE(SW1,SWNW)
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
      NUVWP2 = MUVWP2
      TVAL = TISO
      NFLAG = IABS(IFLAG)
      IF (NFLAG.EQ.0 .OR. NFLAG.GE.8) NFLAG = 7
C
C SET UP SCALING
C
      FACT = -ISIGN(1,IFLAG)
      CALL SET3D (EYE,1.,FNU,1.,FNV,1.,FNW)
C
C BOUND LOWER AND LEFT EDGE OF SLAB
C
      EDGE = SIGN(BIG,FACT)
      DO  40 IUVW=1,NUVWP2
         SLAB(IUVW,1) = EDGE
         SLAB(1,IUVW) = EDGE
   40 CONTINUE
C
C SLICES PERPENDICULAR TO U. THAT IS, V W SLICES. T OF CONSTANT U.
C
      IF (NFLAG .LT. 4) GO TO 100
      CALL ZEROSC
      ISLBT = -1
C
C BOUND UPPER AND RIGHT EDGE OF SLAB.
C
      DO  50 IV=2,NVP2
         SLAB(IV,NWP2) = EDGE
   50 CONTINUE
      DO  60 IW=2,NWP2
         SLAB(NVP2,IW) = EDGE
   60 CONTINUE
C
C GO THRU 3-D ARRAY IN U DIRECTION.  IUEW=IU EITHER WAY.
C PICK IU BASED ON EYEU.
C
      DO  90 IUEW=1,NU
         IU = IUEW
         IF (EYEU .GT. AVEU) IU = NU+1-IUEW
         U = IU
C
C LOAD THIS SLICE OF T INTO SLAB.
C
         DO  80 IV=1,NV
            DO  70 IW=1,NW
               SLAB(IV+1,IW+1) = T(IU,IV,IW)
   70       CONTINUE
   80    CONTINUE
C
C CONTOUR THIS SLAB.
C
         CALL STCNTR (SLAB,NUVWP2,NVP2,NWP2,TVAL)
C
C CONSTRUCT VISIBILITY ARRAY.
C
         CALL FILLIN
   90 CONTINUE
C
C SLICES PERPENDICULAR TO V. U W SLICES. T OF CONSTANT V.
C
  100 IF (MOD(NFLAG/2,2) .EQ. 0) GO TO 160
      CALL ZEROSC
      ISLBT = 0
C
C BOUND UPPER AND RIGHT EDGE OF SLAB.
C
      DO 110 IU=2,NUP2
         SLAB(IU,NWP2) = EDGE
  110 CONTINUE
      DO 120 IW=2,NWP2
         SLAB(NUP2,IW) = EDGE
  120 CONTINUE
C
C GO THRU T IN V DIRECTION.  IVEW=IV EITHER WAY.
C
      DO 150 IVEW=1,NV
         IV = IVEW
         IF (EYEV .GT. AVEV) IV = NV+1-IVEW
         V = IV
C
C LOAD THIS SLICE OF T INTO SLAB.
C
         DO 140 IU=1,NU
            DO 130 IW=1,NW
               SLAB(IU+1,IW+1) = T(IU,IV,IW)
  130       CONTINUE
  140    CONTINUE
C
C CONTOUR THIS SLAB.
C
         CALL STCNTR (SLAB,NUVWP2,NUP2,NWP2,TVAL)
C
C CONSTRUCT VISIBILITY ARRAY.
C
         CALL FILLIN
  150 CONTINUE
C
C SLICES PERPENDICULAR TO W. U V SLICES. T OF CONSTANT W.
C
  160 IF (MOD(NFLAG,2) .EQ. 0) GO TO 220
      CALL ZEROSC
C
      ISLBT = 1
C
C BOUND UPPER AND RIGHT EDGE OF SLAB.
C
      DO 170 IU=2,NUP2
         SLAB(IU,NVP2) = EDGE
  170 CONTINUE
      DO 180 IV=2,NVP2
         SLAB(NUP2,IV) = EDGE
  180 CONTINUE
C
C GO THRU T IN W DIRECTION.
C
      DO 210 IWEW=1,NW
         IW = IWEW
         IF (EYEW .GT. AVEW) IW = NW+1-IWEW
         W = IW
C
C LOAD THIS SLICE OF T INTO SLAB.
C
         DO 200 IU=1,NU
            DO 190 IV=1,NV
               SLAB(IU+1,IV+1) = T(IU,IV,IW)
  190       CONTINUE
  200    CONTINUE
C
C CONTOUR THIS SLAB.
C
         CALL STCNTR (SLAB,NUVWP2,NUP2,NVP2,TVAL)
C
C CONSTRUCT VISIBILITY ARRAY.
C
         CALL FILLIN
  210 CONTINUE
C
C DRAW REFERENCE PLANE EDGES AND W AXIS.
C
  220 IF (IREF .EQ. 0) RETURN
      CALL TRN32I (SU1,SV1,SW1,XT,YT,DUM,2)
      IF (EYEV .LT. SV1) GO TO 240
      CALL FRSTC (IFIX(XT),IFIX(YT),1)
      DO 230 IU=2,NU
         CALL TRN32I (SU(FLOAT(IU)),SV1,SW1,XT,YT,DUM,2)
         CALL FRSTC (IFIX(XT),IFIX(YT),2)
  230 CONTINUE
      GO TO 250
  240 CALL PLOTIT (IFIX(XT),IFIX(YT),0)
      CALL TRN32I (SUNU,SV1,SW1,XT,YT,DUM,2)
      CALL PLOTIT (IFIX(XT),IFIX(YT),1)
  250 IF (EYEU .GT. SUNU) GO TO 270
      CALL FRSTC (IFIX(XT),IFIX(YT),1)
      DO 260 IV=2,NV
         CALL TRN32I (SUNU,SV(FLOAT(IV)),SW1,XT,YT,DUM,2)
         CALL FRSTC (IFIX(XT),IFIX(YT),2)
  260 CONTINUE
      GO TO 280
  270 CALL PLOTIT (IFIX(XT),IFIX(YT),0)
      CALL TRN32I (SUNU,SVNV,SW1,XT,YT,DUM,2)
      CALL PLOTIT (IFIX(XT),IFIX(YT),1)
  280 IF (EYEV .GT. SVNV) GO TO 300
      CALL FRSTC (IFIX(XT),IFIX(YT),1)
      DO 290 IUOW=2,NU
         CALL TRN32I (SU(FLOAT(NU-IUOW+1)),SVNV,SW1,XT,YT,DUM,2)
         CALL FRSTC (IFIX(XT),IFIX(YT),2)
  290 CONTINUE
      GO TO 310
  300 CALL PLOTIT (IFIX(XT),IFIX(YT),0)
      CALL TRN32I (SU1,SVNV,SW1,XT,YT,DUM,2)
      CALL PLOTIT (IFIX(XT),IFIX(YT),1)
  310 IF (EYEU .LT. SU1) GO TO 330
      CALL FRSTC (IFIX(XT),IFIX(YT),1)
      DO 320 IVOW=2,NV
         CALL TRN32I (SU1,SV(FLOAT(NV-IVOW+1)),SW1,XT,YT,DUM,2)
         CALL FRSTC (IFIX(XT),IFIX(YT),2)
  320 CONTINUE
      GO TO 340
  330 CALL PLOTIT (IFIX(XT),IFIX(YT),0)
      CALL TRN32I (SU1,SV1,SW1,XT,YT,DUM,2)
      CALL PLOTIT (IFIX(XT),IFIX(YT),1)
  340 IF (EYEU.LE.SU1 .OR. EYEV.LE.SV1) GO TO 360
      CALL FRSTC (IFIX(XT),IFIX(YT),1)
      DO 350 IW=2,NW
         CALL TRN32I (SU1,SV1,SW(FLOAT(IW)),XT,YT,DUM,2)
         CALL FRSTC (IFIX(XT),IFIX(YT),2)
  350 CONTINUE
C +NOAO - Plotit buffer needs to be flushed before returning.
      call plotit (0, 0, 2)
C -NOAO
      RETURN
  360 CALL PLOTIT (IFIX(XT),IFIX(YT),0)
      CALL TRN32I (SU1,SV1,SWNW,XT,YT,DUM,2)
      CALL PLOTIT (IFIX(XT),IFIX(YT),1)
C +NOAO - Plotit buffer needs to be flushed before returning.
      call plotit (0, 0, 2)
C -NOAO
      RETURN
      END
      SUBROUTINE EZISOS (T,MU,MV,MW,EYE,SLAB,TISO)
C
      SAVE
      DIMENSION       T(MU,MV,MW),EYE(3)
C
        DATA ANG,PI/.35,3.141592/
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('NSSL','ISOSRF','EZISOS','VERSION 12')
C
C ARGUMENTS DESCRIBED IN ISOSRF
C
C PICK TYPES OF LINES TO DRAW
C
      NU = MU
      NV = MV
      NW = MW
      TVAL = TISO
      MAX = MAX0(NU,NV,NW)+2
      ATU = NU/2
      ATV = NV/2
      ATW = NW/2
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
      RU = EYEU-ATU
      RV = EYEV-ATV
      RW = EYEW-ATW
      RU2 = RU*RU
      RV2 = RV*RV
      RW2 = RW*RW
      DU = SQRT(RV2+RW2)
      DV = SQRT(RU2+RW2)
      DW = SQRT(RU2+RV2)
      DR = 1./SQRT(RU2+RV2+RW2)
C
C  COMPUTE THE ARCCOSINE
C
      TU = DU*DR
      ANGU = ATAN(ABS(SQRT(1.-TU*TU)/TU))
      IF (TU .LE. 0.) ANGU = PI-ANGU
      TV = DV*DR
      ANGV = ATAN(ABS(SQRT(1.-TV*TV)/TV))
      IF (TV .LE. 0.) ANGV = PI-ANGV
      TW = DW*DR
      ANGW = ATAN(ABS(SQRT(1.-TW*TW)/TW))
      IF (TW .LE. 0.) ANGW = PI-ANGW
C
C BREAK POINT IS ABOUT 20 DEGREES OR ABOUT .35 RADIANS
C
      IFLAG = 0
      IF (ANGU .GT. ANG) IFLAG = IFLAG+4
      IF (ANGV .GT. ANG) IFLAG = IFLAG+2
      IF (ANGW .GT. ANG) IFLAG = IFLAG+1
C
C FIND SIGN OF IFLAG
C
      ICNT = 0
      IF (ABS(RU) .LE. ATU) GO TO  30
      IU = 1
      IF (EYEU .GT. ATU) IU = NU
      DO  20 IW=1,NW
         DO  10 IV=1,NV
            IF (T(IU,IV,IW) .GT. TVAL) ICNT = ICNT-2
            ICNT = ICNT+1
   10    CONTINUE
   20 CONTINUE
   30 IF (ABS(RV) .LE. ATV) GO TO  60
      IV = 1
      IF (EYEV .GT. ATV) IV = NV
      DO  50 IW=1,NW
         DO  40 IU=1,NU
            IF (T(IU,IV,IW) .GT. TVAL) ICNT = ICNT-2
            ICNT = ICNT+1
   40    CONTINUE
   50 CONTINUE
   60 IF (ABS(RW) .LE. ATW) GO TO  90
      IW = 1
      IF (EYEW .GT. ATW) IW = NW
      DO  80 IV=1,NV
         DO  70 IU=1,NU
            IF (T(IU,IV,IW) .GT. TVAL) ICNT = ICNT-2
            ICNT = ICNT+1
   70    CONTINUE
   80 CONTINUE
   90 IFLAG = ISIGN(IFLAG,ICNT)
      CALL ISOSRF (T,NU,NU,NV,NV,NW,EYE,MAX,SLAB,TVAL,IFLAG)
C +NOAO - Call to frame is suppressed.
C     CALL FRAME
C -NOAO
      RETURN
      END
      SUBROUTINE SET3D (EYE,ULO,UHI,VLO,VHI,WLO,WHI)
      SAVE
      COMMON /TEMPR/  RZERO
C
      DIMENSION       EYE(3)
C
      COMMON /ISOSR3/ ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0
      COMMON /PWRZ1I/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
C
C
      AVE(A,B) = (A+B)*.5
C
C A.S.F. FOR SCALING
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
C CONSTANTS FOR PWRZ
C
      UUMIN = ULO
      UUMAX = UHI
      VVMIN = VLO
      VVMAX = VHI
      WWMIN = WLO
      WWMAX = WHI
      EYEU = EYE(1)
      EYEV = EYE(2)
      EYEW = EYE(3)
C
C FIND CORNERS IN 2-SPACE FOR 3-SPACE BOX CONTAINING OBJECT
C
      ISCALE = 0
      ATU = AVE(SU(UUMIN),SU(UUMAX))
      ATV = AVE(SV(VVMIN),SV(VVMAX))
      ATW = AVE(SW(WWMIN),SW(WWMAX))
      BIGD = 0.
      IF (RZERO .LE. 0.) GO TO  10
C
C RELETIVE SIZE FEATURE IN USE.
C GENERATE EYE POSITION THAT MAKES BOX HAVE MAXIMUM PROJECTED SIZE.
C
      ALPHA = -(VVMIN-ATV)/(UUMIN-ATU)
      VVEYE = -RZERO/SQRT(1.+ALPHA*ALPHA)
      UUEYE = VVEYE*ALPHA
      VVEYE = VVEYE+ATV
      UUEYE = UUEYE+ATU
      WWEYE = ATW
      CALL TRN32I (ATU,ATV,ATW,UUEYE,VVEYE,WWEYE,1)
      CALL TRN32I (UUMIN,VVMIN,ATW,XMIN,DUMM,DUMM,2)
      CALL TRN32I (UUMAX,VVMIN,WWMIN,DUMM,YMIN,DUMM,2)
      CALL TRN32I (UUMAX,VVMAX,ATW,XMAX,DUMM,DUMM,2)
      CALL TRN32I (UUMAX,VVMIN,WWMAX,DUMM,YMAX,DUMM,2)
      BIGD = SQRT((UUMAX-UUMIN)**2+(VVMAX-VVMIN)**2+(WWMAX-WWMIN)**2)*.5
      R0 = RZERO
      GO TO  20
   10 CALL TRN32I (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      CALL TRN32I (SU(UUMIN),SV(VVMIN),SW(WWMIN),X1,Y1,DUM,2)
      CALL TRN32I (SU(UUMIN),SV(VVMIN),SW(WWMAX),X2,Y2,DUM,2)
      CALL TRN32I (SU(UUMIN),SV(VVMAX),SW(WWMIN),X3,Y3,DUM,2)
      CALL TRN32I (SU(UUMIN),SV(VVMAX),SW(WWMAX),X4,Y4,DUM,2)
      CALL TRN32I (SU(UUMAX),SV(VVMIN),SW(WWMIN),X5,Y5,DUM,2)
      CALL TRN32I (SU(UUMAX),SV(VVMIN),SW(WWMAX),X6,Y6,DUM,2)
      CALL TRN32I (SU(UUMAX),SV(VVMAX),SW(WWMIN),X7,Y7,DUM,2)
      CALL TRN32I (SU(UUMAX),SV(VVMAX),SW(WWMAX),X8,Y8,DUM,2)
      XMIN = AMIN1(X1,X2,X3,X4,X5,X6,X7,X8)
      XMAX = AMAX1(X1,X2,X3,X4,X5,X6,X7,X8)
      YMIN = AMIN1(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
      YMAX = AMAX1(Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8)
C
C ADD RIGHT AMOUNT TO KEEP PICTURE SQUARE
C
   20 WIDTH = XMAX-XMIN
      HIGHT = YMAX-YMIN
      DIF = .5*(WIDTH-HIGHT)
      IF (DIF)  30, 50, 40
   30 XMIN = XMIN+DIF
      XMAX = XMAX-DIF
      GO TO  50
   40 YMIN = YMIN-DIF
      YMAX = YMAX+DIF
   50 ISCALE = 1
      CALL TRN32I (ATU,ATV,ATW,EYE(1),EYE(2),EYE(3),1)
      RETURN
      END
      SUBROUTINE TRN32I (U,V,W,XT,YT,ZT,IENT)
C
C THIS ROUTINE IMPLEMENTS THE 3-SPACE TO 2-SPACE TRANSFOR-
C MATION BY KUBER, SZABO AND GIULIERI, THE PERSPECTIVE
C REPRESENTATION OF FUNCTIONS OF TWO VARIABLES. J. ACM 15,
C 2, 193-204,1968.
C ARGUMENTS FOR SET
C U,V,W    ARE THE 3-SPACE COORDINATES OF THE INTERSECTION
C          OF THE LINE OF SIGHT AND THE IMAGE PLANE.  THIS
C          POINT CAN BE THOUGHT OF AS THE POINT LOOKED AT.
C XT,YT,ZT ARE THE 3-SPACE COORDINATES OF THE EYE POSITION.
C
C TRN32 ARGUMENTS
C U,V,W    ARE THE 3-SPACE COORDINATES OF A POINT TO BE
C          TRANSFORMED.
C XT,YT    THE RESULTS OF THE 3-SPACE TO 2-SPACE TRANSFOR-
C          MATION.  WHEN ISCALE=0, XT AND YT ANR IN THE SAME
C          UNITS AS U,V, AND W.  WHEN ISCALE'0, XT AND YT
C          ARE IN PLOTTER COORDINATES.
C ZT       NOT USED.
C
      SAVE
      COMMON /PWRZ1I/ UUMIN      ,UUMAX      ,VVMIN      ,VVMAX      ,
     1                WWMIN      ,WWMAX      ,DELCRT     ,EYEU       ,
     2                EYEV       ,EYEW
      COMMON /ISOSR3/ ISCALE     ,XMIN       ,XMAX       ,YMIN       ,
     1                YMAX       ,BIGD       ,R0
C
C RANGE OF PLOTTER COORDINATES
C
C
C  WARNING
C  IF PLOTTER MAXIMUM VALUE RANGES (IN X OR Y DIRECTION) FALL BELOW
C  101, THEN CHANGES MUST BE MADE IN SUBROUTINE FRSTC. THE REQUIRED
C  CHANGES ARE MARKED BY WARNING COMMENTS IN FRSTC.
      DATA NLX,NBY,NRX,NTY/10,10,32760,32760/
        DATA PI/3.1411592/
C
C STORE THE PARAMETERS OF THE SET CALL FOR USE
C WITH THE TRANSLATE CALL
C
C DECIDE IF SET OR TRANSLATE CALL
C
      IF (IENT .NE. 1) GO TO  50
      AU = U
      AV = V
      AW = W
      EU = XT
      EV = YT
      EW = ZT
C
C
C
C
C
      DU = AU-EU
      DV = AV-EV
      DW = AW-EW
      D = SQRT(DU*DU+DV*DV+DW*DW)
      COSAL = DU/D
      COSBE = DV/D
      COSGA = DW/D
C
C  COMPUTE THE ARCCOSINE
C
      AL = ATAN(ABS(SQRT(1.-COSAL*COSAL)/COSAL))
      IF (COSAL .LE. 0.) AL = PI-AL
      BE = ATAN(ABS(SQRT(1.-COSBE*COSBE)/COSBE))
      IF (COSBE .LE. 0.) BE = PI-BE
      GA = ATAN(ABS(SQRT(1.-COSGA*COSGA)/COSGA))
      IF (COSGA .LE. 0.) GA = PI-GA
      SINGA = SIN(GA)
C
C THE 3-SPACE POINT LOOKED AT IS TRANSFORMED INTO (0,0) OF
C THE 2-SPACE.  THE 3-SPACE W AXIS IS TRANSFORMED INTO THE
C 2-SPACE Y AXIS.  IF THE LINE OF SIGHT IS CLOSE TO PARALLEL
C TO THE 3-SPACE W AXIS, THE 3-SPACE V AXIS IS CHOSEN (IN-
C STEAD OF THE 3-SPACE W AXIS) TO BE TRANSFORMED INTO THE
C 2-SPACE Y AXIS.
C
      ASSIGN  90 TO JDONE
      IF (ISCALE)  10, 30, 10
   10 X0 = XMIN
      Y0 = YMIN
      X1 = NLX
      Y1 = NBY
      X2 = NRX-NLX
      Y2 = NTY-NBY
      X3 = X2/(XMAX-XMIN)
      Y3 = Y2/(YMAX-YMIN)
      X4 = NRX
      Y4 = NTY
      FACT = 1.
      IF (BIGD .LE. 0.) GO TO  20
      X0 = -BIGD
      Y0 = -BIGD
      X3 = X2/(2.*BIGD)
      Y3 = Y2/(2.*BIGD)
      FACT = R0/D
   20 DELCRT = X2
      ASSIGN  80 TO JDONE
   30 IF (SINGA .LT. 0.0001) GO TO  40
      R = 1./SINGA
      ASSIGN  70 TO JUMP
      RETURN
   40 SINBE = SIN(BE)
      R = 1./SINBE
      ASSIGN  60 TO JUMP
      RETURN
C
C********************  ENTRY TRN32  ************************
C     ENTRY TRN32 (U,V,W,XT,YT,ZT)
C
   50 UU = U
      VV = V
      WW = W
      Q = D/((UU-EU)*COSAL+(VV-EV)*COSBE+(WW-EW)*COSGA)
      GO TO JUMP,( 60, 70)
   60 UU = ((EW+Q*(WW-EW)-AW)*COSAL-(EU+Q*(UU-EU)-AU)*COSGA)*R
      VV = (EV+Q*(VV-EV)-AV)*R
      GO TO JDONE,( 80, 90)
   70 UU = ((EU+Q*(UU-EU)-AU)*COSBE-(EV+Q*(VV-EV)-AV)*COSAL)*R
      VV = (EW+Q*(WW-EW)-AW)*R
      GO TO JDONE,( 80, 90)
   80 XT = AMIN1(X4,AMAX1(X1,X1+X3*(FACT*UU-X0)))
      YT = AMIN1(Y4,AMAX1(Y1,Y1+Y3*(FACT*VV-Y0)))
      RETURN
   90 XT = UU
      YT = VV
      RETURN
      END
      SUBROUTINE ZEROSC
      SAVE
C
      COMMON /ISOSR2/ LX         ,NX         ,NY         ,ISCR(8,128),
     1                ISCA(8,128)
C
C ZERO BOTH SCRENE MODELS.
C
      DO  20 I=1,LX
         DO  10 J=1,NY
            ISCR(I,J) = 0
            ISCA(I,J) = 0
   10    CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE STCNTR (Z,L,M,N,CONV)
C
      SAVE
      DIMENSION       Z(L,N)
C
C THIS ROUTINE FINDS THE BEGINNINGS OF ALL CONTOUR LINES AT LEVEL CONV.
C FIRST THE EDGES ARE SEARCHED FOR LINES INTERSECTING THE EDGE (OPEN
C LINES) THEN THE INTERIOR IS SEARCHED FOR LINES WHICH DO NOT INTERSECT
C THE EDGE (CLOSED LINES).  BEGINNINGS ARE STORED IN IR TO PREVENT RE-
C TRACING OF LINES.  IF IR IS FILLED, THE SEARCH IS STOPPED FOR THIS
C CONV.
C
      COMMON /ISOSR6/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(500)    ,NR
      COMMON /ISOSR7/ IENTRY     ,IONES
      COMMON /ISOSR9/ BIG        ,IXBIT
C
C  PACK X AND Y
C
      IPXY(I1,J1) = ISHIFT(I1,IXBIT)+J1
C
      IENTRY = 0
      NP = 0
      CV = CONV
C
C THE FOLLOWING CODE SHOULD BE RE-ENABLED IF THIS ROUTINE IS USED FOR
C GENERAL CONTOURING
C
C     ISS=0
C     DO 2 IP1=2,M
C     I=IP1-1
C     IF(Z(I,1).GE.CV.OR.Z(IP1,1).LT.CV) GO TO 1
C     IX=IP1
C     IY=1
C     IDX=-1
C     IDY=0
C     IS=1
C     CALL DRLINE(Z,L,M,N)
C   1 IF(Z(IP1,N).GE.CV.OR.Z(I,N).LT.CV) GO TO 2
C     IX=I
C     IY=N
C     IDX=1
C     IDY=0
C     IS=5
C     CALL DRLINE(Z,L,M,N)
C   2 CONTINUE
C     DO 4 JP1=2,N
C     J=JP1-1
C     IF(Z(M,J).GE.CV.OR.Z(M,JP1).LT.CV) GO TO 3
C     IX=M
C     IY=JP1
C     IDX=0
C     IDY=-1
C     IS=7
C     CALL DRLINE(Z,L,M,N)
C   3 IF(Z(1,JP1).GE.CV.OR.Z(1,J).LT.CV) GO TO 4
C     IX=1
C     IY=J
C     IDX=0
C     IDY=1
C     IS=3
C     CALL DRLINE(Z,L,M,N)
C   4 CONTINUE
C
      ISS = 1
      DO  40 JP1=3,N
         J = JP1-1
         DO  30 IP1=2,M
            I = IP1-1
            IF (Z(I,J).GE.CV .OR. Z(IP1,J).LT.CV) GO TO  30
            IXY = IPXY(IP1,J)
            IF (NP .EQ. 0) GO TO  20
            DO  10 K=1,NP
               IF (IR(K) .EQ. IXY) GO TO  30
   10       CONTINUE
   20       NP = NP+1
            IF (NP .GT. NR) RETURN
            IR(NP) = IXY
            IX = IP1
            IY = J
            IDX = -1
            IDY = 0
            IS = 1
            CALL DRCNTR (Z,L,M,N)
   30    CONTINUE
   40 CONTINUE
      RETURN
      END
      SUBROUTINE DRCNTR (Z,L,MM,NN)
      SAVE
C
      DIMENSION       Z(L,NN)
C
C THIS ROUTINE TRACES A CONTOUR LINE WHEN GIVEN THE BEGINNING BY STLINE.
C TRANSFORMATIONS CAN BE ADDED BY DELETING THE STATEMENT FUNCTIONS FOR
C FX AND FY IN DRLINE AND MINMAX AND ADDING EXTERNAL FUNCTIONS.
C X=1. AT Z(1,J), X=FLOAT(M) AT Z(M,J). X TAKES ON NON-INTEGER VALUES.
C Y=1. AT Z(I,1), Y=FLOAT(N) AT Z(I,N). Y TAKES ON NON-INTEGER VALUES.
C
      COMMON /ISOSR6/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(500)    ,NR
      COMMON /ISOSR9/ BIG        ,IXBIT
C
      LOGICAL         IPEN       ,IPENO
C
      DATA IOFFP,SPVAL/0,0./
      DATA IPEN,IPENO/.TRUE.,.TRUE./
C
C  PACK X AND Y
C
      IPXY(I1,J1) = ISHIFT(I1,IXBIT)+J1
      FX(X1,Y1) = X1
      FY(X1,Y1) = Y1
      C(P11,P21) = (P11-CV)/(P11-P21)
C
      M = MM
      N = NN
      IF (IOFFP .EQ. 0) GO TO  10
      ASSIGN 100 TO JUMP1
      ASSIGN 150 TO JUMP2
      GO TO  20
   10 ASSIGN 120 TO JUMP1
      ASSIGN 160 TO JUMP2
   20 IX0 = IX
      IY0 = IY
      IS0 = IS
      IF (IOFFP .EQ. 0) GO TO  30
      IX2 = IX+INX(IS)
      IY2 = IY+INY(IS)
      IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL
      IPENO = IPEN
   30 IF (IDX .EQ. 0) GO TO  40
      Y = IY
      ISUB = IX+IDX
      X = C(Z(IX,IY),Z(ISUB,IY))*FLOAT(IDX)+FLOAT(IX)
      GO TO  50
   40 X = IX
      ISUB = IY+IDY
      Y = C(Z(IX,IY),Z(IX,ISUB))*FLOAT(IDY)+FLOAT(IY)
   50 IF (IPEN) CALL FRSTS (FX(X,Y),FY(X,Y),1)
   60 IS = IS+1
      IF (IS .GT. 8) IS = IS-8
      IDX = INX(IS)
      IDY = INY(IS)
      IX2 = IX+IDX
      IY2 = IY+IDY
      IF (ISS .NE. 0) GO TO  70
      IF (IX2.GT.M .OR. IY2.GT.N .OR. IX2.LT.1 .OR. IY2.LT.1) GO TO 190
   70 IF (CV-Z(IX2,IY2))  80, 80, 90
   80 IS = IS+4
      IX = IX2
      IY = IY2
      GO TO  60
   90 IF (IS/2*2 .EQ. IS) GO TO  60
      GO TO JUMP1,(100,120)
  100 ISBIG = IS+(8-IS)/6*8
      IX3 = IX+INX(ISBIG-1)
      IY3 = IY+INY(ISBIG-1)
      IX4 = IX+INX(ISBIG-2)
      IY4 = IY+INY(ISBIG-2)
      IPENO = IPEN
      IF (ISS .NE. 0) GO TO 110
      IF (IX3.GT.M .OR. IY3.GT.N .OR. IX3.LT.1 .OR. IY3.LT.1) GO TO 190
      IF (IX4.GT.M .OR. IY4.GT.N .OR. IX4.LT.1 .OR. IY4.LT.1) GO TO 190
  110 IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL .AND.
     1       Z(IX3,IY3).NE.SPVAL .AND. Z(IX4,IY4).NE.SPVAL
  120 IF (IDX .EQ. 0) GO TO 130
      Y = IY
      ISUB = IX+IDX
      X = C(Z(IX,IY),Z(ISUB,IY))*FLOAT(IDX)+FLOAT(IX)
      GO TO 140
  130 X = IX
      ISUB = IY+IDY
      Y = C(Z(IX,IY),Z(IX,ISUB))*FLOAT(IDY)+FLOAT(IY)
  140 GO TO JUMP2,(150,160)
  150 IF (.NOT.IPEN) GO TO 170
      IF (IPENO) GO TO 160
C
C END OF LINE SEGMENT
C
      CALL FRSTS (D1,D2,3)
      CALL FRSTS (FX(XOLD,YOLD),FY(XOLD,YOLD),1)
C
C CONTINUE LINE SEGMENT
C
  160 CALL FRSTS (FX(X,Y),FY(X,Y),2)
  170 XOLD = X
      YOLD = Y
      IF (IS .NE. 1) GO TO 180
      NP = NP+1
      IF (NP .GT. NR) GO TO 190
      IR(NP) = IPXY(IX,IY)
  180 IF (ISS .EQ. 0) GO TO  60
      IF (IX.NE.IX0 .OR. IY.NE.IY0 .OR. IS.NE.IS0) GO TO  60
C
C END OF LINE
C
  190 CALL FRSTS (D1,D2,3)
      RETURN
      END
      SUBROUTINE TR32 (X,Y,MX,MY)
      SAVE
C
      COMMON /ISOSR1/ ISLBT      ,U          ,V          ,W
C
C A.S.F. FOR SCALING
C
      SU(UTEMP) = UTEMP
      SV(VTEMP) = VTEMP
      SW(WTEMP) = WTEMP
C
      XX = X
      YY = Y
      IF (ISLBT)  10, 20, 30
   10 CALL TRN32I (SU(U),SV(XX-1.),SW(YY-1.),XT,YT,DUM,2)
      GO TO  40
   20 CALL TRN32I (SU(XX-1.),SV(V),SW(YY-1.),XT,YT,DUM,2)
      GO TO  40
   30 CALL TRN32I (SU(XX-1.),SV(YY-1.),SW(W),XT,YT,DUM,2)
   40 MX = XT
      MY = YT
      RETURN
      END
      SUBROUTINE FRSTS (XX,YY,IENT)
C
C THIS IS A SPECIAL VERSION OF THE SMOOTHING DASHED LINE PACKAGE.  LINES
C ARE SMOOTHED IN THE SAME WAY, BUT NO SOFTFARE DASHED LINES ARE USED.
C CONDITIONAL PLOTTING ROUTINES ARE CALL WHICH DETERMINE THE VISIBILITY
C OF A LINE SEGMENT BEFORE PLOTTING.
C
      SAVE
      DIMENSION       XSAVE(70)  ,YSAVE(70)  ,XP(70)     ,YP(70)     ,
     1                TEMP(70)
C
      COMMON /ISOSR7/ IENTRY     ,IONES
C
      DATA NP/150/
      DATA L1/70/
      DATA TENSN/2.5/
      DATA PI/3.14159265358/
      DATA SMALL/128./
C
      AVE(A,B) = .5*(A+B)
C
C  DECIDE IF FRSTS,VECTS,LASTS CALL
C
      GO TO ( 10, 20, 40),IENT
   10 DEG = 180./PI
      X = XX
      Y = YY
      LASTFL = 0
      SSLP1 = 0.0
      SSLPN = 0.0
      XSVN = 0.0
      YSVN = 0.0
C
C INITIALIZE THE POINT AND SEGMENT COUNTER
C N COUNTS THE NUMBER OF POINTS/SEGMENT
C
      N = 0
C
C NSEG = 0       FIRST SEGMENT
C NSEG = 1       MORE THAN ONE SEGMENT
C
      NSEG = 0
      CALL TR32 (X,Y,MX,MY)
C
C SAVE THE X,Y COORDINATES OF THE FIRST POINT
C XSV1           CONTAINS THE X COORDINATE OF THE FIRST POINT
C                OF A LINE
C YSV1           CONTAINS THE Y COORDINATE OF THE FIRST POINT
C                OF A LINE
C
      XSV1 = MX
      YSV1 = MY
      GO TO  30
C
C ************************* ENTRY VECTS *************************
C     ENTRY VECTS (XX,YY)
C
   20 X = XX
      Y = YY
C
C VECTS          SAVES THE X,Y COORDINATES OF THE ACCEPTED
C                POINTS ON A LINE SEGMENT
C
      CALL TR32 (X,Y,MX,MY)
C
CIF THE NEW POINT IS TOO CLOSE TO THE PREVIOUS POINT, IGNORE IT
C
      IF (ABS(FLOAT(IFIX(XSVN)-MX))+ABS(FLOAT(IFIX(YSVN)-MY)) .LT.
     1    SMALL) RETURN
      IFLAG = 0
   30 N = N+1
C
C SAVE THE X,Y COORDINATES OF EACH POINT OF THE SEGMENT
C XSAVE          THE ARRAY OF X COORDINATES OF LINE SEGMENT
C YSAVE          THE ARRAY OF Y COORDINATES OF LINE SEGMENT
C
      XSAVE(N) = MX
      YSAVE(N) = MY
      XSVN = XSAVE(N)
      YSVN = YSAVE(N)
      IF (N .GE. L1-1) GO TO  50
      RETURN
C
C ************************* ENTRY LASTS *************************
C     ENTRY LASTS
C
   40 LASTFL = 1
C
C LASTS          CHECKS FOR PERIODIC LINES AND SETS UP
C                  THE CALLS TO KURV1S AND KURV2S
C
C IFLAG = 0      OK TO CALL LASTS DIRECTLY
C IFLAG = 1      LASTS WAS JUST CALLED FROM BY VECTS
C                IGNORE CALL TO LASTS
C
      IF (IFLAG .EQ. 1) RETURN
C
C COMPARE THE LAST POINT OF SEGMENT WITH FIRST POINT OF LINE
C
   50 IFLAG = 1
C
C IPRD = 0       PERIODIC LINE
C IPRD = 1       NON-PERIODIC LINE
C
      IPRD = 1
      IF (ABS(XSV1-XSVN)+ABS(YSV1-YSVN) .LT. SMALL) IPRD = 0
C
C TAKE CARE OF THE CASE OF ONLY TWO DISTINCT P0INTS ON A LINE
C
      IF (NSEG .GE. 1) GO TO  70
      IF (N-2) 160,150, 60
   60 IF (N .GE. 4) GO TO  70
      DX = XSAVE(2)-XSAVE(1)
      DY = YSAVE(2)-YSAVE(1)
      SLOPE = ATAN2(DY,DX)*DEG+90.
      IF (SLOPE .GE. 360.) SLOPE = SLOPE-360.
      IF (SLOPE .LE. 0.) SLOPE = SLOPE+360.
      SLP1 = SLOPE
      SLPN = SLOPE
      ISLPSW = 0
      SIGMA = TENSN
      GO TO 110
   70 SIGMA = TENSN
      IF (IPRD .GE. 1) GO TO  90
      IF (NSEG .GE. 1) GO TO  80
C
C SET UP FLAGS FOR A  1  SEGMENT, PERIODIC LINE
C
      ISLPSW = 4
      XSAVE(N) = XSV1
      YSAVE(N) = YSV1
      GO TO 110
C
C SET UP FLAGS FOR AN N-SEGMENT, PERIODIC LINE
C
   80 SLP1 = SSLPN
      SLPN = SSLP1
      ISLPSW = 0
      GO TO 110
   90 IF (NSEG .GE. 1) GO TO 100
C
C SET UP FLAGS FOR THE 1ST SEGMENT OF A NON-PERIODIC LINE
C
      ISLPSW = 3
      GO TO 110
C
C SET UP FLAGS FOR THE NTH SEGMENT OF A NON-PERIODIC LINE
C
  100 SLP1 = SSLPN
      ISLPSW = 1
C
C CALL THE SMOOTHING ROUTINES
C
  110 CALL KURV1S (N,XSAVE,YSAVE,SLP1,SLPN,XP,YP,TEMP,S,SIGMA,ISLPSW)
      IF (IPRD.EQ.0 .AND. NSEG.EQ.0 .AND. S.LT.70.) GO TO 170
      IENTRY = 1
C
C DETERMINE THE NUMBER OF POINTS TO INTERPOLATE FOR EACH SEGMENT
C
      IF (NSEG.GE.1 .AND. N.LT.L1-1) GO TO 120
      NPRIME = FLOAT(NP)-(S*FLOAT(NP))/(2.*32768.)
      IF (S .GE. 32768.) NPRIME = .5*FLOAT(NP)
      NPL = FLOAT(NPRIME)*S/32768.
      IF (NPL .LT. 2) NPL = 2
  120 DT = 1./FLOAT(NPL)
      IF (NSEG .LE. 0) CALL FRSTC (IFIX(XSAVE(1)),IFIX(YSAVE(1)),1)
      T = 0.0
      NSLPSW = 1
      IF (NSEG .GE. 1) NSLPSW = 0
      NSEG = 1
      CALL KURV2S (T,XS,YS,N,XSAVE,YSAVE,XP,YP,S,SIGMA,NSLPSW,SLP)
C
C SAVE SLOPE AT THE FIRST POINT OF THE LINE
C
      IF (NSLPSW .GE. 1) SSLP1 = SLP
      NSLPSW = 0
      XSOLD = XSAVE(1)
      YSOLD = YSAVE(1)
      DO 130 I=1,NPL
         T = T+DT
         TT = -T
         IF (I .EQ. NPL) NSLPSW = 1
         CALL KURV2S (TT,XS,YS,N,XSAVE,YSAVE,XP,YP,S,SIGMA,NSLPSW,SLP)
C
C SAVE THE LAST SLOPE OF THIS LINE SEGMENT
C
         IF (NSLPSW .GE. 1) SSLPN = SLP
C
C DRAW EACH PART OF THE LINE SEGMENT
C
         CALL FRSTC (IFIX(AVE(XSOLD,XS)),IFIX(AVE(YSOLD,YS)),2)
         CALL FRSTC (IFIX(XS),IFIX(YS),2)
         XSOLD = XS
         YSOLD = YS
  130 CONTINUE
      IF (IPRD .NE. 0) GO TO 140
C
C CONNECT THE LAST POINT WITH THE FIRST POINT OF A PERIODIC LINE
C
      CALL FRSTC (IFIX(AVE(XSOLD,XS)),IFIX(AVE(YSOLD,YS)),2)
      CALL FRSTC (IFIX(XSV1),IFIX(YSV1),2)
C
C BEGIN THE NEXT LINE SEGMENT WITH THE LAST POINT OF THIS SEGMENT
C
  140 XSAVE(1) = XS
      YSAVE(1) = YS
      N = 1
  150 CONTINUE
  160 RETURN
  170 N = 0
      RETURN
      END
      SUBROUTINE FRSTC (MX,MY,IENT)
      SAVE
C
      COMMON /ISOSR2/ LX         ,NX         ,NY         ,ISCR(8,128),
     1                ISCA(8,128)
      COMMON /ISOSR4/ RX         ,RY
      COMMON /ISOSR5/ NBPW       ,MASK(16)   ,GENDON
      LOGICAL         GENDON
      COMMON /ISOSR8/ NMASK(16)  ,IXOLD      ,IYOLD      ,IBTOLD     ,
     1                HBFLAG     ,IOSLSN     ,LRLX       ,IFSX       ,
     2                IFSY       ,FIRST      ,IYDIR      ,IHX        ,
     3                IHB        ,IHS        ,IHV        ,IVOLD      ,
     4                IVAL       ,IHRX       ,YCHANG     ,ITPD       ,
     5                IHF
      LOGICAL         YCHANG     ,HBFLAG     ,FIRST      ,IHF
C
C
C  DRAW LINE TO THE POINT MX,MY
C
C  ENTER THE POINT INTO THE CURRENT SCREEN, ISCR, IF THE POINT CONFORMS
C  TO THE SHADING ALGORITHM.
C  THE POINT IS NOT ENTERED WHEN;
C  1. IT IS THE SAME POINT USED IN THE LAST CALL, RESOLUTION PROBLEM
C  2. IT IS PART OF A HORIZONTAL LINE BUT NOT AN END POINT
C  3.  THE ENTIRE CONTOUR RESTS ON A HORIZONTAL PLANE
C
C  WHEN DRAWING A HORIZONTAL LINE THREE CONDITIONS EXIST;
C  1. WHEN THE LINE IS A HORIZONTAL STEP ENTER ONLY THE OUTSIDE POINT.
C     A HORIZONTAL STEP IS DEFINED BY THE ENTERING AND EXITING Y
C     DIRECTION THAT IS THE SAME.
C  2. ENTER BOTH END POINTS OF A HORIZONTAL TURNING POINT. A HORIZONTAL
C     TURNING POINT IS A LINE WITH GREATER THAN 1 HORIZONTAL BITS
C     AND THE ENTERING AND EXITING Y DIRECTION IS DIFFIRENT.
C  3.  WHEN THE ENTIRE CONTOUR IS A HORIZONTAL LINE NO POINTS ARE
C      ENTERED. THIS CONDITION IS DETECTED BY THE STATUS OF YCHANG.
C      IF IT IS TRUE THEN THE CONTOUR IS NOT A SINGLE HORIZONTAL LINE.
C
C  THE PREVIOUS POINT IS ERASED IF IT IS A VERTICAL TURNING POINT.
C  A VERTICAL TURNING POINT IS A HORIZONTAL LINE WITH ONLY 1 POINT
C  AND THE ENTERING AND EXITING Y DIRECTION DIFFERS.THIS DATA IS
C  IN THE VARIABLES IOSLSN-OLD SLOPE AND ISLSGN-NEW SLOPE.
C  THE CHANGE IN SLOPE MUST BE -1 TO 1 OR 1 TO -1.
C
C  OTHERWISE THE POINT IS ENTERED INTO ISCR.
C
C  THE TWO ENTRY POINTS ARE REQUIRED BY THE HARDWARE DRAWING ROUTINES.
C  FIRSTC IS USED FOR THE FIRST POINT ON THE CONTOUR. THE REMAINING
C  POINTS ON THE SAME CONTOUR ARE ENTERED VIA VECTC.
C
      DATA IONE/1/
      AVE(A,B) = (A+B)*.5
C
C  COMPUTE VISIBILITY OF THIS POINT
C
C  WARNING
C  IF X OR Y PLOTTER MAXIMUM VALUE RANGES FALL BELOW 101 THEN THE
C  FOLLOWING TWO STATEMENTS WHICH SET IX AND IY MUST BE CHANGED.
C  REPLACE THE CONSTANT 1.0 BY 0.5 IN THE STATEMENTS WHERE THE
C  MAXIMUM PLOTTER VALUE IS LESS THAN 101 FOR THAT DIRECTION.  THE
C  PLOTTER CORDINATE RANGES ARE SET IN SET32.
C
      IX = FLOAT(MX-1)*RX+1.0
      NRLX = IX
      IY = FLOAT(MY-1)*RY+1.0
      IBIT = NBPW-MOD(IX,NBPW)
      IX = IX/NBPW+1
      IVNOW = IAND(ISHIFT(ISCA(IX,IY),1-IBIT),IONE)
C
C  DECIDE IF FRSTC OR VECTC CALL
C
      IF (IENT .NE. 1) GO TO  10
C
      XOLD = MX
      YOLD = MY
C
C
C  SET INITIAL VALUES
C
      IHF = .FALSE.
      IYDIR = 0
      ITPD = 0
      IVAL = 0
      IOSLSN = 0
      IFSX = NRLX
      IFSY = IY
      LASTV = IVNOW
      HBFLAG = .FALSE.
      YCHANG = .FALSE.
      CALL PLOTIT (IFIX(XOLD),IFIX(YOLD),0)
      GO TO 180
C
C****************************  ENTRY VECTC  ****************************
C     ENTRY VECTC (MX,MY)
C
   10 XNOW = MX
      YNOW = MY
      JUMP = IVNOW*2+LASTV+1
      GO TO ( 20, 30, 40, 50),JUMP
C
C BOTH VISIBLE
C
   20 CALL PLOTIT (IFIX(XNOW),IFIX(YNOW),1)
      GO TO  50
C
C JUST TURNED VISIBLE
C
   30 CALL PLOTIT (IFIX(AVE(XNOW,XOLD)),IFIX(AVE(YNOW,YOLD)),0)
      GO TO  50
C
C JUST TURNED INVISIBLE
C
   40 CALL PLOTIT (IFIX(AVE(XNOW,XOLD)),IFIX(AVE(YNOW,YOLD)),1)
C
C BOTH INVISIBLE
C
   50 XOLD = XNOW
      YOLD = YNOW
      LASTV = IVNOW
C
C  TEST FOR RESOLUTION PROBLEM
C
      IF (NRLX.EQ.LRLX .AND. IY.EQ.IYOLD) RETURN
C
C  TEST FOR HORIZONTAL BITS
C
      IF (IYOLD .NE. IY) GO TO  70
C
C  HORIZONTAL BITS DETECTED. SET FLAG AND EXIT.
C  THIS AND THE NEXT HORIZONTAL BIT TEST IS NECESSARY FOR ISCR TO
C  CONFORM TO THE SHADING ALGORITHM IN SUBROUTINE FILLIN
C
C
C  IF HORIZONTAL LINE PREVIOUSLY DETECTED EXIT
C
      IF (.NOT.HBFLAG) GO TO  60
C
C  IF END OF CONTOUR ON A HORIZONTAL LINE BRANCH FOR SPECIAL PROCESSING.
C
      IF (NRLX.EQ.IFSX .AND. IY.EQ.IFSY) GO TO 210
      GO TO 200
C
C  SAVE SLOPE PRIOR TO HORIZONTAL LINE
C
   60 IHX = IXOLD
      IHB = IBTOLD
      IHS = IOSLSN
      IOSLSN = 0
      HBFLAG = .TRUE.
      IHRX = LRLX
      IHV = IVOLD
      IF (LRLX.EQ.IFSX .AND. IYOLD.EQ.IFSY) IHF = .TRUE.
C
C  THIS IS THE SECOND TRAP FOR END OF CONTOUR ON A HORIZONTAL LINE.
C
      IF (NRLX.EQ.IFSX .AND. IY.EQ.IFSY) GO TO 210
      GO TO 200
C
C  COMPUTE THE SLOPE TO THIS POINT
C
   70 IF (IY-IYOLD)  80, 90,100
   80 ISLSGN = 1
      GO TO 110
   90 ISLSGN = 0
      GO TO 120
  100 ISLSGN = -1
  110 IF (IYDIR .EQ. 0) IYDIR = ISLSGN
  120 CONTINUE
C
C  IF PROCESS REACHES THIS CODE THE CONTOUR IS NOT CONTAINED ON A SINGLE
C  HORIZONTAL  PLANE, SO RECORD THIS FACT BY SETTING Y CHANGE FLAG.
C
      YCHANG = .TRUE.
C
C  TEST FOR END OF HORIZONTAL LINE
C
      IF (.NOT.HBFLAG) GO TO 160
      HBFLAG = .FALSE.
C
C  HORIZONTAL LINE JUST ENDED
C
C  TEST FOR REDRAW
C
      ITEMP = IAND(ISCR(IXOLD,IYOLD),MASK(IBTOLD))
      IF ((IHV .EQ. 0) .AND. (ITEMP .EQ. 0)) GO TO 130
C
C  REDRAWING ERASE THIS POINT
C
      ISCR(IXOLD,IYOLD) = IAND(ISCR(IXOLD,IYOLD),NMASK(IBTOLD))
      ISCR(IHX,IYOLD) = IAND(ISCR(IHX,IYOLD),NMASK(IHB))
      GO TO 170
C
C  TEST FOR STEP PROBLEM
C
  130 IF (IHS .NE. ISLSGN) GO TO 140
C
C  STEP PROBLEM
C
      GO TO 170
C
C  TURNING PROBLEM HORIZONTAL LINE IS A TURNING POINT
C
  140 CONTINUE
C
C  ENTER THE TURNING POINT ONLY IF IT IS NOT THE SECOND SUCCEEDING
C  EVENT IN A ROW
C
      ICTPD = 1
      IF (IHRX .GT. NRLX) ICTPD = -1
      IF (ICTPD .NE. ITPD) GO TO 150
      ITPD = 0
C
C  ERASE THE FIRST POINT
C
      ISCR(IHX,IYOLD) = IAND(ISCR(IHX,IYOLD),NMASK(IHB))
      GO TO 170
C
C  ENTER THE TURNING POINT
C
  150 CONTINUE
      ITPD = ICTPD
C
C  ENTER THE SECOND POINT
C
      ISCR(IXOLD,IYOLD) = IOR(ISCR(IXOLD,IYOLD),MASK(IBTOLD))
      GO TO 170
C
C  CHECK IF PREVIOUS ENTRY WAS A VERTICAL TURNING POINT.
C  IF SO ERASE IT.
C
  160 IF (ISLSGN.EQ.IOSLSN .OR. (IOSLSN.EQ.0 .OR. ISLSGN.EQ.0))
     1    GO TO 170
      ITPD = 0
      ISCR(IXOLD,IYOLD) = IAND(ISCR(IXOLD,IYOLD),NMASK(IBTOLD))
C
  170 IOSLSN = ISLSGN
C
C  CHECK IF THIS GRID POINT PREVIOUSLY ACTIVATED
C
      IVAL = IAND(ISCR(IX,IY),MASK(IBIT))
C
C  IF GRID POINTS ACTIVATED BRANCH
C
      IF (IVAL .NE. 0) GO TO 190
C
C  GRID POINT NOT ACTIVATED   SET AND EXIT
C
  180 CONTINUE
      ISCR(IX,IY) = IOR(ISCR(IX,IY),MASK(IBIT))
      GO TO 200
C
C  THIS POINT IS BEING REDRAWN SO ERASE IT.
C  (THIS IS TO CONFORM WITH THE SHADING ALGORITHM, FILLIN.
C  HOWEVER IF BACK TO STARTING POINT DO NOT ERASE
C
  190 IF (NRLX.EQ.IFSX .AND. IY.EQ.IFSY) RETURN
      ISCR(IX,IY) = IAND(ISCR(IX,IY),NMASK(IBIT))
C
C
  200 IXOLD = IX
      LRLX = NRLX
      IYOLD = IY
      IBTOLD = IBIT
      IVOLD = IVAL
      RETURN
C
C  PERFORM THIS OPERATION WHEN A CONTOUR STARTS OR ENDS ON A HORIZONTAL
C  LINE.
C
  210 CONTINUE
C
C  ERASE THE FIRST POINT OF A CONTOUR WHEN IT IS PART OF A HORIZONTAL
C  LINE SEGMENT AND IS NOT THE ENDPOINT OF THE SEGMENT
C
      IF (.NOT.IHF) GO TO 220
      ISCR(IX,IY) = IAND(ISCR(IX,IY),NMASK(IBIT))
  220 CONTINUE
C
C  ERASE THE FIRST POINT OF A HORIZONTAL LINE SEGMENT WHEN IT ENDS
C  THE CONTOUR AND IS NOT THE HIGHEST LINE SEG ON THS SIDE.
C
      IF (.NOT.YCHANG) GO TO 230
      IF (IYDIR .NE. IHS) GO TO 200
  230 ISCR(IHX,IY) = IAND(ISCR(IHX,IY),NMASK(IHB))
      GO TO 200
      END
      SUBROUTINE FILLIN
C
      SAVE
      COMMON /ISOSR2/ LX         ,NX         ,NY         ,ISCR(8,128),
     1                ISCA(8,128)
      COMMON /ISOSR5/ NBPW       ,MASK(16)   ,GENDON
      LOGICAL         GENDON
      COMMON /ISOSR7/ IENTRY     ,IONES
C
      IF (IENTRY .EQ. 0) RETURN
C
C  THIS IS A SHADING ALGORITHM IT IS USED TO DETERMINE CONTOUR LINES
C  THAT ARE HIDDEN BY THE PRESENT LINE. THE ALGORITHM PROCESSES
C  HORIZONTAL ROWS. IT ASSUMES THAT THE BIT PATTERN PASSED TO IT
C  HAS ONLY BITS SET TO MARK THE START AND END OF SHADING. THE
C  ALGORITHM ALSO ASSUMES THAT WHEN AN ON BIT IS ENCOUNTERED THAT A
C  CORRESPONDING OFF BIT IS INCLUDED IN THE SAME ROW.
C
C
C  PULL OUT ROWS OF THE CONTOUR PATTERN
C
      IBVAL = 0
      DO  80 IYNOW=1,NY
         DO  40 IXNOW=1,LX
C
C  IF NO ACTIVATED BITS BRANCH
C
            ICRWD = ISCR(IXNOW,IYNOW)
            IF (ICRWD .EQ. 0) GO TO  30
C
C  ACTIVATED BITS IN WORD SET SHADING FLAG
C
C  CHECK BIT BY BIT FOR ON/OFF FLAGS
C
            DO  20 IB=1,NBPW
               IBIT = (NBPW+1)-IB
C
C
C  PULL OUT THE CURRENT GRID POINT VALUE
C
               IVAL = IAND(ICRWD,MASK(IBIT))
C
C  IF IVAL SET, THIS IS AN ON/OFF FLAG
C
               IF (IVAL .EQ. 0) GO TO  10
C
C  FLAG BIT, ALWAYS SET
C
               IBVAL = MOD(IBVAL+1,2)
               GO TO  20
C
C  SHADE THE SCREEN ACCORDING TO THE STATUS OF IBVAL
C
   10          IF (IBVAL .NE. 0) ICRWD = IOR(ICRWD,MASK(IBIT))
C
   20       CONTINUE
C
C  ZERO OUT THE SCREEN
C
            ISCR(IXNOW,IYNOW) = 0
            ISCA(IXNOW,IYNOW) = IOR(ICRWD,ISCA(IXNOW,IYNOW))
            GO TO  40
C
   30       IF (IBVAL .NE. 0) ISCA(IXNOW,IYNOW) = IONES
   40    CONTINUE
C
C  FIX FOR NONCORRECTABLE RUNAWAYS
C
         IF (IBVAL .EQ. 0) GO TO  80
         IBVAL = 0
         DO  70 K=1,LX
            ITEST = 0
            IF (IYNOW .EQ. 1) GO TO  50
            ITEST = ISCA(K,IYNOW-1)
            IF (IYNOW .EQ. NY) GO TO  60
   50       ITEST = IOR(ITEST,ISCA(K,IYNOW+1))
   60       ISCA(K,IYNOW) = ITEST
   70    CONTINUE
C
   80 CONTINUE
      RETURN
      END
      SUBROUTINE DRAWI (IXA,IYA,IXB,IYB)
C
C INCLUDED FOR USE BY PWRZ
C
      SAVE
      CALL FRSTC (IXA,IYA,1)
      CALL FRSTC (IXB,IYB,2)
      RETURN
      END
      SUBROUTINE MMASK
C
C  MAKE THE MACHINE DEPENDENT MASKS USED IN THE CONTOUR DRAWING
C  AND SHADING ALGORITHMS
C
      SAVE
      COMMON /ISOSR5/ NBPW       ,MASK(16)   ,GENDON
      LOGICAL         GENDON
      COMMON /ISOSR7/ IENTRY     ,IONES
      COMMON /ISOSR8/ NMASK(16)  ,IXOLD      ,IYOLD      ,IBTOLD     ,
     1                HBFLAG     ,IOSLSN     ,LRLX       ,IFSX       ,
     2                IFSY       ,FIRST      ,IYDIR      ,IHX        ,
     3                IHB        ,IHS        ,IHV        ,IVOLD      ,
     4                IVAL       ,IHRX       ,YCHANG     ,ITPD       ,
     5                IHF
      COMMON /ISOSR9/ BIG        ,IXBIT
      LOGICAL         YCHANG     ,HBFLAG     ,FIRST      ,IHF
      GENDON = .TRUE.
      NBPW = 16
C
C  GET BIGGEST REAL NUMBER
C
      BIG = R1MACH(2)
C
C  MASKS TO SELECT A SPECIFIC BIT
C
      DO  10 K=1,NBPW
         MASK(K) = ISHIFT(1,K-1)
   10 CONTINUE
C
C  GENERATE  THE BIT PATTERN 177777 OCTAL
C
      ITEMP1 = 0
      ITEMP = MASK(NBPW)
      IST = NBPW-1
      DO  20 K=1,IST
         ITEMP1 = IOR(ITEMP,ISHIFT(ITEMP1,-1))
   20 CONTINUE
      MFIX = IOR(ITEMP1,1)
C
C  MASKS TO CLEAR A SPECIFIC BIT
C
      DO  30 K=1,NBPW
         NMASK(K) = IAND(ITEMP1,MFIX)
         ITEMP1 = IOR(ISHIFT(ITEMP1,1),1)
   30 CONTINUE
      IONES = MFIX
      RETURN
C
C REVISION HISTORY---
C
C JANUARY 1978     DELETED REFERENCES TO THE  *COSY  CARDS AND
C                  ADDED REVISION HISTORY
C JANUARY 1979     NEW SHADING ALGORITHM
C MARCH 1979       MADE CODE MACHINE INDEPENDENT AND CONFORM
C                  TO 66 FORTRAN STANDARD
C JUNE 1979        THIS VERSION PLACED ON ULIB.
C SEPTEMBER 1979   FIXED PROBLEM IN EZISOS DEALING WITH
C                  DETERMINATION OF VISIBILITY OF W PLANE.
C DECEMBER 1979    FIXED PROBLEM WITH PEN DOWN ON CONTOUR
C                  INITIALIZATION IN SUBROUTINE FRSTC
C MARCH            CHANGED ROUTINE NAMES  TRN32I  AND  DRAW  TO
C                  TRN32I  AND  DRAWI  TO BE CONSISTENT WITH THE
C                  USAGE OF THE NEW ROUTINE  PWRZI.
C JUNE  1980       FIXED PROBLEM WITH ZERO INDEX COMPUTATION IN
C                  SUBROUTINE FRSTC.  ADDED INPUT PARAMETER
C                  DIMENSION STATEMENT MISSING IN EZISOS.
C                  FIXED ERROR IN COMPUTATION OF ARCCOSINE
C                  IN EZISOS AND TRN32I.
C DECEMBER 1984    CONVERTED TO GKS LEVEL 0A AND STANDARD FORTRAN 77
C-----------------------------------------------------------------------
C
      END

      subroutine parse
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer lexstr(100)
      integer lab, labval(100), lextyp(100), sp, token, i, t
      integer lex
      logical pushs0
      sp = 1
      lextyp(1) = -1
      token = lex(lexstr)
23000 if (.not.(token .ne. -1))goto 23002
      pushs0 = .false.
      I23003=(token)
      goto 23003
23005 continue
      call ifcode (lab)
      pushs0 = .true.
      goto 23004
23006 continue
      call iferrc (lab, 1)
      pushs0 = .true.
      goto 23004
23007 continue
      call iferrc (lab, 0)
      pushs0 = .true.
      goto 23004
23008 continue
      call docode (lab)
      pushs0 = .true.
      goto 23004
23009 continue
      call whilec (lab)
      pushs0 = .true.
      goto 23004
23010 continue
      call forcod (lab)
      pushs0 = .true.
      goto 23004
23011 continue
      call repcod (lab)
      pushs0 = .true.
      goto 23004
23012 continue
      call swcode (lab)
      pushs0 = .true.
      goto 23004
23013 continue
      i=sp
23014 if (.not.(i .gt. 0))goto 23016
      if (.not.(lextyp(i) .eq. -92))goto 23017
      goto 23016
23017 continue
23015 i=i-1
      goto 23014
23016 continue
      if (.not.(i .eq. 0))goto 23019
      call synerr (24Hillegal case or default.)
      goto 23020
23019 continue
      call cascod (labval (i), token)
23020 continue
      goto 23004
23021 continue
      call labelc (lexstr)
      pushs0 = .true.
      goto 23004
23022 continue
      t = lextyp(sp)
      if (.not.(t .eq. -99 .or. t .eq. -98 .or. t .eq. -97))goto 23023
      call elseif (labval(sp))
      goto 23024
23023 continue
      call synerr (13HIllegal else.)
23024 continue
      t = lex (lexstr)
      call pbstr (lexstr)
      if (.not.(t .eq. -99 .or. t .eq. -98 .or. t .eq. -97))goto 23025
      call indent (-1)
      token = -72
23025 continue
      pushs0 = .true.
      goto 23004
23027 continue
      if (.not.(lextyp(sp) .eq. -98 .or. lextyp(sp) .eq. -97))goto 23028
      call thenco (lextyp(sp), labval(sp))
      lab = labval(sp)
      token = lextyp(sp)
      sp = sp - 1
      goto 23029
23028 continue
      call synerr (41HIllegal 'then' clause in iferr statement.)
23029 continue
      pushs0 = .true.
      goto 23004
23030 continue
      call litral
      goto 23004
23031 continue
      call errchk
      goto 23004
23032 continue
      call beginc
      goto 23004
23033 continue
      call endcod (lexstr)
      if (.not.(sp .ne. 1))goto 23034
      call synerr (31HMissing right brace or 'begin'.)
      sp = 1
23034 continue
      goto 23004
23036 continue
      if (.not.(token .eq. 123))goto 23037
      pushs0 = .true.
      goto 23038
23037 continue
      if (.not.(token .eq. -67))goto 23039
      call declco (lexstr)
23039 continue
23038 continue
      goto 23004
23003 continue
      I23003=I23003+100
      if (I23003.lt.1.or.I23003.gt.18)goto 23036
      goto (23005,23006,23007,23008,23009,23010,23011,23012,23013,23013,
     *23021,23036,23022,23027,23030,23031,23032,23033),I23003
23004 continue
      if (.not.(pushs0))goto 23041
      if (.not.(body .eq. 0))goto 23043
      call synerr (24HMissing 'begin' keyword.)
      call beginc
23043 continue
      sp = sp + 1
      if (.not.(sp .gt. 100))goto 23045
      call baderr (25HStack overflow in parser.)
23045 continue
      lextyp(sp) = token
      labval(sp) = lab
      goto 23042
23041 continue
      if (.not.(token .ne. -91 .and. token .ne. -90))goto 23047
      if (.not.(token .eq. 125))goto 23049
      token = -74
23049 continue
      I23051=(token)
      goto 23051
23053 continue
      call otherc (lexstr)
      goto 23052
23054 continue
      call brknxt (sp, lextyp, labval, token)
      goto 23052
23055 continue
      call retcod
      goto 23052
23056 continue
      call gocode
      goto 23052
23057 continue
      if (.not.(body .eq. 0))goto 23058
      call strdcl
      goto 23059
23058 continue
      call otherc (lexstr)
23059 continue
      goto 23052
23060 continue
      if (.not.(lextyp(sp) .eq. 123))goto 23061
      sp = sp - 1
      goto 23062
23061 continue
      if (.not.(lextyp(sp) .eq. -92))goto 23063
      call swend (labval(sp))
      sp = sp - 1
      goto 23064
23063 continue
      call synerr (20HIllegal right brace.)
23064 continue
23062 continue
      goto 23052
23051 continue
      I23051=I23051+81
      if (I23051.lt.1.or.I23051.gt.7)goto 23052
      goto (23053,23054,23054,23055,23056,23057,23060),I23051
23052 continue
      token = lex (lexstr)
      call pbstr (lexstr)
      call unstak (sp, lextyp, labval, token)
23047 continue
23042 continue
23001 token = lex(lexstr)
      goto 23000
23002 continue
      if (.not.(sp .ne. 1))goto 23065
      call synerr (15Hunexpected EOF.)
23065 continue
      end
c     pushs0  push_stack
c     logic0  logical_column

#-h-  ngetch			  442  local   12/01/80  15:54:30
# ngetch - get a (possibly pushed back) character
   include  defs

   character function ngetch (c)
   character c

   include COMMON_BLOCKS

   integer getlin, n, i

   if (buf (bp) == EOS)
      if (getlin (buf (PBPOINT), infile (level)) == EOF)
	 c = EOF
      else {
	 c = buf (PBPOINT)
	 bp = PBPOINT + 1
	 if (c == SHARP) {		#check for "#!# nn" directive
	    if (buf(bp) == BANG & buf(bp+1) == SHARP) {
	       n = 0
	       for (i=bp+3;  buf(i) >= DIG0 & buf(i) <= DIG9;  i=i+1)
		  n = n * 10 + buf(i) - DIG0
	       linect (level) = n - 1
	       }
	    }
	    if (linect (level) > 0) {
	       linect (level) = linect (level) + 1
	    }
	 }
   else {
      c = buf (bp)
      bp = bp + 1
      }

   return (c)
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGCHNL (IAXS,VILS,CHRM,MCIM,NCIM,IPXM,CHRE,MCIE,NCIE)
C
      CHARACTER*(*) CHRM,CHRE
C
C The routine AGCHNL is called by AGAXIS just after it has set up the
C character strings comprising a numeric label along an axis.  The
C default version does nothing.  A user may supply his own version to
C change the numeric labels.  For each numeric label, this routine is
C called twice by AGAXIS - once to determine how much space will be
C required when the label is actually drawn and once just before it
C is actually drawn.  The arguments are as follows:
C
C - IAXS is the number of the axis being drawn.  Its value is 1, 2, 3,
C   or 4, implying the left, right, bottom, or top axes, respectively.
C   The value of IAXS must not be altered.
C
C - VILS is the value to be represented by the numeric label, in the
C   label system for the axis.  The value of VILS must not be altered.
C
C - CHRM, on entry, is a character string containing the mantissa of the
C   numeric label, as it will appear if AGCHNL makes no changes.  If the
C   numeric label includes a "times" symbol, it will be represented by
C   a blank in CHRM.  (See IPXM, below.)  CHRM may be modified.
C
C - MCIM is the length of CHRM - the maximum number of characters that
C   it will hold.  The value of MCIM must not be altered.
C
C - NCIM, on entry, is the number of meaningful characters in CHRM.  If
C   CHRM is changed, NCIM should be changed accordingly.
C
C - IPXM, on entry, is zero if there is no "times" symbol in CHRM; if it
C   is non-zero, it is the index of the appropriate character position
C   in CHRM.  If AGCHNL changes the position of the "times" symbol in
C   CHRM, removes it, or adds it, the value of IPXM must be changed.
C
C - CHRE, on entry, is a character string containing the exponent of the
C   numeric label, as it will appear if AGCHNL makes no changes.  CHRE
C   may be modified.
C
C - MCIE is the length of CHRE - the maximum number of characters that
C   it will hold.  The value of MCIE must not be altered.
C
C - NCIE, on entry, is the number of meaningful characters in CHRE.  If
C   CHRE is changed, NCIE should be changed accordingly.
C
C Done.
C
      RETURN
C
      END

      DOUBLE PRECISION FUNCTION slPA (HA, DEC, PHI)
*+
*     - - -
*      P A
*     - - -
*
*  HA, Dec to Parallactic Angle (double precision)
*
*  Given:
*     HA     d     hour angle in radians (geocentric apparent)
*     DEC    d     declination in radians (geocentric apparent)
*     PHI    d     observatory latitude in radians (geodetic)
*
*  The result is in the range -pi to +pi
*
*  Notes:
*
*  1)  The parallactic angle at a point in the sky is the position
*      angle of the vertical, i.e. the angle between the direction to
*      the pole and to the zenith.  In precise applications care must
*      be taken only to use geocentric apparent HA,Dec and to consider
*      separately the effects of atmospheric refraction and telescope
*      mount errors.
*
*  2)  At the pole a zero result is returned.
*
*  P.T.Wallace   Starlink   16 August 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION HA,DEC,PHI

      DOUBLE PRECISION CP,SQSZ,CQSZ



      CP=COS(PHI)
      SQSZ=CP*SIN(HA)
      CQSZ=SIN(PHI)*COS(DEC)-CP*SIN(DEC)*COS(HA)
      IF (SQSZ.EQ.0D0.AND.CQSZ.EQ.0D0) CQSZ=1D0
      slPA=ATAN2(SQSZ,CQSZ)

      END

      SUBROUTINE slHF5Z (RH,DH,EPOCH,R5,D5,DR5,DD5)
*+
*     - - - - - -
*      H F 5 Z
*     - - - - - -
*
*  Transform a Hipparcos star position into FK5 J2000, assuming
*  zero Hipparcos proper motion.
*
*  (double precision)
*
*  Given:
*     RH        d      Hipparcos RA (radians)
*     DH        d      Hipparcos Dec (radians)
*     EPOCH     d      Julian epoch (TDB)
*
*  Returned (all FK5, equinox J2000, epoch EPOCH):
*     R5        d      RA (radians)
*     D5        d      Dec (radians)
*
*  Called:  slDS2C, slDAVM, slDMXV, slDMXM,
*           slDIMV, slDVXV, slDC6S, slDA2P
*
*  Notes:
*
*  1)  The proper motion in RA is dRA/dt rather than cos(Dec)*dRA/dt.
*
*  2)  The FK5 to Hipparcos transformation consists of a pure
*      rotation and spin;  zonal errors in the FK5 catalogue are
*      not taken into account.
*
*  3)  The published orientation and spin components are interpreted
*      as "axial vectors".  An axial vector points at the pole of the
*      rotation and its length is the amount of rotation in radians.
*
*  4)  It was the intention that Hipparcos should be a close
*      approximation to an inertial frame, so that distant objects
*      have zero proper motion;  such objects have (in general)
*      non-zero proper motion in FK5, and this routine returns those
*      fictitious proper motions.
*
*  5)  The position returned by this routine is in the FK5 J2000
*      reference frame but at Julian epoch EPOCH.
*
*  6)  See also slFK5H, slHFK5, sla_FK5ZHZ.
*
*  Reference:
*
*     M.Feissel & F.Mignard, Astron. Astrophys. 331, L33-L36 (1998).
*
*  P.T.Wallace   Starlink   30 December 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RH,DH,EPOCH,R5,D5,DR5,DD5

      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

*  FK5 to Hipparcos orientation and spin (radians, radians/year)
      DOUBLE PRECISION EPX,EPY,EPZ
      DOUBLE PRECISION OMX,OMY,OMZ

      PARAMETER ( EPX = -19.9D-3 * AS2R,
     :            EPY =  -9.1D-3 * AS2R,
     :            EPZ = +22.9D-3 * AS2R )

      PARAMETER ( OMX = -0.30D-3 * AS2R,
     :            OMY = +0.60D-3 * AS2R,
     :            OMZ = +0.70D-3 * AS2R )

      DOUBLE PRECISION PH(3),ORTN(3),R5H(3,3),S5(3),SH(3),T,VST(3),
     :                 RST(3,3),R5HT(3,3),PV5E(6),VV(3),W,R,V

      DOUBLE PRECISION slDA2P



*  Hipparcos barycentric position vector (normalized).
      CALL slDS2C(RH,DH,PH)

*  FK5 to Hipparcos orientation matrix.
      ORTN(1) = EPX
      ORTN(2) = EPY
      ORTN(3) = EPZ
      CALL slDAVM(ORTN,R5H)

*  Hipparcos wrt FK5 spin vector.
      S5(1) = OMX
      S5(2) = OMY
      S5(3) = OMZ

*  Rotate the spin vector into the Hipparcos frame.
      CALL slDMXV(R5H,S5,SH)

*  Time interval from J2000 to epoch.
      T = EPOCH-2000D0

*  Axial vector:  accumulated Hipparcos wrt FK5 spin over that interval.
      VST(1) = OMX*T
      VST(2) = OMY*T
      VST(3) = OMZ*T

*  Express the accumulated spin as a rotation matrix.
      CALL slDAVM(VST,RST)

*  Rotation matrix:  accumulated spin, then FK5 to Hipparcos.
      CALL slDMXM(R5H,RST,R5HT)

*  De-orient & de-spin the vector into FK5 J2000 at epoch.
      CALL slDIMV(R5HT,PH,PV5E)
      CALL slDVXV(SH,PH,VV)
      CALL slDIMV(R5HT,VV,PV5E(4))

*  FK5 position/velocity 6-vector to spherical.
      CALL slDC6S(PV5E,W,D5,R,DR5,DD5,V)
      R5 = slDA2P(W)

      END

C----------------------------------------------------------------------
        subroutine fti2c(ival,cval,status)
C       convert an integer value to a C*20 character string, right justified
        integer ival,status
        character*20 cval

        if (status .gt. 0)return

        write(cval,1000,err=900)ival
1000    format(i20)
        if (cval(1:1) .eq. '*')go to 900
        return
900     status=401
        call ftpmsg('Error in FTI2C converting integer to C*20 string.')        
        end

c MKIM -- Make a two dimensional test image of type short or real.  The pixel
c values go 1, 2, 3, etc. in storage order.
c
c 	usage:  mkim image ncols nlines [dtype] [pixdir]
c
c The data type defaults to type short if not specified on the command line.
c ---------------------------------------------------------------------------- 

	program mkim

	character*80	image, errmsg, pixdir
	integer		im, ier, axlen(7), naxis, dtype
	integer		nlines, ncols, i, j
	real		pix(8192)

c --- Get image name.
	call clargc (1, image, ier)
	if (ier .ne. 0) then
	    write (*, '('' enter image name: '',$)')
	    read (*,*) image
	endif

c --- Get image size.
	call clargi (2, ncols, ier)
	if (ier .ne. 0) then
	    write (*, '('' ncols: '',$)')
	    read (*,*) ncols
	endif
	call clargi (3, nlines, ier)
	if (ier .ne. 0) then
	    write (*, '('' nlines: '',$)')
	    read (*,*) nlines
	endif

c --- Get pixel datatype (optional).
	call clargi (4, dtype, ier)
	if (ier .ne. 0) dtype = 3

c --- Get pixel directory (optional).
	call clargc (5, pixdir, ier)
	if (ier .eq. 0) then
	    call imsdir (pixdir)
	endif

	axlen(1) = ncols
	axlen(2) = nlines
	naxis    = 2

c --- Create the image.
	call imcrea (image, axlen, naxis, dtype, ier)
	if (ier .ne. 0) goto 91

c --- Open the image for writing, and write the data.
	call imopen (image, 3, im, ier)
	if (ier .ne. 0) goto 91

	do 20 j = 1, nlines
	    do 10 i = 1, ncols
		pix(i) = (j-1) * ncols + i
 10	    continue
	    call impl2r (im, pix, j, ier)
	    if (ier .ne. 0) goto 91
 20	continue

c --- Close the image and quit.
	call imclos (im, ier)
	if (ier .ne. 0) goto 91

	stop

c --- Error exit.
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg
	stop
	end

      subroutine fcopy (in, out)
      integer in, out
      integer line (128)
      integer getlin
23000 if (.not.(getlin (line, in) .ne. -1))goto 23001
      call putlin (line, out)
      goto 23000
23001 continue
      return
      end

C--------------------------------------------------------------------------
        subroutine fthdef(ounit,moreky,status)

C       Header DEFinition
C       define the size of the current header unit; this simply lets
C       us determine where the data unit will start
C
C       ounit   i  Fortran I/O unit number
C       moreky  i  number of additional keywords to reserve space for
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,moreky,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff,mkeys

        if (status .gt. 0)return

C       based on the number of keywords which have already been written,
C       plus the number of keywords to reserve space for, we then can
C       define where the data unit should start (it must start at the
C       beginning of a 2880-byte logical block).

        ibuff=bufnum(ounit)

        mkeys=max(moreky,0)
        dtstrt(ibuff)=((hdend(ibuff)+mkeys*80)/2880+1)*2880
        end

      SUBROUTINE slAOPA ( DATE, DUT, ELONGM, PHIM, HM,
     :                       XP, YP, TDK, PMB, RH, WL, TLR, AOPRMS )
*+
*     - - - - - -
*      A O P A
*     - - - - - -
*
*  Precompute apparent to observed place parameters required by
*  slAOPQ and slOAPQ.
*
*  Given:
*     DATE   d      UTC date/time (modified Julian Date, JD-2400000.5)
*     DUT    d      delta UT:  UT1-UTC (UTC seconds)
*     ELONGM d      mean longitude of the observer (radians, east +ve)
*     PHIM   d      mean geodetic latitude of the observer (radians)
*     HM     d      observer's height above sea level (metres)
*     XP     d      polar motion x-coordinate (radians)
*     YP     d      polar motion y-coordinate (radians)
*     TDK    d      local ambient temperature (K; std=273.15D0)
*     PMB    d      local atmospheric pressure (mb; std=1013.25D0)
*     RH     d      local relative humidity (in the range 0D0-1D0)
*     WL     d      effective wavelength (micron, e.g. 0.55D0)
*     TLR    d      tropospheric lapse rate (K/metre, e.g. 0.0065D0)
*
*  Returned:
*     AOPRMS d(14)  star-independent apparent-to-observed parameters:
*
*       (1)      geodetic latitude (radians)
*       (2,3)    sine and cosine of geodetic latitude
*       (4)      magnitude of diurnal aberration vector
*       (5)      height (HM)
*       (6)      ambient temperature (TDK)
*       (7)      pressure (PMB)
*       (8)      relative humidity (RH)
*       (9)      wavelength (WL)
*       (10)     lapse rate (TLR)
*       (11,12)  refraction constants A and B (radians)
*       (13)     longitude + eqn of equinoxes + sidereal DUT (radians)
*       (14)     local apparent sidereal time (radians)
*
*  Notes:
*
*   1)  It is advisable to take great care with units, as even
*       unlikely values of the input parameters are accepted and
*       processed in accordance with the models used.
*
*   2)  The DATE argument is UTC expressed as an MJD.  This is,
*       strictly speaking, improper, because of leap seconds.  However,
*       as long as the delta UT and the UTC are consistent there
*       are no difficulties, except during a leap second.  In this
*       case, the start of the 61st second of the final minute should
*       begin a new MJD day and the old pre-leap delta UT should
*       continue to be used.  As the 61st second completes, the MJD
*       should revert to the start of the day as, simultaneously,
*       the delta UTC changes by one second to its post-leap new value.
*
*   3)  The delta UT (UT1-UTC) is tabulated in IERS circulars and
*       elsewhere.  It increases by exactly one second at the end of
*       each UTC leap second, introduced in order to keep delta UT
*       within +/- 0.9 seconds.
*
*   4)  IMPORTANT -- TAKE CARE WITH THE LONGITUDE SIGN CONVENTION.
*       The longitude required by the present routine is east-positive,
*       in accordance with geographical convention (and right-handed).
*       In particular, note that the longitudes returned by the
*       slOBS routine are west-positive, following astronomical
*       usage, and must be reversed in sign before use in the present
*       routine.
*
*   5)  The polar coordinates XP,YP can be obtained from IERS
*       circulars and equivalent publications.  The maximum amplitude
*       is about 0.3 arcseconds.  If XP,YP values are unavailable,
*       use XP=YP=0D0.  See page B60 of the 1988 Astronomical Almanac
*       for a definition of the two angles.
*
*   6)  The height above sea level of the observing station, HM,
*       can be obtained from the Astronomical Almanac (Section J
*       in the 1988 edition), or via the routine slOBS.  If P,
*       the pressure in millibars, is available, an adequate
*       estimate of HM can be obtained from the expression
*
*             HM ~ -29.3D0*TSL*LOG(P/1013.25D0).
*
*       where TSL is the approximate sea-level air temperature in K
*       (see Astrophysical Quantities, C.W.Allen, 3rd edition,
*       section 52).  Similarly, if the pressure P is not known,
*       it can be estimated from the height of the observing
*       station, HM, as follows:
*
*             P ~ 1013.25D0*EXP(-HM/(29.3D0*TSL)).
*
*       Note, however, that the refraction is nearly proportional to the
*       pressure and that an accurate P value is important for precise
*       work.
*
*   7)  Repeated, computationally-expensive, calls to slAOPA for
*       times that are very close together can be avoided by calling
*       slAOPA just once and then using slAOPT for the subsequent
*       times.  Fresh calls to slAOPA will be needed only when
*       changes in the precession have grown to unacceptable levels or
*       when anything affecting the refraction has changed.
*
*  Called:  slGEOC, slRFCO, slEQEX, slAOPT
*
*  Last revision:   2 December 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE,DUT,ELONGM,PHIM,HM,XP,YP,TDK,PMB,
     :                 RH,WL,TLR,AOPRMS(14)

      DOUBLE PRECISION slEQEX

*  2Pi
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)

*  Seconds of time to radians
      DOUBLE PRECISION S2R
      PARAMETER (S2R=7.272205216643039903848712D-5)

*  Speed of light (AU per day)
      DOUBLE PRECISION C
      PARAMETER (C=173.14463331D0)

*  Ratio between solar and sidereal time
      DOUBLE PRECISION SOLSID
      PARAMETER (SOLSID=1.00273790935D0)

      DOUBLE PRECISION CPHIM,XT,YT,ZT,XC,YC,ZC,ELONG,PHI,UAU,VAU



*  Observer's location corrected for polar motion
      CPHIM = COS(PHIM)
      XT = COS(ELONGM)*CPHIM
      YT = SIN(ELONGM)*CPHIM
      ZT = SIN(PHIM)
      XC = XT-XP*ZT
      YC = YT+YP*ZT
      ZC = XP*XT-YP*YT+ZT
      IF (XC.EQ.0D0.AND.YC.EQ.0D0) THEN
         ELONG = 0D0
      ELSE
         ELONG = ATAN2(YC,XC)
      END IF
      PHI = ATAN2(ZC,SQRT(XC*XC+YC*YC))
      AOPRMS(1) = PHI
      AOPRMS(2) = SIN(PHI)
      AOPRMS(3) = COS(PHI)

*  Magnitude of the diurnal aberration vector
      CALL slGEOC(PHI,HM,UAU,VAU)
      AOPRMS(4) = D2PI*UAU*SOLSID/C

*  Copy the refraction parameters and compute the A & B constants
      AOPRMS(5) = HM
      AOPRMS(6) = TDK
      AOPRMS(7) = PMB
      AOPRMS(8) = RH
      AOPRMS(9) = WL
      AOPRMS(10) = TLR
      CALL slRFCO(HM,TDK,PMB,RH,WL,PHI,TLR,1D-10,
     :               AOPRMS(11),AOPRMS(12))

*  Longitude + equation of the equinoxes + sidereal equivalent of DUT
*  (ignoring change in equation of the equinoxes between UTC and TDB)
      AOPRMS(13) = ELONG+slEQEX(DATE)+DUT*SOLSID*S2R

*  Sidereal time
      CALL slAOPT(DATE,AOPRMS)

      END

chapter x. example 1. plotting some b-splines
c  from  * a practical guide to splines *  by c. de boor
calls  bsplvb, interv
      integer i,j,k,left,leftmk,mflag,n,npoint
      real dx,t(10),values(7),x,xl
c  dimension, order and knot sequence for spline space are specified...
      data n,k /7,3/, t /3*0.,2*1.,3.,4.,3*6./
c  b-spline values are initialized to 0., number of evaluation points...
      data values /7*0./, npoint /31/
c  set leftmost evaluation point  xl , and spacing  dx	to be used...
      xl = t(k)
      dx = (t(n+1)-t(k))/float(npoint-1)
c
      print 600,(i,i=1,5)
  600 format(4h1  x,8x,5(1hb,i1,3h(x),7x))
c
      do 10 i=1,npoint
	 x = xl + float(i-1)*dx
c		      locate  x  with respect to knot array  t .
	 call interv ( t, n, x, left, mflag )
	 leftmk = left - k
c	    get b(i,k)(x)  in  values(i) , i=1,...,n .	k  of these,
c	 viz.  b(left-k+1,k)(x), ..., b(left,k)(x),  are supplied by
c	 bsplvb . all others are known to be zero a priori.
	 call bsplvb ( t, k, 1, x, left, values(leftmk+1) )
c
	 print 610, x, (values(j),j=3,7)
  610	 format(f7.3,5f12.7)
c
c	    zero out the values just computed in preparation for next
c	 evalulation point .
	 do 10 j=1,k
   10	    values(leftmk+j) = 0.
					stop
      end

      FUNCTION CONCOM (XQ,YQ,XD,YD,ZD,NDP,WK,IWK,LOC)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  INTERPOLATE A GIVEN X,Y PAIR AND RETURN ITS LOCATION
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      DIMENSION       XD(1)      ,YD(1)      ,ZD(1)      ,WK(1)      ,
     1                IWK(1)
C
        SAVE
C
C LOCATE PROPER TRIANGLE
C
      CALL CONLOC (NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),XQ,YQ,LOC,
     1             IWK(JWIWL),WK)
C
C  INTERPOLATE THE LOCATION
C
      CALL CONCAL (XD,YD,ZD,NT,IWK(JWIPT),NL,IWK(JWIPL),WK(IPR),LOC,XQ,
     1             YQ,TEMP,ITPV)
      CONCOM = TEMP
      RETURN
      END

      subroutine concat (buf1, buf2, outstr)
      integer buf1(100), buf2(100), outstr(100)
      integer i
      i = 1
      call stcopy (buf1, 1, outstr, i)
      call scopy (buf2, 1, outstr, i)
      return
      end

      integer function mktabl (nodsiz)
      integer nodsiz
      integer mem( 60000)
      common/cdsmem/mem
      integer st
      integer dsget
      integer i
      st = dsget (43 + 1)
      mem (st) = nodsiz
      mktabl = st
      do 23000 i = 1, 43
      st = st + 1
      mem (st) = 0
23000 continue
23001 continue
      return
      end

      subroutine preout
      dimension       idummy(1)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c
c+kpno
c Initialization moved to z8zpii.f.
c
      common /nsplt1/  iclrfb ,isetfb ,ibpw   ,ifwd
c     data iclrfb/0/, isetfb/0/, ibpw/32/, ifwd/1/
c-kpno
c
      kbufa = mbufa
c
c entry while in flash1 mode will cause restart of filling user buffer
c if its size is exceded.  otherwise it is assumed fixed-length output
c record size is exceded, so place for 4 bytes is reserved in user
c buffer, to allow proper record formatting during flash3 call.
c
      if (modef .ne. 1) go to 101
      if (mbuflu+4 .le. mbufl) go to 113
      mbuflu = 0
      mf2er = mf2er+1
      go to 113
c
c if necessary, build masks for setting and clearing new-frame flag
c
  101 if (iclrfb .ne. 0) go to 103
      iposn = ibpw*ifwd-21
      isetfb = ishift(1,iposn)
      do 102 i=1,ibpw
         ibit = 1
         if (i .eq. (ibpw-iposn)) ibit = 0
         iclrfb = ior(ishift(iclrfb,1),ibit)
  102 continue
c
c in flash3 mode, copy any shorter-than-record-length user buffer into
c system buffer, to avoid possible addressing error during fixed-length
c write.
c
  103 if (modef .ne. -3) go to 105
      if (mbuflu .eq. msblen) go to 105
      isub = kbufa-loci(idummy)+1
      do 104 i=1,mbuflu
         msybuf(i) = idummy(isub)
         isub = isub+1
  104 continue
      kbufa = loci(msybuf)
c
c compute metacode byte count and put in first 16 bits of buffer.
c       *** note that we are directly manipulating the
c           first 32 bits of the output buffer here ***
c
  105 mcrout = mcrout+1
      nbytes = -3+(ibpw*mbuflu-1)/8
      isub = kbufa-loci(idummy)+1
      idummy(isub) = ior(idummy(isub),ishift(nbytes,ibpw-16))
c
c put in first-record-of-frame flag if appropriate.  otherwise insure
c frame flag is zeroed.  put buffer out via writeb.
c
      isub = kbufa-loci(idummy)+ifwd
      if (mfrlst .ne. 1) go to 106
      idummy(isub) = ior(idummy(isub),isetfb)
      mfrlst = 0
      go to 107
  106 idummy(isub) = iand(idummy(isub),iclrfb)
  107 if (mbuflu .eq. msblen) go to 109
      isub = kbufa+mbuflu-loci(idummy)
      do 108 i=mbuflu,msblen
         isub = isub+1
         idummy(isub) = 0
  108 continue
  109 call writeb (kbufa,mbuflu,munit)
c
c if this is last buffer of frame, call writeb with zero-byte-count
c record, so that it may arrange that such a record follows the last
c frame of the metafile (note that mbufa points to msybuf when get here)
c
      if (mfrend .ne. 1) go to 112
      mfrlst = 1
      isub = kbufa-loci(idummy)
      do 110 i=1,mbuflu
         isub = isub+1
         idummy(isub) = 0
  110 continue
      do 111 i=1,16
         mbprs(i) = 0
  111 continue
      mbprs(2) = ior(mpair2,2048)
      call packum (mbprs,16,kbufa)
      call writeb (kbufa,0,munit)
c
c finish up by reserving 4 bytes at start of next output buffer.
c
  112 mbuflu = 0
  113 mbprs(1) = mpair1
      mbprs(2) = mpair2
      mipair = 2
      mflcnt = 0
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGCHAX (IFLG,IAXS,IPRT,VILS)
C
C The routine AGCHAX is called by AGAXIS just before and just after each
C of a selected set of objects on the axes are drawn.  A user may supply
C a version to change the appearance of these objects.  The arguments
C are as follows:
C
C - IFLG is zero if a particular object is about to be drawn, non-zero
C   if it has just been drawn.
C
C - IAXS is the number of the axis in question.  The values 1, 2, 3, and
C   4 imply the right, left, bottom, and top axes, respectively.
C
C - IPRT is an integer implying which part of the axis is being drawn.
C   The value 1 implies the line itself, 2 a major tick, 3 a minor tick,
C   4 the mantissa of a label, and 5 the exponent of a label.
C
C - VILS is the value, in the label coordinate system along the axis,
C   associated with the position of the object being drawn.  IPRT=1
C   implies VILS=0.
C
C Done.
C
      RETURN
C
      END

C----------------------------------------------------------------------
        subroutine ftpprj(ounit,group,felem,nelem,array,status)

C       Write an array of i*4 values into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being written).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       felem   i  the first pixel to be written (this routine treats
C                  the primary array a large one dimensional array of
C                  values, regardless of the actual dimensionality).
C       nelem   i  number of data elements to be written
C       array   i  the array of values to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,felem,nelem,status,row
        integer array(*)

C       the primary array is represented as a binary table:
C               each group of the primary array is a row in the table,
C               where the first column contains the group parameters
C               and the second column contains the image itself
        row=max(group,1)
        call ftpclj(ounit,2,row,felem,nelem,array,status)
        end

#-h-  pbnum			  304  local   12/01/80  15:54:33
# pbnum - convert number to string, push back on input
   include  defs

   subroutine pbnum (n)
   integer n

   integer m, num
   integer mod

   string digits '0123456789'

   num = n
   repeat {
      m = mod (num, 10)
      call putbak (digits (m + 1))
      num = num / 10
      } until (num == 0)
   return
   end

C--------------------------------------------------------------------------
        subroutine ftgkyj(iunit,keywrd,intval,comm,status)

C       read an integer value and the comment string from a header record 
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name   
C       OUTPUT PARAMETERS:
C       intval  i  output keyword value 
C       comm    c  output keyword comment
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        integer iunit,intval,status
        character value*35

C       find the keyword and return value and comment as character strings
        call ftgkey(iunit,keywrd,value,comm,status)

C       convert character string to integer
C       datatype conversion will be performed if necessary and if possible
        call ftc2i(value,intval,status)
        end

C----------------------------------------------------------------------
        subroutine ftgbit(buffer,log8)

C       decode the individual bits within the byte into an array of 
C       logical values.  The corresponding logical value is set to 
C       true if the bit is set to 1.

C       buffer  i  input integer containing the byte to be decoded
C       log8    l  output array of logical data values corresponding 
C                  to the bits in the input buffer
C
C       written by Wm Pence, HEASARC/GSFC, May 1992

        integer buffer,tbuff
        logical log8(8)

        log8(1)=.false.
        log8(2)=.false.
        log8(3)=.false.
        log8(4)=.false.
        log8(5)=.false.
        log8(6)=.false.
        log8(7)=.false.
        log8(8)=.false.

C       test for special case: no bits are set
        if (buffer .eq. 0)return

C       This algorithm tests to see if each bit is set by testing
C       the numerical value of the byte, starting with the most significant
C       bit.  If the bit is set, then it is reset to zero before testing
C       the next most significant bit, and so on.

        tbuff=buffer

C       now decode the least significant byte
        if (tbuff .gt. 127)then
                log8(1)=.true.
                tbuff=tbuff-128
        end if
        if (tbuff .gt. 63)then
                log8(2)=.true.
                tbuff=tbuff-64
        end if
        if (tbuff .gt. 31)then
                log8(3)=.true.
                tbuff=tbuff-32
        end if
        if (tbuff .gt. 15)then
                log8(4)=.true.
                tbuff=tbuff-16
        end if
        if (tbuff .gt. 7)then
                log8(5)=.true.
                tbuff=tbuff-8
        end if
        if (tbuff .gt. 3)then
                log8(6)=.true.
                tbuff=tbuff-4
        end if
        if (tbuff .gt. 1)then
                log8(7)=.true.
                tbuff=tbuff-2
        end if
        if (tbuff .eq. 1)then
                log8(8)=.true.
        end if
        end            

C----------------------------------------------------------------------
        subroutine ftgprh(iunit,simple,bitpix,naxis,naxes,
     &                    pcount,gcount,extend,status)

C       OBSOLETE routine: should call ftghpr instead

        integer iunit,bitpix,naxis,naxes(*),pcount,gcount,blank,status
        integer nblank
        logical simple,extend
        double precision fill
        
        call ftgphx(iunit,0,simple,bitpix,naxis,naxes,
     &        pcount,gcount,extend,fill,fill,blank,nblank,status)
        end

C--------------------------------------------------------------------------
        subroutine ftghps(iunit,nkeys,pos,status)

C       Get Header Position
C       get the number of keywords in the header and the current position 
C       in the header, i.e.,  the number of the next keyword record that 
C       would be read.  
C
C       iunit   i  Fortran I/O unit number
C       pos     i  current position in header (1 = beginning of header)
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Jan 1995

        integer iunit,nkeys,pos,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff

        if (status .gt. 0)return

        ibuff=bufnum(iunit)
        nkeys=(hdend(ibuff)-hdstrt(ibuff,chdu(ibuff)))/80
        pos=(nxthdr(ibuff)-hdstrt(ibuff,chdu(ibuff)))/80+1
        end

      SUBROUTINE slDRAF (NDP, ANGLE, SIGN, IDMSF)
*+
*     - - - - - -
*      D R A F
*     - - - - - -
*
*  Convert an angle in radians to degrees, arcminutes, arcseconds
*  (double precision)
*
*  Given:
*     NDP      i      number of decimal places of arcseconds
*     ANGLE    d      angle in radians
*
*  Returned:
*     SIGN     c      '+' or '-'
*     IDMSF    i(4)   degrees, arcminutes, arcseconds, fraction
*
*  Notes:
*
*     1)  NDP less than zero is interpreted as zero.
*
*     2)  The largest useful value for NDP is determined by the size
*         of ANGLE, the format of DOUBLE PRECISION floating-point
*         numbers on the target machine, and the risk of overflowing
*         IDMSF(4).  On some architectures, for ANGLE up to 2pi, the
*         available floating-point precision corresponds roughly to
*         NDP=12.  However, the practical limit is NDP=9, set by the
*         capacity of a typical 32-bit IDMSF(4).
*
*     3)  The absolute value of ANGLE may exceed 2pi.  In cases where it
*         does not, it is up to the caller to test for and handle the
*         case where ANGLE is very nearly 2pi and rounds up to 360 deg,
*         by testing for IDMSF(1)=360 and setting IDMSF(1-4) to zero.
*
*  Called:  slDDTF
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER NDP
      DOUBLE PRECISION ANGLE
      CHARACTER SIGN*(*)
      INTEGER IDMSF(4)

*  Hours to degrees * radians to turns
      DOUBLE PRECISION F
      PARAMETER (F=15D0/6.283185307179586476925287D0)



*  Scale then use days to h,m,s routine
      CALL slDDTF(NDP,ANGLE*F,SIGN,IDMSF)

      END

      SUBROUTINE slCS2C (A, B, V)
*+
*     - - - - -
*      C S 2 C
*     - - - - -
*
*  Spherical coordinates to direction cosines (single precision)
*
*  Given:
*     A,B      real      spherical coordinates in radians
*                           (RA,Dec), (long,lat) etc.
*
*  Returned:
*     V        real(3)   x,y,z unit vector
*
*  The spherical coordinates are longitude (+ve anticlockwise looking
*  from the +ve latitude pole) and latitude.  The Cartesian coordinates
*  are right handed, with the x axis at zero longitude and latitude, and
*  the z axis at the +ve latitude pole.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL A,B,V(3)

      REAL COSB



      COSB = COS(B)

      V(1) = COS(A)*COSB
      V(2) = SIN(A)*COSB
      V(3) = SIN(B)

      END

C----------------------------------------------------------------------
        subroutine ftghad(iunit,curhdu,nxthdu)

C       return the starting byte address of the CHDU and the next HDU.

C       curhdu  i  starting address of the CHDU
C       nxthdu  i  starting address of the next HDU

C       written by Wm Pence, HEASARC/GSFC, May, 1995

        integer iunit,curhdu,nxthdu

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,hdunum

        ibuff=bufnum(iunit)
        hdunum=chdu(ibuff)
        curhdu=hdstrt(ibuff,hdunum)
        nxthdu=hdstrt(ibuff,hdunum+1)
        end        

C----------------------------------------------------------------------
        subroutine ftasfm(form,dtype,width,decims,status)

C       'ASCII Format'
C       parse the ASCII table TFORM column format to determine the data
C       type, the field width, and number of decimal places (if relevant)
C
C       form    c  TFORM format string
C       OUTPUT PARAMETERS:
C       dattyp  i  datatype code
C       width   i  width of the field
C       decims  i  number of decimal places
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, November 1994

        character*(*) form
        integer dtype,width,decims,status
        character dattyp*1,cform*16
        integer nc,c1,i,nw

        if (status .gt. 0)return

        cform=form

C       find first non-blank character
        nc=len(form)
        do 5 i=1,nc
                if (form(i:i) .ne. ' ')then
                        c1=i
                        go to 10
                end if
5       continue

C       error: TFORM is a blank string
        status=261
        call ftpmsg('The TFORM keyword has a blank value.')
        return

10      continue

C       now the chararcter at position c1 should be the data type code
        dattyp=form(c1:c1)

C       set the numeric datatype code
        if (dattyp .eq. 'I')then
                dtype=41
        else if (dattyp .eq. 'E')then
                dtype=42
        else if (dattyp .eq. 'F')then
                dtype=42
        else if (dattyp .eq. 'D')then
                dtype=82
        else if (dattyp .eq. 'A')then
                dtype=16
        else
C               unknown tform datatype code
                status=262
                call ftpmsg('Unknown ASCII table TFORMn keyword '//
     &                      'datatype: '//cform)
                return
        end if
                
C       determine the field width
        c1=c1+1
        nw=0
        do 40 i=c1,nc
            if (form(i:i) .ge. '0' .and. form(i:i).le.'9')then
                    nw=nw+1
            else
                    go to 50
            end if
40      continue
50      continue
        if (nw .eq. 0)then
C               error, no width specified
                go to 990
        else
                call ftc2ii(form(c1:c1+nw-1),width,status)
                if (status .gt. 0 .or. width .eq. 0)then
C                      unrecognized characters following the type code
                       go to 990
                end if
        end if

C       determine the number of decimal places (if any)
        decims=-1
        c1=c1+nw
        if (form(c1:c1) .eq. '.')then
            c1=c1+1
            nw=0
            do 60 i=c1,nc
                if (form(i:i) .ge. '0' .and. form(i:i).le.'9')then
                    nw=nw+1
                else
                    go to 70
            end if
60          continue
70          continue

            if (nw .eq. 0)then
C               error, no decimals specified
                go to 990
            else
                call ftc2ii(form(c1:c1+nw-1),decims,status)
                if (status .gt. 0)then
C                   unrecognized characters 
                    go to 990
                end if
            end if
        else if (form(c1:c1) .ne. ' ')then
            go to 990
        end if

C       consistency checks
        if (dattyp .eq. 'A' .or. dattyp .eq. 'I')then
            if (decims .eq. -1)then
                decims=0
            else
                go to 990
            end if
        else if (decims .eq. -1)then
C           number of decmal places must be specified for D, E, or F fields
            go to 990
        else if (decims .ge. width)then
C           number of decimals must be less than the width
            go to 990
        end if

        if (dattyp .eq. 'I')then
C           set datatype to SHORT integer if 4 digits or less
            if (width .le. 4)dtype=21
        else if (dattyp .eq. 'F')then
C           set datatype to DOUBLE if 8 digits or more
            if (width .ge. 8)dtype=82
        end if
          
        return

990     continue
        status=261
        call ftpmsg('Illegal ASCII table TFORMn keyword: '//cform)
        end

C--------------------------------------------------------------------------
        subroutine ftgbcl(iunit,colnum,xtype,xunit,dtype,rcount,
     &        xscal,xzero,xnull,xdisp,status)

C       Get information about a Binary table CoLumn
C       returns the parameters which define the column

C       iunit   i  Fortran i/o unit number
C       colnum  i  number of the column (first column = 1)
C       xtype   c  name of the column
C       xunit   c  physical units of the column
C       dtype   c  datatype of the column
C       rcount  i  repeat count of the column
C       xscal   d  scaling factor for the column values
C       xzero   d  scaling zero point for the column values
C       xnull   i  value used to represent undefined values in integer column
C       xdisp   c  display format for the column
C       status  i  returned error status

        integer iunit,colnum,rcount,xnull,status
        double precision xscal,xzero
        character*(*) xtype,xunit,dtype,xdisp

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS------------------------------------

        integer ibuff,nfound,tcode
        logical descrp
        character ctemp*2,fwide*4

        if (status .gt. 0)return

        if (colnum .lt. 1 .or. colnum .gt. 999)then
C               illegal column number
                status=302
                return
        end if

        ibuff=bufnum(iunit)

C       get the parameters which are stored in the common block
        rcount=trept(colnum+tstart(ibuff))
        xscal=tscale(colnum+tstart(ibuff))
        xzero=tzero(colnum+tstart(ibuff))
        xnull=tnull(colnum+tstart(ibuff))

C       translate the numeric data type code
        dtype=' '
        tcode=tdtype(colnum+tstart(ibuff)) 
        if (tcode .lt. 0)then
                descrp=.true.
                tcode=-tcode
        else
                descrp=.false.
        end if

        if (tcode .eq. 21)then
                dtype='I'
        else if (tcode .eq. 41)then
                dtype='J'
        else if (tcode .eq. 42)then
                dtype='E'
        else if (tcode .eq. 82)then
                dtype='D'
        else if (tcode .eq. 16)then
C               this is an ASCII field; width of field is stored in TNULL
                write(fwide,1000)tnull(colnum+tstart(ibuff))
1000            format(i4)
                if (tnull(colnum+tstart(ibuff)) .gt. 999)then
                    dtype='A'//fwide
                else if (tnull(colnum+tstart(ibuff)) .gt. 99)then
                    dtype='A'//fwide(2:4)
                else if (tnull(colnum+tstart(ibuff)) .gt. 9)then
                    dtype='A'//fwide(3:4)
                else if (tnull(colnum+tstart(ibuff)) .gt. 0)then
                    dtype='A'//fwide(4:4)
                else
                    dtype='A'
                end if
        else if (tcode .eq. 14)then
                dtype='L'
        else if (tcode .eq. 1)then
                dtype='X'
        else if (tcode .eq. 11)then
                dtype='B'
        else if (tcode .eq. 83)then
                dtype='C'
        else if (tcode .eq. 163)then
                dtype='M'
        end if

        if (descrp)then
                ctemp='P'//dtype(1:1)
                dtype=ctemp
        end if

C       read remaining values from the header keywords
        xtype=' '
        call ftgkns(iunit,'TTYPE',colnum,1,xtype,nfound,status)
        xunit=' '
        call ftgkns(iunit,'TUNIT',colnum,1,xunit,nfound,status)
        xdisp=' '
        call ftgkns(iunit,'TDISP',colnum,1,xdisp,nfound,status)
        end        

C----------------------------------------------------------------------
        subroutine ftghtb(iunit,maxfld,ncols,nrows,nfield,ttype,
     &                    tbcol,tform,tunit,extnam,status)

C       read required standard header keywords from an ASCII table extension 
C
C       iunit   i  Fortran i/o unit number
C       maxfld  i  maximum no. of fields to read; dimension of ttype
C       OUTPUT PARAMETERS:
C       ncols   i  number of columns in the table
C       nrows   i  number of rows in the table
C       nfield  i  number of fields in the table
C       ttype   c  name of each field (array)
C       tbcol   i  beginning column of each field (array)
C       tform   c  Fortran-77 format of each field (array)
C       tunit   c  units of each field (array)
C       extnam  c  name of table (optional)
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,maxfld,ncols,nrows,nfield,status,tbcol(*)
        integer i,nfind,maxf,tstat
        character*(*) ttype(*),tform(*),tunit(*),extnam
        character comm*72

        call ftgttb(iunit,ncols,nrows,nfield,status)
        if (status .gt. 0)return

        if (maxfld .le. 0)then
                maxf=nfield
        else
                maxf=min(maxfld,nfield)
        end if

C       initialize optional keywords
        do 10 i=1,maxf
                ttype(i)=' '
                tunit(i)=' '
10      continue

        call ftgkns(iunit,'TTYPE',1,maxf,ttype,nfind,status)
        call ftgkns(iunit,'TUNIT',1,maxf,tunit,nfind,status)

        if (status .gt. 0)return

        call ftgknj(iunit,'TBCOL',1,maxf,tbcol,nfind,status)
        if (status .gt. 0 .or. nfind .ne. maxf)then
C               couldn't find the required TBCOL keywords
                status=231
        call ftpmsg('Required TBCOL keyword(s) not found in ASCII'//
     &  ' table header (FTGHTB).')
                return
        end if

        call ftgkns(iunit,'TFORM',1,maxf,tform,nfind,status)
        if (status .gt. 0 .or. nfind .ne. maxf)then
C               couldn't find the required TFORM keywords
                status=232
        call ftpmsg('Required TFORM keyword(s) not found in ASCII'//
     &  ' table header (FTGHTB).')
                return
        end if

        extnam=' '
        tstat=status
        call ftgkys(iunit,'EXTNAME',extnam,comm,status)
C       this keyword is not required, so ignore 'keyword not found' status
        if (status .eq. 202)status=tstat
        end

      integer function type (c)
      integer c
      if (.not.((97 .le. c .and. c .le. 122) .or. (65 .le. c .and. c .le
     *. 90)))goto 23000
      type = 97
      goto 23001
23000 continue
      if (.not.(48 .le. c .and. c .le. 57))goto 23002
      type = 48
      goto 23003
23002 continue
      type = c
23003 continue
23001 continue
      return
      end

C SUBROUTINE CURFIT.F 
C
C SOURCE
C   BEVINGTON, PAGES 237-239.
C
C PURPOSE
C   MAKE A LEAST-SQUARES FIT TO A NON-LINEAR FUNCTION
C      WITH A LINEARIZATION OF THE FITTING FUNCTION
C
C USAGE 
C   CALL CURFIT (X, Y, SIGMAY, NPTS, NTERMS, MODE, A, DELTAA,
C      SIGMAA, FLAMDA, YFIT, CHISQR)
C
C DESCRIPTION OF PARAMETERS
C   X	   - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C   Y	   - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C   SIGMAY - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
C   NPTS   - NUMBER OF PAIRS OF DATA POINTS
C   NTERMS - NUMBER OF PARAMETERS
C   MODE   - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C	     +1 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
C	      0 (NO WEIGHTING) WEIGHT(I) = 1.
C	     -1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
C   A	   - ARRAY OF PARAMETERS
C   DELTAA - ARRAY OF INCREMENTS FOR PARAMETERS A
C   SIGMAA - ARRAY OF STANDARD DEVIATIONS FOR PARAMETERS A
C   FLAMDA - PROPORTION OF GRADIENT SEARCH INCLUDED
C   YFIT   - ARRAY OF CALCULATED VALUES OF Y
C   CHISQR - REDUCED CHI SQUARE FOR FIT 
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   FUNCTN (X, I, A)
C      EVALUATES THE FITTING FUNCTION FOR THE ITH TERM
C   FCHISQ (Y, SIGMAY, NPTS, NFREE, MODE, YFIT) 
C      EVALUATES REDUCED CHI SQUARED FOR FIT TO DATA
C   FDERIV (X, I, A, DELTAA, NTERMS, DERIV)
C      EVALUATES THE DERIVATIVES OF THE FITTING FUNCTION
C      FOR THE ITH TERM WITH RESPECT TO EACH PARAMETER
C   MATINV (ARRAY, NTERMS, DET) 
C      INVERTS A SYMMETRIC TWO-DIMENSIONAL MATRIX OF DEGREE NTERMS
C      AND CALCULATES ITS DETERMINANT
C
C COMMENTS
C   DIMENSION STATEMENT VALID FOR NTERMS UP TO 10
C   SET FLAMDA = 0.001 AT BEGINNING OF SEARCH
C
      SUBROUTINE CURFIT (X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,
     *SIGMAA,FLAMDA,YFIT,CHISQR)
      DOUBLE PRECISION ARRAY
      DIMENSION X(1),Y(1),SIGMAY(1),A(1),DELTAA(1),SIGMAA(1), 
     *YFIT(1)
      DIMENSION WEIGHT(100),ALPHA(10,10),BETA(10),DERIV(10),
     *ARRAY(10,10),B(10)
      REAL FUNCTN
      EXTERNAL FUNCTN

C
11     NFREE=NPTS-NTERMS
       IF (NFREE) 13,13,20
13     CHISQR=0.
       GOTO 110
C
C EVALUATE WEIGHTS
C
20     DO 30 I=1,NPTS
21     IF (MODE) 22,27,29
22     IF (Y(I)) 25,27,23
23     WEIGHT(I)=1./Y(I)
       GOTO 30 
25     WEIGHT(I)=1./(-Y(I))
       GOTO 30 
27     WEIGHT(I)=1.
       GOTO 30 
29     WEIGHT(I)=1./SIGMAY(I)**2
30     CONTINUE
C
C EVALUATE ALPHA AND BETA MATRICES
C
31     DO 34 J=1,NTERMS
       BETA(J)=0.
       DO 34 K=1,J
34     ALPHA(J,K)=0.
41     DO 50 I=1,NPTS
       CALL FDERIV (X,I,A,DELTAA,NTERMS,DERIV) 
       DO 46 J=1,NTERMS
       BETA(J)=BETA(J)+WEIGHT(I)*(Y(I)-FUNCTN(X,I,A))*DERIV(J) 
       DO 46 K=1,J
46     ALPHA(J,K)=ALPHA(J,K)+WEIGHT(I)*DERIV(J)*DERIV(K)
50     CONTINUE
51     DO 53 J=1,NTERMS
       DO 53 K=1,J
53     ALPHA(K,J)=ALPHA(J,K)
C
C EVALUATE CHI SQUARE AT STARTING POINT 
C
61     DO 62 I=1,NPTS
62     YFIT(I)=FUNCTN (X,I,A)
63     CHISQ1=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C
C INVERT MODIFIED CURVATURE MATRIX TO FIND NEW PARAMETERS
C
71     DO 74 J=1,NTERMS
       DO 73 K=1,NTERMS
73     ARRAY(J,K)=ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
74     ARRAY(J,J)=1.+FLAMDA
80     CALL MATINV (ARRAY,NTERMS,DET)
81     DO 84 J=1,NTERMS
       B(J)=A(J)
       DO 84 K=1,NTERMS
84     B(J)=B(J)+BETA(K)*ARRAY(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
C
C IF CHI SQUARE INCREASED, INCREASE FLAMDA AND TRY AGAIN
C
91     DO 92 I=1,NPTS
92     YFIT(I)=FUNCTN (X,I,B)
93     CHISQR=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
       IF (CHISQ1-CHISQR) 95,101,101
95     FLAMDA=10.*FLAMDA
       GOTO 71 
C
C EVALUATE PARAMETERS AND UNCERTAINTIES 
C
101    DO 103 J=1,NTERMS
       A(J)=B(J)
103    SIGMAA(J)=SQRT(ARRAY(J,J)/ALPHA(J,J))
       FLAMDA=FLAMDA/10.
110    RETURN
       END

      subroutine flushb
c     dimension       idummy(1)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      external        z8zpbd
      if (mipair .eq. 16) go to 102
      if (mipair .eq. 0) return
      if (mipair.eq.2 .and. mflcnt.eq.0) return
      mipp1 = mipair+1
      do 101 i=mipp1,16
         mbprs(i) = 40992
  101 continue
  102 if (mbufa .eq. -9999) mbufa = loci(msybuf)
      mflcnt = mflcnt+1
      call packum (mbprs,16,mbufa+mbuflu)
      mbuflu = mbuflu+8
      mipair = 0
      if (modef .eq. 1) go to 103
      if (mbuflu+8 .le. mbufl) return
      if (mbuflu .gt. 0) call preout
      return
  103 if (mod(mbuflu,msblen) .eq. 0) go to 104
      if (mbuflu+8 .le. mbufl) return
  104 continue
      if (mbuflu .gt. 0) call preout
      return
      end

      integer function slstr (from, to, first, chars)
      integer from (100), to (100)
      integer first, chars
      integer len, i, j, k
      integer length
      len = length (from)
      i = first
      if (.not.(i .lt. 1))goto 23000
      i = i + len + 1
23000 continue
      if (.not.(chars .lt. 0))goto 23002
      i = i + chars + 1
      chars = - chars
23002 continue
      j = i + chars - 1
      if (.not.(i .lt. 1))goto 23004
      i = 1
23004 continue
      if (.not.(j .gt. len))goto 23006
      j = len
23006 continue
      k = 0
23008 if (.not.(i .le. j))goto 23010
      to (k + 1) = from (i)
      i = i + 1
23009 k = k + 1
      goto 23008
23010 continue
      to (k + 1) = -2
      slstr=(k)
      return
      end

include	defs

# slstr --- slice a substring from a string

   integer function slstr (from, to, first, chars)
   character from (ARB), to (ARB)
   integer first, chars

   integer len, i, j, k
   integer length

   len = length (from)

   i = first
   if (i < 1)
      i = i + len + 1

   if (chars < 0) {
      i = i + chars + 1
      chars = - chars
      }

   j = i + chars - 1
   if (i < 1)
      i = 1
   if (j > len)
      j = len

   for (k = 0; i <= j; k = k + 1) {
      to (k + 1) = from (i)
      i = i + 1
      }
   to (k + 1) = EOS

   return (k)
   end

      DOUBLE PRECISION FUNCTION slDVDV (VA, VB)
*+
*     - - - - -
*      D V D V
*     - - - - -
*
*  Scalar product of two 3-vectors  (double precision)
*
*  Given:
*      VA      dp(3)     first vector
*      VB      dp(3)     second vector
*
*  The result is the scalar product VA.VB (double precision)
*
*  P.T.Wallace   Starlink   November 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION VA(3),VB(3)


      slDVDV=VA(1)*VB(1)+VA(2)*VB(2)+VA(3)*VB(3)

      END

C----------------------------------------------------------------------
        subroutine ftcpdt(iunit,ounit,status)

C       copies the data from the IUNIT CHDU to the data of the OUNIT CHDU.
C       This will overwrite any data already in the OUNIT CHDU.

C       iunit   i  fortran unit number of the input file to be copied
C       ounit   i  fortran unit number of the output file to be copied to
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Aug 1993

        integer iunit,ounit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        character*1 cbuff(2880), xdummy(2880)
        common/ftheap/cbuff,xdummy
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,obuff,nblock,i

        if (status .gt. 0)return

        if (iunit .eq. ounit)then
                status=101
                return
        end if

        ibuff=bufnum(iunit)
        obuff=bufnum(ounit)

C       determine HDU structure as defined by keywords in output file
        call ftrdef(ounit,status)

C       Calculate the number of bytes to be copied.  By definition there
C       will be an integral number of 2880-byte logical blocks to be copied
        nblock=(hdstrt(ibuff,chdu(ibuff)+1)-dtstrt(ibuff))/2880

        if (nblock .gt. 0)then
C           move to the beginning of the data in the input and output files
            call ftmbyt(iunit,dtstrt(ibuff),.false.,status)
            call ftmbyt(ounit,dtstrt(obuff),.true.,status)

C           now copy the data one block at a time
            do 30 i=1,nblock
                call ftgcbf(iunit,0,2880,cbuff,status)
                call ftpcbf(ounit,0,2880,cbuff,status)
30          continue
        end if
        end

      SUBROUTINE slMXV (RM, VA, VB)
*+
*     - - - -
*      M X V
*     - - - -
*
*  Performs the 3-D forward unitary transformation:
*
*     vector VB = matrix RM * vector VA
*
*  (single precision)
*
*  Given:
*     RM       real(3,3)    matrix
*     VA       real(3)      vector
*
*  Returned:
*     VB       real(3)      result vector
*
*  To comply with the ANSI Fortran 77 standard, VA and VB must be
*  different arrays.  However, the routine is coded so as to work
*  properly on many platforms even if this rule is violated.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL RM(3,3),VA(3),VB(3)

      INTEGER I,J
      REAL W,VW(3)


*  Matrix RM * vector VA -> vector VW
      DO J=1,3
         W=0.0
         DO I=1,3
            W=W+RM(J,I)*VA(I)
         END DO
         VW(J)=W
      END DO

*  Vector VW -> vector VB
      DO J=1,3
         VB(J)=VW(J)
      END DO

      END

      SUBROUTINE CONDSD
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  DRAW THE OUTLINE OF THE SHIELD ON THE PLOT
C
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
C
        SAVE
C
C  GET THE START POINT
C
      XS = XVS(1)
      YS = YVS(1)
C
C  MOVE TO THE START OF THE OUTLINE
C
      CALL FL2INT(XS,YS,IX,IY)
      CALL PLOTIT(IX,IY,0)
C
C  LOOP FOR ALL SHIELD ELEMENTS
C
      DO 100 IC = 2,ICOUNT
C
C       DRAW THE OUTLINE OF THE SHIELD
C
        CALL FL2INT(XVS(IC),YVS(IC),IX,IY)
        CALL PLOTIT(IX,IY,1)
C
 100  CONTINUE
C
C  DRAW TO THE START
C
      CALL FL2INT(XS,YS,IX,IY)
      CALL PLOTIT(IX,IY,1)
C
C  FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
      RETURN
C
      END

      SUBROUTINE slCAYD (IY, IM, ID, NY, ND, J)
*+
*     - - - - - -
*      C A Y D
*     - - - - - -
*
*  Gregorian calendar date to year and day in year (in a Julian
*  calendar aligned to the 20th/21st century Gregorian calendar).
*
*  (Includes century default feature:  use slCLYD for years
*   before 100AD.)
*
*  Given:
*     IY,IM,ID   int    year, month, day in Gregorian calendar
*                       (year may optionally omit the century)
*  Returned:
*     NY         int    year (re-aligned Julian calendar)
*     ND         int    day in year (1 = January 1st)
*     J          int    status:
*                         0 = OK
*                         1 = bad year (before -4711)
*                         2 = bad month
*                         3 = bad day (but conversion performed)
*
*  Notes:
*
*  1  This routine exists to support the low-precision routines
*     slERTH, slMOON and slECOR.
*
*  2  Between 1900 March 1 and 2100 February 28 it returns answers
*     which are consistent with the ordinary Gregorian calendar.
*     Outside this range there will be a discrepancy which increases
*     by one day for every non-leap century year.
*
*  3  Years in the range 50-99 are interpreted as 1950-1999, and
*     years in the range 00-49 are interpreted as 2000-2049.
*
*  Called:  slCLYD
*
*  P.T.Wallace   Starlink   23 November 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID,NY,ND,J

      INTEGER I



*  Default century if appropriate
      IF (IY.GE.0.AND.IY.LE.49) THEN
         I=IY+2000
      ELSE IF (IY.GE.50.AND.IY.LE.99) THEN
         I=IY+1900
      ELSE
         I=IY
      END IF

*  Perform the conversion
      CALL slCLYD(I,IM,ID,NY,ND,J)

      END

      function	 gen(anoise)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1972 dec 15
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   generate numbers for construction of test cases.
      mi=891
      mj=457
      i=5
      j=7
      aj=0.
c
      if (anoise) 10,30,20
   10 gen=0.
      return
c
c     the sequence of values of j  is bounded between 1 and 996
c     if initial j = 1,2,3,4,5,6,7,8, or 9, the period is 332
c
   20 j=j*mj
      j=j-997*(j/997)
      aj=j-498
c     the sequence of values of i  is bounded between 1 and 999
c     if initial i = 1,2,3,6,7, or 9,  the period will be 50
c     if initial i = 4 or 8   the period will be 25
c     if initial i = 5	      the period will be 10
c
   30 i=i*mi
      i=i-1000*(i/1000)
      ai=i-500
      gen=ai+aj*anoise
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGINIT
C
C This routine is called to initialize some machine-dependent constants.
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C Fill in the names of the four pre-defined labels.
C
      CALL AGSTCH ('L',1,IDCS)
      FLLB(1,1)=FLOAT(IDCS)
      CALL AGSTCH ('R',1,IDCS)
      FLLB(1,2)=FLOAT(IDCS)
      CALL AGSTCH ('B',1,IDCS)
      FLLB(1,3)=FLOAT(IDCS)
      CALL AGSTCH ('T',1,IDCS)
      FLLB(1,4)=FLOAT(IDCS)
C
C Declare the rest of the label-definition slots to be available.
C
      LBIM=IFIX(QBIM)
C
      DO 101 J=5,LBIM
        FLLB(1,J)=0.
  101 CONTINUE
C
C Fill in the text of the four pre-defined lines.
C
      CALL AGSTCH ('Y',1,IDCS)
      FLLN(4,1)=FLOAT(IDCS)
      CALL AGSTCH (' ',1,IDCS)
      FLLN(4,2)=FLOAT(IDCS)
      CALL AGSTCH ('X',1,IDCS)
      FLLN(4,3)=FLOAT(IDCS)
      CALL AGSTCH (' ',1,IDCS)
      FLLN(4,4)=FLOAT(IDCS)
C
C Declare the rest of the line-definition slots to be available.
C
      LNIM=IFIX(QNIM)
C
      DO 102 J=5,LNIM
        FLLN(1,J)=SVAL(1)
  102 CONTINUE
C
C Set the value of 'LINE/TERMINATOR.'
C
      CALL AGSTCH ('$',1,IDCS)
      TCLN=FLOAT(IDCS)
C
C SMRL is used by AUTOGRAPH for rounding operations.
C
      SMRL=10.**(3-IFIX(ALOG10(FLOAT(I1MACH(10)))*FLOAT(I1MACH(11))))
C
C ISLD is an integer containing 16 one bits (right-justified with zero
C fill to the left).  It is used to direct the DASHCHAR package to draw
C solid lines.  To generate it, we start with a 15-bit mask and then
C add another bit.
C
      ISLD = 32767
      ISLD = ISHIFT(ISLD,1)
      ISLD = IOR(ISLD,1)
C
C Set the initialization flag to indicate initialization has been done.
C
      INIF=1
C
C Done.
C
      RETURN
C
      END

C----------------------------------------------------------------------
        subroutine ftfrcl(iunit,status)

C       free up space in the common blocks that contain descriptors to
C       the columns in the HDU that is being closed.  The various parameters
C       describing each table column (e.g., starting byte address, datatype,
C       tscale, tzero, etc.) are stored in 1-D arrays, and the tstart
C       parameter gives the starting element number in the arrays 
C       for each unit number.  If a table is closed, then all the
C       descriptors for that table columns must be overwritten by
C       shifting any descriptors that follow it in the 1-D arrays to the left.

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC,May, 1995

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld       
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,n2shft,i,j1,j2

C       ignore input status and flush columns regardless of input status value

        ibuff=bufnum(iunit)

        if (status .eq. -999)then
C           just initialize the descriptors as undefined
            tstart(ibuff)=-1
        else if (tstart(ibuff) .lt. 0)then
C           descriptors are already undefined; just return
        else if (tfield(ibuff) .eq. 0)then
C           table had no columns so just reset pointers as undefined
            tstart(ibuff)=-1
            dtstrt(ibuff)=-2000000000
        else
C           calc number of descriptors to be shifted over the recovered space
            n2shft=nxtfld-(tstart(ibuff)+tfield(ibuff))
     
            if (n2shft .gt. 0)then
                j1=tstart(ibuff)
                j2=j1+tfield(ibuff)
                do 10 i=1,n2shft
C                   shift the descriptors
                    j1=j1+1
                    j2=j2+1
                    tbcol(j1)=tbcol(j2)
                    tdtype(j1)=tdtype(j2)
                    trept(j1)=trept(j2)
                    tscale(j1)=tscale(j2)
                    tzero(j1)=tzero(j2)
                    tnull(j1)=tnull(j2)
                    cnull(j1)=cnull(j2)
                    cform(j1)=cform(j2)
10              continue
            end if

C           update pointer to next vacant column discriptor location
            nxtfld=nxtfld-tfield(ibuff)

C           update starting pointer for other opened files
            do 20 i=1,nb
                if (tstart(i) .gt. tstart(ibuff))then
                    tstart(i)=tstart(i)-tfield(ibuff)
                end if
20          continue

C           set pointers for this unit as undefined
            tstart(ibuff)=-1
            dtstrt(ibuff)=-2000000000
        end if
        end                

      double precision function dpmpar(i)
      integer i
c     **********
c
c     function dpmpar
c
c     This function provides double precision machine parameters
c     when the appropriate set of data statements is activated (by
c     removing the c from column 1) and all other data statements are
c     rendered inactive. Most of the parameter values were obtained
c     from the corresponding Bell Laboratories Port Library function.
c
c     The function statement is
c
c       double precision function dpmpar(i)
c
c     where
c
c       i is an integer input variable set to 1, 2, or 3 which
c         selects the desired machine parameter. If the machine has
c         t base b digits and its smallest and largest exponents are
c         emin and emax, respectively, then these parameters are
c
c         dpmpar(1) = b**(1 - t), the machine precision,
c
c         dpmpar(2) = b**(emin - 1), the smallest magnitude,
c
c         dpmpar(3) = b**emax*(1 - b**(-t)), the largest magnitude.
c
c     Argonne National Laboratory. MINPACK Project. June 1983.
c     Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
c
c     **********
      integer mcheps(4)
      integer minmag(4)
      integer maxmag(4)
      double precision dmach(3)
      equivalence (dmach(1),mcheps(1))
      equivalence (dmach(2),minmag(1))
      equivalence (dmach(3),maxmag(1))
c
c     Machine constants for the IBM 360/370 series,
c     the Amdahl 470/V6, the ICL 2900, the Itel AS/6,
c     the Xerox Sigma 5/7/9 and the Sel systems 85/86.
c
c     data mcheps(1),mcheps(2) / z34100000, z00000000 /
c     data minmag(1),minmag(2) / z00100000, z00000000 /
c     data maxmag(1),maxmag(2) / z7fffffff, zffffffff /
c
c     Machine constants for the Honeywell 600/6000 series.
c
c     data mcheps(1),mcheps(2) / o606400000000, o000000000000 /
c     data minmag(1),minmag(2) / o402400000000, o000000000000 /
c     data maxmag(1),maxmag(2) / o376777777777, o777777777777 /
c
c     Machine constants for the CDC 6000/7000 series.
c
c     data mcheps(1) / 15614000000000000000b /
c     data mcheps(2) / 15010000000000000000b /
c
c     data minmag(1) / 00604000000000000000b /
c     data minmag(2) / 00000000000000000000b /
c
c     data maxmag(1) / 37767777777777777777b /
c     data maxmag(2) / 37167777777777777777b /
c
c     Machine constants for the PDP-10 (KA processor).
c
c     data mcheps(1),mcheps(2) / "114400000000, "000000000000 /
c     data minmag(1),minmag(2) / "033400000000, "000000000000 /
c     data maxmag(1),maxmag(2) / "377777777777, "344777777777 /
c
c     Machine constants for the PDP-10 (KI processor).
c
c     data mcheps(1),mcheps(2) / "104400000000, "000000000000 /
c     data minmag(1),minmag(2) / "000400000000, "000000000000 /
c     data maxmag(1),maxmag(2) / "377777777777, "377777777777 /
c
c     Machine constants for the PDP-11. 
c
c     data mcheps(1),mcheps(2) /   9472,      0 /
c     data mcheps(3),mcheps(4) /      0,      0 /
c
c     data minmag(1),minmag(2) /    128,      0 /
c     data minmag(3),minmag(4) /      0,      0 /
c
c     data maxmag(1),maxmag(2) /  32767,     -1 /
c     data maxmag(3),maxmag(4) /     -1,     -1 /
c
c     Machine constants for the Burroughs 6700/7700 systems.
c
c     data mcheps(1) / o1451000000000000 /
c     data mcheps(2) / o0000000000000000 /
c
c     data minmag(1) / o1771000000000000 /
c     data minmag(2) / o7770000000000000 /
c
c     data maxmag(1) / o0777777777777777 /
c     data maxmag(2) / o7777777777777777 /
c
c     Machine constants for the Burroughs 5700 system.
c
c     data mcheps(1) / o1451000000000000 /
c     data mcheps(2) / o0000000000000000 /
c
c     data minmag(1) / o1771000000000000 /
c     data minmag(2) / o0000000000000000 /
c
c     data maxmag(1) / o0777777777777777 /
c     data maxmag(2) / o0007777777777777 /
c
c     Machine constants for the Burroughs 1700 system.
c
c     data mcheps(1) / zcc6800000 /
c     data mcheps(2) / z000000000 /
c
c     data minmag(1) / zc00800000 /
c     data minmag(2) / z000000000 /
c
c     data maxmag(1) / zdffffffff /
c     data maxmag(2) / zfffffffff /
c
c     Machine constants for the Univac 1100 series.
c
c     data mcheps(1),mcheps(2) / o170640000000, o000000000000 /
c     data minmag(1),minmag(2) / o000040000000, o000000000000 /
c     data maxmag(1),maxmag(2) / o377777777777, o777777777777 /
c
c     Machine constants for the Data General Eclipse S/200.
c
c     Note - it may be appropriate to include the following card -
c     static dmach(3)
c
c     data minmag/20k,3*0/,maxmag/77777k,3*177777k/
c     data mcheps/32020k,3*0/
c
c     Machine constants for the Harris 220.
c
c     data mcheps(1),mcheps(2) / '20000000, '00000334 /
c     data minmag(1),minmag(2) / '20000000, '00000201 /
c     data maxmag(1),maxmag(2) / '37777777, '37777577 /
c
c     Machine constants for the Cray-1.
c
c     data mcheps(1) / 0376424000000000000000b /
c     data mcheps(2) / 0000000000000000000000b /
c
c     data minmag(1) / 0200034000000000000000b /
c     data minmag(2) / 0000000000000000000000b /
c
c     data maxmag(1) / 0577777777777777777777b /
c     data maxmag(2) / 0000007777777777777776b /
c
c     Machine constants for the Prime 400.
c
c     data mcheps(1),mcheps(2) / :10000000000, :00000000123 /
c     data minmag(1),minmag(2) / :10000000000, :00000100000 /
c     data maxmag(1),maxmag(2) / :17777777777, :37777677776 /
c
c     Machine constants for the VAX-11.
c
      data mcheps(1),mcheps(2) /   9472,  0 /
      data minmag(1),minmag(2) /    128,  0 /
      data maxmag(1),maxmag(2) / -32769, -1 /
c
      dpmpar = dmach(i)
      return
c
c     Last card of function dpmpar.
c
      end

      subroutine balpar
      integer t, token (100)
      integer gettok, gnbtok
      integer nlpar
      if (.not.(gnbtok (token, 100) .ne. 40))goto 23000
      call synerr (19Hmissing left paren.)
      return
23000 continue
      call outstr (token)
      nlpar = 1
23002 continue
      t = gettok (token, 100)
      if (.not.(t .eq. 59 .or. t .eq. 123 .or. t .eq. 125 .or. t .eq. -1
     *))goto 23005
      call pbstr (token)
      goto 23004
23005 continue
      if (.not.(t .eq. 10))goto 23007
      token (1) = -2
      goto 23008
23007 continue
      if (.not.(t .eq. 40))goto 23009
      nlpar = nlpar + 1
      goto 23010
23009 continue
      if (.not.(t .eq. 41))goto 23011
      nlpar = nlpar - 1
23011 continue
23010 continue
23008 continue
      if (.not.(t .eq. -9))goto 23013
      call squash (token)
23013 continue
      call outstr (token)
23003 if (.not.(nlpar .le. 0))goto 23002
23004 continue
      if (.not.(nlpar .ne. 0))goto 23015
      call synerr (33Hmissing parenthesis in condition.)
23015 continue
      return
      end

      integer function stlu (symbol, node, pred, st)
      integer symbol (100)
      integer node, pred, st
      integer mem( 60000)
      common/cdsmem/mem
      integer hash, i, j, nodsiz
      nodsiz = mem (st)
      hash = 0
      i = 1
23000 if (.not.(symbol (i) .ne. -2))goto 23002
      hash = hash + symbol (i)
23001 i = i + 1
      goto 23000
23002 continue
      hash = mod (hash, 43) + 1
      pred = st + hash
      node = mem (pred)
23003 if (.not.(node .ne. 0))goto 23004
      i = 1
      j = node + 1 + nodsiz
23005 if (.not.(symbol (i) .eq. mem (j)))goto 23006
      if (.not.(symbol (i) .eq. -2))goto 23007
      stlu=(1)
      return
23007 continue
      i = i + 1
      j = j + 1
      goto 23005
23006 continue
      pred = node
      node = mem (pred + 0)
      goto 23003
23004 continue
      stlu=(0)
      return
      end

      SUBROUTINE slCLYD (IY, IM, ID, NY, ND, JSTAT)
*+
*     - - - - -
*      C L Y D
*     - - - - -
*
*  Gregorian calendar to year and day in year (in a Julian calendar
*  aligned to the 20th/21st century Gregorian calendar).
*
*  Given:
*     IY,IM,ID   i    year, month, day in Gregorian calendar
*
*  Returned:
*     NY         i    year (re-aligned Julian calendar)
*     ND         i    day in year (1 = January 1st)
*     JSTAT      i    status:
*                       0 = OK
*                       1 = bad year (before -4711)
*                       2 = bad month
*                       3 = bad day (but conversion performed)
*
*  Notes:
*
*  1  This routine exists to support the low-precision routines
*     slERTH, slMOON and slECOR.
*
*  2  Between 1900 March 1 and 2100 February 28 it returns answers
*     which are consistent with the ordinary Gregorian calendar.
*     Outside this range there will be a discrepancy which increases
*     by one day for every non-leap century year.
*
*  3  The essence of the algorithm is first to express the Gregorian
*     date as a Julian Day Number and then to convert this back to
*     a Julian calendar date, with day-in-year instead of month and
*     day.  See 12.92-1 and 12.95-1 in the reference.
*
*  Reference:  Explanatory Supplement to the Astronomical Almanac,
*              ed P.K.Seidelmann, University Science Books (1992),
*              p604-606.
*
*  P.T.Wallace   Starlink   26 November 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IY,IM,ID,NY,ND,JSTAT

      INTEGER I,J,K,L,N

*  Month lengths in days
      INTEGER MTAB(12)
      DATA MTAB/31,28,31,30,31,30,31,31,30,31,30,31/



*  Preset status
      JSTAT=0

*  Validate year
      IF (IY.GE.-4711) THEN

*     Validate month
         IF (IM.GE.1.AND.IM.LE.12) THEN

*        Allow for (Gregorian) leap year
            IF (MOD(IY,4).EQ.0.AND.
     :         (MOD(IY,100).NE.0.OR.MOD(IY,400).EQ.0)) THEN
               MTAB(2)=29
            ELSE
               MTAB(2)=28
            END IF

*        Validate day
            IF (ID.LT.1.OR.ID.GT.MTAB(IM)) JSTAT=3

*        Perform the conversion
            I=(14-IM)/12
            K=IY-I
            J=(1461*(K+4800))/4+(367*(IM-2+12*I))/12
     :        -(3*((K+4900)/100))/4+ID-30660
            K=(J-1)/1461
            L=J-1461*K
            N=(L-1)/365-L/1461
            J=((80*(L-365*N+30))/2447)/11
            I=N+J
            ND=59+L-365*I+((4-N)/4)*(1-J)
            NY=4*K+I-4716

*        Bad month
         ELSE
            JSTAT=2
         END IF
      ELSE

*     Bad year
         JSTAT=1
      END IF

      END

      subroutine swvar (lab)
      integer lab, i, labnum, ndigi0
      call outch (115)
      call outch (119)
      labnum = lab
      ndigi0=0
23000 if (.not.(labnum .gt. 0))goto 23002
      ndigi0 = ndigi0 + 1
23001 labnum=labnum/10
      goto 23000
23002 continue
      i=3
23003 if (.not.(i .le. 6 - ndigi0))goto 23005
      call outch (48)
23004 i=i+1
      goto 23003
23005 continue
      call outnum (lab)
      return
      end
c     ndigi0  ndigits

C--------------------------------------------------------------------------
        subroutine ftdelt(iunit,status)

C       delete a FITS file that was previously opened with ftopen or ftinit
C
C       iunit   i  Fortran I/O unit number
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, July 1994

        integer iunit,status,ibuff

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

C       ignore input status, and delete file regardless of status value

        ibuff=bufnum(iunit)

C       set current column name buffer as undefined
        call ftrsnm

C       flush the buffers holding data for this HDU
        call ftflsh(ibuff,status)

C       recover common block space containing column descriptors for this HDU
        call ftfrcl(iunit,status)

C       delete the file
        call ftclsx(iunit,.false.,status)
        end

C--------------------------------------------------------------------------
        subroutine ftopen(funit,fname,rwmode,block,status)

C       open an existing FITS file with readonly or read/write access
C
C       funit   i  Fortran I/O unit number
C       fname   c  name of file to be opened
C       rwmode  i  file access mode: 0 = readonly; else = read and write
C       block   i  returned record length blocking factor
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer funit,rwmode,block,status,strlen,i,xtend
        character*(*) fname

        if (status .gt. 0)return

C       ignore any leading blanks in the file name
        strlen=len(fname)
        do 10 i=1,strlen
            if (fname(i:i) .ne. ' ')then

C               call the machine dependent routine which opens the file
                call ftopnx(funit,fname(i:),0,rwmode,block,status)
                if (status .gt. 0)then
                     call ftpmsg('FTOPEN failed to Find and/or Open'//
     &                         ' the following file:')
                     call ftpmsg(fname)
                     return
                end if

C               set column descriptors as undefined
                call ftfrcl(funit,-999)

C               determine the structure and size of the primary HDU
                call ftrhdu(funit,xtend,status)
                if (status .gt. 0)then
                  call ftpmsg('FTOPEN could not interpret primary '
     &              //'array header keywords of file:')
                  call ftpmsg(fname)
                  if (status .eq. 252)then
                      call ftpmsg('Is this a FITS file??')
                  end if
                end if

C               set current column name buffer as undefined
                call ftrsnm
                return
            end if
10      continue

C       if we got here, then the input filename was all blanks
        status=104
        call ftpmsg('FTOPEN: Name of file to open is blank.')
        return

        end

C--------------------------------------------------------------------------
        subroutine ftpkng(ounit,keywrd,nstart,nkey,dval,decim,comm,
     &                    status)

C       write an array of real*8 values to header records in F format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       nstart  i  starting sequence number (usually 1)
C       nkey    i  number of keywords to write
C       dval    d  array of keyword values
C       decim   i  number of decimal places to display in the value field
C       comm    c  array of keyword comments (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm(*)
        integer nstart,nkey,decim,ounit,status,i,j
        double precision dval(*)
        character keynam*8,comm1*48
        logical repeat

        if (status .gt. 0)return

C       check if the first comment string is to be repeated for all keywords
C       (if the last non-blank character is '&', then it is to be repeated)
        call ftcrep(comm(1),comm1,repeat)

        j=nstart
        do 10 i=1,nkey
C               construct keyword name:
                call ftkeyn(keywrd,j,keynam,status)

C               write the keyword record
                if (repeat)then
                  call ftpkyg(ounit,keynam,dval(i),decim,comm1,status)
                else
                  call ftpkyg(ounit,keynam,dval(i),decim,comm(i),status)
                end if
                if (status .gt. 0)return
                j=j+1
10      continue
        end

C----------------------------------------------------------------------
        subroutine ftc2ii(cval,ival,status)
C       convert a character string to an integer
C       (assumes that the input string is left justified)

        integer ival,status,nleng
        character*(*) cval
        character*8 iform

        if (status .gt. 0)return

        if (cval .eq. ' ')go to 900

C       find length of the input integer character string
        nleng=index(cval,' ')-1
        if (nleng .eq. -1)nleng=len(cval)

C       construct the format statement to read the character string
        if (nleng .le. 9)then
                write(iform,1000)nleng, '\0'
1000            format('(I',I1,')',A)
        else
                write(iform,1001)nleng, '\0'
1001            format('(I',I2,')',A)
        end if

        read(cval,iform,err=900)ival
        return

900     continue
C       work around for bug in the DEC Alpha VMS compiler
        if (cval(1:nleng) .eq. '-2147483648')then
                 ival=-2147483647 - 1
        else
                 status=407
        end if
        end

C----------------------------------------------------------------------
        subroutine ftpcni(ounit,colnum,frow,felem,nelem,array,nulval,
     &                    status)

C       write array of integer*2 pixels to the specified column
C       of a table.  Any input pixels equal to the value of NULVAL will
C       be replaced by the appropriate null value in the output FITS file. 

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       array   i*2  array of data values to be written 
C       nulval  i*2  pixel value used to represent an undefine pixel
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1994

        integer ounit,colnum,frow,felem,nelem,status
        integer*2 array(*),nulval

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,repeat,first,ngood,nbad,i,fstelm,fstrow

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

C       get the column repeat count and calculate the absolute position within
C       the column of the first element to be written
        repeat=trept(colnum+tstart(ibuff))
        first=(frow-1)*repeat+felem-1

        ngood=0
        nbad=0
        do 10 i=1,nelem
            if (array(i) .ne. nulval)then
                ngood=ngood+1
                if (nbad .gt. 0)then
C                   write the previous consecutive set of null pixels
                    fstelm=i-nbad+first
C                   calculate the row and element of the first pixel to write
                    fstrow=(fstelm-1)/repeat+1
                    fstelm=fstelm-(fstrow-1)*repeat
                    call ftpclu(ounit,colnum,fstrow,fstelm,nbad,status)
                    nbad=0
                end if
            else
                nbad=nbad+1
                if (ngood .gt. 0)then
C                   write the previous consecutive set of good pixels
                    fstelm=i-ngood+first
C                   calculate the row and element of the first pixel to write
                    fstrow=(fstelm-1)/repeat+1
                    fstelm=fstelm-(fstrow-1)*repeat
                    call ftpcli(ounit,colnum,fstrow,fstelm,ngood,
     &                          array(i-ngood),status)
                    ngood=0
                end if
            end if
10      continue

C       finished;  now just write the last set of pixels
        if (nbad .gt. 0)then
C           write the consecutive set of null pixels
            fstelm=i-nbad+first
            fstrow=(fstelm-1)/repeat+1
            fstelm=fstelm-(fstrow-1)*repeat
            call ftpclu(ounit,colnum,fstrow,fstelm,nbad,status)
        else
C           write the consecutive set of good pixels
            fstelm=i-ngood+first
            fstrow=(fstelm-1)/repeat+1
            fstelm=fstelm-(fstrow-1)*repeat
            call ftpcli(ounit,colnum,fstrow,fstelm,ngood,
     &                  array(i-ngood),status)
        end if
        end

      SUBROUTINE slECEQ (DL, DB, DATE, DR, DD)
*+
*     - - - - - -
*      E C E Q
*     - - - - - -
*
*  Transformation from ecliptic coordinates to
*  J2000.0 equatorial coordinates (double precision)
*
*  Given:
*     DL,DB       dp      ecliptic longitude and latitude
*                           (mean of date, IAU 1980 theory, radians)
*     DATE        dp      TDB (loosely ET) as Modified Julian Date
*                                              (JD-2400000.5)
*  Returned:
*     DR,DD       dp      J2000.0 mean RA,Dec (radians)
*
*  Called:
*     slDS2C, slECMA, slDIMV, slPREC, slEPJ, slDC2S,
*     slDA2P, slDA1P
*
*  P.T.Wallace   Starlink   March 1986
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DL,DB,DATE,DR,DD

      DOUBLE PRECISION slEPJ,slDA2P,slDA1P

      DOUBLE PRECISION RMAT(3,3),V1(3),V2(3)



*  Spherical to Cartesian
      CALL slDS2C(DL,DB,V1)

*  Ecliptic to equatorial
      CALL slECMA(DATE,RMAT)
      CALL slDIMV(RMAT,V1,V2)

*  Mean of date to J2000
      CALL slPREC(2000D0,slEPJ(DATE),RMAT)
      CALL slDIMV(RMAT,V2,V1)

*  Cartesian to spherical
      CALL slDC2S(V1,DR,DD)

*  Express in conventional ranges
      DR=slDA2P(DR)
      DD=slDA1P(DD)

      END

#-h-  outtab			  140  local   12/01/80  15:54:32
# outtab - get past column 6
   include  defs

   subroutine outtab

   include COMMON_BLOCKS

   while (outp < col)
      call outch (BLANK)
   return
   end

      subroutine hybrj(fcn,n,x,fvec,fjac,ldfjac,xtol,maxfev,diag,mode,
     *                 factor,nprint,info,nfev,njev,r,lr,qtf,wa1,wa2,
     *                 wa3,wa4)
      integer n,ldfjac,maxfev,mode,nprint,info,nfev,njev,lr
      double precision xtol,factor
      double precision x(n),fvec(n),fjac(ldfjac,n),diag(n),r(lr),
     *                 qtf(n),wa1(n),wa2(n),wa3(n),wa4(n)
c     **********
c
c     subroutine hybrj
c
c     the purpose of hybrj is to find a zero of a system of
c     n nonlinear functions in n variables by a modification
c     of the powell hybrid method. the user must provide a
c     subroutine which calculates the functions and the jacobian.
c
c     the subroutine statement is
c
c       subroutine hybrj(fcn,n,x,fvec,fjac,ldfjac,xtol,maxfev,diag,
c                        mode,factor,nprint,info,nfev,njev,r,lr,qtf,
c                        wa1,wa2,wa3,wa4)
c
c     where
c
c       fcn is the name of the user-supplied subroutine which
c         calculates the functions and the jacobian. fcn must
c         be declared in an external statement in the user
c         calling program, and should be written as follows.
c
c         subroutine fcn(n,x,fvec,fjac,ldfjac,iflag)
c         integer n,ldfjac,iflag
c         double precision x(n),fvec(n),fjac(ldfjac,n)
c         ----------
c         if iflag = 1 calculate the functions at x and
c         return this vector in fvec. do not alter fjac.
c         if iflag = 2 calculate the jacobian at x and
c         return this matrix in fjac. do not alter fvec.
c         ---------
c         return
c         end
c
c         the value of iflag should not be changed by fcn unless
c         the user wants to terminate execution of hybrj.
c         in this case set iflag to a negative integer.
c
c       n is a positive integer input variable set to the number
c         of functions and variables.
c
c       x is an array of length n. on input x must contain
c         an initial estimate of the solution vector. on output x
c         contains the final estimate of the solution vector.
c
c       fvec is an output array of length n which contains
c         the functions evaluated at the output x.
c
c       fjac is an output n by n array which contains the
c         orthogonal matrix q produced by the qr factorization
c         of the final approximate jacobian.
c
c       ldfjac is a positive integer input variable not less than n
c         which specifies the leading dimension of the array fjac.
c
c       xtol is a nonnegative input variable. termination
c         occurs when the relative error between two consecutive
c         iterates is at most xtol.
c
c       maxfev is a positive integer input variable. termination
c         occurs when the number of calls to fcn with iflag = 1
c         has reached maxfev.
c
c       diag is an array of length n. if mode = 1 (see
c         below), diag is internally set. if mode = 2, diag
c         must contain positive entries that serve as
c         multiplicative scale factors for the variables.
c
c       mode is an integer input variable. if mode = 1, the
c         variables will be scaled internally. if mode = 2,
c         the scaling is specified by the input diag. other
c         values of mode are equivalent to mode = 1.
c
c       factor is a positive input variable used in determining the
c         initial step bound. this bound is set to the product of
c         factor and the euclidean norm of diag*x if nonzero, or else
c         to factor itself. in most cases factor should lie in the
c         interval (.1,100.). 100. is a generally recommended value.
c
c       nprint is an integer input variable that enables controlled
c         printing of iterates if it is positive. in this case,
c         fcn is called with iflag = 0 at the beginning of the first
c         iteration and every nprint iterations thereafter and
c         immediately prior to return, with x and fvec available
c         for printing. fvec and fjac should not be altered.
c         if nprint is not positive, no special calls of fcn
c         with iflag = 0 are made.
c
c       info is an integer output variable. if the user has
c         terminated execution, info is set to the (negative)
c         value of iflag. see description of fcn. otherwise,
c         info is set as follows.
c
c         info = 0   improper input parameters.
c
c         info = 1   relative error between two consecutive iterates
c                    is at most xtol.
c
c         info = 2   number of calls to fcn with iflag = 1 has
c                    reached maxfev.
c
c         info = 3   xtol is too small. no further improvement in
c                    the approximate solution x is possible.
c
c         info = 4   iteration is not making good progress, as
c                    measured by the improvement from the last
c                    five jacobian evaluations.
c
c         info = 5   iteration is not making good progress, as
c                    measured by the improvement from the last
c                    ten iterations.
c
c       nfev is an integer output variable set to the number of
c         calls to fcn with iflag = 1.
c
c       njev is an integer output variable set to the number of
c         calls to fcn with iflag = 2.
c
c       r is an output array of length lr which contains the
c         upper triangular matrix produced by the qr factorization
c         of the final approximate jacobian, stored rowwise.
c
c       lr is a positive integer input variable not less than
c         (n*(n+1))/2.
c
c       qtf is an output array of length n which contains
c         the vector (q transpose)*fvec.
c
c       wa1, wa2, wa3, and wa4 are work arrays of length n.
c
c     subprograms called
c
c       user-supplied ...... fcn
c
c       minpack-supplied ... dogleg,dpmpar,enorm,
c                            qform,qrfac,r1mpyq,r1updt
c
c       fortran-supplied ... dabs,dmax1,dmin1,mod
c
c     argonne national laboratory. minpack project. march 1980.
c     burton s. garbow, kenneth e. hillstrom, jorge j. more
c
c     **********
      integer i,iflag,iter,j,jm1,l,ncfail,ncsuc,nslow1,nslow2
      integer iwa(1)
      logical jeval,sing
      double precision actred,delta,epsmch,fnorm,fnorm1,one,pnorm,
     *                 prered,p1,p5,p001,p0001,ratio,sum,temp,xnorm,
     *                 zero
      double precision dpmpar,enorm
      data one,p1,p5,p001,p0001,zero
     *     /1.0d0,1.0d-1,5.0d-1,1.0d-3,1.0d-4,0.0d0/
c
c     epsmch is the machine precision.
c
      epsmch = dpmpar(1)
c
      info = 0
      iflag = 0
      nfev = 0
      njev = 0
c
c     check the input parameters for errors.
c
      if (n .le. 0 .or. ldfjac .lt. n .or. xtol .lt. zero
     *    .or. maxfev .le. 0 .or. factor .le. zero
     *    .or. lr .lt. (n*(n + 1))/2) go to 300
      if (mode .ne. 2) go to 20
      do 10 j = 1, n
         if (diag(j) .le. zero) go to 300
   10    continue
   20 continue
c
c     evaluate the function at the starting point
c     and calculate its norm.
c
      iflag = 1
      call fcn(n,x,fvec,fjac,ldfjac,iflag)
      nfev = 1
      if (iflag .lt. 0) go to 300
      fnorm = enorm(n,fvec)
c
c     initialize iteration counter and monitors.
c
      iter = 1
      ncsuc = 0
      ncfail = 0
      nslow1 = 0
      nslow2 = 0
c
c     beginning of the outer loop.
c
   30 continue
         jeval = .true.
c
c        calculate the jacobian matrix.
c
         iflag = 2
         call fcn(n,x,fvec,fjac,ldfjac,iflag)
         njev = njev + 1
         if (iflag .lt. 0) go to 300
c
c        compute the qr factorization of the jacobian.
c
         call qrfac(n,n,fjac,ldfjac,.false.,iwa,1,wa1,wa2,wa3)
c
c        on the first iteration and if mode is 1, scale according
c        to the norms of the columns of the initial jacobian.
c
         if (iter .ne. 1) go to 70
         if (mode .eq. 2) go to 50
         do 40 j = 1, n
            diag(j) = wa2(j)
            if (wa2(j) .eq. zero) diag(j) = one
   40       continue
   50    continue
c
c        on the first iteration, calculate the norm of the scaled x
c        and initialize the step bound delta.
c
         do 60 j = 1, n
            wa3(j) = diag(j)*x(j)
   60       continue
         xnorm = enorm(n,wa3)
         delta = factor*xnorm
         if (delta .eq. zero) delta = factor
   70    continue
c
c        form (q transpose)*fvec and store in qtf.
c
         do 80 i = 1, n
            qtf(i) = fvec(i)
   80       continue
         do 120 j = 1, n
            if (fjac(j,j) .eq. zero) go to 110
            sum = zero
            do 90 i = j, n
               sum = sum + fjac(i,j)*qtf(i)
   90          continue
            temp = -sum/fjac(j,j)
            do 100 i = j, n
               qtf(i) = qtf(i) + fjac(i,j)*temp
  100          continue
  110       continue
  120       continue
c
c        copy the triangular factor of the qr factorization into r.
c
         sing = .false.
         do 150 j = 1, n
            l = j
            jm1 = j - 1
            if (jm1 .lt. 1) go to 140
            do 130 i = 1, jm1
               r(l) = fjac(i,j)
               l = l + n - i
  130          continue
  140       continue
            r(l) = wa1(j)
            if (wa1(j) .eq. zero) sing = .true.
  150       continue
c
c        accumulate the orthogonal factor in fjac.
c
         call qform(n,n,fjac,ldfjac,wa1)
c
c        rescale if necessary.
c
         if (mode .eq. 2) go to 170
         do 160 j = 1, n
            diag(j) = dmax1(diag(j),wa2(j))
  160       continue
  170    continue
c
c        beginning of the inner loop.
c
  180    continue
c
c           if requested, call fcn to enable printing of iterates.
c
            if (nprint .le. 0) go to 190
            iflag = 0
            if (mod(iter-1,nprint) .eq. 0)
     *         call fcn(n,x,fvec,fjac,ldfjac,iflag)
            if (iflag .lt. 0) go to 300
  190       continue
c
c           determine the direction p.
c
            call dogleg(n,r,lr,diag,qtf,delta,wa1,wa2,wa3)
c
c           store the direction p and x + p. calculate the norm of p.
c
            do 200 j = 1, n
               wa1(j) = -wa1(j)
               wa2(j) = x(j) + wa1(j)
               wa3(j) = diag(j)*wa1(j)
  200          continue
            pnorm = enorm(n,wa3)
c
c           on the first iteration, adjust the initial step bound.
c
            if (iter .eq. 1) delta = dmin1(delta,pnorm)
c
c           evaluate the function at x + p and calculate its norm.
c
            iflag = 1
            call fcn(n,wa2,wa4,fjac,ldfjac,iflag)
            nfev = nfev + 1
            if (iflag .lt. 0) go to 300
            fnorm1 = enorm(n,wa4)
c
c           compute the scaled actual reduction.
c
            actred = -one
            if (fnorm1 .lt. fnorm) actred = one - (fnorm1/fnorm)**2
c
c           compute the scaled predicted reduction.
c
            l = 1
            do 220 i = 1, n
               sum = zero
               do 210 j = i, n
                  sum = sum + r(l)*wa1(j)
                  l = l + 1
  210             continue
               wa3(i) = qtf(i) + sum
  220          continue
            temp = enorm(n,wa3)
            prered = zero
            if (temp .lt. fnorm) prered = one - (temp/fnorm)**2
c
c           compute the ratio of the actual to the predicted
c           reduction.
c
            ratio = zero
            if (prered .gt. zero) ratio = actred/prered
c
c           update the step bound.
c
            if (ratio .ge. p1) go to 230
               ncsuc = 0
               ncfail = ncfail + 1
               delta = p5*delta
               go to 240
  230       continue
               ncfail = 0
               ncsuc = ncsuc + 1
               if (ratio .ge. p5 .or. ncsuc .gt. 1)
     *            delta = dmax1(delta,pnorm/p5)
               if (dabs(ratio-one) .le. p1) delta = pnorm/p5
  240       continue
c
c           test for successful iteration.
c
            if (ratio .lt. p0001) go to 260
c
c           successful iteration. update x, fvec, and their norms.
c
            do 250 j = 1, n
               x(j) = wa2(j)
               wa2(j) = diag(j)*x(j)
               fvec(j) = wa4(j)
  250          continue
            xnorm = enorm(n,wa2)
            fnorm = fnorm1
            iter = iter + 1
  260       continue
c
c           determine the progress of the iteration.
c
            nslow1 = nslow1 + 1
            if (actred .ge. p001) nslow1 = 0
            if (jeval) nslow2 = nslow2 + 1
            if (actred .ge. p1) nslow2 = 0
c
c           test for convergence.
c
            if (delta .le. xtol*xnorm .or. fnorm .eq. zero) info = 1
            if (info .ne. 0) go to 300
c
c           tests for termination and stringent tolerances.
c
            if (nfev .ge. maxfev) info = 2
            if (p1*dmax1(p1*delta,pnorm) .le. epsmch*xnorm) info = 3
            if (nslow2 .eq. 5) info = 4
            if (nslow1 .eq. 10) info = 5
            if (info .ne. 0) go to 300
c
c           criterion for recalculating jacobian.
c
            if (ncfail .eq. 2) go to 290
c
c           calculate the rank one modification to the jacobian
c           and update qtf if necessary.
c
            do 280 j = 1, n
               sum = zero
               do 270 i = 1, n
                  sum = sum + fjac(i,j)*wa4(i)
  270             continue
               wa2(j) = (sum - wa3(j))/pnorm
               wa1(j) = diag(j)*((diag(j)*wa1(j))/pnorm)
               if (ratio .ge. p0001) qtf(j) = sum
  280          continue
c
c           compute the qr factorization of the updated jacobian.
c
            call r1updt(n,n,r,lr,wa1,wa2,wa3,sing)
            call r1mpyq(n,n,fjac,ldfjac,wa2,wa3)
            call r1mpyq(1,n,qtf,1,wa2,wa3)
c
c           end of the inner loop.
c
            jeval = .false.
            go to 180
  290    continue
c
c        end of the outer loop.
c
         go to 30
  300 continue
c
c     termination, either normal or user imposed.
c
      if (iflag .lt. 0) info = iflag
      iflag = 0
      if (nprint .gt. 0) call fcn(n,x,fvec,fjac,ldfjac,iflag)
      return
c
c     last card of subroutine hybrj.
c
      end

c IMREN -- Rename an image.
c
c	usage:  imren oldname newname
c ----------------------------------------------------------------------

	program imren

	integer		nargs, ier
	character*80	oname, nname, errmsg

c --- Get the old and new names of the image to be renamed.
	call clnarg (nargs)
	if (nargs .ge. 2) then
	    call clargc (1, oname, ier)
	    if (ier .ne. 0) goto 91
	    call clargc (2, nname, ier)
	    if (ier .ne. 0) goto 91
	else
	    write (*, '('' enter old image name: '',$)')
	    read (*,*) oname
	    write (*, '('' enter new image name: '',$)')
	    read (*,*) nname
	endif

c --- Rename the image.
	call imrnam (oname, nname, ier)
	if (ier .ne. 0) goto 91

	stop

c --- Error exit.
 91	call imemsg (ier, errmsg)
	write (*, '('' Error: '', a80)') errmsg

	stop
	end

      SUBROUTINE slDMXM (A, B, C)
*+
*     - - - - -
*      D M X M
*     - - - - -
*
*  Product of two 3x3 matrices:
*
*      matrix C  =  matrix A  x  matrix B
*
*  (double precision)
*
*  Given:
*      A      dp(3,3)        matrix
*      B      dp(3,3)        matrix
*
*  Returned:
*      C      dp(3,3)        matrix result
*
*  To comply with the ANSI Fortran 77 standard, A, B and C must
*  be different arrays.  However, the routine is coded so as to
*  work properly on many platforms even if this rule is violated.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION A(3,3),B(3,3),C(3,3)

      INTEGER I,J,K
      DOUBLE PRECISION W,WM(3,3)


*  Multiply into scratch matrix
      DO I=1,3
         DO J=1,3
            W=0D0
            DO K=1,3
               W=W+A(I,K)*B(K,J)
            END DO
            WM(I,J)=W
         END DO
      END DO

*  Return the result
      DO J=1,3
         DO I=1,3
            C(I,J)=WM(I,J)
         END DO
      END DO

      END

      subroutine setdat(icount)
c  from  * a practical guide to splines *  by c. de boor
c  to be called in main program  l 2 m a i n .
c     this routine is set up to provide the specific data for example 2
c     in chapter xiv. for a general purpose l2-approximation program, it
c     would have to be replaced by a subroutine reading in
c	    ntau, tau(i), gtau(i), i=1,...,ntau
c     and reading in or setting
c	     k, l, break(i),i=1,...,l+1,  and weight(i),i=1,...,ntau,
c	    as well as	totalw = sum( weight(i) , i=1,...,ntau).
c    i c o u n t  is equal to zero when setdat is called in  l 2 m a i n
c     for the first time. after that, it is up to setdat to use icount
c     for keeping track of the passes through setdat . this is important
c     since l2main relies on setdat for  t e r m i n a t i o n .
      integer icount,  i,k,l,lp1,ntau,ntaum1
      real break,coef,gtau,step,tau,totalw,weight
c     parameter lpkmax=100,ntmax=200,ltkmax=2000
c     common / data / ntau, tau(ntmax),gtau(ntmax),weight(ntmax),totalw
c     common /approx/ break(lpkmax),coef(ltkmax),l,k
      common / data / ntau, tau(200),gtau(200),weight(200),totalw
      common /approx/ break(100),coef(2000),l,k
      if (icount .gt. 0)		stop
      icount = icount + 1
      ntau = 10
      ntaum1 = ntau-1
      do 8 i=1,ntaum1
    8	 tau(i) = 1. - .5**(i-1)
      tau(ntau) = 1.
      do 9 i=1,ntau
    9	 gtau(i) = tau(i)**2  + 1.
      do 10 i=1,ntau
   10	 weight(i) = 1.
      totalw = ntau
      l = 6
      lp1 = l+1
      step = 1./float(l)
      k = 2
      do 11 i=1,lp1
   11	 break(i) = (i-1)*step
					return
      end

      SUBROUTINE TCONRE	(nplot, IERROR)
C
C LATEST REVISION	 JUNE 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 CONREC	AND TO TEST CONREC ON A	SINGLE
C			 PROBLEM
C
C USAGE			 CALL TCONRE (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   CONREC TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, TWO FRAMES CONTAINING THE	CONTOUR
C			 PLOT ARE PRODUCED ON THE MACHINE GRAPHICS
C			 DEVICE.  IN ORDER TO DETERMINE	IF THE TEST
C			 WAS SUCCESSFUL, IT IS NECESSARY TO EXAMINE
C			 THESE PLOTS.
C
C PRECISION		 SINGLE
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 THE FUNCTION
C			   Z(X,Y) = X +	Y + 1./((X-.1)**2+Y**2+.09)
C				    -1./((X+.1)**2+Y**2+.09)
C			 FOR X = -1. TO	+1. IN INCREMENTS OF .1	AND
C			     Y = -1.2 TO +1.2 IN INCREMENTS OF .1
C			 IS COMPUTED.
C			 TCONRE	CALL SUBROUTINES EZCNTR, CONREC, AND
C			 PWRIT TO DRAW TWO LABELLED CONTOUR PLOTS OF THE
C			 ARRAY Z.
C
C PORTABILITY		 FORTRAN77
C
C
C Z CONTAINS THE VALUES	TO BE PLOTTED.
C
      REAL	      Z(21,25)
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE INTEGER COORDINATES RANGE	FROM 0.0 TO 1.0, THE VALUES TX AND TY
C DEFINE THE CENTER OF THE TITLE STRING.
C
C     DATA TX/.3955/, TY/.9765/
	data tx/.4267/, ty/.97/
C
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 0
C
C FILL TWO DIMENSIONAL ARRAY TO	BE PLOTTED
C
      DO  20 I=1,21
	 X = .1*FLOAT(I-11)
	 DO  10	J=1,25
	    Y =	.1*FLOAT(J-13)
	    Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1		     1./((X+.10)**2+Y**2+.09)
   10	 CONTINUE
   20 CONTINUE
C
C SELECT NORMALIZATION TRANSFORMATION NUMBER 0
C
      CALL GSELNT ( 0 )
C
C ENTRY	EZCNTR REQUIRES	ONLY THE ARRAY NAME AND	ITS DIMENSIONS
C
C THE TITLE FOR	THIS PLOT IS
C
C  DEMONSTRATION PLOT FOR EZCNTR ENTRY OF CONREC
C
c +noao: flag added to plot either EZCNTR or CONREC
      if (nplot .eq. 1) then
      CALL WTSTR ( TX, TY,
     1		 'DEMONSTRATION PLOT FOR EZCNTR ENTRY OF CONREC',2,0,0 )
      CALL EZCNTR (Z,21,25)
      endif
c -noao
C
C
C ENTRY	CONREC ALLOWS USER SPECIFICATION OF PLOT PARAMETERS, IF	DESIRED
C
C IN THIS EXAMPLE, THE LOWEST CONTOUR LEVEL (-4.5), THE	HIGHEST	CONTOUR
C LEVEL	(4.5), AND THE INCREMENT BETWEEN CONTOUR LEVELS	(0.3) ARE
C SPECIFIED.
C
C THE TITLE FOR	THIS PLOT IS
C
C  DEMONSTRATION PLOT FOR CONREC ENTRY OF CONREC
C
c +noao:  flag added to plot either EZCNTR of CONREC
      if (nplot .eq. 2) then
      CALL WTSTR ( TX ,TY,
     1		 'DEMONSTRATION PLOT FOR CONREC ENTRY OF CONREC',2,0,0 )
      CALL CONREC (Z,21,21,25,-4.5,4.5,.3,0,0,0)
      endif
c -noao
c     CALL NEWFM
C
C     WRITE (6,1001)
      RETURN
C
C1001 FORMAT ('	    CONREC TEST	SUCCESSFUL',24X,
C    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

C----------------------------------------------------------------------
        subroutine ftc2ll(cval,lval,status)
C       convert a character string to a logical value 
C       (assumes that the input string is left justified)
        integer status
        logical lval
        character*(*) cval

        if (status .gt. 0)return

C       convert character string to logical
        if (cval(1:1) .eq.'T')then
                lval=.true.
        else
C               any other character is considered false
                lval=.false.
        end if
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
c +noao: here is the changed block data
c     BLOCKDATA SRFABD
      subroutine srfabd
c
      integer first, temp
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL,
     1                LL         ,FACT       ,IROT       ,NDRZ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI,
     3                CLO        ,CINC       ,ISPVAL
      COMMON /SRFINT/ ISRFMJ     ,ISRFMN     ,ISRFTX
c +noao: common block added 4NOV85 to allow user control of viewport.
      common /noaovp/ vpx1, vpx2, vpy1, vpy2
c-noao
C
c +noao: following flag added to prevent initialization more than once
        common /frstfg/ first
	SAVE
        data temp /1/
	first = temp
        if (first .ne. 1) then
            return
        endif
        temp = 0
c
C +noao: by default, the full device viewport is used
      vpx1 = 0.0
      vpx2 = 1.0
      vpy1 = 0.0
      vpy2 = 1.0
c -noao
C  INITIALIZATION OF INTERNAL PARAMETERS
C
c     DATA ISPVAL/-999/
      ISPVAL = -999

c     DATA IFR,ISTP,IROTS,IDRX,IDRY,IDRZ,IUPPER,ISKIRT,NCLA/
c    1       1,   0,    0,       1,       1,   0,         0,     0,       6/
c +noao: initial value of ifr changed to 0 to suppress frame advance.  This
c       function should be performed by the calling procedure.
c -noao
      IFR    = 0
      ISTP   = 0
      IROTS  = 0  
      IDRX   = 1
      IDRY   = 1
      IDRZ   = 0
      IUPPER = 0
      ISKIRT = 0
      NCLA   = 6
     
c     DATA THETA,HSKIRT,CHI,CLO,CINC/
c    1       .02,    0., 0., 0.,  0./
      THETA  =.02
      HSKIRT = 0.
      CHI    = 0.
      CLO    = 0.
      CINC   = 0.
     
c     DATA NRSWT/0/
      NRSWT = 0

c     DATA IOFFP,SPVAL/0,0.0/
      IOFFP = 0
      SPVAL = 0.0

C LINE COLOR INDEX
c     DATA ISRFMJ/1/
      ISRFMJ = 1
C
c -noao
      END

C 	This routines was copied from the stsdas$pkg/analysis/gasp/gasplib/
C       directory. See the file stsdas$copyright.stsdas  for copyright
C	restrictions. 
	subroutine ksbsvd (u,w,v,m,n,b,x)
	parameter (nmax=1000)
	real*8 u(m,n),w(n),v(n,n),b(m),x(n),tmp(nmax)
	real*8 s

	do j=1,n
		s=0.
		if(w(j).ne.0.)then
			do i=1,m
				s=s+u(i,j)*b(i)
			enddo
			s=s/w(j)
		endif
		tmp(j)=s
	enddo
	do j=1,n
		s=0.
		do jj=1,n
			s=s+v(j,jj)*tmp(jj)
		enddo
		x(j)=s
	enddo
	return
	end

      SUBROUTINE slDCMF (COEFFS,XZ,YZ,XS,YS,PERP,ORIENT)
*+
*     - - - - - -
*      D C M F
*     - - - - - -
*
*  Decompose an [X,Y] linear fit into its constituent parameters:
*  zero points, scales, nonperpendicularity and orientation.
*
*  Given:
*     COEFFS  d(6)      transformation coefficients (see note)
*
*  Returned:
*     XZ       d        x zero point
*     YZ       d        y zero point
*     XS       d        x scale
*     YS       d        y scale
*     PERP     d        nonperpendicularity (radians)
*     ORIENT   d        orientation (radians)
*
*  Called:  slDA1P
*
*  The model relates two sets of [X,Y] coordinates as follows.
*  Naming the elements of COEFFS:
*
*     COEFFS(1) = A
*     COEFFS(2) = B
*     COEFFS(3) = C
*     COEFFS(4) = D
*     COEFFS(5) = E
*     COEFFS(6) = F
*
*  the model transforms coordinates [X1,Y1] into coordinates
*  [X2,Y2] as follows:
*
*     X2 = A + B*X1 + C*Y1
*     Y2 = D + E*X1 + F*Y1
*
*  The transformation can be decomposed into four steps:
*
*     1)  Zero points:
*
*             x' = XZ + X1
*             y' = YZ + Y1
*
*     2)  Scales:
*
*             x'' = XS*x'
*             y'' = YS*y'
*
*     3)  Nonperpendicularity:
*
*             x''' = cos(PERP/2)*x'' + sin(PERP/2)*y''
*             y''' = sin(PERP/2)*x'' + cos(PERP/2)*y''
*
*     4)  Orientation:
*
*             X2 = cos(ORIENT)*x''' + sin(ORIENT)*y'''
*             Y2 =-sin(ORIENT)*y''' + cos(ORIENT)*y'''
*
*  See also slFTXY, slPXY, slINVF, slXYXY
*
*  P.T.Wallace   Starlink   19 December 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION COEFFS(6),XZ,YZ,XS,YS,PERP,ORIENT

      DOUBLE PRECISION A,B,C,D,E,F,RB2E2,RC2F2,XSC,YSC,P1,P2,P,WS,WC,
     :                 OR,HP,SHP,CHP,SOR,COR,DET,X0,Y0,slDA1P



*  Copy the six coefficients.
      A = COEFFS(1)
      B = COEFFS(2)
      C = COEFFS(3)
      D = COEFFS(4)
      E = COEFFS(5)
      F = COEFFS(6)

*  Scales.
      RB2E2 = SQRT(B*B+E*E)
      RC2F2 = SQRT(C*C+F*F)
      IF (B*F-C*E.GE.0D0) THEN
         XSC = RB2E2
      ELSE
         B = -B
         E = -E
         XSC = -RB2E2
      END IF
      YSC = RC2F2

*  Non-perpendicularity.
      IF (C.NE.0D0.OR.F.NE.0D0) THEN
         P1 = ATAN2(C,F)
      ELSE
         P1 = 0D0
      END IF
      IF (E.NE.0D0.OR.B.NE.0D0) THEN
         P2 = ATAN2(E,B)
      ELSE
         P2 = 0D0
      END IF
      P = slDA1P(P1+P2)

*  Orientation.
      WS = C*RB2E2-E*RC2F2
      WC = B*RC2F2+F*RB2E2
      IF (WS.NE.0D0.OR.WC.NE.0D0) THEN
         OR = ATAN2(WS,WC)
      ELSE
         OR = 0D0
      END IF

*  Zero points.
      HP = P/2D0
      SHP = SIN(HP)
      CHP = COS(HP)
      SOR = SIN(OR)
      COR = COS(OR)
      DET = XSC*YSC*(CHP+SHP)*(CHP-SHP)
      IF (ABS(DET).GT.0D0) THEN
         X0 = YSC*(A*(CHP*COR-SHP*SOR)-D*(CHP*SOR+SHP*COR))/DET
         Y0 = XSC*(A*(CHP*SOR-SHP*COR)+D*(CHP*COR+SHP*SOR))/DET
      ELSE
         X0 = 0D0
         Y0 = 0D0
      END IF

*  Results.
      XZ = X0
      YZ = Y0
      XS = XSC
      YS = YSC
      PERP = P
      ORIENT = OR

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C***********************************************************************
C P A C K A G E   E Z M A P   -   I N T R O D U C T I O N
C***********************************************************************
C
C THIS FILE CONTAINS IMPLEMENTATION INSTRUCTIONS, A WRITE-UP, AND THE
C CODE FOR THE PACKAGE EZMAP.  BANNERS LIKE THE ONE ABOVE DELIMIT THE
C MAJOR SECTIONS OF THE FILE.  THE CODE ITSELF IS SEPARATED INTO THREE
C SECTIONS:  USER-LEVEL ROUTINES, INTERNAL ROUTINES, AND THE BLOCK DATA
C ROUTINE WHICH DETERMINES THE DEFAULT VALUES OF INTERNAL PARAMETERS.
C WITHIN EACH SECTION, ROUTINES APPEAR IN ALPHABETICAL ORDER.
C
C***********************************************************************
C P A C K A G E   E Z M A P   -   I M P L E M E N T A T I O N
C***********************************************************************
C
C THE EZMAP PACKAGE IS WRITTEN IN FORTRAN-77 AND SHOULD BE RELATIVELY
C EASY TO IMPLEMENT.  THE OUTLINE DATA REQUIRED MAY BE GENERATED BY
C RUNNING THE PROGRAM
C
C       PROGRAM CONVRT
C       DIMENSION FLIM(4),PNTS(200)
C     1 READ (1,3,END=2) NPTS,IGID,(FLIM(I),I=1,4)
C       IF (NPTS.GT.1) READ (1,4,END=2) (PNTS(I),I=1,NPTS)
C       WRITE (2) NPTS,IGID,(FLIM(I),I=1,4),(PNTS(I),I=1,NPTS)
C       GO TO 1
C     2 STOP
C     3 FORMAT (2I8,4F8.3)
C     4 FORMAT (10F8.3)
C       END
C
C WITH THE FILE EZMAPDAT ASSIGNED TO UNIT 1.  THE OUTPUT FILE, ON UNIT
C 2, CONTAINS THE BINARY OUTLINE DATA TO BE USED BY EZMAP.  THE EZMAP
C ROUTINE MAPIO (WHICH SEE) MUST THEN BE MODIFIED TO ACCESS THIS FILE.
C
C THE ROUTINE MAPCHI CONTAINS THE STATEMENTS
C
C       CALL GETUSV ('IN',INTO)
C       CALL SETUSV ('IN',IFIX(10000.*FLOAT(INTS(IPRT))/255.))
C
C (TO BE EXECUTED FOR A POSITIVE VALUE OF IPRT) AND THE STATEMENT
C
C       CALL SETUSV ('IN',INTO)
C
C (TO BE EXECUTED FOR A NEGATIVE VALUE OF IPRT).  THESE STATEMENTS
C SET/RESET THE INTENSITY FOR VARIOUS PORTIONS OF THE MAP.  IF COLOR
C IS AVAILABLE ON THE DEVICE(S) BEING DRIVEN, THESE STATEMENTS SHOULD
C BE OMITTED AND THE IMPLEMENTOR SHOULD PROVIDE A DEFAULT VERSION OF
C MAPUSR WHICH SETS/RESETS THE INTENSITY AND COLOR AS DESIRED.  THIS
C DEFAULT VERSION OF MAPUSR SHOULD DECLARE THE LABELLED COMMON BLOCK
C MAPNTS AND MAKE USE OF THE CURRENT VALUES IN THE ARRAY INTS TO SET
C THE INTENSITY; IT SHOULD ALSO BE PUBLISHED TO AID USERS IN SETTING
C UP THEIR OWN VERSIONS.
C
C
C***********************************************************************
C P A C K A G E   E Z M A P   -   U S E R ' S   G U I D E
C***********************************************************************
C
C LATEST REVISION        AUGUST, 1985
C
C PURPOSE                TO PLOT MAPS OF THE EARTH ACCORDING TO ANY
C                        ONE OF TEN DIFFERENT PROJECTIONS, SHOWING
C                        CONTINENTAL, INTERNATIONAL, AND/OR U.S. STATE
C                        OUTLINES, PARALLELS, AND MERIDIANS.  THE
C                        ORIGIN AND ORIENTATION OF THE PROJECTION ARE
C                        SELECTED BY THE USER.  POINTS ON THE EARTH
C                        DEFINED BY LATITUDE AND LONGITUDE ARE MAPPED
C                        TO POINTS IN THE PLANE OF PROJECTION - THE
C                        U/V PLANE.  THE U AND V AXES ARE PARALLEL TO
C                        THE X AND Y AXES OF THE PLOTTER, RESPECTIVELY.
C                        A RECTANGULAR FRAME WHOSE SIDES ARE PARALLEL
C                        TO THE U AND V AXES IS CHOSEN AND MATERIAL
C                        WITHIN THAT FRAME (OR AN INSCRIBED ELLIPTICAL
C                        FRAME) IS PLOTTED.
C
C USAGE                  THE ROUTINE MAPDRW DRAWS A COMPLETE MAP, AS
C                        DIRECTED BY THE CURRENT VALUES OF PARAMETERS
C                        IN THE EZMAP PACKAGE.  TO CHANGE THE VALUES
C                        OF THOSE PARAMETERS, AND THUS THE APPEARANCE
C                        OF THE MAP, ONE MAY FIRST CALL ONE OF THE
C                        ROUTINES MAPROJ (TO CHANGE THE PROJECTION TO
C                        BE USED), MAPSET (TO CHANGE WHAT PORTION OF
C                        THE U/V PLANE IS TO BE VIEWED), MAPPOS (TO
C                        CHANGE WHAT PORTION OF THE PLOTTER FRAME IS
C                        TO BE USED), OR ONE OF THE PARAMETER-SETTING
C                        ROUTINES MAPSTC, MAPSTI, MAPSTL, AND MAPSTR
C                        (TO CHANGE VARIOUS OTHER PARAMETERS, OF TYPES
C                        CHARACTER, INTEGER, LOGICAL, AND REAL).  THE
C                        PARAMETER-RETRIEVAL ROUTINES MAPGTC, MAPGTI,
C                        MAPGTL, AND MAPGTR ALLOW THE USER TO RETRIEVE
C                        THE VALUES OF EZMAP PARAMETERS.
C
C                        THE ROUTINE MAPSAV ALLOWS ONE TO SAVE THE
C                        CURRENT STATE OF EZMAP, THE ROUTINE MAPRST TO
C                        RESTORE A SAVED STATE.
C
C                        USERS WITH SPECIAL NEEDS MAY WISH TO CALL THE
C                        LOWER-LEVEL ROUTINES MAPINT (TO INITIALIZE
C                        THE PACKAGE - IT MUST BE CALLED INITIALLY AND
C                        AGAIN WHENEVER CERTAIN PARAMETERS ARE CHANGED),
C                        MAPGRD (TO DRAW PARALLELS AND MERIDIANS),
C                        MAPLBL (TO LABEL THE INTERNATIONAL DATE LINE,
C                        THE EQUATOR, THE GREENWICH MERIDIAN, AND THE
C                        POLES, AND TO DRAW THE PERIMETER), AND MAPLOT
C                        (TO DRAW THE SELECTED GEOGRAPHIC OUTLINES).
C                        THESE ROUTINES ARE NORMALLY CALLED BY MAPDRW.
C
C                        INTENSITIES OF VARIOUS MAP PORTIONS MAY BE SET
C                        BY CALLS TO THE ROUTINE MAPSTI.  THE ROUTINE
C                        MAPUSR IS CALLED BY EZMAP JUST BEFORE/AFTER
C                        DRAWING VARIOUS PORTIONS OF THE MAP; THE
C                        DEFAULT VERSION, WHICH DOES NOTHING, MAY BE
C                        REPLACED BY A USER VERSION WHICH SETS/RESTORES
C                        COLOR, SPOT SIZE, INTENSITY, DASH PATTERN, ETC.
C
C                        THE ROUTINE MAPEOS IS CALLED BY EZMAP ONCE FOR
C                        EACH OUTLINE SEGMENT.  THE USER MAY SUPPLY A
C                        VERSION WHICH EXAMINES THE SEGMENT TO SEE IF
C                        IT OUGHT TO BE PLOTTED AND, IF NOT, TO DELETE
C                        IT.  THIS MAY BE USED, FOR EXAMPLE, TO REDUCE
C                        THE CLUTTER IN NORTHERN CANADA.
C
C                        TO OVERLAY OBJECTS OF ONE'S OWN ON THE MAP
C                        DRAWN BY MAPDRW, ONE MAY USE ONE OR MORE OF
C                        THE ROUTINES MAPTRN (TO COMPUTE THE U/V
C                        COORDINATES OF A POINT, GIVEN ITS LATITUDE
C                        AND LONGITUDE), MAPIT (TO DO "PEN-UP/DOWN"
C                        MOVES), MAPFST (TO DO "PEN-UP" MOVES), AND
C                        MAPVEC (TO DO "PEN-DOWN" MOVES).
C
C                        THE ROUTINE SUPMAP, FROM WHICH EZMAP GREW, IS
C                        IMPLEMENTED WITHIN IT AND ALLOWS ONE TO DRAW
C                        A COMPLETE MAP WITH A SINGLE, RATHER LENGTHY,
C                        CALL.  THE ROUTINE SUPCON, WHICH IS THE OLD
C                        ANALOGUE OF MAPTRN, IS ALSO IMPLEMENTED.
C
C                        THE OLD ROUTINE EZMAP, WHICH WAS IMPLEMENTED
C                        IN SUCH A WAY AS TO CAUSE PORTABILITY PROBLEMS,
C                        HAS BEEN REMOVED.  STATISTICS INDICATED THAT
C                        IT WAS NOT BEING USED, ANYWAY.
C
C                        SEE THE WRITE-UPS OF INDIVIDUAL ROUTINES BELOW.
C
C I/O                    GRAPHICAL OUTPUT IS GENERATED.  OUTLINE DATA
C                        IS READ FROM A "TAPE UNIT".
C
C ERROR CONDITIONS       WHEN AN ERROR OCCURS DURING A CALL TO AN EZMAP
C                        ROUTINE, AN ERROR MESSAGE IS LOGGED, USING THE
C                        NCAR VERSION OF THE PORT ERROR ROUTINE SETERR
C                        (CALLED SETER); BY DEFAULT, THE PROGRAM IS THEN
C                        ABORTED.  ERROR RECOVERY IS POSSIBLE, HOWEVER.
C                        INSERT THE CALL
C
C                              CALL ENTSR (IOLD,1)
C
C                        AT THE BEGINNING OF YOUR PROGRAM.  THIS MAKES
C                        ERROR RECOVERY POSSIBLE.  THEN, FOLLOWING EACH
C                        CALL TO AN EZMAP ROUTINE WHICH COULD CAUSE AN
C                        ERROR, INSERT CODE LIKE THE FOLLOWING:
C
C                              IF (NERRO(IERR).NE.0) THEN
C                                CALL EPRIN
C                                CALL ERROF
C                              END IF
C
C                        THE VALUE OF THE FUNCTION NERRO IS NON-ZERO IF
C                        SETER HAS BEEN CALLED.  THE CALL TO EPRIN DUMPS
C                        OUT THE ERROR MESSAGE (WHICH HAS NOT YET BEEN
C                        PRINTED) AND THE CALL TO ERROF TURNS OFF THE
C                        ERROR CONDITION IN SETER.  THIS DOES NOT CLEAR
C                        EZMAP'S ERROR FLAG, HOWEVER; IT REMAINS SET
C                        UNTIL AFTER THE NEXT SUCCESSFUL CALL TO MAPINT,
C                        PREVENTING OTHER EZMAP ROUTINES FROM TRYING TO
C                        EXECUTE (AND POSSIBLY BOMBING AS A RESULT).
C                        POSSIBLE ERROR FLAGS ARE AS FOLLOWS:
C
C                           1  MAPGTC - UNKNOWN PARAMETER NAME XX
C                           2  MAPGTI - UNKNOWN PARAMETER NAME XX
C                           3  MAPGTL - UNKNOWN PARAMETER NAME XX
C                           4  MAPGTR - UNKNOWN PARAMETER NAME XX
C                           5  MAPINT - ATTEMPT TO USE NON-EXISTENT
C                                       PROJECTION
C                           6  MAPINT - ANGULAR LIMITS TOO GREAT
C                           7  MAPINT - MAP HAS ZERO AREA
C                           8  MAPINT - MAP LIMITS INAPPROPIATE
C                           9  MAPROJ - UNKNOWN PROJECTION NAME XX
C                          10  MAPSET - UNKNOWN MAP AREA SPECIFIER XX
C                          11  MAPSTC - UNKNOWN OUTLINE NAME XX
C                          12  MAPSTC - UNKNOWN PARAMETER NAME XX
C                          13  MAPSTI - UNKNOWN PARAMETER NAME XX
C                          14  MAPSTL - UNKNOWN PARAMETER NAME XX
C                          15  MAPSTR - UNKNOWN PARAMETER NAME XX
C                          16  MAPTRN - ATTEMPT TO USE NON-EXISTENT
C                                       PROJECTION
C                          17  MAPIO -  OUTLINE DATASET IS UNREADABLE
C                          18  MAPIO -  EOF ENCOUNTERED IN OUTLINE
C                                       DATASET
C                          19  MAPPOS - ARGUMENTS ARE INCORRECT
C                          20  MAPRST - ERROR ON READ
C                          21  MAPRST - EOF ON READ
C                          22  MAPSAV - ERROR ON WRITE
C
C PRECISION              SINGLE.
C
C LANGUAGE               FORTRAN.
C
C HISTORY                IN ABOUT 1963, R. L. PARKER OF UCSD WROTE THE
C                        ORIGINAL CODE CALLED SUPERMAP, USING OUTLINE
C                        DATA GENERATED BY HERSHEY.  THIS WAS ADAPTED
C                        FOR USE AT NCAR BY LEE, IN 1968.  REVISIONS
C                        OCCURRED IN JANUARY OF 1969 AND MAY OF 1971.
C                        THE CODE WAS PUT IN STANDARD NSSL FORMAT IN
C                        OCTOBER OF 1973.  FURTHER REVISIONS OCCURRED
C                        IN JULY, 1974, IN AUGUST, 1976, AND IN JULY,
C                        1978.  IN LATE 1984 AND EARLY 1985, THE CODE
C                        WAS HEAVILY REVISED TO ACHIEVE FORTRAN-77 AND
C                        GKS COMPATIBILITY, TO REMOVE ERRORS, AND TO
C                        EXPAND THE OUTLINE DATASETS.  CICELY RIDLEY,
C                        JAY CHALMERS, AND DAVE KENNISON (THE CURRENT
C                        CURATOR) HAVE ALL HAD A HAND IN THE CREATION
C                        OF THIS PACKAGE.
C
C REFERENCES             HERSHEY, A.V., "THE PLOTTING OF MAPS ON A
C                        CRT PRINTER."  NWL REPORT NO. 1844, 1963.
C
C                        LEE, TSO-HWA, "STUDENTS' SUMMARY REPORTS,
C                        WORK-STUDY PROGRAM IN SCIENTIFIC COMPUTING".
C                        NCAR, 1968.
C
C                        PARKER, R.L., "2UCSD SUPERMAP:  WORLD
C                        PLOTTING PACKAGE".
C
C                        STEERS, J.A., "AN INTRODUCTION TO THE STUDY
C                        OF MAP PROJECTIONS".  UNIVERSITY OF LONDON
C                        PRESS, 1962.
C
C ACCURACY               THE DEFINITION OF THE MAP PRODUCED IS LIMITED
C                        BY TWO FACTORS:  THE RESOLUTION OF THE OUTLINE
C                        DATA AND THE RESOLUTION OF THE GRAPHICS
C                        DEVICE.
C
C                        DATA POINTS IN THE CONTINENTAL OUTLINES ARE
C                        ABOUT ONE DEGREE APART AND THE COORDINATES
C                        ARE ACCURATE TO .01 DEGREE.  DATA POINTS IN
C                        U.S. STATE OUTLINES ARE ABOUT .05 DEGREES
C                        APART AND THE COORDINATES ARE ACCURATE TO
C                        .001 DEGREE.  BOTH THE SPACING AND THE
C                        ACCURACY OT THE INTERNATIONAL BOUNDARIES
C                        FALLS SOMEWHERE BETWEEN THESE TWO EXTREMES.
C
C                        THE DICOMED HAS 15-BIT COORDINATE REGISTERS,
C                        BUT AN EFFECTIVE RESOLUTION OF AT MOST 1 IN
C                        4096 IN BOTH X AND Y.
C
C TIMING                 THE MARCH, 1985, UPDATE HAS MADE EZMAP RUN
C                        SIGNIFICANTLY SLOWER.  THIS IS MOSTLY BECAUSE
C                        THE DEFAULT RESOLUTION HAS BEEN INCREASED TO
C                        A VALUE SUITABLE FOR THE DICOMED, RATHER THAN
C                        THE DD80.  USERS WHO ARE CONCERNED ABOUT THIS
C                        MAY INCREASE THE VALUES OF THE PARAMETERS 'MV'
C                        AND/OR 'DD' (SEE THE DESCRIPTION OF MAPSTX)
C                        TO DECREASE THE TIMING (AT THE EXPENSE OF PLOT
C                        QUALITY, OF COURSE).
C
C PORTABILITY            THE CODE IS WRITTEN IN FORTRAN-77 AND SHOULD
C                        BE VERY PORTABLE.  A BINARY DATASET CONTAINING
C                        OUTLINE DATA MUST BE GENERATED AND THE ROUTINE
C                        MAPIO MUST BE MODIFIED TO READ THAT DATASET.
C                        SEE THE IMPLEMENTATION INSTRUCTIONS AT THE
C                        BEGINNING OF THIS FILE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P D R W   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO DRAW THE COMPLETE MAP DESCRIBED BY THE
C                        CURRENT VALUES OF THE EZMAP PARAMETERS.
C
C                        MAPDRW CALLS MAPINT (IF REQUIRED), MAPGRD,
C                        MAPLBL, AND MAPLOT, IN THAT ORDER.  THE USER
C                        MAY WISH TO CALL THESE ROUTINES DIRECTLY.
C
C USAGE                  CALL MAPDRW
C
C ARGUMENTS              NONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P E O S   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                MAPEOS IS CALLED BY EZMAP TO EXAMINE EACH
C                        SEGMENT IN THE OUTLINE DATASETS.  THE DEFAULT
C                        VERSION DOES NOTHING.  A USER-SUPPLIED VERSION
C                        MAY CAUSE SELECTED SEGMENTS TO BE DELETED (TO
C                        REDUCE THE CLUTTER IN NORTHERN CANADA, FOR
C                        EXAMPLE).
C
C USAGE (BY EZMAP)       CALL MAPEOS (NOUT,NSEG,IGID,NPTS,PNTS)
C
C ARGUMENTS              NOUT IS THE NUMBER OF THE OUTLINE DATASET FROM
C                        WHICH THE SEGMENT COMES, AS FOLLOWS:
C
C                          NOUT    DATASET TO WHICH SEGMENT BELONGS.
C                          ----    ------------------------------------
C                            1     'CO' - CONTINENTAL OUTLINES ONLY.
C                            2     'US' - U.S STATE OUTLINES ONLY.
C                            3     'PS' - CONTINENTAL, U.S STATE, AND
C                                  INTERNATIONAL OUTLINES.
C                            4     'PO' - CONTINENTAL AND INTERNATIONAL
C                                  OUTLINES.
C
C                        NSEG IS THE NUMBER OF THE SEGMENT WITHIN THE
C                        OUTLINE DATASET.
C
C                        IGID IDENTIFIES THE GROUP TO WHICH THE SEGMENT
C                        BELONGS, AS FOLLOWS:
C
C                          IGID    GROUP TO WHICH SEGMENT BELONGS.
C                          ----    ------------------------------------
C                            1     CONTINENTAL OUTLINES.
C                            2     U.S. STATE BOUNDARIES.
C                            3     INTERNATIONAL BOUNDARIES.
C
C                        NPTS IS THE NUMBER OF POINTS DEFINING THE
C                        OUTLINE SEGMENT.  NPTS MAY BE ZEROED TO
C                        SUPPRESS PLOTTING OF THE SEGMENT.
C
C                        PNTS IS AN ARRAY OF COORDINATES.  PNTS(1)
C                        AND PNTS(2) ARE THE LATITUDE AND LONGITUDE
C                        OF THE FIRST POINT, PNTS(3) AND PNTS(4) THE
C                        LATITUDE AND LONGITUDE OF THE SECOND POINT, ...
C                        PNTS(2*NPTS-1) AND PNTS(2*NPTS) THE LATITUDE
C                        AND LONGITUDE OF THE LAST POINT.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P F S T   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO DRAW LINES ON THE MAP PRODUCED BY A CALL TO
C                        MAPDRW - USED IN CONJUNCTION WITH MAPVEC.
C
C USAGE                  CALL MAPFST (RLAT,RLON)
C
C                        THIS CALL IS EXACTLY EQUIVALENT TO THE CALL
C
C                          CALL MAPIT (RLAT,RLON,0)
C
C ARGUMENTS              RLAT AND RLON ARE DEFINED AS FOR MAPIT.  SEE
C                        THE DESCRIPTION OF MAPIT.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P G R D   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO DRAW A GRID MADE UP OF LINES OF LATITUDE AND
C                        LONGITUDE.  IF EZMAP NEEDS INITIALIZATION OR IF
C                        THE ERROR FLAG 'ER' IS NON-ZERO, MAPGRD DOES
C                        NOTHING.
C
C USAGE                  CALL MAPGRD
C
C ARGUMENTS              NONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P G T X   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO GET THE VALUES OF EZMAP PARAMETERS.
C
C USAGE                  CALL MAPGTC (WHCH,CVAL)
C                        CALL MAPGTI (WHCH,IVAL)
C                        CALL MAPGTL (WHCH,LVAL)
C                        CALL MAPGTR (WHCH,RVAL)
C
C ARGUMENTS              WHCH IS A CHARACTER STRING SPECIFYING THE
C                        PARAMETER TO GET.
C
C                        CVAL, IVAL, LVAL, OR RVAL IS A VARIABLE TO
C                        RECEIVE THE VALUE OF THE PARAMETER SPECIFIED
C                        BY WHCH - OF TYPE CHARACTER, INTEGER, LOGICAL,
C                        OR REAL, RESPECTIVELY.
C
C                        ALL OF THE PARAMETERS LISTED IN THE DISCUSSION
C                        OF MAPSTX MAY BE RETRIEVED.  THE FOLLOWING MAY
C                        ALSO BE RETRIEVED:
C
C                        WHCH       TYPE  MEANING
C                        ----       ----  -------
C
C                        AREA          C  THE VALUE OF THE MAP LIMITS
C                                         SPECIFIER JLTS FROM THE LAST
C                                         CALL TO MAPSET.  THE DEFAULT
C                                         VALUE IS 'MA'.
C
C                        ERROR         I  THE CURRENT VALUE OF THE ERROR
C                                         FLAG.  DEFAULT IS ZERO.
C
C                        INITIALIZE  I,L  INITIALIZATION FLAG.  IF TRUE
C                                         (NON-ZERO), EZMAP IS IN NEED
C                                         OF INITIALIZATION (BY MEANS OF
C                                         A CALL MAPINT).  THE DEFAULT
C                                         VALUE IS TRUE (NON-ZERO).
C
C                        PROJECTION    C  THE VALUE OF THE PROJECTION
C                                         SPECIFIER JPRJ FROM THE LAST
C                                         CALL TO MAPROJ.  THE DEFAULT
C                                         VALUE IS 'CE'.
C
C                        PN          I,R  THE VALUE OF PLON FROM THE
C                                         LAST CALL TO MAPROJ.  THE
C                                         DEFAULT VALUE IS ZERO.
C
C                        PT          I,R  THE VALUE OF PLAT FROM THE
C                                         LAST CALL TO MAPROJ.  THE
C                                         DEFAULT VALUE IS ZERO.
C
C                        PN          I,R  "N" IS AN INTEGER BETWEEN 1
C                                         AND 8.  RETRIEVES VALUES FROM
C                                         THE LAST CALL TO MAPSET.  P1
C                                         THROUGH P4 GET YOU PLM1(1),
C                                         PLM2(1), PLM3(1), AND PLM4(1),
C                                         WHILE P5 THROUGH P8 GET YOU
C                                         PLM1(2), PLM2(2), PLM3(2), AND
C                                         PLM4(2).  THE DEFAULT VALUES
C                                         ARE ALL ZERO.
C
C                        ROTATION    I,R  THE VALUE OF ROTA FROM THE
C                                         LAST CALL TO MAPROJ.  THE
C                                         DEFAULT VALUE IS ZERO.
C
C                        XLEFT         R  THE PARAMETERS XLOW, XROW,
C                        XRIGHT        R  YBOW, AND YTOW FROM THE LAST
C                        YBOTTOM       R  CALL TO MAPPOS.  DEFAULTS
C                        YTOP          R  ARE .05, .95, .05, AND .95.
C
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P I N T   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO INITIALIZE THE PACKAGE AFTER THE VALUES OF
C                        SOME PARAMETERS HAVE BEEN CHANGED.  THE FLAG
C                        'IN', WHICH MAY BE RETRIEVED BY A CALL TO
C                        MAPGTI OR MAPGTL, INDICATES WHETHER OR NOT
C                        INITIALIZATION IS REQUIRED AT A GIVEN TIME.
C                        (SOME PARAMETERS MAY BE RESET AT ANY TIME AND
C                        DO NOT REQUIRE MAPINT TO BE CALLED AGAIN.)
C
C USAGE                  CALL MAPINT
C
C ARGUMENTS              NONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P I T   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO DRAW LINES ON THE MAP PRODUCED BY A CALL
C                        TO MAPDRW.  MAPIT ATTEMPTS TO OMIT NON-VISIBLE
C                        PORTIONS AND TO HANDLE "CROSS-OVER" - A JUMP
C                        FROM ONE END OF THE MAP TO THE OTHER CAUSED
C                        BY THE PROJECTION'S HAVING SLIT THE GLOBE
C                        ALONG SOME HALF OF A GREAT CIRCLE AND LAID IT
C                        OPEN WITH THE TWO SIDES OF THE SLIT AT OPPOSITE
C                        ENDS OF THE MAP.  CROSS-OVER CAN OCCUR ON
C                        CYLINDRICAL AND CONICAL PROJECTIONS; MAPIT
C                        HANDLES IT VERY WELL ON THE FORMER AND NOT SO
C                        WELL ON THE LATTER.
C
C                        THE EZMAP PARAMETER 'DL' DETERMINES WHETHER
C                        MAPIT DRAWS SOLID LINES OR DOTTED LINES.  THE
C                        PARAMETERS 'DD' AND 'MV' ALSO AFFECT MAPIT'S
C                        BEHAVIOR.  SEE THE DESCRIPTION OF THE ROUTINE
C                        MAPSTX, BELOW.
C
C                        A SEQUENCE OF CALLS TO MAPIT SHOULD BE FOLLOWED
C                        BY A CALL TO MAPIQ (WHICH SEE, ABOVE) TO FLUSH
C                        ITS BUFFERS.
C
C                        POINTS IN TWO CONTIGUOUS PEN-DOWN CALLS TO
C                        MAPIT SHOULD NOT BE FAR APART ON THE GLOBE.
C
C USAGE                  CALL MAPIT (RLAT,RLON,IFST)
C
C ARGUMENTS              RLAT AND RLON ARE THE LATITUDE AND LONGITUDE
C                        OF A POINT TO WHICH THE "PEN" IS TO BE MOVED.
C                        BOTH ARE GIVEN IN DEGREES.  RLAT MUST BE
C                        BETWEEN -90. AND +90., INCLUSIVE; RLON MUST BE
C                        BETWEEN -540. AND +540., INCLUSIVE.
C
C                        IFST IS 0 TO DO A "PEN-UP" MOVE, 1 TO DO A
C                        "PEN-DOWN" MOVE IF THE DISTANCE FROM THE LAST
C                        POINT TO THE NEW POINT IS GREATER THAN 'MV'
C                        PLOTTER UNITS, 2 OR GREATER TO DO THE MOVE
C                        REGARDLESS OF THE DISTANCE FROM THE LAST POINT
C                        TO THE NEW ONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P I Q   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO FLUSH MAPIT'S BUFFERS.  THIS IS PARTICULARLY
C                        IMPORTANT BEFORE A STOP OR A CALL FRAME AND
C                        BEFORE CHANGING INTENSITY, DASH PATTERN, COLOR,
C                        ETC.
C
C USAGE                  CALL MAPIQ
C
C ARGUMENTS              NONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P L B L   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO LABEL THE INTERNATIONAL DATE LINE (ID), THE
C                        EQUATOR (EQ), THE GREENWICH MERIDIAN (GM), AND
C                        THE POLES (NP AND SP), AND TO DRAW THE BORDER
C                        AROUND THE MAP.  IF EZMAP NEEDS INITIALIZATION
C                        OR IF THE ERROR FLAG 'ER' IS SET, MAPLBL DOES
C                        NOTHING.
C
C USAGE                  CALL MAPLBL
C
C ARGUMENTS              NONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P L O T   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO DRAW THE CONTINENTAL AND/OR INTERNATIONAL
C                        AND/OR U.S. STATE OUTLINES SELECTED BY THE
C                        PARAMETER 'OU'.  IF EZMAP CURRENTLY NEEDS
C                        INITIALIZATION OR IF THE ERROR FLAG 'ER' IS
C                        SET, MAPLOT DOES NOTHING.
C
C USAGE                  CALL MAPLOT
C
C ARGUMENTS              NONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P P O S   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO SPECIFY THE POSITION OF THE MAP ON THE
C                        PLOTTER FRAME.
C
C USAGE                  CALL MAPPOS (XLOW,XROW,YBOW,YTOW)
C
C ARGUMENTS              THE ARGUMENTS ARE FRACTIONS BETWEEN 0 AND 1
C                        DETERMINING THE POSITION OF A WINDOW IN THE
C                        PLOTTER FRAME WITHIN WHICH THE MAP IS TO BE
C                        DRAWN.  XLOW AND XROW POSITION THE LEFT AND
C                        RIGHT EDGES AND ARE STATED AS FRACTIONS OF THE
C                        DISTANCE FROM LEFT TO RIGHT IN THE PLOTTER
C                        FRAME.  YBOW AND YTOW POSITION THE BOTTOM AND
C                        TOP EDGES AND ARE STATED AS FRACTIONS OF THE
C                        DISTANCE FROM BOTTOM TO TOP IN THE PLOTTER
C                        FRAME.  THE MAP IS CENTERED IN THE SPECIFIED
C                        WINDOW AND MADE AS LARGE AS POSSIBLE WHILE
C                        MAINTAINING ITS PROPER SHAPE.
C
C                        THE DEFAULT VALUES OF THE INTERNAL PARAMETERS
C                        CHANGED BY THIS ROUTINE ARE .05, .95, .05, AND
C                        .95, RESPECTIVELY.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P R O J   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO SPECIFY THE PROJECTION TO BE USED.
C
C USAGE                  CALL MAPROJ (JPRJ,PLAT,PLON,ROTA)
C
C ARGUMENTS              JPRJ IS A CHARACTER VARIABLE DEFINING THE
C                        DESIRED PROJECTION TYPE, AS FOLLOWS:
C
C                        THE CONIC PROJECTION:
C
C                            'LC' - LAMBERT CONFORMAL CONIC WITH TWO
C                                   STANDARD PARALLELS.
C
C                        THE AZIMUTHAL PROJECTIONS:
C
C                            'ST' - STEREOGRAPHIC.
C
C                            'OR' - ORTHOGRAPHIC.  CAUSES THE PARAMETER
C                                   'SA' (WHICH SEE, IN THE DESCRIPTION
C                                   OF THE ROUTINE MAPSTX) TO BE ZEROED.
C
C                            'LE' - LAMBERT EQUAL AREA.
C
C                            'GN' - GNOMONIC.
C
C                            'AE' - AZIMUTHAL EQUIDISTANT.
C
C                            'SV' - SATELLITE-VIEW.  IF THE PARAMETER
C                                   'SA' (WHICH SEE, IN THE DESCRIPTION
C                                   OF THE ROUTINE MAPSTX) IS GREATER
C                                   THAN 1 OR LESS THAN -1, IT IS LEFT
C                                   ALONE; OTHERWISE, IT IS GIVEN THE
C                                   VALUE 6.631.
C
C                        THE CYLINDRICAL PROJECTIONS:
C
C                            'CE' - CYLINDRICAL EQUIDISTANT.
C
C                            'ME' - MERCATOR.
C
C                            'MO' - MOLLWEIDE.  THE PROJECTION USED IS
C                                   NOT ACTUALLY A TRUE MOLLWEIDE.
C
C                        PLAT, PLON, AND ROTA ARE REALS SPECIFYING THE
C                        VALUES OF ANGULAR QUANTITIES, IN DEGREES.  HOW
C                        THEY ARE USED DEPENDS ON THE VALUE OF JPRJ, AS
C                        FOLLOWS:
C
C                        IF JPRJ IS NOT EQUAL TO 'LC':  PLAT AND PLON
C                        DEFINE THE LATITUDE AND LONGITUDE OF THE POLE
C                        OF THE PROJECTION - THE POINT ON THE GLOBE
C                        WHICH IS TO BE PROJECTED TO THE ORIGIN OF THE
C                        U/V PLANE.  PLAT MUST BE BETWEEN -90. AND +90.,
C                        INCLUSIVE, POSITIVE IN THE NORTHERN HEMISPHERE,
C                        NEGATIVE IN THE SOUTHERN.  PLON MUST BE BETWEEN
C                        -180. AND +180., INCLUSIVE, POSITIVE TO THE
C                        EAST, AND NEGATIVE TO THE WEST, OF GREENWICH.
C                        ROTA IS THE ANGLE BETWEEN THE V AXIS AND NORTH
C                        AT THE ORIGIN.  IT IS TAKEN TO BE POSITIVE IF
C                        THE ANGULAR MOVEMENT FROM NORTH TO THE V AXIS
C                        IS COUNTER-CLOCKWISE, NEGATIVE OTHERWISE.  IF
C                        THE ORIGIN IS AT THE NORTH POLE, "NORTH" IS
C                        CONSIDERED TO BE IN THE DIRECTION OF PLON+180.
C                        IF THE ORIGIN IS AT THE SOUTH POLE, "NORTH" IS
C                        CONSIDERED TO BE IN THE DIRECTION OF PLON.
C                        FOR THE CYLINDRICAL PROJECTIONS, THE AXIS OF
C                        THE PROJECTION IS PARALLEL TO THE V AXIS.
C
C                        IF JPRJ IS EQUAL TO 'LC' (LAMBERT CONFORMAL
C                        CONIC WITH TWO STANDARD PARALLELS):  PLON
C                        DEFINES THE CENTRAL MERIDIAN OF THE PROJECTION,
C                        WHILE PLAT AND ROTA DEFINE THE TWO STANDARD
C                        PARALLELS.  IF PLAT AND ROTA ARE EQUAL, A
C                        CONIC PROJECTION WITH ONE STANDARD PARALLEL
C                        IS USED.
C
C                        MORE DETAILED DESCRIPTIONS OF THE PROJECTIONS
C                        MAY BE FOUND IN THE GRAPHICS MANUAL, TOGETHER
C                        WITH HELPFUL DIAGRAMS, BUT A FEW WORDS MAY BE
C                        HELPFUL HERE:
C
C                        THE CONICAL PROJECTION MAPS THE SURFACE OF THE
C                        EARTH ONTO THE SURFACE OF A CONE INTERSECTING
C                        THE EARTH ALONG THE TWO STANDARD PARALLELS.
C                        THE CONE IS THEN SLIT ALONG A LINE OPPOSITE
C                        THE CENTRAL MERIDIAN AND OPENED UP (WITH SOME
C                        STRETCHING) ONTO A FLAT SURFACE.
C
C                        THE AZIMUTHAL PROJECTIONS MAP THE SURFACE OF
C                        THE EARTH (OR OF ONE HEMISPHERE OF THE EARTH)
C                        ONTO A PLANE WHOSE ORIGIN IS TANGENT TO IT AT
C                        THE POINT (PLAT,PLON).  THE SEVERAL AZIMUTHAL
C                        PROJECTIONS DIFFER ONLY IN THE FUNCTION USED
C                        TO MAP THE GREAT-CIRCLE DISTANCE OF A POINT
C                        FROM THE POLE (PLAT,PLON) TO A LINEAR DISTANCE
C                        OF THE PROJECTED POINT FROM THE ORIGIN (0,0).
C                        THE PROJECTED IMAGE MAY BE ROTATED USING THE
C                        PARAMETER ROTA.
C
C                        THE CYLINDRICAL PROJECTIONS MAP THE SURFACE OF
C                        THE EARTH ONTO A CYLINDER WHICH IS TANGENT TO
C                        IT ALONG A GREAT CIRCLE PASSING THROUGH THE
C                        POINT (PLAT,PLON) AT AN ANGLE DETERMINED BY
C                        ROTA.  THE CYLINDER IS THEN SLIT ALONG ITS
C                        LENGTH THROUGH THE POINT OPPOSITE (PLAT,PLON)
C                        AND OPENED UP ONTO THE PLANE.  THE SEVERAL
C                        CYLINDRICAL PROJECTIONS DIFFER PRINCIPALLY IN
C                        THE FUNCTION USED TO MAP THE DISTANCE FROM THE
C                        GREAT CIRCLE OF TANGENCY TO A DISTANCE ALONG
C                        THE CYLINDER.  IF PLAT IS ZERO AND ROTA IS
C                        EITHER 0. OR 180., THE CYLINDRICAL PROJECTIONS
C                        ARE PARTICULARLY SIMPLE TO DO AND A FASTER PATH
C                        THROUGH THE CODE IS USED.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P R S   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                RECALLS SET.  INTENDED TO BE USED WHEN DATA
C                        IS TO BE PLOTTED OVER A MAP GENERATED IN A
C                        DIFFERENT OVERLAY (E.G., USING A FLASH BUFFER),
C                        AND WHEN THE SYSTEM PLOT PACKAGE DOES NOT
C                        RESIDE IN AN OUTER OVERLAY.
C
C USAGE                  CALL MAPRS
C
C ARGUMENTS              NONE.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P R S T   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                RESTORES A SAVED STATE OF EZMAP.  THIS IS DONE
C                        BY READING SAVED PARAMETER VALUES FROM A USER
C                        UNIT AND THEN CALLING MAPINT.  SEE MAPSAV.
C
C USAGE                  CALL MAPRST (IFNO)
C
C ARGUMENTS              IFNO IS THE NUMBER OF A UNIT FROM WHICH A
C                        SINGLE UNFORMATTED RECORD IS TO BE READ.  IT
C                        IS THE USER'S RESPONSIBILITY TO POSITION THIS
C                        UNIT.  MAPRST DOES NOT REWIND IT, EITHER BEFORE
C                        OR AFTER READING THE RECORD.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P S A V   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                SAVES THE CURRENT STATE OF EZMAP BY WRITING
C                        PARAMETER VALUES ONTO A USER UNIT.  SEE MAPRST.
C
C USAGE                  CALL MAPSAV (IFNO)
C
C ARGUMENTS              IFNO IS THE NUMBER OF A UNIT TO WHICH A SINGLE
C                        UNFORMATTED RECORD IS TO BE WRITTEN.  IT IS THE
C                        USER'S RESPONSIBILITY TO POSITION THIS UNIT.
C                        MAPSAV DOES NOT REWIND IT, EITHER BEFORE OR
C                        AFTER WRITING THE RECORD.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P S E T   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO SPECIFY THE RECTANGULAR PORTION OF THE U/V
C                        PLANE TO BE DRAWN.
C
C USAGE                  CALL MAPSET (JLTS,PLM1,PLM2,PLM3,PLM4)
C
C ARGUMENTS              JLTS CAN HAVE THE FOLLOWING CHARACTER VALUES.
C                        IT SPECIFIES ONE OF FIVE WAYS IN WHICH THE
C                        LIMITS OF THE MAP ARE DEFINED BY THE PARAMETERS
C                        PLM1, PLM2, PLM3, AND PLM4.
C
C                        JLTS='MA' (MAXIMUM).  THE MAXIMUM USEFUL AREA
C                        PRODUCED BY THE PROJECTION IS PLOTTED.  PLM1,
C                        PLM2, PLM3, AND PLM4 ARE NOT USED.
C
C                        JLTS='CO' (CORNERS).  THE POINTS (PLM1,PLM2)
C                        AND (PLM3,PLM4) ARE TO BE AT OPPOSITE CORNERS
C                        OF THE MAP.  PLM1 AND PLM3 ARE LATITUDES, IN
C                        DEGREES.  PLM2 AND PLM4 ARE LONGITUDES, IN
C                        DEGREES.  IF A CYLINDRICAL PROJECTION IS BEING
C                        USED, THE FIRST POINT SHOULD BE ON THE LEFT
C                        EDGE OF THE MAP AND THE SECOND POINT ON THE
C                        RIGHT EDGE; OTHERWISE, THE ORDER MAKES NO
C                        DIFFERENCE.
C
C                        JLTS='PO' (POINTS).  PLM1, PLM2, PLM3, AND PLM4
C                        ARE TWO-ELEMENT ARRAYS GIVING THE LATITUDES
C                        AND LONGITUDES, IN DEGREES, OF FOUR POINTS
C                        WHICH ARE TO BE ON THE EDGES OF THE RECTANGULAR
C                        MAP.  IF A CYLINDRICAL PROJECTION IS BEING
C                        USED, THE FIRST POINT SHOULD BE ON THE LEFT
C                        EDGE AND THE SECOND POINT ON THE RIGHT EDGE;
C                        OTHERWISE, THE ORDER MAKES NO DIFFERENCE.
C                        NOTE THAT THE CALLING PROGRAM SHOULD INCLUDE
C                        THE FOLLOWING STATEMENT:
C
C                          DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C                        (IN FACT, STRICT ADHERENCE TO THE FORTRAN-77
C                        STANDARD REQUIRES THIS, NO MATTER WHAT THE
C                        VALUE OF JLTS.)
C
C                        JLTS='AN' (ANGLES).  PLM1, PLM2, PLM3, AND PLM4
C                        ARE POSITIVE ANGLES, IN DEGREES, REPRESENTING
C                        ANGULAR DISTANCES FROM A POINT ON THE MAP TO
C                        THE LEFT, RIGHT, BOTTOM, AND TOP EDGES OF THE
C                        MAP.  FOR MOST PROJECTIONS, THESE ANGLES ARE
C                        MEASURED WITH THE CENTER OF THE EARTH AT THE
C                        VERTEX AND REPRESENT ANGULAR DISTANCES FROM THE
C                        POINT WHICH PROJECTS TO THE ORIGIN OF THE U/V
C                        PLANE; ON A SATELLITE-VIEW PROJECTION, THEY ARE
C                        MEASURED WITH THE SATELLITE AT THE VERTEX AND
C                        REPRESENT ANGULAR DEVIATIONS FROM THE LINE OF
C                        SIGHT.  ANGULAR LIMITS ARE PARTICULARLY USEFUL
C                        FOR POLAR PROJECTIONS AND THE SATELLITE-VIEW
C                        PROJECTION; THEY ARE NOT APPROPRIATE FOR THE
C                        LAMBERT CONFORMAL CONIC AND AN ERROR WILL
C                        RESULT IF ONE ATTEMPTS TO USE JLTS='AN' WITH
C                        JPRJ='LC'.
C
C                        JLTS='LI' (LIMITS).  PLM1, PLM2, PLM3, AND PLM4
C                        SPECIFY THE MINIMUM VALUE OF U, THE MAXIMUM
C                        VALUE OF U, THE MINIMUM VALUE OF V, AND THE
C                        MAXIMUM VALUE OF V, RESPECTIVELY.  KNOWLEDGE
C                        OF THE PROJECTION EQUATIONS IS NECESSARY IN
C                        ORDER TO USE THIS OPTION CORRECTLY.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P S T X   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO SET THE VALUES OF EZMAP PARAMETERS.
C
C USAGE                  CALL MAPSTC (WHCH,CVAL)
C                        CALL MAPSTI (WHCH,IVAL)
C                        CALL MAPSTL (WHCH,LVAL)
C                        CALL MAPSTR (WHCH,RVAL)
C
C ARGUMENTS              WHCH IS A CHARACTER STRING SPECIFYING THE
C                        PARAMETER TO BE SET.
C
C                        CVAL, IVAL, LVAL, OR RVAL IS THE VALUE TO BE
C                        GIVEN TO THE PARAMETER SPECIFIED BY WHCH - OF
C                        TYPE CHARACTER, INTEGER, LOGICAL, OR REAL,
C                        RESPECTIVELY.
C
C                        SOME PARAMETERS MAY BE SET IN MORE THAN ONE
C                        WAY.  FOR EXAMPLE, THE PARAMETER 'GR' (GRID),
C                        WHICH SPECIFIES THE GRID SPACING, MAY BE GIVEN
C                        THE VALUE 10.0 IN EITHER OF TWO WAYS:
C
C                          CALL MAPSTI ('GR',10)
C                          CALL MAPSTR ('GR',10.)
C
C                        THE FLAG WHICH CONTROLS DOTTING OF OUTLINES
C                        MAY BE TURNED ON USING EITHER OF THESE CALLS:
C
C                          CALL MAPSTI ('DO',1)
C                          CALL MAPSTL ('DO',.TRUE.)
C
C                        THE IMPORTANT POINT TO REMEMBER IS THAT THE
C                        LAST CHARACTER OF THE ROUTINE NAME IMPLIES
C                        THE TYPE OF THE ARGUMENT.
C
C                        ONLY THE FIRST TWO CHARACTERS OF WHCH ARE
C                        EXAMINED.  FOR THE SAKE OF CODE READABILITY,
C                        A LONGER CHARACTER STRING MAY BE USED.
C
C                        BELOW IS A LIST OF ALL THE PARAMETERS WHICH
C                        MAY BE SET USING THESE ROUTINES.
C
C                        WHCH       TYPE  MEANING
C                        ----       ----  -------
C
C                        DASHPATTERN   I  DASHED-LINE PATTERN FOR THE
C                                         GRIDS.  A 16-BIT QUANTITY.
C                                         DEFAULT IS 21845 (OCTAL 52525
C                                         OR BINARY 0101010101010101).
C
C                        DD          I,R  DISTANCE BETWEEN DOTS ALONG A
C                                         DOTTED LINE DRAWN BY MAPIT.
C                                         THE DEFAULT VALUE IS 12 (OUT
C                                         OF 4096; SEE 'RE', BELOW).
C
C                        DL          I,L  IF TRUE (NON-ZERO), USER CALLS
C                                         TO MAPIT DRAW DOTTED LINES.
C                                         DEFAULT IS FALSE (ZERO); LINES
C                                         DRAWN BY MAPIT ARE SOLID OR
C                                         DASHED, DEPENDING ON THE
C                                         CURRENT STATE OF THE DASHCHAR
C                                         PACKAGE.
C
C                        DOT         I,L  IF TRUE (NON-ZERO), OUTLINES
C                                         ARE DOTTED.  DEFAULT IS FALSE
C                                         (ZERO); OUTLINES ARE SOLID.
C
C                        ELLIPTICAL  I,L  IF TRUE (NON-ZERO), ONLY THAT
C                                         PART OF THE MAP WHICH FALLS
C                                         INSIDE AN ELLIPSE INSCRIBED
C                                         WITHIN THE NORMAL RECTANGULAR
C                                         PERIMETER IS DRAWN.  THIS IS
C                                         PARTICULARLY APPROPRIATE FOR
C                                         USE WITH AZIMUTHAL PROJECTIONS
C                                         AND ANGULAR LIMITS SPECIFYING
C                                         A SQUARE, IN WHICH CASE THE
C                                         ELLIPSE BECOMES A CIRCLE, BUT
C                                         IT WILL WORK FOR ANY MAP.  THE
C                                         DEFAULT VALUE IS ZERO.
C
C                        GD            R  THE DISTANCE BETWEEN POINTS
C                                         USED TO DRAW THE GRID, IN
C                                         DEGREES.  THE DEFAULT VALUE
C                                         IS 1.; USER VALUES MUST FALL
C                                         BETWEEN .001 AND 10.
C
C                        GRID        I,R  THE DESIRED GRID SPACING.  A
C                                         ZERO SUPPRESSES THE GRID.  THE
C                                         DEFAULT IS 10 DEGREES.
C
C                        IN            I  "N" IS AN INTEGER BETWEEN 1
C                                         AND 7.  EACH "IN" SPECIFIES
C                                         THE INTENSITY OF SOME PORTION
C                                         OF THE MAP.  VALUES ARE IN THE
C                                         RANGE 0-255.  DEFAULTS ARE:
C
C                                           N   USE           DEFAULT
C                                           -   -----------   -------
C                                           1   PERIMETER        240
C                                           2   GRID             150
C                                           3   LABELS           210
C                                           4   LIMBS            240
C                                           5   CONTINENTS       240
C                                           6   U.S. STATES      180
C                                           7   COUNTRIES        210
C
C                        LABEL       I,L  IF TRUE (NON-ZERO), LABEL THE
C                                         MERIDIANS AND POLES.  DEFAULT
C                                         IS TRUE (NON-ZERO).
C
C                        LS            I  CONTROLS LABEL SIZE.  A
C                                         CHARACTER WIDTH, TO BE USED
C                                         IN CALLING PWRIT.  THE DEFAULT
C                                         VALUE IS 1, WHICH GIVES A
C                                         CHARACTER WIDTH OF 12 PLOTTER
C                                         UNITS.
C
C                        MV          I,R  MINIMUM VECTOR LENGTH FOR
C                                         OUTLINES.  A POINT CLOSER TO
C                                         THE PREVIOUS POINT THAN THIS
C                                         IS OMITTED.  DEFAULT VALUE IS
C                                         4 (OUT OF 4096; SEE 'RE',
C                                         BELOW).
C
C                        OUTLINE       C  SAYS WHICH SET OF OUTLINE DATA
C                                         TO USE.  POSSIBLE VALUES ARE
C                                         'NO', FOR NO OUTLINES, 'CO',
C                                         FOR THE CONTINENTAL OUTLINES
C                                         (THE DEFAULT), 'US', FOR U.S.
C                                         STATE OUTLINES, 'PS', FOR
C                                         CONTINENTAL OUTLINES PLUS
C                                         INTERNATIONAL OUTLINES PLUS
C                                         U.S. STATE OUTLINES, AND 'PO',
C                                         FOR CONTINENTAL OUTLINES PLUS
C                                         INTERNATIONAL OUTLINES.
C                                         DEFAULT IS 'CO'.
C
C                        PERIM       I,L  IF TRUE (NON-ZERO), DRAW THE
C                                         PERIMETER.  DEFAULT IS TRUE
C                                         (NON-ZERO).
C
C                        RESOLUTION  I,R  THE WIDTH OF THE TARGET
C                                         PLOTTER, IN PLOTTER UNITS.
C                                         DEFAULT VALUE IS 4096.
C
C                        SATELLITE   I,R  IF LESS THAN -1 OR GREATER
C                                         THAN 1, CHANGES ORTHOGRAPHIC
C                                         PROJECTION TO SATELLITE-VIEW.
C                                         ABSOLUTE VALUE IS THE DISTANCE
C                                         OF SATELLITE FROM THE CENTER
C                                         OF THE EARTH, IN MULTIPLES OF
C                                         THE EARTH'S RADIUS.  THE SIGN
C                                         INDICATES WHETHER A NORMAL
C                                         PROJECTION (POSITIVE) OR AN
C                                         EXTENDED PROJECTION (NEGATIVE)
C                                         IS TO BE USED.  THE EXTENDED
C                                         PROJECTION IS USEFUL WHEN ONE
C                                         IS OVERLAYING CONREC OUTPUT ON
C                                         A MAP.  THE DEFAULT VALUE OF
C                                         'SA' IS ZERO.  SEE ALSO 'S1'
C                                         AND 'S2', BELOW.
C
C                        S1 AND S2   I,R  USED ONLY WHEN 'SA' IS OUTSIDE
C                                         [-1,1].  BOTH ARE ANGLES, IN
C                                         DEGREES.  'S1' MEASURES THE
C                                         ANGLE BETWEEN THE CENTER OF
C                                         THE EARTH AND THE AIM POINT
C                                         OF THE SATELLITE'S CAMERA, AS
C                                         SEEN FROM THE SATELLITE.  IF
C                                         'S1' IS ZERO, THE PROJECTION
C                                         SHOWS THE EARTH AS SEEN BY A
C                                         SATELLITE LOOKING STRAIGHT
C                                         DOWN; CALL THIS THE "BASIC
C                                         VIEW".  IF 'S1' IS NON-ZERO,
C                                         'S2' MEASURES THE ANGLE FROM
C                                         THE POSITIVE U AXIS OF THE
C                                         BASIC VIEW TO THE LINE OP,
C                                         WHERE O IS THE ORIGIN OF THE
C                                         BASIC VIEW AND P IS THE
C                                         PROJECTION OF THE DESIRED LINE
C                                         OF SIGHT ON THE BASIC VIEW,
C                                         POSITIVE IF MEASURED COUNTER-
C                                         CLOCKWISE.
C
C                        SR            R  A SEARCH RADIUS, IN DEGREES.
C                                         USED BY MAPINT IN FINDING THE
C                                         LATITUDE/LONGITUDE RANGE OF
C                                         THE MAP.  THE DEFAULT VALUE
C                                         IS 1.; USER VALUES MUST FALL
C                                         BETWEEN .001 AND 10.  THIS
C                                         PARAMETER SHOULD PROBABLY NOT
C                                         BE CHANGED EXCEPT BY ADVICE
C                                         OF A KNOWLEDGEABLE CONSULTANT.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P T R N   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO FIND THE PROJECTION IN THE U/V PLANE OF A
C                        POINT WHOSE LATITUDE AND LONGITUDE ARE KNOWN.
C                        MAY BE CALLED AT ANY TIME AFTER EZMAP HAS BEEN
C                        INITIALIZED (BY CALLING MAPINT OR OTHERWISE).
C
C USAGE                  CALL MAPTRN (RLAT,RLON,UVAL,VVAL)
C
C ARGUMENTS              RLAT AND RLON ARE THE LATITUDE AND LONGITUDE,
C                        RESPECTIVELY, OF A POINT ON THE GLOBE.  RLAT
C                        MUST BE BETWEEN -90. AND +90., INCLUSIVE; RLON
C                        MUST BE BETWEEN -540. AND +540., INCLUSIVE.
C
C                        (UVAL,VVAL) IS THE PROJECTION IN THE U/V PLANE
C                        OF (RLAT,RLON).  THE UNITS OF UVAL AND VVAL
C                        DEPEND ON THE PROJECTION.
C
C                        IF THE POINT IS NOT PROJECTABLE, UVAL IS
C                        RETURNED EQUAL TO 1.E12.  NOTE THAT, IF
C                        THE POINT IS PROJECTABLE, BUT OUTSIDE THE
C                        BOUNDARY OF THE MAP, AS DEFINED BY THE LAST
C                        CALL TO MAPSET, ITS U AND V COORDINATES ARE
C                        STILL RETURNED BY MAPTRN.  THE USER MUST DO
C                        THE TEST REQUIRED TO DETERMINE IF THE POINT
C                        IS WITHIN LIMITS, IF THAT IS NECESSARY.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P U S R   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                THE ROUTINE MAPUSR IS CALLED BY EZMAP JUST
C                        BEFORE AND JUST AFTER PORTIONS OF THE MAP
C                        ARE DRAWN.  THE DEFAULT VERSION DOES NOTHING.
C                        (ACTUALLY, THAT'S NOT QUITE TRUE; FOR THE SAKE
C                        OF EFFICIENCY, THE NON-GKS VERSIONS RESETS THE
C                        DASH PATTERN FOR GRID LINES TO "SOLID" AND
C                        THEN DOES AN OPTN CALL TO MAKE THE TRANSLATOR
C                        GENERATE THE DESIRED PATTERN.)  A USER-SUPPLIED
C                        VERSION MAY SET/RESET THE DOTTING PARAMETER
C                        'DL', THE DASHCHAR DASH PATTERN, THE INTENSITY,
C                        THE COLOR, ETC., SO AS TO ACHIEVE A DESIRED
C                        EFFECT.
C
C USAGE (BY EZMAP)       CALL MAPUSR (IPRT)
C
C ARGUMENTS              IPRT, IF POSITIVE, SAYS THAT A PARTICULAR PART
C                        OF THE MAP IS ABOUT TO BE DRAWN, AS FOLLOWS:
C
C                          IPRT  PART
C                          ----  -----------------------
C                            1   PERIMETER.
C                            2   GRID.
C                            3   LABELS.
C                            4   LIMB LINES.
C                            5   CONTINENTAL OUTLINES.
C                            6   U.S. STATE OUTLINES.
C                            7   INTERNATIONAL OUTLINES.
C
C                        IF IPRT IS NEGATIVE, IT SAYS THAT DRAWING OF
C                        THE LAST PART IS COMPLETE.  THE ABSOLUTE VALUE
C                        OF IPRT WILL BE ONE OF THE ABOVE VALUES.
C                        CHANGED QUANTITIES SHOULD BE RESTORED.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   M A P V E C   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO DRAW LINES ON THE MAP PRODUCED BY A CALL TO
C                        MAPDRW - USED IN CONJUNCTION WITH MAPFST.
C
C USAGE                  CALL MAPVEC (RLAT,RLON)
C
C                        THIS CALL IS EXACTLY EQUIVALENT TO THE CALL
C
C                          CALL MAPIT (RLAT,RLON,1)
C
C ARGUMENTS              RLAT AND RLON ARE DEFINED AS FOR MAPIT.  SEE
C                        THE DESCRIPTION OF MAPIT.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   S U P C O N   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                TO FIND THE PROJECTION IN THE U/V PLANE OF A
C                        POINT WHOSE LATITUDE AND LONGITUDE ARE KNOWN.
C                        THIS ROUTINE IS PROVIDED FOR COMPATIBILITY
C                        WITH EARLIER VERSIONS OF THE PACKAGE.  IF
C                        EFFICIENCY IS A CONSIDERATION, THE USER SHOULD
C                        BY-PASS THIS ROUTINE AND CALL MAPTRN DIRECTLY.
C
C USAGE                  CALL SUPCON (RLAT,RLON,UVAL,VVAL)
C
C                        THIS CALL IS EXACTLY EQUIVALENT TO THE CALL
C
C                          CALL MAPTRN (RLAT,RLON,UVAL,VVAL)
C
C ARGUMENTS              RLAT, RLON, UVAL, AND VVAL ARE DEFINED AS FOR
C                        THE ROUTINE MAPTRN.  SEE THE DESCRIPTION OF
C                        MAPTRN.
C
C-----------------------------------------------------------------------
C S U B R O U T I N E   S U P M A P   -   D E S C R I P T I O N
C-----------------------------------------------------------------------
C
C PURPOSE                AN IMPLEMENTATION OF THE ROUTINE FROM WHICH
C                        EZMAP GREW.  A SINGLE CALL TO SUPMAP CREATES
C                        A MAP OF A DESIRED PORTION OF THE GLOBE,
C                        ACCORDING TO A DESIRED PROJECTION, WITH DESIRED
C                        OUTLINES DRAWN IN, AND WITH LINES OF LATITUDE
C                        AND LONGITUDE AT DESIRED INTERVALS.  AN
C                        APPROPRIATE CALL TO THE ROUTINE SET IS
C                        PERFORMED, AND THE ROUTINE SUPCON (WHICH SEE)
C                        IS INITIALIZED SO THAT THE USER MAY MAP POINTS
C                        OF KNOWN LATITUDE AND LONGITUDE TO POINTS IN
C                        THE U/V PLANE AND USE THE U/V COORDINATES TO
C                        DRAW OBJECTS ON THE MAP PRODUCED BY SUPMAP.
C
C USAGE                  CALL SUPMAP (JPRJ,PLAT,PLON,ROTA,PLM1,PLM2,
C                                     PLM3,PLM4,JLTS,JGRD,IOUT,IDOT,
C                                     IERR)
C
C ARGUMENTS              IABS(JPRJ) DEFINES THE PROJECTION TYPE, AS
C                        FOLLOWS (VALUES LESS THAN 1 OR GREATER THAN
C                        10 ARE TREATED AS 1 OR 10, RESPECTIVELY):
C
C                           1  STEREOGRAPHIC.
C                           2  ORTHOGRAPHIC.
C                           3  LAMBERT CONFORMAL CONIC.
C                           4  LAMBERT EQUAL AREA.
C                           5  GNOMONIC.
C                           6  AZIMUTHAL EQUIDISTANT.
C                           7  SATELLITE VIEW.
C                           8  CYLINDRICAL EQUIDISTANT.
C                           9  MERCATOR.
C                          10  MOLLWEIDE.
C
C                        USING THE VALUE 2 CAUSES THE PARAMETER 'SA' TO
C                        BE ZEROED.  USING THE VALUE 7 CAUSES 'SA' TO
C                        BE EXAMINED.  IF IT HAS A NON-ZERO VALUE, THE
C                        VALUE IS LEFT ALONE.  IF IT HAS A ZERO VALUE,
C                        ITS VALUE IS RESET TO 6.631, WHICH IS ABOUT
C                        RIGHT FOR A SATELLITE IN A GEOSYNCHRONOUS
C                        EQUATORIAL ORBIT (FOR WHATEVER THAT'S WORTH).
C
C                        THE SIGN OF JPRJ, WHEN IOUT IS -1, 0, OR 1,
C                        INDICATES WHETHER THE CONTINENTAL OUTLINES ARE
C                        TO BE PLOTTED OR NOT.  SEE IOUT, BELOW.
C
C                        PLAT, PLON, AND ROTA DEFINE THE ORIGIN OF THE
C                        PROJECTION AND ITS ROTATION ANGLE AND ARE USED
C                        IN THE SAME WAY AS THEY WOULD BE IN A CALL TO
C                        THE ROUTINE MAPROJ (WHICH SEE).
C
C                        JLTS, PLM1, PLM2, PLM3, AND PLM4 SPECIFY THE
C                        RECTANGULAR LIMITS OF THE MAP.  THESE ARGUMENTS
C                        ARE USED IN THE SAME WAY AS THEY WOULD BE IN
C                        A CALL TO MAPSET (WHICH SEE), EXCEPT THAT JLTS
C                        IS AN INTEGER INSTEAD OF A CHARACTER STRING.
C                        IABS(JLTS) MAY TAKE ON THE VALUES 1 THROUGH 5,
C                        AS FOLLOWS:
C
C                          1  LIKE JLTS='MA' IN A CALL TO MAPSET.
C                          2  LIKE JLTS='CO' IN A CALL TO MAPSET.
C                          3  LIKE JLTS='LI' IN A CALL TO MAPSET.
C                          4  LIKE JLTS='AN' IN A CALL TO MAPSET.
C                          5  LIKE JLTS='PO' IN A CALL TO MAPSET.
C
C                        AT ONE TIME, THE SIGN OF JLTS SPECIFIED WHETHER
C                        OR NOT A LINE OF TEXT WAS TO BE WRITTEN AT THE
C                        BOTTOM OF THE PLOT PRODUCED.  THIS LINE MAY NO
C                        LONGER BE WRITTEN AND THE SIGN OF JLTS IS
C                        THEREFORE IGNORED.
C
C                        MOD(IABS(JGRD),1000) IS THE VALUE, IN DEGREES,
C                        OF THE INTERVAL AT WHICH LINES OF LATITUDE AND
C                        LONGITUDE ARE TO BE PLOTTED.  IF THE GIVEN
C                        INTERVAL IS ZERO, GRID LINES AND LABELS ARE
C                        NOT PLOTTED.  IF JGRD IS LESS THAN ZERO, THE
C                        PERIMETER IS NOT PLOTTED.  SET JGRD TO -1000 TO
C                        SUPPRESS BOTH GRID LINES AND PERIMETER AND TO
C                        +1000 TO SUPPRESS THE GRID LINES, BUT LEAVE THE
C                        PERIMETER.  THE VALUE -0 MAY HAVE A MEANING ON
C                        ONES' COMPLEMENT MACHINES, BUT SHOULD BE
C                        AVOIDED; USE -1000 INSTEAD.
C
C                        IF IOUT HAS THE VALUE 0, U.S. STATE OUTLINES
C                        ARE OMITTED.  IF IT HAS THE ABSOLUTE VALUE 1,
C                        THEY ARE PLOTTED.  IN BOTH OF THESE CASES, THE
C                        SIGN OF JPRJ INDICATES WHETHER CONTINENTAL
C                        OUTLINES ARE TO BE PLOTTED (JPRJ POSITIVE)
C                        OR NOT (JPRJ NEGATIVE).  ORIGINALLY, SUPMAP
C                        RECOGNIZED ONLY THESE VALUES OF IOUT; NOW, IF
C                        IOUT IS LESS THAN -1 OR GREATER THAN 1, THE
C                        SIGN OF JPRJ IS IGNORED, AND IOUT SELECTS AN
C                        OUTLINE GROUP, AS FOLLOWS:
C
C                          -2 OR LESS     'NO' (NO OUTLINES).
C                           2             'CO' (CONTINENTAL OUTLINES).
C                           3             'US' (U.S. STATE OUTLINES).
C                           4             'PS' (CONTINENTAL OUTLINES
C                                               PLUS INTERNATIONAL
C                                               OUTLINES PLUS U.S.
C                                               STATE OUTLINES).
C                           5 OR GREATER  'PO' (CONTINENTAL OUTLINES
C                                               PLUS INTERNATIONAL
C                                               OUTLINES, BUT NO U.S.
C                                               STATE OUTLINES).
C
C                        AT ONE TIME, THE SIGN OF IOUT SPECIFIED WHETHER
C                        OR NOT A LINE OF TEXT WAS TO BE WRITTEN ON THE
C                        PRINT OUTPUT.  THIS MAY NO LONGER BE DONE.
C
C                        IDOT=0 TO GET CONTINUOUS OUTLINES, 1 TO GET
C                        DOTTED OUTLINES.
C
C                        IERR IS AN OUTPUT PARAMETER.  A NON-ZERO VALUE
C                        INDICATES THAT AN ERROR HAS OCCURRED.
C
C***********************************************************************
C T H E   C O D E   -   U S E R - L E V E L   R O U T I N E S
C***********************************************************************
C
      SUBROUTINE MAPDRW
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPDRW','VERSION  1')
C
C INITIALIZE THE PACKAGE, DRAW AND LABEL THE GRID, AND DRAW OUTLINES.
C
      IF (INTF) CALL MAPINT
      CALL MAPGRD
      CALL MAPLBL
      CALL MAPLOT
C
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPEOS (NOUT,NSEG,IGID,NPTS,PNTS)
      DIMENSION PNTS(*)
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPFST (XLAT,XLON)
      CALL MAPIT (XLAT,XLON,0)
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPGRD
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM1/ IPRJ,SINO,COSO,SINR,COSR,PHOC
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMB/ IIER
C
C DEFINE LOCAL LOGICAL FLAGS.
C
      LOGICAL IMF,IPF
C
C DEFINE REQUIRED CONSTANTS.
C
      DATA DTOR / .017453292519943 /
C
C THE ARITHMETIC STATEMENT FUNCTIONS FLOOR AND CLING GIVE, RESPECTIVELY,
C THE "FLOOR" OF X - THE LARGEST INTEGER LESS THAN OR EQUAL TO X - AND
C THE "CEILING" OF X - THE SMALLEST INTEGER GREATER THAN OR EQUAL TO X.
C
      FLOOR(X)=AINT(X+1.E4)-1.E4
      CLING(X)=-FLOOR(-X)
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPGRD','VERSION  1')
C
C IF EZMAP NEEDS INITIALIZATION OR IF AN ERROR HAS OCCURRED SINCE THE
C LAST INITIALIZATION, DO NOTHING.
C
      IF (INTF) RETURN
      IF (IIER.NE.0) RETURN
C
C IF THE GRID IS SUPPRESSED, DO NOTHING.
C
      IF (GRID.LE.0.) RETURN
C
C RESET THE INTENSITY, DOTTING, AND DASH PATTERN FOR THE GRID.
C
      CALL MAPCHI (2,0,IDSH)
C
C SET THE FLAGS IMF AND IPF, WHICH ARE TRUE IF AND ONLY IF MERIDIANS AND
C PARALLELS, RESPECTIVELY, ARE STRAIGHT LINES AND IT IS "SAFE" TO DRAW
C THEM USING LONG LINE SEGMENTS.  WHAT WE HAVE TO BE SURE OF IS THAT AT
C LEAST ONE OF THE TWO ENDPOINTS OF EACH MERIDIAN, OR ITS MIDPOINT, WILL
C BE VISIBLE.  (IF TWO POINTS ARE INVISIBLE, MAPIT DRAWS NOTHING, EVEN
C THOUGH THE LINE JOINING THEM MAY BE VISIBLE ALONG PART OF ITS LENGTH.)
C
      IF (IPRJ.GE.1.AND.IPRJ.LE.6) THEN
        IF (ELPF) THEN
          IMF=(UCEN/URNG)**2+(VCEN/VRNG)**2.LT.1.
        ELSE
          IMF=UMIN*UMAX.LT.0..AND.VMIN*VMAX.LT.0.
        END IF
        IF (IPRJ.NE.1) IMF=IMF.AND.ABS(PHIA).GE.89.9999
      ELSE IF (IPRJ.EQ.10) THEN
        IMF=.TRUE.
      ELSE IF (IPRJ.EQ.11.AND.(.75*(VMAX-VMIN)).LE.VEPS) THEN
        IMF=.TRUE.
      ELSE
        IMF=.FALSE.
      END IF
C
      IPF=IPRJ.EQ.10.OR.IPRJ.EQ.11.OR.(IPRJ.EQ.12.AND.ILTS.EQ.1)
C
C TRANSFER THE LATITUDE/LONGITUDE LIMITS COMPUTED BY MAPINT TO LOCAL,
C MODIFIABLE VARIABLES.
C
      SLAT=SLAM
      BLAT=BLAM
      SLON=SLOM
      BLON=BLOM
C
C FOR CERTAIN AZIMUTHAL PROJECTIONS CENTERED AT A POLE, THE LATITUDE
C LIMIT FURTHEST FROM THE POLE NEEDS ADJUSTMENT TO MAKE IT PROJECTABLE
C AND VISIBLE.  OTHERWISE, WE HAVE TROUBLE WITH PORTIONS OF MERIDIANS
C DISAPPEARING.
C
      IF (IPRJ.EQ.3.OR.IPRJ.EQ.4.OR.IPRJ.EQ.6) THEN
        IF (PHIA.GT.+89.9999) THEN
          SLAT=SLAT+SRCH
          IF (IPRJ.EQ.3) SLAT=SLAT+SRCH
        END IF
        IF (PHIA.LT.-89.9999) THEN
          BLAT=BLAT-SRCH
          IF (IPRJ.EQ.3) BLAT=BLAT-SRCH
        END IF
      END IF
C
C RLON IS THE SMALLEST LONGITUDE FOR WHICH A MERIDIAN IS TO BE DRAWN,
C XLON THE BIGGEST.  AVOID DRAWING A GIVEN MERIDIAN TWICE.
C
      RLON=GRID*FLOOR(SLON/GRID)
      XLON=GRID*CLING(BLON/GRID)
      IF (XLON-RLON.GT.359.9999) THEN
        IF (IPRJ.EQ.1) THEN
          RLON=GRID*CLING((PHIO-179.9999)/GRID)
          XLON=GRID*FLOOR((PHIO+179.9999)/GRID)
        ELSE IF (IPRJ.GE.2.AND.IPRJ.LE.9) THEN
          XLON=XLON-GRID
          IF (XLON-RLON.GT.359.9999) XLON=XLON-GRID
        END IF
      END IF
C
C OLAT IS THE LATITUDE AT WHICH MERIDIANS WHICH ARE NOT MULTIPLES OF 90
C ARE TO STOP.  (EXCEPT ON CERTAIN FAST-PATH CYLINDRICAL PROJECTIONS,
C ONLY THE MERIDIANS AT LONGITUDES WHICH ARE MULTIPLES OF 90 RUN ALL
C THE WAY TO THE POLES.  THIS AVOIDS A LOT OF CLUTTER.)
C
      IF (IPRJ.EQ.10.OR.IPRJ.EQ.11) THEN
        OLAT=90.
      ELSE
        OLAT=GRID*FLOOR(89.9999/GRID)
      END IF
C
C DRAW THE MERIDIANS.
C
      RLON=RLON-GRID
  101 RLON=RLON+GRID
      XLAT=OLAT
      IF (AMOD(RLON,90.).EQ.0.) XLAT=90.
      RLAT=AMAX1(SLAT,-XLAT)
      XLAT=AMIN1(BLAT,XLAT)
      IF (IMF) THEN
        DLAT=.5*(XLAT-RLAT)
      ELSE
        DLAT=(XLAT-RLAT)/CLING((XLAT-RLAT)/GRDR)
      END IF
      CALL MAPIT (RLAT,RLON,0)
  102 RLAT=RLAT+DLAT
      CALL MAPIT (RLAT,RLON,1)
      IF (RLAT.LT.XLAT-.9999) GO TO 102
      IF (RLON.LT.XLON-.9999) GO TO 101
C
C ROUND THE LATITUDE LIMITS TO APPROPRIATE MULTIPLES OF GRID.
C
      SLAT=GRID*FLOOR(SLAT/GRID)
      IF (SLAT.LE.-90.) SLAT=SLAT+GRID
      BLAT=GRID*CLING(BLAT/GRID)
      IF (BLAT.GE.90.) BLAT=BLAT-GRID
C
C IF A FAST-PATH CYLINDRICAL EQUIDISTANT PROJECTION IS IN USE AND EITHER
C OR BOTH OF THE POLES IS WITHIN THE (RECTANGULAR) PERIMETER, ARRANGE
C FOR THE PARALLELS AT -90 AND/OR +90 TO BE DRAWN.
C
      IF (IPRJ.EQ.10) THEN
        CALL MAPTRN (-90.,PHIO,U,V)
        IF (U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN.AND.V.LE.VMAX)
     +                                                    SLAT=SLAT-GRID
        CALL MAPTRN (90.,PHIO,U,V)
        IF (U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN.AND.V.LE.VMAX)
     +                                                    BLAT=BLAT+GRID
      END IF
C
C DRAW THE PARALLELS.
C
      XLAT=SLAT-GRID
  103 XLAT=XLAT+GRID
      RLAT=AMAX1(-90.,AMIN1(90.,XLAT))
      RLON=FLOOR(SLON)
      XLON=AMIN1(CLING(BLON),RLON+360.)
      IF (IPF) THEN
        DLON=.5*(XLON-RLON)
      ELSE
        DLON=(XLON-RLON)/CLING((XLON-RLON)/GRDR)
      END IF
      CALL MAPIT (RLAT,RLON,0)
  104 RLON=RLON+DLON
      CALL MAPIT (RLAT,RLON,1)
      IF (RLON.LT.XLON-.9999) GO TO 104
      IF (XLAT.LT.BLAT-.9999) GO TO 103
C
C RESTORE THE ORIGINAL INTENSITY, DOTTING, AND DASH PATTERN.
C
      CALL MAPCHI (-2,0,0)
C
C DRAW THE LIMB LINES.
C
      CALL MAPLMB
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPGTC (WHCH,CVAL)
C
      CHARACTER*(*) WHCH,CVAL
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM5/ DDCT(5),LDCT(5),PDCT(10)
      CHARACTER*2     DDCT,LDCT,PDCT
      COMMON /MAPCMB/ IIER
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPGTC','VERSION  1')
C
      IF (WHCH(1:2).EQ.'AR') THEN
        CVAL=LDCT(ILTS)
      ELSE IF (WHCH(1:2).EQ.'OU') THEN
        CVAL=DDCT(NOUT+1)
      ELSE IF (WHCH(1:2).EQ.'PR') THEN
        CVAL=PDCT(JPRJ)
        IF (JPRJ.EQ.3.AND.ABS(SALT).GT.1.) CVAL=PDCT(10)
      ELSE
        GO TO 901
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=1
      CALL MAPCEM (' MAPGTC - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      CVAL=' '
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPGTI (WHCH,IVAL)
C
      CHARACTER*(*) WHCH
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
      COMMON /MAPNTS/ INTS(7)
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPGTI','VERSION  1')
C
      IF (WHCH(1:2).EQ.'DA') THEN
        IVAL=IDSH
      ELSE IF (WHCH(1:2).EQ.'DD') THEN
        IVAL=DDTS
      ELSE IF (WHCH(1:2).EQ.'DL') THEN
        IVAL=IDTL
      ELSE IF (WHCH(1:2).EQ.'DO') THEN
        IVAL=IDOT
      ELSE IF (WHCH(1:2).EQ.'EL') THEN
        IVAL=0
        IF (ELPF) IVAL=1
      ELSE IF (WHCH(1:2).EQ.'ER') THEN
        IVAL=IIER
      ELSE IF (WHCH(1:2).EQ.'GR') THEN
        IVAL=GRID
      ELSE IF (WHCH(1:2).EQ.'IN') THEN
        IVAL=0
        IF (INTF) IVAL=1
      ELSE IF (WHCH(1:2).EQ.'I1') THEN
        IVAL=INTS(1)
      ELSE IF (WHCH(1:2).EQ.'I2') THEN
        IVAL=INTS(2)
      ELSE IF (WHCH(1:2).EQ.'I3') THEN
        IVAL=INTS(3)
      ELSE IF (WHCH(1:2).EQ.'I4') THEN
        IVAL=INTS(4)
      ELSE IF (WHCH(1:2).EQ.'I5') THEN
        IVAL=INTS(5)
      ELSE IF (WHCH(1:2).EQ.'I6') THEN
        IVAL=INTS(6)
      ELSE IF (WHCH(1:2).EQ.'I7') THEN
        IVAL=INTS(7)
      ELSE IF (WHCH(1:2).EQ.'LA') THEN
        IVAL=0
        IF (LBLF) IVAL=1
      ELSE IF (WHCH(1:2).EQ.'LS') THEN
        IVAL=ILCW
      ELSE IF (WHCH(1:2).EQ.'MV') THEN
        IVAL=DPLT
      ELSE IF (WHCH(1:2).EQ.'PE') THEN
        IVAL=0
        IF (PRMF) IVAL=1
      ELSE IF (WHCH(1:2).EQ.'PN') THEN
        IVAL=PHIO
      ELSE IF (WHCH(1:2).EQ.'PT') THEN
        IVAL=PHIA
      ELSE IF (WHCH(1:2).EQ.'P1') THEN
        IVAL=PLA1
      ELSE IF (WHCH(1:2).EQ.'P2') THEN
        IVAL=PLA2
      ELSE IF (WHCH(1:2).EQ.'P3') THEN
        IVAL=PLA3
      ELSE IF (WHCH(1:2).EQ.'P4') THEN
        IVAL=PLA4
      ELSE IF (WHCH(1:2).EQ.'P5') THEN
        IVAL=PLB1
      ELSE IF (WHCH(1:2).EQ.'P6') THEN
        IVAL=PLB2
      ELSE IF (WHCH(1:2).EQ.'P7') THEN
        IVAL=PLB3
      ELSE IF (WHCH(1:2).EQ.'P8') THEN
        IVAL=PLB4
      ELSE IF (WHCH(1:2).EQ.'RE') THEN
        IVAL=PLTR
      ELSE IF (WHCH(1:2).EQ.'RO') THEN
        IVAL=ROTA
      ELSE IF (WHCH(1:2).EQ.'SA') THEN
        IVAL=SALT
      ELSE IF (WHCH(1:2).EQ.'S1') THEN
        IVAL=ALFA
      ELSE IF (WHCH(1:2).EQ.'S2') THEN
        IVAL=BETA
      ELSE
        GO TO 901
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=2
      CALL MAPCEM (' MAPGTI - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      IVAL=0
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPGTL (WHCH,LVAL)
C
      CHARACTER*(*) WHCH
      LOGICAL LVAL
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMB/ IIER
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPGTL','VERSION  1')
C
      IF (WHCH(1:2).EQ.'DL') THEN
        LVAL=IDTL.NE.0
      ELSE IF (WHCH(1:2).EQ.'DO') THEN
        LVAL=IDOT.NE.0
      ELSE IF (WHCH(1:2).EQ.'EL') THEN
        LVAL=ELPF
      ELSE IF (WHCH(1:2).EQ.'IN') THEN
        LVAL=INTF
      ELSE IF (WHCH(1:2).EQ.'LA') THEN
        LVAL=LBLF
      ELSE IF (WHCH(1:2).EQ.'PE') THEN
        LVAL=PRMF
      ELSE
        GO TO 901
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=3
      CALL MAPCEM (' MAPGTL - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      LVAL=.FALSE.
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPGTR (WHCH,RVAL)
C
      CHARACTER*(*) WHCH
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPGTR','VERSION  1')
C
      IF (WHCH(1:2).EQ.'DD') THEN
        RVAL=DDTS
      ELSE IF (WHCH(1:2).EQ.'GD') THEN
        RVAL=GRDR
      ELSE IF (WHCH(1:2).EQ.'GR') THEN
        RVAL=GRID
      ELSE IF (WHCH(1:2).EQ.'MV') THEN
        RVAL=DPLT
      ELSE IF (WHCH(1:2).EQ.'PN') THEN
        RVAL=PHIO
      ELSE IF (WHCH(1:2).EQ.'PT') THEN
        RVAL=PHIA
      ELSE IF (WHCH(1:2).EQ.'P1') THEN
        RVAL=PLA1
      ELSE IF (WHCH(1:2).EQ.'P2') THEN
        RVAL=PLA2
      ELSE IF (WHCH(1:2).EQ.'P3') THEN
        RVAL=PLA3
      ELSE IF (WHCH(1:2).EQ.'P4') THEN
        RVAL=PLA4
      ELSE IF (WHCH(1:2).EQ.'P5') THEN
        RVAL=PLB1
      ELSE IF (WHCH(1:2).EQ.'P6') THEN
        RVAL=PLB2
      ELSE IF (WHCH(1:2).EQ.'P7') THEN
        RVAL=PLB3
      ELSE IF (WHCH(1:2).EQ.'P8') THEN
        RVAL=PLB4
      ELSE IF (WHCH(1:2).EQ.'RE') THEN
        RVAL=PLTR
      ELSE IF (WHCH(1:2).EQ.'RO') THEN
        RVAL=ROTA
      ELSE IF (WHCH(1:2).EQ.'SA') THEN
        RVAL=SALT
      ELSE IF (WHCH(1:2).EQ.'S1') THEN
        RVAL=ALFA
      ELSE IF (WHCH(1:2).EQ.'S2') THEN
        RVAL=BETA
      ELSE IF (WHCH(1:2).EQ.'SR') THEN
        RVAL=SRCH
      ELSE IF (WHCH(1:2).EQ.'XL') THEN
        RVAL=XLOW
      ELSE IF (WHCH(1:2).EQ.'XR') THEN
        RVAL=XROW
      ELSE IF (WHCH(1:2).EQ.'YB') THEN
        RVAL=YBOW
      ELSE IF (WHCH(1:2).EQ.'YT') THEN
        RVAL=YTOW
      ELSE
        GO TO 901
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=4
      CALL MAPCEM (' MAPGTR - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      RVAL=0.
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPINT
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM1/ IPRJ,SINO,COSO,SINR,COSR,PHOC
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM7/ ULOW,UROW,VBOW,VTOW
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C SET UP ALTERNATE NAMES FOR SOME OF THE VARIABLES IN COMMON.
C
      EQUIVALENCE     (PHIA,FLT1),(ROTA,FLT2)
C
      EQUIVALENCE     (PLA1,AUMN),(PLA2,AUMX),
     +                (PLA3,AVMN),(PLA4,AVMX)
C
C ENSURE THAT THE BLOCK DATA ROUTINE WILL LOAD, SO THAT VARIABLES WILL
C HAVE THE PROPER DEFAULT VALUES.
C
      EXTERNAL MAPBD
C
C DEFINE THE NECESSARY CONSTANTS.
C
      DATA RESL / 10. /
      DATA DTOR / .017453292519943 /
      DATA OV90 / .011111111111111 /
      DATA PI   / 3.14159265358979 /
      DATA RTOD / 57.2957795130823 /
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPINT','VERSION  1')
C
C CHECK FOR AN ERROR IN THE PROJECTION SPECIFIER.
C
      IF (JPRJ.LE.0.OR.JPRJ.GE.10) GO TO 901
C
C IPRJ EQUALS JPRJ UNTIL WE FIND OUT IF FAST-PATH PROJECTIONS ARE TO BE
C USED.  PHOC IS JUST A COPY OF PHIO.
C
      IPRJ=JPRJ
      PHOC=PHIO
C
      IF (IPRJ.EQ.1) THEN
C
C COMPUTE CONSTANTS FOR THE LAMBERT CONFORMAL CONIC.
C
        SINO=SIGN(1.,.5*(FLT1+FLT2))
        CHI1=(90.-SINO*FLT1)*DTOR
        IF (FLT1.EQ.FLT2) THEN
          COSO=COS(CHI1)
        ELSE
          CHI2=(90.-SINO*FLT2)*DTOR
          COSO=ALOG(SIN(CHI1)/SIN(CHI2))/ALOG(TAN(.5*CHI1)/TAN(.5*CHI2))
        END IF
C
      ELSE
C
C COMPUTE CONSTANTS REQUIRED FOR ALL THE OTHER PROJECTIONS.
C
        TMP1=ROTA*DTOR
        TMP2=PHIA*DTOR
        SINR=SIN(TMP1)
        COSR=COS(TMP1)
        SINO=SIN(TMP2)
        COSO=COS(TMP2)
C
C COMPUTE CONSTANTS REQUIRED ONLY BY THE CYLINDRICAL PROJECTIONS.
C
        IF (IPRJ.GE.7) THEN
C
C SEE IF FAST-PATH TRANSFORMATIONS CAN BE USED.  (PLAT = 0 AND ROTA = 0
C OR 180.)
C
          IF (ABS(PHIA).GE..0001.OR.(ABS(ROTA).GE..0001.AND.
     +                               ABS(ROTA).LE.179.9999)) THEN
C
C NO.  COMPUTE CONSTANTS FOR THE ORDINARY CYLINDRICAL PROJECTIONS.
C
            SINT=COSO*COSR
            COST=SQRT(1.-(SINT)**2)
            TMP1=SINR/COST
            TMP2=SINO/COST
            PHIO=PHIO-ATAN2(TMP1,-COSR*TMP2)*RTOD
            PHOC=PHIO
            SINR=TMP1*COSO
            COSR=-TMP2
            SINO=SINT
            COSO=COST
C
          ELSE
C
C YES.  THE FAST PATHS ARE IMPLEMENTED AS THREE ADDITIONAL PROJECTIONS.
C
            IPRJ=IPRJ+3
C
            IF (ABS(ROTA).LT..0001) THEN
              SINO=1.
            ELSE
              SINO=-1.
              PHIO=PHIO+180.
              PHOC=PHIO
            END IF
C
            COSO=0.
            SINR=0.
            COSR=1.
C
          END IF
C
        END IF
C
      END IF
C
C NOW, SET UMIN, UMAX, VMIN, AND VMAX TO CORRESPOND TO THE MAXIMUM
C USEFUL AREA PRODUCED BY THE PROJECTION.
C
      GO TO (101,102,101,102,102,103,104,103,105,104,103,105) , IPRJ
C
C LAMBERT CONFORMAL CONIC AND ORTHOGRAPHIC.
C
  101 IF (IPRJ.NE.3.OR.ABS(SALT).LE.1..OR.ALFA.EQ.0.) THEN
        UMIN=-1.
        UMAX=1.
        VMIN=-1.
        VMAX=1.
      ELSE
        TMP1=SALT*SALT*CALF*CALF-1.
        TMP2=CALF*SQRT(SALT*SALT*(1.-SALF*SALF*SBET*SBET)-1.)
        UMIN=SRSS*(-SALF*CBET-TMP2)/TMP1
        UMAX=SRSS*(-SALF*CBET+TMP2)/TMP1
        TMP2=CALF*SQRT(SALT*SALT*(1.-SALF*SALF*CBET*CBET)-1.)
        VMIN=SRSS*(-SALF*SBET-TMP2)/TMP1
        VMAX=SRSS*(-SALF*SBET+TMP2)/TMP1
      END IF
C
      GO TO 106
C
C STEREOGRAPHIC, LAMBERT EQUAL AREA, AND GNOMONIC.
C
  102 UMIN=-2.
      UMAX=2.
      VMIN=-2.
      VMAX=2.
      GO TO 106
C
C AZIMUTHAL EQUIDISTANT AND MERCATOR.
C
  103 UMIN=-PI
      UMAX=PI
      VMIN=-PI
      VMAX=PI
      GO TO 106
C
C CYLINDRICAL EQUIDISTANT.
C
  104 UMIN=-180.
      UMAX=180.
      VMIN=-90.
      VMAX=90.
      GO TO 106
C
C MOLLWEIDE.
C
  105 UMIN=-2.
      UMAX=2.
      VMIN=-1.
      VMAX=1.
C
C COMPUTE THE QUANTITIES USED BY MAPIT IN CHECKING FOR CROSS-OVER.
C
  106 UEPS=.75*(UMAX-UMIN)
      VEPS=.75*(VMAX-VMIN)
C
C AS ALWAYS, THE CONICAL PROJECTION IS THE ODDBALL.  CROSS-OVER IS NOT
C DETECTED IN U AND V, BUT IN LONGITUDE, SO THE VALUE HAS TO BE SET
C DIFFERENTLY.
C
      IF (IPRJ.EQ.1) UEPS=180.
C
C NOW, JUMP TO THE APPROPRIATE LIMIT-SETTING CODE.
C
      GO TO (600,200,300,400,500) , ILTS
C
C ILTS=2    POINTS (PL1,PL2) AND (PL3,PL4) ARE ON OPPOSITE CORNERS
C ------    OF THE PLOT.
C
  200 E=0.
  201 CALL MAPTRN (PLA1,PLA2+E,TMP1,TMP3)
      CALL MAPTRN (PLA3,PLA4-E,TMP2,TMP4)
      IF (IPRJ.GE.7.AND.TMP1.GE.TMP2.AND.E.EQ.0.) THEN
        E=.0001
        GO TO 201
      END IF
      UMIN=AMIN1(TMP1,TMP2)
      UMAX=AMAX1(TMP1,TMP2)
      VMIN=AMIN1(TMP3,TMP4)
      VMAX=AMAX1(TMP3,TMP4)
      IF (UMAX.GE.1.E12) GO TO 904
      GO TO 600
C
C ILTS=3    FOUR EDGE POINTS ARE GIVEN.
C ------
C
  300 E=0.
  301 CALL MAPTRN (PLA1,PLB1+E,TMP1,TMP5)
      CALL MAPTRN (PLA2,PLB2-E,TMP2,TMP6)
      IF (IPRJ.GE.7.AND.TMP1.GE.TMP2.AND.E.EQ.0.) THEN
        E=.0001
        GO TO 301
      END IF
      CALL MAPTRN (PLA3,PLB3,TMP3,TMP7)
      CALL MAPTRN (PLA4,PLB4,TMP4,TMP8)
      UMIN=AMIN1(TMP1,TMP2,TMP3,TMP4)
      UMAX=AMAX1(TMP1,TMP2,TMP3,TMP4)
      VMIN=AMIN1(TMP5,TMP6,TMP7,TMP8)
      VMAX=AMAX1(TMP5,TMP6,TMP7,TMP8)
      IF (UMAX.GE.1.E12) GO TO 904
      GO TO 600
C
C ILTS=4    ANGULAR DISTANCES ARE GIVEN.
C ------
C
  400 CUMI=COS(AUMN*DTOR)
      SUMI=SIN(AUMN*DTOR)
      CUMA=COS(AUMX*DTOR)
      SUMA=SIN(AUMX*DTOR)
      CVMI=COS(AVMN*DTOR)
      SVMI=SIN(AVMN*DTOR)
      CVMA=COS(AVMX*DTOR)
      SVMA=SIN(AVMX*DTOR)
C
      GO TO (904,401,402,403,404,405,406,407,408,406,407,408) , IPRJ
C
C STEREOGRAPHIC.
C
  401 IF (SUMI.LT..0001) THEN
        IF (CUMI.GT.0.) UMIN=0.
      ELSE
        UMIN=-(1.-CUMI)/SUMI
      END IF
      IF (SUMA.LT..0001) THEN
        IF (CUMA.GT.0.) UMAX=0.
      ELSE
        UMAX=(1.-CUMA)/SUMA
      END IF
      IF (SVMI.LT..0001) THEN
        IF (CVMI.GT.0.) VMIN=0.
      ELSE
        VMIN=-(1.-CVMI)/SVMI
      END IF
      IF (SVMA.LT..0001) THEN
        IF (CVMA.GT.0.) VMAX=0.
      ELSE
        VMAX=(1.-CVMA)/SVMA
      END IF
      GO TO 600
C
C ORTHOGRAPHIC.
C
  402 IF (ABS(SALT).LE.1.) THEN
        IF (AMAX1(AUMN,AUMX,AVMN,AVMX).GT.90.) GO TO 902
        UMIN=-SUMI
        UMAX=SUMA
        VMIN=-SVMI
        VMAX=SVMA
      ELSE
        IF (AMAX1(AUMN,AUMX,AVMN,AVMX).GE.90.) GO TO 902
        UTMP=SRSS*SALF/CALF
        VTMP=0.
        UCEN=UTMP*CBET-VTMP*SBET
        VCEN=VTMP*CBET+UTMP*SBET
        UMIN=UCEN-SRSS*CALF*SUMI/CUMI
        UMAX=UCEN+SRSS*CALF*SUMA/CUMA
        VMIN=VCEN-SRSS*CALF*SVMI/CVMI
        VMAX=VCEN+SRSS*CALF*SVMA/CVMA
      END IF
      GO TO 600
C
C LAMBERT EQUAL AREA.
C
  403 IF (SUMI.LT..0001) THEN
        IF (CUMI.GT.0.) UMIN=0.
      ELSE
        UMIN=-2./SQRT(1.+((1.+CUMI)/SUMI)**2)
      END IF
      IF (SUMA.LT..0001) THEN
        IF (CUMA.GT.0.) UMAX=0.
      ELSE
        UMAX=2./SQRT(1.+((1.+CUMA)/SUMA)**2)
      END IF
      IF (SVMI.LT..0001) THEN
        IF (CVMI.GT.0.) VMIN=0.
      ELSE
        VMIN=-2./SQRT(1.+((1.+CVMI)/SVMI)**2)
      END IF
      IF (SVMA.LT..0001) THEN
        IF (CVMA.GT.0.) VMAX=0.
      ELSE
        VMAX=2./SQRT(1.+((1.+CVMA)/SVMA)**2)
      END IF
      GO TO 600
C
C GNOMONIC.
C
  404 IF (AMAX1(AUMN,AUMX,AVMN,AVMX).GE.89.9999) GO TO 902
      UMIN=-SUMI/CUMI
      UMAX=SUMA/CUMA
      VMIN=-SVMI/CVMI
      VMAX=SVMA/CVMA
      GO TO 600
C
C AZIMUTHAL EQUIDISTANT.
C
  405 UMIN=-AUMN*DTOR
      UMAX=AUMX*DTOR
      VMIN=-AVMN*DTOR
      VMAX=AVMX*DTOR
      GO TO 600
C
C CYLINDRICAL EQUIDISTANT.
C
  406 UMIN=-AUMN
      UMAX=AUMX
      VMIN=-AVMN
      VMAX=AVMX
      GO TO 600
C
C MERCATOR.
C
  407 IF (AMAX1(AVMN,AVMX).GE.89.9999) GO TO 902
      UMIN=-AUMN*DTOR
      UMAX=AUMX*DTOR
      VMIN=-ALOG((1.+SVMI)/CVMI)
      VMAX=ALOG((1.+SVMA)/CVMA)
      GO TO 600
C
C MOLLWEIDE.
C
  408 UMIN=-AUMN*OV90
      UMAX=AUMX*OV90
      VMIN=-SVMI
      VMAX=SVMA
      GO TO 600
C
C ILTS=5    VALUES IN THE U/V PLANE ARE GIVEN.
C ------
C
  500 UMIN=PLA1
      UMAX=PLA2
      VMIN=PLA3
      VMAX=PLA4
C
C COMPUTE THE WIDTH AND HEIGHT OF THE PLOT.
C
  600 DU=UMAX-UMIN
      DV=VMAX-VMIN
C
C ERROR IF MAP HAS ZERO AREA.
C
      IF (DU.LE.0..OR.DV.LE.0.) GO TO 903
C
C POSITION THE MAP ON THE PLOTTER FRAME.
C
      IF (DU/DV.LT.(XROW-XLOW)/(YTOW-YBOW)) THEN
        ULOW=.5*(XLOW+XROW)-.5*(DU/DV)*(YTOW-YBOW)
        UROW=.5*(XLOW+XROW)+.5*(DU/DV)*(YTOW-YBOW)
        VBOW=YBOW
        VTOW=YTOW
      ELSE
        ULOW=XLOW
        UROW=XROW
        VBOW=.5*(YBOW+YTOW)-.5*(DV/DU)*(XROW-XLOW)
        VTOW=.5*(YBOW+YTOW)+.5*(DV/DU)*(XROW-XLOW)
      END IF
C
C ERROR IF MAP HAS ESSENTIALLY ZERO AREA.
C
      IF (AMIN1(UROW-ULOW,VTOW-VBOW)*PLTR.LT.RESL) GO TO 903
C
C DO THE REQUIRED SET CALL.
C
      CALL SET (ULOW,UROW,VBOW,VTOW,UMIN,UMAX,VMIN,VMAX,1)
C
C COMPUTE THE QUANTITIES USED BY MAPIT TO SEE IF POINTS ARE FAR ENOUGH
C APART TO DRAW THE LINE BETWEEN THEM AND THE QUANTITIES USED BY MAPVP
C TO DETERMINE THE NUMBER OF DOTS TO INTERPOLATE BETWEEN TWO POINTS.
C
      DSCA=(UROW-ULOW)*PLTR/DU
      DPSQ=DPLT*DPLT
      DSSQ=DSCA*DSCA
      DBTD=DDTS/DSCA
C
C SET PARAMETERS REQUIRED IF AN ELLIPTICAL PERIMETER IS BEING USED.  THE
C ELLIPSE IS MADE TO BE JUST A LITTLE BIGGER THAN AN INSCRIBED ELLIPSE
C SO AS TO AVOID ROUND-OFF PROBLEMS WHEN DRAWING THE LIMB OF CERTAIN
C PROJECTIONS.
C
      UCEN=.5*(UMIN+UMAX)
      VCEN=.5*(VMIN+VMAX)
      URNG=.50005*(UMAX-UMIN)
      VRNG=.50005*(VMAX-VMIN)
C
C NOW, COMPUTE THE LATITUDE/LONGITUDE LIMITS WHICH WILL BE REQUIRED BY
C MAPGRD AND MAPLOT, IF ANY.
C
      IF (GRID.GT.0..OR.NOUT.NE.0) THEN
C
C AT FIRST, ASSUME THE WHOLE GLOBE WILL BE PROJECTED.
C
        SLAM=-90.
        BLAM=+90.
        SLOM=PHIO-180.
        BLOM=PHIO+180.
C
C JUMP IF IT'S OBVIOUS THAT REALLY IS THE CASE.
C
        IF (ILTS.EQ.1.AND.(JPRJ.EQ.4.OR.JPRJ.EQ.6.OR.JPRJ.EQ.7.OR.
     +                                             JPRJ.EQ.9)) GO TO 700
C
C OTHERWISE, THE WHOLE GLOBE IS NOT BEING PROJECTED.  THE FIRST THING
C TO DO IS TO FIND A POINT (CLAT,CLON) WHOSE PROJECTION IS KNOWN TO BE
C ON THE MAP.  FIRST, TRY THE POLE OF THE PROJECTION.
C
        CLAT=PHIA
        CLON=PHIO
        CALL MAPTRN (CLAT,CLON,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                               .AND.V.LE.VMAX).OR.
     +      (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.))
     +                                                         GO TO 611
C
C IF THAT DIDN'T WORK, TRY A POINT BASED ON THE LIMITS SPECIFIER.
C
        IF (ILTS.EQ.2) THEN
          CLAT=.5*(PLA1+PLA3)
          CLON=.5*(PLA2+PLA4)
        ELSE IF (ILTS.EQ.3) THEN
          TMP1=AMIN1(PLA1,PLA2,PLA3,PLA4)
          TMP2=AMAX1(PLA1,PLA2,PLA3,PLA4)
          TMP3=AMIN1(PLB1,PLB2,PLB3,PLB4)
          TMP4=AMAX1(PLB1,PLB2,PLB3,PLB4)
          CLAT=.5*(TMP1+TMP2)
          CLON=.5*(TMP3+TMP4)
        ELSE
          GO TO 700
        END IF
        CALL MAPTRN (CLAT,CLON,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                               .AND.V.LE.VMAX).OR.
     +      (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.))
     +                                                         GO TO 611
        GO TO 700
C
C ONCE WE HAVE THE LATITUDES AND LONGITUDES OF A POINT ON THE MAP, WE
C FIND THE MINIMUM AND MAXIMUM LATITUDE AND THE MINIMUM AND MAXIMUM
C LONGITUDE BY RUNNING A SEARCH POINT ABOUT ON A FINE LAT/LON GRID.
C
C FIND THE MINIMUM LATITUDE.
C
  611   RLAT=CLAT
        RLON=CLON
        DLON=SRCH
  612   RLAT=RLAT-SRCH
        IF (RLAT.LE.-90.) GO TO 621
  613   CALL MAPTRN (RLAT,RLON,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                               .AND.V.LE.VMAX).OR.
     +      (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.)) THEN
          DLON=SRCH
          GO TO 612
        END IF
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180..AND.RLON.LT.CLON+180.) GO TO 613
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180..AND.RLON.LT.CLON+180.) GO TO 613
        SLAM=RLAT
C
C FIND THE MAXIMUM LATITUDE.
C
  621   RLAT=CLAT
        RLON=CLON
        DLON=SRCH
  622   RLAT=RLAT+SRCH
        IF (RLAT.GT.90.) GO TO 631
  623   CALL MAPTRN (RLAT,RLON,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                               .AND.V.LE.VMAX).OR.
     +      (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.)) THEN
          DLON=SRCH
          GO TO 622
        END IF
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180..AND.RLON.LT.CLON+180.) GO TO 623
        RLON=RLON+DLON
        DLON=SIGN(ABS(DLON)+SRCH,-DLON)
        IF (RLON.GT.CLON-180..AND.RLON.LT.CLON+180.) GO TO 623
        BLAM=RLAT
C
C FIND THE MINIMUM LONGITUDE.
C
  631   RLAT=CLAT
        RLON=CLON
        DLAT=SRCH
  632   RLON=RLON-SRCH
        IF (RLON.LE.CLON-360.) GO TO 651
  633   CALL MAPTRN (RLAT,RLON,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                               .AND.V.LE.VMAX).OR.
     +      (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.)) THEN
          DLAT=SRCH
          GO TO 632
        END IF
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90..AND.RLAT.LT.90.) GO TO 633
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90..AND.RLAT.LT.90.) GO TO 633
        SLOM=RLON-SIGN(180.,RLON+180.)+SIGN(180.,180.-RLON)
C
C FIND THE MAXIMUM LONGITUDE.
C
  641   RLAT=CLAT
        RLON=CLON
        DLAT=SRCH
  642   RLON=RLON+SRCH
        IF (RLON.GE.CLON+360.) GO TO 651
  643   CALL MAPTRN (RLAT,RLON,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                               .AND.V.LE.VMAX).OR.
     +      (ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.)) THEN
          DLAT=SRCH
          GO TO 642
        END IF
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90..AND.RLAT.LT.90.) GO TO 643
        RLAT=RLAT+DLAT
        DLAT=SIGN(ABS(DLAT)+SRCH,-DLAT)
        IF (RLAT.GT.-90..AND.RLAT.LT.90.) GO TO 643
        BLOM=RLON-SIGN(180.,RLON+180.)+SIGN(180.,180.-RLON)
        IF (BLOM.LE.SLOM) BLOM=BLOM+360.
        GO TO 700
C
  651   SLOM=PHIO-180.
        BLOM=PHIO+180.
C
      END IF
C
C ZERO THE ERROR FLAG AND TURN OFF THE INITIALIZATION-REQUIRED FLAG.
C
  700 IIER=0
      INTF=.FALSE.
C
C DONE.
C
      RETURN
C
C ERROR RETURNS.
C
  901 IIER=5
      CALL SETER (' MAPINT - ATTEMPT TO USE NON-EXISTENT PROJECTION',
     1              IIER,1)
      RETURN
C
  902 IIER=6
      CALL SETER (' MAPINT - ANGULAR LIMITS TOO GREAT',IIER,1)
      RETURN
C
  903 IIER=7
      CALL SETER (' MAPINT - MAP HAS ZERO AREA',IIER,1)
      RETURN
C
  904 IIER=8
      CALL SETER (' MAPINT - MAP LIMITS INAPPROPIATE',IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPIT (RLAT,RLON,IFST)
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM1/ IPRJ,SINO,COSO,SINR,COSR,PHOC
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM8/ P,Q,R
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
C
      DIMENSION CPRJ(3)
C
      SAVE IVSO,POLD,QOLD,UOLD,VOLD
C
      DATA CPRJ / 360.,6.28318530717959,4. /
C
      DATA IVSO,POLD,QOLD,UOLD,VOLD / 0,0.,0.,0.,0. /
C
C PROJECT THE POINT (RLAT,RLON) TO (U,V).
C
      CALL MAPTRN (RLAT,RLON,U,V)
C
C FOR THE SAKE OF EFFICIENCY, EXECUTE ONE OF TWO PARALLEL ALGORITHMS,
C DEPENDING ON WHETHER AN ELLIPTICAL OR A RECTANGULAR PERIMETER IS IN
C USE.  (THAT WAY, WE TEST ELPF ONLY ONCE.)
C
      IF (ELPF) THEN
C
C ELLIPTICAL - ASSUME THE NEW POINT IS VISIBLE UNTIL WE FIND OTHERWISE.
C
        IVIS=1
C
C SEE IF THE NEW POINT IS INVISIBLE.
C
        IF (((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.GT.1.) THEN
C
C THE NEW POINT IS INVISIBLE.  RESET THE VISIBILITY FLAG.
C
          IVIS=0
C
C IF THE NEW POINT IS A "FIRST POINT" OR IF THE LAST POINT WAS NOT
C VISIBLE OR IF THE NEW POINT IS INVISIBLE BECAUSE ITS PROJECTION IS
C UNDEFINED, DRAW NOTHING.  THE POSSIBLE EXISTENCE OF A VISIBLE SEGMENT
C ALONG THE LINE JOINING TWO INVISIBLE POINTS IS INTENTIONALLY IGNORED,
C FOR REASONS OF EFFICIENCY.  FOR THIS REASON, OBJECTS SHOULD NOT BE
C DRAWN USING LONG LINE SEGMENTS.
C
          IF (IFST.EQ.0.OR.IVSO.EQ.0.OR.U.GE.1.E12) GO TO 108
C
C OTHERWISE, THE NEW POINT IS NOT A "FIRST POINT", THE LAST POINT WAS
C VISIBLE, AND THE PROJECTION OF THE NEW POINT IS DEFINED, SO WE NEED
C TO CONTINUE THE LINE.  FIRST, IF THERE'S A CROSS-OVER PROBLEM, MOVE
C THE NEW POINT TO ITS ALTERNATE POSITION.  THIS MAY MAKE IT VISIBLE.
C
          IF (ABS(P-POLD).GT.UEPS.OR.ABS(Q-QOLD).GT.VEPS) THEN
C
            IF (JPRJ.GE.7) THEN
              P=P-SIGN(CPRJ(JPRJ-6),P)
              U=P
              IF (JPRJ.EQ.9) U=U*SQRT(1.-V*V)
            ELSE
              GO TO 108
            END IF
C
            IF (((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.) THEN
              IVIS=1
              GO TO 107
            END IF
C
          END IF
C
C IF IT'S STILL INVISIBLE, INTERPOLATE TO THE EDGE OF THE FRAME, EXTEND
C THE LINE TO THAT POINT, AND QUIT.
C
          CALL MAPTRE (UOLD,VOLD,U,V,UINT,VINT)
          CALL MAPVP (UOLD,VOLD,UINT,VINT)
          GO TO 108
C
        END IF
C
C THE NEW POINT IS VISIBLE.  IF IT'S THE FIRST POINT OF A LINE, GO START
C A NEW LINE.
C
        IF (IFST.EQ.0.OR.UOLD.GE.1.E12) GO TO 106
C
C THE NEW POINT IS VISIBLE, BUT IT'S NOT THE FIRST POINT OF A LINE.
C CHECK FOR CROSS-OVER PROBLEMS.
C
        IF (ABS(P-POLD).GT.UEPS.OR.ABS(Q-QOLD).GT.VEPS) GO TO 101
C
C THE NEW POINT IS VISIBLE, IT'S NOT THE FIRST POINT OF A LINE, AND
C THERE ARE NO CROSS-OVER PROBLEMS.  IF THE OLD POINT WAS INVISIBLE,
C JUMP TO DRAW THE VISIBLE PORTION OF THE LINE FROM THE OLD POINT TO
C THE NEW ONE.
C
        IF (IVSO.EQ.0) GO TO 102
C
C THE NEW POINT IS VISIBLE, IT'S NOT THE FIRST POINT OF A LINE, THERE
C ARE NO CROSS-OVER PROBLEMS, AND THE LAST POINT WAS VISIBLE.  JUMP TO
C JUST CONTINUE THE LINE.
C
        GO TO 107
C
C WE HAVE THE MOST DIFFICULT CASE.  THE NEW POINT IS VISIBLE, IT'S NOT
C THE FIRST POINT OF A LINE, AND THERE IS A CROSS-OVER PROBLEM.  NONE,
C ONE, OR TWO SEGMENTS MAY NEED TO BE DRAWN.
C
  101   IF (JPRJ.LT.7) GO TO 106
C
C IF THE OLD POINT WAS VISIBLE, GENERATE THE ALTERNATE PROJECTION OF THE
C NEW POINT AND DRAW THE VISIBLE PORTION OF THE LINE SEGMENT JOINING THE
C OLD POINT TO THE ALTERNATE PROJECTION POINT.
C
        IF (IVSO.NE.0) THEN
C
          UTMP=P-SIGN(CPRJ(JPRJ-6),P)
          VTMP=Q
          IF (JPRJ.EQ.9) UTMP=UTMP*SQRT(1.-VTMP*VTMP)
C
          IF (((UTMP-UCEN)/URNG)**2+((VTMP-VCEN)/VRNG)**2.GT.1.) THEN
            CALL MAPTRE (UOLD,VOLD,UTMP,VTMP,UTMP,VTMP)
          END IF
C
          CALL MAPVP (UOLD,VOLD,UTMP,VTMP)
C
        END IF
C
C NOW GENERATE AN ALTERNATE PROJECTION OF THE OLD POINT CLOSE TO THE NEW
C ONE AND DRAW THE VISIBLE PORTION OF THE LINE SEGMENT JOINING IT TO THE
C NEW POINT.
C
        UOLD=POLD-SIGN(CPRJ(JPRJ-6),POLD)
        IF (JPRJ.EQ.9) UOLD=UOLD*SQRT(1.-VOLD*VOLD)
C
        IF (((UOLD-UCEN)/URNG)**2+((VOLD-VCEN)/VRNG)**2.LE.1.) GO TO 105
C
C MOVE (UOLD,VOLD) BY INTERPOLATING TO THE EDGE OF THE FRAME.
C
  102   CALL MAPTRE (U,V,UOLD,VOLD,UOLD,VOLD)
C
      ELSE
C
C RECTANGULAR - REPEAT THE ABOVE CODE, CHANGING THE TESTS FOR A POINT'S
C BEING INSIDE/OUTSIDE THE PERIMETER.  COMMENTING WILL BE ABBREVIATED.
C
        IVIS=1
C
        IF (U.LT.UMIN.OR.U.GT.UMAX.OR.V.LT.VMIN.OR.V.GT.VMAX) THEN
C
          IVIS=0
C
          IF (IFST.EQ.0.OR.IVSO.EQ.0.OR.U.GE.1.E12) GO TO 108
C
          IF (ABS(P-POLD).GT.UEPS.OR.ABS(Q-QOLD).GT.VEPS) THEN
C
            IF (JPRJ.GE.7) THEN
              P=P-SIGN(CPRJ(JPRJ-6),P)
              U=P
              IF (JPRJ.EQ.9) U=U*SQRT(1.-V*V)
            ELSE
              GO TO 108
            END IF
C
            IF (U.GE.UMIN.AND.U.LE.UMAX.AND.
     +          V.GE.VMIN.AND.V.LE.VMAX) THEN
              IVIS=1
              GO TO 107
            END IF
          END IF
C
          CALL MAPTRP (UOLD,VOLD,U,V,UINT,VINT)
          CALL MAPVP (UOLD,VOLD,UINT,VINT)
          GO TO 108
C
        END IF
C
        IF (IFST.EQ.0.OR.UOLD.GE.1.E12) GO TO 106
C
        IF (ABS(P-POLD).GT.UEPS.OR.ABS(Q-QOLD).GT.VEPS) GO TO 103
C
        IF (IVSO.EQ.0) GO TO 104
C
        GO TO 107
C
  103   IF (JPRJ.LT.7) GO TO 106
C
        IF (IVSO.NE.0) THEN
C
          UTMP=P-SIGN(CPRJ(JPRJ-6),P)
          VTMP=Q
          IF (JPRJ.EQ.9) UTMP=UTMP*SQRT(1.-VTMP*VTMP)
C
          IF (UTMP.LT.UMIN.OR.UTMP.GT.UMAX.OR.
     +        VTMP.LT.VMIN.OR.VTMP.GT.VMAX) THEN
            CALL MAPTRP (UOLD,VOLD,UTMP,VTMP,UTMP,VTMP)
          END IF
C
          CALL MAPVP (UOLD,VOLD,UTMP,VTMP)
        END IF
C
        UOLD=POLD-SIGN(CPRJ(JPRJ-6),POLD)
        IF (JPRJ.EQ.9) UOLD=UOLD*SQRT(1.-VOLD*VOLD)
C
        IF (UOLD.GE.UMIN.AND.UOLD.LE.UMAX.AND.
     +      VOLD.GE.VMIN.AND.VOLD.LE.VMAX) GO TO 105
C
  104   CALL MAPTRP (U,V,UOLD,VOLD,UOLD,VOLD)
C
      END IF
C
C DRAW THE VISIBLE PORTION OF THE LINE JOINING THE OLD POINT TO THE NEW.
C
  105 IF (IDTL.EQ.0) THEN
        CALL FRSTD (UOLD,VOLD)
        DATL=0.
      END IF
C
      CALL MAPVP (UOLD,VOLD,U,V)
C
      GO TO 108
C
C START A NEW LINE.
C
  106 IF (IDTL.EQ.0) THEN
        CALL FRSTD (U,V)
        DATL=0.
      END IF
C
      GO TO 108
C
C CONTINUE THE LINE.
C
  107 IF (IFST.LT.2.AND.((U-UOLD)**2+(V-VOLD)**2)*DSSQ.LE.DPSQ) RETURN
      CALL MAPVP (UOLD,VOLD,U,V)
C
C SAVE INFORMATION ABOUT THE CURRENT POINT FOR THE NEXT CALL AND QUIT.
C
  108 IVSO=IVIS
      POLD=P
      QOLD=Q
      UOLD=U
      VOLD=V
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPIQ
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCMP/ NPTB,XPTB(50),YPTB(50)
C
C FLUSH THE POINTS BUFFER.
C
      IF (NPTB.GT.0) THEN
        CALL POINTS (XPTB,YPTB,NPTB,0,0)
        NPTB=0
      END IF
C
C FLUSH PLOTIT'S BUFFER, TOO.
C
      CALL PLOTIT (0,0,0)
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPLBL
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
C
C DEFINE REQUIRED CONSTANTS.  SIN1 AND COS1 ARE RESPECTIVELY THE SINE
C AND COSINE OF ONE DEGREE.
C
      DATA SIN1 / .017452406437283 /
      DATA COS1 / .999847695156390 /
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPLBL','VERSION  1')
C
C IF EZMAP NEEDS INITIALIZATION OR IF AN ERROR HAS OCCURRED SINCE THE
C LAST INITIALIZATION, DO NOTHING.
C
      IF (INTF) RETURN
      IF (IIER.NE.0) RETURN
C
C IF REQUESTED, LETTER KEY MERIDIANS AND POLES.
C
      IF (LBLF) THEN
C
C RESET THE INTENSITY, DOTTING, AND DASH PATTERN FOR LABELLING.
C
        CALL MAPCHI (3,1,0)
C
C FIRST, THE NORTH POLE.
C
        CALL MAPTRN (90.,0.,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                                   .AND.V.LE.VMAX)
     +     .OR.(ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.))
     +                                    CALL WTSTR (U,V,'NP',ILCW,0,0)
C
C THEN, THE SOUTH POLE.
C
        CALL MAPTRN (-90.,0.,U,V)
        IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                                   .AND.V.LE.VMAX)
     +     .OR.(ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.))
     +                                    CALL WTSTR (U,V,'SP',ILCW,0,0)
C
C THE EQUATOR.
C
        RLON=PHIO-10.
        DO 101 I=1,36
          RLON=RLON+10.
          CALL MAPTRN (0.,RLON,U,V)
          IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                                   .AND.V.LE.VMAX)
     +     .OR.(ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.))
     +                                                         GO TO 102
  101   CONTINUE
        GO TO 103
  102   CALL WTSTR (U,V,'EQ',ILCW,0,0)
C
C THE GREENWICH MERIDIAN.
C
  103   RLAT=85.
        DO 104 I=1,16
          RLAT=RLAT-10.
          CALL MAPTRN (RLAT,0.,U,V)
          IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                                   .AND.V.LE.VMAX)
     +     .OR.(ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.))
     +                                                         GO TO 105
  104   CONTINUE
        GO TO 106
  105   CALL WTSTR (U,V,'GM',ILCW,0,0)
C
C INTERNATIONAL DATE LINE.
C
  106   RLAT=85.
        DO 107 I=1,16
          RLAT=RLAT-10.
          CALL MAPTRN (RLAT,180.,U,V)
          IF ((.NOT.ELPF.AND.U.GE.UMIN.AND.U.LE.UMAX.AND.V.GE.VMIN
     +                                                   .AND.V.LE.VMAX)
     +     .OR.(ELPF.AND.((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.LE.1.))
     +                                                         GO TO 108
  107   CONTINUE
        GO TO 109
  108   CALL WTSTR (U,V,'ID',ILCW,0,0)
C
C RESTORE THE ORIGINAL INTENSITY, DOTTING, AND DASH PATTERN.
C
  109   CALL MAPCHI (-3,0,0)
C
      END IF
C
C DRAW PERIMETER, IF REQUESTED.
C
      IF (PRMF) THEN
C
C RESET THE LINE INTENSITY, DOTTING, AND DASH PATTERN FOR THE PERIMETER.
C
        CALL MAPCHI (1,0,IOR(ISHIFT(32767,1),1))
C
C THE PERIMETER IS EITHER AN ELLIPSE OR A RECTANGLE, DEPENDING ON ELPF.
C
        IF (ELPF) THEN
          U=.9999*URNG
          V=0.
          DATL=0.
          CALL FRSTD (UCEN+U,VCEN)
          DO 110 I=1,360
            UOLD=U
            VOLD=V
            U=COS1*UOLD-SIN1*VOLD
            V=SIN1*UOLD+COS1*VOLD
            CALL MAPVP (UCEN+UOLD,VCEN+VOLD*VRNG/URNG,
     +                  UCEN+U   ,VCEN+V   *VRNG/URNG)
  110     CONTINUE
        ELSE
          DATL=0.
          UMINX=UMIN+.9999*(UMAX-UMIN)
          UMAXX=UMAX-.9999*(UMAX-UMIN)
          VMINX=VMIN+.9999*(VMAX-VMIN)
          VMAXX=VMAX-.9999*(VMAX-VMIN)
          CALL FRSTD (UMINX,VMINX)
          CALL MAPVP (UMINX,VMINX,UMAXX,VMINX)
          CALL MAPVP (UMAXX,VMINX,UMAXX,VMAXX)
          CALL MAPVP (UMAXX,VMAXX,UMINX,VMAXX)
          CALL MAPVP (UMINX,VMAXX,UMINX,VMINX)
        END IF
C
C RESTORE THE ORIGINAL INTENSITY, DOTTING, AND DASH PATTERN.
C
        CALL MAPCHI (-1,0,0)
C
      END IF
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPLOT
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMB/ IIER
C
C DEFINE REQUIRED CONSTANTS.
C
      DATA PI / 3.14159265358979 /
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPLOT','VERSION  1')
C
C IF EZMAP NEEDS INITIALIZATION OR IF AN ERROR HAS OCCURRED SINCE THE
C LAST INITIALIZATION, DO NOTHING.
C
      IF (INTF) RETURN
      IF (IIER.NE.0) RETURN
C
C IF THE SELECTED OUTLINE TYPE IS "NONE", DO NOTHING.
C
      IF (NOUT.LE.0) RETURN
C
C SET THE FLAG IWGF TO SAY WHETHER OR NOT THE WHOLE GLOBE IS SHOWN BY
C THE CURRENT PROJECTION.  IF SO (IWGF=1), THERE'S NO NEED TO WASTE THE
C TIME REQUIRED TO CHECK EACH OUTLINE POINT GROUP FOR INTERSECTION WITH
C THE WINDOW.
C
      IWGF=0
      IF (BLAM-SLAM.GT.179.9999.AND.BLOM-SLOM.GT.359.9999) IWGF=1
C
C IGIS KEEPS TRACK OF CHANGES IN THE GROUP IDENTIFIER, SO THAT THE
C INTENSITY CAN BE CHANGED WHEN NECESSARY.
C
      IGIS=0
C
C POSITION TO THE USER-SELECTED PORTION OF THE OUTLINE DATASET.
C
      CALL MAPIO (1)
      NSEG=0
C
C READ THE NEXT RECORD (GROUP OF POINTS).
C
  101 CALL MAPIO (2)
      NSEG=NSEG+1
C
C CHECK FOR THE END OF THE DESIRED DATA.
C
      IF (NPTS.EQ.0) GO TO 103
C
C IF LESS THAN THE WHOLE GLOBE IS SHOWN BY THE PROJECTION, DO A QUICK
C CHECK FOR INTERSECTION OF THE BOX SURROUNDING THE POINT GROUP WITH
C THE AREA SHOWN.
C
      IF (IWGF.EQ.0) THEN
        IF (SLAG.GT.BLAM.OR.BLAG.LT.SLAM) GO TO 101
        IF ((SLOG     .GT.BLOM.OR.BLOG     .LT.SLOM).AND.
     +      (SLOG-360..GT.BLOM.OR.BLOG-360..LT.SLOM).AND.
     +      (SLOG+360..GT.BLOM.OR.BLOG+360..LT.SLOM)) GO TO 101
      END IF
C
C SEE IF THE USER WANTS TO OMIT THIS POINT GROUP.
C
      CALL MAPEOS (NOUT,NSEG,IGID,NPTS,PNTS)
      IF (NPTS.LE.1) GO TO 101
C
C IF WE'VE SWITCHED TO A NEW GROUP, SET THE INTENSITY, DOTTING, AND
C DASH PATTERN FOR THE GROUP.
C
      IF (IGID.NE.IGIS) THEN
        IF (IGIS.NE.0) CALL MAPCHI (-4-IGIS,0,0)
        CALL MAPCHI (4+IGID,IDOT,IOR(ISHIFT(32767,1),1))
        IGIS=IGID
      END IF
C
C PLOT THE GROUP.
C
      CALL MAPIT (PNTS(1),PNTS(2),0)
C
      DO 102 K=2,NPTS-1
        CALL MAPIT (PNTS(2*K-1),PNTS(2*K),1)
  102 CONTINUE
C
      CALL MAPIT (PNTS(2*NPTS-1),PNTS(2*NPTS),2)
C
C GO GET ANOTHER GROUP.
C
      GO TO 101
C
C RESET THE INTENSITY, DOTTING, AND DASH PATTERN, IF NECESSARY.
C
  103 IF (IGIS.NE.0) CALL MAPCHI (-4-IGIS,0,0)
C
C IF THE LIMB LINES HAVE NOT ALREADY BEEN DRAWN, DO IT NOW.
C
      IF (GRID.LE.0.) CALL MAPLMB
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPPOS (ARG1,ARG2,ARG3,ARG4)
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMB/ IIER
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPPOS','VERSION  1')
C
C CHECK THE ARGUMENTS FOR ERRORS.
C
      IF (ARG1.LT.0..OR.ARG1.GE.ARG2.OR.ARG2.GT.1.) GO TO 901
      IF (ARG3.LT.0..OR.ARG3.GE.ARG4.OR.ARG4.GT.1.) GO TO 901
C
C TRANSFER IN THE VALUES.
C
      XLOW=ARG1
      XROW=ARG2
      YBOW=ARG3
      YTOW=ARG4
C
C SET THE FLAG TO INDICATE THAT INITIALIZATION IS NOW REQUIRED.
C
      INTF=.TRUE.
C
C DONE.
C
      RETURN
C
C ERROR EXIT.
C
  901 IIER=19
      CALL SETER (' MAPPOS - ARGUMENTS ARE INCORRECT',IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPROJ (ARG1,ARG2,ARG3,ARG4)
C
      CHARACTER*(*) ARG1
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM5/ DDCT(5),LDCT(5),PDCT(10)
      CHARACTER*2     DDCT,LDCT,PDCT
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPROJ','VERSION  1')
C
C TRANSFER THE PARAMETERS DEFINING THE PROJECTION.
C
      I=IDICTL(ARG1,PDCT,10)
      IF (I.EQ.0) GO TO 901
C
      JPRJ=I
C
      IF (JPRJ.EQ.3) THEN
        CALL MAPSTR ('SA',0.)
      ELSE IF (JPRJ.EQ.10) THEN
        JPRJ=3
        IF (ABS(SALT).LE.1.) CALL MAPSTR ('SA',6.631)
      END IF
C
      PHIA=ARG2
      PHIO=ARG3
      ROTA=ARG4
C
C SET THE FLAG TO INDICATE THAT INITIALIZATION IS NOW REQUIRED.
C
      INTF=.TRUE.
C
C DONE.
C
      RETURN
C
C ERROR EXIT.
C
  901 IIER=9
      CALL MAPCEM (' MAPROJ - UNKNOWN PROJECTION NAME ',ARG1,IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPRS
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM7/ ULOW,UROW,VBOW,VTOW
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPRS','VERSION  1')
C
C RESTORE THE SET CALL.
C
      CALL SET (ULOW,UROW,VBOW,VTOW,UMIN,UMAX,VMIN,VMAX,1)
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPRST (IFNO)
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
      COMMON /MAPNTS/ INTS(7)
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPRST','VERSION  1')
C
C READ A RECORD OF SAVED PARAMETERS.
C
      READ (IFNO,ERR=901,END=902) NOUT,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,
     +                            PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,
     +                            PLTR,GRID,IDSH,IDOT,LBLF,PRMF,ELPF,
     +                            XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,
     +                            ILCW,DPLT,DDTS,SALT,SSMO,SRSS,ALFA,
     +                            BETA,SALF,CALF,SBET,CBET,
     +                            (INTS(I),I=1,7)
C
C RE-INITIALIZE EZMAP.
C
      CALL MAPINT
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=20
      CALL SETER ('MAPRST - ERROR ON READ',IIER,1)
      RETURN
C
  902 IIER=21
      CALL SETER ('MAPRST - EOF ON READ',IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPSAV (IFNO)
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
      COMMON /MAPNTS/ INTS(7)
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPSAV','VERSION  1')
C
C WRITE A RECORD CONTAINING ALL THE USER-SETTABLE PARAMETERS.
C
      WRITE (IFNO,ERR=901) NOUT,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,
     +                     PLA2,PLA3,PLA4,PLB1,PLB2,PLB3,PLB4,
     +                     PLTR,GRID,IDSH,IDOT,LBLF,PRMF,ELPF,
     +                     XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,
     +                     ILCW,DPLT,DDTS,SALT,SSMO,SRSS,ALFA,
     +                     BETA,SALF,CALF,SBET,CBET,
     +                     (INTS(I),I=1,7)
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=22
      CALL SETER ('MAPSAV - ERROR ON WRITE',IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPSET (ARG1,ARG2,ARG3,ARG4,ARG5)
C
      CHARACTER*(*) ARG1
      DIMENSION ARG2(2),ARG3(2),ARG4(2),ARG5(2)
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM5/ DDCT(5),LDCT(5),PDCT(10)
      CHARACTER*2     DDCT,LDCT,PDCT
      COMMON /MAPCMB/ IIER
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPSET','VERSION  1')
C
C TRANSFER THE PARAMETERS DEFINING THE MAP LIMITS.
C
      I=IDICTL(ARG1,LDCT,5)
      IF (I.EQ.0) GO TO 901
      ILTS=I
C
      PLA1=ARG2(1)
      PLA2=ARG3(1)
      PLA3=ARG4(1)
      PLA4=ARG5(1)
C
      IF (I.EQ.3) THEN
        PLB1=ARG2(2)
        PLB2=ARG3(2)
        PLB3=ARG4(2)
        PLB4=ARG5(2)
      END IF
C
C SET THE FLAG TO INDICATE THAT INITIALIZATION IS NOW REQUIRED.
C
      INTF=.TRUE.
C
C DONE.
C
      RETURN
C
C ERROR EXIT.
C
  901 IIER=10
      CALL MAPCEM (' MAPSET - UNKNOWN MAP AREA SPECIFIER ',ARG1,IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPSTC (WHCH,CVAL)
C
      CHARACTER*(*) WHCH,CVAL
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM5/ DDCT(5),LDCT(5),PDCT(10)
      CHARACTER*2     DDCT,LDCT,PDCT
      COMMON /MAPCMB/ IIER
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPSTC','VERSION  1')
C
      IF (WHCH(1:2).EQ.'OU') THEN
        I=IDICTL(CVAL,DDCT,5)
        IF (I.EQ.0) GO TO 901
        NOUT=I-1
      ELSE
        GO TO 902
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=11
      CALL MAPCEM (' MAPSTC - UNKNOWN OUTLINE NAME ',CVAL,IIER,1)
      RETURN
C
  902 IIER=12
      CALL MAPCEM (' MAPSTC - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPSTI (WHCH,IVAL)
C
      CHARACTER*(*) WHCH
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM7/ ULOW,UROW,VBOW,VTOW
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
      COMMON /MAPNTS/ INTS(7)
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPSTI','VERSION  1')
C
      IF (WHCH(1:2).EQ.'DA') THEN
        IDSH=IVAL
      ELSE IF (WHCH(1:2).EQ.'DD') THEN
        DDTS=IVAL
        DBTD=DDTS/DSCA
      ELSE IF (WHCH(1:2).EQ.'DL') THEN
        IDTL=IVAL
      ELSE IF (WHCH(1:2).EQ.'DO') THEN
        IDOT=IVAL
      ELSE IF (WHCH(1:2).EQ.'EL') THEN
        ELPF=IVAL.NE.0
      ELSE IF (WHCH(1:2).EQ.'GR') THEN
        GRID=IVAL
      ELSE IF (WHCH(1:2).EQ.'I1') THEN
        INTS(1)=IVAL
      ELSE IF (WHCH(1:2).EQ.'I2') THEN
        INTS(2)=IVAL
      ELSE IF (WHCH(1:2).EQ.'I3') THEN
        INTS(3)=IVAL
      ELSE IF (WHCH(1:2).EQ.'I4') THEN
        INTS(4)=IVAL
      ELSE IF (WHCH(1:2).EQ.'I5') THEN
        INTS(5)=IVAL
      ELSE IF (WHCH(1:2).EQ.'I6') THEN
        INTS(6)=IVAL
      ELSE IF (WHCH(1:2).EQ.'I7') THEN
        INTS(7)=IVAL
      ELSE IF (WHCH(1:2).EQ.'LA') THEN
        LBLF=IVAL.NE.0
      ELSE IF (WHCH(1:2).EQ.'LS') THEN
        ILCW=IVAL
      ELSE IF (WHCH(1:2).EQ.'MV') THEN
        DPLT=IVAL
        DPSQ=DPLT*DPLT
      ELSE IF (WHCH(1:2).EQ.'PE') THEN
        PRMF=IVAL.NE.0
      ELSE IF (WHCH(1:2).EQ.'RE') THEN
        PLTR=IVAL
        DSCA=(UROW-ULOW)*PLTR/(UMAX-UMIN)
        DSSQ=DSCA*DSCA
        DBTD=DDTS/DSCA
      ELSE IF (WHCH(1:2).EQ.'SA') THEN
        SALT=IVAL
        IF (ABS(SALT).GT.1.) THEN
          SSMO=SALT*SALT-1.
          SRSS=SQRT(SSMO)
        END IF
      ELSE IF (WHCH(1:2).EQ.'S1') THEN
        ALFA=IVAL
        SALF=SIN(.017453292519943*ALFA)
        CALF=COS(.017453292519943*ALFA)
      ELSE IF (WHCH(1:2).EQ.'S2') THEN
        BETA=IVAL
        SBET=SIN(.017453292519943*BETA)
        CBET=COS(.017453292519943*BETA)
      ELSE
        GO TO 901
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=13
      CALL MAPCEM (' MAPSTI - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPSTL (WHCH,LVAL)
C
      CHARACTER*(*) WHCH
      LOGICAL LVAL
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMB/ IIER
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPSTL','VERSION  1')
C
      IF (WHCH(1:2).EQ.'DL') THEN
        IDTL=0
        IF (LVAL) IDTL=1
      ELSE IF (WHCH(1:2).EQ.'DO') THEN
        IDOT=0
        IF (LVAL) IDOT=1
      ELSE IF (WHCH(1:2).EQ.'EL') THEN
        ELPF=LVAL
      ELSE IF (WHCH(1:2).EQ.'LA') THEN
        LBLF=LVAL
      ELSE IF (WHCH(1:2).EQ.'PE') THEN
        PRMF=LVAL
      ELSE
        GO TO 901
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=14
      CALL MAPCEM (' MAPSTL - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPSTR (WHCH,RVAL)
C
      CHARACTER*(*) WHCH
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCM7/ ULOW,UROW,VBOW,VTOW
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMB/ IIER
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','MAPSTR','VERSION  1')
C
      IF (WHCH(1:2).EQ.'DD') THEN
        DDTS=RVAL
        DBTD=DDTS/DSCA
      ELSE IF (WHCH(1:2).EQ.'GD') THEN
        GRDR=AMAX1(.001,AMIN1(10.,RVAL))
      ELSE IF (WHCH(1:2).EQ.'GR') THEN
        GRID=RVAL
      ELSE IF (WHCH(1:2).EQ.'MV') THEN
        DPLT=RVAL
        DPSQ=DPLT*DPLT
      ELSE IF (WHCH(1:2).EQ.'RE') THEN
        PLTR=RVAL
        DSCA=(UROW-ULOW)*PLTR/(UMAX-UMIN)
        DSSQ=DSCA*DSCA
        DBTD=DDTS/DSCA
      ELSE IF (WHCH(1:2).EQ.'SA') THEN
        SALT=RVAL
        IF (ABS(SALT).GT.1.) THEN
          SSMO=SALT*SALT-1.
          SRSS=SQRT(SSMO)
        END IF
      ELSE IF (WHCH(1:2).EQ.'S1') THEN
        ALFA=RVAL
        SALF=SIN(.017453292519943*ALFA)
        CALF=COS(.017453292519943*ALFA)
      ELSE IF (WHCH(1:2).EQ.'S2') THEN
        BETA=RVAL
        SBET=SIN(.017453292519943*BETA)
        CBET=COS(.017453292519943*BETA)
      ELSE IF (WHCH(1:2).EQ.'SR') THEN
        SRCH=AMAX1(.001,AMIN1(10.,RVAL))
      ELSE
        GO TO 901
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=15
      CALL MAPCEM (' MAPSTR - UNKNOWN PARAMETER NAME ',WHCH,IIER,1)
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPTRN (RLAT,RLON,U,V)
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM1/ IPRJ,SINO,COSO,SINR,COSR,PHOC
      COMMON /MAPCM8/ P,Q,R
      COMMON /MAPCMB/ IIER
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C DEFINE REQUIRED CONSTANTS.  DTOR IS PI OVER 180, DTRH IS HALF OF DTOR
C OR PI OVER 360, AND TOPI IS 2 OVER PI.
C
      DATA DTOR / .017453292519943 /
      DATA DTRH / .008726646259971 /
      DATA RTOD / 57.2957795130823 /
      DATA TOPI / .636619772367581 /
C
C SET UP U AND V FOR THE FAST PATHS.  U IS A LONGITUDE, IN DEGREES,
C BETWEEN -180. AND +180., INCLUSIVE, AND V IS A LATITUDE, IN DEGREES.
C
      TMP1=RLON-PHOC
      U=TMP1-SIGN(180.,TMP1+180.)+SIGN(180.,180.-TMP1)
      V=RLAT
C
C TAKE FAST PATHS FOR SIMPLE CYLINDRICAL PROJECTIONS.
C
      IF (IPRJ-10) 101,116,112
C
C NO FAST PATH.  SORT OUT THE LAMBERT CONFORMAL CONIC FROM THE REST.
C
  101 IF (IPRJ-1) 901,102,103
C
C LAMBERT CONFORMAL CONIC.
C
  102 P=U
      CHI=90.-SINO*RLAT
      IF (CHI.GE.179.9999) GO TO 118
      R=TAN(DTRH*CHI)**COSO
      U=U*COSO*DTOR
      V=-R*SINO*COS(U)
      U=R*SIN(U)
      GO TO 117
C
C NOT LAMBERT CONFORMAL CONIC.  CALCULATE CONSTANTS COMMON TO MOST OF
C THE OTHER PROJECTIONS.
C
  103 TMP1=U*DTOR
      TMP2=V*DTOR
      SINPH=SIN(TMP1)
      SINLA=SIN(TMP2)
      COSPH=COS(TMP1)
      COSLA=COS(TMP2)
      TCOS=COSLA*COSPH
      COSA=AMAX1(-1.,AMIN1(+1.,SINLA*SINO+TCOS*COSO))
      SINA=SQRT(1.-COSA*COSA)
      IF (SINA.LT..0001) THEN
        SINA=0.
        IF (IPRJ.GE.7.OR.COSA.LT.0.) GO TO 118
        U=0.
        V=0.
        GO TO 116
      END IF
      SINB=COSLA*SINPH/SINA
      COSB=(SINLA*COSO-TCOS*SINO)/SINA
C
C JUMP TO CODE APPROPRIATE FOR THE CHOSEN PROJECTION.
C
      GO TO (104,105,106,107,108,109,110,111) , IPRJ-1
C
C STEREOGRAPHIC.
C
  104 IF (ABS(SINA).LT..0001) THEN
        R=SINA/2.
      ELSE
        R=(1.-COSA)/SINA
      END IF
      GO TO 115
C
C ORTHOGRAPHIC OR SATELLITE-VIEW, DEPENDING ON THE VALUE OF SALT.
C
  105 IF (ABS(SALT).LE.1.) THEN
        IF (COSA.GT.0.) THEN
          R=SINA
        ELSE
          IF (SALT.GE.0.) GO TO 118
          R=2.-SINA
        END IF
        GO TO 115
      ELSE
        IF (COSA.GT.1./ABS(SALT)) THEN
          R=SRSS*SINA/(ABS(SALT)-COSA)
        ELSE
          IF (SALT.GE.0.) GO TO 118
          R=2.-SRSS*SINA/(ABS(SALT)-COSA)
        END IF
        IF (ALFA.EQ.0.) GO TO 115
        UTM1=R*(SINB*COSR+COSB*SINR)
        VTM1=R*(COSB*COSR-SINB*SINR)
        UTM2=UTM1*CBET+VTM1*SBET
        VTM2=VTM1*CBET-UTM1*SBET
        UTM3=SRSS*UTM2/(UTM2*SALF+SRSS*CALF)
        VTM3=SRSS*VTM2*CALF/(UTM2*SALF+SRSS*CALF)
        U=UTM3*CBET-VTM3*SBET
        V=VTM3*CBET+UTM3*SBET
        GO TO 116
      END IF
C
C LAMBERT EQUAL AREA.
C
  106 IF (ABS(COSA+1.).LT.1.E-6) GO TO 118
      R=(1.+COSA)/SINA
      R=2./SQRT(1.+R*R)
      GO TO 115
C
C GNOMONIC.
C
  107 IF (COSA.LE..0001) GO TO 118
      R=SINA/COSA
      GO TO 115
C
C AZIMUTHAL EQUIDISTANT.
C
  108 IF (ABS(COSA+1.).LT.1.E-6) GO TO 118
      R=ACOS(COSA)
      GO TO 115
C
C CYLINDRICAL EQUIDISTANT, ARBITRARY POLE AND ORIENTATION.
C
  109 U=ATAN2(SINB*COSR+COSB*SINR,SINB*SINR-COSB*COSR)*RTOD
      V=90.-ACOS(COSA)*RTOD
      GO TO 116
C
C MERCATOR, ARBITRARY POLE AND ORIENTATION.
C
  110 U=ATAN2(SINB*COSR+COSB*SINR,SINB*SINR-COSB*COSR)
      V=ALOG((1.+COSA)/SINA)
      GO TO 116
C
C MOLLWEIDE, ARBITRARY POLE AND ORIENTATION.
C
  111 U=ATAN2(SINB*COSR+COSB*SINR,SINB*SINR-COSB*COSR)*TOPI
      P=U
      V=COSA
      U=U*SINA
      GO TO 117
C
C FAST-PATH CYLINDRICAL PROJECTIONS (WITH PLAT=ROTA=0).
C
  112 IF (IPRJ-12) 113,114,901
C
C FAST-PATH MERCATOR.
C
  113 IF (ABS(RLAT).GT.89.9999) GO TO 118
      U=U*DTOR
      V=ALOG(TAN((RLAT+90.)*DTRH))
      GO TO 116
C
C FAST-PATH MOLLWEIDE.
C
  114 U=U/90.
      V=SIN(RLAT*DTOR)
      P=U
      U=U*SQRT(1.-V*V)
      GO TO 117
C
C COMMON TERMINAL CODE FOR CERTAIN PROJECTIONS.
C
  115 U=R*(SINB*COSR+COSB*SINR)
      V=R*(COSB*COSR-SINB*SINR)
C
  116 P=U
C
  117 Q=V
C
C NORMAL EXIT.
C
      RETURN
C
C PROJECTION OF POINT IS INVISIBLE OR UNDEFINED.
C
  118 U=1.E12
      P=U
      RETURN
C
C ERROR EXIT.
C
  901 IF (IIER.NE.0) GO TO 118
      IIER=16
      CALL SETER (' MAPTRN - ATTEMPT TO USE NON-EXISTENT PROJECTION',
     +              IIER,1)
      GO TO 118
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPUSR (IPRT)
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPVEC (XLAT,XLON)
      CALL MAPIT (XLAT,XLON,1)
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE SUPCON (RLAT,RLON,UVAL,VVAL)
      CALL MAPTRN (RLAT,RLON,UVAL,VVAL)
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE SUPMAP (JPRJ,PLAT,PLON,ROTA,PLM1,PLM2,PLM3,PLM4,JLTS,
     +                   JGRD,IOUT,IDOT,IERR)
C
      DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM5/ DDCT(5),LDCT(5),PDCT(10)
      CHARACTER*2     DDCT,LDCT,PDCT
      COMMON /MAPCMB/ IIER
C
      DIMENSION LPRJ(10),LLTS(5)
C
      DATA LPRJ / 2,3,1,4,5,6,10,7,8,9 /
      DATA LLTS / 1,2,5,4,3 /
C
C THE FOLLOWING CALL GATHERS STATISTICS ON LIBRARY USAGE AT NCAR.
C
      CALL Q8QST4 ('GRAPHX','EZMAP','SUPMAP','VERSION  1')
C
C SET EZMAP'S GRID-SPACING PARAMETER.
C
      CALL MAPSTI ('GR',MOD(IABS(JGRD),1000))
C
C SET EZMAP'S OUTLINE-SELECTION PARAMETER.
C
      IF (IABS(IOUT).EQ.0.OR.IABS(IOUT).EQ.1) THEN
        I=1+2*IABS(IOUT)+(1+ISIGN(1,JPRJ))/2
      ELSE
        I=MAX0(1,MIN0(5,IOUT))
      END IF
C
      CALL MAPSTC ('OU',DDCT(I))
C
C SET EZMAP'S PERIMETER-DRAWING FLAG.
C
      CALL MAPSTL ('PE',JGRD.GE.0)
C
C SET EZMAP'S GRID-LINE-LABELLING FLAG.
C
      CALL MAPSTL ('LA',MOD(IABS(JGRD),1000).NE.0)
C
C SET EZMAP'S DOTTED-OUTLINE FLAG.
C
      CALL MAPSTI ('DO',MAX0(0,MIN0(1,IDOT)))
C
C SET EZMAP'S PROJECTION-SELECTION PARAMETERS.
C
      I=MAX0(1,MIN0(10,IABS(JPRJ)))
      CALL MAPROJ (PDCT(LPRJ(I)),PLAT,PLON,ROTA)
C
C SET EZMAP'S RECTANGULAR-LIMITS-SELECTION PARAMETERS.
C
      I=LLTS(MAX0(1,MIN0(5,IABS(JLTS))))
      CALL MAPSET (LDCT(I),PLM1,PLM2,PLM3,PLM4)
C
C DRAW THE MAP.
C
      CALL MAPDRW
C
C RETURN THE ERROR FLAG TO THE USER.
C
      IERR=IIER
C
C DONE.
C
      RETURN
C
      END
C
C***********************************************************************
C T H E   C O D E   -   I N T E R N A L   R O U T I N E S
C***********************************************************************
C
      SUBROUTINE MAPCEM (IEM1,IEM2,IIER,IFLG)
C
      CHARACTER*(*) IEM1,IEM2
C
C MAPCEM IS CALLED TO DO A CALL TO SETER WHEN THE ERROR MESSAGE TO BE
C PRINTED IS IN TWO PARTS WHICH NEED TO BE CONCATENATED.  FORTRAN-77
C RULES MAKE IT NECESSARY TO CONCATENATE THE TWO PARTS OF THE MESSAGE
C INTO A LOCAL CHARACTER VARIABLE.
C
      CHARACTER*100 IEMC
C
      IEMC=IEM1//IEM2
      CALL SETER (IEMC,IIER,IFLG)
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPCHI (IPRT,IDTG,IDPT)
C
C MAPCHI IS CALLED BY VARIOUS EZMAP ROUTINES TO RESET THE INTENSITY,
C DOTTING, AND DASH PATTERN BEFORE AND AFTER DRAWING PARTS OF A MAP.
C
C THE ARGUMENT IPRT, IF POSITIVE, SAYS WHICH PART OF THE MAP IS ABOUT
C TO BE DRAWN, AS FOLLOWS:
C
C     IPRT    PART OF MAP.
C     ----    ------------
C       1     PERIMETER.
C       2     GRID.
C       3     LABELLING.
C       4     LIMB LINES.
C       5     OUTLINE POINT GROUP, CONTINENTAL.
C       6     OUTLINE POINT GROUP, U.S.
C       7     OUTLINE POINT GROUP, COUNTRY.
C
C A CALL WITH IPRT EQUAL TO THE NEGATIVE OF ONE OF THESE VALUES ASKS
C THAT THE INTENSITY SAVED BY THE LAST CALL, WITH IPRT POSITIVE, BE
C RESTORED.
C
C WHEN IPRT IS POSITIVE, IDTG IS ZERO IF SOLID LINES ARE TO BE USED, 1
C IF DOTTED LINES ARE TO BE USED.  IF IPRT IS NEGATIVE, IDTG IS IGNORED.
C
C WHEN IPRT IS POSITIVE AND IDTG IS ZERO, IDPT IS THE DASH PATTERN TO BE
C USED.  IF IPRT IS NEGATIVE OR IDTG IS NON-ZERO, IDPT IS IGNORED.
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPNTS/ INTS(7)
C
C DECLARE ONE OF THE DASH-PACKAGE COMMON BLOCKS, TOO.
C
      COMMON /SMFLAG/ ISMO
C
C THE VARIABLES INTO, IDTS, AND ISMS NEED TO BE SAVED BETWEEN CALLS.
C
      SAVE INTO,IDTS,ISMS
C
C FLUSH ALL BUFFERS BEFORE CHANGING ANYTHING.
C
      CALL MAPIQ
C
C SET/RESET INTENSITY, DOTTING, AND DASH PATTERN.  THE USER HAS THE
C LAST WORD.
C
      IF (IPRT.GT.0) THEN
        ISMS=ISMO
        ISMO=1
        IDTS=IDTL
        IDTL=IDTG
        IF (IDTL.EQ.0) CALL DASHDB (IDPT)
C
C THE FOLLOWING LINES HAVE BEEN COMMENTED OUT BECAUSE THE INTENSITY
C SETTING CAUSES SOME STRANGE BEHAVIOUR ON CERTAIN TERMINALS AND
C WORKSTATIONS.
C
C        CALL GETUSV ('IN',INTO)
C        CALL SETUSV ('IN',IFIX(10000.*FLOAT(INTS(IPRT))/255.))
        CALL MAPUSR (IPRT)
      ELSE
        CALL MAPUSR (IPRT)
C
C THE FOLLOWING LINE HAVE BEEN COMMENTED OUT BECAUSE THE INTENSITY
C SETTING CAUSES SOME STRANGE BEHAVIOUR ON CERTAIN TERMINALS AND
C WORKSTATIONS.
C
C        CALL SETUSV ('IN',INTO)
        IF (IDTL.EQ.0) CALL DASHDB (IOR(ISHIFT(32767,1),1))
        IDTL=IDTS
        ISMO=ISMS
      END IF
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      INTEGER FUNCTION IDICTL (ISTR,IDCT,NDCT)
C
      CHARACTER*(*) ISTR
      CHARACTER*2 IDCT(NDCT)
C
C THE VALUE OF THIS FUNCTION IS THE INDEX IN THE NDCT-ELEMENT DICTIONARY
C IDCT OF THE STRING ISTR.  ONLY THE FIRST TWO CHARACTERS OF ISTR AND
C IDCT(I) ARE COMPARED.  IF ISTR IS NOT FOUND IN THE DICTIONARY, THE
C FUNCTION VALUE IS ZERO.
C
      DO 101 I=1,NDCT
        IF (ISTR(1:2).EQ.IDCT(I)) THEN
          IDICTL=I
          RETURN
        END IF
  101 CONTINUE
C
C NOT FOUND.  RETURN A ZERO.
C
      IDICTL=0
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPIO (IACT)
C
C THIS ROUTINE PERFORMS ALL POSITIONING AND INPUT OF THE OUTLINE DATASET
C FOR MAPLOT.  THE ARGUMENT IACT SPECIFIES WHAT IS TO BE DONE:  1 ASKS
C THAT THE DATASET BE POSITIONED AT THE BEGINNING OF THE DESIRED "FILE",
C 2 THAT THE NEXT RECORD BE READ.
C
C FIVE LINES OF THE CODE BELOW HAVE BEEN INSERTED TO MAKE THIS ROUTINE
C RUN EFFICIENTLY ON NCAR'S CRAYS; THESE LINES SHOULD BE REMOVED BY
C ANYONE IMPLEMENTING EZMAP ON ANOTHER SYSTEM (EXCEPT PERHAPS ANOTHER
C CRAY).
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
      COMMON /MAPCMB/ IERR
C
      IF (IACT.EQ.1) THEN
C
C POSITION TO THE DESIRED "FILE" WITHIN THE DATASET.
C
C THE FOLLOWING FIVE LINES ARE FOR NCAR'S CRAYS.
C
C       ITPN=6LEZMPDT
C       IF (IFDNT(ITPN).EQ.0) THEN
C         CALL SDACCESS (IERR,ITPN)
C         IF (IERR.NE.0) GO TO 901
C       END IF
C
        REWIND ITPN
C
        IF (NOUT.NE.1) THEN
          ITMP=NOUT
  101     READ (ITPN,END=902) NPTS,IGID,BLAG,SLAG,BLOG,SLOG,
     +                                                (PNTS(I),I=1,NPTS)
          IF (NPTS.GT.1) GO TO 101
          ITMP=ITMP-1
          IF (ITMP.GT.1) GO TO 101
        END IF
C
      ELSE
C
C READ THE NEXT RECORD.
C
        READ (ITPN) NPTS,IGID,BLAG,SLAG,BLOG,SLOG,(PNTS(I),I=1,NPTS)
        NPTS=NPTS/2
C
      END IF
C
C DONE.
C
      RETURN
C
C ERROR EXITS.
C
  901 IIER=17
      CALL SETER (' MAPIO - OUTLINE DATASET IS UNREADABLE',IIER,1)
      NOUT=0
      RETURN
C
  902 IIER=18
      CALL SETER (' MAPIO - EOF ENCOUNTERED IN OUTLINE DATASET',IIER,1)
      NOUT=0
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPLMB
C
C THE ROUTINE MAPLMB IS CALLED BY MAPGRD AND/OR MAPLOT TO DRAW THE LIMB
C LINES.
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM1/ IPRJ,SINO,COSO,SINR,COSR,PHOC
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C DEFINE REQUIRED CONSTANTS.  SIN1 AND COS1 ARE RESPECTIVELY THE SINE
C AND COSINE OF ONE DEGREE.
C
      DATA SIN1 / .017452406437283 /
      DATA COS1 / .999847695156390 /
      DATA PI   / 3.14159265358979 /
C
C THE ARITHMETIC STATEMENT FUNCTIONS FLOOR AND CLING GIVE, RESPECTIVELY,
C THE "FLOOR" OF X - THE LARGEST INTEGER LESS THAN OR EQUAL TO X - AND
C THE "CEILING" OF X - THE SMALLEST INTEGER GREATER THAN OR EQUAL TO X.
C
      FLOOR(X)=AINT(X+1.E4)-1.E4
      CLING(X)=-FLOOR(-X)
C
C RESET THE INTENSITY, DOTTING, AND DASH PATTERN FOR LIMB LINES.
C
      CALL MAPCHI (4,0,IOR(ISHIFT(32767,1),1))
C
C DRAW LIMB LINES, THE NATURE OF WHICH DEPENDS ON THE PROJECTION.
C
      GO TO (101,110,104,105,110,106,110,110,107,110,110,107) , IPRJ
C
C LAMBERT CONFORMAL CONIC WITH TWO STANDARD PARALLELS.
C
  101 DLAT=GRDR
      RLON=PHIO+179.9999
      K=CLING(180./DLAT)
      DO 103 I=1,2
        RLAT=-90.
        CALL MAPIT (RLAT,RLON,0)
        DO 102 J=1,K-1
          RLAT=RLAT+DLAT
          CALL MAPIT (RLAT,RLON,1)
  102   CONTINUE
        RLAT=RLAT+DLAT
        CALL MAPIT (RLAT,RLON,2)
        RLON=PHIO-179.9999
  103 CONTINUE
      GO TO 110
C
C ORTHOGRAPHIC (OR SATELLITE-VIEW).
C
  104 IF (ABS(SALT).LE.1..OR.ALFA.EQ.0.) THEN
        URAD=1.
        RVTU=1.
      ELSE
        DNOM=SALT*SALT*CALF*CALF-1.
        URAD=SSMO*CALF/DNOM
        RVTU=SQRT(DNOM)/SRSS
      END IF
      GO TO 108
C
C LAMBERT EQUAL AREA.
C
  105 URAD=2.
      RVTU=1.
      GO TO 108
C
C AZIMUTHAL EQUIDISTANT.
C
  106 URAD=PI
      RVTU=1.
      GO TO 108
C
C MOLLWEIDE.
C
  107 URAD=2.
      RVTU=0.5
C
  108 UCIR=URAD
      VCIR=0.
      IVIS=-1
      DO 109 I=1,361
        IF (IPRJ.NE.3.OR.ABS(SALT).LE.1..OR.ALFA.EQ.0.) THEN
          U=UCIR
          V=RVTU*VCIR
        ELSE
          UTMP=UCIR-SRSS*SALF/DNOM
          VTMP=RVTU*VCIR
          U=UTMP*CBET-VTMP*SBET
          V=VTMP*CBET+UTMP*SBET
        END IF
        IF (.NOT.ELPF.AND.
     +      (U.LT.UMIN.OR.U.GT.UMAX.OR.V.LT.VMIN.OR.V.GT.VMAX)) THEN
          IF (IVIS.EQ.1) THEN
            CALL MAPTRP (UOLD,VOLD,U,V,UEDG,VEDG)
            CALL MAPVP  (UOLD,VOLD,UEDG,VEDG)
          END IF
          IVIS=0
        ELSE IF (ELPF.AND.
     +           (((U-UCEN)/URNG)**2+((V-VCEN)/VRNG)**2.GT.1.)) THEN
          IF (IVIS.EQ.1) THEN
            CALL MAPTRE (UOLD,VOLD,U,V,UEDG,VEDG)
            CALL MAPVP  (UOLD,VOLD,UEDG,VEDG)
          END IF
          IVIS=0
        ELSE
          IF (IVIS.LT.0) THEN
            DATL=0.
            CALL FRSTD (U,V)
            IVIS=1
          ELSE
            IF (IVIS.EQ.0) THEN
              IF (.NOT.ELPF) CALL MAPTRP (U,V,UOLD,VOLD,UOLD,VOLD)
              IF (     ELPF) CALL MAPTRE (U,V,UOLD,VOLD,UOLD,VOLD)
              DATL=0.
              CALL FRSTD (UOLD,VOLD)
              IVIS=1
            END IF
            CALL MAPVP (UOLD,VOLD,U,V)
          END IF
        END IF
        UOLD=U
        VOLD=V
        UTMP=UCIR
        VTMP=VCIR
        UCIR=UTMP*COS1-VTMP*SIN1
        VCIR=UTMP*SIN1+VTMP*COS1
  109 CONTINUE
C
C RESTORE THE ORIGINAL INTENSITY, DOTTING, AND DASH PATTERN.
C
  110 CALL MAPCHI (-4,0,0)
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPTRE (UINS,VINS,UOUT,VOUT,UINT,VINT)
C
C THIS ROUTINE FINDS THE POINT OF INTERSECTION (UINT,VINT) OF THE LINE
C FROM (UINS,VINS) TO (UOUT,VOUT) WITH THE EDGE OF AN ELLIPTICAL FRAME.
C THE FIRST POINT IS INSIDE THE FRAME AND THE SECOND OUTSIDE THE FRAME.
C
C BECAUSE MAPTRE CAN BE CALLED WITH THE SAME ACTUAL ARGUMENTS FOR UINT
C AND VINT AS FOR UOUT AND VOUT, RESPECTIVELY, UINT AND VINT MUST NOT
C BE RESET UNTIL ALL USE OF UOUT AND VOUT IS COMPLETE.
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
C
C WHAT'S INVOLVED IS JUST A LOT OF ALGEBRA.
C
      IF (ABS(UOUT-UINS).GT.ABS(VOUT-VINS)) THEN
        P=(VOUT-VINS)/(UOUT-UINS)
        Q=(UOUT*VINS-UINS*VOUT)/(UOUT-UINS)
        A=VRNG*VRNG+P*P*URNG*URNG
        B=2.*(P*Q*URNG*URNG-UCEN*VRNG*VRNG-P*URNG*URNG*VCEN)
        C=UCEN*UCEN*VRNG*VRNG+Q*Q*URNG*URNG-2.*Q*URNG*URNG*VCEN+
     +                           URNG*URNG*VCEN*VCEN-URNG*URNG*VRNG*VRNG
        UTM1=SQRT(AMAX1(B*B-4.*A*C,0.))
        UTM2=.5*(-B-UTM1)/A
        IF ((UTM2-UOUT)*(UTM2-UINS).GT.0.) UTM2=.5*(-B+UTM1)/A
        UINT=UTM2
        VINT=P*UINT+Q
      ELSE
        P=(UOUT-UINS)/(VOUT-VINS)
        Q=(UINS*VOUT-UOUT*VINS)/(VOUT-VINS)
        A=URNG*URNG+P*P*VRNG*VRNG
        B=2.*(P*Q*VRNG*VRNG-URNG*URNG*VCEN-P*UCEN*VRNG*VRNG)
        C=URNG*URNG*VCEN*VCEN+Q*Q*VRNG*VRNG-2.*Q*UCEN*VRNG*VRNG+
     +                           UCEN*UCEN*VRNG*VRNG-URNG*URNG*VRNG*VRNG
        VTM1=SQRT(AMAX1(B*B-4.*A*C,0.))
        VTM2=.5*(-B-VTM1)/A
        IF ((VTM2-VOUT)*(VTM2-VINS).GT.0.) VTM2=.5*(-B+VTM1)/A
        VINT=VTM2
        UINT=P*VINT+Q
      END IF
C
C DONE.
C
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPTRP (UINS,VINS,UOUT,VOUT,UINT,VINT)
C
C THIS ROUTINE FINDS THE POINT OF INTERSECTION (UINT,VINT) OF THE LINE
C FROM (UINS,VINS) TO (UOUT,VOUT) WITH THE EDGE OF A RECTANGULAR FRAME.
C THE FIRST POINT IS INSIDE THE FRAME AND THE SECOND OUTSIDE THE FRAME.
C
C BECAUSE MAPTRP CAN BE CALLED WITH THE SAME ACTUAL ARGUMENTS FOR UINT
C AND VINT AS FOR UOUT AND VOUT, RESPECTIVELY, UINT AND VINT MUST NOT
C BE RESET UNTIL ALL USE OF UOUT AND VOUT IS COMPLETE.
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
C
C GIVEN ONE COORDINATE OF A POINT ON THE LINE JOINING (UINS,VINS) AND
C (UOUT,VOUT), THE OTHER CAN BE OBTAINED BY USING ONE OF THE FOLLOWING
C ARITHMETIC STATEMENT FUNCTIONS:
C
      UFUN(V)=UINS+(V-VINS)*DU/DV
      VFUN(U)=VINS+(U-UINS)*DV/DU
C
C                                      I     I
C                                   5  I  4  I  6
C                                      I     I
C                                 -----------------
C FIRST, DETERMINE IN WHICH            I     I
C OF THE AREAS SHOWN THE            2  I  1  I  3
C POINT (UOUT,VOUT) LIES.              I     I
C                                 -----------------
C                                      I     I
C                                   8  I  7  I  9
C                                      I     I
C
      IREA=1
      IF (UOUT-UMIN) 101,104,102
  101 IREA=IREA+1
      GO TO 104
  102 IF (UOUT-UMAX) 104,104,103
  103 IREA=IREA+2
  104 IF (VOUT-VMIN) 105,108,106
  105 IREA=IREA+6
      GO TO 108
  106 IF (VOUT-VMAX) 108,108,107
  107 IREA=IREA+3
C
C NEXT, COMPUTE THE QUANTITIES REQUIRED BY UFUN AND VFUN AND JUMP TO THE
C APPROPRIATE PIECE OF CODE FOR THE GIVEN AREA.
C
  108 DU=UOUT-UINS
      DV=VOUT-VINS
C
      GO TO (119,113,114,115,109,110,116,111,112) , IREA
C
  109 IF (UFUN(VMAX)-UMIN) 113,115,115
  110 IF (UFUN(VMAX)-UMAX) 115,115,114
  111 IF (UFUN(VMIN)-UMIN) 113,116,116
  112 IF (UFUN(VMIN)-UMAX) 116,116,114
C
  113 UINT=UMIN
      GO TO 117
  114 UINT=UMAX
      GO TO 117
  115 VINT=VMAX
      GO TO 118
  116 VINT=VMIN
      GO TO 118
C
  117 VINT=VFUN(UINT)
      RETURN
C
  118 UINT=UFUN(VINT)
      RETURN
C
  119 UINT=UOUT
      VINT=VOUT
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MAPVP (UOLD,VOLD,U,V)
C
C PLOT THE LINE SEGMENT FROM (UOLD,VOLD) TO (U,V), USING EITHER A SOLID
C LINE OR A DOTTED LINE (DEPENDING ON THE VALUE OF THE COMMON VARIABLE
C IDTL).
C
C DECLARE REQUIRED COMMON BLOCKS.  SEE MAPBD FOR DESCRIPTIONS OF THESE
C COMMON BLOCKS AND THE VARIABLES IN THEM.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
      LOGICAL         INTF,LBLF,PRMF,ELPF
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
      COMMON /MAPCMP/ NPTB,XPTB(50),YPTB(50)
C
C SELECT VECTOR OR DOT MODE.
C
      IF (IDTL.EQ.0) THEN
C
C USE A SINGLE VECTOR.
C
        CALL VECTD (U,V)
C
      ELSE
C
C USE DOTS.  DELU AND DELV ARE THE U AND V COMPONENTS OF THE VECTOR
C JOINING (UOLD,VOLD) TO (U,V) AND VLEN IS THE LENGTH OF THE VECTOR.
C
        DELU=U-UOLD
        DELV=V-VOLD
C
        VLEN=SQRT(DELU*DELU+DELV*DELV)
C
C NOW DISTRIBUTE DOTS ALONG THE VECTOR.  THE FIRST ONE IS SPACED JUST
C FAR ENOUGH ALONG IT (DATL UNITS) TO BE DBTD UNITS AWAY FROM THE LAST
C DOT ON THE PREVIOUS VECTOR AND THE REST ARE DBTD UNITS APART.
C
  101   IF (DATL.LT.VLEN) THEN
          IF (NPTB.GE.50) THEN
            CALL POINTS (XPTB,YPTB,NPTB,0,0)
            NPTB=0
          END IF
          NPTB=NPTB+1
          XPTB(NPTB)=UOLD+(DATL/VLEN)*DELU
          YPTB(NPTB)=VOLD+(DATL/VLEN)*DELV
          DATL=DATL+DBTD
          GO TO 101
        END IF
C
C SET DATL FOR THE NEXT CALL.
C
        DATL=DATL-VLEN
C
      END IF
C
C DONE.
C
      RETURN
C
      END
C
C***********************************************************************
C T H E   B L O C K   D A T A   " R O U T I N E "   -   D E F A U L T S
C***********************************************************************
C
      BLOCK DATA MAPBD
C
C THE COMMON BLOCK MAPCM1 CONTAINS TRANSFORMATION CONSTANTS.
C
      COMMON /MAPCM1/ IPRJ,SINO,COSO,SINR,COSR,PHOC
C
C THE COMMON BLOCK MAPCM2 CONTAINS AREA-SPECIFICATION VARIABLES.
C
      COMMON /MAPCM2/ UMIN,UMAX,VMIN,VMAX,UEPS,VEPS,UCEN,VCEN,URNG,VRNG,
     +                BLAM,SLAM,BLOM,SLOM
C
C THE COMMON BLOCK MAPCM3 CONTAINS PARAMETERS HAVING TO DO WITH READING
C THE DATA FOR OUTLINES.
C
      COMMON /MAPCM3/ ITPN,NOUT,NPTS,IGID,BLAG,SLAG,BLOG,SLOG,PNTS(200)
C
C THE COMMON BLOCK MAPCM4 CONTAINS MOST OF THE INPUT PARAMETERS.
C
      COMMON /MAPCM4/ INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,
     +                PLB1,PLB2,PLB3,PLB4,PLTR,GRID,IDSH,IDOT,LBLF,PRMF,
     +                ELPF,XLOW,XROW,YBOW,YTOW,IDTL,GRDR,SRCH,ILCW
C
      LOGICAL         INTF,LBLF,PRMF,ELPF
C
C THE COMMON BLOCK MAPCM5 CONTAINS VARIOUS LISTS ("DICTIONARIES") OF
C TWO-CHARACTER CODES REQUIRED BY EZMAP FOR PARAMETER-SETTING.
C
      COMMON /MAPCM5/ DDCT(5),LDCT(5),PDCT(10)
C
      CHARACTER*2     DDCT,LDCT,PDCT
C
C THE COMMON BLOCK MAPCM7 CONTAINS PARAMETERS DESCRIBING THE PORTION OF
C THE PLOTTER FRAME BEING USED.
C
      COMMON /MAPCM7/ ULOW,UROW,VBOW,VTOW
C
C THE COMMON BLOCK MAPCM8 CONTAINS PARAMETERS SET BY MAPTRN AND USED BY
C MAPIT IN HANDLING "CROSS-OVER" PROBLEMS.
C
      COMMON /MAPCM8/ P,Q,R
C
C THE COMMON BLOCK MAPCMA CONTAINS VALUES WHICH ARE USED TO POSITION
C DOTS ALONG DOTTED OUTLINES AND TO AVOID DRAWING VECTORS WHICH ARE
C TOO SHORT.
C
      COMMON /MAPCMA/ DPLT,DDTS,DSCA,DPSQ,DSSQ,DBTD,DATL
C
C THE COMMON BLOCK MAPCMB CONTAINS THE EZMAP ERROR FLAG.
C
      COMMON /MAPCMB/ IIER
C
C THE COMMON BLOCK MAPCMP CONTAINS THE BUFFERS IN WHICH THE X AND Y
C COORDINATES OF POINTS ARE COLLECTED FOR AN EVENTUAL CALL TO POINTS.
C
      COMMON /MAPCMP/ NPTB,XPTB(50),YPTB(50)
C
C THE COMMON BLOCK MAPNTS CONTAINS QUANTITIES SPECIFYING THE INTENSITIES
C TO BE USED FOR VARIOUS PORTIONS OF THE PLOT.
C
      COMMON /MAPNTS/ INTS(7)
C
C THE COMMON BLOCK MAPSAT CONTAINS PARAMETERS FOR THE SATELLITE-VIEW
C PROJECTION.
C
      COMMON /MAPSAT/ SALT,SSMO,SRSS,ALFA,BETA,SALF,CALF,SBET,CBET
C
C
C BELOW ARE DESCRIPTIONS OF THE VARIABLES IN EACH OF THE COMMON BLOCKS,
C TOGETHER WITH DATA STATEMENTS GIVING DEFAULT VALUES TO THOSE VARIABLES
C WHICH NEED DEFAULT VARIABLES.
C
C
C VARIABLES IN MAPCM1:
C
C IPRJ IS AN INTEGER BETWEEN 1 AND 12, SPECIFYING WHAT PROJECTION IS
C CURRENTLY IN USE.  THE VALUES 10, 11, AND 12 SPECIFY FAST-PATH
C VERSIONS OF THE VALUES 7, 8, AND 9, RESPECTIVELY.  SINO, COSO, SINR,
C COSR, AND PHOC ARE PROJECTION VARIABLES COMPUTED BY MAPINT FOR USE BY
C MAPTRN.  PHOC, AS IT HAPPENS, IS JUST A COPY OF PHIO, FROM THE COMMON
C BLOCK MAPCM4.
C
C
C VARIABLES IN MAPCM2:
C
C UMIN, UMAX, VMIN, AND VMAX SPECIFY THE LIMITS OF THE RECTANGLE TO BE
C DRAWN, IN PROJECTION SPACE.  UEPS AND VEPS ARE SET BY MAPINT FOR USE
C IN MAPIT IN TESTING FOR CROSS-OVER PROBLEMS.  UCEN, VCEN, URNG, AND
C VRNG ARE COMPUTED BY MAPINT FOR USE WHEN THE MAP PERIMETER IS MADE
C ELLIPTICAL (BY SETTING THE FLAG ELPF).  BLAM, SLAM, BLOM, AND SLOM
C ARE RESPECTIVELY THE BIGGEST LATITUDE, THE  SMALLEST LATITUDE, THE
C BIGGEST LONGITUDE, AND THE SMALLEST LONGITUDE ON THE MAP.  THEY ARE
C USED IN MAPGRD AND IN MAPLOT TO MAKE THE DRAWING OF GRIDS AND OUTLINES
C MORE EFFICIENT.  UMIN AND UMAX ARE GIVEN DEFAULT VALUES TO PREVENT
C IN MAPSTI AND MAPSTR FROM BLOWING UP WHEN PLTR IS SET PRIOR TO THE
C FIRST CALL TO MAPINT.
C
      DATA UMIN,UMAX / 0.,1. /
C
C
C VARIABLES IN MAPCM3:
C
C ITPN IS THE UNIT NUMBER OF THE "TAPE" FROM WHICH OUTLINE DATA IS TO
C BE READ.  NOUT IS THE NUMBER OF THE OUTLINE TO BE USED; THE VALUES 0
C THROUGH 5 IMPLY 'NO', 'CO', 'US', 'PS', AND 'PO', RESPECTIVELY; THUS,
C IF NOUT IS ZERO, NO OUTLINES ARE TO BE USED, AND, IF IT IS NON-ZERO,
C IT IS THE NUMBER OF THE "FILE" TO BE READ FROM UNIT ITPN.  NPTS, JUST
C AFTER A READ, IS THE NUMBER OF ELEMENTS READ INTO PNTS; IT IS THEN
C DIVIDED BY 2 TO BECOME THE NUMBER OF POINTS DEFINED BY THE GROUP JUST
C READ.  IGID IS AN IDENTIFIER FOR THE GROUP, SO THAT, FOR EXAMPLE, ONE
C CAN DISTINGUISH A GROUP BELONGING TO A INTERNATIONAL BOUNDARY FROM
C ONE BELONGING TO A U.S. STATE BOUNDARY.  BLAG, SLAG, BLOG, AND SLOG
C SPECIFY THE BIGGEST AND SMALLEST LATITUDE AND THE BIGGEST AND SMALLEST
C LONGITUDE OF THE POINTS IN THE GROUP, SO THAT, IN SOME CASES AT LEAST,
C ONE CAN DECIDE QUICKLY NOT TO BOTHER WITH THE GROUP.  PNTS CONTAINS
C NPTS COORDINATE PAIRS, EACH CONSISTING OF A LATITUDE AND A LONGITUDE,
C IN DEGREES.
C
      DATA ITPN,NOUT / 1,1 /
C
C
C VARIABLES IN MAPCM4:
C
C INTF IS A FLAG WHOSE VALUE AT ANY GIVEN TIME INDICATES WHETHER THE
C PACKAGE EZMAP IS IN NEED OF INITIALIZATION (.TRUE.) OR NOT (.FALSE).
C JPRJ IS AN INTEGER BETWEEN 1 AND 9 INDICATING THE TYPE OF PROJECTION
C CURRENTLY IN USE.  PHIA, PHIO, AND ROTA ARE THE POLE LATITUDE AND
C LONGITUDE AND THE ROTATION ANGLE SPECIFIED BY THE LAST USER CALL TO
C MAPROJ.  ILTS IS AN INTEGER BETWEEN 1 AND 5, SPECIFYING HOW THE LIMITS
C OF THE MAP ARE TO BE CHOSEN.  PLA1-4 AND PLB1-4 ARE THE VALUES GIVEN
C BY THE USER FOR PLM1(1), PLM2(1), ..., PLM1(2), PLM2(2), ..., IN THE
C LAST CALL TO MAPSET.  PLTR IS THE PLOTTER RESOLUTION - EFFECTIVELY,
C THE NUMBER OF ADDRESSABLE POINTS IN THE X DIRECTION.  GRID IS THE
C DESIRED SPACING BETWEEN GRID LINES, IN DEGREES OF LATITUDE/LONGITUDE.
C IDSH IS THE DESIRED DASH PATTERN (16-BIT BINARY) FOR GRID LINES.  IDOT
C IS A FLAG SELECTING SOLID OUTLINES (0) OR DOTTED OUTLINES (1).  LBLF
C IS A LOGICAL FLAG INDICATING WHETHER THE INTERNATIONAL DATE LINE, THE
C EQUATOR, THE GREENWICH MERIDIAN, AND THE POLES ARE TO BE LABELLED OR
C NOT.  PRMF IS A LOGICAL FLAG INDICATING WHETHER OR NOT A PERIMETER
C IS TO BE DRAWN.  ELPF IS A LOGICAL FLAG INDICATING WHETHER THE MAP
C PERIMETER IS TO BE RECTANGULAR (.FALSE.) OR ELLIPTICAL (.TRUE.).
C XLOW, XROW, YBOW, AND YTOW ARE FRACTIONS BETWEEN 0. AND 1. SPECIFYING
C THE POSITION OF AREA OF THE PLOTTER FRAME IN WHICH THE MAP IS TO BE
C PUT; THE MAP IS CENTERED IN THIS AREA AND MADE AS LARGE AS POSSIBLE.
C IDTL IS A FLAG SPECIFYING THAT MAPIT SHOULD DRAW SOLID OUTLINES (0)
C OR DOTTEN OUTLINES (1).  GRDR AND SRCH ARE MEASURED IN DEGREES AND
C LIE IN THE RANGE FROM .001 TO 10.  GRDR SPECIFIES THE RESOLUTION WITH
C WHICH THE GRID IS TO BE DRAWN AND SRCH THE ACCURACY WITH WHICH THE
C LATITUDE/LONGITUDE LIMITS OF THE MAP ARE TO BE FOUND.  ILCW IS THE
C CHARACTER WIDTH FOR CHARACTERS IN THE LABEL, AS REQUIRED FOR USE IN A
C CALL TO PWRIT.
C
      DATA INTF,JPRJ,PHIA,PHIO,ROTA,ILTS,PLA1,PLA2,PLA3,PLA4,PLB1,PLB2 /
     1   .TRUE.,   7,  0.,  0.,  0.,   1,  0.,  0.,  0.,  0.,  0.,  0. /
C
      DATA PLB3,PLB4, PLTR,GRID, IDSH,IDOT, LBLF , PRMF ,  ELPF ,IDTL /
     1       0.,  0.,4096., 10.,21845,   0,.TRUE.,.TRUE.,.FALSE.,   0 /
C
      DATA XLOW,XROW,YBOW,YTOW / .05,.95,.05,.95 /
C
      DATA GRDR,SRCH / 1.,1. /
C
      DATA ILCW / 1 /
C
C
C VARIABLES IN MAPCM5:
C
C DDCT IS THE DICTIONARY OF AVAILABLE DATASETS, LDCT THE DICTIONARY OF
C MAP LIMIT DEFINITION TYPES, AND PDCT THE DICTIONARY OF MAP PROJECTION
C NAMES.
C
      DATA DDCT / 'NO','CO','US','PS','PO' /
C
      DATA LDCT / 'MA','CO','PO','AN','LI' /
C
      DATA PDCT / 'LC','ST','OR','LE','GN','AE','CE','ME','MO','SV' /
C
C
C VARIABLES IN MAPCM7:
C
C ULOW, UROW, VBOW, AND VTOW DEFINE THE FRACTION OF THE PLOTTER FRAME
C TO BE OCCUPIED BY THE MAP - THEY MAY BE THOUGHT OF AS THE FIRST FOUR
C ARGUMENTS OF THE SET CALL OR, IN THE GKS SCHEME, AS THE VIEWPORT.
C THEY ARE COMPUTED BY MAPINT.  ULOW AND UROW ARE GIVEN DEFAULT VALUES
C TO PREVENT CODE IN MAPSTI AND MAPSTR FROM BLOWING UP WHEN PLTR IS
C SET PRIOR TO THE FIRST CALL TO MAPINT.
C
      DATA ULOW,UROW / 0.,1. /
C
C
C VARIABLES IN MAPCM8:
C
C P, Q, AND R ARE SET BY MAPTRN EACH TIME IT MAPS (RLAT,RLON) TO (U,V).
C Q IS ALWAYS EQUAL TO V, BUT P IS NOT ALWAYS EQUAL TO U.  INSTEAD, IT
C IS A VALUE OF U FROM AN INTERMEDIATE STEP IN THE PROJECTION PROCESS.
C FOR THE LAMBERT CONFORMAL CONIC, P IS THE DISTANCE, IN LONGITUDE, FROM
C THE CENTRAL MERIDIAN.  FOR THE CYLINDRICAL PROJECTIONS, P IS A VALUE
C OF U PRIOR TO MULTIPLICATION BY A FUNCTION OF V SHRINKING THE MAP
C TOWARD A VERTICAL BISECTOR.  THEY ARE ALL USED BY MAPIT, WHILE DRAWING
C LINES FROM POINT TO POINT, TO DETECT "CROSS-OVER" (A JUMP FROM ONE
C SIDE OF THE MAP TO THE OTHER, CAUSED BY THE PROJECTION'S HAVING SLIT
C THE GLOBE ALONG SOME HALF OF A GREAT CIRCLE AND LAID IT OPEN WITH THE
C TWO SIDES OF THE SLIT AT OPPOSITE ENDS OF THE MAP).
C
C
C VARIABLES IN MAPCMA:
C
C DPLT IS THE MIMIMUM VECTOR LENGTH; MAPIT REQUIRES TWO POINTS TO BE AT
C LEAST DPLT PLOTTER UNITS APART BEFORE IT WILL JOIN THEM WITH A VECTOR.
C DDTS IS THE DESIRED DISTANCE IN PLOTTER UNITS BETWEEN DOTS IN A DOTTED
C OUTLINE.  THESE VALUES ARE RELATIVE TO THE "PLOTTER RESOLUTION" PLTR;
C DPLT/PLTR IS A FRACTION OF THE PLOTTER FRAME.  DSCA IS THE RATIO OF
C THE LENGTH OF A VECTOR, MEASURED IN PLOTTER UNITS, TO THE LENGTH OF
C THE SAME VECTOR, MEASURED IN THE U/V PLANE.  THUS, GIVEN A VECTOR OF
C LENGTH D IN THE U/V PLANE, D*DSCA IS ITS LENGTH IN PLOTTER UNITS.
C DPSQ AND DSSQ ARE THE SQUARES OF DPLT AND DSCA, RESPECTIVELY.  DBTD
C IS THE DISTANCE, IN THE U/V PLANE, BETWEEN TWO DOTS DDTS PLOTTER
C UNITS APART.  DPLT AND DDTS HAVE THE VALUES GIVEN BELOW AND ARE NOT
C RESET BY THE CODE; DSCA, DPSQ, DSSQ, AND DBTD ARE COMPUTED BY MAPINT.
C DSCA IS GIVEN A DEFAULT VALUE ONLY TO KEEP THE ROUTINES MAPSTI AND
C MAPSTR FROM BLOWING UP WHEN DDTS IS SET PRIOR TO ANY CALL TO MAPINT.
C DATL IS USED BY MAPIT AND MAPVP TO KEEP TRACK OF WHERE THE NEXT POINT
C ALONG A CURVE SHOULD GO.
C
      DATA DPLT,DDTS,DSCA / 4.,12.,1. /
C
C
C VARIABLES IN MAPCMB:
C
C IIER IS AN ERROR FLAG, SET WHENEVER AN ERROR OCCURS DURING A CALL TO
C ONE OF THE EZMAP ROUTINES.  ITS VALUE MAY BE RETRIEVED BY A CALL TO
C MAPGTI.
C
      DATA IIER / 0 /
C
C
C VARIABLES IN MAPCMP:
C
C NPTB IS THE NUMBER OF POINTS WHOSE COORDINATES HAVE BEEN COLLECTED IN
C THE ARRAYS XPTB AND YPTB FOR EVENTUAL OUTPUT BY A CALL TO POINTS.
C
      DATA NPTB / 0 /
C
C VARIABLES IN MAPNTS:
C
C THE ARRAY INTS SPECIFIES INTENSITIES TO BE USED FOR THE PERIMETER, FOR
C THE GRID, FOR LABELLING, FOR LIMBS, FOR THE CONTINENTAL OUTLINES, FOR
C THE U.S. STATE OUTLINES, AND FOR INTERNATIONAL POLITICAL OUTLINES.
C SEE THE ROUTINE MAPCHI.  EACH ELEMENT IS AN INTEGER IN THE RANGE 0 TO
C 255, INCLUSIVE.
C
      DATA INTS / 240,150,210,240,240,180,210 /
C
C
C VARIABLES IN MAPSAT:
C
C THE ABSOLUTE VALUE OF SALT, IF GREATER THAN 1, SERVES AS A FLAG THAT
C A SATELLITE-VIEW PROJECTION IS TO BE USED IN PLACE OF AN ORTHOGRAPHIC
C PROJECTION; ITS VALUE IS THE DISTANCE OF THE SATELLITE FROM THE CENTER
C OF THE EARTH, IN UNITS OF EARTH RADII.  IN THIS CASE, SSMO IS THE
C SQUARE OF SALT MINUS 1 AND SRSS IS THE SQUARE ROOT OF SSMO.  IF ALFA
C IS ZERO, THE PROJECTION SHOWS THE VIEW SEEN BY A SATELLITE LOOKING
C STRAIGHT AT THE CENTER OF THE EARTH; CALL THIS THE BASIC SATELLITE
C VIEW.  IF ALFA IS NON-ZERO, IT AND BETA ARE ANGLES, IN DEGREES,
C DETERMINING WHERE THE LINE OF SIGHT OF THE PROJECTION IS.  IF E IS
C AT THE CENTER OF THE EARTH, S IS AT THE SATELLITE, AND P IS A POINT
C ALONG THE LINE OF SIGHT, THEN ALFA MEASURES THE ANGLE ESP.  IF O IS
C THE POINT AT THE ORIGIN OF THE BASIC SATELLITE VIEW AND P IS THE
C PROJECTION OF THE LINE OF SIGHT, THEN BETA MEASURES THE ANGULAR
C DISTANCE FROM THE POSITIVE U AXIS TO THE LINE OP, POSITIVE IF
C MEASURED COUNTER-CLOCKWISE.  SALF, CALF, SBET, AND CBET ARE SINES
C AND COSINES OF ALFA AND BETA.  THE SIGN OF SALT INDICATES WHETHER A
C NORMAL PROJECTION (POSITIVE) OR AN EXTENDED PROJECTION (NEGATIVE)
C IS TO BE USED.  THE LATTER MAKES IT EASIER TO OVERLAY CONREC OUTPUT
C ON ONE OF THESE PROJECTIONS, BY PROJECTING POINTS OUT OF SIGHT AROUND
C THE LIMB TO POINT JUST OUTSIDE THE LIMB ON THE PROJECTED VIEW.
C
      DATA SALT,ALFA,BETA,SALF,CALF,SBET,CBET / 0.,0.,0.,0.,1.,0.,1. /
C
C REVISION HISTORY:
C
C FEBRUARY, 1982   ADDED MODIFICATIONS SO THAT POINTS GENERATED BY THE
C                  DRAWING OF DOTTED CONTINENTAL OUTLINES ARE BUFFERED
C                  AND THEN PUT OUT WITH A CALL TO POINTS, INSTEAD OF
C                  BEING PUT OUT ONE AT A TIME WITH A CALL TO POINT AS
C                  BEFORE.  THE LATTER RESULTED IN HUGE OVERHEAD IN THE
C                  PLOT FILE.  ROUTINES MAPLOT AND MAPVP WERE MODIFIED,
C                  AND A NEW COMMON BLOCK MAPCMP WAS ADDED.
C
C AUGUST, 1984     CONVERTED TO FORTRAN-77 AND GKS.  DELETED THE EZMAP
C                  ENTRY POINT.
C
C MARCH, 1985      COMPLETELY OVERHAULED THE CODE TO SIMPLIFY IT AND TO
C                  REMOVE KNOWN ERRORS.  UPDATED THE OUTLINE DATASET
C                  TO REMOVE ERRORS AND TO INCLUDE INTERNATIONAL
C                  BOUNDARIES.  IMPLEMENTED MANY CONTROLS AIMED AT
C                  OBVIATING THE NEED FOR SOURCE MODIFICATION BY USERS.
C
C MAY, 1985        ADDED CODE TO PREVENT PROBLEMS WHEN A SMOOTHING
C                  VERSION OF THE DASH PACKAGE IS LOADED.  ADDED CODE
C                  IN MAPIT TO GET AROUND A CFT COMPILER PROBLEM.
C                  ADDED CODE TO DO EXTENDED ORTHOGRAPHIC AND SATELLITE-
C                  VIEW PROJECTIONS.
C
C JULY, 1985       FIXED A MISSING DECLARATION IN THE SUBROUTINE MAPSET
C                  AND LIMITED "CALL PLOTIT (0,0,0)" TO THE GKS VERSION.
C
C AUGUST, 1985     FIXED A PROBLEM IN MAPGRD WHICH CAUSED MERIDIANS ON
C                  MERCATOR MAPS WITH VERTICAL LIMITS TOO CLOSE TO THE
C                  POLES TO BE DRAWN IMPROPERLY.  (THE TEST FOR CROSS-
C                  OVER, IN MAPIT, WAS BEING PASSED BECAUSE THE POINTS
C                  USED TO DRAW THE MERIDIANS WERE TOO FAR APART.)  ALSO
C                  FIXED AN ERROR IN THE GKS CODE IN MAPCHI AND BEEFED
C                  UP THE IMPLEMENTORS' INSTRUCTIONS TO SAY WHAT TO DO
C                  WITH THAT ROUTINE WHEN COLOR IS AVAILABLE.
C
C NOVEMBER, 1985   ADDED CODE TO PREVENT GKS CLIPPING FROM DESTROYING
C                  PART OF THE PERIMETER.
C
      END

include	defs

# prompt - write to/read from teletype

   subroutine prompt (str, buf, fd)
   character str(ARB), buf(ARB)
   filedes fd

   integer isatty

   if (isatty(fd) == YES)
	 {
	 call putlin (str, fd)
	 call flush (fd)
	 }
   call getlin (buf, fd)

   return
   end

C FUNCTION DETERM.F
C
C SOURCE
C   BEVINGTON, PAGE 294.
C
C PURPOSE
C   CALCULATE THE DETERMINANT OF A SQUARE MATRIX
C
C USAGE 
C   DET = DETERM (ARRAY, NORDER)
C
C DESCRIPTION OF PARAMETERS
C   ARRAY  - MATRIX
C   NORDER - ORDER OF DETERMINANT (DEGREE OF MATRIX)
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE
C
C COMMENTS
C   THIS SUBPROGRAM DESTROYS THE INPUT MATRIX ARRAY
C   DIMENSION STATEMENT VALID FOR NORDER UP TO 10
C
	FUNCTION DETERM (ARRAY,NORDER)
	DOUBLE PRECISION ARRAY,SAVE
	DIMENSION ARRAY(10,10)
C
10	DETERM=1.
11	DO 50 K=1,NORDER
C
C INTERCHANGE COLUMNS IF DIAGONAL ELEMENT IS ZERO
C
	IF (ARRAY(K,K)) 41,21,41
21	DO 23 J=K,NORDER
	IF (ARRAY(K,J)) 31,23,31
23	CONTINUE
	DETERM=0.
	GOTO 60 
31	DO 34 I=K,NORDER
	SAVE=ARRAY(I,J) 
	ARRAY(I,J)=ARRAY(I,K)
34	ARRAY(I,K)=SAVE 
	DETERM=-DETERM
C
C SUBTRACT ROW K FROM LOWER ROWS TO GET DIAGONAL MATRIX 
C
41	DETERM=DETERM*ARRAY(K,K)
	IF (K-NORDER) 43,50,50
43	K1=K+1
	DO 46 I=K1,NORDER
	DO 46 J=K1,NORDER
46	ARRAY(I,J)=ARRAY(I,J)-ARRAY(I,K)*ARRAY(K,J)/ARRAY(K,K)
50	CONTINUE
60	RETURN
	END

c CHRPAK -- Pack XCHAR (integer*2) into bytes.  Should work on most byte
c addressable machines.  The input and output arrays may be the same.

	subroutine chrpak (a, aoff, b, boff, nchars)

	integer*2 a(*)
	character*1 b(*)
	integer	aoff, boff, nchars, i

 		do 10 i = 0, nchars-1
		    b(boff+i) = char (a(aoff+i))
 10		continue
	end

C--------------------------------------------------------------------------
        subroutine fttnul(ounit,colnum,inull,status)

C       Table column NULl value definition
C       Define the null value for a table column
C
C       ounit   i  Fortran I/O unit number
C       colnum  i  number of the column to be defined
C       inull   i  the value to be use to signify undefined data
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,colnum,inull,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne,nf
        parameter (nb = 20)
        parameter (ne = 200)
        parameter (nf = 3000)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

C       if HDU structure is not defined then scan the header keywords
        if (dtstrt(ibuff) .lt. 0)call ftrdef(ounit,status)
        if (status .gt. 0)return

C       test for proper HDU type
        if (hdutyp(ibuff) .eq. 0)then
            status=235
            return
        end if

        if (colnum .gt. tfield(ibuff) .or. colnum .lt. 1)then
             status=302
             return
        end if

        tnull(colnum+tstart(ibuff))=inull
        end

c PHEAD -- Print the header of the named image in FITS format, one keyword
c per line.  A pattern may optionally be specified to list some subset of the
c header keywords.
c
c	usage:  phead image [pattern]
c ----------------------------------------------------------------------------

	program phead

	character*20	kwname
	character*80	image, patstr, errmsg
	integer		im, kwl, ier
	logical		sortit

c --- Get image name.
	call clargc (1, image, ier)
	if (ier .ne. 0) then
	    write (*, '('' enter image name: '',$)')
	    read (*,*) image
	endif

c --- Get pattern string (list everything if no pattern given).
	call clargc (2, patstr, ier)
	if (ier .ne. 0) then
	    patstr = '*'
	endif

c --- Open the image.
	call imopen (image, 1, im, ier)
	if (ier .ne. 0) goto 91

c --- Open the keyword list and print each keyword in FITS format on the
c     standard output device.

	sortit = .false.
	call imokwl (im, patstr, sortit, kwl, ier)

 10	continue
	call imgnkw (kwl, kwname, ier)
	if (ier .ne. 0) goto 20
	    call putkey (im, kwname, ier)
	    if (ier .ne. 0) goto 91
	    goto 10
 20	continue

	call imckwl (kwl, ier)
	if (ier .ne. 0) goto 91

c --- Clean up.
	call imclos (im, ier)
	if (ier .ne. 0) goto 91

	stop

c --- Error exit.
 91	call imemsg (ier, errmsg)
	write (*, '(1x, '' Error: '', a80)') errmsg

	stop
	end


c PUTKEY -- Read the value and comment fields of the named image header
c keyword, and print the value of the keyword in FITS format on the
c standard output device.
c
c     000000000111111111122222222223333333333444444444455555555556
c     123456789012345678901234567890123456789012345678901234567890
c     keyword =                  xxx / comment
c     keyword = 'sval    '           / comment
c
c Datatype codes: 1=bool, 2=char, 3,4,5=int, 6,7=real/double, 8=complex
c Only codes 1, 2, 4, and 6 (bool,char,int,real) are returned by IMTYPK.
c ------------------------------------------------------------------------

	subroutine putkey (im, kwname, ier)

	integer		im
	character*(*)	kwname

	logical		bval
	character*68	sval
	integer		ival
	doubleprecision dval

	character*18	valstr
	character*47	comstr
	character*70	lngstr
	integer		nchars, dtype, ier, i

c --- Get the keyword data type and comment information.
	call imtypk (im, kwname, dtype, comstr, ier)
	if (ier .ne. 0) return

c --- Print the value of the keyword in FITS format.  The format depends
c     upon the datatype of the parameter.

	if (dtype .eq. 1) then
	    call imgkwb (im, kwname, bval, ier)
	    if (ier .ne. 0) return
	    write (*, 10) kwname, bval, comstr
 10	    format (1x, a8, '= ', l20, ' / ', a47)

	else if (dtype .ge. 3 .and. dtype .le. 5) then
	    call imgkwi (im, kwname, ival, ier)
	    if (ier .ne. 0) return
	    write (*, 20) kwname, ival, comstr
 20	    format (1x, a8, '= ', i20, ' / ', a47)

	else if (dtype .eq. 6 .or. dtype .eq. 7) then
	    call imgkwd (im, kwname, dval, ier)
	    if (ier .ne. 0) return
	    if (abs(dval) .lt. 1.0E6 .and. abs(dval) .ge. 1.0E-1) then
	        write (*, 30) kwname, dval, comstr
 30	        format (1x, a8, '= ', f20.2, ' / ', a47)
	    else
	        write (*, 31) kwname, dval, comstr
 31	        format (1x, a8, '= ', e20.12, ' / ', a47)
	    endif

	else
	    call imgkwc (im, kwname, sval, ier)
	    if (ier .ne. 0) return

	    nchars = len(sval) - 1
	    do 40 i = nchars, 9, -1
		if (sval(i:i) .ne. ' ') goto 41
		nchars = i - 1
 40	    continue
 41	    continue

	    if (nchars .le. 8) then
		write (*, 45) kwname, sval, comstr
 45	    	format (1x, a8, '= ''', a8, '''', 10x, ' / ', a47)
	    else if (nchars .le. 18) then
		valstr = sval
		write (*, 46) kwname, valstr, comstr
 46	    	format (1x, a8, '= ''', a18, '''', ' / ', a47)
	    else
		nchars = min (nchars, len(lngstr) - 2)
		lngstr(1:1) = ''''
		do 47 i = 1, nchars
		    lngstr(i+1:i+1) = sval(i:i)
 47		continue
		lngstr(nchars+2:nchars+2) = ''''
		do 48 i = nchars + 3, len(lngstr)
		    lngstr(i:i) = ' '
 48		continue
		write (*, 49) kwname, lngstr
 49	    	format (1x, a8, '= ', a69)
	    endif
	endif

	ier = 0
	end

C----------------------------------------------------------------------
        subroutine ftgabc(nfield,tform,space, rowlen,tbcol,status)

C       Get ASCII table Beginning Columns
C       determine the byte offset of the beginning of each field of a 
C       ASCII table, and the total width of the table

C       nfield i  number of fields in the binary table
C       tform  c  array of FITS datatype codes of each column.
C                 must be left justified in the string variable
C       space  i  number of blank spaces to insert between each column
C       OUTPUT PARAMETERS:
C       rowlen i  total width of the table, in bytes
C       tbcol  i  beginning position of each column (first column begins at 1)
C       status i  returned error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1992

        integer nfield,space,rowlen,tbcol(*),status
        character*(*) tform(*)
        integer i,j,ival

        if (status .gt. 0)return

        rowlen=0
        do 100 i=1,nfield
                if (tform(i)(2:2) .eq. ' ')then
C                       no explicit width; assume width=1
                        ival=1
                else
C                       find the field width characters
                        j=2
10                      j=j+1
                        if (tform(i)(j:j) .eq. ' ' .or. 
     &                      tform(i)(j:j) .eq. '.')then
C                           read the width
                            call ftc2ii(tform(i)(2:j-1),ival,status)
                        else
C                           keep looking for the end of the width field
                            go to 10
                        end if
                        tbcol(i)=rowlen+1
                        rowlen=rowlen+ival+space
                end if
100     continue

C       don't add space after the last field
        rowlen=rowlen-space
        end

      integer function getwrd (in, i, out)
      integer in (100), out (100)
      integer i
      integer j
23000 if (.not.(in (i) .eq. 32 .or. in (i) .eq. 9))goto 23001
      i = i + 1
      goto 23000
23001 continue
      j = 1
23002 if (.not.(in (i) .ne. -2 .and. in (i) .ne. 32 .and. in (i) .ne. 9 
     *.and. in (i) .ne. 10))goto 23003
      out (j) = in (i)
      i = i + 1
      j = j + 1
      goto 23002
23003 continue
      out (j) = -2
      getwrd = j - 1
      return
      end

      SUBROUTINE slXYXY (X1,Y1,COEFFS,X2,Y2)
*+
*     - - - - - -
*      X Y X Y
*     - - - - - -
*
*  Transform one [X,Y] into another using a linear model of the type
*  produced by the slFTXY routine.
*
*  Given:
*     X1       d        x-coordinate
*     Y1       d        y-coordinate
*     COEFFS  d(6)      transformation coefficients (see note)
*
*  Returned:
*     X2       d        x-coordinate
*     Y2       d        y-coordinate
*
*  The model relates two sets of [X,Y] coordinates as follows.
*  Naming the elements of COEFFS:
*
*     COEFFS(1) = A
*     COEFFS(2) = B
*     COEFFS(3) = C
*     COEFFS(4) = D
*     COEFFS(5) = E
*     COEFFS(6) = F
*
*  the present routine performs the transformation:
*
*     X2 = A + B*X1 + C*Y1
*     Y2 = D + E*X1 + F*Y1
*
*  See also slFTXY, slPXY, slINVF, slDCMF
*
*  P.T.Wallace   Starlink   5 December 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION X1,Y1,COEFFS(6),X2,Y2


      X2=COEFFS(1)+COEFFS(2)*X1+COEFFS(3)*Y1
      Y2=COEFFS(4)+COEFFS(5)*X1+COEFFS(6)*Y1

      END

      SUBROUTINE slGEOC (P, H, R, Z)
*+
*     - - - - -
*      G E O C
*     - - - - -
*
*  Convert geodetic position to geocentric (double precision)
*
*  Given:
*     P     dp     latitude (geodetic, radians)
*     H     dp     height above reference spheroid (geodetic, metres)
*
*  Returned:
*     R     dp     distance from Earth axis (AU)
*     Z     dp     distance from plane of Earth equator (AU)
*
*  Notes:
*
*  1  Geocentric latitude can be obtained by evaluating ATAN2(Z,R).
*
*  2  IAU 1976 constants are used.
*
*  Reference:
*
*     Green,R.M., Spherical Astronomy, CUP 1985, p98.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION P,H,R,Z

*  Earth equatorial radius (metres)
      DOUBLE PRECISION A0
      PARAMETER (A0=6378140D0)

*  Reference spheroid flattening factor and useful function
      DOUBLE PRECISION F,B
      PARAMETER (F=1D0/298.257D0,B=(1D0-F)**2)

*  Astronomical unit in metres
      DOUBLE PRECISION AU
      PARAMETER (AU=1.49597870D11)

      DOUBLE PRECISION SP,CP,C,S



*  Geodetic to geocentric conversion
      SP = SIN(P)
      CP = COS(P)
      C = 1D0/SQRT(CP*CP+B*SP*SP)
      S = B*C
      R = (A0*C+H)*CP/AU
      Z = (A0*S+H)*SP/AU

      END

      DOUBLE PRECISION FUNCTION slGMST (UT1)
*+
*     - - - - -
*      G M S T
*     - - - - -
*
*  Conversion from universal time to sidereal time (double precision)
*
*  Given:
*    UT1    dp     universal time (strictly UT1) expressed as
*                  modified Julian Date (JD-2400000.5)
*
*  The result is the Greenwich mean sidereal time (double
*  precision, radians).
*
*  The IAU 1982 expression (see page S15 of 1984 Astronomical Almanac)
*  is used, but rearranged to reduce rounding errors.  This expression
*  is always described as giving the GMST at 0 hours UT.  In fact, it
*  gives the difference between the GMST and the UT, which happens to
*  equal the GMST (modulo 24 hours) at 0 hours UT each day.  In this
*  routine, the entire UT is used directly as the argument for the
*  standard formula, and the fractional part of the UT is added
*  separately.  Note that the factor 1.0027379... does not appear in the
*  IAU 1982 expression explicitly but in the form of the coefficient
*  8640184.812866, which is 86400x36525x0.0027379...
*
*  See also the routine slGMSA, which delivers better numerical
*  precision by accepting the UT date and time as separate arguments.
*
*  Called:  slDA2P
*
*  P.T.Wallace   Starlink   14 October 2001
*
*  Copyright (C) 2001 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION UT1

      DOUBLE PRECISION slDA2P

      DOUBLE PRECISION D2PI,S2R
      PARAMETER (D2PI=6.283185307179586476925286766559D0,
     :           S2R=7.272205216643039903848711535369D-5)

      DOUBLE PRECISION TU



*  Julian centuries from fundamental epoch J2000 to this UT
      TU=(UT1-51544.5D0)/36525D0

*  GMST at this UT
      slGMST=slDA2P(MOD(UT1,1D0)*D2PI+
     :                    (24110.54841D0+
     :                    (8640184.812866D0+
     :                    (0.093104D0-6.2D-6*TU)*TU)*TU)*S2R)

      END

      subroutine labmod (ifmtx,ifmty,numx,numy,isizx,isizy,ixdec,iydec,
     1                   ixor)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c     ray bovet ishft changed to ishfta patch
      dimension       ifmtx(3)       ,ifmty(3)       ,idec(2),ishfta(2)
      equivalence     (mxdec,idec(1)),(mshftx,ishfta(1))
      do 101 i=1,10
         call ncgchr (ifmtx,10,i,ichar)
         call ncpchr (mfmtx,10,i,ichar)
         call ncgchr (ifmty,10,i,ichar)
         call ncpchr (mfmty,10,i,ichar)
  101 continue
      mumx = numx
      mumy = numy
      if (max0(mumx,mumy) .gt. 20) go to 103
      msizx = isizx
      msizy = isizy
      mxdec = ixdec
      mydec = iydec
      do 102 i=1,2
c     ray bovet ishft changed to ishfta patch
         jdec = isign(ishift(iabs(idec(i)),ishfta(i)),idec(i))
         if (idec(i) .eq. 0) jdec = 655
         if (idec(i) .eq. 1) jdec = 0
         idec(i) = jdec
  102 continue
      mxor = ixor
      return
  103 continue
c     write (mprint,1001) mumx,mumy
c
      call uliber (0,36h0numx or numy .gt. 20 in labmod call,36)
      call perror
      return
c
c1001 format (6h0numx=,i5,6h numy=,i5)
c
      end

C--------------------------------------------------------------------------
        subroutine ftmkey(ounit,keywrd,value,comm,status)

C       modify an existing simple FITS keyword record with format:
C            "KEYWORD = VALUE / COMMENT"
C               VALUE is assumed to be 20 characters long
C               COMMENT is assumed to be 47 characters long
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       value   c  keyword value   (20 characters, cols. 11-30)
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,value,comm
        integer ounit,status
        character key*8, val*20, com*47

        key=keywrd
        val=value
        com=comm

C       overwrite the preceeding 80 characters to the output buffer:
        call ftmodr(ounit,key//'= '//val//' / '//com,status)
        end

      subroutine tran16
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c     ray bovet patch to avoid small integers being set to 0
      integer xx,yy
c
      logical         intt
      equivalence     (zz,mz),(temp,itemp)
c     ray bovet patch to avoid small integers being set to 0
c     zz = xx
      mz = xx
      if (intt(zz)) go to 102
      if (mtypex .eq. 0) go to 101
      if (zz .le. 0.0)
     1    call uliber (0,35h0negative argument with log scaling,35)
      zz = amax1(zz,small)
      mz = 2.0*(xfactr*alog10(zz)+xadd)
      go to 103
  101 mz = 2.0*(xfactr*zz+xadd)
      go to 103
  102 mz = ishift(mz,mshftx+1)
  103 mx = max0(0,min0(65535,mz-1))
c     ray bovet patch to avoid small integers being set to 0
c     zz = yy
      mz = yy
      if (intt(zz)) go to 105
      if (mtypey .eq. 0) go to 104
      if (zz .le. 0.0)
     1    call uliber (0,35h0negative argument with log scaling,35)
      zz = amax1(zz,small)
      mz = 2.0*(yfactr*alog10(zz)+yadd)
      go to 106
  104 mz = 2.0*(yfactr*zz+yadd)
      go to 106
  105 mz =ishift(mz,mshfty+1)
  106 my = max0(0,min0(65535,mz-1))
      return
C
      entry DTRAN16
C
      zz = xx
      if(intt(zz) .or. (zz .eq. 0.0)) goto 203
      mz = 2.0 * xfactr * zz
  203 mx = max0(-127,min0(127,mz))
      zz = yy
      if(intt(zz) .or. (zz .eq. 0.0)) goto 206
      mz = 2.0 * yfactr * zz
  206 my = max0(-127,min0(127,mz))
      return
      end

      integer function sctabl (table, sym, info, posn)
      integer table, posn
      integer sym (100)
      integer info (100)
      integer mem( 60000)
      common/cdsmem/mem
      integer bucket, walker
      integer dsget
      integer nodsiz, i, j
      if (.not.(posn .eq. 0))goto 23000
      posn = dsget (2)
      mem (posn) = 1
      mem (posn + 1) = mem (table + 1)
23000 continue
      bucket = mem (posn)
      walker = mem (posn + 1)
      nodsiz = mem (table)
23002 continue
      if (.not.(walker .ne. 0))goto 23005
      i = walker + 1 + nodsiz
      j = 1
23007 if (.not.(mem (i) .ne. -2))goto 23008
      sym (j) = mem (i)
      i = i + 1
      j = j + 1
      goto 23007
23008 continue
      sym (j) = -2
      i = 1
23009 if (.not.(i .le. nodsiz))goto 23011
      j = walker + 1 + i - 1
      info (i) = mem (j)
23010 i = i + 1
      goto 23009
23011 continue
      mem (posn) = bucket
      mem (posn + 1) = mem (walker + 0)
      sctabl = 1
      return
23005 continue
      bucket = bucket + 1
      if (.not.(bucket .gt. 43))goto 23012
      goto 23004
23012 continue
      j = table + bucket
      walker = mem (j)
23006 continue
23003 goto 23002
23004 continue
      call dsfree (posn)
      posn = 0
      sctabl = -1
      return
      end

include  defs

# GOCODE - generate code for goto statement

subroutine gocode

character token (MAXTOK), t
character gnbtok
integer	ctoi, i
include	COMMON_BLOCKS

	t = gnbtok (token, MAXTOK)
	if (t != DIGIT)
	    call synerr ("Invalid label for goto.")
	else {
	    call outtab
	    i = 1
	    call ogotos (ctoi(token,i), NO)
	}
	xfer = YES

	for (t=gnbtok(token,MAXTOK);  t == NEWLINE;  t=gnbtok(token,MAXTOK))
	    ;
	call pbstr (token)
end

      SUBROUTINE CONSSD(X,Y,IC)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  THIS SUBROUTINE SETS THE SHIELDING FLAG AND CONNECTS THE
C  USERS SHIELD ARRAYS TO SOME INTERNAL POINTERS
C
C  INPUT
C       X-X COORDINATE STRING
C       Y-Y COORDINATE STRING
C       IC-NUMBER OF COORDINATES
C
C  NOTE THE USERS ARRAYS CANNOT BE MUCKED WITH DURING EXECUTION
C       THOSE ARRAYS ARE USED DURING CONRAN EXECUTION
C
      DIMENSION X(1),Y(1)
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
C
        SAVE
C
C  SET COUNTER
C
      ICOUNT = IC
C
C  CHECK THE DIMENSION OF SHIELD ARRAYS
C
      IERUNT = I1MACH(4)
      IF (ICOUNT .GT. 50) THEN
        CALL SETER (' CONSSD -- NUMBER OF SHIELD POINTS .GT. 50',1,1)
C
C + NOAO - FTN write and format statement commented out; SETER is enough.
C       WRITE(IERUNT,1001)
        ICOUNT = 50
      ENDIF
C1001 FORMAT(' ERROR 1 IN CONSSD -- NUMBER OF SHIELD POINTS .GT. 50')
C - NOAO
C
C  SET THE SHIELDING FLAG TO TRUE
C
      SHIELD = .TRUE.
C
C  COMPUTE POINTERS FOR THE USERS SHIELDING ARRAYS
C
      DO 300 I = 1,ICOUNT
        XVS(I) = X(I)
 300  YVS(I) = Y(I)
C
      RETURN
      END

      subroutine vector (x,y)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c     ray bovet patch to avoid small integers being set to 0
      integer x,y,xx,yy
c
      xx = x
      yy = y
      call trans
      minst = 1
      call put42
      return
      end

      subroutine gridal (imajx,iminx,imajy,iminy,ixlab,iylab,iflg,x,y)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c
c non-compact version of gridal
c
c     ray bovet ishft changed to ishfta patch
      dimension       nmaj(2),nmin(2),nlab(2),nflg(2),num(2) ,zza(2) ,
     1                zzb(2) ,zzc(2) ,zzd(2) ,ichars(5)      ,
     2                ifmt(3,2)      ,iz(2)  ,iza(2) ,izb(2) ,imz(2) ,
     3                izdec(2)       ,isiz(2),imajl(2)       ,
     4                iminl(2)       ,itype(2)       ,zz(2)  ,
     5                ishfta(2)       ,izaa(2),izbb(2),kz(4)
c     ray bovet patch to avoid small integers being set to 0
      integer x,y,xx,yy
c
c
c     ray bovet ishft changed to ishfta patch
      equivalence     (xxa,zza(1))   ,(xxb,zzb(1))   ,(xxc,zzc(1))   ,
     1                (xxd,zzd(1))   ,(mfmtx(1),ifmt(1,1)),
     2                (mx,iz(1))     ,(mxa,iza(1))   ,(mxb,izb(1))   ,
     3                (majx,nmaj(1)) ,(minx,nmin(1)) ,(mumx,num(1))  ,
     4                (mxdec,izdec(1))       ,(msizx,isiz(1)),
     5                (mmgrx,imajl(1))       ,(mmnrx,iminl(1))       ,
     6                (mtypex,itype(1))      ,(xx,kz(1))     ,
     7                (xx,zz(1))     ,(mshftx,ishfta(1))
c
c set up variables for loop
c
      nmaj(1) = imajx
      nmaj(2) = imajy
      nmin(1) = iminx
      nmin(2) = iminy
      nlab(1) = ixlab
      nlab(2) = iylab
      nflg(1) = ishift(iflg,-2)-1
      nflg(2) = iand(iflg,3)-1
      izaa(1) = iza(1)
      izaa(2) = iza(2)
      izbb(1) = izb(1)
      izbb(2) = izb(2)
      if (nflg(1).le.0 .and. nflg(2).le.0) go to 101
      xx = x
      yy = y
      call trans
      if (nflg(2) .gt. 0) izaa(1) = mx
      if (nflg(1) .gt. 0) izaa(2) = my
      if (nflg(2) .gt. 0) izbb(1) = mx
      if (nflg(1) .gt. 0) izbb(2) = my
  101 continue
      call optn (4hdpat,65535)
      do 121 i=1,2
c
c i=1 for x axis with ticks in y direction
c i=2 for y axis with ticks in x direction
c
         if (nlab(i)) 121,102,102
  102    continue
c
c ior.ne.0 posibility for x only
c
         ixor = (2-i)*90*mxor
         imaj = max0(nmaj(i),1)
         imin = max0(nmin(i),1)
         begin = iza(i)
         biginc = float(izb(i)-iza(i))/float(imaj)
         smlinc = biginc/float(imin)
         start = zzc(i)
         dif = (zzd(i)-zzc(i))/float(imaj)
         iop = 3-i
c
c iop is the opposit axis to i
c
         idec = izdec(iop)
         if (idec .eq. 0) idec = izaa(iop)-izbb(iop)-655
         if (ixor .eq. i-1) go to 103
c
c labels and axis are orthogonal
c
         icent = isign(1,idec-1)
         go to 104
c
c labels and axis are parallel
c
  103    icent = 0
  104    continue
         if (itype(i) .eq. 0) go to 105
         fact = 10.**imaj
         if (zzc(i) .gt. zzd(i)) fact = 1./fact
         val = zzc(i)/fact
         delval = val
         if (imin.le.10 .and. imaj.eq.1) imin = 9
         if (imin .ne. 9) imin = 1
         imaj = abs(alog10(zzd(i)/zzc(i)))+1.0001
  105    imajp1 = imaj+1
         iminm1 = imin-1
         do 119 j=1,imajp1
            part = j-1
c
c draw major line or tick
c
            call optn (4hintn,4hhigh)
            if (itype(i) .ne. 0) go to 106
            iz(i) = begin+part*biginc
            go to 107
  106       val = val*fact
            zz(i) = val
            kz(iop) = 1
            call trans
            delval = delval*fact
            if (iz(i)-10 .gt. izb(i)) go to 120
  107       continue
            iz(iop) = izaa(iop)
            minst = 0
            call put42
            if (nflg(i)) 108,109,109
  108       iz(iop) = izb(iop)
            minst = 1
            call put42
            go to 111
  109       iz(iop) = izaa(iop)+imajl(iop)
            minst = 1
            call put42
            if (nflg(i)) 110,110,111
  110       iz(iop) = izb(iop)
            minst = 0
            call put42
            iz(iop) = izb(iop)-imajl(iop)
            minst = 1
            call put42
  111       continue
c
c form label if needed
c
            if (nlab(i) .le. 0) go to 112
            if (itype(i) .eq. 0) val = start+part*dif
            call encode (num(i),ifmt(1,i),ichars,val)
c     ray bovet ishft changed to ishfta patch
            imz(i) = ishift(iz(i),-ishfta(i))
            imz(iop) = max0(1,ishift(izaa(iop)-idec,-ishfta(iop)))
            njust = num(i)
            if (icent .eq. 0) call justfy (ichars,num(i),njust)
            call pwrit (imz(1),imz(2),ichars,njust,isiz(i),ixor,icent)
c
c put in minor ticks
c
  112       if (iminm1.le.0 .or. j.eq.imajp1) go to 119
            call optn (4hintn,3hlow)
            do 118 k=1,iminm1
               if (itype(i) .ne. 0) go to 113
               iz(i) = begin+part*biginc+float(k)*smlinc
               go to 114
  113          zz(i) = val+float(k)*delval
               if (zzc(i) .gt. zzd(i)) zzi = val-float(k)*delval*.1
               kz(iop) = 1
               call trans
               if (iz(i) .gt. izb(i)) go to 120
               if (iz(i) .lt. iza(i)) go to 118
  114          continue
               iz(iop) = izaa(iop)
               minst = 0
               call put42
               if (nflg(i)) 115,116,116
  115          iz(iop) = izb(iop)
               minst = 1
               call put42
               go to 118
  116          iz(iop) = izaa(iop)+iminl(iop)
               minst = 1
               call put42
               if (nflg(i)) 117,117,118
  117          iz(iop) = izb(iop)
               minst = 0
               call put42
               iz(iop) = izb(iop)-iminl(iop)
               minst = 1
               call put42
  118       continue
  119    continue
         call optn (4hintn,4hhigh)
  120    if (nflg(iop) .lt. 0) go to 121
c
c draw axis line
c
         iz(i) = iza(i)
         iz(iop) = izaa(iop)
         minst = 0
         call put42
         iz(i) = izb(i)
         iz(iop) = izaa(iop)
         minst = 1
         call put42
         if (nflg(i) .gt. 0) go to 121
         iz(i) = iza(i)
         iz(iop) = izb(iop)
         minst = 0
         call put42
         iz(i) = izb(i)
         iz(iop) = izb(iop)
         minst = 1
         call put42
  121 continue
      return
      end

      SUBROUTINE SINTI (N,WSAVE)
      DIMENSION       WSAVE(*)
      DATA PI /3.14159265358979/
      IF (N .LE. 1) RETURN
      NS2 = N/2
      NP1 = N+1
      DT = PI/FLOAT(NP1)
      DO 101 K=1,NS2
         WSAVE(K) = 2.*SIN(K*DT)
  101 CONTINUE
      CALL RFFTI (NP1,WSAVE(NS2+1))
      RETURN
      END

      SUBROUTINE CONREC (Z,L,M,N,FLO,HI,FINC,NSET,NHI,NDOT)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C
C     DIMENSION OF           Z(L,N)
C     ARGUMENTS
C
C     LATEST REVISION        JUNE 1984
C
C     PURPOSE                CONREC DRAWS A CONTOUR MAP FROM DATA STORED
C                            IN A RECTANGULAR ARRAY, LABELING THE LINES.
C
C     USAGE                  IF THE FOLLOWING ASSUMPTIONS ARE MET, USE
C
C                              CALL EZCNTR (Z,M,N)
C
C                              ASSUMPTIONS:
C                                  --ALL OF THE ARRAY IS TO BE CONTOURED.
C                                  --CONTOUR LEVELS ARE PICKED
C                                    INTERNALLY.
C                                  --CONTOURING ROUTINE PICKS SCALE
C                                    FACTORS.
C                                  --HIGHS AND LOWS ARE MARKED.
C                                  --NEGATIVE LINES ARE DRAWN WITH A
C                                    DASHED LINE PATTERN.
C                                  --EZCNTR CALLS FRAME AFTER DRAWING THE
C                                    CONTOUR MAP.
C
C                            IF THESE ASSUMPTIONS ARE NOT MET, USE
C
C                              CALL CONREC (Z,L,M,N,FLO,HI,FINC,NSET,
C                                           NHI,NDOT)
C
C     ARGUMENTS
C
C     ON INPUT               Z
C     FOR EZCNTR               M BY N ARRAY TO BE CONTOURED.
C
C                            M
C                              FIRST DIMENSION OF Z.
C
C                            N
C                              SECOND DIMENSION OF Z.
C
C     ON OUTPUT              ALL ARGUMENTS ARE UNCHANGED.
C     FOR EZCNTR
C
C     ON INPUT               Z
C     FOR CONREC               THE (ORIGIN OF THE) ARRAY TO BE
C                              CONTOURED.  Z IS DIMENSIONED L BY N.
C
C                            L
C                              THE FIRST DIMENSION OF Z IN THE CALLING
C                              PROGRAM.
C
C                            M
C                              THE NUMBER OF DATA VALUES TO BE CONTOURED
C                              IN THE X-DIRECTION (THE FIRST SUBSCRIPT
C                              DIRECTION).  WHEN PLOTTING AN ENTIRE
C                              ARRAY, L = M.
C
C                            N
C                              THE NUMBER OF DATA VALUES TO BE CONTOURED
C                              IN THE Y-DIRECTION (THE SECOND SUBSCRIPT
C                              DIRECTION).
C
C                            FLO
C                              THE VALUE OF THE LOWEST CONTOUR LEVEL.
C                              IF FLO = HI = 0., A VALUE ROUNDED UP FROM
C                              THE MINIMUM Z IS GENERATED BY CONREC.
C
C                            HI
C                              THE VALUE OF THE HIGHEST CONTOUR LEVEL.
C                              IF HI = FLO = 0., A VALUE ROUNDED DOWN
C                              FROM THE MAXIMUM Z IS GENERATED BY
C                              CONREC.
C
C                            FINC
C                              > 0  INCREMENT BETWEEN CONTOUR LEVELS.
C                              = 0  A VALUE, WHICH PRODUCES BETWEEN 10
C                                   AND 30 CONTOUR LEVELS AT NICE VALUES,
C                                   IS GENERATED BY CONREC.
C                              < 0  THE NUMBER OF LEVELS GENERATED BY
C                                   CONREC IS ABS(FINC).
C
C                            NSET
C                              FLAG TO CONTROL SCALING.
C                              = 0  CONREC AUTOMATICALLY SETS THE
C                                   WINDOW AND VIEWPORT TO PROPERLY
C                                   SCALE THE FRAME TO THE STANDARD
C                                   CONFIGURATION.
C                                   THE GRIDAL ENTRY PERIM IS
C                                   CALLED AND TICK MARKS ARE PLACED
C                                   CORRESPONDING TO THE DATA POINTS.
C                              > 0  CONREC ASSUMES THAT THE USER
C                                   HAS SET THE WINDOW AND VIEWPORT
C                                   IN SUCH A WAY AS TO PROPERLY
C                                   SCALE THE PLOTTING
C                                   INSTRUCTIONS GENERATED BY CONREC.
C                                   PERIM IS NOT CALLED.
C                              < 0  CONREC GENERATES COORDINATES SO AS
C                                   TO PLACE THE (UNTRANSFORMED) CONTOUR
C                                   PLOT WITHIN THE LIMITS OF THE
C                                   USER'S CURRENT WINDOW AND
C                                   VIEWPORT.  PERIM IS NOT CALLED.
C
C                            NHI
C                              FLAG TO CONTROL EXTRA INFORMATION ON THE
C                              CONTOUR PLOT.
C                              = 0  HIGHS AND LOWS ARE MARKED WITH AN H
C                                   OR L AS APPROPRIATE, AND THE VALUE
C                                   OF THE HIGH OR LOW IS PLOTTED UNDER
C                                   THE SYMBOL.
C                              > 0  THE DATA VALUES ARE PLOTTED AT
C                                   EACH Z POINT, WITH THE CENTER OF
C                                   THE STRING INDICATING THE DATA
C                                   POINT LOCATION.
C                              < 0  NEITHER OF THE ABOVE.
C
C                            NDOT
C                              A 10-BIT CONSTANT DESIGNATING THE DESIRED
C                              DASHED LINE PATTERN.
C                              IF ABS(NDOT) = 0, 1, OR 1023, SOLID LINES
C                              ARE DRAWN.
C                              > 0 NDOT PATTERN IS USED FOR ALL LINES.
C                              < 0 ABS(NDOT) PATTERN IS USED FOR NEGA-
C                                TIVE-VALUED CONTOUR LINES, AND SOLID IS
C                                USED FOR POSITIVE-VALUED CONTOURS.
C                                CONREC CONVERTS NDOT
C                                TO A 16-BIT PATTERN AND DASHDB IS USED.
C                                SEE DASHDB COMMENTS IN THE DASHLINE
C                                DOCUMENTATION FOR DETAILS.
C
C
C
C     ON OUTPUT              ALL ARGUMENTS ARE UNCHANGED.
C     FOR CONREC
C
C
C     ENTRY POINTS           CONREC, CLGEN, REORD, STLINE, DRLINE,
C                            MINMAX, PNTVAL, CALCNT, EZCNTR, CONBD
C
C     COMMON BLOCKS          INTPR, RECINT, CONRE1, CONRE2, CONRE3,
C                            CONRE4,CONRE5
C
C     REQUIRED LIBRARY       STANDARD VERSION: DASHCHAR, WHICH AT
C     ROUTINES               NCAR ISLOADED BY DEFAULT.
C                            SMOOTH VERSION: DASHSMTH WHICH MUST BE
C                            REQUESTED AT NCAR.
C                            BOTH VERSIONS REQUIRE  GRIDAL, THE
C                            ERPRT77 PACKAGE, AND THE SPPS.
C
C     I/O                    PLOTS CONTOUR MAP.
C
C     PRECISION              SINGLE
C
C     LANGUAGE               FORTRAN 77
C
C     HISTORY                REPLACES OLD CONTOURING PACKAGE CALLED
C                            CALCNT AT NCAR.
C
C     ALGORITHM              EACH LINE IS FOLLOWED TO COMPLETION.  POINTS
C                            ALONG A LINE ARE FOUND ON BOUNDARIES OF THE
C                            (RECTANGULAR) CELLS. THESE POINTS ARE
C                            CONNECTED BY LINE SEGMENTS USING THE
C                            SOFTWARE DASHED LINE PACKAGE, DASHCHAR.
C                            DASHCHAR IS ALSO USED TO LABEL THE
C                            LINES.
C
C     NOTE                   TO DRAW NON-UNIFORM CONTOUR LEVELS, SEE
C                            THE COMMENTS IN CLGEN.  TO MAKE SPECIAL
C                            MODIFICATIONS FOR SPECIFIC NEEDS SEE THE
C                            EXPLANATION OF THE INTERNAL PARAMETERS
C                            BELOW.
C
C     TIMING                 VARIES WIDELY WITH SIZE AND SMOOTHNESS OF
C                            Z.
C
C     INTERNAL PARAMETERS    NAME   DEFAULT         FUNCTION
C                            ----   -------         --------
C
C                            ISIZEL   1      SIZE OF LINE LABELS,
C                                            AS PER THE SIZE DEFINITIONS
C                                            GIVEN IN THE SPPS
C                                            DOCUMENTATION FOR WTSTR.
C
C                            ISIZEM   2      SIZE OF LABELS FOR MINIMUMS
C                                            AND MAXIMUMS,
C                                            AS PER THE SIZE DEFINITIONS
C                                            GIVEN IN THE SPPS
C                                            DOCUMENTATION FOR WTSTR.
C
C                            ISIZEP   0      SIZE OF LABELS FOR DATA
C                                            POINT VALUES AS PER THE SIZE
C                                            DEFINITIONS GIVEN IN THE SPPS
C                                            DOCUMENTATION FOR WTSTR.
C
C                            NLA      16     APPROXIMATE NUMBER OF
C                                            CONTOUR LEVELS WHEN
C                                            INTERNALLY GENERATED.
C
C                            NLM      40     MAXIMUM NUMBER OF CONTOUR
C                                            LEVELS.  IF THIS IS TO BE
C                                            INCREASED, THE DIMENSIONS
C                                            OF CL AND RWORK IN CONREC
C                                            MUST BE INCREASED BY THE
C                                            SAME AMOUNT.
C
C                            XLT      .05    LEFT HAND EDGE OF THE PLOT
C                                            (0.0 IS THE LEFT EDGE OF
C                                            THE FRAME AND 1.0 IS THE
C                                            RIGHT EDGE OF THE FRAME.)
C
C                            YBT      .05    BOTTOM EDGE OF THE PLOT
C                                            (0.0 IS THE BOTTOM OF THE
C                                            FRAME AND 1.0 IS THE TOP
C                                            OF THE FRAME.)
C
C                            SIDE     0.9    LENGTH OF LONGER EDGE OF
C                                            PLOT (SEE ALSO EXT).
C
C                            NREP     6      NUMBER OF REPETITIONS OF
C                                            THE DASH PATTERN BETWEEN
C                                            LINE LABELS.
C
C                            NCRT     2      NUMBER OF CRT UNITS PER
C                                            ELEMENT (BIT) IN THE DASH
C                                            PATTERN.
C +NOAO - Value of ncrt changed from 4 to 2 in conbd.
C -NOAO
C
C                            ILAB     1      FLAG TO CONTROL THE DRAWING
C                                            OF LINE LABELS.
C                                            . ILAB NON-ZERO MEANS LABEL
C                                              THE LINES.
C                                            . ILAB = 0 MEANS DO NOT
C                                              LABEL THE LINES.
C
C                            NULBLL   3      NUMBER OF UNLABELED LINES
C                                            BETWEEN LABELED LINES.  FOR
C                                            EXAMPLE, WHEN NULBLL = 3,
C                                            EVERY FOURTH LEVEL IS
C                                            LABELED.
C
C                            IOFFD    0      FLAG TO CONTROL
C                                            NORMALIZATION OF LABEL
C                                            NUMBERS.
C                                            . IOFFD = 0 MEANS INCLUDE
C                                              DECIMAL POINT WHEN
C                                              POSSIBLE (DO NOT
C                                              NORMALIZE UNLESS
C                                              REQUIRED).
C                                            . IOFFD NON-ZERO MEANS
C                                              NORMALIZE ALL LABEL
C                                              NUMBERS AND OUTPUT A
C                                              SCALE FACTOR IN THE
C                                              MESSAGE BELOW THE GRAPH.
C
C                            EXT      .0625  LENGTHS OF THE SIDES OF THE
C                                            PLOT ARE PROPORTIONAL TO M
C                                            AND N (WHEN CONREC SETS
C                                            THE WINDOW AND VIEWPORT).
C                                            IN EXTREME CASES, WHEN
C                                            MIN(M,N)/MAX(M,N) IS LESS
C                                            THAN EXT, CONREC
C                                            PRODUCES A SQUARE PLOT.
C
C                            IOFFP      0    FLAG TO CONTROL SPECIAL
C                                            VALUE FEATURE.
C                                            . IOFFP = 0 MEANS SPECIAL
C                                              VALUE FEATURE NOT IN USE.
C                                            . IOFFP NON-ZERO MEANS
C                                              SPECIAL VALUE FEATURE IN
C                                              USE.  (SPVAL IS SET TO THE
C                                              SPECIAL VALUE.)  CONTOUR
C                                              LINES WILL THEN BE
C                                              OMITTED FROM ANY CELL
C                                              WITH ANY CORNER EQUAL TO
C                                              THE SPECIAL VALUE.
C
C                            SPVAL    0.     CONTAINS THE SPECIAL VALUE
C                                            WHEN IOFFP IS NON-ZERO.
C
C                            IOFFM    0      FLAG TO CONTROL THE MESSAGE
C                                            BELOW THE PLOT.
C                                            . IOFFM = 0  IF THE MESSAGE
C                                              IS TO BE PLOTTED.
C                                            . IOFFM NON-ZERO IF THE
C                                              MESSAGE IS TO BE OMITTED.
C
C                            ISOLID   1023   DASH PATTERN FOR
C                                            NON-NEGATIVE CONTOUR LINES.
C
C
C +NOAO - Block data conbd rewritten as run time initialization.
C     EXTERNAL        CONBD
C -NOAO
C
      SAVE
      CHARACTER*1     IGAP       ,ISOL       ,RCHAR
      CHARACTER       ENCSCR*22  ,IWORK*126
C +NOAO - Character variable added for improved label processing.
      character*25    string(5)
C -NOAO
      DIMENSION       LNGTHS(5)  ,HOLD(5)    ,WNDW(4)    ,VWPRT(4)
      DIMENSION       Z(L,N)     ,CL(40)     ,RWORK(40)  ,LASF(13)
      COMMON /INTPR/ PAD1, FPART, PAD(8)
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE3/ IXBITS     ,IYBITS
      COMMON /CONRE4/ ISIZEL     ,ISIZEM     ,ISIZEP     ,NREP       ,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD      ,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA        ,
     3                NLM        ,XLT        ,YBT        ,SIDE
      COMMON /CONRE5/ SCLY
      COMMON /RECINT/ IRECMJ     ,IRECMN     ,IRECTX
C +NOAO - Value of LNGTHS have been changed from original defaults.  Additional
C         common block noaolb added for communication with calling routine.
C
      common /noaolb/ hold
      DATA  LNGTHS(1),LNGTHS(2),LNGTHS(3),LNGTHS(4),LNGTHS(5)
     1      /  13,       4,        21,       10,        19       /
      DATA  ISOL, IGAP /'$', ''''/
C
C -NOAO
C
C ISOL AND IGAP (DOLLAR-SIGN AND APOSTROPHE) ARE USED TO CONSTRUCT PAT-
C TERNS PASSED TO ROUTINE DASHDC IN THE SOFTWARE DASHED-LINE PACKAGE.
C
C
C
C +NOAO - Blockdata conbd called as run time initialization subroutine
      call conbd
C -NOAO
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','CONREC','CONREC','VERSION 01')
C
C NONSMOOTHING VERSION
C
C
C
C  CALL RESET FOR COMPATIBILITY WITH ALL DASH ROUTINES(EXCEPT DASHLINE)
C
      CALL RESET
C
C  GET NUMBER OF BITS IN INTEGER ARITHMETIC
C
      IARTH = I1MACH(8)
      IXBITS = 0
      DO 101 I=1,IARTH
         IF (M .LE. (2**I-1)) GO TO 102
         IXBITS = I+1
  101 CONTINUE
  102 IYBITS = 0
      DO 103 I=1,IARTH
         IF (N .LE. (2**I-1)) GO TO 104
         IYBITS = I+1
  103 CONTINUE
  104 IF ((IXBITS*IYBITS).GT.0 .AND. (IXBITS+IYBITS).LE.24) GO TO 105
C
C REPORT ERROR NUMBER ONE
C
      IWORK =    'CONREC  - DIMENSION ERROR - M*N .GT. (2**IARTH)    M =
     +            N = '
C +NOAO
C
C     WRITE (IWORK(56:62),'(I6)') M
      call encode (6, '(i6)', iwork(56:62), m)
C     WRITE (IWORK(73:79),'(I6)') N
      call encode (6, '(i6)', iwork(73:79), n)
C -NOAO
C
      CALL SETER( IWORK, 1, 1 )
      RETURN
  105 CONTINUE
C
C INQUIRE CURRENT TEXT AND LINE COLOR INDEX
C
      CALL GQTXCI ( IERR, ITXCI )
      CALL GQPLCI ( IERR, IPLCI )
C
C SET LINE AND TEXT ASF TO INDIVIDUAL
C
      CALL GQASF ( IERR, LASF )
      LSV3  = LASF(3)
      LSV10 = LASF(10)
      LASF(3)  = 1
      LASF(10) = 1
      CALL GSASF ( LASF )
C
      GL = FLO
      HA = HI
      GP = FINC
      MX = L
      NX = M
      NY = N
      IDASH = NDOT
      NEGPOS = ISIGN(1,IDASH)
      IDASH = IABS(IDASH)
      IF (IDASH.EQ.0 .OR. IDASH.EQ.1) IDASH = ISOLID
C
C SET CONTOUR LEVELS.
C
      CALL CLGEN (Z,MX,NX,NY,GL,HA,GP,NLA,NLM,CL,NCL,ICNST)
C
C FIND MAJOR AND MINOR LINES
C
      IF (ILAB .NE. 0) CALL REORD (CL,NCL,RWORK,NML,NULBLL+1)
      IF (ILAB .EQ. 0) NML = 0
C
C SAVE CURRENT NORMALIZATION TRANS NUMBER NTORIG AND LOG SCALING FLAG
C
      CALL GQCNTN ( IERR, NTORIG )
      CALL GETUSV ('LS',IOLLS)
C
C SET UP SCALING
C
      CALL GETUSV ( 'YF' , IYVAL )
      SCLY = 1.0 / ISHIFT ( 1, 15 - IYVAL )
C
      IF (NSET) 106,107,111
  106 CALL GQNT ( NTORIG,IERR,WNDW,VWPRT )
      X1 = VWPRT(1)
      X2 = VWPRT(2)
      Y1 = VWPRT(3)
      Y2 = VWPRT(4)
C
C SAVE NORMALIZATION TRANS 1
C
      CALL GQNT (1,IERR,WNDW,VWPRT)
C
C DEFINE NORMALIZATION TRANS AND LOG SCALING
C
      CALL SET(X1, X2, Y1, Y2, 1.0, FLOAT(NX), 1.0, FLOAT(NY), 1)
      GO TO 111
  107 CONTINUE
      X1 = XLT
      X2 = XLT+SIDE
      Y1 = YBT
      Y2 = YBT+SIDE
      X3 = NX
      Y3 = NY
      IF (AMIN1(X3,Y3)/AMAX1(X3,Y3) .LT. EXT) GO TO 110
      IF (NX-NY) 108,110,109
  108 X2 = SIDE*X3/Y3+XLT
      GO TO 110
  109 Y2 = SIDE*Y3/X3+YBT
C
C SAVE NORMALIZATION TRANS 1
C
  110 CALL GQNT ( 1, IERR, WNDW, VWPRT )
C
C DEFINE NORMALIZATION TRANS 1 AND LOG SCALING
C
      CALL SET(X1,X2,Y1,Y2,1.0,X3,1.0,Y3,1)
C
C DRAW PERIMETER
C
      CALL PERIM (NX-1,1,NY-1,1)
  111 IF (ICNST .NE. 0) GO TO 124
C
C SET UP LABEL SCALING
C
      IOFFDT = IOFFD
      IF (GL.NE.0.0 .AND. (ABS(GL).LT.0.1 .OR. ABS(GL).GE.1.E5))
     1    IOFFDT = 1
      IF (HA.NE.0.0 .AND. (ABS(HA).LT.0.1 .OR. ABS(HA).GE.1.E5))
     1    IOFFDT = 1
      ASH = 10.**(3-IFIX(ALOG10(AMAX1(ABS(GL),ABS(HA),ABS(GP)))-5000.)-
     1                                                             5000)
      IF (IOFFDT .EQ. 0) ASH = 1.
      HOLD(1) = GL
      HOLD(2) = HA
      HOLD(3) = GP
      HOLD(4) = Z(3,3)
      HOLD(5) = ASH
      NCHAR = 0
      IF (IOFFM .NE. 0) GO TO 115
C +NOAO -  This label generation has been reworked to eliminate the large
C          spaces in between fields of the label.
C     IWORK = 'CONTOUR FROM              TO              CONTOUR INTERVAL
C    1 OF              PT(3,3)=              LABELS SCALED BY'
      string(1)(1:13) = 'CONTOUR FROM '
      string(2)(1:4)  = ' TO '
      string(3)(1:21) = '; CONTOUR INTERVAL = '
      string(4)(1:11) = '; PT(3,3)= '
      string(5)(1:19) = '; LABELS SCALED BY '
C
      DO 114 I=1,5
C (NOAO) WRITE ( ENCSCR, '(G13.5)' ) HOLD(I)
         call encd (hold(i), ash, encscr, nc, ioffd)
         do 1113 k = 1, lngths(i)
            nchar = nchar + 1
 1113    iwork(nchar:nchar) = string(i)(k:k)
C
C (NOAO) NCHAR = NCHAR+LNGTHS(I)
C (NOAO) DO 113 J=1,13
         do 113 j = 1, nc
            NCHAR = NCHAR+1
            IWORK(NCHAR:NCHAR) = ENCSCR(J:J)
  113    CONTINUE
  114 CONTINUE
C
C +NOAO IF (ASH .EQ. 1.) NCHAR = NCHAR-13-LNGTHS(5)
         if (ash .eq. 1.) nchar = nchar - nc - lngths(5)
C -NOAO
C
C SET TEXT INTENSITY TO LOW, AND WRITE TITLE USING NORMALIZATION
C TRANS NUMBER 0
C
      CALL GSTXCI (IRECTX)
      CALL GETUSV('LS',LSO)
      CALL SETUSV('LS',1)
      CALL GSELNT (0)
C +NOAO - following text output centered on current viewport
C     CALL WTSTR ( 0.5, 0.015625, IWORK(1:NCHAR), 0, 0, 0 )
      CALL WTSTR ( ((x1+x2)/2.0), y1 - 0.03, IWORK(1:NCHAR), 0, 0, 0 )
C -NOAO
      CALL SETUSV('LS',LSO)
      CALL GSELNT (1)
C
C
C
C                       * * * * * * * * * *
C                            * * * * * * * * * *
C
C
C PROCESS EACH LEVEL
C
  115 FPART = .5
C
      DO 123 I=1,NCL
         CONTR = CL(I)
         NDASH = IDASH
         IF (NEGPOS.LT.0 .AND. CONTR.GE.0.) NDASH = ISOLID
C
C CHANGE 10 BIT PATTERN TO 10 CHARACTER PATTERN.
C
         DO 116 J=1,10
            IBIT = IAND(ISHIFT(NDASH,(J-10)),1)
            RCHAR = IGAP
            IF (IBIT .NE. 0) RCHAR = ISOL
            IWORK(J:J) = RCHAR
  116    CONTINUE
         IF (I .GT. NML) GO TO 121
C
C SET UP MAJOR LINE (LABELED)
C
C SET LINE INTENSITY TO HIGH
C
         CALL GSPLCI ( IRECMJ )
C
C NREP REPITITIONS OF PATTERN PER LABEL.
C
         NCHAR = 10
         IF (NREP .LT. 2) GO TO 119
         DO 118 J=1,10
            NCHAR = J
            RCHAR = IWORK(J:J)
            DO 117 K=2,NREP
               NCHAR = NCHAR+10
               IWORK(NCHAR:NCHAR) = RCHAR
  117       CONTINUE
  118    CONTINUE
  119    CONTINUE
C
C PUT IN LABEL.
C
         CALL ENCD (CONTR,ASH,ENCSCR,NCUSED,IOFFDT)
         DO 120 J=1,NCUSED
            NCHAR = NCHAR+1
            IWORK(NCHAR:NCHAR) = ENCSCR(J:J)
  120    CONTINUE
         GO TO 122
C
C SET UP MINOR LINE (UNLABELED).
C
  121    CONTINUE
C
C SET LINE INTENSITY TO LOW
C
         CALL GSPLCI ( IRECMN )
         NCHAR = 10
  122    CALL DASHDC ( IWORK(1:NCHAR),NCRT, ISIZEL )
C
C
C DRAW ALL LINES AT THIS LEVEL.
C
         CALL STLINE (Z,MX,NX,NY,CONTR)
C
C
  123 CONTINUE
C
C FIND RELATIVE MINIMUMS AND MAXIMUMS IF WANTED, AND MARK VALUES IF
C WANTED.
C
      IF (NHI .EQ. 0) CALL MINMAX (Z,MX,NX,NY,ISIZEM,ASH,IOFFDT)
      IF (NHI .GT. 0) CALL MINMAX (Z,MX,NX,NY,ISIZEP,-ASH,IOFFDT)
      FPART = 1.
      GO TO 127
  124 CONTINUE
         IWORK = 'CONSTANT FIELD'
C +NOAO 
C     WRITE( ENCSCR, '(G22.14)' ) GL
      i = gl
      call encode (22, '(g22.14)', encscr, i)
C -NOAO
      DO 126 I=1,22
         IWORK(I+14:I+14) = ENCSCR(I:I)
  126 CONTINUE
C
C WRITE TITLE USING NORMALIZATION TRNS 0
C
      CALL GETUSV('LS',LSO)
      CALL SETUSV('LS',1)
      CALL GSELNT (0)
C +NOAO
C     CALL WTSTR ( 0.09765, 0.48825, IWORK(1:36), 3, 0, -1 )
      CALL WTSTR ( x1+0.03, (y1+y2)/2.0, IWORK(1:36), 3, 0, -1 )
C -NOAO
C
C RESTORE NORMALIZATION TRANS 1, LINE AND TEXT INTENSITY TO ORIGINAL
C
  127 IF (NSET.LE.0) THEN
          CALL SET(VWPRT(1),VWPRT(2),VWPRT(3),VWPRT(4),
     -             WNDW(1),WNDW(2),WNDW(3),WNDW(4),IOLLS)
      END IF
      CALL GSPLCI ( IPLCI )
      CALL GSTXCI ( ITXCI )
C
C SELECT ORIGINAL NORMALIZATION TRANS NUMBER NTORIG, AND RESTORE ASF
C
      CALL GSELNT ( NTORIG )
      LASF(3)  = LSV3
      LASF(10) = LSV10
      CALL GSASF ( LASF )
C
      RETURN
C
C
      END
      SUBROUTINE CLGEN (Z,MX,NX,NNY,CCLO,CHI,CINC,NLA,NLM,CL,NCL,ICNST)
      SAVE
      DIMENSION       CL(NLM)    ,Z(MX,NNY)
      COMMON /CONRE1/ IOFFP      ,SPVAL
C
C CLGEN PUTS THE VALUES OF THE CONTOUR LEVELS IN CL.
C VARIABLE NAMES MATCH THOSE IN CONREC, WITH THE FOLLOWING ADDITIONS.
C         NCL     -NUMBER OF CONTOUR LEVELS PUT IN CL.
C         ICNST   -FLAG TO TELL CONREC IF A CONSTANT FIELD WAS DETECTED.
C                 .ICNST=0 MEANS NON-CONSTANT FIELD.
C                 .ICNST NON-ZERO MEANS CONSTANT FIELD.
C
C TO PRODUCE NON-UNIFORM CONTOUR LEVEL SPACING, REPLACE THE CODE IN THIS
C SUBROUTINE WITH CODE TO PRODUCE WHATEVER SPACING IS DESIRED.
C
      ICNST = 0
      NY = NNY
      CLO = CCLO
      GLO = CLO
      HA = CHI
      FANC = CINC
      CRAT = NLA
      IF (HA-GLO) 101,102,111
  101 GLO = HA
      HA = CLO
      GO TO 111
  102 IF (GLO .NE. 0.) GO TO 120
      GLO = Z(1,1)
      HA = Z(1,1)
      IF (IOFFP .EQ. 0) GO TO 107
      DO 106 J=1,NY
         DO 105 I=1,NX
            IF (Z(I,J) .EQ. SPVAL) GO TO 105
            GLO = Z(I,J)
            HA = Z(I,J)
            DO 104 JJ=J,NY
               DO 103 II=1,NX
                  IF (Z(II,JJ) .EQ. SPVAL) GO TO 103
                  GLO = AMIN1(Z(II,JJ),GLO)
                  HA = AMAX1(Z(II,JJ),HA)
  103          CONTINUE
  104       CONTINUE
            GO TO 110
  105    CONTINUE
  106 CONTINUE
      GO TO 110
  107 DO 109 J=1,NY
         DO 108 I=1,NX
            GLO = AMIN1(Z(I,J),GLO)
            HA = AMAX1(Z(I,J),HA)
  108    CONTINUE
  109 CONTINUE
  110 IF (GLO .GE. HA) GO TO 119
  111 IF (FANC) 112,113,114
  112 CRAT = AMAX1(1.,-FANC)
  113 FANC = (HA-GLO)/CRAT
      P = 10.**(IFIX(ALOG10(FANC)+5000.)-5000)
      FANC = AINT(FANC/P)*P
  114 IF (CHI-CLO) 116,115,116
  115 GLO = AINT(GLO/FANC)*FANC
      HA = AINT(HA/FANC)*FANC*(1.+SIGN(1.E-6,HA))
  116 DO 117 K=1,NLM
         CC = GLO+FLOAT(K-1)*FANC
         IF (CC .GT. HA) GO TO 118
         KK = K
         CL(K) = CC
  117 CONTINUE
  118 NCL = KK
      CCLO = CL(1)
      CHI = CL(NCL)
      CINC = FANC
      RETURN
  119 ICNST = 1
      NCL = 1
      CCLO = GLO
      RETURN
  120 CL(1) = GLO
      NCL = 1
      RETURN
      END
      SUBROUTINE DRLINE (Z,L,MM,NN)
      SAVE
      DIMENSION       Z(L,NN)
C
C THIS ROUTINE TRACES A CONTOUR LINE WHEN GIVEN THE BEGINNING BY STLINE.
C TRANSFORMATIONS CAN BE ADDED BY DELETING THE STATEMENT FUNCTIONS FOR
C FX AND FY IN DRLINE AND MINMAX AND ADDING EXTERNAL FUNCTIONS.
C X=1. AT Z(1,J), X=FLOAT(M) AT Z(M,J). X TAKES ON NON-INTEGER VALUES.
C Y=1. AT Z(I,1), Y=FLOAT(N) AT Z(I,N). Y TAKES ON NON-INTEGER VALUES.
C
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(80000)  ,NR
c + noao:  dimension of ir array in conre2 changed from 500 to 20000 6March87
c + noao:  dimension of ir array in conre2 changed from 20000 to 80000 6-93
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE3/ IXBITS     ,IYBITS
      LOGICAL         IPEN       ,IPENO
      DATA IPEN,IPENO/.TRUE.,.TRUE./
C
      FX(X,Y) = X
      FY(X,Y) = Y
      IXYPAK(IXX,IYY) = ISHIFT(IXX,IYBITS)+IYY
      C(P1,P2) = (P1-CV)/(P1-P2)
C
      M = MM
      N = NN
      IF (IOFFP .EQ. 0) GO TO 101
      ASSIGN 110 TO JUMP1
      ASSIGN 115 TO JUMP2
      GO TO 102
  101 ASSIGN 112 TO JUMP1
      ASSIGN 117 TO JUMP2
  102 IX0 = IX
      IY0 = IY
      IS0 = IS
      IF (IOFFP .EQ. 0) GO TO 103
      IX2 = IX+INX(IS)
      IY2 = IY+INY(IS)
      IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL
      IPENO = IPEN
  103 IF (IDX .EQ. 0) GO TO 104
      Y = IY
      ISUB = IX+IDX
      X = C(Z(IX,IY),Z(ISUB,IY))*FLOAT(IDX)+FLOAT(IX)
      GO TO 105
  104 X = IX
      ISUB = IY+IDY
      Y = C(Z(IX,IY),Z(IX,ISUB))*FLOAT(IDY)+FLOAT(IY)
  105 CALL FRSTD (FX(X,Y),FY(X,Y))
  106 IS = IS+1
      IF (IS .GT. 8) IS = IS-8
      IDX = INX(IS)
      IDY = INY(IS)
      IX2 = IX+IDX
      IY2 = IY+IDY
      IF (ISS .NE. 0) GO TO 107
      IF (IX2.GT.M .OR. IY2.GT.N .OR. IX2.LT.1 .OR. IY2.LT.1) GO TO 120
  107 IF (CV-Z(IX2,IY2)) 108,108,109
  108 IS = IS+4
      IX = IX2
      IY = IY2
      GO TO 106
  109 IF (IS/2*2 .EQ. IS) GO TO 106
      GO TO JUMP1,(110,112)
  110 ISBIG = IS+(8-IS)/6*8
      IX3 = IX+INX(ISBIG-1)
      IY3 = IY+INY(ISBIG-1)
      IX4 = IX+INX(ISBIG-2)
      IY4 = IY+INY(ISBIG-2)
      IPENO = IPEN
      IF (ISS .NE. 0) GO TO 111
      IF (IX3.GT.M .OR. IY3.GT.N .OR. IX3.LT.1 .OR. IY3.LT.1) GO TO 120
      IF (IX4.GT.M .OR. IY4.GT.N .OR. IX4.LT.1 .OR. IY4.LT.1) GO TO 120
  111 IPEN = Z(IX,IY).NE.SPVAL .AND. Z(IX2,IY2).NE.SPVAL .AND.
     1       Z(IX3,IY3).NE.SPVAL .AND. Z(IX4,IY4).NE.SPVAL
  112 IF (IDX .EQ. 0) GO TO 113
      Y = IY
      ISUB = IX+IDX
      X = C(Z(IX,IY),Z(ISUB,IY))*FLOAT(IDX)+FLOAT(IX)
      GO TO 114
  113 X = IX
      ISUB = IY+IDY
      Y = C(Z(IX,IY),Z(IX,ISUB))*FLOAT(IDY)+FLOAT(IY)
  114 GO TO JUMP2,(115,117)
  115 IF (.NOT.IPEN) GO TO 118
      IF (IPENO) GO TO 116
C
C END OF LINE SEGMENT
C
      CALL LASTD
      CALL FRSTD (FX(XOLD,YOLD),FY(XOLD,YOLD))
C
C CONTINUE LINE SEGMENT
C
  116 CONTINUE
  117 CALL VECTD (FX(X,Y),FY(X,Y))
  118 XOLD = X
      YOLD = Y
      IF (IS .NE. 1) GO TO 119
      NP = NP+1
      IF (NP .GT. NR) GO TO 120
      IR(NP) = IXYPAK(IX,IY)
  119 IF (ISS .EQ. 0) GO TO 106
      IF (IX.NE.IX0 .OR. IY.NE.IY0 .OR. IS.NE.IS0) GO TO 106
C
C END OF LINE
C
  120 CALL LASTD
      RETURN
      END
      SUBROUTINE MINMAX (Z,L,MM,NN,ISSIZM,AASH,JOFFDT)
C
C THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - MN IN THE X DIRECTION AND + OR - NM IN THE Y DIRECTION.
C
C ORIGINATOR       DAVID KENNISON
C
      SAVE
      CHARACTER*6     IA
      DIMENSION       Z(L,NN)
C
C
C
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE5/ SCLY
C
      FX(X,Y) = X
      FY(X,Y) = Y
C
      M = MM
      N = NN
C
C SET UP SCALING FOR LABELS
C
      SIZEM = (ISSIZM + 1)*256*SCLY
      ISIZEM = ISSIZM
C
      ASH = ABS(AASH)
      IOFFDT = JOFFDT
C
      IF (AASH .LT. 0.0) GO TO 128
C
      MN = MIN0(15,MAX0(2,IFIX(FLOAT(M)/8.)))
      NM = MIN0(15,MAX0(2,IFIX(FLOAT(N)/8.)))
      NM1 = N-1
      MM1 = M-1
C
C LINE LOOP FOLLOWS - THE COMPLETE TWO-DIMENSIONAL TEST FOR A MINIMUM OR
C MAXIMUM OF THE FIELD IS ONLY PERFORMED FOR POINTS WHICH ARE MINIMA OR
C MAXIMA ALONG SOME LINE - FINDING THESE CANDIDATES IS MADE EFFICIENT BY
C USING A COUNT OF CONSECUTIVE INCREASES OR DECREASES OF THE FUNCTION
C ALONG THE LINE
C
      DO 127 JP=2,NM1
C
         IM = MN-1
         IP = -1
         GO TO 126
C
C CONTROL RETURNS TO STATEMENT 10 AS LONG AS THE FUNCTION IS INCREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MAXIMUM
C
  101    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 104
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 102,103,104
  102    IM = IM+1
         GO TO 101
  103    IM = 0
         GO TO 101
C
C FUNCTION DECREASED - TEST FOR MAXIMUM ON LINE
C
  104    IF (IM .GE. MN) GO TO 106
         IS = MAX0(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 106
         DO 105 II=IS,IT
            IF (AA .LE. Z(II,JP)) GO TO 112
  105    CONTINUE
  106    IS = IP+2
         IT = MIN0(M,IP+MN)
         IF (IS .GT. IT) GO TO 109
         DO 108 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 107
            IP = II-1
            GO TO 125
  107       IF (AA .LE. Z(II,JP)) GO TO 112
  108    CONTINUE
C
C WE HAVE MAXIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MAXIMUM OF FIELD
C
  109    JS = MAX0(1,JP-NM)
         JT = MIN0(N,JP+NM)
         IS = MAX0(1,IP-MN)
         IT = MIN0(M,IP+MN)
         DO 111 JK=JS,JT
            IF (JK .EQ. JP) GO TO 111
            DO 110 IK=IS,IT
               IF (Z(IK,JK).GE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 112
  110       CONTINUE
  111    CONTINUE
C
         X = FLOAT(IP)
         Y = FLOAT(JP)
         CALL WTSTR ( FX(X,Y),FY(X,Y),'H',ISIZEM,0,0 )
         CALL FL2INT ( FX(X,Y),FY(X,Y),IFX,IFY )
C
C SCALE TO USER SET RESOLUTION
C
         IFY = IFY*SCLY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY - SIZEM
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  112    IM = 1
         IF (IP-MM1) 113,127,127
C
C CONTROL RETURNS TO STATEMENT 20 AS LONG AS THE FUNCTION IS DECREASING
C ALONG THE LINE - WE SEEK A POSSIBLE MINIMUM
C
  113    IP = IP+1
         AA = AN
         IF (IP .EQ. MM1) GO TO 116
         AN = Z(IP+1,JP)
         IF (IOFFP.NE.0 .AND. AN.EQ.SPVAL) GO TO 125
         IF (AA-AN) 116,115,114
  114    IM = IM+1
         GO TO 113
  115    IM = 0
         GO TO 113
C
C FUNCTION INCREASED - TEST FOR MINIMUM ON LINE
C
  116    IF (IM .GE. MN) GO TO 118
         IS = MAX0(1,IP-MN)
         IT = IP-IM-1
         IF (IS .GT. IT) GO TO 118
         DO 117 II=IS,IT
            IF (AA .GE. Z(II,JP)) GO TO 124
  117    CONTINUE
  118    IS = IP+2
         IT = MIN0(M,IP+MN)
         IF (IS .GT. IT) GO TO 121
         DO 120 II=IS,IT
            IF (IOFFP.EQ.0 .OR. Z(II,JP).NE.SPVAL) GO TO 119
            IP = II-1
            GO TO 125
  119       IF (AA .GE. Z(II,JP)) GO TO 124
  120    CONTINUE
C
C WE HAVE MINIMUM ON LINE - DO TWO-DIMENSIONAL TEST FOR MINIMUM OF FIELD
C
  121    JS = MAX0(1,JP-NM)
         JT = MIN0(N,JP+NM)
         IS = MAX0(1,IP-MN)
         IT = MIN0(M,IP+MN)
         DO 123 JK=JS,JT
            IF (JK .EQ. JP) GO TO 123
            DO 122 IK=IS,IT
               IF (Z(IK,JK).LE.AA .OR.
     1             (IOFFP.NE.0 .AND. Z(IK,JK).EQ.SPVAL)) GO TO 124
  122       CONTINUE
  123    CONTINUE
C
         X = FLOAT(IP)
         Y = FLOAT(JP)
         CALL WTSTR ( FX(X,Y),FY(X,Y),'L',ISIZEM,0,0 )
         CALL FL2INT( FX(X,Y),FY(X,Y),IFX,IFY )
         IFY = SCLY*IFY
         CALL ENCD (AA,ASH,IA,NC,IOFFDT)
         MY = IFY - SIZEM
         TMY = CPUY ( MY )
         CALL WTSTR ( FX(X,Y),TMY,IA(1:NC),ISIZEM,0,0 )
  124    IM = 1
         IF (IP-MM1) 101,127,127
C
C SKIP SPECIAL VALUES ON LINE
C
  125    IM = 0
  126    IP = IP+1
         IF (IP .GE. MM1) GO TO 127
         IF (IOFFP.NE.0 .AND. Z(IP+1,JP).EQ.SPVAL) GO TO 125
         IM = IM+1
         IF (IM .LE. MN) GO TO 126
         IM = 1
         AN = Z(IP+1,JP)
         IF (Z(IP,JP)-AN) 101,103,113
C
  127 CONTINUE
C
      RETURN
C
C ****************************** ENTRY PNTVAL **************************
C     ENTRY PNTVAL (Z,L,MM,NN,ISSIZM,AASH,JOFFDT)
C
  128 CONTINUE
      II = (M-1+24)/24
      JJ = (N-1+48)/48
      NIQ = 1
      NJQ = 1
      DO 130 J=NJQ,N,JJ
         Y = J
         DO 129 I=NIQ,M,II
            X = I
            ZZ = Z(I,J)
            IF (IOFFP.NE.0 .AND. ZZ.EQ.SPVAL) GO TO 129
            CALL ENCD (ZZ,ASH,IA,NC,IOFFDT)
            CALL WTSTR (FX(X,Y),FY(X,Y),IA(1:NC),ISIZEM,0,0 )
  129    CONTINUE
  130 CONTINUE
      RETURN
      END
      SUBROUTINE REORD (CL,NCL,C1,MARK,NMG)
      SAVE
      DIMENSION       CL(NCL)    ,C1(NCL)
C
C THIS ROUTINE PUTS THE MAJOR (LABELED) LEVELS IN THE BEGINNING OF CL
C AND THE MINOR (UNLABELED) LEVELS IN END OF CL.  THE NUMBER OF MAJOR
C LEVELS IS RETURNED IN MARK.  C1 IS USED AS A WORK SPACE.  NMG IS THE
C NUMBER OF MINOR GAPS (ONE MORE THAN THE NUMBER OF MINOR LEVELS BETWEEN
C MAJOR LEVELS).
C
      NL = NCL
      IF (NL.LE.4 .OR. NMG.LE.1) GO TO 113
      NML = NMG-1
      IF (NL .LE. 10) NML = 1
C
C CHECK FOR ZERO OR OTHER NICE NUMBER FOR A MAJOR LINE
C
      NMLP1 = NML+1
      DO 101 I=1,NL
         ISAVE = I
         IF (CL(I) .EQ. 0.) GO TO 104
  101 CONTINUE
      L = NL/2
      L = ALOG10(ABS(CL(L)))+1.
      Q = 10.**L
      DO 103 J=1,3
         Q = Q/10.
         DO 102 I=1,NL
            ISAVE = I
            IF (AMOD(ABS(CL(I)+1.E-9*CL(I))/Q,FLOAT(NMLP1)) .LE. .0001)
     1          GO TO 104
  102    CONTINUE
  103 CONTINUE
      ISAVE = NL/2
C
C PUT MAJOR LEVELS IN C1
C
  104 ISTART = MOD(ISAVE,NMLP1)
      IF (ISTART .EQ. 0) ISTART = NMLP1
      NMAJL = 0
      DO 105 I=ISTART,NL,NMLP1
         NMAJL = NMAJL+1
         C1(NMAJL) = CL(I)
  105 CONTINUE
      MARK = NMAJL
      L = NMAJL
C
C PUT MINOR LEVELS IN C1
C
      IF (ISTART .EQ. 1) GO TO 107
      DO 106 I=2,ISTART
         ISUB = L+I-1
         C1(ISUB) = CL(I-1)
  106 CONTINUE
  107 L = NMAJL+ISTART-1
      DO 109 I=2,NMAJL
         DO 108 J=1,NML
            L = L+1
            ISUB = ISTART+(I-2)*NMLP1+J
            C1(L) = CL(ISUB)
  108    CONTINUE
  109 CONTINUE
      NLML = NL-L
      IF (L .EQ. NL) GO TO 111
      DO 110 I=1,NLML
         L = L+1
         C1(L) = CL(L)
  110 CONTINUE
C
C PUT REORDERED ARRAY BACK IN ORIGINAL PLACE
C
  111 DO 112 I=1,NL
         CL(I) = C1(I)
  112 CONTINUE
      RETURN
  113 MARK = NL
      RETURN
      END
      SUBROUTINE STLINE (Z,LL,MM,NN,CONV)
      SAVE
      DIMENSION       Z(LL,NN)
C
C THIS ROUTINE FINDS THE BEGINNINGS OF ALL CONTOUR LINES AT LEVEL CONV.
C FIRST THE EDGES ARE SEARCHED FOR LINES INTERSECTING THE EDGE (OPEN
C LINES) THEN THE INTERIOR IS SEARCHED FOR LINES WHICH DO NOT INTERSECT
C THE EDGE (CLOSED LINES).  BEGINNINGS ARE STORED IN IR TO PREVENT RE-
C TRACING OF LINES.  IF IR IS FILLED, THE SEARCH IS STOPPED FOR THIS
C CONV.
C
      COMMON /CONRE2/ IX         ,IY         ,IDX        ,IDY        ,
     1                IS         ,ISS        ,NP         ,CV         ,
     2                INX(8)     ,INY(8)     ,IR(80000)  ,NR
c + noao:  dimension of ir array in conre2 changed from 500 to 20000 6March87
c + noao:  dimension of ir array in conre2 changed from 20000 to 80000 6-93
      COMMON /CONRE3/ IXBITS     ,IYBITS
C
C
C
C
C
C
      IXYPAK(IXX,IYY) = ISHIFT(IXX,IYBITS)+IYY
C
      L = LL
      M = MM
      N = NN
      CV = CONV
      NP = 0
      ISS = 0
      DO 102 IP1=2,M
         I = IP1-1
         IF (Z(I,1).GE.CV .OR. Z(IP1,1).LT.CV) GO TO 101
         IX = IP1
         IY = 1
         IDX = -1
         IDY = 0
         IS = 1
         CALL DRLINE (Z,L,M,N)
  101    IF (Z(IP1,N).GE.CV .OR. Z(I,N).LT.CV) GO TO 102
         IX = I
         IY = N
         IDX = 1
         IDY = 0
         IS = 5
         CALL DRLINE (Z,L,M,N)
  102 CONTINUE
      DO 104 JP1=2,N
         J = JP1-1
         IF (Z(M,J).GE.CV .OR. Z(M,JP1).LT.CV) GO TO 103
         IX = M
         IY = JP1
         IDX = 0
         IDY = -1
         IS = 7
         CALL DRLINE (Z,L,M,N)
  103    IF (Z(1,JP1).GE.CV .OR. Z(1,J).LT.CV) GO TO 104
         IX = 1
         IY = J
         IDX = 0
         IDY = 1
         IS = 3
         CALL DRLINE (Z,L,M,N)
  104 CONTINUE
      ISS = 1
      DO 108 JP1=3,N
         J = JP1-1
         DO 107 IP1=2,M
            I = IP1-1
            IF (Z(I,J).GE.CV .OR. Z(IP1,J).LT.CV) GO TO 107
            IXY = IXYPAK(IP1,J)
            IF (NP .EQ. 0) GO TO 106
            DO 105 K=1,NP
               IF (IR(K) .EQ. IXY) GO TO 107
  105       CONTINUE
  106       NP = NP+1
            IF (NP .GT. NR) THEN
C
C THIS PRINTS AN ERROR MESSAGE IF THE LOCAL ARRAY IR IN SUBROUTINE
C STLINE HAS AN OVERFLOW
C THIS MESSAGE IS WRITTEN BOTH ON THE FRAME AND ON THE STANDARD ERROR
C UNIT
C
C +NOAO - Message is written only to stderr, not to the plotting frame.
C         Error is written with uliber, not FTN write statement.
C
      call uliber (1, 'STLINE (CONREC) - WORK ARRAY OVERFLOW', 80)
      call uliber (1,'STLINE - ***WARNING -- PICTURE INCOMPLETE***',80)
C     IUNIT = I1MACH(4)
C     WRITE(IUNIT,1000)
C1000 FORMAT(
C    1' WARNING FROM ROUTINE STLINE IN CONREC--WORK ARRAY OVERFLOW')
C     CALL GETSET(VXA,VXB,VYA,VYB,XA,XB,YA,YB,LTYPE)
C     Y = (YB - YA) / 2.
C     X = (XB - XA) / 2.
C     CALL PWRIT(X,Y,
C    1'**WARNING--PICTURE INCOMPLETE**',
C    2 31,3,0,0)
C     Y = Y * .7
C     CALL PWRIT(X,Y,
C    1'WORK ARRAY OVERFLOW IN STLINE',
C    2 29,3,0,0)
C -NOAO
        RETURN
        ENDIF
            IR(NP) = IXY
            IX = IP1
            IY = J
            IDX = -1
            IDY = 0
            IS = 1
            CALL DRLINE (Z,L,M,N)
  107    CONTINUE
  108 CONTINUE
      RETURN
      END
      SUBROUTINE CALCNT (Z,M,N,A1,A2,A3,I1,I2,I3)
C
C THIS ENTRY POINT IS FOR USERS WHO ARE TOO LAZY TO SWITCH OLD DECKS
C TO THE NEW CALLING SEQUENCE.
C
      DIMENSION       Z(M,N)
      SAVE
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','CONREC','CALCNT','VERSION 01')
C
      CALL CONREC (Z,M,M,N,A1,A2,A3,I1,I2,-IABS(I3))
      RETURN
      END
      SUBROUTINE EZCNTR (Z,M,N)
C
C CONTOURING VIA SHORTEST POSSIBLE ARGUMENT LIST
C ASSUMPTIONS --
C     ALL OF THE ARRAY IS TO BE CONTOURED,
C     CONTOUR LEVELS ARE PICKED INTERNALLY,
C     CONTOURING ROUTINE PICKS SCALE FACTORS,
C     HIGHS AND LOWS ARE MARKED,
C     NEGATIVE LINES ARE DRAWN WITH A DASHED LINE PATTERN,
C     EZCNTR CALLS FRAME AFTER DRAWING THE CONTOUR MAP.
C IF THESE ASSUMPTIONS ARE NOT MET, USE CONREC.
C
C ARGUMENTS
C     Z   ARRAY TO BE CONTOURED
C     M   FIRST DIMENSION OF Z
C     N   SECOND DIMENSION OF Z
C
      SAVE
      DIMENSION       Z(M,N)
      DATA NSET,NHI,NDASH/0,0,682/
C
C                             682=1252B
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','CONREC','EZCNTR','VERSION 01')
C
      CALL CONREC (Z,M,M,N,0.,0.,0.,NSET,NHI,-NDASH)
C +NOAO - EZCNTR no longer calls frame.
C     CALL FRAME
C -NOAO
      RETURN
      END
C
C REVISION HISTORY---
C
C JANUARY 1980     ADDED REVISION HISTORY AND CHANGED LIBRARY NAME
C                  FROM CRAYLIB TO PORTLIB FOR MOVE TO PORTLIB
C
C MAY 1980         ARRAYS IWORK AND ENCSCR, PREVIOUSLY TOO SHORT FOR
C                  SHORT-WORD-LENGTH MACHINES, LENGTHENED.  SOME
C                  DOCUMENTATION CLARIFIED AND CORRECTED.
C
C JUNE 1984        CONVERTED TO FORTRAN 77 AND TO GKS
C
C JUNE 1985        ERROR HANDLING LINES ADDED; IF OVERFLOW HAPPENS TO
C                  WORK ARRAY IN STLINE, A WARNING MESSAGE IS WRITTEN
C                  BOTH ON PLOT FRAME AND ON STANDARD ERROR MESSAGE.
C-------------------------------------------------------------------
C

include	defs

# outsub - determine if argument is STDOUT substitution

   integer function outsub (arg, file, access)
   character arg (ARB), file (ARB)
   integer access

   if (arg (1) == GREATER & arg (2) != GREATER & arg (2) != EOS) {
      outsub = YES
      access = WRITE
      call scopy (arg, 2, file, 1)
      }

   else if (arg (1) == GREATER & arg (2) == GREATER & arg (3) != EOS) {
      access = APPEND
      outsub = YES
      call scopy (arg, 3, file, 1)
      }

   else
      outsub = NO

   return
   end

chapter xii, example 4. quasi-interpolant with good knots.
c  from  * a practical guide to splines *  by c. de boor
calls bsplpp(bsplvb)
c
      integer i,irate,istep,j,l,m,mmk,n,nlow,nhigh,nm1
      real algerp,aloger,bcoef(22),break(20),c(4,20),decay,dg,ddg,x
     *	  ,dtip1,dtip2,dx,errmax,g,h,pnatx,scrtch(4,4),step,t(26),taui
c     istep and step = float(istep) specify point density for error det-
c     ermination.
      data step, istep /20., 20/
c	 g  is the function to be approximated,  dg  is its first, and
c	 ddg  its second derivative .
      g(x) = sqrt(x+1.)
      dg(x) = .5/g(x)
      ddg(x) = -.5*dg(x)/(x+1.)
      decay = 0.
c      read in the exponent  irate  for the knot distribution and the
c      lower and upper limit for the number  n	.
      read 500,irate,nlow,nhigh
  500 format(3i3)
      print 600
  600 format(28h  n   max.error   decay exp./)
c			       loop over  n = dim( spline(4,t) ) - 2 .
c	       n  is chosen as the parameter in order to afford compar-
c	       ison with examples 2 and 3  in which cubic spline interp-
c	       olation at  n  data points was used .
      do 40 n=nlow,nhigh,2
	 nm1 = n-1
	 h = 1./float(nm1)
	 m = n+2
	 mmk = m-4
	 do 5 i=1,4
	    t(i) = -1.
    5	    t(m+i) = 1.
c		  interior knots are equidistributed with respect to the
c		  function  (x + 1)**(1/irate) .
	 do 6 i=1,mmk
    6	    t(i+4) = 2.*(float(i)*h)**irate - 1.
c					    construct quasi-interpolant.
c						 bcoef(1) = g(-1.) = 0.
	 bcoef(1) = 0.
	 dtip2 = t(5) - t(4)
	 taui = t(5)
c			    special choice of  tau(2)  to avoid infinite
c			    derivatives of  g  at left endpoint .
	 bcoef(2) = g(taui) - 2.*dtip2*dg(taui)/3.
     *		   + dtip2**2*ddg(taui)/6.
	 do 15 i=3,m
	    taui = t(i+2)
	    dtip1 = dtip2
	    dtip2 = t(i+3) - t(i+2)
c				       formula xii(30) of text is used .
   15	    bcoef(i) = g(taui) + (dtip2-dtip1)*dg(taui)/3.
     *		     - dtip1*dtip2*ddg(taui)/6.
c					  convert to pp-representation .
	 call bsplpp(t,bcoef,m,4,scrtch,break,c,l)
c			     estimate max.interpolation error on (-1,1).
	 errmax = 0.
c					      loop over cubic pieces ...
	 do 30 i=1,l
	    dx = (break(i+1)-break(i))/step
c			error is calculated at	istep  points per piece.
	    do 30 j=1,istep
	       h = float(j)*dx
	       pnatx = c(1,i)+h*(c(2,i)+h*(c(3,i)+h*c(4,i)/3.)/2.)
   30	       errmax = amax1(errmax,abs(g(break(i)+h)-pnatx))
c					      calculate decay exponent .
	 aloger = alog(errmax)
	 if (n .gt. nlow)  decay =
     *	     (aloger - algerp)/alog(float(n)/float(n-2))
	 algerp = aloger
c
   40	 print 640,n,errmax,decay
  640 format(i3,e12.4,f11.2)
					stop
      end

c function agauss.f
c
c source
c   Bevington, page 48.
c
c purpose
c   evaluate integral of gaussian probability function
c
c usage
c   result = agauss (x, averag, sigma)
c
c description of parameters
c   x      - limit for integral
c   averag - mean of distribution
c   sigma  - standard deviation of distribution
c   integration range is averag +/- z*sigma
c      where z = abs(x-averag)/sigma
c
c subroutines and function subprograms required
c   none
c
	function agauss (x,averag,sigma)
	double precision z,y2,term,sum,denom
11	z=abs(x-averag)/sigma
	agauss=0.
	if (z) 42,42,21
21	term=0.7071067812*z
22	sum=term
	y2=(z**2)/2.
	denom=1.
c
c accumulate sums of terms
c
31	denom=denom+2.
32	term=term*(y2*2./denom)
33	sum=sum+term
	if (term/sum-1.e-10) 41,41,31
41	agauss=1.128379167*sum*dexp(-y2)
42	return
	end

      DOUBLE PRECISION FUNCTION slDPAV ( V1, V2 )
*+
*     - - - - -
*      D P A V
*     - - - - -
*
*  Position angle of one celestial direction with respect to another.
*
*  (double precision)
*
*  Given:
*     V1    d(3)    direction cosines of one point
*     V2    d(3)    direction cosines of the other point
*
*  (The coordinate frames correspond to RA,Dec, Long,Lat etc.)
*
*  The result is the bearing (position angle), in radians, of point
*  V2 with respect to point V1.  It is in the range +/- pi.  The
*  sense is such that if V2 is a small distance east of V1, the
*  bearing is about +pi/2.  Zero is returned if the two points
*  are coincident.
*
*  V1 and V2 need not be unit vectors.
*
*  The routine slDBER performs an equivalent function except
*  that the points are specified in the form of spherical
*  coordinates.
*
*  Last revision:   16 March 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION V1(3),V2(3)

      DOUBLE PRECISION X1,Y1,Z1,W,X2,Y2,Z2,SQ,CQ



*  The unit vector to point 1.
      X1 = V1(1)
      Y1 = V1(2)
      Z1 = V1(3)
      W = SQRT(X1*X1+Y1*Y1+Z1*Z1)
      IF (W.NE.0D0) THEN
         X1 = X1/W
         Y1 = Y1/W
         Z1 = Z1/W
      END IF

*  The vector to point 2.
      X2 = V2(1)
      Y2 = V2(2)
      Z2 = V2(3)

*  Position angle.
      SQ = Y2*X1-X2*Y1
      CQ = Z2*(X1*X1+Y1*Y1)-Z1*(X2*X1+Y2*Y1)
      IF (SQ.EQ.0D0.AND.CQ.EQ.0D0) CQ=1D0
      slDPAV = ATAN2(SQ,CQ)

      END

C----------------------------------------------------------------------
        subroutine ftgclc(iunit,colnum,frow,felem,nelem,eincr,
     &   nultyp,nulval,array,flgval,anynul,status)

C       read an array of complex data values from the specified column of
C       the table.  
C       This general purpose routine will handle null values in one
C       of two ways: if nultyp=1, then undefined array elements will be
C       set equal to the input value of NULVAL.  Else if nultyp=2, then
C       undefined array elements will have the corresponding FLGVAL element
C       set equal to .TRUE.  If NULTYP=1 and NULVAL=0, then no checks for
C       undefined values will be made, for maximum efficiency.
C       The binary table column being read to must have datatype 'C'
C       and no datatype conversion will be perform if it is not.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read from
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of (pairs) elements to read
C       eincr   i  element increment
C       nultyp  i  input code indicating how to handle undefined values
C       nulval  r  value that undefined pixels will be set to (if nultyp=1)
C       array   r  array of data values that are read from the FITS file
C       flgval  l  set .true. if corresponding element undefined (if nultyp=2)
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,eincr,nultyp,status
        real array(*),nulval(2)
        logical flgval(*),anynul

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bytpix,bstart,tcode,nulchk,incre
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart
        integer offset,rskip,dstart,begcol,lenrow,i,j
        logical scaled,descrp
        double precision scale,zero
        character crow*9,cp1*9,cp2*9,ccol*4

        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table read '//
     &          'request is out of range:'//crow//' (FTGCLC).')
                return
        end if
        if (felem .lt. 1)then
C               illegal element number
                status=308
                write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLC).')
                return
        end if

        i1=1
        ntodo=nelem
        estart=felem-1
        rstart=frow-1
        anynul=.false.
        ibuff=bufnum(iunit)
        dstart=dtstrt(ibuff)
        lenrow=rowlen(ibuff)
        begcol=tbcol(colnum+tstart(ibuff))
        tcode=tdtype(colnum+tstart(ibuff))
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
        bytpix=8

C       determine the repeat count and the first element position
C       incre is the byte offset between consecutive pixels
        incre=bytpix*eincr               

        if (tcode .eq. 83)then
                descrp=.false.
                repeat=trept(colnum+tstart(ibuff))
                if (felem .gt. repeat)then
C                        illegal element number
                         status=308
                         write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLC).')
                         return
                end if
                if (repeat .eq. 1 .and. nelem .gt. 1)then
C                        read multiple rows of data at one time by
C                        fooling it into thinking that this is a vector
C                        column with a large value of bytes per pixel
                                dstart=dstart+rstart*lenrow
                                rstart=0
                                estart=0
                                repeat=nelem*eincr
                                incre=lenrow*eincr 
                                lenrow=lenrow*repeat
                end if
        else if (tcode .eq. -83)then
C               this is a variable length descriptor column
C               read the number of elements and the starting offset:
                descrp=.true.
                call ftgdes(iunit,colnum,frow,repeat,offset,status)
                if (repeat .eq. 0)then
C                               error: null length vector
                                 status=318
                                return
                else if (estart+(nelem-1)*eincr+1 .gt. repeat) then
C                               error: trying to read beyond end of record
                                status=319
                                return
                end if
C               define the starting point of the row
                dstart=dstart+offset+theap(ibuff)
                rstart=0
                begcol=0
        else
C               column must be complex data type
                status=312
                call ftpmsg('Column'//ccol//' does not have '//
     &          'Complex (C) data type (FTGCLC).')
                return
        end if

C       determine if we have to check for null values
        if (nultyp .eq. 1 .and. nulval(1) .eq. 0 .and.
     &      nulval(2) .eq. 0)then
C               user doesn't want to check for nulls
                nulchk=0
        else
C           user does want to check for null values
            nulchk=nultyp
        end if

C       check if scaling is required
        if (scale .eq. 1.0 .and. zero .eq. 0.)then
                scaled=.false.
        else
                scaled=.true.
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,(repeat-estart-1)/eincr+1)

C       move the i/o pointer to the start of the sequence of pixels
        bstart=dstart+rstart*lenrow+begcol+estart*bytpix
        call ftmbyt(iunit,bstart,.false.,status)

C       read the data 
        if (incre .eq. 8)then
C               the data values are contiguous in the FITS file
C               multiply itodo*2 because we are getting pairs of values
                call ftgr4b(iunit,itodo*2,4,array(i1),status)
        else
C               have to read each complex pair one by one
                j=i1
                call ftgr4b(iunit,2,4,array(j),status)
                j=j+2
                do 25 i=2,itodo
                    call ftmoff(iunit,incre-8,.false.,status)
                    call ftgr4b(iunit,2,4,array(j),status)
                    j=j+2
25              continue
        end if

C       find number of pixels left to do, and process them
30      ntodo=ntodo-itodo

        if (status .gt. 0)then
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error reading elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTGCLC.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error reading rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTGCLC).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error reading'//cp2//' elements from'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTGCLC).')
             end if
            return
        end if

        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo*2
                estart=estart+itodo*eincr
                rskip=estart/repeat
                rstart=rstart+rskip
                estart=estart-rskip*repeat
                go to 20
        end if

C       check for null values and/or scale the values
        if (nulchk .ne. 0 .or. scaled)then
          call ftnulc(array,nelem,nulchk,nulval,flgval,anynul,
     &     scaled,scale,zero)
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftpdef(ounit,bitpix,naxis,naxes,pcount,gcount,
     &                    status)

C       Primary data DEFinition
C       define the structure of the primary data unit or an IMAGE extension
C
C       ounit   i  Fortran I/O unit number
C       bitpix  i  bits per pixel value
C       naxis   i  number of data axes
C       naxes   i  length of each data axis (array)
C       pcount  i  number of group parameters
C       gcount  i  number of 'random groups'
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,bitpix,naxis,naxes(*),pcount,gcount,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne,nf
        parameter (nb = 20)
        parameter (ne = 200)
        parameter (nf = 3000)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff,ttype,bytlen,npix,i,pcnt,gcnt
        character caxis*20

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

        if (dtstrt(ibuff) .lt. 0)then
C               freeze the header at its current size
                call fthdef(ounit,0,status)
                if (status .gt. 0)return
        end if

C       check for error conditions
        if (naxis .lt. 0)then
                status=212
                write(caxis,1001)naxis
1001            format(i20)
                call ftpmsg('NAXIS ='//caxis//' in the call to FTPDEF '
     &          //'is illegal.')

        else if (pcount .lt. 0)then
                status=214
        else if (gcount .lt. 0)then
                status=215
        else
                go to 5
        end if
        return

C       test that bitpix has a legal value and set the datatype code value
5       if (bitpix .eq. 8)then
                ttype=11
                bytlen=1
        else if (bitpix .eq. 16)then
                ttype=21
                bytlen=2
        else if (bitpix .eq. 32)then
                ttype=41
                bytlen=4
        else if (bitpix .eq. -32)then
                ttype=42
                bytlen=4
        else if (bitpix .eq. -64)then
                ttype=82
                bytlen=8
        else
C               illegal value of bitpix
                status=211
                return
        end if

C       calculate the number of pixels in the array
        if (naxis .eq. 0)then
C               no data
                npix=0
                gcnt=0
                pcnt=0
        else
C               make sure that the gcount is not zero
                gcnt=max(gcount,1)
                pcnt=pcount        
                npix=1
                do 10 i=1,naxis
                        if (naxes(i) .ge. 0)then
C       The convension used by 'random groups' with NAXIS1 = 0 is not
C       directly supported here.  If one wants to write a 'random group'
C       FITS file, then one should call FTPDEF with naxes(1) = 1, but
C       then write the required header keywords (with FTPHPR) with 
C       naxes(1) = 0.
                                npix=npix*naxes(i)
                        else if (naxes(i) .lt. 0)then
                                status=213
                                return
                        end if
10              continue
        end if
C       the next HDU begins in the next logical block after the data
        hdstrt(ibuff,chdu(ibuff)+1)=
     &          dtstrt(ibuff)+((pcnt+npix)*bytlen*gcnt+2879)/2880*2880

C       the primary array is actually interpreted as a binary table.  There
C       are two columns: the first column contains the 
C       group parameters, if any, and the second column contains the
C       primary array of data.  Each group is a separate row in the table.
C       The scaling and null values are set to the default values.

        hdutyp(ibuff)=0
        tfield(ibuff)=2

        if (nxtfld + 2 .gt. nf)then
C               too many columns open at one time; exceeded array dimensions
                status=111
        else
                tstart(ibuff)=nxtfld
                nxtfld=nxtfld+2
                tdtype(1+tstart(ibuff))=ttype
                tdtype(2+tstart(ibuff))=ttype
                trept(1+tstart(ibuff))=pcnt
                trept(2+tstart(ibuff))=npix
C               choose a special value to represent the absence of a blank value
                tnull(1+tstart(ibuff))=123454321
                tnull(2+tstart(ibuff))=123454321
                tscale(1+tstart(ibuff))=1.
                tscale(2+tstart(ibuff))=1.
                tzero(1+tstart(ibuff))=0.
                tzero(2+tstart(ibuff))=0.
                tbcol(1+tstart(ibuff))=0
                tbcol(2+tstart(ibuff))=pcnt*bytlen
                rowlen(ibuff)=(pcnt+npix)*bytlen
        end if

C       initialize the fictitious heap starting address (immediately following
C       the array data) and a zero length heap.  This is used to find the
C       end of the data when checking the fill values in the last block. 
        scount(ibuff)=0
        theap(ibuff)=(pcnt+npix)*bytlen*gcnt
        nxheap(ibuff)=0
        end

      SUBROUTINE slICHF (STRING, NPTR, NVEC, NDIGIT, DIGIT)
*+
*     - - - - - -
*      I C H F
*     - - - - - -
*
*  Internal routine used by DFLTIN
*
*  Identify next character in string
*
*  Given:
*     STRING      char        string
*     NPTR        int         pointer to character to be identified
*
*  Returned:
*     NPTR        int         incremented unless end of field
*     NVEC        int         vector for identified character
*     NDIGIT      int         0-9 if character was a numeral
*     DIGIT       double      equivalent of NDIGIT
*
*     NVEC takes the following values:
*
*      1     0-9
*      2     space or TAB   !!! n.b. ASCII TAB assumed !!!
*      3     D,d,E or e
*      4     .
*      5     +
*      6     -
*      7     ,
*      8     else
*      9     outside field
*
*  If the character is not 0-9, NDIGIT and DIGIT are either not
*  altered or are set to arbitrary values.
*
*  P.T.Wallace   Starlink   22 December 1992
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER NPTR,NVEC,NDIGIT
      DOUBLE PRECISION DIGIT

      CHARACTER K
      INTEGER NCHAR

*  Character/vector tables
      INTEGER NCREC
      PARAMETER (NCREC=19)
      CHARACTER KCTAB(NCREC)
      INTEGER KVTAB(NCREC)
      DATA KCTAB/'0','1','2','3','4','5','6','7','8','9',
     :           ' ','D','d','E','e','.','+','-',','/
      DATA KVTAB/10*1,2,4*3,4,5,6,7/


*  Handle pointer outside field
      IF (NPTR.LT.1.OR.NPTR.GT.LEN(STRING)) THEN
         NVEC=9
      ELSE

*     Not end of field: identify the character
         K=STRING(NPTR:NPTR)
         DO NCHAR=1,NCREC
            IF (K.EQ.KCTAB(NCHAR)) THEN

*           Recognized
               NVEC=KVTAB(NCHAR)
               NDIGIT=NCHAR-1
               DIGIT=DBLE(NDIGIT)
               GO TO 2300
            END IF
         END DO

*     Not recognized: check for TAB    !!! n.b. ASCII assumed !!!
         IF (K.EQ.CHAR(9)) THEN

*        TAB: treat as space
            NVEC=2
         ELSE

*        Unrecognized
            NVEC=8
         END IF

*     Increment pointer
 2300    CONTINUE
         NPTR=NPTR+1
      END IF

      END

C----------------------------------------------------------------------
        subroutine fttkey(keynam,status)

C       test that keyword name contains only legal characters:
C         uppercase letters, numbers, hyphen, underscore, or space
C         (but no embedded spaces)

C       keynam  c*8  keyword name
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)

        character keynam*(*)
        integer status,i
        character*1 c1,pos
        logical spaces

        if (status .gt. 0)return

        spaces=.false.
        do 20 i=1,8
            c1=keynam(i:i)
            if ((c1 .ge. 'A' .and. c1 .le. 'Z') .or. 
     &          (c1 .ge. '0' .and. c1 .le. '9') .or.
     &           c1 .eq. '-' .or. c1 .eq. '_')then
                 if (spaces)then
C                   error: name contains embedded space
                    status=207
                    call ftpmsg('Keyword name contains embedded '//
     &              'space(s): '//keynam(1:8))
                    return
                 end if
            else if (c1 .eq. ' ')then
                 spaces=.true.
            else 
C                illegal character found
                 status=207
                 write(pos,1000)i
1000             format(i1)
                 call ftpmsg('Character '//pos//' in this keyword name'
     &           //' is illegal: "'//keynam(1:8)//'"')
C                explicitly test for the 2 most common cases:
                 if (ichar(c1) .eq. 0)then
                   call ftpmsg('(This is an ASCII NUL (0) character).')
                 else if (ichar(c1) .eq. 9)then
                   call ftpmsg('(This is an ASCII TAB (9) character).')
                 end if
                 return
            end if
20      continue
        end

c     subroutine qrbd (ipass,q,e,nn,v,mdv,nrv,c,mdc,ncc)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   qr algorithm for singular values of a bidiagonal matrix.
c
c     the bidiagonal matrix
c
c			(q1,e2,0...    )
c			(   q2,e3,0... )
c		 d=	(	.      )
c			(	  .   0)
c			(	    .en)
c			(	   0,qn)
c
c		  is pre and post multiplied by
c		  elementary rotation matrices
c		  ri and pi so that
c
c		  rk...r1*d*p1**(t)...pk**(t) = diag(s1,...,sn)
c
c		  to within working accuracy.
c
c  1. ei and qi occupy e(i) and q(i) as input.
c
c  2. rm...r1*c replaces 'c' in storage as output.
c
c  3. v*p1**(t)...pm**(t) replaces 'v' in storage as output.
c
c  4. si occupies q(i) as output.
c
c  5. the si's are nonincreasing and nonnegative.
c
c     this code is based on the paper and 'algol' code..
c ref..
c  1. reinsch,c.h. and golub,g.h. 'singular value decomposition
c     and least squares solutions' (numer. math.), vol. 14,(1970).
c
      subroutine qrbd (ipass,q,e,nn,v,mdv,nrv,c,mdc,ncc)
      logical wntv ,havers,fail
      dimension q(nn),e(nn),v(mdv,nn),c(mdc,ncc)
      zero=0.
      one=1.
      two=2.
c
      n=nn
      ipass=1
      if (n.le.0) return
      n10=10*n
      wntv=nrv.gt.0
      havers=ncc.gt.0
      fail=.false.
      nqrs=0
      e(1)=zero
      dnorm=zero
	   do 10 j=1,n
   10	   dnorm=amax1(abs(q(j))+abs(e(j)),dnorm)
	   do 200 kk=1,n
	   k=n+1-kk
c
c     test for splitting or rank deficiencies..
c	  first make test for last diagonal term, q(k), being small.
   20	    if(k.eq.1) go to 50
	    if(diff(dnorm+q(k),dnorm)) 50,25,50
c
c     since q(k) is small we will make a special pass to
c     transform e(k) to zero.
c
   25	   cs=zero
	   sn=-one
		do 40 ii=2,k
		i=k+1-ii
		f=-sn*e(i+1)
		e(i+1)=cs*e(i+1)
		call g1 (q(i),f,cs,sn,q(i))
c	  transformation constructed to zero position (i,k).
c
		if (.not.wntv) go to 40
		     do 30 j=1,nrv
   30		     call g2 (cs,sn,v(j,i),v(j,k))
c	       accumulate rt. transformations in v.
c
   40		continue
c
c	  the matrix is now bidiagonal, and of lower order
c	  since e(k) .eq. zero..
c
   50		do 60 ll=1,k
		l=k+1-ll
		if(diff(dnorm+e(l),dnorm)) 55,100,55
   55		if(diff(dnorm+q(l-1),dnorm)) 60,70,60
   60		continue
c     this loop can't complete since e(1) = zero.
c
	   go to 100
c
c	  cancellation of e(l), l.gt.1.
   70	   cs=zero
	   sn=-one
		do 90 i=l,k
		f=-sn*e(i)
		e(i)=cs*e(i)
		if(diff(dnorm+f,dnorm)) 75,100,75
   75		call g1 (q(i),f,cs,sn,q(i))
		if (.not.havers) go to 90
		     do 80 j=1,ncc
   80		     call g2 (cs,sn,c(i,j),c(l-1,j))
   90		continue
c
c	  test for convergence..
  100	   z=q(k)
	   if (l.eq.k) go to 170
c
c	  shift from bottom 2 by 2 minor of b**(t)*b.
	   x=q(l)
	   y=q(k-1)
	   g=e(k-1)
	   h=e(k)
	   f=((y-z)*(y+z)+(g-h)*(g+h))/(two*h*y)
	   g=sqrt(one+f**2)
	   if (f.lt.zero) go to 110
	   t=f+g
	   go to 120
  110	   t=f-g
  120	   f=((x-z)*(x+z)+h*(y/t-h))/x
c
c	  next qr sweep..
	   cs=one
	   sn=one
	   lp1=l+1
		do 160 i=lp1,k
		g=e(i)
		y=q(i)
		h=sn*g
		g=cs*g
		call g1 (f,h,cs,sn,e(i-1))
		f=x*cs+g*sn
		g=-x*sn+g*cs
		h=y*sn
		y=y*cs
		if (.not.wntv) go to 140
c
c	       accumulate rotations (from the right) in 'v'
		     do 130 j=1,nrv
  130		     call g2 (cs,sn,v(j,i-1),v(j,i))
  140		call g1 (f,h,cs,sn,q(i-1))
		f=cs*g+sn*y
		x=-sn*g+cs*y
		if (.not.havers) go to 160
		     do 150 j=1,ncc
  150		     call g2 (cs,sn,c(i-1,j),c(i,j))
c	       apply rotations from the left to
c	       right hand sides in 'c'..
c
  160		continue
	   e(l)=zero
	   e(k)=f
	   q(k)=x
	   nqrs=nqrs+1
	   if (nqrs.le.n10) go to 20
c	   return to 'test for splitting'.
c
	   fail=.true.
c     ..
c     cutoff for convergence failure. 'nqrs' will be 2*n usually.
  170	   if (z.ge.zero) go to 190
	   q(k)=-z
	   if (.not.wntv) go to 190
		do 180 j=1,nrv
  180		v(j,k)=-v(j,k)
  190	   continue
c	  convergence. q(k) is made nonnegative..
c
  200	   continue
      if (n.eq.1) return
	   do 210 i=2,n
	   if (q(i).gt.q(i-1)) go to 220
  210	   continue
      if (fail) ipass=2
      return
c     ..
c     every singular value is in order..
  220	   do 270 i=2,n
	   t=q(i-1)
	   k=i-1
		do 230 j=i,n
		if (t.ge.q(j)) go to 230
		t=q(j)
		k=j
  230		continue
	   if (k.eq.i-1) go to 270
	   q(k)=q(i-1)
	   q(i-1)=t
	   if (.not.havers) go to 250
		do 240 j=1,ncc
		t=c(i-1,j)
		c(i-1,j)=c(k,j)
  240		c(k,j)=t
  250	   if (.not.wntv) go to 270
		do 260 j=1,nrv
		t=v(j,i-1)
		v(j,i-1)=v(j,k)
  260		v(j,k)=t
  270	   continue
c	  end of ordering algorithm.
c
      if (fail) ipass=2
      return
      end

      SUBROUTINE slPRTL (JFORM, DATE0, DATE1,
     :                 EPOCH0, ORBI0, ANODE0, PERIH0, AORQ0, E0, AM0,
     :                 EPOCH1, ORBI1, ANODE1, PERIH1, AORQ1, E1, AM1,
     :                       JSTAT)
*+
*     - - - - - - -
*      P R T L
*     - - - - - - -
*
*  Update the osculating orbital elements of an asteroid or comet by
*  applying planetary perturbations.
*
*  Given (format and dates):
*     JFORM   i    choice of element set (2 or 3; Note 1)
*     DATE0   d    date of osculation (TT MJD) for the given elements
*     DATE1   d    date of osculation (TT MJD) for the updated elements
*
*  Given (the unperturbed elements):
*     EPOCH0  d    epoch (TT MJD) of the given element set (Note 2)
*     ORBI0   d    inclination (radians)
*     ANODE0  d    longitude of the ascending node (radians)
*     PERIH0  d    argument of perihelion (radians)
*     AORQ0   d    mean distance or perihelion distance (AU)
*     E0      d    eccentricity
*     AM0     d    mean anomaly (radians, JFORM=2 only)
*
*  Returned (the updated elements):
*     EPOCH1  d    epoch (TT MJD) of the updated element set (Note 2)
*     ORBI1   d    inclination (radians)
*     ANODE1  d    longitude of the ascending node (radians)
*     PERIH1  d    argument of perihelion (radians)
*     AORQ1   d    mean distance or perihelion distance (AU)
*     E1      d    eccentricity
*     AM1     d    mean anomaly (radians, JFORM=2 only)
*
*  Returned (status flag):
*     JSTAT   i    status: +102 = warning, distant epoch
*                          +101 = warning, large timespan ( > 100 years)
*                     +1 to +10 = coincident with planet (Note 6)
*                             0 = OK
*                            -1 = illegal JFORM
*                            -2 = illegal E0
*                            -3 = illegal AORQ0
*                            -4 = internal error
*                            -5 = numerical error
*
*  Notes:
*
*  1  Two different element-format options are available:
*
*     Option JFORM=2, suitable for minor planets:
*
*     EPOCH   = epoch of elements (TT MJD)
*     ORBI    = inclination i (radians)
*     ANODE   = longitude of the ascending node, big omega (radians)
*     PERIH   = argument of perihelion, little omega (radians)
*     AORQ    = mean distance, a (AU)
*     E       = eccentricity, e
*     AM      = mean anomaly M (radians)
*
*     Option JFORM=3, suitable for comets:
*
*     EPOCH   = epoch of perihelion (TT MJD)
*     ORBI    = inclination i (radians)
*     ANODE   = longitude of the ascending node, big omega (radians)
*     PERIH   = argument of perihelion, little omega (radians)
*     AORQ    = perihelion distance, q (AU)
*     E       = eccentricity, e
*
*  2  DATE0, DATE1, EPOCH0 and EPOCH1 are all instants of time in
*     the TT timescale (formerly Ephemeris Time, ET), expressed
*     as Modified Julian Dates (JD-2400000.5).
*
*     DATE0 is the instant at which the given (i.e. unperturbed)
*     osculating elements are correct.
*
*     DATE1 is the specified instant at which the updated osculating
*     elements are correct.
*
*     EPOCH0 and EPOCH1 will be the same as DATE0 and DATE1
*     (respectively) for the JFORM=2 case, normally used for minor
*     planets.  For the JFORM=3 case, the two epochs will refer to
*     perihelion passage and so will not, in general, be the same as
*     DATE0 and/or DATE1 though they may be similar to one another.
*
*  3  The elements are with respect to the J2000 ecliptic and equinox.
*
*  4  Unused elements (AM0 and AM1 for JFORM=3) are not accessed.
*
*  5  See the slPRTE routine for details of the algorithm used.
*
*  6  This routine is not intended to be used for major planets, which
*     is why JFORM=1 is not available and why there is no opportunity
*     to specify either the longitude of perihelion or the daily
*     motion.  However, if JFORM=2 elements are somehow obtained for a
*     major planet and supplied to the routine, sensible results will,
*     in fact, be produced.  This happens because the slPRTE routine
*     that is called to perform the calculations checks the separation
*     between the body and each of the planets and interprets a
*     suspiciously small value (0.001 AU) as an attempt to apply it to
*     the planet concerned.  If this condition is detected, the
*     contribution from that planet is ignored, and the status is set to
*     the planet number (1-10 = Mercury, Venus, EMB, Mars, Jupiter,
*     Saturn, Uranus, Neptune, Earth, Moon) as a warning.
*
*  Reference:
*
*     Sterne, Theodore E., "An Introduction to Celestial Mechanics",
*     Interscience Publishers Inc., 1960.  Section 6.7, p199.
*
*  Called:  slELUE, slPRTE, slUEEL
*
*  This revision:   19 June 2004
*
*  Copyright (C) 2004 P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE
      INTEGER JFORM
      DOUBLE PRECISION DATE0,DATE1,
     :                 EPOCH0,ORBI0,ANODE0,PERIH0,AORQ0,E0,AM0,
     :                 EPOCH1,ORBI1,ANODE1,PERIH1,AORQ1,E1,AM1
      INTEGER JSTAT

      DOUBLE PRECISION U(13),DM
      INTEGER J,JF



*  Check that the elements are either minor-planet or comet format.
      IF (JFORM.LT.2.OR.JFORM.GT.3) THEN
         JSTAT = -1
         GO TO 9999
      ELSE

*     Provisionally set the status to OK.
         JSTAT = 0
      END IF

*  Transform the elements from conventional to universal form.
      CALL slELUE(DATE0,JFORM,EPOCH0,ORBI0,ANODE0,PERIH0,
     :               AORQ0,E0,AM0,0D0,U,J)
      IF (J.NE.0) THEN
         JSTAT = J
         GO TO 9999
      END IF

*  Update the universal elements.
      CALL slPRTE(DATE1,U,J)
      IF (J.GT.0) THEN
         JSTAT = J
      ELSE IF (J.LT.0) THEN
         JSTAT = -5
         GO TO 9999
      END IF

*  Transform from universal to conventional elements.
      CALL slUEEL(U,JFORM,
     :               JF, EPOCH1, ORBI1, ANODE1, PERIH1,
     :               AORQ1, E1, AM1, DM, J)
      IF (JF.NE.JFORM.OR.J.NE.0) JSTAT=-5

 9999 CONTINUE
      END

      SUBROUTINE slDDTF (NDP, DAYS, SIGN, IHMSF)
*+
*     - - - - - -
*      D D T F
*     - - - - - -
*
*  Convert an interval in days into hours, minutes, seconds
*  (double precision)
*
*  Given:
*     NDP      i      number of decimal places of seconds
*     DAYS     d      interval in days
*
*  Returned:
*     SIGN     c      '+' or '-'
*     IHMSF    i(4)   hours, minutes, seconds, fraction
*
*  Notes:
*
*     1)  NDP less than zero is interpreted as zero.
*
*     2)  The largest useful value for NDP is determined by the size
*         of DAYS, the format of DOUBLE PRECISION floating-point numbers
*         on the target machine, and the risk of overflowing IHMSF(4).
*         On some architectures, for DAYS up to 1D0, the available
*         floating-point precision corresponds roughly to NDP=12.
*         However, the practical limit is NDP=9, set by the capacity of
*         a typical 32-bit IHMSF(4).
*
*     3)  The absolute value of DAYS may exceed 1D0.  In cases where it
*         does not, it is up to the caller to test for and handle the
*         case where DAYS is very nearly 1D0 and rounds up to 24 hours,
*         by testing for IHMSF(1)=24 and setting IHMSF(1-4) to zero.
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER NDP
      DOUBLE PRECISION DAYS
      CHARACTER SIGN*(*)
      INTEGER IHMSF(4)

*  Days to seconds
      DOUBLE PRECISION D2S
      PARAMETER (D2S=86400D0)

      INTEGER NRS,N
      DOUBLE PRECISION RS,RM,RH,A,AH,AM,AS,AF



*  Handle sign
      IF (DAYS.GE.0D0) THEN
         SIGN='+'
      ELSE
         SIGN='-'
      END IF

*  Field units in terms of least significant figure
      NRS=1
      DO N=1,NDP
         NRS=NRS*10
      END DO
      RS=DBLE(NRS)
      RM=RS*60D0
      RH=RM*60D0

*  Round interval and express in smallest units required
      A=ANINT(RS*D2S*ABS(DAYS))

*  Separate into fields
      AH=AINT(A/RH)
      A=A-AH*RH
      AM=AINT(A/RM)
      A=A-AM*RM
      AS=AINT(A/RS)
      AF=A-AS*RS

*  Return results
      IHMSF(1)=MAX(NINT(AH),0)
      IHMSF(2)=MAX(MIN(NINT(AM),59),0)
      IHMSF(3)=MAX(MIN(NINT(AS),59),0)
      IHMSF(4)=MAX(NINT(MIN(AF,RS-1D0)),0)

      END

*> \brief \b SGETRF
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download SGETRF + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sgetrf.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sgetrf.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sgetrf.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGETRF( M, N, A, LDA, IPIV, INFO )
*
*       .. Scalar Arguments ..
*       INTEGER            INFO, LDA, M, N
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       REAL               A( LDA, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGETRF computes an LU factorization of a general M-by-N matrix A
*> using partial pivoting with row interchanges.
*>
*> The factorization has the form
*>    A = P * L * U
*> where P is a permutation matrix, L is lower triangular with unit
*> diagonal elements (lower trapezoidal if m > n), and U is upper
*> triangular (upper trapezoidal if m < n).
*>
*> This is the right-looking Level 3 BLAS version of the algorithm.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix A.  M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the M-by-N matrix to be factored.
*>          On exit, the factors L and U from the factorization
*>          A = P*L*U; the unit diagonal elements of L are not stored.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (min(M,N))
*>          The pivot indices; for 1 <= i <= min(M,N), row i of the
*>          matrix was interchanged with row IPIV(i).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          > 0:  if INFO = i, U(i,i) is exactly zero. The factorization
*>                has been completed, but the factor U is exactly
*>                singular, and division by zero will occur if it is used
*>                to solve a system of equations.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup realGEcomputational
*
*  =====================================================================
      SUBROUTINE SGETRF( M, N, A, LDA, IPIV, INFO )
*
*  -- LAPACK computational routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IINFO, J, JB, NB
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM, SGETF2, SLASWP, STRSM
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = 64
      IF( NB.LE.1 .OR. NB.GE.MIN( M, N ) ) THEN
*
*        Use unblocked code.
*
         CALL SGETF2( M, N, A, LDA, IPIV, INFO )
      ELSE
*
*        Use blocked code.
*
         DO 20 J = 1, MIN( M, N ), NB
            JB = MIN( MIN( M, N )-J+1, NB )
*
*           Factor diagonal and subdiagonal blocks and test for exact
*           singularity.
*
            CALL SGETF2( M-J+1, JB, A( J, J ), LDA, IPIV( J ), IINFO )
*
*           Adjust INFO and the pivot indices.
*
            IF( INFO.EQ.0 .AND. IINFO.GT.0 )
     $         INFO = IINFO + J - 1
            DO 10 I = J, MIN( M, J+JB-1 )
               IPIV( I ) = J - 1 + IPIV( I )
   10       CONTINUE
*
*           Apply interchanges to columns 1:J-1.
*
            CALL SLASWP( J-1, A, LDA, J, J+JB-1, IPIV, 1 )
*
            IF( J+JB.LE.N ) THEN
*
*              Apply interchanges to columns J+JB:N.
*
               CALL SLASWP( N-J-JB+1, A( 1, J+JB ), LDA, J, J+JB-1,
     $                      IPIV, 1 )
*
*              Compute block row of U.
*
               CALL STRSM( 'Left', 'Lower', 'No transpose', 'Unit', JB,
     $                     N-J-JB+1, ONE, A( J, J ), LDA, A( J, J+JB ),
     $                     LDA )
               IF( J+JB.LE.M ) THEN
*
*                 Update trailing submatrix.
*
                  CALL SGEMM( 'No transpose', 'No transpose', M-J-JB+1,
     $                        N-J-JB+1, JB, -ONE, A( J+JB, J ), LDA,
     $                        A( J, J+JB ), LDA, ONE, A( J+JB, J+JB ),
     $                        LDA )
               END IF
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of SGETRF
*
      END

include  defs

# PARSE - parse Ratfor source program

subroutine parse

include COMMON_BLOCKS
character lexstr(MAXTOK)
integer lab, labval(MAXSTACK), lextyp(MAXSTACK), sp, token, i, t
integer lex
logical	push_stack

	sp = 1
	lextyp(1) = EOF

	for (token = lex(lexstr);  token != EOF;  token = lex(lexstr)) {
	    push_stack = .false.

	    switch (token) {
	    case LEXIF:
		call ifcode (lab)
		push_stack = .true.
	    case LEXIFERR:
		call iferrc (lab, 1)
		push_stack = .true.
	    case LEXIFNOERR:
		call iferrc (lab, 0)
		push_stack = .true.
	    case LEXDO:
		call docode (lab)
		push_stack = .true.
	    case LEXWHILE:
		call whilec (lab)
		push_stack = .true.
	    case LEXFOR:
		call forcod (lab)
		push_stack = .true.
	    case LEXREPEAT:
		call repcod (lab)
		push_stack = .true.
	    case LEXSWITCH:
		call swcode (lab)
		push_stack = .true.
	    case LEXCASE, LEXDEFAULT:
		for (i=sp;  i > 0;  i=i-1)	# find for most recent switch
		    if (lextyp(i) == LEXSWITCH)
		       break
		if (i == 0)
		    call synerr ("illegal case or default.")
		else
		    call cascod (labval (i), token)
	    case LEXDIGITS:
		call labelc (lexstr)
		push_stack = .true.
	    case LEXELSE:
		t = lextyp(sp)
		if (t == LEXIF | t == LEXIFERR | t == LEXIFNOERR)
		    call elseif (labval(sp))
		else
		    call synerr ("Illegal else.")

		t = lex (lexstr)			# check for "else if"
		call pbstr (lexstr)
		if (t == LEXIF | t == LEXIFERR | t == LEXIFNOERR) {
		    call indent (-1)			# cancel out indent +1
		    token = LEXIFELSE			# prevent -indent at end
		}
		push_stack = .true.
	    case LEXTHEN:
		if (lextyp(sp) == LEXIFERR | lextyp(sp) == LEXIFNOERR) {
		    call thenco (lextyp(sp), labval(sp))
		    lab = labval(sp)
		    token = lextyp(sp)
		    sp = sp - 1			# cancel out subsequent push
		} else
		    call synerr ("Illegal 'then' clause in iferr statement.")
		push_stack = .true.
	    case LEXLITERAL:
		call litral
	    case LEXERRCHK:
		call errchk
	    case LEXBEGIN:
		call beginc
	    case LEXEND:
		call endcod (lexstr)
		if (sp != 1) {
		    call synerr ("Missing right brace or 'begin'.")
		    sp = 1
		}
	    default:
		if (token == LBRACE)
		    push_stack = .true.
		else if (token == LEXDECL)
		    call declco (lexstr)
	    }

	    if (push_stack) {
		if (body == NO) {
		    call synerr ("Missing 'begin' keyword.")
		    call beginc
		}
		sp = sp + 1				# beginning of statement
		if (sp > MAXSTACK)
		    call baderr ("Stack overflow in parser.")
		lextyp(sp) = token			# stack type and value
		labval(sp) = lab

	    } else if (token != LEXCASE & token != LEXDEFAULT) {
		if (token == RBRACE)
		    token = LEXRBRACE

		switch (token) {
		case LEXOTHER:
		    call otherc (lexstr)
		case LEXBREAK, LEXNEXT:
		    call brknxt (sp, lextyp, labval, token)
		case LEXRETURN:
		    call retcod
		case LEXGOTO:
		    call gocode
		case LEXSTRING:
		    if (body == NO)
			call strdcl
		    else
			call otherc (lexstr)
		case LEXRBRACE:
		    if (lextyp(sp) == LBRACE)
			sp = sp - 1
		    else if (lextyp(sp) == LEXSWITCH) {
			call swend (labval(sp))
			sp = sp - 1
		    } else
		       call synerr ("Illegal right brace.")
		}

		token = lex (lexstr)	   		# peek at next token
		call pbstr (lexstr)
		call unstak (sp, lextyp, labval, token)
	    }
	}

	if (sp != 1)
	    call synerr ("unexpected EOF.")
end

      SUBROUTINE TPWRZI	(IERROR)
C
C LATEST REVISION	 JULY, 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 PWRZI IN CONJUNCTION WITH ISOSRF
C
C USAGE			 CALL TPWRZI (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   PWRZI TEST SUCCESSFUL  . . .	SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, ONE FRAME	CONTAINING THE SAMPLE
C			 PLOT IS PRODUCED ON THE MACHINE GRAPHICS
C			 DEVICE.  IN ORDER TO DETERMINE	IF THE TEST
C			 WAS SUCCESSFUL, IT IS NECESSARY TO EXAMINE
C			 THIS PLOT.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 PWRZI,	ISOSRF
C FILES
C
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 A FUNCTION OF THREE VARIABLES IS DEFINED, AND
C			 VALUES	OF THE FUNCTION	ON A THREE DIMENSIONAL
C			 RECTANGULAR GRID ARE STORED IN	AN ARRAY.  THIS
C			 SUBROUTINE THEN CALLS ISOSRF TO DRAW AN
C			 ISO-VALUED SURFACE PLOT OF THE	FUNCTION,
C			 THEN PWRZI IS CALLED THREE TIMES TO
C			 LABEL THE FRONT, SIDE,	AND BACK OF THE
C			 PICTURE.
C
C PORTABILITY		 ANSI FORTRAN 77
C
C
      DIMENSION	      T(21,31,19),SLAB(33,33),EYE(3)
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE INTEGER COORDINATES RANGE	FROM 0.0 TO 1.0, THE VALUES TX AND TY
C DEFINE THE CENTER OF THE TITLE STRING.
C
      DATA TX/0.4375/, TY/0.9667/
C
      DATA NU,NV,NW/21,31,19/
      DATA RBIG1,RBIG2,RSML1,RSML2/6.,6.,2.,2./
      DATA TISO/0./
      DATA MUVWP2/33/
      DATA IFLAG/-7/
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 1
C
C FILL THREE DIMENSIONAL ARRAY TO BE PLOTTED
C
      JCENT1 = FLOAT(NV)*.5-RBIG1*.5
      JCENT2 = FLOAT(NV)*.5+RBIG2*.5
      DO  30 I=1,NU
	 FIMID = I-NU/2
	 DO  20	J=1,NV
	    FJMID1 = J-JCENT1
	    FJMID2 = J-JCENT2
	    DO	10 K=1,NW
	       FKMID = K-NW/2
	       F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
	       F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
	       FIP1 = (1.-F1)*FIMID
	       FIP2 = (1.-F2)*FIMID
	       FJP1 = (1.-F1)*FJMID1
	       FJP2 = (1.-F2)*FJMID2
	       FKP1 = (1.-F1)*FKMID
	       FKP2 = (1.-F2)*FKMID
	       T(I,J,K)	= AMIN1(FIMID*FIMID+FJP1*FJP1+FKP1*FKP1-
     1			  RSML1*RSML1,
     2			    FKMID*FKMID+FIP2*FIP2+FJP2*FJP2-RSML2*RSML2)
   10	    CONTINUE
   20	 CONTINUE
   30 CONTINUE
C
C DEFINE EYE POSITION
C
      EYE(1) = 100.
      EYE(2) = 150.
      EYE(3) = 125.
C
C SELECT NORMALIZATION TRANS NUMBER 0
C
      CALL GSELNT (0)
C
C
C LABEL	THE PLOT
C
      CALL WTSTR (TX,TY,'DEMONSTRATION PLOT FOR	PWRZI',2,0,0)
C
C TEST ISOSRF WITH SUBARRAY OF T
C
      MU = NU/2
      MV = NV/2
      MW = NW/2
      MUVWP2 = MAX0(MU,MV,MW)+2
      CALL ISOSRF (T(MU,MV,MW),NU,MU,NV,MV,MW,EYE,MUVWP2,SLAB,TISO,
     1		   IFLAG)
      ISIZE = 35
      CALL PWRZI (5.,16.,.5,'FRONT',5,ISIZE,-1,3,0)
      CALL PWRZI (11.,7.5,.5,'SIDE',4,ISIZE,2,-1,0)
      CALL PWRZI (5.,1.,5.,' BACK BACK BACK BACK BACK',25,ISIZE,-1,3,0)
      CALL SETUSV ('XF',10)
      CALL SETUSV ('YF',10)
      CALL NEWFM
      IERROR = 0
C
c     WRITE (6,1001)
      RETURN
C
C
c1001 FORMAT ('	     PWRZI TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

*> \brief \b SSWAP
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*       SUBROUTINE SSWAP(N,SX,INCX,SY,INCY)
*
*       .. Scalar Arguments ..
*       INTEGER INCX,INCY,N
*       ..
*       .. Array Arguments ..
*       REAL SX(*),SY(*)
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    SSWAP interchanges two vectors.
*>    uses unrolled loops for increments equal to 1.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>         number of elements in input vector(s)
*> \endverbatim
*>
*> \param[in,out] SX
*> \verbatim
*>          SX is REAL array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>         storage spacing between elements of SX
*> \endverbatim
*>
*> \param[in,out] SY
*> \verbatim
*>          SY is REAL array, dimension ( 1 + ( N - 1 )*abs( INCY ) )
*> \endverbatim
*>
*> \param[in] INCY
*> \verbatim
*>          INCY is INTEGER
*>         storage spacing between elements of SY
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup single_blas_level1
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>     jack dongarra, linpack, 3/11/78.
*>     modified 12/3/93, array(1) declarations changed to array(*)
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE SSWAP(N,SX,INCX,SY,INCY)
*
*  -- Reference BLAS level1 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      REAL SX(*),SY(*)
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL STEMP
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*       code for both increments equal to 1
*
*
*       clean-up loop
*
         M = MOD(N,3)
         IF (M.NE.0) THEN
            DO I = 1,M
               STEMP = SX(I)
               SX(I) = SY(I)
               SY(I) = STEMP
            END DO
            IF (N.LT.3) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,3
            STEMP = SX(I)
            SX(I) = SY(I)
            SY(I) = STEMP
            STEMP = SX(I+1)
            SX(I+1) = SY(I+1)
            SY(I+1) = STEMP
            STEMP = SX(I+2)
            SX(I+2) = SY(I+2)
            SY(I+2) = STEMP
         END DO
      ELSE
*
*       code for unequal increments or equal increments not equal
*         to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            STEMP = SX(IX)
            SX(IX) = SY(IY)
            SY(IY) = STEMP
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      RETURN
      END

      integer function insub (arg, file)
      integer arg (100), file (100)
      if (.not.(arg (1) .eq. 60 .and. arg (2) .ne. -2))goto 23000
      insub = 1
      call scopy (arg, 2, file, 1)
      goto 23001
23000 continue
      insub = 0
23001 continue
      return
      end

c F77UPK -- Convert a Fortran 77 string into an SPP string.  Unpack
c each Fortran character into an SPP char and trim the blank padding
c at the right.
c
        subroutine f77upk (f77str, sppstr, maxch)
c
        character*(*)	f77str
        integer*2	sppstr(*)
        integer		maxch
        integer		lastch, nchars, i
        integer		EOS, BLANK
        parameter	(EOS=0, BLANK=32)
c
c -- Unpack string.
 	nchars = min (maxch, len(f77str))
	lastch = 0
        do 10 i = 1, nchars
            sppstr(i) = ichar (f77str(i:i))
	    if (sppstr(i) .gt. BLANK) lastch = i
 10     continue
c
c -- Add EOS delimiter to SPP string, trimming blank padding at right.
	if (lastch .gt. maxch) lastch = maxch
	sppstr(lastch+1) = EOS
c
        end

C--------------------------------------------------------------------------
        subroutine ftkshf(iunit,colmin,colmax,incre,status)

C       shift the index value on any existing column keywords
C       This routine will modify the name of any keyword that begins with 'T'
C       and has an index number in the range COLMIN - COLMAX, inclusive.

C       if incre is positive, then the index values will be incremented.
C       if incre is negative, then the kewords with index = COLMIN
C       will be deleted and the index of higher numbered keywords will
C       be decremented.

C       iunit   i  Fortran I/O unit number
C       colmin  i  starting column number to be incremented
C       colmax  i  maximum column number to be increment
C       incre   i  amount by which the index value should be shifted
C       status  i  returned error status (0=ok)

        integer iunit,colmin,colmax,incre,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,typhdu,tflds,nkeys,nmore,nrec,ival,tstat,i1
        character rec*80,newkey*8,q*4

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       test that the CHDU is an ASCII table or BINTABLE
        typhdu=hdutyp(ibuff)
        if (typhdu .ne. 1 .and. typhdu .ne. 2)then
                status=235
                call ftpmsg('Can only operate on TABLE or '//
     &          'BINTABLE extension (FTKSHF)')
                return
        end if

C       test column number limits
        tflds=tfield(ibuff)
        if (colmin .lt. 1 .or. colmax .lt. 1)then
             status=302
             return
        else if (colmin .gt. colmax .or. colmin .gt. tflds)then
             return
        end if

C       get the number of keywords in the header
        call ftghsp(iunit,nkeys,nmore,status)

C       go thru header starting with the 9th keyword looking for 'TxxxxNNN'

        nrec=9     
100     call ftgrec(iunit,nrec,rec,status)

        if (rec(1:1) .eq. 'T')then
            q=rec(2:5)
            i1=6

C           search list of 5-character 'official' indexed keywords
            if ( q .eq. 'BCOL' .or. q .eq. 'FORM' .or. q .eq. 'TYPE'
     &      .or. q .eq. 'UNIT' .or. q .eq. 'NULL' .or. q .eq. 'SCAL'
     &      .or. q .eq. 'ZERO' .or. q .eq. 'DISP')go to 20

C           search list of 5-character 'local' indexed keywords
            if ( q .eq. 'LMIN' .or. q .eq. 'LMAX' .or. q .eq. 'DMIN'
     &      .or. q .eq. 'DMAX' .or. q .eq. 'CTYP' .or. q .eq. 'CRPX' 
     &      .or. q .eq. 'CRVL' .or. q .eq. 'CDLT' .or. q .eq. 'CROT'
     &      .or. q .eq. 'CUNI')go to 20

            q=rec(1:4)
            i1=5
C           search list of 4-character 'official' indexed keywords
            if (q .eq. 'TDIM')go to 20
                 
C           no match so go on to next keyword
            go to 90

20          continue
C           try reading the index number suffix 
            tstat=0
            call ftc2ii(rec(i1:8),ival,tstat)
            if (tstat .eq. 0 .and. ival .ge. colmin .and.
     &          ival .le. colmax)then
                if (incre .le. 0 .and. ival .eq. colmin)then
C                   delete keyword related to this column
                    call ftdrec(iunit,nrec,status)
                    nkeys=nkeys-1
                    nrec=nrec-1
                else
                    ival=ival+incre
                    i1=i1-1
                    call ftkeyn(rec(1:i1),ival,newkey,status)
                    rec(1:8)=newkey
C                   modify the index number of this keyword
                    call ftmrec(iunit,nrec,rec,status)
                end if
            end if
        end if

90      nrec=nrec+1
        if (nrec .le. nkeys)go to 100
        end

      SUBROUTINE slF54Z (R2000,D2000,BEPOCH,
     :                      R1950,D1950,DR1950,DD1950)
*+
*     - - - - - -
*      F 5 4 Z
*     - - - - - -
*
*  Convert a J2000.0 FK5 star position to B1950.0 FK4 assuming
*  zero proper motion and parallax (double precision)
*
*  This routine converts star positions from the new, IAU 1976,
*  FK5, Fricke system to the old, Bessel-Newcomb, FK4 system.
*
*  Given:
*     R2000,D2000     dp    J2000.0 FK5 RA,Dec (rad)
*     BEPOCH          dp    Besselian epoch (e.g. 1950D0)
*
*  Returned:
*     R1950,D1950     dp    B1950.0 FK4 RA,Dec (rad) at epoch BEPOCH
*     DR1950,DD1950   dp    B1950.0 FK4 proper motions (rad/trop.yr)
*
*  Notes:
*
*  1)  The proper motion in RA is dRA/dt rather than cos(Dec)*dRA/dt.
*
*  2)  Conversion from Julian epoch 2000.0 to Besselian epoch 1950.0
*      only is provided for.  Conversions involving other epochs will
*      require use of the appropriate precession routines before and
*      after this routine is called.
*
*  3)  Unlike in the slFK54 routine, the FK5 proper motions, the
*      parallax and the radial velocity are presumed zero.
*
*  4)  It is the intention that FK5 should be a close approximation
*      to an inertial frame, so that distant objects have zero proper
*      motion;  such objects have (in general) non-zero proper motion
*      in FK4, and this routine returns those fictitious proper
*      motions.
*
*  5)  The position returned by this routine is in the B1950
*      reference frame but at Besselian epoch BEPOCH.  For
*      comparison with catalogues the BEPOCH argument will
*      frequently be 1950D0.
*
*  Called:  slFK54, slPM
*
*  P.T.Wallace   Starlink   10 April 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R2000,D2000,BEPOCH,
     :                 R1950,D1950,DR1950,DD1950

      DOUBLE PRECISION R,D,PX,RV



*  FK5 equinox J2000 (any epoch) to FK4 equinox B1950 epoch B1950
      CALL slFK54(R2000,D2000,0D0,0D0,0D0,0D0,
     :               R,D,DR1950,DD1950,PX,RV)

*  Fictitious proper motion to epoch BEPOCH
      CALL slPM(R,D,DR1950,DD1950,0D0,0D0,1950D0,BEPOCH,
     :            R1950,D1950)

      END

      SUBROUTINE TDASHL	(IERROR)
C
C LATEST REVISION	 APRIL 1984
C
C PURPOSE		 TO PROVIDE A DEMONSTRATION OF DASHLINE
C			 AND TO	TEST DASHLINE ON A SIMPLE PROBLEM
C
C USAGE			 CALL TDASHL (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST IS SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   DASHLINE TEST SUCCESSFUL  . . .  SEE	PLOT
C			   TO VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C
C			 IN ADDITION, ONE FRAME	CONTAINING THE
C			 DASHED	LINE PLOT IS PRODUCED ON THE
C			 MACHINE GRAPHICS DEVICE.  TO DETERMINE
C			 IF THE	TEST IS	SUCCESSFUL, IT IS NECESSARY
C			 TO EXAMINE THIS PLOT.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 DASHLINE
C FILES
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 TDASHL	UTILIZES THE SOFTWARE DASHLINE
C			 SUBROUTINES DASHDB, FRSTD, VECTD, LINED AND
C			 CURVED	TO DRAW	FIVE CURVES ON ONE PICTURE
C			 USING FIVE DIFFERENT DASHLINE PATTERNS.  EACH
C			 CURVE IS CENTERED ABOUT SOLID AXIS LINES AND
C			 LABELLED WITH THE BINARY REPRESENTATION OF THE
C			 DASHLINE PATTERN USED.
C
C PORTABILITY		 FORTRAN 77
C
C X CONTAINS ABSCISSAE VALUES OF THE CURVE TO BE PLOTTED, Y CONTAINS
C COORDINATE VALUES OF THE CURVE TO BE PLOTTED.
C
      DIMENSION	      X(31)	 ,Y(31)	     ,IPAT(5)
C
C SELECT NORMALIZATION TRANSFORMATION 0
C
      CALL GSELNT(0)
C
C SET SOLID DASH PATTERN,  1111111111111111 (BINARY).
C BOOLEAN OPERATIONS (EMPLOYING	LOCALLY	IMPLEMENTED
C SUPPORT ROUTINES) ARE	USED.
C
      ISOLID = IOR (ISHIFT (32767,1), 1)
C
C ARRAY	IPAT CONTAINS 5	DIFFERENT 16-BIT DASH PATTERNS.	 THE PATTERNS
C CONSTRUCTED WITH BOOLEAN OPERATIONS AS ABOVE.
C THE BINARY REPRESENTATIONS OF	THE PATTERNS ARE
C	 0001110001111111
C	 1111000011110000
C	 1111110011111100
C	 1111111100000000
C	 1111111111111100
C
      IPAT(1) =	IOR (ISHIFT ( 3647,1), 1)
      IPAT(2) =	ISHIFT (30840,1)
      IPAT(3) =	ISHIFT (32382,1)
      IPAT(4) =	ISHIFT (32640,1)
      IPAT(5) =	ISHIFT (32766,1)
C
      DO  70 K=1,5
	 CALL DASHDB (ISOLID)
	 ORG =1.07-0.195*K
C
C	DRAW CENTRAL AXIS FOR EACH CURVE
C
	 CALL FRSTD (.50,ORG-0.03)
	 CALL VECTD (.50,ORG+0.03)
	 CALL LINED (.109,ORG,.891,ORG)
	 CALL DASHDB (IPAT(K))
C
C	COMPUTE	VALUES FOR AND DRAW THE	KTH CURVE
C
	 DO  10	I=1,31
	    THETA = FLOAT(I-1)*3.1415926535897932/15.
	    X(I) = 0.5+.4*COS(THETA)
	    Y(I) = ORG+.075*SIN(FLOAT(K)*THETA)
   10	 CONTINUE
	 CALL CURVED (X,Y,31)
C
C	LABEL EACH CURVE WITH THE APPROPRIATE BINARY REPRESENTATION OF
C	THE DASHLINE PATTERN
C
C	SET TEXT ALIGNMENT TO CENTER THE STRING	AT THE LEFT OF THE
C	STRING AND IN THE VERTICAL CENTER
C
      CALL GSTXAL(1,3)
C
C	SET CHARACTER HEIGHT
C
      CALL GSCHH(.012)
C
	 ORY = ORG+.09
	 GO TO ( 20, 30, 40, 50, 60),K
   20	 CALL GTX (.1,ORY,'IPAT=0001110001111111')
	 GO TO	70
   30	 CALL GTX (.1,ORY,'IPAT=1111000011110000')
	 GO TO	70
   40	 CALL GTX (.1,ORY,'IPAT=1111110011111100')
	 GO TO	70
   50	 CALL GTX (.1,ORY,'IPAT=1111111100000000')
	 GO TO	70
   60	 CALL GTX (.1,ORY,'IPAT=1111111111111100')
C
   70 CONTINUE
C
      CALL GSTXAL(2,3)
      CALL GTX (.5,.991,'DEMONSTRATION PLOT FOR	DASHLINE')
C
C ADVANCE FRAME
C
      CALL NEWFM
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT ('	  DASHLINE TEST	SUCCESSFUL',24X,
     1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

C--------------------------------------------------------------------------
        subroutine ftbini(iunit,status)

C       initialize the parameters defining the structure of a binary table 

C       iunit   i  Fortran I/O unit number
C       OUTPUT PARAMETERS:
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer lenrow,nrows,pcnt,tfld,nkey,ibuff,i,j,nblank
        character keynam*8,value*70,comm*72,cnaxis*8,clen*8,rec*80

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       store the type of HDU (2 = Binary table extension)
        hdutyp(ibuff)=2

C       temporarily set the location of the end of the header to a huge number
        hdend(ibuff)=2000000000
        hdstrt(ibuff,chdu(ibuff)+1)=2000000000

C       check that this is a valid binary table, and get parameters
        call ftgtbn(iunit,rowlen(ibuff),nrows,pcnt,tfld,status)
        if (status .gt. 0)go to 900

        if (tfld .gt. nf)then
C               arrays not dimensioned large enough for this many fields
                status=111
        call ftpmsg('This Binary table has too many fields '//
     & 'to be read with FITSIO (FTBINI).')
                go to 900
         end if

C       store the number of fields in the common block
        tfield(ibuff)=tfld

        if (nxtfld + tfld .gt. nf)then
C               too many columns open at one time; exceeded array dimensions
                status=111
                return
        end if

        tstart(ibuff)=nxtfld
        nxtfld=nxtfld+tfld

C       initialize the table field parameters
        do 5 i=1,tfld
                tscale(i+tstart(ibuff))=1.
                tzero(i+tstart(ibuff))=0.
                tnull(i+tstart(ibuff))=123454321
                tdtype(i+tstart(ibuff))=-9999
                trept(i+tstart(ibuff))=0
C               reset character NUL string, in case it has been previously
C               defined from an ASCII table extension
                cnull(i+tstart(ibuff))=char(0)
5       continue

C       initialize the default heap starting address (immediately following
C       the table data) and set the next empty heap address 
C       PCOUNT specifies the amount of special data following the table
        scount(ibuff)=pcnt
        theap(ibuff)=rowlen(ibuff)*nrows
        nxheap(ibuff)=pcnt

C       now read through the rest of the header looking for table column
C       definition keywords, and the END keyword.

        nkey=8
8       nblank=0
10      nkey=nkey+1
        call ftgrec(iunit,nkey,rec,status)
        if (status .eq. 107)then
C               if we hit the end of file, then set status = no END card found
                status=210
        call ftpmsg('Required END keyword not found in Binary table'//
     &  ' header (FTBINI).')
                go to 900
        else if (status .gt. 0)then
                go to 900
        end if
        keynam=rec(1:8)
        comm=rec(9:80)

        if (keynam(1:1) .eq. 'T')then
C               get the binary table parameter (if it is one)
                call ftpsvc(rec,value,comm,status)
                call ftgbtp(ibuff,keynam,value,status)
        else if (keynam .eq. ' ' .and. comm .eq. ' ')then
                nblank=nblank+1
                go to 10
        else if (keynam .eq. 'END')then
                go to 20
        end if
        go to 8

20      continue

C       test that all the required keywords were found
        do 25 i=1,tfld
            if (tdtype(i+tstart(ibuff)) .eq. -9999)then
                status=232
                call ftkeyn('TFORM',i,keynam,status)
                call ftpmsg('Required '//keynam//
     &                      ' keyword not found (FTAINI).')
                return
            end if
25      continue


C       now we know everything about the table; just fill in the parameters:
C       the 'END' record begins 80 bytes before the current position, ignoring
C       any trailing blank keywords just before the END keyword
        hdend(ibuff)=nxthdr(ibuff)-80*(nblank+1)

C       the data unit begins at the beginning of the next logical block
        dtstrt(ibuff)=((nxthdr(ibuff)-80)/2880+1)*2880

C       reset header pointer to the first keyword
        nxthdr(ibuff)=hdstrt(ibuff,chdu(ibuff))

C       the next HDU begins in the next logical block after the data
        hdstrt(ibuff,chdu(ibuff)+1)=
     &  dtstrt(ibuff)+(rowlen(ibuff)*nrows+pcnt+2879)/2880*2880

C       determine the byte offset of the beginning of each field and row length
        if (tfld .gt. 0)then
           call ftgtbc(tfld,tdtype(1+tstart(ibuff)),
     &     trept(1+tstart(ibuff)),tbcol(1+tstart(ibuff)),lenrow,status)

C          FITSIO deals with ASCII columns as arrays of strings, not
C          arrays of characters, so need to change the repeat count
C          to indicate the number of strings in the field, not the 
C          total number of characters in the field.
           do 30 i=1,tfld
                if (tdtype(i+tstart(ibuff)) .eq. 16)then
                    j=trept(i+tstart(ibuff))/tnull(i+tstart(ibuff))
                    trept(i+tstart(ibuff))=max(j,1)
                end if
30         continue
           if (status .gt. 0)go to 900

C          check that the sum of the column widths = NAXIS2 value
           if (rowlen(ibuff) .ne. lenrow)then
                status=241
                write(cnaxis,1001)rowlen(ibuff)
                write(clen,1001)lenrow
1001            format(i8)
           call ftpmsg('NAXIS1 ='//cnaxis//' not equal'//
     &     ' to the sum of the column widths ='//clen//' (FTBINI).')
           end if
        end if

900     continue
        end

      subroutine squash (id)
      integer id(100)
      integer junk, i, j
      integer lookup, ludef
      integer newid(100), recdid(100)
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      if (.not.(body .eq. 1 .and. errtbl .ne. 0 .and. ername .eq. 0))got
     *o 23000
      if (.not.(lookup (id, junk, errtbl) .eq. 1))goto 23002
      ername = 1
23002 continue
23000 continue
      j = 1
      i=1
23004 if (.not.(id(i) .ne. -2))goto 23006
      if (.not.(((65.le.id(i).and.id(i).le.90).or.(97.le.id(i).and.id(i)
     *.le.122)) .or. (48.le.id(i).and.id(i).le.57)))goto 23007
      newid(j) = id(i)
      j = j + 1
23007 continue
23005 i=i+1
      goto 23004
23006 continue
      newid(j) = -2
      if (.not.(i-1 .lt. 6 .and. i .eq. j))goto 23009
      return
23009 continue
      if (.not.(lookup (id, junk, fkwtbl) .eq. 1))goto 23011
      return
23011 continue
      if (.not.(ludef (id, recdid, namtbl) .eq. 1))goto 23013
      call scopy (recdid, 1, id, 1)
      return
23013 continue
      call mapid (newid)
      if (.not.(lookup (newid, junk, gentbl) .eq. 1))goto 23015
      call synerr (39HWarning: identifier mapping not unique.)
      call uniqid (newid)
23015 continue
      call entdef (newid, id, gentbl)
      call entdef (id, newid, namtbl)
      call scopy (newid, 1, id, 1)
      end
c     logic0  logical_column

      SUBROUTINE slDPSC (XI, ETA, RA, DEC, RAZ1, DECZ1,
     :                                         RAZ2, DECZ2, N)
*+
*     - - - - - - -
*      D P S C
*     - - - - - - -
*
*  From the tangent plane coordinates of a star of known RA,Dec,
*  determine the RA,Dec of the tangent point.
*
*  (double precision)
*
*  Given:
*     XI,ETA      d    tangent plane rectangular coordinates
*     RA,DEC      d    spherical coordinates
*
*  Returned:
*     RAZ1,DECZ1  d    spherical coordinates of tangent point, solution 1
*     RAZ2,DECZ2  d    spherical coordinates of tangent point, solution 2
*     N           i    number of solutions:
*                        0 = no solutions returned (note 2)
*                        1 = only the first solution is useful (note 3)
*                        2 = both solutions are useful (note 3)
*
*  Notes:
*
*  1  The RAZ1 and RAZ2 values are returned in the range 0-2pi.
*
*  2  Cases where there is no solution can only arise near the poles.
*     For example, it is clearly impossible for a star at the pole
*     itself to have a non-zero XI value, and hence it is
*     meaningless to ask where the tangent point would have to be
*     to bring about this combination of XI and DEC.
*
*  3  Also near the poles, cases can arise where there are two useful
*     solutions.  The argument N indicates whether the second of the
*     two solutions returned is useful.  N=1 indicates only one useful
*     solution, the usual case;  under these circumstances, the second
*     solution corresponds to the "over-the-pole" case, and this is
*     reflected in the values of RAZ2 and DECZ2 which are returned.
*
*  4  The DECZ1 and DECZ2 values are returned in the range +/-pi, but
*     in the usual, non-pole-crossing, case, the range is +/-pi/2.
*
*  5  This routine is the spherical equivalent of the routine slDPVC.
*
*  Called:  slDA2P
*
*  P.T.Wallace   Starlink   5 June 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION XI,ETA,RA,DEC,RAZ1,DECZ1,RAZ2,DECZ2
      INTEGER N

      DOUBLE PRECISION X2,Y2,SD,CD,SDF,R2,R,S,C

      DOUBLE PRECISION slDA2P


      X2=XI*XI
      Y2=ETA*ETA
      SD=SIN(DEC)
      CD=COS(DEC)
      SDF=SD*SQRT(1D0+X2+Y2)
      R2=CD*CD*(1D0+Y2)-SD*SD*X2
      IF (R2.GE.0D0) THEN
         R=SQRT(R2)
         S=SDF-ETA*R
         C=SDF*ETA+R
         IF (XI.EQ.0D0.AND.R.EQ.0D0) R=1D0
         RAZ1=slDA2P(RA-ATAN2(XI,R))
         DECZ1=ATAN2(S,C)
         R=-R
         S=SDF-ETA*R
         C=SDF*ETA+R
         RAZ2=slDA2P(RA-ATAN2(XI,R))
         DECZ2=ATAN2(S,C)
         IF (ABS(SDF).LT.1D0) THEN
            N=1
         ELSE
            N=2
         END IF
      ELSE
         N=0
      END IF

      END

C----------------------------------------------------------------------
        subroutine fti4i4(input,n,scale,zero,tofits,
     &          chktyp,chkval,setval,flgray,anynul,output,status)

C       copy input i*4 values to output i*4 values, doing optional
C       scaling and checking for null values

C       input   i  input array of values
C       n       i  number of values 
C       scale   d  scaling factor to be applied
C       zero    d  scaling zero point to be applied
C       tofits  l  true if converting from internal format to FITS
C       chktyp  i  type of null value checking to be done if TOFITS=.false.
C                       =0  no checking for null values
C                       =1  set null values = SETVAL
C                       =2  set corresponding FLGRAY value = .true.
C       chkval  i   value in the input array that is used to indicated nulls
C       setval  i   value to set output array to if value is undefined
C       flgray  l   array of logicals indicating if corresponding value is null
C       anynul  l   set to true if any nulls were set in the output array
C       output  i   returned array of values
C       status  i  output error status (0 = ok)

        integer input(*),chkval
        integer output(*),setval
        integer n,i,chktyp,status
        double precision scale,zero,dval,i4max,i4min
        logical tofits,flgray(*),anynul,noscal
        parameter (i4max=2.14748364749D+09)
        parameter (i4min=-2.14748364849D+09)
        integer maxi4,mini4
        parameter (maxi4=2147483647)
C       work around for bug in the DEC Alpha VMS compiler
        mini4=-2147483647 - 1

        if (status .gt. 0)return

        if (scale .eq. 1. .and. zero .eq. 0)then
                noscal=.true.
        else
                noscal=.false.
        end if
        
        if (tofits) then
C               we don't have to worry about null values when writing to FITS
                if (noscal)then
                        do 10 i=1,n
                                output(i)=input(i)
10                      continue
                else
                        do 20 i=1,n
                            dval=(input(i)-zero)/scale
C                           trap any values that overflow the I*2 range
                            if (dval.lt.i4max .and. dval.gt.i4min)then      
                                output(i)=nint(dval)
                            else if (dval .ge. i4max)then
                                status=-11
                                output(i)=maxi4
                            else
                                status=-11
                                output(i)=mini4
                            end if
20                      continue
                end if
        else
C               converting from FITS to internal format; may have to check nulls
                if (chktyp .eq. 0)then
C                       don't have to check for nulls
                        if (noscal)then
                                do 30 i=1,n
                                        output(i)=input(i)
30                              continue
                        else
                            do 40 i=1,n
                              dval=input(i)*scale+zero
C                             trap any values that overflow the I*4 range
                              if (dval.lt.i4max .and. dval.gt.i4min)then
                                  output(i)=dval
                              else if (dval .ge. i4max)then
                                  status=-11
                                  output(i)=maxi4
                              else
                                  status=-11
                                  output(i)=mini4
                              end if
40                          continue
                        end if
                else 
C                   must test for null values
                    if (noscal)then
                                do 50 i=1,n
                                        if (input(i) .eq. chkval)then
                                            anynul=.true.
                                            if (chktyp .eq. 1)then
                                                output(i)=setval
                                            else
                                                flgray(i)=.true.
                                            end if
                                        else
                                                output(i)=input(i)
                                        end if
50                              continue
                    else
                        do 60 i=1,n
                            if (input(i) .eq. chkval)then
                                anynul=.true.
                                if (chktyp .eq. 1)then
                                    output(i)=setval
                                else
                                    flgray(i)=.true.
                                end if
                            else
                              dval=input(i)*scale+zero
C                             trap any values that overflow the I*4 range
                              if (dval.lt.i4max .and. dval.gt.i4min)then
                                  output(i)=dval
                              else if (dval .ge. i4max)then
                                  status=-11
                                  output(i)=maxi4
                              else
                                  status=-11
                                  output(i)=mini4
                              end if
                            end if
60                      continue
                    end if
                end if
        end if
        end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C     BLOCKDATA CONBD
      subroutine conbd
      integer first, temp
      common /conflg/ first
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE2/ IX         ,IY         ,IDX  ,IDY ,
     1                IS         ,ISS        ,NP         ,CV ,
     2                INX(8)     ,INY(8)     ,IR(80000)    ,NR
c +noao: dimension of stline ir array increased from 20000 to 80000 6-93
      COMMON /CONRE4/ ISIZEL     ,ISIZEM     ,ISIZEP     ,NREP,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA,
     3                NLM        ,XLT        ,YBT        ,SIDE
      COMMON /RECINT/ IRECMJ     ,IRECMN          ,IRECTX
C
      SAVE
C
C     DATA IOFFP,SPVAL/0,0.0/
      data temp /1/
      first = temp
      IOFFP  = 0
      SPVAL  = 0.0
C     DATA ISIZEL,ISIZEM,ISIZEP,NLA,NLM,XLT,YBT,SIDE,ISOLID,NREP,NCRT/
C    1       1,  2,   0, 16, 40,.05,.05,  .9,  1023,   6,   4 /
      if (first .ne. 1) then
        return
      endif

      temp = 0

c     ISIZEL = 1
c noao: size of contour labels seemed too large.  Changed from 1 to 0
      isizel = 0
      ISIZEM = 2
      ISIZEP = 0
      NLA    = 16
      NLM    = 40
      XLT    = .05
      YBT    = .05
      SIDE   = .9
      ISOLID = 1023
      NREP   = 4
      NCRT   = 2 
C     DATA EXT,IOFFD,NULBLL,IOFFM,ILAB/.25,0,3,0,1/
C +noao value of "extreme" axes ratios changed from 1/4 to 1/16 (ShJ 6-10-88)
C     EXT    = .25
      EXT    = .0625
C -noao
      IOFFD  = 0
      NULBLL = 3
      IOFFM  = 0
      ILAB   = 1
C     DATA INX(1),INX(2),INX(3),INX(4),INX(5),INX(6),INX(7),INX(8)/
C    1        -1 ,   -1 ,    0 ,    1 ,    1 ,          1 ,      0 ,   -1 /
      INX(1) = -1 
      INX(2) = -1
      INX(3) = 0 
      INX(4) = 1 
      INX(5) = 1 
      INX(6) = 1
      INX(7) = 0
      INX(8) = -1
C     DATA INY(1),INY(2),INY(3),INY(4),INY(5),INY(6),INY(7),INY(8)/
C    1         0 ,    1 ,    1 ,    1 ,    0 ,   -1 ,   -1 ,   -1 /
      INY(1) = 0 
      INY(2) = 1
      INY(3) = 1
      INY(4) = 1 
      INY(5) = 0
      INY(6) = -1
      INY(7) = -1
      INY(8) = -1
C     DATA NR/500/
c +noao: dimension of stline array increased from 500 to 5000 6March87
c +noao: dimension of stline array increased from 5000 to 20000 Jan90
c +noao: dimension of stline array increased from 20000 to 80000 6-93
      NR     = 80000
C     DATA IRECMJ,IRECMN,IRECTX/ 1 ,   1 ,   1/
c +noao: value of irecmj changed so major divisions are high intensity
      IRECMJ = 2 
      IRECMN = 1
      IRECTX = 1
C
C - noao
C
C REVISION HISTORY---
C
C JANUARY 1980     ADDED REVISION HISTORY AND CHANGED LIBRARY NAME
C                  FROM CRAYLIB TO PORTLIB FOR MOVE TO PORTLIB
C
C MAY 1980         ARRAYS IWORK AND ENCSCR, PREVIOUSLY TOO SHORT FOR
C                  SHORT-WORD-LENGTH MACHINES, LENGTHENED.  SOME
C                  DOCUMENTATION CLARIFIED AND CORRECTED.
C
C JUNE 1984        CONVERTED TO FORTRAN 77 AND TO GKS
C-------------------------------------------------------------------
C
      END

      SUBROUTINE slPREC (EP0, EP1, RMATP)
*+
*     - - - - -
*      P R E C
*     - - - - -
*
*  Form the matrix of precession between two epochs (IAU 1976, FK5)
*  (double precision)
*
*  Given:
*     EP0    dp         beginning epoch
*     EP1    dp         ending epoch
*
*  Returned:
*     RMATP  dp(3,3)    precession matrix
*
*  Notes:
*
*     1)  The epochs are TDB (loosely ET) Julian epochs.
*
*     2)  The matrix is in the sense   V(EP1)  =  RMATP * V(EP0)
*
*     3)  Though the matrix method itself is rigorous, the precession
*         angles are expressed through canonical polynomials which are
*         valid only for a limited time span.  There are also known
*         errors in the IAU precession rate.  The absolute accuracy
*         of the present formulation is better than 0.1 arcsec from
*         1960AD to 2040AD, better than 1 arcsec from 1640AD to 2360AD,
*         and remains below 3 arcsec for the whole of the period
*         500BC to 3000AD.  The errors exceed 10 arcsec outside the
*         range 1200BC to 3900AD, exceed 100 arcsec outside 4200BC to
*         5600AD and exceed 1000 arcsec outside 6800BC to 8200AD.
*         The SLALIB routine slPREL implements a more elaborate
*         model which is suitable for problems spanning several
*         thousand years.
*
*  References:
*     Lieske,J.H., 1979. Astron.Astrophys.,73,282.
*      equations (6) & (7), p283.
*     Kaplan,G.H., 1981. USNO circular no. 163, pA2.
*
*  Called:  slDEUL
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION EP0,EP1,RMATP(3,3)

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)

      DOUBLE PRECISION T0,T,TAS2R,W,ZETA,Z,THETA



*  Interval between basic epoch J2000.0 and beginning epoch (JC)
      T0 = (EP0-2000D0)/100D0

*  Interval over which precession required (JC)
      T = (EP1-EP0)/100D0

*  Euler angles
      TAS2R = T*AS2R
      W = 2306.2181D0+(1.39656D0-0.000139D0*T0)*T0

      ZETA = (W+((0.30188D0-0.000344D0*T0)+0.017998D0*T)*T)*TAS2R
      Z = (W+((1.09468D0+0.000066D0*T0)+0.018203D0*T)*T)*TAS2R
      THETA = ((2004.3109D0+(-0.85330D0-0.000217D0*T0)*T0)
     :        +((-0.42665D0-0.000217D0*T0)-0.041833D0*T)*T)*TAS2R

*  Rotation matrix
      CALL slDEUL('ZYZ',-ZETA,THETA,-Z,RMATP)

      END

      SUBROUTINE PWRZS (X,Y,Z,ID,N,ISIZE,LIN3,ITOP,ICNT)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C LATEST REVISION        JULY, 1984
C
C PURPOSE                PWRZS IS A CHARACTER PLOTTING ROUTINE FOR
C                        PLOTTING CHARACTERS IN THREE-SPACE WHEN USING
C                        SRFACE.  FOR A LARGE CLASS OF
C                        POSSIBLE POSITIONS, THE HIDDEN CHARACTER
C                        PROBLEM IS SOLVED.
C
C
C
C USAGE                  CALL PWRZS (X,Y,Z,ID,N,ISIZE,LINE,ITOP,ICNT)
C                          USE CALL PWRZS AFTER CALLING
C                          SRFACE AND BEFORE CALLING FRAME
C                            NOTE:  SRFACE WILL HAVE TO BE CHANGED
C                                   TO SUPPRESS THE FRAME CALL.  SEE IFR
C                                   IN SRFACE INTERNAL PARAMETERS.
C
C ARGUMENTS
C
C ON INPUT               X,Y,Z
C                          POSITIONING COORDINATES FOR THE CHARACTERS
C                          TO BE DRAWN.  THESE ARE FLOATING POINT
C                          NUMBERS IN THE SAME THREE-SPACE AS USED IN
C                          SRFACE.
C
C                        ID
C                          CHARACTER STRING TO BE DRAWN
C
C                        N
C                          THE NUMBER OF CHARACTERS IN ID
C
C                        ISIZE
C                          SIZE OF THE CHARACTER
C                          .  IF BETWEEN 0 AND 3 THE FACTOR IS 1., 1.5,
C                             2., OR 3. TIMES A STANDARD WIDTH EQUAL
C                             TO 1/128TH OF THE SCREEN WIDTH.
C                          .  IF GREATER THAN 3 IT IS THE CHARACTER
C                             WIDTH IN PLOTTER ADDRESS UNITS.
C
C                        LINE
C                          THE DIRECTION IN WHICH THE CHARACTERS ARE TO
C                          BE WRITTEN.
C                            1 = +X     -1 = -X
C                            2 = +Y     -2 = -Y
C                            3 = +Z     -3 = -Z
C
C                        ITOP
C                          THE DIRECTION FROM THE CENTER OF THE FIRST
C                          CHARACTER TO THE TOP OF THE FIRST
C                          CHARACTER.  NOTE THAT LINE CANNOT
C                          EQUAL ITOP EVEN IN ABSOLUTE VALUE.
C
C                        ICNT
C                          CENTERING OPTION.
C                          -1 (X,Y,Z)  IS THE CENTER OF THE LEFT EDGE OF
C                                      THE FIRST CHARACTER.
C                          0  (X,Y,Z)  IS THE CENTER OF THE ENTIRE
C                                      STRING.
C                          1  (X,Y,Z)  IS THE CENTER OF THE RIGHT EDGE
C                                      OF THE LAST CHARACTER.
C
C ON OUTPUT              ALL ARGUMENTS ARE UNCHANGED.
C
C NOTE                   THE HIDDEN CHARACTER PROBLEM IS SOLVED
C                        CORRECTLY FOR CHARACTERS NEAR (BUT NOT INSIDE)
C                        THE THREE-SPACE OBJECT.
C
C ENTRY POINTS           PWRZS, INITZS, PWRZOS, PWRZGS
C
C COMMON BLOCKS          PWRZ1S,PWRZ2S
C
C I/O                    PLOTS CHARACTER(S)
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       SRFACE
C ROUTINES
C
C LANGUAGE               FORTRAN
C
C HISTORY                IMPLEMENTED FOR USE WITH SRFACE.
C
C
C
C
C***********************************************************************
C
      SAVE
      CHARACTER*(*)   ID
      CHARACTER*1     JCHAR(46)  ,KCHAR
      DIMENSION       INDEX(46)  ,KX(494)    ,KY(494)
      DIMENSION       VWPRT(4)   ,WNDW(4)
      LOGICAL         LENTRY
c +NOAO:  common block added for user control of viewport
      common /noaovp/ vpx1, vpx2, vpy1, vpy2
c -NOAO
C
C
C THE FOLLOWING DATA STATEMENTS ASSOCIATE EACH CHARACTER WITH ITS
C DIGITIZATION.  THAT IS, THE DIGITIZATION FOR THE CHARACTER A STARTS
C AT KX(1) AND KY(1), WHILE B STARTS AT KX(13) AND KY(13), AND SO ON.
C
      DATA JCHAR( 1),INDEX( 1)/'A',  1/
      DATA JCHAR( 2),INDEX( 2)/'B', 13/
      DATA JCHAR( 3),INDEX( 3)/'C', 28/
      DATA JCHAR( 4),INDEX( 4)/'D', 40/
      DATA JCHAR( 5),INDEX( 5)/'E', 49/
      DATA JCHAR( 6),INDEX( 6)/'F', 60/
      DATA JCHAR( 7),INDEX( 7)/'G', 68/
      DATA JCHAR( 8),INDEX( 8)/'H', 82/
      DATA JCHAR( 9),INDEX( 9)/'I', 92/
      DATA JCHAR(10),INDEX(10)/'J',104/
      DATA JCHAR(11),INDEX(11)/'K',113/
      DATA JCHAR(12),INDEX(12)/'L',123/
      DATA JCHAR(13),INDEX(13)/'M',130/
      DATA JCHAR(14),INDEX(14)/'N',137/
      DATA JCHAR(15),INDEX(15)/'O',143/
      DATA JCHAR(16),INDEX(16)/'P',157/
      DATA JCHAR(17),INDEX(17)/'Q',166/
      DATA JCHAR(18),INDEX(18)/'R',182/
      DATA JCHAR(19),INDEX(19)/'S',194/
      DATA JCHAR(20),INDEX(20)/'T',210/
      DATA JCHAR(21),INDEX(21)/'U',219/
      DATA JCHAR(22),INDEX(22)/'V',229/
      DATA JCHAR(23),INDEX(23)/'W',236/
      DATA JCHAR(24),INDEX(24)/'X',245/
      DATA JCHAR(25),INDEX(25)/'Y',252/
      DATA JCHAR(26),INDEX(26)/'Z',262/
      DATA JCHAR(27),INDEX(27)/'0',273/
      DATA JCHAR(28),INDEX(28)/'1',286/
      DATA JCHAR(29),INDEX(29)/'2',296/
      DATA JCHAR(30),INDEX(30)/'3',308/
      DATA JCHAR(31),INDEX(31)/'4',326/
      DATA JCHAR(32),INDEX(32)/'5',339/
      DATA JCHAR(33),INDEX(33)/'6',352/
      DATA JCHAR(34),INDEX(34)/'7',368/
      DATA JCHAR(35),INDEX(35)/'8',378/
      DATA JCHAR(36),INDEX(36)/'9',398/
      DATA JCHAR(37),INDEX(37)/'+',414/
      DATA JCHAR(38),INDEX(38)/'-',423/
      DATA JCHAR(39),INDEX(39)/'*',429/
      DATA JCHAR(40),INDEX(40)/'/',444/
      DATA JCHAR(41),INDEX(41)/'(',448/
      DATA JCHAR(42),INDEX(42)/')',456/
      DATA JCHAR(43),INDEX(43)/'=',464/
      DATA JCHAR(44),INDEX(44)/' ',473/
      DATA JCHAR(45),INDEX(45)/',',476/
      DATA JCHAR(46),INDEX(46)/'.',486/
C
C THE FOLLOWING DATA STATEMENTS CONTAIN THE DIGITIZATIONS OF THE
C CHARACTERS.  THE CHARACTERS ARE DIGITIZED ON A BOX 6 UNITS WIDE AND
C 7 UNITS TALL.  THIS INCLUDES 2 UNITS OF WHITE SPACE TO THE RIGHT OF
C EACH CHARACTER.  IF KX=7, KY IS A FLAG -- KY=0 MEANS THE FOLLOWING
C KX AND KY ARE A PEN UP MOVE (ALL OTHERS ARE PEN DOWN MOVES), AND
C KY=7 MEANS THAT THE END OF THE DIGITIZATION FOR A PARTICULAR CHARAC-
C TER HAS BEEN REACHED.
C
c None of the following are used anywere.
c     DATA WIDE,HIGH,WHITE/6.,7.,2./
C
      DATA KX(  1),KX(  2),KX(  3),KX(  4),KX(  5),KX(  6)/0,4,7,0,0,1/
      DATA KY(  1),KY(  2),KY(  3),KY(  4),KY(  5),KY(  6)/3,3,0,3,6,7/
      DATA KX(  7),KX(  8),KX(  9),KX( 10),KX( 11),KX( 12)/3,4,4,7,6,7/
      DATA KY(  7),KY(  8),KY(  9),KY( 10),KY( 11),KY( 12)/7,6,0,0,0,7/
      DATA KX( 13),KX( 14),KX( 15),KX( 16),KX( 17),KX( 18)/0,3,4,4,3,0/
      DATA KY( 13),KY( 14),KY( 15),KY( 16),KY( 17),KY( 18)/7,7,6,5,4,4/
      DATA KX( 19),KX( 20),KX( 21),KX( 22),KX( 23),KX( 24)/7,3,4,4,3,0/
      DATA KY( 19),KY( 20),KY( 21),KY( 22),KY( 23),KY( 24)/0,4,3,1,0,0/
      DATA KX( 25),KX( 26),KX( 27),KX( 28),KX( 29),KX( 30)/7,6,7,7,4,3/
      DATA KY( 25),KY( 26),KY( 27),KY( 28),KY( 29),KY( 30)/0,0,7,0,6,7/
      DATA KX( 31),KX( 32),KX( 33),KX( 34),KX( 35),KX( 36)/1,0,0,1,3,4/
      DATA KY( 31),KY( 32),KY( 33),KY( 34),KY( 35),KY( 36)/7,6,1,0,0,1/
      DATA KX( 37),KX( 38),KX( 39),KX( 40),KX( 41),KX( 42)/7,6,7,0,3,4/
      DATA KY( 37),KY( 38),KY( 39),KY( 40),KY( 41),KY( 42)/0,0,7,7,7,6/
      DATA KX( 43),KX( 44),KX( 45),KX( 46),KX( 47),KX( 48)/4,3,0,7,6,7/
      DATA KY( 43),KY( 44),KY( 45),KY( 46),KY( 47),KY( 48)/1,0,0,0,0,7/
      DATA KX( 49),KX( 50),KX( 51),KX( 52),KX( 53),KX( 54)/0,4,7,3,0,7/
      DATA KY( 49),KY( 50),KY( 51),KY( 52),KY( 53),KY( 54)/7,7,0,4,4,0/
      DATA KX( 55),KX( 56),KX( 57),KX( 58),KX( 59),KX( 60)/0,4,7,6,7,0/
      DATA KY( 55),KY( 56),KY( 57),KY( 58),KY( 59),KY( 60)/0,0,0,0,7,7/
      DATA KX( 61),KX( 62),KX( 63),KX( 64),KX( 65),KX( 66)/4,7,0,3,7,6/
      DATA KY( 61),KY( 62),KY( 63),KY( 64),KY( 65),KY( 66)/7,0,4,4,0,0/
      DATA KX( 67),KX( 68),KX( 69),KX( 70),KX( 71),KX( 72)/7,7,4,3,1,0/
      DATA KY( 67),KY( 68),KY( 69),KY( 70),KY( 71),KY( 72)/7,0,6,7,7,6/
      DATA KX( 73),KX( 74),KX( 75),KX( 76),KX( 77),KX( 78)/0,1,3,4,4,3/
      DATA KY( 73),KY( 74),KY( 75),KY( 76),KY( 77),KY( 78)/1,0,0,1,3,3/
      DATA KX( 79),KX( 80),KX( 81),KX( 82),KX( 83),KX( 84)/7,6,7,0,7,0/
      DATA KY( 79),KY( 80),KY( 81),KY( 82),KY( 83),KY( 84)/0,0,7,7,0,4/
      DATA KX( 85),KX( 86),KX( 87),KX( 88),KX( 89),KX( 90)/4,7,4,4,7,6/
      DATA KY( 85),KY( 86),KY( 87),KY( 88),KY( 89),KY( 90)/4,0,7,0,0,0/
      DATA KX( 91),KX( 92),KX( 93),KX( 94),KX( 95),KX( 96)/7,7,1,3,7,2/
      DATA KY( 91),KY( 92),KY( 93),KY( 94),KY( 95),KY( 96)/7,0,7,7,0,7/
      DATA KX( 97),KX( 98),KX( 99),KX(100),KX(101),KX(102)/2,7,1,3,7,6/
      DATA KY( 97),KY( 98),KY( 99),KY(100),KY(101),KY(102)/0,0,0,0,0,0/
      DATA KX(103),KX(104),KX(105),KX(106),KX(107),KX(108)/7,7,0,1,3,4/
      DATA KY(103),KY(104),KY(105),KY(106),KY(107),KY(108)/7,0,1,0,0,1/
      DATA KX(109),KX(110),KX(111),KX(112),KX(113),KX(114)/4,7,6,7,0,7/
      DATA KY(109),KY(110),KY(111),KY(112),KY(113),KY(114)/7,0,0,7,7,0/
      DATA KX(115),KX(116),KX(117),KX(118),KX(119),KX(120)/0,4,7,2,4,7/
      DATA KY(115),KY(116),KY(117),KY(118),KY(119),KY(120)/3,7,0,5,0,0/
      DATA KX(121),KX(122),KX(123),KX(124),KX(125),KX(126)/6,7,7,0,0,4/
      DATA KY(121),KY(122),KY(123),KY(124),KY(125),KY(126)/0,7,0,7,0,0/
      DATA KX(127),KX(128),KX(129),KX(130),KX(131),KX(132)/7,6,7,0,2,4/
      DATA KY(127),KY(128),KY(129),KY(130),KY(131),KY(132)/0,0,7,7,3,7/
      DATA KX(133),KX(134),KX(135),KX(136),KX(137),KX(138)/4,7,6,7,0,4/
      DATA KY(133),KY(134),KY(135),KY(136),KY(137),KY(138)/0,0,0,7,7,0/
      DATA KX(139),KX(140),KX(141),KX(142),KX(143),KX(144)/4,7,6,7,4,7/
      DATA KY(139),KY(140),KY(141),KY(142),KY(143),KY(144)/7,0,0,7,7,0/
      DATA KX(145),KX(146),KX(147),KX(148),KX(149),KX(150)/4,4,3,1,0,0/
      DATA KY(145),KY(146),KY(147),KY(148),KY(149),KY(150)/1,6,7,7,6,1/
      DATA KX(151),KX(152),KX(153),KX(154),KX(155),KX(156)/1,3,4,7,6,7/
      DATA KY(151),KY(152),KY(153),KY(154),KY(155),KY(156)/0,0,1,0,0,7/
      DATA KX(157),KX(158),KX(159),KX(160),KX(161),KX(162)/0,3,4,4,3,0/
      DATA KY(157),KY(158),KY(159),KY(160),KY(161),KY(162)/7,7,6,5,4,4/
      DATA KX(163),KX(164),KX(165),KX(166),KX(167),KX(168)/7,6,7,7,0,0/
      DATA KY(163),KY(164),KY(165),KY(166),KY(167),KY(168)/0,0,7,0,1,6/
      DATA KX(169),KX(170),KX(171),KX(172),KX(173),KX(174)/1,3,4,4,3,1/
      DATA KY(169),KY(170),KY(171),KY(172),KY(173),KY(174)/7,7,6,1,0,0/
      DATA KX(175),KX(176),KX(177),KX(178),KX(179),KX(180)/0,7,2,4,7,6/
      DATA KY(175),KY(176),KY(177),KY(178),KY(179),KY(180)/1,0,2,0,0,0/
      DATA KX(181),KX(182),KX(183),KX(184),KX(185),KX(186)/7,0,3,4,4,3/
      DATA KY(181),KY(182),KY(183),KY(184),KY(185),KY(186)/7,7,7,6,5,4/
      DATA KX(187),KX(188),KX(189),KX(190),KX(191),KX(192)/0,7,2,4,7,6/
      DATA KY(187),KY(188),KY(189),KY(190),KY(191),KY(192)/4,0,4,0,0,0/
      DATA KX(193),KX(194),KX(195),KX(196),KX(197),KX(198)/7,7,0,1,3,4/
      DATA KY(193),KY(194),KY(195),KY(196),KY(197),KY(198)/7,0,1,0,0,1/
      DATA KX(199),KX(200),KX(201),KX(202),KX(203),KX(204)/4,3,1,0,0,1/
      DATA KY(199),KY(200),KY(201),KY(202),KY(203),KY(204)/3,4,4,5,6,7/
      DATA KX(205),KX(206),KX(207),KX(208),KX(209),KX(210)/3,4,7,6,7,7/
      DATA KY(205),KY(206),KY(207),KY(208),KY(209),KY(210)/7,6,0,0,7,0/
      DATA KX(211),KX(212),KX(213),KX(214),KX(215),KX(216)/0,4,7,2,2,7/
      DATA KY(211),KY(212),KY(213),KY(214),KY(215),KY(216)/7,7,0,7,0,0/
      DATA KX(217),KX(218),KX(219),KX(220),KX(221),KX(222)/6,7,7,0,0,1/
      DATA KY(217),KY(218),KY(219),KY(220),KY(221),KY(222)/0,7,0,7,1,0/
      DATA KX(223),KX(224),KX(225),KX(226),KX(227),KX(228)/3,4,4,7,6,7/
      DATA KY(223),KY(224),KY(225),KY(226),KY(227),KY(228)/0,1,7,0,0,7/
      DATA KX(229),KX(230),KX(231),KX(232),KX(233),KX(234)/7,0,2,4,7,6/
      DATA KY(229),KY(230),KY(231),KY(232),KY(233),KY(234)/0,7,0,7,0,0/
      DATA KX(235),KX(236),KX(237),KX(238),KX(239),KX(240)/7,7,0,0,2,4/
      DATA KY(235),KY(236),KY(237),KY(238),KY(239),KY(240)/7,0,7,0,4,0/
      DATA KX(241),KX(242),KX(243),KX(244),KX(245),KX(246)/4,7,6,7,4,7/
      DATA KY(241),KY(242),KY(243),KY(244),KY(245),KY(246)/7,0,0,7,7,0/
      DATA KX(247),KX(248),KX(249),KX(250),KX(251),KX(252)/0,4,7,6,7,7/
      DATA KY(247),KY(248),KY(249),KY(250),KY(251),KY(252)/7,0,0,0,7,0/
      DATA KX(253),KX(254),KX(255),KX(256),KX(257),KX(258)/0,2,4,7,2,2/
      DATA KY(253),KY(254),KY(255),KY(256),KY(257),KY(258)/7,4,7,0,4,0/
      DATA KX(259),KX(260),KX(261),KX(262),KX(263),KX(264)/7,6,7,7,3,1/
      DATA KY(259),KY(260),KY(261),KY(262),KY(263),KY(264)/0,0,7,0,4,4/
      DATA KX(265),KX(266),KX(267),KX(268),KX(269),KX(270)/7,0,4,0,4,7/
      DATA KY(265),KY(266),KY(267),KY(268),KY(269),KY(270)/0,7,7,0,0,0/
      DATA KX(271),KX(272),KX(273),KX(274),KX(275),KX(276)/6,7,7,4,3,1/
      DATA KY(271),KY(272),KY(273),KY(274),KY(275),KY(276)/0,7,0,1,0,0/
      DATA KX(277),KX(278),KX(279),KX(280),KX(281),KX(282)/0,0,1,3,4,4/
      DATA KY(277),KY(278),KY(279),KY(280),KY(281),KY(282)/1,6,7,7,6,1/
      DATA KX(283),KX(284),KX(285),KX(286),KX(287),KX(288)/7,6,7,7,1,2/
      DATA KY(283),KY(284),KY(285),KY(286),KY(287),KY(288)/0,0,7,0,6,7/
      DATA KX(289),KX(290),KX(291),KX(292),KX(293),KX(294)/2,7,1,3,7,6/
      DATA KY(289),KY(290),KY(291),KY(292),KY(293),KY(294)/0,0,0,0,0,0/
      DATA KX(295),KX(296),KX(297),KX(298),KX(299),KX(300)/7,7,0,1,3,4/
      DATA KY(295),KY(296),KY(297),KY(298),KY(299),KY(300)/7,0,6,7,7,6/
      DATA KX(301),KX(302),KX(303),KX(304),KX(305),KX(306)/4,0,0,4,7,6/
      DATA KY(301),KY(302),KY(303),KY(304),KY(305),KY(306)/5,1,0,0,0,0/
      DATA KX(307),KX(308),KX(309),KX(310),KX(311),KX(312)/7,7,0,1,3,4/
      DATA KY(307),KY(308),KY(309),KY(310),KY(311),KY(312)/7,0,6,7,7,6/
      DATA KX(313),KX(314),KX(315),KX(316),KX(317),KX(318)/4,3,1,7,3,4/
      DATA KY(313),KY(314),KY(315),KY(316),KY(317),KY(318)/5,4,4,0,4,3/
      DATA KX(319),KX(320),KX(321),KX(322),KX(323),KX(324)/4,3,1,0,7,6/
      DATA KY(319),KY(320),KY(321),KY(322),KY(323),KY(324)/1,0,0,1,0,0/
      DATA KX(325),KX(326),KX(327),KX(328),KX(329),KX(330)/7,7,3,3,2,0/
      DATA KY(325),KY(326),KY(327),KY(328),KY(329),KY(330)/7,0,0,7,7,4/
      DATA KX(331),KX(332),KX(333),KX(334),KX(335),KX(336)/0,4,7,2,4,7/
      DATA KY(331),KY(332),KY(333),KY(334),KY(335),KY(336)/3,3,0,0,0,0/
      DATA KX(337),KX(338),KX(339),KX(340),KX(341),KX(342)/6,7,7,0,1,3/
      DATA KY(337),KY(338),KY(339),KY(340),KY(341),KY(342)/0,7,0,1,0,0/
      DATA KX(343),KX(344),KX(345),KX(346),KX(347),KX(348)/4,4,3,0,0,4/
      DATA KY(343),KY(344),KY(345),KY(346),KY(347),KY(348)/1,3,4,4,7,7/
      DATA KX(349),KX(350),KX(351),KX(352),KX(353),KX(354)/7,6,7,7,4,3/
      DATA KY(349),KY(350),KY(351),KY(352),KY(353),KY(354)/0,0,7,0,6,7/
      DATA KX(355),KX(356),KX(357),KX(358),KX(359),KX(360)/1,0,0,1,3,4/
      DATA KY(355),KY(356),KY(357),KY(358),KY(359),KY(360)/7,6,1,0,0,1/
      DATA KX(361),KX(362),KX(363),KX(364),KX(365),KX(366)/4,3,1,0,7,6/
      DATA KY(361),KY(362),KY(363),KY(364),KY(365),KY(366)/3,4,4,3,0,0/
      DATA KX(367),KX(368),KX(369),KX(370),KX(371),KX(372)/7,7,0,0,4,4/
      DATA KY(367),KY(368),KY(369),KY(370),KY(371),KY(372)/7,0,6,7,7,6/
      DATA KX(373),KX(374),KX(375),KX(376),KX(377),KX(378)/2,2,7,6,7,7/
      DATA KY(373),KY(374),KY(375),KY(376),KY(377),KY(378)/1,0,0,0,7,0/
      DATA KX(379),KX(380),KX(381),KX(382),KX(383),KX(384)/1,0,0,1,3,4/
      DATA KY(379),KY(380),KY(381),KY(382),KY(383),KY(384)/4,5,6,7,7,6/
      DATA KX(385),KX(386),KX(387),KX(388),KX(389),KX(390)/4,3,1,0,0,1/
      DATA KY(385),KY(386),KY(387),KY(388),KY(389),KY(390)/5,4,4,3,1,0/
      DATA KX(391),KX(392),KX(393),KX(394),KX(395),KX(396)/3,4,4,3,7,6/
      DATA KY(391),KY(392),KY(393),KY(394),KY(395),KY(396)/0,1,3,4,0,0/
      DATA KX(397),KX(398),KX(399),KX(400),KX(401),KX(402)/7,7,0,1,3,4/
      DATA KY(397),KY(398),KY(399),KY(400),KY(401),KY(402)/7,0,1,0,0,1/
      DATA KX(403),KX(404),KX(405),KX(406),KX(407),KX(408)/4,3,1,0,0,1/
      DATA KY(403),KY(404),KY(405),KY(406),KY(407),KY(408)/6,7,7,6,4,3/
      DATA KX(409),KX(410),KX(411),KX(412),KX(413),KX(414)/3,4,7,6,7,7/
      DATA KY(409),KY(410),KY(411),KY(412),KY(413),KY(414)/3,4,0,0,7,0/
      DATA KX(415),KX(416),KX(417),KX(418),KX(419),KX(420)/0,4,7,2,2,7/
      DATA KY(415),KY(416),KY(417),KY(418),KY(419),KY(420)/3,3,0,5,1,0/
      DATA KX(421),KX(422),KX(423),KX(424),KX(425),KX(426)/6,7,7,0,4,7/
      DATA KY(421),KY(422),KY(423),KY(424),KY(425),KY(426)/0,7,0,3,3,0/
      DATA KX(427),KX(428),KX(429),KX(430),KX(431),KX(432)/6,7,7,0,4,7/
      DATA KY(427),KY(428),KY(429),KY(430),KY(431),KY(432)/0,7,0,1,5,0/
      DATA KX(433),KX(434),KX(435),KX(436),KX(437),KX(438)/2,2,7,4,0,7/
      DATA KY(433),KY(434),KY(435),KY(436),KY(437),KY(438)/5,1,0,3,3,0/
      DATA KX(439),KX(440),KX(441),KX(442),KX(443),KX(444)/0,4,7,6,7,4/
      DATA KY(439),KY(440),KY(441),KY(442),KY(443),KY(444)/5,1,0,0,7,7/
      DATA KX(445),KX(446),KX(447),KX(448),KX(449),KX(450)/7,6,7,7,3,2/
      DATA KY(445),KY(446),KY(447),KY(448),KY(449),KY(450)/0,0,7,1,7,6/
      DATA KX(451),KX(452),KX(453),KX(454),KX(455),KX(456)/2,3,7,6,7,7/
      DATA KY(451),KY(452),KY(453),KY(454),KY(455),KY(456)/1,0,0,0,7,0/
      DATA KX(457),KX(458),KX(459),KX(460),KX(461),KX(462)/1,2,2,1,7,6/
      DATA KY(457),KY(458),KY(459),KY(460),KY(461),KY(462)/7,6,1,0,0,0/
      DATA KX(463),KX(464),KX(465),KX(466),KX(467),KX(468)/7,7,4,0,7,0/
      DATA KY(463),KY(464),KY(465),KY(466),KY(467),KY(468)/7,0,5,5,0,2/
      DATA KX(469),KX(470),KX(471),KX(472),KX(473),KX(474)/4,7,6,7,7,6/
      DATA KY(469),KY(470),KY(471),KY(472),KY(473),KY(474)/2,0,0,7,0,0/
      DATA KX(475),KX(476),KX(477),KX(478),KX(479),KX(480)/7,7,1,2,2,1/
      DATA KY(475),KY(476),KY(477),KY(478),KY(479),KY(480)/7,0,0,1,2,2/
      DATA KX(481),KX(482),KX(483),KX(484),KX(485),KX(486)/1,2,7,6,7,7/
      DATA KY(481),KY(482),KY(483),KY(484),KY(485),KY(486)/1,1,0,0,7,0/
      DATA KX(487),KX(488),KX(489),KX(490),KX(491),KX(492)/2,1,1,2,2,7/
      DATA KY(487),KY(488),KY(489),KY(490),KY(491),KY(492)/0,0,1,1,0,0/
      DATA KX(493),KX(494)                                /6,7        /
      DATA KY(493),KY(494)                                /0,7        /
C
C NSIZE IS THE LENGTH OF JCHAR AND INDEX.
C LNGTH IS THE LENGTH OF KX AND KY.
C LENTRY TELLS IF THIS IS THE FIRTST CALL TO PWRZS.
C
      DATA NSIZE/46/
c Variable LNGTH never used.
c     DATA LNGTH/494/
      DATA LENTRY/.FALSE./
      DATA ITHETA/0/
      DATA IDUM1,IDUM2,IDUM3/1,1,1/
C
C THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('GRAPHX','PWRZS','PWRZS','VERSION  1')
C
C INQUIRE CURRENT NORMALIZATION TRANS NUMBER
C
      CALL GQCNTN (IERR,NTORIG)
C
C SAVE NORMALIZATION TRANS 1 AND LOG SCALING FLAG
C
      CALL GQNT (1,IERR,WNDW,VWPRT)
      CALL GETUSV('LS',IOLLS)
C
C DEFINE NORMALIZATION TRANS 1 FOR USE WITH DRAWS
C
c +NOAO: device viewport now user controlled through common noaovp
      call set (vpx1, vpx2, vpy1, vpy2, 1., 1024., 1., 1024., 1)
c     CALL SET(0.0,1.0,0.0,1.0,1.0,1024.0,1.0,1024.0,1)
c-NOAO
C
C SEE IF THIS IS THE FIRST CALL TO PWRZS
C
      IF (LENTRY) GO TO 103
C
C MARK THAT FUTURE CALLS NEED NOT DO THIS CODE.
C
      LENTRY = .TRUE.
C
C RECORD THE LOCATION OF THE BLANK SO IT CAN BE USED FOR UNKNOWN
C CHARACTERS.
C
      IBLKPT = INDEX(44)
C
C CHANGE EACH CHARACTER IN THE TABLE TO RIGHT JUSTIFIED, ZERO FILLED.
C
C
C SORT JCHAR MAINTAINING THE RELATIONSHIP BETWEEN JCHAR AND INDEX.
C (THAT IS, IF JCHAR(I)='B', THEN INDEX(I)=13 FROM THE ABOVE DATA STMT.)
C THIS WILL ENABLE CHARACTERS TO BE QUICKLY FOUND IN ALL SUBSEQUENT
C CALLS TO PWRZS.
C
      CALL PWRZOS (JCHAR,INDEX,NSIZE)
C
C ALL ONE-TIME INITIALIZATION NOW FINISHED.
C
  103 CONTINUE
C
      NN = N
      IF (NN .LE. 0) RETURN
      FNNM1 = NN-1
      JCNT = ICNT
C
C PUT RELATIVE SIZE IN Q, ADJUST FOR CURRENT PLOTTER RESOLUTION
C
      CALL GETUSV ('XF',LX)
      SCALE = 2.**(LX-10)
      IF (ISIZE .EQ. 0) Q = 1.3334*SCALE
      IF (ISIZE .EQ. 1) Q = 2.*SCALE
      IF (ISIZE .EQ. 2) Q = 2.6667*SCALE
      IF (ISIZE .EQ. 3) Q = 4.*SCALE
      IF (ISIZE .GT. 3) Q = FLOAT(ISIZE)/(6.)
C
C PUT ANGLE IN RADIANS IN T.
C
      T = FLOAT(ITHETA)*1.5708
  104 CONTINUE
C
C CALCULATE COMBINED TRANSFORMATION
C
      CT = Q*COS(T)
      ST = Q*SIN(T)
C
C FIND CRT COORDINATES OF CENTER.
C
      LINEI = LIN3
      CALL INTZS (X,Y,Z,LINEI,ITOP)
      IF (LINEI .EQ. 0) RETURN
      IX = 0
      IY = 0
      XC = IX
      YC = IY
C
C CORRECT FOR CHARACTER DATA BEING LOWER-LEFT-HAND POSITIONED.
C
      XC = XC-2.*CT+3.5*ST
      YC = YC-2.*ST-3.5*CT
C
C CORRECT FOR CENTERING IF TURNED ON.
C
      JCNT = MAX0(-1,MIN0(1,JCNT))+2
      GO TO (108,107,109),JCNT
  107 XC = XC-CT*FNNM1*3.
      YC = YC-ST*FNNM1*3.
      GO TO 110
  108 XC = XC+CT*2.
      YC = YC+ST*2.
      GO TO 110
  109 XC = XC-CT*2.
      YC = YC-ST*2.
      XC = XC-CT*FNNM1*6.
      YC = YC-ST*FNNM1*6.
  110 CALL INITZS (IFIX(XC),IFIX(YC),1,IDUM1,IDUM2,2)
      CALL INITZS (IFIX(XC+CT*6.*FNNM1),IFIX(YC+ST*6.*FNNM1),2,IDUM1,
     +             IDUM2,2)
      CALL INITZS (IFIX(XC),IFIX(YC),IDUM1,IDUM2,IDUM3,3)
      DO 114 K=1,NN
         XB = XC
         YB = YC
         IP = 1
C
C EXTRACT CHARACTER NUMBER K FROM THE STRING.
C
         KCHAR = ID(K:K)
C
C FIND THE TABLE ENTRY.
C
       CALL PWRZGS (KCHAR,JCHAR,INDEX,NSIZE,IPOINT)
       IF (IPOINT .EQ. -1) IPOINT = IBLKPT
C
C ALWAYS LESS THAN 20 INSTRUCTIONS.
C
       DO 113 L=1,20
          ISUB = IPOINT+L-1
          NX = KX(ISUB)
          FNX = NX
          NY = KY(ISUB)
          FNY = NY
C
C TEST FOR OP-CODE OR DX AND DY.
C
          IF (NX .NE. 7) GO TO 111
C
C OP-CODE
C
          IP = 0
          IF (NY-7) 113,114,113
C
C DX AND DY
C
  111     XC = XB+FNX*CT-FNY*ST
          YC = YB+FNX*ST+FNY*CT
C
C CALL DESIRED PLOTTING ROUTINE.  DETERMINED BY OP-CODES.
C
          IF (IP .NE. 0) GO TO 112
      CALL INITZS (IFIX(XC+.5),IFIX(YC+.5),IDUM1,IDUM2,IDUM3,3)
          IP = 1
          GO TO 113
  112 CALL INITZS (IFIX(XC+.5),IFIX(YC+.5),IDUM1,IDUM2,IDUM3,4)
  113  CONTINUE
  114 CONTINUE
C
C     FLUSH PLOTIT BUFFER
C
      CALL PLOTIT(0,0,0)
C
C RESTORE NORMALIZATION TRANS 1 AND LOG SCALING
C
      CALL SET(VWPRT(1),VWPRT(2),VWPRT(3),VWPRT(4),
     +         WNDW(1),WNDW(2),WNDW(3),WNDW(4),IOLLS)
      CALL GSELNT (NTORIG)
      RETURN
      END
      SUBROUTINE INTZS (XX,YY,ZZ,LIN3,ITOP)
C
C FORCE STORAGE OF X, Y, AND Z INTO COMMON BLOCK
C
      COMMON /PWRZ2S/ X, Y, Z
      DATA IDUMX,IDUMY,IDUMZ /0, 0, 0/
      X = XX
      Y = YY
      Z = ZZ
      CALL INITZS (IDUMX,IDUMY,IDUMZ,LIN3,ITOP,1)
      RETURN
      END
      SUBROUTINE INITZS (IX,IY,IZ,LIN3,ITOP,IENT)
C
      SAVE
      COMMON /PWRZ1S/ XXMIN ,XXMAX ,YYMIN ,YYMAX ,
     +                ZZMIN ,ZZMAX ,DELCRT,EYEX  ,
     +                EYEY       ,EYEZ
C
      COMMON /PWRZ2S/ X          ,Y          ,Z
c +NOAO:  common block added to allow user control of device viewport.
      common /noaovp/ vpx1, vpx2, vpy1, vpy2
c -NOAO
      FX(R) = R+FACTX*FLOAT(IX)
      FY(R) = R+FACTY*FLOAT(IY)
C
C
C  DETERMINE INITZS,VISSET,FRSTZ OR VECTZ CALL
C
      GO TO (1000,2000,3000,4000),IENT
 1000 LIN = MAX0(1,MIN0(3,IABS(LIN3)))
      ITO = MAX0(1,MIN0(3,IABS(ITOP)))
C
C SET UP SCALING CONSTANTS
C
      DELMAX = AMAX1(XXMAX-XXMIN,YYMAX-YYMIN,ZZMAX-ZZMIN)
      FACTOR = DELMAX/DELCRT
      FACTX = SIGN(FACTOR,FLOAT(LIN3))
      FACTY = SIGN(FACTOR,FLOAT(ITOP))
C
C SET UP FOR PROPER PLANE
C
      JUMP1 = LIN+(ITO-1)*3
      GO TO (108,101,102,103,108,104,105,106,108),JUMP1
  101 ASSIGN 111 TO JUMP
      GO TO 107
  102 ASSIGN 112 TO JUMP
      GO TO 107
  103 ASSIGN 113 TO JUMP
      GO TO 107
  104 ASSIGN 114 TO JUMP
      GO TO 107
  105 ASSIGN 115 TO JUMP
      GO TO 107
  106 ASSIGN 116 TO JUMP
  107 RETURN
  108 CALL SETER ('INITZS - LINE OR ITOP IMPROPER IN PWRZS CALL' ,1,1)
      LIN3 = 0
      RETURN
C
C **************************** ENTRY VISSET ****************************
C     ENTRY VISSET (IX,IY,IZ)
C
C
C VISSET IS CALLED ONCE FOR EACH END OF THE CHARACTER STRING
C
 2000 IVIS = -1
      ITEMP = 0
      GO TO 110
C
C SEE IF THIS END COULD BE BEHIND THE OBJECT
C
  109 IF (EYEX.GT.XXMAX .AND. XX.GT.XXMAX) ITEMP = ITEMP+1
      IF (EYEY.GT.YYMAX .AND. YY.GT.YYMAX) ITEMP = ITEMP+1
      IF (EYEZ.GT.ZZMAX .AND. ZZ.GT.ZZMAX) ITEMP = ITEMP+1
      IF (EYEX.LT.XXMIN .AND. XX.LT.XXMIN) ITEMP = ITEMP+1
      IF (EYEY.LT.YYMIN .AND. YY.LT.YYMIN) ITEMP = ITEMP+1
      IF (EYEZ.LT.ZZMIN .AND. ZZ.LT.ZZMIN) ITEMP = ITEMP+1
      IF (IZ .EQ. 1) IVISS = ITEMP
C
C IF EITHER END CHARACTER COULD BE HIDDEN, TEST ALL LINE SEGMENTS.
C
      IF (IZ .EQ. 2) IVIS = MIN0(IVISS,ITEMP)
      RETURN
C
C **************************** ENTRY FRSTZ *****************************
C     ENTRY FRSTZ (IX,IY)
C
 3000 IFRST = 1
      GO TO 110
C
C **************************** ENTRY VECTZ *****************************
C     ENTRY VECTZ (IX,IY)
C
 4000 IFRST = 0
C
C PICK CORRECT 3-SPACE PLANE TO DRAW IN
C
  110 GO TO JUMP,(111,112,113,114,115,116)
  111 XX = FY(X)
      YY = FX(Y)
      ZZ = Z
      GO TO 117
  112 XX = FY(X)
      YY = Y
      ZZ = FX(Z)
      GO TO 117
  113 XX = FX(X)
      YY = FY(Y)
      ZZ = Z
      GO TO 117
  114 XX = X
      YY = FY(Y)
      ZZ = FX(Z)
      GO TO 117
  115 XX = FX(X)
      YY = Y
      ZZ = FY(Z)
      GO TO 117
  116 XX = X
      YY = FX(Y)
      ZZ = FY(Z)
C
C TRANSLATE TO 2-SPACE
C
  117 CALL TRN32S (XX,YY,ZZ,XT,YT,DUMMY,1)
      IF (IVIS) 109,121,118
  118 IF (IFRST) 119,120,119
C
C IF IN FRONT, DRAW IN ANY CASE.
C
c +NOAO: Remove the assumption that window coordinates 1-1024 map to the
c full plotter metacode range 1-32768
c
  119 zzxmc = (32768./1023.) * (vpx2 - vpx1) * (xt-1.) + (vpx1 * 32768.)
      zzymc = (32768./1023.) * (vpy2 - vpy1) * (yt-1.) + (vpy1 * 32768.)
      call plotit (ifix(zzxmc), ifix(zzymc), 0)
c 119 CALL PLOTIT (32*IFIX(XT),32*IFIX(YT),0)
      RETURN
c
  120 zzxmc = (32768./1023.) * (vpx2 - vpx1) * (xt-1.) + (vpx1 * 32768.)
      zzymc = (32768./1023.) * (vpy2 - vpy1) * (yt-1.) + (vpy1 * 32768.)
      call plotit (ifix(zzxmc), ifix(zzymc), 1)
c 120 CALL PLOTIT (32*IFIX(XT),32*IFIX(YT),1)
c -NOAO
      RETURN
  121 IF (IFRST) 122,123,122
  122 IX1 = XT
      IY1 = YT
      RETURN
  123 IX2 = XT
      IY2 = YT
C
C IF COULD BE HIDDEN, USE HIDDEN LINE PLOTTING ENTRY IN SRFACE
C
      CALL DRAWS (IX1,IY1,IX2,IY2,1,0)
      IX1 = IX2
      IY1 = IY2
      RETURN
      END
      SUBROUTINE PWRZOS (JCHAR,INDEX,NSIZE)
C
C THIS ROUTINE SORTS JCHAR WHICH IS NSIZE IN LENGTH.  THE RELATIONSHIP
C BETWEEN JCHAR AND INDEX IS MAINTAINED.  A BUBBLE SORT IS USED.
C JCHAR IS SORTED IN ASCENDING ORDER.
C
      SAVE
      CHARACTER*1     JCHAR(NSIZE)     ,JTEMP     ,KTEMP
      DIMENSION       INDEX(NSIZE)
      LOGICAL         LDONE
C
      ISTART = 1
      ISTOP = NSIZE
      ISTEP = 1
C
C AT MOST NSIZE PASSES ARE NEEDED.
C
      DO 104 NPASS=1,NSIZE
       LDONE = .TRUE.
       I = ISTART
  101  ISUB = I+ISTEP
       IF (ISTEP*(ICHAR(JCHAR(I))-ICHAR(JCHAR(ISUB)))) 103,103,102
C
C THEY NEED TO BE SWITCHED.
C
  102  LDONE = .FALSE.
       JTEMP = JCHAR(I)
       KTEMP = JCHAR(ISUB)
       JCHAR(I) = KTEMP
       JCHAR(ISUB) = JTEMP
       ITEMP = INDEX(I)
       INDEX(I) = INDEX(ISUB)
       INDEX(ISUB) = ITEMP
C
C THEY DO NOT NEED TO BE SWITCHED.
C
  103  I = I+ISTEP
       IF (I .NE. ISTOP) GO TO 101
C
C IF NONE WERE SWITCHED DURING THIS PASS, WE CAN QUIT.
C
       IF (LDONE) RETURN
C
C SET UP FOR THE NEXT PASS IN THE OTHER DIRECTION.
C
       ISTEP = -ISTEP
       ITEMP = ISTART
       ISTART = ISTOP+ISTEP
       ISTOP = ITEMP
  104 CONTINUE
      RETURN
      END
      SUBROUTINE PWRZGS (KCHAR,JCHAR,INDEX,NSIZE,IPOINT)
C
C THIS ROUTINE FINDS WHERE KCHAR IS IN JCHAR AND RETURNS THE CORRES-
C PONDING INDEX IN IPOINT.  BINARY HALVING IS USED.
C
      SAVE
      CHARACTER*1     JCHAR(NSIZE)     ,KCHAR
      DIMENSION       INDEX(NSIZE)
C
C IT IS ASSUMED THAT JCHAR IS LESS THAT 2**9 IN LENGTH, SO IF KCHAR IS
C NOT FOUND IN 10 STEPS, THE SEARCH IS STOPPED.
C
      KOUNT = 0
      IBOT = 1
      ITOP = NSIZE
      I = ITOP
      GO TO 102
  101 I = (IBOT+ITOP)/2
      KOUNT = KOUNT+1
      IF (KOUNT .GT. 10) GO TO 106
  102 IF (ICHAR(JCHAR(I))-ICHAR(KCHAR)) 103,105,104
  103 IBOT = I
      GO TO 101
  104 ITOP = I
      GO TO 101
  105 IPOINT = INDEX(I)
      RETURN
C
C IPOINT=-1 MEANS THAT KCHAR WAS NOT IN THE TABLE.
C
  106 IPOINT = -1
      RETURN
C
C
C
C REVISION HISTORY----------
C
C MARCH    1980    FIRST ADDED TO ULIB AS A SEPARATE FILE TO BE
C                  USED IN CONJUNCTION WITH THE ULIB ROUTINE
C                  SRFACE
C
C JULY     1984    CONVERTED TO GKS AND FORTRAN 77
C------------------------------------------------------------------
      END

C SUBROUTINE GRADLS.F 
C
C SOURCE
C   BEVINGTON, PAGES 220-222.
C
C PURPOSE
C   MAKE A GRADIENT-SEARCH LEAST-SQUARES FIT TO DATA WITH A
C      SPECIFIED FUNCTION WHICH IS NOT LINEAR IN COEFFICIENTS
C
C USAGE 
C   CALL GRADLS (X, Y, SIGMAY, NPTS, NTERMS, MODE, A, DELTAA,
C      YFIT, CHISQR)
C
C DESCRIPTION OF PARAMETERS
C   X	   - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C   Y	   - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C   SIGMAY - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
C   NPTS   - NUMBER OF PAIRS OF DATA POINTS
C   NTERMS - NUMBER OF PARAMETERS
C   MODE   - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C	     +1 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
C	      0 (NO WEIGHTING) WEIGHT(I) = 1.
C	     -1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
C   A	   - ARRAY OF PARAMETERS
C   DELTAA - ARRAY OF INCREMENTS FOR PARAMETERS A
C   YFIT   - ARRAY OF CALCULATED VALUES OF Y
C   CHISQR - REDUCED CHI SQUARE FOR FIT 
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   FUNCTN (X, I, A)
C      EVALUATES THE FITTING FUNCTION FOR THE ITH TERM
C   FCHISQ (Y, SIGMAY, NPTS, NFREE, MODE, YFIT) 
C      EVALUATES REDUCED CHI SQUARED FOR FIT TO DATA
C
C COMMENTS
C   DIMENSION STATEMENT VALID FOR NTERMS UP TO 10
C
      SUBROUTINE GRADLS (X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,
     *YFIT,CHISQR)
      DIMENSION X(1),Y(1),SIGMAY(1),A(1),DELTAA(1),YFIT(1)
      DIMENSION GRAD(10)
      REAL FUNCTN
      EXTERNAL FUNCTN

C
C EVALUATE CHI SQUARE AT BEGINNING
C
11    NFREE=NPTS-NTERMS
      IF (NFREE) 13,13,21
13    CHISQR=0.
      GOTO 110
21    DO 22 I=1,NPTS
22    YFIT(I)=FUNCTN (X,I,A)
      CHISQ1=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C
C EVALUATE GRADIENT OF CHI SQUARE
C
31    SUM=0.
32    DO 39 J=1,NTERMS
      DELTA=0.1*DELTAA(J)
      A(J)=A(J)+DELTA 
      DO 36 I=1,NPTS
36    YFIT(I)=FUNCTN (X,I,A)
      A(J)=A(J)-DELTA 
      GRAD(J)=CHISQ1-FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
39    SUM=SUM+GRAD(J)**2
41    DO 42 J=1,NTERMS
42    GRAD(J)=DELTAA(J)*GRAD(J)/SQRT(SUM)
C
C EVALUATE CHI SQUARE AT NEW POINT
C
51    DO 52 J=1,NTERMS
52    A(J)=A(J)+GRAD(J)
53    DO 54 I=1,NPTS
54    YFIT(I)=FUNCTN (X,I,A)
      CHISQ2=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C
C MAKE SURE CHI SQUARE DECREASES
C
61    IF (CHISQ1-CHISQ2) 62,62,71
62    DO 64 J=1,NTERMS
      A(J)=A(J)-GRAD(J)
64    GRAD(J)=GRAD(J)/2.
      GOTO 51 
C
C INCREMENT PARAMETERS UNTIL CHI SQUARE STARTS TO INCREASE
C
71    DO 72 J=1,NTERMS
72    A(J)=A(J)+GRAD(J)
      DO 74 I=1,NPTS
74    YFIT(I)=FUNCTN (X,I,A)
75    CHISQ3=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
76    IF (CHISQ3-CHISQ2) 81,91,91
81    CHISQ1=CHISQ2
82    CHISQ2=CHISQ3
      GOTO 71 
C
C FIND MINIMUM OF PARABOLA DEFINED BY LAST THREE POINTS 
C
91    DELTA=1./(1.+(CHISQ1-CHISQ2)/(CHISQ3-CHISQ2))+0.5
      DO 93 J=1,NTERMS
93    A(J)=A(J)-DELTA*GRAD(J) 
      DO 95 I=1,NPTS
95    YFIT(I)=FUNCTN (X,I,A)
      CHISQR=FCHISQ (Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
101   IF (CHISQ2-CHISQR) 102,110,110
102   DO 103 J=1,NTERMS
103   A(J)=A(J)+(DELTA-1.)*GRAD(J)
104   DO 105 I=1,NPTS 
105   YFIT(I)=FUNCTN (X,I,A)
106   CHISQR=CHISQ2
110   RETURN
      END

      SUBROUTINE slFTXY (ITYPE,NP,XYE,XYM,COEFFS,J)
*+
*     - - - - - -
*      F T X Y
*     - - - - - -
*
*  Fit a linear model to relate two sets of [X,Y] coordinates.
*
*  Given:
*     ITYPE    i        type of model: 4 or 6 (note 1)
*     NP       i        number of samples (note 2)
*     XYE     d(2,np)   expected [X,Y] for each sample
*     XYM     d(2,np)   measured [X,Y] for each sample
*
*  Returned:
*     COEFFS  d(6)      coefficients of model (note 3)
*     J        i        status:  0 = OK
*                               -1 = illegal ITYPE
*                               -2 = insufficient data
*                               -3 = no solution
*
*  Notes:
*
*  1)  ITYPE, which must be either 4 or 6, selects the type of model
*      fitted.  Both allowed ITYPE values produce a model COEFFS which
*      consists of six coefficients, namely the zero points and, for
*      each of XE and YE, the coefficient of XM and YM.  For ITYPE=6,
*      all six coefficients are independent, modelling squash and shear
*      as well as origin, scale, and orientation.  However, ITYPE=4
*      selects the "solid body rotation" option;  the model COEFFS
*      still consists of the same six coefficients, but now two of
*      them are used twice (appropriately signed).  Origin, scale
*      and orientation are still modelled, but not squash or shear -
*      the units of X and Y have to be the same.
*
*  2)  For NC=4, NP must be at least 2.  For NC=6, NP must be at
*      least 3.
*
*  3)  The model is returned in the array COEFFS.  Naming the
*      elements of COEFFS as follows:
*
*                  COEFFS(1) = A
*                  COEFFS(2) = B
*                  COEFFS(3) = C
*                  COEFFS(4) = D
*                  COEFFS(5) = E
*                  COEFFS(6) = F
*
*      the model is:
*
*            XE = A + B*XM + C*YM
*            YE = D + E*XM + F*YM
*
*      For the "solid body rotation" option (ITYPE=4), the
*      magnitudes of B and F, and of C and E, are equal.  The
*      signs of these coefficients depend on whether there is a
*      sign reversal between XE,YE and XM,YM;  fits are performed
*      with and without a sign reversal and the best one chosen.
*
*  4)  Error status values J=-1 and -2 leave COEFFS unchanged;
*      if J=-3 COEFFS may have been changed.
*
*  See also slPXY, slINVF, slXYXY, slDCMF
*
*  Called:  slDMAT, slDMXV
*
*  Last revision:   8 September 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER ITYPE,NP
      DOUBLE PRECISION XYE(2,NP),XYM(2,NP),COEFFS(6)
      INTEGER J

      INTEGER I,JSTAT,IW(4),NSOL
      DOUBLE PRECISION A,B,C,D,AOLD,BOLD,COLD,DOLD,SOLD,
     :                 P,SXE,SXEXM,SXEYM,SYE,SYEYM,SYEXM,SXM,
     :                 SYM,SXMXM,SXMYM,SYMYM,XE,YE,
     :                 XM,YM,V(4),DM3(3,3),DM4(4,4),DET,
     :                 SGN,SXXYY,SXYYX,SX2Y2,SDR2,XR,YR



*  Preset the status
      J=0

*  Variable initializations to avoid compiler warnings
      A = 0D0
      B = 0D0
      C = 0D0
      D = 0D0
      AOLD = 0D0
      BOLD = 0D0
      COLD = 0D0
      DOLD = 0D0
      SOLD = 0D0

*  Float the number of samples
      P=DBLE(NP)

*  Check ITYPE
      IF (ITYPE.EQ.6) THEN

*
*     Six-coefficient linear model
*     ----------------------------

*     Check enough samples
         IF (NP.GE.3) THEN

*     Form summations
         SXE=0D0
         SXEXM=0D0
         SXEYM=0D0
         SYE=0D0
         SYEYM=0D0
         SYEXM=0D0
         SXM=0D0
         SYM=0D0
         SXMXM=0D0
         SXMYM=0D0
         SYMYM=0D0
         DO I=1,NP
            XE=XYE(1,I)
            YE=XYE(2,I)
            XM=XYM(1,I)
            YM=XYM(2,I)
            SXE=SXE+XE
            SXEXM=SXEXM+XE*XM
            SXEYM=SXEYM+XE*YM
            SYE=SYE+YE
            SYEYM=SYEYM+YE*YM
            SYEXM=SYEXM+YE*XM
            SXM=SXM+XM
            SYM=SYM+YM
            SXMXM=SXMXM+XM*XM
            SXMYM=SXMYM+XM*YM
            SYMYM=SYMYM+YM*YM
         END DO

*        Solve for A,B,C in  XE = A + B*XM + C*YM
            V(1)=SXE
            V(2)=SXEXM
            V(3)=SXEYM
            DM3(1,1)=P
            DM3(1,2)=SXM
            DM3(1,3)=SYM
            DM3(2,1)=SXM
            DM3(2,2)=SXMXM
            DM3(2,3)=SXMYM
            DM3(3,1)=SYM
            DM3(3,2)=SXMYM
            DM3(3,3)=SYMYM
            CALL slDMAT(3,DM3,V,DET,JSTAT,IW)
            IF (JSTAT.EQ.0) THEN
               DO I=1,3
                  COEFFS(I)=V(I)
               END DO

*           Solve for D,E,F in  YE = D + E*XM + F*YM
               V(1)=SYE
               V(2)=SYEXM
               V(3)=SYEYM
               CALL slDMXV(DM3,V,COEFFS(4))

            ELSE

*           No 6-coefficient solution possible
               J=-3

            END IF

         ELSE

*        Insufficient data for 6-coefficient fit
            J=-2

         END IF

      ELSE IF (ITYPE.EQ.4) THEN

*
*     Four-coefficient solid body rotation model
*     ------------------------------------------

*     Check enough samples
         IF (NP.GE.2) THEN

*        Try two solutions, first without then with flip in X
            DO NSOL=1,2
               IF (NSOL.EQ.1) THEN
                  SGN=1D0
               ELSE
                  SGN=-1D0
               END IF

*           Form summations
               SXE=0D0
               SXXYY=0D0
               SXYYX=0D0
               SYE=0D0
               SXM=0D0
               SYM=0D0
               SX2Y2=0D0
               DO I=1,NP
                  XE=XYE(1,I)*SGN
                  YE=XYE(2,I)
                  XM=XYM(1,I)
                  YM=XYM(2,I)
                  SXE=SXE+XE
                  SXXYY=SXXYY+XE*XM+YE*YM
                  SXYYX=SXYYX+XE*YM-YE*XM
                  SYE=SYE+YE
                  SXM=SXM+XM
                  SYM=SYM+YM
                  SX2Y2=SX2Y2+XM*XM+YM*YM
               END DO

*
*           Solve for A,B,C,D in:  +/- XE = A + B*XM - C*YM
*                                    + YE = D + C*XM + B*YM
               V(1)=SXE
               V(2)=SXXYY
               V(3)=SXYYX
               V(4)=SYE
               DM4(1,1)=P
               DM4(1,2)=SXM
               DM4(1,3)=-SYM
               DM4(1,4)=0D0
               DM4(2,1)=SXM
               DM4(2,2)=SX2Y2
               DM4(2,3)=0D0
               DM4(2,4)=SYM
               DM4(3,1)=SYM
               DM4(3,2)=0D0
               DM4(3,3)=-SX2Y2
               DM4(3,4)=-SXM
               DM4(4,1)=0D0
               DM4(4,2)=SYM
               DM4(4,3)=SXM
               DM4(4,4)=P
               CALL slDMAT(4,DM4,V,DET,JSTAT,IW)
               IF (JSTAT.EQ.0) THEN
                  A=V(1)
                  B=V(2)
                  C=V(3)
                  D=V(4)

*              Determine sum of radial errors squared
                  SDR2=0D0
                  DO I=1,NP
                     XM=XYM(1,I)
                     YM=XYM(2,I)
                     XR=A+B*XM-C*YM-XYE(1,I)*SGN
                     YR=D+C*XM+B*YM-XYE(2,I)
                     SDR2=SDR2+XR*XR+YR*YR
                  END DO

               ELSE

*              Singular: set flag
                  SDR2=-1D0

               END IF

*           If first pass and non-singular, save variables
               IF (NSOL.EQ.1.AND.JSTAT.EQ.0) THEN
                  AOLD=A
                  BOLD=B
                  COLD=C
                  DOLD=D
                  SOLD=SDR2
               END IF

            END DO

*        Pick the best of the two solutions
            IF (SOLD.GE.0D0.AND.(SOLD.LE.SDR2.OR.NP.EQ.2)) THEN
               COEFFS(1)=AOLD
               COEFFS(2)=BOLD
               COEFFS(3)=-COLD
               COEFFS(4)=DOLD
               COEFFS(5)=COLD
               COEFFS(6)=BOLD
            ELSE IF (JSTAT.EQ.0) THEN
               COEFFS(1)=-A
               COEFFS(2)=-B
               COEFFS(3)=C
               COEFFS(4)=D
               COEFFS(5)=C
               COEFFS(6)=B
            ELSE

*           No 4-coefficient fit possible
               J=-3
            END IF
         ELSE

*        Insufficient data for 4-coefficient fit
            J=-2
         END IF
      ELSE

*     Illegal ITYPE - not 4 or 6
         J=-1
      END IF

      END

include  defs

# unstak - unstack at end of statement

define	IFSTMT		999


subroutine unstak (sp, lextyp, labval, token)

integer	labval(MAXSTACK), lextyp(MAXSTACK)
integer	sp, token, type

	for (;  sp > 1;  sp=sp-1) {
	    type = lextyp(sp)
	    if ((type == LEXIFERR | type == LEXIFNOERR) & token == LEXTHEN)
		break
	    if (type == LEXIF | type == LEXIFERR | type == LEXIFNOERR)
		type = IFSTMT
	    if (type == LBRACE | type == LEXSWITCH)
		break
	    if (type == IFSTMT & token == LEXELSE)
		break

	    if (type == IFSTMT) {
		call indent (-1)
		call outcon (labval(sp))
	    } else if (type == LEXELSE | type == LEXIFELSE) {
		if (sp > 2)
		    sp = sp - 1
		if (type != LEXIFELSE)
		    call indent (-1)
		call outcon (labval(sp) + 1)
	    } else if (type == LEXDO)
		call dostat (labval(sp))
	    else if (type == LEXWHILE)
		call whiles (labval(sp))
	    else if (type == LEXFOR)
		call fors (labval(sp))
	    else if (type == LEXREPEAT)
		call untils (labval(sp), token)
	}
end

      FUNCTION CONLCM(X,Y,XD,YD,ZD,NDP,WK,IWK,LOC)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  COMPUTE A Z VALUE FOR A GIVEN X,Y VALUE
C  NOTE THAT X,Y MUST BE INSIDE THE CONVEX HULL OF THE INPUT DATA
C  INORDER FOR THIS FUNCTION TO WORK.
C
C  INPUT
C       X-X COORDINATE OF REQUESTED POINT
C       Y-Y COORDINATE OF REQUESTED POINT
C       WK-LIST OF COEFICENTS FOR LINEAR INTERPOLATION  FUNCTIONS
C             LOCATED BY A = WK((TRI-1)*3+1)
C                        B = WK((TRI-2)*3+1)
C                        C = WK((TRI-3)*3+1)
C
C  OUTPUT
C       LOC-TRIANGLE NUMBER OF REQUESTED POINT
C       Z VALUE AS FUNCTION RESULT
C
      DIMENSION WK(1),IWK(1),XD(1),YD(1),ZD(1)
C
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
C
        SAVE
C
C  LOCATE THE TRIANGLE
C
      CALL CONLOC(NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),X,Y,LOC,
     1            IWK(JWIWL),WK)
C
C  IF OUTSIDE CONVEX HULL THEN DON'T COMPUTE A VALUE
C
      IF (LOC.GT.NT) RETURN
C
C  GET THE VECTOR 1 VALUES FOR THE TRIANGLE
C
      IVEC = (LOC-1)*3 + JWIPT
      IV = IWK(IVEC)
      X1 = X - XD(IV)
      Y1 = Y - YD(IV)
      Z1 = ZD(IV)
C
C  COMPUT THE Z VALUE
C
      IPOINT = (LOC-1)*3 + IPR
C
      Z = (WK(IPOINT)*X1+WK(IPOINT+1)*Y1)/WK(IPOINT+2) + Z1
C
      CONLCM = Z
C
      RETURN
      END

      SUBROUTINE CFFTI1 (N,WA,IFAC)
      DIMENSION       WA(*)      ,IFAC(*)    ,NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/3,4,2,5/
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J.le.4) GO TO 102
      GO TO 103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRYH(4)+2*(J-4)
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR.eq.0) GO TO 105
      GO TO 101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 6.28318530717959
      ARGH = TPI/FLOAT(N)
      I = 2
      L1 = 1
      DO 110 K1=1,NF
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IDOT = IDO+IDO+2
         IPM = IP-1
         DO 109 J=1,IPM
            I1 = I
            WA(I-1) = 1.
            WA(I) = 0.
            LD = LD+L1
            FI = 0.
            ARGLD = FLOAT(LD)*ARGH
            DO 108 II=4,IDOT,2
               I = I+2
               FI = FI+1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IF (IP .LE. 5) GO TO 109
            WA(I1-1) = WA(I-1)
            WA(I1) = WA(I)
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END

C----------------------------------------------------------------------
        subroutine ftpdfl(iunit,status)

C       Write the Data Unit Fill values if they are not already correct
C       Fill the data unit with zeros or blanks depending on the type of HDU
C       from the end of the data to the end of the current FITS 2880 byte block

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1994

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nf = 3000)
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character*1 chbuff(2880),chfill,xdummy(2879)
        common/ftheap/chbuff,chfill,xdummy
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,filpos,nfill,i,tstat

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       check if the data unit is null

        if (theap(ibuff) .eq. 0)return

        filpos=dtstrt(ibuff)+theap(ibuff)+scount(ibuff)
        nfill=(filpos+2879)/2880*2880-filpos

C       return if there are no fill bytes 
        if (nfill .eq. 0)return

C       set the correct fill value to be checked
        if (hdutyp(ibuff) .eq. 1)then
C              this is an ASCII table; should be filled with blanks
               chfill=char(32)
        else
               chfill=char(0)
        end if

C       move to the beginning of the fill bytes and read them
        tstat=status
        call ftmbyt(iunit,filpos,.true.,status)
        call ftgcbf(iunit,0,nfill,chbuff,status)

        if (status .gt. 0)then
C           fill bytes probably haven't been written yet so have to write them
            status=tstat
            go to 100
        end if

C       check if all the fill values are correct
        do 10 i=1,nfill
            if (chbuff(i) .ne. chfill)go to 100
10      continue             

C       fill bytes were correct, so just return
        return

100     continue

C       fill the buffer with the correct fill value
        do 20 i=1,nfill
               chbuff(i)=chfill
20      continue

C       move to the beginning of the fill bytes
        call ftmbyt(iunit,filpos,.true.,status)

C       write all the fill bytes
        call ftpcbf(iunit,0,nfill,chbuff,status)

        if (status .gt. 0)then
           call ftpmsg('Error writing Data Unit fill bytes (FTPDFL).')
        end if
        end

      INTEGER FUNCTION CONXCH (X,Y,I1,I2,I3,I4)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C THIS FUNCTION DETERMINES WHETHER OR NOT THE EXCHANGE OF TWO
C TRIANGLES IS NECESSARY ON THE BASIS OF MAX-MIN-ANGLE CRITERION
C BY C. L. LAWSON.
C THE INPUT PARAMETERS ARE
C     X,Y = ARRAYS CONTAINING THE COORDINATES OF THE DATA
C           POINTS,
C     I1,I2,I3,I4 = POINT NUMBERS OF FOUR POINTS P1, P2,
C                   P3, AND P4 THAT FORM A QUADRILATERAL
C                   WITH P3 AND P4 CONNECTED DIADONALLY.
C THIS FUNCTION RETURNS A VALUE 1 (ONE) WHEN AN EXCHANGE IS
C NEEDED, AND 0 (ZERO) OTHERWISE.
C DECLARATION STATEMENTS
C
      DIMENSION       X(1)       ,Y(1)
      DIMENSION       X0(4)      ,Y0(4)
      EQUIVALENCE     (C2SQ,C1SQ),(A3SQ,B2SQ),(B3SQ,A1SQ),(A4SQ,B1SQ),
     1                (B4SQ,A2SQ),(C4SQ,C3SQ)
C
        SAVE
C
C STATEMENT FUNCTIONS
C
C CALCULATION
C
      X0(1) = X(I1)
      Y0(1) = Y(I1)
      X0(2) = X(I2)
      Y0(2) = Y(I2)
      X0(3) = X(I3)
      Y0(3) = Y(I3)
      X0(4) = X(I4)
      Y0(4) = Y(I4)
      IDX = 0
      U3 = (Y0(2)-Y0(3))*(X0(1)-X0(3))-(X0(2)-X0(3))*(Y0(1)-Y0(3))
      U4 = (Y0(1)-Y0(4))*(X0(2)-X0(4))-(X0(1)-X0(4))*(Y0(2)-Y0(4))
      IF (U3*U4 .LE. 0.0) GO TO  100
      U1 = (Y0(3)-Y0(1))*(X0(4)-X0(1))-(X0(3)-X0(1))*(Y0(4)-Y0(1))
      U2 = (Y0(4)-Y0(2))*(X0(3)-X0(2))-(X0(4)-X0(2))*(Y0(3)-Y0(2))
      A1SQ = (X0(1)-X0(3))**2+(Y0(1)-Y0(3))**2
      B1SQ = (X0(4)-X0(1))**2+(Y0(4)-Y0(1))**2
      C1SQ = (X0(3)-X0(4))**2+(Y0(3)-Y0(4))**2
      A2SQ = (X0(2)-X0(4))**2+(Y0(2)-Y0(4))**2
      B2SQ = (X0(3)-X0(2))**2+(Y0(3)-Y0(2))**2
      C3SQ = (X0(2)-X0(1))**2+(Y0(2)-Y0(1))**2
      S1SQ = U1*U1/(C1SQ*AMAX1(A1SQ,B1SQ))
      S2SQ = U2*U2/(C2SQ*AMAX1(A2SQ,B2SQ))
      S3SQ = U3*U3/(C3SQ*AMAX1(A3SQ,B3SQ))
      S4SQ = U4*U4/(C4SQ*AMAX1(A4SQ,B4SQ))
      IF (AMIN1(S1SQ,S2SQ) .LT. AMIN1(S3SQ,S4SQ)) IDX = 1
  100 CONXCH = IDX
      RETURN
C
      END

C--------------------------------------------------------------------------
        subroutine ftpdat(ounit,status)

C       write the current date to the DATE keyword in the ounit CHU
C
C       ounit   i  fortran output unit number
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Jan 1992

        integer ounit,status,dd,mm,yy
        character datstr*8

C       call the system dependent routine to get the current date
        call ftgsdt(dd,mm,yy,status)
        if (status .gt. 0)return

        datstr='  /  /  '
        write(datstr(1:2),1001)dd
        write(datstr(4:5),1001)mm
        write(datstr(7:8),1001)yy
1001    format(i2)

C       replace blank with leading 0 in each field if required
        if (datstr(1:1) .eq. ' ')datstr(1:1)='0'
        if (datstr(4:4) .eq. ' ')datstr(4:4)='0'
        if (datstr(7:7) .eq. ' ')datstr(7:7)='0'
        
C       update the DATE keyword
        call ftukys(ounit,'DATE',datstr,
     &             'FITS file creation date (dd/mm/yy)',status)
        end

include	defs

# delete --- remove a symbol from the symbol table

   subroutine delete (symbol, st)
   character symbol (ARB)
   pointer st

   DS_COMMON

   integer stlu

   pointer node, pred

   if (stlu (symbol, node, pred, st) == YES) {
      Mem (pred + ST_LINK) = Mem (node + ST_LINK)
      call dsfree (node)
      }

   return
   end

include  defs

# IFGO - generate "if (.not.(...)) goto lab"

subroutine ifgo (lab)

integer lab
include COMMON_BLOCKS
string ifnot "if (.not."
string serrchk ".and.(.not.xerflg)) "

	call outtab			# get to column 7
	call outstr (ifnot)		# " if (.not. "
	call balpar			# collect and output condition
	if (ername == YES)		# add error checking?
	    call outstr (serrchk)
	else {
	    call outch (RPAREN)		# " ) "
	    call outch (BLANK)
	}
	call outgo (lab)		# " goto lab "
	call errgo
end

      subroutine sva (a,mda,m,n,mdata,b,sing,names,iscale,d)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c		singular value analysis printout
c
c     iscale	   set by user to 1, 2, or 3 to select column scaling
c		   option.
c		   1   subr will use identity scaling and ignore the d()
c		       array.
c		   2   subr will scale nonzero cols to have unit euclide
c		       length and will store reciprocal lengths of
c		       original nonzero cols in d().
c		   3   user supplies col scale factors in d(). subr
c		       will mult col j by d(j) and remove the scaling
c		       from the soln at the end.
c
      dimension  a(mda,n), b(m), sing(01),d(n)
c     sing(3*n)
      dimension names(n)
      logical test
      double precision	 sb, dzero
      dzero=0.d0
      one=1.
      zero=0.
      if (m.le.0 .or. n.le.0) return
      np1=n+1
      write (6,270)
      write (6,260) m,n,mdata
      go to (60,10,10), iscale
c
c     apply column scaling to a
c
   10	   do 50 j=1,n
	   a1=d(j)
	   go to (20,20,40), iscale
   20	   sb=dzero
		do 30 i=1,m
   30		sb=sb+dble(a(i,j))**2
	   a1=dsqrt(sb)
	   if (a1.eq.zero) a1=one
	   a1=one/a1
	   d(j)=a1
   40		do 50 i=1,m
   50		a(i,j)=a(i,j)*a1
      write (6,280) iscale,(d(j),j=1,n)
      go to 70
   60 continue
      write (6,290)
   70 continue
c
c     obtain  sing. value decomp. of scaled matrix.
c
c**********************************************************
      call svdrs (a,mda,m,n,b,1,1,sing)
c**********************************************************
c
c     print the v matrix.
c
      call mfeout (a,mda,n,n,names,1)
      if (iscale.eq.1) go to 90
c
c     replace v by d*v in the array a()
c
	   do 80 i=1,n
		do 80 j=1,n
   80		a(i,j)=d(i)*a(i,j)
c
c     g  now in  b array.  v now in a array.
c
c
c     obtain summary output.
c
   90 continue
      write (6,220)
c
c     compute cumulative sums of squares of components of
c     g and store them in sing(i), i=minmn+1,...,2*minmn+1
c
      sb=dzero
      minmn=min0(m,n)
      minmn1=minmn+1
      if (m.eq.minmn) go to 110
	   do 100 i=minmn1,m
  100	   sb=sb+dble(b(i))**2
  110 sing(2*minmn+1)=sb
	   do 120 jj=1,minmn
	   j=minmn+1-jj
	   sb=sb+dble(b(j))**2
	   js=minmn+j
  120	   sing(js)=sb
      a3=sing(minmn+1)
      a4=sqrt(a3/float(max0(1,mdata)))
      write (6,230) a3,a4
c
      nsol=0
c
c
c
	   do 160 k=1,minmn
	   if (sing(k).eq.zero) go to 130
	   nsol=k
	   pi=b(k)/sing(k)
	   a1=one/sing(k)
	   a2=b(k)**2
	   a3=sing(minmn1+k)
	   a4=sqrt(a3/float(max0(1,mdata-k)))
	   test=sing(k).ge.100..or.sing(k).lt..001
	   if (test) write (6,240) k,sing(k),pi,a1,b(k),a2,a3,a4
	   if (.not.test) write (6,250) k,sing(k),pi,a1,b(k),a2,a3,a4
	   go to 140
  130	   write (6,240) k,sing(k)
	   pi=zero
  140		do 150 i=1,n
		a(i,k)=a(i,k)*pi
  150		if (k.gt.1) a(i,k)=a(i,k)+a(i,k-1)
  160	   continue
c
c     compute and print values of ynorm and rnorm.
c
      write (6,300)
      j=0
      ysq=zero
      go to 180
  170 j=j+1
      ysq=ysq+(b(j)/sing(j))**2
  180 ynorm=sqrt(ysq)
      js=minmn1+j
      rnorm=sqrt(sing(js))
      yl=-1000.
      if (ynorm.gt.0.) yl=alog10(ynorm)
      rl=-1000.
      if (rnorm.gt.0.) rl=alog10(rnorm)
      write (6,310) j,ynorm,rnorm,yl,rl
      if (j.lt.nsol) go to 170
c
c     compute values of xnorm and rnorm for a sequence of values of
c     the levenberg-marquardt parameter.
c
      if (sing(1).eq.zero) go to 210
      el=alog10(sing(1))+one
      el2=alog10(sing(nsol))-one
      del=(el2-el)/20.
      ten=10.
      aln10=alog(ten)
      write (6,320)
	   do 200 ie=1,21
c     compute	     alamb=10.**el
	   alamb=exp(aln10*el)
	   ys=0.
	   js=minmn1+nsol
	   rs=sing(js)
		do 190 i=1,minmn
		sl=sing(i)**2+alamb**2
		ys=ys+(b(i)*sing(i)/sl)**2
		rs=rs+(b(i)*(alamb**2)/sl)**2
  190		continue
	   ynorm=sqrt(ys)
	   rnorm=sqrt(rs)
	   rl=-1000.
	   if (rnorm.gt.zero) rl=alog10(rnorm)
	   yl=-1000.
	   if (ynorm.gt.zero) yl=alog10(ynorm)
	   write (6,330) alamb,ynorm,rnorm,el,yl,rl
	   el=el+del
  200	   continue
c
c     print candidate solutions.
c
  210 if (nsol.ge.1) call mfeout (a,mda,n,nsol,names,2)
      return
  220 format (42h0 index  sing. value       p coef         ,48hrecip. s.
     1v.             g coef            g**2  ,39h            c.s.s.
     2    n.s.r.c.s.s.)
  230 format (1h ,5x,1h0,88x,1pe15.4,1pe17.4)
  240 format (1h ,i6,e12.4,1p(e15.4,4x,e15.4,4x,e15.4,4x,e15.4,4x,e15.4,
     12x,e15.4))
  250 format (1h ,i6,f12.4,1p(e15.4,4x,e15.4,4x,e15.4,4x,e15.4,4x,e15.4,
     12x,e15.4))
  260 format (5h0m = ,i6,8h,   n = ,i4,12h,   mdata = ,i8)
  270 format (45h0singular value analysis of the least squares,42h probl
     1em,  a*x=b,  scaled as  (a*d)*y=b  .)
  280 format (19h0scaling option no.,i2,18h.  d is a diagonal,46h matrix
     1 with the following diagonal elements../(5x,10e12.4))
  290 format (50h0scaling option no. 1.   d is the identity matrix./1x)
  300 format (6h0index,13x,28h         ynorm         rnorm,14x,28h  log1
     10(ynorm)  log10(rnorm)/1x)
  310 format (1h ,i4,14x,2e14.5,14x,2f14.5)
  320 format (54h0norms of solution and residual vectors for a range of,
     144h values of the levenberg-marquardt parameter,9h, lambda./1h0,4x
     2,42h        lambda         ynorm         rnorm,42h log10(lambda)
     3log10(ynorm)  log10(rnorm))
  330 format (5x,3e14.5,3f14.5)
      end

      subroutine dodash (valid, array, i, set, j, maxset)
      integer i, j, maxset
      integer valid (100), array (100), set (maxset)
      integer esc
      integer junk, k, limit
      external index
      integer addset, index
      i = i + 1
      j = j - 1
      limit = index (valid, esc (array, i))
      k = index (valid, set (j))
23000 if (.not.(k .le. limit))goto 23002
      junk = addset (valid (k), set, j, maxset)
23001 k = k + 1
      goto 23000
23002 continue
      return
      end

      SUBROUTINE SRFACE (X,Y,Z,M,MX,NX,NY,S,STEREO)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C DIMENSION OF           X(NX),Y(NY),Z(MX,NY),M(2,NX,NY),S(6)
C ARGUMENTS
C
C LATEST REVISION        MARCH 1984
C
C PURPOSE                SRFACE DRAWS A PERSPECTIVE PICTURE OF A
C                        FUNCTION OF TWO VARIABLES WITH HIDDEN LINES
C                        REMOVED.  THE FUNCTION IS APPROXIMATED BY A
C                        TWO-DIMENSIONAL ARRAY OF HEIGHTS.
C
C USAGE                  IF THE FOLLOWING ASSUMPTIONS ARE MET, USE
C                                 CALL EZSRFC (Z,M,N,ANGH,ANGV,WORK)
C
C                          ASSUMPTIONS:
C                                  .THE ENTIRE ARRAY IS TO BE DRAWN,
C                                  .THE DATA IS EQUALLY SPACED (IN THE
C                               X-Y PLANE),
C                                  .NO STEREO PAIRS,
C                                  .SCALING     IS CHOSEN INTERNALLY.
C
C                        IF THESE ASSUMPTIONS ARE NOT MET USE
C                                 CALL SRFACE (X,Y,Z,M,MX,NX,NY,S,
C                                                STEREO)
C
C ARGUMENTS
C
C ON INPUT               Z
C FOR EZSRFC                     THE M BY N ARRAY TO BE DRAWN.
C
C                        M
C                          THE FIRST DIMENSION OF Z.
C
C                        N
C                          THE SECOND DIMENSION OF Z.
C
C                        ANGH
C                          ANGLE IN DEGREES IN THE X-Y PLANE TO THE
C                          LINE OF SIGHT (COUNTER-CLOCK WISE FROM
C                          THE PLUS-X AXIS).
C
C                        ANGV
C                          ANGLE IN DEGREES FROM THE X-Y PLANE TO
C                          THE LINE OF SIGHT (POSITIVE ANGLES ARE
C                          ABOVE THE MIDDLE Z, NEGATIVE BELOW).
C
C                        WORK
C                          A SCRATCH STORAGE DIMENSIONED AT LEAST
C                          2*M*N+M+N.
C
C ON OUTPUT              Z, M, N, ANGH, ANGV ARE UNCHANGED.  WORK
C FOR EZSRFC             HAS BEEN WRITTEN IN.
C
C
C ARGUMENTS
C
C ON INPUT               X
C FOR SRFACE                     A LINEAR ARRAY NX LONG CONTAINING THE X
C                          COORDINATES OF THE POINTS IN THE SURFACE
C                          APPROXIMATION.  SEE NOTE, BELOW.
C
C                        Y
C                          THE LINEAR ARRAY NY LONG CONTAINING THE
C                          Y COORDINATES OF THE POINTS IN THE
C                          SURFACE APPROXIMATION.  SEE NOTE, BELOW.
C
C                        Z
C                          AN ARRAY MX BY NY CONTAINING THE SURFACE
C                          TO BE DRAWN IN NX BY NY CELLS.
C                          Z(I,J) = F(X(I),Y(J)).  SEE NOTE, BELOW.
C
C                        M
C                          SCRATCH ARRAY AT LEAST 2*NX*NY WORDS
C                          LONG.
C
C                        MX
C                          FIRST DIMENSION OF Z.
C
C                        NX
C                          NUMBER OF POINTS IN THE X DIRECTION
C                          IN Z.  WHEN PLOTTING AN ENTIRE ARRAY,
C                          MX=NX.  SEE APPENDIX 1 OF THE GRAPHICS
C                          CHAPTER FOR AN EXPLANATION OF USING THIS
C                          ARGUMENT LIST TO PROCESS ANY PART OF AN
C                          ARRAY.
C
C                        NY
C                          NUMBER OF POINTS IN THE Y DIRECTION IN Z.
C
C                        S
C                          S DEFINES THE LINE OF SIGHT.  THE VIEWER'S
C                          EYE IS AT (S(1), S(2), S(3)) AND THE
C                          POINT LOOKED AT IS AT (S(4), S(5), S(6)).
C                          THE EYE SHOULD BE OUTSIDE THE BLOCK WITH
C                          OPPOSITE CORNERS (X(1), Y(1), ZMIN) AND
C                          (X(NX), Y(NY), ZMAX) AND THE POINT LOOKED
C                          AT SHOULD BE INSIDE IT.      FOR     A NICE
C                          PERSPECTIVE EFFECT, THE DISTANCE BETWEEN
C                          THE EYE AND THE POINT LOOKED AT SHOULD BE
C                          5 TO 10 TIMES THE SIZE OF THE BLOCK.  SEE
C                          NOTE, BELOW.
C
C                        STEREO
C                          FLAG TO INDICATE IF STEREO PAIRS ARE TO
C                          BE DRAWN.  0.0 MEANS NO STEREO PAIR (ONE
C                          PICTURE).  NON-ZERO MEANS PUT OUT TWO
C                          PICTURES.  THE VALUE OF STEREO IS THE
C                          RELATIVE ANGLE BETWEEN THE EYES.  A VALUE
C                          OF 1.0 PRODUCES STANDARD SEPARATION.
C                          NEGATIVE STEREO REVERSES THE LEFT AND
C                          RIGHT FIGURES.
C
C ON OUTPUT              X, Y, Z, MX, NX, NY, S, STEREO ARE
C FOR SRFACE             UNCHANGED.  M HAS BEEN WRITTEN IN.
C
C NOTES                  . THE RANGE OF Z COMPARED WITH THE RANGE
C                          OF X AND Y DETERMINES THE SHAPE OF THE
C                          PICTURE.  THEY ARE ASSUMED TO BE IN THE
C                          SAME UNITS AND NOT WILDLY DIFFERENT IN
C                          MAGNITUDE.  S IS ASSUMED TO BE IN THE
C                          SAME UNITS AS X, Y, AND Z.
C                        . PICTURE SIZE CAN BE MADE RELATIVE TO
C                          DISTANCE.  SEE COMMENTS IN SETR.
C                        . TRN32S CAN BE USED TO TRANSLATE FROM 3
C                          SPACE TO 2 SPACE.  SEE COMMENTS THERE.
C                        . DATA WITH EXTREME DISCONTINUITIES MAY
C                          CAUSE VISIBILITY ERRORS.  IF THIS PROBLEM
C                          OCCURS, USE A DISTANT EYE POSITION
C                          AWAY FROM THE +Z AXIS.
C                        . THE DEFAULT LINE COLOR IS SET TO
C                          COLOR INDEX 1.  IF THE USER WISHES TO
C                          CHANGE THE LINE COLOR, HE CAN DO SO BY
C                          DEFINING COLOR INDEX 1 BEFORE CALLING
C                          SRFACE, OR BY PUTTING THE COMMON BLOCK
C                          SRFINT IN HIS CALLING PROGRAM AND
C                          DEFINING AND USING COLOR INDEX ISRFMJ
C                          (DEFAULTED TO 1 IN BLOCKDATA.)
C
C ENTRY POINTS           SRFACE, SRFGK, EZSRFC, SETR, DRAWS, TRN32S,
C                        CLSET, CTCELL, SRFABD
C
C COMMON BLOCKS          PWRZ1S, SRFBLK, SRFINT, SRFIP1
C
C I/O                    PLOTS
C
C PRECISION              SINGLE
C
C LANGUAGE               FORTRAN
C
C HISTORY                CONVERTED TO FORTRAN 77 AND GKS IN MARCH 1984.
C
C                        PREPARED FOR SIGGRAPH, AUGUST 1976.
C
C                        STANDARDIZED IN JANUARY 1973.
C
C                        WRITTEN IN DECEMBER 1971.      REPLACED K.S.+G.
C                        ALGORITHM CALLED SOLIDS AT NCAR.
C
C
C ALGORITHM              HIGHEST SO FAR IS VISIBLE FROM ABOVE.  (SEE
C                        REFERENCE.)
C
C REFERENCE              WRIGHT, T.J., A TWO SPACE SOLUTION TO THE
C                        HIDDEN LINE PROBLEM FOR PLOTTING A FUNCTION
C                        OF TWO VARIABLES.      IEEE TRANS.     COMP.,
C                        PP 28-33, JANUARY 1973.
C
C ACCURACY               IF THE ENDS OF A LINE SEGMENT ARE VISIBLE,
C                        THE MIDDLE IS ASSUMED VISIBLE.
C
C TIMING                 PROPORTIONAL TO NX*NY.
C
C
C INTERNAL PARAMETERS    NAME   DEFAULT  FUNCTION
C                        ----   -------  --------
C                        IFR        1    -1  CALL FRAME FIRST.
C                                         0  DO NOT CALL FRAME.
C                                        +1  CALL FRAME WHEN DONE.
c +NOAO:  The value of ifr has been changed from its default of +1 to 0.
c -NOAO
C
C                        ISTP       0    STEREO TYPE IF STEREO
C                                        NON-ZERO.
C                                        -1  ALTERNATING FRAMES,
C                                                  SLIGHTLY OFFSET (FOR
C                                                  MOVIES.  IROTS = 0).
C                                               0  BLANK FRAME BETWEEN
C                                                  FOR STEREO   SLIDE.
C                                                  IROTS = 1).
C                                        +1  BOTH ON SAME FRAME.
C                                                  (LEFT PICTURE TO LEFT
C                                                  SIDE.  IROTS = 0).
C
C                        IROTS      0     0  +Z IN VERTICAL PLOTTING
C                                                  DIRECTION (CINE MODE).
C                                        +1  +Z IN HORIZONTAL
C                                                  PLOTTING DIRECTION
C                                                  (COMIC MODE).
C
C                        IDRX       1    +1  DRAW LINES OF CONSTANT
C                                                  X.
C                                               0  DO   NOT.
C
C                        IDRY       1    +1  DRAW LINES OF CONSTANT
C                                                  Y.
C                                               0  DO   NOT.
C
C                        IDRZ       0    +1  DRAW LINES OF CONSTANT
C                                                  Z (CONTOUR   LINES).
C                                               0  DO   NOT.
C
C                        IUPPER         0        +1  DRAW UPPER SIDE OF
C                                                  SURFACE.
C                                        0  DRAW BOTH SIDES.
C                                        -1  DRAW LOWER SIDE.
C
C                        ISKIRT         0        +1  DRAW A SKIRT AROUND THE
C                                                  SURFACE.
C                                                  BOTTOM = HSKIRT.
C                                               0  DO   NOT.
C
C                        NCLA       6    APPROXIMATE NUMBER OF
C                                        LEVELS OF CONSTANT Z THAT
C                                        ARE DRAWN IF LEVELS ARE NOT
C                                        SPECIFIED.  40 LEVELS
C                                        MAXIMUM.
C
C                        THETA    .02    ANGLE IN RADIANS BETWEEN
C                                        EYES FOR STEREO PAIRS.
C
C                        HSKIRT    0.    HEIGHT OF SKIRT
C                                                  (IF ISKIRT   = 1).
C
C                        CHI       0.    HIGHEST LEVEL OF CONSTANT
C                                        Z.
C
C                        CLO       0.    LOWEST LEVEL OF CONSTANT Z.
C
C                        CINC      0.    INCREMENT BETWEEN LEVELS.
C
C                          [IF CHI, CLO, OR CINC IS ZERO, A NICE
C                               VALUE IS GENERATED AUTOMATICALLY.]
C
C                        IOFFP     0     FLAG TO CONTROL USE OF SPECIAL
C                                        VALUE FEATURE.  DO NOT HAVE
C                                        BOTH IOFFP=1 AND ISKIRT=1.
C                                               0 FEATURE NOT   IN USE
C                                        +1  FEATURE IN USE.  NO LINES
C                                                  DRAWN TO DATA POINTS IN Z
C                                                  THAT ARE EQUAL TO SPVAL.
C
C                        SPVAL     0.    SPECIAL VALUE USED TO MARK UN-
C                                        KNOWN DATA WHEN IOFFP=1.
C
C
C
      DIMENSION       X(NX)      ,Y(NY)    ,Z(MX,NY), M(2,NX,NY),
     1                S(6)
      DIMENSION       WIN1(4)    ,VP1(4)           ,LASF(13)
      COMMON /SRFINT/ ISRFMJ     ,ISRFMN          ,ISRFTX
c +NOAO: common block added 4NOV85 to allow user control of viewport
      common /noaovp/ vpx1, vpx2, vpy1, vpy2
c -NOAO
c +NOAO: Blockdata srfabd rewritten as run time initialization
c     EXTERNAL        SRFABD
      call srfabd
c -NOAO
      CALL Q8QST4 ('GRAPHX','SRFACE','SRFACE','VERSION 01')
C
C     THIS DRIVER SAVES THE CURRENT NORMALIZATION TRANSFORMATION
C     INFORMATION, DEFINES THE NORMALIZATION TRANSFORMATION
C     APPROPRIATE FOR SRFGK, CALLS SRFGK, AND RESTORES THE ORIGINAL
C     NORMALIZATION TRANSFORMATION.
C
C     GET CURRENT NORMALIZATION TRANSFORMATION NUMBER
C
      CALL GQCNTN (IER,NTORIG)
C
C     STORE WINDOW AND VIEWPORT OF NORMALIZATION TRANSFORMATION 1
C
      CALL GQNT (NTORIG,IER,WIN1,VP1)
      CALL GETUSV('LS',IOLLS)
C
C     SET WINDOW AND VIEWPORT FOR SRFGK
C
c     CALL SET(0.,1.,0.,1.,1.,1024.,1.,1024.,1)
c +NOAO: viewport limits now stored in common block noaovp
      CALL SET(vpx1, vpx2, vpy1, vpy2, 1.0, 1024., 1.0, 1024., 1)
c -NOAO
C
C     SET LINE COLOR TO INDIVIDUAL (SAVE CURRENT SETTING)
C
      CALL GQASF (IER,LASF)
      LASFSV  = LASF(3)
      LASF(3) = 1
      CALL GSASF(LASF)
C
C     SET LINE COLOR INDEX TO COMMON VARIABLE ISRFMJ (SAVE
C     CURRENT SETTING)
C
      CALL GQPLCI (IER,LCISV)
      CALL GSPLCI (ISRFMJ)
C
C     DRAW PLOT
C
      CALL SRFGK (X,Y,Z,M,MX,NX,NY,S,STEREO)
C
C     RESTORE INITIAL LINE COLOR SETTINGS
C
      LASF(3) = LASFSV
      CALL GSASF(LASF)
      CALL GSPLCI (LCISV)
C
C     RESTORE ORIGINAL NORMALIZATION TRANSFORMATION
C
      CALL SET(VP1(1),VP1(2),VP1(3),VP1(4),WIN1(1),WIN1(2),
     -         WIN1(3),WIN1(4),IOLLS)
      CALL GSELNT (NTORIG)
C
      RETURN
      END
      SUBROUTINE SRFGK (X,Y,Z,M,MX,NX,NY,S,STEREO)
C
      DIMENSION       X(NX)      ,Y(NY)   ,Z(MX,NY)  ,M(2,NX,NY) ,
     1                S(6)
      DIMENSION       MXS(2)     ,MXF(2) ,MXJ(2) ,MYS(2),
     1                MYF(2)     ,MYJ(2)
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL,
     1                LL         ,FACT       ,IROT       ,NDRZ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      COMMON /PWRZ1S/ XXMIN      ,XXMAX      ,YYMIN      ,YYMAX,
     1                ZZMIN      ,ZZMAX      ,DELCRT     ,EYEX,
     2                EYEY       ,EYEZ
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX ,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI,
     3                CLO        ,CINC       ,ISPVAL
c +NOAO:
      common /noaovp/ vpx1, vpx2, vpy1, vpy2
c -NOAO
C
      DATA JF, IF, LY, LX, ICNST /1, 1, 2, 2, 0/
      CALL Q8QST4 ('GRAPHX','SRFACE','SRFGK','VERSION 01')
      BIGEST = R1MACH(2)
      MMXX = MX
      NNXX = NX
      NNYY = NY
      STER = STEREO
      NXP1 = NNXX+1
      NYP1 = NNYY+1
      NLA = NCLA
      NSPVAL = ISPVAL
      NDRZ = IDRZ
      IF (IDRZ .NE. 0)
     1    CALL CLSET (Z,MMXX,NNXX,NNYY,CHI,CLO,CINC,NLA,40,CL,NCL,
     2                ICNST,IOFFP,SPVAL,BIGEST)
      IF (IDRZ .NE. 0) NDRZ = 1-ICNST
      STHETA = SIN(STER*THETA)
      CTHETA = COS(STER*THETA)
      RX = S(1)-S(4)
      RY = S(2)-S(5)
      RZ = S(3)-S(6)
      D1 = SQRT(RX*RX+RY*RY+RZ*RZ)
      D2 = SQRT(RX*RX+RY*RY)
      DX = 0.
      DY = 0.
      IF (STEREO .EQ. 0.) GO TO  20
      D1 = D1*STEREO*THETA
      IF (D2 .GT. 0.) GO TO  10
      DX = D1
      GO TO  20
   10 AGL = ATAN2(RX,-RY)
      DX = D1*COS(AGL)
      DY = D1*SIN(AGL)
   20 IROT = IROTS
      NPIC = 1
      IF (STER .NE. 0.) NPIC = 2
      FACT = 1.
      IF (NRSWT .NE. 0) FACT = RZERO/D1
      IF (ISTP.EQ.0 .AND. STER.NE.0.) IROT = 1
      DO 570 IPIC=1,NPIC
         NUPPER = IUPPER
         IF (IFR .LT. 0) CALL FRAME
C
C SET UP MAPING FROM FLOATING POINT 3-SPACE TO CRT SPACE.
C
         SIGN1 = IPIC*2-3
         EYEX = S(1)+SIGN1*DX
         POIX = S(4)+SIGN1*DX
         EYEY = S(2)+SIGN1*DY
         POIY = S(5)+SIGN1*DY
         EYEZ = S(3)
         POIZ = S(6)
         LL = 0
         XEYE = EYEX
         YEYE = EYEY
         ZEYE = EYEZ
         CALL TRN32S (POIX,POIY,POIZ,XEYE,YEYE,ZEYE,0)
         LL = IPIC+2*ISTP+3
         IF (STER .EQ. 0.) LL = 1
         IF (NRSWT .NE. 0) GO TO 100
         XXMIN = X(1)
         XXMAX = X(NNXX)
         YYMIN = Y(1)
         YYMAX = Y(NNYY)
         UMIN = BIGEST
         VMIN = BIGEST
         ZZMIN = BIGEST
         UMAX = -UMIN
         VMAX = -VMIN
         ZZMAX = -ZZMIN
         DO  40 J=1,NNYY
            DO  30 I=1,NNXX
                ZZ = Z(I,J)
                IF (IOFFP.EQ.1 .AND. ZZ.EQ.SPVAL) GO TO 30
                ZZMAX = AMAX1(ZZMAX,ZZ)
                ZZMIN = AMIN1(ZZMIN,ZZ)
                CALL TRN32S (X(I),Y(J),Z(I,J),UT,VT,DUMMY,1)
                UMAX = AMAX1(UMAX,UT)
                UMIN = AMIN1(UMIN,UT)
                VMAX = AMAX1(VMAX,VT)
                VMIN = AMIN1(VMIN,VT)
   30             CONTINUE
   40    CONTINUE
         IF (ISKIRT .NE. 1) GO TO  70
         NXSTP = NNXX-1
         NYSTP = NNYY-1
         DO  60 J=1,NNYY,NYSTP
            DO  50 I=1,NNXX,NXSTP
                CALL TRN32S (X(I),Y(J),HSKIRT,UT,VT,DUMMY,1)
                UMAX = AMAX1(UMAX,UT)
                UMIN = AMIN1(UMIN,UT)
                VMAX = AMAX1(VMAX,VT)
                VMIN = AMIN1(VMIN,VT)
   50             CONTINUE
   60    CONTINUE
   70    CONTINUE
         WIDTH = UMAX-UMIN
         HIGHT = VMAX-VMIN
         DIF = .5*(WIDTH-HIGHT)
         IF (DIF)  80,100, 90
   80    UMIN = UMIN+DIF
         UMAX = UMAX-DIF
         GO TO 100
   90    VMIN = VMIN-DIF
         VMAX = VMAX+DIF
  100    XEYE = EYEX
         YEYE = EYEY
         ZEYE = EYEZ
         CALL TRN32S (POIX,POIY,POIZ,XEYE,YEYE,ZEYE,0)
         DO 120 J=1,NNYY
            DO 110 I=1,NNXX
                CALL TRN32S (X(I),Y(J),Z(I,J),UT,VT,DUMMY,1)
                M(1,I,J)        = UT
                M(2,I,J)        = VT
  110             CONTINUE
  120    CONTINUE
C
C INITIALIZE UPPER AND LOWER VISIBILITY ARRAYS
C
         DO 130 K=1,1024
            LIMU(K) = 0
            LIML(K) = 1024
  130    CONTINUE
C
C FIND ORDER TO DRAW LINES
C
         NXPASS = 1
         IF (S(1) .GE. X(NNXX)) GO TO 160
         IF (S(1) .LE. X(1)) GO TO 170
         DO 140 I=2,NNXX
            LX = I
            IF (S(1) .LE. X(I)) GO TO 150
  140    CONTINUE
  150    MXS(1) = LX-1
         MXJ(1) = -1
         MXF(1) = 1
         MXS(2) = LX
         MXJ(2) = 1
         MXF(2) = NNXX
         NXPASS = 2
         GO TO 180
  160    MXS(1) = NNXX
         MXJ(1) = -1
         MXF(1) = 1
         GO TO 180
  170    MXS(1) = 1
         MXJ(1) = 1
         MXF(1) = NNXX
  180    NYPASS = 1
         IF (S(2) .GE. Y(NNYY)) GO TO 210
         IF (S(2) .LE. Y(1)) GO TO 220
         DO 190 J=2,NNYY
            LY = J
            IF (S(2) .LE. Y(J)) GO TO 200
  190    CONTINUE
  200    MYS(1) = LY-1
         MYJ(1) = -1
         MYF(1) = 1
         MYS(2) = LY
         MYJ(2) = 1
         MYF(2) = NNYY
         NYPASS = 2
         GO TO 230
  210    MYS(1) = NNYY
         MYJ(1) = -1
         MYF(1) = 1
         GO TO 230
  220    MYS(1) = 1
         MYJ(1) = 1
         MYF(1) = NNYY
C
C PUT ON SKIRT ON FRONT SIDE IF WANTED
C
  230    IF (NXPASS.EQ.2 .AND. NYPASS.EQ.2) GO TO 490
         IF (ISKIRT .EQ. 0) GO TO 290
         IN = MXS(1)
         IF = MXF(1)
         JN = MYS(1)
         JF = MYF(1)
         IF (NYPASS .NE. 1) GO TO 260
         CALL TRN32S (X(1),Y(JN),HSKIRT,UX1,VX1,DUMMY,1)
         CALL TRN32S (X(NNXX),Y(JN),HSKIRT,UX2,VX2,DUMMY,1)
         QU = (UX2-UX1)/(X(NNXX)-X(1))
         QV = (VX2-VX1)/(X(NNXX)-X(1))
         YNOW = Y(JN)
         DO 240 I=1,NNXX
            CALL TRN32S (X(I),YNOW,HSKIRT,RU,RV,DUMMY,1)
            CALL DRAWS (IFIX(RU),IFIX(RV),M(1,I,JN),M(2,I,JN),1,0)
  240    CONTINUE
         CALL DRAWS (IFIX(UX1),IFIX(VX1),IFIX(UX2),IFIX(VX2),1,1)
         IF (IDRY .NE. 0) GO TO 260
         DO 250 I=2,NNXX
            CALL DRAWS (M(1,I-1,JN),M(2,I-1,JN),M(1,I,JN),M(2,I,JN),1,1)
  250    CONTINUE
  260    IF (NXPASS .NE. 1) GO TO 290
         CALL TRN32S (X(IN),Y(1),HSKIRT,UY1,VY1,DUMMY,1)
         CALL TRN32S (X(IN),Y(NNYY),HSKIRT,UY2,VY2,DUMMY,1)
         QU = (UY2-UY1)/(Y(NNYY)-Y(1))
         QV = (VY2-VY1)/(Y(NNYY)-Y(1))
         XNOW = X(IN)
         DO 270 J=1,NNYY
            CALL TRN32S (XNOW,Y(J),HSKIRT,RU,RV,DUMMY,1)
            CALL DRAWS (IFIX(RU),IFIX(RV),M(1,IN,J),M(2,IN,J),1,0)
  270    CONTINUE
         CALL DRAWS (IFIX(UY1),IFIX(VY1),IFIX(UY2),IFIX(VY2),1,1)
         IF (IDRX .NE. 0) GO TO 290
         DO 280 J=2,NNYY
            CALL DRAWS (M(1,IN,J-1),M(2,IN,J-1),M(1,IN,J),M(2,IN,J),1,1)
  280    CONTINUE
C
C PICK PROPER ALGORITHM
C
  290    LI = MXJ(1)
         MI = MXS(1)-LI
         NI = IABS(MI-MXF(1))
         LJ = MYJ(1)
         MJ = MYS(1)-LJ
         NJ = IABS(MJ-MYF(1))
C
C WHEN LINE OF SIGHT IS NEARER TO PARALLEL TO THE X AXIS,
C HAVE J LOOP OUTER-MOST, OTHERWISE HAVE I LOOP OUTER-MOST.
C
         IF (ABS(RX) .LE. ABS(RY)) GO TO 360
         IF (ISKIRT.NE.0 .OR. NYPASS.NE.1) GO TO 310
         I = MXS(1)
         DO 300 J=2,NNYY
            CALL DRAWS (M(1,I,J-1),M(2,I,J-1),M(1,I,J),M(2,I,J),0,1)
  300    CONTINUE
  310    DO 350 II=1,NNXX
            I = MI+II*LI
            IPLI = I+LI
            IF (NYPASS .EQ. 1) GO TO 320
            K = MYS(1)
            L = MYS(2)
            IF (IDRX .NE. 0)
     1          CALL DRAWS (M(1,I,K),M(2,I,K),M(1,I,L),M(2,I,L),1,1)
            IF (NDRZ.NE.0 .AND. II.NE.NI)
     1          CALL CTCELL (Z,MMXX,NNXX,NNYY,M,MIN0(I,I+LI),K)
  320             DO 340 JPASS=1,NYPASS
                LJ = MYJ(JPASS)
                MJ = MYS(JPASS)-LJ
                NJ = IABS(MJ-MYF(JPASS))
                DO 330 JJ=1,NJ
                  J = MJ+JJ*LJ
                  JPLJ = J+LJ
                  IF (IDRX.NE.0 .AND. JJ.NE.NJ)
     1                CALL DRAWS (M(1,I,J),M(2,I,J),M(1,I,JPLJ),
     2                            M(2,I,JPLJ),1,1)
                  IF (I.NE.MXF(1) .AND. IDRY.NE.0)
     1                CALL DRAWS (M(1,IPLI,J),M(2,IPLI,J),M(1,I,J),
     2                            M(2,I,J),1,1)
                  IF (NDRZ.NE.0 .AND. JJ.NE.NJ .AND. II.NE.NNXX)
     1                CALL CTCELL (Z,MMXX,NNXX,NNYY,M,MIN0(I,I+LI),
     2                             MIN0(J,J+LJ))
  330                CONTINUE
  340             CONTINUE
  350    CONTINUE
         GO TO 430
  360    IF (ISKIRT.NE.0 .OR. NXPASS.NE.1) GO TO 380
         J = MYS(1)
         DO 370 I=2,NNXX
            CALL DRAWS (M(1,I-1,J),M(2,I-1,J),M(1,I,J),M(2,I,J),0,1)
  370    CONTINUE
  380    DO 420 JJ=1,NNYY
            J = MJ+JJ*LJ
            JPLJ = J+LJ
            IF (NXPASS .EQ. 1) GO TO 390
            K = MXS(1)
            L = MXS(2)
            IF (IDRY .NE. 0)
     1          CALL DRAWS (M(1,K,J),M(2,K,J),M(1,L,J),M(2,L,J),1,1)
            IF (NDRZ.NE.0 .AND. JJ.NE.NJ)
     1          CALL CTCELL (Z,MMXX,NNXX,NNYY,M,K,MIN0(J,J+LJ))
  390             DO 410 IPASS=1,NXPASS
                LI = MXJ(IPASS)
                MI = MXS(IPASS)-LI
                NI = IABS(MI-MXF(IPASS))
                DO 400 II=1,NI
                  I = MI+II*LI
                  IPLI = I+LI
                  IF (IDRY.NE.0 .AND. II.NE.NI)
     1                CALL DRAWS (M(1,I,J),M(2,I,J),M(1,IPLI,J),
     2                            M(2,IPLI,J),1,1)
                  IF (J.NE.MYF(1) .AND. IDRX.NE.0)
     1                CALL DRAWS (M(1,I,JPLJ),M(2,I,JPLJ),M(1,I,J),
     2                            M(2,I,J),1,1)
                  IF (NDRZ.NE.0 .AND. II.NE.NI .AND. JJ.NE.NNYY)
     1                CALL CTCELL (Z,MMXX,NNXX,NNYY,M,MIN0(I,I+LI),
     2                             MIN0(J,J+LJ))
  400                CONTINUE
  410             CONTINUE
  420    CONTINUE
  430    IF (ISKIRT .EQ. 0) GO TO 520
C
C FIX UP IF SKIRT IS USED WITH LINES ONE WAY.
C
         IF (IDRX .NE. 0) GO TO 460
         DO 450 IPASS=1,NXPASS
            IF (NXPASS .EQ. 2) IF = 1+(IPASS-1)*(NNXX-1)
            DO 440 J=2,NNYY
                CALL DRAWS (M(1,IF,J-1),M(2,IF,J-1),M(1,IF,J),M(2,IF,J),
     1                     1,0)
  440             CONTINUE
  450    CONTINUE
  460    IF (IDRY .NE. 0) GO TO 520
         DO 480 JPASS=1,NYPASS
            IF (NYPASS .EQ. 2) JF = 1+(JPASS-1)*(NNYY-1)
            DO 470 I=2,NNXX
                CALL DRAWS (M(1,I-1,JF),M(2,I-1,JF),M(1,I,JF),M(2,I,JF),
     1                     1,0)
  470             CONTINUE
  480    CONTINUE
         GO TO 520
C
C ALL VISIBLE IF VIEWED FROM DIRECTLY ABOVE OR BELOW.
C
  490    IF (NUPPER.GT.0 .AND. S(3).LT.S(6)) GO TO 520
         IF (NUPPER.LT.0 .AND. S(3).GT.S(6)) GO TO 520
         NUPPER = 1
         IF (S(3) .LT. S(6)) NUPPER = -1
         DO 510 I=1,NNXX
            DO 500 J=1,NNYY
                IF (IDRX.NE.0 .AND. J.NE.NNYY)
     1             CALL DRAWS (M(1,I,J),M(2,I,J),M(1,I,J+1),M(2,I,J+1),
     2                          1,0)
                IF (IDRY.NE.0 .AND. I.NE.NNXX)
     1             CALL DRAWS (M(1,I,J),M(2,I,J),M(1,I+1,J),M(2,I+1,J),
     2                          1,0)
                IF (IDRZ.NE.0 .AND. I.NE.NNXX .AND. J.NE.NNYY)
     1             CALL CTCELL (Z,MMXX,NNXX,NNYY,M,I,J)
  500             CONTINUE
  510    CONTINUE
  520    IF (STER .EQ. 0.) GO TO 560
         IF (ISTP) 540,530,550
  530    CALL FRAME
  540    CALL FRAME
         GO TO 570
  550    IF (IPIC .NE. 2) GO TO 570
  560    IF (IFR .GT. 0) CALL FRAME
  570 CONTINUE
      RETURN
      END
      SUBROUTINE EZSRFC (Z,M,N,ANGH,ANGV,WORK)
      DIMENSION       Z(M,N)     ,WORK(1)
C
C                         WORK(2*M*N+M+N)
C
C PERSPECTIVE PICTURE OF A SURFACE STORED IN A TWO DIMENSIONAL ARRAY
C VIA A VERY SHORT ARGUMENT LIST.
C
C ASSUMPTIONS--
C     THE ENTIRE ARRAY IS TO BE DRAWN,
C     THE DATA IS EQUALLY SPACED (IN THE X-Y PLANE),
C     NO STEREO PAIRS.
C IF THESE ASSUMPTIONS ARE NOT MET USE SRFACE.
C
C ARGUMENTS--
C     Z    THE 2 DIMENSIONAL ARRAY TO BE DRAWN.
C     M    THE FIRST DIMENSION OF Z.
C     N    THE SECOND DIMENSION OF Z.
C     ANGH ANGLE IN DEGREES IN THE X-Y PLANE TO THE LINE OF SIGHT
C          (COUNTER-CLOCK WISE FROM THE PLUS-X AXIS).
C     ANGV ANGLE IN DEGREES FROM THE X-Y PLANE TO THE LINE OF SIGHT
C          (POSITIVE ANGLES ARE ABOVE THE MIDDLE Z, NEGATIVE BELOW).
C     WORK A SCRATCH STORAGE DIMENSIONED AT LEAST 2*M*N+M+N.
C
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL,
     1                LL         ,FACT       ,IROT       ,NDRZ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO,
     4                NOFFP      ,NSPVAL     ,SPV        ,BIGEST
      DIMENSION       S(6)
      DATA S(4),S(5),S(6)/0.0,0.0,0.0/
C
C  FACT1 IS THE PERSPECTIVE RATIO AND IS DEFINED TO BE THE RATIO
C         MAXIMUM(LENGTH,WIDTH)/HEIGHT
C
C  FACT2 IS THE RATIO   (LENGTH OF LINE OF SIGHT)/MAXIMUM(LENGTH,WIDTH)
C
      DATA FACT1,FACT2/2.0,5.0/
      BIGEST = R1MACH(2)
C
C FIND RANGE OF Z
C
      MX = M
      NY = N
      ANG1 = ANGH*3.14159265358979/180.
      ANG2 = ANGV*3.14159265358979/180.
      FLO = BIGEST
      HI = -FLO
      DO  20 J=1,NY
         DO  10 I=1,MX
            IF (NOFFP.EQ.1 .AND. Z(I,J).EQ.SPV) GO TO   10
            HI = AMAX1(Z(I,J),HI)
            FLO = AMIN1(Z(I,J),FLO)
   10    CONTINUE
   20 CONTINUE
C
C SET UP LINEAR X AND Y ARRAYS FOR SRFACE
C
      DELTA = (HI-FLO)/(AMAX0(MX,NY)-1.)*FACT1
      XMIN = -(FLOAT(MX/2)*DELTA+FLOAT(MOD(MX+1,2))*DELTA)
      YMIN = -(FLOAT(NY/2)*DELTA+FLOAT(MOD(NY+1,2))*DELTA)
      DO  30 I=1,MX
         WORK(I) = XMIN+FLOAT(I-1)*DELTA
   30 CONTINUE
      DO  40 J=1,NY
         K = MX+J
         WORK(K) = YMIN+FLOAT(J-1)*DELTA
   40 CONTINUE
C
C SET UP EYE POSITION
C
      FACTE = (HI-FLO)*FACT1*FACT2
      CANG2 = COS(ANG2)
      S(1) = FACTE*CANG2*COS(ANG1)
      S(2) = FACTE*CANG2*SIN(ANG1)
      S(3) = FACTE*SIN(ANG2)+(FLO+HI)*.5
C
C READY
C
      CALL SRFACE (WORK(1),WORK(MX+1),Z,WORK(K+1),MX,MX,NY,S,0.)
      RETURN
      END
      SUBROUTINE SETR (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,R0)
C
C THIS ROUTINE ESTABLISHES CERTAIN CONSTANTS SO THAT SRFACE
C PRODUCES A PICTURE WHOSE SIZE CHANGES WITH RESPECT TO THE
C VIEWERS DISTANCE FROM THE OBJECT.  IT CAN ALSO BE USED
C WHEN MAKING A MOVIE OF AN OBJECT EVOLVING IN TIME TO KEEP
C IT POSITIONED PROPERLY ON THE SCREEN, SAVING COMPUTER TIME
C IN THE BARGIN.  CALL IT WITH R0 NEGATIVE TO TURN OFF THIS
C FEATURE.
C PARAMETERS
C XMIN,XMAX - RANGE OF X ARRAY THAT WILL BE PASSED TO SRFACE.
C YMIN,YMAX - SAME IDEA, BUT FOR Y.
C ZMIN,ZMAX - SAME IDEA, BUT FOR Z.  IF A MOVIE IS BEING
C               MADE OF AN EVOLVING Z ARRAY, ZMIN       AND ZMAX
C               SHOULD CONTAIN RANGE OF THE UNION       OF ALL THE Z
C               ARRAYS.  THEY NEED NOT BE       EXACT.
C R0             - DISTANCE BETWEEN OBSERVER    AND POINT LOOKED AT
C               WHEN THE PICTURE IS TO FILL THE SCREEN WHEN
C               VIEWED FROM THE DIRECTION       WHICH MAKES THE PIC-
C               TURE BIGGEST.  IF       R0 IS NOT POSITIVE, THEN THE
C               RELATIVE SIZE FEATURE IS TURNED OFF, AND SUB-
C               SEQUENT PICTURES WILL FILL THE SCREEN.
C
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL,
     1                LL         ,FACT       ,IROT       ,NDRZ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      COMMON /PWRZ1S/ XXMIN      ,XXMAX      ,YYMIN      ,YYMAX,
     1                ZZMIN      ,ZZMAX      ,DELCRT     ,EYEX,
     2                EYEY       ,EYEZ
C
C
      CALL Q8QST4 ('GRAPHX','SRFACE','SETR','VERSION 01')
      IF (R0)  10, 10, 20
   10 NRSWT = 0
      RETURN
   20 NRSWT = 1
      XXMIN = XMIN
      XXMAX = XMAX
      YYMIN = YMIN
      YYMAX = YMAX
      ZZMIN = ZMIN
      ZZMAX = ZMAX
      RZERO = R0
      LL = 0
      XAT = (XXMAX+XXMIN)*.5
      YAT = (YYMAX+YYMIN)*.5
      ZAT = (ZZMAX+ZZMIN)*.5
      ALPHA = -(YYMIN-YAT)/(XXMIN-XAT)
      YEYE = -RZERO/SQRT(1.+ALPHA*ALPHA)
      XEYE = YEYE*ALPHA
      YEYE = YEYE+YAT
      XEYE = XEYE+XAT
      ZEYE = ZAT
      CALL TRN32S (XAT,YAT,ZAT,XEYE,YEYE,ZEYE,0)
      XMN = XXMIN
      XMX = XXMAX
      YMN = YYMIN
      YMX = YYMAX
      ZMN = ZZMIN
      ZMX = ZZMAX
      CALL TRN32S (XMN,YMN,ZAT,UMN,DUMMY,DUMMIE,1)
      CALL TRN32S (XMX,YMN,ZMN,DUMMY,VMN,DUMMIE,1)
      CALL TRN32S (XMX,YMX,ZAT,UMX,DUMMY,DUMMIE,1)
      CALL TRN32S (XMX,YMN,ZMX,DUMMY,VMX,DUMMIE,1)
      UMIN = UMN
      UMAX = UMX
      VMIN = VMN
      VMAX = VMX
      BIGD = SQRT((XXMAX-XXMIN)**2+(YYMAX-YYMIN)**2+(ZZMAX-ZZMIN)**2)*.5
      RETURN
      END
      SUBROUTINE DRAWS (MX1,MY1,MX2,MY2,IDRAW,IMARK)
C
C THIS ROUTINE DRAWS THE VISIBLE PART OF THE LINE CONNECTING
C (MX1,MY1) AND (MX2,MY2).  IF IDRAW .NE. 0, THE LINE IS DRAWN.
C IF IMARK .NE. 0, THE VISIBILITY ARRAY IS MARKED.
C
      LOGICAL               VIS1         ,VIS2
      DIMENSION       PXS(2)     ,PYS(2)
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL,
     1                LL         ,FACT       ,IROT       ,NDRZ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      DATA STEEP/5./
      DATA MX, MY /0, 0/
C
c +NOAO: Blockdata srfabd rewritten as run time initialization
c     EXTERNAL        SRFABD
      call srfabd
c -NOAO
C MAKE LINE LEFT TO RIGHT.
C
      MMX1 = MX1
      MMY1 = MY1
      MMX2 = MX2
      MMY2 = MY2
      IF (MMX1.EQ.NSPVAL .OR. MMX2.EQ.NSPVAL) RETURN
      IF (MMX1 .GT. MMX2) GO TO  10
      NX1 = MMX1
      NY1 = MMY1
      NX2 = MMX2
      NY2 = MMY2
      GO TO  20
   10 NX1 = MMX2
      NY1 = MMY2
      NX2 = MMX1
      NY2 = MMY1
   20 IF (NUPPER .LT. 0) GO TO 180
C
C CHECK UPPER VISIBILITY.
C
      VIS1 = NY1 .GE. (LIMU(NX1)-1)
      VIS2 = NY2 .GE. (LIMU(NX2)-1)
C
C VIS1 AND VIS2 TRUE MEANS VISIBLE.
C
      IF (VIS1 .AND. VIS2) GO TO 120
C
C VIS1 AND VIS2 FALSE MEANS INVISIBLE.
C
      IF (.NOT.(VIS1 .OR. VIS2)) GO TO 180
C
C FIND CHANGE POINT.
C
      IF (NX1 .EQ. NX2) GO TO 110
      DY = FLOAT(NY2-NY1)/FLOAT(NX2-NX1)
      NX1P1 = NX1+1
      FNY1 = NY1
      IF (VIS1) GO TO  60
      DO  30 K=NX1P1,NX2
         MX = K
         MY = FNY1+FLOAT(K-NX1)*DY
         IF (MY .GT. LIMU(K)) GO TO  40
   30 CONTINUE
   40 IF (ABS(DY) .GE. STEEP) GO TO  90
   50 NX1 = MX
      NY1 = MY
      GO TO 120
   60 DO  70 K=NX1P1,NX2
         MX = K
         MY = FNY1+FLOAT(K-NX1)*DY
         IF (MY .LT. LIMU(K)) GO TO  80
   70 CONTINUE
   80 IF (ABS(DY) .GE. STEEP) GO TO 100
      NX2 = MX-1
      NY2 = MY
      GO TO 120
   90 IF (LIMU(MX) .EQ. 0) GO TO  50
      NX1 = MX
      NY1 = LIMU(NX1)
      GO TO 120
  100 NX2 = MX-1
      NY2 = LIMU(NX2)
      GO TO 120
  110 IF (VIS1) NY2 = MIN0(LIMU(NX1),LIMU(NX2))
      IF (VIS2) NY1 = MIN0(LIMU(NX1),LIMU(NX2))
  120 IF (IDRAW .EQ. 0) GO TO 150
C
C DRAW VISIBLE PART OF LINE.
C
      IF (IROT) 130,140,130
  130 CONTINUE
      PXS(1) = FLOAT(NY1)
      PXS(2) = FLOAT(NY2)
      PYS(1) = FLOAT(1024-NX1)
      PYS(2) = FLOAT(1024-NX2)
      CALL GPL (2,PXS,PYS)
      GO TO 150
  140 CONTINUE
      PXS(1) = FLOAT(NX1)
      PXS(2) = FLOAT(NX2)
      PYS(1) = FLOAT(NY1)
      PYS(2) = FLOAT(NY2)
      CALL GPL (2,PXS,PYS)
  150 IF (IMARK .EQ. 0) GO TO 180
      IF (NX1 .EQ. NX2) GO TO 170
      DY = FLOAT(NY2-NY1)/FLOAT(NX2-NX1)
      FNY1 = NY1
      DO 160 K=NX1,NX2
         LTEMP = FNY1+FLOAT(K-NX1)*DY
	 IF (LTEMP .GT. LIMU(K)) LIMU(K) = LTEMP
  160 CONTINUE
      GO TO 180
  170 LTEMP = MAX0(NY1,NY2)
      IF (LTEMP .GT. LIMU(NX1)) LIMU(NX1) = LTEMP
  180 IF (NUPPER) 190,190,370
C
C SAME IDEA AS ABOVE, BUT FOR LOWER SIDE.
C
  190 IF (MMX1 .GT. MMX2) GO TO 200
      NX1 = MMX1
      NY1 = MMY1
      NX2 = MMX2
      NY2 = MMY2
      GO TO 210
  200 NX1 = MMX2
      NY1 = MMY2
      NX2 = MMX1
      NY2 = MMY1
  210 VIS1 = NY1 .LE. (LIML(NX1)+1)
      VIS2 = NY2 .LE. (LIML(NX2)+1)
      IF (VIS1 .AND. VIS2) GO TO 310
      IF (.NOT.(VIS1 .OR. VIS2)) GO TO 370
      IF (NX1 .EQ. NX2) GO TO 300
      DY = FLOAT(NY2-NY1)/FLOAT(NX2-NX1)
      NX1P1 = NX1+1
      FNY1 = NY1
      IF (VIS1) GO TO 250
      DO 220 K=NX1P1,NX2
         MX = K
         MY = FNY1+FLOAT(K-NX1)*DY
         IF (MY .LT. LIML(K)) GO TO 230
  220 CONTINUE
  230 IF (ABS(DY) .GE. STEEP) GO TO 280
  240 NX1 = MX
      NY1 = MY
      GO TO 310
  250 DO 260 K=NX1P1,NX2
         MX = K
         MY = FNY1+FLOAT(K-NX1)*DY
         IF (MY .GT. LIML(K)) GO TO 270
  260 CONTINUE
  270 IF (ABS(DY) .GE. STEEP) GO TO 290
      NX2 = MX-1
      NY2 = MY
      GO TO 310
  280 IF (LIML(MX) .EQ. 1024) GO TO 240
      NX1 = MX
      NY1 = LIML(NX1)
      GO TO 310
  290 NX2 = MX-1
      NY2 = LIML(NX2)
      GO TO 310
  300 IF (VIS1) NY2 = MAX0(LIML(NX1),LIML(NX2))
      IF (VIS2) NY1 = MAX0(LIML(NX1),LIML(NX2))
  310 IF (IDRAW .EQ. 0) GO TO 340
      IF (IROT) 320,330,320
  320 CONTINUE
      PXS(1) = FLOAT(NY1)
      PXS(2) = FLOAT(NY2)
      PYS(1) = FLOAT(1024-NX1)
      PYS(2) = FLOAT(1024-NX2)
      CALL GPL (2,PXS,PYS)
      GO TO 340
  330 CONTINUE
      PXS(1) = FLOAT(NX1)
      PXS(2) = FLOAT(NX2)
      PYS(1) = FLOAT(NY1)
      PYS(2) = FLOAT(NY2)
      CALL GPL (2,PXS,PYS)
  340 IF (IMARK .EQ. 0) GO TO 370
      IF (NX1 .EQ. NX2) GO TO 360
      DY = FLOAT(NY2-NY1)/FLOAT(NX2-NX1)
      FNY1 = NY1
      DO 350 K=NX1,NX2
         LTEMP = FNY1+FLOAT(K-NX1)*DY
	 IF (LTEMP .LT. LIML(K)) LIML(K) = LTEMP
  350 CONTINUE
      RETURN
  360 LTEMP = MIN0(NY1,NY2)
      IF (LTEMP .LT. LIML(NX1)) LIML(NX1) = LTEMP
  370 RETURN
      END
      SUBROUTINE TRN32S (X,Y,Z,XT,YT,ZT,IFLAG)
C
C THIS ROUTINE IMPLEMENTS THE 3-SPACE TO 2-SPACE TRANSFOR-
C MATION BY KUBER, SZABO AND GIULIERI, THE PERSPECTIVE
C REPRESENTATION OF FUNCTIONS OF TWO VARIABLES. J. ACM 15,
C 2, 193-204,1968.
C IFLAG=0 ARGUMENTS
C X,Y,Z    ARE THE 3-SPACE COORDINATES OF THE INTERSECTION
C          OF THE LINE OF SIGHT AND THE IMAGE PLANE.    THIS
C          POINT CAN BE THOUGHT OF AS THE POINT LOOKED AT.
C XT,YT,ZT ARE THE 3-SPACE COORDINATES OF THE EYE POSITION.
C
C IFLAG=1 ARGUMENTS
C X,Y,Z    ARE THE 3-SPACE COORDINATES OF A POINT TO BE
C          TRANSFORMED.
C XT,YT    THE RESULTS OF THE 3-SPACE TO 2-SPACE TRANSFOR-
C          MATION.
C          USE IFIX(XT) AND IFIX(YT) IN GPL CALLS.
C ZT            NOT USED.
C IF LL (IN COMMON) =0 XT AND YT ARE IN THE SAME SCALE AS X, Y, AND Z.
C
      COMMON /PWRZ1S/ XXMIN      ,XXMAX      ,YYMIN  ,YYMAX,
     1                ZZMIN      ,ZZMAX      ,DELCRT ,EYEX,
     2                EYEY       ,EYEZ
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL,
     1                LL         ,FACT       ,IROT       ,NDRZ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      DIMENSION       NLU(7)     ,NRU(7)     ,NBV(7)     ,NTV(7)
C
C SAVE INSERTED BY BEN DOMENICO 9/8/85 BECAUSE OF ASSUMPTION THAT
C   JUMP, JUMP2, AND JUMP3 ARE PRESERVED BETWEEN CALLS.
C   THERE MAY BE OTHER SUCH ASSUMPTIONS AS WELL.
C
      SAVE
C
C PICTURE CORNER COORDINATES FOR LL=1
C
      DATA NLU(1),NRU(1),NBV(1),NTV(1)/  10,1014,  10,1014/
C
C PICTURE CORNER COORDINATES FOR LL=2
C
      DATA NLU(2),NRU(2),NBV(2),NTV(2)/  10, 924,  50, 964/
C
C PICTURE CORNER COORDINATES FOR LL=3
C
      DATA NLU(3),NRU(3),NBV(3),NTV(3)/ 100,1014,  50, 964/
C
C PICTURE CORNER COORDINATES FOR LL=4
C
      DATA NLU(4),NRU(4),NBV(4),NTV(4)/  10,1014,  10,1014/
C
C PICTURE CORNER COORDINATES FOR LL=5
C
      DATA NLU(5),NRU(5),NBV(5),NTV(5)/  10,1014,  10,1014/
C
C PICTURE CORNER COORDINATES FOR LL=6
C
      DATA NLU(6),NRU(6),NBV(6),NTV(6)/  10, 512, 256, 758/
C
C PICTURE CORNER COORDINATES FOR LL=7
C
      DATA NLU(7),NRU(7),NBV(7),NTV(7)/ 512,1014, 256, 758/
C
C STORE THE PARAMETERS OF THE SET32 CALL FOR USE WHEN
C TRN32 IS CALLED.
C
      IF (IFLAG)  40, 10, 40
   10 CONTINUE
      ASSIGN  60 TO JUMP3
      IF (IOFFP .EQ. 1) ASSIGN  50 TO JUMP3
      AX = X
      AY = Y
      AZ = Z
      EX = XT
      EY = YT
      EZ = ZT
C
C AS MUCH COMPUTATION AS POSSIBLE IS DONE DURING EXECUTION
C THIS ROUTINE WHEN IFLAG=0 BECAUSE CALLS IN THAT MODE ARE INFREQUENT.
C
      DX = AX-EX
      DY = AY-EY
      DZ = AZ-EZ
      D = SQRT(DX*DX+DY*DY+DZ*DZ)
      COSAL = DX/D
      COSBE = DY/D
      COSGA = DZ/D
      SINGA = SQRT(1.-COSGA*COSGA)
      ASSIGN 120 TO JUMP2
      IF (LL .EQ. 0) GO TO  20
      ASSIGN 100 TO JUMP2
      DELCRT = NRU(LL)-NLU(LL)
      U0 = UMIN
      V0 = VMIN
      U1 = NLU(LL)
      V1 = NBV(LL)
      U2 = NRU(LL)-NLU(LL)
      V2 = NTV(LL)-NBV(LL)
      U3 = U2/(UMAX-UMIN)
      V3 = V2/(VMAX-VMIN)
      U4 = NRU(LL)
      V4 = NTV(LL)
      IF (NRSWT .EQ. 0) GO TO  20
      U0 = -BIGD
      V0 = -BIGD
      U3 = U2/(2.*BIGD)
      V3 = V2/(2.*BIGD)
C
C THE 3-SPACE POINT LOOKED AT IS TRANSFORMED INTO (0,0) OF
C THE 2-SPACE.  THE 3-SPACE Z AXIS IS TRANSFORMED INTO THE
C 2-SPACE Y AXIS.  IF THE LINE OF SIGHT IS CLOSE TO PARALLEL
C TO THE 3-SPACE Z AXIS, THE 3-SPACE Y AXIS IS CHOSEN (IN-
C STEAD OF THE 3-SPACE Z AXIS) TO BE TRANSFORMED INTO THE
C 2-SPACE Y AXIS.
C
   20 IF (SINGA .LT. 0.0001) GO TO  30
      R = 1./SINGA
      ASSIGN  70 TO JUMP
      RETURN
   30 SINBE = SQRT(1.-COSBE*COSBE)
      R = 1./SINBE
      ASSIGN  80 TO JUMP
      RETURN
   40 CONTINUE
      XX = X
      YY = Y
      ZZ = Z
      GO TO JUMP3,( 50, 60)
   50 IF (ZZ .EQ. SPVAL) GO TO 110
   60 Q = D/((XX-EX)*COSAL+(YY-EY)*COSBE+(ZZ-EZ)*COSGA)
      GO TO JUMP,( 70, 80)
   70 XX = ((EX+Q*(XX-EX)-AX)*COSBE-(EY+Q*(YY-EY)-AY)*COSAL)*R
      YY = (EZ+Q*(ZZ-EZ)-AZ)*R
      GO TO  90
   80 XX = ((EZ+Q*(ZZ-EZ)-AZ)*COSAL-(EX+Q*(XX-EX)-AX)*COSGA)*R
      YY = (EY+Q*(YY-EY)-AY)*R
   90 GO TO JUMP2,(100,120)
c + NOAO: Clipping is done at the gio level and is unnecessary here.  The
c following statements were preventing labels from being positioned properly
c at the edges of the surface plot, even when the viewport had been reset.
  100 xx = u1 + u3 * (fact * xx - u0)
      yy = v1 + v3 * (fact * yy - v0)
c 100 XX = AMIN1(U4,AMAX1(U1,U1+U3*(FACT*XX-U0)))
c     YY = AMIN1(V4,AMAX1(V1,V1+V3*(FACT*YY-V0)))
c -NOAO
      GO TO 120
  110 XX = NSPVAL
      YY = NSPVAL
C
  120 XT = XX
      YT = YY
      RETURN
      END
      SUBROUTINE CLSET (Z,MX,NX,NY,CHI,CLO,CINC,NLA,NLM,CL,NCL,ICNST,
     1                  IOFFP,SPVAL,BIGEST)
      DIMENSION       Z(MX,NY)   ,CL(NLM)
      DATA KK /0/
C
C CLSET PUTS THE VALUS OF THE CONTOUR LEVELS IN CL
C
      ICNST = 0
      GLO = CLO
      HA = CHI
      FANC = CINC
      CRAT = NLA
      IF (HA-GLO)  10, 20, 50
   10 GLO = HA
      HA = CLO
      GO TO  50
   20 GLO = BIGEST
      HA = -GLO
      DO  40 J=1,NY
         DO  30 I=1,NX
            IF (IOFFP.EQ.1 .AND. Z(I,J).EQ.SPVAL) GO TO  30
            GLO = AMIN1(Z(I,J),GLO)
            HA = AMAX1(Z(I,J),HA)
   30    CONTINUE
   40 CONTINUE
   50 IF (FANC)  60, 70, 90
   60 CRAT = -FANC
   70 FANC = (HA-GLO)/CRAT
      IF (FANC) 140,140, 80
   80 P = 10.**(IFIX(ALOG10(FANC)+500.)-500)
      FANC = AINT(FANC/P)*P
   90 IF (CHI-CLO) 110,100,110
  100 GLO = AINT(GLO/FANC)*FANC
      HA = AINT(HA/FANC)*FANC
  110 DO 120 K=1,NLM
         CC = GLO+FLOAT(K-1)*FANC
         IF (CC .GT. HA) GO TO 130
         KK = K
         CL(K) = CC
  120 CONTINUE
  130 NCL = KK
      RETURN
  140 ICNST = 1
      RETURN
      END
      SUBROUTINE CTCELL (Z,MX,NX,NY,M,I0,J0)
C
C CTCELL COMPUTES LINES OF CONSTANT Z (CONTOUR LINES) IN ONE
C CELL OF THE ARRAY Z FOR THE SRFACE PACKAGE.
C Z,MX,NX,NY ARE THE SAME AS IN SRFACE.
C M              BY     THE TIME CTCELL IS FIRST CALLED, M CONTAINS
C            THE TWO-SPACE PLOTTER LOCATION OF EACH Z POINT.
C            U(Z(I,J))=M(1,I,J).  V(Z(I,J))=M(2,I,J)
C I0,J0      THE CELL Z(I0,J0) TO Z(I0+1,J0+1) IS THE ONE TO
C            BE CONTOURED.
C
      DIMENSION       Z(MX,NY)   ,M(2,NX,NY)
      COMMON /SRFBLK/ LIMU(1024) ,LIML(1024) ,CL(41)     ,NCL,
     1                LL         ,FACT       ,IROT       ,NDRZ,
     2                NUPPER     ,NRSWT      ,BIGD       ,UMIN,
     3                UMAX       ,VMIN       ,VMAX       ,RZERO,
     4                IOFFP      ,NSPVAL     ,SPVAL      ,BIGEST
      DATA IDUB/0/
      R(HO,HU) = (HO-CV)/(HO-HU)
      I1 = I0
      I1P1 = I1+1
      J1 = J0
      J1P1 = J1+1
      H1 = Z(I1,J1)
      H2 = Z(I1,J1P1)
      H3 = Z(I1P1,J1P1)
      H4 = Z(I1P1,J1)
      IF (IOFFP .NE. 1) GO TO  10
      IF (H1.EQ.SPVAL .OR. H2.EQ.SPVAL .OR. H3.EQ.SPVAL .OR.
     1    H4.EQ.SPVAL) RETURN
   10 IF (AMIN1(H1,H2,H3,H4) .GT. CL(NCL)) RETURN
      DO 110 K=1,NCL
C
C FOR EACH CONTOUR LEVEL, DESIDE WHICH OF THE 16 BASIC SIT-
C UATIONS EXISTS, THEN INTERPOLATE IN TWO-SPACE TO FIND THE
C END POINTS OF THE CONTOUR LINE SEGMENT WITHIN THIS CELL.
C
         CV = CL(K)
         K1 = (IFIX(SIGN(1.,H1-CV))+1)/2
         K2 = (IFIX(SIGN(1.,H2-CV))+1)/2
         K3 = (IFIX(SIGN(1.,H3-CV))+1)/2
         K4 = (IFIX(SIGN(1.,H4-CV))+1)/2
         JUMP = 1+K1+K2*2+K3*4+K4*8
         GO TO (120, 30, 50, 60, 70, 20, 80, 90, 90, 80,
     1           40, 70, 60, 50, 30,110),JUMP
   20    IDUB = 1
   30    RA = R(H1,H2)
         MUA = FLOAT(M(1,I1,J1))+RA*FLOAT(M(1,I1,J1P1)-M(1,I1,J1))
         MVA = FLOAT(M(2,I1,J1))+RA*FLOAT(M(2,I1,J1P1)-M(2,I1,J1))
         RB = R(H1,H4)
         MUB = FLOAT(M(1,I1,J1))+RB*FLOAT(M(1,I1P1,J1)-M(1,I1,J1))
         MVB = FLOAT(M(2,I1,J1))+RB*FLOAT(M(2,I1P1,J1)-M(2,I1,J1))
         GO TO 100
   40    IDUB = -1
   50    RA = R(H2,H1)
         MUA = FLOAT(M(1,I1,J1P1))+RA*FLOAT(M(1,I1,J1)-M(1,I1,J1P1))
         MVA = FLOAT(M(2,I1,J1P1))+RA*FLOAT(M(2,I1,J1)-M(2,I1,J1P1))
         RB = R(H2,H3)
         MUB = FLOAT(M(1,I1,J1P1))+RB*FLOAT(M(1,I1P1,J1P1)-M(1,I1,J1P1))
         MVB = FLOAT(M(2,I1,J1P1))+RB*FLOAT(M(2,I1P1,J1P1)-M(2,I1,J1P1))
         GO TO 100
   60    RA = R(H2,H3)
         MUA = FLOAT(M(1,I1,J1P1))+RA*FLOAT(M(1,I1P1,J1P1)-M(1,I1,J1P1))
         MVA = FLOAT(M(2,I1,J1P1))+RA*FLOAT(M(2,I1P1,J1P1)-M(2,I1,J1P1))
         RB = R(H1,H4)
         MUB = FLOAT(M(1,I1,J1))+RB*FLOAT(M(1,I1P1,J1)-M(1,I1,J1))
         MVB = FLOAT(M(2,I1,J1))+RB*FLOAT(M(2,I1P1,J1)-M(2,I1,J1))
         GO TO 100
   70    RA = R(H3,H2)
         MUA = FLOAT(M(1,I1P1,J1P1))+
     1         RA*FLOAT(M(1,I1,J1P1)-M(1,I1P1,J1P1))
         MVA = FLOAT(M(2,I1P1,J1P1))+
     1         RA*FLOAT(M(2,I1,J1P1)-M(2,I1P1,J1P1))
         RB = R(H3,H4)
         MUB = FLOAT(M(1,I1P1,J1P1))+
     1         RB*FLOAT(M(1,I1P1,J1)-M(1,I1P1,J1P1))
         MVB = FLOAT(M(2,I1P1,J1P1))+
     1         RB*FLOAT(M(2,I1P1,J1)-M(2,I1P1,J1P1))
         IDUB = 0
         GO TO 100
   80    RA = R(H2,H1)
         MUA = FLOAT(M(1,I1,J1P1))+RA*FLOAT(M(1,I1,J1)-M(1,I1,J1P1))
         MVA = FLOAT(M(2,I1,J1P1))+RA*FLOAT(M(2,I1,J1)-M(2,I1,J1P1))
         RB = R(H3,H4)
         MUB = FLOAT(M(1,I1P1,J1P1))+
     1         RB*FLOAT(M(1,I1P1,J1)-M(1,I1P1,J1P1))
         MVB = FLOAT(M(2,I1P1,J1P1))+
     1         RB*FLOAT(M(2,I1P1,J1)-M(2,I1P1,J1P1))
         GO TO 100
   90    RA = R(H4,H1)
         MUA = FLOAT(M(1,I1P1,J1))+RA*FLOAT(M(1,I1,J1)-M(1,I1P1,J1))
         MVA = FLOAT(M(2,I1P1,J1))+RA*FLOAT(M(2,I1,J1)-M(2,I1P1,J1))
         RB = R(H4,H3)
         MUB = FLOAT(M(1,I1P1,J1))+RB*FLOAT(M(1,I1P1,J1P1)-M(1,I1P1,J1))
         MVB = FLOAT(M(2,I1P1,J1))+RB*FLOAT(M(2,I1P1,J1P1)-M(2,I1P1,J1))
         IDUB = 0
  100    CALL DRAWS (MUA,MVA,MUB,MVB,1,0)
         IF (IDUB)  90,110, 70
  110 CONTINUE
  120 RETURN
      END

C--------------------------------------------------------------------------
        subroutine ftgkye(iunit,keywrd,rval,comm,status)

C       read a real*4 value and the comment string from a header record 
C
C       iunit   i  fortran input unit number
C       keywrd  c  keyword name   
C       OUTPUT PARAMETERS:
C       rval    r  output keyword value 
C       comm    c  output keyword comment
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        integer iunit,status
        character value*35
        real rval

C       find the keyword and return value and comment as character strings
        call ftgkey(iunit,keywrd,value,comm,status)

C       convert character string to real
C       datatype conversion will be performed if necessary and if possible
        call ftc2r(value,rval,status)
        end

C--------------------------------------------------------------------------
        subroutine ftp3dj(ounit,group,dim1,dim2,nx,ny,nz,array,status)

C       Write a 3-d cube of i*4 values into the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being written).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       dim1    i  actual first dimension of ARRAY
C       dim2    i  actual second dimension of ARRAY
C       nx      i  size of the cube in the x direction
C       ny      i  size of the cube in the y direction
C       nz      i  size of the cube in the z direction
C       array   i  the array of values to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,dim1,dim2,nx,ny,nz,status
        integer array(dim1,dim2,*)
        integer fpixel,row,band

        fpixel=1
        do 20 band=1,nz
        do 10 row = 1,ny
            call ftpprj(ounit,group,fpixel,nx,array(1,row,band),status)
            fpixel=fpixel+nx
10      continue
20      continue

        end

c STRUPK -- Unpack a kernel (C style) string into an SPP string.  The unpacking
c operation can be performed in place.  A kernel string consists of a sequence
c of host characters stored one character per byte, delimited by EOS='\0'.
c We assume here that the host character set is ASCII.  If this is not the
c case code must be added to convert from the host character set to ASCII in
c the unpacked string.
c
c N.B.: If sizeof(XCHAR)=1, XEOS=EOS, and the host character set is ASCII,
c and the operation is being performed in place, then this procedure should
c do nothing.
c 
c N.B.: This code ASSUMES that XCHAR is implemented as INTEGER*2 and that
c both XEOS and EOS are 0.

	subroutine strupk (instr, outstr, maxch)

	character*1 instr(*)
	integer*2 outstr(*)
	integer maxch, EOS
	parameter (EOS=0)
	integer i

		    
c Determine length of string so that we can unpack it in the reverse
c direction.
		i = 1
 10		continue
		if (ichar (instr(i)) .eq. EOS .or. i .gt. maxch) goto 20
		    i = i + 1
		    goto 10
 20		continue

c Unpack the string from right to left.
c
		outstr(i) = EOS
		do 30 i=i, 1, -1
		    outstr(i) = ichar (instr(i))
 30		continue
	end

C--------------------------------------------------------------------------
        subroutine ftgatp(ibuff,keynam,value,status)

C       Get ASCII Table Parameter
C       test if the keyword is one of the table column definition keywords
C       of an ASCII table. If so, decode it and update the value in the common 
C       block

C       ibuff   i sequence number of the data buffer
C       keynam  c name of the keyword
C       value   c value of the keyword
C       status  i returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ibuff,status
        character keynam*8,value*70

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
C       nb = number of file buffers = max. number of FITS file opened at once
C       nf = maximum number of fields allowed in a table
        integer nf,nb
        parameter (nb = 20)
        parameter (nf = 3000)

C       tfield = number of fields in the table
C       tbcol = byte offset in the row of the beginning of the column
C       rowlen = length of one row of the table, in bytes
C       tdtype = integer code representing the datatype of the column
C       trept = the repeat count = number of data values/element in the column
C       tnull = the value used to represent an undefined value in the column
C       tscale = the scale factor for the column
C       tzero = the scaling zero point for the column
C       scount = the total size of the binary table heap (+ gap if any)
C       theap = the starting byte offset for the binary table heap, relative
C               to the start of the binary table data
C       nxheap = the next empty heap location
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)

C       cnull = character string representing nulls in character columns
C       cform = the Fortran format of the column
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer nfield,i,c2,bcol,tstat
        character tform*16

        if (status .gt. 0)return
        tstat=status

        if (keynam(1:5) .eq. 'TFORM')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TFORMn keyword
                    status=tstat
                else
C                   get the TFORM character string, without quotes
                    call ftc2s(value,tform,status)
                    if (status .gt. 0)return
                    if  (tform(1:1) .ne. 'A' .and. tform(1:1) .ne. 'I'
     &              .and. tform(1:1) .ne. 'F' .and. tform(1:1) .ne. 'E'
     &              .and. tform(1:1) .ne. 'D')then
                        status=311
                     call ftpmsg('Illegal '//keynam//' format code: '
     &                           //tform)
                        return
                    end if

                    cform(nfield+tstart(ibuff))=tform
C                   set numeric data type code to indicate an ASCII table field
                    tdtype(nfield+tstart(ibuff))=16
C                   set the repeat count to 1
                    trept(nfield+tstart(ibuff))=1
C                   set the TNULL parameter to the width of the field:
                    c2=0
                    do 10 i=2,8
                        if (tform(i:i) .ge. '0' .and. tform(i:i)
     &                     .le. '9')then
                                c2=i
                        else
                                go to 20
                        end if
10                  continue
20                  continue

                    if (status .gt. 0)return
                    if (c2 .eq. 0)then
C                       no explicit field width, so assume width=1 character
                        tnull(nfield+tstart(ibuff))=1
                    else
                        call ftc2ii(tform(2:c2),tnull(nfield+
     &                              tstart(ibuff)),status)
                        if (status .gt. 0)then
C                               error parsing the TFORM value string
                                status=261
           call ftpmsg('Error parsing '//keynam//' field width: '
     &                  //tform)
                        end if
                    end if
                end if
        else if (keynam(1:5) .eq. 'TBCOL')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TBCOLn keyword
                    status=tstat
                else
C                   get the beginning column number
                    call ftc2ii(value,bcol,status)
                     if (status .gt. 0)then
                        call ftpmsg('Error reading value of '//keynam        
     &                  //' as an integer: '//value)
                     else
                        tbcol(nfield+tstart(ibuff))=bcol-1
                     end if
                end if
        else if (keynam(1:5) .eq. 'TSCAL')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TSCALn keyword
                    status=tstat
                else
C                   get the scale factor
                    call ftc2dd(value,tscale(nfield+tstart(ibuff)),
     &                          status)
                    if (status .gt. 0)then
                         call ftpmsg('Error reading value of'//keynam
     &                //' as a Double: '//value)
                    end if
                end if
        else if (keynam(1:5) .eq. 'TZERO')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TZEROn keyword
                    status=tstat
                else
C                   get the scaling zero point
                    call ftc2dd(value,tzero(nfield+tstart(ibuff)),
     &                          status)
                    if (status .gt. 0)then
                         call ftpmsg('Error reading value of'//keynam
     &                //' as a Double: '//value)
                    end if
                end if
        else if (keynam(1:5) .eq. 'TNULL')then
C               get the field number
                call ftc2ii(keynam(6:8),nfield,status)
                if (status .gt. 0)then
C                   this must not have been a TNULLn keyword
                    status=tstat
                else
C                   get the Null value flag (character)
                    call ftc2s(value,cnull(nfield+tstart(ibuff)),status)
                    if (status .gt. 0)then
                         call ftpmsg('Error reading value of'//keynam
     &                //' as a character string: '//value)
                    end if
                end if
        end if
        end

#-h-  getdef			 1634  local   12/01/80  15:54:08
# getdef (for no arguments) - get name and definition
   include  defs

   subroutine getdef (token, toksiz, defn, defsiz)
   character token (MAXTOK), defn (MAXDEF)
   integer toksiz, defsiz

   include COMMON_BLOCKS

   character c, t, ptoken (MAXTOK)
   character gtok, ngetch

   integer i, nlpar

   call skpblk
   c = gtok (ptoken, MAXTOK)
   if (c == LPAREN)
      t = LPAREN	     # define (name, defn)
   else {
      t = BLANK 	     # define name defn
      call pbstr (ptoken)
      }
   call skpblk
   if (gtok (token, toksiz) != ALPHA)
      call baderr ("non-alphanumeric name.")
   call skpblk
   c = gtok (ptoken, MAXTOK)
   if (t == BLANK) {	     # define name defn
      call pbstr (ptoken)
      i = 1
      repeat {
	 c = ngetch (c)
	 if (i > defsiz)
	    call baderr ("definition too long.")
	 defn (i) = c
	 i = i + 1
	 } until (c == SHARP | c == NEWLINE | c == EOF)
      if (c == SHARP)
	 call putbak (c)
      }
   else if (t == LPAREN) {   # define (name, defn)
      if (c != COMMA)
	 call baderr ("missing comma in define.")
      # else got (name,
      nlpar = 0
      for (i = 1; nlpar >= 0; i = i + 1)
	 if (i > defsiz)
	    call baderr ("definition too long.")
	 else if (ngetch (defn (i)) == EOF)
	    call baderr ("missing right paren.")
	 else if (defn (i) == LPAREN)
	    nlpar = nlpar + 1
	 else if (defn (i) == RPAREN)
	    nlpar = nlpar - 1
	 # else normal character in defn (i)
      }
   else
      call baderr ("getdef is confused.")
   defn (i - 1) = EOS
   return
   end

C----------------------------------------------------------------------
        subroutine ftpdes(ounit,colnum,rownum,nelem,offset,status)

C       write the descriptor values to a binary table.  This is only
C       used for column which have TFORMn = 'P', i.e., for variable
C       length arrays.

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       rownum  i  number of the row to write
C       nelem   i  input number of elements
C       offset  i  input byte offset of the first element
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Nov 1991

        integer ounit,colnum,rownum,nelem,offset,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,bstart,iray(2)

        if (status .gt. 0)return
        if (rownum .lt. 1)then
C               error: illegal row number
                status=307
                return
        end if

        ibuff=bufnum(ounit)

C       check that this is really a 'P' type column
        if (tdtype(colnum+tstart(ibuff)) .ge. 0)then
                status=317
                return
        end if

C       move to the specified column and row:
        bstart=dtstrt(ibuff)+(rownum-1)*rowlen(ibuff)
     &         +tbcol(colnum+tstart(ibuff))
        call ftmbyt(ounit,bstart,.true.,status)

C       now write the number of elements and the offset to the table:
        iray(1)=nelem
        iray(2)=offset
        call ftpi4b(ounit,2,0,iray,status)
        end

      SUBROUTINE slREFV (VU, REFA, REFB, VR)
*+
*     - - - - -
*      R E F V
*     - - - - -
*
*  Adjust an unrefracted Cartesian vector to include the effect of
*  atmospheric refraction, using the simple A tan Z + B tan**3 Z
*  model.
*
*  Given:
*    VU    dp    unrefracted position of the source (Az/El 3-vector)
*    REFA  dp    tan Z coefficient (radian)
*    REFB  dp    tan**3 Z coefficient (radian)
*
*  Returned:
*    VR    dp    refracted position of the source (Az/El 3-vector)
*
*  Notes:
*
*  1  This routine applies the adjustment for refraction in the
*     opposite sense to the usual one - it takes an unrefracted
*     (in vacuo) position and produces an observed (refracted)
*     position, whereas the A tan Z + B tan**3 Z model strictly
*     applies to the case where an observed position is to have the
*     refraction removed.  The unrefracted to refracted case is
*     harder, and requires an inverted form of the text-book
*     refraction models;  the algorithm used here is equivalent to
*     one iteration of the Newton-Raphson method applied to the above
*     formula.
*
*  2  Though optimized for speed rather than precision, the present
*     routine achieves consistency with the refracted-to-unrefracted
*     A tan Z + B tan**3 Z model at better than 1 microarcsecond within
*     30 degrees of the zenith and remains within 1 milliarcsecond to
*     beyond ZD 70 degrees.  The inherent accuracy of the model is, of
*     course, far worse than this - see the documentation for slRFCO
*     for more information.
*
*  3  At low elevations (below about 3 degrees) the refraction
*     correction is held back to prevent arithmetic problems and
*     wildly wrong results.  For optical/IR wavelengths, over a wide
*     range of observer heights and corresponding temperatures and
*     pressures, the following levels of accuracy (arcsec, worst case)
*     are achieved, relative to numerical integration through a model
*     atmosphere:
*
*              ZD    error
*
*              80      0.7
*              81      1.3
*              82      2.5
*              83      5
*              84     10
*              85     20
*              86     55
*              87    160
*              88    360
*              89    640
*              90   1100
*              91   1700         } relevant only to
*              92   2600         } high-elevation sites
*
*     The results for radio are slightly worse over most of the range,
*     becoming significantly worse below ZD=88 and unusable beyond
*     ZD=90.
*
*  4  See also the routine slREFZ, which performs the adjustment to
*     the zenith distance rather than in Cartesian Az/El coordinates.
*     The present routine is faster than slREFZ and, except very low down,
*     is equally accurate for all practical purposes.  However, beyond
*     about ZD 84 degrees slREFZ should be used, and for the utmost
*     accuracy iterative use of slRFRO should be considered.
*
*  P.T.Wallace   Starlink   10 April 2004
*
*  Copyright (C) 2004 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION VU(3),REFA,REFB,VR(3)

      DOUBLE PRECISION X,Y,Z1,Z,ZSQ,RSQ,R,WB,WT,D,CD,F



*  Initial estimate = unrefracted vector
      X = VU(1)
      Y = VU(2)
      Z1 = VU(3)

*  Keep correction approximately constant below about 3 deg elevation
      Z = MAX(Z1,0.05D0)

*  One Newton-Raphson iteration
      ZSQ = Z*Z
      RSQ = X*X+Y*Y
      R = SQRT(RSQ)
      WB = REFB*RSQ/ZSQ
      WT = (REFA+WB)/(1D0+(REFA+3D0*WB)*(ZSQ+RSQ)/ZSQ)
      D = WT*R/Z
      CD = 1D0-D*D/2D0
      F = CD*(1D0-WT)

*  Post-refraction x,y,z
      VR(1) = X*F
      VR(2) = Y*F
      VR(3) = CD*(Z+D*R)+(Z1-Z)

      END

C----------------------------------------------------------------------
        subroutine ftchdu(iunit,status)

C       Close Header Data Unit
C       If we have write access to the file, then close the current HDU by:
C                 -padding remaining space in the header with blanks
C                 -writing the END keyword in the CHU
C                 -check the data fill values, and rewrite them if not correct
C                 -flushing the current buffer to disk
C                 -recover common block space containing column descriptors

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1991

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff

C       ignore input status and close HDU regardless of input status value

        ibuff=bufnum(iunit)

C       see if we have write access to this file
        if (wrmode(ibuff))then
C           rewrite the header END card and the following blank fill, and
C           insure that the internal data structure matches the keywords
            call ftrdef(iunit,status)

C           write the correct data fill values, if they are not already correct
            call ftpdfl(iunit,status)
        end if

C       set current column name buffer as undefined
        call ftrsnm

C       flush the buffers holding data for this HDU
        call ftflsh(ibuff,status)

C       recover common block space containing column descriptors for this HDU
        call ftfrcl(iunit,status)

        if (status .gt. 0)then
            call ftpmsg('Error while closing current HDU (FTCHDU).')
        end if
        end

include	defs

# ctoc --- convert EOS-terminated string to EOS-terminated string

   integer function ctoc (from, to, len)
   integer len
   character from (ARB), to (len)

   integer i

   for (i = 1; i < len & from (i) != EOS; i = i + 1)
      to (i) = from (i)

   to (i) = EOS

   return (i - 1)

   end

*> \brief \b DGETRS
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download DGETRS + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dgetrs.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dgetrs.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dgetrs.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE DGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
*       .. Scalar Arguments ..
*       CHARACTER          TRANS
*       INTEGER            INFO, LDA, LDB, N, NRHS
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DGETRS solves a system of linear equations
*>    A * X = B  or  A**T * X = B
*> with a general N-by-N matrix A using the LU factorization computed
*> by DGETRF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>          Specifies the form of the system of equations:
*>          = 'N':  A * X = B  (No transpose)
*>          = 'T':  A**T* X = B  (Transpose)
*>          = 'C':  A**T* X = B  (Conjugate transpose = Transpose)
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] NRHS
*> \verbatim
*>          NRHS is INTEGER
*>          The number of right hand sides, i.e., the number of columns
*>          of the matrix B.  NRHS >= 0.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          The factors L and U from the factorization A = P*L*U
*>          as computed by DGETRF.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (N)
*>          The pivot indices from DGETRF; for 1<=i<=N, row i of the
*>          matrix was interchanged with row IPIV(i).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB,NRHS)
*>          On entry, the right hand side matrix B.
*>          On exit, the solution matrix X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup doubleGEcomputational
*
*  =====================================================================
      SUBROUTINE DGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
*  -- LAPACK computational routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASWP, DTRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( NOTRAN ) THEN
*
*        Solve A * X = B.
*
*        Apply row interchanges to the right hand sides.
*
         CALL DLASWP( NRHS, B, LDB, 1, N, IPIV, 1 )
*
*        Solve L*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Lower', 'No transpose', 'Unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve U*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
      ELSE
*
*        Solve A**T * X = B.
*
*        Solve U**T *X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Upper', 'Transpose', 'Non-unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve L**T *X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Lower', 'Transpose', 'Unit', N, NRHS, ONE,
     $               A, LDA, B, LDB )
*
*        Apply row interchanges to the solution vectors.
*
         CALL DLASWP( NRHS, B, LDB, 1, N, IPIV, -1 )
      END IF
*
      RETURN
*
*     End of DGETRS
*
      END

      SUBROUTINE Q8QST4(NAME,LBRARY,ENTRY,VRSION)
C
C DIMENSION OF		 NAME(1),LBRARY(1),ENTRY(1),VRSION(1)
C ARGUMENTS
C
C LATEST REVISION	 MARCH 1984
C
C PURPOSE		 MONITORS LIBRARY USE BY WRITING A RECORD WITH
C			 INFORMATION ABOUT THE CIRCUMSTANCES OF	A
C			 LIBRARY ROUTINE CALL TO THE SYSTEM ACCOUNTING
C			 TAPE FOR LATER	PROCESSING.
C
C NOTE---		 THIS VERSION OF Q8QST4	SIMPLY RETURNS TO THE
C			 CALLING ROUTINE.  LOCAL IMPLEMENTORS MAY WISH
C			 TO IMPLEMENT A	VERSION	OF THIS	ROUTINE	THAT
C			 MONITORS USE OF NCAR ROUTINES WITH LOCAL
C			 MECHANISMS.  OTHERWISE	IT WILL	SAVE A SMALL
C			 AMOUNT	OF SPACE AND TIME IF CALLS TO Q8QST4 ARE
C			 DELETED FROM ALL NSSL ROUTINES.
C
      CHARACTER*(*) NAME,LBRARY,ENTRY,VRSION
C
      RETURN
      END

#-h-  swcode			  746  local   12/01/80  15:55:06
# swcode - generate code for beginning of switch statement
   include  defs

   subroutine swcode (lab)
   integer lab

   include COMMON_BLOCKS

   character tok (MAXTOK)

   integer labgen, gnbtok

   lab = labgen (2)
   swvnum = swvnum + 1
   swvlev = swvlev + 1
   if (swvlev > MAXSWNEST)
      call baderr ("switches nested too deeply.")
   swvstk(swvlev) = swvnum

   if (swlast + 3 > MAXSWITCH)
      call baderr ("switch table overflow.")
   swstak (swlast) = swtop
   swstak (swlast + 1) = 0
   swstak (swlast + 2) = 0
   swtop = swlast
   swlast = swlast + 3
   xfer = NO
   call outtab	# Innn=(e)
   call swvar (swvnum)
   call outch (EQUALS)
   call balpar
   call outdwe
   call outgo (lab) # goto L
   call indent (1)
   xfer = YES
   while (gnbtok (tok, MAXTOK) == NEWLINE)
      ;
   if (tok (1) != LBRACE) {
      call synerr ("missing left brace in switch statement.")
      call pbstr (tok)
      }
   return
   end

      SUBROUTINE slATMS (RT, TT, DNT, GAMAL, R, DN, RDNDR)
*+
*     - - - - -
*      A T M S
*     - - - - -
*
*  Internal routine used by REFRO
*
*  Refractive index and derivative with respect to height for the
*  stratosphere.
*
*  Given:
*    RT      d    height of tropopause from centre of the Earth (metre)
*    TT      d    temperature at the tropopause (K)
*    DNT     d    refractive index at the tropopause
*    GAMAL   d    constant of the atmospheric model = G*MD/R
*    R       d    current distance from the centre of the Earth (metre)
*
*  Returned:
*    DN      d    refractive index at R
*    RDNDR   d    R * rate the refractive index is changing at R
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RT,TT,DNT,GAMAL,R,DN,RDNDR

      DOUBLE PRECISION B,W


      B = GAMAL/TT
      W = (DNT-1D0)*EXP(-B*(R-RT))
      DN = 1D0+W
      RDNDR = -R*B*W

      END

      SUBROUTINE slUPCD ( DISCO, X, Y )
*+
*     - - - - - -
*      U P C D
*     - - - - - -
*
*  Remove pincushion/barrel distortion from a distorted [x,y] to give
*  tangent-plane [x,y].
*
*  Given:
*     DISCO    d      pincushion/barrel distortion coefficient
*     X,Y      d      distorted coordinates
*
*  Returned:
*     X,Y      d      tangent-plane coordinates
*
*  Notes:
*
*  1)  The distortion is of the form RP = R*(1+C*R^2), where R is
*      the radial distance from the tangent point, C is the DISCO
*      argument, and RP is the radial distance in the presence of
*      the distortion.
*
*  2)  For pincushion distortion, C is +ve;  for barrel distortion,
*      C is -ve.
*
*  3)  For X,Y in "radians" - units of one projection radius,
*      which in the case of a photograph is the focal length of
*      the camera - the following DISCO values apply:
*
*          Geometry          DISCO
*
*          astrograph         0.0
*          Schmidt           -0.3333
*          AAT PF doublet  +147.069
*          AAT PF triplet  +178.585
*          AAT f/8          +21.20
*          JKT f/8          +13.32
*
*  4)  The present routine is a rigorous inverse of the companion
*      routine slPCD.  The expression for RP in Note 1 is rewritten
*      in the form x^3+a*x+b=0 and solved by standard techniques.
*
*  5)  Cases where the cubic has multiple real roots can sometimes
*      occur, corresponding to extreme instances of barrel distortion
*      where up to three different undistorted [X,Y]s all produce the
*      same distorted [X,Y].  However, only one solution is returned,
*      the one that produces the smallest change in [X,Y].
*
*  P.T.Wallace   Starlink   3 September 2000
*
*  Copyright (C) 2000 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DISCO,X,Y

      DOUBLE PRECISION THIRD
      PARAMETER (THIRD=1D0/3D0)
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925286766559D0)

      DOUBLE PRECISION RP,Q,R,D,W,S,T,F,C,T3,F1,F2,F3,W1,W2,W3



*  Distance of the point from the origin.
      RP = SQRT(X*X+Y*Y)

*  If zero, or if no distortion, no action is necessary.
      IF (RP.NE.0D0.AND.DISCO.NE.0D0) THEN

*     Begin algebraic solution.
         Q = 1D0/(3D0*DISCO)
         R = RP/(2D0*DISCO)
         W = Q*Q*Q+R*R

*     Continue if one real root, or three of which only one is positive.
         IF (W.GE.0D0) THEN
            D = SQRT(W)
            W = R+D
            S = SIGN(ABS(W)**THIRD,W)
            W = R-D
            T = SIGN((ABS(W))**THIRD,W)
            F = S+T
         ELSE

*        Three different real roots:  use geometrical method instead.
            W = 2D0/SQRT(-3D0*DISCO)
            C = 4D0*RP/(DISCO*W*W*W)
            S = SQRT(1D0-MIN(C*C,1D0))
            T3 = ATAN2(S,C)

*        The three solutions.
            F1 = W*COS((D2PI-T3)/3D0)
            F2 = W*COS((T3)/3D0)
            F3 = W*COS((D2PI+T3)/3D0)

*        Pick the one that moves [X,Y] least.
            W1 = ABS(F1-RP)
            W2 = ABS(F2-RP)
            W3 = ABS(F3-RP)
            IF (W1.LT.W2) THEN
               IF (W1.LT.W3) THEN
                  F = F1
               ELSE
                  F = F3
               END IF
            ELSE
               IF (W2.LT.W3) THEN
                  F = F2
               ELSE
                  F = F3
               END IF
            END IF

         END IF

*     Remove the distortion.
         F = F/RP
         X = F*X
         Y = F*Y

      END IF

      END

#-h-  retcod			  580  local   12/01/80  15:54:35
# retcod - generate code for return
   include  defs

   subroutine retcod

   character token (MAXTOK), t
   character gnbtok
   include COMMON_BLOCKS

   t = gnbtok (token, MAXTOK)
   if (t != NEWLINE & t != SEMICOL & t != RBRACE) {
      call pbstr (token)
      call outtab
      call scopy (fcname, 1, token, 1)
      call squash (token)
      call outstr (token)
      call outch (BLANK)
      call outch (EQUALS)
      call outch (BLANK)
      call eatup
      call outdon
      }
   else if (t == RBRACE)
      call pbstr (token)
   call outtab
   call ogotos (retlab, NO)
   xfer = YES
   return
   end

      SUBROUTINE slOAPQ (TYPE, OB1, OB2, AOPRMS, RAP, DAP)
*+
*     - - - - - -
*      O A P Q
*     - - - - - -
*
*  Quick observed to apparent place
*
*  Given:
*     TYPE   c*(*)  type of coordinates - 'R', 'H' or 'A' (see below)
*     OB1    d      observed Az, HA or RA (radians; Az is N=0,E=90)
*     OB2    d      observed ZD or Dec (radians)
*     AOPRMS d(14)  star-independent apparent-to-observed parameters:
*
*       (1)      geodetic latitude (radians)
*       (2,3)    sine and cosine of geodetic latitude
*       (4)      magnitude of diurnal aberration vector
*       (5)      height (HM)
*       (6)      ambient temperature (T)
*       (7)      pressure (P)
*       (8)      relative humidity (RH)
*       (9)      wavelength (WL)
*       (10)     lapse rate (TLR)
*       (11,12)  refraction constants A and B (radians)
*       (13)     longitude + eqn of equinoxes + sidereal DUT (radians)
*       (14)     local apparent sidereal time (radians)
*
*  Returned:
*     RAP    d      geocentric apparent right ascension
*     DAP    d      geocentric apparent declination
*
*  Notes:
*
*  1)  Only the first character of the TYPE argument is significant.
*      'R' or 'r' indicates that OBS1 and OBS2 are the observed right
*      ascension and declination;  'H' or 'h' indicates that they are
*      hour angle (west +ve) and declination;  anything else ('A' or
*      'a' is recommended) indicates that OBS1 and OBS2 are azimuth
*      (north zero, east 90 deg) and zenith distance.  (Zenith distance
*      is used rather than elevation in order to reflect the fact that
*      no allowance is made for depression of the horizon.)
*
*  2)  The accuracy of the result is limited by the corrections for
*      refraction.  Providing the meteorological parameters are
*      known accurately and there are no gross local effects, the
*      predicted apparent RA,Dec should be within about 0.1 arcsec
*      for a zenith distance of less than 70 degrees.  Even at a
*      topocentric zenith distance of 90 degrees, the accuracy in
*      elevation should be better than 1 arcmin;  useful results
*      are available for a further 3 degrees, beyond which the
*      slRFRO routine returns a fixed value of the refraction.
*      The complementary routines slAOP (or slAOPQ) and slOAP
*      (or slOAPQ) are self-consistent to better than 1 micro-
*      arcsecond all over the celestial sphere.
*
*  3)  It is advisable to take great care with units, as even
*      unlikely values of the input parameters are accepted and
*      processed in accordance with the models used.
*
*  5)  "Observed" Az,El means the position that would be seen by a
*      perfect theodolite located at the observer.  This is
*      related to the observed HA,Dec via the standard rotation, using
*      the geodetic latitude (corrected for polar motion), while the
*      observed HA and RA are related simply through the local
*      apparent ST.  "Observed" RA,Dec or HA,Dec thus means the
*      position that would be seen by a perfect equatorial located
*      at the observer and with its polar axis aligned to the
*      Earth's axis of rotation (n.b. not to the refracted pole).
*      By removing from the observed place the effects of
*      atmospheric refraction and diurnal aberration, the
*      geocentric apparent RA,Dec is obtained.
*
*  5)  Frequently, mean rather than apparent RA,Dec will be required,
*      in which case further transformations will be necessary.  The
*      slAMP etc routines will convert the apparent RA,Dec produced
*      by the present routine into an "FK5" (J2000) mean place, by
*      allowing for the Sun's gravitational lens effect, annual
*      aberration, nutation and precession.  Should "FK4" (1950)
*      coordinates be needed, the routines slFK54 etc will also
*      need to be applied.
*
*  6)  To convert to apparent RA,Dec the coordinates read from a
*      real telescope, corrections would have to be applied for
*      encoder zero points, gear and encoder errors, tube flexure,
*      the position of the rotator axis and the pointing axis
*      relative to it, non-perpendicularity between the mounting
*      axes, and finally for the tilt of the azimuth or polar axis
*      of the mounting (with appropriate corrections for mount
*      flexures).  Some telescopes would, of course, exhibit other
*      properties which would need to be accounted for at the
*      appropriate point in the sequence.
*
*  7)  The star-independent apparent-to-observed-place parameters
*      in AOPRMS may be computed by means of the slAOPA routine.
*      If nothing has changed significantly except the time, the
*      slAOPT routine may be used to perform the requisite
*      partial recomputation of AOPRMS.
*
*  8) The azimuths etc used by the present routine are with respect
*     to the celestial pole.  Corrections from the terrestrial pole
*     can be computed using slPLMO.
*
*  Called:  slDS2C, slDC2S, slRFRO, slDA2P
*
*  Last revision:   29 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) TYPE
      DOUBLE PRECISION OB1,OB2,AOPRMS(14),RAP,DAP

*  Breakpoint for fast/slow refraction algorithm:
*  ZD greater than arctan(4), (see slRFCO routine)
*  or vector Z less than cosine(arctan(Z)) = 1/sqrt(17)
      DOUBLE PRECISION ZBREAK
      PARAMETER (ZBREAK=0.242535625D0)

      CHARACTER C
      DOUBLE PRECISION C1,C2,SPHI,CPHI,ST,CE,XAEO,YAEO,ZAEO,V(3),
     :                 XMHDO,YMHDO,ZMHDO,AZ,SZ,ZDO,TZ,DREF,ZDT,
     :                 XAET,YAET,ZAET,XMHDA,YMHDA,ZMHDA,DIURAB,F,HMA

      DOUBLE PRECISION slDA2P



*  Coordinate type
      C = TYPE(1:1)

*  Coordinates
      C1 = OB1
      C2 = OB2

*  Sin, cos of latitude
      SPHI = AOPRMS(2)
      CPHI = AOPRMS(3)

*  Local apparent sidereal time
      ST = AOPRMS(14)

*  Standardise coordinate type
      IF (C.EQ.'R'.OR.C.EQ.'r') THEN
         C = 'R'
      ELSE IF (C.EQ.'H'.OR.C.EQ.'h') THEN
         C = 'H'
      ELSE
         C = 'A'
      END IF

*  If Az,ZD convert to Cartesian (S=0,E=90)
      IF (C.EQ.'A') THEN
         CE = SIN(C2)
         XAEO = -COS(C1)*CE
         YAEO = SIN(C1)*CE
         ZAEO = COS(C2)
      ELSE

*     If RA,Dec convert to HA,Dec
         IF (C.EQ.'R') THEN
            C1 = ST-C1
         END IF

*     To Cartesian -HA,Dec
         CALL slDS2C(-C1,C2,V)
         XMHDO = V(1)
         YMHDO = V(2)
         ZMHDO = V(3)

*     To Cartesian Az,El (S=0,E=90)
         XAEO = SPHI*XMHDO-CPHI*ZMHDO
         YAEO = YMHDO
         ZAEO = CPHI*XMHDO+SPHI*ZMHDO
      END IF

*  Azimuth (S=0,E=90)
      IF (XAEO.NE.0D0.OR.YAEO.NE.0D0) THEN
         AZ = ATAN2(YAEO,XAEO)
      ELSE
         AZ = 0D0
      END IF

*  Sine of observed ZD, and observed ZD
      SZ = SQRT(XAEO*XAEO+YAEO*YAEO)
      ZDO = ATAN2(SZ,ZAEO)

*
*  Refraction
*  ----------

*  Large zenith distance?
      IF (ZAEO.GE.ZBREAK) THEN

*     Fast algorithm using two constant model
         TZ = SZ/ZAEO
         DREF = (AOPRMS(11)+AOPRMS(12)*TZ*TZ)*TZ

      ELSE

*     Rigorous algorithm for large ZD
         CALL slRFRO(ZDO,AOPRMS(5),AOPRMS(6),AOPRMS(7),AOPRMS(8),
     :                  AOPRMS(9),AOPRMS(1),AOPRMS(10),1D-8,DREF)
      END IF

      ZDT = ZDO+DREF

*  To Cartesian Az,ZD
      CE = SIN(ZDT)
      XAET = COS(AZ)*CE
      YAET = SIN(AZ)*CE
      ZAET = COS(ZDT)

*  Cartesian Az,ZD to Cartesian -HA,Dec
      XMHDA = SPHI*XAET+CPHI*ZAET
      YMHDA = YAET
      ZMHDA = -CPHI*XAET+SPHI*ZAET

*  Diurnal aberration
      DIURAB = -AOPRMS(4)
      F = (1D0-DIURAB*YMHDA)
      V(1) = F*XMHDA
      V(2) = F*(YMHDA+DIURAB)
      V(3) = F*ZMHDA

*  To spherical -HA,Dec
      CALL slDC2S(V,HMA,DAP)

*  Right Ascension
      RAP = slDA2P(ST+HMA)

      END

#-h-  uniqid			 1825  local   12/01/80  15:55:09
# uniqid - convert an identifier to one never before seen
   include  defs

subroutine uniqid (id)

character id (MAXTOK)
integer i, j, junk, idchl
external index
integer lookup, index, length
character start (MAXIDLENGTH)
include COMMON_BLOCKS
string idch "0123456789abcdefghijklmnopqrstuvwxyz" # legal id characters

   # Pad the identifer out to length 6 with FILLCHARs:
   for (i = 1; id (i) != EOS; i = i + 1)
      ;
   for (; i <= MAXIDLENGTH; i = i + 1)
      id (i) = FILLCHAR
   i = MAXIDLENGTH + 1
   id (i) = EOS
   id (i - 1) = FILLCHAR

   # Look it up in the table of generated names.  If it's not there,
   #  it's unique.  If it is there, it has been generated previously;
   #  modify it and try again.	Assume this procedure always succeeds,
   #  since to fail implies there are very, very many identifiers in
   #  the symbol table.
   #  Note that we must preserve the first and last characters of the
   #  id, so as not to disturb implicit typing and to provide a flag
   #  to catch potentially conflicting user-defined identifiers without
   #  a lookup.

   if (lookup (id, junk, gentbl) == YES) {   # (not very likely)
      idchl = length (idch)
      for (i = 2; i < MAXIDLENGTH; i = i + 1)
	 start (i) = id (i)
      repeat {	  # until we get a unique id
	 for (i = MAXIDLENGTH - 1; i > 1; i = i - 1) {
	    j = mod (index (idch, id (i)), idchl) + 1
	    id (i) = idch (j)
	    if (id (i) != start (i))
	       break
	    }
	 if (i == 1)
	    call baderr ("cannot make identifier unique.")
	 } until (lookup (id, junk, gentbl) == NO)
      }
end

      SUBROUTINE TSUPMA	(IERROR)
C
C LATEST REVISION	 AUGUST	1984
C
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF THE
C			 SUPMAP	AND MAPDRW ENTRYS OF EZMAPG.
C
C USAGE			 CALL TSUPMA (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			 = 0 IF	THE TEST WAS SUCCESSFUL
C			 = 1 OTHERWISE
C
C I/O			 IF EACH CALL TO ROUTINE SUPMAP	RESULTS	IN
C			 A NORMAL SUPMAP EXIT, THE MESSAGE
C			   SUPMAP TEST SUCCESSFUL  . .	SEE PLOT TO
C			   VERIFY PERFORMANCE
C			 IS PRINTED ON UNIT 6.
C
C			 TEN CONTINENTAL OUTLINE PLOTS,	EACH
C			 RESULTING FROM	A DIFFERENT SPECIFIED
C			 PROJECTION, ARE PRODUCED ON THE MACHINE
C			 GRAPHICS DEVICE.
C			 TO DETERMINE IF THE TEST WAS SUCCESSFUL,
C			 IT IS NECESSARY TO EXAMINE THESE PLOTS.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 EZMAPG
C FILES
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 SUBROUTINE TSUPMA CALLS ROUTINE SUPMAP	ONCE
C			 FOR EACH OF THE NINE PROJECTION TYPES
C			 IN SUPMAP.  SPECIFICALLY, THESE ARE
C			   STEREOGRAPHIC
C			   ORTHOGRAPHIC
C			   LAMBERT CONFORMAL CONIC WITH	TWO
C			     STANDARD PARALLELS
C			   LAMBERT EQUAL AREA
C			   GNOMONIC
C			   AZIMUTHAL EQUIDISTANT
C			   CYLINDRICAL EQUIDISTANT
C			   MERCATOR
C			   MOLLWEIDE TYPE
C			 THE ROUTINE THEN DEMONSTRATES THE SATELLITE VIEW
C			 PROJECTION.
C
C HISTORY		 WRITTEN OCTOBER, 1976
C
C PORTABILITY		 ANSI FORTRAN 77
C
C
C COMMON BLOCK FOR SATELLITE VIEW PROJECTION
C
      COMMON /SATMAP/ SL
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT PLOTTER GRID
C WHERE	THE  COORDINATES RANGE FROM 0.0	TO 1.0,	THE VALUES TX
C AND TY DEFINE	THE CENTER OF THE TITLE	STRING.
C
      DATA TX/0.5/, TY/0.9765/
C
C INITIALIZE ERROR FLAG
C
      IERROR = 0
C
C CHECK	PERFORMANCE CRITERION
C SPECIFY PARAMETERS BEFORE EACH SUPMAP	CALL
C
      IPROJ = 1
      POLAT = 80.
      POLONG = -160.
      ROT = 0.
      PL1 = 0.
      PL2 = 0.
      PL3 = 0.
      PL4 = 0.
      JLTS = 1
      JGRID = 10
      IUSOUT = -1
      IDOT = 0
C
C SELECT NORMALIZATION TRANS 0 TO WRITE	TITLE
C
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	STEREOGRAPHIC PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c     CALL NEWFM
      IF (IER .EQ. 0) GO TO 10
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   10 CONTINUE
C
C
      IPROJ = 2
      POLAT = 60.
      POLONG = -120.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	ORTHOGRAPHIC PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance handled by calling routine
c     CALL NEWFM
c -noao
      IF (IER .EQ. 0) GO TO  20
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   20 CONTINUE
C
C
      IPROJ = -3
      POLAT = 45.
      POLONG = -100.
      ROT = 45.
      PL1 = 50.
      PL2 = -130.
      PL3 = 20.
      PL4 = -75.
      JLTS = 2
      JGRID = 10
      IUSOUT = 1
      IDOT = 0
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1	      'SUPMAP DEMONSTRATION: LAMBERT CONFORMAL CONIC PROJECTION'
     2	      ,2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance is handled by calling routine
c     CALL NEWFM
c -noao
      IF (IER .EQ. 0) GO TO  30
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   30 CONTINUE
C
C
      IPROJ = 4
      POLAT = 20.
      POLONG = -40.
      ROT = 0.
      PL1 = 0.
      PL2 = 0.
      PL3 = 0.
      PL4 = 0.
      JLTS = 1
      JGRID = 10
      IUSOUT = -1
      IDOT = 0
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		'SUPMAP	DEMONSTRATION: LAMBERT EQUAL AREA PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance is handled by calling routine
c     CALL NEWFM
c -nooa
      IF (IER .EQ. 0) GO TO  40
C
C SUPMAP TEST UNSUCCESSFUL
C
C     WRITE (6,1001) IPROJ
      IERROR = 1
   40 CONTINUE
C
C
      IPROJ = 5
      POLAT = 0.
      POLONG = 0.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	GNOMONIC PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance handled by calling routine
c     CALL NEWFM
c -noao
      IF (IER .EQ. 0) GO TO  50
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   50 CONTINUE
C
C
      IPROJ = 6
      POLAT = -20.
      POLONG = 40.
      JGRID = 5
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1	     'SUPMAP DEMONSTRATION: AZIMUTHAL EQUIDISTANT PROJECTION',
     2	      2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance handled by calling routine
c     CALL NEWFM
c -noao
      IF (IER .EQ. 0) GO TO  60
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   60 CONTINUE
C
C
      IPROJ = 8
      POLAT = -40.
      POLONG = 80.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1	   'SUPMAP DEMONSTRATION: CYLINDRICAL EQUIDISTANT PROJECTION'
     2	   ,2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance handled by calling routine
c     CALL NEWFM
c -noao
      IF (IER .EQ. 0) GO TO  70
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   70 CONTINUE
C
C
      IPROJ = 9
      POLAT = -60.
      POLONG = 120.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	MERCATOR PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance handled by calling routine
c     CALL NEWFM
c -noao
      IF (IER .EQ. 0) GO TO  80
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   80 CONTINUE
C
C
      IPROJ = 10
      POLAT = -80.
      POLONG = 160.
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'SUPMAP DEMONSTRATION:	MOLLWEIDE TYPE PROJECTION',
     2		 2,0,0)
      CALL SUPMAP (IPROJ,POLAT,POLONG,ROT,PL1,PL2,PL3,PL4,JLTS,JGRID,
     1		   IUSOUT,IDOT,IER)
c +noao: frame advance handled by calling routine
c     CALL NEWFM
c -noao
      IF (IER .EQ. 0) GO TO 90
C
C SUPMAP TEST UNSUCCESSFUL
C
c     WRITE (6,1001) IPROJ
      IERROR = 1
   90 CONTINUE
C
C DEMONSTRATION	OF SATELLITE VIEW PROJECTION
C
      SL = 6.5
      CALL GSELNT (0)
      CALL WTSTR(TX,TY,
     1		 'EZMAPG DEMONSTRATION:	SATELLITE VIEW PROJECTION',
     2		 2,0,0)
      CALL MAPROJ('OR',0.0,-135.0,0.0)
      CALL MAPSET('MA',0.0,0.0,0.0,0.0)
      CALL MAPDRW
c +noao: frame advance handled by calling routine
c     CALL NEWFM
c -noao
C
C
c     IF (IERROR .EQ. 0) WRITE (6,1002)
c     IF (IERROR .EQ. 1) WRITE (6,1003)
      RETURN
C
C
c1001 FORMAT ('	SUPMAP RETURNED	ERROR FLAG','	IPROJ=',I4/)
c1002 FORMAT('	   SUPMAP TEST SUCCESSFUL',24X,
c    1	     'SEE PLOT TO VERIFY PERFORMANCE')
c1003 FORMAT ('	    SUPMAP TEST	UNSUCCESSFUL')
C
      END

c subroutine regres.f
c
c source
c   Bevington, pages 172-175.
c
c purpose
c   make a mulitple linear regression fit to data with a specified
c      function which is linear in coefficients
c
c usage
c   call regres (x, y, sigmay, npts, nterms, m, mode, yfit,
c      a0, a, sigma0, sigmaa, r, rmul, chisqr, ftest)
c
c description of parameters
c   x	   - array of points for independent variable
c   y	   - array of points for dependent variable
c   sigmay - array of standard deviations for y data points
c   npts   - number of pairs of data points
c   nterms - number of coefficients
c   m	   - array of inclusion/rejection criteria for fctn
c   mode   - determines method of weighting least-squares fit
c	     +1 (instrumental) weight(i) = 1./sigmay(i)**2
c	      0 (no weighting) weight(i) = 1.
c	     -1 (statistical)  weight(i) = 1./y(i)
c   yfit   - array of calculated values of y
c   a0	   - constant term
c   a	   - array of coefficients
c   sigma0 - standard deviation of a0
c   sigmaa - array of standard deviations for coefficients
c   r	   - array of linear correlation coefficients
c   rmul   - multiple linear correlation coefficient
c   chisqr - reduced chi square for fit
c   ftest  - value of f for test of fit
c
c subroutines and function subprograms required
c   fctn (x, i, j, m)
c      evaluates the function for the jth term and the ith data point
c      using the array m to specify terms in the function
c   matinv (array, nterms, det)
c      inverts a symmetric two-dimensional matrix of degree nterms
c      and calculates its determinant
c
c comments
c (dim npts changed 100->1000 21-may-84 dct)
c   dimension statement valid for npts up to 100 and nterms up to 10
c   sigmaag changed to sigmaa in statement following statement 132
c
      subroutine pfregs (x,y,sigmay,npts,nterms,m,mode,yfit,
     *a0,a,sigma0,sigmaa,r,rmul,chisqr,ftest,fctn)
      double precision array,sum,ymean,sigma,chisq,xmean,sigmax
      dimension x(1),y(1),sigmay(1),m(1),yfit(1),a(1),sigmaa(1),
     *r(1)
      dimension weight(1000),xmean(10),sigmax(10),array(10,10)
      external fctn
c
c initialize sums and arrays
c
11    sum=0.
      ymean=0.
      sigma=0.
      chisq=0.
      rmul=0.
      do 17 i=1,npts
17    yfit(i)=0.
21    do 28 j=1,nterms
      xmean(j)=0.
      sigmax(j)=0.
      r(j)=0.
      a(j)=0.
      sigmaa(j)=0.
      do 28 k=1,nterms
28    array(j,k)=0.
c
c accumulate weighted sums
c
30    do 50 i=1,npts
31    if (mode) 32,37,39
32    if (y(i)) 35,37,33
33    weight(i)=1./y(i)
      goto 41
35    weight(i)=1./(-y(i))
      goto 41
37    weight(i)=1.
      goto 41
39    weight(i)=1./sigmay(i)**2
41    sum=sum+weight(i)
      ymean=ymean+weight(i)*y(i)
      do 44 j=1,nterms
44    xmean(j)=xmean(j)+weight(i)*fctn(x,i,j,m)
50    continue
51    ymean=ymean/sum
      do 53 j=1,nterms
53    xmean(j)=xmean(j)/sum
      fnpts=npts
      wmean=sum/fnpts
      do 57 i=1,npts
57    weight(i)=weight(i)/wmean

c
c accumulate matrices r and array
c
61    do 67 i=1,npts
      sigma=sigma+weight(i)*(y(i)-ymean)**2
      do 67 j=1,nterms
      sigmax(j)=sigmax(j)+weight(i)*(fctn(x,i,j,m)-xmean(j))**2
      r(j)=r(j)+weight(i)*(fctn(x,i,j,m)-xmean(j))*(y(i)-ymean)
      do 67 k=1,j
67    array(j,k)=array(j,k)+weight(i)*(fctn(x,i,j,m)-xmean(j))*
     *(fctn(x,i,k,m)-xmean(k))
71    free1=npts-1
72    sigma=dsqrt(sigma/free1)
      do 78 j=1,nterms
74    sigmax(j)=dsqrt(sigmax(j)/free1)
      r(j)=r(j)/(free1*sigmax(j)*sigma)
      do 78 k=1,j
      array(j,k)=array(j,k)/(free1*sigmax(j)*sigmax(k))
78    array(k,j)=array(j,k)
c
c invert symmetric matrix
c
81    call matinv (array,nterms,det)
      if (det) 101,91,101
91    a0=0.
      sigma0=0.
      rmul=0.
      chisqr=0.
      ftest=0.
      goto 150
c
c calculate coefficients, fit, and chi square
c
101   a0=ymean
102   do 108 j=1,nterms
      do 104 k=1,nterms
104   a(j)=a(j)+r(k)*array(j,k)
105   a(j)=a(j)*sigma/sigmax(j)
106   a0=a0-a(j)*xmean(j)
107   do 108 i=1,npts
108   yfit(i)=yfit(i)+a(j)*fctn(x,i,j,m)
111   do 113 i=1,npts
      yfit(i)=yfit(i)+a0
113   chisq=chisq+weight(i)*(y(i)-yfit(i))**2
      freen=npts-nterms-1
115   chisqr=chisq*wmean/freen
c
c calculate uncertainties
c
121   if (mode) 122,124,122
122   varnce=1./wmean
      goto 131
124   varnce=chisqr
131   do 133 j=1,nterms
132   sigmaa(j)=array(j,j)*varnce/(free1*sigmax(j)**2)
      if (sigmaa(j)) 835, 835, 836
835   sigmaa(j) = 0.0
      goto 133
836   sigmaa(j)=sqrt(sigmaa(j))
133   rmul=rmul+a(j)*r(j)*sigmax(j)/sigma
      freej=nterms
c +noao: When rmul = 1, the following division (stmt 135) would blow up.
c        It has been changed so ftest is set to -99999. in this case.
      if (rmul) 935, 136, 136
935   ftest = -99999.
      rmul = -99999.
      goto 141
c -noao
136   if (1.0 - abs(rmul)) 1035, 1036, 1037
1035  rmul=-99999.
      ftest = -99999.
      goto 141
1036  ftest = -99999.
      rmul = 1.0
      goto 141
1037  ftest=(rmul/freej)/((1.-rmul)/freen)
      rmul=sqrt(rmul)
141   sigma0=varnce/fnpts
      do 145 j=1,nterms
      do 145 k=1,nterms
145   sigma0=sigma0+varnce*xmean(j)*xmean(k)*array(j,k)/
     *(free1*sigmax(j)*sigmax(k))
146   sigma0=sqrt(sigma0)
150   return
      end

C----------------------------------------------------------------------
        subroutine ftl2c(lval,cval,status)
C       convert a logical value to a C*20 right justified character string 
        integer status
        logical lval
        character*20 cval

        if (status .gt. 0)return

        if (lval)then
                cval='                   T'
        else
                cval='                   F'
        end if
        end

      SUBROUTINE TSRFAC	(nplot, IERROR)
C
C LATEST REVISION	 MARCH 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 SRFACE	AND TO TEST SRFACE ON A	SINGLE
C			 PROBLEM
C
C USAGE			 CALL TSRFAC (IERROR)
C
C ARGUMENTS
c +noao: additional input parameter
c			 nplot
c		 	   = 1, EZSRF is demonstrated
c			   = 2, SRFACE is demonstrated
c
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST IS SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   SRFACE TEST SUCCESSFUL  . . .  SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C
C			 IN ADDITION, TWO FRAMES CONTAINING THE
C			 SURFACE PLOT ARE PRODUCED ON THE MACHINE
C			 GRAPHICS DEVICE.  IN ORDER TO DETERMINE
C			 IF THE	TEST WAS SUCCESSFUL, IT	IS
C			 NECESSARY TO EXAMINE THESE PLOTS.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 SRFACE
C FILES
C
C LANGUAGE		 FORTRAN
C
C HISTORY		 FIRST WRITTEN IN APRIL	1979, CONVERTED	TO
C			 FORTRAN 77 AND	GKS IN MARCH 1984.
C
C ALGORITHM		 THE FUNCTION
C
C			   Z(X,Y) = .25*(X + Y + 1./((X-.1)**2+Y**2+.09)
C					  - 1./((X+.1)**2+Y**2+.09))
C
C			 IS EVALUATED FOR
C			   X = -1. TO 1. IN INCREMENTS OF .1 AND
C			   Y = -1.2 TO 1.2 IN INCREMENTS OF .1.
C			 TSRFAC	CALLS SUBROUTINES EZSRFC AND SRFACE
C			 ONCE.	EACH CALL PRODUCES A SURFACE PLOT
C			 OF THE	ARRAY Z.
C
C PORTABILITY		 ANSI FORTRAN 77
C
C XX CONTAINS THE X-DIRECTION COORDINATE VALUES	FOR Z(X,Y),  YY	CONTAINS
C THE Y-DIRECTION COORDINATE VALUES FOR	Z(X,Y),	 Z CONTAINS THE	FUNCTION
C VALUES,  S CONTAINS VALUES FOR THE LINE OF SIGHT FOR ENTRY SRFACE,
C WORK IS A WORK ARRAY,	 ANGH CONTAINS THE ANGLE IN DEGREES IN THE X-Y
C PLANE	TO THE LINE OF SIGHT,  ANGV CONTAINS THE ANGLE IN DEGREES FROM
C THE X-Y PLANE	TO THE LINE OF SIGHT.
C
      REAL	      XX(21)	 ,YY(25)     ,Z(21,25)	 ,S(6)	     ,
     1		      WORK(1096)
C
      DATA  S(1), S(2),	S(3), S(4), S(5), S(6)/
     1	    -8.0, -6.0,	 3.0,  0.0,  0.0,  0.0/
C
      DATA  ANGH/45./, ANGV/15./
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE COORDINATES RANGE	FROM 0.	TO 1., THE VALUES CX AND CY
C DEFINE THE CENTER OF THE TITLE STRING.
C
      DATA CX/.405/, CY/.97/
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 0
C
C FILL XX AND YY COORDINATE ARRAYS AND Z FUNCTION VALUE	ARRAY
C
      DO  20 I=1,21
	 X = .1*FLOAT(I-11)
	 XX(I) = X
	 DO  10	J=1,25
	    Y =	.1*FLOAT(J-13)
	    YY(J) = Y
	    Z(I,J) = (X+Y+1./((X-.1)**2+Y**2+.09)-
     1					    1./((X+.1)**2+Y**2+.09))*.25
   10	 CONTINUE
   20 CONTINUE
C
C SELECT NORMALIZATION TRANSFORMATION 0
C
      CALL GSELNT(0)
C
C EZSRFC DEMO
C
C LABEL	THE PLOT FOR ENTRY EZSRFC
C
C SET TEXT ALIGNMENT TO	CENTER THE STRING AT THE STRING	CENTER
C AND IN THE VERTICAL CENTER
C
      CALL GSTXAL(2,3)
C
C SET CHARACTER	HEIGHT
C
      CALL GSCHH(.016)
C
C PLOT CHARACTERS
C
      if (nplot .eq. 1) then
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR EZSRFC ENTRY OF SRFACE')
      CALL EZSRFC (Z,21,25,ANGH,ANGV,WORK)
      endif
C
C
C SRFACE DEMO
C
C LABEL	THE PLOT FOR ENTRY SRFACE
C
C SET TEXT ALIGNMENT TO	CENTER THE STRING AT THE STRING	CENTER
C AND IN THE VERTICAL CENTER
C
      CALL GSTXAL(2,3)
C
C SET CHARACTER	HEIGHT
C
      CALL GSCHH(.016)
C
C PLOT CHARACTERS
C
      if (nplot .eq. 2) then
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR SRFACE ENTRY OF SRFACE')
      CALL SRFACE (XX,YY,Z,WORK,21,21,25,S,0.)
      endif
C
c     WRITE (6,1001)
C
      RETURN
C
C1001 FORMAT ('	    SRFACE TEST	SUCCESSFUL',24X,
C    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

#-h-  balpar			  854  local   12/01/80  15:53:46
# balpar - copy balanced paren string
   include  defs

   subroutine balpar

   character t, token (MAXTOK)
   character gettok, gnbtok

   integer nlpar

   if (gnbtok (token, MAXTOK) != LPAREN) {
      call synerr ("missing left paren.")
      return
      }
   call outstr (token)
   nlpar = 1
   repeat {
      t = gettok (token, MAXTOK)
      if (t == SEMICOL | t == LBRACE | t == RBRACE | t == EOF) {
	 call pbstr (token)
	 break
	 }
      if (t == NEWLINE)      # delete newlines
	 token (1) = EOS
      else if (t == LPAREN)
	 nlpar = nlpar + 1
      else if (t == RPAREN)
	 nlpar = nlpar - 1
      if (t == ALPHA)
	 call squash (token)
      # else nothing special
      call outstr (token)
      } until (nlpar <= 0)

   if (nlpar != 0)
      call synerr ("missing parenthesis in condition.")

   return
   end

chapter xiii, example 2. cubic spline interpolant at knot averages
c			 with good knots.
c  from  * a practical guide to splines *  by c. de boor
calls splint(banfac/slv,bsplvb),newnot,bsplpp(bsplvb*)
c     parameter nmax=20,nmaxp6=26,nmaxp2=22,nmaxt7=140
      integer i,istep,iter,itermx,n,nhigh,nmk,nlow
c     real algerp,aloger,bcoef(nmaxp2),break(nmax),decay,dx,errmax,
c    *	  c(4,nmax),g,gtau(nmax),h,pnatx,scrtch(nmaxt7),step,t(nmaxp6),
c    *	  tau(nmax),tnew(nmax)
      real algerp,aloger,bcoef(22),break(20),decay,dx,errmax,
     *	  c(4,20),g,gtau(20),h,pnatx,scrtch(140),step,t(26),
     *	  tau(20),tnew(20),x
c     istep and step = float(istep) specify point density for error det-
c     ermination.
      data step, istep /20., 20/
c				the function  g  is to be interpolated .
      g(x) = sqrt(x+1.)
      decay = 0.
c      read in the number of iterations to be carried out and the lower
c      and upper limit for the number  n  of data points to be used.
      read 500,itermx,nlow,nhigh
  500 format(3i3)
      print 600, itermx
  600 format(i4,22h cycles through newnot//
     *	    28h  n   max.error	 decay exp./)
c				  loop over  n = number of data points .
      do 40 n=nlow,nhigh,2
    4	 nmk = n-4
	 h = 2./float(nmk+1)
	 do 5 i=1,4
	    t(i) = -1.
    5	    t(n+i) = 1.
	 if (nmk .lt. 1)		go to 10
	 do 6 i=1,nmk
    6	    t(i+4) = float(i)*h - 1.
   10	 iter = 1
c		construct cubic spline interpolant. then, itermx  times,
c		 determine new knots from it and find a new interpolant.
   11	    do 12 i=1,n
	       tau(i) = (t(i+1)+t(i+2)+t(i+3))/3.
   12	       gtau(i) = g(tau(i))
	    call splint ( tau, gtau, t, n, 4, scrtch, bcoef, iflag )
	    call bsplpp ( t, bcoef, n, 4, scrtch, break, c, l )
	    if (iter .gt. itermx)	go to 19
	    iter = iter + 1
	    call newnot ( break, c, l, 4, tnew, l, scrtch )
   15	    do 18 i=2,l
   18	       t(3+i) = tnew(i)
					go to 11
c		       estimate max.interpolation error on  (-1,1) .
   19	 errmax = 0.
c			    loop over polynomial pieces of interpolant .
	 do 30 i=1,l
	    dx = (break(i+1)-break(i))/step
c		 interpolation error is calculated at  istep  points per
c		     polynomial piece .
	    do 30 j=1,istep
	       h = float(j)*dx
	       pnatx = c(1,i)+h*(c(2,i)+h*(c(3,i)+h*c(4,i)/3.)/2.)
   30	    errmax = amax1(errmax,abs(g(break(i)+h)-pnatx))
c					      calculate decay exponent .
	 aloger = alog(errmax)
	 if (n .gt. nlow)  decay =
     *	     (aloger - algerp)/alog(float(n)/float(n-2))
	 algerp = aloger
c
   40	 print 640,n,errmax,decay
  640 format(i3,e12.4,f11.2)
					stop
      end

C--------------------------------------------------------------------------
        subroutine ftprec(ounit,record,status)

C       write a 80 character record to the FITS header
C
C       ounit   i  fortran output unit number
C       record  c  input 80 character header record
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) record
        character*80  rec
        integer ounit,status,ibuff

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------- -----------------------------

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

        if (dtstrt(ibuff) .gt. 0 
     &    .and.(dtstrt(ibuff)-hdend(ibuff)) .le. 80)then
C               not enough room in the header for another keyword

C               try getting more header space
                call ftiblk(ounit,1,0,status)
                if (status .gt. 0)then
                        go to 900
                end if
        end if
                
        rec=record

C       make sure keyword name is in upper case
        call ftupch(rec(1:8))

C       test that keyword name contains only legal characters
        call fttkey(rec(1:8),status)

C       test that the rest of the record contains only legal values
        call fttrec(rec(9:80),status)

C       position the I/O pointer to the end of the header
        call ftmbyt(ounit,hdend(ibuff),.true.,status)

C       append the 80 characters to the output buffer:
        call ftpcbf(ounit,1,80,rec,status)
        if (status .gt. 0)go to 900

C       increment the pointer to the last header record
        hdend(ibuff)=hdend(ibuff)+80
        nxthdr(ibuff)=hdend(ibuff)

900     continue
        end

      subroutine scopy (from, i, to, j)
      integer from (100), to (100)
      integer i, j
      integer k1, k2
      k2 = j
      k1 = i
23000 if (.not.(from (k1) .ne. -2))goto 23002
      to (k2) = from (k1)
      k2 = k2 + 1
23001 k1 = k1 + 1
      goto 23000
23002 continue
      to (k2) = -2
      return
      end

C 	This routine was copied from stsdas$pkg/analysis/gasp/gasplib/.
C	See stsdas$copyright.stsdas for copyright restrictions.
C 
	subroutine varsvd (v,ma,w,cvm,ncvm)
	parameter (mmax=20)
	real*8 v(ma,ma),w(ma),cvm(ncvm,ncvm),wti(mmax)
	real*8 sum

	do i=1,ma
		wti(i)=0.
		if(w(i).ne.0.0d0) wti(i)=1./(w(i)*w(i))
	enddo
	do i=1,ma
		do j=1,i
			sum=0.
			do k=1,ma
				sum=sum+v(i,k)*v(j,k)*wti(k)
			enddo
			cvm(i,j)=sum
			cvm(j,i)=sum
		enddo
	enddo
	return
	end

*> \brief \b SGEMM
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
*
*       .. Scalar Arguments ..
*       REAL ALPHA,BETA
*       INTEGER K,LDA,LDB,LDC,M,N
*       CHARACTER TRANSA,TRANSB
*       ..
*       .. Array Arguments ..
*       REAL A(LDA,*),B(LDB,*),C(LDC,*)
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGEMM  performs one of the matrix-matrix operations
*>
*>    C := alpha*op( A )*op( B ) + beta*C,
*>
*> where  op( X ) is one of
*>
*>    op( X ) = X   or   op( X ) = X**T,
*>
*> alpha and beta are scalars, and A, B and C are matrices, with op( A )
*> an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] TRANSA
*> \verbatim
*>          TRANSA is CHARACTER*1
*>           On entry, TRANSA specifies the form of op( A ) to be used in
*>           the matrix multiplication as follows:
*>
*>              TRANSA = 'N' or 'n',  op( A ) = A.
*>
*>              TRANSA = 'T' or 't',  op( A ) = A**T.
*>
*>              TRANSA = 'C' or 'c',  op( A ) = A**T.
*> \endverbatim
*>
*> \param[in] TRANSB
*> \verbatim
*>          TRANSB is CHARACTER*1
*>           On entry, TRANSB specifies the form of op( B ) to be used in
*>           the matrix multiplication as follows:
*>
*>              TRANSB = 'N' or 'n',  op( B ) = B.
*>
*>              TRANSB = 'T' or 't',  op( B ) = B**T.
*>
*>              TRANSB = 'C' or 'c',  op( B ) = B**T.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>           On entry,  M  specifies  the number  of rows  of the  matrix
*>           op( A )  and of the  matrix  C.  M  must  be at least  zero.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry,  N  specifies the number  of columns of the matrix
*>           op( B ) and the number of columns of the matrix C. N must be
*>           at least zero.
*> \endverbatim
*>
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>           On entry,  K  specifies  the number of columns of the matrix
*>           op( A ) and the number of rows of the matrix op( B ). K must
*>           be at least  zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is REAL
*>           On entry, ALPHA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is REAL array, dimension ( LDA, ka ), where ka is
*>           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
*>           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
*>           part of the array  A  must contain the matrix  A,  otherwise
*>           the leading  k by m  part of the array  A  must contain  the
*>           matrix A.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
*>           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*>           least  max( 1, k ).
*> \endverbatim
*>
*> \param[in] B
*> \verbatim
*>          B is REAL array, dimension ( LDB, kb ), where kb is
*>           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
*>           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
*>           part of the array  B  must contain the matrix  B,  otherwise
*>           the leading  n by k  part of the array  B  must contain  the
*>           matrix B.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>           On entry, LDB specifies the first dimension of B as declared
*>           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
*>           LDB must be at least  max( 1, k ), otherwise  LDB must be at
*>           least  max( 1, n ).
*> \endverbatim
*>
*> \param[in] BETA
*> \verbatim
*>          BETA is REAL
*>           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*>           supplied as zero then C need not be set on input.
*> \endverbatim
*>
*> \param[in,out] C
*> \verbatim
*>          C is REAL array, dimension ( LDC, N )
*>           Before entry, the leading  m by n  part of the array  C must
*>           contain the matrix  C,  except when  beta  is zero, in which
*>           case C need not be set on entry.
*>           On exit, the array  C  is overwritten by the  m by n  matrix
*>           ( alpha*op( A )*op( B ) + beta*C ).
*> \endverbatim
*>
*> \param[in] LDC
*> \verbatim
*>          LDC is INTEGER
*>           On entry, LDC specifies the first dimension of C as declared
*>           in  the  calling  (sub)  program.   LDC  must  be  at  least
*>           max( 1, m ).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup single_blas_level3
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 3 Blas routine.
*>
*>  -- Written on 8-February-1989.
*>     Jack Dongarra, Argonne National Laboratory.
*>     Iain Duff, AERE Harwell.
*>     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*>     Sven Hammarling, Numerical Algorithms Group Ltd.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE SGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
*
*  -- Reference BLAS level3 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      REAL ALPHA,BETA
      INTEGER K,LDA,LDB,LDC,M,N
      CHARACTER TRANSA,TRANSB
*     ..
*     .. Array Arguments ..
      REAL A(LDA,*),B(LDB,*),C(LDC,*)
*     ..
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*     .. Local Scalars ..
      REAL TEMP
      INTEGER I,INFO,J,L,NCOLA,NROWA,NROWB
      LOGICAL NOTA,NOTB
*     ..
*     .. Parameters ..
      REAL ONE,ZERO
      PARAMETER (ONE=1.0E+0,ZERO=0.0E+0)
*     ..
*
*     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
*     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
*     and  columns of  A  and the  number of  rows  of  B  respectively.
*
      NOTA = LSAME(TRANSA,'N')
      NOTB = LSAME(TRANSB,'N')
      IF (NOTA) THEN
          NROWA = M
          NCOLA = K
      ELSE
          NROWA = K
          NCOLA = M
      END IF
      IF (NOTB) THEN
          NROWB = K
      ELSE
          NROWB = N
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF ((.NOT.NOTA) .AND. (.NOT.LSAME(TRANSA,'C')) .AND.
     +    (.NOT.LSAME(TRANSA,'T'))) THEN
          INFO = 1
      ELSE IF ((.NOT.NOTB) .AND. (.NOT.LSAME(TRANSB,'C')) .AND.
     +         (.NOT.LSAME(TRANSB,'T'))) THEN
          INFO = 2
      ELSE IF (M.LT.0) THEN
          INFO = 3
      ELSE IF (N.LT.0) THEN
          INFO = 4
      ELSE IF (K.LT.0) THEN
          INFO = 5
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 8
      ELSE IF (LDB.LT.MAX(1,NROWB)) THEN
          INFO = 10
      ELSE IF (LDC.LT.MAX(1,M)) THEN
          INFO = 13
      END IF
      IF (INFO.NE.0) THEN
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR.
     +    (((ALPHA.EQ.ZERO).OR. (K.EQ.0)).AND. (BETA.EQ.ONE))) RETURN
*
*     And if  alpha.eq.zero.
*
      IF (ALPHA.EQ.ZERO) THEN
          IF (BETA.EQ.ZERO) THEN
              DO 20 J = 1,N
                  DO 10 I = 1,M
                      C(I,J) = ZERO
   10             CONTINUE
   20         CONTINUE
          ELSE
              DO 40 J = 1,N
                  DO 30 I = 1,M
                      C(I,J) = BETA*C(I,J)
   30             CONTINUE
   40         CONTINUE
          END IF
          RETURN
      END IF
*
*     Start the operations.
*
      IF (NOTB) THEN
          IF (NOTA) THEN
*
*           Form  C := alpha*A*B + beta*C.
*
              DO 90 J = 1,N
                  IF (BETA.EQ.ZERO) THEN
                      DO 50 I = 1,M
                          C(I,J) = ZERO
   50                 CONTINUE
                  ELSE IF (BETA.NE.ONE) THEN
                      DO 60 I = 1,M
                          C(I,J) = BETA*C(I,J)
   60                 CONTINUE
                  END IF
                  DO 80 L = 1,K
                      TEMP = ALPHA*B(L,J)
                      DO 70 I = 1,M
                          C(I,J) = C(I,J) + TEMP*A(I,L)
   70                 CONTINUE
   80             CONTINUE
   90         CONTINUE
          ELSE
*
*           Form  C := alpha*A**T*B + beta*C
*
              DO 120 J = 1,N
                  DO 110 I = 1,M
                      TEMP = ZERO
                      DO 100 L = 1,K
                          TEMP = TEMP + A(L,I)*B(L,J)
  100                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = ALPHA*TEMP
                      ELSE
                          C(I,J) = ALPHA*TEMP + BETA*C(I,J)
                      END IF
  110             CONTINUE
  120         CONTINUE
          END IF
      ELSE
          IF (NOTA) THEN
*
*           Form  C := alpha*A*B**T + beta*C
*
              DO 170 J = 1,N
                  IF (BETA.EQ.ZERO) THEN
                      DO 130 I = 1,M
                          C(I,J) = ZERO
  130                 CONTINUE
                  ELSE IF (BETA.NE.ONE) THEN
                      DO 140 I = 1,M
                          C(I,J) = BETA*C(I,J)
  140                 CONTINUE
                  END IF
                  DO 160 L = 1,K
                      TEMP = ALPHA*B(J,L)
                      DO 150 I = 1,M
                          C(I,J) = C(I,J) + TEMP*A(I,L)
  150                 CONTINUE
  160             CONTINUE
  170         CONTINUE
          ELSE
*
*           Form  C := alpha*A**T*B**T + beta*C
*
              DO 200 J = 1,N
                  DO 190 I = 1,M
                      TEMP = ZERO
                      DO 180 L = 1,K
                          TEMP = TEMP + A(L,I)*B(J,L)
  180                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = ALPHA*TEMP
                      ELSE
                          C(I,J) = ALPHA*TEMP + BETA*C(I,J)
                      END IF
  190             CONTINUE
  200         CONTINUE
          END IF
      END IF
*
      RETURN
*
*     End of SGEMM .
*
      END

C----------------------------------------------------------------------
        subroutine ftc2l(cval,lval,status)

C       convert a character string to a logical value
C       perform datatype conversion, if required

        logical lval
        integer ival,status
        character*(*) cval
        character*1 dtype
        character sval*16
        double precision dval


C       convert string to its intrinsic data type
        call ftc2x(cval,dtype,ival,lval,sval,dval,status)
        if (status .gt. 0)return

        if (dtype .ne. 'L')then
C              this is not a logical keyword, so return error
               status=404
               sval=cval
               call ftpmsg('Error in FTC2L evaluating this string '//
     &          'as a logical value: '//sval)
        end if
        end

c function pcorre.f
c
c source
c   Bevington, pages 124-125.
c
c purpose
c   evaluate probability for no correlation between two variables
c
c usage
c   result = pcorre (r, npts)
c
c description of parameters
c   r      - linear correlation coefficient
c   npts   - number of data points
c
c subroutines and function subprograms required
c   gamma (x)
c      calculates gamma function for integers and half-integers
c
	function pcorre (r,npts)
	double precision r2,term,sum,fi,fnum,denom
c
c evaluate number of degrees of freedom
c
11	nfree=npts-2
	if (nfree) 13,13,15
13	pcorre=0.
	goto 60
15	r2=r**2
	if (1.-r2) 13,13,17
17	neven=2*(nfree/2)
	if (nfree-neven) 21,21,41
c
c number of degrees of freedom is even
c
21	imax=(nfree-2)/2
	free=nfree
23	term=abs(r)
	sum=term
	if (imax) 60,26,31
26	pcorre=1.-term
	goto 60
31	do 36 i=1,imax
	fi=i
	fnum=imax-i+1
	denom=2*i+1
	term=-term*r2*fnum/fi
36	sum=sum+term/denom
	pcorre=1.128379167*(gamma((free+1.)/2.)/gamma(free/2.))
	pcorre=1.-pcorre*sum
	goto 60
c
c number of degrees of freedom is odd
c
41	imax=(nfree-3)/2
42	term=abs(r)*dsqrt(1.-r2)
43	sum=datan(r2/term)
	if (imax) 57,45,51
45	sum=sum+term
	goto 57
51	sum=sum+term
52	do 56 i=1,imax
	fnum=2*i
	denom=2*i+1
	term=term*(1.-r2)*fnum/denom
56	sum=sum+term
57	pcorre=1.-0.6366197724*sum
60	return
	end

      SUBROUTINE slPERM ( N, ISTATE, IORDER, J )
*+
*     - - - - - - -
*      P E R M U T
*     - - - - - - -
*
*  Generate the next permutation of a specified number of items.
*
*  Given:
*     N         i      number of items:  there will be N! permutations
*
*  Given and returned:
*     ISTATE    i(N)   state, ISTATE(1)=-1 to initialize
*
*  Returned:
*     IORDER    i(N)   next permutation of numbers 1,2,...,N
*     J         i      status: -1 = illegal N (zero or less is illegal)
*                               0 = OK
*                              +1 = no more permutations available
*
*  Notes:
*
*  1) This routine returns, in the IORDER array, the integers 1 to N
*     inclusive, in an order that depends on the current contents of
*     the ISTATE array.  Before calling the routine for the first
*     time, the caller must set the first element of the ISTATE array
*     to -1 (any negative number will do) to cause the ISTATE array
*     to be fully initialized.
*
*  2) The first permutation to be generated is:
*
*          IORDER(1)=N, IORDER(2)=N-1, ..., IORDER(N)=1
*
*     This is also the permutation returned for the "finished"
*     (J=1) case.
*
*     The final permutation to be generated is:
*
*          IORDER(1)=1, IORDER(2)=2, ..., IORDER(N)=N
*
*  3) If the "finished" (J=1) status is ignored, the routine continues
*     to deliver permutations, the pattern repeating every N! calls.
*
*  Last revision:   19 February 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER N,IORDER(N),ISTATE(N),J

      INTEGER I,IP1,ISLOT,ISKIP


*  -------------
*  Preliminaries
*  -------------

*  Validate, and set status.
      IF (N.LT.1) THEN
         J = -1
         GO TO 9999
      ELSE
         J = 0
      END IF

*  If just starting, initialize state array
      IF (ISTATE(1).LT.0) THEN
         ISTATE(1) = -1
         DO I=2,N
            ISTATE(I) = 0
         END DO
      END IF

*  --------------------------
*  Increment the state number
*  --------------------------

*  The state number, maintained in the ISTATE array, is a mixed-radix
*  number with N! states.  The least significant digit, with a radix of
*  1, is in ISTATE(1).  The next digit, in ISTATE(2), has a radix of 2,
*  and so on.

*  Increment the least-significant digit of the state number.
      ISTATE(1) = ISTATE(1)+1

*  Digit by digit starting with the least significant.
      DO I=1,N

*     Carry?
         IF (ISTATE(I).GE.I) THEN

*        Yes:  reset the current digit.
            ISTATE(I) = 0

*        Overflow?
            IF (I.GE.N) THEN

*           Yes:  there are no more permutations.
               J = 1
            ELSE

*           No:  carry.
               IP1 = I+1
               ISTATE(IP1) = ISTATE(IP1)+1
            END IF
         END IF
      END DO

*  -------------------------------------------------------------------
*  Translate the state number into the corresponding permutation order
*  -------------------------------------------------------------------

*  Initialize the order array.  All but one element will be overwritten.
      DO I=1,N
         IORDER(I) = 1
      END DO

*  Look at each state number digit, starting with the most significant.
      DO I=N,2,-1

*     Initialize the position where the new number will go.
         ISLOT = 0

*     The state number digit says which unfilled slot is to be used.
         DO ISKIP=0,ISTATE(I)

*        Increment the slot number until an unused slot is found.
            ISLOT = ISLOT+1
            DO WHILE (IORDER(ISLOT).GT.1)
               ISLOT = ISLOT+1
            END DO
         END DO

*     Store the number in the permutation order array.
         IORDER(ISLOT) = I
      END DO

 9999 CONTINUE

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGCHIL (IFLG,LBNM,LNNO)
C
      CHARACTER*(*) LBNM
C
C The routine AGCHIL is called by AGLBLS just before and just after each
C informational-label line of text is drawn.  The default version does
C nothing.  A user may supply a version to change the appearance of the
C text lines.  The arguments are as follows:
C
C - IFLG is zero if a text line is about to be drawn, non-zero if one
C   has just been drawn.
C
C - LBNM is the name of the label containing the line in question.
C
C - LNNO is the number of the line.
C
C Done.
C
      RETURN
C
      END

include	defs

# stcopy - copy string from in (i) to out (j), updating j, excluding EOS

   subroutine stcopy (in, i, out, j)
   character in (ARB), out (ARB)
   integer i, j

   integer k

   for (k = i; in (k) != EOS; k = k + 1) {
      out (j) = in (k)
      j = j + 1
      }
   out(j) = EOS
   return
   end

C--------------------------------------------------------------------------
        subroutine fticol(iunit,numcol,ttype,tform,status)

C       insert a new column into an existing table

C       iunit   i  Fortran I/O unit number
C       numcol  i  number (position) for the new column; 1 = first column
C                  any existing columns will be moved up one position
C       ttype   c  name of column (value for TTYPEn keyword)
C       tform   c  column format (value for TFORMn keyword)
C       status  i  returned error status (0=ok)

        integer iunit,numcol,status
        character*(*) ttype,tform

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,colnum,typhdu,datcod,repeat,width,decims,delbyt
        integer naxis1,naxis2,size,freesp,nblock,tflds,tbc,fstbyt,i
        character comm*70,tfm*30,keynam*8

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       test that the CHDU is an ASCII table or BINTABLE
        typhdu=hdutyp(ibuff)
        if (typhdu .ne. 1 .and. typhdu .ne. 2)then
                status=235
                call ftpmsg('Can only append column to TABLE or '//
     &          'BINTABLE extension (FTICOL)')
                return
        end if

C       check that the column number is valid
        tflds=tfield(ibuff)
        if (numcol .lt. 1)then
            status=302
            return
        else if (numcol .gt. tflds)then
            colnum=tflds+1
        else
            colnum=numcol
        end if

C       parse the tform value and calc number of bytes to add to each row
C       make sure format characters are in upper case:
        tfm=tform
        call ftupch(tfm)

        if (typhdu .eq. 1)then
            call ftasfm(tfm,datcod,width,decims,status)
C           add one space between the columns
            delbyt=width+1
        else
            call ftbnfm(tfm,datcod,repeat,width,status)
            if (datcod .eq. 1)then
C               bit column; round up to a multiple of 8 bits
                delbyt=(repeat+7)/8
            else if (datcod .eq. 16)then
C               ASCII string column
                delbyt=repeat
            else
C               numerical data type
                delbyt=(datcod/10)*repeat
            end if
        end if

C       quit on error, or if column is zero byte wide (repeat=0)
        if (status .gt. 0 .or. delbyt .eq. 0)return

C       get current size of the table
        naxis1=rowlen(ibuff)
        call ftgkyj(iunit,'NAXIS2',naxis2,comm,status)

C       Calculate how many more FITS blocks (2880 bytes) need to be added
        size=theap(ibuff)+scount(ibuff)
        freesp=(delbyt*naxis2) - ((size+2879)/2880)*2880 + size
        nblock=(freesp+2879)/2880

C       insert the needed number of new FITS blocks at the end of the HDU
        if (nblock .gt. 0)call ftiblk(iunit,nblock,1,status)

C       shift the heap down, and update pointers to start of heap
        size=delbyt*naxis2
        call fthpdn(iunit,size,status)

C       calculate byte position in the row where to insert the new column
        if (colnum .gt. tflds)then
            fstbyt=naxis1
        else
            fstbyt=tbcol(colnum+tstart(ibuff))
        end if

C       insert DELBYT bytes in every row, at byte position FSTBYT
        call ftcins(iunit,naxis1,naxis2,delbyt,fstbyt,status)

        if (typhdu .eq. 1)then
C           adjust the TBCOL values of the existing columns
            do 10 i=1,tflds
                call ftkeyn('TBCOL',i,keynam,status)
                call ftgkyj(iunit,keynam,tbc,comm,status)
                if (tbc .gt. fstbyt)then
                     tbc=tbc+delbyt
                     call ftmkyj(iunit,keynam,tbc,'&',status)
                end if
10          continue
        end if

C       update the mandatory keywords
        call ftmkyj(iunit,'TFIELDS',tflds+1,'&',status)
        call ftmkyj(iunit,'NAXIS1',naxis1+delbyt,'&',status)

C       increment the index value on any existing column keywords
        call ftkshf(iunit,colnum,tflds,1,status)

C       add the required keywords for the new column
        comm='label for field'
        call ftpkns(iunit,'TTYPE',colnum,1,ttype,comm,status)

        comm='format of field'
        call ftpkns(iunit,'TFORM',colnum,1,tfm,comm,status)

        if (typhdu .eq. 1)then
            comm='beginning column of field '
            if (colnum .eq. tflds+1)then
C               allow for the space between preceding column
                tbc=fstbyt+2
            else
                tbc=fstbyt+1
            end if
            call ftpknj(iunit,'TBCOL',colnum,1,tbc,comm,status)
        end if

C       parse the header to initialize the new table structure
        call ftrdef(iunit,status)
        end

      SUBROUTINE slRDPL (DATE, NP, ELONG, PHI, RA, DEC, DIAM)
*+
*     - - - - - - -
*      R D P L
*     - - - - - - -
*
*  Approximate topocentric apparent RA,Dec of a planet, and its
*  angular diameter.
*
*  Given:
*     DATE        d       MJD of observation (JD - 2400000.5)
*     NP          i       planet: 1 = Mercury
*                                 2 = Venus
*                                 3 = Moon
*                                 4 = Mars
*                                 5 = Jupiter
*                                 6 = Saturn
*                                 7 = Uranus
*                                 8 = Neptune
*                                 9 = Pluto
*                              else = Sun
*     ELONG,PHI   d       observer's east longitude and geodetic
*                                               latitude (radians)
*
*  Returned:
*     RA,DEC      d        RA, Dec (topocentric apparent, radians)
*     DIAM        d        angular diameter (equatorial, radians)
*
*  Notes:
*
*  1  The date is in a dynamical timescale (TDB, formerly ET) and is
*     in the form of a Modified Julian Date (JD-2400000.5).  For all
*     practical purposes, TT can be used instead of TDB, and for many
*     applications UT will do (except for the Moon).
*
*  2  The longitude and latitude allow correction for geocentric
*     parallax.  This is a major effect for the Moon, but in the
*     context of the limited accuracy of the present routine its
*     effect on planetary positions is small (negligible for the
*     outer planets).  Geocentric positions can be generated by
*     appropriate use of the routines slDMON and slPLNT.
*
*  3  The direction accuracy (arcsec, 1000-3000AD) is of order:
*
*            Sun              5
*            Mercury          2
*            Venus           10
*            Moon            30
*            Mars            50
*            Jupiter         90
*            Saturn          90
*            Uranus          90
*            Neptune         10
*            Pluto            1   (1885-2099AD only)
*
*     The angular diameter accuracy is about 0.4% for the Moon,
*     and 0.01% or better for the Sun and planets.
*
*  See the slPLNT routine for references.
*
*  Called: slGMST, slDT, slEPJ, slDMON, slPVOB, slPRNU,
*          slPLNT, slDMXV, slDC2S, slDA2P
*
*  P.T.Wallace   Starlink   26 May 1997
*
*  Copyright (C) 1997 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE
      INTEGER NP
      DOUBLE PRECISION ELONG,PHI,RA,DEC,DIAM

*  AU in km
      DOUBLE PRECISION AUKM
      PARAMETER (AUKM=1.49597870D8)

*  Light time for unit distance (sec)
      DOUBLE PRECISION TAU
      PARAMETER (TAU=499.004782D0)

      INTEGER IP,J,I
      DOUBLE PRECISION EQRAU(0:9),STL,VGM(6),V(6),RMAT(3,3),
     :                 VSE(6),VSG(6),VSP(6),VGO(6),DX,DY,DZ,R,TL
      DOUBLE PRECISION slGMST,slDT,slEPJ,slDA2P

*  Equatorial radii (km)
      DATA EQRAU / 696000D0,2439.7D0,6051.9D0,1738D0,3397D0,71492D0,
     :             60268D0,25559D0,24764D0,1151D0 /



*  Classify NP
      IP=NP
      IF (IP.LT.0.OR.IP.GT.9) IP=0

*  Approximate local ST
      STL=slGMST(DATE-slDT(slEPJ(DATE))/86400D0)+ELONG

*  Geocentre to Moon (mean of date)
      CALL slDMON(DATE,V)

*  Nutation to true of date
      CALL slNUT(DATE,RMAT)
      CALL slDMXV(RMAT,V,VGM)
      CALL slDMXV(RMAT,V(4),VGM(4))

*  Moon?
      IF (IP.EQ.3) THEN

*     Yes: geocentre to Moon (true of date)
         DO I=1,6
            V(I)=VGM(I)
         END DO
      ELSE

*     No: precession/nutation matrix, J2000 to date
         CALL slPRNU(2000D0,DATE,RMAT)

*     Sun to Earth-Moon Barycentre (J2000)
         CALL slPLNT(DATE,3,V,J)

*     Precession and nutation to date
         CALL slDMXV(RMAT,V,VSE)
         CALL slDMXV(RMAT,V(4),VSE(4))

*     Sun to geocentre (true of date)
         DO I=1,6
            VSG(I)=VSE(I)-0.012150581D0*VGM(I)
         END DO

*     Sun?
         IF (IP.EQ.0) THEN

*        Yes: geocentre to Sun
            DO I=1,6
               V(I)=-VSG(I)
            END DO
         ELSE

*        No: Sun to Planet (J2000)
            CALL slPLNT(DATE,IP,V,J)

*        Precession and nutation to date
            CALL slDMXV(RMAT,V,VSP)
            CALL slDMXV(RMAT,V(4),VSP(4))

*        Geocentre to planet
            DO I=1,6
               V(I)=VSP(I)-VSG(I)
            END DO
         END IF
      END IF

*  Refer to origin at the observer
      CALL slPVOB(PHI,0D0,STL,VGO)
      DO I=1,6
         V(I)=V(I)-VGO(I)
      END DO

*  Geometric distance (AU)
      DX=V(1)
      DY=V(2)
      DZ=V(3)
      R=SQRT(DX*DX+DY*DY+DZ*DZ)

*  Light time (sec)
      TL=TAU*R

*  Correct position for planetary aberration
      DO I=1,3
         V(I)=V(I)-TL*V(I+3)
      END DO

*  To RA,Dec
      CALL slDC2S(V,RA,DEC)
      RA=slDA2P(RA)

*  Angular diameter (radians)
      DIAM=2D0*ASIN(EQRAU(IP)/(R*AUKM))

      END

      SUBROUTINE slPM (R0, D0, PR, PD, PX, RV, EP0, EP1, R1, D1)
*+
*     - - -
*      P M
*     - - -
*
*  Apply corrections for proper motion to a star RA,Dec
*  (double precision)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Given:
*     R0,D0    dp     RA,Dec at epoch EP0 (rad)
*     PR,PD    dp     proper motions:  RA,Dec changes per year of epoch
*     PX       dp     parallax (arcsec)
*     RV       dp     radial velocity (km/sec, +ve if receding)
*     EP0      dp     start epoch in years (e.g. Julian epoch)
*     EP1      dp     end epoch in years (same system as EP0)
*
*  Returned:
*     R1,D1    dp     RA,Dec at epoch EP1 (rad)
*
*  Called:
*     slDS2C       spherical to Cartesian
*     slDC2S       Cartesian to spherical
*     slDA2P      normalize angle 0-2Pi
*
*  Notes:
*
*  1  The proper motions in RA are dRA/dt rather than cos(Dec)*dRA/dt,
*     and are in the same coordinate system as R0,D0.
*
*  2  If the available proper motions are pre-FK5 they will be per
*     tropical year rather than per Julian year, and so the epochs
*     must both be Besselian rather than Julian.  In such cases, a
*     scaling factor of 365.2422D0/365.25D0 should be applied to the
*     radial velocity before use.
*
*  P.T.Wallace   Starlink   19 January 2000
*
*  Copyright (C) 2000 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R0,D0,PR,PD,PX,RV,EP0,EP1,R1,D1

*  Km/s to AU/year multiplied by arcseconds to radians
      DOUBLE PRECISION VFR
      PARAMETER (VFR=(365.25D0*86400D0/149597870D0)*4.8481368111D-6)

      INTEGER I
      DOUBLE PRECISION slDA2P
      DOUBLE PRECISION W,EM(3),T,P(3)



*  Spherical to Cartesian
      CALL slDS2C(R0,D0,P)

*  Space motion (radians per year)
      W=VFR*RV*PX
      EM(1)=-PR*P(2)-PD*COS(R0)*SIN(D0)+W*P(1)
      EM(2)= PR*P(1)-PD*SIN(R0)*SIN(D0)+W*P(2)
      EM(3)=         PD*COS(D0)        +W*P(3)

*  Apply the motion
      T=EP1-EP0
      DO I=1,3
         P(I)=P(I)+T*EM(I)
      END DO

*  Cartesian to spherical
      CALL slDC2S(P,R1,D1)
      R1=slDA2P(R1)

      END

C--------------------------------------------------------------------------
        subroutine ftiimg(ounit,bitpix,naxis,naxes,status)

C       insert an IMAGE extension following the current HDU 

C       ounit   i  fortran output unit number
C       bitpix  i  number of bits per data value
C       naxis   i  number of axes in the data array
C       naxes   i  array giving the length of each data axis
C       status  i  returned error status (0=ok)

        integer ounit,bitpix,naxis,naxes(*),status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS:------------------------------------

        integer ibuff,nhdu,i,savstr,nblock

        if (status .gt. 0)return
        ibuff=bufnum(ounit)

C       close the current HDU to make sure END and fill values are written
        call ftchdu(ounit,status)
        if (status .gt. 0)return

C       save the starting address of the next HDU
        nhdu=chdu(ibuff)+1
        savstr=hdstrt(ibuff,nhdu)

C       define a fake CHDU with a one block header
        dtstrt(ibuff)=hdstrt(ibuff,chdu(ibuff))+2880

C       define the size of the new HDU (this modifies hdstrt(ibuff,nhdu))
        call ftpdef(ounit,bitpix,naxis,naxes,0,1,status)

C       use start of next HDU to calc. how big this new HDU is
        nblock=(hdstrt(ibuff,nhdu)-hdstrt(ibuff,nhdu-1))/2880

C       reset the start of the next HDU back to it original value
        hdstrt(ibuff,nhdu)=savstr

C       insert the required number of blocks at the end of the real CHDU
C       (first define hdutyp so that the correct fill value will be used) 
        hdutyp(ibuff)=0
        call ftiblk(ounit,nblock,1,status)
        if (status .gt. 0)return

C       increment the number of HDUs in the file and their starting address
        maxhdu(ibuff)=maxhdu(ibuff)+1
        do 10 i=maxhdu(ibuff),nhdu,-1
                hdstrt(ibuff,i+1)=hdstrt(ibuff,i)
10      continue

C       again, reset the start of the next HDU back to it original value
        hdstrt(ibuff,nhdu)=savstr

C       flush the buffers holding data for the old HDU
        call ftflsh(ibuff,status)

C       recover common block space containing column descriptors for old HDU
        call ftfrcl(ounit,status)

C       move to the new (empty) HDU
        chdu(ibuff)=nhdu

C       set parameters describing an empty 1 block header
        hdutyp(ibuff)=0
        nxthdr(ibuff)=hdstrt(ibuff,nhdu)
        hdend(ibuff)= hdstrt(ibuff,nhdu)
        dtstrt(ibuff)=hdstrt(ibuff,nhdu)+2888

C       write the header keywords
        call ftphpr(ounit,.true.,bitpix,naxis,naxes,0,1,.true.,status)

C       define the structure of the new HDU
        call ftpdef(ounit,bitpix,naxis,naxes,0,1,status)
        end

C--------------------------------------------------------------------------
        subroutine ftpkyt(ounit,keywrd,jval,dval,comm,status)

C       concatinate a integer value with a double precision fraction
C       and write it to the FITS header along with the comment string
C       The value will be displayed in F28.16 format
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       jval    i  integer part of the keyword value
C       dval    d  fractional part of the keyword value
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Sept 1992

        character*(*) keywrd,comm
        double precision dval
        integer ounit,jval,status,dlen
        character dstr*35,jstr*20,key*8,cmnt*48

        if (status .gt. 0)return

        if (dval .ge. 1.0  .or. dval .lt.  0.)then
                status = 402
        end if

        key=keywrd
        cmnt=comm

C       convert integer to C*20 character string
        call fti2c(jval,jstr,status)

C       convert double precision to E23.16 format character string
        call ftd2e(dval,20,dstr,dlen,status)

C       write the concatinated keyword record
        call ftprec(ounit,key//'= '//jstr(10:20)//'.'//
     1   dstr(2:2)//dstr(4:18)//' / '//cmnt,status)
        end

      subroutine pixel0(dx1,dy1,n1,dx2,dy2,n2)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      data ipixop / 10/
      mbpair = ior(ishift(ior(192, ipixop), 8), 12)
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      xx = dx1
      yy = dy1
      call dtran16
      mx1 = mx
      mbpair = mx
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      my1=my
      mbpair=my
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair=n1
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      xx = dx2
      yy = dy2
      call dtran16
      mbpair=mx
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair=my
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      mbpair=n2
      mipair = mipair + 1
      mbprs(mipair) = mbpair
      if (mipair .ge. 16) call flushb
      if(n1*n2*(mx1*my-mx*my1) .ne. 0) return
      call uliber(0,35h vectors not independent in pixel0.,35)
      call perror
      end

#-h-  whilec			  262  local   12/01/80  15:55:11
# whilec - generate code for beginning of while
   include  defs

   subroutine whilec (lab)

   integer lab
   integer labgen
   include COMMON_BLOCKS

   call outcon (0)    # unlabeled continue, in case there was a label
   lab = labgen (2)
   call outnum (lab)
   call ifgo (lab + 1)
   call indent (1)
   return
   end

      SUBROUTINE CONOP4 (IOPT,ARRAY,ISIZE,IFORT)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C SET THE CONTRAN OPTIONS
C
C INPUT
C     IOPT  --  CHARACTER STRING OF OPTION VALUE
C     ARRAY --  CHARACTER INPUT DATA
C     ISIZE --  INTEGER INPUT
C     IFORT --  INTEGER.  THIS VALUE IS USED ONLY WHEN IOPT IS
C               "FMT=ON".  IN THIS CASE, IFORT IS THE TOTAL NUMBER
C               OF CHARACTERS TO BE PROCESSED BY THE FORMAT
C               STATEMENT.  FOR EXAMPLE, FOR THE FORMAT "F10.3",
C               IFORT SHOULD BE SET TO 10.
C
C  SET COMMON DATA EQUAL TO INPUT DATA
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
C  INTPR IS THE DASH PACKAGE COMMON BLOCK INTERFACE
C  NP11 IS NP IN ALL OTHER INTPR DEFINITIONS; NAME CHANGE BECAUSE OF
C  CONFLICT
C
      COMMON /INTPR/  IPAU       ,FPART      ,TENSN      ,NP11       ,
     1                SMALL      ,L1         ,ADDLR      ,ADDTB      ,
     2                MLLINE     ,ICLOSE
        CHARACTER*(*)  ARRAY
        CHARACTER*7  IOPT
        CHARACTER*2  TAG, OPT
C
        SAVE
C
C +NOAO - initialize block data before changing any values
        call conbdn
c -NOAO
C  DETERMINE THE OPTION DESIRED
C
      TAG = IOPT(1:2)
        IF (IOPT(3:3) .EQ. '=') THEN
            OPT = IOPT(4:5)
        ELSE
            OPT = IOPT(5:6)
        ENDIF
C
C  TITLE OPTION GET VALUE OF SWITCH
C
      IF (TAG .EQ. 'TL') THEN
C
C  SWITCH ON GET TITLE AND COUNT FROM INPUT
C
            IF (OPT .EQ. 'ON') THEN
              TITLE = .TRUE.
                ISTRNG = ARRAY
                  ICNT = ISIZE
              RETURN
C
C  SWITCH OFF OPTION DEACTIVATED
C
            ELSEIF (OPT .EQ. 'OF') THEN
              TITLE = .FALSE.
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  CHANGE DATA VALUE FORMAT
C
      ELSEIF (TAG .EQ. 'FM') THEN
C
C  SWITCH ON GET USER FORMAT
C
          IF (OPT .EQ. 'ON') THEN
                FORM = ARRAY
              LEN = ISIZE
              IFMT = IFORT
              RETURN
C
C SWITCH OFF SET FORMAT TO DEFAULT
C
            ELSEIF (OPT .EQ. 'OF') THEN
                FORM = '(G10.3)'
                  LEN = LEND
              IFMT = IFMTD
              RETURN
          ELSE
                  GOTO 120
            ENDIF
C
C  DASH PATTERN OPTION GET VALUE OF SWITCH
C
      ELSEIF (TAG .EQ. 'DA') THEN
C
C  SWITCH OFF DEFAULT PATTERNS
C
          IF (OPT .EQ. 'OF') THEN
                  NDASH = '$$$$$$$$$$'
                  EDASH = '$$$$$$$$$$'
                  IDASH = '$$$$$$$$$$'
                  RETURN
C
C  SWITCH ALL SET GTR,LSS,AND EQU TO SAME VALUE
C
          ELSEIF (OPT .EQ. 'AL') THEN
                  IDASH = ARRAY
                  EDASH = ARRAY
                  NDASH = ARRAY
                  RETURN
C
C  SWITCH SET TO POS CHANGE POS DASH PATTERN
C
          ELSEIF (OPT .EQ. 'GT') THEN
                  IDASH = ARRAY
                  RETURN
C
C  SWITCH SET TO NEG SET NEG DASH PATTERN
C
          ELSEIF (OPT .EQ. 'LS') THEN
                  NDASH = ARRAY
                  RETURN
C
C  SWITCH SET TO EQU SET EQUAL DASH PATTERN
C
          ELSEIF (OPT .EQ. 'EQ') THEN
                EDASH = ARRAY
                RETURN
          ELSE
                  GOTO 120
            ENDIF
        ELSE
            GOTO 120
        ENDIF
C
C  ERROR UNDEFINED OPTION DETECTED
C
  120 CALL SETER (' CONOP4-UNDEFINED OPTION',1,1)
      RETURN
        END

C--------------------------------------------------------------------------
        subroutine ftcdel(iunit,naxis1,naxis2,delbyt,fstbyt,status)

C       delete a specified column by shifting the rows

C       iunit   i  Fortran I/O unit number
C       naxis1  i  width in bytes of existing table
C       naxis2  i  number of rows in the table
C       delbyt  i  how many bytes to delete in each row
C       fstbyt  i  byte position in the row to delete the bytes (0=row start)
C       status  i  returned error status (0=ok)

        integer iunit,naxis1,naxis2,delbyt,fstbyt,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,i,i1,i2,irow,newlen,nseg,nbytes,remain

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

        newlen=naxis1-delbyt

        if (newlen .le. 5760)then
C ***********************************************************************
C       CASE #1: optimal case where whole new row fits in the work buffer
C ***********************************************************************
            i1=fstbyt+1
            i2=i1+delbyt
            do 10 irow=1,naxis2-1
C               read the row to be shifted 
                call ftgtbs(iunit,irow,i2,newlen,buff,status)

C               set row length to its new value
                rowlen(ibuff)=newlen

C               write the row in the new place
                call ftptbs(iunit,irow,i1,newlen,buff,status)

C               reset row length to its original value
                rowlen(ibuff)=naxis1
10          continue

C           now do the last row
            remain=naxis1-(fstbyt+delbyt)
            if (remain .gt. 0)then
C               read the row to be shifted 
                call ftgtbs(iunit,naxis2,i2,remain,buff,status)

C               set row length to its new value
                rowlen(ibuff)=newlen

C               write the row in the new place
                call ftptbs(iunit,naxis2,i1,remain,buff,status)

C               reset row length to its original value
                rowlen(ibuff)=naxis1
            end if
        else
C ************************************************************************
C       CASE #2:  whole row doesn't fit in work buffer; move row in pieces
C ************************************************************************
            nseg=(newlen+5759)/5760

            do 40 irow=1,naxis2-1
                i1=fstbyt+1
                i2=i1+delbyt
                nbytes=newlen-(nseg-1)*5760

                do 30 i=1,nseg
C                   read the row to be shifted
                    call ftgtbs(iunit,irow,i2,nbytes,buff,status)

C                   set row length to its new value
                    rowlen(ibuff)=newlen

C                   write the row in the new place
                    call ftptbs(iunit,irow,i1,nbytes,buff,status)

C                   reset row length to its original value
                    rowlen(ibuff)=naxis1

                    i1=i1+nbytes
                    i2=i2+nbytes
                    nbytes=5760
30              continue
40          continue

C           now do the last row
            remain=naxis1-(fstbyt+delbyt)
            if (remain .gt. 0)then
                nseg=(remain+5759)/5760
                i1=fstbyt+1
                i2=i1+delbyt
                nbytes=remain-(nseg-1)*5760

                do 50 i=1,nseg
C                   read the row to be shifted 
                    call ftgtbs(iunit,naxis2,i2,nbytes,buff,status)

C                   set row length to its new value
                    rowlen(ibuff)=newlen

C                   write the row in the new place
                    call ftptbs(iunit,naxis2,i1,nbytes,buff,status)

C                   reset row length to its original value
                    rowlen(ibuff)=naxis1

                    i1=i1+nbytes
                    i2=i2+nbytes
                    nbytes=5760
50              continue
            end if
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftgnst(iunit,value,lenval,comm,status)

C       get the next string keyword.
C       see if the next keyword in the header is the continuation
C       of a long string keyword, and if so, return the value string,
C       the number of characters in the string, and the associated comment
C       string.

C       value  c  returned value of the string continuation
C       lenval i  number of non-blank characters in the continuation string
C       comm   C  value of the comment string, if any, in this keyword.

        character*(*) value,comm
        integer iunit,lenval,status

        integer i,length,tstat,nkeys,nextky
        character record*80, strval*70

        if (status .gt. 0)return

        tstat=status
        value=' '
        comm=' '
        lenval=0

C       get current header position
        call ftghps(iunit,nkeys,nextky,status)

C       get the next keyword record
        if (nextky .le. nkeys)then
            call ftgrec(iunit,nextky,record,status)
        else
C           positioned at end of header, so there is no next keyword to read
            return
        end if

C       does this appear to be a continuation keyword (=blank keyword name
C       or CONTINUE)?
        if (record(1:10) .ne. ' ' .and. record(1:10) .ne. 
     &     'CONTINUE  ')return

C       return if record is blank
        if (record .eq. ' ')return

C       set a dummy keyword name
        record(1:10)='DUMMYKEY= '

C       parse the record to get the value string and comment
        call ftpsvc(record,strval,comm,status)

C       convert character string to unquoted string
        call ftc2s(strval,value,status)
        if (status .gt. 0)then
C               this must not be a continuation card; reset status and messages
                status=tstat
                call ftcmsg
                value=' '
                comm=' '
                return
        end if

        length=len(value)
        do 10 i=length,1,-1
                if (value(i:i) .ne. ' ')then
                        lenval=i
                        return
                end if
10      continue
        end

C----------------------------------------------------------------------
        subroutine ftgtbh(iunit,ncols,nrows,nfield,ttype,tbcol,
     &                    tform,tunit,extnam,status)

C       OBSOLETE routine: should call ftghtb instead

        integer iunit,ncols,nrows,nfield,status,tbcol(*)
        character*(*) ttype(*),tform(*),tunit(*),extnam

        call ftghtb(iunit,0,ncols,nrows,nfield,ttype,
     &                    tbcol,tform,tunit,extnam,status)
        end

include	defs

# scopy - copy string at from (i) to to (j)

   subroutine scopy (from, i, to, j)
   character from (ARB), to (ARB)
   integer i, j

   integer k1, k2

   k2 = j
   for (k1 = i; from (k1) != EOS; k1 = k1 + 1) {
      to (k2) = from (k1)
      k2 = k2 + 1
      }
   to (k2) = EOS

   return
   end

C------------------------------------------------------------------------------
        subroutine ftxypx(xpos,ypos,xref,yref,xrefpix,yrefpix,
     &                    xinc,yinc,rot,type,xpix,ypix,status)

C       Fortran version of worldpos.c -- WCS Algorithms from Classic AIPS
C       Translated by James Kent Blackburn -- HEASARC/GSFC/NASA -- November 1994
C       routine to determine accurate pixel coordinates from an RA and Dec
C       does: -SIN, -TAN, -ARC, -NCP, -GLS, -MER, -AIT projections
C       returns   0 = good, 
C               501 = angle too large for projection;
C               502 = bad values
C               503 = ???undocumented error - looks like an underflow???
C Input:
C dbl   xpos   x (RA) coordinate (deg)
C dbl   ypos   y (dec) coordinate (deg)
C dbl   xref    x reference coordinate value (deg)
C dbl   yref    y reference coordinate value (deg)
C dbl   xrefpix x reference pixel
C dbl   yrefpix y reference pixel
C dbl   xinc    x coordinate increment (deg)
C dbl   yinc    y coordinate increment (deg)
C dbl   rot     rotation (deg)  (from N through E)
C chr   type    projection type code e.g. "-SIN"
C Output:
C dbl   xpix    x pixel number  (RA or long without rotation)
C dbl   ypiy    y pixel number  (dec or lat without rotation)
C int   status  error status flag, zero

        integer           status
        double precision  xpos,ypos,xref,yref,xrefpix,yrefpix
        double precision  xinc,yinc,rot,xpix,ypix
        character*(*)     type
        integer           error1,error2,error3,error4
        parameter         (error1=501)
        parameter         (error2=502)
        parameter         (error3=503)
        parameter         (error4=504)
        double precision  dx,dy,dz,r,ra0,dec0,ra,dec
        double precision  coss,sins,dt,da,dd,sint,oldxpos
        double precision  l,m,geo1,geo2,geo3,sinr,cosr
        double precision  cond2r
        parameter         (cond2r=1.745329252d-2)
        double precision  twopi,deps
        parameter         (twopi = 6.28318530717959)
        parameter         (deps = 1.0d-5)
        integer           i,itype
        character*4       ctypes(8)
        data ctypes/ '-SIN', '-TAN', '-ARC', '-NCP',
     &               '-GLS', '-MER', '-AIT', '-STG' /

        if (status .gt. 0) return
C   *** 0 hour wrap around test
        oldxpos = xpos
        dt = (xpos - xref)
        if (dt .gt. +180) xpos = xpos - 360
        if (dt .lt. -180) xpos = xpos + 360
C   *** Default values - Linear
        dx = xpos - xref
        dy = ypos - yref
        dz = 0.0
C   *** Correct for rotation
        r = rot * cond2r
        cosr = dcos(r)
        sinr = dsin(r)
        dz = dx * cosr + dy * sinr
        dy = dy * cosr - dx * sinr
        dx = dz
C   *** Check axis increments - bail out if either 0
        if ((xinc .eq. 0.0) .or. (yinc .eq. 0.0)) then
          xpix = 0.0
          ypix = 0.0
          status = error2
          goto 30
        end if
        xpix = dx / xinc + xrefpix
        ypix = dy / yinc + yrefpix
C   *** Find type of coordinate transformation (0 is linear)
        itype = 0
        do 10 i = 1, 8
          if (ctypes(i) .eq. type) itype = i
  10    continue
C   *** Done if linear
        if (itype .eq. 0) goto 30
C   *** Non-Linear position
        ra0 = xref * cond2r
        dec0 = yref * cond2r
        ra = xpos * cond2r
        dec = ypos * cond2r
C   *** Compute directional cosine
        coss = dcos(dec)
        sins = dsin(dec)
        l = dsin(ra-ra0) * coss
        sint = sins * dsin(dec0) + coss * dcos(dec0) * dcos(ra-ra0)
C   *** Process by case
        if (itype .eq. 1) then
C   *** SINE from '-SIN' type
          if (sint .lt. 0.0) then 
            status = error1
            goto 30
          end if
          m = sins * dcos(dec0) - coss * dsin(dec0) * dcos(ra-ra0)
        else if (itype .eq. 2) then
C   *** TANGENT from '-TAN' type
          if (sint .le. 0.0) then 
            status = error1
            goto 30
          end if
          m = sins * dsin(dec0) + coss * dcos(dec0) * dcos(ra-ra0)
          l = l / m
          m = (sins*dcos(dec0) - coss*dsin(dec0)*dcos(ra-ra0)) / m
        else if (itype .eq. 3) then
C   *** Arc from '-ARC' type
          m = sins*dsin(dec0) + coss*dcos(dec0)*dcos(ra-ra0)
          if (m .lt. -1.0) m = -1.0
          if (m .gt. 1.0) m = 1.0
          m = dacos(m)
          if (m .ne. 0) then
            m = m / dsin(m)
          else
            m = 1.0
          end if
          l = l * m
          m = (sins*dcos(dec0) - coss*dsin(dec0)*dcos(ra-ra0)) * m
        else if (itype .eq. 4) then
C   *** North Celestial Pole from '-NCP' type
          if (dec0 .eq. 0.0) then
            status = error1
            goto 30
          else
            m = (dcos(dec0) - coss * dcos(ra-ra0)) / dsin(dec0)
          end if
        else if (itype .eq. 5) then
C   *** Global Sinusoid from '-GLS' type
          dt = ra - ra0
          if (dabs(dec) .gt. twopi/4.0) then 
            status = error1
            goto 30
          end if
          if (dabs(dec0) .gt. twopi/4.0) then 
            status = error1
            goto 30
          end if
          m = dec - dec0
          l = dt * coss
        else if (itype .eq. 6) then
C   *** Mercator from '-MER' type
          dt = yinc * cosr + xinc * sinr
          if (dt .eq. 0.0) dt = 1.0
          dy = (yref/2.0 + 45.0) * cond2r
          dx = dy + dt / 2.0 * cond2r
          dy = dlog(dtan(dy))
          dx = dlog(dtan (dx))
          geo2 = dt * cond2r / (dx - dy)
          geo3 = geo2 * dy
          geo1 = cos (yref * cond2r)
          if (geo1 .le. 0.0) geo1 = 1.0
          dt = ra - ra0
          l = geo1 * dt
          dt = dec / 2.0 + twopi / 8.0
          dt = dtan(dt)
          if (dt .lt. deps) then 
            status = error2
            goto 30
          end if
          m = geo2 * dlog(dt) - geo3
        else if (itype .eq. 7) then
C   *** Aitoff from '-AIT' type
          l = 0.0
          m = 0.0
          da = (ra - ra0) / 2.0
          if (dabs(da) .gt. twopi/4.0) then
            status = error1
            goto 30
          end if
          dt = yinc * cosr + xinc * sinr
          if (dt .eq. 0.0) dt = 1.0
          dt = dt * cond2r
          dy = yref * cond2r
          dx = dsin(dy+dt)/dsqrt((1.0+dcos(dy+dt))/2.0) -
     &         dsin(dy)/dsqrt((1.0+dcos(dy))/2.0)
          if (dx .eq. 0.0) dx = 1.0
          geo2 = dt / dx
          dt = xinc * cosr - yinc * sinr
          if (dt .eq. 0.0) dt = 1.0
          dt = dt * cond2r
          dx = 2.0 * dcos(dy) * dsin(dt/2.0)
          if (dx .eq. 0.0) dx = 1.0
          geo1 = dt*dsqrt((1.0+dcos(dy)*dcos(dt/2.0))/2.0)/dx
          geo3 = geo2 * dsin(dy) / dsqrt((1.0+dcos(dy))/2.0)
          dt = dsqrt ((1.0 + dcos(dec) * dcos(da))/2.0)
          if (dabs(dt) .lt. deps) then
            status = error3
            goto 30
          end if
          l = 2.0 * geo1 * dcos(dec) * dsin(da) / dt
          m = geo2 * dsin(dec) / dt - geo3
        else if (itype .eq. 8) then
C   *** Stereographic from '-STG' type
          da = ra - ra0
          if (dabs(dec) .gt. twopi/4.0) then
            status = error1
            goto 30
          end if
          dd = 1.0 + sins*dsin(dec0) + coss*dcos(dec0)*dcos(da)
          if (dabs(dd) .lt. deps) then 
            status = error1
            goto 30
          end if
          dd = 2.0 / dd
          l = l * dd
          m = dd * (sins*dcos(dec0) - coss*dsin(dec0)*dcos(da))
        else
C   *** Unsupported Projection
          status = error4
          goto 30
        end if
C   *** Convert back to degrees
        dx = l / cond2r
        dy = m / cond2r
C   *** Correct for rotation
        dz = dx * cosr + dy * sinr
        dy = dy * cosr - dx * sinr
        dx = dz
C   *** Convert to PIXELS ... yeah!
        xpix = dx / xinc + xrefpix
        ypix = dy / yinc + yrefpix
  30    continue
C   *** reset xpos to correct for in place modification
        xpos = oldxpos
        end

C--------------------------------------------------------------------------
        subroutine ftdrec(ounit,pos,status)

C       delete keyword record at position POS from header
C
C       ounit   i  fortran output unit number
C       pos     i  position of keyword to be deleted (1 = first keyword)
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, Jan 1995

        integer ounit,pos,status

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------- -----------------------------

        character*80 keybuf,keytmp
        integer ibuff,i,j,nshift

        if (status .gt. 0)return

C       get the number of the data buffer used for this unit
        ibuff=bufnum(ounit)

        if (pos .lt. 1 .or. pos .gt. 
     &     (hdend(ibuff)-hdstrt(ibuff,chdu(ibuff)))/80)then
                status=203
                return
        end if

        nxthdr(ibuff)=hdstrt(ibuff,chdu(ibuff))+(pos-1)*80

C       calculate number of header records following the deleted record
        nshift=(hdend(ibuff)-nxthdr(ibuff))/80

C       go through header shifting each 80 byte record up one place to
C       fill in the gap created by the deleted keyword
        j=hdend(ibuff)
        keybuf=' '
        do 10 i=1,nshift
                j=j-80
C               read current record contents
                call ftmbyt(ounit,j,.false.,status)
                call ftgcbf(ounit,0,80,keytmp,status)
C               overwrite with new contents
                call ftmbyt(ounit,j,.false.,status)
                call ftpcbf(ounit,0,80,keybuf,status)
                keybuf=keytmp
10      continue

C       update end-of-header pointer
        hdend(ibuff)=hdend(ibuff)-80

100     continue
        end

c function gamma.f
c
c source
c   Bevington, page 126.
c
c purpose
c   calculate the gamma function for integers and half-integers
c
c usage
c   result = gamma (x)
c
c description of parameters
c   x      - integer or half-integer
c
c subroutines or function subprograms required
c   factor (n)
c      calculates n factorial for integers
c
	function gamma (x)
	double precision prod,sum,fi
c
c integerize argument
c
11	n=x-0.25
	xn=n
13	if (x-xn-0.75) 31,31,21
c
c argument is integer
c
21	gamma=factor(n)
	goto 60
c
c argument is half-integer
c
31	prod=1.77245385
	if (n) 44,44,33
33	if (n-10) 41,41,51
41	do 43 i=1,n
	fi=i
43	prod=prod*(fi-0.5)
44	gamma=prod
	goto 60
51	sum=0.
	do 54 i=11,n
	fi=i
54	sum=sum+dlog(fi-0.5)
55	gamma=prod*639383.8623*dexp(sum)
60	return
	end

C--------------------------------------------------------------------------
        subroutine ftkeyn(keywrd,nseq,keyout,status)

C       Make a keyword name by concatinating the root name and a 
C       sequence number

C       keywrd  c  root keyword name
C       nseq    i  sequence number 
C       OUTPUT PARAMETERS:
C       keyout  c  output concatinated keyword name
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, February 1991

        character*(*) keywrd
        integer nseq,status,nspace,i
        character keyout*8,value*20

        keyout=keywrd

C       find end of keyword string
        nspace=1
        do 10 i=1,8
                if (keyout(i:i) .eq. ' ')go to 15
                nspace=nspace+1
10      continue
15      continue

C       append sequence number to keyword root only if there is room
        if (nseq .lt. 0)then
C               illegal value
                go to 900
        else if (nseq .lt. 10 .and. nspace .le. 8)then
                write(keyout(nspace:nspace),1001,err=900)nseq
        else if (nseq .lt. 100 .and. nspace .le. 7)then
                write(keyout(nspace:nspace+1),1002,err=900)nseq
        else if (nseq .lt. 1000 .and. nspace .le. 6)then
                write(keyout(nspace:nspace+2),1003,err=900)nseq
        else if (nseq .lt. 10000 .and. nspace .le. 5)then
                write(keyout(nspace:nspace+3),1004,err=900)nseq
        else if (nseq .lt. 100000 .and. nspace .le. 4)then
                write(keyout(nspace:nspace+4),1005,err=900)nseq
        else if (nseq .lt. 1000000 .and. nspace .le. 3)then
                write(keyout(nspace:nspace+5),1006,err=900)nseq
        else if (nseq .lt. 10000000 .and. nspace .le. 2)then
                write(keyout(nspace:nspace+6),1007,err=900)nseq
        else
C               number too big to fit in keyword
                go to 900
        end if

1001    format(i1)
1002    format(i2)
1003    format(i3)
1004    format(i4)
1005    format(i5)
1006    format(i6)
1007    format(i7)

        return
C       come here if error concatinating the seq. no. to the root string
900     continue

        if (status .gt. 0)return
        status=206
        write(value,1008)nseq
1008    format(i20)
        call ftpmsg('Could not concatinate the integer '//value//
     & ' to the root keyword named: '//keyout)
        end

      subroutine unstak (sp, lextyp, labval, token)
      integer labval(100), lextyp(100)
      integer sp, token, type
23000 if (.not.(sp .gt. 1))goto 23002
      type = lextyp(sp)
      if (.not.((type .eq. -98 .or. type .eq. -97) .and. token .eq. -86)
     *)goto 23003
      goto 23002
23003 continue
      if (.not.(type .eq. -99 .or. type .eq. -98 .or. type .eq. -97))got
     *o 23005
      type = 999
23005 continue
      if (.not.(type .eq. 123 .or. type .eq. -92))goto 23007
      goto 23002
23007 continue
      if (.not.(type .eq. 999 .and. token .eq. -87))goto 23009
      goto 23002
23009 continue
      if (.not.(type .eq. 999))goto 23011
      call indent (-1)
      call outcon (labval(sp))
      goto 23012
23011 continue
      if (.not.(type .eq. -87 .or. type .eq. -72))goto 23013
      if (.not.(sp .gt. 2))goto 23015
      sp = sp - 1
23015 continue
      if (.not.(type .ne. -72))goto 23017
      call indent (-1)
23017 continue
      call outcon (labval(sp) + 1)
      goto 23014
23013 continue
      if (.not.(type .eq. -96))goto 23019
      call dostat (labval(sp))
      goto 23020
23019 continue
      if (.not.(type .eq. -95))goto 23021
      call whiles (labval(sp))
      goto 23022
23021 continue
      if (.not.(type .eq. -94))goto 23023
      call fors (labval(sp))
      goto 23024
23023 continue
      if (.not.(type .eq. -93))goto 23025
      call untils (labval(sp), token)
23025 continue
23024 continue
23022 continue
23020 continue
23014 continue
23012 continue
23001 sp=sp-1
      goto 23000
23002 continue
      end

C--------------------------------------------------------------------------
        subroutine ftgcrd(iunit,keynam,card,status)

C       Read the 80 character card image of a specified header keyword record

C       iunit   i  Fortran I/O unit number
C       keynam  c  name of keyword to be read
C       OUTPUT PARAMETERS:
C       card    c  80 character card image that was read
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June, 1991

        character*(*) keynam
        integer iunit,status,i,j,ibuff,maxkey,start
        character*(*) card
        character kname*8
        character*80 keybuf

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        card=' '
        if (status .gt. 0)go to 100

C       get the number of the data buffer used for this unit
        ibuff=bufnum(iunit)

C       make sure keyword name is in uppercase
        kname=keynam
        call ftupch(kname)

C       Start by searching for keyword from current pointer position to the end.
C       Calculate the maximum number of keywords to be searched:
        start=nxthdr(ibuff)
        maxkey=(hdend(ibuff)-start)/80

        do 20 j=1,2
C           position I/O pointer to the next header keyword
            if (maxkey .gt. 0)then
                call ftmbyt(iunit,start,.false.,status)
            end if

            do 10 i=1,maxkey
                call ftgcbf(iunit,1,80,keybuf,status)
                if (status .gt. 0)go to 100
                if (keybuf(1:8) .eq. kname)then
C                       setheader pointer to the following keyword
                        nxthdr(ibuff)=start+i*80
                        card=keybuf
                        return
                end if
10          continue

C           didn't find keyword yet, so now search from top down to starting pt.
C           calculate max number of keywords to be searched and reset nxthdr
            maxkey=(start-hdstrt(ibuff,chdu(ibuff)))/80
            start=hdstrt(ibuff,chdu(ibuff))
20      continue                        

C       keyword was not found
        status=202

C       don't write to error stack because this innoculous error happens a lot
C       call ftpmsg('Could not find the '//kname//' keyword to read.')

100     continue
        end

C--------------------------------------------------------------------------
        subroutine ftadef(ounit,lenrow,nfield,bcol,tform,nrows,status)

C       Ascii table data DEFinition
C       define the structure of the ASCII table data unit
C
C       ounit   i  Fortran I/O unit number
C       lenrow  i  length of a row, in characters
C       nfield  i  number of fields in the table
C       bcol    i  starting position of each column, (starting with 1)
C       tform   C  the data format of the column
C       nrows   i  number of rows in the table
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,lenrow,nfield,bcol(*),nrows,status
        character*(*) tform(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne,nf
        parameter (nb = 20)
        parameter (ne = 200)
        parameter (nf = 3000)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff,i,j,clen,c2
        character ctemp*24, cnum*3,cbcol*10,caxis1*10

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

        if (dtstrt(ibuff) .lt. 0)then
C               freeze the header at its current size
                call fthdef(ounit,0,status)
                if (status .gt. 0)return
        end if

        hdutyp(ibuff)=1
        tfield(ibuff)=nfield

        if (nxtfld + nfield .gt. nf)then
C               too many columns open at one time; exceeded array dimensions
                status=111
                return
        end if

        tstart(ibuff)=nxtfld
        nxtfld=nxtfld+nfield

        if (nfield .eq. 0)then
C           no data; the next HDU begins in the next logical block 
            hdstrt(ibuff,chdu(ibuff)+1)=dtstrt(ibuff)
            scount(ibuff)=0
            theap(ibuff)=0
            nxheap(ibuff)=0
        else
C           initialize the table column parameters
            clen=len(tform(1))
            do 20 i=1,nfield
                tscale(i+tstart(ibuff))=1.
                tzero(i+tstart(ibuff))=0.
C               choose special value to indicate null values are not defined
                cnull(i+tstart(ibuff))=char(1)
                cform(i+tstart(ibuff))=tform(i)
                tbcol(i+tstart(ibuff))=bcol(i)-1
                tdtype(i+tstart(ibuff))=16
C               the repeat count is always one for ASCII tables
                trept(i+tstart(ibuff))=1
C               store the width of the field in TNULL
                c2=0
                do 10 j=2,clen
                        if (tform(i)(j:j) .ge. '0' .and.
     &                     tform(i)(j:j) .le. '9')then
                                c2=j
                        else
                                go to 15
                        end if
10              continue
15              continue
                if (c2 .eq. 0)then
C                       no explicit width, so assume width of 1 character
                        tnull(i+tstart(ibuff))=1
                else
                    call ftc2ii(tform(i)(2:c2),tnull(i+tstart(ibuff))
     &                          ,status)
                    if (status .gt. 0)then
C                        error parsing TFORM to determine field width
                         status=261
                         ctemp=tform(i)
                         call ftpmsg('Error parsing TFORM to get field'
     &                    //' width: '//ctemp)
                         return
                    end if
                end if

C               check that column fits within the table
                if (tbcol(i+tstart(ibuff))+tnull(i+tstart(ibuff)) 
     &            .gt. lenrow .and. lenrow .ne. 0)then
                    status=236
                    write(cnum,1000)i
                    write(cbcol,1001)bcol(i)
                    write(caxis1,1001)lenrow
1000                format(i3)
1001                format(i10)
                    call ftpmsg('Column '//cnum//' will not fit '//
     &             'within the specified width of the ASCII table.')

                    call ftpmsg('TFORM='//cform(i+tstart(ibuff))//
     &              '  TBCOL='//cbcol//'  NAXIS1='//caxis1)
                    return
                 end if
20           continue

C           calculate the start of the next header unit, based on the
C           size of the data unit
            rowlen(ibuff)=lenrow
            hdstrt(ibuff,chdu(ibuff)+1)=
     &          dtstrt(ibuff)+(lenrow*nrows+2879)/2880*2880

C       initialize the fictitious heap starting address (immediately following
C       the table data) and a zero length heap.  This is used to find the
C       end of the table data when checking the fill values in the last block. 
C           ASCII tables have no special data area
            scount(ibuff)=0
            theap(ibuff)=rowlen(ibuff)*nrows
            nxheap(ibuff)=0
        end if
        end

C------------------------------------------------------------------------------
        subroutine ftarch(compid)

C       This routine looks at how integers and reals are internally
C       stored, to figure out what kind of machine it is running on.

C       compid = 1  -  VAX or Alpha VMS system
C                2  -  Decstation or Alpha OSF/1, or IBM PC
C                3  -  SUN workstation 
C                4  -  IBM mainframe

        integer compid
        real rword
        integer*2 iword(2)
        equivalence (rword, iword)

C       set rword to some arbitrary value
        rword=1.1111111111

C       Then look at the equivalent integer, to distinquish the machine type.
C       The machine type is needed when testing for NaNs.

        if (iword(1) .eq. 16270)then
C               looks like a SUN workstation (uses IEEE word format)
                compid=3
        else if (iword(1) .eq. 14564)then
C               looks like a Decstation, alpha OSF/1, or IBM PC (byte swapped)
                compid=2
        else if (iword(1) .eq. 16526)then
C               looks like a VAX or ALPHA VMS system
                compid=1
        else if (iword(1) .eq. 16657)then
C               an IBM main frame (the test for NaNs is the same as on SUNs)
                compid=4
        else
C               unknown machine
                compid=0
                return
        end if
        end

      REAL FUNCTION slRVLG (R2000, D2000)
*+
*     - - - - -
*      R V L G
*     - - - - -
*
*  Velocity component in a given direction due to the combination
*  of the rotation of the Galaxy and the motion of the Galaxy
*  relative to the mean motion of the local group (single precision)
*
*  Given:
*     R2000,D2000   real    J2000.0 mean RA,Dec (radians)
*
*  Result:
*     Component of SOLAR motion in direction R2000,D2000 (km/s)
*
*  Sign convention:
*     The result is +ve when the Sun is receding from the
*     given point on the sky.
*
*  Reference:
*     IAU Trans 1976, 168, p201.
*
*  Called:
*     slCS2C, slVDV
*
*  P.T.Wallace   Starlink   June 1985
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL R2000,D2000

      REAL VA(3), VB(3)

      REAL slVDV

*
*  Solar velocity due to Galactic rotation and translation
*
*  Speed = 300 km/s
*
*  Apex  = L2,B2  90deg, 0deg
*        = RA,Dec  21 12 01.1  +48 19 47  J2000.0
*
*  This is expressed in the form of a J2000.0 x,y,z vector:
*
*      VA(1) = X = -SPEED*COS(RA)*COS(DEC)
*      VA(2) = Y = -SPEED*SIN(RA)*COS(DEC)
*      VA(3) = Z = -SPEED*SIN(DEC)

      DATA VA / -148.23284, +133.44888, -224.09467 /



*  Convert given J2000 RA,Dec to x,y,z
      CALL slCS2C(R2000,D2000,VB)

*  Compute dot product with Solar motion vector
      slRVLG=slVDV(VA,VB)

      END

include	defs

# match --- find match anywhere on line

   integer function match (lin, pat)
   character lin (MAXLINE), pat (MAXPAT)

   integer i, junk (9)
   integer amatch

   for (i = 1; lin (i) != EOS; i = i + 1)
      if (amatch (lin, i, pat, junk, junk) > 0) {
	 match = YES
	 return
	 }
   match = NO
   return
   end

      subroutine mfeout (a,mda,m,n,names,mode)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   subroutine for matrix output with labeling.
c
c     a( )	   matrix to be output
c		   mda	   first dimension of a array
c		   m	     no. of rows in a matrix
c		   n	     no. of cols in a matrix
c     names()	   array of names.  if names(1) = 1h , the rest
c		   of the names() array will be ignored.
c     mode	   =1	for   4p8f15.0	format	for v matrix.
c		   =2	for   8e15.8  format  for candidate solutions.
c
      dimension    a(mda,01)
      integer names(m),ihead(2)
      logical	notblk
      data  maxcol/8/, iblank/1h /,ihead(1)/4h col/,ihead(2)/4hsoln/
c
      notblk=names(1).ne.iblank
      if (m.le.0.or.n.le.0) return
c
      if (mode.eq.2) go to 10
      write (6,70)
      go to 20
   10 write (6,80)
   20 continue
c
      nblock=n/maxcol
      last=n-nblock*maxcol
      ncol=maxcol
      j1=1
c
c			     main loop starts here
c
   30 if (nblock.gt.0) go to 40
      if (last.le.0) return
      ncol=last
      last=0
c
   40 j2=j1+ncol-1
      write (6,90) (ihead(mode),j,j=j1,j2)
c
	   do 60 i=1,m
	   name=iblank
	   if (notblk) name=names(i)
c
	   if (mode.eq.2) go to 50
	   write (6,100) i,name,(a(i,j),j=j1,j2)
	   go to 60
   50	   write (6,110) i,name,(a(i,j),j=j1,j2)
   60	   continue
c
      j1=j1+maxcol
      nblock=nblock-1
      go to 30
c
   70 format (45h0v-matrix of the singular value decomposition,
     * 8h of a*d./47h (elements of v scaled up by a factor of 10**4))
   80 format (35h0sequence of candidate solutions, x)
   90 format (1h0,11x,8(6x,a4,i4,1x)/1x)
  100 format (1x,i3,1x,a6,1x,4p8f15.0)
  110 format (1x,i3,1x,a6,1x,8e15.8)
      end

C+
C
C  SUBROUTINE POLFT1
C
C  PURPOSE
C	MAKE A LEAST SQUARES FIT TO DATA WITH A POLYNOMIAL CURVE
C	Y = A(1) + A(2)*X + A(3)*X**2 + ...
C
C  USAGE
C	CALL POLFIT(X,Y,SIGMAY,NPTS,NTERMS,MODE,A,CHISQR,ARR,IER)
C
C  DESCRIPTION OF PARAMETERS
C	Y	- ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C	SIGMAY	- ARRAY OF STANDARD DEVIATIONS FOR Y-DATA POINTS
C		  (OR - IN CASE MODE = 4 - WEIGHTS FOR POINTS)
C	NPTS	- NO. OF PAIRS OF DATA POINTS
C	NTERMS	- NO. OF COEFFICIENTS (DEGREE OF POLYNOMIAL + 1)
C	MODE	- DETERMINES METHOD OF WEIGHTING LEAST SQUARES FIT
C		  4 (USER DEFINED) WEIGHT(I) = SIGMAY(I)
C		  3 (INSTRUMENTAL) WEIGHT(I) = 1./SIGMAY(I)**2
C		  2 (NO WEIGHTING) WEIGHT(I) = 1.
C		  1 (STATISTICAL)  WEIGHT(I) = 1./Y(I)
C	A	- ARRAY OF COEFFICIENTS OF POLYNOMIAL
C	CHISQR	- REDUCED CHISQUARE FOR FIT
C	ARR	- DOUBLE PRECISION WORK BUFFER; MUST BE AT LEAST
C		  400 WORDS LONG IN THE CALLING ROUTINE
C	IER	- ERROR PARAMETER
C		  -1 DET=0
C		   0 O.K.
C		  +1 NOT ENOUGH POINTS
C
C  SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C	DET(ARR,NORD) - EVALUATES THE DETERMINANT OF A SYMMETRIC
C			TWO DIMENSIONAL MATRIX OF ORDER NORD
C
C  COMMENTS
C	DIMENSION STATEMENT VALID FOR NTERMS UP TO 10
C	FOR DETAILS OF ALGORITHM SEE "DATA REDUCTION AND ERROR
C	ANALYSIS FOR THE PHYSICAL SCIENCES" - PH. R. BEVINGTON
C	MC GRAW-HILL BOOK COMPANY
C
C	IN THIS SPECIAL VERSION THE ELEMENTS OF COEFFICIENT MATRIX
C	ARR ARE NORMALIZED WITH RESPECT TO A VALUE COMPUTED VIA
C	LOGARITHMIC INTERPOLATION BETWEEN THE SMALLEST AND LARGEST
C	MATRIX ELEMENT
C
C  MODIFICATIONS BY A. SCHERMANN - INST. FOR ASTRONOMY,
C	UNIV. OF VIENNA, AUSTRIA
C
C Modified to assume x-variable is index of Y array
C-
	SUBROUTINE POLFT1(Y,SIGMAY,NPTS,NTERMS,MODE,A,CHISQR,ARR,IER)
	DOUBLE PRECISION SUMX(19),SUMY(10),ARR(10,10),XTERM,YTERM,
     1	CHISQ
	DIMENSION Y(1),SIGMAY(1),A(1)
	IER=0
C
C  CHECK DEGREE OF FREEDOM
	FREE=NPTS-NTERMS
	IF(FREE.GT.0.) GOTO 11
	IER=1
	GOTO 80
C
C  ACCUMULATE WEIGHTED SUMS
11	NMAX=2*NTERMS-1
	DO 13 N=1,NMAX
13	SUMX(N)=0.
	DO 15 J=1,NTERMS
15	SUMY(J)=0.
	CHISQ=0.
21	DO 50 I=1,NPTS
	XI=I
	YI=Y(I)
31	GOTO(32,37,38,39),MODE
32	IF(YI)35,37,33
33	WEIGHT=1./YI
	GOTO 41
35	WEIGHT=-1./YI
	GOTO 41
37	WEIGHT=1.
	GOTO 41
38	WEIGHT=1./SIGMAY(I)**2
	GOTO 41
39	WEIGHT=SIGMAY(I)
41	XTERM=WEIGHT
	DO 44 N=1,NMAX
	SUMX(N)=SUMX(N)+XTERM
44	XTERM=XTERM*XI
45	YTERM=WEIGHT*YI
	DO 48 N=1,NTERMS
	SUMY(N)=SUMY(N)+YTERM
48	YTERM=YTERM*XI
49	CHISQ=CHISQ+WEIGHT*YI**2
50	CONTINUE
C
C  GET LARGEST AND SMALLEST MATRIX ELEMENT (FOR NORMALIZATION)
	XTERM=SUMX(1)
	YTERM=XTERM
	DO 100 I=2,NMAX
	IF(SUMX(I).GT.XTERM) XTERM=SUMX(I)
	IF(SUMX(I).LT.YTERM) YTERM=SUMX(I)
100	CONTINUE
	DO 110 I=1,NTERMS
	IF(SUMY(I).GT.XTERM) XTERM=SUMY(I)
	IF(SUMY(I).LT.YTERM) YTERM=SUMY(I)
110	CONTINUE
	IF(YTERM.LE.0.) YTERM=1.D0
C
C  LOGARITHMIC INTERPOLATION OF NORMALIZATION VALUE
	XTERM=1.D1**((DLOG10(XTERM)+DLOG10(YTERM))/2.)
C
C  CONSTRUCT MATRICES AND CALCULATE COEFFICIENTS
51	DO 54 J=1,NTERMS
	DO 54 K=1,NTERMS
	N=J+K-1
54	ARR(J,K)=SUMX(N)/XTERM
	DELTA=DET(ARR,NTERMS)
	IF(DELTA.NE.0.) GOTO 61
57	CHISQR=0.
	DO 59 J=1,NTERMS
59	A(J)=0.
	IER=-1
	GOTO 80
61	DO 70 L=1,NTERMS
62	DO 66 J=1,NTERMS
	DO 65 K=1,NTERMS
	N=J+K-1
65	ARR(J,K)=SUMX(N)/XTERM
66	ARR(J,L)=SUMY(J)/XTERM
70	A(L)=DET(ARR,NTERMS)/DELTA
C
C  CALCULATE CHISQUARE
71	DO 75 J=1,NTERMS
	CHISQ=CHISQ-2.*A(J)*SUMY(J)
	DO 75 K=1,NTERMS
	N=J+K-1
75	CHISQ=CHISQ+A(J)*A(K)*SUMX(N)
77	CHISQR=CHISQ/FREE
80	RETURN
	END
c-----------------------------------------------------------
	FUNCTION POLYNO (COE,NPOL,IX)
C
C EVALUATE A POLYNOMIAL OF ORDER NPOL WITH COEFFICIENTS COE(1),...,
C COE (NPOL+1)  FOR AN INDEX IX
C
	DIMENSION COE(*)
C
	IF(NPOL.GT.0) GO TO 10
	POLYNO=COE(1)
	RETURN
C
10	POLYNO=COE(NPOL+1)
	DO 20 I=NPOL,1,-1
20	    POLYNO=POLYNO*IX+COE(I)
C
	RETURN
	END
c-----------------------------------------------------------
C+
C
C  FUNCTION DET
C
C  PURPOSE
C	CALCULATE DETERMINANT OF A SQUARE MATRIX
C
C  USAGE
C	DET = DET (ARR,NORDER)
C
C  DESCRIPTION OF PARAMETERS
C	ARRAY	- MATRIX
C	NORDER	- DEGREE OF MATRIX
C
C  SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C		NONE
C
C  COMMENTS
C	THIS SUBPROGRAM DESTROYS THE INPUT MATRIX ARRAY
C
	FUNCTION DET(ARRAY,NORDER)
	DOUBLE PRECISION ARRAY(10,10),SAVE
	DET=1.
	DO 90 K=1,NORDER
C  INTERCHANGE COLUMNS, IF DIAGONAL ELEMENT IS ZERO
	IF(ARRAY(K,K).NE.0.) GOTO 40
	DO 10 J=K,NORDER
	IF(ARRAY(K,J).NE.0.) GOTO 20
10	CONTINUE
	DET=0.
	GOTO 100
20	DO 30 I=K,NORDER
	SAVE=ARRAY(I,J)
	ARRAY(I,J)=ARRAY(I,K)
30	ARRAY(I,K)=SAVE
	DET=-DET
C  SUBTRACT ROW K FROM LOWER ROWS TO GET DIAGONAL MATRIX
40	DET=DET*ARRAY(K,K)
	IF(K-NORDER.GE.0) GOTO 90
	K1=K+1
	DO 50 I=K1,NORDER
	DO 50 J=K1,NORDER
50	ARRAY(I,J)=ARRAY(I,J)-ARRAY(I,K)*ARRAY(K,J)/ARRAY(K,K)
90	CONTINUE
100	RETURN
	END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGCTKO (XBGA,YBGA,XDCA,YDCA,CFAX,CFAY,CSFA,JAOR,NMMT,
     +                   QMDP,WMML,WMMR,FNLL,FNLR,MM12,MM34,XMMT,YMMT)
C
      DIMENSION XMMT(4),YMMT(4)
C
C The routine AGCTKO is used to compute the x and y offsets to the end-
C points of the left-of-label and right-of-label portions of the major
C and minor tick marks.  See AGAXIS for definitions of the arguments.
C
C A note about WMML and WMMR:  Each is a positive number, of the form
C (E) or (1+E), where E (=EPSILON) is .LT. 1. and is expressed as a
C fraction of the smaller side of the curve window.  If the form (E) is
C used, it implies just a tick of length E; if the form (1+E) is used,
C it implies a tick long enough to reach the edge of the curve window,
C plus the length E.
C
C If the tick-mark count NMMT .EQ. 0 or the tick-mark dash pattern QMDP
C .EQ. 0 or both the left-of-axis and right-of-axis tick-mark lengths
C WMML and WMMR .EQ. 0, then no tick marks are to be drawn.
C
      IF (NMMT.EQ.0.OR.QMDP.EQ.0..OR.(WMML.EQ.0..AND.WMMR.EQ.0.))
     *                                                         GO TO 115
C
C Compute the distances of the tick mark ends from the axis as fractions
C of the axis length, using only the (EPSILON) portion of WMML and WMMR.
C
      FMML=-CSFA*AMOD(WMML,1.)
      FMMR=+CSFA*AMOD(WMMR,1.)
C
C If the labels overlap the axis and the (EPSILON) form was used for
C WMML or WMMR, move the tick mark to the end of the label.
C
      IF (FNLL*FNLR.GE.0.) GO TO 101
C
      IF (WMML.LT.1.) FMML=FMML+FNLL
C
      IF (WMMR.LT.1.) FMMR=FMMR+FNLR
C
C Compute the x and y offsets to the ends of the tick mark.
C
  101 XMML=+CFAX*FMML*YDCA
      YMML=-CFAY*FMML*XDCA
      XMMR=+CFAX*FMMR*YDCA
      YMMR=-CFAY*FMMR*XDCA
C
C If the (1+EPSILON) form was used for WMML or WMMR, adjust XMML, YMML,
C XMMR, and YMMR as implied by the current axis orientation.
C
      IF (WMML.LT.1.) GO TO 107
C
      GO TO (102,103,104,105) , JAOR
C
C Axis at 0 degrees (left to right).
C
  102 YMML=YMML+1.-YBGA
      GO TO 106
C
C Axis at 90 degrees (bottom to top).
C
  103 XMML=XMML-XBGA
      GO TO 106
C
C Axis at 180 degrees (right to left).
C
  104 YMML=YMML-YBGA
      GO TO 106
C
C Axis at 270 degrees (top to bottom).
C
  105 XMML=XMML+1.-XBGA
C
  106 FMML=(XMML+YMML)/(CFAX*YDCA-CFAY*XDCA)
C
  107 IF (WMMR.LT.1.) GO TO 113
C
      GO TO (108,109,110,111) , JAOR
C
C Axis at 0 degrees (left to right).
C
  108 YMMR=YMMR-YBGA
      GO TO 112
C
C Axis at 90 degrees (bottom to top).
C
  109 XMMR=XMMR+1.-XBGA
      GO TO 112
C
C Axis at 180 degrees (right to left).
C
  110 YMMR=YMMR+1.-YBGA
      GO TO 112
C
C Axis at 270 degrees (top to bottom).
C
  111 XMMR=XMMR-XBGA
C
  112 FMMR=(XMMR+YMMR)/(CFAX*YDCA-CFAY*XDCA)
C
C Now split the tick mark into two portions - one to the left, and one
C to the right, of the numeric label space.
C
  113 XMMT(1)=XMML
      YMMT(1)=YMML
      XMMT(2)=XMMR
      YMMT(2)=YMMR
      MM12=1
      MM34=0
      IF (FMMR.LE.FNLL.OR.FNLL.GE.FNLR) RETURN
C
      MM12=0
      IF (FMML.GE.FNLL) GO TO 114
      MM12=1
      XMMT(2)=+CFAX*(FNLL-.005*CSFA)*YDCA
      YMMT(2)=-CFAY*(FNLL-.005*CSFA)*XDCA
C
  114 IF (FMMR.LE.FNLR) RETURN
C
      MM34=1
      XMMT(4)=XMMR
      YMMT(4)=YMMR
      XMMT(3)=XMML
      YMMT(3)=YMML
C
      IF (FMML.GE.FNLR) RETURN
      XMMT(3)=+CFAX*(FNLR+.005*CSFA)*YDCA
      YMMT(3)=-CFAY*(FNLR+.005*CSFA)*XDCA
      RETURN
C
C No ticks to be drawn - zero the flags MM12 and MM34 to indicate this.
C
  115 MM12=0
      MM34=0
      RETURN
C
      END

*> \brief \b SGETF2 computes the LU factorization of a general m-by-n matrix using partial pivoting with row interchanges (unblocked algorithm).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download SGETF2 + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sgetf2.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sgetf2.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sgetf2.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGETF2( M, N, A, LDA, IPIV, INFO )
*
*       .. Scalar Arguments ..
*       INTEGER            INFO, LDA, M, N
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       REAL               A( LDA, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGETF2 computes an LU factorization of a general m-by-n matrix A
*> using partial pivoting with row interchanges.
*>
*> The factorization has the form
*>    A = P * L * U
*> where P is a permutation matrix, L is lower triangular with unit
*> diagonal elements (lower trapezoidal if m > n), and U is upper
*> triangular (upper trapezoidal if m < n).
*>
*> This is the right-looking Level 2 BLAS version of the algorithm.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix A.  M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the m by n matrix to be factored.
*>          On exit, the factors L and U from the factorization
*>          A = P*L*U; the unit diagonal elements of L are not stored.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (min(M,N))
*>          The pivot indices; for 1 <= i <= min(M,N), row i of the
*>          matrix was interchanged with row IPIV(i).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -k, the k-th argument had an illegal value
*>          > 0: if INFO = k, U(k,k) is exactly zero. The factorization
*>               has been completed, but the factor U is exactly
*>               singular, and division by zero will occur if it is used
*>               to solve a system of equations.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup realGEcomputational
*
*  =====================================================================
      SUBROUTINE SGETF2( M, N, A, LDA, IPIV, INFO )
*
*  -- LAPACK computational routine (version 3.7.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      REAL               A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      REAL               SFMIN
      INTEGER            I, J, JP
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      INTEGER            ISAMAX
      EXTERNAL           SLAMCH, ISAMAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGER, SSCAL, SSWAP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Compute machine safe minimum
*
      SFMIN = R1MACH(1)
*
      DO 10 J = 1, MIN( M, N )
*
*        Find pivot and test for singularity.
*
         JP = J - 1 + ISAMAX( M-J+1, A( J, J ), 1 )
         IPIV( J ) = JP
         IF( A( JP, J ).NE.ZERO ) THEN
*
*           Apply the interchange to columns 1:N.
*
            IF( JP.NE.J )
     $         CALL SSWAP( N, A( J, 1 ), LDA, A( JP, 1 ), LDA )
*
*           Compute elements J+1:M of J-th column.
*
            IF( J.LT.M ) THEN
               IF( ABS(A( J, J )) .GE. SFMIN ) THEN
                  CALL SSCAL( M-J, ONE / A( J, J ), A( J+1, J ), 1 )
               ELSE
                 DO 20 I = 1, M-J
                    A( J+I, J ) = A( J+I, J ) / A( J, J )
   20            CONTINUE
               END IF
            END IF
*
         ELSE IF( INFO.EQ.0 ) THEN
*
            INFO = J
         END IF
*
         IF( J.LT.MIN( M, N ) ) THEN
*
*           Update trailing submatrix.
*
            CALL SGER( M-J, N-J, -ONE, A( J+1, J ), 1, A( J, J+1 ), LDA,
     $                 A( J+1, J+1 ), LDA )
         END IF
   10 CONTINUE
      RETURN
*
*     End of SGETF2
*
      END

      integer function ngetch (c)
      integer c
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer getlin, n, i
      if (.not.(buf (bp) .eq. -2))goto 23000
      if (.not.(getlin (buf (3192), infile (level)) .eq. -1))goto 23002
      c = -1
      goto 23003
23002 continue
      c = buf (3192)
      bp = 3192 + 1
      if (.not.(c .eq. 35))goto 23004
      if (.not.(buf(bp) .eq. 33 .and. buf(bp+1) .eq. 35))goto 23006
      n = 0
      i=bp+3
23008 if (.not.(buf(i) .ge. 48 .and. buf(i) .le. 57))goto 23010
      n = n * 10 + buf(i) - 48
23009 i=i+1
      goto 23008
23010 continue
      linect (level) = n - 1
23006 continue
23004 continue
      if (.not.(linect (level) .gt. 0))goto23003
      linect (level) = linect (level) + 1
23003 continue
      goto 23001
23000 continue
      c = buf (bp)
      bp = bp + 1
23001 continue
      ngetch=(c)
      return
      end
c     logic0  logical_column

c ARGS -- Test the command line argument interface.
c
c	usage:  args [arg1 [arg2 ...]]
c ------------------------------------------------------------------------

	program args

	character*80	argstr
	integer		nargs, ier, i

c --- Test raw command line access.
	call clrawc (argstr, ier)
	if (ier .ne. 0) then
	    write (*, '('' clrawc returns status '', i3)') ier
	else
	    write (*, '('' clrawc: '', a80)') argstr
	endif

c --- Test parsed command line access.
	call clnarg (nargs)
	write (*, '('' nargs = '', i3)') nargs

	do 10 i = 1, nargs
	    call clargc (i, argstr, ier)
	    if (ier .ne. 0) then
		write (*, '('' unexpected error '', i3)') ier
	    else
		write (*, '(i4, 2x, a70)') i, argstr
	    endif
 10	continue

	stop
	end

include	defs

# fold - fold all letters in a string to lower case

   subroutine fold (token)
   character token (ARB)

   character clower

   integer i

   for (i = 1; token (i) != EOS; i = i + 1)
      token (i) = clower (token (i))

   return
   end

        subroutine encode (nchars, ftnfmt, ftnout, rval)

	character*11 ftnfmt, ftnout
	integer*2 sppfmt(12), sppout(12)
	integer SZFMT
	parameter (SZFMT=11)

c unpack the fortran character string, call fencd to actually encode the
c output string, then pack the output string into a fortran string for return
c
	call f77upk (ftnfmt, sppfmt, SZFMT)
	call fencd (nchars, sppfmt, sppout, rval)
	call f77pak (sppout, ftnout, SZFMT)

	end

      integer function getccl (arg, i, pat, j)
      integer arg (128), pat (128)
      integer i, j
      integer jstart, junk
      integer addset
      i = i + 1
      if (.not.(arg (i) .eq. 126))goto 23000
      junk = addset (110, pat, j, 128)
      i = i + 1
      goto 23001
23000 continue
      junk = addset (91, pat, j, 128)
23001 continue
      jstart = j
      junk = addset (0, pat, j, 128)
      call filset (93, arg, i, pat, j, 128)
      pat (jstart) = j - jstart - 1
      if (.not.(arg (i) .eq. 93))goto 23002
      getccl = -2
      goto 23003
23002 continue
      getccl = -3
23003 continue
      return
      end

      SUBROUTINE slUEEL (U, JFORMR,
     :                      JFORM, EPOCH, ORBINC, ANODE, PERIH,
     :                      AORQ, E, AORL, DM, JSTAT)
*+
*     - - - - - -
*      U E E L
*     - - - - - -
*
*  Transform universal elements into conventional heliocentric
*  osculating elements.
*
*  Given:
*     U         d(13)  universal orbital elements (Note 1)
*
*                 (1)  combined mass (M+m)
*                 (2)  total energy of the orbit (alpha)
*                 (3)  reference (osculating) epoch (t0)
*               (4-6)  position at reference epoch (r0)
*               (7-9)  velocity at reference epoch (v0)
*                (10)  heliocentric distance at reference epoch
*                (11)  r0.v0
*                (12)  date (t)
*                (13)  universal eccentric anomaly (psi) of date, approx
*
*     JFORMR    i      requested element set (1-3; Note 3)
*
*  Returned:
*     JFORM     d      element set actually returned (1-3; Note 4)
*     EPOCH     d      epoch of elements (TT MJD)
*     ORBINC    d      inclination (radians)
*     ANODE     d      longitude of the ascending node (radians)
*     PERIH     d      longitude or argument of perihelion (radians)
*     AORQ      d      mean distance or perihelion distance (AU)
*     E         d      eccentricity
*     AORL      d      mean anomaly or longitude (radians, JFORM=1,2 only)
*     DM        d      daily motion (radians, JFORM=1 only)
*     JSTAT     i      status:  0 = OK
*                              -1 = illegal combined mass
*                              -2 = illegal JFORMR
*                              -3 = position/velocity out of range
*
*  Notes
*
*  1  The "universal" elements are those which define the orbit for the
*     purposes of the method of universal variables (see reference 2).
*     They consist of the combined mass of the two bodies, an epoch,
*     and the position and velocity vectors (arbitrary reference frame)
*     at that epoch.  The parameter set used here includes also various
*     quantities that can, in fact, be derived from the other
*     information.  This approach is taken to avoiding unnecessary
*     computation and loss of accuracy.  The supplementary quantities
*     are (i) alpha, which is proportional to the total energy of the
*     orbit, (ii) the heliocentric distance at epoch, (iii) the
*     outwards component of the velocity at the given epoch, (iv) an
*     estimate of psi, the "universal eccentric anomaly" at a given
*     date and (v) that date.
*
*  2  The universal elements are with respect to the mean equator and
*     equinox of epoch J2000.  The orbital elements produced are with
*     respect to the J2000 ecliptic and mean equinox.
*
*  3  Three different element-format options are supported:
*
*     Option JFORM=1, suitable for the major planets:
*
*     EPOCH  = epoch of elements (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = longitude of perihelion, curly pi (radians)
*     AORQ   = mean distance, a (AU)
*     E      = eccentricity, e
*     AORL   = mean longitude L (radians)
*     DM     = daily motion (radians)
*
*     Option JFORM=2, suitable for minor planets:
*
*     EPOCH  = epoch of elements (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = argument of perihelion, little omega (radians)
*     AORQ   = mean distance, a (AU)
*     E      = eccentricity, e
*     AORL   = mean anomaly M (radians)
*
*     Option JFORM=3, suitable for comets:
*
*     EPOCH  = epoch of perihelion (TT MJD)
*     ORBINC = inclination i (radians)
*     ANODE  = longitude of the ascending node, big omega (radians)
*     PERIH  = argument of perihelion, little omega (radians)
*     AORQ   = perihelion distance, q (AU)
*     E      = eccentricity, e
*
*  4  It may not be possible to generate elements in the form
*     requested through JFORMR.  The caller is notified of the form
*     of elements actually returned by means of the JFORM argument:
*
*      JFORMR   JFORM     meaning
*
*        1        1       OK - elements are in the requested format
*        1        2       never happens
*        1        3       orbit not elliptical
*
*        2        1       never happens
*        2        2       OK - elements are in the requested format
*        2        3       orbit not elliptical
*
*        3        1       never happens
*        3        2       never happens
*        3        3       OK - elements are in the requested format
*
*  5  The arguments returned for each value of JFORM (cf Note 6: JFORM
*     may not be the same as JFORMR) are as follows:
*
*         JFORM         1              2              3
*         EPOCH         t0             t0             T
*         ORBINC        i              i              i
*         ANODE         Omega          Omega          Omega
*         PERIH         curly pi       omega          omega
*         AORQ          a              a              q
*         E             e              e              e
*         AORL          L              M              -
*         DM            n              -              -
*
*     where:
*
*         t0           is the epoch of the elements (MJD, TT)
*         T              "    epoch of perihelion (MJD, TT)
*         i              "    inclination (radians)
*         Omega          "    longitude of the ascending node (radians)
*         curly pi       "    longitude of perihelion (radians)
*         omega          "    argument of perihelion (radians)
*         a              "    mean distance (AU)
*         q              "    perihelion distance (AU)
*         e              "    eccentricity
*         L              "    longitude (radians, 0-2pi)
*         M              "    mean anomaly (radians, 0-2pi)
*         n              "    daily motion (radians)
*         -             means no value is set
*
*  6  At very small inclinations, the longitude of the ascending node
*     ANODE becomes indeterminate and under some circumstances may be
*     set arbitrarily to zero.  Similarly, if the orbit is close to
*     circular, the true anomaly becomes indeterminate and under some
*     circumstances may be set arbitrarily to zero.  In such cases,
*     the other elements are automatically adjusted to compensate,
*     and so the elements remain a valid description of the orbit.
*
*  References:
*
*     1  Sterne, Theodore E., "An Introduction to Celestial Mechanics",
*        Interscience Publishers Inc., 1960.  Section 6.7, p199.
*
*     2  Everhart, E. & Pitkin, E.T., Am.J.Phys. 51, 712, 1983.
*
*  Called:  slPVEL
*
*  P.T.Wallace   Starlink   18 March 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION U(13)
      INTEGER JFORMR,JFORM
      DOUBLE PRECISION EPOCH,ORBINC,ANODE,PERIH,AORQ,E,AORL,DM
      INTEGER JSTAT

*  Gaussian gravitational constant (exact)
      DOUBLE PRECISION GCON
      PARAMETER (GCON=0.01720209895D0)

*  Canonical days to seconds
      DOUBLE PRECISION CD2S
      PARAMETER (CD2S=GCON/86400D0)

      INTEGER I
      DOUBLE PRECISION PMASS,DATE,PV(6)


*  Unpack the universal elements.
      PMASS = U(1)-1D0
      DATE = U(3)
      DO I=1,3
         PV(I) = U(I+3)
         PV(I+3) = U(I+6)*CD2S
      END DO

*  Convert the position and velocity etc into conventional elements.
      CALL slPVEL(PV,DATE,PMASS,JFORMR,JFORM,EPOCH,ORBINC,ANODE,
     :               PERIH,AORQ,E,AORL,DM,JSTAT)

      END

      subroutine retcod
      integer token (100), t
      integer gnbtok
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      t = gnbtok (token, 100)
      if (.not.(t .ne. 10 .and. t .ne. 59 .and. t .ne. 125))goto 23000
      call pbstr (token)
      call outtab
      call scopy (fcname, 1, token, 1)
      call squash (token)
      call outstr (token)
      call outch (32)
      call outch (61)
      call outch (32)
      call eatup
      call outdon
      goto 23001
23000 continue
      if (.not.(t .eq. 125))goto 23002
      call pbstr (token)
23002 continue
23001 continue
      call outtab
      call ogotos (retlab, 0)
      xfer = 1
      return
      end
c     logic0  logical_column

c subroutine fderiv.f (non-analytical)
c
c source
c   Bevington, page 242.
c
c purpose
c   evaluate derivatives of function for least-squares search
c      for arbitrary function given by functn
c
c usage
c   call fderiv (x, i, a, deltaa, nterms, deriv)
c
c description of parameters
c   x	   - array of data points for independent variable
c   i	   - index of data points
c   a	   - array of parameters
c   deltaa - array of parameter increments
c   nterms - number of parameters
c   deriv  - derivatives of function
c
c subroutines and function subprograms required
c   functn (x, i, a)
c      evaluates the fitting function for the ith term
c
	subroutine fderiv (x,i,a,deltaa,nterms,deriv)
	dimension x(1),a(1),deltaa(1),deriv(1)
        real FUNCTN
        external FUNCTN

11	do 18 j=1,nterms
	aj=a(j)
	delta=deltaa(j)
	a(j)=aj+delta
	yfit=functn(x,i,a)
	a(j)=aj-delta
	deriv(j)=(yfit-functn(x,i,a))/(2.*delta)
18	a(j)=aj
	return
	end

      subroutine bchslv ( w, nbands, nrow, b )
c  from  * a practical guide to splines *  by c. de boor
c  solves the linear system	c*x = b   of order  n r o w  for  x
c  provided  w	contains the cholesky factorization for the banded (sym-
c  metric) positive definite matrix  c	as constructed in the subroutine
c    b c h f a c  (quo vide).
c
c******  i n p u t  ******
c  nrow.....is the order of the matrix	c .
c  nbands.....indicates the bandwidth of  c .
c  w.....contains the cholesky factorization for  c , as output from
c	 subroutine bchfac  (quo vide).
c  b.....the vector of length  n r o w	containing the right side.
c
c******  o u t p u t  ******
c  b.....the vector of length  n r o w	containing the solution.
c
c******  m e t h o d  ******
c  with the factorization  c = l*d*l-transpose	available, where  l  is
c  unit lower triangular and  d  is diagonal, the triangular system
c  l*y = b  is solved for  y (forward substitution), y is stored in  b,
c  the vector  d**(-1)*y is computed and stored in  b, then the triang-
c  ular system	l-transpose*x = d**(-1)*y is solved for  x (backsubstit-
c  ution).
      integer nbands,nrow,   j,jmax,n,nbndm1
      real w(nbands,nrow),b(nrow)
      if (nrow .gt. 1)			go to 21
      b(1) = b(1)*w(1,1)
					return
c
c		  forward substitution. solve l*y = b for y, store in b.
   21 nbndm1 = nbands - 1
      do 30 n=1,nrow
	 jmax = min0(nbndm1,nrow-n)
	 if (jmax .lt. 1)		go to 30
	 do 25 j=1,jmax
   25	    b(j+n) = b(j+n) - w(j+1,n)*b(n)
   30	 continue
c
c     backsubstitution. solve l-transp.x = d**(-1)*y  for x, store in b.
      n = nrow
   31	 b(n) = b(n)*w(1,n)
	 jmax = min0(nbndm1,nrow-n)
	 if (jmax .lt. 1)		go to 40
	 do 35 j=1,jmax
   35	    b(n) = b(n) - w(j+1,n)*b(j+n)
   40	 n = n-1
      if (n.gt.0)			go to 31
					return
      end

      SUBROUTINE TPWRZS	(IERROR)
C
C LATEST REVISION	 JULY, 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 PWRZS IN CONJUNCTION WITH SRFACE.
C
C USAGE			 CALL TPWRZS (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST WAS SUCCESSFUL, THE MESSAGE
C
C			   PWRZS TEST SUCCESSFUL  . . .	 SEE PLOT
C			   TO VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C			 IN ADDITION, ONE FRAME	CONTAINING THE SAMPLE
C			 PLOT IS PRODUCED ON THE MACHINE GRAPHICS
C			 DEVICE.  IN ORDER TO DETERMINE	IF THE TEST
C			 WAS SUCCESSFUL, IT IS NECESSARY TO EXAMINE
C			 THIS PLOT.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 PWRZS,	SRFACE
C FILES
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 A FUNCTION OF TWO VARIABLES IS	DEFINED, AND
C			 VALUES	OF THE FUNCTION	ON A TWO DIMENSIONAL
C			 RECTANGULAR GRID ARE STORED IN	AN ARRAY.  THIS
C			 SUBROUTINE CALLS  SRFACE  TO DRAW A SURFACE
C			 REPRESENTATION	OF THE ARRAY VALUES, AND THEN
C			 PWRZS IS CALLED THREE TIMES TO	LABEL THE
C			 FRONT,	SIDE, AND BACK OF THE PICTURE.
C
C PORTABILITY		 ANSI FORTRAN 77
C
C
      DIMENSION	      Z(20,30)	 ,X(20)	     ,Y(30)	 ,MM(20,30,2),
     1		      S(6)
C
C LOAD THE SRFACE COMMON BLOCK,	NEEDED TO SURPRESS NEWFM CALL
C
      COMMON /SRFIP1/ IFR	 ,ISTP	     ,IROTS	 ,IDRX	     ,
     1		      IDRY	 ,IDRZ	     ,IUPPER	 ,ISKIRT     ,
     2		      NCLA	 ,THETA	     ,HSKIRT	 ,CHI	     ,
     3		      CLO	 ,CINC	     ,ISPVAL
C
C SPECIFY COORDINATES FOR PLOT TITLES.	ON AN ABSTRACT GRID WHERE
C THE INTEGER COORDINATES RANGE	FROM 0.0 TO 1.0, THE VALUES  TX	AND
C TY  DEFINE THE CENTER	OF THE TITLE STRING.
C
      DATA TX/0.4375/, TY/0.9667/
C
C SPECIFY GRID LOOP INDICES, AND LINE OF SIGHT
C
      DATA M/20/, N/30/
      DATA S/4.,5.,3.,0.,0.,0./
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 1
C
C DEFINE FUNCTION VALUES AND STORE IN Z
C
      DO  10 I=1,M
	 X(I) =	-1.+FLOAT(I-1)/FLOAT(M-1)*2.
   10 CONTINUE
      DO  20 J=1,N
	 Y(J) =	-1.+FLOAT(J-1)/FLOAT(N-1)*2.
   20 CONTINUE
      DO  40 J=1,N
	 DO  30	I=1,M
	    Z(I,J) = EXP(-2.*SQRT(X(I)**2+Y(J)**2))
   30	 CONTINUE
   40 CONTINUE
C
C SET SRFACE PARAMETERS	TO SURPRESS FRAME CALL AND DRAW	CONTOURS
      call srfabd
C
      IFR = 0
      IDRZ = 1
C
C SELECT NORMALIZATION TRANS NUMBER 0
C
      CALL GSELNT (0)
C
C LABEL	THE PLOT
C
      CALL WTSTR (TX,TY,'DEMONSTRATION PLOT FOR PWRZS',2,0,0)
C
C DRAW SURFACE PLOT
C
      CALL SRFACE (X,Y,Z,MM,M,M,N,S,0.)
C
C PUT PWRZS LABELS ON PICTURE
C
      ISIZE = 35
      CALL PWRZS (0.,1.1,0.,'FRONT',5,ISIZE,-1,3,0)
      CALL PWRZS (1.1,0.,0.,'SIDE',4,ISIZE,2,-1,0)
      CALL PWRZS (0.,-1.1,.2,' BACK BACK BACK BACK BACK',25,ISIZE,-1,
     1		  3,0)
c     CALL NEWFM
C
      IERROR = 0
c     WRITE (6,1001)
C
C RESTORE SRFACE PARAMETERS TO DEFAULT
C
      IFR = 1
      IDRZ = 0
C
      RETURN
C
C
c1001 FORMAT ('	     PWRZS TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

      subroutine getopt (iopnam,iopval)
      dimension       iopnam(1)      ,iopval(1)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c
c find index for input name
c
      do 101 i=1,9
         iop = i
         if (jlm2(iopnam) .eq. jlm2(mname(i))) go to 102
  101 continue
c
      call uliber (0,36hounknown name in optn or getopt call,36)
      call perror
      return
  102 if (iop .eq. 9) go to 103
      return
  103 do 104 i=1,3
         call ncgchr (mop(iop),3,i,jchar)
         call ncpchr (iopval,3,i,jchar)
  104 continue
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
c +noao: block data conbdn changed to run time initialization
c     BLOCKDATA CONBDN
      subroutine conbdn
C
C
C
C COMMON DATA
C
C NOTE THE COMMON BLOCKS LISTED INCLUDE ALL THE COMMON USED BY
C      THE ENTIRE CONRAN FAMILY, NOT ALL MEMBERS WILL USE ALL
C      THE COMMON DATA.
C
C   CONRA1
C       CL-ARRAY OF CONTOUR LEVELS
C       NCL-NUMBER OF CONTOUR LEVELS
C       OLDZ-Z VALUE OF LEFT NEIGHBOR TO CURRENT LOCATION
C       PV-ARRAY OF PREVIOUS ROW VALUES
C       HI-LARGEST CONTOUR PLOTTED
C       FLO-LOWEST CONTOUR PLOTTED
C       FINC-INCREMENT LEVEL BETWEEN EQUALLY SPACED CONTOURS
C   CONRA2
C       REPEAT-FLAG TO TRIANGULATE AND DRAW OR JUST DRAW
C       EXTRAP-PLOT DATA OUTSIDE OF CONVEX DATA HULL
C       PER-PUT PERIMETER ARROUND PLOT
C       MESS-FLAG TO INDICATE MESSAGE OUTPUT
C       ISCALE-SCALING SWITCH
C       LOOK-PLOT TRIANGLES FLAG
C       PLDVLS-PLOT THE DATA VALUES FLAG
C       GRD-PLOT GRID FLAG
C       CON-USER SET OR PROGRAM SET CONTOURS FLAG
C       CINC-USER OR PROGRAM SET INCREMENT FLAG
C       CHILO-USER OR PROGRAM SET HI LOW CONTOURS
C       LABON-FLAG TO CONTROL LABELING OF CONTOURS
C       PMIMX-FLAG TO CONTROL THE PLOTTING OF MIN"S
C               AND MAX"S
C       SCALE-THE SCALE FACTOR FOR CONTOUR LINE VALUES
C               AND MIN ,       MAX PLOTTED VALUES
C       FRADV-ADVANCE FRAME BEFORE PLOTTING TRIANGUALTION
C       EXTRI-ONLY PLOT TRIANGULATION
C       BPSIZ-BREAKPOINT SIZE FOR DASHPATTERNS
C       LISTOP-LIST OPTIONS ON UNIT6 FLAG
C   CONRA3
C       IREC-PORT RECOVERABLE ERROR FLAG
C   CONRA4
C       NCP-NUMBER OF DATA POINTS USED AT EACH POINT FOR
C           POLYNOMIAL CONSTRUCTION.
C       NCPSZ-MAX SIZE ALLOWED FOR NCP
C   CONRA5
C       NIT-FLAG TO INDICATE STATUS OF SEARCH DATA BASE
C       ITIPV-LAST TRIANGLE INTERPOLATION OCCURRED IN
C  CONRA6
C       XST-X COORDINATE START POINT FOR CONTOURING
C       YST-Y COORDINATE START POINT FOR CONTOURING
C       XED-X COORDINATE END POINT FOR CONTOURING
C       YED-Y COORDINATE END POINT FOR CONTOURING
C       STPSZ-STEP SIZE FOR X,Y CHANGE WHEN CONTOURING
C       IGRAD-NUMBER OF GRADUATIONS FOR CONTOURING(STEP SIZE)
C       IG-RESET VALUE FOR IGRAD
C       XRG-X RANGE OF COORDINATES
C       YRG-Y RANGE OF COORDINATES
C       BORD-PERCENT OF FRAME USED FOR CONTOUR PLOT
C       PXST-X PLOTTER START ADDRESS FOR CONTOURS
C       PYST-Y PLOTTER START ADDRESS FOR CONTOURS
C       PXED-X PLOTTER END ADDRESS FOR CONTOURS
C       PYED-Y PLOTTER END ADDRESS FOR CONTOURS
C       ITICK-NUMBER OF TICK MARKS FOR GRIDS AND PERIMETERS
C CONRA7
C       TITLE-SWITCH TO INDICATE IF TITLE OPTION ON OR OFF
C       ISTRNG-CHARACTER STRING OF TITLE
C       ICNT-CHARACTER COUNT OF ISTRNG
C       ITLSIZ-SIZE OF TITLE IN PWRIT UNITS
C CONRA8
C       IHIGH-DEFAULT COLOR (INTENSITY) INDEX SETTING
C       INMAJ-CONTOUR LEVEL COLOR (INTENSITY) INDEX FOR MAJOR LINES
C       INMIN-CONTOUR LEVEL COLOR (INTENSITY) INDEX FOR MINOR LINES
C       INLAB-TITLE AND MESSAGE COLOR (INTENSITY) INDEX
C       INDAT-DATA VALUE COLOR (INTENSITY) INDEX
C       FORM-THE FORMAT FOR PLOTTING THE DATA VALUES
C       LEN-THE NUMBER OF CHARACTERS IN THE FORMAT
C       IFMT-SIZE OF THE FORMAT FIELD
C       LEND-DEFAULT FORMAT LENGTH
C       IFMTD-DEFAULT FORMAT FIELD SIZE
C       ISIZEP-SIZE OF THE PLOTTED DATA VALUES
C  CONRA9
C       X-ARRAY OF X COORDINATES OF CONTOURS DRAWN AT CURRENT CONTOUR
C          LEVEL
C       Y-ARRAY OF Y COORDINATES OF CONTOURS DRAWN AT CURRENT CONTOUR
C          LEVEL
C       NP-COUNT IN X AND Y
C       MXXY-SIZE OF X AND Y
C       TR-TOP RIGHT CORNER VALUE OF CURRENT CELL
C       BR-BOTTOM RIGHT CORNER VALUE OF CURRENT CELL
C       TL-TOP LEFT CORNER VALUE OF CURRENT CELL
C       BL-BOTTOM LEFT CORNER VALUE OF CURRENT CELL
C       CONV-CURRENT CONTOUR VALUE
C       XN-X POSITION WHERE CONTOUR IS BEING DRAWN
C       YN-Y POSITION WHERE CONTOUR IS BEING DRAWN
C       ITLL-TRIANGLE WHERE TOP LEFT CORNER OF CURRENT CELL LIES
C       IBLL-TRIANGLE OF BOTTOM LEFT CORNER
C       ITRL-TRIANGLE OF TOP RIGHT CORNER
C       IBRL-TRIANGLE OF BOTTOM LEFT CORNER
C       XC-X COORDINATE OF CURRENT CELL
C       YC-Y CORRDINATE OF CURRENT CELL
C       ITLOC-IN CONJUNCTION WITH PV STORES THE TRIANGLE WHERE PV
C               VALUE CAME FROM
C CONR10
C       NT-NUMBER OF TRIANGLES GENERATED
C       NL-NUMBER OF LINE SEGMENTS
C       NTNL-NT+NL
C       JWIPT-POINTER INTO IWK WHERE WHERE TRIANGLE POINT NUMBERS
C               ARE STORED
C       JWIWL-IN IWK THE LOCATION OF A SCRATCH SPACE
C       JWIWP-IN IWK THE LOCATION OF A SCRATCH SPACE
C       JWIPL-IN IWK THE LOCATION OF END POINTS FOR BORDER LINE
C               SEGMENTS
C       IPR-IN WK THE LOCATION OF THE PARTIAL DERIVITIVES AT EACH
C           DATA POINT
C       ITPV-THE TRIANGLE WHERE THE PREVIOUS VALUE CAME FROM
C CONR11
C       NREP-NUMBER OF REPETITIONS OF DASH PATTERN BEFORE A LABEL
C       NCRT-NUMBER OF CRT UNITS FOR A DASH MARK OR BLANK
C       ISIZEL-SIZE OF CONTOUR LINE LABELS
C       NDASH-ARRAY CONTAINING THE NEGATIVE VALUED CONTOUR DASH
C               PATTERN
C       MINGAP-NUMBER OF UNLABELED LINES BETWEEN EACH LABELED ONE
C       IDASH-POSITIVE VALUED CONTOUR DASH PATTERN
C       ISIZEM-SIZE OF PLOTTED MINIMUMS AND MAXIMUMS
C       EDASH-EQUAL VALUED CONTOUR DASH PATTERN
C       TENS-DEFAULT TENSION SETTING FOR SMOOTHING
C CONR12
C       IXMAX,IYMAX-MAXINUM X AND Y COORDINATES RELATIVE TO THE
C                 SCRATCH ARRAY, SCRARR
C       XMAX,YMAX-MAXIMUM X AND Y COORDINATES RELATIVE TO USERS
C                 COORDINATE SPACE
C CONR13
C       XVS-ARRAY OF THE X COORD FOR SHIELDING
C       YVS-ARRAY OF THE Y COORD FOR SHIELDING
C       IXVST-POINTER (VIA LOC) TO THE USERS X ARRAY FOR SHIELDING
C       IYVST-POINTER (VIA LOC) TO THE USERS Y ARRAY FOR SHIELDING
C       ICOUNT-COUNT OF THE SHIELD ELEMENTS
C       SPVAL-SPECIAL VALUE USED TO HALT CONTOURING AT THE SHIELD
C               BOUNDRY
C       SHIELD-LOGICAL FLAG TO SIGNAL STATUS OF SHIELDING
C       SLDPLT-LOGICAL FLAG TO INDICTE STATUS OF SHIEDL PLOTTING
C CONR14
C       LINEAR-C1 LINAER INTERPOLATIN FLAG
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ    ,PV(210),
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER   ,MESS,
     1                ISCALE     ,LOOK           ,PLDVLS  ,GRD,
     2                CINC       ,CHILO         ,CON     ,LABON,
     3                PMIMX      ,SCALE          ,FRADV  ,EXTRI,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED,
     1                STPSZ      ,IGRAD          ,IG     ,XRG,
     2                YRG        ,BORD       ,PXST       ,PYST,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ          ,INLAB  ,INDAT,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP         ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP              ,MXXY  ,TR,
     1                BR         ,TL               ,BL   ,CONV,
     2                XN         ,YN               ,ITLL      ,IBLL,
     3                ITRL       ,IBRL       ,XC         ,YC,
     4                ITLOC(210) ,JX              ,JY    ,ILOC ,
     5                ISHFCT     ,XO         ,YO         ,IOC    ,NC
      COMMON /CONR10/ NT         ,NL               ,NTNL       ,JWIPT,
     1                JWIWL      ,JWIWP          ,JWIPL  ,IPR  ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX          ,XMAX   ,YMAX
      LOGICAL         REPEAT       ,EXTRAP      ,PER     ,MESS,
     1                LOOK       ,PLDVLS        ,GRD     ,LABON,
     2                PMIMX      ,FRADV          ,EXTRI  ,CINC,
     3                TITLE      ,LISTOP         ,CHILO  ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      logical first
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        COMMON /RAQINT/ IRAQMJ, IRAQMN, IRAQTX
        COMMON /RASINT/ IRASMJ, IRASMN, IRASTX
C
        SAVE
C
C
c +noao:  parameter added to avoid clobbering initialization done
c by conop[1-4].  
        data first /.true./
        if (.not. first) return
        first = .false.
c -noao
C
c       DATA ICOUNT,SHIELD,SLDPLT,LINEAR/0,.FALSE.,.FALSE.,.FALSE./
        ICOUNT = 0
        SHIELD = .FALSE.
        SLDPLT = .FALSE.
        LINEAR = .FALSE.
c
c       DATA REPEAT,EXTRAP,PER/.FALSE.,.FALSE.,.TRUE./
        REPEAT = .FALSE.
        EXTRAP = .FALSE.
        PER = .TRUE.
c
c       DATA FRADV,EXTRI,BPSIZ/.TRUE.,.FALSE.,0.0/
        FRADV = .TRUE.
        EXTRI = .FALSE.
        BPSIZ = 0.0
c
c       DATA TITLE,MESS,LOOK/.FALSE.,.TRUE.,.FALSE./
        TITLE = .FALSE.
        MESS  = .TRUE.
        LOOK  = .FALSE.
c
c       DATA PLDVLS,GRD/.FALSE.,.FALSE./
        PLDVLS = .FALSE.
        GRD     = .FALSE.
c
c       DATA CON,CINC,CHILO/.FALSE.,.FALSE.,.FALSE./
        CON   = .FALSE.
        CINC  = .FALSE.
        CHILO = .FALSE.
c
c       DATA SCALE,PMIMX/1.,.FALSE./
        SCALE = 1.
        PMIMX = .FALSE.
c
c       DATA ISIZEP,ISIZEM,TENS/8,15,2.5/
        ISIZEP = 8
        ISIZEM = 15
        TENS    = 2.5
c
c       DATA INMAJ,INMIN,INLAB,INDAT/1, 1, 1, 1/
        INMAJ = 2
        INMIN = 1
        INLAB = 2
        INDAT = 1
c
c       DATA IRANMJ, IRANMN, IRANTX /1, 1, 1/
        IRANMJ = 2
        IRANMN = 1
        IRANTX = 1
c
c       DATA IRASMJ, IRASMN, IRASTX /1, 1, 1/
        IRASMJ = 2
        IRASMN = 1
        IRASTX = 1
c
c       DATA IRAQMJ, IRAQMN, IRAQTX /1, 1, 1/
        IRAQMJ = 2
        IRAQMN = 1
        IRAQTX = 1
c
c       DATA LABON/.TRUE./,LISTOP/.FALSE./
        LABON   = .TRUE.
        LISTOP = .FALSE.
c
c       DATA BORD,ITICK/.9,10/
        BORD  = .9
        ITICK = 10
c
c       DATA ISCALE,ITLSIZ/0,16/
        ISCALE = 0
        ITLSIZ = 16
c
c       DATA ITIPV,NIT,NCL/0,0,0/
        ITIPV = 0
        NIT   = 0
        NCL   = 0
c
c       DATA NCPSZ/25/
        NCPSZ = 25
c
c       DATA IHIGH/255/
        IHIGH = 255
c
c       DATA NCP /4/
        NCP  = 4
c
c       DATA IREC /1/
        IREC  = 1
c
c       DATA LEN,IFMT,LEND,IFMTD/0,0,7,10/
        LEN = 0
        IFMT = 0
        LEND = 7
        IFMTD = 10
c
c       DATA IGRAD,IG/40,40/
        IGRAD = 40
        IG    = 40
c
c       DATA NREP,NCRT,ISIZEL,MXXY,MINGAP/6,3,9,500,3/
        NREP = 6
        NCRT = 3
        ISIZEL = 9
        MXXY = 500
        MINGAP = 3
c
c       DATA IDASH(1:1)/' '/
        IDASH(1:1) = ' '
c
c       DATA NDASH(1:1)/' '/
        NDASH(1:1) = ' '
c
c       DATA EDASH(1:1)/' '/
        EDASH(1:1) = ' '
c
c       DATA ISHFCT/9/
        ISHFCT = 9
c
c - noao
      END

#-h-  sdupl			  374  local   12/01/80  15:55:03
# sdupl --- duplicate a string in dynamic storage space
   include  defs

   pointer function sdupl (str)
   character str (ARB)

   DS_COMMON

   integer i
   integer length

   pointer j
   pointer dsget

   j = dsget (length (str) + 1)
   sdupl = j
   for (i = 1; str (i) != EOS; i = i + 1) {
      mem (j) = str (i)
      j = j + 1
      }
   mem (j) = EOS

   return
   end

C----------------------------------------------------------------------
        subroutine ftpi1b(ounit,nvals,incre,chbuff,status)

C       Write an array of Integer*1 bytes to the output FITS file.

        integer nvals,incre,ounit,status,i,offset
        character*1 chbuff(nvals)

C       ounit   i  fortran unit number
C       nvals   i  number of pixels in the i2vals array
C       incre   i  byte increment between values
C       chbuff  c*1 array of input byte values
C       status  i  output error status

        if (incre .le. 1)then
                call ftpcbf(ounit,0,nvals,chbuff,status)
        else
C               offset is the number of bytes to move between each value
                offset=incre-1
                call ftpcbf(ounit,0,1,chbuff,status)
                do 10 i=2,nvals
                        call ftmoff(ounit,offset,.true.,status)
                        call ftpcbf(ounit,0,1,chbuff(i),status)
10              continue
        end if
        end

      SUBROUTINE slCTFD (IHOUR, IMIN, SEC, DAYS, J)
*+
*     - - - - - -
*      C T F D
*     - - - - - -
*
*  Convert hours, minutes, seconds to days (single precision)
*
*  Given:
*     IHOUR       int       hours
*     IMIN        int       minutes
*     SEC         real      seconds
*
*  Returned:
*     DAYS        real      interval in days
*     J           int       status:  0 = OK
*                                    1 = IHOUR outside range 0-23
*                                    2 = IMIN outside range 0-59
*                                    3 = SEC outside range 0-59.999...
*
*  Notes:
*
*  1)  The result is computed even if any of the range checks
*      fail.
*
*  2)  The sign must be dealt with outside this routine.
*
*  P.T.Wallace   Starlink   November 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IHOUR,IMIN
      REAL SEC,DAYS
      INTEGER J

*  Seconds per day
      REAL D2S
      PARAMETER (D2S=86400.0)



*  Preset status
      J=0

*  Validate sec, min, hour
      IF (SEC.LT.0.0.OR.SEC.GE.60.0) J=3
      IF (IMIN.LT.0.OR.IMIN.GT.59) J=2
      IF (IHOUR.LT.0.OR.IHOUR.GT.23) J=1

*  Compute interval
      DAYS=(60.0*(60.0*REAL(IHOUR)+REAL(IMIN))+SEC)/D2S

      END

      integer function equal (str1, str2)
      integer str1(100), str2(100)
      integer i
      i = 1
23000 if (.not.(str1 (i) .eq. str2 (i)))goto 23002
      if (.not.(str1 (i) .eq. -2))goto 23003
      equal=(1)
      return
23003 continue
23001 i = i + 1
      goto 23000
23002 continue
      equal=(0)
      return
      end

C----------------------------------------------------------------------
        subroutine ftpcne(ounit,colnum,frow,felem,nelem,array,nulval,
     &                    status)

C       write array of floating point pixels to the specified column
C       of a table.  Any input pixels equal to the value of NULVAL will
C       be replaced by the appropriate null value in the output FITS file. 

C       ounit   i  fortran unit number
C       colnum  i  number of the column to write to
C       frow    i  first row to write
C       felem   i  first element within the row to write
C       nelem   i  number of elements to write
C       array   r  array of data values to be written 
C       nulval  r  pixel value used to represent an undefine pixel
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1994

        integer ounit,colnum,frow,felem,nelem,status
        real array(*),nulval

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,repeat,first,ngood,nbad,i,fstelm,fstrow

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

C       get the column repeat count and calculate the absolute position within
C       the column of the first element to be written
        repeat=trept(colnum+tstart(ibuff))
        first=(frow-1)*repeat+felem-1

        ngood=0
        nbad=0
        do 10 i=1,nelem
            if (array(i) .ne. nulval)then
                ngood=ngood+1
                if (nbad .gt. 0)then
C                   write the previous consecutive set of null pixels
                    fstelm=i-nbad+first
C                   calculate the row and element of the first pixel to write
                    fstrow=(fstelm-1)/repeat+1
                    fstelm=fstelm-(fstrow-1)*repeat
                    call ftpclu(ounit,colnum,fstrow,fstelm,nbad,status)
                    nbad=0
                end if
            else
                nbad=nbad+1
                if (ngood .gt. 0)then
C                   write the previous consecutive set of good pixels
                    fstelm=i-ngood+first
C                   calculate the row and element of the first pixel to write
                    fstrow=(fstelm-1)/repeat+1
                    fstelm=fstelm-(fstrow-1)*repeat
                    call ftpcle(ounit,colnum,fstrow,fstelm,ngood,
     &                          array(i-ngood),status)
                    ngood=0
                end if
            end if
10      continue

C       finished;  now just write the last set of pixels
        if (nbad .gt. 0)then
C           write the consecutive set of null pixels
            fstelm=i-nbad+first
            fstrow=(fstelm-1)/repeat+1
            fstelm=fstelm-(fstrow-1)*repeat
            call ftpclu(ounit,colnum,fstrow,fstelm,nbad,status)
        else
C           write the consecutive set of good pixels
            fstelm=i-ngood+first
            fstrow=(fstelm-1)/repeat+1
            fstelm=fstelm-(fstrow-1)*repeat
            call ftpcle(ounit,colnum,fstrow,fstelm,ngood,
     &                  array(i-ngood),status)
        end if
        end

      subroutine dtblok ( bloks, integs, nbloks, ipivot, iflag,
     *			  detsgn, detlog )
c  computes the determinant of an almost block diagonal matrix whose
c  plu factorization has been obtained previously in fcblok.
c  *** the logarithm of the determinant is computed instead of the
c  determinant itself to avoid the danger of overflow or underflow
c  inherent in this calculation.
c
c parameters
c    bloks, integs, nbloks, ipivot, iflag  are as on return from fcblok.
c	     in particular, iflag = (-1)**(number of interchanges dur-
c	     ing factorization) if successful, otherwise iflag = 0.
c    detsgn  on output, contains the sign of the determinant.
c    detlog  on output, contains the natural logarithm of the determi-
c	     nant if determinant is not zero. otherwise contains 0.
c
      integer nbloks, index, nrow
      integer integs(3,nbloks),ipivot(1),iflag, i,indexp,ip,k,last
      real bloks(1),detsgn,detlog
c
      detsgn = iflag
      detlog = 0.
      if (iflag .eq. 0) 		return
      index = 0
      indexp = 0
      do 2 i=1,nbloks
	 nrow = integs(1,i)
	 last = integs(3,i)
	 do 1 k=1,last
	    ip = index + nrow*(k-1) + ipivot(indexp+k)
	    detlog = detlog + alog(abs(bloks(ip)))
    1	    detsgn = detsgn*sign(1.,bloks(ip))
	 index = nrow*integs(2,i) + index
    2	 indexp = indexp + nrow
					return
      end

      SUBROUTINE CONCLD (ICASE,IOOP)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
      INTEGER GOOP
C
        SAVE
        DATA GOOP/0/
C
C  STATEMENT FUNCTIONS FOR CONTOUR PLACEMENT WITHIN CELLS
C
      CX(W1,W2) = STPSZ*( (W1-CONV)/(W1-W2) )
      CY(W1,W2) = STPSZ*( (W1-CONV)/(W1-W2) )
      IC = ICASE
      ICASE = 0
C
C  SPECIAL PROCESSING IF SHIELDING ACTIVATED
C
      IF (.NOT.SHIELD) GO TO 1
C
C  CHECK IF ANY CELL CORNER CONTAINS A SPECIAL VALUE
C       IF SO THEN FLAG AND RETURN
C
      IF (TR.NE.SPVAL.AND.BR.NE.SPVAL.AND.TL.NE.SPVAL.AND.BL.NE.SPVAL)
     1      GO TO 1
C
C  SPECIAL VALUE IN CELL FLAG AND RETURN
C
      ICASE = -1
      RETURN
C
C  IF CURRENT BR VALUE LESS THAN CONTOUR THEN NEIGHBOR WILL BE WHERE
C  CONTOUR IS DRAWN.
C
 1    CONTINUE
C
      IF (BR.LT.CONV) GO TO    90
C
C  CURRENT LOCATION IS WHERE CONTOUR WILL BE DRAWN
C
C  TEST FOR VERTICAL CONTOUR BREAK
C
      IF (BL.GE.CONV) GO TO    60
C
C  VERTICAL CONTOUR BREAK
C
C  CASE 1 LEFT NEIGHBOR LESS THAN CONTOUR LEVEL AND CURRENT
C  LOCATION GE CONTOUR VALUE
C
      IF (TR.GE.CONV) GO TO    40
C
C  CASE 1A CONTOUR LOWER RIGHT
C
C
C  CONTOUR FROM UPPER RIGHT
C
      XO = XC-CX(BR,TR)
      YO = YC
      YN = YC-CY(BR,BL)
      XN = XC
      NC = 1
      IOC = 4
      IF (IC.NE.3) GO TO    10
      ICASE = IOC
      XN = XO
      YN = YO
      RETURN
   10 IF (IOOP.NE.GOOP) GO TO    20
      IF (IC.NE.2) GO TO    30
   20 ICASE = NC
      RETURN
C
C CASE 1B  CONTOR UPPER LEFT
C
   30 XN = XC-STPSZ
      YN = YC-STPSZ+CY(TL,TR)
      XO = XC-STPSZ+CX(TL,BL)
      YO = YC-STPSZ
      IOC = 2
      NC = 3
      GO TO   180
C
C  CONTOURS FROM ABOVE AND UPPER LEFT
C
   40 IF (TL.LT.CONV) GO TO    50
C
C  CASE 1C CONTOUR LOWER LEFT
C
      XO = XC-STPSZ+CX(TL,BL)
      YO = YC-STPSZ
      YN = YC-CY(BR,BL)
      XN = XC
      NC = 1
      IOC = 2
      GO TO   180
C
C CASE 1D CONTOUR FROM ABOVE
C
   50 XO = XC-STPSZ
      YO = YC-CY(TR,TL)
      YN = YC-CY(BR,BL)
      XN = XC
      NC = 1
      IOC = 3
      GO TO   180
C
C
C  TEST FOR HORIZONTAL CONTOUR BREAK
C
   60 IF (TR.LT.CONV) GO TO    70
      IF (TL.GE.CONV) GO TO   200
C
C  CASE 2A CONTOUR UPPER LEFT
C
      XO = XC-STPSZ
      YO = YC-CY(TR,TL)
      XN = XC-CX(BL,TL)
      YN = YC-STPSZ
      NC = 2
      IOC = 3
      GO TO   180
C
   70 IF (TL.LT.CONV) GO TO    80
C
C  CASE 2B CONTOUR FROM UPPER RIGHT
C
      XO = XC-STPSZ
      YO = YC-STPSZ+CY(TL,TR)
      XN = XC-CX(BR,TR)
      YN = YC
      NC = 4
      IOC = 3
      GO TO   180
C
C  CASE 2C CONTOUR FROM LEFT TO RIGHT
C
   80 XO = XC-CX(BL,TL)
      YO = YC-STPSZ
      XN = XC-CX(BR,TR)
      YN = YC
      NC = 4
      IOC = 2
      GO TO   180
C
C
C  CURRENT BR VALUE LESS THAN CONTOUR
C
C
   90 IF (BL.LT.CONV) GO TO   150
C
C  VERTICAL CONTOUR BREAK
C
C  CASE 3 CURRENT SPACE LESS THAN CONTOUR LEVEL AND LEFT
C  NEIGHBOR GE CONTOUR LEVEL
C
      IF (TL.GE.CONV) GO TO   130
C
C  CASE 3A CONTOUR LOWER LEFT
C
      XO = XC-CX(BL,TL)
      YO = YC-STPSZ
      YN = YC-STPSZ+CY(BL,BR)
      XN = XC
      NC = 1
      IOC = 2
      IF (IC.NE.3) GO TO   100
      ICASE = IOC
      XN = XO
      YN = YO
      RETURN
  100 IF (IOOP.NE.GOOP) GO TO   110
      IF (IC.NE.4) GO TO   120
  110 ICASE = NC
      RETURN
C
C  CASE 3B CONTOUR UPPERRIGHT
C
  120 XO = XC-STPSZ
      YO = YC-CY(TR,TL)
      XN = XC-STPSZ+CX(TR,BR)
      YN = YC
      NC = 4
      IOC = 3
      GO TO   180
C
  130 IF (TR.GE.CONV) GO TO   140
C
C  CASE 3C CONTOUR FROM ABOVE
C
      XO = XC-STPSZ
      YO = YC-STPSZ+CY(TL,TR)
      YN = YC-STPSZ+CY(BL,BR)
      XN = XC
      NC = 1
      IOC = 3
      GO TO   180
C
C  CASE 3D CONTOUR LOWER RIGHT
C
  140 XO = XC-STPSZ+CX(TR,BR)
      YO = YC
      YN = YC-STPSZ+CY(BL,BR)
      XN = XC
      NC = 1
      IOC = 4
      GO TO   180
C
C
C
C  TEST FOR HORIZONTAL BREAK POINT
C
  150 IF (TR.GE.CONV) GO TO   160
C
      IF (TL.LT.CONV) GO TO   200
C
C  CASE 4A CONTOUR UPPER LEFT
C
      XN = XC-STPSZ+CX(TL,BL)
      YN = YC-STPSZ
      XO = XC-STPSZ
      YO = YC-STPSZ+CY(TL,TR)
      NC = 2
      IOC = 3
      GO TO   180
C
  160 IF (TL.GE.CONV) GO TO   170
C
C  CASE 4B CONTOUR UPPER RIGHT
C
      XO = XC-STPSZ
      YO = YC-CY(TR,TL)
      XN = XC-STPSZ+CX(TR,BR)
      YN = YC
      NC = 4
      IOC = 3
      GO TO   180
C
C  CASE 4C CONTOUR FROM LEFT TO RIGHT
C
  170 YO = YC-STPSZ
      XO = XC-STPSZ+CX(TL,BL)
      XN = XC-STPSZ+CX(TR,BR)
      YN = YC
      NC = 4
      IOC = 2
C
C  DRAW THE CONTOUR LINES NOT ALREADY TAKEN CARE OF
C
  180 IF (IABS(IC-NC).NE.2) GO TO   190
      ICASE = IOC
      XN = XO
      YN = YO
      RETURN
  190 ICASE = NC
  200 RETURN
      END

c     prog2
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	 demonstrate algorithm	hfti  for solving least squares problems
c     and algorithm  cov  for computing the associated unscaled
c     covariance matrix.
c
      dimension a(8,8),h(8),b(8),g(8)
      real gen,anoise
      integer ip(8)
      double precision sm
      data mda /8/
c
	  do 180 noise=1,2
	  anorm=500.
	  anoise=0.
	  tau=.5
	  if (noise.eq.1) go to 10
	  anoise=1.e-4
	  tau=anorm*anoise*10.
   10	  continue
c     initialize the data generation function
c    ..
	  dummy=gen(-1.)
	  write (6,230)
	  write (6,240) anoise,anorm,tau
c
	      do 180 mn1=1,6,5
	      mn2=mn1+2
		  do 180 m=mn1,mn2
		      do 180 n=mn1,mn2
		      write (6,250) m,n
c     generate data
c    ..
			  do 20 i=1,m
			      do 20 j=1,n
   20			      a(i,j)=gen(anoise)
			  do 30 i=1,m
   30			  b(i)=gen(anoise)
c
c     ****** call hfti	 ******
c
		      call hfti(a,mda,m,n,b,1,1,tau,krank,srsmsq,h,g,ip)
c
c
		      write (6,260) krank
		      write (6,200) (i,b(i),i=1,n)
		      write (6,190) srsmsq
		      if (krank.lt.n) go to 180
c     ******  algorithm cov bigins here  ******
c    ..
			  do 40 j=1,n
   40			  a(j,j)=1./a(j,j)
		      if (n.eq.1) go to 70
		      nm1=n-1
			  do 60 i=1,nm1
			  ip1=i+1
			      do 60 j=ip1,n
			      jm1=j-1
			      sm=0.d0
				  do 50 l=i,jm1
   50				  sm=sm+a(i,l)*dble(a(l,j))
   60			      a(i,j)=-sm*a(j,j)
c    ..
c     the upper triangle of a has been inverted
c     upon itself.
   70			  do 90 i=1,n
			      do 90 j=i,n
			      sm=0.d0
				  do 80 l=j,n
   80				  sm=sm+a(i,l)*dble(a(j,l))
   90			      a(i,j)=sm
		      if (n.lt.2) go to 160
			  do 150 ii=2,n
			  i=n+1-ii
			  if (ip(i).eq.i) go to 150
			  k=ip(i)
			  tmp=a(i,i)
			  a(i,i)=a(k,k)
			  a(k,k)=tmp
			  if (i.eq.1) go to 110
			      do 100 l=2,i
			      tmp=a(l-1,i)
			      a(l-1,i)=a(l-1,k)
  100			      a(l-1,k)=tmp
  110			  ip1=i+1
			  km1=k-1
			  if (ip1.gt.km1) go to 130
			      do 120 l=ip1,km1
			      tmp=a(i,l)
			      a(i,l)=a(l,k)
  120			      a(l,k)=tmp
  130			  if (k.eq.n) go to 150
			  kp1=k+1
			      do 140 l=kp1,n
			      tmp=a(i,l)
			      a(i,l)=a(k,l)
  140			      a(k,l)=tmp
  150			  continue
  160		      continue
c    ..
c     covariance has been computed and repermuted.
c     the upper triangular part of the
c     symmetric matrix (a**t*a)**(-1) has
c     replaced the upper triangular part of
c     the a array.
		      write (6,210)
			  do 170 i=1,n
  170			  write (6,220) (i,j,a(i,j),j=i,n)
  180		      continue
      stop
  190 format (1h0,8x,17hresidual length =,e12.4)
  200 format (1h0,8x,34hestimated parameters,  x=a**(+)*b,,22h computed
     1by 'hfti'   //(9x,i6,e16.8,i6,e16.8,i6,e16.8,i6,e16.8,i6,e16.8))
  210 format (1h0,8x,31hcovariance matrix (unscaled) of,22h estimated pa
     1rameters.,19h computed by 'cov'./1x)
  220 format (9x,2i3,e16.8,2i3,e16.8,2i3,e16.8,2i3,e16.8,2i3,e16.8)
  230 format (52h1 prog2.     this program demonstates the algorithms,16
     1h hfti  and  cov.)
  240 format (1h0,54hthe relative noise level of the generated data will
     1 be,e16.4/33h0the matrix norm is approximately,e12.4/43h0the absol
     2ute pseudorank tolerance, tau, is,e12.4)
  250 format (1h0////9h0   m   n/1x,2i4)
  260 format (1h0,8x,12hpseudorank =,i4)
      end

      subroutine sbblok ( bloks, integs, nbloks, ipivot, b, x )
calls subroutines  s u b f o r	and  s u b b a k .
c
c  supervises the solution (by forward and backward substitution) of
c  the linear system  a*x = b  for x, with the plu factorization of  a
c  already generated in  f c b l o k .	individual blocks of equations
c  are solved via  s u b f o r	and  s u b b a k .
c
c parameters
c    bloks, integs, nbloks, ipivot    are as on return from fcblok.
c    b	     the right side, stored corresponding to the storage of
c	     the equations. see comments in  s l v b l k  for details.
c    x	     solution vector
c
      integer nbloks
      integer integs(3,nbloks),ipivot(1), i,index,indexb,indexx,j,last,
     *	      nbp1,ncol,nrow
      real bloks(1),b(1),x(1)
c
c      forward substitution pass
c
      index = 1
      indexb = 1
      indexx = 1
      do 20 i=1,nbloks
	 nrow = integs(1,i)
	 last = integs(3,i)
	 call subfor(bloks(index),ipivot(indexb),nrow,last,b(indexb),
     *		     x(indexx))
	 index = nrow*integs(2,i) + index
	 indexb = indexb + nrow
   20	 indexx = indexx + last
c
c     back substitution pass
c
      nbp1 = nbloks + 1
      do 30 j=1,nbloks
	 i = nbp1 - j
	 nrow = integs(1,i)
	 ncol = integs(2,i)
	 last = integs(3,i)
	 index = index - nrow*ncol
	 indexb = indexb - nrow
	 indexx = indexx - last
   30	 call subbak(bloks(index),ipivot(indexb),nrow,ncol,last,
     *		     x(indexx))
					return
      end

      subroutine bspp2d ( t, bcoef, n, k, m, scrtch, break, coef, l )
c  from  * a practical guide to splines *  by c. de boor
calls  bsplvb
c  this is an extended version of  bsplpp  for use with tensor products
c
converts the b-representation  t, bcoef(.,j), n, k  of some spline into
c  its pp-representation  break, coef(j,.,.), l, k , j=1, ..., m  .
c
c******  i n p u t  ******
c  t.....knot sequence, of length  n+k
c  bcoef(.,j) b-spline coefficient sequence, of length	n ,j=1,...,m
c  n.....length of  bcoef  and	dimension of spline space  spline(k,t)
c  k.....order of the spline
c
c  w a r n i n g  . . .  the restriction   k .le. kmax (= 20)	is impo-
c	 sed by the arbitrary dimension statement for  biatx  below, but
c	 is  n o w h e r e   c h e c k e d   for.
c
c  m	 number of data sets
c
c******  w o r k   a r e a  ******
c  scrtch   of size  (k,k,m), needed to contain bcoeffs of a piece of
c	 the spline and its  k-1  derivatives	for each of the m sets
c
c******  o u t p u t  ******
c  break.....breakpoint sequence, of length  l+1, contains (in increas-

c	 ing order) the distinct points in the sequence  t(k),...,t(n+1)
c  coef(mm,.,.)  array of size (k,n), with  coef(mm,i,j) = (i-1)st der-
c	 ivative of  mm-th  spline at break(j) from the right, mm=1,.,m
c  l.....number of polynomial pieces which make up the spline in the in-
c	 terval  (t(k), t(n+1))
c
c******  m e t h o d  ******
c     for each breakpoint interval, the  k  relevant b-coeffs of the
c  spline are found and then differenced repeatedly to get the b-coeffs

c  of all the derivatives of the spline on that interval. the spline and
c  its first  k-1  derivatives are then evaluated at the left end point

c  of that interval, using  bsplvb  repeatedly to obtain the values of
c  all b-splines of the appropriate order at that point.
c
c     parameter kmax = 20
      integer k,l,m,n,	 i,j,jp1,kmj,left,lsofar,mm
      real bcoef(n,m),break(1),coef(m,k,1),t(1),   scrtch(k,k,m)
     *					      ,biatx(20),diff,fkmj,sum
c
c    *					      ,biatx(kmax),diff,fkmj,sum
c     dimension break(l+1),coef(k,l),t(n+k)
current fortran standard makes it impossible to specify the length of
c  break , coef  and  t  precisely without the introduction of otherwise
c  superfluous additional arguments.
      lsofar = 0
      break(1) = t(k)
      do 50 left=k,n
c				 find the next nontrivial knot interval.
	 if (t(left+1) .eq. t(left))	go to 50
	 lsofar = lsofar + 1
	 break(lsofar+1) = t(left+1)
	 if (k .gt. 1)			go to 9
	 do 5 mm=1,m
    5	    coef(mm,1,lsofar) = bcoef(left,mm)
					go to 50
c	 store the k b-spline coeff.s relevant to current knot interval

c			      in  scrtch(.,1) .
    9	 do 10 i=1,k
	    do 10 mm=1,m
   10	       scrtch(i,1,mm) = bcoef(left-k+i,mm)
c
c	 for j=1,...,k-1, compute the  k-j  b-spline coeff.s relevant to
c	 current knot interval for the j-th derivative by differencing
c	 those for the (j-1)st derivative, and store in scrtch(.,j+1) .

	 do 20 jp1=2,k
	    j = jp1 - 1
	    kmj = k - j
	    fkmj = float(kmj)
	    do 20 i=1,kmj
	       diff = (t(left+i) - t(left+i - kmj))/fkmj
	       if (diff .le. 0.)	 go to 20
	       do 15 mm=1,m
   15		  scrtch(i,jp1,mm) =
     *		  (scrtch(i+1,j,mm) - scrtch(i,j,mm))/diff
   20	       continue
c
c	 for  j = 0, ..., k-1, find the values at  t(left)  of the  j+1

c	 b-splines of order  j+1  whose support contains the current
c	 knot interval from those of order  j  (in  biatx ), then comb-

c	 ine with the b-spline coeff.s (in scrtch(.,k-j) ) found earlier
c	 to compute the (k-j-1)st derivative at  t(left)  of the given
c	 spline.
c	    note. if the repeated calls to  bsplvb  are thought to gene-
c	 rate too much overhead, then replace the first call by
c	    biatx(1) = 1.
c	 and the subsequent call by the statement
c	    j = jp1 - 1
c	 followed by a direct copy of the lines
c	    deltar(j) = t(left+j) - x
c		   ......
c	    biatx(j+1) = saved
c	 from  bsplvb . deltal(kmax)  and  deltar(kmax)  would have to
c	 appear in a dimension statement, of course.
c
	 call bsplvb ( t, 1, 1, t(left), left, biatx )
	 do 25 mm=1,m
   25	    coef(mm,k,lsofar) = scrtch(1,k,mm)
	 do 30 jp1=2,k
	    call bsplvb ( t, jp1, 2, t(left), left, biatx )
	    kmj = k+1 - jp1
	    do 30 mm=1,m
	       sum = 0.
	       do 28 i=1,jp1
   28		  sum = biatx(i)*scrtch(i,kmj,mm) + sum
   30	       coef(mm,kmj,lsofar) = sum
   50	 continue
      l = lsofar
					return
      end

      subroutine subfor ( w, ipivot, nrow, last, b, x )
c  carries out the forward pass of substitution for the current block,
c  i.e., the action on the right side corresponding to the elimination
c  carried out in  f a c t r b	for this block.
c     at the end, x(j) contains the right side of the transformed
c  ipivot(j)-th equation in this block, j=1,...,nrow. then, since
c  for i=1,...,nrow-last, b(nrow+i) is going to be used as the right
c  side of equation  i	in the next block (shifted over there from
c  this block during factorization), it is set equal to x(last+i) here.
c
c parameters
c    w, ipivot, nrow, last  are as on return from factrb.
c    b(j)   is expected to contain, on input, the right side of j-th
c	    equation for this block, j=1,...,nrow.
c    b(nrow+j)	 contains, on output, the appropriately modified right
c	    side for equation j in next block, j=1,...,nrow-last.
c    x(j)   contains, on output, the appropriately modified right
c	    side of equation ipivot(j) in this block, j=1,...,last (and
c	    even for j=last+1,...,nrow).
c
      integer nrow
      integer ipivot(nrow), ip,jmax,k, j
      integer last, nrowml, lastp1
c     dimension b(nrow + nrow-last)
      real w(nrow,last),b(1),x(nrow),sum
      ip = ipivot(1)
      x(1) = b(ip)
      if (nrow .eq. 1)			go to 99
      do 15 k=2,nrow
	 ip = ipivot(k)
	 jmax = amin0(k-1,last)
	 sum = 0.
	 do 14 j=1,jmax
   14	    sum = w(ip,j)*x(j) + sum
   15	 x(k) = b(ip) - sum
c
c     transfer modified right sides of equations ipivot(last+1),...,
c     ipivot(nrow) to next block.
      nrowml = nrow - last
      if (nrowml .eq. 0)		go to 99
      lastp1 = last+1
      do 25 k=lastp1,nrow
   25	 b(nrowml+k) = x(k)
   99					return
      end

      SUBROUTINE slC62S (V, A, B, R, AD, BD, RD)
*+
*     - - - - - -
*      C 6 2 S
*     - - - - - -
*
*  Conversion of position & velocity in Cartesian coordinates
*  to spherical coordinates (single precision)
*
*  Given:
*     V      r(6)   Cartesian position & velocity vector
*
*  Returned:
*     A      r      longitude (radians)
*     B      r      latitude (radians)
*     R      r      radial coordinate
*     AD     r      longitude derivative (radians per unit time)
*     BD     r      latitude derivative (radians per unit time)
*     RD     r      radial derivative
*
*  P.T.Wallace   Starlink   28 April 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL V(6),A,B,R,AD,BD,RD

      REAL X,Y,Z,XD,YD,ZD,RXY2,RXY,R2,XYP



*  Components of position/velocity vector
      X=V(1)
      Y=V(2)
      Z=V(3)
      XD=V(4)
      YD=V(5)
      ZD=V(6)

*  Component of R in XY plane squared
      RXY2=X*X+Y*Y

*  Modulus squared
      R2=RXY2+Z*Z

*  Protection against null vector
      IF (R2.EQ.0.0) THEN
         X=XD
         Y=YD
         Z=ZD
         RXY2=X*X+Y*Y
         R2=RXY2+Z*Z
      END IF

*  Position and velocity in spherical coordinates
      RXY=SQRT(RXY2)
      XYP=X*XD+Y*YD
      IF (RXY2.NE.0.0) THEN
         A=ATAN2(Y,X)
         B=ATAN2(Z,RXY)
         AD=(X*YD-Y*XD)/RXY2
         BD=(ZD*RXY2-Z*XYP)/(R2*RXY)
      ELSE
         A=0.0
         IF (Z.NE.0.0) THEN
            B=ATAN2(Z,RXY)
         ELSE
            B=0.0
         END IF
         AD=0.0
         BD=0.0
      END IF
      R=SQRT(R2)
      IF (R.NE.0.0) THEN
         RD=(XYP+Z*ZD)/R
      ELSE
         RD=0.0
      END IF

      END

C----------------------------------------------------------------------
        subroutine ftc2x(cval,dtype,ival,lval,sval,dval,status)

C       convert a character string into it intrinsic data type

C       cval  c  input character string to be converted
C       dtype c  returned intrinsic datatype of the string (I,L,C,F)
C
C       one of  the following values is returned, corresponding to the
C       value of dtype:
C               ival i integer value
C               lval l logical value
C               sval c string value
C               dval d double precision value
C       statue i returned error status

        character*(*) cval
        character*1 dtype
        integer ival,status
        logical lval
        character*(*) sval
        double precision dval

C       determine intrinsic datatype
        call ftdtyp(cval,dtype,status)

C       convert string into its intrinsic datatype
        if (dtype .eq. 'I')then
                call ftc2ii(cval,ival,status)
        else if (dtype .eq. 'F')then
                call ftc2dd(cval,dval,status)
        else if (dtype .eq. 'L')then
                call ftc2ll(cval,lval,status)
        else if (dtype .eq. 'C')then
                call ftc2s(cval,sval,status)
        end if
        end

include  defs

# PBSTR -- Push string back onto input.

subroutine pbstr (s)

character s(ARB)			# string to be pushed back.
integer lenstr, i
integer length

#begin
	lenstr = length (s)
	
	# We are called to push back tokens returned by GTOK, which converts
	# the ratfor relational operators >, >=, &, etc. into their Fortran
	# equivalents .gt., .ge., .and., and so on.  This conversion must be
	# reversed in the push back to prevent macro expansion from operating
	# on the strings "gt", "ge, "and", etc.  This is a stupid way to
	# handle this but this ratfor code (which was free) is a hopeless mess
	# already anyhow.

	if (s(1) == PERIOD & s(lenstr) == PERIOD)
	    if (lenstr == 4) {
		if (s(2) == LETG) {
		    if (s(3) == LETT) {			# .gt.
			call putbak (GREATER)
			return
		    } else if (s(3) == LETE) {		# .ge.
			# Note chars are pushed back in
			# reverse order.
			call putbak (EQUALS)
			call putbak (GREATER)
			return
		    }
		} else if (s(2) == LETL) {
		    if (s(3) == LETT) {			# .lt.
			call putbak (LESS)
			return
		    } else if (s(3) == LETE) {		# .le.
			call putbak (EQUALS)
			call putbak (LESS)
			return
		    }
		} else if (s(2) == LETE & s(3) == LETQ) {
		    call putbak (EQUALS)		# .eq.
		    call putbak (EQUALS)
		    return
		} else if (s(2) == LETN & s(3) == LETE) {
		    call putbak (EQUALS)		# .ne.
		    call putbak (BANG)
		    return
		} else if (s(2) == LETO & s(3) == LETR) {
		    call putbak (OR)			# .or.
		    return
		}
	    } else if (lenstr == 5) {
		if (s(2) == LETN & s(3) == LETO & s(4) == LETT) {
		    call putbak (BANG)			# .not.
		    return
		} else if (s(2) == LETA & s(3) == LETN & s(4) == LETD) {
		    call putbak (AND)			# .and.
		    return
		}
	    }

	# Push back an arbitrary string.
	for (i=lenstr;  i > 0;  i=i-1)
	    call putbak (s(i))
end

      real function bvalue ( t, bcoef, n, k, x, jderiv )
c  from  * a practical guide to splines *  by c. de boor
calls  interv
c
calculates value at  x	of  jderiv-th derivative of spline from b-repr.
c  the spline is taken to be continuous from the right.
c
c******  i n p u t ******
c  t, bcoef, n, k......forms the b-representation of the spline  f  to
c	 be evaluated. specifically,
c  t.....knot sequence, of length  n+k, assumed nondecreasing.
c  bcoef.....b-coefficient sequence, of length	n .
c  n.....length of  bcoef  and dimension of spline(k,t),
c	 a s s u m e d	positive .
c  k.....order of the spline .
c
c  w a r n i n g . . .	 the restriction  k .le. kmax (=20)  is imposed
c	 arbitrarily by the dimension statement for  aj, dl, dr  below,
c	 but is  n o w h e r e	c h e c k e d  for.
c
c  x.....the point at which to evaluate .
c  jderiv.....integer giving the order of the derivative to be evaluated
c	 a s s u m e d	to be zero or positive.
c
c******  o u t p u t  ******
c  bvalue.....the value of the (jderiv)-th derivative of  f  at  x .
c
c******  m e t h o d  ******
c     the nontrivial knot interval  (t(i),t(i+1))  containing  x  is lo-
c  cated with the aid of  interv . the	k  b-coeffs of	f  relevant for
c  this interval are then obtained from  bcoef (or taken to be zero if
c  not explicitly available) and are then differenced  jderiv  times to
c  obtain the b-coeffs of  (d**jderiv)f  relevant for that interval.
c  precisely, with  j = jderiv, we have from x.(12) of the text that
c
c     (d**j)f  =  sum ( bcoef(.,j)*b(.,k-j,t) )
c
c  where
c		    / bcoef(.), 		    ,  j .eq. 0
c		    /
c    bcoef(.,j)  =  / bcoef(.,j-1) - bcoef(.-1,j-1)
c		    / ----------------------------- ,  j .gt. 0
c		    /	 (t(.+k-j) - t(.))/(k-j)
c
c     then, we use repeatedly the fact that
c
c    sum ( a(.)*b(.,m,t)(x) )  =  sum ( a(.,x)*b(.,m-1,t)(x) )
c  with
c		  (x - t(.))*a(.) + (t(.+m-1) - x)*a(.-1)
c    a(.,x)  =	  ---------------------------------------
c		  (x - t(.))	  + (t(.+m-1) - x)
c
c  to write  (d**j)f(x)  eventually as a linear combination of b-splines
c  of order  1 , and the coefficient for  b(i,1,t)(x)  must then be the
c  desired number  (d**j)f(x). (see x.(17)-(19) of text).
c
c     parameter kmax = 20
      integer jderiv,k,n,   i,ilo,imk,j,jc,jcmin,jcmax,jj,kmj,km1,mflag
     *			   ,nmi,jdrvp1
      real bcoef(n),t(1),x,   aj(20),dl(20),dr(20),fkmj
c     real bcoef(n),t(1),x,   aj(kmax),dl(kmax),dr(kmax),fkmj
c     dimension t(n+k)
current fortran standard makes it impossible to specify the length of  t
c  precisely without the introduction of otherwise superfluous addition-
c  al arguments.
      bvalue = 0.
      if (jderiv .ge. k)		go to 99
c
c  *** find  i	 s.t.	1 .le. i .lt. n+k   and   t(i) .lt. t(i+1)   and
c      t(i) .le. x .lt. t(i+1) . if no such i can be found,  x	lies
c      outside the support of  the spline  f  and  bvalue = 0.
c      (the asymmetry in this choice of  i  makes  f  rightcontinuous)
      call interv ( t, n+k, x, i, mflag )
      if (mflag .ne. 0) 		go to 99
c  *** if k = 1 (and jderiv = 0), bvalue = bcoef(i).
      km1 = k - 1
      if (km1 .gt. 0)			go to 1
      bvalue = bcoef(i)
					go to 99
c
c  *** store the k b-spline coefficients relevant for the knot interval
c     (t(i),t(i+1)) in aj(1),...,aj(k) and compute dl(j) = x - t(i+1-j),
c     dr(j) = t(i+j) - x, j=1,...,k-1 . set any of the aj not obtainable
c     from input to zero. set any t.s not obtainable equal to t(1) or
c     to t(n+k) appropriately.
    1 jcmin = 1
      imk = i - k
      if (imk .ge. 0)			go to 8
      jcmin = 1 - imk
      do 5 j=1,i
    5	 dl(j) = x - t(i+1-j)
      do 6 j=i,km1
	 aj(k-j) = 0.
    6	 dl(j) = dl(i)
					go to 10
    8 do 9 j=1,km1
    9	 dl(j) = x - t(i+1-j)
c
   10 jcmax = k
      nmi = n - i
      if (nmi .ge. 0)			go to 18
      jcmax = k + nmi
      do 15 j=1,jcmax
   15	 dr(j) = t(i+j) - x
      do 16 j=jcmax,km1
	 aj(j+1) = 0.
   16	 dr(j) = dr(jcmax)
					go to 20
   18 do 19 j=1,km1
   19	 dr(j) = t(i+j) - x
c
   20 do 21 jc=jcmin,jcmax
   21	 aj(jc) = bcoef(imk + jc)
c
c		*** difference the coefficients  jderiv  times.
      if (jderiv .eq. 0)		go to 30
      do 23 j=1,jderiv
	 kmj = k-j
	 fkmj = float(kmj)
	 ilo = kmj
	 do 23 jj=1,kmj
	    aj(jj) = ((aj(jj+1) - aj(jj))/(dl(ilo) + dr(jj)))*fkmj
   23	    ilo = ilo - 1
c
c  *** compute value at  x  in (t(i),t(i+1)) of jderiv-th derivative,
c     given its relevant b-spline coeffs in aj(1),...,aj(k-jderiv).
   30 if (jderiv .eq. km1)		go to 39
      jdrvp1 = jderiv + 1
      do 33 j=jdrvp1,km1
	 kmj = k-j
	 ilo = kmj
	 do 33 jj=1,kmj
	    aj(jj) = (aj(jj+1)*dl(ilo) + aj(jj)*dr(jj))/(dl(ilo)+dr(jj))
   33	    ilo = ilo - 1
   39 bvalue = aj(1)
c
   99					return
      end

C----------------------------------------------------------------------------
        subroutine ftgsfe(iunit,colnum,naxis,naxes,blc,trc,inc,
     &  array,flgval,anynul,status)

C       read a subsection of real data values from an image or
C       a table column.  Returns an associated array of null value flags.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read from
C       naxis   i  number of dimensions in the FITS array
C       naxes   i  size of each dimension. 
C       blc     i  'bottom left corner' of the subsection to be read
C       trc     i  'top right corner' of the subsection to be read
C       inc     i  increment to be applied in each dimension
C       array   i  array of data values that are read from the FITS file
C       flgval  l  set to .true. if corresponding array element is undefined
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1993

        integer iunit,colnum,naxis,naxes(*),blc(*),trc(*),inc(*),status
        real array(*),nulval
        logical anynul,anyf,flgval(*)

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C-------END OF COMMON BLOCK DEFINITIONS:------- -----------------------------

        integer i,i1,i2,i3,i4,i5,i6,i7,i8,i9,row,rstr,rstp,rinc
        integer str(9),stp(9),incr(9),dsize(10)
        integer felem,nelem,nultyp,ninc,ibuff,numcol
        character caxis*20

C       this routine is set up to handle a maximum of nine dimensions

        if (status .gt. 0)return

        if (naxis .lt. 1 .or. naxis .gt. 9)then
                status=320
                write(caxis,1001)naxis
1001            format(i20)
                call ftpmsg('NAXIS ='//caxis//' in the call to FTGSFE '
     &          //'is illegal.')
                return
        end if

C       if this is a primary array, then the input COLNUM parameter should
C       be interpreted as the row number, and we will alway read the image
C       data from column 2 (any group parameters are in column 1).

        ibuff=bufnum(iunit)
        if (hdutyp(ibuff) .eq. 0)then
C               this is a primary array, or image extension
                if (colnum .eq. 0)then
                    rstr=1
                    rstp=1
                else
                    rstr=colnum
                    rstp=colnum
                end if
                rinc=1
                numcol=2
        else
C               this is a table, so the row info is in the (naxis+1) elements
                rstr=blc(naxis+1)
                rstp=trc(naxis+1)
                rinc=inc(naxis+1)
                numcol=colnum
        end if

        nultyp=2
        anynul=.false.
        i1=1
        do 5 i=1,9
                str(i)=1
                stp(i)=1
                incr(i)=1
                dsize(i)=1
5       continue
        do 10 i=1,naxis
                if (trc(i) .lt. blc(i))then
                        status=321
                        write(caxis,1001)i
        call ftpmsg('In FTGSFE, the range specified for axis '//
     &  caxis(19:20)//' has the start greater than the end.')
                        return
                end if
                str(i)=blc(i)
                stp(i)=trc(i)
                incr(i)=inc(i)
                dsize(i+1)=dsize(i)*naxes(i)
10      continue

        if (naxis .eq. 1 .and. naxes(1) .eq. 1)then
C               This is not a vector column, so read all the rows at once
                nelem=(rstp-rstr)/rinc+1
                ninc=rinc
                rstp=rstr
        else
C               have to read each row individually, in all dimensions
                nelem=(stp(1)-str(1))/inc(1)+1
                ninc=incr(1)
        end if

        do 100 row=rstr,rstp,rinc
         do 90 i9=str(9),stp(9),incr(9)
          do 80 i8=str(8),stp(8),incr(8)
           do 70 i7=str(7),stp(7),incr(7)
            do 60 i6=str(6),stp(6),incr(6)
             do 50 i5=str(5),stp(5),incr(5)
              do 40 i4=str(4),stp(4),incr(4)
               do 30 i3=str(3),stp(3),incr(3)
                do 20 i2=str(2),stp(2),incr(2)

        felem=str(1)+(i2-1)*dsize(2)+(i3-1)*dsize(3)+(i4-1)*dsize(4)
     &  +(i5-1)*dsize(5)+(i6-1)*dsize(6)+(i7-1)*dsize(7)
     &  +(i8-1)*dsize(8)+(i9-1)*dsize(9)

        call ftgcle(iunit,numcol,row,felem,nelem,ninc,
     &  nultyp,nulval,array(i1),flgval(i1),anyf,status)
        if (status .gt. 0)return
        if (anyf)anynul=.true.
        i1=i1+nelem

20              continue
30             continue
40            continue
50           continue
60          continue
70         continue
80        continue
90       continue
100     continue
        end

      SUBROUTINE slMAPZ (RM, DM, AMPRMS, RA, DA)
*+
*     - - - - - - -
*      M A P Z
*     - - - - - - -
*
*  Quick mean to apparent place:  transform a star RA,Dec from
*  mean place to geocentric apparent place, given the
*  star-independent parameters, and assuming zero parallax
*  and proper motion.
*
*  Use of this routine is appropriate when efficiency is important
*  and where many star positions, all with parallax and proper
*  motion either zero or already allowed for, and all referred to
*  the same equator and equinox, are to be transformed for one
*  epoch.  The star-independent parameters can be obtained by
*  calling the slMAPA routine.
*
*  The corresponding routine for the case of non-zero parallax
*  and proper motion is slMAPQ.
*
*  The reference frames and timescales used are post IAU 1976.
*
*  Given:
*     RM,DM    d      mean RA,Dec (rad)
*     AMPRMS   d(21)  star-independent mean-to-apparent parameters:
*
*       (1-4)    not used
*       (5-7)    heliocentric direction of the Earth (unit vector)
*       (8)      (grav rad Sun)*2/(Sun-Earth distance)
*       (9-11)   ABV: barycentric Earth velocity in units of c
*       (12)     sqrt(1-v**2) where v=modulus(ABV)
*       (13-21)  precession/nutation (3,3) matrix
*
*  Returned:
*     RA,DA    d      apparent RA,Dec (rad)
*
*  References:
*     1984 Astronomical Almanac, pp B39-B41.
*     (also Lederle & Schwan, Astron. Astrophys. 134,
*      1-6, 1984)
*
*  Notes:
*
*  1)  The vectors AMPRMS(2-4) and AMPRMS(5-7) are referred to the
*      mean equinox and equator of epoch EQ.
*
*  2)  Strictly speaking, the routine is not valid for solar-system
*      sources, though the error will usually be extremely small.
*      However, to prevent gross errors in the case where the
*      position of the Sun is specified, the gravitational
*      deflection term is restrained within about 920 arcsec of the
*      centre of the Sun's disc.  The term has a maximum value of
*      about 1.85 arcsec at this radius, and decreases to zero as
*      the centre of the disc is approached.
*
*  Called:  slDS2C, slDVDV, slDMXV, slDC2S, slDA2P
*
*  P.T.Wallace   Starlink   18 March 1999
*
*  Copyright (C) 1999 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION RM,DM,AMPRMS(21),RA,DA

      INTEGER I

      DOUBLE PRECISION GR2E,AB1,EHN(3),ABV(3),
     :                 P(3),PDE,PDEP1,W,P1(3),P1DV,
     :                 P1DVP1,P2(3),P3(3)

      DOUBLE PRECISION slDVDV,slDA2P




*  Unpack scalar and vector parameters
      GR2E = AMPRMS(8)
      AB1 = AMPRMS(12)
      DO I=1,3
         EHN(I) = AMPRMS(I+4)
         ABV(I) = AMPRMS(I+8)
      END DO

*  Spherical to x,y,z
      CALL slDS2C(RM,DM,P)

*  Light deflection
      PDE = slDVDV(P,EHN)
      PDEP1 = PDE+1D0
      W = GR2E/MAX(PDEP1,1D-5)
      DO I=1,3
         P1(I) = P(I)+W*(EHN(I)-PDE*P(I))
      END DO

*  Aberration
      P1DV = slDVDV(P1,ABV)
      P1DVP1 = P1DV+1D0
      W = 1D0+P1DV/(AB1+1D0)
      DO I=1,3
         P2(I) = (AB1*P1(I)+W*ABV(I))/P1DVP1
      END DO

*  Precession and nutation
      CALL slDMXV(AMPRMS(13),P2,P3)

*  Geocentric apparent RA,Dec
      CALL slDC2S(P3,RA,DA)
      RA = slDA2P(RA)

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGGETC (TPID,CUSR)
C
      CHARACTER*(*) TPID,CUSR
C
      DIMENSION FURA(1)
C
C The routine AGGETC is used to get the character strings represented
C by the values of certain individual AUTOGRAPH parameters.  TPID is a
C parameter identifier (from the caller).  CUSR is a character string
C (returned to the caller).
C
C See what kind of parameter is being gotten.
C
      CALL AGCTCS (TPID,ITCS)
C
C If the parameter is not intrinsically of type character, log an error.
C
      IF (ITCS.EQ.0) GO TO 901
C
C Otherwise, get the integer value of the parameter and use that to get
C the desired character string.
C
      CALL AGGETP (TPID,FURA,1)
      CALL AGGTCH (IFIX(FURA(1)),CUSR,LNCS)
C
C Done.
C
      RETURN
C
C Error exit.
C
  901 CALL AGPPID (TPID)
      CALL SETER ('AGGETC - PARAMETER TO GET IS NOT INTRINSICALLY OF TYP
     +E CHARACTER',2,2)
C
      END

C--------------------------------------------------------------------------
        subroutine ftikyj(ounit,keywrd,intval,comm,status)

C       insert an integer keyword into the header at the current position
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       intval  i  keyword value 
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, March 1993

        character*(*) keywrd,comm
        integer ounit,status,intval

        character value*20,key*8,com*47
        character*80 record
        integer nkeys,keypos

        if (status .gt. 0)return

C       convert integer to character string and construct the full record
        call fti2c(intval,value,status)
        key=keywrd
        com=comm
        record=key//'= '//value//' / '//com

        call ftghps(ounit,nkeys,keypos,status)
        call ftirec(ounit,keypos,record,status)
        end

      subroutine dsdump (form)
      integer form
      integer mem( 60000)
      common/cdsmem/mem
      integer p, t, q
      t = 2
      call remark (27H** DYNAMIC STORAGE DUMP **.)
      call putint (1, 5, 2)
      call putch (32, 2)
      call putint (2 + 1, 0, 2)
      call remark (14H words in use.)
      p = mem (t + 1)
23000 if (.not.(p .ne. 0))goto 23001
      call putint (p, 5, 2)
      call putch (32, 2)
      call putint (mem (p + 0), 0, 2)
      call remark (17H words available.)
      q = p + mem (p + 0)
23002 if (.not.(q .ne. mem (p + 1) .and. q .lt. mem (1)))goto 23003
      call dsdbiu (q, form)
      goto 23002
23003 continue
      p = mem (p + 1)
      goto 23000
23001 continue
      call remark (15H** END DUMP **.)
      return
      end

c function pchisq.f
c
c source
c   Bevington, pages 192-193.
c
c purpose
c   evaluate probability for exceeding chi square
c
c usage
c   result = pchisq (chisqr, nfree)
c
c description of parameters
c   chisqr - comparison value of reduced chi square
c   nfree  - number of degrees of freedom
c
c subroutines and function subprograms required
c   gamma (x)
c      calculates gamma function for integers and half-integers
c
c comments
c   calculation is approximate for nfree odd and
c      chi square greater than 50
c
	function pchisq (chisqr,nfree)
	double precision z,term,sum
11	if (nfree) 12,12,14
12	pchisq=0.
	goto 60
14	free=nfree
	z=chisqr*free/2.
	neven=2*(nfree/2)
	if (nfree-neven) 21,21,41
c
c number of degrees of freedom is even
c
21	imax=nfree/2
	term=1.
	sum=0.
31	do 34 i=1,imax
	fi=i
	sum=sum+term
34	term=term*z/fi
35	pchisq=sum*dexp(z)
	goto 60
c
c number of degrees of freedom is odd
c
41	if (z-25) 44,44,42
42	z=chisqr*(free-1.)/2.
	goto 21
44	pwr=free/2.
	term=1.
	sum=term/pwr
51	do 56 i=1,1000
	fi=i
	term=-term*z/fi
	sum=sum+term/(pwr+fi)
55	if (dabs(term/sum)-0.00001) 57,57,56
56	continue
57	pchisq=1.-(z**pwr)*sum/gamma(pwr)
60	return
	end

      DOUBLE PRECISION FUNCTION slEPB (DATE)
*+
*     - - - -
*      E P B
*     - - - -
*
*  Conversion of Modified Julian Date to Besselian Epoch
*  (double precision)
*
*  Given:
*     DATE     dp       Modified Julian Date (JD - 2400000.5)
*
*  The result is the Besselian Epoch.
*
*  Reference:
*     Lieske,J.H., 1979. Astron.Astrophys.,73,282.
*
*  P.T.Wallace   Starlink   February 1984
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION DATE


      slEPB = 1900D0 + (DATE-15019.81352D0)/365.242198781D0

      END

      subroutine cubspl ( tau, c, n, ibcbeg, ibcend )
c  from  * a practical guide to splines *  by c. de boor
c     ************************	input  ***************************
c     n = number of data points. assumed to be .ge. 2.
c     (tau(i), c(1,i), i=1,...,n) = abscissae and ordinates of the
c	 data points. tau is assumed to be strictly increasing.
c     ibcbeg, ibcend = boundary condition indicators, and
c     c(2,1), c(2,n) = boundary condition information. specifically,
c	 ibcbeg = 0  means no boundary condition at tau(1) is given.
c	    in this case, the not-a-knot condition is used, i.e. the
c	    jump in the third derivative across tau(2) is forced to
c	    zero, thus the first and the second cubic polynomial pieces
c	    are made to coincide.)
c	 ibcbeg = 1  means that the slope at tau(1) is made to equal
c	    c(2,1), supplied by input.
c	 ibcbeg = 2  means that the second derivative at tau(1) is
c	    made to equal c(2,1), supplied by input.
c	 ibcend = 0, 1, or 2 has analogous meaning concerning the
c	    boundary condition at tau(n), with the additional infor-
c	    mation taken from c(2,n).
c     ***********************  output  **************************
c     c(j,i), j=1,...,4; i=1,...,l (= n-1) = the polynomial coefficients
c	 of the cubic interpolating spline with interior knots (or
c	 joints) tau(2), ..., tau(n-1). precisely, in the interval
c	 interval (tau(i), tau(i+1)), the spline f is given by
c	    f(x) = c(1,i)+h*(c(2,i)+h*(c(3,i)+h*c(4,i)/3.)/2.)
c	 where h = x - tau(i). the function program *ppvalu* may be
c	 used to evaluate f or its derivatives from tau,c, l = n-1,
c	 and k=4.
      integer ibcbeg,ibcend,n,	 i,j,l,m
      real c(4,n),tau(n),   divdf1,divdf3,dtau,g
c****** a tridiagonal linear system for the unknown slopes s(i) of
c  f  at tau(i), i=1,...,n, is generated and then solved by gauss elim-
c  ination, with s(i) ending up in c(2,i), all i.
c     c(3,.) and c(4,.) are used initially for temporary storage.
      l = n-1
compute first differences of tau sequence and store in c(3,.). also,
compute first divided difference of data and store in c(4,.).
      do 10 m=2,n
	 c(3,m) = tau(m) - tau(m-1)
   10	 c(4,m) = (c(1,m) - c(1,m-1))/c(3,m)
construct first equation from the boundary condition, of the form
c	      c(4,1)*s(1) + c(3,1)*s(2) = c(2,1)
      if (ibcbeg-1)			11,15,16
   11 if (n .gt. 2)			go to 12
c     no condition at left end and n = 2.
      c(4,1) = 1.
      c(3,1) = 1.
      c(2,1) = 2.*c(4,2)
					go to 25
c     not-a-knot condition at left end and n .gt. 2.
   12 c(4,1) = c(3,3)
      c(3,1) = c(3,2) + c(3,3)
      c(2,1) =((c(3,2)+2.*c(3,1))*c(4,2)*c(3,3)+c(3,2)**2*c(4,3))/c(3,1)
					go to 19
c     slope prescribed at left end.
   15 c(4,1) = 1.
      c(3,1) = 0.
					go to 18
c     second derivative prescribed at left end.
   16 c(4,1) = 2.
      c(3,1) = 1.
      c(2,1) = 3.*c(4,2) - c(3,2)/2.*c(2,1)
   18 if(n .eq. 2)			go to 25
c  if there are interior knots, generate the corresp. equations and car-
c  ry out the forward pass of gauss elimination, after which the m-th
c  equation reads    c(4,m)*s(m) + c(3,m)*s(m+1) = c(2,m).
   19 do 20 m=2,l
	 g = -c(3,m+1)/c(4,m-1)
	 c(2,m) = g*c(2,m-1) + 3.*(c(3,m)*c(4,m+1)+c(3,m+1)*c(4,m))
   20	 c(4,m) = g*c(3,m-1) + 2.*(c(3,m) + c(3,m+1))
construct last equation from the second boundary condition, of the form
c	    (-g*c(4,n-1))*s(n-1) + c(4,n)*s(n) = c(2,n)
c     if slope is prescribed at right end, one can go directly to back-
c     substitution, since c array happens to be set up just right for it
c     at this point.
      if (ibcend-1)			21,30,24
   21 if (n .eq. 3 .and. ibcbeg .eq. 0) go to 22
c     not-a-knot and n .ge. 3, and either n.gt.3 or  also not-a-knot at
c     left end point.
      g = c(3,n-1) + c(3,n)
      c(2,n) = ((c(3,n)+2.*g)*c(4,n)*c(3,n-1)
     *		  + c(3,n)**2*(c(1,n-1)-c(1,n-2))/c(3,n-1))/g
      g = -g/c(4,n-1)
      c(4,n) = c(3,n-1)
					go to 29
c     either (n=3 and not-a-knot also at left) or (n=2 and not not-a-
c     knot at left end point).
   22 c(2,n) = 2.*c(4,n)
      c(4,n) = 1.
					go to 28
c     second derivative prescribed at right endpoint.
   24 c(2,n) = 3.*c(4,n) + c(3,n)/2.*c(2,n)
      c(4,n) = 2.
					go to 28
   25 if (ibcend-1)			26,30,24
   26 if (ibcbeg .gt. 0)		go to 22
c     not-a-knot at right endpoint and at left endpoint and n = 2.
      c(2,n) = c(4,n)
					go to 30
   28 g = -1./c(4,n-1)
complete forward pass of gauss elimination.
   29 c(4,n) = g*c(3,n-1) + c(4,n)
      c(2,n) = (g*c(2,n-1) + c(2,n))/c(4,n)
carry out back substitution
   30 j = l
   40	 c(2,j) = (c(2,j) - c(3,j)*c(2,j+1))/c(4,j)
	 j = j - 1
	 if (j .gt. 0)			go to 40
c****** generate cubic coefficients in each interval, i.e., the deriv.s
c  at its left endpoint, from value and slope at its endpoints.
      do 50 i=2,n
	 dtau = c(3,i)
	 divdf1 = (c(1,i) - c(1,i-1))/dtau
	 divdf3 = c(2,i-1) + c(2,i) - 2.*divdf1
	 c(3,i-1) = 2.*(divdf1 - c(2,i-1) - divdf3)/dtau
   50	 c(4,i-1) = (divdf3/dtau)*(6./dtau)
					return
      end

include	defs

# maksub --- make substitution string in sub

   integer function maksub (arg, from, delim, sub)
   character arg (MAXARG), delim, sub (MAXPAT)
   integer from

   character esc, type

   integer i, j, junk
   integer addset

   j = 1
   for (i = from; arg (i) != delim & arg (i) != EOS; i = i + 1)
      if (arg (i) == AND) {
	 junk = addset (DITTO, sub, j, MAXPAT)
	 junk = addset (0, sub, j, MAXPAT)
	 }
      else if (arg (i) == ESCAPE & type (arg (i + 1)) == DIGIT) {
	 i = i + 1
	 junk = addset (DITTO, sub, j, MAXPAT)
	 junk = addset (arg (i) - DIG0, sub, j, MAXPAT)
	 }
      else
	 junk = addset (esc (arg, i), sub, j, MAXPAT)
   if (arg (i) != delim)   # missing delimiter
      maksub = ERR
   else if (addset (EOS, sub, j, MAXPAT) == NO)   # no room
      maksub = ERR
   else
      maksub = i
   return
   end

C----------------------------------------------------------------------
        subroutine ftsrnn(value)

C       set a 32-bit pattern equal to an IEEE Not-a-Number value
C       A NaN has all the exponent bits=1, and the fractional part
C       not=0.  
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer value

C       there are many NaN values;  choose a simple one in which all bits=1
        value=-1
        end

      subroutine swcode (lab)
      integer lab
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer tok (100)
      integer labgen, gnbtok
      lab = labgen (2)
      swvnum = swvnum + 1
      swvlev = swvlev + 1
      if (.not.(swvlev .gt. 10))goto 23000
      call baderr (27Hswitches nested too deeply.)
23000 continue
      swvstk(swvlev) = swvnum
      if (.not.(swlast + 3 .gt. 1000))goto 23002
      call baderr (22Hswitch table overflow.)
23002 continue
      swstak (swlast) = swtop
      swstak (swlast + 1) = 0
      swstak (swlast + 2) = 0
      swtop = swlast
      swlast = swlast + 3
      xfer = 0
      call outtab
      call swvar (swvnum)
      call outch (61)
      call balpar
      call outdwe
      call outgo (lab)
      call indent (1)
      xfer = 1
23004 if (.not.(gnbtok (tok, 100) .eq. 10))goto 23005
      goto 23004
23005 continue
      if (.not.(tok (1) .ne. 123))goto 23006
      call synerr (39Hmissing left brace in switch statement.)
      call pbstr (tok)
23006 continue
      return
      end
c     logic0  logical_column

include	defs

# enter --- place a symbol in the symbol table, updating if already present

   subroutine enter (symbol, info, st)
   character symbol (ARB)
   integer info (ARB)
   pointer st

   DS_COMMON

   integer i, nodsiz, j
   integer stlu, length

   pointer node, pred
   pointer dsget

   nodsiz = Mem (st)

   if (stlu (symbol, node, pred, st) == NO) {
      node = dsget (1 + nodsiz + length (symbol) + 1)
      Mem (node + ST_LINK) = LAMBDA
      Mem (pred + ST_LINK) = node
      i = 1
      j = node + ST_DATA + nodsiz
      while (symbol (i) != EOS) {
	 Mem (j) = symbol (i)
	 i = i + 1
	 j = j + 1
	 }
      Mem (j) = EOS
      }

   for (i = 1; i <= nodsiz; i = i + 1) {
      j = node + ST_DATA + i - 1
      Mem (j) = info (i)
      }

   return
   end

C--------------------------------------------------------------------------
        subroutine ftpsvc(keyrec,value,comm,status)

C       parse the header record to find value and comment strings

C       keyrec  c  80 column header record
C       OUTPUT PARAMETERS:
C       value   c  output keyword value string
C       comm    c  output keyword comment string
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*80 keyrec,keytmp
        character*(*) value,comm
        character*80 ctemp
        integer status,j,c1

        if (status .gt. 0)return

        if (keyrec(1:8) .eq.'COMMENT ' .or. keyrec(1:8).eq.'HISTORY '
     &  .or. keyrec(1:8).eq.'END     ' .or. keyrec(1:8).eq.'        ')
     &  then
C           this is a COMMENT or HISTORY record, with no value
            value=' '
            comm=keyrec(9:80)
        else if (keyrec(9:10) .eq. '= ')then
C           this keyword has a value field; now find the first character:
            do 10 j=10,80
                if (keyrec(j:j) .ne. ' ')then
                        c1=j
                        go to 15
                end if
10          continue
C           error: value is blank
            status=204
            call ftpmsg('The keyword '//keyrec(1:8)//
     &      ' has no value string after the equal sign:')
            call ftpmsg(keyrec)
            return

15          if (keyrec(c1:c1) .eq. '''')then
C               This is a string value.
C               Work forward to find a single quote.  Two single quotes
C               in succession is to be interpreted as a literal single
C               quote character as part of the character string, not as
C               the end of the character string.  Everything to the right 
C               of the closing quote is assumed to be the comment.
C               First, copy input to temporary string variable
                keytmp=keyrec
                do 20 j=c1+1,80
                    if (keytmp(j:j) .eq. '''')then
                        if (j.lt.80 .and. keytmp(j+1:j+1).eq.'''')then
C                               found 2 successive quote characters; this is 
C                               interpreted as a literal quote character; remove
C                               one of the quotes from the string, and continue
C                               searching for the closing quote character:
                                keytmp(j+1:80)=keytmp(j+2:80)
                        else
                                value=keytmp(c1:j)
                                if (j .lt. 80)then
                                        ctemp=keytmp(j+1:80)
                                else
                                        ctemp=' '
                                end if
                                go to 30
                        end if
                    end if
20              continue
C               error: no closing quote character
                status=205
            call ftpmsg('The following Keyword value string has '//
     &            'no closing quote:')
            call ftpmsg(keyrec)
                return
            else
C               This is either an integer, floating point, or logical value.
C               Extract the first token as the value; remainder = comment
                do 25 j=c1,80
                    if (keyrec(j:j) .eq. ' ')then
                        value=keyrec(c1:j-1)
                        ctemp=keyrec(j+1:80)
                        go to 30
                    end if
25              continue
C               the first token went all the way to column 80:
                value=keyrec(c1:80)
                ctemp=' '
            end if

30          comm=' '
C           look for first character in the comment string
            do 40 j=1,78
                if (ctemp(j:j).ne.' ')then
                        if (ctemp(j:j).eq.'/')then
C                            ignore first space, if it exists
                             if (ctemp(j+1:j+1) .eq. ' ')then
                                comm=ctemp(j+2:80)
                             else
                                comm=ctemp(j+1:80)
                             end if
                        else
                                comm=ctemp(j:80)
                        end if
                        go to 50
                end if
40          continue
        else
C           illegal keyword record format; must have '= ' in columns 9-10
C           status=210
C           Modified July 1993:  this is actually not an error.  The
C           keyword should simply be interpreted as a comment.
            value=' '
            comm=keyrec(9:80)
        end if
50      continue
        end

#-h-  finit			  432  local   12/01/80  15:54:07
# finit - initialize for each input file
   include  defs

   subroutine finit

   include COMMON_BLOCKS

   outp = 0  # output character pointer
   level = 1  # file control
   linect (1) = 0
   sbp	= 1
   fnamp = 2
   fnames (1) = EOS
   bp = PBPOINT
   buf (bp) = EOS    # to force a read on next call to 'ngetch'
   fordep = 0  # for stack
   fcname (1) = EOS # current function name
   swtop = 0  # switch stack
   swlast = 1
   swvnum = 0
   swvlev = 0
   return
   end

      SUBROUTINE slPRCE (SYSTEM, EP0, EP1, RA, DC)
*+
*     - - - - - - -
*      P R C E
*     - - - - - - -
*
*  Precession - either FK4 (Bessel-Newcomb, pre IAU 1976) or
*  FK5 (Fricke, post IAU 1976) as required.
*
*  Given:
*     SYSTEM     char   precession to be applied: 'FK4' or 'FK5'
*     EP0,EP1    dp     starting and ending epoch
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP0
*
*  Returned:
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP1
*
*  Called:    slDA2P, slPRBN, slPREC, slDS2C,
*             slDMXV, slDC2S
*
*  Notes:
*
*     1)  Lowercase characters in SYSTEM are acceptable.
*
*     2)  The epochs are Besselian if SYSTEM='FK4' and Julian if 'FK5'.
*         For example, to precess coordinates in the old system from
*         equinox 1900.0 to 1950.0 the call would be:
*             CALL slPRCE ('FK4', 1900D0, 1950D0, RA, DC)
*
*     3)  This routine will NOT correctly convert between the old and
*         the new systems - for example conversion from B1950 to J2000.
*         For these purposes see slFK45, slFK54, slF45Z and
*         slF54Z.
*
*     4)  If an invalid SYSTEM is supplied, values of -99D0,-99D0 will
*         be returned for both RA and DC.
*
*  P.T.Wallace   Starlink   20 April 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER SYSTEM*(*)
      DOUBLE PRECISION EP0,EP1,RA,DC

      DOUBLE PRECISION PM(3,3),V1(3),V2(3)
      CHARACTER SYSUC*3

      DOUBLE PRECISION slDA2P




*  Convert to uppercase and validate SYSTEM
      SYSUC=SYSTEM
      IF (SYSUC(1:1).EQ.'f') SYSUC(1:1)='F'
      IF (SYSUC(2:2).EQ.'k') SYSUC(2:2)='K'
      IF (SYSUC.NE.'FK4'.AND.SYSUC.NE.'FK5') THEN
         RA=-99D0
         DC=-99D0
      ELSE

*     Generate appropriate precession matrix
         IF (SYSUC.EQ.'FK4') THEN
            CALL slPRBN(EP0,EP1,PM)
         ELSE
            CALL slPREC(EP0,EP1,PM)
         END IF

*     Convert RA,Dec to x,y,z
         CALL slDS2C(RA,DC,V1)

*     Precess
         CALL slDMXV(PM,V1,V2)

*     Back to RA,Dec
         CALL slDC2S(V2,RA,DC)
         RA=slDA2P(RA)

      END IF

      END

      SUBROUTINE slCDTF (NDP, DAYS, SIGN, IHMSF)
*+
*     - - - - - -
*      C D T F
*     - - - - - -
*
*  Convert an interval in days into hours, minutes, seconds
*
*  (single precision)
*
*  Given:
*     NDP       int      number of decimal places of seconds
*     DAYS      real     interval in days
*
*  Returned:
*     SIGN      char     '+' or '-'
*     IHMSF     int(4)   hours, minutes, seconds, fraction
*
*  Notes:
*
*     1)  NDP less than zero is interpreted as zero.
*
*     2)  The largest useful value for NDP is determined by the size of
*         DAYS, the format of REAL floating-point numbers on the target
*         machine, and the risk of overflowing IHMSF(4).  On some
*         architectures, for DAYS up to 1.0, the available floating-
*         point precision corresponds roughly to NDP=3.  This is well
*         below the ultimate limit of NDP=9 set by the capacity of a
*         typical 32-bit IHMSF(4).
*
*     3)  The absolute value of DAYS may exceed 1.0.  In cases where it
*         does not, it is up to the caller to test for and handle the
*         case where DAYS is very nearly 1.0 and rounds up to 24 hours,
*         by testing for IHMSF(1)=24 and setting IHMSF(1-4) to zero.
*
*  Called:  slDDTF
*
*  Last revision:   26 December 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER NDP
      REAL DAYS
      CHARACTER SIGN*(*)
      INTEGER IHMSF(4)



*  Call double precision version
      CALL slDDTF(NDP,DBLE(DAYS),SIGN,IHMSF)

      END

chapter x. example 3. construction and evaluation of the pp-representat-
c		      ion of a b-spline.
c  from  * a practical guide to splines *  by c. de boor
calls bsplpp(bsplvb),ppvalu(interv)
c
      integer ia,l
      real bcoef(7),break(5),coef(4,4),scrtch(4,4),t(11),value,x
      real ppvalu
c		 set knot sequence  t  and b-coeffs for  b(4,4,t)  ....
      data t / 4*0.,1.,3.,4.,4*6. /, bcoef / 3*0.,1.,3*0. /
c			   construct pp-representation	....
      call bsplpp ( t, bcoef, 7, 4, scrtch, break, coef, l )
c
c     as a check, evaluate  b(4,4,t)  from its pp-repr. on a fine mesh.
c	      the values should agree with (some of) those generated in
c			 example 2 .
      do 20 ia=1,40
	 x = float(ia)*.2 - 1.
	 value = ppvalu ( break, coef, l, 4, x, 0 )
   20	 print 620, x, value
  620 format(f10.1,f20.8)
					stop
      end

C----------------------------------------------------------------------
        subroutine ftptbb(iunit,frow,fchar,nchars,value,status)

C       write a consecutive string of bytes to an ascii or binary
C       table. This will span multiple rows of the table if NCHARS+FCHAR is
C       greater than the length of a row.

C       iunit   i  fortran unit number
C       frow    i  starting row number (1st row = 1)
C       fchar   i  starting byte in the row to write (1st character=1)
C       nchars  i  number of bytes to write (can span multiple rows)
C       value   i  array of bytes to write
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Dec 1991

        integer iunit,frow,fchar,nchars,status
        integer value(*)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,bstart
        
        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       check for errors
        if (nchars .le. 0)then
C               zero or negative number of character requested
                return
        else if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                return
        else if (fchar .lt. 1)then
C               error: illegal starting character
                status=308
                return
        end if
        
C       move the i/o pointer to the start of the sequence of characters
        bstart=dtstrt(ibuff)+(frow-1)*rowlen(ibuff)+fchar-1
        call ftmbyt(iunit,bstart,.true.,status)

C       put the string of bytes
        call ftpbyt(iunit,nchars,value,status)
        end

include	defs

# dsinit --- initialize dynamic storage space to w words

   subroutine dsinit (w)
   integer w

   DS_COMMON

   pointer t

   if (w < 2 * DS_OHEAD + 2)
      call error ("in dsinit: unreasonably small memory size.")

   # set up avail list:
   t = DS_AVAIL
   Mem (t + DS_SIZE) = 0
   Mem (t + DS_LINK) = DS_AVAIL + DS_OHEAD

   # set up first block of space:
   t = DS_AVAIL + DS_OHEAD
   Mem (t + DS_SIZE) = w - DS_OHEAD - 1     # -1 for MEMEND
   Mem (t + DS_LINK) = LAMBDA

   # record end of memory:
   Mem (DS_MEMEND) = w

   return
   end

include	defs

# termin - pick up name of input channel to users teletype

   subroutine termin (name)
   character name (ARB)

   string tname TERMINAL_IN

   call scopy (tname, 1, name, 1)
   return
   end

      subroutine setupq ( x, dx, y, npoint, v, qty )
c  from  * a practical guide to splines *  by c. de boor
c  to be called in  s m o o t h
c  put	delx = x(.+1) - x(.)  into  v(.,4),
c  put	the three bands of  q-transp*d	into  v(.,1-3), and
c  put the three bands of  (d*q)-transp*(d*q)  at and above the diagonal
c     into  v(.,5-7) .
c     here,  q is  the tridiagonal matrix of order (npoint-2,npoint)
c  with general row  1/delx(i) , -1/delx(i) - 1/delx(i+1) , 1/delx(i+1)
c  and	 d  is the diagonal matrix  with general row  dx(i) .
      integer npoint,	i,npm1
      real dx(npoint),qty(npoint),v(npoint,7),x(npoint),y(npoint),
     *							  diff,   prev
      npm1 = npoint - 1
      v(1,4) = x(2) - x(1)
      do 11 i=2,npm1
	 v(i,4) = x(i+1) - x(i)
	 v(i,1) = dx(i-1)/v(i-1,4)
	 v(i,2) = - dx(i)/v(i,4) - dx(i)/v(i-1,4)
   11	 v(i,3) = dx(i+1)/v(i,4)
      v(npoint,1) = 0.
      do 12 i=2,npm1
   12	 v(i,5) = v(i,1)**2 + v(i,2)**2 + v(i,3)**2
      if (npm1 .lt. 3)			go to 14
      do 13 i=3,npm1
   13	 v(i-1,6) = v(i-1,2)*v(i,1) + v(i-1,3)*v(i,2)
   14 v(npm1,6) = 0.
      if (npm1 .lt. 4)			go to 16
      do 15 i=4,npm1
   15	 v(i-2,7) = v(i-2,3)*v(i,1)
   16 v(npm1-1,7) = 0.
      v(npm1,7) = 0.
construct  q-transp. * y  in  qty.
      prev = (y(2) - y(1))/v(1,4)
      do 21 i=2,npm1
	 diff = (y(i+1)-y(i))/v(i,4)
	 qty(i) = diff - prev
   21	 prev = diff
					return
      end

#-h-  untils			  397  local   12/01/80  15:55:11
# untils - generate code for until or end of repeat
   include  defs

   subroutine untils (lab, token)
   integer lab, token

   include COMMON_BLOCKS

   character ptoken (MAXTOK)

   integer junk
   integer lex

   xfer = NO
   call outnum (lab)
   if (token == LEXUNTIL) {
      junk = lex (ptoken)
      call ifgo (lab - 1)
      }
   else
      call outgo (lab - 1)
   call indent (-1)
   call outcon (lab + 1)
   return
   end

      DOUBLE PRECISION FUNCTION slZD (HA, DEC, PHI)
*+
*     - - -
*      Z D
*     - - -
*
*  HA, Dec to Zenith Distance (double precision)
*
*  Given:
*     HA     d     Hour Angle in radians
*     DEC    d     declination in radians
*     PHI    d     observatory latitude in radians
*
*  The result is in the range 0 to pi.
*
*  Notes:
*
*  1)  The latitude must be geodetic.  In critical applications,
*      corrections for polar motion should be applied.
*
*  2)  In some applications it will be important to specify the
*      correct type of hour angle and declination in order to
*      produce the required type of zenith distance.  In particular,
*      it may be important to distinguish between the zenith distance
*      as affected by refraction, which would require the "observed"
*      HA,Dec, and the zenith distance in vacuo, which would require
*      the "topocentric" HA,Dec.  If the effects of diurnal aberration
*      can be neglected, the "apparent" HA,Dec may be used instead of
*      the topocentric HA,Dec.
*
*  3)  No range checking of arguments is done.
*
*  4)  In applications which involve many zenith distance calculations,
*      rather than calling the present routine it will be more efficient
*      to use inline code, having previously computed fixed terms such
*      as sine and cosine of latitude, and perhaps sine and cosine of
*      declination.
*
*  P.T.Wallace   Starlink   3 April 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION HA,DEC,PHI

      DOUBLE PRECISION SH,CH,SD,CD,SP,CP,X,Y,Z


      SH=SIN(HA)
      CH=COS(HA)
      SD=SIN(DEC)
      CD=COS(DEC)
      SP=SIN(PHI)
      CP=COS(PHI)
      X=CH*CD*SP-SD*CP
      Y=SH*CD
      Z=CH*CD*CP+SD*SP
      slZD=ATAN2(SQRT(X*X+Y*Y),Z)

      END

      subroutine bndsol (mode,g,mdg,nb,ip,ir,x,n,rnorm)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   sequential solution of a banded least squares problem..
c	   solution phase.   for the accumulation phase use bndacc.
c
c     mode = 1	   solve r*x=y	 where r and y are in the g( ) array
c		   and x will be stored in the x( ) array.
c	     2	   solve (r**t)*x=y   where r is in g( ),
c		   y is initially in x( ), and x replaces y in x( ),
c	     3	   solve r*x=y	 where r is in g( ).
c		   y is initially in x( ), and x replaces y in x( ).
c
c     the second subscript of g( ) must be dimensioned at least
c     nb+1 in the calling program.
      dimension g(mdg,1),x(n)
      zero=0.
c
      rnorm=zero
      go to (10,90,50), mode
c				    ********************* mode = 1
c				    algc step 26
   10	   do 20 j=1,n
   20	   x(j)=g(j,nb+1)
      rsq=zero
      np1=n+1
      irm1=ir-1
      if (np1.gt.irm1) go to 40
	   do 30 j=np1,irm1
   30	   rsq=rsq+g(j,nb+1)**2
      rnorm=sqrt(rsq)
   40 continue
c				    ********************* mode = 3
c				    alg. step 27
   50	   do 80 ii=1,n
	   i=n+1-ii
c				    alg. step 28
	   s=zero
	   l=max0(0,i-ip)
c				    alg. step 29
	   if (i.eq.n) go to 70
c				    alg. step 30
	   ie=min0(n+1-i,nb)
		do 60 j=2,ie
		jg=j+l
		ix=i-1+j
   60		s=s+g(i,jg)*x(ix)
c				    alg. step 31
   70	   if (g(i,l+1)) 80,130,80
   80	   x(i)=(x(i)-s)/g(i,l+1)
c				    alg. step 32
      return
c				    ********************* mode = 2
   90	   do 120 j=1,n
	   s=zero
	   if (j.eq.1) go to 110
	   i1=max0(1,j-nb+1)
	   i2=j-1
		do 100 i=i1,i2
		l=j-i+1+max0(0,i-ip)
  100		s=s+x(i)*g(i,l)
  110	   l=max0(0,j-ip)
	   if (g(j,l+1)) 120,130,120
  120	   x(j)=(x(j)-s)/g(j,l+1)
      return
c
  130 write (6,140) mode,i,j,l
      stop
  140 format (30h0zero diagonal term in bndsol.,12h mode,i,j,l=,4i6)
      end

#-h-  swvar			  157  local   12/01/80  15:55:08
# swvar - output switch variable SWnnnn, where nnnn = lab
# (modified aug82 dct to permit declaration of switch variable)

   include  defs

   subroutine swvar (lab)
   integer lab, i, labnum, ndigits

   call outch (LETS)
   call outch (LETW)

   labnum = lab
   for (ndigits=0;  labnum > 0;  labnum=labnum/10)
    	ndigits = ndigits + 1
   for (i=3;  i <= 6 - ndigits;  i=i+1)
	call outch (DIG0)
   call outnum (lab)
   return
   end

C----------------------------------------------------------------------
        subroutine ftphpr(ounit,simple,bitpix,naxis,naxes,
     &                    pcount,gcount,extend,status)

C       write required primary header keywords
C
C       ounit   i  fortran output unit number
C       simple  l  does file conform to FITS standard?
C       bitpix  i  number of bits per data value
C       naxis   i  number of axes in the data array
C       naxes   i  array giving the length of each data axis
C       pcount  i  number of group parameters
C       gcount  i  number of random groups
C       extend  l  may extensions be present in the FITS file?
C       OUTPUT PARAMETERS:
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,bitpix,naxis,naxes(*),pcount,gcount,status,i,ibuff
        character comm*50,caxis*20,clen*3
        logical simple,extend

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

        if (chdu(ibuff) .eq. 1)then
            if (simple)then
                comm='file does conform to FITS standard'
            else
                comm='file does not conform to FITS standard'
            end if
            call ftpkyl(ounit,'SIMPLE',simple,comm,status)
        else  
            comm='IMAGE extension'
            call ftpkys(ounit,'XTENSION','IMAGE',comm,status)
        end if

C       test for legal value of bitpix
        call fttbit(bitpix,status)
        comm='number of bits per data pixel'
        call ftpkyj(ounit,'BITPIX',bitpix,comm,status)
        if (status .gt. 0)go to 900

        if (naxis .ge. 0 .and. naxis .le. 999)then
                comm='number of data axes'
                call ftpkyj(ounit,'NAXIS',naxis,comm,status)
        else
C               illegal value of naxis
                status=212
                write(caxis,1001)naxis
1001            format(i20)
                call ftpmsg('NAXIS ='//caxis//' in the call to FTPHPR '
     &          //'is illegal.')
                go to 900
        end if

        comm='length of data axis'
        do 10 i=1,naxis
                if (naxes(i) .ge. 0)then
                        write(comm(21:23),1000)i
1000                    format(i3)      
                        call ftpknj(ounit,'NAXIS',i,1,naxes(i),comm,
     &                              status)
                else
C                       illegal NAXISnnn keyword value
                        status=213
                        write(clen,1000)i
                        write(caxis,1001)naxes(i)
        call ftpmsg('In call to FTPHPR, axis '//clen//
     &  ' has illegal negative size: '//caxis)
                        go to 900
                end if
10      continue

        if (chdu(ibuff) .eq. 1)then
C               only write the EXTEND keyword to primary header if true
                if (extend)then
                        comm='FITS dataset may contain extensions'
                        call ftpkyl(ounit,'EXTEND',extend,comm,status)
                end if

C               write the PCOUNT and GCOUNT values if nonstandard
                if (pcount .gt. 0 .or. gcount .gt. 1)then
                    comm='random group records are present'
                    call ftpkyl(ounit,'GROUPS',.true.,comm,status)
                    comm='number of random group parameters'
                    call ftpkyj(ounit,'PCOUNT',pcount,comm,status)  
                    comm='number of random groups'
                    call ftpkyj(ounit,'GCOUNT',gcount,comm,status)
                end if

                call ftpcom(ounit,'FITS (Flexible Image Transport '//
     & 'System) format defined in Astronomy and',status)
                call ftpcom(ounit,'Astrophysics Supplement Series '//
     & 'v44/p363, v44/p371, v73/p359, v73/p365.',status)
                call ftpcom(ounit,'Contact the NASA Science '//
     & 'Office of Standards and Technology for the',status)
                call ftpcom(ounit,'FITS Definition document '//
     & '#100 and other FITS information.',status)

        else 
                comm='number of random group parameters'
                call ftpkyj(ounit,'PCOUNT',pcount,comm,status)                
                comm='number of random groups'
                call ftpkyj(ounit,'GCOUNT',gcount,comm,status) 
        end if

900     continue
        end

C------------------------------------------------------------------------------
        subroutine ftwldp(xpix,ypix,xref,yref,xrefpix,yrefpix,
     &                    xinc,yinc,rot,type,xpos,ypos,status)

C       Fortran version of worldpos.c -- WCS Algorithms from Classic AIPS
C       Translated by James Kent Blackburn -- HEASARC/GSFC/NASA -- November 1994
C       routine to determine accurate position from pixel coordinates
C       does: -SIN, -TAN, -ARC, -NCP, -GLS, -MER, -AIT projections
C       returns   0 = good, 
C               501 = angle too large for projection;
C Input:
C dbl   xpix    x pixel number  (RA or long without rotation)
C dbl   ypiy    y pixel number  (dec or lat without rotation)
C dbl   xref    x reference coordinate value (deg)
C dbl   yref    y reference coordinate value (deg)
C dbl   xrefpix x reference pixel
C dbl   yrefpix y reference pixel
C dbl   xinc    x coordinate increment (deg)
C dbl   yinc    y coordinate increment (deg)
C dbl   rot     rotation (deg)  (from N through E)
C chr   type    projection type code e.g. "-SIN"
C Output:
C dbl    xpos   x (RA) coordinate (deg)
C dbl    ypos   y (dec) coordinate (deg)
C int   status  error status flag, zero 

        integer           status
        double precision  xpix,ypix,xref,yref,xrefpix,yrefpix
        double precision  xinc,yinc,rot,xpos,ypos
        character*(*)     type
        integer           error1,error4
        parameter         (error1=501)
        parameter         (error4=504)

        double precision  cosr,sinr,dx,dy,dz,temp
        double precision  sins,coss,dect,rat,dt,l,m,mg,da,dd,cos0,sin0
        double precision  dec0,ra0,decout,raout
        double precision  geo1,geo2,geo3
        double precision  cond2r
        parameter         (cond2r=1.745329252d-2)
        double precision  twopi,deps
        parameter         (twopi = 6.28318530717959)
        parameter         (deps = 1.0d-5)
        integer           i,itype
        character*4       ctypes(8)
        data ctypes/ '-SIN', '-TAN', '-ARC', '-NCP',
     &               '-GLS', '-MER', '-AIT', '-STG' /

        if (status .gt. 0) return
C   *** Offset from ref pixel
        dx = (xpix-xrefpix) * xinc
        dy = (ypix-yrefpix) * yinc
C   *** Take out rotation
        cosr = dcos(rot*cond2r)
        sinr = dsin(rot*cond2r)
        if (rot .ne. 0.0) then
          temp = dx * cosr - dy * sinr
          dy = dy * cosr + dx * sinr
          dx = temp
        end if
C   *** Find type of coordinate transformation (0 is linear)
        itype = 0
        do 10 i = 1, 8
          if (ctypes(i) .eq. type) itype = i
  10    continue
C   *** default, linear result for error return
        xpos = xref + dx
        ypos = yref + dy
C   *** Convert to radians
        ra0 = xref * cond2r
        dec0 = yref * cond2r
        l = dx * cond2r
        m = dy * cond2r
        sins = l*l + m*m
        decout = 0.0
        raout = 0.0
        cos0 = dcos(dec0)
        sin0 = dsin(dec0)
C   *** Process by case
        if (itype .eq. 0) then
C   *** LINEAR
          rat =  ra0 + l
          dect = dec0 + m
        else if (itype .eq. 1) then
C   *** SINE from '-SIN' type
          if (sins .gt. 1.0) then 
            status = error1
            goto 30
          end if
          coss = dsqrt(1.0 - sins)
          dt = sin0 * coss + cos0 * m
          if ((dt .gt. 1.0) .or. (dt .lt. -1.0)) then 
            status = error1
            goto 30
          end if
          dect = dasin(dt)
          rat = cos0 * coss - sin0 * m
          if ((rat .eq. 0.0) .and. (l .eq. 0.0)) then 
            status = error1
            goto 30
          end if
          rat = datan2 (l, rat) + ra0
        else if (itype .eq. 2) then
C   *** TANGENT from '-TAN' type
          if (sins .gt. 1.0) then 
            status = error1
            goto 30
          end if
          dect = cos0 - m * sin0
          if (dect .eq. 0.0) then 
            status = error1
            goto 30
          end if
          rat = ra0 + datan2(l, dect)
          dect = datan(dcos(rat-ra0) * (m * cos0 + sin0) / dect)
        else if (itype .eq. 3) then
C   *** Arc from '-ARC' type
          if (sins .ge. twopi * twopi / 4.0) then 
            status = error1
            goto 30
          end if
          sins = dsqrt(sins)
          coss = dcos(sins)
          if (sins .ne. 0.0) then
            sins = dsin(sins) / sins
          else
            sins = 1.0
          end if
          dt = m * cos0 * sins + sin0 * coss
          if ((dt .gt. 1.0) .or. (dt .lt. -1.0)) then 
            status = error1
            goto 30
          end if
          dect = dasin(dt)
          da = coss - dt * sin0
          dt = l * sins * cos0
          if ((da .eq. 0.0) .and. (dt .eq. 0.0)) then 
            status = error1
            goto 30
          end if
          rat = ra0 + datan2(dt, da)
        else if (itype .eq. 4) then
C   *** North Celestial Pole from '-NCP' type
          dect = cos0 - m * sin0
          if (dect .eq. 0.0) then 
            status = error1
            goto 30
          end if
          rat = ra0 + datan2(l, dect)
          dt = dcos(rat-ra0)
          if (dt .eq. 0.0) then 
            status = error1
            goto 30
          end if
          dect = dect / dt
          if ((dect .gt. 1.0) .or. (dect .lt. -1.0)) then 
            status = error1
            goto 30
          end if
          dect = dacos(dect)
          if (dec0 .lt. 0.0) dect = -dect
        else if (itype .eq. 5) then
C   *** Global Sinusoid from '-GLS' type
          dect = dec0 + m
          if (dabs(dect) .gt. twopi/4.0) then 
            status = error1
            goto 30
          end if
          coss = dcos(dect)
          if (dabs(l) .gt. twopi*coss/2.0) then 
            status = error1
            goto 30
          end if
          rat = ra0
          if (coss .gt. deps) rat = rat + l / coss
        else if (itype .eq. 6) then
C   *** Mercator from '-MER' type
          dt = yinc * cosr + xinc * sinr
          if (dt .eq. 0.0) dt = 1.0
          dy = (yref/2.0 + 45.0) * cond2r
          dx = dy + dt / 2.0 * cond2r
          dy = dlog(dtan(dy))
          dx = dlog(dtan(dx))
          geo2 = dt * cond2r / (dx - dy)
          geo3 = geo2 * dy
          geo1 = dcos(yref * cond2r)
          if (geo1 .le. 0.0) geo1 = 1.0
          rat = l / geo1 + ra0
          if (dabs(rat - ra0) .gt. twopi) then 
            status = error1
            goto 30
          end if
          dt = 0.0
          if (geo2 .ne. 0.0) dt = (m + geo3) / geo2
          dt = dexp(dt)
          dect = 2.0 * datan(dt) - twopi / 4.0
        else if (itype .eq. 7) then
C   *** Aitoff from '-AIT' type
          dt = yinc * cosr + xinc * sinr
          if (dt .eq. 0.0) dt = 1.0
          dt = dt * cond2r
          dy = yref * cond2r
          dx = dsin(dy+dt)/dsqrt((1.0+dcos(dy+dt))/2.0) -
     &         dsin(dy)/dsqrt((1.0+dcos(dy))/2.0)
          if (dx .eq. 0.0) dx = 1.0
          geo2 = dt / dx
          dt = xinc * cosr - yinc * sinr
          if (dt .eq. 0.0) dt = 1.0
          dt = dt * cond2r
          dx = 2.0 * dcos(dy) * dsin(dt/2.0)
          if (dx .eq. 0.0) dx = 1.0
          geo1 = dt * dsqrt((1.0+dcos(dy)*dcos(dt/2.0))/2.0) / dx
          geo3 = geo2 * dsin(dy) / dsqrt((1.0+dcos(dy))/2.0)
          rat = ra0
          dect = dec0
          if ((l .eq. 0.0) .and. (m .eq. 0.0)) goto 20
          dz = 4.0-l*l/(4.0*geo1*geo1)-((m+geo3)/geo2)*((m+geo3)/geo2)
          if ((dz .gt. 4.0) .or. (dz .lt. 2.0)) then 
            status = error1
            goto 30
          end if
          dz = 0.5 * dsqrt(dz)
          dd = (m+geo3) * dz / geo2
          if (dabs(dd) .gt. 1.0) then 
            status = error1
            goto 30
          end if
          dd = dasin(dd)
          if (dabs(dcos(dd)) .lt. deps) then 
            status = error1
            goto 30
          end if
          da = l * dz / (2.0 * geo1 * dcos(dd))
          if (dabs(da) .gt. 1.0) then 
            status = error1
            goto 30
          end if
          da = dasin(da)
          rat = ra0 + 2.0 * da
          dect = dd
        else if (itype .eq. 8) then
C   *** Stereographic from '-STG' type
          dz = (4.0 - sins) / (4.0 + sins)
          if (dabs(dz) .gt. 1.0) then 
            status = error1
            goto 30
          end if
          dect = dz * sin0 + m * cos0 * (1.0+dz) / 2.0
          if (dabs(dect) .gt. 1.0) then 
            status = error1
            goto 30
          end if
          dect = dasin(dect)
          rat = dcos(dect)
          if (dabs(rat) .lt. deps) then 
            status = error1
            goto 30
          end if
          rat = l * (1.0+dz) / (2.0 * rat)
          if (dabs(rat) .gt. 1.0) then 
            status = error1
            goto 30
          end if
          rat = dasin(rat)
          mg = 1.0 + dsin(dect)*sin0 + dcos(dect)*cos0*dcos(rat)
          if (dabs(mg) .lt. deps) then 
            status = error1
            goto 30
          end if
          mg = 2.0 * (dsin(dect)*cos0 - dcos(dect)*sin0*dcos(rat)) / mg
          if (dabs(mg-m) .gt. deps) rat = twopi/2.0 - rat
          rat = ra0 + rat
        else
C   *** Unsupported Projection
          status = error4
          goto 30
        end if
  20    continue
C   *** Return RA in range
        raout = rat
        decout = dect
        if (raout-ra0 .gt. twopi/2.0) raout = raout - twopi
        if (raout-ra0 .lt. -twopi/2.0) raout = raout + twopi
        if (raout .lt. 0.0) raout = raout + twopi
C   *** Correct units back to degrees 
        xpos = raout / cond2r
        ypos = decout / cond2r
  30    continue
        end

include defs

# ENTXKW -- Enter all XPP directives in the symbol table.

subroutine entxkw

include	COMMON_BLOCKS

string	sbool	"x$bool"
string	schar	"x$char"
string	sshort	"x$short"
string	sint	"x$int"
string	slong	"x$long"
string	sreal	"x$real"
string	sdble	"x$dble"
string	scplx	"x$cplx"
string	spntr	"x$pntr"
string	sfchr	"x$fchr"
string	sfunc	"x$func"
string	ssubr	"x$subr"
string	sextn	"x$extn"

string dbool	"logical"
string dchar	"integer*2"
string dshort	"integer*2"
string dint	"integer"
string dlong	"integer"
string dpntr	"integer"
string dreal	"real"
string ddble	"double precision"
string dcplx	"complex"
string dfchr	"character"
string dfunc	"function"
string dsubr	"subroutine"
string dextn	"external"

	call entdef (sbool,  dbool,  xpptbl)
	call entdef (schar,  dchar,  xpptbl)
	call entdef (sshort, dshort, xpptbl)
	call entdef (sint,   dint,   xpptbl)
	call entdef (slong,  dlong,  xpptbl)
	call entdef (spntr,  dpntr,  xpptbl)
	call entdef (sreal,  dreal,  xpptbl)
	call entdef (sdble,  ddble,  xpptbl)
	call entdef (scplx,  dcplx,  xpptbl)
	call entdef (sfchr,  dfchr,  xpptbl)
	call entdef (sfunc,  dfunc,  xpptbl)
	call entdef (ssubr,  dsubr,  xpptbl)
	call entdef (sextn,  dextn,  xpptbl)
end

      SUBROUTINE slDH2E (AZ, EL, PHI, HA, DEC)
*+
*     - - - - -
*      D E 2 H
*     - - - - -
*
*  Horizon to equatorial coordinates:  Az,El to HA,Dec
*
*  (double precision)
*
*  Given:
*     AZ      d     azimuth
*     EL      d     elevation
*     PHI     d     observatory latitude
*
*  Returned:
*     HA      d     hour angle
*     DEC     d     declination
*
*  Notes:
*
*  1)  All the arguments are angles in radians.
*
*  2)  The sign convention for azimuth is north zero, east +pi/2.
*
*  3)  HA is returned in the range +/-pi.  Declination is returned
*      in the range +/-pi/2.
*
*  4)  The latitude is (in principle) geodetic.  In critical
*      applications, corrections for polar motion should be applied.
*
*  5)  In some applications it will be important to specify the
*      correct type of elevation in order to produce the required
*      type of HA,Dec.  In particular, it may be important to
*      distinguish between the elevation as affected by refraction,
*      which will yield the "observed" HA,Dec, and the elevation
*      in vacuo, which will yield the "topocentric" HA,Dec.  If the
*      effects of diurnal aberration can be neglected, the
*      topocentric HA,Dec may be used as an approximation to the
*      "apparent" HA,Dec.
*
*  6)  No range checking of arguments is done.
*
*  7)  In applications which involve many such calculations, rather
*      than calling the present routine it will be more efficient to
*      use inline code, having previously computed fixed terms such
*      as sine and cosine of latitude.
*
*  P.T.Wallace   Starlink   21 February 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION AZ,EL,PHI,HA,DEC

      DOUBLE PRECISION SA,CA,SE,CE,SP,CP,X,Y,Z,R


*  Useful trig functions
      SA=SIN(AZ)
      CA=COS(AZ)
      SE=SIN(EL)
      CE=COS(EL)
      SP=SIN(PHI)
      CP=COS(PHI)

*  HA,Dec as x,y,z
      X=-CA*CE*SP+SE*CP
      Y=-SA*CE
      Z=CA*CE*CP+SE*SP

*  To HA,Dec
      R=SQRT(X*X+Y*Y)
      IF (R.EQ.0D0) THEN
         HA=0D0
      ELSE
         HA=ATAN2(Y,X)
      END IF
      DEC=ATAN2(Z,R)

      END

include	defs

# dsget --- get pointer to block of at least w available words

   pointer function dsget (w)
   integer w

   DS_COMMON

   pointer p, q, l

   integer n, k, junk
   integer getlin

   character c (10)

   n = w + DS_OHEAD
   q = DS_AVAIL

   repeat {
      p = Mem (q + DS_LINK)
      if (p == LAMBDA) {
	 call remark ("in dsget: out of storage space.")
	 call remark ("type 'c' or 'i' for char or integer dump.")
	 junk = getlin (c, STDIN)
	 if (c (1) == LETC | c (1) == BIGC)
	    call dsdump (LETTER)
	 else if (c (1) == LETI | c (1) == BIGI)
	    call dsdump (DIGIT)
	 call error ("program terminated.")
	 }
      if (Mem (p + DS_SIZE) >= n)
	 break
      q = p
      }

   k = Mem (p + DS_SIZE) - n
   if (k >= DS_CLOSE) {
      Mem (p + DS_SIZE) = k
      l = p + k
      Mem (l + DS_SIZE) = n
      }
   else {
      Mem (q + DS_LINK) = Mem (p + DS_LINK)
      l = p
      }

   return (l + DS_OHEAD)

   end

include	defs

# gfnarg --- get the next file name from the argument list

   integer function gfnarg (name, state)
   character name (ARB)
   integer state (4)

   integer l
   integer getarg, getlin

   filedes fd
   filedes open

   string in1 "/dev/stdin1"
   string in2 "/dev/stdin2"
   string in3 "/dev/stdin3"

   repeat {

      if (state (1) == 1) {
	 state (1) = 2	      # new state
	 state (2) = 1	      # next argument
	 state (3) = ERR      # current input file
	 state (4) = 0	      # input file count
	 }

      else if (state (1) == 2) {
	 if (getarg (state (2), name, MAXARG) != EOF) {
	    state (1) = 2     # stay in same state
	    state (2) = state (2) + 1  # bump argument count
	    if (name (1) != MINUS) {
	       state (4) = state (4) + 1    # bump input file count
	       return (OK)
	       }
	    else if (name (2) == EOS) {
	       call scopy (in1, 1, name, 1)
	       state (4) = state (4) + 1    # bump input file count
	       return (OK)
	       }
	    else if (name (2) == DIG1 & name (3) == EOS) {
	       call scopy (in1, 1, name, 1)
	       state (4) = state (4) + 1    # bump input file count
	       return (OK)
	       }
	    else if (name (2) == DIG2 & name (3) == EOS) {
	       call scopy (in2, 1, name, 1)
	       state (4) = state (4) + 1    # bump input file count
	       return (OK)
	       }
	    else if (name (2) == DIG3 & name (3) == EOS) {
	       call scopy (in3, 1, name, 1)
	       state (4) = state (4) + 1    # bump input file count
	       return (OK)
	       }

	    else if (name (2) == LETN | name (2) == BIGN) {
	       state (1) = 3	       # new state
	       if (name (3) == EOS)
		  state (3) = STDIN
	       else if (name (3) == DIG1 & name (4) == EOS)
		  state (3) = STDIN1
	       else if (name (3) == DIG2 & name (4) == EOS)
		  state (3) = STDIN2
	       else if (name (3) == DIG3 & name (4) == EOS)
		  state (3) = STDIN3
	       else {
		  state (3) = open (name (3), READ)
		  if (state (3) == ERR) {
		     call putlin (name, ERROUT)
		     call remark (":  can't open.")
		     state (1) = 2
		     }
		  }
	       }
	    else
	       return (ERR)
	    }

	 else
	    state (1) = 4     # EOF state
	 }

      else if (state (1) == 3) {
	 l = getlin (name, state (3))
	 if (l != EOF) {
	    name (l) = EOS
	    state (4) = state (4) + 1  # bump input file count
	    return (OK)
	    }
	 if (fd != ERR & fd != STDIN)
	    call close (state (3))
	 state (1) = 2
	 }

      else if (state (1) == 4) {
	 state (1) = 5
	 if (state (4) == 0) {# no input files
	    call scopy (in1, 1, name, 1)
	    return (OK)
	    }
	 break
	 }

      else if (state (1) == 5)
	 break

      else
	 call error ("in gfnarg:  bad state (1) value.")

      } # end of infinite repeat

   name (1) = EOS
   return (EOF)
   end

C----------------------------------------------------------------------
        subroutine ftgclb(iunit,colnum,frow,felem,nelem,eincr,
     &   nultyp,nulval,array,flgval,anynul,status)

C       read an array of byte data values from the specified column of
C       the table.  
C       This general purpose routine will handle null values in one
C       of two ways: if nultyp=1, then undefined array elements will be
C       set equal to the input value of NULVAL.  Else if nultyp=2, then
C       undefined array elements will have the corresponding FLGVAL element
C       set equal to .TRUE.  If NULTYP=1 and NULVAL=0, then no checks for
C       undefined values will be made, for maximum efficiency.

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read from
C       frow    i  first row to read
C       felem   i  first element within the row to read
C       nelem   i  number of elements to read
C       eincr   i  element increment
C       nultyp  i  input code indicating how to handle undefined values
C       nulval  b  value that undefined pixels will be set to (if nultyp=1)
C       array   b  array of data values that are read from the FITS file
C       flgval  l  set .true. if corresponding element undefined (if nultyp=2)
C       anynul  l  set to .true. if any of the returned values are undefined
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,colnum,frow,felem,nelem,eincr,nultyp,status
        character*1 array(*),nulval
        logical flgval(*),anynul

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer bufdim
        parameter (bufdim = 100)
        integer buffer(bufdim),bytpix,bstart,tcode,i4null,nulchk,incre
        integer ibuff,i1,ntodo,itodo,repeat,rstart,estart,maxpix,ival
        integer offset,rskip,dstart,begcol,lenrow
        integer*2 i2null
        character*1 i1null
        real rval
        double precision scale,zero,dval
        character sval*40,sform*13,snull*16
        logical tofits,descrp,trans
        character crow*9,cp1*9,cp2*9,ccol*4
        
        if (status .gt. 0)return

C       check for zero length array or bad first row number
        if (nelem .le. 0)return
        if (frow .lt. 1)then
C               error: illegal first row number
                status=307
                write(crow,2000)frow
2000            format(i9)
                call ftpmsg('Starting row number for table read '//
     &          'request is out of range:'//crow//' (FTGCLB).')
                return
        end if

        descrp=.false.
        i1=1
        ntodo=nelem
        rstart=frow-1
        anynul=.false.
        ibuff=bufnum(iunit)
        dstart=dtstrt(ibuff)
        lenrow=rowlen(ibuff)
        begcol=tbcol(colnum+tstart(ibuff))
        tcode=tdtype(colnum+tstart(ibuff))
        scale=tscale(colnum+tstart(ibuff))
        zero=tzero(colnum+tstart(ibuff))
C       the data are being scaled from FITS to internal format 
        tofits=.false.

C       calculate the maximum number of column pixels which fit in buffer
        bytpix=max(abs(tcode)/10,1)
C       check for important special case: no datatype conversion required
        if (abs(tcode) .eq. 11)then
                maxpix=nelem
        else
                maxpix=bufdim/bytpix*4
        end if

C       determine the repeat count and the first element position
C       incre is the byte offset between consecutive pixels
        incre=bytpix*eincr               
        if (tcode .eq. 16)then
C           this is an ASCII table; each element will be read one at a time
                repeat=1
                estart=0
C               construct the read format, and get the null value string
C               Microsoft Fortran 5.0 can't handle:
C               sform='(BN,'//cform(colnum+tstart(ibuff))//')'
                sform='(BN,        )'
                sform(5:12)=cform(colnum+tstart(ibuff))
                snull=cnull(colnum+tstart(ibuff))                
                sval=' '
        else
C           this is a binary table
                if (felem .lt. 1)then
C                       illegal element number
                        status=308
                        write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLB).')
                        return
                 end if
                 estart=felem-1

                if (tcode .gt. 0)then
                        repeat=trept(colnum+tstart(ibuff))
                        if (felem .gt. repeat)then
C                               illegal element number
                                status=308
                                write(crow,2000)felem
                call ftpmsg('Starting element number for read '//
     &          'request is out of range:'//crow//' (FTGCLB).')
                                return
                        end if
                        if (repeat .eq. 1 .and. nelem .gt. 1)then
C                           read multiple rows of data at one time by
C                           fooling it into thinking that this is a vector
C                           column with a large value of bytes per pixel
                                dstart=dstart+rstart*lenrow
                                rstart=0
                                estart=0
                                repeat=maxpix*eincr
                                incre=lenrow*eincr 
                                lenrow=lenrow*repeat
                        end if
                else
C                       this is a variable length descriptor column
                        descrp=.true.
                        tcode=-tcode
C                       read the number of elements and the starting offset:
                        call ftgdes(iunit,colnum,frow,repeat,
     &                              offset,status)
                        if (repeat .eq. 0)then
C                               error: null length vector
                                 status=318
                                return
                        else if (estart+(nelem-1)*eincr+1 .gt. repeat)
     %                      then
C                               error: trying to read beyond end of record
                                status=319
                                return
                        end if
C                       define the starting point of the row
                        dstart=dstart+offset+theap(ibuff)
                        rstart=0
                        begcol=0
                end if
        end if

C       determine if we have to check for null values
        if (nultyp .eq. 1 .and. ichar(nulval) .eq. 0)then
C               user doesn't want to check for nulls
                nulchk=0
        else
C           user does want to check for null values
C           see if the null value has been defined for this column
            nulchk=0
            if (tcode .eq. 11)then
C               check if byte datatype null value is defined, 
                if (tnull(colnum+tstart(ibuff)).ne.123454321)then
                        i1null=char(tnull(colnum+tstart(ibuff)))
                        nulchk=nultyp
                end if
            else if (tcode .eq. 21)then
C               check if I*2 datatype null value is defined, 
                if (tnull(colnum+tstart(ibuff)).ne.123454321)then
                        i2null=tnull(colnum+tstart(ibuff))
                        nulchk=nultyp
                end if
            else if (tcode .eq. 41)then
C               check if I*4 datatype null value is defined, 
                if (tnull(colnum+tstart(ibuff)).ne.123454321)then
                        i4null=tnull(colnum+tstart(ibuff))
                        nulchk=nultyp
                end if
            else if (tcode .eq. 42 .or. tcode .eq. 82)then
C               have to check floating point data for NaN values
                nulchk=nultyp
            end if
        end if

        if (nulchk .eq. 0 .and. scale .eq. 1. .and. zero .eq. 0.)then
                trans=.false.
        else
                trans=.true.
        end if

C       process as many contiguous pixels as possible, up to buffer size
20      itodo=min(ntodo,(repeat-estart-1)/eincr+1,maxpix)

C       move the i/o pointer to the start of the sequence of pixels
        bstart=dstart+rstart*lenrow+begcol+estart*bytpix
        call ftmbyt(iunit,bstart,.false.,status)

C       read the data from FITS file, doing datatype conversion and scaling
        if (tcode .eq. 21)then
C               column data type is I (I*2)
C               read the data and do any machine dependent data conversion
                call ftgi2b(iunit,itodo,incre,buffer,status)
C               check for null values, and do scaling and datatype conversion
                call fti2i1(buffer,itodo,scale,zero,tofits,
     &          nulchk,i2null,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 41)then
C               column data type is J (I*4)
C               read the data and do any machine dependent data conversion
                call ftgi4b(iunit,itodo,incre,buffer,status)
C               check for null values, and do scaling and datatype conversion
                call fti4i1(buffer,itodo,scale,zero,tofits,
     &          nulchk,i4null,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 42)then
C               column data type is E (R*4)
C               read the data and do any machine dependent data conversion
                call ftgr4b(iunit,itodo,incre,buffer,status)
C               check for null values, and do scaling and datatype conversion
                call ftr4i1(buffer,itodo,scale,zero,tofits,
     &          nulchk,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 82)then
C               column data type is D (R*8)
C               read the data and do any machine dependent data conversion
                call ftgr8b(iunit,itodo,incre,buffer,status)
C               check for null values, and do scaling and datatype conversion
                call ftr8i1(buffer,itodo,scale,zero,tofits,
     &          nulchk,nulval,flgval(i1),anynul,array(i1),status)
        else if (tcode .eq. 11)then
C               column data type is B (byte)
C               read the data and do any machine dependent data conversion
C               note that we can use the input array directly
                call ftgi1b(iunit,itodo,incre,array(i1),status)
C               check for null values, and do scaling and datatype conversion
                if (trans)then
                  call fti1i1(array(i1),itodo,scale,zero,tofits,nulchk,
     &            i1null,nulval,flgval(i1),anynul,array(i1),status)
                end if
        else if (tcode .eq. 16 .and. hdutyp(ibuff) .eq. 1)then
C               this is an ASCII table column; get the character string
                call ftgcbf(iunit,1,tnull(colnum+tstart(ibuff)),sval,
     &                      status)
                if (status .gt. 0)return

C               check for null
                if (sval(1:16) .eq. snull)then
                        anynul=.true.
                        if (nultyp .eq. 1)then
                                array(i1)=nulval
                        else
                                flgval(i1)=.true.
                        end if
                        go to 30
                end if

C               now read the value, then do scaling and datatype conversion
                if (sform(5:5) .eq. 'I')then
                        read(sval,sform,err=900)ival
                        call fti4i1(ival,itodo,scale,zero,tofits,0,
     &                 i4null,nulval,flgval(i1),anynul,array(i1),status)     
                else if (sform(5:5).eq.'F'.or. sform(5:5).eq.'E')then
                        read(sval,sform,err=900)rval
                        call ftr4i1(rval,itodo,scale,zero,tofits,
     &                  0,nulval,flgval(i1),anynul,array(i1),status)
                else if (sform(5:5) .eq. 'D')then
                        read(sval,sform,err=900)dval
                        call ftr8i1(dval,itodo,scale,zero,tofits,
     &                  0,nulval,flgval(i1),anynul,array(i1),status)
                else
C                       error: illegal ASCII table format code
                        status=311
                        write(ccol,2001)colnum
        call ftpmsg('Cannot read byte (I*1) values from column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTGCLB).')
                        return
                end if
        else
C               error illegal binary table data type code
                status=312
                write(ccol,2001)colnum
        call ftpmsg('Cannot read byte (I*1) values from column'//ccol
     &   //' with TFORM = '//cform(colnum+tstart(ibuff))//' (FTGCLB).')
                return
        end if

C       find number of pixels left to do, and quit if none left
30      ntodo=ntodo-itodo

        if (status .gt. 0)then
          if (hdutyp(ibuff) .eq. 0)then
C            this is a primary array or image extension
             write(cp1,2000)felem+i1-1
             write(cp2,2000)felem+i1+itodo-2
             call ftpmsg('Error reading pixels'//cp1//' to'//cp2
     &                 // ' of the FITS image array (FTGCLB).')
             if (frow .ne. 1)then
                write(cp1,2000)frow
                call ftpmsg('Error while reading group'//cp1//
     &          ' of the multigroup primary array.')
             end if
          else
             write(ccol,2001)colnum
2001         format(i4)
             if (descrp)then
C              this is a variable length descriptor column
               write(crow,2000)frow
               write(cp1,2000)felem+i1-1
               write(cp2,2000)felem+i1+itodo-2
               call ftpmsg('Error reading elements'//cp1//' to'//cp2
     &         //' in row'//crow)
               call ftpmsg(' of variable length vector column'//ccol
     &                    //' (FTGCLB.')
             else if (trept(colnum+tstart(ibuff)) .eq. 1)then
C              this is not a vector column (simple case)
               write(cp1,2000)frow+i1-1
               write(cp2,2000)frow+i1+itodo-2
               call ftpmsg('Error reading rows'//cp1//' to'//cp2
     &           //' of column'//ccol//' (FTGCLB).')
             else
C              this is a vector column (more complicated case)
               write(crow,2000)rstart+1
               write(cp1,2000)estart+1
               write(cp2,2000)itodo
               call ftpmsg('Error reading'//cp2//' elements from'
     &         //' column'//ccol)
               call ftpmsg(' starting at row'//crow
     &         //', element'//cp1//' (FTGCLB).')
             end if
          end if
          return
        end if

        if (ntodo .gt. 0)then
C               increment the pointers
                i1=i1+itodo
                estart=estart+itodo*eincr
                rskip=estart/repeat
                rstart=rstart+rskip
                estart=estart-rskip*repeat
                go to 20
        end if

C       check for any overflows
        if (status .eq. -11)then
               status=412
               call ftpmsg('Numeric overflow error occurred reading '//
     &        'Byte data from FITS file.')
        end if
        return

900     continue
C       error reading formatted data value from ASCII table
        write(ccol,2001)colnum
        write(cp1,2000)rstart+1
        call ftpmsg('Error reading colunm'//ccol//', row'//cp1//
     &  ' of the ASCII Table.')
        call ftpmsg('Tried to read "'//sval(1:20)//
     &              '" with format '//sform//' (FTGCLB).')
        status=315
        end

C----------------------------------------------------------------------
        subroutine ftpbit(setbit,wrbit,buffer)

C       encode the individual bits within the byte as specified by
C       the input logical array. The corresponding bit is set to 
C       1 if the logical array element is true.  Only the bits
C       between begbit and endbit, inclusive, are set or reset;
C       the remaining bits, if any, remain unchanged.

C       setbit  l  input array of logical data values corresponding 
C                  to the bits to be set in the output buffer
C                  TRUE means corresponding bit is to be set.
C       wrbit   l  input array of logical values indicating which
C                  bits in the byte are to be modified.  If FALSE,
C                  then the corresponding bit should remain unchanged.
C       buffer  i  output integer containing the encoded byte
C
C       written by Wm Pence, HEASARC/GSFC, May 1992

        integer buffer,tbuff,outbit
        logical setbit(8),wrbit(8)

        outbit=0
        tbuff=buffer

C       test each of the 8 bits, starting with the most significant
        if (tbuff .gt. 127)then
C           the bit is currently set in the word
            if (wrbit(1) .and. (.not.setbit(1)))then
C                only in this case do we reset the bit
            else
C               in all other cases we want the bit to be set
                outbit=outbit+128
            end if
            tbuff=tbuff-128
        else
C           bit is currently not set; set it only if requested to
            if (wrbit(1) .and. setbit(1))outbit=outbit+128
        end if

        if (tbuff .gt. 63)then
            if (wrbit(2) .and. (.not.setbit(2)))then
            else
                outbit=outbit+64
            end if
            tbuff=tbuff-64
        else
            if (wrbit(2) .and. setbit(2))outbit=outbit+64
        end if

        if (tbuff .gt. 31)then
            if (wrbit(3) .and. (.not.setbit(3)))then
            else
                outbit=outbit+32
            end if
            tbuff=tbuff-32
        else
            if (wrbit(3) .and. setbit(3))outbit=outbit+32
        end if

        if (tbuff .gt. 15)then
            if (wrbit(4) .and. (.not.setbit(4)))then
            else
                outbit=outbit+16
            end if
            tbuff=tbuff-16
        else
            if (wrbit(4) .and. setbit(4))outbit=outbit+16
        end if

        if (tbuff .gt. 7)then
            if (wrbit(5) .and. (.not.setbit(5)))then
            else
                outbit=outbit+8
            end if
            tbuff=tbuff-8
        else
            if (wrbit(5) .and. setbit(5))outbit=outbit+8
        end if

        if (tbuff .gt. 3)then
            if (wrbit(6) .and. (.not.setbit(6)))then
            else
                outbit=outbit+4
            end if
            tbuff=tbuff-4
        else
            if (wrbit(6) .and. setbit(6))outbit=outbit+4
        end if

        if (tbuff .gt. 1)then
            if (wrbit(7) .and. (.not.setbit(7)))then
            else
                outbit=outbit+2
            end if
            tbuff=tbuff-2
        else
            if (wrbit(7) .and. setbit(7))outbit=outbit+2
        end if

        if (tbuff .eq. 1)then
            if (wrbit(8) .and. (.not.setbit(8)))then
            else
                outbit=outbit+1
            end if
        else
            if (wrbit(8) .and. setbit(8))outbit=outbit+1
        end if

        buffer=outbit
        end            

C----------------------------------------------------------------------
        subroutine ftgphx(iunit,maxdim,simple,bitpix,naxis,naxes,pcount
     &               ,gcount,extend,bscale,bzero,blank,nblank,status)

C       get the main primary header keywords which define the array structure
C
C       iunit   i  fortran unit number to use for reading
C       maxdim  i  maximum no. of dimensions to read; dimension of naxes
C       OUTPUT PARAMETERS:
C       simple  l  does file conform to FITS standard?
C       bitpix  i  number of bits per data value
C       naxis   i  number of axes in the data array
C       naxes   i  array giving the length of each data axis
C       pcount  i  number of group parameters (usually 0)
C       gcount  i  number of random groups (usually 1 or 0)
C       extend  l  may extensions be present in the FITS file?
C       bscale  d  scaling factor
C       bzero   d  scaling zero point
C       blank   i  value used to represent undefined pixels
C       nblank  i  number of trailing blank keywords immediately before the END
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,maxdim,bitpix,naxis
        integer naxes(*),pcount,gcount,blank,status,tstat
        logical simple,extend,unknow
        character keynam*8,value*20,lngval*40,comm*72,extn*4,keybuf*80
        double precision bscale,bzero
        integer nkey,nblank,i,ibuff,taxes,maxd

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       check that the first keyword is valid
        call ftgrec(iunit,1,keybuf,status)

        keynam=keybuf(1:8)
C       parse the value and comment fields from the record
        call ftpsvc(keybuf,value,comm,status)

        if (status .gt. 0)go to 900

        simple=.true.
        unknow=.false.
        if (chdu(ibuff) .eq. 1)then
            if (keynam .eq. 'SIMPLE')then
                if (value .eq. 'F')then
C                       this is not a simple FITS file; try to process it anyway
                        simple=.false.
                else if (value .ne. 'T')then
C                       illegal value for the SIMPLE keyword
                        status=220

         if (keybuf(9:10) .ne. '= ')then 
           call ftpmsg('The SIMPLE keyword is missing "= " in '//
     &     'columns 9-10.')
         else
           call ftpmsg('The SIMPLE keyword value is illegal:'//value
     &     // '.  It must equal T or F:')
         end if

                        call ftpmsg(keybuf)
                end if
            else
                status=221
        call ftpmsg('First keyword of the file is not SIMPLE: '//keynam)
                call ftpmsg(keybuf)
                go to 900
            end if
        else
             if (keynam .eq. 'XTENSION')then
                if (value(2:9) .ne. 'IMAGE   ' .and. 
     &              value(2:9) .ne. 'IUEIMAGE')then
C                    I don't know what type of extension this is, but press on
                     unknow=.true.

         if (keybuf(9:10) .ne. '= ')then 
           call ftpmsg('The XTENSION keyword is missing "= " in '//
     &     'columns 9-10.')
         else
           call ftpmsg('This is not an IMAGE extension: '//value)
         end if

                     call ftpmsg(keybuf)
                 end if
             else
                 status=225
                 write(extn,1000)chdu(ibuff)
1000             format(i4)
                 call ftpmsg('First keyword in extension '//extn//
     &           ' was not XTENSION: '//keynam)
                 call ftpmsg(keybuf)
             end if
        end if
        if (status .gt. 0)go to 900

C       check that BITPIX is the second keyword
        call ftgrec(iunit,2,keybuf,status)

        keynam=keybuf(1:8)
C       parse the value and comment fields from the record
        call ftpsvc(keybuf,value,comm,status)

        if (status .gt. 0)go to 900
        if (keynam .ne. 'BITPIX')then
                status=222
        call ftpmsg('Second keyword was not BITPIX: '//keynam)
                call ftpmsg(keybuf)
                go to 900
        end if
C       convert character string to integer
        call ftc2ii(value,bitpix,status)
        if (status .gt. 0)then
C         bitpix value must be an integer
          if (keybuf(9:10) .ne. '= ')then
             call ftpmsg('BITPIX keyword is missing "= "'//
     &      ' in columns 9-10.')
          else
              call ftpmsg('Value of BITPIX is not an integer: '//value)
          end if
          call ftpmsg(keybuf)
          status=211
          go to 900
        end if

C       test that bitpix has a legal value
        call fttbit(bitpix,status)
        if (status .gt. 0)then
                call ftpmsg(keybuf)
                go to 900
        end if

C       check that the third keyword is NAXIS
        call ftgtkn(iunit,3,'NAXIS',naxis,status)
        if (status .eq. 208)then
C               third keyword was not NAXIS
                status=223
        else if (status .eq. 209)then
C               NAXIS value was not an integer
                status=212
        end if
        if (status .gt. 0)go to 900

        if (maxdim .le. 0)then
                maxd=naxis
        else
                maxd=min(maxdim,naxis)
        end if

        do 10 i=1,naxis
C               construct keyword name
                call ftkeyn('NAXIS',i,keynam,status)
C               attempt to read the keyword
                call ftgtkn(iunit,3+i,keynam,taxes,status)
                if (status .gt. 0)then
                        status=224
                        go to 900
                else if (taxes .lt. 0)then
C                       NAXISn keywords must not be negative
                        status=213
                        go to 900
                else if (i .le. maxd)then
                        naxes(i)=taxes
                end if
10      continue

C       now look for other keywords of interest: bscale, bzero, blank, and END
C       and pcount, gcount, and extend
15      bscale=1.
        bzero=0.
        pcount=0
        gcount=1
        extend=.false.
C       choose a special value to represent the absence of a blank value
        blank=123454321

        nkey=3+naxis
18      nblank=0
20      nkey=nkey+1
        tstat=status
        call ftgrec(iunit,nkey,keybuf,status)
        if (status .gt. 0)then
C               first, check for normal end-of-header status, and reset to 0
                if (status .eq. 203)status=tstat
C               if we hit the end of file, then set status = no END card found
                if (status .eq. 107)then
                       status=210
                       call ftpmsg('FITS header has no END keyword!')
                end if
                go to 900
        end if
        keynam=keybuf(1:8)
        comm=keybuf(9:80)

        if (keynam .eq. 'BSCALE')then
C               convert character string to floating pt.
                call ftpsvc(keybuf,lngval,comm,status)
                call ftc2dd(lngval,bscale,status)
                if (status .gt. 0)then
                     call ftpmsg('Error reading BSCALE keyword value'//
     &               ' as a Double:'//lngval)
                end if
        else if (keynam .eq. 'BZERO')then
C               convert character string to floating pt.
                call ftpsvc(keybuf,lngval,comm,status)
                call ftc2dd(lngval,bzero,status)
                if (status .gt. 0)then
                     call ftpmsg('Error reading BZERO keyword value'//
     &               ' as a Double:'//lngval)
                end if
        else if (keynam .eq. 'BLANK')then
C               convert character string to integer
                call ftpsvc(keybuf,value,comm,status)
                call ftc2ii(value,blank,status)
                if (status .gt. 0)then
                     call ftpmsg('Error reading BLANK keyword value'//
     &               ' as an integer:'//value)
                end if
        else if (keynam .eq. 'PCOUNT')then
C               convert character string to integer
                call ftpsvc(keybuf,value,comm,status)
                call ftc2ii(value,pcount,status)
                if (status .gt. 0)then
                     call ftpmsg('Error reading PCOUNT keyword value'//
     &               ' as an integer:'//value)
                end if
        else if (keynam .eq. 'GCOUNT')then
C               convert character string to integer
                call ftpsvc(keybuf,value,comm,status)
                call ftc2ii(value,gcount,status)
                if (status .gt. 0)then
                     call ftpmsg('Error reading GCOUNT keyword value'//
     &               ' as an integer:'//value)
                end if
        else if (keynam .eq. 'EXTEND')then
C               convert character string to logical
                call ftpsvc(keybuf,value,comm,status)
                call ftc2ll(value,extend,status)
                if (status .gt. 0)then
                     call ftpmsg('Error reading EXTEND keyword value'//
     &               ' as a Logical:'//value)
                 end if
        else if (keynam .eq. ' ' .and. comm .eq. ' ')then
C               need to ignore trailing blank records before the END card
                nblank=nblank+1
                go to 20
        else if (keynam .eq. 'END')then
                go to 900
        end if
        if (status .gt. 0)go to 900
        go to 18

900     continue

        if (status .gt. 0)then
          if (chdu(ibuff) .eq. 1)then
            call ftpmsg('Failed to parse the required keywords in '//
     &       'the Primary Array header ')
          else
            call ftpmsg('Failed to parse the required keywords in '//
     &       'the Image Extension header (FTGPHX).')
          end if

        else if (unknow)then
C           set status if this was an unknown type of extension
            status=233
        end if
        end

      subroutine ratfor
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer i, n
      integer getarg, rfopen
      integer arg (30)
      integer defns(1)
      data defns(1)/-2/
      call initkw
      if (.not.(defns (1) .ne. -2))goto 23000
      infile (1) = rfopen(defns, 1)
      if (.not.(infile (1) .eq. -3))goto 23002
      call remark (37Hcan't open standard definitions file.)
      goto 23003
23002 continue
      call finit
      call parse
      call rfclos(infile (1))
23003 continue
23000 continue
      n = 1
      i=1
23004 if (.not.(getarg(i,arg,30) .ne. -1))goto 23006
      n = n + 1
      call query (37Husage:  ratfor [-g] [files] >outfile.)
      if (.not.(arg(1) .eq. 45 .and. arg(2) .eq. 103 .and. arg(3) .eq. -
     *2))goto 23007
      dbgout = 1
      goto 23005
23007 continue
      if (.not.(arg(1) .eq. 45 .and. arg(2) .eq. -2))goto 23009
      infile(1) = 0
      call finit
      goto 23010
23009 continue
      infile(1) = rfopen(arg, 1)
      if (.not.(infile(1) .eq. -3))goto 23011
      call cant (arg)
      goto 23012
23011 continue
      call finit
      call scopy (arg, 1, fnames, 1)
      fnamp=1
23013 if (.not.(fnames(fnamp) .ne. -2))goto 23015
      if (.not.(fnames(fnamp) .eq. 46 .and. fnames(fnamp+1) .eq. 114))go
     *to 23016
      fnames(fnamp+1) = 120
23016 continue
23014 fnamp=fnamp+1
      goto 23013
23015 continue
23012 continue
23010 continue
23008 continue
      call parse
      if (.not.(infile (1) .ne. 0))goto 23018
      call rfclos(infile (1))
23018 continue
23005 i=i+1
      goto 23004
23006 continue
      if (.not.(n .eq. 1))goto 23020
      infile (1) = 0
      call finit
      call parse
23020 continue
      call lndict
      end
c     logic0  logical_column

c     prog5
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   example of the use of subroutines bndacc and bndsol to solve
c     sequentially the banded least squares problem which arises in
c     spline curve fitting.
c
      dimension x(12),y(12),b(10),g(12,5),c(12),q(4),cov(12)
c
c	 define functions p1 and p2 to be used in constructing
c	 cubic splines over uniformly spaced breakpoints.
c
      p1(t)=.25*t**2*t
      p2(t)=-(1.-t)**2*(1.+t)*.75+1.
      zero=0.
c
      write (6,230)
      mdg=12
      nband=4
      m=12
c				   set ordinates of data
      y(1)=2.2
      y(2)=4.0
      y(3)=5.0
      y(4)=4.6
      y(5)=2.8
      y(6)=2.7
      y(7)=3.8
      y(8)=5.1
      y(9)=6.1
      y(10)=6.3
      y(11)=5.0
      y(12)=2.0
c				   set abcissas of data
	   do 10 i=1,m
   10	   x(i)=2*i
c
c     begin loop thru cases using increasing nos of breakpoints.
c
	   do 150 nbp=5,10
	   nc=nbp+2
c				   set breakpoints
	   b(1)=x(1)
	   b(nbp)=x(m)
	   h=(b(nbp)-b(1))/float(nbp-1)
	   if (nbp.le.2) go to 30
		do 20 i=3,nbp
   20		b(i-1)=b(i-2)+h
   30	   continue
	   write (6,240) nbp,(b(i),i=1,nbp)
c
c     initialize ir and ip before first call to bndacc.
c
	   ir=1
	   ip=1
	   i=1
	   jt=1
   40	   mt=0
   50	   continue
	   if (x(i).gt.b(jt+1)) go to 60
c
c			 set row  for ith data point
c
	   u=(x(i)-b(jt))/h
	   ig=ir+mt
	   g(ig,1)=p1(1.-u)
	   g(ig,2)=p2(1.-u)
	   g(ig,3)=p2(u)
	   g(ig,4)=p1(u)
	   g(ig,5)=y(i)
	   mt=mt+1
	   if (i.eq.m) go to 60
	   i=i+1
	   go to 50
c
c		    send block of data to processor
c
   60	   continue
	   call bndacc (g,mdg,nband,ip,ir,mt,jt)
	   if (i.eq.m) go to 70
	   jt=jt+1
	   go to 40
c		    compute solution c()
   70	   continue
	   call bndsol (1,g,mdg,nband,ip,ir,c,nc,rnorm)
c		   write solution coefficients
	   write (6,180) (c(l),l=1,nc)
	   write (6,210) rnorm
c
c	       compute and print x,y,yfit,r=y-yfit
c
	   write (6,160)
	   jt=1
		do 110 i=1,m
   80		if (x(i).le.b(jt+1)) go to 90
		jt=jt+1
		go to 80
c
   90		u=(x(i)-b(jt))/h
		q(1)=p1(1.-u)
		q(2)=p2(1.-u)
		q(3)=p2(u)
		q(4)=p1(u)
		yfit=zero
		     do 100 l=1,4
		     ic=jt-1+l
  100		     yfit=yfit+c(ic)*q(l)
		r=y(i)-yfit
		write (6,170) i,x(i),y(i),yfit,r
  110		continue
c
c     compute residual vector norm.
c
	   if (m.le.nc) go to 150
	   sigsq=(rnorm**2)/float(m-nc)
	   sigfac=sqrt(sigsq)
	   write (6,220) sigfac
	   write (6,200)
c
c     compute and print cols. of covariance.
c
		do 140 j=1,nc
		     do 120 i=1,nc
  120		     cov(i)=zero
		cov(j)=1.
		call bndsol (2,g,mdg,nband,ip,ir,cov,nc,rdummy)
		call bndsol (3,g,mdg,nband,ip,ir,cov,nc,rdummy)
c
c    compute the jth col. of the covariance matrix.
		     do 130 i=1,nc
  130		     cov(i)=cov(i)*sigsq
  140		write (6,190) (l,j,cov(l),l=1,nc)
  150	   continue
      stop
  160 format (4h0  i,8x,1hx,10x,1hy,6x,4hyfit,4x,8hr=y-yfit/1x)
  170 format (1x,i3,4x,f6.0,4x,f6.2,4x,f6.2,4x,f8.4)
  180 format (4h0c =,10f10.5/(4x,10f10.5))
  190 format (4(02x,2i5,e15.7))
  200 format (46h0covariance matrix of the spline coefficients.)
  210 format (9h0rnorm	=,e15.8)
  220 format (9h0sigfac =,e15.8)
  230 format (50h1prog5.    execute a sequence of cubic spline fits,27h
     1to a discrete set of data.)
  240 format (1x////,11h0new case..,/47h0number of breakpoints, includin
     1g endpoints, is,i5/14h0breakpoints =,10f10.5,/(14x,10f10.5))
      end

      SUBROUTINE slSVDS (M, N, MP, NP, B, U, W, V, WORK, X)
*+
*     - - - - - - -
*      S V D S
*     - - - - - - -
*
*  From a given vector and the SVD of a matrix (as obtained from
*  the SVD routine), obtain the solution vector (double precision)
*
*  This routine solves the equation:
*
*     A . x = b
*
*  where:
*
*     A   is a given M (rows) x N (columns) matrix, where M.GE.N
*     x   is the N-vector we wish to find
*     b   is a given M-vector
*
*  by means of the Singular Value Decomposition method (SVD).  In
*  this method, the matrix A is first factorised (for example by
*  the routine slSVD) into the following components:
*
*     A = U x W x VT
*
*  where:
*
*     A   is the M (rows) x N (columns) matrix
*     U   is an M x N column-orthogonal matrix
*     W   is an N x N diagonal matrix with W(I,I).GE.0
*     VT  is the transpose of an NxN orthogonal matrix
*
*     Note that M and N, above, are the LOGICAL dimensions of the
*     matrices and vectors concerned, which can be located in
*     arrays of larger PHYSICAL dimensions MP and NP.
*
*  The solution is found from the expression:
*
*     x = V . [diag(1/Wj)] . (transpose(U) . b)
*
*  Notes:
*
*  1)  If matrix A is square, and if the diagonal matrix W is not
*      adjusted, the method is equivalent to conventional solution
*      of simultaneous equations.
*
*  2)  If M>N, the result is a least-squares fit.
*
*  3)  If the solution is poorly determined, this shows up in the
*      SVD factorisation as very small or zero Wj values.  Where
*      a Wj value is small but non-zero it can be set to zero to
*      avoid ill effects.  The present routine detects such zero
*      Wj values and produces a sensible solution, with highly
*      correlated terms kept under control rather than being allowed
*      to elope to infinity, and with meaningful values for the
*      other terms.
*
*  Given:
*     M,N    i         numbers of rows and columns in matrix A
*     MP,NP  i         physical dimensions of array containing matrix A
*     B      d(M)      known vector b
*     U      d(MP,NP)  array containing MxN matrix U
*     W      d(N)      NxN diagonal matrix W (diagonal elements only)
*     V      d(NP,NP)  array containing NxN orthogonal matrix V
*
*  Returned:
*     WORK   d(N)      workspace
*     X      d(N)      unknown vector x
*
*  Reference:
*     Numerical Recipes, section 2.9.
*
*  P.T.Wallace   Starlink   29 October 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER M,N,MP,NP
      DOUBLE PRECISION B(M),U(MP,NP),W(N),V(NP,NP),WORK(N),X(N)

      INTEGER J,I,JJ
      DOUBLE PRECISION S



*  Calculate [diag(1/Wj)] . transpose(U) . b (or zero for zero Wj)
      DO J=1,N
         S=0D0
         IF (W(J).NE.0D0) THEN
            DO I=1,M
               S=S+U(I,J)*B(I)
            END DO
            S=S/W(J)
         END IF
         WORK(J)=S
      END DO

*  Multiply by matrix V to get result
      DO J=1,N
         S=0D0
         DO JJ=1,N
            S=S+V(J,JJ)*WORK(JJ)
         END DO
         X(J)=S
      END DO

      END

chapter xiii, example 1. a large norm amplifies noise.
c  from  * a practical guide to splines *  by c. de boor
calls splint(banfac/slv,bsplvb),bsplpp(bsplvb*),ppvalu(interv),round
c     an initially uniform data point distribution of  n  points is
c  changed  i t e r m x  times by moving the  j c l o s e -th data point
c  toward its left neighbor, cutting the distance between the two by a
c  factor of  r a t e  each time . to demonstrate the corresponding
c  increase in the norm of cubic spline interpolation at these data
c  points, the data are taken from a cubic polynomial (which would be
c  interpolated exactly) but with noise of size  s i z e  added. the re-
c  sulting noise or error in the interpolant (compared to the cubic)
c  gives the norm or noise amplification factor and is printed out
c  together with the diminishing distance  h  between the two data
c  points.
c     parameter nmax=200,nmaxt4=800,nmaxt7=1400,nmaxp4=204
      integer i,iflag,istep,iter,itermx,j,jclose,l,n,nm1
c     real amax,bcoef(nmax),break(nmax),coef(nmaxt4),dx,fltnm1,fx
c    * ,gtau(nmax),h,rate,scrtch(nmaxt7),size,step,t(nmaxp4),tau(nmax),x
      real amax,bcoef(200),break(200),coef(800),dx,fltnm1,fx
     * ,gtau(200),h,rate,scrtch(1400),size,step,t(204),tau(200),x
      real ppvalu,round,g
      common /rount/ size
      data step, istep / 20., 20 /
c					   function to be interpolated .
      g(x) = 1.+x*(1.+x*(1.+x))
      read 500,n,itermx,jclose,size,rate
  500 format(3i3/e10.3/e10.3)
      print 600,size
  600 format(16h size of noise =,e8.2//
     *	    25h    h	       max.error)
c					start with uniform data points .
      nm1 = n - 1
      fltnm1 = float(nm1)
      do 10 i=1,n
   10	 tau(i) = float(i-1)/fltnm1
c		     set up knot sequence for not-a-knot end condition .
      do 11 i=1,4
	 t(i) = tau(1)
   11	 t(n+i) = tau(n)
      do 12 i=5,n
   12	 t(i) = tau(i-2)
c
      do 100 iter=1,itermx
	 do 21 i=1,n
   21	    gtau(i) = round(g(tau(i)))
	 call splint ( tau, gtau, t, n, 4, scrtch, bcoef, iflag )
					go to (24,23),iflag
   23	 print 623
  623	 format(27h something wrong in splint.)
					stop
   24	 call bsplpp ( t, bcoef, n, 4, scrtch, break, coef, l )
c				     calculate max.interpolation error .
	 amax = 0.
	 do 30 i=4,n
	    dx = (break(i-2) - break(i-3))/step
	    do 25 j=2,istep
	       x = break(i-2) - dx*float(j-1)
	       fx = ppvalu(break,coef,l,4,x,0)
   25	       amax = amax1(amax,abs(fx-g(x)))
   30	    continue
	 h = tau(jclose) - tau(jclose-1)
	 print 630,h,amax
  630	 format(e9.2,e15.3)
c		  move tau(jclose) toward its left neighbor so as to cut
c		  their distance by a factor of  rate .
	 tau(jclose) = (tau(jclose) + (rate-1.)*tau(jclose-1))/rate
  100	 continue
					stop
      end

      SUBROUTINE SINQF (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
      IF (N .EQ. 1) RETURN
      NS2 = N/2
      DO 101 K=1,NS2
         KC = N-K
         XHOLD = X(K)
         X(K) = X(KC+1)
         X(KC+1) = XHOLD
  101 CONTINUE
      CALL COSQF (N,X,WSAVE)
      DO 102 K=2,N,2
         X(K) = -X(K)
  102 CONTINUE
      RETURN
      END

      SUBROUTINE TVELVC	(nplot, IERROR)
C
C LATEST REVISION   JULY, 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 SUBROUTINES VELVCT AND	EZVEC.
C
C USAGE			 CALL TVELVC (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   =0 IF THERE IS A NORMAL EXIT	FROM THE
C			      ROUTINES VELVCT AND EZVEC
C			   =1 OTHERWISE
C
C I/O			 IF THERE IS A NORMAL EXIT FROM	THE ROUTINES
C			 VELVCT	AND EZVEC THE MESSAGE
C			   VELVCT TEST SUCCESSFUL . . .	SEE PLOTS TO
C			   VERIFY PERFORMANCE
C			 IS PRINTED.
C
C PRECISION		 SINGLE
C
C LANGUAGE		 FORTRAN
C
C HISTORY		 ORIGINALLY WRITTEN NOVEMBER 1976
C
C ALGORITHM		 ROUTINE TVELVC	CALLS ROUTINES EZVEC AND
C			 VELVCT	ONCE.  EACH CALL PRODUCES A PLOT
C			 REPRESENTING A	VECTOR FIELD.  THE VECTOR
C			 FIELD IS OBTAINED FROM	THE FUNCTION
C			   Z(X,Y) = X +	Y + 1./((X-.1)**2+Y**2+.09)
C				    -1./((X+.1)**2+Y**2+.09),
C			 BY USING THE DIRECTION	OF THE Z GRADIENT
C			 VECTORS AND THE LOGARITHM OF THE ABSOLUTE
C			 VALUE OF THE COMPONENTS.
C
C
C
C
      DIMENSION	      U(21,25)	 ,V(21,25)
C
C SPECIFY COORDS FOR PLOT TITLES
C
	DATA IX/94/,IY/1000/
C
C SPECIFY SOME OF THE ARGUMENTS	IN VELVCT CALLING SEQUENCE
C
      DATA FLO/0./,HI/0./,NSET/0/,LENGTH/0/,ISPV/0/,SPV/0./
C
C INITIALIZE ERROR PARAMETER
C
      IERROR = 1
C
C SPECIFY VELOCITY FIELD FUNCTIONS U AND V
C
      M	= 21
      N	= 25
      DO  20 I=1,M
	 X = .1*FLOAT(I-11)
	 DO  10	J=1,N
	    Y =	.1*FLOAT(J-13)
	    DZDX = 1.-2.*(X-.10)/((X-.10)**2+Y**2+.09)**2+
     1		   2.*(X+.10)/((X+.10)**2+Y**2+.09)**2
	    DZDY = 1.-2.*Y/((X-.10)**2+Y**2+.09)**2+
     1		   2.*Y/((X+.10)**2+Y**2+.09)**2
	    UVMAG = ALOG(SQRT(DZDX*DZDX+DZDY*DZDY))
	    UVDIR = ATAN2(DZDY,DZDX)
	    U(I,J) = UVMAG*COS(UVDIR)
	    V(I,J) = UVMAG*SIN(UVDIR)
   10	 CONTINUE
   20 CONTINUE
C
C CALL WTSTR FOR EZVEC PLOT TITLE
C
c +noao: flag used to plot either velvct or ezvec
	if (nplot .eq. 1) then
	CALL GQCNTN(IERR,ICN)
	CALL GSELNT(0)
c       X = PAU2FX(IX)
	x = cpux (ix)
c       Y = PAU2FY(IY)
        y = cpuy (iy)
      CALL WTSTR (X,Y,'DEMONSTRATION PLOT FOR ENTRY EZVEC OF VELVCT',
     1		 2,0,-1)
	CALL GSELNT(ICN)
C
C CALL EZVEC FOR VELOCITY FIELD	PLOT
C
      CALL EZVEC (U,V,M,N)
      endif
c -noao
C
C CALL VELVCT FOR VELOCITY FIELD PLOT
C
c +noao: flag used to plot either velvct or ezvec
      if (nplot .eq. 2) then
      CALL VELVCT (U,M,V,M,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
C
C CALL WTSTR FOR VELVCT	PLOT TITLE
C
	CALL GQCNTN(IERR,ICN)
	CALL GSELNT(0)
c       X = PAU2FX(IX)
        x = cpux (ix)
c       Y = PAU2FY(IY)
        y = cpuy (iy)
      CALL WTSTR (X,Y,
     1		 'DEMONSTRATION PLOT FOR ENTRY VELVCT OF VELVCT',2,
     2		 0,-1)
	CALL GSELNT(ICN)
	endif
c -noao
c
c     CALL NEWFM
C
      IERROR = 0
c     WRITE (6,1001)
      RETURN
C
c1001 FORMAT ('	    VELVCT TEST	SUCCESSFUL',24X,
c    1	      'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

C--------------------------------------------------------------------------
        subroutine ftg2di(ounit,group,nulval,dim1,nx,ny,
     &                    array,anyflg,status)

C       Read a 2-d image of i*2 values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       nulval  i*2  undefined pixels will be set to this value (unless = 0)
C       dim1    i  actual first dimension of ARRAY
C       nx      i  size of the image in the x direction
C       ny      i  size of the image in the y direction
C       array   i*2  the array of values to be read
C       anyflg  l  set to true if any of the image pixels were undefined
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,dim1,nx,ny,status
        integer*2 array(dim1,*),nulval
        logical anyflg,ltemp
        integer fpixel,row

        anyflg=.false.
        fpixel=1
        do 10 row = 1,ny
                call ftgpvi(ounit,group,fpixel,nx,nulval,
     &              array(1,row),ltemp,status)
                if (ltemp)anyflg=.true.
                fpixel=fpixel+nx
10      continue

        end

C----------------------------------------------------------------------
        subroutine ftchfl(iunit,status)

C       Check Header Fill values
C       Check that the header unit is correctly filled with blanks from the
C       END card to the end of the current FITS 2880-byte block

C       iunit   i  fortran unit number
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June, 1994

        integer iunit,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,nblank,i,endpos
        character*80 rec
        logical gotend

        if (status .gt. 0)return

        ibuff=bufnum(iunit)

C       calculate the number of blank keyword slots in the header
        endpos=hdend(ibuff)
        nblank=(dtstrt(ibuff)-endpos)/80
C       move the i/o pointer to the end of the header keywords
        call ftmbyt(iunit,endpos,.true.,status)
C       find the END card (there may be blank keywords perceeding it)

        gotend=.false.
        do 10 i=1,nblank
                call ftgcbf(iunit,1,80,rec,status)
                if (rec(1:8) .eq. 'END     ')then
                       if (gotend)then
C                          there is a duplicate END record
                           status=254
             call ftpmsg('Warning: Header fill area contains '//
     &       'duplicate END card:')
                       end if
                       gotend=.true.
                       if (rec(9:80) .ne. ' ')then
C                          END keyword has extra characters
                           status=253
            call ftpmsg('Warning: END keyword contains '//
     &      'extraneous non-blank characters:')
                       end if
                 else if (gotend)then
                       if (rec .ne. ' ')then
C                          The fill area contains extraneous characters
                           status=254
             call ftpmsg('Warning: Header fill area contains '//
     &       'extraneous non-blank characters:')
                        end if
                end if

                if (status .gt. 0)then
                           call ftpmsg(rec)
                           return
                end if
10      continue
        end

      SUBROUTINE slDAFR (IDEG, IAMIN, ASEC, RAD, J)
*+
*     - - - - - -
*      D A F R
*     - - - - - -
*
*  Convert degrees, arcminutes, arcseconds to radians
*  (double precision)
*
*  Given:
*     IDEG        int       degrees
*     IAMIN       int       arcminutes
*     ASEC        dp        arcseconds
*
*  Returned:
*     RAD         dp        angle in radians
*     J           int       status:  0 = OK
*                                    1 = IDEG outside range 0-359
*                                    2 = IAMIN outside range 0-59
*                                    3 = ASEC outside range 0-59.999...
*
*  Notes:
*     1)  The result is computed even if any of the range checks
*         fail.
*     2)  The sign must be dealt with outside this routine.
*
*  P.T.Wallace   Starlink   23 August 1996
*
*  Copyright (C) 1996 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER IDEG,IAMIN
      DOUBLE PRECISION ASEC,RAD
      INTEGER J

*  Arc seconds to radians
      DOUBLE PRECISION AS2R
      PARAMETER (AS2R=0.484813681109535994D-5)



*  Preset status
      J=0

*  Validate arcsec, arcmin, deg
      IF (ASEC.LT.0D0.OR.ASEC.GE.60D0) J=3
      IF (IAMIN.LT.0.OR.IAMIN.GT.59) J=2
      IF (IDEG.LT.0.OR.IDEG.GT.359) J=1

*  Compute angle
      RAD=AS2R*(60D0*(60D0*DBLE(IDEG)+DBLE(IAMIN))+ASEC)

      END

      subroutine delete (symbol, st)
      integer symbol (100)
      integer st
      integer mem( 60000)
      common/cdsmem/mem
      integer stlu
      integer node, pred
      if (.not.(stlu (symbol, node, pred, st) .eq. 1))goto 23000
      mem (pred + 0) = mem (node + 0)
      call dsfree (node)
23000 continue
      return
      end

c function pctile (datum, n, npct)
c
c This is a modification of a quick-sorting algorithm, which is intended
c to take in a vector of numbers, and return the value of the npct-th
c element in that vector:
c
c    dataum 			   input vector
c    n			           number of elements in dataum
c    npct			   npct-th element
c    pctile			   output value of function
c
c
c The array datum contains randomly ordered data
c
c
      real function pctile (datum, n, npct)
c
      implicit none
      integer n, npct
      real datum(1)
      integer min0, max0
      real dkey
      integer lo, hi, limlo, limhi
c
c Initialize the pointers.
c
      npct = max0 (1, min0 (n,npct))
      limlo = 1
      limhi = n
c
c Compare all elements in the sub-vector between limlo and limhi with
c the current key datum.
c
  100 dkey = datum (limlo)
      lo = limlo
      hi = limhi
c
c If lo equals hi, we have tested all the elements in the current search
c interval.
c
  101 continue
      if (lo .eq. hi) go to 200
      if (datum(hi) .le. dkey) go to 109
c
c The pointer hi is to be left pointing at a datum SMALLER than the
c key, which is intended to be overwritten.
c
      hi = hi - 1
c
      goto 101
  109 datum(lo) = datum(hi)
      lo = lo + 1
  110 continue
      if (lo .eq. hi) goto 200
      if (datum(lo) .ge. dkey) go to 119
      lo = lo + 1
c
      goto 110
  119 datum(hi) = datum(lo)
c
c The pointer LO is to be left pointing at a datum LARGER than the
c key, which is intended to be overwritten.
c
      hi = hi - 1
c
      go to 101
c
c lo and hi are equal, and point at a value which is intended to
c be overwritten.  Since all values below this point are less than
c the key and all values above this point are greater than the key,
c this is where we stick the key back into the vector.
c
  200 continue
c
c At this point in the subroutine, all data between limlo and lo-1,
c inclusive, are less than datum (lo), and all data between lo+1 and
c limhi are larger than dataum(lo).  If lo = npct, then datum(lo) is
c the value we are looking for.  If npct < lo, then we want to sort the
c values of datum from limlo to lo-1, inclusive, whereas if npct > lo,
c then we want to sort the values of datum from lo+1 to limhi,
c inclusive.
c
      datum(lo) = dkey
      if (npct - lo) 300, 900, 400
  300 limhi = lo - 1
      go to 100
  400 limlo = lo + 1
      go to 100
  900 pctile = datum(lo)
      return
      end

      subroutine bsplvd ( t, k, x, left, a, dbiatx, nderiv )
c  from  * a practical guide to splines *  by c. de boor
calls bsplvb
calculates value and deriv.s of all b-splines which do not vanish at x
c
c******  i n p u t  ******
c  t	 the knot array, of length left+k (at least)
c  k	 the order of the b-splines to be evaluated
c  x	 the point at which these values are sought
c  left  an integer indicating the left endpoint of the interval of
c	 interest. the	k  b-splines whose support contains the interval
c		(t(left), t(left+1))
c	 are to be considered.
c  a s s u m p t i o n	- - -  it is assumed that
c		t(left) .lt. t(left+1)
c	 division by zero will result otherwise (in  b s p l v b ).
c	 also, the output is as advertised only if
c		t(left) .le. x .le. t(left+1) .
c  nderiv   an integer indicating that values of b-splines and their
c	 derivatives up to but not including the  nderiv-th  are asked
c	 for. ( nderiv	is replaced internally by the integer  m h i g h
c	 in  (1,k)  closest to it.)
c
c******  w o r k   a r e a  ******
c  a	 an array of order (k,k), to contain b-coeff.s of the derivat-
c	 ives of a certain order of the  k  b-splines of interest.
c
c******  o u t p u t  ******
c  dbiatx   an array of order (k,nderiv). its entry  (i,m)  contains
c	 value of  (m-1)st  derivative of  (left-k+i)-th  b-spline of
c	 order	k  for knot sequence  t , i=m,...,k, m=1,...,nderiv.
c
c******  m e t h o d  ******
c  values at  x  of all the relevant b-splines of order k,k-1,...,
c  k+1-nderiv  are generated via  bsplvb  and stored temporarily in
c  dbiatx .  then, the b-coeffs of the required derivatives of the b-
c  splines of interest are generated by differencing, each from the pre-
c  ceding one of lower order, and combined with the values of b-splines
c  of corresponding order in  dbiatx  to produce the desired values .
c
      integer k,left,nderiv,   i,ideriv,il,j,jlow,jp1mid,kp1,kp1mm
     *			      ,ldummy,m,mhigh
      real a(k,k),dbiatx(k,nderiv),t(1),x,   factor,fkp1mm,sum
      mhigh = max0(min0(nderiv,k),1)
c     mhigh is usually equal to nderiv.
      kp1 = k+1
      call bsplvb(t,kp1-mhigh,1,x,left,dbiatx)
      if (mhigh .eq. 1) 		go to 99
c     the first column of  dbiatx  always contains the b-spline values
c     for the current order. these are stored in column k+1-current
c     order  before  bsplvb  is called to put values for the next
c     higher order on top of it.
      ideriv = mhigh
      do 15 m=2,mhigh
	 jp1mid = 1
	 do 11 j=ideriv,k
	    dbiatx(j,ideriv) = dbiatx(jp1mid,1)
   11	    jp1mid = jp1mid + 1
	 ideriv = ideriv - 1
	 call bsplvb(t,kp1-ideriv,2,x,left,dbiatx)
   15	 continue
c
c     at this point,  b(left-k+i, k+1-j)(x) is in  dbiatx(i,j) for
c     i=j,...,k and j=1,...,mhigh ('=' nderiv). in particular, the
c     first column of  dbiatx  is already in final form. to obtain cor-
c     responding derivatives of b-splines in subsequent columns, gene-
c     rate their b-repr. by differencing, then evaluate at  x.
c
      jlow = 1
      do 20 i=1,k
	 do 19 j=jlow,k
   19	    a(j,i) = 0.
	 jlow = i
   20	 a(i,i) = 1.
c     at this point, a(.,j) contains the b-coeffs for the j-th of the
c     k  b-splines of interest here.
c
      do 40 m=2,mhigh
	 kp1mm = kp1 - m
	 fkp1mm = float(kp1mm)
	 il = left
	 i = k
c
c	 for j=1,...,k, construct b-coeffs of  (m-1)st	derivative of
c	 b-splines from those for preceding derivative by differencing
c	 and store again in  a(.,j) . the fact that  a(i,j) = 0  for
c	 i .lt. j  is used.
	 do 25 ldummy=1,kp1mm
	    factor = fkp1mm/(t(il+kp1mm) - t(il))
c	    the assumption that t(left).lt.t(left+1) makes denominator
c	    in	factor	nonzero.
	    do 24 j=1,i
   24	       a(i,j) = (a(i,j) - a(i-1,j))*factor
	    il = il - 1
   25	    i = i - 1
c
c	 for i=1,...,k, combine b-coeffs a(.,i) with b-spline values
c	 stored in dbiatx(.,m) to get value of	(m-1)st  derivative of
c	 i-th b-spline (of interest here) at  x , and store in
c	 dbiatx(i,m). storage of this value over the value of a b-spline
c	 of order m there is safe since the remaining b-spline derivat-
c	 ives of the same order do not use this value due to the fact
c	 that  a(j,i) = 0  for j .lt. i .
   30	 do 40 i=1,k
	    sum = 0.
	    jlow = max0(i,m)
	    do 35 j=jlow,k
   35	       sum = a(j,i)*dbiatx(j,m) + sum
   40	    dbiatx(i,m) = sum
   99					return
      end

      subroutine upper (token)
      integer token (100)
      integer cupper
      integer i
      i = 1
23000 if (.not.(token (i) .ne. -2))goto 23002
      token (i) = cupper (token (i))
23001 i = i + 1
      goto 23000
23002 continue
      return
      end

      SUBROUTINE slDVXV (VA, VB, VC)
*+
*     - - - - -
*      D V X V
*     - - - - -
*
*  Vector product of two 3-vectors  (double precision)
*
*  Given:
*      VA      dp(3)     first vector
*      VB      dp(3)     second vector
*
*  Returned:
*      VC      dp(3)     vector result
*
*  P.T.Wallace   Starlink   March 1986
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION VA(3),VB(3),VC(3)

      DOUBLE PRECISION VW(3)
      INTEGER I


*  Form the vector product VA cross VB
      VW(1)=VA(2)*VB(3)-VA(3)*VB(2)
      VW(2)=VA(3)*VB(1)-VA(1)*VB(3)
      VW(3)=VA(1)*VB(2)-VA(2)*VB(1)

*  Return the result
      DO I=1,3
         VC(I)=VW(I)
      END DO

      END

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGCTCS (TPID,ITCS)
C
      CHARACTER*(*) TPID
C
C The routine AGCTCS is called by the routines AGGETC and AGSETC to
C check what type of character-string parameter is implied by the
C parameter identifier TPID and return an appropriate value of ITCS, as
C follows:
C
C -- ITCS = 0 implies that the parameter is not intrinsically of type
C    character and that AGGETC/AGSETC should not have been called in
C    the way that it was.
C
C -- ITCS = 1 implies a dash-pattern parameter.
C
C -- ITCS = 2 implies a label name.
C
C -- ITCS = 3 implies the line-end character.
C
C -- ITCS = 4 implies the text of some line of some label.
C
C Find out where in the parameter list the requested parameter lies.
C
      CALL AGSCAN (TPID,LOPA,NIPA,IIPA)
C
C See if it's a dash pattern.
C
      CALL AGSCAN ('DASH/PATT.',LODP,NIDP,IIDP)
      IF (LOPA.GE.LODP.AND.LOPA.LE.LODP+NIDP-1) THEN
        ITCS=1
        RETURN
      END IF
C
C See if it's a label name.
C
      CALL AGSCAN ('LABE/NAME.',LOLN,NILN,IILN)
      IF (LOPA.EQ.LOLN) THEN
        ITCS=2
        RETURN
      END IF
C
C See if it's the line-end character.
C
      CALL AGSCAN ('LINE/END .',LOLE,NILE,IILE)
      IF (LOPA.EQ.LOLE) THEN
        ITCS=3
        RETURN
      END IF
C
C See if it's the text of some label line.
C
      CALL AGSCAN ('LINE/BUFF/CONT.',LOLB,NILB,IILB)
      IF (LOPA.GE.LOLB.AND.LOPA.LE.LOLB+NILB-1.AND.
     +                                       MOD(LOPA-LOLB,6).EQ.3) THEN
        ITCS=4
        RETURN
      END IF
C
C Error - type not recognizable.
C
      ITCS=0
      RETURN
C
      END

      integer function alldig (str)
      integer str (100)
      integer i
      alldig = 0
      if (.not.(str (1) .eq. -2))goto 23000
      return
23000 continue
      i = 1
23002 if (.not.(str (i) .ne. -2))goto 23004
      if (.not.(.not.(48.le.str (i).and.str (i).le.57)))goto 23005
      return
23005 continue
23003 i = i + 1
      goto 23002
23004 continue
      alldig = 1
      return
      end

      integer function stake (from, to, chars)
      integer from (100), to (100)
      integer chars
      integer len, start
      integer length, ctoc, max0
      len = length (from)
      if (.not.(chars .lt. 0))goto 23000
      start = max0 (len + chars, 0)
      stake=(ctoc (from (start + 1), to, len + 1))
      return
23000 continue
      stake=(ctoc (from, to, chars + 1))
      return
23001 continue
      end

      DOUBLE PRECISION FUNCTION slDSEPV (V1, V2)
*+
*     - - - - - -
*      D S E P V
*     - - - - - -
*
*  Angle between two vectors.
*
*  (double precision)
*
*  Given:
*     V1      d(3)    first vector
*     V2      d(3)    second vector
*
*  The result is the angle, in radians, between the two vectors.  It
*  is always positive.
*
*  Notes:
*
*  1  There is no requirement for the vectors to be unit length.
*
*  2  If either vector is null, zero is returned.
*
*  3  The simplest formulation would use dot product alone.  However,
*     this would reduce the accuracy for angles near zero and pi.  The
*     algorithm uses both cross product and dot product, which maintains
*     accuracy for all sizes of angle.
*
*  Called:  slDVXV, slDVN, slDVDV
*
*  Last revision:   14 June 2005
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION V1(3),V2(3)

      DOUBLE PRECISION V1XV2(3),WV(3),S,C
      DOUBLE PRECISION slDVDV



*  Modulus of cross product = sine multiplied by the two moduli.
      CALL slDVXV(V1,V2,V1XV2)
      CALL slDVN(V1XV2,WV,S)

*  Dot product = cosine multiplied by the two moduli.
      C = slDVDV(V1,V2)

*  Angle between the vectors.
      IF ( S.NE.0D0 .OR. C.NE.0D0 ) THEN
         slDSEPV = ATAN2(S,C)
      ELSE
         slDSEPV = 0D0
      END IF

      END

#-h-  putchr			  233  local   12/01/80  15:54:34
# putchr - put single char into eval stack
   include  defs

   subroutine putchr (c)
   character c

   include COMMON_BLOCKS

   if (ep > EVALSIZE)
      call baderr ('evaluation stack overflow.')
   evalst (ep) = c
   ep = ep + 1
   return
   end

C----------------------------------------------------------------------
        subroutine ftc2d(cval,dval,status)
C       convert a character string to a double precision value
C       perform datatype conversion, if required

        character*(*) cval
        integer ival,status
        character*1 dtype
        logical lval
        character*16 sval
        double precision dval


C       convert string to its intrinsic data type
        call ftc2x(cval,dtype,ival,lval,sval,dval,status)
        if (status .gt. 0)return

        if (dtype .eq. 'F')then
C               no datatype conversion required, so just return
        else if (dtype .eq. 'I')then
C               convert from integer to double precision
                dval=ival
        else if (dtype .eq. 'L')then
C               need to convert from logical to double precision
                if (lval)then
                        dval=1.
                else
                        dval=0.
                end if
        else if (dtype .eq. 'C')then
C               can't convert a string to double precision, so return error
                dval=0
                status=406
                sval=cval
                call ftpmsg('Error in FTC2D evaluating this string '//
     &          'as a double value: '//sval)
        end if
        end

C----------------------------------------------------------------------
        subroutine ftc2i(cval,ival,status)
C       convert a character string to an integer
C       perform datatype conversion, if required

        integer ival,status
        character*(*) cval
        character*1 dtype
        logical lval
        character sval*16
        double precision dval

C       convert string to its intrinsic data type
        call ftc2x(cval,dtype,ival,lval,sval,dval,status)
        if (status .gt. 0)return

        if (dtype .eq. 'I')then
C               no datatype conversion required, so just return
        else if (dtype .eq. 'F')then
C               need to convert from floating point to integer
                ival=dval
        else if (dtype .eq. 'L')then
C               need to convert from logical to integer
                if (lval)then
                        ival=1
                else
                        ival=0
                end if
        else if (dtype .eq. 'C')then
C               can't convert a string to an integer, so return error
                ival=0
                status=403
                sval=cval
        call ftpmsg('Error in FTC2I evaluating this string as an '
     &  //'integer: '//sval)
        end if
        end

      subroutine bndsol (mode,g,mdg,nb,ip,ir,x,n,rnorm,ier)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   sequential solution of a banded least squares problem..
c	   solution phase.   for the accumulation phase use bndacc.
c
c     mode = 1	   solve r*x=y	 where r and y are in the g( ) array
c		   and x will be stored in the x( ) array.
c	     2	   solve (r**t)*x=y   where r is in g( ),
c		   y is initially in x( ), and x replaces y in x( ),
c	     3	   solve r*x=y	 where r is in g( ).
c		   y is initially in x( ), and x replaces y in x( ).
c
c     the second subscript of g( ) must be dimensioned at least
c     nb+1 in the calling program.
      dimension g(mdg,1),x(n)
      zero=0.
      ier = 0
c
      rnorm=zero
      go to (10,90,50), mode
c				    ********************* mode = 1
c				    algc step 26
   10	   do 20 j=1,n
   20	   x(j)=g(j,nb+1)
      rsq=zero
      np1=n+1
      irm1=ir-1
      if (np1.gt.irm1) go to 40
	   do 30 j=np1,irm1
   30	   rsq=rsq+g(j,nb+1)**2
      rnorm=sqrt(rsq)
   40 continue
c				    ********************* mode = 3
c				    alg. step 27
   50	   do 80 ii=1,n
	   i=n+1-ii
c				    alg. step 28
	   s=zero
	   l=max0(0,i-ip)
c				    alg. step 29
	   if (i.eq.n) go to 70
c				    alg. step 30
	   ie=min0(n+1-i,nb)
		do 60 j=2,ie
		jg=j+l
		ix=i-1+j
   60		s=s+g(i,jg)*x(ix)
c				    alg. step 31
   70	   if (g(i,l+1)) 80,130,80
   80	   x(i)=(x(i)-s)/g(i,l+1)
c				    alg. step 32
      return
c				    ********************* mode = 2
   90	   do 120 j=1,n
	   s=zero
	   if (j.eq.1) go to 110
	   i1=max0(1,j-nb+1)
	   i2=j-1
		do 100 i=i1,i2
		l=j-i+1+max0(0,i-ip)
  100		s=s+x(i)*g(i,l)
  110	   l=max0(0,j-ip)
	   if (g(j,l+1)) 120,130,120
  120	   x(j)=(x(j)-s)/g(j,l+1)
      return
c
c     error return: zero diagonal term in bndsol
  130 ier = 1
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      FUNCTION AGMINI (SVAL,ZLOW,ZDRA,NVIZ,IIVZ,NEVZ,IIEZ)
C
      DIMENSION ZDRA(1)
C
C The routine AGMINI returns the mimimum value of the elements in ZDRA
C specified by NVIZ, IIVZ, NEVZ, and IIEZ, skipping elements having the
C special value SVAL (or less than ZLOW, if ZLOW is not equal to SVAL).
C
C -- NVIZ is the number of vectors of data stored in ZDRA.
C
C -- IIVZ is the index increment from one data vector to the next.
C
C -- NEVZ is the number of elements per vector to be examined.
C
C -- IIEZ is the index increment from one vector element to the next.
C    If IIEZ is 0, the array is ignored and 1. is returned.
C
      AGMINI=1.
      IF (IIEZ.EQ.0) RETURN
C
      AGMINI=SVAL
      INDZ=1-IIEZ
C
      DO 103 I=1,NVIZ
        IF (ZLOW.EQ.SVAL) THEN
          DO 101 J=1,NEVZ
            INDZ=INDZ+IIEZ
            IF (ZDRA(INDZ).EQ.SVAL) GO TO 101
            IF (AGMINI.EQ.SVAL) AGMINI=ZDRA(INDZ)
            AGMINI=AMIN1(AGMINI,ZDRA(INDZ))
  101     CONTINUE
        ELSE
          DO 102 J=1,NEVZ
            INDZ=INDZ+IIEZ
            IF (ZDRA(INDZ).EQ.SVAL.OR.ZDRA(INDZ).LT.ZLOW) GO TO 102
            IF (AGMINI.EQ.SVAL) AGMINI=ZDRA(INDZ)
            AGMINI=AMIN1(AGMINI,ZDRA(INDZ))
  102     CONTINUE
        END IF
        INDZ=INDZ-NEVZ*IIEZ+IIVZ
  103 CONTINUE
C
      RETURN
C
      END

      SUBROUTINE slFK45 (R1950,D1950,DR1950,DD1950,P1950,V1950,
     :                      R2000,D2000,DR2000,DD2000,P2000,V2000)
*+
*     - - - - - -
*      F K 4 5
*     - - - - - -
*
*  Convert B1950.0 FK4 star data to J2000.0 FK5 (double precision)
*
*  This routine converts stars from the old, Bessel-Newcomb, FK4
*  system to the new, IAU 1976, FK5, Fricke system.  The precepts
*  of Smith et al (Ref 1) are followed, using the implementation
*  by Yallop et al (Ref 2) of a matrix method due to Standish.
*  Kinoshita's development of Andoyer's post-Newcomb precession is
*  used.  The numerical constants from Seidelmann et al (Ref 3) are
*  used canonically.
*
*  Given:  (all B1950.0,FK4)
*     R1950,D1950     dp    B1950.0 RA,Dec (rad)
*     DR1950,DD1950   dp    B1950.0 proper motions (rad/trop.yr)
*     P1950           dp    parallax (arcsec)
*     V1950           dp    radial velocity (km/s, +ve = moving away)
*
*  Returned:  (all J2000.0,FK5)
*     R2000,D2000     dp    J2000.0 RA,Dec (rad)
*     DR2000,DD2000   dp    J2000.0 proper motions (rad/Jul.yr)
*     P2000           dp    parallax (arcsec)
*     V2000           dp    radial velocity (km/s, +ve = moving away)
*
*  Notes:
*
*  1)  The proper motions in RA are dRA/dt rather than
*      cos(Dec)*dRA/dt, and are per year rather than per century.
*
*  2)  Conversion from Besselian epoch 1950.0 to Julian epoch
*      2000.0 only is provided for.  Conversions involving other
*      epochs will require use of the appropriate precession,
*      proper motion, and E-terms routines before and/or
*      after FK425 is called.
*
*  3)  In the FK4 catalogue the proper motions of stars within
*      10 degrees of the poles do not embody the differential
*      E-term effect and should, strictly speaking, be handled
*      in a different manner from stars outside these regions.
*      However, given the general lack of homogeneity of the star
*      data available for routine astrometry, the difficulties of
*      handling positions that may have been determined from
*      astrometric fields spanning the polar and non-polar regions,
*      the likelihood that the differential E-terms effect was not
*      taken into account when allowing for proper motion in past
*      astrometry, and the undesirability of a discontinuity in
*      the algorithm, the decision has been made in this routine to
*      include the effect of differential E-terms on the proper
*      motions for all stars, whether polar or not.  At epoch 2000,
*      and measuring on the sky rather than in terms of dRA, the
*      errors resulting from this simplification are less than
*      1 milliarcsecond in position and 1 milliarcsecond per
*      century in proper motion.
*
*  References:
*
*     1  Smith, C.A. et al, 1989.  "The transformation of astrometric
*        catalog systems to the equinox J2000.0".  Astron.J. 97, 265.
*
*     2  Yallop, B.D. et al, 1989.  "Transformation of mean star places
*        from FK4 B1950.0 to FK5 J2000.0 using matrices in 6-space".
*        Astron.J. 97, 274.
*
*     3  Seidelmann, P.K. (ed), 1992.  "Explanatory Supplement to
*        the Astronomical Almanac", ISBN 0-935702-68-7.
*
*  P.T.Wallace   Starlink   19 December 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION R1950,D1950,DR1950,DD1950,P1950,V1950,
     :                 R2000,D2000,DR2000,DD2000,P2000,V2000


*  Miscellaneous
      DOUBLE PRECISION R,D,UR,UD,PX,RV,SR,CR,SD,CD,W,WD
      DOUBLE PRECISION X,Y,Z,XD,YD,ZD
      DOUBLE PRECISION RXYSQ,RXYZSQ,RXY,RXYZ,SPXY,SPXYZ
      INTEGER I,J

*  Star position and velocity vectors
      DOUBLE PRECISION R0(3),RD0(3)

*  Combined position and velocity vectors
      DOUBLE PRECISION V1(6),V2(6)

*  2Pi
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)

*  Radians per year to arcsec per century
      DOUBLE PRECISION PMF
      PARAMETER (PMF=100D0*60D0*60D0*360D0/D2PI)

*  Small number to avoid arithmetic problems
      DOUBLE PRECISION TINY
      PARAMETER (TINY=1D-30)


*
*  CANONICAL CONSTANTS  (see references)
*

*  Km per sec to AU per tropical century
*  = 86400 * 36524.2198782 / 149597870
      DOUBLE PRECISION VF
      PARAMETER (VF=21.095D0)

*  Constant vector and matrix (by columns)
      DOUBLE PRECISION A(3),AD(3),EM(6,6)
      DATA A,AD/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     :           +1.245D-3,    -1.580D-3,   -0.659D-3/

      DATA (EM(I,1),I=1,6) / +0.9999256782D0,
     :                       +0.0111820610D0,
     :                       +0.0048579479D0,
     :                       -0.000551D0,
     :                       +0.238514D0,
     :                       -0.435623D0 /

      DATA (EM(I,2),I=1,6) / -0.0111820611D0,
     :                       +0.9999374784D0,
     :                       -0.0000271474D0,
     :                       -0.238565D0,
     :                       -0.002667D0,
     :                       +0.012254D0 /

      DATA (EM(I,3),I=1,6) / -0.0048579477D0,
     :                       -0.0000271765D0,
     :                       +0.9999881997D0,
     :                       +0.435739D0,
     :                       -0.008541D0,
     :                       +0.002117D0 /

      DATA (EM(I,4),I=1,6) / +0.00000242395018D0,
     :                       +0.00000002710663D0,
     :                       +0.00000001177656D0,
     :                       +0.99994704D0,
     :                       +0.01118251D0,
     :                       +0.00485767D0 /

      DATA (EM(I,5),I=1,6) / -0.00000002710663D0,
     :                       +0.00000242397878D0,
     :                       -0.00000000006582D0,
     :                       -0.01118251D0,
     :                       +0.99995883D0,
     :                       -0.00002714D0 /

      DATA (EM(I,6),I=1,6) / -0.00000001177656D0,
     :                       -0.00000000006587D0,
     :                       +0.00000242410173D0,
     :                       -0.00485767D0,
     :                       -0.00002718D0,
     :                       +1.00000956D0 /



*  Pick up B1950 data (units radians and arcsec/TC)
      R=R1950
      D=D1950
      UR=DR1950*PMF
      UD=DD1950*PMF
      PX=P1950
      RV=V1950

*  Spherical to Cartesian
      SR=SIN(R)
      CR=COS(R)
      SD=SIN(D)
      CD=COS(D)

      R0(1)=CR*CD
      R0(2)=SR*CD
      R0(3)=   SD

      W=VF*RV*PX

      RD0(1)=-SR*CD*UR-CR*SD*UD+W*R0(1)
      RD0(2)= CR*CD*UR-SR*SD*UD+W*R0(2)
      RD0(3)=             CD*UD+W*R0(3)

*  Allow for e-terms and express as position+velocity 6-vector
      W=R0(1)*A(1)+R0(2)*A(2)+R0(3)*A(3)
      WD=R0(1)*AD(1)+R0(2)*AD(2)+R0(3)*AD(3)
      DO I=1,3
         V1(I)=R0(I)-A(I)+W*R0(I)
         V1(I+3)=RD0(I)-AD(I)+WD*R0(I)
      END DO

*  Convert position+velocity vector to Fricke system
      DO I=1,6
         W=0D0
         DO J=1,6
            W=W+EM(I,J)*V1(J)
         END DO
         V2(I)=W
      END DO

*  Revert to spherical coordinates
      X=V2(1)
      Y=V2(2)
      Z=V2(3)
      XD=V2(4)
      YD=V2(5)
      ZD=V2(6)

      RXYSQ=X*X+Y*Y
      RXYZSQ=RXYSQ+Z*Z
      RXY=SQRT(RXYSQ)
      RXYZ=SQRT(RXYZSQ)

      SPXY=X*XD+Y*YD
      SPXYZ=SPXY+Z*ZD

      IF (X.EQ.0D0.AND.Y.EQ.0D0) THEN
         R=0D0
      ELSE
         R=ATAN2(Y,X)
         IF (R.LT.0.0D0) R=R+D2PI
      END IF
      D=ATAN2(Z,RXY)

      IF (RXY.GT.TINY) THEN
         UR=(X*YD-Y*XD)/RXYSQ
         UD=(ZD*RXYSQ-Z*SPXY)/(RXYZSQ*RXY)
      END IF

      IF (PX.GT.TINY) THEN
         RV=SPXYZ/(PX*RXYZ*VF)
         PX=PX/RXYZ
      END IF

*  Return results
      R2000=R
      D2000=D
      DR2000=UR/PMF
      DD2000=UD/PMF
      V2000=RV
      P2000=PX

      END

      REAL FUNCTION slRA1P (ANGLE)
*+
*     - - - - - -
*      R A 1 P
*     - - - - - -
*
*  Normalize angle into range +/- pi  (single precision)
*
*  Given:
*     ANGLE     dp      the angle in radians
*
*  The result is ANGLE expressed in the +/- pi (single
*  precision).
*
*  P.T.Wallace   Starlink   23 November 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL ANGLE

      REAL API,A2PI
      PARAMETER (API=3.141592653589793238462643)
      PARAMETER (A2PI=6.283185307179586476925287)


      slRA1P=MOD(ANGLE,A2PI)
      IF (ABS(slRA1P).GE.API)
     :          slRA1P=slRA1P-SIGN(A2PI,ANGLE)

      END

c STRPAK -- Pack an SPP character string into a C string, i.e., a sequence
c of characters stored one per byte, delimited by EOS='\0'.  The operation
c may be performed in place.  This version assumes that the host character
c set is ASCII and hence no lookup table reference to map character sets is
c needed.  If this is not the case, code must be added to convert to the host
c character set.
c
c N.B.: If sizeof(XCHAR)=1, XEOS=EOS, and the host character set is ASCII,
c and the operation is being performed in place, then this procedure should
c do nothing.
c 
c N.B.: This code ASSUMES that XCHAR is implemented as INTEGER*2 and that
c both XEOS and EOS are 0.

	subroutine strpak (instr, outstr, maxch)

	integer*2 instr(*), ch, EOS
	character*1 outstr(*)
	integer maxch
	parameter (EOS=0)
	integer i

		do 10 i = 1, maxch
		    ch = instr(i)
		    outstr(i) = char (ch)
		    if (ch .eq. EOS) return
 10		continue
		outstr(maxch+1) = char (EOS)
	end

      integer function omatch (lin, i, pat, j)
      integer lin (128), pat (128)
      integer i, j
      integer bump
      integer locate
      omatch = 0
      if (.not.(lin (i) .eq. -2))goto 23000
      return
23000 continue
      bump = -1
      if (.not.(pat (j) .eq. 97))goto 23002
      if (.not.(lin (i) .eq. pat (j + 1)))goto 23004
      bump = 1
23004 continue
      goto 23003
23002 continue
      if (.not.(pat (j) .eq. 37))goto 23006
      if (.not.(i .eq. 1))goto 23008
      bump = 0
23008 continue
      goto 23007
23006 continue
      if (.not.(pat (j) .eq. 63))goto 23010
      if (.not.(lin (i) .ne. 10))goto 23012
      bump = 1
23012 continue
      goto 23011
23010 continue
      if (.not.(pat (j) .eq. 36))goto 23014
      if (.not.(lin (i) .eq. 10))goto 23016
      bump = 0
23016 continue
      goto 23015
23014 continue
      if (.not.(pat (j) .eq. 91))goto 23018
      if (.not.(locate (lin (i), pat, j + 1) .eq. 1))goto 23020
      bump = 1
23020 continue
      goto 23019
23018 continue
      if (.not.(pat (j) .eq. 110))goto 23022
      if (.not.(lin (i) .ne. 10 .and. locate (lin (i), pat, j + 1) .eq. 
     *0))goto 23024
      bump = 1
23024 continue
      goto 23023
23022 continue
      call error (24Hin omatch: can't happen.)
23023 continue
23019 continue
23015 continue
23011 continue
23007 continue
23003 continue
      if (.not.(bump .ge. 0))goto 23026
      i = i + bump
      omatch = 1
23026 continue
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGGTCH (IDCS,CHST,LNCS)
C
      CHARACTER*(*) CHST
C
C This routine gets character strings previously stored by the routine
C AGSTCH (which see).  It has the following arguments:
C
C -- IDCS is the identifying integer returned by AGSTCH when the string
C    was stored.
C
C -- CHST is the character string returned.
C
C -- LNCS is the length of the character string returned in CHST.
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
C
      COMMON /AGCHR2/ CHRA(2000)
C
      CHARACTER*1 CHRA
C
C First, blank-fill the character variable to be returned.
C
      CHST=' '
C
C If the identifier is less than -LNIC, the (one-character) string is
C retrieved from it.
C
      IF (IDCS.LT.(-LNIC)) THEN
        CHST=CHAR(-IDCS-LNIC-1)
        LNCS=1
C
C If the identifier is between -LNIC and -1, its absolute value is the
C index, in INCH, of the descriptor of the character string stored in
C CHRA.
C
      ELSE IF (IDCS.LE.(-1)) THEN
        I=-IDCS
        J=INCH(1,I)-1
        IF (J.GE.0) THEN
          LNCS=MIN0(LEN(CHST),INCH(2,I))
          DO 101 K=1,LNCS
            J=J+1
            CHST(K:K)=CHRA(J)
  101     CONTINUE
        ELSE
          LNCS=0
        END IF
C
C In all other cases, return a single blank.
C
      ELSE
        LNCS=1
C
      END IF
C
C Done.
C
      RETURN
C
      END

#-h-  ifcode			  198  local   12/01/80  15:54:10
# ifcode - generate initial code for if
   include  defs

   subroutine ifcode (lab)
   integer lab

   include COMMON_BLOCKS

   integer labgen

   xfer = NO
   lab = labgen (2)
   call ifgo (lab)
   call indent (1)
   return
   end

chapter xii, example 3. cubic spline interpolation with good knots
c  from  * a practical guide to splines *  by c. de boor
calls cubspl
      integer i,irate,istep,j,n,nhigh,nlow,nm1
      real algerp,aloger,c(4,20),decay,dx,errmax,g,h,pnatx,step,tau(20)
     *	  ,x
      data step, istep /20., 20/
      g(x) = sqrt(x+1.)
      decay = 0.
      read 500,irate,nlow,nhigh
  500 format(3i3)
      print 600
  600 format(28h  n   max.error   decay exp./)
      do 40 n=nlow,nhigh,2
	 nm1 = n-1
	 h = 1./float(nm1)
	 do 10 i=1,n
	    tau(i) = 2.*(float(i-1)*h)**irate - 1.
   10	    c(1,i) = g(tau(i))
c	 construct cubic spline interpolant.
	 call cubspl ( tau, c, n, 0, 0 )
c	 estimate max.interpolation error on (-1,1).
	 errmax = 0.
	 do 30 i=1,nm1
	    dx = (tau(i+1)-tau(i))/step
	    do 30 j=1,istep
	       h = float(j)*dx
	       pnatx = c(1,i)+h*(c(2,i)+h*(c(3,i)+h*c(4,i)/3.)/2.)
	       x = tau(i) + h
   30	       errmax = amax1(errmax,abs(g(x)-pnatx))
	 aloger = alog(errmax)
	 if (n .gt. nlow)  decay =
     *	     (aloger - algerp)/alog(float(n)/float(n-2))
	 algerp = aloger
   40	 print 640,n,errmax,decay
  640 format(i3,e12.4,f11.2)
					stop
      end

      subroutine dsinit (w)
      integer w
      integer mem( 60000)
      common/cdsmem/mem
      integer t
      if (.not.(w .lt. 2 * 2 + 2))goto 23000
      call error (42Hin dsinit: unreasonably small memory size.)
23000 continue
      t = 2
      mem (t + 0) = 0
      mem (t + 1) = 2 + 2
      t = 2 + 2
      mem (t + 0) = w - 2 - 1
      mem (t + 1) = 0
      mem (1) = w
      return
      end

C----------------------------------------------------------------------
        subroutine ftvcks(iunit,dataok,hduok,status)

C       Verify the HDU by comparing the value of the computed checksums against
C       the values of the DATASUM and CHECKSUM keywords if they are present.

C       iunit   i  fortran unit number
C       dataok  i  output verification code for the data unit alone
C       hduok   i  output verification code for the entire HDU
C                  the code values = 1  verification is correct
C                                  = 0  checksum keyword is not present
C                                  = -1 verification not correct
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Dec, 1994

        integer iunit,dataok,hduok,status,tstat,i
        double precision datsum,chksum,dsum
        character keyval*20,comm*8
        logical cexist,dexist

        if (status .gt. 0)return

C       check if the CHECKSUM keyword exists
        tstat=status
        call ftgkys(iunit,'CHECKSUM',keyval,comm,status)
        if (status .le. 0)then
            cexist=.true.
        else
            hduok=0
            cexist=.false.
            status=tstat
        end if

C       check if the DATASUM keyword exists and get its value
        call ftgkys(iunit,'DATASUM',keyval,comm,status)
        if (status .le. 0)then
            dexist=.true.
        else
            dataok=0
            dexist=.false.
            status=tstat
        end if

C       return if neither keyword exists
        if (.not. cexist .and. .not. dexist)return
            
C       calculate the data checksum and the HDU checksum
        call ftgcks(iunit,datsum,chksum,status)
        if (status .gt. 0)return

        if (dexist)then

C           decode the datasum string into a double precision variable
            do 10 i=1,20
                if (keyval(i:i) .ne. ' ')then
                    call ftc2dd(keyval(i:20),dsum,status)
                    if (status .eq. 409)then
C                       couldn't read the keyword; assume it is out of date
                        status=tstat
                        dsum=-1.
                    end if
                    go to 15
                end if
10          continue
            dsum=0.
15          continue

            if (dsum .eq. datsum)then
                dataok=1
            else
                dataok=-1
            end if
        end if

        if (cexist)then
            if (chksum .eq. 0 .or. chksum .eq. 4.294967295D+09)then
                hduok=1
            else
                hduok=-1
            end if
        end if
        end

C 	This routine was copied from the stsdas$pkg/analysis/gasp/gasplib/
C       directory. See stsdas$copyright.stsdas for copyright restrictions.
C 
	subroutine dcmpsv (a,m,n,w,v)
	parameter (nmax=1000)
	real*8 a(m,n),w(n),v(n,n),rv1(nmax)
	real*8 c, g, f, h, s, y, z, x, scale, anorm

	g=0.0
	scale=0.0
	anorm=0.0
	do i=1,n
		l=i+1
		rv1(i)=scale*g
		g=0.0
		s=0.0
		scale=0.0
		if (i.le.m) then
			do k=i,m
				scale=scale+dabs(a(k,i))
			enddo
			if (scale.ne.0.0) then
				do k=i,m
					a(k,i)=a(k,i)/scale
					s=s+a(k,i)*a(k,i)
				enddo
				f=a(i,i)
				g=-dsign(dsqrt(s),f)
				h=f*g-s
				a(i,i)=f-g
				if (i.ne.n) then
					do j=l,n
						s=0.0
						do k=i,m
							s=s+a(k,i)*a(k,j)
						enddo
						f=s/h
						do k=i,m
							a(k,j)=a(k,j)+f*a(k,i)
						enddo
					enddo
				endif
				do k= i,m
					a(k,i)=scale*a(k,i)
				enddo
			endif
		endif
		w(i)=scale *g
		g=0.0
		s=0.0
		scale=0.0
		if ((i.le.m).and.(i.ne.n)) then
			do k=l,n
				scale=scale+dabs(a(i,k))
			enddo
			if (scale.ne.0.0) then
				do k=l,n
					a(i,k)=a(i,k)/scale
					s=s+a(i,k)*a(i,k)
				enddo
				f=a(i,l)
				g=-dsign(dsqrt(s),f)
				h=f*g-s
				a(i,l)=f-g
				do k=l,n
					rv1(k)=a(i,k)/h
				enddo
				if (i.ne.m) then
					do j=l,m
						s=0.0
						do k=l,n
							s=s+a(j,k)*a(i,k)
						enddo
						do k=l,n
							a(j,k)=a(j,k)+s*rv1(k)
						enddo
					enddo
				endif
				do k=l,n
					a(i,k)=scale*a(i,k)
				enddo
			endif
		endif
		anorm=dmax1(anorm,(dabs(w(i))+dabs(rv1(i))))
	enddo
	do i=n,1,-1
		if (i.lt.n) then
			if (g.ne.0.0) then
				do j=l,n
					v(j,i)=(a(i,j)/a(i,l))/g
				enddo
				do j=l,n
					s=0.0
					do k=l,n
						s=s+a(i,k)*v(k,j)
					enddo
					do k=l,n
						v(k,j)=v(k,j)+s*v(k,i)
					enddo
				enddo
			endif
			do j=l,n
				v(i,j)=0.0
				v(j,i)=0.0
			enddo
		endif
		v(i,i)=1.0
		g=rv1(i)
		l=i
	enddo
	do i=n,1,-1
		l=i+1
		g=w(i)
		if (i.lt.n) then
			do j=l,n
				a(i,j)=0.0
			enddo
		endif
		if (g.ne.0.0) then
			g=1.0/g
			if (i.ne.n) then
				do j=l,n
					s=0.0
					do k=l,m
						s=s+a(k,i)*a(k,j)
					enddo
					f=(s/a(i,i))*g
					do k=i,m
						a(k,j)=a(k,j)+f*a(k,i)
					enddo
				enddo
			endif
			do j=i,m
				a(j,i)=a(j,i)*g
			enddo
		else
			do j= i,m
				a(j,i)=0.0
			enddo
		endif
		a(i,i)=a(i,i)+1.0
	enddo
	do k=n,1,-1
		do its=1,30
			do l=k,1,-1
				nm=l-1
				if ((dabs(rv1(l))+anorm).eq.anorm)  go to 2
				if ((dabs(w(nm))+anorm).eq.anorm)  go to 1
			enddo
1			c=0.0
			s=1.0
			do i=l,k
				f=s*rv1(i)
				if ((dabs(f)+anorm).ne.anorm) then
					g=w(i)
					h=dsqrt(f*f+g*g)
					w(i)=h
					h=1.0/h
					c= (g*h)
					s=-(f*h)
					do j=1,m
						y=a(j,nm)
						z=a(j,i)
						a(j,nm)=(y*c)+(z*s)
						a(j,i)=-(y*s)+(z*c)
					enddo
				endif
			enddo
2			z=w(k)
			if (l.eq.k) then
				if (z.lt.0.0) then
					w(k)=-z
					do j=1,n
						v(j,k)=-v(j,k)
					enddo
				endif
				go to 3
			endif
			if (its.eq.30) pause 'nO CONVERGENCE IN 30 ITERATIONS'
			x=w(l)
			nm=k-1
			y=w(nm)
			g=rv1(nm)
			h=rv1(k)
			f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y)
			g=dsqrt(f*f+1.0)
			f=((x-z)*(x+z)+h*((y/(f+dsign(g,f)))-h))/x
			c=1.0
			s=1.0
			do j=l,nm
				i=j+1
				g=rv1(i)
				y=w(i)
				h=s*g
				g=c*g
				z=dsqrt(f*f+h*h)
				rv1(j)=z
				c=f/z
				s=h/z
				f= (x*c)+(g*s)
				g=-(x*s)+(g*c)
				h=y*s
				y=y*c
				do nm=1,n
					x=v(nm,j)
					z=v(nm,i)
					v(nm,j)= (x*c)+(z*s)
					v(nm,i)=-(x*s)+(z*c)
				enddo
				z=sqrt(f*f+h*h)
				w(j)=z
				if (z.ne.0.0) then
					z=1.0/z
					c=f*z
					s=h*z
				endif
				f= (c*g)+(s*y)
				x=-(s*g)+(c*y)
				do nm=1,m
					y=a(nm,j)
					z=a(nm,i)
					a(nm,j)= (y*c)+(z*s)
					a(nm,i)=-(y*s)+(z*c)
				enddo
			enddo
			rv1(l)=0.0
			rv1(k)=f
			w(k)=x
		enddo
3		continue
	enddo
	return
	end

      SUBROUTINE TPWRY (IERROR)
C
C LATEST REVISION	 JULY 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 ENTRY PWRITY OF PWRITY	AND
C			 TO TEST PWRITY	ON A SIMPLE PROBLEM
C
C USAGE			 CALL TPWRY (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST WAS	SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   PWRITY TEST SUCCESSFUL  . . . SEE PLOT TO
C			   VERIFY PERFORMANCE
C
C			 IS WRITTEN TO UNIT 6.
C			 IN ADDITION, ONE FRAME	CONTAINING
C			 CHARACTER STRING PLOTS	IS PRODUCED ON THE
C			 MACHINE GRAPHICS DEVICE.  IN ORDER TO
C			 DETERMINE WHETHER THE TEST WAS	SUCCESSFUL,
C			 IT IS NECESSARY TO EXAMINE THIS PLOT.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 PWRITY
C FILES
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 TPWRY CALLS PWRITY TO PLOT VARIOUS CHARACTER
C			 STRINGS USING DIFFERENT PARAMETERS.
C
C PORTABILITY		 ANSI FORTRAN 77
C
C
C INITIALIZE THE ERROR PARAMETER.
C
      IERROR = 0
C
C DEFINE NORMALIZATION TRANS 1 AND LOG SCALING
C
      CALL GSVP	(1, 0.0, 1.0, 0.0, 1.0)
      CALL GSWN	(1, 1.0, 1024.0, 1.0, 1024.0)
      CALL GSELNT (1)
      CALL SETUSV ('LS',1)
C
C LABEL	FRAME
C
      CALL PWRITY(512.0,950.0,
     1		  'DEMONSTRATION PLOT FOR PWRITY',
     2		  29,2,0,0)
C
C TEST PWRITY FOR DIFFERENT SIZE CHARACTERS.
C
      CALL PWRITY (10.0,900.0,'SIZE TEST',9,0,0,-1)
      CALL PWRITY (10.0,850.0,'SIZE TEST',9,1,0,-1)
      CALL PWRITY (10.0,775.0,'SIZE TEST',9,2,0,-1)
      CALL PWRITY (10.0,675.0,'SIZE TEST',9,3,0,-1)
      CALL PWRITY (10.0,525.0,'SIZE TEST',9,4,0,-1)
      CALL PWRITY (10.0,375.0,'SIZE TEST',9,5,0,-1)
C
C TEST PWRITY FOR DIFFERENT CHARACTER ORIENTATIONS.
C
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,0*90,-1)
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,1*90,-1)
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,2*90,-1)
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,3*90,-1)
C
C TEST CENTERING OPTIONS FOR PWRITY.
C
      CALL PWRITY (512.0,160.0,'CENTR TEST',10,2,0,0)
      CALL PWRITY (512.0,85.0,'CENTR TEST',10,2,0,-1)
      CALL PWRITY (512.0,235.0,'CENTR TEST',10,2,0,1)
c
c     CALL NEWFM
C
c      WRITE (6,1001)
      RETURN
C
c 1001 FORMAT ('	PWRITY TEST SUCCESSFUL',24X,
c     1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

#-h-  initkw			  549  local   12/01/80  15:54:11
# initkw - initialize tables and important global variables
   include  defs

   subroutine initkw

   include COMMON_BLOCKS

   pointer mktabl

   call dsinit (MEMSIZE)
   deftbl = mktabl (1)	   # symbol table for definitions
   call entdkw
   rkwtbl = mktabl (1)	   # symbol table for Ratfor key words
   call entrkw
   fkwtbl = mktabl (0)	   # symbol table for Fortran key words
   call entfkw
   namtbl = mktabl (1)	   # symbol table for long identifiers
   xpptbl = mktabl (1)	   # symbol table for xpp directives
   call entxkw
   gentbl = mktabl (0)	   # symbol table for generated identifiers
   errtbl = NULL	   # table of names to be error checked

   label = FIRST_LABEL	   # starting statement label
   smem(1) = EOS	   # haven't read in "mem.com" file yet
   body = NO		   # not in procedure body to start
   dbgout = NO		   # disable debug output by default
   dbglev = 0		   # file level if debug enabled
   memflg = NO		   # haven't declared mem common yet
   swinrg = NO		   # default range checking for switches
   col = 6

   return
   end

#-h-  skpblk			  247  local   12/01/80  15:55:04
# skpblk - skip blanks and tabs in current input file
   include  defs

   subroutine skpblk

   include COMMON_BLOCKS

   character c
   character ngetch

   for (c = ngetch (c); c == BLANK | c == TAB; c = ngetch (c))
      ;

   call putbak (c)
   return
   end

      SUBROUTINE KURV1S (N,X,Y,SLOP1,SLOPN,XP,YP,TEMP,S,SIGMA,ISLPSW)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C DIMENSION OF           X(N),Y(N),XP(N),YP(N),TEMP(N)
C ARGUMENTS
C
C LATEST REVISION        FEBRUARY 5, 1974
C
C PURPOSE                KURV1S DETERMINES THE PARAMETERS NECESSARY TO
C                        COMPUTE A SPLINE UNDER TENSION PASSING THROUGH
C                        A SEQUENCE OF PAIRS
C                        (X(1),Y(1)),...,(X(N),Y(N)) IN THE PLANE.
C                        THE SLOPES AT THE TWO ENDS OF THE CURVE MAY BE
C                        SPECIFIED OR OMITTED.  FOR ACTUAL COMPUTATION
C                        OF POINTS ON THE CURVE IT IS NECESSARY TO CALL
C                        THE SUBROUTINE KURV2S.
C
C USAGE                  CALL KURV1S(N,X,Y,SLP1,SLPN,XP,YP,TEMP,S,SIGMA)
C
C ARGUMENTS
C
C ON INPUT               N
C                          IS THE NUMBER OF POINTS TO BE INTERPOLATED
C                          (N .GE. 2).
C
C                        X
C                          IS AN ARRAY CONTAINING THE N X-COORDINATES
C                          OF THE POINTS.
C
C                        Y
C                          IS AN ARRAY CONTAINING THE N Y-COORDINATES
C                          OF THE POINTS.
C
C                        SLOP1 AND SLOPN
C                          CONTAIN THE DESIRED VALUES FOR THE SLOPE OF
C                          THE CURVE AT (X(1),Y(1)) AND (X(N),Y(N)),
C                          RESPECTIVELY.  THESE QUANTITIES ARE IN
C                          DEGREES AND MEASURED COUNTER-CLOCKWISE
C                          FROM THE POSITIVE X-AXIS.  IF ISLPSW IS NON-
C                          ZERO, ONE OR BOTH OF SLP1 AND SLPN MAY BE
C                          DETERMINED INTERNALLY BY KURV1S.
C
C                        XP AND YP
C                          ARE ARRAYS OF LENGTH AT LEAST N.
C
C                        TEMP
C                          IS AN ARRAY OF LENGTH AT LEAST N WHICH IS
C                          USED FOR SCRATCH STORAGE.
C
C                        SIGMA
C                          CONTAINS THE TENSION FACTOR.  THIS IS
C                          NON-ZERO AND INDICATES THE CURVINESS DESIRED.
C                          IF ABS(SIGMA) IS VERY LARGE (E.G., 50.) THE
C                          RESULTING CURVE IS VERY NEARLY A POLYGONAL
C                          LINE.  A STANDARD VALUE FOR SIGMA IS ABOUT 2.
C
C                        ISLPSW
C                          IS AN INTEGER INDICATING WHICH END SLOPES
C                          HAVE BEEN USER PROVIDED AND WHICH MUST BE
C                          COMPUTED BY KURV1S.  FOR ISLPSW
C                            = 0  INDICATES BOTH SLOPES ARE PROVIDED,
C                            = 1  ONLY SLOP1 IS PROVIDED,
C                            = 2  ONLY SLOPN IS PROVIDED,
C                            = 3  NEITHER SLOP1 NOR SLOPN IS PROVIDED.
C                            = 4  NEITHER SLOP1 NOR SLOPN IS PROVIDED,
C                                 BUT SLOP1=SLOPN.  IN THIS CASE X(1)=
C                                 X(N), Y(1)=Y(N) AND N.GE.3.
C ON OUTPUT              XP AND YP
C                          CONTAIN INFORMATION ABOUT THE CURVATURE OF
C                          THE CURVE AT THE GIVEN NODES.
C
C                        S
C                          CONTAINS THE POLYGONAL ARCLENGTH OF THE
C                          CURVE.
C
C                        N, X, Y, SLP1, SLPN, SIGMA AND ISLPSW ARE
C                        UNCHANGED.
C
C ENTRY POINTS           KURV1S
C
C SPECIAL CONDITIONS     NONE
C
C COMMON BLOCKS          NONE
C
C I/O                    NONE
C
C PRECISION              SINGLE
C
C REQUIRED ULIB          NONE
C ROUTINES
C
C SPECIALIST             RUSSELL K. REW, NCAR, BOULDER, COLORADO  80302
C
C LANGUAGE               FORTRAN
C
C HISTORY                ORIGINALLY WRITTEN BY A. K. CLINE, MARCH 1972.
C
C
C
C
      INTEGER         N
      REAL            X(N)       ,Y(N)       ,XP(N)      ,YP(N)      ,
     1                TEMP(N)    ,S          ,SIGMA
      SAVE
C
      DATA PI /3.1415926535897932/
C
      NN = N
      JSLPSW = ISLPSW
      SLP1 = SLOP1
      SLPN = SLOPN
      DEGRAD = PI/180.
      NM1 = NN-1
      NP1 = NN+1
      DELX1 = X(2)-X(1)
      DELY1 = Y(2)-Y(1)
      DELS1 = SQRT(DELX1*DELX1+DELY1*DELY1)
      DX1 = DELX1/DELS1
      DY1 = DELY1/DELS1
C
C DETERMINE SLOPES IF NECESSARY
C
      IF (JSLPSW .NE. 0) GO TO 70
   10 SLPP1 = SLP1*DEGRAD
      SLPPN = SLPN*DEGRAD
C
C SET UP RIGHT HAND SIDES OF TRIDIAGONAL LINEAR SYSTEM FOR XP
C AND YP
C
      XP(1) = DX1-COS(SLPP1)
      YP(1) = DY1-SIN(SLPP1)

      TEMP(1) = DELS1
      SS = DELS1
      IF (NN .EQ. 2) GO TO 30
      DO 20 I=2,NM1
         DELX2 = X(I+1)-X(I)
         DELY2 = Y(I+1)-Y(I)
         DELS2 = SQRT(DELX2*DELX2+DELY2*DELY2)
         DX2 = DELX2/DELS2
         DY2 = DELY2/DELS2
         XP(I) = DX2-DX1
         YP(I) = DY2-DY1
         TEMP(I) = DELS2
         DELX1 = DELX2
         DELY1 = DELY2
         DELS1 = DELS2
         DX1 = DX2
         DY1 = DY2
C
C ACCUMULATE POLYGONAL ARCLENGTH
C
         SS = SS+DELS1
   20 CONTINUE
   30 XP(NN) = COS(SLPPN)-DX1
      YP(NN) = SIN(SLPPN)-DY1
C
C DENORMALIZE TENSION FACTOR
C
      SIGMAP = ABS(SIGMA)*FLOAT(NN-1)/SS
C
C PERFORM FORWARD ELIMINATION ON TRIDIAGONAL SYSTEM
C
      S = SS
      DELS = SIGMAP*TEMP(1)
      EXPS = EXP(DELS)
      SINHS = .5*(EXPS-1./EXPS)
      SINHIN = 1./(TEMP(1)*SINHS)
      DIAG1 = SINHIN*(DELS*.5*(EXPS+1./EXPS)-SINHS)
      DIAGIN = 1./DIAG1
      XP(1) = DIAGIN*XP(1)
      YP(1) = DIAGIN*YP(1)
      SPDIAG = SINHIN*(SINHS-DELS)
      TEMP(1) = DIAGIN*SPDIAG
      IF (NN .EQ. 2) GO TO 50
      DO 40 I=2,NM1
         DELS = SIGMAP*TEMP(I)
         EXPS = EXP(DELS)
         SINHS = .5*(EXPS-1./EXPS)
         SINHIN = 1./(TEMP(I)*SINHS)
         DIAG2 = SINHIN*(DELS*(.5*(EXPS+1./EXPS))-SINHS)
         DIAGIN = 1./(DIAG1+DIAG2-SPDIAG*TEMP(I-1))
         XP(I) = DIAGIN*(XP(I)-SPDIAG*XP(I-1))
         YP(I) = DIAGIN*(YP(I)-SPDIAG*YP(I-1))
         SPDIAG = SINHIN*(SINHS-DELS)
         TEMP(I) = DIAGIN*SPDIAG
         DIAG1 = DIAG2
   40 CONTINUE
   50 DIAGIN = 1./(DIAG1-SPDIAG*TEMP(NM1))
      XP(NN) = DIAGIN*(XP(NN)-SPDIAG*XP(NM1))
      YP(NN) = DIAGIN*(YP(NN)-SPDIAG*YP(NM1))
C
C PERFORM BACK SUBSTITUTION
C
      DO 60 I=2,NN
         IBAK = NP1-I
         XP(IBAK) = XP(IBAK)-TEMP(IBAK)*XP(IBAK+1)
         YP(IBAK) = YP(IBAK)-TEMP(IBAK)*YP(IBAK+1)
   60 CONTINUE
      RETURN
   70 IF (NN .EQ. 2) GO TO 100
C
C IF NO SLOPES ARE GIVEN, USE SECOND ORDER INTERPOLATION ON
C INPUT DATA FOR SLOPES AT ENDPOINTS
C
      IF (JSLPSW .EQ. 4) GO TO 90
      IF (JSLPSW .EQ. 2) GO TO 80
      DELNM1 = SQRT((X(NN-2)-X(NM1))**2+(Y(NN-2)-Y(NM1))**2)
      DELN = SQRT((X(NM1)-X(NN))**2+(Y(NM1)-Y(NN))**2)
      DELNN = DELNM1+DELN
      C1 = (DELNN+DELN)/DELNN/DELN
      C2 = -DELNN/DELN/DELNM1
      C3 = DELN/DELNN/DELNM1
      SX = C3*X(NN-2)+C2*X(NM1)+C1*X(NN)
      SY = C3*Y(NN-2)+C2*Y(NM1)+C1*Y(NN)
C
      SLPN = ATAN2(SY,SX)/DEGRAD
   80 IF (JSLPSW .EQ. 1) GO TO 10
      DELS2 = SQRT((X(3)-X(2))**2+(Y(3)-Y(2))**2)
      DELS12 = DELS1+DELS2
      C1 = -(DELS12+DELS1)/DELS12/DELS1
      C2 = DELS12/DELS1/DELS2
      C3 = -DELS1/DELS12/DELS2
      SX = C1*X(1)+C2*X(2)+C3*X(3)
      SY = C1*Y(1)+C2*Y(2)+C3*Y(3)
C
      SLP1 = ATAN2(SY,SX)/DEGRAD
      GO TO 10
   90 DELN = SQRT((X(NM1)-X(NN))**2+(Y(NM1)-Y(NN))**2)
      DELNN = DELS1+DELN
      C1 = -DELS1/DELN/DELNN
      C2 = (DELS1-DELN)/DELS1/DELN
      C3 = DELN/DELNN/DELS1
      SX = C1*X(NM1)+C2*X(1)+C3*X(2)
      SY = C1*Y(NM1)+C2*Y(1)+C3*Y(2)
      IF (SX.EQ.0. .AND. SY.EQ.0.) SX = 1.
      SLP1 = ATAN2(SY,SX)/DEGRAD
      SLPN = SLP1
      GO TO 10
C
C IF ONLY TWO POINTS AND NO SLOPES ARE GIVEN, USE STRAIGHT
C LINE SEGMENT FOR CURVE
C
  100 IF (JSLPSW .NE. 3) GO TO 110
      XP(1) = 0.
      XP(2) = 0.
      YP(1) = 0.
      YP(2) = 0.
C
      SLP1 = ATAN2(Y(2)-Y(1),X(2)-X(1))/DEGRAD
      SLPN = SLP1
      RETURN
C
  110 IF (JSLPSW .EQ. 2)
     1    SLP1 = ATAN2(Y(2)-Y(1)-SLPN*(X(2)-X(1)),
     2                                X(2)-X(1)-SLPN*(Y(2)-Y(1)))/DEGRAD
C
      IF (JSLPSW .EQ. 1)
     1    SLPN = ATAN2(Y(2)-Y(1)-SLP1*(X(2)-X(1)),
     2                                X(2)-X(1)-SLP1*(Y(2)-Y(1)))/DEGRAD
      GO TO 10
      END
      SUBROUTINE KURV2S (T,XS,YS,N,X,Y,XP,YP,S,SIGMA,NSLPSW,SLP)
C
C
C
C DIMENSION OF           X(N),Y(N),XP(N),YP(N)
C ARGUMENTS
C
C LATEST REVISION        OCTOBER 22, 1973
C
C PURPOSE                KURV2S PERFORMS THE MAPPING OF POINTS IN THE
C                        INTERVAL (0.,1.) ONTO A CURVE IN THE PLANE.
C                        THE SUBROUTINE KURV1S SHOULD BE CALLED EARLIER
C                        TO DETERMINE CERTAIN NECESSARY PARAMETERS.
C                        THE RESULTING CURVE HAS A PARAMETRIC
C                        REPRESENTATION BOTH OF WHOSE COMPONENTS ARE
C                        SPLINES UNDER TENSION AND FUNCTIONS OF THE
C                        POLYGONAL ARCLENGTH PARAMETER.
C
C ACCESS CARDS           *FORTRAN,S=ULIB,N=KURV
C                        *COSY
C
C USAGE                  CALL KURV2S (T,XS,YS,N,X,Y,XP,YP,S,SIGMA)
C
C ARGUMENTS
C
C ON INPUT               T
C                          CONTAINS A REAL VALUE OF ABSOLUTE VALUE LESS
C                          THAN OR EQUAL TO 1. TO BE MAPPED TO A POINT
C                          ON THE CURVE.  THE SIGN OF T IS IGNORED AND
C                          THE INTERVAL (0.,1.) IS MAPPED ONTO THE
C                          ENTIRE CURVE.  IF T IS NEGATIVE, THIS
C                          INDICATES THAT THE SUBROUTINE HAS BEEN CALLED
C                          PREVIOUSLY (WITH ALL OTHER INPUT VARIABLES
C                          UNALTERED) AND THAT THIS VALUE OF T EXCEEDS
C                          THE PREVIOUS VALUE IN ABSOLUTE VALUE.  WITH
C                          SUCH INFORMATION THE SUBROUTINE IS ABLE TO
C                          MAP THE POINT MUCH MORE RAPIDLY.  THUS IF THE
C                          USER SEEKS TO MAP A SEQUENCE OF POINTS ONTO
C                          THE SAME CURVE, EFFICIENCY IS GAINED BY
C                          ORDERING THE VALUES INCREASING IN MAGNITUDE
C                          AND SETTING THE SIGNS OF ALL BUT THE FIRST
C                          NEGATIVE.
C
C                        N
C                          CONTAINS THE NUMBER OF POINTS WHICH WERE
C                          INTERPOLATED TO DETERMINE THE CURVE.
C
C                        X AND Y
C                          ARRAYS CONTAINING THE X- AND Y-COORDINATES
C                          OF THE INTERPOLATED POINTS.
C
C                        XP AND YP
C                          ARE THE ARRAYS OUTPUT FROM KURV1 CONTAINING
C                          CURVATURE INFORMATION.
C
C                        S
C                          CONTAINS THE POLYGONAL ARCLENGTH OF THE
C                          CURVE.
C
C                        SIGMA
C                          CONTAINS THE TENSION FACTOR (ITS SIGN IS
C                          IGNORED).
C
C                        NSLPSW
C                          IS AN INTEGER SWITCH WHICH TURNS ON OR OFF
C                          THE CALCULATION OF SLP
C                          NSLPSW
C                                 = 0 INDICATES THAT SLP WILL NOT BE
C                                     CALCULATED
C                                 = 1 SLP WILL BE CALCULATED
C
C                        THE PARAMETERS N, X, Y, XP, YP, S AND SIGMA
C                        SHOULD BE INPUT UNALTERED FROM THE OUTPUT OF
C                        KURV1S.
C
C ON OUTPUT              XS AND YS
C                          CONTAIN THE X- AND Y-COORDINATES OF THE IMAGE
C                          POINT ON THE CURVE.
C
C                        SLP
C                          CONTAINS THE SLOPE OF THE CURVE IN DEGREES AT
C                          THIS POINT.
C
C                        T, N, X, Y, XP, YP, S AND SIGMA ARE UNALTERED.
C
C ENTRY POINTS           KURV2S
C
C SPECIAL CONDITIONS     NONE
C
C COMMON BLOCKS          NONE
C
C I/O                    NONE
C
C PRECISION              SINGLE
C
C REQUIRED ULIB          NONE
C ROUTINES
C
C SPECIALIST             RUSSELL K. REW, NCAR, BOULDER, COLORADO  80302
C
C LANGUAGE               FORTRAN
C
C HISTORY                ORIGINALLY WRITTEN BY A. K. CLINE, MARCH 1972.
C
C
C
C
      INTEGER         N
      REAL            T          ,XS         ,YS         ,X(N)       ,
     1                Y(N)       ,XP(N)      ,YP(N)      ,S          ,
     2                SIGMA      ,SLP
      SAVE
C
      DATA PI /3.1415926535897932/
C
C
C DENORMALIZE SIGMA
C
      SIGMAP = ABS(SIGMA)*FLOAT(N-1)/S
C
C STRETCH UNIT INTERVAL INTO ARCLENGTH DISTANCE
C
      TN = ABS(T*S)
C
C FOR NEGATIVE T START SEARCH WHERE PREVIOUSLY TERMINATED,
C OTHERWISE START FROM BEGINNING
C
      IF (T .LT. 0.) GO TO 10
      DEGRAD = PI/180.
      I1 = 2
      XS = X(1)
      YS = Y(1)
      SUM = 0.
      IF (T .LT. 0.) RETURN
C
C DETERMINE INTO WHICH SEGMENT TN IS MAPPED
C
   10 DO 30 I=I1,N
         DELX = X(I)-X(I-1)
         DELY = Y(I)-Y(I-1)
         DELS = SQRT(DELX*DELX+DELY*DELY)
         IF (SUM+DELS-TN) 20,40,40
   20    SUM = SUM+DELS
   30 CONTINUE
C
C IF ABS(T) IS GREATER THAN 1., RETURN TERMINAL POINT ON
C CURVE
C
      XS = X(N)
      YS = Y(N)
      RETURN
C
C SET UP AND PERFORM INTERPOLATION
C
   40 DEL1 = TN-SUM
      DEL2 = DELS-DEL1
      EXPS1 = EXP(SIGMAP*DEL1)
      SINHD1 = .5*(EXPS1-1./EXPS1)
      EXPS2 = EXP(SIGMAP*DEL2)
      SINHD2 = .5*(EXPS2-1./EXPS2)
      EXPS = EXPS1*EXPS2
      SINHS = .5*(EXPS-1./EXPS)
      XS = (XP(I)*SINHD1+XP(I-1)*SINHD2)/SINHS+
     1     ((X(I)-XP(I))*DEL1+(X(I-1)-XP(I-1))*DEL2)/DELS
      YS = (YP(I)*SINHD1+YP(I-1)*SINHD2)/SINHS+
     1     ((Y(I)-YP(I))*DEL1+(Y(I-1)-YP(I-1))*DEL2)/DELS
      I1 = I
      IF (NSLPSW .EQ. 0) RETURN
      COSHD1 = .5*(EXPS1+1./EXPS1)*SIGMAP
      COSHD2 = .5*(EXPS2+1./EXPS2)*SIGMAP
      XT = (XP(I)*COSHD1-XP(I-1)*COSHD2)/SINHS+
     1     ((X(I)-XP(I))-(X(I-1)-XP(I-1)))/DELS
      YT = (YP(I)*COSHD1-YP(I-1)*COSHD2)/SINHS+
     1     ((Y(I)-YP(I))-(Y(I-1)-YP(I-1)))/DELS
      SLP = ATAN2(YT,XT)/DEGRAD
      RETURN
      END

      subroutine splopt ( tau, n, k, scrtch, t, iflag )
c  from  * a practical guide to splines *  by c. de boor
calls bsplvb, banfac/slv
computes the knots  t  for the optimal recovery scheme of order  k
c  for data at	tau(i), i=1,...,n .
c
c******  i n p u t  ******
c  tau.....array of length  n , containing the interpolation points.
c     a s s u m e d  to be nondecreasing, with tau(i).lt.tau(i+k),all i.
c  n.....number of data points .
c  k.....order of the optimal recovery scheme to be used .
c
c******  w o r k  a r r a y  *****
c  scrtch.....array of length  (n-k)(2k+3) + 5k + 3 . the various
c	 contents are specified in the text below .
c
c******  o u t p u t  ******
c  iflag.....integer indicating success (=1) or failure (=2) .
c     if iflag = 1, then
c  t.....array of length  n+k  containing the optimal knots ready for
c	 use in optimal recovery. specifically,  t(1) = ... = t(k) =
c	 tau(1)  and  t(n+1) = ... = t(n+k) = tau(n) , while the  n-k
c	 interior knots  t(k+1), ..., t(n)  are calculated as described
c	 below under  *method* .
c     if iflag = 2, then
c	 k .lt. 3, or n .lt. k, or a certain linear system was found to
c	 be singular.
c
c******  p r i n t e d	o u t p u t  ******
c  a comment will be printed in case  ilfag = 2  or newton iterations
c  failed to converge in  n e w t m x  iterations .
c
c******  m e t h o d  ******
c     the (interior) knots  t(k+1), ..., t(n)  are determined by newtons
c  method in such a way that the signum function which changes sign at
c   t(k+1), ..., t(n)  and nowhere else in  (tau(1),tau(n)) is orthogon-
c  al to the spline space  spline( k , tau )  on that interval .
c     let  xi(j)  be the current guess for  t(k+j), j=1,...,n-k. then
c  the next newton iterate is of the form
c	       xi(j)  +  (-)**(n-k-j)*x(j)  ,  j=1,...,n-k,
c  with  x  the solution of the linear system
c			 c*x  =  d  .
c  here,  c(i,j) = b(i)(xi(j)), all j, with  b(i)  the i-th b-spline of
c  order  k  for the knot sequence  tau , all i, and  d  is the vector
c  given by  d(i) = sum( -a(j) , j=i,...,n )*(tau(i+k)-tau(i))/k, all i,
c  with  a(i) = sum ( (-)**(n-k-j)*b(i,k+1,tau)(xi(j)) , j=1,...,n-k )
c  for i=1,...,n-1, and  a(n) = -.5 .
c     (see chapter  xiii  of text and references there for a derivation)
c     the first guess for  t(k+j)  is  (tau(j+1)+...+tau(j+k-1))/(k-1) .
c     iteration terminates if  max(abs(x(j))) .lt. t o l  , with
c		  t o l  =  t o l r t e *(tau(n)-tau(1))/(n-k) ,
c  or else after  n e w t m x  iterations , currently,
c		  newtmx, tolrte / 10, .000001
c
      integer iflag,k,n,   i,id,index,j,km1,kpk,kpkm1,kpn,kp1,l,left
     *,leftmk,lenw,ll,llmax,llmin,na,nb,nc,nd,newtmx,newton,nmk,nmkm1,nx
      real scrtch(1),t(1),tau(n),   del,delmax,floatk,sign,signst,sum
     *				   ,tol,tolrte,xij
c     dimension scrtch((n-k)*(2*k+3)+5*k+3), t(n+k)
current fortran standard makes it impossible to specify the precise dim-
c  ensions of  scrtch  and  t  without the introduction of otherwise
c  superfluous additional arguments .
      data newtmx,tolrte / 10,.000001/
      nmk = n-k
      if (nmk)				1,56,2
    1 print 601,n,k
  601 format(13h argument n =,i4,29h in  splopt  is less than k =,i3)
					go to 999
    2 if (k .gt. 2)			go to 3
      print 602,k
  602 format(13h argument k =,i3,27h in  splopt  is less than 3)
					go to 999
   3  nmkm1 = nmk - 1
      floatk = k
      kpk = k+k
      kp1 = k+1
      km1 = k-1
      kpkm1 = kpk-1
      kpn = k+n
      signst = -1.
      if (nmk .gt. (nmk/2)*2)  signst = 1.
c  scrtch(i) = tau-extended(i), i=1,...,n+k+k
      nx = n+kpk+1
c  scrtch(i+nx) = xi(i),i=0,...,n-k+1
      na = nx + nmk + 1
c  scrtch(i+na) = -a(i), i=1,...,n
      nd = na + n
c  scrtch(i+nd) = x(i) or d(i), i=1,...,n-k
      nb = nd + nmk
c  scrtch(i+nb) = biatx(i),i=1,...,k+1
      nc = nb + kp1
c  scrtch(i+(j-1)*(2k-1) + nc) = w(i,j) = c(i-k+j,j), i=j-k,...,j+k,
c						      j=1,...,n-k.
      lenw = kpkm1*nmk
c  extend  tau	to a knot sequence and store in scrtch.
      do 5 j=1,k
	 scrtch(j) = tau(1)
    5	 scrtch(kpn+j) = tau(n)
      do 6 j=1,n
    6	 scrtch(k+j) = tau(j)
c  first guess for  scrtch (.+nx)  =  xi .
      scrtch(nx) = tau(1)
      scrtch(nmk+1+nx) = tau(n)
      do 10 j=1,nmk
	 sum = 0.
	 do 9 l=1,km1
    9	    sum = sum + tau(j+l)
   10	 scrtch(j+nx) = sum/float(km1)
c  last entry of  scrtch (.+na)  =  - a  is always ...
      scrtch(n+na) = .5
c  start newton iteration.
      newton = 1
      tol = tolrte*(tau(n) - tau(1))/float(nmk)
c  start newton step
compute the 2k-1 bands of the matrix c and store in scrtch(.+nc),
c  and compute the vector  scrtch(.+na) = -a.
   20 do 21 i=1,lenw
   21	 scrtch(i+nc) = 0.
      do 22 i=2,n
   22	 scrtch(i-1+na) = 0.
      sign = signst
      left = kp1
      do 28 j=1,nmk
	 xij = scrtch(j+nx)
   23	    if (xij .lt. scrtch(left+1))go to 25
	    left = left + 1
	    if (left .lt. kpn)		go to 23
	    left = left - 1
   25	 call bsplvb(scrtch,k,1,xij,left,scrtch(1+nb))
c	 the tau sequence in scrtch is preceded by  k  additional knots
c	 therefore,  scrtch(ll+nb)  now contains  b(left-2k+ll)(xij)
c	 which is destined for	c(left-2k+ll,j), and therefore for
c	     w(left-k-j+ll,j)= scrtch(left-k-j+ll + (j-1)*kpkm1 + nc)
c	 since we store the 2k-1 bands of  c  in the 2k-1  r o w s  of
c	 the work array w, and	w  in turn is stored in  s c r t c h ,
c	 with  w(1,1) = scrtch(1 + nc) .
c	     also, c  being of order  n-k, we would want  1 .le.
c	 left-2k+ll .le. n-k  or
c	    llmin = 2k-left  .le.  ll  .le.  n-left+k = llmax .
	 leftmk = left-k
	 index = leftmk-j + (j-1)*kpkm1 + nc
	 llmin = max0(1,k-leftmk)
	 llmax = min0(k,n-leftmk)
	 do 26 ll=llmin,llmax
   26	    scrtch(ll+index) = scrtch(ll+nb)
	 call bsplvb(scrtch,kp1,2,xij,left,scrtch(1+nb))
	 id = max0(0,leftmk-kp1)
	 llmin = 1 - min0(0,leftmk-kp1)
	 do 27 ll=llmin,kp1
	    id = id + 1
   27	     scrtch(id+na) = scrtch(id+na) - sign*scrtch(ll+nb)
   28	 sign = -sign
      call banfac(scrtch(1+nc),kpkm1,nmk,km1,km1,iflag)
					go to (45,44),iflag
   44 print 644
  644 format(32h c in  splopt  is not invertible)
					return
compute  scrtch (.+nd) =  d  from  scrtch (.+na) = - a .
   45 i=n
   46	 scrtch(i-1+na) = scrtch(i-1+na) + scrtch(i+na)
	 i = i-1
	 if (i .gt. 1)			go to 46
      do 49 i=1,nmk
   49	 scrtch(i+nd) = scrtch(i+na)*(tau(i+k)-tau(i))/floatk
compute  scrtch (.+nd) =  x .
      call banslv(scrtch(1+nc),kpkm1,nmk,km1,km1,scrtch(1+nd))
compute  scrtch (.+nd) = change in  xi . modify, if necessary, to
c  prevent new	xi  from moving more than 1/3 of the way to its
c  neighbors. then add to  xi  to obtain new  xi  in scrtch(.+nx).
      delmax = 0.
      sign = signst
      do 53 i=1,nmk
	 del = sign*scrtch(i+nd)
	 delmax = amax1(delmax,abs(del))
	 if (del .gt. 0.)		go to 51
	 del = amax1(del,(scrtch(i-1+nx)-scrtch(i+nx))/3.)
					go to 52
   51	 del = amin1(del,(scrtch(i+1+nx)-scrtch(i+nx))/3.)
   52	 sign = -sign
   53	 scrtch(i+nx) = scrtch(i+nx) + del
call it a day in case change in  xi  was small enough or too many
c  steps were taken.
      if (delmax .lt. tol)		go to 54
      newton = newton + 1
      if (newton .le. newtmx)		go to 20
      print 653,newtmx
  653 format(33h no convergence in  splopt  after,i3,14h newton steps.)
   54 do 55 i=1,nmk
   55	 t(k+i) = scrtch(i+nx)
   56 do 57 i=1,k
	 t(i) = tau(1)
   57	 t(n+i) = tau(n)
					return
  999 iflag = 2
					return
      end

      subroutine l2err ( prfun , ftau , error )
c  from  * a practical guide to splines *  by c. de boor
c  this routine is to be called in the main program  l 2 m a i n .
calls subprogram  ppvalu(interv)
c  this subroutine computes various errors of the current l2-approxi-
c  mation , whose pp-repr. is contained in common block  approx  ,
c  to the given data contained in common block	data . it prints out
c  the average error  e r r l 1 , the l2-error	e r r l 2,  and the
c  maximum error  e r r m a x .
c
c******  i n p u t  ******
c  prfun  a hollerith string.  if prfun = 2hon, the routine prints out
c	   the value of the approximation as well as its error at
c	   every data point.
c
c******  o u t p u t  ******
c  ftau(1), ..., ftau(ntau),  with  ftau(i)  the approximation	f at
c	   tau(i), all i.
c  error(1), ..., error(ntau),	with  error(i) = scale*(g - f)
c	   at tau(i), all i. here,  s c a l e  equals  1. in case
c	   prfun .ne. 2hon , or the abs.error is greater than 100 some-
c	   where. otherwise, s c a l e	is such that the maximum of
c	   abs(error))	over all  i  lies between  10  and  100. this
c	   makes the printed output more illustrative.
c
      integer prfun,   ie,k,l,ll,ntau,on
      real ftau(1),error(1),  break,coef,err,errmax,errl1,errl2
     *			     ,gtau,scale,tau,totalw,weight
c     dimension ftau(ntau),error(ntau)
      real ppvalu
c     parameter lpkmax=100,ntmax=200,ltkmax=2000
c     common / data / ntau, tau(ntmax),gtau(ntmax),weight(ntmax),totalw
c     common /approx/ break(lpkmax),coef(ltkmax),l,k
      common / data / ntau, tau(200),gtau(200),weight(200),totalw
      common /approx/ break(100),coef(2000),l,k
      data on /2hon /
      errl1 = 0.
      errl2 = 0.
      errmax = 0.
      do 10 ll=1,ntau
	 ftau(ll) = ppvalu (break, coef, l, k, tau(ll), 0 )
	 error(ll) = gtau(ll) - ftau(ll)
	 err = abs(error(ll))
	 if (errmax .lt. err)	errmax = err
	 errl1 = errl1 + err*weight(ll)
   10	 errl2 = errl2 + err**2*weight(ll)
      errl1 = errl1/totalw
      errl2 = sqrt(errl2/totalw)
      print 615,errl2,errl1,errmax
  615 format(///21h least square error =,e20.6/
     1		21h average error      =,e20.6/
     2		21h maximum error      =,e20.6//)
      if (prfun .ne. on)		return
c     **  scale error curve and print  **
      ie = 0
      scale = 1.
      if (errmax .ge. 10.)		go to 18
      do 17 ie=1,9
	 scale = scale*10.
	 if (errmax*scale .ge. 10.)	go to 18
   17	 continue
   18 do 19 ll=1,ntau
   19	 error(ll) = error(ll)*scale
      print 620,ie,(ll,tau(ll),ftau(ll),error(ll),ll=1,ntau)
  620 format(///14x,36happroximation and scaled error curve/7x,
     110hdata point,7x,13happroximation,3x,16hdeviation x 10**,i1/
     2(i4,f16.8,f16.8,f17.6))
					return
      end

C--------------------------------------------------------------------------
        subroutine ftbdef(ounit,nfield,tform,pcount,nrows,status)

C       Binary table data DEFinition
C       define the structure of the binary table data unit
C
C       ounit   i  Fortran I/O unit number
C       nfield  i  number of fields in the table
C       tform   C  the data format of the column
C       nrows   i  number of rows in the table
C       pcount  i  size in bytes of the special data block following the table
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,nfield,nrows,pcount,status
        character*(*) tform(*)

C-------COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne,nf
        parameter (nb = 20)
        parameter (ne = 200)
        parameter (nf = 3000)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character cnull*16, cform*8
        common/ft0003/cnull(nf),cform(nf)
C-------END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff,i,j,width

        if (status .gt. 0)return

        ibuff=bufnum(ounit)

        if (dtstrt(ibuff) .lt. 0)then
C               freeze the header at its current size
                call fthdef(ounit,0,status)
                if (status .gt. 0)return
        end if

        hdutyp(ibuff)=2
        tfield(ibuff)=nfield

        if (nxtfld + nfield .gt. nf)then
C               too many columns open at one time; exceeded array dimensions
                status=111
                return
        end if

        tstart(ibuff)=nxtfld
        nxtfld=nxtfld+nfield

        if (nfield .eq. 0)then
C           no data; the next HDU begins in the next logical block 
            hdstrt(ibuff,chdu(ibuff)+1)=dtstrt(ibuff)
            scount(ibuff)=0
            theap(ibuff)=0
            nxheap(ibuff)=0
        else
C           initialize the table column parameters
            do 5 i=1,nfield
                tscale(i+tstart(ibuff))=1.
                tzero(i+tstart(ibuff))=0.
C               choose special value to indicate that null value is not defined
                tnull(i+tstart(ibuff))=123454321
C               reset character NUL string, in case it has been 
C               previously defined from an ASCII table extension
                cnull(i+tstart(ibuff))=char(0)

C               parse the tform strings to get the data type and repeat count
                call ftbnfm(tform(i),tdtype(i+tstart(ibuff)),
     &                      trept(i+tstart(ibuff)),width,status)
                if (tdtype(i+tstart(ibuff)) .eq. 1)then
C                  treat Bit datatype as if it were a Byte datatype
                   tdtype(i+tstart(ibuff))=11
                   trept(i+tstart(ibuff))=(trept(i+tstart(ibuff))+7)/8
                else if (tdtype(i+tstart(ibuff)) .eq. 16)then
C                       store ASCII unit string length in TNULL parameter
                        tnull(i+tstart(ibuff))=width
                end if
                if (status .gt. 0)return
5           continue

C           determine byte offset of the beginning of each field and row length
            call ftgtbc(nfield,tdtype(1+tstart(ibuff)),trept(1+
     &           tstart(ibuff)),tbcol(1+tstart(ibuff)),rowlen(ibuff),
     &                  status)

C           FITSIO deals with ASCII columns as arrays of strings, not
C           arrays of characters, so need to change the repeat count
C           to indicate the number of strings in the field, not the 
C           total number of characters in the field.
            do 10 i=1,nfield
                if (tdtype(i+tstart(ibuff)) .eq. 16)then
                    j=trept(i+tstart(ibuff))/tnull(i+tstart(ibuff))
                    trept(i+tstart(ibuff))=max(j,1)
                end if
10          continue

C           initialize the heap offset (=nrows x ncolumns)
C           store the size of the special data area, if any
            scount(ibuff)=pcount
            theap(ibuff)=nrows*rowlen(ibuff)
            nxheap(ibuff)=0

C           calculate the start of the next header unit, based on the
C           size of the data unit (table + special data)
            hdstrt(ibuff,chdu(ibuff)+1)=
     &       dtstrt(ibuff)+(rowlen(ibuff)*nrows+pcount+2879)/2880*2880
        end if
        end

C--------------------------------------------------------------------------
        subroutine ftghsp(ounit,nexist,nmore,status)

C       Get Header SPace
C       return the number of additional keywords that will fit in the header
C
C       ounit   i  Fortran I/O unit number
C       nexist  i  number of keywords already present in the CHU
C       nmore   i  number of additional keywords that will fit in header
C                 -1 indicates that there is no limit to the number of keywords
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,nexist,nmore,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------
        
        integer ibuff
        if (status .gt. 0)return
        ibuff=bufnum(ounit)

        nexist=(hdend(ibuff)-hdstrt(ibuff,chdu(ibuff)))/80
        if (dtstrt(ibuff) .lt. 0)then
C               the max size of the header has not been defined, so there
C               is no limit to the number of keywords which may be written.
                nmore=-1                
        else
                nmore=(dtstrt(ibuff)-hdend(ibuff))/80-1
        end if
        end

include	defs

# BEGINC -- Code that gets executed when the "begin" statement is encountered,
# at the beginning of the executable section of a procedure.


subroutine beginc

integer	labgen
include COMMON_BLOCKS

	body = YES				# in body of procedure
	ername = NO				# errchk name not encountered
	esp = 0					# error stack pointer
	label = FIRST_LABEL			# start over with labels
	retlab = labgen (1)			# label for return stmt
	logical_column = 6 + INDENT
	col = logical_column
end

C----------------------------------------------------------------------
        subroutine ftbnfm(form,dtype,rcount,width,status)

C       'Binary Format'
C       parse the binary table column format to determine the data
C       type and the repeat count (and string width, if it is an ASCII field)
C
C       form    c  format string
C       OUTPUT PARAMETERS:
C       dattyp  i  datatype code
C       rcount  i  repeat count
C       width   i  if ASCII field, this is the width of the unit string
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) form
        integer dtype,rcount,width,status,tstat
        character dattyp*1,cform*16
        integer point,nc,c1,i,nw

        if (status .gt. 0)return

        cform=form

C       find first non-blank character
        nc=len(form)
        do 5 i=1,nc
                if (form(i:i) .ne. ' ')then
                        c1=i
                        go to 10
                end if
5       continue

C       error: TFORM is a blank string
        status=261
        call ftpmsg('The TFORM keyword has a blank value.')
        return

10      continue

C       find the size of the field repeat count, if present
        nw=0
        do 20 i=c1,nc
                if (form(i:i) .ge. '0' .and. form(i:i) .le. '9')then
                        nw=nw+1
                else
                        go to 30
                end if
20      continue
30      continue
        if (nw .eq. 0)then
C               no explicit repeat count, so assume a value of 1
                rcount=1
        else
                call ftc2ii(form(c1:c1+nw-1),rcount,status)
                if (status .gt. 0)then
                   call ftpmsg('Error in FTBNFM evaluating TFORM'
     &             //' repeat value: '//cform)
                   return
                 end if
        end if

        c1=c1+nw

C       see if this is a variable length pointer column (e.g., 'rPt'); if so,
C       then add 1 to the starting search position in the TFORM string
        if (form(c1:c1) .eq. 'P')then
                point=-1
                c1=c1+1
                rcount=1
        else
                point=1
        end if

C       now the chararcter at position c1 should be the data type code
        dattyp=form(c1:c1)

C       set the numeric datatype code
        if (dattyp .eq. 'I')then
                dtype=21
        else if (dattyp .eq. 'J')then
                dtype=41
        else if (dattyp .eq. 'E')then
                dtype=42
        else if (dattyp .eq. 'D')then
                dtype=82
        else if (dattyp .eq. 'A')then
                dtype=16
        else if (dattyp .eq. 'L')then
                dtype=14
        else if (dattyp .eq. 'X')then
                dtype=1
        else if (dattyp .eq. 'B')then
                dtype=11
        else if (dattyp .eq. 'C')then
                dtype=83
        else if (dattyp .eq. 'M')then
                dtype=163
        else
C               unknown tform datatype code
                status=262
                call ftpmsg('Unknown Binary table TFORMn keyword '//
     &                      'datatype: '//cform)
                return
        end if
                
C       set dtype negative if this is a variable length field ('P')
        dtype=dtype*point

C       if this is an ASCII field, determine its width
        if (dtype .eq. 16)then
                c1=c1+1
                nw=0
                do 40 i=c1,nc
                    if (form(i:i) .ge. '0' .and. form(i:i).le.'9')then
                        nw=nw+1
                else
                        go to 50
                end if
40              continue
50              continue
                if (nw .eq. 0)then
C                       no explicit width field, so assume that the
C                       width is the same as the repeat count
                        width=rcount
                else
                        tstat=status
                        call ftc2ii(form(c1:c1+nw-1),width,status)
                        if (status .gt. 0)then
C                       unrecognized characters following the 'A', so ignore it
                               width=rcount
                               status=tstat
                        end if
                end if
        end if
        end

      SUBROUTINE TDASHP	(IERROR)
C
C LATEST REVISION	 JUNE 1984
C
C PURPOSE		 TO PROVIDE A DEMONSTRATION OF DASHSUPR
C			 AND TO	TEST DASHSUPR ON A SIMPLE PROBLEM
C
C USAGE			 CALL TDASHP (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   = 0,	IF THE TEST IS SUCCESSFUL,
C			   = 1,	OTHERWISE
C
C I/O			 IF THE	TEST IS	SUCCESSFUL, THE	MESSAGE
C
C			   DASHSUPR TEST SUCCESSFUL  . . .  SEE	PLOT
C			   TO VERIFY PERFORMANCE
C
C			 IS PRINTED ON UNIT 6.
C
C			 IN ADDITION, ONE FRAME	CONTAINING THE
C			 DASHED	LINE PLOT IS PRODUCED ON THE
C			 MACHINE GRAPHICS DEVICE.  TO DETERMINE
C			 IF THE	TEST IS	SUCCESSFUL, IT IS NECESSARY
C			 TO EXAMINE THIS PLOT.
C
C PRECISION		 SINGLE
C
C REQUIRED LIBRARY	 DASHSUPR
C FILES
C
C LANGUAGE		 FORTRAN
C
C ALGORITHM		 TDASHP	UTILIZES THE SOFTWARE DASHSUPR
C			 SUBROUTINES DASHDB, DASHDC, FRSTD,
C			 VECTD,	LASTD, LINED AND CURVED	TO
C			 DRAW FIVE CURVES ON ONE PICTURE USING
C			 FIVE DIFFERENT	DASHSMTH PATTERNS.  EACH
C			 CURVE IS CENTERED ABOUT SOLID AXIS LINES AND
C			 LABELLED WITH THE CHARACTER REPRESENTATION OF
C			 THE DASHSUPR PATTERN USED.
C
C PORTABILITY		 FORTRAN 77
C
C X CONTAINS ABSCISSAE VALUES OF THE CURVE TO BE PLOTTED, Y CONTAINS
C ORDINATE VALUES OF THE CURVE TO BE PLOTTED.
C
      DIMENSION	      X(31)	 ,Y(31)
C
C SELECT NORMALIZATION TRANSFORMATION 0
C
      CALL GSELNT(0)
C
C RESET	 INITIALIZES THE MODEL PICTURE ARRAY AND SHOULD	BE CALLED WITH
C EACH NEW FRAME AND BEFORE THE	OTHER SUBROUTINES OF THE DASHSUPR
C PACKAGE.
C
      CALL RESET
C
C
C SET SOLID DASH PATTERN,  1111111111111111 (BINARY).
C BOOLEAN OPERATIONS (EMPLOYING	LOCALLY	IMPLEMENTED PLOT PACKAGE
C SUPPORT ROUTINES) ARE	USED FOR PORTABILITY TO	HOSTS WITH 16 BIT
C INTEGERS.
C
      ISOLID = IOR (ISHIFT (32767,1), 1)
C
      DO 130 K=1,5
	 CALL DASHDB (ISOLID)
	 ORG =1.07-0.195*K
C
C	DRAW CENTRAL AXIS FOR EACH CURVE
C
	 CALL FRSTD (.50,ORG-0.03)
	 CALL VECTD (.50,ORG+0.03)
	 CALL LASTD
	 CALL LINED (.109,ORG,.891,ORG)
C
C CALL SUBROUTINE DASHDC WITH A	DIFFERENT DASHED LINE AND CHARACTER
C COMBINATION FOR EACH OF FIVE CURVES
C
	 GO TO ( 10, 20, 30, 40, 50),K
   10	 CALL DASHDC ('$''$''$''$''$''$''$''$K = 1',10,12)
	 GO TO	60
   20	 CALL DASHDC ('$$$$$$''$''$$$$$$K = 2',10,12)
	 GO TO	60
   30	 CALL DASHDC ('$$$$''$$$$''$$$$''K = 3',10,12)
	 GO TO	60
   40	 CALL DASHDC ('$$$$$''''''''''$$$$$K = 4',10,12)
	 GO TO	60
   50	 CALL DASHDC ('$$$''$$$''$$$''$$$K = 5',10,12)
   60	 CONTINUE
C
C	COMPUTE	VALUES FOR AND DRAW THE	KTH CURVE
C
	 DO  70	I=1,31
	    THETA = FLOAT(I-1)*3.1415926535897932/15.
	    X(I) = 0.5+.4*COS(THETA)
	    Y(I) = ORG+.075*SIN(FLOAT(K)*THETA)
   70	 CONTINUE
	 CALL CURVED (X,Y,31)
C
C	LABEL EACH CURVE WITH THE APPROPRIATE CHARACTER	REPRESENTATION
C	OF THE DASHSMTH	PATTERN.  IN THE PATTERN LABELS, A AND D
C	SHOULD BE INTERPRETED AS APOSTROPHE AND	DOLLAR SIGN.
C
C
C	SET TEXT ALIGNMENT TO CENTER THE STRING	AT THE LEFT OF THE
C	STRING AND IN THE VERTICAL CENTER
C
	CALL GSTXAL(1,3)
C
C	SET CHARACTER HEIGHT
C
	 CALL GSCHH(.012)
C
	 ORY = ORG+.089
	 GO TO ( 80, 90,100,110,120),K
   80	 CALL GTX(.1,ORY,'IPAT=DADADADADADADADK=1')
	 GO TO 130
   90	 CALL GTX(.1,ORY,'IPAT=DDDDDDADADDDDDDK=2')
	 GO TO 130
  100	 CALL GTX(.1,ORY,'IPAT=DDDDADDDDADDDDAK=3')
	 GO TO 130
  110	 CALL GTX(.1,ORY,'IPAT=DDDDDAAAAADDDDDK=4')
	 GO TO 130
  120	 CALL GTX(.1,ORY,'IPAT=DDDADDDADDDADDDK=5')
C
  130 CONTINUE
C
      CALL GSTXAL(2,3)
      CALL GTX (.5,.991,'DEMONSTRATION PLOT FOR	DASHSUPR')
      CALL GTX (.5,.013,'IN IPAT STRINGS, A AND	D SHOULD BE INTERPRETED
     1AS APOSTROPHE AND	DOLLAR SIGN')
C
C ADVANCE FRAME
C
      CALL NEWFM
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT ('	  DASHSUPR TEST	SUCCESSFUL',24X,
     1	      'SEE PLOT	TO VERIFY PERFORMANCE')
C
      END

      integer function patsiz (pat, n)
      integer pat (128)
      integer n
      if (.not.(pat (n) .eq. 97 .or. pat (n) .eq. 123 .or. pat (n) .eq. 
     *125))goto 23000
      patsiz = 2
      goto 23001
23000 continue
      if (.not.(pat (n) .eq. 37 .or. pat (n) .eq. 36 .or. pat (n) .eq. 6
     *3))goto 23002
      patsiz = 1
      goto 23003
23002 continue
      if (.not.(pat (n) .eq. 91 .or. pat (n) .eq. 110))goto 23004
      patsiz = pat (n + 1) + 2
      goto 23005
23004 continue
      if (.not.(pat (n) .eq. 42))goto 23006
      patsiz = 4
      goto 23007
23006 continue
      call error (24Hin patsiz: can't happen.)
23007 continue
23005 continue
23003 continue
23001 continue
      return
      end

chapter xiii, example 3 . test of optimal spline interpolation routine
c			  on titanium heat data .
c  from  * a practical guide to splines *  by c. de boor
calls titand,splopt(bsplvb,banfac/slv),splint(*),bvalue(interv)
c
c     lenscr = (n-k)(2k+3)+5k+3  is the length of scrtch required in
c				 splopt .
c     parameter n=12,ntitan=49,k=5,npk=17,lenscr=119
c     integer i,iflag,ipick(n),ipicki,lx,nmk
c     real a(n),gtitan(ntitan),gtau(ntitan),scrtch(lenscr),t(npk),tau(n)
c    *	  ,x(ntitan)
      real bvalue
      integer i,iflag,ipick(12),ipicki,lx,nmk
      real a(12),gtitan(49),gtau(49),scrtch(119),t(17),tau(12)
     *	  ,x(49)
      data n,k /12,5/
      data ipick /1,5,11,21,27,29,31,33,35,40,45,49/
      call titand ( x, gtitan, lx )
      do 10 i=1,n
	 ipicki = ipick(i)
	 tau(i) = x(ipicki)
   10	 gtau(i) = gtitan(ipicki)
      call splopt ( tau, n, k, scrtch, t, iflag )
      if (iflag .gt. 1) 		stop
      call splint ( tau, gtau, t, n, k, scrtch, a, iflag )
      if (iflag .gt. 1) 		stop
      do 20 i=1,lx
	 gtau(i) = bvalue ( t, a, n, k, x(i), 0 )
   20	 scrtch(i) = gtitan(i) - gtau(i)
      print 620,(i,x(i),gtitan(i),gtau(i),scrtch(i),i=1,lx)
  620 format(41h  i, data point, data, interpolant, error//
     2	       (i3,f8.0,f10.4,f9.4,e11.3))
      nmk = n-k
      print 621,(i,t(k+i),i=1,nmk)
  621 format(///16h optimal knots =/(i5,f15.9))
					stop
      end

      integer function itoc (int, str, size)
      integer int, size
      integer str (100)
      integer mod
      integer d, i, intval, j, k
      integer digits (11)
      data digits (1) /48/, digits (2) /49/, digits (3) /50/, digits (4)
     * /51/, digits (5) /52/, digits (6) /53/, digits (7) /54/, digits (
     *8) /55/, digits (9) /56/, digits (10) /57/, digits (11) /-2/
      intval = iabs (int)
      str (1) = -2
      i = 1
23000 continue
      i = i + 1
      d = mod (intval, 10)
      str (i) = digits (d+1)
      intval = intval / 10
23001 if (.not.(intval .eq. 0 .or. i .ge. size))goto 23000
23002 continue
      if (.not.(int .lt. 0 .and. i .lt. size))goto 23003
      i = i + 1
      str (i) = 45
23003 continue
      itoc = i - 1
      j = 1
23005 if (.not.(j .lt. i))goto 23007
      k = str (i)
      str (i) = str (j)
      str (j) = k
      i = i - 1
23006 j = j + 1
      goto 23005
23007 continue
      return
      end

      subroutine entrkw
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer sif(3)
      integer selse(5)
      integer swhile(6)
      integer sdo(3)
      integer sbreak(6)
      integer snext(5)
      integer sfor(4)
      integer srept(7)
      integer suntil(6)
      integer sret(7)
      integer sstr(7)
      integer sswtch(7)
      integer scase(5)
      integer sdeflt(8)
      integer send(4)
      integer serrc0(7)
      integer siferr(6)
      integer sifno0(8)
      integer sthen(5)
      integer sbegin(6)
      integer spoint(8)
      integer sgoto(5)
      data sif(1)/105/,sif(2)/102/,sif(3)/-2/
      data selse(1)/101/,selse(2)/108/,selse(3)/115/,selse(4)/101/,selse
     *(5)/-2/
      data swhile(1)/119/,swhile(2)/104/,swhile(3)/105/,swhile(4)/108/,s
     *while(5)/101/,swhile(6)/-2/
      data sdo(1)/100/,sdo(2)/111/,sdo(3)/-2/
      data sbreak(1)/98/,sbreak(2)/114/,sbreak(3)/101/,sbreak(4)/97/,sbr
     *eak(5)/107/,sbreak(6)/-2/
      data snext(1)/110/,snext(2)/101/,snext(3)/120/,snext(4)/116/,snext
     *(5)/-2/
      data sfor(1)/102/,sfor(2)/111/,sfor(3)/114/,sfor(4)/-2/
      data srept(1)/114/,srept(2)/101/,srept(3)/112/,srept(4)/101/,srept
     *(5)/97/,srept(6)/116/,srept(7)/-2/
      data suntil(1)/117/,suntil(2)/110/,suntil(3)/116/,suntil(4)/105/,s
     *until(5)/108/,suntil(6)/-2/
      data sret(1)/114/,sret(2)/101/,sret(3)/116/,sret(4)/117/,sret(5)/1
     *14/,sret(6)/110/,sret(7)/-2/
      data sstr(1)/115/,sstr(2)/116/,sstr(3)/114/,sstr(4)/105/,sstr(5)/1
     *10/,sstr(6)/103/,sstr(7)/-2/
      data sswtch(1)/115/,sswtch(2)/119/,sswtch(3)/105/,sswtch(4)/116/,s
     *swtch(5)/99/,sswtch(6)/104/,sswtch(7)/-2/
      data scase(1)/99/,scase(2)/97/,scase(3)/115/,scase(4)/101/,scase(5
     *)/-2/
      data sdeflt(1)/100/,sdeflt(2)/101/,sdeflt(3)/102/,sdeflt(4)/97/,sd
     *eflt(5)/117/,sdeflt(6)/108/,sdeflt(7)/116/,sdeflt(8)/-2/
      data send(1)/101/,send(2)/110/,send(3)/100/,send(4)/-2/
      data serrc0(1)/101/,serrc0(2)/114/,serrc0(3)/114/,serrc0(4)/99/,se
     *rrc0(5)/104/,serrc0(6)/107/,serrc0(7)/-2/
      data siferr(1)/105/,siferr(2)/102/,siferr(3)/101/,siferr(4)/114/,s
     *iferr(5)/114/,siferr(6)/-2/
      data sifno0(1)/105/,sifno0(2)/102/,sifno0(3)/110/,sifno0(4)/111/,s
     *ifno0(5)/101/,sifno0(6)/114/,sifno0(7)/114/,sifno0(8)/-2/
      data sthen(1)/116/,sthen(2)/104/,sthen(3)/101/,sthen(4)/110/,sthen
     *(5)/-2/
      data sbegin(1)/98/,sbegin(2)/101/,sbegin(3)/103/,sbegin(4)/105/,sb
     *egin(5)/110/,sbegin(6)/-2/
      data spoint(1)/112/,spoint(2)/111/,spoint(3)/105/,spoint(4)/110/,s
     *point(5)/116/,spoint(6)/101/,spoint(7)/114/,spoint(8)/-2/
      data sgoto(1)/103/,sgoto(2)/111/,sgoto(3)/116/,sgoto(4)/111/,sgoto
     *(5)/-2/
      call enter (sif, -99, rkwtbl)
      call enter (selse, -87, rkwtbl)
      call enter (swhile, -95, rkwtbl)
      call enter (sdo, -96, rkwtbl)
      call enter (sbreak, -79, rkwtbl)
      call enter (snext, -78, rkwtbl)
      call enter (sfor, -94, rkwtbl)
      call enter (srept, -93, rkwtbl)
      call enter (suntil, -70, rkwtbl)
      call enter (sret, -77, rkwtbl)
      call enter (sstr, -75, rkwtbl)
      call enter (sswtch, -92, rkwtbl)
      call enter (scase, -91, rkwtbl)
      call enter (sdeflt, -90, rkwtbl)
      call enter (send, -82, rkwtbl)
      call enter (serrc0, -84, rkwtbl)
      call enter (siferr, -98, rkwtbl)
      call enter (sifno0, -97, rkwtbl)
      call enter (sthen, -86, rkwtbl)
      call enter (sbegin, -83, rkwtbl)
      call enter (spoint, -88, rkwtbl)
      call enter (sgoto, -76, rkwtbl)
      return
      end
c     sifno0  sifnoerr
c     logic0  logical_column
c     serrc0  serrchk

      SUBROUTINE slDVN (V, UV, VM)
*+
*     - - - -
*      D V N
*     - - - -
*
*  Normalizes a 3-vector also giving the modulus (double precision)
*
*  Given:
*     V       d(3)      vector
*
*  Returned:
*     UV      d(3)      unit vector in direction of V
*     VM      d         modulus of V
*
*  Notes:
*
*  1  If the modulus of V is zero, UV is set to zero as well.
*
*  2  To comply with the ANSI Fortran 77 standard, V and UV must be
*     different arrays.  However, the routine is coded so as to work
*     properly on most platforms even if this rule is violated.
*
*  Last revision:   22 July 2004
*
*  Copyright P.T.Wallace.  All rights reserved.
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION V(3),UV(3),VM

      INTEGER I
      DOUBLE PRECISION W1,W2


*  Modulus.
      W1 = 0D0
      DO I=1,3
         W2 = V(I)
         W1 = W1+W2*W2
      END DO
      W1 = SQRT(W1)
      VM = W1

*  Normalize the vector.
      IF (W1.LE.0D0) W1 = 1D0
      DO I=1,3
         UV(I) = V(I)/W1
      END DO

      END

*> \brief \b SSCAL
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*       SUBROUTINE SSCAL(N,SA,SX,INCX)
*
*       .. Scalar Arguments ..
*       REAL SA
*       INTEGER INCX,N
*       ..
*       .. Array Arguments ..
*       REAL SX(*)
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    SSCAL scales a vector by a constant.
*>    uses unrolled loops for increment equal to 1.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>         number of elements in input vector(s)
*> \endverbatim
*>
*> \param[in] SA
*> \verbatim
*>          SA is REAL
*>           On entry, SA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in,out] SX
*> \verbatim
*>          SX is REAL array, dimension ( 1 + ( N - 1 )*abs( INCX ) )
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>         storage spacing between elements of SX
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup single_blas_level1
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>     jack dongarra, linpack, 3/11/78.
*>     modified 3/93 to return if incx .le. 0.
*>     modified 12/3/93, array(1) declarations changed to array(*)
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE SSCAL(N,SA,SX,INCX)
*
*  -- Reference BLAS level1 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      REAL SA
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      REAL SX(*)
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,M,MP1,NINCX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,5)
         IF (M.NE.0) THEN
            DO I = 1,M
               SX(I) = SA*SX(I)
            END DO
            IF (N.LT.5) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,5
            SX(I) = SA*SX(I)
            SX(I+1) = SA*SX(I+1)
            SX(I+2) = SA*SX(I+2)
            SX(I+3) = SA*SX(I+3)
            SX(I+4) = SA*SX(I+4)
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         NINCX = N*INCX
         DO I = 1,NINCX,INCX
            SX(I) = SA*SX(I)
         END DO
      END IF
      RETURN
      END

      subroutine g1 (a,b,cos,sin,sig)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c
c
c     compute orthogonal rotation matrix..
c     compute.. matrix	 (c, s) so that (c, s)(a) = (sqrt(a**2+b**2))
c			 (-s,c) 	(-s,c)(b)   (	0	   )
c     compute sig = sqrt(a**2+b**2)
c	 sig is computed last to allow for the possibility that
c	 sig may be in the same location as a or b .
c
      zero=0.
      one=1.
      if (abs(a).le.abs(b)) go to 10
      xr=b/a
      yr=sqrt(one+xr**2)
      cos=sign(one/yr,a)
      sin=cos*xr
      sig=abs(a)*yr
      return
   10 if (b) 20,30,20
   20 xr=a/b
      yr=sqrt(one+xr**2)
      sin=sign(one/yr,b)
      cos=sin*xr
      sig=abs(b)*yr
      return
   30 sig=zero
      cos=zero
      sin=one
      return
      end

c     prog4
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   demonstrate singular value analysis.
c
      dimension a(15,5),b(15),sing(15)
      data names/1h /
c
      read (5,10) ((a(i,j),j=1,5),b(i),i=1,15)
      write (6,20)
      write (6,30) ((a(i,j),j=1,5),b(i),i=1,15)
      write (6,40)
c
      call sva (a,15,15,5,15,b,sing,names,1,d)
c
      stop
   10 format (6f12.0)
   20 format (46h1prog4.    demonstrate singular value analysis/53h list
     1ing of input matrix, a, and vector, b, follows..)
   30 format (1h /(5f12.8,f20.4))
   40 format (1h1)
      end

      SUBROUTINE CONDRW (SCRARR)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C  DRAW ALL CONTOURS AT THIS LEVEL
C  IF NOT EXTRAPOLATING
C         SEARCH CONVEX HULL FOR CONTOURS INTERSECTING IT AND DRAW THEM
C         SEARCH INTERIOR AND DRAW ALL REMAINING UNDRAWN CONTOURS
C
C  IF EXTRAPOLATING
C         SEARCH FROM X START TO X END AND Y START TO Y END FOR ALL
C         CONTOURS AT THIS LEVEL
C
C  INPUT
C       SCRARR SCRATCH ARRAY USED FOR FAST CONTOURING
C       VIA COMMON BLOCKS BELOW
C           CONV-THE CURRENT CONTOUR LEVEL
C           ITLOC-THE CONVEX HULL BOUNDRIES RELATIVE TO THE SCRATCH
C                 ARRAY, SCRARR
C           PV-REAL Y COOORDINATES OF THE CONVEX HULL RELATIVE TO THE
C                 USERS COORDINATE SPACE
C           IXMAX,IYMAX-MAXINUM X AND Y COORDINATES RELATIVE TO THE
C                 SCRATCH ARRAY, SCRARR
C           XMAX,YMAX-MAXIMUM X AND Y COORDINATES RELATIVE TO USERS
C                 COORDINATE SPACE
C
C  OUTPUT
C    CONTOUR LINES OUTPUT TO PLOTTER FILE
C
C  NOTE
C       THIS ROUTINE WILL DETECT AND CORRECT FOR CONRAN ERROR 9
C
      DIMENSION       SCRARR(1)
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),  NP       ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
        SAVE
C
C
C  FLAGS TO ALLOW COMPRESSION OF CONTOUR STORAGE IF IT IS EXAUSTED
C
        DATA ICOMP,NOCOMP/1,0/
C
C  STATEMENT FUNCTION TO MAKE ARRAY ACCESS SEEM LIKE MATRIX ACCESS
C
      SCRTCH(IXX,IYY) = SCRARR(IYY+(IXX-1)*IYMAX)
C
C  CLEAR THE CONTOUR STORAGE LIST
C
      NP = 0
C
C  SCAN X BOARDERS FOR INTERSECTIONS
C
      JX = 2
      ICASE = 1
      X = XST+STPSZ
C
C  IF NOT EXTRAPOLATING BRANCH
C
   10 IF (.NOT.EXTRAP) GO TO    20
      JY = 2
      JYE = IYMAX
      Y = YST+STPSZ
      GO TO    30
C
C  NOT EXTRAPOLATING
C
   20 JY = ITLOC(JX*2-1)
      IF (JY.EQ.0) GO TO    60
      JYE = ITLOC(JX*2)+1
      IF (JYE.GT.IYMAX) JYE = IYMAX
      Y = PV(JX*2-1)
      IF (JY.GE.2) GO TO 30
      JY = 2
      Y = YST+STPSZ
   30 TL = SCRTCH(JX-1,JY-1)
      BL = SCRTCH(JX,JY-1)
   40 TR = SCRTCH(JX-1,JY)
      BR = SCRTCH(JX,JY)
      CALL CONGEN (X,Y,NOCOMP,SCRARR,ICASE)
C
C  TEST IF CONTOUR STORAGE EXAUSTED
C
      IF (NERRO(NERR).NE.10) GO TO    50
      CALL EPRIN
      CALL ERROF
      RETURN
C
C  MOVE TO NEW CELL
C
   50 TL = TR
      BL = BR
      JY = JY+1
      Y = Y+STPSZ
      IF (JY.LE.JYE) GO TO    40
   60 IF (JX.EQ.IXMAX) GO TO    70
      JX = IXMAX
      ICASE = 3
      X = XMAX
      GO TO    10
C
C  SCAN Y BOARDERS
C
   70 IPOS = 1
      ICASE = 4
   80 JX = 3
      X = XST+STPSZ+STPSZ
C
C  IF NOT EXTRAPOLATING BRANCH
C
   90 IF (.NOT.EXTRAP) GO TO   100
      JY = 2
      Y = YST+STPSZ
      IF (IPOS.NE.0) GO TO   110
      JY = IYMAX
      Y = YED
      GO TO   110
C
C  NOT EXTRAPOLATING
C
 100    JY = ITLOC(JX*2 - IPOS )
      IF (JY.EQ.0) GO TO   120
        JY = JY + IPOS
      Y = PV(JX*2 - IPOS) + STPSZ*(1*IPOS)
  110 TL = SCRTCH(JX-1,JY-1)
      BL = SCRTCH(JX,JY-1)
      TR = SCRTCH(JX-1,JY)
      BR = SCRTCH(JX,JY)
      CALL CONGEN (X,Y,NOCOMP,SCRARR,ICASE)
C
C  TEST IF CONTOUR STORAGE EXAUSTED
C
      IF (NERRO(NERR).NE.10) GO TO   120
      CALL EPRIN
      CALL ERROF
      RETURN
C
C  MOVE TO NEW CELL
C
  120 JX = JX+1
      X = X+STPSZ
      IF (JX.LE.IXMAX-1) GO TO    90
      IF (IPOS.EQ.0) GO TO   130
      IPOS = 0
      ICASE = 2
      GO TO    80
C
C  BOARDER SEARCH DONE CONTOUR INTERIOR
C
C  INITIALIZE THE SEARCH
C
  130 JX = 3
      ICASE = 0
      X = XST+STPSZ+STPSZ
      JXE = IXMAX-1
C
C  IF EXTRAPOLATING GO FROM BORDER TO BORDER
C
  140 IF (.NOT.EXTRAP) GO TO   150
      JY = 3
      JYE = IYMAX-1
      Y = YST+STPSZ+STPSZ
      GO TO   160
C
C  NOT EXTRAPOLATING STAY IN HULL
C
  150 JY = ITLOC(JX*2 - 1)+2
      IF (JY.EQ.2) GO TO   190
      JYE = ITLOC(JX*2)-1
      Y = PV(JX*2 - 1)+STPSZ+STPSZ
C
  160 IF (JY.GT.JYE) GO TO   190
      TL = SCRTCH(JX-1,JY-1)
      BL = SCRTCH(JX,JY-1)
  170 TR = SCRTCH(JX-1,JY)
      BR = SCRTCH(JX,JY)
      CALL CONGEN (X,Y,ICOMP,SCRARR,ICASE)
C
C  TEST IF CONTOUR STORAGE EXAUSTED
C
      IF (NERRO(NERR).NE.10) GO TO   180
      CALL EPRIN
      CALL ERROF
      RETURN
C
C  MOVE TO NEW CELL
C
  180 JY = JY+1
      Y = Y+STPSZ
      TL = TR
      BL = BR
      IF (JY.LE.JYE) GO TO   170
C
C  PROCESS EACH ROW OF INTERIOR
C
  190 X = X+STPSZ
      JX = JX+1
      IF (JX.LE.JXE) GO TO   140
C
      RETURN
      END

C--------------------------------------------------------------------------
        subroutine ftgkyn(iunit,nkey,keynam,value,comm,status)

C       Read value and comment of the NKEYth header record 
C       This routine is useful for reading the entire header, one
C       record at a time.

C       iunit   i  Fortran I/O unit number
C       nkey    i  sequence number (starting with 1) of the keyword to read
C       OUTPUT PARAMETERS:
C       keynam  c  output name of the keyword
C       value   c  output value of the keyword, if any
C       comm    c  output comment string, if any, of the keyword
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer iunit,nkey,status
        character*(*) keynam,value,comm
        character keybuf*80,arec*8

        if (status .gt. 0)return

        call ftgrec(iunit,nkey,keybuf,status)
        if (status .gt. 0)return

        keynam=keybuf(1:8)

C       parse the value and comment fields from the record
        call ftpsvc(keybuf,value,comm,status)
        if (status .gt. 0)return

C       Test that keyword name contains only valid characters.
C       This also serves as a check in case there was no END keyword and
C       program continues to read on into the data unit
        call fttkey(keybuf(1:8),status)
        if (status .gt. 0)then
            write(arec,1000)nkey
1000        format(i8)
            call ftpmsg('Name of header keyword number'//arec//
     &     ' contains illegal character(s):')
            call ftpmsg(keybuf)

C          see if we are at the beginning of FITS logical record
           if (nkey-1 .eq. (nkey-1)/36*36 .and. nkey .gt. 1)then
             call ftpmsg('(This may indicate a missing END keyword).')
           end if
        end if
        end

#-h-  deftok			 4116  local   12/01/80  15:53:47
# deftok - get token; process macro calls and invocations
   include  defs

# this routine has been disabled to allow defines with parameters to be added

#   character function deftok (token, toksiz)
#   character gtok
#   integer toksiz
#   character defn (MAXDEF), t, token (MAXTOK)
#   integer ludef
#   include COMMON_BLOCKS
#
#   for (t = gtok (token, toksiz); t!=EOF; t = gtok (token, toksiz)) {
#      if (t != ALPHA)	 # non-alpha
#	  break
#      if (ludef (token, defn, deftbl) == NO)	  # undefined
#	  break
#      if (defn (1) == DEFTYPE) {   # get definition
#	  call getdef (token, toksiz, defn, MAXDEF)
#	  call entdef (token, defn, deftbl)
#	  }
#      else
#	  call pbstr (defn)   # push replacement onto input
#      }
#   deftok = t
#   if (deftok == ALPHA)   # convert to single case
#      call fold (token)
#   return
#   end
# deftok - get token; process macro calls and invocations

   character function deftok (token, toksiz)
   character token (MAXTOK)
   integer toksiz

   include COMMON_BLOCKS

   character t, c, defn (MAXDEF), mdefn (MAXDEF)
   character gtok
   integer equal

   integer ap, argstk (ARGSIZE), callst (CALLSIZE),
      nlb, plev (CALLSIZE), ifl
   integer ludef, push, ifparm

   string balp "()"
   string pswrg "switch_no_range_check"

   cp = 0
   ap = 1
   ep = 1
   for (t = gtok (token, toksiz); t != EOF; t = gtok (token, toksiz)) {
      if (t == ALPHA)
	 if (ludef (token, defn, deftbl) == NO) {
	    if (cp == 0)
	       break
	    else
	       call puttok (token)
	 } else if (defn (1) == DEFTYPE) {     # process defines directly
	    call getdef (token, toksiz, defn, MAXDEF)
	    call entdef (token, defn, deftbl)
	 } else if (defn (1) == IFDEFTYPE | defn (1) == IFNOTDEFTYPE) {
	    c = defn (1)
	    call getdef (token, toksiz, defn, MAXDEF)
	    ifl = ludef (token, mdefn, deftbl)
	    if ((ifl == YES & c == IFDEFTYPE) |
	     (ifl == NO & c == IFNOTDEFTYPE))
	       call pbstr (defn)

	 } else if (defn(1) == PRAGMATYPE & cp == 0) {   # pragma
	    if (gtok (defn, MAXDEF) == BLANK) {
		if (gtok (defn, MAXDEF) == ALPHA) {
		    if (equal (defn, pswrg) == YES)
			swinrg = YES
		    else
			goto 10
		} else {
10		    call pbstr (defn)
		    call putbak (BLANK)
		    break
		}
	    } else {
		call pbstr (defn)
		break
	    }
		    
	 } else {
	    cp = cp +  1
	    if (cp > CALLSIZE)
	       call baderr ("call stack overflow.")
	    callst (cp) = ap
	    ap = push (ep, argstk, ap)
	    call puttok (defn)
	    call putchr (EOS)
	    ap = push (ep, argstk, ap)
	    call puttok (token)
	    call putchr (EOS)
	    ap = push (ep, argstk, ap)
	    t = gtok (token, toksiz)
	    if (t == BLANK) {		  # allow blanks before arguments
	       t = gtok (token, toksiz)
	       call pbstr (token)
	       if (t != LPAREN)
		  call putbak (BLANK)
	       }
	    else
	       call pbstr (token)
	    if (t != LPAREN)
	       call pbstr (balp)
	    else if (ifparm (defn) == NO)
	       call pbstr (balp)
	    plev (cp) = 0
	} else if (t == LSTRIPC) {
	 nlb = 1
	 repeat {
	    t = gtok (token, toksiz)
	    if (t == LSTRIPC)
	       nlb = nlb + 1
	    else if (t == RSTRIPC) {
	       nlb = nlb - 1
	       if (nlb == 0)
		  break
	       }
	    else if (t == EOF)
	    call baderr ("EOF in string.")
	    call puttok (token)
	    }
        }
      else if (cp == 0)
	 break
      else if (t == LPAREN) {
	 if (plev (cp) > 0)
	    call puttok (token)
	 plev (cp) = plev (cp) + 1
	 }
      else if (t == RPAREN) {
	 plev (cp) = plev (cp) - 1
	 if (plev (cp) > 0)
	    call puttok (token)
	 else {
	    call putchr (EOS)
	    call evalr (argstk, callst (cp), ap - 1)
	    ap = callst (cp)
	    ep = argstk (ap)
	    cp =  cp - 1
	    }
	 }
      else if (t == COMMA & plev (cp) == 1) {
	 call putchr (EOS)
	 ap = push (ep, argstk, ap)
	 }
      else
	 call puttok (token)
      }

   deftok = t
   if (t == ALPHA)
      call fold (token)

   return
   end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGDLCH (IDCS)
C
C This routine deletes character strings previously stored by the
C routine AGSTCH (which see).  It has the following argument:
C
C -- IDCS is the identifying integer returned by AGSTCH when the string
C    was stored.
C
C The following common blocks contain variables which are required for
C the character-storage-and-retrieval scheme of AUTOGRAPH.
C
      COMMON /AGCHR1/ LNIC,INCH(2,50),LNCA,INCA
C
      COMMON /AGCHR2/ CHRA(2000)
C
      CHARACTER*1 CHRA
C
C Only if the identifier is between -LNIC and -1, inclusive, was the
C string ever stored, so that it needs to be deleted.  If the string is
C the last one in CHRA, we can just set INCA to point to the position
C preceding it; otherwise, we zero out the string but don't bother to
C collapse CHRA, which will happen in AGSTCH when the space is needed
C again.  In either case, the index entry in INCH is zeroed.
C
      IF (IDCS.GE.(-LNIC).AND.IDCS.LE.(-1)) THEN
        I=-IDCS
        J=INCH(1,I)
        IF (J.GT.0) THEN
          K=J+INCH(2,I)-1
          IF (K.EQ.INCA) THEN
            INCA=J-1
          ELSE
            DO 101 L=J,K
              CHRA(L)=CHAR(0)
  101       CONTINUE
          END IF
          INCH(1,I)=0
        END IF
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE TTHREE	(IERROR)
C
C LATEST REVISION	 JULY, 1984
C
C PURPOSE		 TO PROVIDE A SIMPLE DEMONSTRATION OF
C			 THE ROUTINE THREED.
C
C USAGE			 CALL TTHREE (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT		 IERROR
C			   AN INTEGER VARIABLE
C			   =0 IF THERE IS A NORMAL EXIT	FROM THE
C			      ROUTINE THREED.
C			   =1 OTHERWISE
C
C I/O			 IF THERE IS A NORMAL EXIT FROM	THE ROUTINE
C			 THREED	THE MESSAGE
C			   THREED TEST SUCCESSFUL . . .	SEE PLOT TO
C			   VERIFY PERFORMANCE
C			 IS PRINTED.
C
C PRECISION		 SINGLE
C
C LANGUAGE		 FORTRAN
C
C HISTORY		 ORIGINALLY WRITTEN NOVEMBER 1976
C			 CONVERTED TO GKS AND FORTRAN 77 JULY 1984
C
C ALGORITHM		 ROUTINE TTHREE	CALLS SET3 TO ESTABLISH	A
C			 MAPPING BETWEEN THE PLOTTER ADDRESSES AND
C			 THE USER'S VOLUME, AND	TO INDICATE THE
C			 COORDINATES OF	THE EYE	POSITION FROM
C			 WHICH THE LINES TO BE DRAWN ARE VIEWED.
C			 NEXT, THE VOLUME PERIMETERS AND ASSOCIATED
C			 TICK MARKS ARE	DRAWN BY CALLS TO PERIM3.
C			 THEN THE LINES	ARE DRAWN.  THESE ARE
C			 CERTAIN LATITUDES AND LONGITUDES OF A
C			 SPHERE.
C
C PORTABILITY		 ANSI FORTRAN 77
C
C
C
C
      REAL EYE(3),X(31),Y(31),Z(31)
C
C SPECIFY ARGUMENT VALUES TO BE	USED BY	ROUTINE	SET3.  ON AN
C ABSTRACT PLOTTER WITH	AN ADDRESS RANGE OF 0. TO 1. IN	EACH
C COORDINATE DIRECTION,	THE VALUES  RXA, RXB, RYA, AND RYB
C DEFINE THE PORTION OF	THE ADDRESS SPACE TO BE	USED IN	MAKING
C THE PLOT.  UC, UD, VC, VD, WC, WD  DEFINE A VOLUME IN	USER
C COORDINATES WHICH IS TO BE MAPPED ONTO THE PORTION OF	THE
C VIEWING SURFACE AS SPECIFIED BY  RXA,	RXB, RYA, AND RYB.
C
      DATA RXA/0.097656/, RXB/0.90236/,	RYA/0.097656/, RYB/0.90236/
      DATA UC/-1./, UD/1./, VC/-1./, VD/1./, WC/-1./, WD/1./
      DATA EYE(1),EYE(2),EYE(3)/10.,6.,3./
      DATA TX/0.4374/, TY/0.9570/
C
C DEFINE PI
      DATA PI/3.1415926535898/
C
C
C SELECT NORMALIZATION TRANSFORMATION 0
C
      CALL GSELNT (0)
C
C CALL SET3 TO ESTABLISH A MAPPING BETWEEN THE PLOTTER ADDRESSES
C AND THE USER'S VOLUME, AND TO	INDICATE THE COORDINATES OF THE
C EYE POSITION FROM WHICH THE LINES TO BE DRAWN	ARE VIEWED.
C
      CALL SET3(RXA,RXB,RYA,RYB,UC,UD,VC,VD,WC,WD,EYE)
C
C CALL PERIM3 TO DRAW PERIMETER	LINES AND TICK MARKS
C
      CALL PERIM3(2,5,1,10,1,-1.)
      CALL PERIM3(4,2,1,1,2,-1.)
      CALL PERIM3(2,10,4,5,3,-1.)
C
C DEFINE AND DRAW LATITUDINAL LINES ON THE SPHERE OF RADIUS ONE
C HAVING CENTER	(0.,0.,0.)
C
      DO 10 J=1,18
      THETA = FLOAT(J)*PI/9.
      CT = COS(THETA)
      ST = SIN(THETA)
      DO 20 K=1,31
      PHI = FLOAT(K-16)*PI/30.
      Z(K) = SIN(PHI)
      CP = COS(PHI)
      X(K) = CT*CP
      Y(K) = ST*CP
   20 CONTINUE
      CALL CURVE3(X,Y,Z,31)
   10 CONTINUE
C
C DEFINE AND DRAW LONGITUDINAL LINES ON	THE SPHERE OF RADIUS ONE
C HAVING CENTER	(0.,0.,0.)
C
      DO 30 K=1,5
      PHI = FLOAT(K-3)*PI/6.
      SP = SIN(PHI)
      CP = COS(PHI)
      DO 40 J=1,31
      TUETA = FLOAT(J-1)*PI/15.
      X(J) = COS(TUETA)*CP
      Y(J) = SIN(TUETA)*CP
      Z(J) = SP
   40 CONTINUE
      CALL CURVE3(X,Y,Z,31)
   30 CONTINUE
C
C CALL WTSTR FOR THREED	PLOT TITLE
C
      CALL WTSTR(TX,TY,'DEMONSTRATION PLOT FOR ROUTINE THREED',2,0,0)
      call pwrzt (1.,0.,-1.,'DEMONSTRATION PLOT FOR ROUTINE THREED', 37,
     * 2, 2, 3, 0)
C
c     CALL NEWFM
C
      IERROR = 0
c     WRITE(6,1001)
      RETURN
C
c1001 FORMAT('	   THREED TEST SUCCESSFUL', 24X,
c    1	     'SEE PLOT TO VERIFY PERFORMANCE')
      END

      SUBROUTINE RFFTF1 (N,C,CH,WA,IFAC)
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = IFAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IF (IP .NE. 4) GO TO 102
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL RADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  101    CALL RADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  102    IF (IP .NE. 2) GO TO 104
         IF (NA .NE. 0) GO TO 103
         CALL RADF2 (IDO,L1,C,CH,WA(IW))
         GO TO 110
  103    CALL RADF2 (IDO,L1,CH,C,WA(IW))
         GO TO 110
  104    IF (IP .NE. 3) GO TO 106
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 105
         CALL RADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 110
  105    CALL RADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))
         GO TO 110
  106    IF (IP .NE. 5) GO TO 108
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 107
         CALL RADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  107    CALL RADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  108    IF (IDO .EQ. 1) NA = 1-NA
         IF (NA .NE. 0) GO TO 109
         CALL RADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         NA = 1
         GO TO 110
  109    CALL RADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
         NA = 0
  110    L2 = L1
  111 CONTINUE
      IF (NA .EQ. 1) RETURN
      DO 112 I=1,N
         C(I) = CH(I)
  112 CONTINUE
      RETURN
      END
      SUBROUTINE RADF2 (IDO,L1,CC,CH,WA1)
      DIMENSION       CH(IDO,2,L1)           ,CC(IDO,L1,2)           ,
     1                WA1(*)
      DO 101 K=1,L1
         CH(1,1,K) = CC(1,K,1)+CC(1,K,2)
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,2)
  101 CONTINUE
      IF (IDO.lt.2) GO TO 107
      IF (IDO.eq.2) GO TO 105
      GO TO 102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CH(I,1,K) = CC(I,K,1)+TI2
            CH(IC,2,K) = TI2-CC(I,K,1)
            CH(I-1,1,K) = CC(I-1,K,1)+TR2
            CH(IC-1,2,K) = CC(I-1,K,1)-TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(1,2,K) = -CC(IDO,K,2)
         CH(IDO,1,K) = CC(IDO,K,1)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADF3 (IDO,L1,CC,CH,WA1,WA2)
      DIMENSION       CH(IDO,3,L1)           ,CC(IDO,L1,3)           ,
     1                WA1(*)     ,WA2(*)
      DATA TAUR,TAUI /-.5,.866025403784439/
      DO 101 K=1,L1
         CR2 = CC(1,K,2)+CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2
         CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))
         CH(IDO,2,K) = CC(1,K,1)+TAUR*CR2
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR2 = DR2+DR3
            CI2 = DI2+DI3
            CH(I-1,1,K) = CC(I-1,K,1)+CR2
            CH(I,1,K) = CC(I,K,1)+CI2
            TR2 = CC(I-1,K,1)+TAUR*CR2
            TI2 = CC(I,K,1)+TAUR*CI2
            TR3 = TAUI*(DI2-DI3)
            TI3 = TAUI*(DR3-DR2)
            CH(I-1,3,K) = TR2+TR3
            CH(IC-1,2,K) = TR2-TR3
            CH(I,3,K) = TI2+TI3
            CH(IC,2,K) = TI3-TI2
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADF4 (IDO,L1,CC,CH,WA1,WA2,WA3)
      DIMENSION       CC(IDO,L1,4)           ,CH(IDO,4,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)
      DATA HSQT2 /.7071067811865475/
      DO 101 K=1,L1
         TR1 = CC(1,K,2)+CC(1,K,4)
         TR2 = CC(1,K,1)+CC(1,K,3)
         CH(1,1,K) = TR1+TR2
         CH(IDO,4,K) = TR2-TR1
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,3)
         CH(1,3,K) = CC(1,K,4)-CC(1,K,2)
  101 CONTINUE
      IF (IDO.lt.2) GO TO 107
      IF (IDO.eq.2) GO TO 105
      GO TO 102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            TR1 = CR2+CR4
            TR4 = CR4-CR2
            TI1 = CI2+CI4
            TI4 = CI2-CI4
            TI2 = CC(I,K,1)+CI3
            TI3 = CC(I,K,1)-CI3
            TR2 = CC(I-1,K,1)+CR3
            TR3 = CC(I-1,K,1)-CR3
            CH(I-1,1,K) = TR1+TR2
            CH(IC-1,4,K) = TR2-TR1
            CH(I,1,K) = TI1+TI2
            CH(IC,4,K) = TI1-TI2
            CH(I-1,3,K) = TI4+TR3
            CH(IC-1,2,K) = TR3-TI4
            CH(I,3,K) = TR4+TI3
            CH(IC,2,K) = TR4-TI3
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = -HSQT2*(CC(IDO,K,2)+CC(IDO,K,4))
         TR1 = HSQT2*(CC(IDO,K,2)-CC(IDO,K,4))
         CH(IDO,1,K) = TR1+CC(IDO,K,1)
         CH(IDO,3,K) = CC(IDO,K,1)-TR1
         CH(1,2,K) = TI1-CC(IDO,K,3)
         CH(1,4,K) = TI1+CC(IDO,K,3)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADF5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      DIMENSION       CC(IDO,L1,5)           ,CH(IDO,5,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/
      DO 101 K=1,L1
         CR2 = CC(1,K,5)+CC(1,K,2)
         CI5 = CC(1,K,5)-CC(1,K,2)
         CR3 = CC(1,K,4)+CC(1,K,3)
         CI4 = CC(1,K,4)-CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2+CR3
         CH(IDO,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3
         CH(1,3,K) = TI11*CI5+TI12*CI4
         CH(IDO,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3
         CH(1,5,K) = TI12*CI5-TI11*CI4
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)
            DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)
            CR2 = DR2+DR5
            CI5 = DR5-DR2
            CR5 = DI2-DI5
            CI2 = DI2+DI5
            CR3 = DR3+DR4
            CI4 = DR4-DR3
            CR4 = DI3-DI4
            CI3 = DI3+DI4
            CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3
            CH(I,1,K) = CC(I,K,1)+CI2+CI3
            TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3
            TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3
            TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3
            TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3
            TR5 = TI11*CR5+TI12*CR4
            TI5 = TI11*CI5+TI12*CI4
            TR4 = TI12*CR5-TI11*CR4
            TI4 = TI12*CI5-TI11*CI4
            CH(I-1,3,K) = TR2+TR5
            CH(IC-1,2,K) = TR2-TR5
            CH(I,3,K) = TI2+TI5
            CH(IC,2,K) = TI5-TI2
            CH(I-1,5,K) = TR3+TR4
            CH(IC-1,4,K) = TR3-TR4
            CH(I,5,K) = TI3+TI4
            CH(IC,4,K) = TI4-TI3
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)
      DATA TPI/6.28318530717959/
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP+2
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IF (IDO .EQ. 1) GO TO 119
      DO 101 IK=1,IDL1
         CH2(IK,1) = C2(IK,1)
  101 CONTINUE
      DO 103 J=2,IP
         DO 102 K=1,L1
            CH(1,K,J) = C1(1,K,J)
  102    CONTINUE
  103 CONTINUE
      IF (NBD .GT. L1) GO TO 107
      IS = -IDO
      DO 106 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 105 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 104 K=1,L1
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  104       CONTINUE
  105    CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J=2,IP
         IS = IS+IDO
         DO 109 K=1,L1
            IDIJ = IS
            DO 108 I=3,IDO,2
               IDIJ = IDIJ+2
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  108       CONTINUE
  109    CONTINUE
  110 CONTINUE
  111 IF (NBD .LT. L1) GO TO 115
      DO 114 J=2,IPPH
         JC = IPP2-J
         DO 113 K=1,L1
            DO 112 I=3,IDO,2
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  112       CONTINUE
  113    CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J=2,IPPH
         JC = IPP2-J
         DO 117 I=3,IDO,2
            DO 116 K=1,L1
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  116       CONTINUE
  117    CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  120 CONTINUE
  121 DO 123 J=2,IPPH
         JC = IPP2-J
         DO 122 K=1,L1
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)
  122    CONTINUE
  123 CONTINUE
C
      AR1 = 1.
      AI1 = 0.
      DO 127 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 124 IK=1,IDL1
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)
            CH2(IK,LC) = AI1*C2(IK,IP)
  124    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 126 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 125 IK=1,IDL1
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      DO 129 J=2,IPPH
         DO 128 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)
  128    CONTINUE
  129 CONTINUE
C
      IF (IDO .LT. L1) GO TO 132
      DO 131 K=1,L1
         DO 130 I=1,IDO
            CC(I,1,K) = CH(I,K,1)
  130    CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I=1,IDO
         DO 133 K=1,L1
            CC(I,1,K) = CH(I,K,1)
  133    CONTINUE
  134 CONTINUE
  135 DO 137 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 136 K=1,L1
            CC(IDO,J2-2,K) = CH(1,K,J)
            CC(1,J2-1,K) = CH(1,K,JC)
  136    CONTINUE
  137 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IF (NBD .LT. L1) GO TO 141
      DO 140 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 139 K=1,L1
            DO 138 I=3,IDO,2
               IC = IDP2-I
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  138       CONTINUE
  139    CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 143 I=3,IDO,2
            IC = IDP2-I
            DO 142 K=1,L1
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  142       CONTINUE
  143    CONTINUE
  144 CONTINUE
      RETURN
      END

C----------------------------------------------------------------------
        logical function fttdnn(value)

C       test if a R*8 value has a IEEE Not-a-Number value
C       A NaN has all the exponent bits=1, and the fractional part
C       not=0. 
C       Exponent field is in bits 20-30 in the most significant 4-byte word
C       Mantissa field is in bits 0-19 of most sig. word and entire 2nd word
C
C       written by Wm Pence, HEASARC/GSFC, May 1992
C       modified Aug 1994 to handle all IEEE special values.

        integer value(2)

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer compid
        common/ftcpid/compid
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer word1,word2

C       COMPID specifies what type of floating point word structure
C       is used on this machine, and determines how to test for NaNs.

C       COMPID value:
C           1        generic machine: simply test for NaNs with all bits set
C           2        like a decstation or alpha OSF/1, or IBM PC
C           3        SUN workstation, or IBM mainframe
C          -2305843009213693952   Cray (64-bit) machine

        fttdnn=.false.
	return

        if (compid .eq. 1)then
C           on the VAX we can assume that all NaNs will be set to all bits on
C           (which is equivalent to an integer with a value of -1) because
C           this is what the IEEE to VAX conversion MACRO program returns
            if (value(1) .eq. -1 .and. value(2) .eq. -1)fttdnn=.true.

        else if (compid .gt. 1)then
            if (compid .ge. 3)then
C               this is for SUN-like machines, or IBM main frames
                word1=value(1)
                word2=value(2)
            else
C               this is for DECstation and IBM PCs.  The 2 32 bit integer words
C               are reversed from what you get on the SUN.
                word1=value(2)
                word2=value(1)
            end if

C           efficiently search the number space for NaNs and underflows
            if (word2 .eq. -1)then
                if ((word1 .ge. -1048577 .and. word1 .le. -1)
     &           .or. (word1 .ge. 2146435071))then
                      fttdnn=.true.
                else if ((word1 .lt. -2146435072) .or.
     &          (word1 .ge. 0 .and. word1 .lt. 1048576))then
                      value(1)=0
                      value(2)=0
                end if
             else if (word2 .eq. 0)then
                if ((word1 .gt. -1048577 .and. word1 .le. -1)
     &           .or. (word1 .gt. 2146435071))then
                      fttdnn=.true.
                else if ((word1 .le. -2146435072) .or.
     &          (word1 .ge. 0 .and. word1 .le. 1048576))then
                      value(1)=0
                      value(2)=0
                end if
             else
                if ((word1 .gt. -1048577 .and. word1 .le. -1)
     &           .or. (word1 .gt. 2146435071))then
                      fttdnn=.true.
                else if ((word1 .lt. -2146435072) .or.
     &          (word1 .ge. 0 .and. word1 .lt. 1048576))then
                      value(1)=0
                      value(2)=0
                end if
             end if
        else
C           branch for the Cray:  COMPID stores the negative integer
C           which corresponds to the 3 most sig digits set to 1.   If these
C           3 bits are set in a floating point number, then it represents
C           a reserved value (i.e., a NaN)
            if (value(1).lt. 0 .and. value(1) .ge. compid)fttdnn=.true.        
        end if
        end

      integer function locate (c, pat, offset)
      integer c, pat (128)
      integer offset
      integer i
      i = offset + pat (offset)
23000 if (.not.(i .gt. offset))goto 23002
      if (.not.(c .eq. pat (i)))goto 23003
      locate=(1)
      return
23003 continue
23001 i = i - 1
      goto 23000
23002 continue
      locate=(0)
      return
      end

C--------------------------------------------------------------------------
        subroutine ftg3db(ounit,group,nulval,dim1,dim2,nx,ny,nz,
     &                    array,anyflg,status)

C       Read a 3-d cube of byte values from the primary array.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       ounit   i  Fortran output unit number
C       group   i  number of the data group, if any
C       nulval  c*1  undefined pixels will be set to this value (unless = 0)
C       dim1    i  actual first dimension of ARRAY
C       dim2    i  actual second dimension of ARRAY
C       nx      i  size of the cube in the x direction
C       ny      i  size of the cube in the y direction
C       nz      i  size of the cube in the z direction
C       array   c*1  the array of values to be read
C       anyflg  l  set to true if any of the image pixels were undefined
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,group,dim1,dim2,nx,ny,nz,status
        character*1 array(dim1,dim2,*),nulval
        logical anyflg,ltemp
        integer fpixel,row,band

        anyflg=.false.
        fpixel=1
        do 20 band=1,nz
        do 10 row = 1,ny
                call ftgpvb(ounit,group,fpixel,nx,nulval,
     &              array(1,row,band),ltemp,status)
                if (ltemp)anyflg=.true.
                fpixel=fpixel+nx
10      continue
20      continue
        end

include	defs

# addset - put c in string (j) if it fits, increment j

   integer function addset (c, str, j, maxsiz)
   integer j, maxsiz
   character c, str (maxsiz)

   if (j > maxsiz)
      addset = NO
   else {
      str(j) = c
      j = j + 1
      addset = YES
      }

   return
   end

c     prog3
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 jun 12
c     to appear in 'solving least squares problems', prentice-hall, 1974
c	   demonstrate the use of subroutine   svdrs  to compute the
c     singular value decomposition of a matrix, a, and solve a least
c     squares problem,	a*x=b.
c
c     the s.v.d.  a= u*(s,0)**t*v**t is
c     computed so that..
c     (1)  u**t*b replaces the m+1 st. col. of	b.
c
c     (2)  u**t   replaces the m by m identity in
c     the first m cols. of  b.
c
c     (3) v replaces the first n rows and cols.
c     of a.
c
c     (4) the diagonal entries of the s matrix
c     replace the first n entries of the array s.
c
c     the array s( ) must be dimensioned at least 3*n .
c
      dimension a(8,8),b(8,9),s(24),x(8),aa(8,8)
      real gen,anoise
      double precision sm
      data mda,mdb/8,8/
c
      do 150 noise=1,2
      anoise = 0.
      rho = 1.e-3
      if(noise .eq. 1) go to 5
      anoise = 1.e-4
      rho = 10. * anoise
    5 continue
      write(6,230)
      write(6,240) anoise,rho
c     initialize data generation function
c    ..
      dummy= gen(-1.)
c
	   do 150 mn1=1,6,5
	   mn2=mn1+2
		do 150 m=mn1,mn2
		do 150 n=mn1,mn2
		write (6,160) m,n
		     do 20 i=1,m
			  do 10 j=1,m
   10			  b(i,j)=0.
		     b(i,i)=1.
			  do 20 j=1,n
			  a(i,j)= gen(anoise)
   20			  aa(i,j)=a(i,j)
		     do 30 i=1,m
   30		     b(i,m+1)= gen(anoise)
c
c     the arrays are now filled in..
c     compute the s.v.d.
c     ******************************************************
		call svdrs (a,mda,m,n,b,mdb,m+1,s)
c     ******************************************************
c
		write (6,170)
		write (6,220) (i,s(i),i=1,n)
		write (6,180)
		write (6,220) (i,b(i,m+1),i=1,m)
c
c     test for disparity of ratio of singular values.
c    ..
		krank=n
		tau=rho*s(1)
		     do 40 i=1,n
		     if (s(i).le.tau) go to 50
   40		     continue
		go to 55
   50		krank=i-1
   55 write(6,250) tau, krank
c     compute solution vector assuming pseudorank is krank
c     ..
   60		     do 70 i=1,krank
   70		     b(i,m+1)=b(i,m+1)/s(i)
		     do 90 i=1,n
		     sm=0.d0
			  do 80 j=1,krank
   80			  sm=sm+a(i,j)*dble(b(j,m+1))
   90		     x(i)=sm
c     compute predicted norm of residual vector.
c     ..
		srsmsq=0.
		if (krank.eq.m) go to 110
		kp1=krank+1
		     do 100 i=kp1,m
  100		     srsmsq=srsmsq+b(i,m+1)**2
		srsmsq=sqrt(srsmsq)
c
  110		continue
		write (6,190)
		write (6,220) (i,x(i),i=1,n)
		write (6,200) srsmsq
c     compute the frobenius norm of  a**t- v*(s,0)*u**t.
c
c     compute  v*s  first.
c
		minmn=min0(m,n)
		     do 120 j=1,minmn
			  do 120 i=1,n
  120			  a(i,j)=a(i,j)*s(j)
		dn=0.
		     do 140 j=1,m
			  do 140 i=1,n
			  sm=0.d0
			       do 130 l=1,minmn
  130			       sm=sm+a(i,l)*dble(b(l,j))
c     computed difference of (i,j) th entry
c     of  a**t-v*(s,0)*u**t.
c     ..
			  t=aa(j,i)-sm
  140			  dn=dn+t**2
		dn=sqrt(dn)/(sqrt(float(n))*s(1))
		write (6,210) dn
  150		continue
      stop
  160 format (1h0////9h0   m   n/1x,2i4)
  170 format (1h0,8x,25hsingular values of matrix)
  180 format (1h0,8x,30htransformed right side, u**t*b)
  190 format (1h0,8x,33hestimated parameters,  x=a**(+)*b,21h computed b
     1y 'svdrs' )
  200 format (1h0,8x,24hresidual vector length =,e12.4)
  210 format (1h0,8x,43hfrobenius norm (a-u*(s,0)**t*v**t)/(sqrt(n),
     *22h*spectral norm of a) =,e12.4)
  220 format (9x,i5,e16.8,i5,e16.8,i5,e16.8,i5,e16.8,i5,e16.8)
  230 format(51h1prog3.     this program demonstrates the algorithm,
     * 9h, svdrs. )
  240 format(55h0the relative noise level of the generated data will be,
     *e16.4/44h0the relative tolerance, rho, for pseudorank,
     *17h determination is,e16.4)
  250 format(1h0,8x,36habsolute pseudorank tolerance, tau =,
     *e12.4,10x,12hpseudorank =,i5)
      end

      SUBROUTINE slDSC6 (A, B, R, AD, BD, RD, V)
*+
*     - - - - - -
*      D S C 6
*     - - - - - -
*
*  Conversion of position & velocity in spherical coordinates
*  to Cartesian coordinates
*
*  (double precision)
*
*  Given:
*     A     dp      longitude (radians)
*     B     dp      latitude (radians)
*     R     dp      radial coordinate
*     AD    dp      longitude derivative (radians per unit time)
*     BD    dp      latitude derivative (radians per unit time)
*     RD    dp      radial derivative
*
*  Returned:
*     V     dp(6)   Cartesian position & velocity vector
*
*  P.T.Wallace   Starlink   10 July 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION A,B,R,AD,BD,RD,V(6)

      DOUBLE PRECISION SA,CA,SB,CB,RCB,X,Y,RBD,W



*  Useful functions
      SA=SIN(A)
      CA=COS(A)
      SB=SIN(B)
      CB=COS(B)
      RCB=R*CB
      X=RCB*CA
      Y=RCB*SA
      RBD=R*BD
      W=RBD*SB-CB*RD

*  Position
      V(1)=X
      V(2)=Y
      V(3)=R*SB

*  Velocity
      V(4)=-Y*AD-W*CA
      V(5)=X*AD-W*SA
      V(6)=RBD*CB+SB*RD

      END

C--------------------------------------------------------------------------
        subroutine ftpssb(iunit,group,naxis,naxes,fpixel,lpixel,
     &                    array,status)

C       Write a subsection of byte values to the primary array.
C       A subsection is defined to be any contiguous rectangular
C       array of pixels within the n-dimensional FITS data file.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       iunit   i  Fortran input unit number
C       group   i  number of the data group to be written, if any
C       naxis   i  number of data axes in the FITS array
C       naxes   i  (array) size of each FITS axis
C       fpixel  i  (array) the first pixel in each dimension to be included
C                  in the subsection (first pixel = 1)
C       lpixel  i  (array) the last pixel in each dimension to be included
C                  in the subsection
C       array   c*1  array of values to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, Feb 1992

        integer iunit,group,naxis,naxes(*),fpixel(*),lpixel(*),status
        character*1 array(*)
        integer fpix(7),irange(7),dimen(7),astart,pstart
        integer off2,off3,off4,off5,off6,off7
        integer st10,st20,st30,st40,st50,st60,st70
        integer st1,st2,st3,st4,st5,st6,st7
        integer i,i1,i2,i3,i4,i5,i6,i7
        character caxis*20

        if (status .gt. 0)return

        if (naxis .lt. 1 .or. naxis .gt. 7)then
C               this routine only supports up to 7 dimensions
                status=320
                write(caxis,1001)naxis
1001            format(i20)
                call ftpmsg('NAXIS ='//caxis//' in the call to FTPSSB '
     &          //'is illegal.')
                return
        end if

C       calculate the sizes and number of loops to perform in each dimension
        do 10 i=1,7
             fpix(i)=1
             irange(i)=1
             dimen(i)=1
10      continue

        do 20 i=1,naxis
             fpix(i)=fpixel(i)
             irange(i)=lpixel(i)-fpixel(i)+1
             dimen(i)=naxes(i) 
20      continue
        i1=irange(1)

C       compute the pixel offset between each dimension
        off2=     dimen(1)
        off3=off2*dimen(2)
        off4=off3*dimen(3)
        off5=off4*dimen(4)
        off6=off5*dimen(5)
        off7=off6*dimen(6)

        st10=fpix(1)
        st20=(fpix(2)-1)*off2
        st30=(fpix(3)-1)*off3
        st40=(fpix(4)-1)*off4
        st50=(fpix(5)-1)*off5
        st60=(fpix(6)-1)*off6
        st70=(fpix(7)-1)*off7

C       store the initial offset in each dimension
        st1=st10
        st2=st20
        st3=st30
        st4=st40
        st5=st50
        st6=st60
        st7=st70

        astart=1

        do 170 i7=1,irange(7)
        do 160 i6=1,irange(6)
        do 150 i5=1,irange(5)
        do 140 i4=1,irange(4)
        do 130 i3=1,irange(3)
        pstart=st1+st2+st3+st4+st5+st6+st7
        do 120 i2=1,irange(2)
                call ftpprb(iunit,group,pstart,i1,
     &              array(astart),status)
                astart=astart+i1
                pstart=pstart+off2
120     continue
        st2=st20
        st3=st3+off3        
130     continue
        st3=st30
        st4=st4+off4
140     continue
        st4=st40
        st5=st5+off5
150     continue
        st5=st50
        st6=st6+off6
160     continue
        st6=st60
        st7=st7+off7
170     continue
        end        

c function area.f
c
c source
c   Bevington, pages 272-273.
c
c purpose
c   integrate the area beneath a set of data points
c
c usage
c   result = area (x, y, npts, nterms)
c
c description of parameters
c   x	   - array of data points for independent variable
c   y	   - array of data points for dependent variable
c   npts   - number of pairs of data points
c   nterms - number of terms in fitting polynomial
c
c subroutines and function subprograms required
c   integ (x, y, nterms, i1, x1, x2 sum)
c      fits a polynomial with nterms starting at i1
c      and integrates area from x1 to x2
c
	function area (x,y,npts,nterms)
	double precision sum
	dimension x(1),y(1)
11	sum=0.
	if (npts-nterms) 21,21,13
13	neven=2*(nterms/2)
	idelta=nterms/2-1
	if (nterms-neven) 31,31,51
c
c fit all points with one curve
c
21	x1=x(1)
	x2=x(npts)
23	call integ (x,y,npts,1,x1,x2,sum)
	goto 71
c
c even number of terms
c
31	x1=x(1)
	j=nterms-idelta
	x2=x(j)
	call integ (x,y,nterms,1,x1,x2,sum)
	i1=npts-nterms+1
	j=i1+idelta
	x1=x(j)
	x2=x(npts)
39	call integ (x,y,nterms,i1,x1,x2,sum)
	if (i1-2) 71,71,41
41	imax=i1-1
	do 46 i=2,imax
	j=i+idelta
	x1=x(j)
	x2=x(j+1)
46	call integ (x,y,nterms,i,x1,x2,sum)
	goto 71
c
c odd number of terms
c
51	x1=x(1)
	j=nterms-idelta
	x2=(x(j)+x(j-1))/2.
	call integ (x,y,nterms,1,x1,x2,sum)
	i1=npts-nterms+1
	j=i1+idelta
	x1=(x(j)+x(j+1))/2.
	x2=x(npts)
59	call integ (x,y,nterms,i1,x1,x2,sum)
	if (i1-2) 71,71,61
61	imax=i1-1
	do 66 i=2,imax
	j=i+idelta
	x1=(x(j+1)+x(j))/2.
	x2=(x(j+2)+x(j+1))/2.
66	call integ (x,y,nterms,i,x1,x2,sum)
71	area=sum
	return
	end

C----------------------------------------------------------------------
        subroutine ftghdn(iunit,hdunum)

C       return the number of the current header data unit.  The
C       first HDU (the primary array) is number 1.

C       iunit   i  fortran unit number
C       hdunum  i  returned number of the current HDU 
C
C       written by Wm Pence, HEASARC/GSFC, March, 1993

        integer iunit,hdunum

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nb,ne
        parameter (nb = 20)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        hdunum=chdu(bufnum(iunit))
        end        

      SUBROUTINE CONRAN (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C
C    SUBROUTINE CONRAN(XD,YD,ZD,NDP,WK,IWK,SCRARR)
C    STANDARD AND SMOOTH VERSIONS OF CONRAN
C
C          DIMENSION OF  XD(NDP),YD(NDP),ZD(NDP),WK(13*NDP)
C             ARGUMENTS  IWK((27+NCP)*NDP),SCRARR(RESOLUTION**2)
C                        WHERE NCP = 4 AND RESOLUTION = 40 BY
C                        DEFAULT.
C
C       LATEST REVISION  JULY 1984
C
C              OVERVIEW  CONRAN  PERFORMS  CONTOURING  OF  IRREGULARLY
C                        DISTRIBUTED  DATA.   IT IS THE STANDARD AND
C                        SMOOTH MEMBERS OF THE CONRAN FAMILY. THIS
C                        VERSION  WILL  PLOT CONTOURS; SMOOTH THEM USING
C                        SPLINES  UNDER  TENSION (IF THE PACKAGE DASHSMTH
C                        IS LOADED); PLOT A PERIMETER OR GRID; TITLE THE
C                        PLOT; PRINT A MESSAGE GIVING THE CONTOUR INTERVALS
C                        BELOW THE MAP; PLOT THE INPUT DATA ON THE MAP;
C                        AND LABEL THE CONTOUR LINES.
C
C               PURPOSE  CONRAN  PLOTS  CONTOUR  LINES  USING  RANDOM,
C                        SPARSE  OR  IRREGULAR DATA SETS.  THE DATA IS
C                        TRIANGULATED AND THEN CONTOURED.   CONTOURING
C                        IS  PERFORMED USING INTERPOLATION OF THE TRI-
C                        ANGULATED DATA.  THERE ARE TWO METHODS OF
C                        INTERPOLATION:  C1 SURFACES AND LINEAR.
C
C                 USAGE  CALL CONRAN(XD,YD,ZD,NDP,WK,IWK,SCRARR)
C                        AN OPTION SETTING ROUTINE  CAN  ALSO  BE  IN-
C                        VOKED,  SEE  WRITEUP  BELOW.   FRAME  MUST BE
C                        CALLED BY THE USER.
C
C                        IF DIFFERENT COLORS (OR INTENSITIES) ARE TO BE
C                        USED FOR NORMAL INTENSITY, LOW INTENSITY OR
C                        TEXT OUTPUT, THEN THE VALUES IN COMMON BLOCK
C                        RANINT SHOULD BE CHANGED:
C
C                        IRANMJ  COLOR INDEX FOR NORMAL (MAJOR) INTENSITY
C                                LINES.
C                        IRANMN  COLOR INDEX FOR LOW INTENSITY LINES
C                        IRANTX  COLOR INDEX FOR TEXT (LABELS)
C
C
C             ARGUMENTS
C
C              ON INPUT  XD
C                            ARRAY OF DIMENSION NDP CONTAINING THE  X-
C                            COORDINATES OF THE DATA POINTS.
C
C                        YD
C                            ARRAY OF DIMENSION NDP CONTAINING THE  Y-
C                            COORDINATES OF THE DATA POINTS.
C
C                        ZD
C                            ARRAY OF  DIMENSION  NDP  CONTAINING  THE
C                            DATA VALUES AT THE POINTS.
C
C                        NDP
C                            NUMBER OF  DATA  POINTS  (MUST  BE  4  OR
C                            GREATER) TO BE CONTOURED.
C
C                        WK
C                            REAL WORK ARRAY  OF  DIMENSION  AT  LEAST
C                            13*NDP
C
C                        IWK
C                            INTEGER WORK ARRAY.  WHEN USING C1 SURFACES
C                            THE ARRAY MUST BE AT LEAST IWK((27+NCP)*NDP).
C                            WHEN USING LINEAR INTERPOLATION THE ARRAY
C                            MUST BE AT LEAST IWK((27+4)*NDP).
C
C                        SCRARR
C                            REAL WORK ARRAY  OF  DIMENSION  AT  LEAST
C                            (RESOLUTION**2)   WHERE   RESOLUTION   IS
C                            DESCRIBED IN THE SSZ OPTION BELOW.  RESO-
C                            LUTION IS 40 BY DEFAULT.
C
C             ON OUTPUT  ALL ARGUMENTS  REMAIN  UNCHANGED  EXCEPT  THE
C                        SCRATCH ARRAYS IWK, WK, AND SCRARR WHICH HAVE
C                        BEEN WRITTEN INTO.  IF MAKING  MULTIPLE  RUNS
C                        ON  THE SAME TRIANGULATION IWK AND WK MUST BE
C                        SAVED AND RETURNED TO THE NEXT INVOCATION  OF
C                        CONRAN.
C
C          ENTRY POINTS  CONRAN, CONDET, CONINT, CONCAL, CONLOC, CONTNG,
C                        CONDRW, CONCLS, CONSTP, CONBDN, CONTLK
C                        CONPDV, CONOP1, CONOP2, CONOP3, CONOP4,
C                        CONXCH, CONREO, CONCOM, CONCLD, CONPMM,
C                        CONGEN, CONLOD, CONECD, CONOUT, CONOT2,
C                        CONSLD, CONLCM, CONLIN, CONDSD, CONSSD
C
C         COMMON BLOCKS  CONRA1, CONRA2, CONRA3, CONRA4, CONRA5, CONRA6,
C                        CONRA7, CONRA8, CONRA9, CONR10, CONR11, CONR12,
C                        CONR13, CONR14, CONR15, CONR16, CONR17, RANINT
C                        INTPR FROM THE DASH PACKAGE
C
C                   I/O  PLOTS THE CONTOUR MAP AND, VIA  THE ERPRT77
C                        PACKAGE,  OUTPUTS  MESSAGES  TO  THE MESSAGE
C                        OUTPUT  UNIT; AT  NCAR  THIS  UNIT  IS  THE
C                        PRINTER.  THE OPTION VALUES ARE ALL LISTED ON
C                        STANDARD ERPRT77 OUTPUT UNIT; AT NCAR THIS
C                        UNIT IS THE PRINTER.
C
C             PRECISION  SINGLE
C
C      REQUIRED LIBRARY  STANDARD VERSION: DASHCHAR, WHICH AT NCAR IS
C              ROUTINES  LOADED BY DEFAULT.
C                        SMOOTH VERSION: DASHSMTH WHICH MUST BE
C                        REQUESTED AT NCAR.
C                        BOTH VERSIONS REQUIRE CONCOM, CONTERP, GRIDAL
C                        THE ERPRT77 PACKAGE, AND THE SPPS.
C
C              LANGUAGE  FORTRAN77
C
C               HISTORY
C
C             ALGORITHM  THE SPARSE DATA IS TRIANGULATED AND A VIRTUAL
C                        GRID  IS  LAID  OVER  THE  TRIANGULATED AREA.
C                        EACH VIRTUAL GRID POINT RECEIVES AN  INTERPO-
C                        LATED  VALUE.   THE  GRID IS SCANNED ONCE FOR
C                        EACH CONTOUR LEVEL AND ALL CONTOURS  AT  THAT
C                        LEVEL ARE PLOTTED.
C                        THERE ARE TWO METHODS OF INTERPOLATION. THE
C                        FIRST IS A SMOOTH DATA INTERPOLATION
C                        SCHEME BASED  ON  LAWSON'S  C1
C                        SURFACE  INTERPOLATION  ALGORITHM,  WHICH HAS
C                        BEEN REFINED  BY  HIROSHA  AKIMA.   PARTS  OF
C                        AKIMA'S  ALGORITHM  ARE USED IN THIS PACKAGE.
C                        SEE THE "REFERENCE" SECTION BELOW.
C                        THE SECOND IS A LINEAR INTERPOLATION SCHEME.
C                        WHEN DATA IS SPARSE IT IS USUALLY BETTER TO
C                        USE THE C1 INTERPOLATION.  IF YOU HAVE DENSE
C                        DATA (OVER 100 POINTS) THEN THE LINEAR
C                        INTERPOLATION WILL GIVE THE BETTER RESULTS.
C
C           PORTABILITY  ANSI FORTRAN
C
C
C             OPERATION  CALL CONRAN (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C
C                        FRAME MUST BE CALLED BY THE USER.
C
C                        CONRAN HAS MANY OPTIONS, EACH OF WHICH MAY
C                        BE CHANGED BY CALLING ONE OF THE FOUR
C                        SUBROUTINES CONOP1, CONOP2, CONOP3, OR
C                        CONOP4.  THE NUMBER OF ARGUMENTS TO EACH
C                        CONOP ROUTINE IS THE SAME AS THE FINAL
C                        SUFFIX CHARACTER IN THE ROUTINE'S NAME.
C
C                        THE CONOP ROUTINES ARE CALLED BEFORE CONRAN
C                        IS CALLED, AND VALUES SET BY THESE CALLS
C                        CONTINUE TO BE IN EFFECT UNTIL THEY ARE
C                        CHANGED BY ANOTHER CALL TO A CONOP ROUTINE.
C
C                        ALL THE CONOP ROUTINES HAVE AS THEIR FIRST
C                        ARGUMENT A CHARACTER STRING TO IDENTIFY THE
C                        OPTION BEING CHANGED.  THIS IS THE ONLY
C                        ARGUMENT TO CONOP1.  CONOP2 HAS AN INTEGER
C                        SECOND ARGUMENT.  CONOP3 HAS A REAL ARRAY (OR
C                        CONSTANT) AS ITS SECOND ARGUMENT AND AN
C                        INTEGER (USUALLY THE DIMENSION OF THE
C                        ARRAY) AS ITS THIRD ARGUMENT.  CONOP4 HAS A
C                        CHARACTER STRING AS ITS SECOND ARGUMENT AND
C                        INTEGERS FOR THE THIRD AND FOURTH ARGUMENTS.
C
C                        ONLY THE FIRST TWO CHARACTERS ON EACH SIDE OF
C                        THE EQUAL SIGN ARE SCANNED.  THEREFORE ONLY 2
C                        CHARACTERS  FOR  EACH  OPTION ARE REQUIRED ON
C                        INPUT TO CONOP (I.E.  'SCA=PRI'  AND  'SC=PR'
C                        ARE EQUIVALENT.)
C
C                        REMEMBER, THERE MUST BE AT LEAST 4 DATA POINTS.
C                        THIS IS EQUAL TO  THE  DEFAULT  NUMBER OF
C                        DATA POINTS TO BE USED FOR ESTIMATION OF PAR-
C                        TIAL DERIVATIVES AT  EACH  DATA  POINT.
C                        THE ESTIMATED PARTIAL DERIVATIVES  ARE
C                        USED  FOR THE CONSTRUCTION OF THE INTERPOLAT-
C                        ING POLYNOMIAL'S COEFFICIENTS.
C
C                        LISTED BELOW ARE OPTIONS WHICH CAN ENHANCE
C                        YOUR PLOT.  AN EXAMPLE OF AN APPROPRIATE
C                        CONOP CALL IS GIVEN FOR EACH OPTION.  A
C                        COMPLETE LIST OF DEFAULT SETTINGS FOLLOWS
C                        THE LAST OPTION.
C
C               OPTIONS
C
C                   CHL  THIS FLAG DETERMINES HOW  THE  HIGH  AND  LOW
C                        CONTOUR VALUES ARE SET.  THESE CONTOUR VALUES
C                        MAY BE SET BY THE PROGRAM OR BY THE USER.  IF
C                        CHL=OFF,  THE PROGRAM EXAMINES THE USER'S IN-
C                        PUT DATA AND DETERMINES BOTH THE HIGH AND LOW
C                        VALUES.  IF CHL=ON, THE USER MUST SPECIFY THE
C                        DESIRED HIGH (HI) AND LOW (FLO) VALUES.
C                        THE DEFAULT IS CHL=OFF.
C
C                        IF PROGRAM SET:   CALL CONOP3('CHL=OFF',0.,0)
C
C                        IF USER SET:  CALL CONOP3('CHL=ON',ARRAY,2)
C                                WHERE ARRAY(1)=HI, ARRAY(2)=FLO
C
C                        NOTE: THE VALUES SUPPLIED FOR CONTOUR  INCRE-
C                        MENT  AND CONTOUR HIGH AND LOW VALUES ASSUMES
C                        THE UNSCALED DATA VALUES.  SEE THE SDC  FLAG,
C                        BELOW.
C
C                        EXAMPLE:  CALL   CONOP3('CHL=ON',ARRAY,2)
C                                  WHERE  ARRAY(1)=5020. (THE DESIRED
C                                  HIGH CONTOUR VALUE) AND ARRAY(2)=
C                                  2000 (THE DESIRED LOW CONTOUR VALUE).
C                                  THESE ARE FLOATING POINT NUMBERS.
C
C                   CIL  THIS FLAG DETERMINES HOW THE  CONTOUR  INCRE-
C                        MENT  (CINC) IS SET.  THE INCREMENT IS EITHER
C                        CALCULATED BY THE PROGRAM (CIL=OFF) USING THE
C                        RANGE  OF HIGH AND LOW VALUES FROM THE USER'S
C                        INPUT DATA, OR SET BY THE USER (CIL=ON). THE
C                        DEFAULT IS CIL=OFF.
C
C                        IF PROGRAM SET:   CALL CONOP3('CIL=OFF',0.,0)
C
C                        IF USER SET:      CALL CONOP3('CIL=ON',CINC,1)
C
C                        NOTE: BY DEFAULT,  THE  PROGRAM  WILL EXAMINE
C                        THE USER'S INPUT DATA AND DETERMINE THE CONTOUR
C                        INTERVAL (CINC)  AT SOME APPROPRIATE RANGE BETWEEN
C                        THE LEVEL OF HIGH AND LOW VALUES SUPPLIED, USUALLY
C                        GENERATING BETWEEN 15 AND 20 CONTOUR LEVELS.
C                        ELS.
C
C                        EXAMPLE:          CALL CONOP3('CIL=ON',15.,1)
C                                          WHERE  15.  REPRESENTS  THE
C                                          CONTOUR  INCREMENT  DESIRED
C                                          BY THE USER.
C
C                   CON  THIS FLAG DETERMINES HOW THE  CONTOUR  LEVELS
C                        ARE  SET.   IF  CON=ON, THE USER MUST SPECIFY
C                        THE ARRAY OF CONTOUR VALUES AND THE NUMBER OF
C                        CONTOUR LEVELS.  A  MAXIMUM OF 30 CONTOUR (NCL)
C                        LEVELS ARE PERMITTED.  IF CON=OFF,  DEFAULT
C                        VALUES  ARE  USED.  IN THIS CASE, THE PROGRAM
C                        WILL CALCULATE THE VALUES FOR THE  ARRAY  AND
C                        NCL USING INPUT DATA.  THE DEFAULT IS OFF.
C
C                        IF PROGRAM SET:   CALL CONOP3('CON=OFF',0.,0)
C
C                        IF USER SET:   CALL CONOP3('CON=ON',ARRAY,NCL)
C
C                        NOTE: THE ARRAY (ARRAY) CONTAINS THE  CONTOUR
C                        LEVELS  (FLOATING  POINT ONLY) AND NCL IS THE
C                        NUMBER OF LEVELS.  THE MAXIMUM NUMBER OF CON-
C                        TOUR LEVELS ALLOWED IS 30.  WHEN ASSIGNING
C                        THE ARRAY OF CONTOUR VALUES, THE VALUES MUST
C                        BE ORDERED FROM SMALLEST TO LARGEST.
C
C                        EXAMPLE:
C                         DATA RLIST(1),...,RLIST(5)/1.,2.,3.,10.,12./
C
C                                  CALL CONOP3('CON=ON',RLIST,5) WHERE
C                                  'RLIST' CONTAINS THE USER SPECIFIED
C                                  CONTOUR LEVELS, AND 5  IS  THE
C                                  NUMBER  OF  USER  SPECIFIED CONTOUR
C                                  LEVELS (NCL).
C
C                        WARNING ON CONTOUR OPTIONS:
C                        IT IS ILLEGAL TO USE THE CON OPTION WHEN
C                        EITHER  CIL  OR  CHL  ARE ACTIVATED.  IF
C                        THIS IS DONE, THE OPTION CALL THAT DETECTED
C                        THE ERROR WILL NOT BE EXECUTED.
C
C                   DAS  THIS  FLAG  DETERMINES  WHICH  CONTOURS   ARE
C                        REPRESENTED  BY  DASHED LINES.  THE USER SETS
C                        THE DASHED LINE PATTERN.  THE USER MAY SPECI-
C                        FY  THAT  DASHED  LINES  BE USED FOR CONTOURS
C                        WHOSE  VALUE  IS  LESS  THAN,  EQUAL  TO,  OR
C                        GREATER THAN THE DASH PATTERN BREAKPOINT (SEE
C                        THE DBP OPTION BELOW), WHICH IS ZERO BY
C                        DEFAULT.  IF DAS=OFF (THE DEFAULT VALUE), ALL
C                        SOLID LINES ARE USED.
C
C                        ALL SOLID LINES: CALL CONOP4('DAS=OFF',' ',0,0)
C
C                        IF GREATER:      CALL CONOP4('DAS=GTR',PAT,0,0)
C
C                        IF EQUAL:        CALL CONOP4('DAS=EQU',PAT,0,0)
C
C                        IF LESS:         CALL CONOP4('DAS=LSS',PAT,0,0)
C
C                        IF ALL SAME:     CALL CONOP4('DAS=ALL',PAT,0,0)
C
C                        NOTE: PAT MUST BE A TEN CHARACTER
C                        STRING WITH A DOLLAR SIGN ($) FOR SOLID AND A
C                        SINGLE QUOTE (') FOR BLANK.  RECALL THAT IN
C                        FORTRAN 77, IN A QUOTED STRING A SINGLE QUOTE
C                        IS REPRESENTED BY TWO SINGLE QUOTES ('').
C
C                        EXAMPLE:
C                          CALL CONOP4('DAS=GTR','$$$$$''$$$$',0,0)
C
C                   DBP  THIS FLAG DETERMINES  HOW  THE  DASH  PATTERN
C                        BREAK POINT (BP) IS SET.  IF DBP=ON, BP  MUST
C                        BE SET BY THE  USER  BY  SPECIFYING  BP.   IF
C                        DBP=OFF  THE  PROGRAM  WILL SET BP TO THE
C                        DEFAULT VALUE WHICH IS ZERO.
C
C                        IF PROGRAM SET:   CALL CONOP3('DBP=OFF',0.,0)
C
C                        IF USER SET:      CALL CONOP3('DBP=ON',BP,1)
C
C                        NOTE: BP IS A FLOATING POINT NUMBER WHERE THE
C                        BREAK  FOR  GTR AND LSS CONTOUR DASH PATTERNS
C                        ARE DEFINED.  BP IS ASSUMED TO BE GIVEN RELA-
C                        TIVE TO THE UNTRANSFORMED CONTOURS.
C
C                        EXAMPLE:          CALL CONOP3('DBP=ON',5.,1)
C                                          WHERE 5. IS THE USER SPECI-
C                                          FIED BREAK POINT.
C
C                   DEF  RESET FLAGS TO  DEFAULT  VALUES.   ACTIVATING
C                        THIS  OPTION  SETS  ALL  FLAGS TO THE DEFAULT
C                        VALUE.  DEF HAS NO 'ON' OF 'OFF' STATES.
C
C                        TO ACTIVATE:   CALL CONOP1('DEF')
C
C                   EXT  FLAG TO SET EXTRAPOLATION. NORMALLY ALL
C                        CONRAN VERSIONS WILL  ONLY PLOT THE BOUNDARIES
C                        OF THE CONVEX HULL DEFINED BY THE USER'S DATA.
C                        TO HAVE THE CONTOURS FILL THE RECTANGULAR
C                        AREA OF THE FRAME, SET THE EXT SWITCH ON.
C                        THE DEFAULT IS OFF.
C
C                        TO TURN ON:    CALL CONOP1('EXT=ON')
C
C                        TO TURN OFF:   CALL CONOP1('EXT=OFF')
C
C                   FMT  FLAG FOR THE FORMAT OF THE PLOTTED INPUT DATA
C                        VALUES.   IF  FMT=OFF, THE DEFAULT VALUES FOR
C                        FT, L, AND IF ARE USED.  THE  DEFAULT  VALUES
C                        ARE:
C
C                        FT = '(G10.3)'
C                        L  = 7  CHARACTERS INCLUDING THE PARENTHESES
C                        IF = 10 CHARACTERS PRINTED IN THE OUTPUT
C                             FIELD BY THE FORMAT
C
C                        IF FMT=ON, THE USER MUST SPECIFY  VALUES  FOR
C                        FT,  L,  AND  IF.   ALL USER SPECIFIED VALUES
C                        MUST BE GIVEN IN THE CORRECT FORMAT.
C
C                        IF PROGRAM SET:  CALL CONOP4('FMT=OFF',' ',0,0)
C
C                        IF USER SET:  CALL CONOP4('FMT=ON',FT,L,IF)
C
C                        NOTE: FT IS A CHARACTER STRING CONTAINING THE
C                        FORMAT.   THE  FORMAT  MUST  BE  ENCLOSED  IN
C                        PARENTHESES.  ANY  FORMAT, UP TO 10 CHARACTERS
C                        WHICH IS  ALLOWED  AT  YOUR INSTALLATION WILL BE
C                        ACCEPTED.  L IS THE NUMBER OF  CHARACTERS  IN
C                        FT.  IF IS THE LENGTH OF THE FIELD CREATED BY
C                        THE FORMAT.
C
C                        EXAMPLE:  CALL CONOP4('FMT=ON','(G30.2)',7,30)
C
C                        WARNING: CONRAN WILL NOT  TEST  FOR  A  VALID
C                        FORMAT.  THE FORMAT IS ONLY ALLOWED TO BE
C                        10 CHARACTERS LONG.
C
C                   GRI  FLAG TO DISPLAY THE GRID. GRI IS OFF BY DEFAULT.
C
C                        TO TURN ON:    CALL CONOP1('GRI=ON')
C
C                        TO TURN OFF:   CALL CONOP1('GRI=OFF')
C
C                        NOTE: IF GRI IS ON, THE VIRTUAL GRID WILL
C                        BE SUPERIMPOSED OVER THE CONTOUR PLOT.
C                        THE X AND Y TICK INTERVALS WILL BE DISPLAYED
C                        UNDER THE MAP ONLY IF PER=ON.  (SEE PER)
C
C                   INT  FLAG TO DETERMINE THE INTENSITIES OF THE CON-
C                        TOUR  LINES  AND OTHER PARTS OF THE PLOT.  IF
C                        INT=OFF,  ALL INTENSITIES ARE SET TO THE DEFAULT
C                        VALUES.  IF INT=ALL, ALL INTENSITIES ARE SET
C                        TO THE GIVEN VALUE, IVAL.  IF INT IS SET TO
C                        ONE OF THE OTHER POSSIBLE OPTIONS (MAJ, MIN,
C                        LAB OR DAT), THE INTENSITY LEVEL FOR THAT
C                        OPTION IS SET TO THE GIVEN VALUE, IVAL.
C
C                        IF PROGRAM SET:   CALL CONOP2('INT=OFF',0)
C
C                        ALL THE SAME:     CALL  CONOP2('INT=ALL',IVAL)
C
C                        MAJOR LINES:      CALL CONOP2('INT=MAJ',IVAL)
C
C                        MINOR LINES:      CALL CONOP2('INT=MIN',IVAL)
C
C                        TITLE AND MESSAGE:
C                                          CALL  CONOP2('INT=LAB',IVAL)
C
C                        DATA VALUES:      CALL  CONOP2('INT=DAT',IVAL)
C
C                        NOTE: 'INT=DAT' RELATES TO THE PLOTTED DATA
C                        VALUES AND THE PLOTTED MAXIMUMS AND MINIMUMS.
C
C                        NOTE: IVAL IS THE INTENSITY DESIRED.  FOR  AN
C                        EXPLANATION  OF THE OPTION VALUE SETTINGS SEE
C                        THE OPTN ROUTINE  IN  THE  NCAR  SYSTEM  PLOT
C                        PACKAGE DOCUMENTATION.  BRIEFLY, IVAL  VALUES
C                        RANGE FROM 0 TO 255 OR THE CHARACTER  STRINGS
C                        'LO'  AND  'HI'.   THE DEFAULT IS 'HI' EXCEPT
C                        FOR INT=MIN WHICH IS SET TO 'LO'.
C
C                        EXAMPLE:           CALL CONOP2('INT=ALL',110)
C
C                   ITP  SET THE INTERPOLATION SCHEME.
C                        THERE ARE TWO SCHEMES--C1 SURFACES AND LINEAR.
C                        THE C1 METHOD TAKES LONGER BUT WILL GIVE THE
C                        BEST RESULTS WHEN THE DATA IS SPARSE (LESS
C                        THAN 100 POINTS).  THE LINEAR METHOD WILL
C                        PRODUCE A BETTER PLOT WHEN THERE IS A DENSE
C                        DATA SET.  THE DEFAULT IS C1 SURFACE.
C
C                        FOR C1 SURFACE   CALL CONOP1('ITP=C1')
C
C                        FOR LINEAR       CALL CONOP1('ITP=LIN')
C
C                   LAB  THIS FLAG CAN BE SET TO EITHER LABEL THE CON-
C                        TOURS (LAB=ON) OR NOT (LAB=OFF).  THE DEFAULT
C                        VALUE IS LAB=ON.
C
C                        TO TURN ON:    CALL CONOP1('LAB=ON')
C
C                        TO TURN OFF:   CALL CONOP1('LAB=OFF')
C
C                   LOT  FLAG TO LIST OPTIONS ON THE PRINTER.  THE DE-
C                        FAULT  VALUE  IS  SET  TO OFF, AND NO OPTIONS
C                        WILL BE DISPLAYED.
C
C                        TO TURN ON:    CALL CONOP1('LOT=ON')
C
C                        TO TURN OFF:   CALL CONOP1('LOT=OFF')
C
C                        NOTE: IF  USERS  WANT  TO  PRINT  THE  OPTION
C                        VALUES, THEY SHOULD TURN THIS OPTION ON.  THE
C                        OPTION VALUES WILL BE SENT  TO  THE  STANDARD
C                        OUTPUT  UNIT  AS  DEFINED BY THE SUPPORT
C                        ROUTINE I1MACH.
C
C                   LSZ  THIS FLAG  DETERMINES  THE  LABEL  SIZE.   IF
C                        LSZ=OFF,  THE  DEFAULT ISZLSZ VALUE WILL BE
C                        USED.  IF LSZ=ON,  THE  USER  SHOULD  SPECIFY
C                        ISZLSZ.   THE  DEFAULT VALUE IS 9 PLOTTER
C                        ADDRESS UNITS.
C
C                        IF PROGRAM SET:   CALL CONOP2('LSZ=OFF',0)
C
C                        IF USER SET:   CALL CONOP2('LSZ=ON',ISZLSZ)
C
C                        NOTE: ISZLSZ  IS  THE  REQUESTED  CHARACTER
C                        SIZE IN PLOTTER ADDRESS UNITS.
C
C                        EXAMPLE:          CALL CONOP2('LSZ=ON',4)
C                                          WHERE 4 IS THE USER DESIRED
C                                          INTEGER PLOTTER ADDRESS
C                                          UNITS.
C
C                   MES  FLAG TO PLOT A MESSAGE. THE DEFAULT IS ON.
C
C                        TO TURN ON:    CALL CONOP1('MES=ON')
C
C                        TO TURN OFF:   CALL CONOP1('MES=OFF')
C
C                        NOTE: IF MES=ON, A MESSAGE IS  PRINTED   BELOW
C                        THE  PLOT GIVING CONTOUR INTERVALS AND EXECU-
C                        TION TIME IN SECONDS.  IF PER OR GRI ARE  ON,
C                        THE  MESSAGE  ALSO  CONTAINS THE X AND Y TICK
C                        INTERVALS.
C
C                   NCP  FLAG TO INDICATE THE NUMBER OF DATA POINTS
C                        USED FOR THE PARTIAL DERIVATIVE
C                        ESTIMATION.   IF NCP=OFF, NUM IS SET TO
C                        4, WHICH IS THE DEFAULT  VALUE.   IF  NCP=ON,
C                        THE  USER  MUST  SPECIFY  NUM GREATER THAN OR
C                        EQUAL TO 2.
C
C                        IF PROGRAM SET:   CALL CONOP2('NCP=OFF',0)
C
C                        IF USER SET:      CALL CONOP2('NCP=ON',NUM)
C
C                        NOTE: NUM = NUMBER OF DATA  POINTS  USED  FOR
C                        ESTIMATION.   CHANGING THIS VALUE EFFECTS THE
C                        CONTOURS PRODUCED AND THE SIZE OF INPUT ARRAY
C                        IWK.
C
C                        EXAMPLE:          CALL CONOP2('NCP=ON',3)
C
C                   PDV  FLAG TO PLOT THE INPUT DATA VALUES.  THE
C                        DEFAULT VALUE IS PDV=OFF.
C
C                        TO TURN ON:    CALL CONOP1('PDV=ON')
C
C                        TO TURN OFF:   CALL CONOP1('PDV=OFF')
C
C                        NOTE: IF PDV=ON, THE INPUT  DATA  VALUES  ARE
C                        PLOTTED  RELATIVE  TO  THEIR  LOCATION ON THE
C                        CONTOUR MAP.  IF YOU ONLY WISH TO SEE THE
C                        LOCATIONS  AND  NOT THE VALUES, SET PDV=ON AND
C                        CHANGE FMT TO PRODUCE AN ASTERISK (*) SUCH AS
C                        (I1).
C
C                   PER  FLAG TO SET THE PERIMETER.  THE DEFAULT VALUE
C                        IS  PER=ON,  WHICH  CAUSES  A PERIMETER TO BE
C                        DRAWN AROUND THE CONTOUR PLOT.
C
C                        TO TURN ON:    CALL CONOP1('PER=ON')
C
C                        TO TURN OFF:   CALL CONOP1('PER=OFF')
C
C                        NOTE: IF MES IS ON, THE X AND Y TICK INTERVALS
C                        WILL  BE GIVEN.  THESE ARE THE INTERVALS IN USER
C                        COORDINATES THAT EACH TICK MARK REPRESENTS.
C
C                   PMM  FLAG TO PLOT RELATIVE MINIMUMS AND MAXIMUMS.
C                        THIS FLAG IS OFF BY DEFAULT.
C
C                        TO TURN OFF:      CALL CONOP1('PMM=OFF')
C
C                        TO TURN ON:       CALL CONOP1('PMM=ON')
C
C                   PSL  FLAG WHICH SETS THE PLOT SHIELD OPTION.
C                        THE OUTLINE OF THE SHIELD WILL BE DRAWN ON
C                        THE SAME FRAME AS THE CONTOUR PLOT.
C                        BY DEFAULT THIS OPTION IS OFF.
C                        (SEE SLD OPTION).
C
C                        DRAW THE SHIELD:  CALL CONOP1('PSL=ON')
C
C                        DON'T DRAW IT:    CALL CONOP1('PSL=OFF')
C
C                   REP  FLAG INDICATING THE USE OF THE SAME DATA IN
C                        A NEW EXECUTION.  THE DEFAULT VALUE IS OFF.
C
C                        TO TURN ON:    CALL CONOP1('REP=ON')
C
C                        TO TURN OFF:   CALL CONOP1('REP=OFF')
C
C                        NOTE: IF REP=ON, THE SAME X-Y DATA AND TRIANGU-
C                        LATION  ARE  TO  BE  USED BUT IT IS ASSUMED
C                        THE USER HAS CHANGED CONTOUR VALUES OR RESOLUTION
C                        FOR THIS RUN.  SCRATCH ARRAYS WK AND IWK MUST
C                        REMAIN UNCHANGED.
C
C                   SCA  FLAG FOR SCALING OF THE PLOT ON A FRAME.
C                        THIS FLAG IS ON BY DEFAULT.
C
C                        USER SCALING:     CALL CONOP1('SCA=OFF')
C
C                        PROGRAM SCALING:  CALL CONOP1('SCA=ON')
C
C                        PRIOR WINDOW:     CALL CONOP1('SCA=PRI')
C
C                        NOTE:  WITH  SCA=OFF,  PLOTTING  INSTRUCTIONS
C                        WILL BE ISSUED USING THE USER'S INPUT COORDI-
C                        NATES, UNLESS THEY ARE TRANSFORMED VIA FX AND
C                        FY  TRANSFORMATIONS.   USERS WILL FIND AN
C                        EXTENDED DISCUSSION IN THE "INTERFACING WITH
C                        OTHER GRAPHICS ROUTINES" SECTION BELOW.  THE SCA
C                        OPTION  ASSUMES  THAT ALL INPUT DATA FALLS INTO
C                        THE CURRENT WINDOW SETTING.  WITH SCA=ON, THE
C                        ENTRY POINT WILL ESTABLISH A VIEWPORT SO THAT
C                        THE USER'S PLOT WILL FIT INTO THE  CENTER  90
C                        PERCENT OF THE FRAME.  WHEN SCA=PRI, THE
C                        PROGRAM  MAPS THE USER'S PLOT INSTRUCTIONS  INTO
C                        THE  PORTION OF THE FRAME DEFINED BY THE
C                        CURRENT NORMALIZATION TRANSFORMATION.  SCA=OFF
C                        SHOULD BE USED TO INTERFACE WITH EZMAP.
C
C                   SDC  FLAG TO DETERMINE HOW TO SCALE  THE  DATA  ON
C                        THE CONTOURS.  IF SDC=OFF, THE FLOATING POINT
C                        VALUE IS GIVEN BY SCALE.  IF SDC=ON, THE USER
C                        MAY SPECIFY SCALE.  THE DEFAULT VALUE FOR SCALE
C                        IS 1.
C
C                        IF PROGRAM SET:   CALL CONOP3('SDC=OFF',0.,0)
C
C                        IF USER SET:      CALL CONOP3('SDC=ON',SCALE,1)
C
C                        NOTE: THE DATA PLOTTED ON CONTOUR  LINES  AND
C                        THE  DATA  PLOTTED  FOR RELATIVE MINIMUMS AND
C                        MAXIMUMS WILL BE SCALED BY THE FLOATING POINT
C                        VALUE  GIVEN  BY SCALE.  TYPICAL SCALE VALUES
C                        ARE 10., 100., 1000., ETC.  THE ORIGINAL DATA
C                        VALUES ARE MULTIPLIED BY SCALE.  SCALE MUST BE
C                        A FLOATING POINT NUMBER AND IS DISPLAYED IN THE
C                        MESSAGE  (SEE  MES).
C
C                        EXAMPLE:          CALL CONOP2('SDC=ON',100.,1)
C
C                   SLD  ACTIVATE OR DEACTIVATE THE SHIELDING OPTION.
C                        WHEN THIS OPTION IS ACTIVATED,  ONLY THOSE
C                        CONTOURS WITHIN THE SHIELD ARE DRAWN. THE SHIELD
C                        IS A POLYGON SPECIFIED BY THE USER WHICH MUST
C                        BE GIVEN IN THE SAME COORDINATE RANGE AS THE
C                        THE DATA. IT MUST DEFINE ONLY ONE POLYGON.
C
C                        TO ACTIVATE THE SHIELD:
C                               CALL CONOP3('SLD=ON',ARRAY,ICSD)
C
C                        TO DEACTIVATE THE SHIELD:
C                               CALL CONOP3('SLD=OFF',0.,0)
C
C                        NOTE:  ARRAY IS A REAL ARRAY ICSD ELEMENTS LONG.
C                        THE FIRST ICSD/2 ELEMENTS ARE X COORDINATES AND
C                        THE SECOND ICSD/2 ELEMENTS ARE Y COORDINATES.
C                        ICSD IS THE LENGTH OF ENTIRE ARRAY, THE
C                        NUMBER OF (X + Y) SHIELD COORDS. THE POLYGON
C                        MUST BE CLOSED, THAT IS THE FIRST AND LAST
C                        POINTS DESCRIBING IT MUST BE THE SAME.
C
C                        EXAMPLE:       DIMENSION SHLD
C                                       DATA SHLD/ 7.,10.,10.,7.,7.,
C                                      1           7.,7.,10.,10.,7./
C                                       CALL CONOP3 (6HSLD=ON,SHLD,10)
C
C
C                   SML  FLAG TO DETERMINE THE  SIZE  OF  MINIMUM  AND
C                        MAXIMUM CONTOUR LABELS.  IF SML=OFF, THE
C                        ISZSML DEFAULT VALUE OF  15 IS  USED.
C                        IF SML=ON, THE USER MUST SPECIFY ISZSML.
C
C                        IF PROGRAM SET:   CALL CONOP2('SML=OFF',0)
C
C                        IF USER SET:  CALL CONOP2('SML=ON',ISZSML)
C
C                        NOTE: ISZSML IS AN INTEGER NUMBER WHICH  IS
C                        THE SIZE OF LABELS IN PLOTTER ADDRESS UNITS
C                        AS DEFINED IN THE SPPS ENTRY WTSTR.
C
C                        EXAMPLE:      CALL CONOP2('SML=ON',12)
C
C                   SPD  FLAG FOR THE SIZE OF THE PLOTTED  INPUT  DATA
C                        VALUES.  IF SPD=OFF, THE VALUE OF ISZSPD IS
C                        8, WHICH IS THE DEFAULT.  IF SPD=ON, THE USER
C                        MUST SPECIFY ISZSPD.
C
C                        IF PROGRAM SET:   CALL CONOP2('SPD=OFF',0)
C
C                        IF USER SET:   CALL CONOP2('SPD=ON',ISZSPD)
C
C                        NOTE: ISZSPD IS AN INTEGER NUMBER GIVING THE
C                        SIZE TO PLOT THE DATA VALUES IN PLOTTER ADDRESS
C                        UNITS AS DEFINED IN THE SPPS ENTRY WTSTR.    .
C
C                        EXAMPLE:          CALL CONOP2('SPD=ON',6)
C
C                   SSZ  FLAG TO DETERMINE THE RESOLUTION  (NUMBER  OF
C                        STEPS  IN  EACH  DIRECTION).   IF SSZ=ON, THE
C                        USER SETS ISTEP, OR, IF SSZ=OFF, THE  PROGRAM
C                        WILL  AUTOMATICALLY  SET ISTEP AT THE DEFAULT
C                        VALUE OF 40.
C
C                        IF PROGRAM SET:   CALL CONOP2('SSZ=OFF',0)
C
C                        IF USER SET:      CALL CONOP2('SSZ=ON',ISTEP)
C
C                        NOTE: ISTEP IS AN INTEGER SPECIFYING THE DENSITY
C                        OF THE VIRTUAL GRID. IN MOST CASES, THE DEFAULT
C                        VALUE OF 40 PRODUCES PLEASING CONTOURS.   FOR
C                        COARSER   BUT  QUICKER  CONTOURS,  LOWER  THE
C                        VALUE.  FOR SMOOTHER CONTOURS AT
C                        THE EXPENSE OF TAKING LONGER  TIME,  RAISE
C                        THE  VALUE.   NOTE:   FOR  STEP SIZES GREATER
C                        THAN 200 IN CONRAN, THE ARRAYS  PV  IN  COMMON
C                        CONRA1  AND ITLOC IN COMMON CONRA9,  MUST BE
C                        EXPANDED TO ABOUT 10 MORE THAN ISTEP.
C                        SEE CONRA1 AND CONRA9 COMMENTS BELOW FOR MORE
C                        INFORMATION.
C
C                        EXAMPLE:          CALL    CONOP2('SSZ=ON',25)
C                                          THIS  ISTEP VALUE WILL PRO-
C                                          DUCE A COARSE CONTOUR.
C
C                   STL  FLAG TO DETERMINE  THE  SIZE  OF  THE  TITLE.
C                        ISZSTL  MAY BE SET BY THE USER (STL=ON), OR
C                        THE PROGRAM WILL SET IT TO THE  DEFAULT  SIZE
C                        OF 16 PLOTTER ADDRESS UNITS (STL=OFF).
C
C                        IF PROGRAM SET:   CALL CONOP2('STL=OFF',0)
C
C                        IF USER SET:  CALL  CONOP2('STL=ON',ISZSTL)
C
C                        NOTE: WHEN 30 OR 40 CHARACTERS ARE  USED  FOR
C                        THE TITLE, THE DEFAULT SIZE OF 16 PLOTTER
C                        ADDRESS UNITS WORKS WELL.  FOR LONGER TITLES,
C                        A SMALLER TITLE SIZE IS REQUIRED.
C
C                        EXAMPLE:          CALL CONOP2('STL=ON',13)
C
C                   TEN  FLAG TO DETERMINE THE TENSION FACTOR  APPLIED
C                        WHEN  SMOOTHING  CONTOUR LINES.  THE USER MAY
C                        SET TENS OR ALLOW  THE  PROGRAM  TO  SET  THE
C                        VALUE.   IF  USER SET, TENS MUST HAVE A VALUE
C                        GREATER THAN ZERO AND LESS THAN OR  EQUAL  TO
C                        30.  THE DEFAULT VALUE IS 2.5.
C
C                        IF PROGRAM SET:   CALL CONOP3('TEN=OFF',0.,0)
C
C                        IF USER SET:      CALL CONOP3('TEN=ON',TENS,1)
C
C                        NOTE: TENS IS NOT AVAILABLE IN THE STANDARD
C                        VERSION OF CONRAN.
C                        SMOOTHING OF CONTOUR  LINES  IS  ACCOMPLISHED
C                        WITH  SPLINES  UNDER  TENSION.  TO ADJUST THE
C                        AMOUNT OF SMOOTHING APPLIED, ADJUST THE  TEN-
C                        SION  FACTOR.   SETTING TENS VERY LARGE
C                        (I.E. 30.), EFFECTIVELY SHUTS OFF SMOOTHING.
C
C                        EXAMPLE:          CALL CONOP3('TEN=ON',14.,1)
C
C                   TFR  FLAG TO ADVANCE THE FRAME BEFORE TRIANGULATION.
C                        THE DEFAULT VALUE IS TFR=ON, WHICH MEANS THAT
C                        THE CONTOURS AND THE TRIANGLES WILL BE PLOTTED
C                        ON SEPARATE FRAMES.
C
C                        IF PROGRAM SET:   CALL CONOP1('TFR=ON')
C
C                        TO TURN OFF:      CALL CONOP1('TFR=OFF')
C
C                        NOTE: TRIANGLES ARE PLOTTED  AFTER  THE  CON-
C                        TOURING  IS COMPLETED.  TO SEE THE TRIANGLES
C                        OVER  THE  CONTOURS,  TURN THIS SWITCH OFF.
C
C                   TLE  FLAG TO PLACE A TITLE AT THE TOP OF THE PLOT.
C                        IF  TLE=ON,  THE USER MUST SPECIFY CHARS AND
C                        INUM.  CHARS  IS THE CHARACTER STRING CONTAINING
C                        THE TITLE.  INUM IS THE NUMBER OF CHARACTERS
C                        IN CHARS.  THE DEFAULT VALUE IS  OFF.
C
C                        TO TURN ON: CALL CONOP4('TLE=ON',CHARS,INUM,0)
C
C                        TO TURN OFF:   CALL CONOP4('TLE=OFF',' ',0,0)
C
C                        NOTE: IF LONGER THAN 64-CHARACTER TITLES ARE
C                        DESIRED, THE CHARACTER VARIABLE ISTRNG FOUND
C                        IN CONRA7 MUST BE INCREASED APPROPRIATELY.
C
C                        EXAMPLE: CALL CONOP4('TLE=ON','VECTOR REVIEW'
C                                       ,13,0)
C
C                   TOP  FLAG TO PLOT ONLY THE TRIANGLES.
C
C                        TO TURN OFF:   CALL CONOP1('TOP=OFF')
C
C                        TO TURN ON:    CALL CONOP1('TOP=ON')
C
C                        NOTE: THE USER MAY WISH TO OVERLAY THE TRIAN-
C                        GLES ON SOME OTHER PLOT.  'TOP=ON' WILL
C                        ALLOW  THAT.   THIS  OPTION  WHEN   ACTIVATED
C                        (TOP=ON),  WILL  SET TRI=ON, AND TFR=OFF.  IF
C                        THE USER WANTS TFR=ON, IT SHOULD BE SET AFTER
C                        TOP IS SET.  IF THE USER SETS TOP=OFF IT WILL
C                        SET TRI=OFF AND TFR=ON. IF THE USER WANTS TRI
C                        OR  TFR  DIFFERENT, SET THEM AFTER THE
C                        TOP CALL.
C
C                   TRI  FLAG TO PLOT THE TRIANGULATION.  THE DEFAULT IS
C                        OFF AND THEREFORE THE TRIANGLES ARE NOT DRAWN.
C
C                        TO TURN ON:    CALL CONOP1('TRI=ON')
C
C                        TO TURN OFF:   CALL CONOP1('TRI=OFF')
C
C                        NOTE: PLOTTING THE TRIANGLES WILL INDICATE TO
C                        THE  USER WHERE GOOD AND BAD POINTS OF INTER-
C                        POLATION ARE OCCURRING IN  THE  CONTOUR  MAP.
C                        EQUILATERAL  TRIANGLES ARE OPTIMAL FOR INTER-
C                        POLATION.  QUALITY DEGRADES AS TRIANGLES
C                        APPROACH  A  LONG AND NARROW SHAPE.  THE CONVEX
C                        HULL OF THE  TRIANGULATION  IS  ALSO  A  POOR
C                        POINT OF INTERPOLATION.
C
C        OPTION DEFAULT  BELOW ARE  LISTED  THE  DEFAULT
C                VALUES  VALUES  FOR  THE VARIOUS OPTIONS GIVEN ABOVE.
C                        UNLESS THE USER  SPECIFIES  OTHERWISE,  THESE
C                        VALUES WILL BE USED IN EXECUTION OF THE VARI-
C                        OUS OPTIONS.
C
C                           CHL=OFF  LOT=OFF  SLD=OFF
C                           CIL=OFF  LSZ=OFF  SML=OFF
C                           CON=OFF  MES=ON   SPD=OFF
C                           DAS=OFF  NCP=OFF  SPT=OFF
C                           DBP=OFF  PDV=OFF  SSZ=OFF
C                           EXT=OFF  PER=ON   STL=OFF
C                           FMT=OFF  PMM=OFF  TEN=OFF
C                           GRI=OFF  REP=OFF  TFR=ON
C                           ITP=C1   SCA=ON   TOP=OFF
C                           LAB=ON   SDC=OFF  TRI=OFF
C
C    DEFAULT VALUES FOR  THE OPTION DEFAULT  VALUES  GIVEN  ABOVE,  IF
C        USER SPECIFIED  USED, WILL SET DEFAULT VALUES FOR THE FOLLOW-
C            PARAMETERS  ING PARAMETERS:
C
C                        PARAMETER    DEFAULT
C                        ---------    -------
C
C                        ARRAY        UP TO 30 CONTOUR LEVELS ALLOWED.
C                                     VALUES  ARE COMPUTED BY THE
C                                     PROGRAM, BASED ON INPUT.
C
C                        BP           0.
C
C                        CINC         COMPUTED BY THE PROGRAM BASED ON THE
C                                     RANGE OF HI AND LO VALUES OF THE
C                                     INPUT DATA.
C
C                        FLO          COMPUTED BY THE PROGRAM BASED ON THE
C                                     LOWEST UNSCALED INPUT DATA.
C
C                        FT           (G10.3)  PARENTHESES MUST BE
C                                     INCLUDED.
C
C                        HI           COMPUTED BY THE PROGRAM BASED ON THE
C                                     HIGHEST UNSCALED INPUT DATA.
C
C                        CHARS        NO TITLE
C
C                        IF           10 CHARACTERS
C
C                        INUM         NO TITLE
C
C                        IPAT         '$$$$$$$$$$'  (THIS IS A 10 CHARACTER
C                                     STRING.)
C
C                        ISZLSZ       9 PLOTTER ADDRESS UNITS
C
C                        ISZSML       15 PLOTTER ADDRESS UNITS
C
C                        ISZSPD       8 PLOTTER ADDRESS UNITS
C
C                        ISZSTL       16 PLOTTER ADDRESS UNITS
C
C                        ISTEP        40
C
C                        IVAL         'HI' FOR ALL EXCEPT  MINOR  CON-
C                                     TOUR   LINES   WHICH  ARE  'LO'.
C
C                        L            7  CHARACTERS  (INCLUDING   BOTH
C                                     PARENTHESES)
C
C                        NCL          COMPUTED BY THE PROGRAM BASED ON
C                                     INPUT DATA.  UP TO 30 CONTOUR
C                                     LEVELS ARE PERMITTED.
C
C                        NUM          4 DATA POINTS
C
C                        SCALE        1. (NO SCALING PERFORMED)
C
C                        TENS         2.5
C
C                        ICSD         0 (NO SHIELD)
C
C         OPTIONS WHICH  THE SHAPE OF THE CONTOURS MAY BE MODIFIED BY
C            EFFECT THE  CHANGING NCP  AND SSZ.  NCP CONTROLS THE
C              CONTOURS  NUMBER OF DATA POINTS TO BE USED IN THE
C                        INTERPOLATION.  INCREASING NCP CAUSES MORE
C                        OF THE  SURROUNDING  DATA  TO INFLUENCE THE
C                        POINT OF INTERPOLATION.  SOME  DATASETS CAUSE
C                        DIFFICULTY  WHEN  TRYING  TO PRODUCE MEANINGFUL
C                        CONTOURS (TRIANGLES WHICH ARE LONG AND  NARROW).
C                        BY MODIFYING NCP A USER CAN FINE-TUNE A
C                        PLOT.   INCREASING  ISTEP, THE DENSITY OF THE
C                        VIRTUAL GRID, WILL  SMOOTH OUT THE CONTOUR
C                        LINES AND PICK UP  MORE  DETAIL  (NEW  CONTOURS
C                        WILL APPEAR AS ISTEP INCREASES AND OLD ONES WILL
C                        SOMETIMES BREAK INTO MORE  DISTINCT UNITS).
C                        ISTEP IS CHANGED BY THE SSD OPTION.
C
C                  NOTE  IF NCP.GT.25, ARRAYS DSQ0 AND IPC0 IN CONDET
C                        MUST  BE ADJUSTED ACCORDINGLY.  ALSO NCPSZ IN
C                        CONBDN (25 BY DEFAULT), MUST BE INCREASED TO
C                        NCP.   THE  DEFAULT  VALUE OF NCP, WHICH IS 4,
C                        PRODUCES PLEASING  PICTURES  IN  MOST  CASES.
C                        HOWEVER, FINE-TUNING OF THE INTERPOLATION CAN
C                        BE OBTAINED BY INCREASING THE  SIZE  OF  NCP,
C                        WITH  A CORRESPONDING LINEAR INCREASE IN WORK
C                        SPACE.
C
C                        THE INTERPOLATION METHOD USED WILL ALSO CAUSE
C                        DIFFERENT LOOKING CONTOURS.  THE C1 METHOD
C                        IS RECOMMENDED WHEN THE DATA IS SPARSE.  IT
C                        WILL SMOOTH THE DATA AND ADD TRENDS (FALSE
C                        HILLS AND VALLEYS).  THE LINEAR METHOD IS
C                        RECOMMENDED WHEN DATA IS DENSE (GT 50 TO 100)
C                        IT WILL NOT SMOOTH THE DATA OR ADD TRENDS.
C
C      INTERFACING WITH  NORMALLY THE SCALING FACTOR WILL BE SET TO OFF.
C        OTHER GRAPHICS  IN MOST CASES MAPPING CAN BE PERFORMED BEFORE
C              ROUTINES  CALLING THE CONRAN ENTRY POINT, THUS SAVING THE
C                        USER FROM  MODIFYING THE FILE.  IF REASONABLE
C                        RESULTS CANNOT BE OBTAINED, THE STATEMENT
C                        FUNCTIONS, FX AND FY, WILL HAVE TO BE REPLACED.
C                        THE ROUTINES HAVING THESE STATEMENT FUNCTIONS
C                        ARE:
C
C                           CONDRW, CONPDV, CONTLK, CONPMS, CONGEN
C
C            REFERENCES  AKIMA, HIROSHA
C                           A METHOD OF BIVARIATE INTERPOLATION AND
C                           SMOOTH SURFACE FITTING FOR IRREGULARLY
C                           DISTRIBUTED DATA POINTS.
C                           ACM TRANSACTIONS ON MATHEMATICAL SOFTWARE
C                           VOL 4, NO. 2, JUNE 1978, PAGES 148-159
C                        LAWSON, C.L.
C                           SOFTWARE FOR C1 SURFACE INTERPOLATION
C                           JPL PUBLICATION 77-30
C                           AUGUST 15, 1977
C
C     CONRAN ERROR  ERROR  ROUTINE               MESSAGE
C       MESSAGES
C                    1      CONRAN         INPUT PARAMETER NDP LT NCP
C                    2      CONRAN         NCP GT MAX SIZE OR LT 2
C                    3      CONTNG         ALL COLINEAR DATA POINTS
C                    4      CONTNG         IDENTICAL INPUT DATA POINTS
C                                          FOUND
C                    5      CONOP          UNDEFINED OPTION
C                    6      CONCLS         CONSTANT INPUT FIELD
C                    7      CONOP          INCORRECT CONOP CALL USED
C                    8      CONOP          ILLEGAL USE OF CON OPTION
C                                          WITH CIL OR CHL OPTIONS
C                    9      CONOP          NUMBER OF CONTOUR LEVELS
C                                          EXCEEDS 30
C                    10     CONDRW         CONTOUR STORAGE EXHAUSTED
C                                          THIS ERROR IS TRAPPED AND
C                                          NULLIFIED BY CONRAN.  IT
C                                          SERVES TO SIGNAL THE USER
C                                          THAT A CONTOUR LEVEL MAY NOT
C                                          BE COMPLETE.
C                    11     CONSTP         ASPECT RATIO OF X AND Y
C                                          GREATER THAN 5 TO 1.
C                                          (THIS ERROR MAY CAUSE A POOR
C                                          QUALITY PLOT.  USUALLY THIS
C                                          CAN BE FIXED BY MULTIPLYING
C                                          X OR Y BY A CONSTANT FACTOR.
C                                          IF THIS SOLUTION IS
C                                          UNACCEPTABLE THEN INCREASING
C                                          SSZ TO A VERY LARGE VALUE
C                                          MAY HELP.  NOTE:  THIS CAN BE
C                                          EXPENSIVE.)
C
C                     THE ERRORS LISTED ABOVE ARE DEFINED AS RECOVERABLE
C                     ERRORS SHOULD THE USER WISH TO USE THEM IN THAT
C                     FASHION.  THE DOCUMENTATION ON THE ERPRT77 PACKAGE
C                     EXPLAINS HOW TO RECOVER FROM AN ERROR.
C
C NOTE:  THE COMMON BLOCKS LISTED INCLUDE ALL THE COMMON USED BY
C        THE ENTIRE CONRAN FAMILY.  NOT ALL MEMBERS WILL USE ALL
C        THE COMMON VARIABLES.
C
C   CONRA1
C       CL-ARRAY OF CONTOUR LEVELS
C       NCL-NUMBER OF CONTOUR LEVELS
C       OLDZ-Z VALUE OF LEFT NEIGHBOR TO CURRENT LOCATION
C       PV-ARRAY OF PREVIOUS ROW VALUES
C       HI-LARGEST CONTOUR PLOTTED
C       FLO-LOWEST CONTOUR PLOTTED
C       FINC-INCREMENT LEVEL BETWEEN EQUALLY SPACED CONTOURS
C   CONRA2
C       REPEAT-FLAG TO TRIANGULATE AND DRAW OR JUST DRAW
C       EXTRAP-PLOT DATA OUTSIDE OF CONVEX DATA HULL
C       PER-PUT PERIMETER AROUND PLOT
C       MESS-FLAG TO INDICATE MESSAGE OUTPUT
C       ISCALE-SCALING SWITCH
C       LOOK-PLOT TRIANGLES FLAG
C       PLDVLS-PLOT THE DATA VALUES FLAG
C       GRD-PLOT GRID FLAG
C       CON-USER SET OR PROGRAM SET CONTOURS FLAG
C       CINC-USER OR PROGRAM SET INCREMENT FLAG
C       CHILO-USER OR PROGRAM SET HI LOW CONTOURS
C       LABON-FLAG TO CONTROL LABELING OF CONTOURS
C       PMIMX-FLAG TO CONTROL THE PLOTTING OF MIN'S
C             AND MAX'S
C       SCALE-THE SCALE FACTOR FOR CONTOUR LINE VALUES
C             AND MIN, MAX PLOTTED VALUES
C       FRADV-ADVANCE FRAME BEFORE PLOTTING TRIANGULATION
C       EXTRI-ONLY PLOT TRIANGULATION
C       BPSIZ-BREAKPOINT SIZE FOR DASHPATTERNS
C       LISTOP-LIST OPTIONS ON UNIT6 FLAG
C   CONRA3
C       IRED-ERPRT77 RECOVERABLE ERROR FLAG
C   CONRA4
C       NCP-NUMBER OF DATA POINTS USED AT EACH POINT FOR
C           POLYNOMIAL CONSTRUCTION.
C       NCPSZ-MAX SIZE ALLOWED FOR NCP
C   CONRA5
C       NIT-FLAG TO INDICATE STATUS OF SEARCH DATA BASE
C       ITIPV-LAST TRIANGLE INTERPOLATION OCCURRED IN
C  CONRA6
C       XST-X COORDINATE START POINT FOR CONTOURING
C       YST-Y COORDINATE START POINT FOR CONTOURING
C       XED-X COORDINATE END POINT FOR CONTOURING
C       YED-Y COORDINATE END POINT FOR CONTOURING
C       STPSZ-STEP SIZE FOR X,Y CHANGE WHEN CONTOURING
C       IGRAD-NUMBER OF GRADUATIONS FOR CONTOURING (STEP SIZE)
C       IG-RESET VALUE FOR IGRAD
C       XRG-X RANGE OF COORDINATES
C       YRG-Y RANGE OF COORDINATES
C       BORD-PERCENT OF FRAME USED FOR CONTOUR PLOT
C       PXST-X PLOTTER START ADDRESS FOR CONTOURS
C       PYST-Y PLOTTER START ADDRESS FOR CONTOURS
C       PXED-X PLOTTER END ADDRESS FOR CONTOURS
C       PYED-Y PLOTTER END ADDRESS FOR CONTOURS
C       ITICK-NUMBER OF TICK MARKS FOR GRIDS AND PERIMETERS
C CONRA7
C       TITLE-SWITCH TO INDICATE IF TITLE OPTION ON OR OFF
C       ISTRNG-CHARACTER STRING CONTAINING THE TITLE
C       ICNT-CHARACTER COUNT OF ISTRNG
C       ITLSIZ-SIZE OF TITLE IN PWRIT UNITS
C CONRA8
C       IHIGH-DEFAULT INTENSITY SETTING
C       INMAJ-CONTOUR LEVEL INTENSITY FOR MAJOR LINES
C       INMIN-CONTOUR LEVEL INTENSITY FOR MINOR LINES
C       INLAB-TITLE AND MESSAGE INTENSITY
C       INDAT-DATA VALUE INTENSITY
C       FORM-THE FORMAT FOR PLOTTING THE DATA VALUES
C       LEN-THE NUMBER OF CHARACTERS IN THE FORMAT
C       IFMT-SIZE OF THE FORMAT FIELD
C       LEND-DEFAULT FORMAT LENGTH
C       IFMTD-DEFAULT FORMAT FIELD SIZE
C       ISIZEP-SIZE OF THE PLOTTED DATA VALUES
C  CONRA9
C       X-ARRAY OF X COORDINATES OF CONTOURS DRAWN AT CURRENT CONTOUR
C          LEVEL
C       Y-ARRAY OF Y COORDINATES OF CONTOURS DRAWN AT CURRENT CONTOUR
C          LEVEL
C       NP-COUNT IN X AND Y
C       MXXY-SIZE OF X AND Y
C       TR-TOP RIGHT CORNER VALUE OF CURRENT CELL
C       BR-BOTTOM RIGHT CORNER VALUE OF CURRENT CELL
C       TL-TOP LEFT CORNER VALUE OF CURRENT CELL
C       BL-BOTTOM LEFT CORNER VALUE OF CURRENT CELL
C       CONV-CURRENT CONTOUR VALUE
C       XN-X POSITION WHERE CONTOUR IS BEING DRAWN
C       YN-Y POSITION WHERE CONTOUR IS BEING DRAWN
C       ITLL-TRIANGLE WHERE TOP LEFT CORNER OF CURRENT CELL LIES
C       IBLL-TRIANGLE OF BOTTOM LEFT CORNER
C       ITRL-TRIANGLE OF TOP RIGHT CORNER
C       IBRL-TRIANGLE OF BOTTOM RIGHT CORNER
C       XC-X COORDINATE OF CURRENT CELL
C       YC-Y COORDINATE OF CURRENT CELL
C       ITLOC-IN CONJUNCTION WITH PV STORES THE TRIANGLE WHERE PV
C             VALUE CAME FROM
C CONR10
C       NT-NUMBER OF TRIANGLES GENERATED
C       NL-NUMBER OF LINE SEGMENTS
C       NTNL-NT+NL
C       JWIPT-POINTER INTO IWK WHERE WHERE TRIANGLE POINT NUMBERS
C             ARE STORED
C       JWIWL-IN IWK THE LOCATION OF A SCRATCH SPACE
C       JWIWP-IN IWK THE LOCATION OF A SCRATCH SPACE
C       JWIPL-IN IWK THE LOCATION OF END POINTS FOR BORDER LINE
C             SEGMENTS
C       IPR-IN WK THE LOCATION OF THE PARTIAL DERIVATIVES AT EACH
C           DATA POINT
C       ITPV-THE TRIANGLE WHERE THE PREVIOUS VALUE CAME FROM
C CONR11
C       NREP-NUMBER OF REPETITIONS OF DASH PATTERN BEFORE A LABEL
C       NCRT-NUMBER OF CRT UNITS FOR A DASH MARK OR BLANK
C       ISIZEL-SIZE OF CONTOUR LINE LABELS
C       NDASH-ARRAY CONTAINING THE NEGATIVE VALUED CONTOUR DASH
C             PATTERN
C       MINGAP-NUMBER OF UNLABELED LINES BETWEEN EACH LABELED ONE
C       IDASH-POSITIVE VALUED CONTOUR DASH PATTERN
C       ISIZEM-SIZE OF PLOTTED MINIMUMS AND MAXIMUMS
C       EDASH-EQUAL VALUED CONTOUR DASH PATTERN
C       TENS-DEFAULT TENSION SETTING FOR SMOOTHING
C CONR12
C       IXMAX,IYMAX-MAXIMUM X AND Y COORDINATES RELATIVE TO THE
C                 SCRATCH ARRAY, SCRARR
C       XMAX,YMAX-MAXIMUM X AND Y COORDINATES RELATIVE TO USERS
C                 COORDINATE SPACE
C CONR13
C       XVS-ARRAY OF THE X COORDINATES FOR SHIELDING
C       YVS-ARRAY OF THE Y COORDINATES FOR SHIELDING
C       IXVST-POINTER TO THE USERS X ARRAY FOR SHIELDING
C       IYVST-POINTER TO THE USERS Y ARRAY FOR SHIELDING
C       ICOUNT-COUNT OF THE SHIELD ELEMENTS
C       SPVAL-SPECIAL VALUE USED TO HALT CONTOURING AT THE SHIELD
C               BOUNDARY
C       SHIELD-LOGICAL FLAG TO SIGNAL STATUS OF SHIELDING
C       SLDPLT-LOGICAL FLAG TO INDICATE STATUS OF SHIELD PLOTTING
C CONR14
C       LINEAR-C1 LINEAR INTERPOLATING FLAG
C CONR15
C       ISTRNG-TITLE OF THE PLOT
C CONR16
C       FORM-FORMAT USED FOR DATA
C CONR17
C       NDASH-DASH PATTERN USED FOR CONTOUR LINES LESS THAN BP
C       IDASH-DASH PATTERN USED FOR CONTOUR LINES GREATER THAN BP
C       EDASH-DASH PATTERN USED FOR CONTOUR LINES EQUAL TO THE BP
C RANINT
C       IRANMJ-COLOR INDEX FOR NORMAL (MAJOR) INTENSITY LINES
C       IRANMN-COLOR INDEX FOR LOW INTENSITY LINES
C       IRANMJ-COLOR INDEX FOR TEXT (LABELS)
C
C +NOAO - Blockdata data conbdn rewritten as run time initialization
C         Variable LNGTHS not used.
C
C     EXTERNAL        CONBDN
C     DIMENSION       LNGTHS(4), HOLD(4)
      DIMENSION       HOLD(4)
C - NOAO
        CHARACTER*110   IWORK
        CHARACTER*13    ENCSCR,  ENSCRY
        CHARACTER*1     ICHAR
        CHARACTER*500   DPAT
        REAL            WIND(4),   VIEW(4),  NWIND(4), NVIEW(4)
      DIMENSION       XD(*)      ,YD(*)      ,ZD(*)      ,WK(*)      ,
     1                IWK(*)     ,SCRARR(*)
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
        COMMON /RANINT/ IRANMJ, IRANMN, IRANTX
        INTEGER OPLASF, OTXASF, LASF(13), OCOLI, OTEXCI
        SAVE
C
C
C+NOAO - Variable LNGTHS not used.
C       DATA LNGTHS(1),LNGTHS(2),LNGTHS(3),LNGTHS(4)/13,4,21,6/
C-NOAO
C
C ICONV CONVERT FORM 0-32767 TO 1-1024
C
        DATA ICONV/32/
C
C IABOVE AMOUNT TITLE IS PLACED ABOVE PLOT
C IBELOW, IBEL2 AMOUNT MESSAGE IS BELOW PLOT
C
C       DATA IABOVE,IBELOW,IBEL2/30,-30,-45/
C
C + NOAO - Label placement is improved by changed these values.  Also,
C          call the run time initialization subroutine, conbdn.
C
      iabove = 30
      ibelow = -15
      ibel2 = -30
      call conbdn
C - NOAO
C
C  THE FOLLOWING CALL IS FOR MONOTORING LIBRARY USE AT NCAR
C
      CALL Q8QST4 ('NSSL','CONRAN','CONRAN','VERSION 01')
C
C  LIST THE OPTION VALUES IF REQUESTED
C
      IF (LISTOP) CALL CONOUT (2)
C
C  SET SWITCH TO MAP TRIANGLES, IN CONLOC, FOR QUICK SEARCHES
C
      NIT = 0
C
C  TEST TO SEE IF ENOUGH INPUT DATA
C
      IF (NDP.GE.NCP) GO TO    10
      CALL SETER (' CONRAN - INPUT PARAMETER NDP LESS THAN NCP',1,
     1             IREC)
      RETURN
C
   10 IF (NCPSZ.GE.NCP .AND. NCP.GE.2) GO TO    20
      CALL SETER (' CONRAN - NCP LT 2 OR GT NCPSZ',2,IREC)
C
   20 IWK(1) = NDP
      IWK(2) = NCP
      IWK(3) = 1
C
C  SET POLYLINE COLOR ASF TO INDIVIDUAL
C
        CALL GQASF(IERR,LASF)
        OPLASF = LASF(3)
        LASF(3) = 1
        OTXASF = LASF(10)
        LASF(10) = 1
        CALL GSASF(LASF)
C
C  INQUIRE CURRENT POLYLINE AND TEXT COLOR
C
        CALL GQPLCI(IERR,OCOLI)
        CALL GQTXCI(IERR,OTEXCI)
C
C  SET POLYLINE AND TEXT COLOR TO VALUE IN COMMON
C
        CALL GSPLCI(IRANMJ)
      CALL GSTXCI(IRANTX)
C
C CONSTRUCTION OF WORK SPACE POINTERS
C
C TRIANGLE POINT NUMBERS
C
      JWIPT = 16
C
C SCRATCH SPACE
C
      JWIWL = 6*NDP + 1
C
C  END POINTS OF BORDER LINE SEGMENTS AND TRIANGLE NUMBER
C
      JWIPL = 24*NDP + 1
C
C  POINT NUMBERS WHERE THE NCP DATA POINTS AROUND EACH POINT
C
      JWIPC = 27*NDP + 1
C
C  SCRATCH SPACE
C
      JWIWP = 30*NDP + 1
C
C  PARTIAL DERIVATIVES AT EACH DATA POINT
C
      IPR = 8*NDP + 1
C
C  TEST IF REPEAT (JUST NEW CONTOURS OF INTERPOLATED DATA)
C  OR NO REPEAT (TRIANGULATE AND CONTOUR)
C
      IF (REPEAT) GO TO    30
C
C TRIANGULATES THE X-Y PLANE.
C
      CALL CONTNG (NDP,XD,YD,NT,IWK(JWIPT),NL,IWK(JWIPL),IWK(JWIWL),
     1             IWK(JWIWP),WK)
      IF (NERRO(ITEMP).NE.0) RETURN
C
      IWK(5) = NT
      IWK(6) = NL
      NTNL = NT+NL
C
C  SKIP IF NOT LINEAR INTERPOLATION
C
      IF (.NOT.LINEAR) GO TO 25
C
C  FIND THE COEFICENTS FOR LINER INTERPOLATION OF EACH TRIANGLE
C
      CALL CONLIN(XD,YD,ZD,NT,IWK(JWIPT),WK(IPR))
      GO TO 35
C
C
C DETERMINES NCP POINTS CLOSEST TO EACH DATA POINT.
C
 25   CALL CONDET (NDP,XD,YD,NCP,IWK(JWIPC))
C
C  ESTIMATE THE PARTIAL DERIVATIVES AT ALL DATA POINTS
C
      CALL CONINT (NDP,XD,YD,ZD,NCP,IWK(JWIPC),WK(IPR))
C
C  VERIFY DATA VALUES VALID
C
   30 NT = IWK(5)
      NL = IWK(6)
      NTNL = NT+NL
C
C  COMPUTE STEP SIZE FOR CONTOURING
C
 35   CALL CONSTP (XD,YD,NDP)
C
C  SAVE ORIGINAL WINDOW, VIEWPORT OF TRANSFORMATION 1, AND ORIGINAL
C  LOG SCALING FLAG.
C
        CALL GQCNTN(IER,IOLDNT)
        CALL GQNT(IOLDNT,IER,WIND,VIEW)
        RX1 = VIEW(1)
        RX2 = VIEW(2)
        RY1 = VIEW(3)
        RY2 = VIEW(4)
C  SAVE NORMALIZATION TRANSFORMATION 1
        CALL GQNT(1,IER,WIND,VIEW)
        CALL GETUSV('LS',IOLLS)
C
C  DETERMINE SCALING OPTION
C
      ISC = ISCALE+1
      GO TO (   40,   60,   50),ISC
C
C  CONRAN SETS SCALING FACTOR
C
   40 CALL SET(PXST,PXED,PYST,PYED,XST,XED,YST,YED,1)
      GO TO 60
C
C  CONRAN PLOTS WITHIN USERS BOUNDARIES
C
   50 CALL SET(RX1,RX2,RY1,RY2,XST,XED,YST,YED,1)
C
C  IF TRIANGULATION PLOT ONLY BRANCH
C
   60 IF (EXTRI) GO TO   390
C
C  GENERATE CONTOURS IF NONE SUPPLIED BY USER
C
      CALL CONCLS (ZD,NDP)
      IF (NERRO(ITEMP).NE.0) RETURN
C
C  REORDER THE CONTOUR LINES FOR CORRECT PATTERN DISPLAY
C
      MAJLNS = 0
      IF (LABON) CALL CONREO (MAJLNS)
C
C  MAKE SURE INTEGER COORDINATES IN 1-1024 RANGE
C
      CALL SETUSV('XF',10)
        CALL SETUSV('YF',10)
C
C  SET THE DASH PATTERNS TO DEFAULT IF THEY HAVE NOT BEEN SET
C
C
      IF (IDASH(1:1).NE.' ') GO TO        80
C
C  SET POSITIVE CONTOUR VALUE TO DEFAULT
C
        IDASH = '$$$$$$$$$$'
   80 IF (NDASH(1:1).NE.' ') GO TO       100
C
C  SET NEGATIVE CONTOUR DASH PATTERN TO DEFAULT
C
        NDASH = '$$$$$$$$$$'
  100 IF (EDASH(1:1).NE.' ') GO TO   120
C
C  SET EQUAL CONTOUR DASH PATTERN TO DEFAULT
C
        EDASH = '$$$$$$$$$$'
C
C  INITIALIZE THE CONTOURING DATA STRUCTURE
C
  120 IF (.NOT.EXTRAP) YST = YST+STPSZ
C
C  LOAD THE SCRATCH SPACE
C
      CALL CONLOD (XD,YD,ZD,NDP,WK,IWK,SCRARR)
C
C  PERFORM SHIELDING IF SO REQUESTED
C
      IF (SHIELD) CALL CONSLD(SCRARR)
C
C  *******************************************************
C  *                                                     *
C  * IF THE USER NEEDS TO DIVIDE THE PROGRAM UP          *
C  * THIS IS THE BREAK POINT.  ALL SUBROUTINES CALLED    *
C  * PRIOR TO THIS MESSAGE ARE NOT USED AGAIN AND        *
C  * ALL ROUTINES AFTER THIS MESSAGE ARE NOT USED        *
C  * ANY EARLIER.  NOTE THIS ONLY REFEARS TO ENTRY POINTS*
C  * WHICH ARE PART OF THE CONRAN PACKAGE.               *
C  * ALL DATA STRUCTURES AND VARIABLES MUST BE RETAINED. *
C  *******************************************************
C
C
C  PLOT RELATIVE MINIMUMS AND MAXIMUMS IF REQUESTED
C
      IF (PMIMX) CALL CONPMM (SCRARR)
C
C
      LENDAS = NREP*10
C
C  SET THE ERROR MODE TO RECOVERY FOR THE CONTOURING STORAGE ERROR
C
      CALL ENTSR (IROLD,1)
C
C  DRAW THE CONTOURS
C
      DO   250 I=1,NCL
C
          CONV = CL(I)
          IF (CONV.GE.BPSIZ) GO TO   150
C
C  SET UP NEGATIVE CONTOUR PATTERN
C
              DO   140 J=1,10
                ICHAR = NDASH(J:J)
                  DO   130 K=1,NREP
                DPAT( J+( 10*(K-1) ): J+( 10*(K-1)) ) = ICHAR
  130             CONTINUE
  140         CONTINUE
          GO TO   210
C
C  SET UP POSITIVE CONTOUR DASH PATTERN
C
  150     IF (CONV.EQ.BPSIZ) GO TO   180
              DO   170 J=1,10
                ICHAR = IDASH(J:J)
                  DO   160 K=1,NREP
                  DPAT( J+( 10*(K-1) ): J+( 10*(K-1)) ) = ICHAR
  160             CONTINUE
  170         CONTINUE
          GO TO   210
C
C  SET UP EQUAL CONTOUR DASH PATTERN
C
  180         DO   200 J=1,10
                ICHAR = EDASH(J:J)
                  DO   190 K=1,NREP
                DPAT( J+( 10*(K-1) ): J+( 10*(K-1)) ) = ICHAR
  190             CONTINUE
  200         CONTINUE
C
  210     IF (I.GT.MAJLNS) GO TO   230
C
C  SET UP MAJOR LINES
C
          CALL GSPLCI (IRANMJ)
          CALL CONECD (CONV,IWORK,NCUSED)
          NCHAR = LENDAS + NCUSED
        DPAT(LENDAS+1:NCHAR) = IWORK(1:NCUSED)
          GO TO   240
C
C  SET UP MINOR LINES
C
  230     NCHAR = 10
      CALL GSPLCI (IRANMN)
C
C  PROCESS FOR ALL CONTOURS
C
  240     CALL DASHDC (DPAT(1:NCHAR),NCRT,ISIZEL)
C
C  DRAW ALL CONTOURS AT THIS LEVEL
C
          CALL CONDRW (SCRARR)
C
C  GET NEXT CONTOUR LEVEL
C
  250     CONTINUE
C
C  CONTOURING COMPLETED CHECK FOR OPTIONAL OUTPUTS ON PLOT
C
C  FIRST SET ERROR MODE BACK TO USERS VALUE
C
      CALL RETSR (IROLD)
C
C  GET PLOT BOUNDRIES FOR TITLING AND MESSAGE POSITIONING
C
      CALL GQCNTN(IER,ICN)
        CALL GQNT(ICN,IER,NWIND,NVIEW)
        XST = NWIND(1)
        XED = NWIND(2)
        YST = NWIND(3)
        YED = NWIND(4)
        CALL GETUSV('LS',LT)
C
C  RESET POLYLINE COLOR INDEX TO MAJOR (NORMAL)
C
        CALL GSPLCI (IRANMJ)
C
C  DRAW SHIELD ON PLOT IF REQUESTED
C
      IF(SLDPLT.AND.SHIELD) CALL CONDSD
C
C  DRAW PERIMETER ARROUND PLOT IF DESIRED
C
      IF (PER) CALL PERIM (ITICK,0,ITICK,0)
C
C  DRAW GRID IF REQUESTED
C
      IF (GRD) CALL GRID (ITICK,0,ITICK,0)
C
C  PLOT THE DATA VALUES IF REQUESTED
C
      IF (.NOT.PLDVLS) GO TO   260
      CALL CONPDV (XD,YD,ZD,NDP)
C
C  OUTPUT TITLE IF REQUESTED
C
  260 IF (.NOT.TITLE) GO TO   270
        CALL GSTXCI (IRANTX)
      CALL FL2INT (XED,YED,MX,MY)
      MY = (MY/ICONV)+IABOVE
        ILAST = 64
        DO 261 I = 64,1,-1
            IF (ISTRNG(I:I) .NE. ' ')THEN
                  ILAST = I + 1
                  GOTO 262
            ENDIF
  261 CONTINUE
  262 CONTINUE
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      XC = ( NVIEW(1) + NVIEW(2)) / 2.
      YC = CPUY(MY)
      CALL WTSTR(XC,YC,ISTRNG(1:ILAST),ITLSIZ,0,0)
      CALL GSELNT(ICN)
C
C
C  OUTPUT MESSAGE IF REQUESTED
C
  270 IF (.NOT.MESS) GO TO   390
C
        CALL GSTXCI(IRANTX)
      CALL FL2INT (XST,YST,MX,MY)
      MY = (MY/ICONV)
C
C  IF PERIMETER OR GRID PUT OUT TICK INTERVAL
C
        IMSZ = 0
      IF (.NOT.PER .AND. .NOT.GRD) GO TO   300
        IWORK(1:36) = 'X INTERVAL=              Y INTERVAL='
C
C +NOAO - FTN internal writes rewritten as calls to encode.
C       WRITE(ENCSCR,'(G13.5)')XRG
C       WRITE(ENSCRY,'(G13.5)')YRG
        call encode (13, '(f13.5)', encscr, xrg)
	call encode (13, '(f13.5)', enscry, yrg)
C -NOAO
        IWORK(12:24) = ENCSCR
        IWORK(37:49) = ENSCRY
        IMSZ = 50
  300 IF (SCALE .EQ. 1.) GOTO 330
            IWORK(IMSZ:IMSZ+10) = ' SCALED BY '
C +NOAO
C           WRITE(ENCSCR,'(G13.5)')SCALE
            call encode (13, '(f13.5)', encscr, scale)
C -NOAO
            IWORK(IMSZ+11:IMSZ+23) = ENCSCR
            IMSZ = 73
  330 IF (IMSZ .NE. 0) THEN
        ILAST = IMSZ
        DO 291 I = IMSZ,1,-1
            IF (IWORK(I:I) .NE. ' ')THEN
                  ILAST = I + 1
                  GOTO 292
            ENDIF
  291 CONTINUE
  292 CONTINUE
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      XC = ( NVIEW(1) + NVIEW(2)) / 2.
      YC = CPUY(MY+IBEL2)
      CALL WTSTR(XC,YC,IWORK(1:ILAST),8,0,0)
      CALL GSELNT(ICN)
        ENDIF
C
C  PRODUCE CONTOUR INFO
C
      IWORK(1:42) = 'CONTOUR FROM              TO              '
      IWORK(43:77) = 'CONTOUR INTERVAL OF                '
      HOLD(1) = FLO
      HOLD(2) = HI
      HOLD(3) = FINC
C
C +NOAO
C       WRITE(ENCSCR,'(G13.5)')HOLD(1)
        call encode (13, '(f13.5)', encscr, hold(1))
        IWORK(13:25) = ENCSCR
C       WRITE(ENCSCR,'(G13.5)')HOLD(2)
        call encode (13, '(f13.5)', encscr, hold(2))
        IWORK(29:41) = ENCSCR
C       WRITE(ENCSCR,'(G13.5)')HOLD(3)
        call encode (13, '(f13.5)', encscr, hold(3))
        IWORK(62:74) = ENCSCR
C -NOAO
C
C  IF IRREGULAR SPACED CONTOURS MODIFY CONTOUR INTERVAL STATEMENT
C
      IF (FINC.GE.0.) GO TO   380
      NC = 62
          IWORK(NC:NC+15) = ' IRREGULAR      '
C
        ILAST = 77
  380 DO 381 I = 77,1,-1
            IF (IWORK(I:I) .NE. ' ')THEN
                  ILAST = I + 1
                  GOTO 382
            ENDIF
  381 CONTINUE
  382 CONTINUE
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      XC = ( NVIEW(1) + NVIEW(2)) / 2.
      YC = CPUY(MY+IBELOW)
      CALL WTSTR(XC,YC,IWORK(1:ILAST),8,0,0)
      CALL GSELNT(ICN)
C
C
C
C  PLOT TRIANGLES IF REQUESTED
C
  390 IF (LOOK) THEN
          CALL GSPLCI(IRANMN)
          CALL CONTLK (XD,YD,NDP,IWK(JWIPT))
          CALL GSPLCI(IRANMJ)
      ENDIF
C  RESTORE NORMALIZATION TRANSFORMATION 1 AND LOG SCALING
      IF (ISCALE .NE. 1) THEN
        CALL SET(VIEW(1),VIEW(2),VIEW(3),VIEW(4),
     -           WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)
      ENDIF
C RESTORE ORIGINAL NORMALIZATION TRANSFORMATION NUMBER
      CALL GSELNT (IOLDNT)
C
C  RESTORE ORIGINAL COLOR
C
      CALL GSPLCI(OCOLI)
      CALL GSTXCI(OTEXCI)
C
C  RESTORE POLYLINE COLOR ASF TO WHAT IT WAS ON ENTRY TO GRIDAL
C
        LASF(10) = OTXASF
        LASF(3) = OPLASF
        CALL GSASF(LASF)
      RETURN
      END
      SUBROUTINE CONPMM (SCRARR)
C
C THIS ROUTINE FINDS RELATIVE MINIMUMS AND MAXIMUMS.  A RELATIVE MINIMUM
C (OR MAXIMUM) IS DEFINED TO BE THE LOWEST (OR HIGHEST) POINT WITHIN
C A CERTAIN NEIGHBORHOOD OF THE POINT.  THE NEIGHBORHOOD USED HERE
C IS + OR - IXRG IN THE X DIRECTION AND + OR - IYRG IN THE Y DIRECTION.
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
C
C
      DIMENSION       SCRARR(*)
      CHARACTER*10    IA
      SAVE
C
C  CONVERT FROM 0-32767 TO 1-1024
C
        DATA ICONV/32/
C
C  ACCESSING FUNCTION INTO SCRARR
C
      SCRTCH(IXX,IYY) = SCRARR(IYY+(IXX-1)*IYMAX)
C
C  GRAPHICS MAPPING FUNCTIONS
C
      FX(XXX,YYY) = XXX
      FY(XXX,YYY) = YYY
C
C  MAPPING FROM INTEGER TO USER INPUT FLOATING POINT
C
      CONVX(IXX) = XST + FLOAT(IXX-1)*STPSZ
      CONVY(IYY) = YST + FLOAT(IYY-1)*STPSZ
C
C  SET INTENSITY TO HIGH
C
        IF (INDAT .NE. 1) THEN
          CALL GSTXCI (INDAT)
      ELSE
            CALL GSTXCI (IRANTX)
        ENDIF
C
C  COMPUTE THE SEARCH RANGE FOR MIN AND MAX DETERMINATION
C
      IXRG = MIN0(15,MAX0(2,IFIX(FLOAT(IXMAX)/8.)))
      IYRG = MIN0(15,MAX0(2,IFIX(FLOAT(IYMAX)/8.)))
C
C  LOOP THROUGH ALL ROWS OF THE DATA SEARCHING FOR AN IMMEDIATE MIN OR
C  MAX.
C
      IX = 1
C
C  SCAN A ROW
C
C  IF EXTRAPOLATING DONT LIMIT ROW SCANS
C
   10 IF (.NOT.EXTRAP) GO TO    20
      IYST = 1
      IYED = IYMAX
      IY = 1
      GO TO    30
C
C  NOT EXTRAPOLATING STAY IN HULL BOUNDRIES
C
   20 IYST = ITLOC(IX*2-1)
      IYED = ITLOC(IX*2)
      IF (IYST.EQ.0) GO TO   240
      IY = IYST
   30 VAL = SCRTCH(IX,IY)
C
C  SEARCH FOR A MIN
C
C
C  BRANCH IF NOT FIRST ON A ROW
C
      IF (IY.NE.IYST) GO TO    40
      IF (VAL.GE.SCRTCH(IX,IY+1)) GO TO   130
      IF (VAL.GE.SCRTCH(IX,IY+2)) GO TO   130
      GO TO    60
C
C  BRANCH IF NOT LAST ON ROW
C
   40 IF (IY.NE.IYED) GO TO    50
      IF (VAL.GE.SCRTCH(IX,IY-1)) GO TO   140
      IF (VAL.GE.SCRTCH(IX,IY-2)) GO TO   140
      GO TO    60
C
C  IN MIDDLE OF ROW
C
   50 IF (VAL.GE.SCRTCH(IX,IY+1)) GO TO   150
      IF (VAL.GE.SCRTCH(IX,IY-1)) GO TO   150
C
C  POSSIBLE MIN FOUND SEARCH NEIGHBORHOOD
C
   60 IXST = MAX0(1,IX-IXRG)
      IXSTOP = MIN0(IXMAX,IX+IXRG)
C
C IF NOT EXTRAPOLATING BRANCH
C
   70 IF (.NOT.EXTRAP) GO TO    80
      IYSRS = 1
      IYSRE = IYMAX
      GO TO    90
C
C  NOT EXTRAPOLATING STAY IN CONVEX HULL
C
   80 IYSRS = ITLOC(IXST*2-1)
      IYSRE = ITLOC(IXST*2)
      IF (IYSRS.EQ.0) GO TO   120
C
   90 IYSRS = MAX0(IYSRS,IY-IYRG)
      IYSRE = MIN0(IYSRE,IY+IYRG)
C
  100 CUR = SCRTCH(IXST,IYSRS)
      IF (VAL.LT.CUR) GO TO   110
      IF (VAL.GT.CUR) GO TO   230
      IF (IX.EQ.IXST .AND. IY.EQ.IYSRS) GO TO   110
      GO TO   230
C
C  SUCCESS SO FAR TRY NEXT SPACE
C
  110 IYSRS = IYSRS+1
      IF (IYSRS.LE.IYSRE) GO TO   100
  120 IXST = IXST+1
      IF (IXST.LE.IXSTOP) GO TO    70
C
C  SUCCESS, WE HAVE FOUND A RELATIVE MIN
C
      X = CONVX(IX)
      Y = CONVY(IY)
      X1 = FX(X,Y)
      CALL FL2INT (X1,FY(X,Y),MX,MY)
      MX = MX/ICONV
      MY = MY/ICONV
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      XC = CPUX(MX)
      YC = CPUY(MY)
      CALL WTSTR(XC,YC,'L',ISIZEM,0,0)
      CALL GSELNT(ICN)
C
      CALL CONECD (VAL,IA,NC)
      MY = MY - 2*ISIZEM
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      YC = CPUY(MY)
      CALL WTSTR(XC,YC,IA(1:NC),ISIZEM,0,0)
      CALL GSELNT(ICN)
C
      GO TO   230
C
C  SEARCH FOR A LOCAL MAXIMUM
C
C  IF FIRST LOC ON A ROW
C
  130 IF (VAL.LE.SCRTCH(IX,IY+1)) GO TO   230
      IF (VAL.LE.SCRTCH(IX,IY+2)) GO TO   230
      GO TO   160
C
C  IF LAST ON ROW
C
  140 IF (VAL.LE.SCRTCH(IX,IY-1)) GO TO   230
      IF (VAL.LE.SCRTCH(IX,IY-2)) GO TO   230
      GO TO   160
C
C  IN MIDDLE OF ROW
C
  150 IF (VAL.LE.SCRTCH(IX,IY+1)) GO TO   230
      IF (VAL.LE.SCRTCH(IX,IY-1)) GO TO   230
C
C  POSSIBLE MIN FOUND SEARCH NEIGHBORHOOD
C
  160 IXST = MAX0(1,IX-IXRG)
      IXSTOP = MIN0(IXMAX,IX+IXRG)
  170 IF (.NOT.EXTRAP) GO TO   180
      IYSRS = 1
      IYSRE = IYMAX
      GO TO   190
C
C  NOT EXTRAPOLATING STAY IN CONVEX HULL
C
  180 IYSRS = ITLOC(IXST*2-1)
      IYSRE = ITLOC(IXST*2)
      IF (IYSRS.EQ.0) GO TO   220
C
  190 IYSRS = MAX0(IYSRS,IY-IYRG)
      IYSRE = MIN0(IYSRE,IY+IYRG)
C
  200 CUR = SCRTCH(IXST,IYSRS)
      IF (VAL.GT.CUR) GO TO   210
      IF (VAL.LT.CUR) GO TO   230
      IF (IX.EQ.IXST .AND. IY.EQ.IYSRS) GO TO   210
      GO TO   230
C
C  SUCCESS SO FAR TRY NEXT SPACE
C
  210 IYSRS = IYSRS+1
      IF (IYSRS.LE.IYSRE) GO TO   200
  220 IXST = IXST+1
      IF (IXST.LE.IXSTOP) GO TO   170
C
C  SUCCESS WE HAVE A MAXIMUM
C
      X = CONVX(IX)
      Y = CONVY(IY)
      X1 = FX(X,Y)
      CALL FL2INT (X1,FY(X,Y),MX,MY)
      MX = MX/ICONV
      MY = MY/ICONV
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      XC = CPUX(MX)
      YC = CPUY(MY)
      CALL WTSTR(XC,YC,'H',ISIZEM,0,0)
      CALL GSELNT(ICN)
C
      CALL CONECD (VAL,IA,NC)
      MY = MY - 2*ISIZEM
C
C  POSITION STRINGS PROPERLY IF COORDS ARE IN PAU'S
C
      CALL GQCNTN(IER,ICN)
      CALL GSELNT(0)
      YC = CPUY(MY)
      CALL WTSTR(XC,YC,IA(1:NC),ISIZEM,0,0)
      CALL GSELNT(ICN)
C
C  END OF SEARCH AT THIS LOCATION TRY NEXT
C
  230 IY = IY+1
      IF (IY.LE.IYED) GO TO    30
  240 IX = IX+1
      IF (IX.LE.IXMAX) GO TO    10
C
      CALL GSTXCI (IRANTX)
C
      RETURN
C
C******************************************************************
C*                                                                *
C*                   REVISION HISTORY                             *
C*                                                                *
C*  JUNE 1980   ADDED CONRAN TO ULIB                              *
C*  AUGUST 1980 CHANGED ACCESS CARD DOCUMENTATION                 *
C*  DECEMBER 1980 MODIFIED COMMENT CARD DOCUMENTATION             *
C*  MARCH 1983  ADDED ASPECT RATIO ERROR                          *
C*  JULY 1983  ADDED SHIELDING AND LINEAR INTERPOLATION           *
C*             REMOVED 7600 ACCESS CARDS                          *
C*  JULY 1984  CONVERTED TO STANDARD FORTRAN77 AND GKS        *
C*                                                                *
C******************************************************************
C
      END

      SUBROUTINE slDBJI (STRING, NSTRT, DRESLT, J1, J2)
*+
*     - - - - - -
*      D B J I
*     - - - - - -
*
*  Convert free-format input into double precision floating point,
*  using DFLTIN but with special syntax extensions.
*
*  The purpose of the syntax extensions is to help cope with mixed
*  FK4 and FK5 data.  In addition to the syntax accepted by DFLTIN,
*  the following two extensions are recognized by DBJIN:
*
*     1)  A valid non-null field preceded by the character 'B'
*         (or 'b') is accepted.
*
*     2)  A valid non-null field preceded by the character 'J'
*         (or 'j') is accepted.
*
*  The calling program is notified of the incidence of either of these
*  extensions through an supplementary status argument.  The rest of
*  the arguments are as for DFLTIN.
*
*  Given:
*     STRING      char       string containing field to be decoded
*     NSTRT       int        pointer to 1st character of field in string
*
*  Returned:
*     NSTRT       int        incremented
*     DRESLT      double     result
*     J1          int        DFLTIN status: -1 = -OK
*                                            0 = +OK
*                                           +1 = null field
*                                           +2 = error
*     J2          int        syntax flag:  0 = normal DFLTIN syntax
*                                         +1 = 'B' or 'b'
*                                         +2 = 'J' or 'j'
*
*  Called:  slDFLI
*
*  For details of the basic syntax, see slDFLI.
*
*  P.T.Wallace   Starlink   23 November 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) STRING
      INTEGER NSTRT
      DOUBLE PRECISION DRESLT
      INTEGER J1,J2

      INTEGER J2A,LENSTR,NA,J1A,NB,J1B
      CHARACTER C



*   Preset syntax flag
      J2A=0

*   Length of string
      LENSTR=LEN(STRING)

*   Pointer to current character
      NA=NSTRT

*   Attempt normal decode
      CALL slDFLI(STRING,NA,DRESLT,J1A)

*   Proceed only if pointer still within string
      IF (NA.GE.1.AND.NA.LE.LENSTR) THEN

*      See if DFLTIN reported a null field
         IF (J1A.EQ.1) THEN

*         It did: examine character it stuck on
            C=STRING(NA:NA)
            IF (C.EQ.'B'.OR.C.EQ.'b') THEN
*            'B' - provisionally note
               J2A=1
            ELSE IF (C.EQ.'J'.OR.C.EQ.'j') THEN
*            'J' - provisionally note
               J2A=2
            END IF

*         Following B or J, attempt to decode a number
            IF (J2A.EQ.1.OR.J2A.EQ.2) THEN
               NB=NA+1
               CALL slDFLI(STRING,NB,DRESLT,J1B)

*            If successful, copy pointer and status
               IF (J1B.LE.0) THEN
                  NA=NB
                  J1A=J1B
*            If not, forget about the B or J
               ELSE
                  J2A=0
               END IF

            END IF

         END IF

      END IF

*   Return argument values and exit
      NSTRT=NA
      J1=J1A
      J2=J2A

      END

C----------------------------------------------------------------------
        subroutine ftc2s(in,cval,status)
C       convert an input quoted string to an unquoted string
C
C       The first character of the input string must be a quote character (')
C       and at least one additional quote character must also be present in the 
C       input string. This routine then simply outputs all the characters 
C       between the first and last quote characters in the input string.
C
C       in      c  input quoted string
C       cval    c  output unquoted string
C       status  i  output error status (0=ok, 1=first quote missing,
C                  2=second quote character missing.

        character*(*) in,cval
        integer length,i,j,i2,status
        character*1 dtype

C       test for datatype
        call ftdtyp(in,dtype,status)
        if (status .gt. 0)return
        if (dtype .ne. 'C')then
C               do no conversion and just return the raw character string
                cval=in
        else
C               convert character string to unquoted string

C               find closing quote character
                length=len(in)
                i2=length-1
                do 10 i=length,2,-1
                        if (in(i:i) .eq. '''')go to 20
                        i2=i2-1
10              continue
20              continue

                if (i2 .eq. 0)then
C                       there was no closing quote character
                        status=205
            call ftpmsg('The following keyword value string has no '
     &      //'closing quote:')
            call ftpmsg(in)
                else if (i2 .eq. 1)then
C                       null string
                        cval=' '
                else
                        cval=in(2:i2)

C                       test for double single quote characters; if found,
C                       then  delete one of the quotes (FITS uses 2 single
C                       quote characters to represent a single quote)
                        i2=i2-2
                        do 30  i=1,i2
                            if (cval(i:i) .eq. '''')then
                                if (cval(i+1:i+1) .eq. '''')then
                                   do 40 j=i+1,i2
                                         cval(j:j)=cval(j+1:j+1)
40                                 continue
                                   cval(i2:i2)=' '
                                end if
                            end if
30                      continue
                end if
        end if
        end

      SUBROUTINE slSMAT (N, A, Y, D, JF, IW)
*+
*     - - - - -
*      S M A T
*     - - - - -
*
*  Matrix inversion & solution of simultaneous equations
*  (single precision)
*
*  For the set of n simultaneous equations in n unknowns:
*     A.Y = X
*
*  where:
*     A is a non-singular N x N matrix
*     Y is the vector of N unknowns
*     X is the known vector
*
*  SMATRX computes:
*     the inverse of matrix A
*     the determinant of matrix A
*     the vector of N unknowns
*
*  Arguments:
*
*     symbol  type dimension           before              after
*
*       N      int                 no. of unknowns       unchanged
*       A      real  (N,N)             matrix             inverse
*       Y      real   (N)              vector            solution
*       D      real                       -             determinant
*     * JF     int                        -           singularity flag
*       IW     int    (N)                 -              workspace
*
*  *  JF is the singularity flag.  If the matrix is non-singular,
*    JF=0 is returned.  If the matrix is singular, JF=-1 & D=0.0 are
*    returned.  In the latter case, the contents of array A on return
*    are undefined.
*
*  Algorithm:
*     Gaussian elimination with partial pivoting.
*
*  Speed:
*     Very fast.
*
*  Accuracy:
*     Fairly accurate - errors 1 to 4 times those of routines optimised
*     for accuracy.
*
*  Note:  replaces the obsolete slSMATRX routine.
*
*  P.T.Wallace   Starlink   10 September 1990
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER N
      REAL A(N,N),Y(N),D
      INTEGER JF
      INTEGER IW(N)

      REAL SFA
      PARAMETER (SFA=1E-20)

      INTEGER K,IMX,I,J,NP1MK,KI
      REAL AMX,T,AKK,YK,AIK


      JF=0
      D=1.0
      DO K=1,N
         AMX=ABS(A(K,K))
         IMX=K
         IF (K.NE.N) THEN
            DO I=K+1,N
               T=ABS(A(I,K))
               IF (T.GT.AMX) THEN
                  AMX=T
                  IMX=I
               END IF
            END DO
         END IF
         IF (AMX.LT.SFA) THEN
            JF=-1
         ELSE
            IF (IMX.NE.K) THEN
               DO J=1,N
                  T=A(K,J)
                  A(K,J)=A(IMX,J)
                  A(IMX,J)=T
               END DO
               T=Y(K)
               Y(K)=Y(IMX)
               Y(IMX)=T
               D=-D
            END IF
            IW(K)=IMX
            AKK=A(K,K)
            D=D*AKK
            IF (ABS(D).LT.SFA) THEN
               JF=-1
            ELSE
               AKK=1.0/AKK
               A(K,K)=AKK
               DO J=1,N
                  IF (J.NE.K) A(K,J)=A(K,J)*AKK
               END DO
               YK=Y(K)*AKK
               Y(K)=YK
               DO I=1,N
                  AIK=A(I,K)
                  IF (I.NE.K) THEN
                     DO J=1,N
                        IF (J.NE.K) A(I,J)=A(I,J)-AIK*A(K,J)
                     END DO
                     Y(I)=Y(I)-AIK*YK
                  END IF
               END DO
               DO I=1,N
                  IF (I.NE.K) A(I,K)=-A(I,K)*AKK
               END DO
            END IF
         END IF
      END DO
      IF (JF.NE.0) THEN
         D=0.0
      ELSE
         DO K=1,N
            NP1MK=N+1-K
            KI=IW(NP1MK)
            IF (NP1MK.NE.KI) THEN
               DO I=1,N
                  T=A(I,NP1MK)
                  A(I,NP1MK)=A(I,KI)
                  A(I,KI)=T
               END DO
            END IF
         END DO
      END IF
      END

#-h-  labelc			  404  local   12/01/80  15:54:12
# labelc - output statement number
   include  defs

   subroutine labelc (lexstr)
   character lexstr (ARB)

   include COMMON_BLOCKS

   integer length, l

   xfer = NO   # can't suppress goto's now
   l = length (lexstr)
   if (l >= 3 & l < 4)		# possible conflict with pp-generated labels
       call synerr ("Warning: statement labels 100 and above are reserved.")
   call outstr (lexstr)
   call outtab
   return
   end

      SUBROUTINE slPRCS (SYSTEM, EP0, EP1, RA, DC)
*+
*     - - - - - - -
*      P R C E
*     - - - - - - -
*
*  Precession - either FK4 (Bessel-Newcomb, pre IAU 1976) or
*  FK5 (Fricke, post IAU 1976) as required.
*
*  Given:
*     SYSTEM     int    precession to be applied: 1 = FK4 or 2 = FK5
*     EP0,EP1    dp     starting and ending epoch
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP0
*
*  Returned:
*     RA,DC      dp     RA,Dec, mean equator & equinox of epoch EP1
*
*  Called:    slDA2P, slPRBN, slPREC, slDS2C,
*             slDMXV, slDC2S
*
*  Notes:
*
*     1)  Lowercase characters in SYSTEM are acceptable.
*
*     2)  The epochs are Besselian if SYSTEM=FK4 and Julian if FK5.
*         For example, to precess coordinates in the old system from
*         equinox 1900.0 to 1950.0 the call would be:
*             CALL slPRCS (1, 1900D0, 1950D0, RA, DC)
*
*     3)  This routine will NOT correctly convert between the old and
*         the new systems - for example conversion from B1950 to J2000.
*         For these purposes see slFK45, slFK54, slF45Z and
*         slF54Z.
*
*     4)  If an invalid SYSTEM is supplied, values of -99D0,-99D0 will
*         be returned for both RA and DC.
*
*  P.T.Wallace   Starlink   20 April 1990
*-

      IMPLICIT NONE

      INTEGER SYSTEM
      DOUBLE PRECISION EP0,EP1,RA,DC

      DOUBLE PRECISION PM(3,3),V1(3),V2(3)

      DOUBLE PRECISION slDA2P


*  Convert to uppercase and validate SYSTEM
      IF (SYSTEM.NE.1.AND.SYSTEM.NE.2) THEN
         RA=-99D0
         DC=-99D0
      ELSE

*     Generate appropriate precession matrix
         IF (SYSTEM.EQ.1) THEN
            CALL slPRBN(EP0,EP1,PM)
         ELSE
            CALL slPREC(EP0,EP1,PM)
         END IF

*     Convert RA,Dec to x,y,z
         CALL slDS2C(RA,DC,V1)

*     Precess
         CALL slDMXV(PM,V1,V2)

*     Back to RA,Dec
         CALL slDC2S(V2,RA,DC)
         RA=slDA2P(RA)

      END IF

      END

C----------------------------------------------------------------------
        subroutine ftgcxd(iunit,colnum,frow,nrow,fbit,nbit,
     &             dvalue,status)

C       read any consecutive bits from an 'X' or 'B' column as an unsigned
C       n-bit integer

C       iunit   i  fortran unit number
C       colnum  i  number of the column to read
C       frow    i  first row to read
C       nrow    i  number of rows to read
C       fbit    i  first bit within the row to read
C       nbit    i  number of bits to read
C       dvalue  d  returned value(s)
C       status  i  output error status
C
C       written by Wm Pence, HEASARC/GSFC, Nov 1994

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer iunit,colnum,fbit,nbit,frow,nrow,status
        integer i,k,istart,itodo,ntodo,row,ibuff
        double precision dvalue(*),power,dval
        logical lray(64)

        if (status .gt. 0)return

        ibuff=bufnum(iunit)
        if ((fbit+nbit+6)/8 .gt. trept(colnum+tstart(ibuff)))then
            call ftpmsg('Asked to read more bits than exist in'//
     &      ' the column (ftgcxd)')
            status=308
            return
        end if

        row=frow-1
        do 30 k=1,nrow
            row=row+1
            dval=0.
            power=1.0D+00
            istart=fbit+nbit
            ntodo=nbit

10          itodo=min(ntodo,64)
            istart=istart-itodo

C           read up to 64 bits at a time
C           get the individual bits
            call ftgcx(iunit,colnum,row,istart,itodo,lray,status)
            if (status .gt. 0)return

C           reconstruct the positive integer value
            do 20 i=itodo,1,-1
                if (lray(i))dval=dval+power
                power=power*2.0D+00
20          continue

            ntodo=ntodo-itodo
            if (itodo .gt. 0)go to 10
            dvalue(k)=dval
30      continue
        end

      SUBROUTINE SINQB (N,X,WSAVE)
      DIMENSION       X(*)       ,WSAVE(*)
      IF (N .GT. 1) GO TO 101
      X(1) = 4.*X(1)
      RETURN
  101 NS2 = N/2
      DO 102 K=2,N,2
         X(K) = -X(K)
  102 CONTINUE
      CALL COSQB (N,X,WSAVE)
      DO 103 K=1,NS2
         KC = N-K
         XHOLD = X(K)
         X(K) = X(KC+1)
         X(KC+1) = XHOLD
  103 CONTINUE
      RETURN
      END

*> \brief \b SGER
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
*
*       .. Scalar Arguments ..
*       REAL ALPHA
*       INTEGER INCX,INCY,LDA,M,N
*       ..
*       .. Array Arguments ..
*       REAL A(LDA,*),X(*),Y(*)
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGER   performs the rank 1 operation
*>
*>    A := alpha*x*y**T + A,
*>
*> where alpha is a scalar, x is an m element vector, y is an n element
*> vector and A is an m by n matrix.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>           On entry, M specifies the number of rows of the matrix A.
*>           M must be at least zero.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the number of columns of the matrix A.
*>           N must be at least zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is REAL
*>           On entry, ALPHA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in] X
*> \verbatim
*>          X is REAL array, dimension at least
*>           ( 1 + ( m - 1 )*abs( INCX ) ).
*>           Before entry, the incremented array X must contain the m
*>           element vector x.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           X. INCX must not be zero.
*> \endverbatim
*>
*> \param[in] Y
*> \verbatim
*>          Y is REAL array, dimension at least
*>           ( 1 + ( n - 1 )*abs( INCY ) ).
*>           Before entry, the incremented array Y must contain the n
*>           element vector y.
*> \endverbatim
*>
*> \param[in] INCY
*> \verbatim
*>          INCY is INTEGER
*>           On entry, INCY specifies the increment for the elements of
*>           Y. INCY must not be zero.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension ( LDA, N )
*>           Before entry, the leading m by n part of the array A must
*>           contain the matrix of coefficients. On exit, A is
*>           overwritten by the updated matrix.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program. LDA must be at least
*>           max( 1, m ).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \date December 2016
*
*> \ingroup single_blas_level2
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 2 Blas routine.
*>
*>  -- Written on 22-October-1986.
*>     Jack Dongarra, Argonne National Lab.
*>     Jeremy Du Croz, Nag Central Office.
*>     Sven Hammarling, Nag Central Office.
*>     Richard Hanson, Sandia National Labs.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE SGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
*
*  -- Reference BLAS level2 routine (version 3.7.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     December 2016
*
*     .. Scalar Arguments ..
      REAL ALPHA
      INTEGER INCX,INCY,LDA,M,N
*     ..
*     .. Array Arguments ..
      REAL A(LDA,*),X(*),Y(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL ZERO
      PARAMETER (ZERO=0.0E+0)
*     ..
*     .. Local Scalars ..
      REAL TEMP
      INTEGER I,INFO,IX,J,JY,KX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (M.LT.0) THEN
          INFO = 1
      ELSE IF (N.LT.0) THEN
          INFO = 2
      ELSE IF (INCX.EQ.0) THEN
          INFO = 5
      ELSE IF (INCY.EQ.0) THEN
          INFO = 7
      ELSE IF (LDA.LT.MAX(1,M)) THEN
          INFO = 9
      END IF
      IF (INFO.NE.0) THEN
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR. (ALPHA.EQ.ZERO)) RETURN
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF (INCY.GT.0) THEN
          JY = 1
      ELSE
          JY = 1 - (N-1)*INCY
      END IF
      IF (INCX.EQ.1) THEN
          DO 20 J = 1,N
              IF (Y(JY).NE.ZERO) THEN
                  TEMP = ALPHA*Y(JY)
                  DO 10 I = 1,M
                      A(I,J) = A(I,J) + X(I)*TEMP
   10             CONTINUE
              END IF
              JY = JY + INCY
   20     CONTINUE
      ELSE
          IF (INCX.GT.0) THEN
              KX = 1
          ELSE
              KX = 1 - (M-1)*INCX
          END IF
          DO 40 J = 1,N
              IF (Y(JY).NE.ZERO) THEN
                  TEMP = ALPHA*Y(JY)
                  IX = KX
                  DO 30 I = 1,M
                      A(I,J) = A(I,J) + X(IX)*TEMP
                      IX = IX + INCX
   30             CONTINUE
              END IF
              JY = JY + INCY
   40     CONTINUE
      END IF
*
      RETURN
*
*     End of SGER  .
*
      END

#-h-  outnum			  381  local   12/01/80  15:54:32
# outnum - output decimal number
   include  defs

   subroutine outnum (n)
   integer n

   character chars (MAXCHARS)

   integer i, m

   m = iabs (n)
   i = 0
   repeat {
      i = i + 1
      chars (i) = mod (m, 10) + DIG0
      m = m / 10
      } until (m == 0 | i >= MAXCHARS)
   if (n < 0)
      call outch (MINUS)
   for ( ; i > 0; i = i - 1)
      call outch (chars (i))
   return
   end

c subroutine legfit.f
c
c source
c   Bevington, pages 155-157.
c
c purpose
c   make a least-squares fit to data with a legendre polynomial
c      y = a(1) + a(2)*x + a(3)*(3x**2-1)/2 + ...
c        = a(1) * (1. + b(2)*x + b(3)*(3x**2-1)/2 + ... )
c      where x = cos(theta)
c
c usage
c   call legfit (theta, y, sigmay, npts, norder, neven, mode, ftest,
c      yfit, a, sigmaa, b, sigmab, chisqr)
c
c description of parameters
c   theta  - array of angles (in degrees) of the data points
c   y      - array of data points for dependent variable
c   sigmay - array of standard deivations for y data points
c   npts   - number of pairs of data points
c   norder - highest order of polynomial (number of terms - 1)
c   neven  - determines odd or even character of polynomial
c            +1 fits only to even terms
c             0 fits to all terms
c            -1 fits only to odd terms (plus constant term)
c   mode   - determines mode of weighting least-squares fit
c            +1 (instrumental) weight(i) = 1./sigmay(i)**2
c             0 (no weighting) weight(i) = 1.
c            -1 (statistical)  weight(i) = 1./y(i)
c   ftest  - array of values of f(l) for an f test
c   yfit   - array of calculated values of y
c   a      - array of coefficients of polynomial
c   sigmaa - array of standard deviations for coefficients
c   b      - array of normalized relative coefficients
c   sigmab - array of standard deviations for relative coefficients
c   chisqr - reduced chi square for fit
c
c subroutines and function subprograms required
c   matinv (array, nterms, det)
c      inverts a symmetric two-dimensional matrix of degree nterms
c      and calculates its determinant
c
c comments
c   dimension statement valid for npts up to 100 and order up to 9
c   dcos changed to cos in statement 31
c
      subroutine legfit (theta,y,sigmay,npts,norder,neven,mode,
     *ftest,yfit,a,sigmaa,b,sigmab,chisqr)
      double precision cosine,p,beta,alpha,chisq
      dimension theta(1),y(1),sigmay(1),ftest(1),yfit(1),
     *a(1),sigmaa(1),b(1),sigmab(1)
      dimension weight(100),p(100,10),beta(10),alpha(10,10)
c
c accumulate weights and legendre polynomials
c
11    nterms=1
      ncoeff=1
      jmax=norder+1
20    do 40 i=1,npts
21    if (mode) 22,27,29
22    if (y(i)) 25,27,23
23    weight(i)=1./y(i)
      goto 31
25    weight(i)=1./(-y(i))
      goto 31
27    weight(i)=1.
      goto 31
29    weight(i)=1./sigmay(i)**2
31    cosine=cos(0.01745329252*theta(i))
      p(i,1)=1.
      p(i,2)=cosine
      do 36 l=2,norder
      fl=l
36    p(i,l+1)=((2.*fl-1.)*cosine*p(i,l)-(fl-1.)*p(i,l-1))/fl
40    continue
c
c accumulate matrices alpha and beta
c
51    do 54 j=1,nterms
      beta(j)=0.
      do 54 k=1,nterms
54    alpha(j,k)=0.
61    do 66 i=1,npts
      do 66 j=1,nterms
      beta(j)=beta(j)+p(i,j)*y(i)*weight(i)
      do 66 k=j,nterms
      alpha(j,k)=alpha(j,k)+p(i,j)*p(i,k)*weight(i)
66    alpha(k,j)=alpha(j,k)
c
c delete fixed coefficients
c
70    if (neven) 71,91,81
71    do 76 j=3,nterms,2
      beta(j)=0.
      do 75 k=1,nterms
      alpha(j,k)=0.
75    alpha(k,j)=0.
76    alpha(j,j)=1.
      goto 91
81    do 86 j=2,nterms,2
      beta(j)=0.
      do 85 k=1,nterms
      alpha(j,k)=0.
85    alpha(k,j)=0.
86    alpha(j,j)=1.
c
c invert curvature matrix alpha
c
91    do 95 j=1,jmax
      a(j)=0.
      sigmaa(j)=0.
      b(j)=0.
95    sigmab(j)=0.
      do 97 i=1,npts
97    yfit(i)=0.
101   call matinv (alpha,nterms,det)
      if (det) 111,103,111
103   chisqr=0.
      goto 170
c
c calculate coefficients, fit, and chi square
c
111   do 115 j=1,nterms
      do 113 k=1,nterms
113   a(j)=a(j)+beta(k)*alpha(j,k)
      do 115 i=1,npts
115   yfit(i)=yfit(i)+a(j)*p(i,j)
121   chisq=0.
      do 123 i=1,npts
123   chisq=chisq+(y(i)-yfit(i))**2*weight(i)
      free=npts-ncoeff
      chisqr=chisq/free
c
c test for end of fit
c
131   if (nterms-jmax) 132,151,151
132   if (ncoeff-2) 133,134,141
133   if (neven) 137,137,135
134   if (neven) 135,137,135
135   nterms=nterms+2
      goto 138
137   nterms=nterms+1
138   ncoeff=ncoeff+1
      chisq1=chisq
      goto 51
141   fvalue=(chisq1-chisq)/chisqr
      if (ftest(nterms)-fvalue) 134,143,143
143   if (neven) 144,146,144
144   nterms=nterms-2
      goto 147
146   nterms=nterms-1
147   ncoeff=ncoeff-1
      jmax=nterms
149   goto 51
c
c calculate remainder of output
c
151   if (mode) 152,154,152
152   varnce=1.
      goto 155
154   varnce=chisqr
155   do 156 j=1,nterms
156   sigmaa(j)=dsqrt(varnce*alpha(j,j))
161   if (a(1)) 162,170,162
162   do 166 j=2,nterms
      if (a(j)) 164,166,164
164   b(j)=a(j)/a(1)
165   sigmab(j)=b(j)*dsqrt((sigmaa(j)/a(j))**2+(sigmaa(1)/a(1))**2
     *-2.*varnce*alpha(j,1)/(a(j)*a(1)))
166   continue
      b(1)=1.
170   return
      end

      subroutine bsplvb ( t, jhigh, index, x, left, biatx )
c  from  * a practical guide to splines *  by c. de boor
calculates the value of all possibly nonzero b-splines at  x  of order
c
c		jout  =  max( jhigh , (j+1)*(index-1) )
c
c  with knot sequence  t .
c
c******  i n p u t  ******
c  t.....knot sequence, of length  left + jout	, assumed to be nonde-
c	 creasing.  a s s u m p t i o n . . . .
c			t(left)  .lt.  t(left + 1)   .
c   d i v i s i o n  b y  z e r o  will result if  t(left) = t(left+1)
c  jhigh,
c  index.....integers which determine the order  jout = max(jhigh,
c	 (j+1)*(index-1))  of the b-splines whose values at  x	are to
c	 be returned.  index  is used to avoid recalculations when seve-
c	 ral columns of the triangular array of b-spline values are nee-
c	 ded (e.g., in	bvalue	or in  bsplvd ). precisely,
c		      if  index = 1 ,
c	 the calculation starts from scratch and the entire triangular
c	 array of b-spline values of orders 1,2,...,jhigh  is generated
c	 order by order , i.e., column by column .
c		      if  index = 2 ,
c	 only the b-spline values of order  j+1, j+2, ..., jout  are ge-
c	 nerated, the assumption being that  biatx , j , deltal , deltar
c	 are, on entry, as they were on exit at the previous call.
c	    in particular, if  jhigh = 0, then	jout = j+1, i.e., just
c	 the next column of b-spline values is generated.
c
c  w a r n i n g . . .	the restriction   jout .le. jmax (= 20)  is im-
c	 posed arbitrarily by the dimension statement for  deltal  and
c	 deltar  below, but is	n o w h e r e  c h e c k e d  for .
c
c  x.....the point at which the b-splines are to be evaluated.
c  left.....an integer chosen (usually) so that
c		   t(left) .le. x .le. t(left+1)  .
c
c******  o u t p u t  ******
c  biatx.....array of length  jout , with  biatx(i)  containing the val-
c	 ue at	x  of the polynomial of order  jout  which agrees with
c	 the b-spline  b(left-jout+i,jout,t)  on the interval (t(left),
c	 t(left+1)) .
c
c******  m e t h o d  ******
c  the recurrence relation
c
c			x - t(i)	      t(i+j+1) - x
c     b(i,j+1)(x)  =  -----------b(i,j)(x) + ---------------b(i+1,j)(x)
c		      t(i+j)-t(i)	     t(i+j+1)-t(i+1)
c
c  is used (repeatedly) to generate the (j+1)-vector  b(left-j,j+1)(x),
c  ...,b(left,j+1)(x)  from the j-vector  b(left-j+1,j)(x),...,
c  b(left,j)(x), storing the new values in  biatx  over the old. the
c  facts that
c	     b(i,1) = 1  if  t(i) .le. x .lt. t(i+1)
c  and that
c	     b(i,j)(x) = 0  unless  t(i) .le. x .lt. t(i+j)
c  are used. the particular organization of the calculations follows al-
c  gorithm  (8)  in chapter x of the text.
c
c     parameter jmax = 20
      integer index,jhigh,left,   i,j,jp1
c     real biatx(jhigh),t(1),x,   deltal(jmax),deltar(jmax),saved,term
      real biatx(jhigh),t(1),x,   deltal(20),deltar(20),saved,term
c     dimension biatx(jout), t(left+jout)
current fortran standard makes it impossible to specify the length of
c  t  and of  biatx  precisely without the introduction of otherwise
c  superfluous additional arguments.
      data j/1/
c     save j,deltal,deltar (valid in fortran 77)
c
					go to (10,20), index
   10 j = 1
      biatx(1) = 1.
      if (j .ge. jhigh) 		go to 99
c
   20	 jp1 = j + 1
	 deltar(j) = t(left+j) - x
	 deltal(j) = x - t(left+1-j)
	 saved = 0.
	 do 26 i=1,j
	    term = biatx(i)/(deltar(i) + deltal(jp1-i))
	    biatx(i) = saved + deltar(i)*term
   26	    saved = deltal(jp1-i)*term
	 biatx(jp1) = saved
	 j = jp1
	 if (j .lt. jhigh)		go to 20
c
   99					return
      end

C--------------------------------------------------------------------------
        subroutine ftpsse(iunit,group,naxis,naxes,fpixel,lpixel,
     &                    array,status)

C       Write a subsection of real values to the primary array.
C       A subsection is defined to be any contiguous rectangular
C       array of pixels within the n-dimensional FITS data file.
C       Data conversion and scaling will be performed if necessary
C       (e.g, if the datatype of the FITS array is not the same
C       as the array being read).

C       iunit   i  Fortran input unit number
C       group   i  number of the data group to be written, if any
C       naxis   i  number of data axes in the FITS array
C       naxes   i  (array) size of each FITS axis
C       fpixel  i  (array) the first pixel in each dimension to be included
C                  in the subsection (first pixel = 1)
C       lpixel  i  (array) the last pixel in each dimension to be included
C                  in the subsection
C       array   r  array of values to be written
C       status  i  returned error stataus

C       written by Wm Pence, HEASARC/GSFC, Feb 1992

        integer iunit,group,naxis,naxes(*),fpixel(*),lpixel(*),status
        real array(*)
        integer fpix(7),irange(7),dimen(7),astart,pstart
        integer off2,off3,off4,off5,off6,off7
        integer st10,st20,st30,st40,st50,st60,st70
        integer st1,st2,st3,st4,st5,st6,st7
        integer i,i1,i2,i3,i4,i5,i6,i7
        character caxis*20

        if (status .gt. 0)return

        if (naxis .lt. 1 .or. naxis .gt. 7)then
C               this routine only supports up to 7 dimensions
                status=320
                write(caxis,1001)naxis
1001            format(i20)
                call ftpmsg('NAXIS ='//caxis//' in the call to FTPSSE '
     &          //'is illegal.')
                return
        end if

C       calculate the sizes and number of loops to perform in each dimension
        do 10 i=1,7
             fpix(i)=1
             irange(i)=1
             dimen(i)=1
10      continue

        do 20 i=1,naxis
             fpix(i)=fpixel(i)
             irange(i)=lpixel(i)-fpixel(i)+1
             dimen(i)=naxes(i) 
20      continue
        i1=irange(1)

C       compute the pixel offset between each dimension
        off2=     dimen(1)
        off3=off2*dimen(2)
        off4=off3*dimen(3)
        off5=off4*dimen(4)
        off6=off5*dimen(5)
        off7=off6*dimen(6)

        st10=fpix(1)
        st20=(fpix(2)-1)*off2
        st30=(fpix(3)-1)*off3
        st40=(fpix(4)-1)*off4
        st50=(fpix(5)-1)*off5
        st60=(fpix(6)-1)*off6
        st70=(fpix(7)-1)*off7

C       store the initial offset in each dimension
        st1=st10
        st2=st20
        st3=st30
        st4=st40
        st5=st50
        st6=st60
        st7=st70

        astart=1

        do 170 i7=1,irange(7)
        do 160 i6=1,irange(6)
        do 150 i5=1,irange(5)
        do 140 i4=1,irange(4)
        do 130 i3=1,irange(3)
        pstart=st1+st2+st3+st4+st5+st6+st7
        do 120 i2=1,irange(2)
                call ftppre(iunit,group,pstart,i1,
     &              array(astart),status)
                astart=astart+i1
                pstart=pstart+off2
120     continue
        st2=st20
        st3=st3+off3        
130     continue
        st3=st30
        st4=st4+off4
140     continue
        st4=st40
        st5=st5+off5
150     continue
        st5=st50
        st6=st6+off6
160     continue
        st6=st60
        st7=st7+off7
170     continue
        end        

      SUBROUTINE slTP2S (XI, ETA, RAZ, DECZ, RA, DEC)
*+
*     - - - - -
*      T P 2 S
*     - - - - -
*
*  Transform tangent plane coordinates into spherical
*  (single precision)
*
*  Given:
*     XI,ETA      real  tangent plane rectangular coordinates
*     RAZ,DECZ    real  spherical coordinates of tangent point
*
*  Returned:
*     RA,DEC      real  spherical coordinates (0-2pi,+/-pi/2)
*
*  Called:        slRA2P
*
*  P.T.Wallace   Starlink   24 July 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL XI,ETA,RAZ,DECZ,RA,DEC

      REAL slRA2P

      REAL SDECZ,CDECZ,DENOM



      SDECZ=SIN(DECZ)
      CDECZ=COS(DECZ)

      DENOM=CDECZ-ETA*SDECZ

      RA=slRA2P(ATAN2(XI,DENOM)+RAZ)
      DEC=ATAN2(SDECZ+ETA*CDECZ,SQRT(XI*XI+DENOM*DENOM))

      END

C--------------------------------------------------------------------------
        subroutine ftpkyj(ounit,keywrd,intval,comm,status)

C       write an integer value to a header record 
C
C       ounit   i  fortran output unit number
C       keywrd  c  keyword name    ( 8 characters, cols.  1- 8)
C       intval  i  keyword value 
C       comm    c  keyword comment (47 characters, cols. 34-80)
C       OUTPUT PARAMETERS
C       status  i  output error status (0 = ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        character*(*) keywrd,comm
        integer ounit,status,intval
        character value*20

C       convert integer to character string
        call fti2c(intval,value,status)

C       write the keyword record
        call ftpkey(ounit,keywrd,value,comm,status)
        end

      integer function ctoi(in, i)
      integer in (100)
      integer i
      integer d
      external index
      integer index
      integer digits(11)
      data digits (1) /48/, digits (2) /49/, digits (3) /50/, digits (4)
     * /51/, digits (5) /52/, digits (6) /53/, digits (7) /54/, digits (
     *8) /55/, digits (9) /56/, digits (10) /57/, digits (11) /-2/
23000 if (.not.(in (i) .eq. 32 .or. in (i) .eq. 9))goto 23001
      i = i + 1
      goto 23000
23001 continue
      ctoi = 0
23002 if (.not.(in (i) .ne. -2))goto 23004
      d = index (digits, in (i))
      if (.not.(d .eq. 0))goto 23005
      goto 23004
23005 continue
      ctoi = 10 * ctoi + d - 1
23003 i = i + 1
      goto 23002
23004 continue
      return
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGDASH (DASH,WODQ,WOCD,SCWP)
C
C AGDASH sets up the DASHD call required to establish the dash pattern
C desired for the next curve.  The arguments are as follows:
C
C -- DASH specifies the desired dash pattern.  A positive value implies
C    that a binary dash pattern is to be used, a negative value that a
C    character-string dash pattern is to be used.
C
C -- WODQ is the width of the solid-line segment specified by a dollar
C    sign and the gap specified by a quote, expressed as a fraction of
C    the smaller side of the curve window.
C
C -- WOCD is the width of a character which is to be a part of the dash
C    pattern, expressed in the same units as WODQ.
C
C -- SCWP is the length of the smaller side of the curve window, in
C    plotter coordinate units.
C
C The following common block contains other AUTOGRAPH variables, both
C real and integer, which are not control parameters.  The only ones
C used here are MWCD and MWDQ - the minimum widths of characters and
C spaces, respectively, in the dash pattern.
C
      COMMON /AGORIP/ SMRL , ISLD , MWCL,MWCM,MWCE,MDLA,MWCD,MWDQ ,
     +                INIF
C
C The following common block contains other AUTOGRAPH variables, of type
C character.
C
      COMMON /AGOCHP/ CHS1,CHS2
C
c+noao
c     CHARACTER*504 CHS1,CHS2
      CHARACTER*500 CHS1,CHS2
c-noao
C
C The AUTOGRAPH function AGFPBN is of type integer.
C
      INTEGER AGFPBN
C
      IWCD=MAX0(MWCD,IFIX(WOCD*SCWP))
      IWDQ=MAX0(MWDQ,IFIX(WODQ*SCWP))
C
      IF (DASH.GE.0.) THEN
        CALL DASHDB (AGFPBN(DASH))
      ELSE
        CALL AGGTCH (IFIX(DASH),CHS1,LNC1)
        CALL DASHDC (CHS1(1:LNC1),IWDQ,IWCD)
      END IF
C
      RETURN
C
      END

include	defs

# ctomn --- translate ASCII control character to mnemonic string

   integer function ctomn (c, rep)
   character c, rep (4)

   integer i
   integer length

   character mntext (136)     # 4 chars/mnemonic; 32 control chars + SP + DEL
   data mntext / _
      BIGN, BIGU, BIGL, EOS,
      BIGS, BIGO, BIGH, EOS,
      BIGS, BIGT, BIGX, EOS,
      BIGE, BIGT, BIGX, EOS,
      BIGE, BIGO, BIGT, EOS,
      BIGE, BIGN, BIGQ, EOS,
      BIGA, BIGC, BIGK, EOS,
      BIGB, BIGE, BIGL, EOS,
      BIGB, BIGS, EOS,	EOS,
      BIGH, BIGT, EOS,	EOS,
      BIGL, BIGF, EOS,	EOS,
      BIGV, BIGT, EOS,	EOS,
      BIGF, BIGF, EOS,	EOS,
      BIGC, BIGR, EOS,	EOS,
      BIGS, BIGO, EOS,	EOS,
      BIGS, BIGI, EOS,	EOS,
      BIGD, BIGL, BIGE, EOS,
      BIGD, BIGC, DIG1, EOS,
      BIGD, BIGC, DIG2, EOS,
      BIGD, BIGC, DIG3, EOS,
      BIGD, BIGC, DIG4, EOS,
      BIGN, BIGA, BIGK, EOS,
      BIGS, BIGY, BIGN, EOS,
      BIGE, BIGT, BIGB, EOS,
      BIGC, BIGA, BIGN, EOS,
      BIGE, BIGM, EOS,	EOS,
      BIGS, BIGU, BIGB, EOS,
      BIGE, BIGS, BIGC, EOS,
      BIGF, BIGS, EOS,	EOS,
      BIGG, BIGS, EOS,	EOS,
      BIGR, BIGS, EOS,	EOS,
      BIGU, BIGS, EOS,	EOS,
      BIGS, BIGP, EOS,	EOS,
      BIGD, BIGE, BIGL, EOS/

   i = mod (max(c,0), 128)
   if (0 <= i & i <= 32)     # non-printing character or space
      call scopy (mntext, 4 * i + 1, rep, 1)
   else if (i == 127)	      # rubout (DEL)
      call scopy (mntext, 133, rep, 1)
   else {		      # printing character
      rep (1) = c
      rep (2) = EOS
      }

   return (length (rep))
   end

c subroutine regres.f
c
c source
c   Bevington, pages 172-175.
c
c purpose
c   make a mulitple linear regression fit to data with a specified
c      function which is linear in coefficients
c
c usage
c   call regres (x, y, sigmay, npts, nterms, m, mode, yfit,
c      a0, a, sigma0, sigmaa, r, rmul, chisqr, ftest)
c
c description of parameters
c   x	   - array of points for independent variable
c   y	   - array of points for dependent variable
c   sigmay - array of standard deviations for y data points
c   npts   - number of pairs of data points
c   nterms - number of coefficients
c   m	   - array of inclusion/rejection criteria for fctn
c   mode   - determines method of weighting least-squares fit
c	     +1 (instrumental) weight(i) = 1./sigmay(i)**2
c	      0 (no weighting) weight(i) = 1.
c	     -1 (statistical)  weight(i) = 1./y(i)
c   yfit   - array of calculated values of y
c   a0	   - constant term
c   a	   - array of coefficients
c   sigma0 - standard deviation of a0
c   sigmaa - array of standard deviations for coefficients
c   r	   - array of linear correlation coefficients
c   rmul   - multiple linear correlation coefficient
c   chisqr - reduced chi square for fit
c   ftest  - value of f for test of fit
c
c subroutines and function subprograms required
c   fctn (x, i, j, m)
c      evaluates the function for the jth term and the ith data point
c      using the array m to specify terms in the function
c   matinv (array, nterms, det)
c      inverts a symmetric two-dimensional matrix of degree nterms
c      and calculates its determinant
c
c comments
c (dim npts changed 100->1000 21-may-84 dct)
c   dimension statement valid for npts up to 100 and nterms up to 10
c   sigmaag changed to sigmaa in statement following statement 132
c
      subroutine regres (x,y,sigmay,npts,nterms,m,mode,yfit,
     *a0,a,sigma0,sigmaa,r,rmul,chisqr,ftest)
      double precision array,sum,ymean,sigma,chisq,xmean,sigmax
      dimension x(1),y(1),sigmay(1),m(1),yfit(1),a(1),sigmaa(1),
     *r(1)
      dimension weight(1000),xmean(10),sigmax(10),array(10,10)
      REAL FCTN
      EXTERNAL FCTN

c
c initialize sums and arrays
c
11    sum=0.
      ymean=0.
      sigma=0.
      chisq=0.
      rmul=0.
      do 17 i=1,npts
17    yfit(i)=0.
21    do 28 j=1,nterms
      xmean(j)=0.
      sigmax(j)=0.
      r(j)=0.
      a(j)=0.
      sigmaa(j)=0.
      do 28 k=1,nterms
28    array(j,k)=0.
c
c accumulate weighted sums
c
30    do 50 i=1,npts
31    if (mode) 32,37,39
32    if (y(i)) 35,37,33
33    weight(i)=1./y(i)
      goto 41
35    weight(i)=1./(-y(i))
      goto 41
37    weight(i)=1.
      goto 41
39    weight(i)=1./sigmay(i)**2
41    sum=sum+weight(i)
      ymean=ymean+weight(i)*y(i)
      do 44 j=1,nterms
44    xmean(j)=xmean(j)+weight(i)*fctn(x,i,j,m)
50    continue
51    ymean=ymean/sum
      do 53 j=1,nterms
53    xmean(j)=xmean(j)/sum
      fnpts=npts
      wmean=sum/fnpts
      do 57 i=1,npts
57    weight(i)=weight(i)/wmean
c
c accumulate matrices r and array
c
61    do 67 i=1,npts
      sigma=sigma+weight(i)*(y(i)-ymean)**2
      do 67 j=1,nterms
      sigmax(j)=sigmax(j)+weight(i)*(fctn(x,i,j,m)-xmean(j))**2
      r(j)=r(j)+weight(i)*(fctn(x,i,j,m)-xmean(j))*(y(i)-ymean)
      do 67 k=1,j
67    array(j,k)=array(j,k)+weight(i)*(fctn(x,i,j,m)-xmean(j))*
     *(fctn(x,i,k,m)-xmean(k))
71    free1=npts-1
72    sigma=dsqrt(sigma/free1)
      do 78 j=1,nterms
74    sigmax(j)=dsqrt(sigmax(j)/free1)
      r(j)=r(j)/(free1*sigmax(j)*sigma)
      do 78 k=1,j
      array(j,k)=array(j,k)/(free1*sigmax(j)*sigmax(k))
78    array(k,j)=array(j,k)
c
c invert symmetric matrix
c
81    call matinv (array,nterms,det)
      if (det) 101,91,101
91    a0=0.
      sigma0=0.
      rmul=0.
      chisqr=0.
      ftest=0.
      goto 150
c
c calculate coefficients, fit, and chi square
c
101   a0=ymean
102   do 108 j=1,nterms
      do 104 k=1,nterms
104   a(j)=a(j)+r(k)*array(j,k)
105   a(j)=a(j)*sigma/sigmax(j)
106   a0=a0-a(j)*xmean(j)
107   do 108 i=1,npts
108   yfit(i)=yfit(i)+a(j)*fctn(x,i,j,m)
111   do 113 i=1,npts
      yfit(i)=yfit(i)+a0
113   chisq=chisq+weight(i)*(y(i)-yfit(i))**2
      freen=npts-nterms-1
115   chisqr=chisq*wmean/freen
c
c calculate uncertainties
c
121   if (mode) 122,124,122
122   varnce=1./wmean
      goto 131
124   varnce=chisqr
131   do 133 j=1,nterms
132   sigmaa(j)=array(j,j)*varnce/(free1*sigmax(j)**2)
      sigmaa(j)=sqrt(sigmaa(j))
133   rmul=rmul+a(j)*r(j)*sigmax(j)/sigma
      freej=nterms
c +noao: When rmul = 1, the following division (stmt 135) would blow up.
c        It has been changed so ftest is set to -99999. in this case.
      if (1. - rmul) 135, 935, 135
135   ftest=(rmul/freej)/((1.-rmul)/freen)
      goto 136
935   ftest = -99999.
c -noao
136   rmul=sqrt(rmul)
141   sigma0=varnce/fnpts
      do 145 j=1,nterms
      do 145 k=1,nterms
145   sigma0=sigma0+varnce*xmean(j)*xmean(k)*array(j,k)/
     *(free1*sigmax(j)*sigmax(k))
146   sigma0=sqrt(sigma0)
150   return
      end

C--------------------------------------------------------------------------
        subroutine ftcins(iunit,naxis1,naxis2,delbyt,fstbyt,status)

C       insert DELBYT bytes after byte fstbyt in every row of the table

C       iunit   i  Fortran I/O unit number
C       naxis1  i  width in bytes of existing table
C       naxis2  i  number of rows in the table
C       delbyt  i  how many bytes to insert in each row
C       fstbyt  i  byte position in the row to insert the bytes (0=row start)
C       status  i  returned error status (0=ok)

        integer iunit,naxis1,naxis2,delbyt,fstbyt,status

C       COMMON BLOCK DEFINITIONS:--------------------------------------------
        integer nf,nb,ne
        parameter (nb = 20)
        parameter (nf = 3000)
        parameter (ne = 200)
        integer bufnum,chdu,hdutyp,maxhdu,hdstrt,hdend,nxthdr,dtstrt
        integer nxtfld
        logical wrmode
        common/ft0001/bufnum(199),chdu(nb),hdutyp(nb),maxhdu(nb),
     &  wrmode(nb),hdstrt(nb,ne),hdend(nb),nxthdr(nb),dtstrt(nb),nxtfld
        integer tfield,tstart,tbcol,rowlen,tdtype,trept,tnull,scount
        integer theap,nxheap
        double precision tscale,tzero
        common/ft0002/tfield(nb),tstart(nb),tbcol(nf),rowlen(nb),
     &  tdtype(nf),trept(nf),tscale(nf),tzero(nf),tnull(nf),scount(nb)
     &  ,theap(nb),nxheap(nb)
        character*1 buff(5760)
        common/ftheap/buff
C       END OF COMMON BLOCK DEFINITIONS-----------------------------------

        integer ibuff,i,i1,irow,newlen,fbyte,nseg,nbytes
        character cfill*1

        if (status .gt. 0)return

C       define the number of the buffer used for this file
        ibuff=bufnum(iunit)

C       select appropriate fill value
        if (hdutyp(ibuff) .eq. 1)then
C           fill  header or ASCII table with space
            cfill=char(32)
        else
C           fill image or bintable data area with Null (0)
            cfill=char(0)
        end if

        newlen=naxis1+delbyt

        if (newlen .le. 5760)then
C ***********************************************************************
C       CASE #1: optimal case where whole new row fits in the work buffer
C ***********************************************************************
C           write the correct fill value into the buffer
            do 10 i=1,delbyt
                buff(i)=cfill
10          continue
            i1=delbyt+1

C           first move the trailing bytes (if any) in the last row
            fbyte=fstbyt+1
            nbytes=naxis1-fstbyt
            call ftgtbs(iunit,naxis2,fbyte,nbytes,buff(i1),status)

C           set row length to its new value
            rowlen(ibuff)=newlen

C           write the row (with leading fill bytes) in the new place
            nbytes=nbytes+delbyt
            call ftptbs(iunit,naxis2,fbyte,nbytes,buff,status)

C           reset row length to its original value
            rowlen(ibuff)=naxis1

C           now move the rest of the rows
            do 20 irow=naxis2-1,1,-1
C               read the row to be shifted (work backwards through the table)
                call ftgtbs(iunit,irow,fbyte,naxis1,buff(i1),status)

C               set row length to its new value
                rowlen(ibuff)=newlen

C               write the row (with the leading fill bytes) in the new place
                call ftptbs(iunit,irow,fbyte,newlen,buff,status)

C               reset row length to its original value
                rowlen(ibuff)=naxis1
20          continue

        else
C ************************************************************************
C       CASE #2:  whole row doesn't fit in work buffer; move row in pieces
C ************************************************************************
C           first copy the data, then go back and write fill into the new column
C           start by copying the trailing bytes (if any) in the last row

            nbytes=naxis1-fstbyt
            nseg=(nbytes+5759)/5760
            fbyte=(nseg-1)*5760+fstbyt+1
            nbytes=naxis1-fbyte+1

            do 25 i=1,nseg
                call ftgtbs(iunit,naxis2,fbyte,nbytes,buff,status)

C               set row length to its new value
                rowlen(ibuff)=newlen

C               write the row in the new place
                call ftptbs(iunit,naxis2,fbyte+delbyt,nbytes,
     &                      buff,status)

C               reset row length to its original value
                rowlen(ibuff)=naxis1
                          
                fbyte=fbyte-5760
                nbytes=5760
25          continue

C           now move the rest of the rows
            nseg=(naxis1+5759)/5760

            do 40 irow=naxis2-1,1,-1
                fbyte=(nseg-1)*5760+fstbyt+1
                nbytes=naxis1-(nseg-1)*5760
                do 30 i=1,nseg
C                   read the row to be shifted (work backwards thru the table)
                    call ftgtbs(iunit,irow,fbyte,nbytes,buff,status)

C                   set row length to its new value
                    rowlen(ibuff)=newlen

C                   write the row in the new place
                    call ftptbs(iunit,irow,fbyte+delbyt,nbytes,
     &                          buff,status)

C                   reset row length to its original value
                    rowlen(ibuff)=naxis1

                    fbyte=fbyte-5760
                    nbytes=5760
30              continue
40          continue

C           now write the fill values into the new column
            nbytes=min(delbyt,5760)
            do 50 i=1,nbytes
                    buff(i)=cfill
50          continue

            nseg=(delbyt+5759)/5760

C           set row length to its new value
            rowlen(ibuff)=newlen

            do 70 irow=1,naxis2
                fbyte=fstbyt+1
                nbytes=delbyt-((nseg-1)*5760)
                do 60 i=1,nseg
C                   write the fill
                    call ftptbs(iunit,irow,fbyte,nbytes,buff,status)
                    fbyte=fbyte+nbytes
                    nbytes=5760
60              continue
70          continue

C           reset the rowlength
            rowlen(ibuff)=naxis1
        end if
        end

      subroutine flash4 (ifw,lwd,ipoint)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
      dimension       ifw(1) ,lwd(1)
      jfwa = loci(ifw)
      jlwda = loci(lwd)
      kpoint = ipoint
      if (jfwa .gt. jlwda) go to 101
      if (kpoint.lt.0 .or. kpoint.gt.10) go to 102
      nextra = 5
      mfwa(kpoint+1) = jfwa
      mlwa(kpoint+1) = jlwda-nextra
      nwds = jlwda-jfwa
      modef = 4
      return
  101 continue
c     write (mprint,1001) jfwa,jlwda
c
      call uliber (0,38h0loci(ifw).gt.loci(lwd) in flash4 call,38)
      call perror
      return
  102 continue
c     write (mprint,1002) kpoint
c
      call uliber (0,43h0third argument out of range in flash4 call,43)
      call perror
      return
c
c1001 format (10h0loci(ifw)=,i10,10x,9hloci(lwd)=,i10)
c1002 format (27h0flash4 called with ipoint=,i5)
c
      end

C
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C ---------------------------------------------------------------------
C
      SUBROUTINE AGSCAN (TPID,LOPA,NIPA,IIPA)
C
      CHARACTER*(*) TPID
C
C The routine AGSCAN is used by AGGETP and AGSETP to scan a parameter
C identifier and return a description of the parameter-list items which
C are specified by that parameter identifier.  It has the following
C arguments:
C
C -- TPID is the parameter identifier.
C
C -- LOPA is the index of the first parameter-list item specified.
C
C -- NIPA is the number of parameter-list items specified.
C
C -- IIPA is the index increment between one of the parameter-list items
C    specified and the next (meaningless if NIPA=1).
C
C
C BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE
C
C Originally, this routine used the function "LOC" to return, in LOPA,
C the base address, in core, of the specified parameter group.  To some
C degree, it was thereby insulated from changes in the labelled common
C block AGCONP.  With the demise of "LOC", LOPA has been re-defined and
C that insulation no longer exists.  In the following code, there are
C integers which represent the indices of desired quantities in common.
C
C BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE BEWARE
C
C
C The following common block contains the AUTOGRAPH control parameters,
C all of which are real.  If it is changed, all of AUTOGRAPH (especially
C the routine AGSCAN) must be examined for possible side effects.
C
      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL(2) ,
     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
     +                XMIN,XMAX,QLUX,QOVX,QCEX,XLOW,XHGH ,
     +                YMIN,YMAX,QLUY,QOVY,QCEY,YLOW,YHGH ,
     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
     +                XBGA(4),YBGA(4),UBGA(4),XNDA(4),YNDA(4),UNDA(4),
     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
     +                WNLE(4),QLUA(4) ,
     +                RBOX(6),DBOX(6,4),SBOX(6,4)
C
C Declare the block data routine EXTERNAL to force loading of it.
C
C +NOAO - call agdflt as run time initialization
C
C     EXTERNAL AGDFLT
      call agdflt
C -NOAO
C
C Initialize the parameter-identifier character index.
C
      IPID=0
C
C Initialize the value of the index increment to be returned.
C
      IIPA=1
C
C Find the first keyword in the parameter identifier.
C
      CALL AGSRCH (TPID,IPID,IKWL,'PRIMFRAMSET ROW INVEWINDNULLGRAPGRIDX
     +   Y   AXISLEFTRIGHBOTTTOP DASHLABELINESECOBACK')
C
      GO TO (101,102,103,104,105,106,107,108,109,110,
     +       111,113,114,114,114,114,132,133,147,155,166,901) , IKWL
C
C PRIMARY CONTROL PARAMETERS.
C
  101 LOPA=1
      NIPA=336
      GO TO 203
C
C FRAME PARAMETER.
C
  102 LOPA=1
      GO TO 202
C
C SET PARAMETER.
C
  103 LOPA=2
      GO TO 202
C
C ROW PARAMETER.
C
  104 LOPA=3
      GO TO 202
C
C X/Y INVERSION PARAMETER.
C
  105 LOPA=4
      GO TO 202
C
C WINDOWING PARAMETER.
C
  106 LOPA=5
      GO TO 202
C
C BACKGROUND PARAMETER.
C
  166 LOPA=6
      GO TO 202
C
C NULL PARAMETER(S).
C
  107 LOPA=7
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'1   2   ')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C PLOT (GRAPH) WINDOW PARAMETERS.
C
  108 LOPA=9
      NIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP ')
C
      IF (IKWL.EQ.5) GO TO 901
      GO TO 201
C
C GRID WINDOW PARAMETERS.
C
  109 LOPA=13
      NIPA=5
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP SHAP')
C
      IF (IKWL.EQ.6) GO TO 901
      GO TO 201
C
C X DATA PARAMETERS.
C
  110 LOPA=18
      GO TO 112
C
C Y DATA PARAMETERS.
C
  111 LOPA=25
C
C X OR Y DATA PARAMETERS.
C
  112 NIPA=7
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'MINIMAXILOGAORDENICESMALLARG')
C
      IF (IKWL.EQ.8) GO TO 901
      GO TO 201
C
C AXIS PARAMETERS.
C
  113 LOPA=32
      NIPA=92
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP ')
C
      IF (IKWL.EQ.5) GO TO 901
      IKWL=IKWL+12
C
C LEFT, RIGHT, BOTTOM, OR TOP AXIS PARAMETERS.
C
  114 LOPA=19+IKWL
      NIPA=23
      IIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +       'CONTLINEINTEFUNCTICKMAJOMINONUMETYPEEXPOFRACANGLOFFSWIDT')
C
      GO TO (202,201,115,167,116,117,123,126,127,127,127,
     +       127,127,127,901) , IKWL
C
C AXIS INTERSECTION PARAMETERS.
C
  115 LOPA=LOPA+8
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'GRIDUSER')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C AXIS MAPPING FUNCTION.
C
  167 LOPA=LOPA+16
      GO TO 202
C
C AXIS TICK PARAMETERS.
C
  116 LOPA=LOPA+20
      NIPA=10
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'MAJOMINO')
C
      LOPA=LOPA-20
      GO TO (117,123,901) , IKWL
C
C AXIS MAJOR-TICK PARAMETERS.
C
  117 LOPA=LOPA+20
      NIPA=6
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'SPACTYPEBASECOUNPATTLENGOUTWINWA')
C
      GO TO (118,119,119,119,120,121,122,122,901) , IKWL
C
C AXIS MAJOR-TICK SPACING PARAMETERS.
C
  118 NIPA=3
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'TYPEBASECOUN')
C
      IF (IKWL.EQ.4) GO TO 901
C
      GO TO 201
C
  119 IKWL=IKWL-1
      GO TO 201
C
C AXIS MAJOR-TICK DASH PATTERN.
C
  120 LOPA=LOPA+12
      GO TO 202
C
C AXIS MAJOR-TICK LENGTH PARAMETERS.
C
  121 LOPA=LOPA+16
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'OUTWINWA')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
  122 LOPA=LOPA+16
      IKWL=IKWL-6
      GO TO 201
C
C AXIS MINOR-TICK PARAMETERS.
C
  123 LOPA=LOPA+44
      NIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'SPACPATTLENGOUTWINWA')
C
      GO TO (202,201,124,125,125,901) , IKWL
C
C AXIS MINOR-TICK LENGTH PARAMETERS.
C
  124 LOPA=LOPA+8
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'OUTWINWA')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
  125 LOPA=LOPA+8
      IKWL=IKWL-3
      GO TO 201
C
C AXIS NUMERIC-LABEL PARAMETERS.
C
  126 LOPA=LOPA+60
      NIPA=8
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'TYPEEXPOFRACANGLOFFSWIDT')
C
      GO TO 128
C
  127 LOPA=LOPA+60
      IKWL=IKWL-8
C
  128 GO TO (202,201,201,129,130,131,901) ,IKWL
C
C AXIS NUMERIC-LABEL ORIENTATION ANGLE.
C
  129 LOPA=LOPA+12
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'1ST 2ND ')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C AXIS NUMERIC-LABEL OFFSET.
C
  130 LOPA=LOPA+20
      GO TO 202
C
C AXIS NUMERIC-LABEL WIDTH PARAMETERS.
C
  131 LOPA=LOPA+24
      NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'MANTEXPO')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C DASH-PATTERN PARAMETERS.
C
  132 LOPA=124
      NIPA=30
      IF (TPID(IPID:IPID).EQ.'.') RETURN
      JPID=IPID
      CALL AGSRCH (TPID,IPID,IKWL,'SELELENGCHARDOLLPATT')
      IF (IKWL.EQ.6) THEN
        IPID=JPID
        GO TO 168
      END IF
      IF (IKWL.NE.5) GO TO 201
  168 LOPA=LOPA+4
      NIPA=26
      IF (TPID(IPID:IPID).EQ.'.') RETURN
      CALL AGSRCH (TPID,IPID,IKWL,
     +'1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16  1
     +7  18  19  20  21  22  23  24  25  26  ')
      IF (IKWL.EQ.27) GO TO 901
      GO TO 201
C
C LABEL PARAMETERS.
C
  133 LBIM=IFIX(QBIM)
      LBAN=IFIX(QBAN)
C
      LOPA=154
      NIPA=3+LBIM*10
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +                   'CONTBUFFNAMEDEFISUPPBASEOFFSANGLCENTLINEINDE')
C
      GO TO (202,136,139,140,141,141,141,141,141,141,141,901) , IKWL
C
C LABEL BUFFER PARAMETERS.
C
  136 LOPA=155
      NIPA=1+LBIM*10
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LENGCONTNAME')
C
      GO TO (202,137,138,901) , IKWL
C
C LABEL BUFFER CONTENTS.
C
  137 LOPA=156
      NIPA=LBIM*10
      GO TO 203
C
C LABEL BUFFER NAMES.
C
  138 LOPA=156
      NIPA=LBIM
      IIPA=10
      GO TO 203
C
C LABEL NAME.
C
  139 LOPA=236
      GO TO 202
C
C LABEL DEFINITION.
C
  140 IF (LBAN.LT.1.OR.LBAN.GT.LBIM) GO TO 902
C
      LOPA=157+(LBAN-1)*10
      NIPA=9
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'SUPPBASEOFFSANGLCENTLINEINDE')
C
      GO TO 142
C
  141 IF (LBAN.LT.1.OR.LBAN.GT.LBIM) GO TO 902
C
      LOPA=157+(LBAN-1)*10
      IKWL=IKWL-4
C
  142 GO TO (202,143,144,146,146,146,146,901) , IKWL
C
C LABEL POSITION.
C
  143 LOPA=LOPA+1
      GO TO 145
C
C LABEL OFFSET.
C
  144 LOPA=LOPA+3
C
C LABEL POSITION OR OFFSET.
C
  145 NIPA=2
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'X   Y   ')
C
      IF (IKWL.EQ.3) GO TO 901
      GO TO 201
C
C OTHER LABEL ATTRIBUTES.
C
  146 LOPA=LOPA+5
      IKWL=IKWL-3
      GO TO 201
C
C LINE PARAMETERS.
C
  147 LNIM=IFIX(QNIM)
      LNAN=IFIX(QNAN)
C
      LOPA=237
      NIPA=4+LNIM*6
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +                       'MAXIEND BUFFNUMBDEFISUPPCHARTEXTLENGINDE')
C
      GO TO (202,201,150,152,153,154,154,154,154,154,901) , IKWL
C
C LINE BUFFER PARAMETERS.
C
  150 LOPA=239
      NIPA=1+LNIM*6
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'LENGCONT')
C
      GO TO (202,151,901) , IKWL
C
C LINE BUFFER CONTENTS.
C
  151 LOPA=240
      NIPA=LNIM*6
      GO TO 203
C
C LINE NUMBER.
C
  152 LOPA=336
      GO TO 202
C
C LINE DEFINITION.
C
  153 IF (LNAN.LT.1.OR.LNAN.GT.LNIM) GO TO 903
C
      LOPA=241+(LNAN-1)*6
      NIPA=5
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'SUPPCHARTEXTLENGINDE')
C
      IF (IKWL.EQ.6) GO TO 901
      GO TO 201
C
  154 IF (LNAN.LT.1.OR.LNAN.GT.LNIM) GO TO 903
      LOPA=241+(LNAN-1)*6
      IKWL=IKWL-5
      GO TO 201
C
C SECONDARY CONTROL PARAMETERS.
C
  155 LOPA=337
      NIPA=149
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,
     +                       'GRAPUSERCURVDIMEAXISLEFTRIGHBOTTTOP LABE')
C
      GO TO (156,157,158,159,160,161,161,161,161,165,901) , IKWL
C
C PLOT (GRAPH) WINDOW EDGES.
C
  156 LOPA=337
      NIPA=4
      GO TO 203
C
C USER WINDOW PARAMETERS.
C
  157 LOPA=341
      NIPA=4
      GO TO 203
C
C CURVE WINDOW PARAMETERS.
C
  158 LOPA=345
      NIPA=4
      GO TO 203
C
C CURVE WINDOW DIMENSIONS.
C
  159 LOPA=349
      NIPA=3
      GO TO 203
C
C AXIS PARAMETERS.
C
  160 LOPA=352
      NIPA=80
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP ')
C
      IF (IKWL.EQ.5) GO TO 901
C
      IKWL=IKWL+5
C
C LEFT, RIGHT, BOTTOM, OR TOP AXIS PARAMETERS.
C
  161 LOPA=346+IKWL
      NIPA=20
      IIPA=4
      IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGSRCH (TPID,IPID,IKWL,'POSITICKNUME')
C
      GO TO (162,163,164,901) , IKWL
C
C AXIS POSITIONING PARAMETERS.
C
  162 NIPA=6
      GO TO 203
C
C AXIS TICK PARAMETERS.
C
  163 LOPA=LOPA+24
      NIPA=3
      GO TO 203
C
C AXIS NUMERIC-LABEL PARAMETERS.
C
  164 LOPA=LOPA+36
      NIPA=11
      GO TO 203
C
C LABEL BOXES.
C
  165 LOPA=432
      NIPA=54
      IF (TPID(IPID:IPID).EQ.'.') GO TO 203
C
      CALL AGSRCH (TPID,IPID,IKWL,'LEFTRIGHBOTTTOP CENTGRAP')
C
      IF (IKWL.EQ.7) GO TO 901
C
      LOPA=LOPA+IKWL-1
      NIPA=9
      IIPA=6
      GO TO 203
C
C Normal exits.
C
  201 LOPA=LOPA+(IKWL-1)*IIPA
C
  202 NIPA=1
C
  203 IF (TPID(IPID:IPID).EQ.'.') RETURN
C
      CALL AGPPID (TPID)
C +NOAO - following FTN write and fmt statements commented out, SETER is okay.
C
C     WRITE (I1MACH(4),1001)
      RETURN
C
C Error exits.
C
  901 CALL AGPPID (TPID)
      CALL SETER ('AGGETP OR AGSETP - ILLEGAL KEYWORD USED IN PARAMETER
     +IDENTIFIER',11,2)
C
  902 CALL AGPPID (TPID)
      CALL SETER ('AGGETP OR AGSETP - ATTEMPT TO ACCESS LABEL ATTRIBUTES
     + BEFORE SETTING LABEL NAME',12,2)
C
  903 CALL AGPPID (TPID)
      CALL SETER ('AGGETP OR AGSETP - ATTEMPT TO ACCESS LINE ATTRIBUTES
     +BEFORE SETTING LINE NUMBER',13,2)
C
C Formats.
C
C1001 FORMAT (' WARNING - ABOVE PARAMETER IDENTIFIER HAS TOO MANY KEYWOR
C    +DS')
C
C -NOAO
      END

      integer function cupper (c)
      integer c
      if (.not.(c .ge. 97 .and. c .le. 122))goto 23000
      cupper = c + (65 - 97)
      goto 23001
23000 continue
      cupper = c
23001 continue
      return
      end

C----------------------------------------------------------------------
        subroutine ftgtbc(tfld,tdtype,trept,tbcol,lenrow,status)

C       Get Table Beginning Columns
C       determine the byte offset of the beginning of each field of a 
C       binary table

C       tfld   i  number of fields in the binary table
C       tdtype i array of numerical datatype codes of each column
C       trept  i array of repetition factors for each column
C       OUTPUT PARAMETERS:
C       tbcol  i array giving the byte offset to the start of each column
C       lenrow i total width of the table, in bytes
C       status i  returned error status
C
C       written by Wm Pence, HEASARC/GSFC, June 1991
C       modified 6/17/92 to deal with ASCII column trept values measured
C       in units of characters rather than in terms of number of repeated
C       strings.

        integer tfld,tdtype(*),trept(*),tbcol(*),lenrow
        integer status,i,nbytes
        character ifld*4

        if (status .gt. 0)return

C       the first column always begins at the first byte of the row:
        tbcol(1)=0
        
        do 100 i=1,tfld-1
                if (tdtype(i) .eq. 16)then
C                       ASCII field; each character is 1 byte
                        nbytes=1
                else if (tdtype(i) .gt. 0)then
                        nbytes=tdtype(i)/10
                else if (tdtype(i) .eq. 0)then
C                   error: data type of column not defined! (no TFORM keyword)
                        status=232
                        write(ifld,1000)i
1000                    format(i4)
                        call ftpmsg('Field'//ifld//' of the binary'//
     &                  ' table has no TFORMn keyword')
                        return
                else 
C                       this is a descriptor field: 2J
                        nbytes=8
                end if

                if (nbytes .eq. 0)then
C                       this is a bit array
                        tbcol(i+1)=tbcol(i)+(trept(i)+7)/8
                else
                        tbcol(i+1)=tbcol(i)+trept(i)*nbytes
                end if
100     continue

C       determine the total row width
        if (tdtype(tfld) .eq. 16)then
C               ASCII field; each character is 1 byte
                nbytes=1
        else if (tdtype(tfld) .gt. 0)then
                nbytes=tdtype(tfld)/10
        else if (tdtype(i) .eq. 0)then
C            error: data type of column not defined! (no TFORM keyword)
                status=232
                write(ifld,1000)tfld
                call ftpmsg('Field'//ifld//' of the binary'//
     &                  ' table is missing required TFORMn keyword.')
                return
        else
C               this is a descriptor field: 2J
                nbytes=8
        end if
        if (nbytes .eq. 0)then
C               this is a bit array
                lenrow=tbcol(tfld)+(trept(tfld)+7)/8
        else
                lenrow=tbcol(tfld)+trept(tfld)*nbytes
        end if

        end

C--------------------------------------------------------------------------
        subroutine fttkyn(iunit,nkey,keynam,keyval,status)

C       test that the keyword number NKEY has name = KEYNAM
C       and has value = KEYVAL
C
C       iunit   i  Fortran I/O unit number
C       nkey    i  sequence number of the keyword to test
C       keynam  c  name that the keyword is supposed to have
C       keyval  c  value that the keyword is supposed to have
C       OUTPUT PARAMETERS:
C       status  i  returned error status (0=ok)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991
C
        integer iunit,nkey,status
        character*(*) keynam,keyval
        character kname*8,value*30,comm*48,npos*8,keybuf*80
        character errmsg*80

        if (status .gt. 0)return

C       read the name and value of the keyword

C       get the whole record
        call ftgrec(iunit,nkey,keybuf,status)

        kname=keybuf(1:8)
C       parse the value and comment fields from the record
        call ftpsvc(keybuf,value,comm,status)
        if (status .gt. 0)go to 900

C       test if the keyword has the correct name
        if (kname .ne. keynam)then
                status=208
                go to 900
        end if

C       check that the keyword has the correct value
        if (value .ne. keyval)then
                status=209
        end if

900     continue
        if (status .gt. 0)then

            write(npos,1000)nkey
1000        format(i8)
            errmsg='FTTKYN found unexpected keyword or value '//
     &      'for header keyword number '//npos//'.'
            call ftpmsg(errmsg)
            errmsg='  Was expecting keyword '//keynam//
     &      ' with value = '//keyval
            call ftpmsg(errmsg)
            if (keybuf(9:10) .ne. '= ')then
              errmsg='      but found keyword '//kname//
     &      ' with no "= " in cols. 9-10.'
            else
              errmsg='      but found keyword '//kname//
     &      ' with value = '//value
            end if
            call ftpmsg(errmsg)
            call ftpmsg(keybuf)
        end if
        end

      REAL FUNCTION slRVLK (R2000, D2000)
*+
*     - - - - - - -
*      R V L K
*     - - - - - - -
*
*  Velocity component in a given direction due to the Sun's motion
*  with respect to an adopted kinematic Local Standard of Rest.
*
*  (single precision)
*
*  Given:
*     R2000,D2000   r    J2000.0 mean RA,Dec (radians)
*
*  Result:
*     Component of "standard" solar motion in direction R2000,D2000 (km/s)
*
*  Sign convention:
*     The result is +ve when the Sun is receding from the given point on
*     the sky.
*
*  Note:  The Local Standard of Rest used here is one of several
*         "kinematical" LSRs in common use.  A kinematical LSR is the
*         mean standard of rest of specified star catalogues or stellar
*         populations.  The Sun's motion with respect to a kinematical
*         LSR is known as the "standard" solar motion.
*
*         There is another sort of LSR, the "dynamical" LSR, which is a
*         point in the vicinity of the Sun which is in a circular orbit
*         around the Galactic centre.  The Sun's motion with respect to
*         the dynamical LSR is called the "peculiar" solar motion.  To
*         obtain a radial velocity correction with respect to the
*         dynamical LSR use the routine slRVLD.
*
*  Reference:  Delhaye (1965), in "Stars and Stellar Systems", vol 5,
*              p73.
*
*  Called:
*     slCS2C, slVDV
*
*  P.T.Wallace   Starlink   11 March 1994
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      REAL R2000,D2000

      REAL VA(3), VB(3)

      REAL slVDV

*
*  Standard solar motion (from Methods of Experimental Physics, ed Meeks,
*  vol 12, part C, sec 6.1.5.2, p281):
*
*  20 km/s towards RA 18h Dec +30d (1900).
*
*  The solar motion is expressed here in the form of a J2000.0
*  equatorial Cartesian vector:
*
*      VA(1) = X = -SPEED*COS(RA)*COS(DEC)
*      VA(2) = Y = -SPEED*SIN(RA)*COS(DEC)
*      VA(3) = Z = -SPEED*SIN(DEC)

      DATA VA / -0.29000, +17.31726, -10.00141 /



*  Convert given J2000 RA,Dec to x,y,z
      CALL slCS2C(R2000,D2000,VB)

*  Compute dot product with solar motion vector
      slRVLK=slVDV(VA,VB)

      END

      integer function lex (lexstr)
      integer lexstr (100)
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer gnbtok, t, c
      integer lookup, n
      integer sdefa0(8)
      data sdefa0(1)/100/,sdefa0(2)/101/,sdefa0(3)/102/,sdefa0(4)/97/,sd
     *efa0(5)/117/,sdefa0(6)/108/,sdefa0(7)/116/,sdefa0(8)/-2/
      lex = gnbtok (lexstr, 100)
23000 if (.not.(lex .eq. 10))goto 23002
23001  lex = gnbtok (lexstr, 100)
      goto 23000
23002 continue
      if (.not.(lex .eq. -1 .or. lex .eq. 59 .or. lex .eq. 123 .or. lex 
     *.eq. 125))goto 23003
      return
23003 continue
      if (.not.(lex .eq. 48))goto 23005
      lex = -89
      goto 23006
23005 continue
      if (.not.(lex .eq. 37))goto 23007
      lex = -85
      goto 23008
23007 continue
      if (.not.(lex .eq.  -166))goto 23009
      lex = -67
      goto 23010
23009 continue
      if (.not.(lookup (lexstr, lex, rkwtbl) .eq. 1))goto 23011
      if (.not.(lex .eq. -90))goto 23013
      n = -1
23015 continue
      c = ngetch (c)
      n = n + 1
23016 if (.not.(c .ne. 32 .and. c .ne. 9))goto 23015
23017 continue
      call putbak (c)
      t = gnbtok (lexstr, 100)
      call pbstr (lexstr)
      if (.not.(n .gt. 0))goto 23018
      call putbak (32)
23018 continue
      call scopy (sdefa0, 1, lexstr, 1)
      if (.not.(t .ne. 58))goto 23020
      lex = -80
23020 continue
23013 continue
      goto 23012
23011 continue
      lex = -80
23012 continue
23010 continue
23008 continue
23006 continue
      return
      end
c     logic0  logical_column
c     sdefa0  sdefault

      subroutine entdef (name, defn, table)
      integer name (100), defn (100)
      integer table
      integer lookup
      integer text
      integer sdupl
      if (.not.(lookup (name, text, table) .eq. 1))goto 23000
      call dsfree (text)
23000 continue
      call enter (name, sdupl (defn), table)
      return
      end

      function diff(x,y)
c     c.l.lawson and r.j.hanson, jet propulsion laboratory, 1973 june 7
c     to appear in 'solving least squares problems', prentice-hall, 1974
      diff=x-y
      return
      end

c subroutine linfit.f
c
c source
c   Bevington, pages 104-105.
c
c purpose
c   make a least-squares fit to a data set with a straight line
c
c usage
c   call linfit (x, y, sigmay, npts, mode, a, sigmaa, b, sigmab, r)
c
c description of parameters
c   x      - array of data points for independent variable
c   y      - array of data points for dependent variable
c   sigmay - array of standard deviations for y data points
c   npts   - number of pairs of data points
c   mode   - determines method of weighting least-squares fit
c            +1 (instrumental) weight(i) = 1./sigmay(i)**2
c             0 (no weighting) weight(i) = 1.
c            -1 (statistical)  weight(i) = 1./y(i)
c   a      - y intercept of fitted straight line
c   sigmaa - standard deviation of a
c   b      - slope of fitted straight line
c   sigmab - standard deviation of b
c   r      - linear correlation coefficient
c
c subroutines and function subprograms required
c   none
c
      subroutine linfit (x,y,sigmay,npts,mode,a,sigmaa,b,sigmab,r)
      double precision sum,sumx,sumy,sumx2,sumxy,sumy2
      double precision xi,yi,weight,delta,varnce
      dimension x(1),y(1),sigmay(1)
c
c accumulate weighted sums
c
11    sum=0.
      sumx=0.
      sumy=0.
      sumx2=0.
      sumxy=0.
      sumy2=0.
21    do 50 i=1,npts
      xi=x(i)
      yi=y(i)
      if (mode) 31,36,38
31    if (yi) 34,36,32
32    weight=1./yi
      goto 41
34    weight=1./(-yi)
      goto 41
36    weight=1.
      goto 41
38    weight=1./sigmay(i)**2
41    sum=sum+weight
      sumx=sumx+weight*xi
      sumy=sumy+weight*yi
      sumx2=sumx2+weight*xi*xi
      sumxy=sumxy+weight*xi*yi
      sumy2=sumy2+weight*yi*yi
50    continue
c
c calculate coefficients and standard deviations
c
51    delta=sum*sumx2-sumx*sumx
      a=(sumx2*sumy-sumx*sumxy)/delta
53    b=(sumxy*sum-sumx*sumy)/delta
61    if (mode) 62,64,62
62    varnce=1.
      goto 67
64    c=npts-2
      varnce=(sumy2+a*a*sum+b*b*sumx2
     *-2.*(a*sumy+b*sumxy-a*b*sumx))/c
67    sigmaa=dsqrt(varnce*sumx2/delta)
68    sigmab=dsqrt(varnce*sum/delta)
71    r=(sum*sumxy-sumx*sumy)/
     *dsqrt(delta*(sum*sumy2-sumy*sumy))
      return
      end

      subroutine bchfac ( w, nbands, nrow, diag )
c  from  * a practical guide to splines *  by c. de boor
constructs cholesky factorization
c		      c  =  l * d * l-transpose
c  with l unit lower triangular and d diagonal, for given matrix c of
c  order  n r o w , in case  c	is (symmetric) positive semidefinite
c  and	b a n d e d , having  n b a n d s  diagonals at and below the
c  main diagonal.
c
c******  i n p u t  ******
c  nrow.....is the order of the matrix	c .
c  nbands.....indicates its bandwidth, i.e.,
c	   c(i,j) = 0 for abs(i-j) .gt. nbands .
c  w.....workarray of size (nbands,nrow)  containing the  nbands  diago-
c	 nals in its rows, with the main diagonal in row  1 . precisely,
c	 w(i,j)  contains  c(i+j-1,j), i=1,...,nbands, j=1,...,nrow.
c	   for example, the interesting entries of a seven diagonal sym-
c	 metric matrix	c  of order  9	would be stored in  w  as
c
c			11 22 33 44 55 66 77 88 99
c			21 32 43 54 65 76 87 98
c			31 42 53 64 75 86 97
c			41 52 63 74 85 96
c
c	 all other entries of  w  not identified in this way with an en-
c	 try of  c  are never referenced .
c  diag.....is a work array of length  nrow .
c
c******  o u t p u t  ******
c  w.....contains the cholesky factorization  c = l*d*l-transp, with
c	 w(1,i) containing  1/d(i,i)
c	 and  w(i,j)  containing  l(i-1+j,j), i=2,...,nbands.
c
c******  m e t h o d  ******
c   gauss elimination, adapted to the symmetry and bandedness of  c , is
c   used .
c     near zero pivots are handled in a special way. the diagonal ele-
c  ment c(n,n) = w(1,n) is saved initially in  diag(n), all n. at the n-
c  th elimination step, the current pivot element, viz.  w(1,n), is com-
c  pared with its original value, diag(n). if, as the result of prior
c  elimination steps, this element has been reduced by about a word
c  length, (i.e., if w(1,n)+diag(n) .le. diag(n)), then the pivot is de-
c  clared to be zero, and the entire n-th row is declared to be linearly
c  dependent on the preceding rows. this has the effect of producing
c   x(n) = 0  when solving  c*x = b  for  x, regardless of  b. justific-
c  ation for this is as follows. in contemplated applications of this
c  program, the given equations are the normal equations for some least-
c  squares approximation problem, diag(n) = c(n,n) gives the norm-square
c  of the n-th basis function, and, at this point,  w(1,n)  contains the
c  norm-square of the error in the least-squares approximation to the n-
c  th basis function by linear combinations of the first n-1 . having
c  w(1,n)+diag(n) .le. diag(n) signifies that the n-th function is lin-
c  early dependent to machine accuracy on the first n-1 functions, there
c  fore can safely be left out from the basis of approximating functions
c     the solution of a linear system
c			c*x = b
c   is effected by the succession of the following  t w o  calls:
c     call bchfac ( w, nbands, nrow, diag )	  , to get factorization
c     call bchslv ( w, nbands, nrow, b, x )	       , to solve for x.
c
      integer nbands,nrow,   i,imax,j,jmax,n
      real w(nbands,nrow),diag(nrow),	ratio
      if (nrow .gt. 1)			go to 9
      if (w(1,1) .gt. 0.) w(1,1) = 1./w(1,1)
					return
c					 store diagonal of  c  in  diag.
    9 do 10 n=1,nrow
   10	 diag(n) = w(1,n)
c							 factorization .
      do 20 n=1,nrow
	 if (w(1,n)+diag(n) .gt. diag(n)) go to 15
	 do 14 j=1,nbands
   14	    w(j,n) = 0.
					go to 20
   15	 w(1,n) = 1./w(1,n)
	 imax = min0(nbands-1,nrow - n)
	 if (imax .lt. 1)		go to 20
	 jmax = imax
	 do 18 i=1,imax
	    ratio = w(i+1,n)*w(1,n)
	    do 17 j=1,jmax
   17	       w(j,n+i) = w(j,n+i) - w(j+i,n)*ratio
	    jmax = jmax - 1
   18	    w(i+1,n) = ratio
   20	 continue
					return
      end

      subroutine swend (lab)
      integer lab
      common /cdefio/ bp, buf (4096)
      integer bp
      integer buf
      common /cfname/ fcname (30)
      integer fcname
      common /cfor/ fordep, forstk (200)
      integer fordep
      integer forstk
      common /cgoto/ xfer
      integer xfer
      common /clabel/ label, retlab, memflg, col, logic0
      integer label
      integer retlab
      integer memflg
      integer col
      integer logic0
      common /cline/ dbgout, dbglev, level, linect (5), infile (5), fnam
     *p, fnames ( 150)
      integer dbgout
      integer dbglev
      integer level
      integer linect
      integer infile
      integer fnamp
      integer fnames
      common /cmacro/ cp, ep, evalst (500), deftbl
      integer cp
      integer ep
      integer evalst
      integer deftbl
      common /coutln/ outp, outbuf (74)
      integer outp
      integer outbuf
      common /csbuf/ sbp, sbuf(2048), smem(240)
      integer sbp
      integer sbuf
      integer smem
      common /cswtch/ swtop, swlast, swstak(1000), swvnum, swvlev, swvst
     *k(10), swinrg
      integer swtop
      integer swlast
      integer swstak
      integer swvnum
      integer swvlev
      integer swvstk
      integer swinrg
      common /ckword/ rkwtbl
      integer rkwtbl
      common /clname/ fkwtbl, namtbl, gentbl, errtbl, xpptbl
      integer fkwtbl
      integer namtbl
      integer gentbl
      integer errtbl
      integer xpptbl
      common /erchek/ ername, body, esp, errstk(30)
      integer ername
      integer body
      integer esp
      integer errstk
      integer mem( 60000)
      common/cdsmem/mem
      integer lb, ub, n, i, j, swn
      integer sif(5)
      integer slt(10)
      integer sgt(5)
      integer sgoto(7)
      integer seq(5)
      integer sge(5)
      integer sle(5)
      integer sand(6)
      data sif(1)/105/,sif(2)/102/,sif(3)/32/,sif(4)/40/,sif(5)/-2/
      data slt(1)/46/,slt(2)/108/,slt(3)/116/,slt(4)/46/,slt(5)/49/,slt(
     *6)/46/,slt(7)/111/,slt(8)/114/,slt(9)/46/,slt(10)/-2/
      data sgt(1)/46/,sgt(2)/103/,sgt(3)/116/,sgt(4)/46/,sgt(5)/-2/
      data sgoto(1)/103/,sgoto(2)/111/,sgoto(3)/116/,sgoto(4)/111/,sgoto
     *(5)/32/,sgoto(6)/40/,sgoto(7)/-2/
      data seq(1)/46/,seq(2)/101/,seq(3)/113/,seq(4)/46/,seq(5)/-2/
      data sge(1)/46/,sge(2)/103/,sge(3)/101/,sge(4)/46/,sge(5)/-2/
      data sle(1)/46/,sle(2)/108/,sle(3)/101/,sle(4)/46/,sle(5)/-2/
      data sand(1)/46/,sand(2)/97/,sand(3)/110/,sand(4)/100/,sand(5)/46/
     *,sand(6)/-2/
      swn = swvstk(swvlev)
      swvlev = max0(0, swvlev - 1)
      lb = swstak (swtop + 3)
      ub = swstak (swlast - 2)
      n = swstak (swtop + 1)
      call outgo (lab + 1)
      if (.not.(swstak (swtop + 2) .eq. 0))goto 23000
      swstak (swtop + 2) = lab + 1
23000 continue
      xfer = 0
      call indent (-1)
      call outcon (lab)
      call indent (1)
      if (.not.(n .ge. 3 .and. ub - lb + 1 .lt. 2 * n))goto 23002
      if (.not.(lb .ne. 1))goto 23004
      call outtab
      call swvar (swn)
      call outch (61)
      call swvar (swn)
      if (.not.(lb .lt. 1))goto 23006
      call outch (43)
23006 continue
      call outnum (-lb + 1)
      call outdon
23004 continue
      if (.not.(swinrg .eq. 0))goto 23008
      call outtab
      call outstr (sif)
      call swvar (swn)
      call outstr (slt)
      call swvar (swn)
      call outstr (sgt)
      call outnum (ub - lb + 1)
      call outch (41)
      call outch (32)
      call outgo (swstak (swtop + 2))
23008 continue
      call outtab
      call outstr (sgoto)
      j = lb
      i = swtop + 3
23010 if (.not.(i .lt. swlast))goto 23012
23013 if (.not.(j .lt. swstak (i)))goto 23015
      call outnum (swstak (swtop + 2))
      call outch (44)
23014 j = j + 1
      goto 23013
23015 continue
      j = swstak (i + 1) - swstak (i)
23016 if (.not.(j .ge. 0))goto 23018
      call outnum (swstak (i + 2))
23017 j = j - 1
      goto 23016
23018 continue
      j = swstak (i + 1) + 1
      if (.not.(i .lt. swlast - 3))goto 23019
      call outch (44)
23019 continue
23011 i = i + 3
      goto 23010
23012 continue
      call outch (41)
      call outch (44)
      call swvar (swn)
      call outdon
      goto 23003
23002 continue
      if (.not.(n .gt. 0))goto 23021
      i = swtop + 3
23023 if (.not.(i .lt. swlast))goto 23025
      call outtab
      call outstr (sif)
      call swvar (swn)
      if (.not.(swstak (i) .eq. swstak (i+1)))goto 23026
      call outstr (seq)
      call outnum (swstak (i))
      goto 23027
23026 continue
      call outstr (sge)
      call outnum (swstak (i))
      call outstr (sand)
      call swvar (swn)
      call outstr (sle)
      call outnum (swstak (i + 1))
23027 continue
      call outch (41)
      call outch (32)
      call outgo (swstak (i + 2))
23024 i = i + 3
      goto 23023
23025 continue
      if (.not.(lab + 1 .ne. swstak (swtop + 2)))goto 23028
      call outgo (swstak (swtop + 2))
23028 continue
23021 continue
23003 continue
      call indent (-1)
      call outcon (lab + 1)
      swlast = swtop
      swtop = swstak (swtop)
      swinrg = 0
      return
      end
c     logic0  logical_column

      SUBROUTINE slOBS (N, C, NAME, W, P, H)
*+
*     - - - -
*      O B S
*     - - - -
*
*  Parameters of selected groundbased observing stations
*
*  Given:
*     N       int     number specifying observing station
*
*  Either given or returned
*     C       c*(*)   identifier specifying observing station
*
*  Returned:
*     NAME    c*(*)   name of specified observing station
*     W       dp      longitude (radians, West +ve)
*     P       dp      geodetic latitude (radians, North +ve)
*     H       dp      height above sea level (metres)
*
*  Notes:
*
*     Station identifiers C may be up to 10 characters long,
*     and station names NAME may be up to 40 characters long.
*
*     C and N are alternative ways of specifying the observing
*     station.  The C option, which is the most generally useful,
*     may be selected by specifying an N value of zero or less.
*     If N is 1 or more, the parameters of the Nth station
*     in the currently supported list are interrogated, and
*     the station identifier C is returned as well as NAME, W,
*     P and H.
*
*     If the station parameters are not available, either because
*     the station identifier C is not recognized, or because an
*     N value greater than the number of stations supported is
*     given, a name of '?' is returned and C, W, P and H are left
*     in their current states.
*
*     Programs can obtain a list of all currently supported
*     stations by calling the routine repeatedly, with N=1,2,3...
*     When NAME='?' is seen, the list of stations has been
*     exhausted.
*
*     Station numbers, identifiers, names and other details are
*     subject to change and should not be hardwired into
*     application programs.
*
*     All station identifiers C are uppercase only;  lowercase
*     characters must be converted to uppercase by the calling
*     program.  The station names returned may contain both upper-
*     and lowercase.  All characters up to the first space are
*     checked;  thus an abbreviated ID will return the parameters
*     for the first station in the list which matches the
*     abbreviation supplied, and no station in the list will ever
*     contain embedded spaces.  C must not have leading spaces.
*
*     IMPORTANT -- BEWARE OF THE LONGITUDE SIGN CONVENTION.  The
*     longitude returned by slOBS is west-positive in accordance
*     with astronomical usage.  However, this sign convention is
*     left-handed and is the opposite of the one used by geographers;
*     elsewhere in SLALIB the preferable east-positive convention is
*     used.  In particular, note that for use in slAOP, slAOPA
*     and slOAP the sign of the longitude must be reversed.
*
*     Users are urged to inform the author of any improvements
*     they would like to see made.  For example:
*
*         typographical corrections
*         more accurate parameters
*         better station identifiers or names
*         additional stations
*
*  P.T.Wallace   Starlink   15 March 2002
*
*  Copyright (C) 2002 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      INTEGER N
      CHARACTER C*(*),NAME*(*)
      DOUBLE PRECISION W,P,H

      INTEGER NMAX,M,NS,I
      CHARACTER*10 CC

      DOUBLE PRECISION AS2R,WEST,NORTH,EAST,SOUTH
      INTEGER ID,IAM
      REAL AS
      PARAMETER (AS2R=0.484813681109535994D-5)

*  Table of station identifiers
      PARAMETER (NMAX=83)
      CHARACTER*10 CTAB(NMAX)
      DATA CTAB  (1) /'AAT       '/
      DATA CTAB  (2) /'LPO4.2    '/
      DATA CTAB  (3) /'LPO2.5    '/
      DATA CTAB  (4) /'LPO1      '/
      DATA CTAB  (5) /'LICK120   '/
      DATA CTAB  (6) /'MMT       '/
      DATA CTAB  (7) /'DAO72     '/
      DATA CTAB  (8) /'DUPONT    '/
      DATA CTAB  (9) /'MTHOP1.5  '/
      DATA CTAB (10) /'STROMLO74 '/
      DATA CTAB (11) /'ANU2.3    '/
      DATA CTAB (12) /'GBVA140   '/
      DATA CTAB (13) /'TOLOLO4M  '/
      DATA CTAB (14) /'TOLOLO1.5M'/
      DATA CTAB (15) /'TIDBINBLA '/
      DATA CTAB (16) /'BLOEMF    '/
      DATA CTAB (17) /'BOSQALEGRE'/
      DATA CTAB (18) /'FLAGSTF61 '/
      DATA CTAB (19) /'LOWELL72  '/
      DATA CTAB (20) /'HARVARD   '/
      DATA CTAB (21) /'OKAYAMA   '/
      DATA CTAB (22) /'KPNO158   '/
      DATA CTAB (23) /'KPNO90    '/
      DATA CTAB (24) /'KPNO84    '/
      DATA CTAB (25) /'KPNO36FT  '/
      DATA CTAB (26) /'KOTTAMIA  '/
      DATA CTAB (27) /'ESO3.6    '/
      DATA CTAB (28) /'MAUNAK88  '/
      DATA CTAB (29) /'UKIRT     '/
      DATA CTAB (30) /'QUEBEC1.6 '/
      DATA CTAB (31) /'MTEKAR    '/
      DATA CTAB (32) /'MTLEMMON60'/
      DATA CTAB (33) /'MCDONLD2.7'/
      DATA CTAB (34) /'MCDONLD2.1'/
      DATA CTAB (35) /'PALOMAR200'/
      DATA CTAB (36) /'PALOMAR60 '/
      DATA CTAB (37) /'DUNLAP74  '/
      DATA CTAB (38) /'HPROV1.93 '/
      DATA CTAB (39) /'HPROV1.52 '/
      DATA CTAB (40) /'SANPM83   '/
      DATA CTAB (41) /'SAAO74    '/
      DATA CTAB (42) /'TAUTNBG   '/
      DATA CTAB (43) /'CATALINA61'/
      DATA CTAB (44) /'STEWARD90 '/
      DATA CTAB (45) /'USSR6     '/
      DATA CTAB (46) /'ARECIBO   '/
      DATA CTAB (47) /'CAMB5KM   '/
      DATA CTAB (48) /'CAMB1MILE '/
      DATA CTAB (49) /'EFFELSBERG'/
      DATA CTAB (50) /'GBVA300   '/
      DATA CTAB (51) /'JODRELL1  '/
      DATA CTAB (52) /'PARKES    '/
      DATA CTAB (53) /'VLA       '/
      DATA CTAB (54) /'SUGARGROVE'/
      DATA CTAB (55) /'USSR600   '/
      DATA CTAB (56) /'NOBEYAMA  '/
      DATA CTAB (57) /'JCMT      '/
      DATA CTAB (58) /'ESONTT    '/
      DATA CTAB (59) /'ST.ANDREWS'/
      DATA CTAB (60) /'APO3.5    '/
      DATA CTAB (61) /'KECK1     '/
      DATA CTAB (62) /'TAUTSCHM  '/
      DATA CTAB (63) /'PALOMAR48 '/
      DATA CTAB (64) /'UKST      '/
      DATA CTAB (65) /'KISO      '/
      DATA CTAB (66) /'ESOSCHM   '/
      DATA CTAB (67) /'ATCA      '/
      DATA CTAB (68) /'MOPRA     '/
      DATA CTAB (69) /'SUBARU    '/
      DATA CTAB (70) /'CFHT      '/
      DATA CTAB (71) /'KECK2     '/
      DATA CTAB (72) /'GEMININ   '/
      DATA CTAB (73) /'FCRAO     '/
      DATA CTAB (74) /'IRTF      '/
      DATA CTAB (75) /'CSO       '/
      DATA CTAB (76) /'VLT1      '/
      DATA CTAB (77) /'VLT2      '/
      DATA CTAB (78) /'VLT3      '/
      DATA CTAB (79) /'VLT4      '/
      DATA CTAB (80) /'GEMINIS   '/
      DATA CTAB (81) /'KOSMA3M   '/
      DATA CTAB (82) /'MAGELLAN1 '/
      DATA CTAB (83) /'MAGELLAN2 '/

*  Degrees, arcminutes, arcseconds to radians
      WEST(ID,IAM,AS)=AS2R*(DBLE(60*(60*ID+IAM))+DBLE(AS))
      NORTH(ID,IAM,AS)=WEST(ID,IAM,AS)
      EAST(ID,IAM,AS)=-WEST(ID,IAM,AS)
      SOUTH(ID,IAM,AS)=-WEST(ID,IAM,AS)




*  Station specified by number or identifier?
      IF (N.GT.0) THEN

*     Station specified by number
         M=N
         IF (M.LE.NMAX) C=CTAB(M)

      ELSE

*     Station specified by identifier:  determine corresponding number
         CC=C
         DO NS=1,NMAX
            DO I=1,10
               IF (CC(I:I).EQ.' ') GO TO 5
               IF (CC(I:I).NE.CTAB(NS)(I:I)) GO TO 1
            END DO
            GO TO 5
 1          CONTINUE
         END DO
         NS=NMAX+1
 5       CONTINUE
         IF (C(1:1).NE.' ') THEN
            M=NS
         ELSE
            M=NMAX+1
         END IF

      END IF

*
*  Return parameters of Mth station
*  --------------------------------

      GO TO (10,20,30,40,50,60,70,80,90,100,
     :       110,120,130,140,150,160,170,180,190,200,
     :       210,220,230,240,250,260,270,280,290,300,
     :       310,320,330,340,350,360,370,380,390,400,
     :       410,420,430,440,450,460,470,480,490,500,
     :       510,520,530,540,550,560,570,580,590,600,
     :       610,620,630,640,650,660,670,680,690,700,
     :       710,720,730,740,750,760,770,780,790,800,
     :       810,820,830) M
      GO TO 9000

*  AAT (Observer's Guide)                                            AAT
 10   CONTINUE
      NAME='Anglo-Australian 3.9m Telescope'
      W=EAST(149,03,57.91)
      P=SOUTH(31,16,37.34)
      H=1164D0
      GO TO 9999

*  WHT (Gemini, April 1987)                                       LPO4.2
 20   CONTINUE
      NAME='William Herschel 4.2m Telescope'
      W=WEST(17,52,53.9)
      P=NORTH(28,45,38.1)
      H=2332D0
      GO TO 9999

*  INT (Gemini, April 1987)                                       LPO2.5
 30   CONTINUE
      NAME='Isaac Newton 2.5m Telescope'
      W=WEST(17,52,39.5)
      P=NORTH(28,45,43.2)
      H=2336D0
      GO TO 9999

*  JKT (Gemini, April 1987)                                         LPO1
 40   CONTINUE
      NAME='Jacobus Kapteyn 1m Telescope'
      W=WEST(17,52,41.2)
      P=NORTH(28,45,39.9)
      H=2364D0
      GO TO 9999

*  Lick 120" (S.L.Allen, private communication, 2002)            LICK120
 50   CONTINUE
      NAME='Lick 120 inch'
      W=WEST(121,38,13.689)
      P=NORTH(37,20,34.931)
      H=1286D0
      GO TO 9999

*  MMT 6.5m conversion (MMT Observatory website)                     MMT
 60   CONTINUE
      NAME='MMT 6.5m, Mt Hopkins'
      W=WEST(110,53,04.4)
      P=NORTH(31,41,19.6)
      H=2608D0
      GO TO 9999

*  Victoria B.C. 1.85m (1984 Almanac)                              DAO72
 70   CONTINUE
      NAME='DAO Victoria BC 1.85 metre'
      W=WEST(123,25,01.18)
      P=NORTH(48,31,11.9)
      H=238D0
      GO TO 9999

*  Las Campanas (1983 Almanac)                                    DUPONT
 80   CONTINUE
      NAME='Du Pont 2.5m Telescope, Las Campanas'
      W=WEST(70,42,9.)
      P=SOUTH(29,00,11.)
      H=2280D0
      GO TO 9999

*  Mt Hopkins 1.5m (1983 Almanac)                               MTHOP1.5
 90   CONTINUE
      NAME='Mt Hopkins 1.5 metre'
      W=WEST(110,52,39.00)
      P=NORTH(31,40,51.4)
      H=2344D0
      GO TO 9999

*  Mt Stromlo 74" (1983 Almanac)                               STROMLO74
 100  CONTINUE
      NAME='Mount Stromlo 74 inch'
      W=EAST(149,00,27.59)
      P=SOUTH(35,19,14.3)
      H=767D0
      GO TO 9999

*  ANU 2.3m, SSO (Gary Hovey)                                     ANU2.3
 110  CONTINUE
      NAME='Siding Spring 2.3 metre'
      W=EAST(149,03,40.3)
      P=SOUTH(31,16,24.1)
      H=1149D0
      GO TO 9999

*  Greenbank 140' (1983 Almanac)                                 GBVA140
 120  CONTINUE
      NAME='Greenbank 140 foot'
      W=WEST(79,50,09.61)
      P=NORTH(38,26,15.4)
      H=881D0
      GO TO 9999

*  Cerro Tololo 4m (1982 Almanac)                               TOLOLO4M
 130  CONTINUE
      NAME='Cerro Tololo 4 metre'
      W=WEST(70,48,53.6)
      P=SOUTH(30,09,57.8)
      H=2235D0
      GO TO 9999

*  Cerro Tololo 1.5m (1982 Almanac)                           TOLOLO1.5M
 140  CONTINUE
      NAME='Cerro Tololo 1.5 metre'
      W=WEST(70,48,54.5)
      P=SOUTH(30,09,56.3)
      H=2225D0
      GO TO 9999

*  Tidbinbilla 64m (1982 Almanac)                              TIDBINBLA
 150  CONTINUE
      NAME='Tidbinbilla 64 metre'
      W=EAST(148,58,48.20)
      P=SOUTH(35,24,14.3)
      H=670D0
      GO TO 9999

*  Bloemfontein 1.52m (1981 Almanac)                              BLOEMF
 160  CONTINUE
      NAME='Bloemfontein 1.52 metre'
      W=EAST(26,24,18.)
      P=SOUTH(29,02,18.)
      H=1387D0
      GO TO 9999

*  Bosque Alegre 1.54m (1981 Almanac)                         BOSQALEGRE
 170  CONTINUE
      NAME='Bosque Alegre 1.54 metre'
      W=WEST(64,32,48.0)
      P=SOUTH(31,35,53.)
      H=1250D0
      GO TO 9999

*  USNO 61" astrographic reflector, Flagstaff (1981 Almanac)   FLAGSTF61
 180  CONTINUE
      NAME='USNO 61 inch astrograph, Flagstaff'
      W=WEST(111,44,23.6)
      P=NORTH(35,11,02.5)
      H=2316D0
      GO TO 9999

*  Lowell 72" (1981 Almanac)                                    LOWELL72
 190  CONTINUE
      NAME='Perkins 72 inch, Lowell'
      W=WEST(111,32,09.3)
      P=NORTH(35,05,48.6)
      H=2198D0
      GO TO 9999

*  Harvard 1.55m (1981 Almanac)                                  HARVARD
 200  CONTINUE
      NAME='Harvard College Observatory 1.55m'
      W=WEST(71,33,29.32)
      P=NORTH(42,30,19.0)
      H=185D0
      GO TO 9999

*  Okayama 1.88m (1981 Almanac)                                  OKAYAMA
 210  CONTINUE
      NAME='Okayama 1.88 metre'
      W=EAST(133,35,47.29)
      P=NORTH(34,34,26.1)
      H=372D0
      GO TO 9999

*  Kitt Peak Mayall 4m (1981 Almanac)                            KPNO158
 220  CONTINUE
      NAME='Kitt Peak 158 inch'
      W=WEST(111,35,57.61)
      P=NORTH(31,57,50.3)
      H=2120D0
      GO TO 9999

*  Kitt Peak 90 inch (1981 Almanac)                               KPNO90
 230  CONTINUE
      NAME='Kitt Peak 90 inch'
      W=WEST(111,35,58.24)
      P=NORTH(31,57,46.9)
      H=2071D0
      GO TO 9999

*  Kitt Peak 84 inch (1981 Almanac)                               KPNO84
 240  CONTINUE
      NAME='Kitt Peak 84 inch'
      W=WEST(111,35,51.56)
      P=NORTH(31,57,29.2)
      H=2096D0
      GO TO 9999

*  Kitt Peak 36 foot (1981 Almanac)                             KPNO36FT
 250  CONTINUE
      NAME='Kitt Peak 36 foot'
      W=WEST(111,36,51.12)
      P=NORTH(31,57,12.1)
      H=1939D0
      GO TO 9999

*  Kottamia 74" (1981 Almanac)                                  KOTTAMIA
 260  CONTINUE
      NAME='Kottamia 74 inch'
      W=EAST(31,49,30.)
      P=NORTH(29,55,54.)
      H=476D0
      GO TO 9999

*  La Silla 3.6m (1981 Almanac)                                   ESO3.6
 270  CONTINUE
      NAME='ESO 3.6 metre'
      W=WEST(70,43,36.)
      P=SOUTH(29,15,36.)
      H=2428D0
      GO TO 9999

*  Mauna Kea 88 inch                                            MAUNAK88
*  (IfA website, Richard Wainscoat)
 280  CONTINUE
      NAME='Mauna Kea 88 inch'
      W=WEST(155,28,09.96)
      P=NORTH(19,49,22.77)
      H=4213.6D0
      GO TO 9999

*  UKIRT (IfA website, Richard Wainscoat)                          UKIRT
 290  CONTINUE
      NAME='UK Infra Red Telescope'
      W=WEST(155,28,13.18)
      P=NORTH(19,49,20.75)
      H=4198.5D0
      GO TO 9999

*  Quebec 1.6m (1981 Almanac)                                  QUEBEC1.6
 300  CONTINUE
      NAME='Quebec 1.6 metre'
      W=WEST(71,09,09.7)
      P=NORTH(45,27,20.6)
      H=1114D0
      GO TO 9999

*  Mt Ekar 1.82m (1981 Almanac)                                   MTEKAR
 310  CONTINUE
      NAME='Mt Ekar 1.82 metre'
      W=EAST(11,34,15.)
      P=NORTH(45,50,48.)
      H=1365D0
      GO TO 9999

*  Mt Lemmon 60" (1981 Almanac)                               MTLEMMON60
 320  CONTINUE
      NAME='Mt Lemmon 60 inch'
      W=WEST(110,42,16.9)
      P=NORTH(32,26,33.9)
      H=2790D0
      GO TO 9999

*  Mt Locke 2.7m (1981 Almanac)                               MCDONLD2.7
 330  CONTINUE
      NAME='McDonald 2.7 metre'
      W=WEST(104,01,17.60)
      P=NORTH(30,40,17.7)
      H=2075D0
      GO TO 9999

*  Mt Locke 2.1m (1981 Almanac)                               MCDONLD2.1
 340  CONTINUE
      NAME='McDonald 2.1 metre'
      W=WEST(104,01,20.10)
      P=NORTH(30,40,17.7)
      H=2075D0
      GO TO 9999

*  Palomar 200" (1981 Almanac)                                PALOMAR200
 350  CONTINUE
      NAME='Palomar 200 inch'
      W=WEST(116,51,50.)
      P=NORTH(33,21,22.)
      H=1706D0
      GO TO 9999

*  Palomar 60" (1981 Almanac)                                  PALOMAR60
 360  CONTINUE
      NAME='Palomar 60 inch'
      W=WEST(116,51,31.)
      P=NORTH(33,20,56.)
      H=1706D0
      GO TO 9999

*  David Dunlap 74" (1981 Almanac)                              DUNLAP74
 370  CONTINUE
      NAME='David Dunlap 74 inch'
      W=WEST(79,25,20.)
      P=NORTH(43,51,46.)
      H=244D0
      GO TO 9999

*  Haute Provence 1.93m (1981 Almanac)                         HPROV1.93
 380  CONTINUE
      NAME='Haute Provence 1.93 metre'
      W=EAST(5,42,46.75)
      P=NORTH(43,55,53.3)
      H=665D0
      GO TO 9999

*  Haute Provence 1.52m (1981 Almanac)                         HPROV1.52
 390  CONTINUE
      NAME='Haute Provence 1.52 metre'
      W=EAST(5,42,43.82)
      P=NORTH(43,56,00.2)
      H=667D0
      GO TO 9999

*  San Pedro Martir 83" (1981 Almanac)                           SANPM83
 400  CONTINUE
      NAME='San Pedro Martir 83 inch'
      W=WEST(115,27,47.)
      P=NORTH(31,02,38.)
      H=2830D0
      GO TO 9999

*  Sutherland 74" (1981 Almanac)                                  SAAO74
 410  CONTINUE
      NAME='Sutherland 74 inch'
      W=EAST(20,48,44.3)
      P=SOUTH(32,22,43.4)
      H=1771D0
      GO TO 9999

*  Tautenburg 2m (1981 Almanac)                                  TAUTNBG
 420  CONTINUE
      NAME='Tautenburg 2 metre'
      W=EAST(11,42,45.)
      P=NORTH(50,58,51.)
      H=331D0
      GO TO 9999

*  Catalina 61" (1981 Almanac)                                CATALINA61
 430  CONTINUE
      NAME='Catalina 61 inch'
      W=WEST(110,43,55.1)
      P=NORTH(32,25,00.7)
      H=2510D0
      GO TO 9999

*  Steward 90" (1981 Almanac)                                  STEWARD90
 440  CONTINUE
      NAME='Steward 90 inch'
      W=WEST(111,35,58.24)
      P=NORTH(31,57,46.9)
      H=2071D0
      GO TO 9999

*  Russian 6m (1981 Almanac)                                       USSR6
 450  CONTINUE
      NAME='USSR 6 metre'
      W=EAST(41,26,30.0)
      P=NORTH(43,39,12.)
      H=2100D0
      GO TO 9999

*  Arecibo 1000' (1981 Almanac)                                  ARECIBO
 460  CONTINUE
      NAME='Arecibo 1000 foot'
      W=WEST(66,45,11.1)
      P=NORTH(18,20,36.6)
      H=496D0
      GO TO 9999

*  Cambridge 5km (1981 Almanac)                                  CAMB5KM
 470  CONTINUE
      NAME='Cambridge 5km'
      W=EAST(0,02,37.23)
      P=NORTH(52,10,12.2)
      H=17D0
      GO TO 9999

*  Cambridge 1 mile (1981 Almanac)                             CAMB1MILE
 480  CONTINUE
      NAME='Cambridge 1 mile'
      W=EAST(0,02,21.64)
      P=NORTH(52,09,47.3)
      H=17D0
      GO TO 9999

*  Bonn 100m (1981 Almanac)                                   EFFELSBERG
 490  CONTINUE
      NAME='Effelsberg 100 metre'
      W=EAST(6,53,01.5)
      P=NORTH(50,31,28.6)
      H=366D0
      GO TO 9999

*  Greenbank 300' (1981 Almanac)                        GBVA300 (R.I.P.)
 500  CONTINUE
      NAME='Greenbank 300 foot'
      W=WEST(79,50,56.36)
      P=NORTH(38,25,46.3)
      H=894D0
      GO TO 9999

*  Jodrell Bank Mk 1 (1981 Almanac)                             JODRELL1
 510  CONTINUE
      NAME='Jodrell Bank 250 foot'
      W=WEST(2,18,25.)
      P=NORTH(53,14,10.5)
      H=78D0
      GO TO 9999

*  Australia Telescope Parkes Observatory                         PARKES
*  (Peter te Lintel Hekkert)
 520  CONTINUE
      NAME='Parkes 64 metre'
      W=EAST(148,15,44.3591)
      P=SOUTH(32,59,59.8657)
      H=391.79D0
      GO TO 9999

*  VLA (1981 Almanac)                                                VLA
 530  CONTINUE
      NAME='Very Large Array'
      W=WEST(107,37,03.82)
      P=NORTH(34,04,43.5)
      H=2124D0
      GO TO 9999

*  Sugar Grove 150' (1981 Almanac)                            SUGARGROVE
 540  CONTINUE
      NAME='Sugar Grove 150 foot'
      W=WEST(79,16,23.)
      P=NORTH(38,31,14.)
      H=705D0
      GO TO 9999

*  Russian 600' (1981 Almanac)                                   USSR600
 550  CONTINUE
      NAME='USSR 600 foot'
      W=EAST(41,35,25.5)
      P=NORTH(43,49,32.)
      H=973D0
      GO TO 9999

*  Nobeyama 45 metre mm dish (based on 1981 Almanac entry)      NOBEYAMA
 560  CONTINUE
      NAME='Nobeyama 45 metre'
      W=EAST(138,29,12.)
      P=NORTH(35,56,19.)
      H=1350D0
      GO TO 9999

*  James Clerk Maxwell 15 metre mm telescope, Mauna Kea             JCMT
*  From GPS measurements on 11Apr2007 for eSMA setup (R. Tilanus)
 570  CONTINUE
      NAME='JCMT 15 metre'
      W=WEST(155,28,37.30)
      P=NORTH(19,49,22.22)
      H=4124.75D0
      GO TO 9999

*  ESO 3.5 metre NTT, La Silla (K.Wirenstrand)                    ESONTT
 580  CONTINUE
      NAME='ESO 3.5 metre NTT'
      W=WEST(70,43,07.)
      P=SOUTH(29,15,30.)
      H=2377D0
      GO TO 9999

*  St Andrews University Observatory (1982 Almanac)           ST.ANDREWS
 590  CONTINUE
      NAME='St Andrews'
      W=WEST(2,48,52.5)
      P=NORTH(56,20,12.)
      H=30D0
      GO TO 9999

*  Apache Point 3.5 metre (R.Owen)                                APO3.5
 600  CONTINUE
      NAME='Apache Point 3.5m'
      W=WEST(105,49,11.56)
      P=NORTH(32,46,48.96)
      H=2809D0
      GO TO 9999

*  W.M.Keck Observatory, Telescope 1                               KECK1
*  (William Lupton)
 610  CONTINUE
      NAME='Keck 10m Telescope #1'
      W=WEST(155,28,28.99)
      P=NORTH(19,49,33.41)
      H=4160D0
      GO TO 9999

*  Tautenberg Schmidt (1983 Almanac)                            TAUTSCHM
 620  CONTINUE
      NAME='Tautenberg 1.34 metre Schmidt'
      W=EAST(11,42,45.0)
      P=NORTH(50,58,51.0)
      H=331D0
      GO TO 9999

*  Palomar Schmidt (1981 Almanac)                              PALOMAR48
 630  CONTINUE
      NAME='Palomar 48-inch Schmidt'
      W=WEST(116,51,32.0)
      P=NORTH(33,21,26.0)
      H=1706D0
      GO TO 9999

*  UK Schmidt, Siding Spring (1983 Almanac)                         UKST
 640  CONTINUE
      NAME='UK 1.2 metre Schmidt, Siding Spring'
      W=EAST(149,04,12.8)
      P=SOUTH(31,16,27.8)
      H=1145D0
      GO TO 9999

*  Kiso Schmidt, Japan (1981 Almanac)                               KISO
 650  CONTINUE
      NAME='Kiso 1.05 metre Schmidt, Japan'
      W=EAST(137,37,42.2)
      P=NORTH(35,47,38.7)
      H=1130D0
      GO TO 9999

*  ESO Schmidt, La Silla (1981 Almanac)                          ESOSCHM
 660  CONTINUE
      NAME='ESO 1 metre Schmidt, La Silla'
      W=WEST(70,43,46.5)
      P=SOUTH(29,15,25.8)
      H=2347D0
      GO TO 9999

*  Australia Telescope Compact Array                                ATCA
*  (WGS84 coordinates of Station 35, Mark Calabretta)
 670  CONTINUE
      NAME='Australia Telescope Compact Array'
      W=EAST(149,33,00.500)
      P=SOUTH(30,18,46.385)
      H=236.9D0
      GO TO 9999

*  Australia Telescope Mopra Observatory                           MOPRA
*  (Peter te Lintel Hekkert)
 680  CONTINUE
      NAME='ATNF Mopra Observatory'
      W=EAST(149,05,58.732)
      P=SOUTH(31,16,04.451)
      H=850D0
      GO TO 9999

*  Subaru telescope, Mauna Kea                                     SUBARU
*  (IfA website, Richard Wainscoat)
 690  CONTINUE
      NAME='Subaru 8m telescope'
      W=WEST(155,28,33.67)
      P=NORTH(19,49,31.81)
      H=4163D0
      GO TO 9999

*  Canada-France-Hawaii Telescope, Mauna Kea                         CFHT
*  (IfA website, Richard Wainscoat)
 700  CONTINUE
      NAME='Canada-France-Hawaii 3.6m Telescope'
      W=WEST(155,28,07.95)
      P=NORTH(19,49,30.91)
      H=4204.1D0
      GO TO 9999

*  W.M.Keck Observatory, Telescope 2                                KECK2
*  (William Lupton)
 710  CONTINUE
      NAME='Keck 10m Telescope #2'
      W=WEST(155,28,27.24)
      P=NORTH(19,49,35.62)
      H=4159.6D0
      GO TO 9999

*  Gemini North, Mauna Kea                                        GEMININ
*  (IfA website, Richard Wainscoat)
 720  CONTINUE
      NAME='Gemini North 8-m telescope'
      W=WEST(155,28,08.57)
      P=NORTH(19,49,25.69)
      H=4213.4D0
      GO TO 9999

*  Five College Radio Astronomy Observatory                        FCRAO
*  (Tim Jenness)
 730  CONTINUE
      NAME='Five College Radio Astronomy Obs'
      W=WEST(72,20,42.0)
      P=NORTH(42,23,30.0)
      H=314D0
      GO TO 9999

*  NASA Infra Red Telescope Facility                                IRTF
*  (IfA website, Richard Wainscoat)
 740  CONTINUE
      NAME='NASA IR Telescope Facility, Mauna Kea'
      W=WEST(155,28,19.20)
      P=NORTH(19,49,34.39)
      H=4168.1D0
      GO TO 9999

*  Caltech Submillimeter Observatory                                 CSO
*  (IfA website, Richard Wainscoat; height estimated)
 750  CONTINUE
      NAME='Caltech Sub-mm Observatory, Mauna Kea'
      W=WEST(155,28,31.79)
      P=NORTH(19,49,20.78)
      H=4080D0
      GO TO 9999

* ESO VLT, UT1                                                       VLT1
* (ESO website, VLT Whitebook Chapter 2)
 760  CONTINUE
      NAME='ESO VLT, Paranal, Chile: UT1'
      W=WEST(70,24,11.642)
      P=SOUTH(24,37,33.117)
      H=2635.43
      GO TO 9999

* ESO VLT, UT2                                                       VLT2
* (ESO website, VLT Whitebook Chapter 2)
 770  CONTINUE
      NAME='ESO VLT, Paranal, Chile: UT2'
      W=WEST(70,24,10.855)
      P=SOUTH(24,37,31.465)
      H=2635.43
      GO TO 9999

* ESO VLT, UT3                                                       VLT3
* (ESO website, VLT Whitebook Chapter 2)
 780  CONTINUE
      NAME='ESO VLT, Paranal, Chile: UT3'
      W=WEST(70,24,09.896)
      P=SOUTH(24,37,30.300)
      H=2635.43
      GO TO 9999

* ESO VLT, UT4                                                       VLT4
* (ESO website, VLT Whitebook Chapter 2)
 790  CONTINUE
      NAME='ESO VLT, Paranal, Chile: UT4'
      W=WEST(70,24,08.000)
      P=SOUTH(24,37,31.000)
      H=2635.43
      GO TO 9999

*  Gemini South, Cerro Pachon                                     GEMINIS
*  (GPS readings by Patrick Wallace)
 800  CONTINUE
      NAME='Gemini South 8-m telescope'
      W=WEST(70,44,11.5)
      P=SOUTH(30,14,26.7)
      H=2738D0
      GO TO 9999

*  Cologne Observatory for Submillimeter Astronomy (KOSMA)        KOSMA3M
*  (Holger Jakob)
 810  CONTINUE
      NAME='KOSMA 3m telescope, Gornergrat'
      W=EAST(7,47,3.48)
      P=NORTH(45,58,59.772)
      H=3141D0
      GO TO 9999

*  Magellan 1, 6.5m telescope at Las Campanas, Chile            MAGELLAN1
*  (Skip Schaller)
 820  CONTINUE
      NAME='Magellan 1, 6.5m, Las Campanas'
      W=WEST(70,41,31.9)
      P=SOUTH(29,00,51.7)
      H=2408D0
      GO TO 9999

*  Magellan 2, 6.5m telescope at Las Campanas, Chile            MAGELLAN2
*  (Skip Schaller)
 830  CONTINUE
      NAME='Magellan 2, 6.5m, Las Campanas'
      W=WEST(70,41,33.5)
      P=SOUTH(29,00,50.3)
      H=2408D0
      GO TO 9999

*  Unrecognized station
 9000 CONTINUE
      NAME='?'

*  Exit
 9999 CONTINUE

      END

      subroutine porgn (x,y)
      common /sysplt/ mmajx  ,mmajy  ,mminx  ,mminy  ,mxlab  ,mylab  ,
     1                mflg   ,mtype  ,mxa    ,mya    ,mxb    ,myb    ,
     2                mx     ,my     ,mtypex ,mtypey ,xxa    ,yya    ,
     3                xxb    ,yyb    ,xxc    ,yyc    ,xxd    ,yyd    ,
     4                xfactr ,yfactr ,xadd   ,yadd   ,xx     ,yy     ,
     5                mfmtx(3)       ,mfmty(3)       ,mumx   ,mumy   ,
     6                msizx  ,msizy  ,mxdec  ,mydec  ,mxor   ,mop(19),
     7                mname(19)      ,mxold  ,myold  ,mxmax  ,mymax  ,
     8                mxfac  ,myfac  ,modef  ,mf2er  ,mshftx ,mshfty ,
     9                mmgrx  ,mmgry  ,mmnrx  ,mmnry  ,mfrend ,mfrlst ,
     +                mcrout ,mpair1 ,mpair2 ,msblen ,mflcnt ,mjxmin ,
     1                mjymin ,mjxmax ,mjymax ,mnxsto ,mnysto ,mxxsto ,
     2                mxysto ,mprint ,msybuf(360)    ,mncpw  ,minst  ,
     3                mbufa  ,mbuflu ,mfwa(12)       ,mlwa(12)       ,
     4                mipair ,mbprs(16)      ,mbufl  ,munit  ,mbswap ,
     5                small
c     ray bovet patch to avoid small integers being set to 0
      integer x,y,xx,yy
c
      xx = x
      yy = y
      call trans
      xadd = mx-1
      yadd = my-1
      return
      end

      DOUBLE PRECISION FUNCTION slEPCO (K0, K, E)
*+
*     - - - - -
*      E P C O
*     - - - - -
*
*  Convert an epoch into the appropriate form - 'B' or 'J'
*
*  Given:
*     K0    char    form of result:  'B'=Besselian, 'J'=Julian
*     K     char    form of given epoch:  'B' or 'J'
*     E     dp      epoch
*
*  Called:  slEPB, slEJ2D, slEPJ, slEB2D
*
*  Notes:
*
*     1) The result is always either equal to or very close to
*        the given epoch E.  The routine is required only in
*        applications where punctilious treatment of heterogeneous
*        mixtures of star positions is necessary.
*
*     2) K0 and K are not validated.  They are interpreted as follows:
*
*        o  If K0 and K are the same the result is E.
*        o  If K0 is 'B' or 'b' and K isn't, the conversion is J to B.
*        o  In all other cases, the conversion is B to J.
*
*        Note that K0 and K won't match if their cases differ.
*
*  P.T.Wallace   Starlink   5 September 1993
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      CHARACTER*(*) K0,K
      DOUBLE PRECISION E
      DOUBLE PRECISION slEPB,slEJ2D,slEPJ,slEB2D


      IF (K.EQ.K0) THEN
         slEPCO=E
      ELSE IF (K0.EQ.'B'.OR.K0.EQ.'b') THEN
         slEPCO=slEPB(slEJ2D(E))
      ELSE
         slEPCO=slEPJ(slEB2D(E))
      END IF

      END

C----------------------------------------------------------------------
        subroutine fttrec(string,status)

C       test the remaining characters in a header record to insure that
C       it contains only pri-ntable ASCII characters,
C       i.e., with ASCII codes greater than or equal to 32 (a blank)
C       Note: this will not detect the delete character (ASCII 127)
C       because of the difficulties in also supporting this check
C       on IBM mainframes, where the collating sequence is entirely
C       different.

C       string  c*72 keyword name
C       OUTPUT PARAMETERS:
C       status  i  output error status (0 = ok)

C       optimized in 7/93 to compare "ichar(string(i:i)) .lt. space"
C       rather than                       "(string(i:i)) .lt. ' ' "
C       This is much faster on SUNs and DECstations,
C       and decreases the time needed to write a keywor (ftprec) by 10%.
C       This change made no difference on a VAX

        integer space
C       The following line won't compile with the Lahey compiler on a PC
C        parameter(space = ichar(' '))
        character string*(*)
        integer status,i
        character pos*2

        if (status .gt. 0)return
        space=ichar(' ')

        do 20 i=1,72
            if (ichar(string(i:i)) .lt. space)then
C                 illegal character found
                  status=207
                  write(pos,1000)i
1000              format(i2)
        call ftpmsg('Character #'//pos//' in this keyword value or '//
     &  'comment string is illegal:')
        call ftpmsg(string)
                  return
            end if
20      continue
        end

c function ppoiss.f
c
c source
c   Bevington, page 39.
c
c purpose
c   evaluate poisson probability function
c
c usage
c   result = ppoiss (nobs, averag)
c
c description of parameters
c   nobs   - number of items observed
c   averag - mean of distribution
c
c subroutines and function subprograms required
c   factor (n)
c      calculates n factorial for integers
c
	function ppoiss (nobs,averag)
1	ppoiss=((averag**nobs)/factor(nobs))*exp(-averag)
	return
	end

      SUBROUTINE slDPVC (XI, ETA, V, V01, V02, N)
*+
*     - - - - - - -
*      D P V C
*     - - - - - - -
*
*  Given the tangent-plane coordinates of a star and its direction
*  cosines, determine the direction cosines of the tangent-point.
*
*  (double precision)
*
*  Given:
*     XI,ETA    d       tangent plane coordinates of star
*     V         d(3)    direction cosines of star
*
*  Returned:
*     V01       d(3)    direction cosines of tangent point, solution 1
*     V02       d(3)    direction cosines of tangent point, solution 2
*     N         i       number of solutions:
*                         0 = no solutions returned (note 2)
*                         1 = only the first solution is useful (note 3)
*                         2 = both solutions are useful (note 3)
*
*  Notes:
*
*  1  The vector V must be of unit length or the result will be wrong.
*
*  2  Cases where there is no solution can only arise near the poles.
*     For example, it is clearly impossible for a star at the pole
*     itself to have a non-zero XI value, and hence it is meaningless
*     to ask where the tangent point would have to be.
*
*  3  Also near the poles, cases can arise where there are two useful
*     solutions.  The argument N indicates whether the second of the
*     two solutions returned is useful.  N=1 indicates only one useful
*     solution, the usual case;  under these circumstances, the second
*     solution can be regarded as valid if the vector V02 is interpreted
*     as the "over-the-pole" case.
*
*  4  This routine is the Cartesian equivalent of the routine slDPSC.
*
*  P.T.Wallace   Starlink   5 June 1995
*
*  Copyright (C) 1995 Rutherford Appleton Laboratory
*
*  License:
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program (see SLA_CONDITIONS); if not, write to the
*    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
*    Boston, MA  02110-1301  USA
*
*  Copyright (C) 1995 Association of Universities for Research in Astronomy Inc.
*-

      IMPLICIT NONE

      DOUBLE PRECISION XI,ETA,V(3),V01(3),V02(3)
      INTEGER N

      DOUBLE PRECISION X,Y,Z,RXY2,XI2,ETA2P1,SDF,R2,R,C


      X=V(1)
      Y=V(2)
      Z=V(3)
      RXY2=X*X+Y*Y
      XI2=XI*XI
      ETA2P1=ETA*ETA+1D0
      SDF=Z*SQRT(XI2+ETA2P1)
      R2=RXY2*ETA2P1-Z*Z*XI2
      IF (R2.GT.0D0) THEN
         R=SQRT(R2)
         C=(SDF*ETA+R)/(ETA2P1*SQRT(RXY2*(R2+XI2)))
         V01(1)=C*(X*R+Y*XI)
         V01(2)=C*(Y*R-X*XI)
         V01(3)=(SDF-ETA*R)/ETA2P1
         R=-R
         C=(SDF*ETA+R)/(ETA2P1*SQRT(RXY2*(R2+XI2)))
         V02(1)=C*(X*R+Y*XI)
         V02(2)=C*(Y*R-X*XI)
         V02(3)=(SDF-ETA*R)/ETA2P1
         IF (ABS(SDF).LT.1D0) THEN
            N=1
         ELSE
            N=2
         END IF
      ELSE
         N=0
      END IF

      END

      subroutine rmtabl (st)
      integer st
      integer mem( 60000)
      common/cdsmem/mem
      integer i
      integer walker, bucket, node
      bucket = st
      do 23000 i = 1, 43
      bucket = bucket + 1
      walker = mem (bucket)
23002 if (.not.(walker .ne. 0))goto 23003
      node = walker
      walker = mem (node + 0)
      call dsfree (node)
      goto 23002
23003 continue
23000 continue
23001 continue
      call dsfree (st)
      return
      end

include	defs

# itoc - convert integer  int  to char string in  str

   integer function itoc (int, str, size)
   integer int, size
   character str (ARB)

   integer mod
   integer d, i, intval, j, k

   # string digits "0123456789"
   character digits (11)
   data digits (1) /DIG0/,
      digits (2) /DIG1/,
      digits (3) /DIG2/,
      digits (4) /DIG3/,
      digits (5) /DIG4/,
      digits (6) /DIG5/,
      digits (7) /DIG6/,
      digits (8) /DIG7/,
      digits (9) /DIG8/,
      digits (10) /DIG9/,
      digits (11) /EOS/

   intval = iabs (int)
   str (1) = EOS
   i = 1
   repeat {			     # generate digits
      i = i + 1
      d = mod (intval, 10)
      str (i) = digits (d+1)
      intval = intval / 10
      } until (intval == 0 | i >= size)

   if (int < 0 & i < size) {	     # then sign
      i = i + 1
      str (i) = MINUS
      }
   itoc = i - 1

   for (j = 1; j < i; j = j + 1) {   # then reverse
      k = str (i)
      str (i) = str (j)
      str (j) = k
      i = i - 1
      }

   return
   end

#-h-  docode			  522  local   12/01/80  15:53:49
# docode - generate code for beginning of do
   include  defs

   subroutine docode (lab)
   integer lab

   integer labgen

   include COMMON_BLOCKS

   character gnbtok
   character lexstr (MAXTOK)

   string sdo "do"

   xfer = NO
   call outtab
   call outstr (sdo)
   call outch (BLANK)
   lab = labgen (2)
   if (gnbtok (lexstr, MAXTOK) == DIGIT) # check for fortran DO
      call outstr (lexstr)
   else {
      call pbstr (lexstr)
      call outnum (lab)
      }
   call outch (BLANK)
   call eatup
   call outdwe
   call indent (1)
   return
   end

C----------------------------------------------------------------------
        subroutine ftphbn(ounit,nrows,nfield,ttype,tform,tunit,
     &                    extnam,pcount,status)

C       write required standard header keywords for a binary table extension 
C
C       ounit   i  fortran output unit number
C       nrows   i  number of rows in the table
C       nfield  i  number of fields in the table
C       ttype   c  name of each field (array) (optional)
C       tform   c  format of each field (array)
C       tunit   c  units of each field (array) (optional)
C       extnam  c  name of table extension (optional)
C       pcount  i  size of special data area following the table (usually = 0)
C       OUTPUT PARAMETERS:
C       status  i  output error status (0=OK)
C
C       written by Wm Pence, HEASARC/GSFC, June 1991

        integer ounit,nrows,nfield,pcount,status
        integer i,lenrow,dtype,rcount,xbcol,length,width
        character*(*) ttype(*),tform(*),tunit(*),extnam
        character comm*48,tfm*40

        comm='binary table extension'
        call ftpkys(ounit,'XTENSION','BINTABLE',comm,status)

        comm='8-bit bytes'
        call ftpkyj(ounit,'BITPIX',8,comm,status)

        comm='2-dimensional binary table'
        call ftpkyj(ounit,'NAXIS',2,comm,status)

        if (status .gt. 0)return

C       calculate the total width of each row, in bytes
        lenrow=0
        do 10 i=1,nfield
C               get the numerical datatype and repeat count of the field
                call ftbnfm(tform(i),dtype,rcount,width,status)
                if (dtype .eq. 1)then
C                       treat Bit datatype as if it were a Byte datatype
                        dtype=11
                        rcount=(rcount+7)/8
                end if
C               get the width of the field
                call ftgtbc(1,dtype,rcount,xbcol,length,status)
                lenrow=lenrow+length
10      continue

        comm='width of table in bytes'
        call ftpkyj(ounit,'NAXIS1',lenrow,comm,status)

        if (status .gt. 0)return

        if (nrows .ge. 0)then
                comm='number of rows in table'
                call ftpkyj(ounit,'NAXIS2',nrows,comm,status)
        else
                status=218
        end if

        if (status .gt. 0)return

        if (pcount .ge. 0)then
                comm='size of special data area'
                call ftpkyj(ounit,'PCOUNT',pcount,comm,status)
        else
                status=214
        end if

        comm='one data group (required keyword)'
        call ftpkyj(ounit,'GCOUNT',1,comm,status)

        comm='number of fields in each row'
        call ftpkyj(ounit,'TFIELDS',nfield,comm,status)

        if (status .gt. 0)return

        do 20 i=1,nfield
            if (ttype(i) .ne. ' ' .and. ichar(ttype(i)(1:1)).ne.0)then
                comm='label for field '
                write(comm(17:19),1000)i
1000            format(i3)      
                call ftpkns(ounit,'TTYPE',i,1,ttype(i),comm,status)
            end if

            comm='data format of the field'
C           make sure format characters are in upper case:
            tfm=tform(i)
            call ftupch(tfm)

C           Add datatype to the comment string:
            call ftbnfm(tfm,dtype,rcount,width,status)
            if (dtype .eq. 21)then
                comm(25:)=': 2-byte INTEGER'
            else if(dtype .eq. 41)then
                comm(25:)=': 4-byte INTEGER'
            else if(dtype .eq. 42)then
                comm(25:)=': 4-byte REAL'
            else if(dtype .eq. 82)then
                comm(25:)=': 8-byte DOUBLE'
            else if(dtype .eq. 16)then
                comm(25:)=': ASCII Character'
            else if(dtype .eq. 14)then
                comm(25:)=': 1-byte LOGICAL'
            else if(dtype .eq. 11)then
                comm(25:)=': BYTE'
            else if(dtype .eq. 1)then
                comm(25:)=': BIT'
            else if(dtype .eq. 83)then
                comm(25:)=': COMPLEX'
            else if(dtype .eq. 163)then
                comm(25:)=': DOUBLE COMPLEX'
            end if

            call ftpkns(ounit,'TFORM',i,1,tfm,comm,status)

            if (tunit(i) .ne. ' ' .and. ichar(tunit(i)(1:1)).ne.0)then
                comm='physical unit of field'
                call ftpkns(ounit,'TUNIT',i,1,tunit(i),comm,status)
            end if
            if (status .gt. 0)return
20      continue        

        if (extnam .ne. ' ' .and. ichar(extnam(1:1)) .ne. 0)then
                comm='name of this binary table extension'
                call ftpkys(ounit,'EXTNAME',extnam,comm,status)
        end if
        end

include	defs

# getwrd - get non-blank word from in (i) into out, increment i

   integer function getwrd (in, i, out)
   character in (ARB), out (ARB)
   integer i

   integer j

   while (in (i) == BLANK | in (i) == TAB)
      i = i + 1

   j = 1
   while (in (i) != EOS & in (i) != BLANK
    & in (i) != TAB & in (i) != NEWLINE) {
      out (j) = in (i)
      i = i + 1
      j = j + 1
      }
   out (j) = EOS

   getwrd = j - 1
   return
   end

      SUBROUTINE CONREO (MAJLNS)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C THIS ROUTINE PUTS THE MAJOR (LABELED) LEVELS IN THE BEGINNING OF CL
C AND THE MINOR (UNLABELED) LEVELS IN END OF CL.  THE NUMBER OF MAJOR
C LEVELS IS RETURNED IN MAJLNS.  PV IS USED AS A WORK SPACE.  MINGAP IS
C THE NUMBER OF MINOR GAPS (ONE MORE THAN THE NUMBER OF MINOR LEVELS
C BETWEEN MAJOR LEVELS).
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10    NDASH, IDASH, EDASH
C
        SAVE
C
      NL = NCL
      IF (NL.LE.4 .OR. MINGAP.LE.1) GO TO   160
      NML = MINGAP-1
      IF (NL.LE.10) NML = 1
C
C CHECK FOR BREAK POINT IN THE LIST OF CONTOURS FOR A MAJOR LINE
C
      NMLP1 = NML+1
          DO    10 I=1,NL
          ISAVE = I
          IF (CL(I).EQ.BPSIZ) GO TO    40
   10     CONTINUE
C
C  NO BREAKPOINT FOUND SO TRY FOR A NICE NUMBER
C
      L = NL/2
      L = ALOG10( ABS( CL(L) ) )+1.
      Q = 10.**L
          DO    30 J=1,3
          Q = Q/10.
              DO    20 I=1,NL
              ISAVE = I
              IF (AMOD( ABS( CL(I) + 1.E-9*CL(I) )/Q,FLOAT(NMLP1) ).LE.
     1            .0001) GO TO    40
   20         CONTINUE
   30     CONTINUE
      ISAVE = NL/2
C
C PUT MAJOR LEVELS IN PV
C
   40 ISTART = MOD(ISAVE,NMLP1)
      IF (ISTART.EQ.0) ISTART = NMLP1
      NMAJL = 0
          DO    50 I=ISTART,NL,NMLP1
          NMAJL = NMAJL+1
          PV(NMAJL) = CL(I)
   50     CONTINUE
      MAJLNS = NMAJL
      L = NMAJL
C
C PUT MINOR LEVELS IN PV
C
      IC = NML/2 + 1
      L = MAJLNS+1
          DO   100 LOOP=1,NML
          IC1 = IC
              DO    90 IWCH=1,2
              IF (LOOP.EQ.1) GO TO    60
              IC1 = IC+(LOOP-1)
              IF (IWCH.EQ.2) IC1 = IC-(LOOP-1)
              IF (IC1.GE.NMLP1) GO TO    90
              IF (IC1.LE.0) GO TO    90
   60             DO    70 K=ISTART,NL,NMLP1
                  IND = K+IC1
                  IF (IND.GT.NL) GO TO    80
                  PV(L) = CL(IND)
                  L = L+1
   70             CONTINUE
   80         IF (LOOP.EQ.1) GO TO   100
   90         CONTINUE
  100     CONTINUE
C
C  IF MAJOR LINES DID NOT START ON THE FIRST ENTRY PICK UP THE MISSING
C  LEVELS
C
      IF (ISTART.EQ.1) GO TO   140
          DO   130 LOOP=1,NML
          IC1 = IC
              DO   120 IWCH=1,2
              IF (LOOP.EQ.1) GO TO   110
              IC1 = IC+(LOOP-1)
              IF (IWCH.EQ.2) IC1 = IC-(LOOP-1)
  110         IF (IC1.GE.ISTART) GO TO   120
              IF (IC1.LE.0) GO TO   120
              PV(L) = CL(IC1)
              L = L+1
              IF (LOOP.EQ.1) GO TO   130
  120         CONTINUE
  130     CONTINUE
C
C PUT REORDERED ARRAY BACK IN ORIGINAL PLACE
C
  140     DO   150 I=1,NL
          CL(I) = PV(I)
  150     CONTINUE
      RETURN
  160 MAJLNS = NL
      RETURN
      END

      subroutine pwrt (x,y,chars,nchar,jsiz,jor)
      dimension       chars(1)
      dimension       jfix(4)
      data jfix(1),jfix(2),jfix(3),jfix(4)/128,192,256,384/
      isiz = max0(0,min0(3,jsiz))
      call fl2int (x,y,nx,ny)
      call getsi (ixsave,iysave)
      nx = max0(0,ishift(nx-(1-jor)*jfix(isiz+1),ixsave-15))
      ny = max0(0,ishift(ny-jor*jfix(isiz+1),iysave-15))
      call pwrit (nx,ny,chars,nchar,isiz,jor*90,-1)
      return
      end

      SUBROUTINE CONOUT (IVER)
C                                                                               
C +-----------------------------------------------------------------+           
C |                                                                 |           
C |                Copyright (C) 1986 by UCAR                       |           
C |        University Corporation for Atmospheric Research          |           
C |                    All Rights Reserved                          |           
C |                                                                 |           
C |                 NCARGRAPHICS  Version 1.00                      |           
C |                                                                 |           
C +-----------------------------------------------------------------+           
C                                                                               
C                                                                               
C
C + NOAO - This routine is a no-op in IRAF.
C - NOAO
C
C  LIST OUT ALL THE CONRAN OPTION VALUES ON THE LINE PRINTER
C
C  THE VALUE OF IVER DETERMINES WHICH ENTRY POINT CALLED THIS ROUTINE
C
C 1. CONRAQ
C 2. CONRAN
C 3. CONRAS
C
C
C
      COMMON /CONRA1/ CL(30)     ,NCL        ,OLDZ       ,PV(210)    ,
     1                FINC       ,HI         ,FLO
      COMMON /CONRA2/ REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                ISCALE     ,LOOK       ,PLDVLS     ,GRD        ,
     2                CINC       ,CHILO      ,CON        ,LABON      ,
     3                PMIMX      ,SCALE      ,FRADV      ,EXTRI      ,
     4                BPSIZ      ,LISTOP
      COMMON /CONRA3/ IREC
      COMMON /CONRA4/ NCP        ,NCPSZ
      COMMON /CONRA5/ NIT        ,ITIPV
      COMMON /CONRA6/ XST        ,YST        ,XED        ,YED        ,
     1                STPSZ      ,IGRAD      ,IG         ,XRG        ,
     2                YRG        ,BORD       ,PXST       ,PYST       ,
     3                PXED       ,PYED       ,ITICK
      COMMON /CONRA7/ TITLE      ,ICNT   ,ITLSIZ
      COMMON /CONRA8/ IHIGH      ,INMAJ      ,INLAB      ,INDAT      ,
     1              LEN      ,IFMT       ,LEND       ,
     2                IFMTD      ,ISIZEP     ,INMIN
      COMMON /CONRA9/ ICOORD(500),NP         ,MXXY       ,TR         ,
     1                BR         ,TL         ,BL         ,CONV       ,
     2                XN         ,YN         ,ITLL       ,IBLL       ,
     3                ITRL       ,IBRL       ,XC         ,YC         ,
     4                ITLOC(210) ,JX         ,JY         ,ILOC       ,
     5                ISHFCT     ,XO         ,YO         ,IOC        ,NC
      COMMON /CONR10/ NT         ,NL         ,NTNL       ,JWIPT      ,
     1                JWIWL      ,JWIWP      ,JWIPL      ,IPR        ,
     2                ITPV
      COMMON /CONR11/ NREP       ,NCRT       ,ISIZEL     ,
     1                MINGAP     ,ISIZEM         ,
     2                TENS
      COMMON /CONR12/ IXMAX      ,IYMAX      ,XMAX       ,YMAX
      LOGICAL         REPEAT     ,EXTRAP     ,PER        ,MESS       ,
     1                LOOK       ,PLDVLS     ,GRD        ,LABON      ,
     2                PMIMX      ,FRADV      ,EXTRI      ,CINC       ,
     3                TITLE      ,LISTOP     ,CHILO      ,CON
      COMMON /CONR13/XVS(50),YVS(50),ICOUNT,SPVAL,SHIELD,
     1               SLDPLT
      LOGICAL SHIELD,SLDPLT
      COMMON /CONR14/LINEAR
      LOGICAL LINEAR
      COMMON /CONR15/ ISTRNG
        CHARACTER*64 ISTRNG
        COMMON /CONR16/ FORM
        CHARACTER*10 FORM
        COMMON /CONR17/ NDASH, IDASH, EDASH
        CHARACTER*10 NDASH, IDASH, EDASH
C
      SAVE
C
C  GET THE STANDARD OUTPUT UNIT TO WRITE THE OPTION VALUE LIST
C
      IUNIT = I1MACH(2)
C
C  PRINT OUT HEADER AND ALL OPTIONS WHICH APPLY TO CALLING VERSION
C
C     GO TO ( 100, 110, 120),IVER
C 100 WRITE (IUNIT,1001)
C     GO TO  130
C 110 WRITE (IUNIT,1002)
C     GO TO  130
C 120 WRITE (IUNIT,1003)
C 130 WRITE (IUNIT,1004)
C
C  PERIMETER
C
C     WRITE (IUNIT,1005)
C     IF (PER) GO TO  140
C     WRITE (IUNIT,1006)
C     GO TO  150
C 140 WRITE (IUNIT,1007)
C
C  GRID
C
C 150 WRITE (IUNIT,1008)
C     IF (GRD) GO TO  160
C     WRITE (IUNIT,1009)
C     GO TO  170
C 160 WRITE (IUNIT,1010)
C
C  SCALING OF DATA ON FRAME
C
C 170 WRITE (IUNIT,1011)
C     GO TO ( 180, 190, 200),ISCALE+1
C 180 WRITE (IUNIT,1012)
C     GO TO  210
C 190 WRITE (IUNIT,1013)
C     GO TO  210
C 200 WRITE (IUNIT,1014)
C
C  SAME DATA ANOTHER PLOT
C
C 210 WRITE (IUNIT,1015)
C     IF (REPEAT) GO TO  220
C     WRITE (IUNIT,1016)
C     GO TO  230
C 220 WRITE (IUNIT,1017)
C
C  SHIELDING
C
C 230 WRITE(IUNIT,2000)
C     IF (SHIELD) GO TO 231
C     WRITE(IUNIT,2001)
C     GO TO 232
C 231 WRITE(IUNIT,2002)
C
C  INTERPOLATION
C
C 232 WRITE(IUNIT,2003)
C     IF (LINEAR) GO TO 233
C     WRITE(IUNIT,2004)
C     GO TO 234
C 233 WRITE(IUNIT,2005)
C
C  PLOT THE SHIELD
C
C 234 WRITE(IUNIT,2006)
C     IF (SLDPLT) GO TO 235
C     WRITE(IUNIT,2007)
C     GO TO 236
C 235 WRITE(IUNIT,2008)
C
C  EXTRAPOLATION
C
C 236 WRITE (IUNIT,1018)
C     IF (EXTRAP) GO TO  240
C     WRITE (IUNIT,1019)
C     GO TO  250
C 240 WRITE (IUNIT,1020)
C
C  STEP SIZE OR RESOLUTION OF THE GRID
C
C 250 WRITE (IUNIT,1021) IGRAD
C
C  MESSAGE AT BOTTOM OF PLOT
C
C     WRITE (IUNIT,1022)
C     IF (MESS) GO TO  260
C     WRITE (IUNIT,1023)
C     GO TO  270
C 260 WRITE (IUNIT,1024)
C
C  TITLE AT TOP OF PLOT
C
C 270 WRITE (IUNIT,1025)
C     IF (TITLE) GO TO  280
C     WRITE (IUNIT,1026)
C     GO TO  290
C 280 WRITE (IUNIT,1027)
C
C  SIZE OF TITLE
C
C 290 WRITE (IUNIT,1028) ITLSIZ
C
C  PRINT TITLE
C
C     IF (ICNT.EQ.0 .OR. .NOT.TITLE) GO TO  310
C     ICC = 100
C     IF (ICC .GT. ICNT) ICC = ICNT
C     WRITE (IUNIT,1029) ISTRNG
C
C  DATA POINTS USED FOR PARTIAL DERIVATIVE ESTIMATION
C
C 310 WRITE (IUNIT,1030) NCP
C
C  LOOK AT TRIANGLES SWITCH
C
C     WRITE (IUNIT,1031)
C     IF (LOOK) GO TO  320
C     WRITE (IUNIT,1032)
C     GO TO  330
C 320 WRITE (IUNIT,1033)
C
C  ADVANCE FRAME BEFORE PLOTTING TRIANGULATION
C
C 330 WRITE (IUNIT,1034)
C     IF (FRADV) GO TO  340
C     WRITE (IUNIT,1035)
C     GO TO  350
C 340 WRITE (IUNIT,1036)
C
C  TRIANGLES ONLY PLOT
C
C 350 WRITE (IUNIT,1037)
C     IF (EXTRI) GO TO  360
C     WRITE (IUNIT,1038)
C     GO TO  370
C 360 WRITE (IUNIT,1039)
C
C  PLOT THE INPUT DATA VALUES
C
C 370 WRITE (IUNIT,1040)
C     IF (PLDVLS) GO TO  380
C     WRITE (IUNIT,1041)
C     GO TO  390
C 380 WRITE (IUNIT,1042)
C
C  FORMAT OF THE PLOTTED INPUT DATA
C
C 390 WRITE (IUNIT,1043)
C     IF (LEN .NE. 0) GO TO  400
C     WRITE (IUNIT,1044)
C     GO TO  420
C 400 WRITE (IUNIT,1045) FORM
C
C  SIZE OF THE PLOTTED DATA VALUES
C
C 420 WRITE (IUNIT,1046) ISIZEP
C
C  INTENSITY SETTINGS
C
C     WRITE (IUNIT,1047)
C     WRITE (IUNIT,1048) INMAJ,INMIN,INLAB,INDAT
C
C  DISTLAY CONTOUR SETTING
C
C     WRITE (IUNIT,1049)
C     IF (CON) GO TO  430
C     WRITE (IUNIT,1050)
C     GO TO  440
C 430 WRITE (IUNIT,1051) NCL,(CL(I),I=1,NCL)
C
C  CONTOUR INCREMENT
C
C 440 WRITE (IUNIT,1052)
C     IF (CINC) GO TO  450
C     WRITE (IUNIT,1053)
C     GO TO  460
C 450 WRITE (IUNIT,1054) FINC
C
C  CONTOUR HIGH AND LOW VALUES
C
C 460 WRITE (IUNIT,1055)
C     IF (CHILO) GO TO  470
C     WRITE (IUNIT,1056)
C     GO TO  480
C 470 WRITE (IUNIT,1057) HI,FLO
C
C  CALL CONOT2 IF NOT QUICK VERSION
C
C 480 IF (IVER .NE. 1) CALL CONOT2 (IVER,IUNIT)
C
C  THE ROUTINE CONOT2 WAS GENERATED TO ELIMINATE COMPILER ERRORS
C  RESULTING FROM TOO MANY FORMAT STATEMENTS IN ONE SUBROUTINE
C
C     RETURN
C
C
C1001 FORMAT (1X,'CONRAQ')
C1002 FORMAT (1X,'CONRAN')
C1003 FORMAT (1X,'CONRAS')
C1004 FORMAT ('+',6X,'-OPTION VALUE SETTINGS',/
C    1        ,7X,'ALL NON-PWRIT VALUES APPLY TO THE UNSCALED DATA')
C1005 FORMAT (5X,'PERIMETER, PER=')
C1006 FORMAT ('+',19X,'OFF')
C1007 FORMAT ('+',19X,'ON')
C1008 FORMAT (5X,'GRID, GRD=')
C1009 FORMAT ('+',14X,'OFF')
C1010 FORMAT ('+',14X,'ON')
C1011 FORMAT (5X,'SCALING OF PLOT ON FRAME, SCA=')
C1012 FORMAT ('+',34X,'ON')
C1013 FORMAT ('+',34X,'OFF')
C1014 FORMAT ('+',34X,'PRI')
C1015 FORMAT (5X,'SAME DATA FOR ANOTHER PLOT, REP=')
C1016 FORMAT ('+',36X,'OFF')
C1017 FORMAT ('+',36X,'ON')
C1018 FORMAT (5X,'EXTRAPOLATION, EXT=')
C1019 FORMAT ('+',23X,'OFF')
C1020 FORMAT ('+',23X,'ON')
C1021 FORMAT (5X,'RESOLUTION, SSZ=',I4)
C1022 FORMAT (5X,'MESSAGE, MES=')
C1023 FORMAT ('+',17X,'OFF')
C1024 FORMAT ('+',17X,'ON')
C1025 FORMAT (5X,'TITLE, TLE=')
C1026 FORMAT ('+',15X,'OFF')
C1027 FORMAT ('+',15X,'ON')
C1028 FORMAT (5X,'TITLE SIZE IN PWRIT UNITS, STL=',I4)
C1029 FORMAT (5X,'TITLE=',A64)
C1030 FORMAT (5X,'DATA POINTS USED FOR PARTIAL DERIVATIVE',
C    1' ESTIMATION,  NCP=',I4)
C1031 FORMAT (5X,'LOOK AT TRIANGLES, TRI=')
C1032 FORMAT ('+',27X,'OFF')
C1033 FORMAT ('+',27X,'ON')
C1034 FORMAT (5X,'ADVANCE FRAME BEFORE PLOTTING TRIANGULATION,',
C    1' TFR=')
C1035 FORMAT ('+',53X,'OFF')
C1036 FORMAT ('+',53X,'ON')
C1037 FORMAT (5X,'TRIANGULATION ONLY PLOT, TOP=')
C1038 FORMAT ('+',33X,'OFF')
C1039 FORMAT ('+',33X,'ON')
C1040 FORMAT (5X,'PLOT THE INPUT DATA VALUES, PDV=')
C1041 FORMAT ('+',36X,'OFF')
C1042 FORMAT ('+',36X,'ON')
C1043 FORMAT (5X,'FORMAT OF THE PLOTTED INPUT DATA, FMT=')
C1044 FORMAT ('+',42X,'(G10.3)')
C1045 FORMAT ('+',42X,A10)
C1046 FORMAT (5X,'SIZE OF THE PLOTTED DATA VALUES IN PWRIT',
C    1' UNITS, SPD=',I4)
C1047 FORMAT (5X,'COLOR (INTENSITY) INDICES FOLLOW.',
C    1' FOR CONRAQ MAJOR CONTOURS ARE ONLY USED')
C1048 FORMAT (10X,'MAJOR CONTOUR LINES, MAJ=',I4,/
C    1        ,10X,'MINOR CONTOUR LINES, MIN=',I4,/
C    2        ,10X,'TITLE AND MESSAGE, LAB=',I4,/
C    3        ,10X,'PLOTTED DATA VALUES, DAT=',I4)
C1049 FORMAT (5X,'CONTOUR LEVELS,  CON=')
C1050 FORMAT ('+',25X,'OFF')
C1051 FORMAT ('+',25X,'ON, NCL=',I4,' ARRAY='/(10(2X,F10.3)))
C1052 FORMAT (5X,'CONTOUR INCREMENT, CIL=')
C1053 FORMAT ('+',27X,'OFF')
C 1054 FORMAT ('+',27X,'ON, INCREMENT=',G10.3)
C 1055 FORMAT (5X,'CONTOUR HIGH AND LOW VALUES, CHL=')
C 1056 FORMAT ('+',37X,'OFF')
C 1057 FORMAT ('+',37X,'ON, HI=',G10.3,' FLO=',G10.3)
C 2000 FORMAT (5X,'SHIELDING, SLD=')
C 2001 FORMAT ('+',19X,'OFF')
C 2002 FORMAT ('+',19X,'ON')
C 2003 FORMAT (5X,'INTERPOLATION, ITP=')
C 2004 FORMAT ('+',23X,'C1 SURFACE')
C 2005 FORMAT ('+',23X,'LINEAR')
C 2006 FORMAT (5X,'PLOT THE SHIELD, SPT=')
C 2007 FORMAT ('+',25X,'OFF')
C 2008 FORMAT ('+',25X,'ON')
C
      END

#-h-  doif			  458  local   12/01/80  15:53:49
# doif - select one of two (macro) arguments
   include  defs

   subroutine doif (argstk, i, j)
   integer argstk (ARGSIZE), i, j

   include COMMON_BLOCKS

   integer a2, a3, a4, a5
   integer equal

   if (j - i < 5)
      return
   a2 = argstk (i + 2)
   a3 = argstk (i + 3)
   a4 = argstk (i + 4)
   a5 = argstk (i + 5)
   if (equal (evalst (a2), evalst (a3)) == YES)   # subarrays
      call pbstr (evalst (a4))
   else
      call pbstr (evalst (a5))

   return
   end

#!/bin/csh -f
#
# IRAF definitions for the UNIX/csh user.  The additional variables iraf$ and
# home$ should be defined in the user's .login file.


setenv MACH 	 `${iraf}unix/hlib/irafarch.sh`
setenv IRAFARCH  `${iraf}unix/hlib/irafarch.sh`



setenv	hostid	unix
setenv	host	${iraf}unix/
setenv	hlib	${iraf}unix/hlib/
setenv	hbin	${iraf}unix/bin.$MACH/
setenv	tmp	/tmp/

# Default to GCC for compilation.
setenv	CC	gcc
setenv	F77	${hlib}f77.sh
setenv	F2C	${hbin}f2c.e
setenv	RANLIB	ranlib
if ( ! ${?CPPFLAGS} ) then
    set CPPFLAGS
endif
if (! ${?CFLAGS} ) then
    set CFLAGS
endif
if (! ${?LDFLAGS} ) then
    set LDFLAGS
endif

setenv XC_CFLAGS "${CPPFLAGS} ${CFLAGS} -I${iraf}include"
setenv HSI_CF "${XC_CFLAGS}"
setenv HSI_XF "-x -Inolibc -/Wall -/O2"
setenv HSI_FF "-g -DBLD_KERNEL -O2"
setenv HSI_LF "${LDFLAGS}"
setenv HSI_F77LIBS ""
setenv HSI_LFLAGS ""
setenv HSI_OSLIBS ""

# The following determines whether or not the VOS is used for filename mapping.
if (-f ${iraf}lib/libsys.a) then
	setenv	HSI_LIBS "${hlib}libboot.a ${iraf}lib/libsys.a ${iraf}lib/libvops.a ${hlib}libos.a ${hbin}libf2c.a -lm"
else
	setenv	HSI_CF "$HSI_CF -DNOVOS"
	setenv	HSI_LIBS "${hlib}libboot.a ${hlib}libos.a -lm"
endif

setenv HSI_LIBS "$HSI_LIBS $HSI_OSLIBS"

alias	mkiraf	${hlib}mkiraf.sh
alias	mkmlist	${hlib}mkmlist.sh

alias	edsym	${hbin}edsym.e
alias	generic	${hbin}generic.e
alias	mkpkg	${hbin}mkpkg.e
alias	rmbin	${hbin}rmbin.e
alias	rmfiles	${hbin}rmfiles.e
alias	rtar	${hbin}rtar.e
alias	wtar	${hbin}wtar.e
alias	xc	${hbin}xc.e
alias	xyacc	${hbin}xyacc.e

#!/bin/sh
# Bootstrap the generic preprocessor.  The -lln library is not used to avoid
# the enternal dependency.  The filename lex.yy.c is changed to lexyy.c
# for portability reasons.

# Exit on error
set -e

flex -o lexyy.c tok.l

$CC -c $HSI_CF	generic.c yywrap.c lexyy.c
$CC $HSI_LF	generic.o lexyy.o yywrap.o $HSI_LIBS -o generic.e
mv -f		generic.e ../../hlib
rm		*.o

#!/bin/sh
#
# IRAF definitions for the UNIX/sh user.  The additional variables iraf$ and
# home$ should be defined in the user's .login file.


export MACH=$("$iraf/unix/hlib/irafarch.sh")
export IRAFARCH=$("$iraf/unix/hlib/irafarch.sh")
            


export	hostid=unix
export	host=${iraf}unix/
export	hlib=${iraf}unix/hlib/
export	hbin=${iraf}unix/bin.$MACH/
export	tmp=/tmp/

# Default to GCC for compilation.
export	CC=gcc
export	F77=$hlib/f77.sh
export	F2C=$hbin/f2c.e
export	RANLIB=ranlib

export XC_CFLAGS="${CPPFLAGS} ${CFLAGS} -I${iraf}include"
export HSI_CF="${XC_CFLAGS}"
export HSI_XF="-x -Inolibc -/Wall -/O2"
export HSI_FF="-g -DBLD_KERNEL -O2"
export HSI_LF="${LDFLAGS}"
export HSI_F77LIBS=""
export HSI_LFLAGS=""
export HSI_OSLIBS=""

if [ "$MACH" = "macosx" ] ; then
    export MACOSX_DEPLOYMENT_TARGET=10.5
fi

# The following determines whether or not the VOS is used for filename mapping.
if [ -f "${iraf}lib/libsys.a" ]; then
	export	HSI_LIBS="${hlib}libboot.a ${iraf}lib/libsys.a ${iraf}lib/libvops.a ${hlib}libos.a ${hbin}libf2c.a -lm"
else
	export	HSI_CF="$HSI_CF -DNOVOS"
	export	HSI_LIBS="${hlib}libboot.a ${hlib}libos.a -lm"
fi

export HSI_LIBS="$HSI_LIBS $HSI_OSLIBS"

alias	mkiraf="${hlib}mkiraf.sh"
alias	mkmlist="${hlib}mkmlist.sh"

alias	edsym="${hbin}edsym.e"
alias	generic="${hbin}generic.e"
alias	mkpkg="${hbin}mkpkg.e"
alias	rmbin="${hbin}rmbin.e"
alias	rmfiles="${hbin}rmfiles.e"
alias	rtar="${hbin}rtar.e"
alias	wtar="${hbin}wtar.e"
alias	xc="${hbin}xc.e"
alias	xyacc="${hbin}xyacc.e"

#!/bin/sh 
#
#  IRAFARCH -- Determine or set the current platform architecture parameters.
#
#  Usage:       irafarch
#		irafarch -set [<arch>] [opts]
#               irafarch [ -hsi | -nbits | -endian ]
#
#	-mach		print the iraf architecture name [default]
#	-hsi		print the HSI arch
#	-nbits		print number of bits in an int (32 or 64)
#	-endian		print endianness of platform (big or little)
#
#	-actual		print actual architecture name regardless of IRAFARCH
#	-set <arch>	manually reset the iraf environment architecture
#
# ----------------------------------------------------------------------------


##############################################################################
# START OF MACHDEP DEFINITIONS.
##############################################################################

debug=0

# Get the Utility aliases.
# Initialize the $iraf and environment.
if [ -z "$iraf" ]; then
  bindir=$(dirname "$0")                # get iraf root directory 
  iraf=${bindir%/*}/../
fi


#----------------------------------
# Determine platform architecture.
#----------------------------------

if [ -e /usr/bin/uname ]; then
    uname_cmd=/usr/bin/uname
elif [ -e /bin/uname ]; then
    uname_cmd=/bin/uname
else
    echo  "No 'uname' command found to determine architecture."
    exit 1
fi

export MNAME=$($uname_cmd | tr '[:upper:]' '[:lower:]')

# Allow an IRAFARCH definition in the environment to override.

if [ $# -gt 0 ]; then
    if [ "$1" = "-actual" ]; then
        unset IRAFARCH
	shift
    elif [ "$1" = "-current" ]; then
        export IRAFARCH=$(ls -lnd "${iraf}bin" 2> /dev/null | \
			awk '{ printf ("%s\n", $11) }' | \
			sed -e 's/bin.//g')
	shift
    elif [ "$1" = "-set" ]; then
	export IRAFARCH=$2
    fi
fi


# Set some common defaults for most platforms

if [ $debug = 1 ]; then				# DEBUG PRINT
    if [ -n "$IRAFARCH" ]; then
        echo " IRAFARCH=$IRAFARCH"
    fi
    echo "    MNAME=$MNAME"
fi


# Determine parameters for each architecture.
if [ -n "$IRAFARCH" ]; then
    mach="$IRAFARCH"
    if [ "$mach" = "macintel" ] || [ "$mach" = "macos64" ] || [ "$mach" = "freebsd64" ] || [ "$mach" = "linux64" ]; then
	nbits=64
    else
	nbits=32
    fi
else
    nbits=$(getconf LONG_BIT)
    case "$MNAME" in
     "darwin")		# Mac OS X
	 if [ "$nbits" = 64 ] ; then
	     if [ "$(uname -m)" = "x86_64" ] ; then
	         mach="macintel"
             else
                 mach="macos64"
	     fi
	 else
             mach="macosx"
         fi
         ;;

     "linux")
	 if [ "$nbits" = 64 ] ; then
             mach="linux64"
	 else
	     mach="linux"
         fi
         ;;

     "*freebsd")
	 if [ "$nbits" = 64 ] ; then
             mach="freebsd64"
         else
             mach="freebsd"
         fi
         ;;
     "gnu"|"hurd") # GNU HURD
         mach="hurd"
         ;;

    *)
	echo  "Unable to determine platform architecture for ($MNAME)."
	exit 1
	;;
    esac
fi
if [ "$(printf 'I' | od -to2 | awk 'FNR==1{ print substr($2,6,1)}')" = "0" ] ; then
    endian="big"
else
    endian="little"
fi

##############################################################################
# END OF MACHDEP DEFINITIONS.
##############################################################################

# Handle any command-line options.
if [ $# = 0 ]; then
    echo $mach
else
    case "$1" in
    "-mach"|"-hsi")
	echo "$mach"
	;;
    "-nbits")
	echo "$nbits"
	;;
    "-endian")
	echo "$endian"
	;;
    "-set")
	if [ -n "$2" ]; then
	    export IRAFARCH=$2
	fi
	export MNAME=$IRAFARCH
	;;
    *)
	echo 'Invalid option '"$1"
	;;
    esac
fi

#!/bin/sh
# Make the first pass (XPP) of the SPP language compiler.

# Exit on error
set -e

if [ ! -f lexyy.c -o xpp.l -nt lexyy.c ] ; then
    lex	-o lexyy.c -t xpp.l
fi

$CC -c $HSI_CF	xppmain.c xppcode.c decl.c lexyy.c
$CC $HSI_LF	xppmain.o lexyy.o xppcode.o decl.o $HSI_LIBS -o xpp.e
mv -f		xpp.e ../../../hlib
rm		*.o

#!/bin/sh
# Utility library subroutines for RPP.

# Exit on error
set -e

$F77 -c $HSI_FF	addset.f addstr.f amatch.f catsub.f clower.f concat.f
$F77 -c $HSI_FF	ctoc.f ctoi.f ctomn.f cupper.f delete.f docant.f dodash.f
$F77 -c $HSI_FF	dsdbiu.f dsdump.f dsfree.f dsget.f dsinit.f enter.f equal.f
$F77 -c $HSI_FF	error.f errsub.f esc.f fcopy.f filset.f fmtdat.f fold.f
$F77 -c $HSI_FF	gctoi.f getc.f getccl.f getpat.f getwrd.f gfnarg.f index.f
$F77 -c $HSI_FF	insub.f itoc.f length.f locate.f lookup.f lower.f makpat.f
$F77 -c $HSI_FF	maksub.f match.f mktabl.f mntoc.f omatch.f outsub.f patsiz.f
$F77 -c $HSI_FF	prompt.f putc.f putdec.f putint.f putstr.f query.f rmtabl.f
$F77 -c $HSI_FF	scopy.f sctabl.f sdrop.f skipbl.f slstr.f stake.f stclos.f
$F77 -c $HSI_FF	stcopy.f stlu.f strcmp.f strim.f termin.f trmout.f type.f
$F77 -c $HSI_FF	upper.f wkday.f

ar r		libf.a *.o
$RANLIB		libf.a
mv -f		libf.a ..
rm		*.o

#!/bin/sh
# XYACC -- Yacc parser generator for SPP.

# Exit on error
set -e

$CC -c $HSI_CF	y[1-4].c
$CC $HSI_LF	y[1-4].o $HSI_LIBS -o xyacc.e
mv -f		xyacc.e ../../hlib
cp 		yaccpar.x ../../../lib
rm -f		*.o

#!/bin/sh
# Make the bootstrap utilities library (bootlib).

# Exit on error
set -e

# $CC -c $HSI_CF [a-z]*.c
for i in [a-z]*.c ;\
do	$CC -c $HSI_CF $i ;\
done

ar rv		libboot.a *.o; rm *.o
$RANLIB		libboot.a
mv -f		libboot.a ../../bin

#!/bin/sh
# Fortran source for RPP preprocessor.

# Exit on error
set -e

$F77 -c $HSI_FF	addchr.f allblk.f alldig.f baderr.f balpar.f beginc.f
$F77 -c $HSI_FF	brknxt.f cascod.f caslab.f declco.f deftok.f doarth.f
$F77 -c $HSI_FF	docode.f doif.f doincr.f domac.f dostat.f dosub.f
$F77 -c $HSI_FF	eatup.f elseif.f endcod.f entdef.f entdkw.f entfkw.f
$F77 -c $HSI_FF	entrkw.f entxkw.f errchk.f errgo.f errorc.f evalr.f
$F77 -c $HSI_FF	finit.f forcod.f fors.f getdef.f gettok.f gnbtok.f
$F77 -c $HSI_FF	gocode.f gtok.f ifcode.f iferrc.f ifgo.f ifparm.f
$F77 -c $HSI_FF	indent.f initkw.f labelc.f labgen.f lex.f litral.f
$F77 -c $HSI_FF	lndict.f ludef.f mapid.f ngetch.f ogotos.f otherc.f
$F77 -c $HSI_FF	outch.f outcon.f outdon.f outdwe.f outgo.f outnum.f
$F77 -c $HSI_FF	outstr.f outtab.f parse.f pbnum.f pbstr.f poicod.f
$F77 -c $HSI_FF	push.f putbak.f putchr.f puttok.f ratfor.f relate.f
$F77 -c $HSI_FF	repcod.f retcod.f sdupl.f skpblk.f squash.f strdcl.f
$F77 -c $HSI_FF	swcode.f swend.f swvar.f synerr.f thenco.f ulstal.f
$F77 -c $HSI_FF	uniqid.f unstak.f untils.f whilec.f whiles.f

ar r		librpp.a *.o
$RANLIB		librpp.a
mv -f		librpp.a ..
rm		*.o

#!/bin/sh
# MKMLIST -- Make a library member list on the standard output, e.g., for
# inclusion in a MKPKG file.

_ml1() {
    ls	-- *.[xfcs]
    grep	'^include' -- *.x
}

_ml2() {
    _ml1 | grep -v '#' | grep -v '<syserr.h>' | sort | uniq |\
	sed -e	's/^.*include./ /' | sed -e 's/\"//g' |\
	sed -e	's/\.x/.x	/' | tr -s '\n ' '\t' 
}

printf "	"
_ml2 | sed -e 's/\(	\)\([^<]\)/#	\2/g' | tr '#' '\n' |\
    sed -e 's/>	</> </g'

#!/bin/sh
#
# CL.SH -- Startup the version of the CL executable compiled for the
# architecture or floating point hardware appropriate for the current
# machine.  This script can be used to invoke a number of CL flavors 
# depending on how it is called.  The installation will create a 'cl'
# and 'ecl' command link to this script with the intent that a different
# binary would be started for each command.  

# Determine IRAF root directory (value set in install script).
d_iraf=/iraf/iraf/
if [ -n "$iraf" -a  ! -e "$iraf" ]; then
    echo "Warning: iraf=$iraf does not exist (check .bashrc or .zshrc)"
    echo "Session will default to iraf=$d_iraf"
    unset iraf ; sleep 3
fi
if [ -z "$iraf" ]; then
    if [ -r ${HOME}/.iraf/irafroot ] ; then
	export iraf=$(cat /etc/iraf/irafroot)
    elif [ -r /etc/iraf/irafroot ] ; then
	export iraf=$(cat /etc/iraf/irafroot)
    else
	export iraf="$d_iraf"
    fi
fi

if [ "${IRAFARCH}" -a  ! -e "${iraf}bin.${IRAFARCH}" ] ; then
    echo "Warning: ${iraf}bin.${IRAFARCH} does not exist (check .bashrc or .zshrc)"
    echo "IRAFARCH will be reset"
    unset IRAFARCH arch ; sleep 3
fi
if [ "${IRAFARCH}" ] ; then
    export arch=".${IRAFARCH}"
    bin="${iraf}bin${arch}/"
else
    bin="${iraf}bin/"
fi

# Determine CL binary to run based on how we were called.
nm=${0##*/}

cl_binary="${bin}ecl.e"

case "$nm" in
    "cl" | "cl.sh")
        cl_binary="${bin}cl.e"
        ;;
    "ecl" | "ecl.sh" | "irafcl" | "irafcl.sh")
        cl_binary="${bin}ecl.e"
        ;;
    "vocl" | "vocl.sh")
        cl_binary="${bin}vocl.e"
        ;;
esac

iraf_version=$(grep version\\s  ${iraf}unix/hlib/zzsetenv.def | \
		   cut -d\" -f2 | cut -d\  -f-3)

while getopts "h?Vcexf:" opt; do
    case "$opt" in
    h|\?)
	echo 'IRAF Command Language Interpreter'
	echo ''
	echo 'Usage:'
	echo '    irafcl [-V|-e|-c] [-x] [-f file]'
	echo ''
	echo 'Arguments:'
	echo '    -V        print version and exit'
	echo '    -e        force ecl'
	echo '    -c        force classic cl'
	echo '    -x        start in new xgterm (xterm if xgterm is not installed)'
	echo '    -f file   start with file'
	echo ''
	exit 0
        ;;
    V)
        echo "${iraf_version}"
	exit 0
        ;;
    e)
	cl_binary=${irafbin}ecl.e
	;;
    c)
	cl_binary=${irafbin}cl.e
	;;
    x)
	start_x="yes"
	;;
    f)
	script=$OPTARG
	;;
    esac
done

# Workaround for autoconf scripts attempting to use this command as a
# valid compiler option.  On some systems (mostly Debian) a valid CC
# command can't be found and eventually the 'cl' (lisp) compiler is
# tried.  It will always apparently have the conftest.c test file, so
# simply exit with a code to tell autoconf it won't work.
if [ "${1##*.}" = "c" ]; then
    exit 1
fi

# Determine the temporary dir, using standard variable from The Open Group
# Base Specifications. Default to FHS.
if [ -z $tmp ]; then
    if [ -n "$TMPDIR" ]; then
        export tmp=$(echo "$TMPDIR" | sed s';/$;;')/
    else
        export tmp="/tmp/"
    fi
fi

# Initialize the IRAF user dirs
for d in imdir cache uparm ; do
    if [ ! -e "${HOME}/.iraf/${d}" ] ; then
        mkdir -p "${HOME}/.iraf/${d}"
    fi
done


# Check whether we should start in an x(g)term window
if [ "${start_x}" = "yes" ] ; then
    if which xgterm > /dev/null ; then
        cl_binary="xgterm -e ${cl_binary}"
    elif which xterm > /dev/null ; then
        cl_binary="xterm -e ${cl_binary}"
    fi
fi

if [ -z "${script}" ] ; then
    exec ${cl_binary}
else
    exec ${cl_binary} -f "${script}"
fi

#!/bin/sh
# Patch f2c and libf2c for the changes done in the IRAF version

set -e

################### F2C ######################
# Base: "src" subdir of f2c-20200916.tar.gz, f.e. from the Debian sources
# Remove files not needed here
rm -f src/f2c.h src/readme src/tokdefs.h src/xsum0.out src/index.html src/mkfile.plan9 

################# LIBF2C ####################
# Base: "src" subdir of libf2c2-20140711.tar.gz, f.e. from the Debian sources
# Remove files not needed here
rm -f libf2c/xsum0.out libf2c/libf2c/mkfile.plan9 libf2c/comptry.bat  libf2c/scomptry.bat


# Patch f2c and libf2c
for p in patches/*.patch; do
    echo $p
    patch -p3 < $p
done

#!/bin/sh
# f77-style shell script to compile and load fortran, C, and assembly codes
#	usage:	f77 [-g] [-O|-O[23456]] [-o absfile] [-c] files [-l library]
#		-o objfile	Override default executable name a.out.
#		-c		Do not call linker, leave relocatables in *.o.
#		-S		leave assembler output on file.s
#		-l library	(passed to ld).
#		-i8		Compile for 8-byte integers
#		-u		complain about undeclared variables
#		-w		omit all warning messages
#		-w66		omit Fortran 66 compatibility warning messages
#		-f*		pass thru cc optimizer options
#		-W*		pass thru cc warning options
#		files		FORTRAN source files ending in .f .
#				C source files ending in .c .
#				Assembly language files ending in .s .
#				efl source files ending in .e .
#		-I includepath	passed to C compiler (for .c files)
#		-Ntnnn		allow nnn entries in table t
#		-cpp -Dxxx	pipe through cpp
#
# [IRAF] -- For IRAF we had to modify the f77 script that came with Linux
# to remove the "f2ctmp_XX" prefix that the script was adding to the Fortran
# file names when compiling.  The main problem with this is that it prevents
# source code debugging from working since the file that was compiled (e.g.
# f2ctmp_foo.f) no longer exists at run time.  A lesser problem was that the
# code which deletes the f2ctmp_ files would return an exit 4 status, causing
# problems with XC (XC was modified for Linux to ignore this but it is still
# a bug with the f77 script).  NOTE -- the old behavior is still present if
# the Fortran file has a .F extension.  The modified (no f2ctmp_) behavior is
# for .f files.

# This f77.sh will modify the IRAF generated files so that the memd struct
# contains two elements rather than one element.  This is essential to 
# insure that doubles are aligned on 128 byte boundaries, which is necessary
# for gcc 4.8 to correctly generate instructions with SSE2.
#
# Also note that config.h has to also have the memory alignment set so that
# doubles are aligned against 128-bit boundaries.
#
# This was the reported with Mageia bug #11507
# https://bugs.mageia.org/show_bug.cgi?id=11507
set -e

s=/tmp/stderr_$$
CC=${CC_f2c:-${CC:-cc}}
CFLAGS="-I${iraf}include ${XC_CFLAGS} -std=gnu11 -Wno-deprecated-non-prototype -Wno-maybe-uninitialized -Wno-strict-aliasing -Wno-unknown-warning-option -Wno-return-type -fcommon"
EFL=${EFL:-/v/bin/efl}
EFLFLAGS=${EFLFLAGS:-'system=portable deltastno=10'}
F2C=${F2C:-${iraf}unix/bin/f2c.e}
F2CFLAGS=${F2CFLAGS:='-KRw8 -Nn802 -cf'}
keepc=0
xsrc=0
rc=0
trap 'rm -f $s ; exit $rc' 0
OUTF=a.out
cOPT=1
G=
CPP=cat
CPPFLAGS=
# set -- `getopt cD:gI:N:Oo:Suw6 "$@"`
case $? in 0);; *) exit 1;; esac
while
	test X"$1" != X--
do
	case "$1"
	in
	-b)	CFLAGS="$CFLAGS -b $2"
		shift 2
		;;

	-K)	keepc=1
		shift
		;;

	-c)	cOPT=0
		shift
		;;

	-D)	CPPFLAGS="$CPPFLAGS -D$2"
		shift 2
		;;

	-D*)	CPPFLAGS="$CPPFLAGS $1"
		shift 1
		;;

	-f2c)	F2C="$2"
		#F2C="${iraf}/unix/bin/f2c.e"
		shift 2
		;;

	-f*)	CFLAGS="$CFLAGS $1"
		shift 1
		;;

	-g)	CFLAGS="$CFLAGS -g"
		F2CFLAGS="$F2CFLAGS -g"
		G="-g"
		shift;;

	-x64)	CFLAGS="$CFLAGS -mfloat64"
		shift;;

	-I)	CFLAGS="$CFLAGS -I$2"
		shift 2
		;;

	-I*)	CFLAGS="$CFLAGS $1"
		shift 1
		;;

	-m*)	CFLAGS="$CFLAGS $1"
		shift 1
		;;

	-o)	OUTF=$2
		shift 2
		;;

	-O*)
		CFLAGS="$CFLAGS $1"
		shift
		;;

	-arch)	CFLAGS="$CFLAGS -arch $2"
		shift 2
		;;

	-U)	CFLAGS="$CFLAGS -arch ppc -arch i386"
		shift
		;;

	-u)	F2CFLAGS="$F2CFLAGS -u"
		shift
		;;

	-i8)	F2CFLAGS="$F2CFLAGS -I8"
		shift
		;;

	-P)	F2CFLAGS="$F2CFLAGS -P"
		shift
		;;

	-FP)	CFLAGS="$CFLAGS -include $2"
		shift 2
		;;

	-W*)	CFLAGS="$CFLAGS $1"
		shift 1
		;;

	-w)	F2CFLAGS="$F2CFLAGS -w"
		CFLAGS="$CFLAGS -w"
		case $2 in -6) F2CFLAGS="$F2CFLAGS"66; shift
			case $2 in -6) shift;; esac;; esac
		shift
		;;

	-x)	xsrc=1
		shift
		;;

	-N)	F2CFLAGS="$F2CFLAGS $1""$2"
		shift 2
		;;

	-N*|-C)	F2CFLAGS="$F2CFLAGS $1"
		shift 1
		;;

	-cpp)	CPP="/lib/cpp -traditional"
		shift 1
		;;

	-S)	CFLAGS="$CFLAGS -S"
		cOPT=0
		shift
		;;

	-*)
		echo "invalid parameter $1" 1>&2
		shift
		;;

	*)	set -- -- $@
		;;
	esac
done
shift

while
	test -n "$1"
do
	case "$1"
	in
	*.f)
		case "$1" in *.f) f=".f";; *.F) f=".F";; esac
		b=$(basename "$1" $f)
		$F2C $F2CFLAGS "$b.f"
		if [ $xsrc = 1 ]; then
		    sed -e "s/$b\\.f/$b.x/" < "$b.c" > "$b.t"; mv "$b.t" "$b.c"
		fi
                $CC $CPPFLAGS -c $CFLAGS "$b.c" 2>"$s"
		rc=$?
		sed '/parameter .* is not referenced/d;/warning: too many parameters/d' $s 1>&2
		case $rc in 0);; *) exit 5;; esac
		if [ $keepc = 0 ]; then
		    rm -f "$b.c"
		fi
		OFILES="$OFILES $b.o"
		case $cOPT in 1) cOPT=2;; esac
		shift
		;;
	*.F)
		case "$1" in *.f) f=".f";; *.F) f=".F";; esac
		b=$(basename "$1" "$f")
                trap 'rm -f f2ctmp_$b.* ; exit 4' 0
                sed 's/\\$/\\-/;
                     s/^ *INCLUDE *'\(.*\)'.*$/#include "\1"/' "$1" |\
		 $CPP $CPPFLAGS |\
		 grep -E -v '^# ' > "f2ctmp_$b.f"
                trap 'rm -f f2ctmp_$b.* ; exit 4' 0
		$F2C $F2CFLAGS "f2ctmp_$b.f"
		case $? in 0);; *) rm f2ctmp_* ; exit 5;; esac
                rm -f "f2ctmp_$b.f"
		mv "f2ctmp_$b.c" "$b.c"
		if [ -f "f2ctmp_$b.P" ]; then mv "f2ctmp_$b.P" "$b.P"; fi
		case $? in 0);; *) rm -f "$b.c" ; exit 5;; esac
                trap 'rm -f $s ; exit 4' 0
                $CC $CPPFLAGS -c $CFLAGS "$b.c" 2>$s
		rc=$?
		sed '/parameter .* is not referenced/d;/warning: too many parameters/d' $s 1>&2
		case $rc in 0);; *) exit 5;; esac
		if [ $keepc = 0 ]; then
		    rm -f "$b.c"
		fi
		OFILES="$OFILES $b.o"
		case $cOPT in 1) cOPT=2;; esac
		shift
		;;
	*.e)
		b=$(basename "$1" .e)
		$EFL $EFLFLAGS "$1" >"$b.f"
		case $? in 0);; *) exit;; esac
		$F2C $F2CFLAGS "$b.f"
		case $? in 0);; *) exit;; esac
                $CC -c $CFLAGS "$b.c"
		case $? in 0);; *) exit;; esac
		OFILES="$OFILES $b.o"
		rm "$b".[cf]
		case $cOPT in 1) cOPT=2;; esac
		shift
		;;
	*.s)
		echo "$1": 1>&2
		OFILE=$(basename "$1" .s).o
		${AS:-as} -o "$OFILE" $AFLAGS "$1"
		case $? in 0);; *) exit;; esac
		OFILES="$OFILES $OFILE"
		case $cOPT in 1) cOPT=2;; esac
		shift
		;;
	*.c)
		echo "$1": 1>&2
		OFILE=$(basename "$1" .c).o
                $CC -c $CFLAGS $CPPFLAGS "$1"
		rc=$?; case $rc in 0);; *) exit;; esac
		OFILES="$OFILES $OFILE"
		case $cOPT in 1) cOPT=2;; esac
		shift
		;;
	*.o)
		OFILES="$OFILES $1"
		case $cOPT in 1) cOPT=2;; esac
		shift
		;;
	-l)
		OFILES="$OFILES -l$2"
		shift 2
		case $cOPT in 1) cOPT=2;; esac
		;;
	-l*)
		OFILES="$OFILES $1"
		shift
		case $cOPT in 1) cOPT=2;; esac
		;;
	-o)
		OUTF=$2; shift 2;;
	*)
		OFILES="$OFILES $1"
		shift
		case $cOPT in 1) cOPT=2;; esac
		;;
	esac
done

case $cOPT in 2) $CC $G -o "$OUTF" "$OFILES" -lf2c -lm;; esac
rc=$?
exit $rc

#!/bin/sh
# Copyright (c) 2011-2017, Astropy Developers
# Distributable under a BSD-3-Clause license

# This script is adopted from astropy and adjusted for the needs in IRFA.
# It should be run every time cfitsio is updated.
# This moves all the code needed for the actual library to lib
# and deletes everything else (except License.txt and doc/changes.txt)

# So, the standard update would be to execute, from this directory,
# rm -rf cfitsio
# tar xvf <PATH_TO_TAR>   # (e.g., cfitsio3410.tar.gz)
# ./trim_cfitsio.sh

set -e

# Locally patch wcsutil.c
patch -s -p1 <<EOF
--- b/cfitsio/wcsutil.c
+++ a/cfitsio/wcsutil.c
@@ -81,8 +81,9 @@ int ffwldp(double xpix, double ypix, double xref, double yref,
       dect = dec0 + m;
 
     } else if (*cptr == 'T') {  /* -TAN */
-      if (*(cptr + 1) != 'A' ||  *(cptr + 2) != 'N') {
-         return(*status = 504);
+      if ( !(*(cptr + 1) == 'A' && *(cptr + 2) == 'N') && 
+           !(*(cptr + 1) == 'P' && *(cptr + 2) == 'V') ) {
+         	return(*status = 504);
       }
       x = cos0*cos(ra0) - l*sin(ra0) - m*cos(ra0)*sin0;
       y = cos0*sin(ra0) + l*cos(ra0) - m*sin(ra0)*sin0;

EOF

# This just gets CORE_SOURCES from Makefile.in
lib_files=$(make -f cfitsio/Makefile.in cfitsioLibSrcs | sed 's/zlib\/.*//')
flib_files='f77_wrap1.c f77_wrap2.c f77_wrap3.c f77_wrap4.c'
# The include files cannot be directly inferred from Makefile.in
inc_files='fitsio.h fitsio2.h longnam.h drvrsmem.h eval_defs.h eval_tab.h region.h group.h simplerng.h grparser.h f77_wrap.h cfortran.h'
extra_files='config.sub config.guess Makefile.in cfitsio.pc.in'

if [ ! -d cfitsio/lib ]; then
    mkdir cfitsio/lib
fi

for fil in $lib_files $flib_files $inc_files $extra_files; do
    if [ -f "cfitsio/$fil" ]; then
        mv "cfitsio/$fil" cfitsio/lib/
    fi
done
rm -rf cfitsio/cfitsio.xcodeproj
rm -rf cfitsio/docs
rm -f cfitsio/[!L]*.*
mv cfitsio/lib/* cfitsio/
rmdir cfitsio/lib/
cat <<EOF >cfitsio/README.IRAF
Note: IRAF only requires the CFITSIO library, and hence in this bundled version,
we removed all other files except the required license (License.txt) and changelog
(docs/changes.txt, which has the version number).
EOF
cat <<EOF >cfitsio/mklibs
#!/bin/sh

set -e

top=\$(pwd)

export CC=gcc
export CXX=g++


if [ "\$PLMACH" = "macosx" ] ; then
   export CFLAGS="-DDarwin"
fi

echo "  (Using toplevel directory \$top ....)"

# Global options.
gopts="--prefix=\$top --exec-prefix=\$top --disable-shared"

./configure \$gopts
make clean
make

cp   libcfitsio.a ../voclient/lib
mv   libcfitsio.a ../../lib
cp   fitsio*.h longnam.h ../../include

make clean
echo "done"
EOF

chmod +x cfitsio/mklibs

#!/bin/sh
#
# CL.SH -- Startup the version of the CL executable compiled for the
# architecture or floating point hardware appropriate for the current
# machine.  This script can be used to invoke a number of CL flavors 
# depending on how it is called.  The install script will create a 'cl'
# and 'ecl' command link to this script with the intent that a different
# binary would be started for each command.  


# Determine CL binary to run based on how we were called.

nm=${0##*/}
cl_binary="ecl.e"

case "$nm" in
    "cl" | "cl.sh")
        cl_binary="cl.e"
        ;;
    "ecl" | "ecl.sh")
        cl_binary="ecl.e"
        ;;
    "vocl" | "vocl.sh")
        cl_binary="vocl.e"
        ;;
    *)
	if [ $# -gt 1 ]; then
	    if [ "$1" = "-old" ] || [ "$1" = "-o" ]; then
        	cl_binary="cl.e"
	    elif [ "$1" = "-ecl" ] || [ "$1" = "-e" ]; then
        	cl_binary="ecl.e"
	    elif [ "$1" = "-vo" ]; then
        	cl_binary="vocl.e"
	    elif [ "${1##*.}" = "c" ]; then
		# Workaround for autoconf scripts attempting to use this 
		# command as a valid compiler option.  On some systems (mostly
		# Debian) a valid CC command can't be found and eventually 
		# the 'cl' (lisp) compiler is tried.  It will always apparently
		# have the conftest.c test file, so simply exit with a code to
		# tell autoconf it won't work.
		exit 1
	    fi
	fi
esac

# Determine IRAF root directory (value set in install script).
d_iraf="/iraf/iraf/"
if [ -n "$iraf" ]; then
    if [ ! -e "$iraf" ]; then
        echo "Warning: iraf=$iraf does not exist (check .cshrc or .login)"
        echo "Session will default to iraf=$d_iraf"
        unset iraf ; sleep 3
    fi
fi
if [ -z "$iraf" ]; then
    export iraf="$d_iraf"
fi

# Check for a version query.
if [ $# -gt 1 ]; then
    case "$1" in
	"-v" | "-V" | "-version" | "--version")
            head -1 $iraf/unix/hlib/motd
	    exit 0
	    ;;
	*)
	    ;;
    esac
fi


# Determine platform architecture.
if [ -e $iraf/unix/hlib/irafarch.sh ]; then
    ACTUAL_ARCH=$($iraf/unix/hlib/irafarch.sh -actual)
else
    ACTUAL_ARCH=$IRAFARCH
fi

if [ -n "$IRAFARCH" ]; then
    if [ -e "$iraf/bin.${IRAFARCH}/${cl_binary}" ]; then
	MACH=$IRAFARCH
    else
        echo "ERROR:  No $iraf/bin.${IRAFARCH}/${cl_binary} binary found."
	if [ "$ACTUAL_ARCH" != "$IRAFARCH" ]; then
            echo "ERROR:  IRAFARCH set to '$IRAFARCH', should be '$ACTUAL_ARCH'"
	fi
	exit 1
    fi
    export arch=".$MACH"

else
    os_mach=$(uname -s | tr '[:upper:]' '[:lower:]' | cut -c1-6)
 
    if [ -e $iraf/unix/hlib/irafarch.sh ]; then
        MACH=$($iraf/unix/hlib/irafarch.sh)
    else
        MACH=$os_mach
    fi

    if [ "$os_mach" = "linux" ]; then		# handle linux systems
        if [ "$(uname -m)" = "x86_64" ]; then
            export mach="linux64"
        else
            export mach="linux"
        fi
    elif [ "$os_mach" = "darwin" ]; then	# handle Mac systems
        if [ "$(uname -m)" = "x86_64" ]; then
	     if [ "$(uname -m)" = "x86_64" ] ; then
	         export mach="macintel"
             else
                 export mach="macos64"
	     fi
        else
            export mach="macosx"
        fi
    else
        mach=$(uname -s | tr '[:upper:]' '[:lower:]')
    fi

    export arch=".$MACH"
    if [ -z "$IRAFARCH" ]; then
        export IRAFARCH="$MACH"
    fi

    if [ ! -e "$iraf/bin.${MACH}/${cl_binary}" ]; then
        echo "ERROR:  No $iraf/bin.${IRAFARCH}/${cl_binary} binary found."
	exit 1
    fi
fi


# Just run the CL if IRAFARCH already defined.
if [ -n "$IRAFARCH" ]; then
    if [ -z "$IRAFARCH" ]; then
	export arch=""
    else
	export arch=".$IRAFARCH"
    fi

    export IRAFBIN="${iraf}bin$arch/"
    file=${IRAFBIN}$cl_binary
    if [ -e "$file" ]; then
	exec "$file"
    else
	echo "$file not found"
    fi
fi


# Set the architecture to be used.
export IRAFARCH=$MACH
export arch=.$IRAFARCH
export IRAFBIN=${iraf}bin$arch/

# Run the desired CL.
exec  "${IRAFBIN}$cl_binary"

#!/bin/sh
# Bootstrap the UNIX bootstrap utilities and host system interface.
# Note - the environment variables HSI_CF and HSI_FF (compile/link flags)
# are required for the bootstrap; these are defined in hlib$irafuser.csh.
#
# USAGE:  `sh -x mkpkg.sh >& spool'  to bootstrap the IRAF HSI.

# Exit on error
set -e

# Set the HSI architecture.
sh -x setarch.sh

echo "----------------------- OS -----------------------------"
echo "+"; echo "+"
(cd os;   sh -x mkpkg.sh)
echo "----------------------- F2C ----------------------------"
echo "+"; echo "+"
(cd f2c; sh -x mkpkg.sh)
echo "----------------------- BOOT ---------------------------"
echo "+"; echo "+"
(cd boot; sh -x mkpkg.sh)
#echo "----------------------- SHLIB --------------------------"
#echo "+"; echo "+"
#(cd shlib; sh -x mkpkg.sh)
echo "----------------------- GDEV ---------------------------"
(cd gdev; sh -x mkpkg.sh)

# Install the newly created executables.
echo "install HSI executables in $host/bin.$MACH"
mv -f hlib/*.e bin.$MACH

#!/bin/sh
#
# FC.SH -- Link an IMFORT or host fortran program from IRAF.  A front end
# to XC, the purpose of this script is to determine the IRAF architecture
# and add the appropriate host compiler file to XC.


# Determine the desired architecture.
IRAFARCH=$("$iraf/unix/hlib/irafarch.csh")
export MACH=$IRAFARCH

# Set any float option switch.
case $IRAFARCH in
    macosx)
        float="-/arch -//i386"
        ;;
    macintel)
        float="-/arch -//x86_64"
        ;;
    linux64)
        float="-/m64"				# FIXME
        ;;
    *)
        float=""
        ;;
esac

# Call XC with the appropriate float option.
xc $float "$@"

# Allow a previously defined $iraf to be used.
set d_iraf = /iraf/iraf/
if ( ! ( $?iraf )) then
    if ( -r ${HOME}/.iraf/irafroot ) then
	setenv iraf `cat /etc/iraf/irafroot`
    else if ( -r /etc/iraf/irafroot ) then
	setenv iraf `cat /etc/iraf/irafroot`
    else
	setenv iraf $d_iraf
    endif
endif

# Allow a previously defined $IRAFARCH to be used.
if ( ! ( $?IRAFARCH )) then
    setenv IRAFARCH	`$iraf/unix/hlib/irafarch.sh -actual`
endif

set path = ($HOME/.iraf/bin $path)
set cdpath  = ($iraf $iraf/pkg $iraf/noao $iraf/sys $iraf/unix $iraf/unix/boot)

# The world'd most obvious alias ....
alias iraf	"xgterm -e cl &"

rehash

# Set the HSI architecture.

# Set the link 'as'.
if [ "`ls -d as`" = "as" ]; then rm -rf as; fi
    ln -s as.$MACH as

# Ditto for 'bin'.
if [ "`ls -d bin`" = "bin" ]; then rm -rf bin; fi
    ln -s bin.$MACH bin

#!/bin/sh
# Make the second pass (RPP) of the SPP language compiler.

# Exit on error
set -e

if [ "${RATFOR}" ] ; then
    echo "------------------- Ratfor preprocessing ---------------"
    rm -f rppfor/*.f ratlibf/*.f rpprat/fort ratlibr/fort
    make -C rpprat RATFOR=${RATFOR}
    make -C ratlibr RATFOR=${RATFOR}
fi

echo "----------------------- RPPFOR -------------------------"
(cd rppfor;	sh -x mkpkg.sh)
echo "----------------------- RATLIBF ------------------------"
(cd ratlibf;	sh -x mkpkg.sh)
echo "----------------------- RATLIBC ------------------------"
(cd ratlibc;	sh -x mkpkg.sh)

$CC -c $HSI_CF	rpp.c
$CC $HSI_LF	rpp.o librpp.a libf.a libc.a $HSI_F77LIBS -o rpp.e
mv -f		rpp.e ../../../hlib
rm		*.[ao]

#!/bin/sh
# Bootstrap MKPKG.

# Exit on error
set -e

$CC -c $HSI_CF	char.c fdcache.c fncache.c host.c main.c pkg.c scanlib.c\
		    sflist.c tok.c
$CC $HSI_LF	main.o char.o fdcache.o fncache.o host.o pkg.o scanlib.o\
		    sflist.o tok.o $HSI_LIBS -o mkpkg.e

mv -f mkpkg.e ../../hlib
rm *.o

#!/bin/sh
#
#  MKIRAF -- Setup the IRAF environment for a user.  Should be called from the
#  directory from which the user will thereafter type "cl" to start a session.
#
#  Usage:
#
#	% mkiraf [--default] [--init] [--noinit] [--copy] [--quiet]
#
#  Where
#	-d,--default		Create default login dir
#	-i,--init		Initialize the uparm directory
#	-n,--noinit		Do not nitialize the uparm directory
#	-c,--copy		Copy login.cl file
#	-q,--quiet		Suppress output
#
#  Use of the -i or -n options will suppress the corresponding prompt
#  for input.


# Initialize the script variables.
uparm_init="ask"
quiet=""
def=""
copy=""
imdir="${HOME}/.iraf/imdir/"
cachedir="${HOME}/.iraf/cache/"

# Path edited by the install script.
d_iraf="/iraf/iraf/"
if [ -z "$iraf" ]; then
    if [ -r ${HOME}/.iraf/irafroot ] ; then
	export iraf=$(cat ${HOME}/.iraf/irafroot)
    elif [ -r /etc/iraf/irafroot ] ; then
	export iraf=$(cat /etc/iraf/irafroot)
    else
	export iraf="$d_iraf"
    fi
fi

# Parse the command-line options.
for i in "$@"; do
    case $i in
	-d|--default)			# Create default login dir
            def="default"
            quiet="quiet"
	    echo ""
    	    ;;
	-i|--init)			# Initialize uparm directory
            uparm_init="yes"
    	    ;;
	-n|--noinit)			# Don't initialize uparm directory
            uparm_init="no"
    	    ;;
	-c|--copy)                      # Copy login.cl file
	    copy="yes"
	    ;;
	-q|--quiet)			# Suppress output
            quiet="quiet"
    	    ;;
	*)
            echo "Error: unknown option '$i'"
	    exit 1
    	    ;;
    esac
done

# With --default, chdir to the default directory to create uparm and
# login.cl there
if [ "$def" ]; then
    cd "${HOME}/.iraf/"
else
    # Protect against running mkiraf in an iraf system directory.
    irafdir=$(cd "$iraf" ; pwd)
    if (pwd | grep -q "^$irafdir") && ! (pwd | grep -q iraf/local); then
	echo "Error: current directory is not an iraf user login directory"
	exit 1
    fi
fi

# Create imdir and cache dir if not already there
mkdir -p "${imdir}" "${cachedir}"

# Make an empty "uparm" (user parameter) directory.
if [ ! -e uparm ]; then
    if [ ! "$quiet" ]; then
        echo '-- creating a new uparm directory'
    fi
    mkdir uparm
elif [ ! -d uparm ]; then
    echo "Error: a file uparm exists"
    exit 1
else
    if [ "$uparm_init" = "ask" ] ; then
	if [ ! "$quiet" ] ; then
            printf 'Initialize uparm? (y|n): '
            read yesno
	else
	    yesno="yes"
	fi
	if [ "$yesno" = "y" ] || [ "$yesno" = "yes" ]; then
	    if [ ! "$quiet" ]; then
		echo '-- initializing uparm'
	    fi
	    rm -rf uparm
	    mkdir uparm
	fi
    elif [ "$uparm_init" = "yes" ]; then
	if [ ! "$quiet" ]; then
	    echo '-- initializing uparm'
	fi
	rm -rf uparm
	mkdir uparm
    fi
fi


# Create local login.cl
if [ "$copy" ]; then
    if [ -e login.cl ]; then
	mv -f login.cl login.cl.OLD
    fi
    cp -f "${iraf}unix/hlib/login.cl" login.cl
    if [ ! "$def" ]; then
	echo 'A new LOGIN.CL file has been created in the current directory.'
	echo 'You may wish to review and edit this file to change the defaults.'
    fi
fi

#!/bin/sh
# Host system interface for the RPP program.

# Exit on error
set -e

$CC -c -g $HSI_CF	cant.c close.c endst.c getarg.c getlin.c initst.c open.c\
		putch.c putlin.c r4tocstr.c remark.c

ar rv		libc.a *.o
$RANLIB		libc.a
mv -f		libc.a ..
rm		*.o

#!/bin/sh
# Make the SGI translators and install them in hlib.

# Exit on error
set -e

$CC -c $HSI_CF	sgiUtil.c

$CC -c $HSI_CF	sgidispatch.c
$CC $HSI_LF	sgidispatch.o ../../hlib/libos.a $HSI_LIBS -o sgidispatch.e
mv -f		sgidispatch.e ../../hlib
rm		sgidispatch.o

$CC -c $HSI_CF	sgi2uimp.c
$CC $HSI_LF	sgi2uimp.o sgiUtil.o $HSI_LIBS -o sgi2uimp.e
mv -f		sgi2uimp.e ../../hlib
rm		sgi2uimp.o

$CC -c $HSI_CF	sgi2uapl.c
$CC $HSI_LF	sgi2uapl.o sgiUtil.o $HSI_LIBS -o sgi2uapl.e
mv -f		sgi2uapl.e ../../hlib
rm		sgi2uapl.o

$CC -c $HSI_CF	sgi2uqms.c
$CC $HSI_LF	sgi2uqms.o sgiUtil.o $HSI_LIBS -o sgi2uqms.e
mv -f		sgi2uqms.e ../../hlib
rm		sgi2uqms.o

$CC -c $HSI_CF	sgi2uptx.c
$CC $HSI_LF	sgi2uptx.o sgiUtil.o $HSI_LIBS -o sgi2uptx.e
mv -f		sgi2uptx.e ../../hlib
rm		sgi2uptx.o

$CC -c $HSI_CF	sgi2uhplj.c
$CC $HSI_LF	sgi2uhplj.o sgiUtil.o $HSI_LIBS -o sgi2uhplj.e
mv -f		sgi2uhplj.e ../../hlib
rm		sgi2uhplj.o

$CC -c $HSI_CF	sgi2uhpgl.c
$CC $HSI_LF	sgi2uhpgl.o sgiUtil.o $HSI_LIBS -o sgi2uhpgl.e
mv -f		sgi2uhpgl.e ../../hlib
rm		sgi2uhpgl.o

$CC -c $HSI_CF	sgi2ueps.c
$CC $HSI_LF	sgi2ueps.o sgiUtil.o $HSI_LIBS -o sgi2ueps.e
mv -f		sgi2ueps.e ../../hlib
rm		sgi2ueps.o

$CC -c $HSI_CF	sgi2gif.c
$CC $HSI_LF	sgi2gif.o sgiUtil.o $HSI_LIBS -o sgi2gif.e
mv -f		sgi2gif.e ../../hlib
rm		sgi2gif.o

$CC -c $HSI_CF	sgi2xbm.c
$CC $HSI_LF	sgi2xbm.o sgiUtil.o $HSI_LIBS -o sgi2xbm.e
mv -f		sgi2xbm.e ../../hlib
rm		sgi2xbm.o

$CC -c $HSI_CF	sgi2svg.c
$CC $HSI_LF	sgi2svg.o sgiUtil.o $HSI_LIBS -o sgi2svg.e
mv -f		sgi2svg.e ../../hlib
rm		sgi2svg.o

rm		sgiUtil.o

# RMBIN -- Shell script to strip the binaries from the HSI.  This is normally
# done with the HSI bootstrap program 'rmbin', but this script can be used
# instead if the rmbin executable is not available for some reason.
#
#	USAGE:  'sh -x rmbin.sh'.

/bin/rm -f `find . \! -type d -print | grep '\.[aoe]$'`

# Allow a previously defined $iraf to be used.
d_iraf="/iraf/iraf/"
if [ -z "$iraf" ]; then
    if [ -r ${HOME}/.iraf/irafroot ] ; then
	export iraf=$(cat ${HOME}/.iraf/irafroot)
    elif [ -r /etc/iraf/irafroot ] ; then
	export iraf=$(cat /etc/iraf/irafroot)
    else
	export iraf="$d_iraf"
    fi
fi

# Allow a previously defined $IRAFARCH to be used.
if [ -z "$IRAFARCH" ]; then
    export IRAFARCH=$("$iraf/unix/hlib/irafarch.sh" -actual)
fi

export PATH=$HOME/.iraf/bin:${PATH}

# The world'd most obvious alias ....
alias iraf="xgterm -e cl &"

#!/bin/sh
# Bootstrap the LIBOS.A library.

# Exit on error
set -e

echo		"--------------------- OS ----------------------"


$CC -c $HSI_CF -Wall zsvjmp.S gmttolst.c irafpath.c prwait.c z*.c alloc.c getproc.c
$CC $HSI_LF -Wall alloc.o getproc.o $HSI_OSLIBS -o alloc.e
chmod	4755 alloc.e
mv -f	alloc.e ../hlib
rm -f	alloc.o zmain.o
ar r	libos.a *.o; 
ranlib	libos.a

rm *.o
mv -f		libos.a ../bin

#!/bin/sh
#
#  UTIL.SH -- Utility support script for IRAF commands.
#
# ----------------------------------------------------------------------------


##############################################################################
#  Start of MACHDEP definitions.
##############################################################################

# MACHDEP definitions which may be reset below.
LS() {
    ls 					# [MACHDEP]
} ; export LS


export IRAF_VERSION="V2.16"
export V=$(printf "%s" $IRAF_VERSION | cut -c2-5)

export hilite=1


##############################################################################
#  Utility aliases.
##############################################################################

ECHO() {
    if [ "$1" = "-n" ]; then
        printf "%s" "$2"
    else
        printf "%s\\n" "$1"
    fi
} ; export ECHO

RM() {
    rm -rf "$1"
} ; export RM

LN() {
    ln -s "$2" "$1"
} ; export LN

BOLD_ON() {
    if [ $hilite ]; then tput bold; fi
} ; export BOLD_ON
BOLD_OFF() {
    if [ $hilite ]; then tput sgr0; fi
} ; export BOLD_OFF
SO_ON() {
    if [ $hilite ]; then tput smso; fi
} ; export SO_ON
SO_OFF() {
    if [ $hilite ]; then tput sgr0; fi
} ; export SO_OFF

DO_OK() {
    ECHO -n "[ "; BOLD_ON; ECHO -n " OK "; BOLD_OFF; ECHO " ]"
} ; export DO_OK

DO_WARN() {
    ECHO -n "[ "; BOLD_ON; ECHO -n "WARN"; BOLD_OFF; ECHO " ]"
} ; export DO_WARN

DO_FAIL() {
    ECHO -n "[ ";   SO_ON; ECHO -n "FAIL";   SO_OFF; ECHO " ]"
} ; export DO_FAIL

NEWLINE() {
    ECHO ''
} ; export NEWLINE



PUT() {
    cp -p "$1" "$2"
} ; export PUT

PROMPT() {
    BOLD_ON; ECHO -n "$1"; BOLD_OFF; ECHO -n " (yes): "
} ; export PROMPT

PROMPT_N() {
    BOLD_ON; ECHO -n "$1"; BOLD_OFF; ECHO -n " (no): "
} ; export PROMPT_N

MSG() {
    ECHO -n "   "; BOLD_ON; ECHO -n "***  "; BOLD_OFF; ECHO "$1"
} ; export MSG

MSGB() {
    ECHO -n "   ";BOLD_ON;ECHO -n "***  ";ECHO "$1"; BOLD_OFF
} ; export MSGB

MSGN() {
    ECHO -n "   ";BOLD_ON;ECHO -n "***  ";BOLD_OFF; ECHO -n "$1"
} ; export MSGN

MSGBN() {
    ECHO -n "   ";BOLD_ON;ECHO -n "***  ";ECHO -n "$1"; BOLD_OFF
} ; export MSGBN

ERRMSG() {
    ECHO -n "   ";BOLD_ON;ECHO -n "ERROR: "  ;BOLD_OFF; ECHO "$1"
} ; export ERRMSG

WARNING() {
    ECHO -n "   ";
    BOLD_ON;
    ECHO -n "WARNING: ";
    BOLD_OFF;
    ECHO "$1"
} ; export WARNING

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is. Please make sure that your problem appears under the community version of IRAF.

**To Reproduce**
Steps to reproduce the behavior.

 1. [First Step]
 2. [Second Step]
 3. [and so on...]

If possible, please include the used files, or include a link to them.

**Expected behavior**
A clear and concise description of what you expected to happen.

**System details:**
 - OS: [e.g. macOS 10.16, or Ubuntu 20.04]
 - Version [e.g. 2.17]
 - Versions of all additionally involved software, i.e. xgterm, PyRAF, sptable,

**Additional context**
Add any other context about the problem here.

# Installation Instructions

## System Requirements and Dependencies

The distributed binaries require the readline or libedit, and zlib
libraries to be installed.

On Debian and its derivatives (Ubuntu, Mint, Devuan, Raspbian etc.):

	$ sudo apt install gcc make bison flex zlib1g-dev libreadline-dev

On Fedora and its derivatives (Redhat, Scientific Linux etc.)

	$ sudo dnf install gcc make perl flex bison zlib-devel readline-devel

On macOS, you need to have the XCode tools installed. If you
haven't, you can install them with:

	$ xcode-select --install

Click "Install" to download and install Xcode Command Line Tools.


## Download and Unpack the IRAF Distribution

IRAF v2.18.1 is available from Github at

https://github.com/iraf-community/iraf/archive/refs/tags/v2.18.1.tar.gz

The source distribution file is built as a tarball with the package
name and version as base directory. Thus, distribution files can be
unpacked with the command

	$ tar zxf /<path>/iraf-2.18.1.tar.gz
	$ cd iraf-2.18.1/

Alternatively, the development version can be always retrieved from
the [Github repository](https://github.com/iraf-community/iraf).

## Build from Sources

Now you can compile IRAF on your system with the command

	$ make 2>&1 | tee build.log

The following IRAF architectures are supported:

Architecture | Operating system | Supported CPU types
-------------|------------------|---------------------------------------------
`linux64`    | Linux 64 bit     | x86\_64, arm64, mips64, ppc64, riscv64, alpha, loongarch64
`linux`      | Linux 32 bit     | i386, x32, arm, mips
`macos64`    | macOS 64 bit     | arm64
`macintel`   | macOS 64 bit     | x86\_64
`macosx`     | macOS 32 bit     | i386
`freebsd64`  | FreeBSD 64 bit   | x86\_64
`freebsd`    | FreeBSD 32 bit   | i386, arm
`hurd64`     | GNU HURD 64 bit  | x86\_64
`hurd`       | GNU HURD 32 bit  | i386

Note that Cygwin and big endian architectures like macosx/ppc are not
supported anymore.

## Test the Build

IRAF comes with a small set of basic tests to ensure that the build
works fine. To execute the tests, run:

	$ make test

The output should look like

	ecl.e: README.md
	ecl.e: files.md ......
	ecl.e: images.imcoords.md ...........
	ecl.e: images.imfilter.md .x............
	ecl.e: images.imfit.md ...
	ecl.e: images.imgeom.md ........
	ecl.e: images.immatch.md ..
	ecl.e: lists.md .......
	ecl.e: noao.astutil.md ........
	ecl.e: noao.digiphot.photcal.md .
	ecl.e: numerical-recipes.md ..........
	ecl.e: os.md ..
	ecl.e: programming.md ............
	ecl.e: sys.vops.md .
	ecl.e: test-syntax.md ...xs.
	ecl.e: testproc.md ..........................
	ecl.e: utilities.nttools.md ..............
	Test summary:  128 passed
	   1 skipped
	   2 xfailed

Note that `xfailed` (`x`) are e**x**pected **fail**ures, which one
does not need to worry about.

For details of the tests, see the file [`test/README.md`](test/README.md).

## Install the software at its final place

There are two options to install the build: system wide (by default
under `/usr/local/lib/iraf`), or in-place for the current user
only. If you have root (sudo, admin) access, the system wide
installation is the preferred option.

### System wide installation

The system wide installation copies everything that is needed to
`/usr/local/lib/iraf`, making it available for all users of the
computer. For this, do the following command:

	$ sudo make install

This also installs the links required to run iraf or its commands to
`/usr/local/bin`. After the installation finishes, one can directly
start using

	$ mkiraf
	$ ecl

Note that the `mkiraf` command is now optional if a local parameter
storage is not needed. Setting the `iraf` environment variable is not
needed to run the system.

### In-place installation

The in-place installation just configures the built system in its
current location.

	$ make inplace

This also installs the links required to run iraf or its commands to
`~/.iraf/bin`. This directory should be added to your `PATH` variable
so that the IRAF commands can be found by their name. Different to
previous versions, the installation does not touch your login files;
you should edit these files manually to add the path if
needed. Setting the `iraf` environment variable is not needed to run
the system.

## Customization variables

### Build customization

The build using **make** can be customized by a number of environment
variables:

 * **CC** - the C compiler to use (default: **cc**, which is the
   standard C compiler of the system). gcc and clang are both known to
   work.

 * **CFLAGS** - C compiler flags (default `-g -O2`). To
   build a 32-bit IRAF on a 64-bit system, add `-m32`.

 * **CPPFLAGS** - C preprocessor flags (default: empty).

 * **LDFLAGS** - Linker flags (default: empty). To
   build a 32-bit IRAF on a 64-bit system, add `-m32`.

 * **IRAFARCH** - IRAF architecture string. This is used as suffix for
   the binary directory names (i.e. `bin.linux64`, `unix/bin.linux64`,
   `noao/bin.linux64`) If not set, the IRAF architecture is determined
   automatically from the system. If set to an empty string `''`, the
   binary directories are just named `bin`, `unix/bin` and
   `noao/bin`. Note that external packages need to be adjusted to also
   allow suffix-less bin directory names when build in this case.

### Installation customization

The installation using **make install** recognizes the following
environment variables:

 * **prefix** - Common installation prefix (default: `/usr/local`). The
   installation goes to `${prefix}/lib/iraf`, with symlinks for the
   user-callable executables in `${prefix}/bin`, and the manpages
   installed in `${prefix}/share/man`. The `iraf` variable is set to
   `${prefix}/lib/iraf/`.

 * **DESTDIR** - directory name prepended to each installed target
   file. This is useful for package creators, where the files are not
   installed by **make** in their finaly installation.

# Authors of NOAO IRAF

This list was compiled from the IRAF newsletter, web page, and the
revision notes:

 * Ed Anderson
 * Jeanette Barnes
 * David Bell
 * Chris Biemesderfer
 * Todd Boroson
 * Matt Cheselka
 * Mike Cobb
 * Dennis Crabtree
 * Lindsey Davis
 * Michele De La Peña
 * Elwood Downey
 * Jonathan Eisenhamer
 * Mike Fitzpatrick
 * Pedro Gigoux
 * Rick Hill
 * George Jacoby
 * Suzanne Jacoby
 * Dyer Lytle
 * Eric Mandel
 * Phil Massey
 * Tom McGlynn
 * Drew Phillips
 * Fred Romelfanger
 * Steve Rooke
 * Jim Rose
 * Skip Schaller
 * Rob Seaman
 * Peter Shames
 * Richard Shaw
 * Peter Stetson
 * Cliff Stoll
 * Doug Tody
 * Jay Travisano
 * Frank Valdes
 * Phillip Warner
 * Richard Wolff
 * Nelson Zarate

# Contributors from the IRAF community

 * Christian Dersch
 * Linbo He
 * Masato Onodera
 * Ole Streicher
 * Josef Wang
 * Chisato Yamauchi

# IRAF 2.17

The latest NOAO IRAF release is 2.16.1 from October 2013. Intermediate
releases were snapshots based on that latest available source code. These
snapshots were tagged with their release date in the version number.
Changes to the 2.16.1 sources include:

* __All known non-free code removed__

    Although IRAF 2.16.1 was claimed to be "free software", it contained
    source code that is not freely distributable; namely code copied from the
    book ["Numerical Recipes in Fortran"](http://numerical.recipes/). This
    code is replaced with free equivalents. The IRAF community edition is
    [Open Source](https://opensource.org/docs/osd), and as such included in
    Debian.

* __Major bug fixes__

  Many bugs of the 2.16.1 release are fixed. Some of he major ones are:
  
   - Linux systems crashed with "Out of memory" (13 year old bug;
     [2.12 release notes](https://github.com/iraf-community/iraf/blob/9590f4/doc/notes.v212#L1065-L1075))
   
   - `noao.digiphot.photcal.fitparams` failed with a segmentation
     fault on 64-bit systems
     ([iraf.net](https://iraf.net/forum/viewtopic.php?showtopic=1467834))
   
   - The system wide IRAF installation changed the permissions of
     `/tmp/`, creating a major security hole in the system
     (https://iraf-community.github.io/iraf-v216/issues/23)
   
   - On Linux systems, self-compiled tasks gave wrong results
     ([iraf.net](https://iraf.net/forum/viewtopic.php?showtopic=1467841))
   
   - On modern systems, background execution did not work
     ([iraf.net](https://iraf.net/forum/viewtopic.php?showtopic=1467431))

* __Fixes to build and run IRAF on non-historic platforms__

  The original code produced errornous executables when build on Linux
  versions later than 2012, due to some funny hacks in the IRAF
  code. It also did not build from scratch, but required an already
  compiled IRAF version.

* __VO package and vocl removed__

    The VO package, and the vocl shell heavily depend on a number of
    Java jars, where the creation from sources is undocumented. The
    package also uses outdated VO standards. A discussion with Mike
    Fitzpatrick resulted in his plan to [move the VO functionality
    into an external
    package](https://iraf-community.github.io/iraf-v216/issues/90).
    Therefore, no attempt was put into getting these problems fixed,
    and the VO stuff was cut out.  The VOTable functionality, however,
    remains available

* __IRAF ported to other architectures__

    IRAF is now ported to a number of little endian architectures
    (ARM, PowerPC, MIPS, x32, RISC-V64) and operating systems (GNU Hurd and
    FreeBSD).

* __Simple CI test framework added__

    The tests are defined and documented in
    [MarkDown](https://github.com/iraf-community/iraf/blob/main/test/README.md)
    files. Tests are run using Github Actions on Linux and MacOS X platforms.

# Test of Numerical Recipes functions (and their replacements)

Historically, IRAF contains a number of files that contain code from
the book "Numerical Recipes" (NR). The code from this book is not free
(neither as in Free Beer, nor as in Free Speech), and so it is
required to replace this code to make IRAF truly Open Source.

These tests written to ensure that code replacing Numerical Recipes
code will get the same results.

## Simple functions and random numbers

### GASDEV: normally distributed deviate of zero mean and unit var

We test the statistical momentums for the distribution.

File: `test-gasdev.x`
```
task test_gasdev = t_gasdev
procedure t_gasdev ()
real gasdev()
double x, y
double m[4]
int i,j,n
begin
	n=20000000
	do j=1, 4 {
		m[j] = 0
	}
	do i=1, n {
	    x = gasdev(0)
		y = 1
		do j=1, 4 {
		    y = y * x
			m[j] = m[j] + y
	    }
	}
	call printf("Mean     = %f\n")
	call pargd(m[1]/n)
	call printf("Variance = %f\n")
	call pargd(m[2]/n)
	call printf("Skew     = %f\n")
	call pargd(m[3]/n)
	call printf("Kurtosis = %f\n")
	call pargd(m[4]/n)
end
```

Compile it, declare and run as an IRAF task. The following numbers are
the result of the original NR code.

Test options: `decimals=2`
```
cl> softools
cl> xc -x test-gasdev.x -lxtools
cl> task $test_gasdev = test-gasdev.e
cl> test_gasdev
Mean     = 0.0004794365668388
Variance = 1.0000408915199221
Skew     = 0.0013315610063655
Kurtosis = 3.0004513785393642
```

### POIDEV: Poisson deviates for a given mean

File: `test-poidev.x`
```
task test_poidev = t_poidev
procedure t_poidev ()
real poidev()
real x, y, xm
real clgetr()
double m[4]
int i,j,n, start
data start/0/
begin
    xm=clgetr("xm")
	n=1500000
	do j=1, 4 {
		m[j] = 0
	}
	do i=1, n {
	    x = poidev(xm,0) - xm
		y = 1
		do j=1, 4 {
		    y = y * x
			m[j] = m[j] + y
	    }
	}
	if (start == 0) {
		call printf("     xm |       mean |   variance |       skew |   kurtosis\n")
		call printf("--------|------------|------------|------------|------------\n")
		start = 1
	}
	# To avoid accuracy problems with different magnitudes of the value,
	# we normalize all expected values for the moments to 1.0.
	call printf("%7.1f | %10.4f | %10.4f | %10.4f | %10.4f\n")
	call pargr(xm)
	call pargd((xm + m[1]/n) / xm) # expected: xm
	call pargd((m[2]/n) / xm)      # expected: xm
	call pargd((m[3]/n) / xm)      # expected: xm
	call pargd((m[4]/n) / (xm * (1+3*xm))) # expected: xm*(1+3*xm)
end
```

Compile it, declare and run as an IRAF task. The following numbers are
the result of the original NR code.

Test options: `decimals=1`
```
cl> softools
cl> xc -x test-poidev.x -lxtools
cl> task $test_poidev = test-poidev.e
cl> for ( x = 0.7; x < 60; x*=1.55)  test_poidev(x)
     xm |       mean |   variance |       skew |   kurtosis
--------|------------|------------|------------|------------
    0.7 |     0.9986 |     0.9998 |     1.0006 |     1.0014
    1.1 |     0.9991 |     1.0007 |     1.0007 |     1.0012
    1.7 |     1.0000 |     1.0009 |     1.0026 |     1.0021
    2.6 |     1.0006 |     1.0011 |     1.0055 |     1.0013
    4.0 |     1.0000 |     0.9988 |     0.9925 |     0.9951
    6.3 |     1.0004 |     1.0019 |     1.0155 |     1.0040
    9.7 |     1.0000 |     1.0004 |     1.0056 |     1.0011
   15.0 |     0.9999 |     1.0006 |     1.0010 |     0.9995
   23.3 |     1.0001 |     1.0013 |     1.0101 |     1.0027
   36.1 |     1.0001 |     0.9997 |     1.0120 |     1.0041
   56.0 |     0.9999 |     1.0001 |     0.9719 |     1.0023
```

### GAMMLN: natural log of gamma function

File: `test-gammln.x`
```
task test_gammln = t_gammln
procedure t_gammln ()
real gammln()
real x, y
real clgetr()
begin
    x = clgetr("x")
	y = gammln(x)
	call printf("gammln(%4.2f) = %.6f\n")
	call pargr(x)
	call pargr(y)
end
```

Compile it, declare and run as an IRAF task. The following numbers are
the result of the original NR code.

Test options: `decimals=4`
```
cl> softools
cl> xc -x test-gammln.x -lxtools
cl> task $test_gammln = test-gammln.e
cl> for ( x = 0.23; x < 10; x += 0.667)  test_gammln(x)
gammln(0.23) = 1.376194
gammln(0.90) = 0.068650
gammln(1.56) = -0.116568
gammln(2.23) = 0.114094
gammln(2.90) = 0.601105
gammln(3.57) = 1.273372
gammln(4.23) = 2.090656
gammln(4.90) = 3.027074
gammln(5.57) = 4.064579
gammln(6.23) = 5.189871
gammln(6.90) = 6.392745
gammln(7.57) = 7.665116
gammln(8.23) = 9.000430
gammln(8.90) = 10.393257
gammln(9.57) = 11.839035
cl> test_gammln(20)
gammln(20.0) = 39.339886
cl> test_gammln(80)
gammln(80.0) = 269.291107
cl> test_gammln(200)
gammln(200.0) = 857.933655
```

### DAORAN: random number generator RAN2

The DAORAN random number generator is going to be replaced by the
URAND random number generator by D.Knuth.

File: `test-ran2.x`
```
task test_ran2 = t_ran2
procedure t_ran2 ()
real urand()
double x, y
double m[4]
int i,j,n
begin
	n=20000000
	do j=1, 4 {
		m[j] = 0
	}
	do i=1, n {
	    x = urand(0)
		if (x < 0 | x >= 1) {
			call printf("Outlyer: %g\n")
			call pargd(x)
	    }
		x = x - 0.5
		y = 1
		do j=1, 4 {
		    y = y * x
			m[j] = m[j] + y
	    }
	}
	call printf("Mean     = %f\n")
	call pargd(m[1]/n)
	call printf("Variance = %f\n")
	call pargd(m[2]/n)
	call printf("Skew     = %f\n")
	call pargd(m[3]/n)
	call printf("Kurtosis = %f\n")
	call pargd(m[4]/n)
end
```

Compile it, declare and run as an IRAF task. The following numbers are
the result of the original NR code.

Test options: `decimals=4`
```
cl> softools
cl> xc test-ran2.x
cl> task $test_ran2 = test-ran2.e
cl> test_ran2
Mean     = 0.0000018238614310
Variance = 0.0833325982276019
Skew     = 0.0000003118007337
Kurtosis = 0.0124998479272606
```

### AST_JULDAY_TO_DATE: Convert Julian date to calendar date

File: `test-jd.x`
```
task test_jd = t_jd
procedure t_jd ()
double jd
int year, month, day
double t
double clgetd()
begin
    jd = clgetd("jd")
	call ast_julday_to_date(jd, year, month, day, t)
	call printf("JD (%.2f) = %d/%02d/%02d + %5.2f\n")
	call pargd(jd)
	call pargi(year)
	call pargi(month)
	call pargi(day)
	call pargd(t)
end
```

Compile it, declare and run as an IRAF task. The following numbers are
the result of the original NR code.

```
cl> copy noao$astutil/asttools/asttimes.x .
cl> softools
cl> xc -/Wno-shift-op-parentheses test-jd.x asttimes.x
cl> task $test_jd = test-jd.e
cl> for (x = 2450123.7; x < 2450123.7 + 35; x += 2.13)  test_jd(jd=x)
JD (2450123.70) = 1996/02/10 +  4.80
JD (2450125.83) = 1996/02/12 +  7.92
JD (2450127.96) = 1996/02/14 + 11.04
JD (2450130.09) = 1996/02/16 + 14.16
JD (2450132.22) = 1996/02/18 + 17.28
JD (2450134.35) = 1996/02/20 + 20.40
JD (2450136.48) = 1996/02/22 + 23.52
JD (2450138.61) = 1996/02/25 +  2.64
JD (2450140.74) = 1996/02/27 +  5.76
JD (2450142.87) = 1996/02/29 +  8.88
JD (2450145.00) = 1996/03/02 + 12.00
JD (2450147.13) = 1996/03/04 + 15.12
JD (2450149.26) = 1996/03/06 + 18.24
JD (2450151.39) = 1996/03/08 + 21.36
JD (2450153.52) = 1996/03/11 +  0.48
JD (2450155.65) = 1996/03/13 +  3.60
JD (2450157.78) = 1996/03/15 +  6.72
```

## Matrix operations

### LU decomposition of a square matrix

`MW_LUDECOMPOSE`, `LUDCMD`, `LUDCMP`: Replace an NxN matrix A by the LU
decomposition of a rowwise permutation of the matrix.  The LU decomposed
matrix A and the permutation index IX are output.  The decomposition is
performed in place.

`MW_LUBACKSUB`, `LUBKSD`, `LUBKSB`: Solves the set of N linear equations
`A*X=B`.  Here A is input, not as the matrix A but rather as its LU
decomposition, determined by the routine mw_ludecompose.  IX is input as the
permutation vector as returned by `MW_LUDECOMPOSE` & Co.  B is input as the
right hand side vector B, and returns with the solution vector X.

These subroutines are going to be replaced by LAPACK routines

File: `test_ludecompose.x`
```
task test_ludecompose = t_ludecompose

procedure eval_ludecompose (x, y, ndim)
double x[ndim, ndim]
double y[ndim]
int ndim, i, j, istat
double d
pointer sp, ix, m_in, m_out, y_in
begin
    call smark(sp)
    call salloc(ix, ndim, TY_INT)
    call salloc(m_out, ndim*ndim, TY_DOUBLE)
    call salloc(m_in, ndim*ndim, TY_DOUBLE)
    call salloc(y_in, ndim, TY_DOUBLE)
    call achtdd(x, Memd[m_in], ndim*ndim)
    call achtdd(y, Memd[y_in], ndim)

# Test MW_LUDECOMPOSE and MW_INVERTD

    call printf("Original matrix:\n")
    do i = 1, ndim {
        call printf("%d  ")
	call pargi(i)
	do j = 1, ndim {
	    call printf(" %6.3f")
	    call pargd(x[j, i])
	}
	call printf("\n")
    }
    call mw_invertd(Memd[m_in], Memd[m_out], ndim)
    call printf("Inverted matrix:\n")
    do i = 1, ndim {
        call printf("%d  ")
	call pargi(i)
	do j = 1, ndim {
	    call printf(" %6.3f")
	    call pargd(Memd[m_out + (j-1) + (i-1)*ndim])
	}
	call printf("\n")
    }
    call mw_ludecompose(Memd[m_in], Memi[ix], ndim)
    call printf("Decomposed matrix (MW_LUDECOMPOSE):\n")
    do i = 1, ndim {
        call printf("%d %d")
	call pargi(i)
	call pargi(Memi[ix+i-1])
	do j = 1, ndim {
	    call printf(" %6.3f")
	    call pargd(Memd[m_in + (j-1) + (i-1)*ndim])
	}
	call printf("\n")
    }

    call printf("solve [")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargd(y[j])
    }
    call mw_lubacksub(Memd[m_in], Memi[ix], Memd[y_in], ndim)
    call printf("] ==> [")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargd(Memd[y_in + (j-1)])
    }
    call printf("]\n")

    call achtdd(x, Memd[m_in], ndim*ndim)
    call ludcmd(Memd[m_in], ndim, ndim, Memi[ix], d, istat)
    call printf("Decomposed matrix (LUDCMD):\n")
    do i = 1, ndim {
        call printf("%d %d")
	call pargi(i)
	call pargi(Memi[ix+i-1])
	do j = 1, ndim {
	    call printf(" %6.3f")
	    call pargd(Memd[m_in + (j-1) + (i-1)*ndim])
	}
	call printf("\n")
    }

    call achtdd(y, Memd[y_in], ndim)
    call printf("solve [")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargd(y[j])
    }
    call lubksd(Memd[m_in], ndim, ndim, Memi[ix], Memd[y_in])
    call printf("] ==> [")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargd(Memd[y_in + (j-1)])
    }
    call printf("]\n")

    call salloc(m_in, ndim*ndim, TY_REAL)
    call achtdr(x, Memr[m_in], ndim*ndim)
    call ludcmp(Memr[m_in], ndim, ndim, Memi[ix], d)
    call printf("Decomposed matrix (LUDCMB):\n")
    do i = 1, ndim {
        call printf("%d %d")
	call pargi(i)
	call pargi(Memi[ix+i-1])
	do j = 1, ndim {
	    call printf(" %6.3f")
	    call pargr(Memr[m_in + (j-1) + (i-1)*ndim])
	}
	call printf("\n")
    }
    call salloc(y_in, ndim, TY_REAL)
    call achtdr(y, Memr[y_in], ndim)
    call printf("solve [")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargd(y[j])
    }
    call lubksb(Memr[m_in], ndim, ndim, Memi[ix], Memr[y_in])
    call printf("] ==> [")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargr(Memr[y_in + (j-1)])
    }
    call printf("]\n")

    call sfree(sp)
end

procedure t_ludecompose ()
double x1[2,2], y1[2]
data x1 /2., 8., 1., 7./
data y1 /4., 1./
double x2[3,3], y2[3]
data x2 /4., 5., -2., 7., -1., 2., 3., 1., 4./
data y2 /1., 3., 2./
begin
    call eval_ludecompose(x1, y1, 2)
    call eval_ludecompose(x2, y2, 3)
end
```

```
cl> copy pkg$stxtools/lu* .
cl> softools
cl> xc -x test_ludecompose.x lubksb.f  lubksd.f  ludcmd.x  ludcmp.x
cl> task $test_ludecompose = test_ludecompose.e
cl> test_ludecompose
Original matrix:
1    2.000  8.000
2    1.000  7.000
Inverted matrix:
1    1.167 -1.333
2   -0.167  0.333
Decomposed matrix (MW_LUDECOMPOSE):
1 2  8.000  0.250
2 2  7.000 -0.750
solve [  4.000  1.000] ==> [  4.500 -5.000]
Decomposed matrix (LUDCMD):
1 2  8.000  0.250
2 2  7.000 -0.750
solve [  4.000  1.000] ==> [  4.500 -5.000]
Decomposed matrix (LUDCMB):
1 2  8.000  0.250
2 2  7.000 -0.750
solve [  4.000  1.000] ==> [  4.500 -5.000]
Original matrix:
1    4.000  5.000 -2.000
2    7.000 -1.000  2.000
3    3.000  1.000  4.000
Inverted matrix:
1    0.039  0.143 -0.052
2    0.143 -0.143  0.143
3   -0.065 -0.071  0.253
Decomposed matrix (MW_LUDECOMPOSE):
1 2  5.000  0.800 -0.400
2 2 -1.000  7.800  0.205
3 3  1.000  2.200  3.949
solve [  1.000  3.000  2.000] ==> [  0.338 -0.429  0.883]
Decomposed matrix (LUDCMD):
1 2  5.000  0.800 -0.400
2 2 -1.000  7.800  0.205
3 3  1.000  2.200  3.949
solve [  1.000  3.000  2.000] ==> [  0.338 -0.429  0.883]
Decomposed matrix (LUDCMB):
1 2  5.000  0.800 -0.400
2 2 -1.000  7.800  0.205
3 3  1.000  2.200  3.949
solve [  1.000  3.000  2.000] ==> [  0.338 -0.429  0.883]
```

## Fast Fourier transform

### REALFT: FFT of a set of 2N real valued data points

`realfft` Calculates the Fourier Transform of a set of 2N real valued data
points.  Replaces this data by the positive frequency half of it's complex
Fourier Transform.  The real valued first and last components of the complex
transform are returned as elements DATA(1) and DATA(2) respectively.  N must
be an integer power of 2.  This routine also calculates the inverse transform
of a complex array if it is the transform of real data.  (Result in this case
must be multiplied by 1/N). A forward transform is perform for `isign == 1`,
otherwise the inverse transform is computed.

File: `test_realfft.x`
```
task test_realfft = t_realfft

procedure eval_realfft(x, ndim)
int ndim
real x[ndim]
int j
begin
    call printf("FFT input  ")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargr(x[j])
    }
    call realfft(x, ndim/2, 1)
    call printf("\nFFT output ")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargr(x[j])
    }
    call realfft(x, ndim/2, -1)
    call printf("\nInverse    ")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargr(x[j]/(ndim/2))
    }
    call printf("\n")
end

procedure t_realfft ()
real x[8]
data x /1.0, 2.0, 1.0, -1.0, 1.5, 1.0, 0.5, 1.0/
begin
    call eval_realfft(x, 8)
end
```

```
cl> copy noao$rv/numrep.x .
cl> softools
cl> xc -x test_realfft.x numrep.x
cl> task $test_realfft = test_realfft.e
cl> test_realfft
FFT input    1.000  2.000  1.000 -1.000  1.500  1.000  0.500  1.000
FFT output   7.000  1.000  1.621 -0.207  1.000  3.000 -2.621 -1.207
Inverse      1.000  2.000  1.000 -1.000  1.500  1.000  0.500  1.000
```

### TWOFFT: complex FFTs of two input real arrays

Given two real input arrays, each of length N, this routine calls `cc_four1()`
and returns two complex output arrays, FFT1 and FFT2, each of complex length N
(i.e. real length 2*N), which contain the discrete Fourier transforms of the
respective `DATA`s.  As always, N must be an integer power of 2.

File: `test_twofft.x`
```
task test_twofft = t_twofft

procedure eval_twofft(x1, x2, ndim)
int ndim
real x1[ndim], x2[ndim]
int j
pointer sp, y1, y2

begin
    call smark(sp)
    call salloc(y1, 2*ndim, TY_REAL)
    call salloc(y2, 2*ndim, TY_REAL)

    call printf("in 1 ")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargr(x1[j])
    }
    call printf("\nin 2 ")
    do j = 1, ndim {
        call printf(" %6.3f")
        call pargr(x2[j])
    }
    call twofft(x1, x2, Memr[y1], Memr[y2], ndim)
    call printf("\nout 1")
    do j = 1, ndim {
        call printf(" %6.3f + %6.3fi,")
        call pargr(Memr[y1 + 2*j-2])
        call pargr(Memr[y1 + 2*j-1])
    }
    call printf("\nout 2")
    do j = 1, ndim {
        call printf(" %6.3f + %6.3fi,")
        call pargr(Memr[y2 + 2*j-2])
        call pargr(Memr[y2 + 2*j-1])
    }
    call printf("\n")

    call sfree(sp)
end

procedure t_twofft ()
real x1[8]
real x2[8]
data x1 /1.0, 2.0, 1.0, -1.0, 1.5, 1.0, 0.5, 1.0/
data x2 /0.9, 7.5, 6.5, 5.0, 7.5, 5.2, 5.1, 7.7/
begin
    call eval_twofft(x1, x2, 8)
end
```

Test options: `decimals=3`
```
cl> softools
cl> xc -x test_twofft.x numrep.x
cl> task $test_twofft = test_twofft.e
cl> test_twofft
in 1   1.000  2.000  1.000 -1.000  1.500  1.000  0.500  1.000
in 2   0.900  7.500  6.500  5.000  7.500  5.200  5.100  7.700
out 1  7.000 +  0.000i,  1.621 + -0.207i,  1.000 +  3.000i, -2.621 + -1.207i,  1.000 +  0.000i, -2.621 +  1.207i,  1.000 + -3.000i,  1.621 +  0.207i,
out 2 45.400 +  0.000i, -3.064 +  1.117i, -3.200 +  0.000i, -10.14 + -1.683i, -5.400 +  0.000i, -10.14 +  1.683i, -3.200 + 0.000i, -3.064 + -1.117i,
```

## Interpolation routines for `trebin`

This covers `tucspl`, `tuispl`, `tuhunt`, and `tuispl`.

These are just the [`trebin` test in `nttools`](nttools.md), with an
extended resolution:

File: `rebin.tbl`
```
#c lambda d %6.2f nm
#c Y d %6.3f pixels
453.02   5.873
464.60  17.939
603.04  39.843
625.08  68.326
647.27  44.617
723.45  68.226
730.31  36.557
764.82  42.797
784.33   2.650
862.67  38.502
```

### TUCSPL/TUISPL: Spline interpolation

```
cl> trebin rebin.tbl rebspl.tbl lambda 450. 550. 10. function=spline
rebin.tbl --> rebspl.tbl
cl> type rebspl.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
450.00  INDEF
460.00 13.514
470.00 22.065
480.00 26.780
490.00 28.293
500.00 27.306
510.00 24.524
520.00 20.653
530.00 16.395
540.00 12.456
550.00  9.540
cl> trebin rebin.tbl rebsplu.tbl lambda 860. 870. 10. function=spline
rebin.tbl --> rebsplu.tbl
cl> type rebsplu.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
860.00 33.545
870.00  INDEF
```

### TUIEP3: Poly3 interpolation


```
cl> trebin rebin.tbl rebpol.tbl lambda 450. 550. 10. function=poly3
rebin.tbl --> rebpol.tbl
cl> type rebpol.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
450.00  INDEF
460.00 13.681
470.00 22.107
480.00 27.688
490.00 30.876
500.00 32.122
510.00 31.879
520.00 30.599
530.00 28.733
540.00 26.734
550.00 25.052
cl> trebin rebin.tbl rebpolu.tbl lambda 860. 870. 10. function=poly3
rebin.tbl --> rebpolu.tbl
cl> type rebpolu.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
860.00 22.331
870.00  INDEF
```

# Writing own procedures

## SPP tasks

This example is taken from a the [slides of a talk by Rob
Seaman](https://iraf-community.github.io/doc/spp_intro.pdf).

Take a simple program from the test directory:

File: `hello.x`
```
# HELLO -- Sample program introducing SPP.
task hello = t_hello_world
procedure t_hello_world ()
begin
    call printf ("Hello,world!\n")
end
```

Compile it, declare and run as an IRAF task

```
cl> softools
cl> xc hello.x
cl> task $hello = hello.e
cl> hello
Hello, world!
```

## SPP debugging info

This is a test for [#98](https://iraf-community.github.io/iraf-v216/issues/98).

XC is able to keep the line number of the main file, for
debugging. This is done with the `-x` flag:

```
cl> softools
cl> xc -x -f hello.x
cl> system
cl> tail hello.f nlines=22 | head nlines=11
      subroutine thelld ()
      integer*2 st0001(14)
      save
      integer iyy
      data (st0001(iyy),iyy= 1, 8) / 72,101,108,108,111, 44,119,111/
      data (st0001(iyy),iyy= 9,14) /114,108,100, 33, 10, 0/
#line 5 "hello.x"
         call xprinf(st0001)
100      call zzepro
         return
      end
```

## Machine dependent limits

This is a test for [#106](https://iraf-community.github.io/iraf-v216/issues/106).

Some limits are defined by the `R1MACH` and `D1MACH` functions. We
just test some very basic properties of these numbers:

File: `machtest.x`
```
task machtest = t_machtest
procedure t_machtest ()
real r1mach()
double d1mach()
int i
int failures
begin

# Check that all values are positive numbers

    failures = 0
    do i=1, 5 {
        if (! (r1mach(i) == r1mach(i))) {
            call printf("R1MACH(%d) is not a number\n")
	         call pargi(i)
            failures = failures + 1
        } else if (r1mach(i) <= 0) {
            call printf("R1MACH(%d) is not positive\n")
	         call pargi(i)
            failures = failures + 1
	}
    }
    call printf("\n")
    do i=1, 5 {
        if (! (d1mach(i) == d1mach(i))) {
            call printf("D1MACH(%d) is not a number\n")
	         call pargi(i)
            failures = failures + 1
        } else if (d1mach(i) <= 0) {
            call printf("D1MACH(%d) is not positive\n")
	         call pargi(i)
            failures = failures + 1
	}
    }
    if (failures == 0) {
        call printf("Simple consistency check passed.\n")
    } else {
        call printf("Simple consistency check has %d failures\n")
        call pargi(failures)
    }
end
```
Running this should give:

```
cl> softools
cl> xc machtest.x
cl> task $machtest = machtest.e
cl> machtest

Simple consistency check passed.
```

## ILP64 memory model

This is a test for [#107](https://iraf-community.github.io/iraf-v216/issues/107).

On 64-bit machines, IRAF uses the ILP64 model that makes normal SPP
`integer` 8 byte wide. `real` values however remain at 4 byte. This
should be recognized by the Fortran compiler when doing
`equivalence`.

File: `test_equiv.x`
```
task test_equiv = t_equiv
procedure t_equiv ()
real	fval, gval
int	ival
%	equivalence (fval, ival)
begin
    ival = 0
    gval = 1.2345e06
    call printf("Should be zero: %d\n")
    call pargi(ival)

    gval = 0.
    ival = 998765123423
    call printf("Should be zero: %g\n")
    call pargr(gval)
end
```

In that example, setting `ival` should not affect the independently
defined variable `gval` and vice versa:

```
cl> softools
cl> xc test_equiv.x
cl> task $test_equiv = test_equiv.e
cl> test_equiv
Should be zero: 0
Should be zero: 0.
```

## Plain FORTRAN files

The xc compiler should be able to compile plain FORTRAN files (with
FORTRAN I/O) as well. The f2c compiler used in 2.17, 2.17.1, 2.18
cannot compile this. See [discussion
#369](https://github.com/orgs/iraf-community/discussions/369).

File: `test_io.f`
```
      PROGRAM TESTIO
      OPEN (11, FILE='testio.dat')
      WRITE (11, *) 'Hello world'
      CLOSE (11)
      END
```

```
cl> softools
cl> xc -h test_io.f
cl> !./test_io.e
cl> type testio.dat
Hello world
```

## Loop optimization

This is a test for [#60](https://iraf-community.github.io/iraf-v216/issues/60).

With the original 2.16.1 release, there is a problem with loop
optimization on "newer" platforms. A simple example task is here:

File: `otest.x`
```
task otest = t_otest
procedure t_otest ()
int i
pointer p, sp
begin
    call smark(sp)
    call salloc(p, 4, TY_DOUBLE)
    do i = 1, 4
        memd[p+i-1] = i

    do i = 1, 4 {
        call printf("%d == %g\n")
	    call pargi(i)
        call pargd(memd[p+i-1])
    }

    call sfree(sp)
end
```

All this code does is to allocate a temporary array with four
integers, fill each position with its index, and then print out the
integers. Compile it, declare the task in (e)cl and run it:

```
cl> softools
cl> xc otest.x
cl> task $otest = otest.e
cl> otest
1 == 1.
2 == 2.
3 == 3.
4 == 4.
```

See issue #73 for the bug report.

## The `generic` preprocessor

The `generic` preprocessor is used to translate generic source code (code
written to work for any datatype) into type dependent source code,
suitable for compilation and insertion into a library.  The generic source
is translated for each datatype, producing a type dependent copy of the
source code for each datatype.

One way to operate `generic` is to embed `$for` and `$endfor`
directives into the source file. The example is taken from the
`sys/vops` subdir:

File: `aabs.gx`
```
$for (dr)
procedure aabs$t (a, b, npix)
PIXEL	a[ARB], b[ARB]
int	npix, i
begin
	do i = 1, npix
	    b[i] = abs(a[i])
end
$endfor
```

which produces the following single output file:

```
cl> softools
cl> generic aabs.gx -o aabs.x
cl> dir aabs*
aabs.gx aabs.x 
cl> type aabs.x

procedure aabsd (a, b, npix)
double	a[ARB], b[ARB]
int	npix, i
begin
	do i = 1, npix
	    b[i] = abs(a[i])
end

procedure aabsr (a, b, npix)
real	a[ARB], b[ARB]
int	npix, i
begin
	do i = 1, npix
	    b[i] = abs(a[i])
end

```

One may also specify the types on the command line of `generic`, like
for this input file:

File: `alim.gx`
```
procedure alim$t (a, npix, minval, maxval)
PIXEL   a[ARB], minval, maxval, value
int     npix, i
begin
        minval = a[1]
        maxval = a[1]
        do i = 1, npix {
            value = a[i]
            $if (datatype == x)
                if (abs(value) < abs(minval))
                    minval = value
                else if (abs(value) > abs(maxval))
                    maxval = value
            $else
                if (value < minval)
                    minval = value
                else if (value > maxval)
                    maxval = value
            $endif
        }
end
```

It produces one output file per type:

```
cl> softools
cl> generic -t  silrdx alim.gx
cl> dir alim*
alim.gx   alimd.x   alimi.x   aliml.x   alimr.x   alims.x   alimx.x   
cl> type alimi.x
procedure alimi (a, npix, minval, maxval)
int   a[ARB], minval, maxval, value
int     npix, i
begin
        minval = a[1]
        maxval = a[1]
        do i = 1, npix {
            value = a[i]
            if (value < minval)
                minval = value
            else if (value > maxval)
                maxval = value
        }
end
cl> type alimr.x
procedure alimr (a, npix, minval, maxval)
real   a[ARB], minval, maxval, value
int     npix, i
begin
        minval = a[1]
        maxval = a[1]
        do i = 1, npix {
            value = a[i]
                if (value < minval)
            minval = value
                else if (value > maxval)
            maxval = value
        }
end
```

The `generic` has a specific handling for `INDEF`: `INDEF` and
`IS_INDEF` are replaced with the ones specific for the processed data
type, while `INDEFR` etc. are kept as they are. Also, `$if` can limit
the preprocessing.

For example,

File: `geofxy.gx`
```
$for (rd)
procedure geo_fxy$t(fit, sf1)
pointer fit, sf1
begin
$if (datatype == r)
        if (IS_INDEFD(GM_XO(fit)))
            call gsset (sf1, GSXREF, INDEF)
$else
        call gsset (sf1, GSXREF, INDEF)
$endif
end
$endfor
```

which produces:

```
cl> softools
cl> generic geofxy.gx -o geofxy.x
cl> type geofxy.x

procedure geo_fxyr(fit, sf1)
pointer fit, sf1
begin
        if (IS_INDEFD(GM_XO(fit)))
            call gsset (sf1, GSXREF, INDEFR)
end

procedure geo_fxyd(fit, sf1)
pointer fit, sf1
begin
        call gsset (sf1, GSXREF, INDEFD)
end

```

# imcoords - Image coordinates package

These tests were collected from the "EXAMPLES" section in the help of
the commands in the "images" package.

## ccfind - Find catalog sources in an image

File: `wpix.coords`
```
13:29:47.297  47:13:37.52
13:29:37.406  47:09:09.18
13:29:38.700  47:13:36.23
13:29:55.424  47:10:05.15
13:30:01.816  47:12:58.79
```

```
cl> imcopy dev$wpix wpix
dev$wpix -> wpix
cl> hedit wpix equinox 1950.0 verify- add+
add wpix,equinox = 1950.
wpix updated
cl> ccfind wpix.coords wpix.match wpix usewcs+

Input File: wpix.coords  Output File: wpix.match
    Image: wpix  Wcs: 
Insystem: j2000  Coordinates: equatorial FK5
    Equinox: J2000.000 Epoch: J2000.00000000 MJD: 51544.50000
Refsystem: wpix.fits logical  Projection: TAN  Ra/Dec axes: 1/2
    Coordinates: equatorial FK4 Equinox: B1950.000
    Epoch: B1987.25767884 MJD: 46890.00000
Located 5 objects in image wpix

cl> type wpix.match

# Input File: wpix.coords  Output File: wpix.match
#     Image: wpix  Wcs: 
# Insystem: j2000  Coordinates: equatorial FK5
#     Equinox: J2000.000 Epoch: J2000.00000000 MJD: 51544.50000
# Refsystem: wpix.fits logical  Projection: TAN  Ra/Dec axes: 1/2
#     Coordinates: equatorial FK4 Equinox: B1950.000
#     Epoch: B1987.25767884 MJD: 46890.00000

13:29:47.297  47:13:37.52     327.504    410.379
13:29:37.406  47:09:09.18     465.503     62.101
13:29:38.700  47:13:36.23     442.013    409.654
13:29:55.424  47:10:05.15     224.351    131.200
13:30:01.816  47:12:58.79     134.373    356.327
```

## ccget - Extract objects from a text file catalog

```
cl> ccget noao$digiphot/photcal/catalogs/nlandolt.dat output 03:55:00.0 0:00:00 0.2 0.15 outsystem="j2000"

Catalog File: noao$digiphot/photcal/catalogs/nlandolt.dat  Output File: output
Field System: j2000  Coordinates: equatorial FK5
    Equinox: J2000.000 Epoch: J2000.00000000 MJD: 51544.50000
Catalog System: j2000  Coordinates: equatorial FK5
    Equinox: J2000.000 Epoch: J2000.00000000 MJD: 51544.50000
Output System: j2000  Coordinates: equatorial FK5
    Equinox: J2000.000 Epoch: J2000.00000000 MJD: 51544.50000
#
# Field Center:  3:55:00.0 0:00:00.0  Width: 0.2000 0.1500
# Field Limits: 3:54:36.0 3:55:24.0  -0:04:30.0 0:04:30.0
#
      95_62  03:55:00.0   -0:02:55  13.538  1.355  1.181  0.742  0.685  1.428  22  11  0.0030 0.0053 0.0136 0.0019 0.0019 0.0028
     95_137  03:55:04.0    0:03:33  14.440  1.457  1.136  0.893  0.845  1.737   1   1  0.0000 0.0000 0.0000 0.0000 0.0000 0.0000
     95_139  03:55:05.0    0:03:13  12.196  0.923  0.677  0.562  0.476  1.039   3   2  0.0017 0.0046 0.0191 0.0023 0.0017 0.0035
     95_142  03:55:09.0    0:01:19  12.927  0.588  0.097  0.371  0.375  0.745  22  11  0.0030 0.0030 0.0036 0.0019 0.0017 0.0028
```

## ccmap - Compute image plate solutions using matched coordinate lists

File: `coords`
```
13:29:47.297  47:13:37.52  327.50  410.38
13:29:37.406  47:09:09.18  465.50   62.10
13:29:38.700  47:13:36.23  442.01  409.65
13:29:55.424  47:10:05.15  224.35  131.20
13:30:01.816  47:12:58.79  134.37  356.33
```

```
cl> imcopy dev$pix pix
dev$pix -> pix
cl> ccmap coords coords.db image=pix xcol=3 ycol=4 lngcol=1 latcol=2 inter- verb+
Refsystem: j2000  Coordinates: equatorial FK5
    Equinox: J2000.000 Epoch: J2000.00000000 MJD: 51544.50000
Insystem: j2000  Coordinates: equatorial FK5
    Equinox: J2000.000 Epoch: J2000.00000000 MJD: 51544.50000

Coords File: coords  Image: pix
    Database: coords.db  Solution: pix
Coordinate mapping status
    XI fit ok.  ETA fit ok.
    Ra/Dec or Long/Lat fit rms: 0.229  0.241   (arcsec  arcsec)
Coordinate mapping parameters
    Sky projection geometry: tan
    Reference point: 13:29:48.130  47:11:53.44  (hours  degrees)
    Reference point: 318.717  273.981  (pixels  pixels)
    X and Y scale: 0.764  0.767  (arcsec/pixel  arcsec/pixel)
    X and Y axis rotation: 179.110  358.958  (degrees  degrees)
Wcs mapping status
    Ra/Dec or Long/Lat wcs rms: 0.229  0.241   (arcsec  arcsec)
```


## ccsetwcs - Create an image celestial wcs from the ccmap plate solution

Test options: `decimals=5`
```
cl> ccsetwcs pix coords.db pix 
Image: pix  Database: coords.db  Solution: pix
Coordinate mapping parameters
    Sky projection geometry: tan
    Reference point: 13:29:48.130  47:11:53.44  (hours   degrees)
    Ra/Dec logical image axes: 1  2
    Reference point: 318.717  273.981  (pixels  pixels)
    X and Y scale: 0.764  0.767  (arcsec/pixel  arcsec/pixel)
    X and Y coordinate rotation: 179.110  358.958  (degrees  degrees)
Updating image header wcs
cl> imheader pix l+ | match ^CTYPE
CTYPE1  = 'RA---TAN'
CTYPE2  = 'DEC--TAN'
cl> imheader pix l+ | match ^CRVAL
CRVAL1  =     202.450540982385
CRVAL2  =     47.1981766432095
cl> imheader pix l+ | match ^CRPIX
CRPIX1  =     318.717314475376
CRPIX2  =     273.980754205693
cl> imheader pix l+ | match ^CD
CD1_1   =  -2.1224478467185E-4
CD1_2   =  -3.8721154990263E-6
CD2_1   =  -3.2966623625400E-6
CD2_2   =  2.12934727219336E-4
cl> imheader pix l+ | match ^LTM
LTM1_1  =                   1.
LTM2_2  =                   1.
cl> imheader pix l+ | match ^WAT
WAT0_001= 'system=image'
WAT1_001= 'wtype=tan axtype=ra'
WAT2_001= 'wtype=tan axtype=dec'
cl> imheader pix l+ | match ^WCSDIM
WCSDIM  =                    2
```

## ccstd - Transform to and from standard astrometric coordinates

Compute the standard coordinates in arcseconds per pixel given a list
of pixel and equatorial coordinates and the position of the reference
point in pixel and equatorial coordinates.

```
cl> ccstd coords STDOUT "" xref=256.5 yref=256.5 lngref=13:29:48.1 latref = 47:11:53.4 xcol=3 ycol=4 lngcol=1 latcol=2
  -8.180   104.120    71.000   153.880
-109.087  -164.189   209.000  -194.400
 -95.753   102.854   185.510   153.150
  74.688  -108.235   -32.150  -125.300
 139.745    65.441  -122.130    99.830
```

## cctran - Transform coordinate lists using the ccmap plate solution

```
cl> cctran coords STDOUT coords.db coords xcol=3 ycol=4 lngformat=%0.3h latformat=%0.2h
13:29:47.297  47:13:37.52  327.50  410.38
13:29:37.406  47:09:09.18  465.50   62.10
13:29:38.700  47:13:36.23  442.01  409.65
13:29:55.424  47:10:05.15  224.35  131.20
13:30:01.816  47:12:58.79  134.37  356.33
```

## hpctran - Convert between HEALPix row and spherical coordinate

Test options: `decimals=7`
```
cl> hpctran lng=50.12 lat=-33.45
2298092 50.12 -33.45000000000001
```

## imcctran - Transform image header from one celestial wcs to another

Test options: `decimals=5`
```
cl> imcctran pix j1975.0
INPUT IMAGE: pix
Insystem: pix logical  Projection: TAN  Ra/Dec axes: 1/2
    Coordinates: equatorial FK5 Equinox: J2000.000
    Epoch: J1987.25667351 MJD: 46890.00000
Outsystem: j1975.0  Coordinates: equatorial FK5
    Equinox: J1975.000 Epoch: J1975.00000000 MJD: 42413.25000
Crval1,2: 202:27:01.9, 47:11:53.4 -> 202:11:14.9, 47:19:37.0 dd:mm:ss.s
    Scaling: Xmag: 0.999996 Ymag: 1.000004 Xrot: 359.922 Yrot: 359.922 degrees
    Rms: X fit: 1.209002E-5 pixels  Y fit: 1.286608E-5 pixels

```

## mkcwcs - Make or update a simple celestial wcs

Test options: `decimals=5`
```
cl> mkcwcs new ra=1:20:23.1 dec=-12:11:13 scale=0.25
cl> imheader new l+ | match ^CTYPE
CTYPE1  = 'RA---TAN'
CTYPE2  = 'DEC--TAN'
cl> imheader pix l+ | match ^CRVAL
CRVAL1  =     202.187467189328
CRVAL2  =     47.3269441654267
cl> imheader pix l+ | match ^CRPIX
CRPIX1  =     318.717314475376
CRPIX2  =     273.980754205693
cl> imheader pix l+ | match ^CD
CD1_1   =  -2.1224907057248E-4
CD1_2   =  -3.5826140669847E-6
CD2_1   =  -3.0080993807270E-6
CD2_2   =  2.12939794761845E-4
cl> imheader pix l+ | match ^LTM
LTM1_1  =                   1.
LTM2_2  =                   1.
cl> imheader pix l+ | match ^WAT
WAT0_001= 'system=image'
WAT1_001= 'wtype=tan axtype=ra'
WAT2_001= 'wtype=tan axtype=dec'
cl> imheader pix l+ | match ^WCSDIM
WCSDIM  =                    2
```

## mkcwwcs - Make or update a simple celestial/wavelength 3D wcs

Test options: `decimals=5`
```
cl> mkcwwcs new3d ra=1:20:23.1 dec=-12:11:13 wave=5500.  scale=0.25 wscale=1.23
cl> imheader new3d l+ | match ^CTYPE
CTYPE1  = 'RA---TAN'
CTYPE2  = 'DEC--TAN'
CTYPE3  = 'LINEAR  '
cl> imheader pix l+ | match ^CRVAL
CRVAL1  =     202.187467189328
CRVAL2  =     47.3269441654267
cl> imheader pix l+ | match ^CRPIX
CRPIX1  =     318.717314475376
CRPIX2  =     273.980754205693
cl> imheader pix l+ | match ^CD
CD1_1   =  -2.1224907057248E-4
CD1_2   =  -3.5826140669847E-6
CD2_1   =  -3.0080993807270E-6
CD2_2   =  2.12939794761845E-4
cl> imheader pix l+ | match ^LTM
LTM1_1  =                   1.
LTM2_2  =                   1.
cl> imheader pix l+ | match ^WAT
WAT0_001= 'system=image'
WAT1_001= 'wtype=tan axtype=ra'
WAT2_001= 'wtype=tan axtype=dec'
cl> imheader pix l+ | match ^WCSDIM
WCSDIM  =                    2
```

## starfind - Automatically detect stellar objects in a list of images

```
cl> starfind dev$wpix default 2.5 500. wcs=world wxf="%12.2H" wyf="%12.1h" verb+

Image: dev$wpix.imh  Output: wpix.obj.1
Detection Parameters
    Hwhmpsf: 2.500 (pixels)  Threshold: 500. (ADU) Npixmin: 5
    Datamin: INDEF (ADU)  Datamax: INDEF (ADU)
    Fradius: 2.500 (HWHM)  Sepmin: 5.000 (HWHM)

     465.647    62.086  13:27:31.21   47:24:45.1  -10.72    110   1.61  0.011  177.9   0.644      1
     379.169    66.818  13:27:37.74   47:24:48.8  -11.27    115   1.57  0.039  102.3   0.628      2
     224.349   131.181  13:27:49.42   47:25:38.1  -10.95    114   1.60  0.072  164.0   0.638      3
     372.707   156.520  13:27:38.22   47:25:57.5  -10.61     99   2.35  0.165   70.2   0.938      4
     347.666   188.732  13:27:40.11   47:26:22.2  -13.11    121   1.58  0.019  127.7   0.633      5
      59.511   226.086  13:28:01.87   47:26:50.8   -9.95     84   1.59  0.087   28.3   0.636      6
     347.579   231.578  13:27:40.12   47:26:55.0   -9.86     71   1.38  0.071  129.3   0.550      7
     257.838   258.956  13:27:46.89   47:27:16.0  -12.72    120   2.43  0.073  125.3   0.972      8
     404.525   274.207  13:27:35.81   47:27:27.7  -11.28     97   1.54  0.074   71.8   0.618      9
     442.007   409.617  13:27:32.98   47:29:11.4  -11.04    119   1.60  0.021  133.2   0.639     10
     162.633   434.238  13:27:54.09   47:29:30.3  -10.34    112   2.07  0.044   61.5   0.829     11
     507.767   445.718  13:27:28.00   47:29:39.0   -9.81    113   1.63  0.043  154.9   0.651     12

Selection Parameters
    Maglo: INDEF  Maghi: INDEF
    Roundlo: 0.000  Roundhi: 0.200
    Sharplo: 0.500  Sharphi: 2.000
```

# imfilter - Image filtering package

## boxcar - Boxcar smooth a list of 1 or 2-D images

Smooth an image using a 3 by 3 smoothing box and nearest neighbor
boundary extension.

```
cl> boxcar dev$pix pix.box 3 3
cl> imstat pix.box
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              pix.box    262144     107.9      119.       30.    12240.
```

## convolve - Convolve a list of 1 or 2-D images with a rectangular filter

Convolve an image with a kernel using string entry mode and wrap
around boundary extension.

See https://github.com/iraf/iraf-v216/issues/109

Test options: `xfail`
```
cl> convolve dev$pix pix.cnv "1. 1. 1.; 1. 0. 1.; 1. 1. 1." bound=wrap
cl> imstat pix.cnv
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              pix.cnv    262144     860.5     804.5   -30822.    32055.
```

```
cl> chpixtype dev$pix rpix real
Image: dev$pix (short) -> Image: rpix (real)
cl> convolve rpix rpix.cnv "1. 1. 1.; 1. 0. 1.; 1. 1. 1." bound=wrap
cl> imstat rpix.cnv
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
             rpix.cnv    262144     866.5     942.5      230.    90232.
```


## fmedian - Quantize and box median filter a list of 1D or 2D images

Median filter the test image dev$pix rejecting any pixels < 5 or
greater than 19935 from the medianing process.

```
cl> fmedian dev$pix pix.fme 5 5 hmin=-1 hmax=20000 zmin=-1.0 zmax=20000 zloreject=5 zhireject=20000
5x5 Box median filter dev$pix to pix.fme
    Pixels < 5. or > 20000. excluded from the median filter
cl> imstat pix.fme
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              pix.fme    262144     106.4     93.33       36.     4568.
```

## fmode - Quantize and box modal filter a list of 1D or 2D images

Modal filter the test image dev$pix rejecting any pixels < 5 or
greater than 19935 from the mode computing process.

```
cl> fmode dev$pix pix.fmo 5 5 hmin=-1 hmax=20000 zmin=-1.0 zmax=20000 zloreject=5 zhireject=20000
5x5 Box modal filter dev$pix to pix.fmo
    Pixels < 5. or > 20000. excluded from the modal filter
cl> imstat pix.fmo
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              pix.fmo    262144     102.2     96.15    -6312.     3280.
```

## frmedian - Quantize and ring median filter a list of 1D or 2D images

Median filter a 16 bit CCD image using a circular ring filter with an
inner radius of 4 pixels and a width of 1 pixel.
    
```
cl> frmedian dev$pix pix.frmed 4.0 5.0 hmin=-32768 hmax=32767 zmin=-32768.  zmax=32767.
Ring rin=4.0 rout=5.0 median filter dev$pix to pix.frmed
cl> imstat pix.frmed
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
            pix.frmed    262144     104.2     80.83       36.     1738.
```

## frmode - Quantize and ring modal filter a list of 1D or 2D images

Modal filter a 16 bit CCD image using a circular ring filter with an
inner radius of 4 pixels and a width of 1 pixel.

```
cl> frmode dev$pix pix.frmo 4.0 5.0 hmin=-32768 hmax=32767 zmin=-32768. zmax=32767.
Ring rin=4.0 rout=5.0 modal filter dev$pix to pix.frmo
cl> imstat pix.frmo
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
             pix.frmo    262144     95.38     94.47    -4119.     1743.
```

## gauss - Convolve a list of 1 or 2-D images with an elliptical Gaussian

Convolve an image with an elliptical Gaussian function whose sigma in
the major and minor axis direction is 2.0 and 1.5 respectively, and
whose position angle is 45 degrees, using wrap around boundary
extension. In this case the full 2D kernel is used by default.

```
cl> gauss dev$pix pix.gau 2.0 ratio=.75 theta=45. bound=wrap
cl> imstat pix.gau
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              pix.gau    262144     107.8     105.3       36.     6151.
```

## gradient - Convolve a list of 1 or 2-D images with a gradient operator

Calculate the gradient in the 180 degree direction using nearest
neighbor boundary extension.

```
cl> gradient dev$pix pix.odeg 180
cl> imstat pix.odeg fields="image,npix,stddev,min,max"
#               IMAGE      NPIX    STDDEV       MIN       MAX
             pix.odeg    262144     42.85    -6983.     6529.
```

## laplace - Laplacian filter a list of 1 or 2-D images

Convolve an image with the Laplacian filter xyall using nearest
neighbor boundary extension. The result quality is a bit bad, so we
limit the precision to one digit.

Test options: `decimals=1`
```
cl> laplace dev$pix pix.lap laplace=xyall
cl> imstat pix.lap fields="image,npix,stddev,min,max"
#               IMAGE      NPIX    STDDEV       MIN       MAX
              pix.lap    262144     77.22   -20349.     4191.
```

## median - Median box filter a list of 1D or 2D images

Median filter an image using a 5 by 5 window and nearest pixel
boundary extension.
    
```
cl> median dev$pix pix.5by5 5 5
5x5 Box median filter dev$pix to pix.5by5
cl> imstat pix.5by5
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
             pix.5by5    262144     106.4     93.33       36.     4568.
```

## mode - Modal box filter a list of 1D or 2D images

Modal filter an image using a 3 by 3 window and constant boundary
extension.

```
cl> mode dev$pix pix.3by3 3 3 boun=const const=0.
3x3 Box modal filter dev$pix to pix.3by3
cl> imstat pix.3by3
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
             pix.3by3    262144     105.8      101.    -3482.    10975.
```

## rmedian - Ring median filter a list of 1D or 2D images

Median filter the test image dev$pix rejecting any pixels < 5 or
greater than 19935 from the medianing process using a circular filter
of outer radius 5.0.
    
```
cl> rmedian dev$pix pix.rme 0.0 5.0 zloreject=5 zhireject=19935
Ring rin=0.0 rout=5.0 median filter dev$pix to pix.rme
    Pixels < 5. or > 19935. excluded from the median filter
cl> imstat pix.rme
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              pix.rme    262144     105.2     84.41       37.     2110.
```

## rmode - Ring modal filter a list of 1D or 2D images

Modal filter the test image dev$pix rejecting any pixels < 5 or
greater than 19935 from the modal filter using a circular filter of
outer radius 5.0.
    
```
cl> rmode dev$pix pix.rmo 0.0 5.0 zloreject=5 zhireject=19935
Ring rin=0.0 rout=5.0 modal filter dev$pix to pix.rmo
    Pixels < 5. or > 19935. excluded from the modal filter
cl> imstat pix.rmo
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              pix.rmo    262144     98.58     90.65    -2937.     1144.
```

# IRAF Unit Test Syntax

## Introduction

All tests are given in
[Markdown](https://guides.github.com/features/mastering-markdown/)
format, where the code blocks are usually executed. The code block
contains CL commands as well as the expected output. In principle, one
can just cut and paste a sample session into the code blocks.

With this example code block, one IRAF command is executed and the
result is compared with the given output:

```
cl> imstat dev$pix
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              dev$pix    262144     108.3     131.3       -1.    19936.
```

Each Markdown file starts the execution within an empty directory that
is temporaily created, and destroyed after the test. If test data is
needed, they are usually taken from the IRAF source code.


### Additional text files

Sometimes, additional (text) files are required to run the test. These
may be given as a special code block that is preceded with `File:` and
the file name in backticks:

File: `sample.txt`
```
 7.311
 6.123
24.829
16.696
29.923
```

This file is then created within the working directory and can be used for
tests:

```
cl> dir
sample.txt
cl> type sample.txt
 7.311
 6.123
24.829
16.696
29.923
```


### Test options

Options for individual tests can be given by preceding the code block
with a line

Test options: `opt1 opt2=arg`

The individual options are separated by space. Options may have
additional parameters, as `opt2` in the line above.


#### Handling floating point output

Due to limited processing accuracy, the result of IRAF tasks may
differ slightly between different platforms, which would break a
direct string comparison of expected and actual output. To deal with
this, the required accuracy can be set by preceding the code block
with a line containing the required accuracy. For example:

Test options: `decimals=7`
```
cl> =1.0/3.0
0.33333331
```

When this option is used, the expected and the actual output are
parsed for floating point numbers, which are reformatted for the
specified accuracy.

#### Expected failures

Sometimes, it is expected for an individual test to fail. This can be
switched on with the `xfail` option:

Test options: `xfail`
```
cl> =2*2
6
```

#### Skipping tests

One can also skip individual code blocks, f.e. if they don't contain a
test, of if the test is known to never return.

Test options: `skip`
```
cl> while (1==1) i=1
```

#### Testing only specified archs

To run a test only on a subset of architectures, the `arch` option may
be used:

Test options: `arch=macintel`
```
cl> !uname -m
x86_64
```

More than one architecture can be specified by separating them with
comma.

### Running tests

To run, just the script `test/run_test` needs to be executed. It has the
following options:

 * `-h` this help
 * `-v` verbose output
 * `-c CL.e` use `CL.e` as IRAF shell (may be given several times)
 * `TEST.md` run test script `TEST.md` (may be given several times)

If no further options are given, all markdown files in `test` are executed
with the `ecl.e` IRAF shell. For each Markdown file, it will print the file
name, and the result of each test as one character per executed code block:

  * `.` test passed,
  * `F` test failed,
  * `x` test failed and was expected to fail
  * `s` test skipped,
  * `a` architecture specific test skipped.

As an example, the output for this file is

File: `printed on stdout`
```
$ ./test/run_tests test/README.md
ecl.e: README.md ...xs.
```

Without errors, the return status is 0. If there is an error, then the
expected, the actual output and their difference are printed:

File: `printed on stdout`
```
$ ./test/run_tests test/README.md
ecl.e: README.md ..Fxs.

=================== Failure in README.md:66 with ecl.e ===================

Expected
========
cl> =1.0/3.0
0.33333331

Output
======
cl> =1.0/3.0
0.33333333333333

Diff
====
@@ -1,2 +1,2 @@
 cl> =1.0/3.0
-0.33333331
+0.33333333333333
```

In this case, the exit status of the test script is 1.

# CL scripts

This is based on [An Introductory User’s Guide to IRAF
Scripts](https://iraf-community.github.io/doc/script.pdf) by Ed Anderson.

You will recall that several tasks may be called in sequence on a
single command line, using a semicolon `;` to separate each command.
For example:

```
cl> mkdir database; dir; cd database; dir
database
no files found
```

If the command sequence is too long to fit on a single line, one could
construct a compound statement by using the curly braces, `{}`:

```
cl> {
>>> dir
database
>>> cd database
>>> dir
no files found
>>> }
```

The `>>>` prompt indicates that the CL requires more input (in this
case, the CL is waiting for a `}`) before executing the task or
sequence of tasks.  A Terminal Script is essentially a compound
statement, but uses some of the simple programming tools provided by
the CL.

Now we check some control structures. First create a list file with a
`for` loop

File: `loop.cl`
```
for (i = 1; i < 5; i+=1) {
    j = i*i
    print (i, j, >> "sqr.lis")
}
```

Execute this script and check the content of the list:


```
cl> cl < loop.cl
cl> type "sqr.lis"
1 1 
2 4 
3 9 
4 16 
```

Read the file just created with a `while` loop with this script:

File: `while.cl`
```
list = "sqr.lis"
while (fscan(list, i, j) != EOF) print(i, j)
```



```
cl> cl < while.cl
1 1 
2 4 
3 9 
4 16 
```

Test intrinsic mathematical CL functions

Test options: `decimals=7`
```
cl> =sin(1.2)
0.9320390859672263
cl> =cos(1.2)
0.3623577544766736
cl> =tan(1.2)
2.5721516221263188
cl> =atan2(2.,3.)
0.5880026035475675
cl> =exp(1.2)
3.3201169227365472
cl> =frac(1.2)
0.2
cl> =int(-1.2)
-1
cl> =log(1.2)
0.1823215567939546
cl> =log10(1.2)
0.07918124604762482
cl> =max(2,3,4,2)
4
cl> =min(2,3,4,2)
2
cl> =mod(123, 7)
4
cl> =nint(1.5)
2
cl> =nint(2.5)
3
cl> =sqrt(1.2)
1.0954451150103321
```

Intrinsic logic functions

```
cl> =real("1.23")
1.23
cl> =isindef(0)
no
cl> =isindef(INDEF)
yes
cl> =radix(123, 10)
123
cl> =radix(123, 16)
7B
cl> =radix(-123, 10)
4294967173
cl> =radix(-123, 16)
FFFFFF85
```

Intrinsic string functions

```
cl> =stridx("fd", "abcdefg")
4
cl> =strldx("fd", "abcdefg")
6
cl> =strlen("abcdefg")
7
cl> =strlstr("def", "abcdefg")
4
cl> =strlwr("aBcDeF")
abcdef
cl> =strstr("def", "abcdefg")
4
cl> =strupr("aBcDeF")
ABCDEF
cl> =substr("abcdefg", 2, 5)
bcde
```

# imfit - Image fitting package

## fit1d - Fit a function to image lines or columns

```
cl> fit1d dev$pix fitimage fit interactive-
cl> imstat fitimage
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
             fitimage    262144     108.3     65.53    -236.1     521.1
```

## imsurfit - Fit a surface to a 2-D image

```
cl> imsurfit dev$pix smooth 5 10 function=spline3
cl> imstat smooth
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
               smooth    262144     107.8     69.11      -39.      480.
```

## lineclean - Replace deviant pixels in image lines

```
cl> lineclean dev$pix clean interactive-
cl> imstat clean
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                clean    262144     100.7     62.55        9.     1661.
```

This is compiled from

 * [Preliminary Test Procedure for IRAF](https://iraf-community.github.io/doc/testproc.pdf),
   IRAF Version V2.11, Jeannette Barnes, Central Computer Services,
   National Optical Astronomy Observatories, P.O. Box 26732, Tucson, AZ
   85726, Revised September 23, 1997,

 * [A Beginner's Guide to Using IRAF](https://iraf-community.github.io/doc/beguide.pdf),
   IRAF Version 2.10, Jeannette Barnes, Central Computer Services, August 1993.

***

The following pages describe a short test procedure that sites can
execute to test some basic image functions within IRAF for a new
installation. This process will help verify that everything is working
correctly and also help the rst time user gain familiarity with the
system. The commands you need to type and the expected terminal output
are given below.

# The basics

We will assume that you have started IRAF and are residing in an empty
directory from which you wish to work.

## Packages and tasks

All of the IRAF core packages are loaded when you log into IRAF. You
can list what packages are currently loaded by typing the word
`package`. The following should be displayed, but the packages may not
be listed in the same order:

```
cl> package
    clpackage
    language
    system
    lists
    noao
    nttools
    utilities
    proto
    imutil
    immatch
    imgeom
    imfit
    imfilter
    imcoords
    images
```

New packages can be loaded by simply typing the packages name. Not the
change of the prompt. The last package loaded can be unloaded by
typing `bye`. Try the following. Note that in our example the top
level packages listed may be different than yours.

```
cl> digiphot
di> ?
      apphot   daophot  photcal  ptools
di> bye
cl> ?
      dataio      language    noao        plot        softools    utilities
      images      lists       obsolete    proto       system
```

## Image files

An IRAF image exists in the `dev$` directory. Lets make a copy of this
image into the current working directory.

```
cl> imcopy dev$pix image.short
dev$pix -> image.short    
```

Let's look at the header information for this image with `imhead`.

```
cl> imhead dev$pix long+
dev$pix[512,512][short]: m51  B  600s
No bad pixels, min=-1., max=19936.
Line storage mode, physdim [512,512], length of user area 1621 s.u.
Created Mon 23:54:13 31-Mar-1997, Last modified Sun 16:37:53 12-Mar-2006
Pixel file "HDR$pix.pix" [ok]
'KPNO-IRAF'           /
'31-03-97'            /
IRAF-MAX=           1.993600E4  /  DATA MAX
IRAF-MIN=          -1.000000E0  /  DATA MIN
IRAF-BPX=                   16  /  DATA BITS/PIXEL
IRAFTYPE= 'SHORT   '            /  PIXEL TYPE
CCDPICNO=                   53  /  ORIGINAL CCD PICTURE NUMBER
ITIME   =                  600  /  REQUESTED INTEGRATION TIME (SECS)
TTIME   =                  600  /  TOTAL ELAPSED TIME (SECS)
OTIME   =                  600  /  ACTUAL INTEGRATION TIME (SECS)
DATA-TYP= 'OBJECT (0)'          /  OBJECT,DARK,BIAS,ETC.
DATE-OBS= '05/04/87'            /  DATE DD/MM/YY
RA      = '13:29:24.00'         /  RIGHT ASCENSION
DEC     = '47:15:34.00'         /  DECLINATION
EPOCH   =                 0.00  /  EPOCH OF RA AND DEC
ZD      = '22:14:00.00'         /  ZENITH DISTANCE
UT      = ' 9:27:27.00'         /  UNIVERSAL TIME
ST      = '14:53:42.00'         /  SIDEREAL TIME
CAM-ID  =                    1  /  CAMERA HEAD ID
CAM-TEMP=              -106.22  /  CAMERA TEMPERATURE, DEG C
DEW-TEMP=              -180.95  /  DEWAR TEMPRATURE, DEG C
F1POS   =                    2  /  FILTER BOLT I POSITION
F2POS   =                    0  /  FILTER BOLT II POSITION
TVFILT  =                    0  /  TV FILTER
CMP-LAMP=                    0  /  COMPARISON LAMP
TILT-POS=                    0  /  TILT POSITION
BIAS-PIX=                    0  /
BI-FLAG =                    0  /  BIAS SUBTRACT FLAG
BP-FLAG =                    0  /  BAD PIXEL FLAG
CR-FLAG =                    0  /  BAD PIXEL FLAG
DK-FLAG =                    0  /  DARK SUBTRACT FLAG
FR-FLAG =                    0  /  FRINGE FLAG
FR-SCALE=                 0.00  /  FRINGE SCALING PARAMETER
TRIM    = 'Apr 22 14:11 Trim image section is [3:510,3:510]'
BT-FLAG = 'Apr 22 14:11 Overscan correction strip is [515:544,3:510]'
FF-FLAG = 'Apr 22 14:11 Flat field image is Flat1.imh with scale=183.9447'
CCDPROC = 'Apr 22 14:11 CCD processing done'
AIRMASS =    1.08015632629395   / AIRMASS
HISTORY 'KPNO-IRAF'
HISTORY '24-04-87'
HISTORY 'KPNO-IRAF'           /
HISTORY '08-04-92'            /
```

Note that the pixels are short integers (=16 bits).

Print the same, but without the user fields:

```
cl> imhead dev$pix l+ u-
dev$pix[512,512][short]: m51  B  600s
No bad pixels, min=-1., max=19936.
Line storage mode, physdim [512,512], length of user area 1621 s.u.
Created Mon 23:54:13 31-Mar-1997, Last modified Sun 16:37:53 12-Mar-2006
Pixel file "HDR$pix.pix" [ok]
'KPNO-IRAF'           /
'31-03-97'            /
```

Check the parameter settings for `imhead`:

```
cl> lpar imhead
       images =                 image names
      (imlist = "*.imh,*.fits,*.pl,*.qp,*.hhh") default image names
  (longheader = no)             print header in multi-line format
  (userfields = yes)            print the user fields (instrument parameters)
        (mode = "ql")           
```

It would be useful to generate two more copies of this image but with
different pixel types - one with 32-bit floating point pixels (called
`real`s) and one with 64-bit double precision floating point pixels
(called `double`). Note that IRAF also supports other pixel data types -
32-bit integers called `long`, 16-bit unsigned integers called
`ushort`, and complex numbers. Execute the following:

```
cl> imarith image.short / 1 image.real pixtype=r
cl> imarith image.short / 1 image.dbl pixtype=d
cl> imhead image.*
image.dbl.fits[512,512][double]: m51  B  600s
image.real.fits[512,512][real]: m51  B  600s
image.short.fits[512,512][short]: m51  B  600s
```

Let's execute a couple of more tasks that will exercise some image
operators. Typing

```
cl> minmax image.dbl,image.real,image.short
image.dbl [77,4] -1. [348,189] 19936.
image.real [77,4] -1. [348,189] 19936.
image.short [77,4] -1. [348,189] 19936.
```

Now display a table with pixel values.

```
cl> listpix image.short[300:305,200:205] formats="%4s %4s" | table
   1.   1.  145.     4.   2.  141.     1.   4.  149.     4.   5.  144.
   2.   1.  143.     5.   2.  132.     2.   4.  149.     5.   5.  145.
   3.   1.  141.     6.   2.  130.     3.   4.  146.     6.   5.  144.
   4.   1.  142.     1.   3.  162.     4.   4.  143.     1.   6.  138.
   5.   1.  135.     2.   3.  145.     5.   4.  145.     2.   6.  139.
   6.   1.  138.     3.   3.  146.     6.   4.  140.     3.   6.  145.
   1.   2.  147.     4.   3.  144.     1.   5.  144.     4.   6.  141.
   2.   2.  147.     5.   3.  135.     2.   5.  145.     5.   6.  141.
   3.   2.  145.     6.   3.  141.     3.   5.  133.     6.   6.  149.
```

## Image sections

Now let's test the use of image sections. Type and observe the
following terminal interactions:

```
cl> imcopy image.real[200:300,200:300] image.sect
image.real[200:300,200:300] -> image.sect
cl> imhead image.sect
image.sect[101,101][real]: m51  B  600s
```

## Modifying images

At this time, let's modify a couple of image titles.

```
cl> hedit image.real title "m51 real" verify=no
image.real,i_title: "m51  B  600s" -> "m51 real"
image.real updated
cl> hedit image.dbl title "m51 double" verify=no
image.dbl,i_title: "m51  B  600s" -> "m51 double"
image.dbl updated
```

We can verify the new title with the `imheader` task.

```
cl> imhead image*
image.dbl.fits[512,512][double]: m51 double
image.real.fits[512,512][real]: m51 real
image.sect.fits[101,101][real]: m51  B  600s
image.short.fits[512,512][short]: m51  B  600s
```

# Plotting data

## One-dimensional (vector) plotting tasks

Now let's check some plotting options. Type

```
cl> plot
cl> pcol image.short 256 >G image.short.meta
cl> !ls  image.short.meta
image.short.meta
cl> del image.short.meta
```

The redirected output graphics file should have the md5 sum
`0806e05ccea335a1ad4962282905c830` on 64 bit. Unfortunately, this is
machine dependent, so on 32 bit, the md5 sum is
`32e139a609d9d50c8f108d0023820c11`.

## Two-dimensional plotting tasks

Let's make a contour plot of the section image. We do it as IRAF graphics.

```
cl> plot
cl> contour image.sect >G image.sect.meta
Image will be block averaged by 1 in x and 1 in y
cl> !ls  image.sect.meta
image.sect.meta
cl> del image.sect.meta
```

Unfortunately, the file contains local information and therefore the
content can't be strictly compared.


## Tasks that manipulate graphics metacode files

Graphics output can be stored in files. These files are called
"metacode" files. Graphics metacode files can be generated by the task
itself, by the user by redirecting the graphics output to a metacode
file on the command line with the `>G` syntax, or by writing the plot
directly to a metacode file with the `:.write` option in interactive
graphics mode.

A metacode file is distributed with your IRAF system and we will use
it to demonstrate these tasks.

```
cl> plot
cl> gkidir dev$vdm.gki

METAFILE 'dev$vdm.gki':
    [1]  (3517 words)    The SINC Function
    [2]  (2855 words)    The SINC Function
    [3]  (5701 words)    .2
    [4]  (2525 words)    Line 250 of dev$pix[200:300,*]
    [5]  (7637 words)    Log Scaling
    [6]  (97781 words)   NOAO/IRAF V2.3 tody@lyra Fri 23:30:27 08-Aug-86
    [7]  (2501 words)    The Sinc Function
    [8]  (11719 words)   Line 250 of dev$pix[200:300,*]
```

# Using the image display

In the workstation environment the user displays an image into a frame
buffer and then uses the display server, either IMTOOL or SAOimage,
for panning, zooming, blinking, changing the lookup tables (greyscale
and color), and so on. These functions will be done differently
depending on the server you are using.

Before doing anything involving image display the environment variable
stdimage must be set to the correct frame buffer size for the display
servers (as described in the `dev$graphcap` file under the section
"STDIMAGE devices") or to the correct image display device. The task
`GDEVICES` is helpful for determining this information for the display
servers.

```
cl> show stdimage
imt512
cl> set stdimage=imt800
cl> set stdimage=iism70v
```

## Displaying IRAF images

The `DISPLAY` task is the main task used for displaying images, but
cannot be tested here. Running `DISPLAY` without an image server will
result in a failure.

# Coordinate systems within IRAF

IRAF has support for three coordinate systems. The "logical"
coordinate system is defined by pixel coordinates relative to the
current image or image section.

```
cl> listpix dev$wpix[16:20,5:6] wcs=logical
1. 1.  41.
2. 1.  38.
3. 1.  41.
4. 1.  42.
5. 1.  40.
1. 2.  38.
2. 2.  38.
3. 2.  38.
4. 2.  39.
5. 2.  38.
```

The "physical" coordinate system is also in pixel coordinates but
relative to the original or parent image. 

```
cl> listpix dev$wpix[16:20,5:6] wcs=physical
16. 5.  41.
17. 5.  38.
18. 5.  41.
19. 5.  42.
20. 5.  40.
16. 6.  38.
17. 6.  38.
18. 6.  38.
19. 6.  39.
20. 6.  38.
```

The "world" coordinates can be in any general world coordinate system
such as right ascension and declination or wavelength.

```
cl> listpix dev$wpix[16:20,5:6] wcs=world format="%H %h"
13:28:05.1 47:24:01.4  41.
13:28:05.1 47:24:01.4  38.
13:28:05.0 47:24:01.4  41.
13:28:04.9 47:24:01.4  42.
13:28:04.8 47:24:01.4  40.
13:28:05.1 47:24:02.1  38.
13:28:05.1 47:24:02.2  38.
13:28:05.0 47:24:02.2  38.
13:28:04.9 47:24:02.2  39.
13:28:04.8 47:24:02.2  38.
```

# Additional interesting topics

## File and image name templates

Templates are character strings including some
metacharacters. Templates can be used as input to IRAF tasks; those
file names matching the template are used as input.

The following are a few examples of the more commonly used file templates.

```
cl> dir *.fits
image.dbl.fits      image.real.fits     image.sect.fits     image.short.fits
```

## The @file

The @file (pronounced "at file") can be used for handling large lists
of images for input and output. The @file is a text file containing a
list of images. The easiest way to generate an @file is with the `FILES`
or `SECTIONS` task. This is often the preferred input/output to tasks
rather than using templates directly. Since the @file is a text file
it can also be edited.

```
cl> files *.fits > inlist
cl> imstat @inlist
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
       image.dbl.fits    262144     108.3     131.3       -1.    19936.
      image.real.fits    262144     108.3     131.3       -1.    19936.
      image.sect.fits     10201     363.9      346.      108.     7734.
     image.short.fits    262144     108.3     131.3       -1.    19936.
```

You can also use the `//` operator:

```
cl> imarith @inlist * 2 @inlist//.2
cl> imstat @inlist//.2
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
     image.dbl.2.fits    262144     216.6     262.6       -2.    39872.
    image.real.2.fits    262144     216.6     262.6       -2.    39872.
    image.sect.2.fits     10201     727.8      692.      216.    15468.
   image.short.2.fits    262144     216.1      250.   -26476.    29280.
cl> imdelete image.*.2.fits
```

A common extension can be specified as well in the list with the new
image opening code (`set use_vo = yes`; see
[#235](https://github.com/iraf-community/iraf/issues/235)):

```
cl> imstat @inlist[0]
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
    image.dbl.fits[0]    262144     108.3     131.3       -1.    19936.
   image.real.fits[0]    262144     108.3     131.3       -1.    19936.
   image.sect.fits[0]     10201     363.9      346.      108.     7734.
  image.short.fits[0]    262144     108.3     131.3       -1.    19936.
```

## Using the CL as a calculator

The CL has a built-in calculator capability. Some variables that may
be used are defined in the parameter file for the CL which includes
the booleans b1, b2, and b3; the integer variables, i, j, and k; the
real variables, x, y, and z; and the string variables, s1, s2, and
s3. There are a variety of built-in functions that are also available
including sin, cos, abs, exp, log, log10, max, min, sqrt, and tan.

For more complex examples see the document An Introductory User's
Guide to IRAF Scripts, mentioned in §9.1.

```
cl> i=1;j=2;x=5;=i+x**j
26.
cl> =x
5.
cl> =sqrt(x/10)
0.70710678118655
cl> =(sin(0.5)**2+cos(0.5)**2)
1.
```

# Cleaning up

Hopefully all went well to this point. Let's clean things up a bit.

```
cl> dir
image.dbl.fits      image.sect.fits     inlist
image.real.fits     image.short.fits
cl> imdelete image.*
cl> dir
inlist
```

Remember that if you want to delete any images you just use the task
`imdelete`. The task `delete` will delete your text files. If the
wrong task is used to delete images a warning message is printed and
no images are deleted.

If discrepancies occur during any of these steps, please look at the
examples closely. It might be advisable to backtrack a few steps and
verify things again. If the discrepancies are repeatable there could
indeed be a problem. Please document the discrepancy and feel free to
contact us if some advice or help is needed.

# Test of sys/vops routines

## FFT842: fast fourier transform for complex input


This program replaces the vector z=x+iy by its finite discrete, complex
fourier transform if `in=0`. The inverse transform is calculated for `in=1`.

File: `test_fft842.x`
```
task test_fft842 = t_fft842

procedure eval_fft842(x, y, ndim)
int ndim
real x[ndim], y[ndim]
int j
int ier
begin
    call printf("FFT input  ")
    do j = 1, ndim {
        call printf(" (%6.3f;%4.3f)")
        call pargr(x[j])
        call pargr(y[j])
    }
    call fft842(0, ndim, x, y, ier)
    call printf("\nFFT output ")
    do j = 1, ndim {
        call printf(" (%6.3f;%4.3f)")
        call pargr(x[j])
        call pargr(y[j])
    }
    call fft842(1, ndim, x, y, ier)
    call printf("\nInverse    ")
    do j = 1, ndim {
        call printf(" (%6.3f;%4.3f)")
        call pargr(x[j])
        call pargr(y[j])
    }
    call printf("\n")
end

procedure t_fft842 ()
real x[8], y[8]
data x /1.0, 2.0, 1.0, -1.0, 1.5, 1.0, 0.5, 1.0/
data y /0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/
begin
    call eval_fft842(x, y, 8)
end
```

Test options: `decimals=4`
```
cl> softools
cl> xc -x test_fft842.x
cl> task $test_fft842 = test_fft842.e
cl> test_fft842
FFT input   ( 1.000;0.00) ( 2.000;0.00) ( 1.000;0.00) (-1.000;0.00) ( 1.500;0.00) ( 1.000;0.00) ( 0.500;0.00) ( 1.000;0.00)
FFT output  ( 7.0000;0.0000) ( 1.6210;0.2100) ( 1.0000;-3.0000) (-2.6210;1.2100) ( 1.0000;0.0000) (-2.6210;-1.2000) ( 1.0000;3.0000) ( 1.6210;0.2000)
Inverse     ( 1.000;0.00) ( 2.000;0.00) ( 1.000;0.00) (-1.000;0.00) ( 1.500;0.00) ( 1.000;0.00) ( 0.500;0.00) ( 1.000;0.00)
```

# Check for required (built) files

## Executables

```
cl> dir bin$*.e ncol=1
bin$cl.e
bin$ecl.e
bin$irafks.e
bin$x_color.e
bin$x_dataio.e
bin$x_images.e
bin$x_imdkern.e
bin$x_lists.e
bin$x_mkttydata.e
bin$x_ncar.e
bin$x_nttools.e
bin$x_obsolete.e
bin$x_plot.e
bin$x_proto.e
bin$x_sgikern.e
bin$x_softools.e
bin$x_stdgraph.e
bin$x_system.e
bin$x_tv.e
bin$x_utilities.e
bin$x_vol.e
```

```
cl> dir host$bin/*.e ncol=1
host$bin/alloc.e
host$bin/f2c.e
host$bin/generic.e
host$bin/mkpkg.e
host$bin/rmbin.e
host$bin/rmfiles.e
host$bin/rpp.e
host$bin/rtar.e
host$bin/sgi2gif.e
host$bin/sgi2svg.e
host$bin/sgi2uapl.e
host$bin/sgi2ueps.e
host$bin/sgi2uhpgl.e
host$bin/sgi2uhplj.e
host$bin/sgi2uimp.e
host$bin/sgi2uptx.e
host$bin/sgi2uqms.e
host$bin/sgi2xbm.e
host$bin/sgidispatch.e
host$bin/wtar.e
host$bin/xc.e
host$bin/xpp.e
host$bin/xyacc.e
```

# Libraries

```
cl> dir bin$*.a ncol=1
bin$libc.a
bin$libcur.a
bin$libcurfit.a
bin$libdeboor.a
bin$libds.a
bin$libex.a
bin$libfftpack.a
bin$libgks.a
bin$libgsurfit.a
bin$libimc.a
bin$libimd.a
bin$libimfort.a
bin$libiminterp.a
bin$libinterp.a
bin$liblapack.a
bin$libllsq.a
bin$libncar.a
bin$libnlfit.a
bin$libsgi.a
bin$libslalib.a
bin$libstg.a
bin$libstxtools.a
bin$libsurfit.a
bin$libsys.a
bin$libtbtables.a
bin$libvops.a
bin$libxtools.a
```

```
cl> dir host$bin/*.a ncol=1
host$bin/libboot.a
host$bin/libf2c.a
host$bin/libos.a
```

## NOAO packages

```
cl> dir noaobin$*.e ncol=1
noaobin$x_apextract.e
noaobin$x_apphot.e
noaobin$x_artdata.e
noaobin$x_astcat.e
noaobin$x_astutil.e
noaobin$x_bias.e
noaobin$x_ccdred.e
noaobin$x_crutil.e
noaobin$x_daophot.e
noaobin$x_dtoi.e
noaobin$x_generic.e
noaobin$x_irred.e
noaobin$x_longslit.e
noaobin$x_mtlocal.e
noaobin$x_nobsolete.e
noaobin$x_nproto.e
noaobin$x_obsutil.e
noaobin$x_onedspec.e
noaobin$x_photcal.e
noaobin$x_ptools.e
noaobin$x_quad.e
noaobin$x_quadred.e
noaobin$x_rv.e
noaobin$x_scombine.e
noaobin$x_vtel.e
```

```
cl> dir noaobin$*.a ncol=1
noaobin$libasttools.a
noaobin$libsmw.a
```

# astutil - Astronomical utilities package

## airmass - Compute the airmass at a given elevation above the horizon

```
cl> noao
cl> astutil
cl> airmass 30
airmass 1.996 at an elevation of 30. degrees (0.5236 radians) above horizon
```

## astcalc - Astronomical calculator

File: `example2.dat`
```
# Define variables.
observatory = "kpno"
date = "05/04/87"
ut = 9:27:27
ra = 13:29:24
dec = 47:15:34
epoch = epoch (date, ut)
mst = mst (date, ut, obsdb (observatory, "longitude"))

# Print results of some expressions.
print ((1 + 2 + 3) / 2 - 2 * 2)       # Calculation with constants
print (epoch)                         # Print variable
print (mst)                           # Print variable
print (julday (date, ut))             # Print result of function
print (ra_precess (ra, dec, epoch, 1950))
print (dec_precess (ra, dec, epoch, 1950))
print (airmass (ra, dec, mst, obsdb (observatory, "latitude")))

# Formatted print with arguments.  Note newline.
printf ("Hello World: %s\n", precess (ra, dec, epoch, 1950))
```

Test options: `decimals=7`
```
cl> noao
cl> astutil
cl> astcalc commands=example2.dat
-1
1987.257752395672
14:53:39.81
2446890.894062519
13:27:49.84
47:27:05.72
1.07968417231416
Hello World: 13:27:49.84  47:27:05.7   1950.
```

### Precess coordinates given in a text file.

File: `example3.dat`
```
# Read table of RA, DEC, and optional EPOCH and precess to 2000.

epoch = 1900            # Default input epoch
epoch1 = 2000           # Precession epoch

# Scan table and precess coordinates.
if (fscan ("ra", "dec", "epoch") >= 2)
    ra1 = ra_precess (ra, dec, epoch, epoch1)
    dec1 = dec_precess (ra, dec, epoch, epoch1)
    printf ("%h %h %d -> %h %h %d\n", ra, dec, epoch, ra1, dec1, epoch1)
else
    printf ("Missing coordinates\n")
endif
```

File: `table.dat`
```
12:22:31        31:10:15        1950
13:52:44        10:21:32        1996.1
14:52:44        11:21:32
10:20:30
```

```
cl> noao
cl> astutil
cl> astcalc commands=example3.dat table=table.dat
12:22:31.0 31:10:15.0 1950 -> 12:25:00.56 30:53:38.13 2000
13:52:44.0 10:21:32.0 1996 -> 13:52:55.54 10:20:23.11 2000
14:52:44.0 11:21:32.0 1900 -> 14:57:33.16 10:57:24.74 2000
Missing coordinates
```

## asthedit - Astronomical header editor

## astradius - Find images within a circle on the sky

## asttimes - Compute UT, Julian day, epoch, and sidereal time

```
cl> noao
cl> astutil
cl> asttimes year=1987 month=10 day=28 time=15:30 obs=kpno
# ASTTIMES: Observatory parameters for Kitt Peak National Observatory
#       timezone = 7
#       longitude = 111:36.0
##YR MON   DAY          ZT         UT      EPOCH           JD       LMST
1987  10 28 WED 15:30:00.0 22:30:00.0 1987.82324 2447097.4375 17:30:31.8
cl> =asttimes.lmst
17.508823973881
```

## ccdtime - Compute time, magnitude, and signal-to-noise for CCDs

## galactic - Convert ra, dec to galactic coordinates

File: `galactic.coords`
```
12:30:10.12 10:18:27.5 1930.
12:30 10:18
12.5  10:18
```

Test options: `decimals=2`
```
cl> noao
cl> astutil
cl> galactic galactic.coords
  12:30:10.12   10:18:27.5  1930.00     288.4444   72.2931
  12:30:00.00   10:18:00.0  1950.00     287.4345   72.3248
  12:30:00.00   10:18:00.0  1950.00     287.4345   72.3248
```

## gratings - Compute and print grating parameters

## keywpars - Translate the image header keywords used in ASTUTIL package

## pdm - Find periods in light curves by Phase Dispersion Minimization

## precess - Precess a list of astronomical coordinates

File: `precess.coords`
```
12:30:10.12 10:18:27.5
12:30 10:18
12:30 -20 1900
12:30 -20 1900 2000
```

Test options: `decimals=2`
```
cl> noao
cl> astutil
cl> precess precess.coords 1950 1990
  12:32:11.79   10:05:13.09  1990.0
  12:32:01.68   10:04:45.51  1990.0
  12:34:42.90  -20:29:46.32  1990.0
  12:35:14.41  -20:33:04.42  2000.0
```

## rvcorrect - Compute radial velocity corrections

File: `rv.obs`
```
1987 10 21 11:00:24  3:36:15   0:22:04
1987 10 21 11:08:00  8:19:35  -0:51:35
1987 10 21 11:15:47  8:35:12   6:40:29
1987 10 21 12:12:10  9:13:20  61:28:49
1987 10 21 12:16:03  9:27:48   9:07:08
1987 10 21 12:20:43  9:50:45  -6:06:58
1979  3 25 11:22:59 16:07:28 -23:37:49 0 -67.5
```

```
cl> noao
cl> astutil
cl> rvcorrect f=rv.obs obs=kpno > rv.dat
cl> type rv.dat
# RVCORRECT: Observatory parameters for Kitt Peak National Observatory
#	latitude = 31:57.8
#	longitude = 111:36.0
#	altitude = 2120.
##   HJD          VOBS   VHELIO     VLSR   VDIURNAL   VLUNAR  VANNUAL   VSOLAR
2447089.96358     0.00    11.06    -2.74     -0.190    0.008   11.247  -13.808
2447089.96296     0.00    28.05    13.56      0.255    0.010   27.790  -14.498
2447089.96813     0.00    29.04    16.64      0.263    0.011   28.770  -12.401
2447090.00834     0.00    22.06    25.26      0.115    0.010   21.940    3.200
2447090.00884     0.00    27.70    18.55      0.251    0.009   27.438   -9.152
2447090.01129     0.00    23.99    13.50      0.276    0.007   23.704  -10.484
2443957.97715   -67.50   -41.37   -31.48      0.002    0.012   26.117    9.884
```

## setairmass - Compute effective airmass and middle UT for an exposure

```
cl> noao
cl> astutil
cl> setairmass dev$pix exposure=itime obs=kpno update-
#              Image    UT middle  effective  begin   middle     end   updated
	Coords not precessed for dev$pix.imh: check epoch
# SETAIRMASS: Observatory parameters for Kitt Peak National Observatory
#	latitude = 31:57.8
             dev$pix    9:32:27.0   1.0852   1.0797   1.0852   1.0910  no
```

## setjd - Compute and set Julian dates in images

# Lists

These tests are taken from the examples

## average - Compute the mean and standard deviation of a list

Task average computes the average and standard deviation of a list of
numbers.

File: `numbers`
```
0.7087 
 0.425 
0.9906 
0.5149 
0.4219 
0.6486 
0.7075 
0.8334 
```

```
cl> type numbers | average
0.656325 0.19892008266064 8
cl> print 1 | average add
0.69451111111111 0.21851009384262 9
```

## columns - Convert multicolumn file to separate files

Task columns is used to reformat a multicolumn list file into separate
files, such that one output file is created for each column in the
input file.

File: `dtable`
```
0.7087  0.425 0.9906 
0.5149 0.4219 0.6486 
0.7075 0.8334 0.8039 
 0.571 0.6779 0.3024 
0.6091 0.4976 0.5332 
0.3596 0.1426 0.3051 
0.4146 0.5085 0.0547 
0.4568 0.1392 0.3042 
0.1508 0.4498 0.7418 
```

```
cl> columns dtable 3 outroot=datacol.
cl> type datacol.1
0.7087
0.5149
0.7075
0.571
0.6091
0.3596
0.4146
0.4568
0.1508
cl> type datacol.2
0.425
0.4219
0.8334
0.6779
0.4976
0.1426
0.5085
0.1392
0.4498
cl> type datacol.3
0.9906
0.6486
0.8039
0.3024
0.5332
0.3051
0.0547
0.3042
0.7418
```

## lintran - Perform linear transformation of a list

Specified fields from the input list can be scaled, rotated and
shifted.

File: `frame1`
```
0.7087  0.424 
0.9906 0.5149 
0.4219 0.6486 
0.7075 0.8334 
0.8039  0.571 
0.6779 0.3024 
0.6091 0.4976 
0.5332 0.3596 
```

```
cl> lintran frame1 x1=35.7 y1=389.2 x2=36.9 y2=400.0
1.9087  11.22 
2.1906 11.315 
1.6219 11.449 
1.9075 11.633 
2.0039  11.37 
1.8779 11.102 
1.8091 11.298 
1.7332  11.16 
cl> lintran frame1 angle=90
-0.424 0.7087 
-0.515 0.9906 
-0.649 0.4219 
-0.833 0.7075 
-0.571 0.8039 
-0.302 0.6779 
-0.498 0.6091 
 -0.36 0.5332
```

## table - Format a list of words into a table

Task table reads a list of strings from the standard input or a list
of files and assembles a nicely formatted table.

```
cl> sort numbers numeric_sort=yes | table ncol=2 first_col=1 last_col=20
0.4219    0.7075 
 0.425    0.7087 
0.5149    0.8334 
0.6486    0.9906 
```

## tokens - Break a file up into a stream of tokens

Task tokens breaks the input up into a series of tokens.

File: `hello.x`
```
# HELLO -- Sample program introducing SPP.
procedure t_hello_world ()
begin
    call printf ("Hello,world!")
end
```

```
cl> tokens hello.x newline=no
procedure
t_hello_world
(
)
begin
call
printf
(
"Hello,world!"
)
end
```

## unique - Delete redundant elements from a list

Task unique reads the input comparing adjacent lines. The second and
successive copies of a line are removed; the remainder is passed on to
the standard output.

File: `names`
```
what
is
important
about
object
is
something
```

```
cl> sort names | unique
about
important
is
object
something
what
```

## words - Break a file up into a stream of words

Task words is used to break the input up into a series of words or
strings.

File: `text`
```
Task words is used to break the input up into a series of  words  or
strings.
```

```
cl> words text
Task
words
is
used
to
break
the
input
up
into
a
series
of
words
or
strings.
```

# photcal - Photometric Calibration Package

This package has serious 64-bit problems in the original 2.16.1 distribution.

## fitparams - Compute the parameters of the transformation equations

This issue is created on base of [a forum post in 2013](https://iraf.net/forum/viewtopic.php?showtopic=1467834). Lets take the following minimal observation list:

File: `sobs.dat`
```
alpha 20. 0.
beta  16. 3.
gamma 15. 7.
delta 13. 6.
```
and this configuration file:

File: `config.dat`
```
observations

x 2
y 3

transformation

fit v1=0.0, v2=0.0
FIT : y = v1 + v2 * x
```
The catalog remains empty in this example (but has to be given as dummy).
Running this gives a segmentation violation on 64-bit platforms:

Test options: `decimals=4`
```
cl> noao
cl> digiphot
cl> photcal
cl> fitparams.interactive=no
cl> fitparams.logfile=""
cl> fitparams sobs.dat stds.dat config.dat fitpar.txt
cl> match "^\#" fitpar.txt stop=yes
begin	FIT
	status	0	(Solution converged)
	variance	2.98077
	stdeviation	1.726491
	avsqerror	1.
	averror		1.
	avsqscatter	0.
	avscatter	0.
	chisqr		2.98077
	msq		1.490385
	rms		1.220813
	reference	y
	fitting		v1+v2*x
	weights		uniform
	parameters	2
		v1	(fit)
		v2	(fit)
	derivatives	2
		0.1
		0.1
	values	2
		19.3846
		-0.9615375
	errors	2
		5.485904
		0.3385923

```

# nttools - NOAO version of TTOOLS package

File: `startable`
```
#c STARno i %5d 
#c X d %6.2f pixels
#c Y d %6.2f pixels
#c MAG d %15.7g magnitude
#c SHARP d %15.7g 
#c ROUND d %15.7g 
#c STARNAME ch*15 %-15s 
#k HISTORY  = 'Created Thu 08:48:13 26-Oct-2017'
1   3.00   4.00              5.              6.              7. HD12345
2  10.00  11.00             12.             13.             14. "HD 122"
3  20.00  21.00             22.             23.             24. ""
```

## keypar - Copy an image or table header keyword to an IRAF parameter.

```
cl> keypar dev$pix airmass
cl> print(keypar.value)
1.08015632629395
```

## keytab - Copy an image or table header keyword to a table element.

## parkey - Put an IRAF parameter into an image or table header keyword.

## partab - Transfer an IRAF parameter to a table element.

## tabkey - Copy a table element to an image or table header keyword.

## tabpar - Transfer a table element to an IRAF parameter.

## gtedit - Graphically edit a table.

## gtpar - Pset to specify graph parameters for 'gtedit' task.

## imtab - Copy an image to a table column.

```
cl> imtab dev$pix pixtab data
cl> head pixtab
#c data i %11d 
#k HISTORY  = 'Column data from dev$pix.imh'
         38
         43
         35
         43
         39
         39
         41
         41
         41
         37
```

## tabim - Copy a table column to an image.

```
cl> tabim pixtab pixtabimg data 2 512
cl> imstat pixtabimg
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
            pixtabimg    262144     108.3     131.3       -1.    19936.
cl> imarith dev$pix - pixtabimg zero
cl> imstat zero
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                 zero    262144        0.        0.        0.        0.
```

## taextract - Copy an array entry to a column of scalars in another table.

## tainsert - Copy a column of scalars to an array entry in another table.

## tcalc - Perform arithmetic operations on table columns.

## tchcol - Change column name, print format, or units.

## tcheck - Check STSDAS table element values.

## tchsize - Change allocated sizes of various sections of a table.

## tcopy - Copy tables.

Test options: `decimals=7`
```
cl> tcopy startable startable.fits
# startable -> startable.fits
cl> tdump startable.fits
STARno           I             %5d  ""
X                D           %6.2f  pixels
Y                D           %6.2f  pixels
MAG              D          %15.7g  magnitude
SHARP            D          %15.7g  ""
ROUND            D          %15.7g  ""
STARNAME         CH*15       %-15s  ""
XTENSION t 'BINTABLE'  binary table extension
BITPIX   i 8  8-bit bytes
NAXIS    i 2  2-dimensional binary table
NAXIS1   i 59  width of table in bytes
NAXIS2   i 3
PCOUNT   i 0  size of special data area
GCOUNT   i 1  one data group (required keyword)
TFIELDS  i 7
TTYPE1   t 'STARno'  label for field   1
TFORM1   t '1J'  data format of the field: 4-byte INTEGER
TTYPE2   t 'X'  label for field   2
TFORM2   t '1D'  data format of the field: 8-byte DOUBLE
TUNIT2   t 'pixels'  physical unit of field
TTYPE3   t 'Y'  label for field   3
TFORM3   t '1D'  data format of the field: 8-byte DOUBLE
TUNIT3   t 'pixels'  physical unit of field
TTYPE4   t 'MAG'  label for field   4
TFORM4   t '1D'  data format of the field: 8-byte DOUBLE
TUNIT4   t 'magnitude'  physical unit of field
TTYPE5   t 'SHARP'  label for field   5
TFORM5   t '1D'  data format of the field: 8-byte DOUBLE
TTYPE6   t 'ROUND'  label for field   6
TFORM6   t '1D'  data format of the field: 8-byte DOUBLE
TTYPE7   t 'STARNAME'  label for field   7
TFORM7   t '15A'  data format of the field: ASCII Character
EXTNAME  t 'startable'  name of this binary table extension
TDISP1   t 'I5'  display format
TNULL1   i -2147483647  undefined value for column
TDISP2   t 'F6.2'  display format
TDISP3   t 'F6.2'  display format
TDISP4   t 'G15.7'  display format
TDISP5   t 'G15.7'  display format
TDISP6   t 'G15.7'  display format
TDISP7   t 'A15'  display format
HISTORY  t   Created Thu 08:48:13 26-Oct-2017
  1    3.     4.    5.     6.     7. HD12345
  2   10.     11.  12.    13.    14. "HD 122"
  3   20.     21.  22.    23.    24. ""
```

Test options: `decimals=7`
```
cl> tcopy startable.fits startable2
# startable.fits -> startable2
cl> tdump startable2
STARno           I             %5d  ""
X                D           %6.2f  pixels
Y                D           %6.2f  pixels
MAG              D          %15.7g  magnitude
SHARP            D          %15.7g  ""
ROUND            D          %15.7g  ""
STARNAME         CH*15       %-15s  ""
EXTNAME  t 'startable'  name of this binary table extension
HISTORY  t   Created Thu 08:48:13 26-Oct-2017
  1   3.   4.   5.    6.    7. HD12345
  2  10.  11.  12.   13.   14. "HD 122"
  3  20.  21.  22.   23.   24. ""
```


## tcreate - Create a STSDAS table from an ASCII descriptor table.

`columns.cd` may contain just the following:

File: `columns.cd`
```
STARno I  i5
X       r      "F6.2"  pixels
Y       R    F6.2     "pixels"
MAG R   ""   magnitude
                SHARP     R
                                ROUND           r
STARNAME   ch*15
```

Note the free format of, and embedded tabs in, the column definitions
file itself.  The format for display of MAG is not specified, but the
unit is given as magnitude, so adjacent quotes are used to mark the
position where the display format is expected.

The file `data.dat` may contain (if `nskip=3`, `nlines=2`):

File: `data.dat`
```
this is a header
      header2
       header3
 1      3.0     4.0     
           5.0  6.0     7.0 HD12345
   2 10.0 11.0 12.0 13.0
14.0 "HD 122"
3 20.0    21.0        22.0         23.0     24.0  ""
dummy line
```

Note the tabbed and free format of the data file and the specification
of the character strings.  If the character data contain embedded
blanks then the whole string should be quoted, otherwise this is not
necessary.  The final entry is the null character string.

```
cl> tcreate outfile columns.cd data.dat nskip=3
out of synch or extra data in line 9
cl> match "#k HISTORY" outfile stop=yes
#c STARno i %5d 
#c X d %6.2f pixels
#c Y d %6.2f pixels
#c MAG d %15.7g magnitude
#c SHARP d %15.7g 
#c ROUND d %15.7g 
#c STARNAME ch*15 %-15s 
    1   3.00   4.00              5.              6.              7. HD12345
    2  10.00  11.00             12.             13.             14. "HD 122"
    3  20.00  21.00             22.             23.             24. ""
```

## tdelete - Delete tables.

## tdiffer - Form a table which is the difference of two tables.

## tdump - Dump the contents of a table to an ASCII file.

Test options: `decimals=7`
```
cl> tdump startable
STARno           I             %5d  ""
X                D           %6.2f  pixels
Y                D           %6.2f  pixels
MAG              D          %15.7g  magnitude
SHARP            D          %15.7g  ""
ROUND            D          %15.7g  ""
STARNAME         CH*15       %-15s  ""
HISTORY  t Created Thu 08:48:13 26-Oct-2017
  1    3.     4.   5.     6.   7. HD12345
  2   10.    11.  12.    13.  14. "HD 122"
  3   20.    21.  22.    23.  24. ""
```

## tedit - Edit a table.

## texpand - Expand tables according to a set of rules.

## thedit - Edit or print table header keywords.

```
cl> thedit startable i_ncols .
startable,i_ncols = 7
cl> thedit startable.fits history .
startable.fits,HISTORY = "Created Thu 08:48:13 26-Oct-2017"
```

## thistogram - Make a histogram of a column in a table.

## thselect - Select tables satisfying an expression; print keywords.

## tinfo - Display table size information.

```
cl> tinfo startable
# startable
   3 rows written to table
   7 columns defined
   1 header parameters written to table
   5 records allocated for header parameters
  11 space allocated for column descriptors
table type:  text  explicit column definitions
cl> tinfo startable.fits
# startable.fits[1]
   3 rows written to table
   7 columns defined
  35 header parameters written to table
  35 records allocated for header parameters
   7 space allocated for column descriptors
table type:  fits
```

## tintegrate - Numerically integrate one column with respect to another.

## tjoin - Perform a relational join of two tables.

## tlcol - List column information for a table.

## tlinear - Use linear regression to fit one or two table columns.

## tmatch - Find closest match between rows in two tables

## tmerge - Either merge or append tables.

## tprint - Print tables--both headers and data.

## tproduct - Form the Cartesian product of two tables.

## tproject - Create new table from selected columns in a table.

## tquery - Create a new table from selected rows and columns in a table.

## tread - Browse through a table.

## trebin - Resample a table to uniform spacing.

This task resamples tables. The grid on which to interpolate an input
table may be specified either by a table giving explicit values or by
start, end, and step values for uniform spacing. The column names in
the output table will be the same as in the input table.

This is out input file. The numbers are just randomly chosen.

File: `rebin.tbl`
```
#c lambda d %6.2f nm
#c Y d %6.3f pixels
453.02   5.873
464.60  17.939
603.04  39.843
625.08  68.326
647.27  44.617
723.45  68.226
730.31  36.557
764.82  42.797
784.33   2.650
862.67  38.502
```

There are four different functions for interpolation: nearest, linear,
poly3, spline.

```
cl> trebin rebin.tbl rebnr.tbl lambda 460. 860. 50. function=nearest
rebin.tbl --> rebnr.tbl
cl> type rebnr.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
460.00 17.939
510.00 17.939
560.00 39.843
610.00 39.843
660.00 44.617
710.00 68.226
760.00 42.797
810.00  2.650
860.00 38.502
```

```
cl> trebin rebin.tbl reblin.tbl lambda 460. 860. 50. function=linear
rebin.tbl --> reblin.tbl
cl> type reblin.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
460.00 13.146
510.00 25.122
560.00 33.033
610.00 48.838
660.00 48.562
710.00 130.32
760.00 52.715
810.00 14.398
860.00 37.280
```

```
cl> trebin rebin.tbl rebspl.tbl lambda 460. 860. 50. function=spline
rebin.tbl --> rebspl.tbl
cl> type rebspl.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
460.00 13.514
510.00 24.524
560.00  8.351
610.00 52.234
660.00 49.286
710.00 106.62
760.00 41.834
810.00 -26.03
860.00 33.545
```

```
cl> trebin rebin.tbl rebpol.tbl lambda 460. 860. 50. function=poly3
rebin.tbl --> rebpol.tbl
cl> type rebpol.tbl
#c lambda d %6.2f nm
#c Y d %6.3f pixels
460.00 13.681
510.00 31.879
560.00 24.140
610.00 53.145
660.00 56.902
710.00 102.17
760.00 38.854
810.00 -51.35
860.00 22.331
```

## tselect - Create a new table from selected rows of a table.

## tsort - Sort a table.

## tstat - Get mean, standard deviation, min, and max for a column.

## ttranspose - Transpose or flip a table.

File: `ttranspose.in`
```
one     two     three
four    five    six
seven   eight   nine
ten     eleven  twelve
```

The input is the text file "in", and the output is to be displayed on
the screen.  Each of the three operations ("t", "h", "v") and some
combinations are illustrated.

```
cl> ttranspose ttranspose.in STDOUT t
ttranspose.in --> STDOUT
one    four   seven  ten
two    five   eight  eleven
three  six    nine   twelve
cl> ttranspose ttranspose.in STDOUT h
ttranspose.in --> STDOUT
three  two    one
six    five   four
nine   eight  seven
twelve eleven ten
cl> ttranspose ttranspose.in STDOUT v
ttranspose.in --> STDOUT
ten   eleven twelve
seven eight  nine
four  five   six
one   two    three
cl> ttranspose ttranspose.in STDOUT hv
ttranspose.in --> STDOUT
twelve eleven ten
nine   eight  seven
six    five   four
three  two    one
cl> ttranspose ttranspose.in STDOUT th
ttranspose.in --> STDOUT
ten    seven  four   one
eleven eight  five   two
twelve nine   six    three
```

## tunits - Convert table column from one set of units to another

## tupar - Edit table header keywords.

## tiimage - Insert images into rows of a 3-D table.

## titable - Insert 2-D tables into rows of a 3-D table.

## tximage - Extract images from rows of 3-D tables.

## txtable - Extract 2-D tables from rows of 3-D tables.

## tscopy - Copy row/column subsets of tables using selectors.

# imgeom - Image geometric transformation package

## blkavg - Block average or sum a list of N-D images

```
cl> blkavg dev$pix avg 2 3
cl> imstat avg
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                  avg     43776     107.8     122.7       28.    12997.
```

## blkrep - Block replicate a list of N-D images

```
cl> blkrep dev$pix rep 2 3
cl> imstat rep
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                  rep   1572864     108.3     131.3       -1.    19936.
```

## imlintran - Linearly transform a list of 2-D images

```
cl> imlintran dev$pix lintran 45.0 45.0 0.50 0.50

Transforming image dev$pix to image lintran
    xshift: 75.13 yshift: 256.50 xmag: 0.50 ymag: 0.50 xrot: 45.00 yrot: 45.00
cl> imstat lintran
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
              lintran    262144     45.46     56.19        4.     4916.
```

## imshift - Shift a list of 1-D or 2-D images

```
cl> imshift dev$pix shift 3.2 -4.5 inter=poly5 bound=neare
cl> imstat shift
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                shift    262144     107.8     130.9       21.    19756.
```

## imtranspose - Transpose a list of 2-D images

```
cl> imtranspose dev$pix tpix
cl> imstat tpix
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                 tpix    262144     108.3     131.3       -1.    19936.
```

## im3dtran - Transpose a list of 3-D images

nothing yet

## magnify - Magnify a list of 1-D or 2-D images

```
vocl> magnify dev$pix mag 2.5 2.5

mag
  Magnify image dev$pix to image mag.
  Interpolation is linear.
  Boundary extension is nearest.
  Output coordinates in terms of input coordinates:
    x1 =         1., x2 =       512., dx =        0.4
    y1 =         1., y2 =       512., dy =        0.4
vocl> imstat mag
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                  mag   1633284     16.86     20.46        1.     3176.
```

## rotate - Rotate and shift a list of 2-D images

```
cl> rotate dev$pix r30 30.0

Transforming image dev$pix to image r30
    xshift: -93.89 yshift: 162.61 xmag: 1.00 ymag: 1.00 xrot: 30.00 yrot: 30.00
cl> imstat r30
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                  r30    262144     107.4      127.       14.    17175.
```

## shiftlines - Shift the lines of a list of N-D images

```
cl> shiftlines dev$pix shi 0.25
cl> imstat shi
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
                  shi    262144     107.9     129.1        5.    19834.
```

# immatch - Image matching and combining package

File: `rtran`
```
1.0000  1.0000 184.1445 -153.0376
512.0000 1.0000 684.0376 184.1445
512.0000 512.0000 346.8555 684.0376
1.0000 512.0000 -153.0380 346.8555  
```

## geomap - Compute geometric transforms using matched coordinate lists

Compute  the  linear  transformation between coordinate systems.

Test options: `decimals=5`
```
cl> geomap rtran rtran.db 1.0 512.0 1.0 512.0 intera- | match rms stop=yes

Coordinate list: rtran  Transform: rtran
    Results file: 
Coordinate mapping status
    X fit ok.  Y fit ok.
Coordinate mapping parameters
    Mean Xref and Yref: 256.5  256.5
    Mean Xin and Yin: 265.4999  265.5
    X and Y shift: 183.826  -154.6757  (xin  yin)
    X and Y scale: 1.18  1.18  (xin / xref  yin / yref)
    X and Y axis rotation: 326.00000  326.00000  (degrees  degrees)
cl> tail rtran.db nlines=-1 | match rms stop=yes
begin	rtran
	xrefmean	256.5
	yrefmean	256.5
	xmean		265.4999084472656
	ymean		265.5
	geometry	general
	function	polynomial
	xshift		183.826
	yshift		-154.6757
	xmag		1.18
	ymag		1.18
	xrotation	326.
	yrotation	326.
	surface1	11
			3.	3.
			2.	2.
			2.	2.
			0.	0.
			1.	1.
			512.	512.
			1.	1.
			512.	512.
			183.826	-154.6757
			0.9782647	0.6598474
			-0.6598479	0.9782643
	surface2	0
```

## geoxytran - Transform coordinate lists using the geomap transforms

Compute the transformation from the reference system to the output
system and then evaluate the transformation for both the input list
and the list of unknowns.

Test options: `decimals=2`
```
cl> geoxytran rtran STDOUT rtran.db rtran
184.1444 -153.038 184.1445 -153.0376
684.0377 184.1444 684.0376 184.1445
346.8554 684.0375 346.8555 684.0376
-153.038 346.8555 -153.0380 346.8555  
```

## gregister - Register 1-D or 2-D images using the geomap transforms

## imalign - Align and register 2-D images using a reference pixel list

## imcentroid - Compute and print relative shifts for a list of 2-D images

## imcombine - Combine images pixel-by-pixel using various algorithms

## linmatch - Match the linear intensity scales of 1-D or 2-D images

## psfmatch - Match the point-spread functions of 1-D or 2-D images

## skymap - Compute geometric transforms using the image celestial wcs

## skyxymtach - Generate matched pixel lists using the image celestial wcs

## sregister - Register 1-D or 2-D images using the image celestial wcs

## wcscopy - Copy the wcs from one image to another

## wcsmap - Compute geometric transforms using the image wcs

## wcsxymatch - Generate matched pixel lists using the image wcs

## wregister - Register 1-D or 2-D images using the image wcs 

## xregister - Register 1-D or 2-D images using x-correlation techniques

## xyxymatch - Match pixel coordinate lists

# OS specific function is host$os

## ZGMTCO

ZGMTCO returns the correction, in seconds, from local standard
time. This may have some issues with daylight saving time.

File: `gmtcotest.x`
```
task gmtcotest = t_gmtcotest
procedure t_gmtcotest ()
int corr
begin
    call zgmtco(corr)
	if ((corr < - 86400) || (corr > 86400)) {
	    call printf("Unreasonable correction %d\n")
		    call pargi(corr)
	} else {
	    call printf("OK")
	}
end
```

The test program should just return OK:

```
cl> softools
cl> xc -w gmtcotest.x
cl> task $gmtcotest = gmtcotest.e
cl> gmtcotest
OK
```

## Non-local goto

IRAF uses its own version of a "long jump" (non-local goto), which needs a
small piece of code to be written in assembler (`zsvjmp.s`). This is highly
CPU and OS specific. Here is some test code:

File: `jmptest.x`
```
include <config.h>
task jmptest = t_jmptest
procedure t_jmptest ()
int jmp_buf[LEN_JUMPBUF]
int status, step
begin
    status = 0
    step = 0

    call zsvjmp(jmp_buf, status)
    call printf("status = %d, step = %d\n")
    call pargi(status)
    call pargi(step)
    if (status == 0) {
        if (step == 1) {
	    call printf("Error: Called zsvjmp a second time\n")
            return
	 }
         step = 1
         call printf("Calling zdojmp\n")
         call zdojmp(jmp_buf, status)
         call printf("Error: return from ZDOJMP\n")
         return
      }
      if (step == 0) {
         call printf("Error: ZSVJMP was not called successfully\n")
         return
      }
      call printf("All OK\n")
end
```

`ZSVJMP` saves the processor registers in a buffer, while a following `ZDOJMP`
restores them (and therefore goes back to the place where `ZSVJMP was called).

```
cl> softools
cl> xc -w jmptest.x
cl> task $jmptest = jmptest.e
cl> jmptest
status = 0, step = 0
Calling zdojmp
status = 1, step = 1
All OK
```
